/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __AAPIGLE_H__
	#define	__AAPIGLE_H__

	#include "tapigle.h"

	VOID GLEa_error(UINT8 viewId, UINT16 errorCode);
	VOID GLEa_status(UINT8 viewId, UINT16 statusCode);
	
	VOID GLEa_newCard(UINT8 viewId, const GLE_STRING title, const CHAR *URL, BOOL isBookmarkable, const WCHAR * const *history);
	BOOL GLEa_drawCardRequest(UINT8 viewId, UINT16 contentPosX, UINT16 contentWidth, UINT16 contentPosY, UINT16 contentHeight);
	VOID GLEa_drawCardCompleted(UINT8 viewId);
	VOID GLEa_clearCard(UINT8 viewId);

	VOID GLEa_playSoundClick(VOID);
	
	WCHAR* GLEa_strcpyGle2Wchar(WCHAR* dst, const GLE_STRING src);
	GLE_STRING GLEa_strcpyWchar2Gle(GLE_STRING dst, const WCHAR* src);
	GLE_STRING GLEa_strcpyGle2Gle(GLE_STRING dst, const GLE_STRING src);
	INT16 GLEa_strlen(const GLE_STRING str);
	UINT16 GLEa_sizeofString(const WCHAR* str);
	INT16 GLEa_strNbrCharsWithoutEndingSpaces(const GLE_STRING str, UINT16 len);
	UINT16 GLEa_sizeofNchars(const GLE_STRING str, UINT16 len);
	
	UINT16 GLEa_textFontAscent(INT8 format, BOOL isLink);
	UINT16 GLEa_textFontLineHeight(INT8 format, BOOL isLink);
	UINT16 GLEa_textFontWidth(const GLE_STRING text, const UINT16 len, INT8 format, BOOL isLink);	
	UINT16 GLEa_textFontWordWrap(const GLE_STRING text, const UINT16 wrapWidth, INT8 format, BOOL isLink);	
	VOID GLEa_textDraw(UINT8 viewId, const GLE_STRING text, const UINT16 len, BOOL invert, GleRectangleType *textBounds, UINT16 deltaY, INT8 format, BOOL isLink);

	GleBitmap* GLEa_imageConvert(const CHAR *imageData, UINT16 imageSize, const CHAR *imageType, INT8* vSpace, INT8* hSpace, INT16* width, INT16* height, INT8 isPercent);
	VOID GLEa_imageDraw(UINT8 viewId, const GleBitmap *image, BOOL invert, GleRectangleType* imageBounds);
	VOID GLEa_imageFree(GleBitmap *image);
	
	VOID GLEa_fieldSetDraw(UINT8 viewId, const GLE_STRING title, GleRectangleType *fieldSetBounds);
	
	VOID GLEa_inputSize(INT8 size, INT8 nChars, INT16 maxWidth, INT16 *width, INT16 *height, UINT16 *ascent);
	VOID GLEa_inputDraw(UINT8 viewId, const GLE_STRING text, BOOL invert, INT8 size, INT8 nChars, BOOL isPassword, const GLE_STRING format, GleRectangleType *inputBounds);
	VOID GLEa_inputDialog(GleInput* inputPtr);
	
	#ifdef SHOW_KEYS_IN_CONTENT
		BOOL GLEa_newKey (UINT8 objectId, UINT8 keyId, const WCHAR *eventType, const WCHAR *label, BOOL isOptional);
		VOID GLEa_keySize(const GLE_STRING label, const GLE_STRING eventType, INT16 maxWidth, INT16 *width, INT16 *height, UINT16 *ascent);
		VOID GLEa_keyDraw(UINT8 viewId, const GLE_STRING label, const GLE_STRING eventType, BOOL invert, GleRectangleType *keyBounds);
	#endif
	#ifdef SHOW_OPTIONS_IN_CONTENT
		VOID GLEa_optionSize(const GLE_STRING label, BOOL multiSelect, INT16 maxWidth, INT16 *width, INT16 *height, UINT16 *ascent);
		VOID GLEa_optionDraw(UINT8 viewId, const GLE_STRING label, BOOL multiSelect, BOOL invert, BOOL selected, GleRectangleType *optionBounds);
		VOID GLEa_optionGroupSize(const GLE_STRING label, INT16 maxWidth, INT16 *width, INT16 *height, UINT16 *ascent);
		VOID GLEa_optionGroupDraw(UINT8 viewId, const GLE_STRING label, GleRectangleType *optionGroupBounds);
	#else
		VOID GLEa_selectSize(const GLE_STRING label, BOOL multiSelect, INT16 maxWidth, INT16 *width, INT16 *height, UINT16 *ascent);
		VOID GLEa_selectDraw(UINT8 viewId, const GLE_STRING label, BOOL multiSelect, BOOL invert, GleRectangleType *selectBounds);
		VOID GLEa_selectGetLabel(GleSelect* self);
		VOID GLEa_selectDialog(const GleSelect* self);
	#endif

	VOID GLEa_tableDraw(UINT8 viewId, GlePointType pos, GLE_STRING title, INT8 noOfCells, INT8 noOfColumns, INT8 noOfRows, const INT16 *colWidth, const INT16 *rowHeight);	
#endif