/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __CAPIGLE_H__
	#define	__CAPIGLE_H__
	
	#include "tapigle.h"
	#include "capiclnt.h"	
	
	VOID GLEc_start(VOID);
	VOID GLEc_terminate(VOID);
	
	VOID GLEc_openView(UINT8 viewId, UINT8 uaMode, UINT16 width, UINT16 height);
	VOID GLEc_closeView(UINT8 viewId);
	VOID GLEc_resizeView(UINT8 viewId, UINT16 newWidth, UINT16 newHeight);
	VOID GLEc_drawView(UINT8 viewId);
	
	VOID GLEc_stop(UINT8 viewId);
	
	VOID GLEc_handleEvent(UINT8 viewId, GleEvent event);
	
	VOID GLEc_inputDialogResponse(GleInput* inputPtr, const GLE_STRING newText, BOOL ok); 
	VOID GLEc_horizontalScrollbarChanged(UINT8 viewId, UINT16 scrollPos);
	VOID GLEc_verticalScrollbarChanged(UINT8 viewId, UINT16 scrollPos);

	BOOL GLEc_formatStringValid(const WCHAR* format, INT16* length, FormatInfoType* info, BOOL* containsConstantChars);
	BOOL GLEc_inputStringValid(const WCHAR* str, const WCHAR* format, FormatErrorType* error);
	
	VOID GLEc_setIntConfig (UINT8 viewId, ConfigInt kind, UINT32 value);
/*
	typedef enum  {UpperCaseLetter, LowerCaseLetter, Numerical, General, ToLong, ToShort} FormatErrorType;
	FormatErrorType GLEc_inputStringValid(WCHAR* str, WCHAR* format, INT16* numberSame);
	BOOL GLEc_formatStringValid(WCHAR* format);
*/	
	#ifndef SHOW_OPTIONS_IN_CONTENT
		VOID GLEc_selectSetLabel(GleSelect* self, const GLE_STRING newLabel);
		VOID GLEc_optionSelected(UINT8 viewId, GleOption* self);
	#endif

	/* The following functions converts the GLE_STRING parameters to Unicode WCHAR and then calls the corresponding MMIa_ fuction*/	
	VOID GLEc_newFieldSetTest(UINT8 viewId, const GLE_STRING title);
	VOID GLEc_newImageTest(UINT8 viewId, UINT8 imageId, const CHAR *imageData, UINT16 imageSize, const CHAR *imageType, const GLE_STRING altText, const GLE_STRING localSrc, BOOL isLink, const GLE_STRING linkTitle, INT8 vSpace, INT8 hSpace, INT16 width, INT16 height, INT8 isPercent, INT8 align);
	VOID GLEc_newInputTest(UINT8 viewId, UINT8 inputId, const GLE_STRING title, const GLE_STRING text, BOOL isPassword, BOOL emptyOK, const GLE_STRING format, INT8 size, INT8 nChars, INT8 tabIndex);
	VOID GLEc_newKeyTest(UINT8 viewId, UINT8 keyId, const GLE_STRING eventType, const GLE_STRING label, BOOL isOptional);
	VOID GLEc_newSelectTest(UINT8 viewId, const GLE_STRING title, BOOL multiSelect, INT8 tabIndex);
	VOID GLEc_newOptionTest(UINT8 viewId, UINT8 optionId, const GLE_STRING label, const GLE_STRING title, BOOL isSelected);
	VOID GLEc_newOptionGroupTest(UINT8 viewId, const GLE_STRING label);
	VOID GLEc_newTableTest(UINT8 viewId, const GLE_STRING title, INT8 noOfColumns, const CHAR *align);
	VOID GLEc_newTextTest(UINT8 viewId, UINT8 textId, const GLE_STRING text, BOOL isLink, const GLE_STRING linkTitle, INT8 format);
#endif
