/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __TAPIGLE_H__
	#define	__TAPIGLE_H__
	#include "tapicmmn.h"
	#include "gledef.h"
	
	#ifdef CAPTURE_GWCAPI_CALLS
		#define CALL_GWC_API(a)		gle_##a
		#include "a_gle.h"
		#include "c_gle.h"
	#else
		#define CALL_GWC_API(a)		a
	#endif		
	
	

	typedef BYTE* GLE_STRING;
	typedef BYTE GleBitmap;

	typedef enum  {Mixed, PureConstant, Only_A, Only_a, Only_N, Only_X, Only_x, Only_M, Only_m} FormatInfoType;
	typedef enum  {NullPointer, ToLong, ToShort, WrongFormat, ConstantReplaced} FormatErrorType;

	typedef enum  {Break, CloseFieldSet, CloseOptionGroup, CloseSelect, CloseTable,  FieldSet, Image, Input, Key, NoType, Option, OptionGroup, Paragraph, Scrollbar, Select, Table, TableData, Text} GleElementType;
	typedef enum  {KeyDown, KeyLeft, KeyLinkInfo, KeyRight, KeyUp, KeyYes, PenDown, PenLinkInfo, PenMove, PenUp } GleEventType;
	typedef enum  {Down, Up, NoDirection} GleDirectionType;

	typedef enum  {InputFieldLeftEmpty} GleErrorCode;
	typedef enum  {AllImagesDone} GleStatusCode;
	
	typedef struct {
		INT16 x;
		INT16 y;
		} GlePointType;
	
	typedef struct {
		GleEventType eventType;
		GlePointType point;	
		} GleEvent;
	
	typedef struct GleRectangleTypeNode{
		GlePointType  topLeft;
		GlePointType  extent;
		} GleRectangleType, *GleRectanglePtr;



	typedef struct GleInputNode
		{
		#include "baseobj.h"
		GleRectangleType bounds;
		UINT16  ascent;
		/*INT16	maxWidth;*/
		UINT8	viewId;
		UINT8 	inputId;
		BOOL	isPassword;
		BOOL	emptyOK;
		UINT8 	size;
		UINT8 	nChars;
		UINT8 	tabIndex;
		GLE_STRING title;
		GLE_STRING format;
		GLE_STRING text;		
		}GleInput;
		
	typedef struct GleCloseOptionGroupNode 
		{
		#include "baseobj.h"
		} GleCloseOptionGroup;
	
	typedef struct GleOptionNode 
		{
		#include "baseobj.h"
		GleRectangleType bounds;
		UINT8		viewId; 
		BOOL		multipleSelected; 	
		BOOL		isInverted; 		
		UINT8		optionId;
		UINT16  	ascent;			
		VOID*		singleSelect;
		GLE_STRING	label;
		GLE_STRING	title;
		} GleOption;
		
	typedef struct GleOptionGroupNode 
		{
		#include "baseobj.h"
		GleRectangleType bounds;
		GLE_STRING	label;
		UINT16  	ascent;
		} GleOptionGroup;
		
	typedef struct GleSelectNode 
		{
		#include "baseobj.h"
		
		#ifndef SHOW_OPTIONS_IN_CONTENT
			GLE_STRING	title;
			GLE_STRING	label;
			GleRectangleType bounds;
			UINT16  	ascent;		
			UINT16 maxWidth;
		#endif
		
		INT8 tabIndex;
		UINT8		viewId;
		GleOption*		singleSelectedOption;
		BOOL		multiSelect;
		} GleSelect;
		
	typedef struct GleCloseSelectNode {
		#include "baseobj.h"
		UINT8 	viewId;
		} GleCloseSelect;
	



#endif