/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GENERIC_LAYOUT_ENGINE_H__
#define	__GENERIC_LAYOUT_ENGINE_H__

#include "tapigle.h"
#include "gleview.h"

INT16 SizeOfGleList(VOID);

VOID GleAddToGleList(GleViewType* viewP, GleElement* p);
VOID GleDeleteCard(GleViewType* viewP);
VOID GleDrawCard(GleViewType* viewP);

VOID GleGetLinkInfo(GleViewType* viewP, GleElement* p);
VOID GleKeyScrollCard(GleViewType* viewP, GleDirectionType direction);
VOID GlePerformHorizontalScroll(GleViewType* viewP, INT16 pixelsToScroll);
VOID GlePerformVerticalScroll(GleViewType* viewP, INT16 pixelsToScroll);
VOID GleRctGetIntersection (const GleRectanglePtr r1, const GleRectanglePtr r2, GleRectanglePtr r3);
BOOL GleRctPtInRectangle (const INT16 x, const INT16 y, const GleRectanglePtr r);
VOID GleRctSetRectangle (const GleRectanglePtr r, const INT16 left, const INT16 top, const INT16 width, const INT16 height);
BOOL GleRenderCard(GleViewType *viewP, INT16 *xSize, INT16 *ySize);
INT16 SizeOfGleList(VOID);

#endif