/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#include "glebreak.h"
VOID* WIPAlloc(UINT32 size);
VOID WIPFree( VOID* memory );

BOOL GleBreakRenderX(GleElement* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID *viewP){
	if (*gleType==Break) {
		*descenderMax = *currentFontLineHeight; /* Return-Return slag*/
		*ascentMax = 0;
		}
	*gleType = self->type;
	return FALSE;
	}	 

GleElement *GleBreakConstruct(){
	GleElement *self;
	UINT32 chunkSize;
	chunkSize = sizeof(GleElement);

	self = (GleElement*)WIPAlloc(chunkSize);

	self->type=Break;
	self->chunkSize = chunkSize;
	#ifdef SUPPORT_PEN_NAVIGATION
		self->Contains=&GleElementContains;
	#endif
	self->Draw=&GleElementDraw;  /* *(p->Draw)();*/
	self->RenderX=&GleBreakRenderX;
	self->RenderY=&GleElementRenderY;
	self->Destruct=&GleElementDestruct;  /* *(p->Destruct)();*/
	#ifdef SUPPORT_KEY_NAVIGATION
		self->IsMarkable=&GleElementIsMarkable;
	#endif
	self->Selected=&GleElementSelected;
	return (GleElement*)self;
	}
	