/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#include "gleelem.h"
#include "gleview.h"
VOID* WIPAlloc(UINT32 size);
VOID WIPFree( VOID* memory );

#ifdef SUPPORT_KEY_NAVIGATION
	BOOL GleElementIsMarkable(const GleElement* self) {
		return FALSE;
	}
#endif
	
VOID GleElementDraw(const GleElement* self) {
	}
	
BOOL GleElementRenderX(GleElement* self, UINT16  *xSum, UINT16 *ySum, UINT16 *ascentMax, UINT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID *viewP){
	return TRUE;
	}	
	
VOID GleElementSelected(const GleElement* self) {}
	
VOID GleElementRenderY(GleElement* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax) {
	}

#ifdef SUPPORT_PEN_NAVIGATION
BOOL GleElementContains(const GleElement *self, GlePointType point) {
	return FALSE;
	}
#endif

VOID GleElementDestruct(GleElement* self){
	WIPFree(self);
	}

#ifdef SUPPORT_KEY_NAVIGATION
	GleElement* GleElementGetNextMarkable(VOID* viewP, GleElement* p, GleDirectionType direction) {
	/* Searches next markable controlelement in direction and returns it*/
		if (direction==Up) {
			if(p)
				p=p->prev;
			while( p ) {
				if(p->IsMarkable((GleViewType*)viewP, p))
					return(p);
				else
					p=p->prev;
				}
			}
		else {
			if(p)
				p=p->next;
			while( p ) {
				if(p->IsMarkable((GleViewType*)viewP, p))
					return(p);
				else
					p=p->next;
				}
		}
		return(0);
	}
#endif