/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLEELEMENT_H__
#define __GLEELEMENT_H__

#include "tapigle.h"

typedef struct GleElementNode
	{
	#include "baseobj.h"
	} GleElement;

#ifdef SUPPORT_KEY_NAVIGATION
	BOOL GleElementIsMarkable(const GleElement* self);
#endif
VOID GleElementDraw(const GleElement* self);
BOOL GleElementRenderX(GleElement* self, UINT16  *xSum, UINT16 *ySum, UINT16 *ascentMax, UINT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID *viewP);
VOID GleElementRenderY(GleElement* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax);
VOID GleElementSelected(const GleElement* self);
#ifdef SUPPORT_PEN_NAVIGATION
	BOOL GleElementContains(const GleElement* self, GlePointType point);
#endif
VOID GleElementDestruct(GleElement* self);
GleElement* GleElementGetNextMarkable(VOID* viewP, GleElement* p, GleDirectionType direction);

#endif