/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLEFIELDSET_H__
#define __GLEFIELDSET_H__
	
#include "tapigle.h"
#include "gleview.h"

typedef struct GleFieldSetNode 
	{
	#include "baseobj.h"
	GleRectangleType bounds;
	UINT8 viewId;
	struct GleFieldSetNode* prevFieldSet;
	GLE_STRING title;
	} GleFieldSet;
	
typedef struct GleCloseFieldSetNode 
	{
	#include "baseobj.h"
	} GleCloseFieldSet;

/* VOID FieldSetHeightAndWidth(GleFieldSet *self, INT16 *ySum, INT16 *xSum, INT16 *columnLeftX, INT16 *columnWidth); */
VOID GleFieldSetDraw(GleViewType* viewP, const GleFieldSet* self);
BOOL GleFieldSetRenderX(GleFieldSet* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID *viewP);
VOID GleFieldSetDestruct(GleFieldSet* self);
GleElement *GleFieldSetConstruct(UINT8 viewId, const WCHAR *title);
BOOL GleCloseFieldSetRenderX(GleFieldSet* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth);
GleElement *GleCloseFieldSetConstruct(VOID);

#endif