/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLEIMAGE_H__
#define __GLEIMAGE_H__

#include "tapigle.h"
#include "gleelem.h"
#include "gleview.h"

typedef struct GleImageNode
	{
	#include "baseobj.h"
	GleRectangleType bounds;
	UINT8 viewId;
	UINT8 imageId;
	UINT16 imageSize;
	BOOL isLink;	
	INT8 vSpace;
	INT8 hSpace;
	INT8 isPercent;
	INT8 align;
	/*	VOID* myTable;*/
	UINT16  ascent;	
	/*virtual	BOOL 	TableGetColInfo(WMLobjectAtrType& wmlType, TableColDataType* colData);*/
	GleBitmap *bitmap;			
	GLE_STRING altText;
	GLE_STRING localSrc;
	GLE_STRING linkTitle;
	} GleImage;		

VOID GleImageAlign(GleImage* self, INT8 align);
#ifdef SUPPORT_PEN_NAVIGATION
	BOOL GleImageContains(GleViewType* viewP, const GleImage *self, GlePointType point);
#endif
VOID GleImageDraw(GleViewType* viewP, const GleImage* self);
BOOL GleImageRenderX(GleImage* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID* viewP);
VOID GleImageRenderY(GleImage* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax);
#ifdef SUPPORT_KEY_NAVIGATION
	BOOL GleImageIsMarkable(GleViewType* viewP, const GleImage* self);
#endif
VOID GleImageSelected(GleViewType* viewP, const GleImage* self);
VOID GleImageDestruct(GleImage* self);
GleElement *GleImageConstruct(UINT8 viewId, UINT8 imageId, const CHAR *imageData, UINT16 imageSize, const CHAR *imageType, const WCHAR *altText, const WCHAR *localSrc, BOOL isLink, const WCHAR *linkTitle, INT8 vSpace, INT8 hSpace, INT16 width, INT16 height, INT8 isPercent, INT8 align);

#endif