/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLEINPUT_H__
#define __GLEINPUT_H__
	
#include "tapigle.h"
#include "gleelem.h"
#include "gleview.h"

#ifdef SUPPORT_PEN_NAVIGATION
	BOOL GleInputContains(GleViewType* viewP, const GleInput *self, GlePointType point);
#endif
VOID GleInputDestruct(GleInput* self);
VOID GleInputDraw(GleViewType* viewP, const GleInput* self);
BOOL GleInputRenderX(GleInput* self, UINT16  *xSum, UINT16 *ySum, UINT16 *ascentMax, UINT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID* viewP);
VOID GleInputRenderY(GleInput* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax);
#ifdef SUPPORT_KEY_NAVIGATION 
	BOOL GleInputIsMarkable(GleViewType* viewP, const GleInput* self);
#endif
VOID GleInputSelected(GleViewType* viewP, GleInput* self);
GleElement *GleInputConstruct(UINT8 viewId, UINT8 inputId, const WCHAR *title, const WCHAR *text, BOOL isPassword, BOOL emptyOK, const WCHAR *format,INT8 size , INT8 nChars, INT8 tabIndex);

#endif