/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifdef SHOW_KEYS_IN_CONTENT
	#ifndef __GLEKEY_H__
	#define __GLEKEY_H__

	#include "tapigle.h"	
	#include "gleelem.h"
	#include "gleview.h"
	
	typedef struct GleKeyNode
		{
		#include "baseobj.h"
		GleRectangleType bounds;
		UINT16  ascent;
		UINT8	keyId;
		UINT8 	viewId;
		BOOL	isOptional;
		GLE_STRING eventType;
		GLE_STRING label;
		} GleKey;
	
	#ifdef SUPPORT_PEN_NAVIGATION
		BOOL GleKeyContains(GleViewType* viewP, const GleKey *self, GlePointType point);
	#endif
	VOID GleKeyDraw(GleViewType* viewP, const GleKey* self);
	VOID GleKeyDestruct(GleKey* self);
	BOOL GleKeyRenderX(GleKey* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID* viewP);
	VOID GleKeyRenderY(GleKey* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax);
	#ifdef SUPPORT_KEY_NAVIGATION 
		BOOL GleKeyIsMarkable(GleViewType* viewP, const GleKey* self);
	#endif	
	VOID GleKeySelected(GleViewType* viewP, const GleKey* self);
	GleElement *GleKeyConstruct(UINT8 viewId, UINT8 keyId, const WCHAR *eventType, const WCHAR *label, BOOL isOptional);
	#endif
#endif