/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLESELECT_H__
	#define __GLESELECT_H__

	#include "tapigle.h"
	#include "gleoptn.h"

	BOOL 	   	GleCloseSelectRenderX(GleCloseSelect* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID* viewP);
	GleElement *GleCloseSelectConstruct(UINT8 viewId);	
	#ifdef SUPPORT_PEN_NAVIGATION
		BOOL 		GleSelectContains(GleViewType* viewP, const GleSelect *self, GlePointType point);
	#endif
	VOID 		GleSelectDestruct(GleSelect* self);
	VOID 		GleSelectDraw(GleViewType* viewP, GleSelect* self);
	#ifdef SUPPORT_KEY_NAVIGATION 	
		BOOL 		GleSelectIsMarkable(GleViewType* viewP, const GleSelect* self);
	#endif
	BOOL 		GleSelectRenderX(GleSelect* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth);
	VOID 		GleSelectRenderY(GleSelect* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax);
	VOID 		GleSelectSelected(GleViewType* viewP, const GleSelect* self);
	VOID 		GleSelectDestruct(GleSelect* self);
	GleElement *GleSelectConstruct(UINT8 viewId, const WCHAR* title, BOOL multiSelect, INT8 tabIndex);

#endif