/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLETABLE_H__
#define __GLETABLE_H__

#include "tapigle.h"
#include "tapimmi.h"
#include "gleelem.h"
#include "gleview.h"

typedef struct
	{
	INT16 columnLeftX;
	TextAlignmentType align;	
	} TableColDataType;

typedef struct GleTableNode
	{
	#include "baseobj.h"
	GleRectangleType bounds;
	GleRectangleType oldClip;
	INT16	tableWidth;
	INT8	noOfCells;
	INT8	noOfColumns;
	INT8	noOfRows;
	GLE_STRING title;		
	TableColDataType *col;
	INT16 *rowHeight;
	INT16 *colWidth;
	} GleTable;

typedef struct GleTableDataNode
	{
	#include "baseobj.h"
	/*VOID*	 myTable;	*/
	/*GleTable* myTable;*/
	GleRectangleType bounds;
	} GleTableData;

BOOL 	   GleCloseTableRenderX(GleElement* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth);
GleElement *GleCloseTableConstruct(UINT8 viewId);
BOOL 	   GleElementGetTableColInfo(const GleElement* self, INT16 *colWidth);
VOID	   GleTableDestruct(GleTable* self);
VOID 	   GleTableDraw(GleViewType* viewP, const GleTable* self);
BOOL	   GleTableRenderX(GleTable* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID* viewP);
GleElement *GleTableConstruct(UINT8 viewId, const WCHAR* title, INT8 myNoOfColumns, const CHAR* myAlign);
/*BOOL GleTableContains(GleTable *self, GlePointType point);*/
VOID 	   GleTableDataDraw(const GleTableData* self);
BOOL 	   GleTableDataRenderX(GleTableData* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth);
GleElement *GleTableDataConstruct(UINT8 viewId);

#endif