/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLETEXT_H__
#define __GLETEXT_H__

#include "tapigle.h"
#include "gleview.h"
#include "gleimage.h"

typedef struct GleTextRowInfoNode{
	UINT16 nChars;
	UINT16 nBytes;
	GleRectangleType bounds;
	} GleTextRowInfoType;

typedef struct GleTextNode
	{
	#include "baseobj.h"
	UINT8	viewId;
	UINT8 	textId;
	BOOL 	isLink;
	INT8 	format;	
	UINT16 	ascent;
	/*VOID*	myTable;	*/
	BOOL 	underlined;
	INT16 	totalTextHeight;
	INT16 	firstRowDeltaY;
	INT16 	lastRowDeltaY;
	INT16 	columnLeftX;
	INT16 	columnWidth;
	UINT16 	nRows;
	GleImage* image;
	GLE_STRING text;
	GLE_STRING linkTitle;
	GleTextRowInfoType *rowInfo;
	} GleText;

VOID GleTextDestruct(GleText* self);
VOID GleTextDraw(GleViewType* viewP, const GleText* self);
VOID GleTextGetAcsentAndDescender(const GleText* self, INT16* ascentMax, INT16* descenderMax);
VOID GleTextMultipleRowCheck(GleText* self, INT16 *xSum, GleText** multipleRowTextPtr, INT16 *descenderMax, INT16 *columnWidth, INT16 xOffset);
BOOL GleTextRenderX(GleText* self, INT16  *xSum, INT16 *ySum, INT16 *ascentMax, INT16 *descenderMax, GleElementType *gleType, UINT16 *currentFontLineHeight, INT8 *myAlign, BOOL *myWrap, INT16 *columnLeftX, INT16 *columnWidth, VOID *viewP);
VOID GleTextRenderY(GleText* self, INT16* xOffSet, INT16* ySum, INT16* ascentMax);
VOID GleTextLastRowRenderY(GleText* self, INT16 *xSum, INT8 *myAlign, INT16 *ascentMax, INT16 *descenderMax);
#ifdef SUPPORT_PEN_NAVIGATION
	BOOL GleTextContains(GleViewType* viewP, const GleText *self, GlePointType point);
#endif
VOID GleTextSelected(GleViewType* viewP, const GleText* self);
GleElement *GleTextConstruct(UINT8 viewId, UINT8 textId, const WCHAR *text, BOOL isLink, const WCHAR *linkTitle, INT8 format, GleImage* image);
#ifdef SUPPORT_KEY_NAVIGATION 
	BOOL GleTextIsMarkable(GleViewType* viewP, const GleText* self);
#endif

#endif