/*
 * Copyright (C) AU-System AB, 2000.
 * All rights reserved.
 *
 * This software is covered by the license agreement between
 * the end user and AU-System AB, and may be used and copied
 * only in accordance with the terms of the said agreement.
 *
 * AU-System AB does not assume any responsibility or 
 * liability for any errors or inaccuracies in this 
 * software, or any consequential, incidental or indirect 
 * damage arising out of the use of the Generic Layout Engine 
 * software.
 */

#ifndef __GLEVIEW_H__
#define	__GLEVIEW_H__

#include "tapigle.h"
#include "gleelem.h"

typedef struct GleViewNode 
	{
	UINT8 viewId;
	UINT8 displayImages;
	UINT8 updateImages;

	BOOL mMIa_wait;
	BOOL redrawWhenNotWait;
	BOOL cardComplete;
#ifndef	SUPPORT_TABLES
	INT8 tableNumberColumns;
	INT8 tableCurrentColumn;
#endif
	INT16 waitingForNImages;
	INT16 vertOffset;
	INT16 horizOffset;
	INT16 verticalSize;	
	INT16 horizontalSize;

	UINT16 width;
	UINT16 height;

	INT16 oldPenX;
	INT16 oldPenY;
	INT16 xSumMaxForFieldSet;
	GleElement* firstGleElement;
	GleElement* lastGleElement;
	GleElement* markedGleElement;   /* Marked by keys */	
	GleElement* selectedGleElement; /* Selected by mouse */
	/*	GleSelect * gleSingleSelect ;*/

	VOID* gleSingleSelect ;
	VOID* gleFieldSetPtr ;
	UINT8 numberOfNestledFieldSet;
	GLE_STRING title;
	CHAR* URL;
	GLE_STRING  *history;
	struct GleViewNode *next;
	} GleViewType;

GleViewType* GleViewCreateAddInit(UINT8 viewId, UINT16 width, UINT16 height);
VOID GleViewDelete(GleViewType* viewId);
GleViewType* GleViewSearchByViewId(UINT8 viewId);

#endif

