#
#	Setting Directory for AUS Objects
#
# WIPDB treated differently from other AUSOBJ2s as it causes 
# the TI optimiser to crash.
include $(AUSYSTEM_DIR)/ausystem_env.mak
COPTAUS  = -me -mt -o -pw2 -x -mw -pe 
WIPDB_COPTAUS  = -me -mt -o0 -pw2 -x -mw -pe

ifndef NO_SYMBOL
COPTAUS += -g -mn
WIPDB_COPTAUS += -g -mn
endif 


$(AUS_LIB) : $(AOBJ) $(AUSOBJ1) $(AUSOBJ2) $(WIPDB_OBJ) $(AUSOPTMEMOBJ) $(AUS_LIB_DIR)
	$(AR) r $(AUS_LIB) $(AUSOBJ1) 
	$(AR) r $(AUS_LIB) $(AUSOBJ2) 
	$(AR) r $(AUS_LIB) $(WIPDB_OBJ) 
	$(AR) r $(AUS_LIB) $(AUSOPTMEMOBJ)
	
	
$(AOBJ):	
	mkdir $(subst /,$(SLASH),$(AOBJ))

$(AUS_LIB_DIR):
	mkdir $(subst /,$(SLASH),$(AUS_LIB_DIR))

clean: 
	$(REMOVE) $(subst /,$(SLASH),$(AOBJ))


$(AUSOBJ1) : $(AOBJ)/%.obj : $(AUS_SRC_DIR)/%.c
	echo -DTRGT_G23 >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -DLOG_EXTERNAL >> cmd
	echo -I$(IAUS_OPT_MEM) >> cmd
	echo -I$(IAUS) >> cmd
	echo $(COPTAUS) >> cmd
	echo -I$(ICOM) >> cmd
	echo -fr$(AOBJ) >> cmd
	$(CC) $^ -@cmd


$(AUSOBJ2) : $(AOBJ)/%.$(OBJ_TAIL) : $(AUS_SRC_DIR)/%.c
	echo -DTRGT_G23 > cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -DLOG_EXTERNAL >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IAUS_OPT_MEM) >> cmd
	echo $(COPTAUS) >> cmd
	echo -I$(ICOM) >> cmd
	echo -fr$(AOBJ) >> cmd
	$(CC) $^ -@cmd

$(WIPDB_OBJ) : $(AOBJ)/%.$(OBJ_TAIL) : $(AUS_SRC_DIR)/%.c
	echo -DTRGT_G23 > cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -DLOG_EXTERNAL >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IAUS_OPT_MEM) >> cmd
	echo $(WIPDB_COPTAUS) >> cmd
	echo -I$(ICOM) >> cmd
	echo -fr$(AOBJ) >> cmd
	$(CC) $< -@cmd

$(AUSOPTMEMOBJ): $(AOBJ)/%.$(OBJ_TAIL) : $(AUS_OPT_MEM_SRC_DIR)/%.c
	echo -DTRGT_G23 > cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -DLOG_EXTERNAL >> cmd
	echo -I$(IAUS_OPT_MEM) >> cmd
	echo -I$(IAUS) >> cmd
	echo $(COPTAUS) >> cmd
	echo -I$(ICOM) >> cmd
	echo -fr$(AOBJ) >> cmd
	$(CC) $^ -@cmd



