#----------------------------------------------------------------------------- 
#  Project :  
#  Modul   :  J:\g23m\condat\com\src\driver\gdi.mak
#----------------------------------------------------------------------------- 
#  Copyright 2002 Texas Instruments Berlin, AG 
#                 All rights reserved. 
# 
#                 This file is confidential and a trade secret of Texas 
#                 Instruments Berlin, AG 
#                 The receipt of or possession of this file does not convey 
#                 any rights to reproduce or disclose its contents or to 
#                 manufacture, use, or sell anything it may describe, in 
#                 whole, or in part, without the specific written consent of 
#                 Texas Instruments Berlin, AG. 
#----------------------------------------------------------------------------- 
#|  Purpose :  
#----------------------------------------------------------------------------- 
#
#	Setting Directory for GDI Objects
#
OBJ := $(L23_OBJ_DIR)/gdi

SRCCST=$(TI_BASE_DIR)/condat/gsm/condat/ms/src/cst
SRCDRV=$(CONDAT_DIR)/com/src/driver

GDI_L1_INC := $(patsubst %,-i%,$(CFG_INCLUDE)) $(patsubst %,-i%,$(RIVIERA_INCLUDES)) $(patsubst %,-i%,$(SERVICES_INCLUDES)) $(patsubst %,-i%,$(DRIVERS_INCLUDES)) $(patsubst %,-i%,$(LAYER1_INCLUDES))
INUC  =$(GPF_DIR)/INC/NUC

TM = -DTESTMODE=$(TESTMODE)

#SPR 1434, COLOURDISPLAY and CHINESE_MMI compilation flags for font_bitmaps.c
#SPR 1840  Added LSCREEN to allow us to control which font is used. 

COLOUR_MMI = 0
LSCREEN = 0

#
# Support for Colour display
#	
ifeq ($(BOARD),41)
COLOUR_MMI = 1
LSCREEN = 1
endif

ifeq ($(BOARD),40)
COLOUR_MMI = 1
LSCREEN = 1
endif

#COLOUR_MMI = 0
#LSCREEN = 0


ifeq ($(COLOUR_MMI),1)
COPT1 += -dCOLOURDISPLAY
else
COPT1 += -uCOLOURDISPLAY
endif

ifeq ($(LSCREEN),1)
COPT1 += -dLSCREEN
else
COPT1 += -uLSCREEN
endif

#conditional compilation flag CHINESE_MMI
ifeq ($(CHIMMI),1)
COPT1+= -dCHINESE_MMI
else
COPT1+= -uCHINESE_MMI
endif

#TTY settings
ifeq ($(FF_TTY),1)
COPT1 += -dFF_TTY
else
COPT1 += -uFF_TTY
endif

# to allow files to depend on L1 variants
# added by zhq.
ifdef L1
COPT1 += -dL1=$(L1)
endif


CUST = 0

DRVOBJ	= $(OBJ)/audio.$(OBJ_TAIL) $(OBJ)/display.$(OBJ_TAIL) $(OBJ)/keypad.$(OBJ_TAIL) \
	  $(OBJ)/light.$(OBJ_TAIL) $(OBJ)/power.$(OBJ_TAIL) $(OBJ)/rx.$(OBJ_TAIL) $(OBJ)/em.$(OBJ_TAIL) \
	  $(OBJ)/rtc.$(OBJ_TAIL) $(OBJ)/vmd.$(OBJ_TAIL) $(OBJ)/GameDisplay.$(OBJ_TAIL) $(OBJ)/ffs_coat.$(OBJ_TAIL)

#
# ---------------- create GDI ---------------------
#

$(GDI_LIB) : $(OBJ) $(DRVOBJ)
	$(AR) r $(GDI_LIB) $(CSTOBJ) $(DRVOBJ)

$(OBJ):
	mkdir $(subst /,$(SLASH),$(OBJ))

clean:
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(DRVOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCDRV)/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NWARN) >> cmd
	echo $(COPT) >> cmd
	echo $(TM) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo -DBOARD=$(BOARD) >> cmd
	echo -DCHIPSET=$(CHIPSET) >> cmd
	echo -DCUST=$(CUST) >> cmd
	echo -DLAYER1=$(L1) >> cmd
	echo -I$(SRCCST) >> cmd
#2003/12/23, zhq, modified for all build
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
	echo -I$(INUC) >> cmd
	echo -I$(ICDG) >> cmd
	echo $(ZHQDRV0) >> cmd
	echo $(ZHQDRV1) >> cmd
	echo $(ZHQDRV2) >> cmd
	echo $(patsubst %,-i$(TOP_DIR)/%, $(DRIVERS_DIR)/common/spi) >> cmd
	echo $(patsubst %,-i$(TOP_DIR)/%, $(DRIVERS_DIR)/common/pwr) >> cmd
#	echo $(GDI_L1_INC) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd
