/*
+-----------------------------------------------------------------------------
|  Project :
|  Modul   :
+-----------------------------------------------------------------------------
|  Copyright 2002 Texas Instruments Berlin, AG
|                 All rights reserved.
|
|                 This file is confidential and a trade secret of Texas
|                 Instruments Berlin, AG
|                 The receipt of or possession of this file does not convey
|                 any rights to reproduce or disclose its contents or to
|                 manufacture, use, or sell anything it may describe, in
|                 whole, or in part, without the specific written consent of
|                 Texas Instruments Berlin, AG.
+-----------------------------------------------------------------------------
|  Purpose :  Component Table for GPRS
+-----------------------------------------------------------------------------
*/

#ifndef _TARGET_
#define NEW_ENTITY
#endif

/*==== INCLUDES ===================================================*/

#include "nucleus.h"
#include "typedefs.h"
#include "os.h"
#include "vsi.h"
#include "pei.h"
#include "gprsconst.h"
#include "frm_defs.h"
#include "frm_types.h"
#include "frm_glob.h"
#include "os_types.h"
#include "os_glob.h"

/*==== CONSTANTS ==================================================*/


/*==== EXTERNALS ==================================================*/

extern SHORT tstrcv_pei_create(T_PEI_INFO const **Info);
extern SHORT tstsnd_pei_create(T_PEI_INFO const **Info);
extern SHORT aci_pei_create   (T_PEI_INFO const **Info);
extern SHORT cst_pei_create   (T_PEI_INFO const **Info);
extern SHORT sim_pei_create   (T_PEI_INFO const **Info);
extern SHORT sms_pei_create   (T_PEI_INFO const **Info);
extern SHORT cc_pei_create    (T_PEI_INFO const **Info);
extern SHORT sm_pei_create    (T_PEI_INFO const **Info);
extern SHORT ss_pei_create    (T_PEI_INFO const **Info);
extern SHORT mm_pei_create    (T_PEI_INFO const **Info);
extern SHORT gmm_pei_create   (T_PEI_INFO const **Info);
extern SHORT rr_pei_create    (T_PEI_INFO const **Info);
extern SHORT grr_pei_create   (T_PEI_INFO const **Info);
#ifdef GRR_PPC_IF_PRIM
extern SHORT ppc_pei_create   (T_PEI_INFO const **Info);
#endif /* #ifdef GRR_PPC_IF_PRIM */
extern SHORT dl_pei_create    (T_PEI_INFO const **Info);
extern SHORT pl_pei_create    (T_PEI_INFO const **Info);
extern SHORT l2r_pei_create   (T_PEI_INFO const **Info);
extern SHORT rlp_pei_create   (T_PEI_INFO const **Info);
extern SHORT fad_pei_create   (T_PEI_INFO const **Info);
extern SHORT t30_pei_create   (T_PEI_INFO const **Info);
extern SHORT llc_pei_create   (T_PEI_INFO const **Info);
extern SHORT sndcp_pei_create (T_PEI_INFO const **Info);
extern SHORT ppp_pei_create   (T_PEI_INFO const **Info);
extern SHORT uart_pei_create  (T_PEI_INFO const **Info);

#ifdef FF_PKTIO
extern SHORT pktio_pei_create (T_PEI_INFO const **Info);
#endif /* #ifdef FF_PKTIO */

#ifdef FF_EOTD
extern SHORT lc_pei_create    (T_PEI_INFO const **Info);
extern SHORT rrlp_pei_create  (T_PEI_INFO const **Info);
#endif /* FF_EOTD */

#ifdef WAP
extern SHORT udp_pei_create   (T_PEI_INFO const **Info);
extern SHORT ip_pei_create    (T_PEI_INFO const **Info);
extern SHORT wap_pei_create   (T_PEI_INFO const **Info);
#endif /* WAP */

#ifndef _TARGET_
extern SHORT ra_pei_create    (T_PEI_INFO const **Info);
#endif

#ifdef _TARGET_
extern SHORT l1_pei_create    (T_PEI_INFO const **Info);
#ifdef FF_TCP_IP
extern SHORT aaa_pei_create ( T_PEI_INFO const **Info);
#endif /* FF_TCP_IP */
#endif /* _TARGET_ */


/*Talcon Hu 2004.07.15 added for pcsyn*/
#ifdef MMI_PCSYN_ENABLED
extern SHORT pcsyn_pei_create (T_PEI_INFO const **info);
#endif

/*Talcon Hu 2004.07.17 added for mms*/
#ifdef MMI_MMSTASK_ENABLED
extern SHORT mms_pei_create (T_PEI_INFO const **info);
#endif

/*==== VARIABLES ==================================================*/

//EF For normal Test Definition Language (TDL) TAP usage set newTstHeader = FALSE
//EF For multiple entity (TCSL) Test Case Script Lang.   set newTstHeader = TRUE
#ifndef _TARGET_

#ifdef TDL_TAP
BOOL newTstHeader = FALSE;
#else
BOOL newTstHeader = TRUE;	
#endif

#endif

#ifndef DATA_EXT_RAM

const T_COMPONENT_ADDRESS tstrcv_list[] =
{
  { tstrcv_pei_create,   NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS tstsnd_list[] =
{
  { tstsnd_pei_create,   NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS mmi_list[] =
{
  { aci_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS cst_list[] =
{
  { cst_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS sim_list[] =
{
  { sim_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS cm_list[] =
{
  { sms_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { cc_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { sm_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { ss_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   (int)"CM" }
};

const T_COMPONENT_ADDRESS mmgmm_list[] =
{
  { mm_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { gmm_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   (int)"MMGMM" }
};

const T_COMPONENT_ADDRESS rr_list[] =
{
  { rr_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS grr_list[] =
{
  { grr_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

#ifdef GRR_PPC_IF_PRIM
const T_COMPONENT_ADDRESS ppc_list[] =
{
  { ppc_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};
#endif /* #ifdef GRR_PPC_IF_PRIM */

const T_COMPONENT_ADDRESS dl_list[] =
{
  { dl_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS pl_list[] =
{
  { pl_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS l2rt30_list[] =
{
  { l2r_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { t30_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   (int)"L2RT30" }
};

const T_COMPONENT_ADDRESS rlpfad_list[] =
{
  { rlp_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { fad_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   (int)"RLPFAD" }
};


const T_COMPONENT_ADDRESS llc_list[] =
{
  { llc_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS sndcp_list[] =
{
  { sndcp_pei_create,    NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS ppp_list[] =
{
  { ppp_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS uart_list[] =
{
  { uart_pei_create,     NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

#ifdef FF_PKTIO
const T_COMPONENT_ADDRESS pktio_list[] =
{
  { pktio_pei_create,    NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};
#endif /* #ifdef FF_PKTIO */

#ifdef FF_EOTD
const T_COMPONENT_ADDRESS eotd_list[] =
{
  { lc_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { rrlp_pei_create,     NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   (int)"EOTD" }
};
#endif /* FF_EOTD */

#ifdef WAP
const T_COMPONENT_ADDRESS wap_list[] =
{
  { wap_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS udp_list[] =
{
  { udp_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};

const T_COMPONENT_ADDRESS ip_list[] =
{
  { ip_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};
#endif /* WAP */

#ifndef _TARGET_
const T_COMPONENT_ADDRESS ra_list[] =
{
  { ra_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};
#endif /* !_TARGET_ */

#ifdef FF_TCP_IP
const T_COMPONENT_ADDRESS aaa_list[] =
{
#ifdef _TARGET_
  { aaa_pei_create,      NULL,   ASSIGNED_BY_CONDAT },
#else /* _TARGET_ */
  { NULL,               "AAA",   ASSIGNED_BY_CONDAT },
#endif /* else _TARGET_ */
  { NULL,                NULL,   0 }
};
#endif /* FF_TCP_IP */

const T_COMPONENT_ADDRESS l1_list[] =
{
#ifdef _TARGET_
  { l1_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
#else
  { NULL,                "L1",   ASSIGNED_BY_CONDAT },
#endif
  { NULL,                NULL,   0 }
};

#ifdef MMI_PCSYN_ENABLED
const T_COMPONENT_ADDRESS pcsyn_list[] =
{
  { pcsyn_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};
#endif

#ifdef MMI_MMSTASK_ENABLED
const T_COMPONENT_ADDRESS mms_list[] =
{
  { mms_pei_create,       NULL,   ASSIGNED_BY_CONDAT },
  { NULL,                NULL,   0 }
};
#endif

const T_COMPONENT_ADDRESS *ComponentTables[]=
{
  tstrcv_list,
  tstsnd_list,
  mmi_list,
  cst_list,
  sim_list,
  cm_list,
  mmgmm_list,
  rr_list,
  grr_list,
#ifdef GRR_PPC_IF_PRIM
  ppc_list,
#endif
  dl_list,
  pl_list,
  l2rt30_list,
  rlpfad_list,
  llc_list,
  sndcp_list,
  ppp_list,
  uart_list,
#ifdef FF_PKTIO
  pktio_list,
#endif
#ifdef FF_EOTD
  eotd_list,
#endif
#ifdef WAP
  wap_list,
  udp_list,
  ip_list,
#endif
#ifndef _TARGET_
  ra_list,
#endif /* !_TARGET_ */
#ifdef FF_TCP_IP
  aaa_list,
#endif /* FF_TCP_IP */
  l1_list,
#ifdef MMI_PCSYN_ENABLED
 pcsyn_list,
#endif

#ifdef MMI_MMSTASK_ENABLED
 mms_list,
#endif
  NULL
};

/*==== VERSIONS ===================================================*/
#ifndef CTRACE
  char * str2ind_version = "&0";
#endif

#endif /* DATA_EXT_RAM */
