/*
+--------------------------------------------------------------------+
| PROJECT: PCO2 ()                    $Workfile:: pco_pdi.h         $|
| Author:: RK  CONDAT GmbH            $Revision: 1.1.1.1 $|
| CREATED: 2.08.00                    $Modtime:: 6.09.99 12:07      $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : PCO_PDI

   PURPOSE : This header provides functions to read and store data for
             usage with the pdi-module (Primitive Decoding Information).
             Furthermore filter functions are included. (filtering by opc,
             up/downlink and air message id)

*/


#ifndef _PCO_PDI_H_
#define _PCO_PDI_H_

/*==== INCLUDES ==================================================*/
#include "ccdapi.h"
extern "C" {
#include "pdi.h"
}

/*==== GLOABAL FUNCTION DECLARATIONS =============================*/

/*
+---------------------------------------------------------------------+
| PROJECT : PCO2                       MODULE  : PCO_PDI              |
| STATE   : code                       ROUTINE : pco_pdi_init         |
+---------------------------------------------------------------------+

  PURPOSE : initalized pdi data for pco

  PARAMS:   fname .. name of file with pdi data

  RETURNS:   0 .. sucess
            -1 .. otherwise

*/
int pco_pdi_init(const char* fname);

int pco_pdi_exit();


T_PDI_CONTEXT* pco_pdi_context();


#endif /*_PCO_PDI_H_*/