/*
+------------------------------------------------------------------------------
|  File:       tdc_msg.h
+------------------------------------------------------------------------------
|              Copyright Condat AG 2002, Berlin
|              All rights reserved.
|
|              This file is confidential and a trade secret of Condat AG.
|              The receipt of or possession of this file does not convey
|              any rights to reproduce or disclose its contents or to
|              manufacture, use, or sell anything it may describe, in
|              whole, or in part, without the specific written consent of
|              Condat AG.
+------------------------------------------------------------------------------
| Purpose:     
|
+------------------------------------------------------------------------------
*/

#ifdef TDC_H
#error "TDC.H already included, TDC.H must come after all primitives and messages"
#endif

#ifndef TDC_MSG_H
#define TDC_MSG_H

#if DOT_COMPLETE_DEFINES

//----------------------------------------------------------------------------
// macros to repeat stuff that is similar in many interface classes 
//----------------------------------------------------------------------------

#define M_TDC_INTERFACE_PRIM_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_PSTRUCT_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_PUNION_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_SDU_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_PENUM_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_PINT_ADDITIONAL(INT_NAME, SHORT_NAME)

//-----

#define M_TDC_INTERFACE_MSG_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_MSTRUCT_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_MUNION_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_MENUM_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_MINT_ADDITIONAL(INT_NAME, SHORT_NAME)

//-----

#define M_TDC_INTERFACE_INT_ADDITIONAL(SHORT_NAME)

#define M_TDC_INTERFACE_XXX_PRIMITIVE_UNION_ADDITIONAL(SAP)

#define M_TDC_INTERFACE_XXX_MESSAGE_UNION_ADDITIONAL(MSG)

#define M_TDC_CREATE_DEFAULT_PRIMITIVE_INTERFACE_CLASS(SAP)

#define M_TDC_INTERFACE_PRIMITIVE_ADDITIONAL()

#define M_TDC_INTERFACE_PRIMITIVE_ELEMENT_ADDITIONAL(SAP)

#define M_TDC_CREATE_DEFAULT_MESSAGE_INTERFACE_CLASS(MSG)

#define M_TDC_INTERFACE_MESSAGE_ADDITIONAL()

#define M_TDC_INTERFACE_MESSAGE_ELEMENT_ADDITIONAL(MSG)

#else
#endif

#include "tdc_base.h"

#ifndef TDC_DESCRIPTOR
#include "message.h"
#include "primitive.h"
#else
#include "message_dsc.h"
#include "primitive_dsc.h"
#endif

struct T_TDC_INTERFACE_U8;

//TODO: eliminate need for these types used by M_RR (this is a bug work around)
typedef T_TDC_HANDLE_U8 T_TDC_HANDLE_AVG_W;
typedef T_TDC_HANDLE_U8 T_TDC_HANDLE_AVG_T;
typedef T_TDC_INTERFACE_U8 T_TDC_INTERFACE_AVG_W;
typedef T_TDC_INTERFACE_U8 T_TDC_INTERFACE_AVG_T;
//TODO: eliminate need for these types used by M_GRR (this is a bug work around)
typedef T_TDC_HANDLE_U8 T_TDC_HANDLE_RESEL;
typedef T_TDC_INTERFACE_U8 T_TDC_INTERFACE_RESEL;

//TODO: eliminate need for these types used by CCDGEN_TEST (this is a bug work around)
typedef struct T_TDC_DESCRIPTOR_TEST_v1 T_TDC_DESCRIPTOR_TEST_var1;
typedef struct T_TDC_DESCRIPTOR_TEST_v2 T_TDC_DESCRIPTOR_TEST_var2;
typedef struct T_TDC_DESCRIPTOR_TEST_var4 T_TDC_DESCRIPTOR_TEST_var4T;
typedef struct T_TDC_DESCRIPTOR_TEST_enum4 T_TDC_DESCRIPTOR_TEST_enum4T;
typedef struct T_TDC_HANDLE_TEST_v1 T_TDC_HANDLE_TEST_var1;
typedef struct T_TDC_HANDLE_TEST_v2 T_TDC_HANDLE_TEST_var2;
typedef struct T_TDC_HANDLE_TEST_var4 T_TDC_HANDLE_TEST_var4T;
typedef struct T_TDC_HANDLE_TEST_enum4 T_TDC_HANDLE_TEST_enum4T;
typedef struct T_TDC_HANDLE_TEST_comp4 T_TDC_HANDLE_TEST_comp4T;
typedef struct T_TDC_HANDLE_TEST_union4 T_TDC_HANDLE_TEST_union4T;
typedef struct T_TDC_INTERFACE_TEST_v1 T_TDC_INTERFACE_TEST_var1;
typedef struct T_TDC_INTERFACE_TEST_v2 T_TDC_INTERFACE_TEST_var2;
typedef struct T_TDC_INTERFACE_TEST_var4 T_TDC_INTERFACE_TEST_var4T;
typedef struct T_TDC_INTERFACE_TEST_enum4 T_TDC_INTERFACE_TEST_enum4T;


M_TDC_FORWARD_SDU (sdu)
struct T_TDC_DESCRIPTOR_sdu;
struct T_TDC_HANDLE_sdu;
struct T_TDC_INTERFACE_sdu;
struct T_sdu;
typedef T_TDC_HANDLE_sdu T_TDC_HANDLE_SDU;
typedef T_TDC_DESCRIPTOR_sdu T_TDC_DESCRIPTOR_SDU;
typedef T_TDC_INTERFACE_sdu T_TDC_INTERFACE_SDU;
typedef T_sdu T_TDC_INSTANCE_SDU;


struct T_TDC_HANDLE_desc_list
{
	//TODO: make some sencible stuff here
};
struct T_TDC_HANDLE_desc
{
	//TODO: make some sencible stuff here
};
struct T_TDC_INTERFACE_desc_list
{
	//TODO: make some sencible stuff here
};
struct T_TDC_INTERFACE_desc
{
	//TODO: make some sencible stuff here
};



#ifdef TDC_DESCRIPTOR

/*M_TDC_FORWARD_PSTRUCT(raw)
M_TDC_FORWARD_PSTRUCT(aim)
M_TDC_FORWARD_PSTRUCT(sdu)*/

struct T_TDC_DESCRIPTOR_aim:T_TDC_DESCRIPTOR_PSTRUCT_BASE
{
	M_TDC_DESCRIPTOR_PSTRUCT_ADDITIONAL (aim)
	T_TDC_HANDLE_U8 ti; 
	T_TDC_HANDLE_U8 tie;
	T_TDC_HANDLE_MESSAGE_UNION entity;
};

struct T_TDC_DESCRIPTOR_sdu:T_TDC_DESCRIPTOR_SDU_BASE
{
	M_TDC_DESCRIPTOR_SDU_ADDITIONAL (sdu)
	T_TDC_HANDLE_raw raw; //manual sdu
	T_TDC_HANDLE_aim aim; //coded sdu
};

#endif

#if !defined TDC_DESCRIPTOR || defined TDC_PRECOMPILE 

struct T_aim:T_TDC_INSTANCE_PSTRUCT_BASE
{
  M_TDC_INSTANCE_PSTRUCT_ADDITIONAL (aim,aim)
  T_TDC_INTERFACE_aim* operator-> ();
};
struct T_TDC_INTERFACE_aim:T_TDC_INTERFACE_PSTRUCT_BASE
{
  M_TDC_INTERFACE_PSTRUCT_ADDITIONAL (aim,aim)
  T_TDC_INTERFACE_U8 ti;
  T_TDC_INTERFACE_U8 tie;
  T_TDC_INTERFACE_MESSAGE_UNION entity;
#ifdef TDC_TYPE_NAME_COMPLETE
  struct { char T_aim, ___ti___tie___entiy; } _type_name ();
#endif
};

struct T_sdu:T_TDC_INSTANCE_SDU_BASE
{
  M_TDC_INSTANCE_SDU_ADDITIONAL (sdu)
  T_TDC_INTERFACE_sdu* operator-> ();
};
struct T_TDC_INTERFACE_sdu:T_TDC_INTERFACE_SDU_BASE
{
  M_TDC_INTERFACE_PSTRUCT_ADDITIONAL (sdu,sdu)
  T_TDC_INTERFACE_raw raw; //manual sdu
  T_TDC_INTERFACE_aim aim; //coded sdu
#ifdef TDC_TYPE_NAME_COMPLETE
  struct { char T_sdu, ___raw___aim; } _type_name ();
#endif
};

#endif //!defined TDC_DESCRIPTOR || defined TDC_PRECOMPILE 

//============================================================================
template <class T>
T_sdu tds_array_to_sdu(const T& U8array)
//This function is a temporary solution to help the convertion from TDS U8 arrays to TDC SDU's.
{
	T_sdu sdu; 
	sdu->raw.l_buf = U8array[0] + U8array[1] * 256;
	sdu->raw.o_buf = U8array[2] + U8array[3] * 256;
	if (sizeof(U8array)>4)
	{
		for (int i = 4; i < sizeof(U8array);i++)
		{
			sdu->raw.buf[i-4] = U8array[i];
		}
	}
	else
	{
		sdu->raw.buf = T_ARRAY<U8>();
	}
	return sdu;
}
//============================================================================
#endif //TDC_MSG_H
