/* 
+------------------------------------------------------------------------------
|  File:       os_const.h
+------------------------------------------------------------------------------
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Constants for the WIN32 OS-Layer
+----------------------------------------------------------------------------- 
*/ 

#ifndef OS_CONST_H
#define OS_CONST_H

/*==== INCLUDES =============================================================*/

#include "shared.h"

/*==== CONSTS ===============================================================*/

#define PT_OVERHEAD   0
#define POOL_OVERHEAD 0

#define PPM_CHKOVERHEAD  0
#define PPM_OVERHEAD     0

#define PPM_OFFSET       ((PPM_OVERHEAD-PPM_CHKOVERHEAD)/sizeof(ULONG))

#define PT_CHKOVERHEAD   0

#define SUSPEND_ONE_TICK           1

#define OS_SUSPEND       0xffffffffUL  /*NU_SUSPEND*/
#define OS_NO_SUSPEND    0             /*NU_NO_SUSPEND*/

#define OS_FOREVER       0xffffffffUL  /*NU_SUSPEND*/

#define OS_SYSTEM_ERROR(A,B,C,D,E)

/*==== TYPES =================================================================*/


/*==== EXPORTS ===============================================================*/


#endif /* OS_CONST_H */
