/* 
+------------------------------------------------------------------------------
|  File:       tst_reception.h
+------------------------------------------------------------------------------
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Definitions for VCMS-Processes to announce to tst.
+----------------------------------------------------------------------------- 
*/ 

#ifndef TST_RECEPTION_H
#define TST_RECEPTION_H

/*==== INCLUDES =============================================================*/

/*==== CONSTS ===============================================================*/
/* Return values */
#define TST_REC_OK              0
#define TST_REC_NO_MEM          1
#define TST_REC_NO_TSTQ         2
#define TST_REC_TSTQ_ERROR      3

/*==== TYPES =================================================================*/

/*==== EXPORTS ===============================================================*/

#ifndef TST_RECEPTION_C

#ifdef __cplusplus
extern  "C" {
#endif /*_cplusplus*/

extern int tst_register (const char* who);
extern int tst_withdraw (const char* who);
extern int tst_send (const char* string, const char* receiver);

#ifdef __cplusplus
}
#endif /*_cplusplus*/

#endif /* !TST_RECEPTION_C */

#endif /* !TST_RECEPTION_H */
