/* 
+----------------------------------------------------------------------------- 
|  Project :  
|  Modul   :  aci_error
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  This modul ...
+----------------------------------------------------------------------------- 
*/ 

#ifndef ACI_ERR_H
#define ACI_ERR_H

/*
 *  this enum is used to jump into  ati_err_tbl[]
 *  it must start with 0  and must not have gaps !
 *  0,1,2,3,...n
 *  AND IT MUST FIT TO ati_err_tbl[].
 */
#define ACI_ERROR_NONE -1
 
typedef enum
{
  CME_ERR_NotPresent = 0,
  CME_ERR_PhoneFail,
  CME_ERR_NoConnect,
  CME_ERR_LinkRes,
  CME_ERR_OpNotAllow,
  CME_ERR_OpNotSupp,
  CME_ERR_PhSimPinReq,
  CME_ERR_SimNotIns,
  CME_ERR_SimPinReq,
  CME_ERR_SimPukReq,
  CME_ERR_SimFail,
  CME_ERR_SimBusy,
  CME_ERR_SimWrong,
  CME_ERR_WrongPasswd,
  CME_ERR_SimPin2Req,
  CME_ERR_SimPuk2Req,
  CME_ERR_MemFull,
  CME_ERR_InvIdx,
  CME_ERR_NotFound,
  CME_ERR_MemFail,
  CME_ERR_TxtToLong,
  CME_ERR_InvalidTxtChar,
  CME_ERR_DialToLong,
  CME_ERR_InvDialChar,
  CME_ERR_NoServ,
  CME_ERR_Timeout,
  CME_ERR_LimServ,
  CME_ERR_NetworkPersPinReq,        /* PIN to change network personalisation required */
  CME_ERR_NetworkPersPukReq,        /* network personalisation PUK is required */
  CME_ERR_NetworkSubsetPersPinReq,  /* keycode to change nw subset personalisation required */
  CME_ERR_NetworkSubsetPersPukReq,  /* network subset  personalisation PUK is required */
  CME_ERR_ProviderPersPinReq,       /* keycode to change service provider personal. required */
  CME_ERR_ProviderPersPukReq,       /* service provider personalisation PUK is required */
  CME_ERR_CorporatePersPinReq,      /* keycode to change corporate personalisation required */
  CME_ERR_CorporatePersPukReq,      /* corporate personalisation PUK is required */
  CME_ERR_Unknown,                  /* ATTENTION! If you insert new entries before CME_ERR_Unknown, remember to increase NBR_CME_NORM_ERR */
#ifdef GPRS
  CME_ERR_GPRSBadMs,
  CME_ERR_GPRSBadMe,
  CME_ERR_GPRSNoService,
  CME_ERR_GPRSBadPlmn,
  CME_ERR_GPRSBadLoc,
  CME_ERR_GPRSNoRoam,
  CME_ERR_GPRSSerOptNsup,
  CME_ERR_GPRSSerOptNsub,
  CME_ERR_GPRSSerOptOOO,
  CME_ERR_GPRSUnspec,
  CME_ERR_GPRSPdpAuth,
  CME_ERR_GPRSBadModClass,
#endif /* GPRS */
  CME_ERR_FailedToAbort,
  CME_ERR_AcmResetNeeded,
/*************************/
  CEER_NotPresent,
  CEER_Unassign,
  CEER_NoRoute,
  CEER_ChanUnaccept,
  CEER_Barred,
  CEER_CallClear,
  CEER_UserBusy,
  CEER_NoResponse,
  CEER_AlertNoAnswer,
  CEER_CallReject,
  CEER_NumChanged,
  CEER_UserClear,
  CEER_DestOutOfOrder,
  CEER_NumFormat,
  CEER_FacilityReject,
  CEER_StatusEnquiry,
  CEER_Unspecified,
  CEER_NoChanAvail,
  CEER_NetworkOutOfOrder,
  CEER_TempFailure,
  CEER_SwitchCongest,
  CEER_InfoDiscard,
  CEER_ReqChanUnavail,
  CEER_ResourceUnavail,
  CEER_QOS_Unavail,
  CEER_FAC_Unsubscr,
  CEER_BarredInCUG,
  CEER_BearerCapNotAuth,
  CEER_BearerCapUnavail,
  CEER_ServUnavail,
  CEER_BearerNotImpl,
  CEER_ACM_Max,
  CEER_FAC_NotImpl,
  CEER_RestrictBearerCap,
  CEER_ServNotImpl,
  CEER_InvalidTI,
  CEER_UserNotInCUG,
  CEER_IncompatDest,
  CEER_InvalidTransNet,
  CEER_IncorrMsg,
  CEER_InvalidMandInfo,
  CEER_MsgTypeNotImpl,
  CEER_MsgTypeIncomp,
  CEER_InfoElemNotImpl,
  CEER_CondInfoElem,
  CEER_MsgIncomp,
  CEER_Timer,
  CEER_Protocol,
  CEER_Interworking,
  CEER_ReqBearerServNotAvail,
  CEER_NoTransIdAvail,
  CEER_Timer303,
  CEER_EstabFail,
  CEER_NoError,
  CEER_Failed,
  CEER_Timeout,
  CEER_BearerServNotCompat,
#ifdef GPRS
  CEER_FailedGPRSAttach,
  CEER_FailedGPRSContextAct,
  CEER_GPRSDetach,
  CEER_GPRSDeactivation,
#endif /* GPRS */
/*************************/
  EXT_ERR_NotPresent,
  EXT_ERR_Parameter,
  EXT_ERR_DataCorrupt,
  EXT_ERR_Internal,
  EXT_ERR_CallTabFull,
  EXT_ERR_SrvTabFull,
  EXT_ERR_CallNotFound,
  EXT_ERR_NoDataCallSup,
  EXT_ERR_OneCallOnHold,
  EXT_ERR_CallTypeNoHold,
  EXT_ERR_FdnCheck,
  EXT_ERR_BdnCheck,
  EXT_ERR_ParallelUSSD,
  EXT_ERR_FaxMinSpeedCond,
  EXT_ERR_CmdDetailsSAT,
  EXT_ERR_Unknown,
/*************************/
  CMS_ERR_UnAllocNum,      
  CMS_ERR_OpDetermBarr,     
  CMS_ERR_CallBarr,    
  CMS_ERR_TransReject,      
  CMS_ERR_DestOutOfServ,    
  CMS_ERR_UnidentSubsc,
  CMS_ERR_FacReject,
  CMS_ERR_UnKnownSubsc,
  CMS_ERR_NetOutOfOrder,    
  CMS_ERR_TempFail,         
  CMS_ERR_Congestion,
  CMS_ERR_ResUnAvail,       
  CMS_ERR_FacNotSubscr,     
  CMS_ERR_FacNotImpl,       
  CMS_ERR_TransRefInval,    
  CMS_ERR_InValSM,          
  CMS_ERR_InValManInfo,
  CMS_ERR_MsgTypNotExist,
  CMS_ERR_MsgNotCompatible,
  CMS_ERR_InfoElemNotImpl,
  CMS_ERR_ProtErr,
  CMS_ERR_InterWrkUnSpec,
  CMS_ERR_TlmtkNotSup,     
  CMS_ERR_SM0NotSup,
  CMS_ERR_CantReplceSM,
  CMS_ERR_UnSpecPIDErr,
  CMS_ERR_DcsNotSup,
  CMS_ERR_MsgClassNotSup,
  CMS_ERR_UnSpecTpDcs,
  CMS_ERR_CmdNotAct,
  CMS_ERR_CmdUnSup,
  CMS_ERR_UnSpecTpCmd,
  CMS_ERR_TpduUnSup,
  CMS_ERR_ScBsy,
  CMS_ERR_NoScSubsc,
  CMS_ERR_ScSysFail,
  CMS_ERR_InValSme,
  CMS_ERR_DestSmeBarr,
  CMS_ERR_SmRejctDuplSm,
  CMS_ERR_SimSmsStorFull,
  CMS_ERR_NoStorInSim,
  CMS_ERR_ErrInMs,
  CMS_ERR_MemCabExcee,
  CMS_ERR_UnSpecErr,
  CMS_ERR_MeFail,
  CMS_ERR_ServRes,
  CMS_ERR_OpNotAllowed,
  CMS_ERR_OpNotSup,
  CMS_ERR_InValPduMod,
  CMS_ERR_InValTxtMod,
  CMS_ERR_SimNotIns,
  CMS_ERR_SimPinReq,
  CMS_ERR_PhSimPinReq,
  CMS_ERR_SimFail,
  CMS_ERR_SimBsy,
  CMS_ERR_SimWrong,
  CMS_ERR_SimPukReq,
  CMS_ERR_SimPin2Req,
  CMS_ERR_SimPuk2Req,
  CMS_ERR_MemFail,
  CMS_ERR_InValMemIdx,
  CMS_ERR_MemFull,
  CMS_ERR_SmscAdrUnKnown,
  CMS_ERR_NoNetServ,
  CMS_ERR_NetTimeOut,
  CMS_ERR_NoCnmaAckExpect,
  CMS_ERR_UnknownErr,
  CMS_ERR_FailedToAbort,
  CMS_ERR_NotPresent   
} T_ACI_ERR;

/* !!! for CMS_ERR_AcmResetNeeded no message, so removed from T_ACI_ERR !!! */

typedef enum
{
  ACI_ERR_VERBOSE_NONE,
  ACI_ERR_VERBOSE_NUMERIC,
  ACI_ERR_VERBOSE_FULL 
} T_ACI_ERR_VERBOSE;

EXTERN CHAR *aci_error (T_ACI_ERR e, T_ACI_ERR_VERBOSE ev);

#endif /* ACI_ERR_H */
