/* 
+----------------------------------------------------------------------------- 
|  Project :  GSM-PS (6147)
|  Modul   :  CMH_MM
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Definitions for the command handler of the
|             Mobility Mangement
+----------------------------------------------------------------------------- 
*/ 

#ifndef CMH_MM_H
#define CMH_MM_H

/*==== CONSTANTS ==================================================*/
#define PNN_SHORT_NAME_IEI	0x45
#define PNN_LONG_NAME_IEI	0x43

/*==== TYPES ======================================================*/
 
/*==== PROTOTYPES =================================================*/
EXTERN SHORT            cmhMM_Registered   ( void );
EXTERN SHORT            cmhMM_Deregistered ( void );
EXTERN SHORT            cmhMM_SelNetwork ( void );
EXTERN SHORT            cmhMM_NetworkLst ( void );

EXTERN T_OPER_NTRY*     cmhMM_FindPLMN     ( SHORT mcc, SHORT mnc, UBYTE idx);
EXTERN void             cmhMM_getBandSettings( UBYTE *SetBands,
                                               UBYTE *AllowedBands );
EXTERN BOOL             cmhMM_isBandAllowed( UBYTE band,
                                             UBYTE AllowedBands );
EXTERN BOOL             cmhMM_writeSetBand ( UBYTE setband );
EXTERN T_OPER_NTRY*     cmhMM_FindNumeric  ( const CHAR * numStr );
EXTERN T_OPER_NTRY*     cmhMM_FindName     ( const CHAR * longStr,
                                                   T_ACI_CPOL_FRMT format );
EXTERN void             cmhMM_CnvrtPLMN2INT( const UBYTE * BCDmcc,
                                             const UBYTE * BCDmnc,
                                                   SHORT * mccBuf,
                                                   SHORT * mncBuf );
EXTERN void             cmhMM_CnvrtINT2PLMN(       SHORT INTmcc,
                                                   SHORT INTmnc,
                                                   UBYTE * mccBuf,
                                                   UBYTE * mncBuf );
EXTERN T_ACI_CREG_STAT  cmhMM_GetNregCREGStat( void );
EXTERN T_ACI_CME_ERR    cmhMM_GetNregCMEStat ( void );
EXTERN USHORT           cmhMM_GetOperLstLen  ( void );
EXTERN void             cmhMM_CnvrtTrmPCMOpNam( void *pPCMBuf, UBYTE index );
EXTERN void             cmhMM_Ntfy_NtwRegistrationStatus( T_ACI_CREG_STAT creg );
EXTERN SHORT            cmhMM_CipheringInd  ( UBYTE ciph );
EXTERN void		   	cmhMM_OpCheckName ();  //EONS function
EXTERN void		   	cmhMM_OpCheckList ();//EONS function
EXTERN BOOL		   	cmhMM_OpReadName ( UBYTE rec_num);//EONS function
EXTERN void		   	cmhMM_OpReadNameCb ( SHORT table_id);//EONS function
EXTERN void       cmhMM_OpSetPNNLst(); //EONS function
EXTERN void		   	cmhMM_OpExtractNameCB ( SHORT table_id); //EONS function
EXTERN BOOL		   	cmhMM_OpUpdateName (); //EONS function

/*==== EXPORT =====================================================*/
#ifdef CMH_MMF_C

GLOBAL T_ENT_STAT mmEntStat;
GLOBAL BOOL regReqPnd = FALSE;

#else

EXTERN T_ENT_STAT mmEntStat;
EXTERN BOOL regReqPnd;

#endif /* CMH_MMF_C */

#endif /* CMH_MM_H */

/*==== EOF =======================================================*/
