/* 
+----------------------------------------------------------------------------- 
|  Project :  
|  Modul   :  J:\g23m-aci\aci_ext\aci_ext_pers_cus.h
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  
+----------------------------------------------------------------------------- 
*/ 


/* 
  The actual store holding ME's information about what SIM is valid for this personalised ME and what not.
  This is needed for the Condat default implementation and may be discarded by the customers implementation.
  */

/* actual status for each personalisation type */
T_ACI_PERS_STATUS personalisation_status =
  {
#ifdef SIMLOCK
    0x55,       /* locks1, everything switched on */
    0x01,       /* locks1, first SIM is off, corporate is switched on*/
#else /* SIMLOCK */
    0x00,       /* locks1, everything switched off */
    0x00,       /* locks1, everything switched off*/
#endif /* SIMLOCK */
    0,          /* cnt */
    3,          /* maxcnt */
    0x21,0x43,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,  /* PKey   */
    0x21,0x43,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,  /* SPKey  */
    0x21,0x43,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,  /* NSKey  */
    0x21,0x43,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,  /* CKey   */
    0x21,0x43,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,  /* NKey   */
    0x21,0x43,0x65,0xFF,0xFF,0xFF,0xFF,0xFF,  /* PUK    */
  };

/* personalisation data for a potential network lock */
T_ACI_PERS_DATAS_NW personalisation_nw =
{ /* IMSI: 012-03 xxxxxx */
  1,
  {{3,{0x09,0x21,0x30,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},   /* empty records up to PERSONALISATION_MAX */
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}}}
};

/* personalisation data for a potential network subnet lock */
T_ACI_PERS_DATAS_NW personalisation_ns =
{ /* IMSI: 012-03 10xxxx */
  1,
  {{4,{0x09,0x21,0x30,0x01,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}}}
};

/* personalisation data for a potential service provider lock */
T_ACI_PERS_DATAS_SP personalisation_sp =
{ /* IMSI: 012-03 102030xxxx*/
  1,
  {{6,{0x09,0x21,0x30,0x01,0x02,0x03,0xFF,0xFF},0x01},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF}}
};

/* personalisation data for a potential corporate lock */
T_ACI_PERS_DATAS_CP personalisation_cp =
{ /* IMSI: 012-03 102030xxxx*/
  1,
  {{6,{0x09,0x21,0x30,0x01,0x02,0x03,0xFF,0xFF},0x01,0x01},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF},0xFF,0xFF}}
};
  
/* personalisation data for a potential SIM lock */
T_ACI_PERS_DATAS_NW personalisation_sim =
{ /* IMSI: 012-03 1020305476 */
  1,
  {{8,{0x09,0x21,0x30,0x01,0x02,0x03,0x45,0x67}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}},
   {0,{0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF}}}
};

