#ifndef _MMICOORDINATE_H_
#define _MMICOORDINATE_H_ 1


/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   Coordinate Manager
 $File:       MmiCoordinate.h
 $Revision:   1.0
 
 $Author:   Mobile Innovation(UK)
 $Date:       15/5/03

********************************************************************************

 Description:

  common coordinate macros

********************************************************************************
 $History: MmiResources.h

   15/5/03     gudy add
 $End

*******************************************************************************/

/*definitions of font*/
#define U_WIDTH_16X16 16       /*16X16 UnicodeĿ*/
#define U_HEIGHTH_16X16 16     /*16X16 Unicodeĸ߶*/
#define A_WIDTH_16X16 8 		 /*16X16 ASCIIĿ*/
#define A_HEIGHTH_16X16 16		 /*16X16 ASCIIĸ߶*/
#define U_WIDTH_12X12 12		 /*12X12 UnicodeĿ*/
#define U_HEIGHTH_12X12 12		 /*12X12 Unicodeĸ߶*/
#define A_WIDTH_12X12 6		 /*12X12 ASCIIĿ*/
#define A_HEIGHTH_12X12 12 	 /*12X12 ASCIIĸ߶*/
/*invariable definitions in different lcd*/
#define LCD_LEFT 0
#define LCD_TOP 0

/*alterable definitions in different lcd*/
#if(ModelTyep==1)  /*coordinate in eg730b*/
        #define FIRST_LINE 16
		#define FIRST_LINE_ICON 16
		#define SECOND_LINE 32
		#define SECOND_LINE_ICON 32
		#define THIRD_LINE 48
		#define FOURTH_LINE 64
		#define FIFTH_LINE 80
		#define SIXTH_LINE 96
		#define SEVENTH_LINE 112	//sunsjtest
		#define TWENTY_LINE  160
		#define LINE_HEIGHT 16
		#define FIRST_LINE_CHINESE 16
		#define SECOND_LINE_CHINESE 32
		#define THIRD_LINE_CHINESE 48
		#define FOURTH_LINE_CHINESE 64
		#define LINE_HEIGHT_CHINESE 16

		#define CHINESE_MENU_VERTICAL_SIZE 144
		#define STANDARD_MENU_VERTICAL_SIZE 142  //xsf change it from 144 to 142  02.12.18
		#define VIEWLIST_MENU_VERTICAL_SIZE 142//zy 10/11
		#define STANDARD_CALL_TXT_VERTICAL 106//zy add 04/08/02 for display callresult 
		#define SCREEN_SIZE_X 128 //modified by ljq from 120 to 128 2003/4/10
		#define SCREEN_SIZE_Y 160  		
#else if(ModelTyep==0)      
/* 2004/01/04 sunsj modify for different lcd size */

#if (MAIN_LCD_SIZE==3)
#define LINE_HEIGHT				16//15//shiheng 288 modify
#define LINE_HEIGHT_CHINESE		16//15//shiheng 288 modify


#define SCREEN_SIZE_X			128	/* 2004/01/02 sunsj modify *///shiheng 288 modify
#define SCREEN_SIZE_Y			128//160	/* 2004/01/02 sunsj modify *///shiheng 288 modify

#define TITLE_HEIGHT			18//18//shiheng 288 modify
#define SOFTKEY_HEIGHT			18//18//shiheng 288 modify
#define MENU_PER_HEIGHT			18//18	/* 2004/01/13 sunsj *///shiheng 288 modify

#define CHINESE_MENU_VERTICAL_SIZE	110//144//shiheng 288 modify
#define STANDARD_MENU_VERTICAL_SIZE 110//142//shiheng 288 modify
#define VIEWLIST_MENU_VERTICAL_SIZE 110//142//shiheng 288 modify
#define STANDARD_CALL_TXT_VERTICAL	110//106//shiheng 288 modify

#elif  ( MAIN_LCD_SIZE==4 )
		#define LINE_HEIGHT				16
		#define LINE_HEIGHT_CHINESE		16

		#define SCREEN_SIZE_X			128	/* 2004/01/02 sunsj modify */
		#define SCREEN_SIZE_Y			160	/* 2004/01/02 sunsj modify */

		#define TITLE_HEIGHT			18
		#define SOFTKEY_HEIGHT			18
		#define MENU_PER_HEIGHT			18	/* 2004/01/13 sunsj */

		/* 2004/05/18 sunsj modify */
		#define CHINESE_MENU_VERTICAL_SIZE	144
		#define STANDARD_MENU_VERTICAL_SIZE 144
		#define VIEWLIST_MENU_VERTICAL_SIZE 144
		#define STANDARD_CALL_TXT_VERTICAL	106

#elif ( MAIN_LCD_SIZE==2 )
		#define LINE_HEIGHT				12
		#define LINE_HEIGHT_CHINESE		12

		#define SCREEN_SIZE_X		102 /* 2004/01/02 sunsj modify */
		#define SCREEN_SIZE_Y		80  /* 2004/01/02 sunsj modify */

		#define TITLE_HEIGHT			14
		#define SOFTKEY_HEIGHT			14
		#define MENU_PER_HEIGHT			13	/* 2004/03/24 sunsj */

		#define CHINESE_MENU_VERTICAL_SIZE	66
		#define STANDARD_MENU_VERTICAL_SIZE 66
		#define VIEWLIST_MENU_VERTICAL_SIZE 66
		#define STANDARD_CALL_TXT_VERTICAL	66
#endif
		#define FIRST_LINE				LINE_HEIGHT+2
		#define FIRST_LINE_ICON			LINE_HEIGHT+2
		#define SECOND_LINE				FIRST_LINE+LINE_HEIGHT
		#define SECOND_LINE_ICON		FIRST_LINE_ICON+LINE_HEIGHT
		#define THIRD_LINE				SECOND_LINE+LINE_HEIGHT
		#define FOURTH_LINE				THIRD_LINE+LINE_HEIGHT
		#define FIFTH_LINE				FOURTH_LINE+LINE_HEIGHT
		#define SIXTH_LINE				FIFTH_LINE+LINE_HEIGHT
		#define SEVENTH_LINE			SIXTH_LINE+LINE_HEIGHT

		#define FIRST_LINE_CHINESE		LINE_HEIGHT_CHINESE+2
		#define SECOND_LINE_CHINESE		FIRST_LINE_CHINESE+LINE_HEIGHT_CHINESE
		#define THIRD_LINE_CHINESE		SECOND_LINE_CHINESE+LINE_HEIGHT_CHINESE
		#define FOURTH_LINE_CHINESE		THIRD_LINE_CHINESE+LINE_HEIGHT_CHINESE			
#endif

#define X_CENTER     SCREEN_SIZE_X/2
#define Y_CENTER     SCREEN_SIZE_Y/2
#define LCD_RIGHT        SCREEN_SIZE_X
#define LCD_BOTTOM       SCREEN_SIZE_Y

/* 2004/01/14 sunsj add for title position */
#define TITLE_LEFT			1
#define TITLE_MIDDLE		2
#define TITLE_RIGHT			3
#define TITLE_WITH_NUMBER	4

#endif
