/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		timer
 $File:		    MmiUnitConversion.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the unit converting functionality

  
********************************************************************************
 $History: MmiToolkit.c

	25/10/00			Original Condat(UK) BMI version.
	06/09/02            gdy add
	   
 $End

*******************************************************************************/

/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "MmiBookShared.h"
#include "MmiEditor.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
#include "Mmitoolkit.h"
#include "Mmitimedate.h"
//#include "BmiEastAPI.h"
#include "GameDisplay.h"

#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "..\bmi\icons\ToolKitIcn.h"
#include "MmiUnitConversion.h"
/******************************************************************************
                                                                              
                                                                                                              
*******************************************************************************/
#define MAX_CHANGE_VALUE 99999999
#define MAX_STRING_LENGTH 15
static BOOL pointflag=FALSE;
static BOOL afterpointflag=FALSE;
static int afterpointcount1=0;
extern const unsigned char left_right[];

static const char SoftLeft_key_bmp[]={
0xff,0xff,0xbf,0xff,0x7f,0xff,0x5f,0xff,0x5f,0xff,0x5f,0xff,0x7f,0xff,0x7f,0xff,0x9f,0xff,0xbf,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x9f,0xff,0x1f,0xff,0x1f,0xff,0x1f,0xff,0x1f,0xff,0x1f,0xff,0x1f,0xff,0x1f,0xff,
0x1f,0xff,0x1f,0xff,0x1f,0xff,0x3f,0xff,0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,
0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xdf,0xfe,0xff,0xfe,0xff,0xff,
0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,
0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x7e,0xfe,0x9e,0xfe,0xdf,0xff,0xdf,0xff,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3d,0xfe,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,
0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0xfd,0x5d,0xfe,0xbe,0xf7,
0xdf,0xff,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1e,0xff,0x7c,0xf5,0x9c,0xf5,0x9c,0xf5,
0x7c,0xf5,0x9c,0xf5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x9c,0xf5,0x9c,0xf5,0x9c,0xf5,0x7c,0xf5,0x9c,0xf5,0x7c,0xf5,
0x9c,0xf5,0x7c,0xf5,0x7c,0xf5,0x9c,0xf5,0x9e,0xf7,0xbe,0xf7,0xdf,0xff,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xdf,0xff,0x5c,0xf6,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x1b,0xed,0x7d,0xef,0x9e,0xf7,0xbe,0xf7,
0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xdf,0xff,0xbb,0xed,0xba,0xe4,0xba,0xe4,0xba,0xe4,0xba,0xe4,0xba,0xe4,
0xba,0xe4,0xba,0xe4,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xba,0xe4,0xba,0xe4,0xba,0xe4,0xba,0xe4,0xba,0xe4,
0xba,0xe4,0xba,0xe4,0x3c,0xe7,0x7d,0xef,0x9e,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xdf,0xff,0x9e,0xf7,0xfb,0xe5,
0x59,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0x39,0xdc,0xb9,0xdc,0x1c,0xe7,0x7d,0xef,0xbe,0xf7,0xdf,0xff,0xff,0xff,
0xff,0xff,0xdf,0xff,0xbe,0xf7,0x7d,0xef,0x9b,0xe6,0x78,0xd4,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,
0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xff,0xff,0xff,0xff,0xff,0xff,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xd8,0xd3,0xba,0xd6,
0x1c,0xe7,0x7d,0xef,0xbe,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0x9e,0xf7,0x5d,0xef,0x1c,0xe7,0x79,0xd5,0xd7,0xcb,
0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x57,0xcb,0x77,0xcb,
0x57,0xcb,0x57,0xcb,0x57,0xcb,0x59,0xce,0xdb,0xde,0x3c,0xe7,0x9e,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xbe,0xf7,
0x9e,0xf7,0x5d,0xef,0x1c,0xe7,0xba,0xd6,0x18,0xcd,0xb6,0xc3,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,
0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0xf6,0xc2,0x36,0xc3,0x18,0xc6,0x9a,0xd6,0x1c,0xe7,0x7d,0xef,0xdf,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xbe,0xf7,0x9e,0xf7,0x5d,0xef,0x1c,0xe7,0xdb,0xde,0x79,0xce,0x38,0xc6,0x76,0xbc,
0x35,0xbb,0x95,0xc2,0x95,0xc2,0x95,0xc2,0x95,0xc2,0x95,0xc2,0x95,0xc2,0x95,0xc2,0x95,0xc2,0xb5,0xc2,0x75,0xb4,0xf7,0xbd,
0x79,0xce,0x1c,0xe7,0x7d,0xef,0xbe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xdf,0xff,0x9e,0xf7,0x7d,0xef,
0x3c,0xe7,0xfb,0xde,0xba,0xd6,0x59,0xce,0x18,0xc6,0xf7,0xbd,0x95,0xb4,0xd5,0xb3,0x94,0xb3,0xf4,0xb2,0xd4,0xb2,0xd4,0xb2,
0xb4,0xb3,0xd5,0xac,0x96,0xb5,0xf7,0xbd,0x79,0xce,0x1c,0xe7,0x9e,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xdf,0xff,0xbe,0xf7,0x9e,0xf7,0x5d,0xef,0x1c,0xe7,0xdb,0xde,0xba,0xd6,0x79,0xce,0x38,0xc6,0xf7,0xbd,
0xd7,0xbd,0x96,0xb5,0x96,0xb5,0x75,0xad,0x96,0xb5,0x96,0xb5,0xf7,0xbd,0x38,0xc6,0xba,0xd6,0x3c,0xe7,0x9e,0xf7,0xdf,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xdf,0xff,0x9e,0xf7,0x9e,0xf7,0x5d,0xef,
0x3c,0xe7,0xfb,0xde,0xdb,0xde,0x9a,0xd6,0x79,0xce,0x38,0xc6,0x18,0xc6,0x18,0xc6,0x18,0xc6,0x38,0xc6,0x79,0xce,0xba,0xd6,
0x1c,0xe7,0x7d,0xef,0xbe,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xdf,0xff,0xbe,0xf7,0xbe,0xf7,0x9e,0xf7,0x7d,0xef,0x5d,0xef,0x3c,0xe7,0x1c,0xe7,0xfb,0xde,0xdb,0xde,0xdb,0xde,
0xdb,0xde,0xdb,0xde,0x1c,0xe7,0x3c,0xe7,0x7d,0xef,0xbe,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xdf,0xff,0xbe,0xf7,0xbe,0xf7,0x9e,0xf7,
0x7d,0xef,0x7d,0xef,0x5d,0xef,0x5d,0xef,0x5d,0xef,0x5d,0xef,0x7d,0xef,0x9e,0xf7,0xbe,0xf7,0xdf,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xdf,0xff,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xdf,0xff,0xdf,0xff,
0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
};

static const char blue_left_bmp[]={
0xff,0xdf,0xff,0xdf,0xff,0xdf,0x1f,0x03,0xff,0xdf,0xff,0xdf,0x1f,0x03,0x1f,0x03,0xff,0xdf,0x1f,0x03,0x1f,0x03,0x1f,0x03,
0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0xff,0xdf,0x1f,0x03,0x1f,0x03,0x1f,0x03,
0xff,0xdf,0xff,0xdf,0x1f,0x03,0x1f,0x03,0xff,0xdf,0xff,0xdf,0xff,0xdf,0x1f,0x03
};

static const char blue_right_bmp[]={
0x1f,0x03,0xff,0xdf,0xff,0xdf,0xff,0xdf,0x1f,0x03,0x1f,0x03,0xff,0xdf,0xff,0xdf,0x1f,0x03,0x1f,0x03,0x1f,0x03,0xff,0xdf,
0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0xff,0xdf,
0x1f,0x03,0x1f,0x03,0xff,0xdf,0xff,0xdf,0x1f,0x03,0xff,0xdf,0xff,0xdf,0xff,0xdf
};

static const char yellow_left_bmp[]={
0xfb,0xff,0xfb,0xff,0xfb,0xff,0x1f,0x03,0xfb,0xff,0xfb,0xff,0x1f,0x03,0x1f,0x03,0xfb,0xff,0x1f,0x03,0x1f,0x03,0x1f,0x03,
0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0xfb,0xff,0x1f,0x03,0x1f,0x03,0x1f,0x03,
0xfb,0xff,0xfb,0xff,0x1f,0x03,0x1f,0x03,0xfb,0xff,0xfb,0xff,0xfb,0xff,0x1f,0x03
};

static const char yellow_right_bmp[]={
0x1f,0x03,0xfb,0xff,0xfb,0xff,0xfb,0xff,0x1f,0x03,0x1f,0x03,0xfb,0xff,0xfb,0xff,0x1f,0x03,0x1f,0x03,0x1f,0x03,0xfb,0xff,
0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0x1f,0x03,0xfb,0xff,
0x1f,0x03,0x1f,0x03,0xfb,0xff,0xfb,0xff,0x1f,0x03,0xfb,0xff,0xfb,0xff,0xfb,0xff
};

int conversion(MfwMnu* m, MfwMnuItem* i);
static T_MFW_HND conversion_create(MfwHnd parent_window);
static int  conversion_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void conversionDisplay(convertdata* data);
static void conversion_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int conversion_kbd_cb (MfwEvt e, MfwKbd *kc);
void conversion_destroy (T_MFW_HND own_window);
double change(char* s);
int handle(char* s);



int conversion(MfwMnu* m, MfwMnuItem* i)
{
   T_MFW_HND	    	parent_win = mfwParent( mfw_header());
   T_MFW_HND       	win    = conversion_create(parent_win);
    
		
   if (win NEQ NULL)
      {
       	SEND_EVENT (win, CONVERT_INIT, 0, 0);
      } 
  
   return MFW_EVENT_CONSUMED;
}

static T_MFW_HND conversion_create(MfwHnd parent_window)
{
	convertdata     * data = (convertdata *)ALLOC_MEMORY (sizeof (convertdata));
	T_MFW_WIN  * win;
	
    
      TRACE_EVENT("conversion_create");
	if (data EQ NULL)
	{
		return NULL;
	}

	// Create window handler
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)conversion_win_cb);
	if (data->win EQ NULL)
	{
		
		return NULL;
	}
	// connect the dialog data to the MFW-window
	data->mmi_control.dialog = (T_DIALOG_FUNC)conversion_DialogCB;
	data->mmi_control.data   = data;
	win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent_win         = parent_window;

	winShow(data->win);
	return data->win;
}


static int  conversion_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    convertdata* data = (convertdata *)win->user;
            
    TRACE_EVENT ("conversion_win_cb()");


    if (data EQ 0)
     return 1;

    switch (event)
      {
       case E_WIN_VISIBLE:
           if (win->flags & E_WIN_VISIBLE)
            {
                  /*
                   * Clear Screen
                   */
              dspl_ClearAll();   
              conversionDisplay(data);             
           	}
              break;
         default:
              return 0;
    	}
    return 1;
}


void conversionDisplay(convertdata* data)
{  
  int old_color;
  char str[MAX_STRING_LENGTH];
  char handle_str[MAX_STRING_LENGTH];
  char string[14];
  char s[2];  
  char string1[14];
  char str1[MAX_STRING_LENGTH];  
  int i,j;
  BOOL unit2point=FALSE;
  game_Rectangle rectangle;
  game_Line line;
    
  TRACE_EVENT("conversionDisplay");
  //display title
 // if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
 // 	{
 // old_color=dspl_GetBkgColor();
 // dspl_SetBkgColor(0x0000ff);
 // dspl_Clear(0, 0, 120, 19);
 // PROMPT_COLOR(35, 0, 0, data->unit_id, 0xff0000);
 // dspl_BitBlt(90, 0, 28, 20, 0, (void *)Hash, 0);
 // dspl_SetBkgColor(old_color); 
  //display the second line content
  /*dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
      menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
      menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);*/
  DRAW_ICON(ICON_MENUUP);
  if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
	  dspl_colorTextOut(28,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtConversion),0xffffff);
  else
	  dspl_colorTextOut(0,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtConversion),0xffffff);  	  
  dspl_BitBlt(5, 29, 28, 20, 0, (void *)SoftLeft_key_bmp, 0);
  rectangle.x1=33;
  rectangle.y1=26;
  rectangle.x2=73;
  rectangle.y2=49;
  rectangle.color=0xf8e0ee;
  rectangle.fillcolor=0xf8e0ee;
  DrawRectagle(rectangle);
  rectangle.x1=33;
  rectangle.y1=26;
  rectangle.x2=33;
  rectangle.y2=49;
  rectangle.color=0x95668a;
  rectangle.fillcolor=0x95668a;
  DrawRectagle(rectangle);
  rectangle.x1=34;
  rectangle.y1=25;
  rectangle.x2=72;
  rectangle.y2=25;
  rectangle.color=0x95668a;
  rectangle.fillcolor=0x95668a;
  DrawRectagle(rectangle);
  rectangle.x1=34;
  rectangle.y1=50;
  rectangle.x2=72;
  rectangle.y2=50;
  rectangle.color=0xcdaac5;
  rectangle.fillcolor=0xcdaac5;
  DrawRectagle(rectangle);
  rectangle.x1=73;
  rectangle.y1=26;
  rectangle.x2=73;
  rectangle.y2=49;
  rectangle.color=0xcdaac5;
  rectangle.fillcolor=0xcdaac5;
  DrawRectagle(rectangle);
  if(Mmi_getCurrentLanguage()==ENGLISH_LANGUAGE)
  	{
  	set_font_type(UNI12X12_FONT);  	
    dspl_TextOut(34+(38-6*wstrBitlen(MmiRsrcGetText(data->unit_id)))/2,32,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->unit_id));
  	}
  else
  	{
  	dspl_TextOut(30+(38-6*wstrBitlen(MmiRsrcGetText(data->unit_id)))/2,30,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->unit_id));
  	}
#if(MAIN_LCD_SIZE==3)
  dspl_BitBlt(86,28, 28, 20, 0, (void *)Hash, 0);    
#endif
  memset((char*)str,0,sizeof(str)); 
  memset((char*)string,0,sizeof(string));
  memset((char*)string1,0,sizeof(string1));
 // strcpy((char*)s,":");
  switch(data->unit_type)
  	{
  	case LENGTH:  
  		 if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
  	        {
             switch(data->unit1.unit)
     	      {  	       
        	   	case METER:
                  strcpy((char*)string,"\x80\x7c\x73\x00\x00");//
                  break;
                case DECIMETER:
        	      strcpy((char*)string,"\x80\x52\x06\x7c\x73\x00\x00");//
                  break;
                case CENTIMETER:
        	      strcpy((char*)string,"\x80\x53\x98\x7c\x73\x00\x00");//
        	      break;
                case MILLIMETER:
        	      strcpy((char*)string,"\x80\x6b\xeb\x7c\x73\x00\x00");//
        	      break;
                case INCH:
        	      strcpy((char*)string,"\x80\x82\xf1\x5b\xf8\x00\x00");//Ӣ
        	      break;
                case FOOT:
        	      strcpy((char*)string,"\x80\x82\xf1\x5c\x3a\x00\x00");//Ӣ
        	      break;
                case MILE:
        	      strcpy((char*)string,"\x80\x82\xf1\x91\xcc\x00\x00");//Ӣ
        	      break;
                 case YARD:
        	      strcpy((char*)string,"\x80\x78\x01\x00\x00");//
        	      break;    	
             	}
             switch(data->unit2.unit)
             	{
             	case METER:
                  strcpy((char*)string1,"\x80\x7c\x73\x00\x00");//
                  break;
                case DECIMETER:
        	      strcpy((char*)string1,"\x80\x52\x06\x7c\x73\x00\x00");//
                  break;
                case CENTIMETER:
        	      strcpy((char*)string1,"\x80\x53\x98\x7c\x73\x00\x00");//
        	      break;
                case MILLIMETER:
        	      strcpy((char*)string1,"\x80\x6b\xeb\x7c\x73\x00\x00");//
        	      break;
                case INCH:
        	      strcpy((char*)string1,"\x80\x82\xf1\x5b\xf8\x00\x00");//Ӣ
        	      break;
                case FOOT:
        	      strcpy((char*)string1,"\x80\x82\xf1\x5c\x3a\x00\x00");//Ӣ
        	      break;
                case MILE:
        	      strcpy((char*)string1,"\x80\x82\xf1\x91\xcc\x00\x00");//Ӣ
        	      break;
                case YARD:
        	      strcpy((char*)string1,"\x80\x78\x01\x00\x00");//
        	      break;    	
             	}
  		 	}
  	      else
  	      	{
  	      	switch(data->unit1.unit)
  	      		{
            	case METER:
                  strcpy((char*)string,"m");
                  break;
                case DECIMETER:
        	      strcpy((char*)string,"dm");
                  break;
                case CENTIMETER:
        	      strcpy((char*)string,"cm");
        	      break;
                case MILLIMETER:
        	      strcpy((char*)string,"mm");
        	      break;
                case INCH:
        	      strcpy((char*)string,"in");
        	      break;
                case FOOT:
        	      strcpy((char*)string,"ft");
        	      break;
                case MILE:
        	      strcpy((char*)string,"mi");
        	      break;
                case YARD:
        	      strcpy((char*)string,"yd");
        	      break;    	
  	      		}
  	      	switch(data->unit2.unit)
  	      		{
  	      		case METER:
                  strcpy((char*)string1,"m");
                  break;
                case DECIMETER:
        	      strcpy((char*)string1,"dm");
                  break;
                case CENTIMETER:
        	      strcpy((char*)string1,"cm");
        	      break;
                case MILLIMETER:
        	      strcpy((char*)string1,"mm");
        	      break;
                case INCH:
        	      strcpy((char*)string1,"in");
        	      break;
                case FOOT:
        	      strcpy((char*)string1,"ft");
        	      break;
                case MILE:
        	      strcpy((char*)string1,"mi");
        	      break;
                case YARD:
        	      strcpy((char*)string1,"yd");
        	      break;
  	      		}
  	      	}        	
        break;
     case AREA:
     	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
     		{
        	switch(data->unit1.unit)
        		{     		
        		case SQ_METER:
        			strcpy((char*)string,"\x80\x5e\x73\x65\xb9\x7c\x73\x00\x00");//ƽ
        			break;
        		case HECTARE:
        			strcpy((char*)string,"\x80\x51\x6c\x98\x77\x00\x00");//
        			break;
        		case MU:
        			strcpy((char*)string,"\x80\x4e\xa9\x00\x00");//Ķ
        			break;
        		case SQ_FOOT:
        			strcpy((char*)string,"\x80\x5e\x73\x65\xb9\x82\xf1\x5c\x3a\x00\x00");//ƽӢ
        			break;
        		case SQ_YARD:
        			strcpy((char*)string,"\x80\x5e\x73\x65\xb9\x78\x01\x00\x00");//ƽ
        			break;
        		case ACRE:
        			strcpy((char*)string,"\x80\x82\xf1\x4e\xa9\x00\x00");//ӢĶ
        			break;
        		case SQ_INCH:
        			strcpy((char*)string,"\x80\x5e\x73\x65\xb9\x82\xf1\x5b\xf8\x00\x00");//ƽӢ
        			break;
     			}
        	switch(data->unit2.unit)
        		{
        		case SQ_METER:
        			strcpy((char*)string1,"\x80\x5e\x73\x65\xb9\x7c\x73\x00\x00");//ƽ
        			break;
        		case HECTARE:
        			strcpy((char*)string1,"\x80\x51\x6c\x98\x77\x00\x00");//
        			break;
        		case MU:
         			strcpy((char*)string1,"\x80\x4e\xa9\x00\x00");//Ķ
        			break;
        		case SQ_FOOT:
        			strcpy((char*)string1,"\x80\x5e\x73\x65\xb9\x82\xf1\x5c\x3a\x00\x00");//ƽӢ
        			break;
        		case SQ_YARD:
        			strcpy((char*)string1,"\x80\x5e\x73\x65\xb9\x78\x01\x00\x00");//ƽ
        			break;
        		case ACRE:
        			strcpy((char*)string1,"\x80\x82\xf1\x4e\xa9\x00\x00");//ӢĶ
        			break;
        		case SQ_INCH:
        			strcpy((char*)string1,"\x80\x5e\x73\x65\xb9\x82\xf1\x5b\xf8\x00\x00");//ƽӢ
         			break;
        		}
     		}
   		else
   			{
   			switch(data->unit1.unit)
        		{ 
        		case SQ_METER:
        			strcpy((char*)string,"m*2");
          			break;
        		case HECTARE:
        			strcpy((char*)string,"ha");
        			break;
        		case MU:
        			strcpy((char*)string,"mu");
        			break;
        		case SQ_FOOT:
        			strcpy((char*)string,"ft*2");
        			break;
        		case SQ_YARD:
        			strcpy((char*)string,"yd*2");
        			break;
        		case ACRE:
        			strcpy((char*)string,"a");
        			break;
        		case SQ_INCH:
        			strcpy((char*)string,"in*2");
        			break;
   				}
   			switch(data->unit2.unit)
   				{
   				case SQ_METER:
     	    		strcpy((char*)string1,"m*2");
        			break;
        		case HECTARE:
         			strcpy((char*)string1,"ha");
        			break;
        		case MU:
        			strcpy((char*)string1,"mu");
        			break;
        		case SQ_FOOT:
        			strcpy((char*)string1,"ft*2");
        			break;
        		case SQ_YARD:
        			strcpy((char*)string1,"yd*2");
        			break;
        		case ACRE:
        			strcpy((char*)string1,"a");
        			break;
        		case SQ_INCH:
        			strcpy((char*)string1,"in*2");
        			break;
   				}
   			}     	
     	break;
     case VOLUME:
     	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
     		{
        	switch(data->unit1.unit)
        		{     		
        		case ML:
        			strcpy((char*)string,"\x80\x6b\xeb\x53\x47\x00\x00");//
        			break;
        		case LITRE:
        			strcpy((char*)string,"\x80\x53\x47\x00\x00");//
        			break;
        		case GAL:
        			strcpy((char*)string,"\x80\x52\xa0\x4e\xd1\x00\x00");//
        			break;
        		case QT:
        			strcpy((char*)string,"\x80\x59\x38\x81\x31\x00\x00");//
        			break;
        		}
        	switch(data->unit2.unit)
         		{         	
        		case ML:
        			strcpy((char*)string1,"\x80\x6b\xeb\x53\x47\x00\x00");//
        			break;
        		case LITRE:
        			strcpy((char*)string1,"\x80\x53\x47\x00\x00");//
        			break;
         		case GAL:
        			strcpy((char*)string1,"\x80\x52\xa0\x4e\xd1\x00\x00");//
        			break;
        		case QT:
        			strcpy((char*)string1,"\x80\x59\x38\x81\x31\x00\x00");//
         			break;
     			}
     		}
   		else
   			{
   			switch(data->unit1.unit)
        		{ 
        		case ML:
        			strcpy((char*)string,"ml");
        			break;     		
        		case LITRE:
        			strcpy((char*)string,"l");
        			break;
        		case GAL:
        			strcpy((char*)string,"gal");
        			break;
        		case QT:
        			strcpy((char*)string,"qt");
        			break;
     			}
   			switch(data->unit2.unit)
        		{
        		case ML:
     		    	strcpy((char*)string1,"ml");
        			break;     		
        		case LITRE:
         			strcpy((char*)string1,"l");
        			break;
        		case GAL:
        			strcpy((char*)string1,"gal");
        			break;
        		case QT:
        			strcpy((char*)string1,"qt");
     	    		break;
   				}
     		}     	
     	break;
     case WEIGHT:     	
     	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
   			{
    			switch(data->unit1.unit)
            		{     	
            		case GRAM:
            			strcpy((char*)string,"\x80\x51\x4b\x00\x00");//
            			break;
            		case KILOGRAM:
        	    		strcpy((char*)string,"\x80\x53\x43\x51\x4b\x00\x00");//ǧ
        		    	break;
            		case TON:
            			strcpy((char*)string,"\x80\x54\x28\x00\x00");//
     	        		break;
            		case OUNCE:
            			strcpy((char*)string,"\x80\x76\xce\x53\xf8\x00\x00");//˾
            			break;
            		case POUND:
            			strcpy((char*)string,"\x80\x78\xc5\x00\x00");//
     	        		break;
    				}
            	switch(data->unit2.unit)
            		{     		
            		case GRAM:
            			strcpy((char*)string1,"\x80\x51\x4b\x00\x00");//
        	    		break;
        	    	case KILOGRAM:
            			strcpy((char*)string1,"\x80\x53\x43\x51\x4b\x00\x00");//ǧ
            			break;
        	    	case TON:
     	        		strcpy((char*)string1,"\x80\x54\x28\x00\x00");//
     		        	break;
            		case OUNCE:
            			strcpy((char*)string1,"\x80\x76\xce\x53\xf8\x00\x00");//˾
        	    		break;
            		case POUND:
            			strcpy((char*)string1,"\x80\x78\xc5\x00\x00");//
        	    		break;
        		}
     		}
   		else
   			{
   			    switch(data->unit1.unit)
            		{ 
            		case GRAM:
            			strcpy((char*)string,"g");
            			break;
            		case KILOGRAM:
            			strcpy((char*)string,"kg");
            			break;
            		case TON:
            			strcpy((char*)string,"t");
            			break;
            		case OUNCE:
            			strcpy((char*)string,"oz");
            			break;
            		case POUND:
            			strcpy((char*)string,"lb");
            			break;
   			    	}
        		switch(data->unit2.unit)
            		{  
            		case GRAM:
            			strcpy((char*)string1,"g");
        	    		break;
            		case KILOGRAM:
        	    		strcpy((char*)string1,"kg");
        		    	break;
            		case TON:
            			strcpy((char*)string1,"t");
            			break;
            		case OUNCE:
            			strcpy((char*)string1,"oz");
            			break;
            		case POUND:
            			strcpy((char*)string1,"lb");
            			break;
        			}
     		}
     	break;
  	}
  rectangle.x1=3;
  rectangle.y1=61;
  rectangle.x2=3;
  rectangle.y2=132;
  rectangle.color=0x5474a7;
  rectangle.fillcolor=0x5474a7;
  DrawRectagle(rectangle);
  rectangle.x1=4;
  rectangle.y1=60;
  rectangle.x2=117;
  rectangle.y2=60;
  rectangle.color=0x5474a7;
  rectangle.fillcolor=0x5474a7;
  DrawRectagle(rectangle);
  rectangle.x1=4;
  rectangle.y1=133;
  rectangle.x2=117;
  rectangle.y2=133;
  rectangle.color=0x5474a7;
  rectangle.fillcolor=0x5474a7;
  DrawRectagle(rectangle);
  rectangle.x1=118;
  rectangle.y1=61;
  rectangle.x2=118;
  rectangle.y2=132;
  rectangle.color=0x5474a7;
  rectangle.fillcolor=0x5474a7;
  DrawRectagle(rectangle);
  rectangle.x1=4;
  rectangle.y1=61;
  rectangle.x2=117;
  rectangle.y2=97;
  rectangle.color=0xdbffff;
  rectangle.fillcolor=0xdbffff;
  DrawRectagle(rectangle);
  rectangle.x1=4;
  rectangle.y1=98;
  rectangle.x2=117;
  rectangle.y2=132;
  rectangle.color=0xfffeb9;
  rectangle.fillcolor=0xfffeb9;
  DrawRectagle(rectangle);
  line.x1=4;
  line.y1=61;
  line.x2=4;
  line.y2=132;
  line.color=0xb9d9ea;
  DrawLine(line);
  line.x1=4;
  line.y1=61;
  line.x2=117;
  line.y2=61;
  line.color=0xb9d9ea;
  DrawLine(line);
  line.x1=4;
  line.y1=132;
  line.x2=117;
  line.y2=132;
  line.color=0xb9d9ea;
  DrawLine(line);
  line.x1=117;
  line.y1=61;
  line.x2=117;
  line.y2=132;
  line.color=0xb9d9ea;
  DrawLine(line);
  set_font_type(UNI12X12_FONT);
  dspl_TextOut(13, 67, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtInitValue));
  if(Mmi_getCurrentLanguage()==ENGLISH_LANGUAGE)
  	{
  	set_font_type(UNI12X12_FONT);
  	dspl_TextOut(13, 79, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtValue));
  	}  
  set_font_type(UNI12X12_FONT);
  dspl_TextOut(14, 67, DSPL_TXTATTR_TRANSPARENT, (char*)str);
  if(!data->position)
  	{
  	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
  		{
#if(MAIN_LCD_SIZE==3)
 	    dspl_BitBlt(7, 70, 5, 6, 0, (void *)uptriangle, 0);
#endif
  	    dspl_BitBlt(54,69, 4, 8, 0, (void *)blue_left_bmp,  0);
 	    dspl_BitBlt(112,69, 4, 8, 0, (void *)blue_right_bmp,  0);
    	rectangle.x1=59;
 	    rectangle.y1=64;
 	    rectangle.x2=110;
 	    rectangle.y2=79;
 	    rectangle.color=0x5ac7ff;
 	    rectangle.fillcolor=0x5ac7ff;
 	    DrawRectagle(rectangle);
 	    set_font_type(UNI12X12_FONT);
 	    dspl_colorTextOut(59+(51-6*wstrBitlen(string))/2, 67, DSPL_TXTATTR_TRANSPARENT, (char*)string, 0xffffff);
  		}
  	else
  		{
#if(MAIN_LCD_SIZE==3)
  		dspl_BitBlt(7, 70, 5, 6, 0, (void *)uptriangle, 0);
#endif
  	    dspl_BitBlt(70,69, 4, 8, 0, (void *)blue_left_bmp,  0);
 	    dspl_BitBlt(112,69, 4, 8, 0, (void *)blue_right_bmp,  0);
    	rectangle.x1=75;
 	    rectangle.y1=64;
 	    rectangle.x2=110;
 	    rectangle.y2=79;
 	    rectangle.color=0x5ac7ff;
 	    rectangle.fillcolor=0x5ac7ff;
 	    DrawRectagle(rectangle);
 	    set_font_type(UNI12X12_FONT);
 	    dspl_colorTextOut(75+(35-6*wstrBitlen(string))/2, 67, DSPL_TXTATTR_TRANSPARENT, (char*)string, 0xffffff);
  		}
  	}  
  else
  	{
  	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
  		{
	  	 set_font_type(UNI12X12_FONT);
	     dspl_TextOut(59+(51-6*wstrBitlen(string))/2, 67, DSPL_TXTATTR_TRANSPARENT, (char*)string);
  		}
  	else
  		{
  		 set_font_type(UNI12X12_FONT);
	     dspl_TextOut(75+(35-6*wstrBitlen(string))/2, 67, DSPL_TXTATTR_TRANSPARENT, (char*)string);
  		}
  	}
  //set_font_type(UNI12X12_FONT);
  //dspl_colorTextOut(60, 25, 0, (char*)s, 0x0000ff);  
  //display the third line content
  memset((char*)str,0,sizeof(str));
  memset((char*)handle_str,0,sizeof(handle_str));
  sprintf((char*)str,"%f",data->unit1.value);
  strncpy(handle_str,str,handle(str));
  if(pointflag)
  	{
  	strcat(handle_str,".");
  	}
  TRACE_EVENT(data->string);
 /* if((data->stringbuffer[0]=='.')&&(data->stringbuffer[1]=='0')&&(strlen(data->stringbuffer)==2)
  	||(data->stringbuffer[0]=='.')&&(data->stringbuffer[1]=='0')&&(data->stringbuffer[2]=='0')&&(strlen(data->stringbuffer)==3)
  	||(data->stringbuffer[0]=='.')&&(data->stringbuffer[1]=='0')&&(data->stringbuffer[2]=='0')&&(data->stringbuffer[3]=='0')&&(strlen(data->stringbuffer)==4))
  	{
  	   memset((char*)handle_str,0,sizeof(handle_str));
  	   strcpy(handle_str,"0");
       strcat(handle_str,data->stringbuffer);
  	}
  for(i=0;i<strlen(data->stringbuffer);i++)
  	{
  	  if(data->stringbuffer[i]=='.')
  	  	j=i;
  	}
  TRACE_EVENT(data->stringbuffer);
  if(((data->stringbuffer[j+1]=='0')&&(data->stringbuffer[j+2]=='\0')
  	||(data->stringbuffer[j+1]=='0')&&(data->stringbuffer[j+2]=='0')&&(data->stringbuffer[j+3]=='\0')
  	||(data->stringbuffer[j+1]=='0')&&(data->stringbuffer[j+2]=='0')&&(data->stringbuffer[j+3]=='0')&&(data->stringbuffer[j+4]=='\0')
  	||(data->stringbuffer[strlen(data->stringbuffer)]=='0'))
  	&&(j!=0))
  	{
  	   TRACE_EVENT("data->stringbuffer[strlen(data->stringbuffer)]=='0'");
  	   memset((char*)handle_str,0,sizeof(handle_str));  	  
       
  	}  */
  if(!strlen(data->stringbuffer))
  	{
        strcpy(data->stringbuffer,"0");
        strcpy(handle_str,data->stringbuffer);  
        set_font_type(UNI12X12_FONT);
        dspl_TextOut(115-6*strlen(handle_str),85 ,DSPL_TXTATTR_TRANSPARENT ,handle_str);
        memset(data->stringbuffer,0,sizeof(data->stringbuffer));
  	}
  else
  	{
  	    strcpy(handle_str,data->stringbuffer);  
        set_font_type(UNI12X12_FONT);
        dspl_TextOut(115-6*strlen(handle_str),85 ,DSPL_TXTATTR_TRANSPARENT ,handle_str);
  	}
  //display line
 // dspl_DrawLine(4, 60, 116,60);
  //display the fourth line content
  memset((char*)str,0,sizeof(str)); 
 // memset((char*)s,0,sizeof(s));
  strcpy((char*)str,MmiRsrcGetText(TxtResultValue));  
//  strcpy((char*)s,":");
  set_font_type(UNI12X12_FONT);
  dspl_TextOut(13,103,DSPL_TXTATTR_TRANSPARENT,(char*)str);
  if(Mmi_getCurrentLanguage()==ENGLISH_LANGUAGE)
  	{
  	set_font_type(UNI12X12_FONT);
  	dspl_TextOut(13, 115, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtValue));
  	}
  if(data->position)
  	{
  	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
  		{
#if(MAIN_LCD_SIZE==3)
	  	 dspl_BitBlt(7,106,5,6,0,(void *)downtriangle,0);  
#endif
  		 dspl_BitBlt(54,105, 4, 8, 0, (void *)yellow_left_bmp,  0);
	     dspl_BitBlt(112,105, 4, 8, 0, (void *)yellow_right_bmp,  0);
	     rectangle.x1=59;
	     rectangle.y1=100;
	     rectangle.x2=110;
	     rectangle.y2=115;
	     rectangle.color=0x5ac7ff;
	     rectangle.fillcolor=0x5ac7ff;
	     DrawRectagle(rectangle);
	     set_font_type(UNI12X12_FONT);
	     dspl_colorTextOut(59+(51-6*wstrBitlen(string1))/2, 103, DSPL_TXTATTR_TRANSPARENT, (char*)string1, 0xffffff);
  		}
  	else
  		{
#if(MAIN_LCD_SIZE==3)
  		 dspl_BitBlt(7,106,5,6,0,(void *)downtriangle,0);  
#endif
  		 dspl_BitBlt(70,105, 4, 8, 0, (void *)yellow_left_bmp,  0);
	     dspl_BitBlt(112,105, 4, 8, 0, (void *)yellow_right_bmp,  0);
	     rectangle.x1=75;
	     rectangle.y1=100;
	     rectangle.x2=110;
	     rectangle.y2=115;
	     rectangle.color=0x5ac7ff;
	     rectangle.fillcolor=0x5ac7ff;
	     DrawRectagle(rectangle);
	     set_font_type(UNI12X12_FONT);
	     dspl_colorTextOut(75+(35-6*wstrBitlen(string1))/2, 103, DSPL_TXTATTR_TRANSPARENT, (char*)string1, 0xffffff);
  		}
  	}
  else
  	{
  	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
  		{
	  	 set_font_type(UNI12X12_FONT);
	     dspl_TextOut(59+(51-6*wstrBitlen(string1))/2, 103, DSPL_TXTATTR_TRANSPARENT, (char*)string1);
  		}
  	else
  		{
  		 set_font_type(UNI12X12_FONT);
	     dspl_TextOut(75+(35-6*wstrBitlen(string1))/2, 103, DSPL_TXTATTR_TRANSPARENT, (char*)string1);
  		}
  	}  	
 // set_font_type(UNI12X12_FONT);
 // dspl_colorTextOut(23,77,0,(char*)str,0x0000ff);
 // set_font_type(UNI12X12_FONT);
 // dspl_colorTextOut(60,77,0,(char*)s,0x0000ff);
 // set_font_type(UNI12X12_FONT);
 // dspl_colorTextOut(67,77,0,(char*)string1,0x0000ff);
  //display the fifth line content
  memset((char*)str,0,sizeof(str));
  memset((char*)handle_str,0,sizeof(handle_str));  
  sprintf((char*)str,"%f",data->unit2.value);
  strncpy(handle_str,str,handle(str));
  for(i=0;i<strlen(handle_str);i++)
  	{
  	if(handle_str[i]=='.')
  		unit2point=TRUE;
  	}
  if(pointflag)
  	{
  	//if(!unit2point)
  	//strcat(handle_str,".");
  	}
 /* if((data->stringbuffer[0]=='.')&&(data->stringbuffer[1]=='0')&&(strlen(data->stringbuffer)==2)
  	||(data->stringbuffer[0]=='.')&&(data->stringbuffer[1]=='0')&&(data->stringbuffer[2]=='0')&&(strlen(data->stringbuffer)==3)
  	||(data->stringbuffer[0]=='.')&&(data->stringbuffer[1]=='0')&&(data->stringbuffer[2]=='0')&&(data->stringbuffer[3]=='0')&&(strlen(data->stringbuffer)==4))
  	{
  	   memset((char*)handle_str,0,sizeof(handle_str));
  	   strcpy(handle_str,"0");
       strcat(handle_str,data->stringbuffer);
  	}*/
  set_font_type(UNI12X12_FONT);//gdy
  dspl_TextOut(115-6*strlen(handle_str),118, DSPL_TXTATTR_TRANSPARENT, handle_str);  //gdy
  //	}
 // dspl_BitBlt(6, 113, 44, 19, 0, (void *)left_right, 0);
 // dspl_colorTextOut(51, 115, 0, MmiRsrcGetText(TxtUnitChange), 0xff0000); 
 // old_color=dspl_GetBkgColor();
 // dspl_SetBkgColor(0x70db93);
 // dspl_Clear(0, 142, 120, 160);
  if(strlen(data->stringbuffer))
    displaySoftKeys(TxtNext,TxtDelete);
  else
  	displaySoftKeys(TxtNext,TxtSoftBack);
 // dspl_SetBkgColor(old_color);
}

int handle(char* s)
{
  int i=0,j=0,k=0;
  BOOL point=false,flag=false;
 
  //remove the surplus 0s

  while(s[i])
  	{
  	//if(flag)
  	//	k++;
	if(s[i]=='.')
		{
		point=true;
		flag=true;
		}
	if(!point)
		j=i;
  	if((s[i]!='0')&&(s[i]!='.')&&point)
  		j=i;
  	i++;
  	}
  //if(k>5)
  //  return j+1+5-k;
  //else
  	return j+1;
}

static void conversion_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN       	*win_data   = ( (T_MFW_HDR *) win )->data;
	convertdata* data = (convertdata *) win_data->user;	
	T_DISPLAY_DATA display_info;	
	
	TRACE_EVENT("conversion_DialogCB");

	switch(event)
		{
		  case CONVERT_INIT:
		  	data->kbd=kbd_create(data->win,KEY_ALL,(T_MFW_CB)conversion_kbd_cb);
		  	data->index=0;
		  	data->unit_type=LENGTH;
		  	data->unit_id=TxtLength;
		  	data->position=FALSE;
		  	data->unit1.unit=METER,
		  	data->unit1.value=0;
		  	data->unit2.unit=METER,
		  	data->unit2.value=0;
		  	winShow(win);
		  	break;
		  case CONVERT_EXIT:
		  	conversion_destroy(win);
		  	break;
		}
}

static int conversion_kbd_cb (MfwEvt e, MfwKbd *kc)
{
   T_MFW_HND win = mfw_parent(mfw_header());
   T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
   T_DISPLAY_DATA    display_info;
   convertdata * data = (convertdata *)win_data->user;
   char string2[MAX_STRING_LENGTH];   
   double t;

   TRACE_EVENT("conversion_kbd_cb");
   switch(kc->code)
   	{
   	case KCD_0:
   	case KCD_1:
   	case KCD_2:
   	case KCD_3:
   	case KCD_4:
   	case KCD_5:
   	case KCD_6:
   	case KCD_7:
   	case KCD_8:
   	case KCD_9:
   	case KCD_HASH:   		
   		if(kc->code==KCD_HASH)
   			{
   			if(!afterpointflag)
   				{
   				  if(!strlen(data->stringbuffer))
   				  	{
   				  	data->stringbuffer[data->index]='0';
   				  	data->index++;
   				  	data->stringbuffer[data->index]='.';
   				  	data->index++;
   				  	}
   				  else
   				  	{
   			        data->stringbuffer[data->index]='.';
   		            data->index++;
   				  	}
   		          afterpointflag=TRUE;
   				}
   			}
   		else
   			{
   			if(afterpointcount1<3)
   				{
   				  if(kc->code==KCD_0)
   				  	{
   				  	  if(!strlen(data->stringbuffer))
   				  	  	break;
   				  	}
   		          data->stringbuffer[data->index]='0'+kc->code;
   		          data->index++; 
   		          if(afterpointflag)
   		          	{
   		              afterpointcount1++;
   		          	}
   				}
   			else{
   				 break;
   				}
   			}
   		memset(data->string,0,sizeof(data->string));
   		strcpy(data->string,data->stringbuffer);
   		TRACE_EVENT("data->stringbuffer=:");
   		TRACE_EVENT(data->string);
   		data->unit1.value=change((char*)data->stringbuffer);   		
   		switch(data->unit_type)
   			{
   			case LENGTH:
   		       switch(data->unit1.unit)
   			     {
   			     case METER:
   			     	t=data->unit1.value;
   			     	break;
   			     case DECIMETER:
   			     	t=data->unit1.value/10;
   			     	break;
   			     case CENTIMETER:
   			     	t=data->unit1.value/100;
   			     	break;
   			     case MILLIMETER:
   			     	t=data->unit1.value/1000;
   			     	break;
   			     case INCH:
   			     	t=data->unit1.value*2.45/100;
   			     	break;
   			     case FOOT:
   			     	t=data->unit1.value*30.48/100;
   			     	break;
   			     case MILE:
   			     	t=data->unit1.value*1609;
   			     	break;
   			     case YARD:
   			     	t=data->unit1.value*0.914;
   			     	break;
   			        			     
   			     }
   		       switch(data->unit2.unit)
   		       	{
   		       	 case METER:
   			     	data->unit2.value=t;
   			     	break;
   			     case DECIMETER:
   			     	data->unit2.value=t*10;
   			     	break;
   			     case CENTIMETER:
   			     	data->unit2.value=t*100;
   			     	break;
   			     case MILLIMETER:
   			     	data->unit1.value=t*1000;
   			     	break;
   			     case INCH:
   			     	data->unit2.value=t*100/2.45;
   			     	break;
   			     case FOOT:
   			     	data->unit2.value=t*100/30.48;
   			     	break;
   			     case MILE:
   			     	data->unit2.value=t/1609;
   			     	break;
   			     case YARD:
   			     	data->unit2.value=t/0.914;
   			     	break;
   			        			  
   		       	}
   		       break;
   		    case AREA:
   		    	switch(data->unit1.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	   	t=data->unit1.value;
   		    	     break;
   		    	  case HECTARE:
   		    	   	t=data->unit1.value*10000;
   		    	     break;
   		    	  case MU:
   		    	  	t=data->unit1.value/0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	t=data->unit1.value*929/10000;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	t=data->unit1.value*0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	t=data->unit1.value*4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	t=data->unit1.value*6.451/10000;
   		    	  	break;
   		    	  }
   		    	switch(data->unit2.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	    data->unit2.value=t;
   		    	     break;
   		    	  case HECTARE:
   		    	   	data->unit2.value=t/10000;
   		    	     break;
   		    	  case MU:
   		    	  	data->unit2.value=t*0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	data->unit2.value=t*10000/929;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	data->unit2.value=t/0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	data->unit2.value=t/4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	data->unit2.value=t*10000/6.451;
   		    	  	break;
   		    	  }
   		    	break;
   		    case VOLUME:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case LITRE:
   		    			t=data->unit1.value;
   		    			break;
   		    		case ML:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case GAL:
   		    			t=data->unit1.value*4.546;
   		    			break;
   		    		case QT:
   		    			t=data->unit1.value*1.136;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case LITRE:
   		    			data->unit2.value=t;
   		    			break;
   		    		case ML:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case GAL:
   		    			data->unit2.value=t/4.546;
   		    			break;
   		    		case QT:
   		    			data->unit2.value=t/1.136;
   		    			break;
   		    		}
   		    	break;
   		    case WEIGHT:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case GRAM:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case KILOGRAM:
   		    			t=data->unit1.value;
   		    			break;
   		    		case TON:
   		    			t=data->unit1.value*1000;
   		    			break;
   		    		case OUNCE:
   		    			t=data->unit1.value*31.03/1000;
   		    			break;
   		    		case POUND:
   		    			t=data->unit1.value*0.373;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case GRAM:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case KILOGRAM:
   		    			data->unit2.value=t;
   		    			break;
   		    		case TON:
   		    			data->unit2.value=t/1000;
   		    			break;
   		    		case OUNCE:
   		    			data->unit2.value=t*1000/31.03;
   		    			break;
   		    		case POUND:
   		    			data->unit2.value=t/0.373;
   		    			break;
   		    		}
   		    	break;   		    
   			}
   		memset(string2,0,sizeof(string2));
   		sprintf(string2,"%f",data->unit2.value);   		
   		if((data->unit1.value>MAX_CHANGE_VALUE)||(data->unit2.value>MAX_CHANGE_VALUE))
   			{
   			 dialog_info_init(&display_info);  			 
             display_info.TextId2     =TxtOverflow;             
             display_info.Time       = FOREVER;
             display_info.iconindex = REMIND_NORECORD;

             display_info.Callback     = (T_VOID_FUNC)NULL;
          /*
           * Call Info Screen
           */
             info_dialog (win, &display_info);
             data->unit1.value=0;
             data->unit2.value=0;
             memset(data->stringbuffer,0,sizeof(data->stringbuffer));
             afterpointflag=FALSE;
   		     afterpointcount1=0;
             data->index=0;
   			}
   		//RightKeyFlag=FALSE;
   		winShow(win);   			
   		break;
   	case KCD_LEFT:
   	case KCD_OK:
   		if(data->unit_type<UNITEND-1)
   			{
   		    data->unit_type++;
   		    data->unit_id++;
   			}
   		else
   			{
   			data->unit_type=LENGTH;
   			data->unit_id=TxtLength;
   			}
   		data->unit1.unit=0;
   		data->unit2.unit=0;
   		data->unit1.value=0;
   		data->unit2.value=0;
   		data->index=0;
   		afterpointflag=FALSE;
   		afterpointcount1=0;
   		memset(data->stringbuffer,0,sizeof(data->stringbuffer));
   		//RightKeyFlag=FALSE;
   		winShow(win);
   		break;
   	case KCD_MNUUP:    		
   	case KCD_MNUDOWN:
   		data->position=!data->position;
   		afterpointflag=FALSE;
   		afterpointcount1=0;
   		//RightKeyFlag=FALSE;
   		winShow(win);
   		break;
   	case KCD_MNULEFT:
   		switch(data->unit_type)
   			{
   			case LENGTH:   			
     		   if(!data->position)
   			    {
   			    if(data->unit1.unit>METER)
   			    	data->unit1.unit--;
   			    else data->unit1.unit=YARD;
     		   	}
     		   else
     		   	{
     		   	if(data->unit2.unit>METER)
   			    	data->unit2.unit--;
   			    else data->unit2.unit=YARD;
     		   	}
     		   break;
     		case AREA:
     			if(!data->position)
     				{
     				if(data->unit1.unit>SQ_METER)
     					data->unit1.unit--;
     				else data->unit1.unit=SQ_INCH;
     				}
     			else
     				{
     				if(data->unit2.unit>SQ_METER)
     					data->unit2.unit--;
     				else data->unit2.unit=SQ_INCH;
     				}
     			break;
     		case VOLUME:
     			if(!data->position)
     				{
     				if(data->unit1.unit>ML)
     					data->unit1.unit--;
     				else data->unit1.unit=QT;
     				}
     			else
     				{
     				if(data->unit2.unit>ML)
     					data->unit2.unit--;
     				else data->unit2.unit=QT;
     				}
     			break;
     		case WEIGHT:
     			if(!data->position)
     				{
     				if(data->unit1.unit>GRAM)
     					data->unit1.unit--;
     				else data->unit1.unit=POUND;
     				}
     			else
     				{
     				if(data->unit2.unit>GRAM)
     					data->unit2.unit--;
     				else data->unit2.unit=POUND;
     				}
     			break;
   		}
   		/*
   		data->unit1.value=change((char*)data->stringbuffer); 
   		switch(data->unit_type)
   			   {
   			   case LENGTH:
   		           switch(data->unit1.unit)
   			         {
   			          case METER:
   			     	     t=data->unit1.value;
   			     	     break;
   			          case DECIMETER:
   			     	     t=data->unit1.value/10;
   			     	     break;
   			          case CENTIMETER:
   			     	     t=data->unit1.value/100;
   			     	     break;
   			          case MILLIMETER:
   			     	     t=data->unit1.value/1000;
   			     	     break;
   			          case INCH:
   			     	     t=data->unit1.value*2.45/100;
   			     	     break;
   			          case FOOT:
   			     	     t=data->unit1.value*30.48/100;
   			     	     break;
   			          case MILE:
   			     	     t=data->unit1.value*1609;
   			     	     break;
   			          case YARD:
   			     	     t=data->unit1.value*0.914;
   			     	     break;
   			          case NAUTICAL_MILE:
   			     	     t=data->unit1.value*1852;
   			     	     break;   			     
   		           	}
   		            switch(data->unit2.unit)
   		       	     {
   		       	      case METER:
   			     	     data->unit2.value=t;
   			     	     break;
   			          case DECIMETER:
   			     	     data->unit2.value=t*10;
   			     	     break;
   			          case CENTIMETER:
   			     	     data->unit2.value=t*100;
   			     	     break;
   			          case MILLIMETER:
   			     	     data->unit1.value=t*1000;
   			     	     break;
   			          case INCH:
   			     	     data->unit2.value=t*100/2.45;
   			     	     break;
   			          case FOOT:
   			         	 data->unit2.value=t*100/30.48;
   			     	     break;
   			          case MILE:
   			     	     data->unit2.value=t/1609;
   			     	     break;
   			          case YARD:
   			     	     data->unit2.value=t/0.914;
   			     	     break;
   			          case NAUTICAL_MILE:
   			     	     data->unit2.value/1852;
   			     	     break;   			  
   		            	}
   		           break;
   		    case AREA:
   		    	switch(data->unit1.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	   	t=data->unit1.value;
   		    	     break;
   		    	  case HECTARE:
   		    	   	t=data->unit1.value*10000;
   		    	     break;
   		    	  case MU:
   		    	  	t=data->unit1.value/0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	t=data->unit1.value*929/10000;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	t=data->unit1.value*0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	t=data->unit1.value*4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	t=data->unit1.value*6.451/10000;
   		    	  	break;
   		    	  }
   		    	switch(data->unit2.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	    data->unit2.value=t;
   		    	     break;
   		    	  case HECTARE:
   		    	   	data->unit2.value=t/10000;
   		    	     break;
   		    	  case MU:
   		    	  	data->unit2.value=t/0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	data->unit2.value=t*10000/929;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	data->unit2.value=t/0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	data->unit2.value=t/4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	data->unit2.value=t*10000/6.451;
   		    	  	break;
   		    	  }
   		    	break;
   		    case VOLUME:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case LITRE:
   		    			t=data->unit1.value;
   		    			break;
   		    		case ML:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case GAL:
   		    			t=data->unit1.value*4.546;
   		    			break;
   		    		case QT:
   		    			t=data->unit1.value*1.136;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case LITRE:
   		    			data->unit2.value=t;
   		    			break;
   		    		case ML:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case GAL:
   		    			data->unit2.value=t/4.546;
   		    			break;
   		    		case QT:
   		    			data->unit2.value=t/1.136;
   		    			break;
   		    		}
   		    	break;
   		    case WEIGHT:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case GRAM:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case KILOGRAM:
   		    			t=data->unit1.value;
   		    			break;
   		    		case TON:
   		    			t=data->unit1.value*1000;
   		    			break;
   		    		case OUNCE:
   		    			t=data->unit1.value*31.03/1000;
   		    			break;
   		    		case POUND:
   		    			t=data->unit1.value*0.373;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case GRAM:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case KILOGRAM:
   		    			data->unit2.value=t;
   		    			break;
   		    		case TON:
   		    			data->unit2.value=t/1000;
   		    			break;
   		    		case OUNCE:
   		    			data->unit2.value=t*1000/31.03;
   		    			break;
   		    		case POUND:
   		    			data->unit2.value=t/0.373;
   		    			break;
   		    		}
   		    	break;   		    
   			  } */  
   	    memset(data->stringbuffer,0,sizeof(data->stringbuffer));
   		data->index=0;
   		data->unit1.value=0;
   		data->unit2.value=0;
   		data->index=0;
   		afterpointflag=FALSE;
   		afterpointcount1=0;
   		if((data->unit1.value>MAX_CHANGE_VALUE)||(data->unit2.value>MAX_CHANGE_VALUE))
   			{
   			dialog_info_init(&display_info);//gdy add
   			 display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
             display_info.LeftSoftKey  = '\0';
             display_info.RightSoftKey = '\0';
             display_info.TextString   = '\0';
             display_info.TextString2  = '\0';
             display_info.TextId2     =TxtOverflow;
             display_info.TextId      = '\0';
             display_info.Time       = ONE_SECS;

             display_info.Callback     = (T_VOID_FUNC)NULL;
          /*
           * Call Info Screen
           */
             info_dialog (win, &display_info);
             data->unit1.value=0;
             data->unit2.value=0;
             memset(data->stringbuffer,0,sizeof(data->stringbuffer));
             data->index=0;
   			}
   		//RightKeyFlag=FALSE;
   		winShow(win);
   		break;
   	case KCD_MNURIGHT:
   		switch(data->unit_type)
   			{
   			case LENGTH:   			
     		   if(!data->position)
   			    {
   			    if(data->unit1.unit<YARD)
   			    	data->unit1.unit++;
   			    else data->unit1.unit=METER;
     		   	}
     		   else
     		   	{
     		   	if(data->unit2.unit<YARD)
   			    	data->unit2.unit++;
   			    else data->unit2.unit=METER;
     		   	}
     		   break;
     		case AREA:
     			if(!data->position)
     				{
     				if(data->unit1.unit<SQ_INCH)
     					data->unit1.unit++;
     				else data->unit1.unit=SQ_METER;
     				}
     			else
     				{
     				if(data->unit2.unit<SQ_INCH)
     					data->unit2.unit++;
     				else data->unit2.unit=SQ_METER;
     				}
     			break;
     		case VOLUME:
     			if(!data->position)
     				{
     				if(data->unit1.unit<QT)
     					data->unit1.unit++;
     				else data->unit1.unit=ML;
     				}
     			else
     				{
     				if(data->unit2.unit<QT)
     					data->unit2.unit++;
     				else data->unit2.unit=ML;
     				}
     			break;
     		case WEIGHT:
     			if(!data->position)
     				{
     				if(data->unit1.unit<POUND)
     					data->unit1.unit++;
     				else data->unit1.unit=GRAM;
     				}
     			else
     				{
     				if(data->unit2.unit<POUND)
     					data->unit2.unit++;
     				else data->unit2.unit=GRAM;
     				}
     			break;
   		}
   		/*
   		data->unit1.value=change((char*)data->stringbuffer); 
   		switch(data->unit_type)
   			   {
   			   case LENGTH:
   		           switch(data->unit1.unit)
   			         {
   			          case METER:
   			     	     t=data->unit1.value;
   			     	     break;
   			          case DECIMETER:
   			     	     t=data->unit1.value/10;
   			     	     break;
   			          case CENTIMETER:
   			     	     t=data->unit1.value/100;
   			     	     break;
   			          case MILLIMETER:
   			     	     t=data->unit1.value/1000;
   			     	     break;
   			          case INCH:
   			     	     t=data->unit1.value*2.45/100;
   			     	     break;
   			          case FOOT:
   			     	     t=data->unit1.value*30.48/100;
   			     	     break;
   			          case MILE:
   			     	     t=data->unit1.value*1609;
   			     	     break;
   			          case YARD:
   			     	     t=data->unit1.value*0.914;
   			     	     break;
   			          case NAUTICAL_MILE:
   			     	     t=data->unit1.value*1852;
   			     	     break;   			     
   		           	}
   		            switch(data->unit2.unit)
   		       	     {
   		       	      case METER:
   			     	     data->unit2.value=t;
   			     	     break;
   			          case DECIMETER:
   			     	     data->unit2.value=t*10;
   			     	     break;
   			          case CENTIMETER:
   			     	     data->unit2.value=t*100;
   			     	     break;
   			          case MILLIMETER:
   			     	     data->unit1.value=t*1000;
   			     	     break;
   			          case INCH:
   			     	     data->unit2.value=t*100/2.45;
   			     	     break;
   			          case FOOT:
   			         	 data->unit2.value=t*100/30.48;
   			     	     break;
   			          case MILE:
   			     	     data->unit2.value=t/1609;
   			     	     break;
   			          case YARD:
   			     	     data->unit2.value=t/0.914;
   			     	     break;
   			          case NAUTICAL_MILE:
   			     	     data->unit2.value/1852;
   			     	     break;   			  
   		            	}
   		           break;
   		    case AREA:
   		    	switch(data->unit1.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	   	t=data->unit1.value;
   		    	     break;
   		    	  case HECTARE:
   		    	   	t=data->unit1.value*10000;
   		    	     break;
   		    	  case MU:
   		    	  	t=data->unit1.value/0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	t=data->unit1.value*929/10000;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	t=data->unit1.value*0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	t=data->unit1.value*4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	t=data->unit1.value*6.451/10000;
   		    	  	break;
   		    	  }
   		    	switch(data->unit2.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	    data->unit2.value=t;
   		    	     break;
   		    	  case HECTARE:
   		    	   	data->unit2.value=t/10000;
   		    	     break;
   		    	  case MU:
   		    	  	data->unit2.value=t/0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	data->unit2.value=t*10000/929;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	data->unit2.value=t/0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	data->unit2.value=t/4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	data->unit2.value=t*10000/6.451;
   		    	  	break;
   		    	  }
   		    	break;
   		    case VOLUME:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case LITRE:
   		    			t=data->unit1.value;
   		    			break;
   		    		case ML:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case GAL:
   		    			t=data->unit1.value*4.546;
   		    			break;
   		    		case QT:
   		    			t=data->unit1.value*1.136;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case LITRE:
   		    			data->unit2.value=t;
   		    			break;
   		    		case ML:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case GAL:
   		    			data->unit2.value=t/4.546;
   		    			break;
   		    		case QT:
   		    			data->unit2.value=t/1.136;
   		    			break;
   		    		}
   		    	break;
   		    case WEIGHT:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case GRAM:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case KILOGRAM:
   		    			t=data->unit1.value;
   		    			break;
   		    		case TON:
   		    			t=data->unit1.value*1000;
   		    			break;
   		    		case OUNCE:
   		    			t=data->unit1.value*31.03/1000;
   		    			break;
   		    		case POUND:
   		    			t=data->unit1.value*0.373;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case GRAM:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case KILOGRAM:
   		    			data->unit2.value=t;
   		    			break;
   		    		case TON:
   		    			data->unit2.value=t/1000;
   		    			break;
   		    		case OUNCE:
   		    			data->unit2.value=t*1000/31.03;
   		    			break;
   		    		case POUND:
   		    			data->unit2.value=t/0.373;
   		    			break;
   		    		}
   		    	break;   		    
   			  }*/		
   		memset(data->stringbuffer,0,sizeof(data->stringbuffer));
   		data->index=0;
   		data->unit1.value=0;
   		data->unit2.value=0;
   		data->index=0;
   		afterpointflag=FALSE;
   		afterpointcount1=0;
   		if((data->unit1.value>MAX_CHANGE_VALUE)||(data->unit2.value>MAX_CHANGE_VALUE))
   			{
   			dialog_info_init(&display_info);//gdy add
   			 display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
             display_info.LeftSoftKey  = '\0';
             display_info.RightSoftKey = '\0';
             display_info.TextString   = '\0';
             display_info.TextString2  = '\0';
             display_info.TextId2     =TxtOverflow;
             display_info.TextId      = '\0';
             display_info.Time       = ONE_SECS;

             display_info.Callback     = (T_VOID_FUNC)NULL;
          /*
           * Call Info Screen
           */


          
             info_dialog (win, &display_info);
             data->unit1.value=0;
             data->unit2.value=0;
             memset(data->stringbuffer,0,sizeof(data->stringbuffer));
             data->index=0;
   			}
   		//RightKeyFlag=FALSE;
   		winShow(win);
   		break;
   	case KCD_RIGHT:
   		if(strlen(data->stringbuffer))
   			{
   			pointflag=TRUE;
   			if(data->stringbuffer[strlen(data->stringbuffer)-1]=='.')
   				{
   				  afterpointcount1=0;
   				  afterpointflag=FALSE;
   				  pointflag=FALSE;
   				}
   			data->stringbuffer[strlen(data->stringbuffer)-1]='\0';
   			data->index--;
   			data->unit1.value=change((char*)data->stringbuffer);   		
   		    switch(data->unit_type)
   			   {
   			   case LENGTH:
   		           switch(data->unit1.unit)
   			         {
   			          case METER:
   			     	     t=data->unit1.value;
   			     	     break;
   			          case DECIMETER:
   			     	     t=data->unit1.value/10;
   			     	     break;
   			          case CENTIMETER:
   			     	     t=data->unit1.value/100;
   			     	     break;
   			          case MILLIMETER:
   			     	     t=data->unit1.value/1000;
   			     	     break;
   			          case INCH:
   			     	     t=data->unit1.value*2.45/100;
   			     	     break;
   			          case FOOT:
   			     	     t=data->unit1.value*30.48/100;
   			     	     break;
   			          case MILE:
   			     	     t=data->unit1.value*1609;
   			     	     break;
   			          case YARD:
   			     	     t=data->unit1.value*0.914;
   			     	     break;
   			            			     
   		           	}
   		            switch(data->unit2.unit)
   		       	     {
   		       	      case METER:
   			     	     data->unit2.value=t;
   			     	     break;
   			          case DECIMETER:
   			     	     data->unit2.value=t*10;
   			     	     break;
   			          case CENTIMETER:
   			     	     data->unit2.value=t*100;
   			     	     break;
   			          case MILLIMETER:
   			     	     data->unit1.value=t*1000;
   			     	     break;
   			          case INCH:
   			     	     data->unit2.value=t*100/2.45;
   			     	     break;
   			          case FOOT:
   			         	 data->unit2.value=t*100/30.48;
   			     	     break;
   			          case MILE:
   			     	     data->unit2.value=t/1609;
   			     	     break;
   			          case YARD:
   			     	     data->unit2.value=t/0.914;
   			     	     break;
   			           			  
   		            	}
   		           break;
   		    case AREA:
   		    	switch(data->unit1.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	   	t=data->unit1.value;
   		    	     break;
   		    	  case HECTARE:
   		    	   	t=data->unit1.value*10000;
   		    	     break;
   		    	  case MU:
   		    	  	t=data->unit1.value/0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	t=data->unit1.value*929/10000;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	t=data->unit1.value*0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	t=data->unit1.value*4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	t=data->unit1.value*6.451/10000;
   		    	  	break;
   		    	  }
   		    	switch(data->unit2.unit)
   		    	  {
   		    	  case SQ_METER:
   		    	    data->unit2.value=t;
   		    	     break;
   		    	  case HECTARE:
   		    	   	data->unit2.value=t/10000;
   		    	     break;
   		    	  case MU:
   		    	  	data->unit2.value=t*0.0015;
   		    	  	break;
   		    	  case SQ_FOOT:
   		    	  	data->unit2.value=t*10000/929;
   		    	  	break;   		    	
   		    	  case SQ_YARD:
   		    	  	data->unit2.value=t/0.836;
   		    	  	break;
   		    	  case ACRE:
   		    	  	data->unit2.value=t/4047;
   		    	  	break;
   		    	  case SQ_INCH:
   		    	  	data->unit2.value=t*10000/6.451;
   		    	  	break;
   		    	  }
   		    	break;
   		    case VOLUME:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case LITRE:
   		    			t=data->unit1.value;
   		    			break;
   		    		case ML:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case GAL:
   		    			t=data->unit1.value*4.546;
   		    			break;
   		    		case QT:
   		    			t=data->unit1.value*1.136;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case LITRE:
   		    			data->unit2.value=t;
   		    			break;
   		    		case ML:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case GAL:
   		    			data->unit2.value=t/4.546;
   		    			break;
   		    		case QT:
   		    			data->unit2.value=t/1.136;
   		    			break;
   		    		}
   		    	break;
   		    case WEIGHT:
   		    	switch(data->unit1.unit)
   		    		{
   		    		case GRAM:
   		    			t=data->unit1.value/1000;
   		    			break;
   		    		case KILOGRAM:
   		    			t=data->unit1.value;
   		    			break;
   		    		case TON:
   		    			t=data->unit1.value*1000;
   		    			break;
   		    		case OUNCE:
   		    			t=data->unit1.value*31.03/1000;
   		    			break;
   		    		case POUND:
   		    			t=data->unit1.value*0.373;
   		    			break;
   		    		}
   		    	switch(data->unit2.unit)
   		    		{
   		    		case GRAM:
   		    			data->unit2.value=t*1000;
   		    			break;
   		    		case KILOGRAM:
   		    			data->unit2.value=t;
   		    			break;
   		    		case TON:
   		    			data->unit2.value=t/1000;
   		    			break;
   		    		case OUNCE:
   		    			data->unit2.value=t*1000/31.03;
   		    			break;
   		    		case POUND:
   		    			data->unit2.value=t/0.373;
   		    			break;
   		    		}
   		    	break;   		    
   			  }
   		    afterpointcount1--;
   		    if(afterpointcount1<0)
   		    	afterpointcount1=0;
   		    //RightKeyFlag=TRUE;
   		     winShow(win);
   			}
   		else 
   			{
   			conversion_destroy(win);
   			afterpointflag=FALSE;
   		    afterpointcount1=0;
   			}
   		break;
   	case KCD_HUP:
   		conversion_destroy(win);
   		break;
   	default:
   		break;
   	}
   return MFW_EVENT_CONSUMED;
}

double change(char* s)
{
	int i=0,j=0;
	int integer=0;
	float place=0;
	int divisor=1;
	double point=0;
	double t;

    pointflag=FALSE;
	while(!(s[i]=='.')&&(i<strlen(s)))
		i++;	
	for(j=0;j<i;j++)
	{
		integer=10*integer+(int)s[j]-48;
	}
	for(j=i+1;j<strlen(s);j++)
	{
		place=place*10+(int)s[j]-48;		
		divisor=divisor*10;
	}
	if((s[i]=='.')&&(j==i+1))
		{
		pointflag=TRUE;
		}
	point=place/divisor;
	t=(double)integer+point;
	return t;
}


void conversion_destroy (T_MFW_HND own_window)
{
 T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
 convertdata* data   = (convertdata*)win->user;

  TRACE_EVENT ("conversion_destroy()");


 if (own_window)
  {
    /*
     * Delete WIN Handler
     */
    
    
    win_delete (own_window);
    /*
     * Free Memory
    */
   FREE_MEMORY ((void *)data, sizeof (convertdata));
  }
}


