/********************************************************************************  
					CONDAT (UK)

/********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Timer
 $File:		    MmiUnitConversion.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the start code for the MMI
                        
********************************************************************************
 $History: MmiStart.h

	25/10/00			Original Condat(UK) BMI version.
	06/09/02            gdy add
	   
 $End

*******************************************************************************/
#ifndef _MMICONVERSION_H
#define _MMICONVERSION_H 1


typedef struct
{
  int unit;
  double value;
}unitdata;

typedef struct
{
  T_MMI_CONTROL   mmi_control;
  T_MFW_HND       parent_win;
  T_MFW_HND          win;
  T_MFW_HND       info_tim;
  T_MFW_HND       kbd;  
  int unit_type;
  int unit_id;
  char stringbuffer[20];
  char string[20];
  int index;
  unitdata unit1;
  unitdata unit2;
  BOOL position;
}convertdata;

typedef enum
{
  CONVERT_INIT,
  CONVERT_EXIT
}CONVERT_EVENT;

typedef enum
{
  LENGTH=0,
  AREA,
  VOLUME,
  WEIGHT,
  UNITEND
}UNIT_LIST;

typedef enum
{
  METER=0,
  DECIMETER,
  CENTIMETER,
  MILLIMETER,
  INCH,
  FOOT,
  MILE,
  YARD,
 //NAUTICAL_MILE,
  LENGTHEND
}LENGTH_LIST;

typedef enum
{
  SQ_METER=0,
  HECTARE,
  MU,
  SQ_FOOT,
  SQ_YARD,
  ACRE,
  SQ_INCH,
  AREAEND
}AREA_LIST;

typedef enum
{
  ML=0,
  LITRE,
  GAL,
  QT,
  VOLUMEEND
}VOLUME_LIST;

typedef enum
{
  GRAM=0,
  KILOGRAM,
  TON,
  OUNCE,
  POUND,
  WEIGHTEND
}WEIGHT_LIST;

int conversion(MfwMnu* m, MfwMnuItem* i);
#endif
