/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		autopower
 $File:		    Mmiautopower.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the main autopower functionality

  
********************************************************************************
 $History: MmiToolkit.c

    25/10/00			Original Condat(UK) BMI version.
    15/08/2002          gdy add
       
 $End

*******************************************************************************/
/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define CLEAR_BOTTOM_ZONE dspl_Clear( KEY_AREA );
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "MmiBookShared.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "Gamedisplay.h"
#include "Mmitoolkit_timer.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
//#include "MmiStopwatch.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
//#include "Mmitoolkit.h"
#include "Mmitimedate.h"
#include "Mmiautopower.h"
#include "Rtc_api.h"

#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
//#include "bmieastapi.h"

//wyj
#include "TdDisplay.h"

/******************************************************************************
                                                                              
                                                                                                             
*******************************************************************************/
typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         parent_win;
    T_MFW_HND         editor_handle;
    T_MFW_HND         win;
    T_MFW_HND         info_tim;
    T_MFW_HND         kbd;
    T_EDITOR_DATA     editor_data;
    int               id;                 
    int               positon;
    BOOL              power_switch;
    BOOL              AMANDPM;
    char              time[6];
    char              ontime[6];
    char              offtime[6];
    MfwEdtAttr        editAttr;
    UBYTE             index;
}autodata;

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         parent_win;
    T_MFW_HND         win;
    T_MFW_HND         info_tim;
    T_MFW_HND         kbd;
    int               tim_num;
}confirmdata;

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         parent_win;
    T_MFW_HND         win;  
    T_MFW_HND         kbd;
}auto_browse_data;


typedef enum
{
    OPENTIME=0,
    CLOSETIME
}INTPUTSTATUS;

typedef enum
{
    AUTOPOWERON=0,
    AUTOPOWEROFF,
    DEACTIVIATE,
    AUTODESTROY
}AUTOSTATUS;


int static              time_status = OPENTIME;
extern T_RTC_DATE_TIME  timedate;
static MfwHnd           confirmtim;

extern void goodbye_cb (void);
extern      showGoodBye(T_MFW_HND win);

extern                      autopower_flag;
extern T_MFW_HND            alarm_win;
extern T_call               call_data;
extern BOOL                 call_win_flag;
/* 2004/05/20 yhf remove */
//extern const unsigned char	left_key_mask[];
//extern const unsigned char	right_key_mask[];


/* Զػ */
static T_MFW_HND    auto_create(MfwHnd parent_window);
static void         auto_DialogCB(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          auto_kbd_cb (MfwEvt e, MfwKbd *kc);
void                auto_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
static int          auto_win_cb(T_MFW_EVENT event,T_MFW_WIN * win);
void                auto_destroy (T_MFW_HND own_window);

static void         reset_edt_attr_sett2(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                         U8 *controls, char *text,U16 size,MfwEdtAttr* attr,U8 dsplTitle);
/* ػش */
static T_MFW_HND    ConAutopower_create(MfwHnd parent_window);
static int          conAuto_win_cb(T_MFW_EVENT event,T_MFW_WIN * win);
static void         confirm_DialogCB(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          confirm_kbd_cb (MfwEvt e, MfwKbd *kc);
void                conAuto_destroy (T_MFW_HND own_window);
static T_MFW_CB     confirm_tim_cb(T_MFW_EVENT event, T_MFW_TIM *tc);
static void         confirm_cb();
extern T_MFW_CB     autopower_tim_cb(MfwEvt e, MfwTim *tc);

/* 鿴 */
static T_MFW_HND    auto_browse_create(MfwHnd parent_window);
static void         autoBrowse_DialogCB(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          autoBrowse_kbd_cb(MfwEvt e, MfwKbd *kc);
static void         autoBrowse_destroy(T_MFW_HND own_window);
void                autoBrowse_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);

/* 2003.10.16 wyj Զػļ */
static void checkAutoNumInput(autodata *data, U8 keynum);
static void checkAutoLeftInput(autodata *data);
static void checkAutoRightInput(autodata *data);

/* Զػ */
extern const TD_Rect    AU_input_rect;  
extern const TD_Attri   AU_input_attr1; 
extern const TD_Attri   AU_input_attr2;
extern const TD_Line    AU_index_l; 
extern const Color      AU_index_c; 
extern const TD_Rect    AU_SW_rect; 
extern const TD_Attri   AU_SW_attr;
extern const TD_Rect    AU_AP_rect; 
extern const TD_Attri   AU_AP_attr;


/* 鿴״̬˵ */
int autoBrowse(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win  = mfwParent( mfw_header());
    T_MFW_HND           win         = auto_browse_create(parent_win);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, 0, 0, 0);
    }

    return 1;
}

/* ԶػĲ˵Ӧ */
int autopoweron(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win  = mfwParent( mfw_header());
    T_MFW_HND           win         = auto_create(parent_win);

    TRACE_EVENT("test for autopower");
    //zgzTraceData("FFS_flashData.opentime:",FFS_flashData.opentime);
    //zgzTraceData("FFS_flashData.closetime:",FFS_flashData.closetime);
    //TraceInt(FFS_flashData.closetime); 

    TRACE_EVENT("autopoweropen");

    if( win NEQ NULL )
    {
        SEND_EVENT (win, AUTOPOWERON, 0, 0);
    }

    return 1;
}

/* Զػ˵Ӧ */
int autopoweroff(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win  = mfwParent( mfw_header());
    T_MFW_HND           win         = auto_create(parent_win);

    TRACE_EVENT("test for autopower");
    //zgzTraceData("FFS_flashData.opentime:",FFS_flashData.opentime);
    //zgzTraceData("FFS_flashData.closetime:",FFS_flashData.closetime);
    //TraceInt(FFS_flashData.closetime); 

    TRACE_EVENT("autopoweropen");

    if( win NEQ NULL )
    {
        SEND_EVENT (win, AUTOPOWEROFF, 0, 0);
    }

    return 1;
}

/* رղ˵Ӧ */
int autopowerclose(MfwMnu * m, MfwMnuItem * i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA  display_info;
    // T_MFW_HND       	win    = auto_create(parent_win);
    //  T_RTC_DATE_TIME  date_time;
    //  T_RV_RETURN return_path;  
    //  char string[5];

    FFS_flashData.poweron_switch    = 0;
    FFS_flashData.poweroff_switch   = 0;

    dialog_info_init(&display_info);

    display_info.TextId2    = TxtDeActivated;
    display_info.Time       = FOREVER;
    display_info.iconindex  = REMIND_COMPLETE;

    info_dialog(parent_win, &display_info); 
    // if (win NEQ NULL)
    //    {
    //       	SEND_EVENT (win, DEACTIVIATE, 0, 0);
    //    } 

    return 1;
}
/* 鿴״̬Ĵڴ */
static T_MFW_HND auto_browse_create(MfwHnd parent_window)
{
    auto_browse_data *data = (auto_browse_data*)ALLOC_MEMORY (sizeof (auto_browse_data));
    T_MFW_WIN        *win;

    TRACE_EVENT("timer_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, 0);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog    = (T_DIALOG_FUNC)autoBrowse_DialogCB;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *)data;
    data->parent_win            = parent_window;

    data->kbd = kbd_create(data->win,KEY_ALL,(T_MFW_CB)autoBrowse_kbd_cb);    


    return data->win;
}

/* 鿴״̬¼ */
static void autoBrowse_DialogCB(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ((T_MFW_HDR *)win)->data;
    auto_browse_data    *data       = (auto_browse_data*)win_data->user;
    T_DISPLAY_DATA      display_info;
    game_Line           line;
    char                string[8];

    dspl_ClearAll();
    /*  ʾ"ѹر" */
    if( (!FFS_flashData.poweron_switch)&&(!FFS_flashData.poweroff_switch) )
    {
        dialog_info_init(&display_info);
        display_info.RightSoftKey   = TxtSoftBack;
        display_info.TextId2        = TxtDeActivated;
        display_info.iconindex      = REMIND_NORECORD;
        display_info.Time           = FOREVER;
        display_info.Callback       = (T_VOID_FUNC)autoBrowse_dialog_cb;
        info_dialog(win, &display_info);
        return;
    }
    /* background display */
    /* 2004/05/20 yhf remove */
    //TD_drawBkg(BG_rect, BG_attr);

    /* 2004/05/26 sunsj modify */
    displayTitle( 0, (char *)MmiRsrcGetText(TxtBrowseAlarm), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
#if 0
    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                 menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                 menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

    /* 2004/05/20 yhf modify */
    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
        dspl_colorTextOut(28+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtBrowseAlarm),0xffffff);
    else
        dspl_colorTextOut(8+EX, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtBrowseAlarm),0xffffff);
#endif

    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
        dspl_colorTextOut(14+EX, 23, 0, MmiRsrcGetText(TxtPowerOnTime),0);
    else
        dspl_colorTextOut(6+EX, 23, 0, MmiRsrcGetText(TxtPowerOnTime),0);

    if( FFS_flashData.poweron_switch )
    {
        memset(string,0,8);
        sprintf(string,"%02d:%02d",FFS_flashData.opentime[0],FFS_flashData.opentime[1]);
        drawSolidRectangle(57+EX, 43, 106+EX, 62, 3,0xDBFFFF,0xDBFFFF);          
        dspl_colorTextOut(63+EX,45,DSPL_TXTATTR_TRANSPARENT,string,0);
    }
    else
    {
        drawSolidRectangle(59+EX, 43, 100+EX, 62, 3,0x5AC7FF,0x5AC7FF);
        dspl_colorTextOut(67+EX, 45,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtClose),0xffffff);
    }
    /***end yhf modify***/
    /*2004/05/20 yhf add*/
    line.x1=7+EX;
    line.y1=79;
    line.x2=113+EX;
    line.y2=79;
    line.color=0xB9D9EA;
    DrawLine(line);
    line.x1=6+EX;
    line.y1=80;
    line.x2=114+EX;
    line.y2=80;
    line.color=0x5474A7;
    DrawLine(line);
    line.x1=7+EX;
    line.y1=81;
    line.x2=113+EX;
    line.y2=81;
    line.color=0xB9D9EA;
    DrawLine(line); 
    /***end yhf add***/

    /* 2004/05/20 yhf modify */
    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
        dspl_colorTextOut(14+EX, 87, 0, MmiRsrcGetText(TxtPowerOffTime),0);
    else
        dspl_colorTextOut(6+EX, 87, 0, MmiRsrcGetText(TxtPowerOffTime),0);

    if( FFS_flashData.poweroff_switch )
    {
        memset(string,0,8);
        sprintf(string,"%02d:%02d",FFS_flashData.closetime[0],FFS_flashData.closetime[1]);
        drawSolidRectangle(57+EX, 106, 106+EX, 125, 3,0xDBFFFF,0xDBFFFF);         
        dspl_colorTextOut(63+EX,108,DSPL_TXTATTR_TRANSPARENT,string,0);
    }
    else
    {
        drawSolidRectangle(59+EX, 106, 100+EX, 125, 3,0x5AC7FF,0x5AC7FF);
        dspl_colorTextOut(67+EX,108,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtClose),0xffffff);
    }
    /***end yhf modify***/

    displaySoftKeys(0, TxtSoftBack);
}
/* 鿴״̬İ */
static int autoBrowse_kbd_cb(MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND        win        = mfw_parent(mfw_header());
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
    auto_browse_data *edt_data  = (auto_browse_data*)win_data->user;

    switch( kc->code )
    {
    case KCD_RIGHT:
    case KCD_HUP:
        autoBrowse_destroy(win);
        break;
    default:
        break;
    }
    return 1;
}
/* 鿴״̬Ĵٺ */
static void autoBrowse_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN           *win    = ((T_MFW_HDR *)own_window)->data;
    auto_browse_data    *data   = (auto_browse_data*)win->user;

    if( own_window )
    {
        /*
        * Delete WIN Handler
         */
        win_delete (own_window);
        /*
        * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (auto_browse_data));
    }
}

/* 鿴״̬ϢڵĻص */
void autoBrowse_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    autoBrowse_destroy(win);
}

/* ԶػĴڴ */
static T_MFW_HND auto_create(MfwHnd parent_window)
{
    autodata    *data   = (autodata*)ALLOC_MEMORY (sizeof (autodata));
    T_MFW_WIN   *win;

    TRACE_EVENT("timer_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)auto_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)auto_DialogCB;
    data->mmi_control.data= data;
    win= ((T_MFW_HDR *)data->win)->data;
    win->user= (void *)data;
    data->parent_win= parent_window;

    //reset_edt_attr_sett2(32,60,70,16,0,0,edtCurBar1,0,(char*)data->time,5,&data->editAttr,0);

    data->editor_handle = edt_create(data->win,&data->editAttr,0,0);
    data->kbd= kbd_create(data->win,KEY_ALL,(T_MFW_CB)auto_kbd_cb);    

    return data->win;
}

/* ԶػĴ¼ 
 * 2003.10.28 wyj ޸ 12/24Сʱ */
static void auto_DialogCB(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
    autodata    *data       = (autodata*)win_data->user;
    int hour;

    TRACE_EVENT("auto_DialogCB");

    switch( event )
    {
    case AUTOPOWERON:
        TraceInt(FFS_flashData.opentime[0]);
        TraceInt(FFS_flashData.opentime[1]);
        data->id            = AUTOPOWERON;
        data->index         = 0;
        data->positon       = 0;
        data->power_switch  = TRUE;
        time_status         = OPENTIME;
        memset(data->ontime,0,6);
        memset(data->time,0,6);
        hour = FFS_flashData.opentime[0];
        memset(data->time,0,6);
        /* 2003.10.28 wyj ޸ 12/24Сʱ */
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( hour > 11 )                   //PM
            {
                data->AMANDPM = 1;
                if( hour != 12 )
                    hour %= 12;
            }
            else                            //AM
            {
                data->AMANDPM = 0;
            }
        }
        sprintf(data->ontime,"%02d:%02d",hour,FFS_flashData.opentime[1]);        
        //sprintf(data->offtime,"%02d:%02d",FFS_flashData.closetime[0],FFS_flashData.closetime[1]);
        strcpy(data->time,data->ontime);
        winShow(data->win);
        break;
    case AUTOPOWEROFF:
        data->id=AUTOPOWEROFF;
        data->index=0;
        data->positon=0;
        data->power_switch=TRUE;
        time_status=CLOSETIME;
        //memset(data->ontime,0,6);
        memset(data->offtime,0,6); 
        memset(data->time,0,6);
        hour=FFS_flashData.closetime[0]; 
        /* 2003.10.28 wyj ޸ 12/24Сʱ */
        if( FFS_flashData.time_format==TWELVE_HOUR )
        {
            if( hour > 11 )                   //PM
            {
                data->AMANDPM = 1;
                if( hour != 12 )
                    hour %= 12;
            }
            else                            //AM
            {
                data->AMANDPM = 0;
            }
        }
        //sprintf(data->ontime,"%02d:%02d",FFS_flashData.opentime[0],FFS_flashData.opentime[1]);        
        sprintf(data->offtime,"%02d:%02d",hour,FFS_flashData.closetime[1]);
        strcpy(data->time,data->offtime);
        winShow(data->win);
        break;
    case DEACTIVIATE:
    case AUTODESTROY:
        auto_destroy(win);
        break;
    default:
        break;
    }
}

/* 2003.10.16 wyj ʱļ
 * 2003.10.28 wyj AM/PM  
 * Զػڵİ
 */
static int auto_kbd_cb (MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND       win         = mfw_parent(mfw_header());
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
    autodata        *edt_data   = (autodata*)win_data->user;//tida edt data
    char            hour[3];
    char            minute[3];
    int             temp_hour;
    int             temp_minute;
    game_Rectangle  rectangle;
    game_Line       line;
    T_DISPLAY_DATA  display_info;
    int flag = 1,t;

    TRACE_EVENT("auto_kbd_cb"); 
    switch( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        if( edt_data->positon )
            break;

        /* 2003.10.16 wyj ʱļ */
        checkAutoNumInput(edt_data, kc->code);

        winShow(win);
        break;

    case KCD_MNULEFT:
        if( !edt_data->positon )      //ʱ
        {
            /* 2003.10.16 wyj ʱļ */
            checkAutoLeftInput(edt_data);
        }
        else if( edt_data->positon==1 )   //ڿ/رտ
        {
            edt_data->power_switch=!edt_data->power_switch;
        }
        else                        //AM/PMÿ
        {
            if( FFS_flashData.time_format==TWELVE_HOUR )
            {
                edt_data->AMANDPM=!edt_data->AMANDPM;
            }
        }
        winShow(win);
        break;

    case KCD_MNURIGHT:
        if( !edt_data->positon )
        {
            /* 2003.10.16 wyj ʱļ */
            checkAutoRightInput(edt_data);
        }
        else if( edt_data->positon==1 )
        {
            edt_data->power_switch=!edt_data->power_switch;
        }
        else
        {
            if( FFS_flashData.time_format==TWELVE_HOUR )
            {
                edt_data->AMANDPM=!edt_data->AMANDPM;
            }
        }
        winShow(win);
        break;

    case KCD_MNUDOWN:               
        edt_data->index=0;
        if( FFS_flashData.time_format==TWELVE_HOUR )
        {
            if( edt_data->positon==2 )
                edt_data->positon=0;
            else
                edt_data->positon++;
        }
        else
        {
            if( edt_data->positon )
                edt_data->positon=0;
            else
                edt_data->positon=1;
        }
        winShow(win);
        break;

    case KCD_MNUUP:
        edt_data->index=0;
        if( FFS_flashData.time_format==TWELVE_HOUR )
        {
            if( edt_data->positon==0 )
                edt_data->positon=2;
            else
                edt_data->positon--;
        }
        else
        {
            if( edt_data->positon )
                edt_data->positon=0;
            else
                edt_data->positon=1;
        }
        winShow(win);
        break;

    case KCD_LEFT:                                 /* select and ok button */
    case KCD_OK:
        TRACE_EVENT("KCD_LEFT");            
        memset(hour,0,3);
        memset(minute,0,3);
        hour[0]=edt_data->time[0];
        hour[1]=edt_data->time[1];
        minute[0]=edt_data->time[3];
        minute[1]=edt_data->time[4];
        temp_hour=atoi(hour);
        temp_minute=atoi(minute);

        //2003.10.28 AM/PM wyj
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( edt_data->AMANDPM )           //
            {
                if( temp_hour<12 && temp_hour>0 )
                    temp_hour += 12;
            }
            sprintf(edt_data->time,"%02d:%02d",temp_hour,temp_minute);
        }
        TRACE_EVENT(edt_data->time);
        if( ((((int)edt_data->time[0]-48)*10+((int)edt_data->time[1]-48))>=24)||((((int)edt_data->time[3]-48)*10+((int)edt_data->time[4]-48))>59) )
        {
            //memset((char*)edt_data->time,0,sizeof(edt_data->time));
            edt_data->index=0;
            dialog_info_init(&display_info);
            display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = '\0';
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2      = TxtInputError;
            display_info.TextId       = '\0';
            display_info.Time         = FOREVER;

            display_info.Callback     = (T_VOID_FUNC)auto_dialog_cb;
            display_info.Identifier   = 0;
            display_info.iconindex    = REMIND_NORECORD;
            /*
             * Call Info Screen
             */
            info_dialog (edt_data->win, &display_info);
            SEND_EVENT(win, edt_data->id, 0, 0);
        }
        else
        {
            if( time_status==OPENTIME )
            {
                FFS_flashData.poweron_switch=edt_data->power_switch;
                FFS_flashData.opentime[0]=0;
                FFS_flashData.opentime[1]=0;
                /* if(((((int)edt_data->time[0]-48)*10+(int)edt_data->time[1]-48-currclock.hour)*60+
                     ((int)edt_data->time[3]-48)*10+(int)edt_data->time[4]-48-currclock.min>0)&&
                     ((((int)edt_data->time[0]-48)*10+(int)edt_data->time[1]-48-currclock.hour)*60+
                     ((int)edt_data->time[3]-48)*10+(int)edt_data->time[4]-48-currclock.min<4))
                     {
                      edt_data->index=0;
                      dialog_info_init(&display_info);
                      display_info.TextId2=TxtError;
                     }*/
                FFS_flashData.opentime[0]=((int)edt_data->time[0]-48)*10+(int)edt_data->time[1]-48;
                FFS_flashData.opentime[1]=((int)edt_data->time[3]-48)*10+(int)edt_data->time[4]-48;                     
            }
            else
            {
                FFS_flashData.poweroff_switch=edt_data->power_switch;
                FFS_flashData.closetime[0]=0;
                FFS_flashData.closetime[1]=0;
                FFS_flashData.closetime[0]=((int)edt_data->time[0]-48)*10+(int)edt_data->time[1]-48;
                FFS_flashData.closetime[1]=((int)edt_data->time[3]-48)*10+(int)edt_data->time[4]-48;
            }
            flash_write();
            autopower_flag=FALSE;
            set_latest_alarm();
            //TRACE_EVENT((char*)edt_data->offtime);
            dialog_info_init(&display_info);
            if( edt_data->power_switch )
            {
                display_info.TextId2     =TxtActivated;     
            }
            else
            {
                display_info.TextId2     =TxtDeActivated;
            }
            display_info.Time       = FOREVER;
            display_info.Callback   = (T_VOID_FUNC)NULL;//auto_dialog_cb;                               
            display_info.iconindex  = REMIND_COMPLETE;
            /*
             * Call Info Screen
             */
            info_dialog (win, &display_info);                
            auto_destroy(edt_data->win);                                    
        }
        break;

    case KCD_RIGHT:                               /* back to previous menu */   
    case KCD_HUP:
        SEND_EVENT(edt_data->win,AUTODESTROY,0,0);              
        break;
    default:
        break;      
    }   
    return MFW_EVENT_CONSUMED;
}

/* ԶػĴʾص */
static int auto_win_cb(T_MFW_EVENT event,T_MFW_WIN * win)
{
    autodata            *data = (autodata*)win->user;
    char                string[4];
    int                 old_color;
    game_Line           line;
    game_Rectangle      rectangle;
    TD_Line             l;

    TRACE_FUNCTION ("timer_edt_win_cb");

    if( event EQ MfwWinVisible )
    {
        U8 uMode = 0;
        int     color;

        uMode = dspl_Enable(0);

        dspl_ClearAll();

        /* background display */
        TD_drawBkg(BG_rect, BG_attr);

		displayTitle( 0, (char *)MmiRsrcGetText(TxtEnterTime), NULL, TITLE_MIDDLE, 0x000000, 0x000000);		
		/* 2004/05/25 sunsj modify */
        //displayTitle( 0, (char *)MmiRsrcGetText(TxtMemoryState), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
#if 0
        /* title display */
        dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                     menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                     menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

        //title޸Ϊʱ䡱
        /* 2004/05/20 yhf modify */
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
            dspl_colorTextOut(28+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0xffffff);
        else
            dspl_colorTextOut(20+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0xffffff);
#endif
        /* input rect display */
        if( data->positon == 0 )                  //focus on input rect
        {
            TD_drawSolidRectangle(AU_input_rect, AU_input_attr1);
            l       = AU_index_l;
#if(MAIN_LCD_SIZE==4)
            l.x1    = AU_index_l.x1 + data->index*8;
            l.x2    = AU_index_l.x2 + data->index*8;
#elif (MAIN_LCD_SIZE==3)
            l.x1    = AU_index_l.x1 + data->index*6;
            l.x2    = AU_index_l.x2 + data->index*6;
#endif
            
            TD_drawLine(l, AU_index_c);
        }
        else
        {
            TD_drawSolidRectangle(AU_input_rect, AU_input_attr2);
        }
#if(MAIN_LCD_SIZE==4)
        dspl_colorTextOut(40+EX, 57, DSPL_TXTATTR_TRANSPARENT, data->time, 0);
#elif (MAIN_LCD_SIZE==3)
        dspl_colorTextOut(36+EX, 18, DSPL_TXTATTR_TRANSPARENT, data->time, 0);
#endif
        /* switch on/off rect display */
        if( data->positon == 1 )              //focus on switch on/off rect
        {
#if(MAIN_LCD_SIZE==4)
        /* 2004/06 sunsj modify for picture manage */
			DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 33+EX, 86, 0, ICON_LOCATION);
            DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 84+EX, 86, 1, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
            /* 2004/06 sunsj modify for picture manage */
			DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 33+EX, 39, 0, ICON_LOCATION|ICON_MASK);
            DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 65+EX, 39, 1, ICON_LOCATION|ICON_MASK);
#endif
            
            /*dspl_BitBlt(65+EX, 39, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);
            dspl_BitBlt(65+EX, 39, 4, 8, 0, (void *)right_key_mask, DSPL_BMPAND);
            dspl_BitBlt(65+EX, 39, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);*/

            TD_drawSolidRectangle(AU_SW_rect, AU_SW_attr);
            color = 0xffffff;
        }
        else
        {
            color = 0x0;
        }
        if( data->power_switch )              //
        {
#if(MAIN_LCD_SIZE==4)
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                dspl_colorTextOut(44+EX,83,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtOpen),color);
            else
                dspl_colorTextOut(52+EX,83,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtOpen),color);
#elif (MAIN_LCD_SIZE==3)
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                dspl_colorTextOut(38+EX,36,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtOpen),color);
            else
                dspl_colorTextOut(45+EX,36,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtOpen),color);
#endif
            
        }
        else                                //ر
        {
#if(MAIN_LCD_SIZE==4)
            if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                dspl_colorTextOut(44+EX,83,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtClose),color);
            else
                dspl_colorTextOut(48+EX,83,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtClose),color);
#elif (MAIN_LCD_SIZE==3)
			if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                dspl_colorTextOut(38+EX,36,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtClose),color);
            else
                dspl_colorTextOut(42+EX,36,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtClose),color);
#endif

        }

        /* AM/PM rect diaplay */
        if( data->positon == 2 )              //focus on AM/PM rect
        {
	    /* 2004/06 sunsj modify for picture manage */
	    DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 44+EX, 105, 0, ICON_LOCATION);
	    DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 73+EX, 105, 1, ICON_LOCATION);
            //dspl_BitBlt(44+EX, 105, 4, 8, 0, (void *)left_key, 0);
            //dspl_BitBlt(73+EX, 105, 4, 8, 0, (void *)right_key, 0);         
            /*dspl_BitBlt(35+EX, 53, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
            dspl_BitBlt(35+EX, 53, 4, 8, 0, (void *)left_key_mask, DSPL_BMPAND);
            dspl_BitBlt(35+EX, 53, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
            
            dspl_BitBlt(64+EX, 53, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);
            dspl_BitBlt(64+EX, 53, 4, 8, 0, (void *)right_key_mask, DSPL_BMPAND);
            dspl_BitBlt(64+EX, 53, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);*/

            TD_drawSolidRectangle(AU_AP_rect, AU_AP_attr);

            if( data->AMANDPM )
                dspl_colorTextOut(52+EX,102,DSPL_TXTATTR_TRANSPARENT,"PM",0xffffff);
            else
                dspl_colorTextOut(52+EX,102,DSPL_TXTATTR_TRANSPARENT,"AM",0xffffff);
        }
        else
        {
            if( FFS_flashData.time_format==TWELVE_HOUR )
            {
                if( data->AMANDPM )
                    dspl_colorTextOut(52+EX,102,DSPL_TXTATTR_TRANSPARENT,"PM",0);
                else
                    dspl_colorTextOut(52+EX,102,DSPL_TXTATTR_TRANSPARENT,"AM",0);           
            }
        }
        /***end yhf modify***/

        displaySoftKeys(TxtSoftOK,TxtSoftBack);//confirm

        dspl_Enable(uMode);

        return 1;
    }
    return 0;
}


void auto_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    TRACE_EVENT ("auto_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        /* no break; */
    case INFO_KCD_HUP:
        /* no break; */
    case INFO_KCD_RIGHT:
        /* no break; */
    case INFO_KCD_CLEAR:

        //go back to the previous dialog     

        break;
    }
    //auto_destroy(win);
}
/* ԶػĴٺ */
void auto_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN       *win    = ((T_MFW_HDR *)own_window)->data;
    autodata        *data   = (autodata*)win->user;

    TRACE_EVENT ("autodestroy()");

    if( own_window )
    {
        /*
         * Delete WIN Handler
         */
        win_delete (own_window);
        /*
         * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (autodata));
    }
}


static void reset_edt_attr_sett2(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                 U8 *controls, char *text,U16 size,MfwEdtAttr* attr,U8 dsplTitel)
{

    attr->win.px    = winPx;
    attr->win.py    = winPy;
    attr->win.sx    = winSx;
    attr->win.sy    = winSy;
    attr->fgColor   = fgColor;
    attr->font      = font;
    attr->mode      = mode;
    attr->controls  = controls;
    attr->text      = text;
    attr->size      = size;
    attr->titleMode = dsplTitel;
}
/* ˵״̬ */
USHORT autopower_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    char string[8];

    TRACE_EVENT("autopower_check");

    if( ((!FFS_flashData.poweron_switch) && (!FFS_flashData.poweroff_switch) && (((int)mi->str)==TxtClose))
        ||(
          (  ((FFS_flashData.poweron_switch==1)  && (((int)mi->str)==TxtAutoPowerOn))
             ||((FFS_flashData.poweroff_switch==1) && (((int)mi->str)==TxtAutoPowerOff)) ) 
          )
      )
        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;
}
/* ػڳʼ */
void ConfirmAutopower()
{

    T_MFW_HND         parent_win = mfwParent( mfw_header());
    T_MFW_HND         win    = ConAutopower_create(parent_win);

    if( win NEQ NULL )
        SEND_EVENT(win, 0, 0, 0);
}

/* ػڴ */
static T_MFW_HND ConAutopower_create(MfwHnd parent_window)
{
    confirmdata *data = (confirmdata*)ALLOC_MEMORY (sizeof (confirmdata));
    T_MFW_WIN   *win;

    TRACE_EVENT("timer_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)conAuto_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog    = (T_DIALOG_FUNC)confirm_DialogCB;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *)data;
    data->parent_win            = parent_window;
    data->info_tim              = tim_create (data->win, 1000, (T_MFW_CB)confirm_tim_cb);
    data->kbd                   = kbd_create(data->win,KEY_ALL,(T_MFW_CB)confirm_kbd_cb);    

    return data->win;
}

/* ػʾص */
static int conAuto_win_cb(T_MFW_EVENT event,T_MFW_WIN * win)
{
    confirmdata *data = (confirmdata*)win->user;   
    char        string[6];

    TRACE_FUNCTION ("timer_edt_win_cb");

    if( event EQ MfwWinVisible )
    {
        dspl_ClearAll();

        /* background display */
        /* 2004/05/20 yhf modify */
        //TD_drawBkg(BG_rect, BG_attr);

        /* title display */
        /*dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
            menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
            menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
        
        if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
            dspl_colorTextOut(28+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtAutoPowerOff),0x0);
        else
            dspl_colorTextOut(20,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtAutoPowerOff),0x0);
        
        if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
        {
            dspl_colorTextOut(12, 14, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtAutoOff), 0xcd7f32);
            dspl_colorTextOut(28, 30, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtAutoConfirm), 0xcd7f32);
        }
        else
        {
            dspl_colorTextOut(8, 14, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtAutoOff), 0xcd7f32);
            dspl_colorTextOut(28, 38, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtAutoConfirm), 0xcd7f32);
        }*/
        dspl_colorTextOut(12, 10, 0, MmiRsrcGetText(TxtAutoOff), 0xcd7f32);
        dspl_colorTextOut(28, 26, 0, MmiRsrcGetText(TxtAutoConfirm), 0xcd7f32);     

        if( data->tim_num==1||data->tim_num==0 )
            sprintf(string,"%d%s",data->tim_num,"second");
        else
            sprintf(string,"%d%s",data->tim_num,"seconds");
        dspl_colorTextOut(28, 50, 0, string, 0x0000ff);
        /***end yhf modify***/

        displaySoftKeys(TxtYes,TxtNo);//confirm	 		
        return 1;
    }
    return 0;
}
/* رմ¼ */
static void confirm_DialogCB(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    confirmdata* data = (confirmdata*)win_data->user;

    TRACE_EVENT("confirm_DialogCB");
    data->tim_num=10;
    tim_start(data->info_tim);
}
/* رմڰ */
static int confirm_kbd_cb (MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    MfwHnd times_switchoff;
    confirmdata* data = (confirmdata*)win_data->user;

    TRACE_EVENT("auto_kbd_cb");
    switch( kc->code )
    {
    case KCD_LEFT:
    case KCD_OK:
        //FfsWriteAllEvent();
        //conAuto_destroy(win);
        //AutoPowerOn();
        //showGoodBye ( idle_get_window () ); 
        conAuto_destroy(win);
        AutoPowerOn();
        FfsWriteAllEvent();//hxl add for save file completely 20021125
        FieldTestExit();

                /* 2004/07/09 sunsj add for forbidden hall off */
		HallOffForbid = TRUE;
        showGoodBye ( idle_get_window () ); //gb		
#if 0 /* Robert.Chen removed, 2004-05-05 */
        times_switchoff = timCreate(0,THREE_SECS,(MfwCb)goodbye_cb);
        timStart(times_switchoff);
#endif 
        // nm_deregistration();        /* start deregistration procedure   */
        // BaseWinExit();
        break;

    case KCD_RIGHT:
        conAuto_destroy(win);
        break;

    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}
/* رմٺ */
void conAuto_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *)own_window)->data;
    confirmdata     *data = (confirmdata*)win->user;

    TRACE_EVENT ("conAuto_destroy()");

    if( own_window )
    {
        /*
         * Delete WIN Handler
         */

        win_delete (own_window);
        /*
         * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (confirmdata));
    }
}

/* ػǰ10 */
static T_MFW_CB confirm_tim_cb(T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win         = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data    = ((T_MFW_HDR *)win)->data;
    T_MFW_HND       tim_win;
    MfwHnd          times_switchoff;
    confirmdata   * data        = (confirmdata *)win_data->user;

    if( !data->tim_num )
    {
        //FfsWriteAllEvent();
        //conAuto_destroy(win);
        //AutoPowerOn();
        //showGoodBye ( idle_get_window () ); 
        conAuto_destroy(win);
        AutoPowerOn();

	/* robert.chen add, 2004-08-10, for MMS integration */		
	#ifdef MMS_WAP_ENABLED
		{
			extern void mms_pushfile_exit();
			mms_pushfile_exit();
		}
	#endif

	#ifdef _MMS_ENABLE_
		MMS_Exit();
	#endif
        
        FfsWriteAllEvent();//hxl add for save file completely 20021125
        FieldTestExit();

                /* 2004/07/09 sunsj add for forbidden hall off */
		HallOffForbid = TRUE;
        showGoodBye ( idle_get_window () ); //gb

        //2004-04-26 Sunny remove
        //times_switchoff = timCreate(0,THREE_SECS,(MfwCb)goodbye_cb);
        //timStart(times_switchoff);
        //2004-04-26 Sunny remove end

        //nm_deregistration();        /* start deregistration procedure   */
        //BaseWinExit();
    }
    else
    {
        if( call_data.win_incoming||call_data.win_calling||call_win_flag||alarm_win )
        {
            conAuto_destroy(win);
            tim_win=timCreate(win, 1000, (T_MFW_CB)autopower_tim_cb);
            timStart(tim_win);
        }
        else
        {
            data->tim_num--;
            tim_start(data->info_tim);
            winShow(win);
        }
    }  
}

/**********************************************************************************
* Function Name         : checkAutoNumInput
* Function Description  : дԶػʱõּʹܴ֮
*
* Parameters		    : autodata *data        	     I/O
*						: U8 keynum					 I
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkAutoNumInput(autodata *data, U8 keynum)
{

    /* ӣ֤СʱûԽ */
    switch( data->index )
    {
    case 0:                                 // Сʱʮλ
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( keynum > 1 )
                return;
        }
        else
        {
            if( keynum > 2 )
                return;
        }

        //data->timeʽhh:mm
        data->time[data->index++] = '0' + keynum;
        break;

    case 1:                                 //Сʱλ
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( (data->time[data->index-1]=='1') && (keynum>2) )
                return;
        }
        else
        {
            if( (data->time[data->index-1]=='2') && (keynum>3) )
                return;
        }
        data->time[data->index++] = '0' + keynum;
        data->index++;
        break;

    case 3:                                 //ʮλ
        if( keynum > 5 )
            return;
        data->time[data->index++] = '0' + keynum;
        break;

    case 4:                                 //Ӹλ
        data->time[data->index++] = '0' + keynum;
        data->index = 0;
        break;                              

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : checkAutoLeftInput
* Function Description  : дԶػʱõĲ˵ʹܴ֮
*
* Parameters		    : autodata *data        			I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkAutoLeftInput(autodata *data)
{
    char *p;
    int  value;

    //ʱʽhh:mm
    switch( data->index )
    {
    case 1:                                 //Ҫ
    case 4:
        data->index--;
        break;

    case 0:                                 //Сʱ
        p = &data->time[0];
        value = (p[0]-48)*10 + (p[1]-48);

        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            //ʮСʱСʱ12
            if( value > 12 )
                return;
        }
        else
        {
            //ʮСʱСʱ23
            if( value > 23 )
                return;
        }
        data->index = 4;
        break;

    case 3:                                 //
        if( data->time[3] > '5' )
            return;

        data->index = 1;
        break;

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : checkAutoRightInput
* Function Description  : дԶػʱõĲ˵Ҽʹܴ֮
*
* Parameters		    : TR_data *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkAutoRightInput(autodata *data)
{
    char *p;
    int  value;

    //ʱʽhh:mm
    switch( data->index )
    {
    case 0:                                 //Ҫ
    case 3:
        data->index++;
        break;

    case 1:                                 //Сʱ
        p = &data->time[0];
        value = (p[0]-48)*10 + (p[1]-48);

        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            //ʮСʱСʱ12
            if( value > 12 )
                return;
        }
        else
        {
            //ʮСʱСʱ23
            if( value > 23 )
                return;
        }
        data->index = 3;
        break;

    case 4:                                 //
        if( data->time[3] > '5' )
            return;

        data->index = 0;
        break;

    default:
        break;
    }
}
