/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Calculator
 $File:		    MmiCalculator.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the main calculator functionality

  
********************************************************************************
 $History: MmiCalculatorMain.c

    25/10/00			Original Condat(UK) BMI version.	
    27/08/02            gdy add
       
 $End

*******************************************************************************/


/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
//extern const unsigned char calculatorbmp[];

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mmibookshared.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"

#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "Mmiicons.h"
#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
#include "Mmiicons.h"
#include "mmiusersymbolinput.h"
#include "GameDisplay.h"
//#include "Mmischedule.h"



#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "MmiCalculator.h"
//#include "mmiicndialogs.h"
#include "mmiicons.h"
/*******************************************************************************
                                                                              
                                Function Prototypes
                                                                              
*******************************************************************************/
#define HUNDRED_MILLION 100000000
#define DIV_LEN 6
#define MAX_OPTNUMBER 13

#define MAX_CALC_TOTAL 999999999
#define MIN_CALC_TOTAL -99999999
#define MAX_NUMBER   14

static T_MFW_HND calc_win = NULL;


static T_MFW_HND calculator_create(MfwHnd parent_window);
static int calculator_win_cb(T_MFW_EVENT event,T_MFW_WIN * win);
static void calculator_DialogCB(T_MFW_HND win, USHORT event,  SHORT identifier, void *parameter);
void calculator_destroy(MfwHnd own_window);
static int calculator_kbd_cb (MfwEvt e, MfwKbd *kc);
//void CalclatorSetEditor(T_MFW_HND win);
void calcDisplay(CalcData* data);
void calculate(char str1[MAXLEN],char str2[MAXLEN],char mark[2],char result_s[MAXLEN+MAXLEN]);
//char getoperator(int c);
static game_Line set_Line(int x1,int y1,int x2,int y2,int color);
void reset_calculator(CalcData* data);
int calculate1(char str1[MAXLEN],char str2[MAXLEN],char mark[2],char result_s[MAXLEN+MAXLEN]);
int stringchange(char *fi,char *ff,char *si,char *sf,char *mark);
void stringexchange(char *from,char *to);
static long pow10(int i);
void convert(char a[MAXLEN],char b[MAXLEN+MAXLEN]);


int calculator_new(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win       = mfwParent(mfw_header());
    T_MFW_HND          win=calculator_create(parent_win);

    if( win NEQ NULL )
        SEND_EVENT(win, CALCULATOR_INIT, 0, 0);

    return MFW_EVENT_CONSUMED;
}

static T_MFW_HND calculator_create(MfwHnd parent_window)
{
    CalcData     * data = (CalcData *)ALLOC_MEMORY (sizeof (CalcData ));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)calculator_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)calculator_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    //calculator_win = data->win;
    data->kbd =kbd_create(data->win,KEY_ALL,(T_MFW_CB)calculator_kbd_cb);
    //calc_win=data->win;

    winShow(data->win);

    return data->win;
}

static int calculator_win_cb(T_MFW_EVENT event,T_MFW_WIN * win)
{


    CalcData * data = (CalcData *)win->user;//tida edt data
    T_MFW_WIN * win_timer =((T_MFW_HDR *)data->parent_win)->data;
    int old_color,i;


    TRACE_EVENT("calculator_win_cb");

    if( event EQ MfwWinVisible )
    {
		DRAW_ICON(ICON_SPECIAL_BG);
        //drawIconByIcnAttr((MfwIcnAttr*)&icnSpBkgAttr,0);
        /******end**********/
        if( !strlen(data->result) )
        {
            strcpy(data->result,"0");
        }
        calcDisplay(data);
        // old_color=dspl_GetBkgColor();
        // dspl_SetBkgColor(0x00ffff);
        // dspl_Clear(0, 141, 120, 160);
        if( (data->result[0]=='0')&&(strlen((char*)data->result)==1) )
        {
            i=0;
        }
        else
        {
            i=strlen((char*)data->result);
        }
        /* 2004/05/18 yhf modify */
#if ( MAIN_LCD_SIZE==4 )
        if( strlen((char*)data->operate_number1)&&!((strlen(data->operate_number1)==1)&&(data->operate_number1[0]=='0'))&&!i )
            displaySoftKeys(TxtResult, TxtDelete);
        else
            displaySoftKeys(0, TxtSoftBack);
#endif
        //if(strlen((char*)data->operate_number1)&&!((strlen(data->operate_number1)==1)&&(data->operate_number1[0]=='0'))&&!i)
        //	displaySoftKeys(TxtResult, TxtDelete);
        //else
        //    displaySoftKeys(0, TxtSoftBack);
        // dspl_SetBkgColor(old_color);

        return 1;
    }
    return 0;  
}

static void calculator_DialogCB(T_MFW_HND win, USHORT event,  SHORT identifier, void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    CalcData* data = (CalcData *) win_data->user;

    switch( event )
    {
    case CALCULATOR_INIT:
        reset_calculator(data);
        data->continues=FALSE;
        data->resultflag=TRUE;
        memset((char*)data->result,0,sizeof(data->result));
        memset((char*)data->SpecialResult,0,sizeof(data->SpecialResult));
        // 	strcpy((char*)data->result,"0");

        winShow(win);
        break;
    case CALC_EXIT:
        calculator_destroy(win);
        break;
    }
}

void calculator_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    CalcData   * data = NULL; 

    if( own_window )
    {

        win_data = ((T_MFW_HDR *)own_window)->data;
        if( win_data != NULL ) //PATCH TB
            data = (CalcData *)win_data->user;

        if( data )
        {

            win_delete (data->win);
            // Free Memory
            FREE_MEMORY ((void *)data, sizeof (CalcData));

        }
        else
        {

        }
    }
}

static int calculator_kbd_cb (MfwEvt e, MfwKbd *kc)
{

    T_MFW_HND win = mfw_parent(mfw_header());
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_DISPLAY_DATA    display_info;
    CalcData* data = (CalcData *)win_data->user;//data
    char string[MAXLEN+MAXLEN];
    char tem_str[MAXLEN];
    char exponent[2];
    int i,j,k,l,EndOfPoint;
    BOOL t;

    switch( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:         
        if( !data->flag )
        {
            if( data->continues==TRUE )
            {
                data->continues=FALSE;
                memset((char*)data->result,0,sizeof(data->result));
            }
            TRACE_EVENT("data->flag==FALSE");
            if( strlen(data->operate_number1)<MAX_OPTNUMBER )
                if( !data->pointflag )
                {
                    if( data->index<MAX_NUMBER )
                    {
                        if( (data->operate_number1[0]=='0')&&data->index )
                            data->index--;
                        data->operate_number1[data->index]='0'+kc->code;
                        data->index++;
                    }
                }
                else
                {
                    if( data->afterpoint<5 )
                    {
                        data->operate_number1[data->index]='0'+kc->code;
                        data->afterpoint++;
                        data->index++;
                    }
                    else break;
                }
            //data->opera='\0';
        }
        else
        {
            TRACE_EVENT("data->flag==TRUE");
            if( strlen(data->operate_number2)<15 )
                if( !data->pointflag )
                {
                    if( data->index<MAX_NUMBER )
                    {
                        if( (data->operate_number2[0]=='0')&&data->index )
                            data->index--;
                        data->operate_number2[data->index]='0'+kc->code;
                        data->index++;
                    }
                }
                else
                {
                    if( data->afterpoint<5 )
                    {
                        data->operate_number2[data->index]='0'+kc->code;
                        data->afterpoint++;
                        data->index++;
                    }
                }
        }
        data->resultflag=FALSE;
        data->operaflag=FALSE;
        winShow(win);
        break;
    case KCD_STAR:
        if( data->flag==FALSE )
        {
            if( (!strlen(data->operate_number1))&&(data->index) )
            {
                data->operate_number1[data->index]='-';
                data->index++;

            }
            else
            {
                memset(tem_str,0,sizeof(tem_str));
                if( data->operate_number1[0]=='-' )
                {
                    strcpy( tem_str,data->operate_number1+1);
                    strcpy(data->operate_number1,tem_str);
                    data->index--;
                }
                else
                {
                    strcpy(tem_str,"-");
                    strcat(tem_str,data->operate_number1);
                    strcpy(data->operate_number1,tem_str);
                    data->index++;
                }
            }
        }
        else
        {
            if( (!strlen(data->operate_number2))&&(data->index) )
            {
                data->operate_number2[data->index]='-';
                data->index++;
            }
            else
            {
                memset(tem_str,0,sizeof(tem_str));
                if( data->operate_number2[0]=='-' )
                {
                    strcpy( tem_str,data->operate_number2+1);
                    strcpy(data->operate_number2,tem_str);
                    data->index--;
                }
                else
                {
                    strcpy(tem_str,"-");
                    strcat(tem_str,data->operate_number2);
                    strcpy(data->operate_number2,tem_str);
                    data->index++;
                }                 
            }
        }           
        winShow(win);
        break;
    case KCD_HASH:
        if( data->pointflag )
            break;
        if( !data->pointflag )
        {
            if( !data->flag )
            {
                if( (data->operate_number1[0]=='-')&&((strlen(data->operate_number1)==1)||(data->operate_number1[1]=='0')) )
                    break;
                if( data->continues==TRUE )
                {
                    data->continues=FALSE;
                    memset((char*)data->result,0,sizeof(data->result));
                }
                if( strlen(data->operate_number1) )
                {
                    if( !data->index )
                        data->index++;
                    data->operate_number1[data->index]='.';
                    data->index++;
                    data->pointflag=TRUE;
                }
            }
            else
            {
                if( (data->operate_number2[0]=='-')&&((strlen(data->operate_number2)==1)||(data->operate_number2[1]='0')) )
                    break;
                if( strlen(data->operate_number2) )
                {
                    if( !data->index )
                        data->index++;
                    data->operate_number2[data->index]='.';
                    data->index++;
                    data->pointflag=TRUE;
                }
            }

        }
        winShow(win);
        break;
    case KCD_MNUUP:
        if( strlen(data->opera) )
            break;
        TRACE_EVENT("KCD_MNUUP");
        if( (data->continues==TRUE)&&(!data->operaflag) )
        {
            if( strlen(data->SpecialResult) )
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->SpecialResult,MAXLEN);
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->SpecialResult);
            }
            else
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->result,MAXLEN); 
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->result); 
            }           
        }
        memset((char*)data->result,0,sizeof(data->result));
        memset((char*)data->opera,0,sizeof(data->opera));
        //data->opera='\0';
        TRACE_EVENT(data->operate_number1);
        if( (strlen(data->operate_number1)>1)||((strlen(data->operate_number1)==1)&&(data->operate_number1[0]!='0')) )
        {
            strcpy((char*)data->opera,"+");
            data->pointflag=FALSE;
            data->afterpoint=0;
            data->flag=TRUE;
            data->index=0;
            data->resultflag=FALSE;
            data->operaflag=TRUE;
            winShow(win);
        }
        break;
    case KCD_MNUDOWN:
        if( strlen(data->opera) )
            break;
        if( (data->continues==TRUE)&&(!data->operaflag) )
        {
            if( strlen(data->SpecialResult) )
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->SpecialResult,MAXLEN);
                }
                else
                {
                    TRACE_EVENT("KCD_MNUDOWN");
                    strcpy((char*)data->operate_number1,(char*)data->result); 
                    TRACE_EVENT(data->operate_number1);
                }
            }
            else
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->result,MAXLEN); 
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->result); 
            }             
        }
        memset((char*)data->result,0,sizeof(data->result));
        memset((char*)data->opera,0,sizeof(data->opera));
        //data->opera='\0';
        if( (strlen(data->operate_number1)>1)||((strlen(data->operate_number1)==1)&&(data->operate_number1[0]!='0')) )
        {
            strcpy((char*)data->opera,"-");
            data->pointflag=FALSE;
            data->afterpoint=0;
            data->flag=TRUE;
            data->index=0;
            data->resultflag=FALSE;
            data->operaflag=TRUE;
            winShow(win);
        }
        break;
    case KCD_MNURIGHT:
        if( strlen(data->opera) )
            break;
        if( (data->continues==TRUE)&&(!data->operaflag) )
        {
            if( strlen(data->SpecialResult) )
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->SpecialResult,MAXLEN);
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->result); 
            }
            else
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->result,MAXLEN); 
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->result); 
            }                         
        }
        memset((char*)data->result,0,sizeof(data->result));
        memset((char*)data->opera,0,sizeof(data->opera));
        //data->opera='\0';
        if( (strlen(data->operate_number1)>1)||((strlen(data->operate_number1)==1)&&(data->operate_number1[0]!='0')) )
        {
            strcpy((char*)data->opera,"/");
            data->pointflag=FALSE;
            data->afterpoint=0;
            data->flag=TRUE;
            data->index=0;
            data->resultflag=FALSE;
            data->operaflag=TRUE;
            winShow(win);
        }
        break;
    case KCD_MNULEFT:
        if( strlen(data->opera) )
            break;
        if( (data->continues==TRUE)&&(!data->operaflag) )
        {
            if( strlen(data->SpecialResult) )
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->SpecialResult,MAXLEN);
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->result); 
            }
            else
            {
                if( !data->sig )
                {
                    strcpy((char*)data->operate_number1,"-");
                    strncat((char*)data->operate_number1,(char*)data->result,MAXLEN); 
                }
                else
                    strcpy((char*)data->operate_number1,(char*)data->result); 
            }                         
        }
        memset((char*)data->result,0,sizeof(data->result));
        memset((char*)data->opera,0,sizeof(data->opera));
        //data->opera='\0';
        if( (strlen(data->operate_number1)>1)||((strlen(data->operate_number1)==1)&&(data->operate_number1[0]!='0')) )
        {
            strcpy((char*)data->opera,"*");
            data->pointflag=FALSE;
            data->afterpoint=0;
            data->flag=TRUE;
            data->index=0;
            data->resultflag=FALSE;
            data->operaflag=TRUE;
            winShow(win); 
        }
        break;
    case KCD_RIGHT:
        if( !data->flag )
        {
            if( (strlen(data->operate_number1)==1)&&(data->operate_number1[0]=='0') )
            {
                calculator_destroy(win);
                break;
            }
        }
        if( data->result[0]=='0' )
        {
            l=0;
        }
        else
        {
            l=strlen((char*)data->result);
        }
        if( strlen((char*)data->operate_number1)&&!l )
        {
            if( !data->flag )
            {
                if( strlen(data->SpecialResult) )
                    break;
                data->afterpoint--; 
                if( data->afterpoint<0 )
                    data->afterpoint=0;
                if( data->operate_number1[strlen((char*)data->operate_number1)-1]=='.' )
                {
                    data->pointflag=FALSE;                          
                }
                data->operate_number1[strlen((char*)data->operate_number1)-1]='\0';
                data->index=strlen((char*)data->operate_number1);               
            }
            else
            {
                if( strlen((char*)data->operate_number2)>1||!((strlen(data->operate_number1)==1)&&(data->operate_number1[0]=='0')) )
                {
                    if( data->pointflag )
                        data->afterpoint--;
                    if( data->operate_number2[strlen((char*)data->operate_number2)-1]=='.' )
                    {
                        data->pointflag=FALSE;                     
                    }
                    data->operate_number2[strlen((char*)data->operate_number2)-1]='\0';
                    data->index=strlen((char*)data->operate_number2);                        
                }
                else
                {
                    strcpy(data->operate_number2,"0");
                    data->index=0;
                    memset((char*)data->opera,0,sizeof(data->opera));
                    TraceInt(strlen(data->SpecialResult));
                    if( strlen(data->SpecialResult) )
                    {
                        winShow(win);
                        break;
                    }
                    data->flag=!data->flag;
                }                   
            }
            if( !strlen(data->operate_number1) )
            {
                strcpy(data->operate_number1,"0");
                data->index=0;
            }
            winShow(win);
        }
        else
        {
            calculator_destroy(win);
        }
        break;
    case KCD_OK:
    case KCD_LEFT:  
        if( !strlen(data->opera) )
            break;
        data->leftkey_indication=1;
        memset(data->SpecialResult,0,MAXLEN+MAXLEN);
        if( strlen(data->operate_number1)&&strlen(data->operate_number2)&&(!data->resultflag) )
        {
            if( (data->opera[0]=='/')&&(strlen(data->operate_number2)==1)&&(data->operate_number2[0]=='0') )
            {
                dialog_info_init(&display_info);
                display_info.TextId2     =TxtOverflow;//overflow                      
                display_info.Time       = FOREVER;
                display_info.iconindex = REMIND_NORECORD;
                display_info.Callback     = (T_VOID_FUNC)NULL;
                /*
                 * Call Info Screen
                 */
                info_dialog (win, &display_info);
                SEND_EVENT(win, CALCULATOR_INIT, 0, 0);
            }
            else
            {
                TRACE_EVENT("Special expression");
                memset(data->result,0,sizeof(data->result));
                memset(string,0,sizeof(string));
                data->sig=1;
                TRACE_EVENT(data->operate_number1);
                convert(data->operate_number1,string);
                TRACE_EVENT(string);
                /* i=0;
                 while((data->operate_number1[i]!='E')&&(i<strlen(data->operate_number1)))
                   i++;
                 TraceInt(strlen(data->operate_number1));
                 TraceInt(i);   	        		 
                 if(i<strlen(data->operate_number1))
                   {
                   if(data->operate_number1[i+1]=='+')
                       {
                       strncpy(string,data->operate_number1,1);
                       strncat(string,data->operate_number1+2,i-2);
                       exponent[0]=0;   	        		  	
                       strcpy(exponent,data->operate_number1+i+2);
                       TRACE_EVENT(exponent);
                       l=atoi(exponent);
                       TraceInt(l);
                       for(j=0;j<l-i;j++)
                       strcat(string,"0");
                       TRACE_EVENT(string);   */                           
                if( strlen(string)>MAXLEN )
                {
                    dialog_info_init(&display_info);
                    display_info.TextId2     =TxtOverflow;//overflow                      
                    display_info.Time       = FOREVER;
                    display_info.iconindex = REMIND_NORECORD;
                    display_info.Callback     = (T_VOID_FUNC)NULL;
                    /*
                     * Call Info Screen
                     */
                    info_dialog (win, &display_info);
                    SEND_EVENT(win, CALCULATOR_INIT, 0, 0);
                }
                else
                {
                    strcpy(data->operate_number1,string);
                }                         
                /*	else
                      {
                      memset(exponent,0,2);   	        		  	
                      strcpy(exponent,data->operate_number1+i+2);
                      TRACE_EVENT(exponent);
                      l=atoi(exponent);
                      TraceInt(l);
                      strcpy(string,"0.");
                      for(j=0;j<l-1;j++)
                          strcat(string,"0");
                      strncat(string,data->operate_number1,1);
                      strncat(string,data->operate_number1+2,i-2);
                      TRACE_EVENT(string);
                      strcpy(data->operate_number1,string);
                      }
                  }   */  
                memset(data->result,0,MAXLEN+MAXLEN);
                data->sig=calculate1(data->operate_number1,data->operate_number2,data->opera,data->result);
                TRACE_EVENT(data->result);  
                if( data->result[0]!='0' )
                {
                    i=0;
                    j=0;
                    EndOfPoint=0;
                    while( data->result[i]!='.' )
                        i++;
                    if( i<strlen(data->result) )
                    {
                        while( (data->result[i]!='\0')&&(!EndOfPoint) )
                        {
                            i++;
                            j++;
                            if( j>5 )
                            {
                                EndOfPoint=1;
                                data->result[i]=0;
                            }
                        }
                    }
                }
                i=0;
                memset(string,0,sizeof(string));
                while( data->result[i]=='0'&&data->result[i+1]!='.' )
                    i++;
                strcpy(string,data->result+i);
                strcpy(data->result,string);
                memset(string,0,sizeof(string));
                if( data->result[0]=='.' )
                {
                    strcpy(string,"0");
                    strcat(string,data->result);
                    strcpy(data->result,string);
                }
                i=0;
                j=0;
                k=strlen(data->result);
                while( (data->result[i]!='.')&&(i<strlen(data->result)) )
                    i++;
                if( i<strlen(data->result) )
                {
                    for( j=i;j<=strlen(data->result);j++ )
                    {
                        if( data->result[j]!='0'&&data->result[j]!=0 )
                            k=j;
                    }
                    data->result[k+1]=0;
                }
            }
            if( strlen(data->result)<=MAXLEN+3 )
            {
                data->continues=TRUE;
                data->resultflag=TRUE;
                winShow(win); 
                reset_calculator(data);
            }
            else
            {
                dialog_info_init(&display_info);                    
                display_info.TextId2     =TxtError;                  
                display_info.Time       = FOREVER;
                display_info.iconindex=REMIND_NORECORD;

                display_info.Callback     = (T_VOID_FUNC)NULL;
                /*
                 * Call Info Screen
                 */
                info_dialog (win, &display_info);
                SEND_EVENT(win, CALCULATOR_INIT, 0, 0);
            }
        }
        break;
    case KCD_HUP:
        calculator_destroy(win);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}



//extern const unsigned char icnMnuListBkg[];
void calcDisplay(CalcData* data)
{
#if (MAIN_LCD_SIZE==3)
   game_Line line;
   int old_color,i,j;   
   char string[MAXLEN],string1[MAXLEN+1],s[3];

   TRACE_EVENT("calcDisplay");
  
   memset(string,0,MAXLEN);
   memset(string1,0,MAXLEN+1);
   memset(s,0,3);

   //display the bitmap
   DRAW_ICON_SEL(ICON_CALCULATOR,2);
   DRAW_ICON_SEL(ICON_CALCULATOR,0);
   DRAW_ICON_SEL(ICON_CALCULATOR,1);
   
   //display the operate number   
   string[0]=0;
   i=0;
   while((data->operate_number1[i]!='.')&&(i<strlen(data->operate_number1)))
   	i++;
   if(i>14)
   	{
   	  if(data->operate_number1[0]=='-')
   	  	{
   	  	string[0]=data->operate_number1[0];
   	    string[1]=data->operate_number1[1];
   	    string[2]='.';
   	    strncat(string,data->operate_number1+2,6);
    	if(data->result[8]>'4')
   	       string[8]=data->operate_number1[7]+1;
   	    else
   	       string[8]=data->operate_number1[7];
   	  	}
   	  else
   	  	{
    	  string[0]=data->operate_number1[0];
    	  string[1]='.';
    	  strncat(string,data->operate_number1+1,6);
   	      if(data->result[7]>'4')
   	        string[7]=data->operate_number1[6]+1;
    	  else
    	    string[7]=data->operate_number1[6];
   	  	}
   	  strcat(string,"E+");
   	  if(data->operate_number1[0]=='-')
   	  	sprintf(s,"%02d",i-2);
   	  else
    	sprintf(s,"%02d",i-1);
   	  strcat(string,s); 
   	  set_font_type(UNI12X12_FONT);
      dspl_colorTextOut(26+94-strlen(string)*6, 16, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);//jhxu 288  modify 6 to 16
   	}
   else
   	{
   	i=0;
   	while(((data->operate_number1[i]<'1')||(data->operate_number1[i]>'9'))&&(i<strlen(data->operate_number1)))
   		i++;
   	if(i>14)
   		{
   		if(data->operate_number1[0]=='-')
   	    	strncpy(string,data->operate_number1,2);
   		else strncpy(string,data->operate_number1,1);
   		strcat(string,".");
   	    if(strlen(data->operate_number1)-i)
   	      strncat(string,data->operate_number1+i+1,6);
   	    else strcat(string,"0");   	    	
   	   // if(data->result[strlen(data->result)]>'4')
   	   //   string[6]=data->result[i+5]+1;
   	   // else
   	   //   string[6]=data->result[i+5];
   	    strcat(string,"E-");
   	    sprintf(s,"%02d",i);
   	    strcat(string,s);   	    
   		set_font_type(UNI12X12_FONT);   	  
        dspl_colorTextOut(26+94-strlen(string)*6, 16, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);//jhxu 288  modify 6 to 16		
   		}
    	else
   		{
   	     set_font_type(UNI12X12_FONT);
   	     dspl_colorTextOut(26+94-strlen(data->operate_number1)*6, 16, DSPL_TXTATTR_TRANSPARENT, (char *)data->operate_number1, 0x000000);////jhxu 288  modify 6 to 16
   		}   	  
   	}   
   set_font_type(UNI12X12_FONT);
   dspl_colorTextOut(4, 30, DSPL_TXTATTR_TRANSPARENT, (char*)data->opera, 0x000000);//jhxu 288  modify 20 to 30
   set_font_type(UNI12X12_FONT);
   dspl_colorTextOut(26+94-strlen(data->operate_number2)*6, 30, DSPL_TXTATTR_TRANSPARENT, (char *)data->operate_number2, 0x000000);//jhxu 288  modify 20 to 30

   //jhxu 288  modify 20 to 26
   DrawLine(set_Line(2, 42 ,99+26, 42,line.color=0x000000));////jhxu 288  modify 32 to 42


   TRACE_EVENT("data->result=:");
   TRACE_EVENT(data->result);
   memset(string,0,sizeof(string));
   i=0;
   while((data->result[i]!='.')&&(i<strlen(data->result)))
   	i++;
   if((i>0)&&(i==strlen(data->result)-1))
   	data->result[strlen(data->result)-1]=0;
   if(i>=8)
   	{
   	  string[0]=data->result[0];
   	  string[1]='.';
   	  strncat(string,data->result+1,6);
   	  if(data->result[7]>'4')
   	  	{
   	  	if(data->result[6]!='9')
   	      string[7]=data->result[6]+1;
   	  	else string[7]=data->result[6];
   	  	}
   	  else
   	    string[7]=data->result[6];
   	  strcat(string,"E+");
   	  sprintf(s,"%02d",i-1);
   	  strcat(string,s); 
   	  string[12]=0;
   	  TRACE_EVENT(string);
   	  memset(data->SpecialResult,0,MAXLEN+MAXLEN);  
   	  strcpy(data->SpecialResult,string);
   	  if(!data->sig)
   	     {
   	       strcpy(string1,"-");
   	       strcat(string1,string);   	       
   	       set_font_type(UNI12X12_FONT);   	  
           dspl_colorTextOut(26+94-13*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)string1, 0x000000);//jhxu 288  modify 34 to 44
   	   	 }
   	   else
   	  	  {   	  
   	        set_font_type(UNI12X12_FONT);   	  
            dspl_colorTextOut(26+94-12*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);//jhxu 288  modify 34 to 44        
   	      }      	   
   	}
   else
   	{
   	i=0;
   	while(((data->result[i]<'1')||(data->result[i]>'9'))&&(i<strlen(data->result)))
   		i++;
   	TraceInt(i);
   	if(i>14)
   		{
   		string[0]=data->result[i];
   	    string[1]='.';
   	    if(strlen(data->result)-i)
   	    	{
   	    	if((strlen(data->result)-i)<7)
   	         strncat(string,data->result+i+1,strlen(data->result)-i);
   	    	else strncat(string,data->result+i+1,6);
   	    	}
   	    else strcat(string,"0");   	    	
   	   // if(data->result[strlen(data->result)]>'4')
   	   //   string[6]=data->result[i+5]+1;
   	   // else
   	   //   string[6]=data->result[i+5];
   	    strcat(string,"E-");
   	    sprintf(s,"%02d",i);
   	    strcat(string,s); 
   	    memset(data->SpecialResult,0,MAXLEN+MAXLEN);   
   	    strcpy(data->SpecialResult,string);
   		if(!data->sig)
   		   {
   		    strcpy(string1,"-");
   		    strcat(string1,string);   		    
   	        set_font_type(UNI12X12_FONT);   	  
            dspl_colorTextOut(26+94-strlen(string1)*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)string1, 0x000000);//jhxu 288  modify 34 to 44
   		    }
   		else
   			{
   			set_font_type(UNI12X12_FONT);   	  
            dspl_colorTextOut(26+94-strlen(string)*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000); //jhxu 288  modify 34 to 44        
   			}   		
   		}
   	else
   		{
   		if((data->result[0]=='0')&&(strlen(data->result)<2))
   			{
   		   	  set_font_type(UNI12X12_FONT);
              dspl_colorTextOut(26+94-strlen(data->result)*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)data->result, 0x000000);//jhxu 288  modify 34 to 44
              return;
   			}
   		i=0;
   		j=0;
   		while(data->result[i]!='.')
   			i++;
   		if(i)
   			for(j=i;j<strlen(data->result);j++);
   		if(i+j>17)
   			data->result[i+j]=0;   		
    	if((!data->sig)&&strlen(data->result))
        	{
   	   	      strcpy(string1,"-");
    	      strcat(string1,data->result);
   	    	  set_font_type(UNI12X12_FONT);   	  
              dspl_colorTextOut(26+94-strlen(string1)*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)string1, 0x000000);//jhxu 288  modify 34 to 40
        	}
        else
        	{
              set_font_type(UNI12X12_FONT);
              dspl_colorTextOut(26+94-strlen(data->result)*6, 44, DSPL_TXTATTR_TRANSPARENT, (char *)data->result, 0x000000);//jhxu 288  modify 34 to 40
         	}   		
   		}
   	}
   if(data->leftkey_indication==1)
   	memset(data->opera,0,sizeof(data->opera));
  
#elif ( MAIN_LCD_SIZE==4 )
    extern GLOBAL int get_StringWidth(char *string);

    game_Line line;
    int old_color,i,j;   
    char s[3]= "0";
    char *txt ;
    char string[MAXLEN];
    memset(string,0 ,sizeof(string) );
    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
        dspl_colorTextOut(35, 0, DSPL_TXTATTR_TRANSPARENT,(char*)MmiRsrcGetText(TxtCalculator),0x000000);
    else
        dspl_colorTextOut(20, 0, DSPL_TXTATTR_TRANSPARENT,(char*)MmiRsrcGetText(TxtCalculator),0x000000);

    //display the bitmap
    /* 2004/06 sunsj modify for picture manage */
    for( i=0 ; i< GET_ICONATTR_NUM(ICON_CALCULATE_OFF); i++ )
    {
        DRAW_ICON_SEL(ICON_CALCULATE_OFF, i);
        /*
       pdspl_BitBlt(icnCalcOptOffAttr[i].area.px+1,icnCalcOptOffAttr[i].area.py+5, 
           icnCalcOptOffAttr[i].area.sx,icnCalcOptOffAttr[i].area.sy, 0,
           icnCalcOptOffAttr[i].icons,
           0);
            */
        //drawIconByIcnAttr((MfwIcnAttr *)&icnCalcOptOffAttr[i], 0);
    }
    if( data->opera[0] != 0x00 )
    {
        if( strcmp(data->opera, "+") == 0 )
        {
            DRAW_ICON_SEL(ICON_CALCULATE_ON, 0);
        }
        else if( strcmp(data->opera, "-") == 0 )
        {
            DRAW_ICON_SEL(ICON_CALCULATE_ON, 1);
        }
        else if( strcmp(data->opera, "*") == 0 )
        {
            DRAW_ICON_SEL(ICON_CALCULATE_ON, 2);
        }
        else if( strcmp(data->opera, "/") == 0 )
        {
            DRAW_ICON_SEL(ICON_CALCULATE_ON, 3);
        }
    }
    /*
    elseif 
        break;
    case '-':
        DRAW_ICON_SEL(ICON_CALCULATE_ON, 1);
        break;
    case '*':
        DRAW_ICON_SEL(ICON_CALCULATE_ON, 2);
        break;
    case '/':
        DRAW_ICON_SEL(ICON_CALCULATE_ON, 3);
        break;
    default:
        break;
    }
    */

    old_color = dspl_SetBkgColor(0x000000);
    dspl_fill_rectangle(20,29,108,70);
    dspl_SetBkgColor(0x2fa6ff);
    dspl_fill_rectangle(22,31,106,68);
    dspl_SetBkgColor(old_color);

    if( data->operate_number2[0] == 0 )
    {
        if( data->operate_number1[0] == 0 )
        {
            txt = (char*)s;
        }
        else
        {
            txt = (char*)data->operate_number1;
        }
    }
    else if( data->resultflag ==0 )
    {
        txt = (char*)data->operate_number2;
    }
    else
    {
        txt = (char*)data->result;
        if( !data->sig )
        {
            string[0] = '-';
        }
        if( strlen(data->result) > MAX_OPTNUMBER )
        {
            int k = 1;
            i = j = -1;
            while( *txt != 0 )
            {
                if( i == -1 )
                {
                    if( *txt != '0' && *txt != '.' )
                        i = (int)txt - (int)data->result;
                }
                if( j == -1 )
                {
                    if( *txt == '.' )
                        j = (int)txt - (int)(char *)data->result;
                }
                txt ++;
            }
            if( j == -1 )j = (int)txt - (int)(char *)data->result;
            txt = (char*)data->result+i;
            data->SpecialResult[0] = *txt++;
            data->SpecialResult[1] = '.';
            while( k <=2 && *txt !=0 )
            {
                if( *txt <= '9' && *txt>= '0' )
                    data->SpecialResult[1 + k++] = *txt;
                txt++;
            }
            while( k<=2 )
                data->SpecialResult[1 + k++] = '0';
            if( i < j )
            {
                strcat(data->SpecialResult,"E+");
                i = j - i -1;
            }
            else
            {
                strcat(data->SpecialResult,"E-"); 
                i = i - j;
            }
            sprintf(s,"%02d",i);
            strcat(data->SpecialResult,s);
            strcat(string,data->SpecialResult);
        }
        else
        {
            strcat(string,data->result);
        }
        txt = (char*)string;


    }
    set_font_type(UNI12X12_FONT);
    i = get_StringWidth(txt);
    dspl_colorTextOut(105 - i, 52 , DSPL_TXTATTR_TRANSPARENT, txt,0x000000); 

    /* 2004/05/18 yhf modify */
#elif ( MAIN_LCD_SIZE==2 )
    game_Line line;
    int old_color,i,j; 
    char string[MAXLEN],string1[MAXLEN+1],s[3];
    TRACE_EVENT("calcDisplay");

    memset(string,0,MAXLEN);
    memset(string1,0,MAXLEN+1);
    memset(s,0,3);


    dspl_BitBlt(0, 0, 102, 65, 0, (void *)icnMnuListBkg, 0);
    dspl_BitBlt(0, 49, 102, 31, 0, (void *)calculatorbmp, 0);


    //draw a rectangle ,it's left top coordinate is (5,63) right bottom coordinate is (115,130)
    //  DrawLine(set_Line(5, 65, 115, 65, line.color=0x0000ff));
    //  DrawLine(set_Line(5, 65, 5, 132, line.color=0x0000ff));
    //  DrawLine(set_Line(5, 132, 115, 132, line.color=0x0000ff));
    //  DrawLine(set_Line(115, 132, 115, 65, line.color=0x0000ff));
    //display the operate number   
    string[0]=0;
    i=0;
    while( (data->operate_number1[i]!='.')&&(i<strlen(data->operate_number1)) )
        i++;
    if( i>14 )
    {
        if( data->operate_number1[0]=='-' )
        {
            string[0]=data->operate_number1[0];
            string[1]=data->operate_number1[1];
            string[2]='.';
            strncat(string,data->operate_number1+2,6);
            if( data->result[8]>'4' )
                string[8]=data->operate_number1[7]+1;
            else
                string[8]=data->operate_number1[7];
        }
        else
        {
            string[0]=data->operate_number1[0];
            string[1]='.';
            strncat(string,data->operate_number1+1,6);
            if( data->result[7]>'4' )
                string[7]=data->operate_number1[6]+1;
            else
                string[7]=data->operate_number1[6];
        }
        strcat(string,"E+");
        if( data->operate_number1[0]=='-' )
            sprintf(s,"%02d",i-2);
        else
            sprintf(s,"%02d",i-1);
        strcat(string,s); 
        set_font_type(UNI12X12_FONT);
        dspl_colorTextOut(94-strlen(string)*6, 6, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);
    }
    else
    {
        i=0;
        while( ((data->operate_number1[i]<'1')||(data->operate_number1[i]>'9'))&&(i<strlen(data->operate_number1)) )
            i++;
        if( i>14 )
        {
            if( data->operate_number1[0]=='-' )
                strncpy(string,data->operate_number1,2);
            else strncpy(string,data->operate_number1,1);
            strcat(string,".");
            if( strlen(data->operate_number1)-i )
                strncat(string,data->operate_number1+i+1,6);
            else strcat(string,"0");            
            // if(data->result[strlen(data->result)]>'4')
            //   string[6]=data->result[i+5]+1;
            // else
            //   string[6]=data->result[i+5];
            strcat(string,"E-");
            sprintf(s,"%02d",i);
            strcat(string,s);           
            set_font_type(UNI12X12_FONT);         
            dspl_colorTextOut(94-strlen(string)*6, 6, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);              
        }
        else
        {
            set_font_type(UNI12X12_FONT);
            dspl_colorTextOut(94-strlen(data->operate_number1)*6, 6, DSPL_TXTATTR_TRANSPARENT, (char *)data->operate_number1, 0x000000);
        }         
    }   
    set_font_type(UNI12X12_FONT);
    dspl_colorTextOut(4, 20, DSPL_TXTATTR_TRANSPARENT, (char*)data->opera, 0x000000);
    set_font_type(UNI12X12_FONT);
    dspl_colorTextOut(94-strlen(data->operate_number2)*6, 20, DSPL_TXTATTR_TRANSPARENT, (char *)data->operate_number2, 0x000000);


    DrawLine(set_Line(2, 32 ,99, 32,line.color=0x000000));


    TRACE_EVENT("data->result=:");
    TRACE_EVENT(data->result);
    memset(string,0,sizeof(string));
    i=0;
    while( (data->result[i]!='.')&&(i<strlen(data->result)) )
        i++;
    if( (i>0)&&(i==strlen(data->result)-1) )
        data->result[strlen(data->result)-1]=0;
    if( i>=8 )
    {
        string[0]=data->result[0];
        string[1]='.';
        strncat(string,data->result+1,6);
        if( data->result[7]>'4' )
        {
            if( data->result[6]!='9' )
                string[7]=data->result[6]+1;
            else string[7]=data->result[6];
        }
        else
            string[7]=data->result[6];
        strcat(string,"E+");
        sprintf(s,"%02d",i-1);
        strcat(string,s); 
        string[12]=0;
        TRACE_EVENT(string);
        memset(data->SpecialResult,0,MAXLEN+MAXLEN);  
        strcpy(data->SpecialResult,string);
        if( !data->sig )
        {
            strcpy(string1,"-");
            strcat(string1,string);             
            set_font_type(UNI12X12_FONT);      
            dspl_colorTextOut(94-13*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)string1, 0x000000);           
        }
        else
        {
            set_font_type(UNI12X12_FONT);         
            dspl_colorTextOut(94-12*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);            
        }            
    }
    else
    {
        i=0;
        while( ((data->result[i]<'1')||(data->result[i]>'9'))&&(i<strlen(data->result)) )
            i++;
        TraceInt(i);
        if( i>14 )
        {
            string[0]=data->result[i];
            string[1]='.';
            if( strlen(data->result)-i )
            {
                if( (strlen(data->result)-i)<7 )
                    strncat(string,data->result+i+1,strlen(data->result)-i);
                else strncat(string,data->result+i+1,6);
            }
            else strcat(string,"0");            
            // if(data->result[strlen(data->result)]>'4')
            //   string[6]=data->result[i+5]+1;
            // else
            //   string[6]=data->result[i+5];
            strcat(string,"E-");
            sprintf(s,"%02d",i);
            strcat(string,s); 
            memset(data->SpecialResult,0,MAXLEN+MAXLEN);   
            strcpy(data->SpecialResult,string);
            if( !data->sig )
            {
                strcpy(string1,"-");
                strcat(string1,string);             
                set_font_type(UNI12X12_FONT);         
                dspl_colorTextOut(94-strlen(string1)*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)string1, 0x000000);            
            }
            else
            {
                set_font_type(UNI12X12_FONT);         
                dspl_colorTextOut(94-strlen(string)*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)string, 0x000000);            
            }           
        }
        else
        {
            if( (data->result[0]=='0')&&(strlen(data->result)<2) )
            {
                set_font_type(UNI12X12_FONT);
                dspl_colorTextOut(94-strlen(data->result)*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)data->result, 0x000000);
                return;
            }
            i=0;
            j=0;
            while( data->result[i]!='.' )
                i++;
            if( i )
                for( j=i;j<strlen(data->result);j++ );
            if( i+j>17 )
                data->result[i+j]=0;
            if( (!data->sig)&&strlen(data->result) )
            {
                strcpy(string1,"-");
                strcat(string1,data->result);
                set_font_type(UNI12X12_FONT);       
                dspl_colorTextOut(94-strlen(string1)*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)string1, 0x000000);
            }
            else
            {
                set_font_type(UNI12X12_FONT);
                dspl_colorTextOut(94-strlen(data->result)*6, 34, DSPL_TXTATTR_TRANSPARENT, (char *)data->result, 0x000000);
            }           
        }
    }
#endif
   
}

/*void calculate(char str1[MAXLEN],char str2[MAXLEN],char mark[2],char result_s[MAXLEN+MAXLEN])
{
   float number1=0,number2=0,result=0,r,t;  
   int resultint;
   int negative=0;
   float resultpoint;
   int divisor=1,multiplyer=1;
   int index=0;
   int pointflag=0;
   int i=0;
  
   for(i=0;i<strlen(str1);i++)
    {
     if(str1[i]=='-')
        {
          negative=1;
        }
     else
        {
      if(pointflag==0)
        {
        if(str1[i]!='.')
          {
            number1=number1*10+(int)str1[i]-48;
          }
        else
            {   	    	  
              pointflag=1;
            }
        }
      else
        {
           divisor=divisor*10;
           r=(int)str1[i]-48;
           number1=number1+r/divisor;		  
        }
        }	 
    }
   if(negative)
    {
      number1=number1*(-1);
      negative=0;
    }
   
   divisor=1;
   pointflag=0;

   for(i=0;i<strlen(str2);i++)
    {
     if(str2[i]=='-')
        {
          negative=1;
        }
     else
        {
      if(pointflag==0)
        {
        if(str2[i]!='.')
          {
            number2=number2*10+(int)str2[i]-48;
          }
        else
            {   	    	  
              pointflag=1;
            }
        }
      else
        {
           divisor=divisor*10;
           r=(int)str2[i]-48;
           number2=number2+r/divisor;		  
        }
        }	 
    }
   if(negative)
    {
      number2=number2*(-1);
      negative=0;
    }

   switch(mark[0])
    {
      case '+':
        result=number1+number2;
        break;
      case '-':
        result=number1-number2;
        break;
      case '*':
        result=number1*number2;
        break;
      case '/':
        result=number1/number2;
        break;
    } 
   if(result<0)
    {
     result_s[index]='-';
     index++;
     result=result*(-1);
    }  
   r=result;
   resultpoint=r-(int)result;
   resultint=(int)r;  
   t=resultint;  
   divisor=1;
   while(t>=10)
    {
      t/=10;
      divisor=divisor*10;
    }
   
   while(divisor>0)
    {	 
      t=resultint/divisor;	 
      result_s[index]=(char)(t+48);
      resultint%=divisor;
      divisor/=10;	 
      index++;	  
    }        
   r=resultpoint*100;
   if((resultpoint*100-(int)r)>=0.5)
       resultpoint+=0.01;
   if(resultpoint>0)
   {	   
       result_s[index]='.';
       index++;
       for(i=0;i<2;i++)
       {		  
           multiplyer=multiplyer*10;
           t=resultpoint*multiplyer;		  
           result_s[index]=(char)((int)t+48);
           resultpoint=(resultpoint*10-(int)t)/10;
           index++;
       }
   }   
   TRACE_EVENT(result_s);
}*/

#if 0
char getoperator(int c)
{
    switch( c )
    {
    case CALCULATOR_PLUS:   return '+'; break;
    case CALCULATOR_MINUS:   return '-'; break;
    case CALCULATOR_MULTIPLY:   return '*'; break;
    case CALCULATOR_DIVIDE:   return '/'; break;
    default: return '\0'; break;
    }
}
#endif

game_Line set_Line(int x1,int y1,int x2,int y2,int color)
{
    game_Line l;

    l.x1=x1;
    l.y1=y1;
    l.x2=x2;
    l.y2=y2;
    l.color=color;

    return l;
}

void reset_calculator(CalcData* data)
{
    memset((char*)data->operate_number1,0,sizeof(data->operate_number1));
    memset((char*)data->operate_number2,0,sizeof(data->operate_number2));
    /*2004/05/19 yhf modify*/       
    memset((char*)data->result,0,sizeof(data->result));
    memset((char*)data->opera,0,sizeof(data->opera));
    /* end yhf */
    //memset((char*)data->result,0,sizeof(data->result));
    /*2004/05/19 yhf modify*/           
    //strcpy((char*)data->operate_number1,"0");
    //strcpy((char*)data->operate_number2,"0");
    /* end yhf */  
    data->flag=FALSE;
    data->index=0;
    data->pointflag=FALSE;
    data->afterpoint=0;
    data->leftkey_indication=0;
}


int calculate1(char str1[MAXLEN],char str2[MAXLEN],char mark[2],char *result_s)
{
    int i,j;
    int off,amp,k,carry=0,signal=1,shr;
    char temp_mark[2];
    char fi[MAXLEN],ff[MAXLEN],si[MAXLEN],sf[MAXLEN],s[MAXLEN],t[MAXLEN],sTemp[MAXLEN+MAXLEN];
    long v1,v2;

    memset(fi,0,MAXLEN);
    memset(ff,0,MAXLEN);
    memset(si,0,MAXLEN);
    memset(sf,0,MAXLEN);
    memset(s,0,MAXLEN);
    memset(t,0,MAXLEN);
    memset(sTemp,0,MAXLEN);    
    i=0;
    while( str1[i]!='.'&&(i<strlen(str1)) )
        i++;
    strncpy(fi,str1,i);
    if( i<strlen(str1) )
        strcpy(ff,str1+i+1);
    i=0;
    while( str2[i]!='.'&&(i<strlen(str2)) )
        i++;
    strncpy(si,str2,i);
    if( i<strlen(str2) )
        strcpy(sf,str2+i+1);
    memset(temp_mark,0,2);
    strcpy(temp_mark,mark);
    signal=stringchange(fi,ff,si,sf,temp_mark); 
    switch( temp_mark[0] )
    {
    case '+':
        i = strlen(ff);
        j = strlen(sf);
        strcpy(s, ff);
        strcpy(t, sf);
        if( i < j )
        {
            k = i;
            i = j;
            j = k;
            strcpy(s, sf);
            strcpy(t, ff);
        }
        if( i > 0 )
        { //has fraction
            strcpy(ff, s+j);
            s[j] = t[j] = 0;
            while( j >= STEP_LEN )
            {
                v1 = atol(s+j-STEP_LEN);//j-8
                v2 = atol(t+j-STEP_LEN)+carry;//j-8
                v1 += v2;
                carry = 0;
                if( v1 >= HUNDRED_MILLION )
                    carry = 1;
                sprintf(sTemp, "%0*ld", STEP_LEN, v1);
                sprintf(sf,"%s%s",sTemp+carry,ff);
                strcpy(ff,sf);
                j -= STEP_LEN;
                s[j] = t[j] = 0;
            }
            if( j > 0 )
            {
                v1 = atol(s);
                v2 = atol(t)+carry;
                v1 += v2;
                carry = 0;
                sprintf(sTemp, "%0*ld", j, v1);
                if( strlen(sTemp)>j )
                    carry = 1;
                sprintf(sf,"%s%s",sTemp+carry,ff);
                strcpy(ff,sf);
            }
        }
        //integer section
        k = i = strlen(fi);
        j = strlen(si);
        strcpy(s, fi);
        strcpy(t, si);
        if( i < j )
        {
            k = j;
            j = i;
            i = k;
            strcpy(s, si);
            strcpy(t, fi);
        }
        if( 1 )
        {//has integer
            fi[0] = 0;
            while( j >= STEP_LEN )
            {
                v1 = atol(s+i-STEP_LEN);//i-8
                v2 = atol(t+j-STEP_LEN)+carry;//j-8
                v1 += v2;
                carry = 0;
                if( v1 >= HUNDRED_MILLION )
                    carry = 1;
                sprintf(sTemp, "%0*ld", STEP_LEN, v1);
                sprintf(si,"%s%s",sTemp+carry,fi);
                strcpy(fi,si);
                i -= STEP_LEN;
                j -= STEP_LEN;
                s[i] = t[j] = 0;
            }
            if( j > 0 )
            {
                v1 = atol(s+i-j);
                v2 = atol(t)+carry;
                v1 += v2;
                carry = 0;
                sprintf(sTemp, "%0*ld", j, v1);
                if( strlen(sTemp)>j )
                    carry = 1;
                sprintf(si,"%s%s", sTemp+carry, fi);
                strcpy(fi,si);
                i -= j;
                s[i] = 0;
            }
            //more than t
            while( i >= STEP_LEN )
            {
                v1 = atol(s+i-STEP_LEN)+carry;
                carry = 0;
                if( v1 >= HUNDRED_MILLION )
                    carry = 1;
                sprintf(sTemp, "%0*ld", STEP_LEN, v1);
                sprintf(si, "%s%s", sTemp+carry, fi);
                strcpy(fi, si);
                i -= 8;
                s[i] = 0;
            }
            if( i >= 0 )
            {
                v1 = atol(s)+carry;
                carry = 0;
                sprintf(sTemp, "%ld", v1);
                if( strlen(sTemp)>j )
                    carry = 1;
                sprintf(si, "%s%s", sTemp, fi);
                strcpy(fi, si);
            }
        }

        break;
    case '-':           
        strcpy(s,ff);
        strcpy(t,sf);
        //s - t fraction
        i = strlen(s);
        j = strlen(t);                  
        if( i | j )
        { //fraction
            ff[0] = 0;        
            while( i<=j-STEP_LEN )
            {
                v1 = HUNDRED_MILLION-carry;
                carry = 1;
                v2 = atol(t+j-STEP_LEN);
                v1 = (v1 - v2)%HUNDRED_MILLION;
                sprintf(sTemp,"%0*ld", STEP_LEN, v1);
                sprintf(sf, "%s%s",sTemp, ff);
                strcpy(ff, sf);
                j -= STEP_LEN;
                t[j] = 0;
            }
            if( i < j )
            {
                v1 = pow10(j-i)-carry;
                carry = 1;
                v2 = atol(t+i);
                v1 = (v1 - v2)%pow10(j-i);
                sprintf(sTemp, "%0*ld",j-i, v1);
                sprintf(sf, "%s%s",sTemp, ff);
                strcpy(ff, sf);
                j = i;
                t[j] = 0;
            }
            if( i > j )
            {
                strcpy(ff, s+j);
                i = j;
                s[j] = 0;               
            }
            while( i  >= STEP_LEN )
            {
                v1 = atol(s+i-STEP_LEN)-carry;
                v2 = atol(t+j-STEP_LEN);
                carry = (v1 < v2);
                v1 = (v1 + carry*HUNDRED_MILLION - v2);
                sprintf(sTemp, "%0*ld", STEP_LEN, v1);
                sprintf(sf, "%s%s", sTemp, ff);
                strcpy(ff, sf);
                i -= STEP_LEN;
                j -= STEP_LEN;
                s[i] = t[j] = 0;
            }
            if( i > 0 )
            {
                v1 = atol(s)-carry;
                v2 = atol(t);
                carry = (v1 < v2);
                v1 = (v1 + carry*pow10(i) - v2);
                sprintf(sTemp, "%0*ld", i, v1);
                sprintf(sf, "%s%s", sTemp, ff);
                strcpy(ff, sf);
            }
        }
        strcpy(s, fi);
        strcpy(t, si);          
        i = strlen(s);
        j = strlen(t);
        fi[0] = 0;
        while( j >= STEP_LEN )
        {
            v1 = atol(s+i-STEP_LEN)-carry;
            v2 = atol(t+j-STEP_LEN);
            carry = (v1 < v2);
            v1 = (v1+carry*HUNDRED_MILLION - v2);
            sprintf(sTemp, "%0*ld", STEP_LEN, v1);
            sprintf(si, "%s%s", sTemp, fi);
            strcpy(fi, si);
            i -= STEP_LEN;
            j -= STEP_LEN;
            s[i] = t[j] = 0;
        }
        if( j > 0 )
        {
            v1 = atol(s+i-j)-carry;
            v2 = atol(t);
            carry = (v1 < v2);
            v1 = (v1+carry*pow10(j) - v2);
            sprintf(sTemp, "%0*ld", j, v1);
            sprintf(si, "%s%s", sTemp, fi);
            strcpy(fi, si);
            i -= j;
            s[i] = 0;
        }
        while( i >= STEP_LEN )
        {
            v1 = atol(s+i-STEP_LEN)-carry;
            carry=0;
            if( v1 < 0 )
            {
                carry = 1;
                v1 += HUNDRED_MILLION;
            }
            sprintf(sTemp, "%0*ld", STEP_LEN, v1);
            sprintf(si, "%s%s", sTemp, fi);
            strcpy(fi, si);
            i -= STEP_LEN;
            s[i] = 0;
        }
        if( i > 0 )
        {
            v1 = atol(s) - carry;
            sprintf(sTemp, "%0*ld", i, v1);
            sprintf(si, "%s%s", sTemp, fi);
            strcpy(fi, si);
        }
        break;
    case '*':
        i = strlen(fi);
        j = strlen(si);
        k = sprintf(s,"%s%s",fi,ff);
        amp = k - i;
        off = 0;
        while( s[off]=='0'&&s[off+1]>='0'&&s[off+1]<='9' )
            off++;
        if( off )
            strcpy(s, s+off);

        k = sprintf(t,"%s%s",si,sf);
        amp += k - j;
        off = 0;
        while( t[off]=='0'&&t[off+1]>='0'&&t[off+1]<='9' )
            off++;
        if( off )
            strcpy(t, t+off);

        i = strlen(s);
        j = strlen(t);
        if( i+j > (STEP_LEN+1) )
        {
            amp -= i+j - (STEP_LEN+1);
            if( i < 5 )
                j = (STEP_LEN+1)-i;
            else if( j < 5 )
                i = (STEP_LEN+1)-j;
            else
            {
                i = 4;
                j = (STEP_LEN+1)-i;
            }
            s[i] = 0;
            t[j] = 0;
        }
        v1 = atol(s);
        v2 = atol(t);
        v1 *= v2;
        k = sprintf(sTemp, "%lu", v1);
        if( amp < 0 )
        {
            sprintf(fi,"%s%0*d",sTemp,(-amp),0);
            ff[0] = 0;
        }
        else if( k >= amp )
        {
            sprintf(ff, "%s", sTemp+k-amp);
            sTemp[k-amp] = 0;
            strcpy(fi, sTemp);
        }
        else
        {
            sprintf(ff, "%0*d%s", amp-k, 0, sTemp);
            strcpy(fi, "0");
        }
        break;
    case '/':
        i = strlen(fi);
        j = strlen(si);
        k = sprintf(s,"%s%s",fi,ff);
        amp = k - i;
        off = 0;
        while( s[off]=='0'&&s[off+1]>='0'&&s[off+1]<='9' )
            off++;
        if( off )
            strcpy(s, s+off);
        k = strlen(s);
        if( k < (STEP_LEN+1) )
        {
            amp += (STEP_LEN+1) - k;
            sprintf(s+k, "%0*d", (STEP_LEN+1)-k, 0);
        }
        else
        {
            amp -= k - (STEP_LEN+1);
            s[(STEP_LEN+1)] = 0;
        }
        v1 = atol(s);
        k = sprintf(t,"%s%s",si,sf);
        shr = k - j;
        off = 0;
        while( t[off]=='0'&&t[off+1]>='0'&&t[off+1]<='9' )
            off++;
        if( off )
            strcpy(t, t+off);
        k = strlen(t);
        if( k >= DIV_LEN )
        {
            shr -= k-DIV_LEN;
            t[DIV_LEN] = 0;
        }
        v2 = atol(t);
        if( v2==0 )
        {
            strcpy(fi,"0");
            ff[0] = 0;
            return 0;
        }
        v1 /= v2;
        memset(sTemp,0, sizeof(sTemp));
        i = sprintf(sTemp, "%ld", v1);
        j = i + shr - amp;
        ff[0] = 0;
        if( j > i )
        {
            sprintf(fi,"%s%0*d",sTemp,j-i,0);
            ff[0] = 0;
        }
        else if( j >= 0 )
        {
            sprintf(ff,"%s", sTemp+j);
            sTemp[j] = 0;
            strcpy(fi, sTemp);
        }
        else
        {
            strcpy(fi, "0");
            sprintf(ff,"%0*d%s", amp-i-shr, 0, sTemp);
        }
        if( !strlen(fi) )
            strcpy(fi,"0");
        TRACE_EVENT(ff);
        break;
    default:
        break;
    }   
    strcpy(result_s,fi);
    if( strlen(ff) )
    {
        strcat(result_s,".");
        strcat(result_s,ff);
    }
    return signal;
}


int stringchange(char *fi,char *ff,char *si,char *sf,char *mark)
{
    char string[MAXLEN],stri[MAXLEN],strf[MAXLEN];
    int i,j,k,l,m,n;
    int sig=1;

    memset(string,0,MAXLEN);
    memset(stri,0,MAXLEN);
    memset(strf,0,MAXLEN);   
    switch( mark[0] )
    {
    case '+':       
        if( (fi[0]=='-')&&(si[0]=='-') )
        {
            sig=0;
            strcpy(string,fi+1);
            strcpy(fi,string);
            strcpy(string,si+1);
            strcpy(si,string);
        }
        if( (fi[0]=='-')&&(si[0]!='-') )
        {
            strcpy(string,fi+1);
            strcpy(fi,string);
            i=strlen(fi);
            j=strlen(si);
            k=strcmp(fi,si);
            l=strlen(ff);
            m=strlen(sf);
            n=strcmp(ff,sf);
            if( (i<j)||(i==j)&&(k<0)||(i==j)&&(k==0)&&((l<m)||(l==m)&&(n<0)) )
            {
                stringexchange(fi,si);
                stringexchange(ff,sf);
            }
            else
                sig=0;

            mark[0]='-';
        }
        if( (fi[0]!='-')&&(si[0]=='-') )
        {
            strcpy(string,si+1);
            strcpy(si,string);
            i=strlen(fi);
            j=strlen(si);
            k=strcmp(fi,si);
            l=strlen(ff);
            m=strlen(sf);
            n=strcmp(ff,sf);
            if( (i<j)||(i==j)&&(k<0)||(i==j)&&(k==0)&&((l<m)||(l==m)&&(n<0)) )
            {
                sig=0;
                stringexchange(fi,si);
                stringexchange(ff,sf);
            }
            mark[0]='-';
        }
        break;
    case '-':       
        if( (fi[0]=='-')&&(si[0]!='-') )
        {
            sig=0;
            strcpy(string,fi+1);
            strcpy(fi,string);
            mark[0]='+';
        }
        if( (fi[0]=='-')&&(si[0]=='-') )
        {
            strcpy(string,fi+1);
            strcpy(fi,string);
            strcpy(string,si+1);
            strcpy(si,string);              
            i=strlen(fi);
            j=strlen(si);
            k=strcmp(fi,si);
            l=strlen(ff);
            m=strlen(sf);
            n=strcmp(ff,sf);
            if( (i<j)||(i==j)&&(k<0)||(i==j)&&(k==0)&&((l<m)||(l==m)&&(n<0)) )
            {
                stringexchange(fi,si); 
                stringexchange(ff,sf);
            }
            else
                sig=0;                
        }
        if( (fi[0]!='-')&&(si[0]=='-') )
        {
            strcpy(string,si+1);
            strcpy(si,string);
            mark[0]='+';
        }
        if( (fi[0]!='-')&&(si[0]!='-') )
        {
            i=strlen(fi);
            j=strlen(si);
            k=strcmp(fi,si);
            l=strlen(ff);
            m=strlen(sf);
            n=strcmp(ff,sf);
            if( (i<j)||(i==j)&&(k<0)||(i==j)&&(k==0)&&((l<m)||(l==m)&&(n<0)) )
            {
                sig=0;
                stringexchange(fi,si);
                stringexchange(ff,sf);
            }
        }
        break;
    case '*':
    case '/':
        if( (fi[0]=='-')&&(si[0]!='-') )
        {
            strcpy(string,fi+1);
            strcpy(fi,string);
            sig=0;
        }
        if( (fi[0]!='-')&&(si[0]=='-') )
        {
            sig=0;
            strcpy(string,si+1);
            strcpy(si,string);
        }
        if( (fi[0]=='-')&&(si[0]=='-') )
        {
            strcpy(string,fi+1);
            strcpy(fi,string);
            strcpy(string,si+1);
            strcpy(si,string);
        }
        break;
    }   
    return sig;
}


void stringexchange(char *from,char *to)
{
    char string[MAXLEN],string1[MAXLEN];

    memset(string,0,sizeof(string));
    memset(string1,0,sizeof(string1));

    memcpy(string,from,MAXLEN);
    memcpy(string1,to,MAXLEN);
    memcpy(from,string1,MAXLEN);
    memcpy(to,string,MAXLEN);
}

static long pow10(int i){
    long v = 1;
    while( i-->0 )
        v *= 10;
    return v;
}


void convert(char a[MAXLEN],char b[MAXLEN+MAXLEN])
{
    int i=0,j=0,k=0;
    char string[MAXLEN+MAXLEN];
    char exponent[2];

    memset(string,0,MAXLEN+MAXLEN);
    memset(exponent,0,2);
    i=0;
    while( (a[i]!='E')&&(i<strlen(a)) )
        i++; 
    if( i<strlen(a) )
    {
        if( a[i+1]=='+' )
        {
            if( a[0]=='-' )
            {
                strncpy(string,a,2);
                strncat(string,a+3,i-3);
            }
            else
            {
                strncpy(string,a,1);
                strncat(string,a+2,i-2);
            }                       
            exponent[0]=a[i+2];
            exponent[1]=a[i+3];             
            j=((int)exponent[0]-48)*10+(int)exponent[1]-48; 
            if( a[0]=='-' )
            {
                for( k=0;k<j-i+3;k++ )
                    strcat(string,"0"); 
            }
            else
            {
                for( k=0;k<j-i+2;k++ )
                    strcat(string,"0");
            }
        }
        else
        {
            strcpy(exponent,a+i+2);
            j=(exponent[0]-'0')*10+exponent[1]-'0';
            if( a[0]=='-' )
            {
                strcpy(string,"-0.");
            }
            else
            {
                strcpy(string,"0.");
            }
            for( k=0;k<j-1;k++ )
                strcat(string,"0");
            strncat(string,a,1);
            strncat(string,a+2,i-2);
        }
        strcpy(b,string);
    }
    else strcpy(b,a);   
}
