/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Supplementary services
 $File:		    Mmidict.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		hxl(Mobile Innovation)                                                         
 $Date:		    28/06/02                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This module provides the supplementary services functionality

  
********************************************************************************
 $History: Mmidict.c

	01/08/02 			huangxl creat.	
	   
 $End

*******************************************************************************/


/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#define BUGS 0

#define ENTITY_MFW
/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"

#include "rtc_api.h"
#include "mmihz.h"
#include "mmieditor.h"
#include "mmiusersymbolinput.h" 
#include "Mmidict.h"
#include "Mmidictfunc.h"

#ifdef EASY_TEXT_ENABLED
#include "MmiChineseInput.h"
#endif

#define LIST_COL	8
#define LIST_LEN	15

typedef enum{
	searched_chn=DictDummy,
	search_chn,
	searched_fail
}DICTIDTIFY;

//move from el630dict---------------------------------------------------
static S16	l_index;  // index of current word and in START it is the position of setting
static U8	l_startline; // the start line of word for display
static S8	l_opt; // it is a reused variable;
					// for WIN_UPDATE,it is the selection of list
					// for TEST_START&RECITE_START, it is a flag of changing configurate
					// for RECITE, it's a flag of displaying Chinese
					// for TEST, it is the index of selection,0:Q,1:A,2:B,3:C,4:D
static U16	l_booktotal; //the total word of current book
static S16	l_indexofbook; // the word index of current book
static U8	l_test_true_cnt; // it is the true count of testing;
							// in recite,it also used for sequence of chinese and english->0:EC;1:CE;2:list
static S16	l_test_opt[4];
static U8   l_lastkey;
//static U8	l_e2cshow_input;//if it is 1,indicate the e2cinput_win_show will clear edit buffer first
static const int l_booktext[] = {
		TxtSchool,
		TxtCET4,
		TxtCET6,
		TxtGraduate,
		TxtTOEFL,
		TxtGRE,
		TxtBusiness,
		TxtMBA
};
static const char l_book[] = {
	BOOK_SCHOOL,
	BOOK_CET4,
	BOOK_CET6,
	BOOK_GRADUATE,
	BOOK_TOEFL,
	BOOK_GRE,
	BOOK_BUSINESS,
	BOOK_MBA
};

static UBYTE DicteditAlpha [8]=           /* alpha mode characters    */
{
    'a', 'd','g','j','m','p','t','w'
};

extern	INT8	g_norejectkeyflag;//add for editor 2002-12-27

void dictSetEditAttributes(
    U16  winPx,   U16 winPy, U16 winSx, U16 winSy,
	U8   fgColor, U8  font,  U8  mode,  U8  *controls,
	char *text,   U16 size,
	MfwEdtAttr*   attr);
static char *  GetListLine(char*buf,int line);
static void SetListItem( char*buf,int listnum,UBYTE invers);
static S16 GenIndex(int range0,int range1,unsigned int rand);
static void GenTestOption(void);
void yb_codeconvert(char* in,char* out);

T_MFW_HND E2CInput_Start (T_MFW_HND parent_window,tdictInputSpecifics *properties,T_dict *dict);
T_MFW_HND E2CInput_create (T_MFW_HND parent_window,T_dict *dict);
void E2CInput_destroy (T_MFW_HND own_window);
static void E2CInput_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int E2CInput_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int E2CInput_kbd_cb (MfwEvt e, MfwKbd *k);
void InputEngWordCB( T_MFW_HND win, UBYTE reason , USHORT identifier);
static void	E2CInputShowUpdate(T_MFW_WIN * win);
static int C2EEdit_tim_cb( MfwEvt e, MfwTim *tc );

MfwHnd E2CShowWinEntry(T_MFW_HND win);
T_MFW_HND E2CShowWinStart (T_MFW_HND parent_window,tdictInputSpecifics *properties );
T_MFW_HND E2CShow_create (T_MFW_HND parent_window);
void E2CShow_destroy (T_MFW_HND own_window);
static int E2CShow_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void E2CShow_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int E2CShow_kbd_cb (MfwEvt e, MfwKbd *k);
void E2CShowCB( T_MFW_HND win, UBYTE reason );



T_MFW_HND C2EInput_Start (T_MFW_HND parent_window,tdictInputSpecifics *properties ,T_dict *dict);
T_MFW_HND C2EInput_create (T_MFW_HND parent_window,T_dict *dict);
void C2EInput_destroy (T_MFW_HND own_window);
static int C2EInput_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void C2EInput_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
//static int C2EInput_kbd_cb (MfwEvt e, MfwKbd *k);
static MfwHnd DictShowInformation( MfwHnd parent, int txtId, int txtId2, char *str, unsigned long time,USHORT identifier,T_VOID_FUNC cb_function );
static int Dict_Inofrmation_cb(T_MFW_HND win, USHORT identifier, USHORT reason);

int DictChnEditEntry(T_MFW_HND win);
void dict_loadEditDefault(T_EDITOR_DATA *editor_data);
void InputChnWordCB( T_MFW_HND win, USHORT Identifier, UBYTE reason );

MfwHnd C2EShowWinEntry(T_MFW_HND win,T_dict *dict);
T_MFW_HND C2EShowWinStart (T_MFW_HND parent_window,tdictInputSpecifics *properties,T_dict *dict );
T_MFW_HND C2EShow_create (T_MFW_HND parent_window,T_dict *dict);
void C2EShow_destroy (T_MFW_HND own_window);
static int C2EShow_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void C2EShow_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int C2EShow_kbd_cb (MfwEvt e, MfwKbd *k);
static int C2EShow_tim_cb( MfwEvt e, MfwTim *tc );
void C2EShowCB( T_MFW_HND win, UBYTE reason );

T_MFW_HND TestStart_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties );
T_MFW_HND TestStart_create (T_MFW_HND parent_window);
void TestStart_destroy (T_MFW_HND own_window);
static int TestStart_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void TestStart_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int TestStart_kbd_cb (MfwEvt e, MfwKbd *k);
void TestStartCB( T_MFW_HND win, UBYTE reason );

MfwHnd TestWinEntry(T_MFW_HND win);
T_MFW_HND Test_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties,T_dict *dict);// 
T_MFW_HND Test_create (T_MFW_HND parent_window,T_dict *dict);//
void Test_destroy (T_MFW_HND own_window);
static int Test_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void Test_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int Test_kbd_cb (MfwEvt e, MfwKbd *k);
void TestCB( T_MFW_HND win, UBYTE reason );

MfwHnd TestPromptWinEntry(T_MFW_HND win);
T_MFW_HND TestPrompt_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties );
T_MFW_HND TestPrompt_create (T_MFW_HND parent_window);
void TestPrompt_destroy (T_MFW_HND own_window);
static int TestPrompt_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void TestPrompt_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int TestPrompt_kbd_cb (MfwEvt e, MfwKbd *k);
static int TestPrompt_tim_cb( MfwEvt e, MfwTim *tc );
void TestPromptCB( T_MFW_HND win, UBYTE reason );

MfwHnd TestResultWinEntry(T_MFW_HND win);
T_MFW_HND TestResult_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties );
T_MFW_HND TestResult_create (T_MFW_HND parent_window);
void TestResult_destroy (T_MFW_HND own_window);
static int TestResult_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void TestResult_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int TestResult_kbd_cb (MfwEvt e, MfwKbd *k);
void TestResultCB( T_MFW_HND win, UBYTE reason );

T_MFW_HND Recite_create (T_MFW_HND parent_window);
void Recite_destroy (T_MFW_HND own_window);
static void Recite_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
T_MFW_HND Recite_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties );
static int Recite_kbd_cb (MfwEvt e, MfwKbd *k);
static int Recite_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void ReciteCB( T_MFW_HND win, UBYTE reason );


T_MFW_HND ReciteEnd_create (T_MFW_HND parent_window);
void ReciteEnd_destroy (T_MFW_HND own_window);
static void ReciteEnd_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
T_MFW_HND ReciteEnd_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties );
static int ReciteEnd_kbd_cb (MfwEvt e, MfwKbd *k);
static int ReciteEnd_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
MfwHnd ReciteEndWinEntry(T_MFW_HND win);
void ReciteEndCB( T_MFW_HND win, UBYTE reason );

T_MFW_HND ReciteStart_create (T_MFW_HND parent_window);
void ReciteStart_destroy (T_MFW_HND own_window);
static void ReciteStart_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
T_MFW_HND ReciteStart_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties );
static int ReciteStart_kbd_cb (MfwEvt e, MfwKbd *k);
static int ReciteStart_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
MfwHnd ReciteWinEntry(T_MFW_HND win);
void ReciteStartCB( T_MFW_HND win, UBYTE reason );


/*******************************************************************************

 $Function:    	DictEngToChnEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
//char edt_buf[WORD_MAX_LEN];
//MfwEdtAttr attr;		/* Editor attributes */
int DictEngToChnEntry(MfwMnu *m, MfwMnuItem *i ) 
{
    T_MFW_HND win = mfw_parent(mfw_header());
	tdictInputSpecifics DefaultParameters;
	T_dict	*dict;
	int	j=0;

	TRACE_FUNCTION ("DictEngToChnEntry()");
	
	//init the parameter
	l_index=0;
	l_startline = 0;
	l_opt = -1;//hxl add for select the second word when edit is blank 2002-12-9
	MODE = ENG;
	l_booktotal=0;
	for(j=0;j<(sizeof(l_booktext)/sizeof(int));j++)
		l_booktotal+=dict_getTotalByBook(l_book[j]);
	/* allocate memory for our control block
	*/
	if ( ( dict = (T_dict *) ALLOC_MEMORY( sizeof( T_dict ) ) ) == NULL )
		return NULL;

    memset( dict->edt_buf_EngWord, '\0', WORD_MAX_LEN ); 
	dictSetEditAttributes( 0, 18, 120, 16, 0, 0, edtCurBar1, 0, 
		dict->edt_buf_EngWord , WORD_MAX_LEN+3, &dict->edt_attr_EngWord);

	
	DefaultParameters.abc               = LOWERCASE_MODE;
	DefaultParameters.text              = TxtE2CGreeting;
	DefaultParameters.edt_attr_input    = &dict->edt_attr_EngWord;
	DefaultParameters.left_soft_key     = TxtSoftOK;
	DefaultParameters.right_soft_key    = TxtSoftBack;//Changed text ,TxtDelete
	// dunno if that changes softkey functionality
	DefaultParameters.parent_callback	= InputEngWordCB;

	//allocate window, and if successful initialise it
    if(E2CInput_Start( win, &DefaultParameters, dict )==NULL)
		FREE_MEMORY( (void *)dict, sizeof( T_dict ) );
    
	return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:    	E2CInput_Start

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND E2CInput_Start (T_MFW_HND parent_window,tdictInputSpecifics *properties ,T_dict *dict)
{
	T_MFW_HND win;

	TRACE_FUNCTION ("E2CInput_Start()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = E2CInput_create( parent_window ,dict) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	
	return win;
}


/*******************************************************************************

 $Function:    	E2CInput_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND E2CInput_create (T_MFW_HND parent_window,T_dict *dict)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("E2CInput_create()");
	
	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) E2CInput_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) E2CInput_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
 	data->dict					= dict;
	data->parent_win			= parent_window;
	
	g_norejectkeyflag=1;//add for editor 2002-12-27

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL ,            (MfwCb) E2CInput_kbd_cb );
	data->tim		= timCreate(data->win,   300,         (MfwCb) C2EEdit_tim_cb);
	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	E2CInput_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void E2CInput_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("bookInputDestroy()");

	if (data)
	{
		ec_editDeactivate();
        edtDelete(data->edt);
		g_norejectkeyflag=0;//add for editor 2002-12-27

		winDelete ( data->win );
		FREE_MEMORY( (void *)data->dict, sizeof( T_dict ) );
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
	}
}


/*******************************************************************************

 $Function:    	E2CInput_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int E2CInput_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("E2CInput_win_cb()");
	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			//UINT32 OldBackColor;
			/* Window visible
			*/
			//if(l_e2cshow_input)
			//	break;
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtE2CGreeting)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtE2CGreeting), 0xffffff );
			dspl_Clear(0,34,120,142);
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
			
			if (  strlen(data->properties.edt_attr_input->text)> 0){
				l_index =dict_english_find(data->properties.edt_attr_input->text);
			}
			l_opt = 0;//hxl 0220
			data->properties.parent_callback( data->win, WIN_UPDATE,0 );//hxl changed for back show selecting before 2002-12-9
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	E2CInput_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void E2CInput_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("E2CInput_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{
			/* Initialise the input window
			*/
			data->properties.abc			= properties->abc;
			data->properties.text			= properties->text;
			data->properties.edt_attr_input	= properties->edt_attr_input;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.parent_callback	= properties->parent_callback;
            data->edt						= edtCreate( data->win, data->properties.edt_attr_input, 0, 0 );

			/* activate our editor, stopping any others before doing so
			*/
			ec_editDeactivate();
		    ec_editActivate(data->edt, data->properties.abc);//
			edtChar( data->edt, ecBottom );

			edtShow( data->edt );
			/* show the window
			*/
			winShow( data->win );
			
		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			E2CInput_destroy( win );
		}
		break;
	}
}
/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int E2CInput_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	int	i=0;
  	static	uint8	oldlen=0;
  TRACE_FUNCTION ("E2CInput_kbd_cb()");
	/* make sure the active editor is ours
	*/

    if ( getactiveEditor() != data->edt )
        ec_editActivate( data->edt, data->properties.abc );
    

	/* Handle the key press
	*/
    switch (k->code)
    {
		case KCD_MNUUP:
		{
			if(l_opt>0)
				l_opt --;
			else if((l_index-LIST_COL+3)>=0){
			    l_index-=LIST_COL-3;
			    l_opt=0;
			}else{
			    l_opt=0;
			    l_index=0;
			}
			data->properties.parent_callback( data->win, WIN_UPDATE ,0);
		}
		break;

	    case KCD_MNUDOWN:
		{
			if(l_opt<(LIST_COL-4)) {
			    if(dict_eng(l_index+l_opt+1))
			    	l_opt ++;
			} else if(dict_eng(l_index+LIST_COL-3)) {
				l_index+=LIST_COL-3;
				l_opt=0;
			}else{
				l_opt=0;
				l_index=0;
			}
			data->properties.parent_callback( data->win, WIN_UPDATE,0 );
		}
		break;

	    case KCD_LEFT:
	    case KCD_OK:
		{
			/* select the entry using the parent window callback
			*/
		    data->properties.parent_callback( data->win, SET_LEFT ,0);
		   
		}
		break;

		case KCD_HUP:
		{
            data->properties.parent_callback( data->win, SET_CLEAR,0 );
		}
		break;

		case KCD_RIGHT:
		{
			//If we have any data input, delete the char before cursor
			if ( strlen(data->properties.edt_attr_input->text) > 0 ){
				edtChar( data->edt, ecBack );
				//if no char ,change the rightkey
				if(strlen(data->properties.edt_attr_input->text) == 0){
					data->properties.right_soft_key =TxtSoftBack;
					l_index=0;//for meue_up_down show from "a";2002-12-9
					l_opt = 0;
				}
				E2CInputShowUpdate( win_data );
			}else{
				data->properties.parent_callback( data->win, SET_CLEAR,0 );
			}
			 
		}
		break;

		case KCD_2:
		case KCD_3:
		case KCD_4:
		case KCD_5:
		case KCD_6:
		case KCD_7:
		case KCD_8:
		case KCD_9:
		{
			//If we  input first, softkey show delete
			data->properties.right_soft_key =TxtDelete;
		    ec_editEventKey( e, k );
			if(oldlen!=strlen(data->properties.edt_attr_input->text) ){
				E2CInputShowUpdate( win_data);
				oldlen=strlen(data->properties.edt_attr_input->text);
			}else{
				if(data->tim!= NULL)
					timStop(data->tim);
				timStart(data->tim);
			}
		}
		break;
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

static void	E2CInputShowUpdate(T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;
	int	len=strlen(data->properties.edt_attr_input->text);

	dspl_Clear(0,34,120,142);

	if(len<=1){
		displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
	}	
	if (len> 0){
		l_index =(dict_english_find(data->properties.edt_attr_input->text));
		l_opt = 0;
	}
	
	data->properties.parent_callback( data->win, WIN_UPDATE,0 );//hxl changed for back show selecting before 2002-12-9

}


/*******************************************************************************

 $Function:     C2EEdit_tim_cb

 $Description:  The  time out has occured 

 $Returns:    MFW_EVENT_CONSUMED always

 $Arguments:  e, event, tc timer context

*******************************************************************************/
static int C2EEdit_tim_cb( MfwEvt e, MfwTim *tc )
{
  T_MFW_HND win = mfw_parent(mfw_header());
  T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
  tDictStandard	*data		= (tDictStandard *) win_data->user;

  TRACE_EVENT("TestPrompt_tim_cb()");
  // stop running timer.
  if (data->tim != NULL ) {
    timStop(data->tim);
  }
	E2CInputShowUpdate( win_data);

  return MFW_EVENT_CONSUMED;
  
}

/*******************************************************************************

 $Function:     InputEngWordCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void InputEngWordCB( T_MFW_HND win, UBYTE reason, USHORT identifier)
{

    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("InputEngWordCB()");

    switch ( reason )
    {
        case SET_LEFT:
        {
        	if((strlen(data->properties.edt_attr_input->text) == 0)&&(l_opt==-1))//for select word don't show e2c err 2002-12-9
        		break;
    		l_index += l_opt;
    		l_opt = 0;//hxl 0220
      		data->dict->e2cshow_win=E2CShowWinEntry( win );
        }
    	break;

    	case SET_CLEAR:
        {
            /* Both right and clear can do the same task here
            */
            
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
        }
    	break;
    	case WIN_UPDATE://WIN_UPDATE printscreen
    	{
    		int i;
    		if(l_opt<=0){
				for(i=0;i<LIST_COL-3;i++)
					SetListItem(dict_eng((l_index+i)),2+i,l_opt==i);
    		}else{
				SetListItem(dict_eng((l_index+l_opt-1)),2+l_opt-1,0);
				SetListItem(dict_eng((l_index+l_opt)),2+l_opt,1);
				if(l_opt<LIST_COL-4)
					SetListItem(dict_eng((l_index+l_opt+1)),2+l_opt+1,0);
    		}
    		if(l_opt<2){
				dspl_Clear(0, 34, 120, 34);
				dspl_DrawLine(0, 34, 119, 34);
    		}
    	}
    	break;
    	case SET_KEY:
		{

			//If we  input first, softkey show delete
			data->properties.right_soft_key =TxtDelete;
			memset(data->properties.edt_attr_input->text ,'\0', WORD_MAX_LEN ); 
			edtChar( data->edt, DicteditAlpha[identifier-2]);
			
			E2CInputShowUpdate( win_data);
		}
    	break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }}

MfwHnd E2CShowWinEntry(T_MFW_HND win)
{
    tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("E2CShowWinEntry()");
	
	//l_e2cshow_input=0;
   
	DefaultParameters.text              = TxtEngToChn;
	DefaultParameters.left_soft_key	= TxtNull;//Changed text ,TxtDelete
	DefaultParameters.right_soft_key    = TxtSoftBack;//Changed text ,TxtDelete
	DefaultParameters.callback          = E2CShowCB;
	DefaultParameters.parent_callback	= InputEngWordCB;

	// allocate window, and if successful initialise it
	return E2CShowWinStart( win, &DefaultParameters );
    
}

/*******************************************************************************

 $Function:    	E2CShowWinStart

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND E2CShowWinStart (T_MFW_HND parent_window,tdictInputSpecifics *properties)
{
	T_MFW_HND win;

	TRACE_FUNCTION ("E2CShowWinStart()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = E2CShow_create( parent_window) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}


/*******************************************************************************

 $Function:    	E2CShow_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND E2CShow_create (T_MFW_HND parent_window)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("E2CShow_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) E2CShow_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) E2CShow_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL, (MfwCb) E2CShow_kbd_cb );

	/* And return the handle of the newly created window
	*/
    return data->win;

}





/*******************************************************************************

 $Function:    	E2CShow_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void E2CShow_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("E2CShow_destroy()");

	if (data)
	{
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}



/*******************************************************************************

 $Function:    	E2CShow_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int E2CShow_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("E2CShow_win_cb()");
	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtEngToChn)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEngToChn), 0xffffff );
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

/*******************************************************************************

 $Function:    	E2CShow_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void E2CShow_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("E2CShow_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{
			// Initialise the input window
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.callback		= properties->callback;
			data->properties.parent_callback  = properties->parent_callback;

			/* show the window
			*/
			winShow( data->win );
    		
		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			E2CShow_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	E2CShow_keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int E2CShow_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("E2CShow_kbd_cb()");
	/* Handle the key press
	*/
    switch (k->code)
    {
		case KCD_RIGHT:
		{
 		       l_opt = 0;//for back show selecting before 2002-12-9
			l_startline = 0;
			
            		data->properties.callback( data->win, SET_CLEAR );
		}
		break;
		case KCD_HUP:
		{
			T_MFW_HND parent_win = data->parent_win;
            data->properties.callback( data->win, SET_CLEAR );
            
            SEND_EVENT( parent_win, SET_DESTROY, 0, 0 );
            parent_win = 0;
		}
		break;
		case KCD_MNUUP:
		   	if(l_startline)
		   		l_startline--;//hxl try on the phone ,but phone poweron again
		   	else if(l_index>0)
		   		l_index--;
		    data->properties.callback( data->win, WIN_UPDATE);
		    break;
		    
		case KCD_MNUDOWN:
		{
			int i,j;
			char buf[57];
			i = strlen(dict_eng(l_index));
			j = strlen(dict_yb(l_index));
			/*
			if(j) {
				if(i<=14 && i+j>12)
					sprintf(buf,"%-14s<%s>",dict_eng(l_index),dict_yb(l_index));
				else
					sprintf(buf,"%s<%s>",dict_eng(l_index),dict_yb(l_index));
			} else
				sprintf(buf,"%s",dict_eng(l_index));
			for(i=0;GetListLine(buf,i);i++);*/
			for(i=0;GetListLine(dict_eng(l_index),i);i++);
			if(j)
				for(j=0;GetListLine(dict_yb(l_index),j);j++);
			
			if(GetListLine(dict_chn(l_index), l_startline+LIST_COL-2-i-j))
				l_startline++;
			else if(dict_eng(l_index+1)) {
				l_startline = 0;
				l_index++;
			}
			data->properties.callback( data->win, WIN_UPDATE);
		}
		break;
		case KCD_2:
		case KCD_3:
		case KCD_4:
		case KCD_5:
		case KCD_6:
		case KCD_7:
		case KCD_8:
		case KCD_9:
		{
			T_MFW_HND parentwin=data->parent_win;//delete for return one layer 2002-12-9
			USHORT kcode=k->code;
			//l_e2cshow_input=1;
            data->properties.parent_callback( parentwin, SET_KEY, kcode);
            data->properties.callback( data->win, SET_CLEAR );
            
			
		//	return MFW_EVENT_PASSED;
		}
		break;
		default:
			break;
    }
    
	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}




/*******************************************************************************

 $Function:     E2CShowCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void E2CShowCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("E2CShowCB()");
    
    switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			U8 omitflag=0;
			UINT32  OldBackColor;
			
		    dspl_Clear(0,18,120,142);

			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );

			if(l_index<0){
				SetListItem(MmiRsrcGetText(TxtNotFound),1,0);
			}
			else if(l_index>=0) {
				int engline,i,j;
				int ybline=0;
				char buf[29];//57
				char yb_buf[29];
				char test[20];
				memset(buf,0,29);
				memset(yb_buf,0,29);
		   		//get engline
		   		for(engline=0;GetListLine(dict_eng(l_index),engline);engline++);
		   		//get ybline
		   		yb_codeconvert(dict_yb(l_index),buf);
		   		j=strlen(buf);
		   		if(j){
		   			sprintf(yb_buf,"<%s>",buf);
		   			for(ybline=0;GetListLine(yb_buf,ybline);ybline++);
		   		}
		   		
		   		sprintf(test,"idx:%d",l_index);
		   		TRACE_EVENT(test);
		   		
			   	for(i=0;i<LIST_COL-2;i++) {
			   		if(GetListLine(dict_eng(l_index),l_startline+i)){
						SetListItem(GetListLine(dict_eng(l_index), l_startline+i),i+1,0);
			   		}else if(j&&GetListLine(yb_buf,l_startline+i-engline)){
			   			set_font_type(YB8X16_FONT);
						SetListItem(GetListLine(yb_buf, l_startline+i-engline),i+1,0);
			   		}else{
			   			SetListItem(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline),i+1,0);
			   		}
			   	}	
			   	if(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline))
					omitflag = 1;
    			if(omitflag) 
    				dspl_TextOut(0, (LIST_COL-1)*18, 0,"...");
			}
    	}
    	break;
    	case SET_CLEAR:
            /* Both right and clear can do the same task here
            */
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
    	break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
    }
}



/*******************************************************************************

 $Function:    	DictChnToEngEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int DictChnToEngEntry(MfwMnu *m, MfwMnuItem *i ) 
{
    T_MFW_HND win = mfw_parent(mfw_header());
	tdictInputSpecifics DefaultParameters;
	T_dict	*dict;

	TRACE_FUNCTION ("DictChnToEngEntry()");
	
	//init the parameter
	l_index=-2;
	l_startline = 0;
	l_opt = 0;
	MODE = CHN;
	
	/* allocate memory for our control block
	*/
	if ( ( dict = (T_dict *) ALLOC_MEMORY( sizeof( T_dict ) ) ) == NULL )
		return NULL;

    memset( dict->edt_buf_ChnWord, '\0', WORD_MAX_LEN+2 ); 

	//allocate window, and if successful initialise it
    if(C2EInput_Start( win, &DefaultParameters, dict )==NULL)
		FREE_MEMORY( (void *)dict, sizeof( T_dict ) );
    
	return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:    	C2EInput_Start

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND C2EInput_Start (T_MFW_HND parent_window,tdictInputSpecifics *properties ,T_dict *dict)
{
	T_MFW_HND win;

	TRACE_FUNCTION ("C2EInput_Start()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = C2EInput_create( parent_window ,dict) ) != NULL )
		DictChnEditEntry( win);
	
	return win;
}


/*******************************************************************************

 $Function:    	C2EInput_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND C2EInput_create (T_MFW_HND parent_window,T_dict *dict)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("C2EInput_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) C2EInput_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) C2EInput_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
 	data->dict					= dict;
	data->parent_win			= parent_window;

	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	C2EInput_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void C2EInput_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("C2EInput_destroy()");

	if (data)
	{
        editDeactivate();
		winDelete ( data->win );
		FREE_MEMORY( (void *)data->dict, sizeof( T_dict ) );
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
	}
}


/*******************************************************************************

 $Function:    	C2EInput_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int C2EInput_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("C2EInput_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			
			*/
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	C2EInput_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void C2EInput_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("C2EInput_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{
			/* Initialise the input window
			*/
		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			C2EInput_destroy( win );
		}
		break;
	}
}

int DictChnEditEntry(T_MFW_HND win)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
    T_dict			*dict		=data->dict;
 	T_EDITOR_DATA editor_data;

	TRACE_FUNCTION ("DictChnEditEntry()");
	
	dict_loadEditDefault(&editor_data);

	//editor_attr_init_only( &editor_data.editor_attr,0, 17, 120, 16, TITLE_TOP, TxtChnToEng, 
	//	dict->edt_buf_ChnWord,WORD_MAX_LEN+3,edtCurBar1,0);
	editor_attr_init_fullscr(&editor_data.editor_attr,1, TxtChnToEng, //hxl changed 2003-4-11
		dict->edt_buf_ChnWord,WORD_MAX_LEN+3,edtCurBar1);
	editor_data.LeftSoftKey          = TxtSoftOK;
	editor_data.RightSoftKey         = TxtDelete;
	editor_data.mode				 = PARADISE_MODE;
	editor_data.min_enter				=1;
	editor_data.edtInPbk			=0;
	editor_data.Callback             = (T_EDIT_CB)InputChnWordCB;
	editor_data.destroyEditor		 = FALSE;
	

	//allocate window, and if successful initialise it
    dict->editorwin =editor_start(win, &editor_data); /* start the editor */ 
	
	return MFW_EVENT_CONSUMED;

	
}

void dict_loadEditDefault(T_EDITOR_DATA *editor_data)
{
	    TRACE_FUNCTION ("dict_loadEditDefault()");

		editor_attr_init(&editor_data->editor_attr, NULL, edtCurBar1, 0, 0, 0);
		editor_data->hide 					= FALSE;
		editor_data->min_enter				= 1;  // Avoid to return empty strings
		editor_data->LeftSoftKey          = TxtSoftSelect;
		editor_data->RightSoftKey         = TxtSoftBack;
		editor_data->AlternateLeftSoftKey	= TxtNull;
		editor_data->TextId               = '\0';  
		editor_data->Identifier           =  0; 
		editor_data->TextString           = NULL;  
		editor_data->timeout			  = FOREVER;  // Avoid to return empty strings
		editor_data->mode                 = ALPHA_MODE;
		editor_data->Callback             = NULL;
		editor_data->destroyEditor        = TRUE ; 
}

/*******************************************************************************

 $Function:     InputChnWordCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void InputChnWordCB( T_MFW_HND win,  USHORT Identifier, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	
    switch ( reason )
    {
        case INFO_KCD_LEFT:
        {
			//editor_destroy(data->dict->editorwin);//edit win destroy
			//data->dict->editorwin = 0;
			
        	if(strlen(data->dict->edt_buf_ChnWord ) == 0)
        		break;
            //l_index = dict_chinese_find_first(data->dict->edt_buf_ChnWord );
            l_index=-2;
            DictShowInformation(win,0,TxtSearching,NULL,1000,search_chn,(T_VOID_FUNC)Dict_Inofrmation_cb);

        }
    	break;

    	case INFO_KCD_RIGHT:
    	case INFO_KCD_HUP:
        {
              TRACE_EVENT("hxl1");
          /* Both right and clear can do the same task here
            */
        
			editor_destroy(data->dict->editorwin);//edit win destroy
			data->dict->editorwin = 0;
			
            SEND_EVENT( win, SET_DESTROY, 0, 0 );//c2einput win destroy
            win = 0;
            TRACE_EVENT("hxl2");
        }
    	break;
    	case INFO_EDT_UPDATE:
        	if(strlen(data->dict->edt_buf_ChnWord ) == 0){
        		data->properties.left_soft_key=TxtNull;
        		data->properties.right_soft_key =TxtSoftBack;
			}else{
        		data->properties.left_soft_key=TxtSoftOK;
				data->properties.right_soft_key =TxtDelete;
			}
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
    	break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}

/*******************************************************************************

 $Function:    	C2EShowWinEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
MfwHnd C2EShowWinEntry(T_MFW_HND win,T_dict *dict)
{
    	tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("C2EShowWinEntry()");
	
	DefaultParameters.text              = TxtChnToEng;
	DefaultParameters.left_soft_key	= TxtNull;//Changed text ,TxtDelete
	DefaultParameters.right_soft_key    = TxtSoftBack;//Changed text ,TxtDelete
	DefaultParameters.callback          = C2EShowCB;

	// allocate window, and if successful initialise it
	return C2EShowWinStart( win, &DefaultParameters,dict );
    
}

/*******************************************************************************

 $Function:    	C2EShowWinStart

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND C2EShowWinStart (T_MFW_HND parent_window,tdictInputSpecifics *properties,T_dict *dict )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("C2EShowWinStart()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = C2EShow_create( parent_window ,dict) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}


/*******************************************************************************

 $Function:    	C2EShow_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND C2EShow_create (T_MFW_HND parent_window,T_dict *dict)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("C2EShow_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) C2EShow_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) C2EShow_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
	data->parent_win			= parent_window;
	data->dict					= dict;
	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL, (MfwCb) C2EShow_kbd_cb );
	data->tim		= timCreate(data->win,   1000,         (MfwCb) C2EShow_tim_cb);
	
	/* And return the handle of the newly created window
	*/

    return data->win;

}





/*******************************************************************************

 $Function:    	C2EShow_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void C2EShow_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("C2EShow_destroy()");

	if (data)
	{
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}



/*******************************************************************************

 $Function:    	C2EShow_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int C2EShow_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("C2EShow_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtChnToEng)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtChnToEng), 0xffffff );
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

/*******************************************************************************

 $Function:    	C2EShow_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void C2EShow_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("C2EShow_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{
			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key = properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );
			
    		
		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			C2EShow_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	C2EShow_keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int C2EShow_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("C2EShow_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
    	case KCD_RIGHT:
		{
			l_startline = 0;
            //if(l_index==-1)
               //	 timStop(data->tim);	
            
            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            data->win = 0;
		}
    	break;
    	case KCD_HUP:
		{
			T_MFW_HND parentwin=data->parent_win;//delete for return one layer 2002-12-9

			l_startline = 0;
            //if(l_index==-1)
               // timStop(data->tim);	
            
            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            data->win = 0;
			
            SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );//delete for return one layer 2002-12-9
            parentwin = 0;
		}
		break;
		case KCD_MNUUP:
		   	if(l_startline)
		   		l_startline--;
		   	else {
		   		int i;
				i = dict_chinese_find_back(data->dict->edt_buf_ChnWord);
				if(i>=0)
					l_index = i;
		   	}
			data->properties.callback( data->win, WIN_UPDATE);
		break;
		case KCD_MNUDOWN:
		{
			int i,j;
			char buf[57];
			i = strlen(dict_eng(l_index));
			j = strlen(dict_yb(l_index));
			/*
			if(j) {
				if(i<=14 && i+j>12)
					Sprintf(buf,"%-14s<%s>",dict_eng(l_index),dict_yb(l_index));
				else
					sprintf(buf,"%s<%s>",dict_eng(l_index),dict_yb(l_index));
			} else
				sprintf(buf,"%s",dict_eng(l_index));
			for(i=0;GetListLine(buf,i);i++);*/
			for(i=0;GetListLine(dict_eng(l_index),i);i++);
			if(j)
				for(j=0;GetListLine(dict_yb(l_index),j);j++);
				
			if(GetListLine(dict_chn(l_index), l_startline+LIST_COL-2-i-j))
				l_startline++;
			else {
				i = dict_chinese_find_next(data->dict->edt_buf_ChnWord);
				if(i>=0) {
					l_startline = 0;
					l_index = i;
				}
			}
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;
		default:
			break;
    }
	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     C2EShow_tim_cb

 $Description:  The  time out has occured 

 $Returns:    MFW_EVENT_CONSUMED always

 $Arguments:  e, event, tc timer context

*******************************************************************************/
static int C2EShow_tim_cb( MfwEvt e, MfwTim *tc )
{
  T_MFW_HND win = mfw_parent(mfw_header());
  T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
  tDictStandard	*data		= (tDictStandard *) win_data->user;
  T_MFW_HND parentwin=data->parent_win;
  
  TRACE_EVENT("C2EShow_tim_cb()");
  // stop running timer.
  if (data->tim != NULL ) {
    tim_delete (data->tim);
   // timStop(data->tim);
  }
  
  SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
  data->win = 0;
  
  //SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );
  //parentwin = 0;
	
  return MFW_EVENT_CONSUMED;
  
}

/*******************************************************************************

 $Function:     C2EShowCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void C2EShowCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	U8 omitflag=0;
	char	info[50];
	S16		idx;
	
    switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			UINT32 OldBackColor;
			
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
		    dspl_Clear(0,18,120,142);

			if(l_index<0){

				dspl_TextOut(16, 36, 0, MmiRsrcGetText(TxtNotFound));
				timStart(data->tim);
			}
			else if(l_index>=0) {
				int engline,i,j;
				int ybline=0;
				char buf[29];//57
				char yb_buf[29];
				memset(buf,0,29);
				memset(yb_buf,0,29);
		   		//get engline
		   		for(engline=0;GetListLine(dict_eng(l_index),engline);engline++);
		   		//get ybline
		   		yb_codeconvert(dict_yb(l_index),buf);
		   		j=strlen(buf);
		   		if(j){
		   			sprintf(yb_buf,"<%s>",buf);
		   			for(ybline=0;GetListLine(yb_buf,ybline);ybline++);
		   		}
		   		
			   	for(i=0;i<LIST_COL-2;i++) {
			   		if(GetListLine(dict_eng(l_index),l_startline+i)){
						SetListItem(GetListLine(dict_eng(l_index), l_startline+i),i+1,0);
			   		}else if(j&&GetListLine(yb_buf,l_startline+i-engline)){
						set_font_type(YB8X16_FONT);
						SetListItem(GetListLine(yb_buf, l_startline+i-engline),i+1,0);
			   		}else{
			   			SetListItem(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline),i+1,0);
			   		}
			   	}	
			   	if(GetListLine(dict_chn(l_index), l_startline+i-engline))
					omitflag = 1;
    			if(omitflag) 
    				dspl_TextOut(0, (LIST_COL-1)*18, 0,"...");
			}
    	}	
    	break;
    	case SET_CLEAR:
            /* Both right and clear can do the same task here
            */
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
    	break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
    }
}


int DictTestEntry(void)
{
    T_MFW_HND win = mfw_parent(mfw_header());
	tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("DictEngToChnEntry()");
	
	//init the parameter
	l_index=0;
	l_startline = 0;
	l_opt = 0;
	
	DefaultParameters.text				= TxtDictTest;
	DefaultParameters.left_soft_key     = TxtDictStart;
	DefaultParameters.right_soft_key    = TxtChange;
	DefaultParameters.callback          = TestStartCB;

	/* allocate window, and if successful initialise it
	*/
    TestStart_Init( win, &DefaultParameters );

	return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	TestStart_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND TestStart_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("TestStart_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = TestStart_create( parent_window ) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}

/*******************************************************************************

 $Function:    	TestStart_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND TestStart_create (T_MFW_HND parent_window)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("TestStart_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) TestStart_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) TestStart_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) TestStart_kbd_cb );

	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	TestStart_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void TestStart_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("TestStart_destroy()");

	if (data)
	{
     
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	TestStart_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int TestStart_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("TestStart_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtDictTest)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDictTest), 0xffffff );
		    dspl_Clear(0,96,120,142);
			l_test_true_cnt = 0;
		    l_opt = 0;
	        l_booktotal = dict_getTotalByBook(l_book[FFS_flashData.DictBookIndex]);
		    l_startline = 0;	  	
            //change the softkey
		    if(!l_opt) {
				data->properties.left_soft_key     = TxtDictStart;
				data->properties.right_soft_key    = TxtChange;
    		}else{
				data->properties.left_soft_key     = TxtNull;
				data->properties.right_soft_key    = TxtDictDone;
    		}
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	TestStart_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void TestStart_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("TestStart_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{
			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );
		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			TestStart_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int TestStart_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	char			ascrange[30];
	char			unirange[60];
	static			UBYTE	Ischange=0;
    TRACE_FUNCTION ("TestStart_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:
		{

            l_booktotal = dict_getTotalByBook(l_book[FFS_flashData.DictBookIndex]);
	        if(l_opt==1){ //in setting
 				//update config
				if(FFS_flashData.StartGroup>l_booktotal/FFS_flashData.WordEveryGroup)
					FFS_flashData.StartGroup=l_booktotal/FFS_flashData.WordEveryGroup;
                l_opt = 0;
		    	dspl_Clear(0,112,120,128);
            	//change the softkey
				data->properties.left_soft_key     = TxtDictStart;
				data->properties.right_soft_key    = TxtChange;
		    	data->properties.callback( data->win, WIN_UPDATE);
		    	break;
	        }

            l_indexofbook = FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup;
            l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
            l_opt = 0;
            GenTestOption();
            l_test_true_cnt = 0;
      		TestWinEntry( data->win );
		}
		break;

		case KCD_HUP:
		{
            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            data->win = 0;
		}
		break;

		case KCD_RIGHT:
		{
        	if(l_opt==0) {
                l_opt = 1;
             	//change the softkey
				data->properties.left_soft_key     = TxtDictDone;
             	if((l_index==2)&&(FFS_flashData.StartGroup>10)){
					data->properties.right_soft_key    = TxtDelete;
             	}else
					data->properties.right_soft_key    = TxtNull;
		    	data->properties.callback( data->win, WIN_UPDATE);
		    	if(l_index==2)
					Ischange=1;//for input
				if((l_opt==1)&&(l_index==2)){
					wstrcpy(unirange, MmiRsrcGetText(TxtRange));
					sprintf(ascrange,":(%d-%d)",1,l_booktotal/FFS_flashData.WordEveryGroup);
					wstrcat(unirange, ascrange);
		    		dspl_Clear(1,112,120,128);
					dspl_TextOut(1, 112, 0, unirange);
				}
				if((l_opt==1)&&(l_index==1)){
					wstrcpy(unirange, MmiRsrcGetText(TxtRange));
					strcpy(ascrange,":(10-100)");
					wstrcat(unirange, ascrange);
		    		dspl_Clear(1,112,120,128);
					dspl_TextOut(1, 112, 0, unirange);
				}
        	}else{
         		if(FFS_flashData.StartGroup>10){
       				FFS_flashData.StartGroup=FFS_flashData.StartGroup/10;
             		if(l_index==2)
						data->properties.right_soft_key    = TxtDelete;
         		}else
					data->properties.right_soft_key    = TxtNull;
		    	data->properties.callback( data->win, WIN_UPDATE);
        	}
		}
		break;
		case KCD_MNUUP:
		{
        	if(l_opt == 0) {
                l_index = (l_index+2)%3;
		    	data->properties.callback( data->win, WIN_UPDATE);
                break;
            }
			switch(l_index) {
				case 0:
					if(FFS_flashData.DictBookIndex > 0)
						FFS_flashData.DictBookIndex--;
					else
						FFS_flashData.DictBookIndex = sizeof(l_booktext)/sizeof(int)-1;
				break;
				case 1:
					FFS_flashData.WordEveryGroup = (FFS_flashData.WordEveryGroup+100)%100+10;
				break;
				case 2:
					FFS_flashData.StartGroup ++;
					FFS_flashData.StartGroup %= (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
				break;
			}
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;
		case KCD_MNUDOWN:
        	if(l_opt == 0) {
                l_index = ++l_index%3;
			    data->properties.callback( data->win, WIN_UPDATE);
                break;
            }
			switch(l_index) {
				case 0:
					if(FFS_flashData.DictBookIndex < sizeof(l_booktext)/sizeof(int)-1)
						FFS_flashData.DictBookIndex++;
					else 
						FFS_flashData.DictBookIndex = 0;
					break;
				case 1:
					FFS_flashData.WordEveryGroup = (FFS_flashData.WordEveryGroup+80)%100+10;
					break;
				case 2:
					FFS_flashData.StartGroup += (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
					FFS_flashData.StartGroup --;
					FFS_flashData.StartGroup %= (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
					break;
			}
		    data->properties.callback( data->win, WIN_UPDATE);
		break;
		case KCD_0:
		case KCD_1:
		case KCD_2:
		case KCD_3:
		case KCD_4:
		case KCD_5:
		case KCD_6:
		case KCD_7:
		case KCD_8:
		case KCD_9:
		{
			if(l_opt==0)
				break;
			switch(l_index) {
				case 1:
					if(k->code==0)
						FFS_flashData.WordEveryGroup = 100;
					else
						FFS_flashData.WordEveryGroup = k->code*10;
		    		data->properties.callback( data->win, WIN_UPDATE);
					break;
				case 2:
					if(Ischange){
						FFS_flashData.StartGroup=0;
						Ischange=0;
					}
					FFS_flashData.StartGroup=(FFS_flashData.StartGroup)*10+k->code ;
					if(FFS_flashData.StartGroup>l_booktotal/FFS_flashData.WordEveryGroup)
						FFS_flashData.StartGroup =(FFS_flashData.StartGroup)/10;
             		if((l_index==2)&&(FFS_flashData.StartGroup>10)){
						data->properties.right_soft_key    = TxtDelete;
             		}else
						data->properties.right_soft_key    = TxtNull;
             	
		    		data->properties.callback( data->win, WIN_UPDATE);
		    		
					break;
				default:
					break;
			}
		}
		break;
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     TestStartCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void TestStartCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
  switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			char buf[50];
			char tempbuf[20];
			UINT32 OldBackColor;
			
		    dspl_Clear(0,18,120,96);
		    
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );

			wstrcpy(buf,MmiRsrcGetText(TxtDictBook));
			wstrcat(buf,":");
			wstrcat(buf,MmiRsrcGetText(l_booktext[FFS_flashData.DictBookIndex]));
			SetListItem(buf, 1, l_index==0);
			
			wstrcpy(buf,MmiRsrcGetText(TxtWordEveryGroup));
			sprintf(tempbuf,":%d",FFS_flashData.WordEveryGroup);
			wstrcat(buf,tempbuf);
			SetListItem(buf, 2, l_index==1);
			
			wstrcpy(buf,MmiRsrcGetText(TxtStartGroup));
			if(FFS_flashData.StartGroup==0)
				sprintf(tempbuf,":%d",FFS_flashData.StartGroup+1);
			else
				sprintf(tempbuf,":%d",FFS_flashData.StartGroup);
			wstrcat(buf,tempbuf);
			SetListItem(buf, 3, l_index==2);
    	}
    	break;
        default:
	    break;
    }
}

/*******************************************************************************

 $Function:    	TestWinEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/

MfwHnd TestWinEntry(T_MFW_HND win)
{
    tdictInputSpecifics   DefaultParameters;
	T_dict	*dict;

	TRACE_FUNCTION ("TestWinEntry()");

    
	/* allocate memory for our control block
	*/
	if ( ( dict = (T_dict *) ALLOC_MEMORY( sizeof( T_dict ) ) ) == NULL )
		return NULL;
	
 /* Set up the default parameters for the input window
    */
	DefaultParameters.text				= TxtDictTest;
    if(!l_opt)
		DefaultParameters.left_soft_key	= TxtTip;
    else
		DefaultParameters.left_soft_key	= TxtSelect;
	DefaultParameters.right_soft_key    = TxtSoftBack;
	DefaultParameters.callback          = TestCB;

	/* allocate window, and if successful initialise it
	*/
	return Test_Init( win, &DefaultParameters ,dict);
	
}

/*******************************************************************************

 $Function:    	Test_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND Test_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties,T_dict *dict)
{
	T_MFW_HND win;

	TRACE_FUNCTION ("Test_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = Test_create( parent_window ,dict) ) != NULL ){
		dict->test_win=win;
		SEND_EVENT( win, SET_INIT, 0, properties );
	}else{
		FREE_MEMORY( (void *)dict, sizeof( T_dict) );
	}
		
	return win;
}

/*******************************************************************************

 $Function:    	Test_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND Test_create (T_MFW_HND parent_window,T_dict *dict)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("Test_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) Test_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) Test_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
 	data->dict					= dict;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) Test_kbd_cb );
	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	Test_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void Test_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("Test_destroy()");

	if (data)
	{
    
		winDelete ( data->win );
		FREE_MEMORY( (void *)data->dict, sizeof( T_dict ) );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	Test_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int Test_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("Test_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtDictTest)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDictTest), 0xffffff );
		    l_startline = 0;
		    //update the softkey
			if(!l_opt)
				data->properties.left_soft_key	= TxtTip;
    		else
				data->properties.left_soft_key	= TxtSelect;
    		
			data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	Test_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void Test_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("Test_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{
			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );

		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			Test_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int Test_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("Test_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:
      		data->dict->test_prompt_win=TestPromptWinEntry( data->win );
        break;

		case KCD_HUP:
		{
			T_MFW_HND	parentwin=data->parent_win;
            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            data->win = 0;
            SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );
            parentwin = 0;
		}
		break;

		case KCD_RIGHT:
		{
            l_index = 2;
            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            data->win = 0;
			 
		}
		break;
		case KCD_MNUUP:
		   	if(l_startline)
		   		l_startline--;
		   	else if(l_opt) {
	           	l_opt--;
	           	if(l_opt==0){
		       		//update the softkey
				    if(!l_opt)
						data->properties.left_soft_key	= TxtTip;
    				else
						data->properties.left_soft_key	= TxtSelect;
	           	}
		   	}
		    data->properties.callback( data->win, WIN_UPDATE);
        break;						
		case KCD_MNUDOWN:
			if(l_opt) {
		   		if(GetListLine(dict_chn(l_test_opt[l_opt-1]), l_startline+LIST_COL-3)) //if chinese not finish
		   			l_startline++;
   			    else if(l_opt<4) {//next word
   			        l_opt++;
   			        l_startline=0;
   			    }
       		} else {
		        l_opt++;
       			//update the softkey
		    	if(!l_opt)
					data->properties.left_soft_key	= TxtTip;
    			else
					data->properties.left_soft_key	= TxtSelect;
		   	}
		    data->properties.callback( data->win, WIN_UPDATE);
		break;
		
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:     TestCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void TestCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	U8 omitflag=0;

    switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			UINT32 OldBackColor;
			int i;
			char buf1[20];
			char buf2[20];
			char tempbuf[10];
			int engline;
			
		    dspl_Clear(0,18,120,142);
		    
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
			
			for(engline=0;GetListLine(dict_eng(l_index),engline);engline++);
			wstrcpy(buf1,MmiRsrcGetText(TxtDictQuestion));
			sprintf(tempbuf," %d:",l_indexofbook-FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup+1);
			wstrcat(buf1,tempbuf);
			sprintf(buf2,"(%c)",l_opt+'A'-1);
				
			for(i=0;i<LIST_COL-2;i++) {
				if(GetListLine(buf1,l_startline+i)){
					
					SetListItem(buf1,i+1,0);
				}else if(GetListLine(dict_eng(l_index),l_startline+i-1)){
					SetListItem(GetListLine(dict_eng(l_index), l_startline+i-1),i+1,0);
				}else if(l_opt){
					if(GetListLine(buf2,l_startline+i-engline-1)){
						SetListItem( buf2, i+1, 1);
					}else if(GetListLine(dict_chn(l_test_opt[l_opt-1]), l_startline+i-engline-2)){
						SetListItem(GetListLine(dict_chn(l_test_opt[l_opt-1]), l_startline+i-engline-2),i+1,0);
					}
				}
			}
			if(GetListLine(dict_chn(l_test_opt[l_opt-1]), l_startline+i-engline-2))
				omitflag = 1;
    		if((omitflag)&&(l_opt)) 
    			dspl_TextOut(0, (LIST_COL-1)*18, 0,"...");
    	}	
    	break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}

MfwHnd TestPromptWinEntry(T_MFW_HND win)
{
    tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("TestPromptWinEntry()");

    
 /* Set up the default parameters for the input window
    */
	DefaultParameters.text				= TxtDictTest;
	DefaultParameters.left_soft_key	    = TxtSoftOK;
	DefaultParameters.right_soft_key    = TxtNull;
	DefaultParameters.callback          = TestPromptCB;

	/* allocate window, and if successful initialise it
	*/
   return TestPrompt_Init( win, &DefaultParameters );
	
}

/*******************************************************************************

 $Function:    	TestPrompt_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND TestPrompt_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("TestPrompt_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = TestPrompt_create( parent_window ) ) != NULL ){
		SEND_EVENT( win, SET_INIT, 0, properties );
	}
	return win;
}

/*******************************************************************************

 $Function:    	TestPrompt_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND TestPrompt_create (T_MFW_HND parent_window)
{
    T_MFW_WIN		*parent_win_data    = ( (T_MFW_HDR *) parent_window )->data;
    tDictStandard     *parent_data        = (tDictStandard *) parent_win_data->user;
	T_dict			*dict               = parent_data->dict;
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("TestPrompt_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) TestPrompt_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) TestPrompt_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
 	data->dict					= dict;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) TestPrompt_kbd_cb );
	data->tim		= timCreate(data->win,   1000,         (MfwCb) TestPrompt_tim_cb);


    if(l_opt!=0) {
    	if(l_test_opt[l_opt-1]==l_index) { //true      
			l_test_true_cnt++;
			timSetTime(data->tim, 1000);
		}
		else
			timSetTime(data->tim, 10000);    
		}
	else 
		timSetTime(data->tim, 5000); 
        	
	timStart(data->tim);

	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	TestPrompt_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void TestPrompt_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("TestPrompt_destroy()");

	if (data)
	{
    
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	TestPrompt_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int TestPrompt_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("TestPrompt_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtDictTest)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDictTest), 0xffffff );
		    l_startline = 0;	  	
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	TestPrompt_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void TestPrompt_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("TestPrompt_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{

			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );

		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			TestPrompt_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int TestPrompt_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("TestPrompt_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:

        	if(l_opt==0) {
	            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            	data->win = 0;
                break;
            }
            l_indexofbook++;
            if(l_indexofbook == (FFS_flashData.StartGroup+1)*FFS_flashData.WordEveryGroup) {
	        	TestResultWinEntry( data->win );
            } else {
            	l_opt = 0;	
  		   		l_startline = 0;
		        l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
		        GenTestOption();
		        if(l_index==-1){
		        	TestResultWinEntry( data->win );
		        }else{
		            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
		            data->win = 0;
		        }
            }
        break;

		case KCD_HUP:
		{
            SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
            data->win = 0;
		}
		break;

		case KCD_MNUUP:
		   	if(l_startline)
		   		l_startline--;
		    data->properties.callback( data->win, WIN_UPDATE);
        break;						
		case KCD_MNUDOWN:
   			if(GetListLine(dict_chn(l_test_opt[l_opt-1]), l_startline+LIST_COL-3)) //if chinese not finish
   				l_startline++;
		    data->properties.callback( data->win, WIN_UPDATE);
					
		break;
		
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     TestPrompt_tim_cb

 $Description:  The  time out has occured 

 $Returns:    MFW_EVENT_CONSUMED always

 $Arguments:  e, event, tc timer context

*******************************************************************************/
static int TestPrompt_tim_cb( MfwEvt e, MfwTim *tc )
{
  T_MFW_HND win = mfw_parent(mfw_header());
  T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
  tDictStandard	*data		= (tDictStandard *) win_data->user;

  TRACE_EVENT("TestPrompt_tim_cb()");
  // stop running timer.
  if (data->tim != NULL ) {
    timStop(data->tim);
  }

  if(l_opt==0) {
  	SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
	data->win = 0;
    return MFW_EVENT_CONSUMED;
  }
  l_indexofbook++;
  if(l_indexofbook == (FFS_flashData.StartGroup+1)*FFS_flashData.WordEveryGroup) {
	TestResultWinEntry( data->win );
  } else {
    l_opt = 0;	
  	l_startline = 0;
	l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
	GenTestOption();
	if(l_index==-1){
		TestResultWinEntry( data->win );
	}else{
		SEND_EVENT( data->win, SET_DESTROY, 0, 0 );
		data->win = 0;
	}
  }
  return MFW_EVENT_CONSUMED;
  
}

/*******************************************************************************

 $Function:     TestPromptCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void TestPromptCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	U8 omitflag=0;

  	switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			char buf[50];
			UINT32 OldBackColor;
			
		    dspl_Clear(0,18,120,142);
		    
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
			
			if(l_opt==0) {
				int i;
				wstrcpy(buf,MmiRsrcGetText(TxtTestPrompt));
				for(i=0;i<LIST_COL-2;i++)
					SetListItem( GetListLine(buf,i),i+1, 0);
			} else {
				if(l_test_opt[l_opt-1]==l_index) {//true
//					sprintf(buf,"\n%s!",MmiRsrcGetText(TxtDictTrue));
					wstrcpy(buf,"\n");
					wstrcat(buf,MmiRsrcGetText(TxtDictTrue));
					wstrcat(buf,"!");
					SetListItem( buf, 1, 0);
				} else {
					int i;
					char tempbuf[10];
					for(i=0;i<4;i++)
						if(l_index == l_test_opt[i])
							break;
//					sprintf(buf,"%s!%s:(%c)",MmiRsrcGetText(TxtDictFalse),MmiRsrcGetText(TxtDictAnswer),i+'A');
					wstrcpy(buf,MmiRsrcGetText(TxtDictFalse));
					wstrcat(buf,"!");
					wstrcat(buf,MmiRsrcGetText(TxtDictAnswer));
					sprintf(tempbuf,":(%c)",i+'A');
					wstrcat(buf,tempbuf);
					SetListItem( buf, 1, 0);
					for(i=0;i<LIST_COL-3;i++)
						SetListItem(GetListLine(dict_chn(l_index), l_startline+i),i+2,0);
				   	if(GetListLine(dict_chn(l_index), l_startline+i))
						omitflag = 1;
				}
    			if(omitflag) 
	    			dspl_TextOut(0, (LIST_COL-1)*18, 0,"...");
			}
  		}
    	break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}

MfwHnd TestResultWinEntry(T_MFW_HND win)
{
    tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("TestResultWinEntry()");

    
 /* Set up the default parameters for the input window
    */
	DefaultParameters.text				= TxtDictTest;
	DefaultParameters.left_soft_key	= TxtNextGroup;//Changed text ,TxtDelete
	DefaultParameters.right_soft_key    = TxtSoftBack;//Changed text ,TxtDelete
	DefaultParameters.callback          = TestResultCB;

	/* allocate window, and if successful initialise it
	*/
   return TestResult_Init( win, &DefaultParameters );
	
}

/*******************************************************************************

 $Function:    	TestResult_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND TestResult_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("TestResult_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = TestResult_create( parent_window ) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}

/*******************************************************************************

 $Function:    	TestResult_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND TestResult_create (T_MFW_HND parent_window)
{
    T_MFW_WIN		*parent_win_data    = ( (T_MFW_HDR *) parent_window )->data;
    tDictStandard     *parent_data        = (tDictStandard *) parent_win_data->user;
	T_dict			*dict               = parent_data->dict;
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("TestResult_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) TestResult_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) TestResult_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
 	data->dict					= dict;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) TestResult_kbd_cb );

	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	TestResult_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void TestResult_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("TestResult_destroy()");

	if (data)
	{
    
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	TestResult_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int TestResult_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;

    TRACE_FUNCTION ("TestResult_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(TxtDictTest)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDictTest), 0xffffff );
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	TestResult_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void TestResult_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("TestResult_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{

			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );

		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			TestResult_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int TestResult_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("TestResult_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:
	    {
			T_MFW_HND	parentwin;
        	l_opt = 0;
			FFS_flashData.StartGroup ++;
			FFS_flashData.StartGroup %= (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
            l_indexofbook = FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup;
			l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);  
            GenTestOption();
            l_test_true_cnt = 0;
            //back to test
            parentwin=data->parent_win;
            
            
		    data->properties.callback( data->win, SET_DESTROY);
		    
            SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );
            parentwin = 0;
	    }
        break;

		case KCD_HUP:
		{
			//back to teststart
            T_MFW_HND	promptwin=data->parent_win;
            T_MFW_HND	testwin=data->dict->test_win;
            
		    data->properties.callback( data->win, SET_DESTROY);
		    
            SEND_EVENT( promptwin, SET_DESTROY, 0, 0 );
            promptwin = 0;
            SEND_EVENT( testwin, SET_DESTROY, 0, 0 );
            testwin = 0;
		}
		break;

		case KCD_RIGHT:
		{
            T_MFW_HND	promptwin=data->parent_win;
            T_MFW_HND	testwin=data->dict->test_win;
            
            
            l_index = 2;
            //back to teststart
		    data->properties.callback( data->win, SET_DESTROY);
		    
            SEND_EVENT( promptwin, SET_DESTROY, 0, 0 );
            promptwin = 0;
            SEND_EVENT( testwin, SET_DESTROY, 0, 0 );
            testwin = 0;
			 
		}
		break;
		
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     TestResultCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void TestResultCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	U8 omitflag=0;

    switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			char buf[15];
			int total;
			char tempbuf[10];
			UINT32 OldBackColor;
			
		    dspl_Clear(0,18,120,142);
		    
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
			
			total = l_indexofbook - FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup;
			wstrcpy(buf,MmiRsrcGetText(TxtDictTrue));
			sprintf(tempbuf,":%d",l_test_true_cnt);
			wstrcat(buf,tempbuf);
			SetListItem(buf,1,0);
			
			wstrcpy(buf,MmiRsrcGetText(TxtDictFalse));
			sprintf(tempbuf,":%d",total - l_test_true_cnt);
			wstrcat(buf,tempbuf);
			SetListItem(buf,2,0);
			
			wstrcpy(buf,MmiRsrcGetText(TxtDictScore));
			sprintf(tempbuf,":%d",l_test_true_cnt*100/total);
			wstrcat(buf,tempbuf);
			SetListItem(buf,3,0);
    	}
    	break;
    	case SET_DESTROY:
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
            break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}

/*******************************************************************************

 $Function:    	DictReciteECEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int DictReciteECEntry(void)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    tdictInputSpecifics DefaultParameters;
    
	TRACE_FUNCTION ("DictReciteECEntry()");

	//init the parameter
	l_index=0;
	l_startline = 0;
	l_opt = 0;
	l_test_true_cnt = 0;
	
	DefaultParameters.text				= TxtDictReciteEC;
	DefaultParameters.left_soft_key     = TxtDictStart;
	DefaultParameters.right_soft_key    = TxtChange;
	
	DefaultParameters.callback          = ReciteStartCB;

	/* allocate window, and if successful initialise it
	*/
    ReciteStart_Init( win, &DefaultParameters );

	return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	DictReciteCEEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int DictReciteCEEntry(void)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    tdictInputSpecifics DefaultParameters;
    
	TRACE_FUNCTION ("DictReciteECEntry()");

	//init the parameter
	l_index=0;
	l_startline = 0;
	l_opt = 0;
	l_test_true_cnt = 1;
	
	DefaultParameters.text				= TxtDictReciteCE;
	DefaultParameters.left_soft_key     = TxtDictStart;
	DefaultParameters.right_soft_key    = TxtChange;
	
	DefaultParameters.callback          = ReciteStartCB;

	/* allocate window, and if successful initialise it
	*/
    ReciteStart_Init( win, &DefaultParameters );

	return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	DictReciteListEntry

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int DictReciteListEntry(void)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    tdictInputSpecifics DefaultParameters;
    
	TRACE_FUNCTION ("DictReciteECEntry()");

	//init the parameter
	l_index=0;
	l_startline = 0;
	l_opt = 0;
	l_test_true_cnt = 2;
	
	DefaultParameters.text				= TxtDictReciteList;
	DefaultParameters.left_soft_key     = TxtDictStart;
	DefaultParameters.right_soft_key    = TxtChange;
	
	DefaultParameters.callback          = ReciteStartCB;

	/* allocate window, and if successful initialise it
	*/
    ReciteStart_Init( win, &DefaultParameters );

	return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	ReciteStart_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND ReciteStart_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("ReciteStart_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = ReciteStart_create( parent_window ) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}

/*******************************************************************************

 $Function:    	ReciteStart_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND ReciteStart_create (T_MFW_HND parent_window)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("ReciteStart_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) ReciteStart_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) ReciteStart_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) ReciteStart_kbd_cb );

	/* And return the handle of the newly created window
	*/
   return data->win;

}

/*******************************************************************************

 $Function:    	ReciteStart_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void ReciteStart_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("ReciteStart_destroy()");

	if (data)
	{
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	ReciteStart_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int ReciteStart_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;
	int	txtid=0;
    TRACE_FUNCTION ("ReciteStart_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			if(l_test_true_cnt==0)
				txtid=TxtDictReciteEC;
			else if(l_test_true_cnt==1)
				txtid=TxtDictReciteCE;
			else 
				txtid= TxtDictReciteList;
			
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(txtid)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(txtid), 0xffffff );
		    dspl_Clear(0,96,120,142);
		    l_opt = 0;
       		l_booktotal = dict_getTotalByBook(l_book[FFS_flashData.DictBookIndex]);
		    l_startline = 0;	  	
			//update the softkey
    		if(!l_opt) {
				data->properties.left_soft_key     = TxtDictStart;
				data->properties.right_soft_key    = TxtChange;
    		}else{
				data->properties.left_soft_key     = TxtNull;
				data->properties.right_soft_key    = TxtDictDone;
    		}
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	ReciteStart_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void ReciteStart_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("ReciteStart_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{

			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key = properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );

		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			ReciteStart_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int ReciteStart_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	char			ascrange[30];
	char			unirange[60];
	static			UBYTE	Ischange=0;

    TRACE_FUNCTION ("ReciteStart_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:
		{
            l_booktotal = dict_getTotalByBook(l_book[FFS_flashData.DictBookIndex]);
	        if(l_opt==1){ //in setting
 				//update config
				if(FFS_flashData.StartGroup>l_booktotal/FFS_flashData.WordEveryGroup)
					FFS_flashData.StartGroup=l_booktotal/FFS_flashData.WordEveryGroup;
                l_opt = 0;
		    	dspl_Clear(0,112,120,128);
            	//change the softkey
				data->properties.left_soft_key     = TxtDictStart;
				data->properties.right_soft_key    = TxtChange;
		    	data->properties.callback( data->win, WIN_UPDATE);
		    	break;
	        }

            l_indexofbook = FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup;
            l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
            l_opt = 0;
            
	      	ReciteWinEntry( data->win );
		}	    	
        break;

		case KCD_HUP:
		{
		    data->properties.callback( data->win, SET_CLEAR);
		}
		break;

		case KCD_RIGHT:
		{
        	if(l_opt==0) {
                l_opt = 1;
             	//change the softkey
				data->properties.left_soft_key     = TxtDictDone;
             	if((l_index==2)&&(FFS_flashData.StartGroup>10)){
					data->properties.right_soft_key    = TxtDelete;
             	}else
					data->properties.right_soft_key    = TxtNull;
		    	data->properties.callback( data->win, WIN_UPDATE);
		    	if(l_index==2)
					Ischange=1;//for input
				if((l_opt==1)&&(l_index==2)){
					wstrcpy(unirange, MmiRsrcGetText(TxtRange));
					sprintf(ascrange,":(%d-%d)",1,l_booktotal/FFS_flashData.WordEveryGroup);
					wstrcat(unirange, ascrange);
		    		dspl_Clear(1,112,120,128);
					dspl_TextOut(1, 112, 0, unirange);
				}
				if((l_opt==1)&&(l_index==1)){
					wstrcpy(unirange, MmiRsrcGetText(TxtRange));
					strcpy(ascrange,":(10-100)");
					wstrcat(unirange, ascrange);
		    		dspl_Clear(1,112,120,128);
					dspl_TextOut(1, 112, 0, unirange);
				}
        	}else{
         		if(FFS_flashData.StartGroup>10){
       				FFS_flashData.StartGroup=FFS_flashData.StartGroup/10;
             		if(l_index==2)
						data->properties.right_soft_key    = TxtDelete;
         		}else
					data->properties.right_soft_key    = TxtNull;
		    	data->properties.callback( data->win, WIN_UPDATE);
        	}
		}
		break;
		case KCD_MNUUP:
        	if(l_opt == 0) {
                l_index = (l_index+2)%3;
			    data->properties.callback( data->win, WIN_UPDATE);
                break;
            }
			switch(l_index) {
				case 0:
					if(FFS_flashData.DictBookIndex > 0)
						FFS_flashData.DictBookIndex--;
					else
						FFS_flashData.DictBookIndex = sizeof(l_booktext)/sizeof(int)-1;
				break;
				case 1:
					FFS_flashData.WordEveryGroup = (FFS_flashData.WordEveryGroup+100)%100+10;
				break;
				case 2:
					FFS_flashData.StartGroup ++;
					FFS_flashData.StartGroup %= (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
				break;
			}
		    data->properties.callback( data->win, WIN_UPDATE);
		break;
		case KCD_MNUDOWN:
        	if(l_opt == 0) {
                l_index = ++l_index%3;
			    data->properties.callback( data->win, WIN_UPDATE);
                break;
            }
			switch(l_index) {
				case 0:
					if(FFS_flashData.DictBookIndex < sizeof(l_booktext)/sizeof(int)-1)
						FFS_flashData.DictBookIndex++;
					else 
						FFS_flashData.DictBookIndex = 0;
					break;
				case 1:
					FFS_flashData.WordEveryGroup = (FFS_flashData.WordEveryGroup+80)%100+10;
					break;
				case 2:
					FFS_flashData.StartGroup += (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
					FFS_flashData.StartGroup --;
					FFS_flashData.StartGroup %= (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
					break;
			}
		    data->properties.callback( data->win, WIN_UPDATE);
		break;
		
		case KCD_0:
		case KCD_1:
		case KCD_2:
		case KCD_3:
		case KCD_4:
		case KCD_5:
		case KCD_6:
		case KCD_7:
		case KCD_8:
		case KCD_9:
		{
			if(l_opt==0)
				break;
			switch(l_index) {
				case 1:
					if(k->code==0)
						FFS_flashData.WordEveryGroup = 100;
					else
						FFS_flashData.WordEveryGroup = k->code*10;
		    		data->properties.callback( data->win, WIN_UPDATE);
					break;
				case 2:
					if(Ischange){
						FFS_flashData.StartGroup=0;
						Ischange=0;
					}
					FFS_flashData.StartGroup=(FFS_flashData.StartGroup)*10+k->code ;
					if(FFS_flashData.StartGroup>l_booktotal/FFS_flashData.WordEveryGroup)
						FFS_flashData.StartGroup =(FFS_flashData.StartGroup)/10;
             		if((l_index==2)&&(FFS_flashData.StartGroup>10)){
						data->properties.right_soft_key    = TxtDelete;
             		}else
						data->properties.right_soft_key    = TxtNull;
             	
		    		data->properties.callback( data->win, WIN_UPDATE);
		    		
					break;
				default:
					break;
			}
		}
		break;
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     ReciteStartCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void ReciteStartCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;

    TRACE_EVENT("ReciteStartCB()");
    
  	switch ( reason )
    {
    	case WIN_UPDATE:
    	{
			char buf[50];
			char tempbuf[10];
			UINT32 OldBackColor;
			
		    dspl_Clear(0,18,120,96);
		    
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
			
//			sprintf(buf,"%s:%s",MmiRsrcGetText(TxtDictBook),MmiRsrcGetText(l_booktext[FFS_flashData.DictBookIndex]));
			wstrcpy(buf,MmiRsrcGetText(TxtDictBook));
			wstrcat(buf,":");
			wstrcat(buf,MmiRsrcGetText(l_booktext[FFS_flashData.DictBookIndex]));
			SetListItem(buf, 1, l_index==0);
			
//			sprintf(buf,"%s:%d",MmiRsrcGetText(TxtWordEveryGroup),FFS_flashData.WordEveryGroup);
			wstrcpy(buf,MmiRsrcGetText(TxtWordEveryGroup));
			sprintf(tempbuf,":%d",FFS_flashData.WordEveryGroup);
			wstrcat(buf,tempbuf);
			SetListItem(buf, 2, l_index==1);
			
			wstrcpy(buf,MmiRsrcGetText(TxtStartGroup));
			if(FFS_flashData.StartGroup==0)
				sprintf(tempbuf,":%d",FFS_flashData.StartGroup+1);
			else
				sprintf(tempbuf,":%d",FFS_flashData.StartGroup);
			wstrcat(buf,tempbuf);
			SetListItem(buf, 3, l_index==2);
    	}
    	break;
    	case SET_CLEAR:
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
            break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}

MfwHnd ReciteWinEntry(T_MFW_HND win)
{
    tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("ReciteWinEntry()");

    
 /* Set up the default parameters for the input window
    */
    switch(l_test_true_cnt)
    {
    	case 0:
 			DefaultParameters.text				= TxtDictReciteEC;
    	break;
    	case 1:
 			DefaultParameters.text				= TxtDictReciteCE;
    	break;
    	case 2:
 			DefaultParameters.text				= TxtDictReciteList;
    	break;
    }
	DefaultParameters.left_soft_key	= TxtSoftOK;//Changed text ,TxtDelete
	DefaultParameters.right_soft_key    = TxtSoftBack;//Changed text ,TxtDelete
	DefaultParameters.callback          = ReciteCB;

	/* allocate window, and if successful initialise it
	*/
   return Recite_Init( win, &DefaultParameters );
	
}
/*******************************************************************************

 $Function:    	Recite_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND Recite_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("Recite_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = Recite_create( parent_window ) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}

/*******************************************************************************

 $Function:    	Recite_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND Recite_create (T_MFW_HND parent_window)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("Recite_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) Recite_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) Recite_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) Recite_kbd_cb );

	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	Recite_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void Recite_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("Recite_destroy()");

	if (data)
	{
    
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	Recite_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int Recite_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;
	int	txtid;
    TRACE_FUNCTION ("Recite_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			/* Window visible
			*/
			if(l_test_true_cnt==0)
				txtid=TxtDictReciteEC;
			else if(l_test_true_cnt==1)
				txtid=TxtDictReciteCE;
			else 
				txtid= TxtDictReciteList;
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(txtid)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(txtid), 0xffffff );
		    data->properties.callback( data->win, WIN_UPDATE);
		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	Recite_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void Recite_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("Recite_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{

			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key = properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );
			

		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			Recite_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int Recite_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;

    TRACE_FUNCTION ("Recite_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:

        	if(l_test_true_cnt==2)
                l_opt = 1;
            if(l_opt) {
               	l_indexofbook++;
                if(l_indexofbook == (FFS_flashData.StartGroup+1)*FFS_flashData.WordEveryGroup) {
			    	ReciteEndWinEntry( data->win );
			    	break;
                } else {
		            if(l_test_true_cnt!=2)
	              		l_opt = 0;	
  		   			l_startline = 0;
		            l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
		            if(l_index==-1){
				    	ReciteEndWinEntry( data->win );
				    	break;
		            }
             	}
            } else {
                l_opt = 1;
            }
		    data->properties.callback( data->win, WIN_UPDATE);
        break;

		case KCD_HUP:
		{
			T_MFW_HND	parentwin=data->parent_win;
		    data->properties.callback( data->win, SET_CLEAR);
		    
            SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );
            parentwin = 0;
		}
		break;

		case KCD_RIGHT:
		{
            l_index = 2;
		    data->properties.callback( data->win, SET_CLEAR);
			 
		}
		break;
		case KCD_MNUUP:
		   	if(l_startline)
		   		l_startline--;
		   	else if(l_indexofbook>FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup){
	            l_indexofbook--;
	           	if(l_test_true_cnt!=2)
					l_opt = 0;	
  		   		l_startline = 0;
		        l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
		        if(l_index==-1){
				    data->properties.callback( data->win, SET_CLEAR);
				    break;
		        }
		   	}
		    data->properties.callback( data->win, WIN_UPDATE);
		break;
		case KCD_MNUDOWN:
	    	if(l_test_true_cnt==2)
                l_opt = 1;
			if(l_opt)
			{
		   		int i;
		   		for(i=0;GetListLine(dict_eng(l_index),i);i++);
		   		if(GetListLine(dict_chn(l_index), l_startline+LIST_COL-2-i)) //if chinese not finish
		   			l_startline++;
		        else{
		        	l_indexofbook++;
		        	if(l_indexofbook == (FFS_flashData.StartGroup+1)*FFS_flashData.WordEveryGroup) {
			      		ReciteEndWinEntry( data->win );
			      		break;
					} else { //next word
 			    		//l_indexofbook++;
   			        	if(l_test_true_cnt!=2)
   			           		l_opt = 0;	
		  		   		l_startline = 0;
				    	l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]);
				    	if(l_index==-1){
				      		ReciteEndWinEntry( data->win );
				      		break;
				    	}
       				}
		        }
       		} else {
				l_opt = 1;
		   	}
		    data->properties.callback( data->win, WIN_UPDATE);
		break;
		
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     ReciteCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void ReciteCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	U8 omitflag=0;

    TRACE_EVENT("ReciteCB()");
    switch ( reason )
    {
    	case WIN_UPDATE:
			{
				
				int engline,i,j;
				int ybline=0;
				char buf[29];//57
				char yb_buf[29];
				UINT32 OldBackColor;
				char Idtext[50];
				memset(buf,0,29);
				memset(yb_buf,0,29);
				
		    	dspl_Clear(0,18,120,142);
			    
				displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
				
		   		for(engline=0;GetListLine(dict_eng(l_index),engline);engline++);
		   		//get ybline
		   		yb_codeconvert(dict_yb(l_index),buf);
		   		j=strlen(buf);
		   		if(j){
		   			sprintf(yb_buf,"<%s>",buf);
		   			for(ybline=0;GetListLine(yb_buf,ybline);ybline++);
		   		}
		   		
		   		switch(l_test_true_cnt) {
		   			case 0:
					   	for(i=0;i<LIST_COL-2;i++) {
					   		if(GetListLine(dict_eng(l_index),l_startline+i)){
								SetListItem(GetListLine(dict_eng(l_index), l_startline+i),i+1,0);
					   		}else if(l_opt){
								if(j&&GetListLine(yb_buf,l_startline+i-engline)){
			   						set_font_type(YB8X16_FONT);
									SetListItem(GetListLine(yb_buf, l_startline+i-engline),i+1,0);
			   					}else{
			   						SetListItem(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline),i+1,0);
			   					}
					   		}
					   	}
			   			if(l_opt&&GetListLine(dict_chn(l_index), l_startline+i-engline-ybline))
							omitflag = 1;
			   			break;
			   		case 1:
					   	for(i=0;i<LIST_COL-2;i++) {
					   		if(l_opt){
					   			if(GetListLine(dict_eng(l_index),l_startline+i))
									SetListItem(GetListLine(dict_eng(l_index), l_startline+i),i+1,0);
								else if(j&&GetListLine(yb_buf,l_startline+i-engline)){
			   						set_font_type(YB8X16_FONT);
									SetListItem(GetListLine(yb_buf, l_startline+i-engline),i+1,0);
			   					}else
			   						SetListItem(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline),i+1,0);
			   					
					   		}else{
					   			if(GetListLine(dict_eng(l_index),l_startline+i)){
								}else if(j&&GetListLine(yb_buf,l_startline+i-engline)){
			   					}else{
			   						SetListItem(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline),i+1,0);
			   					}
					   		}
					   	}
			   			if(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline))
							omitflag = 1;
			   			break;
			   		case 2:
					   	for(i=0;i<LIST_COL-2;i++) {
					   		if(GetListLine(dict_eng(l_index),l_startline+i))
								SetListItem(GetListLine(dict_eng(l_index), l_startline+i),i+1,0);
					   		else{
								if(j&&GetListLine(yb_buf,l_startline+i-engline)){
			   						set_font_type(YB8X16_FONT);
									SetListItem(GetListLine(yb_buf, l_startline+i-engline),i+1,0);
			   					}else{
			   						SetListItem(GetListLine(dict_chn(l_index), l_startline+i-engline-ybline),i+1,0);
			   					}
					   		}
					   	}
			   			if(l_opt&&GetListLine(dict_chn(l_index), l_startline+i-engline-ybline))
							omitflag = 1;
			   			break;
		   		}
    			if(omitflag) 
    				dspl_TextOut(0, (LIST_COL-1)*18, 0,"...");
    
			}
    	break;
    	case SET_CLEAR:
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
            break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}

MfwHnd ReciteEndWinEntry(T_MFW_HND win)
{
    tdictInputSpecifics DefaultParameters;

	TRACE_FUNCTION ("ReciteEndWinEntry()");

    
 /* Set up the default parameters for the input window
    */
    switch(l_test_true_cnt)
    {
    	case 0:
 			DefaultParameters.text				= TxtDictReciteEC;
    	break;
    	case 1:
 			DefaultParameters.text				= TxtDictReciteCE;
    	break;
    	case 2:
 			DefaultParameters.text				= TxtDictReciteList;
    	break;
    }
	DefaultParameters.left_soft_key	= TxtNextGroup;//Changed text ,TxtDelete
	DefaultParameters.right_soft_key    = TxtSoftBack;//Changed text ,TxtDelete
	DefaultParameters.callback          = ReciteEndCB;

	/* allocate window, and if successful initialise it
	*/
   return ReciteEnd_Init( win, &DefaultParameters );
	
}
/*******************************************************************************

 $Function:    	ReciteEnd_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND ReciteEnd_Init (T_MFW_HND parent_window,tdictInputSpecifics *properties )
{
	T_MFW_HND win;

	TRACE_FUNCTION ("ReciteEnd_Init()");

	/* allocate window, and if successful initialise it
	*/
	if ( ( win = ReciteEnd_create( parent_window ) ) != NULL )
		SEND_EVENT( win, SET_INIT, 0, properties );
	return win;
}

/*******************************************************************************

 $Function:    	ReciteEnd_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND ReciteEnd_create (T_MFW_HND parent_window)
{
	T_MFW_WIN		*win_data;
	tDictStandard	*data;

	TRACE_FUNCTION ("ReciteEnd_create()");

	/* allocate memory for our control block
	*/
	if ( ( data = (tDictStandard *) ALLOC_MEMORY( sizeof( tDictStandard ) ) ) == NULL )
		return NULL;

	/* Create the window if we can
	*/
	if ( ( data->win = win_create( parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB) ReciteEnd_win_cb ) ) == NULL )
	{
		FREE_MEMORY( (void *)data, sizeof( tDictStandard ) );
		return NULL;
	}

	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
    data->mmi_control.dialog	= (T_DIALOG_FUNC) ReciteEnd_dialog;
    data->mmi_control.data		= data;
    win_data					= ((T_MFW_HDR *)data->win)->data;
 	win_data->user				= (void *) data;
	data->parent_win			= parent_window;

	/* create keyboards and menus for our window
	*/
	data->kbd		= kbdCreate( data->win, KEY_ALL,            (MfwCb) ReciteEnd_kbd_cb );

	/* And return the handle of the newly created window
	*/
    return data->win;

}

/*******************************************************************************

 $Function:    	ReciteEnd_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void ReciteEnd_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN     *win  = ((T_MFW_HDR *) own_window)->data;
	tDictStandard *data = (tDictStandard *) win->user;

	TRACE_FUNCTION ("ReciteEnd_destroy()");

	if (data)
	{
    
		winDelete ( data->win );
		FREE_MEMORY( (void *) data, sizeof( tDictStandard ) );
	}
}

/*******************************************************************************

 $Function:    	ReciteEnd_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int ReciteEnd_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	tDictStandard *data = (tDictStandard *) win->user;
	int	txtid;
    TRACE_FUNCTION ("ReciteEnd_win_cb()");

	/* Handle the visible event, otherwise return MFW_EVENT_PASSED
	*/
	switch( event)
    {
        case MfwWinVisible:
		{
			UINT32 OldBackColor;
			/* Window visible
			*/
			if(l_test_true_cnt==0)
				txtid=TxtDictReciteEC;
			else if(l_test_true_cnt==1)
				txtid=TxtDictReciteCE;
			else 
				txtid= TxtDictReciteList;
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
           		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
			dspl_colorTextOut((120-8*wstrBitlen(MmiRsrcGetText(txtid)))/2, 1, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(txtid), 0xffffff );
			
		    dspl_Clear(0,18,120,142);
			
			displaySoftKeys( data->properties.left_soft_key, data->properties.right_soft_key );
			l_index = 2;
			SetListItem(MmiRsrcGetText(TxtGroupEnd),1,0);

		}
		break;

        default:
		{
			/* unabel to handle event, pass handling of event back up tree
			*/
			return MFW_EVENT_PASSED;
		}
    }

	/* if we get here, we have handled the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	ReciteEnd_dialog

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void ReciteEnd_dialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
	tdictInputSpecifics	*properties = (tdictInputSpecifics *) parameter;

    TRACE_FUNCTION ("ReciteEnd_dialog()");

	/* Handle the input event, ew only deal with initialise and
	   destroy of the window in here
	*/
    switch( event )
	{
		case SET_INIT:
		{

			/* Initialise the input window
			*/
			data->properties.text			= properties->text;
			data->properties.left_soft_key	= properties->left_soft_key;
			data->properties.right_soft_key	= properties->right_soft_key;
			data->properties.callback		= properties->callback;

			/* show the window
			*/
			winShow( data->win );
		}
		break;

		case SET_DESTROY:
		{
			/* destroy the input window
			*/
			ReciteEnd_destroy( win );
		}
		break;
	}
}

/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
 				
*******************************************************************************/

static int ReciteEnd_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win			= mfwParent( mfw_header() );
    T_MFW_WIN		*win_data	= ((T_MFW_HDR *) win)->data;
    tDictStandard	*data		= (tDictStandard *) win_data->user;
    T_dict          *dict       = data->dict;

    TRACE_FUNCTION ("ReciteEnd_kbd_cb()");

	/* Handle the key press
	*/
    switch (k->code)
    {
	    case KCD_OK:
	    case KCD_LEFT:
		case KCD_MNUDOWN:
        	l_opt = 0;
			FFS_flashData.StartGroup ++;
			FFS_flashData.StartGroup %= (l_booktotal+FFS_flashData.WordEveryGroup-1)/FFS_flashData.WordEveryGroup;
            l_indexofbook = FFS_flashData.StartGroup*FFS_flashData.WordEveryGroup;
			l_index = dict_getWordByBook(l_indexofbook,l_book[FFS_flashData.DictBookIndex]); 
		    data->properties.callback( data->win, SET_CLEAR);
        break;

		case KCD_HUP:
		{
			//back to recitestart
			T_MFW_HND	parentwin=data->parent_win;
		    data->properties.callback( data->win, SET_CLEAR);
		    
            SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );
            parentwin = 0;
		}
		break;

		case KCD_RIGHT:
		{
			T_MFW_HND	parentwin=data->parent_win;
            l_index = 2;
            
		    data->properties.callback( data->win, SET_CLEAR);
            SEND_EVENT( parentwin, SET_DESTROY, 0, 0 );
            parentwin= 0;
			 
		}
		break;
		
	    default:
			break;
    }

	/* always consume the event
	*/
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     ReciteEndCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

*******************************************************************************/

void ReciteEndCB( T_MFW_HND win, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	U8 omitflag=0;

    switch ( reason )
    {
    	case SET_CLEAR:
            SEND_EVENT( win, SET_DESTROY, 0, 0 );
            win = 0;
            break;
        default:
        {
            /* otherwise no action to be performed
            */
        break;
        }
  }
}


/*******************************************************************************

 $Function:    	dictSetEditAttributes

 $Description:	
 
    Sets up the edit attribute structure with the provided parameters

 $Returns:		None

 $Arguments:	winPx, winPy, winSx, winSy, positioning information
                fgColor, colour for foreground
				font, mode, controls, pretty much what they say
				*text, initial text to be edited
				size, of the text (in bytes)
				attr, the block to be set up with the other parameters
 
*******************************************************************************/

void dictSetEditAttributes(
    U16  winPx,   U16 winPy, U16 winSx, U16 winSy,
	U8   fgColor, U8  font,  U8  mode,  U8  *controls,
	char *text,   U16 size,
	MfwEdtAttr*   attr)
{
	/* Populate the structure with the parameters
	*/
	attr->win.px = winPx;
	attr->win.py = winPy;
	attr->win.sx = winSx;
	attr->win.sy = winSy;
	attr->fgColor = fgColor;
	attr->font = font;
	attr->mode = mode;
	attr->controls = controls;
	attr->text = text;
	attr->size = size;
}

static char *  GetListLine(char*buf,int line)
{
	int i;
	int linenum=0,linelen=0;
	int charlen=1;
	static char linebuf[32];//LIST_LEN,hxl changed for unicode
	unsigned char * puc;
	int buflen=0;
	BOOL IsUnicode=FALSE;//hxl add for unicode
	int Unicodelinelen=0,Unicodecharlen=0;

	if(buf==NULL)
		return NULL;
	if(buf==linebuf)
		return linebuf;
	puc = ( unsigned char *)buf;
	memset(linebuf,0,sizeof(linebuf));
//	for(i=0;i<(int)strlen((char*)buf);) {
	//hxl add for unicode-------------
	if(puc[0]==0x80){
		IsUnicode=TRUE;
		buflen=wstrlen((char*)buf);
	}else
		buflen=strlen((char*)buf);
	
	for(i=0;i<buflen;) {
		if(IsUnicode){
			if(i>0){
				Unicodecharlen=2;
				charlen = 2;
			}
			if(puc[i]==0x00)
				charlen = 1;
		}else{
	//end of hxl changed ----------------------

			if(puc[i]>=0xa1&&puc[i]<=0xfe) //if the char is GB2312 Chinese font, char len is two byte
				charlen = 2;
			else
				charlen = 1;
		}
		
		
		if(linelen+charlen>LIST_LEN-1) {//hxl ask:puc[i]==0x0D
			linenum++; 
			if(linenum>line)
				break;
			linelen = charlen;//hxl is it a new line start?
			if((IsUnicode)&&(i>0))
				Unicodelinelen=2;
		} else {
			linelen += charlen;
			if((IsUnicode)&&(i==0))
				linelen = 0;
			
			if((IsUnicode)&&(i>0))
				Unicodelinelen+=2;

		}

		if(linenum==line ) {
			if(IsUnicode){
					linebuf[0] = buf[0];
					linebuf[Unicodelinelen-Unicodecharlen+1] = buf[i];
					linebuf[Unicodelinelen-Unicodecharlen+2] = buf[i+1];
			}else{
//				if(buf[i]!=LIST_LEN-2)//------------hxl delete
				linebuf[linelen-charlen] = buf[i];
				if(charlen==2)
					linebuf[linelen-charlen+1] = buf[i+1];
			}
		}

//hxl add---------------
		if(IsUnicode){
			if(i>0)
				i+=2;
			else if(i==0)
				i+=1;
		}else
			//end of hxl add------------------
			i+=charlen;
	}
	if(linebuf[0])
		return linebuf;
	return NULL;
}

static void SetListItem( char*buf,int listnum,UBYTE invers)
{
	char* p = GetListLine(buf,0);
	dspl_Clear(0,(listnum%LIST_COL) *18,120,(listnum%LIST_COL) *18+18);
	if(p) {
		UBYTE attr = DSPL_TXTATTR_NORMAL;
		if(invers){
			attr = DSPL_TXTATTR_TRANSPARENT;
			dspl_BitBlt(menumid[FlashSettingData.theme].area.px, (listnum%LIST_COL) *18, menumid[FlashSettingData.theme].area.sx, menumid[FlashSettingData.theme].area.sy, 0, (void*)menumid[FlashSettingData.theme].icons, 0);
			dspl_colorTextOut(4 , (listnum%LIST_COL) *18+1, attr,p,0xffffff);
		}else
			dspl_TextOut(4 , (listnum%LIST_COL) *18+1, attr,p);
		TRACE_EVENT(p);
		//strcpy(l_list_item[listnum%LIST_COL],p);
	}
}

static S16 GenIndex(int range0,int range1,unsigned int rand)
{
	S16 v[2];
	U8  sign;
	U16 offset;
	sign = rand%2;
	offset = (rand/2)%(range1-range0)+range0;
	v[sign] = l_index+offset;
	v[(sign+1)%2] = l_index-offset;
	if(dict_eng(v[0]))
		return v[0];
	if(dict_eng(v[1]))
		return v[1];
	if(dict_eng(l_index+range0))
		return l_index+range0;
	if(dict_eng(l_index-range0))
		return l_index-range0;
	return l_index;
}
 const U16 range[][2] = {
 	2,51,
 	52,3401,
 	3402,6991
 };
static void GenTestOption(void)
{
	T_RTC_DATE_TIME timedate;
	unsigned int rand;
	unsigned int seed;
	unsigned int i;
	unsigned int first;
	const unsigned char * p;

	p = (const unsigned char*)dict_chn(l_index);
	for(;*p!=0&&*p<0xa1;p++);
	seed = (*p)*(*(p+1))*(*(dict_eng(l_index)))+l_index;
	
	RTC_GetDateTime(&timedate);
	rand = (timedate.minute*60+timedate.second)%3600;
	
	rand ^= seed;
	first = rand%4;
	l_test_opt[first] = l_index;
	for(i=0;i<3;i++) 
		l_test_opt[(first+i+1)%4]= GenIndex(range[i][0],range[i][1],rand);
}

void yb_codeconvert(char* in,char* out)
{
	int i=0;
	for(;i<strlen(in);i++) {
		switch(in[i]) {
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
				out[i] = (char)(in[i]-49);
				break;
			case 'c':
				out[i] = (char)25;
				break;
			case 'q':
				out[i] = (char)26;
				break;
			case 'x':
				out[i] = (char)27;
				break;
			case 'y':
				out[i] = (char)28;
				break;
			default:
				out[i]=in[i];
				break;
			}
		}
}


/*******************************************************************************

 $Function:     DictShowInformation

 $Description:  general information dialog routine

 $Returns:    none

 $Arguments:  parent, window,
                text, to be displayed,
                cb_function, call back on completion of window

*******************************************************************************/

static MfwHnd DictShowInformation( MfwHnd parent, int txtId, int txtId2, char *str, unsigned long time,USHORT identifier,T_VOID_FUNC cb_function )
{
    T_DISPLAY_DATA display_info;

	dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_RIGHT | KEY_HUP;
    display_info.TextId       = txtId;
    display_info.TextId2      = txtId2;
    display_info.TextString  ='\0' ;
    display_info.TextString2   =str ;
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey  = TxtSoftBack;
    display_info.Time         = time;
    display_info.Callback     = (T_VOID_FUNC) cb_function;
    display_info.Identifier    =identifier;
    switch(txtId2)
    {
     case TxtSearching:
     	display_info.iconindex=REMIND_WAITTING;
        break;
     case TxtNotFound:
     	display_info.iconindex=REMIND_NORECORD;
     	break;
      default:
        break;
    }
    if(identifier==searched_chn)
    	display_info.iconindex=REMIND_SUCCEED;
    // Call Info Screen    
    return info_dialog( parent, &display_info );
}


static int Dict_Inofrmation_cb(T_MFW_HND win, USHORT identifier, USHORT reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tDictStandard   *data       = (tDictStandard *) win_data->user;
	char	info[50];
	S16		idx;
 
	switch(reason)
	{
		case INFO_TIMEOUT:
		{
			switch (identifier)
			{
				case search_chn:
    			l_index = dict_chinese_find_total(data->dict->edt_buf_ChnWord, &idx);
				if(l_index==-1){
					DictShowInformation(win,0,TxtNotFound,NULL,500,searched_fail,(T_VOID_FUNC)Dict_Inofrmation_cb);
         			//C2EShowWinEntry( data->dict->editorwin ,data->dict);
				}else{
                    sprintf(info,"%d",(int)l_index);                   
                    wstrcat((char *)info, MmiRsrcGetText(TxtPhbkFind));
                    l_index=idx;
		            DictShowInformation(win,0,0,info,500,searched_chn,(T_VOID_FUNC)Dict_Inofrmation_cb);
				}
				break;
				case searched_chn:
         			C2EShowWinEntry( data->dict->editorwin ,data->dict);
				break;
				case searched_fail:
					break;
				default:	break;
			}
		}
		break;
		case INFO_KCD_RIGHT:
		case INFO_KCD_HUP:
		break;
		default:
			return MFW_EVENT_REJECTED;
	}
			
	return MFW_EVENT_CONSUMED;
}

