#ifndef _DEF_BMI_DICTMENU_H_
#define _DEF_BMI_DICTMENU_H_

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Supplementary services
 $File:		    Mmidict.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		hxl(Mobile Innovation)                                                         
 $Date:		    28/06/02                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This module provides the supplementary services functionality

  
********************************************************************************
 $History: Mmidict.h

	01/08/02 			huangxl creat.	
	   
 $End

*******************************************************************************/

#define CHN 0
#define ENG 1
#define WORD_MAX_LEN          14
#define DICT_ID_CHNEDIT			20

typedef enum
{
	SET_INIT,
	SET_LEFT,
	SET_RIGHT,
	SET_CLEAR,
	SET_DESTROY,
	WIN_UPDATE,
	SET_KEY
} tDictMessageEvents;


typedef struct T_dict_data
{
	T_MFW_HND			e2cshow_win;
	T_MFW_HND			test_win;
	T_MFW_HND			test_prompt_win;
	T_MFW_HND			editorwin;

	char				edt_buf_EngWord[WORD_MAX_LEN+3];
    MfwEdtAttr			edt_attr_EngWord;
	char				edt_buf_ChnWord[WORD_MAX_LEN+3];
	MfwEdtAttr			edt_attr_ChnWord;

} T_dict;


/* Each window uses a standard message block containing references
   to the keyboards, editors, menues etc.
*/
typedef struct _tdictInputSpecifics_
{
    int 		text;
    MfwEdtAttr	*edt_attr_input;
    int         left_soft_key;
    int         right_soft_key;
	short		abc;
    void		(* callback)( T_MFW_HND win,UBYTE reason );
    void		(* parent_callback)( T_MFW_HND win,UBYTE reason,USHORT identifier );
} tdictInputSpecifics;

typedef struct _tDictStandard_
{
	/* Standard elements which are consistent across all dict
	   window control blocks
	*/
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       edt;
    T_MFW_HND       tim;
	T_dict			 *dict;
	tdictInputSpecifics properties;

} tDictStandard;


static UBYTE MODE;

int DictEngToChnEntry(MfwMnu *m, MfwMnuItem *i );
int DictChnToEngEntry(MfwMnu *m, MfwMnuItem *i );

int DictReciteECEntry(void);
int DictReciteCEEntry(void);
int DictReciteListEntry(void);
int DictTestEntry(void);
#endif



