/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		memo
 $File:		    Mmimemo.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the main calculator functionality

  
********************************************************************************
 $History: MmiToolkit.c

    25/10/00			Original Condat(UK) BMI version.
    26/11/02            gdy add
       
 $End

*******************************************************************************/
/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"
    #include "GameDisplay.h"

#endif
#include "MmiBookShared.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
//#include "MmiStopwatch.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
//#include "Mminote.h"


#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"
#include "Td.h"
#include "mfw_ffs.h"
#include "GameDisplay.h"
#include "Mmismssend.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "Mmimemo.h"
//#include "bmieastapi.h"
#include "mmiusersymbolinput.h"
#include "mmitextinput.h"		/* 2003/12/04 sunsj */
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

#define MemoIndexNumber   30

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       editor_win;
    T_EDITOR_DATA   editor_data;
    USHORT event;
    uint8 text[MEMO_LEN];
}MemoData;

typedef enum
{
    MEMO_INIT=MemoIndexNumber,
    MEMO_COVER,
    MEMO_DELETEALL,
    MEMO_EXIT
}MEMOTYPE;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       editor_win;
    T_EDITOR_DATA   editor_data;
    ListMenuData*     menu_list_data;  
    int event;
    UBYTE position;
    int numberOfRecords;
}memoBrowseData;

typedef enum
{
    MEMOBROWSE_INIT=MemoIndexNumber+4,
    MEMOBROWSE_DELETE,
    MEMOBROWSE_EXIT
}MEMOBROWSE_TYPE;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;  
    T_MFW_HND       editor_win;
    T_EDITOR_DATA   editor_data;
    char string[MEMO_LEN];
}MemoChangeData;

typedef enum
{
    MEMOCHANGE_INIT=MemoIndexNumber+7,
    MEMOCHANGE_EXIT
}MEMOCHANGE_TYPE;

typedef struct
{
    int position;
}MemoIndexData;

typedef struct
{
    MemoIndexData Item[10];
}MemoIndex;

typedef struct
{
    char string[13];
}StringData;

typedef struct
{
    StringData item[10]; 
}String10;

String10 string_data;

static MfwMnuAttr memo_menuAttrib =
{
    0,
    &melody_menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};

T_MFW_HND memo_win=NULL;
MemoIndex MemoDataIndex;
static int position=0;
extern stopw_menuAttrib;
extern const unsigned char backgroundBit[];
extern const unsigned char iconRequire[];
extern T_call call_data;

static  T_MFW_HND   memo_create(MfwHnd parent_win);
static void         Memo_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
void                MemoSetEditor(T_MFW_HND win);
static void         MemoCB( T_MFW_HND win,USHORT Identifier,UBYTE reason);
void                Memo_destroy(T_MFW_HND own_window);
static int          cover_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
static T_MFW_HND    memoBrowse_create(MfwHnd parent_win);
static void         MemoBrowse_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
void                memoBrowse_destroy(T_MFW_HND own_window);
static void         MemoChangeCB( T_MFW_HND win,USHORT Identifier,UBYTE reason);
void                MemoList_cb(T_MFW_HND  Parent, ListMenuData * ListData);
void                MemoChangeSetEditor(T_MFW_HND win);
static void         MemoChange_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int          MemoChange_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_HND    MemoChange_create(MfwHnd parent_win);
static int          memoBrowse_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void                MemoDelete_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
void                positionChange();
void                MemoChange_destroy(T_MFW_HND own_window);
void                memo_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
void                memoBrowse_destroy1(T_MFW_HND own_window);

void                MemoIndexInit();

int memoAdd(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = memo_create(parent_win);

    TRACE_EVENT("memoAdd");    

    if( win NEQ NULL )
    {
        if( call_data.win )
        {
            call_data.win_memo=win;//zy 2003-04-01 if in call add memo
        }
        SEND_EVENT (win, MEMO_INIT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "" "ȫɾ" ڴ */
static T_MFW_HND memo_create(MfwHnd parent_win)
{
    MemoData* data = (MemoData *)ALLOC_MEMORY (sizeof (MemoData));
    T_MFW_WIN  * win;


    TRACE_EVENT("memo_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, 0);//(T_MFW_CB)browse_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)Memo_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;  

    return data->win;

}

/* "" "ȫɾ" ڵ¼ */
static void Memo_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    MemoData * data = (MemoData *) win_data->user;  
    int old_color,i,number;
    T_DISPLAY_DATA    display_info; 
    game_Line line;

    data->event=event;
    data->kbd=kbd_create(data->win,KEY_ALL,(T_MFW_CB)cover_kbd_cb);
    switch( event )
    {
    case MEMO_INIT:                     //Ӵڵĳʼ
        MemoSetEditor(win);//set editor with default attribute values			
        data->editor_data.Callback          = (T_EDIT_CB)MemoCB;
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            data->editor_win = text_input(win, &(data->editor_data));
        }
        else
        {
            data->editor_win = editor_start(win, &(data->editor_data));
        }
        // winShow(win);
        break;
    case MEMO_COVER:                    //ǵһ༭ڵĻص
		// 2004.3.10 WYJ modify embedded popup dialog
        draw_popup_background();
		/* 2004/05/25 sunsj modify */
		draw_icon_require();
		//dialog_drawPopIcon(POP_ICONREQUIRE);
		
		/* 2004/05/25 sunsj modify */
		ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtCover);

        displaySoftKeys(TxtSoftOK, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        break;
    case MEMO_DELETEALL:                //ȫɾڵĳʼ
        number=0;
        for( i=0;i<10;i++ )
        {
            if( (FFS_MemoData.item[i].text[0]!=0)&&(FFS_MemoData.item[i].position!=0) )
                number++;
        }
        if( !number )
        {
            dialog_info_init(&display_info);                    
            display_info.TextId2     =TxtNorecord;                  
            display_info.Time       = FOREVER;                 
            display_info.iconindex =REMIND_NORECORD;

            /*
             * Call Info Screen
             */
            info_dialog(win, &display_info);
            Memo_destroy(win);
            break;
        }
		// 2004.3.10 WYJ modify embedded popup dialog
        draw_popup_background();
		/* 2004/05/25 sunsj modify */
		draw_icon_require();
		//dialog_drawPopIcon(POP_ICONREQUIRE);
		
#if(MAIN_LCD_SIZE==4)
		ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtDeleteAll);
#elif(MAIN_LCD_SIZE==3)
        ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtDeleteAll);
#endif
        displaySoftKeys(TxtSoftOK,TxtSoftBack);    /*2003/12/12, wangyan modify*/
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        break;
    case MEMO_EXIT:
        Memo_destroy(win);
        break;
    }
}

/* "" "ȫɾ"ȷϼ */
static int cover_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_DISPLAY_DATA    display_info;
    MemoData * data = (MemoData *) win_data->user;
    int i;

    switch( keyboard->code )
    {
    case KCD_LEFT:       
        if( data->event==MEMO_COVER )         //ǵһ
        {
            memset(FFS_MemoData.item[MemoDataIndex.Item[1].position].text,0,MEMO_LEN);
            memcpy((char*)FFS_MemoData.item[MemoDataIndex.Item[1].position].text,(char*)data->text,MEMO_LEN);
            FFS_MemoData.item[MemoDataIndex.Item[1].position].position=10;
            flash_Memowrite();

            dialog_info_init(&display_info);                 
            display_info.TextId2     =TxtSaved;                   
            display_info.Time       = FOREVER;                   
            display_info.iconindex =REMIND_COMPLETE;

            display_info.Callback     = (T_VOID_FUNC)memo_dialog_cb;
            /*
             * Call Info Screen
             */

            info_dialog (data->win, &display_info);                                   
        }
        else if( data->event==MEMO_DELETEALL )    //ȫɾ
        {
            FlashMemoDataInitialise();
            flash_Memowrite();
            //if(!flash_Memowrite())
            {
                //MemoIndexInit();
                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = '\0';
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtDeleted;
                display_info.TextId      = '\0';
                display_info.Time       = FOREVER;

                display_info.Callback     = (T_VOID_FUNC)memo_dialog_cb;
                display_info.Identifier = 0;
                display_info.iconindex =REMIND_COMPLETE;
                /*
                 * Call Info Screen
                 */

                info_dialog (data->win, &display_info);                    
            }
        }
        Memo_destroy(win);
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        Memo_destroy(win);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}
/* ı */
void MemoSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    MemoData* data = (MemoData *) win_data->user;   

    memset(data->text,0,sizeof(data->text));
    editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtAdd, (char*)data->text, MEMO_LEN, edtCurBar1);
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings


    data->editor_data.Identifier        = 0xFFFF ; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = TRUE;
    data->editor_data.TextId               = '\0';                                                
    data->editor_data.LeftSoftKey       = TxtSoftOK;//comfirm

    data->editor_data.AlternateLeftSoftKey  = TxtNull;
    data->editor_data.RightSoftKey      = TxtDelete;
    data->editor_data.mode              = TEXTINPUT_MODE;       /* 2003/12/04 sunsj modify */
    data->editor_data.InputMode         = PINYIN_INPUT_MODE;    /* 2003/12/04 sunsj */
}
/* ༭Ļص */
static void MemoCB( T_MFW_HND win,USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    MemoData   *data       = (MemoData *) win_data->user;  
    int i=0,j=0;
    T_DISPLAY_DATA    display_info;

    TRACE_EVENT("MemoCB");

    switch( reason )
    {
    case INFO_KCD_LEFT: 
        //flash_Memoread();    		
        while( (FFS_MemoData.item[i].text[0]!=0)&&(i<10) )
        {
            if( j<FFS_MemoData.item[i].position )
                j=FFS_MemoData.item[i].position;
            i++;
        }
        if( i<10 )
        {
            TRACE_EVENT("i<10");
            memset(FFS_MemoData.item[i].text,0,sizeof(FFS_MemoData.item[i].text));
            memcpy((char*)FFS_MemoData.item[i].text,(char*)data->text,MEMO_LEN);
            FFS_MemoData.item[i].position=j+1;  
            flash_Memowrite();
            // if(!flash_Memowrite())
            {
                //MemoIndexInit();
                dialog_info_init(&display_info);                                    
                display_info.TextId2     =TxtSaved;                    
                display_info.Time       = FOREVER;
                display_info.Callback     = (T_VOID_FUNC)memo_dialog_cb;
                display_info.Identifier = 0;
                display_info.iconindex =REMIND_COMPLETE;
                /*
                 * Call Info Screen
                 */

                info_dialog (data->win, &display_info);
                //editor_destroy(data->editor_win);                    
                Memo_destroy(win);
            }
        }
        else
        {
            /* 2003/12/04 sunsj modify for new editor mode */
            //¼ ǵһ
            if( data->editor_data.mode == TEXTINPUT_MODE )
            {
                text_input_destroy(data->editor_win);
            }
            else
            {
                editor_destroy(data->editor_win);
            }
            data->editor_win=0;
            SEND_EVENT(win, MEMO_COVER, 0, 0);
        }
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        //editor_destroy(data->editor_win);
        Memo_destroy(win);
        break;
    }
}


void Memo_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    MemoData* data   = (MemoData*)win->user;

    TRACE_EVENT ("Memo_destroy()");

    if( data->editor_win )
    {
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            text_input_destroy(data->editor_win);
        }
        else
        {
            editor_destroy(data->editor_win);
        }
    }

    if( own_window )
    {
        /*
        * Delete WIN Handler
            */

        if( call_data.win&&call_data.win_memo )
        {
            call_data.win_memo=0;//zy 2003-04-01 if is incall destroy memo
        }
        win_delete (own_window);
        /*
        * Free Memory
        */   
        FREE_MEMORY ((void *)data, sizeof (MemoData));
    }
}


int memoBrowse(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = memoBrowse_create(parent_win);

    TRACE_EVENT("memoBrowse");      

    if( win NEQ NULL )
    {
        SEND_EVENT (win, MEMOBROWSE_INIT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "鿴" "ɾ"ڴ */
static T_MFW_HND memoBrowse_create(MfwHnd parent_win)
{
    T_MFW_WIN  * win;
    memoBrowseData* data = (memoBrowseData*)ALLOC_MEMORY (sizeof (memoBrowseData)); 


    TRACE_EVENT("memoBrowse");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)memoBrowse_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)MemoBrowse_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;  
    memo_win=data->win;

    winShow(data->win);
    return data->win;

}


static int  memoBrowse_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    memoBrowseData* data = (memoBrowseData *)win->user;

    if( data EQ NULL )
        return 0;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
            * Clear Screen
                */
            //dspl_ClearAll();                /*2003/12/12, wangyan modify*/
        }
        break;
    default:
        return 0;
    }
    return 1;
}


/* "鿴" "ɾ"¼menu_list */
static void MemoBrowse_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    memoBrowseData * data = (memoBrowseData *) win_data->user;
    T_DISPLAY_DATA    display_info; 
    int i;

    TRACE_EVENT("MemoBrowse_DialogCB");
    data->event=event;
    TraceInt(data->event);
    switch( event )
    {
    case MEMOBROWSE_INIT:
    case MEMOBROWSE_DELETE:         
        data->numberOfRecords=0;
        for( i=0;i<10;i++ )
        {
            if( (FFS_MemoData.item[i].text[0]!=0)&&(FFS_MemoData.item[i].position!=0) )
                data->numberOfRecords++;
        }
        TraceInt(data->numberOfRecords);
        if( data->numberOfRecords )
        {
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( data->menu_list_data == 0 )
            {
                TRACE_EVENT("Failed memory alloc 1 ");
                return;
            }

            data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( data->numberOfRecords * sizeof(T_MFW_MNU_ITEM) );

            if( data->menu_list_data->List == 0 )
            {
                TRACE_EVENT("Failed memory alloc 2");
                return;
            }

            for( i = 0; i < data->numberOfRecords; i++ )
            {
                if( FFS_MemoData.item[i].text[0]!=0 )
                {
                    memset(string_data.item[i].string,0,13);
                    memcpy(&string_data.item[i].string,&FFS_MemoData.item[i].text,13);
                    data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_LISTCOMMON, 0);//&colist;     /* 2004/06 sunsj modify for icon manage */
                    data->menu_list_data->List[i].exta = 0;
                    data->menu_list_data->List[i].edit = 0;
                    data->menu_list_data->List[i].menu =0;
                    data->menu_list_data->List[i].func = NULL;  
                    data->menu_list_data->List[i].str  =(char*)string_data.item[i].string;                            
                    data->menu_list_data->List[i].flagFunc = item_flag_none;    
                }
            }
            if( data->event==MEMOBROWSE_INIT )
            {
                data->menu_list_data->LeftSoftKey = TxtChange;
                data->menu_list_data->ListMenuHeadStr =MmiRsrcGetText(TxtBrowse);
            }
            else
            {
                data->menu_list_data->LeftSoftKey = TxtDelete;
                data->menu_list_data->ListMenuHeadStr =MmiRsrcGetText(TxtDeleteOnebyOne);
            }
            data->menu_list_data->ListLength =data->numberOfRecords;
            data->menu_list_data->ListPosition = 1;
            data->menu_list_data->CursorPosition = 1;
            data->menu_list_data->SnapshotSize = data->numberOfRecords;
            data->menu_list_data->Font = 0;               
            data->menu_list_data->RightSoftKey = TxtSoftBack;
            data->menu_list_data->KeyEvents = KEY_ALL;
            data->menu_list_data->Reason = 0;
            data->menu_list_data->Strings = TRUE;
            data->menu_list_data->Attr   = &memo_menuAttrib;
            data->menu_list_data->autoDestroy    = TRUE;               //2004.4.21 WYJ MI18800000298
            data->menu_list_data->ListMenuFlag  =1;               
            listDisplayListMenu(win, data->menu_list_data,(ListCbFunc)MemoList_cb,0); 
        }
        else
        {
            dialog_info_init(&display_info);                  
            display_info.TextId2     =TxtNorecord;                  
            display_info.Time       = FOREVER;                 
            display_info.iconindex =REMIND_NORECORD;
            /*
            * Call Info Screen
            */
            info_dialog (win, &display_info);
            memoBrowse_destroy1(win);
        }
        break;      
    case MEMOBROWSE_EXIT:
        memoBrowse_destroy(win);
        break;
    }
}
/* "鿴" "ɾ"Ĳ˵ص */
void MemoList_cb(T_MFW_HND  Parent, ListMenuData * ListData)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *)Parent)->data;
    memoBrowseData * data     = (memoBrowseData *)win_data->user;  
    T_MFW_HND  win=data->win;
    T_MFW_HND change_win;
    T_DISPLAY_DATA    display_info;

    TRACE_EVENT("MemoList_cb");
    TraceInt(data->event);
    if( data->event==MEMOBROWSE_INIT )        //"鿴"
    {
        if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
            || (ListData->Reason EQ LISTS_REASON_HANGUP) )
        {
            TRACE_EVENT("LISTS_REASON_BACK");
            //listsDestroy(data->menu_list_data->win); 2004.4.21 WYJ MI18800000298
            memoBrowse_destroy(memo_win);                  
        }
        else if( (ListData->Reason EQ LISTS_REASON_SELECT) || (ListData->Reason EQ LISTS_REASON_OK) ) //xsf add (ListData->Reason EQ LISTS_REASON_OK) 03.10
        {   

            TRACE_EVENT("LISTS_REASON_SELECT");                
            position=ListData->ListPosition; 
            //listsDestroy(data->menu_list_data->win); 2004.4.21 WYJ MI18800000298		
            memoBrowse_destroy(memo_win);         //2004.2.27 WYJ 
            change_win=MemoChange_create(Parent); //2004.2.27 WYJ
            if( change_win NEQ NULL )
                SEND_EVENT(change_win, MEMOCHANGE_INIT, 0, 0);
        }
    }
    else if( data->event==MEMOBROWSE_DELETE ) //"ɾ"
    {
        if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
            || (ListData->Reason EQ LISTS_REASON_HANGUP) )
        {
            //listsDestroy(data->menu_list_data->win); 2004.4.21 WYJ MI18800000298
            memoBrowse_destroy(memo_win);                  
        }
        else if( (ListData->Reason EQ LISTS_REASON_SELECT) || (ListData->Reason EQ LISTS_REASON_OK) ) //xsf add (ListData->Reason EQ LISTS_REASON_OK) 03.10
        {
            FFS_MemoData.item[ListData->ListPosition].position=0;
            memset(FFS_MemoData.item[ListData->ListPosition].text,0,sizeof(MEMO_LEN)); 

            flash_Memowrite();                
            dialog_info_init(&display_info);                
            display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = TxtSoftBack;
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2     =TxtDeleted;
            display_info.TextId      = '\0';
            display_info.Time       = FOREVER;
            display_info.Callback     = (T_VOID_FUNC)NULL;//MemoDelete_dialog_cb;
            display_info.iconindex = REMIND_COMPLETE;
            display_info.Identifier =0;
            /*
            * Call Info Screen
            */
            info_dialog (data->win, &display_info);                 
            positionChange();               //м¼   
            //listsDestroy(data->menu_list_data->win); 2004.4.21 WYJ MI18800000298
            memoBrowse_destroy(memo_win);
        }
    }
}

/* ɾԼ¼ĵ */
void positionChange()
{
    int i,j,k=0;
    Flash_Memo t;

    for( i=9;i>0;i-- )
    {
        if( !k )
        {
            k=1;                            //־ ûнĻͲ
            for( j=0;j<i;j++ )
            {
                if( (FFS_MemoData.item[j].text[0]==0)&&(FFS_MemoData.item[j+1].text[0]!=0) )
                {
                    memset(&t,0,sizeof(Flash_Memo));
                    t.position=FFS_MemoData.item[j].position;
                    FFS_MemoData.item[j].position=FFS_MemoData.item[j+1].position;
                    FFS_MemoData.item[j+1].position=t.position;
                    wstrcpy(t.text,FFS_MemoData.item[j].text);
                    wstrcpy(FFS_MemoData.item[j].text,FFS_MemoData.item[j+1].text);
                    wstrcpy(FFS_MemoData.item[j+1].text,t.text);               
                    k=0;
                }
            }
        }
    }
}

void memoBrowse_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    memoBrowseData* data   = (memoBrowseData*)win->user;

    TRACE_EVENT ("memoBrowse_destroy()");

    memo_win=NULL;
    if( own_window )
    {
        /*
        * Delete WIN Handler
            */


        win_delete (own_window);
        /*
        * Free Memory
        */      
        FREE_MEMORY((void*)data->menu_list_data->List,data->numberOfRecords*sizeof(T_MFW_MNU_ITEM));
        FREE_MEMORY((void*)data->menu_list_data,sizeof(ListMenuData));   
        FREE_MEMORY ((void *)data, sizeof(memoBrowseData));  
    }
}


void memoBrowse_destroy1(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    memoBrowseData* data   = (memoBrowseData*)win->user;

    TRACE_EVENT ("memoBrowse_destroy()");

    memo_win=NULL;
    if( own_window )
    {
        /*
        * Delete WIN Handler
            */


        win_delete (own_window);
        /*
        * Free Memory
        */   
        FREE_MEMORY ((void *)data, sizeof(memoBrowseData));  
    }
}


int memoDeleteAll(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = memo_create(parent_win);

    TRACE_EVENT("memoDeleteAll");  

    if( win NEQ NULL )
    {
        SEND_EVENT (win, MEMO_DELETEALL, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
int memoOnebyone(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = memoBrowse_create(parent_win);

    TRACE_EVENT("memoOnebyone");   

    if( win NEQ NULL )
    {
        SEND_EVENT (win, MEMOBROWSE_DELETE, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}

void MemoChange_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    MemoChangeData* data   = (MemoChangeData*)win->user;

    TRACE_EVENT ("MemoChange_destroy()");


    if( own_window )
    {
        /*
        * Delete WIN Handler
            */


        win_delete (own_window);
        /*
        * Free Memory
        */
        flash_Memowrite();
        FREE_MEMORY ((void *)data, sizeof (MemoChangeData));
    }
}

static T_MFW_HND MemoChange_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    MemoChangeData* data = (MemoChangeData *)ALLOC_MEMORY (sizeof (MemoChangeData ));

    TRACE_EVENT("stopwEditor_create");

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)MemoChange_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)MemoChange_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;   

    winShow(win);
    return data->win;
}

static void MemoChange_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    MemoChangeData* data = (MemoChangeData *) win_data->user;

    switch( event )
    {
    case MEMOCHANGE_INIT:
        MemoChangeSetEditor(win);
        data->editor_data.Callback          = (T_EDIT_CB)MemoChangeCB;
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            data->editor_win = text_input(win, &(data->editor_data));
        }
        else
        {
            data->editor_win = editor_start(win, &(data->editor_data));
        }
        //winShow(win);
        break;
    case MEMOCHANGE_EXIT:
        MemoChange_destroy(win);
        break;
    }
}

static int  MemoChange_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    MemoChangeData* data = (MemoChangeData *)win->user;
    T_DISPLAY_DATA display_info;
    char str[4];

    TRACE_EVENT ("stopwEditor_win_cb()");


    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
            * Clear Screen
                */
            dspl_ClearAll();                
        }
        break;
    default:
        return 0;
    }
    return 1;
}

/* ޸ļ¼༭Ļص */
static void MemoChangeCB( T_MFW_HND win,USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    MemoChangeData   *data       = (MemoChangeData *) win_data->user;      
    T_DISPLAY_DATA    display_info;

    TRACE_EVENT("MemoCB");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        memset(FFS_MemoData.item[position].text,0,MEMO_LEN);
        memcpy(FFS_MemoData.item[position].text,data->string,MEMO_LEN);
        flash_Memowrite();

        dialog_info_init(&display_info);
        display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = TxtSoftBack;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';
        display_info.TextId2     =TxtSaved;
        display_info.TextId      = '\0';
        display_info.Time       = FOREVER;

        display_info.Callback     = (T_VOID_FUNC)memo_dialog_cb;
        display_info.Identifier = 0;
        display_info.iconindex =REMIND_COMPLETE;
        /*
        * Call Info Screen
        */

        info_dialog (data->win, &display_info);    
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            text_input_destroy(data->editor_win);
        }
        else
        {
            editor_destroy(data->editor_win);
        }
        MemoChange_destroy(win);
        //memoBrowse_destroy(memo_win); 	//2004.2.27 WYJ 
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP: 
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            text_input_destroy(data->editor_win);
        }
        else
        {
            editor_destroy(data->editor_win);
        }
        MemoChange_destroy(win); 
        //memoBrowse_destroy(memo_win);		//2004.2.27 WYJ
        break;
    }

}

void memo_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    //MemoIndexInit();
}

void MemoDelete_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    MemoChangeData * data       = (MemoChangeData *) win_data->user;     
}
/* "鿴"->޸ļ¼ı༭ */
void MemoChangeSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    MemoChangeData* data = (MemoChangeData *) win_data->user;   

    TRACE_EVENT("MemoChangeSetEditor");
    memset((char*)data->string,0,MEMO_LEN);
    memcpy((char*)data->string,(char*)FFS_MemoData.item[position].text,MEMO_LEN);   
    editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtChange, (char*)data->string, MEMO_LEN, edtCurBar1);   
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings


    data->editor_data.Identifier        = 0xFFFF ; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = TRUE;

    data->editor_data.TextId               = '\0';                                                
    data->editor_data.LeftSoftKey       = TxtSoftConfirm;//comfirm

    data->editor_data.AlternateLeftSoftKey  = TxtNull;
    data->editor_data.RightSoftKey      = TxtDelete;
    data->editor_data.mode              = TEXTINPUT_MODE;       /* 2003/12/04 sunsj modify */
    data->editor_data.InputMode         = PINYIN_INPUT_MODE;    /* 2003/12/04 sunsj */
}






















