/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		schedule
 $File:		    Mmischedule.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the main calculator functionality

  
********************************************************************************
 $History: MmiToolkit.c

    25/10/00			Original Condat(UK) BMI version.
    14/08/02            gdy add
    27/08/02            gdy add
       
 $End

*******************************************************************************/
/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define CLEAR_BOTTOM_ZONE dspl_Clear( KEY_AREA );
#define ENTITY_MFW

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"
    #include "GameDisplay.h"

#endif
#include "MmiBookShared.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "MmiSmsidle.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
//#include "MmiStopwatch.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
//#include "Mminote.h"
#include "Mmitoolkit_timer.h"


#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"
#include "Td.h"
#include "mfw_ffs.h"
#include "GameDisplay.h"
#include "Mmismssend.h"
#include "Mmismsmenu.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "Mmischedule.h"
//#include "bmieastapi.h"
#include "mmiusersymbolinput.h"
#include "mmitextinput.h"		/* 2003/12/04 sunsj */

//wyj 2003.11.11
#include "TdDisplay.h"

//yhf 2004.05.17
//#include "mmiicnother.h"

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND          win;
    T_MFW_HND       info_tim;
    T_MFW_HND       kbd;
    T_EDITOR_DATA   editor_data;
    T_MFW_HND editor_win;
    T_MFW_HND menu_options_win;
    TIMEDATE * calin;
    MONTHTABLE * month_table;
    int year;
    int month;
    int day;
    int wday;
}tddata;

typedef enum
{
    TD_INIT,
    TD_EXIT
}td_event;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND          win;
    T_MFW_HND       info_tim;
    T_MFW_HND       kbd;
    T_EDITOR_DATA   editor_data;
    T_MFW_HND editor_win;
    T_MFW_HND editor_handle;
    T_MFW_HND menu_options_win;
    T_MFW_HND menu_options_win1;
    MfwEdtAttr editAttr;
    char time[6];
    int index;
}schedule_data;

typedef enum
{
    SCHE_INIT,
    SCHE_EDIT,
    SCHE_EXIT
}sche_event;

typedef enum
{
    TR_TIME,
    TR_RING,
    TR_EXIT
}tr_event;



typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND          win;
    T_MFW_HND       kbd;
    T_MFW_HND editor_handle;
    T_MFW_HND menu_options_win;
    MfwEdtAttr editAttr;
    char time[8];
    int index;
    int id;
    BOOL AMANDPM;
    BOOL position;
}TR_data;


typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND          win;
    T_MFW_HND       kbd;
    T_MFW_HND editor_win;
    T_EDITOR_DATA   editor_data;
    T_MFW_HND menu_options_win;
    int index;
    int id;
    int count;
    int flag;
    int flag1;
}ScheBrowse_data;

typedef enum
{
    SCHEBROWSE_TODAY,
    SCHEBROWSE_ALL,
    SCHEBROWSE_EXIT
}ScheBrowse_event;


typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND          win;
    T_MFW_HND       kbd;
    T_MFW_HND editor_win;
    T_EDITOR_DATA   editor_data;
    ScheBrowse_data * data1;
    uint8 string[SCHE_LEN];
}change_data;


typedef enum
{
    CHANGE_INIT,
    CHANGE_SMS,
    CHANGE_EXIT
}change_evnet;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND          win;
    T_MFW_HND       kbd;
    T_MFW_HND     info_win;
    int id;
}all_data;

typedef enum
{
    ALL_INIT,
    OLD_SCHEDULE,
    ALL_EXIT
}all_event;

//#define SCHEDULE_NUMBER  70
extern char CurrentScheFileName[10];
extern ScheTable[3][10];

FlashSchedule sche_data;
int ToolkitTitle=0;//gdy add
T_MFW_SCHE_INDEX replace[SCHEDULE_NUMBER];
static MfwHnd sche_win=NULL;
static MfwHnd TR_win=NULL;
static MfwHnd calin_win=NULL;
static MfwHnd browse_win=NULL;
static MfwHnd menu_win=NULL;
static int sche_index=0;
//static int sche_year;
//static int sche_month;
//static int sche_day;
//static int sche_wday;
static int change_index;
static int browse_flag;

static T_MFW_HND    calin_create(MfwHnd parent_window);
static void         calin_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int          calin_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
void                calin_destroy (T_MFW_HND own_window);
static int          calin_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);

static T_MFW_HND    sche_create(MfwHnd parent_win);
static void         sche_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
void                ScheSetEditor(T_MFW_HND win);
void                ScheSetPhoneEditor(T_MFW_HND win);
static void         ScheCB( T_MFW_HND win,USHORT Identifier,UBYTE reason);
static int          sche_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
static int          sche_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
static void         reset_editor(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                 U8 *controls, char *text,U16 size,MfwEdtAttr* attr,U8 dsplTitle);
void                sche_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);

static T_MFW_HND    TR_create(MfwHnd parent_win);
static void         TR_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int          TR_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                TR_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
void                TRdestroy(T_MFW_HND own_window);
int                 TimeAndRing(MfwHnd parent_window);
static int          TR_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
static T_MFW_HND    browse_create(MfwHnd parent_win);
static void         ScheBrowse_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int          browse_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
static int          ScheBrowse_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                ScheBrowse_destroy(T_MFW_HND own_window);
static T_MFW_HND    change_create(MfwHnd parent_win);
static void         BrowseCB( T_MFW_HND win,USHORT Identifier,UBYTE reason);
void                ChangeSetEditor(T_MFW_HND win);
static void         change_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
void                change_destroy(T_MFW_HND own_window);
void                type_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);

static T_MFW_HND    all_create(MfwHnd parent_win);
static void         all_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
void                all_destroy(T_MFW_HND own_window);
static int          all_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                all_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
void                old_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
static void         sche_menu_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
void                no_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
void                delete_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
int                 ScheRecordAddOneIndex(int k);
int                 ScheRecordReadOneIndex(int k);
void                BrowseDisplay(FlashSchedule * data,ScheBrowse_data* t);
effs_t              Flash_ScheWrite(char * filename);
void                copy(T_MFW_SCHE_INDEX *a, T_MFW_SCHE_INDEX *b);
void                exchange(T_MFW_SCHE_INDEX *a, T_MFW_SCHE_INDEX *b);
void                getLunarMonth(int mon_number, char * s);
void                getLunarDay(int day_number, char * s);
static              game_Line setLine(int x1,int y1,int x2,int y2,int color);
void                scheSMS_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
void                schedestroy(T_MFW_HND own_window);
void                Sche_Copy(FlashSchedule * a,FlashSchedule * b);


/* 2003.10.16 wyj ճļ */
static void checkSchNumInput(TR_data *data, U8 keynum);
static void checkSchLeftInput(TR_data *data);
static void checkSchRightInput(TR_data *data);

/* 2003.11.17 WYJ ճ̱ʾ */
static void calinDisp(MONTHTABLE *month_table);
static void calinBkgDisp();
static void calinNumDisp(int wd, int day, int count, int line);
static void calinFocusDisp(int wd, int count);
static void dsplCalinder();

/*  */
extern const TD_Rect    AL_input_rect; 
extern const TD_Attri   AL_input_attr1;
extern const TD_Attri   AL_input_attr2;
extern const TD_Line    AL_index_l;
extern const Color      AL_index_c;
extern const TD_Rect    AL_hint_rect;
extern const TD_Attri   AL_hint_attr;
extern const TD_Rect    AL_AP_rect;
extern const TD_Attri   AL_AP_attr;

/* ճ̱ */
extern const TD_Rect    SC_week_rect;
extern const TD_Attri   SC_week_attr;
extern const TD_Rect    SC_Lunar_rect;          
extern const TD_Attri   SC_Lunar_attr;
extern const TD_Rect    SC_BS_rect;
extern const TD_Attri   SC_BS_attr;
/* icon */
extern const MfwIcnAttr idl_AttrMask[];


T_MFW_HND calin_start(T_MFW_HND parent_win)
{

    T_MFW_HND           win    = calin_create(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, TD_INIT, 0, 0);
    }

    return win;
}
/* "ճ̱" */
int calinder(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = calin_create(parent_win);

    TRACE_EVENT("calinder");   

    if( win NEQ NULL )
    {
        SEND_EVENT (win, TD_INIT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}

int NewSche(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_MFW_HND         menu_options_win;
    //T_MFW_HND       	win    = sche_create(parent_win);
    // int j=0,k=0;
    int flag;

    TRACE_EVENT("NewSche");
    /*TraceInt(DateMessage->year);
    TraceInt(DateMessage->month);
    TraceInt(DateMessage->day);*/     


    ToolkitTitle=TxtNewSche;
    menu_options_win=bookMenuStart(parent_win, TypeOptions(), PhbkToolkit);
    SEND_EVENT(menu_options_win, ADD_CALLBACK, NULL, (void*)sche_menu_cb);
    // if(win NEQ NULL)
    // 	{
    //        SEND_EVENT(win, SCHE_INIT, 0, 0);
    // 	}
    // TRACE_EVENT("gdy win NEQ NULL");

    return MFW_EVENT_CONSUMED;
}
/* "ճ" */
int TodaySche(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_MFW_HND         win=browse_create(parent_win);
    //T_DISPLAY_DATA    display_info;

    if( win NEQ NULL )
    {
        SEND_EVENT(win, SCHEBROWSE_TODAY, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}


int AllSche(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND         parent_win = mfwParent( mfw_header());
    T_MFW_HND         win=browse_create(parent_win);
    //T_DISPLAY_DATA    display_info;

    if( win NEQ NULL )
    {
        SEND_EVENT(win, SCHEBROWSE_ALL, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}

/* "ɾѹճ" */
int DeleteOld(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_MFW_HND          win    = all_create(parent_win);

    TRACE_EVENT("DeleteAll");

    if( win NEQ NULL )
    {
        SEND_EVENT(win, OLD_SCHEDULE, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "ɾȫ" */
int DeleteAll(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_MFW_HND          win    = all_create(parent_win);

    TRACE_EVENT("DeleteAll");

    if( win NEQ NULL )
    {
        SEND_EVENT(win, ALL_INIT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "" */
int meeting(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());     
    T_MFW_HND          win    = sche_create(parent_win);
    T_MFW_WIN*         win_data;
    // schedule_data*			data;

    //if new window successfully created
    //TRACE_EVENT("meeting");
    //TraceInt(sche_year);
    //TraceInt(sche_month);
    //TraceInt(sche_day);
    sche_data.type=MEETING;
    if( win NEQ NULL )
    {   //win_data   = ( (T_MFW_HDR *) sche_win )->data;
        //data = (schedule_data*)win_data->user;
        SEND_EVENT(win, SCHE_EDIT, 0, 0);
    }
    return MFW_EVENT_CONSUMED;
}
/* "" */
int birthday(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());     
    T_MFW_HND          win      = sche_create(parent_win);
    T_MFW_WIN*         win_data;
    schedule_data*     data;

    //if new window successfully created

    sche_data.type=BIRTHDAY;
    if( win NEQ NULL )
    {   //win_data   = ( (T_MFW_HDR *) sche_win )->data;
        //data = (schedule_data*)win_data->user;
        SEND_EVENT (win, SCHE_EDIT, 0, 0);
    }
    return MFW_EVENT_CONSUMED;;
}
/* "Լ" */
int appointment(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());     
    T_MFW_HND          win    = sche_create(parent_win);
    T_MFW_WIN*            win_data;
    schedule_data*         data;

    //if new window successfully created

    sche_data.type=APPOINTMENT;
    if( win NEQ NULL )
    {   //win_data   = ( (T_MFW_HDR *) sche_win )->data;
        //data = (schedule_data*)win_data->user;
        SEND_EVENT (win, SCHE_EDIT, 0, 0);
    }
    return MFW_EVENT_CONSUMED;
}
/* "" */
int remind(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());     
    T_MFW_HND          win    = sche_create(parent_win);
    T_MFW_WIN*         win_data;
    schedule_data*         data;

    //if new window successfully created

    sche_data.type=REMIND;
    if( win NEQ NULL )
    {   //win_data   = ( (T_MFW_HDR *) sche_win )->data;
        //data = (schedule_data*)win_data->user;
        SEND_EVENT (win, SCHE_EDIT, 0, 0);
    }
    return MFW_EVENT_CONSUMED;
}

int phone(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());     
    T_MFW_HND          win    = sche_create(parent_win);
    T_MFW_WIN*         win_data;
    schedule_data*         data;

    //if new window successfully created

    sche_data.type=PHONE;
    if( win NEQ NULL )
    {   //win_data   = ( (T_MFW_HDR *) sche_win )->data;
        //data = (schedule_data*)win_data->user;
        SEND_EVENT (win, SCHE_EDIT, 0, 0);
    }
    return MFW_EVENT_CONSUMED;
}
/* "һ" */
int type_once(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA    display_info;
    T_MFW_WIN          *win_data   = ((T_MFW_HDR *) sche_win )->data;
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;
    T_MFW_WIN     * win_data2= ((T_MFW_HDR *) sche_win )->data;
    tddata*    calin_data=(tddata* )win_data1->user;
    schedule_data* ScheData=(schedule_data*)win_data2->user;
    // schedule_data*  data=(schedule_data*)win_data->user;
    int k=0,j;
    char debugbuffer[40];

    //showAlarmIcon();
    sche_data.ringandf=sche_data.ringandf+ONCE;
    //TraceInt(sche_data.date[0]);
    //TraceInt(sche_data.date[1]);

    while( (ScheDetailIndex[k].index!=0)&&(k<SCHEDULE_NUMBER) )
        k++;
    //TraceInt(k);

    ScheRecordAddOneIndex(k);
    TRACE_EVENT("the value of Sche_data:");
    //TraceInt(sche_data.date[0]);
    //TraceInt(sche_data.date[1]);
    //TraceInt(sche_data.time);
    j=0;
    while( ScheIndex[j].index )
        j++;
    ScheIndex[j].index=ScheDetailIndex[k].index;
    ScheIndex[j].date[0]=ScheDetailIndex[k].date[0];
    ScheIndex[j].date[1]=ScheDetailIndex[k].date[1];
    ScheIndex[j].wday=ScheDetailIndex[k].wday;
    ScheIndex[j].hour=ScheDetailIndex[k].hour;
    ScheIndex[j].minute=ScheDetailIndex[k].minute;

    TRACE_EVENT("type_once");

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId2     =TxtSaved;
    display_info.TextId      = '\0';
    display_info.Time       = FOREVER;

    display_info.Callback     = (T_VOID_FUNC)type_dialog_cb;
    display_info.iconindex = REMIND_COMPLETE;
    /* Call Info Screen  */
    info_dialog (parent_win, &display_info);

    return MFW_EVENT_CONSUMED;
}
/* "ÿ" */
int type_day(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA    display_info;
    T_MFW_WIN          *win_data   = ( (T_MFW_HDR *) sche_win )->data;
    schedule_data * data=(schedule_data*)win_data->user;
    int k=0,j;

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId2     =TxtSaved;
    display_info.TextId      = '\0';
    display_info.Time       = FOREVER;

    display_info.Callback     = (T_VOID_FUNC)type_dialog_cb;
    display_info.iconindex = REMIND_COMPLETE;
    /* Call Info Screen  */
    info_dialog (parent_win, &display_info);

    sche_data.ringandf=sche_data.ringandf+EVERYDAY;

    while( (ScheDetailIndex[k].index!=0)&&(k<SCHEDULE_NUMBER) )
        k++;
    // showAlarmIcon();
    ScheRecordAddOneIndex(k);

    /* if(sche_index<70)
        {
        for(j=0;j<sche_index;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char*)ScheTable[0]);
        }
     else if(sche_index<140)
        {
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char *)ScheTable[0]);
        for(j=0;j<sche_index-70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[70+j];
        Flash_ScheWrite((char *)ScheTable[1]);
        }
     else
        {
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char *)ScheTable[0]);
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[70+j];
        Flash_ScheWrite((char *)ScheTable[1]);
        for(j=0;j<sche_index-140;j++)
            FFS_ScheData.FfsSche[j]=sche_data[140+j];
        Flash_ScheWrite((char *)ScheTable[2]);
        }*/


    /*    bookMenuDestroy(parent_win);
        TRdestroy(TR_win);
        schedestroy(sche_win);
        calin_destroy(calin_win);*/

    return MFW_EVENT_CONSUMED;
}
/* "ÿ" */
int type_week(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA    display_info;
    T_MFW_WIN          *win_data   = ( (T_MFW_HDR *) sche_win )->data;
    schedule_data*  data=(schedule_data*)win_data->user;
    int k=0,j;

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId2     =TxtSaved;
    display_info.TextId      = '\0';
    display_info.Time       = FOREVER;

    display_info.Callback     = (T_VOID_FUNC)type_dialog_cb;
    display_info.iconindex = REMIND_COMPLETE;
    /*
     * Call Info Screen
     */
    info_dialog (parent_win, &display_info);

    sche_data.ringandf=sche_data.ringandf+WEEKLY;

    while( (ScheDetailIndex[k].index!=0)&&(k<SCHEDULE_NUMBER) )
        k++;
    //showAlarmIcon();
    ScheRecordAddOneIndex(k);

    /* if(sche_index<70)
        {
        for(j=0;j<sche_index;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char*)ScheTable[0]);
        }
     else if(sche_index<140)
        {
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char *)ScheTable[0]);
        for(j=0;j<sche_index-70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[70+j];
        Flash_ScheWrite((char *)ScheTable[1]);
        }
     else
        {
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char *)ScheTable[0]);
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[70+j];
        Flash_ScheWrite((char *)ScheTable[1]);
        for(j=0;j<sche_index-140;j++)
            FFS_ScheData.FfsSche[j]=sche_data[140+j];
        Flash_ScheWrite((char *)ScheTable[2]);
        }*/


    /*   bookMenuDestroy(parent_win);
       TRdestroy(TR_win);
       schedestroy(sche_win);
       calin_destroy(calin_win);*/

    return MFW_EVENT_CONSUMED;
}
/* "ÿ" */
int type_month(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA    display_info;
    T_MFW_WIN          *win_data   = ( (T_MFW_HDR *) sche_win )->data;
    schedule_data * data=(schedule_data*)win_data->user;
    int k=0,j;

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId2     =TxtSaved;
    display_info.TextId      = '\0';
    display_info.Time       = FOREVER;

    display_info.Callback     = (T_VOID_FUNC)type_dialog_cb;
    display_info.iconindex = REMIND_COMPLETE;
    /*
     * Call Info Screen
     */
    info_dialog (parent_win, &display_info);

    sche_data.ringandf=sche_data.ringandf+EVERYMONTH;

    while( (ScheDetailIndex[k].index!=0)&&(k<SCHEDULE_NUMBER) )
        k++;
    //showAlarmIcon();
    ScheRecordAddOneIndex(k);
    /* if(sche_index<70)
        {
        for(j=0;j<sche_index;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char*)ScheTable[0]);
        }
     else if(sche_index<140)
        {
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char *)ScheTable[0]);
        for(j=0;j<sche_index-70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[70+j];
        Flash_ScheWrite((char *)ScheTable[1]);
        }
     else
        {
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[j];
        Flash_ScheWrite((char *)ScheTable[0]);
        for(j=0;j<70;j++)
            FFS_ScheData.FfsSche[j]=sche_data[70+j];
        Flash_ScheWrite((char *)ScheTable[1]);
        for(j=0;j<sche_index-140;j++)
            FFS_ScheData.FfsSche[j]=sche_data[140+j];
        Flash_ScheWrite((char *)ScheTable[2]);
        }*/


    /* bookMenuDestroy(parent_win);
     TRdestroy(TR_win);
     schedestroy(sche_win);
     calin_destroy(calin_win);*/

    return MFW_EVENT_CONSUMED;
}
/* "ÿ" */
int type_year(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_DISPLAY_DATA    display_info;
    T_MFW_WIN          *win_data   = ( (T_MFW_HDR *) sche_win )->data;
    schedule_data*  data=(schedule_data*)win_data->user;
    int k=0,j;

    sche_data.ringandf=sche_data.ringandf+ANNUALLY;

    while( (ScheDetailIndex[k].index!=0)&&(k<SCHEDULE_NUMBER) )
        k++;
    // showAlarmIcon();
    if( ScheRecordAddOneIndex(k) )
    {
        dialog_info_init(&display_info);
        display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = TxtSoftBack;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';
        display_info.TextId2     =TxtSaved;
        display_info.TextId      = '\0';
        display_info.Time       = FOREVER;

        display_info.Callback     = (T_VOID_FUNC)type_dialog_cb;
        display_info.iconindex = REMIND_COMPLETE;
        /*
         * Call Info Screen
         */
        info_dialog (parent_win, &display_info);
    }
    /*  if(sche_index<70)
         {
         for(j=0;j<sche_index;j++)
             FFS_ScheData.FfsSche[j]=sche_data[j];
         Flash_ScheWrite((char*)ScheTable[0]);
         }
      else if(sche_index<140)
         {
         for(j=0;j<70;j++)
             FFS_ScheData.FfsSche[j]=sche_data[j];
         Flash_ScheWrite((char *)ScheTable[0]);
         for(j=0;j<sche_index-70;j++)
             FFS_ScheData.FfsSche[j]=sche_data[70+j];
         Flash_ScheWrite((char *)ScheTable[1]);
         }
      else
         {
         for(j=0;j<70;j++)
             FFS_ScheData.FfsSche[j]=sche_data[j];
         Flash_ScheWrite((char *)ScheTable[0]);
         for(j=0;j<70;j++)
             FFS_ScheData.FfsSche[j]=sche_data[70+j];
         Flash_ScheWrite((char *)ScheTable[1]);
         for(j=0;j<sche_index-140;j++)
             FFS_ScheData.FfsSche[j]=sche_data[140+j];
         Flash_ScheWrite((char *)ScheTable[2]);
         }*/

    /*  bookMenuDestroy(parent_win);
      TRdestroy(TR_win);
      schedestroy(sche_win);
      calin_destroy(calin_win);*/

    return MFW_EVENT_CONSUMED;
}

int ScheChange(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = change_create(parent_win);
    ScheBrowse_data *   data   = ( (T_MFW_HDR *) browse_win )->data;

    menu_win=parent_win;

    if( win!=NULL )
    {
        SEND_EVENT(win, CHANGE_INIT, 0, data);
    }

    return MFW_EVENT_CONSUMED;
}

int ScheSMS(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win = mfwParent( mfw_header());
    T_MFW_HND           win    = change_create(parent_win);
    ScheBrowse_data *   data   = ( (T_MFW_HDR *) browse_win )->data;

    if( win!=NULL )
    {
        SEND_EVENT(win, CHANGE_SMS, 0, data);
    }


    return MFW_EVENT_CONSUMED;
}

int ScheDelete(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          parent_win = mfwParent( mfw_header());
    T_MFW_WIN * win_data   = ( (T_MFW_HDR *) browse_win )->data;
    ScheBrowse_data *   data =(ScheBrowse_data *)win_data->user;
    T_DISPLAY_DATA    display_info;
    T_MFW_SCHE_INDEX t;
    int j=0,k=0;

    TRACE_EVENT("ScheDelete");

    FFS_ScheData.FfsSche[data->flag].date[0]=0;
    FFS_ScheData.FfsSche[data->flag].date[1]=0;
    FFS_ScheData.FfsSche[data->flag].hour=0;
    FFS_ScheData.FfsSche[data->flag].minute=0;
    FFS_ScheData.FfsSche[data->flag].ringandf=0;
    FFS_ScheData.FfsSche[data->flag].type=0;
    strcpy((char*)FFS_ScheData.FfsSche[data->flag].text,"");
    Flash_ScheWrite((char *)CurrentScheFileName);
    set_latest_alarm();
    ScheDetailIndex[ScheIndex[k].index-1].index=0;
    ScheDetailIndex[ScheIndex[k].index-1].date[0]=0;
    ScheDetailIndex[ScheIndex[k].index-1].date[1]=0;
    ScheDetailIndex[ScheIndex[k].index-1].wday=0;
    ScheDetailIndex[ScheIndex[k].index-1].hour=0;
    ScheDetailIndex[ScheIndex[k].index-1].minute=0;
    ScheDetailIndex[ScheIndex[k].index-1].number=0;
    ScheDetailIndex[ScheIndex[k].index-1].ringandt=0;
    ScheIndex[data->index].date[0]=0;
    ScheIndex[data->index].date[1]=0;
    ScheIndex[data->index].wday=0;
    ScheIndex[data->index].hour=0;
    ScheIndex[data->index].minute=0;
    ScheIndex[data->index].index=0;
    j=data->index;
    while( ScheIndex[j+1].index )
    {
        /* ScheIndex[j].date[0]=ScheIndex[j+1].date[0];
         ScheIndex[j].date[1]=ScheIndex[j+1].date[1];
         ScheIndex[j].time=ScheIndex[j+1].time;
         ScheIndex[j].index=ScheIndex[j+1].index;*/
        copy(&ScheIndex[j],&ScheIndex[j+1]);
        //ScheIndex[j+1]=t;
        j++;
    }
    ScheIndex[j].index=0;
    ScheIndex[j].date[0]=0;
    ScheIndex[j].date[1]=0;
    ScheIndex[j].hour=0;
    ScheIndex[j].minute=0;
    //copy((T_MFW_SCHE_INDEX *)ScheIndex[j],(T_MFW_SCHE_INDEX *)0);
    data->index=0;
    //TraceInt(data->flag1);
    /*k=0;
    for(j=0;j<SCHEDULE_NUMBER;j++)
       {
          if(ScheDetailIndex[j].index)
           {
             ScheIndex[k].date[0]=ScheDetailIndex[j].date[0];
             ScheIndex[k].date[1]=ScheDetailIndex[j].date[1];
             ScheIndex[k].time=ScheDetailIndex[j].time;
             ScheIndex[k].index=ScheDetailIndex[j].index;
             k++;
           }
       }*/

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.TextId2     =TxtDeleted;
    display_info.TextId      = '\0';
    display_info.Time       = FOREVER;
    display_info.Callback     = (T_VOID_FUNC)delete_dialog_cb;
    display_info.iconindex  = REMIND_COMPLETE;
    /*
     * Call Info Screen
     */
    info_dialog(parent_win, &display_info);

    /*  while(j<SCHEDULE_NUMBER)
         {
           if(ScheDetailIndex[j].index)
             {
                ScheIndex[k].index=ScheDetailIndex[j].index;
                //ScheIndex[k].number=j;
                ScheIndex[k].date[0]=ScheDetailIndex[j].date[0];
                ScheIndex[k].date[1]=ScheDetailIndex[j].date[1];
                ScheIndex[k].time=ScheIndex[j].time;
                k++;
             }
          j++;
         }*/
    showAlarmIcon();        
}
/* "ճ"ڴ*/
int TimeAndRing(MfwHnd parent_window)
{
    T_MFW_HND          win    = TR_create(parent_window);

    TRACE_EVENT("TimeAndRing");

    if( win NEQ NULL )
    {
        SEND_EVENT(win, TR_RING, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "ճ̱"ڴ */
static T_MFW_HND calin_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    tddata* data = (tddata *)ALLOC_MEMORY (sizeof (tddata ));
    data->calin=(TIMEDATE *)ALLOC_MEMORY(sizeof(TIMEDATE));

    data->month_table=(MONTHTABLE *)ALLOC_MEMORY(sizeof(MONTHTABLE));

    //int i=0;
    memset(data->month_table,0,sizeof(MONTHTABLE));
    memset(data->calin,0,sizeof(TIMEDATE));
    memset(data->calin->l_year,0,16);
    TRACE_EVENT("calin_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)calin_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)calin_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    calin_win=data->win;

    return data->win;
}
/* "ճ̱"¼ */
static void calin_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tddata* data = (tddata *) win_data->user;


    TRACE_EVENT("calin_DialogCB");
    switch( event )
    {
    case TD_INIT:
        TRACE_EVENT("TD_INIT");
        data->kbd=kbdCreate(data->win, KEY_ALL, (T_MFW_CB)calin_kbd_cb);
        GetTimeDate(currdate.year, currdate.month,currdate.day,data->calin);//currdate.month, currdate.day,);
        data->wday=data->calin->week;
        TRACE_EVENT(data->calin->l_year);
        // TraceInt(data->calin->month);
        // TraceInt(data->calin->day);
        TRACE_EVENT("GetTimeDate");
        GetMonthTable(data->calin, 0, 0,data->month_table);
        // TraceInt(data->month_table->day);

        winShow(win);
        break;
    case TD_EXIT:
        calin_destroy(win);
        break;
    }
}
/* "ճ̱" ʾص
 * 2003.10.21 wyj ӢĽյʾ 
 * 2003.11.5 wyj ޶ũڵʾΧ19802031
 * 2003.11.17 WYJ дʾ
 * 2003.12.2 WYJ ޸Ľ
*/
static int calin_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{
    tddata * data = (tddata *)win->user;
    char strn[30];
	char strnMonth[3];//jhxu720 add
    char strn1[30];
    char strm[10];
    char strd[20];
    char str[40];
    char ly[20];//lunar year
    short lm;//lunar month
    short ld;//lunar day
    short wd=0;//week day
    int i,j;
    int sum=0;
    int posx=0;//
    int posy=47;//
    int old_color;
    int oldFontColor;
    game_Line line;
    game_Rectangle rectangle;

    /*2003/11/11,talcon add*/
    U8 uMode = 0;

    TRACE_EVENT ("calin_win_cb()");

    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        TRACE_EVENT("E_WIN_VISIBLE");
        if( win->flags & E_WIN_VISIBLE )
        {
            /*2003/11/11,talcon add*/
            uMode = dspl_Enable(0);

            /* Clear Screen */
            dspl_ClearAll();
#if (MAIN_LCD_SIZE==3)//jhxu720
            /* ʾ */
            calinBkgDisp();
#elif ( MAIN_LCD_SIZE==4 )
            /* ʾ */
            calinBkgDisp();
#endif

#if 0		// 2004.1.16 WYJ 

            if( wstrBitlen(data->calin->holidayl_txt)<2 )
            {
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut(36+4,1,DSPL_TXTATTR_TRANSPARENT,(char*)MmiRsrcGetText(TxtCalinder),0xffffff);
                else
                    dspl_colorTextOut(28+4,1,DSPL_TXTATTR_TRANSPARENT,(char*)MmiRsrcGetText(TxtCalinder),0xffffff);
            }
            else                            //ũռ
            {
                /* 2003.10.21 wyj ޸*/
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut((132-wstrBitlen(data->calin->holidayl_txt)*8)/2, 1,DSPL_TXTATTR_TRANSPARENT,(char *)data->calin->holidayl_txt,0xffffff);
                else
                    dspl_colorTextOut(28+4,1,DSPL_TXTATTR_TRANSPARENT,(char*)MmiRsrcGetText(TxtCalinder),0xffffff);
            }

            /*   ũʾ */
            set_font_type(UNI12X12_FONT);
            memset((char *)strn,0,sizeof(strn));
            memset((char *)strn1,0,sizeof(strn1));
            sprintf((char*)strn,"%d.%02d.%02d",data->month_table->year,data->month_table->month,data->month_table->day);
            TRACE_EVENT((char*)strn);

            if( (wstrBitlen(data->calin->holiday_txt)<3)&&(wstrBitlen(data->month_table->solar[0].solartxt)<3)
                &&(wstrBitlen(data->month_table->solar[1].solartxt)<3) )
            {
                set_font_type(UNI12X12_FONT);
                dspl_colorTextOut(9, 19, DSPL_TXTATTR_TRANSPARENT, (char*)strn, 0x004c98);  //ƺԶ
            }
            else
            {
                set_font_type(UNI12X12_FONT);
                dspl_colorTextOut(9, 19, DSPL_TXTATTR_TRANSPARENT, (char*)strn,0x004c98);

                set_font_type(UNI12X12_FONT);
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                {
                    set_font_type(UNI12X12_FONT);
                    if( strlen(data->calin->holiday_txt) )    //ʾ
                    {
                        dspl_colorTextOut(80, 18, 0, (char*)data->calin->holiday_txt, 0x004c98);
                    }
                    else                    //ʾ
                    {
                        if( data->calin->day==data->month_table->solar[0].day )
                            dspl_colorTextOut(80+8, 18, 0, (char *)data->month_table->solar[0].solartxt,0x004c98);
                        if( data->calin->day==data->month_table->solar[1].day )
                            dspl_colorTextOut(80+8, 18, 0, (char *)data->month_table->solar[1].solartxt,0x004c98);
                    }  
                }
            }
#endif
            /* 2004/05/17 yhf modify */
#if ( MAIN_LCD_SIZE==4 )
            /* title display */
            if( wstrBitlen(data->calin->holidayl_txt)<2 )
            {
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut(36+4,1,DSPL_TXTATTR_WHITE_EDGE,(char*)MmiRsrcGetText(TxtCalinder),0x0);
                else
                    dspl_colorTextOut(28+4,1,DSPL_TXTATTR_WHITE_EDGE,(char*)MmiRsrcGetText(TxtCalinder),0x0);
            }
            else                            //ũռ
            {
                /* 2003.10.21 wyj ޸*/
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                    dspl_colorTextOut((132-wstrBitlen(data->calin->holidayl_txt)*8)/2, 1,DSPL_TXTATTR_WHITE_EDGE,(char *)data->calin->holidayl_txt,0x0);
                else
                    dspl_colorTextOut(28+4,1,DSPL_TXTATTR_WHITE_EDGE,(char*)MmiRsrcGetText(TxtCalinder),0x0);
            }

            /*   ũʾ */
            set_font_type(UNI12X12_FONT);
            memset((char *)strn,0,sizeof(strn));
            memset((char *)strn1,0,sizeof(strn1));
            sprintf((char*)strn,"%d.%02d.%02d",data->month_table->year,data->month_table->month,data->month_table->day);
            TRACE_EVENT((char*)strn);

            if( (wstrBitlen(data->calin->holiday_txt)<3)&&(wstrBitlen(data->month_table->solar[0].solartxt)<3)
                &&(wstrBitlen(data->month_table->solar[1].solartxt)<3) )
            {
                set_font_type(UNI12X12_FONT);
                dspl_colorTextOut(9, 19, DSPL_TXTATTR_TRANSPARENT, (char*)strn, 0x004c98);  //ƺԶ
            }
            else
            {
                set_font_type(UNI12X12_FONT);
                dspl_colorTextOut(9, 19, DSPL_TXTATTR_TRANSPARENT, (char*)strn,0x004c98);

                set_font_type(UNI12X12_FONT);
                if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                {
                    set_font_type(UNI12X12_FONT);
                    if( strlen(data->calin->holiday_txt) )    //ʾ
                    {
                        dspl_colorTextOut(80, 18, 0, (char*)data->calin->holiday_txt, 0x004c98);
                    }
                    else                    //ʾ
                    {
                        if( data->calin->day==data->month_table->solar[0].day )
                            dspl_colorTextOut(80+8, 18, 0, (char *)data->month_table->solar[0].solartxt,0x004c98);
                        if( data->calin->day==data->month_table->solar[1].day )
                            dspl_colorTextOut(80+8, 18, 0, (char *)data->month_table->solar[1].solartxt,0x004c98);
                    }  
                }
            }
#endif
            /* 2004/05/17 yhf modify */
#if ( MAIN_LCD_SIZE==2 )
            /* title display */
            dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                         menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                         menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

            /* data display */
            sprintf((char*)strn,"%d.%02d.%02d",data->month_table->year,data->month_table->month,data->month_table->day);
            dspl_colorTextOut(0, 0, DSPL_TXTATTR_TRANSPARENT, (char*)strn, 0x0);
#endif
            /* title display */
			DRAW_ICON(ICON_MENUUP);//jhxu720 add
			
			/* data display */
            /*sprintf((char*)strn,"%d.%02d.%02d",data->month_table->year,data->month_table->month,data->month_table->day);
            dspl_colorTextOut(0, 0, DSPL_TXTATTR_TRANSPARENT, (char*)strn, 0x0);*/
            /* 2003.11.17 WYJ ʾճ̱*/
            calinDisp(data->month_table);
#if(MAIN_LCD_SIZE==3)
			sprintf((char*)strn,"%d",data->month_table->year);
            dspl_colorTextOut(20, 95, DSPL_TXTATTR_TRANSPARENT, (char*)strn, 0xffffff);
			sprintf((char*)strnMonth,"%0d",data->month_table->month);
            dspl_colorTextOut(90, 94, DSPL_TXTATTR_TRANSPARENT, (char*)strnMonth, 0xffffff);
#endif			
#if 0
            if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )  //ʾũ
            {
                /* 2003.11.5 wyj ޶ũڵʾΧ */
                if( data->calin->year>=1980 && data->calin->year<=2031 )
                {
                    memset((char *)ly,0,sizeof(ly));
                    memset((char *)strm,0,sizeof(strm));
                    memset((char *)strd,0,sizeof(strd));
                    GetLunarYear(data->calin->year, data->calin->month, data->calin->l_month%16,(char *)ly);
                    lm=data->calin->l_month%16;
                    getLunarMonth(lm,(char *)strm);      
                    ld=data->calin->l_day;
                    getLunarDay(ld,(char *)strd);
                    memset((char *)str,0,sizeof(str));
                    strncpy(str,(char *)ly,7);
                    strncat(str,(char *)strm,4);
                    strncat(str,(char *)strd,6);

                    set_font_type(UNI12X12_FONT);
                    dspl_colorTextOut(60-3*wstrBitlen((char*)str)+EX, 127, DSPL_TXTATTR_TRANSPARENT, str,0x004c98);    //ʾũ    
                }
            }
#endif
            /* 2004/05/17 yhf modify */
#if ( MAIN_LCD_SIZE==4 )
            if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )  //ʾũ
            {
                /* 2003.11.5 wyj ޶ũڵʾΧ */
                if( data->calin->year>=1980 && data->calin->year<=2031 )
                {
                    memset((char *)ly,0,sizeof(ly));
                    memset((char *)strm,0,sizeof(strm));
                    memset((char *)strd,0,sizeof(strd));
                    GetLunarYear(data->calin->year, data->calin->month, data->calin->l_month%16,(char *)ly);
                    lm=data->calin->l_month%16;
                    getLunarMonth(lm,(char *)strm);      
                    ld=data->calin->l_day;
                    getLunarDay(ld,(char *)strd);
                    memset((char *)str,0,sizeof(str));
                    strncpy(str,(char *)ly,7);
                    strncat(str,(char *)strm,4);
                    strncat(str,(char *)strd,6);

                    set_font_type(UNI12X12_FONT);
                    dspl_colorTextOut(60-3*wstrBitlen((char*)str)+EX, 127, DSPL_TXTATTR_TRANSPARENT, str,0x004c98);    //ʾũ    
                }
            }
#endif
            set_font_type(NORMAL_FONT);

            displaySoftKeys(TxtSoftOptions, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
			draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
            /*2003/11/11,talcon add*/
            dspl_Enable(uMode );
        }
        break;
    default:
        break;
    }
    return 1;
}

void calin_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    tddata* data   = (tddata*)win->user;
    int i;

    TRACE_EVENT ("calin_destroy()");

    if( data )
    {
        /*
         * Delete WIN Handler
         */

        win_delete(calin_win);

        /*
         * Free Memory
        */
        FREE_MEMORY((void *)data->calin,sizeof(TIMEDATE));
        FREE_MEMORY((void *)data->month_table,sizeof(MONTHTABLE));
        FREE_MEMORY((void *)data, sizeof(tddata));
    }
}

/* 2003.10.21 wyj ũΧ19802031 "ճ̱"
 * 2003.11.5  wyj Ϊ޶Χ1980-2099Χ19802031ʾũ
*/
static int calin_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    //T_DISPLAY_DATA   display_info;
    tddata* data   = (tddata*)win_data->user;
    char debugbuffer[80];
    int i=0,j=0,k=0;
    TRACE_EVENT("calin_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_LEFT:
    case KCD_OK:
        TRACE_EVENT("KCD_LEFT");
        memset(&sche_data,0,sizeof(FlashSchedule));
        //while(!(Iswritefileend(ScheTable[i],sizeof(FFS_ScheData))));
        //ScheMemoRead();
        while( j<SCHEDULE_NUMBER )
        {
            if( ScheDetailIndex[j].index )
            {
                ScheIndex[k].index=ScheDetailIndex[j].index;
                //ScheIndex[k].number=j;
                ScheIndex[k].date[0]=ScheDetailIndex[j].date[0];
                ScheIndex[k].date[1]=ScheDetailIndex[j].date[1];
                ScheIndex[k].wday=ScheDetailIndex[j].wday;
                ScheIndex[k].hour=ScheDetailIndex[j].hour;
                ScheIndex[k].minute=ScheDetailIndex[j].minute;
                k++;
            }
            j++;
        }
        TRACE_EVENT("K=:");
        // set_font_type(NORMAL_FONT);  
        data->year  = data->month_table->year;
        data->month = data->month_table->month;
        data->day   = data->month_table->day;
        data->wday  = data->calin->week;
        TraceInt(data->year);
        TraceInt(data->month);
        TraceInt(data->day);
        if( data->menu_options_win!=NULL )
        {
            TRACE_EVENT("gdy option_win true");
            //bookMenuDestroy(data->menu_options_win);
        }
        else
            TRACE_EVENT("gdy option_win false");
        ToolkitTitle=TxtSchedule;
        if( ScheIndex[0].index )
            data->menu_options_win=bookMenuStart(data->win, sche_mnu1Attributes(), PhbkToolkit);
        else
            data->menu_options_win=bookMenuStart(data->win, sche_NoAttributes(), PhbkToolkit);
        SEND_EVENT(data->menu_options_win, ADD_CALLBACK, NULL, 0);
        //DateMessage=data->month_table;  		

        /*while(sche_data[i].text[0]!=0)
                i++;
        sche_index=i;*/
        //winShow(win);
        break;
    case KCD_MNULEFT:                       //һ
        /* 2003.11.5 wyj  Χ19802099 */
        if( data->calin->year==1980 && data->calin->month==1 &&data->calin->day==1 )
            break;

        GetMonthTable(data->calin, 0, -1, data->month_table);
        GetTimeDate(data->month_table->year, data->month_table->month,data->month_table->day,data->calin);
        winShow(win);
        break;
    case KCD_MNURIGHT:                      //һ
        /* 2003.11.5 wyj  Χ19802099 */
        if( data->calin->year==2099 && data->calin->month==12 &&data->calin->day==31 )
            break;

        GetMonthTable(data->calin, 0, 1, data->month_table);
        GetTimeDate(data->month_table->year, data->month_table->month,data->month_table->day,data->calin);
        /*sche_year=data->month_table.year;
        sche_month=data->month_table.month;
        sche_day=data->month_table.day;*/
        winShow(win);
        break;
    case KCD_MNUUP:                         //һ
        /* 2003.11.5 wyj Χ19802099 */
        if( data->calin->year==1980 && data->calin->month==1 )
            break;

        GetMonthTable(data->calin, -1, 0, data->month_table);
        GetTimeDate(data->month_table->year, data->month_table->month,data->month_table->day,data->calin);
        /*sche_year=data->month_table.year;
        sche_month=data->month_table.month;
        sche_day=data->month_table.day;*/
        winShow(win);
        break;
    case KCD_MNUDOWN:                       //һ
        /* 2003.11.5 wyj  Χ19802099*/
        if( data->calin->year==2099 && data->calin->month==12 )
            break;

        GetMonthTable(data->calin, 1, 0, data->month_table);
        GetTimeDate(data->month_table->year, data->month_table->month,data->month_table->day,data->calin);
        /*sche_year=data->month_table.year;
        sche_month=data->month_table.month;
        sche_day=data->month_table.day;*/
        winShow(win);
        break;
    case KCD_HUP:
    case KCD_RIGHT:
        SEND_EVENT(calin_win, TD_EXIT, 0, 0);
        break;
    default:
        break;
    } 

    return MFW_EVENT_CONSUMED;
}
/* "ճ" */
static T_MFW_HND sche_create(MfwHnd parent_win)
{
    schedule_data* data = (schedule_data *)ALLOC_MEMORY (sizeof (schedule_data ));
    T_MFW_WIN  * win;
    int i=0;

    TRACE_EVENT("calin_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)sche_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)sche_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;
    sche_win=data->win;

    //for(i=0;i<2;i++)
    //TRACE_EVENT((char*)sche_data[i].text);

    return data->win;
}
/* "ճ"*/
static void sche_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    schedule_data * data = (schedule_data *) win_data->user;
    //data->id=value;

    TRACE_EVENT("sche_DialogCB");

    switch( event )
    {
    case SCHE_INIT:
        //if(data->menu_options_win!=NULL)
        //bookMenuDestroy(data->menu_options_win);

        break;
    case SCHE_EDIT:
        //PROMPT(30, 0, 0, TxtSchedule);
        ScheSetEditor(win);//set editor with default attribute values
        /*
        data->editor_data.editor_attr.win.px = 0;
        data->editor_data.editor_attr.win.py = 20;
        data->editor_data.editor_attr.win.sx = 120;
        data->editor_data.editor_attr.win.sy = 120;
        */
        data->editor_data.Callback          = (T_EDIT_CB)ScheCB;
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            data->editor_win = text_input(win, &data->editor_data);
        }
        else
        {
            data->editor_win = editor_start(win, &(data->editor_data));
        }

        winShow(win);             
        break;
    case SMS_PHBK_NUMBER:
        TRACE_EVENT("SMS_PHBK_NUMBER");
        strcpy((char*)sche_data.text,(char*)parameter);
        //ScheSetPhoneEditor(win);
        //data->editor_data.Callback 	= (T_EDIT_CB)ScheCB;
        //data->editor_win = editor_start(win, &(data->editor_data));

        //winShow(win);			 
        break;
    case SCHE_EXIT:
        schedestroy(win);
        break;
    }               
}


static int sche_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{
    // TR_data * data = (TR_data *)win->user;
    // char strn[8];

    TRACE_EVENT ("TR_win_cb()");
    /*
      if (data EQ 0)
      return 1;*/

    switch( event )
    {
    case E_WIN_VISIBLE:
        TRACE_EVENT("E_WIN_VISIBLE");
        if( win->flags & E_WIN_VISIBLE )
        {  /*
            * Clear Screen
            */
            TRACE_EVENT("gdy test");
        }
        break;
    default:
        break;
    }
    return 1;
}


static void reset_editor(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                         U8 *controls, char *text,U16 size,MfwEdtAttr* attr,U8 dsplTitle)
{

    attr->win.px = winPx;
    attr->win.py = winPy;
    attr->win.sx = winSx;
    attr->win.sy = winSy;
    attr->fgColor = fgColor;
    attr->font = font;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
    attr->title_id=dsplTitle;
}
/* "ճ" ı򴴽 */
void ScheSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    schedule_data* data = (schedule_data *) win_data->user;
    short TxtID;
    char stre[3];

    //editor_attr_init(&((data->editor_data).editor_attr), NULL, edtCurBar1, 0, 0, 0);
    switch( sche_data.type )
    {
    case MEETING:
        TxtID=TxtScheMeeting;
        break;
    case BIRTHDAY:
        TxtID=TxtBirthday;
        break;
    case APPOINTMENT:
        TxtID=TxtAppointment;
        break;
    case PHONE:
        TxtID=TxtPhone;
        break;
    case REMIND:
        TxtID=TxtRemind;
        break;
    default:
        break;
    }
    memset((char*)sche_data.text,0,sizeof(sche_data.text));
    if( sche_data.type==PHONE )
        editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtID, (char *)sche_data.text, 24, edtCurBar1);
    else
        editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtID, (char *)sche_data.text, SCHE_LEN, edtCurBar1);
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings


    data->editor_data.Identifier        = 0xFFFF ; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = FALSE;
    //data->editor_data.editor_attr.text	= (char *)sche_data.text; 
    //data->editor_data.editor_attr.size	= 98; 

    data->editor_data.TextId               = '\0'; 
    if( sche_data.type==PHONE )
    {
        data->editor_data.Identifier        =SMSSEND_ID_NBEDIT;
        data->editor_data.LeftSoftKey          =TxtSoftOK;
        data->editor_data.AlternateLeftSoftKey  = TxtFind;
        data->editor_data.RightSoftKey         = TxtDelete;             
    }
    else
    {
        data->editor_data.LeftSoftKey       = TxtSoftOK;//comfirm									
        data->editor_data.AlternateLeftSoftKey  = TxtNull;
        data->editor_data.RightSoftKey      = TxtDelete;
    }
    if( sche_data.type==PHONE )
    {
        data->editor_data.mode              = PHONENUMONLY_MODE;
    }
    else
    {
        data->editor_data.mode              = TEXTINPUT_MODE;   /* 2003/12/04 sunsj modiyf */
        data->editor_data.InputMode         = PINYIN_INPUT_MODE;    /* 2003/12/04 sunsj */
    }
}

void ScheSetPhoneEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    schedule_data* data = (schedule_data *) win_data->user;

    editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtPhone, (char *)sche_data.text, 24, edtCurBar1);

    data->editor_data.hide             = FALSE;
    data->editor_data.min_enter            = 1;  // Avoid returning empty strings	


    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = FALSE;
    //data->editor_data.editor_attr.text	= (char *)sche_data.text; 
    //data->editor_data.editor_attr.size	= 98; 
    data->editor_data.TextId               = '\0';  
    data->editor_data.Identifier        =SMSSEND_ID_NBEDIT;
    data->editor_data.LeftSoftKey          =TxtSoftOK;
    data->editor_data.AlternateLeftSoftKey  = TxtFind;
    data->editor_data.RightSoftKey         = TxtDelete;             

    data->editor_data.mode              = PHONENUMONLY_MODE;
}
/* "ճ" ıص */
static void ScheCB( T_MFW_HND win,USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    schedule_data   *data       = (schedule_data *) win_data->user;  

    TRACE_EVENT("ScheCB");

    switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
        TRACE_EVENT("INFO_KCD_ALTERNATELEFT");
        //editor_destroy(data->editor_win);
        bookPhonebookStart(data->win, PhbkFromSms);
        break;
    case INFO_KCD_LEFT:
        {
            TRACE_EVENT("INFO_KCD_LEFT");
            //TraceInt(sche_year);
            //TraceInt(sche_month);
            //TraceInt(sche_day);
            TimeAndRing(data->win);
        }
        break;         
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            text_input_destroy(data->editor_win);
        }
        else
        {
            editor_destroy(data->editor_win);
        }
        schedestroy(sche_win);
        break;      
    default:
        break;
    }
    //return MFW_EVENT_CONSUMED;
}

void schedestroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    schedule_data* data   = (schedule_data*)win->user;

    TRACE_EVENT ("schedestroy()");

    if( own_window )
    {
        /* Delete WIN Handler */
        win_delete (own_window);
        /* Free Memory */
        FREE_MEMORY ((void *)data, sizeof (schedule_data));
    }
}

void sche_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    TRACE_EVENT ("sche_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        /* no break; */
    case INFO_KCD_HUP:
        /* no break; */
    case INFO_KCD_RIGHT:
        /* no break; */
    case INFO_KCD_CLEAR:
        //go back to the previous dialog
        SEND_EVENT (sche_win, SCHE_EXIT,0, 0);

        break;
    }
}
/* "ճ"ڴ */
static T_MFW_HND TR_create(MfwHnd parent_win)
{
    TR_data* data = (TR_data *)ALLOC_MEMORY (sizeof (TR_data ));
    T_MFW_WIN  * win;

    //int i=0;

    TRACE_EVENT("TR_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)TR_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)TR_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;
    data->kbd=kbdCreate(data->win, KEY_ALL, (T_MFW_CB)TR_kbd_cb);
    TR_win=data->win;

    winShow(win);
    return data->win;

}
/* "ճ"ʾص */
static int TR_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{
    TR_data         *data = (TR_data *)win->user;
    char            strn[8]; 
    char            string[4];
    int             old_color;
    game_Line       line;
    game_Rectangle  rectangle;

    TD_Line         l;

    TRACE_EVENT ("TR_win_cb()");

    if( data EQ 0 )
        return 1;
    switch( event )
    {
    case E_WIN_VISIBLE:
        TRACE_EVENT("E_WIN_VISIBLE");
        if( win->flags & E_WIN_VISIBLE )
        {
            U8 uMode = 0;
            uMode = dspl_Enable(0);

            /* Clear Screen */
            switch( data->id )
            {
            case TR_TIME:
                TRACE_EVENT("dspl_title");
                dspl_ClearAll();

                /* background display */
                TD_drawBkg(BG_rect, BG_attr);

                /* title display */
                /* 2004/06 sunsj modify for picture manage */
                DRAW_ICON(ICON_MENUUP);
                /*
                dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                             menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                             menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
                */
                /* 2004/05/19yhf modify */
                dspl_colorTextOut(28+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0x0); //ʱ  
                //dspl_colorTextOut(28+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtEnterTime),0x0);
                /****end yhf modify****/

                /* input rect display */
                if( !data->position )         //focus on input rect
                {
                    TD_drawSolidRectangle(AL_input_rect, AL_input_attr1);
                    l       = AL_index_l;
                    /* 2004/05/19yhf modify */
#if(MAIN_LCD_SIZE==4)
                    l.x1    = AL_index_l.x1 + data->index*8;
                    l.x2    = AL_index_l.x2 + data->index*8;
#elif(MAIN_LCD_SIZE==3) 
                    l.x1    = AL_index_l.x1 + data->index*8;
                    l.x2    = AL_index_l.x2 + data->index*8;
#endif
                    /***end yhf modify***/
                    TD_drawLine(l, AL_index_c);
                }
                else
                {
                    TD_drawSolidRectangle(AL_input_rect, AL_input_attr2);
                }
                /* 2004/05/19yhf modify */
#if(MAIN_LCD_SIZE==3)
				dspl_colorTextOut(30+EX, 19, DSPL_TXTATTR_TRANSPARENT, data->time,0 );
#elif(MAIN_LCD_SIZE==4) 
                dspl_colorTextOut(40+EX, 57, DSPL_TXTATTR_TRANSPARENT, data->time,0 );              
#endif
                /**** end yhf modify***/

                /* hint rect dispaly */
                TD_drawSolidRectangle(AL_hint_rect, AL_hint_attr);
                set_font_type(UNI12X12_FONT);
#if(MAIN_LCD_SIZE==4) 
                if( FFS_flashData.time_format==TWENTYFOUR_HOUR )
                {
                    /* 2004/05/19yhf modify */
                    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                        dspl_colorTextOut(37+EX, 83+20, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
                    else
                        dspl_colorTextOut(36+EX, 83+20, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
                }
                else
                {
                    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                        dspl_colorTextOut(37+EX, 103, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
                    else
                        dspl_colorTextOut(36+EX, 103, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
                    /***end yhf modify***/
                }
#elif (MAIN_LCD_SIZE==3)
				if( FFS_flashData.time_format==TWENTYFOUR_HOUR )
                {
                    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                        dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
                    else
                        dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwentyfourHour),0);
                }
                else
                {
                    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
                        dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
                    else
                        dspl_colorTextOut(28+EX, 50, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtTwelveHour),0);
                }
#endif
                /* AM/PM rect display */
                if( FFS_flashData.time_format==TWELVE_HOUR )
                {
                    memset(string,0,4);

                    if( data->AMANDPM )
                        strcpy(string,"PM");
                    else
                        strcpy(string,"AM");    

                    if( data->position )      //focus on AM/PM rect
                    {
                        TD_drawSolidRectangle(AL_AP_rect, AL_AP_attr);

                        DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 44+EX, 84, 0, ICON_LOCATION);
                        DRAW_ICON_ATTRIBUTE(ICON_TIMEARROW_KEY, 73+EX, 84, 1, ICON_LOCATION);
                        //dspl_BitBlt(44+EX, 84, 4, 8, 0, (void *)left_key, 0);
                        //dspl_BitBlt(73+EX, 84, 4, 8, 0, (void *)right_key, 0);
                        /* 2004/05/19yhf modify */
#if (MAIN_LCD_SIZE==3)
						dspl_colorTextOut(44+EX, 36, DSPL_TXTATTR_TRANSPARENT, string, 0xffffff);
#elif (MAIN_LCD_SIZE==4)
                        dspl_colorTextOut(52+EX, 81, DSPL_TXTATTR_TRANSPARENT, string, 0xffffff); 
#endif
                        /*dspl_BitBlt(35+EX, 38, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
                        dspl_BitBlt(35+EX, 38, 4, 8, 0, (void *)left_key_mask, DSPL_BMPAND);
                        dspl_BitBlt(35+EX, 38, 4, 8, 0, (void *)left_key, DSPL_BMPXOR);
                        
                        dspl_BitBlt(64+EX, 38, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);
                        dspl_BitBlt(64+EX, 38, 4, 8, 0, (void *)right_key_mask, DSPL_BMPAND);
                        dspl_BitBlt(64+EX, 38, 4, 8, 0, (void *)right_key, DSPL_BMPXOR);

                        dspl_colorTextOut(44+EX, 36, DSPL_TXTATTR_TRANSPARENT, string, 0xffffff);*/   
                        /***end yhf modify ***/
                    }
                    else
                    {
#if (MAIN_LCD_SIZE==3)
						dspl_colorTextOut(44+EX, 36, DSPL_TXTATTR_TRANSPARENT, string, 0xffffff);
#elif (MAIN_LCD_SIZE==4)
                        dspl_colorTextOut(52+EX, 81, DSPL_TXTATTR_TRANSPARENT, string, 0xffffff); 
#endif                   
					}
                }

                /*  icon display */
                /* 2004/05/19yhf modify */
                /* 2004/06 sunsj modify for picture manage */
#if (MAIN_LCD_SIZE==4)
                DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 13+EX, 59, iconIdAlarm, ICON_MASK|ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 3+EX, 20, iconIdAlarm, ICON_MASK|ICON_LOCATION);
#endif
                /*** end yhf modify ***/

                displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();//jhxu720
#endif
                break;

            case TR_RING:
                //       dspl_ClearAll();/*2003/12/12, wangyan modify*/
                /* 2004/06 sunsj modify for picture manage */
                DRAW_ICON(ICON_MENUUP);
                /*
                dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                             menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                             menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
                */

                if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
                    dspl_colorTextOut(36, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtNewSche), 0x0);
                else
                    dspl_colorTextOut(12, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtNewSche), 0x0);

                // 2004.3.10 WYJ modify embedded popup dialog
                draw_popup_background();
                /* 2004/05/25 sunsj modify */
                //dialog_drawPopIcon(POP_ICONREQUIRE); //2004.3.10 WYJ
                draw_icon_require();
#if(MAIN_LCD_SIZE==3)
                ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtRing);//
#elif(MAIN_LCD_SIZE==4)
                ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtRing);//
#endif
                displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();//jhxu720
#endif
                break;
            default:
                break;
            }

            dspl_Enable(uMode );
        }
        break;
    default:
        break;
    }
    return 1;
}
/* "ճ"¼ 
 * 2003.10.28 wyj 12/24Сʱ */
static void TR_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    TR_data * data = (TR_data *) win_data->user;
    data->id=event;

    TRACE_EVENT("TR_DialogCB");
    switch( event )
    {
    case TR_TIME:                           //ʱ
        TRACE_EVENT("TR_TIME");
        //TraceInt(sche_year);
        //TraceInt(sche_month);
        // TraceInt(sche_day);
        memset((char*)data->time,0,sizeof(data->time));
        //reset_editor(32,60,70,16,0,0,edtCurBar1,0,(char*)data->time,5,&data->editAttr,0);

        //data->editor_handle = edt_create(data->win,&data->editAttr,0,0);
        if( FFS_flashData.time_format==TWELVE_HOUR )
        {
            if( strlen(data->time)==0 )
            {
                /* 2003.10.28 wyj 12/24Сʱ */
                if( currclock.hour < 12 )     //ʾAM
                {
                    data->AMANDPM = 0;
                    sprintf(data->time,"%02d:%02d",currclock.hour,currclock.min);
                }
                else                        //ʾPM
                {
                    data->AMANDPM = 1;
                    if( currclock.hour == 12 )
                        sprintf(data->time,"%02d:%02d",currclock.hour,currclock.min);
                    else
                        sprintf(data->time,"%02d:%02d",currclock.hour-12,currclock.min);
                }                           
            }
        }
        else
        {
            if( strlen(data->time)==0 )
                sprintf(data->time,"%02d:%02d",currclock.hour,currclock.min);
        }
        data->position = 0;
        data->index = 0;

        winShow(win);
        edtChar(data->editor_handle, ecTop);
        break;
    case TR_RING:       
        winShow(win);
        break;
    case TR_EXIT:
        TRdestroy(win);
        break;
    default:
        break;
    }
}
/* ճӵİ 2003.10.16 wyj ޸ģ 
 * 2003.10.28 wyj 12/24Сʱ */
static int TR_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;
    T_MFW_WIN     * win_data2= ((T_MFW_HDR *) sche_win )->data;
    tddata*    calin_data=(tddata*)win_data1->user;
    schedule_data* ScheData=(schedule_data*)win_data2->user;
    T_DISPLAY_DATA   display_info;
    TR_data* data = (TR_data *)win_data->user;
    char hour[3];
    char minute[3];
    int temp_hour;
    int temp_minute;
    int i,k=0;
    int tra;
    int flag=1;
    int t;

    TRACE_EVENT("TR_kbd_cb");
    switch( keyboard->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9: 
        if( data->id==TR_RING )
            break;
        /* 2003.10.16 wyj ޸ģ */
        if( data->id==TR_TIME )
        {
            checkSchNumInput(data, keyboard->code);
        }
        winShow(win);
        break;
    case KCD_MNULEFT:
        if( data->id==TR_RING )
            break;
        if( !data->position )
        {
            /* 2003.10.16 wyj ޸ģ */
            checkSchLeftInput(data);
        }
        else
        {
            data->AMANDPM=!data->AMANDPM;
        }
        winShow(win);
        break;
    case KCD_MNURIGHT:
        if( data->id==TR_RING )
            break;
        if( !data->position )
        {
            /* 2003.10.16 wyj ޸ģ */
            checkSchRightInput(data);
        }
        else
        {
            data->AMANDPM=!data->AMANDPM;
        }
        winShow(win);
        break;
    case KCD_MNUDOWN:
    case KCD_MNUUP:
        if( data->id==TR_RING )
            break;
        if( FFS_flashData.time_format==TWENTYFOUR_HOUR )
            break;
        data->index=0;
        data->position=!data->position;
        winShow(win);
        break;
    case KCD_LEFT:
    case KCD_OK:
        TRACE_EVENT("kcd_left");
        //sche_data[sche_index].time=sche_data[sche_index].time*16+;
        //TraceInt(sche_data.time);
        if( data->id==TR_TIME )
        {
            if( FFS_flashData.time_format==TWELVE_HOUR )
            {
                hour[0]=data->time[0];
                hour[1]=data->time[1];
                minute[0]=data->time[3];
                minute[1]=data->time[4];
                temp_hour=atoi(hour);
                temp_minute=atoi(minute);
                /* 2003.10.28 wyj 12/24Сʱ */
                if( data->AMANDPM )           //PM
                {
                    if( temp_hour<12 && temp_hour>0 )
                        temp_hour += 12;
                }
                memset(data->time,0,8);
                sprintf(data->time,"%02d:%02d",temp_hour,temp_minute);
            }
            if( ((((int)data->time[0]-48)*10+((int)data->time[1]-48))>=24)||((((int)data->time[3]-48)*10+((int)data->time[4]-48))>59) )
            {
                //memset((char*)data->time,0,sizeof(data->time));
                data->index=0;
                dialog_info_init(&display_info);            
                display_info.RightSoftKey = TxtSoftBack;          
                display_info.TextId2     =TxtInputError;
                display_info.TextId      = '\0';
                display_info.Time       = FOREVER;
                display_info.iconindex = REMIND_NORECORD;

                display_info.Callback     = (T_VOID_FUNC)TR_dialog_cb;
                /* Call Info Screen */
                info_dialog (data->win, &display_info);
                SEND_EVENT(TR_win, data->id, 0, 0);
                break;
            }
        }

        if( data->id!=TR_TIME )
        {
            if( data->id==TR_RING )
            {
                sche_data.ringandf=0;
                sche_data.ringandf=sche_data.ringandf+1*16;
                data->id=TR_TIME;
            }
            SEND_EVENT(TR_win, data->id, 0, 0);
        }
        else                                //ճʱȷ
        {
            sche_data.hour=((int)(data->time[0])-48)*10+((int)(data->time[1])-48);
            sche_data.minute=((int)(data->time[3])-48)*10+(int)(data->time[4])-48;
            data->id=TR_RING;
            //edtClear(data->editor_handle);
            //edtHide(data->editor_handle)
            ToolkitTitle=TxtAlarm;
            data->menu_options_win = bookMenuStart(win, FrequOptionScheMenuAttibutes(),PhbkToolkit);
            SEND_EVENT(data->menu_options_win, ADD_CALLBACK, NULL, 0);
            winShow(win);
        }
        break;
    case KCD_RIGHT:    
        if( data->id!=TR_RING )
        {
            if( data->id==TR_TIME )
                data->id=TR_RING;
            SEND_EVENT(data->win, data->id, 0, 0);
        }
        else
        {
            //lxj 
            sche_data.hour=0;
            sche_data.minute=0;
            //lxj
            sche_data.ringandf=0;
            sche_data.ringandf=sche_data.ringandf+0*16;
            while( (ScheDetailIndex[k].index!=0)&&(k<SCHEDULE_NUMBER) )
                k++;

            tra=ScheRecordAddOneIndex(k);   
            dialog_info_init(&display_info);
            if( tra )
            {
                i=0;
                while( ScheIndex[i].index )
                    i++;
                ScheIndex[i].index=ScheDetailIndex[k].index;
                ScheIndex[i].date[0]=ScheDetailIndex[k].date[0];
                ScheIndex[i].date[1]=ScheDetailIndex[k].date[1];
                ScheIndex[i].hour=ScheDetailIndex[k].hour;
                ScheIndex[i].minute=ScheDetailIndex[k].minute;
                ScheIndex[i].wday=ScheDetailIndex[k].wday;                   

                display_info.RightSoftKey = TxtSoftBack;                   
                display_info.TextId2     =TxtSaved;                   
                display_info.Time       = FOREVER;

                display_info.Callback     = (T_VOID_FUNC)no_dialog_cb;
                display_info.iconindex = REMIND_COMPLETE;
            }
            else
            {
                display_info.RightSoftKey = TxtSoftBack;                   
                display_info.TextId2     =TxtError;                   
                display_info.Time       = ONE_SECS;

                display_info.Callback     = (T_VOID_FUNC)no_dialog_cb;
                display_info.iconindex = REMIND_FAILURE;
            }
            /* Call Info Screen */
            info_dialog (data->win, &display_info);
        }
        break;
    case KCD_HUP:
        if( data->id==TR_TIME )
        {
            data->id=TR_RING;
            SEND_EVENT(data->win, data->id, 0, 0);
        }
        else
        {
            TRdestroy(win);
            // schedestroy(sche_win);
        }
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}

void TR_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    TRACE_EVENT ("sche_dialog_cb()");

    SEND_EVENT(TR_win, TR_TIME, 0, 0);
}

void TRdestroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    TR_data* data   = (TR_data*)win->user;

    TRACE_EVENT ("TRdestroy()");

    if( own_window )
    {
        /* Delete WIN Handler */
        win_delete (own_window);
        /* Free Memory  */
        FREE_MEMORY ((void *)data, sizeof (TR_data));
    }
}
/* "ճ" "ȫճ" */
static T_MFW_HND browse_create(MfwHnd parent_win)
{
    ScheBrowse_data* data = (ScheBrowse_data *)ALLOC_MEMORY (sizeof (ScheBrowse_data));
    T_MFW_WIN  * win;
    int i=0;

    TRACE_EVENT("browse_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)browse_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)ScheBrowse_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;
    data->kbd               =kbdCreate(data->win, KEY_ALL, (T_MFW_CB)ScheBrowse_kbd_cb);
    browse_win=data->win;

    return data->win;
}
/* ¼ ¼ */
static void ScheBrowse_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    ScheBrowse_data * data = (ScheBrowse_data *) win_data->user;
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;    
    tddata*    calin_data=(tddata*)win_data1->user;
    int i=0,j;
    T_MFW_SCHE_INDEX t;
    int flag=0;
    T_DISPLAY_DATA    display_info;
    int k=0;
    data->id=event;
    data->index=0;
    data->count=0;

    TRACE_EVENT("browse_DialogCB");
    ScheMemoRead();
    ScheRecordReadOneIndex(1);
    switch( event )
    {
    case SCHEBROWSE_TODAY:
        {   
            browse_flag=SCHEBROWSE_TODAY;
            while( ScheIndex[i].index!=0 )
                i++;
            //TraceInt(i);
            for( j=0;j<i;j++ )
            {
                if( (ScheIndex[j].date[0]==calin_data->calin->year)&&(ScheIndex[j].date[1]/256==calin_data->calin->month)&&
                    (ScheIndex[j].date[1]%256==calin_data->calin->day) )
                {
                    data->count++;
                    copy(&replace[k],&ScheIndex[j]);
                    /*	replace[k].index=ScheIndex[j].index;
                        replace[k].date[0]=ScheIndex[j].date[0];
                        replace[k].date[1]=ScheIndex[j].date[1];
                        replace[k].time=ScheIndex[j].time;*/
                    k++;
                }
            }
            j=data->count;      
            //data->index=0;
            do
            {
                flag=0;
                for( i=0;i<j-1;i++ )
                    //if(((replace[i].hour>replace[i+1].hour)||(replace[i].hour=replace[i+1].hour)&&(replace[i].minute>replace[i+1].minute))&&(replace[i+1].index!=0))
                    //lxj
                    if( (replace[i].hour*60+replace[i].minute>replace[i+1].hour*60+replace[i+1].minute)&&(replace[i+1].index!=0) )
                    //lxj
                    {
                        /*t.date[0]=replace[i].date[0];
                        t.date[1]=replace[i].date[1];
                        t.time=replace[i].time;
                        t.index=replace[i].index;
                        replace[i].date[0]=replace[i+1].date[0];
                        replace[i].date[1]=replace[i+1].date[1];
                        replace[i].time=replace[i+1].time;
                        replace[i].index=replace[i+1].index;
                        replace[i+1].date[0]=t.date[0];
                        replace[i+1].date[1]=t.date[1];
                        replace[i+1].time=t.time;
                        replace[i+1].index=t.index;*/
                        exchange(&replace[i],&replace[i+1]);
                        flag=1;
                    }
                    //TraceInt(replace[j].time);
                j--;
            }while( j&&flag );            
            TRACE_EVENT("the times are:");

            if( data->count==0 )
            {
                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtNorecord;
                display_info.TextId      = '\0';
                display_info.Time       = FOREVER;
                display_info.iconindex = REMIND_NORECORD;

                display_info.Callback     = (T_VOID_FUNC)NULL;                
                /*
                 * Call Info Screen
                 */
                info_dialog (win, &display_info);

                SEND_EVENT(win, SCHEBROWSE_EXIT, 0, 0);
            }
            else
            {
                data->index=0;
                winShow(win);
            }
        }
        break;
    case SCHEBROWSE_ALL:
        TRACE_EVENT("SCHEBROWSE_ALL");
        browse_flag=SCHEBROWSE_ALL;
        data->count=0;
        /*for(i=0;i<10;i++)
            {
              zgzTraceData("ScheIndex[i].date[1]=:", ScheIndex[i].date[1]);
               zgzTraceData("ScheIndex[i].index=:", ScheIndex[i].index);
            }*/
        i=0;
        while( ScheIndex[i].index!=0 )
        {
            data->count++;
            copy(&replace[i],&ScheIndex[i]);
            //replace[i]=ScheIndex[i];
            i++;
        }
        //TraceInt(data->count);
        //TRACE_EVENT("The first time:");
        //for(i=0;i<10;i++)
        //	TraceInt(replace[i].date[1]);
        /*TraceInt(FFS_ScheData.FfsSche[0].date[0]);
        TraceInt(ScheDetailIndex[0].index);
        TraceInt(ScheIndex[0].index);*/
        j=data->count;          
        do
        {
            flag=0;
            for( i=0;i<j-1;i++ )
            {
                if( ((replace[i].date[0]>replace[i+1].date[0])||(replace[i].date[0]==replace[i+1].date[0])&&(replace[i].date[1]>replace[i+1].date[1])||
                     (replace[i].date[0]==replace[i+1].date[0])&&(replace[i].date[1]==replace[i+1].date[1])
                     &&(replace[i].hour*60+replace[i].minute>replace[i+1].hour*60+replace[i+1].minute))&&(replace[i+1].index!=0) )
                {
                    t.date[0]=replace[i].date[0];
                    t.date[1]=replace[i].date[1];
                    t.hour=replace[i].hour;
                    t.minute=replace[i].minute;
                    t.wday=replace[i].wday;
                    t.index=replace[i].index;
                    replace[i].date[0]=replace[i+1].date[0];
                    replace[i].date[1]=replace[i+1].date[1];
                    replace[i].hour=replace[i+1].hour;
                    replace[i].minute=replace[i+1].minute;
                    replace[i].wday=replace[i+1].wday;
                    replace[i].index=replace[i+1].index;
                    replace[i+1].date[0]=t.date[0];
                    replace[i+1].date[1]=t.date[1];
                    replace[i+1].hour=t.hour;
                    replace[i+1].minute=t.minute;
                    replace[i+1].wday=t.wday;
                    replace[i+1].index=t.index;
                    //exchange(&replace[i],&replace[i+1]);
                    flag=1;
                }
            }
            j--;
        }while( j&&flag );
        TRACE_EVENT("The second time:");
        /*for(i=0;i<10;i++)
            {
              zgzTraceData("replace[i].date[1]=:", replace[i].date[1]);
               zgzTraceData("replace[i].index=:", replace[i].index);
            }*/
        if( data->count==0 )
        {
            dialog_info_init(&display_info);
            display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = TxtSoftBack;
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2     =TxtNorecord;
            display_info.TextId      = '\0';
            display_info.Time       = FOREVER;
            display_info.iconindex  = REMIND_NORECORD;

            display_info.Callback     = (T_VOID_FUNC)NULL;
            /* Call Info Screen */
            info_dialog (win, &display_info);

            SEND_EVENT(win, SCHEBROWSE_EXIT, 0, 0);
        }
        else
        {
            data->index=0;
            winShow(win);
        }
        break;          
    case SCHEBROWSE_EXIT:
        ScheBrowse_destroy(win);
        break;
    default:
        break;
    }
}
/* ʾص */
static int browse_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{
    ScheBrowse_data * data = (ScheBrowse_data *)win->user;
    char strn[16];  
    char str1[10];
    T_MFW_SCHE_INDEX  display=replace[data->index];
    int bIndex=0;

    TRACE_EVENT ("browse_win_cb()");

    if( data EQ 0 )
        return 1;

    if( win->flags & E_WIN_VISIBLE )
    {
        /* Clear Screen */
        dspl_ClearAll();
        /* if(data->id==SCHEBROWSE_TODAY)
            {
               display=replace[data->index];
            }
         else
            {
               display=ScheIndex[data->index];
            }*/
        data->flag1=display.index-1;

        //sprintf(str1,"%d/%d",data->index+1,data->count);
        //dspl_colorTextOut(64,0,DSPL_TXTATTR_INVERS,str1,0x4f2f4f);
        switch( data->id )
        {
        case SCHEBROWSE_TODAY: 
        case SCHEBROWSE_ALL:
            //TRACE_EVENT("SCHEBROWSE_TODAY");
            //ScheRecordReadOneIndex(display.index-1);
            if( (display.index-1)<70 )
            {
                bIndex=display.index-1;
            }
            else if( (display.index-1)<140 )
            {
                bIndex=display.index-70-1;
                //data->flag=1;
            }
            else
            {
                bIndex=display.index-140-1;
                //data->flag=2;
            }
            data->flag=bIndex;
            BrowseDisplay(&FFS_ScheData.FfsSche[bIndex],data);
            /*if((display.index-1)<70)
                {
                
                //Flash_ScheRead((char *)ScheTable[0]); 
                if(FFS_ScheData.FfsSche[display.index-1].type==MEETING)
                    {
                      PROMPT(30,0,0, TxtMeeting);
                    }
                else if(FFS_ScheData.FfsSche[display.index-1].type==BIRTHDAY)
                    {
                      PROMPT(30,0,0, TxtBirthday);
                    }
                else if(FFS_ScheData.FfsSche[display.index-1].type==APPOINTMENT)
                    {
                      PROMPT(30,0,0, TxtAppointment);
                    }
                else if(FFS_ScheData.FfsSche[display.index-1].type==PHONE)
                    {
                      PROMPT(30,0,0, TxtPhone);
                    }
                else{
                    PROMPT(30,0,0, TxtRemind);
                    }
            sprintf(strn,"%d.%d.%d %d%d:%d%d",FFS_ScheData.FfsSche[display.index-1].date[0],
                FFS_ScheData.FfsSche[display.index-1].date[1]/256,FFS_ScheData.FfsSche[display.index-1].date[1]%256,
                FFS_ScheData.FfsSche[display.index-1].time/4096,FFS_ScheData.FfsSche[display.index-1].time%4096/256,
                FFS_ScheData.FfsSche[display.index-1].time%4096%256/16,FFS_ScheData.FfsSche[display.index-1].time%4096%256%16);
            sprintf(str1,"%d/%d",data->index+1,data->count);
            dspl_colorTextOut(64,0,DSPL_TXTATTR_INVERS,str1,0x4f2f4f);
            dspl_TextOut(0, 16, 0, strn);
            dspl_TextOut(0, 48, 0, (char *)FFS_ScheData.FfsSche[display.index-1].text);
            data->flag=(display.index-1)*16+0;
            displaySoftKeys(TxtSelect,TxtSoftBack);//confirm          			
                }
            else if(data->index<140)
                {
                Flash_ScheRead((char *)ScheTable[1]);
                if(FFS_ScheData.FfsSche[display.index-70-1].type==MEETING)
                    {
                      PROMPT(30,0,0, TxtMeeting);
                    }
                else if(FFS_ScheData.FfsSche[display.index-70-1].type==BIRTHDAY)
                    {
                      PROMPT(30,0,0, TxtBirthday);
                    }
                else if(FFS_ScheData.FfsSche[display.index-70-1].type==APPOINTMENT)
                    {
                      PROMPT(30,0,0, TxtAppointment);
                    }
                else if(FFS_ScheData.FfsSche[display.index-70-1].type==PHONE)
                    {
                      PROMPT(30,0,0, TxtPhone);
                    }
                else{
                    PROMPT(30,0,0, TxtRemind);
                    }
            sprintf(strn,"%d.%d.%d %d:%d",FFS_ScheData.FfsSche[display.index-70-1].date[0],
                FFS_ScheData.FfsSche[display.index-70-1].date[1]/256,FFS_ScheData.FfsSche[display.index-70-1].date[1]%256,
                FFS_ScheData.FfsSche[display.index-70-1].time/256,FFS_ScheData.FfsSche[display.index-70-1].time%256);
            sprintf(str1,"%d/%d",data->index+1,data->count);
            dspl_colorTextOut(64,0,DSPL_TXTATTR_INVERS,str1,0x4f2f4f);
            dspl_TextOut(0, 16, 0, strn);
            dspl_TextOut(0, 48, 0, (char *)FFS_ScheData.FfsSche[display.index-70-1].text);
            data->flag=(display.index-70-1)*16+1;
            displaySoftKeys(TxtSelect,TxtSoftBack);//confirm
                }
            else{
                Flash_ScheRead((char *)ScheTable[2]);
                if(FFS_ScheData.FfsSche[display.index-140-1].type==MEETING)
                    {
                      PROMPT(30,0,0, TxtMeeting);
                    }
                else if(FFS_ScheData.FfsSche[display.index-140-1].type==BIRTHDAY)
                    {
                      PROMPT(30,0,0, TxtBirthday);
                    }
                else if(FFS_ScheData.FfsSche[display.index-140-1].type==APPOINTMENT)
                    {
                      PROMPT(30,0,0, TxtAppointment);
                    }
                else if(FFS_ScheData.FfsSche[display.index-140-1].type==PHONE)
                    {
                      PROMPT(30,0,0, TxtPhone);
                    }
                else{
                    PROMPT(30,0,0, TxtRemind);
                    }
            sprintf(strn,"%d.%d.%d %d:%d",FFS_ScheData.FfsSche[display.index-140-1].date[0],
                FFS_ScheData.FfsSche[display.index-140-1].date[1]/256,FFS_ScheData.FfsSche[display.index-140-1].date[1]%256,
                FFS_ScheData.FfsSche[display.index-140-1].time/256,FFS_ScheData.FfsSche[display.index-140-1].time%256);
            sprintf(str1,"%d/%d",data->index+1,data->count+1);
            dspl_colorTextOut(64,0,DSPL_TXTATTR_INVERS,str1,0x4f2f4f);
            dspl_TextOut(0, 16, 0, strn);
            dspl_TextOut(0, 48, 0, (char *)FFS_ScheData.FfsSche[display.index-140-1].text);
            data->flag=(display.index-140-1)*16+2;
            displaySoftKeys(TxtSelect,TxtSoftBack);//confirm*/                                  
            break;
        default:
            break;
        }
    }
    return 1;
}
/* ճ  */
static int ScheBrowse_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    ScheBrowse_data * data=(ScheBrowse_data *)win_data->user;

    TRACE_EVENT("ScheBrowse_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_LEFT:
    case KCD_OK:
        change_index=data->flag;
        if( data->id==SCHEBROWSE_TODAY )
            ToolkitTitle=TxtToday;
        else if( data->id==SCHEBROWSE_ALL )
            ToolkitTitle=TxtAllSche;
        data->menu_options_win = bookMenuStart(data->win, BrowseOptionMenuAttibutes(),PhbkToolkit);
        SEND_EVENT(data->menu_options_win, ADD_CALLBACK, NULL, 0);
        break;
    case KCD_MNUDOWN:
        data->index++;
        if( data->index>=data->count )
            data->index=0;
        //data->flag1=data->index;
        winShow(data->win);
        break;
    case KCD_MNUUP:
        data->index--;
        if( data->index<0 )
            data->index=data->count-1;
        //data->flag1=data->index;
        winShow(data->win);
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        SEND_EVENT(data->win, SCHEBROWSE_EXIT, 0, 0);
        break;
    default:
        break;
    }

    return MFW_EVENT_CONSUMED;
}

void ScheBrowse_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    ScheBrowse_data* data   = (ScheBrowse_data*)win->user;

    TRACE_EVENT ("ScheBrowse_destroy()");


    if( own_window )
    {
        /* Delete WIN Handler  */
        win_delete (own_window);
        /* Free Memory  */
        FREE_MEMORY ((void *)data, sizeof (ScheBrowse_data));
    }
}

static void BrowseCB( T_MFW_HND win,USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    change_data   *data       = (change_data *) win_data->user;  
    T_DISPLAY_DATA    display_info;

    TRACE_EVENT("BrowseCB");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            TRACE_EVENT("INFO_KCD_LEFT");
            memcpy((char*)FFS_ScheData.FfsSche[change_index].text,(char*)data->string,SCHE_LEN);
            //TRACE_EVENT((char *)FFS_ScheData.FfsSche[change_index].text);
            Flash_ScheWrite((char*)CurrentScheFileName);

            // TRACE_EVENT((char *)CurrentScheFileName);

            dialog_info_init(&display_info);
            display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = TxtSoftBack;
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2     =TxtSaved;
            display_info.TextId      = '\0';
            display_info.Time       = FOREVER;

            display_info.Callback     = (T_VOID_FUNC)NULL;//TR_dialog_cb;
            display_info.iconindex = REMIND_COMPLETE;
            /*
             * Call Info Screen
             */
            info_dialog (win, &display_info); 
            SEND_EVENT(data->win, CHANGE_EXIT, 0, 0);
            //bookMenuDestroy(menu_win);
        }
        break;         
    case INFO_KCD_RIGHT:
        SEND_EVENT(data->win, CHANGE_EXIT, 0, 0);
        break;
    case INFO_KCD_HUP:
        SEND_EVENT(data->win, CHANGE_EXIT, 0, 0);
        break;
    default:
        break;
    }
    //return MFW_EVENT_CONSUMED;
}

static T_MFW_HND change_create(MfwHnd parent_win)
{
    change_data* data = (change_data *)ALLOC_MEMORY (sizeof (change_data));
    T_MFW_WIN  * win;


    TRACE_EVENT("browse_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, 0);//(T_MFW_CB)browse_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)change_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;
    //data->kbd               =kbdCreate(data->win, KEY_ALL, (T_MFW_CB)ScheBrowse_kbd_cb);
    //browse_win=data->win;

    return data->win;
}

static void change_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_DISPLAY_DATA   display_info;
    T_SmsUserData    SmsData; 
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    change_data  * data  = (change_data *) win_data->user;
    data->data1= (ScheBrowse_data *)parameter;   


    switch( event )
    {
    case CHANGE_INIT:           
        ChangeSetEditor(win);//set editor with default attribute values			
        data->editor_data.Callback          = (T_EDIT_CB)BrowseCB;
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            data->editor_win = text_input(win, &data->editor_data);
        }
        else
        {
            data->editor_win = editor_start(win, &(data->editor_data));
        }

        //winShow(win);
        break;
    case CHANGE_SMS:
        if( wstrlen(FFS_ScheData.FfsSche[change_index].text)<MAX_MSG_LEN_ARRAY )
        {
            SmsData.Send_state= E_FORWARD; 
            memset(SmsData.TextBuffer,0,sizeof(SmsData.TextBuffer));
            memset(SmsData.NumberBuffer,0,sizeof(SmsData.NumberBuffer));
            SmsData.called_from_reply_item=FALSE;
            memcpy(SmsData.TextBuffer,FFS_ScheData.FfsSche[change_index].text,wstrlen(FFS_ScheData.FfsSche[change_index].text));      
            SmsSend_SEND_start( win, (void *) &SmsData );
            // change_destroy(win);                
        }
        else
        {
            dialog_info_init(&display_info);
            display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = '\0';
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2     =TxtTooLong;
            display_info.TextId      = '\0';
            display_info.Time       = ONE_SECS;

            display_info.Callback     = (T_VOID_FUNC)scheSMS_dialog_cb;
            /* Call Info Screen */
            info_dialog (data->win, &display_info);
        }
        break;
    case CHANGE_EXIT:
    case E_BACK:
    case E_RETURN:
        change_destroy(win);
        break;
    }   
}

void scheSMS_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data= ((T_MFW_HDR *) win )->data;
    change_data*    data=(change_data* )win_data->user;

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:
        break;
    default:
        break;
    }
    change_destroy(win);    
}

void ChangeSetEditor(T_MFW_HND win)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    change_data  * data  = (change_data *) win_data->user;
    int TxtID,mode;

    switch( FFS_ScheData.FfsSche[change_index].type )
    {
    case MEETING:
        TxtID=TxtScheMeeting;
        mode  = TEXTINPUT_MODE;     /* 2003/12/04 sunsj modify */
        break;
    case BIRTHDAY:
        TxtID=TxtBirthday;
        mode  = TEXTINPUT_MODE;     /* 2003/12/04 sunsj modify */
        break;
    case APPOINTMENT:
        TxtID=TxtAppointment;
        mode  = TEXTINPUT_MODE;     /* 2003/12/04 sunsj modify */
        break;
    case PHONE:
        TxtID=TxtPhone;
        mode=PHONENUMONLY_MODE;
        break;
    case REMIND:
        TxtID=TxtRemind;
        mode  = TEXTINPUT_MODE;     /* 2003/12/04 sunsj modify */
        break;
    default:
        break;
    }
    memset(data->string,0,sizeof(data->string));
    memcpy((char*)data->string,(char*)FFS_ScheData.FfsSche[change_index].text,SCHE_LEN);
    editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtID, (char*)data->string, SCHE_LEN, edtCurBar1);
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings

    data->editor_data.Identifier        = 0xFFFF ; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = TRUE;
    //data->editor_data.editor_attr.text	= (char *)FFS_ScheData.FfsSche[change_index].text; 
    //data->editor_data.editor_attr.size	= 98; 

    /* 2003/12/04 sunsj remove the textid */
    //data->editor_data.TextId            = TxtID;
    data->editor_data.TextId            = '\0';
    data->editor_data.LeftSoftKey       = TxtSoftOK;//comfirm

    data->editor_data.AlternateLeftSoftKey  = TxtNull;
    data->editor_data.RightSoftKey      = TxtDelete;
    data->editor_data.mode=mode;
    /* 2003/12/04 sunsj set default input mode */
    if( data->editor_data.mode == TEXTINPUT_MODE )
    {
        data->editor_data.InputMode = PINYIN_INPUT_MODE;
    }
}

void change_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    change_data* data   = (change_data*)win->user;

    TRACE_EVENT ("change_destroy()");


    if( own_window )
    {
        /*
         * Delete WIN Handler
         */


        win_delete (own_window);
        /*
         * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (change_data));
    }
}


void type_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;
    T_MFW_WIN     * win_data2= ((T_MFW_HDR *) sche_win )->data;
    tddata*    calin_data=(tddata* )win_data1->user;
    schedule_data* ScheData=(schedule_data*)win_data2->user;
    TRACE_EVENT ("sche_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:
        break;
    default:
        break;
    }

    bookMenuDestroy(win);            
    TRdestroy(TR_win);   
    /* 2003/12/04 sunsj modify for new editor mode */
    if( ScheData->editor_data.mode == TEXTINPUT_MODE )
    {
        text_input_destroy(ScheData->editor_win);
    }
    else
    {
        editor_destroy(ScheData->editor_win);
    }
    schedestroy(sche_win);  
    //bookMenuDestroy(ScheData->menu_options_win);       
    bookMenuDestroy(calin_data->menu_options_win);
    //calin_destroy(calin_win); 
}

void old_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data= ((T_MFW_HDR *) calin_win )->data;
    tddata*    calin_data=(tddata* )win_data->user;

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:
        break;
    default:
        break;
    }

    all_destroy(win);
    bookMenuDestroy(calin_data->menu_options_win); 
    // calin_destroy(calin_win);
    showAlarmIcon();
}

void old_dialog_cb1(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data= ((T_MFW_HDR *) calin_win )->data;
    tddata*    calin_data=(tddata* )win_data->user;
    int i,j=0;
    T_DISPLAY_DATA    display_info;


    switch( reason )
    {
    case INFO_TIMEOUT:
        i=0;
        memset(&ScheIndex,0,SCHEDULE_NUMBER*sizeof(T_MFW_SCHE_INDEX));
        for( j=0;j<SCHEDULE_NUMBER;j++ )
        {
            if( ScheDetailIndex[j].index )
            {
                ScheIndex[i].date[0]=ScheDetailIndex[j].date[0];
                ScheIndex[i].date[1]=ScheDetailIndex[j].date[1];
                ScheIndex[i].wday=ScheDetailIndex[j].wday;
                //ScheDetailIndex[ScheIndex[k].index-1].hour=0;//lxj delete
                //  ScheDetailIndex[ScheIndex[k].index-1].minute=0;//lxj delete
                ScheIndex[i].index=ScheDetailIndex[j].index;
                //lxj
                ScheIndex[i].hour=ScheDetailIndex[j].hour;
                ScheIndex[i].minute=ScheDetailIndex[j].minute;
                //lxj
                i++;
            }
        }
        dialog_info_init(&display_info);
        display_info.TextId2     =TxtDeleted;                         
        display_info.Time       = ONE_SECS;
        display_info.Callback     = (T_VOID_FUNC)NULL;
        display_info.iconindex  = REMIND_SUCCEED; 
        info_dialog(win, &display_info);
        break;
    default:
        break;
    }
    all_destroy(win);
    bookMenuDestroy(calin_data->menu_options_win); 
    // calin_destroy(calin_win);
    showAlarmIcon();
}
/* ɾ¼ ڴ */
static T_MFW_HND all_create(MfwHnd parent_win)
{
    all_data* data = (all_data *)ALLOC_MEMORY (sizeof (all_data));
    T_MFW_WIN  * win;


    TRACE_EVENT("all_create");
    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_win, 0, E_WIN_VISIBLE, 0);//(T_MFW_CB)browse_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)all_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_win;
    data->kbd               =kbdCreate(data->win, KEY_ALL, (T_MFW_CB)all_kbd_cb);
    //browse_win=data->win;

    return data->win;
}
/* ɾ¼ ڴ */
static void all_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    all_data  * data  = (all_data *) win_data->user;
    T_DISPLAY_DATA display_data;
    int old_color;
    game_Line line;
    data->id=event;

    switch( event )
    {
    case ALL_INIT:
        //       dspl_ClearAll();/*2003/12/12, wangyan modify*/

        // 2004.3.10 WYJ modify embedded popup dialog
        draw_popup_background();
        /* 2004/05/25 sunsj modify */
        draw_icon_require();
        //dialog_drawPopIcon(POP_ICONREQUIRE);

        /* 2004/05/25 sunsj modify */
#if(MAIN_LCD_SIZE==3)
		ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtDeleteAll);//ȫɾ
#elif(MAIN_LCD_SIZE==4)
		ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtDeleteAll);//ȫɾ
#endif
        displaySoftKeys(TxtSoftOK,TxtSoftBack);/*2003/12/1, wangyan modify*/
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        break;

    case OLD_SCHEDULE:

        // 2004.3.10 WYJ modify embedded popup dialog
        draw_popup_background();
        /* 2004/05/25 sunsj modify */
        draw_icon_require();
        //dialog_drawPopIcon(POP_ICONREQUIRE);

#if(MAIN_LCD_SIZE==3)
		ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtDelete);//ɾ
#elif(MAIN_LCD_SIZE==4)
		ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtDelete);//ɾ
#endif
        displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        ScheMemoRead();
        Flash_ScheRead((char *)ScheTable[0]);
        break;
    case ALL_EXIT:
        all_destroy(win);
        break;
    }
}

void all_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    all_data* data   = (all_data*)win->user;

    TRACE_EVENT ("all_destroy()");

    // if((!ScheIndex[0].index)&&(data->id)==ALL_INIT)
    // 	SEND_EVENT(data->info_win, DIALOG_DESTROY, 0, 0);
    if( own_window )
    {
        /* Delete WIN Handler */
        win_delete (own_window);
        /* Free Memory */
        FREE_MEMORY ((void *)data, sizeof (all_data));
    }
}
/* ɾ¼  */
static int all_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_DISPLAY_DATA    display_info;
    all_data * data=(all_data *)win_data->user;  
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;
    tddata*    calin_data=(tddata* )win_data1->user;
    // T_DISPLAY_DATA    display_info;
    BOOL delete_flag=FALSE;
    int i,k=0, j=0;
    int oi=201,filenumber;
    T_MFW_SCHE_INDEX t;
    int flag=0;
    int monthandday;

    TRACE_EVENT("ScheBrowse_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_LEFT:       
        if( data->id==ALL_INIT )
        {
            if( ScheIndex[0].index )
            {
                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2      = '\0';
                display_info.TextId       = '\0';
                display_info.Time         = 5*ONE_SECS;

                display_info.Callback     = (T_VOID_FUNC)all_dialog_cb;
                display_info.Identifier=0;
                display_info.iconindex=REMIND_DELETING;
                /*
                 * Call Info Screen
                 */
                data->info_win=info_dialog (data->win, &display_info);                        
            }
            else
            {
                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2      = TxtNorecord;
                display_info.TextId       = '\0';
                display_info.Time         = FOREVER;

                display_info.Callback     = (T_VOID_FUNC)all_dialog_cb;
                display_info.Identifier=0;
                display_info.iconindex=REMIND_NORECORD;
                /*
                 * Call Info Screen
                 */
                data->info_win=info_dialog (data->win, &display_info);
                // all_destroy(win);
                // bookMenuDestroy(calin_data->menu_options_win); 
            }
        }
        else
        {
            monthandday=calin_data->calin->month*256+calin_data->calin->day;
            while( (ScheIndex[k].index)&&(k<71) )
            {
                if( (((ScheIndex[k].date[0]<calin_data->calin->year)||((ScheIndex[k].date[0]==calin_data->calin->year)&&(ScheIndex[k].date[1]<monthandday))||
                      ((ScheIndex[k].date[0]==calin_data->calin->year)&&(ScheIndex[k].date[1]==monthandday)&&(ScheIndex[k].hour<calin_data->calin->hour))
                      //    ||((ScheIndex[k].date[0]==currdate.year)&&(ScheIndex[k].date[1]==monthandday)&&(ScheIndex[k].hour==currclock.hour)&&(ScheIndex[k].hour<currclock.min)))
                      ||((ScheIndex[k].date[0]==calin_data->calin->year)&&(ScheIndex[k].date[1]==monthandday)&&(ScheIndex[k].hour==calin_data->calin->hour)&&(ScheIndex[k].minute<calin_data->calin->minute)))
                     &&(FFS_ScheData.FfsSche[ScheIndex[k].index-1].ringandf%16==ONCE)&&(FFS_ScheData.FfsSche[ScheIndex[k].index-1].ringandf/16))||
                    (((ScheIndex[k].date[0]<calin_data->calin->year)||((ScheIndex[k].date[0]==calin_data->calin->year)&&(ScheIndex[k].date[1]<monthandday)))&&(FFS_ScheData.FfsSche[ScheIndex[k].index-1].ringandf/16==0)) )
                {
                    if( ScheIndex[k].index<SCHEDULE_NUMBER )
                    {
                        oi=ScheIndex[k].index-1;
                        filenumber=0;
                    }
                    /*  else if(ScheIndex[k].index<140)
                        {
                           oi=ScheIndex[k].index-70-1;
                           filenumber=1;
                        }
                          else
                            {
                              oi=ScheIndex[k].index-140-1;
                              filenumber=2;
                            }*/
                    if( oi<201 )
                    {
                        //if(strcmp((char *)CurrentScheFileName,(char *)ScheTable[filenumber]))
                        //    Flash_ScheRead((char *)ScheTable[0]);     	  	   
                        FFS_ScheData.FfsSche[oi].date[0]    = 0;
                        FFS_ScheData.FfsSche[oi].date[1]    = 0;
                        FFS_ScheData.FfsSche[oi].hour       = 0;
                        FFS_ScheData.FfsSche[oi].minute     = 0;
                        FFS_ScheData.FfsSche[oi].ringandf   = 0;
                        FFS_ScheData.FfsSche[oi].type       = 0;
                        strcpy((char*)FFS_ScheData.FfsSche[oi].text,"");                                                         
                        ScheDetailIndex[ScheIndex[k].index-1].index     = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].date[0]   = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].date[1]   = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].wday      = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].hour      = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].minute    = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].number    = 0;
                        ScheDetailIndex[ScheIndex[k].index-1].ringandt  = 0;
                        ScheIndex[k].index      = 0;
                        ScheIndex[k].date[0]    = 0;
                        ScheIndex[k].date[1]    = 0;
                        ScheIndex[k].wday       = 0;
                        ScheIndex[k].hour       = 0;
                        ScheIndex[k].minute     = 0;
                        flag=1;    
                    }
                    oi=201;
                    delete_flag=TRUE;
                }
                k++;
            }
            Flash_ScheWrite((char *)ScheTable[0]); 
            set_latest_alarm();

            if( delete_flag&&(k<20) )
            {
                i=0;
                //lxj
                memset(&ScheIndex,0,SCHEDULE_NUMBER*sizeof(T_MFW_SCHE_INDEX));
                //lxj
                for( j=0;j<SCHEDULE_NUMBER;j++ )
                {
                    if( ScheDetailIndex[j].index )
                    {
                        ScheIndex[i].date[0]=ScheDetailIndex[j].date[0];
                        ScheIndex[i].date[1]=ScheDetailIndex[j].date[1];
                        ScheIndex[i].wday=ScheDetailIndex[j].wday;
                        //ScheDetailIndex[ScheIndex[k].index-1].hour=0;//lxj delete
                        //  ScheDetailIndex[ScheIndex[k].index-1].minute=0;//lxj delete
                        ScheIndex[i].index=ScheDetailIndex[j].index;
                        //lxj
                        ScheIndex[i].hour=ScheDetailIndex[j].hour;
                        ScheIndex[i].minute=ScheDetailIndex[j].minute;
                        //lxj
                        i++;
                    }
                }
            }
            dialog_info_init(&display_info);
            if( delete_flag )
            {
                if( k<20 )
                {
                    display_info.TextId2     =TxtDeleted;                         
                    display_info.Time       = FOREVER;
                    display_info.Callback     = (T_VOID_FUNC)old_dialog_cb;
                    display_info.iconindex  = REMIND_COMPLETE;                      
                }
                else
                {
                    display_info.TextId2     =TxtDeletingSms;                         
                    display_info.Time       = ONE_SECS;
                    display_info.Callback     = (T_VOID_FUNC)old_dialog_cb1;
                    display_info.iconindex  = REMIND_DELETING;
                }                                           
            }
            else
            {
                display_info.TextId2     =TxtNorecord;                      
                display_info.Time       = FOREVER;

                display_info.Callback     = (T_VOID_FUNC)old_dialog_cb;
                display_info.iconindex  = REMIND_NORECORD;                          
            }
            info_dialog (data->win, &display_info);  
        }
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        SEND_EVENT(data->win, ALL_EXIT, 0, 0);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}
/* ɾճ */
void all_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;
    tddata*    calin_data=(tddata* )win_data1->user;
    T_DISPLAY_DATA display_info;
    int i;

    TRACE_EVENT("all_dialog_cb");
    switch( reason )
    {
    case INFO_KCD_LEFT:
        break;
    case INFO_KCD_RIGHT:
        all_destroy(win);
        return;
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:          
        break;
    default:
        break;
    }  
    for( i=0;i<3;i++ )
    {
        Flash_ScheRead((char *)ScheTable[i]);
        FlashScheDataInitialise();
        Flash_ScheWrite((char *)ScheTable[i]);
        set_latest_alarm();
    }
    for( i=0;i<SCHEDULE_NUMBER;i++ )
    {
        ScheDetailIndex[i].index=0;
        ScheDetailIndex[i].date[0]=0;
        ScheDetailIndex[i].date[1]=0;
        ScheDetailIndex[i].hour=0;
        ScheDetailIndex[i].minute=0;
        ScheDetailIndex[i].wday=0;
        ScheDetailIndex[i].number=0;
        ScheDetailIndex[i].ringandt=0;
        ScheIndex[i].index=0;
        ScheIndex[i].date[0]=0;
        ScheIndex[i].date[1]=0;
        ScheIndex[i].hour=0;
        ScheIndex[i].minute=0;
        ScheIndex[i].wday=0;
    }
    all_destroy(win);
    bookMenuDestroy(calin_data->menu_options_win); 
    // calin_destroy(calin_win);
    showAlarmIcon();
    dialog_info_init(&display_info);
    display_info.TextId2= TxtDeleted;
    display_info.Time       =ONE_SECS;
    display_info.iconindex=REMIND_SUCCEED;
    info_dialog (win, &display_info);
}

static void sche_menu_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) parent_win )->data;
    schedule_data* data = (schedule_data*) win_data->user;
    //set menu window to NULL to prevent any dealloc problems
    TRACE_EVENT("sche_menu_cb")

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:
        break;
    default:
        break;
    }
    schedestroy(sche_win);
}

void no_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data1= ((T_MFW_HDR *) calin_win )->data;
    T_MFW_WIN     * win_data2= ((T_MFW_HDR *) sche_win )->data;
    tddata*    calin_data=(tddata*)win_data1->user;
    schedule_data* ScheData=(schedule_data*)win_data2->user;
    int i,k=0;
    int tra;
    TRACE_EVENT ("no_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:
        break;
    default:
        break;
    }

    SEND_EVENT(TR_win, TR_EXIT, 0, 0);
    // bookMenuDestroy(ScheData->menu_options_win);
    /* 2003/12/04 sunsj modify for new editor mode */
    if( ScheData->editor_data.mode == TEXTINPUT_MODE )
    {
        text_input_destroy(ScheData->editor_win);
    }
    else
    {
        editor_destroy(ScheData->editor_win);
    }
    schedestroy(sche_win);
    bookMenuDestroy(calin_data->menu_options_win);     
}

void delete_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN * win_data   = ( (T_MFW_HDR *) browse_win )->data;
    ScheBrowse_data *   data =(ScheBrowse_data *)win_data->user;
    T_MFW_WIN * win_data1   = ( (T_MFW_HDR *) calin_win )->data;
    tddata * data1 =(tddata *)win_data1->user;

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:
    case INFO_KCD_HUP:
        break;
    default:
        break;
    }  
    ScheMemoRead();
    bookMenuDestroy(data->menu_options_win);
    ScheBrowse_destroy(browse_win); 
    bookMenuDestroy(data1->menu_options_win);
    // SEND_EVENT(browse_win, browse_flag, 0, 0);
}
//--------------------------------------
//k : index of the record saved in the file.һճ
int  ScheRecordAddOneIndex(int k)
{
    T_MFW_WIN * win_data   = ( (T_MFW_HDR *) calin_win)->data;
    tddata*   data =(tddata *)win_data->user;
    int indexNumber;
    unsigned char TableIndex;
    char temp_str[4];
    char string[20];
    int iTemp;
    int i=0;

    TRACE_EVENT("ScheRecordAddOneIndex");
    sche_data.date[0]=data->year;
    sche_data.date[1]=data->month*256+data->day;
    sche_data.wday=data->wday;
    TraceInt(data->year);
    TraceInt(data->month);
    TraceInt(data->day);
    if( k>199 ) return FALSE;
    if( k<SCHEDULE_NUMBER )
    {
        indexNumber=k;
        TableIndex=0;
    }
    else if( k<140 )
    {
        indexNumber=k-SCHEDULE_NUMBER;
        TableIndex=1;          
    }
    else
    {
        indexNumber=k-140;
        TableIndex=2;          
    }
    TRACE_EVENT("Read File Count");
    if( strcmp((char*)CurrentScheFileName,(char*) ScheTable[TableIndex])!=0 )
        iTemp=Flash_ScheRead((char *) ScheTable[TableIndex]);
    // TraceInt(iTemp);
    TRACE_EVENT((char*)CurrentScheFileName);
    //TRACE_EVENT((char*)FFS_ScheData.FfsSche[0].text);
    //TRACE_EVENT((char*)FFS_ScheData.FfsSche[1].text);
    Sche_Copy(&FFS_ScheData.FfsSche[indexNumber], &sche_data);
    //FFS_ScheData.FfsSche[indexNumber]=sche_data; 
    ScheDetailIndex[indexNumber].index=k+1;
    ScheDetailIndex[indexNumber].date[0]=sche_data.date[0];
    ScheDetailIndex[indexNumber].date[1]=sche_data.date[1];
    ScheDetailIndex[indexNumber].hour=sche_data.hour;
    ScheDetailIndex[indexNumber].minute=sche_data.minute;
    ScheDetailIndex[indexNumber].wday=sche_data.wday;
    ScheDetailIndex[indexNumber].ringandt=sche_data.ringandf/16*16+sche_data.type;

    Flash_ScheWrite((char *) ScheTable[TableIndex]);  
    memset(temp_str,0,sizeof(temp_str));        
    sprintf(temp_str,"%d",FFS_ScheData.FfsSche[indexNumber].ringandf%16);
    // TRACE_EVENT("ring frequency");
    // TRACE_EVENT(temp_str);
    memset(temp_str,0,sizeof(temp_str));        
    sprintf(temp_str,"%d",indexNumber);
    // TRACE_EVENT("indexNumber");
    // TRACE_EVENT(temp_str);
    memset(temp_str,0,sizeof(temp_str));
    memset(string,0,sizeof(string));
    sprintf(temp_str,"%d",sche_data.ringandf/16);
    // TRACE_EVENT("if ring is on or off");
    //  TRACE_EVENT(temp_str);
    memset(temp_str,0,sizeof(temp_str));
    sprintf(temp_str,"%d",sche_data.ringandf%16);
    //  TRACE_EVENT("the type of ring");
    //  TRACE_EVENT(temp_str);
    memset(temp_str,0,sizeof(temp_str));
    sprintf(temp_str,"%d",sche_data.wday);
    // TRACE_EVENT("week day");
    // TRACE_EVENT(temp_str);
    //  zgzTraceData("sche_data.type=", sche_data.type);     	  
    if( sche_data.ringandf/16 )
        set_latest_alarm();
    showAlarmIcon();
    return iTemp;
} 
//--------------------------------------
//k : index of the record saved in the file.
int  ScheRecordReadOneIndex(int k)
{
    int iIndex;
    if( k<SCHEDULE_NUMBER )
        iIndex=0;
    else if( k<140 )
        iIndex=1;
    else iIndex=2;         

    if( strcmp((char*)CurrentScheFileName,(char*)ScheTable[iIndex])==0 )
    {
        TRACE_EVENT("Current File is existed");
        return FALSE;
    }
    else
    {
        while( !Flash_ScheRead((char *)ScheTable[iIndex]) );
        strcpy((char*)CurrentScheFileName,(char*)ScheTable[iIndex]);
    }
    return TRUE;   
}
/* ʾһճ */
void BrowseDisplay(FlashSchedule * data,ScheBrowse_data* t)
{
    char strn[20];  
    char str1[10];
    char stime[6];

    TRACE_EVENT("BrowseDisplay");

    /* 2004/05/18 yhf modify */
    /* title display */
    if( data->type==MEETING )
    {
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
            PROMPT(50+EX,0,0, TxtScheMeeting);
        else
            PROMPT(30+EX,0,0,TxtScheMeeting);
    }
    else if( data->type==BIRTHDAY )
    {
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
            PROMPT(50+EX,0,0, TxtBirthday);
        else
            PROMPT(30+EX,0,0,TxtBirthday);
    }
    else if( data->type==APPOINTMENT )
    {
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
            PROMPT(50+EX,0,0, TxtAppointment);
        else
            PROMPT(24+EX,0,0,TxtAppointment);//2004/07/01 yhf modify
    }
    else if( data->type==PHONE )
    {
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
            PROMPT(50+EX,0,0, TxtPhone);
        else
            PROMPT(30+EX,0,0, TxtPhone);
    }
    else
    {
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
            PROMPT(50+EX,0,0, TxtRemind);
        else
            PROMPT(30+EX,0,0, TxtRemind);
    } 
	//2004/07/01 yhf modify
    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
	{		
		if( data->ringandf/16 )               //
			DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 33+EX, 2, iconIdAlarm, ICON_MASK|ICON_LOCATION);	
    }
	else
	{
		if( data->ringandf/16 )  
			DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 1+EX, 2, iconIdAlarm, ICON_MASK|ICON_LOCATION);		
	}
	if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
    {
            /* 2004/06 sunsj modify for picture manage */
            //dspl_BitBlt(33+EX, 2, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);
            //dspl_BitBlt(33+EX, 2, idl_Attr[iconIdAlarm].area.sx, idl_AttrMask[iconIdAlarm].area.sy, 0, idl_AttrMask[iconIdAlarm].icons, DSPL_BMPAND);
            //dspl_BitBlt(33+EX, 2, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);
		
            switch( data->ringandf%16 )
            {
            case ONCE:
                dspl_TextOut(0+EX,0,0,(char*)MmiRsrcGetText(TxtOnce));
                break;
            case EVERYDAY:
                dspl_TextOut(0+EX,0,0,(char*)MmiRsrcGetText(TxtDay));
                break;
            case WEEKLY:
                dspl_TextOut(0+EX,0,0,(char*)MmiRsrcGetText(TxtWeek));
                break;
            case EVERYMONTH:
                dspl_TextOut(0+EX,0,0,(char*)MmiRsrcGetText(TxtMonth));
                break;
            case ANNUALLY:
                dspl_TextOut(0+EX,0,0,(char*)MmiRsrcGetText(TxtYear));
                break;
            }
    }
	//end of yhf modify

    /* ʾ */
    memset(str1,0,sizeof(str1));
    sprintf(str1,"%d/%d",t->index+1,t->count);  
    drawSolidRectangle(120-6*strlen(str1)-2+EX, 3, 119+EX, 13, 3, 0x5AC7FF,0x5AC7FF);
    set_font_type(UNI12X12_FONT); 
    dspl_colorTextOut(120-6*strlen(str1)+EX, 2, DSPL_TXTATTR_TRANSPARENT,str1,0xffffff);     

    /* ʱ䱳ʾ */
    TD_drawSolidRectangle(SC_BS_rect, SC_BS_attr);

    /* ʱʾ */
    memset(strn, 0, sizeof(strn));
    sprintf(strn,"%d.%02d.%02d",data->date[0], data->date[1]/256, data->date[1]%256);
    set_font_type(UNI12X12_FONT); 
    dspl_colorTextOut(10+EX, 18, DSPL_TXTATTR_TRANSPARENT, strn,0x004c98);  

    if( data->ringandf/16 )               //
    {
        memset(stime, 0, sizeof(stime));
        sprintf(stime, "%02d:%02d", data->hour, data->minute);
        set_font_type(UNI12X12_FONT);      
        dspl_colorTextOut(80+EX, 18, DSPL_TXTATTR_TRANSPARENT, stime,0x004c98);  
    }

    /* ʾ */
    dspl_colorTextOut(0, 32, 0, (char *)data->text,0x000000);     

    /* title display */ 
    // 2004.4.16 MI18800000284
    /*if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
    {
        if( data->type==MEETING )
            PROMPT(50+EX-6,0,0, TxtScheMeeting);
        else if( data->type==BIRTHDAY )
            PROMPT(50+EX-6,0,0, TxtBirthday);
        else if( data->type==APPOINTMENT )
            PROMPT(50+EX-6,0,0, TxtAppointment);
        else if( data->type==PHONE )
            PROMPT(50+EX-6,0,0, TxtPhone);
        else
            PROMPT(50+EX-6,0,0, TxtRemind);
    }
    else if(!(data->ringandf/16))
    {
        if( data->type==MEETING )
            PROMPT(1,0,0, TxtScheMeeting);
        else if( data->type==BIRTHDAY )
            PROMPT(1,0,0, TxtBirthday);
        else if( data->type==APPOINTMENT )
            PROMPT(1,0,0, TxtAppointment);
        else if( data->type==PHONE )
            PROMPT(1,0,0, TxtPhone);
        else
            PROMPT(30+EX-6,0,0, TxtRemind);
    }

    if( data->ringandf/16 )               //
    {
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
        {
            // 2004.4.16 MI18800000284
            dspl_BitBlt(29+EX, 1, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);
            dspl_BitBlt(29+EX, 1, idl_Attr[iconIdAlarm].area.sx, idl_AttrMask[iconIdAlarm].area.sy, 0, idl_AttrMask[iconIdAlarm].icons, DSPL_BMPAND);
            dspl_BitBlt(29+EX, 1, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);

            switch( data->ringandf%16 )
            {
            case ONCE:
                dspl_TextOut(2+EX,0,0,(char*)MmiRsrcGetText(TxtOnce));
                break;
            case EVERYDAY:
                dspl_TextOut(2+EX,0,0,(char*)MmiRsrcGetText(TxtDay));
                break;
            case WEEKLY:
                dspl_TextOut(2+EX,0,0,(char*)MmiRsrcGetText(TxtWeek));
                break;
            case EVERYMONTH:
                dspl_TextOut(2+EX,0,0,(char*)MmiRsrcGetText(TxtMonth));
                break;
            case ANNUALLY:
                dspl_TextOut(2+EX,0,0,(char*)MmiRsrcGetText(TxtYear));
                break;
            }
        }
        else
        {
            // 2004.4.16 MI18800000284
            dspl_BitBlt(1, 1, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);
            dspl_BitBlt(1, 1, idl_Attr[iconIdAlarm].area.sx, idl_AttrMask[iconIdAlarm].area.sy, 0, idl_AttrMask[iconIdAlarm].icons, DSPL_BMPAND);
            dspl_BitBlt(1, 1, idl_Attr[iconIdAlarm].area.sx, idl_Attr[iconIdAlarm].area.sy, 0, idl_Attr[iconIdAlarm].icons, DSPL_BMPXOR);

            switch( data->ringandf%16 )
            {
            case ONCE:
                dspl_TextOut(20,0,0,(char*)MmiRsrcGetText(TxtOnce));
                break;
            case EVERYDAY:
                dspl_TextOut(20,0,0,(char*)MmiRsrcGetText(TxtDay));
                break;
            case WEEKLY:
                dspl_TextOut(20,0,0,(char*)MmiRsrcGetText(TxtWeek));
                break;
            case EVERYMONTH:
                dspl_TextOut(20,0,0,(char*)MmiRsrcGetText(TxtMonth));
                break;
            case ANNUALLY:
                dspl_TextOut(20,0,0,(char*)MmiRsrcGetText(TxtYear));
                break;
            }

        }

        memset(stime, 0, sizeof(stime));
        sprintf(stime, "%02d:%02d", data->hour, data->minute);
        set_font_type(UNI12X12_FONT);      
        dspl_colorTextOut(68+EX, 16, DSPL_TXTATTR_TRANSPARENT, stime,0x004c98);  

    }

    /* ʾ */
    /*memset(str1,0,sizeof(str1));
    sprintf(str1,"%d/%d",t->index+1,t->count);  
    drawSolidRectangle(102-6*strlen(str1)-2+EX, 0, 119+EX, 13, 3, 0x5AC7FF,0x5AC7FF);
    set_font_type(UNI12X12_FONT); 
    dspl_colorTextOut(102-6*strlen(str1)+EX, 1, DSPL_TXTATTR_TRANSPARENT,str1,0xffffff);     


    /* ʱʾ */
    /*memset(strn, 0, sizeof(strn));
    sprintf(strn,"%d.%02d.%02d",data->date[0], data->date[1]/256, data->date[1]%256);
    set_font_type(UNI12X12_FONT); 
    dspl_colorTextOut(1+EX, 16, DSPL_TXTATTR_TRANSPARENT, strn,0x004c98);  

    /* ʾ */
    /*dspl_colorTextOut(0, 29, 0, (char *)data->text,0x000000); */    

    updateSoftkey();
}


void scheDataDisplay(FlashSchedule * data)
{
    // clrobert modified
    // from
    /*
    char strn[16];
    char str1[10];
     */
    // to
    char strn[20];    
    int old_color;
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON(ICON_MENUUP);
    /*
    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                 menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                 menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
    */
    if( data->type==MEETING )
    {
        ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtScheMeeting);
    }
    else if( data->type==BIRTHDAY )
    {
        ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtBirthday);
    }
    else if( data->type==APPOINTMENT )
    {
        ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtAppointment);
    }
    else if( data->type==PHONE )
    {
        ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtPhone);
    }
    else
    {
        ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtRemind);
    }   

    memset(strn,0,sizeof(strn));
    sprintf(strn,"%d.%02d.%02d %02d:%02d",data->date[0],data->date[1]/256,data->date[1]%256,data->hour,data->minute);
    set_font_type(UNI12X12_FONT);      
    dspl_colorTextOut(2, 17, DSPL_TXTATTR_TRANSPARENT, strn,0x00000);     
    dspl_colorTextOut(2, 30, 0, (char *)data->text,0x00000);     
    displaySoftKeys(0, TxtSoftBack);
}


void ScheInit()
{
    int i;

    //FlashScheDataInitialise();
    memset(&ScheDetailIndex,0,200*sizeof(T_MFW_DetailSche_index));
    memset(&ScheIndex,0,200*sizeof(T_MFW_SCHE_INDEX));
    memset(&FFS_ScheData,0,sizeof(Flash_Sche));

    //InitFile(&FFS_ScheData, 70, 0);
    //while(!(Iswritefileend((char*)ScheTable[0],sizeof(FFS_ScheData))));
    //InitFile(&FFS_ScheData, 70, 1);
    //while(!(Iswritefileend((char*)ScheTable[1],sizeof(FFS_ScheData))));
    //InitFile(&FFS_ScheData, 60, 2);
    //for(i=0;i<3;i++)
    //{
    //Flash_ScheInitWrite((char *)ScheTable[i]);
    //}
}
/* ճ */
void ScheMemoRead()
{
    int i,j,Temp,k=0;
    for( i=0;i<3;i++ )
    {
        Temp= Flash_ScheRead((char *)ScheTable[i]);
        Temp=SCHEDULE_NUMBER;
#if 1
        for( j=0;j<Temp;j++ )
        {
            if( FFS_ScheData.FfsSche[j].text[0] )
            {
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].index=SCHEDULE_NUMBER*i+j+1;
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].date[0]=FFS_ScheData.FfsSche[j].date[0];
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].date[1]=FFS_ScheData.FfsSche[j].date[1];
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].hour=FFS_ScheData.FfsSche[j].hour;
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].minute=FFS_ScheData.FfsSche[j].minute;
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].wday=FFS_ScheData.FfsSche[j].wday;
                ScheDetailIndex[SCHEDULE_NUMBER*i+j].ringandt=FFS_ScheData.FfsSche[j].ringandf/16*16+FFS_ScheData.FfsSche[j].type;
                // if(FFS_ScheData.FfsSche[j].ringandf/16)
                //	iconsSetState(iconIdAlarm);
            }
            else
            {
                if( (SCHEDULE_NUMBER*i+j)<SCHEDULE_NUMBER )
                    ScheDetailIndex[70*i+j].index=0;
            }       
        }
#endif      
    }
    /*j=0;
    while(j<SCHEDULE_NUMBER)
         {
           if(ScheDetailIndex[j].index)
             {
                ScheIndex[k].index=ScheDetailIndex[j].index;
                //ScheIndex[k].number=j;
                ScheIndex[k].date[0]=ScheDetailIndex[j].date[0];
                ScheIndex[k].date[1]=ScheDetailIndex[j].date[1];
                ScheIndex[k].wday=ScheDetailIndex[j].wday;
                ScheIndex[k].hour=ScheDetailIndex[j].hour;
                ScheIndex[k].minute=ScheDetailIndex[j].minute;
                k++;
             }
          j++;
         }*/
}

effs_t Flash_ScheWrite(char * filename)
{
    char str[20]="/bmi/";   /* 2004/04/22 sunsj modify */
    //int size,i;

    strcat(str,filename);
    strcpy((char*)CurrentScheFileName,filename);
    //for(i=0;i<70;i++)
    //	if(FFS_ScheData.FfsSche[i].date[0])
    //		size=i+1;
    //TraceInt(size);
    return ffs_fwrite( str, &FFS_ScheData,sizeof(FFS_ScheData));//size * sizeof(FlashSchedule));
}

void Sche_Copy(FlashSchedule * a,FlashSchedule * b)
{
    a->date[0]=b->date[0];
    a->date[1]=b->date[1];
    a->wday = b->wday;      //2003.12.3 WYJ 
    a->hour=b->hour;
    a->minute=b->minute;
    a->ringandf=b->ringandf;
    a->type=b->type;
    memset(a->text,0,sizeof(a->text));
    memcpy((char *)a->text,(char *)b->text,SCHE_LEN);
}

extern void InitFile(Flash_Sche* t, int size, int filenumber)
{
    int i;

    memset(t,0,sizeof(Flash_Sche));
    if( size<71 )
    {
        for( i=0;i<size;i++ )
        {
            t->FfsSche[i].date[0]=2002;
            t->FfsSche[i].date[1]=2561;
            t->FfsSche[i].hour=10;
            t->FfsSche[i].minute=1;
            t->FfsSche[i].ringandf=0;
            t->FfsSche[i].type=MEETING;
            strcpy((char*)t->FfsSche[i].text,"test");
            ScheDetailIndex[filenumber*SCHEDULE_NUMBER+i].index=filenumber*SCHEDULE_NUMBER+1;
            ScheDetailIndex[filenumber*SCHEDULE_NUMBER+i].date[0]=2002;
            ScheDetailIndex[filenumber*SCHEDULE_NUMBER+i].date[1]=2561;
            ScheDetailIndex[filenumber*SCHEDULE_NUMBER+i].hour=10;
            ScheDetailIndex[filenumber*SCHEDULE_NUMBER+i].ringandt=MEETING;
        }
        Flash_ScheWrite((char*)ScheTable[filenumber]);
    }
}

void copy(T_MFW_SCHE_INDEX *a, T_MFW_SCHE_INDEX *b)
{
    a->date[0]=b->date[0];
    a->date[1]=b->date[1];
    a->hour=b->hour;
    a->minute=b->minute;
    a->index=b->index;
}

void exchange(T_MFW_SCHE_INDEX *a, T_MFW_SCHE_INDEX *b)
{//lxj
    T_MFW_SCHE_INDEX t;

    t.date[0]=a->date[0];
    t.date[1]=a->date[1];
    t.hour=a->hour;
    t.minute=a->minute;
    t.index=a->index;
    a->date[0]=b->date[0];
    a->date[1]=b->date[1];
    a->hour=b->hour;
    a->minute=b->minute;
    a->index=b->index;
    b->date[0]=t.date[0];
    b->date[1]=t.date[1];
    b->hour=t.hour;
    b->minute=t.minute;
    b->index=t.index;
    //lxj
}

void getLunarMonth(int mon_number, char * s)
{
    switch( mon_number )
    {
    case 1:
        strncpy(s,"\x6b\x63",2);//
        break;
    case 2:
        strncpy(s,"\x4e\x8c",2);//
        break;
    case 3:
        strncpy(s,"\x4e\x09",2);//
        break;
    case 4:
        strncpy(s,"\x56\xdb",2);//
        break;
    case 5:
        strncpy(s,"\x4e\x94",2);//
        break;
    case 6:
        strncpy(s,"\x51\x6d",2);//
        break;
    case 7:
        strncpy(s,"\x4e\x03",2);//
        break;
    case 8:
        strncpy(s,"\x51\x6b",2);//
        break;
    case 9:
        strncpy(s,"\x4e\x5d",2);//
        break;
    case 10:
        strncpy(s,"\x53\x41",2);//ʮ
        break;
    case 11:
        strncpy(s,"\x51\xac",2);//
        break;
    case 12:
        strncpy(s,"\x81\x4a",2);//
        break;
    default:
        break;
    }
    strcat(s,"\x67\x08");//
}

void getLunarDay(int day_number, char * s)
{
    if( day_number!=10 )
    {
        if( day_number<10 )
        {
            strncpy(s,"\x52\x1d",2);//
        }
        else if( day_number<20 )
        {
            strncpy(s,"\x53\x41",2);//ʮ
        }
        else if( day_number<30 )
        {
            strncpy(s,"\x4e\x8c\x53\x41",4);//ʮ
        }
        else
        {
            strncpy(s,"\x4e\x09\x53\x41",4);//ʮ
        }
    }
    else
    {
        strcpy(s,"\x52\x1d\x53\x41\x00\x00");//ʮ
    }
    day_number=day_number%10;
    switch( day_number )
    {
    case 1:
        strcat(s,"\x4e\x00\x00");//һ
        break;
    case 2:
        strcat(s,"\x4e\x8c\x00");//
        break;
    case 3:
        strcat(s,"\x4e\x09\x00");//
        break;
    case 4:
        strcat(s,"\x56\xdb\x00");//
        break;
    case 5:
        strcat(s,"\x4e\x94\x00");//
        break;
    case 6:
        strcat(s,"\x51\x6d\x00");//
        break;
    case 7:
        strcat(s,"\x4e\x03\x00");//
        break;
    case 8:
        strcat(s,"\x51\x6b\x00");//
        break;
    case 9:
        strcat(s,"\x4e\x5d\x00");//
        break;
    default:
        break;     
    }
}
/* ʾ */
void dsplCalinder()
{
    int             i,j,k;
    int             posx = 2, posy = 13;                //ʾʼλ
    game_Line       line;
    game_Rectangle  rectangle;
    char            str[7][5] = {   "\x80\x65\xe5\x00\x00",
        "\x80\x4e\x00\x00\x00",
        "\x80\x4e\x8c\x00\x00",
        "\x80\x4e\x09\x00\x00",
        "\x80\x56\xdb\x00\x00",
        "\x80\x4e\x94\x00\x00",
        "\x80\x51\x6d\x00\x00"};
    rectangle.x1        = 0;
    rectangle.y1        = 31;
    rectangle.x2        = 127;
    rectangle.y2        = 44;
    rectangle.color     = 0xc7eceb;
    rectangle.fillcolor = 0xc7eceb;
    TD_drawSolidRectangle(SC_week_rect, SC_week_attr);

    line.x1=0;
    line.y1=45;
    line.x2=127;
    line.y2=45;
    line.color=0x0;
    DrawLine(line);

    /* ʾ */
    for( i=0;i<7;i++ )
    {
        set_font_type(UNI12X12_FONT);

        if( i==0 )
            dspl_colorTextOut(posx, posy, DSPL_TXTATTR_TRANSPARENT,(char *)str[i],0xe32020);
        else if( i==6 )
            dspl_colorTextOut(posx, posy, DSPL_TXTATTR_TRANSPARENT,(char *)str[i],0x9a51ac);
        else
            dspl_colorTextOut(posx, posy, DSPL_TXTATTR_TRANSPARENT,(char *)str[i],0x0);

        posx=posx+14;
    }
}

game_Line setLine(int x1,int y1,int x2,int y2,int color)
{
    game_Line l;

    l.x1=x1;
    l.y1=y1;
    l.x2=x2;
    l.y2=y2;
    l.color=color;

    return l;
}

/**********************************************************************************
* Function Name         : checkSchNumInput
* Function Description  : дճʱõּʹܴ֮
*
* Parameters		    : TR_data *data        	     I/O
*						: U8 keynum					 I
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkSchNumInput(TR_data *data, U8 keynum)
{
    char hour[3]   = {0,0,0};
    char minute[3] = {0,0,0};

    /* ӣ֤СʱûԽ */
    switch( data->index )
    {
    case 0:                                 // Сʱʮλ
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( keynum > 1 )
                return;
        }
        else
        {
            if( keynum > 2 )
                return;
        }

        //data->edtbuf1ʽhh:mm
        data->time[data->index++] = '0' + keynum;
        break;

    case 1:                                 //Сʱλ
        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            if( (data->time[data->index-1]=='1') && (keynum>2) )
                return;
        }
        else
        {
            if( (data->time[data->index-1]=='2') && (keynum>3) )
                return;
        }
        data->time[data->index++] = '0' + keynum;
        data->index++;
        break;

    case 3:                                 //ʮλ
        if( keynum > 5 )
            return;
        data->time[data->index++] = '0' + keynum;
        break;

    case 4:                                 //Ӹλ
        data->time[data->index++] = '0' + keynum;
        data->index = 0;
        break;                              

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : checkSchLeftInput
* Function Description  : дճʱõĲ˵ʹܴ֮
*
* Parameters		    : TR_data *data        			I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkSchLeftInput(TR_data *data)
{
    char *p;
    int  value;

    //ʱʽhh:mm
    switch( data->index )
    {
    case 1:                                 //Ҫ
    case 4:
        data->index--;
        break;

    case 0:                                 //Сʱ
        p = &data->time[0];
        value = (p[0]-48)*10 + (p[1]-48);

        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            //ʮСʱСʱ12
            if( value > 12 )
                return;
        }
        else
        {
            //ʮСʱСʱ23
            if( value > 23 )
                return;
        }
        data->index = 4;
        break;

    case 3:                                 //
        if( data->time[3] > '5' )
            return;

        data->index = 1;
        break;

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : checkSchRightInput
* Function Description  : дճʱõĲ˵Ҽʹܴ֮
*
* Parameters		    : TR_data *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void checkSchRightInput(TR_data *data)
{
    char *p;
    int  value;

    //ʱʽhh:mm
    switch( data->index )
    {
    case 0:                                 //Ҫ
    case 3:
        data->index++;
        break;

    case 1:                                 //Сʱ
        p = &data->time[0];
        value = (p[0]-48)*10 + (p[1]-48);

        if( FFS_flashData.time_format == TWELVE_HOUR )
        {
            //ʮСʱСʱ12
            if( value > 12 )
                return;
        }
        else
        {
            //ʮСʱСʱ23
            if( value > 23 )
                return;
        }
        data->index = 3;
        break;

    case 4:                                 //
        if( data->time[3] > '5' )
            return;

        data->index = 0;
        break;

    default:
        break;
    }
}

/**********************************************************************************
* Function Name         : calinDisp
* Function Description  : ճ̱ʾ
*
* Parameters		    : month_table       I	ʾϢ
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2003.11.18
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/

static void calinDisp(MONTHTABLE *month_table)
{
    int line    = 1;                            //ʾڵڼ
    int day     = 0;                            //ʾʼ
    int wd      = month_table->firstday;        //һڼ

	/* ʾ */
	calinBkgDisp();

    /* ʾ */
    calinFocusDisp(wd, month_table->day);

    /* ʾ */
    calinNumDisp(wd, 1, 7-wd, 0);           //һʾ
    day = 7 - wd + 1;                       

    while( 1 )
    {
        if( day+7 > month_table->lenth )      //Ƿһ
        {
            calinNumDisp(0, day, month_table->lenth-day+1, line);
            break;
        }
        else
        {
            calinNumDisp(0, day, 7, line);
        }
        line++;
        day += 7;
    }
}

/**********************************************************************************
* Function Name         : calinBkgDisp
* Function Description  : ճ̱ʾ
*
* Parameters		    : 
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2003.11.18
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void calinBkgDisp()
{
    int             i;
    game_Line       line;
    game_Rectangle  rectangle;

#if (MAIN_LCD_SIZE==3)//jhxu720
	DRAW_ICON(ICON_CALENDARBKG);
	DRAW_ICON(ICON_CALENDARICON);
	dspl_colorTextOut(60, 93, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtCalendarYear), 0xffffff);//jhxu 288 add
	dspl_colorTextOut(110, 93, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtCalendarMonth), 0xffffff);//jhxu 288 add
#elif ( MAIN_LCD_SIZE==4 )
    /* 2004/06 sunsj modify for picture manage */
    /* ⱳ */
    DRAW_ICON(ICON_SCHEDULE_PIC);
    //dspl_BitBlt(0, 0, 128, 18, 0, (void *)gImage_pic, 0);

    /* ʾ */
    DRAW_ICON(ICON_SCHEDULE_WEEK);
    //dspl_BitBlt(0, 30, 128, 16, 0, (void *)gImage_week, 0);

    /* ʾɫ */
    rectangle.x1    = 0;
    rectangle.y1    = 46;
    rectangle.x2    = 127;
    rectangle.y2    = 125;
    rectangle.color = 0xD9F7FF;
    rectangle.fillcolor = 0xD9F7FF;
    DrawRectagle(rectangle);

    /* ũ */
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON(ICON_SCHEDULE_NL);
    //dspl_BitBlt(0, 125, 128, 17, 0, (void *)gImage_nl, 0);

#elif ( MAIN_LCD_SIZE==2 )
    dspl_BitBlt(0, 13, 102, 52, 0, (void *)gImage_callin, 0);
#endif

}

/**********************************************************************************
* Function Name         : calinNumDisp
* Function Description  : ճ̱ʾ
*
* Parameters		    : wd		I	ʾʼ06
*						  day		I	ʾʼڣ131
*						  count		I	ʾ17
*						  line		I	ʾڵڼУ05
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2003.11.18
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void calinNumDisp(int wd, int day, int count, int line)
{
    int     i;
    char    str[4];
#if (MAIN_LCD_SIZE==3)
	int     xpos = 4;                            //ʾʼλ
    int     ypos = 32;                          //ʾʼλ//shiheng 288 change form 25 to 30
	
	if(line == 5)
		line = 0;
	
    for( i=0; i<count; i++ )
    {
        sprintf(str, "%2d", day+i);
		//set_font_type(SMALL_FONT); 
		set_font_type(UNI12X12_FONT); //shiheng 288
		
		
		switch((wd+i)) 
		{
		case 0:								//ʾ
            dspl_colorTextOut((wd+i)*17+xpos, ypos+line*12, DSPL_TXTATTR_TRANSPARENT,//shiheng 288 change from (wd+i)*14 to (wd+i)*17
				str,0xe32020);
			break;
			
		case 1:
		case 2:
            dspl_colorTextOut((wd+i)*17+xpos, ypos+line*12, DSPL_TXTATTR_TRANSPARENT,//shiheng 288 change from *8 to *15
				str,0x000000);
			break;
			
		case 3:
		case 4:
            dspl_colorTextOut((wd+i)*17+xpos+1, ypos+line*12, DSPL_TXTATTR_TRANSPARENT,
				str,0x000000);
			break;
			
		case 5:
            dspl_colorTextOut((wd+i)*17+xpos+2, ypos+line*12, DSPL_TXTATTR_TRANSPARENT,
				str,0x000000);
			break;
			
		case 6:								//ʾ
			dspl_colorTextOut((wd+i)*17+xpos+3, ypos+line*12, DSPL_TXTATTR_TRANSPARENT,
				str,0x9a51ac);
			break;
		}
    }
    set_font_type(UNI12X12_FONT); 
#elif ( MAIN_LCD_SIZE==4 )
    int     xpos = 1+4;                          //ʾʼλ
    int     ypos = 47;                          //ʾʼλ

    for( i=0; i<count; i++ )
    {
        sprintf(str, "%2d", day+i);
        set_font_type(UNI12X12_FONT); 

        if( (wd+i) == 0 )                     //ʾ
        {
            dspl_colorTextOut((wd+i)*17+xpos, ypos+line*13, DSPL_TXTATTR_TRANSPARENT,
                              str,0xe32020);
        }
        else if( (wd+i) == 6 )               //ʾ
        {
            dspl_colorTextOut((wd+i)*17+xpos, ypos+line*13, DSPL_TXTATTR_TRANSPARENT,
                              str,0x9a51ac);
        }
        else                                //һʾ
        {
            dspl_colorTextOut((wd+i)*17+xpos, ypos+line*13, DSPL_TXTATTR_TRANSPARENT,
                              str,0x000000);
        }
    }
#elif ( MAIN_LCD_SIZE==2 )
    int     xpos = 4;                          //ʾʼλ
    int     ypos = 25;                          //ʾʼλ

    if( line == 5 )
        line = 0;

    for( i=0; i<count; i++ )
    {
        sprintf(str, "%2d", day+i);
        set_font_type(SMALL_FONT); 

        switch( (wd+i) )
        {
        case 0:                             //ʾ
            dspl_colorTextOut((wd+i)*14+xpos, ypos+line*8, DSPL_TXTATTR_TRANSPARENT,
                              str,0xe32020);
            break;

        case 1:
        case 2:
            dspl_colorTextOut((wd+i)*14+xpos, ypos+line*8, DSPL_TXTATTR_TRANSPARENT,
                              str,0x000000);
            break;

        case 3:
        case 4:
            dspl_colorTextOut((wd+i)*14+xpos+1, ypos+line*8, DSPL_TXTATTR_TRANSPARENT,
                              str,0x000000);
            break;

        case 5:
            dspl_colorTextOut((wd+i)*14+xpos+2, ypos+line*8, DSPL_TXTATTR_TRANSPARENT,
                              str,0x000000);
            break;

        case 6:                             //ʾ
            dspl_colorTextOut((wd+i)*14+xpos+3, ypos+line*8, DSPL_TXTATTR_TRANSPARENT,
                              str,0x9a51ac);
            break;
        }
    }
    set_font_type(UNI12X12_FONT);
#endif
}

extern const unsigned char gImage_SchFocus[];
extern const unsigned char gImage_SchFmask[];
/**********************************************************************************
* Function Name         : calinFocusDisp
* Function Description  : ճ̱ʾ
*
* Parameters		    : wd        I	ÿµһڼ06
*						  count		I	ڼѡеģ131
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2003.11.18
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
extern const unsigned char gImage_SchFocus[]; 
static void calinFocusDisp(int wd, int count)
{
    int             x, y;                       //ʾλ
#if (MAIN_LCD_SIZE==3)//jhxu720
	int             xpos = 4;                 //ʾʼλ
    int             ypos = 32;//25;                  //ʾʼλ//shiheng 288 modify
    game_Rectangle  rectangle;
	
    /* λ */
    x = (wd+count-1) % 7;
	
    y = (wd+count-1) / 7;
	
	if(y == 5)
		y = 0;
	
	switch(x) 
	{
	case 0://jhxu 288 add
		xpos+=5;
		break;
	case 2:
	case 3:
		xpos -= 2;
		break;
	case 4:
	case 5:
	case 6:
		xpos -= 3;
		break;
	}
	
    /* ͼƬѡʾ */
    //dspl_BitBlt(xpos + x*19-5, ypos + y*14-1, 18, 13, 0, (void *)gImage_SchFocus, 0);//jhxu 288 modify
    DRAW_ICON_LOCATION(ICON_IMAGEFOCUS, xpos + x*19-5, ypos + y*12);
#elif ( MAIN_LCD_SIZE==4 )
    int             xpos = 3;                 //ʾʼλ
    int             ypos = 46;                  //ʾʼλ
    game_Rectangle  rectangle;

    /* λ */
    x = (wd+count-1) % 7;

    y = (wd+count-1) / 7;

    if( count < 10 )
        xpos += 3;

    /* 2004/06 sunsj modify for picture manage */
    /* ͼƬѡʾ */
    DRAW_ICON_LOCATION(ICON_SCHEDULE_FOCUS, xpos+x*17, ypos + y*13);
    //dspl_BitBlt(xpos + x*17 , ypos + y*13, 17, 14, 0, (void *)gImage_focus, 0);

#elif ( MAIN_LCD_SIZE==2 )
    int             xpos = 4;                 //ʾʼλ
    int             ypos = 25;                  //ʾʼλ
    game_Rectangle  rectangle;

    /* λ */
    x = (wd+count-1) % 7;

    y = (wd+count-1) / 7;

    if( y == 5 )
        y = 0;

    switch( x )
    {
    case 2:
    case 3:
        xpos -= 2;
        break;
    case 4:
    case 5:
    case 6:
        xpos -= 3;
        break;
    }

    /* ͼƬѡʾ */
    dspl_BitBlt(xpos + x*15 - 1, ypos + y*8, 9, 8, 0, (void *)gImage_SchFocus, 0);
#endif
}


