/********************************************************************************
                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Stopwatch
 $File:		    Mmistopwatch.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the main stopwatch functionality

  
********************************************************************************
 $History: Mmistopwatch.c

    25/10/00			Original Condat(UK) BMI version.
    10/09/02            gdy add
       
 $End

*******************************************************************************/
/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_tim.h"
#include "mfw_edt.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "Mmitoolkit_timer.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
//#include "BmiEastAPI.h"
#include "Rtc_api.h"
#include "mmiusersymbolinput.h"
#include "Gamedisplay.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "MmiStopwatch.h"
#include "mmitextinput.h"		/* 2003/12/04 sunsj */
#include "mmiiconresource.h"	/* 2004/06 sunsj modify for picture manage */

//wyj
#include "tddisplay.h"

//*******************************************************************************************************************
#define A_SCREEN_NUMBER  7
#define NUMBER_OF_GROUP 5
#define A_GROUP_NUMBER  40

extern                      ToolkitTitle;
extern                      g_norejectkeyflag;
extern const unsigned char  backgroundBit[];
extern const unsigned char  iconRequire[];
static FlashStopwatch       temp_data;
static MfwHnd               dynamic_win         = NULL;
static MfwHnd               dynamicRecord_win   = NULL;
static MfwHnd               delete_menu_win     = NULL;
static MfwHnd               stopw_menu_win      = NULL;
static char_str             string[A_GROUP_NUMBER];
static int                  browse_type         = 0;
MfwHnd                      stopw_win           = NULL;
//static int realpositon=0;
//static int displaypositon=0;


static MfwMnuAttr stopw_menuAttrib =
{
    0,
    &melody_menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};

int                 StopwMemoRead();
static T_MFW_HND    stopwatch_create(MfwHnd parent_window);
static void         stopw_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static T_MFW_CB     stopw_tim_cb(MfwEvt e, MfwTim *tc);
static int          stopw_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int          stopw_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                stopwatch_destroy(MfwHnd own_window);
void                StopwSetEditor(T_MFW_HND win);
static void         stopwCB( T_MFW_HND win,USHORT Identifier,UBYTE reason);
void                stopw_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);

int                 dynamicMenu(T_MFW_HND parent_win);
static T_MFW_HND    dynamicTitleMenu_create(MfwHnd parent_window);
static void         dynamicTitleMenu_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          dynamicTitle_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);

static void         Editor_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
void                stopwEditor_destroy(MfwHnd own_window);
static T_MFW_HND    stopwEditor_create(MfwHnd parent_window);
static int          stopwEditor_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
int                 stopwAddOne();
void                reset();
int                 GetNumber();
static void         stopw_menu_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
void                dynamicTitleList_cb(T_MFW_HND  Parent, ListMenuData * ListData);
void                dynamicTitleMenu_destroy(MfwHnd own_window);
static T_MFW_HND    delete_All_create(MfwHnd parent_window);
static void         delete_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          delete_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                delete_destroy(MfwHnd own_window);
//void dynamicTitle_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);

static T_MFW_HND    dynamicRecord_create(MfwHnd parent_window);
static void         dynamicRecord_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          dynamic_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                dynamicRecordMenu_destroy(T_MFW_HND own_window);
void                recorddisplay(DynamicRecordData* data);
static int          dynamic_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void                recordList_cb(T_MFW_HND  Parent, ListMenuData * ListData);

/* ֱʱڳʼ */
int separately(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent  = mfwParent( mfw_header());
    T_MFW_HND           win     = stopwatch_create(parent);

    stopw_menu_win = parent;
    if( win NEQ NULL )
    {
        SEND_EVENT(win, STOPW_COUNT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* Ȧʱڳʼ */
int bycircle(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent  = mfwParent( mfw_header());
    T_MFW_HND           win     =  stopwatch_create(parent);

    stopw_menu_win = parent;
    if( win NEQ NULL )
    {
        SEND_EVENT(win, STOPW_COUNT, 1, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "¼"˵Ӧ˵ */
int browse(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent  = mfwParent( mfw_header());
    T_MFW_HND           win     = dynamicTitleMenu_create(parent);

    stopw_menu_win = parent;
    if( win NEQ NULL )
    {
        SEND_EVENT( win , DYNAMIC_INIT, BROWSE_TITEL, 0);
    }

    return MFW_EVENT_CONSUMED;    
}
/* "ɾ¼"˵Ӧ */
int Delete(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent  = mfwParent( mfw_header());
    T_MFW_HND           win;

    ToolkitTitle = TxtDeleteRecord;
    win = bookMenuStart(parent, DeleteOptions(), PhbkToolkit);
    delete_menu_win = win;
    if( win NEQ NULL )
    {
        SEND_EVENT(win, ADD_CALLBACK, NULL, (void*)NULL);//stopw_delete_cb);
    }

    return MFW_EVENT_CONSUMED;
}
/* "ʱ"˵Ӧ */
int continue_count(MfwMnu* m, MfwMnuItem* i)
{    
    T_MFW_HND           parent_win  = mfwParent( mfw_header());
    T_MFW_WIN          *win_data    = ((T_MFW_HDR *) stopw_win )->data;
    StopwData          *data        = (StopwData* )win_data->user;

	// MI18800000280
	if(data->recordNumber >= A_GROUP_NUMBER)
	{
	T_DISPLAY_DATA display_info;

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = 0;
    display_info.TextId2      = TxtCapacityFull;
    display_info.TextString   = NULL;
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = 1000;;
    display_info.Callback     = 0;
    display_info.Identifier   = 0;
	display_info.iconindex 	  = REMIND_NORECORD;

    info_dialog( parent_win, &display_info );
	return;
	}
	
    //dspl_Clear(20, 69, 117, 89);
    data->RightKey = TRUE;
    tim_start(data->info_tim);

    bookMenuDestroy(parent_win);
    return MFW_EVENT_CONSUMED;
}
/* ""˵Ӧ */
int save(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent  = mfwParent( mfw_header());
    T_MFW_HND           win     = stopwEditor_create(parent);

    if( win NEQ NULL )
    {
        SEND_EVENT(win, STOPWEDITOR_INIT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "¼ʱ"˵Ӧ */
int restart(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent_win  = mfwParent( mfw_header());
    T_MFW_WIN          *win_data    = ((T_MFW_HDR *) stopw_win )->data;
    StopwData          *data        = (StopwData* )win_data->user;

    data->RightKey      = TRUE;
    data->counter       = 0;
    data->recordNumber  = 0;
    reset();

    //dspl_Clear(20, 69, 117, 89);
    tim_start(data->info_tim);

    bookMenuDestroy(parent_win);
    return MFW_EVENT_CONSUMED;
}
/* "¼"˵ӦӲ˵ */
int browse_record(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND           parent  = mfwParent( mfw_header());
    T_MFW_HND           win     = dynamicRecord_create(parent);

    if( win NEQ NULL )
    {
        SEND_EVENT( win , DYNAMIC_RECORD_INIT, 0, 0);
    }

    return MFW_EVENT_CONSUMED;  
}

/* "ȫɾ"˵ӦӲ˵ */
int delete_All(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       parent      = mfwParent( mfw_header());
    T_MFW_HND       win         = delete_All_create(parent);

    if( win NEQ NULL )
    {
        SEND_EVENT(win, DELETE_INITIAL, 0, 0);
    }

    return MFW_EVENT_CONSUMED;
}
/* "ɾ"˵ӦӲ˵ */
int DeleteOnebyOne(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND        parent       = mfwParent( mfw_header());
    T_MFW_HND        win          = dynamicTitleMenu_create(parent);


    if( win NEQ NULL )
    {
        SEND_EVENT( win , DYNAMIC_INIT, BROWSE_DELETE, 0);
    }

    return MFW_EVENT_CONSUMED; 
}
/* ֱʱȦʱڴ */
static T_MFW_HND stopwatch_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    StopwData* data = (StopwData *)ALLOC_MEMORY (sizeof (StopwData ));

    TRACE_EVENT("stopwatch_create");

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)stopw_win_cb);

    if( data->win EQ NULL )
    {
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)stopw_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;   
    stopw_win=data->win;

    winShow(win);
    return data->win;
}

/* Ӵ¼ ¼ʱʼʱ */
static void stopw_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      *win_data    = ( (T_MFW_HDR *) win )->data;
    StopwData      *data        = (StopwData *) win_data->user;
    T_EDITOR_DATA   editor_data;
    T_DISPLAY_DATA  display_info;

    TRACE_EVENT("stopw_DialogCB");

    data->event = event;
    data->type  = value;   
    switch( event )
    {
    case STOPW_COUNT:
        strcpy((char*)data->timebuffer,"00:00:00:0");           
        data->RightKey=TRUE;        
        data->recordNumber=0;
        winShow(win); 
        //dspl_Clear(20, 69, 117, 89);
        reset();
        data->groupNumber=StopwMemoRead();//gdy add 27/08/02   
        if( data->groupNumber>4 )             //¼
        {
            dialog_info_init(&display_info);//gdy add

            display_info.TextId2     =TxtFull;          
            display_info.Time       = FOREVER;
            display_info.Callback     = (T_VOID_FUNC)NULL;//sepa_dialog_cb;
            display_info.iconindex = REMIND_NORECORD;           
            /*
            * Call Info Screen
            */
            info_dialog (win, &display_info);
            stopwatch_destroy(stopw_win);
            break;
        }
        data->kbd =  kbd_create(win, KEY_ALL, (T_MFW_CB)stopw_kbd_cb);
        data->info_tim=timCreate(data->win,100,(T_MFW_CB)stopw_tim_cb); //0.1SΪλ
        tim_start(data->info_tim);          
        break;
    case STOPW_EXIT:
        stopwatch_destroy(win);
        break;
    }
}
/* ʱ һСʱʱ һСʱ */
static T_MFW_CB  stopw_tim_cb(MfwEvt e, MfwTim *tc) 
{
    T_MFW_HND       win         = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data    = ((T_MFW_HDR *)win)->data;
    StopwData     * data        = (StopwData*)win_data->user;
    T_DISPLAY_DATA  display_info;  
    unsigned int    t           = 0;
    char            str[4];


    TRACE_EVENT("stopwatch_tim_cb");

    if( data->counter<36000 )   /*The maxmum record number is 5 by name*/
    {
        if( data->recordNumber<A_GROUP_NUMBER )  /*Tne maxemu record number of each name is 40*/
        {
            data->counter++;           
            tim_start(data->info_tim);
        }
        else
        {
            data->groupNumber++;
            data->recordNumber=0;
            tim_stop(data->info_tim);         
            //SEND_EVENT(win, SUBMENU, data->Identifier,0);/*create submenu to choice the next step*/		
        }
        sprintf((char*)str,"%02d:",data->counter/36000);
        strcpy((char*)data->timebuffer,(char*)str);
        sprintf((char*)str,"%02d:",(data->counter%36000)/600);
        strcat((char*)data->timebuffer,(char*)str);
        sprintf((char*)str,"%02d:",((data->counter%36000)%600)/10);
        strcat((char*)data->timebuffer,(char*)str);
        sprintf((char*)str,"%d",((data->counter%36000)%600)%10);
        strcat((char*)data->timebuffer,(char*)str);      

        /*
        * Print the elapsed time
        */

        /*  2003.11.19 WYJ 绰ʱʾbug */
        if( (stopw_win NEQ NULL) && winIsFocussed(stopw_win) )
#if(MAIN_LCD_SIZE==4)
			dspl_colorTextOut(28, 72, 0,(char*)data->timebuffer,0x5474A7);		
#elif (MAIN_LCD_SIZE==3)
            dspl_colorTextOut(20, 18, 0,(char*)data->timebuffer,0x5474A7);
#endif
		    /***end yhf modify***/
        //dspl_colorTextOut(22, 66, 0,(char*)data->timebuffer,0x0000ff);

        /*
        * Print softkeys         */
    }
    else
    {
        dialog_info_init(&display_info);//gdy add
        display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = TxtSoftBack;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';
        display_info.TextId2     =TxtFull;
        display_info.TextId      = '\0';
        display_info.Time       = FOREVER;
        display_info.Callback     = (T_VOID_FUNC)NULL;//sepa_dialog_cb;
        display_info.iconindex = REMIND_COMPLETE;
        display_info.Identifier =0;
        /*
        * Call Info Screen
        */
        info_dialog (win, &display_info);
        stopwatch_destroy(stopw_win);
    } 

    return 0;
}

/* ʾص */
static int  stopw_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    StopwData* data = (StopwData *)win->user;
    T_DISPLAY_DATA display_info;
    char str[4];
    int old_color;
    game_Line line;

    TRACE_EVENT ("stopw_win_cb()");

    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
			U8 uMode = 0;
			uMode = dspl_Enable(0);
			
        	//title display
            dspl_ClearAll(); 
#if(MAIN_LCD_SIZE==3)
			/* 2004/05/18 yhf modify */
			TD_drawBkg(BG_rect, BG_attr);
#endif
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_MENUUP);
            /*
            dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                         menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                         menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
            */
			
			// icon display
#if(MAIN_LCD_SIZE==4)
			/* 2004/05/31 yhf modify */
			if( !data->type )
                dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSeparately), 0x0);
            else
                dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtBycircle), 0x0); 
			if( data->type )
			{
                DRAW_ICON_ATTRIBUTE(ICON_STOPWATCH_CIRCLE, 2, 72, 0, ICON_LOCATION|ICON_MASK_OWN);
                /*
                dspl_BitBlt(2, 71, 12, 12, 0, (void *)circle, DSPL_BMPXOR);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)circle_mask, DSPL_BMPAND);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)circle, DSPL_BMPXOR);
                */
			}
            else
			{
                DRAW_ICON_ATTRIBUTE(ICON_STOPWATCH_SEPA, 2, 72, 0, ICON_LOCATION|ICON_MASK_OWN);
                /*
                dspl_BitBlt(2, 71, 12, 12, 0, (void *)sepa, DSPL_BMPXOR);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)sepa_mask, DSPL_BMPAND);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)sepa, DSPL_BMPXOR);
                */
			}
#elif(MAIN_LCD_SIZE==3)
			if( !data->type )
                dspl_colorTextOut(32, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSeparately), 0x0);
            else
                dspl_colorTextOut(32, 0, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtBycircle), 0x0);
			if( data->type )
			{
                DRAW_ICON_ATTRIBUTE(ICON_STOPWATCH_CIRCLE, 2, 20, 0, ICON_LOCATION|ICON_MASK_OWN);
                /*
                dspl_BitBlt(2, 71, 12, 12, 0, (void *)circle, DSPL_BMPXOR);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)circle_mask, DSPL_BMPAND);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)circle, DSPL_BMPXOR);
                */
			}
            else
			{
                DRAW_ICON_ATTRIBUTE(ICON_STOPWATCH_SEPA, 2, 20, 0, ICON_LOCATION|ICON_MASK_OWN);
                /*
                dspl_BitBlt(2, 71, 12, 12, 0, (void *)sepa, DSPL_BMPXOR);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)sepa_mask, DSPL_BMPAND);
				dspl_BitBlt(2, 71, 12, 12, 0, (void *)sepa, DSPL_BMPXOR);
                */
			}
#endif		

#if(MAIN_LCD_SIZE==4)
			drawSolidRectangle(20, 69, 116 , 88, 1,0xFFFFFF,0x95668A);//0x5AC7FF			

            line.x1=20;
            line.x2=116;
            line.y1=89;
            line.y2=89;
            line.color=0xCDAAC5;
            DrawLine(line);

            line.x1=117;
            line.x2=117;
            line.y1=69;
            line.y2=88;
            line.color=0xCDAAC5;
            DrawLine(line);

			dspl_colorTextOut(28, 72, DSPL_TXTATTR_TRANSPARENT,(char*)data->timebuffer,0x000000);			
#elif(MAIN_LCD_SIZE==3)
		    
			drawSolidRectangle(20, 18, 99, 30, 1,0xFFFFFF,0x95668A);//0x5AC7FF			

            line.x1=20;
            line.x2=99;
            line.y1=31;
            line.y2=31;
            line.color=0xCDAAC5;
            DrawLine(line);

            line.x1=99;
            line.x2=99;
            line.y1=19;
            line.y2=30;
            line.color=0xCDAAC5;
            DrawLine(line);

            dspl_colorTextOut(20, 18, DSPL_TXTATTR_TRANSPARENT,(char*)data->timebuffer,0x000000);		
#endif
            if( (data->RightKey)&&(data->recordNumber<A_GROUP_NUMBER) )
                displaySoftKeys(TxtSoftOK, TxtStop);//confirm 
            else
                displaySoftKeys(TxtSoftOptions, TxtSoftBack);      
			
			dspl_Enable(uMode );
        }
        break;
    default:
        return 0;
    }
    return 1;
}
/* ʱڰ */
static int stopw_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    StopwData* data = (StopwData *)win_data->user;
    T_DISPLAY_DATA display_info;

    TRACE_EVENT("stopw_kbd_cb");

    g_norejectkeyflag=1;
    switch( keyboard->code )
    {
    case KCD_LEFT:
    case KCD_OK:
        if( (data->RightKey)&&(data->recordNumber<A_GROUP_NUMBER) ) //ʱûͣҼ¼δ
        {
            if( !data->type )             //ֱʱ
            {
                temp_data.record[data->recordNumber]=data->counter;
                temp_data.group_number=data->groupNumber+1;                       
            }
            else                        //Ȧʱ
            {
                temp_data.record[data->recordNumber]=data->counter;
                temp_data.group_number=data->groupNumber+1;
                data->counter=0;
            }
            temp_data.type=data->type;  
            data->recordNumber++;
            if( data->recordNumber==A_GROUP_NUMBER )
            {
                tim_stop(data->info_tim);
                data->RightKey=FALSE;                  
                displaySoftKeys(TxtSoftOptions, TxtSoftBack);  
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();//jhxu720
#endif
                winShow(win);
            }
        }
        else
        {
            if( !temp_data.record[0] )
            {
                dialog_info_init(&display_info);//gdy add

                display_info.TextId2     =TxtNorecord;          
                display_info.Time       = FOREVER;
                display_info.Callback     = (T_VOID_FUNC)NULL;//sepa_dialog_cb;
                display_info.iconindex = REMIND_NORECORD;           
                /*
                * Call Info Screen
                */
                info_dialog (win, &display_info);
                g_norejectkeyflag=0;
                stopwatch_destroy(stopw_win);
                break;
            }
            dspl_Clear(20, 69, 117, 89);
            g_norejectkeyflag=0;
            ToolkitTitle=TxtStopwatch;
            data->menu_options_win = bookMenuStart(stopw_menu_win,CountMenuAttributes(),PhbkToolkit);
            SEND_EVENT(data->menu_options_win, ADD_CALLBACK, NULL, (void*)stopw_menu_cb);                                  
        }
        break;
    case KCD_RIGHT:
        if( data->RightKey )                  //ûͣ
        {
            tim_stop(data->info_tim);
            data->RightKey=FALSE;
            displaySoftKeys(TxtSoftOptions, TxtSoftBack);
            winShow(win);
        }
        else
            SEND_EVENT(win, STOPW_EXIT, 0, 0);
        break;
    case KCD_HUP:
        SEND_EVENT(win, STOPW_EXIT, 0, 0);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}

static void stopw_menu_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) parent_win )->data;
    StopwData* data = (StopwData *) win_data->user;

    switch( reason )
    {
    case INFO_KCD_RIGHT:
        bookMenuDestroy(data->menu_options_win);
        stopwatch_destroy(parent_win);
        break;
    default:
        break;
    }
}

/*  */
void stopwatch_destroy(MfwHnd own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    StopwData* data   = (StopwData*)win->user;

    TRACE_EVENT ("stopwatch_destroy()");  
    g_norejectkeyflag=0;
    if( own_window )
    {
        /*
         * Delete WIN Handler
         */

        stopw_win=NULL;
        win_delete (own_window);
        /*
         * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (StopwData));
    }
}

/* ı */
void StopwSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    EditorData* data = (EditorData *) win_data->user;

    //editor_attr_init(&((data->editor_data).editor_attr), NULL, edtCurBar1, 0, 0, 0);
    memset(temp_data.name,0,sizeof(temp_data.name));
	//2004-04-06 Sunny modify.old :TxtNames
    editor_attr_init_fullscr(&((data->editor_data).editor_attr), 1,TxtRecordName, (char *)temp_data.name, 14, edtCurBar1);
    //editor_attr_init_only(&((data->editor_data).editor_attr),5,40,110,60, 1,TxtNames, (char *)temp_data.name, 20, edtCurBar1);
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings


    data->editor_data.Identifier        = 0xFFFF ; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = TRUE;

    data->editor_data.TextId               = '\0';                                                
    data->editor_data.LeftSoftKey       = TxtSoftOK;//comfirm

    data->editor_data.AlternateLeftSoftKey  = TxtNull;
    data->editor_data.RightSoftKey      = TxtDelete;
    data->editor_data.mode              = TEXTINPUT_MODE;   /* 2003/12/04 sunsj modify */
    data->editor_data.InputMode         = PINYIN_INPUT_MODE;    /* 2003/12/04 sunsj set default input mode */
}

/* ıص */
static void stopwCB( T_MFW_HND win,USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    EditorData      *data       = (EditorData *) win_data->user;  
    T_MFW_WIN       *win_data1  = ((T_MFW_HDR*)stopw_win)->data;
    StopwData       *data1      = (StopwData *)win_data1->user;
    T_DISPLAY_DATA   display_info;

    TRACE_EVENT("stopwCB");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {   
            if( !stopwAddOne() )
            {
                /* 2003/12/04 sunsj modify for new editor mode */
                if( data->editor_data.mode == TEXTINPUT_MODE )
                {
                    text_input_destroy(data->editor_win);
                }
                else
                {
                    editor_destroy(data->editor_win);    
                }
                dialog_info_init(&display_info);//gdy add
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtSaved;
                display_info.TextId      = '\0';
                display_info.Time       = FOREVER;
                display_info.Callback     = (T_VOID_FUNC)stopw_dialog_cb;
                display_info.iconindex = REMIND_COMPLETE;
                display_info.Identifier =0;
                /*
                * Call Info Screen
                */
                info_dialog (win, &display_info);                  
                // editor_destroy(data->editor_win);
                // bookMenuDestroy(data1->menu_options_win);
                // stopwatch_destroy(stopw_win);
            }
            else
            {
                /* 2003/12/04 sunsj modify for new editor mode */
                if( data->editor_data.mode == TEXTINPUT_MODE )
                {
                    text_input_destroy(data->editor_win);
                }
                else
                {
                    editor_destroy(data->editor_win);
                }
                dialog_info_init(&display_info);//gdy add
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtError;
                display_info.TextId      = '\0';
                display_info.Time       = ONE_SECS;
                display_info.Callback     = (T_VOID_FUNC)stopw_dialog_cb;
                display_info.iconindex = REMIND_FAILURE;
                display_info.Identifier =0;
                /*
                * Call Info Screen
                */
                info_dialog (win, &display_info);
                // editor_destroy(data->editor_win);
                //bookMenuDestroy(data1->menu_options_win);
                //stopwatch_destroy(stopw_win);
            }
        }       
        break;         
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:      
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            text_input_destroy(data->editor_win);
        }
        else
        {
            editor_destroy(data->editor_win);
        }
        stopwEditor_destroy(win);
        break;  
    default:
        break;
    }    
}


void stopw_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{
    T_MFW_WIN     * win_data= ((T_MFW_HDR *) stopw_win )->data;     
    StopwData*    data=(StopwData* )win_data->user;

    TRACE_EVENT("stopw_dialog_cb");     
    stopwEditor_destroy(win);
    bookMenuDestroy(data->menu_options_win);
    stopwatch_destroy(stopw_win);
}

int dynamicMenu(T_MFW_HND parent_win)
{
    T_MFW_HND win = dynamicTitleMenu_create(parent_win);

    if( win NEQ NULL )
    {
        SEND_EVENT(win, DYNAMIC_INIT, 0, 0);
        return MFW_EVENT_CONSUMED;
    }
}

/* ""ıԻ */
static T_MFW_HND stopwEditor_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    EditorData* data = (EditorData *)ALLOC_MEMORY (sizeof (EditorData ));

    TRACE_EVENT("stopwEditor_create");

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)stopwEditor_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)Editor_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;   

    winShow(win);
    return data->win;
}


static int  stopwEditor_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    EditorData* data = (EditorData *)win->user;
    T_DISPLAY_DATA display_info;
    char str[4];

    TRACE_EVENT ("stopwEditor_win_cb()");


    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
            * Clear Screen
                */
            dspl_ClearAll();                
        }
        break;
    default:
        return 0;
    }
    return 1;
}

/* ༭¼Ӧ */
static void Editor_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    EditorData* data = (EditorData *) win_data->user;

    switch( event )
    {
    case STOPWEDITOR_INIT:
        StopwSetEditor(win);                //ڼeditؼ
        data->editor_data.Callback          = (T_EDIT_CB)stopwCB;
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            data->editor_win = text_input(win, &data->editor_data);
        }
        else
        {
            data->editor_win = editor_start(win, &(data->editor_data));     
        }
        break;
    case STOPWEDITOR_EXIT:
        stopwEditor_destroy(win);
        break;
    }
}

void stopwEditor_destroy(MfwHnd own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    EditorData* data   = (EditorData*)win->user;

    TRACE_EVENT ("stopwEditor_destroy()");  

    if( own_window )
    {
        /*
        * Delete WIN Handler
            */


        win_delete (own_window);
        /*
        * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (EditorData));
    }
}



static T_MFW_HND dynamicTitleMenu_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    DynamicTitleData* data = (DynamicTitleData *)ALLOC_MEMORY (sizeof (DynamicTitleData ));

    TRACE_EVENT("dynamic_create");

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)dynamicTitle_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)dynamicTitleMenu_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;   
    dynamic_win  = data->win;   

    winShow(win);
    return data->win;
}
/* ¼˵ */
static void dynamicTitleMenu_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    DynamicTitleData* data = (DynamicTitleData *) win_data->user;
    //T_MFW_WIN  * win_data1 =((T_MFW_HDR *) stopw_win)->data;
    //StopwData  * data1=(StopwData*)win_data1->user;
    T_DISPLAY_DATA    display_info;
    char tem_str[4];
    char* titleStr;
    int i;

    TRACE_EVENT("dynamicMenu_DialogCB");

    data->id=value;
    switch( event )
    {
    case DYNAMIC_INIT:      
        if( data->id==BROWSE_TITEL )
        {
            TRACE_EVENT("BROWSE_STOPW");
            reset();           
            data->numberOfRecords=StopwMemoRead();//gdy add 27/08/02
            // while(StopwIndex[data->numberOfRecords].flag)
            //   data->numberOfRecords++;
            TRACE_EVENT("data->numberOfRecords=:");
            TraceInt(data->numberOfRecords);
            if( data->numberOfRecords )
            {
                data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

                if( data->menu_list_data == 0 )
                {
                    TRACE_EVENT("Failed memory alloc 1 ");
                    return;
                }

                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( data->numberOfRecords * sizeof(T_MFW_MNU_ITEM) );

                if( data->menu_list_data->List == 0 )
                {
                    TRACE_EVENT("Failed memory alloc 2");
                    return;
                }

                for( i = 0; i < data->numberOfRecords ; i++ )
                {
                    if( StopwIndex[i].type )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_STOPWATCH_CIRCLE, 0);//&circle_bmp;
                    }
                    else
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_STOPWATCH_SEPA, 0);//&sepa_bmp;
                    }
                    data->menu_list_data->List[i].exta = 0;
                    data->menu_list_data->List[i].edit = 0;
                    data->menu_list_data->List[i].menu =0;
                    data->menu_list_data->List[i].func = NULL;
                    TRACE_EVENT((char*)StopwIndex[i].name);
                    data->menu_list_data->List[i].str=(char*)StopwIndex[i].name;
                    TRACE_EVENT(data->menu_list_data->List[i].str);
                    data->menu_list_data->List[i].flagFunc = item_flag_none;     
                }

                data->menu_list_data->ListLength =data->numberOfRecords;
                data->menu_list_data->ListPosition = 1;
                data->menu_list_data->CursorPosition = 1;
                data->menu_list_data->SnapshotSize = data->numberOfRecords;
                data->menu_list_data->Font = 0;
                data->menu_list_data->LeftSoftKey = TxtSoftSelect;
                data->menu_list_data->RightSoftKey = TxtSoftBack;
                data->menu_list_data->KeyEvents = KEY_ALL;
                data->menu_list_data->Reason = 0;
                data->menu_list_data->Strings = TRUE;
                data->menu_list_data->Attr   = &stopw_menuAttrib;
                data->menu_list_data->autoDestroy    = FALSE;
                data->menu_list_data->ListMenuFlag  =1;
                data->menu_list_data->ListMenuHeadStr =MmiRsrcGetText(TxtBrowseRecord);
                listDisplayListMenu(win, data->menu_list_data,(ListCbFunc)dynamicTitleList_cb,0);// 
            }
            else
            {
                dialog_info_init(&display_info);           
                display_info.TextId2     =TxtNorecord;           
                display_info.Time       = FOREVER;
                display_info.Callback     = (T_VOID_FUNC)NULL;
                display_info.iconindex = REMIND_NORECORD;
                display_info.Identifier =0;
                /*
                * Call Info Screen
                */
                info_dialog (win, &display_info);
                dynamicTitleMenu_destroy(win);
            }
        }
        else if( data->id==BROWSE_DELETE )
        {
            data->numberOfRecords=StopwMemoRead();//gdy add 27/08/02
            // while(StopwIndex[data->numberOfRecords].flag)
            //  data->numberOfRecords++;
            // zgzTraceData("data->numberOfRecords", data->numberOfRecords);   		 
            if( data->numberOfRecords )
            {
                data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

                if( data->menu_list_data == 0 )
                {
                    TRACE_EVENT("Failed memory alloc 1 ");
                    return;
                }

                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( data->numberOfRecords * sizeof(T_MFW_MNU_ITEM) );

                if( data->menu_list_data->List == 0 )
                {
                    TRACE_EVENT("Failed memory alloc 2");
                    return;
                }

                for( i = 0; i < data->numberOfRecords ; i++ )
                {
                    if( StopwIndex[i].type )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_STOPWATCH_CIRCLE, 0);//&circle_bmp;
                    }
                    else
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_STOPWATCH_SEPA, 0);//&sepa_bmp;
                    }
                    data->menu_list_data->List[i].exta = 0;
                    data->menu_list_data->List[i].edit = 0;
                    data->menu_list_data->List[i].menu =0;
                    data->menu_list_data->List[i].func = NULL;
                    TRACE_EVENT((char*)StopwIndex[i].name);
                    data->menu_list_data->List[i].str=(char*)StopwIndex[i].name;
                    TRACE_EVENT(data->menu_list_data->List[i].str);
                    data->menu_list_data->List[i].flagFunc = item_flag_none;     
                }

                data->menu_list_data->ListLength =data->numberOfRecords;
                data->menu_list_data->ListPosition = 1;
                data->menu_list_data->CursorPosition = 1;
                data->menu_list_data->SnapshotSize = data->numberOfRecords;
                data->menu_list_data->Font = 0;
                data->menu_list_data->LeftSoftKey = TxtDelete;
                data->menu_list_data->RightSoftKey = TxtSoftBack;
                data->menu_list_data->KeyEvents = KEY_ALL;
                data->menu_list_data->Reason = 0;
                data->menu_list_data->Strings = TRUE;
                data->menu_list_data->Attr   = &stopw_menuAttrib;
                data->menu_list_data->autoDestroy    = FALSE;
                data->menu_list_data->ListMenuFlag  =1;
                data->menu_list_data->ListMenuHeadStr =MmiRsrcGetText(TxtStopwatch);
                listDisplayListMenu(win, data->menu_list_data,(ListCbFunc)dynamicTitleList_cb,0);// 
            }
            else
            {
                dialog_info_init(&display_info);               
                display_info.TextId2     =TxtNorecord;           
                display_info.Time       = FOREVER;
                display_info.Callback     = (T_VOID_FUNC)NULL;
                display_info.iconindex = REMIND_NORECORD;
                display_info.Identifier =0;
                /*
                * Call Info Screen
                */
                info_dialog (win, &display_info);
                dynamicTitleMenu_destroy(win);
            }
        }
        //winShow(win);
        break;
    case DYNAMIC_EXIT:
        dynamicTitleMenu_destroy(win);
        break;
    default:
        break;          
    }
}


static int  dynamicTitle_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    DynamicTitleData* data = (DynamicTitleData *)win->user;

    if( data EQ NULL )
        return 0;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
            * Clear Screen
                */
            dspl_ClearAll();                
        }
        break;
    default:
        return 0;
    }
    return 1;
}


int GetNumber()
{
    int i=0;
    while( temp_data.record[i] )
	{
		if(i >= STOPWRECORD_NUM)		// MI18800000346 2004.4.23 WYJ
		{
			i = STOPWRECORD_NUM;
			break;
		}
		
        i++;
    }
    return i;
}

void dynamicTitleList_cb(T_MFW_HND  Parent, ListMenuData * ListData)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *)Parent)->data;
    DynamicTitleData * data     = (DynamicTitleData *)win_data->user;  
    T_MFW_HND   win;
    T_MFW_HND   parent;
    T_DISPLAY_DATA display_info;
    int i,flag=0;

    TRACE_EVENT("StopwList_cb");

    if( data->id==BROWSE_TITEL )
    {
        TRACE_EVENT("data->id==BROWSE_STOPW");
        if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
            || (ListData->Reason EQ LISTS_REASON_HANGUP) )
        {
            listsDestroy(data->menu_list_data->win);
            dynamicTitleMenu_destroy(data->win);                   
        }
        else if( ListData->Reason EQ LISTS_REASON_SELECT )
        {
            //TRACE_EVENT(StopwIndex[ListData->ListPosition].name);
            parent=data->parent_win;     
            wstrcpy((char*)temp_data.name,(char*)StopwIndex[ListData->ListPosition].name);
            temp_data.group_number=StopwIndex[ListData->ListPosition].group_number;
            temp_data.type=StopwIndex[ListData->ListPosition].type;
            TRACE_EVENT(temp_data.name);
            i=0;
            while( FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].record[i] )
            {
				if(i >= STOPWRECORD_NUM)	// MI18800000346 2004.4.23 WYJ
					break;
				
                temp_data.record[i]=FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].record[i];
                i++;
            }
	    	listsDestroy(data->menu_list_data->win);
            dynamicTitleMenu_destroy(data->win);
            win= dynamicRecord_create(parent);
            if( win NEQ NULL )
                SEND_EVENT(win, DYNAMIC_RECORD_INIT, 0, 0);
        }
    }
    else if( data->id==BROWSE_DELETE )
    {
        TRACE_EVENT("data->id==BROWSE_DELETE");
        if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
            || (ListData->Reason EQ LISTS_REASON_HANGUP) )
        {
            listsDestroy(data->menu_list_data->win); 
            dynamicTitleMenu_destroy(data->win);
        }
        else if( ListData->Reason EQ LISTS_REASON_SELECT )
        {
            for( i=0;i<NUMBER_OF_GROUP;i++ )
            {
                if( FFS_StopwData.group[i].group_number>FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].group_number )
                    FFS_StopwData.group[i].group_number--;
            }
            FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].type=0;
            memset(FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].name,0,sizeof(FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].name));
            for( i=0;i<A_GROUP_NUMBER;i++ )
            {
                FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].record[i]=0;
            }
            memset(&FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1],0,sizeof(FlashStopwatch));
            //FFS_StopwData.group[StopwIndex[ListData->ListPosition].flag-1].group_number=0;
            if( !flash_Stopwrite() )
            {
                TRACE_EVENT("flash_Stopwrite success");
                dialog_info_init(&display_info);//gdy add
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtDeleted;
                display_info.TextId      = '\0';
                display_info.Time       = FOREVER;
                display_info.Callback     = (T_VOID_FUNC)NULL;//dynamicTitle_dialog_cb;
                display_info.iconindex = REMIND_COMPLETE;
                display_info.Identifier =0;
                /*
                * Call Info Screen
                */
                info_dialog (data->win, &display_info);                   
                listsDestroy(data->menu_list_data->win);
                dynamicTitleMenu_destroy(dynamic_win);                    
            }
            else
            {
                dialog_info_init(&display_info);//gdy add
                display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = TxtSoftBack;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtError;
                display_info.TextId      = '\0';
                display_info.Time       = ONE_SECS;
                display_info.Callback     = (T_VOID_FUNC)NULL;//dynamicTitle_dialog_cb;
                display_info.iconindex = REMIND_FAILURE;
                display_info.Identifier =0;
                /*
                * Call Info Screen
                */
                info_dialog (data->win, &display_info);
                for( i=0;i<NUMBER_OF_GROUP;i++ )
                {
                    if( FFS_StopwData.group[i].group_number )
                        flag=1;
                }
                //				zgzTraceData("flag=", flag);
                if( flag )
                {
                    listsDestroy(data->menu_list_data->win);
                    SEND_EVENT(dynamic_win, DYNAMIC_INIT, BROWSE_DELETE, 0);
                }
                else
                {
                    listsDestroy(data->menu_list_data->win);
                    dynamicTitleMenu_destroy(dynamic_win);
                }
            }                 
        }
    }
}

void dynamicTitleMenu_destroy(MfwHnd own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    DynamicTitleData* data   = (DynamicTitleData*)win->user;

    TRACE_EVENT ("dynamicTitleMenu_destroy()");

    dynamic_win=NULL;


    if( own_window )
    {
        /*
        * Delete WIN Handler
            */


        win_delete (own_window);
        /*
        * Free Memory
        */
        if( data )
        {
            if( data->menu_list_data )
            {
                if( data->menu_list_data->List )
                    FREE_MEMORY((void*)data->menu_list_data->List,data->numberOfRecords*sizeof(T_MFW_MNU_ITEM));

                FREE_MEMORY((void*)data->menu_list_data,sizeof(ListMenuData));
            }
            FREE_MEMORY ((void *)data, sizeof (DynamicTitleData));
        }
    }
}

static T_MFW_HND dynamicRecord_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    DynamicRecordData* data = (DynamicRecordData *)ALLOC_MEMORY (sizeof (DynamicRecordData ));

    TRACE_EVENT("dynamicRecord_create");

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)dynamic_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)dynamicRecord_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;   
    //
    //realpositon=1;
    //displaypositon=1;
    //data->stroll=0;
    dynamicRecord_win=data->win;

    return data->win;
}

static void dynamicRecord_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    DynamicRecordData* data = (DynamicRecordData *) win_data->user;
    T_DISPLAY_DATA    display_info;
    char tem_str[4];
    char* titleStr;
    int i;

    TRACE_EVENT("dynamicRecord_DialogCB");

    switch( event )
    {
    case DYNAMIC_RECORD_INIT:  
        data->kbd=kbd_create(win, KEY_ALL, (T_MFW_CB)dynamic_kbd_cb);
        data->numberOfRecords =GetNumber();    
#if (MAIN_LCD_SIZE==4)
		data->screenNumber=data->numberOfRecords/7+1;
#elif (MAIN_LCD_SIZE==3)
		data->screenNumber=data->numberOfRecords/6+1;
#endif
        
		data->currentNumber=1;
        if( data->numberOfRecords )
        {
            winShow(win);
        }
        else
        {
            dialog_info_init(&display_info);//gdy add
            display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = TxtSoftBack;
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2     =TxtNorecord;
            display_info.TextId      = '\0';
            display_info.Time       = FOREVER;
            display_info.Callback     = (T_VOID_FUNC)NULL;
            display_info.iconindex = REMIND_COMPLETE;
            display_info.Identifier =0;
            /*
            * Call Info Screen
            */
            info_dialog (win, &display_info);
            dynamicRecordMenu_destroy(win);
        }
        break;
    case DYNAMIC_RECORD_EXIT:
        dynamicRecordMenu_destroy(win);
        break;
    }
}


static int  dynamic_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    DynamicRecordData* data = (DynamicRecordData *)win->user;
    int old_color;

    TRACE_EVENT ("dynamic_win_cb()");


    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
            * Clear Screen
                */
            dspl_ClearAll();  
            recorddisplay(data);

            displaySoftKeys(0, TxtSoftBack);
        }
    }
}
/* ʾ¼ */
void recorddisplay(DynamicRecordData* data)
{
	
#if 0
	
    int i,Number;
    int old_color,t;
    game_Rectangle rectangle;
    char string[20],tem_str[4];
	U8 uMode = 0;
	uMode = dspl_Enable(0);

    TRACE_EVENT("recorddisplay");

	//title display
	dspl_ClearAll();  
	TD_drawBkg(BG_rect, BG_attr);

    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                 menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                 menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

    dspl_colorTextOut((102-6*wstrBitlen(temp_data.name))/2, 0, DSPL_TXTATTR_TRANSPARENT, temp_data.name, 0x0);

    if( data->currentNumber == data->screenNumber )   //һҳ
    {
        Number = GetNumber();               //ܼ¼
        if( !(Number%3) )
            Number=(data->currentNumber-1)*3;
	}
    else
    {
		Number=(data->currentNumber)*3;
	}

    memset((char*)string,0,sizeof(string));  
    memset((char*)tem_str,0,sizeof(tem_str));
	
    for( i =(data->currentNumber-1)*3; i < Number; i++ )
    {
        if( i>39 )
            return;
        /* ֿʾ */
        drawSolidRectangle(5+EX, 20+i%3*16, 20+EX, 17+i%3*16+12, 3, 0x5AC7FF,0x5AC7FF);   

        /* ʾ */
        set_font_type(UNI12X12_FONT);
        sprintf((char*)tem_str,"%02d",i+1);
        dspl_colorTextOut(7+EX, 19+i%3*16,DSPL_TXTATTR_TRANSPARENT,(char*)tem_str,0xffffff);      

        /* ¼ʾ */
        sprintf((char*)tem_str,"%02d:",temp_data.record[i]/36000);//hours
        strcpy((char*)string,(char*)tem_str);
        sprintf((char*)tem_str,"%02d:",(temp_data.record[i]%36000)/600);//munites
        strcat((char*)string,(char*)tem_str);
        sprintf((char*)tem_str,"%02d:",((temp_data.record[i]%36000)%600)/10);//seconds
        strcat(string,(char*)tem_str);
        sprintf((char*)tem_str,"%d",((temp_data.record[i]%36000)%600)%10);//ms	  
        strcat((char*)string,(char*)tem_str);


		set_font_type(UNI12X12_FONT);
		dspl_colorTextOut(34+EX, 19+i%3*16,DSPL_TXTATTR_TRANSPARENT, (char*)string, 0x000000);        
    }   

	dspl_Enable(uMode );
#endif
	
	int i,Number;
    int old_color,t;
    game_Rectangle rectangle;
    char string[20],tem_str[4];
	
    TRACE_EVENT("recorddisplay");
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON(ICON_MENUUP);
    /*
    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
		menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
		menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
    */
    dspl_colorTextOut((120-8*wstrBitlen(temp_data.name))/2+EX, 0, DSPL_TXTATTR_TRANSPARENT, temp_data.name, 0x0);
	
    if( data->currentNumber == data->screenNumber )   //һҳ
    {
        Number = GetNumber();               //ܼ¼
#if (MAIN_LCD_SIZE==4)
        if( !(Number%7) )
            Number=(data->currentNumber-1)*7;
#elif (MAIN_LCD_SIZE==3)
		if( !(Number%6) )
            Number=(data->currentNumber-1)*6;
#endif
	}
    else
    {
#if (MAIN_LCD_SIZE==4)
		
		Number=(data->currentNumber)*7;
#elif (MAIN_LCD_SIZE==3)
		Number=(data->currentNumber)*6;
#endif
	}
	
    memset((char*)string,0,sizeof(string));  
    memset((char*)tem_str,0,sizeof(tem_str));
#if (MAIN_LCD_SIZE==4)	
    for( i =(data->currentNumber-1)*7; i < Number; i++ )
    {
        if( i>39 )
            return;
        /* ֿʾ */
        drawSolidRectangle(11+EX, 22+i%7*17, 26+EX, 20+i%7*17+12, 3, 0x5AC7FF,0x5AC7FF);   
		
        /* ʾ */
        set_font_type(UNI12X12_FONT);
        sprintf((char*)tem_str,"%02d",i+1);
        dspl_colorTextOut(13+EX,22+i%7*17,DSPL_TXTATTR_TRANSPARENT,(char*)tem_str,0xffffff);      
		
        /* ¼ʾ */
        sprintf((char*)tem_str,"%02d:",temp_data.record[i]/36000);//hours
        strcpy((char*)string,(char*)tem_str);
        sprintf((char*)tem_str,"%02d:",(temp_data.record[i]%36000)/600);//munites
        strcat((char*)string,(char*)tem_str);
        sprintf((char*)tem_str,"%02d:",((temp_data.record[i]%36000)%600)/10);//seconds
        strcat(string,(char*)tem_str);
        sprintf((char*)tem_str,"%d",((temp_data.record[i]%36000)%600)%10);//ms	  
        strcat((char*)string,(char*)tem_str);
        if( (i+1)%2 )
        {
            rectangle.x1    = 38+EX;
            rectangle.y1    = 20+i%7*17;
            rectangle.x2    = 108+EX;
            rectangle.y2    = 20+i%7*17+15;
            rectangle.color = 0xc7eceb;
            rectangle.fillcolor = 0xc7eceb;
			
            DrawRectagle(rectangle);
            set_font_type(UNI12X12_FONT);
            dspl_colorTextOut(43+EX, 22+i%7*17,DSPL_TXTATTR_TRANSPARENT, (char*)string, 0x000000);        
        }
        else
        {
            set_font_type(UNI12X12_FONT);
            dspl_colorTextOut(43+EX, 22+i%7*17+1,0, (char*)string, 0x000000);
        }
    }  
#elif (MAIN_LCD_SIZE==3)
	for( i =(data->currentNumber-1)*6; i < Number; i++ )
    {
        if( i>39 )
            return;
        /* ֿʾ */
        drawSolidRectangle(11+EX, 22+i%6*16, 26+EX, 20+i%6*16+12, 3, 0x5AC7FF,0x5AC7FF);   
		
        /* ʾ */
        set_font_type(UNI12X12_FONT);
        sprintf((char*)tem_str,"%02d",i+1);
        dspl_colorTextOut(13+EX,22+i%6*16,DSPL_TXTATTR_TRANSPARENT,(char*)tem_str,0xffffff);      
		
        /* ¼ʾ */
        sprintf((char*)tem_str,"%02d:",temp_data.record[i]/36000);//hours
        strcpy((char*)string,(char*)tem_str);
        sprintf((char*)tem_str,"%02d:",(temp_data.record[i]%36000)/600);//munites
        strcat((char*)string,(char*)tem_str);
        sprintf((char*)tem_str,"%02d:",((temp_data.record[i]%36000)%600)/10);//seconds
        strcat(string,(char*)tem_str);
        sprintf((char*)tem_str,"%d",((temp_data.record[i]%36000)%600)%10);//ms	  
        strcat((char*)string,(char*)tem_str);
        if( (i+1)%2 )
        {
            rectangle.x1    = 38+EX;
            rectangle.y1    = 20+i%6*16;
            rectangle.x2    = 108+EX;
            rectangle.y2    = 20+i%6*16+15;
            rectangle.color = 0xc7eceb;
            rectangle.fillcolor = 0xc7eceb;
			
            DrawRectagle(rectangle);
            set_font_type(UNI12X12_FONT);
            dspl_colorTextOut(43+EX, 22+i%6*16,DSPL_TXTATTR_TRANSPARENT, (char*)string, 0x000000);        
        }
        else
        {
            set_font_type(UNI12X12_FONT);
            dspl_colorTextOut(43+EX, 22+i%6*16+1,0, (char*)string, 0x000000);
        }
    }  
	
#endif
	
}


static int dynamic_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    DynamicRecordData* data = (DynamicRecordData *)win_data->user;

    TRACE_EVENT("dynamic_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_MNUDOWN:
        if( data->screenNumber==1 )
            break;
        else
        {
            data->currentNumber++;
            if( data->currentNumber>data->screenNumber )
                data->currentNumber=data->screenNumber;
#if (MAIN_LCD_SIZE==4)          
			if( (data->currentNumber==data->screenNumber)&&(!(data->numberOfRecords%7)) )
#elif (MAIN_LCD_SIZE==3)
			if( (data->currentNumber==data->screenNumber)&&(!(data->numberOfRecords%6)) )
#endif
                data->currentNumber--;
            winShow(win);
            break;
        }
    case KCD_MNUUP:
        if( data->screenNumber==1 )
            break;
        else
        {
            data->currentNumber--;
            if( data->currentNumber<1 )
                data->currentNumber=1;
#if (MAIN_LCD_SIZE==4)          
            if( (data->currentNumber==data->screenNumber)&&(!(data->numberOfRecords%7)) )
#elif (MAIN_LCD_SIZE==3)
            if( (data->currentNumber==data->screenNumber)&&(!(data->numberOfRecords%6)) )
								
#endif				
                data->currentNumber++;
            winShow(win);
            break; 
        }
    case KCD_RIGHT:
    case KCD_HUP:
        dynamicRecordMenu_destroy(win);
        break;
    }
    return MFW_EVENT_CONSUMED;
}


void dynamicRecordMenu_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    DynamicRecordData* data   = (DynamicRecordData*)win->user;

    TRACE_EVENT ("dynamicRecordMenu_destroy()");  

    if( own_window )
    {
        /*
        * Delete WIN Handler
            */
		controlBrowseNew();				// MI18800000279

        win_delete(own_window);
        /*
        * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (DynamicRecordData));
    }

}


/*void recordList_cb(T_MFW_HND  Parent, ListMenuData * ListData)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *)Parent)->data;
    DynamicRecordData * data     = (DynamicRecordData *)win_data->user;  
    T_MFW_HND   win;
        
    TRACE_EVENT("StopwList_cb");

    if((ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
    || (ListData->Reason EQ LISTS_REASON_HANGUP))
        {    
            TRACE_EVENT("LISTS_REASON_BACK");
              listsDestroy(data->menu_list_data->win);     
              dynamicRecordMenu_destroy(data->win);    	  	
        }    	
}*/

static T_MFW_HND delete_All_create(MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    DeleteData* data = (DeleteData *)ALLOC_MEMORY (sizeof (DeleteData ));

    TRACE_EVENT("delete_All_create");

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, 0);//(T_MFW_CB)dynamic_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)delete_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;       

    return data->win;
}


static void delete_DialogCB (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    DeleteData* data = (DeleteData *) win_data->user;
    int old_color,i;
    BOOL flag=FALSE;
    T_DISPLAY_DATA display_info; 
    game_Line line;


    switch( event )
    {
    case DELETE_INITIAL:
        for( i=0;i<NUMBER_OF_GROUP;i++ )
        {
            if( FFS_StopwData.group[i].record[0] )
                flag=TRUE;
        }
        if( !flag )
        {
            dialog_info_init(&display_info);                  
            display_info.TextId2     =TxtNorecord;                  
            display_info.Time       = FOREVER;
            display_info.Callback     = (T_VOID_FUNC)NULL;//sepa_dialog_cb;
            display_info.iconindex = REMIND_NORECORD;
            /*
            * Call Info Screen
            */
            info_dialog (win, &display_info);
            delete_destroy(win);
            // bookMenuDestroy(delete_menu_win);
            break;
        }
        data->kbd          = kbd_create(win, KEY_ALL, (T_MFW_CB)delete_kbd_cb);

		// 2004.3.10 WYJ modify embedded popup dialog
        draw_popup_background();
		/* 2004/05/25 sunsj modify */
		draw_icon_require();
		//dialog_drawPopIcon(POP_ICONREQUIRE);
		
#if(MAIN_LCD_SIZE==4)
		ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtDeleteAll);
#elif(MAIN_LCD_SIZE==3)
		ALIGNED_PROMPT(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, DSPL_TXTATTR_TRANSPARENT, TxtDeleteAll);
#endif
        displaySoftKeys(TxtSoftOK,TxtSoftBack);        /*2003/12/1, wangyan modify*/
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        break;
    case DELETE_EXIT:
        delete_destroy(win);
        break;
    }
}


static int delete_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    DeleteData* data = (DeleteData *)win_data->user;  
    T_DISPLAY_DATA display_info;  
    int i;
    BOOL flag=FALSE;

    switch( keyboard->code )
    {
    case KCD_LEFT:       
        //flash_Stopwread();   		
        //if(flag)
        //	{
        FlashStopwDataInitialise();
        if( !flash_Stopwrite() )
        {
            dialog_info_init(&display_info);
            display_info.TextId2 = TxtDeleted;
            display_info.Time       = FOREVER;                  
            display_info.iconindex =REMIND_COMPLETE;
            /*
            * Call Info Screen
            */
            info_dialog (win, &display_info);
            delete_destroy(win);
            bookMenuDestroy(delete_menu_win);
        }
        else
        {
            dialog_info_init(&display_info);                    
            display_info.TextId2     =TxtError;                  
            display_info.Time       = FOREVER;
            display_info.Callback     = (T_VOID_FUNC)NULL;//sepa_dialog_cb;
            display_info.iconindex = REMIND_NORECORD;                  
            /*
            * Call Info Screen
            */
            info_dialog (win, &display_info);
            delete_destroy(win);
            bookMenuDestroy(delete_menu_win);
        }
        /*		}
        else
        {
        dialog_info_init(&display_info);   			      
        display_info.TextId2     =TxtNorecord;                  
        display_info.Time       = FOREVER;
        display_info.Callback     = (T_VOID_FUNC)NULL;//sepa_dialog_cb;
        display_info.iconindex = REMIND_NORECORD;
        /*
        * Call Info Screen
        */
        /*          info_dialog (win, &display_info);
        delete_destroy(win);
        bookMenuDestroy(delete_menu_win);
}*/
        break;
    case KCD_RIGHT:
        SEND_EVENT(win, DELETE_EXIT, 0, 0);
        break;
    }
}




void delete_destroy(MfwHnd own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    DeleteData* data   = (DeleteData*)win->user;

    TRACE_EVENT ("delete_destroy()");  

    if( own_window )
    {
        /*
        * Delete WIN Handler
            */


        win_delete (own_window);
        /*
        * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (DeleteData));
    }
}


int stopwAddOne()
{
    int i=0,j=0;

    TRACE_EVENT("stopwAddOne");

    // flash_Stopwread();
    while( FFS_StopwData.group[i].record[0] )
        i++;
    TraceInt(i);
    TRACE_EVENT(temp_data.name);
    wstrcpy((char*)FFS_StopwData.group[i].name,(char*)temp_data.name);
    FFS_StopwData.group[i].type=temp_data.type;
    FFS_StopwData.group[i].group_number=temp_data.group_number;
    while( temp_data.record[j] )
    {
    	if(j >= STOPWRECORD_NUM)		// MI18800000346 2004.4.23 WYJ
		break;	

        FFS_StopwData.group[i].record[j]=temp_data.record[j];
        j++;
    } 
    return flash_Stopwrite();
}

void reset()
{
    // int i;

    memset(&temp_data,0,sizeof(temp_data));
    /* temp_data.group_number=0;
    temp_data.type=0;
    strcpy((char*)temp_data.name,"");
    for(i=0;i<A_GROUP_NUMBER;i++)
    {
      temp_data.record[i]=0;
}*/
}

/* flashļ¼ */
int StopwMemoRead()
{
    int i,j=0;
    char s[20];
    int group_number;
    //flash_Stopwread();

    TRACE_EVENT("StopwMemoRead");
    for( i=0;i<NUMBER_OF_GROUP;i++ )  //StopwIndex
    {
        StopwIndex[i].flag=0;
        //strcpy((char*)StopwIndex[i].name,"");
        memset(StopwIndex[i].name,0,sizeof(StopwIndex[i].name));
        StopwIndex[i].type=0;
        StopwIndex[i].group_number=0;
    }
    group_number=0;
    for( i=0;i<NUMBER_OF_GROUP;i++ )
    {
        //TraceInt(wstrlen((char*)FFS_StopwData.group[i].name));
        if( FFS_StopwData.group[i].record[0] )
        {
            // TRACE_EVENT((char*)FFS_StopwData.group[i].name);
            StopwIndex[j].flag=i+1;
            wstrcpy((char*)StopwIndex[j].name,(char*)FFS_StopwData.group[i].name);
            StopwIndex[j].type=FFS_StopwData.group[i].type;
            StopwIndex[j].group_number=FFS_StopwData.group[i].group_number;
            j++;
            TraceInt(FFS_StopwData.group[i].group_number);
            if( group_number<FFS_StopwData.group[i].group_number )
                group_number=FFS_StopwData.group[i].group_number;
        }
    } 
    TRACE_EVENT("END_StopwMemoRead");

    TraceInt(group_number);
    return group_number;
}
