/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   Stopwatch
 $File:       MmStopwatch.h
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

     This provides the main stopwatch functionality

********************************************************************************
 $History: Mmistopwatch.h

  25/10/00      Original Condat(UK) BMI version.
  10/09/02            gdy add

 $End

*******************************************************************************/


/*******************************************************************************

                               Data Types

*******************************************************************************/
#ifndef _MMISTOPWATCH_H
#define _MMISTOPWATCH_H 1

//extern MfwHnd OldParent;

typedef struct 
{
   
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
    T_EDITOR_DATA     editor_data;
   
    /* associated handlers */

    T_MFW_HND         kbd;   
    T_MFW_HND        info_tim;
    USHORT          Identifier;
    char        timebuffer[12];
    T_MFW_HND menu_options_win;
    T_MFW_HND editor_win;
    USHORT event;
    BOOL RightKey;//indicate if it is the first time in the count status
    int type;//indicate this group is separately or bycircle
    unsigned int counter;//indicate the mount of ms
    int groupNumber;//indicate which group is the current record belong to
    int recordNumber;//indicate the number of current record in this group
} StopwData;

typedef enum
{
 STOPW_COUNT,
 STOPW_EXIT
}STOPW_EVENT;

typedef enum
{
 BROWSE_TITEL,
 BROWSE_DELETE
}BROWSE_EVENT;

typedef struct 
{
   
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
      
    /* associated handlers */

    T_MFW_HND         kbd; 
     ListMenuData*     menu_list_data;     
     int id;
    int numberOfRecords;
    int flag;
}DynamicTitleData;

typedef enum
{
 DYNAMIC_INIT,
 DYNAMIC_EXIT	
}DYNAMIC_EVENT;


typedef struct 
{
   
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
      
    /* associated handlers */

    T_MFW_HND         kbd;     
     int numberOfRecords;
     int screenNumber;
     int currentNumber;
}DynamicRecordData;

typedef enum
{
  DYNAMIC_RECORD_INIT,
  DYNAMIC_RECORD_EXIT
}DYNAMIC_RECORD;

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
      
    /* associated handlers */

    T_MFW_HND         kbd; 
    T_MFW_HND editor_win;
    T_EDITOR_DATA     editor_data;
}EditorData;

typedef enum
{
  STOPWEDITOR_INIT,
  STOPWEDITOR_EXIT
}EDITOR_EVENT;

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
      
    /* associated handlers */

    T_MFW_HND         kbd; 
}DeleteData;

typedef enum
{
 DELETE_INITIAL,
 DELETE_EXIT
}DELETE_EVENT;

typedef struct
{
 char str[12];
}char_str;

int separately(MfwMnu* m, MfwMnuItem* i);
int bycircle(MfwMnu* m, MfwMnuItem* i);
int browse(MfwMnu* m, MfwMnuItem* i);
int Delete(MfwMnu* m, MfwMnuItem* i);
int continue_count(MfwMnu* m, MfwMnuItem* i);
int save(MfwMnu* m, MfwMnuItem* i);
int restart(MfwMnu* m, MfwMnuItem* i);
int browse_record(MfwMnu* m, MfwMnuItem* i);
int delete_All(MfwMnu* m, MfwMnuItem* i);
int DeleteOnebyOne(MfwMnu* m, MfwMnuItem* i);
#endif

