/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		timer
 $File:		    Mmitoolkit.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the timer functionality

  
********************************************************************************
 $History: MmiToolkit.c

	25/10/00			Original Condat(UK) BMI version.
	27/08/02            gdy add
	   
 $End

*******************************************************************************/
/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "MmiBookShared.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "GameDisplay.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
//#include "MmiStopwatch.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
#include "Mmitoolkit.h"
#include "Mmitimedate.h"

#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
/******************************************************************************
                                                                              
                                                                                                              
*******************************************************************************/
#if 0
#define CLEAR_BOTTOM_ZONE dspl_Clear( KEY_AREA );

static int statusflag=TIMER_START;
static char lefttime[12]; 
static int timenumber=0;
static int pasttime=0;
static MfwHnd timer_win=NULL;
static MfwHnd timer_editor_win=NULL;
/******************************************************************************
                                                                              
                                                                                                             
*******************************************************************************/

int tooltimer(MfwMnu* m, MfwMnuItem* i);
T_MFW_HND timer_start(T_MFW_HND parent_window, SHORT ID);
static T_MFW_HND toolkit_timer_create(MfwHnd parent_window);
static void timer_DialogCB(T_MFW_HND win, USHORT e,  SHORT value, void * parameter);
static int timer_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_CB timer_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);
static int chartoint(char* str);
void timerdestroy (T_MFW_HND own_window);
T_MFW_HND timer_edt_create(T_MFW_HND parent_window);
static int timer_edt_kbd_cb (MfwEvt e, MfwKbd *kc);
void timer_edt_destroy  (T_MFW_HND own_window);
void timer_memo_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void timer_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void reset_edt_attr_sett1(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
					U8 *controls, char *text,U16 size,MfwEdtAttr* attr,U8 dsplTitle);
static int timer_edt_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);

T_MFW_HND tooltimerstart(T_MFW_HND parent_win)
{
    T_MFW_HND       	win    = toolkit_timer_create(parent_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    timerdata * timer_data = (timerdata *)win_data->user;
    if (win NEQ NULL)
        {
           	SEND_EVENT (win, TIMER_INIT, statusflag, timer_data);
        } 
    return win;
}

int tooltimer(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND	    	parent_win = mfwParent( mfw_header());
    T_MFW_HND       	win    = toolkit_timer_create(parent_win);
    
	 T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
      timerdata * timer_data = (timerdata *)win_data->user;

      TRACE_EVENT("tooltimer");
	
    if (win NEQ NULL)
        {
           	SEND_EVENT (win, TIMER_INIT, statusflag, timer_data);
        } 

   return 1;
}



/*T_MFW_HND timer_start(T_MFW_HND parent_window, SHORT ID)
{
  	T_MFW_HND       	win           = timer_create(parent_window);
	 T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
      timerdata * timer_data = (timerdata *)win_data->user;

      TRACE_FUNCTION("timer_start()");
	  TRACE_EVENT("timer_start");

	
    if (win NEQ NULL)
        {
           	SEND_EVENT (win, TIMER_INIT, ID, timer_data);
        } 

   return win;
}*/


static T_MFW_HND toolkit_timer_create(MfwHnd parent_window)
{
	timerdata     * data = (timerdata *)ALLOC_MEMORY (sizeof (timerdata ));
	T_MFW_WIN  * win;
	
    
      TRACE_EVENT("timer_create");
	if (data EQ NULL)
	{
		return NULL;
	}

	// Create window handler
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, 0);
	if (data->win EQ NULL)
	{
		
		return NULL;
	}
	// connect the dialog data to the MFW-window
	data->mmi_control.dialog = (T_DIALOG_FUNC)timer_DialogCB;
	data->mmi_control.data   = data;
	win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent_win         = parent_window;
	timer_win=data->win;	    
      
    
	return data->win;
}


static void timer_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
       T_MFW_WIN       	*win_data   = ( (T_MFW_HDR *) win )->data;
	timerdata* data = (timerdata *) win_data->user;
	T_timer_edt * timer_edt_data = (T_timer_edt *) parameter;//tida editor data
	T_MFW_HND timer_edt_win;
	T_DISPLAY_DATA display_info;

	//data->Identifier=value;
	TRACE_EVENT("timer_DialogCB");

	

       switch(event)
       	{
       	case TIMER_INIT:

       	
       		if(value==TIMER_START)
       			{

       			TRACE_EVENT("TIMER_START");
       		    timer_edt_win = timer_edt_create(data->win);
			    if(timer_edt_win!=NULL)
			      {
				    SEND_EVENT(timer_edt_win,value,0,data);
			      }

			    }
       		else if(value==MIDDLE)
       			{
       			timer_edt_win = timer_edt_create(data->win);
			  if(timer_edt_win!=NULL)
			  {
				SEND_EVENT(timer_edt_win,value,0,data);
			  }
   			}
			break;
	case TIMER_END:
			timerdestroy(win);
			break;
		default:
			break;
		}
   }

void timer_memo_dialog_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
  /*T_MFW_WIN * win_data = ((T_MFW_HDR *)timer_editor_win)->data;
	T_timer_edt * edt_data = (T_timer_edt *)win_data->user;
	T_MFW_WIN     * win_data1  = ((T_MFW_HDR *)timer_win)->data;
    timerdata* data1   = (timerdata*)win_data1->user;*/
  
  
  TRACE_EVENT ("voice_memo_dialog_cb()");

  switch(reason)
  	{
  	case INFO_KCD_RIGHT:
  	default:
  		break;      
  	}
  Stopplayingdevice();
  //timer_edt_destroy(timer_editor_win);
  //timerdestroy(timer_win);
  
}


static int timer_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
TRACE_EVENT("timer_win_cb");

  if (event EQ MfwWinVisible)
  {
    /*
     * Top Window has no output
     */
    dspl_ClearAll();
	return 1;
  }
  return 0;
}


T_MFW_HND timer_edt_create(T_MFW_HND parent_window)
{
  T_timer_edt * data = (T_timer_edt*)ALLOC_MEMORY (sizeof (T_timer_edt));

  T_MFW_WIN * win;

  data->editor_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)timer_edt_win_cb);

  TRACE_EVENT("timer_edt_create");

  if (data->editor_win EQ 0)
    return 0;

  /*
   * Create window handler
   */
  data->mmi_control.dialog    = (T_DIALOG_FUNC)timer_editor;
  data->mmi_control.data      = data;
  data->parent_win = parent_window;
  win                         = ((T_MFW_HDR *)data->editor_win)->data;
  win->user                   = (void *) data;
  /*
   * Create any other handler
   */
  //reset_edt_attr_sett1(20,70,70,16,0,0,edtCurBar1,0,(char*)data->elapsed_time,8,&data->editAttr,0);  
  data->info_tim=timCreate(data->parent_win, 1000, (T_MFW_CB)timer_tim_cb);
  data->editor_handle = edt_create(data->editor_win,&data->editAttr,0,0);
  data->kbd_handle = kbd_create(data->editor_win,KEY_ALL,(T_MFW_CB)timer_edt_kbd_cb);
  timer_editor_win=data->editor_win;
   /*
   * return window handle
   */
   winShow(data->editor_win);
  return data->editor_win;
}


static int timer_edt_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{


  T_timer_edt * edt_data = (T_timer_edt *)win->user;//tida edt data
  T_MFW_WIN * win_timer =((T_MFW_HDR *)edt_data->parent_win)->data;
  int old_color;
  game_Line line;
      

  TRACE_FUNCTION ("timer_edt_win_cb");

  if (event EQ MfwWinVisible)
  	{

  	dspl_ClearAll();
  	
  	switch(statusflag)
  	{
  	case TIMER_START:
	   PROMPT_COLOR(13,Mmi_layout_second_line(),0,TxtSettime,0xff0000);
	    //displaySoftKeys(TxtStart,TxtSoftBack);
       
		//edt_data->index = 0;
		//edtShow(edt_data->editor_handle);
		//edtChar(edt_data->editor_handle, ecTop);
		//CLEAR_BOTTOM_ZONE;
		dspl_TextOut(23, 60, 0, edt_data->elapsed_time);
	    line.x1=23+edt_data->index*8;
	    line.y1=76;
	    line.x2=23+(edt_data->index+1)*8;
	    line.y2=76;
	    DrawLine(line);
	    old_color=dspl_GetBkgColor();
		dspl_SetBkgColor(0xf0ffff);
        dspl_Clear(0, 144, 119, 159);
		displaySoftKeys(TxtStart,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
		dspl_SetBkgColor(old_color);
		break;
	case MIDDLE:
		TRACE_EVENT("MIDDLE");
		old_color=dspl_GetBkgColor();
		dspl_SetBkgColor(0x00ffff);
        dspl_Clear(3, 30, 117, 80);
		
    	   PROMPT_COLOR(5,35,0, TxtLefttime,0xffffff);    	   

            /*
             * Print the elapsed time
             */

            TRACE_EVENT((char*)edt_data->display_id1);
            dspl_colorTextOut(20, 60, 0, (char *)edt_data->display_id1,0xffffff);
            dspl_SetBkgColor(old_color);

            /*
             * Print softkeys
             */
          old_color=dspl_GetBkgColor();
		  dspl_SetBkgColor(0xf0ffff);
          dspl_Clear(0, 144, 119, 159);
          if(edt_data->LeftKey)
            displaySoftKeys(TxtStop, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		  draw_softkeybar_updown_arrow();//jhxu720
#endif
          else
          	displaySoftKeys(TxtStart, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		  draw_softkeybar_updown_arrow();//jhxu720
#endif
          dspl_SetBkgColor(old_color);
          break;
     default:
     	break;
	}
	 		
    return 1;
  }
  return 0;
  
}


static void timer_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
	T_timer_edt * edt_data = (T_timer_edt *)win_data->user;
	T_MFW_WIN     * win_data1  = ((T_MFW_HDR *)timer_win)->data;
    timerdata* data1   = (timerdata*)win_data1->user;
   	T_DISPLAY_DATA display_info;


    timerdata* timer_data = (timerdata *)parameter;//tida main data

	
	TRACE_EVENT("timer_editor");

  /*
   * depending on event
   */
  switch (event)
  {
	case MIDDLE:
	    TRACE_EVENT("MIDDLE");
      	if(!timenumber)
      	   {  
        	statusflag=TIMER_START;
       		StartPlayByReason(ALARMPLAY,0);
       		tim_stop(edt_data->info_tim);
       		//StartVibrator();
            display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = TxtSoftConfirm;
            display_info.TextString   = '\0';
            display_info.TextString2  = '\0';
            display_info.TextId2     =TxtTimeup;
            display_info.TextId      = '\0';
            display_info.Time       = 30*ONE_SECS;

            display_info.Callback     = (T_VOID_FUNC)timer_memo_dialog_cb;
            /*
             * Call Info Screen
             */
            info_dialog (win, &display_info);
            //statusflag=END;
      		}
       	else{
       		timStart(edt_data->info_tim);
       		}
       	winShow(win);
       	break;
	case TIMER_START:		
		edt_data->LeftKey=FALSE;
		Sprintf((char*)edt_data->elapsed_time,"%s","00:00:00");
		winShow(edt_data->editor_win);		
		break;
   	case END:
		timer_edt_destroy(win);
		break;
	default:
		break;
  }
}

static int timer_edt_kbd_cb (MfwEvt e, MfwKbd *kc)
{

   T_MFW_HND win = mfw_parent(mfw_header());

   T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
   T_timer_edt * edt_data = (T_timer_edt *)win_data->user;//tida edt data

   T_MFW_WIN * win_timer =((T_MFW_HDR *)edt_data->parent_win)->data;
   timerdata* timer_data = (timerdata*)win_timer->user; // tida main data
   T_DISPLAY_DATA display_info;
   int flag=1;
   int t;

    char lin1[12];
   char lin2[12];
 
   TRACE_EVENT("timer_edt_kbd_cb");
    if(statusflag==TIMER_START)
    	{
		switch(kc->code)
		{
			case KCD_0:
			case KCD_1:
			case KCD_2:
			case KCD_3:
			case KCD_4:
			case KCD_5:
			case KCD_6:
			case KCD_7:
			case KCD_8:
			case KCD_9:
			if(edt_data->index NEQ 7)
				{
				if((edt_data->index NEQ 1)&&(edt_data->index NEQ 4))
					{
					        edt_data->elapsed_time[edt_data->index] = '0' + kc->code;
							//edtChar(edt_data->editor_handle,edt_data->elapsed_time[edt_data->index]);
							edt_data->index++;
					}
				else
					{
					        edt_data->elapsed_time[edt_data->index] = '0' + kc->code;
							//edtChar(edt_data->editor_handle,edt_data->elapsed_time[edt_data->index]);
							edt_data->index++;
							/*edtChar(edt_data->editor_handle,':');
							edt_data->elapsed_time[edt_data->index] = ':';*/
							//edtChar(edt_data->editor_handle,ecRight);
							edt_data->index++;
					}
				}
			else
				{
				if(flag)
			    		{
			              edt_data->elapsed_time[edt_data->index] = '0' + kc->code;
				          //edtChar(edt_data->editor_handle,edt_data->elapsed_time[edt_data->index]);
				          //edtChar(edt_data->editor_handle,ecTop);
				          edt_data->index=0;
				          //t=(int)edt_data->elapsed_time[4]-48;
				          //flag=0;
			             }
		             else
			             {
			              edt_data->elapsed_time[edt_data->index] =(char)(t-48);
				          ///edtChar(edt_data->editor_handle,edt_data->elapsed_time[edt_data->index]);
			              }    
				}
	if(((((int)edt_data->elapsed_time[0]-48)*10+((int)edt_data->elapsed_time[1]-48))>=24)||((((int)edt_data->elapsed_time[3]-48)*10+((int)edt_data->elapsed_time[4]-48))>59))
   		{
   		  memset((char*)edt_data->elapsed_time,0,sizeof(edt_data->elapsed_time));
   		  edt_data->index=0;
   		  display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT;
          display_info.LeftSoftKey  = '\0';
          display_info.RightSoftKey = '\0';
          display_info.TextString   = '\0';
          display_info.TextString2  = '\0';
          display_info.TextId2     =TxtInputError;
          display_info.TextId      = '\0';
          display_info.Time       = ONE_SECS;

          display_info.Callback     = (T_VOID_FUNC)timer_memo_dialog_cb;
          /*
           * Call Info Screen
           */
          info_dialog(edt_data->editor_win, &display_info);
		}
			  /*  if(edt_data->index < 8)
					{
						if((edt_data->index NEQ 2)&&(edt_data->index NEQ 5))
						{
							edt_data->elapsed_time[edt_data->index] = '0' + kc->code;
							edtChar(edt_data->editor_handle,edt_data->elapsed_time[edt_data->index]);
							edt_data->index++;
						}
						if((edt_data->index EQ 2)||(edt_data->index EQ 5))
						{
							edtChar(edt_data->editor_handle,':');
							edt_data->elapsed_time[edt_data->index] = ':';
							edt_data->index++;
						}
					}*/		
			 winShow(edt_data->editor_win);
				break;
			case KCD_LEFT:                                 /* select and ok button */
				//edtClear(edt_data->editor_handle);
   		        //edtHide(edt_data->editor_handle);
   		        edt_data->LeftKey=!edt_data->LeftKey;
				timenumber=chartoint((char*)edt_data->elapsed_time);
				timer_flag=TRUE;
				statusflag=MIDDLE;
				SEND_EVENT(win, statusflag, 0, 0);
				winShow(win);
			break;
			case KCD_RIGHT:                                /* back to previous menu */
				       TRACE_EVENT("KCD_RIGHT");
				       tim_stop(edt_data->info_tim);
				       timer_edt_destroy(edt_data->editor_win);					
				       timerdestroy(timer_win);
            break;
			case KCD_MNUUP:                                /* cursor to right  */
					edt_data->index++;
					edtChar(edt_data->editor_handle,ecRight);

					if(((edt_data->index EQ 2)||(edt_data->index EQ 5)))
					{
						edt_data->index++;
						edtChar(edt_data->editor_handle,ecRight);
					}

				 break;
			case KCD_HUP:
			case KCD_MNUDOWN:                            /* cursor to left or clear  */
				if(edt_data->index EQ 0)
						;
			    else
				 edt_data->index--;

				if((edt_data->index EQ 2)||(edt_data->index EQ 5))
				{
				   if(edt_data->index EQ 0)
					 ;
				   else
					 edt_data->index--;

					 edtChar(edt_data->editor_handle,ecLeft);
					 edtChar(edt_data->editor_handle,ecLeft);
				}
				else
				  edtChar(edt_data->editor_handle,ecLeft);				
				break;
			default:
				return MFW_EVENT_CONSUMED;
			}
		}
    else if(statusflag==MIDDLE)
    	{
    	switch(kc->code)
    		{
    		case KCD_LEFT:    	    
    	    edt_data->LeftKey=!edt_data->LeftKey;
  	        //timenumber=0;
  		    //statusflag=TIMER_START;
  		    if(edt_data->LeftKey)
  		        tim_start(edt_data->info_tim);
  		    else
  		    	tim_stop(edt_data->info_tim);
  		    //SEND_EVENT(win, statusflag, 0, 0);
  		    winShow(win);
  		    //timerdestroy(win);
  		    break;
  		    case KCD_RIGHT:
  		    	if(!edt_data->LeftKey)
  		    		{
  		    		  timenumber=0;
  		              statusflag=TIMER_START;
  		    		}
  			    SEND_EVENT(edt_data->editor_win, END, 0, 0);
  			    timerdestroy(timer_win);
  		    break;
  		    default:
  		    break;
    		}
    	}
    else{
    	switch(kc->code)
    		{
    		default:    		  			
  			SEND_EVENT(edt_data->editor_win, END, 0, 0);
  			timerdestroy(timer_win);
    		break;
    		}
    	}
    return MFW_EVENT_CONSUMED;
}


void timer_edt_destroy(T_MFW_HND own_window)
{
  T_timer_edt * data ;
  T_MFW_WIN * win;


  if (own_window)
  {
	  TRACE_FUNCTION ("timer_edt_destroy");

	  win = ((T_MFW_HDR *)own_window)->data;
	  data = (T_timer_edt *)win->user;

	  kbd_delete(data->kbd_handle);
      win_delete (own_window);

	  if(data)
	  {
          //edt_delete(data->editor_handle);
          
	      FREE_MEMORY((void *)data,(sizeof(T_timer_edt)));
	  }
   }
}




static T_MFW_CB timer_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
  T_MFW_HND       win  = mfw_parent (mfw_header());
  T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
  T_timer_edt* data = (T_timer_edt*)win_data->user;
  T_DISPLAY_DATA display_info;

  char str[8];

  TRACE_EVENT ("timer_tim_cb()");

 // switch (statusflag)
  //{
   // case MIDDLE:
      if (timenumber!=0)
      {
          TRACE_EVENT ("continue the second timer");

        timenumber--;
        // it shows here the elapsed time
        memset((char *)data->display_id1,0,sizeof(data->display_id1));
        if(timenumber/3600<10)
           	sprintf((char *)str,"0%d:",timenumber/3600);
        else
        	sprintf((char *)str,"%d:",timenumber/3600);
        strcat((char *)data->display_id1,(char *)str);
        if(timenumber%3600/60<10)
        	sprintf((char *)str,"0%d:",timenumber%3600/60);
        else
        	sprintf((char *)str,"%d:",timenumber%3600/60);
        strcat((char *)data->display_id1,(char *)str);
        if(timenumber%3600%60<10)
        	sprintf((char *)str,"0%d",timenumber%3600%60);
        else
        	sprintf((char *)str,"%d",timenumber%3600%60);
        strcat((char *)data->display_id1,(char *)str);
        strcpy(data->elapsed_time,data->display_id1);
        	
        //sprintf((char*)data->display_id1,"%2d:%2d:%2d", timenumber/3600,timenumber%3600/60,timenumber%3600%60);

        TRACE_EVENT ((char*)data->display_id1);

        //continue the second timer
        timStart (data->info_tim);
        }
      else
      	{
      	//SEND_EVENT(win, statusflag, 0, 0);
      	  timStop(data->info_tim);
      	  timer_flag=FALSE;
      	  StartPlayByReason(ALARMPLAY,0);       		
       		//StartVibrator();
          display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
          display_info.LeftSoftKey  = '\0';
          display_info.RightSoftKey = TxtSoftConfirm;
          display_info.TextString   = '\0';
          display_info.TextString2  = '\0';
          display_info.TextId2     =TxtTimeup;
          display_info.TextId      = '\0';
          display_info.Time       = 30*ONE_SECS;

          display_info.Callback     = (T_VOID_FUNC)timer_memo_dialog_cb;
            /*
             * Call Info Screen
             */
          info_dialog (win, &display_info);
      	}
      //break;
//default:
 //     break;
    TRACE_EVENT("test");  


  //Update the screen
  winShow(win);


  return 0;
}

static int chartoint(char* str)
{
    int result=0,number=0;

    TRACE_EVENT("char to int");
    
/* get the number of seconds*/
    number=(int)str[1]-48+((int)str[0]-48)*10;
    result=result+number*3600;
    number=0;
    /*get the number of munites and turn it into seconds*/

     number=(int)str[4]-48+((int)str[3]-48)*10;
    result=result+number*60;
    number=0;
    /*get the number of hours and turn it into seconds*/

    number=(int)str[7]-48+((int)str[6]-48)*10;
    result=result+number;

    return result;
    
}

void timerdestroy (T_MFW_HND own_window)
{
 T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
 timerdata* data   = (timerdata*)win->user;

  TRACE_EVENT ("timerdestroy()");


 if (own_window)
  {
    /*
     * Delete WIN Handler
     */
    
    
    win_delete (own_window);
    /*
     * Free Memory
    */
   FREE_MEMORY ((void *)data, sizeof (timerdata));
  }
}

static void reset_edt_attr_sett1(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
					U8 *controls, char *text,U16 size,MfwEdtAttr* attr,U8 dsplTitle)
{

	attr->win.px = winPx;
	attr->win.py = winPy;
	attr->win.sx = winSx;
	attr->win.sy = winSy;
	attr->fgColor = fgColor;
	attr->font = font;
	attr->mode = mode;
	attr->controls = controls;
	attr->text = text;
	attr->size = size;
	attr->title_id=dsplTitle;
}
#endif
