/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		timer
 $File:		    Mmitoolkit_timer.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This provides the timer functionality

  
********************************************************************************
 $History: MmiToolkit.c

	25/10/00			Original Condat(UK) BMI version.
	27/08/02            gdy add
	   
 $End

*******************************************************************************/
/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "MmiBookShared.h"
#include "MmiEditor.h"
#include "Mfw_edt.h"
#include "MmiDialogs.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"
#include "GameDisplay.h"

#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
//#include "MmiStopwatch.h"
#include "Mmieditor.h"
#include "Mmieditor_i.h"
#include "Mmisounds.h"
#include "Mmilists.h"
#include "Mmitoolkit.h"
#include "Mmitimedate.h"
#include "Mmiicons.h"

#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mmiouterIdle.h"
#include "Mmitoolkit_timer.h"

//wyj 2003.11.12
#include "TdDisplay.h"
//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "mmicamera.h"
#endif

/******************************************************************************
                                                                              
                                                                                                              
*******************************************************************************/

typedef struct
{
  T_MMI_CONTROL   mmi_control;
  T_MFW_HND       parent_win;
  T_MFW_HND          win;
  T_MFW_HND       info_tim;
  T_MFW_HND       kbd;
  char timebuffer[10];
  char timer_string[10];
 // char string[10];
  int index;
  BOOL LeftKey;
}timer_data;

typedef enum
{
   TIMER_EDT=0,
   TIMER_COUNT,
   TIMER_END
}timer_event;


BOOL		timer_flag		= FALSE;
BOOL		over_flag		= FALSE;
int			timer_counter	= 0;
int			timer_status	= TIMER_EDT;
MfwHnd		info_timer_Hnd	= NULL;
MfwHnd		timer_win		= NULL;
T_MFW_HND	timer_alarm_win	= NULL;
T_MFW_HND	info_window		= NULL;
extern		VOS_Idle_Win;
extern		T_call call_data;
extern		T_MFW_HND alarm_win;
static char timer_string[10];
static int	timer_afterCall	= 0;
extern		MfwHnd timer_Hnd;
static BOOL timer_start		= FALSE;
extern const unsigned char TimerBit[];


static T_MFW_HND	toolkit_timer_create(MfwHnd parent_window);
static int			timer_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void			timer_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int			timer_kbd_cb (MfwEvt e, MfwKbd *kc);
void				timerdestroy (T_MFW_HND own_window);

T_MFW_CB			timer_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);

int					toolkitTimer(MfwMnu* m, MfwMnuItem* i);
T_MFW_CB			timerEnd_tim_cb(T_MFW_EVENT event, T_MFW_TIM *tc);
void				timer_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason);
T_MFW_CB			TimerAlarm_tim_cb(MfwEvt e, MfwTim *tc);
void				timer_alarm();

void				drawSolidRectangle(int x1,int y1,int x2,int y2,int type,int fillcolor,int color);
static int			chartoint(char* str);
T_MFW_CB			info_timer_tim_cb(MfwEvt e, MfwTim *tc);


/* 2003.10.16 wyj Զʱļ */
static void checkTimerNumInput(timer_data *data, U8 keynum);
static void checkTimerLeftInput(timer_data *data);
static void checkTimerRightInput(timer_data *data);

/* ʱ */
extern const TD_Rect	TM_input_rect; 
extern const TD_Attri	TM_input_attr;
extern const TD_Line	TM_index_l;	  
extern const Color		TM_index_c;	   

/* icon */
extern const MfwIcnAttr idl_AttrMask[];

T_MFW_HND tooltimerstart(T_MFW_HND parent_win)
{
    T_MFW_HND       	win    = toolkit_timer_create(parent_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
	// timer_data * timer_data = (timer_data *)win_data->user;
    if (win NEQ NULL)
	{
		SEND_EVENT (win, timer_status, 0, 0);
	} 
    return win;
}
/* "ʱ"˵Ӧ */
int toolkitTimer(MfwMnu* m, MfwMnuItem* i)
{
	T_MFW_HND	    	parent_win = mfwParent( mfw_header());
	T_MFW_HND       	win    = toolkit_timer_create(parent_win);
	
	if(win NEQ NULL)
   	{
		SEND_EVENT(win, timer_status, 0, 0);
   	}
}

static T_MFW_HND toolkit_timer_create(MfwHnd parent_window)
{
	timer_data     * data = (timer_data *)ALLOC_MEMORY (sizeof (timer_data ));
	T_MFW_WIN  * win;
	
    
      TRACE_EVENT("timer_create");
	if (data EQ NULL)
	{
		return NULL;
	}

	// Create window handler
	data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)timer_win_cb);
	if (data->win EQ NULL)
	{
		
		return NULL;
	}
	// connect the dialog data to the MFW-window
	data->mmi_control.dialog = (T_DIALOG_FUNC)timer_DialogCB;
	data->mmi_control.data   = data;
	win                      = ((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent_win         = parent_window;	
	timer_win				 = data->win;
    
	return data->win;
}

/* 2003.11.11 WYJ ޸Ķʱʾ */
static int timer_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	timer_data		*data = (timer_data *)win->user;//tida edt data
	int				old_color;
	game_Line		line;
	game_Rectangle	rectangle;
	char			str[4];

	TD_Line			l;
	
	TRACE_EVENT("timer_win_cb");
	
	if (event EQ MfwWinVisible)
	{
		U8 uMode = 0;
		uMode = dspl_Enable(0);

		dspl_ClearAll();
		if(timer_status==TIMER_EDT)			//༭
		{
			/* background display */
			TD_drawBkg(BG_rect, BG_attr);//ɫ

			/* 2004/05/18 yhf modify */
			/* title display */
			/* 2004/06 sunsj modify for picture manage */
			DRAW_ICON(ICON_MENUUP);
			/*
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
				menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
				menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
			*/
#if(MAIN_LCD_SIZE==4)
			dspl_colorTextOut(16+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtSettime),0x0);
#elif(MAIN_LCD_SIZE==3)
            dspl_colorTextOut(28+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtSettime),0x0);
#endif
			/*input rect display */
			if(!timer_counter)
			{
				strcpy(data->timebuffer,"00:00:00");
			}
			TD_drawSolidRectangle(TM_input_rect, TM_input_attr);
#if(MAIN_LCD_SIZE==4)	
			dspl_TextOut(28+EX, 65, DSPL_TXTATTR_TRANSPARENT, data->timebuffer);
			l		= TM_index_l;
			l.x1	= TM_index_l.x1 + data->index*8;
			l.x2	= TM_index_l.x2 + data->index*8;
#elif (MAIN_LCD_SIZE==3)
			dspl_TextOut(27+EX, 19, DSPL_TXTATTR_TRANSPARENT, data->timebuffer);
			l		= TM_index_l;
			l.x1	= TM_index_l.x1 + data->index*8;
			l.x2	= TM_index_l.x2 + data->index*8;
#endif
			TD_drawLine(l, TM_index_c);
			
			/* icon display */
			/* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
		    DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 3+EX, 20, iconIdTimer, ICON_MASK|ICON_LOCATION);
#elif (MAIN_LCD_SIZE==4)
			DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 18+EX, 45, iconIdTimer, ICON_MASK|ICON_LOCATION);
#endif
			//dspl_BitBlt(5+EX, 30, idl_Attr[iconIdTimer].area.sx, idl_Attr[iconIdTimer].area.sy, 0, idl_Attr[iconIdTimer].icons, DSPL_BMPXOR);
			//dspl_BitBlt(5+EX, 30, idl_AttrMask[iconIdTimer].area.sx, idl_AttrMask[iconIdTimer].area.sy, 0, idl_AttrMask[iconIdTimer].icons, DSPL_BMPAND);
			//dspl_BitBlt(5+EX, 30, idl_Attr[iconIdTimer].area.sx, idl_Attr[iconIdTimer].area.sy, 0, idl_Attr[iconIdTimer].icons, DSPL_BMPXOR);

			displaySoftKeys(TxtStart,TxtSoftBack);
		}
		else if(timer_status==TIMER_COUNT)	//ʱ
		{
			/* background display */
#if(MAIN_LCD_SIZE==3)
            TD_drawBkg(BG_rect, BG_attr);
#endif
			/* 2004/06 sunsj modify for picture manage */
			DRAW_ICON(ICON_MENUUP);
			/*
			dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
				menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
				menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);
			*/
#if(MAIN_LCD_SIZE==4)
			dspl_colorTextOut(8+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtLefttime),0x0);
#elif(MAIN_LCD_SIZE==3)
            dspl_colorTextOut(22+EX,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(TxtLefttime),0x0);
#endif
			
			/* icon display */
#if(MAIN_LCD_SIZE==3)
			TD_drawSolidRectangle(TM_input_rect, TM_input_attr);
			DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 3+EX, 15, iconIdTimer, ICON_MASK|ICON_LOCATION);
			dspl_colorTextOut(27+EX, 17, DSPL_TXTATTR_TRANSPARENT, (char *)timer_string,0x000000);
#elif (MAIN_LCD_SIZE==4)
			drawSolidRectangle(28+EX, 69, 110, 88, 1,0xDBFFFF,0x95668A);
			DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, 9+EX, 72, iconIdTimer, ICON_MASK|ICON_LOCATION);
			dspl_colorTextOut(36+EX, 72, DSPL_TXTATTR_TRANSPARENT, (char *)timer_string,0x000000);
#endif
            /* Print softkeys */
            displaySoftKeys(TxtStop, TxtSoftBack);
		}

		dspl_Enable(uMode );
		return 1;
	}
	return 0;
}


static void timer_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN       	*win_data   = ( (T_MFW_HDR *) win )->data;
	timer_data* data = (timer_data *) win_data->user;
	
	TRACE_EVENT("timer_DialogCB");
	data->kbd = kbd_create(win,KEY_ALL,(T_MFW_CB)timer_kbd_cb);
	switch(event)
	{
	case TIMER_EDT:
		TRACE_EVENT("TIMER_EDT");
		//data->LeftKey=TRUE;
		timer_counter=0;
		//memset(data->timebuffer,0,sizeof(data->timebuffer));
		memset(timer_string,0,10);
		sprintf(timer_string,"00:00:00");
		//sprintf(data->timebuffer,"00:00:00");
		winShow(win);
		break;
	case TIMER_COUNT:
		TRACE_EVENT("TIMER_COUNT");
		if(!timer_start)
		{
			timStart(timer_Hnd);
			timer_start=TRUE;
		}
		winShow(win);
		break;
	}
}

/* ʱص  1s е绰ȣʱtimer_alarm_win */
T_MFW_CB timer_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{ 
	T_MFW_HND	   win = mfwParent( mfw_header());
	// T_MFW_HND    timer_tim_win=NULL;
	int old_color;
	T_DISPLAY_DATA display_info;  
	
	if (timer_counter!=0)
	{
		/* 2003.11.19 WYJ 绰ʱʾbug */ 
        /*
		if(call_win_flag)					
		{
			timer_status=TIMER_EDT;
			tim_stop(timer_Hnd);
			timer_start=FALSE;
			//tim_delete(timer_Hnd);
			//timer_Hnd=NULL;
			iconsDeleteState(iconIdTimer);
		}
		*/
		timer_counter--;
		sprintf(timer_string,"%02d:%02d:%02d",timer_counter/3600,(timer_counter%3600)/60,(timer_counter%3600)%60);
		timStart (timer_Hnd);
	}
	else									//ʱ
	{
		// if(timer_win!=NULL)
		// 	{
		// 	timerdestroy(timer_win);
		// 	}
		TRACE_EVENT("timer_counter==0");
		if((int)call_data.win_incoming||(int)call_data.win_calling||call_win_flag||alarm_win) 
		{          	 
          	 timer_alarm_win=timCreate(win, 1000, (T_MFW_CB)TimerAlarm_tim_cb);
			 timStart(timer_alarm_win);
		}
		else
		{
          	 timer_alarm();					//ʾ
#if 0
			 timDelete(timer_Hnd);       	  
			 timer_flag=FALSE;
			 timer_tim_win=0;
			 timer_status=TIMER_EDT;
			 StartPlayByReason(ALARMPLAY,0);  
			 iconsDeleteState(iconIdTimer);       	  
			 //dspl_colorTextOut(20,40,0,(char*)MmiRsrcGetText(TxtTimeup),0x0000ff);      	 
			 dialog_info_init(&display_info);  
			 display_info.KeyEvents = KEY_RIGHT |KEY_LEFT|KEY_HUP|KEY_F4;
			 display_info.TextId2   = TxtTimeup;
			 display_info.Time       = 30*ONE_SECS;
			 display_info.iconindex = REMIND_NORECORD;
			 display_info.Callback     = (T_VOID_FUNC)timer_dialog_cb;
			 /*
             * Call Info Screen
             */
			 info_dialog (win, &display_info);
#endif
		}
		
	}
	if((timer_win NEQ NULL)&&winIsFocussed(timer_win))
		winShow(timer_win);
	
	return 0;
}


T_MFW_CB info_timer_tim_cb(MfwEvt e, MfwTim *tc)
{
	T_DISPLAY_DATA display_info;
	
	TRACE_EVENT("info_timer_tim_cb");
	if(call_data.win_incoming||call_data.win_calling||call_win_flag)
	{
		TRACE_EVENT("call_data.win_incoming!=NULL");		 
		if(info_window)
		{
			SEND_EVENT(info_window, DIALOG_DESTROY, 0, 0);
		}   
	}
	else
    {    
		if(!info_window)
		{    
			if(timer_afterCall==2)
			{
				TRACE_EVENT("info_window==NULL");
				timDelete(info_timer_Hnd);
				timer_start=FALSE;
				StartPlayByReason(ALARMPLAY,0);   
				dialog_info_init(&display_info); 
				display_info.KeyEvents = KEY_RIGHT |KEY_LEFT|KEY_HUP|KEY_F4;
				display_info.TextId2   = TxtTimeup;
				display_info.Time       = 10*ONE_SECS;
				display_info.iconindex = REMIND_NORECORD;
				display_info.Callback     = (T_VOID_FUNC)timer_dialog_cb;
				/*
				* Call Info Screen
				*/
				info_dialog (0, &display_info);
			}
			else
			{
				timer_afterCall++;
			}
		}
    }
	timStart(info_timer_Hnd);
}

/* ȵûе绰ʱ ʾʱ */
T_MFW_CB TimerAlarm_tim_cb(MfwEvt e, MfwTim *tc)
{
	if(call_data.win_incoming||call_data.win_calling||call_win_flag||alarm_win)
		timStart(timer_alarm_win);
	else
	{  
		if(timer_afterCall==2)
		{
			timDelete(timer_alarm_win);  
			timer_start=FALSE;
			timer_alarm();
			timer_afterCall=0;
		}
		else
		{
			timer_afterCall++;
			timStart(timer_alarm_win);
		}
	}
}

//ʾʱ
void timer_alarm()
{
	T_DISPLAY_DATA display_info;

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
     CamExit();
#endif
	

	// MI18800000348 wyj
	LedLightnessAdjust(200);
	timStart(gtVibator);
	
	TRACE_EVENT("timer_alarm");
	// timDelete(timer_Hnd);  
	timStop(timer_Hnd);
	timer_start=FALSE;
	// timer_Hnd=NULL;
	timer_flag=FALSE;  
	timer_status=TIMER_EDT;
	StartPlayByReason(ALARMPLAY,0);  
	iconsDeleteState(iconIdTimer);  
	dialog_info_init(&display_info);  
	display_info.LeftSoftKey = TxtSoftOK;//2004-04-16 Sunny add
	display_info.KeyEvents = KEY_RIGHT |KEY_LEFT|KEY_HUP|KEY_F4;
	display_info.TextId2   = TxtTimeup;
	display_info.Time       = 30*ONE_SECS;
	display_info.iconindex = REMIND_NORECORD;
	display_info.Callback     = (T_VOID_FUNC)timer_dialog_cb;

	setOuterState(OUTERIDLESTATE_ALERT,1,0);//2004-04-23 Sunny add
	/*
	* Call Info Screen
	*/
	info_dialog (0, &display_info);
	// info_timer_Hnd=tim_create(0, 1000, (T_MFW_CB)info_timer_tim_cb);
	// timStart(info_timer_Hnd);
}


T_MFW_CB timerEnd_tim_cb(T_MFW_EVENT event, T_MFW_TIM *tc)
{
	if(timer_counter<30)
		timer_counter++;
	else
	{
		Stopplayingdevice();
		timer_flag=FALSE;
		timer_status=TIMER_EDT;
	}
}

void timer_dialog_cb(T_MFW_HND win, USHORT event, UBYTE reason)
{   
	switch(reason)
	{
	case INFO_KCD_F4:
             /* 2004/07/09 sunsj add for forbidden hall off */
		//break;     	  
	default:
		//Stopplayingdevice();  xsf changed 12.31     	  	
		/* 2004/07/12 sunsj fix MI18800000460 if current win is change so we only need to destroy 
		   timer win */
		if(call_data.win_incoming||call_data.win_calling||call_win_flag)
		{
		}
		else
		{
		StopPlayByReasonId(ALARMPLAY);
		}
		timer_flag=FALSE;
		timer_status=TIMER_EDT;
		if(timer_win)
		{
			timerdestroy(timer_win);
		}     	  
		setOuterState(OUTERIDLESTATE_ALERT,0,0);//2004-04-23 Sunny add
		break;
	}
}

/* 2003.10.16 wyj ޸ģд鲿*/
static int timer_kbd_cb (MfwEvt e, MfwKbd *kc)
{
	T_MFW_HND win = mfw_parent(mfw_header());
	T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
	timer_data* data = (timer_data*)win_data->user; // tida main data
	T_DISPLAY_DATA display_info;
	int flag=1;
	int t;
	
	TRACE_EVENT("timer_kbd_cb");
	
	if(timer_status==TIMER_EDT)
	{
		TRACE_EVENT("timer_status==TIMER_EDT");
		switch(kc->code)
		{
		case KCD_0:
		case KCD_1:
		case KCD_2:
		case KCD_3:
		case KCD_4:
		case KCD_5:
		case KCD_6:
		case KCD_7:
		case KCD_8:
		case KCD_9:
			/* 2003.10.16 wyj ޸ģд鲿*/
			checkTimerNumInput(data, kc->code);
			timer_counter=chartoint((char*)data->timebuffer);
			winShow(win);
			
			break;
			
		case KCD_MNULEFT:
			/* 2003.10.16 wyj ޸ģд鲿*/
			checkTimerLeftInput(data);
			winShow(win);
			break;
			
		case KCD_MNURIGHT:
			/* 2003.10.16 wyj ޸ģд鲿*/
			checkTimerRightInput(data);
			winShow(win);
			break;
		case KCD_LEFT:                               /* select and ok button */
		case KCD_OK:
			TRACE_EVENT("timer:KCD_LEFT");
			if(((((int)data->timebuffer[0]-48)*10+((int)data->timebuffer[1]-48))>=24)||((((int)data->timebuffer[3]-48)*10+((int)data->timebuffer[4]-48))>59)
				||((((int)data->timebuffer[6]-48)*10+((int)data->timebuffer[7]-48))>59))
			{
				memset((char*)data->timebuffer,0,sizeof(data->timebuffer));
				sprintf(data->timebuffer,"00:00:00");
				data->index=0;
				dialog_info_init(&display_info);   		  
				display_info.TextId2     =TxtInputError;          
				display_info.Time       = FOREVER;
				display_info.iconindex = REMIND_NORECORD;
				
				display_info.Callback     = (T_VOID_FUNC)NULL;//timer_memo_dialog_cb;
															  /*
															  * Call Info Screen
				*/
				info_dialog(data->win, &display_info);
				break;	
			}	
			
			data->LeftKey=TRUE;
			strcpy(timer_string,data->timebuffer);
			timer_counter=chartoint((char*)data->timebuffer);
			timer_flag=TRUE;
			timer_status=TIMER_COUNT;
			iconsSetState(iconIdTimer);
			SEND_EVENT(win, timer_status, 0, 0);				
			break;
		case KCD_RIGHT:                                /* back to previous menu */
		case KCD_HUP:
			TRACE_EVENT("KCD_RIGHT");
			//tim_stop(timer_Hnd);
			//iconsDeleteState(iconIdTimer);
			//tim_delete(timer_Hnd);
			//timer_Hnd=NULL;
			timerdestroy(timer_win);
            break;			
		default:
			break;			
		}
		winShow(win);
	}
    else if(timer_status==TIMER_COUNT)
	{
		TRACE_EVENT("timer_status==TIMER_COUNT");
		switch(kc->code)
		{
		case KCD_LEFT: 
		case KCD_OK:
			TRACE_EVENT("KCD_LEFT");
			timer_counter=0;			
			if(timer_flag)
			{
				timer_flag=FALSE;
				tim_stop(timer_Hnd);
				//tim_delete(timer_Hnd);
				timer_start=FALSE;
				//timer_Hnd=NULL;
				iconsDeleteState(iconIdTimer);
			}
			dialog_info_init(&display_info);//gdy add  
			display_info.TextId = TxtTimer;
			display_info.TextId2     =TxtCancelled;
			display_info.TextId      = '\0';
			display_info.Time       = FOREVER;
			display_info.iconindex= REMIND_NORECORD;
			
			display_info.Callback     = (T_VOID_FUNC)NULL;//timer_memo_dialog_cb;
														  /*
														  * Call Info Screen
			*/
			info_dialog(data->win, &display_info);
			
			data->index=0;
			timer_flag=FALSE;
			timer_status=TIMER_EDT;
			SEND_EVENT(data->win, TIMER_EDT, 0, 0);
			//else
			//	{
			//	 timer_flag=TRUE;
			//	}
  		        //winShow(win);  		    
			break;
  		    case KCD_RIGHT:  
			case KCD_HUP:
				TRACE_EVENT("data->LeftKey=TRUE"); 
				//if(!timer_flag)
				//iconsDeleteState(iconIdTimer);
				//timer_status=TIMER_EDT;  		    	
				timerdestroy(timer_win);  			    
				break;
			default:
				break;
		}
		
	}    
    //
    return MFW_EVENT_CONSUMED;    
}


static int chartoint(char* str)
{
    int result=0,number=0;

    TRACE_EVENT("char to int");
    
/* get the number of seconds*/
    number=(int)str[1]-48+((int)str[0]-48)*10;
    result=result+number*3600;
    number=0;
    /*get the number of munites and turn it into seconds*/

     number=(int)str[4]-48+((int)str[3]-48)*10;
    result=result+number*60;
    number=0;
    /*get the number of hours and turn it into seconds*/

    number=(int)str[7]-48+((int)str[6]-48)*10;
    result=result+number;

    return result;
    
}

void timerdestroy (T_MFW_HND own_window)
{
	T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
	timer_data* data   = (timer_data*)win->user;
	
	TRACE_EVENT ("timerdestroy()");
	
	timer_win=NULL;
	if (own_window)
	{
    /*
	* Delete WIN Handler
		*/
		
		
		win_delete (own_window);
		/*
		* Free Memory
		*/
		FREE_MEMORY ((void *)data, sizeof (timer_data));
	}
}

/*void trace_timer()
{
  MfwTim *prev, *curr;
  int i=0;

  TRACE_EVENT("trace_timer");

  if (!timRoot)
    {       
       TraceInt(i);
       return;
    }  
  prev = timRoot;
  curr = timRoot->next;
  while (curr)
    {
        i++;
        prev = curr;
        curr = curr->next;
    }
  TraceInt(i);  
}*/


void drawSolidRectangle(int x1,int y1,int x2,int y2,int type,int fillcolor,int color)
{
	game_Line line;
	game_Rectangle rectangle;
	int old_color;
	
	if(type==1)
	{
		dspl_Clear(x1, y1, x2, y2);
		
		rectangle.x1=x1;
		rectangle.y1=y1;
		rectangle.x2=x2;
		rectangle.y2=y2;
		rectangle.fillcolor=fillcolor;
		rectangle.color=fillcolor;
		DrawRectagle(rectangle); 
		
		line.x1=x1;
		line.y1=y1;
		line.x2=x1;
		line.y2=y2;
		line.color=fillcolor;
		DrawLine(line);
		
		line.x1=x1;
		line.y1=y1-1;
		line.x2=x2;
		line.y2=y1-1;
		line.color=color;
		DrawLine(line);
		
		line.x1=x1-1;
		line.y1=y1;
		line.x2=x1-1;
		line.y2=y2;
		line.color=color;
		DrawLine(line);
		
		line.x1=x1;
		line.y1=y2+1;
		line.x2=x2;
		line.y2=y2+1;
		line.color=color;
		DrawLine(line);
		
		line.x1=x2+1;
		line.y1=y1;
		line.x2=x2+1;
		line.y2=y2;
		line.color=color;
		DrawLine(line);      
	}
	else if(type==0)
	{
		old_color=dspl_GetBkgColor();
		dspl_SetBkgColor(fillcolor);
		dspl_Clear(x1, y1, x2+1, y2+1);
		dspl_SetBkgColor(old_color);
		/*rectangle.x1=x1;
		rectangle.x2=x2;
		rectangle.y1=y1;
		rectangle.y2=y2;
		rectangle.color=0x0000ff;  	  
		rectangle.fillcolor=0x0000ff;
		DrawRectagle(rectangle);*/
		line.x1=x1+1;
		line.y1=y2+1;
		line.x2=x2;
		line.y2=y2+1;
		line.color=color;
		DrawLine(line); 
		line.x1=x2+1;
		line.y1=y1+1;
		line.x2=x2+1;
		line.y2=y2;
		line.color=color;
		DrawLine(line); 
	}
	else if(type==2)
	{
		old_color=dspl_GetBkgColor();
		dspl_SetBkgColor(fillcolor);//0x77ECB1
		dspl_Clear(x1, y1, x2+1, y2+1);
		dspl_SetBkgColor(old_color);
		line.x1=x1+1;
		line.y1=y2+1;
		line.x2=x2-1;
		line.y2=y2+1;
		line.color=color;//0x006400
		DrawLine(line); 
		line.x1=x2+1;
		line.y1=y1+1;
		line.x2=x2+1;
		line.y2=y2-1;
		line.color=color;
		DrawLine(line); 
	}
	else if(type==3)
	{
		rectangle.x1=x1;
		rectangle.y1=y1;
		rectangle.x2=x2;
		rectangle.y2=y2;
		rectangle.fillcolor=fillcolor;
		rectangle.color=fillcolor;
		DrawRectagle(rectangle);  
		line.x1=x1;
		line.y1=y1;
		line.x2=x1;
		line.y2=y2;
		line.color=color;
		DrawLine(line);
		line.x1=x1;
		line.y1=y1-1;
		line.x2=x2;
		line.y2=y1-1;
		line.color=color;
		DrawLine(line);
		line.x1=x1-1;
		line.y1=y1;
		line.x2=x1-1;
		line.y2=y2;
		line.color=color;
		DrawLine(line);  
		line.x1=x1;
		line.y1=y2+1;
		line.x2=x2;
		line.y2=y2+1;
		line.color=color;
		DrawLine(line);
		line.x1=x2+1;
		line.y1=y1;
		line.x2=x2+1;
		line.y2=y2;
		line.color=color;
		DrawLine(line);
	}
}
/**********************************************************************************
* Function Name         : checkTimerNumInput
* Function Description  : дʱʱõּʹܴ֮
*
* Parameters		    : timer_data *data        	     I/O
*						: U8 keynum						 I
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void	checkTimerNumInput(timer_data *data, U8 keynum)
{
	/* ӣ֤СʱûԽ */
	switch(data->index)
	{
	case 0:									//Сʱʮλ
		if(keynum > 2)
			return;

		//data->timer_dataʽhh:mm:ss
		data->timebuffer[data->index++] = '0' + keynum;
		break;

	case 1:									//Сʱλ
		if( (data->timebuffer[data->index-1]=='2') && (keynum>3) )
				return;
		
		data->timebuffer[data->index++] = '0' + keynum;
		data->index++;
		break;

	case 3:									//ʮλ
	case 6:									//ʮλ
		if(keynum > 5)
			return;
		data->timebuffer[data->index++] = '0' + keynum;
		break;

	case 4:									//Ӹλ
		data->timebuffer[data->index++] = '0' + keynum;
		data->index++;
		break;								

	case 7:									//Ӹλ
		data->timebuffer[data->index++] = '0' + keynum;
		data->index = 0;
		break;

	default:
		break;
	}
}

/**********************************************************************************
* Function Name         : checkTimerLeftInput
* Function Description  : дʱʱõĲ˵ʹܴ֮
*
* Parameters		    : timer_data *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.16
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/
static void	checkTimerLeftInput(timer_data *data)
{
int  h;

	/* Ҫ, */
	switch(data->index)						
	{
	case 1:
	case 4:
	case 7:
		data->index--;
		return;
	}
	
	/* Сʱ */
	h = (data->timebuffer[0]-48)*10 + (data->timebuffer[1]-48);
	if(h > 23)
		return;

	
	/*  */
	h = (data->timebuffer[3]-48)*10 + (data->timebuffer[4]-48);
	if(h>59)
		return;

	/*  */
	h = (data->timebuffer[6]-48)*10 + (data->timebuffer[7]-48);
	if(h>59)
		return;


	/* ȷ޸index */
	switch(data->index)
	{
	case 3:
	case 6:
		data->index -= 2;
		break;

	case 0:
		data->index = 7;
		break;

	default:
		break;
	}
}



/**********************************************************************************
* Function Name         : checkTimerRightInput
* Function Description  : дʱõĲ˵Ҽʹܴ֮
*
* Parameters		    : timer_data *data        	     I/O
*
* Return	            : void
*
* Author   Name         : Wu Yajun
* Date			        : 2002.10.14
* History:  Date        :
*           Author      :
*           Modify      : 
***********************************************************************************/

static void	checkTimerRightInput(timer_data *data)
{
int h;

	/* Ҫ, */
	switch(data->index)	
	{
	case 0:
	case 3:
	case 6:
		data->index++;
		return;
	}
	
	/* Сʱ */
	h = (data->timebuffer[0]-48)*10+ (data->timebuffer[1]-48);
	if(h > 23)
		return;

	
	/*  */
	h = (data->timebuffer[3]-48)*10 + (data->timebuffer[4]-48);
	if(h>59)
		return;

	/*  */
	h = (data->timebuffer[6]-48)*10 + (data->timebuffer[7]-48);
	if(h>59)
		return;
	
	/* ȷ޸index */
	switch(data->index)
	{
	case 1:
	case 4:
		data->index += 2;
		break;

	case 7:
		data->index = 0;
		break;

	default:
		break;
	}
}
