/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:                                                   
 $Project code:	                                                           
 $Module:		
 $File:		    AUIWap.h
 $Revision:		                                                      
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
                                                                               
********************************************************************************
                                                                              
 Description:
 	This file...
    
                        
********************************************************************************

 $History: AUIWap.h

	
	   
 $End

*******************************************************************************/



/*******************************************************************************

 $Function:    	AUI_menu

 $Description:	The main WAP menu
 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_menu(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_homepage

 $Description:	Entry point to the WAP browser, jumps to homepage
 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_homepage(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	MMI_AUI_goto_www

 $Description:	Opens up a text edit screen for entering URLs with "www." entered.
    	     
 $Returns:		none.

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_goto_www(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	MMI_AUI_goto_wap

 $Description:	Opens up a text edit screen for entering URLs with "wap." entered.
    	     
 $Returns:		none.

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_goto_wap(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	MMI_AUI_goto_other

 $Description:	Opens up a blank text edit screen for entering URLs
    	     
 $Returns:		none.

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_goto_other(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_add_www

 $Description:	Opens up a text edit screen for entering URLs with "www." entered.
    	     
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_bookmarks_add_www(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_add_wap

 $Description:	Opens up a text edit screen for entering URLs with "wap." entered.
    	     
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_bookmarks_add_wap(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_add_other

 $Description:	Opens up a blank text edit screen for entering URLs
    	     
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_bookmarks_add_other(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_list

 $Description:	List Bookmarks menu option
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_list(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_goto

 $Description:	Open up the selected bookmark in the WAP browser
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_goto(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_edit

 $Description:	Edit the name of the selected bookmark
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_edit(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_edit_url

 $Description:	Edit the URL of the selected bookmark
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_edit_url(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_delete

 $Description:	Delete the selected bookmark from the bookmarks list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_delete(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_bookmarks_sendSMS

 $Description:	Open up a bookmark in an SMS write editor
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_bookmarks_sendSMS(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_list

 $Description:	List History menu option
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

int AUI_history_list(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_goto

 $Description:	Open up the selected history entry in the WAP browser
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_goto(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_edit

 $Description:	Edit the name of the selected history entry
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_edit(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_edit_url

 $Description:	Edit the URL of the selected history entry
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_edit_url(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_delete

 $Description:	Delete the selected entry from the history list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_delete(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_clear

 $Description:	Deletes all entries in history list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_clear(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_addbook

 $Description:	Adds a history item to the bookmarks list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_addbook(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_history_sendSMS

 $Description:	Open up a history entry in an SMS write editor
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_history_sendSMS(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_profiles_list

 $Description:	Lists names of all profiles in flash
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_profiles_list(MfwMnu* menu, MfwMnuItem* item);

/*******************************************************************************

 $Function:    	AUI_profiles_setup

 $Description:	Lists names of all profiles in flash, for changing settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_profiles_setup(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_profile_name_edit

 $Description:	Opens up a text edit screen for editing the name of a profile
    	     
 $Returns:		none.

 $Arguments:	shortcut	- pointer to a string that will appear in the editor
 				identifier	- specifies what to do with the URL (connect, store etc).
 
*******************************************************************************/

int AUI_profile_name_edit(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	MMI_AUI_homepage_edit

 $Description:	Opens up a text edit screen for changing the homepage URL
    	     
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_homepage_edit(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_connectionType

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_connectionType(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_connectionType_set

 $Description:	Set WAP connection to temporary or permanent
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_connectionType_set(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_security

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_security(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_security_set

 $Description:	Switch security on or off
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_security_set(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_access

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_access(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_access_set

 $Description:	Set access type
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_access_set(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_dialupNumber

 $Description:	Opens up a numeric edit screen for editing the service number
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_dialupNumber(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_IPAddress1

 $Description:	Opens up a numeric edit screen for editing the primary IP address
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_IPAddress1(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_IPAddress2

 $Description:	Opens up a numeric edit screen for editing the secondary IP address
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_IPAddress2(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_Port1

 $Description:	Opens up a numeric edit screen for editing the primary port
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_Port1(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_Port2

 $Description:	Opens up a numeric edit screen for editing the secondary port
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_Port2(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_APN

 $Description:	Opens up a numeric edit screen for editing the APN
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_APN(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_username

 $Description:	Opens up a text edit screen for editing the ISP username
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_username(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_password

 $Description:	Opens up a text edit screen for editing the ISP password
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_password(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_response_timer

 $Description:	Opens up a numeric edit screen for editing the response timer
    	     
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
 				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_response_timer(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_savehist

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_savehist(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_savehist_set

 $Description:	Switch save history on or off
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_savehist_set(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_scaleimages

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_scaleimages(MfwMnu* menu, MfwMnuItem* item);


/*******************************************************************************

 $Function:    	AUI_scaleimages_set

 $Description:	Set image scaling on or off
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
 				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_scaleimages_set(MfwMnu* menu, MfwMnuItem* item);

/*******************************************************************************

 $Function:    	AUI_wap_launch_browser

 $Description:	Launches the browser to a given URL, bearer,etc
 
 $Returns:		TRUE-> succesfully launched, FALSE -> error

 $Arguments:	The URL and the bearer.
 
*******************************************************************************/

T_MFW_HND AUI_wap_launch_browser(char *URL,UBYTE* bearer_list,UBYTE bearer_list_len);


/*******************************************************************************

 $Function:    	AUI_wap_extDestroy

 $Description:	Allows external files to destroy the WAP application
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void AUI_wap_extDestroy(void);
/*******************************************************************************

 $Function:    	AUI_wap_GPRS_status

 $Description:	Called when GPRS state changes.  If WAP is active, updates status.
 				SPR#1574 - SH - Added this function
 
 $Returns:		None.

 $Arguments:	
 
*******************************************************************************/

void AUI_wap_gprs_status(UBYTE status);
/*******************************************************************************

 $Function:    	AUI_wap_call_disconnect

 $Description:	SPR#1656 - SH - Added this function
 				Called when a CSD call is terminated - informs WAP of this.
 
 $Returns:		None.

 $Arguments:	
 
*******************************************************************************/

void AUI_wap_call_disconnect(void);

/*******************************************************************************

 $Function:    	AUI_end_call

 $Description:	SPR#1575 - SH - Determine whether call is CSD or GPRS,
 				and attempt to end it.
 
 $Returns:		None.

 $Arguments:	
 
*******************************************************************************/

void AUI_end_call(void);
