/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Idle
 $File:		    Fieldtest.c 
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

   Handling for the idle screen
                        
********************************************************************************
 $History: Fieldtest.c

    25/10/00			Original Condat(UK) BMI version.	
       
 $End

*******************************************************************************/
/********************************************************************************
 $History: Fieldtest.c  ver2.69
    date         version     comment
    02/09/02     0.10       change the gblink timer to 3seconds, and do not set timer frequentyl ganchh

    21/06/02			zy for forbid update idlewin when the focused win is not focused
                        in idle
    04/08/02            zy change the idle display arrangement
                        and the softkey and relative fuction
    09/08         windy modified
    15/08/02        xsf modified for switch scene mode in idle window
  26/08/02		hxl add for charger
  29/08/02		hxl changed for charger
   18/09/02            xsf add codes for missedcallTone and unreadSMSTone timer 
 $End

*******************************************************************************/
/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/



#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
//#include <stdio.h>
//#include <string.h>

//#include "mfw_sys.h"

//#include "stddefs.h"
//#include "custom.h"
//#include "gsm.h"
//#include "vsi.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_cm.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"

//#include "spi_drv.h"	//add for hardware status

#include "dspl.h"
#include "MmiMmi.h"

#include "ksd.h"
#include "psa.h"


#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMain.h"
#include "MmiStart.h"

#include "MmiMenu.h"

#include "MmiBookController.h"
#include "MmiBookUtils.h"

#include "MmiCall.h"
#include "MmiNetwork.h"
#include "MmiIcons.h"
#include "MmiEditor.h"


#include "MmiSounds.h"
#include "MmiUserData.h"
#include "MmiSoftKeys.h"
#include "MmiPins.h"

#include "MmiDialogs.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSettings.h"
#include "MmiSmsIdle.h"
#include "mfw_ffs.h"
#include "MmiSmsBroadcast.h"
#include "MmiCPHS.h"
#ifdef MMI_HOMEZONE_ENABLED
    #include "MmiHomezone.h"	/* SPR759 - SH*/
#endif
#include "gdi.h"
#include "audio.h"
#include "GameDisplay.h"//zy add 09/18

#include "cus_aci.h"
#include "p_sim.h"
//GW-Remove? #include "pcm.h"
#include "pwr.h" //hxl add for charger
#include "mmicharging.h"
#include "mmiservices.h" //wufei add 
#include "fieldtest.h"
#include "mmibookshared.h"
//#include "bmieastapi.h"/*2003/12/16, wangyan delete*/
//#include "pwr_disch.h"
#include "mmiiconresource.h"    /* 2004/06 sunsj modify for icon manage */

#undef JVJ_USSD_TEST
/* Extern Function declare-----------------------*/
#define SiteOfCheckSumPin     10
extern MfwHnd call_get_window(void);
extern int idleIsFocussed(void);
extern USHORT GetIO12StatusforMode(void);

/* 2004/06 sunsj modify for icon manage */
//extern const unsigned char iconMainIdle12[];

#ifndef _INNOVATION_EMULATOR_
extern char *date;
#endif

typedef          long  WORD32;

ModeCheck_Parameter  ResetRelatedPara;
typedef struct
{
    /* administrative data */

    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
    T_EDITOR_DATA     editor_data;
    T_MFW_HND         kbd;
    T_MFW_HND         editor_handle;

    /* internal data */
    char        buffer[100];
    UBYTE       status;

    USHORT      position;
} tSpecialMode;

/* 2004/05/21 sunsj add */
typedef struct
{
	T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       factory_win;
    T_MFW_HND       factory_kbd;
	T_MFW_HND		factory_tim;
}FACTORY_TEST_DATA;

#define CIRCLE_FACTORY_TIMES	800
static circle_times = 0;

/*const char * date = "2003.05.16";
const char * ver  = "Ver2.69";
const char * label = "Coordinate_gdy_0516";
const char * purpose    = "Baseline 1.0 1336s108533p6tiberlin";*//*2003/12/1, wangyan modify*/

#ifdef _INNOVATION_EMULATOR_
char * date = "2004.04.21";
#endif

/* 2004/06/30 sunsj modify */
#ifdef _E501_
char * ver  = "E501 1.0.11";
#endif

#ifdef _E505111315_
char * ver  = "E505 1.0.8";
#endif

#ifdef _E50602_
char * ver  = "E506 1.0.8";
#endif

#if defined(_E508_) && defined(_ENCRYPT_)
char * ver  = "E508+ 1.0.8";
#elif defined(_E508_) 
char * ver  = "E508 1.0.8";
#endif

#if defined(_E510_) && defined(_ENCRYPT_) 
char * ver  = "E510+ 1.0.8";
#elif defined(_E510_)
char * ver  = "E510 1.0.8";
#endif

#if  defined(_E512_) && defined(_ENCRYPT_)
char * ver  = "E512+ 1.0.8";
#elif defined(_E512_)
char * ver  = "E512+ 1.0.8";
#endif

#if defined(_E330_)&& defined(_ENCRYPT_)
char * ver  = "E330+ 1.0.8";
#elif defined (_E330_)
char * ver  = "E330+ 1.0.8";
#endif


extern FieldTest    FFS_FieldTest;

//extern FlashData               FFS_flashData;
//extern TffsfileCmd			  ffsfileCmd;
USHORT *RAMValue;   //ram value;


static T_MFW_HND show_timer;         //the timer for show_rssi
static unsigned char refresh_flag;      //the flag for need refresh or not
unsigned char ucNumberOfAbnormal=0;  //ganchh 2003/3/21 for the number of total abnormal number
static unsigned char PhoneIsReseted=0;         //ganchh 2003/3/21 for the Flag of RESET

extern int ffs_status;      //Bob added 02/17	
extern UINT32  *OriginLCDData; //modified by ljq from 9760 to R2D_MWWIDTH*R2D_HEIGHT 2003/4/10

extern UBYTE globalSignalPicNumber;

UBYTE   currentsignalvalue,lastsignalvalue=0;       //xzy add for signal pic number update;

/* 2004/04/01 sunsj add for count key press number */
static int keyPressNumber = 0;

static T_MFW_HND ShowVersion_create(MfwHnd parent_window);
static void ShowVersion_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier, void *parameter);
void ShowVersionSetEditor(T_MFW_HND win);
static void ShowVerionCB (MfwEvt e, MfwKbd *k);
void showVersion_destroy(MfwHnd own_window);

//begin of xzy add for test special mode 2002/12/30
static T_MFW_HND LayeronePara_create(MfwHnd parent_window);
static void LayeronePara_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
//void LayeroneParaSetEditor(T_MFW_HND win);
//static void LayeroneParaCB( T_MFW_HND win, USHORT Identifier,UBYTE reason);
//static int  LayeronePara_winCB (T_MFW_EVENT event, T_MFW_WIN * win);
static int LayeronePara_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
static T_MFW_CB showRssi_timercb (T_MFW_EVENT event, T_MFW_TIM *tc);
void LayeronePara_destroy(MfwHnd own_window);
extern void layer1_em_get_rxlevqual(WORD32 *l1_rxlev_scell,WORD32 *l1_rxlev_dedic_sub,WORD32 *l1_rxqual_dedic,WORD32 *l1_rxqual_dedic_sub); //xzy add for test mode 2002/12/30
extern void layer1_em_get_mode(WORD32 *l1_mode);
static T_MFW_HND LayeroneParaTwo_create(MfwHnd parent_window);
static void LayeroneParaTwo_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
static void LayeroneParaTwoCB (MfwEvt e, MfwKbd *k);
void LayeroneParaTwo_destroy(MfwHnd own_window);
//end of xzy add for test special mode 2002/12/30

static T_MFW_HND LayeroneParaThree_create(MfwHnd parent_window);
static void LayeroneParaThree_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
static void LayeroneParaThreeCB (MfwEvt e, MfwKbd *k);
void LayeroneParaThree_destroy(MfwHnd own_window);



static T_MFW_HND TestCommand_create(MfwHnd parent_window);

static void TestCommand_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                 void *parameter);

void TestCommandSetEditor(T_MFW_HND win);
//static int TestCommand_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
static void TestCommandCB( T_MFW_HND win, USHORT Identifier,UBYTE reason);
void TestCommand_destroy(MfwHnd own_window);
static T_MFW_HND SpkMic_create(MfwHnd parent_window);
static void SpkMic_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
static void SpkMicCB (MfwEvt e, MfwKbd *k);
void SpkMic_destroy(MfwHnd own_window);

static T_MFW_HND MemFlashRtc_create(MfwHnd parent_window);
static void MemFlashRtc_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
static void MemFlashRtcCB (MfwEvt e, MfwKbd *k);
void MemFlashRtc_destroy(MfwHnd own_window);

static T_MFW_HND KeyPressTest_create(MfwHnd parent_window);
static int  KeyPressTest_WinCB (T_MFW_EVENT event, T_MFW_WIN * win);
static void KeyPressTest_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
static int KeyPressTest_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
void KeyPressTest_destroy(MfwHnd own_window);
void WriteLcdColor(unsigned short color);
void ShowVersiondialog(T_MFW_HND win);/*2004/05/10, wangyan add*/
//begin xzy add for special test mode 2002/12/30;

/* 2004/05/21 sunsj add */
static T_MFW_HND  circle_factoryTest_create        (T_MFW_HND  parent_win);
static void       circle_factoryTest_exec_cb       (T_MFW_HND  win, USHORT event, SHORT value, int parameter);
static int        circle_factoryTest_win_cb        (T_MFW_EVENT event, T_MFW_WIN * win);
static int        circle_factoryTest_kbd_cb        (T_MFW_EVENT event, T_MFW_KBD * keyboard);
static int        circle_factoryTest_tim_cb        (T_MFW_EVENT event, T_MFW_TIM *tc);

/*******************************************************************************

 $Function:    	showVersion

 $Description:	Displays the version of software and date
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
int ShowVersion(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = ShowVersion_create(parent_window);
    TRACE_FUNCTION("ShowVerion()");
#ifdef _DAIENABLE_
    DAIsignalEnable();  //enable the DAI
#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, SHOWVERSION_INIT, 0, 0);
    }

    return 0;
}

/*******************************************************************************

 $Function:    	ShowVersion_create

 $Description:	creates the window
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static T_MFW_HND ShowVersion_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)ShowVersion_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)ShowVerionCB);
    return data->win;
}


/*******************************************************************************

 $Function:    	showVersion_DialogCB

 $Description:	CallBack Function
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void ShowVersion_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                 void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    T_DISPLAY_DATA display_info;

    char   ffsstatus[20]="";


    TRACE_FUNCTION("ShowVersion_DialogCB()");

    switch( e )
    {
    case SHOWVERSION_INIT:
        {   
            /*		dspl_ClearAll();
                    strcat(data->buffer, ver);
                    strcat(data->buffer,"\n");
                    strcat(data->buffer, label);
                    strcat(data->buffer,"\n");
                    strcat(data->buffer,date);
                    strcat(data->buffer,"\n");
                    strcat(data->buffer, purpose);
            
                    Sprintf(ffsstatus,"\nffs status: %d\n",ffs_status);	
                    strcat(data->buffer,ffsstatus);
                            dspl_TextOut(0,TOP_POSITION+26,DSPL_TXTATTR_TRANSPARENT,data->buffer);*/
            dialog_info_init(&display_info);//gdy add    	
            display_info.KeyEvents    = KEY_CLEAR;
            display_info.TextId       = 0;
            display_info.TextId2      = 0;
            display_info.TextString   = ver;
            display_info.TextString2  = date;
            display_info.LeftSoftKey  = TxtNull;
            display_info.RightSoftKey = TxtSoftBack;
            display_info.Time         =ONE_SECS;//
            display_info.Callback     = NULL;
            display_info.iconindex=REMIND_REQUIRE;
            info_dialog( win, &display_info );

        }
        break;

    default:
        {
            TRACE_EVENT("ShowVersion_DialogCB(): Unknown Event");
        }
        break;

    }

}
#if 0
/*******************************************************************************

 $Function:    	ShowVersionSetEditor

 $Description:	Set the editor up
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void ShowVersionSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;

    editor_attr_init(&((data->editor_data).editor_attr), NULL, edtCurNone, 0, 0, 0);
    data->editor_data.editor_attr.win.py=16;     //ganchh 2002/8/27 set editor area
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings


    data->editor_data.Identifier        =  0; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = TRUE; 
    data->editor_data.editor_attr.text  = (char *)data->buffer; 
    data->editor_data.editor_attr.size  = 35; 
    data->editor_data.TextId               = '\0';                                                
    data->editor_data.LeftSoftKey       = TxtSoftBack;
    data->editor_data.AlternateLeftSoftKey   = TxtNull;
    data->editor_data.RightSoftKey      = TxtNull;
    data->editor_data.mode              = READ_ONLY_MODE;
}

#endif
/*******************************************************************************

 $Function:    	ShowVerionCB

 $Description:	Callback
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void ShowVerionCB (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   


    TRACE_FUNCTION("ShowVerionCB()");


    showVersion_destroy(data->win); //ganchh modified

}

/*******************************************************************************

 $Function:    	showVersion_destroy

 $Description:	Destroys the editor
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void showVersion_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )



        win_data = ((T_MFW_HDR *)own_window)->data;
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("showVersion_destroy()");

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));

    }
    else
    {
        TRACE_EVENT ("showVersion_destroy() called twice");
    }
}

int LayeronePara(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = LayeronePara_create(parent_window);
    TRACE_FUNCTION("LayeronePara()");
    //#ifdef _DAIENABLE_
    //  DAIsignalEnable();  //enable the DAI
    //#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, LAYERONEPARA_INIT, 0, 0);
    }

    return 0;
}

static T_MFW_HND LayeronePara_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)LayeronePara_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;

    //if(!show_timer)
    //	show_timer=timCreate(data->win,2000,(MfwCb)showRssi_timercb);
    //timStart(show_timer);
    return data->win;
}



static void LayeronePara_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                  void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    T_EDITOR_DATA       editor_data;
    WORD32 a,b,c,d,f;

    TRACE_FUNCTION("LayeronePara_DialogCB()");

    if( !show_timer )
    {
        show_timer=timCreate(data->win,2000,(MfwCb)showRssi_timercb);
        timStart(show_timer);
    }

    switch( e )
    {  //when window first created
    case LAYERONEPARA_INIT:
        {   

            /* 2004/03/02 sunsj modify for lcd display area */
            layer1_em_get_rxlevqual(&a,&b,&c,&d);
            layer1_em_get_mode(&f);


            dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);

            sprintf(data->buffer,"lev_scell\n%d\n",a/2);
            dspl_TextOut(0, 0, 0, (char*)data->buffer);

            sprintf(data->buffer,"lev_dedic_sub\n%d\n",b);
            dspl_TextOut(0, 14, 0, (char*)data->buffer);

            sprintf(data->buffer,"qual_dedic\n%d\n",c);
            dspl_TextOut(0, 28, 0, (char*)data->buffer);

            sprintf(data->buffer,"qual_dedic_sub\n%d\n",d);
            dspl_TextOut(0, 42, 0, (char*)data->buffer);

            sprintf(data->buffer,"mode:%d",f);
            dspl_TextOut(0, 66, 0, (char*)data->buffer);

            data->kbd=kbd_create(data->win,KEY_ALL,(T_MFW_CB)LayeronePara_kbd_cb);

        }
        break;
    case LAYERONEPARA_UPDATA:
        {
            if( !winIsFocussed(win) )
            {
                LayeronePara_destroy(win);
                //StopVmRecord(VmRecordCB);
                //needback=1;
                return;
            }


            layer1_em_get_rxlevqual(&a,&b,&c,&d);
            layer1_em_get_mode(&f);

            /* 2004/03/02 sunsj modify for lcd display area */
            dspl_Clear(0, 0, SCREEN_SIZE_X, 14);
            sprintf(data->buffer,"%d",a/2);
            dspl_TextOut(0, 0, 0, (char*)data->buffer);

            dspl_Clear(0, 14, SCREEN_SIZE_X, 28);
            sprintf(data->buffer,"%d",b);
            dspl_TextOut(0, 14, 0, (char*)data->buffer);

            dspl_Clear(0, 28, SCREEN_SIZE_X, 42);
            sprintf(data->buffer,"%d",c);
            dspl_TextOut(0, 28, 0, (char*)data->buffer);

            dspl_Clear(0, 42, SCREEN_SIZE_X, 66);
            sprintf(data->buffer,"%d",d);
            dspl_TextOut(0, 42, 0, (char*)data->buffer);

            dspl_Clear(0, 66, SCREEN_SIZE_X, 80);
            sprintf(data->buffer,"mode:%d",f);
            dspl_TextOut(0, 66, 0, (char*)data->buffer);

            timStart(show_timer);


        }
        break;
    case LAYERONEPARA_EXIT:
        {
            LayeronePara_destroy(win);
            break;

        }
    default:
        {
            TRACE_EVENT("LayeronePara_DialogCB(): Unknown Event");
        }
        break;

    }

}
#if 0

static int  LayeronePara_winCB (T_MFW_EVENT event, T_MFW_WIN * win)
{
    tSpecialMode* data = (tSpecialMode *)win->user;    
    int i;

    TRACE_EVENT ("iconselect_win_cb");


    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {

        }
    }
}
void LayeroneParaSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;

    editor_attr_init(&((data->editor_data).editor_attr), NULL, edtCurNone, 0, 0, 0);
    data->editor_data.editor_attr.win.py=16;     //ganchh 2002/8/27 set editor area
    data->editor_data.hide              = FALSE;
    data->editor_data.min_enter         = 1;  // Avoid returning empty strings


    data->editor_data.Identifier        =  0; 
    data->editor_data.TextString        = NULL;  
    data->editor_data.timeout           = FOREVER;  // Avoid returning empty strings
    data->editor_data.destroyEditor     = TRUE; 
    data->editor_data.editor_attr.text  = (char *)data->buffer; 
    data->editor_data.editor_attr.size  = 35; 
    data->editor_data.TextId               = '\0';                                                
    data->editor_data.LeftSoftKey       = TxtSoftBack;
    data->editor_data.AlternateLeftSoftKey   = TxtNull;
    data->editor_data.RightSoftKey      = TxtNull;
    data->editor_data.mode              = READ_ONLY_MODE;
}
static void LayeroneParaCB( T_MFW_HND win, USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   


    TRACE_FUNCTION("LayeroneParaCB()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CALL:  //xsf add 12.13
        LayeronePara_destroy(data->win); //ganchh modified
        break;
    default:

        break;
    }
}
#endif
void LayeronePara_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )



        win_data = ((T_MFW_HDR *)own_window)->data;
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("LayeronePara_destroy()");

        timDelete(show_timer);
        show_timer=0;

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));

    }
    else
    {
        TRACE_EVENT ("LayeronePara_destroy() called twice");
    }
}

static T_MFW_CB showRssi_timercb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );

    timStop(show_timer);
    refresh_flag=1;
    TRACE_EVENT("new we show the Rssi");

    SEND_EVENT (parent_window, LAYERONEPARA_UPDATA, 0, 0);

    return 0;
}

static int LayeronePara_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());

    switch( keyboard->code )
    {
    case KCD_RIGHT:
    case KCD_HUP:
        LayeronePara_destroy(win);
        break;
    }

    return MFW_EVENT_CONSUMED;

}
//end of xzy add for special test mode 2002/12/30;

int LayeroneParaTwoStart(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = LayeroneParaTwo_create(parent_window);
    TRACE_FUNCTION("LayeroneParaTwoStart()");
    //#ifdef _DAIENABLE_
    //  DAIsignalEnable();  //enable the DAI
    //#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, LAYERONEPARATWO_INIT, 0, 0);
    }

    return 0;
}


static T_MFW_HND LayeroneParaTwo_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)LayeroneParaTwo_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)LayeroneParaTwoCB);
    return data->win;
}


/*******************************************************************************

 $Function:    	LayeroneParaTwo_DialogCB

 $Description:	CallBack Function
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void LayeroneParaTwo_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                     void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    //int WDTcounter,SWRcounter,HWRcounter;
    int redLED,greenLED,backlightLED,LCD,vibrator,MIC,Speaker;
    U16 voltage;

    TRACE_FUNCTION("LayeroneParaTwo_DialogCB()");

    switch( e )
    {  //when window first created
    case LAYERONEPARATWO_INIT:
        {   
            dspl_ClearAll();

            //redLED=Red_Status();
            greenLED=Green_Status();
            backlightLED=Backlight_Status();
            //LCD=LCD_Status();
            //vibrator=Vibrator_Status();
            
            #ifdef _M188_
            voltage=GetBatteryVoltageBySpi();
            #else
            voltage=1;
            #endif			

            /* 2004/03/02 sunsj modify for display area */
            //sprintf(data->buffer,"redLED:%d",redLED);
            //dspl_TextOut(0, 0, 0, (char*)data->buffer);

            sprintf(data->buffer,"greenLED:%d",greenLED);
            dspl_TextOut(0, 13, 0, (char*)data->buffer);

            sprintf(data->buffer,"backlightLED:%d",backlightLED);
            dspl_TextOut(0, 26, 0, (char*)data->buffer);

            //sprintf(data->buffer,"LCD:%d",LCD);
            //dspl_TextOut(0, 39, 0, (char*)data->buffer);

            //sprintf(data->buffer,"vibrator:%d",vibrator);
            //dspl_TextOut(0, 52, 0, (char*)data->buffer);

            //sprintf(data->buffer,"voltage:%d",voltage);
            //dspl_TextOut(0, 65, 0, (char*)data->buffer);
            
            sprintf(data->buffer,"voltage:%d",voltage);
            dspl_TextOut(0, 39, 0, (char*)data->buffer);
        }
        break;

    default:
        {
            TRACE_EVENT("LayeroneParaTwo_DialogCB(): Unknown Event");
        }
        break;

    }

}

static void LayeroneParaTwoCB (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   


    TRACE_FUNCTION("ShowVerionCB()");


    LayeroneParaTwo_destroy(data->win); //ganchh modified

}

/*******************************************************************************

 $Function:    	LayeroneParaTwo_destroy

 $Description:	Destroys the dialog
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void LayeroneParaTwo_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )



        win_data = ((T_MFW_HDR *)own_window)->data;
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("LayeroneParaTwo_destroy()");

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));

    }
    else
    {
        TRACE_EVENT ("LayeroneParaTwo_destroy() called twice");
    }
}

int LayeroneParaThreeStart(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = LayeroneParaThree_create(parent_window);
    TRACE_FUNCTION("LayeroneParaThreeStart()");
    //#ifdef _DAIENABLE_
    //  DAIsignalEnable();  //enable the DAI
    //#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, LAYERONEPARATHREE_INIT, 0, 0);
    }

    return 0;


}



static T_MFW_HND LayeroneParaThree_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)LayeroneParaThree_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)LayeroneParaThreeCB);
    return data->win;
}


/*******************************************************************************

 $Function:    	LayeroneParaTwo_DialogCB

 $Description:	CallBack Function
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void LayeroneParaThree_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                       void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    int WDTcounter,SWRcounter,HWRcounter;
    char reason[20];

    TRACE_FUNCTION("LayeroneParaThree_DialogCB()");

    switch( e )
    {  //when window first created
    case LAYERONEPARATWO_INIT:
        {   
            dspl_ClearAll();
            //dspl_Clear(0, 0, 120, 160);
            WDTcounter=FFS_FieldTest.WDTCounter;
            SWRcounter=FFS_FieldTest.SoftWareResetCounter;
            HWRcounter=FFS_FieldTest.HardWareResetCounter;
            strcpy(reason,FFS_FieldTest.ResetReason);

            /*
            sprintf(data->buffer,"sleep-mode:\n%d\n",a/2);
            dspl_TextOut(0, 0, 0, (char*)data->buffer);
            
            sprintf(data->buffer,"batt-abc:%d\n",b);
            dspl_TextOut(0, 16, 0, (char*)data->buffer);
            */
            /* 2004/03/02 sunsj modify for display area */
            sprintf(data->buffer,"WDT counter:%d\n",WDTcounter);
            dspl_TextOut(0, 13, 0, (char*)data->buffer);

            sprintf(data->buffer,"SWR counter:%d\n",SWRcounter);    //SWR softeare reset
            dspl_TextOut(0, 26, 0, (char*)data->buffer);

            sprintf(data->buffer,"HWR counter:%d",HWRcounter);
            dspl_TextOut(0, 39, 0, (char*)data->buffer);

            sprintf(data->buffer,"reason:%s",reason);
            dspl_TextOut(0, 52, 0, (char*)data->buffer);


        }
        break;

    default:
        {
            TRACE_EVENT("LayeroneParaThree_DialogCB(): Unknown Event");
        }
        break;

    }

}

static void LayeroneParaThreeCB (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   


    TRACE_FUNCTION("LayeroneParaThreeCB()");


    LayeroneParaThree_destroy(data->win); //ganchh modified

}

/*******************************************************************************

 $Function:    	LayeroneParaThree_destroy

 $Description:	Destroys the dialog
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void LayeroneParaThree_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )



        win_data = ((T_MFW_HDR *)own_window)->data;
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("LayeroneParaThree_destroy()");

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));

    }
    else
    {
        TRACE_EVENT ("LayeroneParaThree_destroy() called twice");
    }
}

void FieldTestInit()
{
    TRACE_EVENT("FieldTestInit");
    memset(&ResetRelatedPara,0,sizeof(ModeCheck_Parameter)); //ganchh, reset all the value
    //begin xzy add for WDTCounter 0123;
    flash_FTread();
    RAMValue=(USHORT *)RAMDeafultAdress;
    //*RAMValue=RAMDeafultValue1;
    //memset((void *)0x7FFFD,RAMDeafultValue1,1);
#if 0
    sprintf(temp,"xzy,WDTValue:%d\n",FFS_FieldTest.WDTValue);
    MmiTrace(temp);

    sprintf(temp,"xzy,WDTCounter:%d\n",FFS_FieldTest.WDTCounter);
    MmiTrace(temp);

    sprintf(temp,"xzy,SoftWareResetCounter:%d\n",FFS_FieldTest.SoftWareResetCounter);
    MmiTrace(temp);

    sprintf(temp,"xzy,HardWareResetCounter:%d\n",FFS_FieldTest.HardWareResetCounter);
    MmiTrace(temp);

    sprintf(temp,"xzy,RAMValue:%d\n",(*RAMValue));
    MmiTrace(temp);
#endif
    if( FFS_FieldTest.WDTValue!=WDTDeafultValue2 )
    {
        FFS_FieldTest.WDTCounter++;


        if( (*RAMValue)==RAMDeafultValue1 )
        {
            ResetRelatedPara.PhoneIsResetedFlag=1;
            FFS_FieldTest.SoftWareResetCounter++;
            strcpy(FFS_FieldTest.ResetReason,"SoftWare Reset");
        }
        else
        {
            FFS_FieldTest.HardWareResetCounter++;
            strcpy(FFS_FieldTest.ResetReason,"LostPower Reset");
        }

    }
    else
    {
        if( FFS_FieldTest.LowVoltageValue==LowVoltageDeafultValue2 )
        {
            strcpy(FFS_FieldTest.ResetReason,"Low Voltage shutdown");
        }
        else
        {
            strcpy(FFS_FieldTest.ResetReason,"Normal shutdown");
        }
    }

    FFS_FieldTest.WDTValue=WDTDeafultValue1;
    flash_FTwrite();

    //TRACE_EVENT("SetRamValue");
    //*((USHORT *)RAMDeafultAdress)=(USHORT)RAMDeafultValue1;    //ganchunhui move to after begin to login the network
#if 0
    MmiTrace("read value");
    sprintf(temp,"xzy,RAMValue:%d\n",(*RAMValue));
    MmiTrace(temp);

    sprintf(temp,"xzy,WDTCounter:%d\n",FFS_FieldTest.WDTCounter);
    MmiTrace(temp);
#endif

}

void FieldTestExit()
{
    //begin xzy add for WDTCounter 0123;
    FFS_FieldTest.WDTValue=WDTDeafultValue2;
    //memset((void *)0x7FFFD,RAMDeafultValue1,1);

    //*RAMValue=RAMDeafultValue2;
#if 0
    sprintf(temp,"xzy,WDTValue%d\n",FFS_FieldTest.WDTValue);
    MmiTrace(temp);

    sprintf(temp,"xzy,RAMValue%d\n",(*RAMValue));
    MmiTrace(temp);
#endif
    flash_FTwrite();
    //end xzy add for WDTCounter 0123;

}

void FieldTestLowPowerExit()
{
    TRACE_EVENT("LowPowerExit");

    //begin xzy add for WDTCounter 0123;
    FFS_FieldTest.WDTValue=WDTDeafultValue2;
    FFS_FieldTest.LowVoltageValue=LowVoltageDeafultValue2;
    //memset((void *)0x7FFFD,RAMDeafultValue1,1);

    //*RAMValue=RAMDeafultValue2;

#if 0
    sprintf(temp,"xzy,WDTValue%d\n",FFS_FieldTest.WDTValue);
    MmiTrace(temp);

    sprintf(temp,"xzy,RAMValue%d\n",(*RAMValue));
    MmiTrace(temp);
#endif
    flash_FTwrite();
    //end xzy add for WDTCounter 0123;

}

#if 0
void SetRamValue()
{
    TRACE_EVENT("SetRamValue");
    *((USHORT *)RAMDeafultAdress)=RAMDeafultValue1;
    sprintf(temp,"xzy,RAMValue:%d\n",(*((USHORT *)RAMDeafultAdress)));
    MmiTrace(temp);

}

USHORT ReadRamValue()
{
    return(*RAMValue);
}

#endif
//begin xzy added 0126 for test command
int TestCommand(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = TestCommand_create(parent_window);
    TRACE_FUNCTION("TestCommand()");

    if( win NEQ NULL )
    {
        SEND_EVENT (win, TESTCOMMAND_INIT, 0, 0);
    }

    return 0;

}

static T_MFW_HND TestCommand_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)TestCommand_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    //data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)TestCommandCB);
    //if(!show_timer)
    //	show_timer=timCreate(data->win,2000,(MfwCb)showRssi_timercb);
    //timStart(show_timer);
    return data->win;
}

static void TestCommand_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                 void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    T_EDITOR_DATA       editor_data;


    TRACE_FUNCTION("TestCommand_DialogCB()");

    switch( e )
    {  //when window first created
    case TESTCOMMAND_INIT:
        {   

            TestCommandSetEditor(win);//set editor with default attribute values
            //data->editor_data.Callback     		= (T_EDIT_CB)TestCommandCB;
            data->editor_handle=editor_start(win, &(data->editor_data));  /* start the editor */ 

            //data->kbd=kbd_create(data->win,KEY_ALL,(T_MFW_CB)TestCommand_kbd_cb);


            winShow(data->win);

        }
        break;

    default:
        {
            TRACE_EVENT("TestCommand_DialogCB(): Unknown Event");
        }
        break;

    }

}

/*******************************************************************************

 $Function:    	TestCommandSetEditor

 $Description:	Set the editor up
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void TestCommandSetEditor(T_MFW_HND win)
{
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;

    editor_attr_init_fullscr(&data->editor_data.editor_attr,1,TxtTestCommand,NULL,PHB_name_len+3,edtCurBar1);  
    data->editor_data.hide            = FALSE;
    data->editor_data.min_enter       = 0;
    data->editor_data.Identifier        = 0xFFFF;
    data->editor_data.timeout         = FOREVER;
    data->editor_data.destroyEditor     = FALSE;//TRUE
    data->editor_data.editor_attr.text   = (char *)data->buffer;
    data->editor_data.TextId          = TxtTestCommand;
    data->editor_data.LeftSoftKey      = TxtSoftOK;
    data->editor_data.RightSoftKey     = TxtDelete;
    data->editor_data.mode           = 15;              //PHONENUMONLY_MODE
    data->editor_data.Callback        = (T_EDIT_CB)TestCommandCB;                       
}


/*******************************************************************************

 $Function:    	TestCommandCB

 $Description:	Callback
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void TestCommandCB( T_MFW_HND win, USHORT Identifier,UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   
    int flashupdata=0;

    TRACE_FUNCTION("TestCommandCB()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            if( !strcmp(((char *)data->buffer),"100000") )
            {
                FFS_FieldTest.WDTCounter=0;
                FFS_FieldTest.SoftWareResetCounter=0;
                FFS_FieldTest.HardWareResetCounter=0;
                flashupdata=1;
            }

            if( !strcmp(((char *)data->buffer),"100101") )
            {
				/* 2004/03/15 sunsj remove */
                //Red_On();
            }
            if( !strcmp(((char *)data->buffer),"100100") )
            {
				/* 2004/03/15 sunsj remove */
                //Red_Off();
            }
            if( !strcmp(((char *)data->buffer),"100201") )
            {
                Green_On();
            }
            if( !strcmp(((char *)data->buffer),"100200") )
            {
                Green_Off();
            }

            if( !strcmp(((char *)data->buffer),"100301") )
            {
                Backlight_ON();
            }

            if( !strcmp(((char *)data->buffer),"100300") )
            {
                Backlight_OFF();
            }

            if( !strcmp(((char *)data->buffer),"100401") )
            {
                LCD_ON();
            }

            if( !strcmp(((char *)data->buffer),"100400") )
            {
                LCD_OFF();
            }
            if( !strcmp(((char *)data->buffer),"100501") )
            {
                Vibrator_on();
            }

            if( !strcmp(((char *)data->buffer),"100500") )
            {
                Vibrator_off();
            }

            if( !strcmp(((char *)data->buffer),"100601") )
            {
                Mic_on();
            }

            if( !strcmp(((char *)data->buffer),"100600") )
            {
                Mic_off();
            }

            if( !strcmp(((char *)data->buffer),"100701") )
            {
                Spk_on();
            }

            if( !strcmp(((char *)data->buffer),"100700") )
            {
                Spk_off();
            }

            if( !strcmp(((char *)data->buffer),"200001") )
            {
                ffs_Check();                    // change to pctm check flash error
            }

            if( !strcmp(((char *)data->buffer),"200000") )
            {
                ffs_Check_stop();                   // change to pctm check flash error
            }

            if( !strcmp(((char *)data->buffer),"900000") )
            {
                while( 1 )
                {
                }
            }
            memset(data->buffer,0,100);             //clear buffer added by yq
            edtChar((MfwHnd)getactiveEditor(),(int)ecBottom);
            displaySoftKeys(TxtSoftConfirm, TxtSoftBack);

            if( flashupdata==1 )
                flash_FTwrite();
        }
        break;
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        //case INFO_KCD_CALL:  //xsf add 12.13
        /* 2003/12/04 sunsj modify for new editor mode */
        if( data->editor_data.mode == TEXTINPUT_MODE )
        {
            text_input_destroy(data->editor_handle);
        }
        else
        {
            editor_destroy(data->editor_handle);           //destory editor
        }         TestCommand_destroy(data->win); //ganchh modified
        break;
    default:
        break;
    }
}
/*
static int TestCommand_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       	*win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    int flashupdata=0;
    char temp[100];

    //sprintf(temp,"1000");
    //MmiTrace(temp);
      switch(keyboard->code)
      {
        case KCD_LEFT:

        case KCD_RIGHT:
        case KCD_HUP:
            TestCommand_destroy(win);
            break;
        }
      
      return MFW_EVENT_CONSUMED;
}

*/
void TestCommand_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )
        win_data = ((T_MFW_HDR *)own_window)->data;
    
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("TestCommand_destroy()");

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));
    }
    else
    {
        TRACE_EVENT ("TestCommand_destroy() called twice");
    }
}


//begin xzy added 0126 for test command

//begin xzy added 0217 for spk and mic status
int SpkMicStart(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = SpkMic_create(parent_window);
    TRACE_FUNCTION("SpkMicStart()");
    //#ifdef _DAIENABLE_
    //  DAIsignalEnable();  //enable the DAI
    //#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, SPKMIC_INIT, 0, 0);
    }

    return 0;
}



static T_MFW_HND SpkMic_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)SpkMic_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)SpkMicCB);
    return data->win;
}


/*******************************************************************************

 $Function:    	SpkMic_DialogCB

 $Description:	CallBack Function
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void SpkMic_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                            void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    int MIC,Speaker,VBCR,VBCR2,VBUR,VBDR;
    char reason[20];
    UINT8 ctrl_reg,stat_reg;

    TRACE_FUNCTION("SpkMic_DialogCB()");

    switch( e )
    {  //when window first created
    case SPKMIC_INIT:
        {   
            dspl_ClearAll();
            MIC=Mic_status();
            Speaker=speaker_status();
            VBCR=VBCR_status();
            VBCR2=VBCR2_status();
            VBUR=VBUR_status();
            VBDR=VBDR_status();

            /* 2004/03/02 sunsj modify for display area */
            sprintf(data->buffer,"MIC:%d",MIC);
            dspl_TextOut(0, 0, 0, (char*)data->buffer);

            sprintf(data->buffer,"Speaker:%d\n",Speaker);
            dspl_TextOut(0, 13, 0, (char*)data->buffer);

            sprintf(data->buffer,"VBCR:0x%x",VBCR);
            dspl_TextOut(0, 26, 0, (char*)data->buffer);

            sprintf(data->buffer,"VBCR2:0x%x",VBCR2);
            dspl_TextOut(0, 39, 0, (char*)data->buffer);

            sprintf(data->buffer,"VBUR:0x%x",VBUR);
            dspl_TextOut(0, 52, 0, (char*)data->buffer);

            sprintf(data->buffer,"VBDR:0x%x",VBDR);
            dspl_TextOut(0, 65, 0, (char*)data->buffer);
        }
        break;

    default:
        {
            TRACE_EVENT("SpkMic_DialogCB(): Unknown Event");
        }
        break;
    }
}

static void SpkMicCB (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   

    TRACE_FUNCTION("SpkMicCB()");
    SpkMic_destroy(data->win); //ganchh modified
}

/*******************************************************************************

 $Function:    	SpkMic_destroy

 $Description:	Destroys the dialog
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void SpkMic_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )
        win_data = ((T_MFW_HDR *)own_window)->data;
    
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("SpkMic_destroy()");

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));
    }
    else
    {
        TRACE_EVENT ("SpkMic_destroy() called twice");
    }
}


//end xzy added 0217 for spk and mic status

//begin xzy added 0219 for spk and rtc mem flash status
int MemFlashRtcStart(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window   = mfwParent( mfw_header() );
    T_MFW_HND           win           = MemFlashRtc_create(parent_window);
    TRACE_FUNCTION("MemFlashRtcStart()");
    //#ifdef _DAIENABLE_
    //  DAIsignalEnable();  //enable the DAI
    //#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, MEMFLASHRTC_INIT, 0, 0);
    }

    return 0;
}



static T_MFW_HND MemFlashRtc_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );
        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)MemFlashRtc_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)MemFlashRtcCB);
    return data->win;
}


/*******************************************************************************

 $Function:    	MemFlashRtc_DialogCB

 $Description:	CallBack Function
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
static void MemFlashRtc_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                 void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    UINT8 ctrl_reg,stat_reg;
    UINT32 FFS_free,FFS_used,FFS_lost;
    UINT16 memoryleft;

    TRACE_FUNCTION("MemFlashRtc_DialogCB()");

    switch( e )
    {  //when window first created
    case MEMFLASHRTC_INIT:
        {   
            dspl_ClearAll();

            //sprintf(memoryleft,"memory left: %d\n",mfwCheckMemoryLeft());
            //strcat(data->buffer,memoryleft);

            memoryleft=mfwCheckMemoryLeft();

            FFS_free = FFS_Get_Free_Bytes();
            FFS_lost = FFS_Get_Lost_Bytes();
            FFS_used = FFS_Get_Used_Bytes();

            ctrl_reg  = Rtc_getctrreg();        //added by xzy for rtc reg status 0218
            stat_reg  = Rtc_getstatusreg();

            /* 2004/03/02 sunsj modify for display area */
            sprintf(data->buffer,"mem left:%d",memoryleft);
            dspl_TextOut(0, 0, 0, (char*)data->buffer);

            sprintf(data->buffer,"FFS_free:%d",(FFS_free-FFS_lost));
            dspl_TextOut(0, 13, 0, (char*)data->buffer);

            sprintf(data->buffer,"FFS_lost:%d",FFS_lost);
            dspl_TextOut(0, 26, 0, (char*)data->buffer);

            sprintf(data->buffer,"FFS_used:%d",FFS_used);
            dspl_TextOut(0, 39, 0, (char*)data->buffer);

            sprintf(data->buffer,"rtc_ctrl:%d",ctrl_reg);
            dspl_TextOut(0, 52, 0, (char*)data->buffer);

            sprintf(data->buffer,"rtc_status:%d",stat_reg);
            dspl_TextOut(0, 65, 0, (char*)data->buffer);
        }
        break;

    default:
        {
            TRACE_EVENT("MemFlashRtc_DialogCB(): Unknown Event");
        }
        break;

    }

}

static void MemFlashRtcCB (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode*data       = (tSpecialMode*) win_data->user;   


    TRACE_FUNCTION("MemFlashRtcCB()");


    SpkMic_destroy(data->win); //ganchh modified

}

/*******************************************************************************

 $Function:    	SpkMic_destroy

 $Description:	Destroys the dialog
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void MemFlashRtc_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )



        win_data = ((T_MFW_HDR *)own_window)->data;
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("MemFlashRtc_destroy()");

        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));

    }
    else
    {
        TRACE_EVENT ("MemFlashRtc_destroy() called twice");
    }
}
//end xzy added 0219 for spk and rtc mem flash status
void LCDDisplayTestStart(MfwMnu* m, MfwMnuItem* i)
{     
    T_MFW_HND       window      = mfwParent( mfw_header() );
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *)window)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    //char * dspltext;

    //sprintf(dspltext,"MIC:");

    LCD_OFF();

    //rvf_delay(200);
    //LedLightnessAdjust(10);  // 3 level backlight, 
    //LCD_ON();

    //rvf_delay(200);
    //LedLightnessAdjust(255); // 3 level backlight, 
    //LCD_ON();
    //rvf_delay(200);

#ifndef _INNOVATION_EMULATOR_
#if R2D_COMPARE_REFRESH	/* Robert.Chen add, 2003-12-13 */
    memset(OriginLCDData, '\0',sizeof(OriginLCDData));
#endif
#endif

	/* 2004/04/10 sunsj modify */
	dspl_ClearAll();
	dspl_Enable(1);
	rvf_delay(300);
	
	/* 2004/05/21 sunsj modify */
	LedLightnessAdjust(255);
	/* 2004/06 sunsj modify for icon manage */
	//dspl_BitBlt(0, 0, 102, 65, 0, (void *)iconMainIdle12, 0);
	dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x00\x4c\x00\x43\x00\x44\x6d\x4b\x8b\xd5\x00\x00");
	displaySoftKeys( TxtNull, TxtSoftBack);
	dspl_Enable(1);
	rvf_delay(300);
#if 0
    WriteLcdColor(1);       //ȫ
    rvf_delay(300);

    WriteLcdColor(2);       //ȫ
    rvf_delay(300);

    WriteLcdColor(3);       //ڰ׷
    rvf_delay(300);
    //Force_refresh();
    //dspl_ClearAll();
    controlBrowseNew();
    //rvf_delay(300);
    winShow( window );
    //uShow(data->menu );
    //rvf_delay(400);
	displaySoftKeys( TxtSoftSelect, TxtSoftBack);
#endif
}

void LEDBacklightTestStart(MfwMnu* m, MfwMnuItem* i)
{
    dspl_ClearAll();
	displaySoftKeys( TxtNull, TxtSoftBack);
    dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x80\xcc\x51\x49\x6d\x4b\x8b\xd5\x00\x00");
    LedLightnessAdjust(0);
    rvf_delay(300);
    LedLightnessAdjust(255);
    rvf_delay(100);

    dspl_ClearAll();
    dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x95\x2e\x76\xd8\x70\x6f\x6d\x4b\x8b\xd5\x00\x00");
	Backlight_ON();
    rvf_delay(300);
	Backlight_OFF();

    dspl_ClearAll();
    dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x00\x4c\x00\x45\x00\x44\x6d\x4b\x8b\xd5\x00\x00");
    Green_On();
    rvf_delay(300);
}

void MelodyandVibratorTestStart(MfwMnu* m, MfwMnuItem* i)
{
    SetMVol_DownLinkPGA(6); 
	//StartMelody(0);
	dspl_ClearAll();
	displaySoftKeys( TxtNull, TxtSoftBack);
	dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x94\xc3\x58\xf0\x6d\x4b\x8b\xd5\x00\x00");
	
	StartPlayingMelody2(5, 0); //glowing,2003-12-23, use the yamaha api
    rvf_delay(600);
    //StopMelody();
   	StopPlayingMelody2(); //glowing,2003-12-23, use the yamaha api

	dspl_ClearAll();
	dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x97\x07\x52\xa8\x6d\x4b\x8b\xd5\x00\x00");

    StartVibrator();
    rvf_delay(400);
    StopVibrator();
}

//added for xzy by ljq 2003/3/20
void WriteLcdColor(unsigned short color)
{
#ifdef _M188_
    UINT16 loopp;
    WriteIR(0x21);
    WriteRam(0x0000);   //set address COM=14,SEG=00
    WriteIR(0x22);      //Begain write ram
    switch( color )
    {
    case 1:
        //white
        for( loopp=0;loopp<102*80;loopp++ )  //write 20*120 pixel blue+gree
        {
            WriteRam(0xffff);
        }
        break;
    case 2:
        //black
        for( loopp=0;loopp<102*80;loopp++ )  //write 20*120 pixel blue+gree
        {
            WriteRam(0x0000);
        }
        break;
    case 3:
        //black and white
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*80;loopp++ )
        {
            WriteRam(0xffff);
        }
        break;
    case 4:
        //black and white
        for( loopp=0;loopp<10*120;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*120;loopp++ )
        {
            WriteRam(0xffff);
        }
        for( loopp=0;loopp<10*120;loopp++ )
        {
            WriteRam(0x0000);
        }
        for( loopp=0;loopp<10*120;loopp++ )
        {
            WriteRam(0xffff);
        }

    default:
        break;
    }
#endif	
}


int KeyPressTest(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND     parent_window = mfwParent( mfw_header() );
    T_MFW_HND     win           = KeyPressTest_create(parent_window);
    TRACE_FUNCTION("KeyPressTest()");
    //#ifdef _DAIENABLE_
    //  DAIsignalEnable();  //enable the DAI
    //#endif
    if( win NEQ NULL )
    {
        SEND_EVENT (win, KEYPRESSTEST_INIT, 0, 0);
    }

    return 0;
}

static T_MFW_HND KeyPressTest_create(MfwHnd parent_window)
{
    tSpecialMode* data = (tSpecialMode*)ALLOC_MEMORY (sizeof (tSpecialMode));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)KeyPressTest_WinCB);

    if( data->win EQ NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tSpecialMode ) );

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)KeyPressTest_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbd_create(data->win,KEY_ALL,(T_MFW_CB)KeyPressTest_kbd_cb);
	keyPressNumber           = 0;	/* 2004/04/01 sunsj add */
	
    return data->win;
}



static int  KeyPressTest_WinCB (T_MFW_EVENT event, T_MFW_WIN * win)
{
    tSpecialMode* data = (tSpecialMode *)win->user;    
    //const unsigned char str[];
    int row,line,counter=0;
    char keypresstxt[5];

    TRACE_EVENT ("KeyPressTest_WinCB");

    //sprintf(keypresstxt, "#*");

    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            dspl_ClearAll();

            for( row=0;row<6;row++ )
            {
                for( line=0;line<4;line++ )
                {
                    switch( counter )
                    {
                    case 0:
                        sprintf(keypresstxt, " ");
                        break;
                    case 1:
                        sprintf(keypresstxt, "b");
                        break;
                    case 2:
                        sprintf(keypresstxt, "c");
                        break;
                    case 3:
                        sprintf(keypresstxt, "d");
                        break;
                    case 4:
                        sprintf(keypresstxt, "e");
                        break;
                    case 5:
                        sprintf(keypresstxt, "f");
                        break;
                    case 6:
                        sprintf(keypresstxt, "g");
                        break;
                    case 7:
                        sprintf(keypresstxt, "h");
                        break;
                    case 8:
                        sprintf(keypresstxt, "i");
                        break;
                    case 9:
                        sprintf(keypresstxt, "j");
                        break;
                    case 10:
                        sprintf(keypresstxt, "k");
                        break;
                    case 11:
                        sprintf(keypresstxt, "l");
                        break;
                    case 12:
                        sprintf(keypresstxt, "1");
                        break;
                    case 13:
                        sprintf(keypresstxt, "2");
                        break;
                    case 14:
                        sprintf(keypresstxt, "3");
                        break;
                    case 15:
                        sprintf(keypresstxt, "4");
                        break;
                    case 16:
                        sprintf(keypresstxt, "5");
                        break;
                    case 17:
                        sprintf(keypresstxt, "6");
                        break;
                    case 18:
                        sprintf(keypresstxt, "7");
                        break;
                    case 19:
                        sprintf(keypresstxt, "8");
                        break;
                    case 20:
                        sprintf(keypresstxt, "9");
                        break;
                    case 21:
                        sprintf(keypresstxt, "*");
                        break;
                    case 22:
                        sprintf(keypresstxt, "0");
                        break;
                    case 23:
                        sprintf(keypresstxt, "#");
                        break;

                    default:
                        break;
                    }

                    dspl_TextOut(5+line*25, row*12, 0, (char *)keypresstxt);
                    counter++;
                }
            }
        }
        break;
    default:
        return 0;
    }
    return 1;
}


static void KeyPressTest_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,
                                  void *parameter)
{   
    T_MFW_WIN           *win_data   = ( (T_MFW_HDR *) win )->data;
    tSpecialMode* data = (tSpecialMode*) win_data->user;
    //T_EDITOR_DATA		editor_data;
    int row,line;

    TRACE_FUNCTION("KeyPressTest_DialogCB()");

    switch( e )
    {  //when window first created
    case KEYPRESSTEST_INIT:
        {   
            data->position=0;
            winShow(win);
        }
        break;
    case KEYPRESSTEST_UPDATA:
        {
            identifier=identifier-1;
            row=identifier/4;
            line=identifier%4;

            dspl_Clear(5+line*25, row*12, (line+1)*25, (row+1)*12);
        }
        break;
    case KEYPRESSTEST_EXIT:
        {
            KeyPressTest_destroy(win);
            break;
        }
    default:
        {
            TRACE_EVENT("KeyPressTest_DialogCB(): Unknown Event");
        }
        break;
    }
}

void KeyPressTest_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;

    tSpecialMode* data = NULL;

    if( own_window )
        win_data = ((T_MFW_HDR *)own_window)->data;
    if( win_data != NULL )
        data = (tSpecialMode*)win_data->user;

    if( data )
    {
        TRACE_EVENT ("KeyPressTest_destroy()");


        win_delete (data->win);
        // Free Memory
        FREE_MEMORY ((void *)data, sizeof (tSpecialMode));

    }
    else
    {
        TRACE_EVENT ("KeyPressTest_destroy() called twice");
    }
}

static int KeyPressTest_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       parent_window  = mfw_parent (mfw_header());

    switch( keyboard->code )
    {
    case KCD_F3:
		keyPressNumber |= 0x00000001;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 3, 0);
        break;

    case KCD_VOLUP:
		keyPressNumber |= 0x00000002;
		SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 2, 0);
        break;

    //case KCD_VOLDOWN:
    //    SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 3, 0);
    //    break;

    case KCD_LEFT:
		keyPressNumber |= 0x00000004;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 4, 0);
        break;

    case KCD_MNUUP:
		keyPressNumber |= 0x00000008;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 5, 0);
        break;

    case KCD_RIGHT:
		keyPressNumber |= 0x00000010;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 6, 0);
        break;

    case KCD_MNULEFT:
		keyPressNumber |= 0x00000020;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 7, 0);
        break;

    case KCD_OK:
		keyPressNumber |= 0x00000040;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 8, 0);
        break;

    case KCD_MNURIGHT:
		keyPressNumber |= 0x00000080;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 9, 0);
        break;

    case KCD_CALL:
		keyPressNumber |= 0x00000100;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 10, 0);
        break;

    case KCD_MNUDOWN:
		keyPressNumber |= 0x00000200;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 11, 0);
        break;

    case KCD_HUP:
		keyPressNumber |= 0x00000400;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 12, 0);
        break;


    case KCD_1:
		keyPressNumber |= 0x00000800;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 13, 0);
        break;

    case KCD_2:
		keyPressNumber |= 0x00001000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 14, 0);
        break;

    case KCD_3:
		keyPressNumber |= 0x00002000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 15, 0);
        break;

    case KCD_4:
		keyPressNumber |= 0x00004000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 16, 0);
        break;

    case KCD_5:
		keyPressNumber |= 0x00008000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 17, 0);
        break;

    case KCD_6:
		keyPressNumber |= 0x00010000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 18, 0);
        break;

    case KCD_7:
		keyPressNumber |= 0x00020000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 19, 0);
        break;

    case KCD_8:
		keyPressNumber |= 0x00040000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 20, 0);
        break;

    case KCD_9:
		keyPressNumber |= 0x00080000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 21, 0);
        break;

    case KCD_STAR:
		keyPressNumber |= 0x00100000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 22, 0);
        break;

    case KCD_0:
		keyPressNumber |= 0x00200000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 23, 0);
        break;

    case KCD_HASH:
		keyPressNumber |= 0x00400000;
        SEND_EVENT (parent_window, KEYPRESSTEST_UPDATA, 24, 0);
        break;


    case KCD_F4:
        KeyPressTest_destroy(parent_window);
        break;
    default:
        break;
    }
	if( keyPressNumber == 0x007FFFFF )
	{
		KeyPressTest_destroy(parent_window);
		returntoidle(1);
	}
    return MFW_EVENT_CONSUMED;
}
//end of xzy add for special test mode 2003/03/26;

void  GetSignalPicNumber(void)
{
    WORD32      a,b,c,d,f;
    TRACE_EVENT("GetSignalInfo")


    layer1_em_get_rxlevqual(&a,&b,&c,&d);
    layer1_em_get_mode(&f);

    a=a/2;  //in fact signal 

    if( lastsignalvalue==0 )
    {
        lastsignalvalue=a;
    }



    if( a>=35 && a<=102 )
    {
        currentsignalvalue=(a+lastsignalvalue)/2;   //do nothing if signal>35 and a<102

        if( currentsignalvalue>=35 && currentsignalvalue<85 )
        {
            globalSignalPicNumber = 5;
            lastsignalvalue=a;

        }
        if( currentsignalvalue >= 85 && currentsignalvalue < 92 )
        {
            globalSignalPicNumber = 4;
            lastsignalvalue=a;

        }
        if( currentsignalvalue >= 92 && currentsignalvalue < 96 )
        {
            globalSignalPicNumber = 3;
            lastsignalvalue=a;

        }
        if( currentsignalvalue >= 96 && currentsignalvalue < 100 )
        {
            globalSignalPicNumber = 2;
            lastsignalvalue=a;

        }
        if( currentsignalvalue >= 100 && currentsignalvalue <= 102 )
        {
            globalSignalPicNumber = 1;
            lastsignalvalue=a;

        }

    }

    if( a > 102 )
    {
        TRACE_EVENT("SetSignalPicNumber > 102");
        globalSignalPicNumber = 0;

    }
#if 0
    sprintf(temp ,"a NUM:%d",a);
    TRACE_EVENT(temp);

    sprintf(temp ,"lastsignalvalue :%d",lastsignalvalue);
    TRACE_EVENT(temp);

    sprintf(temp ,"Signal NUM:%d", globalSignalPicNumber);
    TRACE_EVENT(temp);
#endif
}


void  SetSignalPicNumberZero(void)
{
    TRACE_EVENT("SetSignalPicNumberZero");


    globalSignalPicNumber = 0;
}
/*-----------------------------------------------------------------
  Function: Set_ForResetIndication
  Description: set the value in the RAM for reset indication
  Return: 
  Author: Gan chunhui 2003/4/9
------------------------------------------------------------------*/

void Set_ForResetIndication()
{
#ifndef _INNOVATION_EMULATOR_
    *((USHORT *)RAMDeafultAdress)=(USHORT)RAMDeafultValue1;
    return;
#endif
}
/*-----------------------------------------------------------------
  Function: IsReset
  Description: Check whether it is powered on because of reset
  Return: 1 ---is reset   0---No
  Author: Gan chunhui 2003/3/21
------------------------------------------------------------------*/
unsigned char IsReset()
{

    if( ResetRelatedPara.PhoneIsResetedFlag )
    {
        //TraceMMIValue_EAST("IsReset",1); 
        return 1;
    }
    else
    {
        //TraceMMIValue_EAST("IsReset",0); 
        return 0;
    }
}

/*-----------------------------------------------------------------
Save PIN data, temporally, should be checked later. how to handle after PUK1 inputted
------------------------------------------------------------------*/
void vSavePinData(unsigned char *s)
{
    unsigned char *s1;
    unsigned char stringLength=0;
    unsigned char checkSum=0;
    unsigned char i;
    s1=(unsigned char *)RAMPINAdress;
    strncpy((char *)s1, (char*)s, 8);
    s1[8]=0;
    stringLength=strlen((char *)s);
    for( i=0;i<stringLength;i++ )
        checkSum ^=s1[i];
    s1[SiteOfCheckSumPin-1]=checkSum;    //save the checksum value for later check
    return;
}

unsigned char GetPinData(unsigned char *s)

{

    unsigned char *s1;
    unsigned char checkSum=0;
    unsigned char stringLength=0;
    unsigned char i;
    TRACE_FUNCTION("Get PIN data");
    s1=(unsigned char *)RAMPINAdress;
    strncpy((char *)s, (char*)s1, 8);
    s[8]=0;
    stringLength=strlen((char *)s);
    //   TraceMMI((char *)s);
    for( i=0;i<stringLength;i++ )
        checkSum ^=s[i];
    if( checkSum!=s1[SiteOfCheckSumPin-1] )   //check whether it is valid
        return 0;
    else
        return 1;

}
/*-----------------------------------------------------------------
  Function: IsLayer1ModeNormal()
  Description: Check whether it is powered on because of reset
  Return: 1 ---is normal   0---No
  Remark: 
  Author: Gan chunhui 2003/3/21
------------------------------------------------------------------*/
unsigned char IsLayer1ModeNormal()
{
    unsigned char IsModeNormal=1;
    WORD32 f;
    layer1_em_get_mode(&f);
    //TraceMMIValue_EAST("Layer mode", f); 
    /*------------------------------
    if confige the mobile phone as MODEM, then mode==5 is nomal
    In WAP over GPRS, mode==7 is also normal
    While call connected, mode==5 is normal  
    0:  ʾոReset
    1:  ʾڽСѡ
    2:  ʾIdle״̬
    3:  ʾֻһǰ״̬
    4:  ʾֻһ֮״̬
    5:  ʾͨ
    6:  ʾʴ(ǰûʹ)
    7:  ʾGRPS鴫
    ---------------------------------------------------*/

    if( f!=2 )    // 2 means normal 
    {
        if( (f==1)||(f==3)||(f==4)||(f==0) )
            IsModeNormal=0;
        else
        {             //check mode==7 and mode==5 only in idle
            if( idleIsFocussed() )
            {
            #ifdef _M188_
                if( ((f==7)&&(GetIO12StatusforMode()!=8))||(f==5) )    //in idle, mod0==7 and modem line is not connectted or mode==5 is not normal
 			#else
                if( f==5 )    //in idle, mod0==7 and modem line is not connectted or mode==5 is not normal
			#endif
                    IsModeNormal=0;
            }
        }

    }
    return IsModeNormal;
}

/*-----------------------------------------------------------------
  Function: unCheckTotalNumberOfAbnormal
  Description: Check whether it is powered on because of reset
  Return: the number of all the continuous abnormal times, 0 means all is OK
  Author: Gan chunhui 2003/3/21
------------------------------------------------------------------*/
unsigned char ucCheckTotalNumberOfAbnormal()
{

    if( !call_get_window() )   // not call connected
    {
        if( IsLayer1ModeNormal() )
        {
            ResetRelatedPara.NumberOfAbnormal=0;
            return 0;
        }
        else
        {
            //    	      TraceMMI("Layer1 Mode not equal 2");
            ResetRelatedPara.NumberOfAbnormal++;
            return ResetRelatedPara.NumberOfAbnormal;
        }
    }
    else
        return 0;
}
/*-----------------------------------------------------------------
  Function: NetWorkFoundRegister()
  Description: register that network is founded
  Return: void
  Author: Gan chunhui 2003/3/21
------------------------------------------------------------------*/
void NetWorkFoundRegister()
{
    ResetRelatedPara.NetWorkFoundFlag=1;
    ResetRelatedPara.NoNetWork=0;
    return;
}

/*-----------------------------------------------------------------
  Function: RegisterNoSIM()
  Description: register that No SIM happens
  Return: void
  Author: Gan chunhui 2003/3/23
------------------------------------------------------------------*/
void RegisterNoSIM()
{

    ResetRelatedPara.NoSIM=1;
    return;
}

/*-----------------------------------------------------------------
  Function: RegisterNoNetWork()
  Description: register that No network happens
  Return: void
  Author: Gan chunhui 2003/3/23
------------------------------------------------------------------*/
void RegisterNoNetWork()
{
    //   TraceMMI("Function: Register No Network");
    ResetRelatedPara.NoNetWork++;
    return;
}
/*-----------------------------------------------------------------
  Function: RegisterNoNetWork()
  Description: register that No network happens
  Return: void
  Author: Gan chunhui 2003/3/23
------------------------------------------------------------------*/
void SetResetRequirement()
{
    ResetRelatedPara.NeedResetFlag=1;
    return;
}

/*-----------------------------------------------------------------
  Function: ShouldBeReseted()
  Description: decide should reset the system
  Return: 1-----true, 0------false
  Author: Gan chunhui 2003/3/21
------------------------------------------------------------------*/
unsigned char ShouldBeReseted()
{
    //TraceMMIValue_EAST("NumberofAbnormal",ResetRelatedPara.NumberOfAbnormal); 
    if( ResetRelatedPara.NeedResetFlag==1 )
        return 1;
    else
    {
        if( ResetRelatedPara.NetWorkFoundFlag )    //the first criteria is network has been founded
        {
            if( ResetRelatedPara.NoSIM )    //No SIM after network founded, reset immediately
                return 1;
            else
            {
                /*gan chunhui 2003/3/23*/
                //number of layer1 abnormal more than 10 times(means 10 min.), reset it.
                //the frequency of no network should be checked
                if( (ucCheckTotalNumberOfAbnormal()>10)||(ResetRelatedPara.NoNetWork>10) )
                    return 1;    //should be resetted
                else
                    return 0;  
            }
        }
        else
            return 0;
    }
}


void AudioLoopTest()
{
#ifndef _INNOVATION_EMULATOR_
	dspl_ClearAll();
	displaySoftKeys( TxtNull, TxtSoftBack);
	dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x97\xf3\x98\x91\x56\xde\x8d\xef\x6d\x4b\x8b\xd5\x00\x00");
	
	Audio_Loop_Test();

	//glowing,2004-04-29 comment the following statement
	//rvf_delay(1500);

	dspl_ClearAll();
	dspl_TextOut_Blk(2, 14, SCREEN_SIZE_X, DSPL_TXTATTR_TRANSPARENT, "\x80\x95\x2e\x76\xd8\x6d\x4b\x8b\xd5\x00\x00");
#endif
}
/* 2004/04/01 sunsj add */
void factoryTest()
{
	LCDDisplayTestStart(0, 0);
	LEDBacklightTestStart(0, 0);
	MelodyandVibratorTestStart(0, 0);
	AudioLoopTest();
	KeyPressTest(0, 0);
}

/* 2004/05/10 wangyan add */
void ShowVersiondialog(T_MFW_HND win)
{   

    T_DISPLAY_DATA display_info;
    TRACE_FUNCTION("ShowVersion_DialogCB()");


            dialog_info_init(&display_info);//gdy add    	
            display_info.KeyEvents    = KEY_CLEAR|KEY_HUP|KEY_RIGHT;
            display_info.TextId       = 0;
            display_info.TextId2      = 0;
            display_info.TextString   = ver;
            display_info.TextString2  = date;
            display_info.LeftSoftKey  = TxtNull;
            display_info.RightSoftKey = TxtSoftBack;
            display_info.Time         =FOREVER;//
            display_info.Callback     = NULL;
            display_info.iconindex=REMIND_REQUIRE;
            info_dialog( win, &display_info );
}

/* 2004/05/21 sunsj add */
/*******************************************************************************

 $Function:    	circle_factoryTest

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND circle_factoryTest (T_MFW_HND parent_win, int param)
{
    T_MFW_HND   win;
	
    win = circle_factoryTest_create (parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, FIELDTEST_INIT, 0, 0);
    }
    return win;
}

/*******************************************************************************

 $Function:    	circle_factoryTest_destroy

 $Description:	Destruction of an information dialog
 
 $Returns:		void

 $Arguments:	win
 
*******************************************************************************/
void circle_factoryTest_destroy (T_MFW_HND own_window)
{
	T_MFW_WIN        * win  = ((T_MFW_HDR *)own_window)->data;
    FACTORY_TEST_DATA     * data = (FACTORY_TEST_DATA *)win->user;
	
    if( data )
    {
        /* Exit TIMER & KEYBOARD Handle */
        kbd_delete (data->factory_kbd);
		tim_delete (data->factory_tim);
        /* Delete WIN Handler */
        win_delete (data->factory_win);
        /* Free Memory */
        FREE_MEMORY ((void *)data, sizeof (FACTORY_TEST_DATA));
    }
}

/*******************************************************************************

 $Function:    	circle_factoryTest_create

 $Description:	
 
 $Returns:		Dialogue info win

 $Arguments:	parent win
 
*******************************************************************************/
static T_MFW_HND circle_factoryTest_create (T_MFW_HND parent_win)
{
    T_MFW_WIN     * win_data;
    FACTORY_TEST_DATA  * data = (FACTORY_TEST_DATA *)ALLOC_MEMORY (sizeof (FACTORY_TEST_DATA));

    data->factory_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)circle_factoryTest_win_cb);
    if( data->factory_win EQ 0 )
    {
        return 0;
    }
    /* Create window handler */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)circle_factoryTest_exec_cb;
    data->mmi_control.data      = data;
    data->parent_win            = parent_win;
    win_data                    = ((T_MFW_HDR *)data->factory_win)->data;
    win_data->user              = (void *)data;
    /*return window handle */
    return data->factory_win;
}

/*******************************************************************************

 $Function:    	circle_factoryTest_exec_cb

 $Description:	

 $Returns:		void

 $Arguments:	win, window handle event, value, parameter

*******************************************************************************/
static void circle_factoryTest_exec_cb (T_MFW_HND win, USHORT event, SHORT value, int parameter)
{
    T_MFW_WIN			* win_data       = ((T_MFW_HDR *)win)->data;
    FACTORY_TEST_DATA   * data           = (FACTORY_TEST_DATA *)win_data->user;
    T_MFW_HND			parent_win       = data->parent_win;

	switch( event )
	{
	case FIELDTEST_INIT:
		data->factory_kbd       = kbd_create (data->factory_win, KEY_ALL, (T_MFW_CB)circle_factoryTest_kbd_cb);
		data->factory_tim   = timCreate(data->factory_win, 10000, (MfwCb) circle_factoryTest_tim_cb);
		circle_times = 0;
		
		tim_start(data->factory_tim);
		
		win_show (data->factory_win);
		break;
	case FIELDTEST_DESTROY:
		circle_factoryTest_destroy(data->factory_win);
		returntoidle(1);
		break;
	default:
		break;
	}
}

/*******************************************************************************

 $Function:    	circle_factoryTest_win_cb

 $Description:	
 
 $Returns:		void

 $Arguments:	window handle event, win
*******************************************************************************/
static int circle_factoryTest_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	LCDDisplayTestStart(0, 0);
	LEDBacklightTestStart(0, 0);
	MelodyandVibratorTestStart(0, 0);
	AudioLoopTest();
}

/*******************************************************************************

 $Function:    	circle_factoryTest_kbd_cb

 $Description:	Keyboard event handler

 $Returns:		status int

 $Arguments:	window handle event, keyboard control block

 $History:      

*******************************************************************************/
static int circle_factoryTest_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
	T_MFW_HND      win           = mfw_parent (mfw_header());
    T_MFW_WIN      * win_data    = ((T_MFW_HDR *)win)->data;
    FACTORY_TEST_DATA   * data   = (FACTORY_TEST_DATA *)win_data->user;
    T_MFW_HND      parent_win    = data->parent_win;
	
	if( event & KEY_LONG )
	{

	}
	else
	{
		switch( keyboard->code )
		{
		case KCD_1:
			break;
		case KCD_RIGHT:
			SEND_EVENT (win, FIELDTEST_DESTROY, 0, 0);
			break;
		}
	}
	return 0;
}

/*******************************************************************************

 $Function:     circle_factoryTest_tim_cb

 $Description:  Callback function for the editor info timer.

 $Returns:      None.

 $Arguments:    None.

*******************************************************************************/
static int circle_factoryTest_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
	T_MFW_HND			win        = mfw_parent (mfw_header());
    T_MFW_WIN			* win_data = ((T_MFW_HDR *)win)->data;
    FACTORY_TEST_DATA	* data     = (FACTORY_TEST_DATA *)win_data->user;
	
    T_MFW_HND       parent_win = data->parent_win;
	
	tim_stop(data->factory_tim);

	win_show (data->factory_win);

	if(circle_times < CIRCLE_FACTORY_TIMES)
	{
		tim_start(data->factory_tim);
		circle_times++;
	}
	return 0;
}
