
#ifndef _DEF_MMI_FIELDTEST_H_
#define _DEF_MMI_FIELDTEST_H_

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Call
 $File:		    MmiIdle.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
                        
********************************************************************************

 $History: MmiIdle.h

	25/10/00			Original Condat(UK) BMI version.	
	20/08/02    ver0.101  fzq modified
	   
 $End

*******************************************************************************/
//xzy add for fieldtest 2003/01/23
#define		WDTDeafultValue1		0x5A			//abnormal power off
#define		WDTDeafultValue2		0xA5			//normal power off
#define		LowVoltageDeafultValue1		0x5A			//deafult 
#define		LowVoltageDeafultValue2		0xA5			//lower voltage shut down
#define		RAMDeafultValue1		0x55AA			//software reset (auto reset)
#define		RAMDeafultValue2		0xAA55			//hardware reset (lost power)

#define		RAMDeafultAdress		0x0087FFFC		//RAM ADDRESS
#define      RAMPINAdress          0x0087FFF0     //for SAVE pin data


typedef enum
{
    SHOWVERSION_INIT
} Version_events;

typedef enum
{
    LAYERONEPARA_INIT,
    LAYERONEPARA_UPDATA,
    LAYERONEPARA_EXIT
} LAYERONEPARA_events;

typedef enum
{
    LAYERONEPARATWO_INIT,
    LAYERONEPARATWO_EXIT
} LAYERONEPARATWO_events;

typedef enum
{
	LAYERONEPARATHREE_INIT,
    LAYERONEPARATHREE_EXIT
} LAYERONEPARATHREE_events;

typedef enum
{
    TESTCOMMAND_INIT,
    TESTCOMMAND_EXIT
} TESTCOMMAND_events;

typedef enum
{
	SPKMIC_INIT,
    SPKMIC_EXIT
} SPKMIC_events;
	
typedef enum
{
	MEMFLASHRTC_INIT,
    MEMFLASHRTC_EXIT
} MEMFLASHRTC_events;

typedef enum
{
    KEYPRESSTEST_INIT,
    KEYPRESSTEST_UPDATA,
    KEYPRESSTEST_EXIT
} KEYPRESSTEST_events;

/* 2004/05/21 sunsj add */
typedef enum
{
	FIELDTEST_INIT, 
	FIELDTEST_DESTROY,
} field_test_events;

typedef struct{                   //ganchh 2003/3/21   for network check and autoreset check
     unsigned char NumberOfAbnormal; //ganchh 2003/3/21 for the number of total abnormal number
     unsigned char PhoneIsResetedFlag;       //ganchh 2003/3/21 for the Flag of RESET
     unsigned char NetWorkFoundFlag;    //network is founded
     unsigned char NoSIM;                //NO SIM event
     unsigned char NoNetWork;           //No network
     unsigned char NeedResetFlag;       //need to be resetted
}ModeCheck_Parameter;

int TestCommand(MfwMnu* m, MfwMnuItem* i);
int ShowVersion(MfwMnu* m, MfwMnuItem* i);
int LayeronePara(MfwMnu* m, MfwMnuItem* i);
int LayeroneParaTwoStart(MfwMnu* m, MfwMnuItem* i);
int LayeroneParaThreeStart(MfwMnu* m, MfwMnuItem* i);
void FieldTestInit();
void FieldTestExit();
void FieldTestLowPowerExit();
int SpkMicStart(MfwMnu* m, MfwMnuItem* i);
int MemFlashRtcStart(MfwMnu* m, MfwMnuItem* i);
void LCDDisplayTestStart(MfwMnu* m, MfwMnuItem* i);
void LEDBacklightTestStart(MfwMnu* m, MfwMnuItem* i);
void MelodyandVibratorTestStart(MfwMnu* m, MfwMnuItem* i);
int KeyPressTest(MfwMnu* m, MfwMnuItem* i);
void  GetSignalPicNumber(void);
void  SetSignalPicNumberZero(void);
unsigned char IsReset();
void vSavePinData(unsigned char *s);
unsigned char GetPinData(unsigned char *s);
unsigned char IsLayer1ModeNormal();
unsigned char ucCheckTotalNumberOfAbnormal();
void NetWorkFoundRegister();
unsigned char ShouldBeReseted();
void factoryTest();
#endif

