include $(CONDAT_BASE_DIR)/condat_lib_ip.mak

#
# Settings for the compilation process
# depending whether traces will be compressed or not
#

TARID := pic$(NTK)$(NWAP)$(NBT)$(NNF)$(NUNIC)$(NCOMPTRC)
OBJ := $(L23_OBJ_DIR)/icn

INCLAYER4 = -I$(SRCMFW)  -I$(SRCACI)  -I$(SRCSMI) -I$(SRCKSD)

# must not be empty. set to "-D" for no local flags.
MY_OPTIONS = -D


SRCWAP=$(CONDAT_DIR)/ms/src/wapaus
SRCEZI=$(CONDAT_DIR)/ms/src/ezitxt
SRCCE=$(CONDAT_DIR)/ms/src/agfa
SRCATB=$(CONDAT_DIR)/ms/src/atb
COLOUR_MMI = 0 
# New editor. 1 -> Compile. 0 -> Don't compile, compile old editor.
#glowing,2004-05-11, use the old editor
NEWED = 0


#
# Sim application setting
#

ifeq ($(TK),1)
COPT1 += -dSIM_TOOLKIT
else
COPT1 += -uSIM_TOOLKIT
endif

ifeq ($(MELGEN),1)
COPT1 += -dMMI_MELODYGENERATOR
else
COPT1 += -uMMI_MELODYGENERATOR
endif

ifeq ($(GAME),1)
COPT1 += -dMMIGAME
else
COPT1 += -uMMIGAME
endif


ifeq ($(CHIMMI),1)
COPT1+= -dCHINESE_MMI
else
#COPT1+= -uCHINESE_MMI
COPT1+= -dCHINESE_MMI
endif


ifeq ($(ETXT),1)
COPT1 += -dEASY_TEXT_ENABLED
else
COPT1 += -uEASY_TEXT_ENABLED
endif


ifeq ($(WAP),1)
COPT1 += -dMMI_WAP_ENABLED
else
COPT1 += -uMMI_WAP_ENABLED
endif

#
# Support for Homezone

ifeq ($(HZONE),1)
COPT1 += -dMMI_HOMEZONE_ENABLED
else
COPT1 += -uMMI_HOMEZONE_ENABLED
endif


#
# Support for UNICODE
#	

ifeq ($(UNIC),1)
COPT1 += -dNO_ASCIIZ
endif

#SPR890 - SH - Test mode menu
ifeq ($(MMITEST),1)
COPT1 += -dMMI_TEST_MODE
else
COPT1 += -uMMI_TEST_MODE
endif

#
# Support for GPRS
#
ifeq ($(PMODE),2)
COPT1 += -dMMI_GPRS_ENABLED
else
COPT1 += -uMMI_GPRS_ENABLED
endif

#
# Support for light version
#
#JVJ-SPR-1298. Provisional until a new option in the .inf file is inserted.

ifeq ($(SRVC),0)
COPT1 += -dMMI_LITE
else
COPT1 += -uMMI_LITE
endif


#
# Support for ENGINEERING MODE
#
ifeq ($(EM),1)
COPT1 += -dMMI_EM_ENABLED
else
COPT1 += -uMMI_EM_ENABLED
endif


#
# Support for Colour display
#	
ifeq ($(BOARD),41)
LSCREEN = 1
COLOUR_MMI = 1
endif

ifeq ($(BOARD),40)
LSCREEN = 1
COLOUR_MMI = 1
endif

ifeq ($(SRVC),0)
COLOUR_MMI = 0
endif

ifeq ($(LSCREEN),1)
COPT1 += -dLSCREEN
else
COPT1 += -uLSCREEN
endif


ifeq ($(COLOUR_MMI),1)
COPT1 += -dCOLOURDISPLAY
else
COPT1 += -uCOLOURDISPLAY
endif

#TTY settings
ifeq ($(FF_TTY),1)
COPT1 += -dMMI_TTY_ENABLED
else
COPT1 += -uMMI_TTY_ENABLED
endif

#
# Internal Phonebook
# Currently always on
#
COPT1 += -dINT_PHONEBOOK

#
# New editor (SPR#1428 - SH)
#
ifeq ($(NEWED),1)
COPT1 += -dNEW_EDITOR
else
COPY1 += -uNEW_EDITOR
endif

COREOBJ = $(OBJ)/TextinputIcn.$(OBJ_TAIL) \
	  $(OBJ)/idleDynamicWp.$(OBJ_TAIL)\
	  $(OBJ)/idleStaticWp.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn1.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn2.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn3.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn4.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn5.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn6.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn7.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn8.$(OBJ_TAIL)\
	  $(OBJ)/mainmenuicn9.$(OBJ_TAIL)\
	  $(OBJ)/MenuTitleIcn.$(OBJ_TAIL)\
	  $(OBJ)/ToolkitIcn.$(OBJ_TAIL)\
	  $(OBJ)/ListIcn.$(OBJ_TAIL)\
	  $(OBJ)/BatteryIcn.$(OBJ_TAIL)\
	  $(OBJ)/SmsIcn.$(OBJ_TAIL)\
	  $(OBJ)/IdleStateIcn.$(OBJ_TAIL)\
	  $(OBJ)/OuterScreenIcn.$(OBJ_TAIL)\
	  $(OBJ)/SignalIcn.$(OBJ_TAIL)\
	  $(OBJ)/SceneIcn.$(OBJ_TAIL)\
	  $(OBJ)/TimeDateIcn.$(OBJ_TAIL)\
	  $(OBJ)/PhoneBookIcn.$(OBJ_TAIL)\
	  $(OBJ)/CallIcn.$(OBJ_TAIL)\
	  $(OBJ)/PopupIcn.$(OBJ_TAIL)\
	  $(OBJ)/ContrastIcn.$(OBJ_TAIL)\
	  $(OBJ)/SwitchOnIcn.$(OBJ_TAIL)\
	  $(OBJ)/SwitchOffIcn.$(OBJ_TAIL)\
	  $(OBJ)/SimNetIcn.$(OBJ_TAIL)\
	  $(OBJ)/WapIcn.$(OBJ_TAIL)\
	  $(OBJ)/DialingIcn.$(OBJ_TAIL)\
	  $(OBJ)/GameIcn.$(OBJ_TAIL)\
	  $(OBJ)/GameBoxmanIcn.$(OBJ_TAIL)\
	  $(OBJ)/GameRussiaIcn.$(OBJ_TAIL)\
	  $(OBJ)/GameSnakeIcn.$(OBJ_TAIL)

ifeq ($(LCDCCHIP),1)
COREOBJ +=	$(OBJ)/cameraIcn.$(OBJ_TAIL) 
endif
	  
	  
BMIPMOBJ = $(COREOBJ)



$(ICN_LIB) : $(OBJ) $(COREOBJ)
	cd $(subst /,$(SLASH),$(OBJ)) $(DELIMITER) 
	$(AR) r $(ICN_LIB) $(COREOBJ)

$(OBJ):	
	mkdir $(subst /,$(SLASH),$(OBJ))
	
clean: 
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(BMIPMOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCICN)/%.c
	echo -D$(NCONFIG) >  cmd
	echo $(MY_OPTIONS) >> cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo -DAUS_CONDAT_TYPE_PORTING >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INCDRV1) >> cmd
#2003/12/23, zhq, modified for all build
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
	echo $(ZHQDRV0) >> cmd
	echo $(ZHQDRV1) >> cmd
	echo $(ZHQDRV2) >> cmd
#	echo $(INCDRV2) >> cmd
	echo -I$(ICDG) >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IGLE) >> cmd
	echo -I$(IAUSC) >> cmd
	echo -I$(SRCWAP) >> cmd
	echo -I$(SRCATB) >> cmd
#	echo -I$(TOP_DIR)/zi/include >> cmd
	echo $(INCLAYER4) >> cmd
	echo $(patsubst %,-i$(TOP_DIR)/%, $(DRIVERS_DIR)/board/spi) >> cmd
	echo $(patsubst %,-i$(TOP_DIR)/%, $(DRIVERS_DIR)/board/melody) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd
