/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Advice of Charge
 $File:		    MmiVoiceMemo.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    09/04/01                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the start code for the MMI
                        
********************************************************************************
 $History: MmiAoc.c

    09/04/01			Original Condat(UK) BMI version.	
    28/08/02      wufei modified
       
 $End

*******************************************************************************/




/*******************************************************************************
                                                                              
                                Include files
                                                                              
*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"
#include "cus_aci.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_ss.h" /*for convert*/
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_cphs.h"
#include "mfw_sat.h"
#include "mfw_ffs.h" //wufei add 0827

#include "dspl.h"


#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiEditor.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "mmiusersymbolinput.h"  //2003-4-10
#include "mmitextinput.h"		/* 2003/12/04 sunsj */

/*******************************************************************************
    Local Data
 
*******************************************************************************/
#define	PIN_REQUEST_FOR_RATE				700
#define	SERVICES_ENTER_CURRENCY			701
#define	SERVICES_ONE_UNIT					702
#define	SERVICES_RATE_CHANGED			703
/*#define	SERVICES_CREDIT_REMAINING		704
#define	SERVICES_LAST_CHARGE				711
#define	SERVICES_TOTAL_CHARGE			712*/
#define	PIN_REQUEST_FOR_LIMIT_CHANGE	705
#define	PIN_REQUEST_FOR_LIMIT_CANCEL	706
#define	SERVICES_LIMIT_VIEW				707
#define	SERVICES_LIMIT_CHANGE				708
#define	SERVICES_LIMIT_CANCEL				709
#define	SERVICES_LIMIT_CHANGED			710

#define	SERVICES_RESET_CHARGE			713
#define	SERVICES_CHARGE_CHANGED			714
#define	SERVICES_OUT_OF_RANGE			715
#define	SERVICES_AOC_NOT_SUPPORTED		716
#define PIN_REQUEST_FOR_RESET_CHARGE		717
#define  SERVICES_RATE_VIEW				718 //WUFEI APPEND
#define  SERVICES_RATE_CANCEL				719 //WUFEI APPEND
#define PIN_REQUEST_FOR_RATE_CANCEL		720 //WUFEI APPEND


/* Max. Enter of Character   */
#define MAX_ENTER_LIMIT      7
#define MAX_ENTER_CURRENCY   4
#define MAX_ENTER_UNIT       6
/*    */



typedef struct
{
    T_MMI_CONTROL           mmi_control;
    T_MFW_HND               service_win;        /* MFW win handler      */
    T_MFW_HND              edt_win;
    T_MFW_CM_AOC_INFO       aocInfo;
    USHORT                  Identifier;
    char                    edt_Buf[30];      /* Editor buffer       */
} T_SERVICES;




LONG acm_last_call = 0; //accumulated call meter  from the last call
//later the value should save and read again from PCM
extern FlashSetting FlashSettingData; //wufei add 0827

/*******************************************************************************
    Local prototypes
 
*******************************************************************************/
T_MFW_HND   service_Init        (T_MFW_HND parent_window);
void        service_Exit        (T_MFW_HND own_window);
T_MFW_HND   service_create      (T_MFW_HND parent_window);
void        service_destroy     (T_MFW_HND own_window);
static int  service_win_cb      (T_MFW_EVENT event, T_MFW_WIN * win);
void        service_dialog_cb   (T_MFW_HND win, USHORT identifier, UBYTE reason);
void        service             (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
void        service_loadEditDefault (T_EDITOR_DATA *editor_data);
void        service_calc_balance   (T_MFW_HND win,char* line);
void        service_calculate   (T_MFW_HND win, char* line, long value);
USHORT      service_check_pin_for_aoc (void);



/* 2003/10/28, wangyan, modify AOC statistics menu*/
int aoc_statistics (MfwMnu* m, MfwMnuItem* i)/* 2003/10/28, wangyan, modify call time statistics menu*/
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_statistics")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), SERVICES_AOC_STATISTICS, 0, 0);


    return 0;
}


#if 0
/*******************************************************************************
    Functions
 
*******************************************************************************/

/*******************************************************************************

 $Function:    	aoc_credit_remaining

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

int aoc_credit_remaining (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_credit_remaining")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), SERVICES_CREDIT_REMAINING, 0, 0);


    return 0;
}

/*******************************************************************************

 $Function:    	aoc_last_charge

 $Description:	Dispays the charge for the last call in the currency or in units
                if no currency information has been entered
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_last_charge (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), SERVICES_LAST_CHARGE, 0, 0);


    return 0;
}

/*******************************************************************************

 $Function:    	aoc_total_charge

 $Description:	Displays the charge for all calls since the chage counter was last reset
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_total_charge (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), SERVICES_TOTAL_CHARGE, 0, 0);


    return 0;
}
#endif


/*******************************************************************************

 $Function:    	aoc_charge_rate

 $Description:	A security code editing screen is opened and Pin 2 requested.
                Once entered successfully, an alpha. editor is opened with the 
                title "Enter currency".Once entered, an numeric editor is opened
                with the title "Enter price p. unit". When the user has finished 
                entry the information screen " Rate changed" is displayed for 
                3 second and the phone returns to the previous sub-menu
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_charge_rate (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    switch( service_check_pin_for_aoc () )
    {
    case MFW_SIM_PIN2_REQ:  
        // create new dynamic dialog for the AOC
        SEND_EVENT (service_Init (win), PIN_REQUEST_FOR_RATE, 0, 0);
        break;  

    case MFW_SIM_PIN_REQ:
    case MFW_SIM_NO_PIN:
        //pin 1 or no pin required, open now the editor for entering the currency
//        SEND_EVENT (service_Init (win),  SERVICES_ENTER_CURRENCY, 0, 0);/*2004/5/14, wangyan modify*/
        SEND_EVENT (service_Init (win),  PIN_REQUEST_FOR_RATE, 0, 0);
        break;

        //		case MFW_SIM_FAILURE:
        //AOC is supported from the SIM 
        //			SEND_EVENT (service_Init (win),  SERVICES_AOC_NOT_SUPPORTED, 0, 0);
        //			break;
    }

    return 0;
}

//--------------------------WUFEI ADD----------------------------------------
/**************************WUFEI ADD*****************************************
$Function: aoc_view_rate
$Description: view the ppu and currency(PUCT)
$Returns:
$Arguments:
******************************************************************************/
int aoc_view_rate (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    TRACE_FUNCTION("aoc_view_rate")
    SEND_EVENT (service_Init(win), SERVICES_RATE_VIEW, 0, 0);
    return 0;
}


/******************************************************************************
$Function: aoc_cancel_rate
$Descripton: cancel the PUCT settings
$Returns:
$Arguments:
*******************************************************************************/
int aoc_cancel_rate (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), PIN_REQUEST_FOR_RATE_CANCEL, 0, 0);

    //	SEND_EVENT (service_Init(win), SERVICES_RATE_CANCEL, 0, 0);
    return 0;
}

//------------------------END OF WUFEI ADD---------------------------------

/*******************************************************************************

 $Function:    	aoc_view_limit

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_view_limit (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), SERVICES_LIMIT_VIEW, 0, 0);

    return 0;
}


/*******************************************************************************

 $Function:    	aoc_change_limit

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_change_limit (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), PIN_REQUEST_FOR_LIMIT_CHANGE, 0, 0);


    return 0;
}


/*******************************************************************************

 $Function:    	aoc_cancel_limit

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_cancel_limit (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    // create new dynamic dialog for the AOC
    SEND_EVENT (service_Init (win), PIN_REQUEST_FOR_LIMIT_CANCEL, 0, 0);


    return 0;
}


/*******************************************************************************

 $Function:    	aoc_reset_charge

 $Description:	Resets the charge counter for all calls
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int aoc_reset_charge (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION("aoc_charge_rate")

    switch( service_check_pin_for_aoc () )
    {
    case MFW_SIM_PIN2_REQ:
        // create new dynamic dialog for the AOC
        SEND_EVENT (service_Init (win), PIN_REQUEST_FOR_RESET_CHARGE, 0, 0);
        break;

    case MFW_SIM_PIN_REQ:
    case MFW_SIM_NO_PIN:
        //pin 1 or no pin required, open now the editor for entering the currency
        SEND_EVENT (service_Init (win), SERVICES_RESET_CHARGE, 0, 0);

        break;
    }

    return 0;
}






/*******************************************************************************

 $Function:    	service_Init

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND service_Init (T_MFW_HND parent_window)
{
    return(service_create (parent_window));
}


/*******************************************************************************

 $Function:    	service_Exit

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void service_Exit (T_MFW_HND own_window)
{

    T_MFW_WIN   * win_data     = ((T_MFW_HDR *)own_window)->data;
    T_SERVICES     * data         = (T_SERVICES *)win_data->user;

    service_destroy (data->service_win);
}

/*******************************************************************************

 $Function:    	service_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND service_create (T_MFW_HND parent_window)
{
    T_SERVICES *  data = (T_SERVICES *)ALLOC_MEMORY (sizeof (T_SERVICES));
    T_MFW_WIN   * win;


    TRACE_FUNCTION ("service_create()");

    data->service_win = win_create (parent_window, 0, 0, (T_MFW_CB)service_win_cb);

    if( data->service_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog =  (T_DIALOG_FUNC)service;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->service_win)->data;
    win->user                = (void *) data;

    data->edt_win            =NULL;


    winShow(data->service_win);
    /*
     * return window handle
     */
    return data->service_win;
}

/*******************************************************************************

 $Function:    	service_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void service_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN   * win;
    T_SERVICES * data;

    TRACE_FUNCTION ("service_destroy()");

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_SERVICES *)win->user;

        if( data )
        {

            /* 2003/12/04 sunsj modify for new editor mode */
            if( data->edt_win )
            {
                if( data->Identifier == SERVICES_ENTER_CURRENCY )
                {
                    text_input_destroy(data->edt_win);
                }
                else
                {
                    editor_destroy(data->edt_win);
                }
            }
            /*
             * Delete WIN handler
             */
            win_delete (data->service_win);
            data->service_win = 0;

            FREE_MEMORY ((void *)data, sizeof (T_SERVICES));

        }
    }
}
/*******************************************************************************

 $Function:    	service_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int service_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}

/*******************************************************************************

 $Function:    	service_dialog_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void service_dialog_cb(T_MFW_HND win, USHORT identifier, UBYTE reason)
{

    char buf [40];

    TRACE_FUNCTION ("service_dialog_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        /* no break; */
    case INFO_TIMEOUT:
        /* no break; */
    case INFO_KCD_HUP:
        /* no break; */
    case INFO_KCD_RIGHT:
        /* no break; */
    case INFO_KCD_CLEAR:

        sprintf(buf, "identifier: %d", identifier); 
        TRACE_EVENT(buf);

        if( identifier EQ SERVICES_OUT_OF_RANGE )
        {
            TRACE_EVENT ("SERVICES_OUT_OF_RANGE");
            SEND_EVENT (win, SERVICES_ONE_UNIT, 0, 0);
        }
        else
        {
            TRACE_EVENT (" destroy ");

            service_Exit(win);
        }
        break;
    }
}

/*******************************************************************************

 $Function:    	service_editor_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void service_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_SERVICES    * data     = (T_SERVICES *)win_data->user;


    UBYTE PWD, i;
    int result;


    char buf[60];


    TRACE_FUNCTION ("service_editor_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        switch( Identifier )
        {
        case SERVICES_ENTER_CURRENCY:
            TRACE_EVENT ("SERVICES_ENTER_CURRENCY");
            TRACE_EVENT ("pressed left");


            // clear old current currency before overwrite it
            memset(data->aocInfo.cur, 0x80, sizeof(data->aocInfo.cur));

            if( strlen(data->edt_Buf) NEQ 0 )
            {
                memcpy(data->aocInfo.cur, data->edt_Buf, MAX_ENTER_CURRENCY);                        
            }

            //termination from ASCII to GSM default
            for( i=0; i< MAX_ENTER_CURRENCY-1; i++ )
            {
                if( data->aocInfo.cur[i] EQ '\0' )
                    data->aocInfo.cur[i] = 0x80;
            }


            // open the next editor for entering the price per unit
            SEND_EVENT (win, SERVICES_ONE_UNIT, 0, 0);
            break;

        case SERVICES_ONE_UNIT:
            TRACE_EVENT ("SERVICES_ONE_UNIT");
            TRACE_EVENT ("pressed left");

            // clear old current ppu before overwrite it
            memset(data->aocInfo.ppu, '\0', sizeof(data->aocInfo.ppu));

            if( strlen(data->edt_Buf) NEQ 0 )
            {
                memcpy(data->aocInfo.ppu, data->edt_Buf, strlen(data->edt_Buf));
            }


            // Password not necessary, Pin2 scenario done 
            PWD='\0';

            // write cur and ppu in AOC 
            result = cm_set_aoc_value(CM_AOC_PUCT, &data->aocInfo, &PWD);

            /*
             sprintf(buf, "%s", data->aocInfo.ppu); 
             TRACE_EVENT(buf);
             sprintf(buf, "%s", data->aocInfo.cur); 
             TRACE_EVENT(buf);
             sprintf(buf, "%d", result); 
             TRACE_EVENT(buf);	
             */
            if( data->edt_win )
            {
                editor_destroy(data->edt_win);
                data->edt_win=NULL;
            }
            if( result EQ CM_OK )
            {
                SEND_EVENT (win, SERVICES_RATE_CHANGED, 0, 0);
            }
            else
            {
                SEND_EVENT (win, SERVICES_OUT_OF_RANGE, 0, 0);
            }

            break;

        case SERVICES_LIMIT_CHANGE:

            // string => long
            data->aocInfo.acm_max = atol(data->edt_Buf);

            // Password not necessary, Pin2 scenario done 
            PWD='\0';  

            result = cm_set_aoc_value(CM_AOC_ACMMAX,&data->aocInfo, &PWD); /* save ACMmax in AOC */

            sprintf(buf, "%ld", data->aocInfo.acm_max); 
            TRACE_EVENT(buf);
            sprintf(buf, "result of set aoc %d", result); 
            TRACE_EVENT(buf);


            SEND_EVENT (win, SERVICES_LIMIT_CHANGED, 0, 0);

            break;
        case SERVICES_RESET_CHARGE:
            /* MC 12/04/02: Changed ACMMAX to ACM (should fix "broken" SIM problem)*/

            result = cm_set_aoc_value(CM_AOC_ACM,&data->aocInfo, &PWD); /* save ACMmax in AOC */

        }
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_CLEAR:
    case INFO_KCD_HUP: //hbh 2003-4-10


        TRACE_EVENT ("INFO_KCD_RIGHT pressed");

        switch( Identifier )
        {
        
        case SERVICES_LIMIT_CHANGE:
        case SERVICES_ENTER_CURRENCY:

            //go back to the previous screen 
            service_Exit (win);
            break;
        case SERVICES_ONE_UNIT:
            if( data->edt_win )
            {
                editor_destroy(data->edt_win);
                data->edt_win=NULL;
            }
            //go back to the previous screen 
            SEND_EVENT (win, SERVICES_ENTER_CURRENCY, 0, 0);
            break;


        default:
            break;
        }
    default:
        break;
    }
}


//---------------------wufei modified------------------------------------------------
/*******************************************************************************

 $Function:    	service

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void service (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *) win)->data;
    T_SERVICES    * data     = (T_SERVICES *)win_data->user;

    char buf[60];

    T_EDITOR_DATA   editor_data;
    T_DISPLAY_DATA display_info;        
    T_MFW_SIM_PIN_STATUS status;


    UBYTE PWD, i, result;
	/*2004/04/14,TALCON modify ,add static*/
    static char line[MAX_LINE],line1[MAX_LINE],line2[MAX_LINE],line3[MAX_LINE];

    TRACE_FUNCTION("service()");

    switch( event )
    {
#if 0
    case SERVICES_CREDIT_REMAINING:

        memset(line,'\0',sizeof(line));

        //Get the ACM MAX
        cm_get_aoc_value(CM_AOC_ACMMAX,&data->aocInfo);  

        //Get ACM
        cm_get_aoc_value(CM_AOC_ACM,&data->aocInfo);    

        //Get currency and price per unit
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);   

        /* nm test only  set the default  */
        //    data->aocInfo.acm_max=100;
        //    data->aocInfo.acm=1;
        //    strcpy ((char *)data->aocInfo.cur, "DM");
        //    strcpy ((char *)data->aocInfo.ppu, "1.5");
        /* nm test only  set the default  */

        sprintf(buf, "ACMMAX: %ld", data->aocInfo.acm_max); 
        TRACE_FUNCTION(buf);
        sprintf(buf, "ACM: %ld", data->aocInfo.acm); 
        TRACE_FUNCTION(buf);
        sprintf(buf, "PPU:%s", data->aocInfo.ppu); 
        TRACE_FUNCTION(buf);
        sprintf(buf, "CUR:%s", data->aocInfo.cur); 
        TRACE_FUNCTION(buf);


        if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) NEQ 0)&& (data->aocInfo.acm NEQ '\0') )
        //if ((data->aocInfo.acm_max NEQ '\0') && (data->aocInfo.acm NEQ '\0'))	
        {
            /* special case: It is not possible to have ACM > ACMMAX   */
            /* this case the mobile has to disconnect */
            if( data->aocInfo.acm > data->aocInfo.acm_max )
            {
                strcpy(line, "????");
            }
            else
            {
                /* calculate the credit with ACMAX and PPU  */
                TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU !=0");
                service_calc_balance (win,(char*)line);

            }
        }
        else if( (data->aocInfo.acm_max EQ '\0') && (strlen((char*)data->aocInfo.ppu) NEQ 0)&& (data->aocInfo.acm NEQ '\0') )
        //if ((data->aocInfo.acm_max EQ '\0') && (data->aocInfo.acm NEQ '\0'))	
        {
            /* calculate the cost with ACM and PPU  */
            TRACE_FUNCTION ("CREDIT :ACMMAX ==0 and PPU !=0");
            service_calculate (win, (char*)line, data->aocInfo.acm);

        }
        else if( (data->aocInfo.acm_max EQ '\0') && (strlen((char*)data->aocInfo.ppu) EQ 0)&& (data->aocInfo.acm NEQ '\0') )
        // if ((data->aocInfo.acm_max EQ '\0') && (data->aocInfo.acm NEQ '\0') )	
        {
            /* show only ACM */
            TRACE_FUNCTION ("CREDIT :ACMMAX ==0 and PPU ==0");
            sprintf(line, "%ld", data->aocInfo.acm); /*   */
        }
        else if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) EQ 0)&& (data->aocInfo.acm NEQ '\0') )
        // if ((data->aocInfo.acm_max NEQ '\0') && (data->aocInfo.acm NEQ '\0'))	
        {
            /*  show only ACMAX  */
            TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU ==0");
            sprintf(line, "%ld", data->aocInfo.acm_max - data->aocInfo.acm); /*   */
        }
        else if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) EQ 0) && (data->aocInfo.acm EQ '\0') )
        {
            /*  show only ACMAX  */
            TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU ==0");
            sprintf(line, "%ld", data->aocInfo.acm_max); /*   */
        }
        else if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) NEQ 0) && (data->aocInfo.acm EQ '\0') )
        {
            /* calculate the credit with ACMAX and PPU  */
            TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU !=0");
            service_calculate (win, (char*)line, data->aocInfo.acm_max);

        }
        else
            strcpy ((char *)line, "0");

        //from ASCII to GSM default
        for( i=0; i< MAX_LINE; i++ )
        {
            if( line[i] EQ 0x80 OR line[i] EQ 0xFF )
                line[i] = '\0';
        }
        dialog_info_init(&display_info);//gdy add


        //sprintf(buf, "line:   %s", line); 
        //TRACE_FUNCTION(buf);
        if( data->aocInfo.acm_max EQ 0 )
        {
            display_info.TextString="\x80\x8d\x39\x75\x28\x00\x00";//WUFEI MODIFY 0812
            //display_info.TextId       = TxtCost;//wufei modify 0812
        }
        else
        {
            display_info.TextString="\x80\x4f\x59\x98\x9d\x00\x00";//WUFEI MODIFY 0812
            //display_info.TextId       = TxtBalance;//WUFEI MODIFY 0812
        }

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = TxtSoftBack;  //hu binhao 2003-2-27
        //display_info.TextString1		= '\0';

        if( strlen(line)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line,"  ");

        }

        display_info.TextString2 = line;           //hu binhao 2003-1-15
        //	display_info.TextId                = ;
        display_info.TextId2            = 0;
        display_info.Time               = FOREVER;  //hu binhao 2003-1-27
        display_info.Identifier         = event;
        display_info.iconindex              =REMIND_NORECORD;

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;

#endif

    case SERVICES_AOC_STATISTICS:

        memset(line1,'\0',sizeof(line1));
        memset(line2,'\0',sizeof(line2));
        memset(line3,'\0',sizeof(line3));
        //Get the ACM MAX
        cm_get_aoc_value(CM_AOC_ACMMAX,&data->aocInfo);  

        //Get ACM
        cm_get_aoc_value(CM_AOC_ACM,&data->aocInfo);    

        //Get currency and price per unit
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);   

        /* nm test only  set the default  */
        //    data->aocInfo.acm_max=100;
        //    data->aocInfo.acm=1;
        //    strcpy ((char *)data->aocInfo.cur, "DM");
        //    strcpy ((char *)data->aocInfo.ppu, "1.5");
        /* nm test only  set the default  */

        sprintf(buf, "ACMMAX: %ld", data->aocInfo.acm_max); 
        TRACE_FUNCTION(buf);
        sprintf(buf, "ACM: %ld", data->aocInfo.acm); 
        TRACE_FUNCTION(buf);
        sprintf(buf, "PPU:%s", data->aocInfo.ppu); 
        TRACE_FUNCTION(buf);
        sprintf(buf, "CUR:%s", data->aocInfo.cur); 
        TRACE_FUNCTION(buf);


        if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) NEQ 0)&& (data->aocInfo.acm NEQ '\0') )
        //if ((data->aocInfo.acm_max NEQ '\0') && (data->aocInfo.acm NEQ '\0'))	
        {
            /* special case: It is not possible to have ACM > ACMMAX   */
            /* this case the mobile has to disconnect */
            if( data->aocInfo.acm > data->aocInfo.acm_max )
            {
                strcpy(line1, "????");
            }
            else
            {
                /* calculate the credit with ACMAX and PPU  */
                TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU !=0");
                service_calc_balance (win,(char*)line1);

            }
        }
        else if( (data->aocInfo.acm_max EQ '\0') && (strlen((char*)data->aocInfo.ppu) NEQ 0)&& (data->aocInfo.acm NEQ '\0') )
        //if ((data->aocInfo.acm_max EQ '\0') && (data->aocInfo.acm NEQ '\0'))	
        {
            /* calculate the cost with ACM and PPU  */
            TRACE_FUNCTION ("CREDIT :ACMMAX ==0 and PPU !=0");
            service_calculate (win, (char*)line1, data->aocInfo.acm);

        }
        else if( (data->aocInfo.acm_max EQ '\0') && (strlen((char*)data->aocInfo.ppu) EQ 0)&& (data->aocInfo.acm NEQ '\0') )
        // if ((data->aocInfo.acm_max EQ '\0') && (data->aocInfo.acm NEQ '\0') )	
        {
            /* show only ACM */
            TRACE_FUNCTION ("CREDIT :ACMMAX ==0 and PPU ==0");
            sprintf(line1, "%ld", data->aocInfo.acm); /*   */
        }
        else if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) EQ 0)&& (data->aocInfo.acm NEQ '\0') )
        // if ((data->aocInfo.acm_max NEQ '\0') && (data->aocInfo.acm NEQ '\0'))	
        {
            /*  show only ACMAX  */
            TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU ==0");
            sprintf(line1, "%ld", data->aocInfo.acm_max - data->aocInfo.acm); /*   */
        }
        else if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) EQ 0) && (data->aocInfo.acm EQ '\0') )
        {
            /*  show only ACMAX  */
            TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU ==0");
            sprintf(line1, "%ld", data->aocInfo.acm_max); /*   */
        }
        else if( (data->aocInfo.acm_max NEQ '\0') && (strlen((char*)data->aocInfo.ppu) NEQ 0) && (data->aocInfo.acm EQ '\0') )
        {
            /* calculate the credit with ACMAX and PPU  */
            TRACE_FUNCTION ("CREDIT :ACMMAX !=0 and PPU !=0");
            service_calculate (win, (char*)line1, data->aocInfo.acm_max);

        }
        else
            strcpy ((char *)line1, "0");

        //from ASCII to GSM default
        for( i=0; i< MAX_LINE; i++ )
        {
            if( line1[i] EQ 0x80 OR line1[i] EQ 0xFF )
                line1[i] = '\0';
        }
        dialog_info_init(&display_info);//gdy add


        //sprintf(buf, "line:   %s", line); 
        //TRACE_FUNCTION(buf);
        /*          if (data->aocInfo.acm_max EQ 0)
                  {
                      display_info.TextString="\x80\x8d\x39\x75\x28\x00\x00";//WUFEI MODIFY 0812
                      //display_info.TextId       = TxtCost;//wufei modify 0812
                  }
                  else
                  {
                      display_info.TextString="\x80\x4f\x59\x98\x9d\x00\x00";//WUFEI MODIFY 0812
                      //display_info.TextId       = TxtBalance;//WUFEI MODIFY 0812
                  }*/
        if( data->aocInfo.acm_max EQ 0 )
        {
            display_info.TextId=TxtCost;//WUFEI MODIFY 0812
            //display_info.TextId       = TxtCost;//wufei modify 0812
        }
        else
        {
            display_info.TextId=TxtBalance;//WUFEI MODIFY 0812
            //display_info.TextId       = TxtBalance;//WUFEI MODIFY 0812
        }
        if( strlen(line1)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line1,"  ");

        }

        display_info.TextString= line1;           //hu binhao 2003-1-15

        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */

        if( (strlen((char*)data->aocInfo.ppu) EQ 0) && (data->aocInfo.ccm NEQ '\0') ) //wufei
        {
            TRACE_EVENT ("get only :ACM ; PPU ==0 and ACM!=0");

            //show only the units ACM from last call
            sprintf(line2, "%ld", acm_last_call); 


        }
        else if( (strlen((char*)data->aocInfo.ppu) NEQ 0) && (data->aocInfo.ccm NEQ '\0') ) //wufei
        {
            TRACE_FUNCTION ("get only :ACM ; PPU !=0 and ACM!=0");

            // add currency
            //sprintf(line, "%ld %s", acm_last_call, data->aocInfo.cur);   
            service_calculate (win, (char*)line2, data->aocInfo.ccm);


        }
        else //wufei
            strcpy ((char *)line2, "0");

        if( acm_last_call EQ '\0' )
            strcpy ((char *)line2, "0");

        display_info.TextId2=TxtLastCharge;


        if( strlen(line2)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line2,"  ");
        }
        display_info.TextString2        = line2;


        cm_get_aoc_value(CM_AOC_ACM,&data->aocInfo);  /* Get the ACM      */
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */


        /* nm test only  set the default  */
        //		    data->aocInfo.acm=125;
        //		    strcpy ((char *)data->aocInfo.cur, "DM");
        //		    strcpy ((char *)data->aocInfo.ppu, "1.5");
        /* nm test only  set the default  */

        sprintf(buf, "ACM: %ld", data->aocInfo.acm); 
        TRACE_EVENT(buf);
        sprintf(buf, "PPU:%s", data->aocInfo.ppu); 
        TRACE_EVENT(buf);
        sprintf(buf, "CUR:%s", data->aocInfo.cur); 
        TRACE_EVENT(buf);


        if( (strlen((char*)data->aocInfo.ppu) EQ 0) && data->aocInfo.acm NEQ '\0' )
        {
            //show only the units ACM
            sprintf(line3, "%ld", data->aocInfo.acm);    
            TRACE_EVENT ("get only :ACM ; PPU ==0 and ACM!=0");

        }
        if( (strlen((char*)data->aocInfo.ppu) NEQ 0) && data->aocInfo.acm NEQ '\0' )
        {

            service_calculate (win, (char*)line3, data->aocInfo.acm);

            TRACE_EVENT ("calculate ACM * PPU; PPU !=0 and ACM!=0");
        }

        if( data->aocInfo.acm EQ '\0' )
            strcpy ((char *)line3, "0");
        display_info.TextId3=TxtTotalCharge;

        if( strlen(line3)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line3,"  ");
        }
        display_info.TextString3        = line3;

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT| KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = TxtSoftBack;
        display_info.Time               = FOREVER;
        display_info.Identifier         = SERVICES_AOC_STATISTICS;

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;

    case PIN_REQUEST_FOR_RATE:
        //save the status
        data->Identifier = SERVICES_ENTER_CURRENCY;

        //PIN2 is requested to change the Rate
        pin2_check (data->service_win);
        //service_destroy(data->service_win); //xsf remarked it 2003.04.09

        break;

    case PIN_REQUEST_FOR_LIMIT_CHANGE:

        //PIN2 is requested to change the Rate
        pin2_check (data->service_win);

        //save the status
        data->Identifier = SERVICES_LIMIT_CHANGE;
        //service_destroy(data->service_win); //xsf remarked it 2003.04.09
        break;

    case PIN_REQUEST_FOR_LIMIT_CANCEL:

        //PIN2 is requested to change the Rate
        pin2_check (data->service_win);

        //save the status
        data->Identifier = SERVICES_LIMIT_CANCEL;
        //service_destroy(data->service_win); //xsf remarked it 2003.04.09
        break;
    case PIN_REQUEST_FOR_RATE_CANCEL: //WUFIE ADD
        pin2_check(data->service_win);
        data->Identifier=SERVICES_RATE_CANCEL;
        //service_destroy(data->service_win); //xsf remarked it 2003.04.09
        break;
    case PIN_REQUEST_FOR_RESET_CHARGE:
        //save the status
        data->Identifier = SERVICES_RESET_CHARGE;

        //PIN2 is requested to change the Rate
        pin2_check (data->service_win);
        //service_destroy(data->service_win); //xsf remarked it 2003.04.09

        break;


        //it calls from MMI PINS
    case PIN2_OK:
        TRACE_EVENT("PIN2_OK");

        switch( data->Identifier )
        {
        case SERVICES_ENTER_CURRENCY:

            //pin was ok, open now the editor for entering the currency
            SEND_EVENT (win, data->Identifier, 0, 0);
            break;
        case SERVICES_LIMIT_CHANGE:

            //pin was ok, open now the editor for entering the currency
            SEND_EVENT (win, data->Identifier, 0, 0);
            break;
        case SERVICES_LIMIT_CANCEL:

            //pin was ok, open now the editor for entering the currency
            SEND_EVENT (win, data->Identifier, 0, 0);
            break;
        case SERVICES_RESET_CHARGE:

            //pin was ok, open now the editor for entering the currency
            SEND_EVENT (win, data->Identifier, 0, 0);
            break;
        case SERVICES_RATE_CANCEL: //WUFEI ADD
            SEND_EVENT(win,data->Identifier,0,0);
            break;


        }
        break;

    case  PIN2_ABORT:
        dialog_info_init(&display_info);//gdy add
        display_info.TextId       = TxtFailed;
        display_info.KeyEvents      = KEY_CLEAR | KEY_RIGHT | KEY_LEFT | KEY_HUP;
        display_info.LeftSoftKey    = '\0';
        display_info.RightSoftKey   = '\0';
        display_info.TextString     = '\0';
        display_info.TextString2    = line;
        display_info.TextId2      = '\0';
        display_info.Time       = TWO_SECS;
        display_info.Identifier     = event;

        display_info.Callback     = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;
        //begin xsf add for pin2 check of  2003.04.09
    case PIN2_CHECK_ABORT:
        service_destroy(data->service_win); //xsf remarked it 2003.04.09
        break;
        //end xsf add for pin2 check of  2003.04.09
    case SERVICES_ENTER_CURRENCY:


        //save the status
        data->Identifier = SERVICES_ENTER_CURRENCY;


        //PUCT (currency and price per unit) is requested 
        result = cm_get_aoc_value(CM_AOC_PUCT, &data->aocInfo);    

        sprintf(buf, "result %d", result); 
        TRACE_EVENT(buf);


        //fill up editor-sttribut with default
        service_loadEditDefault (&editor_data);


        //clear the editor-buffer
        memset(data->edt_Buf,'\0',sizeof(data->edt_Buf));

        // let to show the current currency, before the user change it */
        memcpy(data->edt_Buf, data->aocInfo.cur, MAX_ENTER_CURRENCY);

        for( i=0; i< MAX_ENTER_CURRENCY-1; i++ )
        {
            if( data->edt_Buf[i] EQ 0x80 OR data->edt_Buf[i] EQ 0xFF )
                data->edt_Buf[i] = '\0';
        }


        editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtEnterCurrency,
                                 (char *)data->edt_Buf,9,edtCurBar1);  //hbh 200304-10



        //editor_data.editor_attr.text	= data->edt_Buf;  /* buffer to be edited */
        //editor_data.editor_attr.size	= MAX_ENTER_CURRENCY;/* limit to 3 letters */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        //editor_data.TextId				= TxtEnterCurrency;
        editor_data.Identifier          = data->Identifier;  
        //editor_data.mode				= ALPHA_MODE;
        editor_data.mode                = TEXTINPUT_MODE;  /* 2003/12/04 sunsj modify */
        editor_data.InputMode           = PINYIN_INPUT_MODE;   /* 2003/12/04 sunsj set default input mode */
        editor_data.AlternateLeftSoftKey = TxtNull;
        editor_data.min_enter           = 1;
        editor_data.destroyEditor       = 0;


		/* 2003/12/15 sunsj initialize editor */
        /* create the dialog handler */
        //data->edt_win=editor_start(data->service_win, &editor_data);  /* start the editor */ 
		data->edt_win = text_input(data->service_win, &editor_data);        break;



    case SERVICES_ONE_UNIT:
        if( data->edt_win )
        {
            editor_destroy(data->edt_win);
            data->edt_win=NULL;
        }
        //save the status
        data->Identifier = SERVICES_ONE_UNIT;
        memset(&editor_data,'\0',sizeof(editor_data));  //hbh 2003-4-10
        //fill up editor-sttribut with default
        service_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(data->edt_Buf,'\0',sizeof(data->edt_Buf));

        /* let to show the current price per unit, before the user change it */
        memcpy(data->edt_Buf, data->aocInfo.ppu, sizeof(data->aocInfo.ppu));



        for( i=0; i< MAX_ENTER_UNIT-1; i++ )
        {
            if( data->edt_Buf[i] EQ 0x80 OR data->edt_Buf[i] EQ 0xFF )
                data->edt_Buf[i] = '\0';
        }

        editor_attr_init_fullscr(&editor_data.editor_attr,1,Txt1Unit,
                                 (char *)data->edt_Buf,9,edtCurBar1);  //hbh 200304-10

        //editor_data.editor_attr.text	= data->edt_Buf;  /* buffer to be edited */
        //editor_data.editor_attr.size	= MAX_ENTER_UNIT;/* limit to 5 numerics */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        //editor_data.TextId				= Txt1Unit;
        editor_data.Identifier          = data->Identifier;  
        editor_data.mode                = SHUZI_MODE;  //hbh 2003-4-9
        editor_data.AlternateLeftSoftKey     = TxtNull;
        editor_data.min_enter           = 1;
        editor_data.destroyEditor           =0;         

        /* create the dialog handler */
        data->edt_win=editor_start(data->service_win, &editor_data);  /* start the editor */ 
        break;


    case SERVICES_RATE_CHANGED:
        dialog_info_init(&display_info);//gdy add

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_LEFT | KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = '\0';
        if( FFS_flashData.language==0 )
        {
            display_info.TextString         = "\x80\x90\x1a\x8b\xdd\x8d\x39\x73\x87\x00\x00";//WUFEI Modify 0812 original value is 0
            display_info.TextString2        = "\x80\x5D\xF1\x65\x39\x53\xD8\x00\x00";//WUFEI Modify 0812 orignal value is 0
        }
        else
        {
            display_info.TextString         = "Rate";
            display_info.TextString2        = "Changed";//wufei modified 0827
        }
        display_info.TextId             = '\0';//WUFEI Modify 0812 original value is TxtRate
        display_info.TextId2            = '\0';//WUFEI Modify 0812 original value is TxtChanged
        display_info.Time               = FOREVER;
        display_info.Identifier         = event;
        display_info.iconindex          =REMIND_COMPLETE; //hubh 2003-4-9

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);
        break;

    case SERVICES_LIMIT_VIEW:
        dialog_info_init(&display_info);//gdy add
        memset(line,'\0',sizeof(line));

        cm_get_aoc_value(CM_AOC_ACMMAX,&data->aocInfo);  /* Get the ACM MAX     */
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */



        /* nm test only  set the default  */
        //    data->aocInfo.acm_max=100;
        //    data->aocInfo.acm=1;
        //    strcpy ((char *)data->aocInfo.cur, "DM");
        //    strcpy ((char *)data->aocInfo.ppu, "1.5");
        /* nm test only  set the default  */


        sprintf(buf, "ACMMAX: %ld", data->aocInfo.acm_max); 
        TRACE_EVENT(buf);
        sprintf(buf, "ACM: %ld", data->aocInfo.acm); 
        TRACE_EVENT(buf);
        sprintf(buf, "PPU:%s", data->aocInfo.ppu); 
        TRACE_EVENT(buf);
        sprintf(buf, "CUR:%s", data->aocInfo.cur); 
        TRACE_EVENT(buf);



        if( (strlen((char*)data->aocInfo.ppu) EQ 0) && data->aocInfo.acm_max NEQ '\0' )
        {
            sprintf(line, "%ld", data->aocInfo.acm_max);     /* Show only ACMmax  */
            TRACE_EVENT ("get only :ACMMAX ; PPU ==0 and ACMMAX!=0");
        }
        if( (strlen((char*)data->aocInfo.ppu) NEQ 0) && data->aocInfo.acm_max NEQ '\0' )
        {
            service_calculate (win, (char*)line, data->aocInfo.acm_max);

            TRACE_EVENT ("calculate ACMMAX * PPU; PPU !=0 and ACMMAX!=0");
        }

        for( i=0; i< MAX_LINE; i++ )
        {
            if( line[i] EQ 0x80 OR line[i] EQ 0xFF )
                line[i] = '\0';
        }
        if( strlen(line)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line,"  ");

        }

        if( data->aocInfo.acm_max NEQ '\0' )
        {
            display_info.TextId       = '\0';//WUFEI MODIFIED 0812 Orignal value is TxtLimitEQ
            display_info.TextId2      = '\0';
            if( FFS_flashData.language==0 )
                display_info.TextString   = "\x80\x96\x50\x5E\xA6\x00\x00";//WUFEI MODIFIED 0812 Orignal value is 0
            else
                display_info.TextString   ="Limit=";//wufei modified 0827
            display_info.TextString2  = line;
        }
        else
        {
            display_info.TextId       = '\0';//WUFEI MODIFIED 0812 Orignal value is TxtNo
            display_info.TextId2      = '\0';//WUFEI MODIFIED 0812 Orignal value is TxtLimit
            if( FFS_flashData.language==0 )
            {
                display_info.TextString   = "\x80\x8d\x39\x75\x28\x4e\x0a\x96\x50\x00\x00";//WUFEI Modified 0812 orignal value is 0
                display_info.TextString2  = "\x80\x65\xe0\x00\x00";//WUFEI Modified 0812 orignal value is 0
            }
            else
            {
                display_info.TextString   = "Limit";
                display_info.TextString2  = "No"; //wufei modified 0827
            }

        }

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT |KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = TxtSoftBack;  //hu binhao 2003-2-17
        display_info.Time               = FOREVER;  ;
        display_info.Identifier         = event;
        display_info.iconindex              =REMIND_NORECORD;  //hu binhao 2003-2-17

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;

    case SERVICES_LIMIT_CHANGE:

        //fill up editor-sttribut with default
        service_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(data->edt_Buf,'\0',sizeof(data->edt_Buf));
        editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtEnterLimit,
                                 (char *)data->edt_Buf,9,edtCurBar1);  //hbh 200304-10


        editor_data.editor_attr.text    = data->edt_Buf;  /* buffer to be edited */
        //editor_data.editor_attr.size	= MAX_ENTER_LIMIT; /* limit to 6 terms of units */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        //editor_data.TextId				= TxtEnterLimit;
        editor_data.Identifier          = data->Identifier;  
        editor_data.mode                = PHONENUMONLY_MODE;  //hbh 2003-4-9
        editor_data.AlternateLeftSoftKey     = TxtNull;
        editor_data.min_enter           = 1;

        /* create the dialog handler */
        editor_start(data->service_win, &editor_data);  /* start the editor */ 


        break;
    case SERVICES_LIMIT_CANCEL:

        // clear the limit
        data->aocInfo.acm_max = 0;

        // Password not necessary, Pin2 scenario done 
        PWD='\0';  

        cm_set_aoc_value(CM_AOC_ACMMAX,&data->aocInfo, &PWD); /* save ACMmax in AOC */

        sprintf(buf, "%ld", data->aocInfo.acm_max); 
        TRACE_EVENT(buf);

        SEND_EVENT (win, SERVICES_LIMIT_CHANGED, 0, 0);

        break;

    case SERVICES_LIMIT_CHANGED:
        dialog_info_init(&display_info);//gdy add
        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_LEFT| KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = '\0';
        if( FFS_flashData.language==0 )
        {
            display_info.TextString         = "\x80\x8d\x39\x75\x28\x4e\x0a\x96\x50\x00\x00";//WUFEI Modify 0812 orignal value is 0
            display_info.TextString2        = "\x80\x5D\xF1\x65\x39\x53\xD8\x00\x00";//WUFEI Modify 0812 orignal value is 0
        }
        else
        {
            display_info.TextString         = "Limit";//wufei modified 0827
            display_info.TextString2        = "Changed";//wufei modified 0827
        }
        display_info.TextId             = '\0';//WUFEI modified 0812 orignal value is TxtLimit
        display_info.TextId2            = '\0';//WUFEI Modified 0812 orignal value is TxtChanged
        display_info.Time               = FOREVER;
        display_info.Identifier         = event;
        display_info.iconindex          =REMIND_COMPLETE; //hubh 2003-4-9


        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;

#if 0
    case SERVICES_LAST_CHARGE: //wufei modified

        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */

        if( (strlen((char*)data->aocInfo.ppu) EQ 0) && (data->aocInfo.ccm NEQ '\0') ) //wufei
        {
            TRACE_EVENT ("get only :ACM ; PPU ==0 and ACM!=0");

            //show only the units ACM from last call
            sprintf(line, "%ld", acm_last_call); 


        }
        else if( (strlen((char*)data->aocInfo.ppu) NEQ 0) && (data->aocInfo.ccm NEQ '\0') ) //wufei
        {
            TRACE_FUNCTION ("get only :ACM ; PPU !=0 and ACM!=0");

            // add currency
            //sprintf(line, "%ld %s", acm_last_call, data->aocInfo.cur);   
            service_calculate (win, (char*)line, data->aocInfo.ccm);


        }
        else //wufei
            strcpy ((char *)line, "0");




        if( acm_last_call EQ '\0' )
            strcpy ((char *)line, "0");
        dialog_info_init(&display_info);//gdy add

        display_info.TextId             = '\0';//WUFEI Modify 0812 orignal value is TxtLastCharge
        display_info.TextId2            = '\0';
        if( FFS_flashData.language==0 )
            display_info.TextString         = "\x80\x4e\x0a\x6b\x21\x90\x1a\x8b\xdd\x8d\x39\x75\x28\x00\x00";//WUFEI Modify 0812 orignal value is 0 ,now TxtLastCharge
        else
            display_info.TextString         ="Last Charge";//wufei modified 0827


        if( strlen(line)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line,"  ");
        }
        display_info.TextString2        = line;
        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = TxtSoftBack;  //hu binhao 2003-2-17
        display_info.Time               = FOREVER;
        display_info.iconindex              =REMIND_NORECORD;
        display_info.Identifier         = event;

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);



        break;

    case SERVICES_TOTAL_CHARGE:

        memset(line,'\0',sizeof(line));

        cm_get_aoc_value(CM_AOC_ACM,&data->aocInfo);  /* Get the ACM      */
        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */


        /* nm test only  set the default  */
        //		    data->aocInfo.acm=125;
        //		    strcpy ((char *)data->aocInfo.cur, "DM");
        //		    strcpy ((char *)data->aocInfo.ppu, "1.5");
        /* nm test only  set the default  */

        sprintf(buf, "ACM: %ld", data->aocInfo.acm); 
        TRACE_EVENT(buf);
        sprintf(buf, "PPU:%s", data->aocInfo.ppu); 
        TRACE_EVENT(buf);
        sprintf(buf, "CUR:%s", data->aocInfo.cur); 
        TRACE_EVENT(buf);


        if( (strlen((char*)data->aocInfo.ppu) EQ 0) && data->aocInfo.acm NEQ '\0' )
        {
            //show only the units ACM
            sprintf(line, "%ld", data->aocInfo.acm);    
            TRACE_EVENT ("get only :ACM ; PPU ==0 and ACM!=0");

        }
        if( (strlen((char*)data->aocInfo.ppu) NEQ 0) && data->aocInfo.acm NEQ '\0' )
        {

            service_calculate (win, (char*)line, data->aocInfo.acm);

            TRACE_EVENT ("calculate ACM * PPU; PPU !=0 and ACM!=0");
        }

        if( data->aocInfo.acm EQ '\0' )
            strcpy ((char *)line, "0");
        dialog_info_init(&display_info);//gdy add
        display_info.TextId             = '\0';//WUFEI Modify 0812 orignal value is TxtTotalCharge 
        display_info.TextId2            = '\0';
        if( FFS_flashData.language==0 )
            display_info.TextString         = "\x80\x7d\x2f\x8b\xa1\x90\x1a\x8b\xdd\x8d\x39\x75\x28\x00\x00";//WUFEI Modify 0812 orignal value is 0 now TxtTotalCharge
        else
            display_info.TextString         = "Total Charge";//wufei modified 0827

        if( strlen(line)<3 )  //for gudy dialog hu binhao 2002-2-27
        {
            strcat(line,"  ");
        }
        display_info.TextString2        = line;
        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT| KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = TxtSoftBack;
        display_info.Time               = FOREVER;
        display_info.iconindex              =REMIND_NORECORD;
        display_info.Identifier         = event;

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;
#endif

    case SERVICES_RESET_CHARGE:

        // clear the charge counter for all calls
        data->aocInfo.acm = 0;
        acm_last_call    = 0;

        cm_set_aoc_value(CM_AOC_ACM,&data->aocInfo, &PWD); /* save ACM in AOC */

        sprintf(buf, "%ld", data->aocInfo.acm); 
        TRACE_EVENT(buf);

        SEND_EVENT (win, SERVICES_CHARGE_CHANGED, 0, 0);

        break;

    case SERVICES_CHARGE_CHANGED:
        dialog_info_init(&display_info);//gdy add

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_LEFT |KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = '\0';
        display_info.TextString         = '\0';
        display_info.TextString2        = '\0';
        display_info.TextId             = TxtResetCharge;
        display_info.TextId2            = TxtNull;
        display_info.Time               = FOREVER;
        display_info.Identifier         = event;
        display_info.iconindex          =REMIND_COMPLETE; //hubh 2003-4-9

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);


        break;
    case SERVICES_OUT_OF_RANGE:
        dialog_info_init(&display_info);//gdy add
        TRACE_EVENT("SERVICES_OUT_OF_RANGE");

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_LEFT | KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = '\0';
        display_info.TextString         = '\0';
        display_info.TextString2        = '\0';
        display_info.TextId             = TxtOutofRange;
        display_info.TextId2            = TxtNull;
        display_info.Time               = THREE_SECS;
        display_info.Identifier         = event;

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);
        break;

    case SERVICES_AOC_NOT_SUPPORTED:

        TRACE_EVENT("SERVICES_OUT_OF_RANGE");
        dialog_info_init(&display_info);//gdy add

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT | KEY_LEFT | KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = '\0';
        display_info.TextString         = '\0';
        display_info.TextString2        = '\0';
        display_info.TextId             = TxtNotAllowed;
        display_info.TextId2            = TxtNull;
        display_info.Time               = THREE_SECS;
        display_info.Identifier         = event;

        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);
        break;
    case SERVICES_RATE_VIEW:                //WUFEI Add the following code
        memset(line,'\0',sizeof(line));
        dialog_info_init(&display_info);//gdy add

        cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */

        sprintf(buf, "PPU:%s", data->aocInfo.ppu); //WUFEI MODIFY
        TRACE_FUNCTION(buf);
        sprintf(buf, "CUR:%s", data->aocInfo.cur); //WUFEI MODIFY
        TRACE_FUNCTION(buf);

        if( strlen((char*)data->aocInfo.ppu) NEQ 0 )
        {
            sprintf(line, "%s %s", data->aocInfo.ppu, data->aocInfo.cur);     
            TRACE_FUNCTION ("get only :ACMMAX ; PPU ==0 and ACMMAX!=0");
        }
        //from ASCII TO GSM DEFAULT
        for( i=0; i< MAX_LINE; i++ )
        {
            if( line[i] EQ 0x80 OR line[i] EQ 0xFF )
                line[i] = '\0';
        }

        if( data->aocInfo.ppu NEQ '\0' )
        {
            display_info.TextId       = '\0';//WUFEI Modify 0812 orignal value is Txt1Unit
            display_info.TextId2      = '\0';//WUFEI Modify 0812 orignal value is TxtNull
            if( FFS_flashData.language==0 )
                display_info.TextString   = "\x80\x00\x31\x90\x1a\x8b\xdd\x53\x55\x4f\x4d\xff\x1d\x00\x00";//WUFEI Modify 0812 orignal value is 0 ,now txt1unit
            else
                display_info.TextString   = "1 Unit=...";//wufei modified 0827
            display_info.TextString2  = line;
        }
        else
        {
            display_info.TextId       = '\0';//WUFEI Modify 0812orignal value is TxtWithout
            display_info.TextId2      = '\0';//WUFEI Modify 0812 orignal value is TxtRate
            if( FFS_flashData.language==0 )
            {
                display_info.TextString   = "\x80\x90\x1a\x8b\xdd\x8d\x39\x73\x87\x00\x00";//WUFEI Modify 0812 orignal value is 0,now txtrate
                display_info.TextString2  = "\x80\x65\xe0\x00\x00";//WUFEI Modify 0812 orignal value is 0,now txtwithout
            }
            else
            {
                display_info.TextString   = "Rate";
                display_info.TextString2  = "NO";//wufei modified 0827
            }
        }

        display_info.KeyEvents          = KEY_CLEAR | KEY_RIGHT  | KEY_HUP;
        display_info.LeftSoftKey        = '\0';
        display_info.RightSoftKey       = TxtSoftBack;  //hu binhao 2003-2-17
        display_info.iconindex= REMIND_NORECORD;  /*2003/11/20, wangyan add*/
        display_info.Time               = THREE_SECS;
        display_info.Identifier         = event;
        display_info.Callback           = (T_VOID_FUNC)service_dialog_cb;
        /*
         * Call Info Screen
         */
        info_dialog (win, &display_info);

        break;

    case SERVICES_RATE_CANCEL:              //WUFEI Add the following code

        memset(data->aocInfo.ppu, '\0', sizeof(data->aocInfo.ppu));
        memset(data->aocInfo.cur, 0x80, sizeof(data->aocInfo.cur));
        // Password not necessary, Pin2 scenario done 
        PWD='\0';  

        sprintf(buf, "%s %s", data->aocInfo.ppu,data->aocInfo.cur); 
        TRACE_FUNCTION(buf);
        if( cm_set_aoc_value(CM_AOC_PUCT,&data->aocInfo, &PWD) EQ CM_OK )/* save ACMmax in AOC */

            SEND_EVENT (win, SERVICES_RATE_CHANGED, 0, 0);
        else
            SEND_EVENT (win, SERVICES_AOC_NOT_SUPPORTED, 0,0);
        break;
    }
}

//-----------------------------end of wufei modified------------------------------


/*******************************************************************************

 $Function:    	service_loadEditDefault

 $Description:	fill up editor-sttribut with default
 
 $Returns:		
 
 $Arguments:		
                
*******************************************************************************/
void service_loadEditDefault (T_EDITOR_DATA *editor_data) //wufei modified the value of px py sx xy/ 0813 
{
    TRACE_FUNCTION ("service_loadEditDefault()");


    editor_data->editor_attr.win.px   = 6;
    editor_data->editor_attr.win.py   = 38;
    editor_data->editor_attr.win.sx   = 100;
    editor_data->editor_attr.win.sy   = 58;
    editor_data->editor_attr.fgColor  = 0;
    editor_data->editor_attr.font     = 0;
    editor_data->editor_attr.mode     = edtCurBar1;
    editor_data->editor_attr.controls = 0;
    editor_data->editor_attr.text     = '\0';  
    editor_data->editor_attr.size     = 0;
    editor_data->editor_attr.e_size   = 0;          /* 2003/12/04 sunsj fix the ascii char text size */
    editor_data->hide                 = FALSE;
    editor_data->Identifier           = 0;  /* optional */
    //editor_data->mode               = DIGITS_MODE;
    editor_data->destroyEditor        = TRUE;   //2003-4-10
    editor_data->LeftSoftKey          = TxtSoftSelect;
    editor_data->AlternateLeftSoftKey = TxtNull;
    editor_data->RightSoftKey         = TxtSoftBack;
    editor_data->TextId               = '\0';  
    editor_data->TextString           = NULL;  
    editor_data->min_enter            = 1;  // Avoid to return empty strings
    editor_data->timeout              = FOREVER;
    editor_data->edtInPbk             =0; //hbh 2003-4-10
    editor_data->Callback             = (T_EDIT_CB)service_editor_cb;
}


/*******************************************************************************

 $Function:    	service_calc_balance

 $Description:	Calculate the Credit remaining
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void service_calc_balance (T_MFW_HND win,char* line)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SERVICES    * data     = (T_SERVICES *)win_data->user;


    char line2[MAX_LINE];
    char *pdest,*src,*dst,*POINT;
    LONG result;
    int  ch = '.';
    UBYTE counter=0;

    memset(line2,'\0',sizeof(line2));

    cm_get_aoc_value(CM_AOC_ACMMAX,&data->aocInfo);  /* Get the ACM MAX     */
    cm_get_aoc_value(CM_AOC_ACM,&data->aocInfo);     /* Get ACM  */
    cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */

    /* nm test only  set the default  */
    //    data->aocInfo.acm_max=100;
    //    data->aocInfo.acm=1;
    //    strcpy ((char *)data->aocInfo.cur, "DM");
    //    strcpy ((char *)data->aocInfo.ppu, "1.5");
    /* nm test only  set the default  */


    /* Search for '.' */
    pdest =(char *) strchr((char*) data->aocInfo.ppu, ch );

    if( pdest EQ NULL )                              /* '.' not founded  */
    {
        result = atol((char*)data->aocInfo.ppu );                /* STRING => LONG   */
        result= result *(data->aocInfo.acm_max - data->aocInfo.acm); /* (ACMmax-ACM) * PPU */
        sprintf(line, "%ld %s", result,data->aocInfo.cur); /* LONG => STRING   */
    }
    else                                        /* '.' found  */
    {
        /*
        * '.' found, *pdest EQ '.'
            */
        counter = strlen(pdest + 1); /* store the decimal place */

        src = (char*)data->aocInfo.ppu;
        dst = line;
        do                           /* remove the '.'   */
        {
            if( *src NEQ '.' )
            {
                *dst++ = *src;
            }
        } while( *src++ NEQ '\0' );
        /* STRING => LONG   */
        result= (atol(line))*(data->aocInfo.acm_max - data->aocInfo.acm); /* (ACMmax - ACM) * PPU */
        sprintf(line, "%ld", result);        /* LONG => STRING   */

        if( strlen(line) < counter )
        {
            src = line;
            dst = line2;
            *dst++ = '0';
            *dst++ = '.';
            counter = counter - strlen(line);
            do                               /* fill up with '0'   */
            {
                *dst++ = '0';
            } while( --counter NEQ 0 );

            memcpy (dst,src,sizeof(src));
            sprintf(line, "%s %s", line2,data->aocInfo.cur);     /* add the currency */
            return;
        }
        src = line;
        dst = line2;
        POINT= src + strlen(src) - counter;
        do                                  /* set the '.'   */
        {
            if( src EQ POINT )
            {
                *dst++ = '.';
            }
            *dst++ = *src++;

        } while( *src NEQ '\0' );

        if( line2[0] EQ '.' )
            sprintf(line, "0%s %s", line2,data->aocInfo.cur);     /* add the currency */

        if( line2[0] NEQ '.' )
            sprintf(line, "%s %s", line2,data->aocInfo.cur);     /* add the currency */

    }
    return;
}


/*******************************************************************************

 $Function:    	service_calculate

 $Description:	Calculate the value with price per unit and currency. 

                "value * PPU" @ currency
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void service_calculate (T_MFW_HND win, char* line, long value)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SERVICES      * data     = (T_SERVICES *)win_data->user;

    char line2[MAX_LINE];
    char *pdest,*src,*dst,*POINT;
    LONG result;
    int  ch = '.';
    UBYTE counter=0;

    memset(line2,'\0',sizeof(line2));

    //    cm_get_aoc_value(CM_AOC_ACM,&data->aocInfo);  //WUFEI Modified   /* Get ACM  */ 
    cm_get_aoc_value(CM_AOC_PUCT,&data->aocInfo);    /* Get currency and price per unit */

    /* nm test only  set the default  */
    //    data->aocInfo.acm=1;
    //    strcpy ((char *)data->aocInfo.cur, "DM");
    //    strcpy ((char *)data->aocInfo.ppu, "1.5");
    /* nm test only  set the default  */



    /* Search for '.' */
    pdest =(char *) strchr((char*) data->aocInfo.ppu, ch );
    if( pdest EQ NULL )                              /* '.' not founded  */
    {
        result = atol((char*)data->aocInfo.ppu );                /* STRING => LONG   */
        result= result * value;            /* value * PPU */
        sprintf(line, "%ld %s", result,data->aocInfo.cur); /* LONG => STRING   */
    }
    else                                        /* '.' found  */
    {
        /*
         * '.' found, *pdest EQ '.'
         */
        counter = strlen(pdest + 1); /* store the decimal place */

        src = (char*)data->aocInfo.ppu;
        dst = line;
        do                           /* remove the '.'   */
        {
            if( *src NEQ '.' )
            {
                *dst++ = *src;
            }
        } while( *src++ NEQ '\0' );

        /* STRING => LONG   */
        result= atol(line) * value;        /* value * PPU     */
        sprintf(line, "%ld", result);        /* LONG => STRING   */

        if( strlen(line) < counter )
        {
            src = line;
            dst = line2;
            *dst++ = '0';
            *dst++ = '.';
            counter = counter - strlen(line);
            do                               /* fill up with '0'   */
            {
                *dst++ = '0';
            } while( --counter NEQ 0 );

            memcpy (dst,src,sizeof(src));
            sprintf(line, "%s %s", line2,data->aocInfo.cur);     /* add the currency */
            return;
        }
        src = line;
        dst = line2;
        POINT= src + strlen(src) - counter;
        do                                  /* set the '.'   */
        {
            if( src EQ POINT )
            {
                *dst++ = '.';
            }
            *dst++ = *src++;

        } while( *src NEQ '\0' );

        if( line2[0] EQ '.' )
            sprintf(line, "0%s %s", line2,data->aocInfo.cur);     /* add the currency */

        if( line2[0] NEQ '.' )
            sprintf(line, "%s %s", line2,data->aocInfo.cur);     /* add the currency */
    }
    return;
}

/*******************************************************************************

 $Function:    	service_check_pin_for_aoc

 $Description: this function check the PIN 2 requirement & availability of AOC	 

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT service_check_pin_for_aoc (void)
{
    T_MFW_AOC_ACCESS access;

    char buf[40];

    /* check PIN 2 requirement & availability of AOC */
    sim_configuration (NULL, NULL, NULL, NULL, NULL, &access);

    sprintf(buf, "acm:%d acmmax:%d,puct:%d", access.access_acm,access.access_acmmax,access.access_puct); 
    TRACE_EVENT(buf);


    if( access.access_acm     EQ MFW_SIM_PIN2 && 
        access.access_acmmax EQ MFW_SIM_PIN2 &&
        access.access_puct     EQ MFW_SIM_PIN2 )
    {
        TRACE_EVENT("PIN 2 required")
        return MFW_SIM_PIN2_REQ;

    }
    else if( access.access_acm     EQ MFW_SIM_PIN1 && 
             access.access_acmmax EQ MFW_SIM_PIN1 &&
             access.access_puct     EQ MFW_SIM_PIN1 )
    {
        TRACE_EVENT("PIN 1 required")
        return MFW_SIM_PIN_REQ;

    }
    else if( access.access_acm     EQ MFW_SIM_NO_PIN && 
             access.access_acmmax EQ MFW_SIM_NO_PIN &&
             access.access_puct     EQ MFW_SIM_NO_PIN )
    {
        TRACE_EVENT("no any PIN  required")
        return MFW_SIM_NO_PIN;

    }
    else if( access.access_acm     EQ MFW_SIM_UNKNOWN && 
             access.access_acmmax EQ MFW_SIM_UNKNOWN &&
             access.access_puct     EQ MFW_SIM_UNKNOWN )
    {
        TRACE_EVENT("AOC not supported")
        return MFW_SIM_FAILURE;
    }


}

/*******************************************************************************

 $Function:    	service_check_aoc

 $Description:   If there is no support for AOC on SIM card
               the item "Charge Timers" will not Appear on the menulist
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT service_check_aoc (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    TRACE_FUNCTION("service_check_aoc")

    switch( service_check_pin_for_aoc () )
    {
    case MFW_SIM_PIN2_REQ:  
    case MFW_SIM_PIN_REQ:
    case MFW_SIM_NO_PIN:
        TRACE_EVENT("AOC item visible")
        return 0;
        break;

    case MFW_SIM_FAILURE:
        TRACE_EVENT("AOC item not visible")
        //return 1;
        return 0; // hu binhao 2003-4-30 if the sim card not support aoc,it still show charge nemu item
        break;
    }


}


