/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	eg730                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Game
 $File:		    mmiballoon.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		tangyan                                                         
 $Date:		    08/21/02                                                      
                                                                               
********************************************************************************

                                                                              
 Description

    This provides the main game (boxman) functionality

 ////////////////////////////////////////////////////////////////////////////////

//
////////////////////////////////////////////////////////////////////////////////

********************************************************************************/
/*******************************************************************************
History
Date                          Modified
08/26/02                                                                              
*******************************************************************************/

/*******************************************************************************
                                                                              
                                Include files
                                                                              
*******************************************************************************/

#include "mfw_sys.h"
//#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
//#include "vsi.h"
#include "ffs.h"
#include "p_sim.h"
#include "cus_aci.h"
#include "Rtc_Api.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "mfw_mnu.h"
#include "mfw_ffs.h"
#include "dspl.h"
#include "bmieastapi.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiBookShared.h"
#include "mmiballoon.h"
#include "MmiBlkLangDB.h"
#include "GameDisplay.h"
#include "mmigameicons.h"
#include "mmi3dframe.h"
#include "mmisettings.h"

/******************************************************************************

                                궨
                                
********************************************************************************/                                
#define balloongame 121	
#define CURSORSPEED  5
//ڲͬļʱпܲһ
#define balloontimer1 100
#define balloontimer2 150
#define balloontimer3 200
#define balloontimeout 900

#define CURSORXMAX 120
#define CURSORYMAX 160
#define CURSORXMIN  0
#define CURSORYMIN  0
#define CURSORWIDTH 4   
#define GAMESELECTY 10   //ѡϷַʾʼλ
#define CURSORSIZE   9
#define abs(a)  ((a)>0? (a):-(a))
#define SMALLER(a,b) (((a-b)>0)?(b):(a))
#define LAGER(a,b)   (((a-b)>0)?(a):(b))
#ifndef BALLOONDEBUG
#define BALLOONDEBUG 1
#endif
#undef  BALLOONDEBUG
#define HELPDISPLAY 22	
/*******************************************************************************
                                                                              
                                ݽṹ
                                                                              
*******************************************************************************/
typedef enum {
	BALLOONINITIAL,                                    
		//Ϸʼ״̬
	BALLOONPLAY,                                       
	//Ϸ״̬
	BALLOONEXIT,                                     
	//Ϸѡ״̬
	BALLOONSCORE,                                          
	//Ϸ༭״̬
	BALLOONSETTING,                                   
	//Ϸ״̬
    BALLOONHELP,                                          
    //Ϸ״̬
    BALLOONWIN,                                          
    //Ϸʤ״̬
	MAX_MENU_MODE
	}Balloon_Modes;

typedef enum {
    SpeedOne=1,
    SpeedTwo,
    SpeedThree,
    SpeedFour,
    SpeedFive,
    SpeedSix,
    SpeedSeven,
    SpeedEight,
    SpeedNine,
    SpeedMax
	}Balloon_Speed;//Ϸٶȼ
	

typedef struct{	
	U16   width;
	U16   height;
	U16   score;  
} Balloon_Property;


typedef struct{
         U8 balloontype;  //ԣܹ14
         U8  speed;       //¼ٶ
         U8  flag;         //ֵΪ1ʱʾҪɾ
         U16 xposition;   
         //ǰλãrect¼Ͻǵλ
         short yposition;   
         //Բ¼Բλ
         void * balloonnext; //ָԪصһԪ
         }BalloonItem;

typedef struct{
	     U8 countall;
         U8 btcount[8];
}BalloonTotal;
	     
typedef struct{
           U16 ballooncount;   //ǰĻ
           U16 keycode;        //ǰֵ
         //  BalloonItem ballooncur; //ָĵǰ۽
           U8 balloonspeed;
           U8 hitcount[8];
           U8 fireflag;
           U16 score;
           BalloonItem *pfirst;//ָͷ
           BalloonItem *plast;//ָһԪ
           BalloonTotal *balloontotal;//¼ÿĸҼ¼
         
} BalloonItemHeader; 

typedef struct
{
    T_MMI_CONTROL   mmi_control;		// common control parameter
	T_MFW_HND win;
	T_MFW_HND kbd;
	T_MFW_HND 	bltimer;
	U8 balloonTimeflag;
    BalloonItemHeader *pheader;
    char * pscreenbuffer;
} Balloon_Game;


/******************************************************************************

                                
                                
********************************************************************************/  
//ͣĴСĻ
char *balloonaddresses[]={(char *)balloon16,(char *)balloon18,(char *)balloon20,(char *)balloon22,
	               (char *)balloon24,(char *)balloon16mul,(char *)balloon24div,(char *)balloonstop};

Balloon_Property balloonproperty[]={{8,8,9,},{9,9,7},{10,10,6},{11,11,5},
                                 {12,12,4},{8,8,0},{12,12,0},{10,10,0}};


/**********************************************************************************************

                            ϵͳص
                               
 **********************************************************************************************/
T_MFW_HND balloon_create(MfwHnd parent);
void balloon_destroy (T_MFW_HND);
void balloon_dialog (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
int balloon_kbd_cb (MfwEvt e, MfwKbd *k);
int balloon_win_cb (MfwEvt e, MfwWin *w);
int balloon_mnu_cb (MfwEvt e, MfwMnu *m);
T_MFW_HND balloon_start (T_MFW_HND win_parent,char *character);
int balloon(MfwMnu* m, MfwMnuItem* i);
int balloontimerfunc(MfwEvt e, MfwTim *bmtime); 
/**********************************************************************************

                              

***********************************************************************************/
/***********************************************************************************
 ʷ:
                                   
       gameinterfaceshow                          08/22/02
       balloonheadinitial                     08/22/02
       addballoonitem                      08/22/02
       iteminitial                           08/22/02
       randomxpositioncreate                08/22/02
       randomtypecreate                    08/22/02
       removeelement                      08/22/02
       removeallitem                       08/22/02
       balloonrise                          08/22/02
       countbaloontype                     08/26/02
       randcreate                          08/26/02
       ypositionadd                         08/27/02
       settimelevel                         08/27/02
       movecursor                         08/27/02
       gunshurt                            08/27/02
       shotinside                           08/27/02
       moveoutside                         09/02/02
       judgeoutside                         09/02/02
       balloondisplay                        09/13/02
       countscore                           09/15/02
       gameover                           09/15/02
       newgame                            09/15/02
       countballoontotal                      09/16/02
       gamelevelselect                       09/18/02
       drawgamelevel                       09/28/02
       balloonwinshow                         10/11/02
       gamescoresave                        10/11/02
       socreinitial()                      10/11/02
       get_freshsize()                    27/11/02
       clear_remain()                     28/11/02
************************************************************************************/
void gameinterfaceshow(BalloonItemHeader *pheader, char* pscreenbuffer);
void balloonheadinitial(BalloonItemHeader *pheader);
void addballoonitem(BalloonItemHeader *pheader);
void iteminitial(BalloonItem *newballoon,BalloonItemHeader *pheader);
U16 randomxpositioncreate(BalloonItemHeader *pheader);
U16 randomtypecreate(BalloonItemHeader *pheader);
void removeelement(BalloonItemHeader *pheader);
void removeallitem(BalloonItemHeader *pheader);
void balloonrise(BalloonItemHeader *pheader);
void countballoontype(BalloonItemHeader *pheader);
void ypositionadd(BalloonItemHeader * pheader,char* pscreenbuffer);
U16 settimelevel(void);
void movecursor(BalloonItemHeader * pheader);
void showcursor(char *pscreenbuffer);
int gunshort(BalloonItemHeader *pheader);
int shortinside(BalloonItem *balloon);
int moveoutside(BalloonItemHeader *pheader);
int judgeoutside(BalloonItem *balloon);
void test(U8 select);
void balloondisplay(BalloonItem *tempballoon);
void countscore(BalloonItemHeader *pheader,BalloonItem *tempballoon,U8 scoreflag);
void gameover(BalloonItemHeader *pheader);
void  newgame(BalloonItemHeader* pheader);
void countballoontotal(BalloonItemHeader *pheader);
void movecursorquik(BalloonItemHeader * pheader);
void mvoe_memory(BalloonItemHeader *pheader);
void cursor_resume(BalloonItemHeader *pheader, char *pscreenbuffer);
U8  get_freshsize(U16 xposition,U16 yposition,U16 height,U16 width);
void clear_remain(char *pscreenbuffer,U16 xposition,U16 yposition);
void dspl_all(BalloonItemHeader *pheader, char* pscreenbuffer);
void balloon_help(void);
void Show_Socre(BalloonItemHeader *pheader);
void Show_Hitin(BalloonItemHeader *pheader);
void Set_Bs_Btimer(BalloonItemHeader* pheader,Balloon_Speed currentlevel);
U16 getballoonymin(BalloonItemHeader * pheader);
void Balloon_Mnushow();
/**********************************************************************************

                               ⲿ
                        
***********************************************************************************/
//extern void drawcolrclaritytext(U16 left , U16 top , char* text, U32 color );
/**********************************************************************************

                               ȫֱ
                        
***********************************************************************************/
extern INT8  g_norejectkeyflag;
extern ffsgamedata ffs_gamedata;
static Balloon_Modes l_mode=BALLOONINITIAL;
BalloonItem  cursor={0,61,61,0,0,0};
Balloon_Speed BalloonGamelevel; 
U16 lcdischange=0;
char freshwidth,freshheight;
U16 timestoped=0;

GameScore *Blloon_Score=(GameScore *)&ffs_gamedata.Blloon_ffsScore;
U32 totalscore=0;

/**********************************************************************************

                          ϵͳص

**********************************************************************************/                          
T_MFW_HND balloon_create (T_MFW_HND parent_window)
{

    T_MFW_WIN     * win;
    char *balloontitle;
    Balloon_Game *  data; 
    BalloonItemHeader  * pheader;
    char * pscreenbuffer;

    data = (Balloon_Game *)ALLOC_MEMORY (sizeof (Balloon_Game));
    if(data==NULL)
		return 0;
	
    pheader=(BalloonItemHeader *)ALLOC_MEMORY(sizeof(BalloonItemHeader));
    if(pheader==NULL)
    	{
           FREE_MEMORY ((void *)data, sizeof (Balloon_Game));
	    return 0;
    	}
	
    pscreenbuffer=(char *)ALLOC_MEMORY((CURSORSIZE*CURSORSIZE*2+2)*sizeof(char));
    if(pscreenbuffer==NULL)
    	{
    	FREE_MEMORY ((void *)data, sizeof (Balloon_Game));
    	FREE_MEMORY ((void *)pheader, sizeof (BalloonItemHeader));
		return 0;
    	}
    data->pscreenbuffer=pscreenbuffer;
    data->pheader=pheader;
   // mapinfo->selcet=1;
    
	TRACE_FUNCTION ("boxman_create()");
     
    memset(pscreenbuffer,0xff,(CURSORSIZE*CURSORSIZE*2)*sizeof(char));  
    balloontitle=(char *) MmiRsrcGetText(TxtBalloongame);  // get the editor title text
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)balloon_win_cb);

    if (data->win EQ 0)
      return 0;
	
    g_game_win=data->win;
    data->mmi_control.dialog    = (T_DIALOG_FUNC)balloon_dialog;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
    * Create any other handler
    */
    
    data->kbd      = kbd_create (data->win,KEY_ALL | KEY_MAKE,(T_MFW_CB)balloon_kbd_cb);
    data->bltimer = timCreate (data->win, balloontimeout, (MfwCb)balloontimerfunc);
    data->balloonTimeflag = 0;
   

//	winShow(data->win);
    return data->win;
}

/*******************************************************************************
 $Function:    	balloon_destroy
 $Description:	  
 $Returns:		
 $Arguments:					
*******************************************************************************/
void balloon_destroy (T_MFW_HND own_window)
{
  T_MFW_WIN     * win;
  Balloon_Game  * data;
  BalloonItemHeader *pheader;
  char * pscreenbuffer;
	TRACE_EVENT("balloon_destroy");

  if (own_window)
  {
    win  = ((T_MFW_HDR *)own_window)->data;
    data = (Balloon_Game *)win->user;
    pheader=data->pheader;
    pscreenbuffer=(char *)data->pscreenbuffer;
    
    if (data)
    {
      win_delete (data->win);
    }
      flash_Gamewrite();
    FREE_MEMORY ((void *)pscreenbuffer, (CURSORSIZE*CURSORSIZE*2+2)*sizeof(char));
    FREE_MEMORY ((void *)pheader, sizeof (BalloonItemHeader));
    FREE_MEMORY ((void *)data, sizeof (Balloon_Game));
    g_norejectkeyflag=0;
    g_game_win=0;
    //set_backlight_on();//2004-03-25 Sunny remove
  }
}

/*******************************************************************************
 $Function:    	balloon_start
 $Description:	 This function just creates and inits the new dialog
 $Returns:		
 $Arguments:					
*******************************************************************************/
T_MFW_HND balloon_start (T_MFW_HND win_parent,char *character)
{


  T_MFW_HND win = balloon_create (win_parent);

  TRACE_EVENT("balloon_start");

  if (win NEQ NULL)
  {
         g_norejectkeyflag=1;
#if 0	//2004-03-25 Sunny remove
	  if( ffs_gamedata.Balloon_Ffskeyload[1].keyCode%40)
	  	set_backlight_off();
#endif
	  
	  SEND_EVENT(win,balloongame,0,character);//ʼwindialog¼
  }
  return win;

}

/*******************************************************************************
 $Function:    	boxman_dialog
 $Description:	 
 $Returns:		
 $Arguments:					
*******************************************************************************/
void balloon_dialog (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    Balloon_Game      * data = (Balloon_Game *)win_data->user;

    TRACE_FUNCTION ("balloon_dialog()");

   /*
   *  In this case the communication is very simple (only one intern event)
   */


    switch (event)
	{
		case balloongame:
               winShow(data->win);
		break;

	    default:
		return;
	}

}

/*******************************************************************************
 $Function:    	boxman_win_cb
 $Description:	win calback function of boxman
 $Returns:		
 $Arguments:	 				
*******************************************************************************/
static int balloon_win_cb (MfwEvt e, MfwWin *w)
{
	Balloon_Game * data = (Balloon_Game *)w->user;
	BalloonItemHeader * pheader= data->pheader;
   // MapInfo   *mapinfo2=data->mapinfo;

	if(winIsFocussed(data->win)==0)
		{
              winfocusout = 1; 
#if 0//2004-03-25 Sunny remove
		if( ffs_gamedata.Balloon_Ffskeyload[1].keyCode%40)
		   set_backlight_off();
#endif
		}
	 else 
	 	{
	 	winfocusout=0;
#if 0//2004-03-25 Sunny remove
		if(!g_lcd_game_flag&&( ffs_gamedata.Balloon_Ffskeyload[1].keyCode%40))
			set_backlight_off();
#endif
	 	}
     
	
	switch (e)
    {
        case MfwWinVisible:
        		TRACE_EVENT("balloon_win_cb clear");

        		switch(l_mode)
        			{
        			case BALLOONINITIAL:
                          Balloon_Mnushow();
                          if(data->balloonTimeflag==0)
                          	{
                          	timStart(data->bltimer);
                          	data->balloonTimeflag=1;
                          	}
        				 break;
        			case BALLOONPLAY:     
        				 dspl_ClearAll();      
        				 if(winfocusout==1)
        				 	{			
        				 	dspl_all(pheader,data->pscreenbuffer);
        				 	timStart(data->bltimer);
        				 	data->balloonTimeflag=1;
        				 	}
        				 break;
        		    case BALLOONWIN:  
        		    	 dspl_ClearAll();
        		    	 if(pheader->score>149)
        		    	 Show_Hitin(pheader);
        		    	 else
        		    	 Show_Socre(pheader);
        		   	     break;
        		   case BALLOONEXIT:
        		   		 dspl_ClearAll();
        		   		 Draw_Dialog((char *)gameexit);
                                    dsplsoftkey(TxtGameGoon, TxtGameExit);
        		   		 break;
                        case BALLOONHELP:
        		          //dspl_ClearAll();
                                    balloon_help();
                            	break;
                        case  BALLOONSETTING:
                            	dspl_ClearAll();
                        	if(Key_Setshow((void *)&keysetting))
                    		{
                      	  timStart(data->bltimer);
                     	  data->balloonTimeflag=1;
                    		}
                     	break;
                       case BALLOONSCORE:
                     	//dspl_ClearAll();
                           Show_Socre(pheader);
                     	break;
        			}        	
        break;
        default:
        break;
    }

    return 1;
}

/*******************************************************************************
 $Function:    	balloon_kbd_cb
 $Description:	 
 $Returns:		
 $Arguments:	 				
*******************************************************************************/
static int balloon_kbd_cb (MfwEvt e, MfwKbd *k)
{

    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    Balloon_Game         * data = (Balloon_Game *)win_data->user;
    char * pscreenbuffer=data->pscreenbuffer;
    BalloonItemHeader * pheader=data->pheader;
    U8 i;
    
    TRACE_EVENT ("balloon_kbd_cb()");
  
	if((e & KEY_MAKE))
		{
	switch(l_mode)
		{
		  case BALLOONINITIAL:
		  	   switch(k->code)
		  	   	{
		  	   	 case KCD_1:
		  	   	 	 l_mode=BALLOONPLAY;
		  	   	 	 totalscore=0;
		  	   	 	 
		  	   	 	 if(data->balloonTimeflag==1)
                                    timStop(data->bltimer);

		  	   	        newgame(pheader);
		  	   	        timStart(data->bltimer);
		  	   	        data->balloonTimeflag=1;
		  	   	  	 winShow(data->win);
		  	   	  	break;
		  	   	  case KCD_2:
		  	   	  	 l_mode=BALLOONSCORE;
		  	   	  	   winShow(data->win);
		  	   	  	break;
		  	   	  case KCD_3:
		  	   	  	   l_mode=BALLOONSETTING;
		  	   	  	   Load_Keyset(balloongame);
		  	   	  	   winShow(data->win);
		  	   	  	break;
		  	   	  case KCD_4:
		  	   	  	   l_mode=BALLOONHELP;
		  	   	  	   winShow(data->win);
		  	   	  	   break;
		  	   	  case KCD_RIGHT:
		  	   	  case KCD_HUP:		  	   	  
				       balloon_destroy(data->win);
		  	   	  	break;
		  	   	  default:break;
		  	   	}
		  	break;
		  case BALLOONPLAY:				
		  				if(k->code== Balloon_Ffskey[2].keyCode)//
		  					{
		  					pheader->keycode=1;
		  					movecursorquik(pheader);
		  					showcursor(pscreenbuffer);
		  					return MFW_EVENT_CONSUMED;
		  					}
		  				if(k->code== Balloon_Ffskey[3].keyCode)//
		  					{
		  					pheader->keycode=2;
		  					movecursorquik(pheader);
		  					showcursor(pscreenbuffer);
		  					return MFW_EVENT_CONSUMED;
		  					}
		  					
		  				if(k->code== Balloon_Ffskey[4].keyCode)//
		  					{
		  					pheader->keycode=4;
		  					movecursorquik(pheader);
		  					showcursor(pscreenbuffer);
		  					return MFW_EVENT_CONSUMED;
		  					}
		  				if(k->code== Balloon_Ffskey[5].keyCode)//
		  					{
		  					pheader->keycode=3;
		  					movecursorquik(pheader);
		  					showcursor(pscreenbuffer);
		  					return MFW_EVENT_CONSUMED;	
		  					}
		  				if(k->code== Balloon_Ffskey[6].keyCode)//ǹ
		  					{
		  					pheader->keycode=5;
		  					if(gunshort(pheader))	
		  						{
		  					removeelement(pheader);
		  					if(timestoped)
		  					 pheader->fireflag=1;
		  						}
		  					return MFW_EVENT_CONSUMED;
		  					}
		  			   if(k->code==Balloon_Ffskey[7].keyCode)//˳
		  			   	{
		  				 timStop(data->bltimer);
		  				 data->balloonTimeflag=0;
		  				 l_mode=BALLOONEXIT;		  						
		  				 winShow(data->win); 					  
		  				 return MFW_EVENT_CONSUMED;	
		  			   	}
		  	   break;
		  	   
		  case BALLOONEXIT:
		  	   switch(k->code)
		  	   	{
                 case KCD_LEFT:
                 	l_mode=BALLOONPLAY;
                 	dspl_ClearAll();
                 	dspl_all(pheader,data->pscreenbuffer);
                 	timStart(data->bltimer);
                 	data->balloonTimeflag=1;
                 	break;
                 case KCD_RIGHT:
                 case KCD_HUP:
                 	removeallitem(pheader);
		  			keysetting.gamedifficult=SpeedOne;	
		  			timSetTime(data->bltimer, balloontimeout);
		  			l_mode=BALLOONINITIAL;
                 	winShow(data->win);
                 	break;
		  	    }
		  	   break;
		  case BALLOONWIN:
		  	   switch(k->code)
		  	   	{
		  	   	case KCD_LEFT:
		  	         if(pheader->score>149)
		  	         	{
		  	         	keysetting.gamedifficult++;
		  	         	}
		  	         	else
		  	         		{
		  	         		totalscore=0;
		  	         	    keysetting.gamedifficult=SpeedOne;	
		  	         		}
		  	   		 l_mode=BALLOONPLAY;
		  	   		 newgame(pheader);
		  	   	     timStart(data->bltimer); 
		  	   	     data->balloonTimeflag=1;
		  	   	     winShow(data->win);
		  	   		 break;
		  	   	case KCD_RIGHT:
		  	   	case KCD_HUP:
		  	   		 totalscore=0;
		  	   		 keysetting.gamedifficult=SpeedOne;
		  	   		 l_mode=BALLOONINITIAL;
		  	   		 timSetTime(data->bltimer, balloontimeout);
		  	   		 winShow(data->win);
		  	   		 break;
		  	   		 default:
		  	   		 	break;
		  	   	}		    
		  	 break;
		  case BALLOONHELP:
		  	switch(k->code)
		  		{
		  		case KCD_LEFT:
		  		case KCD_RIGHT:
		  		case KCD_HUP:
		     	l_mode=BALLOONINITIAL;
		     	break;
		  		}
		  	winShow(data->win);
		  	break;
		 case BALLOONSETTING:
		 	if(Key_Setting_func(balloongame, &keysetting,k))
		 		l_mode=BALLOONINITIAL;
		 	winShow(data->win);
		  	break;
         case BALLOONSCORE:
            switch(k->code)
            	{
            	case KCD_LEFT:
            		for(i=0;i<5;i++)
            			{
            			Blloon_Score->score[i]=0;
            			}
            		winShow(data->win);
            		break;
            	case KCD_RIGHT:
            	case KCD_HUP:
            		l_mode=BALLOONINITIAL;
		 	        winShow(data->win);
            		break;
            	}
		 	break;
		  	default:break;
		}
		}
	
	    if(!(e&KEY_MAKE))
    	{
    	//֮ĸڼOK
    	if(l_mode==BALLOONPLAY)
    		{
		  	if((k->code== Balloon_Ffskey[2].keyCode)||
		  	  (k->code== Balloon_Ffskey[3].keyCode)||
		  	  (k->code== Balloon_Ffskey[4].keyCode)||
		  	  (k->code== Balloon_Ffskey[5].keyCode)||
		  	  (k->code== Balloon_Ffskey[6].keyCode))		
	         pheader->keycode=0;	
    		}
    	}//end if key_make
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************
 $Function:    	balloon
 $Description:	Starts the game function on user selection
 $Returns:		
 $Arguments:	 
*******************************************************************************/
int balloon(MfwMnu* m, MfwMnuItem* i)
{
	Balloon_Game *			data;
    T_MFW_HND	    	parent       = mfwParent( mfw_header());
    TRACE_EVENT("balloon()");
    balloon_start(parent,0);
    return MFW_EVENT_CONSUMED;  //eat it and won't be deal with in the parent window
}



static int balloon_mnu_cb (MfwEvt e, MfwMnu *m)
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    Balloon_Game    *data = (Balloon_Game *)win_data->user;
    T_MFW_HND  *l_parent;
    SHORT        l_id;

    switch (e)
        {
	default: 
	    return MFW_EVENT_REJECTED;
        }
    return MFW_EVENT_CONSUMED;
}


 int balloontimerfunc(MfwEvt e, MfwTim *bmtime)
 	{
 	T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    Balloon_Game         * data = (Balloon_Game *)win_data->user;
    BalloonItemHeader  *pheader=data->pheader;
    BalloonTotal * balloontotal=pheader->balloontotal;
    char * pscreenbuffer=(char *)data->pscreenbuffer;
    INT8  umode;


    TraceMMI("balloontimerfunc");
    
   
    timStop(data->bltimer);
    data->balloonTimeflag=0;
    
    umode=dspl_Enable(0);
	if(winIsFocussed(data->win)==0)
		{
              winfocusout = 1; 
		//set_backlight_on();//2004-03-25 Sunny remove
		}
	 else 
	 	{
	 	winfocusout=0;
#if 0//2004-03-25 Sunny remove
		if(!g_lcd_game_flag&&( ffs_gamedata.Balloon_Ffskeyload[1].keyCode%40))
			set_backlight_off();
#endif
	 	}
     

    //TraceMMIValue_EAST("balloontimerfunc",);
switch(l_mode)
		{
		case BALLOONPLAY:	 
			if(winfocusout==0)
				{
			    ypositionadd(pheader,pscreenbuffer);
			    movecursor(pheader);
			    showcursor(pscreenbuffer);
   			     if(balloontotal->countall>=33 && pheader->ballooncount==0)
		     	          {
		     	            gameover(pheader);
		     	           // gameinterfaceshow(pheader,pscreenbuffer);	
		     	            winShow(data->win);
		                   	break;
		     	          }
			 	 timStart(data->bltimer);
			 	 data->balloonTimeflag=1;
				}
			break;
		case BALLOONSETTING:
            keysetting.keySetstatus=1;
           	dspl_ClearAll();
            Key_Setshow((void *)&keysetting);
			break;
		case BALLOONINITIAL:
            if(winfocusout==0 && data->balloonTimeflag==0)
            	{
            	Balloon_Mnushow();
            	timStart(data->bltimer);
			 	 data->balloonTimeflag=1;
            	}
			break;
		default:
			break;
		}
	 dspl_Enable(umode);

    return MFW_EVENT_CONSUMED;

 	}


/*************************************************************************************
  :balloonheadinitial
  :Ѿ42ҵǰĻѾû
  ˾ΪϷ
  *************************************************************************************/
void gameover(BalloonItemHeader *pheader)
{
l_mode=BALLOONWIN;


totalscore=pheader->score+totalscore;
removeallitem(pheader);
}

/*************************************************************************************
  :balloonheadinitial
  :µϷ
  *************************************************************************************/
void  newgame(BalloonItemHeader* pheader)
{
U8  increament;

BalloonGamelevel = keysetting.gamedifficult;

if(BalloonGamelevel>=SpeedMax || BalloonGamelevel==0)
{
	BalloonGamelevel=SpeedOne;
	keysetting.gamedifficult=SpeedOne;
}
increament=BalloonGamelevel/2+2;

Set_Bs_Btimer(pheader,BalloonGamelevel);


balloonheadinitial(pheader);
cursor.xposition=CURSORWIDTH+52;
/*趨cursorypositionʱcursor_resumeshowcursor
  лָԭеͼγypositionֵǸ1*/
cursor.yposition=CURSORWIDTH+55+pheader->balloonspeed;//+increament
cursor.balloonnext=NULL;
cursor.balloontype=0;
cursor.speed=0;
cursor.flag=0;
}

/************************************************************************************

                              

**************************************************************************************/ 

/*************************ݽṹص************************************/
/*************************************************************************************
  :balloonheadinitial
  :˺ڳʼͷѹĵַΪ
  ͷһϷʼʱ
  *************************************************************************************/
void balloonheadinitial(BalloonItemHeader *pheader)
{
  
   BalloonTotal *balloontotal=(BalloonTotal *)ALLOC_MEMORY(sizeof(BalloonTotal));  

   if(balloontotal){
   memset(balloontotal,0,sizeof(BalloonTotal));
   memset(pheader->hitcount,0,8*sizeof(char));
   pheader->keycode=0;
   pheader->fireflag=0;
   pheader->ballooncount=0;   
   pheader->score=0;
   pheader->pfirst=&cursor;
   pheader->plast=&cursor;
   pheader->balloontotal=balloontotal;
   	}
   TRACE_EVENT("balloonheadinitial");

}

/*************************************************************************************
  :addballoonitem
  :һµԪزΪռ䣬޸
  *************************************************************************************/
void addballoonitem(BalloonItemHeader *pheader)
{
   BalloonItem *newballoon=(BalloonItem*)ALLOC_MEMORY(sizeof(BalloonItem));
   BalloonItem *lastballoon;


   
   TRACE_EVENT("addballoonitem  ty");
   
   if(pheader->plast)
   	 lastballoon=pheader->plast;
   else
   	 lastballoon=pheader->pfirst;
   
   if(newballoon)
   	{
   	if(!(pheader->pfirst->balloonnext))
   		pheader->pfirst->balloonnext=newballoon;
   	
        iteminitial(newballoon,pheader);
        pheader->ballooncount++;
         //   pheader->keycode=0; һСbug
        lastballoon->balloonnext=newballoon;
        pheader->plast=newballoon;
        countballoontotal(pheader);
   	}
   
}

/*************************************************************************************
  :balloonheadinitial
  :˺ڳʼ½Ԫأ趨͡
         ꣬ٶȵȵ
  *************************************************************************************/
void iteminitial(BalloonItem *newballoon,BalloonItemHeader *pheader)
{
   U16 random,randomtype,balloonsize;
   
 //  TRACE_EVENT("iteminitial");

   random=randomxpositioncreate(pheader);   
   randomtype=randomtypecreate(pheader);
   newballoon->xposition=random;
   newballoon->balloonnext=NULL;
   newballoon->balloontype=randomtype;
   newballoon->speed=pheader->balloonspeed;

   balloonsize=balloonproperty[randomtype].height*2;
   newballoon->yposition=CURSORYMAX-balloonsize;
  // newballoon->yposition=140;
   newballoon->flag=0;
  #ifdef BALLOONDEBUG
    zgzTraceDataFunc("iteminitial xposition", (U16)random);
    zgzTraceDataFunc("iteminitial balloontype", (U16)randomtype);
  #endif
   
}

/*************************************************************************************
  :balloonheadinitial
  :˺ɾ־Ԫ
  *************************************************************************************/
void removeelement(BalloonItemHeader *pheader)
{

     BalloonItem *oldballoon,* tempballoon;
     BalloonTotal *balloontotal;
     short xpos,ypos,balloonsize;

     balloontotal=pheader->balloontotal;
     TRACE_EVENT ("removeelement()");
     oldballoon=pheader->pfirst;
     #ifdef BALLOONDEBUG
     zgzTraceDataFunc("rmballoonnumber1", (U16)balloontotal->countall); 
     #endif
     //ɾ־
     while(oldballoon)
     	//ԭǰoldballoon->balloonnextΪжɾ
     	//ȴoldballoonԾͲɾһе
     	{     	
     	//ȡõһ򣬻һ
     	tempballoon=oldballoon->balloonnext;
     	
     	if( tempballoon && ( tempballoon->flag==1 ||tempballoon->flag==2))
     		//򱻻лƳ
     		{
        //	zgzTraceDataFunc("removeelementbc", (U16)pheader->ballooncount); 
        //һΪվNULLҪ³
     		if(tempballoon->balloonnext)
     		   oldballoon->balloonnext=tempballoon->balloonnext;
     		   else
     		   	oldballoon->balloonnext=NULL;
     		   pheader->ballooncount--;
     		#ifdef BALLOONDEBUG   
     	    zgzTraceDataFunc("removeelementflag", (U16)tempballoon->flag); 
     		#endif
              xpos=tempballoon->xposition;
              ypos=tempballoon->yposition;
              
              balloonsize=2*balloonproperty[tempballoon->balloontype].height;
              
             //yposС0  
              dspl_Clear(xpos,LAGER(0, ypos),xpos+balloonsize,ypos+balloonsize);
            
             if(tempballoon->flag==1)
            //yposС0
               lcdischange=get_freshsize(xpos,LAGER(0, ypos),balloonsize+SMALLER(0, ypos),balloonsize);//lcdѾˢ
               
               #ifdef BALLOONDEBUG
               zgzTraceDataFunc("removeelementlcdischange", (U16)lcdischange);   
               #endif
     		   FREE_MEMORY ((void *)tempballoon, sizeof (BalloonItem));  
     		}
     	else
     		//һĵַoldballoon
     		if(tempballoon)
        	oldballoon=tempballoon;
     		else 
     			oldballoon=NULL;
     	/*δ봦ҪΪ˴һ
     	һ򱻻ôҪǰһ
     	趨Ϊһ*/
     	 if(!(oldballoon->balloonnext))
     	 	pheader->plast=oldballoon;     	 
     	 
       	 if(oldballoon==pheader->plast)
     		{
     		oldballoon->balloonnext=NULL;
     		}
     	}
   #ifdef BALLOONDEBUG
   zgzTraceDataFunc("rmballoonnumber2", (U16)balloontotal->countall); 
   #endif
}

/*************************************************************************************
  :balloonheadinitial
  :ɾеԪ
  *************************************************************************************/
void removeallitem(BalloonItemHeader *pheader)
{
    BalloonItem *oldballoon,* tempballoon;
    BalloonTotal  *balloontotal;
    
    oldballoon=pheader->pfirst;
    oldballoon=oldballoon->balloonnext;
    while(oldballoon)
    	{
    	   tempballoon=oldballoon->balloonnext;
    	   FREE_MEMORY ((void *)oldballoon, sizeof (BalloonItem));
    	   oldballoon=tempballoon;
    	}
    
    balloontotal=pheader->balloontotal;
    FREE_MEMORY ((void *)balloontotal, sizeof (BalloonTotal));

    oldballoon=pheader->pfirst;
    pheader->plast=NULL;
    oldballoon->balloonnext=NULL;
    pheader->ballooncount=NULL;    
}


/*************************************************************************************
  :cursor_resume
  :ÿͼincreamentʱʱҲͻ
         ָԭͼΣȻõ꽫Ҫʾλõ
         
**************************************************************************************/
void cursor_resume(BalloonItemHeader *pheader, char *pscreenbuffer)
{
U16 prexposition,preyposition;
U8  increament;


increament=BalloonGamelevel/2+2;

prexposition=cursor.xposition-CURSORWIDTH;

if(pheader->fireflag!=1)
    preyposition=cursor.yposition-CURSORWIDTH-pheader->balloonspeed;//-increament
else
	preyposition=cursor.yposition-CURSORWIDTH;

if(lcdischange==0)
 {
 dspl_BitBlt(prexposition,preyposition,CURSORSIZE,CURSORSIZE,0,(void *)pscreenbuffer, 0);
 }
 else
 {
 clear_remain(pscreenbuffer,prexposition,preyposition); 
 lcdischange=0;
 }


preyposition=cursor.yposition-CURSORWIDTH;
dspl_getscreen(prexposition,preyposition,CURSORSIZE,CURSORSIZE, pscreenbuffer);
//memset(pscreenbuffer,0xff,(CURSORSIZE*CURSORSIZE*2)*sizeof(char));  //for test
}


void dspl_all(BalloonItemHeader *pheader, char* pscreenbuffer)
{
BalloonItem *tempballoon;
U32 pixcolor,oldcolor;
game_Line cursorline1,cursorline2;
   
 tempballoon=pheader->pfirst;

 while(tempballoon)
    	{
    	tempballoon=tempballoon->balloonnext;   	
    	if(tempballoon)
    	  balloondisplay(tempballoon);
    	}
 
   dspl_getscreen(cursor.xposition-CURSORWIDTH,cursor.yposition-CURSORWIDTH,CURSORSIZE,CURSORSIZE, pscreenbuffer);
 
   pixcolor=*(U16 *)(pscreenbuffer+CURSORSIZE*CURSORSIZE);
   cursorline1.x1=cursor.xposition-CURSORWIDTH;
   cursorline1.x2=cursor.xposition+CURSORWIDTH;
   cursorline1.y1=cursorline1.y2=cursor.yposition;
   cursorline1.color=0x0;//(~pixcolor)&0x00ffffff; 

   cursorline2.y1=cursor.yposition-CURSORWIDTH;
   cursorline2.y2=cursor.yposition+CURSORWIDTH;
   cursorline2.x1=cursorline2.x2=cursor.xposition;
   cursorline2.color=0x0;//(~pixcolor)&0xffff;

   DrawLine(cursorline1);
   DrawLine(cursorline2);
   
}
/*************************************************************************************
  :gameinterfaceshow
  :ҪƵʱҪʾϷ
         ʱݣԭʱֹͣʱҲõ
         Ϊʱֹͣһ
**************************************************************************************/
void gameinterfaceshow(BalloonItemHeader *pheader, char* pscreenbuffer)
{
  
    BalloonItem *tempballoon;


    tempballoon=pheader->pfirst;
  
    
   // TRACE_EVENT("gameinterfaceshow");
   
    dspl_Clear(0, 160-pheader->balloonspeed,120,160);
    while(tempballoon)
    	{
    	tempballoon=tempballoon->balloonnext;   	
    	if(tempballoon)
    		{    		
    		if((tempballoon->yposition+balloonproperty[tempballoon->balloontype].height*2-159)>0)
    			{
    			#ifdef BALLOONDEBUG
    		     zgzTraceDataFunc("gameinterfaceshow yposition", (U16)tempballoon->yposition);
    			#endif
    		     balloondisplay(tempballoon);
    			}
    		}
    	if(pheader->fireflag!=1)
    	tempballoon->yposition=tempballoon->yposition-tempballoon->speed;
    	}
    if(pheader->fireflag!=1)		
    mvoe_memory(pheader);
    //ʾ
    
    if(moveoutside(pheader))
     removeelement(pheader);	
    
    if(pheader->balloonspeed/2==1)
    dspl_Clear(0, 159-pheader->balloonspeed,120,160);
    else
    dspl_Clear(0, 160-pheader->balloonspeed,120,160);
    
    cursor_resume(pheader,pscreenbuffer);

}

/*************************************************************************************
  :balloonheadinitial
  :˺ʾ꣬ҪӦе
         ʾȫtimercbд˼¼һλ
         ĻݾͷǳбҪ
  *************************************************************************************/
void showcursor(char * pscreenbuffer)
{
   static U16 nextx,nexty;
   U32 pixcolor,oldcolor;
   game_Line cursorline1,cursorline2;
   U8 umode;


   if(lcdischange==0&&winfocusout==0)
	dspl_BitBlt(nextx,nexty,CURSORSIZE,CURSORSIZE,0,(void *)pscreenbuffer, 0);
   else
   	{     
   clear_remain(pscreenbuffer,nextx,nexty); 
      lcdischange=0;
   	}
   
   nextx=cursor.xposition-CURSORWIDTH;
   nexty=cursor.yposition-CURSORWIDTH;
   
   dspl_getscreen(nextx,nexty,CURSORSIZE,CURSORSIZE, pscreenbuffer);
 
   pixcolor=*(U16 *)(pscreenbuffer+CURSORSIZE*CURSORSIZE);

   cursorline1.x1=cursor.xposition-CURSORWIDTH;
   cursorline1.x2=cursor.xposition+CURSORWIDTH;
   cursorline1.y1=cursorline1.y2=cursor.yposition;
   cursorline1.color=0x0;//(~pixcolor)&0x00ffffff; 

   cursorline2.y1=cursor.yposition-CURSORWIDTH;
   cursorline2.y2=cursor.yposition+CURSORWIDTH;
   cursorline2.x1=cursorline2.x2=cursor.xposition;
   cursorline2.color=0x0;//(~pixcolor)&0xffff;

   umode=dspl_Enable(0);
   DrawLine(cursorline1);
   DrawLine(cursorline2);
   dspl_Enable(umode);
}

/*************************************************************************************
  :clear_remain
  :  򣬻ˢµʱˢµ
           ͱ뿼ˢµĴСget_freshsize
  *************************************************************************************/
void clear_remain(char *pscreenbuffer,U16 xposition,U16 yposition)
{
U16 remainmask[CURSORSIZE][CURSORSIZE],i,j,umode;

memset(&remainmask[0][0],0x0000,(CURSORSIZE*CURSORSIZE)*sizeof(U16)); 

switch(lcdischange)
{
   case 1:// x-  y-
    	for(i=freshheight;i<CURSORSIZE;i++)
  	       for(j=freshwidth;j<CURSORSIZE;j++)
  			{
  			#ifdef BALLOONDEBUG
            zgzTraceDataFunc("clear_remain1 i", (U16)i);
            zgzTraceDataFunc("clear_remain1 j", (U16)j);
            #endif
  			remainmask[i][j]=0xffff;
  			}  	  
   	  break;
   case 2:  //x-  y+
      for(i=0;(i<freshheight)&&(i<CURSORSIZE);i++)
	  	for(j=freshwidth;j<CURSORSIZE;j++)
	  		{
	  		#ifdef BALLOONDEBUG
	  		zgzTraceDataFunc("clear_remain2 i", (U16)i);
            zgzTraceDataFunc("clear_remain2 j", (U16)j);
            #endif
	  		remainmask[i][j]=0xffff;
	  		}
   	  break;
   case 3:  //x+ y-
   	    for(i=freshheight;i<CURSORSIZE;i++)
  		 for(j=0;(j<freshwidth)&&(j<CURSORSIZE);j++)
  			{
  			#ifdef BALLOONDEBUG
  			zgzTraceDataFunc("clear_remain3 i", (U16)i);
            zgzTraceDataFunc("clear_remain3 j", (U16)j);
            #endif
  			remainmask[i][j]=0xffff;
  			}
   	  break;
   case 4:  // x+ y+
   	   for(i=0;(i<freshheight)&&(i<CURSORSIZE);i++)
    		for(j=0;(j<freshwidth)&&(j<CURSORSIZE);j++)
  			{
  			#ifdef BALLOONDEBUG
  			zgzTraceDataFunc("clear_remain4 i", (U16)i);
            zgzTraceDataFunc("clear_remain4 j", (U16)j);
            #endif
  			remainmask[i][j]=0xffff;
  			}
   	  break;
   default:
      break;
}

#ifdef BALLOONDEBUG
TraceMMIValue("clear_remain freshwidth", (int)freshwidth);
TraceMMIValue("clear_remain freshheight", (int)freshheight);
zgzTraceDataFunc("clear_remain freshwidth", (U16)freshwidth);
zgzTraceDataFunc("clear_remain freshheight", (U16)freshheight);
for(i=0;i<CURSORSIZE;i++)
	for(j=0;j<CURSORSIZE;j++)
		{
		zgzTraceDataFunc("clear_remain remainmask", (U16)remainmask[i][j]);
		}
#endif

umode=dspl_Enable(0);
dspl_BitBlt(xposition, yposition, CURSORSIZE, CURSORSIZE, 0, (void *)pscreenbuffer, DSPL_BMPXOR);
dspl_BitBlt(xposition, yposition, CURSORSIZE, CURSORSIZE, 0, (void *)&remainmask[0][0],DSPL_BMPAND);
dspl_BitBlt(xposition, yposition, CURSORSIZE, CURSORSIZE, 0, (void *)pscreenbuffer, DSPL_BMPXOR);
dspl_Enable(umode);
}
/*************************************************************************************
  :balloondisplay
  :˺ʾ͸λͼ
         ʾλ
         
  *************************************************************************************/
void balloondisplay(BalloonItem *tempballoon)
{

U16 xposition,yposition,height,width;
char * balloonaddr,*balloonmaskaddr;
Balloon_Property balloon;

balloon=balloonproperty[tempballoon->balloontype];
xposition=tempballoon->xposition;
yposition=tempballoon->yposition;
height=2*(balloon.height);

balloonaddr=balloonaddresses[tempballoon->balloontype];
dspl_BitBlt(xposition, yposition, height, height, 0, (void *)balloonaddr, 0);

if(cursor.yposition>120)
lcdischange=get_freshsize(xposition,yposition,height,height);
#ifdef BALLOONDEBUG
zgzTraceDataFunc("balloondisplay lcdischange", (U16)lcdischange);
#endif
}


/*************************************************************************************
  :mvoe_memory
  : ݵǰļĻn
  *************************************************************************************/
void mvoe_memory(BalloonItemHeader *pheader)
{

dspl_move_lcdbuffer(pheader->balloonspeed);

}
/*****************************ͼص*****************************************/
/*************************************************************************************
  :balloonheadinitial
  :еyϵspeedҵmoveoutsideж
         ǲѾƳĻ
  *************************************************************************************/
void Set_Bs_Btimer(BalloonItemHeader* pheader,Balloon_Speed currentlevel)
{
T_MFW_HND       win  = mfw_parent (mfw_header());
T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
Balloon_Game         * data = (Balloon_Game *)win_data->user;
    
if(currentlevel>=SpeedMax)
{
MmiTrace("erro");
return;
}
switch(currentlevel)
{
    case SpeedOne://timer=200
    	 pheader->balloonspeed=2;
    	 timSetTime(data->bltimer,balloontimer3);
         break;
    case SpeedTwo:
    	 pheader->balloonspeed=3;
    	 timSetTime(data->bltimer,balloontimer3);
    	 break;
    case SpeedThree:
    	 pheader->balloonspeed=4;
    	 timSetTime(data->bltimer,balloontimer3);
    	 break;
    case SpeedFour://timer=100
    	 pheader->balloonspeed=2;
       	 timSetTime(data->bltimer,balloontimer1);
         break;
    case SpeedFive://timer=150
    	 pheader->balloonspeed=3;
    	 timSetTime(data->bltimer,balloontimer2); 
    	 break;
    case SpeedSix:
    	 pheader->balloonspeed=4;
    	 timSetTime(data->bltimer,balloontimer2); 
    	 break;
    case SpeedSeven://timer=100
    	 pheader->balloonspeed=3;
    	timSetTime(data->bltimer,balloontimer1); 
    	 break;
    case SpeedEight:
    	 pheader->balloonspeed=4;
    	timSetTime(data->bltimer,balloontimer1); 
    	 break;
    case SpeedNine:
    	 pheader->balloonspeed=5;
    	timSetTime(data->bltimer,balloontimer1); 
    	 break;
    default: break;
}

}
/*************************************************************************************
  :balloonheadinitial
  :еyϵspeedҵmoveoutsideж
         ǲѾƳĻ
  *************************************************************************************/
void balloonrise(BalloonItemHeader *pheader)
{
  BalloonItem *tempballoon;
 tempballoon=pheader->pfirst;

// TRACE_EVENT("ballloonrise");
 while(tempballoon->balloonnext)
 	{
 	tempballoon=tempballoon->balloonnext;

 		tempballoon->yposition=tempballoon->yposition-tempballoon->speed;
 		#ifdef BALLOONDEBUG
 		zgzTraceDataFunc("balloonrise yposition", (U16)tempballoon->yposition);
 		#endif
 	}
  if(moveoutside(pheader))
  removeelement(pheader);
}

/*************************************************************************************
  :balloonheadinitial
  :˺ȷx꣬
         ɵ0100֮䡣һ
         ĺ15 жһĺ
         60Ǿͷһȥ40ͼ40
  *************************************************************************************/
U16 randomxpositioncreate(BalloonItemHeader *pheader)
{
    U16 random,pre1xpos,pre2xpos,smallerx,lagerx;
    short int tempint;
    BalloonItem * temp=pheader->plast;

    
//ķֵ
    if(pheader->ballooncount<1)
    	{
    	  random=rand();
          random=random%96;
          return random;
    	}
    if(pheader->ballooncount<2)
    	{
    	  random=rand();
          random=random%24+24;
          pre1xpos=temp->xposition;
          return (((pre1xpos-48)>=0)?(pre1xpos-random):(pre1xpos+random));
    	}

    temp=pheader->pfirst;
    
    while(temp->balloonnext)
 	{
 	pre2xpos=temp->xposition;
 	temp=temp->balloonnext;
    pre1xpos=temp->xposition;
    }
    
    #ifdef BALLOONDEBUG
    zgzTraceDataFunc("randomxpositioncreate pre2xpos", (U16)pre2xpos);
    zgzTraceDataFunc("randomxpositioncreate pre1xpos", (U16)pre1xpos);
    #endif
    
    tempint=abs(pre2xpos-pre1xpos)-48;
  
    if((tempint>0)&&(tempint<49))
    	{
    	random=rand();
        random=random%tempint+24;
        #ifdef BALLOONDEBUG
        zgzTraceDataFunc("randomxpositioncreate random1", (U16)random);
        #endif
        return SMALLER(pre1xpos,pre2xpos)+random;
    	}
    if(tempint==0)
    	return  SMALLER(pre1xpos,pre2xpos)+24;

    smallerx=SMALLER(pre1xpos,pre2xpos);
    lagerx=96-LAGER(pre1xpos,pre2xpos);
 //   zgzTraceDataFunc("randomxpositioncreate smallerx", (U16)smallerx);
  //  zgzTraceDataFunc("randomxpositioncreate lagerx", (U16)lagerx);
    if(smallerx>=lagerx)
    	{
    	tempint=smallerx-24;
    	random=rand();
        random=random%tempint;
        #ifdef BALLOONDEBUG
        zgzTraceDataFunc("randomxpositioncreate random2", (U16)tempint);
        #endif
        return random;
    	}
    else
    	{
    	tempint=lagerx-24;
    	random=rand();
        random=random%tempint+24;
        #ifdef BALLOONDEBUG
         zgzTraceDataFunc("randomxpositioncreate random3", (U16)random);
        #endif
     //    ﲻ72 random Ӧlagerx
        lagerx=LAGER(pre1xpos,pre2xpos);
        return lagerx+random;
    	}
    
     return 0;
     
}

/*************************************************************************************
  :balloonheadinitial
  :˺ȷ,ܹ8*2 /2
         ֹͣ*2 /2 sֻһ
         Ĺ
         (1) ܹ33е÷ָָһ
         (2) ǰ15в/2 *2 s 5
             ܳ3
         (3) 18пԴ͵Ǳ
            1
  *************************************************************************************/
U16 randomtypecreate(BalloonItemHeader *pheader)
{
    U8 random,i,j;
    BalloonTotal * balloontotal=pheader->balloontotal;

    random=rand();
   // random=random%8;
  //Ҫǰ15вstopmuldiv
  //5ܳ3 	
    if(balloontotal->countall<16)
    	{
    	  	random=random%5;
    	  if(balloontotal->btcount[random]<2)
    	  	//2Ҫһ͡
    	  	return random;
    	  else
    	  	{
    	  	  for(i=random+1;i<random+6;i++)
    	  	  	{      	  	  	
    	  	  		j=i%5;  	  	  	  
    	  	  	if(balloontotal->btcount[j]<4)
    	  	  		return j;
    	  	  	}   	  	  	
    	  	}
    	}
//15֮* / sֻܸ1
   if(balloontotal->countall>15)
    	{
    		random=random%8;
    	  for(i=random;i<random+8;i++)
    	  	 {
    	  	    j=i%8;
    	  	    
    	  	  	if(j==5)
    	  	  		{
    	  	  		if(balloontotal->btcount[5]==1)
    	  	  	   	   continue;
    	  	  	       else return j;
    	  	  		}
    	  	    if(j==6)
    	  	    	{
    	  	    	if(balloontotal->btcount[6]==1)
    	  	  	       continue;
    	  	  	      else return j;
    	  	    	}
    	  	  	if(j==7)
    	  	  		{
    	  	  		if(balloontotal->btcount[7]==1)
    	  	  	       continue;
    	  	  	      else return j;
    	  	  		}
    	  	  	
    	  	  if(balloontotal->btcount[j]<6)
   //6Ҫһ͡
    	        	return j;
    	            else
    	        	{
    //j=4Ͳ,ͻᴴ/2
    	          if(j==4)
    	         	continue;
    	  	    	 if(balloontotal->btcount[j+1]<6)
    	  	  	   	return j+1;
    	  	     	}
    	  	}
    	}
    
    return 2;
}

/*************************************************************************************
  :balloonheadinitial
  :ڼͶӦÿ
  *************************************************************************************/
void countballoontotal(BalloonItemHeader *pheader)
{
    BalloonItem *lastballoon=pheader->plast;
    BalloonTotal *balloontotal=pheader->balloontotal;

    if(lastballoon->balloontype!=10)
    	{
    	balloontotal->countall++;
    	balloontotal->btcount[lastballoon->balloontype]+=1;
    	}
}

/*************************************************************************************
  :newballoon
  :˺жʲôʱҪһµ
         漰ѶƲҪĻķֲ
***************************************************************************************/
void newballoon(BalloonItemHeader * pheader)
{
     static U16 timelevel;
     short ymin;
     BalloonTotal *balloontotal=pheader->balloontotal;

     if(balloontotal->countall>32)
     	return;
     	
     if(pheader->ballooncount<18)
     	{
        if(pheader->ballooncount==0)
        	{
     	       addballoonitem(pheader);  
              return;
        	}
        
        //ȡyֵ
        ymin=getballoonymin(pheader);
        
        #ifdef BALLOONDEBUG
        zgzTraceDataFunc("newballoon ymin", (U16)ymin);
        #endif
        
        //0,һڴλ
        //Ҫ9صľ
        ymin=CURSORYMAX-ymin;
         if((ymin>=36)&&(ymin<160))
    	  addballoonitem(pheader);
    	}
}

/*************************************************************************************
  :balloonheadinitial
  :˺ڷСyminûͷ120
  *************************************************************************************/
U16 getballoonymin(BalloonItemHeader * pheader)
{
   U16 ymin=CURSORYMIN;
   BalloonItem * tempballoon=pheader->pfirst;

   if(pheader->ballooncount==0)
   	return CURSORYMAX-ymin;

   while(tempballoon)
   	{
    tempballoon=tempballoon->balloonnext;
    if(tempballoon)
    	{
         if(ymin<tempballoon->yposition)
   	      ymin=tempballoon->yposition;
   	    }
   	}
   return ymin;
}

/*************************************************************************************
  :balloonheadinitial
  :˺ôµԪزҵballoonrise,ˢlcd 
         stopͲߴµ
  ע:һtimelevelĵĲҪΪѶõ       
  *************************************************************************************/
void ypositionadd(BalloonItemHeader * pheader,char *pscreenbuffer)
{
   static U16 calculagraph;
   U16 timelevel;
      calculagraph++;
      timelevel=settimelevel();

      if(pheader->fireflag&&timestoped)                              /* if 's' is hit and other balloon is hit				*/
    	{      	
     	gameinterfaceshow(pheader,pscreenbuffer);
     	pheader->fireflag=0;
     	}
     	
      if(pheader->ballooncount==0)                                     /*  there is no balloon on screen 					*/
      	timelevel=0;
      
      if(calculagraph>timelevel)							
      	calculagraph=0;
      
      if(calculagraph==timelevel)
    	{
    	timestoped=0;   	
      	calculagraph=0;   
        gameinterfaceshow(pheader,pscreenbuffer);	
     	}     
      
        if(calculagraph==0)
      	{
      	newballoon(pheader);	
      	}
      	
      
}

/*************************************************************************************
  :balloonheadinitial
  : Ϸܹ9
          ô˵ÿνtimercbеҪ
          żôƽνtimercbе
          һ
  *************************************************************************************/
U16 settimelevel(void)
{
    if(timestoped==1)
    	return 100;
    	
    	return 1;
}

/*************************************************************************************
  :balloonheadinitial
  :
  *************************************************************************************/
void movecursorquik(BalloonItemHeader * pheader)
{
  static U8 bmtimecount;
  
  movecursor(pheader);
  if(bmtimecount==pheader->keycode+1)
    movecursor(pheader);
  else
	bmtimecount=pheader->keycode+1;

}

/*************************************************************************************
  :balloonheadinitial
  :˺ƶÿƶ5
  *************************************************************************************/
void movecursor(BalloonItemHeader * pheader)
{
   switch(pheader->keycode)
   	{
   	case 0:
   		break;
   	case 1:
   		if(cursor.xposition>CURSORXMIN+CURSORSIZE)
   		cursor.xposition=cursor.xposition-CURSORSPEED;
   		break;
   	case 2:
   		if(cursor.xposition<CURSORXMAX-CURSORSIZE)
   		cursor.xposition=cursor.xposition+CURSORSPEED;
   		break;
   	case 3:	
   		if(cursor.yposition>CURSORYMIN+CURSORSIZE)
   		cursor.yposition=cursor.yposition-CURSORSPEED;
   		break;
   	case 4:
   		if(cursor.yposition<CURSORYMAX-CURSORSIZE)
   	    cursor.yposition=cursor.yposition+CURSORSPEED;
   		break;	
   	case 5:
   	default:
   		break;
   		
   	}
}

/*************************************************************************************
* :balloonheadinitial
* :˺shortinsideҵcountscore
         
*************************************************************************************/
int gunshort(BalloonItemHeader *pheader)
{
    BalloonItem *tempballoon;
    U8 scoreflag=0;
        
  // TRACE_EVENT ("gunshort()");

    tempballoon=pheader->pfirst;
   
    while(tempballoon->balloonnext)
    	{
    	tempballoon=tempballoon->balloonnext;
    	if(tempballoon){
    	shortinside(tempballoon); 
    	
    	if(tempballoon->flag==1)
    		{
    		scoreflag++;
    		countscore(pheader, tempballoon,scoreflag);
    		}
    	}
    	}
    return scoreflag;
}

/*************************************************************************************
  :balloonheadinitial
  :˺жǷжϵķʽԲΪ
         жϵķ
  *************************************************************************************/
int shortinside(BalloonItem *balloon)
{
    U16 width,height,radius;
    Balloon_Property tempballoon;
    
    #ifdef BALLOONDEBUG
    TRACE_EVENT ("shorinside()");
    #endif
    
    if(balloon->flag==2)
    	return;

    tempballoon=balloonproperty[balloon->balloontype];
    radius=tempballoon.height;
    
    width=abs(cursor.xposition-(balloon->xposition+radius));
    height=abs(cursor.yposition-(balloon->yposition+radius));

    if(radius*radius>(width*width+height*height))
    	{
        	balloon->flag=1;
        	
    	}
 
}

/*************************************************************************************
  :balloonheadinitial
  :˺жǲƳ
  *************************************************************************************/
int moveoutside(BalloonItemHeader *pheader)
{
 int moveout;
 BalloonItem *tempballoon;

 tempballoon=pheader->pfirst;
 moveout=0;
 
 while(tempballoon->balloonnext)
 	{
 	tempballoon=tempballoon->balloonnext;
 	#ifdef BALLOONDEBUG
 	zgzTraceDataFunc("moveoutside yposition", (U16)tempballoon->yposition);
 	#endif
 	if(judgeoutside(tempballoon))
 		moveout++;
 	}
 return moveout;
}

/*************************************************************************************
  :judgeoutside
  :жǲѾƳ⣬С0
         ߴ140 Ǿ˵Ѿˣ趨־flagΪ2
  ע:ypositionusigned ͣypositionС0ʵжϵʱ
         140 С0
  *************************************************************************************/
int judgeoutside(BalloonItem *balloon)
{
   U8 balloonsize;

   balloonsize=balloonproperty[balloon->balloontype].height*2;
   
   if((balloon->yposition+balloonsize)<=CURSORYMIN)
   	{
   	balloon->flag=2;
   	return 1;
   	}
   return 0;
}

/*************************************************************************************
  :judgeoutside
  :ڼ㵱ֵĵ÷
  *************************************************************************************/
void countscore(BalloonItemHeader *pheader,BalloonItem *tempballoon,U8 scoreflag)
{

U32 score;


score=pheader->score;
if(tempballoon->balloontype==7)
{//stop
    pheader->hitcount[7]=1;
    timestoped=1;
    return;
}
if(tempballoon->balloontype==6)
	//г2
{
  pheader->hitcount[6]=1;
  pheader->score=score/2;
  return;
}
if(tempballoon->balloontype==5)
{//г2 
  pheader->hitcount[5]=1;
  pheader->score=score*2;
  return;
}
if(scoreflag==1)
{
//һ
 pheader->score =score+balloonproperty[tempballoon->balloontype].score;
 pheader->hitcount[tempballoon->balloontype]++;
}
if(scoreflag>1)
{
//һǹ
  pheader->score =score+balloonproperty[tempballoon->balloontype].score+10;
}
}

/*************************************************************************************
  :get_freshsize
  :򱻻лˢµʱغ
         ҪˢµĴСֳ4
         1Ͻ lcdischange=1
         2½мұlcdischange=4
         3Ϸlcdischange=3
         4lcdischange=2
**************************************************************************************/
U8  get_freshsize(U16 xposition,U16 yposition,U16 height,U16 width)
{
U16 cxposition,cyposition;

cxposition=cursor.xposition-CURSORWIDTH;
cyposition=cursor.yposition-CURSORWIDTH;
//freshwidth=freshheight=0;
#ifdef BALLOONDEBUG
zgzTraceDataFunc("get_freshsize xposition", (U16)xposition);
zgzTraceDataFunc("get_freshsize yposition", (U16)yposition);
zgzTraceDataFunc("get_freshsize cxposition", (U16)cxposition);
zgzTraceDataFunc("get_freshsize cyposition", (U16)cyposition);
zgzTraceDataFunc("get_freshsize height", (U16)height);
#endif

if(((xposition-CURSORSIZE)<(cxposition))&&(cxposition<(xposition+width)))
{
 if(((yposition-CURSORSIZE)<cyposition)&&(cyposition<(yposition+height)))
 	{
 	  if(cxposition<xposition)
 	  	{
 		   freshwidth=xposition-cxposition; 	
 	    if(cyposition<yposition)
 	    	{
 	    	lcdischange=1;//- -
 		    freshheight=yposition-cyposition;
 	    	}
 	    	else
 		    {
 	    	lcdischange=2;//- +
 	    	freshheight=SMALLER(CURSORSIZE, (yposition+height-cyposition));
 	    	} 		
 	  	}
 	  else
    	  	{
    	  	freshwidth=SMALLER(CURSORSIZE, (xposition+width-cxposition));
    	  	if(cyposition<yposition)
 	    	{
 	    	lcdischange=3;//+ -
 		    freshheight=yposition-cyposition;
 	    	}
 	    	else
 		    {
 	    	lcdischange=4;//+ +
 	    	freshheight=SMALLER(CURSORSIZE, (yposition+height-cyposition));
 	    	} 		
    	  	}

 	//if((freshheight==CURSORSIZE)||(freshwidth==CURSORSIZE))
 	#ifdef BALLOONDEBUG
 	   TraceMMIValue("get_freshsize freshwidth", (int)freshwidth);
 	   TraceMMIValue("get_freshsize freshheight", (int)freshheight);
 	   zgzTraceDataFunc("get_freshsize freshwidth", (U16)freshwidth);
 	   zgzTraceDataFunc("get_freshsize freshheight", (U16)freshheight);
 	#endif
 	}
}
/*÷ֵlcdischangeһССbug
ܽ*/
//return 0;
return lcdischange;
}

void balloon_help(void)
{
U32 oldcolor;

oldcolor = dspl_SetBkgColor(0xF6F2CD);
dspl_fill_rectangle(0, 0, 120, 160);
dspl_DrawLine(0,0,0,160);
dspl_SetBkgColor(oldcolor);

dspl_BitBlt(0,0,120,18,0,(void*)gameTitle,0);
drawcolorclarity(44, 1, (char *)gameexplain,0xffffff);
//draw3dbutton(0,0,119,21,(char *)gameexplain,0x80ff,1);

dspl_TextOut(0, HELPDISPLAY,DSPL_TXTATTR_TRANSPARENT, (char *)balloonhelp1);
dspl_TextOut(0,HELPDISPLAY+ 18,DSPL_TXTATTR_TRANSPARENT, (char *)balloonhelp2);
dspl_TextOut(0,HELPDISPLAY+ 41,DSPL_TXTATTR_TRANSPARENT, (char *)publichelp1);
dspl_TextOut(0,HELPDISPLAY+ 59,DSPL_TXTATTR_TRANSPARENT, (char *)publichelp2);
dspl_TextOut(0,HELPDISPLAY+ 77,DSPL_TXTATTR_TRANSPARENT, (char *)publichelp3);
dspl_TextOut(0,HELPDISPLAY+ 95,DSPL_TXTATTR_TRANSPARENT, (char *)publichelp4);

}

void Show_Hitin(BalloonItemHeader *pheader)
{
U8 i,hitnum[7];
char * balloonaddr;
Balloon_Property balloon;


memset(hitnum,0,7*sizeof(char));
for(i=0;i<8;i++)
{
balloon=balloonproperty[i];
balloonaddr=balloonaddresses[i];
if(i<4)
{
dspl_BitBlt(60*(i/4)+7, (i%4)*25+5, 2*balloon.height, 2*balloon.height, 0, balloonaddr, 0);
hitnum[0]=pheader->hitcount[i]+48;
drawcolorclarity(60*(i/4)+37, (i%4)*25+5,(char*)hitnum,0x0);
}
else
{
  if(i==4)
  	{
  	 dspl_BitBlt(67, 80, 2*balloon.height, 2*balloon.height, 0, balloonaddr, 0);
        hitnum[0]=pheader->hitcount[i]+48;
        drawcolorclarity(97, 80, (char*)hitnum,0x0);
     }
 if(i==5)
  	{
  	dspl_BitBlt(67, 5, 2*balloon.height, 2*balloon.height, 0, balloonaddr, 0);
    hitnum[0]=pheader->hitcount[i]+48;
    drawcolorclarity(97, 5,(char*)hitnum,0x0);
    }
  if(i==6)
  	{
  	dspl_BitBlt(67, 55, 2*balloon.height, 2*balloon.height, 0, balloonaddr, 0);
    hitnum[0]=pheader->hitcount[i]+48;
    drawcolorclarity(97, 55,(char*)hitnum,0x0);
  	}
  if(i==7)
  	{
  	dspl_BitBlt(67, 30, 2*balloon.height, 2*balloon.height, 0, balloonaddr, 0);
    hitnum[0]=pheader->hitcount[i]+48;
    drawcolorclarity(97, 30,(char*)hitnum,0x0);
    }
   
}
}

Print_Number((char*)hitnum,7,(U32)pheader->score);
drawcolorclarity(7,108,(void *)result,0x0);
drawcolorclarity(67,108,(void *)hitnum,0x0);

Print_Number((char*)hitnum,7,(U32)totalscore);
drawcolorclarity(7,126,(void *)zongfen,0x0);
drawcolorclarity(67,126,(void *)hitnum,0x0);

dsplsoftkey(TxtGameGoon, TxtGameExit);
}

void Show_Socre(BalloonItemHeader *pheader)
{
U8 i,j;
char scoretemp[7],temp[2];
U32 oldcolor;



oldcolor = dspl_SetBkgColor(0xF6F2CD);
dspl_fill_rectangle(0, 0, 120, 160);
dspl_DrawLine(0,0,0,160);
dspl_SetBkgColor(oldcolor);

if(winfocusout==0 && l_mode==BALLOONWIN)
{
for(i=0;i<5;i++)
{
  if(totalscore>Blloon_Score->score[i])
  {
 	 for(j=4;j>i;j--)
	{
	Blloon_Score->score[j]=Blloon_Score->score[j-1];
	}
	Blloon_Score->score[i]=totalscore;
	break;
}
}

if(i<5)
{
oldcolor = dspl_SetBkgColor(0xffffff);
dspl_fill_rectangle(0,i*20+22 ,119,i*20+38);
dspl_SetBkgColor(oldcolor);
}

}


dspl_BitBlt(0,0,120,18,0,(void*)gameTitle,0);
drawcolorclarity(36, 1, (char *)jifenbang,0xffffff);


for(j=0;j<5;j++)
{
temp[0]=0;
temp[1]=0;
temp[0]=j+49;

drawcolorclarity(15,j*20+22,(char *)temp,0x0);
Print_Number((char*)scoretemp,7,(U32)Blloon_Score->score[j]);
drawcolorclarity(75,j*20+22,(char *)scoretemp,0x0);
}

if(l_mode==BALLOONWIN)
{
oldcolor = dspl_SetBkgColor(0xffffff);
dspl_fill_rectangle(0,121,119,138);
dspl_SetBkgColor(oldcolor);

memset(scoretemp,0,7*sizeof(char));
Print_Number((char*)scoretemp,7,(U32)totalscore);
drawcolorclarity(15,122,(void *)zongfen,0x0);
drawcolorclarity(75,122,(char *)scoretemp,0x0);

dsplsoftkey(TxtGameRestart, TxtGameExit);
}
else
dsplsoftkey(TxtSoftClearall, TxtSoftBack);

}

void Balloon_Mnushow()
{
static U8 bmpnum;


if(bmpnum==1)
{
bmpnum=0;
	dspl_BitBlt(0,0,120,78,0,(void*)balloon_mnubmp1,0);
}
else
{
bmpnum=1;
       dspl_BitBlt(0,0,120,78,0,(void*)balloon_mnubmp1,0);
	dspl_BitBlt(21,1,36,40,0,(void*)balloon_mnubmp2,0);

}

dspl_BitBlt(0,78,120,82,0,(void*)game_mnubmp,0);

}

