#ifndef _AUTOGEN_RESOURCE_HEADER_H_
#define _AUTOGEN_RESOURCE_HEADER_H_ 1
//
/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Resource Manager
 $File:		    MmiBlkLanfDB.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    This file contains the basic resource manager information relating
	to the textual entries managed.

    There are two routines provided by this module, one returning the
	number of resource tables supported, the other giving the base address
	of the resource tables.

    This module is derived from an auto generated version of the file with
	additional commenting added.
                        
********************************************************************************
 $History: MmiBlkLangDB.h
    Date .................. Modification ......................................	
	25/10/00			Original Condat(UK) BMI version.	
    01/08/02      version 0.100 zy add "TxtAddNewCall,TxtEndOne"two words for call menu	   
    04/08/02      version 0.101 zy add settings related words
    09/08/02      version 0.102 windy modified
    15/08/02      version 0.103 gdy modified
    16/08/02      version 0.104 tangyan modified
    19/08/02      version 0.105 wangxia modified
    20/08/02      version 0.106 fzq modified
  26/08/02		hxl add for charger
     29/08/02     xsf add for hostkey and pins
 $End

*******************************************************************************/



/*******************************************************************************
                                                                              
                                Required Include Files
                                                                              
*******************************************************************************/

#include "mfw_lng.h"
#include "mmiQQSwitch.h" //hxl add for check qq func



/* The tPointerStructure provides the basic entry type for the resource
   tables indicated below.

   The structure provides a simple one-to-one mapping between the identifier
   and it's associated text string.
*/
typedef struct _tPointerStructure_
{
    long int Id;
    char *Text;
} tPointerStructure, *pPointerStructure;


/*******************************************************************************
                                                                              
                                Public Definitions
                                                                              
*******************************************************************************/

typedef enum     {
	TxtNull = 0,
   	TxtNotImplemented,
    TxtManu,
    TxtEnterPin1,
    TxtEnterPin2,
    TxtEnterPuk1,
    TxtEnterPuk2,
    TxtInvalidCard, 
    TxtNoCard,
    TxtSoftCall,
    TxtSoftOK,
    TxtSoftMenu,
    TxtHelp,
    TxtSoftContacts,
    TxtPlay,
    TxtMessages,
    TxtAlarm,
    TxtAlarmPrompt,  //xsf add for environment set 2002.09.24
    TxtSettings,
    TxtExtra, 
    TxtSend, 
    TxtSent,
    TxtNotSent, 
    TxtServiceCentre, 
    TxtPleaseWait,
    TxtSmsEnterNumber, 
    TxtRead, 
    TxtDeleteAll, 
    TxtSave,
    TxtVoicemail,
    TxtBroadcast, 
    TxtNew, 
    TxtDigits, 
    TxtLowercase, 
    TxtUppercase, 
    TxtApplications, 
    TxtVoiceMemo, 
    TxtSim,
    TxtSimNot, 
    TxtNotReady, 
    TxtSmsListFull,
    TxtNewCbMessage, 
    TxtSaved,
    TxtDelete, 
    TxtReply, 
    TxtStoreNumber,
    TxtForward,
    TxtActivate, 
    TxtTopics,
    TxtConsult,
    TxtAddNew, 
    TxtContacts, 
    TxtSearchName, 
    TxtMemory, 
    TxtRinger,
    TxtVolume,
    TxtRingVolume,  //xsf add 2002.08.28 2 lines
    TxtAlarmVolume, 
    TxtSpeakerVolume,  //xsf add 2002.08.30
    TxtKeypadTones,
    TxtNewMessage, 
    TxtNewBroadcast, 
    TxtAutoAnswer, 
    TxtTimeDate, 
    TxtLanguages, 
    TxtPinCode, 
    TxtAutoredial,
    TxtDTMF, 
    TxtOn,
    TxtOff,
    TxtNetworkSel, 
    TxtSendID,
    TxtChargeTimers,
    TxtCallDivert,
    TxtDateTime,	//sunsj030918
    TxtCallWaiting,
    TxtIfBusy,
    TxtIfNoAnswer,
    TxtIfNotReachable, 
    TxtAllCalls,
    TxtCancelAll,
    TxtAll,
    TxtVoice,
    TxtFax,
    TxtData,
    TxtStatus,
    TxtCancel,
    TxtCalculator,
    TxtSoftBack,
    TxtSoftSelect,
    TxtSoftConfirm,
    TxtSoftOptions,
    TxtEmptyList,
    TxtSendMessage,
    TxtChange,
    TxtWriteError,
    TxtEntryDeleted,
    TxtDetails,
    TxtHold,
    TxtUnhold,
    TxtMute,
    TxtSendDTMF,
    TxtMainMenu,
    TxtSwap,
    TxtEndAll,
    TxtPrivateCall,
    TxtStartConference,
    TxtReStartConference,
    TxtFind,
    TxtServiceNumbers,
    TxtOutofRange,
    TxtDone,
    TxtFailed,
    TxtEnterNewPin,
    TxtConfPin,
    TxtChangPin,
    TxtEnd,
    TxtPINFail,
    TxtSOS,
    TxtAutomatic,
    TxtManual,
    TxtFixedNames,
    TxtFactoryReset,
    TxtSearching,
    TxtChangPIN2, 
    TxtOldPIN,
    TxtOldPIN2, 
    TxtNotAcc, 
    TxtEnabled,
    TxtDisabled, 
    TxtPINOK,
    TxtSimBlocked,
    TxtNewPIN,
    TxtAcc,
    TxtNoNetwork,
    TxtNo,
    TxtEnterDate,
    TxtEnterTime,
    TxtScratchPad,
    TxtDeleted,
    TxtActivated, 
    TxtDeActivated,
    TxtDeactivate,
    TxtCheck,
    TxtYes, 
    TxtCallNumber,
    TxtEnterMid,
    TxtReadError,
    TxtUsed,
    TxtOutgoing,
    TxtMuted,
    TxtCallEnded,
    TxtIncomingCall,
    TxtIncomingData,
  	TxtIncomingFax, //SPR#1147 - DS - Added string to lang table.
    TxtNumberWithheld,
    TxtAccept,
    TxtReject,
    TxtCalling,
    TxtWaitingAnswer,   
    TxtMissedCalls,
    TxtMissedCall,
    TxtCallSingle,
    TxtCallTwo,
    TxtCallPrivateCall,
    TxtCallConfernce,
    TxtCallSingleMultiparty,
    TxtCallMultipartySingle,
    TxtLocked,
    TxtUnmute,
    TxtNeedCharging,
    TxtCharging,
    TxtChargComplete,
	TxtNoPower,
	TxtSwitchOff,
    TxtOperationNotAvail,
    TxtNetUselessInCall,//zy 2003-04-07 add for call notavail failed
    TxtNetUselessCallAgain,
    TxtAddToConference,
    TxtEmpty,
    TxtSelectFromList,
    TxtEnterNetworkCode,
    TxtMCCMNC,
    TxtRecord,
    TxtSecurity,
    TxtEnglish,
    TxtGerman,
    TxtValidity,
    TxtMessageTyp,
    TxtSetVoiceMail,
    TxtCallTimers,
    TxtLastCharge,
    TxtTotalCharge,
    TxtResetCharge,
    TxtIfNoService,
    TxtDiscard,
    TxtEDIT,  
    TxtExtractNumber,
    TxtWrite, 
    TxtCheckStatus,
    TxtSetDivert,
    TxtCancelDivert,
    TxtHideID,
    TxtTones,
    TxtClock,
    TxtPhone, 
    TxtStop,
    TxtRecording,
    TxtPlaying,
    TxtPlayback,
    TxtNoNumber,
    TxtOkToDelete,
    TxtBalance,
    TxtLimit, 
    TxtLimitEq,
    TxtRate,
    TxtMinutes,
    TxtCost,
    TxtCredit, 
    TxtPressOk, 
    TxtReset,
    TxtIncoming,
    TxtCounter,
    TxtOutgoingCalls,
    TxtCostCounter,
    TxtEnterCurrency, 
    Txt1Unit,
    TxtChanged,
    TxtEnterLimit,
    TxtCancelled, 
    TxtView,
    TxtEnterPCK,
    TxtEnterCCK,
    TxtEnterNCK,
    TxtEnterNSCK,
    TxtEnterSPCK, 
    TxtCodeInc,
    TxtPuk1Inc,
    TxtChangeFail,
    TxtBlckPerm,
    TxtDealer,
    TxtSendingDTMF,
    TxtCheckNumber,
    TxtNumberBusy,
    TxtNoAnswer, 
    TxtNumberChanged,
    TxtNetworkBusy,
    TxtNotSubscribed, 
    TxtAnyKeyAnswer,
    TxtPINBlock,
    TxtEdit,
    TxtChangePassword,
    TxtSetBar,
    TxtSmsTone,
    TxtSmsVolume,
    TxtKeypadToneVolume,		/* 2003/12/08 sunsj */
    TxtKeypadToneRing,			/* 2003/12/08 sunsj */
    TxtKeypadToneSpecialRing,	/* 2003/12/08 sunsj */
    TxtMelody,
    TxtSilent,
    TxtClick,
    TxtClearAlarm,
    TxtTimeFormat,	
    TxtTwelveHour,
    TxtTwentyfourHour,
    TxtInCallTimer,
    TxtStore,
    TxtNone,
    TxtPIN,
    TxtPIN2, 
    TxtConfPin2,
    TxtNewPIN2, 
    TxtUnlockOK, 
    TxtIMEI, 
    TxtList, 
    TxtFull, 
    TxtCapacityFull,
    TxtNotAvailable, 
    TxtCallBAOC, 
    TxtCallBAOIC, 
    TxtCallBAOICexH, 
    TxtCallBAIC,
    TxtCallBAICroam, 
    TxtCallBarringAll,
    TxtCallBAOCAll,
    TxtCallBAICAll, 
    TxtCLIP, 
    TxtCOLP, 
    TxtCOLR, 
    TxtSimToolkit, 
    TxtRecentCalls, 
    TxtRecordName,//2004-04-06 Sunny add
    TxtInterCalls,
    TxtInterHome,
    TxtWhenRoaming,
    TxtCancelAllBars,
    TxtWaiting,
    TxtBarred, 
    TxtForwarded, 
    TxtCallDivertNoReach, 
    TxtCallDivertNoReply, 
    TxtCallDivertIfBusy, 
    TxtPressMenu, 
    TxtSending,
    TxtMessage,
    TxtSoftNext,
    TxtLastCall,
    TxtIncomingCalls,
    TxtLow,
    TxtMedium,
    TxtHigh,
    TxtIncreasing,
    TxtTimerReset, 
    TxtClockSetTo, 
    TxtSilentMode,
    TxtSmsValidityPeriodSet,
    Txt1Hour,
    Txt12Hours,
    Txt24Hours,
    Txt1Week,
    TxtPin2Code,
    TxtEnablePIN,
    TxtRequesting,
    TxtNotAllowed,
    TxtEmergency,
    TxtChinese,
    TxtPassword,
    TxtConfirmPassword,
    TxtNewPassword,
    TxtNoMessages,
    TxtTwoAttemptsLeft,
    TxtOneAttemptLeft,
    Txtblacklisted,
    TxtErrUnknown,
    TxtSSErr,
    TxtUnknownSub,
    TxtIllSub,
    TxtIllEqip,
    TxtIllOp,
    TxtSubVil,
    TxtInComp,
    TxtFacNoSup,
    TxtAbsSub,
    TxtSysFail,
    TxtMissDta,
    TxtUnexDta,
    TxtPwdErr,
    TxtUnkAlph,
    TxtMaxMpty,
    TxtResNoAvai,
    TxtUnRec,
    TxtMisTyp,
    TxtBadStruct,
    TxtDupInv,
    TxtResLim,
    TxtIniRel,
    TxtFatRes,
    TxtEntAnw,
    TxtSsMsg,
    TxtOld,
    TxtInsertnote, 
   	TxtMelodygenerator,
   	TxtOctaveHigher,
   	TxtOctaveLower,
   	TxtLoadMelody,
   	TxtEasyText,
   	TxtDataCount,
   	TxtQoS,
   	TxtTypeofConnection,
   	TxtTotalCount,
   	TxtResetCount,
   	TxtDataCounter,
   	TxtV42bis,
   	TxtNormal,
   	TxtCSD,
   	TxtClassB,
   	TxtClassC,
   	TxtIPAddress,
   	TxtIPAddress1,
   	TxtIPAddress2,
   	TxtPort1,
   	TxtPort2,
   	TxtAPN,
    TxtConnectionType, 
    TxtGPRS, 
    TxtGPRSInfo, //WUFEI APPEND
    TxtOutgoingData,
    TxtHomepage,
	TxtBookmarks,
    TxtGoTo,
    TxtHistory,
   	TxtSetup,
   	TxtNewBookmark,
   	TxtWWWdot,
   	TxtWAPdot,
   	TxtSMS,
   	TxtEmail,
   	TxtClear,
   	TxtBookmark,
   	TxtSelectProfile,
   	TxtSetupProfiles,
   	TxtSaveHistory,
   	TxtEditName,
   	TxtEditURL,
   	TxtAccessType,
   	TxtResponseTimer,
   	TxtDialupNumber,
   	TxtTemporary,
   	TxtContinuous,
   	TxtGPRSData,
   	TxtCSData,
   	TxtWAP,
   	TxtExit,
   	TxtReload,
   	TxtStored,
	TxtOther,
	TxtConnecting,
	TxtDownloading,
	TxtUpdating,
	TxtEnterURL,
	TxtProfileName,
    TxtISPUsername,
    TxtISPPassword,
    TxtGoToLink,
    TxtSelect,
	TxtNotConnected,
	TxtScaleImages,
	TxtLoggingIn,
	TxtAcceptEndWAP,
    TxtErrorUnknown,
	TxtErrorNotImp,
    TxtErrorUnsupported,
    TxtErrorOverload,
	TxtErrorNoResponse,
	TxtErrorTooLarge,
    TxtErrorBadRequest,
	TxtErrorUnauthorized,
	TxtErrorPaymentReq,
	TxtErrorForbidden,
	TxtErrorFileNotFnd,
	TxtErrorNotAllowed,
	TxtErrorNotAcceptable,
	TxtErrorAuthReq,
	TxtErrorReqTimeout,
	TxtErrorHTTPConf,
	TxtErrorOutOfMem,
	TxtErrorWMLError,
	TxtErrorDisplay,
	TxtErrorCardEmpty,
	TxtErrorURLInvalid,
	TxtErrorMemLow,
    TxtErrorPeerAbort,
	TxtError,
	TxtErrorHTTP,
	TxtErrorWSP,
	TxtErrorWAE,
	TxtErrorWSPCL,
	TxtErrorWSPCM,
	TxtErrorWTP,
	TxtErrorWTLS,
	TxtErrorWDP,
	TxtErrorUDCP,
	TxtNotSupported,
	TxtSelectLine,
   	TxtLine1,
   	TxtLine2,
   	TxtInfoNumbers,
	TxtAttach,	/*sbh 18/01/02*/
	TxtDetach,	/*sbh 18/01/02*/
	TxtGPRSAuto,/*zy 2003-03-04*/
	TxtGPRSNeed,/*zy 2003-03-04*/
	TxtAttachMode,/*zy 2003-03-04*/
	TxtDefineContext, /*sbh 22/01/02*/
	TxtActivateContext, /*sbh 22/01/02*/
	TxtDeactivateContext, /*sbh 22/01/02*/
	TxtGPRSPreferred,
	TxtCSDPreferred,
	TxtNotAttached,
	TxtAlreadyAttached,
	TxtSelected, /*ap 06/02/02*/
	TxtNetwork, /*ap 06/02/02*/
	TxtForbidden, /*ap 06/02/02*/
	TxtActivateFDN, /*ap 06/02/02*/
	TxtPlease, /*ap 06/02/02*/
	TxtTimedOut, // sh 13/02/02
	TxtWillChangeOn, // sh 13/02/02
	TxtAttached, // sh 14/02/02
	TxtDetached, // sh 14/02/02
	TxtUnknown, // api 13/14/02
	TxtCallTransfer,//MC
	TxtBufferFull,
	TxtAddNewCall,//zy Mobile Innovation 01/08/02 
    TxtEndOne,//zy Mobile Innovation 01/08/02 
    TxtCallMenu,//zy Mobile Innovation 23/09/02
    TxtBackgroud,/*........zy change for idle and setting 04/08/02...........*/
    TxtSelBackgroud,
    TxtBackgroundDisabled,
    TxtA, 
    TxtB,
    TxtUserDefine,
    TxtUserdefine1,
    TxtUserdefine2,
    TxtUserdefine3,
    TxtUserdefine4,
    TxtUserdefine5,
    TxtUserDefinedPic,//chenjun 2002-12-29 add for user defined pic, PCSync
    TxtNoUserPic, //chenjun 2003-01-15 for info dialog when there is not any user pic
    TxtRename,
    TxtAdjustContrast,
    TxtOnOffAnimation, 
    TxtBackLight,
    TxtBmpAlbum,
    TxtGreetingWord,
    TxtDsplSetting,
    TxtBacklightOnTime,
    TxtBacklightOffTime,
    TxtBacklightIntensity,
    TxtSavingSetting, 
    TxtGreetingWordOn, 
    TxtGreetingWordOff,
    TxtGreetingWordEdit,
    TxtMobileInnovation, 
    TxtFlower, 
    TxtSkyrocket,
    TxtCloseAnim,
    TxtSavingMode, 
    TxtNormalMode,
    TxtMobileSettings,
    TxtVoiceCallDivert,  //WUFEI APPEND
    TxtAllFaxCallDivert,  //WUFEI APPEND
    TxtAllDataCallDivert, //WUFEI APPEND
    TxtVoiceMailBox, //WUFEI APPEND
    TxtOtherNumber, //WUFEI APPEND
    TxtNumberInCommonUse,//WUFEI APPEND
    TxtCallSettings,//WUFEI APPEND
    TxtMinuteHint,//WUFEI APPEND
    TxtNextCall,//WUFEI APPEND
    TxtCUGNumber,//WUFEI APPEND
    TxtPreDefine,//WUFEI APPEND  
    TxtEnterIndex,//WUFEI APPEND
    TxtAddCUG,//WUFEI APPEND
    TxtModify,//WUFEI APPEND
    TxtDCTbVar0,//WUFEI APPEND
    TxtDCTbVar1,//WUFEI Add
    TxtDCTbVar2,//WUFEI Add
    TxtDCTbVar3,//WUFEI Add
    TxtDCTbVar4,//WUFEI Add
    TxtDCTbVar5,//WUFEI Add
    TxtDCTbVar6,//WUFEI Add
    TxtDCTbVar7,//WUFEI Add
    TxtDCTbVar8,//WUFEI Add
    TxtDCTbVar9,//WUFEI APPEND
    TxtEnterNRyTime,//WUFEI APPEND
    TxtCancelAffirm,//WUFIE APPEND
    TxtWithout,//WUFEI APPEND
    TxtScene, //xsf 18/04/02
    TxtNormals,
	TxtOut,
    TxtMeeting,
    TxtIncar,
    TxtStart,
    TxtPssetting,
    TxtAnswer,         //xsf 24/04/02
    Txtmelody1,
    Txtmelody2,
    Txtmelody3,	
    Txtmelody4,
    Txtmelody5,
    Txtmelody6,
    Txtmelody7,
    Txtmelody8,
    Txtmelody9,
    Txtmelody10,
    Txtmelody11,
    Txtmelody12,
	Txtmelody13,
	Txtmelody14,
	Txtmelody15,
	Txtmelody16,
	Txtmelody17,
	Txtmelody18,
	Txtmelody19,
	Txtmelody20,
    TxtmelodyNone,
    TxtSmsRing1,  //xsf add for sms special ring 03.03.13
    TxtSmsRing2,
    TxtSmsRing3,
    TxtSmsRing4,
    TxtSmsRing5,
    TxtHostKey,
    TxtHostSwitchOn,
    TxtHostSimLock, 
    TxtHostDelPbkall, 
    TxtHostReset, 
    TxtHostMsgbox, 
    TxtHostKeySet, 
    TxtHostKeyChange, 
    TxtHostKeyItems,      //xsf 14/05/02  9items
    TxtEnterHostKey,
    TxtSimReplaced,   //xsf add "SIMѸı"2003.04.10
    TxtHostKeyOk,  
    TxtHostKeyFail, 
    TxtOldHostKey, 
    TxtNewHostKey,  
    TxtHostKeyConfirm,  
    TxtHostKeyChangeOk,
    TxtHostKeyChangeFail,
    TxtHostKeyNotOn,  //xsf add 2002.08.29
    TxtHostKeyOpen,   //뿪
    TxtHostKeyClose,   //ر
    TxtHostkeySelect, //xsf add 2 Texts for noticing user to select pro_options with kcd_ok 2003.04.16
    TxtAnswerTone,
    TxtUndoEvent,
    TxtUnreadSMSTone,
    TxtMissedCallTone,
    TxtAlerttype,     //xsf 2002.07.08
    TxtRingmode,
    TxtRingPrompt,  //xsf add for ring prompt of alarm 09.24
    TxtVibramode,
    TxtVibraRing,
    TxtRingandVib,
    TxtSmsRing,  //  "sms ring type"       
    TxtSpecialRing,  //  "sms special Ring type"      
    TxtSmsVibra,  //  "sms vibra" 
    TxtSmsRVibra,  //  "sms ring and vibra" 
    TxtSmsMute,
    T_China_Telecomm,
    T_China_Unicomm,
    TxtDualBand,
    TxtGSM900,
    TxtDCS1800,
    TxtPLMNInfo,
    TxtPLMNReselect,
    TxtRegMode,
    TxtLockBand,
    TxtSearchingNetwork,  //searching for network
    TxtRegNetwork,   //registering
    TxtPLMNavailable,  //xsf add for listmenu title of PLMN reselect ѡ10.10
    TxtTimeOut,  //xsf add for network searching or registering 2003.02.26
    TxtPhonebook,              //绰    
    TxtPhoneSearch,            //ѯ
    TxtPhoneAdd,               //Ӻ                
    TxtGroupingSetting,         //
    TxtMultiCopy,               //
    TxtClearAll,                 //ɾȫ
    TxtShortCutDial,            //ݲ
    TxtMyNumber,              //
    TxtVoiceList,               //б
    TxtSearchItem,            //ѯѡ    
    TxtChangeRecord,          //༭
    TxtCopyRecord,            //Ƽ¼
    TxtDeleteRecord,           //ɾ¼
    TxtVoiceCall,               //
    TxtSIMBook,               //sim绰
    TxtNVMBook,               //绰    
    TxtPhoneNew,              //    
    TxtEnterName,              //
    TxtEnterNumber,            //ƶ
    TxtEnterHome,              //լ
    TxtEnterOffice,              //칫
    TxtEnterMemo,              //עϢ
    TxtGroupingOne,            //һ
	TxtGroupingTwo,            //
	TxtGroupingThree,          //
	TxtGroupingFour,           //
	TxtGroupingFive,           //
	TxtGroupingSix,            //
	TxtGroupingSeven,         //
	TxtGroupingEight,          //
	TxtGroupingNine,           //
	TxtGroupingTen,            //                            
    TxtGroupingItem,           //ѡ 
    TxtBrowserMember,       //Ա
    TxtAddMember,           //ӳԱ
    TxtGroupingIcon,          //ͼ    
    TxtGroupingRing,         //
    TxtGroupingRename,      //
    TxtCopyAll,               //ȫ
    TxtCopySIMtoNVM,         //sim
    TxtCopyNVMtoSIM,         //ƻsim
	TxtChoiceCopy,           //ѡ              
    TxtNullNumber,	         //ռ¼
    TxtPhoneSelect,          //ѡ    
    TxtEditSucceed,          //޸ĳɹ
    TxtEditFail    ,          //޸ʧ
    TxtAddSucceed,         //ӳɹ
    TxtAddFail,               //ʧ
    TxtCopySucceed,        //Ƴɹ
    TxtCopyFail,            //ʧ
    TxtDelSucceed,         //ɾɹ
    TxtDelFail,             //ɾʧ      
    TxtPhbkFull,           //绰              
    TxtBrowse,                
    TxtVoiceMemoAdd,
    TxtVoiceMemory,              	
	TxtRecVoice,           //¼
	TxtPhbkFind,           //ҵ!
	TxtPhbkCopy,          //!
	TxtPhbkDelMess,//Ƿɾ
	TxtPhbkCopyMess,
	TxtDelMember,//ɾԱɹ!
    TxtMemberAdd,//ӳԱɹ!
    TxtDelMemberError,//ɾԱɹ!
    TxtMemberAddError,//ӳԱʧ!
    TxtPhbkNvmFull,//绰!
    TxtPhbkSimFull,//SIM绰! 
    TxtPhbkNvmEmpty,//绰޼¼!
    TxtPhbkSimEmpty,//SIM绰޼¼!
    TxtPhbkSIMCopyAll,//SIMм¼?   
    TxtPhbkNVMCopyAll,//ƻ绰м¼?  
    TxtPhbkSIMCopyError,//SIM ռ䲻,? 
    TxtPhbkNVMCopyError,//绰  ռ䲻,? 
    TxtPhbkCopying,//ڸ...
    TxtPhbkDeleteSIMAll,//ɾSIMм¼?
    TxtPhbkDeleteNVMAll,//ɾ绰м¼?
    TxtPhbkChange,//޸ 
    TxtPhbkNumber,//
    TxtPhbkUse,//ʹ
 	TxtPhbkleft,//ʣ 
 	TxtMemoryState,//ڴ״̬
    TxtGroupingIconSucceed,//ͼóɹ!
    TxtGroupingIconError,//ͼʧ!
    TxtGroupingClassmate,//ͬѧ
    TxtGroupingFriend,//
    TxtGroupingFamily,//
    TxtGroupingWorkmate,//ͬ
    TxtRenameForbidden,//ֹ
    TxtChangeIconForbidden,
    TxtOnlyforBlacklist,//ר
	TxtTestCommand,//
    TxtSoftwareVersion,//汾
	TxtSpkMic,//Spk&Mic Status
	TxtMemFlashRtc,//Mem&Flash&Rtc Status
	TxtProductTest,//
	TxtLCDDisplay,//LCD
	TxtLEDBacklight,//LED,
	TxtMelodyandVibrator,//Ӳ
	TxtKeyPressTest,//
	   TxtToolkit,
#if(MAIN_LCD_SIZE==3)
	   TxtCamera,//Knuth
#endif

	TxtStopwatch,
       TxtSeparately,
       TxtBycircle,
       TxtBrowseRecord,
       TxtContinue,  
       TxtRestart,
     TxtNorecord,
     TxtConfirm,
     TxtBack,
     TxtOnebyone,
     TxtDeleteError,
     TxtSaveError,
     TxtTimer,
     TxtSetontime,
     TxtOpen,
     TxtClose,
     TxtSettime,
     TxtLefttime,
     TxtTimeup,
     TxtAutopower,
     TxtOpentime,
     TxtClosetime,
     TxtNote,
     TxtNotebrowse,
     TxtAdd,
     TxtChpriority,
     TxtToschedule,
     TxtTomessage,
     TxtOnce,
     TxtDay,
     TxtWeek,
     TxtMonth,
     TxtYear,
     TxtRing,
     TxtSchedule,
	/*talcon add for pcsyn,2004.07.06*/
#ifdef MMI_PCSYN_ENABLED
     TxtPCSyn,
#endif
     TxtWeekDay,
     TxtNewSche,
     TxtToday,
     TxtAllSche,
     TxtDeleteOld,
     TxtScheMeeting,
     TxtBirthday,
     TxtAppointment,
     TxtRemind,
     TxtReConfirm,
     TxtInputError,
     TxtResult,
     TxtDeleteOnebyOne,
     TxtConversion,
     TxtLength,
     TxtAcre,
     TxtUnitVolume,
     TxtWeight,
     TxtInitValue,
     TxtResultValue,
     TxtNext,
     TxtOverflow,
     TxtCall,
     TxtUnitChange,
     TxtStroke,
     TxtYMD,
     TxtBrowseAlarm,
     TxtAutoOff,
     TxtAutoConfirm,
     TxtScheSMS,
     TxtTooLong,
     TxtMemo,
     TxtCover,
     TxtAddMemo,
     TxtCalinder,
     TxtPowerOnTime,
     TxtPowerOffTime,
     TxtAutoPowerOn,
     TxtAutoPowerOff,
     TxtValue,
     TxtSelectDate,
    TxtGamestart,
	TxtGameedit,
	TxtGameselect,
	TxtGamesetting,
	TxtGamehelp,
	TxtGameScore,
	TxtGameRestart,
	TxtGameWinCondition,//2004-04-23 Sunny add
	TxtGameStageCruTtl,
	TxtGameStageInput,
	TxtGameExit,
	TxtGameExitConfirm,
	TxtGameNext,
	TxtGameGoon,
	TxtSnakegame,//2003/12/19,talcon add
	TxtBoxmangame,// tangyan 8.16 add it
	TxtBoxmanHelp,//2004-04-23 Sunny add
	TxtSnakeHelp,////2004-04-23 Sunny add
	TxtCalendarYear,
	TxtCalendarMonth,
	TxtBalloongame,// tangyan 8.16 add it
	TxtRussiagame,
	TxtSoftClearall,//end tangyan add
	TxtFlashErr,	//hxl add 20021029
	TxtGame,
	TxtSuoha,
	TxtSuohaNew,
	TxtSuohaPre,
	TxtConnected, // SH
    TxtGSM_900,	// SH
    TxtDCS_1800,
	TxtPCS_1900,
    TxtE_GSM,
	TxtGSM_850,
	TxtCallTimeout,
	TxtBand,
	TxtSatRefresh,
	TxtCallBlocked,
	TxtSRR,  // Marcus: Issue 1170: 30/09/2002
	TxtDelivered,  // Marcus: Issue 1170: 07/10/2002
	TxtTempError,  // Marcus: Issue 1170: 07/10/2002
    TxtSetDate,
    TxtSetTime,
    TxtFullHrAlert,
    TxtWorldTime,
    TxtKwajalein,
    TxtMidwayIs,
    TxtSamoa,
    TxtHawaii,
    TxtHonolulu,
    TxtAlaska,
    TxtLosAngeles,
    TxtSanFrancisco,
    TxtDenver,
    TxtChicago,
    TxtMexicoCity,
    TxtNewYork,
    TxtLima,
    TxtMontreal,
    TxtSantiago,
    TxtLaPaz,
    TxtBrasilia,
    TxtRioDeJaneiro,
    TxtMidAtlantic,
    TxtCapeVerdeIs,
    TxtLondon,
    TxtCasablanca,
    TxtLisbon,
    TxtRome,
    TxtBerlin,
    TxtParis,
    TxtMadrid,
    TxtAthens,
    TxtEasternEurope,
    TxtHelsinki,
    TxtBaghdad,
    TxtKoweit,
    TxtMoscow,
    TxtTbilisi,
    TxtIslamabad,
    TxtAlmaty,
    TxtDhaKa,
    TxtBangkok,
    TxtJaKarta,
    TxtBeiJing,
    TxtHongkong,
    TxtSingapore,
    TxtSeoul,
    TxtTokyo,
    TxtGuam,
    TxtSydney,
    TxtVladivostok,
    TxtSolomonIs,
    TxtFiji,
    TxtMarshallIs,
    TxtWellington,
    TxtDailyAlarm,
    TxtWeeklyAlarm,
    TxtSoftChange,
	TxtSunday,
	TxtMonday,
	TxtTuesday,
	TxtWednesday,
	TxtThursday,
	TxtFriday,
	TxtSaturday,
    TxtSendTo,	///"
    TxtRecieveFrom,	///
    TxtReadSms,
    TxtReadMt,//windy
    TxtReadMo,//windy 
	TxtSendSms,
	TxtUNSend,
	TxtSMSSettings,
	T_CBLanguageAll ,   
	T_CBLanguageNone ,
	T_CBGerman ,      
	T_CBEnglish  ,    
	T_CBItalian,       
	T_CBFrench ,      
	T_CBSpanish,      
	T_CBDutch ,       
	T_CBSwedish ,     
	T_CBDanish   ,    
	T_CBPortuguese ,  
	T_CBFinnish   ,   
	T_CBNorwegian  ,  
	T_CBGreek ,         
	T_CBTurkish ,        
	T_CBHungarian ,     
	T_CBPolish ,        
    	T_CBLanguage,
	TxtOnOff,
	TxtCBCHSET,
 	TxtCommonMsg,
 	TxtSaveToFfs,
 	TxtSendOnly,
 	TxtSendSave,
 	TxtInsertCMmsg,
	TxtNVMMsg,
	TxtSaveToNVM,
	TxtSMSNVMFull,
	TxtDeletingSms,
	TxtSavingSms, 
	TxtSmsFull, 
	TxtSIMSms,
	TxtCBChanel,
	TxtDelThisMsg1,
	TxtDelThisMsg2,
	TxtTryAgain,
	TxtUselessSMS,
    TxtAdviceDel, 
    TxtReadingSms,
    TxtInvalidMessage, 
    TxtChanelFull,
    TxtNVMInbox,
 	TxtNVMOutbox,
	TxtRussia,
	TxtActive,
    TxtCallSetup,//WUFEI 1010
    TxtShortCutMenu,
    TxtFunctionSelect,
    TxtDeleteAllFunctions,
    TxtHallOnConnect,
    TxtLedSetting,//zy 2003-02-11
    TxtRejectCalls,  
    TxtIncomingCallTime,
    TxtDialTime,
    TxtName,
    TxtNumberShow,
    TXTNoRecentNumber,    //hu binhao 2002-12-3
    TxtEnterDivertNumber,   //hu binhao 2002-12-16
    TxtOutgoingDataNew,        //hu binhao 2002-12-25
    TxTMakeSureTimeReset,     //hu binhao 2002 12-26
    TxtHaveReset,           //hu binhao 2002-1-17 for timer reset
    Txtonlinefunction,    //zhaowm 2002.12.15 
    Txtnotitle,           //zhaowm 2002.12.18 
    TxtnoGPRSservice,
	Txt5sec,   
    Txt10sec,  
    Txt15sec,  
    Txt20sec,
    Txt25sec, 
    Txt30sec, 
    TxtSetCFTime,
    Txtfunction,
    Txtdisconnectionbrow,
    TxtSOFTBACK,
    TxtLIST,
	TxtShowDetails,//yq add for phb
    TxtAddVoiceDial,//yq added for voiceDial?
    TxtModifyVoiceDial,//޸
    TxtVoiceDialFull,//¼
    TxtNoVoiceDial,//δ¼
    TxtStartEnroll,    //yq added for voiceDialʼ¼
    TxtEnrolling,       //¼
    TxtEnrollSucess,//¼ɹ
    TxtStartUpdate,//ʼȷ
    TxtVoiceUpdating,//ȷ
    TxtUpdateSucess,//ȷϳɹ
    TxtRecordSucess,//¼ɹ
    TxtEnrollError,//¼
    TxtUpdateError,//ȷϴ
    TxtStartDial,//ʼʶ
    TxtDialing,//ʶ
    TxtDialOk,//ʶɹ
    TxtDialRedial,//ٴʶ
    TxtDialError,//ʶ
    TxtPlayingNow,//ڲ
    TxtEnrollOnceMore,//ٴ¼
    TxtCallReady,//׼
    TxtRange,
    TxtConnection, /* SPR#1590 - SH */
    TxtRoaming,
	TxtOpenDivert,		//ת//2003.10.22 wyj תӵĲ˵ַ
	TxtCloseDivert,		//رת
	TxtLimitedService,
    TxtCallDuration,   //ʱͳ
    TxtAocStatistics,/* 2003/10/28, wangyan, modify AOC statistics menu*/
    TxtInvalidService, /* 2003/11/21, glowing, add invalid service */
	TxtOnRing,
	TxtOffRing,
	TxtOnOffRing,
	TxtOnVolume,
	TxtOffVolume,
	TxtHallOnRing,
	TxtHallOffRing,
	TxtHallOnOffRing,
	TxtHallOnVolume,
	TxtHallOffVolume,
	TxtGroupSelect,
	TxtGroupMute,
    TxtSwitchLED,
    TxtCheckHideID,	/* 2004/05/20 wy add */

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
// 2004.5.13 WYJ add for CAM 
	TxtCamCatch,
	TxtCamBook,
	TxtCamProperty,
	TxtCamMirror,
	TxtCamSize,
	TxtCamRotation,	
	TxtCamVGA,
    TxtCamQVGA,     
    TxtCamQQVGA,    
	TxtCamMobile,  

    TxtCam90,    
    TxtCam180,   
    TxtCam270,   
        
    TxtCamQuality,
    TxtCamFine,
    TxtCamNor, 
    TxtCamEco, 
    TxtCamOSD,

    TxtCamM1,
    TxtCamM2,
    TxtCamMelody,
// end of 2004.5.13 WYJ add for CAM
#endif



/* 2004/06/19 yhf add */
    TxtBmHelp1,
	TxtBmHelp2,
	TxtPublicHelp1,
	TxtPublicHelp2,
	TxtPublicHelp3,
	TxtPublicHelp4,
	TxtTerrisHelp1,
	TxtGameExplain,
/* end yhf add */
	TxtExitGame,//2004/06/29 yhf add
#ifdef MMI_EM_ENABLED	//Robert.Chen added, 2004-08-02
	TxtEngineeringMode,
	TxtMobileInfo, /*SPR1209*/
  	TxtServingCell,/*SPR1209*/
 	TxtNeighbourCell, /*SPR1209*/
 	TxtLocation, /*SPR1209*/
	TxtCiphHopDTX,/*SPR1209*/
#endif

#ifdef _MMS_ENABLE_
	//begin xie
	TxtMMS,
	TxtMMSNew,
	TxtMMSSendFolder,
	TxtMMSRecvFolder,
	TxtMMSDraftFolder,
	TxtMMSSentFolder,
	TxtMMSDeleteAll,
	TxtMMSSettings,

	TxtNewMMSTo,
	TxtNewMMSCC,
	TxtNewMMSBCC,
	TxtNewMMSTitle,
	TxtNewMMSText,
	TxtNewMMSPicture,
	TxtNewMMSMusic,

	TxtMMSNoImage,
	TxtMMSNoMusic,
	//new
	TxtMMSSendToNumber,
	TxtMMSSendToEmail,
	TxtMMSPreview,
	TxtMMSExitNewMsg,
	//end new
	TxtAddText,
	TxtAddImage,
	TxtAddMusic,
	TxtDeleteText,
	TxtTextColor,
	TxtAddSlide,
	TxtDeleteSlide,
	TxtSlideColor,
	TxtSlideTime,
	TxtPreviousSlide,
	TxtNextSlide,
	TxtInsertSlide,
	TxtMMSStoreMsg,

	TxtMMSSendReportOn,
	TxtMMSSendReportOff,
	TxtMMSAutoSaveOn,
	TxtMMSAutoSaveOff,
	TxtMMSAutoRecvOn,
	TxtMMSAutoRecvOff,
	TxtMMSSendReport,
	TxtMMSAutoSave,
	TxtMMSAutoRecv,
	TxtMMSSendSettings,
	TxtMMSRecvSettings,
	TxtMMSNetSettings,

	TxtMMSDelAll,
	TxtMMSDelSendFolder,
	TxtMMSDelRecvFolder,   
	TxtMMSDelDraftFolder,
	TxtMMSDelSentFolder,
	TxtMMSSendFolderEmpty,
	TxtMMSRecvFolderEmpty,   
	TxtMMSDraftFolderEmpty,
	TxtMMSSentFolderEmpty,
	TxtMMSDelAllMsg,

	TxtMMSPicture,      
	TxtMMSMusic,
	TxtMMSRetrieve,
	TxtMMSDelete, 
	TxtMMSPlay,
	TxtMMSReplay,  
	TxtMMSReply,         
	TxtMMSFarward,  
	TxtMMSCallback, 
	TxtMMSCutMedia,
	TxtMMSCutAddress,         
	TxtMMSDetails,  
	TxtMMSMoveToSentFolder ,  

	TxtMMSIPAddress,
	TxtMMSIPPort, 
	TxtMMSISDN,
	TxtMMSAnologue,
	TxtMMSGateway,  
	TxtMMSDataCallType,
	TxtMMSDiaNumber, 
	TxtMMSAPN,         
	TxtMMSLoginID,          
	TxtMMSPassword,     
	TxtMMSOnlyGPRS,   
	TxtMMSOnlyGSM,    
	TxtMMSMMSCURL,          
	TxtMMSGSMSettings,      
	TxtMMSGPRSSettings,          
	TxtMMSTransportMode,
	TxtMMSCurSettings,//add by xie 04-07-08
	TxtMMSAllSettings,
	TxtMMSEditGroupName,

	TxtMMSDetailFrom,
	TxtMMSDetailDate,
	TxtMMSDetailTo,
	TxtMMSDetailSize,
	TxtMMSEmpty,

	TxtMMSTelNumber,
	TxtMMSEmail,

	TxtMMSSenderIsEmpty,
	TxtMMSSendFailed,
	TxtMMSSendSuccess,
	TxtMMSSendCancelled,

	TxtMMSRecvSuccess,
	TxtMMSRecvCancelled,
	TxtMMSDataError,
	TxtMMSRecvFailed,

	TxtMMSRetrieving,
	TxtMMSSending,
	TxtMMSPleaseWaitting,

	TxtMMSFileTooBig,
	TxtMMSSystemError,
	TxtMMSSave,
	TxtMMSAlreadyExist,
	TxtMMSNoEnoughFlashSpace,
	TxtMMSNoImageInCurSlide,
	TxtMMSNoMusicInCurSlide,
	TxtMMSReceiverCanNotBeEmpty,
	TxtMMSInvalidInput,
	TxtMMSPleaseInputAgain,
	TxtMMSEdit,
	TxtMMSNewMMSSum,
	//end xie

	//begin feng
	TxtMMSDeleteMusic,
	TxtMMSDeleteImage,
	TxtMMSDeleteContent,
	TxtMMSSend,
	TxtMMSAddpage,
	TxtMMSDeletepage,
	TxtMMSPageUp,
	TxtMMSExit,
	TxtMMSPageDown,
	TxtMMSErrorPre,
	TxtMMSErrorLast,
	TxtMMSErrorLarge,
	TxtMMSErrorZero,
	TxtMMSTitleisnotNull,
	TxtMMSSent,
	//end feng
#endif


//2004.08.05 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
	//yangx Add
	TxtPhotoFrameChoice,
	TxtPhotoCapacity,
	TxtMemoryCapacity,
	TxtPhotoProperty,
	TxtPhotoSize,
	TxtPhotoType,
	//end yangx Add
#endif

    NO_OF_DEFINED_TEXT_IDS	//GW Leave this as the last element.
} tIndexTagNames, LangTxt;

//#define N_LANG1 342

#define LEN_LANGUAGE1 NO_OF_DEFINED_TEXT_IDS
#define LEN_LANGUAGE2 NO_OF_DEFINED_TEXT_IDS

extern tPointerStructure LanguageIndex_1[LEN_LANGUAGE1+1];
extern tPointerStructure LanguageIndex_2[LEN_LANGUAGE2+1];
/*******************************************************************************
                                                                              
                                Public Routine Definitions                                 
                                                                              
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif
    void *Mmir_BaseAddress();
    int Mmir_NumberOfEntries();
#ifdef __cplusplus
}
#endif



/*******************************************************************************
                                                                              
                                End of File
                                                                              
*******************************************************************************/

#endif





















