#ifndef _MMI_BOOK_INPUT_WINDOW_H_
#define _MMI_BOOK_INPUT_WINDOW_H_ 1

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiBookInputWindow.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This module provides the functionality for the input window of the
	phone book module.
	                    
********************************************************************************
 $History: MmiBookInputWindow.h

	25/10/00			Original Condat(UK) BMI version.	
	20/08/02     ver0.101  fzq modified   
 $End

*******************************************************************************/

/* Entry point for the input window
*/
MfwHnd bookInputStart( MfwHnd parent, T_EDITOR_DATA *properties );

/* Provide two special cases of the input handler to deal with the
   input of names and numbers using default properties
*/
MfwHnd bookInputStartNameEditor(   MfwHnd parent, void *buffer );
MfwHnd bookInputStartNumberEditor( MfwHnd parent, void *buffer );
MfwHnd bookInputStartHomeEditor( MfwHnd parent, void *buffer );
MfwHnd bookInputStartOfficeEditor( MfwHnd parent, void *buffer );
MfwHnd bookInputStartMemoEditor( MfwHnd parent, void *buffer );


/* Destruction point
*/
void bookInputDestroy( MfwHnd window );


/*******************************************************************************
                                                                              
                                End of File
                                                                              
*******************************************************************************/

#endif
