/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
																			  
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiBookMenuWindow.c
 $Revision:		1.0                                                       
																			  
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
																			   
********************************************************************************
																			  
 Description:

	Menu handling for the phone book
						
********************************************************************************
 $History: MmiBookMenuWindow.c

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/

/*******************************************************************************
																			  
								Include Files
																			  
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

	#include "typedefs.h"
	#include "vsi.h"
	#include "pei.h"
	#include "custom.h"
	#include "gsm.h"

#else

	#include "stddefs.h"
	#include "custom.h"
	#include "gsm.h"
	#include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"
#include "Mmistopwatch.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"

#include "MmiBookShared.h"
#include "MmiSettings.h"  // for keypadlock
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "Mmiservices.h"
#include "Mmihost.h" 

#include "mmiQQSwitch.h" 

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "mmicamera.h"
#endif


extern int gPlayKeytoneFlag; // MI18800000126

extern UBYTE HUPKeyOrigin;		// Variable to indicate that long end key press is coming from menu
extern MfwHnd stopw_win;
extern ToolkitTitle;
extern WapTitle;  
extern T_idle idle_data;
extern MfwHnd wap_main_window;
extern MfwHnd show_timer;
extern MfwHnd edt_timer;
extern UBYTE AllowPredText;
extern INT8 g_norejectkeyflag;
extern T_call call_data;
extern BOOL g_SATsession_is_active;
extern UBYTE anim_real_complete;
static int menutype = 0;  
extern BOOL phonebook_search_flag;
#define ONEKEY_TOIDLE
/*******************************************************************************                       
								External Function Prototype
																			  
*******************************************************************************/
/* Fix for the melody and volume settings. */
extern BOOL getScrollSelectMenuItem(void);
extern void ClearWindowHandle();
extern clearScrollSelectMenuItem(void);
extern void volMenuItemSelected(void);
extern USHORT getSoundsReason(void);
extern void startRingerVolSettingInactivityTimer(void);
extern void stopRingerVolSettingInactivityTimer(void);
extern void restartVolSettingInactivityTimer(void);
extern void ec_editDeactivate(void);
#ifdef QQFUNC
extern uint8    In_QQ;
extern void FreeListMemory();
#endif
/* 2004/07/09 sunsj add for forbidden hall off */
extern void sat_destroy();
/*******************************************************************************
																			  
								Private Methods
																			  
*******************************************************************************/



/*******************************************************************************

 $Function:    	bookMenuMenuCB

 $Description:	Menu handler for the menu window
 
 $Returns:		MFW_EVENT_CONSUMED if event handled, otherwise
				MFW_EVENT_PASSED

 $Arguments:	e, event, m, menu handle
 
*******************************************************************************/

static int bookMenuMenuCB( MfwEvt e, MfwMnu *m )
{
	T_MFW_HND       window      = mfwParent( mfw_header() );
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)window)->data;
	tBookStandard   *data       = (tBookStandard *) win_data->user;

	TRACE_FUNCTION( "bookMenuMenuCB()" );

	/* We only handle the ESCAPE event in here
	*/
	switch (e)
	{
	case E_MNU_ESCAPE:
		{
			/* Escape requested, we need to shut down this window
			*/
			if (data->Callback)
				(data->Callback) (data->parent_win, NULL, NULL);
			bookMenuDestroy( window );
			stopRingerVolSettingInactivityTimer();
		}

		break;

	default:
		{
			/* unknown event, pass it up the tree for handling elsewhere
			*/
			return MFW_EVENT_PASSED;
		}
		break;
	}

	/* We got here, event handled, prevent anyone else
	   dealing with it
	*/
	return MFW_EVENT_CONSUMED;
}






/*******************************************************************************

 $Function:    	bookMenuDialog

 $Description:	Menu window dialog function
 
 $Returns:		none

 $Arguments:	win, window handle
				event, event to be handled
				value, not used
				parameter, not used
 
*******************************************************************************/

void bookMenuDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
	tBookStandard   *data       = (tBookStandard *) win_data->user;
	MfwMnu          *mnu;
	char * userdefine; //define the child menu title value

	TRACE_FUNCTION( "bookMenuDialog()" );

	/* The menu dialog function has to deal with initialisation
	   and responses from the PIN2 validation methods
	*/
	switch (event)
	{
	case MENU_INIT:
		{
			/* On initialisation, create the menus and display the window */
			if (value EQ  PhbkDetailsListDone)
			{
				userdefine=(char *)"userRename";
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}
			else if (value EQ  PhbkHostkeyList)
			{
				userdefine=(char *) MmiRsrcGetText(TxtHostKeyItems);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
				menutype = PhbkHostkeyList;	
			}
			else if (value EQ  PhbkHostkeyOnOffList)
			{
				userdefine=(char *) MmiRsrcGetText(TxtHostKeySet);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}
			else if (value EQ PhbkNormal)
			{
				userdefine=MmiRsrcGetText(TxtPhonebook);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}
			else if (value EQ PhbkFromVoiceMemo)
			{
				userdefine=MmiRsrcGetText(TxtVoiceMemo);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );                        
			}
			else if (value EQ PhbkSearchItem)
			{
				userdefine=MmiRsrcGetText(TxtSearchItem);
#if(MAIN_LCD_SIZE==3)
            	phonebook_search_flag=FALSE;
#endif
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}
			else if (value EQ PhbkFromGroupingItem)
			{
				userdefine=MmiRsrcGetText(TxtGroupingItem);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}
			else if ((value EQ PhbkNameEnterIdle) || (value EQ PhbkNameEnterSms)||(value EQ PhbkNameEnterRecentCall)) 
			{
				userdefine=MmiRsrcGetText(TxtPhoneAdd);  
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
			}
			else if (value EQ PhbkToolkit)
			{
				userdefine=MmiRsrcGetText(ToolkitTitle);  
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
			}
			else if (value EQ PhbkWap)
			{
			#ifdef MMI_WAP_ENABLED
				userdefine=MmiRsrcGetText(WapTitle);  
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
			#endif
			}
			else if (value EQ CFTimeSet)
			{
				userdefine=MmiRsrcGetText(TxtSetCFTime);  
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
			}
			else if (value EQ PhbkVoiceList)
			{
				userdefine=MmiRsrcGetText(TxtVoiceList);  
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}
		#ifdef QQFUNC
			else if ((value EQ Nvm_fri_list))
			{				
				userdefine=MmiRsrcGetText(TxtQQFriSel);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = Nvm_fri_list; 
			}
			else if (value EQ Net_fri_list)
			{
				userdefine=MmiRsrcGetText(TxtQQFriSel);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = Net_fri_list; //for update the datalist when back
			}
			else if (value EQ Sys_info_list)
			{				
				userdefine=MmiRsrcGetText(TxtQQSysInfo);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = Sys_info_list; //update the datalist when back
			}
			else if (value EQ Chat_info_list)
			{
				userdefine=MmiRsrcGetText(TxtQQChatInfo);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = Chat_info_list; //update the datalist when back
			}
			else if (value EQ Unread_info_list)
			{
				userdefine=MmiRsrcGetText(TxtNewQQ);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = Unread_info_list; 
			}
			else if (value EQ find_fri_sel)
			{
				userdefine=MmiRsrcGetText(TxtQQFriSel);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = find_fri_sel; 
			}
			else if (value EQ Left_info_list)
			{
				userdefine=MmiRsrcGetText(TxtQQLeftInfo);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  ); 
				menutype = Left_info_list; 
			}
		#endif	//QQFUNC
			else if (value EQ Phbksoftversion)
			{
				userdefine=MmiRsrcGetText(TxtSoftwareVersion);  
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine  );
			}  /*2003/12/5, wangyan modify*/
		#ifdef MMI_EM_ENABLED
			else if(value EQ PhbEmMode)
			{
				userdefine = MmiRsrcGetText(TxtEngineeringMode);
				data->menu = mnuListCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB, userdefine );
			}
		#endif
			else
			{
				data->menu = mnuCreate( data->win, (MfwMnuAttr *) parameter, E_MNU_ESCAPE, (MfwCb) bookMenuMenuCB );
			}
			mnuLang( data->menu, mainMmiLng );
			mnuUnhide( data->menu );
			winShow( data->win );
			if (value EQ PhbkHostkeyList)
				displaySoftKeys( TxtSoftOK, TxtCancel);

			if (value EQ PhbkMainMenu)
			{
				// start the timer for the keypadlock
				tim_start (data->menu_tim);
				data->status_of_timer = FALSE;

			}
			else
			{
				data->status_of_timer = TRUE;
				
			}
			if (value == SettingVolume)
			{
				/*
				  The ringer volume settings dialog has been invoked, create and start the
				  4 second time out.
				*/
				startRingerVolSettingInactivityTimer();
			}

		}
		break;

	case ADD_CALLBACK:
		{
			/* Change the callback from the default menu callback to one specified
			 * in parameter */
			data->Callback = (T_VOID_FUNC)parameter;
		}
		break;

	case DEFAULT_OPTION:
		{
			/* Highlight an option in the menu when it is opened.  Parameter points to a UBYTE. */

			mnuChooseVisibleItem(data->menu, *((UBYTE *)parameter));
		}
		break;

	case PIN2_OK:
		{
			/* We have received a PIN2 authorisation, so we can execute the
			   the requested function
			*/
			//data->phbk->menu = NULL;
			//data->phbk->item = NULL;

			TRACE_FUNCTION("PIN2_OK: Should carry on to perform phonebook op");
			(data->phbk->pin2_next)( data->phbk->menu, data->phbk->item);

		}
		break;
	case E_MNU_ESCAPE:
		{
			/* Escape requested, we need to shut down this window
			*/
			bookMenuDestroy( win);
		}
		break;
	default:
		{
			/* In situations where a PIN2 abort is returned, we can handle it
			   as a default event, and just ignore it
			*/
			TRACE_FUNCTION("PIN2 not OK");
		}
		break;
	}
	
}



/*******************************************************************************

 $Function:    	bookMenuTimCB

 $Description:	Menu tim handler
 
 $Returns:		
				
 $Arguments:	
 
*******************************************************************************/

static int bookMenuTimCB (T_MFW_EVENT event, T_MFW_TIM *tc)
{
	T_MFW_HND       window      = mfwParent( mfw_header() );
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)window)->data;
	tBookStandard   *data       = (tBookStandard *) win_data->user;

	data->status_of_timer = TRUE;

}






/*******************************************************************************

 $Function:    	bookMenuWindowCB

 $Description:	Menu window handler
 
 $Returns:		MFW_EVENT_CONSUMED if event handled, otherwise
				MFW_EVENT_PASSED

 $Arguments:	e, event, m, window handle
 
*******************************************************************************/

static int bookMenuWindowCB( MfwEvt e, MfwWin *w )
{
	tBookStandard * data = (tBookStandard *)w->user;
	MfwMnu * mnu;

	UINT32 oldColor,oldFontColor;

	TRACE_FUNCTION( "bookMenuWindowCB()" );

	switch (e)
	{
	case MfwWinVisible:
		{
			dspl_ClearAll();	// sbh - clear screen before update
			mnu = (MfwMnu *) mfwControl( data->menu );
			//JVJE MmiBookShowDefault();
			oldColor=dspl_GetBkgColor();
			dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
			oldFontColor=dspl_GetFrgColor();
			dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));
			displaySoftKeys( '\0', '\0');
			displaySoftKeys( TxtSoftSelect, TxtSoftBack);
			dspl_SetBkgColor(oldColor);
			dspl_SetFrgColor(oldFontColor);
			controlBrowseNew();
		}
		break;

	default:
		{
			/* unknown event, pass it up the tree for handling elsewhere */
			return MFW_EVENT_PASSED;
		}
		break;
	}

	/* We got here, event handled, prevent anyone else dealing with it */
	return MFW_EVENT_CONSUMED;
}






/*******************************************************************************

 $Function:    	bookMenuKbdCB

 $Description:	tbd
 
 $Returns:		MFW_EVENT_CONSUMED always

 $Arguments:	e, event, k, key handle
 
*******************************************************************************/

static int bookMenuKbdCB( MfwEvt e, MfwKbd *k )
{
	static BOOL storeSelectedItemToPcm=FALSE;
	T_MFW_HND       window      = mfwParent( mfw_header() );
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)window)->data;
	tBookStandard   *data       = (tBookStandard *) win_data->user;

	TRACE_EVENT( "bookMenuKbdCB()" );

	/* handle the keypress */
	switch (k->code)
	{
	case KCD_MNUUP:
		{
			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;           
			/* Update the window with the previous element */
			if (IsViewListMenu(data->menu))
			{
				mnuPageUp( data->menu );
				TRACE_EVENT("mainmenu_MnuUpdate");
			}
			else
				mnuUp( data->menu );
			/*
			Special case when setting up ringer volume, the current ringer 
			is played as user scrolls the volume settings Silent -> cresendo.
			MZ.
			*/
			if (getScrollSelectMenuItem() == TRUE ||(getSoundsReason() == SettingVolume))
			{
				mnuSelect(data->menu);
				restartVolSettingInactivityTimer();
			}
//JVJE			winShow( window );
		}
		break;

	case KCD_MNUDOWN:
		{
			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;           
			/* Update the window with the next element
			*/
			TRACE_EVENT( "KCD_MNUDOWN" );
			if (IsViewListMenu(data->menu))
			{
				mnuPageDown( data->menu );
				TRACE_EVENT("mainmenu_MnuUpdate");
			}
			else
				mnuDown( data->menu );

			/*
			Special case when setting up ringer volume, the current ringer 
			is played as user scrolls the volume settings Silent -> cresendo.
			MZ.
			*/

			if ((getScrollSelectMenuItem() == TRUE) || (getSoundsReason() == SettingVolume))
			{
				mnuSelect(data->menu);
				restartVolSettingInactivityTimer();
			}


//JVJE			winShow( window );

		}
		break;
	case KCD_MNULEFT:
		{
			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;           
			/* Update the window with the previous element
			*/
			if (IsViewListMenu(data->menu))
				mnuUp( data->menu );
			/*
			Special case when setting up ringer volume, the current ringer 
			is played as user scrolls the volume settings Silent -> cresendo.
			MZ.
			*/

//JVJE			winShow( window );
		}
		break;

	case KCD_MNURIGHT:
		{
			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;           
			/* Update the window with the next element
			*/
			if (IsViewListMenu(data->menu))
				mnuDown( data->menu );

			/*
			Special case when setting up ringer volume, the current ringer 
			is played as user scrolls the volume settings Silent -> cresendo.
			MZ.
			*/


//JVJE			winShow( window );

		}
		break;

	case KCD_LEFT:
#if(MAIN_LCD_SIZE==3)
            phonebook_search_flag=FALSE;
#endif
		if (menutype == PhbkHostkeyOnOffList)
		{
			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;

			// get us out of here
			mnuEscape( data->menu );
			menutype = 0; 
			flash_hostwrite(); 
			HostkeyProtectOpts_confirm();
			break;
		}
		else if (menutype == PhbkHostkeyList)
		{
			HostkeyProtectOpts_notice();
			break;
		}		
	case KCD_OK:  //xsf add for list menu KCD_OK=KCD_LEFT 2003.02.18
		{
		#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
			if ((In_QQ)&&(k->code==KCD_OK))
			{
				Get_Unread_info(window);
				break;
			}
		#endif

			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;   

			// Select this element
			mnuSelect( data->menu );
			if (menutype == PhbkHostkeyList)
			{
				menutype = PhbkHostkeyOnOffList;
			}

			// A volume or tone setting menu has been entered. MZ 2/4/01
			if ((getScrollSelectMenuItem() == TRUE) || (getSoundsReason() == SettingVolume))
			{
				/* 
				   First time pcm flag is false, subsequent selection of menu item
				   will select and terminate the volume settings menu. 3/4/01 MZ.
				*/
				if (storeSelectedItemToPcm ==TRUE || getSoundsReason() == SettingVolume)
				{
					clearScrollSelectMenuItem();
					volMenuItemSelected();
					storeSelectedItemToPcm =FALSE;
					mnuEscape( data->menu );
					if (getSoundsReason() == SettingVolume)
					{
						setSoundsReason(SoundsNone);
						stopRingerVolSettingInactivityTimer();
					}
					break;
				}
				/*
				  Second time the left soft key is used, store the setting in pcm and terminate the 
				  volume settings menu.
				*/
				storeSelectedItemToPcm =TRUE;

			}
		}
		break;

		// POWER key takes us to idle screen.
	case KCD_POWER:
		data->status_of_timer = TRUE;   

		HUPKeyOrigin = 0; // sbh - we're coming from the menu screen, so don't shut down right away

		//return to idle screen

		if (data->Callback)
			(data->Callback) (data->parent_win, NULL, NULL);

		bookMenuDestroy(data->win);
		stopRingerVolSettingInactivityTimer();

		SEND_EVENT(idle_get_window(), IDLE_UPDATE, 0, 0);
		break;

	case KCD_F4:    
		if (HallStatus())
			break;
		else
		{
			returntoidle(1);
			break;
		}
	case KCD_HUP:
	#ifdef ONEKEY_TOIDLE
		{
		#ifdef QQFUNC
			if ((In_QQ)&&((menutype == Nvm_fri_list)||(menutype == Net_fri_list)
						  ||(menutype == Sys_info_list)||(menutype == Chat_info_list)
						  ||(menutype == Left_info_list)||(menutype == Unread_info_list)))
			{
				T_MFW_HND       listwin     = mfwParent( window);//window=bookmenu win
				T_MFW_HND       listpawin       = mfwParent( listwin);////listpa win

				SEND_EVENT(window, E_MNU_ESCAPE, 0, 0);
				FreeListMemory();
				listsDestroy(listwin);
				SEND_EVENT(listpawin, 0, 0, 0);
				menutype=0;
			}
			else
		#endif	//QQFUNC
				//mnuEscape( data->menu ); //we don't escapemenu.
				if (returntoidle(0))
				break;
		}
	#endif	//ONEKEY_TOIDLE
	
	case KCD_RIGHT:
		{
			// keypadLock will not activate anymore
			data->status_of_timer = TRUE;

			HUPKeyOrigin = 0; // sbh - we're coming from the menu screen, so don't shut down right away
			if (menutype == PhbkHostkeyList) 
			{
				menutype = 0; 
				//flash_hostread();
			}
			else if (menutype == PhbkHostkeyOnOffList)
			{
				menutype = 0; //xsf add 2003.03.03
				flash_hostread();
			}			
			/* get us out of here */
		#ifdef QQFUNC
			if ((In_QQ)&&((menutype == Nvm_fri_list)||(menutype == Net_fri_list)
						  ||(menutype == Sys_info_list)||(menutype == Chat_info_list)
						  ||(menutype == Left_info_list)||(menutype == Unread_info_list)))
			{
				T_MFW_HND       listwin     = mfwParent( window);//window=bookmenu win
				T_MFW_HND       listpawin       = mfwParent( listwin);////listpa win

				SEND_EVENT(window, E_MNU_ESCAPE, 0, 0);
				FreeListMemory();
				listsDestroy(listwin);
				SEND_EVENT(listpawin, 0, 0, 0);
				menutype=0;
			}
			else
		#endif
		
				mnuEscape( data->menu );

			if (stopw_win)
			{
				SEND_EVENT(stopw_win, STOPW_EXIT, 0, 0);
			}

			// Return the menu scroll behavior to normal.
			if (getScrollSelectMenuItem() == TRUE)
			{
				clearScrollSelectMenuItem();
			}

			/*
				If user exits the volume settings menu from the Idle or Incoming call screen.
				clear the soundsReason.
			*/
			if (getSoundsReason() == SettingVolume)
				setSoundsReason(SoundsNone);

		}
		break;
	case KCD_1:
	case KCD_2:
	case KCD_3:
	case KCD_4:
	case KCD_5:
	case KCD_6:
	case KCD_7:
	case KCD_8:
	case KCD_9:
		mnuKeyAction(data->menu, k->code);
		break;
#if 0
	case KCD_STAR:
		{
			U8 uMode;           
			/*
			 * Keypadlock will lock only 
			 * within two seconds by press "*"
			 */         
			if (data->status_of_timer EQ FALSE)
			{
//				uMode = dspl_Enable(0);
				TRACE_FUNCTION ("activate KEYpadLOCK");
				mnuEscape( data->menu );
//				settingsKeyPadLockOn ();zy 01/23/2003 avoid begin keypad
//				dspl_Enable(uMode);
			}

		}
		break;

	case KCD_HASH:
		{
			U8 uMode;           
			/*
			 * Keypadlock will lock only 
			 * within two seconds by press "*"
			 */         
			if (data->status_of_timer EQ FALSE)
			{
//				uMode = dspl_Enable(0);
				TRACE_FUNCTION ("activate Silent mode");

				if (FFS_flashData.settings_status & SettingsSilentMode)
				{
					//settingsSilentModeOff();zy change 09/27 still not use
				}
				else
				{
					//settingsSilentModeOn();
				}
				mnuEscape( data->menu );
//				dspl_Enable(uMode);
			}

		}
		break;
#endif
	default:
#if 0
		{
			// SH - only allow dialling if we are in the main menu
			if (window == data->phbk->menu_main_win)
			{
				U8 keycode;
				U8 uMode;           
				uMode = dspl_Enable(0);
				/* no action required
				*/
				// keypadLock will not activate anymore
				data->status_of_timer = TRUE;       

				/* Number key presses in phonebook menu returns user to idle screen, 
				   add key press to Idle edit screen. */

				keycode = k->code;

				bookMenuDestroy(data->win);

				if (k->code>=KCD_0 && k->code<=KCD_9)
				{
					SEND_EVENT(idle_get_window(), IDLE_START_DIALLING_NUMBER, 0, &keycode);
				}


				dspl_Enable(uMode);
			}
		}
#endif
		break;
	}

	/* always consume the event
	*/
	return MFW_EVENT_CONSUMED;
}







/*******************************************************************************

 $Function:    	bookMenuKbdLongCB

 $Description:	keyboard long press event handler
 
 $Returns:		MFW_EVENT_CONSUMED always

 $Arguments:	e, event, k, key handle
 
*******************************************************************************/

static int bookMenuKbdLongCB( MfwEvt e, MfwKbd *k )
{
	T_MFW_HND       window      = mfwParent( mfw_header() );
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)window)->data;
	tBookStandard   *data       = (tBookStandard *) win_data->user;

	TRACE_EVENT( "bookMenuKbdLongCB()" );

	if (( e & KEY_CLEAR ) && ( e & KEY_LONG ))
	{
		mnuEscape( data->menu );
		return MFW_EVENT_CONSUMED;
	}
	/*if long press on END key*/
	if (( e & KEY_HUP) && ( e & KEY_LONG ))
	{
		U8 keycode;
		U8 uMode;           
//			uMode = dspl_Enable(0);

		// keypadLock will not activate anymore
		data->status_of_timer = TRUE;       

		//return to idle screen

		keycode = k->code;

		if (data->Callback)
			(data->Callback) (data->parent_win, NULL, NULL);

		bookMenuDestroy(data->win);
		stopRingerVolSettingInactivityTimer();

		SEND_EVENT(idle_get_window(), IDLE_UPDATE, 0, &keycode);

//			dspl_Enable(uMode);
	}

	return MFW_EVENT_CONSUMED;
}






/*******************************************************************************

 $Function:    	bookMenuCreate

 $Description:	Create the menu window
 
 $Returns:		handle of newly created window, or NULL if error

 $Arguments:	parent, handle of the parent window
 
*******************************************************************************/

static T_MFW_HND bookMenuCreate( MfwHnd parent )
{
	T_MFW_WIN       *parent_win_data = ( (T_MFW_HDR *) parent )->data;
	T_phbk          *phbk = (T_phbk *)parent_win_data->user;
	T_MFW_WIN       *win_data;
	tBookStandard   *data;

	TRACE_FUNCTION( "bookMenuCreate()" );

	/* allocate memory for our control block
	*/
	if (( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL)
		return NULL;

	/* Create the window if we can
	*/
	if (( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookMenuWindowCB ) ) == NULL)
	{
		FREE_MEMORY( (void *)data, sizeof( tBookStandard ) );
		return NULL;
	}
#if(MAIN_LCD_SIZE==3)
    phonebook_search_flag=FALSE;
#endif
	/* Okay, we have created the control block and the window, so
	   we now need to configure the dialog and data pointers
	*/
	data->mmi_control.dialog    = (T_DIALOG_FUNC) bookMenuDialog;
	data->mmi_control.data      = data;
	win_data                    = ((T_MFW_HDR *)data->win)->data;
	win_data->user              = (void *) data;
	data->phbk                  = phbk;
	data->parent_win            = parent;

	/* create keyboards and menus for our window
	*/
	data->kbd       = kbdCreate  ( data->win, KEY_ALL,            (MfwCb) bookMenuKbdCB );
	data->kbd_long  = kbdCreate  ( data->win, KEY_ALL | KEY_LONG, (MfwCb) bookMenuKbdLongCB );
	data->menu_tim  = tim_create (data->win, THREE_SECS,          (MfwCb) bookMenuTimCB);

	data->Callback = NULL;						// Use standard menu callback (changed by sending event ADD_CALLBACK)

	/* And return the handle of the newly created window
	*/
	return data->win;
}





/*******************************************************************************
																			  
								Public Methods
																			  
*******************************************************************************/

/*******************************************************************************

 $Function:     bookMenuStart

 $Description:	tbd
 
 $Returns:		tbd

 $Arguments:	tbd
 
*******************************************************************************/

T_MFW_HND bookMenuStart( MfwHnd parent, MfwMnuAttr *menuAttr,SHORT reason )
{
	T_MFW_HND win;

	if (( win = bookMenuCreate( parent ) ) != NULL)
		SEND_EVENT( win, MENU_INIT, reason, (MfwMnuAttr *) menuAttr );
	return win;
}



/*******************************************************************************

 $Function:    	bookMenuDestroy

 $Description:	Destroy the menu window 
 
 $Returns:		none

 $Arguments:	window, handle of the window being destroyed
 
*******************************************************************************/

void bookMenuDestroy( MfwHnd window )
{
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)window)->data;
	tBookStandard   *data       = (tBookStandard *) win_data->user;
	char            test_string[40];

	TRACE_FUNCTION( "bookMenuDestroy()" );

	if (data)
	{

		/* If we have the root window here then we use the main phone
		   book destroy method
		*/
		if (data->phbk->root_win == window)
		{
			bookPhonebookDestroy( data->phbk->win );
			return;
		}

		/* Otherwise clear down our pointers and free the current
		   menu window structures
		*/
		if (data->phbk->search_win == window)
			data->phbk->search_win = 0;
		if (data->phbk->menu_main_win == window)
			data->phbk->menu_main_win = 0;
		if (data->phbk->menu_options_win == window)
			data->phbk->menu_options_win = 0;
		if (data->phbk->menu_options_win_2 == window)
			data->phbk->menu_options_win_2 = 0;
		if (data->phbk->menu_call_options_win == window)
			data->phbk->menu_call_options_win = 0;
		if (data->phbk->menu_call_options_win_2 == window)
			data->phbk->menu_call_options_win_2 = 0;

		winDelete( data->win );

		FREE_MEMORY( (void *)data, sizeof( tBookStandard ) );
		sprintf(test_string, "Bookmenudestroy: %d", mfwCheckMemoryLeft());
		TRACE_FUNCTION(test_string);
	}

}


/******************************************************************************
yq add for return to idle
******************************************************************************/
int  returntoidle(int halloff)
{
	/* 2004/07/09 sunsj add for forbidden hall off */
	T_SAT_RES sat_res;

#ifdef QQFUNC
	if (anim_real_complete&&!In_QQ)
#else
	if (anim_real_complete)
#endif
	{
		if (!call_data.win)
		{
			if (menutype == PhbkHostkeyList) 
			{
				menutype = 0; 
				//flash_hostread();
			}
			else if (menutype == PhbkHostkeyOnOffList)
			{
				menutype = 0; 
				flash_hostread();
			}

			if (winIsFocussed(idle_data.win))
				return 1;
		#ifdef MMI_WAP_ENABLED
			if (wap_main_window)
				return 0;
		#endif
			/* 2004/07/09 sunsj modify for exit simtoolkit through hall off */
			if (g_SATsession_is_active)
			{
				sat_destroy();
				//return 0;
			}

			show_timer=0;
			edt_timer=0;
			ClearWindowHandle();
			SetPhbkIN(0);
			//if(!halloff)					//2004.1.12 WYJ not hall off  
			//Stopplayingdevice();			//MI18800000126
			gPlayKeytoneFlag = 1;
			MC_StopVibra();		// 2004.4.16 WYJ add
			
			//2004.08.02 Added by Cathy for Camera
			#ifdef CAMERA_ENABLED
		        CamExit();
			#endif

			cm_force_disconnect();
			call_data.ignore_disconnect=TRUE;
			soundReasonSmsTone(NULL,NULL,NULL);
			AllowPredText = FALSE;
			g_norejectkeyflag=0;
			editDeactivate();
			ec_editDeactivate();
			winFocusShow(idle_data.win);

			return 1;
		}
	}
	return 0;
}


/*******************************************************************************
																			  
								End of File
																			  
*******************************************************************************/
