/*******************************************************************************

               CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiBookPhoneBook.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This module provides the basic phone book functionality

  
********************************************************************************
 $History: MmiBookPhoneBook.c

   25/10/00			Original Condat(UK) BMI version.	
        08/08         version 0.102   fzq modified	   
        19/08/02      version 0.102   xusufang modified 
        20/08/02      version 0.103   fzq modified
 $End

*******************************************************************************/


/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"

#include "MmiBookShared.h"
#include "MmiBookController.h"
//#include "uniparad.h"
#include "l1tm_cust_add.h"  //hxl add for pcsync 20020925
#include "Mmismsmenu.h"//yq added 2003/3/17
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */
//#define TDTRACE 1
#include "mmiutilapi.h"

#define     MaxHanZi                  7336*4
#define		PHONEBOOK_RECORD_PERPAGE	3//绰
//static int     ReadEntries(U8 p_type, U8 p_idx, U8 p_mode, U8 p_number);
//static int     ReadSIM_Init(U8 p_type,U8 p_mode);
static void    ChoiceSort(T_MFW_PHB_SORT_INDEX *SortData,int RecordLen);
static U8      ChLowCase(U8 n);
static U8 UnchangePinYinProgramCode(U8 code);
static T_MFW_HND bookShowWait( MfwHnd parent,int reason);
static void show_number();
static void yq_edtchar(T_MFW_HND edt,unsigned char code);
void bookCallPhbDestroy( MfwHnd window );
static void ShowWaitDestroy( MfwHnd window );

extern BOOL phonebook_search_flag;
//static T_MFW_PHB_ENTRY	  l_phb_entry[PE_SIZE]; // in NVM_phbk, we also read 10 entries once, revised by gan chunhui
//static T_MFW_PHB_LIST	  l_phb_list;	/* phonebook list */
//static T_MFW_PHB_STATUS   l_phb_status;
//static U8				  l_idx;
//static U8				  l_startidx;	/* start index of found matches */
//static U8				  l_found;	/* number of pattern matches */
static int wait_reason;
static unsigned char dynamic_index;
unsigned char no_wait=1;/*2003/12/13, wangyan modify*/
static MfwHnd dynamic_tim;
typedef enum
{
    Wait_Init,
    Wait_Ok,
    Wait_Destroy
}ShowWaitEvent;

typedef enum
{
    CALLPHB_INIT,
    CALLPHB_DESTROY
}CallPhbEvent;

typedef enum
{
    NONE,
    TOLEFT,
    TORIGHT
} T_BrowserWay;

typedef enum
{
    B_NUMBER,
    B_HOME,
    B_OFFICE,
    B_MEMO
} T_BrowserType;


static MfwMnuAttr readName_menuAttrib =//the default menu attr
{
    0,
    &menuDynamicArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};
/*2003/12/16, WANGYAN MODIFY*/
static MfwMnuAttr readName_fromcall_menuAttrib =//the default menu attr
{
    0,
    &menuDynamicArea_fromcall,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};
/*2003/12/16, WANGYAN MODIFY*/
T_DynamicBuffer Dynamic_menu[5];
extern unsigned char backgroundBit[];
/* 2004/05/17 sunsj modify */
//extern unsigned char waiting1[];
//extern unsigned char waiting2[];
//extern unsigned char waiting3[];
/*extern unsigned char waiting4[];
extern unsigned char waiting5[];
extern unsigned char waiting6[];
extern unsigned char waiting7[];*//*2003/12/13, wangyan modify*/
extern UINT8 SimNumber[ALL_SIM_LIST][PHB_number_len/2+1];
//yq added for phb in calling
extern void ShowPhoneBookNumber(int Index,T_BrowserWay way);
static void ClearCallWindowHandle();
static void SetCallWindowsHandle(T_MFW_HND win);
extern void ShortCutLocation(ListWinInfo  * dataInfo, char * NewKey,TABLE_TYPE table, int *BufferIndex,int flag);
extern void GetVoiceData();
/* 2004/06 sunsj modify for icon manage */
//extern const unsigned char abc_bmp[];
extern T_BrowserType CurrentType;
extern T_call call_data;//yq added 2003/4/7 for reset the call_data.win_phb
static int search_total;
static MfwHnd showtimer=0;
static MfwHnd edttimer=0;
static MfwHnd calldatawin=0;
static USHORT show_index;
static UBYTE refresh_flag;
static unsigned char cursor_correct=1;   //the flag indicate the cursor correct or not
static unsigned char key_before=0xff;      //the key you pressed before this key
static unsigned char key_index=0;          //the index of the key in edt_key
static const unsigned char edt_key[8][5]={"abc","def","ghi","jkl","mno","pqrs","tuv","wxyz"};//the key array for edt
/*******************************************************************************
                                                                              
                                Private Methods
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	bookPhonebookDialog

 $Description:	Dialog function for the phone book application
 
 $Returns:		none

 $Arguments:	win, window handle
                event, event to be handled
            value, not used
            parameter, reason for call
 
*******************************************************************************/

static void bookPhonebookDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN   *win_data  = ((T_MFW_HDR *) win)->data;
    T_phbk      *data      = (T_phbk *) win_data->user;
    SHORT    *reason     = (SHORT *) parameter;
    /*
    char temp[100];
    TRACE_FUNCTION ("bookPhonebookDialog()");
    Sprintf(temp,"event,%d,reason,%d",event,*reason);
    TRACE_EVENT(temp);
    */

    switch( event )
    {
    case PHBK_INIT:
        {
            /* Initialise the phone book application.
               Note that we need to deal with a number of different
               initialisation types, depending on the reason given
            */
            memset( data->edt_buf_name,   '\0', sizeof( data->edt_buf_name   ) );
            memset( data->edt_buf_number, '\0', sizeof( data->edt_buf_number ) );

            /* 2004/05/26 sunsj modify */
            //bookSetEditAttributes( 4, 26, 80, 20, 0, 0, edtCurBar1, 0,
            //                       (char *) data->edt_buf_name,   PHB_name_len, &data->edt_attr_name   );
            //bookSetEditAttributes( 4, 26, 80, 20, 0, 0, edtCurBar1, 0,
            //                       (char *) data->edt_buf_number, PHB_number_len, &data->edt_attr_number );

            // deal with the different initialisation types			
            //if ((bookPhoneBookLoading()==BOOK_FAILURE)&&(( *reason )!=)&&(( *reason )!=PhbkHostkeyList))  //xsf add &&(( *reason )!=PhbkHostkeyList)) 08/19
            if( ( ( *reason )!=PhbkMainMenu) && (( *reason )!=PhbkHostkeyList)&& (( *reason )!=PhbkHostkeyOnOffList) && ((*reason)!=PhbkFromVoiceMemo) )
            {
                if( (bookPhoneBookLoading()==BOOK_FAILURE) )  //xsf add &&(( *reason )!=PhbkHostkeyList)) 08/19
                {

                    /*	T_DISPLAY_DATA display_info;
           
                       dialog_info_init(&display_info);//gdy add    			
                        display_info.TextId2       = TxtPleaseWait;				
                        display_info.Time         = 5000;
                        display_info.Callback     = (T_VOID_FUNC) NULL;
                           display_info.iconindex    =REMIND_WAITTING;
                        // Call Info Screen			    
                        info_dialog( idle_get_window(), &display_info );
           
                       bookPhonebookDestroy(data->win);
                       
                       Sprintf(temp,"reason:%d",*reason);
                       TRACE_EVENT(temp);
                    */ 
                    bookShowWait(data->win,*reason);
                    return;
                }
                else
                {

                    //hxl add for updata the nvm data
                    if( NVMLoadingPhbk==FALSE )
                    {
                        Get_NVM_data();
                        PHBKTotal=NVMTotal+SIMTotal;//hxl add fot update the 
                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
                        NVMLoadingPhbk=TRUE;
                    }

                    if( SIMLoadingPhbk==FALSE )
                    {
                        if( no_wait )
                        {
                            bookShowWait(data->win,*reason);
                            return;
                        }
                        else
                        {
                            TRACE_EVENT("glowing: bookPhonebookDialog---before GetSIMData");
                            GetSIMData();
                            TRACE_EVENT("glowing: bookPhonebookDialog---after GetSIMData");
                            phb_get_upn();
                            SIMLoadingPhbk=TRUE;
                        }
                    }
                }
            }

            switch( *reason )
            {
            case PhbkNormal:
                {
                    // Normal initialisation															
                    data->current.status.book  = bookActiveBook(READ);
                    data->current.index        = 1;                                
                    data->menu_main_win         = bookMenuStart( data->win, bookPhonebookMenuAttributes(), *reason);
                    data->root_win          = data->menu_main_win;

                    data->phbk->EntryType        =PhbkNormal;
                }
                break;

            case PhbkFromCall:
                {
                    data->phbk->current.status.book = bookActiveBook(READ);
                    data->phbk->EntryType         = PhbkFromCall; 
                    data->CallPhbk_win= bookCallPhbStart( data->phbk->win );
                    data->root_win=data->CallPhbk_win;
                }
                break;

            case PhbkMainMenu:
                {
                    // Normal initialisation					
                    data->current.status.book  = bookActiveBook(READ);
                    data->current.index        = 1;
                    data->menu_main_win         = bookMenuStart( data->win, bookMainMenuAttributes(), *reason);
                    data->root_win          = data->menu_main_win;
                }
                break;
                //xsf add 2002.08.19
            case PhbkHostkeyList:
                {
                    data->current.index        = 1;
                    data->menu_main_win         = bookMenuStart( data->win, bookHostkeyMenuAttributes(), *reason);
                    data->root_win          = data->menu_main_win;
                }
                break;
                //xsf add 2002.08.23
            case PhbkHostkeyOnOffList:
                {
                    data->current.index        = 1;
                    data->menu_main_win         = bookMenuStart( data->win, bookHostkeyOnOffAttributes(), *reason);
                    data->root_win          = data->menu_main_win;
                }
                break;

            case PhbkReplyListNormal:
                {
                    // reply list					
                    bookCallListStart(win,PHB_LRN);
                }
                break;
            case PhbkMissedCallsListNormal:
                {
                    // reply list					
                    bookCallListStart(win,PHB_LMN);
                }
                break;

            case PhbkRedialListNormal:
                {
                    // Redial list					
                    bookCallListStart(win,PHB_LDN);
                }
                break;

            case PhbkNameEnterIdle:
            case PhbkNameEnterSms:
            case PhbkNameEnterRecentCall: //wufei add 
                {
                    data->current.status.book  = bookActiveBook(READ);
                    data->current.index        = 1;
                    data->menu_main_win         = bookMenuStart( data->win, bookPhonebookAdd(), *reason);
                    data->root_win          = data->menu_main_win;
                    data->phbk->UpdateAction     = ADD_FROM_IDLE;
                    data->phbk->deletenumber=1;
                }
                break;
            case PhbkSearchNormal :
                {
                    // Search window					
                    data->root_win = data->phbk->search_win;
                }
                break;

            case PhbkFromSms :
                {        
                    if( IsPhbIN() )//current we have a phbk dynamic menu
                    {
                        data->phbk->current.status.book = bookActiveBook(READ);
                        data->phbk->EntryType         = PhbkFromSms; 
                        data->CallPhbk_win= bookCallPhbStart( data->phbk->win );
                        data->root_win=data->CallPhbk_win;
                    }
                    else
                    {
                        data->phbk->current.KindOfSearch = SEARCH_BY_NAME;              
                        data->phbk->current.status.book   = bookActiveBook(READ);
                        data->phbk->EntryType           =PhbkFromSms;
                        data->phbk->search_win          = bookSearchStart( data->phbk->win );
                        data->root_win                   = data->phbk->search_win;
                    }
                }
                break;
            case PhbkFromVoiceMemo:
                {                    
                    data->menu_main_win         = bookMenuStart( data->win, bookPhonebookVoiceMemo(), *reason);
                    data->root_win          = data->menu_main_win;
                }  
                break;   
            case PhbkFromShortcutKey :
                {
                    data->phbk->current.status.book = bookActiveBook(READ);
                    data->phbk->EntryType         = PhbkFromShortcutKey; 
                    data->phbk->search_win        = bookSearchStart( data->phbk->win );
                    data->root_win                 = data->phbk->search_win;                   
                } 
                break;

            case PhbkFromDivert:
                {              
                    data->phbk->EntryType=PhbkFromDivert;                          
                    data->phbk->current.KindOfSearch = SEARCH_BY_NAME;
                    data->phbk->current.status.book = bookActiveBook(READ);
                    data->phbk->search_win = bookSearchStart( data->phbk->win );
                    data->root_win = data->phbk->search_win;              
                }
                break;

            default:
                {
                    // No default action required					
                }
            }
        }
        break;
    case PHBK_SEND_NUMBER:
        TRACE_EVENT ("PHBK_SEND_NUMBER");
        /*2004/04/07,talcon delete
        {
           char temp[100];
           sprintf(temp,"win %p parameter %s data->phbk %p",win,(char*)parameter,data->phbk);
           TRACE_EVENT (temp);
        }*/
        strncpy((char *) data->phbk->edt_buf_foradd,  (char*)parameter, PHB_number_len );
        break;
    default:
        {
            // No default action required			
        }
    }
}

/*******************************************************************************

 $Function:    	bookPhonebookWindowCB

 $Description:	Window call back for the phone book application
 
 $Returns:		MFW_EVENT_CONSUMED if event is MfwWinVisible, otherwise
            MFW_EVENT_PASSED

 $Arguments:	e, event, w, window handle
 
*******************************************************************************/

static int bookPhonebookWindowCB ( MfwEvt e, MfwWin *w )
{
    TRACE_FUNCTION ("bookPhonebookWindowCB()");
    return( e == MfwWinVisible ) ? MFW_EVENT_CONSUMED : MFW_EVENT_PASSED;
}

/*******************************************************************************

 $Function:    	bookPhonebookCreate

 $Description:	Create the phone book application
 
 $Returns:		Handle of the newly created window or NULL if error

 $Arguments:	parent, handle of parent window
 
*******************************************************************************/

static T_MFW_HND bookPhonebookCreate( MfwHnd parent )
{
    T_MFW_WIN   *win_data;
    T_phbk       *data;

    TRACE_FUNCTION ("bookPhonebookCreate()");

    if( ( data = (T_phbk *) ALLOC_MEMORY( sizeof( T_phbk ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookPhonebookWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( T_phbk ) );
        return NULL;
    }

    // Create window handler    
    data->mmi_control.dialog   = (T_DIALOG_FUNC) bookPhonebookDialog;
    data->mmi_control.data     = data;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;
    winShow(data->win);

    // initialise the options structure	
    data->root_win             = 0;
    data->menu_main_win          = 0;
    data->calls_list_win       = 0;
    data->menu_options_win        = 0;
    data->menu_options_win_2      = 0;
    data->menu_call_options_win      = 0;
    data->menu_call_options_win_2 = 0;
    data->name_details_win        = 0;
    data->search_win           = 0;
    data->fromSMS              = FALSE;
    data->fromDivert            = FALSE;
    data->parent_win           = parent;
    data->phbk                 = data;

    // return window handle    
    return data->win;
}

/*******************************************************************************
                                                                              
                                Public methods
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	bookPhonebookStart

 $Description:	Starts up the phone book application
 
 $Returns:		Handle of window or NULL if error

 $Arguments:	parent, window, reason, for invocation
 
*******************************************************************************/

T_MFW_HND bookPhonebookStart( MfwHnd parent, int reason )
{
    T_MFW_HND win;
    /*2004/04/07,talcon delete
    char temp[100];
    Sprintf(temp,"reason,%d,formcall,%d",reason,PhbkFromCall);
    TRACE_EVENT(temp);*/
    if( ( win = bookPhonebookCreate( parent ) ) != NULL )
        SEND_EVENT( win, PHBK_INIT, 0, (int *) &reason );
    return win;
}

/*******************************************************************************

 $Function:    	bookPhonebookDestroy

 $Description:	Destroys the phone book application
 
 $Returns:		none

 $Arguments:	window, to be destroyed
 
*******************************************************************************/

void bookPhonebookDestroy( MfwHnd window )
{
    T_MFW_WIN   *win  = ((T_MFW_HDR *)window)->data;
    T_phbk      *data = (T_phbk *) win->user;

    TRACE_FUNCTION ("bookPhonebookDestroy()");

    if( data )
    {
        /* need to clean up all of the subordinate windows which
           may have been created during the phone book application
        */
        data->root_win = 0;
        if( data->search_win )
            bookSearchDestroy( data->search_win );

        if( data->menu_main_win )
            bookMenuDestroy(data->menu_main_win);

        if( data->calls_list_win )
            bookCallListDestroy(data->calls_list_win);

        if( data->menu_options_win )
            bookMenuDestroy(data->menu_options_win);

        if( data->menu_options_win_2 )
            bookMenuDestroy(data->menu_options_win_2);

        if( data->menu_call_options_win )
            bookMenuDestroy(data->menu_call_options_win);

        if( data->menu_call_options_win_2 )
            bookMenuDestroy(data->menu_call_options_win_2);

        if( data->name_details_win )
            bookDetailsDestroy(data->name_details_win);
        if( data->CallPhbk_win )
            bookCallPhbDestroy(data->CallPhbk_win);
        /*
              if (data->input_name_win)
                 bookInputDestroy(data->input_name_win);
        
              if (data->input_number_win)
                 bookInputDestroy(data->input_number_win);
        */

        // delete the window and free any allocated memory
        if( call_data.win_phb==window )
            call_data.win_phb=NULL;
        winDelete (data->win);
        FREE_MEMORY( (void *) data, sizeof( T_phbk ) );
    }

}

#if 0
static int ReadEntries(U8 p_type, U8 p_idx, U8 p_mode, U8 p_number)
{    
    memset(&l_phb_entry, 0, sizeof(l_phb_entry));
    memset(&l_phb_list, 0, sizeof(l_phb_list));
    l_phb_list.entry = l_phb_entry;
    l_phb_list.num_entries = PE_SIZE;

    if( phb_read_entries(p_type, p_idx, p_mode, p_number, &l_phb_list)!=MFW_PHB_OK )
        return 1;

    l_phb_status.book = (UBYTE)p_type;

    if( phb_get_status(&l_phb_status) == MFW_PHB_OK )
        l_found = l_phb_status.used_entries;
    return 0;
}

static int ReadSIM_Init(U8 p_type,U8 p_mode)
{
    T_MFW_PHB_STATUS  status;

    /* get actual status of specific phonebook */
    memset(&status, 0, sizeof(T_MFW_PHB_STATUS));
    status.book = p_type;
    if( phb_get_status(&status) != MFW_PHB_OK )//SIMǷ               
        return 1;

    l_startidx = 1;
    l_idx =0;

    ReadEntries(p_type,l_startidx,p_mode,PE_SIZE);
    if( l_found==0 ) return 2;
    return 0;
}
#endif
//yq added for show the phbnumber in calling
static void bookCallPhb_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user;
    T_phbk           * Phbk     = data->phbk;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;

    T_MFW_PHB_ENTRY   l_phb_Shortentry;
    PhbkDetailItem       l_phb_NVMEntry; 
    int                 i;
    UBYTE oldmode=dspl_Enable(0);

    switch( ListData->Reason )
    {
    case LISTS_REASON_SEND:
    case LISTS_REASON_SELECT:
        if( Phbk->EntryType==PhbkFromCall )
        {
            memset(data->edtBuf,0,sizeof(data->edtBuf));

            if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
            {
                if( ReadNVMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_NVMEntry) )
                {
                    timStop(showtimer);
                    timStop(edttimer);
                    listsDestroy(ListData->win);
                    FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));  
                    data->menu_list_data=NULL;
                    bookCallPhbDestroy(Parent);
                    switch( CurrentType )
                    {
                    T_EasyName data;
                    memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                    memcpy(data.number,(char *)l_phb_NVMEntry.number,PHB_number_len);
                    SetCallData(data);
                    case B_NUMBER:
                        {                      
                            callNumber((UBYTE *)l_phb_NVMEntry.number);
                        } 
                        break;
                    case B_HOME:
                        {                      
                            callNumber((UBYTE *)l_phb_NVMEntry.home);
                        } 
                        break;
                    case B_OFFICE:
                        {                      
                            callNumber((UBYTE *)l_phb_NVMEntry.office);
                        } 
                        break;
                    default:break;
                    }                  
                }
            }
            else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_Shortentry) )
                {
                    T_EasyName data1;
                    timStop(showtimer);
                    timStop(edttimer);
                    listsDestroy(ListData->win);
                    FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));           
                    data->menu_list_data=NULL;
                    bookCallPhbDestroy(Parent);
                    memcpy(data1.name,(char *)l_phb_Shortentry.name.data,PHB_name_len+2);
                    memcpy(data1.number,(char *)l_phb_Shortentry.number,PHB_number_len);
                    SetCallData(data1);
                    callNumber((UBYTE *) l_phb_Shortentry.number);
                }
            }

        }
        else if( Phbk->EntryType==PhbkFromSms )
        {
            if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
            {
                if( ReadNVMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_NVMEntry) )
                {
                    switch( CurrentType )
                    {
                    case B_NUMBER:
                        {
                            SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,
                                        (UBYTE *)l_phb_NVMEntry.number);
                        }  
                        break;
                    case B_HOME:
                        {
                            SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,
                                        (UBYTE *)l_phb_NVMEntry.home);

                        }   
                        break;
                    case B_OFFICE:
                        {
                            SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,
                                        (UBYTE *)l_phb_NVMEntry.office);

                        }   
                        break;
                    default:break;
                    }                  
                }
            }
            else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_Shortentry) )
                {
                    SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,(UBYTE *) l_phb_Shortentry.number);

                }
            }
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));             
            data->menu_list_data=NULL;
            bookCallPhbDestroy(data->win);               
        }
        break;


    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //	break;
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            timStop(showtimer);
            timStop(edttimer);
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));  
            data->menu_list_data=NULL;
            bookCallPhbDestroy(Parent);
        }
        break;
    case LISTS_REASON_BACK:

        {

            if( wstrlen(data->edtBuf)==0 )
            {
                timStop(showtimer);
                timStop(edttimer);
                listsDestroy(ListData->win);

                FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));  
                data->menu_list_data=NULL;
                bookCallPhbDestroy(Parent);
            }

            else
                edtChar(data->edt,ecBack);
        }
        break;
    case LISTS_REASON_UPDATE:
        {
            show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;

            refresh_flag=1;
#if(MAIN_LCD_SIZE==4)
            dspl_Clear(0,108,SCREEN_SIZE_X,126);
            /* 2004/06 sunsj modify for icon manage */
            //dspl_BitBlt(0, 110, 14, 14, 0, (void *)abc_bmp, 0);
            DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
			ShowPhoneBookNumber(show_index,NONE);
            edtChar(data->edt,ecBottom);
#elif(MAIN_LCD_SIZE==3)//Knuth
			//dspl_Clear(0,87,128,113);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 70);
			DRAW_ICON(ICON_SOFTKEYBAR);
			displaySoftKeys(TxtSoftSelect,TxtSoftBack);
			ShowPhoneBookNumber(show_index,NONE);
            edtChar(data->edt,ecBottom);
#endif
        }   
        break;
    case LISTS_REASON_UP:
        {
            if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                mnuUp(dataInfo->MenuLists);              
                show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal+1;             
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
		    /* 2004/06 sunsj modify for picture manage */
                    memcpy(Dynamic_menu[i].name,l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                    if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                    else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                }     
                mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                show_index=l_phb_sort_index[(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal].index;
                show_number();
            }
        }
        break;
    case LISTS_REASON_DOWN:
        {
            if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                mnuDown(dataInfo->MenuLists);             
                show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal].index;
                show_number();
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex)%SearchTotal)+1; 
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
		    /* 2004/06 sunsj modify for picture manage */
                    memcpy(Dynamic_menu[i].name,l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                    if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                    else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                }     
                mnuChooseVisibleItem(dataInfo->MenuLists,0);
                show_index=l_phb_sort_index[(Phbk->BufferIndex)%SearchTotal].index;
                show_number();
            }
        }   
        break;
    case LISTS_REASON_LEFT:
        {
            if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
        }   
        break;
    case LISTS_REASON_RIGHT:
        {
            if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
        }
        break;
    case LISTS_REASON_KCD2:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_2);
        }    
        break;                                              
    case LISTS_REASON_KCD3: 
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_3);
        }    
        break;
    case LISTS_REASON_KCD4:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_4);
        }     
        break;                                                                                          
    case LISTS_REASON_KCD5:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_5);
        }     
        break;                                             
    case LISTS_REASON_KCD6:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_6);
        }     
        break;                                              
    case LISTS_REASON_KCD7:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_7);
        }     
        break;                                              
    case LISTS_REASON_KCD8:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_8);
        }     
        break;                                              
    case LISTS_REASON_KCD9:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_9);
        }     
        break;                                             
    default:break;     
    }                              
    dspl_Enable(oldmode);
}


void bookCallPhbDestroy( MfwHnd window )
{
    T_MFW_WIN      *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard  *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookCallPhbDestroy()" );

    // Only destroy if the data is valid	
    if( data )
    {
        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );
            return;
        }
        if( showtimer )
        {
            timStop(showtimer);
            timDelete(showtimer);
            showtimer=0;
        }
        if( edttimer )
        {
            timStop(edttimer);
            timDelete(edttimer);
            edttimer=0;
        }
        if( data->menu_list_data!=NULL )
        {
            TRACE_EVENT("we have win");
            listsDestroy(data->menu_list_data->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
            data->menu_list_data=NULL;
        }
        key_before=0xff;
        cursor_correct=1;
        key_index=0;
        SearchTotal=search_total;
        // delete ourself		
        data->phbk->CallPhbk_win=0;
        ClearCallWindowHandle();
        winDelete( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}
static void show_number()
{
    UBYTE old_mode;
    UINT32 b_color;
    TRACE_EVENT("show_number");
    if( showtimer )
    {
        TRACE_EVENT("we have showtimer");
        timStop(showtimer);
        timStart(showtimer);
    }
    if( refresh_flag==1 )
    {
        TRACE_EVENT("we need refresh");
        old_mode=dspl_Enable(0);
        b_color=dspl_SetBkgColor(0xF8E0EE);

#if(MAIN_LCD_SIZE==4)
        dspl_Clear (0,126,SCREEN_SIZE_X,142);
#elif(MAIN_LCD_SIZE==3)
        //dspl_Clear (0,100,SCREEN_SIZE_X,113);
		phonebook_search_flag=TRUE;
#endif
        dspl_SetBkgColor(b_color);

        refresh_flag=0;
        dspl_Enable(old_mode);
    }
}

static T_MFW_CB showtimer_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHdr *win=(MfwHdr *)mfwParent((MfwHdr *)showtimer);
    T_MFW_WIN    *win_data=(MfwWin *)(win->data);
    tBookStandard  *data=(tBookStandard *)(win_data->user);
    T_phbk           * Phbk     = data->phbk;
    MfwHdr *mnu_win=data->menu_list_data->win;//yq modified 2003/3/12.(MfwHdr *)mfwParent(mfwFocus);	

    timStop(showtimer);
    refresh_flag=1;
    if( winIsFocussed(mnu_win) )
        ShowPhoneBookNumber(show_index,NONE);
    return 0;
}

static void yq_edtchar(T_MFW_HND edt,unsigned char code)
{
    MfwHdr *win=(MfwHdr *)mfwParent((MfwHdr *)edt);
    T_MFW_WIN    *win_data=(MfwWin *)(win->data);
    tBookStandard  *data=(tBookStandard *)(win_data->user);
    TRACE_EVENT("yq_edtchar");
    if( edttimer )
        timStop(edttimer);
    if( cursor_correct )
    {
        edtChar(edt,edt_key[code-2][key_index]);
        edtChar(edt,ecLeft);
        timStart(edttimer);

        key_index=0;
    }
    else
    {
        if( code==key_before )
        {
            key_index++;
            if( key_index>=wstrlen((char *)edt_key[code-2]) )
                key_index=0;
            edtChar(edt,ecDel);
            edtChar(edt,edt_key[code-2][key_index]);
            edtChar(edt,ecLeft);
            timStart(edttimer);
        }
        else
        {
            edtChar(edt,ecRight);
            edtChar(edt,edt_key[code-2][0]);
            edtChar(edt,ecLeft);
            timStart(edttimer);

            key_index=0;
        }
    }
    cursor_correct=0;
    key_before=code;
    TRACE_EVENT("yq:now the edt buffer:");
    TRACE_EVENT((char *)data->edtBuf);
}

static T_MFW_CB edttimer_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHdr *win=(MfwHdr *)mfwParent((MfwHdr *)edttimer);
    T_MFW_WIN    *win_data=(MfwWin *)(win->data);
    tBookStandard  *data=(tBookStandard *)(win_data->user);
    T_phbk           * Phbk     = data->phbk;
    MfwHdr *mnu_win=data->menu_list_data->win;//yq modified 2003/3/12.(MfwHdr *)mfwParent(mfwFocus);
    T_MFW_WIN *mnu_data=(MfwWin *)(mnu_win->data);
    ListWinInfo        * dataInfo = (ListWinInfo *)mnu_data->user;
    TRACE_EVENT("edttimer_cb");
    timStop(edttimer);
    key_before=0xff;
    cursor_correct=1;
    key_index=0;
    if( winIsFocussed(mnu_win) )
    {
        ShortCutLocation(dataInfo,(char *)data->edtBuf,Phbk->BufferTable,&(Phbk->BufferIndex),100);
        edtChar(data->edt,ecRight);
    }
    return 0;
}

static void book_callphb_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{


    TRACE_FUNCTION ("book_callphb_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT:   
        {
            bookCallPhbDestroy( win );
        }      
        break;                                                   
    default: break;
    }
}

static void bookCallPhbDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN     *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard *data    = (tBookStandard *) win_data->user;
    T_phbk *Phbk=data->phbk;
    char * titleStr;
    int i;
    /*2004/04/07,talcon delete
    char temp[100];*/
    TRACE_EVENT("bookCallPhbDialog");
    switch( event )
    {
    case CALLPHB_INIT:
        TRACE_EVENT("callphbdialog Init");
        if( PHBKTotal )
        {
            TRACE_EVENT("has phb");
            if( PHBKTotal<=PHONEBOOK_RECORD_PERPAGE )
            {
                for( i=0;i<PHBKTotal;i++ )
                {
		    /* 2004/06 sunsj modify for picture manage */
                    memcpy(Dynamic_menu[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);        
                    if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                    else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                }    
            }
            else
            {
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
		    /* 2004/06 sunsj modify for picture manage */
                    memcpy(Dynamic_menu[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);                                     
                    if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                    else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                        Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                }   
            }
            Phbk->BufferIndex=0;
            search_total=SearchTotal;
            SearchTotal=PHBKTotal;
            Phbk->BufferTable=GlobalTable;
            TRACE_EVENT("all the first memort");
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                TRACE_EVENT("no memoryin");
                //destroy the dialog     
                bookCallPhbDestroy(win);
            }
            else//alloc memory ok!
            {
                TRACE_EVENT("all the second memort");
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(SearchTotal) *sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )//alloc_memory ok
                {
                    TRACE_EVENT("all memory alloc ok!");
                    for( i = 0; i < GetFree(SearchTotal); i++ )
                    {
                        data->menu_list_data->List[i].icon =&Dynamic_menu[i].bookicon;                
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit = 0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].func = NULL;   
                        data->menu_list_data->List[i].str=(char *)Dynamic_menu[i].name;                                                                                                
                        data->menu_list_data->List[i].flagFunc=item_flag_none;
                    }

                    data->menu_list_data->ListLength     = GetFree(SearchTotal);
                    data->menu_list_data->SnapshotSize  = GetFree(SearchTotal);
                    data->menu_list_data->Font          = 0;

                    if( data->phbk->EntryType==PhbkFromCall )
                        data->menu_list_data->LeftSoftKey    = TxtSoftCall;
                    else if( data->phbk->EntryType==PhbkFromSms )
                        data->menu_list_data->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    //data->menu_list_data->Attr           = &readName_menuAttrib;  
                    data->menu_list_data->Attr           = & readName_fromcall_menuAttrib; /*2003/12/16, wangyan modify call phonebook area*/
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1; 
                    /* glowing: modify TxtSearchName to TxtPhoneSearch */
                    //titleStr=MmiRsrcGetText(TxtSearchName);
                    titleStr=MmiRsrcGetText(TxtPhoneSearch);
                    data->menu_list_data->ListMenuHeadStr=titleStr;
                    data->menu_list_data->ListPosition    = 1;               
                    data->menu_list_data->CursorPosition = 1;
                    TRACE_EVENT("now we display the menu");
                    /* 2004/05/26 sunsj modify */
                    edtShow(data->edt);
                    edtChar(data->edt,ecBottom);

                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookCallPhb_cb,0);
                    show_index=l_phb_sort_index[Phbk->BufferIndex].index;
                    refresh_flag=1;
                    
                    /* 2004/06 sunsj modify for icon manage */
#if(MAIN_LCD_SIZE==4)
					dspl_Clear(0,108,SCREEN_SIZE_X,126);
		            DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)//Knuth
					dspl_Clear(0,72,128,110);
					DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
					ShowPhoneBookNumber(show_index,NONE);
                    //edtShow(data->edt);
                    //edtChar(data->edt,ecBottom);
                }
                else
                {
                    TRACE_EVENT("second no memory");
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    //destroy the dialog
                    bookCallPhbDestroy(win);
                }  
            }
        }
        else
        {
            TRACE_EVENT("no phb");
            bookShowInformation(win, TxtEmptyList, NULL, (T_VOID_FUNC)book_callphb_cb);
        }
        break;
    }
}

static T_MFW_HND bookCallPhbCreate( MfwHnd parent )
{
    T_MFW_WIN      *win_data;
    tBookStandard  *data;
    T_MFW_WIN      *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    T_phbk         *Phbk = (T_phbk *)parent_win_data->user;
    TRACE_FUNCTION ("bookCallPhbCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, NULL) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    // Okay, we have created the control block and the window, so
    //   we now need to configure the dialog and data pointers	
    data->mmi_control.dialog  = (T_DIALOG_FUNC) bookCallPhbDialog;
    data->mmi_control.data    = data;
    win_data               = ((T_MFW_HDR *)data->win)->data;
    win_data->user          = (void *) data;
    data->parent_win        = parent;
    data->phbk=Phbk;
#if(MAIN_LCD_SIZE==3)
	bookSetEditAttributes(20,85,32,30,0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#elif (MAIN_LCD_SIZE==4)
    bookSetEditAttributes(20, 108, 32, 16, 0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#endif
    data->edt=edtCreate(data->win,&data->attr,0,0);
    if( !showtimer )
    {
        TRACE_EVENT("need create showtimer");
#ifndef FOR_FTA_CTA
        showtimer=timCreate(data->win,300,(MfwCb)showtimer_cb);
#endif
    }
    if( !edttimer )
    {
        TRACE_EVENT("need create showtimer");
#ifndef FOR_FTA_CTA
        edttimer=timCreate(data->win,500,(MfwCb)edttimer_cb);
#endif
    }
    return data->win;
} 

T_MFW_HND bookCallPhbStart( MfwHnd parent)
{
    T_MFW_HND win;
    TRACE_EVENT("bookCallPhbStart");
    if( ( win = bookCallPhbCreate( parent ) ) != NULL )
    {
        SetCallWindowsHandle(win);
        SEND_EVENT( win, CALLPHB_INIT, 0, 0 );
    }
    return win;
}

//end yq added
void Create_SORT_Table(T_MFW_PHB_INDEX l_phb_index[],int RecordLen)
{
    int i,j;  
    //char temp[100];/*2004/04/07,talcon delete*/
    TRACE_EVENT("create_sort_table");
    if( PHBKTotal!=0 )
    {
        memset(l_phb_sort_index,0,sizeof(l_phb_sort_index));
        for( i=0,j=0;i<RecordLen;i++ )
        {
            if( CheckFlag(i) )
            {
                l_phb_sort_index[j].name=GetShortName(l_phb_index[i].name);
                l_phb_sort_index[j].index=i;
                j=j+1;     
            }
        }
        if( j>1 ) ChoiceSort(l_phb_sort_index,j);
    }
}

static void ChoiceSort(T_MFW_PHB_SORT_INDEX *SortData,int RecordLen)//ѡ
{
    T_MFW_PHB_SORT_INDEX TempRecord;

    int i,j,k;

    for( i=0;i<RecordLen-1;i++ )
    {
        k=i;
        for( j=i+1;j<RecordLen;j++ )
            if( SortData[j].name<SortData[k].name ) k=j;

        TempRecord.index=SortData[k].index;      
        TempRecord.name=SortData[k].name;      

        SortData[k].index=SortData[i].index;         
        SortData[k].name=SortData[i].name;

        SortData[i].index=TempRecord.index;          
        SortData[i].name=TempRecord.name;     
    }    
}

int SetSearchLocation(T_SearchResult *SortData,int Index)
{
    int s,j,m,k;
    T_SearchResult TempRecord;  
    // char temp[50];/*2004/04/07,talcon delete*/
    int   backindex;

    TempRecord.index=SortData[Index].index;
    TempRecord.selectflag=SortData[Index].selectflag;

    switch( SearchTotal )
    {
    case 1:
        {
            backindex=Index;
        } 
        break;
    case 2:
        {
            if( Index==1 )
            {
                if( GetShortName(l_phb_index[SortData[Index].index].name)<
                    GetShortName(l_phb_index[SortData[Index-1].index].name) )
                {
                    SortData[Index].index=SortData[Index-1].index;
                    SortData[Index].selectflag=SortData[Index-1].selectflag;

                    SortData[Index-1].index=TempRecord.index;
                    SortData[Index-1].index=TempRecord.selectflag;
                    backindex=Index-1;
                }
                else backindex=Index;
            }
            else if( Index==0 )
            {
                if( GetShortName(l_phb_index[SortData[Index].index].name)>
                    GetShortName(l_phb_index[SortData[Index+1].index].name) )
                {
                    SortData[Index].index=SortData[Index+1].index;
                    SortData[Index].selectflag=SortData[Index+1].selectflag;

                    SortData[Index+1].index=TempRecord.index;
                    SortData[Index+1].selectflag=TempRecord.selectflag;
                    backindex=Index+1;
                }
                else backindex=Index;
            }
        } 
        break;        
    default:
        {
            if( Index!=0 && Index!=SearchTotal-1 )
            {
                if( GetShortName(l_phb_index[SortData[Index].index].name)<
                    GetShortName(l_phb_index[SortData[Index-1].index].name) )
                {
                    s=0;
                    j=Index-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( GetShortName(l_phb_index[SortData[Index].index].name)<
                            GetShortName(l_phb_index[SortData[m].index].name) )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index-1;k>=j+1;k-- )
                    {
                        SortData[k+1].index=SortData[k].index;
                        SortData[k+1].selectflag=SortData[k].selectflag;
                    }      
                    SortData[j+1].index=TempRecord.index;
                    SortData[j+1].selectflag=TempRecord.selectflag;
                    backindex=j+1;       
                }
                else if( GetShortName(l_phb_index[SortData[Index].index].name)>
                         GetShortName(l_phb_index[SortData[Index+1].index].name) )
                {
                    s=Index+1;
                    j=SearchTotal-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( GetShortName(l_phb_index[SortData[Index].index].name)<
                            GetShortName(l_phb_index[SortData[m].index].name) )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index;k<=j;k++ )
                    {
                        SortData[k].index=SortData[k+1].index;
                        SortData[k].selectflag=SortData[k+1].selectflag;
                    }            
                    SortData[j].index=TempRecord.index;
                    SortData[j].selectflag=TempRecord.selectflag;
                    backindex=j;
                }
                else backindex=Index;
            }
            else if( Index==0 )
            {
                if( GetShortName(l_phb_index[SortData[Index].index].name)>
                    GetShortName(l_phb_index[SortData[Index+1].index].name) )
                {
                    s=Index+1;
                    j=SearchTotal-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( GetShortName(l_phb_index[SortData[Index].index].name)<
                            GetShortName(l_phb_index[SortData[m].index].name) )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index;k<=j;k++ )
                    {
                        SortData[k].index=SortData[k+1].index;
                        SortData[k].selectflag=SortData[k+1].selectflag;
                    }            
                    SortData[j].index=TempRecord.index;
                    SortData[j].selectflag=TempRecord.selectflag;
                    backindex=j;
                }
                else backindex=Index;           
            }
            else if( Index==SearchTotal-1 )
            {
                if( GetShortName(l_phb_index[SortData[Index].index].name)<
                    GetShortName(l_phb_index[SortData[Index-1].index].name) )
                {
                    s=0;
                    j=Index-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( GetShortName(l_phb_index[SortData[Index].index].name)<
                            GetShortName(l_phb_index[SortData[m].index].name) )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index-1;k>=j+1;k-- )
                    {
                        SortData[k+1].index=SortData[k].index;
                        SortData[k+1].selectflag=SortData[k].selectflag;
                    }       
                    SortData[j+1].index=TempRecord.index;
                    SortData[j+1].selectflag=TempRecord.selectflag;
                    backindex=j+1;        
                }
                else backindex=Index;
            }
        }
        break;
    }
    return backindex;
}

int SetLocation(T_MFW_PHB_SORT_INDEX *SortData,int Index)
{
    int s,j,m,k;
    T_MFW_PHB_SORT_INDEX TempRecord;  
    //char temp[50];/*2004/04/07,talcon delete*/
    int backindex;

    TempRecord.name=SortData[Index].name;
    TempRecord.index=SortData[Index].index;

    switch( SearchTotal )
    {
    case 1:
        {
            backindex=Index;
        } 
        break;
    case 2:
        {
            if( Index==1 )
            {
                if( SortData[Index].name<SortData[Index-1].name )
                {
                    SortData[Index].name=SortData[Index-1].name;
                    SortData[Index].index=SortData[Index-1].index;

                    SortData[Index-1].name=TempRecord.name;
                    SortData[Index-1].index=TempRecord.index;           
                    backindex=Index-1;
                }
                else backindex=Index;
            }
            else if( Index==0 )
            {
                if( SortData[Index].name>SortData[Index+1].name )
                {
                    SortData[Index].name=SortData[Index+1].name;
                    SortData[Index].index=SortData[Index+1].index;

                    SortData[Index+1].name=TempRecord.name;
                    SortData[Index+1].index=TempRecord.index;

                    backindex=Index+1;
                }
                else backindex=Index;
            }
        } 
        break;        
    default:
        {
            if( Index!=0 && Index!=SearchTotal-1 )
            {
                if( SortData[Index].name<SortData[Index-1].name )
                {
                    s=0;
                    j=Index-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( SortData[Index].name<SortData[m].name )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index-1;k>=j+1;k-- )
                    {
                        SortData[k+1].name=SortData[k].name;
                        SortData[k+1].index=SortData[k].index;             
                    }      

                    SortData[j+1].name=TempRecord.name;
                    SortData[j+1].index=TempRecord.index;
                    backindex=j+1;       
                }
                else if( SortData[Index].name>SortData[Index+1].name )
                {
                    s=Index+1;
                    j=SearchTotal-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( SortData[Index].name<SortData[m].name )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index;k<=j;k++ )
                    {
                        SortData[k].name=SortData[k+1].name;
                        SortData[k].index=SortData[k+1].index;

                    }            
                    SortData[j].name=TempRecord.name;
                    SortData[j].index=TempRecord.index;
                    backindex=j;
                }
                else backindex=Index;
            }
            else if( Index==0 )
            {
                if( SortData[Index].name>SortData[Index+1].name )
                {
                    s=Index+1;
                    j=SearchTotal-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( SortData[Index].name<SortData[m].name )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index;k<=j;k++ )
                    {
                        SortData[k].name=SortData[k+1].name;
                        SortData[k].index=SortData[k+1].index;                
                    }        
                    SortData[j].name=TempRecord.name;
                    SortData[j].index=TempRecord.index;
                    backindex=j;
                }
                else backindex=Index;           
            }
            else if( Index==SearchTotal-1 )
            {
                if( SortData[Index].name<SortData[Index-1].name )
                {
                    s=0;
                    j=Index-1;

                    while( s<=j )
                    {
                        m=(s+j)/2;
                        if( SortData[Index].name<SortData[m].name )
                            j=m-1;
                        else s=m+1;
                    }

                    for( k=Index-1;k>=j+1;k-- )
                    {
                        SortData[k+1].name=SortData[k].name;
                        SortData[k+1].index=SortData[k].index;                   
                    }       
                    SortData[j+1].name=TempRecord.name;
                    SortData[j+1].index=TempRecord.index;
                    backindex=j+1;        
                }
                else backindex=Index;
            }
        }
        break;
    }
    return backindex;   
}

USHORT GetShortName(UBYTE NameData[])  
{

    int              i,OffSetPosition;  
    unsigned short   HzWord1,HzWord2;
    unsigned short   Temp;
    unsigned short   LowWord = 0;	/* 2004/07/06 sunsj modify */
    USHORT         Tempindex;
    U8              NotFindHanZi,tempchar,tempchar1;
    unsigned short  pinyin[10];
    //char             tempdata[100],temp[100];/*2004/04/07,talcon delete*/
    Tempindex = 0x0000;
	HzWord1 = 0x0000;
    HzWord2 = 0x0000;
    if( strlen((char *)NameData) )  //chinese first
    {
        i=0;    

        if( (NameData[i]==0x80) && (NameData[i+1]!=0x00) )
        {
            HzWord1=NameData[i+1];
            HzWord1=HzWord1<<8;       
            HzWord1=HzWord1+NameData[i+2];

            OffSetPosition=0;                        
            NotFindHanZi=1;

            memset(pinyin, 0x00, sizeof(pinyin));
            Zi8GetCharInfo(HzWord1, pinyin, 10, 1);
            Temp = (pinyin[0]&0x00ff) << 8;
            Tempindex = Tempindex+Temp;
			
            /*
            while( (OffSetPosition<MaxHanZi) && NotFindHanZi )
            {
                if( HzWord1==(*(HLCode+OffSetPosition+3)) )
                {
                    Temp=(*(HLCode+OffSetPosition)&0xff00);
                    NotFindHanZi=0;                                   
                    Tempindex=Tempindex+Temp;
                    //LowWord=*(HLCode+OffSetPosition+1);
                    //tempchar=(U8)((LowWord>>12)&0x0f);
                    //tempchar1=UnchangePinYinProgramCode(tempchar);
                    //Tempindex=(Temp&0xff00)|(USHORT)(tempchar1);
                    //Tempindex=Temp+0x01;              
                }
                OffSetPosition+=4;                  
            }
            */
            if( (NameData[i+3]!=0x00) )   //second word is chinese
            {

                HzWord2=NameData[i+3];
                HzWord2=HzWord2<<8;       
                HzWord2=HzWord2+NameData[i+4];

                OffSetPosition=0;                        
                NotFindHanZi=1;

                memset(pinyin, 0x00, sizeof(pinyin));
                Zi8GetCharInfo(HzWord2, pinyin, 10, 1);
                Temp = (pinyin[0]&0x00ff);
		Tempindex = Tempindex+Temp;
		/*
                while( (OffSetPosition<MaxHanZi) && NotFindHanZi )
                {
                    if( HzWord2==(*(HLCode+OffSetPosition+3)) )
                    {
                        LowWord=((*(HLCode+OffSetPosition)>>8)&0x00ff);
                        NotFindHanZi=0;                                   
                    }
                    OffSetPosition+=4;                  
                }
		*/
            }
            else if( (NameData[i+3]==0x00)&&((NameData[i+4]!=0x00)) )   //sescond word is english
            {
                LowWord=(unsigned char)ChLowCase(NameData[i+4]);
            }

            Tempindex=(Tempindex&0xff00)|(LowWord&0x00ff);

            /*    sprintf(temp,"xzy:LowWord:%d",(USHORT)LowWord);
              TRACE_EVENT(temp);
                sprintf(temp,"xzy:tempchar:%d",(USHORT)tempchar);
              TRACE_EVENT(temp);
                sprintf(temp,"xzy:tempchar1:%c",(U8)tempchar1);
              TRACE_EVENT(temp);
               sprintf(temp,"xzy:Tempindex:%d",(USHORT)Tempindex);
              TRACE_EVENT(temp);
        */
        }
        else //english first
        {
            if( (NameData[i]==0x80) && (NameData[i+1]==0x00) ) //english unicode
            {
                Tempindex=Tempindex+(unsigned char)ChLowCase(NameData[i+2]);

                if( NameData[i+3]!=0x00 )   //first english,second chinese unicode
                {
                    HzWord2=NameData[i+3];
                    HzWord2=HzWord2<<8;       
                    HzWord2=HzWord2+NameData[i+4];

                    OffSetPosition=0;                        
                    NotFindHanZi=1;

                    memset(pinyin, 0x00, sizeof(pinyin));
                    Zi8GetCharInfo(HzWord1, pinyin, 10, 1);
                    Temp = (pinyin[0]&0x00ff);
                    Tempindex = Tempindex+Temp;
                    /*
                    while( (OffSetPosition<MaxHanZi) && NotFindHanZi )
                    {
                        if( HzWord2==(*(HLCode+OffSetPosition+3)) )
                        {
                            Temp=*(HLCode+OffSetPosition);
                            LowWord=((Temp>>8)&0x00ff);
                            NotFindHanZi=0;                                   
                        }
                        OffSetPosition+=4;                  
                    }
                    */
                }
                else
                    LowWord=(unsigned char)ChLowCase(NameData[i+4]);  //two english word unicode
            }
            else    //english ascii
            {
                Tempindex=Tempindex+(unsigned char)ChLowCase(NameData[i]);
                LowWord=(unsigned char)ChLowCase(NameData[i+1]);

            }
            Tempindex=Tempindex<<8;
            Tempindex=(Tempindex&0xff00)|(LowWord&0x00ff);
            /*2004/04/07,talcon delete
                     sprintf(temp,"xzy:LowWord:%c",(USHORT)LowWord);
                     TRACE_EVENT(temp);
                     sprintf(temp,"xzy:Tempindex:%d",(USHORT)Tempindex);
                     TRACE_EVENT(temp);*/

            //Tempindex=Tempindex+LowWord;
        }               
    }

    return Tempindex;   
}

static U8 UnchangePinYinProgramCode(U8 code)
{
    unsigned char unchangecode;
    switch( code )
    {
    case 2:      unchangecode='a';   break;
    case 3:      unchangecode='e';   break;
    case 4:      unchangecode='i';    break;
    case 5:      unchangecode='n';   break;
    case 6:      unchangecode='o';   break;
    case 7:      unchangecode='r';   break;
    case 8:      unchangecode='u';   break;
    case 9:      unchangecode='g';   break;
    case 12:     unchangecode='h';   break;
    case 11:     unchangecode='v';   break;
    default :     unchangecode='\0';  break;
    }
    return unchangecode;
}


static U8 ChLowCase(U8 n)
{
    if( (n>64)&&(n<91) )
        n+=32;
    return n;
}

#if 0
static T_MFW_CB Dynamic_timcb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHnd win=mfwParent(mfwHeader());
    MfwWin *win_win=(MfwWin *)(((MfwHdr *)win)->data);
    tBookStandard *win_data=(tBookStandard *)win_win->user;
    if( winIsFocussed(win) )
    {
        timStart(dynamic_tim);
        dynamic_index=(dynamic_index+1)%4;
        dspl_Clear(42,54,77,78);
        switch( dynamic_index )
        {
        case 0:
            dspl_BitBlt(44,57,27,27,0,(void*)waiting1,0);
            break;
        case 1:
            dspl_BitBlt(44,57,27,27,0,(void*)waiting2,0);
            break;
        case 2:
            dspl_BitBlt(44,57,27,27,0,(void*)waiting3,0);
            break;
        case 3:
            dspl_BitBlt(44,57,27,27,0,(void*)waiting4,0);
            break;
        case 4:
            dspl_BitBlt(44,57,30,30,0,(void*)waiting5,0);
            break;
        case 5:
            dspl_BitBlt(44,57,30,30,0,(void*)waiting6,0);
            break;
        case 6:
            dspl_BitBlt(44,57,30,30,0,(void*)waiting7,0);
            break;
        default:
            break;
        }
    }
    return;
}
#endif

static T_MFW_CB Dynamic_timcb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHnd win=mfwParent(mfwHeader());
    MfwWin *win_win=(MfwWin *)(((MfwHdr *)win)->data);
    tBookStandard *win_data=(tBookStandard *)win_win->user;
    if( winIsFocussed(win) )
    {
        timStart(dynamic_tim);
#if (MAIN_LCD_SIZE==4)
    dynamic_index=(dynamic_index+1)%GET_ICONATTR_NUM(ICON_POPWAITING);

	/* 2004/06 sunsj modify for picture manage */
	DRAW_ICON_SEL(ICON_POPWAITING, dynamic_index);
#endif 
    }
	return;
}


/*static void bookShowWaitWindowCBdestroy(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
   switch (reason)
   {
   case INFO_TIMEOUT:
   case INFO_KCD_RIGHT:
   case INFO_KCD_HUP:
   case INFO_KCD_LEFT:   
      {
         ShowWaitDestroy( win );
      }      
      break;                                                   
   default: break;
   }
}*//*2003/12/1, wangyan modify*/
static int bookShowWaitWindowCB ( MfwEvt e, MfwWin *w )
{
    tBookStandard *data=w->user;
#if 0   
    /*  dspl_ClearAll();
      dspl_BitBlt(9,41,102,72,0,(void*)backgroundBit,0);
      draw_background();
      dspl_BitBlt(44,57,27,27,0,(void*)waiting1,0);
   draw_popup_background();
   ALIGNED_PROMPT(CENTER,86,DSPL_TXTATTR_TRANSPARENT, TxtPleaseWait);
      dynamic_index=0;
      displaySoftKeys(TxtNull,TxtSoftBack);
      timStart(data->copy_tim);
      timStart(dynamic_tim);*//*2003/11/20, wangyan modify */

    T_DISPLAY_DATA display_info;
    TRACE_FUNCTION ("bookShowWaitWindowCB()");   
    dialog_info_init(&display_info); 
    display_info.KeyEvents    = KEY_CLEAR;
    /*   	display_info.TextId       = TxtPleaseWait;
           display_info.TextId2      = 0;*/
    display_info.TextId = TxtSimNot;
    display_info.TextId2    = TxtPleaseWait;/*2003/12/3, wangyan modify */
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         =ONE_SECS;
    display_info.Callback     = NULL;
    display_info.iconindex=REMIND_WAITTING;
    info_dialog( data->win, &display_info );
    timStart(data->copy_tim);
#endif

    //draw_special_background();
    /* 2004/05/17 sunsj modify s */
    dspl_ClearAll();//jhxu720
	draw_special_background();//jhxu720
    draw_popup_background();
    displaySoftKeys(TxtNull,TxtSoftBack);
#if (MAIN_LCD_SIZE==3)
	ALIGNED_PROMPT(CENTER_RIGHT,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, TxtSimNot);
	ALIGNED_PROMPT(CENTER_RIGHT,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, TxtPleaseWait);
	dialog_drawPopIcon(POP_ICONWAIT);// 2004.3.11 wyj
	dynamic_index=0;
#elif ( MAIN_LCD_SIZE==4 )
	ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, TxtSimNot);
	ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, TxtPleaseWait);
    dynamic_index=0;
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON_SEL(ICON_POPWAITING, dynamic_index);
    //dspl_BitBlt(48, 52, 32, 32, 0,(void*)waiting1,0);

#elif ( MAIN_LCD_SIZE==2 )
	ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, TxtSimNot);
	ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, TxtPleaseWait);
    dialog_drawPopIcon(POP_ICONWAIT);// 2004.3.11 wyj
    dynamic_index=0;
#endif
    timStart(data->copy_tim);

#ifndef FOR_FTA_CTA
    //dspl_BitBlt(64,  85, 60, 55, 0,(void*)waiting1,0);// 2004.3.11 wyj
    timStart(dynamic_tim);/*2003/12/13, wangyan modify */
#endif	
}


static T_MFW_CB ShowWait_timcb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHnd win=mfwParent(mfwHeader());
    MfwWin *win_win=(MfwWin *)(((MfwHdr *)win)->data);
    tBookStandard *win_data=(tBookStandard *)win_win->user;
    //   static int do_initial=6;/*2003/12/13, wangyan modify*/
    static int do_initial=4;
    if( winIsFocussed(win) )
    {
        if( bookPhoneBookLoading()==BOOK_FAILURE )
        {
            TRACE_EVENT_P1("glowing: ShowWait_timcb---BOOK_FAILURE no_initial=%d", do_initial);
            timStart(win_data->copy_tim);
            return;
        }
        else if( bookPhoneBookLoading()==BOOK_SUCCESS )
        {
            TRACE_EVENT_P1("glowing: ShowWait_timcb---BOOK_FAILURE no_wait=%d", no_wait);
            if( no_wait==0 )
                SEND_EVENT(win,Wait_Ok,NULL,NULL);
            if( do_initial-->0 )
                timStart(win_data->copy_tim);
            else
                SEND_EVENT(win,Wait_Ok,NULL,NULL);
            return;
        }
    }
    return;
}

static void ShowWaitDestroy( MfwHnd window )
{
    T_MFW_WIN   *win  = ((T_MFW_HDR *)window)->data;
    tBookStandard *data = (tBookStandard *) win->user;
    if( data )
    {
        timStop(data->copy_tim);
        timDelete(data->copy_tim);
#ifndef FOR_FTA_CTA
        timStop(dynamic_tim);
        timDelete(dynamic_tim);/*2003/12/13, wangyan modify*/
#endif
        winDelete(data->win);
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return;
    }
    return;
}
static void bookShowWaitDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN   *win_data  = ((T_MFW_HDR *) win)->data;
    tBookStandard *data    = (tBookStandard *) win_data->user;
    T_phbk *phbk=data->phbk;
    SHORT    *reason     = (SHORT *) parameter;
    // char temp[100];/*2004/04/07,talcon delete*/
    T_DISPLAY_DATA display_info;
    TRACE_FUNCTION ("bookShowWaitDialog()");

    switch( event )
    {
    case Wait_Init:
        {
#if 0 /*2003/12/13, wangyan modify*/
            /*  dspl_ClearAll();
              ALIGNED_PROMPT(CENTER,92,0, TxtPleaseWait);
             dspl_BitBlt(42,54,27,27,0,(void*)waiting1,0);
             dspl_BitBlt(9,41,102,72,0,(void*)backgroundBit,0);
     draw_popup_background();
              dynamic_index=0;
              displaySoftKeys(TxtNull,TxtSoftBack);
              timStart(data->copy_tim);
              timStart(dynamic_tim);*//*2003/11/20, wangyan modify */

            dialog_info_init(&display_info); 
            display_info.KeyEvents    = KEY_CLEAR;
            /*    	display_info.TextId       = TxtPleaseWait;
                    display_info.TextId2      = 0;*//*2003/12/3, wangyan modify */

            display_info.TextId = TxtSimNot;
            display_info.TextId2    = TxtPleaseWait;/*2003/12/3, wangyan modify */
            display_info.LeftSoftKey  = TxtNull;
            display_info.RightSoftKey = TxtSoftBack;
            display_info.Time         =ONE_SECS;//
            display_info.Callback     = NULL;
            display_info.iconindex=REMIND_WAITTING;
            info_dialog( win, &display_info );
            timStart(data->copy_tim);
#endif

            //draw_special_background();
            dspl_ClearAll();
            draw_popup_background();
            displaySoftKeys(TxtNull,TxtSoftBack);
            ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, TxtSimNot);
            ALIGNED_PROMPT(CENTER,DIALOG_THIRD_LINE,DSPL_TXTATTR_TRANSPARENT, TxtPleaseWait);
            dynamic_index=0;
            //dialog_drawPopIcon(POP_ICONWAIT);   //2004.3.11 WYJ


            timStart(data->copy_tim);
#ifndef FOR_FTA_CTA
            //dspl_BitBlt(64,  85, 60, 55, 0,(void*)waiting1,0);//2004.3.11 WYJ
            timStart(dynamic_tim);/*2003/12/13, wangyan modify */
#endif
        }
        break;
    case Wait_Ok:
        {
            TRACE_EVENT("initial ok");
            ShowWaitDestroy(data->win);
            no_wait=0;
            if( PcCmdStatus.isPcConect )//when pc read sim phb,return
                return;

            //end of hxl add----------------------------------
            //hxl add for updata the nvm data
            /**/
            if( NVMLoadingPhbk==FALSE )
            {
                Get_NVM_data();
                PHBKTotal=NVMTotal+SIMTotal;//hxl add fot update the 
                Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
                NVMLoadingPhbk=TRUE;
            }

            if( SIMLoadingPhbk==FALSE )
            {
                TRACE_EVENT("glowing: bookShowWaitDialog--before GetSIMData");
                GetSIMData();
                TRACE_EVENT("glowing: bookShowWaitDialog--after GetSIMData");
                phb_get_upn();
                SIMLoadingPhbk=TRUE;
            }
            /*2004/04/07,talcon delete
            sprintf(temp,"reason:%d",wait_reason);
            TRACE_EVENT(temp);*/
            SEND_EVENT(phbk->win,PHBK_INIT,NULL,&wait_reason);

        }
        break;

    default:
        break;
    }

}

static int ShowWait_kbdcb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    MfwHnd win=mfwParent(mfwHeader());
    MfwHnd parent=mfwParent(win);
    switch( keyboard->code )
    {
    case KCD_RIGHT:
    case KCD_HUP:
        {
            ShowWaitDestroy(win);
            bookPhonebookDestroy(parent);
        }
        break;
    default:
        break;
    }
    return 1;
}

static T_MFW_HND bookShowWaitCreate( MfwHnd parent )
{
    T_MFW_WIN   *win_data;
    T_MFW_WIN *parent_data;
    tBookStandard *data;

    TRACE_FUNCTION ("bookShowWaitCreate()");
    parent_data=(MfwWin *)(((MfwHdr *)parent)->data);
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (MfwCb)bookShowWaitWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    // Create window handler    
    data->mmi_control.dialog   = (T_DIALOG_FUNC) bookShowWaitDialog;
    data->mmi_control.data     = data;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;
    winShow(data->win);


    data->parent_win           = parent;
    data->phbk                 = (T_phbk *)(parent_data->user);
    data->copy_tim=timCreate(data->win,1000,(MfwCb)ShowWait_timcb);
#ifndef FOR_FTA_CTA
    dynamic_tim=timCreate(data->win,300,(MfwCb)Dynamic_timcb);/*2003/11/20, wangyan modify */
#endif
    data->kbd=kbdCreate(data->win,KEY_ALL,(MfwCb)ShowWait_kbdcb);
    // return window handle    
    return data->win;
}



static T_MFW_HND bookShowWait( MfwHnd parent,int reason)
{
    MfwHnd win;
    if( (win=bookShowWaitCreate(parent))!=NULL )
    {
        wait_reason=reason;
        winShow(win);
    }
    return win;
}

UBYTE Is_Valid(T_MFW_PHB_ENTRY *entry)
{
    /* 2004/04/13 sunsj modify */
    //if( wstrlen((char *)(entry->name.data))&&wstrlen((char *)entry->number) )
    if( wstrlen((char *)entry->number) )
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

#if 0
void GetSIMData(void)
{
    U8               ExitFlag;
    U8               RetValue;
    int               SIMStartSite,i,needread;
    char              tempdata[100];
    UBYTE            len;
    PhbkDetailItem     l_phb_NVMentry;
    T_MFW_PHB_ENTRY l_phb_Shortentry;
    T_MFW_PHB_LIST yq_list;

    SIMTotal=0;needread=-1;
    TRACE_EVENT("GetSIMData");
    // RetValue=ReadSIM_Init(PHB_ADN,MFW_PHB_INDEX);
    RetValue=ReadSIM_Init(PHB_ADN,MFW_PHB_ALPHA);//PHB_ADN

    if( !RetValue )
    {
        SIMStartSite=ALL_NVM_LIST;
        ExitFlag=0;      
        memset(&l_phb_index[SIMStartSite],0,sizeof(T_MFW_PHB_INDEX)*ALL_SIM_LIST);//reset the sim data area to 0
        do//SIM
        {
            len=l_phb_entry[l_idx % PE_SIZE].name.len;
            memcpy((char *)l_phb_index[SIMStartSite].name,(char *)l_phb_entry[l_idx % PE_SIZE].name.data,PHB_name_len);
            if( len>PHB_name_len-2 )
            {
                l_phb_index[SIMStartSite].name[19]=0x00;
                l_phb_index[SIMStartSite].name[20]=0x00;
            }
            else
            {
                l_phb_index[SIMStartSite].name[len]=0x00;
                l_phb_index[SIMStartSite].name[len+1]=0x00;
            } 

            // TraceMMI(l_phb_index[SIMStartSite].name);  //ganchh 2002/11/24

            l_phb_index[SIMStartSite].phonebook=SIM_BOOK_SEL;
            l_phb_index[SIMStartSite].index=l_phb_entry[l_idx % PE_SIZE].index;
            if( l_phb_entry[l_idx % PE_SIZE].index==0 )
                needread=SIMStartSite;
            /*   zgzTraceDataFunc("physical index", l_phb_index[SIMStartSite].index);
               TRACE_EVENT((char *)l_phb_entry[l_idx % PE_SIZE].name.data);
               TRACE_EVENT((char *)l_phb_entry[l_idx % PE_SIZE].number);
               zgzTraceDataFunc("book:",l_phb_entry[l_idx % PE_SIZE].book);
           */CompressNum((char *)l_phb_entry[l_idx % PE_SIZE].number,(unsigned char *)SimNumber[SIMStartSite-ALL_NVM_LIST]);
            l_phb_index[SIMStartSite].number[0]=GetShortNumber((char *)l_phb_entry[l_idx % PE_SIZE].number);      
            l_phb_index[SIMStartSite].number[1]=0x0000;
            l_phb_index[SIMStartSite].number[2]=0x0000;     
            l_phb_index[SIMStartSite].flag=SetAddFlag(SIMStartSite);

            SIMTotal=SIMTotal+1;                             
            l_idx = (l_idx + 1) % l_found;
            if( l_found==1 || (l_found>1 && l_idx==0) )
                ExitFlag=1;
            else if( (l_idx % PE_SIZE == 0)&&l_found>PE_SIZE )
            {
                //  if (ReadEntries(PHB_ADN, (U8)(l_startidx + ((l_idx/PE_SIZE)*PE_SIZE)), MFW_PHB_INDEX, PE_SIZE) != 0)
                if( ReadEntries(PHB_ADN, (U8)(l_startidx + ((l_idx/PE_SIZE)*PE_SIZE)), MFW_PHB_ALPHA, PE_SIZE) != 0 )
                    ExitFlag=2;
                else if( l_phb_list.result == MFW_NO_ENTRY )
                    ExitFlag=3;
            }
            SIMStartSite=SIMStartSite+1;
        }
        while( ExitFlag==0 );  
        if( needread!=-1 )
        {
            yq_list.entry=&l_phb_Shortentry;
            phb_read_entries(PHB_ADN,9,MFW_PHB_PHYSICAL,1, &yq_list);
            TRACE_EVENT("read form adn");
            zgzTraceDataFunc("index",l_phb_Shortentry.index);
            zgzTraceDataFunc("book",l_phb_Shortentry.book);
            TRACE_EVENT((char *)l_phb_Shortentry.name.data);
            TRACE_EVENT((char *)l_phb_Shortentry.number);
            phb_read_entries(PHB_ECC,9,MFW_PHB_PHYSICAL,1, &yq_list);
            TRACE_EVENT("read form ecc");
            zgzTraceDataFunc("index",l_phb_Shortentry.index);
            zgzTraceDataFunc("book",l_phb_Shortentry.book);
            TRACE_EVENT((char *)l_phb_Shortentry.name.data);
            TRACE_EVENT((char *)l_phb_Shortentry.number);
        }
    }
    else
    {
        switch( RetValue )
        {
        case 1 :ExitFlag=2;//SIMû׼               
            break;
        case 2 :ExitFlag=1;//SIM绰¼ûҵ
            break;
        default: break;
        }  
    }
    PHBKTotal=NVMTotal+SIMTotal;
    if( PHBKTotal!=0 )
    {
        sprintf(tempdata,"SIMTotal:%d ;NVMTotal:%d;PHBKTotal:%d",SIMTotal,NVMTotal,PHBKTotal);
        TRACE_EVENT(tempdata);

        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
    }
}
#else
void GetSIMData(void)
{
    T_MFW_PHB_STATUS status;
    int               SIMStartSite,i,j,count;
    int m,len,sim_len;
    T_MFW_PHB_ENTRY l_phb_Shortentry[5];
    T_MFW_PHB_LIST l_phb_list;
    status.book=PHB_ADN;
    SIMTotal=0;
    SIMStartSite=ALL_NVM_LIST;
    GetVoiceData();
    TRACE_EVENT_P1("glowing: GetSIMData--before phb_get_status status.book=%d", status.book);
    if( phb_get_status(&status)==MFW_PHB_OK )
    {
        count=status.avail_entries+status.used_entries;
        sim_len=status.tag_len;
        j=count/5+1;
        TRACE_EVENT_P1("glowing: GetSIMData--1 j=%d", j);
        memset(&l_phb_index[SIMStartSite],0,sizeof(T_MFW_PHB_INDEX)*ALL_SIM_LIST);//reset the sim data area to 0
        for( i=0;i<j;i++ )
        {
            memset(&l_phb_Shortentry[0],0,sizeof(l_phb_Shortentry));
            l_phb_list.entry=&l_phb_Shortentry[0];
            TRACE_EVENT_P1("glowing: before phb_read entries --2 i=%d", i);
            if( phb_read_entries(PHB_ADN,i*5+1,MFW_PHB_PHYSICAL,5,&l_phb_list)!=0 )
            {
                TRACE_EVENT("glowing: GetSIMData 3  phb_read_entries failed!");
                break;
            }
            else
            {
                for( m=0;m<5;m++ )
                {
                    TRACE_EVENT_P1("glowing: GetSIMData 2 m=%d", m);
                    if( Is_Valid(&l_phb_Shortentry[m]) )
                    {
                        TRACE_EVENT("glowing: GetSIMData after Is_Valid");
                        len=l_phb_Shortentry[m].name.len;
                        if( l_phb_Shortentry[m].name.data[0]==0x80 )
                        {
                            if( sim_len%2==0 )
                            {
                                l_phb_Shortentry[m].name.data[sim_len-1]=0;
                                l_phb_Shortentry[m].name.data[sim_len]=0;
                            }
                            else
                            {
                                l_phb_Shortentry[m].name.data[sim_len]=0;
                                l_phb_Shortentry[m].name.data[sim_len+1]=0;
                            }
                        }
                        else
                        {
                            if( sim_len%2==0 )
                            {
                                l_phb_Shortentry[m].name.data[sim_len-1]=0;
                                l_phb_Shortentry[m].name.data[sim_len]=0;
                            }
                            else
                            {
                                l_phb_Shortentry[m].name.data[sim_len]=0;
                                l_phb_Shortentry[m].name.data[sim_len+1]=0;
                            }
                        }
                        memcpy((char *)l_phb_index[SIMStartSite].name,(char *)l_phb_Shortentry[m].name.data,sim_len);
                        if( len>PHB_name_len-2 )
                        {
                            l_phb_index[SIMStartSite].name[19]=0x00;
                            l_phb_index[SIMStartSite].name[20]=0x00;
                        }
                        else
                        {
                            l_phb_index[SIMStartSite].name[len]=0x00;
                            l_phb_index[SIMStartSite].name[len+1]=0x00;
                        } 
                        l_phb_index[SIMStartSite].phonebook=SIM_BOOK_SEL;
                        l_phb_index[SIMStartSite].index=l_phb_Shortentry[m].index;
                        l_phb_index[SIMStartSite].number[0]=GetShortNumber((char *)l_phb_Shortentry[m].number);
                        CompressNum((char *)l_phb_Shortentry[m].number,(unsigned char *)SimNumber[SIMStartSite-ALL_NVM_LIST]);
                        l_phb_index[SIMStartSite].number[1]=0x0000;
                        l_phb_index[SIMStartSite].number[2]=0x0000;      
                        l_phb_index[SIMStartSite].flag=SetAddFlag(SIMStartSite);
                        SIMTotal=SIMTotal+1;
                        SIMStartSite=SIMStartSite+1;
                    }
                }
            }
        }
    }
    PHBKTotal=NVMTotal+SIMTotal;
    if( PHBKTotal!=0 )
    {
        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
    }
}
#endif
//yq added for phb start from call
void SetCallWindowsHandle(MfwHnd win)
{
    calldatawin=win;
    return;
}

void ClearCallWindowHandle()
{
    calldatawin=0;
    return;
}

MfwHnd GetCallWindowHandle()
{
    return calldatawin;
}
/*******************************************************************************
                                                                              
                                End Of File
                                                                              
*******************************************************************************/
