#ifndef _MMI_BOOK_SEARCH_WINDOW_H_
#define _MMI_BOOK_SEARCH_WINDOW_H_

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiSearchWindow.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
	This module provides the phone book search window functionality for the
	phone book module of the basic MMI
                        
********************************************************************************
 $History: MmiSearchWindow.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/
// Entry point to the search window functions
#define VOICEDIAL_MAX 10
typedef struct
{
  U8 name[PHB_name_len+3];
  MfwIcnAttr bookicon;
} T_DynamicBuffer;



typedef struct 
{  
  int   index;
  BOOL selectflag;
} T_SearchResult;

typedef struct
{
  BOOL  CopyEnd;
  U8     complete; 
} T_CopyResult;

typedef struct
{
	char name[PHB_MAX_LEN+3];
	char number[PHB_MAX_LEN+1];
	
}voice_info;

typedef struct
{
  T_MMI_CONTROL   mmi_control;
  T_MFW_HND       parent_win;
  T_MFW_HND       win;
  T_MFW_HND       tim;
  T_MFW_HND       kbd;
  
} T_voice_info;

typedef enum
{
	voicelist_init,
	voicelist_destroy
}voicelist_event;

typedef enum
{
  record_ready,
  record_begin,
  record_update,
  record_update_ready,
  record_update_over,
  record_destroy,
  record_over,
  record_error,
  record_update_error,
  record_sucess,
  record_dial
} voice_event;

typedef enum
{
 dial_ready,
 dialing,
 redial1,
  dial_error,
  dial_ok,
  dial_destroy
}dial_event;

typedef enum
{
 recordready,
 recording,
 recorderror,
 updateerror,
 updateready,
 playing1,
 playing2,
 updating,
 recordsucess
} voice_mode;

/* 2004/01/04 sunsj modify for different lcd size */
#if (MAIN_LCD_SIZE==3)
/* 2003/11/1 sunsj the coordinate of phone code display */
#define PHONE_NAME_Y		        16
#define PHONE_MOBILENUM_Y	        34
#define PHONE_HOMENUM_Y		        52
#define PHONE_OFFICENUM_Y	        70
#define PHONE_MEMO_Y		        88
#define PHONE_LINE_HEIGHT			18
#define BOOKINPUT_HEIGHT_PERLINE	15//15
/* phone input editor width */
#define PHONEEDITOR_SCREEN_WIDTH	105
#define PHONEEDITOR_SCREEN_X_OFFSET	20//22//shiheng 288

#elif ( MAIN_LCD_SIZE==4 )
/* 2003/11/1 sunsj the coordinate of phone code display */
#define PHONE_NAME_Y		        22
#define PHONE_MOBILENUM_Y	        42
#define PHONE_HOMENUM_Y		        62
#define PHONE_OFFICENUM_Y	        82
#define PHONE_MEMO_Y		        102
#define BOOKINPUT_HEIGHT_PERLINE	18

    /* 2003/12/22 sunsj add for phone input editor width */
#define PHONEEDITOR_SCREEN_WIDTH	105
#define PHONEEDITOR_SCREEN_X_OFFSET	22

#define PHONE_LINE_HEIGHT			18
#define PHONEBOOK_ICON_WIDTH		14	/* 2004/05/20 sunsj add */
#define PHONEBOOK_ICON_HEIGHT		14	/* 2004/05/20 sunsj add */
#elif ( MAIN_LCD_SIZE==2 )
	/* 2003/11/1 sunsj the coordinate of phone code display */
#define PHONE_NAME_Y				14
#define PHONE_MOBILENUM_Y			27
#define PHONE_HOMENUM_Y				40
#define PHONE_OFFICENUM_Y			53
#define PHONE_MEMO_Y				80
#define BOOKINPUT_HEIGHT_PERLINE	13
#define PHONEEDITOR_SCREEN_WIDTH	80
#define PHONEEDITOR_SCREEN_X_OFFSET	20

#endif

/* 2003/11/01,talcon add */
typedef enum
{
	BookWndType_Search,			/* search window */
	BookWndType_Group,			/* Grouping window	*/
	BookWndType_GroupBrowser,    /* Grouping Brwoser window */
	BookWndType_GroupAdd,		  /* Grouping Add window */
	BookWndType_ShortCut,		/* Short cut dial */	
	BookWndType_ChoiceCopy		/* Choice Copy */	
}T_BookWndType;
/* 2003/11/04,talcon add */
#define SHOWTIMEOUT	1000

extern      T_DynamicBuffer     DataItem[MAX_Grouping];
extern      T_SearchResult      bookname[ALL_NUMBER_LIST];
extern      int                 SearchTotal;
extern      int                 CopyNumber;
#if(MAIN_LCD_SIZE==4)
extern      T_DynamicBuffer     DynamicBuffer[3];    /* 2004/05/26 sunsj modify */
#elif(MAIN_LCD_SIZE==3)
extern      T_DynamicBuffer     DynamicBuffer[4];    /* 2004/05/26 sunsj modify */
#endif
extern      USHORT            ShortName;
extern      int                 RingSelect;
extern      T_CopyResult       CopyResult;

void        bookCopyRecord(T_MFW_HND Window, USHORT TxtContent);
void        bookDeleteRecord(T_MFW_HND Window);
T_MFW_HND bookSearchStart( MfwHnd parent );
void        bookSearchDestroy( MfwHnd window );
MfwHnd bookShowDetailStart( MfwHnd parent);//yq add for show the details
T_MFW_HND bookGroupingStart( MfwHnd parent );
void        bookGroupingDestroy( MfwHnd window );

T_MFW_HND bookShortCutDialStart( MfwHnd parent );
void        bookShortCutDialDestroy( MfwHnd window );
T_MFW_HND bookClearAllStart( MfwHnd parent,void *buffer );
void        bookClearAllDestroy( MfwHnd window );

T_MFW_HND bookGroupingAddStart( MfwHnd parent );
void        bookGroupingAddDestroy( MfwHnd window );

T_MFW_HND bookGroupingBrowserStart( MfwHnd parent );
void        bookGroupingBrowserDestroy( MfwHnd window );

T_MFW_HND bookGroupingRenameStart( MfwHnd parent,void *buffer );
void        bookGroupingRenameDestroy( MfwHnd window );


T_MFW_HND bookChoiceCopyStart( MfwHnd parent,T_CopyWay  NewCopyWay );
void        bookChoiceCopyDestroy( MfwHnd window );
T_MFW_HND bookCopyAllStart( MfwHnd parent, T_CopyWay  NewCopyWay );//NVMToSIM,SIMToNVM
void        bookCopyAllDestroy( MfwHnd window );
T_MFW_HND bookOwnNumberStart( MfwHnd parent );
void        bookOwnNumberDestroy( MfwHnd window );
MfwHnd     bookInputStart( MfwHnd parent);
void        bookInputDestroy( MfwHnd window );
void        bookDeleteAllSIMRecord(T_MFW_HND Window);
void        bookDeleteAllNVMRecord(T_MFW_HND Window);
void ClearWindowHandle();
//begin xzy add 2002/10/24 for phonebook grouping icon
//void bookGroupingIconSet( MfwHnd parent ,int IconNumber);
T_MFW_HND iconSelect_create( MfwHnd parent_window);
//end xzy add 2002/10/24 for phonebook grouping icon
void bookVoiceAddStart(T_MFW_HND Window,int Id,char *name,char *number);//char * TxtContent
void bookVoiceModifyStart(T_MFW_HND Window,unsigned char  TxtContent,char *name,char *number);
T_MFW_HND bookVoiceListStart(MfwHnd window);
void VdRecordPlayCB (void* parameter);
void VdUpdatePlayCB (void* parameter);
void bookDeleteRecordStart(T_MFW_HND Window);
MfwHnd bookVoiceRecordStart( MfwHnd parent);
int MayAddVoice(void);
int IsNumberIn(char *number);
void GetVoiceData(void);
void SetCurrentMode(voice_mode mode);
void SetDialMode(unsigned char mode);
void WriteVoiceData(void);
//end yq added
T_MFW_HND GetWindowHandle();
void SetWindowsHandle(T_MFW_HND win);
//yq added for indicate now we have a phbk dynamic_menu.2003/3/17
void SetPhbkIN(UBYTE flag);
int IsPhbIN();//yq added for indicate the phbk 
//end yq added

/* Entry point for the input window
*/

// Additional helper functions provided by this module
UBYTE bookSearchName( char *pattern, UBYTE number, tMmiPhbData *current );

/*******************************************************************************
                                End of File
*******************************************************************************/
#endif
