/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   PhoneBook
 $File:       MmiBookServices.c
 $Revision:   1.0


 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

    This provides the implementation of service functions for use with the
  phone book module

********************************************************************************
 $History: MmiBookServices.c

  25/10/00      Original Condat(UK) BMI version.
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiBookServices.c

  22/07/02     zy Mobile Innovation add the function:bookShowInformationWithIcon
  make the information dialog has icons
  08/08        fzq modified
  20/08/02     ver0.103  fzq modified
  01/11/2003   sunsj 
               modify the phone book input area and display method
  10/11/2003   sunsj
               modify the number display method when input phone book record
  2003/11/19   sunsj add name icon
 $End

*******************************************************************************/



/*******************************************************************************

                                Include Files

*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"
#include "mfw_cnvt.h"	//GW Added for 'mfw_SIM2GsmStr'

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"

#include "MmiBookShared.h"
#include "MmiBookController.h"
#include "MmiBookPhonebook.h"
#include "mmiusersymbolinput.h"
#include "mmisettings.h"

static void book_edit_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void book_add_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void book_search_information(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void ChangeFlashDCTbDataName(T_EasyName  NumChangeName);//yq added 2003/1/24
//JVJE #include "MmiMsgsEdit.h"
//JVJE#include "MmiSmsCB.h"
//#include "MmiMsgs.h"


/*******************************************************************************

                                Private data elements

*******************************************************************************/

static MfwHnd phb;
static int NewIndex;
void ShowDetailView(int txtid1,int txtid2);
static void cleardown(int txtid);
static void clearup();
#if ( MAIN_LCD_SIZE==2 )
extern unsigned char iconWaitting[];
#endif

void UpdateDetailDate(T_phbk *Phbk);    /* 2003/10/21 sunsj add */

/* 2004/05/26 sunsj modify */
#if(MAIN_LCD_SIZE==4)
#define		PHONEBOOK_RECORD_PERPAGE	3
#elif(MAIN_LCD_SIZE==3)
#define		PHONEBOOK_RECORD_PERPAGE	4
#endif
/*******************************************************************************

                                Public Methods

*******************************************************************************/

/*******************************************************************************

 $Function:     bookInitialise

 $Description:  Initialise the phone book application

 $Returns:    none, side effect is to set up the static phone
                book element

 $Arguments:  none

*******************************************************************************/

void bookInitialise( MfwHnd parent )
{
    //TRACE_FUNCTION( "bookInitialise()" );
    phb  = phb_create( 0, (MfwEvt) (E_PHB_UPN_LIST | E_PHB_ERROR | E_PHB_STATUS | E_PHB_READY), (MfwCb) bookEvent );
    bookCreateNewPhoneBook();
}
/*******************************************************************************

 $Function:     bookExit

 $Description:  Exit the phone book application, this will delete the static
                phone book element

 $Returns:    none

 $Arguments:  none

*******************************************************************************/

void bookExit( void )
{
    //TRACE_FUNCTION( "bookExit()" );
    phb_delete( phb );
    bookDeletePhoneBook();
}

/*******************************************************************************

 $Function:     bookShowInformation

 $Description:  general information dialog routine

 $Returns:    none

 $Arguments:  parent, window,
                text, to be displayed,
                cb_function, call back on completion of window
*******************************************************************************/
/* 2004/03/02 sunsj modify */
void bookShowInformation( MfwHnd parent, int txtId, char *text, T_VOID_FUNC cb_function )
{
    T_DISPLAY_DATA display_info;

    //TRACE_FUNCTION( "bookShowInformation()" );

    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = 0;
    display_info.TextId2      = txtId;
    display_info.TextString   = text;
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = FOREVER;
    display_info.Callback     = (T_VOID_FUNC) cb_function;
    display_info.Identifier    =0;
    switch( display_info.TextId2 )
    {
    case TxtCopySucceed:
    case TxtDelSucceed:
    case TxtAddSucceed:
    case TxtEditSucceed:
    case TxtEntryDeleted:
    case TxtDeleted:
    case TxtDelMember:
    case TxtMemberAdd:
        display_info.iconindex=REMIND_SUCCEED;
        display_info.Time         = ONE_SECS;
        break;
    case TxtFailed:
    case TxtReadError:
    case TxtWriteError:
    case TxtNoVoiceDial:
    case TxtVoiceDialFull:
    case TxtDelFail:
    case TxtEditFail:
    case TxtAddFail:
    case TxtCopyFail:
        display_info.iconindex=REMIND_FAILURE;
        display_info.Time         = ONE_SECS;
        break;
    case TxtPleaseWait:
        display_info.iconindex=REMIND_WAITTING;
        display_info.Time         = FIVE_SECS;
        break;
    case TxtPhbkFull:
    case TxtPhbkSimEmpty:
    case TxtPhbkNvmFull:
    case TxtPhbkNvmEmpty:
    case TxtPhbkSimFull:
    case TxtEmptyList:
    case TxtCapacityFull:
    case TxtCallTimeout:
        display_info.iconindex=REMIND_NORECORD;
        break;
    default:
        display_info.Time=1000;
        break;
    }
    // Call Info Screen    
    info_dialog( parent, &display_info );
}

void bookShowPhbkInformation( MfwHnd parent, int txtId, char *text, T_VOID_FUNC cb_function )
{
    T_DISPLAY_DATA display_info;

    //TRACE_FUNCTION( "bookShowInformation()" );

    dialog_info_init(&display_info);//gdy add 
    //display_info.KeyEvents    = KEY_CLEAR;/*2003/12/3, wangyan modify*/
    display_info.KeyEvents    = KEY_CLEAR|KEY_RIGHT | KEY_HUP;
    display_info.TextId       = txtId;
    display_info.TextId2      = 0;
    display_info.TextString   =  '\0';
    display_info.TextString2  =text;
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = ONE_SECS;
    display_info.Callback     = (T_VOID_FUNC) cb_function;
    display_info.iconindex=REMIND_SUCCEED;
    // Call Info Screen    
    info_dialog( parent, &display_info );
}

void bookPromptInformation( MfwHnd parent, int txtId, char *text, T_VOID_FUNC cb_function )
{
    T_DISPLAY_DATA display_info;

    //TRACE_FUNCTION( "bookShowInformation()" );

    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    = KEY_OK |KEY_CLEAR;
    display_info.TextId       = txtId;
    display_info.TextId2      = 0;
    display_info.TextString   = text;
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = TxtSoftBack;
    //display_info.Time         = 0;
    display_info.Callback     = (T_VOID_FUNC) cb_function;

    /* Call Info Screen
    */
    info_dialog( parent, &display_info );
}

/* 2004/05/13 sunsj modify */

/*******************************************************************************

  $Function:     bookShowInformationWithIcon
  
	$Description:  general information dialog routine
	
	  $Returns:    none
	  
		$Arguments:  parent, window,
		text, to be displayed,
		cb_function, call back on completion of window
		zy Mobile Innovation add the function with Icon                
		
*******************************************************************************/
void bookShowCallInformation( MfwHnd parent, int txtId, char *text, T_VOID_FUNC cb_function ,USHORT identify)
{
    T_DISPLAY_DATA display_info;
	T_MFW_HND redialwin;/*2003/12/16, wangyan modify*/
	
    TRACE_FUNCTION( "bookShowCallInformation()" );
    dialog_info_init(&display_info);//gdy add 
    display_info.Identifier    = identify;
    display_info.KeyEvents   = KEY_CLEAR | KEY_RIGHT | KEY_LEFT|KEY_HUP;
    display_info.TextId      = txtId;
    display_info.TextId2       = 0;
    display_info.TextString   = text;
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey = TxtNull;
    display_info.Time       = 1000;
    display_info.Callback     = (T_VOID_FUNC) cb_function;
	
    // Call Info Screen    
    redialwin= info_dialog( parent, &display_info );
	/*2003/12/16, wangyan modify*/	
	//if( txtId==TxtNetUselessCallAgain )
    //    mmi_dialogs_insert_fixmov_animation(redialwin,500,CALLREDIALANIM);
	/*
	if(txtId==TxtNetUselessCallAgain)
		mmi_dialogs_insert_fixmov_animation(redialwin,500,CALLREDIALANIM);
	else if(txtId==TxtCallTimeout)
		mmi_dialogs_insert_fixmov_animation(redialwin,500,CALLFAILANIM);
	else
		mmi_dialogs_insert_fixmov_animation(redialwin,500,CALLNOTCONNECTANIM);
	*/
}

/*******************************************************************************

 $Function:     bookFindNameInPhonebook

 $Description:  Locates the name in a specified phone book

 $Returns:      0 if error, 1 if successful

 $Arguments:  p_pszNumber, pointer to pattern to match, p_pEntry, pointer
                to buffer into which to store result.

*******************************************************************************/

int bookFindNameInPhonebook( const char *p_pszNumber, T_MFW_PHB_ENTRY *p_pEntry )
{
#ifdef NO_ASCIIZ
    T_MFW_PHB_TEXT p_pszNumberText;
#endif

    T_MFW_PHB_LIST  phb_list, new_list;

    //glowing,2004-04-09, compatible with the new version
#if TCS20_VER
    SHORT  phb_index;
#else
    UBYTE     phb_index;
#endif

    UBYTE     l_name[PHB_name_len+3];
    T_MFW_PHB_ENTRY temp_pEntry[4];
    int i;
    int j;
    char debug[50];
    //TRACE_FUNCTION( "bookFindNameInPhonebook()" );



    if( p_pszNumber == 0 || p_pEntry == 0 )
        return 0;

    memset( p_pEntry,  0, sizeof(T_MFW_PHB_ENTRY) );
    memset( &phb_list, 0, sizeof(phb_list) );
    phb_list.entry = temp_pEntry;
    phb_list.num_entries = 4;
    //search phonebook for up to 4 entries with thr last 6 digits matching number
#ifdef WIN32
    phb_find_entries(
                    bookActiveBook(READ),   /* phonebook                */
                    &phb_index,       /* returns index in phb     */
                    MFW_PHB_NUMBER,     /* searching for number     */
                    4,            /* return max. one entry    */
                    (UBYTE *) p_pszNumber,  /* search this pattern      */
                    0,
                    &phb_list       /* return structure         */
                    );
#else

#ifdef NO_ASCIIZ

    //GW Set up data structure for NO_ASCIIZ
    p_pszNumberText.dcs = MFW_DCS_7bits;
    p_pszNumberText.len = strlen(p_pszNumber);
    strcpy((char*)p_pszNumberText.data, p_pszNumber);

    phb_find_entries(
                    bookActiveBook(READ),   /* phonebook                */
                    &phb_index,       /* returns index in phb     */
                    MFW_PHB_NUMBER,     /* searching for number     */
                    4,            /* return max. one entry    */
                    &p_pszNumberText,  /* search this pattern      */
                    &phb_list       /* return structure         */
                    );

#else

    phb_find_entries(
                    bookActiveBook(READ),   /* phonebook                */
                    &phb_index,       /* returns index in phb     */
                    MFW_PHB_NUMBER,     /* searching for number     */
                    4,            /* return max. one entry    */
                    (char *)p_pszNumber,  /* search this pattern      */
                    &phb_list       /* return structure         */
                    );
#endif //NO_ASCIIZ

#endif //WIN32
    memset( p_pEntry,  0, sizeof(T_MFW_PHB_ENTRY) );
    for( i=0; i<phb_list.num_entries; i++ ) //for each entry
    {
        //if number strings match completely
        if( !strncmp((char*)temp_pEntry[i].number, (char*)p_pszNumber, strlen((char*)p_pszNumber)) )
        {
            memcpy( p_pEntry, &temp_pEntry[i] , sizeof(T_MFW_PHB_ENTRY) );
            //convert name into appropriate format
#ifdef NO_ASCIIZ

            mfw_SIM2GsmStr( p_pEntry->name.len,
                            p_pEntry->name.data,
                            PHB_name_len,
                            l_name );

            memcpy( p_pEntry->name.data, l_name, PHB_name_len );

#else
            bookGsm2Alpha( (UBYTE *) p_pEntry->name );
#endif
            return 1;
        }
    }
    return 0;

}

/*******************************************************************************

 $Function:     bookFindNumberByPosition

 $Description:  locate a number given the index

 $Returns:    0 if failure, 1 otherwise

 $Arguments:  index of the number to find, p_pentry, return structure

*******************************************************************************/

UBYTE bookFindNumberByPosition (UBYTE index,T_MFW_PHB_ENTRY* p_pEntry)
{
    T_MFW_PHB_LIST  phb_list;
    UBYTE l_name[PHB_name_len];

    //TRACE_FUNCTION( "bookFindNumberByPosition()" );

    /* only search if we have valid input information
    */
    if( index == 0 || p_pEntry == 0 )
        return 0;

    /* Clear the output buffers
    */
    memset( p_pEntry,  0, sizeof( T_MFW_PHB_ENTRY ) );
    memset( &phb_list, 0, sizeof( phb_list ) );

    /* searc for the selected entry
    */
    phb_list.entry          = p_pEntry;
    phb_list.num_entries    = 1;
    phb_read_entries( bookActiveBook(READ), index, MFW_PHB_INDEX, 1, &phb_list );

    /* if we haven't found the entry return 0
    */
    if( phb_list.result == MFW_ENTRY_EXIST )
        return 0;

    /* otherwise copy the located information to the output structure
    */
#ifdef NO_ASCIIZ

    mfw_SIM2GsmStr( p_pEntry->name.len, p_pEntry->name.data, PHB_name_len, l_name );
    memcpy( p_pEntry->name.data, l_name, PHB_name_len );

#else

    bookGsm2Alpha( (UBYTE *) p_pEntry->name );

#endif

    /* successful return status
    */
    return 1;

}








/*******************************************************************************

 $Function:     bookCallIndex

 $Description:  Calls the number in the physical index

 $Returns:    status from the phb_read_entries routine

 $Arguments:  index, of the number to call

*******************************************************************************/

int bookCallIndex( UBYTE index )
{
    T_MFW_PHB_LIST  phb_list;
    T_MFW_PHB_ENTRY entry;
    UBYTE           status;

    //TRACE_FUNCTION( "bookCallIndex()" );

    memset( &entry,    0, sizeof( T_MFW_PHB_ENTRY ) );
    memset( &phb_list, 0, sizeof( phb_list ) );

    phb_list.entry          = &entry;
    phb_list.num_entries    = 1;
    if( ( status = phb_read_entries( bookActiveBook(READ), index, MFW_PHB_PHYSICAL, 1, &phb_list ) ) == MFW_PHB_OK )
        callNumber( entry.number );
    return status;
}

/*******************************************************************************

 $Function:     bookGsm2Alpha

 $Description:  Convert a string from it's GSM to alpha characters

 $Returns:    none

 $Arguments:  alpha, pointer to string to be converted (Must be null
                terminated string)

*******************************************************************************/


void bookGsm2Alpha( UBYTE *alpha )
{
    int index, length;
    length = wstrlen( (char *) alpha );
    for( index = 0; index < length; index++ )
        alpha[index] = alpha[index] & 0x7F;
}

/*******************************************************************************

 $Function:     bookActiveBook

 $Description:  Determine if the current active book is restricted or not

 $Returns:    PHB_FDN if restricted, PHB_ADN otherwise

 $Arguments:  None

*******************************************************************************/

UBYTE bookActiveBook( int process )
{
    //TRACE_FUNCTION( "bookActiveBook()" );
    if( process == READ )
        return( phb_get_mode() == PHB_RESTRICTED ) ? PHB_FDN : PHB_ADN_FDN;
    else if( process == WRITE )
        return( phb_get_mode() == PHB_RESTRICTED ) ? PHB_FDN : PHB_ADN;
}

/*******************************************************************************

 $Function:    	bookActivateFDN

 $Description:	information screen to tell user to activate FDN
 
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/

void bookActivateFDN( T_MFW_HND window )
{
    tBookDialogData Dialog;

    /* Initialise the dialog control block with default information
    */
    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents    = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId       = TxtPlease;
    Dialog.TextId2      = TxtActivateFDN;
    Dialog.TextString   = '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtNull;
    Dialog.RightSoftKey = TxtNull;
    Dialog.Time         = 4000;
    Dialog.Callback     = (T_VOID_FUNC) NULL;
    Dialog.Identifier   = 0;

    /* Show the dialog
    */
    info_dialog( /*bookCurrent*/window, &Dialog );
}


/*******************************************************************************

 $Function:     bookMemoryView

 $Description:  Display the memory status

 $Returns:    None

 $Arguments:  None

*******************************************************************************/

void bookMemoryView( void )
{
    T_MFW_HND       win         = mfwParent( mfw_header() );
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    USHORT      simleft;
    int TxtToShow;
    T_DISPLAY_DATA  display_info;

    // Determine which book we are currently using

    data->phbk->current.status.book = bookActiveBook(READ);

    // retrieve he status of the book, and create a string for output
    //   based on the status

    //memset( Buffer, '\0', 16 );
    //memset( Buffer1,'\0', 16 );
    //memset( Buffer2,'\0', 16 );
    //memset( Buffer3,'\0', 16 );
    data->phbk->current.status.book=PHB_ADN;
    if( bookGetCurrentStatus( &data->phbk->current.status ) == MFW_PHB_OK )
    {
//        simleft = (data->phbk->current.status.avail_entries+data->phbk->current.status.used_entries);//data->phbk->current.status.used_entries
simleft = (data->phbk->current.status.avail_entries+SIMTotal);/*2004/5/28, wy modify*/
        //sprintf( Buffer1, "%d%s",(SIMTotal-data->phbk->current.status.avail_entries+data->phbk->current.status.used_entries),GET_TEXT(TxtPhbkleft));

    }
    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    =  KEY_RIGHT|KEY_CLEAR|KEY_HUP|KEY_F4;    /* 2004/04/10 sunsj modify */
    display_info.TextId       = simleft;
    display_info.TextId2      = NVMTotal;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         =FOREVER;
    display_info.Callback     = NULL;
    display_info.Identifier = MMI_PHONEBOOK_MEMORYSTATE;

    info_dialog( win, &display_info );
}


void bookSearchCB( T_MFW_HND win,USHORT Identifier, UBYTE reason )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard     *data       = (tBookStandard *) win_data->user;
    T_phbk           *Phbk       = data->phbk;    
    BOOL             NotFound,CompFlag;
    int               i;
    char              info[30];
    char              temp[100];

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            if( (wstrlen(Phbk->edt_buf_name)!=0) && (PHBKTotal!=0) )
            {
                Phbk->BufferTable=SearchTable;
                ShortName=GetShortName(Phbk->edt_buf_name);
                //                zgzTraceDataFunc("the shortname:",ShortName);
                memset(Phbk->edt_buf_name,'\0',PHB_name_len+5);
                NotFound=TRUE;
                CompFlag=FALSE;
                for( i=0,SearchTotal=0;i<PHBKTotal;i++ )
                {
                    //                    zgzTraceDataFunc("i",i);
                    //                   zgzTraceDataFunc("name",l_phb_sort_index[i].name);
                    if( (l_phb_sort_index[i].name==ShortName)||((l_phb_sort_index[i].name&0xff00)==ShortName) )
                    {
                        bookname[SearchTotal].index=l_phb_sort_index[i].index;
                        CompFlag=TRUE;
                        NotFound= FALSE;
                        SearchTotal=SearchTotal+1;
                    }
                    else CompFlag=FALSE;

                    if( (NotFound==FALSE) && (CompFlag==FALSE) ) break;
                }

                if( NotFound==FALSE )
                {
                    /* 2004/05/26 sunsj modify */
                    if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
                    {
                        for( i=0;i<SearchTotal;i++ )
                        {
                            /* 2004/06 sunsj modify for picture manage */
                            memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len+2);
                            if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                            else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                        }                       
                        Phbk->BufferIndex=0;                   
                        sprintf(info,"%d",SearchTotal);                   
                        wstrcat((char *)info, MmiRsrcGetText(TxtPhbkFind));

                        bookShowPhbkInformation(win,NULL,info,(T_VOID_FUNC)book_search_information);                
                    }
                    else
                    {
                        /* 2004/05/26 sunsj modify */
                        for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                        {
                            /* 2004/06 sunsj modify for picture manage */
                            memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len+2);
                            if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                            else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                        }   
                        Phbk->BufferIndex=0;
                        sprintf(info,"%d",SearchTotal);                   
                        wstrcat((char *)info, MmiRsrcGetText(TxtPhbkFind));

                        bookShowPhbkInformation(win,NULL,info,(T_VOID_FUNC)book_search_information);                    
                    }   
                }
                else
                {
                    MmiBookSetCurrentText(TxtEmptyList);//ʾϢ                   
                    bookShowInformation( win , MmiBookCurrentText(),NULL,NULL);                
                }
            }
            else if( PHBKTotal!=0 )
            {
                Phbk->BufferTable=GlobalTable; 
                /* 2004/05/26 sunsj modify */
                if( PHBKTotal<=PHONEBOOK_RECORD_PERPAGE )
                {
                    for( i=0;i<PHBKTotal;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len+2); 
                        //Sprintf(temp,"namelen:%d",wstrlen((char *)DynamicBuffer[i].name));
                        //TRACE_EVENT(temp);
                        if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                }
                else
                {
                    /* 2004/05/26 sunsj modify */
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len+2);                                        
                        if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }   

                }
                Phbk->BufferIndex=0;
                SearchTotal=PHBKTotal;
                sprintf(info,"%d",SearchTotal);                   
                wstrcat((char *)info, MmiRsrcGetText(TxtPhbkFind));

                bookShowPhbkInformation(win,NULL,info,(T_VOID_FUNC)book_search_information);                
            }
            else
            {
                MmiBookSetCurrentText(TxtEmptyList);//ʾϢ                   
                bookShowInformation( win, MmiBookCurrentText(),NULL,NULL);                 
            }
        } 
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:    
        {
            /* 2003/12/04 sunsj modify for new editor mode */
            //editor_destroy(data->edtname);
            text_input_destroy(data->edtname);

            bookSearchDestroy( win ); 
        } 
        break;
    default: break;
    }
}

/*******************************************************************************

 $Function:     bookAddNameCB

 $Description:  default call back for name entry

 $Returns:    None

 $Arguments:  win, handle of parent window, reason, for invocation

 $History:    2003/11/10 sunsj modify number display method
              2004/01/14 sunsj modify for different screen size

*******************************************************************************/

void bookAddCB( T_MFW_HND win,USHORT Identifier, UBYTE reason )
{

    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard     *data       = (tBookStandard *) win_data->user;
    T_phbk           *Phbk       = data->phbk;
    char              temp[100];
    int                i,Index;

    T_MFW_HND       parentwin    =data->parent_win;
    T_MFW_HND       Dynamicwin  =Phbk->dynamicmenu_win;
    T_MFW_HND       searchwin    =Phbk->search_win;
    UINT32 oldColor,oldFontColor;

    //sprintf(temp,"Phbk->BookType:%d",Phbk->BookType);
    //TRACE_EVENT(temp);
    //sprintf(temp,"Phbk->MODE:%d",Phbk->MODE);
    //TRACE_EVENT(temp);

    //TRACE_FUNCTION("bookAddCB");

    NewIndex=-1;
    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
			/* 2004/06/01 sunsj modify */
			if( Phbk->MODE == MEMO )
			{
				if( data->edtmemo )
				{
					text_input_destroy( data->edtmemo );
					data->edtmemo = 0;
				}
				SEND_EVENT( data->win, INPUT_NAME, NULL , NULL);
				break;
			}
			/* 2004/06/01 sunsj modify */
            if( (Phbk->BookType==SIM_BOOK_SEL) && /*(wstrlen((char *)Phbk->edt_buf_name)!=0) && */(strlen((char *)Phbk->edt_buf_number)!=0) )
            {
                //sprintf(temp,"UpdateAction:%d",Phbk->UpdateAction);
                //TRACE_EVENT(temp);
                dspl_ClearAll();
				/* 2004/05/17 sunsj modify */
#if (MAIN_LCD_SIZE==3)
		DRAW_ICON_SEL(ICON_POPUPICON,7);//jhxu720
#elif ( MAIN_LCD_SIZE==4 )
		/* 2004/06 sunsj modify for picture manage */
		DRAW_ICON_SEL(ICON_POPWAITING, 0);
                //dspl_BitBlt(48, 52, 32, 32,0,(void*)waiting1,0);
#elif ( MAIN_LCD_SIZE==2)
                dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);
#endif
                if( Phbk->UpdateAction == CREATE_ENTRY )
                {
                    //TRACE_EVENT("CREATE_ENTRY!");
                    storeInFile( Phbk );
                }
                else if( Phbk->UpdateAction == MODIFY_EXISTING )
                {
                    //TRACE_EVENT("MODIFY_EXISTING!");
                    NewIndex=changeInFile( Phbk );
                    sprintf(temp,"NewIndex:%d",NewIndex);
                    //TRACE_EVENT(temp);
                }

                if( data->edtname )
                {
                    text_input_destroy(data->edtname);      /* 2003/12/04 sunsj modify */
                    data->edtname=0; 
                }
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber=0;
                }
                if( (MmiBookCurrentText()==TxtEditSucceed)||(MmiBookCurrentText()==TxtAddSucceed) )
                {
                    T_EasyName data;
                    memset(&data,0,sizeof(data));
                    memcpy(data.name,Phbk->edt_buf_name,PHB_name_len+2);
                    memcpy(data.number,Phbk->edt_buf_number,PHB_number_len);
                    ChangeFlashDCTbDataName(data);                      
                }
                SEND_EVENT( Phbk->input_win, INPUT_DESTROY, NULL, NULL);
                Phbk->input_win = 0;
                if( Phbk->UpdateAction == CREATE_ENTRY )
                {
                    bookShowInformation( win, MmiBookCurrentText(), NULL,NULL );
                }
                else if( Phbk->UpdateAction == MODIFY_EXISTING )
                {
                    /* 2003/12/04 sunsj the list parent win is search win, the win
                       need not to be displaied again so i turn off the flag */
                    MfwHdr * parent_win = (MfwHdr*) mfwParent(Dynamicwin);
                    MfwWin * parent_controlBlock = ((MfwHdr *) parent_win)->data;
                    parent_controlBlock->flags ^= MfwWinVisible;

                    SEND_EVENT(parentwin, E_MNU_ESCAPE, NULL, NULL);
                    listsDestroy(Dynamicwin);
                    parent_controlBlock->flags |= MfwWinVisible;

                    bookShowInformation(searchwin, MmiBookCurrentText(), NULL,(T_VOID_FUNC)book_edit_cb);                              
                }
            }
            else if( (Phbk->BookType==NVM_BOOK_SEL) && (wstrlen((char *)Phbk->edt_buf_name)!=0) &&
                     ((strlen((char *)Phbk->edt_buf_number)!=0) || (strlen((char *)Phbk->edt_buf_home)!=0) || (strlen((char *)Phbk->edt_buf_office)!=0)) )
            {
				/* 2004/05/18 sunsj remove */
                dspl_ClearAll();
#if (MAIN_LCD_SIZE==3)//jhxu720
		DRAW_ICON_SEL(ICON_POPUPICON,7);//jhxu720
#elif ( MAIN_LCD_SIZE==4 )
		/* 2004/06 sunsj modify for picture manage */
		DRAW_ICON_SEL(ICON_POPWAITING, 0);
                //dspl_BitBlt(48, 52, 32, 32,0,(void*)waiting1,0);
#elif ( MAIN_LCD_SIZE==2 )
                dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);
#endif
                if( Phbk->UpdateAction==CREATE_ENTRY )
                {
                    for( i=0;i<ALL_NVM_LIST;i++ )
                    {
                        //sprintf(temp,"CheckFlag(%d):%d",i,CheckFlag(i));
                        //TRACE_EVENT(temp);
                        //sprintf(temp,"check:%d",!CheckFlag(i));
                        //TRACE_EVENT(temp);
                        if( !CheckFlag(i) )
                        {
                            memcpy(l_phb_index[i].name,Phbk->edt_buf_name,PHB_name_len+2);                              
                            l_phb_index[i].phonebook=NVM_BOOK_SEL;
                            l_phb_index[i].number[0]=GetShortNumber((char *)Phbk->edt_buf_number);
                            l_phb_index[i].number[1]=GetShortNumber((char *)Phbk->edt_buf_home);
                            l_phb_index[i].number[2]=GetShortNumber((char *)Phbk->edt_buf_office);                                                                                                                                 
                            l_phb_index[i].flag=SetAddFlag(i);
                            l_phb_index[i].flag|=0x0F;//yq modified 2003/3/6 set grouping=0x0f,it means no group;
                            switch( Phbk->FirstNumber )
                            {
                            case  NUMBER:
                                l_phb_index[i].flag=SetFirstNumFlag(i, 1);
                                break;
                            case  HOME:
                                l_phb_index[i].flag=SetFirstNumFlag(i, 2);
                                break;
                            case  OFFICE: 
                                l_phb_index[i].flag=SetFirstNumFlag(i, 3);
                                break;
                            }
                            //sprintf(temp,"CheckFlag(%d):%d",i,CheckFlag(i));
                            //TRACE_EVENT(temp);

                            if( CurrentTable!=(i/PHB_table_len) )
                            {
                                if( flash_PBread(PBTable[i/PHB_table_len])!=0 )
                                    CurrentTable=i/PHB_table_len;
                            }

                            memcpy(FFS_PBData.NVMBook[i%PHB_table_len].name,Phbk->edt_buf_name,PHB_name_len+2);
                            CompressNum((char *)Phbk->edt_buf_number,FFS_PBData.NVMBook[i%PHB_table_len].number);
                            CompressNum((char *)Phbk->edt_buf_home,FFS_PBData.NVMBook[i%PHB_table_len].home);
                            CompressNum((char *)Phbk->edt_buf_office,FFS_PBData.NVMBook[i%PHB_table_len].office);
                            memcpy(FFS_PBData.NVMBook[i%PHB_table_len].memo,Phbk->edt_buf_memo,PHB_memo_len+3);                                    
                            FFS_PBData.NVMBook[i%PHB_table_len].info=l_phb_index[i].flag;                                    

                            flash_PBwrite(PBTable[CurrentTable]);
                            //sprintf(temp,"CurrentTable:%d",CurrentTable);
                            //TRACE_EVENT(temp);
                            NVMTotal=NVMTotal+1;
                            PHBKTotal=PHBKTotal+1;                                    
                            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
                            break;
                        }
                    }
                    MmiBookSetCurrentText( TxtAddSucceed );    
                }
                else if( Phbk->UpdateAction==MODIFY_EXISTING )
                {
                    switch( Phbk->BufferTable )
                    {
                    case GlobalTable:
                        {
                            //sprintf(temp,"select_index:%d",Phbk->select_index);
                            //TRACE_EVENT(temp);

                            Index=l_phb_sort_index[Phbk->select_index].index;
                            if( Index/PHB_table_len!=CurrentTable )
                            {
                                if( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                                    CurrentTable=Index/PHB_table_len;
                            }

                            memcpy(l_phb_index[Index].name,Phbk->edt_buf_name,PHB_name_len+2);                          
                            l_phb_index[Index].number[0]=GetShortNumber((char *)Phbk->edt_buf_number);
                            l_phb_index[Index].number[1]=GetShortNumber((char *)Phbk->edt_buf_home);
                            l_phb_index[Index].number[2]=GetShortNumber((char *)Phbk->edt_buf_office);

                            memcpy(FFS_PBData.NVMBook[Index%PHB_table_len].name,Phbk->edt_buf_name,PHB_name_len+2);                                             
                            CompressNum((char *)Phbk->edt_buf_number,FFS_PBData.NVMBook[Index%PHB_table_len].number);
                            CompressNum((char *)Phbk->edt_buf_home,FFS_PBData.NVMBook[Index%PHB_table_len].home);
                            CompressNum((char *)Phbk->edt_buf_office,FFS_PBData.NVMBook[Index%PHB_table_len].office);
                            memcpy(FFS_PBData.NVMBook[Index%PHB_table_len].memo,Phbk->edt_buf_memo,PHB_memo_len+3);
                            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[Index].flag;

                            flash_PBwrite(PBTable[CurrentTable]);

                            l_phb_sort_index[Phbk->select_index].name=GetShortName(Phbk->edt_buf_name);
                            NewIndex=SetLocation(l_phb_sort_index,Phbk->select_index);//reset location                                                                   
                            MmiBookSetCurrentText( TxtEditSucceed );
                        }    
                        break;
                    case SearchTable:
                        {
                            //sprintf(temp,"select_index:%d",Phbk->select_index);
                            //TRACE_EVENT(temp);

                            Index=bookname[Phbk->select_index].index;
                            if( Index/PHB_table_len!=CurrentTable )
                            {
                                if( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                                    CurrentTable=Index/PHB_table_len;
                            }

                            memcpy(l_phb_index[Index].name,Phbk->edt_buf_name,PHB_name_len+2);                          
                            l_phb_index[Index].number[0]=GetShortNumber((char *)Phbk->edt_buf_number);
                            l_phb_index[Index].number[1]=GetShortNumber((char *)Phbk->edt_buf_home);
                            l_phb_index[Index].number[2]=GetShortNumber((char *)Phbk->edt_buf_office);

                            memcpy(FFS_PBData.NVMBook[Index%PHB_table_len].name,Phbk->edt_buf_name,PHB_name_len+2);                                             
                            CompressNum((char *)Phbk->edt_buf_number,FFS_PBData.NVMBook[Index%PHB_table_len].number);
                            CompressNum((char *)Phbk->edt_buf_home,FFS_PBData.NVMBook[Index%PHB_table_len].home);
                            CompressNum((char *)Phbk->edt_buf_office,FFS_PBData.NVMBook[Index%PHB_table_len].office);
                            memcpy(FFS_PBData.NVMBook[Index%PHB_table_len].memo,Phbk->edt_buf_memo,PHB_memo_len+3);
                            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[Index].flag;

                            flash_PBwrite(PBTable[CurrentTable]);

                            //bookname[Phbk->select_index].name=GetShortName(Phbk->edt_buf_name);
                            for( i=0;i<SearchTotal;i++ )
                            {
                                if( l_phb_sort_index[i].index==bookname[Phbk->select_index].index )
                                {
                                    l_phb_sort_index[i].name=GetShortName(Phbk->edt_buf_name);
                                    break;
                                }
                            }
                            NewIndex=SetSearchLocation(bookname,Phbk->select_index);//reset location                                                                   
                            MmiBookSetCurrentText( TxtEditSucceed );
                        }    
                        break;
                    default: break;
                    }                                      
                }
                if( (MmiBookCurrentText()==TxtEditSucceed)||(MmiBookCurrentText()==TxtAddSucceed) )
                {
                    T_EasyName data;
                    memset(&data,0,sizeof(data));
                    memcpy(data.name,Phbk->edt_buf_name,PHB_name_len+2);
                    if( (strlen((char *)Phbk->edt_buf_number)!=0) )
                    {
                        memcpy(data.number,Phbk->edt_buf_number,PHB_number_len);
                        ChangeFlashDCTbDataName(data);
                    }
                    if( (strlen((char *)Phbk->edt_buf_home)!=0) )
                    {
                        memcpy(data.number,Phbk->edt_buf_home,PHB_number_len);
                        ChangeFlashDCTbDataName(data);
                    }
                    if( (strlen((char *)Phbk->edt_buf_office)!=0) )
                    {
                        memcpy(data.number,Phbk->edt_buf_office,PHB_number_len);
                        ChangeFlashDCTbDataName(data);
                    }
                }

                if( data->edtname )
                {
                    /* 2003/12/04 sunsj modify for new editor mode */
                    //editor_destroy(data->edtname);
                    text_input_destroy(data->edtname);
                    data->edtname=0;
                }
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber=0;
                } /*
                if ( data->edthome )   
                {
                  editor_destroy(data->edthome);
                  data->edthome=0;
                }
                if ( data->edtoffice )
                {
                  editor_destroy(data->edtoffice);
                  data->edtoffice=0;
                }	
                */
                /* 2003/12/04 sunsj destroy memo editor */
                if( data->edtmemo )
                {
                    text_input_destroy(data->edtmemo);
                    data->edtmemo=0;
                }

                if( Phbk->UpdateAction == CREATE_ENTRY )
                {
                    bookShowInformation( win, MmiBookCurrentText(), NULL,NULL );
                }
                SEND_EVENT( Phbk->input_win, INPUT_DESTROY, NULL, NULL);
                Phbk->input_win = 0; 
                if( Phbk->UpdateAction == MODIFY_EXISTING )
                {
                    /* 2003/12/04 sunsj the list parent win is search win, the win
                       need not to be displaied again so i turn off the flag */
                    MfwHdr * parent_win = (MfwHdr*) mfwParent(Dynamicwin);
                    MfwWin * parent_controlBlock = ((MfwHdr *) parent_win)->data;
                    parent_controlBlock->flags ^= MfwWinVisible;

                    SEND_EVENT(parentwin, E_MNU_ESCAPE, NULL, NULL);
                    listsDestroy(Dynamicwin);
                    parent_controlBlock->flags |= MfwWinVisible;

                    bookShowInformation(searchwin, MmiBookCurrentText(), NULL,(T_VOID_FUNC)book_edit_cb);                              
                }
            }
            else
            {
                if( (Phbk->BookType==SIM_BOOK_SEL) && (Phbk->MODE==NAME) )
                {
                    if( data->edtname )
                    {
                        /* 2003/12/04 sunsj modify for new editor mode */
                        //editor_destroy(data->edtname);
                        text_input_destroy(data->edtname);
                        data->edtname=0;
                    }

                    oldColor=dspl_SetBkgColor(0xDBF4FF);
                    dspl_Clear(6, 42, 114, 76);
                    dspl_SetBkgColor(oldColor);
                    if( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                        dspl_SetBkgColor(oldFontColor);
                    }
                    SEND_EVENT( data->win, INPUT_NUMBER, NULL , NULL);                                  
                }
                if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==NAME) )
                {
                    if( data->edtname )
                    {
                        /* 2003/12/04 sunsj modify for new editor mode */
                        //editor_destroy(data->edtname);
                        text_input_destroy(data->edtname);

                        data->edtname=0;
                    }
                    oldColor=dspl_SetBkgColor(0xDBF4FF);
                    dspl_Clear(6, 42, 114, 76);
                    dspl_SetBkgColor(oldColor);
                    if( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                        dspl_SetBkgColor(oldFontColor);
                    }
                    SEND_EVENT( data->win, INPUT_NUMBER, NULL , NULL); 
                    if( Phbk->FirstNumber==NUMBER )
                    {
                        SEND_EVENT( data->win, INPUT_NUMBER, NULL, NULL); 
                    }
                    if( Phbk->FirstNumber==HOME )
                    {
                        SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);
                    }
                    if( Phbk->FirstNumber==OFFICE )
                    {
                        SEND_EVENT( data->win, INPUT_OFFICE, NULL ,NULL);                               
                    }
                }

            }                                                                                                                                                                                
        }
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:  
        {                           
            if( Phbk->BookType==SIM_BOOK_SEL )
            {
                if( data->edtname )
                {
                    /* 2003/12/04 sunsj modify for new editor mode */
                    //editor_destroy(data->edtname);
                    text_input_destroy(data->edtname);

                    data->edtname=0;
                }
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber=0;
                }
                SEND_EVENT( Phbk->input_win, INPUT_DESTROY, NULL, NULL);
                Phbk->input_win = 0;                                            
            }
            else if( Phbk->BookType==NVM_BOOK_SEL )
            {
                if( data->edtname )
                {
                    /* 2003/12/04 sunsj modify for new editor mode */
                    //editor_destroy(data->edtname);
                    text_input_destroy(data->edtname);

                    data->edtname=0;
                }
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber=0;
                }/*	 
                if ( data->edthome )   
                {
                  editor_destroy(data->edthome);
                  data->edthome=0;
                }	 
                if ( data->edtoffice )   
                {
                  editor_destroy(data->edtoffice);
                  data->edtoffice=0;
                }	 
                */
                /* 2003/12/04 sunsj destroy memo editor */
                if( data->edtmemo )
                {
                    text_input_destroy(data->edtmemo);
                    data->edtmemo=0;
                }

                SEND_EVENT( Phbk->input_win, INPUT_DESTROY, NULL, NULL);
                Phbk->input_win = 0;                  
            }
        }
        break;
    case INFO_EDT_UPDATE:
        {     /*    	
              oldColor=dspl_GetBkgColor();
              dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
              oldFontColor=dspl_GetFrgColor();
              dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));
              */
            /* 2004/03/24 sunsj remove */
            /*
            if( (wstrlen((char *)data->phbk->edt_buf_name)!=0) &&
                ((strlen((char *)data->phbk->edt_buf_number)!=0) || (strlen((char *)data->phbk->edt_buf_home)!=0) || (strlen((char *)data->phbk->edt_buf_office)!=0)) )
                displayPhbkEditSoftKeys(TxtSoftOK,TxtNull);
            else
                displayPhbkEditSoftKeys(TxtNull, TxtNull);
            */
            /*
            dspl_SetBkgColor(oldColor);
            dspl_SetFrgColor(oldFontColor);
            */
            if( Identifier==2 )
            {
                if( ((Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==NAME))||((Phbk->BookType==SIM_BOOK_SEL)&&(Phbk->MODE==NAME)) )
                {
                    dspl_ClearAll();
                    //draw the up rect
                    oldFontColor=dspl_SetFrgColor(0xADCCDC);
                    oldColor=dspl_SetBkgColor(0xDBF4FF);
                    dspl_DrawLine(3,20,95,20);
                    dspl_DrawLine(3,78,115,78);
                    dspl_DrawLine(2,21,2,78);

                    dspl_DrawLine(96,39,115,39);
                    dspl_Clear(6, 42, 114, 76);
                    dspl_SetFrgColor(oldFontColor);
                    dspl_SetBkgColor(oldColor);
                    oldColor=dspl_SetBkgColor(0xADCCDC);
                    dspl_fill_rectangle(95,20, 98, 39);
                    dspl_fill_rectangle(115,39, 118, 78);
                    dspl_SetBkgColor(oldColor);
                    //end draw up
                    //draw up word
                    dspl_TextOut(23,23,0,MmiRsrcGetText(TxtEnterName));
                    //end draw
                    //    SEND_EVENT( data->win, INPUT_NAME, NULL , NULL);
                }
                else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==MEMO) )
                {
                    dspl_ClearAll();

                    //draw the up rect
                    oldFontColor=dspl_SetFrgColor(0xADCCDC);
                    oldColor=dspl_SetBkgColor(0xDBF4FF);
                    dspl_DrawLine(3,20,95,20);
                    dspl_DrawLine(3,78,115,78);
                    dspl_DrawLine(2,21,2,78);

                    dspl_DrawLine(96,39,115,39);
                    dspl_Clear(6, 42, 114, 76);
                    dspl_SetFrgColor(oldFontColor);
                    dspl_SetBkgColor(oldColor);
                    oldColor=dspl_SetBkgColor(0xADCCDC);
                    dspl_fill_rectangle(95,20, 98, 39);
                    dspl_fill_rectangle(115,39, 118, 78);
                    dspl_SetBkgColor(oldColor);
                    //end draw up
                    //  if((Phbk->FirstNumber==NUMBER)||(Phbk->FirstNumber==HOME))
                    {//draw up word
                        dspl_TextOut(23,23,0,MmiRsrcGetText(TxtEnterName));
                        //show up details
                        if( strlen((char *)Phbk->edt_buf_name)!=0 )
                        {
                            oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                            dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                            dspl_SetBkgColor(oldFontColor);
                        }
                    }


                }
            }
            else if( Identifier==1 )
            {
                //dspl_DrawLine(0,144,119,144);
                //dspl_DrawLine(0,143,119,143);
                if( Phbk->BookType==SIM_BOOK_SEL && Phbk->MODE==NAME )
                {
                    /* 2003/11/1 sunsj sim code input */
                    UINT32 oldbackcolor,oldfontcolor;

                    //oldfontcolor=dspl_SetFrgColor(0xADCCDC);
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/01/14 sunsj modify for different screen size */
                    dspl_Clear(0, BOOKINPUT_HEIGHT_PERLINE, SCREEN_SIZE_X, VIEWLIST_MENU_VERTICAL_SIZE);

                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_NAME);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)nameicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)namefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)nameicon,DSPL_BMPXOR);

                    /* 2003/11/1 sunsj modify display area */
                    if( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        dspl_SetBkgColor(0xFFF6C1);
                        dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y-2, SCREEN_SIZE_X, PHONE_NAME_Y+BOOKINPUT_HEIGHT_PERLINE);
                        /* 2003/11/10 sunsj the number is one line display */
                        if( get_StringWidth((char *)Phbk->edt_buf_name) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
                        {
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)(Phbk->edt_buf_name+CountLengthOfSting(Phbk->edt_buf_name, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
                        }
                        else
                        {
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)Phbk->edt_buf_name, dspl_GetFrgColor());
                        }
                        //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)Phbk->edt_buf_name);
                        dspl_SetBkgColor(0xDBF4FF);
                    }
                    else
                    {
                        dspl_SetBkgColor(0xFFF6C1);
                        dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y-2, SCREEN_SIZE_X, PHONE_NAME_Y+BOOKINPUT_HEIGHT_PERLINE);
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)MmiRsrcGetText(TxtEnterName), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)MmiRsrcGetText(TxtEnterName));
                        dspl_SetBkgColor(0xDBF4FF);
                    }
                    //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)Phbk->edt_buf_name);

                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);

                    if( strlen((char *)Phbk->edt_buf_number)!=0 )
                    {
                        //dspl_SetBkgColor(0xDBF4FF);
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)Phbk->edt_buf_number, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)Phbk->edt_buf_number); 
                    }
                    else
                    {
                        //dspl_SetBkgColor(0xDBF4FF);
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterNumber)); 
                    }
                    dspl_SetBkgColor(oldbackcolor);
                    //dspl_SetFrgColor(oldfontcolor);
                    /*
                    ShowDetailView(TxtEnterName,TxtEnterNumber);
                    if ( strlen((char *)Phbk->edt_buf_number)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                        dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_number); 
                        dspl_SetBkgColor(oldFontColor);
                    }
                    */
                }
                else if( Phbk->BookType==SIM_BOOK_SEL && Phbk->MODE==NUMBER )
                {
                    /* 2003/11/1 sunsj sim code input */
                    UINT32 oldbackcolor,oldfontcolor;

                    //oldfontcolor=dspl_SetFrgColor(0xADCCDC);
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    dspl_Clear(0, BOOKINPUT_HEIGHT_PERLINE, SCREEN_SIZE_X, VIEWLIST_MENU_VERTICAL_SIZE);

                    if( strlen((char *)Phbk->edt_buf_number)!=0 )
                    {
                        dspl_SetBkgColor(0xFFF6C1);
                        dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y-2, SCREEN_SIZE_X, PHONE_MOBILENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
                        /* 2003/11/10 sunsj the number is one line display */
                        if( get_StringWidth((char *)Phbk->edt_buf_number) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
                        {
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)(Phbk->edt_buf_number+CountLengthOfSting(Phbk->edt_buf_number, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
                        }
                        else
                        {
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)Phbk->edt_buf_number, dspl_GetFrgColor());
                        }
                        //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)Phbk->edt_buf_number); 
                        dspl_SetBkgColor(0xDBF4FF);
                    }
                    else
                    {
                        dspl_SetBkgColor(0xFFF6C1);
                        dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y-2, SCREEN_SIZE_X, PHONE_MOBILENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterNumber)); 
                        dspl_SetBkgColor(0xDBF4FF);
                    }

                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                    ///dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);

                    /* 2004/03/11 sunsj modify */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_NAME);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)nameicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)namefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)nameicon,DSPL_BMPXOR);

                    /* 2003/11/1 sunsj modify display area */
                    if( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        //dspl_SetBkgColor(0xDBF4FF);
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)Phbk->edt_buf_name, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)Phbk->edt_buf_name);
                    }
                    else
                    {
                        //dspl_SetBkgColor(0xDBF4FF);
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)MmiRsrcGetText(TxtEnterName), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)MmiRsrcGetText(TxtEnterName));
                    }
                    dspl_SetBkgColor(oldbackcolor);
                    //dspl_SetFrgColor(oldfontcolor);
                    /*
                    ShowDetailView(TxtEnterName,TxtEnterNumber);
                    if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name); 
                        dspl_SetBkgColor(oldFontColor);
                    }
                    */
                }
                else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==NAME) )
                {
                    /* 2003/10/21 sunsj modify for the new book input display */
                    ShowDetailView(TxtEnterName,TxtEnterNumber);
                    UpdateDetailDate(Phbk);

                    /*
                    if ( Phbk->FirstNumber==NUMBER )
                    {
                        ShowDetailView(TxtEnterName,TxtEnterNumber);
                        if ( strlen((char *)Phbk->edt_buf_number)!=0 )
                        {
                            oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                            dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_number); 
                            dspl_SetBkgColor(oldFontColor);
                        }

                    }
                    if ( Phbk->FirstNumber==HOME )
                    {
                        ShowDetailView(TxtEnterName,TxtEnterHome);
                        if ( strlen((char *)Phbk->edt_buf_home)!=0 )
                        {
                            oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                            dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_home);
                            dspl_SetBkgColor(oldFontColor);
                        }
                    }
                    if ( Phbk->FirstNumber==OFFICE )
                    {
                        ShowDetailView(TxtEnterName,TxtEnterOffice);
                        if ( strlen((char *)Phbk->edt_buf_office)!=0 )
                        {
                            oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                            dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_office); 
                            dspl_SetBkgColor(oldFontColor);
                        }
                    }
                    */
                }
                else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==NUMBER) )
                {
                    /* 2003/10/21 sunsj/ modify for new bookinput */
                    ShowDetailView(TxtEnterName,TxtEnterNumber);
                    UpdateDetailDate(Phbk);
                    /*
                    if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name); 
                        dspl_SetBkgColor(oldFontColor);
                    }
                    */
                }
                else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==HOME) )
                {
                    /* 2003/10/21 sunsj/ modify for new bookinput */
                    ShowDetailView(TxtEnterName,TxtEnterHome);
                    UpdateDetailDate(Phbk);
                    /*
                    if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                        dspl_SetBkgColor(oldFontColor);
                    }
                    */
                }
                else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==OFFICE) )
                {
                    /* 2003/10/21 sunsj/ modify for new bookinput */
                    ShowDetailView(TxtEnterName,TxtEnterOffice);
                    UpdateDetailDate(Phbk);
                    /*
                    if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                        dspl_SetBkgColor(oldFontColor);
                    }
                    */
                }

                else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==MEMO) )
                {
                    /* 2003/10/21 sunsj/ modify for new bookinput */
                    ShowDetailView(TxtEnterName,TxtEnterMemo);
                    UpdateDetailDate(Phbk);
                    /*
                    if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                    {
                        oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                        dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                        dspl_SetBkgColor(oldFontColor);
                    }
                    */
                }
            }
        }   
        break;
    case INFO_TOPREV_EDT:
        {
            oldColor=dspl_GetBkgColor();
            dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
            oldFontColor=dspl_GetFrgColor();
            dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));  
            if( (wstrlen((char *)data->phbk->edt_buf_name)!=0) &&
                ((strlen((char *)data->phbk->edt_buf_number)!=0) || (strlen((char *)data->phbk->edt_buf_home)!=0) || (strlen((char *)data->phbk->edt_buf_office)!=0)) )
            {
                displayPhbkEditSoftKeys(TxtSoftOK,TxtNull);
            }
            else
            {
                displayPhbkEditSoftKeys(TxtNull, TxtNull);
            }
            dspl_SetBkgColor(oldColor);
            dspl_SetFrgColor(oldFontColor);
            //dspl_DrawLine(0,144,119,144);
            //dspl_DrawLine(0,143,119,143);
            if( (Phbk->BookType==SIM_BOOK_SEL) && (Phbk->MODE==NUMBER) )
            {
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber=0;
                }
                /* 2003/10/21 sunsj/ modify for new bookinput 
                   modify the number to the name edt */
                //clearup();
                //cleardown(0);
                SEND_EVENT( data->win, INPUT_NAME, NULL , NULL);
                /*
                if ( strlen((char *)Phbk->edt_buf_number)!=0 )
                {
                oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_number); 
                dspl_SetBkgColor(oldFontColor); 
                }
                */
            }
            else if( Phbk->BookType==NVM_BOOK_SEL )
            {
                switch( Phbk->MODE )
                {
                case NUMBER:
                    {
                        /* 2003/10/21 sunsj/ modify for new bookinput */
                        if( data->edtnumber )
                        {
                            editor_destroy(data->edtnumber);
                            data->edtnumber=0;
                        }

                        SEND_EVENT( data->win, INPUT_NAME, NULL , NULL);

                        /*
                        if ( Phbk->FirstNumber==NUMBER )
                        {
                            clearup();
                            cleardown(0);
                            if ( data->edtnumber )
                            {
                                editor_destroy(data->edtnumber);
                                data->edtnumber=0;
                            }
                            SEND_EVENT( data->win, INPUT_NAME, NULL , NULL); 
                            if ( strlen((char *)Phbk->edt_buf_number)!=0 )
                            {
                                oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                                dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_number); 
                                dspl_SetBkgColor(oldFontColor); 
                            }
                        }
                        if ( Phbk->FirstNumber==HOME )
                        {
                            cleardown(TxtEnterHome);
                            SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);  
                        }
                        if ( Phbk->FirstNumber==OFFICE )
                        {
                            cleardown(TxtEnterOffice);
                            SEND_EVENT( data->win, INPUT_OFFICE, NULL , NULL);     
                        }
                        */
                    }  
                    break;                      
                case HOME: 
                    {
                        /* 2003/10/21 sunsj/ modify for new bookinput */
                        if( data->edtnumber )
                        {
                            editor_destroy(data->edtnumber);
                            data->edtnumber=0;
                        }

                        SEND_EVENT( data->win, INPUT_NUMBER, NULL , NULL);

                        /*
                        if ( Phbk->FirstNumber==HOME )
                        {
                            clearup();
                            cleardown(0);
                            if ( data->edtnumber )
                            {
                                editor_destroy(data->edtnumber);
                                data->edtnumber=0;
                            }
                            SEND_EVENT( data->win, INPUT_NAME, NULL , NULL); 
                            if ( strlen((char *)Phbk->edt_buf_home)!=0 )
                            {
                                oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                                dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_home); 
                                dspl_SetBkgColor(oldFontColor); 
                            }
                        }
                        if ( Phbk->FirstNumber==NUMBER ||Phbk->FirstNumber==OFFICE )
                        {
                            cleardown(TxtEnterNumber);

                            SEND_EVENT( data->win, INPUT_NUMBER, NULL , NULL);
                        }
                        */
                    }                     
                    break;
                case OFFICE:
                    {
                        /* 2003/10/21 sunsj/ modify for new bookinput */
                        if( data->edtnumber )
                        {
                            editor_destroy(data->edtnumber);
                            data->edtnumber=0;
                        }

                        SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);

                        /*
                        if ( Phbk->FirstNumber==NUMBER )
                        {
                            cleardown(TxtEnterHome);
                            SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);
                        }
                        if ( Phbk->FirstNumber==HOME )
                        {
                            cleardown(TxtEnterNumber);
                            SEND_EVENT( data->win, INPUT_NUMBER, NULL , NULL);
                        }
                        if ( Phbk->FirstNumber==OFFICE )
                        {
                            clearup();
                            cleardown(0);
                            if ( data->edtnumber )
                            {
                                editor_destroy(data->edtnumber);
                                data->edtnumber=0;
                            }
                            SEND_EVENT( data->win, INPUT_NAME, NULL , NULL); 
                            if ( strlen((char *)Phbk->edt_buf_office)!=0 )
                            {
                                oldFontColor=dspl_SetBkgColor(0xFFF6C1);
                                dspl_TextOut_Blk(6,105,114,0,(char *)Phbk->edt_buf_office); 
                                dspl_SetBkgColor(oldFontColor); 
                            }
                        }
                        */
                    }  
                    break;
                case MEMO:
                    {
                        /* 2003/10/21 sunsj/ modify for new bookinput */
                        /* 2003/12/04 sunsj modify for new bookinput */
                        if( data->edtmemo )
                        {
                            text_input_destroy(data->edtmemo);
                            data->edtmemo=0;
                        }

                        SEND_EVENT( data->win, INPUT_OFFICE, NULL , NULL); 
                        /*
                        if ( Phbk->FirstNumber==NUMBER || Phbk->FirstNumber==HOME )
                        {
                            cleardown(TxtEnterOffice);
                            SEND_EVENT( data->win, INPUT_OFFICE, NULL , NULL);         
                        }
                        if ( Phbk->FirstNumber==OFFICE )
                        {
                            cleardown(TxtEnterHome);
                            SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);
                        }
                        */
                    }  
                    break;
                default:
                    break;                         
                }                    
            }
        }
        break;
    case INFO_TONEXT_EDT:
        {
            /* 2004/03/24 sunsj remove */
            /*
            oldColor=dspl_GetBkgColor();
            dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
            oldFontColor=dspl_GetFrgColor();
            dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));  
            if( (wstrlen((char *)data->phbk->edt_buf_name)!=0) &&
                ((strlen((char *)data->phbk->edt_buf_number)!=0) || (strlen((char *)data->phbk->edt_buf_home)!=0) || (strlen((char *)data->phbk->edt_buf_office)!=0)) )
            {
                displayPhbkEditSoftKeys(TxtSoftOK,TxtNull);
            }
            else
            {
                displayPhbkEditSoftKeys(TxtNull, TxtNull);
            }
            dspl_SetBkgColor(oldColor);
            dspl_SetFrgColor(oldFontColor);
            */
            //dspl_DrawLine(0,144,119,144);
            //dspl_DrawLine(0,143,119,143);
            if( (Phbk->BookType==SIM_BOOK_SEL) && (Phbk->MODE==NAME) )
            {
                if( data->edtname )
                {
                    /* 2003/12/04 sunsj modify for new editor mode */
                    //editor_destroy(data->edtname);
                    text_input_destroy(data->edtname);

                    data->edtname=0;
                }
                clearup();
                cleardown(0);
                SEND_EVENT( data->win, INPUT_NUMBER, NULL , NULL); 
                /* 2003/10/21 sunsj/ modify for new bookinput */
                /*
                if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                {
                    oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                    dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                    dspl_SetBkgColor(oldFontColor);
                }
                */
            }
            if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==NAME) )
            {

                if( data->edtname )
                {
                    /* 2003/12/04 sunsj modify for new editor mode */
                    //editor_destroy(data->edtname);
                    text_input_destroy(data->edtname);

                    data->edtname=0;
                }
                clearup();
                cleardown(0);

                /* 2003/10/21/ sunsj modify for new book input */
                //if ( Phbk->FirstNumber==NUMBER )
                {
                    SEND_EVENT( data->win, INPUT_NUMBER, NULL, NULL);
                }
                /*
                if ( Phbk->FirstNumber==HOME )
                {
                    SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);
                }
                if ( Phbk->FirstNumber==OFFICE )
                {
                    SEND_EVENT( data->win, INPUT_OFFICE, NULL ,NULL);
                }
                if ( strlen((char *)Phbk->edt_buf_name)!=0 )
                {
                    oldFontColor=dspl_SetBkgColor(0xDBF4FF);
                    dspl_TextOut_Blk(6,42,114,0,(char *)Phbk->edt_buf_name);
                    dspl_SetBkgColor(oldFontColor);
                }
                */
            }
            else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==NUMBER) )
            {
                /* 2003/10/21/ sunsj modify for new book input */
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber = 0;
                }

                //if ( Phbk->FirstNumber==NUMBER || Phbk->FirstNumber==OFFICE )
                {
                    cleardown(TxtEnterHome);
                    SEND_EVENT( data->win, INPUT_HOME, NULL , NULL);
                }
                /*
                if ( Phbk->FirstNumber==HOME )
                {
                    cleardown(TxtEnterOffice);
                    SEND_EVENT( data->win, INPUT_OFFICE, NULL ,NULL);       
                }
                */
            }
            else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==HOME) )
            {
                /* 2003/10/21/ sunsj modify for new book input */
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber = 0;
                }

                //if ( Phbk->FirstNumber==NUMBER )
                {
                    cleardown(TxtEnterOffice);
                    SEND_EVENT( data->win, INPUT_OFFICE, NULL ,NULL);
                }
                /*
                if ( Phbk->FirstNumber==HOME )
                {
                    cleardown(TxtEnterNumber);
                    SEND_EVENT( data->win, INPUT_NUMBER, NULL, NULL);
                }
                if ( Phbk->FirstNumber==OFFICE )
                {
                    cleardown(TxtEnterMemo);
                    SEND_EVENT( data->win, INPUT_MEMO, NULL , NULL);
                }
                */
            }
			/* 2004/05/28 sunsj modify */
            else if( (Phbk->BookType==NVM_BOOK_SEL) && (Phbk->MODE==OFFICE) )
            {
                /* 2003/10/21/ sunsj modify for new book input */
                if( data->edtnumber )
                {
                    editor_destroy(data->edtnumber);
                    data->edtnumber = 0;
                }

                //if ( Phbk->FirstNumber==NUMBER || Phbk->FirstNumber==HOME )
                {
                    cleardown(TxtEnterMemo);
                    SEND_EVENT( data->win, INPUT_MEMO, NULL , NULL); 
                }
                /*
                if ( Phbk->FirstNumber==OFFICE )
                {
                    cleardown(TxtEnterNumber);
                    SEND_EVENT( data->win, INPUT_NUMBER, NULL, NULL); 
                }
                */
            }
        }
        break;
    default:
        break;
    }
    if( Phbk->root_win==Phbk->win )    /*To destroy the phonebook when entering from idle*/
        bookPhonebookDestroy(Phbk->win);

}

void bookGroupingRenameCB( T_MFW_HND win,USHORT Identifier,  UBYTE reason )
{
    T_MFW_WIN        *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard      *data       = (tBookStandard *) win_data->user;
    T_phbk            *Phbk       =data->phbk;
    char               temp[100];

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            if( strlen((char *)data->phbk->edt_buf_rename)!=0 )
            {
                if( data->phbk->edt_buf_rename[0]==0x80 )
                {
                    wstrncpy( (char *) FFS_PBOtherData.GroupingItem[Phbk->select_index].GroupingName,          
                              (char *) data->phbk->edt_buf_rename,GroupingName_len);
                    wstrncpy( (char *) DataItem[Phbk->select_index].name,(char *) data->phbk->edt_buf_rename,GroupingName_len);

                }
                else
                {
                    memcpy(FFS_PBOtherData.GroupingItem[Phbk->select_index].GroupingName,data->phbk->edt_buf_rename,GroupingName_len);               
                    memcpy(DataItem[Phbk->select_index].name,data->phbk->edt_buf_rename,GroupingName_len);
                }  

                flash_PBOtherWrite("PBOption");
                MmiBookSetCurrentText(TxtEditSucceed);//Ϊɹ                         
            }
            else MmiBookSetCurrentText(TxtEditFail);//Ϊʧ               
            bookShowInformation( data->phbk->groupingRename_win, MmiBookCurrentText(),NULL, NULL );
            SEND_EVENT(data->phbk->groupingRename_win, INPUT_DESTROY, 0, 0);                      
        }
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        {            
            SEND_EVENT( data->phbk->groupingRename_win, INPUT_DESTROY, 0, 0 );
        }
        break;

    default: break;
    }

}

void bookOwnNumberEditCB( T_MFW_HND win,USHORT Identifier, UBYTE reason )
{
    T_MFW_WIN        *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard      *data       = (tBookStandard *) win_data->user;
    T_phbk            *Phbk       =data->phbk;
    char               temp[100];

    //sprintf(temp,"Phbk->select_index:%d;Phbk->phbk->select_index:%d",
    //       Phbk->select_index,Phbk->phbk->select_index);
    //TRACE_EVENT(temp);

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            if( data->phbk->OwnNumberItem_win!=0 )
            {
                //change
                memcpy(data->phbk->upnList->upn[data->phbk->select_index].number,data->phbk->edt_buf_number,PHB_number_len);
//glowing,2004-06-16,phb_save_upn use the difference parameters between M188 and M288
#ifdef _M188_				
                if( phb_save_upn(&data->phbk->upnList->upn[data->phbk->select_index],data->phbk->select_index+1)==MFW_PHB_OK )
#else
                if( phb_save_upn(&data->phbk->upnList->upn[data->phbk->select_index])==MFW_PHB_OK )
#endif
                    MmiBookSetCurrentText(TxtEditSucceed);
                else MmiBookSetCurrentText(TxtEditFail);
            }
            else
            {
                //new 
                memcpy(data->phbk->upnList->upn[data->phbk->upnList->count].number,data->phbk->edt_buf_number,PHB_number_len);
#ifdef _M188_				
                if( phb_save_upn(&data->phbk->upnList->upn[data->phbk->upnList->count],data->phbk->upnList->count+1)==MFW_PHB_OK )
#else
                if( phb_save_upn(&data->phbk->upnList->upn[data->phbk->upnList->count])==MFW_PHB_OK )
#endif
                {
                    data->phbk->upnList->count=data->phbk->upnList->count+1;
                    MmiBookSetCurrentText(TxtAddSucceed);
                }
                else MmiBookSetCurrentText(TxtAddFail);
            }

            bookShowInformation( data->win, MmiBookCurrentText(),NULL, NULL );       

            if( data->editor_data.mode == TEXTINPUT_MODE )
            {
                text_input_destroy(data->edt);
            }
            else
            {
                editor_destroy(data->edt);   
            }

            if( data->phbk->OwnNumberItem_win==0 )
                SEND_EVENT( data->win, OwnNumber_DESTROY, NULL, NULL);
        }
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        {            
            if( data->editor_data.mode == TEXTINPUT_MODE )
            {
                text_input_destroy(data->edt);
            }
            else
            {
                editor_destroy(data->edt);   
            }
            if( data->phbk->OwnNumberItem_win==0 )
                SEND_EVENT( data->win, OwnNumber_DESTROY, NULL, NULL);
        }
        break;

    default: break;
    }

}


/*******************************************************************************

                                End of File

*******************************************************************************/

static void book_edit_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    char temp[50];

    //TRACE_FUNCTION ("book_failure_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            //sprintf(temp,"tempindex:%d",NewIndex);
            //TRACE_EVENT(temp);
            SEND_EVENT(win, SEARCH_DESTROY, 1, (int *)NewIndex); 
        }      
        break;                                                   
    default: break;
    }
}

static void book_add_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard     *data       = (tBookStandard *) win_data->user;
    T_phbk           *Phbk       = data->phbk;

    //TRACE_FUNCTION ("book_failure_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {

            SEND_EVENT( Phbk->input_win, INPUT_DESTROY, NULL, NULL);
            Phbk->input_win = 0;
        }      
        break;                                                   
    default: break;
    }
}
static void book_search_information(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  * data     = (tBookStandard *) win_data->user;
    T_phbk         * Phbk       =data->phbk;

    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            SEND_EVENT(win, SEARCH_INIT, NULL, NULL);
            //winShow(data->win);
        }      
        break;                                                   
    default: break;
    }
}
//hbh added for keep the ldb same with phb
static void ChangeFlashDCTbDataName(T_EasyName  NumChangeName) //hubinhao 2003-1-24
{
    UBYTE n,flagMarkChange;
    int i;
    n=0;
    flagMarkChange=0;

    //TRACE_FUNCTION("ChangeFlashDCTbDataName");

    //step 1 check "M" calls
    n=FlashDCTbData.LMNID;
    for( i=0;i<n;i++ )
    {
        if( GetShortNumber((char *)FlashDCTbData.LMNTable[i])==GetShortNumber((char *)NumChangeName.number) )
        {
            //TRACE_EVENT("we find the number");
            //TRACE_EVENT((char *)NumChangeName.number);
            if( strcmp((char*)FlashDCTbData.LMNTable[i],(char *)NumChangeName.number)==0 )
            {
                wstrcpy((char*)FlashDCTbData.Mname[i],(char*)NumChangeName.name);  //hu binhao 2003-1-24
                flagMarkChange=1;
                break;

            }


        }
    }


    //step 2 check "J" calls
    n=FlashDCTbData.LJNID;
    for( i=0;i<n;i++ )
    {
        if( GetShortNumber((char *)FlashDCTbData.LJNTable[i])==GetShortNumber((char *)NumChangeName.number) )
        {
            if( strcmp((char*)FlashDCTbData.LJNTable[i],(char *)NumChangeName.number)==0 )
            {
                wstrcpy((char*)FlashDCTbData.Jname[i],(char*)NumChangeName.name);  //hu binhao 2003-1-24
                flagMarkChange=1;
                break;

            }


        }
    }


    //step 3 check "R" calls
    n=FlashDCTbData.LRNID;
    for( i=0;i<n;i++ )
    {
        if( GetShortNumber((char *)FlashDCTbData.LRNTable[i])==GetShortNumber((char *)NumChangeName.number) )
        {
            if( strcmp((char*)FlashDCTbData.LRNTable[i],(char *)NumChangeName.number)==0 )
            {
                wstrcpy((char*)FlashDCTbData.Rname[i],(char*)NumChangeName.name);  //hu binhao 2003-1-24
                flagMarkChange=1;
                break;

            }


        }
    }


    //step 4 check "D" calls
    n=FlashDCTbData.LDNID;
    for( i=0;i<n;i++ )
    {
        if( GetShortNumber((char *)FlashDCTbData.LDNTable[i])==GetShortNumber((char *)NumChangeName.number) )
        {
            if( strcmp((char*)FlashDCTbData.LDNTable[i],(char *)NumChangeName.number)==0 )
            {
                wstrcpy((char*)FlashDCTbData.Dname[i],(char*)NumChangeName.name);  //hu binhao 2003-1-24
                flagMarkChange=1;
                break;

            }


        }
    }

    //step 5 write to flash
    if( flagMarkChange )
        flash_DCTbwrite();
    ChangeSmsDataName(NumChangeName);

}

static void cleardown(int txtid)
{
    /* 2003/12/22 sunsj remove */
#if 0
    UINT32 oldbackcolor;
    char temp[100],temp2[10];
    int i,j;
    oldbackcolor=dspl_SetBkgColor(0xFFF6C1);
    dspl_Clear(6, 105, 114, 139);
    dspl_SetBkgColor(oldbackcolor);
    if( txtid!=0 )
        dspl_Clear(5,86,94,103);
    if( txtid==TxtEnterNumber )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)mobileicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)mobilefficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)mobileicon,DSPL_BMPXOR);
    }
    else if( txtid==TxtEnterOffice )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)officeicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)officefficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)officeicon,DSPL_BMPXOR);
    }
    else if( txtid==TxtEnterHome )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)homeicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)homefficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)homeicon,DSPL_BMPXOR);
    }
    else if( txtid==TxtEnterMemo )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)memoicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)memofficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)memoicon,DSPL_BMPXOR);
    }
    dspl_TextOut(23,86,0,MmiRsrcGetText(txtid));
    //Sprintf(temp,"ID:%d",txtid);
    //TRACE_EVENT(temp);
    //Sprintf(temp,"memo:%d",TxtEnterMemo);
    //TRACE_EVENT(temp);
    //Sprintf(temp,"length:%d",wstrlen((char *)MmiRsrcGetText(txtid)));
    //TRACE_EVENT(temp);
    memset(temp,0,100);
    for( i=0;i<wstrlen((char *)MmiRsrcGetText(txtid));i++ )
    {
        Sprintf(temp2,"%d:%d",i+1,*(MmiRsrcGetText(txtid)+i));
        wstrcat(temp,temp2);
    }
    //TRACE_EVENT(temp);
#endif
}
static void clearup()
{
    /* 2003/12/22 sunsj remove */
#if 0
    UINT32 oldbackcolor;
    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);
    dspl_Clear(6, 42, 114, 76);
    dspl_SetBkgColor(oldbackcolor);
#endif
}

/****************************************************************************************
 $Function:    	ShowDetailView

 $Description:	display phone code icon

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003.10.21

 $History:  2003/11/1   sunsj modify the display area

****************************************************************************************/
void ShowDetailView(int txtid1,int txtid2)
{
    /* 2003/10/21 sunsj modify for the new book input display */
#if 0
    UINT32 oldbackcolor,oldfontcolor;
    dspl_ClearAll();
    //draw the up rect
    oldfontcolor=dspl_SetFrgColor(0xADCCDC);
    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);
    dspl_DrawLine(3,20,95,20);
    dspl_DrawLine(3,78,115,78);
    dspl_DrawLine(2,21,2,78);

    dspl_DrawLine(96,39,115,39);
    dspl_Clear(6, 42, 114, 76);
    //end draw up
    //draw down rect
    dspl_SetBkgColor(0xFFF6C1);
    dspl_DrawLine(3,82,95,82);
    dspl_DrawLine(3,140,115,140);
    dspl_DrawLine(2,83,2,140);

    dspl_DrawLine(96,101,115,101);
    dspl_Clear(6, 105, 114, 139);
    dspl_SetBkgColor(oldbackcolor);
    dspl_SetFrgColor(oldfontcolor);
    //end draw down
    oldbackcolor=dspl_SetBkgColor(0xADCCDC);
    dspl_fill_rectangle(95,20, 98, 39);
    dspl_fill_rectangle(115,39, 118, 78);
    dspl_fill_rectangle(95,82, 98, 101);
    dspl_fill_rectangle(115,101, 118, 140);
    dspl_SetBkgColor(oldbackcolor);
    //draw down word
    if( txtid2==TxtEnterNumber )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)mobileicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)mobilefficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)mobileicon,DSPL_BMPXOR);
    }
    else if( txtid2==TxtEnterOffice )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)officeicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)officefficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)officeicon,DSPL_BMPXOR);
    }
    else if( txtid2==TxtEnterHome )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)homeicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)homefficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)homeicon,DSPL_BMPXOR);
    }
    else if( txtid2==TxtEnterMemo )
    {
        dspl_BitBlt(6,86,12,12,0,(void *)memoicon,DSPL_BMPXOR);
        dspl_BitBlt(6,86,12,12,0,(void *)memofficon,DSPL_BMPAND);
        dspl_BitBlt(6,86,12,12,0,(void *)memoicon,DSPL_BMPXOR);
    }
    //draw up word
    dspl_TextOut(23,23,0,MmiRsrcGetText(txtid1));
    //end
    dspl_TextOut(23,86,0,MmiRsrcGetText(txtid2));
    //end
#endif
    UINT32 oldbackcolor,oldfontcolor;
    //dspl_ClearAll();

    oldfontcolor=dspl_SetFrgColor(0xADCCDC);
    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

    /* 2004/01/14 sunsj modify for different screen size */
    dspl_Clear(0, BOOKINPUT_HEIGHT_PERLINE, SCREEN_SIZE_X, VIEWLIST_MENU_VERTICAL_SIZE);
    dspl_SetBkgColor(oldbackcolor);
    dspl_SetFrgColor(oldfontcolor);
    //draw up word
    //dspl_TextOut(23,23,0,MmiRsrcGetText(txtid1));
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_NAME);

    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);

    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_HOME);

    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_OFFICE);

    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MEMO);
    /* display all the record icons */

    return;

}

/****************************************************************************************
 $Function:    	UpdateDetailDate

 $Description:	update input date display

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003.10.21

 $History:  2003/11/1   sunsj modify the display area
            2003/11/10  sunsj modify number display method
            2004/01/14	sunsj modify for different screen size
****************************************************************************************/
void UpdateDetailDate(T_phbk *Phbk)
{
    UINT32 oldFontColor;
    T_phbk *phbk;
    /* 2003/12/04 sunsj modify name display */
    char display_buf[40];

    phbk = Phbk;

    oldFontColor=dspl_SetBkgColor(0xDBF4FF);

    if( strlen((char *)Phbk->edt_buf_name)!=0 )
    {
        if( Phbk->MODE == NAME )
        {
            dspl_SetBkgColor(0xFFF6C1);
            /* 2004/01/14 sunsj modify for different screen size */
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, SCREEN_SIZE_X, PHONE_NAME_Y+BOOKINPUT_HEIGHT_PERLINE);

            /* 2003/11/10 sunsj the number is one line display */
            if( get_StringWidth((char *)Phbk->edt_buf_name) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
            {
                /* 2003/12/04 sunsj modify for name display */
                if( Phbk->edt_buf_name[0] == 0x80 )
                {
                    memset(display_buf, 0x00, 40);
                    display_buf[0] = 0x80;
                    /* 2004/01/14 sunsj modify for different screen size */
                    memcpy(&display_buf[1], (char *)(Phbk->edt_buf_name+CountLengthOfSting(Phbk->edt_buf_name, 
                                                                                           SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)+1), 
                           sizeof(wstrlen((char *)Phbk->edt_buf_name) - (CountLengthOfSting(Phbk->edt_buf_name, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)/2))*2);
                    drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, 
                                               (char *)display_buf, dspl_GetFrgColor());
                }
                else
                {
                    drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, 
                                               (char *)(phbk->edt_buf_name+CountLengthOfSting(phbk->edt_buf_name, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
                }
            }
            else
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, 
                                           (char *)Phbk->edt_buf_name, dspl_GetFrgColor());
            }
            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)phbk->edt_buf_name); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)Phbk->edt_buf_name, dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)phbk->edt_buf_name); 
        }
        //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)phbk->edt_buf_name); 
    }
    else
    {
        if( Phbk->MODE == NAME )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, SCREEN_SIZE_X, PHONE_NAME_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)MmiRsrcGetText(TxtEnterName), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)MmiRsrcGetText(TxtEnterName));
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET ,PHONE_NAME_Y ,SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET , 0, (char *)MmiRsrcGetText(TxtEnterName));
        }
    }

    if( strlen((char *)Phbk->edt_buf_number)!=0 )
    {
        if( Phbk->MODE == NUMBER )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, SCREEN_SIZE_X, PHONE_MOBILENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            if( get_StringWidth((char *)phbk->edt_buf_number) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, 
                                           (char *)(phbk->edt_buf_number+CountLengthOfSting(phbk->edt_buf_number, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
            }
            else
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)phbk->edt_buf_number, dspl_GetFrgColor());
            }
            //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)phbk->edt_buf_number); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)phbk->edt_buf_number, dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)phbk->edt_buf_number); 
        }
        //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)phbk->edt_buf_number); 
    }
    else
    {
        if( Phbk->MODE == NUMBER )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, SCREEN_SIZE_X, PHONE_MOBILENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterNumber)); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterNumber)); 
        }
        //dspl_TextOut_Blk(22,PHONE_MOBILENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterNumber)); 
    }

    if( strlen((char *)Phbk->edt_buf_home)!=0 )
    {
        if( Phbk->MODE == HOME )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, SCREEN_SIZE_X, PHONE_HOMENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            if( get_StringWidth((char *)phbk->edt_buf_home) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)(phbk->edt_buf_home+CountLengthOfSting(phbk->edt_buf_home, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
            }
            else
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)phbk->edt_buf_home, dspl_GetFrgColor());
            }
            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)phbk->edt_buf_home); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)phbk->edt_buf_home, dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)phbk->edt_buf_home); 
        }
        //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)phbk->edt_buf_home); 
    }
    else
    {
        if( Phbk->MODE == HOME )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, SCREEN_SIZE_X, PHONE_HOMENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
        }
        //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
    }

    if( strlen((char *)Phbk->edt_buf_office)!=0 )
    {
        if( Phbk->MODE == OFFICE )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, SCREEN_SIZE_X, PHONE_OFFICENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            if( get_StringWidth((char *)phbk->edt_buf_office) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)(phbk->edt_buf_office+CountLengthOfSting(phbk->edt_buf_office, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
            }
            else
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)phbk->edt_buf_office, dspl_GetFrgColor());
            }
            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)phbk->edt_buf_office);
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)phbk->edt_buf_office, dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)phbk->edt_buf_office);
        }
        //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)phbk->edt_buf_office); 
    }
    else
    {
        if( Phbk->MODE == OFFICE )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, SCREEN_SIZE_X, PHONE_OFFICENUM_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/11/10 sunsj the number is one line display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
        }
        //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
    }

    if( strlen((char *)Phbk->edt_buf_memo)!=0 )
    {
        if( Phbk->MODE == MEMO )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, SCREEN_SIZE_X, PHONE_MEMO_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/12/04 sunsj the number is one line display */
            if( get_StringWidth((char *)phbk->edt_buf_memo) >= (SCREEN_SIZE_X - PHONEEDITOR_SCREEN_X_OFFSET) )
            {
                /* 2003/12/04 sunsj modify for memo display */
                if( Phbk->edt_buf_memo[0] == 0x80 )
                {
                    memset(display_buf, 0x00, 40);
                    display_buf[0] = 0x80;
                    memcpy(&display_buf[1], (char *)(Phbk->edt_buf_memo+CountLengthOfSting(Phbk->edt_buf_memo, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)+1), sizeof(wstrlen((char *)Phbk->edt_buf_memo) - (CountLengthOfSting(Phbk->edt_buf_memo, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)/2))*2);
                    drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, (char *)display_buf, dspl_GetFrgColor());
                }
                else
                {
                    drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, (char *)(phbk->edt_buf_memo+CountLengthOfSting(phbk->edt_buf_memo, SCREEN_SIZE_X-PHONEEDITOR_SCREEN_X_OFFSET, 0)),dspl_GetFrgColor());
                }
            }
            else
            {
                drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, (char *)phbk->edt_buf_memo, dspl_GetFrgColor());
            }
            //dspl_TextOut_Blk(22,PHONE_MEMO_Y,110,0,(char *)phbk->edt_buf_memo); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/12/04 sunsj modify for memo display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, (char *)phbk->edt_buf_memo, dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_MEMO_Y,110,0,(char *)phbk->edt_buf_memo); 
        }
        //dspl_TextOut_Blk(22,PHONE_MEMO_Y,110,0,(char *)phbk->edt_buf_memo); 
    }
    else
    {
        if( Phbk->MODE == MEMO )
        {
            dspl_SetBkgColor(0xFFF6C1);
            dspl_Clear(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, SCREEN_SIZE_X, PHONE_MEMO_Y+BOOKINPUT_HEIGHT_PERLINE);
            /* 2003/12/04 sunsj modify for memo display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, (char *)MmiRsrcGetText(TxtEnterMemo), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_MEMO_Y,110,0,(char *)MmiRsrcGetText(TxtEnterMemo)); 
            dspl_SetBkgColor(0xDBF4FF);
        }
        else
        {
            dspl_SetBkgColor(0xDBF4FF);
            /* 2003/12/04 sunsj modify for memo display */
            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, (char *)MmiRsrcGetText(TxtEnterMemo), dspl_GetFrgColor());
            //dspl_TextOut_Blk(22,PHONE_MEMO_Y,110,0,(char *)MmiRsrcGetText(TxtEnterMemo)); 
        }
        //dspl_TextOut_Blk(22,PHONE_MEMO_Y,110,0,(char *)MmiRsrcGetText(TxtEnterMemo)); 
    }
    /* display all the content of the input editor */
    dspl_SetBkgColor(oldFontColor);
}

/****************************************************************************************
 $Function:    	CountLengthOfSting

 $Description:	count the stringnumber by given length

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003/11/10

 $History:

****************************************************************************************/
int CountLengthOfSting(char *string, int stringlength, int stringtype)
{
    char *str;
    int  stringnumber = 0;
    int  total_width = 0;
    int  stepsize = 0;
    U16  HighByte;
    U16  LowByte;
    U16  Temp_Char;

    str = string;

    if( str == NULL )
        return 0;

    if( stringtype == DSPL_TXTATTR_UNICODE )    /* unicode string */
    {
        stepsize = 2;
    }
    else if( *string == (char)0x80 )    /* unicode string */
    {
        string++;
        stepsize = 2;
    }
    else    /* ascii string*/
    {
        stepsize = 1;
    }

    if( stepsize == 2 )
    {
        HighByte = (*str & 0x00ff) << 8;
        LowByte = (*(str+1) & 0x00ff);

        Temp_Char = HighByte | LowByte;

        while( Temp_Char )
        {
            total_width += get_CharWidth( Temp_Char );

            if( total_width > stringlength )
            {
                break;
            }
            string += stepsize;
            stringnumber += stepsize;
            HighByte = (*str & 0x00ff) << 8;
            LowByte = (*(str+1) & 0x00ff);

            Temp_Char = HighByte | LowByte;
        }
    }
    else
    {
        while( *str )
        {
            total_width += get_CharWidth( (U16)*str );

            if( total_width > stringlength )
            {
                break;
            }
            stringnumber += stepsize;
        }
    }
    return stringnumber;
}
/*******************************************************************************

                                End of File

*******************************************************************************/

