#ifndef _MMI_BOOK_SERVICES_H_
#define _MMI_BOOK_SERVICES_H_ 1

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiBookServices.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This module provides the basic phone book services required by
	the other phone book modules
                        
********************************************************************************
 $History: MmiMsgs.c

	25/10/00			Original Condat(UK) BMI version.	
	20/08/02     ver0.101  fzq modified  
 $End

*******************************************************************************/




/*******************************************************************************
                                                                              
                                Public Methods
                                                                              
*******************************************************************************/
#define READ 3
#define WRITE 6
//#define MMI_PHONEBOOK_MEMORYSTATE 700
//#define MMI_VOICEMEMO_MEMROYSTATE 701/*2003/12/4, wangyan delete*/

/* initialise and exit the phone book application
*/
void bookInitialise( MfwHnd parent );
void bookExit( void );

/* The following services are provided by this module
*/
int bookFindNameInPhonebook( const char* p_pszNumber, T_MFW_PHB_ENTRY* p_pEntry );

/* Find a number given a position in the book
*/
UBYTE bookFindNumberByPosition( UBYTE index, T_MFW_PHB_ENTRY* p_pEntry );

/* Show an information dialog
*/
void bookShowInformation( MfwHnd parent, int txtId, char *text, T_VOID_FUNC cb_function );
/* Show an information dialog with Icon zy Mobile Innovation add
*/
void bookShowInformationWithIcon( MfwHnd parent, int txtId,MfwIcnAttr * icn,char *text, T_VOID_FUNC cb_function,USHORT identify );

/* Add name when the number is already known
*/
void bookAddName(T_MFW_HND win,char* number);

/* Call index
*/
int bookCallIndex(UBYTE index);

/* Convert GSM strings to their alphanumeric equivalent
*/
void bookGsm2Alpha( UBYTE *alpha );

/* Determine type of current phone book, FDN/ADN
*/
UBYTE bookActiveBook( int process );

// Default call backs for name and number entry
void bookAddCB( T_MFW_HND win,USHORT Identifier, UBYTE reason );
void bookGroupingRenameCB( T_MFW_HND win,USHORT Identifier,  UBYTE reason );
void bookOwnNumberEditCB( T_MFW_HND win,USHORT Identifier, UBYTE reason );
void bookSearchCB( T_MFW_HND win,USHORT Identifier, UBYTE reason );


// Memory view
void bookMemoryView( void );

// Delete entry from phone book
void bookDeleteEntry(T_MFW_HND Window);
void bookActivateFDN( T_MFW_HND window );

/*******************************************************************************
                                                                              
                                End of File
                                                                              
*******************************************************************************/

#endif
