/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   PhoneBook
 $File:       MmiBookShared.c
 $Revision:   1.0
 
 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

    Shared definitions of data elements are made in here
    and accessed via the primitive operations supplied

********************************************************************************

 $History: MmiBookShared.c

  25/10/00      Original Condat(UK) BMI version.
  01/08/02   ver0.101   change for add listIcon menu define
  04/08/02   ver0.102   change for settings related menu define
  07/08/02   ver0.103   change for settings related menu define
  08/08      ver0.104   modified
  09/08      ver0.105   modified
  12/08/02   ver0.106   mainmenu and setting menu
  08/14/2002 ver0.107   modified suoha menu
  14/08/02   ver0.108   modified scene mode menu
  15/08/02   ver0.109   modified schedule and autopower menu
  16/08/02   ver0.110   modified
  19/08/02   ver0.111   modified 
  19/08/02   ver0.112   modified 
  20/08/02   ver0.113   modified
  28/08/02              modified
  29/08/02   ver0.114   modified 
 $End

*******************************************************************************/


/*******************************************************************************

                                Include Files

*******************************************************************************/
#ifndef GPRS
#define GPRS
#endif
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "MmiTimers.h"

//


#include "MmiBookShared.h"
#include "MmiBookController.h"
#include "MmiResources.h"

#include "MmiNetwork.h"
#include "MmiSettings.h"
#include "MmiServices.h"
#include "MmiPins.h"
#include "MmiTimeDate.h"
#include "MmiecTimeDate.h"  //include our time and date
#include "mmiSmsBroadcast.h"
#include "mmiSimToolkit.h"
#include "mmiSmsMenu.h"
#include "mmiSmssend.h"
//#include "MmiCalculatorMain.h"
#include "AUIWapext.h"
#include "MmiSounds.h"
#include "MmiLists.h"
#include "MmiTimers.h"
#include "MmiVoiceMemo.h"
#include "MmiIcons.h"
#include "MmiAoc.h"
#ifdef MMI_EM_ENABLED	//Robert.Chen added, 2004-08-02
#include "MmiEm.h" /*SPR1209*/
#endif

//#ifdef MMIGAME
//#include "Mmigame.h"
//#endif
#include "suoha_main.h"
//#include "mmiboxman.h"
#include "mmiboxman.h"
#include "mmiballoon.h"
#include "MmiRussia.h"
#include "MmiCPHS.h"
#include "MmiBand.h"
#ifdef MMI_GPRS_ENABLED
#include "MmiGprs.h"
#endif
#include "MmiBookUtils.h"   //2002.04.19
#include "Mmihost.h"
#include "Mmiautopower.h"
#include "Mmitoolkit_timer.h"
#include "Mmischedule.h"
#include "Mmicalculator.h"
#include "Mmistopwatch.h"
#include "MmiUnitConversion.h"
#include "Mmimemo.h"
#include "Mmishortcutmnu.h"
#include "fieldtest.h"
#include "mmisettings.h"
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
#include "mmiqq.h" 
#endif
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

#ifdef _MMS_ENABLE_
//begin xie
#include "mmiMMSMenu.h"
#include "mmiMMSGlobalDef.h"
#include "mmiMMSNEW.h"
#include "mmiMMSFolders.h"
#include "mmiMMSDeleteAll.h"
#include "mmiMMSSetting.h"
//end xie
#endif

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "mmicamera.h"
#endif

/*talcon add for pcsyn,2004.07.06*/
#ifdef MMI_PCSYN_ENABLED
#include "mmipcsyn.h"
#endif

extern int M_exeSendNew(MfwMnu* m, MfwMnuItem* i); // MZ
//extern int M_exeRead(MfwMnu* m, MfwMnuItem* i);    /*2003/11/28, wangyan delete*/
//extern int M_exeNVMMsg(MfwMnu* m, MfwMnuItem* i);/*2003/11/28, wangyan delete*/
#include "CPHS_mod.h"
extern void soundsSetVolume(void);
extern int SmsSend_R_OPTExeCentreEdit(MfwMnu* m, MfwMnuItem* i);
extern int GetCurrentMemory(MfwMnu* m, MfwMnuItem* i);
extern USHORT SetUserDefinedPic(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//chenjun
/*2003/12/18,talcon add */
extern int  GameSnakeEntry(MfwMnu* m, MfwMnuItem* i);
/*******************************************************************************

                                Static members

*******************************************************************************/

/* Menu areas*/
/* Call list buffer*/

static UBYTE callList[NAME_LIST_SIZE][NAME_SCREEN_MAX];

/* menu buffers*/
static MfwMnuItem menuNamesItems [] =
{
   { 0, 0, 0, (char *) callList[0], 0, 0, item_flag_none },
   { 0, 0, 0, (char *) callList[1], 0, 0, item_flag_none },
    { 0, 0, 0, (char *) callList[2], 0, 0, item_flag_none }/*,
    { 0, 0, 0, (char *) callList[3], 0, 0, item_flag_none }*/

};

static MfwMnuAttr menudetailsList =
{
    0,
    &menuNamesArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE,
    -1,
    menuNamesItems,
    sizeof(menuNamesItems)/sizeof(MfwMnuItem),
    0
    //,
    //(MfwIcnAttr *)&menuup
};

/* Global text message structure*/
static int textMessage;
/******************************************************************************

                                Menu Definitions

*******************************************************************************/

#define DEF_MENU_STYLE          (MNU_LEFT | MNU_LIST | MNU_CUR_LINE)
#define BEGIN_MENU( name ) \
static const MfwMnuItem name##Items [] = {

#define MENU_ITEM( msg, handler, attrFunction ) \
    { 0,0,0, (char *) msg, 0,                       (MenuFunc)handler, attrFunction }

#define MENU_ITEM_SUB_MENU( msg, sub_menu,handler, attrFunction ) \
    { 0,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu,(MenuFunc)handler, attrFunction }


#define SUB_MENU( msg, sub_menu, attrFunction ) \
    { 0,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu, 0,                 attrFunction }

#define END_MENU( name, area ) \
}; \
\
static const MfwMnuAttr name = { \
   0, (MfwRect *) &area, DEF_MENU_STYLE, -1, (MfwMnuItem *) name##Items, sizeof( name##Items ) / sizeof( MfwMnuItem ) \
};

#define DEF_MENU_VIEWLIST_STYLE          (MNU_CENTER| MNU_VIEWLIST | MNU_CUR_LINE)
#define BEGIN_ICON_MENU( name ) \
static const MfwMnuItem name##Items [] = {

#define MENU_ICON_ITEM( icon, msg, handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, 0,                       (MenuFunc)handler, attrFunction }


#define SUB_ICON_MENU( icon,msg, sub_menu, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu, 0,                 attrFunction }

#define END_ICON_MENU( name, area ) \
}; \
\
static const MfwMnuAttr name = { \
    0,(MfwRect *) &area, DEF_MENU_VIEWLIST_STYLE, -1, (MfwMnuItem *) name##Items, sizeof( name##Items ) / sizeof( MfwMnuItem ) \
};
//2004/05/25 yhf add
#define END_TITLEICON_NOTITLE_MENU( name, area, titleicon ) \
}; \
	\
	static const MfwMnuAttr name = { \
    (T_Titleicon) titleicon, (MfwRect *) &area, DEF_MENU_TITLEICON_STYLE|MNU_NOTITLE, -1, (MfwMnuItem *) name##Items, sizeof( name##Items ) / sizeof( MfwMnuItem ) \
};
/***********************zy change define TITLE ICON_MENU**********************************/
#define DEF_MENU_TITLEICON_STYLE          (MNU_LEFT | MNU_OVERLAPPED | MNU_CUR_LINE)
#define BEGIN_TITLEICON_MENU( name ) \
static const MfwMnuItem name##Items [] = {

#define MENU_LISTICON_ITEM( icon, msg, handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, 0,                       (MenuFunc)handler, attrFunction }

#define LISTICON_SUB_MENU_ITEM(icon, msg, sub_menu,handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu,(MenuFunc)handler, attrFunction }//zy add for both submenu and function


#define SUB_LISTICON_MENU( icon,msg, sub_menu, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu, 0,                 attrFunction }


#define END_TITLEICON_MENU( name, area, titleicon ) \
}; \
\
static const MfwMnuAttr name = { \
    (T_Titleicon) titleicon, (MfwRect *) &area, DEF_MENU_TITLEICON_STYLE, -1, (MfwMnuItem *) name##Items, sizeof( name##Items ) / sizeof( MfwMnuItem ) \
};
/***********************zy change define LISTICON_MENU**********************************/
#define DEF_MENU_LISTICON_STYLE          (MNU_LEFT | MNU_OVERLAPPED | MNU_CUR_LINE)
#define BEGIN_LISTICON_MENU( name ) \
static const MfwMnuItem name##Items [] = {

#define MENU_LISTICON_ITEM( icon, msg, handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, 0,                       (MenuFunc)handler, attrFunction }

#define LISTICON_SUB_MENU_ITEM(icon, msg, sub_menu,handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu,(MenuFunc)handler, attrFunction }//zy add for both submenu and function


#define SUB_LISTICON_MENU( icon,msg, sub_menu, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu, 0,                 attrFunction }

#define LISTICON_MENU_ITEM_SUB_MENU(icon, msg, sub_menu,handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu,(MenuFunc)handler, attrFunction }
//zy add 
    
#define END_LISTICON_MENU( name, area ) \
}; \
\
static const MfwMnuAttr name = { \
   0, (MfwRect *) &area, DEF_MENU_LISTICON_STYLE, -1, (MfwMnuItem *) name##Items, sizeof( name##Items ) / sizeof( MfwMnuItem ) \
};

/********************end of zy changed*************************************************/
#define CFFaxDataFlag 1 //hubinhao 2003-2-11 
/*..........................................zy change for pagemenu 04/08/02....................................*/
#define DEF_MENU_PAGED_STYLE          (MNU_LEFT | MNU_PAGED | MNU_CUR_LINE)
#define BEGIN_ICONONE_MENU( name ) \
static const MfwMnuItem name##Items [] = {

#define MENU_ICON_ITEM( icon, msg, handler, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, 0,                       (MenuFunc)handler, attrFunction }


#define SUB_ICON_MENU( icon,msg, sub_menu, attrFunction ) \
    { (MfwIcnAttr *)icon,0,0, (char *) msg, (MfwMnuAttr*) &sub_menu, 0,                 attrFunction }

#define END_ICONONE_MENU( name, area ) \
}; \
\
static const MfwMnuAttr name = { \
  0,  (MfwRect *) &area, DEF_MENU_PAGED_STYLE, -1, (MfwMnuItem *) name##Items, sizeof( name##Items ) / sizeof( MfwMnuItem ) \
};

/* 2004/06 sunsj modify for icon manage */
extern MfwIcnAttr colist[];
extern MfwIcnAttr situationIcon[];
extern MfwIcnAttr situation3Icon[];
extern MfwIcnAttr situation4Icon[];

/*.......................................... end of zy change for pagemenu 04/08/02....................................*/
#ifdef MMI_WAP_ENABLED

/*
 *  WAP menus
 */

// Scale Images sub-menu

BEGIN_MENU( menuScaleImages )
  MENU_LISTICON_ITEM( &situationIcon,TxtOff,        (MenuFunc)AUI_scaleimages_set,  options_check ),
  MENU_LISTICON_ITEM( &situationIcon,TxtOn,       (MenuFunc)AUI_scaleimages_set,  options_check )
/* END_MENU( menuScaleImages, menuListArea, menuup ) */
END_MENU( menuScaleImages, menuListArea )

// Save History sub-menu

BEGIN_MENU( menuSaveHistory )
  MENU_LISTICON_ITEM( &situationIcon,TxtOff,        (MenuFunc)AUI_savehist_set,   options_check ),
  MENU_LISTICON_ITEM( &situationIcon,TxtOn,       (MenuFunc)AUI_savehist_set,   options_check )
 END_MENU( menuSaveHistory, menuListArea )
//END_MENU( menuSaveHistory, menuListArea )

// Access Type sub-menu

BEGIN_MENU( menuAccessType )
  MENU_LISTICON_ITEM(&situationIcon, TxtGPRSData,     (MenuFunc)AUI_access_set, options_check ),
  MENU_LISTICON_ITEM(&situationIcon, TxtCSData,     (MenuFunc)AUI_access_set, options_check ),
  MENU_LISTICON_ITEM(&situationIcon, TxtSMS,        (MenuFunc)AUI_access_set, options_check )
END_MENU( menuAccessType, menuListArea )
//END_MENU( menuAccessType, menuListArea )

// Security sub-menu

BEGIN_MENU( menuSecurityOption )
  MENU_LISTICON_ITEM(&situationIcon, TxtOff,        (MenuFunc)AUI_security_set, options_check ),
  MENU_LISTICON_ITEM(&situationIcon, TxtOn,       (MenuFunc)AUI_security_set, options_check )
END_MENU( menuSecurityOption, menuListArea  )
//END_MENU( menuSecurityOption, menuListArea )

// Connection Type sub-menu

BEGIN_MENU( menuWAPConnectionType )
  MENU_LISTICON_ITEM( &situationIcon,TxtTemporary,    (MenuFunc)AUI_connectionType_set,options_check ),
  MENU_LISTICON_ITEM( &situationIcon,TxtContinuous,   (MenuFunc)AUI_connectionType_set,options_check ),
END_MENU( menuWAPConnectionType, menuListArea )
//END_MENU( menuWAPConnectionType, menuListArea )

// Setup profiles options

BEGIN_MENU( menuSetupProfilesOptions )
  MENU_LISTICON_ITEM( &colist,TxtEditName,     (MenuFunc)AUI_profile_name_edit, item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtHomepage,     (MenuFunc)AUI_homepage_edit, item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtConnectionType, AUI_connectionType,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtSecurity,     AUI_security,       item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtAccessType,   AUI_access,         item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtResponseTimer,  (MenuFunc)AUI_response_timer, item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtIPAddress1,   (MenuFunc)AUI_IPAddress1, item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtIPAddress2,   (MenuFunc)AUI_IPAddress2, item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtPort1,      (MenuFunc)AUI_Port1,    item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtPort2,      (MenuFunc)AUI_Port2,    item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtAPN,        (MenuFunc)AUI_APN,      item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtDialupNumber,   (MenuFunc)AUI_dialupNumber, item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtISPUsername,    (MenuFunc)AUI_username,   item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtISPPassword,    (MenuFunc)AUI_password,   item_flag_none)
END_MENU( menuSetupProfilesOptions, menuListArea )
//END_MENU( menuSetupProfilesOptions, menuListArea )

// Setup sub-menu

BEGIN_MENU( menuWAPSettings )
  MENU_LISTICON_ITEM( &colist,TxtSelectProfile,  (MenuFunc)AUI_profiles_list,    item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtSetupProfiles,  (MenuFunc)AUI_profiles_setup,  item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtSaveHistory,    AUI_savehist,       item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtScaleImages,    AUI_scaleimages,      item_flag_none )
END_MENU( menuWAPSettings, menuListArea )
//END_MENU( menuWAPSettings, menuListArea )

// History Options sub-menu

BEGIN_MENU( menuHistoryOptions )
  MENU_LISTICON_ITEM( &colist,TxtGoTo,       AUI_history_goto,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtEditName,     AUI_history_edit,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtEditURL,      AUI_history_edit_url,   item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtDelete,     AUI_history_delete,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtSend,       AUI_history_sendSMS,    item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtBookmark,     AUI_history_addbook,    item_flag_none )
END_MENU( menuHistoryOptions, menuListArea )
//END_MENU( menuHistoryOptions, menuListArea )

// History sub-menu

BEGIN_MENU( menuHistory )
  MENU_LISTICON_ITEM( &colist,TxtLIST,       AUI_history_list,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtClear,      AUI_history_clear,      item_flag_none )
END_MENU( menuHistory, menuListArea )
//END_MENU( menuHistory, menuListArea )

// GoTo sub-menu

BEGIN_MENU( menuGoTo )
  MENU_LISTICON_ITEM( &colist,TxtWWWdot,     AUI_goto_www,       item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtWAPdot,     AUI_goto_wap,       item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtOther,      AUI_goto_other,       item_flag_none )
END_MENU( menuGoTo, menuListArea )
//END_MENU( menuGoTo, menuListArea )

// Bookmark Options sub-menu

BEGIN_MENU( menuBookmarkOptions )
  MENU_LISTICON_ITEM( &colist,TxtGoTo,       AUI_bookmarks_goto,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtEditName,     AUI_bookmarks_edit,     item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtEditURL,      AUI_bookmarks_edit_url,   item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtDelete,     AUI_bookmarks_delete,   item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtSend,       AUI_bookmarks_sendSMS,    item_flag_none )
END_MENU( menuBookmarkOptions, menuListArea )
//END_MENU( menuBookmarkOptions, menuListArea )

// New Bookmark sub-menu

BEGIN_MENU( menuNewBookmark )
  MENU_LISTICON_ITEM( &colist,TxtWWWdot,     AUI_bookmarks_add_www,    item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtWAPdot,     AUI_bookmarks_add_wap,    item_flag_none ),
  MENU_LISTICON_ITEM( &colist,TxtOther,      AUI_bookmarks_add_other,  item_flag_none )
END_MENU( menuNewBookmark, menuListArea )
//END_MENU( menuNewBookmark, menuListArea )

// Bookmarks sub-menu

BEGIN_MENU( menuBookmarks )
  MENU_LISTICON_ITEM( &colist,TxtLIST,       AUI_bookmarks_list,     item_flag_none ),
  SUB_LISTICON_MENU( &colist,TxtNewBookmark,   menuNewBookmark,      item_flag_none )
END_MENU( menuBookmarks, menuListArea )
//END_MENU( menuBookmarks, menuListArea )

// WAP Menu


BEGIN_TITLEICON_MENU( menuWAP )
  MENU_LISTICON_ITEM( &colist,TxtHomepage,     AUI_homepage,       item_flag_none ),
  SUB_LISTICON_MENU( &colist,TxtBookmarks,     menuBookmarks,        item_flag_none ),
  SUB_LISTICON_MENU(&colist,TxtGoTo,        menuGoTo,         item_flag_none ),
  SUB_LISTICON_MENU( &colist,TxtHistory,     menuHistory,        item_flag_none ),
  SUB_LISTICON_MENU( &colist,TxtSettings,      menuWAPSettings,      item_flag_none )
END_TITLEICON_MENU( menuWAP, menuListArea,wapTitleicon )
//END_TITLEICON_MENU( menuWAP, menuListArea,wapTitleicon )

#endif

BEGIN_LISTICON_MENU( menuCBLanguage )
    MENU_LISTICON_ITEM(&situation3Icon,T_CBLanguageAll ,     SetLangAll,   CBLanguage_check ),  //HostkeySwitchOn
    MENU_LISTICON_ITEM(&situation3Icon,T_CBLanguageNone ,   SetLangNone,   CBLanguage_check ),   //  HostkeySimLock
    MENU_LISTICON_ITEM(&situation3Icon,T_CBGerman ,      SetLangGer,   CBLanguage_check ),    // HostkeyDelPbkall
    MENU_LISTICON_ITEM(&situation3Icon,T_CBEnglish ,     SetLangEng,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBItalian,        SetLangItal,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBFrench ,       SetLangFren,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBSpanish,       SetLangSpan,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBDutch ,        SetLangDutch,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBSwedish ,      SetLangSwed,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBDanish ,       SetLangDanish,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBPortuguese ,   SetLangPort,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBFinnish ,    SetLangFinn,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBNorwegian ,   SetLangNorw,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBGreek ,          SetLangGreek,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBTurkish ,       SetLangTurk,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBHungarian ,     SetLangHung,   CBLanguage_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon,T_CBPolish ,        SetLangPolish,   CBLanguage_check )      //HostkeyMsgbox
END_LISTICON_MENU( menuCBLanguage, menuListArea )
//END_LISTICON_MENU( menuCBLanguage, menuListArea )
/*---------------------------------------------------------------------------*/

#ifdef MMI_EM_ENABLED	//Robert.Chen added, 2004-08-02
/*Engineering mode menus - MC SPR1209*/
#if 0
BEGIN_MENU( menuEngMode )
    MENU_ITEM( TxtMobileInfo,    Mmi_em_display_mobile_info_data,   item_flag_none ),
  	MENU_ITEM( TxtServingCell,   Mmi_em_display_serving_cell_params,    item_flag_none ),
    MENU_ITEM( TxtNeighbourCell,    Mmi_em_display_neighbour_cell_params,    item_flag_none ),
    MENU_ITEM( TxtLocation,    Mmi_em_display_location_params,    item_flag_none ),
    MENU_ITEM( TxtCiphHopDTX,    Mmi_em_display_ciph_hop_DTX_params,    item_flag_none ),
    MENU_ITEM( TxtGPRS,    Mmi_em_display_GPRS_params,    item_flag_none )
END_MENU( menuEngMode, menuListArea, COLOUR_LIST_SUBMENU )
#else
BEGIN_LISTICON_MENU( menuEngMode )
    MENU_LISTICON_ITEM( &colist, TxtMobileInfo,    Mmi_em_display_mobile_info_data,		item_flag_none ),
  	MENU_LISTICON_ITEM( &colist, TxtServingCell,   Mmi_em_display_serving_cell_params,	item_flag_none ),
    MENU_LISTICON_ITEM( &colist, TxtNeighbourCell, Mmi_em_display_neighbour_cell_params,	item_flag_none ),
    MENU_LISTICON_ITEM( &colist, TxtLocation,      Mmi_em_display_location_params,		item_flag_none ),
    MENU_LISTICON_ITEM( &colist, TxtCiphHopDTX,    Mmi_em_display_ciph_hop_DTX_params,	item_flag_none ),
    MENU_LISTICON_ITEM( &colist, TxtGPRS,          Mmi_em_display_GPRS_params,			item_flag_none )
END_LISTICON_MENU( menuEngMode, menuListArea )
#endif

/*MC end*/
#endif



#ifdef EASY_TEXT_ENABLED
//Sub Menu of Easy Text
BEGIN_MENU( menuEasyText )
  MENU_LISTICON_ITEM(&colist,TxtActivate,   Easy_Activate,  item_flag_none ),
  MENU_LISTICON_ITEM(&colist,TxtDeactivate, Easy_DeActivate, item_flag_none)
END_MENU( menuEasyText, menuListArea )
//END_MENU( menuEasyText, menuListArea )
#endif

//Sub-Menu of Volume Settings
BEGIN_MENU( menuSetSmsValidityPeriod )
    MENU_LISTICON_ITEM(&colist, Txt1Hour,  SmsValidityPeriod,    item_flag_none ),
    MENU_LISTICON_ITEM(&colist, Txt12Hours,  SmsValidityPeriod,  item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  Txt24Hours,  SmsValidityPeriod,    item_flag_none ),
    MENU_LISTICON_ITEM(&colist, Txt1Week,  SmsValidityPeriod,  item_flag_none )
END_MENU( menuSetSmsValidityPeriod, menuListArea )
//END_MENU( menuSetSmsValidityPeriod, menuListArea )

// Sub-Menu of Message Settings
BEGIN_MENU( menuSetMsg )
#ifndef EASY_TEXT_ENABLED
    MENU_LISTICON_ITEM(&colist,  TxtServiceCentre,  SmsSend_R_OPTExeCentreEdit,     item_flag_none ),
    //SUB_LISTICON_MENU( &colist,TxtValidity,      menuSetSmsValidityPeriod,     item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtMemory,         GetCurrentMemory,     item_flag_none ),
	/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    MENU_LISTICON_ITEM( situation4Icon,TxtSRR,      SmsStatusReportRequest,     SRRONOFF_check ) // Marcus: Issue 1170: 30/09/2002
//    MENU_ITEM( TxtMessageTyp,   bookMenuNotImplemented,     item_flag_none )
#else
    MENU_LISTICON_ITEM(&colist, TxtServiceCentre,  SmsSend_R_OPTExeCentreEdit,     item_flag_none ),
    //SUB_LISTICON_MENU( &colist,TxtValidity,      menuSetSmsValidityPeriod,     item_flag_none ),
    SUB_LISTICON_MENU( &colist,TxtEasyText,      menuEasyText,       item_flag_none),
//    MENU_ITEM( TxtMessageTyp,   bookMenuNotImplemented,     item_flag_none )
#endif
END_MENU( menuSetMsg, menuListArea )
//END_MENU( menuSetMsg, menuListArea )
// Sub-Menu of CB mid set
BEGIN_MENU( menuCBMID )
    MENU_LISTICON_ITEM(&colist, TxtAdd,smscb_CB_EDT_ExeAdd,item_flag_none),
    MENU_LISTICON_ITEM(&colist, TxtModify,smscb_CB_EDT_ExeModify,item_flag_none),
    MENU_LISTICON_ITEM(&colist, TxtDelete,smscb_M_CB_MID_DEL,item_flag_none)
    //MENU_LISTICON_ITEM(&colist,  TxtServiceCentre,  SmsSend_R_OPTExeCentreEdit,     item_flag_none ),
    //MENU_LISTICON_ITEM(&colist, TxtMemory,         GetCurrentMemory,     item_flag_none ),
END_MENU( menuCBMID, menuListArea )
//END_MENU( menuCBMID, menuListArea )

 //Sub-Menu of Broadcast Messages,С㲥
BEGIN_LISTICON_MENU( menuBroadMsg )
/*2003/11/05,talcon change "&situation3Icon" to  "situation4Icon" */
    MENU_LISTICON_ITEM( situation4Icon,TxtOnOff,   smscb_M_CB_ACT_ExeOnOff,  CBONOFF_check ),
    // MENU_LISTICON_ITEM( &outIcon,TxtRead,       sms_cb_select_read,         item_flag_none ),
    //MENU_LISTICON_ITEM( &outIcon, TxtNewBroadcast,smscb_M_CB_MID,   item_flag_none ),
    SUB_LISTICON_MENU(&colist,TxtCBCHSET,   menuCBMID,  item_flag_none ),
    SUB_LISTICON_MENU( &colist, T_CBLanguage,  menuCBLanguage,        item_flag_none )
END_LISTICON_MENU( menuBroadMsg, menuListArea )
//END_LISTICON_MENU( menuBroadMsg, menuListArea )

// Sub-Menu of VoiceMail
BEGIN_MENU( menuVoiceMsg )
    MENU_LISTICON_ITEM(&colist, TxtVoicemail,  M_callVoice,           item_flag_none ),
    //windyMENU_ITEM( TxtVoicemail,  menu_cphs_call_mailbox_number,           item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtSetVoiceMail, M_exeVoice,           item_flag_none ),
    //windyMENU_ITEM( TxtSetVoiceMail, menu_cphs_edit_mailbox_number,     item_flag_none/*CphsMailboxPresent*/ )
END_MENU( menuVoiceMsg, menuListArea  )
//END_MENU( menuVoiceMsg, menuListArea )

//
// Menu of received Messages added by windy
BEGIN_MENU( menuReadMsg)
    MENU_LISTICON_ITEM(&colist,  TxtReadMt,  SmsRead_R_KINDExeIncoming,     item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtReadMo,  SmsRead_R_KINDExeOutgoing,     item_flag_none)
END_MENU(  menuReadMsg, menuListArea )

// Menu of delete all Messages added by windy
BEGIN_MENU( menuDelAll)
    MENU_LISTICON_ITEM(&colist,  TxtSIMSms,  M_exeDelAll,     item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtNVMMsg,  M_exeDelNVMAll,     item_flag_none)
END_MENU(  menuDelAll, menuListArea )
//END_MENU(  menuDelAll, menuListArea )
BEGIN_MENU( menuNVMMsg)
    MENU_LISTICON_ITEM(&colist,  TxtNVMInbox,  SmsRead_R_NVMExeIncoming,     item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtNVMOutbox,  SmsRead_R_NVMExeOutgoing,     item_flag_none)
END_MENU(  menuNVMMsg, menuListArea )
//END_MENU(  menuNVMMsg, menuListArea )

//hxl add for QQ 2002-12-16------------------------------------
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
BEGIN_MENU( menuQQNetListSel )
    MENU_LISTICON_ITEM( &colist,TxtSendSms,     SendQQ_Start,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQAddToNvm,  ADD_TO_NVMFri,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQDatas,      See_QQ_Datas,     In_QQ_Menu )
END_MENU( menuQQNetListSel, menuListArea )
//END_MENU( menuQQNetListSel, menuListArea )

BEGIN_MENU( menuQQFindSel )
    MENU_LISTICON_ITEM( &colist,TxtSendSms,     SendQQ_Start,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQAddToNvm,  ADD_TO_NVMFri,     In_QQ_Menu )
END_MENU( menuQQFindSel, menuListArea )
//END_MENU( menuQQFindSel, menuListArea )

BEGIN_MENU( menuQQNVMListSel )
    MENU_LISTICON_ITEM( &colist,TxtSendSms,     SendQQ_Start,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQDatas,      See_QQ_Datas,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtDelete,      Del_QQ_Fri,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtDeleteAll,      Del_ALL_QQ_Fri,     In_QQ_Menu )
END_MENU( menuQQNVMListSel, menuListArea )
//END_MENU( menuQQNVMListSel, menuListArea )

BEGIN_MENU( menuQQChat )
    MENU_LISTICON_ITEM( &colist,TxtQQNVMFriend,	Get_NVM_Friend,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQNetFriend,	Get_NET_Friend,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQAddNew,	Add_New_friend,     In_QQ_Menu )
END_MENU( menuQQChat, menuListArea )
//END_MENU( menuQQChat, menuListArea )


BEGIN_MENU( menuQQSysBoxListSel )
    MENU_LISTICON_ITEM( &colist,TxtDelete,      Del_QQ_Sms,     In_SpeQQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtDeleteAll,      Del_ALL_QQ_Sms,     In_SpeQQ_Menu )
END_MENU( menuQQSysBoxListSel, menuListArea )
//END_MENU( menuQQSysBoxListSel, menuListArea )

BEGIN_MENU( menuQQBoxListSel )
    MENU_LISTICON_ITEM( &colist,TxtDelete,      Del_QQ_Sms,     In_SpeQQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtReply,     Reply_QQ_Start,     In_SpeQQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtForward,      Forward_QQ_Start,     In_SpeQQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtDeleteAll,      Del_ALL_QQ_Sms,     In_SpeQQ_Menu )
END_MENU( menuQQBoxListSel, menuListArea )
//END_MENU( menuQQBoxListSel, menuListArea )

BEGIN_MENU( menuQQDelAll )
    MENU_LISTICON_ITEM( &colist,TxtQQSysInfo,      Del_ALL_SysQQ,     In_SpeQQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQChatInfo,      Del_ALL_ChatQQ,     In_SpeQQ_Menu )
END_MENU( menuQQDelAll, menuListArea )
//END_MENU( menuQQDelAll, menuListArea )

BEGIN_MENU( menuQQBox )
    MENU_LISTICON_ITEM( &colist,TxtQQSysInfo,      Get_System_info,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQChatInfo,      Get_chat_info,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQLeftInfo,      Get_left_info,     In_QQ_Menu ),
    SUB_LISTICON_MENU( &colist,TxtDeleteAll,	menuQQDelAll,     In_QQ_Menu ),
END_MENU( menuQQBox, menuListArea )
//END_MENU( menuQQBox, menuListArea )

BEGIN_MENU( menuQQFindNew )
    MENU_LISTICON_ITEM( &colist,TxtQQFindRandom,      FindQQ_Random,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQFindByQQ,      FindQQ_ByQQ,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQFindByNick,      FindQQ_ByNick,     In_QQ_Menu )
END_MENU( menuQQFindNew, menuListArea )
//END_MENU( menuQQFindNew, menuListArea )

BEGIN_MENU( menuQQSetService )
    MENU_LISTICON_ITEM( &colist, TxtOpenService,     setQQServiceOn,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist, TxtCancelService,   setQQServiceOff,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist, TxtStopService,     setQQRecieveOff,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist, TxtResumeService,   setQQRecieveOn,     In_QQ_Menu )
END_MENU( menuQQSetService, menuListArea )
//END_MENU( menuQQSetService, menuListArea )

BEGIN_MENU( menuQQSetBind )
    MENU_LISTICON_ITEM( &colist,TxtBindQQ,      Set_QQ_Bind,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist, TxtCancelBind,	Cancel_QQ_Bind,     In_QQ_Menu )
END_MENU( menuQQSetBind, menuListArea )
//END_MENU( menuQQSetBind, menuListArea )

BEGIN_MENU( menuQQSet )
    SUB_LISTICON_MENU( &colist,TxtQQSetSevice,	menuQQSetService,     In_QQ_Menu ),
    SUB_LISTICON_MENU( &colist,TxtQQSetBind,	menuQQSetBind,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtQQAskNum,	Ask_QQ_number,     In_QQ_Menu )
END_MENU( menuQQSet, menuListArea )
//END_MENU( menuQQSet, menuListArea )

BEGIN_MENU( menuQQ )
    SUB_LISTICON_MENU( &colist,TxtQQChat,	menuQQChat,     In_QQ_Menu ),
    SUB_LISTICON_MENU( &colist,TxtQQBox,	menuQQBox,     In_QQ_Menu ),
    SUB_LISTICON_MENU( &colist,TxtQQFindNew,	menuQQFindNew,     In_QQ_Menu ),
    SUB_LISTICON_MENU( &colist,TxtQQSet,	menuQQSet,     In_QQ_Menu ),
    MENU_LISTICON_ITEM( &colist,TxtHelp,	Show_QQ_help,     In_QQ_Menu )
END_MENU( menuQQ, menuListArea )
//END_MENU( menuQQ, menuListArea )
#endif
//end of hxl add for QQ 2002-12-16------------------------------
// Menu of Messages
/*BEGIN_TITLEICON_MENU( menuMsg )
    SUB_LISTICON_MENU( &colist,TxtReadSms,      menuReadMsg,         item_flag_none ),
#ifdef EASY_TEXT_ENABLED
    MENU_LISTICON_ITEM(&colist,TxtSendSms,    showeZiTextIcon,       item_flag_none ),
#else
    MENU_LISTICON_ITEM( &colist,TxtSendSms,    M_exeSendNew,      item_flag_none ),
#endif
#ifdef 	QQFUNC//hxl add for qq func switch,2003-3-24
    SUB_LISTICON_MENU ( &QQlist,TxtQQ,   menuQQ,        get_current_service ),//hxl add for QQ 2002-12-16
#endif
    SUB_LISTICON_MENU( &colist,TxtNVMMsg,      menuNVMMsg,         item_flag_none ),
    //MENU_LISTICON_ITEM( &colist,TxtNVMMsg,    	M_exeNVMMsg,      item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtCommonMsg,  smscb_M_common_msg,  item_flag_none ),
    SUB_LISTICON_MENU( &colist,TxtDeleteAll,    menuDelAll,  item_flag_none ),
    SUB_LISTICON_MENU ( &colist,TxtBroadcast,    menuBroadMsg,      item_flag_none ),
    //MENU_ITEM ( TxtBroadcast,    cellbroadcast_start,      item_flag_none ),
    SUB_LISTICON_MENU ( &colist,TxtVoicemail,    menuVoiceMsg,        item_flag_none ),
    SUB_LISTICON_MENU ( &colist,TxtSMSSettings,   menuSetMsg,        item_flag_none )
END_TITLEICON_MENU( menuMsg, menuListArea,smsTitleicon )*/
//modify by wangyan 03-09-17

/* robert.chen add, 2004-08-10, for MMS integration */
#ifdef _MMS_ENABLE_
//begin xie
BEGIN_LISTICON_MENU( menuMMSFolderOptMedia )
MENU_LISTICON_ITEM( &colist, TxtMMSPicture,   MMS_Folder_PictureList,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSMusic,  MMS_Folder_MusicList,  item_flag_none ) 
END_LISTICON_MENU( menuMMSFolderOptMedia, menuListArea )

BEGIN_LISTICON_MENU( menuMMSRecvFolderOption)
MENU_LISTICON_ITEM( &colist, TxtMMSReply,   MMS_Folder_Opt_Reply,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSFarward,  MMS_Folder_Opt_Farward,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSDelete,   MMS_Folder_Opt_Delete,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSReplay,  MMS_Folder_Opt_Replay,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSCallback,   MMS_Folder_Opt_Callback,  item_flag_none),       
 SUB_LISTICON_MENU( &colist, TxtMMSCutMedia ,   menuMMSFolderOptMedia,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSCutAddress,   MMS_Folder_Opt_CutAddress,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSDetails,  MMS_Folder_Opt_Details,  item_flag_none), 
//MENU_LISTICON_ITEM( &colist, TxtMMSMoveToSentFolder,   MMS_Folder_Opt_MoveToSentFolder,  item_flag_none)     
END_LISTICON_MENU( menuMMSRecvFolderOption, menuListArea )

BEGIN_LISTICON_MENU( menuMMSNotifyOption)      
MENU_LISTICON_ITEM( &colist, TxtMMSRetrieve,  MMS_Folder_Opt_Retrieve,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSDelete,   MMS_Folder_Opt_Delete,  item_flag_none),       
END_LISTICON_MENU( menuMMSNotifyOption, menuListArea )


BEGIN_LISTICON_MENU( menuMMSSendFolderOption )
MENU_LISTICON_ITEM( &colist, TxtMMSSend,  MMS_Folder_Opt_Send,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSDelete,   MMS_Folder_Opt_Delete,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSReplay,  MMS_Folder_Opt_Replay,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSDetails,  MMS_Folder_Opt_Details,  item_flag_none), 
//MENU_LISTICON_ITEM( &colist, TxtMMSMoveToSentFolder,   MMS_Folder_Opt_MoveToSentFolder,  item_flag_none)     
END_LISTICON_MENU( menuMMSSendFolderOption, menuListArea )

BEGIN_LISTICON_MENU( menuMMSDraftFolderOption )
SUB_LISTICON_MENU( &colist, TxtMMSCutMedia ,   menuMMSFolderOptMedia,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSSend,  MMS_Folder_Opt_Send,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSDelete,   MMS_Folder_Opt_Delete,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSReplay,  MMS_Folder_Opt_Replay,  item_flag_none ), 
MENU_LISTICON_ITEM( &colist, TxtMMSDetails,  MMS_Folder_Opt_Details,  item_flag_none),
//MENU_LISTICON_ITEM( &colist, TxtMMSMoveToSentFolder,   MMS_Folder_Opt_MoveToSentFolder,  item_flag_none)     
END_LISTICON_MENU( menuMMSDraftFolderOption, menuListArea )

BEGIN_LISTICON_MENU( menuMMSSentFolderOption )
//MENU_LISTICON_ITEM( &colist, TxtMMSReply,   MMS_Folder_Opt_Reply,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSFarward,  MMS_Folder_Opt_Farward,  item_flag_none ),  
MENU_LISTICON_ITEM( &colist, TxtMMSDelete,   MMS_Folder_Opt_Delete,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSReplay,  MMS_Folder_Opt_Replay,  item_flag_none ), 
//SUB_LISTICON_MENU( &colist, TxtMMSCutMedia ,   menuMMSFolderOptMedia,  item_flag_none ), 
//MENU_LISTICON_ITEM( &colist, TxtMMSCutAddress,   MMS_Folder_Opt_CutAddress,  item_flag_none),       
MENU_LISTICON_ITEM( &colist, TxtMMSDetails,  MMS_Folder_Opt_Details,  item_flag_none)
END_LISTICON_MENU( menuMMSSentFolderOption, menuListArea )

BEGIN_LISTICON_MENU( menuMMSSendReport )
MENU_LISTICON_ITEM( &situationIcon, TxtMMSSendReportOn,   MMS_Setting_SendReport_On,  MMS_Setting_flagFunc),       
MENU_LISTICON_ITEM( &situationIcon, TxtMMSSendReportOff,  MMS_Setting_SendReport_Off,  MMS_Setting_flagFunc ) 
END_LISTICON_MENU( menuMMSSendReport, menuListArea )

BEGIN_LISTICON_MENU( menuMMSAutoSave )
MENU_LISTICON_ITEM( &situationIcon, TxtMMSAutoSaveOn,   MMS_Setting_AutoSave_On,  MMS_Setting_flagFunc ),       
MENU_LISTICON_ITEM( &situationIcon, TxtMMSAutoSaveOff,  MMS_Setting_AutoSave_Off,  MMS_Setting_flagFunc ) 
END_LISTICON_MENU( menuMMSAutoSave, menuListArea )

BEGIN_LISTICON_MENU( menuMMSAutoRecv )
MENU_LISTICON_ITEM( &situationIcon, TxtMMSAutoRecvOn,   MMS_Setting_AutoRecv_On,  MMS_Setting_flagFunc ),       
MENU_LISTICON_ITEM( &situationIcon, TxtMMSAutoRecvOff,  MMS_Setting_AutoRecv_Off,  MMS_Setting_flagFunc ) 
END_LISTICON_MENU( menuMMSAutoRecv, menuListArea )

BEGIN_LISTICON_MENU(menuMMSSendSettings)
SUB_LISTICON_MENU( &colist,TxtMMSSendReport,    menuMMSSendReport,      item_flag_none )
END_LISTICON_MENU(menuMMSSendSettings,menuListArea)

BEGIN_LISTICON_MENU(menuMMSRecvSettings)
SUB_LISTICON_MENU( &colist,TxtMMSAutoSave,    menuMMSAutoSave,      item_flag_none ),
SUB_LISTICON_MENU( &colist,TxtMMSAutoRecv,    menuMMSAutoRecv,      item_flag_none )
END_LISTICON_MENU(menuMMSRecvSettings,menuListArea)

BEGIN_LISTICON_MENU(menuMMSGSMGateway)
MENU_LISTICON_ITEM( &colist, TxtMMSIPAddress,  MMS_Setting_GSM_IPAddress,   item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtMMSIPPort,     MMS_Setting_GSM_IPPort,      item_flag_none )
END_LISTICON_MENU(menuMMSGSMGateway,menuListArea)

#if 0 //deleted by xie 04-07-14
BEGIN_LISTICON_MENU(menuMMSDataCallType)
MENU_LISTICON_ITEM( &situationIcon, TxtMMSISDN,  MMS_Setting_GSM_ISDN,   MMS_Setting_flagFunc ),
MENU_LISTICON_ITEM( &situationIcon, TxtMMSAnologue,     MMS_Setting_GSM_Anologue,  MMS_Setting_flagFunc )
END_LISTICON_MENU(menuMMSDataCallType,menuListArea)
#endif

BEGIN_LISTICON_MENU(menuMMSGSMSettings)
SUB_LISTICON_MENU( &colist,TxtMMSGateway,    menuMMSGSMGateway,      item_flag_none ),
//SUB_LISTICON_MENU( &colist,TxtMMSDataCallType,   menuMMSDataCallType,      item_flag_none ), //deleted by xie 04-07-14
MENU_LISTICON_ITEM( &colist,TxtMMSDiaNumber,    MMS_Setting_GSM_Dial_Number,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSLoginID,    MMS_Setting_GSM_Login_ID,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSPassword,   MMS_Setting_GSM_Password,      item_flag_none )
END_LISTICON_MENU(menuMMSGSMSettings,menuListArea)

BEGIN_LISTICON_MENU(menuMMSGPRSGateway)
MENU_LISTICON_ITEM( &colist, TxtMMSIPAddress, MMS_Setting_GPRS_IPAddress,   item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSIPPort,     MMS_Setting_GPRS_IPPort,      item_flag_none )
END_LISTICON_MENU(menuMMSGPRSGateway,menuListArea)

BEGIN_LISTICON_MENU(menuMMSGPRSSettings)
SUB_LISTICON_MENU( &colist, TxtMMSGateway,  menuMMSGPRSGateway,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSAPN,          MMS_Setting_GPRS_APN,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSLoginID,         MMS_Setting_GPRS_Login_ID,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSPassword,     MMS_Setting_GPRS_Password,      item_flag_none )
END_LISTICON_MENU(menuMMSGPRSSettings,menuListArea)

BEGIN_LISTICON_MENU(menuMMSTransportMode)
MENU_LISTICON_ITEM( &situationIcon,TxtMMSOnlyGPRS,   MMS_Setting_Only_GPRS,     MMS_Setting_flagFunc ),
MENU_LISTICON_ITEM( &situationIcon,TxtMMSOnlyGSM,    MMS_Setting_Only_GSM,      MMS_Setting_flagFunc )
END_LISTICON_MENU(menuMMSTransportMode,menuListArea)

BEGIN_LISTICON_MENU(menuMMSNetSeettings)
MENU_LISTICON_ITEM(&colist, TxtMMSMMSCURL,       MMS_Setting_MMSCURL,  item_flag_none ),       
SUB_LISTICON_MENU( &colist, TxtMMSGSMSettings,     menuMMSGSMSettings,     item_flag_none ),
SUB_LISTICON_MENU( &colist, TxtMMSGPRSSettings,    menuMMSGPRSSettings,    item_flag_none ),       
SUB_LISTICON_MENU( &colist, TxtMMSTransportMode,   menuMMSTransportMode,   item_flag_none ),
END_LISTICON_MENU(menuMMSNetSeettings,menuListArea)

BEGIN_LISTICON_MENU(menuMMSAllSettings)
MENU_LISTICON_ITEM( &colist,TxtMMSEditGroupName,     MMS_Setting_Group_Name,      item_flag_none ),
SUB_LISTICON_MENU( &colist,TxtMMSSendSettings,    menuMMSSendSettings,      item_flag_none ),
SUB_LISTICON_MENU( &colist,TxtMMSRecvSettings,    menuMMSRecvSettings,      item_flag_none ),
SUB_LISTICON_MENU( &colist,TxtMMSNetSettings,    menuMMSNetSeettings,      item_flag_none )
END_LISTICON_MENU(menuMMSAllSettings,menuListArea)

BEGIN_LISTICON_MENU(menuMMSSettings)
MENU_LISTICON_ITEM( &colist,TxtMMSCurSettings,    MMS_Cur_Settings_List,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSAllSettings,    MMS_All_Settings_List,      item_flag_none )
END_LISTICON_MENU(menuMMSSettings,menuListArea)

BEGIN_LISTICON_MENU( menuDeleteAll )
MENU_LISTICON_ITEM( &situation3Icon, TxtMMSDelAll,          MMS_Del_All_OnOff,          MMS_Del_flagFunc ),       
MENU_LISTICON_ITEM( &situation3Icon, TxtMMSDelSendFolder,   MMS_Del_SendFolder_OnOff,   MMS_Del_flagFunc ), 
MENU_LISTICON_ITEM( &situation3Icon, TxtMMSDelRecvFolder,   MMS_Del_RecvFolder_OnOff,   MMS_Del_flagFunc ),       
MENU_LISTICON_ITEM( &situation3Icon, TxtMMSDelDraftFolder,  MMS_Del_DraftFolder_OnOff,  MMS_Del_flagFunc ),
MENU_LISTICON_ITEM( &situation3Icon, TxtMMSDelSentFolder,   MMS_Del_SentFolder_OnOff,   MMS_Del_flagFunc )
END_LISTICON_MENU( menuDeleteAll, menuListArea )

BEGIN_TITLEICON_MENU(menuMMS)
MENU_LISTICON_ITEM(&colist,  TxtMMSNew,         MMS_Menu_New,     item_flag_none ),
MENU_LISTICON_ITEM(&colist,TxtMMSRecvFolder,   MMS_Menu_Recv_Folder,      item_flag_none ),
MENU_LISTICON_ITEM( &colist,  TxtMMSSendFolder,  MMS_Menu_Send_Folder,     item_flag_none),
MENU_LISTICON_ITEM( &colist,TxtMMSDraftFolder,   MMS_Menu_Draft_Folder,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSSentFolder,   MMS_Menu_Sent_Folder,  item_flag_none ),
//SUB_LISTICON_MENU( &colist,TxtMMSDeleteAll,     menuDeleteAll,  item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtMMSDeleteAll,     MMS_Menu_Delete_All,  item_flag_none ),

MENU_LISTICON_ITEM ( &colist,TxtMMSSettings,   MMS_SettingsMenu,        item_flag_none )
END_TITLEICON_MENU( menuMMS, menuListArea,smsTitleicon )

MfwMnuAttr *MMSRetrieveMsgOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMMSNotifyOption;
}

MfwMnuAttr *MMSRecvFolderOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMMSRecvFolderOption;
}

MfwMnuAttr *MMSSendFolderOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMMSSendFolderOption;
}

MfwMnuAttr *MMSDraftFolderOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMMSDraftFolderOption;
}

MfwMnuAttr *MMSSentFolderOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMMSSentFolderOption;
}


MfwMnuAttr *MMSDeleteAllOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuDeleteAll;
}

MfwMnuAttr *MMSMainMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMMS;
}

MfwMnuAttr * MMSSettingsMenuAttributes(void)
{
    return (MfwMnuAttr *) &menuMMSSettings;
}

MfwMnuAttr * MMSAllSettingsMenuAttributes(void)
{
    return (MfwMnuAttr *) &menuMMSAllSettings;
}
//end xie
#endif	/* _MMS_ENABLE_ */
BEGIN_TITLEICON_MENU( menuMsg )
    #ifdef _MMS_ENABLE_
    //begin xie
//  SUB_LISTICON_MENU (&colist,TxtMMS,   menuMMS,   MMS_Entry_MMSMenu),
    MENU_LISTICON_ITEM( &colist,TxtMMS,    MMS_MainMenu,      item_flag_none ),
    //end xie
    #endif

#ifdef EASY_TEXT_ENABLED
    MENU_LISTICON_ITEM(&colist,TxtSendSms,    showeZiTextIcon,       item_flag_none ),
#else
    MENU_LISTICON_ITEM( &colist,TxtSendSms,    M_exeSendNew,      item_flag_none ),	//дϢ
#endif
    MENU_LISTICON_ITEM(&colist,  TxtReadMt,  SmsRead_R_KINDExeIncoming,     item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtReadMo,  SmsRead_R_KINDExeOutgoing,     item_flag_none),
#ifdef 	QQFUNC//hxl add for qq func switch,2003-3-24
    SUB_LISTICON_MENU ( &QQlist,TxtQQ,   menuQQ,        get_current_service ),//hxl add for QQ 2002-12-16
#endif
    SUB_LISTICON_MENU( &colist,TxtNVMMsg,      menuNVMMsg,         item_flag_none ),
    //MENU_LISTICON_ITEM( &colist,TxtNVMMsg,    	M_exeNVMMsg,      item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtCommonMsg,  smscb_M_common_msg,  item_flag_none ),//Ϣ
    SUB_LISTICON_MENU( &colist,TxtDeleteAll,    menuDelAll,  item_flag_none ),
    SUB_LISTICON_MENU ( &colist,TxtBroadcast,    menuBroadMsg,      item_flag_none ),
    //MENU_ITEM ( TxtBroadcast,    cellbroadcast_start,      item_flag_none ),
//    SUB_LISTICON_MENU ( &colist,TxtVoicemail,    menuVoiceMsg,        item_flag_none ),
    SUB_LISTICON_MENU ( &colist,TxtSMSSettings,   menuSetMsg,        item_flag_none )
END_TITLEICON_MENU( menuMsg, menuListArea,smsTitleicon )
//END_TITLEICON_MENU( menuMsg, menuListArea,smsTitleicon )
//modify by wangyan 03-09-17

/*---------------------------------------------------------------------------*/
/* Phone book menus*/
// Sub-Menu of
BEGIN_MENU( menuRepRedOptions )//ͨѡ˵
    MENU_ITEM( TxtStoreNumber, bookRepRedNameEnter, item_flag_none ),
    MENU_ITEM( TxtSendMessage, bookSendMessage,     item_flag_none ),
    MENU_ITEM( TxtDetails,     bookCallListDetails,      item_flag_none ),
    MENU_ITEM( TxtDelete,      bookRepRedDelete,     item_flag_none ),
    MENU_ITEM( TxtDeleteAll,   bookDeleteAll,          item_flag_none ),
END_MENU( menuRepRedOptions, menuListArea )
//END_MENU( menuRepRedOptions, menuListArea )

BEGIN_MENU ( bookNvmNameEnter )
    MENU_LISTICON_ITEM( &colist,	TxtEnterNumber, bookNumberEnter,	item_flag_none),//ֻ
    MENU_LISTICON_ITEM( &colist,	TxtEnterHome,   bookHomeEnter,		item_flag_none),//סլ绰
    MENU_LISTICON_ITEM( &colist,	TxtEnterOffice,	bookOfficeEnter,	item_flag_none),//칫绰
END_MENU( bookNvmNameEnter,menuListArea )
//END_MENU( bookNvmNameEnter,menuListArea)

/* 2003/12/01 sunsj remove submenu about nvm book enter */
BEGIN_MENU ( bookNameAdd )//绰(SIMNVM)
    MENU_LISTICON_ITEM( &colist, TxtSIMBook,	bookNameEnter,		item_flag_none),//SIM绰
    //SUB_LISTICON_MENU ( &colist, TxtNVMBook,	bookNvmNameEnter,	item_flag_none),//ֻ绰
    MENU_LISTICON_ITEM( &colist, TxtNVMBook,    bookNvmNumberEnter,	item_flag_none),
END_MENU ( bookNameAdd,menuListArea )
//END_MENU ( bookNameAdd,menuListArea )

BEGIN_MENU( bookCopyAll )
    MENU_LISTICON_ITEM( &colist,TxtCopySIMtoNVM, bookCopyAllSIMToNVM,  item_flag_none),//SIMֻ
    MENU_LISTICON_ITEM(&colist, TxtCopyNVMtoSIM, bookCopyAllNVMToSIM,  item_flag_none),//ֻSIM
END_MENU ( bookCopyAll,menuListArea )

BEGIN_MENU ( bookChoiceCopy )
    MENU_LISTICON_ITEM(&colist, TxtCopySIMtoNVM, bookChoiceCopySIMToNVM,  item_flag_none),//SIMֻ
    MENU_LISTICON_ITEM(&colist, TxtCopyNVMtoSIM, bookChoiceCopyNVMToSIM,  item_flag_none),//ֻSIM
END_MENU( bookChoiceCopy, menuListArea )
    
BEGIN_MENU( bookMultiCopy )//绰(SIMNVM)    
    SUB_LISTICON_MENU(&colist, TxtCopyAll,    bookCopyAll,		item_flag_none),//ȫ
    SUB_LISTICON_MENU(&colist, TxtChoiceCopy, bookChoiceCopy,	item_flag_none),//ѡ
END_MENU( bookMultiCopy,menuListArea )

BEGIN_MENU( bookClearAll )
    MENU_LISTICON_ITEM(&colist, TxtSIMBook, bookSimDeleteAll,  item_flag_none), //SIM绰
    MENU_LISTICON_ITEM(&colist, TxtNVMBook, bookNvmDeleteAll,  item_flag_none),	//ֻ绰
END_MENU( bookClearAll,menuListArea )
    
// Menu of Phonebook
BEGIN_MENU( menuPhbk )
    MENU_LISTICON_ITEM( &colist,	TxtPhoneSearch,     bookNameSearch,		item_flag_none),//ѯ
    SUB_LISTICON_MENU ( &colist,	TxtPhoneAdd,        bookNameAdd,		item_flag_none),//
    MENU_LISTICON_ITEM( &colist,	TxtGroupingSetting, bookGroupingSetting,item_flag_none),//
    SUB_LISTICON_MENU ( &colist,	TxtMultiCopy,       bookMultiCopy,      item_flag_none),//
    SUB_LISTICON_MENU ( &colist,	TxtClearAll,        bookClearAll,       item_flag_none),//ȫɾ
    MENU_LISTICON_ITEM( &colist,	TxtShortCutDial,    bookShortCutDial,   item_flag_none),//ݲ
    MENU_LISTICON_ITEM( &colist,	TxtMyNumber,		bookOwnNumber,		item_flag_none),//
    MENU_LISTICON_ITEM( &colist,	TxtMemory,			bookMemoryStatus,   item_flag_none),//ڴ      
    //MENU_LISTICON_ITEM( &colist,	TxtVoiceList,       bookVoiceList,      item_flag_none),//б	/* 2004/04/10 sunsj remove */
END_MENU( menuPhbk, menuListArea )

//begin xzy add 2002/10/24 for phone book grouping icon
/*
BEGIN_LISTICON_MENU(GroupingIcon)
	MENU_LISTICON_ITEM(&BookGroupingIcon[0], TxtGroupingClassmate, SetIconClassmate, item_flag_none),
	MENU_LISTICON_ITEM(&BookGroupingIcon[1], TxtGroupingFriend, SetIconFriend, item_flag_none ),
	MENU_LISTICON_ITEM(&BookGroupingIcon[2], TxtGroupingFamily, SetIconFamily, item_flag_none ),
	MENU_LISTICON_ITEM(&BookGroupingIcon[3], TxtGroupingWorkmate, SetIconWorkmate, item_flag_none)
END_LISTICON_MENU(GroupingIcon, menuListArea )
//end xzy add 2002/10/24 for phone book grouping icon
//begin xzy append 2002/11/25
//end xzy append 2002/11/25
*/
/*
BEGIN_MENU(menuGrouping)
    MENU_ITEM(TxtBrowserMember, bookGroupingShow, item_flag_none),
    MENU_ITEM(TxtAddMember,    bookGroupingAdd, item_flag_none),
    MENU_ITEM(TxtGroupingRing,   soundsRinger, soundReasonPhbk),
    MENU_ITEM(TxtGroupingIcon,  SetGroupingIcon,  item_flag_none ),		//fix by xzy 2002/10/24 for book grouping icon
    MENU_ITEM(TxtGroupingRename, bookGroupingRename, item_flag_none),
END_MENU( menuGrouping, menuListArea )
*/

//2004.3.18 WYJ add
BEGIN_MENU(menuGroupRing)
	MENU_LISTICON_ITEM( &situationIcon, TxtGroupSelect, groupSelect ,  group_check ),
    MENU_LISTICON_ITEM( &situationIcon, TxtGroupMute,   SetGroupMute,  group_check ), 
END_MENU(menuGroupRing, menuListArea)
// end of 2004.3.18 WYJ add

BEGIN_MENU(menuGrouping)
    MENU_LISTICON_ITEM(&colist,TxtBrowserMember,	bookGroupingShow,	item_flag_none),//Աб
    MENU_LISTICON_ITEM(&colist,TxtAddMember,		bookGroupingAdd,	item_flag_none),
	//2004.3.18 WYJ 
	SUB_LISTICON_MENU(&colist,TxtGroupingRing,		menuGroupRing,		soundReasonPhbk),
    MENU_LISTICON_ITEM(&colist,TxtGroupingIcon,		SetGroupingIcon,	item_flag_none ),//fix by xzy 2002/10/24 for book grouping icon
    MENU_LISTICON_ITEM(&colist,TxtGroupingRename,	bookGroupingRename, item_flag_none),
END_MENU( menuGrouping, menuListArea )

                              
BEGIN_MENU( menuNameOptions )
	MENU_LISTICON_ITEM( &colist,	TxtShowDetails,		bookShowDetails,    item_flag_none),//
    MENU_LISTICON_ITEM( &colist,	TxtChangeRecord,	bookEditOne,		item_flag_none),//༭  
    MENU_LISTICON_ITEM( &colist,	TxtCopyRecord,		bookCopyOne,		item_flag_none),//
    MENU_LISTICON_ITEM( &colist,	TxtDeleteRecord,	bookDeleteOne,		item_flag_none),//ɾ   
    MENU_LISTICON_ITEM( &colist,	TxtSendMessage,		bookSendMessage,	item_flag_none),//Ͷ
//    MENU_LISTICON_ITEM( &colist,	TxtVoiceCall,       bookVoiceCall,		item_flag_none),//
END_MENU( menuNameOptions, menuListArea )

/* glowing: ȥ"¼"   */
BEGIN_MENU( bookVoiceMemo )//¼
    MENU_LISTICON_ITEM( &colist, TxtBrowse,      voice_memo_browser ,  item_flag_none),//鿴
    MENU_LISTICON_ITEM( &colist, TxtVoiceMemoAdd,voice_memo_record,  item_flag_none),//
    MENU_LISTICON_ITEM ( &colist, TxtClearAll,      voice_memo_DeleteAll,  item_flag_none),//ɾȫ
   // MENU_LISTICON_ITEM(  &colist,TxtVoiceMemory,  voice_memo_Memory,  item_flag_none),//¼
END_MENU(  bookVoiceMemo, menuListArea)

BEGIN_MENU( VoiceList )
    MENU_LISTICON_ITEM(  &colist,TxtPlaying, voice_memo_play,item_flag_none),
    MENU_LISTICON_ITEM( &colist, TxtDelete,    voice_memo_Delete,item_flag_none),
END_MENU( VoiceList, menuListArea)

BEGIN_MENU(PhoneVoiceList )
    MENU_LISTICON_ITEM(&colist, TxtPlaying, bookVoicePlay,item_flag_none),
    MENU_LISTICON_ITEM( &colist,TxtDelete,    bookVoiceDelete,item_flag_none),
    MENU_LISTICON_ITEM( &colist,TxtCallSetup, bookVoiceCalling,item_flag_none),
     MENU_LISTICON_ITEM(&colist, TxtModify, bookVoiceModify,item_flag_none),
END_MENU( PhoneVoiceList, menuListArea)
/*---------------------------------------------------------------------------*/


/*
 *  Recent Calls menus
 */

//-----------------------------WUFEI Modify-----------------------------------------

//Sub-Menu of Call Timers


BEGIN_MENU(menuCallTimers)
// MENU_LISTICON_ITEM(&colist,TxtLastCall,   timerLastCall,          item_flag_none),
// MENU_LISTICON_ITEM(&colist,TxtIncomingCalls,    timerIncomingCalls,       item_flag_none),
// MENU_LISTICON_ITEM(&colist, TxtOutgoingCalls,    timerOutgoingCalls,       item_flag_none),
 MENU_LISTICON_ITEM(&colist, TxtCallDuration,    timerstatistics,       item_flag_none),
 MENU_LISTICON_ITEM(&colist,TxtTimerReset,     timerReset,       item_flag_none) //WUFEI Append

END_MENU(menuCallTimers, menuListArea)



//Sub-Menu of Charge Limit / AOC
BEGIN_MENU( menuLimitAOC )
    MENU_LISTICON_ITEM(&colist, TxtView,     aoc_view_limit,         item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtChange,   aoc_change_limit,       item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtCancel,   aoc_cancel_limit,       item_flag_none )
END_MENU( menuLimitAOC, menuListArea )

/*----------------WUFEI Append-----------------------------------*/
//Sub-Menu of Charge Rate / AOC
BEGIN_MENU( menuChargeRate )
	MENU_LISTICON_ITEM(&colist, TxtView,    aoc_view_rate,      item_flag_none ),
	MENU_LISTICON_ITEM(&colist, TxtChange,  aoc_charge_rate,   item_flag_none ),
	MENU_LISTICON_ITEM(&colist,TxtCancel,   aoc_cancel_rate,   item_flag_none )
END_MENU( menuChargeRate, menuListArea)
/*---------------------------------------------------------------*/


/* 2003/10/28, wangyan, modify call time statistics menu*/
//Sub-Menu of AOC
BEGIN_MENU( menuAOCRecent )
    //MENU_LISTICON_ITEM(&colist,TxtCredit,   aoc_credit_remaining,   item_flag_none ),
   // MENU_ITEM( TxtRate,     aoc_charge_rate,        item_flag_none ),
    MENU_LISTICON_ITEM(&colist,TxtAocStatistics,   aoc_statistics,   item_flag_none ),
    SUB_LISTICON_MENU( &colist, TxtRate,     menuChargeRate,    item_flag_none ),  //WUFEI Append    

    SUB_LISTICON_MENU( &colist,TxtLimit,    menuLimitAOC,       item_flag_none ),
    //MENU_LISTICON_ITEM(&colist, TxtLastCharge, aoc_last_charge,      item_flag_none ),
    //MENU_LISTICON_ITEM(&colist, TxtTotalCharge,  aoc_total_charge,     item_flag_none ),
    MENU_LISTICON_ITEM(&colist,TxtResetCharge,  aoc_reset_charge,     item_flag_none )
END_MENU( menuAOCRecent, menuListArea )

/********************WUFEI APPEND*********************************/
//Sub-Menu of GPRS DATA COUNT
//modify by wangyan 03-09-17
/*BEGIN_MENU( menuDataCount )

   MENU_LISTICON_ITEM(&colist, TxtIncomingData,    GPRSIncomingDataCount,   item_flag_none  ),
   MENU_LISTICON_ITEM(&colist,TxtOutgoingDataNew,    GPRSOutgoingDataCount,   item_flag_none  ) //hu binhao 2002-12-25 for 3125
END_MENU( menuDataCount, menuListArea )*/
/*********************Append END*************************************/
//modify by wangyan 03-09-17


// Menu of Recent Calls
/*BEGIN_TITLEICON_MENU( menuRecent )
    MENU_LISTICON_ITEM(&colist, TxtMissedCalls,  GetLMNrecord,     item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtRejectCalls,  GetLJNrecord,     item_flag_none ),  // hu binhao 11-22
    MENU_LISTICON_ITEM(&colist, TxtIncomingCalls, GetLRNrecord,     item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtOutgoingCalls,GetLDNrecord,     item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtDeleteAll,    Rnum_exeDelAll,  item_flag_none ),
    SUB_LISTICON_MENU (&colist, TxtCallTimers, menuCallTimers,     item_flag_none ),
    SUB_LISTICON_MENU (&colist, TxtChargeTimers, menuAOCRecent,   service_check_aoc ),
    SUB_LISTICON_MENU (&colist, TxtGPRS, menuDataCount,         item_flag_none ) //hbh 2003.04.15

END_TITLEICON_MENU( menuRecent, menuListArea,reccallTitleicon )*/
//modify by wangyan 03-09-17
BEGIN_TITLEICON_MENU( menuRecent )
    MENU_LISTICON_ITEM(&colist, TxtMissedCalls,  GetLMNrecord,     item_flag_none ),
//    MENU_LISTICON_ITEM( &colist,TxtRejectCalls,  GetLJNrecord,     item_flag_none ),  // hu binhao 11-22
    MENU_LISTICON_ITEM(&colist, TxtIncomingCalls, GetLRNrecord,     item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtOutgoingCalls,GetLDNrecord,     item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtDeleteAll,    Rnum_exeDelAll,  item_flag_none ),
    SUB_LISTICON_MENU (&colist, TxtCallTimers, menuCallTimers,     item_flag_none ),
    SUB_LISTICON_MENU (&colist, TxtChargeTimers, menuAOCRecent,   service_check_aoc ),
//    SUB_LISTICON_MENU (&colist, TxtGPRS, menuDataCount,         item_flag_none ) //hbh 2003.04.15
END_TITLEICON_MENU( menuRecent, menuListArea,reccallTitleicon )
//modify by wangyan 03-09-17

//-------------------------------end of WUFEI Modify-----------------------------

/*---------------------------------------------------------------------------*/

/*
 *  Divert menus
 */

//----------------------------------WUFEI Modify---------------------------------
//Sub-Menu  WUFEI APPEND

//sunsj030918 s
BEGIN_LISTICON_MENU( menuFullHrAlert )
	MENU_LISTICON_ITEM( &situationIcon,TxtOn,    setFullHrAlertOn,    fullHrAlertCheck ),
	MENU_LISTICON_ITEM( &situationIcon,TxtOff,    setFullHrAlertOff,     fullHrAlertCheck )
END_LISTICON_MENU( menuFullHrAlert, menuListArea )

BEGIN_LISTICON_MENU( menuTimeFormat )
	MENU_LISTICON_ITEM( &situationIcon,TxtTwelveHour,    setTo12hrMode,    hourModeCheck ),
	MENU_LISTICON_ITEM( &situationIcon,TxtTwentyfourHour,    setTo24hrMode,     hourModeCheck ),
END_LISTICON_MENU( menuTimeFormat, menuListArea )

/* glowing: "ʱ""" */
//2003.11.18 WYJ ȥ12/24Сʱѡ
BEGIN_MENU( menuTypTimeDate )
	MENU_LISTICON_ITEM(&colist, TxtSetTime,  setSystemTime,   item_flag_none ),  //set phone's time
	MENU_LISTICON_ITEM(&colist, TxtSetDate,  setSystemDate,   item_flag_none ), //set phone's date
	SUB_LISTICON_MENU(&colist,TxtFullHrAlert,  menuFullHrAlert, item_flag_none), //set full hour alert on or off
	//SUB_LISTICON_MENU(&colist,TxtTimeFormat,  menuTimeFormat,   item_flag_none ), //set 24/12 hour mode
	//MENU_LISTICON_ITEM(&colist, TxtWorldTime,  setWTime,   item_flag_none )  //set world time
END_MENU( menuTypTimeDate, menuListArea )

BEGIN_MENU( menuTypDailyAlarm )
	MENU_LISTICON_ITEM(&situationIcon, TxtOn,  setDailyAlarmOn,   daily_flag_check), 
	MENU_LISTICON_ITEM(&situationIcon, TxtOff,  setDailyAlarmOff,   daily_flag_check)
END_MENU( menuTypDailyAlarm, menuListArea )

BEGIN_MENU( menuTypWeeklyAlarm )
	MENU_LISTICON_ITEM(&situationIcon,TxtOn,  setWeeklyAlarm,   weekly_flag_check), 
	MENU_LISTICON_ITEM(&situationIcon,TxtOff,  setWeeklyAlarmOff,  weekly_flag_check)
END_MENU( menuTypWeeklyAlarm, menuListArea )


BEGIN_MENU( menuTypAlarm )
	MENU_LISTICON_ITEM(&colist,TxtBrowseAlarm, browseAlarm, item_flag_none),
	SUB_LISTICON_MENU(&colist,TxtDailyAlarm,  menuTypDailyAlarm, item_flag_none), 
	SUB_LISTICON_MENU(&colist,TxtWeeklyAlarm,  menuTypWeeklyAlarm,   item_flag_none)
END_MENU( menuTypAlarm, menuListArea )

BEGIN_MENU(stopwatch)
	MENU_LISTICON_ITEM(&colist,TxtSeparately, separately,  item_flag_none),
	MENU_LISTICON_ITEM(&colist,TxtBycircle,  bycircle,   item_flag_none),
	MENU_LISTICON_ITEM(&colist,TxtBrowseRecord, browse,  item_flag_none),
	MENU_LISTICON_ITEM(&colist,TxtClear, Delete,  item_flag_none)	//ɾ¼
END_MENU(stopwatch, menuListArea)
//sunsj030918 e

BEGIN_MENU( menuDivertNumberVoice )
	MENU_LISTICON_ITEM(&colist,TxtVoicemail, servicesDoVoiceMailNumber, item_flag_none ),
	MENU_LISTICON_ITEM(&colist,TxtOtherNumber,  servicesDoOtherNumber,  item_flag_none ),
	//	MENU_LISTICON_ITEM(&colist,TxtNumberInCommonUse, servicesDoUsedNumber, item_flag_none ) /*2003/12/4, wangyan modify*/
END_MENU( menuDivertNumberVoice, menuListArea )

BEGIN_MENU( menuDivertNumber )
	MENU_LISTICON_ITEM(&colist,TxtOtherNumber,  servicesDoOtherNumber,  item_flag_none ),
//	MENU_LISTICON_ITEM(&colist,TxtNumberInCommonUse, servicesDoUsedNumber, item_flag_none )/*2003/12/4, wangyan modify*/
END_MENU( menuDivertNumber, menuListArea )


//Sub-Menu
BEGIN_MENU( menuCallDivert )
    MENU_LISTICON_ITEM(&colist,TxtCheckStatus,   servicesDivertCheck,     item_flag_none ),
    LISTICON_SUB_MENU_ITEM (&colist,TxtSettings,   menuDivertNumber,  servicesNumbers,  item_flag_none ), //WUFEI Modified hu binhao 2003-2-18 change txt
	MENU_LISTICON_ITEM(&colist,TxtCancel, ShowAffirmWin, item_flag_none)//WUFEI APPEND hu binhao 2003-2-18 change txt
    //MENU_ITEM ( TxtCancelDivert,  servicesDivertDeactivate,    item_flag_none )
END_MENU( menuCallDivert, menuListArea )
BEGIN_MENU( menuCallDivertVoice )
    MENU_LISTICON_ITEM		(&colist,TxtCheckStatus,servicesDivertCheck,    item_flag_none ),//ѯ״̬
    LISTICON_SUB_MENU_ITEM	(&colist,TxtOpenDivert,   menuDivertNumberVoice,	servicesNumbers,  item_flag_none ), //WUFEI Modified hu binhao 2003-2-18 change txtת
	MENU_LISTICON_ITEM		(&colist,TxtCloseDivert,		ShowAffirmWin,			item_flag_none)//WUFEI APPEND hu binhao 2003-2-18 change txtȡת
    //MENU_ITEM ( TxtCancelDivert,  servicesDivertDeactivate,    item_flag_none )
END_MENU( menuCallDivertVoice, menuListArea )

//Sub-Menu  WUFEI APPEND
BEGIN_MENU( menuVoiceDivert )
	LISTICON_SUB_MENU_ITEM (&colist,TxtIfNoService, menuCallDivertVoice,  servicesDivertNoService,  item_flag_none),
	LISTICON_SUB_MENU_ITEM (&colist,TxtIfBusy,    menuCallDivertVoice,  servicesDivertBusy,    item_flag_none),
	LISTICON_SUB_MENU_ITEM (&colist,TxtIfNoAnswer,  menuCallDivertVoice, servicesDivertNoAnswer,  item_flag_none),
	LISTICON_SUB_MENU_ITEM (&colist,TxtAllCalls,   menuCallDivertVoice,   servicesDivertAllCalls,   item_flag_none),
	MENU_LISTICON_ITEM(&colist, TxtCancelAll,   servicesVoiceDivertCancelAll, item_flag_none)
END_MENU( menuVoiceDivert, menuListArea )

#if 0
// Menu of Divert  WUFEI APPEND
BEGIN_TITLEICON_MENU( menuDivert )
	LISTICON_SUB_MENU_ITEM (&colist, TxtVoiceCallDivert, menuVoiceDivert, servicesDivertVoice, item_flag_none),
	LISTICON_SUB_MENU_ITEM (&colist, TxtAllFaxCallDivert, menuCallDivert, servicesDivertFax, item_flag_none),
	LISTICON_SUB_MENU_ITEM (&colist, TxtAllDataCallDivert, menuCallDivert, servicesDivertData, item_flag_none),
	MENU_LISTICON_ITEM(&colist,  TxtCancelAll,  servicesDivertCancelAll, item_flag_none)
END_TITLEICON_MENU( menuDivert, menuListArea,calldivTitleicon)
#endif

//----------------------------END of WUFEI Modify----------------------------------------
// Menu of Divert  WUFEI APPEND
#if 0
/* ޸Ĳ˵ */
//sunsj030918 s
//hu binhao append 2003-2-11 begin
BEGIN_TITLEICON_MENU( menuDateTime )
	//ignore the fax and data forwarding,so we directly inter the sub menu list ,and add servicesDivertVoice to servicesDivertNoService servicesDivertBusy servicesDivertAllCalls

	//LISTICON_SUB_MENU_ITEM (&colist,TxtIfNoService, menuCallDivertVoice,  servicesDivertNoService,  item_flag_none),
	//LISTICON_SUB_MENU_ITEM (&colist,TxtIfBusy,    menuCallDivertVoice,  servicesDivertBusy,    item_flag_none),
	//LISTICON_SUB_MENU_ITEM (&colist,TxtIfNoAnswer,  menuCallDivertVoice, servicesDivertNoAnswer,  item_flag_none),
	//LISTICON_SUB_MENU_ITEM (&colist,TxtAllCalls,   menuCallDivertVoice,   servicesDivertAllCalls,   item_flag_none),
	//MENU_LISTICON_ITEM(&colist, TxtCancelAll,   servicesVoiceDivertCancelAll, item_flag_none)
	SUB_LISTICON_MENU(&colist,TxtTimeDate,      menuTypTimeDate,    item_flag_none ),
	SUB_LISTICON_MENU(&colist, TxtAlarm,        menuTypAlarm,       item_flag_none ),
	MENU_LISTICON_ITEM(&colist,TxtTimer,        (MenuFunc)toolkitTimer,    item_flag_none),
	SUB_LISTICON_MENU( &colist,TxtStopwatch,    stopwatch,          item_flag_none)
/*
    LISTICON_SUB_MENU_ITEM (&colist, TxtVoiceCallDivert, menuVoiceDivert, servicesDivertVoice, item_flag_none),
    LISTICON_SUB_MENU_ITEM (&colist, TxtAllFaxCallDivert, menuCallDivert, servicesDivertFax, item_flag_none),
    LISTICON_SUB_MENU_ITEM (&colist, TxtAllDataCallDivert, menuCallDivert, servicesDivertData, item_flag_none),
    MENU_LISTICON_ITEM(&colist,  TxtCancelAll,  servicesDivertCancelAll, item_flag_none)
*/
END_TITLEICON_MENU( menuDateTime, menuListArea,calldivTitleicon)
#endif
//hu binhao append 2003-2-11 end
BEGIN_LISTICON_MENU( menuDivertNoFaxData )
	//ignore the fax and data forwarding,so we directly inter the sub menu list ,and add servicesDivertVoice to servicesDivertNoService servicesDivertBusy servicesDivertAllCalls
	LISTICON_SUB_MENU_ITEM (&colist,TxtAllCalls,	menuCallDivertVoice,	servicesDivertAllCalls,		item_flag_none),//ȫ
	LISTICON_SUB_MENU_ITEM (&colist,TxtIfNoService, menuCallDivertVoice,	servicesDivertNoService,	item_flag_none),//޷ͨ
	LISTICON_SUB_MENU_ITEM (&colist,TxtIfBusy,		menuCallDivertVoice,	servicesDivertBusy,			item_flag_none),//ֻռ
	LISTICON_SUB_MENU_ITEM (&colist,TxtIfNoAnswer,  menuCallDivertVoice,	servicesDivertNoAnswer,		item_flag_none),//˽
MENU_LISTICON_ITEM(&colist, TxtCancelAll,   servicesVoiceDivertCancelAll, item_flag_none)
/*
    LISTICON_SUB_MENU_ITEM (&colist, TxtVoiceCallDivert, menuVoiceDivert, servicesDivertVoice, item_flag_none),
    LISTICON_SUB_MENU_ITEM (&colist, TxtAllFaxCallDivert, menuCallDivert, servicesDivertFax, item_flag_none),
    LISTICON_SUB_MENU_ITEM (&colist, TxtAllDataCallDivert, menuCallDivert, servicesDivertData, item_flag_none),
    MENU_LISTICON_ITEM(&colist,  TxtCancelAll,  servicesDivertCancelAll, item_flag_none)
*/
END_LISTICON_MENU( menuDivertNoFaxData, menuListArea)
//sunsj030918 e

/*---------------------------------------------------------------------------*/
/*
 *  Security menus
 */

//Sub-Menu of Pin Code
BEGIN_MENU( menuPinCodeSet )
    MENU_LISTICON_ITEM(&colist,  TxtStatus,   pin_status,        item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtActivate,  pin_enable,        item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtDeactivate, pin_disable,       item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtChange,   pin_change,        item_flag_none )
END_MENU( menuPinCodeSet, menuListArea )


//Sub-Menu of Fixed Dial
BEGIN_MENU( menuFixedDialSet )
    MENU_LISTICON_ITEM( &colist, TxtYes,    bookFDNActivate,   item_flag_none ),
    MENU_LISTICON_ITEM( &colist, TxtNo,   bookFDNDeactivate,   item_flag_none )
END_MENU( menuFixedDialSet, menuListArea )

//sub-menu of hostkey
BEGIN_LISTICON_MENU( menuHostKeyOptions )
    MENU_LISTICON_ITEM(&situation3Icon,  TxtHostSwitchOn,    SetModeSwitchOn,   HostkeyOptions_check ),  //HostkeySwitchOn
    MENU_LISTICON_ITEM(&situation3Icon, TxtHostSimLock,     SetModeSimLock,   HostkeyOptions_check ),   //  HostkeySimLock
    MENU_LISTICON_ITEM(&situation3Icon, TxtHostDelPbkall,   SetModeDelAllPhb,   HostkeyOptions_check ),    // HostkeyDelPbkall
    MENU_LISTICON_ITEM(&situation3Icon,  TxtHostReset,       SetModeReset,   HostkeyOptions_check ),     //HostkeyReset
    MENU_LISTICON_ITEM(&situation3Icon, TxtHostMsgbox,      SetModeMsgBox,   HostkeyOptions_check )      //HostkeyMsgbox
END_LISTICON_MENU( menuHostKeyOptions, menuListArea )

BEGIN_LISTICON_MENU( menuHostKeySet )
    MENU_LISTICON_ITEM( &situation3Icon, TxtOn,   settingHostKeyOn,  HostkeyOptions_check ),
    MENU_LISTICON_ITEM( &situation3Icon, TxtOff,    settingHostKeyOff, HostkeyOptions_check )
END_LISTICON_MENU( menuHostKeySet, menuListArea )


BEGIN_MENU( menuHostKey )
/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    MENU_LISTICON_ITEM( &situation4Icon, TxtHostKeySet,    settingHostKeyOnOff,   HostkeyOptions_check ),   //Hostkey  xsf changed 2002.08.22
    //MENU_LISTICON_ITEM( &situation3Icon, TxtHostKeySet,  settingHostKeyOnOff,   HostkeyOptions_check ),  //ChangeHostkey
    MENU_LISTICON_ITEM(&colist,  TxtHostKeyChange,		hostkey_change,   item_flag_none ),  //ChangeHostkeyֻ޸
    MENU_LISTICON_ITEM(&colist,  TxtHostKeyItems,		hostkey_menu_check,     item_flag_none )//
END_MENU( menuHostKey, menuListArea )


// Menu of Security 
BEGIN_MENU( menuSecurity )
    SUB_LISTICON_MENU (&colist, TxtPIN,        menuPinCodeSet,      item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtPIN2,       pin2_change,         pin2_avail_check ),
    SUB_LISTICON_MENU (&colist,	TxtHostKey,    menuHostKey,			item_flag_none ),	//ֻ
    SUB_LISTICON_MENU (&colist,	TxtFixedNames, menuFixedDialSet,    fdn_service_check  )//̶
END_MENU( menuSecurity, menuListArea )

/*---------------------------------------------------------------------------*/
/*
 *  Applications menus
 */

  /*  Toolkit menus
   
   ---------------------------------------------------------------------------*/

//schedule

//options of browse schedule
BEGIN_MENU(BrowseSche)
   MENU_LISTICON_ITEM(&colist,TxtChange, ScheChange,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtScheSMS, ScheSMS,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtDelete,  ScheDelete,   item_flag_none)
END_MENU(BrowseSche, menuListArea)

//submen of frequency
BEGIN_MENU(FrequScheOptions)
   MENU_LISTICON_ITEM(&colist,TxtOnce, type_once,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtDay,  type_day,   item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtWeek, type_week,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtMonth, type_month,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtYear, type_year,  item_flag_none)
END_MENU(FrequScheOptions, menuListArea)

//submen of type
BEGIN_MENU(typemenu)
   MENU_LISTICON_ITEM(&colist,TxtScheMeeting, meeting,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtBirthday,  birthday,   item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtPhone, phone,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtAppointment, appointment,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtRemind, remind,  item_flag_none)
END_MENU(typemenu, menuListArea)
//submen1 of schedule
BEGIN_MENU(menusche1)
   SUB_LISTICON_MENU(&colist,TxtNewSche, typemenu,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtToday,  TodaySche,   item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtAllSche, AllSche,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtDeleteOld, DeleteOld,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtDeleteAll, DeleteAll,  item_flag_none)
END_MENU(menusche1, menuListArea)


BEGIN_MENU(menuNoSche1)
   SUB_LISTICON_MENU(&colist,TxtNewSche, typemenu,  item_flag_none)
END_MENU(menuNoSche1, menuListArea)  


//submenu of autopower
BEGIN_LISTICON_MENU(autopower)
    MENU_LISTICON_ITEM( &colist, TxtBrowseAlarm ,  autoBrowse,  item_flag_none),
    /*2003/11/06,talcon change "&situationIcon" to  "situation4Icon" */
    MENU_LISTICON_ITEM( situation4Icon,  TxtAutoPowerOn,    autopoweron,    autopower_check ),
    MENU_LISTICON_ITEM( situation4Icon,  TxtAutoPowerOff,    autopoweroff,    autopower_check ),
  //  MENU_LISTICON_ITEM( &situationIcon,  TxtOpen,    autopoweropen,    autopower_check ),
    MENU_LISTICON_ITEM( situation4Icon,  TxtClose,    autopowerclose,    autopower_check )
//     MENU_ITEM(TxtOpen,      autopoweropen,      item_flag_none ),
//     MENU_ITEM(TxtClose,      autopowerclose,      item_flag_none )
END_LISTICON_MENU(autopower, menuListArea)

/* 2004/04/10 sunsj add */
//Sub-Menu of OnOffLED
BEGIN_LISTICON_MENU( LEDSwitch )
	MENU_LISTICON_ITEM( &situationIcon, TxtOn,    settingLED,   LEDSwitchOn_check ),
	MENU_LISTICON_ITEM( &situationIcon,TxtOff,   settingLED,    LEDSwitchOn_check )
END_LISTICON_MENU( LEDSwitch, menuListArea )

BEGIN_LISTICON_MENU( menuBackground )
	//  MENU_ITEM( TxtBackgroud,   BackgroundSel,  item_flag_none ),
	//SUB_LISTICON_MENU (&colist,TxtSelBackgroud,		menuSelBG,		item_flag_none),//ѡǽֽ
	MENU_LISTICON_ITEM(&colist,TxtSelBackgroud,	BKGSelEntry,   item_flag_none),	//ѡǽֽ
	MENU_LISTICON_ITEM(&colist,TxtBackgroundDisabled,	settingBGOff,   item_flag_none)	//رǽֽ
END_LISTICON_MENU( menuBackground, menuListArea )

/* 2004/05/28 sunsj remove */
BEGIN_LISTICON_MENU( Background )
	SUB_LISTICON_MENU( situation4Icon, TxtBackgroud, menuBackground,     SetSituation_check ),
	//MENU_LISTICON_ITEM(&colist,	TxtSelOuterBackgroud,	OuterBKGSelEntry,   item_flag_none),	//ѡǽֽ
END_LISTICON_MENU( Background,  menuListArea )

/* Ƴstopwatch ˵*/
//sunsj030918 s
/*
//submenu of stopwatch
BEGIN_MENU(stopwatch)
   MENU_LISTICON_ITEM(&colist,TxtSeparately, separately,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtBycircle,  bycircle,   item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtBrowseRecord, browse,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtDeleteRecord, Delete,  item_flag_none)
END_MENU(stopwatch, menuListArea)
*/
//sunsj030918 e

//submenu of count

BEGIN_MENU(menuCount)
   MENU_LISTICON_ITEM(&colist,TxtContinue, continue_count,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtSave,  save,   item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtRestart, restart,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtBrowseRecord, browse_record,  item_flag_none)
END_MENU(menuCount, menuListArea)

//submenu of stopwatch delete
BEGIN_MENU(StopwDelete)
   MENU_LISTICON_ITEM(&colist,TxtDeleteAll,  delete_All,  item_flag_none),
   MENU_LISTICON_ITEM(&colist,TxtOnebyone,  DeleteOnebyOne,  item_flag_none)
END_MENU(StopwDelete, menuListArea)

//Options-Menu of Calculator
#if 0
BEGIN_MENU( menuCalcOptions )
  MENU_ITEM( TxtEquals,       calcEquals,             item_flag_none ),
    MENU_ITEM( TxtPlus,         calcPlus,               item_flag_none ),
    MENU_ITEM( TxtMinus,        calcMinus,              item_flag_none ),
    MENU_ITEM( TxtDivideBy,     calcDivide,           item_flag_none ),
    MENU_ITEM( TxtMultiplyBy,     calcMultiply,             item_flag_none )
END_MENU( menuCalcOptions, menuListArea )
#endif
//Options-Menu of Melodie Generator
#ifdef MMI_MELODYGENERATOR
BEGIN_MENU( menuMelgenOptions )
  MENU_ITEM( TxtOctaveHigher, octave_higher,           item_flag_none ),
  MENU_ITEM( TxtOctaveLower,  octave_lower,          item_flag_none ),
  MENU_ITEM( TxtPlay,     melody_generator,        item_flag_none ),
  MENU_ITEM( TxtInsertnote, insert_new_note,         item_flag_none ),
  MENU_ITEM( TxtSave,     melody_generator,          item_flag_none ),
  MENU_ITEM( TxtLoadMelody, melody_generator,          item_flag_none ),
  MENU_ITEM( TxtDelete,   delete_current_note,       item_flag_none )
END_MENU( menuMelgenOptions, menuListArea )
#endif //MMI_MELODYGENERATOR

//zhangzg 08/14/2002
/* glowing : remove the game - Suoha 2003-10-29 */
#if 0
BEGIN_MENU(SuohaSub)
    MENU_LISTICON_ITEM( &colist,TxtSuohaNew, Suoha_Aktivate,         item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtSuohaPre, Suoha_Pre,         item_flag_none )
END_MENU(SuohaSub, menuListArea)
#endif

//Sub-Menu of Voice Memo
BEGIN_MENU( menuVoiceMemo )
    MENU_LISTICON_ITEM( &colist,TxtPlay,     voice_memo_play,         item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtRecord,   voice_memo_record,         item_flag_none )
END_MENU( menuVoiceMemo, menuListArea )

//zhangzg 08/14/2002
/* glowing: ȥʹ */
/*2003/12/18,talcon add snake*/
/*2004/05/25 yhf modify
/*BEGIN_TITLEICON_MENU(Game)
    //SUB_LISTICON_MENU( &colist,TxtSuoha,    SuohaSub,  item_flag_none ),
//    MENU_LISTICON_ITEM( &colist,TxtRussia,  GameRussiaEntry,  item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtBoxmangame,  (MenuFunc)boxman ,  item_flag_none ),
	MENU_LISTICON_ITEM( &colist,TxtSnakegame,  (MenuFunc)GameSnakeEntry ,  item_flag_none ),
    //MENU_LISTICON_ITEM( &colist,TxtBalloongame,  (MenuFunc)balloon ,  item_flag_none ),
END_TITLEICON_MENU(Game, menuListArea,gameTitleicon)*/
#ifdef GAME_SUBMENU
BEGIN_TITLEICON_MENU(RussiaSub)
MENU_LISTICON_ITEM( &colist,TxtGamestart, GameRussiaEntry,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGamesetting, GameRussiaEntry,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGameScore, GameRussiaEntry,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGamehelp, GameRussiaEntry,         item_flag_none )
END_TITLEICON_NOTITLE_MENU(RussiaSub, menuListArea, russiaTitleicon)

BEGIN_TITLEICON_MENU(BoxmanSub)
MENU_LISTICON_ITEM( &colist,TxtGamestart, boxman,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGameselect, boxman,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGamesetting, boxman,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGamehelp, boxman,         item_flag_none )
END_TITLEICON_NOTITLE_MENU(BoxmanSub, menuListArea, boxmanTitleicon)

BEGIN_TITLEICON_MENU(SnakeSub)
MENU_LISTICON_ITEM( &colist,TxtGamestart, GameSnakeEntry,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGameselect, GameSnakeEntry,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGamesetting, GameSnakeEntry,         item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtGameScore, GameSnakeEntry,         item_flag_none )
END_TITLEICON_NOTITLE_MENU(SnakeSub, menuListArea, snakeTitleicon)
#endif
#ifdef GAME_SUBMENU
BEGIN_TITLEICON_MENU(Game)
SUB_LISTICON_MENU( &colist,TxtRussia,  RussiaSub,  item_flag_none ),
SUB_LISTICON_MENU( &colist,TxtBoxmangame,  BoxmanSub ,  item_flag_none ),
SUB_LISTICON_MENU( &colist,TxtSnakegame,  SnakeSub ,  item_flag_none )
END_TITLEICON_MENU(Game, menuListArea,gameTitleicon)
#else
BEGIN_TITLEICON_MENU(Game)
MENU_LISTICON_ITEM( &colist,TxtRussia,  GameRussiaEntry,  item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtBoxmangame,  (MenuFunc)boxman ,  item_flag_none ),
MENU_LISTICON_ITEM( &colist,TxtSnakegame,  (MenuFunc)GameSnakeEntry ,  item_flag_none )
END_TITLEICON_MENU(Game, menuListArea,gameTitleicon)
#endif

//======================================================
//zgz, 2002.8.15 add our time and date setting

//Sub-menu of time Format
/*
BEGIN_MENU( menuTimeFormat )
    MENU_ITEM( TxtTwelveHour,   twelve_hour_clock,    item_flag_none ),
    MENU_ITEM( TxtTwentyfourHour, twentyfour_hour_clock,  item_flag_none ),
END_MENU( menuTimeFormat, menuListArea )
*/

/* Ƴʱ˵ */
//sunsj030918 s
/*
BEGIN_LISTICON_MENU( menuTimeFormat )
  MENU_LISTICON_ITEM( &situationIcon,TxtTwelveHour,    setTo12hrMode,    hourModeCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtTwentyfourHour,    setTo24hrMode,     hourModeCheck ),
END_LISTICON_MENU( menuTimeFormat, menuListArea )
*/
//sunsj030918 e

//Sub-menu of in-call timer
BEGIN_MENU( menuInCallTimer )
    MENU_LISTICON_ITEM(&colist,TxtOn,   menuInCallTimerOn,    item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtOff,    menuInCallTimerOff, item_flag_none ),

END_MENU( menuInCallTimer, menuListArea )
/*
//Sub-Menu of Clock
//GW 15/09/01 Removed debug menu items


BEGIN_MENU( menuTypclock )
    MENU_ITEM( TxtTimeDate,   settingsTimeDate,   item_flag_none ),
    MENU_ITEM( TxtAlarm,    alarmTimeDate,      item_flag_none ),
    MENU_ITEM( TxtClearAlarm, clear_alarm,    item_flag_none ),
    SUB_MENU( TxtTimeFormat,  menuTimeFormat,   item_flag_none ),
    SUB_MENU( TxtInCallTimer, menuInCallTimer,   item_flag_none )
END_MENU( menuTypclock, menuListArea )

*/
//sub menu of full-hour alert on/off

//sunsj030918 s
/*
BEGIN_LISTICON_MENU( menuFullHrAlert )
  MENU_LISTICON_ITEM( &situationIcon,TxtOn,    setFullHrAlertOn,    fullHrAlertCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtOff,    setFullHrAlertOff,     fullHrAlertCheck )
END_LISTICON_MENU( menuFullHrAlert, menuListArea )

BEGIN_MENU( menuTypTimeDate )
    MENU_LISTICON_ITEM(&colist, TxtSetTime,  setSystemTime,   item_flag_none ),  //set phone's time
    MENU_LISTICON_ITEM(&colist, TxtSetDate,  setSystemDate,   item_flag_none ), //set phone's date
    SUB_LISTICON_MENU(&colist,TxtFullHrAlert,  menuFullHrAlert, item_flag_none), //set full hour alert on or off
    SUB_LISTICON_MENU(&colist,TxtTimeFormat,  menuTimeFormat,   item_flag_none ), //set 24/12 hour mode
    MENU_LISTICON_ITEM(&colist, TxtWorldTime,  setWTime,   item_flag_none )  //set world time
END_MENU( menuTypTimeDate, menuListArea )

BEGIN_MENU( menuTypDailyAlarm )
    MENU_LISTICON_ITEM(&situationIcon, TxtOn,  setDailyAlarmOn,   daily_flag_check), 
    MENU_LISTICON_ITEM(&situationIcon, TxtOff,  setDailyAlarmOff,   daily_flag_check)
END_MENU( menuTypDailyAlarm, menuListArea )

BEGIN_LISTICON_MENU( menuTypWeeklyAlarmSet)
  MENU_LISTICON_ITEM( &situationIcon,TxtSunday,    setFullHrAlertOn,    weeklyAlarmStateCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtMonday,    setFullHrAlertOff,     weeklyAlarmStateCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtTuesday,    setFullHrAlertOff,     weeklyAlarmStateCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtWednesday,    setFullHrAlertOff,     weeklyAlarmStateCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtThursday,    setFullHrAlertOff,     weeklyAlarmStateCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtFriday,    setFullHrAlertOff,     weeklyAlarmStateCheck ),
  MENU_LISTICON_ITEM( &situationIcon,TxtSaturday,    setFullHrAlertOff,     weeklyAlarmStateCheck )
END_LISTICON_MENU( menuTypWeeklyAlarmSet, menuListArea )

BEGIN_MENU( menuTypWeeklyAlarm )
    MENU_LISTICON_ITEM(&situationIcon,TxtOn,  setWeeklyAlarm,   weekly_flag_check), 
    MENU_LISTICON_ITEM(&situationIcon,TxtOff,  setWeeklyAlarmOff,  weekly_flag_check)
END_MENU( menuTypWeeklyAlarm, menuListArea )


BEGIN_MENU( menuTypAlarm )
    MENU_LISTICON_ITEM(&colist,TxtBrowseAlarm, browseAlarm, item_flag_none),
    SUB_LISTICON_MENU(&colist,TxtDailyAlarm,  menuTypDailyAlarm, item_flag_none), 
    SUB_LISTICON_MENU(&colist,TxtWeeklyAlarm,  menuTypWeeklyAlarm,   item_flag_none)
END_MENU( menuTypAlarm, menuListArea )
*/
//sunsj030918 e

//======================================================
//hxl add start--------------------------06/28/02--------------------------------------
/* glowing : remove dictionary 2003-10-29 */
#if 0
BEGIN_MENU( menuDictExercise )
    MENU_LISTICON_ITEM(&colist, TxtDictTest,       DictTestEntry,        item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtDictReciteEC,    DictReciteECEntry,        item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtDictReciteCE,     DictReciteCEEntry,        item_flag_none ),
    MENU_LISTICON_ITEM( &colist,TxtDictReciteList,     DictReciteListEntry,        item_flag_none )
END_MENU( menuDictExercise, menuListArea )


BEGIN_MENU( menuDictMemo )
   MENU_LISTICON_ITEM( &colist,TxtEngToChn,       DictEngToChnEntry,        item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtChnToEng,       DictChnToEngEntry,        item_flag_none ),
    SUB_LISTICON_MENU( &colist,TxtDictExercise,     menuDictExercise,        item_flag_none )
END_MENU( menuDictMemo, menuListArea )
#endif
//end of hxl add--------------------------------------------------------------------
//zgz,2002.8.15 end of Mobile Innovation change

/*======================submenu of memo=========================*/
BEGIN_MENU(memoDelete)
    MENU_LISTICON_ITEM(&colist,TxtDeleteAll, memoDeleteAll, item_flag_none),
    MENU_LISTICON_ITEM(&colist,TxtOnebyone, memoOnebyone, item_flag_none)
END_MENU( memoDelete, menuListArea )

BEGIN_MENU(memoSubmenu)
    MENU_LISTICON_ITEM(&colist,TxtAdd, memoAdd, item_flag_none),
    MENU_LISTICON_ITEM(&colist,TxtBrowse, memoBrowse, item_flag_none),
    SUB_LISTICON_MENU(&colist,TxtDelete,  memoDelete,   item_flag_none)
END_MENU( memoSubmenu, menuListArea )
//gdy,2002.11.26


//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
// cammaim->settings->Quality
BEGIN_LISTICON_MENU( menuCamQuality )
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamFine,    Cam_Quality_Set,    Cam_Quality_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamNor,     Cam_Quality_Set,    Cam_Quality_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamEco,     Cam_Quality_Set,    Cam_Quality_Check),
END_LISTICON_MENU( menuCamQuality, menuListArea )

// cammaim->settings->size
BEGIN_LISTICON_MENU( menuCamSize )
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamMobile, Cam_Size_Set,    Cam_Size_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamQQVGA,   Cam_Size_Set,    Cam_Size_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamQVGA,    Cam_Size_Set,    Cam_Size_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamVGA,     Cam_Size_Set,    Cam_Size_Check),
END_LISTICON_MENU( menuCamSize, menuListArea )

// cammain->settings->melody
BEGIN_LISTICON_MENU( menuCamMelody )
    MENU_LISTICON_ITEM( &situationIcon,  TxtOff,        Cam_Melody_Set,    Cam_Melody_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamM1,      Cam_Melody_Set,    Cam_Melody_Check),
    MENU_LISTICON_ITEM( &situationIcon,  TxtCamM2,      Cam_Melody_Set,    Cam_Melody_Check),
END_LISTICON_MENU( menuCamMelody, menuListArea )

// cammaim->settings
BEGIN_LISTICON_MENU( menuCamSettings )
	SUB_LISTICON_MENU ( &colist, TxtCamSize,  		menuCamSize,  	item_flag_none ), 
    SUB_LISTICON_MENU ( &colist, TxtCamQuality,     menuCamQuality,    item_flag_none ), 
    SUB_LISTICON_MENU ( &colist, TxtCamMelody,      menuCamMelody,    item_flag_none ), 
END_LISTICON_MENU( menuCamSettings, menuListArea )

// cammaim
BEGIN_LISTICON_MENU( menuCamMain )
MENU_LISTICON_ITEM( &colist, TxtCamCatch,  		Cam_Main_Catch,  	item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtCamBook, 		Cam_Book_Browse,  	item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtMemoryState,	Cam_Memory_State,  	item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtDeleteAll,  	Cam_Delete_All,  	item_flag_none ),
//SUB_LISTICON_MENU ( &colist, TxtSettings,  		menuCamSettings,  	item_flag_none ),
END_LISTICON_MENU( menuCamMain, menuListArea )

// cammaim options->effect
BEGIN_LISTICON_MENU( menuCamEffect )
    MENU_LISTICON_ITEM( &situationIcon, TxtOff, 	    Cam_Effect_Set,    Cam_Effect_Check),
    MENU_LISTICON_ITEM( &situationIcon, TxtOn, 	    Cam_Effect_Set,    Cam_Effect_Check),
END_LISTICON_MENU( menuCamEffect, menuListArea )

// cammaim options->Rotation
BEGIN_LISTICON_MENU( menuCamRotation )
    MENU_LISTICON_ITEM( &situationIcon, TxtOff,         Cam_Rotation_Set,    Cam_Rotation_Check),
    MENU_LISTICON_ITEM( &situationIcon, TxtCam90,       Cam_Rotation_Set,    Cam_Rotation_Check),
    MENU_LISTICON_ITEM( &situationIcon, TxtCam180,      Cam_Rotation_Set,    Cam_Rotation_Check),
    MENU_LISTICON_ITEM( &situationIcon, TxtCam270,      Cam_Rotation_Set,    Cam_Rotation_Check),
END_LISTICON_MENU( menuCamRotation, menuListArea )

// cammaim options->Overlay
BEGIN_LISTICON_MENU( menuCamOSD )
    MENU_LISTICON_ITEM( &situationIcon, TxtOff,     Cam_OSD_Set,    Cam_OSD_Check),
    MENU_LISTICON_ITEM( &situationIcon, TxtOn,      Cam_OSD_Set,    Cam_OSD_Check),
END_LISTICON_MENU( menuCamOSD, menuListArea )

// cammaim options
BEGIN_LISTICON_MENU( menuCamMainOptions )
	SUB_LISTICON_MENU( &colist, TxtCamMirror,  	menuCamEffect,  	item_flag_none ),
	SUB_LISTICON_MENU( &colist, TxtCamRotation,	menuCamRotation,  	item_flag_none ),
    SUB_LISTICON_MENU( &colist, TxtCamOSD,      menuCamOSD,         item_flag_none ),
END_LISTICON_MENU( menuCamMainOptions, menuListArea )


BEGIN_LISTICON_MENU( menuCamBowseOption )
	MENU_LISTICON_ITEM( &colist, TxtRename,  		Cam_Browse_Rename,  	item_flag_none ),
	MENU_LISTICON_ITEM( &colist, TxtDelete, 		Cam_Browse_Delete,  	item_flag_none ),
    MENU_LISTICON_ITEM( &colist, TxtCamProperty,	Cam_Browse_Property,  	item_flag_none ),
END_LISTICON_MENU( menuCamBowseOption, menuListArea )

MfwMnuAttr *menuCamMainAttributes(void)
{
    return (MfwMnuAttr *) &menuCamMain;
}

MfwMnuAttr *menuCamMainOptionsAttributes(void)
{
    return (MfwMnuAttr *) &menuCamMainOptions;
}
MfwMnuAttr *menuCamBOptionAttributes(void)
{
    return (MfwMnuAttr *) &menuCamBowseOption;
}
#endif



/* glowing "¼"뵽 2003-10-27 */
/* glowing "ʱ" ""    2003-10-28 */

BEGIN_MENU( menuToolkit  )

	//SUB_LISTICON_MENU(&colist,TxtTimeDate,       menuTypTimeDate,       item_flag_none ),  //zgz,2002.8.15 add date and time setting to applications menu	//sunsj030918
	//SUB_LISTICON_MENU( &colist,TxtDictionary,        menuDictMemo,        item_flag_none ), //hxl add for dict 06/28/02	//sunsj030918
	//SUB_LISTICON_MENU(&colist, TxtAlarm,    menuTypAlarm,      item_flag_none ), //zgz, 2002.8.27  add the alarm	//sunsj030918
	MENU_LISTICON_ITEM(&colist, TxtSchedule,    (MenuFunc)calinder,      item_flag_none),  
    MENU_LISTICON_ITEM(&colist, TxtWorldTime,    setWTime,   item_flag_none ),  //set world time
	SUB_LISTICON_MENU(&colist,  TxtVoiceMemo,    bookVoiceMemo,  item_flag_none ),
	SUB_LISTICON_MENU(&colist,  TxtMemo,        memoSubmenu,      item_flag_none ),
	MENU_LISTICON_ITEM(&colist, TxtCalculator,  (MenuFunc)calculator_new,    item_flag_none ),
	//MENU_LISTICON_ITEM(&colist,TxtTimer, (MenuFunc)toolkitTimer,    item_flag_none),	//sunsj030918
	//SUB_LISTICON_MENU( &colist,TxtStopwatch,      stopwatch,     item_flag_none),	//sunsj030918
	//MENU_LISTICON_ITEM(&colist,TxtConversion, (MenuFunc)conversion, item_flag_none) 	//sunsj030918 
	MENU_LISTICON_ITEM(&colist, TxtTimer,        (MenuFunc)toolkitTimer,    item_flag_none),
	SUB_LISTICON_MENU( &colist, TxtStopwatch,    stopwatch,          item_flag_none),
		/*talcon add for pcsyn,2004.07.06*/
#ifdef MMI_PCSYN_ENABLED
	MENU_LISTICON_ITEM(&colist, TxtPCSyn,  (MenuFunc)pcsyn_start,    item_flag_none )
#endif
END_TITLEICON_MENU( menuToolkit, menuListArea, toolkitTitleicon)

#ifdef CAMERA_ENABLED
BEGIN_MENU( Camera  )//
MENU_LISTICON_ITEM( &colist, TxtCamCatch,  		Cam_Main_Catch,  	item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtCamBook, 		Cam_Book_Browse,  	item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtMemoryState,	Cam_Memory_State,  	item_flag_none ),
MENU_LISTICON_ITEM( &colist, TxtDeleteAll,  	Cam_Delete_All,  	item_flag_none ),
//SUB_LISTICON_MENU ( &colist, TxtSettings,  		menuCamSettings,  	item_flag_none ),	
END_TITLEICON_MENU( Camera, menuListArea, cameraicon)//Knuth
#endif

/*BEGIN_MENU( menuApplications )
  MENU_ITEM( TxtCalculator,     (MenuFunc)calculator, item_flag_none ),
  #ifdef MMI_MELODYGENERATOR
  MENU_ITEM( TxtMelodygenerator,  (MenuFunc)melody_generator_aktivate,  item_flag_none ),
  #endif // MMI_MELODYGENERATOR
  //#ifdef MMIGAME
  SUB_MENU( TxtGame,       Game,  item_flag_none),
//  #else
  //GW 15/09/01 removed debug code
  //#endif // MMIGAME
    SUB_MENU( TxtVoiceMemo,       menuVoiceMemo,        item_flag_none )
END_MENU( menuApplications, menuListArea )
*/
/*---------------------------------------------------------------------------*/

/*
 *  Settings menus
 */
//Sub-Menu of Language
/**********zy change for example the list icon menu**********************/
BEGIN_LISTICON_MENU( menuLanguage )
  MENU_LISTICON_ITEM( &situationIcon,TxtEnglish,    Mmi_Set2English,    Language_check ),
#ifndef CHINESE_MMI
  MENU_LISTICON_ITEM( &situationIcon,TxtGerman,   Mmi_Set2German,    item_flag_none )
#else
  MENU_LISTICON_ITEM( &situationIcon,TxtChinese,    Mmi_Set2Chinese,     Language_check )
#endif
END_LISTICON_MENU( menuLanguage, menuListArea )
/*******************end of zy changed***********************************/
/*...............................zy change for setting's submenu 04/08/02....................................*/
  /*
 BEGIN_MENU(menuBGUserDefine)
  MENU_ITEM( TxtUserdefine1,  settingBGOn,    item_flag_none ),
  MENU_ITEM( TxtUserdefine2,  settingBGOn,    item_flag_none ),
  MENU_ITEM( TxtUserdefine3,  settingBGOn,    item_flag_none ),
  MENU_ITEM( TxtUserdefine4,  settingBGOn,    item_flag_none ),
  MENU_ITEM( TxtUserdefine5,  settingBGOn,    item_flag_none ),
 END_MENU( menuBGUserDefine, menuListArea )
  //Sub-Menu of selectbackground
BEGIN_MENU( menuSelBG )    
    MENU_ITEM( TxtA,   settingBGOn,    item_flag_none ),
    MENU_ITEM( TxtB,   settingBGOn,    item_flag_none ),
   // MENU_ITEM( TxtUserDefine,   BackgroundSel,  item_flag_none )
   SUB_MENU( TxtUserDefine,   menuBGUserDefine,    item_flag_none )
END_MENU( menuSelBG, menuListArea )*/
//sub-Menu of MenuSavingSetting
#if 0
BEGIN_MENU( menuSavingSetting )    
    MENU_ITEM( TxtBacklightOnTime,   settingBacklighOnTime,    item_flag_none ),
    MENU_ITEM( TxtBacklightOffTime,   settingBacklighOffTime,    item_flag_none )
END_MENU( menuSavingSetting, menuListArea )
#endif
//sub-Menu of menuBLSetting

BEGIN_MENU( menuBLSetting )    
    MENU_ITEM( TxtBacklightIntensity,   settingBacklightIntensity,    item_flag_none ),
   // SUB_MENU( TxtSavingSetting,   menuSavingSetting,    item_flag_none )//gdy add
END_MENU( menuBLSetting, menuListArea )



//sub-Menu of menuGreetingWordOn

#if 0/*2003/1201 talcon comment it*/
//Sub-Menu of Theme
BEGIN_LISTICON_MENU( menuTheme )
    MENU_LISTICON_ITEM( &situationIcon, TxtBlue,    settingTheme,   Theme_check ),
    MENU_LISTICON_ITEM( &situationIcon, TxtPink,    settingTheme,   Theme_check ),
    MENU_LISTICON_ITEM( &situationIcon,TxtJazz,    settingTheme,    Theme_check ),
    MENU_LISTICON_ITEM( &situationIcon,TxtPopular,  settingTheme,    Theme_check ),
    MENU_LISTICON_ITEM( &situationIcon, TxtBlackWhite,   settingTheme,   Theme_check )
END_LISTICON_MENU( menuTheme, menuListArea )
#endif
//Sub-Menu of Background

#if 0
BEGIN_ICONONE_MENU(  menuSelBG )
/*2003/10/30,talcon modify it*/
//	MENU_ICON_ITEM ( &BackgroundIcon1,TxtA, settingBGOn ,  item_flag_none ),   
    MENU_ICON_ITEM ( BackgroundIcon1,TxtA, settingBGOn ,  item_flag_none ),   
	/*end talcon */
   //MENU_ICON_ITEM ( &BackgroundIcon2,TxtB, settingBGOn , item_flag_none ),
#if 0/*2003/12/01,talcon comment*/
    MENU_ICON_ITEM ( &BackgroundIcon3,TxtUserdefine1, settingBGOn , item_flag_none ),
    MENU_ICON_ITEM ( &BackgroundIcon4,TxtUserdefine2, settingBGOn ,item_flag_none ),
    MENU_ICON_ITEM ( &BackgroundIcon5,TxtUserdefine3, settingBGOn ,item_flag_none ),
    MENU_ICON_ITEM ( &BackgroundIcon6,TxtUserdefine4, settingBGOn ,item_flag_none ),
    MENU_ICON_ITEM ( &BackgroundIcon7,TxtUserdefine5, settingBGOn ,item_flag_none ),
#endif
    MENU_ICON_ITEM ( NULL,TxtUserDefinedPic, settingBGOn ,SetUserDefinedPic )//chenjun
END_ICONONE_MENU( menuSelBG, menuListArea )
#endif

//Sub-Menu of OnOffAnimation
BEGIN_LISTICON_MENU( menuOnOffAnimation )
 //  MENU_LISTICON_ITEM( &situationIcon, TxtMobileInnovation,    settingAnimation,   OnAnimation_check ),
    MENU_LISTICON_ITEM( &situationIcon,TxtFlower,   settingAnimation,    OnAnimation_check ),
    MENU_LISTICON_ITEM( &situationIcon,TxtCloseAnim,   settingAnimation,    OnAnimation_check )
    //xsf comment it 2003.02.28 MENU_LISTICON_ITEM( &situationIcon, TxtSkyrocket,    settingAnimation,   OnAnimation_check )
END_LISTICON_MENU( menuOnOffAnimation, menuListArea )


//Sub-Menu of BackLight
BEGIN_MENU( menuBackLight )
    MENU_ITEM( TxtSavingMode,    settingSavingMode,    item_flag_none ),
    MENU_ITEM( TxtNormalMode,    settingNormalMode,   item_flag_none ),
    SUB_MENU( TxtSettings,    menuBLSetting,   item_flag_none )
END_MENU( menuBackLight, menuListArea )


//Sub-Menu of BmpAlbum
//zy remove 0918
#if 0
BEGIN_ICONONE_MENU( menuScinece )
    MENU_ICON_ITEM ( &ScienceIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &ScienceIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuScinece, menuListArea )

BEGIN_ICONONE_MENU( menuSensibility )
    MENU_ICON_ITEM ( &SensibilityIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SensibilityIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuSensibility, menuListArea )

BEGIN_ICONONE_MENU( menuTravel )
    MENU_ICON_ITEM ( &TravelIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &TravelIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuTravel, menuListArea )

BEGIN_ICONONE_MENU( menuPerson )
    MENU_ICON_ITEM ( &PersonIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &PersonIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuPerson, menuListArea )


BEGIN_ICONONE_MENU( menuSport )
    MENU_ICON_ITEM ( &SportIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &SportIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuSport, menuListArea )



BEGIN_ICONONE_MENU( menuRelax )
    MENU_ICON_ITEM ( &RelaxIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &RelaxIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuRelax, menuListArea )

BEGIN_ICONONE_MENU( menuMusic )
    MENU_ICON_ITEM ( &MusicIcon1,Txt1, item_flag_none ,  item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon2,Txt2, item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon3,Txt3,item_flag_none , item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon4,Txt4, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon5,Txt5,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon6,Txt6,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon7,Txt7, item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon8,Txt8,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon9,Txt9,  item_flag_none ,item_flag_none ),
    MENU_ICON_ITEM ( &MusicIcon10,Txt10, item_flag_none ,item_flag_none )
END_ICONONE_MENU( menuMusic, menuListArea )

BEGIN_MENU( menuBmpAlbum )
    SUB_MENU( TxtScience,    menuScinece,   item_flag_none ),
    SUB_MENU( TxtSensibility,    menuSensibility,   item_flag_none ),
    SUB_MENU( TxtTravel,    menuTravel,   item_flag_none ),
    SUB_MENU(TxtPerson ,   menuPerson ,   item_flag_none ),
    SUB_MENU( TxtSport,    menuSport,   item_flag_none ),
    SUB_MENU( TxtRelax,   menuRelax,   item_flag_none ),
    SUB_MENU( TxtMusic,  menuMusic,   item_flag_none ),
 //   SUB_MENU( TxtAnimation,    menuAnimation,   item_flag_none ),
END_MENU( menuBmpAlbum, menuListArea )
#endif
//end of zy change 0918


//Sub-Menu of GreetingWord

BEGIN_LISTICON_MENU( menuGreetingWord )
     MENU_LISTICON_ITEM( &colist,TxtGreetingWordOn,   settingGreetingWordOn,    item_flag_none ), 
     MENU_LISTICON_ITEM( &colist,TxtGreetingWordOff,   settingGreetingWordOff,    item_flag_none ),
     MENU_LISTICON_ITEM( &colist,TxtGreetingWordEdit,   editGreetingWord,        item_flag_none )
END_LISTICON_MENU( menuGreetingWord, menuListArea )
/*..............................end of zy change for setting's submenu 04/08/02....................................*/

//Sub-Menu of AnyKey
BEGIN_MENU( menuAnyKeySet )
    MENU_ITEM( TxtOn,   settingsAnyKeyAnswerOn,  item_flag_none ),
    MENU_ITEM( TxtOff,    settingsAnyKeyAnswerOff, item_flag_none )
END_MENU( menuAnyKeySet, menuListArea )


//Sub-Menu of AutoAnswer
//BEGIN_MENU( menuAutoAnswerSet )
    //MENU_ITEM( TxtOn,   settingsAutoAnswerOn,  item_flag_none ),
    //MENU_ITEM( TxtOff,    settingsAutoAnswerOff,   item_flag_none )
//END_MENU( menuAutoAnswerSet, menuListArea )
BEGIN_LISTICON_MENU( menuAutoAnswerSet )
	MENU_LISTICON_ITEM( &situationIcon, TxtOn,  settingsAutoAnswerOn,  autoanswer_check ),//wufei 0918
	MENU_LISTICON_ITEM( &situationIcon, TxtOff, settingsAutoAnswerOff, autoanswer_check )
END_LISTICON_MENU( menuAutoAnswerSet, menuListArea )



//Sub-Menu of AutoRedial
//BEGIN_MENU( menuAutoRedialSet )
    //MENU_ITEM( TxtOn,   settingsAutoRedialOn,  item_flag_none ),
    //MENU_ITEM( TxtOff,    settingsAutoRedialOff,   item_flag_none )
//END_MENU( menuAutoRedialSet, menuListArea )
BEGIN_LISTICON_MENU( menuAutoRedialSet )
	MENU_LISTICON_ITEM( &situationIcon, TxtOn,  settingsAutoRedialOn,  autoredial_check ),//wufei 0827
	MENU_LISTICON_ITEM( &situationIcon, TxtOff, settingsAutoRedialOff, autoredial_check )
END_LISTICON_MENU( menuAutoRedialSet, menuListArea )
//zgz,2002.8.30 comment out it
/*
//Sub-menu of time Format
BEGIN_MENU( menuTimeFormat )
    MENU_ITEM( TxtTwelveHour,   twelve_hour_clock,    item_flag_none ),
    MENU_ITEM( TxtTwentyfourHour, twentyfour_hour_clock,  item_flag_none ),

END_MENU( menuTimeFormat, menuListArea )
*/

//zgz,2002.8.30 comment out it
/*
//Sub-menu of in-call timer
BEGIN_MENU( menuInCallTimer )
    MENU_ITEM( TxtOn,   menuInCallTimerOn,    item_flag_none ),
    MENU_ITEM( TxtOff,    menuInCallTimerOff, item_flag_none ),

END_MENU( menuInCallTimer, menuListArea )
*/

/*zgz,2002.8.30 comment out it
//Sub-Menu of Clock
//GW 15/09/01 Removed debug menu items
BEGIN_MENU( menuTypclock )
    MENU_ITEM( TxtTimeDate,   settingsTimeDate,   item_flag_none ),
    MENU_ITEM( TxtAlarm,    alarmTimeDate,      item_flag_none ),
    MENU_ITEM( TxtClearAlarm, clear_alarm,    item_flag_none ),
    SUB_MENU( TxtTimeFormat,  menuTimeFormat,   item_flag_none ),
    SUB_MENU( TxtInCallTimer, menuInCallTimer,   item_flag_none )
END_MENU( menuTypclock, menuListArea )
*/
//MENU OF SCENE MODE............................................................................................

//Sub-Menu of KeypadTones
/*	2004.4.4 WYJ modify
BEGIN_MENU( menuSetTones2 )
    MENU_ITEM( TxtSilent, soundsKeypadSilent,  item_flag_none ),
    MENU_ITEM( TxtClick,  soundsKeypadClick,   item_flag_none ),
    MENU_ITEM( TxtDTMF,   soundsKeypadDTMF,  item_flag_none )
END_MENU( menuSetTones2, menuListArea )
*/

//Sub-Menu of Volume Settings
BEGIN_MENU( menuSetVolume )
    MENU_ITEM( TxtSilent, soundsVolSilent,    Stopplaying ),
    MENU_ITEM( TxtLow,    soundsVolLow,  Stopplaying ),
    MENU_ITEM( TxtMedium, soundsVolMedium,  Stopplaying ),
    MENU_ITEM( TxtHigh,   soundsVolHigh,   Stopplaying ),
    MENU_ITEM( TxtIncreasing, soundsVolInc,      Stopplaying )
END_MENU( menuSetVolume, menuListArea )

/* submenu: alert type */
BEGIN_LISTICON_MENU( menuAlerttype )   //xsf change to listicon menu 2002.09.05
    MENU_LISTICON_ITEM( &situationIcon, TxtRingmode,   SetRingmode,  Stopplaying ),  // "Ring"      
    MENU_LISTICON_ITEM( &situationIcon, TxtVibramode,   SetVibramode,  Stopplaying ),  // "Vibration"   
    MENU_LISTICON_ITEM( &situationIcon, TxtVibraRing,   SetRingVibra,  Stopplaying ),  // "Vibra then Ring"
    MENU_LISTICON_ITEM( &situationIcon, TxtRingandVib,   SetRingAndVib,  Stopplaying ),  //ring and vibrate
    MENU_LISTICON_ITEM( &situationIcon, TxtMute,   SetMuteMode,  Stopplaying )     //Mute mode
END_LISTICON_MENU( menuAlerttype, menuListArea )


/* submenu: sms specialring 2003.3.18 WYJ
BEGIN_LISTICON_MENU( menuSmsSpcial )   //xsf change to listicon menu 2002.09.05
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRing1,   SetSpecialRing,  Stopplaying ),  //  "sms ring type"       
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRing2,   SetSpecialRing,  Stopplaying ),  //  "sms special Ring type"      
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRing3,   SetSpecialRing,  Stopplaying ),  //  "sms vibra" 
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRing4,   SetSpecialRing,  Stopplaying ),  //  "sms ring and vibra" 
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRing5,   SetSpecialRing,  Stopplaying )     //sms mute 
END_LISTICON_MENU( menuSmsSpcial, menuListArea )
*/

/* submenu: sms setting */
BEGIN_LISTICON_MENU( menuSmsAlert )   //xsf change to listicon menu 2002.09.05
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRing,   SetSmsRing,  Stopplaying ),  //  "sms ring type"       
    MENU_LISTICON_ITEM( &situationIcon, TxtSpecialRing,   smsSelect,  Stopplaying ),  //  "sms special Ring type"      
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsVibra,   SetSmsVibra,  Stopplaying ),  //  "sms vibra" 
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsRVibra,   SetSmsRVibra,  Stopplaying ),  //  "sms ring and vibra" 
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsMute,   SetSmsMute,  Stopplaying )     //sms mute 
END_LISTICON_MENU( menuSmsAlert, menuListArea )


//Sub-Menu of Ringer,SMS Tone,Alarm
BEGIN_LISTICON_MENU( menuSetTones )
    SUB_LISTICON_MENU(&colist,  TxtAlerttype,    menuAlerttype,      item_flag_none ),
    MENU_LISTICON_ITEM(&colist,  TxtMelody,   callSelect,  soundReasonRinger ),
    MENU_LISTICON_ITEM(&colist,  TxtRingVolume,   AdjustRingerVolume,  item_flag_none )
    //MENU_ITEM_SUB_MENU( TxtVolume,    menuSetVolume,soundsSetVolume, item_flag_none )
END_LISTICON_MENU( menuSetTones, menuListArea )

BEGIN_LISTICON_MENU( menuSetTonAlarm )
/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    MENU_LISTICON_ITEM( situation4Icon, TxtSmsVibra,   SetAlarmVibramode,  environment_check ),  // "Vibration"   
    MENU_LISTICON_ITEM( situation4Icon, TxtRingPrompt,   SetAlarmRingmode,  soundReasonAlarm ),  // "Ring"ʾ      
    MENU_LISTICON_ITEM( &colist,  TxtMelody,   alarmSelect,  item_flag_none ),
    MENU_LISTICON_ITEM( &colist,  TxtAlarmVolume,   AdjustRingerVolume, item_flag_none )
END_LISTICON_MENU( menuSetTonAlarm, menuListArea )


//Sub-menu of Answer Set
//sunsj030918 s
BEGIN_LISTICON_MENU(menuHallconnect)
	MENU_LISTICON_ITEM( &situationIcon, TxtActivate,  Hallconnect,  Hallconnect_check ),
	MENU_LISTICON_ITEM( &situationIcon, TxtDeactivate, Hallconnect, Hallconnect_check )
END_LISTICON_MENU( menuHallconnect, menuListArea )//Sub-Menu of Call Settings

//Sub-menu of Answer Set
BEGIN_LISTICON_MENU( menuAnswer )
	//xsf remarked 09.16 SUB_MENU( TxtAutoAnswer,    menuAutoAnswerSet,      item_flag_none ),

	SUB_LISTICON_MENU( &colist, TxtHallOnConnect,       menuHallconnect,       SetSituation_check ),
	/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
	MENU_LISTICON_ITEM( situation4Icon, TxtAnyKeyAnswer,    SetModeEasyanswer,        environment_check ),	
	MENU_LISTICON_ITEM( situation4Icon, TxtAnswerTone,   SetModeConnectTonewer,   environment_check )
END_LISTICON_MENU( menuAnswer, menuListArea )
//sunsj030918 e

//Sub-menu of SMS Prompt
BEGIN_LISTICON_MENU( menuSmsPrompt )
    SUB_LISTICON_MENU(&colist, TxtAlerttype,    menuSmsAlert, item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtSmsVolume,   AdjustRingerVolume,  item_flag_none ),  
END_LISTICON_MENU( menuSmsPrompt, menuListArea )

/* 2003/12/08 sunsj */
BEGIN_LISTICON_MENU( menuKeypadToneType )
    MENU_LISTICON_ITEM( &situationIcon, TxtKeypadToneRing,   SetKeypadToneRing,  Stopplaying ),
    MENU_LISTICON_ITEM( &situationIcon, TxtKeypadToneSpecialRing,   SetKeypadToneSpcial,  Stopplaying ),
    MENU_LISTICON_ITEM( &situationIcon, TxtMute,   setKeypadMute,  checkKeypadMute ),
END_LISTICON_MENU( menuKeypadToneType, menuListArea )

/* 2003/12/08 sunsj sub menu of keypad tone */
BEGIN_LISTICON_MENU( menuKeypadTone )
    SUB_LISTICON_MENU(&colist, TxtAlerttype,    menuKeypadToneType, item_flag_none ),
    MENU_LISTICON_ITEM(&colist, TxtKeypadToneVolume,   AdjustRingerVolume,  item_flag_none ),  
END_LISTICON_MENU( menuKeypadTone, menuListArea )

/*-------------2004.1.13 WYJ add On&Off  Ring---------------- */
//power on ring type
BEGIN_LISTICON_MENU( menuOnRingType )
    MENU_LISTICON_ITEM( &situationIcon, TxtSpecialRing, powerOnSelect ,  OnOff_check ),  //"on Ring type"      
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsMute,   SetOnRingMute,  OnOff_check )     //on mute 
END_LISTICON_MENU( menuOnRingType, menuListArea )

//power off ring type
BEGIN_LISTICON_MENU( menuOffRingType )
    MENU_LISTICON_ITEM( &situationIcon, TxtSpecialRing, powerOffSelect ,  OnOff_check ),  //"off Ring type"      
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsMute,   SetOffRingMute,  OnOff_check )     //off mute 
END_LISTICON_MENU( menuOffRingType, menuListArea )

//power on ring menu
BEGIN_LISTICON_MENU( menuOnRing )
    SUB_LISTICON_MENU(&colist,  TxtMelody,    menuOnRingType,      item_flag_none ),
	MENU_LISTICON_ITEM(&colist,  TxtOnVolume,   AdjustRingerVolume,  item_flag_none ),
END_LISTICON_MENU( menuOnRing, menuListArea )

//power off ring menu
BEGIN_LISTICON_MENU( menuOffRing ) 
    SUB_LISTICON_MENU(&colist,  TxtMelody,    menuOffRingType,      item_flag_none ),
	MENU_LISTICON_ITEM(&colist,  TxtOffVolume,   AdjustRingerVolume,  item_flag_none ),
END_LISTICON_MENU( menuOffRing, menuListArea )

// On&Off ring set main menu 2004.5.10 wyj modify
BEGIN_LISTICON_MENU( menuOnOffRing )  
	LISTICON_SUB_MENU_ITEM(&colist, TxtOnRing, menuOnRing ,	SetOnMenu, item_flag_none),
	LISTICON_SUB_MENU_ITEM(&colist, TxtOffRing, menuOffRing ,SetOffMenu,item_flag_none),
END_LISTICON_MENU( menuOnOffRing, menuListArea )
/*------------ end of 2004.1.13 WYJ add On&Off  Ring ---------*/


/*-------------2004.2.12 WYJ add Hall On&Off  Ring---------------- */
// Hall On/off ring type
BEGIN_LISTICON_MENU( menuOnOffRingType )
    MENU_LISTICON_ITEM( &situationIcon, TxtSpecialRing, hallOnOffSelect ,  HallOnOff_check ),  //"off Ring type"      
    MENU_LISTICON_ITEM( &situationIcon, TxtSmsMute,   SetHallOnOffRingMute,  HallOnOff_check ),     //off mute 
END_LISTICON_MENU( menuOnOffRingType, menuListArea )

// Hall On/off ring menu
BEGIN_LISTICON_MENU( menuHallOnOffRing ) 
    SUB_LISTICON_MENU(&colist,  TxtMelody,    menuOnOffRingType,      item_flag_none ),
	MENU_LISTICON_ITEM(&colist,  TxtHallOnVolume,   AdjustRingerVolume,  item_flag_none ),
END_LISTICON_MENU( menuHallOnOffRing, menuListArea )

// Hall On&Off ring set main menu 
BEGIN_LISTICON_MENU( menuHallOnOff )  
	LISTICON_SUB_MENU_ITEM(&colist, TxtHallOnRing, menuHallOnOffRing, SetHallOnMenu,item_flag_none),
	LISTICON_SUB_MENU_ITEM(&colist, TxtHallOffRing, menuHallOnOffRing,SetHallOffMenu,item_flag_none),
END_LISTICON_MENU( menuHallOnOff, menuListArea )
/*-------------end of 2004.2.12 WYJ add Hall On&Off  Ring---------------- */


//Sub-Menu of Tones
BEGIN_LISTICON_MENU( menuTonesSet )
    SUB_LISTICON_MENU(&colist, TxtRinger,    menuSetTones, soundReasonSmsTone ),//ʾ
    //SUB_LISTICON_MENU(&colist, TxtSmsTone,    menuSmsAlert, item_flag_none ),
    SUB_LISTICON_MENU(&colist, TxtSmsTone,   menuSmsPrompt,  item_flag_none ),   //xsf 2003.01.28ʾ
    SUB_LISTICON_MENU(&colist, TxtAlarmPrompt,     menuSetTonAlarm, soundReasonSmsTone ),
    MENU_LISTICON_ITEM(&colist, TxtSpeakerVolume,   AdjustRingerVolume,  item_flag_none ),   //xsf 2002.08.30
    //SUB_LISTICON_MENU(&colist, TxtAnswer, menuAnswer,   item_flag_none ),    //xsf 2002.04.24		//sunsj030918
    /*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    /* 2003/12/08 sunsj add submenu in keypad tone */
    //MENU_LISTICON_ITEM( situation4Icon, TxtKeypadTones,   SetKeypadTone,  environment_check ),    
    SUB_LISTICON_MENU(&colist, TxtKeypadTones, menuKeypadTone, item_flag_none),
    //MENU_LISTICON_ITEM( situation4Icon, TxtMissedCallTone,  SetMissedcallTone,  environment_check ),		/* 2003/12/08 sunsj remove */
    //MENU_LISTICON_ITEM( situation4Icon, TxtUnreadSMSTone,   SetUnreadsmsTone,    environment_check )   	/* 2003/12/08 sunsj remove */
    //SUB_MENU( TxtKeypadTones, menuSetTones2,   item_flag_none )
// 2004.1.13 WYJ add On&Off Hall Ring 
	SUB_LISTICON_MENU(&colist, TxtOnOffRing, menuOnOffRing ,item_flag_none),
	SUB_LISTICON_MENU(&colist, TxtHallOnOffRing, menuHallOnOff ,item_flag_none),
// end of 2004.1.13 WYJ add On&Off Hall Ring 
END_LISTICON_MENU( menuTonesSet, menuListArea )


// Menu of Scene

BEGIN_LISTICON_MENU( menuSetmode )
/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    MENU_LISTICON_ITEM( situation4Icon, TxtActivate,     SetEnvironmentmode,       environment_check ),
    SUB_LISTICON_MENU(&colist, TxtPssetting,  menuTonesSet,       item_flag_none)//
END_LISTICON_MENU( menuSetmode, menuListArea )

/********** Scene list icon menu start of xsf change 2002.08.13**********************/
//2004-03-10 Sunny modified
#if 0
 BEGIN_TITLEICON_MENU( menuScene )
  LISTICON_SUB_MENU_ITEM( &scene_Attr[0],	TxtNormals, menuSetmode,  scenemode_normal, item_flag_none ),//ͨ
  LISTICON_SUB_MENU_ITEM( &scene_Attr[0],		TxtOut,		menuSetmode,  scenemode_out, item_flag_none ),	 //⻷
  LISTICON_SUB_MENU_ITEM( &scene_Attr[0],	TxtMeeting, menuSetmode,  scenemode_meeting, item_flag_none ),//黷
  LISTICON_SUB_MENU_ITEM( &scene_Attr[0],	TxtIncar,   menuSetmode,  scenemode_incar, item_flag_none ), //ڻ
  MENU_LISTICON_ITEM(	  &scene_Attr[0],	TxtSilent,  scenemode_mute,     item_flag_none )			 //
END_TITLEICON_MENU( menuScene, menuListArea,sceneTitleicon )
#endif

BEGIN_TITLEICON_MENU( menuScene )
  LISTICON_SUB_MENU_ITEM( &colist,	TxtNormals, menuSetmode,  scenemode_normal, item_flag_none ),//ͨ
  LISTICON_SUB_MENU_ITEM( &colist,	TxtOut,		menuSetmode,  scenemode_out, item_flag_none ),	 //⻷
  LISTICON_SUB_MENU_ITEM( &colist,	TxtMeeting, menuSetmode,  scenemode_meeting, item_flag_none ),//黷
  LISTICON_SUB_MENU_ITEM( &colist,	TxtIncar,   menuSetmode,  scenemode_incar, item_flag_none ), //ڻ
  MENU_LISTICON_ITEM(	  &colist,	TxtSilent,  scenemode_mute,     item_flag_none )			 //
END_TITLEICON_MENU( menuScene, menuListArea,sceneTitleicon )


/********** end of xsf change 2002.08.13**********************/

//Sub-Menu of Network Selection
BEGIN_MENU( menuregmode )
    MENU_ICON_ITEM( &situation3Icon,TxtAutomatic,  (MenuFunc)network_set_mode_auto,       networkMenuIcon_check ),
    MENU_ICON_ITEM( &situation3Icon,TxtManual,  (MenuFunc)network_set_mode_man,       networkMenuIcon_check)
END_MENU( menuregmode, menuListArea )

BEGIN_MENU( menunmband )
    MENU_ITEM( TxtDualBand,(MenuFunc)SetDualBand, item_flag_none ),  // Dual band  
    MENU_ITEM( TxtGSM900, (MenuFunc)SetGSM900,  item_flag_none ),	// Lock GSM900   
    MENU_ITEM( TxtDCS1800,   (MenuFunc)SetDCS1800,   item_flag_none )	//Lock DCS1800
END_MENU( menunmband, menuListArea )
//--------copy from 1331 by ganchh 2002/8/25------------
BEGIN_MENU(menuBandSelect)
  MENU_LISTICON_ITEM( &colist,TxtStatus,          mmi_band_radio_mode_info,              item_flag_none),
  MENU_LISTICON_ITEM( &colist,TxtAutomatic,      mmi_band_radio_mode_change_auto,       item_flag_none),
  MENU_LISTICON_ITEM( &colist,TxtManual,        mmi_band_radio_mode_change_manual,     item_flag_none )
END_MENU(menuBandSelect, menuListArea)
//-----------end of copy by ganchh--------------------  

BEGIN_MENU( menuNetworkSet )
    MENU_LISTICON_ITEM( &colist,  TxtPLMNInfo,(MenuFunc)ShowHomePlmn, item_flag_none ),

    MENU_LISTICON_ITEM( &colist, TxtPLMNReselect, (MenuFunc)networkreselect,  item_flag_none )  //Request the available PLMN list
    //SUB_LISTICON_MENU(&colist,  TxtRegMode,   menuregmode,   item_flag_none ),  //xsf 2003.04.14
   // SUB_MENU(TxtLockBand,  menunmband,       item_flag_none),
    //SUB_LISTICON_MENU(&colist, TxtLockBand, menuBandSelect,item_flag_none)   //xsf 2003.04.14 //added by ganchunhui from 1331
END_MENU( menuNetworkSet, menuListArea )

/*BEGIN_MENU( menuNetworkSet )
    MENU_ITEM( TxtAutomatic,(MenuFunc)network_set_mode_auto, item_flag_none ),
    MENU_ITEM( TxtManual, (MenuFunc)network_set_mode_man,  item_flag_none ),
    MENU_ITEM( TxtList,   (MenuFunc)network_pref_list,   item_flag_none )
END_MENU( menuNetworkSet, menuListArea )*/


//Sub-Menu of Hide ID
//BEGIN_MENU( menuHideIDSet )
    //MENU_ITEM( TxtCheckStatus,  servicesCheckCLIR   ,    item_flag_none ),
    //MENU_ITEM( TxtActivate   ,  servicesActivateCLIR  ,    item_flag_none ),
    //MENU_ITEM( TxtDeactivate ,  servicesDeactivateCLIR  ,  item_flag_none )
//END_MENU( menuHideIDSet, menuListArea )
BEGIN_LISTICON_MENU( menuHideIDSet )
	MENU_LISTICON_ITEM( &situationIcon, TxtActivate,  servicesActivateCLIR,  hideid_check ), //wufei 0827
	MENU_LISTICON_ITEM( &situationIcon, TxtDeactivate, servicesDeactivateCLIR, hideid_check )
END_LISTICON_MENU( menuHideIDSet, menuListArea )



//Sub-Menu of Call Waiting
//BEGIN_MENU( menuCallWaitingSet )
    //MENU_ITEM( TxtCheckStatus,  servicesCheckCWaiting,     item_flag_none ),
    //MENU_ITEM( TxtActivate,   servicesActivateCWaiting,  item_flag_none ),
    //MENU_ITEM( TxtDeactivate, servicesDeactivateCWaiting,  item_flag_none )
//END_MENU( menuCallWaitingSet, menuListArea )
BEGIN_LISTICON_MENU( menuCallWaitingSet )
    MENU_LISTICON_ITEM( &colist, TxtCheckStatus,  servicesCheckCWaiting,     item_flag_none ),
	MENU_LISTICON_ITEM( &colist, TxtActivate,  servicesActivateCWaiting,  item_flag_none ), //wufei 0827
	MENU_LISTICON_ITEM( &colist, TxtDeactivate, servicesDeactivateCWaiting, item_flag_none )
END_LISTICON_MENU( menuCallWaitingSet, menuListArea )     

//Sub-Menu
BEGIN_MENU( menuCallBarring)
    MENU_ITEM ( TxtCheckStatus, servicesCallBarringCheck,  item_flag_none ),
    MENU_ITEM ( TxtSetBar,    servicesCallBarringActivate, item_flag_none ),
    MENU_ITEM ( TxtCancel,  servicesCallBarringDeactivate ,item_flag_none )
END_MENU( menuCallBarring, menuListArea )


//Sub-Menu of Call Barring
BEGIN_MENU( menuBarringSet )
    MENU_ITEM_SUB_MENU ( TxtOutgoing,   menuCallBarring,   servicesBarringAllOutgoing,item_flag_none  ),
    MENU_ITEM_SUB_MENU ( TxtInterCalls,   menuCallBarring,   servicesBarringInternational,item_flag_none  ),
    MENU_ITEM_SUB_MENU ( TxtInterHome,    menuCallBarring,   servicesBarringInternationalHome,item_flag_none  ),
    MENU_ITEM_SUB_MENU ( TxtIncomingCall, menuCallBarring,   servicesBarringAllIncoming ,item_flag_none ),
    MENU_ITEM_SUB_MENU ( TxtWhenRoaming,  menuCallBarring,   servicesBarringIncomingRoaming,item_flag_none  ),
    MENU_ITEM( TxtCancelAllBars,  servicesCallBarringCancelAll,  item_flag_none ),
    MENU_ITEM( TxtChangePassword, enterNewCBPassword,  item_flag_none )
END_MENU( menuBarringSet, menuListArea )
#ifdef MMI_GPRS_ENABLED

// sbh 25/1/02.
BEGIN_MENU( menuSMSService )
    MENU_ITEM( TxtGPRS,       GPRSselectSms_set,     item_flag_none  ),
    MENU_ITEM( TxtCSD,        GPRSselectSms_set,     item_flag_none  ),
    MENU_ITEM( TxtGPRSPreferred,  GPRSselectSms_set,     item_flag_none  ),
    MENU_ITEM( TxtCSDPreferred,   GPRSselectSms_set,     item_flag_none  )
END_MENU( menuSMSService , menuListArea )

/* sbh...24/1/02.  Simplify data counter menus.

BEGIN_MENU( menuTotalCallCount )
    MENU_ITEM ( TxtIncomingData,    showTotalIncDataCount,   item_flag_none  ),
    MENU_ITEM ( TxtOutgoingData,    showTotalOutDataCount,   item_flag_none  )
END_MENU( menuTotalCallCount , menuListArea )

BEGIN_MENU( menuLastCallCount )
    MENU_ITEM ( TxtIncomingData,    GPRSIncomingDataCount,   item_flag_none  ),
    MENU_ITEM ( TxtOutgoingData,    GPRSOutgoingDataCount,   item_flag_none  )
END_MENU( menuLastCallCount, menuListArea )

BEGIN_MENU( menuResetCount )
    MENU_ITEM ( TxtIncomingData,    resetIncDataCount,   item_flag_none  ),
    MENU_ITEM ( TxtOutgoingData,    resetOutDataCount,   item_flag_none  )
END_MENU( menuResetCount, menuListArea )

BEGIN_MENU( menuShowDataCounter )
    MENU_ITEM ( TxtOn,    showCounter,   item_flag_none  ),
    MENU_ITEM ( TxtOff, dontShowCounter,   item_flag_none  )
END_MENU( menuShowDataCounter, menuListArea )
...sbh */

//BEGIN_MENU( menuDataCount )//WUFEI MODIFY
/* sbh...24/1/02. Simplify data counter menus.
    SUB_MENU ( TxtLastCall,   menuLastCallCount,   item_flag_none  ),
    SUB_MENU ( TxtTotalCount,   menuTotalCallCount,  item_flag_none  ),
    SUB_MENU ( TxtResetCount,   menuResetCount,   item_flag_none  ),
    SUB_MENU ( TxtDataCounter,  menuShowDataCounter,  item_flag_none )
...sbh */

//    MENU_ITEM ( TxtIncomingData,    GPRSIncomingDataCount,   item_flag_none  ),//WUFEI MODIFY
//    MENU_ITEM ( TxtOutgoingData,    GPRSOutgoingDataCount,   item_flag_none  )//WUFEI MODIFY
//END_MENU( menuDataCount, menuListArea )//WUFEI MODIFY
/*
BEGIN_MENU( menuQoS )
    MENU_ITEM ( TxtHigh,    setQosHigh,  item_flag_none  ),
    MENU_ITEM ( TxtNormal,    setQosNormal,  item_flag_none  ),
    MENU_ITEM ( TxtLow,     setQosLow,   item_flag_none  )
END_MENU( menuQoS, menuListArea )

BEGIN_MENU( menuClassCConnection )
    MENU_ITEM ( TxtVoice,   setClassCVoice,  item_flag_none  ),
    MENU_ITEM ( TxtData,    setClassCData,   item_flag_none  )
END_MENU( menuClassCConnection, menuListArea )

BEGIN_MENU( menuGPRSConnection )
    MENU_ITEM( TxtClassB, setClassBConnection,   item_flag_none ),
    SUB_MENU ( TxtClassC, menuClassCConnection, item_flag_none  )
END_MENU( menuGPRSConnection, menuListArea )

BEGIN_MENU( menuConnectionType )
    MENU_ITEM( TxtCSD,  csdConnection,   item_flag_none ),
    SUB_MENU ( TxtGPRS, menuGPRSConnection, item_flag_none  )
END_MENU( menuConnectionType, menuListArea )

BEGIN_MENU( menuCompression )
    MENU_ITEM( TxtStatus, GPRSCompressionStatus,   item_flag_none ),
    MENU_ITEM( TxtOn,   GPRSCompressionOn,  item_flag_none  ),
    MENU_ITEM( TxtOff,    GPRSCompressionOff, item_flag_none  )
END_MENU( menuCompression, menuListArea )
*/

//BEGIN_MENU(menuLineSelect)
  //MENU_ITEM(TxtStatus,      cphs_als_status,      item_flag_none),
  //MENU_ITEM(TxtLine1,       cphs_line1_select,      item_flag_none ),
  //MENU_ITEM(TxtLine2,       cphs_line2_select,      item_flag_none )
//END_MENU(menuLineSelect, menuListArea)
BEGIN_LISTICON_MENU( menuLineSelect )//wufei 0827
    MENU_LISTICON_ITEM(&colist, TxtStatus,      cphs_als_status,      item_flag_none),
	//MENU_LISTICON_ITEM( &situationIcon, TxtLine1,  cphs_line1_select,  line_check ), //wufei 0827
	//MENU_LISTICON_ITEM( &situationIcon, TxtLine2, cphs_line2_select, line_check )
	MENU_LISTICON_ITEM( &colist, TxtLine1,  cphs_line1_select,  item_flag_none ), //wufei 0827
	MENU_LISTICON_ITEM( &colist, TxtLine2, cphs_line2_select, item_flag_none )
END_LISTICON_MENU( menuLineSelect, menuListArea )
/*******************zy for Gprs Attachmode***************************/
BEGIN_LISTICON_MENU( MenuGprsMode )
  MENU_LISTICON_ITEM(&situationIcon,TxtGPRSAuto,     GPRSAttachMode,         GprsAttachMode_check ),/*zy 2003-03-04*/
  MENU_LISTICON_ITEM(&situationIcon, TxtGPRSNeed,     GPRSAttachMode,         GprsAttachMode_check ),/*zy 2003-03-04*/
END_LISTICON_MENU( MenuGprsMode,     menuListArea )
//Sub-Menu of Data Settings
//BEGIN_LISTICON_MENU( menuDataSettings )
//  MENU_LISTICON_ITEM(&colist,TxtAttach,     GPRSAttach,         item_flag_none ),
//  MENU_LISTICON_ITEM(&colist, TxtDetach,     GPRSDetach,         item_flag_none ),
/*  MENU_ITEM( TxtDefineContext,  GPRSContextDefine,      item_flag_none ),
  MENU_ITEM( TxtActivateContext,  GPRSActivate,       item_flag_none ),
  MENU_ITEM( TxtDeactivateContext,   GPRSDeactivate,      item_flag_none ), */
//    SUB_MENU ( TxtDataCount,    menuDataCount,        item_flag_none ),//WUFEI MODIFY
/*    SUB_MENU ( TxtQoS,        menuQoS,          item_flag_none ), */
/*    SUB_MENU ( TxtConnectionType, menuConnectionType,     item_flag_none ), */
/*    MENU_ITEM( TxtIPAddress,    showIPAddress,        item_flag_none ), */
/*    SUB_MENU ( TxtV42bis,     menuCompression,      item_flag_none ) */
//  SUB_LISTICON_MENU  (&situation3Icon, TxtAttachMode,     MenuGprsMode,    GprsAttachMode_check),  
 // MENU_LISTICON_ITEM (&colist, TxtSMS,       GPRSselectSms,        item_flag_none ),
//END_LISTICON_MENU( menuDataSettings,     menuListArea )zy move 2003-03-04 change attachmode
#endif
// Menu of Settings
#ifdef _TESTING__
BEGIN_MENU(menuCphsTesting)
	MENU_ITEM (TxtRead, 			Cphs_reading_test, 			item_flag_none),
	MENU_ITEM(TxtWrite, 			Cphs_writing_test, 			item_flag_none)
END_MENU(menuCphsTesting, menuListArea)
#endif
/*
BEGIN_MENU( menuSet )
#ifdef _TESTING__
	SUB_MENU(TxtExtra, 				menuCphsTesting, 			item_flag_none),
#endif
    SUB_MENU( TxtLanguages,       menuLanguage,               item_flag_none ),
  MENU_ITEM( TxtCallBarringAll, requestCBPassword,      item_flag_none ),
    SUB_MENU( TxtCallWaiting,   menuCallWaitingSet,       item_flag_none ),
    SUB_MENU( TxtHideID,      menuHideIDSet,          item_flag_none ),
    SUB_MENU( TxtNetworkSel,    menuNetworkSet,         item_flag_none ),
    SUB_MENU( TxtSecurity,    menuSecurity,         item_flag_none ), //xsf add 2002.08.08    
    #ifdef MMI_GPRS_ENABLED
    SUB_MENU( TxtGPRS,        menuDataSettings,     item_flag_none ),
    #endif
  SUB_MENU( TxtTones,       menuTonesSet,         item_flag_none ),
    SUB_MENU( TxtClock,       menuTypclock,       item_flag_none ),
    SUB_MENU( TxtAutoredial,    menuAutoRedialSet,      item_flag_none ),
  SUB_MENU( TxtAutoAnswer,    menuAutoAnswerSet,      item_flag_none ),
    SUB_MENU( TxtAnyKeyAnswer,    menuAnyKeySet,        item_flag_none ),
    #ifdef MMI_GPRS_ENABLED
    SUB_MENU( TxtSelectLine,      menuLineSelect,       item_flag_none),
    #endif
  MENU_ITEM( TxtFactoryReset,   factoryReset,         item_flag_none )
END_MENU( menuSet, menuListArea )
*/
//----------------------------------WUFEI Add-----------------------------------------------
//Sub-Menu of Next Call
//BEGIN_MENU( menuNextCall )
	//MENU_ITEM( TxtVoice, settingsVoiceCall,	item_flag_none ),
	//MENU_ITEM( TxtData,  settingsDataCall,	item_flag_none ),
	//MENU_ITEM( TxtFax,   settingsFaxCall,	item_flag_none )
	BEGIN_LISTICON_MENU( menuNextCall ) //wufei 0827
		MENU_LISTICON_ITEM( &situationIcon,  TxtVoice,    settingsVoiceCall,    nextcall_check ),
		MENU_LISTICON_ITEM( &situationIcon,  TxtData,     settingsDataCall,    nextcall_check),
		MENU_LISTICON_ITEM( &situationIcon,  TxtFax,      settingsFaxCall,     nextcall_check)
	END_LISTICON_MENU( menuNextCall, menuListArea )
//END_MENU( menuNextCall, menuListArea )



//Sub-Menu of Call Minute Hints
//BEGIN_MENU( menuMinuteHint )
	//MENU_ITEM( TxtCheckStatus, settingsMinuteFlagCheck,    item_flag_none ),
	//MENU_ITEM( TxtActivate,     settingsCallMinuteFlagOn,    item_flag_none ),
	//MENU_ITEM( TxtDeactivate,   settingsCallMinuteFlagOff,   item_flag_none )
BEGIN_LISTICON_MENU( menuMinuteHint ) //wufei 0827
	MENU_LISTICON_ITEM( &situationIcon, TxtActivate,  settingsCallMinuteFlagOn,  minutehint_check ),
	MENU_LISTICON_ITEM( &situationIcon, TxtDeactivate, settingsCallMinuteFlagOff, minutehint_check )
END_LISTICON_MENU( menuMinuteHint, menuListArea )
//END_MENU( menuMinuteHint, menuListArea )
/************added by ganchunhui  begin************************/
//#ifdef FIELD_TEST_MODE_ENABLED
#if 0
BEGIN_LISTICON_MENU( menuEarPhoneSet ) //ganchh 2003/1/1
	MENU_LISTICON_ITEM( &situationIcon, TxtActivate,  settingsEarPhoneSetFlagOn,   EarPhoneMode_CheckActive ),
	MENU_LISTICON_ITEM( &situationIcon, TxtDeactivate,settingsEarPhoneSetFlagOff,  EarPhoneMode_CheckDeActive )
END_LISTICON_MENU( menuEarPhoneSet, menuListArea )
#endif
/***********end  added by ganchunhui***************************/
/*zy move hallconnect control here in call setting menu 2003-02-12*/

//sunsj030918 s
/*
BEGIN_LISTICON_MENU(menuHallconnect)
    MENU_LISTICON_ITEM( &situationIcon, TxtActivate,  Hallconnect,  Hallconnect_check ),
    MENU_LISTICON_ITEM( &situationIcon, TxtDeactivate, Hallconnect, Hallconnect_check )
END_LISTICON_MENU( menuHallconnect, menuListArea )//Sub-Menu of Call Settings
*/
//sunsj030918 e

/*end of zy move hallconnect control here in call setting menu 2003-02-12*/
/**/
BEGIN_MENU( menuCallSettings )
	//MENU_LISTICON_ITEM( &colist,TxtCallBarringAll, requestCBPassword,  item_flag_none ),  //hu binhao 2002-12-26
	SUB_LISTICON_MENU( &colist, TxtCallDivert,	   menuDivertNoFaxData,	item_flag_none ),	//ת
	SUB_LISTICON_MENU( &colist, TxtAnswer,		   menuAnswer,			item_flag_none ),
	SUB_LISTICON_MENU( &colist, TxtCallWaiting,   menuCallWaitingSet,  item_flag_none ),	//sunsj030918
	SUB_LISTICON_MENU( &colist, TxtAutoredial,    menuAutoRedialSet,   item_flag_none ),
	SUB_LISTICON_MENU( &colist, TxtAutoAnswer,    menuAutoAnswerSet,   item_flag_none ),//wufei 0827
	SUB_LISTICON_MENU( &colist, TxtHideID,        menuHideIDSet,       item_flag_none ),	//sunsj030918
	//2004-03-30 Sunny remove
	//SUB_LISTICON_MENU( &colist, TxtHallOnConnect, menuHallconnect,     SetSituation_check ),	//sunsj030918
#ifdef MMI_GPRS_ENABLED
	SUB_LISTICON_MENU( &colist, TxtSelectLine,   menuLineSelect,      item_flag_none ),	//·л
#endif
	SUB_LISTICON_MENU( &colist, TxtMinuteHint,   menuMinuteHint,    item_flag_none ),
//#ifdef FIELD_TEST_MODE_ENABLED  
#if 0
	SUB_LISTICON_MENU( &colist, TxtEarPhoneSet,   menuEarPhoneSet,    item_flag_none ),
#endif
	//SUB_LISTICON_MENU( &colist, TxtNextCall,    menuNextCall,    item_flag_none ),  //hu binhao 2002-12-26
	//SUB_MENU( TxtCUGNumber, menuCUGNumber, item_flag_none ) //(suppressed for buildcugmenu func call)
	// hu binhao 2002-12-16 for 6113 
	//MENU_LISTICON_ITEM( &colist,TxtCUGNumber, servicesDoCUGSetting, item_flag_none ) //for test 
END_MENU( menuCallSettings, menuListArea)
//----------------------------end of WUFEI Add-------------------------------------------
/*........................................................zy changed for settingmenu08/12/02......................................*/

/* glowing: ˵"ֻ" */
BEGIN_LISTICON_MENU( menuDsplSet )
	SUB_LISTICON_MENU( &colist,          TxtLanguages,     menuLanguage,               item_flag_none ),   //sunsj030918
/*2003/12/01,talcon comment following line*/
    //SUB_LISTICON_MENU( &colist,          TxtTheme,      menuTheme,          item_flag_none ),
	/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    //SUB_LISTICON_MENU( situation4Icon, TxtBackgroud, menuBackground,     SetSituation_check ),
	SUB_LISTICON_MENU(&colist, TxtBackgroud, Background, item_flag_none),
//    SUB_MENU( TxtCallWaiting,   menuCallWaitingSet,       item_flag_none ),
    SUB_LISTICON_MENU( &colist,          TxtOnOffAnimation, menuOnOffAnimation,          item_flag_none ),
	MENU_LISTICON_ITEM( &colist,         TxtAdjustContrast, settingBacklightContrast, item_flag_none ),	//Աȶȵ
//    SUB_LISTICON_MENU(                  TxtBackLight,      menuBackLight,          item_flag_none ),
   // SUB_MENU( TxtBmpAlbum,              menuBmpAlbum,          item_flag_none ),//zy move 09/18
/*2003/11/06,talcon change "&situation3Icon" to  "situation4Icon" */
    SUB_LISTICON_MENU( situation4Icon, TxtGreetingWord,      menuGreetingWord,          SetSituation_check ),
	SUB_LISTICON_MENU( &colist,          TxtAutopower,      autopower,     item_flag_none), 
	SUB_LISTICON_MENU( &colist,          TxtSwitchLED,      LEDSwitch,     item_flag_none),		/* 2004/04/10 sunsj add */	
 END_LISTICON_MENU( menuDsplSet, menuListArea ) 
 

BEGIN_LISTICON_MENU(menuLedSetting)
	MENU_LISTICON_ITEM( &situationIcon, TxtActivate,  LedSetting,  LED_check ),
	MENU_LISTICON_ITEM( &situationIcon, TxtDeactivate, LedSetting, LED_check )
END_LISTICON_MENU( menuLedSetting, menuListArea )


BEGIN_LISTICON_MENU( menuSet )
	//MENU_ITEM( TxtCallBarringAll, requestCBPassword,      item_flag_none ),
	//SUB_LISTICON_MENU( &colist, TxtDsplSetting,    menuDsplSet,         item_flag_none ),	//sunsj030918
#ifdef MMI_GPRS_ENABLED
	//SUB_LISTICON_MENU( &colist, TxtAttachMode,        MenuGprsMode,     item_flag_none ),	//sunsj030918
#endif
	//SUB_MENU( TxtTones,       menuTonesSet,         item_flag_none ),
	//SUB_MENU( TxtClock,       menuTypclock,       item_flag_none ),
	//SUB_MENU( TxtAutoredial,    menuAutoRedialSet,      item_flag_none ),
	//SUB_MENU( TxtAutoAnswer,    menuAutoAnswerSet,      item_flag_none ),
	//SUB_MENU( TxtAnyKeyAnswer,    menuAnyKeySet,        item_flag_none ),
	//SUB_LISTICON_MENU( &colist, TxtLanguages,       menuLanguage,               item_flag_none ),	//sunsj030918
	SUB_LISTICON_MENU( &situation3Icon, TxtLedSetting,       menuLedSetting,       SetSituation_check ),    //sunsj030918
	//#ifdef MMI_GPRS_ENABLED
	//SUB_MENU( TxtSelectLine,      menuLineSelect,       item_flag_none),
	//#endif
	//MENU_LISTICON_ITEM(&colist, TxtFactoryReset,   factoryReset,         item_flag_none )	//sunsj030918
END_LISTICON_MENU( menuSet, menuListArea )
/*---------------------------------------------------------------------------*/
/* glowing:   TxtDsplSetting Ϊ TxtMobileSettings 2003-10-28 */
BEGIN_TITLEICON_MENU( menuSets )
	SUB_LISTICON_MENU(&colist,  TxtAlarm,         menuTypAlarm,       item_flag_none ),
	SUB_LISTICON_MENU(&colist,  TxtTimeDate,      menuTypTimeDate,    item_flag_none ),
	//SUB_LISTICON_MENU( &colist, TxtDsplSetting,   menuDsplSet,         item_flag_none ),   //sunsj030918
	SUB_LISTICON_MENU( &colist,TxtMobileSettings, menuDsplSet,          item_flag_none ),	//sunsj030918
	SUB_LISTICON_MENU( &colist, TxtCallSettings,  menuCallSettings,   item_flag_none ), //sunsj030918
	SUB_LISTICON_MENU( &colist, TxtNetworkSel,    menuNetworkSet,         item_flag_none ),
	SUB_LISTICON_MENU( &colist, TxtSecurity,      menuSecurity,     item_flag_none ),//sunsj030918
	MENU_LISTICON_ITEM(&colist, TxtFactoryReset,   factoryReset,         item_flag_none )   //sunsj030918
END_TITLEICON_MENU( menuSets, menuListArea,settingTitleicon )

// add for special mode xzy
BEGIN_MENU(menuProductTest)
    MENU_LISTICON_ITEM( &colist,TxtLCDDisplay,      LCDDisplayTestStart,   item_flag_none),//
    MENU_LISTICON_ITEM( &colist,TxtLEDBacklight,     LEDBacklightTestStart,   item_flag_none),//
    MENU_LISTICON_ITEM( &colist,TxtMelodyandVibrator,     MelodyandVibratorTestStart,   item_flag_none),//
    MENU_LISTICON_ITEM( &colist,TxtKeyPressTest,     KeyPressTest,   item_flag_none)//
END_MENU(menuProductTest,  menuListArea)
    
/*BEGIN_MENU( menuSpecialMode )
    MENU_LISTICON_ITEM( &colist,TxtTestCommand,      TestCommand,   item_flag_none),//汾
    MENU_LISTICON_ITEM( &colist,TxtSoftwareVersion,      ShowVersion,   item_flag_none),//汾
    MENU_LISTICON_ITEM( &colist,TxtLayeronePara,      LayeronePara,   item_flag_none),//ģʽ1
    MENU_LISTICON_ITEM( &colist,TxtLayeroneParaTwo,      LayeroneParaTwoStart,   item_flag_none),//ģʽ2
    MENU_LISTICON_ITEM( &colist,TxtLayeroneParaThree,      LayeroneParaThreeStart,   item_flag_none),//ģʽ2
    MENU_LISTICON_ITEM( &colist,TxtSpkMic,      SpkMicStart,   item_flag_none),//MIC AND SPK STATUS
    MENU_LISTICON_ITEM( &colist,TxtMemFlashRtc,      MemFlashRtcStart,   item_flag_none),//MEM , FLASH AND RTC STATUS
    SUB_LISTICON_MENU( &colist,TxtProductTest,      menuProductTest,   item_flag_none)//
END_MENU( menuSpecialMode, menuListArea )*//*2003/12/1, wangyan delete*/

/* 2004/04/28 sunsj modify */
BEGIN_MENU( menuSpecialMode )
    MENU_LISTICON_ITEM( &colist,TxtSoftwareVersion,      ShowVersion,   item_flag_none),//汾
	//MENU_LISTICON_ITEM( &colist,TxtLayeronePara,      LayeronePara,   item_flag_none),	/* 2004/05/08 sunsj modify */
	//MENU_LISTICON_ITEM( &colist,TxtLayeroneParaTwo,      LayeroneParaTwoStart,   item_flag_none),	/* 2004/05/08 sunsj modify */
	//MENU_LISTICON_ITEM( &colist,TxtLayeroneParaThree,      LayeroneParaThreeStart,   item_flag_none),	/* 2004/05/08 sunsj modify */
	//MENU_LISTICON_ITEM( &colist,TxtSpkMic,      SpkMicStart,   item_flag_none),
	//MENU_LISTICON_ITEM( &colist,TxtMemFlashRtc,      MemFlashRtcStart,   item_flag_none),
	//SUB_LISTICON_MENU( &colist,TxtProductTest,      menuProductTest,   item_flag_none)
END_MENU( menuSpecialMode, menuListArea )
// end of special mode xzy
/*.....................................................end of zy change08/12/02................................................................*/
/* Main system menu, keep this here until we get the real one implemented
*/
/**********************zy change mainmenu*********************/
//int menuWapNone( MfwMnu* m, MfwMnuItem* i)
//{  
//return 1;
//}

#if 0    
BEGIN_ICON_MENU( menuMainMenu )    
	#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    SUB_ICON_MENU ( &mainIconMessages,TxtMessages,    menuMsg,    In_Sms_Menu),//hxl changed for indicate back from qq menu,2003-2-28
	#else
    SUB_ICON_MENU ( &mainIconMessages,TxtMessages,    menuMsg,          item_flag_none ),
	#endif
    SUB_ICON_MENU ( &mainIconRecentCalls,TxtRecentCalls, menuRecent,        item_flag_none ), 
    SUB_ICON_MENU ( &mainIconPhonebook,TxtGame,   Game,           item_flag_none ),    
    /*
    #ifdef CFFaxDataFlag //hu binhao 2002-2-11
		SUB_ICON_MENU ( &mainIconCallDivert,TxtDateTime,  menuDateTime,       item_flag_none ),   //sunsj030918
    #else
   	    SUB_ICON_MENU ( &mainIconCallDivert,TxtCallDivert,  menuDivert,       item_flag_none ),
    #endif
    */
    //SUB_ICON_MENU ( &mainIconSecurity,TxtSecurity,    menuSecurity,     item_flag_none ),
    SUB_ICON_MENU ( &mainIconSecurity,TxtScene,   menuScene,                item_flag_none ),
    SUB_ICON_MENU ( &mainIconCalculator,TxtToolkit, menuToolkit,    item_flag_none ),
    SUB_ICON_MENU ( &mainIconSettings,TxtSettings,    menuSets,          item_flag_none ),
#ifdef MMI_WAP_ENABLED
    MENU_ICON_ITEM ( &mainIconWAP,TxtWAP, AUI_menu,   item_flag_none ),
#endif
    MENU_ICON_ITEM( &mainIconSimToolkit,TxtSimToolkit,  menuSimItemCallback,     sim_toolkit_check )
END_ICON_MENU( menuMainMenu, menuViewListArea, mainBackgroundIcn )
#endif

/* 2004/06 sunsj modify for icon manage */
extern const MfwIcnAttr menuMainFuncIcn1[];
extern const MfwIcnAttr menuMainFuncIcn2[];
extern const MfwIcnAttr menuMainFuncIcn3[];
extern const MfwIcnAttr menuMainFuncIcn4[];
extern const MfwIcnAttr menuMainFuncIcn5[];
extern const MfwIcnAttr menuMainFuncIcn6[];
extern const MfwIcnAttr menuMainFuncIcn7[];
extern const MfwIcnAttr menuMainFuncIcn8[];
extern const MfwIcnAttr menuMainFuncIcn9[];
/* 2004/05/18 sunsj modify order of mainmenu */
BEGIN_ICON_MENU( menuMainMenu )    
SUB_ICON_MENU ( menuMainFuncIcn1,TxtMessages,    menuMsg,          item_flag_none ),
SUB_ICON_MENU ( menuMainFuncIcn2,TxtRecentCalls, menuRecent,        item_flag_none ), 
SUB_ICON_MENU ( menuMainFuncIcn3,TxtScene,   menuScene,                item_flag_none ),
SUB_ICON_MENU ( menuMainFuncIcn4,TxtSettings,    menuSets,          item_flag_none ),
//SUB_ICON_MENU ( &menuMainFuncIcn4,TxtCallDivert,  menuDivert,       item_flag_none ),
SUB_ICON_MENU ( menuMainFuncIcn5,TxtToolkit, menuToolkit,    item_flag_none ),
SUB_ICON_MENU ( menuMainFuncIcn6,TxtGame,   Game,           item_flag_none ),


#ifdef CAMERA_ENABLED    
SUB_ICON_MENU ( menuMainFuncIcn9,TxtCamera, Camera,item_flag_none),//Knuth
#endif

#ifdef MMI_WAP_ENABLED
    MENU_ICON_ITEM ( menuMainFuncIcn7,TxtWAP, AUI_menu,   item_flag_none ),
#endif
MENU_ICON_ITEM( menuMainFuncIcn8,TxtSimToolkit,  menuSimItemCallback,     sim_toolkit_check )

END_ICON_MENU( menuMainMenu, menuViewListArea )


/******************end of zy change mainmenu*********************/
BEGIN_LISTICON_MENU( menuFunction )  //add for shortcut menu by zhangxp
  MENU_LISTICON_ITEM( &situation3Icon,TxtScene,    QuickFunctionSelected,    FunctionMenu_check ),
  MENU_LISTICON_ITEM( &situation3Icon,TxtSendSms,    QuickFunctionSelected,    FunctionMenu_check ),
  MENU_LISTICON_ITEM( &situation3Icon,TxtReadSms,   QuickFunctionSelected,    FunctionMenu_check ),
  MENU_LISTICON_ITEM( &situation3Icon,TxtMemory,   QuickFunctionSelected,    FunctionMenu_check ),  
  MENU_LISTICON_ITEM( &situation3Icon,TxtMissedCalls,    QuickFunctionSelected,    FunctionMenu_check),
  //2004-03-04 Sunny remove
  //MENU_LISTICON_ITEM( &situation3Icon,TxtRejectCalls,    QuickFunctionSelected,    FunctionMenu_check),
  MENU_LISTICON_ITEM( &situation3Icon,TxtIncomingCalls,    QuickFunctionSelected,    FunctionMenu_check ),  
  MENU_LISTICON_ITEM( &situation3Icon,TxtOutgoingCalls,    QuickFunctionSelected,    FunctionMenu_check ),  
  MENU_LISTICON_ITEM( &situation3Icon,TxtAlarm,    QuickFunctionSelected,   FunctionMenu_check ),
  MENU_LISTICON_ITEM( &situation3Icon,TxtTimer,   QuickFunctionSelected,    FunctionMenu_check ),
  MENU_LISTICON_ITEM( &situation3Icon,TxtStopwatch,   QuickFunctionSelected,    FunctionMenu_check ),
  MENU_LISTICON_ITEM( &situation3Icon,TxtSchedule,    QuickFunctionSelected,   FunctionMenu_check ),
  //2004-04-07 Sunny modify old:MENU_ITEM( TxtDeleteAll,   DeleteAllSelect,   item_flag_none)
  MENU_LISTICON_ITEM( &situation3Icon,TxtDeleteAll,   DeleteAllSelect,   item_flag_none)
END_LISTICON_MENU( menuFunction, menuListArea ) 
BEGIN_LISTICON_MENU( menuSetTime ) //wufei 0827
	MENU_LISTICON_ITEM( &colist, Txt5sec,  NoRplyTime,  item_flag_none ),
	MENU_LISTICON_ITEM( &colist, Txt10sec,  NoRplyTime,  item_flag_none ),
    MENU_LISTICON_ITEM( &colist, Txt15sec,  NoRplyTime,  item_flag_none ),
	MENU_LISTICON_ITEM( &colist, Txt20sec,  NoRplyTime,  item_flag_none ),
	MENU_LISTICON_ITEM( &colist, Txt25sec,  NoRplyTime,  item_flag_none ),  
	MENU_LISTICON_ITEM( &colist, Txt30sec,  NoRplyTime,  item_flag_none )
END_LISTICON_MENU( menuSetTime, menuListArea )

/*******************************************************************************

                           Public Menu Access Routines

*******************************************************************************/
#ifdef MMI_EM_ENABLED	//Robert.Chen added, 2004-08-02
/*MC, SPR1209 return engineering mode menu*/
MfwMnuAttr *EngModeAttributes( void )
{
    return (MfwMnuAttr *) &menuEngMode;
}
#endif

//add for shortcut menu
MfwMnuAttr *menuSetTimeAttributes(void)
{
    return (MfwMnuAttr *) &menuSetTime;
}
MfwMnuAttr *SceneMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuScene;
}
//modify by wangyan 03-09-17
MfwMnuAttr *menuReadMsgAttributes(void)
{
    return (MfwMnuAttr *) &menuReadMsg;
}
//modify by wangyan 03-09-17
MfwMnuAttr *AlarmMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuTypAlarm;
}
MfwMnuAttr *stopwatchMenuAttributes( void )
{
    return (MfwMnuAttr *) &stopwatch;
}
MfwMnuAttr *menuFunctionAttributes(void)
{
   return(MfwMnuAttr *) &menuFunction;
}
//end of adding by zhangxp

// add for special mode xzy
MfwMnuAttr *menuSpecialModeAttributes(void)
{
    return (MfwMnuAttr *) &menuSpecialMode;
}
// end special mode xzy 1230

MfwMnuAttr *bookPhonebookMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuPhbk;
}

MfwMnuAttr *bookPhonebookVoiceMemo(void)
{
    return (MfwMnuAttr *) &bookVoiceMemo;
}

MfwMnuAttr *bookPhonebookVoiceList(void)
{
    return (MfwMnuAttr *) &VoiceList;
}    
MfwMnuAttr *bookPhonebookAdd(void)
{
   return (MfwMnuAttr *)&bookNameAdd;
}

MfwMnuItem *bookPhonebookMenuItems( void )
{
    return (MfwMnuItem *) menuPhbkItems;
}

MfwMnuAttr *bookRepRedOptionsMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuRepRedOptions;
}
MfwMnuItem *bookRepRedOptionsMenuItems( void )
{
    return (MfwMnuItem *) menuRepRedOptionsItems;
}

MfwMnuAttr *bookNameMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuNameOptions;
}

MfwMnuAttr *bookGroupingSettingAttributes( void )
{
    return (MfwMnuAttr *)&menuGrouping;
}

MfwMnuItem *bookNameMenuItems( void )
{
    return (MfwMnuItem *) menuNameOptionsItems;
}

MfwMnuAttr *bookMainMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMainMenu;
}
MfwMnuItem *bookMainMenuItems( void )
{
    return (MfwMnuItem *) menuMainMenuItems;
}
//begin of xsf add 2002.08.19
MfwMnuAttr *bookHostkeyMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuHostKeyOptions;
}
MfwMnuItem *bookHostkeyMenuItems( void )
{
    return (MfwMnuItem *) menuHostKeyOptionsItems;
}
//end of xsf add 2002.08.19

//begin of xsf add 2002.08.23
MfwMnuAttr *bookHostkeyOnOffAttributes( void )
{
    return (MfwMnuAttr *) &menuHostKeySet;
}
//yq add for voicedial
MfwMnuAttr *bookPhonebookPhoneVoiceList(void)
{
    return (MfwMnuAttr *) &PhoneVoiceList; 
}

MfwMnuItem *bookHostkeyOnOffItems( void )
{
    return (MfwMnuItem *) menuHostKeySetItems;
}
//end of xsf add 2002.08.23

MfwMnuAttr *bookCallBarringMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuBarringSet;
}
/*
MfwMnuAttr *calcOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuCalcOptions;
}
MfwMnuItem *calcOptionMenuItems( void )
{
    return (MfwMnuItem *) menuCalcOptionsItems;
}
*/
/*MfwMnuAttr *noteOptionMenuAttributes1( void )
{
    return (MfwMnuAttr*) &menunoteOptions1;
}

MfwMnuAttr *noteOptionMenuAttributes(void)
{
    return (MfwMnuAttr*) &menunoteOptions;
}

MfwMnuAttr *PriorityOptionMenuAttibutes(void)
{
    return (MfwMnuAttr*) &PriorityOptions;
}

MfwMnuAttr *FrequOptionMenuAttibutes(void)
{
    return (MfwMnuAttr*) &FrequOptions;
}*/

MfwMnuAttr *FrequOptionScheMenuAttibutes(void)
{
    return (MfwMnuAttr*) &FrequScheOptions;
}

/*MfwMnuAttr *stopwatchMenuAttributes( void )
{
    return (MfwMnuAttr *) &stopwatch;
}*/

MfwMnuAttr *CountMenuAttributes( void )
{
return(MfwMnuAttr *) &menuCount;
}

/*MfwMnuAttr *DeleterecordMenuAttributes(void)
{
	return(MfwMnuAttr *) &menuDeleteRecord;
}*/

MfwMnuAttr *TypeOptions(void)
{
   return(MfwMnuAttr *) &typemenu;
}

MfwMnuAttr *sche_mnu1Attributes(void)
{
   return(MfwMnuAttr *) &menusche1;
}

MfwMnuAttr *sche_NoAttributes(void)
{
   return(MfwMnuAttr *) &menuNoSche1;
}


MfwMnuAttr *BrowseOptionMenuAttibutes(void)
{
   return(MfwMnuAttr *) &BrowseSche;
}

MfwMnuAttr *DeleteOptions(void)
{
   return(MfwMnuAttr *) &StopwDelete;
}
#ifdef MMI_MELODYGENERATOR
MfwMnuAttr *MelgenOptionMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuMelgenOptions;
}
MfwMnuItem *MelgenOptionMenuItems( void )
{
    return (MfwMnuItem *) menuMelgenOptionsItems;
}
#endif // MMI_MELODYGENERATOR

MfwMnuAttr *ringerVolumeSetting( void )
{
    return (MfwMnuAttr *) &menuSetVolume;
}


#ifdef MMI_WAP_ENABLED

MfwMnuAttr *WAPMenuAttributes(void)
{
  return (MfwMnuAttr *) &menuWAP;
}

MfwMnuItem *WAPMenuItems(void)
{
  return (MfwMnuItem *) menuWAPItems;
}

MfwMnuAttr *WAPBookOptMenuAttributes(void)
{
  return (MfwMnuAttr *) &menuBookmarkOptions;
}

MfwMnuItem *WAPBookOptMenuItems(void)
{
  return (MfwMnuItem *) menuBookmarkOptionsItems;
}

MfwMnuAttr *WAPHistOptMenuAttributes(void)
{
  return (MfwMnuAttr *) &menuHistoryOptions;
}

MfwMnuItem *WAPHistOptMenuItems(void)
{
  return (MfwMnuItem *) menuHistoryOptionsItems;
}

MfwMnuAttr *WAPProfOptionsAttributes(void)
{
  return (MfwMnuAttr *) &menuSetupProfilesOptions;
}

MfwMnuItem *WAPProfOptionsItems(void)
{
  return (MfwMnuItem *) menuSetupProfilesOptionsItems;
}

MfwMnuAttr *WAPGoToAttributes(void)
{
  return (MfwMnuAttr *) &menuGoTo;
}

MfwMnuItem *WAPGoToItems(void)
{
  return (MfwMnuItem *) menuGoToItems;
}

MfwMnuAttr *WAPConnectionTypeAttributes(void)
{
  return (MfwMnuAttr *) &menuWAPConnectionType;
}

MfwMnuItem *WAPConnectionTypeItems(void)
{
	return (MfwMnuItem *) menuWAPConnectionTypeItems;
}

MfwMnuAttr *WAPAccessTypeAttributes(void)
{
  return (MfwMnuAttr *) &menuAccessType;
}

MfwMnuItem *WAPAccessTypeItems(void)
{
  return (MfwMnuItem *) menuAccessTypeItems;
}

MfwMnuAttr *WAPSecurityOptionAttributes(void)
{
  return (MfwMnuAttr *) &menuSecurityOption;
}

MfwMnuItem *WAPSecurityOptionItems(void)
{
  return (MfwMnuItem *) menuSecurityOptionItems;
}

MfwMnuAttr *WAPSaveHistoryAttributes(void)
{
  return (MfwMnuAttr *) &menuSaveHistory;
}

MfwMnuItem *WAPSaveHistoryItems(void)
{
  return (MfwMnuItem *) menuSaveHistoryItems;
}

MfwMnuAttr *WAPScaleImagesAttributes(void)
{
  return (MfwMnuAttr *) &menuScaleImages;
}

MfwMnuItem *WAPScaleImagesItems(void)
{
  return (MfwMnuItem *) menuScaleImagesItems;
}

#endif // WAP

//hxl add for QQ 2002-12-18--------------------------------
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
MfwMnuAttr *QQNVMSelMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuQQNVMListSel;
}

MfwMnuAttr *QQNetSelMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuQQNetListSel;
}

MfwMnuAttr *QQBoxSelMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuQQBoxListSel;
}


MfwMnuAttr *QQSysBoxSelMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuQQSysBoxListSel;
}

MfwMnuAttr *QQFindSelMenuAttributes( void )
{
    return (MfwMnuAttr *) &menuQQFindSel;
}
#endif
//end of hxl add for QQ 2002-12-18------------------------

#ifdef MMI_GPRS_ENABLED

MfwMnuAttr *SMSServiceAttributes(void)
{
  return (MfwMnuAttr *) &menuSMSService;
}

MfwMnuItem *SMSServiceItems(void)
{
  return (MfwMnuItem *) menuSMSServiceItems;
}

#endif //GPRS

/*******************************************************************************

                                Public Routines

*******************************************************************************/

/*******************************************************************************

 $Function:     MmiBookMenuArea

 $Description:  access routine for the local static menu area

 $Returns:    pointer to the menu area

 $Arguments:  none.

*******************************************************************************/

MfwRect MmiBookMenuArea( void )
{
  return menuArea;
}

/*******************************************************************************

 $Function:     MmiBookNamesArea

 $Description:  access routine for the local static names menu area

 $Returns:    pointer to the names menu area

 $Arguments:  none.

*******************************************************************************/

MfwRect MmiBookNamesArea( void )
{
  return menuNamesArea;
}

/*******************************************************************************

 $Function:     MmiBookCallList

 $Description:  access routine for the local static call list buffer

 $Returns:    pointer to the call list buffer

 $Arguments:  index, of the element required

*******************************************************************************/

void *MmiBookCallList( int index )
{
  /* Make sure that the index is reasonable before using it
  */
  if ( index < 0 )
    index = 0;

  if ( index >= NAME_LIST_SIZE )
    index = NAME_LIST_SIZE - 1;

  /* return address of requested element in array
  */
  return &callList[index][0];
}

/*******************************************************************************

 $Function:     MmiBookCallListSize

 $Description:  access routine for the size of the local static call list buffer

 $Returns:    NAME_SCREEN_MAX

 $Arguments:  index, provided for compatibility with call list access routine

*******************************************************************************/

int MmiBookCallListSize( int index )
{
  return NAME_SCREEN_MAX;
}


/*******************************************************************************

 $Function:     MmiBookMenuDetailsList

 $Description:  access routine for the menu details list attribute structure

 $Returns:    address of attribute structure

 $Arguments:  none.

*******************************************************************************/

MfwMnuAttr *MmiBookMenuDetailsList( void )
{
  return &menudetailsList;
}


/*******************************************************************************

 $Function:     MmiBookShowDefault

 $Description:  Default screen update routine, this will be called prior to
        any other screen painting in the phone book. For now we just
        clear the display as a default action.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/

void MmiBookShowDefault( void )
{
    dspl_ClearAll();
}





/*******************************************************************************

 $Function:     MmiBookCurrentText

 $Description:  Returns a handle to the current global text message.

 $Returns:    Returns a handle to the current global text message.

 $Arguments:  None.

*******************************************************************************/

int MmiBookCurrentText( void )
{
    return textMessage;
}

void MmiBookSetCurrentText( int pstr )
{
  textMessage = pstr;
}
/*******************************************************************************

                                End of File

*******************************************************************************/

