#ifndef _MMIBOOKSHARED_
#define _MMIBOOKSHARED_ 1

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiBookShared.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    This module provides definitions of the types and
    constants which are shared across the phone book
    application modules.
   
********************************************************************************
 $History: MmiBookShared.h



*******************************************************************************/



/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

/* The following include files provide the basic type definitions
   required by the phone book application. In order to minimise
   the maintenance of these includes, we will define them all
   here and include this file in each of the public headers. In
   this way any changes are localised to a single module.
*/
#include "p_sim.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_sim.h"
#include "mfw_sat.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_phb.h"
#include "phb.h"
#include "mfw_sys.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_nm.h"
#include "mfw_str.h"
#include "mfw_sms.h"
#include "mfw_ss.h"

#include "dspl.h"


#include "mmiQQSwitch.h" //hxl add for check qq func
#include "MmiDummy.h"
#include "MmiMmi.h"
#include "MmiDialogs.h"
#include "MmiSoftKeys.h"
#include "MmiMain.h"
#include "MmiMenu.h"
#include "MmiPins.h"
#include "MmiCall.h"
#include "MmiIdle.h"



#include "MmiBlkLangDB.h"
#include "MmiResources.h"
#include "mfw_ffs.h"
#include "MmiLists.h"
#include "Mmieditor.h"


#ifndef MFW_EVENT_PASSED
#define MFW_EVENT_PASSED 0
#endif



/*******************************************************************************
                                                                              
                                Shared Definitions
                                                                              
*******************************************************************************/

/* Define standard error reports from the phone book
*/
#define BOOK_FAILURE    (-1)
#define BOOK_SUCCESS    (0)
#define BOOK_WINDOW_KEY (0x00BABE04L)



/* Standard definitions which are shared across the phonebook
   modules
*/
#define MAX_CALL_LISTS			15
#define NAME_SCREEN_MAX			13
#define NAME_LIST_SIZE			3
#define MAX_SEARCHED			3

#define MAX_SEARCH_NAME			3
#define MAX_SEARCH_CALL_LIST	3
//#define EDITOR_SIZE				41 zy move 2003-04-04 no use all is 22
#define STANDARD_EDITOR_SIZE	60

//GW-SPR#762- 40 digit phonebook size.
#ifdef PHONEBOOK_EXTENSION
#define NUMBER_LENGTH			41
#else
#define NUMBER_LENGTH			22	/* 2003/12/29 sunsj modify phone editor size in sms */
#endif
#define MAX_SEARCH_CHAR			8
//#define PHB_UPN					MAX_PHB_TYPE+1
//This definition conflicts with the MFW definition



/* Define a default menu structure
*/




/*******************************************************************************
                                                                              
                        Shared Structure Definitions
                                                                              
*******************************************************************************/
typedef enum
{
  NVMToSIM,
  SIMToNVM
} T_CopyWay;

/* Define the type of searching we can perform, these can be
   on name, number or SIM location
*/
typedef enum
{
    PhbkNone=PhbkDummy,
    PhbkNormal,
    PhbkMainMenu,
    PhbkDone,
    PhbkSearchNormal,
    PhbkDetailsListDone,
    PhbkHostkeyList,   
    PhbkHostkeyOnOffList, 
    PhbkNameEnterNormal,
    PhbkNameEnterIdle,
    PhbkNameEnterSms,
    PhbkNumberEnterNormal,
    PhbkMissedCallsListNormal,
    PhbkReplyListNormal,
    PhbkRepRedOptionsNormal,
    PhbkRedialListNormal,
	PhbkDetailListToIdle,
	PhbkFromSms,
	PhbkFromVoiceMemo,
	PhbkSearchItem,
	PhbkFromGroupingItem,
	PhbkFromDivert,
	PhbkFromShortcutKey,
	PhbkSendAsDTMF,
	PhbkToolkit,  	//for adding menu title in toolkit
	PhbkVoiceList,	//for voicelist
	PhbkWap,		//for wap menu title	
	PhbkNameEnterRecentCall,
	PhbkFromCall
#ifdef QQFUNC
	,Nvm_fri_list,
	Net_fri_list,
	Sys_info_list,
	Chat_info_list,
	find_fri_sel,
	Left_info_list,
	Unread_info_list 
#endif
	,Phbksoftversion /*2003/12/1, wangyan modify*/
#ifdef MMI_EM_ENABLED
	,PhbEmMode		/* Robert.chen 2004-08-03, integrated engineering mode */
#endif
} tBookActionIdentifiers;

typedef enum {
    SEARCH_BY_NAME, 
    SEARCH_BY_NUMBER,
    SEARCH_BY_LOCATION
} tSearchTypes;

typedef enum {
    CREATE_ENTRY,
    MODIFY_EXISTING,
    ADD_FROM_IDLE
} tUpdateTypes;



typedef struct
{
    T_MFW_PHB_ENTRY     entry[MAX_SEARCHED];
    T_MFW_PHB_LIST      list;
    T_MFW_PHB_STATUS    status;
    UBYTE               result;
	UBYTE               selectedName;

	//glowing,2004-04-09, compatible with the new version
	#if TCS20_VER
    SHORT                index;
	#else
	UBYTE               index;
	#endif

    UBYTE				missedCallsOffset;
	int                 mode;
    tSearchTypes        KindOfSearch;
} tMmiPhbData, *pMmiPhbData;

typedef enum
{
  FromSMS,
  FromSearchNumber,
  FromShortCutKey,
  FromShortCutDial,
  FromBrowserMember,
  FromAddMember
} T_EntryMode; //write to Phonebook struct

typedef struct
{
  T_EntryMode   EntryMode;
  
  unsigned char  SearchName[PHB_name_len];
  unsigned char  Select_index;
} T_EntryMenuData;

/* 2003/11/1 sunsj modify homenumber and officenumber's order */
typedef enum
{
  NAME,
  NUMBER,
  HOME,
  OFFICE,
  MEMO,
  OPTION 
} INPUT_MODE;

typedef enum
{
  NoTable,
  GlobalTable,
  SearchTable
} TABLE_TYPE;

typedef enum
{
  TOP,
  BOTTOM
} EDIT_MODE;  

typedef struct
{
	T_MMI_CONTROL		mmi_control;
    T_MFW_HND			win;
    T_MFW_HND          parent_win; 
    T_MFW_HND          kbd;
    int position;
}iconSelect_data;

typedef enum
{
  ICONSELECT_INIT,
  ICONSELECT_EXIT
}iconSelect_type;

//2004/05/25 yhf modify
#if(MAIN_LCD_SIZE==4)
#define GAME_SUBMENU
#endif
typedef enum
{
	smsTitleicon=1,
	reccallTitleicon,
	gameTitleicon,
	//calldivTitleicon,
	sceneTitleicon,
	toolkitTitleicon,
#if(MAIN_LCD_SIZE==3)
	cameraicon,//Knuth
#endif

	settingTitleicon,
	wapTitleicon,
	simtktTitleicon
#ifdef GAME_SUBMENU
	,
	russiaTitleicon,
	boxmanTitleicon,
	snakeTitleicon
#endif
} T_Titleicon;
/*typedef enum
{
	smsTitleicon=1,
	reccallTitleicon,
	gameTitleicon,
	//calldivTitleicon,
	sceneTitleicon,
	toolkitTitleicon,
	settingTitleicon,
	wapTitleicon,
	simtktTitleicon
} T_Titleicon;*/
 
/* Define the basic control record for the phonebook itself,
   this structure will be used by all phonebook application
   modules.
*/
typedef struct T_phbk_data
{
    T_MMI_CONTROL		mmi_control;
    T_MFW_HND			win;

    //internal data    
    T_MFW_HND			search_win;
	T_MFW_HND			root_win;
    T_MFW_HND			menu_main_win;
	T_MFW_HND			calls_list_win;
	T_MFW_HND			menu_options_win;
	T_MFW_HND			menu_options_win_2;	
	T_MFW_HND		    menu_call_options_win;
	T_MFW_HND			menu_call_options_win_2;
	T_MFW_HND			name_details_win;
	
	T_MFW_HND          input_win;
	T_MFW_HND			parent_win;	

	T_MFW_PHB_SELECT   BookType;
	INPUT_MODE         MODE;
	INPUT_MODE         FirstNumber;
	EDIT_MODE          CurrentEdit;
	tBookActionIdentifiers  EntryType;
	TABLE_TYPE          BufferTable;
	int                  BufferIndex;
	char				fromSMS;	
	char				fromDivert;
	tMmiPhbData			current;
    T_MFW_PHB_ENTRY		newEntry;
    T_MFW_UPN_LIST		*upnList;
	struct T_phbk_data	*phbk;
	unsigned char        edt_buf_rename[GroupingName_len];	
    unsigned char        edt_buf_password[10];
    unsigned char	    edt_buf_name[PHB_name_len+5];
	unsigned char	    edt_buf_number[PHB_number_len+3];
	unsigned char        edt_buf_office[PHB_number_len+3];
	unsigned char        edt_buf_home[PHB_number_len+3];
	unsigned char        edt_buf_memo[PHB_memo_len+3];
	unsigned char        edt_buf_foradd[PHB_number_len+3];
    MfwEdtAttr           edt_attr_rename;
    MfwEdtAttr			edt_attr_password;   
	MfwEdtAttr			edt_attr_name;
    MfwEdtAttr			edt_attr_number;
    T_VOID_FUNC			pin2_next;
    struct MfwMnuTag 	 *menu;		//Added for FDN -- MC
	struct MfwMnuItemTag *item;		//Added for FDN -- MC
	tUpdateTypes          UpdateAction;

	T_MFW_HND          choicecopy_win;	
    T_MFW_HND          dynamicmenu_win;
            
	T_MFW_HND          groupingsetting_win;
	T_MFW_HND          groupingicon_win;
	T_MFW_HND          groupingring_win;
	T_MFW_HND          OwnNumberItem_win;
	
	T_MFW_HND          groupingadd_win;
	T_MFW_HND          groupingbrowser_win;	
	T_MFW_HND	         shortcutdial_win;	
	T_MFW_HND          groupingRename_win;	
	T_MFW_HND          OwnNumber_win;            		
	unsigned char deletenumber;
	int                  select_index;	         
	T_MFW_HND          CallPhbk_win;
}  T_phbk;


/* Each window uses a standard message block containing references
   to the keyboards, editors, menues etc.
*/
typedef struct _tInputSpecifics_
{
    int 		text;
    MfwEdtAttr	*edt_attr_input;
    int         left_soft_key;
    int         right_soft_key;
	short		abc;
    void		(* callback)( T_MFW_HND win,UBYTE reason );
} tInputSpecifics, *pInputSpecifics;

typedef struct _tBookStandard_
{
	/* Standard elements which are consistent across all phonebook
	   window control blocks
	*/
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu_tim;
    T_MFW_HND       menu;
	T_MFW_HND       edt;
	T_MFW_HND       edtname;
	T_MFW_HND       edtnumber;
	T_MFW_HND       edthome;
	T_MFW_HND       edtoffice;
	T_MFW_HND       edtmemo;
    T_MFW_HND       parent_win;
    T_MFW_HND       copy_tim;
    T_phbk			*phbk;
    T_VOID_FUNC     Callback;

    /* internal data*/
    UBYTE            status_of_timer; /* use for the keypadlock */
    MfwEdtAttr        attr;
    char             edtBuf[50];
    ListMenuData      *menu_list_data;
    ListMenuData      *menu_list_data2;
	tInputSpecifics     properties;
	T_EDITOR_DATA   editor_data;	
} tBookStandard, *pBookStandard;

/* In order to encapsulate the behaviour of the phonebook in
   it's own terms of reference, we will provide the following
   type definition overrides.
*/
#define tBookStatus			int
#define tBookPtr			void *
#define tBookDialogData		T_DISPLAY_DATA
#define tBookMfwMenu		struct MfwMnuTag
#define tBookMfwMenuItem	struct MfwMnuItemTag
#define tBookMfwHnd			MfwHnd
#define tBookMfwHdr			MfwHdr
#define tBookMfwWin         MfwWin
#define tBookMfwEvent       MfwEvt
#define tBookMfwBook        int
#define tBookPhonebook		T_phbk

#define pBookPhonebook      tBookPhonebook *
#define pBookStandard       tBookStandard *
#define pBookMfwWin         tBookMfwWin *
#define THREE_SECS          0x0BB8             /* 3000 milliseconds.                  */


/* The following definitions are inherited from the Phbk.h header
   and will be adjusted as required to provide the phone book
   functionality.
*/

typedef enum
{
	INPUT_INIT,
	INPUT_NAME,
	INPUT_NUMBER,
	INPUT_HOME,
	INPUT_OFFICE,
	INPUT_MEMO,
	INPUT_LEFT,
	INPUT_RIGHT,
	INPUT_CLEAR,
	INPUT_DESTROY,
	MENU_INIT,
	ADD_CALLBACK,
	DEFAULT_OPTION,
	SEARCH_INPUT,
	SEARCH_INIT,
	SEARCH_DESTROY,
	SEARCH_TOMENU,
	SEARCH_SCROLL_UP,
	SEARCH_SCROLL_DOWN,
	SEARCH_STRING,
	SEARCH_UPDATE,
	Grouping_INIT,
	Grouping_ADDINIT,
	Grouping_BROWSERINIT,
	ShortCut_Item,
	ShortCut_Browser,
	CALL_DETAILS_INIT,
	CALLS_LIST_INIT,
	OwnNumber_INIT,
	OwnNumber_UPDATE,
	OwnNumber_DESTROY,
	PHBK_INIT,
	COPY_INIT,
	PHBK_SEND_NUMBER,
	SMS_PHBK_NUMBER,
	#ifdef QQFUNC
	INPUT_PW,
	#endif
	DIVERT_PHBK_NUMBER  //MZ 26/02/01 definition for set divert.
} tBookMessageEvents;


/*******************************************************************************
                                                                              
                        Define common interface definitions
                                                                              
*******************************************************************************/

/* Define shared macros for the event and dialog handlers. This macro
   definition ensures that all handlers are given the same interface.
*/
#define EVENT_HANDLER( Name ) \
static int Name( tBookMfwEvent Event, tBookMfwWin *Window )

#define DIALOG_FUNCTION( Name ) \
static void Name( tBookMfwHnd win, USHORT event, SHORT value, void *parameter )




/*******************************************************************************
                                                                              
                                Function Prototypes
                                                                              
*******************************************************************************/

/* We have a pair of menu area definitions which must be used in
   the phone book, these are defined once in this module and then
   shared between all of the phone book modules.
*/
MfwRect MmiBookMenuArea( void );
MfwRect MmiBookNamesArea( void );

/* Similarly for the shared call list buffer
*/
void *MmiBookCallList( int index );
int MmiBookCallListSize( int index );

/* and menu attributes
*/
MfwMnuAttr *MmiBookMenuDetailsList( void );


/* Helper functions
*/
void MmiBookShowDefault( void );

/* Text message handling functions
*/
int MmiBookCurrentText( void );
void MmiBookSetCurrentText( int pstr );


/* Menu structure access routines*/
//add for shortcut menu
MfwMnuAttr *SceneMenuAttributes( void );
MfwMnuAttr *menuReadMsgAttributes(void);
MfwMnuAttr *AlarmMenuAttributes( void );
MfwMnuAttr *stopwatchMenuAttributes( void );
MfwMnuAttr *menuFunctionAttributes(void);
MfwMnuAttr *menuSpecialModeAttributes(void);
MfwMnuAttr *bookPhonebookMenuAttributes( void );
MfwMnuAttr *bookPhonebookVoiceMemo(void);
MfwMnuAttr *bookPhonebookVoiceList(void);
MfwMnuItem *bookPhonebookMenuItems( void );
MfwMnuAttr *bookPhonebookAdd(void);
MfwMnuAttr *bookRepRedOptionsMenuAttributes( void );
MfwMnuItem *bookRepRedOptionsMenuItems( void );
MfwMnuAttr *bookNameMenuAttributes( void );
MfwMnuAttr *bookGroupingSettingAttributes( void );
MfwMnuItem *bookNameMenuItems( void );
MfwMnuAttr *bookMainMenuAttributes( void );
MfwMnuAttr *bookCallBarringMenuAttributes( void );
MfwMnuAttr *bookHostkeyMenuAttributes( void );
MfwMnuItem *bookHostkeyMenuItems( void );
MfwMnuAttr *bookHostkeyOnOffAttributes( void );
MfwMnuItem *bookHostkeyOnOffItems( void );
MfwMnuAttr *bookPhonebookPhoneVoiceList(void);
MfwMnuItem *bookMainMenuItems( void );
MfwMnuAttr *noteOptionMenuAttributes(void);
MfwMnuAttr *noteOptionMenuAttributes1(void);
MfwMnuAttr *PriorityOptionMenuAttibutes(void);
MfwMnuAttr *FrequOptionScheMenuAttibutes(void);
MfwMnuAttr *FrequOptionMenuAttibutes(void);
MfwMnuAttr *CountMenuAttributes( void );
MfwMnuAttr *DeleterecordMenuAttributes(void);
//MfwMnuItem *calcOptionMenuItems( void );
MfwMnuAttr *TypeOptions(void);
MfwMnuAttr *sche_mnu1Attributes(void);
MfwMnuAttr *sche_NoAttributes(void);
MfwMnuAttr *BrowseOptionMenuAttibutes(void);
MfwMnuAttr *DeleteOptions(void);
MfwMnuAttr *MelgenOptionMenuAttributes( void );
MfwMnuItem *MelgenOptionMenuItems( void );
MfwMnuAttr *ringerVolumeSetting( void );
#ifdef MMI_WAP_ENABLED
MfwMnuAttr *WAPMenuAttributes(void);
MfwMnuItem *WAPMenuItems(void);
MfwMnuAttr *WAPBookOptMenuAttributes(void);
MfwMnuItem *WAPBookOptMenuItems(void);
MfwMnuAttr *WAPHistOptMenuAttributes(void);
MfwMnuItem *WAPHistOptMenuItems(void);
MfwMnuAttr *WAPProfOptionsAttributes(void);
MfwMnuItem *WAPProfOptionsItems(void);
MfwMnuAttr *WAPGoToAttributes(void);
MfwMnuItem *WAPGoToItems(void);
MfwMnuAttr *WAPConnectionTypeAttributes(void);
MfwMnuItem *WAPConnectionTypeItems(void);
MfwMnuAttr *WAPAccessTypeAttributes(void);
MfwMnuItem *WAPAccessTypeItems(void);
MfwMnuAttr *WAPSecurityOptionAttributes(void);
MfwMnuItem *WAPSecurityOptionItems(void);
MfwMnuAttr *WAPSaveHistoryAttributes(void);
MfwMnuItem *WAPSaveHistoryItems(void);
MfwMnuAttr *WAPScaleImagesAttributes(void);
MfwMnuItem *WAPScaleImagesItems(void);
#endif // WAP

#ifdef QQFUNC
MfwMnuAttr *QQNVMSelMenuAttributes(void);
MfwMnuAttr *QQNetSelMenuAttributes(void);
MfwMnuAttr *QQBoxSelMenuAttributes(void);
MfwMnuAttr *QQSysBoxSelMenuAttributes(void);
MfwMnuAttr *QQFindSelMenuAttributes(void);
#endif

#ifdef MMI_GPRS_ENABLED
MfwMnuAttr *SMSServiceAttributes(void);
MfwMnuItem *SMSServiceItems(void);
#endif // GPRS

MfwMnuAttr *menuUserDefineAttributes(void);
MfwMnuAttr *menuSetTimeAttributes(void);

#ifdef _MMS_ENABLE_
MfwMnuAttr *MMSRetrieveMsgOptionMenuAttributes( void );
MfwMnuAttr *MMSRecvFolderOptionMenuAttributes( void );
MfwMnuAttr *MMSSendFolderOptionMenuAttributes( void );
MfwMnuAttr *MMSDraftFolderOptionMenuAttributes( void );
MfwMnuAttr *MMSSentFolderOptionMenuAttributes( void );
MfwMnuAttr *MMSDeleteAllOptionMenuAttributes( void );
MfwMnuAttr *MMSMainMenuAttributes( void );
MfwMnuAttr * MMSSettingsMenuAttributes(void);
MfwMnuAttr * MMSAllSettingsMenuAttributes(void);
#endif
/*******************************************************************************
                                                                              
                    Include Files For Phone Book Functionality
                                                                              
*******************************************************************************/

/* These includes need to be here as they depend on definitions
   defined above.
*/
#include "MmiBookUtils.h"
#include "MmiBookServices.h"
#include "MmiBookDialogWindow.h"
#include "MmiBookSearchWindow.h"
#include "MmiBookMenuWindow.h"
#include "MmiBookDetailsWindow.h"
#include "MmiBookCallListWindow.h"
#include "MmiBookCallDetailsWindow.h"
#include "MmiBookSDNWindow.h"
#include "MmiBookPhonebook.h"
#include "MmiMenu.h"


USHORT		options_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);//zhaowm add for check wap options menu should show what icon
T_MFW_HND	AUI_create (T_MFW_HND parent_win); 
void		AUI_connect_URL (T_MFW_HND win, char *URL);
int			AUI_homepageStart(T_MFW_HND parent_win);

#endif
