/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiBookUtils.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                                    
********************************************************************************
                                                                              
 Description:
 
    This module provides utility function for use in the
    phone book application
                        
********************************************************************************

 $History: MmiBookUtils.c

    25/10/00			Original Condat(UK) BMI version.	
        08/08            fzq modified  
        21/08/02     ver0.102  fzq modified
 $End

*******************************************************************************/



/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"

#include "MmiBookShared.h"
#include "l1tm_cust_add.h"  //hxl add for pcsync 20020925


/*******************************************************************************
                                                                              
                                Private data elements
                                                                              
*******************************************************************************/
#define MAX_SMSNAME 30
static T_EasyName CallData;
static T_SmsName SmsName[MAX_SMSNAME];
static T_MFW_UPN_LIST   *upnList = NULL;
static T_phbk           *GlobalPhoneBookHandle = NULL;
extern int SelectTotal;
extern UINT8 SimNumber[ALL_SIM_LIST][PHB_number_len/2+1];
uint8 SimReadyFlag=0; //for 3120 (change in findnumber()) hu binhao2002-12-26
extern unsigned char no_wait;
static int SameNumber(char *number1,char * number2);//yq added 2003/2/13 for change findnumber
static void AddSmsDataName(T_EasyName AddName);
/*******************************************************************************
                                                                              
                                Private Methods
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	changeName

 $Description:	Change a phone book entry if we have a valid book selected
 
 $Returns:		status of change, or MWB_PHB_FAIL if an error occurs

 $Arguments:	book, to be updated
                entry, to update
                currentStatus, pointer to status word
 
*******************************************************************************/

static UBYTE changeName( UBYTE book, T_MFW_PHB_ENTRY *entry, T_MFW_PHB_STATUS *currentStatus )
{
    TRACE_FUNCTION( "changeName()" );

    if ( /* ( book == PHB_UPN ) ||*/ ( book == PHB_SDN ) )
        return MFW_PHB_FAIL;

    return phb_store_entry( book, entry, currentStatus );
}

/*******************************************************************************

 $Function:    	deleteName

 $Description:	Delete a phone book entry
 
 $Returns:		status of delete, or MWB_PHB_FAIL if an error occurs

 $Arguments:	book, to be updated
                index, index of entry to delete
                currentStatus, pointer to status word
 
*******************************************************************************/

static UBYTE deleteName( UBYTE book, UBYTE index, T_MFW_PHB_STATUS *currentStatus )
{
    TRACE_FUNCTION( "deleteName()" );

    if ( /*( book == /*PHB_UPN ) ||*/ ( book == PHB_SDN ) )
        return MFW_PHB_FAIL;

    return phb_delete_entry( book, index, currentStatus );
}

/*******************************************************************************

 $Function:    	addName

 $Description:	Add a new name to the phone book
 
 $Returns:		status of change, or MWB_PHB_FAIL if an error occurs

 $Arguments:	book, to be updated
                entry, to update
                currentStatus, pointer to status word
 
*******************************************************************************/

UBYTE addName( UBYTE book, T_MFW_PHB_ENTRY *entry, T_MFW_PHB_STATUS *currentStatus )
{

    int size;
    T_MFW_PHB_STATUS status;
    TRACE_EVENT( "addName()" );
    status.book=PHB_ADN;   
    if ( phb_get_status(&status)==MFW_PHB_OK )
    {
        size=status.tag_len;
    }

    {

        {
            char temp[100];
            memset(temp,'\0',100);
#ifdef NO_ASCIIZ
            {
                if ( *(entry->name.data)==0x80 )
                {
                    if ( size%2==1 )
                    {
                        entry->name.data[size]=0x00;
                        entry->name.data[size+1]=0x00;
                    }
                    else
                    {
                        entry->name.data[size-1]=0x00;
                        entry->name.data[size]=0x00;
                    }
                }
                else
                {
                    if ( size%2==1 )
                    {
                        //entry->name.data[size-1]=0x00;
                        entry->name.data[size]=0x00;
                        entry->name.data[size+1]=0x00;
                    }
                    else
                    {
                        //entry->name.data[size-2]=0x00;
                        entry->name.data[size-1]=0x00;
                        entry->name.data[size]=0x00;
                    }
                }
                if ( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
                {
                    //mfw_Ucs2SIMStr( MFW_DCS_7bits, 
                    //    	       entry->name.data, 
                    //         	   entry->name.len ,
                    //        	   buf.data,
                    //    	       &buf.len );
                    TRACE_EVENT("Converting Unicode 2 SIM");

                    // convert from GSM to Alpha characters
                    //bookGsm2Alpha( (UBYTE *) buf.data );

                    sprintf(temp,"Book: %d Name %s Number %s",
                            book,
                            (char*)entry->name.data,(char*)entry->number);
                }
                else

                {
                    // convert from GSM to Alpha characters
                    //bookGsm2Alpha( (UBYTE *) entry->name.data );

                    sprintf(temp,"Book: %d Name %s Number %s",
                            book,
                            (char*)entry->name.data,(char*)entry->number);
                }
            }
#else
            if ( *(entry->name)==0x80 )
            {
                if ( size%2==1 )
                {
                    entry->name[size]=0x00;
                    entry->name[size+1]=0x00;
                }
                else
                {
                    entry->name[size-1]=0x00;
                    entry->name[size]=0x00;
                }
            }
            else
            {
                if ( size%2==1 )
                {
                    //entry->name.data[size-1]=0x00;
                    entry->name[size]=0x00;
                }
                else
                {
                    //entry->name.data[size-2]=0x00;
                    entry->name[size-1]=0x00;
                }
            }
            sprintf(temp,"Book: %d Name %s Number %s",
                    book,
                    (char*)entry->name,(char*)entry->number);
#endif
            TRACE_EVENT(temp);
        }
        entry->index = 0;
        return phb_store_entry( book, entry, currentStatus );
    }
}

/*******************************************************************************
                                                                              
                          File Handling Utilities
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	storeInFile

 $Description:	Converts the name to a storeable format and stores it
                in the phone book
 
 $Returns:		None

 $Arguments:	phbk, pointer to phonebook structure
 
*******************************************************************************/

void storeInFile( T_phbk *phbk )
{   int i;
    UBYTE actual_length;
    char debug[20];
    char  temp[100];
    TRACE_FUNCTION( "storeInFile()" );

    // Convert the name

#ifdef NO_ASCIIZ

    // if the pattern is GSM default format, use the function mfw_Gsm2SIMStr() here

#ifdef EASY_TEXT_ENABLED

    if ( phbk->edt_buf_name[0] == 0x80 )//if unicode
    {
        for ( i =0; i < PHB_name_len; i+=2 ) //work out string length
        {
            if ( phbk->edt_buf_name[i] == 0 && phbk->edt_buf_name[i+1] == 0 )
            {
                if ( i== 0 )
                    actual_length =0;
                else
                    actual_length = i -2;
                break;
            }
        }
        phbk->edt_buf_name[0] = (UBYTE)(actual_length/2);//add string length to beginning of string
        phbk->edt_buf_name[1] = 0x00;

        memset(phbk->newEntry.name.data, 0, PHB_name_len);
        //convert to SIM string
        mfw_Ucs2SIMStr( MFW_DCS_UCS2 , (U16*)phbk->edt_buf_name, PHB_name_len,
                        phbk->newEntry.name.data, &phbk->newEntry.name.len );
        TRACE_EVENT(    (char*)phbk->newEntry.name.data);
        //phbk->newEntry.name.len = actual_length;
        sprintf(debug, "length:%d", phbk->newEntry.name.len);
        TRACE_EVENT(debug);
    }
    else
#endif
        mfw_Gsm2SIMStr( MFW_DCS_7bits, (U16*)phbk->edt_buf_name, PHB_name_len,
                        phbk->newEntry.name.data, &phbk->newEntry.name.len );   

#else

    strncpy( (char *)phbk->newEntry.name, (char *)phbk->edt_buf_name, PHB_name_len );

#endif


    // update the number
    if ( phbk->edt_buf_name[0]==0x80 )
    {
        wstrncpy( (char *) phbk->newEntry.name.data,(char *) phbk->edt_buf_name,PHB_name_len);
        phbk->newEntry.name.len=wstrlen((char *) phbk->edt_buf_name);
    }
    else
    {
        strncpy( (char *) phbk->newEntry.name.data,(char *) phbk->edt_buf_name, PHB_name_len );
        phbk->newEntry.name.len=wstrlen((char *)phbk->edt_buf_name);
        sprintf(temp,"Store Name:%s",phbk->newEntry.name.data);
        TRACE_EVENT(temp);
    }

    strncpy( (char *) phbk->newEntry.number, (char *) phbk->edt_buf_number, PHB_number_len );
    //phbk->newEntry.book = phbk->current.status.book; //JVJE We can only store in ADN/FDN 
    phbk->newEntry.book = bookActiveBook(WRITE);
    phbk->newEntry.index = 0;

    /* Add the name/number combination to the phone book and setup
       the current text status string
    */
    switch ( addName( phbk->newEntry.book, &phbk->newEntry, &phbk->current.status ) )
    {
    case MFW_PHB_OK :
        {
            /* Entry saved okay
            */
            MmiBookSetCurrentText( TxtAddSucceed);
            GetSIMData();           
        }
        break;

    case MFW_PHB_FULL :
        {
            /* Phone book full
            */
            MmiBookSetCurrentText( TxtPhbkFull  );
        }
        break;

    case MFW_PHB_FAIL :
        {
            /* Write failure
            */
            MmiBookSetCurrentText( TxtWriteError  );
        }
        break;

    default:
        {
            /* No other returns possible
            */
        }
        break;
    }
}


/*******************************************************************************

 $Function:    	changeInFile

 $Description:	change the phone book entry
 
 $Returns:		none

 $Arguments:	phbk, pointer to phonebook structure
 
*******************************************************************************/

int changeInFile( T_phbk *phbk )
{   
    char temp[100];
    int NewIndex,i;

    NewIndex=-1;
    TRACE_FUNCTION( "changeInFile()" );

    if ( phbk->current.status.book == PHB_ADN_FDN )
        phbk->current.status.book = PHB_ADN;    //JVJE We can only store in ADN/FDN 
    else
        phbk->current.status.book = phbk->current.status.book;

    TRACE_EVENT_P1("Current Book = %d", phbk->current.status.book);
    TRACE_EVENT_P1("Current Name = %s",  phbk->current.selectedName);
    TRACE_EVENT_P1("Current Buf Name = %s", phbk->edt_buf_name);

// update the number        
    strncpy( (char *) phbk->current.entry[ phbk->current.selectedName ].number,
             (char *) phbk->edt_buf_number, PHB_name_len );

    if ( phbk->edt_buf_name[0] == 0x80 )
    {
        wstrncpy( (char *) phbk->current.entry[ phbk->current.selectedName].name.data,        
                  (char *) phbk->edt_buf_name,PHB_name_len);
        phbk->current.entry[phbk->current.selectedName].name.len=wstrlen((char *) phbk->edt_buf_name);
    }
    else
    {
        strncpy( (char *) phbk->current.entry[ phbk->current.selectedName ].name.data,
                 (char *) phbk->edt_buf_name, PHB_name_len );
        phbk->current.entry[phbk->current.selectedName].name.len=strlen((char *)phbk->edt_buf_name);      
    }

    // Add the name/number combination to the phone book and setup the current text status string   


    if ( phbk->BufferTable==GlobalTable )
    {
        TRACE_EVENT("GlobalTable");
        phbk->current.entry[phbk->current.selectedName].index=l_phb_index[l_phb_sort_index[phbk->phbk->select_index].index].index;
    }
    else if ( phbk->BufferTable==SearchTable )
    {
        TRACE_EVENT("SearchTable");
        phbk->current.entry[phbk->current.selectedName].index=l_phb_index[bookname[phbk->phbk->select_index].index].index;
    }

    switch ( changeName( phbk->current.status.book,&phbk->current.entry[ phbk->current.selectedName ], 
                         &phbk->current.status ) )
    {
    case MFW_PHB_OK :
        {
            // Entry saved okay            
            MmiBookSetCurrentText( TxtEditSucceed );

            if ( phbk->BufferTable==GlobalTable )
            {
                if ( phbk->edt_buf_name[0] == 0x80 )
                {
                    wstrncpy( (char *) l_phb_index[l_phb_sort_index[phbk->phbk->select_index].index].name,        
                              (char *) phbk->edt_buf_name,PHB_name_len);
                    l_phb_index[l_phb_sort_index[phbk->phbk->select_index].index].number[0]=GetShortNumber((char *) phbk->edt_buf_number);
                    CompressNum((char *) phbk->edt_buf_number,SimNumber[l_phb_sort_index[phbk->phbk->select_index].index-ALL_NVM_LIST]);
                    l_phb_sort_index[phbk->phbk->select_index].name=GetShortName(phbk->edt_buf_name);
                }
                else
                {
                    strncpy( (char *) l_phb_index[l_phb_sort_index[phbk->phbk->select_index].index].name,
                             (char *) phbk->edt_buf_name, PHB_name_len );
                    l_phb_index[l_phb_sort_index[phbk->phbk->select_index].index].number[0]=GetShortNumber((char *) phbk->edt_buf_number);
                    CompressNum((char *) phbk->edt_buf_number,SimNumber[l_phb_sort_index[phbk->phbk->select_index].index-ALL_NVM_LIST]);
                    l_phb_sort_index[phbk->phbk->select_index].name=GetShortName(phbk->edt_buf_name);
                }
                NewIndex=SetLocation(l_phb_sort_index,phbk->phbk->select_index);//reset location
                sprintf(temp,"NewIndex:%d",NewIndex);
                TRACE_EVENT(temp);
                sprintf(temp,"Search_win:%d;%d",(int *)phbk->search_win,(int *)phbk->phbk->search_win);
                TRACE_EVENT(temp);
            }
            else if ( phbk->BufferTable==SearchTable )
            {
                if ( phbk->edt_buf_name[0] == 0x80 )
                {
                    wstrncpy( (char *) l_phb_index[bookname[phbk->phbk->select_index].index].name,        
                              (char *) phbk->edt_buf_name,PHB_name_len);
                    l_phb_index[bookname[phbk->phbk->select_index].index].number[0]=GetShortNumber((char *) phbk->edt_buf_number);
                    CompressNum((char *) phbk->edt_buf_number,SimNumber[bookname[phbk->phbk->select_index].index-ALL_NVM_LIST]);
                    //bookname[phbk->phbk->select_index].name=GetShortName(phbk->edt_buf_name);
                    for ( i=0;i<ALL_NUMBER_LIST;i++ )
                    {
                        if ( l_phb_sort_index[i].index==bookname[phbk->phbk->select_index].index )
                        {
                            l_phb_sort_index[i].name=GetShortName(phbk->edt_buf_name);
                            break;
                        }
                    }
                }
                else
                {
                    strncpy( (char *) l_phb_index[bookname[phbk->phbk->select_index].index].name,
                             (char *) phbk->edt_buf_name, PHB_name_len );
                    l_phb_index[bookname[phbk->phbk->select_index].index].number[0]=GetShortNumber((char *) phbk->edt_buf_number);
                    CompressNum((char *) phbk->edt_buf_number,SimNumber[bookname[phbk->phbk->select_index].index-ALL_NVM_LIST]);
                    //bookname[phbk->phbk->select_index].name=GetShortName(phbk->edt_buf_name);
                    for ( i=0;i<ALL_NUMBER_LIST;i++ )
                    {
                        if ( l_phb_sort_index[i].index==bookname[phbk->phbk->select_index].index )
                        {
                            l_phb_sort_index[i].name=GetShortName(phbk->edt_buf_name);
                            break;
                        }
                    }
                }
                NewIndex=SetSearchLocation(bookname,phbk->phbk->select_index);//reset location
                sprintf(temp,"NewIndex:%d",NewIndex);
                TRACE_EVENT(temp);
                sprintf(temp,"Search_win:%d;%d",(int *)phbk->search_win,(int *)phbk->phbk->search_win);
                TRACE_EVENT(temp);
            }
        }
        break;
    case MFW_PHB_FAIL :
        {
            // Write failure            
            MmiBookSetCurrentText(  TxtWriteError );
        }
        break;

    default: break;
    }

    return NewIndex;    
}

/*******************************************************************************

 $Function:    	deleteFromFile

 $Description:	delete an entry from a phone book
 
 $Returns:		None

 $Arguments:	phbk, phone book handle,
                book, book to update,
 
*******************************************************************************/

void deleteFromFile( T_phbk *phbk, UBYTE book )
{
    int index;
    TRACE_FUNCTION( "deleteFromFile()" );

    index = phbk->current.selectedName - phbk->current.missedCallsOffset;
    switch ( deleteName( book,
                         phbk->current.entry[index].index, &phbk->current.status ) )
    {
    case MFW_PHB_OK :
        {
            /* Entry saved okay
            */
            MmiBookSetCurrentText(  TxtEntryDeleted  );

#ifdef NO_ASCIIZ
            phbk->current.entry[index].name.len = 0;
            memset((char*)phbk->current.entry[index].number, '\0', PHB_name_len); 

#else
            memset((char*)phbk->current.entry[index].name, '\0', PHB_name_len);
            memset((char*)phbk->current.entry[index].number, '\0', PHB_number_len); 
#endif
            /* Move the current index to the next valid entry
            */
            if ( phbk->current.selectedName > 0 )
                phbk->current.selectedName --;
            else
                phbk->current.selectedName = 0;

            if ( phbk->current.index > 1 )
                phbk->current.index--;
            else
                phbk->current.index = 1;

            /* And if we have a search window, perform the search to
               update the current valid entry
            */
            if ( phbk->search_win )
            {
                bookGetCurrentStatus( &phbk->current.status );
                if ( ! phbk->current.status.used_entries )
                {
                    /* empty phone book
                    */
                    bookSearchDestroy( phbk->search_win );
                    phbk->search_win = 0;
                }
                else
                {
                    /* perform the search
                    */
                    SEND_EVENT( phbk->search_win, SEARCH_UPDATE, 0, 0 );
                }
            }
        }
        break;

    case MFW_PHB_FAIL :
        {
            /* Write failure
            */
            MmiBookSetCurrentText(  TxtWriteError );
        }
        break;

    default:
        {
            /* No other action required
            */
        }
        break;
    }
}

/*******************************************************************************
                                                                              
                                Public Methods
                                                                              
*******************************************************************************/




/*******************************************************************************

 $Function:    	bookCurrentWindow

 $Description:

   This returns the window handle associated with the current
   MFW element
 
 $Returns:		window handle of current MFW item

 $Arguments:	none.
 
*******************************************************************************/

tBookMfwHnd bookCurrentWindow( void )
{
    return mfwParent( mfwHeader() );
}

/*******************************************************************************

 $Function:    	bookDefaultCallBack

 $Description:	

   This is a simple call back function which is invoked when
   a not implemented dialog is displayed. We don't want anyone
   outside of this module using it so define it as static,
   this will still be callable from the info dialogs as it
   will use the reference we set up.
 
 $Returns:		zero, always

 $Arguments:	win, parent window
                identifier, of the window
                reason, for the window
 
*******************************************************************************/

static tBookStatus bookDefaultCallBack( tBookMfwHnd win, UBYTE identifier, UBYTE reason )
{
    if ( win )
        winShow( win );

    return 0;
}

/*******************************************************************************

 $Function:    	bookWindowData

 $Description:	

   This routine is designed to be invoked from within a menu
   handler or call back function and will return a pointer to
   the window data associated with the current MFW element.
 
 $Returns:		pointer to the data area

 $Arguments:	none.
 
*******************************************************************************/

void *bookWindowData( void )
{
    tBookMfwHnd WinPtr;

    if ( ( WinPtr = bookCurrentWindow() ) == NULL )
        return(void *) NULL;

    return(void *)((tBookMfwHdr *) WinPtr)->data;
}

/*******************************************************************************

 $Function:    	bookMenuSelectedNumber

 $Description:	

   This will return the currently selected entry in the phone
   book, when the routine is being called from a menu handler
 
 $Returns:		pointer to the selected number buffer

 $Arguments:	none.
 
*******************************************************************************/

char *bookMenuSelectedNumber( void )
{
    tBookMfwHnd WinData;

    /* Have we got a valid window ?
    */
    if ( ( WinData = (tBookMfwHnd) bookWindowData() ) == NULL )
        return NULL;

    return NULL;
}

/*******************************************************************************

 $Function:    	bookPhoneBookLoading

 $Description:	access routine for the local static menu area

    Utility functions to determine if the phone book is
    still in the loading state
  
 $Returns:		BOOK_FAILURE if loading, otherwise BOOK_SUCCESS

 $Arguments:	none.
 
*******************************************************************************/

tBookStatus bookPhoneBookLoading( void )
{
    // rewrite by clrobert, invoke phb_get_mode() twice is not necessary
    // from
/*
    int temp;
    char tempst[20];
    TRACE_FUNCTION("bookPhoneBookLoading");
    temp = phb_get_mode();
    sprintf(tempst,"phb_get_mode %d",temp);
    TRACE_EVENT(tempst);
    return ( (phb_get_mode() == PHB_LOADING)||(phb_get_mode() == MFW_PHB_FAIL) ) ? BOOK_FAILURE : BOOK_SUCCESS;
*/
    // to

    int mode;

    mode = phb_get_mode();
    return(((mode == PHB_LOADING) || (mode == MFW_PHB_FAIL)) ? BOOK_FAILURE : BOOK_SUCCESS);
}

/*******************************************************************************

 $Function:    	bookInfoDialog

 $Description:
 
    Utility functions just to throw a string onto the screen
    primarily for debug purposes, the modal version will wait
    for a user input before removing the message, the non-modal
    will clear after three seconds

 $Returns:		One.

 $Arguments:	String1, String2, character strings to be displayed.
 
*******************************************************************************/

tBookStatus bookInfoDialog( char *String1, char *String2 )
{
    tBookMfwHnd Win = bookCurrentWindow();
    tBookDialogData Dialog;

    // Initialise the dialog control block with default information	
    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    Dialog.TextId       = 0;
    Dialog.TextId2      = 0;
    Dialog.TextString   = String1;
    Dialog.TextString2  = String2;
    Dialog.LeftSoftKey  = 0;
    Dialog.RightSoftKey = 0;
    Dialog.Time         = 3000;
    Dialog.Callback     = (T_VOID_FUNC) bookDefaultCallBack;
    Dialog.Identifier   = 0;

    // Show the dialog	
    info_dialog( Win, &Dialog );

    return 1;
}
/*******************************************************************************

 $Function:    	bookNotImplemented

 $Description:	

    This will present an information dialog indicating the current
    feature is still under development. This routine will use the
    current MFW element to detect the handle of the parent window
    if the incoming window handle is NULL.
 
 $Returns:		One

 $Arguments:	Parent, window, can be NULL
 
*******************************************************************************/

tBookStatus bookNotImplemented( tBookMfwHnd Parent )
{
    tBookMfwHnd Win = ( Parent ) ? Parent : bookCurrentWindow();
    tBookDialogData Dialog;

    /* Initialise the dialog control block with default information
    */
    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents    = KEY_CLEAR;
    Dialog.TextId       = 0;
    Dialog.TextId2      = 0;
    Dialog.TextString   = MmiRsrcGetText( TxtNotImplemented );
    Dialog.TextString2  = NULL;
    Dialog.LeftSoftKey  = 0;
    Dialog.RightSoftKey = 0;
    Dialog.Time         = 3000;
    Dialog.Callback     = (T_VOID_FUNC) bookDefaultCallBack;
    Dialog.Identifier   = 0;

    /* Show the dialog
    */
    info_dialog( Win, &Dialog );

    return 1;

}

/* Menu handler to invoke the routine above
*/
tBookStatus bookMenuNotImplemented( tBookMfwMenu *Menu, tBookMfwMenuItem *Item )
{
    return bookNotImplemented( NULL );
}

/*******************************************************************************

 $Function:    	set_edt_attr

 $Description:	
 
    Sets up the edit attribute structure with the provided parameters

 $Returns:		None

 $Arguments:	winPx, winPy, winSx, winSy, positioning information
                fgColor, colour for foreground
                font, mode, controls, pretty much what they say
                *text, initial text to be edited
                size, of the text (in bytes)
                attr, the block to be set up with the other parameters
 
*******************************************************************************/

void bookSetEditAttributes(
                          U16  winPx,   U16 winPy, U16 winSx, U16 winSy,
                          U8   fgColor, U8  font,  U8  mode,  U8  *controls,
                          char *text,   U16 size,
                          MfwEdtAttr*   attr)
{
    /* Populate the structure with the parameters
    */
    attr->win.px = winPx;
    attr->win.py = winPy;
    attr->win.sx = winSx;
    attr->win.sy = winSy;
    attr->fgColor = fgColor;
    attr->font = font;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
}

/*******************************************************************************
                                                                              
                       Public memory allocation overrides
                                                                              
*******************************************************************************/

/* Memory allocation and freeing functions

   These routines provided guarded access to the malloc and free
   routines used in the MMI application. The wrapper functions
   provided here allow debugging and tracking information to be
   easily derived, it also allows the memory allocation and
   deallocation to be changed if required.

   Note that the free routine takes a pointer to the pointer
   to the memory being freed. This allows the actual pointer
   value to be set to NULL as part of the free operation, this
   helps protect against reusing the pointer after the memory
   has been deallocated.

   Sample usage:

        tStructure *ptr;

        if ( ( ptr = (tStructure *) bookMemAlloc( sizeof(tStructure) ) ) != NULL )
        {
            // use the allocated memory
            //
            ...

            // free the memory
            //
            bookMemFree( &ptr );
        }
*/


/*******************************************************************************

 $Function:    	bookMemAlloc

 $Description:	memory allocator
 
 $Returns:		pointer to allocated memory, NULL if failure

 $Arguments:	Numbytes, number of contiguous bytes to allocate
 
*******************************************************************************/

void *bookMemAlloc( long int NumBytes )
{
    return sysAlloc( (unsigned short) NumBytes );
}

/*******************************************************************************

 $Function:    	bookMemFree

 $Description:	frees previously allocated memory
 
 $Returns:		none. (But *Pointer will be set to NULL)

 $Arguments:	**Pointer, pointer to pointer to allocated memory
 
*******************************************************************************/

void bookMemFree( void **Pointer )
{
    if ( ! Pointer )
        return;

    if ( *Pointer )
    {
        sysFree( *Pointer );
        *Pointer = NULL;
    }
}

/*******************************************************************************
                                                                              
                             Name Handling Functions
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	bookGetCurrentStatus

 $Description:	Determines the current status of the phone book
 
 $Returns:		status byte

 $Arguments:	currentStatus, pointer to structure to be populated with
                status information
 
*******************************************************************************/

UBYTE bookGetCurrentStatus( T_MFW_PHB_STATUS *currentStatus )
{
    UBYTE temp;
    TRACE_FUNCTION( "bookGetCurrentStatus()" );

    //currentStatus->book=PHB_ADN;
    temp=phb_get_status( currentStatus );
    if ( temp!=MFW_PHB_FAIL )
    {
        char temp[255];
        sprintf(temp,"book %d max_entries %d used_entries %d aval_entries %d",
                currentStatus->book,currentStatus->max_entries,
                currentStatus->used_entries,
                currentStatus->avail_entries);
        TRACE_EVENT(temp);
    }
    return temp;
}

/*******************************************************************************

 $Function:    	bookFindNames

 $Description:	Fine name in phone book
 
 $Returns:		status of search

 $Arguments:	number, number of entries to search, current,
                pointer to structure containing search context
 
*******************************************************************************/

UBYTE bookFindName( UBYTE number, tMmiPhbData *current )
{
    UBYTE   ret;
    int     index, Count = 0;
    UBYTE   l_name[PHB_name_len];

    UBYTE   book_type, index_type;

    int i;
    char debug[22];
    char temp2[50];

    TRACE_EVENT( "bookFindName()" );

    /* Firstly, check for an empty book
    */
    bookGetCurrentStatus( &current->status );
    if ( current->status.used_entries < 1 )
    {
        current->index = 0;
        return MFW_PHB_OK;
    }

    /* Okay, we have some entries to search, so initialise the current
       entry buffer to empty
    */
    memset( current->entry, 0, MAX_SEARCH_CALL_LIST * sizeof( T_MFW_PHB_ENTRY ) );



    current->list.entry         = current->entry;
    current->list.num_entries   = number;

    /* Sort out how we index the information
    */
    book_type  = current->status.book;
    index_type = MFW_PHB_INDEX;


    if ( ( book_type == bookActiveBook(WRITE) ) || ( book_type == PHB_SDN ) )
        index_type = MFW_PHB_ALPHA;

    /* Sort out the type of search we are performing
    */
    if ( (book_type == PHB_LDN) || (book_type == PHB_LRN)|| (book_type == PHB_LMN) )
        index_type = MFW_PHB_INDEX;
    else
    {
        if ( current->KindOfSearch == SEARCH_BY_NAME )
            index_type = MFW_PHB_ALPHA;
        else if ( current->KindOfSearch == SEARCH_BY_NUMBER )
            index_type = MFW_PHB_NUMBER;
        else if ( current->KindOfSearch == SEARCH_BY_LOCATION )
            index_type = MFW_PHB_INDEX;
    }


    /* read the appropriate entries from the phone book
    */
    {
        char temp[255];
        sprintf(temp,"book %d index %d indextype %d number %d",
                book_type,current->index,index_type,number);
        TRACE_EVENT(temp);      
    }   

    if ( book_type == PHB_ADN )   /*Quick test */
    {
        TRACE_EVENT("book_type == PHB_ADN");
        ret = phb_read_entries( PHB_ADN_FDN, current->index, index_type, number, &current->list );
    }
    else
    {
        TRACE_EVENT("book_type == OTHER");
        ret = phb_read_entries( book_type, current->index, index_type, number, &current->list );
    }

    /* Populate the output structures
    */
    if ( current->list.result == MFW_NO_ENTRY )
        current->index = 0;

    for ( index = 0; index < number; index++ )
#ifdef NO_ASCIIZ
    {
#ifdef EASY_TEXT_ENABLED

        int actual_length;

        /* GSM character sets
        */
        TRACE_EVENT( (char*)current->entry[index].name.data);
        TRACE_EVENT("Convert from SIM to UCS2");

        //mfw_SIM2UcsStr( /*current->entry[index].name.len*/PHB_name_len, 
        //   current->entry[index].name.data, PHB_name_len, (U16*)l_name );
        if ( current->entry[index].name.data[0] == 0x80 )
        {
            for ( i=1; i<PHB_name_len; i+=1 )
            {
                l_name[i+1] = current->entry[index].name.data[i];
                //l_name[i] = current->entry[index].name.data[i+1];
            }
            l_name[0] = current->entry[index].name.data[0]; 
            l_name[1] = PHB_name_len;

            memcpy( current->entry[index].name.data, (char*)l_name, PHB_name_len );

            for ( i=0; i < PHB_name_len;i++ )
            {
                if ( current->entry[index].name.data[i]== 0 && current->entry[index].name.data[i+1] != 0 )
                    debug[i] = '0';
                else
                    debug[i] = (char)current->entry[index].name.data[i];
            }

            for ( i =0; i < PHB_name_len; i+=2 ) //work out string length
            {
                if ( current->entry[index].name.data[i] == 0 && current->entry[index].name.data[i+1] == 0 )
                {
                    if ( i== 0 )
                        actual_length =0;
                    else
                        actual_length = i -2;
                    break;
                }
            }
            current->entry[index].name.len = actual_length;


        }

        else
#endif
            bookGsm2Alpha( (UBYTE *) current->entry[index].name.data ); 
    }
#else
    {
        bookGsm2Alpha( (UBYTE *) current->entry[index].name );
    }
#endif

    /* Needed to make international calls from the phonebook
    */
    for ( index = 0; index < number; index++ )
    {
        if ( current->entry[index].ton )
        {
            /* Pre-pend a '+' to the phone number string because
               this number is international
            */
            memmove( (char *) &current->entry[ index ].number[ 1 ],
                     (char *) current->entry[ index ].number, PHB_number_len - 1 );

            /* Now pre-pend the '+'
            */
            current->entry[index].number[0] = '+';
        }
    }
    TRACE_EVENT("Book searched");   
    return current->result = ret;
}
/*******************************************************************************

 $Function:    	bookEvent

 $Description:	Event handler for a phone book event
 
 $Returns:		MFW_EVENT_CONSUMED if recognised message, otherwise
                MFW_EVENT_PASSED

 $Arguments:	e, event, para, general parameter giving context of call
 
*******************************************************************************/

int bookEvent( MfwEvt e, void *para )
{
    T_MFW_PHB_STATUS *status;

    T_MFW_PHB_ENTRY    l_phb_Shortentry;
    T_MFW_PHB_STATUS   newstatus; 
    int                  Index,i;

    char                 temp[100];

    TRACE_FUNCTION( "bookEvent" );

    /* deal with the incoming event
    */
    switch ( e )
    {
    case E_PHB_UPN_LIST :
        {
            upnList = (T_MFW_UPN_LIST *)para;
        }
        break;

    case E_PHB_STATUS:
        {
            status = (T_MFW_PHB_STATUS *)para;
            if ( ( status->book == PHB_FDN ) || ( status->book == PHB_ADN ) )
            {
                if ( pinsSetIsFocussed() == FOCUSSED_PINS )
                    backpinFDNactdeact();
            }
        }
        break;
    case E_PHB_ERROR:
        {
            /* tbd */
            //hxl add 20020917--------------------------------------
            MmiTrace("E_PHB_ERROR");
            if ( PcCmdStatus.isPcCmdRun )
            {
                PcCmdStatus.isPcCmdRun=0;
                MmiTrace("write_sim_phb_cb");
                write_sim_phb_cb();
                return MFW_EVENT_CONSUMED;
            }
            //end of hxl add 20020917------------------------------------
        }
        break;

    case E_PHB_READY:
        {
            TRACE_EVENT("Entry bookevent");
            MmiTrace("E_PHB_READY");
            //hxl add 20020917--------------------------------------
            if ( PcCmdStatus.isPcCmdRun )
            {
                PcCmdStatus.isPcCmdRun=0;
                MmiTrace("write_sim_phb_cb");
                write_sim_phb_cb();
                return MFW_EVENT_CONSUMED;
            }
            //end of hxl add 20020917------------------------------------

            if ( phonebookstatus==COPYINGALL )
            {
                sprintf(temp,"Copyidx:%d",Copyidx);
                TRACE_EVENT(temp);
                if ( CopyNumber==NVMTotal )
                {
                    GetSIMData();
                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );    
                    CopyResult.CopyEnd=TRUE;
                    CopyResult.complete=MFW_PHB_OK;
                    phonebookstatus=COPYNONE;
                }
                else if ( Copyidx==PHBKTotal )
                {
                    GetSIMData();
                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );    
                    CopyResult.CopyEnd=TRUE;
                    CopyResult.complete=MFW_PHB_FAIL;
                    phonebookstatus=COPYNONE;
                }
                else
                {
                    TRACE_EVENT("copy not finished!");
                    for ( i=Copyidx;i<PHBKTotal;i++ )
                    {
                        if ( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                        {
                            Index=l_phb_sort_index[i].index;

                            if ( CurrentTable!=Index/PHB_table_len )
                            {
                                if ( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                                    CurrentTable=Index/PHB_table_len;
                            }

                            memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                            l_phb_Shortentry.book=bookActiveBook(WRITE);
                            newstatus.book=l_phb_Shortentry.book;

                            memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len);
                            l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                            //================================================================================================                      
                            switch ( CheckFirstNumFlag(Index) )
                            {
                            case 0x01:
                                if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                break;  
                            case 0x02:
                                if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                break;
                            case 0x03:
                                if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                break;
                                //================================================================================================                                  
                            }
                            //UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);                                                                      

                            switch ( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&newstatus) )
                            {
                            case MFW_PHB_OK :
                                {
                                    TRACE_EVENT("OK");
                                    CopyResult.CopyEnd=FALSE;
                                    CopyResult.complete=MFW_PHB_OK;                                                                       
                                }
                                break;
                            case MFW_PHB_FULL :
                                {
                                    // Phone book full
                                    TRACE_EVENT("full");
                                    GetSIMData();
                                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );    
                                    CopyResult.CopyEnd=TRUE;
                                    CopyResult.complete=MFW_PHB_FULL;
                                    phonebookstatus=COPYNONE;                                                               
                                }
                                break;
                            case MFW_PHB_FAIL :
                            default:    
                                {
                                    TRACE_EVENT("faile or out");
                                    GetSIMData();
                                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );
                                    CopyResult.CopyEnd=TRUE;
                                    CopyResult.complete=MFW_PHB_FAIL;
                                    phonebookstatus=COPYNONE;                                                              
                                }
                                break;                                                     
                            }
                            if ( CopyResult.complete==MFW_PHB_OK ) CopyNumber=CopyNumber+1;
                            break; 
                        }
                    }                                
                    if ( i==PHBKTotal ) Copyidx=PHBKTotal;
                    else Copyidx=i+1;                   
                }
            }
            else if ( phonebookstatus==COPYINGSELECT )
            {
                if ( CopyNumber==SelectTotal )//copy finished
                {
                    GetSIMData();
                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );
                    CopyResult.CopyEnd=TRUE;
                    CopyResult.complete=MFW_PHB_OK;
                    phonebookstatus=COPYNONE;
                }
                else if ( Copyidx==SearchTotal )
                {
                    GetSIMData();
                    TRACE_EVENT("copy over but fail in bookevent!");
                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );
                    CopyResult.CopyEnd=TRUE;
                    CopyResult.complete=MFW_PHB_FAIL;
                    phonebookstatus=COPYNONE;

                }
                else
                {
                    for ( i=Copyidx;i<SearchTotal;i++ )
                    {
                        if ( bookname[i].selectflag==TRUE )
                        {
                            Index=bookname[i].index;

                            if ( CurrentTable!=Index/PHB_table_len )
                            {
                                flash_PBread(PBTable[Index/PHB_table_len]);
                                CurrentTable=Index/PHB_table_len;                    
                            }

                            memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                            l_phb_Shortentry.book=bookActiveBook(WRITE);
                            newstatus.book=l_phb_Shortentry.book;

                            memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len);
                            l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                            switch ( CheckFirstNumFlag(Index) )
                            {
                            case 0x01:
                                if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                break;  
                            case 0x02:
                                if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                break;
                            case 0x03:
                                if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                else if ( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                break;
                                //================================================================================================                                  
                            }
                            //UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);                                                                      

                            switch ( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&newstatus) )
                            {
                            case MFW_PHB_OK :
                                {
                                    TRACE_EVENT("OK");
                                    CopyResult.CopyEnd=FALSE;
                                    CopyResult.complete=MFW_PHB_OK;                                                                       
                                }
                                break;
                            case MFW_PHB_FULL :
                                {
                                    // Phone book full
                                    TRACE_EVENT("full");
                                    GetSIMData();
                                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );    
                                    CopyResult.CopyEnd=TRUE;
                                    CopyResult.complete=MFW_PHB_FULL;
                                    phonebookstatus=COPYNONE;                                                               
                                }
                                break;
                            case MFW_PHB_FAIL :
                            default:    
                                {
                                    TRACE_EVENT("out or fail");
                                    GetSIMData();
                                    Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );
                                    CopyResult.CopyEnd=TRUE;
                                    CopyResult.complete=MFW_PHB_FAIL;
                                    phonebookstatus=COPYNONE;                                                              
                                }
                                break;              
                            }
                            if ( CopyResult.complete==MFW_PHB_OK ) CopyNumber=CopyNumber+1;
                            break; 
                        }
                    }                                
                    if ( i==SearchTotal ) Copyidx=SearchTotal;
                    else Copyidx=i+1;
                }
            }
        }   
        break;
    default:
        {
            // indicate we haven't dealt with event            
            return MFW_EVENT_PASSED;
        }
        break;
    }

    // got to here, we have dealt with the event    
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	bookCreateNewPhoneBook

 $Description:	Creates a single view of the phone book object, this is
                called as part of the initialisation sequence, then the
                book is used in all subsequent phone book operations.
 
 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

void bookCreateNewPhoneBook( void )
{
    GlobalPhoneBookHandle = (T_phbk *) ALLOC_MEMORY( sizeof( T_phbk ) );
}
/*******************************************************************************

 $Function:    	bookDeletePhoneBook

 $Description:	Deletes the global phone book instance
 
 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

void bookDeletePhoneBook( void )
{
    if ( GlobalPhoneBookHandle )
        FREE_MEMORY( (void *) GlobalPhoneBookHandle, sizeof( T_phbk ) );
    GlobalPhoneBookHandle = NULL;
}

T_MFW_UPN_LIST * GetOwnNumber(void)
{
    return upnList;
}

/*******************************************************************************

 $Function:    	bookFetchPhoneBookHandle

 $Description:	Provides handle of global phone book
 
 $Returns:		pointer to the phone book instance

 $Arguments:	None.
 
*******************************************************************************/

T_phbk *bookFetchPhoneBookHandle( void )
{
    return GlobalPhoneBookHandle;
}

//index input value: Index=l_phb_sort_index[0].index;
//                 Index=Searchbuffer[0]->index;
BOOL ReadSIMRecord( int Index,T_MFW_PHB_ENTRY * l_phb_Shortentry )
{ 
    T_MFW_PHB_ENTRY  TempEntry;
    T_MFW_PHB_LIST    l_phb_list; /* phonebook list */  
    T_MFW             ret;
    char               temp[100];

    memset(&TempEntry,0,sizeof(TempEntry));
    memset(&l_phb_list,0,sizeof(l_phb_list));
    l_phb_list.entry=&TempEntry;
    l_phb_list.num_entries=1;

    TRACE_EVENT("readsimrecord");
    //ret=phb_read_entries(PHB_ADN,Index-ALL_NVM_LIST+1,MFW_PHB_INDEX,1,&l_phb_list);//l_phb_index[Index].index
    // ret=phb_read_entries(PHB_ADN,l_phb_index[Index].index,MFW_PHB_PHYSICAL,1,&l_phb_list);//l_phb_index[Index].index
    // sprintf(temp,"Read SIM:%d",ret);
    // TRACE_EVENT(temp);

    // if (ret==MFW_PHB_OK)
    {        
        memcpy(l_phb_Shortentry->name.data,l_phb_index[Index].name,PHB_name_len+2);
        UnCompressNum((char *)SimNumber[Index-ALL_NVM_LIST],l_phb_Shortentry->number);
        //memcpy(l_phb_Shortentry->name.data,TempEntry.name.data,PHB_name_len);
        //memcpy(l_phb_Shortentry->number,TempEntry.number,PHB_number_len);
        l_phb_Shortentry->index = l_phb_index[Index].index;
        l_phb_Shortentry->book = PHB_ADN; //TempEntry.book       
        return TRUE;
    } 
    //else return FALSE;
}

BOOL ReadNVMRecord( int Index,PhbkDetailItem * l_phb_NVMentry)
{  
    if ( CurrentTable != Index/PHB_table_len )
    {
        if ( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
            CurrentTable=Index/PHB_table_len;
        else return FALSE; 
    }
    memset(l_phb_NVMentry->memo,0,PHB_memo_len+3);
    FFS_PBData.NVMBook[Index%PHB_table_len].name[PHB_name_len]=0x00;
    FFS_PBData.NVMBook[Index%PHB_table_len].name[PHB_name_len+1]=0x00;
    FFS_PBData.NVMBook[Index%PHB_table_len].name[PHB_name_len+2]=0x00;
    memcpy(l_phb_NVMentry->name,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len+3);
    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_NVMentry->number);
    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_NVMentry->office);
    UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_NVMentry->home);
    memcpy(l_phb_NVMentry->memo,FFS_PBData.NVMBook[Index%PHB_table_len].memo,PHB_memo_len+1);
    l_phb_NVMentry->info=FFS_PBData.NVMBook[Index%PHB_table_len].info;
    return TRUE;  
}

BOOL FindName(const char * name,char * number)//return number
{
    int                i;
    T_MFW_PHB_ENTRY  l_phb_ShortEntry;
    PhbkDetailItem      l_phb_NVMEntry; 

    for ( i=0;i<PHBKTotal;i++ )
    {
        if ( strcmp((char *)l_phb_index[l_phb_sort_index[i].index].name,(char *)name)==0 )
        {
            if ( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
            {
                if ( ReadSIMRecord(l_phb_index[l_phb_sort_index[i].index].index,&l_phb_ShortEntry)==TRUE )
                {
                    strncpy(number,(char *)l_phb_ShortEntry.number,PHB_number_len);
                    return TRUE;
                }
            }
            else if ( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
            {
                if ( ReadNVMRecord(l_phb_index[l_phb_sort_index[i].index].index,&l_phb_NVMEntry)==TRUE )
                {
                    switch ( CheckFirstNumFlag(l_phb_sort_index[i].index) )
                    {
                    case 0x01:
                        {
                            strncpy(number,(char *)l_phb_NVMEntry.number,PHB_number_len); 
                            return TRUE;
                        }         
                        break;
                    case 0x02:
                        {
                            strncpy(number,(char *)l_phb_NVMEntry.home,PHB_number_len);
                            return TRUE;                             
                        }          
                        break;
                    case 0x03:
                        {
                            strncpy(number,(char *)l_phb_NVMEntry.office,PHB_number_len);
                            return TRUE;
                        }          
                        break;
                    }                              
                }
            }
        }
    }

    return FALSE;      
}

//yq added for mo in phb or ldn
BOOL SetCallData(T_EasyName data)
{
    memset(&CallData,0,sizeof(T_EasyName));
    memcpy(CallData.name,data.name,PHB_name_len+2);
    memcpy(CallData.number,data.number,PHB_number_len+1);
    return TRUE;
}

BOOL FindCallNumber(char *number,T_FindName * searchdata)
{
    TRACE_FUNCTION("findcallnumber()");
    TRACE_EVENT(number);
/*	if ((bookPhoneBookLoading()==BOOK_FAILURE)) 
        {
            SimReadyFlag=1;
            return FALSE;
        }
    else
        SimReadyFlag=0;
*/  if ( SameNumber(number,(char *)CallData.number)==0 )
    {
        TRACE_EVENT("we neednot call findnumber");
        if ( wstrlen((char *)CallData.name)!=0 )
        {
            memcpy(searchdata->name,CallData.name,PHB_name_len+2);
            memset(&CallData,0,sizeof(T_EasyName));
            return TRUE;
        }
        else
            return FALSE;
    }
    else
    {
        memset(&CallData,0,sizeof(T_EasyName));
        return FindNumber(number,searchdata);
    }
}
//end yq added 
BOOL FindNumber(char *number,T_FindName * searchdata)//return name
{
    int               i,j;
    unsigned char     backstr[PHB_name_len];
    T_MFW_PHB_ENTRY l_phb_ShortEntry;
    BOOL             backvalue;
    char              temp[100];
    TRACE_FUNCTION("findnumber()");
    TRACE_EVENT(number);
    memset(backstr,'\0',PHB_name_len);
    backvalue=FALSE;
	/* 2004/04/30 sunsj modify */
	memset(searchdata->name, 0x00, PHB_name_len+3);

    searchdata->GroupIndex=0xff;//iniatial, availd value is 0-9
    searchdata->GroupingIcon=0xff;
    searchdata->GroupingRing=0xff;
    SimReadyFlag=1;    //hu binhao 2002-12-28 "1" represent the sim card not read 
    if ( (bookPhoneBookLoading()==BOOK_FAILURE) ) return FALSE;
    else
    {
        if ( SIMLoadingPhbk==FALSE )
        {
            if ( !no_wait )
            {
                GetSIMData();
                phb_get_upn();
                SIMLoadingPhbk=TRUE;
            }
            else
                return FALSE;
        }
    }   

    TRACE_EVENT("fuzhiqiang");
    for ( i=0;i<PHBKTotal;i++ )
    {
        if ( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
        {
            for ( j=0;j<3;j++ )
            {
                //sprintf(temp,"Com_number:%x",GetShortNumber(number));
                //TRACE_EVENT(temp);

                if ( l_phb_index[l_phb_sort_index[i].index].number[j]==GetShortNumber(number) )
                {
                    if ( CurrentTable!=l_phb_sort_index[i].index/PHB_table_len )
                    {
                        flash_PBread(PBTable[l_phb_sort_index[i].index/PHB_table_len]); 
                        CurrentTable=l_phb_sort_index[i].index/PHB_table_len;                                         
                    }

                    switch ( j )
                    {
                    case 0 :
                        UnCompressNum((char *)FFS_PBData.NVMBook[l_phb_sort_index[i].index%PHB_table_len].number,backstr);
                        break;
                    case 1 :
						/* 2003/12/01 sunsj modidy office and home turn */
                        //UnCompressNum((char *)FFS_PBData.NVMBook[l_phb_sort_index[i].index%PHB_table_len].office,backstr); 
                        UnCompressNum((char *)FFS_PBData.NVMBook[l_phb_sort_index[i].index%PHB_table_len].home,backstr);
                        break;
                    case 2 :
						/* 2003/12/01 sunsj modidy office and home turn */
                        //UnCompressNum((char *)FFS_PBData.NVMBook[l_phb_sort_index[i].index%PHB_table_len].home,backstr);
                        UnCompressNum((char *)FFS_PBData.NVMBook[l_phb_sort_index[i].index%PHB_table_len].office,backstr);
                        break; 
                    default:break;
                    }                 
                    if ( SameNumber((char *)backstr,number)==0 )
                    {
                        //TRACE_EVENT("zy:findnumber OK");
                        if ( l_phb_index[l_phb_sort_index[i].index].name[0]==0x80 )
                            wstrncpy((char *)searchdata->name,(char *)l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);
                        else
                            strncpy((char *)searchdata->name,(char *)l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);                   
                        searchdata->GroupingIcon=FFS_PBOtherData.GroupingItem[CheckGroupingFlag(l_phb_sort_index[i].index)].GroupingIcon;
                        searchdata->GroupingRing=FFS_PBOtherData.GroupingItem[CheckGroupingFlag(l_phb_sort_index[i].index)].GroupingRing;
                        searchdata->GroupIndex=CheckGroupingFlag(l_phb_sort_index[i].index);
                        //TraceInt(CheckGroupingFlag(l_phb_sort_index[i].index));
                        //TraceInt(searchdata->GroupingIcon);
                        //TraceInt((int)FFS_PBOtherData.GroupingItem[CheckGroupingFlag(l_phb_sort_index[i].index)].GroupingIcon);
                        backvalue=TRUE;
                        break;
                    }
                    else memset(backstr,'\0',PHB_name_len);                  
                }
            }
        }
        else if ( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
        {
            //sprintf(temp,"Com_number:%x",GetShortNumber(number));
            //TRACE_EVENT(temp);

            if ( l_phb_index[l_phb_sort_index[i].index].number[0]=GetShortNumber(number) )
            {
                if ( ReadSIMRecord(l_phb_sort_index[i].index,&l_phb_ShortEntry)==TRUE )
                {
                    if ( SameNumber(number,(char *)l_phb_ShortEntry.number)==0 )
                    {
                        TRACE_EVENT("OK");
                        memcpy(backstr,l_phb_ShortEntry.number,PHB_name_len);                                                                                                               
                        if ( l_phb_index[l_phb_sort_index[i].index].name[0]==0x80 )
                            wstrncpy((char *)searchdata->name,(char *)l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);
                        else
                            strncpy((char *)searchdata->name,(char *)l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);
                        searchdata->GroupingIcon=0xff;
                        searchdata->GroupingRing=0xff;
                        TRACE_EVENT("zy:searchdata->GroupingRing=0");
                        backvalue=TRUE;
                    }
                }
            }
        }
        if ( backvalue==TRUE ) break;
    }

    SimReadyFlag=0;    //hu binhao 2002-12-28 0"represent the sim card read 
    return backvalue;
}

//yq added for compare two number
static int SameNumber(char *number1,char * number2)
{
    char tempnumber1[21]="";
    char tempnumber2[21]="";
    TRACE_FUNCTION("samenumber()");
    TRACE_EVENT("number1");
    TRACE_EVENT(number1);
    TRACE_EVENT("number2");
    TRACE_EVENT(number2);
    if ( number1[0]=='+' )
        memcpy(tempnumber1,&number1[3],18);
    else if ( number1[0]=='0'&&number1[1]=='0' )
        memcpy(tempnumber1,&number1[4],17);
    else
        memcpy(tempnumber1,number1,21);
    if ( number2[0]=='+' )
        memcpy(tempnumber2,&number2[3],18);
    else if ( number2[0]=='0'&&number2[1]=='0' )
        memcpy(tempnumber2,&number2[4],17);
    else
        memcpy(tempnumber2,number2,21);
    TRACE_EVENT("tempnumber1");
    TRACE_EVENT(tempnumber1);
    TRACE_EVENT("tempnumber2");
    TRACE_EVENT(tempnumber2);
    return strcmp(tempnumber1,tempnumber2);

}
//end yq added
//yq added for make sms quickly
BOOL FindSmsNumber(char *number,T_FindName * searchdata)
{
    int i;
    BOOL sucess;
    TRACE_FUNCTION("findsmsnumber()");
    for ( i=0;i<MAX_SMSNAME;i++ )
    {
        if ( GetShortNumber(number)==GetShortNumber(SmsName[i].number) )
        {
            if ( SameNumber(number,SmsName[i].number) )
            {
                if ( wstrlen((char *)SmsName[i].name)!=0 )
                {
                    memcpy(searchdata->name,SmsName[i].name,PHB_name_len+2);
                    SmsName[i].usertime=SmsName[i].usertime+1>127?127:SmsName[i].usertime+1;
                    return TRUE;
                }
                else
                    return FALSE;
            }
        }

    }
    sucess= FindNumber(number,searchdata);
    if ( sucess )//we found the name
    {
        T_EasyName add_name;
        memset(&add_name,0,sizeof(T_EasyName));
        memcpy(add_name.number,number,PHB_number_len);
        memcpy(add_name.name,searchdata->name,PHB_name_len);
        AddSmsDataName(add_name);
    }
    else//we don't found
    {
        T_EasyName add_name;
        memset(&add_name,0,sizeof(T_EasyName));
        memcpy(add_name.number,number,PHB_number_len);
        AddSmsDataName(add_name);
    }
    //add this number to smsdata
    return sucess;
}

static void AddSmsDataName(T_EasyName AddName)//we need add a number and name to smsdata
{
    int i,changeindex,j=127;
    TRACE_FUNCTION("ChangeSmsDataName()");
    for ( i=0;i<MAX_SMSNAME;i++ )
    {
        if ( wstrlen(SmsName[i].number)==0&&wstrlen(SmsName[i].name)==0 )
        {
            memcpy(SmsName[i].name,AddName.name,PHB_name_len);
            memcpy(SmsName[i].number,AddName.number,PHB_number_len);
            SmsName[i].usertime=0;
            break;
        }
        else
        {
            if ( SmsName[i].usertime<j )
            {
                j=SmsName[i].usertime;
                changeindex=i;
            }

        }
    }
    if ( i>=MAX_SMSNAME )
    {
        memcpy(SmsName[changeindex].name,AddName.name,PHB_name_len);
        memcpy(SmsName[changeindex].number,AddName.number,PHB_number_len);
        SmsName[changeindex].usertime=0;
    }
}

void ChangeSmsDataName(T_EasyName  NumChangeName)
{
    int i;
    TRACE_FUNCTION("ChangeSmsDataName()");
    for ( i=0;i<MAX_SMSNAME;i++ )
    {
        if ( GetShortNumber(NumChangeName.number)==GetShortNumber(SmsName[i].number) )
        {
            if ( SameNumber(NumChangeName.number,SmsName[i].number) )
            {
                memset(SmsName[i].name,0,PHB_name_len+3);
                memcpy(SmsName[i].name,NumChangeName.name,PHB_name_len);
            }
        }
    }
}

void SetSmsDataNull()
{
    TRACE_FUNCTION("SetSmsDataNull()");
    memset(SmsName,0,sizeof(SmsName));
    return;
}
//end yq added
/*******************************************************************************
                                                                              
                                End of File
                                                                              
*******************************************************************************/

