/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MmiChineseInput
 $File:		    MmiChineseInput.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:MMI Chinese Input handling.
 

                         
********************************************************************************

 $History: MmiChineseInput.c

    25/10/00			Original Condat(UK) BMI version.
    10/11/2003          sunsj
                        fix the bug that can't insert char to text.
       
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#include <stdio.h>
#include <string.h>
/*kk tracing*/

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif


/*kk tracing end*/

//#include "mfw_sys.h"

//GW #include "stddefs.h"    // needed for mfw_mfw.h
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiDummy.h"
//JVJE #include "MmiMsgsEdit.h"
//#include "MmiLists.h"
#include "MmiMmi.h"

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MMIChineseInput.h"
//#include "MmiLatinPredText.h"
#include "Mmieditor_i.h"
#include "MmiSmsBroadcast.h"
#include "MmiSmsMenu.h"
#include "MmiSmsSend.h"
/* JF Modified */
//#include "MmiBookController.h"
//#include "cus_aci.h"
//#include "p_sim.h"
//#include "pcm.h"

/* Joseph Lee modified */
//#include "MmiSmsSend.h
/* START NEW PART */

//extern int SymbolChar;

/* 2003/10/13 sunsj/ store pinyin element */
typedef struct
{
    ZI8SHORT Count;
    ZI8WCHAR PinyinEleBUF[10][6];
} Pinyin_EleBUF;

static const unsigned char TextIconeZiTextSmall[] =
{
    0x03,
    0x03,
    0x18,
    0x7c,
    0xcc,
    0x08,
    0x10,
    0x0c
};

USHORT  TEXT_BUFFER_EDIT_SIZE;
static ZI8WCHAR chinese_input_buffer[70];   /* 2003/10/13 sunsj */
static int  editor_input_mode;              /* 2003/10/26 sunsj */
extern TextCursor;
#define   MaxPinYin 402						/* 2003/10/13 sunsj */

const char  StrokePrompt[]  = {0x7B, 0x14, 0x52, 0x12, 0x00, 0x3A, 0x00, 0x00};
const char  PinYinPrompt[]  = {0x62, 0xFC, 0x97, 0xF3, 0x00, 0x3A, 0x00, 0x00};
ZI8WCHAR const ZiStrokeKeyMap[10][3] =   /* table for PINYIN */
{
    {0,   ZI8_STROKE_MORE},
    {1,   ZI8_STROKE_OVER},
    {2,   ZI8_STROKE_DOWN},
    {3,   ZI8_STROKE_LEFT},
    {4,   ZI8_STROKE_DOT},
    {5,   ZI8_STROKE_OVER_DOWN},
    {6,   ZI8_STROKE_CURVED_HOOK},
    {7,   ZI8_STROKE_DOWN_OVER},
    {8,   ZI8_STROKE_MORE},
    {9,   ZI8_STROKE_OVER_DOWN_OVER},
};

ZI8WCHAR const ZiPinYinKeyMap[9][6] =   /* table for PINYIN */
{
    {ZI8_CODE_TONES_1,    ZI8_CODE_TONES_2,   ZI8_CODE_TONES_3,   ZI8_CODE_TONES_4,   ZI8_CODE_TONES_5,   5},
    {ZI8_CODE_PINYIN_A,   ZI8_CODE_PINYIN_B,  ZI8_CODE_PINYIN_C,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_D,   ZI8_CODE_PINYIN_E,  ZI8_CODE_PINYIN_F,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_G,   ZI8_CODE_PINYIN_H,  ZI8_CODE_PINYIN_I,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_J,   ZI8_CODE_PINYIN_K,  ZI8_CODE_PINYIN_L,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_M,   ZI8_CODE_PINYIN_N,  ZI8_CODE_PINYIN_O,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_P,   ZI8_CODE_PINYIN_Q,  ZI8_CODE_PINYIN_R,  ZI8_CODE_PINYIN_S,  0,                  4},
    {ZI8_CODE_PINYIN_T,   ZI8_CODE_PINYIN_U,  ZI8_CODE_PINYIN_V,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_W,   ZI8_CODE_PINYIN_X,  ZI8_CODE_PINYIN_Y,  ZI8_CODE_PINYIN_Z,  0,                  4},
};

/* 2003/10/13 sunsj add for pinyin input */
static const char  * PinyinTable[MaxPinYin] = {
    "a","ai","an","ang","ao","ba","bai","ban","bang","bao",
    "bei","ben","beng","bi","bian","biao","bie","bin","bing","bo",
    "bu","ca","cai","can","cang","cao","ce","cen","ceng","cha",
    "chai","chan","chang","chao","che","chen","cheng","chi","chong","chou",
    "chu","chuai","chuan","chuang","chui","chun","chuo","ci","cong","cou",
    "cu","cuan","cui","cun","cuo","da","dai","dan","dang","dao",
    "de","deng","di","dia","dian","diao","die","ding","diu","dong",
    "dou","du","duan","dui","dun","duo","e","ei","en","er",
    "fa","fan","fang","fei","fen","feng","fo","fou","fu","ga",
    "gai","gan","gang","gao","ge","gei","gen","geng","gong","gou",
    "gu","gua","guai","guan","guang","gui","gun","guo","ha","hai",
    "han","hang","hao","he","hei","hen","heng","hong","hou","hu",
    "hua","huai","huan","huang","hui","hun","huo","ji","jia","jian",
    "jiang","jiao","jie","jin","jing","jiong","jiu","ju","juan","jue",
    "jun","ka","kai","kan","kang","kao","ke","ken","keng","kong",
    "kou","ku","kua","kuai","kuan","kuang","kui","kun","kuo","la",
    "lai","lan","lang","lao","le","lei","leng","li","lia","lian",
    "liang","liao","lie","lin","ling","liu","long","lou","lu","luan",
    "lue","lun","luo","lv","ma","mai","man","mang","mao","me",
    "mei","men","meng","mi","mian","miao","mie","min","ming","miu",
    "mo","mou","mu","na","nai","nan","nang","nao","ne","nei",
    "nen","neng","ni","nian","niang","niao","nie","nin","ning","niu",
    "nong","nou","nu","nuan","nue","nuo","nv","o","ou","pa",
    "pai","pan","pang","pao","pei","pen","peng","pi","pian","piao",
    "pie","pin","ping","po","pou","pu","qi","qia","qian","qiang",
    "qiao","qie","qin","qing","qiong","qiu","qu","quan","que","qun",
    "ran","rang","rao","re","ren","reng","ri","rong","rou","ru",
    "ruan","rui","run","ruo","sa","sai","san","sang","sao","se",
    "sen","seng","sha","shai","shan","shang","shao","she","shen","sheng",
    "shi","shou","shu","shua","shuai","shuan","shuang","shui","shun","shuo",
    "si","song","sou","su","suan","sui","sun","suo","ta","tai",
    "tan","tang","tao","te","teng","ti","tian","tiao","tie","ting",
    "tong","tou","tu","tuan","tui","tun","tuo","wa","wai","wan",
    "wang","wei","wen","weng","wo","wu","xi","xia","xian","xiang",
    "xiao","xie","xin","xing","xiong","xiu","xu","xuan","xue","xun",
    "ya","yan","yang","yao","ye","yi","yin","ying","yo","yong",
    "you","yu","yuan","yue","yun","za","zai","zan","zang","zao",
    "ze","zei","zen","zeng","zha","zhai","zhan","zhang","zhao","zhe",
    "zhen","zheng","zhi","zhi","zhong","zhou","zhu","zhua","zhuai","zhuan",
    "zhuang","zhui","zhun","zhuo","zi","zong","zou","zu","zuan","zui","zun","zuo"
};

typedef struct _IME_DATA
{
    int             CandidateCursor;    /* the indication of the current candidate highlighted */
    unsigned short  TextBufferCount;    // Total number of characters contained in the wszTextBuffer.
    unsigned char   candidates;         /* last returned number of candidates */
    int             TextCursor;         /* the current test cursor */
    PZI8WCHAR       pTextBuffer;        /* the start of the text buffer */
    int             TextBufferEditSize; /*  */
    int             TextBufferSize;     /*  */
    unsigned char   moreCount;          /* keeps track of the more count */
    PZI8WCHAR       pDisplayElementBuffer;
    ZI8UCHAR        EditorMode;         // To store current editor mode i.e. stroke, PinYin
    unsigned char   InputScreenType;    // This variable is to state the different screen type. 
    PZI8GETPARAM    pGetParam;          /* pointer to Zi8GetParam */
    Pinyin_EleBUF   PinyinElementBUF[6];    /* 2003/10/13 sunsj/ pinyin element buffer */
    USHORT      PinyinDisplayBuf[ELEMENT_PERPAGE][TEXT_BUFFER_EXTRA_SPACE+1];   /* 2003/10/13 sunsj/ pinyin display buffer */
    USHORT      Element_Select;         /* 2003/10/13 sunsj/ the pinyin which user select */
    USHORT      ElementNumber;          /* 2003/10/13 sunsj/ the whole pinyin number */
    ZI8WCHAR        Association_Buffer[10]; /* 2003/10/13 sunsj/ association buf */
} IME_DATA, * pIME_DATA;

typedef struct
{
    T_MMI_CONTROL       mmi_control;
    T_MFW_HND           parent_win;
    T_MFW_HND           input_win;
    T_MFW_HND           input_kbd;
//    T_MFW_HND			edt;
    USHORT              Identifier;

    ZI8UCHAR            version;    
    ZI8WCHAR*           wszTextBuffer;/*[TEXT_BUFFER_EDIT_SIZE + 1];*/  /* TEXT_BUFFER_EDIT_SIZE = 80 */
    ZI8WCHAR            DisplayElementBuffer[TEXT_BUFFER_EXTRA_SPACE + 1];  /* TEXT_BUFFER_EXTRA_SPACE = 20 */
    ZI8WCHAR            wszElementBuffer[TEXT_BUFFER_EXTRA_SPACE + 1];      /* TEXT_BUFFER_EXTRA_SPACE = 20 */
    ZI8GETPARAM         GetParam;
    IME_DATA            Ime;
    ZI8WCHAR            wcCandidates[2*CANDIDATES_PER_GROUP+1];           /* CANDIDATES_PER_GROUP = 7 */    /* 2003/10/13 sunsj */
    ZI8WCHAR            StartOfDisplayIndex;
    ZI8WCHAR            HighlightedCandidate[2];  // This arrary is used to store the highlighted character pointed by CandidateCursor
    ZI8WCHAR            CursorPosition[2];  //Used to show the cursor Position in the composed text.
    ZI8UCHAR            NumberOfKeyPress;
    CHAR                PerviousKeyPress;
    T_MFW_HND           options_win;
    //MfwEdtAttr		edt_attr;
    /* Start of variable decleared for dummy functions. This is to be removed when eZiText code is received*/
    /* End */
    T_CHINESE_DATA      Callback_Data;
} T_chinese_input;

static T_MFW_HND    chinese_input_create        (T_MFW_HND  parent_win);
static void     chinese_input_exec          (T_MFW_HND  win, USHORT event, SHORT value, void * parameter);
static int  chinese_input_win_cb        (T_MFW_EVENT event, T_MFW_WIN * win);
static int  chinese_input_kbd_cb        (T_MFW_EVENT event, T_MFW_KBD * keyboard);

/* Initialize the defined structure */
void IMEInitialize(pIME_DATA pIME, PZI8GETPARAM pGetParam, PZI8WCHAR wszTextBuffer, int TextBufferEditSize,
                   int TextBufferSize, PZI8WCHAR wcCandidates, PZI8WCHAR wszElementBuffer, PZI8WCHAR DisplayElementBuffer);
void IMECursorLeft(pIME_DATA pIME); /* move the cadidate cursor left */
void IMECursorRight(pIME_DATA pIME); /* move the cadidate cursor right */
void IMESelectCandidate(pIME_DATA pIME, PZI8WCHAR wszElementBuffer); /* Select the candidate at sursor */
void IMEMore(pIME_DATA pIME); /* get the next group of candidates */
void IMEKeyPress(pIME_DATA pIME, ZI8WCHAR wcStroke); /* enter the stroke and get new candidates */
void IMEClear(pIME_DATA pIME, PZI8WCHAR wszElementBuffer); /* Clear the last stroke entered */
void CandidateHighlightDisplayContorl(pIME_DATA pIME, PZI8WCHAR HighlightedCandidate);
void TextCursorDisplayContorl(pIME_DATA pIME, PZI8WCHAR CursorPosition, int InsertLine);
void IMEChangeMode(pIME_DATA pIME, PZI8GETPARAM pGetParam);
void DataConvert(pIME_DATA pIME);
ZI8WCHAR Uni_strlen(PZI8WCHAR String);

/* 2003/10/13 sunsj/ onekey press pinyin method */
void Zi_onekey_keypress(pIME_DATA pIME , PZI8WCHAR key_map);    /* enter the key and get pinyin and candidate */
int Zi_GetElementCandidates(pIME_DATA pIME);                    /* getcandidate through element */
void UnicodeConver(USHORT* inputString, USHORT* outputString);
void Zi_onekey_clear(pIME_DATA pIME);   /* clear element or text */
void IMECandidatePageUp(pIME_DATA pIME);    /* page up candidate */
void IMECandidatePageDown(pIME_DATA pIME);  /* page down candidate */
void ElementHighlightDisplayContorl(pIME_DATA pIME);    /* display highlight element */

/*************************************************************************
   Start: Fummy functions. This is to be removed when eZiText code is received 
/*************************************************************************/
//ZI8UCHAR Zi8GetCandidates(PZI8GETPARAM pGetParam);
//void Zi8Initialize(void);
/* End */
UBYTE LatinChar(ZI8WCHAR char_code)
{   //if last byte is 0x00 and first byte is between 0x20 and 0x7E
    if ( (char_code% 0x100 == 0)&&(char_code>=0x2000) && (char_code<0x7F00) )
        return TRUE;
    else
        return FALSE;
}

/*******************************************************************************

 $Function:    	chinese_input

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND chinese_input (T_MFW_HND parent_win, T_CHINESE_DATA* chinese_data, SHORT kc)
{
    T_MFW_HND   win;
	//MfwEdt *edit = ((MfwHdr *) myHandle)->data;

    win = chinese_input_create (parent_win);
    if ( win NEQ NULL )
    {
        //SEND_EVENT (win, CHINESE_INPUT_INIT, 0, chinese_data);
        SEND_EVENT (win, CHINESE_INPUT_INIT, kc, chinese_data);
    }
    return win;
}


/*******************************************************************************

 $Function:    	chinese_input_create

 $Description:	
 
 $Returns:		Dialogue info win

 $Arguments:	parent win
 
*******************************************************************************/
static T_MFW_HND chinese_input_create (T_MFW_HND parent_win)
{
    T_MFW_WIN     *  win_data;
    T_chinese_input  *  data = (T_chinese_input *)ALLOC_MEMORY (sizeof (T_chinese_input));

    //TRACE_EVENT ("chinese_input_create()");

    data->input_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)chinese_input_win_cb);
    if ( data->input_win EQ 0 )
        return 0;
    /* Create window handler */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)chinese_input_exec;
    data->mmi_control.data      = data;
    data->parent_win            = parent_win;
    win_data                    = ((T_MFW_HDR *)data->input_win)->data;
    win_data->user              = (void *)data;
    /*return window handle */
    return data->input_win;
}


/*******************************************************************************

 $Function:    	chinese_input_destroy

 $Description:	Destruction of an information dialog
 
 $Returns:		void

 $Arguments:	win
 
*******************************************************************************/
void chinese_input_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    T_chinese_input  * data = (T_chinese_input *)win->user;
    //TRACE_EVENT ("chinese_input_destroy()");
    /* 2003/11/10 sunsj */
    T_MFW_HND     parent_win         = mfw_parent (own_window);
    T_MFW_WIN     * parent_win_data  = ((T_MFW_HDR *)parent_win)->data;
    T_EDITOR_INFO * parent_data      = (T_EDITOR_INFO *)parent_win_data->user;
    MfwHdr *edit_hdr = (MfwHdr *)parent_data->edt_edt;
    MfwEdt *edit_controll = (MfwEdt *)edit_hdr->data;

    if ( data )
    {
        /* 2003/11/1 sunsj */
        if ( data->Ime.pTextBuffer == NULL )
            return;

        if ( data->Ime.pTextBuffer[0] )
        {
            //UnicodeConver((USHORT*)data->Ime.pTextBuffer, (USHORT*)data->Ime.pTextBuffer);
			/* 2003/11/27 sunsj */
            memcpy(&data->Callback_Data.TextString[1], chinese_input_buffer, TEXT_BUFFER_EDIT_SIZE);
            /* 2003/11/10 sunsj add text cursor */
            edit_controll->cp = data->Ime.TextCursor;
        }
        /* Exit TIMER & KEYBOARD Handle */
        kbd_delete (data->input_kbd);
        /* Delete WIN Handler */
        win_delete (data->input_win);
        /* Free Memory */
        FREE_MEMORY ((void *)data, sizeof (T_chinese_input));
    }
}


/*******************************************************************************

 $Function:    	chinese_input

 $Description:	

 $Returns:		void

 $Arguments:	win, window handle event, value, parameter

*******************************************************************************/
void chinese_input_exec (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN       * win_data      = ((T_MFW_HDR *)win)->data;
    T_chinese_input * data          = (T_chinese_input *)win_data->user;
    T_CHINESE_DATA  * chinese_data  = (T_CHINESE_DATA *)parameter;
    T_EDIT_CB       Callback   = data->Callback_Data.Callback;
    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->Callback_Data.Identifier;
    char debug[20];
    PZI8WCHAR       temp_ZiKeyMap;
    //TRACE_EVENT ("chinese_input_exec()");
    switch ( event )
    {
    case CHINESE_INPUT_INIT:
        data->Callback_Data = *chinese_data;
		/* 2003/11/27 sunsj */
        TEXT_BUFFER_EDIT_SIZE = (data->Callback_Data.EditorSize - 3);
		/* Initialize dialog */
        /* Create timer and keyboard handler */
        data->input_kbd = kbd_create (win, KEY_ALL, (T_MFW_CB)chinese_input_kbd_cb);
        /* Initialize all data structure and veriables to zero */
        memset(&data->Ime, 0, sizeof(data->Ime));
        //memset(&data->wszTextBuffer, 0, sizeof(data->wszTextBuffer));
        memset(&data->GetParam, 0, sizeof(data->Ime));
        memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
        memset(&data->HighlightedCandidate, 0, sizeof(data->HighlightedCandidate));
        memset(&data->CursorPosition, 0, sizeof(data->CursorPosition));
        memset(&data->DisplayElementBuffer, 0,sizeof(data->DisplayElementBuffer));
        data->StartOfDisplayIndex   = 0;
        data->NumberOfKeyPress      = 0;
        data->PerviousKeyPress      = -1;
        /* 2003/10/26 sunsj add for select input mode */
        editor_input_mode = chinese_data->InputMode;

        /* 2003/11/10 sunsj set text cursor */
        data->Ime.TextCursor = chinese_data->Cursor;

        /* Now intitialize the Zi8 Core Engine */
        Zi8Initialize();

        /* Now initialize the IME */
        /*
        memset(chinese_input_buffer, 0x0000, 70);
        memcpy(chinese_input_buffer, &data->Callback_Data.TextString[1], 140);
                */

        if ( (data->Callback_Data.TextString[0] & 0x80) != 0 )
        {
            data->Callback_Data.TextString[0] = 0x80;
            //data->wszTextBuffer = (PZI8WCHAR)(data->Callback_Data.TextString+1); //ignore first char (Unicode marker)		
            data->wszTextBuffer = chinese_input_buffer;

            /* 2003/11/27 sunsj */
            memset(chinese_input_buffer, 0x00, 140);
            memcpy(chinese_input_buffer, &data->Callback_Data.TextString[1], TEXT_BUFFER_EDIT_SIZE-3);
        }
        else
        {
            int i=0;

            while ( data->Callback_Data.TextString[i] )
            {
                i++;
            }

            data->wszTextBuffer = chinese_input_buffer;
            //data->wszTextBuffer++;

            /* 2003/11/27 sunsj convert ascii to unicode */
            for ( ; i>0; i-- )
            {
                data->Callback_Data.TextString[i*2] = data->Callback_Data.TextString[i-1];
                data->Callback_Data.TextString[i*2-1] = 0x00;
            }
            data->Callback_Data.TextString[0] = 0x80;

            /* 2003/11/27 sunsj */
            memset(chinese_input_buffer, 0x00, 140);
            memcpy(chinese_input_buffer, &data->Callback_Data.TextString[1], TEXT_BUFFER_EDIT_SIZE);
        }

        IMEInitialize(&data->Ime, &data->GetParam, data->wszTextBuffer, TEXT_BUFFER_EDIT_SIZE,
                      sizeof(data->wszTextBuffer), data->wcCandidates, data->wszElementBuffer, data->DisplayElementBuffer);

        /* Store any other data */
        /* 2003/10/13 sunsj/ the first key press */
        switch ( value )
        {
        case KCD_8:
            switch ( data->Ime.EditorMode )
            {
            case STROKE_INPUT_MODE:
                data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                IMEMore(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                winShow(win);
                break;
            case PINYIN_INPUT_MODE:
                data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;

                temp_ZiKeyMap = (PZI8WCHAR )ZiPinYinKeyMap[value-1];

                Zi_onekey_keypress(&data->Ime, temp_ZiKeyMap);

                /* due to not able to receive key press count, it is assume the first letter assign to the key is selected when key */
                /* is pressed.																					   */
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                winShow(win);
                break;
            default:
                break;
            }
            break;
        case KCD_1:
            switch ( data->Ime.EditorMode )
            {
            case STROKE_INPUT_MODE:
                data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                IMEKeyPress( &data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[value][1] + ZI8_BASE_STROKES) );
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                winShow(win);
                break;
            case PINYIN_INPUT_MODE:
                {
                    int candidate_num;
                    /* 2003/11/1 sunsj */
                    data->Ime.InputScreenType = WORD_ASSOCIATION_SCREEN;
                    data->Ime.pGetParam->ElementCount = 1;
                    data->Ime.pGetParam->pElements[data->Ime.pGetParam->ElementCount-1] = ZI8_CODE_MORE;

                    data->Ime.pGetParam->FirstCandidate = data->Ime.moreCount * CANDIDATES_PER_GROUP;
                    data->Ime.pGetParam->MaxCandidates = 2 * CANDIDATES_PER_GROUP;
                    data->Ime.candidates = Zi8GetCandidates(data->Ime.pGetParam);


                    if ( data->Ime.candidates > 0 )
                    {
                        /* Convert the data storage format for display purpose */
                        DataConvert(&data->Ime);
                        /* initialize the candidate cursor to zero */
                        data->Ime.CandidateCursor = 0;
                    }
                    /*
                    if( data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count == 1 )
                    {
                        return;
                    }

                    if(data->Ime.Element_Select == data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count-1)
                    {
                        data->Ime.Element_Select = 0;
                    }
                    else
                    {
                        data->Ime.Element_Select++;
                    }
                    candidate_num = Zi_GetElementCandidates(&data->Ime);
                    */
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                    winShow(win);
                }
                break;

            default:
                break;
            }
            break;
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_9: 
            switch ( data->Ime.EditorMode )
            {
            case STROKE_INPUT_MODE:
                data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[value][1] + ZI8_BASE_STROKES));
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                winShow(win);
                break;
            case PINYIN_INPUT_MODE:
                temp_ZiKeyMap = (PZI8WCHAR )ZiPinYinKeyMap[value-1];
                data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;
                Zi_onekey_keypress(&data->Ime, temp_ZiKeyMap);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                winShow(win);
                break;

            default:
                break;
            }
            break;
        default:
            win_show (win);
            break;
        }
        break;
    case CHINESE_INPUT_DESTROY:
        {/* on DEINIT => selfdestroy; sendevent <value> */
            int i;

            if ( data->Callback_Data.DestroyEditor == TRUE )
            {
                ZI8WCHAR Temp, LowByte, HighByte;


                for ( i = 0; i < (/*data->Ime.TextBufferCount*/data->Callback_Data.EditorSize ); i++ )
                {
                    Temp = data->wszTextBuffer[i];
                    LowByte = data->wszTextBuffer[i] & 0x00FF;
                    HighByte = data->wszTextBuffer[i] & 0xFF00;
                    Temp = (LowByte << 8) & 0xFF00;
                    HighByte = (HighByte >> 8) & 0x00FF;
                    Temp = Temp |HighByte;
                    data->wszTextBuffer[i] = Temp;
                }
            }
            for ( i=(data->Ime.TextBufferCount ); i < TEXT_BUFFER_EDIT_SIZE; i++ )
                data->wszTextBuffer[/*data->Ime.TextBufferCount*/i] = 0x0000;//terminate string

            if ( Callback )
            { //TRACE_EVENT("Running Callback");
                (Callback) (parent_win, Identifier, value);
                sprintf(debug, "Identifier: %d", Identifier);
                //TRACE_EVENT(debug);
            }


            if ( data->Callback_Data.DestroyEditor == TRUE )
            {
                chinese_input_destroy(win);
            }
        }

        break;
    case ADD_SYMBOL:
        if ( data->Ime.TextBufferCount < TEXT_BUFFER_EDIT_SIZE )
        {
            int i=0;
            int j=0;

            if ( data->Ime.TextCursor < data->Ime.TextBufferCount ) /* locate the text cursor position for correct character insertion */
            {
                for ( i=data->Ime.TextCursor; i<data->Ime.TextBufferCount; i++ ) /* shift and move characters to make rooms to insert the selected character */
                {
                    //pIME->pTextBuffer[pIME->TextBufferCount - i + 1]=pIME->pTextBuffer[pIME->TextBufferCount - i];
                    data->Ime.pTextBuffer[data->Ime.TextBufferCount - j]=data->Ime.pTextBuffer[data->Ime.TextBufferCount - j - 1];
                    j++;
                }
            }

            //data->Ime.pTextBuffer[data->Ime.TextCursor++]= (ZI8WCHAR)(SymbolChar << 8);
            data->Ime.TextBufferCount++;
        }
        win_show(win);
        break;
    case LATIN_INPUT:
        data->Ime.TextBufferCount = Uni_strlen(data->Ime.pTextBuffer);
        data->Ime.TextCursor = data->Ime.TextBufferCount;
        break;
    }
}


/*******************************************************************************

 $Function:    	chinese_input_win_cb

 $Description:	
 
 $Returns:		void

 $Arguments:	window handle event, win
*******************************************************************************/
static int chinese_input_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_chinese_input * data = (T_chinese_input *)win->user;
    int i = 0;
    int j = 0;
    PZI8WCHAR   Temp_ptr;
    UINT32 oldColor;    /* 2003/10/13 sunsj */
    int current_pixel;  /* 2003/10/13 sunsj */
    int current_x = 0, current_y = 0;   /* 2003/10/13 sunsj */
    BOOL conver_page = FALSE;   /* 2003/10/13 sunsj */
	char spareNum[10];

    //TRACE_EVENT ("chinese_input_win_cb()");

    if ( data EQ 0 )
        return 1;
    switch ( event )
    {
    case E_WIN_VISIBLE:
        if ( win->flags & E_WIN_VISIBLE )
        {
            /* Print the information dialog */
            /* Clear Screen */
            oldColor=dspl_GetBkgColor();
            dspl_SetBkgColor(0xe6ffff);
            dspl_Clear(0,0,120,131);
            //dspl_ClearAll();
            //dspl_BitBlt(0, 0, menuup[0].area.sx, menuup[0].area.sy, 0, (void*)menuup[0].icons, 0);
			DRAW_ICON(ICON_MENUUP);
			sprintf(spareNum, "%d", (data->Ime.TextBufferEditSize/2 - data->Ime.TextBufferCount));
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                {
                    /* This section of the code was written to display the data stored in the text buffer. The text cursor position */
                    /* was also taken into consideration to display the correct portion of text during editing (when data stored in */
                    /* the text buffer is more than two line display.   */
                    ZI8WCHAR TempArray[CANDIDATES_PER_GROUP*2]; //maximum no of chars possible in a line
                    ZI8WCHAR TempArray2[CANDIDATES_PER_GROUP+1];
                    int i;
                    int space_counter;

                    UBYTE first_line= 0; //no of chars in first line(set to minimum)
                    UBYTE second_line=0; //no of chars in second line

                    //dspl_BitBlt(75,0,LINE_HEIGHT,LINE_HEIGHT,0,(char*)TextIconeZiTextSmall,0); 

                    memset(TempArray, 0, CANDIDATES_PER_GROUP*2);
                    //dspl_TextOut(4,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
#if 0
                    if ( data->Ime.TextBufferCount == 0 ) //If text buffer is empty
                    {
                        displaySoftKeys(data->Callback_Data.LeftSoftKey,TxtSoftBack);   /* Softkey display*/
                    }
                    else if ( data->Ime.TextBufferCount <= (CANDIDATES_PER_GROUP * 2) ) // data in text buffer is within 2 lines
                    {
                        for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                            TempArray[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i];
                        TempArray[CANDIDATES_PER_GROUP] = 0x0000;

                        dspl_TextOut(1,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char*)/*Temp_ptr*/TempArray);
                        if ( data->Ime.TextBufferCount > CANDIDATES_PER_GROUP )
                        {
                            //Temp_ptr += CANDIDATES_PER_GROUP;
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray2[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i+CANDIDATES_PER_GROUP];
                            TempArray2[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray2);
                        }
                        j = (data->Ime.TextCursor / CANDIDATES_PER_GROUP) + 1;
                        TextCursorDisplayContorl(&data->Ime, data->CursorPosition, j);

                        /* 2003/10/13 sunsj/ mark */
                        //displaySoftKeys(data->Callback_Data.LeftSoftKey,TxtDelete);     /* Softkey display*/
                    }
                    else // data in text buffer is more than 14 characters. 
                    {
                        if ( data->Ime.TextCursor == data->StartOfDisplayIndex )
                        {
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i];
                            //Temp_ptr = &data->wszTextBuffer[data->StartOfDisplayIndex];
                            TempArray[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray);
                            //Temp_ptr += CANDIDATES_PER_GROUP;
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray2[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i +CANDIDATES_PER_GROUP];
                            TempArray2[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray2);
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 1); 
                        }
                        else if ( data->Ime.TextCursor > data->StartOfDisplayIndex )
                        {
                            while ( data->Ime.TextCursor - data->StartOfDisplayIndex >= CANDIDATES_PER_GROUP*2 )
                            {
                                data->StartOfDisplayIndex = data->StartOfDisplayIndex + CANDIDATES_PER_GROUP;
                            }
                            //Temp_ptr = &data->wszTextBuffer[data->StartOfDisplayIndex];
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i];
                            TempArray[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray);

                            //Temp_ptr += CANDIDATES_PER_GROUP;
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray2[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i +CANDIDATES_PER_GROUP];
                            TempArray2[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray2);

                            if ( (data->Ime.TextCursor - data->StartOfDisplayIndex) < CANDIDATES_PER_GROUP )
                                j = 1;
                            else if ( (data->Ime.TextCursor - data->StartOfDisplayIndex) < CANDIDATES_PER_GROUP * 2 )
                                j = 2;
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, j);
                        }
                        else if ( data->Ime.TextCursor < data->StartOfDisplayIndex && data->StartOfDisplayIndex != 0 )
                        {
                            data->StartOfDisplayIndex = data->StartOfDisplayIndex - CANDIDATES_PER_GROUP;
                            //Temp_ptr = &data->wszTextBuffer[data->StartOfDisplayIndex];
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i ];
                            TempArray[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray);
                            //Temp_ptr += CANDIDATES_PER_GROUP;
                            for ( i=0; i<CANDIDATES_PER_GROUP; i++ )
                                TempArray2[i]= data->wszTextBuffer[data->StartOfDisplayIndex+ i +CANDIDATES_PER_GROUP];
                            TempArray2[CANDIDATES_PER_GROUP] = 0x0000;
                            dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE,(char *)TempArray2);
                            if ( (data->Ime.TextCursor - data->StartOfDisplayIndex) < CANDIDATES_PER_GROUP )
                                j = 1;
                            else if ( (data->Ime.TextCursor - data->StartOfDisplayIndex) < CANDIDATES_PER_GROUP * 2 )
                                j = 2;
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, j);
                        }
                        displaySoftKeys(data->Callback_Data.LeftSoftKey,TxtDelete);     /* Softkey display*/
                    }
#endif
                }
                break;
            case STROKE_INPUT_SCREEN:
                /* Display the correct portion composed text stored in wszTextBuffer. If the text cursor is not pointing at */
                /* the end of the text buffer, the display content is then adjusted to display the correct portion of the   */
                /* text buffer.																				  */

                current_x = 0;
                current_y = FIRST_LINE;
                conver_page = FALSE;
                j=0;
                UnicodeConver(data->wszTextBuffer, data->wszTextBuffer);
                while ( data->wszTextBuffer[j] )
                {
                    current_pixel = get_CharWidth(data->wszTextBuffer[j]);
                    current_x += current_pixel;

                    /* 2003/10/28 sunsj modify the line width */
                    if ( current_x>112 )
                    {
                        current_y += 16;
                        current_x = current_pixel;
                    }
                    if ( current_y > FIFTH_LINE )
                    {
                        Temp_ptr = data->wszTextBuffer;
                        Temp_ptr = Temp_ptr + j;
                        current_y = 0;
                        conver_page = TRUE;
                    }
                    j++;
                }
                UnicodeConver(data->wszTextBuffer, data->wszTextBuffer);

                if ( conver_page == FALSE )
                {
                    if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                    {
                        dspl_TextOut(4,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                    }
                    else
                    {
                        dspl_TextOut(4,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                        TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                    }
                }
                else
                {
                    dspl_TextOut(4, FIRST_LINE, DSPL_TXTATTR_UNICODE, (char *)Temp_ptr);
                }
#if 0
                if ( data->Ime.TextBufferCount <=CANDIDATES_PER_GROUP )  //check text buffer count
                {
                    if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                    {
                        dspl_TextOut(1,0,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                    }
                    else
                    {
                        dspl_TextOut(1,0,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                        TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                    }
                }
                else //when data->Ime.TextBufferCount > CANDIDATES_PER_GROUP
                {
                    if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                    {
                        Temp_ptr = data->wszTextBuffer;
                        Temp_ptr = Temp_ptr + data->Ime.TextBufferCount - CANDIDATES_PER_GROUP;
                        dspl_TextOut(1,0,DSPL_TXTATTR_UNICODE,(char *)Temp_ptr);
                    }
                    else if ( data->Ime.TextCursor < CANDIDATES_PER_GROUP )
                    {
                        dspl_TextOut(1,0,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                        TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                    }
                    else
                    {
                        Temp_ptr = &data->wszTextBuffer[data->Ime.TextCursor] - CANDIDATES_PER_GROUP + 1;
                        dspl_TextOut(1,0,DSPL_TXTATTR_UNICODE,(char *)Temp_ptr);
                        dspl_TextOut(73,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)data->CursorPosition);
                    }
                }
                dspl_TextOut(0,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char*)StrokePrompt);   /* Display input prompt */
#endif
                dspl_colorTextOut(0,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT,(char*)StrokePrompt,0xffffff);   /* Display input prompt */ //sunsjtest
                /* 2003/10/26 sunsj add for stroke element display */
                dspl_TextOut(1,SIXTH_LINE,DSPL_TXTATTR_UNICODE,(char*)data->DisplayElementBuffer);

                /* Display candidate charaters returned from eZiText */
                dspl_TextOut(3,SEVENTH_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wcCandidates);
                dspl_DrawRect(0, 98, 119, 130);
                /* Highlight the candidate character pointed by Ime.CandidateCursor */
                CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);
                /* 2003/11/27 sunsj */
                displaySoftKeys(TxtSoftOK,TxtDelete);   /* Softkey display*/
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
				//displaySoftKeys(TxtSoftSelect,TxtSoftOK);   /* Softkey display*/
#if 0
                /* Display input sequence for stroke */
                i = Uni_strlen(data->DisplayElementBuffer);
                if ( i <= 4 )
                {
                    dspl_TextOut(36,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char*)data->DisplayElementBuffer);//data->wszElementBuffer);
                }
                else
                {
                    Temp_ptr = data->DisplayElementBuffer;
                    Temp_ptr = Temp_ptr + i - 4;
                    dspl_TextOut(36,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE,(char*)Temp_ptr);//data->wszElementBuffer);
                }
                /* Display candidate charaters returned from eZiText */
                dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE,(char*)data->wcCandidates);
                /* Highlight the candidate character pointed by Ime.CandidateCursor */
                CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);
                displaySoftKeys(TxtSoftSelect,TxtSoftOK);   /* Softkey display*/
#endif
                break;
            case PINYIN_INPUT_SCREEN:
                {
                    /* 2003/10/13 sunsj modify the display of input pinyin */
                    /* Display the correct portion composed text stored in wszTextBuffer. If the text cursor is not pointing at */
                    /* the end of the text buffer, the display content is then adjusted to display the correct portion of the   */
                    /* text buffer.																				  */
                    //if ( data->Ime.TextBufferCount <=CANDIDATES_PER_GROUP )  //check text buffer count
                    current_x = 0;
                    current_y = FIRST_LINE;
                    conver_page = FALSE;
                    j=0;
                    UnicodeConver(data->wszTextBuffer, data->wszTextBuffer);
                    while ( data->wszTextBuffer[j] )
                    {
                        current_pixel = get_CharWidth(data->wszTextBuffer[j]);
                        current_x += current_pixel;

                        /* 2003/12/01 sunsj modify the line width */
                        if ( current_x>115 )
                        {
                            current_y += 16;
                            current_x = current_pixel;
                        }
                        if ( current_y > FIFTH_LINE )
                        {
                            Temp_ptr = data->wszTextBuffer;
                            Temp_ptr = Temp_ptr + j;
                            current_y = 0;
                            conver_page = TRUE;
                        }
                        j++;
                    }
                    UnicodeConver(data->wszTextBuffer, data->wszTextBuffer);

                    if ( conver_page == FALSE )
                    {
                        if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                        {
							/* 2003/12/01 sunsj modify lcd width */
                            dspl_TextOut_Blk(4,FIRST_LINE, 115, DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                        }
                        else
                        {
							/* 2003/12/01 sunsj modify lcd width */
                            dspl_TextOut_Blk(4,FIRST_LINE, 115, DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                        }
                    }
                    else
                    {
						/* 2003/12/01 sunsj modify lcd width */
                        dspl_TextOut_Blk(4, FIRST_LINE, 115, DSPL_TXTATTR_UNICODE, (char *)Temp_ptr);
                    }
					drawcolorclarity(102, 1 ,spareNum, 0xffffff);
                    /* 2003/10/13 sunsj/ modify pinyin input method display */
                    /*else if( data->Ime.TextBufferCount <= CANDIDATES_PER_GROUP*2 )//when data->Ime.TextBufferCount > CANDIDATES_PER_GROUP
                    {
                        Temp_ptr = data->wszTextBuffer;
                        Temp_ptr = Temp_ptr + CANDIDATES_PER_GROUP;
                        dspl_TextOut(4,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                        dspl_TextOut(4, SECOND_LINE, DSPL_TXTATTR_UNICODE, (char *)Temp_ptr);
                    }*/
                    /*{
                        if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                        {
                            Temp_ptr = data->wszTextBuffer;
                            Temp_ptr = Temp_ptr + data->Ime.TextBufferCount - CANDIDATES_PER_GROUP;
                            dspl_TextOut(1,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char *)Temp_ptr);
                        }
                        else if ( data->Ime.TextCursor < CANDIDATES_PER_GROUP )
                        {
                            dspl_TextOut(1,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                        }
                        else
                        {
                            Temp_ptr = &data->wszTextBuffer[data->Ime.TextCursor] - CANDIDATES_PER_GROUP + 1;
                            dspl_TextOut(1,	FIRST_LINE,DSPL_TXTATTR_UNICODE,(char *)Temp_ptr);
                            dspl_TextOut(73,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)data->CursorPosition);
                        }
                    }*/
                    dspl_colorTextOut(0,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT,(char*)PinYinPrompt,0xffffff);   /* Display input prompt */ //sunsjtest

                    /* 2003/10/13 sunsj/ Display input sequence for Pin-yin input */
                    i = data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count;
                    dspl_Clear(0, FIFTH_LINE, 120, SEVENTH_LINE);
                    for ( j=0; j < ELEMENT_PERPAGE; j++ )
                    {
                        memset( &data->Ime.PinyinDisplayBuf[j], 0x0000, TEXT_BUFFER_EXTRA_SPACE+1);
                    }

                    if ( data->Ime.Element_Select < ELEMENT_PERPAGE )
                    {
                        for ( j=0; j<ELEMENT_PERPAGE; j++ )
                        {
                            UnicodeConver((USHORT*)&data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].PinyinEleBUF[j],(USHORT*)&data->Ime.PinyinDisplayBuf[j]);
                        }
                    }
                    else
                    {
                        UnicodeConver((USHORT*)&data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].PinyinEleBUF[4],(USHORT*)&data->Ime.PinyinDisplayBuf[0]);
                        UnicodeConver((USHORT*)&data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].PinyinEleBUF[5],(USHORT*)&data->Ime.PinyinDisplayBuf[1]);
                    }
                    //if ( i <= 4 )
                    {
                        dspl_TextOut(1,FIFTH_LINE,DSPL_TXTATTR_UNICODE,(char*)&data->Ime.PinyinDisplayBuf[0]);//data->wszElementBuffer);
                        dspl_TextOut(61,FIFTH_LINE,DSPL_TXTATTR_UNICODE,(char*)&data->Ime.PinyinDisplayBuf[1]);//data->wszElementBuffer);
                        dspl_TextOut(1,SIXTH_LINE,DSPL_TXTATTR_UNICODE,(char*)&data->Ime.PinyinDisplayBuf[2]);//data->wszElementBuffer);
                        dspl_TextOut(61,SIXTH_LINE,DSPL_TXTATTR_UNICODE,(char*)&data->Ime.PinyinDisplayBuf[3]);//data->wszElementBuffer);
                    }
                    /*else
                    {
                        Temp_ptr = data->DisplayElementBuffer;
                        Temp_ptr = Temp_ptr + i - 4;
                        dspl_TextOut(1,SIXTH_LINE,DSPL_TXTATTR_UNICODE,(char*)Temp_ptr);//data->wszElementBuffer);
                    }*/
                    ElementHighlightDisplayContorl(&data->Ime);

                    /* Display candidate charaters returned from eZiText */
                    dspl_TextOut(3,SEVENTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_SIGNED_COORDS,(char*)data->wcCandidates);
                    dspl_DrawRect(0, 82, 119, 130);
                    /* Highlight the candidate character pointed by Ime.CandidateCursor */
                    CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);

                    /* 2003/11/27 sunsj */
					displaySoftKeys(TxtSoftOK,TxtDelete);   /* Softkey display*/
#if(MAIN_LCD_SIZE==3)
					draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
                    //displaySoftKeys(TxtSoftSelect,TxtSoftOK);   /* Softkey display*/
                }
                break;
            case WORD_ASSOCIATION_SCREEN:
                {
                    /* Display the correct portion composed text stored in wszTextBuffer. If the text cursor is not pointing at */
                    /* the end of the text buffer, the display content is then adjusted to display the correct portion of the   */
                    /* text buffer.																				  */
                    //if ( data->Ime.TextBufferCount <=CANDIDATES_PER_GROUP )  //check text buffer count
                    current_x = 0;
                    current_y = FIRST_LINE;
                    conver_page = FALSE;
                    j=0;
                    UnicodeConver(data->wszTextBuffer, data->wszTextBuffer);
                    while ( data->wszTextBuffer[j] )
                    {
                        current_pixel = get_CharWidth(data->wszTextBuffer[j]);
                        current_x += current_pixel;

                        /* 2003/12/01 sunsj modify the line width */
                        if ( current_x>115 )
                        {
                            current_y += 16;
                            current_x = current_pixel;
                        }
                        if ( current_y > FIFTH_LINE )
                        {
                            Temp_ptr = data->wszTextBuffer;
                            Temp_ptr = Temp_ptr + j;
                            current_y = 0;
                            conver_page = TRUE;
                        }
                        j++;
                    }
                    UnicodeConver(data->wszTextBuffer, data->wszTextBuffer);

                    if ( conver_page == FALSE )
                    {
                        if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                        {
							/* 2003/12/01 sunsj modify lcd width */
                            dspl_TextOut_Blk(4,FIRST_LINE, 115, DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                        }
                        else
                        {
							/* 2003/12/01 sunsj modify lcd width */
                            dspl_TextOut_Blk(4,FIRST_LINE, 115, DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                        }
                    }
                    else
                    {
						/* 2003/12/01 sunsj modify lcd width */
                        dspl_TextOut_Blk(4, FIRST_LINE, 115, DSPL_TXTATTR_UNICODE, (char *)Temp_ptr);
                    }
					drawcolorclarity(102, 1 ,spareNum, 0xffffff);
                    /* 2003/10/13 sunsj modify pinyin input method text display */
                    /*else if ( data->Ime.TextBufferCount <= CANDIDATES_PER_GROUP*2 ) //when data->Ime.TextBufferCount > CANDIDATES_PER_GROUP
                    {
                        Temp_ptr = data->wszTextBuffer;
                        Temp_ptr = Temp_ptr + CANDIDATES_PER_GROUP;
                        dspl_TextOut(4, FIRST_LINE, DSPL_TXTATTR_UNICODE, (char *)data->wszTextBuffer);
                        dspl_TextOut(4, SECOND_LINE, DSPL_TXTATTR_UNICODE, (char *)Temp_ptr);
                    }*/
                    /*{
                        if ( data->Ime.TextBufferCount == data->Ime.TextCursor )
                        {
                            Temp_ptr = data->wszTextBuffer;
                            Temp_ptr = Temp_ptr + data->Ime.TextBufferCount - CANDIDATES_PER_GROUP;
                            dspl_TextOut(1,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char *)Temp_ptr);
                        }
                        else if ( data->Ime.TextCursor < CANDIDATES_PER_GROUP )
                        {
                            dspl_TextOut(1,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wszTextBuffer);
                            TextCursorDisplayContorl(&data->Ime, data->CursorPosition, 0);
                        }
                        else
                        {
                            Temp_ptr = &data->wszTextBuffer[data->Ime.TextCursor] - CANDIDATES_PER_GROUP + 1;
                            dspl_TextOut(1,FIRST_LINE,DSPL_TXTATTR_UNICODE,(char *)Temp_ptr);
                            dspl_TextOut(73,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)data->CursorPosition);
                        }
                    }*/

                    if ( data->Ime.EditorMode == STROKE_INPUT_MODE )
                    {
                        /* 2003/10/26 sunsj modify for stroke mode display */
                        //dspl_TextOut(0,0,DSPL_TXTATTR_UNICODE,(char*)StrokePrompt);   /* Display input prompt */
                        dspl_colorTextOut(0,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT,(char*)StrokePrompt,0xffffff);   /* Display input prompt */ //sunsjtest
                        /* Display input sequence for stroke */
                    }
                    else if ( data->Ime.EditorMode == PINYIN_INPUT_MODE )
                    {
                        /* 2003/10/13 sunsj */
                        dspl_colorTextOut(0,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT,(char*)PinYinPrompt,0xffffff);   /* Display input prompt */ //sunsjtest
                        //dspl_TextOut(0,0,DSPL_TXTATTR_UNICODE,(char*)PinYinPrompt);   /* Display input prompt */
                        /* Display input sequence for Pin-yin input */
                    }

                    /* 2003/10/13 sunsj modify display attr */
                    /* Display candidate charaters returned from eZiText */
                    dspl_TextOut(3,SIXTH_LINE,DSPL_TXTATTR_UNICODE,(char*)data->wcCandidates);
                    /* Highlight the candidate character pointed by Ime.CandidateCursor */
                    CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);
                    /* draw rectangle */
                    dspl_DrawRect(0, 97, 119, 130);
                    /* 2003/11/27 sunsj */
					displaySoftKeys(TxtSoftOK,TxtDelete);   /* Softkey display*/
#if(MAIN_LCD_SIZE==3)
					draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
                    //displaySoftKeys(TxtSoftSelect,TxtSoftOK);   /* Softkey display*/
                }
                break;
            default:
                break;
            }
            dspl_SetBkgColor(oldColor);
        }
        break;
    default:
        return 0;
    }
    return 1;
}


/*******************************************************************************

 $Function:    	chinese_input_kbd_cb

 $Description:	Keyboard event handler

 $Returns:		status int

 $Arguments:	window handle event, keyboard control block

 $History:      2003/11/10 sunsj Return to idle when close screen

*******************************************************************************/

static int chinese_input_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND           win         = mfw_parent (mfw_header());
    T_MFW_WIN       *   win_data    = ((T_MFW_HDR *)win)->data;
    T_chinese_input *   data        = (T_chinese_input *)win_data->user;
    T_MFW_HND           parent_win  = data->parent_win;
    USHORT              Identifier  = data->Identifier;
    int                 temp = 0;
    PZI8WCHAR           temp_ZiKeyMap;
    T_MFW_WIN           *parentwin_data =((T_MFW_HDR *)parent_win)->data;
    T_EDITOR_INFO       *parentdata   =(T_EDITOR_INFO *)parentwin_data->user;
    //void (* Callback)() = data->Callback;

    //TRACE_EVENT("chinese_input_kbd_cb");

    switch ( keyboard->code )
    {
    case KCD_LEFT:
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //access to the option list.
                //data->options_win = SmsSend_OPT_start(win,&SmsSend_R_OPTAttrib);
                SEND_EVENT(win, CHINESE_INPUT_DESTROY, INFO_KCD_LEFT, NULL);
                break;
            case STROKE_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                IMESelectCandidate(&data->Ime, data->wszElementBuffer);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;

        case PINYIN_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //chinese_input_destroy(win);
                SEND_EVENT(win, CHINESE_INPUT_DESTROY, INFO_KCD_LEFT, NULL);
                //access to the option list.
                break;
            case PINYIN_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                /* 2003/11/27 sunsj */
                if ( (data->Ime.TextBufferCount * 2) < (TEXT_BUFFER_EDIT_SIZE/2)*2 )
                {
                    IMESelectCandidate(&data->Ime, data->wszElementBuffer);
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                }
                else
                {
                    chinese_input_destroy(win);
                }
                break;
            default:
                break;
            }
            winShow(win);
        default:
            break;
        }   
        break;
    case KCD_RIGHT:
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                if ( data->Ime.TextBufferCount == 0 )
                {   /* When there is no stored data, return back to the menu*/
                    chinese_input_destroy(win);
                }
                else
                {
                    IMEClear(&data->Ime, data->wszElementBuffer);
                }
                break;
            case STROKE_INPUT_SCREEN:
                IMEClear(&data->Ime, data->wszElementBuffer);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];

                /* 2003/12/01 remove chinese_input_destroy will display screen */
                //winShow(win);

                /* 2003/10/26 sunsj add for stroke mode */
                if ( data->Ime.pGetParam->ElementCount == 0 )
                {
                    chinese_input_destroy(win);
                }
                break;
            case WORD_ASSOCIATION_SCREEN:
                data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;

                /* 2003/12/01 remove chinese_input_destroy will display screen */
                //winShow(win);
                chinese_input_destroy(win);
//		       				memset(&data->HighlightedCandidate, 0, sizeof(data->HighlightedCandidate));
                break;
            default:
                /* 2003/10/26 sunsj add for stroke mode */
                winShow(win);
                break;
            }
            /* 2003/10/26 sunsj remove for new stroke mode */
            //winShow(win);
            break;
        case PINYIN_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                if ( data->Ime.TextBufferCount == 0 )
                {   /* When there is no stored data, return back to the menu*/
                    chinese_input_destroy(win);
                    //SEND_EVENT(win, CHINESE_INPUT_DESTROY, INFO_KCD_RIGHT, NULL);
                }
                else
                {
                    IMEClear(&data->Ime, data->wszElementBuffer);
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                }
                break;
            case PINYIN_INPUT_SCREEN:
                /* 2003/10/13 sunsj modify clear function */
                //IMEClear(&data->Ime, data->wszElementBuffer);
                Zi_onekey_clear(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
				/* 2003/12/01 remove chinese_input_destroy will display screen */
                //winShow(win);

                if ( data->Ime.ElementNumber == 0 )
                {
                    chinese_input_destroy(win);
                }

                break;
            case WORD_ASSOCIATION_SCREEN:
//				edtSymbol(parentdata->edt_edt,0);
                data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
                //winShow(win);
                chinese_input_destroy(win);
//		       				memset(&data->HighlightedCandidate, 0, sizeof(data->HighlightedCandidate));
                break;
            default:
                winShow(win);
                break;
            }
            //chinese_input_destroy(win);
            //winShow(win);
            break;
        default:
            break;
        }
        break;
    case KCD_HUP:
        /* 2003/10/13 sunsj/ modify the hup_key's operation */
        //SEND_EVENT(win, CHINESE_INPUT_DESTROY, INFO_KCD_HUP, NULL);
        chinese_input_destroy(win);
/*	    	
        switch(data->EditorMode)
        {
            case STROKE_INPUT_MODE:
                switch (data->Ime.InputScreenType)
                {
                    case TEXT_DISPLAY_SCREEN:
                    case STROKE_INPUT_SCREEN:
                    case WORD_ASSOCIATION_SCREEN:
                        chinese_input_destroy(win);
                        break;
                    default:
                        break;
                }
                break;
            case PINYIN_INPUT_MODE:
                switch (data->Ime.InputScreenType)
                {
                    case TEXT_DISPLAY_SCREEN:
                    case PINYIN_INPUT_SCREEN:
                    case WORD_ASSOCIATION_SCREEN:
                        chinese_input_destroy(win);
                        break;
                    default:
                        break;
                }
                break;
            default:
                break;
        }	
*/
        break;
    case KCD_MNUUP:
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor
                if ( data->Ime.TextCursor > 0 && data->Ime.TextCursor <= data->Ime.TextBufferCount )
                {
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor - 1];
                    data->Ime.TextCursor--;
                }
                break;
            case STROKE_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                /* 2003/10/26 sunsj modify down key operate of stroke mode */
                IMECandidatePageUp(&data->Ime);
                //IMECursorLeft(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;

        case PINYIN_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor
                if ( data->Ime.TextCursor > 0 && data->Ime.TextCursor <= data->Ime.TextBufferCount )
                {
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor - 1];
                    data->Ime.TextCursor--;
                }
                break;
            case PINYIN_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                /* 2003/10/13 sunsj modify for candidate pageup */
                //IMECursorLeft(&data->Ime);
                IMECandidatePageUp(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;
        default:
            break;
        }   
        break;
    case KCD_MNUDOWN:
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor 
                if ( data->Ime.TextCursor < data->Ime.TextBufferCount )
                {
                    data->Ime.TextCursor++;
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor];                                
                }
                break;
            case STROKE_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                /* 2003/10/26 sunsj modify down key in stroke mode */
                IMECandidatePageDown(&data->Ime);
                //IMECursorRight(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;

        case PINYIN_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                /*//update the text cursor 
                if ( data->Ime.TextCursor < data->Ime.TextBufferCount )
                {
                    data->Ime.TextCursor++;
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor];                                
                }*/
                break;
            case PINYIN_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                /* 2003/10/13 sunsj modify for candidate pagedown */
                //IMECursorRight(&data->Ime);
                IMECandidatePageDown(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;
        default:
            break;
        }   
        break;
        /* 2003/10/13 sunsj/ add for menuleft key operate */
    case KCD_MNULEFT:
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor
                if ( data->Ime.TextCursor > 0 && data->Ime.TextCursor <= data->Ime.TextBufferCount )
                {
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor - 1];
                    data->Ime.TextCursor--;
                }
                break;
            case STROKE_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                IMECursorLeft(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;

        case PINYIN_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor
                if ( data->Ime.TextCursor > 0 && data->Ime.TextCursor <= data->Ime.TextBufferCount )
                {
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor - 1];
                    data->Ime.TextCursor--;
                }
                break;
            case PINYIN_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                IMECursorLeft(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;
        default:
            break;
        }   
        break;
        /* 2003/10/13 sunsj add for menuright key operate */
    case KCD_MNURIGHT:
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor 
                if ( data->Ime.TextCursor < data->Ime.TextBufferCount )
                {
                    data->Ime.TextCursor++;
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor];                                
                }
                break;
            case STROKE_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                IMECursorRight(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;

        case PINYIN_INPUT_MODE:
            switch ( data->Ime.InputScreenType )
            {
            case TEXT_DISPLAY_SCREEN:
                //update the text cursor 
                if ( data->Ime.TextCursor < data->Ime.TextBufferCount )
                {
                    data->Ime.TextCursor++;
                    data->CursorPosition[0] = data->wszTextBuffer[data->Ime.TextCursor];                                
                }
                break;
            case PINYIN_INPUT_SCREEN:
            case WORD_ASSOCIATION_SCREEN:
                IMECursorRight(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                break;
            default:
                break;
            }
            winShow(win);
            break;
        default:
            break;
        }   
        break;
    case KCD_CALL:
        break;
    case KCD_0:
        /* 2003/10/13 sunsj control the textbuffer number */
        if ( ((data->Ime.TextBufferCount * 2)+20) >= data->Ime.TextBufferEditSize )
        {
            return MFW_EVENT_CONSUMED;
        }
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
            IMEMore(&data->Ime);
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            break;
        case PINYIN_INPUT_MODE:
            /* 2003/10/13 sunsj remark the kcd_0 operation */
            /*
            data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;
            IMEMore(&data->Ime);
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            */
            break;

        default:
            break;
        }
        break;
    case KCD_8:
        /* 2003/10/13 sunsj control the textbuffer number */
        if ( ((data->Ime.TextBufferCount * 2)+20) >= data->Ime.TextBufferEditSize )
        {
            return MFW_EVENT_CONSUMED;
        }
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
            /* 2003/10/26 sunsj modify for stroke */
            IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[keyboard->code][1] + ZI8_BASE_STROKES));
            //IMEMore(&data->Ime);
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            break;
        case PINYIN_INPUT_MODE:
            data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;

            /* 2003/10/13 sunsj/ the onekey press pinyin need the all pinyin element when the key press
               so we need a temp key map to store all pinyin element */
            temp_ZiKeyMap = (PZI8WCHAR )ZiPinYinKeyMap[(keyboard->code)-1];

            /* 2003/10/13 sunsj/ the new key press operate function */
            Zi_onekey_keypress(&data->Ime, temp_ZiKeyMap);

            /* The unclear of eZiText document, it is assumed that multi-key press may required to get to the required letter */
            /* To do that a ZiPinYinKeyMap array is defined in ChineseInput.h header file.                                 */
            /* When number of keypress from the user is given from the keypad hadler, the key press count can then be    */
            /* used to work out the relevent code to insert into the element buffer for eZiText search. The variable          */
            /* data->NumberOfKeyPress is decleared to store the key press count. 								  */

            //temp = data->NumberOfKeyPress % ZiPinYinKeyMap[(keyboard->code)-1][5];
            //IMEKeyPress(&data->Ime, (ZI8WCHAR) ZiPinYinKeyMap[(keyboard->code)-1][temp - 1]);

            /* due to not able to receive key press count, it is assume the first letter assign to the key is selected when key */
            /* is pressed.																					   */
            /* 2003/10/13 sunsj/ romove the old key press function */
            //IMEKeyPress(&data->Ime, (ZI8WCHAR) ZiPinYinKeyMap[(keyboard->code)-1][0]);
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            break;
        default:
            break;
        }
        break;
    case KCD_1:
        /* 2003/10/13 sunsj control the textbuffer number */
        if ( ((data->Ime.TextBufferCount * 2)+20) >= data->Ime.TextBufferEditSize )
        {
            return MFW_EVENT_CONSUMED;
        }
        /* 2003/10/13 sunsj/ add for to select different pinyin code */
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
            IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[keyboard->code][1] + ZI8_BASE_STROKES));
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            break;
        case PINYIN_INPUT_MODE:
            {
                int candidate_num;

                if ( data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count == 1 )
                {
                    return MFW_EVENT_CONSUMED;
                }

                if ( data->Ime.Element_Select == data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count-1 )
                {
                    data->Ime.Element_Select = 0;
                }
                else
                {
                    data->Ime.Element_Select++;
                }
                candidate_num = Zi_GetElementCandidates(&data->Ime);
                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                winShow(win);
            }
            break;

        default:
            break;
        }
        break;
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_9:
        /* 2003/11/27 sunsj control the textbuffer number */
		if( data->Callback_Data.edtInPbk == 0 )
		{
			if ( ((data->Ime.TextBufferCount * 2)+20) >= data->Ime.TextBufferEditSize )
			{
				return MFW_EVENT_CONSUMED;
			}
		}
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
            IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[keyboard->code][1] + ZI8_BASE_STROKES));
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            break;
        case PINYIN_INPUT_MODE:
            temp_ZiKeyMap = (PZI8WCHAR )ZiPinYinKeyMap[(keyboard->code)-1];
            data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;
            /*if(data->PerviousKeyPress == -1)
            {
                data->PerviousKeyPress = keyboard->code;
                data->NumberOfKeyPress = 1;
            }*/
            Zi_onekey_keypress(&data->Ime, temp_ZiKeyMap);
            //IMEKeyPress(&data->Ime, (ZI8WCHAR) ZiPinYinKeyMap[(keyboard->code)-1][0]);
            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
            winShow(win);
            break;

        default:
            break;
        }
        break;
    case KCD_STAR:
        /* 2003/10/13 sunsj control the textbuffer number */
        if ( ((data->Ime.TextBufferCount * 2)+20) >= data->Ime.TextBufferEditSize )
        {
            return MFW_EVENT_CONSUMED;
        }
        switch ( data->Ime.EditorMode )
        {
        case STROKE_INPUT_MODE:
            //SymbolScreenstart(win, NULL);
            break;
        case PINYIN_INPUT_MODE:
            //SymbolScreenstart(win, NULL);
            break;
        default:
            break;
        }

        break;
    case KCD_HASH:
        switch ( data->Ime.EditorMode )
        {
        T_EDITOR_DATA  editor_data;
        case STROKE_INPUT_MODE:
            data->Ime.EditorMode = PINYIN_INPUT_MODE;
            break;
        case PINYIN_INPUT_MODE:
            /* 2003/10/13 sunsj/ remove the hash operate */
/*            //start latin editor
            SmsSend_loadEditDefault(&editor_data);
            //set mode to stroke input when Latin editor exited
            data->Ime.EditorMode = STROKE_INPUT_MODE;
            editor_data.editor_attr.text     = (char *)data->Callback_Data.TextString;  
            editor_data.editor_attr.size     = data->Callback_Data.EditorSize*2 + 3; 
            editor_data.min_enter            = 0; 
            editor_data.mode = ALPHA_MODE;              
            editor_data.LeftSoftKey          = TxtChinese;
            editor_data.AlternateLeftSoftKey = TxtSoftBack;
            editor_data.RightSoftKey         = TxtDelete;
            editor_data.Identifier          = LATIN_INPUT;

            editor_data.Callback             = (T_EDIT_CB)chinese_input_exec;
            editor_data.destroyEditor        = TRUE;
            editor_start(data->input_win, &editor_data);*/
            break;
        default:
            break;
        }
//	    	data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
//	    	memset(data->wszElementBuffer, 0, sizeof(data->wszElementBuffer));
//        memset(&data->DisplayElementBuffer, 0,sizeof(data->DisplayElementBuffer));
//        IMEChangeMode(&data->Ime,&data->GetParam);
//        winShow(win);
        break;
        /* 2003/11/10 sunsj if close screen return to idle */
    case KCD_F4:
        {
            if ( !HallStatus() )
                returntoidle(1);
        }
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:  	

 $Description:	
 $Returns:		

 $Arguments:	menu and menu item (neither used)
 
*******************************************************************************/
int chinese_input_menu(MfwMnu* m, MfwMnuItem* i)
{   
    T_MFW_HND       parent        = mfwParent( mfw_header() );
    chinese_input( parent, NULL, 0 );   //sunsjtest
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	IMEChangeMode

 $Description:	This function change some of the setting when user selected to use 
                different input method. E.g change from Stroke to Pin-yin input.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
void IMEChangeMode(pIME_DATA pIME, PZI8GETPARAM pGetParam)
{
    /* First initialize the members that will be constant */
    switch ( pIME->EditorMode )
    {
    case STROKE_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_STROKES;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context      = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_ALLCOMPONENTS;
        //pGetParam->GetOptions		= ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case PINYIN_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_PINYIN;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context      = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case LATIN_INPUT_MODE:
        /*pGetParam->Language			= ZI8_LANG_EN;
        pGetParam->GetMode			= ZI8_GETMODE_DEFAULT;
        pGetParam->SubLanguage		= ZI8_SUBLANG_DEFAULT;
        pGetParam->Context		= ZI8_GETCONTEXT_DEFAULT;
        pGetParam->GetOptions		= ZI8_GETOPTION_STRINGS;
    */
        pIME->InputScreenType = TEXT_DISPLAY_SCREEN;
        break;
    default:
        break;
    }
    pIME->InputScreenType = TEXT_DISPLAY_SCREEN;
    memset(pGetParam->pElements, 0, sizeof(pGetParam->pElements));
    memset(pIME->pDisplayElementBuffer, 0,sizeof(pIME->pDisplayElementBuffer));
    /* save the pointer to the ZI8GETPARAM structure in the IME data */
    pIME->pGetParam             = pGetParam;
    /* now initialize the text buffer and element buffer */
    pIME->moreCount             = 0;
    pGetParam->ElementCount     = 0;
    /* initilalize the WordCharacterCount to zero */
    pGetParam->WordCharacterCount = 0;
    /* initialize the saved number of candidates to zero */
    pIME->candidates = 0;
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}


/*******************************************************************************

 $Function:    	IMEInitialize

 $Description:	This function initializes the ZI8GETPARAM structure defined in the API 
                and the various members of the IME_DATA structure defined in to keep 
                track of the IME.

 $Returns:		void

 $Arguments:

 $History:		2003/11/10 sunsj Get the text cursor.

*******************************************************************************/
/*void IMEInitialize(pIME_DATA pIME, PZI8GETPARAM pGetParam, PZI8WCHAR wszTextBuffer, int TextBufferEditSize,
                 int TextBufferSize, PZI8WCHAR pCandidates)*/
void IMEInitialize(pIME_DATA pIME, PZI8GETPARAM pGetParam, PZI8WCHAR wszTextBuffer,
                   int TextBufferEditSize, int TextBufferSize, PZI8WCHAR pCandidates, 
                   PZI8WCHAR wszElementBuffer, PZI8WCHAR DisplayElementBuffer)
{
    int i;  /* 2003/10/13 sunsj */

    /* 2003/10/26 sunsj modify for select input mode */
    pIME->EditorMode            = editor_input_mode;
    /* 2003/10/13 sunsj/ set the default editor mode to pinyin */
    //pIME->EditorMode            = PINYIN_INPUT_MODE;

    /* First initialize the members that will be constant */
    switch ( pIME->EditorMode )
    {
    case STROKE_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_STROKES;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context          = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_ALLCOMPONENTS;
        //pGetParam->GetOptions		= ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case PINYIN_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_PINYIN;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context          = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case LATIN_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_EN;
        pGetParam->GetMode          = ZI8_GETMODE_DEFAULT;
        pGetParam->SubLanguage      = ZI8_SUBLANG_DEFAULT;
        pGetParam->Context          = ZI8_GETCONTEXT_DEFAULT;
        pGetParam->GetOptions       = ZI8_GETOPTION_STRINGS;
        break;
    default:
        break;
    }
    /* save the pointer to the ZI8GETPARAM structure in the IME data */
    pIME->pGetParam             = pGetParam;
    /* now initialize the text buffer and element buffer */
    pIME->pTextBuffer           = wszTextBuffer;
    pIME->TextBufferEditSize    = TextBufferEditSize;
    pIME->TextBufferSize        = TextBufferSize;
    pIME->moreCount             = 0;
    pIME->TextBufferCount       = Uni_strlen(wszTextBuffer);;
    /* 2003/11/10 sunsj remove */
    //pIME->TextCursor            = pIME->TextBufferCount;
    pIME->pDisplayElementBuffer = DisplayElementBuffer;
    pIME->InputScreenType       = TEXT_DISPLAY_SCREEN;

//	pGetParam->pElements 		= wszTextBuffer;
    pGetParam->pElements        = wszElementBuffer;
    pGetParam->ElementCount     = 0;
    /* initilalize the WordCharacterCount to zero */
    pGetParam->WordCharacterCount = 0;
    /*initial pointer to the candidate buffer*/
    pGetParam->pCandidates = pCandidates;
    /* initialize the saved number of candidates to zero */
    pIME->candidates = 0;
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;

    /* 2003/10/13 sunsj/ initialize the display element buffer */
    for ( i=0; i<ELEMENT_PERPAGE; i++ )
    {
        memset( &pIME->PinyinDisplayBuf[i], 0x0000, TEXT_BUFFER_EXTRA_SPACE+1 );
    }

    /* 2003/10/13 sunsj/ initialize the element cursor to zero */
    pIME->Element_Select  = 0;

    /* 2003/10/13 sunsj/ initialize the total element number */
    pIME->ElementNumber   = 0;

    /* 2003/10/13 sunsj/ initialize the word association buffer */
    memset( pIME->Association_Buffer, 0x0000, 10);
}


/*******************************************************************************

 $Function:    	IMECursorLeft

 $Description:	Move the candidate cursor left

 $Returns:		void

 $Arguments:

 $modify:	2003.10.16 sunsj modify for word association screen
            2003.11.01 sunsj modify for pinyin and stroke input

*******************************************************************************/
void IMECursorLeft(pIME_DATA pIME)
{
    /* 2003/11/1 sunsj pinyin and stroke use the same method */
    if ( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        if ( pIME->CandidateCursor != 0 )
        {
            pIME->CandidateCursor--;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
        }
        /* check ElementCount to see whether ElementBuffer is empty and check if where is any more tick in the element buffer. */
        else if ( pIME->moreCount != 0 )
        /*
        else if ( pIME->pGetParam->ElementCount != 0 || 
                  pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
        */
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;

            /* 2003/10/28 sunsj remove */
            /*
            if(pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE)
            {
                //replace last element with zero
                pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0x0000;
            }
            */
            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor the character position*/
            pIME->CandidateCursor = 6;
        }
    }
    /* 2003/11/1 sunsj remove */
#if 0
    else if ( pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        if ( pIME->CandidateCursor != 0 )
        {
            pIME->CandidateCursor--;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
        }
        /* check ElementCount to see whether ElementBuffer is empty and check if where is any more tick in the element buffer. */
        else if ( pIME->moreCount != 0 )
        /*
        else if ( pIME->pGetParam->ElementCount != 0 || 
                  pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
        */
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;

            /* 2003/10/28 sunsj remove */
            /*
            if(pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE)
            {
                //replace last element with zero
                pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0x0000;
            }
            */
            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor the character position*/
            pIME->CandidateCursor = 6;
        }
    }
#endif
    else if ( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if ( pIME->CandidateCursor != 0 )
        {
            pIME->CandidateCursor--;
        }
        else if ( pIME->moreCount !=0 )
        /*
        else if ( pIME->pGetParam->ElementCount !=0 &&
                  pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
        */
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;
            /* 2003/10/28 sunsj remove */
            /* replace last element with zero */
            //pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0x0000;

            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor of the new position */
            pIME->CandidateCursor = (CANDIDATES_PER_GROUP * 2) - 1;
        }
        else if ( pIME->moreCount != 0 && pIME->pGetParam->WordCharacterCount != 0 )
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;
            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor of the new position */
            pIME->CandidateCursor = (CANDIDATES_PER_GROUP * 2) - 1;
        }
    }
}


/*******************************************************************************

 $Function:    	IMECursorRight

 $Description:	Move the candidate cursor right

 $Returns:		void

 $Arguments:	

 $modify:	2003.10.16 sunsj modify for word association screen
            2003.11.01 sunsj modify for pinyin and stroke
            2003/11/10 sunsj if there is no candidate backup candidate cursor
*******************************************************************************/
void IMECursorRight(pIME_DATA pIME)
{
    /* 2003/11/10 sunsj backup old candidate cursor*/
    int oldcandidatecursor=0;
    oldcandidatecursor = pIME->CandidateCursor;

    /* 2003/11/1 sunsj pinyin and stroke use the same method */
    if ( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        /* If the candidate cursor is greater than the display ability, more tick is add to the element buffer */
        /* to request for next set of characters.												 */
        if ( pIME->CandidateCursor >= CANDIDATES_PER_GROUP-1 )
        {
            pIME->moreCount++;
            /* 2003/10/28 sunsj remove */
            //pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = ZI8_CODE_MORE;

            /* get new candidates */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if ( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;
                /* 2003/10/28 sunsj remove */
                /*
                pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
                pIME->pGetParam->ElementCount--;
                */

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                /* 2003/11/10 sunsj recover candidate cursor */
                pIME->CandidateCursor = oldcandidatecursor;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
        /* Check number of available candidates before increment of candidate cursor is allowed */
        else if ( pIME->candidates > (pIME->CandidateCursor + 1) )
        {
            pIME->CandidateCursor++;
            //pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            //DataConvert(pIME);
        }
    }
    /* 2003/11/1 sunsj remove */
#if 0
    else if ( pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        /* If the candidate cursor is greater than the display ability, more tick is add to the element buffer */
        /* to request for next set of characters.												 */
        if ( pIME->CandidateCursor >= CANDIDATES_PER_GROUP-1 )
        {
            pIME->moreCount++;
            /* 2003/10/28 sunsj remove */
            //pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = ZI8_CODE_MORE;

            /* get new candidates */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if ( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;
                /* 2003/10/28 sunsj remove */
                /*
                pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
                pIME->pGetParam->ElementCount--;
                */

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
        /* Check number of available candidates before increment of candidate cursor is allowed */
        else if ( pIME->candidates > (pIME->CandidateCursor + 1) )
        {
            pIME->CandidateCursor++;
            //pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            //DataConvert(pIME);
        }
    }
#endif
    else if ( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if ( pIME->CandidateCursor < (CANDIDATES_PER_GROUP * 2)-1 )
        {
            pIME->CandidateCursor++;
        }
        else if ( pIME->pGetParam->ElementCount != 0 && pIME->pGetParam->WordCharacterCount == 0 )
        {
            /* increase the candidate's page number */
            pIME->moreCount++;
            /* 2003/10/28 sunsj remove */
            //pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = ZI8_CODE_MORE;

            /* get the new candidate */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if ( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;
                /* 2003/10/28 sunsj remove */
                //pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0x00;

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
        else if ( pIME->pGetParam->WordCharacterCount != 0 )
        {
            /* increase the candidate's page number */
            pIME->moreCount++;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if ( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;
                /* 2003/10/28 sunsj remove */
                //pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0x00;

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
    }
}


/*******************************************************************************

 $Function:    	IMESelectCandidate

 $Description:	Select the cadidate at cursor.

 $Returns:		void

 $Arguments:	

 $modify:	2003.10.13 sunsj modify word association function and some other bug
*******************************************************************************/
//void IMESelectCandidate(pIME_DATA pIME)
void IMESelectCandidate(pIME_DATA pIME, PZI8WCHAR wszElementBuffer)
{
    int i = 0;
    int j = 0;
    ZI8WCHAR HighByte;
    ZI8WCHAR Temp;
    ZI8WCHAR LowByte;   

    /* we can allow selection only if we have candidates*/
    if ( pIME->candidates == 0 )
        return;
    /* if we have elements in the test we must now remove them */
    while ( pIME->pGetParam->ElementCount > 0 )
    {
        pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;
    }
    /* the more count must be set to zero */
    pIME->moreCount = 0;

    /* 2003/10/13 sunsj/  clear element number  */
    pIME->ElementNumber = 0;
    pIME->pGetParam->ElementCount = pIME->ElementNumber;

    /* check the limit of the text buffer. Stop user to enter character when text buffer is full */
    if ( pIME->TextBufferCount >= TEXT_BUFFER_EDIT_SIZE )
    {
        //messages can be added to inform user when text buffer is full.
        return;
    }

    /* chek if the selected candidate is a component. To do that the storage format has to be change. */
    /* Followin bit shifting procedure is used the perfrom the task.						 */
    LowByte = pIME->pGetParam->pCandidates[pIME->CandidateCursor] & 0x00FF;
    HighByte = pIME->pGetParam->pCandidates[pIME->CandidateCursor] & 0xFF00;
    Temp = (LowByte << 8) & 0xFF00;
    HighByte = (HighByte >> 8) & 0x00FF;
    Temp = Temp | HighByte;

    if ( Temp > ZI8_BASE_COMPONENTS && Temp < ZI8_BASE_BPMF ) /* check if the selected candidate is a component */
    {
        memset(pIME->pDisplayElementBuffer, 0, sizeof(pIME->pDisplayElementBuffer));
        pIME->pDisplayElementBuffer[0] = pIME->pGetParam->pCandidates[pIME->CandidateCursor];

        pIME->pGetParam->pElements[0] = Temp;
        pIME->pGetParam->ElementCount = 1;
        /* 2003/10/26 sunsj add for component operator */
        pIME->moreCount = 0;
        pIME->CandidateCursor = 0;

        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    }
    else    /* The selected character is character not a component */
    {
        if ( pIME->TextCursor < pIME->TextBufferCount ) /* locate the text cursor position for correct character insertion */
        {
            for ( i=pIME->TextCursor; i<pIME->TextBufferCount; i++ ) /* shift and move characters to make rooms to insert the selected character */
            {
                //pIME->pTextBuffer[pIME->TextBufferCount - i + 1]=pIME->pTextBuffer[pIME->TextBufferCount - i];
                pIME->pTextBuffer[pIME->TextBufferCount - j]=pIME->pTextBuffer[pIME->TextBufferCount - j - 1];
                j++;
            }
        }

        /* now added this character to the text */
        pIME->pTextBuffer[pIME->TextCursor++] = pIME->pGetParam->pCandidates[pIME->CandidateCursor];

        /* Change input screen type */
        pIME->InputScreenType = WORD_ASSOCIATION_SCREEN;

        /* 2003/10/13 sunsj/ association function */
        /* upate the element buffer to its new position */  
        //pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = Temp;

        /* Adjust the word association. If the candidate we selected was a word candidat,	*/
        /* then we continue the word association. Otherwise this character begins a new word        */      
        if ( pIME->pGetParam->wordCandidates > pIME->CandidateCursor )
        {
            pIME->pGetParam->WordCharacterCount++;

            /* 2003/10/13 sunsj/ update word association element */
            UnicodeConver(pIME->pTextBuffer,pIME->pTextBuffer);
            memcpy(pIME->Association_Buffer, &pIME->pTextBuffer[pIME->TextCursor - 1], pIME->pGetParam->WordCharacterCount*2);
            UnicodeConver(pIME->pTextBuffer,pIME->pTextBuffer);
        }
        else    /* the new word association */
        {
            pIME->pGetParam->WordCharacterCount = 1;

            /* 2003/10/13 sunsj update word assoication element buffer */
            UnicodeConver(pIME->pTextBuffer,pIME->pTextBuffer);
            memcpy(pIME->Association_Buffer, &pIME->pTextBuffer[pIME->TextCursor - 1], pIME->pGetParam->WordCharacterCount*2);
            pIME->pGetParam->pCurrentWord = pIME->Association_Buffer;
            UnicodeConver(pIME->pTextBuffer,pIME->pTextBuffer);
        }
        /* 2003/10/13 sunsj get 2 group of candidate */
        /* get new candidates */
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP * 2;

        /* 2003/10/13 sunsj get 2 group of candidate */
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP*2;

        //increase TextBufferCount by one
        pIME->TextBufferCount++;
        memset(pIME->pDisplayElementBuffer, 0, sizeof(pIME->pDisplayElementBuffer));
    }
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
    DataConvert(pIME);
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}


/*******************************************************************************

 $Function:    	IMEMore

 $Description:	Get the next group of candidates. For this function, we add the more tick 
                to the element buffer and increase the more count. Then we get the 
                next group of candidates.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
void IMEMore(pIME_DATA pIME)
{   
    pIME->moreCount++;
    /* 2003/10/28 sunsj remove */
    //pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = ZI8_CODE_MORE;

    /* get new candidates */
    pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
    pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
    DataConvert(pIME);
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}


/*******************************************************************************

 $Function:    	IMEKeyPress

 $Description:	Enter the stroke and get new candidates. However, any more ticks from 
                the element buffer must be removed before any stroke is to be added.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
void IMEKeyPress(pIME_DATA pIME, ZI8WCHAR wcStroke)
{   
    /* remove any trailing more ticks and set the more count back to zero */
    while ( (pIME->pGetParam->ElementCount > 0) && pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
    {
        pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;
    }
    pIME->moreCount = 0;

    /* Check the limit of the element buffer. Stop user to enter stroke or Pin Yin letter */
    /* when element budder is full 												 */
    if ( pIME->pGetParam->ElementCount >= TEXT_BUFFER_EXTRA_SPACE )
    {
        return;
    }
    /* Insert the stroke or the Pin Yin letter into the element buffer for character search */
    pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = wcStroke;

    /* get candidates with the new stroke */
    pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
    pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

    if ( pIME->candidates > 0 )
    {
        /* Convert the data storage format for display purpose */
        DataConvert(pIME);
        /* initialize the candidate cursor to zero */
        pIME->CandidateCursor = 0;
    }
    else
    {   //remove this keypress
        IMEClear(pIME, pIME->pGetParam->pElements);
    }
}


/*******************************************************************************

 $Function:    	IMEClear

 $Description:	Clear the last stroke entered. This function first handle the case where 
                the last element is a more tick. If there are no elements, it removes 
                the last text element.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
//void IMEClear(pIME_DATA pIME)
void IMEClear(pIME_DATA pIME, PZI8WCHAR wszElementBuffer)
{
    int i = 0;

    /* handle the condition where the last element is a more tick */
    if ( pIME->pGetParam->ElementCount != 0 ) //check ElementCount to see whether ElementBuffer is empty
    {
        /* If the last input is a more tick, remove it */
        if ( pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
        {
            pIME->moreCount--;

            /* replace last element with zero */
            pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;
        }
        else
        {
            pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;    
            pIME->pDisplayElementBuffer[pIME->pGetParam->ElementCount] = 0;
        }

        /* When ElementCount is zero and InputScreenType is STROKE_INPUT_SCREEN or PINYIN_INPUT_SCREEN, 	 */
        /* InputScreenType will be set to WORD_ASSOCIATION_SCREEN to get the associated character. If no associated */
        /* characters can be found, the most common used character in chinese writting will be provided.	 */
        if ( (pIME->pGetParam->ElementCount == 0 && pIME->InputScreenType == STROKE_INPUT_SCREEN) || 
             (pIME->pGetParam->ElementCount == 0 && pIME->InputScreenType == PINYIN_INPUT_SCREEN) )
        {
            pIME->InputScreenType = WORD_ASSOCIATION_SCREEN;
        }
    }
    else
    {
        /* remove the last character from text buffer */
        /* first update count for word association */
        if ( pIME->pGetParam->WordCharacterCount > 0 )
            pIME->pGetParam->WordCharacterCount--;

        /* remove the character at cursor position */
        if ( pIME->TextCursor != 0 )
        {
            /* replace last character with zero */
            if ( pIME->TextBufferCount==pIME->TextCursor )
            {
                pIME->pTextBuffer[--pIME->TextCursor] = 0;
                pIME->TextBufferCount--;
            }
            else if ( pIME->TextBufferCount > pIME->TextCursor )
            {
                for ( i=pIME->TextCursor; i<pIME->TextBufferCount; i++ )
                {
                    pIME->pTextBuffer[i-1]=pIME->pTextBuffer[i];
                }
                pIME->pTextBuffer[pIME->TextBufferCount-1]=0;
                pIME->TextCursor--;
                pIME->TextBufferCount--;
            }
        }
        /* update location of elements */
        pIME->pGetParam->pElements = wszElementBuffer;
    }
    /* get candidates */
    pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
    pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
    /* Convert the data storage format for display purpose */
    DataConvert(pIME);
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}


/*******************************************************************************

 $Function:    	CandidateHighlightDisplayContorl

 $Description:	With given candidate cursor position, and character stored in the HighlightedCandidate,
                this function will invert the colour of the candidate to indicate user the current selected
                character.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
void CandidateHighlightDisplayContorl(pIME_DATA pIME, PZI8WCHAR HighlightedCandidate)
{
    int candidatewidth;

    candidatewidth = get_font_width();
    /* Highlight the candidate character pointed by Ime.CandidateCursor */
/*	if ( pIME->CandidateCursor == 0 )
        dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    else if ( pIME->CandidateCursor == 1 )
        dspl_TextOut(13,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    else if ( pIME->CandidateCursor == 2 )
        dspl_TextOut(25,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    else if ( pIME->CandidateCursor == 3 )
        dspl_TextOut(37,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    else if ( pIME->CandidateCursor == 4 )
        dspl_TextOut(49,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    else if ( pIME->CandidateCursor == 5 )
        dspl_TextOut(61,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    else
        dspl_TextOut(73,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
*/
    /* 2003/10/13 sunsj modify for highlight candidate display */
    if ( pIME->InputScreenType == PINYIN_INPUT_SCREEN )
    {
        dspl_TextOut((USHORT)(3+(candidatewidth*2*pIME->CandidateCursor)),SEVENTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    }
    /* 2003/10/26 sunsj modify for strkoe input mode */
    else if ( pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        dspl_TextOut((USHORT)(3+(candidatewidth*2*pIME->CandidateCursor)),SEVENTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    }
    else if ( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if ( pIME->CandidateCursor < CANDIDATES_PER_GROUP )
        {
            dspl_TextOut((USHORT)(3+(candidatewidth*2*pIME->CandidateCursor)),SIXTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
        }
        else
        {
            dspl_TextOut((USHORT)(3+(candidatewidth*2*( pIME->CandidateCursor - CANDIDATES_PER_GROUP ))),SEVENTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
        }
    }
}


/*******************************************************************************

 $Function:    	TextCursorDisplayContorl

 $Description:	To display the cursor position to user during text editing.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
void TextCursorDisplayContorl(pIME_DATA pIME, PZI8WCHAR CursorPosition, int InsertLine)
{
    USHORT TempTextCursor  = 0;
    USHORT x_position = 1;
    int i;
    int line;//position of char at start of line

    TempTextCursor = pIME->TextCursor % CANDIDATES_PER_GROUP;
    line = pIME->TextCursor - TempTextCursor;
    for ( i=0; i < TempTextCursor; i++ )
    {   //if last byte of word is 0x00, and first byte is between 0x20 and 0x7E
        if ( LatinChar(pIME->pTextBuffer[line+i]) )
            x_position +=6;
        else
            x_position+=12;
    }
    switch ( pIME->InputScreenType )
    {
    case TEXT_DISPLAY_SCREEN:

        if ( InsertLine == 1 )
        {

            dspl_TextOut(x_position,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);

            /*if(TempTextCursor == 0)
                dspl_TextOut(1,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 1)
                dspl_TextOut(13,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 2)
                dspl_TextOut(25,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 3)
                dspl_TextOut(37,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 4)
                dspl_TextOut(49,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 5)
                dspl_TextOut(61,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 6)
                dspl_TextOut(73,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else
                dspl_TextOut(85,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
                */
        }
        else
        {
            dspl_TextOut(x_position,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            /*if(TempTextCursor == 0)
                dspl_TextOut(1,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 1)
                dspl_TextOut(13,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 2)
                dspl_TextOut(25,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 3)
                dspl_TextOut(37,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 4)
                dspl_TextOut(49,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 5)
                dspl_TextOut(61,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 6)
                dspl_TextOut(73,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else
                dspl_TextOut(85,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
                */
        }
        break;
    case STROKE_INPUT_SCREEN:
    case WORD_ASSOCIATION_SCREEN:
        dspl_TextOut(x_position,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
        /*	TempTextCursor = pIME->TextCursor % CANDIDATES_PER_GROUP;
            if(TempTextCursor == 0)
                dspl_TextOut(1,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 1)
                dspl_TextOut(13,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 2)
                dspl_TextOut(25,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 3)
                dspl_TextOut(37,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 4)
                dspl_TextOut(49,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 5)
                dspl_TextOut(61,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else if(TempTextCursor == 6)
                dspl_TextOut(73,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            else
                dspl_TextOut(85,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
            break;*/
    default:
        break;
    }   
}


/*******************************************************************************

 $Function:    	DataConvert

 $Description:	To change to data storage format i.e if a unicode is 0x89D5.
                The DataConvert function will change storage format to 0xD589 (This format 
                is required to display UniCode on LCD). The data format is chaged by 
                byte shifting.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
void DataConvert(pIME_DATA pIME)
{
    ZI8WCHAR HighByte;
    ZI8WCHAR Temp;
    ZI8WCHAR LowByte;
    ZI8WCHAR tempString[25];
    int word_length;
    int i       = 0;
    int count   = 0;
    char debug[20];
    //TRACE_EVENT("DataConvert");


    if ( (pIME->InputScreenType == STROKE_INPUT_SCREEN) ||
         (pIME->InputScreenType == PINYIN_INPUT_SCREEN) )
    {
        count = pIME->pGetParam->ElementCount;
        /* The more tick is not to be displayed on LCD therefore it is not considered. */
        while ( (count > 0) && pIME->pGetParam->pElements[count - 1] == ZI8_CODE_MORE )
        {
            count--;
        }

        /* Format of the data stored in the array pointed by pElement is coverted and  */
        /* saved in the array pointed by pDisplayElementBuffer. Please note that the    */
        /* the data format stored in the array pointed by pElement was unchanged. This */
        /* is kept that way for eZiText character search.*/
        if ( pIME->InputScreenType == STROKE_INPUT_SCREEN )
        {
            for ( i = 0; i < count; i++ )
            {
                Temp = pIME->pGetParam->pElements[i];
                LowByte = pIME->pGetParam->pElements[i] & 0x00FF;
                HighByte = pIME->pGetParam->pElements[i] & 0xFF00;
                Temp = (LowByte << 8) & 0xFF00;
                HighByte = (HighByte >> 8) & 0x00FF;
                Temp = Temp | HighByte;
                pIME->pDisplayElementBuffer[i] = Temp;
            }   
            pIME->pDisplayElementBuffer[count] = 0x0000; //terminate string
        }

        if ( pIME->InputScreenType == PINYIN_INPUT_SCREEN )
        {
            int no_of_display_chars;
            //word_length = Zi8GetCharInfo2(pIME->pGetParam->pCandidates[pIME->CandidateCursor], tempString, 12, ZI8_GETMODE_PINYIN, pIME->pGetParam->pElements, (ZI8UCHAR)count );
            word_length = Zi8GetCharInfo(pIME->pGetParam->pCandidates[pIME->CandidateCursor], tempString, 12, ZI8_GETMODE_PINYIN);
            //TRACE_EVENT((char*)tempString);
            sprintf(debug, "chars returned: %d", word_length);
            //TRACE_EVENT(debug);

            if ( word_length > 0 )
            {
                if ( word_length < count )
                    no_of_display_chars = word_length;
                else
                    no_of_display_chars = count;

                for ( i = 0; i < no_of_display_chars; i++ )
                {
                    Temp = tempString[i];
                    LowByte = tempString[i] & 0x00FF;
                    HighByte = tempString[i] & 0xFF00;
                    Temp = (LowByte << 8) & 0xFF00;
                    HighByte = (HighByte >> 8) & 0x00FF;
                    Temp = Temp |HighByte;
                    pIME->pDisplayElementBuffer[i] = Temp;
                }
                pIME->pDisplayElementBuffer[no_of_display_chars] = 0x0000;//terminate string
            }
        }
    }

    //if (pIME->CandidateCursor == 0)
    /* format of the data stored in the array pointed by pCandidates is coverted for display */
    for ( i = 0; i < pIME->pGetParam->count; i++ )
    {
        Temp = pIME->pGetParam->pCandidates[i];
        LowByte = pIME->pGetParam->pCandidates[i] & 0x00FF;
        HighByte = pIME->pGetParam->pCandidates[i] & 0xFF00;
        Temp = (LowByte << 8) & 0xFF00;
        HighByte = (HighByte >> 8) & 0x00FF;
        Temp = Temp | HighByte;
        pIME->pGetParam->pCandidates[i] = Temp;
    }
    pIME->pGetParam->pCandidates[pIME->candidates] = 0x0000;//terminate string

}


/*******************************************************************************

 $Function:    	Uni_strlen

 $Description:	To count the number of element from the input array

 $Returns:		number of element

 $Arguments:	

*******************************************************************************/
ZI8WCHAR Uni_strlen(PZI8WCHAR String)
{
    int i = 0;
    ZI8WCHAR count = 0;

    while ( String[i] != 0 )
    {
        i++;
        count++;
    }
    return count;
}


/*****************************************************************************************************/
/* Following functions are written as dummy interfaces to bypass the eZitext. The objective is to check and      */
/* simulate the implemented code to try to minimize the software bugs. The dummy functions written below need */
/* to be removed when eZitext library and object code are available.         						 */
/*****************************************************************************************************/
/*ZI8UCHAR Zi8GetCandidates(PZI8GETPARAM pGetParam)
{	
    int MoreTickCount = 0;
    int i = 0;

    i = pGetParam->ElementCount;

    while((i > 0) && pGetParam->pElements[i - 1] == ZI8_CODE_MORE)
    {
        i--;
        MoreTickCount++;
    }
        
    if(MoreTickCount > 0)
    {
        if(MoreTickCount % 2 == 0)
        {
            pGetParam->pCandidates[0]  	= 0x91CC;
            pGetParam->pCandidates[1]  	= 0x91CD;
            pGetParam->pCandidates[2]  	= 0x91CF;
            pGetParam->pCandidates[3]  	= 0x949F;
            pGetParam->pCandidates[4]  	= 0x94C3;
            pGetParam->pCandidates[5] 	= 0x9501;
            pGetParam->pCandidates[6]  	= 0x9519;
        }
        else
        {
            pGetParam->pCandidates[0]  	= 0x5DE5;
            pGetParam->pCandidates[1]  	= 0x5DF1;
            pGetParam->pCandidates[2]  	= 0x5DF2;
            pGetParam->pCandidates[3]  	= 0x5E01;
            pGetParam->pCandidates[4]  	= 0x5E74;
            pGetParam->pCandidates[5] 	= 0x5F00;
            pGetParam->pCandidates[6]  	= 0x5F0F;
        }
    }
    else
    {
        pGetParam->pCandidates[0]  	= 0x8F93;
        pGetParam->pCandidates[1]  	= 0x5165;
        pGetParam->pCandidates[2]  	= 0x53F7;
        pGetParam->pCandidates[3]  	= 0x7801;
        pGetParam->pCandidates[4]  	= 0x9605;
        pGetParam->pCandidates[5] 	= 0x8BFB;
        pGetParam->pCandidates[6]  	= 0xF022;
    }
    pGetParam->count = 7;
    return pGetParam->count;
}

/*void Zi8Initialize(void)
{
}*/

/****************************************************************************************
 $Function:    	Zi_onekey_keypress

 $Description:	onekey pinyin input

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003.10.13

 $modify: 2003.10.20 sunsj
          2003.11.01 sunsj modify the size of the temp pinyin buffer
                           modify the method that compare the element and pinyin table

****************************************************************************************/
void Zi_onekey_keypress(pIME_DATA pIME , PZI8WCHAR key_map)
{
    int i=0,j=0;    /* 2003/10/20 sunsj */
    int l=0,k=0;
    BOOL Element_Is_True=FALSE;
    BOOL valid_element=TRUE;
    BOOL if_valid_element=TRUE;
    int Loop;       /* 2003/10/20 sunsj */
    BOOL Element_Is_Pinyin = FALSE; /* 2003/10/20 sunsj */
    /* 2003/11/1 sunsj the max pinyin number is 6 so the buf need 7 */
    char temp_pinyin[7];

    /* 2003/10/20 sunsj */
    if ( pIME->pGetParam->ElementCount > 6 )
        return;

    pIME->pGetParam->wordCandidates = 0;
    pIME->pGetParam->WordCharacterCount = 0;

    /* Note: add code here to check if we are end of buffer */
    pIME->moreCount = 0;
    pIME->Element_Select = 0;

    pIME->pGetParam->GetMode = ZI8_GETMODE_PINYIN;
    pIME->pGetParam->GetOptions = ZI8_GETOPTION_DEFAULT;

    pIME->ElementNumber++;
    pIME->pGetParam->ElementCount = pIME->ElementNumber;

    if ( pIME->pGetParam->ElementCount>1 )
    {
        if ( pIME->pGetParam->GetMode == ZI8_GETMODE_PINYIN )
        {
            k = 0;
            for ( i=0;i < pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-2].Count;i++ )
            {
                memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-2].PinyinEleBUF[i], (pIME->pGetParam->ElementCount-1)*sizeof(ZI8WCHAR));

                for ( l=0;l<key_map[5];l++ )
                {
                    pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1]=key_map[l];

                    if ( key_map[l]==ZI8_CODE_PINYIN_N && (pIME->pGetParam->ElementCount<=3) &&
                         pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_O )
                    {
                        if ( pIME->pGetParam->ElementCount==2 )
                        {
                            valid_element=FALSE;
                        }
                        else if ( pIME->pGetParam->ElementCount==3 )
                        {
                            switch ( pIME->pGetParam->pElements[0] )
                            {
                            case ZI8_CODE_PINYIN_B:
                            case ZI8_CODE_PINYIN_M:
                            case ZI8_CODE_PINYIN_P:
                            case ZI8_CODE_PINYIN_F:
                            case ZI8_CODE_PINYIN_W:
                                valid_element=FALSE;
                                break;
                            }
                        }
                    }
                    else if ( (key_map[l]==ZI8_CODE_PINYIN_O)&&(pIME->pGetParam->ElementCount==3) &&
                              (pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_I) )
                    {
                        switch ( pIME->pGetParam->pElements[0] )
                        {
                        case ZI8_CODE_PINYIN_B:
                        case ZI8_CODE_PINYIN_M:
                        case ZI8_CODE_PINYIN_P:
                        case ZI8_CODE_PINYIN_C:
                        case ZI8_CODE_PINYIN_D:
                        case ZI8_CODE_PINYIN_L:
                        case ZI8_CODE_PINYIN_N:
                        case ZI8_CODE_PINYIN_R:
                        case ZI8_CODE_PINYIN_S:
                        case ZI8_CODE_PINYIN_Y:
                        case ZI8_CODE_PINYIN_T:
                        case ZI8_CODE_PINYIN_Z:
                            valid_element=FALSE;
                            break;
                        }
                    }
                    else if ( (pIME->pGetParam->ElementCount==4)&&(key_map[l]==ZI8_CODE_PINYIN_O) &&  //liu for pinyin
                              (pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_I) )
                    {
                        if ( pIME->pGetParam->pElements[1]==ZI8_CODE_PINYIN_H )
                        {
                            switch ( pIME->pGetParam->pElements[0] )
                            {
                            case ZI8_CODE_PINYIN_Z:
                            case ZI8_CODE_PINYIN_C:
                            case ZI8_CODE_PINYIN_S:
                                valid_element=FALSE;
                                break;
                            }
                        }
                    }
                    else if ( (key_map[l]==ZI8_CODE_PINYIN_A)&&(pIME->pGetParam->ElementCount==3) &&
                              (pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_V) )
                    {
                        switch ( pIME->pGetParam->pElements[0] )
                        {
                        case ZI8_CODE_PINYIN_L:
                        case ZI8_CODE_PINYIN_N:
                            valid_element=FALSE;
                            break;
                        }
                    }
                    //pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                    //pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
                    //pIME->pGetParam->FirstCandidate = 0;
                    //pIME->pGetParam->MaxCandidates = 1;
                    //pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

                    // char g_str[10];

                    /* 2003/11/1 sunsj if valid_element is false so we need not check the element */
                    if ( valid_element == TRUE )
                    {
                        /* 2003/10/20 sunsj check pinyin code */
                        for ( j=0; j<7; j++ )
                        {
                            temp_pinyin[j] = (UCHAR)pIME->pGetParam->pElements[j] & 0x00ff;
                        }

                        Element_Is_Pinyin = FALSE;
                        for ( Loop=0;Loop<MaxPinYin;Loop++ )
                        {
                            if ( strncmp(PinyinTable[Loop],&temp_pinyin[0],strlen(&temp_pinyin[0])) == 0 )
                            {
                                Element_Is_Pinyin = TRUE;
                                /* 2003/11/1 sunsj if the element is pinyin code then break the search */
                                break;
                            }
                        }
                    }

                    //if(pIME->pGetParam->count!=0 && pIME->pGetParam->letters==pIME->pGetParam->ElementCount && valid_element)
                    if ( (Element_Is_Pinyin == TRUE) && valid_element )
                    {
                        pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].Count++;
                        memcpy(pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[k], pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-2].PinyinEleBUF[i], (pIME->pGetParam->ElementCount-1)*sizeof(ZI8WCHAR));
                        pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[k][pIME->pGetParam->ElementCount-1]=key_map[l];
                        Element_Is_True=TRUE;
                        k++;
                    }
                    valid_element=TRUE;
                }
            }
        }
    }
    else
    {
        /* 2003/11/1 sunsj */
        memset(pIME->PinyinElementBUF, 0, sizeof(pIME->PinyinElementBUF));
        /*
        for(i=0;i<6;i++)
        {
            for(k=0;k<pIME->PinyinElementBUF[i].Count;k++)
            {
                memset(pIME->PinyinElementBUF[i].PinyinEleBUF[k],0x0,6*sizeof(ZI8WCHAR));
            }
            pIME->PinyinElementBUF[i].Count = 0;
        }
        */
        for ( i=0;i<key_map[5];i++ )
        {
            pIME->pGetParam->pElements[0]=key_map[i];
            //pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            //pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            //pIME->pGetParam->FirstCandidate = 0;
            //pIME->pGetParam->MaxCandidates = 1;
            //pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            for ( j=0; j<7; j++ )
            {
                temp_pinyin[j] = (UCHAR)pIME->pGetParam->pElements[j] & 0x00ff;
            }

            /* 2003/10/20 sunsj chesk pinyin code */
            Element_Is_Pinyin = FALSE;
            for ( Loop=0;Loop<MaxPinYin;Loop++ )
            {
                if ( strncmp(PinyinTable[Loop],temp_pinyin,strlen(temp_pinyin)) == 0 )
                {
                    Element_Is_Pinyin = TRUE;
                    /* 2003/11/1 sunsj if the element is pinyin code break the search */
                    break;
                }
            }

            //if(pIME->pGetParam->count!=0)
            if ( Element_Is_Pinyin == TRUE )
            {
                U8 Temp_element_num=0;
                pIME->PinyinElementBUF[0].Count++;
                Temp_element_num = pIME->PinyinElementBUF[0].Count;
                pIME->PinyinElementBUF[0].PinyinEleBUF[Temp_element_num-1][0]=key_map[i];
                Element_Is_True=TRUE;
            }
        }
    }

    if ( Element_Is_True == TRUE )
    {
        memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[0], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
        pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        /* 2003/11/1 sunsj we need convert data after Zi8GetCandidates */
        if ( pIME->candidates > 0 )
        {
            /* Convert the data storage format for display purpose */
            DataConvert(pIME);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;
        }
    }
    else
    {
        //pIME->pGetParam->ElementCount-=1;
        pIME->ElementNumber--;
        pIME->pGetParam->ElementCount = pIME->ElementNumber;
        memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[0], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
        pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        /* 2003/11/1 sunsj because the candidate buffer has not been changed so need not 
           get candidate again */
        //pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
        if_valid_element=FALSE;
    }

    /* 2003/11/1 sunsj because if the element is wrong so we need not convert the data */
    /*
    if ( pIME->candidates > 0 )
    {
        //Convert the data storage format for display purpose
        DataConvert(pIME);
        //initialize the candidate cursor to zero
        pIME->CandidateCursor = 0;
    }
    */
}

/****************************************************************************************
 $Function:    	Zi_GetElementCandidates

 $Description:	onekey pinyin input get candidates

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003.10.13

****************************************************************************************/

int Zi_GetElementCandidates(pIME_DATA pIME)
{
    int old_morecount = pIME->moreCount;

    if ( pIME->ElementNumber > 0 )
    {
        pIME->pGetParam->ElementCount = pIME->ElementNumber;
        pIME->moreCount = 0;
        if ( pIME->PinyinElementBUF[pIME->ElementNumber-1].Count > 1 )
        {
            memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[pIME->Element_Select % pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].Count], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
        }
        else
        {
            pIME->moreCount = old_morecount;
        }

        if ( pIME->candidates > 0 )
        {
            /* Convert the data storage format for display purpose */
            DataConvert(pIME);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;
        }

        return(pIME->candidates);
    }
    else
        return 0;
}

/****************************************************************************************
 $Function:    	UnicodeConver

 $Description:	convert element buffer to display element buffer

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003.10.13

****************************************************************************************/
void UnicodeConver(USHORT* inputString, USHORT* outputString)
{
    USHORT HighByte;
    USHORT Temp;
    USHORT LowByte;
    USHORT tempString[25];
    int word_length;
    int i       = 0;
    int count   = 0;

    //count = wstrlen((char *)inputString);
    while ( inputString[i] )
    {
        /* format of the data stored in the array pointed by pCandidates is coverted for display */
        Temp = inputString[i];
        LowByte = Temp & 0x00FF;
        HighByte = Temp & 0xFF00;
        Temp = (LowByte << 8) & 0xFF00;
        HighByte = (HighByte >> 8) & 0x00FF;
        Temp = Temp | HighByte;
        outputString[i] = Temp;
        i++;
    }
}

/****************************************************************************************
 $Function:    	Zi_onekey_clear

 $Description:	onekey pinyin input clear function

 $Returns: void

 $Author Name:  Sunsj

 $Date: 2003.10.13
 
****************************************************************************************/
void Zi_onekey_clear(pIME_DATA pIME)
{
    int i=0;

    /* Note: add code here to check if we are end of buffer */
    if ( pIME->ElementNumber != 0 )
    {
        pIME->moreCount = 0;
        pIME->Element_Select = 0;

        pIME->ElementNumber--;
        pIME->pGetParam->ElementCount = pIME->ElementNumber;

        for ( i=0; i < pIME->PinyinElementBUF[pIME->pGetParam->ElementCount].Count; i++ )
        {
            memset( pIME->PinyinElementBUF[pIME->pGetParam->ElementCount].PinyinEleBUF[i],0x0,6*sizeof(ZI8WCHAR) );
        }
        pIME->PinyinElementBUF[pIME->pGetParam->ElementCount].Count=0;

        if ( pIME->pGetParam->ElementCount != 0 )
        {
            /* now we need to get candidates with the new stroke */
            memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[0], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
            pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        }
        else
        {
            pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
            pIME->candidates    = 0;
            pIME->pGetParam->pCandidates[pIME->candidates] = 0x0000;
            pIME->pDisplayElementBuffer[pIME->pGetParam->ElementCount] = 0x0000;
            DataConvert(pIME);
            return;
        }

        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        DataConvert(pIME);
        /* initialize the candidate cursor to zero */
        pIME->CandidateCursor = 0;
    }
    else
    {
        if ( pIME->pGetParam->WordCharacterCount > 0 )
            pIME->pGetParam->WordCharacterCount--;

        /* remove the character at cursor position */
        if ( pIME->TextCursor != 0 )
        {
            /* replace last character with zero */
            if ( pIME->TextBufferCount==pIME->TextCursor )
            {
                pIME->pTextBuffer[--pIME->TextCursor] = 0;
                pIME->TextBufferCount--;
            }
            else if ( pIME->TextBufferCount > pIME->TextCursor )
            {
                for ( i=pIME->TextCursor; i<pIME->TextBufferCount; i++ )
                {
                    pIME->pTextBuffer[i-1]=pIME->pTextBuffer[i];
                }
                pIME->pTextBuffer[pIME->TextBufferCount-1]=0;
                pIME->TextCursor--;
                pIME->TextBufferCount--;
            }
        }
    }
}

/****************************************************************************************
 $Function:    	IMECandidatePageUp

 $Description:	onekey pinyin input candidates pageup

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2003.10.13

 $modify: 2003.10.16 sunsj modify word association screen
          2003.11.01 sunsj modify pinyin and stroke input

****************************************************************************************/

void IMECandidatePageUp(pIME_DATA pIME)
{
    /* 2003/11/1 sunsj pinyin and stroke use the same method */
    if ( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        if ( pIME->moreCount != 0 )
        {
            pIME->moreCount--;  
        }

        /* now we need to get candidates */
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        DataConvert(pIME);
    }
    /* 2003/11/1 sunsj remove */
    /*
    else if ( pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        if( pIME->moreCount != 0 )
        {
            pIME->moreCount--;
        }

        //now we get the new candidates
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        DataConvert(pIME);
    }
    */
    else if ( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if ( pIME->CandidateCursor < CANDIDATES_PER_GROUP )
        {
            if ( pIME->moreCount != 0 )
            {
                pIME->moreCount--;

                /* set the new candidate cursor */
                pIME->CandidateCursor += CANDIDATES_PER_GROUP;

                /* 2003/10/28 sunsj remove */
                /*
                if( pIME->pGetParam->WordCharacterCount == 0 )
                {
                    //remove the element more code
                    pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0x0000;
                }
                    */

                /* now we get the new candidate */
                pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

                DataConvert(pIME);
            }
        }
        else
        {
            pIME->CandidateCursor -= CANDIDATES_PER_GROUP;
        }

    }
}

/****************************************************************************************
 $Function:    	IMECandidatePageDown

 $Description:	onekey pinyin candidate pagedown

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date: 2003.10.13

 $modify: 2003.10.16 sunsj add the operate in word association screen
          2003.11.01 sunsj modify the pinyin and stroke input

****************************************************************************************/

void IMECandidatePageDown(pIME_DATA pIME)
{
    /* 2003/11/1 sunsj pinyin and stroke use the same method */
    if ( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        //pIME->CandidateCursor=0;
        pIME->moreCount++;

        /* now we need to get new candidates */
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        if ( pIME->pGetParam->count == 0 )
        {
            pIME->moreCount--;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
        }

        if ( pIME->CandidateCursor >= pIME->candidates )
        {
            pIME->CandidateCursor = 0;
        }
        DataConvert(pIME);
    }
    /* 2003/11/1 sunsj remove */
    /*
    else if ( pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        //pIME->CandidateCursor = 0;
        pIME->moreCount++;

        // now we get the new candidates
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        if( pIME->pGetParam->count == 0 )
        {
            pIME->moreCount--;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
        }

        if( pIME->CandidateCursor >= pIME->candidates )
        {
            pIME->CandidateCursor = 0;
        }
        DataConvert(pIME);
    }
    */
    else if ( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if ( pIME->CandidateCursor < CANDIDATES_PER_GROUP )
        {
            pIME->CandidateCursor += CANDIDATES_PER_GROUP;
        }
        else
        {
            pIME->moreCount++;
            pIME->CandidateCursor -= CANDIDATES_PER_GROUP;

            /* 2003/10/28 sunsj remove */
            /*
            if( pIME->pGetParam->WordCharacterCount == 0 )
            {
                //set the more candidate code
                pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = ZI8_CODE_MORE;
            }
                */

            /* now we get the new candidate */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

            if ( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;
                pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }

            DataConvert(pIME);
        }
    }
}

/****************************************************************************************
 $Function:    	ElementHighlightDisplayContorl

 $Description:	display highlight element

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date: 2003.10.13

****************************************************************************************/
void ElementHighlightDisplayContorl(pIME_DATA pIME)
{
    if ( pIME->Element_Select%4 == 0 )
    {
        dspl_TextOut(1,FIFTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)pIME->PinyinDisplayBuf[0]);
    }
    else if ( pIME->Element_Select%4 == 1 )
    {
        dspl_TextOut(61,FIFTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)pIME->PinyinDisplayBuf[1]);
    }
    else if ( pIME->Element_Select%4 == 2 )
    {
        dspl_TextOut(1,SIXTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)pIME->PinyinDisplayBuf[2]);
    }
    else if ( pIME->Element_Select%4 == 3 )
    {
        dspl_TextOut(61,SIXTH_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)pIME->PinyinDisplayBuf[3]);
    }
}
