

#ifndef _DEF_MMI_CHINESE_H_
#define _DEF_MMI_CHINESE_H_
/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMChineseInput
 $File:		    MMChineseInput.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

 
                        
********************************************************************************
 $History: MMChineseInput.h

	25/10/00			Original Condat(UK) BMI version.
	2003/11/10          sunsj modify T_CHINESE_DATA add cursor.
	   
 $End

*******************************************************************************/
#include "zi8api.h"
#include "MmiEditor.h"



#define CANDIDATES_PER_GROUP	7
#define ELEMENT_PERPAGE			4	/* 2003/10/13 sunsj the number of display element */
//#define TEXT_BUFFER_EDIT_SIZE	80  // size of 80 is defined for chinese SMS
#define TEXT_BUFFER_EXTRA_SPACE	20 //This is the zise allowed for element buffer.

//define for InputScreenType
#define TEXT_DISPLAY_SCREEN	  		1
#define STROKE_INPUT_SCREEN 		2
#define PINYIN_INPUT_SCREEN 		3
#define WORD_ASSOCIATION_SCREEN 	4
#define SYMBOL_INPUT_SCREEN			5

//define for EditorMode
#define STROKE_INPUT_MODE	  		10
#define PINYIN_INPUT_MODE 			11
#define LATIN_INPUT_MODE 			12

typedef enum
{
	CHINESE_INPUT_INIT, 
	CHINESE_INPUT_DESTROY,
	ADD_SYMBOL,
	LATIN_INPUT
} chinese_editor_events;


typedef struct
{
  char *       		TextString;
  T_EDIT_CB     	Callback;
  USHORT          	Identifier;
  int				LeftSoftKey;
  UBYTE				DestroyEditor;
  USHORT			EditorSize;
  int				InputMode;	/* 2003/10/26 sunsj add for pinyin and stroke mode */
  int               Cursor;		/* 2003/11/10 sunsj */
  int               edtInPbk;	/* 2003/11/27 sunsj add flag for phone book input */
} T_CHINESE_DATA;

//typedef void (*T_CHINESE_EDIT_CB) (T_MFW_HND, USHORT, USHORT);

T_MFW_HND chinese_input (T_MFW_HND parent_win, T_CHINESE_DATA* chinese_data, SHORT kc);
//T_MFW_HND chinese_input (T_MFW_HND        parent_win,
//                       T_MFW_KBD *kc);
void	chinese_input_destroy		(T_MFW_HND  own_window);

int chinese_input_menu(MfwMnu* m, MfwMnuItem* i);

#endif



