
/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MmiDialogs
 $File:		    MmiDialogs.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:MMI Information dialogue handling.
 

                        
********************************************************************************

 $History: MmiDialogs.c

    25/10/00			Original Condat(UK) BMI version.	
       
 $End

*******************************************************************************/

/********************************************************************************

 $History: MmiDialogs.c

    22/07/00			zy Mobile Innovation change the dialog show win 	
       
 $End

*******************************************************************************/
/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiDummy.h"
//JVJE #include "MmiMsgsEdit.h"
//#include "MmiLists.h"
#include "MmiMmi.h"

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "GameDisplay.h"

/* JF Modified
*/
#include "MmiBookController.h"
#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mmihost.h"  //xsf add 2002.08.23
#include "mmiectimedate.h"  //xsf add 2 lines 2002.09.20
#include "mmisounds.h"
#include "Mmiicons.h"
#include "Mmistart.h"
#include "mmiservices.h" //wufei add 1017
#include "Pwr.h"//zy for driver_Parameter drvpara
#include "mmismsmenu.h"
#include "mmismssend.h"
#include "mmiouteridle.h"
/*
 * START NEW PART
 */
/*2003/11/20, wangyan*/
//#include "TdDisplay.h"
//#define TDTRACE 1
#include "mmiutilapi.h"
//#include "mmiicndialogs.h" /*2004/1/10, wangyan*/
#include "mmiiconresource.h"	/* 2004/06 sunsj modify for picture manage */

typedef struct                                                                               
{
    T_MMI_CONTROL    mmi_control;                                                            
    T_MFW_HND      parent_win;                                                               
    T_MFW_HND      info_win;                                                                 
    T_MFW_HND      info_tim;                                                                 
    T_MFW_HND      info_kbd;                                                                 
    T_MFW_HND      info_kbd_long;                                                            
    T_MFW_HND      icon;                                                                     

    /* animation fields */                                                                                       
    UBYTE          number_of_frames;                                                         
    UBYTE          current_frame;                                                            
    T_MFW_HND      anim_time;                                                                
    MfwIcnAttr     *icon_array;                                                              
    MfwIcnAttr     *current_icon;                                                            
    USHORT         iconIndex;                                                                
    T_MFW_HND      animation_timer;                                                          
    AnimationReason  animareason;                                                            
    T_MFW_HND      delete_tim_win;//gdy add 												 
    USHORT         id;            //gdy add 												 

    /* internal data */
    char               *TextString;                                                              
    USHORT         LeftSoftKey;                                                              
    USHORT         RightSoftKey;                                                             
    char               *LSKString;      // SH - text for left soft key							 
    char               *RSKString;      // SH - text for right soft key 						 
    BOOL               SoftKeyStrings;  // SH - TRUE if using text rather than IDs for soft keys 
    UBYTE          WrapStrings;     // GW - bits 0,1 set=wrap string 1,2					 
    ULONG          Time;                                                                     
    T_MFW_EVENT    KeyEvents;                                                                
    USHORT         TextId;                                                                   
    USHORT         Identifier;                                                               
    char *         TextString2;                                                              
    USHORT         TextId2;                                                                  
    char *         TextString3;                                                              
    USHORT         TextId3;                                                                  
    T_VOID_FUNC    Callback;                                                                 
    UINT32         FontColor;                                                                
    UINT32         BackColor;                                                                
} T_dialog_info;                                                                             


static T_MFW_HND   dialog_info_create    (T_MFW_HND  parent_win);
static void        dialog_info_destroy   (T_MFW_HND  own_window);
static void        dialog_info           (T_MFW_HND  win,
                                          USHORT event, SHORT value, void * parameter);
void DrawAnimFixMovBit(AnimationReason Reason,int animindex );
static int         dialog_info_win_cb    (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_CB    dialog_info_tim_cb    (T_MFW_EVENT event, T_MFW_TIM * tc);
static int         dialog_info_kbd_cb    (T_MFW_EVENT event, T_MFW_KBD * keyboard);
static int         dialog_info_kbd_long_cb (T_MFW_EVENT event, T_MFW_KBD * keyboard);
void remind_animal(T_MFW_HND parent_win, int id);
void draw_popup_background(void);
void draw_special_background(void);/*2003/12/19, wangyan modify*/
void draw_dialog_current_page(T_dialog_info * data, int current);
void draw_softkeybar_background(void);

void DrawWelcomeAnim(AnimationReason Reason,int animindex);
void DrawGoodbyeAnim(AnimationReason Reason,int animindex);

void mmi_dialogs_insert_animation_CB (T_MFW_EVENT event, T_MFW_TIM *tc);
void mmi_dialogs_insert_fixmov_animation (T_MFW_HND win_dialog , S32 anim_time ,AnimationReason Reason );/* 2003/10/20, wangyan, Add for incomingcall animation. */

static T_MFW_CB  remind_tim_cb(MfwEvt e, MfwTim *tc);
static UINT32 oldfontcolor,oldbackcolor;
static UBYTE  tim_NoSimClock=0;  //xsf add 12.20
extern T_MFW_HND  lowVoltageWin;
extern void Force_refresh();
extern void temptest();//jhxu720 add
extern driver_Parameter drvpara;//zy 10/22 for hall action in call
extern T_MFW_HND info_window;//gdy add for timer 24/02/03

extern T_MFW_MEM_INFO     memory;
int currentpage=1;
int totalpage=2; 
int firstpage=1;/*wangyan add*/

/*******************************************************************************
 $Function:    	dialog_info_init

 $Description:	initial function before creating info win
 
 $Returns:		void

 $Arguments:	display info

 *******************************************************************************/
void dialog_info_init(T_DISPLAY_DATA *  display_info)
{
    display_info->TextString     ='\0';
    display_info->SoftKeyStrings =0;
    display_info->LeftSoftKey    =0;
    display_info->RightSoftKey   =TxtSoftBack;
    display_info->LSKString      ='\0';
    display_info->RSKString      ='\0';
    display_info->Time          =0;
    display_info->KeyEvents      =KEY_RIGHT |KEY_LEFT|KEY_POWER;
    display_info->TextId         =0;
    display_info->Identifier       =0;
    display_info->TextString2     ='\0';
    display_info->TextId2        =0;
    display_info->Callback       =(T_VOID_FUNC)NULL;
    display_info->WrapStrings    =0;
    display_info->icn            ='\0';
    display_info->FontColor       =0x000000;
    display_info->BackColor      =0xffffff;
    display_info->iconindex       =0; 
    display_info->TextString3     ='\0';//zy add 2003-01-29
    display_info->TextId3        =0;
}
/*******************************************************************************

 $Function:    	info_dialog

 $Description:	Common information dialog
 
 $Returns:		Dialogue info win

 $Arguments:	parent win, display info
 
*******************************************************************************/
T_MFW_HND info_dialog (T_MFW_HND parent_win, T_DISPLAY_DATA * display_info)
{
    T_MFW_HND win;

    display_info->SoftKeyStrings = FALSE;
    win = dialog_info_create (parent_win);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, DIALOG_INIT, 0, display_info);
    }
    return win;
}


/*******************************************************************************

 $Function:    	info_dialog_softkeystrings

 $Description:	Common information dialog, sets "softkeystrings" to TRUE
 
 $Returns:		Dialogue info win

 $Arguments:	parent win, display info, leftsoftkey, rightsoftkey
 
*******************************************************************************/
T_MFW_HND info_dialog_softkeystrings (T_MFW_HND parent_win, T_DISPLAY_DATA * display_info)
{
    T_MFW_HND win;

    display_info->SoftKeyStrings = TRUE;
    win = dialog_info_create (parent_win);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, DIALOG_INIT, 0, display_info);
    }
    return win;
}


/*******************************************************************************

 $Function:    	dialog_info_create

 $Description:	Creation of an information dialog
 
 $Returns:		Dialogue info win

 $Arguments:	parent win
 
*******************************************************************************/
static T_MFW_HND dialog_info_create (T_MFW_HND parent_win)
{
    T_MFW_WIN     * win_data;
    T_dialog_info *  data = (T_dialog_info *)ALLOC_MEMORY (sizeof (T_dialog_info));

    TRACE_FUNCTION ("dialog_info_create()");

    data->info_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)dialog_info_win_cb);

    if( data->info_win EQ 0 )
        return 0;

    /* Create window handler */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)dialog_info;
    data->mmi_control.data     = data;
    data->parent_win           = parent_win;
    win_data                   = ((T_MFW_HDR *)data->info_win)->data;
    win_data->user             = (void *)data;

    /* return window handle */
    return data->info_win;
}


/*******************************************************************************

 $Function:    	dialog_info_destroy

 $Description:	Destruction of an information dialog
 
 $Returns:		void

 $Arguments:	win
 
*******************************************************************************/
void dialog_info_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    T_dialog_info * data = (T_dialog_info *)win->user;


    MMI_TRACE_EVENT(("win_incoming dialog_info_destroy()"));
    if( data )
    {
        /* Exit TIMER & KEYBOARD Handle */

        kbd_delete (data->info_kbd);
        kbd_delete (data->info_kbd_long);

        tim_delete (data->info_tim);

        tim_delete (data->delete_tim_win);
        icnDelete(data->icon);//zy 09/11
        if( data->animation_timer )
            tim_delete(data->animation_timer);
        /* Delete WIN Handler  */
        win_delete (data->info_win);
        /* Free Memory  */
        FREE_MEMORY ((void *)data, sizeof (T_dialog_info));
    }
}


#if 1
//zhaowm 2003.1.28
void dlg_zeroDisplayData( T_DISPLAY_DATA *displayInfo)
{
    if( displayInfo == NULL )
        return;
    displayInfo->LeftSoftKey    = 0;
    displayInfo->RightSoftKey   = 0;
    displayInfo->LSKString      = NULL;
    displayInfo->RSKString      = NULL;
    displayInfo->TextString     = NULL;
    displayInfo->TextString2    = NULL;
    displayInfo->TextString3    = NULL;//zy 02-10
    displayInfo->WrapStrings    = 0;
    displayInfo->TextId         = 0;
    displayInfo->TextId2        = 0;
    displayInfo->TextId3        = 0;//zy 02-10
    displayInfo->SoftKeyStrings = FALSE;
    //	displayInfo->Callback		= NULL;
    //    displayInfo->Time        	= 0;
    //?	displayInfo->Time			= FOREVER;											
    //    displayInfo->KeyEvents   	= 0;
    displayInfo->Identifier     = 0;
    dlg_initDisplayData_events( displayInfo, NULL, 0, 0);

}

void dlg_initDisplayData_TextId( T_DISPLAY_DATA *displayInfo, int lsk, int rsk, int str1, int str2)
{
    if( displayInfo == NULL )
        return;
    dlg_zeroDisplayData(displayInfo);
    displayInfo->LeftSoftKey    = (USHORT)lsk;
    displayInfo->RightSoftKey   = (USHORT)rsk;
    displayInfo->TextId         = str1;
    displayInfo->TextId2        = str2;

}
void dlg_initDisplayData_TextStr( T_DISPLAY_DATA *displayInfo, int lsk, int rsk,char *str1, char *str2)
{
    if( displayInfo == NULL )
        return;
    dlg_zeroDisplayData(displayInfo);
    displayInfo->LeftSoftKey    = (USHORT)lsk;
    displayInfo->RightSoftKey   = (USHORT)rsk;
    displayInfo->TextString     = str1;
    displayInfo->TextString2    = str2;
}

void dlg_initDisplayData_events( T_DISPLAY_DATA *displayInfo, T_VOID_FUNC callback, int timer, T_MFW_EVENT keyEvents)
{
    displayInfo->Callback       = callback;
    displayInfo->Time           = timer;
    displayInfo->KeyEvents      = keyEvents;
}
#endif /*2003/12/13, wangyan delete*/

//
/*******************************************************************************

 $Function:    	dialog_info

 $Description:	Dialog function for information dialog
 
 $Returns:		void

 $Arguments:	win, window handle event, value, parameter

*******************************************************************************/
void dialog_info (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
    T_dialog_info  * data         = (T_dialog_info *)win_data->user;
    T_DISPLAY_DATA * display_info = (T_DISPLAY_DATA *)parameter;

    TRACE_FUNCTION ("dialog_info()");

    switch( event )
    {
    case DIALOG_INIT:
        /* Initialize dialog */

        /* Create timer and keyboard handler */
        if( display_info->Identifier==RECTCALLDETAIL )
        {
#ifndef FOR_FTA_CTA	
            data->info_tim = tim_create (win, display_info->Time, (T_MFW_CB)dialog_info_tim_cb);
#endif		

            data->info_kbd = kbd_create (win, KEY_ALL, (T_MFW_CB)dialog_info_kbd_cb);
            data->info_kbd_long = kbd_create(win,KEY_ALL|KEY_LONG,(MfwCb)dialog_info_kbd_long_cb);

            /* Store any other data */
            data->KeyEvents = display_info->KeyEvents;
            data->TextString = display_info->TextString;
            data->LeftSoftKey = display_info->LeftSoftKey;
            data->RightSoftKey = display_info->RightSoftKey;
            data->SoftKeyStrings = display_info->SoftKeyStrings;    // SH - TRUE if using strings rather than IDs
            data->LSKString = display_info->LSKString;      // Text for left soft key
            data->RSKString = display_info->RSKString;      // Text for right soft key
            data->TextId = display_info->TextId;
            data->Identifier = display_info->Identifier;
            data->Callback = display_info->Callback;
            data->TextString2 = display_info->TextString2;
            data->TextId2 = display_info->TextId2;
            data->WrapStrings = display_info->WrapStrings;  //GW-SPR#762
            data->iconIndex =display_info->iconindex;
            data->BackColor =display_info->BackColor;
            data->FontColor =display_info->FontColor;
            data->TextString3 = display_info->TextString3;
            data->TextId3 = display_info->TextId3;
            data->Time = display_info->Time;
            data->animation_timer =0;
#ifndef FOR_FTA_CTA	
            if( display_info->Time NEQ FOREVER )
            {
                tim_start (data->info_tim);
            }
#endif

            win_show (win);
        }
        else
        {
            switch( display_info->iconindex )
            {
            case REMIND_COMPLETE:
                /* 2004/05/17 sunsj modify */
                display_info->Time=200*7;               
                break;
            case REMIND_FAILURE:
            case REMIND_SUCCEED:   
                if( display_info->Time!=FOREVER )
                {
                    display_info->Time=600;
                }
                break;
            case REMIND_NORECORD:
                if( (display_info->Time == FOREVER)&&(display_info->Identifier!=LOW_VOLTAGE_WARNING) )  ///zym modified
                    display_info->Time=800;
                break;
            default:
                break;
            }
            if( (display_info->Identifier==SERVICES_AOC_STATISTICS)||(display_info->Identifier==MMI_TIMER_STATISTICS) )
            {/* 2003/10/22, wangyan, modify call time statistics menu*/
            }
            else
            {
                if( ((display_info->TextId!=0)||(display_info->TextId!='\0'))&&((display_info->TextString!=0)||(display_info->TextString!='\0')) )
                    /* 2003/10/22, wangyan, modify call time statistics menu*/
                    display_info->TextString='\0';//gdy add to advoid displaying two different text in the same place
                if( ((display_info->TextId2!=0)||(display_info->TextId2!='\0'))&&((display_info->TextString2!=0)||(display_info->TextString2!='\0')) )
                    /* 2003/10/22, wangyan, modify call time statistics menu*/
                    display_info->TextString2='\0';//gdy add to advoid displaying two different text in the same place
            }
            if( (display_info->Identifier==StartAnimDialog)||(display_info->Identifier==StartSwitchoffDialog) )
            {
                data->info_tim = tim_create (win, display_info->Time, (T_MFW_CB)dialog_info_tim_cb);
                tim_start (data->info_tim);
            }
#ifndef FOR_FTA_CTA	
            data->info_tim = tim_create (win, display_info->Time, (T_MFW_CB)dialog_info_tim_cb);
#endif
            data->info_kbd = kbd_create (win, KEY_ALL, (T_MFW_CB)dialog_info_kbd_cb);
            data->info_kbd_long = kbd_create(win,KEY_ALL|KEY_LONG,(MfwCb)dialog_info_kbd_long_cb);

            /* Store any other data */
            data->KeyEvents = display_info->KeyEvents;
            data->TextString = display_info->TextString;
            data->LeftSoftKey = display_info->LeftSoftKey;
            data->RightSoftKey = display_info->RightSoftKey;
            data->SoftKeyStrings = display_info->SoftKeyStrings;    // SH - TRUE if using strings rather than IDs
            data->LSKString = display_info->LSKString;      // Text for left soft key
            data->RSKString = display_info->RSKString;      // Text for right soft key
            data->TextId = display_info->TextId;
            data->Identifier = display_info->Identifier;
            data->Callback = display_info->Callback;
            data->TextString2 = display_info->TextString2;
            data->TextId2 = display_info->TextId2;
            data->WrapStrings = display_info->WrapStrings;  //GW-SPR#762
            data->iconIndex =display_info->iconindex;
            data->BackColor =display_info->BackColor;
            data->FontColor =display_info->FontColor;
            data->TextString3 = display_info->TextString3;
            data->TextId3 = display_info->TextId3;
            data->Time = display_info->Time;
            data->animation_timer        =0;
#ifndef FOR_FTA_CTA	
            if( display_info->Time NEQ FOREVER )
            {
                tim_start (data->info_tim);
            }
#endif
            win_show (win);
        }
        break;
    case DIALOG_DESTROY:
        dialog_info_destroy(win);
        info_window=NULL;
        break;
    }
}

#define MAX_LINE_CHAR MAX_LINE

/*******************************************************************************

 $Function:    	ShowSmsPbkMemory

 $Description:	show sms and phone book's memory state  
            
 $Returns:		

 $Arguments:	
*******************************************************************************/
/*void ShowSmsPbkMemory(int TXTId1,int TXTId2,int  TXTId3,int TXTId4,USHORT TXTId5,USHORT TXTId6)
{
    game_Rectangle param;
    char buffer[MAX_LINE_CHAR+1];
    
    dspl_Clear(0, 0, 120, 160);
    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
        menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
        menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);      

    if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
    {
        dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtMemoryState),0xffffff );
    }
    else
    {
        dspl_colorTextOut(14, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtMemoryState),0xffffff );
    }
    dspl_BitBlt(6, 24, 16, 16, 0, (void *)&iconsimbook, 0);   
    dspl_TextOut(30, 23, 0, (char *)MmiRsrcGetText(TXTId5));

    drawSolidRectangle(28,42,56,55,3,0xDBFFFF,0xDBFFFF);
    sprintf(buffer,"%d",TXTId1);
    dspl_colorTextOut(32, 41,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    dspl_TextOut(60, 41, 0, (char*)GET_TEXT(TxtPhbkUse));
    drawSolidRectangle(28,59,56,72,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId2);
    dspl_colorTextOut(32, 59, DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0xffffff );
    dspl_TextOut(60, 59, 0, (char*)GET_TEXT(TxtTotalCount));
    param.color=0xB9D9EA;
    param.fillcolor=0xB9D9EA;
    param.x1=7;
    param.x2=113;
    param.y1=79;
    param.y2=82;
    DrawRectagle(param);
    param.color=0x5474A7;
    param.fillcolor=0x5474A7;
    param.x1=6;
    param.x2=114;
    param.y1=80;
    param.y2=81;
    DrawRectagle( param);
    dspl_BitBlt(6, 87, 16, 16, 0, (void *)&iconnvmbook, 0);   
    dspl_TextOut(30, 87, 0, (char *)MmiRsrcGetText(TXTId6));
    drawSolidRectangle(28,106,56,119,3,0xDBFFFF,0xDBFFFF);
    sprintf(buffer,"%d",TXTId3);
    dspl_colorTextOut(32, 105,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    dspl_TextOut(60, 105, 0, (char*)GET_TEXT(TxtPhbkUse));
    drawSolidRectangle(28,124,56,137,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer, "%d",TXTId4);
    dspl_colorTextOut(32, 123, DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0xffffff );
    dspl_TextOut(60, 123, 0, (char*)GET_TEXT(TxtTotalCount));
 }*/
/* 2003/11/11, wangyan, modify sms memory show*/
/*void ShowSmsPbkMemory(int TXTId1,int TXTId2,int  TXTId3,int TXTId4,USHORT TXTId5,USHORT TXTId6)
{
    game_Rectangle param;
    char buffer[MAX_LINE_CHAR+1];
    
    dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
        menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
        menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);      

    if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
    {
        dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtMemoryState),0xffffff );
    }
    else
    {
        dspl_colorTextOut(14, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtMemoryState),0xffffff );
    }
    dspl_BitBlt(6, 24, 16, 16, 0, (void *)&iconsimbook, 0);   
    dspl_TextOut(30, 23, 0, (char *)MmiRsrcGetText(TXTId5));

    drawSolidRectangle(80,42,108,55,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId1);
    dspl_colorTextOut(84, 41,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    dspl_TextOut(30, 41, 0, (char*)GET_TEXT(TxtPhbkUse));
    
    drawSolidRectangle(80,59,108,72,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId2);
    dspl_colorTextOut(84, 58, DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0xffffff );
    dspl_TextOut(30, 58, 0, (char*)GET_TEXT(TxtTotalCount));
    param.color=0xB9D9EA;
    param.fillcolor=0xB9D9EA;
    param.x1=7;
    param.x2=113;
    param.y1=79;
    param.y2=82;
    DrawRectagle(param);
    param.color=0x5474A7;
    param.fillcolor=0x5474A7;
    param.x1=6;
    param.x2=114;
    param.y1=80;
    param.y2=81;
    DrawRectagle( param);
    dspl_BitBlt(6, 87, 16, 16, 0, (void *)&iconnvmbook, 0);   
    dspl_TextOut(30, 87, 0, (char *)MmiRsrcGetText(TXTId6));
    
    drawSolidRectangle(80,106,108,119,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId3);
    dspl_colorTextOut(84, 105,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    dspl_TextOut(30, 105, 0, (char*)GET_TEXT(TxtPhbkUse));
    
    drawSolidRectangle(80,124,108,137,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer, "%d",TXTId4);
    dspl_colorTextOut(84, 123, DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0xffffff );
    dspl_TextOut(30, 123, 0, (char*)GET_TEXT(TxtTotalCount));
 }*/
/* 2004/05/25 sunsj modify */
void ShowSmsPbkMemory(int TXTId1,int TXTId2,int  TXTId3,int TXTId4,USHORT TXTId5,USHORT TXTId6)
{
    game_Rectangle param;
    char buffer[MAX_LINE_CHAR+1];
    const char chineseTxtSIMBook1[]= {0x80,0x00,0x53,0x00,0x49,0x00,0x4d,0x53,0x61,0x00,0x00};  
    const char chineseTxtNVMBook1[]= {0x80,0x62,0x4b,0x67,0x3a,0x00,0x00};
    const char EngTxtSIMBook1[]= {"SIM"};   
    const char EngTxtNVMBook1[]= {"Mobile"};


    dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
#if (MAIN_LCD_SIZE==3)//jhxu720
	displayTitle( 0, (char *)MmiRsrcGetText(TxtMemoryState), NULL, TITLE_MIDDLE, 0x000000, 0x000000);   
	
	//	dspl_BitBlt(6, 24, 16, 16, 0, (void *)&iconsimbook, 0);   
	//	dspl_TextOut(30, 23, 0, (char *)MmiRsrcGetText(TXTId5));
	if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
	{
		dspl_TextOut(48, DIALOG_FIRST_LINE+2, 0, (char*)chineseTxtSIMBook1);
		dspl_TextOut(87, DIALOG_FIRST_LINE+2, 0,(char *)chineseTxtNVMBook1);	
	}
	else
	{
		dspl_TextOut(40, DIALOG_FIRST_LINE+2, 0, (char*)EngTxtSIMBook1);
		dspl_TextOut(75, DIALOG_FIRST_LINE+2, 0,(char *)EngTxtNVMBook1);	
	}
	
	dspl_TextOut(1, DIALOG_SECOND_LINE+2, 0, (char*)GET_TEXT(TxtPhbkUse));
	drawSolidRectangle(52,DIALOG_SECOND_LINE+4,74,DIALOG_THIRD_LINE+2,3,0x5AC7FF,0x5AC7FF);
	sprintf(buffer,"%d",TXTId1);
	dspl_colorTextOut(54, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
	drawSolidRectangle(88,DIALOG_SECOND_LINE+4,110,DIALOG_THIRD_LINE+2,3,0x5AC7FF,0x5AC7FF);
	sprintf(buffer,"%d",TXTId3);
	dspl_colorTextOut(90, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
	
	dspl_TextOut(1, DIALOG_THIRD_LINE+8, 0, (char*)GET_TEXT(TxtTotalCount));
	drawSolidRectangle(52,DIALOG_THIRD_LINE+10,74,DIALOG_FOURTH_LINE+8,3,0x5AC7FF,0x5AC7FF);
	sprintf(buffer,"%d",TXTId2);
	dspl_colorTextOut(54, DIALOG_THIRD_LINE+8,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
	drawSolidRectangle(88,DIALOG_THIRD_LINE+10,110,DIALOG_FOURTH_LINE+8,3,0x5AC7FF,0x5AC7FF);
	sprintf(buffer,"%d",TXTId4);
	dspl_colorTextOut(90, DIALOG_THIRD_LINE+8,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
#elif ( MAIN_LCD_SIZE==4 )
    displayTitle( 0, (char *)MmiRsrcGetText(TxtMemoryState), NULL, TITLE_MIDDLE, 0x000000, 0x000000);

    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON_LOCATION(ICON_SIMBOOK, 6, 24);
    //dspl_BitBlt(6, 24, 14, 14, 0, (void *)&iconsimbook, 0);   
    dspl_TextOut(30, 23, 0, (char *)MmiRsrcGetText(TXTId5));

    drawSolidRectangle(80,42,108,55,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId1);
    dspl_colorTextOut(84, 41,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    dspl_TextOut(30, 41, 0, (char*)GET_TEXT(TxtPhbkUse));

    drawSolidRectangle(80,59,108,72,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId2);
    dspl_colorTextOut(84, 58, DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0xffffff );
    dspl_TextOut(30, 58, 0, (char*)GET_TEXT(TxtTotalCount));
    param.color=0xB9D9EA;
    param.fillcolor=0xB9D9EA;
    param.x1=7;
    param.x2=113;
    param.y1=79;
    param.y2=82;
    DrawRectagle(param);
    param.color=0x5474A7;
    param.fillcolor=0x5474A7;
    param.x1=6;
    param.x2=114;
    param.y1=80;
    param.y2=81;
    DrawRectagle( param);
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON_LOCATION(ICON_NVMBOOK, 6, 87);
    //dspl_BitBlt(6, 87, 14, 14, 0, (void *)&iconnvmbook, 0);   
    dspl_TextOut(30, 87, 0, (char *)MmiRsrcGetText(TXTId6));

    drawSolidRectangle(80,106,108,119,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId3);
    dspl_colorTextOut(84, 105,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    dspl_TextOut(30, 105, 0, (char*)GET_TEXT(TxtPhbkUse));

    drawSolidRectangle(80,124,108,137,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer, "%d",TXTId4);
    dspl_colorTextOut(84, 123, DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0xffffff );
    dspl_TextOut(30, 123, 0, (char*)GET_TEXT(TxtTotalCount));

#elif ( MAIN_LCD_SIZE==2 )
    /* 2004/04/22 sunsj modify */
    displayTitle( 0, (char *)MmiRsrcGetText(TxtMemoryState), NULL, TITLE_MIDDLE, 0x000000, 0x000000);

    //	dspl_BitBlt(6, 24, 16, 16, 0, (void *)&iconsimbook, 0);   
    //	dspl_TextOut(30, 23, 0, (char *)MmiRsrcGetText(TXTId5));

    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
    {
        dspl_TextOut(36, DIALOG_FIRST_LINE+2, 0, (char*)chineseTxtSIMBook1);
        dspl_TextOut(75, DIALOG_FIRST_LINE+2, 0,(char *)chineseTxtNVMBook1);    
    }
    else
    {
        dspl_TextOut(40, DIALOG_FIRST_LINE+2, 0, (char*)EngTxtSIMBook1);
        dspl_TextOut(75, DIALOG_FIRST_LINE+2, 0,(char *)EngTxtNVMBook1);    
    }

    dspl_TextOut(1, DIALOG_SECOND_LINE+2, 0, (char*)GET_TEXT(TxtPhbkUse));
    drawSolidRectangle(40,DIALOG_SECOND_LINE+2,62,DIALOG_THIRD_LINE-2,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId1);
    dspl_colorTextOut(42, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    drawSolidRectangle(76,DIALOG_SECOND_LINE+2,98,DIALOG_THIRD_LINE-2,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId3);
    dspl_colorTextOut(78, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );

    dspl_TextOut(1, DIALOG_THIRD_LINE+2, 0, (char*)GET_TEXT(TxtTotalCount));
    drawSolidRectangle(40,DIALOG_THIRD_LINE+2,62,DIALOG_FOURTH_LINE-2,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId2);
    dspl_colorTextOut(42, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
    drawSolidRectangle(76,DIALOG_THIRD_LINE+2,98,DIALOG_FOURTH_LINE-2,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId4);
    dspl_colorTextOut(78, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );
#endif
}

/* 2004/05/26 sunsj modify */
/* 2003/10/22, wangyan, modify call time statistics menu*/
void ShowCalltimerstatistics(T_dialog_info * data, int serviceID)
{
#if(MAIN_LCD_SIZE==4)
    char buffer[MAX_LINE_CHAR+1];

    dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
    /*
    dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
        menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
        menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);      
    */
    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
    {
        if( serviceID==MMI_TIMER_STATISTICS )
            displayTitle( 0, (char *)MmiRsrcGetText(TxtCallDuration), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
        //dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtCallDuration),0xffffff );
        else if( serviceID==SERVICES_AOC_STATISTICS )
            displayTitle( 0, (char *)MmiRsrcGetText(TxtAocStatistics), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
        //dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtAocStatistics),0xffffff );
    }
    else
    {
        if( serviceID==MMI_TIMER_STATISTICS )
            displayTitle( 0, (char *)MmiRsrcGetText(TxtCallDuration), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
        //dspl_colorTextOut(14, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtCallDuration),0xffffff );
        else if( serviceID==SERVICES_AOC_STATISTICS )
            displayTitle( 0, (char *)MmiRsrcGetText(TxtAocStatistics), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
        //dspl_colorTextOut(14, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtAocStatistics),0xffffff );
    }

    dspl_colorTextOut(10, 21,DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(data->TextId),0x000000 );
    drawSolidRectangle(28,42,100,55,3,0x5AC7FF,0x5AC7FF);
    dspl_colorTextOut(32, 41,DSPL_TXTATTR_TRANSPARENT, data->TextString,0x000000 );

    dspl_colorTextOut(10, 61,DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(data->TextId2),0x000000 );
    drawSolidRectangle(28,82,100,95,3,0x5AC7FF,0x5AC7FF);
    dspl_colorTextOut(32, 81,DSPL_TXTATTR_TRANSPARENT, data->TextString2,0x000000 );

    dspl_colorTextOut(10, 101,DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(data->TextId3),0x000000 );
    drawSolidRectangle(28,122,100,135,3,0x5AC7FF,0x5AC7FF);
    dspl_colorTextOut(32, 121,DSPL_TXTATTR_TRANSPARENT, data->TextString3,0x000000 );
#elif (MAIN_LCD_SIZE==3)
    char buffer[MAX_LINE_CHAR+1];


    /*	dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
            menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
            menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);      */
    const char chineseTxtLastCall1[]= {0x80,0x4e,0x0a,0x6b,0x21,0x00,0x00}; 
    const char chineseTxtIncomingCalls1[]= {0x80,0x54,0x7c,0x51,0x65,0x00,0x00};
    const char chineseTxtOutgoingCalls1[]= {0x80,0x62,0xE8,0x5C,0x80,0x00,0x00};
    const char EngTxtLastCall1[]= {"Last"}; 
    const char EngTxtIncomingCalls1[]= {"Received"};
    const char EngTxtOutgoingCalls1[]= {"Dialled"};
    const char chineseTxtCost1[]= { 0x80,0x8d,0x39,0x75,0x28,0x00,0x00};
    const char chineseTxtLastCharge1[]= {0x80,0x4e,0x0a,0x6b,0x21,0x00,0x00};
    const char chineseTxtTotalCharge1[]= {0x80,0x7d,0x2f,0x8b,0xa1,0x00,0x00};
    const char EngTxtCost1[]= {"Cost"}; 
    const char EngTxtLastCharge1[]= {"Last"};
    const char EngTxtTotalCharge1[]= {"Total"};

    MMI_TRACE_EVENT(("<<<talcon,ShowCalltimerstatistics-->TextString1-3:%0xp,%0xp,%0xp",data->TextString,data->TextString2,data->TextString3));
    MMI_TRACE_EVENT(("<<<talcon,ShowCalltimerstatistics-->TextString1-3:%s,%s,%s",data->TextString,data->TextString2,data->TextString3));
    dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
    if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
    {
        if( serviceID==MMI_TIMER_STATISTICS )
        {
            /* 2004/04/22 sunsj modify */
            displayTitle( 0, (char *)MmiRsrcGetText(TxtCallDuration), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
            dspl_colorTextOut(1, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)chineseTxtLastCall1,0x000000 );
            drawSolidRectangle(46,DIALOG_FIRST_LINE+3,113,DIALOG_SECOND_LINE,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString,0x000000 );

            dspl_colorTextOut(1, DIALOG_SECOND_LINE+3,DSPL_TXTATTR_TRANSPARENT, (char *)chineseTxtIncomingCalls1,0x000000 );
            drawSolidRectangle(46,DIALOG_SECOND_LINE+4,113,DIALOG_THIRD_LINE+2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_SECOND_LINE+3,DSPL_TXTATTR_TRANSPARENT, data->TextString2,0x000000 );

            dspl_colorTextOut(1, DIALOG_THIRD_LINE+4,DSPL_TXTATTR_TRANSPARENT, (char *)chineseTxtOutgoingCalls1,0x000000 );
            drawSolidRectangle(46,DIALOG_THIRD_LINE+6,113,DIALOG_FOURTH_LINE+2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_THIRD_LINE+4,DSPL_TXTATTR_TRANSPARENT, data->TextString3,0x000000 );
        }
        else if( serviceID==SERVICES_AOC_STATISTICS )
        {
            /* 2004/04/22 sunsj modify */
            displayTitle( 0, (char *)MmiRsrcGetText(TxtAocStatistics), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
            dspl_colorTextOut(1, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)chineseTxtCost1,0x000000 );
            drawSolidRectangle(46,DIALOG_FIRST_LINE+3,98,DIALOG_SECOND_LINE,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString,0x000000 );

            dspl_colorTextOut(1, DIALOG_SECOND_LINE+3,DSPL_TXTATTR_TRANSPARENT, (char *)chineseTxtLastCharge1,0x000000 );
            drawSolidRectangle(46,DIALOG_SECOND_LINE+4,98,DIALOG_THIRD_LINE+2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_SECOND_LINE+3,DSPL_TXTATTR_TRANSPARENT, data->TextString2,0x000000 );

            dspl_colorTextOut(1, DIALOG_THIRD_LINE+4,DSPL_TXTATTR_TRANSPARENT, (char *)chineseTxtTotalCharge1,0x000000 );
            drawSolidRectangle(46,DIALOG_THIRD_LINE+6,98,DIALOG_FOURTH_LINE+2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_THIRD_LINE+4,DSPL_TXTATTR_TRANSPARENT, data->TextString3,0x000000 );
        }
    }
    else
    {
        if( serviceID==MMI_TIMER_STATISTICS )
        {
            /* 2004/04/22 sunsj modify */
            displayTitle( 0, (char *)MmiRsrcGetText(TxtCallDuration), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
            dspl_colorTextOut(1, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)EngTxtLastCall1,0x000000 );
            drawSolidRectangle(46,DIALOG_FIRST_LINE+2,98,DIALOG_SECOND_LINE-2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString,0x000000 );

            dspl_colorTextOut(1, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)EngTxtIncomingCalls1,0x000000 );
            drawSolidRectangle(46,DIALOG_SECOND_LINE+2,98,DIALOG_THIRD_LINE-2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString2,0x000000 );

            dspl_colorTextOut(1, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)EngTxtOutgoingCalls1,0x000000 );
            drawSolidRectangle(46,DIALOG_THIRD_LINE+2,98,DIALOG_FOURTH_LINE-2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString3,0x000000 );
        }
        else if( serviceID==SERVICES_AOC_STATISTICS )
        {
            /* 2004/04/22 sunsj modify */
            displayTitle( 0, (char *)MmiRsrcGetText(TxtAocStatistics), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
            dspl_colorTextOut(1, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)EngTxtCost1,0x000000 );
            drawSolidRectangle(46,DIALOG_FIRST_LINE+2,98,DIALOG_SECOND_LINE-2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString,0x000000 );

            dspl_colorTextOut(1, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)EngTxtLastCharge1,0x000000 );
            drawSolidRectangle(46,DIALOG_SECOND_LINE+2,98,DIALOG_THIRD_LINE-2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString2,0x000000 );

            dspl_colorTextOut(1, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char *)EngTxtTotalCharge1,0x000000 );
            drawSolidRectangle(46,DIALOG_THIRD_LINE+2,98,DIALOG_FOURTH_LINE-2,3,0x5AC7FF,0x5AC7FF);
            dspl_colorTextOut(47, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, data->TextString3,0x000000 );
        }
    }
#endif
}
/*******************************************************************************



 $Function:    	ShowVMMemory

 $Description:	show voicememo''s memory state  
            
 $Returns:		

 $Arguments:	
*******************************************************************************/
void ShowVMMemory(int TXTId1,int TXTId2)
{
    char buffer[MAX_LINE_CHAR+1];

    dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
    /* 2004/04/22 sunsj modify */
    displayTitle( 0, (char *)MmiRsrcGetText(TxtMemoryState), NULL, TITLE_MIDDLE, 0x000000, 0x000000);
    /*dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
        menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
        menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);    

    if(Mmi_getCurrentLanguage()==CHINESE_LANGUAGE)
    {
        dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtMemoryState),0xffffff );
    }
    else
    {
        dspl_colorTextOut(23, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtMemoryState),0xffffff );
    }*/  

    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE+2,DSPL_TXTATTR_TRANSPARENT,TxtVoiceMemory);



    dspl_colorTextOut(1, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)GET_TEXT(TxtPhbkUse),0x000000 );
    drawSolidRectangle(70,DIALOG_SECOND_LINE+2,100,DIALOG_THIRD_LINE-2,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId1);
    dspl_colorTextOut(72, DIALOG_SECOND_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)buffer,0x000000 );


    dspl_colorTextOut(1, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT, (char*)GET_TEXT(TxtTotalCount),0x000000 );
    drawSolidRectangle(70,DIALOG_THIRD_LINE+2,100,DIALOG_FOURTH_LINE-2,3,0x5AC7FF,0x5AC7FF);
    sprintf(buffer,"%d",TXTId2);
    dspl_colorTextOut(72, DIALOG_THIRD_LINE+2,DSPL_TXTATTR_TRANSPARENT,(char*)buffer,0x000000 );    

}

/*******************************************************************************

 $Function:    	dialog_info_win_cb

 $Description:	Callback function for information dialog
 
 $Returns:		void

 $Arguments:	window handle event, win
*******************************************************************************/
//GW-SPR#762-Added code to wraps txtString2 if there is room on the display to allow 
//very long numbers to be displayed.
static int dialog_info_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_dialog_info * data = (T_dialog_info *)win->user;
    char buffer[MAX_LINE_CHAR+1];
    int yPos,bufPos,nLines;
    int xpos=0;//zy 11/04
    UBYTE mode;
    // MfwIcn *icn;//zy 11/04
    int callxpos;
    int old_color;
    //	game_Rectangle param;
    //	TRACE_EVENT("dialog_info_win_cb()");

    if( data EQ 0 )
        return 1;

    /*	param.x1=0;
        param.y1=0;
        param.x2=SCREEN_SIZE_X;
        param.y2=SCREEN_SIZE_Y;
        param.fillcolor=0x5AC7FF;
        param.color=0x5AC7FF;*/

    mode=dspl_Enable(0);
    MMI_TRACE_EVENT(("<<<talcon,dialog_info_win_cb--mode:%d",mode));

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /* Print the information dialog */
            /* Clear Screen */

            if( data->Identifier ==MMI_PHONEBOOK_MEMORYSTATE )
            {
                ShowSmsPbkMemory(SIMTotal,(int)data->TextId,(int)data->TextId2,
                                 ALL_NVM_LIST,(USHORT)TxtSIMBook,(USHORT)TxtNVMBook);
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier ==MMI_VOICEMEMO_MEMROYSTATE )
            {
                ShowVMMemory((int)data->TextId,VM_file);
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier ==MMI_TIMER_STATISTICS ) /* 2003/10/22, wangyan, modify call time statistics menu*/
            {
                ShowCalltimerstatistics(data,MMI_TIMER_STATISTICS);
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier ==SERVICES_AOC_STATISTICS ) /* 2003/10/28, wangyan, modify AOC statistics menu*/
            {
                ShowCalltimerstatistics(data,SERVICES_AOC_STATISTICS);
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier ==MMI_MESSAGE_MEMORYSTATE )
            {
                ShowSmsPbkMemory((int)memory.used,(int)memory.total,(int)FlashSMStotal,
                                 FLSAH_SMS_NUM,(USHORT)TxtSIMSms,(USHORT)TxtNVMMsg);
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey); // display ID softkeys
                dspl_Enable(mode);/*2004/04/06,talcon add */
                return 1;
            }
            else if( data->Identifier ==StartAnimNoSimcard )
            {
                draw_special_background();
#if ( MAIN_LCD_SIZE==4 )//jhxu720
                DRAW_ICON_SEL(ICON_POPCALLICON, 0);
                DRAW_ICON_SEL(ICON_POPCALLICON, 1);
#endif
                if( (data->TextId2 NEQ 0)&&(data->TextId2!='\0') )
                {
#if ( MAIN_LCD_SIZE==4 )//jhxu720
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);    
#elif(MAIN_LCD_SIZE==3)
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
#endif
                    
                }
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier ==SMSSEND_ID_SENT )
            {
                draw_special_background();
                if( (data->TextId2 NEQ 0)&&(data->TextId2!='\0') )
                {
#if ( MAIN_LCD_SIZE==4 )//jhxu720
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);    
#elif(MAIN_LCD_SIZE==3)
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
#endif                
				}
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier == MMI_CALLFORWARD_DIALOG_NORMAL )
            {
                draw_special_background();

                if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
#if ( MAIN_LCD_SIZE==4 )//jhxu720
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId);
#elif(MAIN_LCD_SIZE==3)
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId);
#endif                
				}
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier == MMI_CALL_ACTIVE )
            {
                draw_special_background();

                if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
#if ( MAIN_LCD_SIZE==4 )//jhxu720
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId);    
#elif(MAIN_LCD_SIZE==3)
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId);
#endif
                }
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey); 
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier == MMI_SHOWCALLICON_DIALOG )
            {
                draw_special_background();
#if(MAIN_LCD_SIZE==4)
                if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
                    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId);
                }
                if( data->TextString2&&(data->TextString2!='\0') )
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
#elif(MAIN_LCD_SIZE==3)
				if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
                    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId);
                }
                if( data->TextString2&&(data->TextString2!='\0') )
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
#endif
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier == MMI_INCOMING_CALL_DIALOG_NORMAL
                     ||data->Identifier == MMI_OUTGOING_CALL_DIALOG_SAT
                     ||data->Identifier == MMI_OUTGOING_CALL_DIALOG_NORMAL
                     ||data->Identifier == MMI_OUTGOING_CALL_SAT_RINGOFF
                     ||data->Identifier ==MMI_OUTGOING_CALL_DIALOG_RINGOFF/*2003/11/11, wangyan, modify call outgoing anim*/
                     ||data->Identifier ==MMI_OUTGOING_REDIAL )/*2004/4/27, wangyan modify */
            {
                draw_special_background();/*2003/12/15, wangyan modify*/

                if( data->Identifier == MMI_INCOMING_CALL_DIALOG_NORMAL )
                {
                    mmi_dialogs_insert_fixmov_animation(data->info_win, 400,CALLINCOMINGANIM);
                }
                if( data->Identifier == MMI_OUTGOING_CALL_DIALOG_SAT
                    ||data->Identifier == MMI_OUTGOING_CALL_DIALOG_NORMAL
                    ||data->Identifier == MMI_OUTGOING_CALL_SAT_RINGOFF
                    ||data->Identifier ==MMI_OUTGOING_CALL_DIALOG_RINGOFF/*2003/11/11, wangyan, modify call outgoing anim*/
                    ||data->Identifier ==MMI_OUTGOING_REDIAL )/*2004/4/27, wangyan modify */
                {
                    mmi_dialogs_insert_fixmov_animation(data->info_win, 400,CALLOUTGOINGANIM);
                }

                /*					if (idleIsFocussed())
                                        icnShow(data->icon);*/
                /*					if (data->SoftKeyStrings)
                                    {
                                        displayCustSoftKeys(data->LSKString, data->RSKString);// SH - display text softkeys
                                    }
                                    else*/

                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey); /*2003/12/9, wangyan modify*/

                if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
#if(MAIN_LCD_SIZE==3)//jhxu720
					ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId);//jhxu720
#elif(MAIN_LCD_SIZE==4)					
                    ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId);//jhxu720
#endif
                }
                if( (data->TextId2 NEQ 0)&&(data->TextId2!='\0') )
                    if( (data->Identifier == MMI_OUTGOING_CALL_DIALOG_NORMAL)
                        ||(data->Identifier == MMI_OUTGOING_CALL_DIALOG_RINGOFF)
                        ||(data->Identifier ==MMI_OUTGOING_CALL_DIALOG_SAT)
                        ||(data->Identifier ==MMI_OUTGOING_CALL_SAT_RINGOFF)
                        ||(data->Identifier ==MMI_OUTGOING_REDIAL) )/*2004/4/27, wangyan modify */
                    {
#if(MAIN_LCD_SIZE==3)//jhxu720
						ALIGNED_PROMPT(CENTER, DIALOG_SECOND_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId2);//jhxu720
#elif(MAIN_LCD_SIZE==4)						
                        ALIGNED_PROMPT(CENTER, DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);//jhxu720
#endif                   //						drawcolorclarity(0,140,MmiRsrcGetText(data->TextId2), 0x000000);
                    }
                if( (data->TextString2 NEQ NULL)&&(data->TextString2!='\0') )
                {
                    if( (data->Identifier == MMI_OUTGOING_CALL_DIALOG_NORMAL)
                        ||(data->Identifier == MMI_OUTGOING_CALL_DIALOG_RINGOFF)
                        ||(data->Identifier ==MMI_OUTGOING_CALL_DIALOG_SAT)
                        ||(data->Identifier ==MMI_OUTGOING_CALL_SAT_RINGOFF)
                        ||(data->Identifier ==MMI_OUTGOING_REDIAL)/*2004/4/27, wangyan modify */
                        ||(data->Identifier == MMI_INCOMING_CALL_DIALOG_NORMAL) )
                    {
                        /*							callxpos=(SCREEN_SIZE_X-get_StringWidth((char *) data->TextString2))/2;
                                                    if(callxpos<0)
                                                        callxpos=0;	
                                                    drawcolorclarity(callxpos,DIALOG_SECOND_LINE,data->TextString2, 0x000000);*/
#if(MAIN_LCD_SIZE==3)//jhxu720						
						displayAlignedText(CENTER, DIALOG_SECOND_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextString2);//jhxu720
#elif(MAIN_LCD_SIZE==4)	
                        displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);//jhxu720
#endif
                    }
                }

                /*					if(data->animation_timer )
                                    {
                                        DrawAnimFixMovBit(data->animareason, 0);
                                        DrawAnimFixMovBit(data->animareason, 1);
                                        timStart(data->animation_timer);
                                    }*//*2003/12/9, wangyan modify*/

                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier==RECTCALLDETAIL )
            {
                /*					dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
                                    DrawRectagle(param); 
                                    dspl_TextOut(1,16,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId));
                                    dspl_TextOut(1,32,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString);
                
                                    if(data->iconIndex==100)
                                    {
                                        dspl_BitBlt( 45 , 55, BookGroupingIcon[15].area.sx,
                                            BookGroupingIcon[15].area.sy, BookGroupingIcon[15].nIcons,BookGroupingIcon[15].icons,0); 
                                    }
                                    
                                    if(data->TextId2!=0)
                                    {
                                        dspl_TextOut(1,55,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2));
                                        dspl_TextOut(1,71,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString2);
                                    }
                
                                    dspl_TextOut(1,94,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId3));
                                    dspl_TextOut(1,110,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString3);
                                    displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);	// display ID softkeys*/

                draw_dialog_current_page(data, 1);
                /*					draw_special_background();
                                    dspl_TextOut(1,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId));
                                    dspl_TextOut(1,13,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString);
                
                                    if(data->iconIndex==100)
                                    {
                                        dspl_BitBlt( 45 , 26, BookGroupingIcon[15].area.sx,
                                            BookGroupingIcon[15].area.sy, BookGroupingIcon[15].nIcons,BookGroupingIcon[15].icons,0); 
                                    }
                                    
                                    if(data->TextId2!=0)
                                    {
                                        dspl_TextOut(1,26,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2));
                                        dspl_TextOut(1,39,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString2);
                                    }
                
                                    dspl_TextOut(1,52,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId3));
                                    dspl_TextOut(30,52,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString3);
                                    displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);	*/
                dspl_Enable(mode);
                return 1;
            }
            else if( data->Identifier == SMS_SENDING_MSG )
            {
                draw_special_background();

                if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
#if(MAIN_LCD_SIZE==3)//ڷ											
					ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId);
#elif(MAIN_LCD_SIZE==4)
                    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId);//jhxu720
#endif
                }
                if( (data->TextString2 NEQ NULL)&&(data->TextString2!='\0') )
#if(MAIN_LCD_SIZE==3)//jhxu720	
					displayAlignedText(CENTER, DIALOG_SECOND_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
#elif(MAIN_LCD_SIZE==4)				
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);//jhxu720
#endif
                displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
                dspl_Enable(mode);
                return 1;   

            }
            else if( data->Identifier == IDENTIFIER_CLOCK )
            {
                draw_special_background();
                //					dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);/*2003/11/20, wangyan modify*/
                //					DrawRectagle(param); /*2003/12/3,  wangyan modify*/

                if( idleIsFocussed() )
                    icnShow(data->icon);//zy avoid show icons in not idle win
                if( data->SoftKeyStrings )
                {
                    displayCustSoftKeys(data->LSKString, data->RSKString);// SH - display text softkeys
                }
                else
                {
                    displaySoftKeys(data->LeftSoftKey, data->RightSoftKey); // display ID softkeys
                }

                if( (data->TextId NEQ 0)&&(data->TextId!='\0') )
                {
#if(MAIN_LCD_SIZE==3)//jhxu720			
					ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextId);          
#else					
                    ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId);//jhxu720
#endif
                }

                if( (data->TextString2 NEQ NULL)&&(data->TextString2!='\0') )
                {
#if(MAIN_LCD_SIZE==3)//jhxu720	
					displayAlignedText(CENTER, DIALOG_SECOND_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
#else					
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);//jhxu720
#endif
                }
                if( data->animation_timer )
                {
                    DrawAnimFixMovBit(data->animareason, 0);
                    DrawAnimFixMovBit(data->animareason, 1);
                    timStart(data->animation_timer);
                }/* 2003/12/1, wangyan modify */
                dspl_Enable(mode);
                return 1;
            }
            else if( ((data->Identifier != MMI_INCOMING_CALL_DIALOG_NORMAL)&&
                      (data->Identifier != MMI_OUTGOING_CALL_DIALOG_NORMAL)&&
                      (data->Identifier != MMI_OUTGOING_CALL_DIALOG_RINGOFF)&&
                      (data->Identifier != MMI_OUTGOING_CALL_SAT_RINGOFF)&&//zy add 2003-04-16
                      (data->Identifier != MMI_CALLFORWARD_DIALOG_NORMAL)&&
                      (data->Identifier != MMI_OUTGOING_CALL_DIALOG_SAT)&&
                      (data->Identifier != MMI_OUTGOING_REDIAL)&&/*2004/4/27, wangyan modify */
                      (data->Identifier != SMS_SENDING_MSG)&&
                      (data->Identifier != IDENTIFIER_CLOCK)&&
                      (data->Identifier != StartAnimNoSimcard)&&
                      (data->Identifier != StartAnimDialog)&&
                      (data->Identifier != MMI_SHOWCALLICON_DIALOG))&&
                     (data->Identifier <DictDummy)&&
                     (((data->Identifier < PinsDummy)&&(data->Identifier >TimeDateDummy ))
                      ||((data->Identifier < HostkeyDummy)||(data->Identifier > SatDummy)))
                     &&((data->iconIndex<REMIND_START)||(data->iconIndex>REMIND_END)) )
            {
                //dspl_Clear(0, 112, 16, 128);
                dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
                draw_special_background();
#if(MAIN_LCD_SIZE==4)
                if( data->TextId&&(data->TextId!='\0') )
                    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId);
                if( data->TextString&&(data->TextString!='\0') )
                    displayAlignedText(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT,data->TextString);
                if( data->TextId2&&(data->TextId2!='\0') )
                    ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                if( data->TextString2&&(data->TextString2!='\0') )
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                xpos=0;
#elif (MAIN_LCD_SIZE==3)
				if( data->TextId&&(data->TextId!='\0') )
                    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextId);
                if( data->TextString&&(data->TextString!='\0') )
                    displayAlignedText(CENTER, DIALOG_FIRST_LINE-19, DSPL_TXTATTR_TRANSPARENT,data->TextString);
                if( data->TextId2&&(data->TextId2!='\0') )
                    ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE-19,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                if( data->TextString2&&(data->TextString2!='\0') )
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE-19, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                xpos=0;
#endif
            }


            if( data->animation_timer )
            {
                DrawAnimFixMovBit(data->animareason, 0);
                DrawAnimFixMovBit(data->animareason, 1);
                timStart(data->animation_timer);
            }

            if( (data->iconIndex>=85)&&(data->iconIndex<=100) )
            {

                // dspl_BitBlt(0,112, 16, 16, 0, (void *)newSMS, 0);
                /* 2004/06 sunsj modify for picture manage */
                DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_GROUP, 0, 32, data->iconIndex-85, ICON_LOCATION);
                //dspl_BitBlt( 0,32, BookGroupingIcon[data->iconIndex-85].area.sx,BookGroupingIcon[data->iconIndex-85].area.sy,
                //             BookGroupingIcon[data->iconIndex-85].nIcons,BookGroupingIcon[data->iconIndex-85].icons,0);
                Force_refresh();
                xpos=16;
            }
            else if( (data->iconIndex>REMIND_START)&&(data->iconIndex<REMIND_END) )
            {
                /* if((data->iconIndex<REMIND_DELETING)&&(data->iconIndex!=REMIND_WAITTING))
                    dspl_BitBlt( (120-REMINDS[data->iconIndex-110].area.sx)/2,(160-REMINDS[data->iconIndex-110].area.sy)/2-10,
                        REMINDS[data->iconIndex-110].area.sx,REMINDS[data->iconIndex-110].area.sy,
                        REMINDS[data->iconIndex-110].nIcons,REMINDS[data->iconIndex-110].icons,0);
                else*/
                remind_animal(data->info_win,data->iconIndex);                
                // Force_refresh();
            }

            /* Print softkeys */
            if( idleIsFocussed() )
                icnShow(data->icon);//zy avoid show icons in not idle win
            if( data->SoftKeyStrings )
            {
                displayCustSoftKeys(data->LSKString, data->RSKString);// SH - display text softkeys
            }
            else
            {
                /* 2004/05/28 sunsj modify */
                if( data->LeftSoftKey != TxtNull || data->RightSoftKey != TxtNull )
                {
                    displaySoftKeys(data->LeftSoftKey, data->RightSoftKey); // display ID softkeys
                }
            }
        }
        break;
        /* end of zy changed for dialog and with icons,big or small */
    default:
        dspl_Enable(mode);
        return 0;
    }
    dspl_Enable(mode);
    return 1;
}


/*******************************************************************************

 $Function:    	dialog_info_tim_cb

 $Description:	Callback function for the dialog info timer.

 
 $Returns:		MFW event handler

 $Arguments:	window handle event, timer control block

*******************************************************************************/
static T_MFW_CB dialog_info_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_info * data = (T_dialog_info *)win_data->user;

    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->Identifier;
    void (* Callback)() = data->Callback;

    if( (Identifier==MMI_INCOMING_CALL_DIALOG_NORMAL)&&((!IsHandsetPlugin())&&(!HallOnOff())) )//zy 2003-05-08 if nohandsetplugin and halloff dont accept call now
    {
        return 0;
    }

    if( data->animation_timer )
        timStop(data->animation_timer);
    dialog_info_destroy (win);
    if( Callback )
        (Callback) (parent_win, Identifier, INFO_TIMEOUT);
    if( Identifier == IDENTIFIER_CLOCK )  //xsf add for alarm 2002.09.23
        Stopplayingdevice();
    return 0;
}


/*******************************************************************************

 $Function:    	dialog_info_kbd_cb

 $Description:	Keyboard event handler

 $Returns:		status int

 $Arguments:	window handle event, keyboard control block

*******************************************************************************/

static int dialog_info_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_info * data = (T_dialog_info *)win_data->user;
    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->Identifier;
    void (* Callback)() = data->Callback;

    MMI_TRACE_EVENT(("wangyan dialog_info_kbd_cb"));
#if 0
    /*zy move 2003-02-11 StartAnimDialog needn't kbd action 
    when start must have time to initialize some actions*/
    if( data->Identifier==StartAnimDialog&&keyboard->code!=KCD_POWER )
    {
        Identifier = keyboard->code;
        dialog_info_destroy (win);
        if( Callback )
            (Callback) (parent_win, Identifier, INFO_KCD_ALL);
        return MFW_EVENT_CONSUMED;
    }
#endif
    /* 2004/04/13 sunsj modify */
    //if((data->Identifier==StartAnimNoSimcard) && (keyboard->code<=KCD_STAR ||keyboard->code==KCD_HUP 
    //	|| keyboard->code==KCD_ABC))   //xsf add for no simcard animation 2002.12.03 
    if( (data->Identifier==StartAnimNoSimcard) && (keyboard->code<=KCD_STAR || keyboard->code==KCD_HUP || keyboard->code==KCD_ABC) )   //xsf add for no simcard animation 2002.12.03 
    {
        Identifier = keyboard->code;
        //if(keyboard->code!=KCD_HUP)
        dialog_info_destroy (win);
        tim_NoSimClock=0;
        if( Callback )
            (Callback) (parent_win, Identifier, INFO_KCD_ALL);
        return MFW_EVENT_CONSUMED;
    }
    if( (data->Identifier==MMI_INCOMING_CALL_DIALOG_NORMAL) && (keyboard->code==KCD_F3 || keyboard->code==KCD_VOLUP) )
    {
        /*2004/5/17, wangyan add*/
        return MFW_EVENT_CONSUMED;
    }
    switch( keyboard->code )
    {
    case KCD_LEFT:
        //INFO_KCD_ALL is for anykey answer
        //		if (data->KeyEvents & KEY_LEFT )//zy 09/04
        if( data->KeyEvents & KEY_LEFT ||  (data->KeyEvents == KEY_ALL) )
        {
            dialog_info_destroy (win);
            if( Identifier == IDENTIFIER_CLOCK )   //xsf add for stop alarm melody/vibrator 09.20
                Stopplayingdevice();
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_LEFT);
            //2004-04-01 Sunny add to close the window of low voltage remind.
            setOuterState(OUTERIDLESTATE_LOWVOLTAGE, 0,0);
        }
        break;

    case KCD_RIGHT:
        //INFO_KCD_ALL is for anykey answer
        //		if (data->KeyEvents & KEY_RIGHT)//zy 09/04		
        if( data->KeyEvents & KEY_RIGHT  ||  (data->KeyEvents == KEY_ALL) )
        {
            dialog_info_destroy (win);
            if( Identifier == IDENTIFIER_CLOCK ) //xsf add for stop alarm melody/vibrator 09.20
                Stopplayingdevice();
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_RIGHT);
            //2004-04-01 Sunny add to close the window of low voltage remind.
            setOuterState(OUTERIDLESTATE_LOWVOLTAGE, 0,0);
        }
        break;

    case KCD_HUP:
        //INFO_KCD_ALL is for anykey answer
        if( data->KeyEvents & KEY_HUP  ||  (data->KeyEvents == KEY_ALL) )//zy 09/04
        {
            dialog_info_destroy (win);
            if( Identifier == IDENTIFIER_CLOCK ) //xsf add for stop alarm melody/vibrator 09.20
                Stopplayingdevice();
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_HUP);
            //2004-04-01 Sunny add to close the window of low voltage remind.
            setOuterState(OUTERIDLESTATE_LOWVOLTAGE, 0,0);
        }
        break;

    case KCD_MNUUP:
        if( data->KeyEvents & KEY_MNUUP|| (data->KeyEvents == KEY_ALL) )
        {
            //  dialog_info_destroy (win);//MZ ??
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_UP);
        }
        if( data->Identifier==RECTCALLDETAIL )
        {
            currentpage--;
            if( currentpage<firstpage ) currentpage=totalpage;
            draw_dialog_current_page(data, currentpage);
        }
        break;

    case KCD_MNUDOWN:
        if( data->KeyEvents & KEY_MNUDOWN|| (data->KeyEvents == KEY_ALL) )
        {
            //	dialog_info_destroy (win);//MZ ??
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_DOWN);
        }
        if( data->Identifier==RECTCALLDETAIL )
        {
            currentpage++;
            if( currentpage>totalpage ) currentpage=firstpage;
            draw_dialog_current_page(data, currentpage);
        }
        break;

        //MZ 7/3/01 used to start a call.
    case KCD_CALL:
        //INFO_KCD_ALL is for anykey answer
        //	if (data->KeyEvents & KEY_CALL ) 		
        if( data->KeyEvents & KEY_CALL  || (data->KeyEvents == KEY_ALL) )
        {
            dialog_info_destroy (win);
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_OFFHOOK);
        }
        //2004-04-01 Sunny add to close the window of low voltage remind.
        setOuterState(OUTERIDLESTATE_LOWVOLTAGE, 0,0);
        break;

    case KCD_F4:
        if( data->KeyEvents & KEY_F4  || (data->KeyEvents == KEY_ALL) )
        {
            if( Identifier== MMI_OUTGOING_CALL_DIALOG_NORMAL||Identifier== MMI_OUTGOING_CALL_DIALOG_SAT
                ||Identifier== MMI_OUTGOING_CALL_DIALOG_RINGOFF 
                ||Identifier==MMI_SHOWCALLICON_DIALOG||Identifier ==MMI_OUTGOING_CALL_SAT_RINGOFF
                ||Identifier == MMI_PHONEBOOK_MEMORYSTATE /* 2004/04/10 sunsj modify */
                ||Identifier==MMI_OUTGOING_REDIAL )  /* 2004/04/27 wangyan modify */
            {
                dialog_info_destroy (win);
                if( Callback )
                    (Callback) (parent_win, Identifier, INFO_KCD_F4);
            }
            if( Identifier==MMI_INCOMING_CALL_DIALOG_NORMAL )
            {
                //if(FlashSettingData.hallonconnect||drvpara.hallstatusflag==0||FlashDCTbData.AutoAnswerFlag)//zy 2003-05-08 if autoanswer f4 hallon accept incomingcall
                if( (!IsHandsetPlugin())&&(FlashSettingData.hallonconnect||drvpara.hallstatusflag==0||FlashDCTbData.AutoAnswerFlag) )/*2004/5/24, wy modify*/
                {
                    dialog_info_destroy (win);
                    if( Callback )
                        (Callback) (parent_win, Identifier, INFO_KCD_F4);
                }
            }
        }
        break;

    case KCD_ABC:///zym modified for charging
        if( data->KeyEvents & KCD_ABC ||  (data->KeyEvents == KEY_ALL) )
        {
            //glowing,2004-04-09, disable to process KCD_ABC in the following condition
            if( Identifier== MMI_OUTGOING_CALL_DIALOG_NORMAL||Identifier== MMI_OUTGOING_CALL_DIALOG_SAT
                ||Identifier== MMI_OUTGOING_CALL_DIALOG_RINGOFF 
                ||Identifier==MMI_SHOWCALLICON_DIALOG||Identifier ==MMI_OUTGOING_CALL_SAT_RINGOFF
                || Identifier==MMI_INCOMING_CALL_DIALOG_NORMAL )
            {
                break;
            }

            dialog_info_destroy (win);          
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_ABC);
            //2004-04-01 Sunny add to close the window of low voltage remind.
            setOuterState(OUTERIDLESTATE_LOWVOLTAGE, 0,0);
        }
        break;

    default:
        if( data->KeyEvents == KEY_ALL|| (Identifier==MMI_INCOMING_CALL_DIALOG_NORMAL && FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag) )/*2004/4/13, wangyan modify*/
        {
            /* Note: The variable Identifier is overwritten with the keycode of the dialog;
            we need it only for the Multicall Control !!*/
            Identifier = keyboard->code;
            dialog_info_destroy (win);
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_ALL);
        }
        break;
    }
    return MFW_EVENT_CONSUMED;
}


static int dialog_info_kbd_long_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard){
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	mmi_dialog_information_screen

 $Description:	

 $Returns:		

 $Arguments:	

*******************************************************************************/
/*2003/12/15, wangyan modify*/
T_MFW_HND mmi_dialog_information_screen(T_MFW_HND parent_win,USHORT TxtId2,USHORT TextId, T_VOID_FUNC call_back, USHORT identifier)
{
    T_DISPLAY_DATA display_info;
    T_MFW_HND dialog_win;
    display_info.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
    display_info.TextId2       = TxtId2;
    display_info.TextId      = TextId;
    display_info.TextString   = NULL;
    display_info.TextString2   =NULL;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.Time         = ONE_SECS;
    display_info.Identifier   = identifier;
    display_info.Callback     = (T_VOID_FUNC)call_back;

    switch( display_info.Identifier )
    {
    case SMSSEND_ID_SC_NOT_READY:
    case SMSSEND_ID_SAVE_NOT_READY:
        display_info.iconindex =REMIND_WAITTING;
        break;

    case SMSSEND_ID_NBEDIT:
    case SMSSEND_ID_CM_SAVE_READY:
    case SMSSEND_ID_SAVED:
    case SMSMENU_ID_SAVEOK:
        display_info.iconindex =REMIND_SUCCEED;
        break;

    case SMSSEND_ID_SENT:
        display_info.Time         = TWO_SECS;
        dialog_win= info_dialog(parent_win,&display_info); 
        mmi_dialogs_insert_fixmov_animation(dialog_win, 500, SMSSENDINGSUCANIM);
        return dialog_win;

    case SMSSEND_ID_NOT_SAVED:
    case SMSSEND_ID_LIST_FULL:
    case SMSSEND_ID_NOT_SENT:
    case SMSSEND_ID_NOT_ALLOWED:
        display_info.iconindex =REMIND_NORECORD;
        break;
    default:
        break;
    } 

    return info_dialog(parent_win,&display_info); //information screen
}

#if 0 /*2003/12/15, wangyan modify*/
T_MFW_HND mmi_dialog_information_screen(T_MFW_HND parent_win,USHORT TxtId2,USHORT TextId, T_VOID_FUNC call_back, USHORT identifier)
{
    T_DISPLAY_DATA display_info;
    display_info.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
    display_info.TextId2       = TxtId2;
    display_info.TextId      = TextId;
    display_info.TextString   = NULL;
    display_info.TextString2   =NULL;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.Time         = ONE_SECS;
    display_info.Identifier   = identifier;
    display_info.Callback     = (T_VOID_FUNC)call_back;

    switch( display_info.Identifier )
    {
    case SMSSEND_ID_SC_NOT_READY:
    case SMSSEND_ID_SAVE_NOT_READY:
        display_info.iconindex =REMIND_WAITTING;
        break;

    case SMSSEND_ID_NBEDIT:
    case SMSSEND_ID_SENT:
    case SMSSEND_ID_CM_SAVE_READY:
    case SMSSEND_ID_SAVED:
    case SMSMENU_ID_SAVEOK:
        display_info.iconindex =REMIND_SUCCEED;
        break;

    case SMSSEND_ID_NOT_SAVED:
    case SMSSEND_ID_LIST_FULL:
    case SMSSEND_ID_NOT_SENT:
    case SMSSEND_ID_NOT_ALLOWED:
        display_info.iconindex =REMIND_NORECORD;
        break;
    default:
        break;
    } 

    return info_dialog(parent_win,&display_info); //information screen
}
#endif
#if 0
//溯case ˼
typedef enum
{
    /* Logical frames */
    0SEND_ID,
    1SAVE_ID,
    /* Extern windows */
    2PHBK_ID,
    /* Editor windows */
    3SMSSEND_ID_TEXTEDIT,
    4SMSSEND_ID_NBEDIT,
    5SMSSEND_ID_CENTREEDIT,
    6SMSSEND_ID_CENTREEDIT_CHANGE,
    /* Dialog windows */
    7SMSSEND_ID_WAITING,
    8SMSSEND_ID_WAIT_SEND,
    9SMSSEND_ID_SENT,
    10SMSSEND_ID_NOT_SENT,
    11SMSSEND_ID_WAIT_SAVE,
    12SMSSEND_ID_SAVED,
    13SMSSEND_ID_NOT_SAVED,
    14SMSSEND_ID_LIST_FULL,
    15SMSSEND_ID_SAVE_NOT_READY, //PATCH TB
    16SMSSEND_ID_SC_NOT_READY, //PATCH TB
    17SMSSEND_ID_CM_SAVE_READY,
    18SMSSEND_ID_NOT_ALLOWED
} sms_send_id;
#endif

/*******************************************************************************

 $Function:    	mmi_dialogs_insert_icon

 $Description:	Displays one icon in a dialog 

 $Returns:		none

 $Arguments:	win, pointer to an icon

*******************************************************************************/
void mmi_dialogs_insert_icon (T_MFW_HND win_dialog ,MfwIcnAttr *icon)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win_dialog)->data;
    T_dialog_info  * data         = (T_dialog_info *)win_data->user;

    data->icon = icnCreate(win_dialog,icon,E_ICN_VISIBLE,NULL);         
    icnUnhide(data->icon);
    winShow(win_dialog);
}

/*******************************************************************************

 $Function:    	mmi_dialogs_insert_animation

 $Description:	starts an animation in a dialog

 $Returns:		none

 $Arguments:	win, animation time, pointer to an icon, number of frames

*******************************************************************************/
void mmi_dialogs_insert_animation (T_MFW_HND win_dialog , S32 anim_time ,MfwIcnAttr *icon ,UBYTE number_of_frames)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win_dialog)->data;
    T_dialog_info  * data         = (T_dialog_info *)win_data->user;

    data->number_of_frames = number_of_frames;
    data->current_frame = 0;
    data->icon_array = icon;  
    data->current_icon = data->icon_array;
    data->icon = icnCreate(win_dialog,data->current_icon,E_ICN_VISIBLE,NULL);           
    icnUnhide(data->icon);
    data->animation_timer = timCreate(win_dialog,anim_time,(MfwCb)mmi_dialogs_insert_animation_CB);
    timStart(data->animation_timer);
    winShow(win_dialog);    
}

/*******************************************************************************

 $Function:    	mmi_dialogs_insert_animation_CB

 $Description:	destroys the current icon and starts the next icon

 $Returns:		none

 $Arguments:	timer event, timer control block

*******************************************************************************/
void mmi_dialogs_insert_animation_CB (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_info * data = (T_dialog_info *)win_data->user;

    icnDelete(data->icon);
    if( data->current_frame < (data->number_of_frames-1) )
    {
        data->current_frame++;
        data->current_icon++;               
    }
    else
    {
        data->current_frame = 0;
        data->current_icon = data->icon_array;
    }
    data->icon = icnCreate(win,data->current_icon,E_ICN_VISIBLE,NULL);          
    icnUnhide(data->icon);
    timStart(data->animation_timer);
    winShow(win);                   
}

/* 2004/06 sunsj modify for picture manage */
void DrawAnimFixMovBit(AnimationReason Reason,int animindex )
{ 
#if (MAIN_LCD_SIZE==3)//jhxu720
	switch( Reason)
	{
	case WELCOMEANIM:  
		DrawWelcomeAnim(Reason, animindex);
		break;	
	case GOODBYEANIM:
		DrawGoodbyeAnim(Reason, animindex);
		break;
		
	case CALLOUTGOINGANIM:
		DRAW_ICON_SEL(ICON_CALLOUTGOING, animindex);
		
		break;
	case CALLACTIVEANIM:
		DRAW_ICON_SEL(ICON_CALLACTIVE_ANI, animindex);
		
		break;
	case CALLREDIALANIM:
		DRAW_ICON_SEL(ICON_CALLREDIAL_ANI, animindex);
		break;
		/*		case CALLALERTANIM:
		dspl_BitBlt( CallAlert_Attr[animindex].area.px,CallAlert_Attr [animindex].area.py,
		CallAlert_Attr [animindex].area.sx,CallAlert_Attr [animindex].area.sy,
		CallAlert_Attr [animindex].nIcons,CallAlert_Attr [animindex].icons,0);
		break;
		case CALLFORWARDANIM:
		dspl_BitBlt( CallForward_Attr[animindex].area.px,CallForward_Attr [animindex].area.py,
		CallForward_Attr [animindex].area.sx,CallForward_Attr [animindex].area.sy,
		CallForward_Attr [animindex].nIcons,CallForward_Attr [animindex].icons,0);
		break;*/
	case CALLINCOMINGANIM:
		DRAW_ICON_SEL(ICON_CALLINCOMING, animindex);
		
		break;
		
		
	case NETWORKSEARCHINGANIM:	
		
		DRAW_ICON_SEL(ICON_NETWORKSEARCH, animindex);
		
		break;
	case SENDINGSMSANIM:	
		
		DRAW_ICON_SEL(ICON_SMSSENDING, animindex);
		break;
	case SMSSENDINGSUCANIM:
		
		DRAW_ICON_SEL(ICON_SMSSENDSUCCESS, animindex);
		break;
		/*		case WAITINGANIM:	
		dspl_BitBlt(  Waiting_Attr[animindex].area.px, Waiting_Attr[animindex].area.py,
		Waiting_Attr[animindex].area.sx, Waiting_Attr[animindex].area.sy,
		Waiting_Attr[animindex].nIcons, Waiting_Attr[animindex].icons,0);
		break;*/
	case NOSIMCARDANIM:	
		
		DRAW_ICON_SEL(ICON_NOSIMCARD, animindex);
		
		break;
		
	default:
		break; 
	} 
#elif ( MAIN_LCD_SIZE==4 )
    switch( Reason )
    {
    case CALLOUTGOINGANIM:
        DRAW_ICON_SEL(ICON_CALLOUTGOING, animindex);
        /*
        dspl_BitBlt( CallOutgoing_Attr[animindex].area.px,CallOutgoing_Attr [animindex].area.py,
                     CallOutgoing_Attr [animindex].area.sx,CallOutgoing_Attr [animindex].area.sy,
                     CallOutgoing_Attr [animindex].nIcons,CallOutgoing_Attr [animindex].icons,0);
        */
        break;
    case CALLACTIVEANIM:
        //DRAW_ICON_SEL(ICON_CALLINCALL, animindex);
        /*
        dspl_BitBlt( CallActive_Attr[animindex].area.px,CallActive_Attr [animindex].area.py,
                     CallActive_Attr [animindex].area.sx,CallActive_Attr [animindex].area.sy,
                     CallActive_Attr [animindex].nIcons,CallActive_Attr [animindex].icons,0);
        */
        break;
        /* 2004/06/01 sunsj remove */
        /*
    case CALLREDIALANIM:
        dspl_BitBlt( CallRedial_Attr[animindex].area.px,CallRedial_Attr [animindex].area.py,
                     CallRedial_Attr [animindex].area.sx,CallRedial_Attr [animindex].area.sy,
                     CallRedial_Attr [animindex].nIcons,CallRedial_Attr [animindex].icons,0);
        break;
        */
        /*		case CALLALERTANIM:
        dspl_BitBlt( CallAlert_Attr[animindex].area.px,CallAlert_Attr [animindex].area.py,
        CallAlert_Attr [animindex].area.sx,CallAlert_Attr [animindex].area.sy,
        CallAlert_Attr [animindex].nIcons,CallAlert_Attr [animindex].icons,0);
        break;
        case CALLFORWARDANIM:
        dspl_BitBlt( CallForward_Attr[animindex].area.px,CallForward_Attr [animindex].area.py,
        CallForward_Attr [animindex].area.sx,CallForward_Attr [animindex].area.sy,
        CallForward_Attr [animindex].nIcons,CallForward_Attr [animindex].icons,0);
        break;*/
    case CALLINCOMINGANIM:
        DRAW_ICON_SEL(ICON_CALLINCOMING, animindex);
        /*
        dspl_BitBlt(  callIncoming_Attr[animindex].area.px, callIncoming_Attr[animindex].area.py,
                      callIncoming_Attr[animindex].area.sx, callIncoming_Attr[animindex].area.sy,
                      callIncoming_Attr[animindex].nIcons, callIncoming_Attr[animindex].icons,0);
        */
        break;
    case WELCOMEANIM:  
        /*
        dspl_BitBlt( SwitchOn_Attr[animindex].area.px,SwitchOn_Attr [animindex].area.py,
            SwitchOn_Attr [animindex].area.sx,SwitchOn_Attr [animindex].area.sy,
            SwitchOn_Attr [animindex].nIcons,SwitchOn_Attr [animindex].icons,0);
        */
        DrawWelcomeAnim(Reason, animindex);
        break;  
    case GOODBYEANIM:
        /*
        dspl_BitBlt(  SwitchOff_Attr[animindex].area.px, SwitchOff_Attr[animindex].area.py,
            SwitchOff_Attr[animindex].area.sx, SwitchOff_Attr[animindex].area.sy,
            SwitchOff_Attr[animindex].nIcons, SwitchOff_Attr[animindex].icons,0);
        */
        DrawGoodbyeAnim(Reason, animindex);
        break;

    case NETWORKSEARCHINGANIM:  
        DRAW_ICON_SEL(ICON_NETWORKSEARCH, animindex);
        /*
        dspl_BitBlt( networksearching_Attr[animindex].area.px, networksearching_Attr[animindex].area.py,
                     networksearching_Attr[animindex].area.sx, networksearching_Attr[animindex].area.sy,
                     networksearching_Attr[animindex].nIcons, networksearching_Attr[animindex].icons,0);
        */
        break;
    case SENDINGSMSANIM:    
        DRAW_ICON_SEL(ICON_SMSSENDING, animindex);
        /*
        dspl_BitBlt(  SendingSms_Attr[animindex].area.px, SendingSms_Attr[animindex].area.py,
                      SendingSms_Attr[animindex].area.sx, SendingSms_Attr[animindex].area.sy,
                      SendingSms_Attr[animindex].nIcons, SendingSms_Attr[animindex].icons,0);
        */
        break;
    case SMSSENDINGSUCANIM:
        DRAW_ICON_SEL(ICON_SMSSENDSUCCESS, animindex);
        /*
        dspl_BitBlt(  SmsSendSuc_Attr[animindex].area.px, SmsSendSuc_Attr[animindex].area.py,
                      SmsSendSuc_Attr[animindex].area.sx, SmsSendSuc_Attr[animindex].area.sy,
                      SmsSendSuc_Attr[animindex].nIcons, SmsSendSuc_Attr[animindex].icons,0);             
        */
        break;
        /*		case WAITINGANIM:	
        dspl_BitBlt(  Waiting_Attr[animindex].area.px, Waiting_Attr[animindex].area.py,
        Waiting_Attr[animindex].area.sx, Waiting_Attr[animindex].area.sy,
        Waiting_Attr[animindex].nIcons, Waiting_Attr[animindex].icons,0);
        break;*/
    case CALLFAILANIM:  
        /*
        dspl_BitBlt(  CallFailure_Attr[animindex].area.px, CallFailure_Attr[animindex].area.py,
                      CallFailure_Attr[animindex].area.sx, CallFailure_Attr[animindex].area.sy,
                      CallFailure_Attr[animindex].nIcons, CallFailure_Attr[animindex].icons,0);
        */
        break;
    case CALLNOTCONNECTANIM:    
        /*
        dspl_BitBlt(  CallNotConnect_Attr[animindex].area.px, CallNotConnect_Attr[animindex].area.py,
                      CallNotConnect_Attr[animindex].area.sx, CallNotConnect_Attr[animindex].area.sy,
                      CallNotConnect_Attr[animindex].nIcons, CallNotConnect_Attr[animindex].icons,0);
        */
        break;
    case NOSIMCARDANIM: 
        DRAW_ICON_SEL(ICON_NOSIMCARD, animindex);
        /*
        dspl_BitBlt(  NoSim_Attr[animindex].area.px, NoSim_Attr[animindex].area.py,
                      NoSim_Attr[animindex].area.sx, NoSim_Attr[animindex].area.sy,
                      NoSim_Attr[animindex].nIcons, NoSim_Attr[animindex].icons,0);
        */
        break;

    default:
        break; 
    } 
#endif
}
/*******************************************************************************/

void mmi_dialogs_insert_FixMov_animation_CB (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_info * data = (T_dialog_info *)win_data->user;
    //	game_Rectangle param;

    TRACE_EVENT("mmi_dialogs_insert_FixMov_animation_CB");
    //  icnDelete(data->icon);
    if( data->animareason==NOSIMCARDANIM )
    {
        /*		param.x1=0;
                param.y1=0;
                param.x2=SCREEN_SIZE_X;
                param.y2=SCREEN_SIZE_Y;
                param.fillcolor=0x5AC7FF;
                param.color=0x5AC7FF;
                DrawRectagle(param); */

        //ALIGNED_PROMPT(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId2);
        /*if((tim_NoSimClock==0) ||(tim_NoSimClock==59) )
        {
            dspl_Clear(0,113,120,142);
            showCLOCK();  
            showDATE();
            SetChargingIcon( CurrentBatPicNum );
        }
        if(tim_NoSimClock<59)
            tim_NoSimClock++;
        else
            tim_NoSimClock=0;*/

    } /*2003/12/1, wangyan modify*/
    if( !winIsFocussed(data->info_win) )
    {
        timStop(data->animation_timer);
        return;
    }
    timStop(data->animation_timer);
    timStart(data->animation_timer);

    if( data->current_frame < (data->number_of_frames-1) )
    {
        data->current_frame++;
    }
    else
    {
        data->current_frame = 0;
    }
    DrawAnimFixMovBit(  data->animareason, data->current_frame);
}
/*******************************************************************************

 $Function:    	mmi_dialogs_insert_fixmov_animation

 $Description:	starts an animation in a dialog

 $Returns:		none

 $Arguments:	win, animation time, pointer to an icon, number of frames

 $History:    2004/06 sunsj modify for picture manage 

*******************************************************************************/
/*2003/12/4, wangyan modify*/
UBYTE Count_number_of_frames(AnimationReason Reason)
{   UBYTE number_of_frames=0;

    switch( Reason )
    {
    case CALLOUTGOINGANIM:
        number_of_frames = GET_ICONATTR_NUM(ICON_CALLOUTGOING);//sizeof(CallOutgoing_Attr)/sizeof(MfwIcnAttr);
        break;
    case CALLACTIVEANIM:
#if(MAIN_LCD_SIZE==3)
		number_of_frames=GET_ICONATTR_NUM(ICON_CALLACTIVE_ANI);
#endif
        break;
    case CALLREDIALANIM:
#if(MAIN_LCD_SIZE==3)
        number_of_frames=GET_ICONATTR_NUM(ICON_CALLREDIAL_ANI);
#endif
        break;
        /*		case CALLALERTANIM:
                    number_of_frames=sizeof(CallAlert_Attr)/sizeof(MfwIcnAttr);
                    break;
                case CALLFORWARDANIM:
                    number_of_frames=sizeof(CallForward_Attr)/sizeof(MfwIcnAttr);
                    break;*/
    case CALLINCOMINGANIM:
        number_of_frames = GET_ICONATTR_NUM(ICON_CALLINCOMING);//sizeof(callIncoming_Attr)/sizeof(MfwIcnAttr);
        break;  
    case WELCOMEANIM:
        /* 2004/05/13 sunsj modify */
        switch( FFS_flashData.onoffanimation )
        {
        case 0:
#if(MAIN_LCD_SIZE==4)
			number_of_frames = GET_ICONATTR_NUM(ICON_SWITCHON_DEFAULT);//sizeof(SwitchOn_Attr)/sizeof(MfwIcnAttr);
#endif
            break;
        case 1://Mobileinnovation			
            break;
        case 2://flower
#if (MAIN_LCD_SIZE==3)
            number_of_frames = GET_ICONATTR_NUM(ICON_SWITCHON);//sizeof(SwitchOn_Animination_Attr)/sizeof(MfwIcnAttr);
#elif _( MAIN_LCD_SIZE==4 )
            number_of_frames = GET_ICONATTR_NUM(ICON_SWITCHON);//sizeof(SwitchOn_Animination_Attr)/sizeof(MfwIcnAttr);

#elif ( MAIN_LCD_SIZE==2)
            number_of_frames=GET_ICONATTR_NUM(ICON_SWITCHON);;
#endif
            break;
        case 3://Skyrocket
            break;
        default:
            break;
        }
        break;
    case GOODBYEANIM:
        number_of_frames = GET_ICONATTR_NUM(ICON_SWITCHOFF);//sizeof(SwitchOff_Attr)/sizeof(MfwIcnAttr);
        break;
    case NETWORKSEARCHINGANIM:  
        number_of_frames = GET_ICONATTR_NUM(ICON_NETWORKSEARCH);//sizeof(networksearching_Attr)/sizeof(MfwIcnAttr);
        break;
    case SENDINGSMSANIM:    
        number_of_frames = GET_ICONATTR_NUM(ICON_SMSSENDING);//sizeof(SendingSms_Attr)/sizeof(MfwIcnAttr);
        break;
    case SMSSENDINGSUCANIM:
        number_of_frames = GET_ICONATTR_NUM(ICON_SMSSENDSUCCESS);//sizeof(SmsSendSuc_Attr)/sizeof(MfwIcnAttr);
        break;
        /*		case WAITINGANIM:	
                    number_of_frames=sizeof(Waiting_Attr)/sizeof(MfwIcnAttr);
                    break;*/
    case NOSIMCARDANIM: 
        number_of_frames = GET_ICONATTR_NUM(ICON_NOSIMCARD);//sizeof(NoSim_Attr)/sizeof(MfwIcnAttr);
        break;

    default:
        break; 
    }
	temptest();//jhxu720 add
    return(number_of_frames);
}
/*2003/12/4, wangyan modify*/

void mmi_dialogs_insert_fixmov_animation (T_MFW_HND win_dialog , S32 anim_time ,AnimationReason Reason)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win_dialog)->data;
    T_dialog_info  * data         = (T_dialog_info *)win_data->user;
    // char animdata[5];

    //	data->number_of_frames = number_of_frames;/*2003/12/4, wangyan modify*/
    data->number_of_frames = Count_number_of_frames(Reason);
    data->current_frame = 0;

    /*	if(Reason ==CALLFORWARDANIM||Reason ==WAITING)    
            dspl_BitBlt (9,41,102,72,0,(void *)backgroundBit, 0);*//*2003/12/4, wangyan modify*/

#if 0 //2004-04-21 Sunny remove
    if( (Reason==WELCOMEANIM)||(Reason==GOODBYEANIM) )
        DrawAnimFixMovBit(Reason,0 );
#endif

    /* 2004/05/13 sunsj modify */
#if ( MAIN_LCD_SIZE==4 )
    if( Reason == SENDINGSMSANIM )
    {
        /* 2004/06 sunsj modify for picture manage */
        //DRAW_ICON(ICON_CALLCOMMON_SJ1);
        DRAW_ICON_SEL(ICON_POPSMSSEND, 0);
        //dspl_BitBlt(40, 57, 49, 69, 0, (void *) smssendingbg, 0); 
    }
    else if( Reason == SMSSENDINGSUCANIM )
    {
        /* 2004/06 sunsj modify for picture manage */
        //DRAW_ICON(ICON_CALLCOMMON_SJ1);
        //DRAW_ICON(ICON_SMSSENDSUCCESS);
        DRAW_ICON_SEL(ICON_POPSMSSEND, 0);
        DRAW_ICON_SEL(ICON_POPSMSSEND, 1);
        //dspl_BitBlt(40, 57, 49, 69, 0, (void *) smssendingbg, 0);
        //dspl_BitBlt(40, 83, 30, 14, 0, (void *) smssendingokbg, 0); 
    }
    else if( Reason == NOSIMCARDANIM )
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPCALLICON, 0);
        DRAW_ICON_SEL(ICON_POPCALLICON, 1);
        //dspl_BitBlt(46, 59, 35, 66, 0, (void *) callrelativebg, 0);
        //dspl_BitBlt(83, 69, 17, 26, 0, (void *) callnosimbg, 0); 
    }
    else if( (Reason == CALLINCOMINGANIM)||(Reason==CALLOUTGOINGANIM) )
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPCALLICON, 0);
        //dspl_BitBlt(46, 59, 35, 66, 0, (void *) callrelativebg, 0);
    }
    /* 2004/06/01 sunsj remove */
    /*
    else if( Reason == CALLREDIALANIM )
    {
        dspl_BitBlt(40, 57, 49, 69, 0, (void *) callredialbg, 0);
        dspl_BitBlt(35, 85, 31, 31, 0, (void *) callredialrbg, 0);
    }
    */
    else if( Reason == CALLNOTCONNECTANIM )
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPCALLICON, 0);
        //dspl_BitBlt(46, 59, 35, 66, 0, (void *) callrelativebg, 0);
    }
#endif
    //	DrawAnimFixMovBit(Reason,1 );/*2003/12/15, wangyan modify*/
#ifndef FOR_FTA_CTA
    DrawAnimFixMovBit(Reason,0 );
    data->animation_timer = timCreate(win_dialog,anim_time,(MfwCb)mmi_dialogs_insert_FixMov_animation_CB);
    timStart(data->animation_timer);
    data->animareason=Reason;
#endif
    //	winShow(win_dialog);	
}



//2004.3.10 WYJ modify  text display position etc.
void remind_animal(T_MFW_HND parent_win, int id)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)parent_win)->data;
    T_dialog_info* data = (T_dialog_info*)win_data->user;  
    int old_color;
    game_Line line;
    game_Rectangle rectangle;
    POP_TYPE    type = POP_END;
    int         dline;

    TRACE_EVENT("remind_animal");

    data->id=id;  

    if( id==REMIND_WAP )
    {
        draw_special_background();
        displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
    }
    else
        draw_popup_background();/*2003/11/20, wangyan modify */

    switch( id )
    {
    case REMIND_DELETING:
#if (MAIN_LCD_SIZE==3)//jhxu720
        DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDeletingSms));//jhxu720
		dialog_drawPopIcon(POP_ICONDELETE);
#elif(MAIN_LCD_SIZE==4)
		DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDeletingSms));
		DRAW_ICON_SEL(ICON_POPDELETE, 0);		
#endif		
        break;

    case REMIND_COPYING:   
        //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT,TxtCopyRecord);/*2003/11/20, wangyan modify */
#if (MAIN_LCD_SIZE==3)//jhxu720
		DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtCopyRecord));			
		dialog_drawPopIcon(POP_ICONCOPY);
		break;
#elif ( MAIN_LCD_SIZE==4 )
        DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtCopyRecord));
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPCOPY, 0);
        //dspl_BitBlt(47, 57, 35, 33, 0, (void *)copyBit1, 0);
        data->number_of_frames=1;
#else ( MAIN_LCD_SIZE==2 )
        DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtCopyRecord));         
        dialog_drawPopIcon(POP_ICONCOPY);
#endif
        break;

    case REMIND_SAVING:   
        //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT,TxtSavingSms);/*2003/11/20, wangyan modify */
        //2004-05-09 Sunny add
#if (MAIN_LCD_SIZE==3)//jhxu720
		DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_HALF_FIRSTSECOND, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSavingSms));
		dialog_drawPopIcon(POP_ICONSAVE);
		break;
#elif ( MAIN_LCD_SIZE==4 )
        DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSavingSms));
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPSAVE, 0);
        //dspl_BitBlt(47, 61, 35, 25, 0, (void *)saveBit1,0);
        data->number_of_frames=1;

#elif ( MAIN_LCD_SIZE==2 )
        DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSavingSms));
        dialog_drawPopIcon(POP_ICONSAVE);
#endif
        break;

    case REMIND_WAITTING:
#if 0 //2004-05-09 Sunny remove
        if( (data->TextId)&&(data->TextId!='\0') )
            ALIGNED_PROMPT(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId);
        else if( data->TextString&&(data->TextString!='\0') )
            displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString);/*2003/11/20, wangyan modify */

        if( data->TextId || data->TextString )    // no text1 display
            dline = DIALOG_THIRD_LINE ;
        else
            dline = DIALOG_SECOND_LINE;

        if( data->TextId2&&(data->TextId2!='\0') )
            ALIGNED_PROMPT(CENTER, dline, DSPL_TXTATTR_TRANSPARENT, data->TextId2);
        else if( data->TextString2&&(data->TextString2!='\0') )
            displayAlignedText(CENTER, dline, DSPL_TXTATTR_TRANSPARENT, data->TextString2);/*2003/11/20, wangyan modify */
#endif
#if (MAIN_LCD_SIZE==3)//jhxu720
        if( (data->TextId) && (data->TextId != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
            //DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));              
        }
        else if( data->TextString && (data->TextString != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            //DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, 84, DSPL_TXTATTR_TRANSPARENT, data->TextString);                              
        }

        if( data->TextId || data->TextString )
            dline = DIALOG_SECOND_LINE;
        else
            dline = DIALOG_FIRST_LINE;

        if( data->TextId2 && (data->TextId2 != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER_RIGHT, dline, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
            //DisplayAlignedAndTruncate(CENTER, dline, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));                              
        }
        else if( data->TextString2 && (data->TextString2 != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER_RIGHT, dline, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            //DisplayAlignedAndTruncate(CENTER, dline, 84, DSPL_TXTATTR_TRANSPARENT, data->TextString2);                                              
        }

        /* 2004/06 sunsj modify for picture manage */
        dialog_drawPopIcon(POP_ICONWAIT);
        //dspl_BitBlt(48, 52, 32, 32, 0,(void*)waiting1,0);
        //dialog_drawPopIcon(POP_ICONWAIT);
        break;
#else
		/* 2004/05/26 sunsj modify */
        if( (data->TextId) && (data->TextId != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
            //DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));              
        }
        else if( data->TextString && (data->TextString != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            //DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, 84, DSPL_TXTATTR_TRANSPARENT, data->TextString);                              
        }
		
        if( data->TextId || data->TextString )
            dline = DIALOG_SECOND_LINE;
        else
            dline = DIALOG_FIRST_LINE;
		
        if( data->TextId2 && (data->TextId2 != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, dline, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
            //DisplayAlignedAndTruncate(CENTER, dline, 84, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));                              
        }
        else if( data->TextString2 && (data->TextString2 != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, dline, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            //DisplayAlignedAndTruncate(CENTER, dline, 84, DSPL_TXTATTR_TRANSPARENT, data->TextString2);                                              
        }
		
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPWAITING, 0);
        //dspl_BitBlt(48, 52, 32, 32, 0,(void*)waiting1,0);
        //dialog_drawPopIcon(POP_ICONWAIT);
        break;
#endif
    case REMIND_COMPLETE:
        {
#if (MAIN_LCD_SIZE==3)//jhxu720
		type = POP_ICONCOMFIRM;	
#elif ( MAIN_LCD_SIZE==4 )
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL(ICON_POPCOMPLETE, 0);
            //dspl_BitBlt(42, 48, 40, 38, 0,(void*)completeBit1,0);

#elif ( MAIN_LCD_SIZE==2)
            type = POP_ICONCOMFIRM;         
#endif
        }
        break;

    case REMIND_SUCCEED:
        {
#if (MAIN_LCD_SIZE==3)//jhxu720
			type = POP_ICONSUCESS;
#elif ( MAIN_LCD_SIZE==4 )
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_POPUP_ACTIONBG);
            DRAW_ICON_SEL(ICON_POPUPACTION, 0);
            //dspl_BitBlt(45, 47, 37, 43, 0, (void *)iconSucessbg, 0);    
            //dspl_BitBlt(51, 59, 24, 14, 0, (void *)iconSucess, 0);

            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }

#elif ( MAIN_LCD_SIZE==2 )
            type = POP_ICONSUCESS;
#endif
        }
        break;

    case REMIND_FAILURE:
        {
#if (MAIN_LCD_SIZE==3)//jhxu720
			type = POP_ICONFAILED;
#elif ( MAIN_LCD_SIZE==4 )
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_POPUP_ACTIONBG);
            DRAW_ICON_SEL(ICON_POPUPACTION, 1);
            //dspl_BitBlt(45, 47, 37, 43, 0, (void *)iconSucessbg, 0);    
            //dspl_BitBlt(54, 56, 20, 19, 0, (void *)iconFailed, 0);
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
                //ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId);     		
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
                //displayAlignedText(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString);/*2003/11/20, wangyan modify */
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //displayAlignedText(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextString2);/*2003/11/20, wangyan modify */
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //displayAlignedText(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextString2);/*2003/11/20, wangyan modify */
                }
            }
#elif ( MAIN_LCD_SIZE==2 )
            type = POP_ICONFAILED;
#endif
        }
        break;

    case REMIND_REQUIRE:
        {
#if (MAIN_LCD_SIZE==3)//jhxu720
			type = POP_ICONREQUIRE;
#elif ( MAIN_LCD_SIZE==4 )
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_POPUP_ACTIONBG);
            DRAW_ICON_SEL(ICON_POPUPACTION, 2);
            //dspl_BitBlt(45, 47, 37, 43, 0, (void *)iconSucessbg, 0);    
            //dspl_BitBlt(54, 53, 18, 24, 0, (void *)iconRequire, 0);
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
                //ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId);     		
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
                //displayAlignedText(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString);/*2003/11/20, wangyan modify */
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //displayAlignedText(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextString2);/*2003/11/20, wangyan modify */
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //displayAlignedText(CENTER,DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);/*2003/11/20, wangyan modify */
                }
            }
#elif ( MAIN_LCD_SIZE==2)
            type = POP_ICONREQUIRE;
#endif
        }
        break;

    case REMIND_NORECORD:
#if (MAIN_LCD_SIZE==3)//jhxu720
		type = POP_ICONINDICATE;
#elif ( MAIN_LCD_SIZE==4 )
        /* 2004/06/15 sunsj fix charging bug */
        //if( data->TextId2==TxtNeedCharging )
        //{
        //    ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
        //}
        //else
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_POPUP_ACTIONBG);
            DRAW_ICON_SEL(ICON_POPUPACTION, 3);
            //dspl_BitBlt(45, 47, 37, 43, 0, (void *)iconSucessbg, 0);    
            //dspl_BitBlt(59, 55, 9, 22, 0, (void *)NoRecordBit, 0);
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
        }
#elif ( MAIN_LCD_SIZE==2 )
        type = POP_ICONINDICATE;
#endif
        break;  

    case REMIND_WAP:
        /* 2004/05/19 sunsj modify */
        //draw_special_background(); /*2003/12/19, wangyan modify*/
#if 0
        if( (wstrBitlen(data->TextString2)>10)||(wstrBitlen(MmiRsrcGetText(data->TextId2))>10) )
        {
            if( (data->TextId)&&(data->TextId!='\0') )
                //ALIGNED_PROMPT(CENTER,86, DSPL_TXTATTR_TRANSPARENT, data->TextId);   
                dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId)),10,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId),0xffffff);
            else if( data->TextString&&(data->TextString!='\0') )
                dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString),10, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    // ALIGNED_PROMPT(CENTER,106,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                    dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId2)),25,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2),0xffffff);
                }
                else
                {
                    // ALIGNED_PROMPT(CENTER,92,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                    dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId2)),25,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2),0xffffff);                     
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString2),25, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString2),25, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
        }
        else
#endif

#if(MAIN_LCD_SIZE==3)//jhxu720
		{
            /* 2004/06 sunsj modify for picture manage */
          //  DRAW_ICON(ICON_CONNECT_WAP);
            //dspl_BitBlt(41, 59, 49, 68, 0, (void *)Wap_Picture1,0);
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
                // ALIGNED_PROMPT(CENTER,86, DSPL_TXTATTR_TRANSPARENT, data->TextId);  
                //dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId)),10,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId),0xffffff);
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
                //dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString),10, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    // ALIGNED_PROMPT(CENTER,106,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                    //dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId2)),25,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2),0xffffff);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //ALIGNED_PROMPT(CENTER,92,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                    //dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId2)),25,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2),0xffffff);
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString2),25, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString2),25, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
        }
#else
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_CONNECT_WAP);
            //dspl_BitBlt(41, 59, 49, 68, 0, (void *)Wap_Picture1,0);
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
                // ALIGNED_PROMPT(CENTER,86, DSPL_TXTATTR_TRANSPARENT, data->TextId);  
                //dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId)),10,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId),0xffffff);
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
                //dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString),10, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    // ALIGNED_PROMPT(CENTER,106,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                    //dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId2)),25,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2),0xffffff);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //ALIGNED_PROMPT(CENTER,92,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                    //dspl_colorTextOut(SCREEN_SIZE_X-get_StringWidth((char *)MmiRsrcGetText(data->TextId2)),25,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2),0xffffff);
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString2),25, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(data->TextString2),25, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
        }
#endif
        break;

    default:
        break;
    }

#if ( MAIN_LCD_SIZE==4 )
    if( (data->id!=REMIND_REQUIRE)&&(data->id!=REMIND_SUCCEED)&&(data->id!=REMIND_FAILURE) )
    {
        data->number_of_frames=0;
        if( (data->iconIndex==REMIND_DELETING)||(data->iconIndex==REMIND_COPYING)||(data->iconIndex==REMIND_SAVING) )
        {
            data->delete_tim_win=tim_create(parent_win,400,(T_MFW_CB)remind_tim_cb);
        }
        else if( (data->iconIndex==REMIND_WAITTING) )
        {
            data->delete_tim_win=tim_create(parent_win,600,(T_MFW_CB)remind_tim_cb);
        }
        else
        {
            data->delete_tim_win=tim_create(parent_win,200,(T_MFW_CB)remind_tim_cb);
        }       
        timStart(data->delete_tim_win);
    }
#endif

#if (MAIN_LCD_SIZE==3)//jhxu720
	if(type != POP_END)
	{
		//2004-05-09 Sunny add
		if((data->TextId) && (data->TextId != '\0'))
		{
			DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));//jhxu714
		}
		else if(data->TextString && (data->TextString != '\0'))
		{
			DisplayAlignedAndTruncate(CENTER_RIGHT, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);//jhxu714
		}
		
		if(data->TextId || data->TextString)	
			dline = DIALOG_SECOND_LINE ;
		else
			dline = DIALOG_HALF_FIRSTSECOND;
		
		if(data->TextId2 && (data->TextId2 != '\0'))
		{
			DisplayAlignedAndTruncate(CENTER_RIGHT, dline, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
		}
		else if(data->TextString2 && (data->TextString2 != '\0'))
		{
			DisplayAlignedAndTruncate(CENTER_RIGHT, dline, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
		}
		//2004-05-09 Sunny add end
		
		dialog_drawPopIcon(type); //2004.3.5 WYJ
	}
#elif ( MAIN_LCD_SIZE==4 )
    if( (data->id!=REMIND_REQUIRE)&&(data->id!=REMIND_SUCCEED)&&(data->id!=REMIND_FAILURE) )
    {
        data->number_of_frames=0;
        if( (data->iconIndex==REMIND_DELETING)||(data->iconIndex==REMIND_COPYING)||(data->iconIndex==REMIND_SAVING) )
        {
            data->delete_tim_win=tim_create(parent_win,400,(T_MFW_CB)remind_tim_cb);
        }
        else if( (data->iconIndex==REMIND_WAITTING) )
        {
            data->delete_tim_win=tim_create(parent_win,600,(T_MFW_CB)remind_tim_cb);
        }
        else
        {
            data->delete_tim_win=tim_create(parent_win,200,(T_MFW_CB)remind_tim_cb);
        }       
        timStart(data->delete_tim_win);
    }

#elif ( MAIN_LCD_SIZE==2)
    // need draw icon 2004.3.10 WYJ
    if( type != POP_END )
    {
        //2004-05-09 Sunny add
        if( (data->TextId) && (data->TextId != '\0') )//jhxu720
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
        }
        else if( data->TextString && (data->TextString != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
        }

        if( data->TextId || data->TextString )
            dline = DIALOG_SECOND_LINE ;//jhxu720
        else
            dline = DIALOG_HALF_FIRSTSECOND;//jhxu720

        if( data->TextId2 && (data->TextId2 != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, dline, POP_WINDOWS_WIDTH * 2, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
        }
        else if( data->TextString2 && (data->TextString2 != '\0') )
        {
            DisplayAlignedAndTruncate(CENTER, dline, POP_WINDOWS_WIDTH * 2, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
        }
        //2004-05-09 Sunny add end

        dialog_drawPopIcon(type); //2004.3.5 WYJ
    }
#endif
}

/* 2004/05/17 sunsj modify */
#if ( MAIN_LCD_SIZE==4 )
static T_MFW_CB  remind_tim_cb(MfwEvt e, MfwTim *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_info* data = (T_dialog_info*)win_data->user;
    T_MFW_HND       parent_win = data->parent_win;
    USHORT    Identifier=data->Identifier;
    void (* Callback)() = data->Callback;
    game_Rectangle rectangle;

    TRACE_EVENT("remind_tim_cb");

    if( !winIsFocussed(data->info_win) )
    {
        timStop(data->delete_tim_win);
        return;
    }

    switch( data->id )
    {
    case REMIND_DELETING:   
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPDELETE, 0);
        DRAW_ICON_SEL(ICON_POPDELETE, (data->number_of_frames%2)+1);
        /*
        dspl_BitBlt(46, 45, 36, 49, 0, (void *)deleteBit1, 0);
        switch( data->number_of_frames%2 )
        {
        case 0:
            dspl_BitBlt(46, 53, 36, 15, 0, (void *)deleteBit2, 0);
            break;
        case 1:
            dspl_BitBlt(46, 53, 36, 15, 0, (void *)deleteBit3, 0);          
            break;
        }
        */
        data->number_of_frames++;
        timStart(data->delete_tim_win);
        break;
    case REMIND_COPYING: 
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON(ICON_POPUPBACKGROUND);
        DRAW_ICON_SEL(ICON_POPCOPY, data->number_of_frames%2);
        /*
        switch( data->number_of_frames%2 )
        {
        case 0:
            dspl_BitBlt(12,TOP_POSITION, 104, 96, 0, (void *)popupbackground, 0);
            dspl_BitBlt(47, 57, 35, 33, 0, (void *)copyBit1, 0);
            break;
        case 1:
            dspl_BitBlt(12,TOP_POSITION, 104, 96, 0, (void *)popupbackground, 0);
            dspl_BitBlt(47, 49, 35, 41, 0, (void *)copyBit2, 0);        
            break;
        }
        */
        DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtCopyRecord));
        data->number_of_frames++;
        timStart(data->delete_tim_win);
        break;
    case REMIND_SAVING:  
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON(ICON_POPUPBACKGROUND);
        DRAW_ICON_SEL(ICON_POPSAVE, data->number_of_frames%3);
        /*
        switch( data->number_of_frames%3 )
        {
        case 0:
            dspl_BitBlt(12,TOP_POSITION, 104, 96, 0, (void *)popupbackground, 0);
            dspl_BitBlt(47, 61, 35, 25, 0,(void *)saveBit1,0);
            break;
        case 1:
            dspl_BitBlt(12,TOP_POSITION, 104, 96, 0, (void *)popupbackground, 0);
            dspl_BitBlt(44, 53, 38, 33, 0,(void *)saveBit2,0);
            break; 
        case 2:
            dspl_BitBlt(12,TOP_POSITION, 104, 96, 0, (void *)popupbackground, 0);
            dspl_BitBlt(47, 41, 35, 45, 0,(void *)saveBit3,0);
            break;
        }
        */
        /* 2004/05/19 sunsj modify */
        DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSavingSms));
        data->number_of_frames++;
        timStart(data->delete_tim_win);
        break;
    case REMIND_COMPLETE:
        /* 2004/05/19 sunsj modify */
        if( (data->TextId)&&(data->TextId!='\0') )
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
        }
        else if( data->TextString&&(data->TextString!='\0') )
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            //displayAlignedText(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
        }

        if( data->TextId2&&(data->TextId2!='\0') )
        {
            if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
            }
            else
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
            }
        }
        else if( data->TextString2&&(data->TextString2!='\0') )
        {
            if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                //displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            }
            else
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                //displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            }
        }
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPCOMPLETE, data->number_of_frames%2);
        /*
        switch( data->number_of_frames%2 )
        {
        case 0:
            dspl_BitBlt(42, 48, 40, 38, 0,(void*)completeBit1,0);
            break;
        case 1:
            dspl_BitBlt(42, 48, 40, 38, 0,(void*)completeBit2,0);
            break;
        }  
        */
        timStart(data->delete_tim_win);
        data->number_of_frames++;                                 
        break;
    case REMIND_WAITTING:
        /* 2004/05/26 sunsj modify */
        if( (data->TextId)&&(data->TextId!='\0') )
        {
            /* 2004/05/26 sunsj Fix M188B00000033 */
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
            //ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId);           
        }
        else if( data->TextString&&(data->TextString!='\0') )
        {
            DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            //displayAlignedText(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString);
        }

        if( data->TextId2&&(data->TextId2!='\0') )
        {
            if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
            }
            else
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
            }
        }
        else if( data->TextString2&&(data->TextString2!='\0') )
        {
            if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                //displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            }
            else
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                //displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
            }
        }
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_POPWAITING, data->number_of_frames%2);
        /*
        switch( data->number_of_frames%2 )  //xsf changed temporarily 7 t0 4 03.03.14
        {
        case 0:
            dspl_BitBlt(48, 52, 32, 32,0,(void*)waiting1,0);
            break;
        case 1:
            dspl_BitBlt(48, 52, 32, 32,0,(void*)waiting2,0);
            break;
        }
        */
        timStart(data->delete_tim_win);
        data->number_of_frames++;  
        break;

    case REMIND_SUCCEED:
    case REMIND_FAILURE:
        timStop(data->delete_tim_win);
        /* dialog_info_destroy(win);
        if(Callback)
            (Callback)(parent_win, Identifier, 0);*/
        break;
    case REMIND_NORECORD:       
        break;
    case REMIND_WAP:
        /* 2004/05/19 sunsj modify */
#if 0
        if( (wstrBitlen(data->TextString2)>10)||(wstrBitlen(MmiRsrcGetText(data->TextId2))>10) )
        {
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId); 
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                displayAlignedText(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }
            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
                else
                {
                    ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
        }
        else
#endif
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_CONNECT_WAP);
            //dspl_BitBlt(41, 59, 49, 68, 0, (void *)Wap_Picture1,0);
            if( (data->TextId)&&(data->TextId!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId));
                //ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextId);
            }
            else if( data->TextString&&(data->TextString!='\0') )
            {
                DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString);
                //displayAlignedText(CENTER, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString);
            }

            if( data->TextId2&&(data->TextId2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(data->TextId2));
                    //ALIGNED_PROMPT(CENTER,DIALOG_SECOND_LINE,DSPL_TXTATTR_TRANSPARENT, data->TextId2);
                }
            }
            else if( data->TextString2&&(data->TextString2!='\0') )
            {
                if( ((data->TextId)&&(data->TextId!='\0'))||(data->TextString&&(data->TextString!='\0')) )
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_SECOND_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
                else
                {
                    DisplayAlignedAndTruncate(CENTER, DIALOG_FIRST_LINE, POP_WINDOWS_WIDTH, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                    //displayAlignedText(CENTER, DIALOG_SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, data->TextString2);
                }
            }
        }
#if 0
        switch( data->number_of_frames%12 )
        {
        case 0:
            dspl_BitBlt(64, 81, 59, 59 , 0,(void *)Wap_Picture1,0);
            break;
        case 1:
            dspl_BitBlt(64, 81, 59, 59 , 0,(void *)Wap_Picture2,0);
            break;
        case 2:
            dspl_BitBlt(64, 81, 59, 59, 0, (void *)Wap_Picture3,0);
            break;
        case 3:
            dspl_BitBlt(64, 81, 59, 59 , 0, (void *)Wap_Picture4,0);
            break;
        case 4:
            dspl_BitBlt(64, 81, 59, 59 , 0, (void *)Wap_Picture5,0);
            break;
        }
#endif
        timStart(data->delete_tim_win);
        data->number_of_frames++;  
        break;
    }  
}
#endif

void draw_popup_background(void)
{
#if(MAIN_LCD_SIZE==3)
    DRAW_ICON_MASK_OWN(ICON_POPUPBACKGROUND);//jhxu720
#elif (MAIN_LCD_SIZE==4)
	DRAW_ICON(ICON_POPUPBACKGROUND);//jhxu720
#endif
}

//2004-04-01 Sunny add for outer screen
void draw_popup_background_sub(void)
{
#if(MAIN_LCD_SIZE==3)
	DRAW_ICON_MASK_OWN(ICON_POPUPBACKGROUND);//jhxu720
#elif (MAIN_LCD_SIZE==4)
	DRAW_ICON(ICON_POPUPBACKGROUND);//jhxu720
#endif
}
//2004-04-01 Sunny add end
/*2003/12/19, wangyan modify*/
void draw_special_background(void)
{
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON(ICON_SPECIAL_BG);
    //drawIconByIcnAttr((MfwIcnAttr*)&icnSpBkgAttr, 0);
    DRAW_ICON(ICON_SOFTKEYBAR);
    //drawIconByIcnAttr((MfwIcnAttr*)&softkeybarAttr, 0);
}
/*2003/12/19, wangyan modify*/

/*2003/12/19, wangyan modify*/
void draw_softkeybar_background(void)
{
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON(ICON_SOFTKEYBAR);
    //drawIconByIcnAttr((MfwIcnAttr*)&softkeybarAttr, 0);
    //dspl_BitBlt(0, 65, 102, 15, 0, (void * )softkeybar, 0);
}


/*zy add 2003-04-16 get dialog id*/
USHORT GetDiaolgIden(T_MFW_HND win)
{
    USHORT Identifier;

    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_info * data = (T_dialog_info *)win_data->user;
    Identifier = data->Identifier;

    return Identifier;
}
/*end of zy change 2003-04-16*/

#if(MAIN_LCD_SIZE==3)

void dialog_drawPopIcon(POP_TYPE type)
{
    if( type<0 || type>=POP_END )
        return;

    if( type < POP_ICONSAVE )
        //dspl_BitBlt( 41, 15, 21, 18, 0, (void*)popIcon[type], 0);
		DRAW_ICON_SEL(ICON_POPUPICON,type);
    else
    {
        // Сһ, ʾλ
        /*dspl_BitBlt( 41+4, 15+2, 13, 13, 0, (void*)popIcon[type], DSPL_BMPXOR);
        dspl_BitBlt( 41+4, 15+2, 13, 13, 0, (void*)popIconMask[type], DSPL_BMPAND);
        dspl_BitBlt( 41+4, 15+2, 13, 13, 0, (void*)popIcon[type], DSPL_BMPXOR);*/
		DRAW_ICON_SEL(ICON_POPUPICON,type);
    }
}
// end of 2004.3.5 WYJ ADD

//2004-04-01 Sunny add for outer screen
void dialog_drawPopIcon_sub(POP_TYPE type)
{
    if( type<0 || type>=POP_END )
        return;

    if( type < POP_ICONSAVE )
        //dspl_sub_BitBlt( 37, 15, 21, 18, 0, (void*)popIcon[type], 0);
		DRAW_ICON_SEL(ICON_POPUPICON,type);
    else
    {
        // Сһ, ʾλ
        /*dspl_sub_BitBlt( 37+4, 15+2, 13, 13, 0, (void*)popIcon[type], DSPL_BMPXOR);
        dspl_sub_BitBlt( 37+4, 15+2, 13, 13, 0, (void*)popIconMask[type], DSPL_BMPAND);
        dspl_sub_BitBlt( 41+4, 15+2, 13, 13, 0, (void*)popIcon[type], DSPL_BMPXOR);*/
		DRAW_ICON_SEL(ICON_POPUPICON,type);
    }
}
#endif
//2004-04-01 Sunny add for outer screen

extern int CountLengthOfSting(char *string, int stringlength, int stringtype);
/****************************************************************************************
 $Function:    	displayTitle

 $Description:	display title

 $Returns: void
 
 $Author Name:  Sunsj

 $Date: 2004/01/14

 $History:	2004/04/22 sunsj modify for long title text

****************************************************************************************/
void displayTitle( int start_x, const char *TitleString, const char *TitleNum, int position, int FrgColor, int BkgColor )
{
    UBYTE titleLen,NumberLen;
    int oldFrgColor,oldBkgColor;
    int TextColor = 0;
    int stringNum = 0;
    char tempString[50];
    int tooLongFlag = 0;

    /* if title is null then return */
    if( TitleString == NULL )
    {
        return;
    }
    memset( tempString, 0x00, 50 );
    /* get the total length of title */
    titleLen = get_StringWidth(TitleString);
    if( position == TITLE_WITH_NUMBER )
    {
        NumberLen = get_StringWidth( TitleNum );
        if( (titleLen + NumberLen) > (SCREEN_SIZE_X - start_x - NumberLen - 2) )
        {
            tooLongFlag = 1;
            stringNum = CountLengthOfSting( (char *)TitleString, (SCREEN_SIZE_X - start_x - NumberLen - 2), 0 );
            if( TitleString[0] == (char)0x80 )
            {
                tempString[0] = 0x80;
                memcpy( (char *)tempString, (char *)TitleString, stringNum+1);
                tempString[stringNum+1] = 0x00;
                tempString[stringNum+2] = 0x2e;
                tempString[stringNum+3] = 0x00;
                tempString[stringNum+4] = 0x2e;
            }
            else
            {
                memcpy( (char *)tempString, (char *)TitleString, stringNum);
                strcat( tempString, ".." );
            }
        }
    }
    else
    {
        NumberLen = 0;
        if( (titleLen + NumberLen) > (SCREEN_SIZE_X - start_x) )
        {
            tooLongFlag = 1;
            position = TITLE_LEFT;
            stringNum = CountLengthOfSting( (char *)TitleString, (SCREEN_SIZE_X - start_x), 0 );
            if( TitleString[0] == (char)0x80 )
            {
                tempString[0] = 0x80;
                memcpy( tempString, (char *)TitleString, stringNum+1);
                //strcat( tempString, symbol );
                tempString[stringNum+1] = 0x00;
                tempString[stringNum+2] = 0x2e;
                tempString[stringNum+3] = 0x00;
                tempString[stringNum+4] = 0x2e;
            }
            else
            {
                memcpy( (char *)tempString, (char *)TitleString, stringNum);
                strcat( tempString, ".." );
            }
        }
    }

    /* if user want use background color so we needn't draw title icon and clear title area */
    if( BkgColor == 0x000000 )
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON(ICON_MENUUP);
        //dspl_BitBlt(0, 0, menuup[0].area.sx, menuup[0].area.sy, 0, (void*)menuup[0].icons, 0);
    }
    else
    {
        oldBkgColor = dspl_SetBkgColor( BkgColor );
        dspl_Clear(0, 0, SCREEN_SIZE_X, TITLE_HEIGHT);
    }
    /* set text color */
    //oldFrgColor = dspl_SetFrgColor( FrgColor );

    /* draw title with its position */
#if(MAIN_LCD_SIZE==4)
    switch( position )
    {
    case TITLE_LEFT:
        /* if title text length is longer than screen size, then draw title by temp string */
        if( tooLongFlag == 1 )
        {
            drawcolorclarity_NoNewline(1+start_x, 1, tempString, FrgColor);
        }
        else
        {
            drawcolorclarity_NoNewline(1, 1, TitleString, FrgColor);
        }
        break;
    case TITLE_MIDDLE:
        drawcolorclarity_NoNewline((SCREEN_SIZE_X-titleLen)/2, 1, TitleString, FrgColor);
        break;
    case TITLE_RIGHT:
        drawcolorclarity_NoNewline((SCREEN_SIZE_X-titleLen), 1, TitleString, FrgColor);
        break;
    case TITLE_WITH_NUMBER:
        if( TitleNum == NULL )
        {
            return;
        }
        NumberLen = get_StringWidth( TitleNum );
        drawcolorclarity_NoNewline((SCREEN_SIZE_X-NumberLen-2), 1, TitleNum, FrgColor);
        if( tooLongFlag == 1 )
        {
            drawcolorclarity_NoNewline( start_x, 1, tempString, FrgColor);
        }
        else
        {
            drawcolorclarity_NoNewline((SCREEN_SIZE_X-NumberLen-titleLen)/2, 1, TitleString, FrgColor);
        }
        break;
    default:
        break;
    }
#elif (MAIN_LCD_SIZE==3)
	switch( position )
    {
    case TITLE_LEFT:
        /* if title text length is longer than screen size, then draw title by temp string */
        if( tooLongFlag == 1 )
        {
            drawcolorclarity_NoNewline(1+start_x, 0, tempString, FrgColor);
        }
        else
        {
            drawcolorclarity_NoNewline(1, 0, TitleString, FrgColor);
        }
        break;
    case TITLE_MIDDLE:
        drawcolorclarity_NoNewline((SCREEN_SIZE_X-titleLen)/2, 0, TitleString, FrgColor);
        break;
    case TITLE_RIGHT:
        drawcolorclarity_NoNewline((SCREEN_SIZE_X-titleLen), 0, TitleString, FrgColor);
        break;
    case TITLE_WITH_NUMBER:
        if( TitleNum == NULL )
        {
            return;
        }
        NumberLen = get_StringWidth( TitleNum );
        drawcolorclarity_NoNewline((SCREEN_SIZE_X-NumberLen-2), 0, TitleNum, FrgColor);
        if( tooLongFlag == 1 )
        {
            drawcolorclarity_NoNewline( start_x, 0, tempString, FrgColor);
        }
        else
        {
            drawcolorclarity_NoNewline((SCREEN_SIZE_X-NumberLen-titleLen)/2, 0, TitleString, FrgColor);
        }
        break;
    default:
        break;
    }
#endif
    if( BkgColor != 0x000000 )
    {
        dspl_SetBkgColor( oldBkgColor );
    }
}

void draw_dialog_current_page(T_dialog_info * data, int current)
{
    /* 2004/05/26 sunsj modify */
    UBYTE mode;

    mode=dspl_Enable(0);

    if( data->Identifier==RECTCALLDETAIL )
    {
        dspl_Clear(0, 0, SCREEN_SIZE_X, SCREEN_SIZE_Y);
        dspl_TextOut(1,16,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId));
        dspl_TextOut(1,32,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString);

        
#if(MAIN_LCD_SIZE==4)
		if( data->iconIndex==100 )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_GROUP, 45, 55, 15, ICON_LOCATION|ICON_MASK_OWN);
            //dspl_BitBlt( 45 , 55, BookGroupingIcon[15].area.sx,
            //             BookGroupingIcon[15].area.sy, BookGroupingIcon[15].nIcons,BookGroupingIcon[15].icons,0); 
        }

        if( data->TextId2!=0 )
        {
            dspl_TextOut(1,55,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2));
            dspl_TextOut(1,71,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString2);
        }
        dspl_TextOut(1,94,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId3));
        dspl_TextOut(1,110,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString3);
#elif(MAIN_LCD_SIZE==3)
		if( data->iconIndex==100 )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_GROUP, 45, 48, 15, ICON_LOCATION|ICON_MASK_OWN);
            //dspl_BitBlt( 45 , 55, BookGroupingIcon[15].area.sx,
            //             BookGroupingIcon[15].area.sy, BookGroupingIcon[15].nIcons,BookGroupingIcon[15].icons,0); 
        }

        if( data->TextId2!=0 )
        {
            dspl_TextOut(1,48,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2));
            dspl_TextOut(1,64,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString2);
        }
		dspl_TextOut(1,80,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId3));
        dspl_TextOut(1,96,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString3);
#endif
        displaySoftKeys(data->LeftSoftKey, data->RightSoftKey); // display ID softkeys
        dspl_Enable(mode);
#if 0
        if( current==1 )
        {
            draw_special_background();
            dspl_TextOut(1,0,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId));
            dspl_TextOut(1,13,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString);

            if( data->iconIndex==100 )
            {
                dspl_BitBlt( 45 , 26, BookGroupingIcon[15].area.sx,
                             BookGroupingIcon[15].area.sy, BookGroupingIcon[15].nIcons,BookGroupingIcon[15].icons,0); 
            }

            if( data->TextId2!=0 )
            {
                dspl_TextOut(1,26,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId2));
                dspl_TextOut(1,39,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString2);
            }

            dspl_TextOut(1,52,DSPL_TXTATTR_TRANSPARENT,MmiRsrcGetText(data->TextId3));

            displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
        }
        else if( current==2 )
        {
            draw_special_background();
            dspl_TextOut(1,0,DSPL_TXTATTR_TRANSPARENT,(char*)data->TextString3);
            displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
        }
#endif
    }

}

/****************************************************************************************************
    $Function:		DrawWelcomAnim
    $Description:
    $Author:		Sunny
    $Date:			2004-04-21
****************************************************************************************************/
void DrawWelcomeAnim(AnimationReason Reason,int animindex)
{
    MfwIcnAttr *iconAttr = 0;

    switch( FFS_flashData.onoffanimation )
    {
    case 0:
        /* 2004/06 sunsj modify for picture manage */
        iconAttr = GET_ICONATTR(ICON_SWITCHON, animindex);//(MfwIcnAttr *)&SwitchOn_Attr[animindex];
        break;
    case 1://Mobileinnovation			
        break;
    case 2://flower
#if (MAIN_LCD_SIZE==3)
		iconAttr = GET_ICONATTR(ICON_SWITCHON, animindex);
#elif ( MAIN_LCD_SIZE==4 )
        iconAttr = GET_ICONATTR(ICON_SWITCHON, animindex);//(MfwIcnAttr *)&SwitchOn_Animination_Attr[animindex];
#elif ( MAIN_LCD_SIZE==2 )
        iconAttr = GET_ICONATTR(ICON_SWITCHON, animindex);
#endif
        break;
    case 3://Skyrocket
        break;
    }

    if( iconAttr )
    {
#if(MAIN_LCD_SIZE==3)
		DRAW_ICON(ICON_SWITCHON_BKG);//jhxu720
#endif
        dspl_BitBlt( iconAttr->area.px,iconAttr->area.py,
                     iconAttr->area.sx,iconAttr->area.sy,
                     iconAttr->nIcons,iconAttr->icons,0);
    }
}

/****************************************************************************************************
    $Function:		DrawGoodbyeAnim
    $Description:
    $Author:		Sunny
    $Date:			2004-04-21
****************************************************************************************************/
void DrawGoodbyeAnim(AnimationReason Reason,int animindex)
{
    MfwIcnAttr *iconAttr = 0;

    switch( FFS_flashData.onoffanimation )
    {
    case 0:
        /* 2004/06/01 sunsj modify */
        iconAttr = GET_ICONATTR(ICON_SWITCHOFF, animindex);//jhxu720
        break;
    case 1://Mobileinnovation			
        break;
    case 2://flower
		iconAttr = GET_ICONATTR(ICON_SWITCHOFF, animindex);//(MfwIcnAttr *)&SwitchOff_Attr[animindex];
#if ( MAIN_LCD_SIZE==2 )
        iconAttr = (MfwIcnAttr *)&SwitchOff_Flower_Attr[animindex];
#endif
        break;
    case 3://Skyrocket
        break;
    }

    if( iconAttr )
    {
#if(MAIN_LCD_SIZE==3)
		DRAW_ICON(ICON_SWITCHOFF_BKG);//jhxu720
#endif
        dspl_BitBlt( iconAttr->area.px,iconAttr->area.py,
                     iconAttr->area.sx,iconAttr->area.sy,
                     iconAttr->nIcons,iconAttr->icons,0);
    }
}
/*2004/05/19 sunsj add */
void draw_icon_require(void)
{
    draw_popup_background();
#if(MAIN_LCD_SIZE==3)//jhxu720
    DRAW_ICON_SEL(ICON_POPUPICON, 2);
#else
	DRAW_ICON(ICON_POPUP_ACTIONBG);
#endif
}
