
#ifndef _DEF_MMI_DUMMY_H_
#define _DEF_MMI_DUMMY_H_


/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		
 $File:		    MmiDummy.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
                                                                             
 
*******************************************************************************/



/****************************************************************************************
 *
 * Common Definitions for template and MFW compatibility
 *
 ****************************************************************************************
 */
/*
 * compatibility definitions
 * MFW - GUI uses definitions which are not compatible with the
 * interface !!!
 */

#define mfw_parent mfwParent
#define mfw_header mfwHeader

#define win_create winCreate
#define win_delete winDelete
#define win_show   winShow
#define win_hide   winHide
#define win_unhide winUnhide
#define E_WIN_VISIBLE MfwWinVisible

#define kbd_create kbdCreate
#define kbd_delete kbdDelete

#define edt_create edtCreate
#define edt_delete edtDelete

#define edt_create edtCreate
#define edt_delete edtDelete
#define edt_reset  edtReset
#define tim_delete   timDelete
#define tim_create   timCreate
#define tim_start    timStart
#define tim_stop     timStop
#define tim_set_time timSetTime

#define sat_create satCreate
#define sat_init   satInit
#define sat_delete satDelete
#define sat_exit   satExit

#define sat_done( a, b )    satDone( a, (U8 *) b, (int) sizeof( b ) )

typedef MfwSat T_MFW_SAT;
typedef MfwTim T_MFW_TIM;
typedef MfwWin T_MFW_WIN;

typedef SatCmd   T_SAT_CMD;
typedef SatTxt   T_SAT_TXT;
typedef SatInput T_SAT_INPUT;

typedef MfwMnuItem T_MFW_MNU_ITEM;
typedef MfwMnuAttr T_MFW_MNU_ATTR;
typedef MfwMnu     T_MFW_MNU;
typedef MfwKbd     T_MFW_KBD;
typedef MfwEdtAttr T_MFW_EDT_ATTR;

#define MFW_SAT_REFRESH         MfwSatRefresh
#define MFW_SAT_TEXT_OUT        MfwSatTextOut
#define MFW_SAT_GET_KEY         MfwSatGetKey
#define MFW_SAT_GET_STRING      MfwSatGetString
#define MFW_SAT_PLAY_TONE       MfwSatPlayTone
#define MFW_SAT_SETUP_MENU      MfwSatSetupMenu
#define MFW_SAT_SELECT_ITEM     MfwSatSelectItem
#define MFW_SAT_SEND_SMS        MfwSatSendSMS
#define MFW_SAT_SEND_SS         MfwSatSendSS
#define MFW_SAT_CALL            MfwSatCall
#define MFW_SAT_SESSION_END     MfwSatSessionEnd

#define SAT_RES_SUCCESS         SatResSuccess
#define SAT_RES_PARTIAL         SatResPartial
#define SAT_RES_MISSING         SatResMissing
#define SAT_RES_ADDITIONAL      SatResAdditional
#define SAT_RES_MODIFIED        SatResModified
#define SAT_RES_USER_ABORT      SatResUserAbort
#define SAT_RES_USER_BACK       SatResUserBack
#define SAT_RES_USER_NO_RESP    SatResUserNoResp
#define SAT_RES_USER_HELP       SatResUserHelp
#define SAT_RES_BUSY_ME         SatResBusyME
#define SAT_RES_BUSY_NET        SatResBusyNet
#define SAT_RES_REJECT          SatResReject
#define SAT_RES_CLEARED         SatResCleared
#define SAT_RES_CC_TEMP         SatResCCTemp
#define SAT_RES_IMPOSSIBLE      SatResImpossible
#define SAT_RES_UNKNOWN_TYPE    SatResUnknownType
#define SAT_RES_UNKNOWN_DATA    SatResUnknownData
#define SAT_RES_UNKNOWN_NUMBER  SatResUnknownNumber
#define SAT_RES_SS_ERROR        SatResSSerror
#define SAT_RES_SMS_ERROR       SatResSMSerror
#define SAT_RES_NO_VALUES       SatResNoValues
#define SAT_RES_USSD_ERROR      SatResUSSDerror
#define SAT_RES_CC_PERMANENT    SatResCCPermanent

/*
 * end of compatibility definitions
 */

char* get_build_user();
char* get_build_date();
char* get_build_time();

int get_imei(char *imei);

extern T_MFW_HND idle_get_window (void);


#endif

