/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   MMI
 $File:       MmiEditor.c
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       22/02/01

********************************************************************************

 Description:



********************************************************************************

 $History: MmiMain.c
 2003/11/10 sunsj fix can't insert char to text and add the function that return to idle
                  when close screen.
       * *****************  Version 05.1 *****************
 * zgz,2002.9.3
 *when two or more editor in one window, add the KCD_MNUUP,KCD_MNUDOWN event to preve or next editor
 *Send event to upper layer at any case when in phbk editing, user press KCD_LEFT

      * *****************  Version 05.0 *****************
 * zgz,2002.8.26
 *add the code in editor_win_cb() to   indicate upper layer to update
 *

     * *****************  Version 05.0 *****************
 * zgz,2002.8.26
 *update  function editor_attr_init_only(), Add the handle of title attribute TITLE_TOP
 *Add the right softkey handle. when no text in buffer, It displayed "back", else it is "del"
indicate upper layer to update
    * *****************  Version 04.2 *****************
 * zgz,2002.7.31
 *update  function editor_kbd_cb(), handle the KCD_RIGHT when no unicode chars(only 0x80) in the buffer
 *
   * *****************  Version 04.1 *****************
 * zgz,2002.7.29
 *update  function editor_attr_init_only(), editor_attr_init_fullscr() for drawing frame line
 *update editor_kbd_cb()  for disable input_method update when only draw title 

  * *****************  Version 04 *****************
 * zgz,2002.7.11
 *change the editor for Mobile Innovation symbol input
 * 

 * *****************  Version 03 *****************
 * zgz,2002.7.2
 *added function editor_attr_init_only(), editor_attr_init_fullscr(), getNextInputLen()
 * update edtChar() by edtSymbol() for symbol input

 
 * *****************  Version 02 *****************
 * zgz,2002.06.24
 * editor_kbd_cb() changed. Add the process for the key KCD_MNULEFT,KCD_MNURIGHT,KCD_VOLUP,KCD_VOLDOWN
 * 

  25/10/00      Original Condat(UK) BMI version.
 $End

*******************************************************************************/

#define ENTITY_MFW
////////////////////////////////////////////////////////////////////////////


//#define _ZGZ_EDITOR_DEBUG  1 // zgz,2002.7.4 define it for editor debug


/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_ss.h"
#include "mfw_icn.h"
//GW Removed T9 references
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_cm.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"


#include "MmiMain.h"
#include "MmiDummy.h"
//#include "MmiLists.h"
#include "MmiMmi.h"

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
//GW Removed T9 reference
#include "MmiIdle.h"

#include "MmiEditor.h"
#include "MmiEditor_i.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mmiicons.h"
#include "mmibookshared.h"
#include "mmismsmenu.h"
#include "mfw_ffs.h"

#include "mmisymbol.h" // zgz,2002.7.6
#include "mmitextinput.h"	/* 2003/12/04 sunsj */
#include "mmiusersymbolinput.h"	// zgz,2002.7.6
#include "wstring.h"				//zgz,2002.7.31
#include "mmisettings.h"
#include "mmistart.h"
#include "mmiSat_i.h"  //zhaowm 2003.1.6
#include "mmismsmenu.h"
#ifdef EASY_TEXT_ENABLED
    #include "MmiLatinPredText.h"
    #include "MmiDictionary.h"
#endif
#include "mmiicons.h"
#include "mmi3dframe.h"

#ifndef MFW_EVENT_PASSED
    #define MFW_EVENT_PASSED 0
#endif


#ifdef _ZGZ_EDITOR_DEBUG
    #include "MmiLatinPredText.h"
#endif

//#define TDTRACE 1
#include "mmiutilapi.h"
#include "encrypt.h"					// 2004.6.2 WYJ add

extern void ShowVersiondialog(T_MFW_HND win);/*2004/5/10, wangyan add*/
/*********************************************************************
**********************************************************************

                                 DYNAMIC EDITOR WINDOW. DECLARATION

*********************************************************************
**********************************************************************/
/*
 * Internal events
 */



static T_MFW_HND   editor_create       (T_MFW_HND  parent);
//SH - static void        editor_destroy      (T_MFW_HND  window);
static void        editor_exec_cb      (T_MFW_HND  win,USHORT event, SHORT value, T_EDITOR_DATA * editor_data);
static int         editor_win_cb       (T_MFW_EVENT event, T_MFW_WIN * win);
static int         editor_kbd_cb       (T_MFW_EVENT event, T_MFW_KBD * keyboard);
static int         editor_tim_cb       (T_MFW_EVENT event, T_MFW_TIM *tc);

//static void Setcursor(MfwEdt *edit,char *text,MfwRect win);


static char SymbolPrompt[40] = "123456789";
static int DoNextLongPress = FALSE;

static UBYTE UPPER_CASE = FALSE;
extern int upCase;

UBYTE AllowPredText = FALSE;
extern int SymbolChar;
extern INT8 g_norejectkeyflag;

/* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
//extern int editForChineseInput;

extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
extern uint8    In_QQ;//2003-2-28,indicate in qq menu
#endif

static const unsigned char TextIconeZiTextSmall[] =
{
    0x03,
    0x03,
    0x18,
    0x7c,
    0xcc,
    0x08,
    0x10,
};

/* zhq, 2004/07/08, modified for we will use pin_outer_wait to init sub screen
and only refresh sub screen until main screen drawIdle. */
extern UBYTE main_sreen_init_complete;

/* internal used functions: */
static void editor_hideInit(T_EDITOR_INFO *data);
static void editor_hideInsert(T_EDITOR_INFO *data, U8 key);
static void editor_hideClear(T_EDITOR_INFO *data);
static void editor_hideClearAll(T_EDITOR_INFO *data);
static void editor_hideTerminate(T_EDITOR_INFO *data);
static int show_error_info(T_MFW_HND parent_win);
static void displayedtsoftkey(T_MFW_HND win);


/*********************************************************************
**********************************************************************

                                DYNAMIC EDITOR WINDOW. IMPLEMENTATION

*********************************************************************
**********************************************************************/

//KK011107 #ifndef WIN32 why is this undeffed?? it is used!!
/*******************************************************************************

 $Function:     editor_attr_init

 $Description:  initialize parameters in the edit buffer

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
void editor_attr_init(MfwEdtAttr* attr, int zone_id, U8 mode, U8 *controls, char *text, U16 size )
{
    attr->win.px = 0;
    attr->win.py = 0;
    attr->win.sx = SCREEN_SIZE_X;//120;  /* 2003/12/22 sunsj modify for LCD width */
    /* 2004/01/04 sunsj moidfy for different lcd size */
    attr->win.sy = SCREEN_SIZE_Y-Mmi_layout_line_height() ;   //zgz, attr->win.sy = 48-Mmi_layout_line_height() ;
    attr->fgColor = 0xffffff;
    attr->font = 0;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
    attr->title_id = 0; 
    AllowPredText = FALSE;
}

/*******************************************************************************

 $Function:     editor_attr_init_only

 $Description:  Just initialize parameters in the edit buffer, Not consider the softkey's display area

 $Returns:    None.

 $Arguments: 
 $Author:		zgz,2002.07.02

*******************************************************************************/
void editor_attr_init_only(MfwEdtAttr* attr, U16 px, U16 py, U16 sx, U16 sy, U8 titleMode, int title_id, char *text, U16 size,U8 mode ,char *textnum)
{
    attr->win.px = px;
    attr->win.py = py;
    attr->win.sx = sx; 
    attr->win.sy = sy;
    attr->titleMode = titleMode;
    attr->title_id = title_id; 
    attr->text = text;
    attr->size = size;
    attr->mode = mode;
    attr->textnum = textnum;

    if( (titleMode == TITLE_ALL) || (titleMode == TITLE_ONLYTEXT) )
    {
        attr->win.py = py + Mmi_layout_line_height() + 1;  // 1 means the frame line position
        attr->win.sy = sy - Mmi_layout_line_height() - 1;
    }


    //set the default attribute
    attr->fgColor = 0xffffff;
    attr->font = 0;
}


/*******************************************************************************

 $Function:     editor_attr_init_fullscr

 $Description:   initialize parameters in the edit buffer,  consider the softkey's display area, Set the editor area to full screen

 $Returns:    None.

 $Arguments: 
 $Author:		zgz,2002.07.02

*******************************************************************************/

void editor_attr_init_fullscr(MfwEdtAttr* attr,  U8 titleMode, int title_id, char *text, U16 size , U8 mode)
{
    /* 2004/02/11 sunsj modify editor area */
#if(MAIN_LCD_SIZE==3)
	attr->win.px = 8;
	attr->win.py = 0;
    attr->win.sx = SCREEN_SIZE_X-4;//115;
	attr->win.sy = SCREEN_SIZE_Y-Mmi_layout_line_height()-4 ;
#elif(MAIN_LCD_SIZE==4)
    attr->win.px = 0;
	attr->win.py = 0;
    attr->win.sx = SCREEN_SIZE_X;//115;		/* 2003/12/22 sunsj modify for LCD width */
	attr->win.sy = SCREEN_SIZE_Y-Mmi_layout_line_height()-1 ; 
#endif
	
    attr->titleMode = titleMode;
    attr->title_id = title_id;
    attr->text = text;
    attr->size = size;
    attr->mode = mode;
    attr->textnum = NULL;
    attr->e_size = 0;   /* 2003/12/04 sunsj set ascii text size */

    if( titleMode )
    {
        
#if(MAIN_LCD_SIZE==3)
		attr->win.py = Mmi_layout_line_height() +2;  
		attr->win.sy = SCREEN_SIZE_Y - 2*Mmi_layout_line_height()-4;
#elif(MAIN_LCD_SIZE==4)
		attr->win.py = Mmi_layout_line_height() + 2;  
		attr->win.sy = SCREEN_SIZE_Y - 2*Mmi_layout_line_height();//-4;
#endif
    }

    //set the default attribute
    attr->fgColor = 0xe6ffff;
    attr->font = 0;

}
#ifdef EASY_TEXT_ENABLED
void editor_attr_init_pred(MfwEdtAttr* attr, int zone_id, U8 mode, U8 *controls, char *text, U16 size)
{
    attr->win.px = 0;
    attr->win.py = Mmi_layout_line_height();
    attr->win.sx = SCREEN_SIZE_X;//120;  /* 2003/12/22 sunsj modify for LCD width */
    /* 2004/01/04 sunsj modify for different lcd size */
    attr->win.sy = SCREEN_SIZE_Y-2*Mmi_layout_line_height() ;  //attr->win.sy = 48-2*Mmi_layout_line_height() ;
    attr->fgColor = 0;
    attr->font = 0;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
    AllowPredText = TRUE;
}

//returns true if next word after cursor ought to be capitalised
UBYTE capitalise_word(T_MFW_HND editor_handle)
{
    char LastChar;
    char CharBefore;

    LastChar = getCursorChar(editor_handle, -1);
    CharBefore = getCursorChar(editor_handle, -2);

    if( LastChar == '.' || LastChar == '!' || LastChar == '?' || LastChar == 0 )
        return TRUE;
    if( LastChar == ' ' )
        if( CharBefore == '.' || CharBefore == '!' || CharBefore == '?' )
            return TRUE;
    return FALSE;
}
#endif

//kk011107 #endif
#ifdef EASY_TEXT_ENABLED
/*******************************************************************************

 $Function:     eZitextIcon

 $Description:  Icon to be displayed if eZiText has been selected.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
int showeZiTextIcon(MfwMnu* m, MfwMnuItem* i)
{
    char buf[40];
    T_MFW_HND       win  = mfwParent(mfw_header());

    TRACE_EVENT ("showeZiTextIcon()");

    if( g_pcsyncstatus )//when pcsync run ,return,hxl add 2003-2-13
        return 1;

    if( Easy_Text_Available == TRUE )
    {
        if( FFS_flashData.PredTextSelected == TRUE )
        {
            T_DISPLAY_DATA display_info;

            dialog_info_init(&display_info);
            display_info.LeftSoftKey    = '\0';
            display_info.RightSoftKey   = '\0';
            display_info.TextId   = '\0';
            display_info.TextId2  = '\0';
            display_info.TextString = '\0';
            display_info.TextString2    = '\0';
            display_info.Time   = 4000;
            display_info.Callback = (T_VOID_FUNC)M_exeSendNew;
            display_info.KeyEvents  = 0;

            mmi_dialogs_insert_animation(info_dialog(win, &display_info), 400, (MfwIcnAttr*)&IconTexteZiText,1);
        }
        else if( FFS_flashData.PredTextSelected == FALSE )
        {
            M_exeSendNew(m,i);
        }
    }
    else
        M_exeSendNew(m,i);
}

/*******************************************************************************

 $Function:     EasyActivate

 $Description:  Icon to be displayed if eZiText has been selected.

 $Returns:    MFW_EVENT_CONSUMED.

 $Arguments:  None.

*******************************************************************************/
int Easy_Activate(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfwParent(mfw_header());
    T_DISPLAY_DATA display_info;

    if( FFS_flashData.PredTextSelected == FALSE )
    {
        FFS_flashData.PredTextSelected = TRUE;
        flash_write();

        dialog_info_init(&display_info);
        display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
        display_info.TextId     = TxtEasyText;
        display_info.TextId2    = TxtActivated;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';
        display_info.LeftSoftKey  = TxtNull;
        display_info.RightSoftKey = TxtNull;
        display_info.Time     = 3000;
        display_info.Callback   = (T_VOID_FUNC) NULL;

        info_dialog(win, &display_info);

        return MFW_EVENT_CONSUMED;
    }
}

/*******************************************************************************

 $Function:     EasyActivate

 $Description:  Icon to be displayed if eZiText has been selected.

 $Returns:    MFW_EVENT_CONSUMED.

 $Arguments:  None.

*******************************************************************************/
int Easy_DeActivate(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfwParent(mfw_header());
    T_DISPLAY_DATA display_info;

    if( FFS_flashData.PredTextSelected == TRUE )
    {
        FFS_flashData.PredTextSelected =  FALSE;
        flash_write();

        dialog_info_init(&display_info);
        display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
        display_info.TextId     = TxtEasyText;
        display_info.TextId2    = TxtDeActivated;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';
        display_info.LeftSoftKey  = TxtNull;
        display_info.RightSoftKey = TxtNull;
        display_info.Time     = 3000;
        display_info.Callback   = (T_VOID_FUNC) NULL;

        info_dialog(win, &display_info);

        return MFW_EVENT_CONSUMED;
    }
}
#endif

/*******************************************************************************

 $Function:    	nosimcard_animation_cb

 $Description:	Callback for information dialog (not used)n
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void nosimcard_animation_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN      * win_data  = ((T_MFW_HDR *)win)->data;
    T_EDITOR_INFO  * data      = (T_EDITOR_INFO *)win_data->user;

    data->edt_anim_win = 0;
    if( identifier == KCD_ABC )
    {
        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_ABC, NULL);
        win_show(data->edt_win); 
        return;
    }

    if( identifier != KCD_HUP )
    {
        edtChar(data->edt_edt, editControls[identifier]);
        win_show(data->edt_win); 
    }

    if( identifier == KCD_STAR )
        data->ss_string = TRUE;
}

/*******************************************************************************

 $Function:     editor_start

 $Description:  Common editor.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
T_MFW_HND editor_start (T_MFW_HND parent, T_EDITOR_DATA * editor_data)
{
    T_MFW_HND win;

    TRACE_EVENT ("editor_start()");

    /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
    //if (editForChineseInput)
    //    editForChineseInput=0;

    win = editor_create (parent);
    //set the e_size =0
    if( editor_data->editor_attr.e_size!=163 )
        editor_data->editor_attr.e_size=0;
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_EDITOR_INIT, 0, editor_data);
    }
    return win;
}

/*******************************************************************************

 $Function:     editor_create

 $Description:  Creation of an editor.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static T_MFW_HND editor_create (T_MFW_HND  parent)
{
    T_EDITOR_INFO *  data = (T_EDITOR_INFO *)ALLOC_MEMORY (sizeof (T_EDITOR_INFO));
    T_MFW_WIN     *  win;

    TRACE_EVENT ("editor_create()");

    /*
     * Create window handler
     */

    data->edt_win = win_create (parent, 0, E_WIN_VISIBLE, (T_MFW_CB)editor_win_cb);

    if( data->edt_win EQ NULL )
    {
        return NULL;
    }

    /*
     * connect the dialog data to the MFW-window
     */


    data->mmi_control.dialog = (T_DIALOG_FUNC)editor_exec_cb;
    data->mmi_control.data   = data;
    data->parent             = parent;
    win                      = ((T_MFW_HDR *)data->edt_win)->data;
    win->user                = (void *)data;
    g_norejectkeyflag=1;

    /*
     * return window handle
     */

    return data->edt_win;
}
/*******************************************************************************

 $Function:     editor_destroy

 $Description:  Destroy the editor.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
void editor_destroy (T_MFW_HND window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)window)->data;
    T_EDITOR_INFO * data = (T_EDITOR_INFO *)win->user;

    TRACE_EVENT ("editor_destroy()");

    if( data )
    {
        //GW Removed T9 reference
        //GW Removed T9 reference
        if( ((MfwHdr *)data->edt_edt)->type==MfwTypEdt )
        {
            AllowPredText = FALSE; //prevent any problems with new editors
            g_norejectkeyflag=0;

            /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
            //if (editForChineseInput)
            //    editForChineseInput=0;

            /* end KGT */

            /*
             * Delete WIN Handler
             */
            editDeactivate();

            ec_editDeactivate();  //zgz, 2002.7.5 Mobile Innovation

            /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
            /*zhangxp 2003-04-01 del all these little win*/
            //if (data->hz_input!=NULL)
            //    hz_destroy(data->hz_input);

            if( data->symbol_input!=NULL )
                keystar_destroy(data->symbol_input);
            /*end of zhangxp win*/
            win_delete (data->edt_win);
            /*
             * Free Memory
             */
            FREE_MEMORY ((void *)data, sizeof (T_EDITOR_INFO));
        }
        else
        {
            TRACE_EVENT("not a editor");
            return;
        }
    }
    else
    {
        TRACE_EVENT ("editor_destroy() called twice");
        return ;
    }
}

/*******************************************************************************

 $Function:     editor_exec_cb

 $Description:  Dialog function for editor.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void editor_exec_cb (T_MFW_HND win, USHORT event, SHORT value, T_EDITOR_DATA * editor_data)
{
    T_MFW_WIN      * win_data  = ((T_MFW_HDR *)win)->data;
    T_EDITOR_INFO  * data      = (T_EDITOR_INFO *)win_data->user;

    T_MFW_HND       parent_win = data->parent;
    USHORT          Identifier = data->editor_data.Identifier;
    T_EDIT_CB       Callback   = data->editor_data.Callback;
    UINT32           oldFontColor;
    //char EventSymbolChar = (char)value;

    TRACE_EVENT ("editor_exec_cb()");

    switch( event )
    {
    case E_EDITOR_INIT: 
        /*
         * Store data
         */

        data->editor_data = *editor_data;

        if( data->editor_data.TextString NEQ NULL )
        {
            memcpy (data->LabelText, data->editor_data.TextString, sizeof(data->LabelText));
        }
        /* Note that we do not copy the edited buffer here */
        //zgz,2002.0628 commend out it
        //data->editor_data.editor_attr.predText[0] = '\0';
        /*
         * Create the handler
         */
        data->edt_kbd      = kbd_create (data->edt_win, KEY_ALL,         (T_MFW_CB)editor_kbd_cb);
        data->edt_kbd_long = kbd_create (data->edt_win, KEY_ALL|KEY_LONG,(T_MFW_CB)editor_kbd_cb);
        data->edt_edt      = edtCreate  (data->edt_win, &data->editor_data.editor_attr,MfwEdtVisible,0);
        /* 2003/11/1 sunsj modify */
        data->edit_input     = NULL;//zhangxp2003-04-01 
        data->symbol_input = NULL;//zhangxp2003-04-01

        /*
         * Set the mode for the editor
         */
        data->destroyEditor = editor_data->destroyEditor;

        // c015 rsa
        /* create the timer handler */
        if( data->editor_data.timeout && (data->editor_data.timeout NEQ FOREVER) )
        {
            data->edt_tim      = tim_create (data->edt_win, data->editor_data.timeout, (T_MFW_CB)editor_tim_cb);
            tim_start (data->edt_tim);
        }
        else
        {
            data->edt_tim      = NULL;
        }
        // end c015 rsa

        /*************************************************
        
            zgz,2002.7.4 Add Mobile Innovation edit mode
            
        ***************************************************/
        switch( data->editor_data.mode )
        {
        /* 2003/12/04 sunsj remove */
        //case PARADISE_MODE:
        //case UPPERCASE_MODE:
        //case LOWERCASE_MODE:
        case SHUZI_MODE:
        case PHONENUMONLY_MODE:
#if 0
            if( ((data->editor_data.editor_attr.text[0]==0x80)&&(wstrlen(data->editor_data.editor_attr.text)>(data->editor_data.editor_attr.size-2))
                 ||(data->editor_data.editor_attr.text[0]!=0x80)&&(2*wstrlen(data->editor_data.editor_attr.text)>(data->editor_data.editor_attr.size-3)))
                &&(data->editor_data.mode==PARADISE_MODE) )
                data->editor_data.mode=UPPERCASE_MODE;//for change the mode for smssend	
#endif
            ec_editActivate(data->edt_edt,data->editor_data.mode);
            /* 2003/12/04 sunsj remove */
            /*
            if ( data->editor_data.mode==PARADISE_MODE )
                data->editor_data.hide  = FALSE;
            */
            if( data->editor_data.hide )              /* if hide is set, show '*' instead of numbers.  zhangxp,2003/4/8  */
            {
                editor_hideInit(data);                 /* initialize editor for hide                          */
                ec_editHiddenActivate(data->tmpBuf);   /* initialise multi-tap for hide */
            }
            data->edt_mode          = E_MOBILEINNOVATION_MODE;
            /* 2003/12/01 sunsj win_show have some problem, i think the screen was displaied twice */
            win_show(data->edt_win);

            /* 2003/11/1 sunsj turn on editor display flag */
            if( data->editor_data.edtInPbk == 1 )
            {
                MfwEdt *edt;
                edt = ((MfwHdr *) data->edt_edt)->data;
                edt->flags |= MfwEdtVisible;
            }


            //            			edtSymbol(data->edt_edt,ecBottom);//set the cursor to the last,we need't this
            //we set the cursor use the setcursor	

            return;
        case IPADDRESS_MODE:
            ec_editActivate(data->edt_edt,data->editor_data.mode);
            data->editor_data.hide  = FALSE; 
            data->edt_mode          = E_MOBILEINNOVATION_MODE;
            win_show(data->edt_win);
            edtSymbol(data->edt_edt,ecTop);
            return;
        case ONLYREAD_MODE:
            ec_editActivate(data->edt_edt,data->editor_data.mode);
            data->editor_data.hide  = FALSE;           /* don't allow hide for other modes than DIGITS_MODE.  */
            data->edt_mode          = E_MOBILEINNOVATION_MODE;   /* if editor is not called in T9 mode, set the normal  */
            data->editor_data.editor_attr.mode = 0; // sbh - read only mode has no cursor
            win_show(data->edt_win);

            edtSymbol(data->edt_edt,ecTop);
            return;
        default:
            break;

        }

        /*************************************************
        
            zgz,2002.7.4
            
        ***************************************************/

        set_ecinput_mode(0);  
        editActivate(data->edt_edt,data->editor_data.mode);

        // SH - format mode with *M or *m is just alpha mode with case preference

        if( data->editor_data.mode == FORMAT_MODE )
        {
            if( strcmp(data->editor_data.FormatString, "*M")==0 )
            {
                //data->editor_data.mode = ALPHA_MODE;
                upCase = TRUE;
                UPPER_CASE = FALSE;
            }
            if( strcmp(data->editor_data.FormatString, "*m")==0 )
            {
                //data->editor_data.mode = ALPHA_MODE;
                upCase = FALSE;
                UPPER_CASE = TRUE;
            }
        }

        // SH - end of format mode modification

        //KGT
        switch( data->editor_data.mode )
        {
        case READ_ONLY_MODE:
            data->editor_data.hide  = FALSE;           /* don't allow hide for other modes than DIGITS_MODE.  */
            data->edt_mode          = E_NORMAL_MODE;   /* if editor is not called in T9 mode, set the normal  */
            data->editor_data.editor_attr.mode = 0; // sbh - read only mode has no cursor
            win_show(data->edt_win);
            edtChar(data->edt_edt,ecTop);              /* in read-only mode set cursor to begin               */
            break;                                     /* editor mode                                         */

        case ALPHA_MODE:

#ifdef EASY_TEXT_ENABLED
            FFS_flashData.PredTextAvailable = TRUE;
            Initialize_Dict(/*ENGLISH*/1, 0);
            ResetDictSearch();
#endif
#ifndef EASY_TEXT_ENABLED
            //FFS_flashData.PredTextAvailable = FALSE;
            //FFS_flashData.PredTextSelected = FALSE;
#endif
            if( data->editor_data.hide )              /* if hide is set, show '*' instead of numbers.        */
            {
                editor_hideInit(data);                 /* initialize editor for hide                          */
                editHiddenActivate(data->tmpBuf);   /* initialise multi-tap for hide */
                data->editor_data.editor_attr.mode |= edtModOverWr; // Must be overwrite mode
            }
            data->edt_mode          = E_NORMAL_MODE;   /* if editor is not called in T9 mode, set the normal  */
            win_show(data->edt_win);
            edtChar(data->edt_edt,ecBottom);              /* in read-only mode set cursor to begin               */
            break;                                     /* editor mode                                         */
        case DIGITS_MODE:
            if( data->editor_data.hide )              /* if hide is set, show '*' instead of numbers.        */
                editor_hideInit(data);                 /* initialize editor for hide                          */
            data->edt_mode          = E_NORMAL_MODE;   /* if editor is not called in T9 mode, set the normal  */
            win_show(data->edt_win);
            edtChar(data->edt_edt,ecBottom);              /* in read-only mode set cursor to begin               */
            break;                    /* editor mode                                         */
            //GW Removed T9 reference
        case CALC_MODE:
            data->editor_data.hide  = FALSE;           /* don't allow hide for other modes than DIGITS_MODE.  */
            data->edt_mode          = E_NORMAL_MODE;   /* if editor is not called in T9 mode, set the normal  */
            win_show(data->edt_win);
            edtChar(data->edt_edt,ecBottom);
            break;
        case PIN_SECURITY:
            if( data->editor_data.hide )              /* if hide is set, show '*' instead of numbers.        */
                editor_hideInit(data);                 /* initialize editor for hide                          */
            data->edt_mode          = E_PIN_SECURITY;   /* spec. handling for PIN entering  */
            data->emergency_call = FALSE;
            data->ss_string = FALSE;
            edtChar(data->edt_edt,ecBottom);
            win_show(data->edt_win);
            //12.04 xsf moved it before win_show(data->edt_win); edtChar(data->edt_edt,ecBottom);
            break;
        case FORMAT_MODE:
            if( data->editor_data.hide )              /* if hide is set, show '*' instead of numbers.        */
            {
                editor_hideInit(data);                 /* initialize editor for hide                          */
                editHiddenActivate(data->tmpBuf);   /* initialise multi-tap for hide */
            }
            data->editor_data.editor_attr.mode |= edtModOverWr; // Must be overwrite mode
            data->edt_mode    = E_NORMAL_MODE;
            win_show(data->edt_win);
            edtChar(data->edt_edt,ecTop);         // Cursor is at start of string
            data->editor_data.formatIndex = -1;         // Current format character.  -1; increased to 0 in editCharFindNext below.
            data->editor_data.fieldIndex = 0;

            // Skip over any fixed characters that may be at start
            setFormatPointers (data->editor_data.FormatString, &(data->editor_data.formatIndex), &(data->editor_data.fieldIndex));
            TRACE_EVENT("Starting format mode");
            editCharFindNext(NULL);
            break;
        }
        // end KGT

        /* put the (new) dialog window on top of the window stack */
        break;

    case E_EDITOR_DEINIT:
        /* on DEINIT => selfdestroy; sendevent <value> */
		{
			T_MFW_HND oldparent = NULL;

			oldparent = data->parent;

        if( Callback )
            (Callback) (parent_win, Identifier, value);

        // MZ Destroy the text edit window after creating the number editor.
			if( data->parent == oldparent )
			{
        if( data->editor_data.destroyEditor == TRUE )
				{
            editor_destroy (data->edt_win);
				}
			}
		}
        break;

    case E_EDITOR_UPDATE:
        TRACE_EVENT("in editor update");
        if( value )
        {
            TRACE_EVENT("value is not zero");
            if( data->editor_data.edtInPbk )
            {
                (Callback) (parent_win, 2, INFO_EDT_UPDATE); 
                edtShow(data->edt_edt); 
            }
            //	win_show(data->edt_win);
            else edtShow(data->edt_edt);        
        }
        break;
#ifdef EASY_TEXT_ENABLED

        if( SymbolChar != '\0' )
        {
            //editActivate(data->edt_edt,data->editor_data.mode);
            edtShow(data->edt_edt);
            edtChar(data->edt_edt, SymbolChar);
            if( (SymbolChar == '.') ||(SymbolChar == '!') || (SymbolChar == '?') )
            {
                edtChar(data->edt_edt, ' ');
            }

            win_show(data->edt_win);
        }
        break;
#endif
    default:
        break;
    }
}
/*******************************************************************************

 $Function:     editor_win_cb

 $Description:  Editor window event handler.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static int editor_win_cb (T_MFW_EVENT event, T_MFW_WIN * win) 
{
    T_EDITOR_INFO * data = (T_EDITOR_INFO *)win->user;
    //zgz, 2002.8.27 add  for upper layer update
    T_MFW_HND       parent_win = data->parent;
    USHORT          Identifier = data->editor_data.Identifier;
    T_EDIT_CB       Callback   = data->editor_data.Callback;
    MfwHdr *edit_hdr=(MfwHdr *)data->edt_edt;
    MfwEdt *edit_controll=(MfwEdt *)edit_hdr->data;
    char Trace_data[10];    
    int currentTheme;
    //zgz, 2002.8.27 add  END
    UINT32 oldColor,oldFontColor;
    T_DISPLAY_DATA display_info;  //XSF ADD 12.03
    MMI_TRACE_EVENT(("sunsj-------------editor_win_cb()"));

    if( data EQ 0 )
    {
        return MFW_EVENT_CONSUMED;
    }

    //zgz,2002.7.5 Mobile Innovation
    if( data->edt_mode EQ E_MOBILEINNOVATION_MODE )
    {
        if( data->edt_edt != getactiveEditor() )
            ec_editActivate(data->edt_edt,data->editor_data.mode);
    }
    else
    {
        if( data->edt_edt!=activeEditor() )
            editActivate(data->edt_edt,data->editor_data.mode);

    }
    /* zgz,2002.7.5 Mobile Innovation     
          if (data->edt_edt!=activeEditor())
          editActivate(data->edt_edt,data->editor_data.mode);
    */      
    //editActivate(data->edt_edt,data->editor_data.mode);

    // SH - hidden mode

    if( data->editor_data.hide )
        editHiddenActivate(data->tmpBuf);

    // end hidden mode


    switch( event )
    {
    case E_WIN_VISIBLE: /* window is visible  */
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
             * Clear Screen
             */
            MmiTrace("edior_win_cb");
            if( Identifier==CARD_REJECTED )
            {
                //dspl_Clear(0, 0, 104, 16);
                //dspl_Clear(0, 16, 120, 160);
                /* 2004/06/08 sunsj modify */
                dspl_Clear(0, 0, SCREEN_SIZE_X, CHINESE_MENU_VERTICAL_SIZE);
            }
            /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
            /*else if (editForChineseInput)
            {
                TRACE_EVENT("exiting from chineseinput");
                if (wstrlen(data->editor_data.editor_attr.text) == 0)
                    displaySoftKeys(data->editor_data.LeftSoftKey, TxtSoftBack);
                else
                    displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
                return MFW_EVENT_CONSUMED;
            }*/
            else
            {
                dspl_ClearAll();
            }

            TRACE_EVENT("not exiting from chineseinput");

            if( Callback&&data->editor_data.edtInPbk )            //zgz add, 2002.8.27 indicate upper layer to update
                (Callback) (parent_win, 1, INFO_EDT_UPDATE);
            if( Callback && data->editor_data.Identifier==SMSREAD_EDIT )
                (Callback) (parent_win, 1, INFO_EDT_UPDATE);
            /*
             * Print the information
             */
#ifdef EASY_TEXT_ENABLED
            if( AllowPredText == TRUE && FFS_flashData.PredTextSelected == TRUE )
            {
                dspl_BitBlt(75,0,Mmi_layout_line_height(),Mmi_layout_line_height(),0,(char*)TextIconeZiTextSmall,0);
            }
#endif
            /****************************************************
            yq added to instead the edtshow
            ****************************************************/
            /*			edit_controll->attr->win.px=data->editor_data.editor_attr.win.px;
                        edit_controll->attr->win.py=data->editor_data.editor_attr.win.py;
                        edit_controll->attr->win.sx=data->editor_data.editor_attr.win.sx;
                        edit_controll->attr->win.sy=data->editor_data.editor_attr.win.sy;
                        if(wstrlen(data->editor_data.editor_attr.text)==0)
                            {
                                edit_controll->cp_curr_width=8;
                                edit_controll->cp_curr_x=data->editor_data.editor_attr.win.px;
                                edit_controll->cp_curr_y=data->editor_data.editor_attr.win.py;
                                edit_controll->cp_last_x=edit_controll->cp_curr_x;
                                edit_controll->cp_last_y=edit_controll->cp_curr_y;
                                edit_controll->cp=0;
                            }
                        else
                            {
                                edit_controll->cp_curr_width=8;
                                Setcursor(edit_controll,data->editor_data.editor_attr.text,data->editor_data.editor_attr.win);
                                dspl_TextOut(data->editor_data.editor_attr.win.px,data->editor_data.editor_attr.win.py,0,data->editor_data.editor_attr.text);			
                            }
                        inputIndicate_update(edit_controll);				
                        
                        dspl_DrawLine(edit_controll->cp_last_x,edit_controll->cp_last_y+15,edit_controll->cp_last_x+edit_controll->cp_curr_width-1,edit_controll->cp_last_y+15);
            /****************************************************
            end yq added
            ****************************************************/
            /* 2003/12/01 sunsj remove because edtshow will do the same thing */
            //updateWindow(edit_controll, 0);
            /* 2003/11/1 sunsj phone input need not display editor */
            if( data->editor_data.edtInPbk == 1 )
            {
                /* 2003/12/01 sunsj add update widow */
                updateWindow(edit_controll, 0);

                //2004-04-05 Sunny add
                edtShow(data->edt_edt);
            }
            else
            {
                edtShow(data->edt_edt);
            }
            /* 2003/11/10 sunsj */  
            if( wstrlen(edit_controll->attr->text)!=0&&(edit_controll->attr->mode)!=0&&(edit_controll->cp_curr_x!=15) )
                edtChar(data->edt_edt,ecBottom);
            /*
             * Print the label
             */
            //GW Removed T9 reference
            //GW Actually remove T9 ref, not code executed when T9 not enabled.
            /* 2003/11/1 sunsj modify title display */
            if( data->editor_data.TextId NEQ 0 )
            {
                if( data->editor_data.Identifier EQ CARD_REJECTED )  //xsf add 2002.10.24
                    PROMPT(10,22,0,data->editor_data.TextId);
                else
                {
                    /* 2004/01/14 sunsj modify for title */
#if 0
                    int title_x=0;
                    char *title;

                    currentTheme=FlashSettingData.theme;
                    //dspl_BitBlt(0, 0, menuup[currentTheme].area.sx, menuup[currentTheme].area.sy, 0, (void*)menuup[currentTheme].icons, 0);

                    title = (char *) MmiRsrcGetText(data->editor_data.TextId);
                    /*
                    if ( title != NULL )
                    {
                        title_x = get_StringWidth(title);
                        /* 2003/12/04 sunsj modify for global value
                        drawcolorclarity((SCREEN_SIZE_X-title_x)/2,1 ,title, 0x000000);
                    }
                    */
#endif
                    char *title;

                    title = (char *) MmiRsrcGetText(data->editor_data.TextId);
					/* 2004/05/19 sunsj remove */
                    //displayTitle( 0, title, 0, TITLE_MIDDLE, 0, 0);
                    //PROMPT(editor_menuArea.px,editor_menuArea.py,0,data->editor_data.TextId);
                }
            }
            else if( data->editor_data.TextString NEQ NULL )
            {
                /* sunsj modiyf for STK title */
				char spareNum[4];
				MfwEdt *edt = ((MfwHdr *) data->edt_edt)->data;
				if( getSymbolNumSpare(edt) >= 0 )
				{
					sprintf(spareNum, "%3d", getSymbolNumSpare(edt));
				}
				else
				{
					sprintf(spareNum, "%3d", 0);
				}
				/* 2004/04/22 sunsj modify */
				MMI_TRACE_EVENT(("sunsj------------there is no textstring"));
				//displayTitle( 0, data->LabelText, 0, TITLE_MIDDLE, 0, 0);
				displayTitle( 0, data->LabelText, spareNum, 4, 0, 0);
				/*
                if( data->editor_data.Identifier==SAT_SEND_SMS||data->editor_data.Identifier==SAT_SEND_SS
                    ||data->editor_data.Identifier==SAT_CALL_RESULT )
                    dspl_TextOut(editor_menuArea.px,editor_menuArea.py,0,data->LabelText);
                else
                {
                    currentTheme=FlashSettingData.theme;
                    dspl_BitBlt(0, 0, menuup[currentTheme].area.sx, menuup[currentTheme].area.sy, 0, (void*)menuup[currentTheme].icons, 0);
                    drawcolorclarity(editor_menuArea.px,editor_menuArea.py,data->LabelText,0x000000);
                }
				*/
                //  dspl_TextOut(editor_menuArea.px,editor_menuArea.py,0,data->LabelText);
                //dspl_TextOut(editor_menuArea.px,editor_menuArea.py,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_CURRENT_MODE	,data->editor_data.TextString);//zhaowm
            }
            /*
             oldColor=dspl_GetBkgColor();
             dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
             oldFontColor=dspl_GetFrgColor();
             dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));  
             */

            if( data->edt_mode == E_PIN_SECURITY )//xsf add for no simcard 11.28
            {
/* zhq, 2004/07/08, modified for we will use pin_outer_wait to init sub screen
and only refresh sub screen until main screen drawIdle. */
            	  main_sreen_init_complete = TRUE;
		  drawOuterIdle();
                if( !wstrlen(data->editor_data.editor_attr.text) && (data->edt_anim_win EQ 0) )
                {
                    dspl_SetBkgColor(0xffffff);
                    //dspl_Clear(10,50,100,100);                 
                    dialog_info_init(&display_info);
                    display_info.KeyEvents    = KEY_0|KEY_1|KEY_2|KEY_3|KEY_4|KEY_5|KEY_6|KEY_7|KEY_8|KEY_9|KEY_STAR|KEY_ABC;
                    display_info.TextId2       = TxtInvalidCard;  //TxtInvalidCard;
                    display_info.TextId      = 0;  
                    display_info.TextString   = 0; 
                    display_info.TextString2  = 0;  
                    display_info.LeftSoftKey  = '\0';
                    display_info.RightSoftKey = '\0';
                    display_info.Identifier  = StartAnimNoSimcard;
                    display_info.Time         = FOREVER;  
                    display_info.Callback     = (T_VOID_FUNC)nosimcard_animation_cb;
                    data->edt_anim_win = info_dialog (data->edt_win , &display_info);

		    /* 2004/07/13 sunsj modify */
                    mmi_dialogs_insert_fixmov_animation(data->edt_anim_win , 500 ,NOSIMCARDANIM);/*2003/12/16, wangyan modify*/  
                }
            }
            /*
             * Print the softkeys
             */
            if( data->edt_mode != E_PIN_SECURITY )
            {
#ifdef EASY_TEXT_ENABLED
                if( data->editor_data.editor_attr.predText[0] != '\0' && FFS_flashData.PredTextSelected == TRUE )
                    displaySoftKeys(TxtSoftOK, TxtDelete);
                else
#endif
                {
                    /* 2004/03/24 sunsj modify for softkey display*/
                    if( wstrlen(data->editor_data.editor_attr.text) < data->editor_data.min_enter ) // zgz, 2002.7.11 it should be changed. function strlen is wrong for unicode string
                    {
                        if( data->editor_data.edtInPbk )
                        {
                            if( wstrlen(data->editor_data.editor_attr.text) ==0 )
                                displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                            else
                                displaySoftKeys(data->editor_data.LeftSoftKey,TxtDelete);
                            (Callback) (parent_win, Identifier, INFO_EDT_UPDATE); 
                        }
                        else if( wstrlen(data->editor_data.editor_attr.text) == 0 && data->editor_data.edtInPbk==0 )
                        {
                            displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                        }
                        else if( data->editor_data.edtInPbk == 0 )/* entered less than the required number of chars: Alternate Softkey appears */
                        {
                            displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
                        }
                        else if( Callback&&(data->editor_data.edtInPbk) )
                        {
                            displaySoftKeys(TxtNull, TxtDelete);
                            (Callback) (parent_win, 0, INFO_EDT_UPDATE); 
                        }
                    }
                    else
                    {
                        /* 2004/03/24 sunsj modify for softkey display*/
                        if( data->editor_data.edtInPbk )
                        {
                            if( wstrlen(data->editor_data.editor_attr.text) ==0 )
                                displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                            else
                                displaySoftKeys(data->editor_data.LeftSoftKey,TxtDelete);
                            (Callback) (parent_win, Identifier, INFO_EDT_UPDATE); 
                        }
                        else if( wstrlen(data->editor_data.editor_attr.text) == 0 && data->editor_data.edtInPbk==0 )
                            displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                        else if( data->editor_data.edtInPbk == 0 )/* entered less than the required number of chars: Alternate Softkey appears */
                            displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
                        else if( Callback && (data->editor_data.edtInPbk) )             //zgz add, 2002.8.27 indicate upper layer to update
                        {
                            displaySoftKeys(TxtNull, TxtDelete);
                            (Callback) (parent_win, 0, INFO_EDT_UPDATE); 
                        }
                    }
                }
            }
            else
            {
                if( data->emergency_call EQ TRUE )
                {
                    displaySoftKeys(TxtSoftCall, data->editor_data.RightSoftKey);
                    TRACE_EVENT ("softkeys , call, delete");
                }
                else
                {
                    //no emergency_call
                    if( strlen(data->editor_data.editor_attr.text) < data->editor_data.min_enter )
                    {


                        if( strlen(data->editor_data.editor_attr.text) EQ 0 )
                            displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtNull);
                        else
                            displaySoftKeys(data->editor_data.AlternateLeftSoftKey, data->editor_data.RightSoftKey);

                        TRACE_EVENT ("softkeys , altern, delete");
                    }
                    else
                    {
                        if( strlen(data->editor_data.editor_attr.text) EQ 0 )
                            displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtNull);
                        else
                            displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);

                        TRACE_EVENT ("softkeys , ok, delete");
                    }
                }

            }
            /*
            dspl_SetBkgColor(oldColor);
            dspl_SetFrgColor(oldFontColor);
            */

        }
        break;
    default:
        return MFW_EVENT_PASSED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     editor_kbd_cb

 $Description:  Editor keyboard event handler

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static int editor_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_EDITOR_INFO *  data       = (T_EDITOR_INFO *)win_data->user;
    //T_CHINESE_DATA  chinese_data;       /* 2003/12/04 sunsj */

    T_MFW_HND       parent_win = data->parent;  //zgz add,2002.9.3
    USHORT          Identifier = data->editor_data.Identifier;   //zgz add,2002.9.3
    T_EDIT_CB       Callback   = data->editor_data.Callback;  //zgz add,2002.9.3
    MfwHdr *edit_hdr=(MfwHdr *)data->edt_edt;
    MfwEdt *edit_controll=(MfwEdt *)edit_hdr->data;
    MfwEdtAttr* edtattr=&data->editor_data.editor_attr;

    char* PredText = data->editor_data.editor_attr.predText;
    unsigned int editMode;
    char debug[25];

    unsigned int  cur_ecinput_mode;   //zgz,2002.7.9
    UINT32           oldFontColor;
    UBYTE old_mode;
    TRACE_EVENT("editor_kbd_cb");
    //old_mode=dspl_Enable(0);

    /* subpress unwanted longpresses (mfw throws more than one long press event for one long press on a key)*/
    if( !( event & KEY_LONG ) )
        DoNextLongPress = TRUE;         /* next Key_long event is correct */
    else if( DoNextLongPress )
        DoNextLongPress = FALSE;        /* mark Key_long event as consumed but do current long press */
    else if( !DoNextLongPress )
        return MFW_EVENT_CONSUMED;      /* don't do current long press */


    // c015 rsa
    if( data->edt_tim NEQ NULL )
    {
        /* restart the timer for no response */
        tim_stop  (data->edt_tim);
        tim_start (data->edt_tim);
    }
    // end c015 rsa

    /*  RM T9 integration 24-08
     *
     */
    editMode = data->edt_mode;
#ifdef EASY_TEXT_ENABLED
    if( FFS_flashData.PredTextSelected == FALSE || data->editor_data.mode != ALPHA_MODE )
#else
    if( 1 )
#endif
    {
        //TRACE_EVENT("Not in predictive mode");
        //sprintf(debug, "Key: %d", keyboard->code);
        //TRACE_EVENT(debug);
        switch( editMode )
        {
        case E_MOBILEINNOVATION_MODE:
            cur_ecinput_mode = get_ecinput_mode();
            if( event & KEY_LONG )
            {
                switch( keyboard->code )
                {
                case KCD_CALL:
                    //SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);                        	
                    break;
                case KCD_LEFT:
                    break;
                case KCD_MNUUP:
                    if( cur_ecinput_mode NEQ ONLYREAD_MODE &&
                        !data->editor_data.hide )
                        //GW Removed T9 code.
                        break;
                case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
				case KCD_CLEAR:
#endif
                    if( data->editor_data.editor_attr.text[0] NEQ '\0' )
                    {
                        if( data->editor_data.hide )
                            editor_hideClearAll(data);
                        else
                        {
                            /* clear the whole buffer */
                            //data->editor_data.editor_attr.text[0] = '\0';
                            memset(data->editor_data.editor_attr.text, 0, sizeof(data->editor_data.editor_attr.text));
                            //edtHide(data->edt_edt);	// zgz added, 2002.04.29
                            //       edtSymbol(data->edt_edt,ecTop); //zgz, 2002.7.2 edtChar(data->edt_edt,ecTop);
                            //edtClear(data->edt_edt);
                            // edtUnhide(data->edt_edt);	// zgz added, 2002.04.29


                            win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                    }
                    else
                    {
                        /* leave editor if buffer already empty */
                        TRACE_EVENT("yq:event for long right");
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);
                    }
                    break;

                case KCD_0: /* '+' key */
                    /* 2003/12/04 sunsj modify for new editor */
                    if( (cur_ecinput_mode NEQ ONLYREAD_MODE) /*&& (cur_ecinput_mode NEQ PARADISE_MODE)*/ ) /* ignore normal keys if in read-only mode */
                    {
                        if( data->editor_data.hide )

                            editor_hideClear(data); /* remove the '0' */

                        else
                        {
                            edtSymbol(data->edt_edt,ecBack);  //zgz,2002.7.2 edtChar(data->edt_edt,ecBack); /* remove the '0' */
                            edtSymbol(data->edt_edt,'+');  //zgz,2002.7.2 edtChar(data->edt_edt,'+');    /* insert the '+' */
                            displayedtsoftkey(win);//       win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                    }
                    break;
                case KCD_HASH:
                    if( (cur_ecinput_mode EQ PHONENUMONLY_MODE) || (cur_ecinput_mode EQ SHUZI_MODE) )
                    {
                        edtSymbol(data->edt_edt,ecBack);  //zgz,2002.7.2 edtChar(data->edt_edt,ecBack); /* remove the '0' */
                        edtSymbol(data->edt_edt,'p');  //zgz,2002.7.2 edtChar(data->edt_edt,'+');    /* insert the '+' */
                        displayedtsoftkey(win);//        win_show(data->edt_win); /* in order to update the Softkeys */

                    }
                    break;

                default:

                    return MFW_EVENT_CONSUMED; /* we don't handle other long presses here */


                }
            }
            else
            {
                switch( keyboard->code )
                {
                case KCD_CALL:
                    //SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);                        	
                    break;
                    //zgz, 2002.5.15  add the up or down one line key process
                case KCD_VOLUP:
                case KCD_MNUUP:
                    TRACE_EVENT("haha,yanqing pressed the up");
                    if( data->editor_data.edtInPbk )
                    {
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TOPREV_EDT, NULL);
                    }
                    else if( !data->editor_data.hide )
                        edtSymbol(data->edt_edt,ecUp);
                    break;

                case KCD_VOLDOWN:
                case KCD_MNUDOWN:
                    TRACE_EVENT("yanqing,you pressed the down");
                    if( data->editor_data.edtInPbk )
                    {
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TONEXT_EDT, NULL);
                    }
                    else if( !data->editor_data.hide )
                        edtSymbol(data->edt_edt,ecDown);
                    break;

                case KCD_MNULEFT:
                    if( cur_ecinput_mode EQ ONLYREAD_MODE )
                        edtSymbol(data->edt_edt,ecUp);
                    else if( cur_ecinput_mode EQ IPADDRESS_MODE )
                    {
                        if( findprechar()=='.' )
                        {
                            edtSymbol(data->edt_edt,ecLeft);
                            edtSymbol(data->edt_edt,ecLeft);
                        }
                        else edtSymbol(data->edt_edt,ecLeft);
                    }
                    else if( !data->editor_data.hide )
                        edtSymbol(data->edt_edt,ecLeft);
                    break;

                case KCD_MNURIGHT:
                    if( cur_ecinput_mode EQ ONLYREAD_MODE )
                        edtSymbol(data->edt_edt,ecDown);
                    else if( cur_ecinput_mode EQ IPADDRESS_MODE )
                    {
                        if( findnextchar()=='.' )
                        {
                            edtSymbol(data->edt_edt,ecRight);
                            edtSymbol(data->edt_edt,ecRight);
                        }
                        else edtSymbol(data->edt_edt,ecRight);
                    }
                    else if( !data->editor_data.hide )
                        edtSymbol(data->edt_edt,ecRight);
                    break;

                case KCD_OK:
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
                    if( In_QQ )
                    {//hxl add for qq,2003-3-2
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_OK, NULL);
                        break;
                    }
#endif
                case KCD_LEFT:
                    /* 2004/04/13 sunsj add for password editor */
                    if( data->editor_data.hide == 1 )
                    {
                        memcpy(data->editor_data.editor_attr.text, data->tmpBuf, data->editor_data.editor_attr.size);
                    }

                    if( wstrlen(data->editor_data.editor_attr.text) < data->editor_data.min_enter )
                    {
                        /* entered less than the required number of chars */
                        if( data->editor_data.AlternateLeftSoftKey NEQ TxtNull )
                        {
                            /* an alternate softkey were defined: execute it*/
                            SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_ALTERNATELEFT, NULL);
                        }
                        else
                        {  //zgz add,2002.9.3 this else sentence only for phbk editing
                            if( data->editor_data.edtInPbk )
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                        }
                    }
                    else if( data->editor_data.LeftSoftKey NEQ TxtNull )
                    {
                        /* 2003/11/10 sunsj */
                        edit_controll->cp_curr_x=15;
                        /* left Softkey is enabled (and entered sufficient number of chars): execute it */
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                    }
                    else
                    {
                        /* NOP */
                        /* entered less than the required number of chars */
                        if( data->editor_data.AlternateLeftSoftKey NEQ TxtNull )
                        {
                            /* an alternate softkey were defined: execute it*/
                            SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_ALTERNATELEFT, NULL);
                        }
                        else
                        {  //zgz add,2002.9.3 this else sentence only for phbk editing
                            if( data->editor_data.edtInPbk )
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                        }
                    }

                    break;

                case KCD_HUP:
                    if( data->editor_data.RightSoftKey NEQ TxtNull )
                    {
                        /* Right softkey is enabled: execute it */
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_HUP, NULL);
                    }
                    break;

                case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
				case KCD_CLEAR:
#endif
                    if( !((data->editor_data.LeftSoftKey == TxtNull)&&(data->editor_data.RightSoftKey == TxtNull)&&
                          ((data->editor_data.Identifier == SAT_SEND_SMS)||
                           (data->editor_data.Identifier == SAT_SEND_SS)||
                           (data->editor_data.Identifier == SAT_CALL_RESULT))) ) //zhaowm 2003.1.4
                    {
                        char unicode_head = 0x80;
                        if( cur_ecinput_mode NEQ ONLYREAD_MODE ) /* ignore clear key if in read-only mode */
                        {
                            /* 2003/11/1 sunsj modify */
                            if( (data->editor_data.editor_attr.text[0] == unicode_head && ((data->editor_data.editor_attr.text[1] NEQ '\0') || (data->editor_data.editor_attr.text[2] NEQ '\0'))) 
                                || data->editor_data.editor_attr.text[0] NEQ '\0' )
                            //if (data->editor_data.editor_attr.text[0] NEQ '\0' && ((data->editor_data.editor_attr.text[1] NEQ '\0') || (data->editor_data.editor_attr.text[2] NEQ '\0')))
                            {
                                /* buffer is not empty, delete the char before the cursor */
                                if( cur_ecinput_mode EQ IPADDRESS_MODE )
                                {
                                    if( findprechar()=='.'&&findnextchar()==0 )
                                    {
                                        edtSymbol(data->edt_edt, ecBack);
                                        edtSymbol(data->edt_edt, ecBack);
                                    }
                                    else if( findnextchar()==0 )
                                        edtSymbol(data->edt_edt, ecBack);

                                    break;

                                }
                                else edtSymbol(data->edt_edt, ecBack);
                                displayedtsoftkey(win);

                            }
                            else
                            {
                                /* leave editor if buffer already empty */
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);
                            }
                        }
                        else
                            SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);

                    }
                    break;                      


                case KCD_HASH:
                    if( (((MfwEdt *)((MfwHdr *)data->edt_edt)->data)->attr->titleMode == 1) ||(((MfwEdt *)((MfwHdr *)data->edt_edt)->data)->attr->titleMode == TITLE_TOP) )
                    {

                        if( (cur_ecinput_mode NEQ ONLYREAD_MODE) && (cur_ecinput_mode NEQ PHONENUMONLY_MODE) )
                        {
                            /* 2003/12/04 sunsj remove */
#if 0
                            switch_ecinput_mode();  // switch the input method
                            if( (get_ecinput_mode() == PARADISE_MODE)&&data->editor_data.hide )
                                switch_ecinput_mode();

                            if( get_ecinput_mode() == PARADISE_MODE )
                            {
                                if( getSymbolNumSpare(((MfwHdr *) data->edt_edt)->data) == -1 )
                                {
                                    show_error_info(win);
                                    switch_ecinput_mode();
                                }
                                else inputIndicate_update(((MfwHdr *) data->edt_edt)->data) ;

                            }
                            else inputIndicate_update(((MfwHdr *) data->edt_edt)->data) ;       // update the input method indicate area
#endif
                        }
                        else if( cur_ecinput_mode EQ PHONENUMONLY_MODE )
                        {
                            edtSymbol(data->edt_edt, '#');
                            //edtSymbol(data->edt_edt,ecRight);
                            displayedtsoftkey(win);
                        }
                    }
                    else
                    {
                        if( (cur_ecinput_mode NEQ ONLYREAD_MODE) && (cur_ecinput_mode NEQ PHONENUMONLY_MODE) )
                        {
                            /* 2003/12/04 sunsj remove */
#if 0
                            switch_ecinput_mode();  // switch the input method
                            if( (get_ecinput_mode() == PARADISE_MODE)&&data->editor_data.hide )
                                switch_ecinput_mode();

                            if( get_ecinput_mode() == PARADISE_MODE )
                            {
                                if( getSymbolNumSpare(((MfwHdr *) data->edt_edt)->data) == -1 )
                                {
                                    show_error_info(win);
                                    switch_ecinput_mode();
                                }

                            }
#endif
                        }
                        else if( cur_ecinput_mode EQ PHONENUMONLY_MODE )
                        {
                            edtSymbol(data->edt_edt, '#');  
                            //edtSymbol(data->edt_edt,ecRight);
                            displayedtsoftkey(win);
                        }
                    }
                    break;
                case KCD_STAR:
		    /* 2004/06 23 sunsj modify for editor */
                    if( cur_ecinput_mode EQ PHONENUMONLY_MODE )
                    {
                        edtSymbol(data->edt_edt, '*');
                        //edtSymbol(data->edt_edt,ecRight);
                    }
                    displayedtsoftkey(win);
                    break;
                    /* 2003/11/10 sunsj if close screen return to idle */
                case KCD_F4:
                    {
                        if( !HallStatus() )
                        {
                            returntoidle(1);
                        }
                    }
                    break;

                default: /* any key */ //zgz, such as 0123456789
                    if( keyboard->code>KCD_9 )
                        break;
                    if( cur_ecinput_mode NEQ ONLYREAD_MODE ) /* ignore normal keys if in read-only mode */
                    {
                        /* 2003/12/04 sunsj modify */
                        ec_editEventKey(event,keyboard);
#if 0
                        if( cur_ecinput_mode NEQ PARADISE_MODE && cur_ecinput_mode NEQ STROKE_MODE )
                        {
                            ec_editEventKey(event,keyboard);
                        }
                        else if( keyboard->code>0&&getSymbolNumSpare(edit_controll)>0 )
                        {
                            /* 2003/10/13 sunsj/ replace hz input method */
                            chinese_data.LeftSoftKey= data->editor_data.LeftSoftKey;
                            chinese_data.DestroyEditor= data->editor_data.destroyEditor;
                            chinese_data.Identifier = data->editor_data.Identifier;
                            chinese_data.Callback   = data->editor_data.Callback;
                            /* 2003/11/27 sunsj */
                            //chinese_data.EditorSize = 160;
                            chinese_data.EditorSize = data->editor_data.editor_attr.size;

                            chinese_data.TextString = data->editor_data.editor_attr.text;
                            /* 2003/11/10 sunsj set text cursor */
                            chinese_data.Cursor     = edit_controll->cp;

                            /* 2003/11/27 sunsj set phone book input flag */
                            chinese_data.edtInPbk = data->editor_data.edtInPbk;

                            /* 2003/10/26 sunsj add for pinyin and stroke mode */
                            if( cur_ecinput_mode == PARADISE_MODE )
                            {
                                chinese_data.InputMode = PINYIN_INPUT_MODE;
                            }
                            else if( cur_ecinput_mode == STROKE_MODE )
                            {
                                chinese_data.InputMode = STROKE_INPUT_MODE;
                            }
                            /* 2003/11/10 sunsj don't set cursor to bottom */
                            edit_controll->cp_curr_x=15;

                            /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
                            //data->hz_input=hz_start(win, keyboard);//zhangxp2003-04-01

                            /* 2003/11/1 sunsj modify */
                            data->edit_input=chinese_input(win, &chinese_data, (SHORT)keyboard->code);
                            break;
                        }
#endif
                        displayedtsoftkey(win);
                    }
                    break;

                }
            }
            break;
        case E_NORMAL_MODE:

            /*  Ende RM T9 integration 24-08
             *
             */


            if( event & KEY_LONG )
            {
                switch( keyboard->code )
                {
                case KCD_CALL:
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);                         
                    break;
                case KCD_LEFT:
                    break;
                case KCD_MNUUP:
                    if( data->editor_data.mode NEQ READ_ONLY_MODE &&
                        !data->editor_data.hide )
                        //GW Removed T9 code.
                        break;
                case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
				case KCD_CLEAR:
#endif
                    // SH - special clear all for format mode

                    if( data->editor_data.mode EQ FORMAT_MODE )
                    {
                        editClear();
                    }

                    // SH - End of format mode modification

                    else if( data->editor_data.editor_attr.text[0] NEQ '\0' )
                    {
                        /* clear the whole buffer */
                        //KGT
                        if( data->editor_data.hide )
                            editor_hideClearAll(data);
                        else
                        // end KGT
                        {
                            data->editor_data.editor_attr.text[0] = '\0';

                            edtHide(data->edt_edt); // zgz added, 2002.04.29
                            edtSymbol(data->edt_edt,ecTop); //zgz, 2002.7.2 edtChar(data->edt_edt,ecTop);
                            edtUnhide(data->edt_edt);   // zgz added, 2002.04.29

                            if( data->editor_data.min_enter > 0 )
                            {

                                win_show(data->edt_win); /* in order to update the Softkeys */
                            }
                            else
                            {
                                edtShow(data->edt_edt);
                            }
                        }
                    }
                    else
                    {
                        /* leave editor if buffer already empty */
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);
                    }
                    break;

                case KCD_0: /* '+' key */
                    if( data->editor_data.mode NEQ READ_ONLY_MODE ) /* ignore normal keys if in read-only mode */
                    {
                        if( data->editor_data.hide )
                        {
                            /* in hidden mode do not allow entering of '+' */
                            //KGT
                            //edtChar(data->edt_edt,ecBack); /* remove the '0' */
                            editor_hideClear(data); /* remove the '0' */
                            // end KGT
                        }
                        else
                        {
                            edtSymbol(data->edt_edt,ecBack);  //zgz,2002.7.2 edtChar(data->edt_edt,ecBack); /* remove the '0' */
                            edtSymbol(data->edt_edt,'+');  //zgz,2002.7.2 edtChar(data->edt_edt,'+');    /* insert the '+' */
                            if( data->editor_data.min_enter > 0 )
                            {
                                win_show(data->edt_win); /* in order to update the Softkeys */
                            }
                            else
                            {
                                edtShow(data->edt_edt);
                            }
#if 0  //JVJE
                            if( (data->editor_data.mode == DIGITS_MODE) &&
                                (data->editor_data.editor_attr.size == 2) )
                            {
                                /* "single digit key request" returns immediately on any normal key */
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                            }
#endif
                        }
                    }
                    break;

                default:
                    {
                        // change the Lowercase to Uppercase and visa-versa
                        //only possible in Alpha mode (SH - or format mode)
                        if( data->editor_data.mode EQ ALPHA_MODE || data->editor_data.mode EQ FORMAT_MODE )
                        {
                            if( UPPER_CASE EQ FALSE )
                            {
                                TRACE_EVENT("UPPER_CASE EQ FALSE");
                                UPPER_CASE = TRUE;
                                upCase = FALSE;
                                displaySoftKeys_edition (TxtLowercase ,TxtNull,TxtNull);
                            }
                            else
                            {
                                TRACE_EVENT("UPPER_CASE EQ TRUE");
                                UPPER_CASE = FALSE;
                                upCase = TRUE;
                                displaySoftKeys_edition (TxtUppercase ,TxtNull,TxtNull);
                            }
                            if( data->editor_data.mode NEQ FORMAT_MODE ) // SH - for format mode, don't erase the character
                            {
                                edtChar(data->edt_edt,ecBack);
                                editEventKey(event,keyboard);  // zgz, 2002.05.15
                                if( data->editor_data.min_enter > 0 )
                                {
                                    win_show(data->edt_win); /* in order to update the Softkeys */
                                }
                                else
                                {
                                    edtShow(data->edt_edt);
                                }
                            }
                        }


                    }
                    return MFW_EVENT_CONSUMED; /* we don't handle other long presses here */


                }
            }
            else
            {
                switch( keyboard->code )
                {
                case KCD_CALL:
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);                         
                    break;
                    //zgz, 2002.5.15  add the up or down one line key process
                case KCD_VOLUP:
                case KCD_MNUUP:
                    if( !data->editor_data.hide )       // SH - key not available in hide mode
                    {
                        //zgz,2002.0627 edtChar(data->edt_edt,ecUp);
                        edtSymbol(data->edt_edt,ecUp);

                    }
                    break;

                case KCD_VOLDOWN:
                case KCD_MNUDOWN:
                    if( !data->editor_data.hide )
                    {
                        //zgz,2002.0627edtChar(data->edt_edt,ecDown);
                        edtSymbol(data->edt_edt,ecDown);
                    }
                    break;

                case KCD_MNULEFT:
                    if( data->editor_data.mode EQ READ_ONLY_MODE )
                        edtChar(data->edt_edt,ecUp);
                    else if( !data->editor_data.hide )       // SH - key not available in hide mode
                    {

                        /* SH - format mode, skip over fixed characters */

                        if( data->editor_data.mode EQ FORMAT_MODE )  // formatted input
                        {
                            TRACE_EVENT("MNUUP");
                            editCharFindNext(ecRight);  // Insert character & move cursor forward once
                        }

                        /* end of format mode modification */

                        else
                        {
                            TRACE_EVENT("MNUUP, not format mode");
                            //zgz,2002.0627edtChar(data->edt_edt,ecLeft);
                            edtSymbol(data->edt_edt,ecLeft);
                        }
                    }

                    edtShow(data->edt_edt);
                    break;

                case KCD_MNURIGHT:
                    if( data->editor_data.mode EQ READ_ONLY_MODE )
                        edtChar(data->edt_edt,ecDown);
                    else if( !data->editor_data.hide )       // SH - key not available in hide mode
                    {

                        /* SH - format mode, skip over fixed characters */

                        if( data->editor_data.mode EQ FORMAT_MODE )  // formatted input
                        {
                            TRACE_EVENT("MNUDOWN,  format mode");
                            editFindPrev();             // find previous non-fixed character
                        }

                        /* end of format mode modification */

                        else
                        {
                            TRACE_EVENT("MNUDOWN,   not format mode");
                            //zgz,2002.0627edtChar(data->edt_edt,ecRight);
                            edtSymbol(data->edt_edt,ecRight);
                        }
                    }
                    edtShow(data->edt_edt);
                    break;

                case KCD_OK:
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
                    if( In_QQ )
                    {
                        //hxl add for qq,2003-3-2
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_OK, NULL);
                        break;
                    }
#endif
                case KCD_LEFT:
                    if( strlen(data->editor_data.editor_attr.text) < data->editor_data.min_enter )
                    {
                        /* entered less than the required number of chars */
                        if( data->editor_data.AlternateLeftSoftKey NEQ TxtNull )
                        {
                            /* an alternate softkey were defined: execute it*/
                            SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_ALTERNATELEFT, NULL);
                        }
                    }
                    else if( data->editor_data.LeftSoftKey NEQ TxtNull )
                    {
                        /* left Softkey is enabled (and entered sufficient number of chars): execute it */
                        //KGT
                        /* get the orginal text back into the editor instead of the
                           hide buffer ( only filled with '*') */
                        if( data->editor_data.hide )
                            editor_hideTerminate(data);
                        //end KGT
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                    }
                    else
                    {
                        /* NOP */
                    }
                    break;

                case KCD_HUP:
                    if( data->editor_data.RightSoftKey NEQ TxtNull )
                    {
                        /* Right softkey is enabled: execute it */
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_HUP, NULL);
                    }
                    break;

                case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
				case KCD_CLEAR:
#endif
                    if( data->editor_data.mode NEQ READ_ONLY_MODE ) /* ignore clear key if in read-only mode */
                    {
                        if( data->editor_data.editor_attr.text[0] NEQ '\0' )
                        {
                            /* buffer is not empty, delete the char before the cursor */
                            //KGT
                            if( data->editor_data.hide )
                                editor_hideClear(data);
                            else
                            //end KGT
                            {

                                /* SH - format mode, skip over fixed characters */

                                if( data->editor_data.mode EQ FORMAT_MODE )          // SH - formatted input
                                {
                                    switch( editFindPrev() )                 // Skip over fixed characters
                                    {
                                    case 1:
                                        edtChar(data->edt_edt,' ');           // overwrite with space
                                        edtChar(data->edt_edt,ecLeft);          // Move cursor left again
                                        break;
                                    case 2:
                                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);  // Exit editor
                                        break;
                                    case 3:
                                        edtChar(data->edt_edt,ecRight); // Last character - shorten string
                                        edtChar(data->edt_edt,ecBack);
                                        break;
                                    }

                                }

                                /* end of format mode modification */

                                else
                                {
                                    //zgz,2002.06.27 edtChar(data->edt_edt,ecBack);
                                    edtSymbol(data->edt_edt, ecBack);
                                }
                                if( data->editor_data.min_enter > 0 )
                                {
                                    win_show(data->edt_win); /* in order to update the Softkeys */
                                }
                                else
                                {
                                    edtShow(data->edt_edt);
                                }
                            }
                        }
                        else
                        {
                            /* leave editor if buffer already empty */
                            SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);
                        }
                    }
                    else
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);

                    break;
#ifdef EASY_TEXT_ENABLED
                case (KCD_HASH):
                    { if( AllowPredText == TRUE )
                            if( FFS_flashData.PredTextAvailable == TRUE )
                            {
                                FFS_flashData.PredTextSelected = TRUE;
                                win_show(data->edt_win);
                                break;
                            }

                        {
                            editEventKey(event,keyboard);
                            if( data->editor_data.min_enter > 0 )
                            {
                                win_show(data->edt_win); /* in order to update the Softkeys */
                            }
                            else
                            {
                                edtShow(data->edt_edt);
                            }
                        }
                    }
                    break;
#endif
                    // zgz, 2002.7.4 debug
#ifdef 	_ZGZ_EDITOR_DEBUG
                case KCD_STAR:
                    SymbolScreenstart (data->edt_win, 0);
                    break;
#endif					
                    /* 2004/04/06 sunsj add for close sub-lcd in normal mode */
                case KCD_F4:
                    {
                        if( !HallStatus() )
                        {
                            returntoidle(1);
                        }
                    }
                    break;
                default: /* any key */
                    if( keyboard->code>KCD_9 )
                        break;
                    if( data->editor_data.mode NEQ READ_ONLY_MODE ) /* ignore normal keys if in read-only mode */
                    {
                        //KGT
                        /*if ( data->editor_data.hide )
                          {
                            editor_hideInsert(data,keyboard->code);
                            TRACE_EVENT(data->editor_data.editor_attr.text);
                          }

                        //editor_hideEdtChar(data,ecBack);
                        else*/
                        //end KGT
                        {
                            /* SH - format mode, setup pointers to format string & index */

                            if( data->editor_data.mode EQ FORMAT_MODE )
                            {
                                setFormatPointers (data->editor_data.FormatString, &(data->editor_data.formatIndex),
                                                   &(data->editor_data.fieldIndex));
                            }

                            /* End of format mode modification */

                            editEventKey(event,keyboard);
                            if( data->editor_data.min_enter > 0 )
                            {
                                win_show(data->edt_win); /* in order to update the Softkeys */
                            }
                            else
                            {
                                //edtShow(data->edt_edt); // zgz, 2002.5.15  it is not necessary
                            }
#if 0  //JVJE

                            if( (data->editor_data.mode == DIGITS_MODE) && (data->editor_data.editor_attr.size == 2) )
                            {
                                /* "single digit key request" returns immediately on any normal key */
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                            }
#endif
                        }
                    }
                    break;
                }
            }

            break; //GW Replaced missing break   //zgz,2002.7.5 end of case E_NORMAL_MODE:
            //GW Removed T9 code.

            /*  E_PIN_SECURITY entering
             *
             */

        case E_PIN_SECURITY:

            switch( keyboard->code )
            {
            //hxl add for charger icon 2002-9-25---------------------------
            case KCD_ABC:
                MmiTrace("edior_kcd_abc");
                /* deal with the charger virtual key */
                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_ABC, NULL);
                break;
            case KCD_POWER:
                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_HUP, NULL);
                break;
                //end of hxl add for charger icon 2002-9-25--------------------------
            case KCD_MNUUP:
            case KCD_MNULEFT:
            case KCD_MNURIGHT:
            case KCD_VOLUP:
            case KCD_VOLDOWN:
            case KCD_F3:                 
                break;

            case KCD_MNUDOWN:
                break;

            case KCD_STAR:

                //only possible when the first digit is a '*'
                //if (strlen(data->editor_data.editor_attr.text) EQ 0 && data->editor_data.hide)
                if( strlen(data->editor_data.editor_attr.text) EQ 0 )  //xsf changed 2002.10.24
                {
                    data->ss_string = TRUE;
                    //the string should be visible on screen
                    data->editor_data.hide = FALSE;
                    //xsf remarked it 2002.10.24 editEventKey(event,keyboard);
                    edtChar(data->edt_edt, editControls[keyboard->code]);
                    win_show(data->edt_win);
                }
                break;

            case KCD_HASH:

                if( data->ss_string )
                {
                    T_MFW_SS_RETURN ssRes;

                    //xsf remarked it 2002.10.24 editEventKey(event,keyboard);
                    edtChar(data->edt_edt, editControls[keyboard->code]);

                    //      if ( strcmp((char*)data->editor_data.editor_attr.text, "*#520#") == 0 )
#if (MAIN_LCD_SIZE==3)                  
					if( strcmp((char*)data->editor_data.editor_attr.text, "*#188#") == 0 )/*2003/12/1, wangyan modify*/
#elif (MAIN_LCD_SIZE==4)
					if( strcmp((char*)data->editor_data.editor_attr.text, "*746*837#") == 0 )/*2003/12/1, wangyan modify*/
#endif
					{
                     
						//ShowVersion(0);	

                        //                     bookMenuStart( data->edt_win, menuSpecialModeAttributes(), NULL);
                        //bookMenuStart( data->edt_win, menuSpecialModeAttributes(), Phbksoftversion); /*2003/12/1, wangyan modify*/
                        ShowVersiondialog(win);/*2004/05/10, wangyan modify*/
                        return MFW_EVENT_CONSUMED;

                    }
#ifdef	_ENCRYPT_
                    else if( strcmp((char*)data->editor_data.editor_attr.text, "*#07#") == 0 )/*2003/12/1, wangyan modify*/
                    {
                        //ShowVersion(0);	

                        //bookMenuStart( data->edt_win, menuSpecialModeAttributes(), NULL);
                        //bookMenuStart( data->edt_win, menuSpecialModeAttributes(), Phbksoftversion); /*2003/12/1, wangyan modify*/
			Encrypt_Main(0);
			return MFW_EVENT_CONSUMED;
                    }
#endif
                    else
                    {
                        ssRes = ss_check_ss_string((UBYTE*)data->editor_data.editor_attr.text);
                        switch( ssRes )
                        {
                        case MFW_SS_MMI:
                            get_imei((char*)data->imei);
                            //editor_hideClearAll(data);
                            showIMEI(win,(char*)data->imei);                   

                            //set back to the default
                            data->ss_string = FALSE;

                            // go back in the hide mode
                            //xsf remarked it 2002.10.24 data->editor_data.hide = TRUE;

                            return MFW_EVENT_CONSUMED;
                        }
                    }

                }
                else if( strlen(data->editor_data.editor_attr.text) >= data->editor_data.min_enter )
                {
                    if( data->editor_data.hide )
                        editor_hideTerminate(data);
                    TRACE_EVENT("press hash");
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                }
                break;
            case KCD_OK:
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
                if( In_QQ )
                {//hxl add for qq,2003-3-2
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_OK, NULL);
                    break;
                }
#endif
            case KCD_LEFT:

                if( data->emergency_call EQ TRUE )
                {
                    TRACE_EVENT("press left  < min");
                    /* get the orginal text back into the editor instead of the hide buffer ( only filled with '*') */

                    if( data->editor_data.hide )
                        editor_hideTerminate(data);
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_EMERGENCY, NULL);
                }
                else if( strlen(data->editor_data.editor_attr.text) >= data->editor_data.min_enter )
                {
                    /* left Softkey is enabled (and entered sufficient number of chars): execute it */
                    //KGT
                    /* get the orginal text back into the editor instead of the hide buffer ( only filled with '*') */
                    if( data->editor_data.hide )
                        editor_hideTerminate(data);
                    //end KGT

                    TRACE_EVENT("press left");
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                }
                else
                {
                    /* NOP */
                    TRACE_EVENT("NOP");
                }
                break;

            case KCD_HUP:
                {
                    if( data->editor_data.editor_attr.text[0] EQ '\0' )
                        win_show(data->edt_win);  //xsf add for update window if press KCD_HUP when edit buf is NULL 12.04
                }
                break;

            case KCD_CALL:
                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);
                //   break;  zy change 0902                  

                if( data->emergency_call EQ TRUE )
                {
                    TRACE_EVENT("press left  < min");

                    /* get the orginal text back into the editor instead of the
                       hide buffer ( only filled with '*') */
                    if( data->editor_data.hide )
                        editor_hideTerminate(data);

                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_EMERGENCY, NULL);
                }
                break;

            case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
			case KCD_CLEAR:
#endif
                data->emergency_call = FALSE;

                if( data->editor_data.editor_attr.text[0] NEQ '\0' )
                {
                    /* buffer is not empty, delete the char before the cursor */
                    //KGT
                    if( data->editor_data.hide )
                    {
                        U8 uMode;
                        //                      uMode = dspl_Enable(0);
                        editor_hideClear(data);

                        if( cm_check_emergency((U8*)data->tmpBuf) )
                        {
                            TRACE_EVENT(" it is a emergency number !");
                            data->emergency_call = TRUE;
                            TRACE_EVENT(" emergency_call = TRUE");
                        }
                        else
                        {
                            data->emergency_call = FALSE;
                            TRACE_EVENT(" emergency_call = FALSE");
                        }

                        if( data->editor_data.min_enter > 0 || data->emergency_call )
                        {
                            win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                        else
                        {
                            edtShow(data->edt_edt);
                        }
                        //                      dspl_Enable(uMode);
                    }
                    else
                    //end KGT
                    {
                        edtChar(data->edt_edt,ecBack);

                        // this is for the ss_string
                        if( strlen(data->editor_data.editor_attr.text) EQ 0
                            && data->ss_string )
                        {
                            data->ss_string = FALSE;
                            //the string should be visible on screen
                            //data->editor_data.hide = TRUE;  xsf remarked 2002.12.02
                        }

                        /* is it a  emergency call number ?!*/
                        if( cm_check_emergency((U8*)data->editor_data.editor_attr.text) )
                        {
                            TRACE_EVENT(" it is a emergency number !");
                            data->emergency_call = TRUE;
                            TRACE_EVENT(" emergency_call = TRUE");
                        }
                        else
                        {
                            data->emergency_call = FALSE;
                            TRACE_EVENT(" emergency_call = FALSE");
                        }

                        if( data->editor_data.min_enter > 0 )
                        {
                            win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                        else
                        {
                            edtShow(data->edt_edt);
                        }
                    }
                }
                else
                    win_show(data->edt_win);  //xsf add for update window if press KCD_RIGHT when edit buf is NULL 12.04

                break;
            default: /* any key */

                //data->emergency_call = FALSE;

                if( data->editor_data.mode NEQ READ_ONLY_MODE ) /* ignore normal keys if in read-only mode */
                {
                    if( data->editor_data.hide )
                    {
                        U8 uMode;
                        TRACE_EVENT(" hide mode");
                        //                    uMode = dspl_Enable(0);
                        editor_hideInsert(data,keyboard->code);

                        if( cm_check_emergency((U8*)data->tmpBuf) )
                        {
                            TRACE_EVENT(" it is a emergency number !");
                            data->emergency_call = TRUE;
                            TRACE_EVENT(" emergency_call = TRUE");

                        }
                        else
                        {
                            data->emergency_call = FALSE;
                            TRACE_EVENT(" emergency_call = FALSE");
                        }

                        if( data->editor_data.min_enter > 0 || data->emergency_call )
                        {
                            win_show(data->edt_win); /* in order to update the Softkeys */
                            TRACE_EVENT(" win_show");
                        }
                        else
                        {
                            edtShow(data->edt_edt);
                            TRACE_EVENT(" edtShow");
                        }
                        //                      dspl_Enable(uMode);

                    }

                    else
                    {
                        TRACE_EVENT(" unhide mode");
                        //xsf remarked it 2002.10.24 editEventKey(event,keyboard);
                        edtChar(data->edt_edt, editControls[keyboard->code]);
                        /* is it a  emergency call number ?!*/
                        if( cm_check_emergency((U8*)data->editor_data.editor_attr.text) )
                        {
                            TRACE_EVENT(" it is a emergency number !");
                            data->emergency_call = TRUE;
                        }
                        else
                        {
                            data->emergency_call = FALSE;
                        }

                        if( data->editor_data.min_enter > 0 )
                        {
                            win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                        else
                        {
                            edtShow(data->edt_edt);
                        }
                    }
                }
                break;
            }

            break;
            //  E_PIN_SECURITY out
        }
    }
    /*  Ende RM T9 integration 24-08
     *
     */
#ifdef EASY_TEXT_ENABLED
    else if( FFS_flashData.PredTextAvailable == TRUE )
    {
        //TRACE_EVENT("In predictive mode");
        //sprintf(debug, "Key: %d", keyboard->code);
        //TRACE_EVENT(debug);
        if( event & KEY_LONG )
        {
            switch( keyboard->code )
            {
            case KCD_CALL:
                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);
                break;
            case KCD_RIGHT: //empty predictive text string
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
			case KCD_CLEAR:
#endif
                if( PredText[0] NEQ '\0' )
                {
                    PredText[0]= '\0';
                    ResetDictSearch();
                }
                else //empty whole editor
                {
                    if( data->editor_data.editor_attr.text[0] NEQ '\0' )
                    {
                        data->editor_data.editor_attr.text[0] = '\0';
                        if( data->editor_data.min_enter > 0 )
                        {
                            win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                        else
                        {
                            edtShow(data->edt_edt);
                        }

                    }
                    else
                    {
                        /* leave editor if buffer already empty */
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);
                    }
                }
                break;

            case KCD_0: /* '+' key */
                if( PredText[0] == '\0' )
                {


                    //edtChar(data->edt_edt,ecBack); /* remove the '0' */
                    //edtChar(data->edt_edt,'+');    /* insert the '+' */
                    if( data->editor_data.min_enter > 0 )
                    {
                        win_show(data->edt_win); /* in order to update the Softkeys */
                    }
                    else
                    {
                        edtShow(data->edt_edt);
                    }
                }

                break;

            case(KCD_STAR):
                { char symbol;
                    SymbolScreenstart (data->edt_win, &symbol);
                }
                break;

            default: //change case
                { if( PredText[0] == '\0' )
                    {
                        // change the Lowercase to Uppercase and visa-versa
                        //only possible in Alpha mode
                        if( data->editor_data.mode EQ ALPHA_MODE )
                        {
                            if( UPPER_CASE EQ FALSE )
                            {
                                TRACE_EVENT("UPPER_CASE EQ FALSE");
                                UPPER_CASE = TRUE;
                                upCase = FALSE;
                                displaySoftKeys_edition (TxtLowercase ,TxtNull,TxtNull);
                            }
                            else
                            {
                                TRACE_EVENT("UPPER_CASE EQ TRUE");
                                UPPER_CASE = FALSE;
                                upCase = TRUE;
                                displaySoftKeys_edition (TxtUppercase ,TxtNull,TxtNull);
                            }
                        }
                        //edtChar(data->edt_edt,ecBack);
                    }
                }
                return MFW_EVENT_CONSUMED; /* we don't handle other long presses here */


            }
        }
        else
        {
            switch( keyboard->code )
            {
            case KCD_CALL:
                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_CALL, NULL);                         
                break;
            case KCD_MNUUP:
                if( PredText[0] == '\0' )
                {
                    edtChar(data->edt_edt,ecRight);
                    edtShow(data->edt_edt);
                }
                break;

            case KCD_MNUDOWN:
                if( PredText[0] == '\0' )
                {

                    edtChar(data->edt_edt,ecLeft);
                    edtShow(data->edt_edt);
                }
                break;

            case KCD_LEFT:
                if( PredText[0] == '\0' )
                {

                    if( data->editor_data.LeftSoftKey NEQ TxtNull )
                    {

                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_LEFT, NULL);
                    }
                }
                else
                {
                    char TempString[16];
                    char LastChar;

                    if( (strlen(data->editor_data.editor_attr.text) + strlen(PredText)) < MAX_MSG_LEN )
                        if( PredText[0] != '*' )
                        {
                            if( capitalise_word(data->edt_edt) == TRUE|| (strlen(PredText)== 1 && PredText[0] == 'i') )
                            {
                                PredText[0] -= 0x20;
                            }
                            LastChar = getCursorChar(data->edt_edt, -1);
                            if( LastChar != ' ' && LastChar != 0 )
                            {
                                sprintf(TempString, " %s", PredText);
                                edtInsertString(data->edt_edt, TempString);
                            }
                            else
                                edtInsertString(data->edt_edt,PredText);
                        }
                    PredText[0] = '\0';
                    ResetDictSearch();
                    win_show(data->edt_win);
                }

                break;

            case KCD_HUP:
                if( data->editor_data.RightSoftKey NEQ TxtNull )
                {
                    /* Right softkey is enabled: execute it */
                    SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_HUP, NULL);
                }
                break;

            case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
			case KCD_CLEAR:
#endif
                if( PredText[0] == '\0' )
                {
                    if( data->editor_data.editor_attr.text[0] NEQ '\0' )
                    {
                        
                        {
                            edtChar(data->edt_edt,ecBack);
                            if( data->editor_data.min_enter > 0 )
                            {
                                win_show(data->edt_win); /* in order to update the Softkeys */
                            }
                            else
                            {
                                edtShow(data->edt_edt);
                            }
                        }
                    }
                    else
                    {
                        /* leave editor if buffer already empty */
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_KCD_RIGHT, NULL);
                    }
                }
                else
                {
                    if( strlen(PredText) == 1 )
                    {
                        DictBackSpace(data->editor_data.editor_attr.predText);
                        PredText[0] = '\0';
                    }
                    else
                        DictBackSpace(data->editor_data.editor_attr.predText);

                    win_show(data->edt_win);
                }

                break;
            case (KCD_2):
            case (KCD_3):
            case (KCD_4):
            case (KCD_5):
            case (KCD_6):
            case (KCD_7):
            case (KCD_8):
            case (KCD_9):
                {
                    DictAlphaKeyPress(keyboard->code,PredText);
                    win_show(data->edt_win);
                }
                break;

            case (KCD_HASH):
                {   FFS_flashData.PredTextSelected = FALSE;
                    PredText[0] = '\0';
                    win_show(data->edt_win);
                }
                break;

            case (KCD_STAR):
                if( PredText[0] == '\0' )
                {
                    char symbol;
                    SymbolScreenstart (data->edt_win, &symbol);
                }
                else
                {
                    int i;
                    MoreCandidates(PredText, &i);
                    win_show(data->edt_win);
                }
                break;

            case KCD_0:
            case KCD_1:
                if( PredText[0] != '\0' )
                {
                    char TempString[16];
                    char LastChar;

                    if( (strlen(data->editor_data.editor_attr.text) + strlen(PredText)) < MAX_MSG_LEN )
                    {
                        //if char b4 cursor full stop/question/exclamation
                        //(or last char space and char b4 full stop)
                        if( capitalise_word(data->edt_edt) == TRUE || (strlen(PredText)== 1 && PredText[0] == 'i') )
                        {
                            PredText[0] -= 0x20;

                        }
                        //capitalise first letter of char
                        //if char b4 cursor not space
                        //insert spac
                        LastChar = getCursorChar(data->edt_edt, -1);

                        if( PredText[0] != '*' )
                        {
                            if( keyboard->code == KCD_1 )
                            {
                                if( LastChar != ' ' && LastChar != 0 )
                                    sprintf(TempString, " %s ", PredText);
                                else
                                    sprintf(TempString, "%s ", PredText);
                            }
                            else
                            {
                                if( LastChar != ' ' && LastChar != 0 )
                                    sprintf(TempString, " %s. ", PredText);
                                else
                                    sprintf(TempString, "%s. ", PredText);
                            }
                            edtInsertString(data->edt_edt, TempString);
                        }
                    }
                    PredText[0] = '\0';
                    ResetDictSearch();
                    win_show(data->edt_win);
                    break;
                }

            default:
                /* any key */
                if( data->editor_data.mode NEQ READ_ONLY_MODE ) /* ignore normal keys if in read-only mode */
                {
                    {
                        editEventKey(event,keyboard);
                        if( data->editor_data.min_enter > 0 )
                        {
                            win_show(data->edt_win); /* in order to update the Softkeys */
                        }
                        else
                        {
                            edtShow(data->edt_edt);
                        }
                    }
                }
                break;
            }
        }
    }
#endif
    //dspl_Enable(old_mode);
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     editor_tim_cb

 $Description:  Callback function for the editor info timer.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static int editor_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_EDITOR_INFO * data       = (T_EDITOR_INFO *)win_data->user;

    T_MFW_HND       parent_win = data->parent;
    USHORT          Identifier = data->editor_data.Identifier;
    T_EDIT_CB       Callback   = data->editor_data.Callback;

    /* timer elapsed => selfdestroy; sendevent INFO_TIMEOUT */
    editor_destroy (data->edt_win);
    if( Callback )
        (Callback) (parent_win, Identifier, INFO_TIMEOUT);

    return MFW_EVENT_CONSUMED;
}

/* 2004/06/30 sunsj modify for screen size */
#define EDITOR_TOP_LEFT_POS_X   2
#if(MAIN_LCD_SIZE==3)
#define EDITOR_TOP_LEFT_POS_Y   14		// sbh - was 10, meant editor went into softkeys
#define EDITOR_HORIZONTAL_SIZE  104//98//76		//sbh - was 84, meant editor went off edge of screen//shiheng 288 modify
#define EDITOR_VERTICAL_SIZE    114//66//32	//shiheng 288 modify	
#elif (MAIN_LCD_SIZE==4)
#define EDITOR_TOP_LEFT_POS_Y   14		// sbh - was 10, meant editor went into softkeys
#define EDITOR_HORIZONTAL_SIZE  124//76		//sbh - was 84, meant editor went off edge of screen
#define EDITOR_VERTICAL_SIZE    144//32		
#endif	
#define EDITOR_COLOR            0
#define EDITOR_FONT             0
#define EDITOR_CONTROLS         0

T_MFW_HND editor_start_common(T_MFW_HND win, char * buffer, U16 len, T_EDITOR_DATA * editor_info, T_EDIT_CB editor_cb)
{
    editor_info->editor_attr.win.px   = EDITOR_TOP_LEFT_POS_X;
    editor_info->editor_attr.win.py   = EDITOR_TOP_LEFT_POS_Y;  //zhaowm,to display fully
    editor_info->editor_attr.win.sx   = EDITOR_HORIZONTAL_SIZE;
    editor_info->editor_attr.win.sy   = EDITOR_VERTICAL_SIZE;
    editor_info->editor_attr.fgColor  = 0xffffff;
    editor_info->editor_attr.font     = EDITOR_FONT;
    editor_info->editor_attr.mode     = edtCurBar1;
    editor_info->editor_attr.controls = EDITOR_CONTROLS;
    editor_info->editor_attr.text     = buffer;
    editor_info->editor_attr.size     = len;
    editor_info->editor_attr.e_size   = 0;
    editor_info->editor_attr.textnum  = 0;

    if( editor_info->mode != ONLYREAD_MODE )
    {
        editor_info->editor_attr.titleMode= 1;         //zhaowm 2002/08/12 add the flag of the input
        editor_info->editor_attr.title_id = '\0';
    }
    else
    {
        editor_info->editor_attr.titleMode= 0;         
        editor_info->editor_attr.title_id = '\0';
    }
    if( editor_info->editor_attr.titleMode )
    {
        editor_info->editor_attr.win.py = Mmi_layout_line_height()+1;  /* 2004/04/22 sunsj modify */
        editor_info->editor_attr.win.sy = EDITOR_VERTICAL_SIZE-Mmi_layout_line_height() - 1;
    }

    //editor_info->destroyEditor      = FALSE;//TRUE; zhaowm2002/07/28
    editor_info->destroyEditor        = TRUE; //zhaowm2002/07/28

    editor_info->Callback             = editor_cb;

    /* 2004/04/12 sunsj modify for create the dialog handler */
    if( editor_info->mode != TEXTINPUT_MODE )
    {
        return editor_start(win, editor_info);  /* start the common editor */
    }
    else
    {
        return text_input(win, editor_info);
    }
}

/*******************************************************************************

 $Function:     editor_hideInit

 $Description:  the editor hides letters and numbers behind '*'.
         Initialize editor for hide.

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void editor_hideInit(T_EDITOR_INFO *data)
{
    USHORT  len = strlen(data->editor_data.editor_attr.text);

    TRACE_EVENT("MmiEditor.editor_hideInit");

    /* get memory for the tempory buffer */
    data->tmpBuf = (char *) ALLOC_MEMORY(data->editor_data.editor_attr.size);

    /* copy text to the tempory buffer */
    strcpy(data->tmpBuf, data->editor_data.editor_attr.text);

    /* overwrite the string in the editor buffer with stars */
    memset(data->editor_data.editor_attr.text,'\0',sizeof(data->editor_data.editor_attr.text));
    edtReset(data->edt_edt);

    while( strlen(data->editor_data.editor_attr.text) < len )
        edtChar(data->edt_edt,'*');

    /* show editor with hide buffer */
    if( data->editor_data.min_enter > 0 )
        win_show(data->edt_win); /* in order to update the Softkeys */
    else
        edtShow(data->edt_edt);

    return;
}

/*******************************************************************************

 $Function:     editor_hideInsert

 $Description:  Insert the typed letter/number with editEventKey into the
        original editor buffer and insert a '*' into the hide buffer

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void editor_hideInsert(T_EDITOR_INFO *data, U8 key)
{
    USHORT  i;
    MfwEdt  *edt = ((T_MFW_HDR      *)(data->edt_edt))->data;

    TRACE_EVENT("MmiEditor.editor_hideInsert");

    /* check if no more space in buffer  */
    if( (int) strlen(data->editor_data.editor_attr.text) >=
        data->editor_data.editor_attr.size - 1 )
        return;

    /* do insert on original editor buffer without cursor move: */
    if( !data->editor_data.editor_attr.mode )
        return;
    else
        /* if not in overwrite mode, move text behind cursor position 1 position
           to the right */
        if( !(data->editor_data.editor_attr.mode & edtModOverWr) )

        for( i = strlen(data->tmpBuf); i > edt->cp; i-- )
            data->tmpBuf[i] = data->tmpBuf[i-1];

    /* insert the character */
    data->tmpBuf[edt->cp] = (char) (key + '0');

    /* do insert on hide buffer with cursor move */
    edtChar(data->edt_edt,'*');

    /* show editor with hide buffer */
    if( data->editor_data.min_enter > 0 )
        win_show(data->edt_win); /* in order to update the Softkeys */
    else
        edtShow(data->edt_edt);

    return;
}

/*******************************************************************************

 $Function:     editor_hideClear

 $Description:  clears a character at the cursor position inthe  original editor
        buffer and the hide buffer

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void editor_hideClear(T_EDITOR_INFO *data)
{
    MfwEdt *edt = ((T_MFW_HDR *)(data->edt_edt))->data;

    TRACE_EVENT("MmiEditor.editor_hideClear");

    /* check if at beginning of buffer  */
    if( edt->cp == 0 )
        return;

    /* do delete on original editor buffer without cursor move */
    strcpy(data->tmpBuf + edt->cp - 1, data->tmpBuf + edt->cp);

    /* do delete on hide buffer with cursor move */
    edtChar(data->edt_edt,ecBack);

    /* show editor with hide buffer */
    if( data->editor_data.min_enter > 0 )
        win_show(data->edt_win); /* in order to update the Softkeys */
    else
        edtShow(data->edt_edt);

    return;
}

/*******************************************************************************

 $Function:     editor_hideClearAll

 $Description:  clears hole original editor buffer and hole hide buffer

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void editor_hideClearAll(T_EDITOR_INFO *data)
{
    TRACE_EVENT("MmiEditor.editor_hideClearAll");

    /* clear the original editor buffer and the hide buffer */
    memset(data->tmpBuf,'\0',sizeof(data->tmpBuf));
    memset(data->editor_data.editor_attr.text,'\0',sizeof(data->editor_data.editor_attr.text));
    edtReset(data->edt_edt);

    /* show editor with hide buffer */
    if( data->editor_data.min_enter > 0 )
        win_show(data->edt_win); /* in order to update the Softkeys */
    else
        edtShow(data->edt_edt);

    return;
}

/*******************************************************************************

 $Function:     editor_hideTerminate

 $Description:  switchs the normal editor buffer with the tempory buffer in
        T_EDITOR_INFO

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/
static void editor_hideTerminate(T_EDITOR_INFO *data)
{
    TRACE_EVENT("MmiEditor.editor_hideTerminate");

    /* overwrite the stars with the original typed text */
    strcpy(data->editor_data.editor_attr.text, data->tmpBuf);

    /* free the memory for the tempory buffer */
    FREE_MEMORY ((void *)data->tmpBuf, data->editor_data.editor_attr.size);

    return;
}

/*
zgz,2002.06.28

Get next inputed symbol's length(bytes) by the current input method;
Note: this function will be called in the mfw_edt.c  level
*/

int getNextInputLen(void)
{
    /*
    zgz,2002.07.01  the window is always update, It's not always editor window
    
        T_MFW_HND       win        = mfw_parent (mfw_header());
        T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
        T_EDITOR_INFO *  data       = (T_EDITOR_INFO *)win_data->user;
    */   
    /*
    // myHandle
        if(data->editor_data.mode EQ HANZI_MODE)   // or the current input mode is indicated by the global variable
            return 2;
        else
            return 1;
    */   
    /* 2003/12/04 sunsj modify */
    return 1;
#if 0
    if( get_ecinput_mode() == PARADISE_MODE )
        return 2;
    else
        return 1;
#endif

}

//zgz,2002.7.15 when the ascii string can't be converted to unicode string, (the buffer is limited)
//the prompt information should be showed.
static int show_error_info(T_MFW_HND parent_win)
{

    T_DISPLAY_DATA display_info;

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId     = TxtBufferFull;
    display_info.TextId2    = 0;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtNull;
    display_info.Time     = 2000;
    display_info.Callback   = (T_VOID_FUNC) NULL;

    info_dialog(parent_win, &display_info);

    return MFW_EVENT_CONSUMED;

}


/******************************************************************************
$Function:     setcursor

 $Description:  calculate the cursor position and width after display the text;

 $Returns:    no.

 $Arguments:  the edit controll data,the string,the edit win area.

*******************************************************************************/
void Setcursor(MfwEdt *edit,char *text,MfwRect win)
{
    int last_x=0,last_y=0,curr_x=win.px,curr_y=win.py,len=0,i,j;
    len=wstrlen(text);

    j=0;

    if( text[0]==0x80 )
    {
        len/=2;
        text++;
        for( i=0;i<len;i++ )
        {
            if( *(text+2*i)==0x00 )
            {
                curr_y+=((curr_x+8)/120)*16;
                curr_x=(curr_x+8)%120;
            }
            else
            {
                if( (curr_x+16)>120 )
                {
                    curr_y+=16;
                    curr_x=16;
                }
                else
                {
                    curr_y+=((curr_x+16)/120)*16;
                    curr_x=(curr_x+16)%120;
                }
            }

        }
        last_x=curr_x;
        last_y=curr_y;
        edit->cp=len*2;
    }
    else
    {
        j=len*8;
        last_x=j%120+win.px;
        last_y=(j/120)*16+win.py;
        curr_x=last_x;
        curr_y=last_y;
        edit->cp=len;
    }
    edit->cp_curr_x=curr_x;
    edit->cp_curr_y=curr_y;
    edit->cp_last_x=last_x;
    edit->cp_last_y=last_y;
    return;
}

/*
yq add for sms
*/
BOOL set_esize (U16 esize, MfwHnd win)
{
    MfwHdr *win_hdr;
    MfwWin *win_win;
    T_EDITOR_INFO *edtinfo;
    MfwHdr * edt;
    MfwEdt * edt_data;
    MfwEdtAttr *edt_attr;
    if( win )
    {
        win_hdr=(MfwHdr *)win;
        if( win_hdr->type!=MfwTypWin )
            return FALSE;
        win_win=(MfwWin *)win_hdr->data;
        if( !win_win )
            return FALSE;
        edtinfo=(T_EDITOR_INFO *)(win_win->user);
        if( !edtinfo )
            return FALSE;
        edt=(MfwHdr *)edtinfo->edt_edt;
        if( !edt )
            return FALSE;
        if( edt->type!=MfwTypEdt )
            return FALSE;
        edt_data=(MfwEdt *)edt->data;
        if( !edt_data )
            return FALSE;
        edt_attr=edt_data->attr;
        if( !edt_attr )
            return FALSE;
        edt_attr->e_size=esize;
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

/* 2004/03/24 sunsj modify softkey display bug */
static void displayedtsoftkey(T_MFW_HND win)
{
    //  T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_EDITOR_INFO *  data       = (T_EDITOR_INFO *)win_data->user;

    T_MFW_HND       parent_win = data->parent;  //zgz add,2002.9.3
    USHORT          Identifier = data->editor_data.Identifier;   //zgz add,2002.9.3
    T_EDIT_CB       Callback   = data->editor_data.Callback;  //zgz add,2002.9.3

    UINT32 oldColor,oldFontColor;

    if( data->edt_mode != E_PIN_SECURITY )
    {
#ifdef EASY_TEXT_ENABLED
        if( data->editor_data.editor_attr.predText[0] != '\0' && FFS_flashData.PredTextSelected == TRUE )
            displaySoftKeys(TxtSoftOK, TxtDelete);
        else
#endif
        {
            if( wstrlen(data->editor_data.editor_attr.text) < data->editor_data.min_enter ) // zgz, 2002.7.11 it should be changed. function strlen is wrong for unicode string
            {
                if( data->editor_data.edtInPbk )
                {
                    if( wstrlen(data->editor_data.editor_attr.text) ==0 )
                        displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                    else
                        displaySoftKeys(data->editor_data.LeftSoftKey,TxtDelete);
                    (Callback) (parent_win, Identifier, INFO_EDT_UPDATE); 
                }
                else if( wstrlen(data->editor_data.editor_attr.text) ==0 )
                {
                    displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                }
                else if( data->editor_data.edtInPbk == 0 )/* entered less than the required number of chars: Alternate Softkey appears */
                {
                    /* 2004/04/16 sunsj modify */
                    displaySoftKeys(data->editor_data.AlternateLeftSoftKey, data->editor_data.RightSoftKey);
                }
                else if( Callback && (data->editor_data.edtInPbk) )           //zgz add, 2002.8.27 indicate upper layer to update
                {
                    displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtDelete);
                    (Callback) (parent_win, Identifier, INFO_EDT_UPDATE); 
                }
            }
            else
            {
                if( wstrlen(data->editor_data.editor_attr.text) == 0 )
                    displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                else
                    /* entered sufficient number of chars: Normal Softkey appears */
                    displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
            }
        }
    }
}

