/*******************************************************************************

$Project name:	Basic MMI                                                      
$Project code:	BMI                                                      
$Module:		Mmiiconresource
$File:		    Mmiiconresource.c
$Revision:		1.0                                                       
				
$Author:		sunsj
$Date:		    2004/06/10
				
********************************************************************************
				
Description:Manage picture resource.
			
********************************************************************************
			
$History: 
    1.1 Create object
		  
$End
		  
*******************************************************************************/

/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#include <stdio.h>
#include <string.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

#include "dspl.h"

#include "mmicoordinate.h"
#include "mmiiconresource.h"

#include "..\bmi\icons\TextinputIcn.h"
#include "..\bmi\icons\idledynamicwp.h"
#include "..\bmi\icons\idlestaticwp.h"
#include "..\bmi\icons\mainmenuicn.h"
#include "..\bmi\icons\mainmenuicn1.h"
#include "..\bmi\icons\mainmenuicn2.h"
#include "..\bmi\icons\mainmenuicn3.h"
#include "..\bmi\icons\mainmenuicn4.h"
#include "..\bmi\icons\mainmenuicn5.h"
#include "..\bmi\icons\mainmenuicn6.h"
#include "..\bmi\icons\mainmenuicn7.h"
#include "..\bmi\icons\mainmenuicn8.h"
#include "..\bmi\icons\mainmenuicn9.h"
#include "..\bmi\icons\MenuTitleIcn.h"
#include "..\bmi\icons\ToolkitIcn.h"
#include "..\bmi\icons\ListIcn.h"
#include "..\bmi\icons\BatteryIcn.h"
#include "..\bmi\icons\SmsIcn.h"
#include "..\bmi\icons\IdleStateIcn.h"
#include "..\bmi\icons\OuterScreenIcn.h"
#include "..\bmi\icons\SignalIcn.h"
#include "..\bmi\icons\SceneIcn.h"
#include "..\bmi\icons\TimeDateIcn.h"
#include "..\bmi\icons\PhoneBookIcn.h"
#include "..\bmi\icons\CallIcn.h"
#include "..\bmi\icons\PopupIcn.h"
#include "..\bmi\icons\ContrastIcn.h"
#include "..\bmi\icons\SwitchOnIcn.h"
#include "..\bmi\icons\SwitchOffIcn.h"
#include "..\bmi\icons\SimNetIcn.h"
#include "..\bmi\icons\WapIcn.h"
#include "..\bmi\icons\DialingIcn.h"
#include "..\bmi\icons\GameIcn.h"
#include "..\bmi\icons\GameSnakeIcn.h"
#include "..\bmi\icons\GameBoxmanIcn.h"
#include "..\bmi\icons\GameRussiaIcn.h"

//2004.08.04 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "..\bmi\icons\cameraIcn.h"
#endif


//#define TDTRACE 1
#include "mmiutilapi.h"

/*******************************************************************************
                                                                              
                                Include Files end
                                                                              
*******************************************************************************/

/************************************************************************/
/* data part                                                            */
/************************************************************************/
IconResource icontable[ICON_MAX_NUMBER+1] = 
{
	{ 0, 0, 0 },
	{ ICON_TEXTINPUT_PINYIN, pinyin, 1},
	{ ICON_TEXTINPUT_BIHUA,  bihua,  1},
	{ ICON_TEXTINPUT_ABC,    ABC_input, 1},
	{ ICON_TEXTINPUT_abc,    abc_input, 1},
	{ ICON_TEXTINPUT_SHUZI,   D123_input, 1},
#if (MAIN_LCD_SIZE==3)
	{ ICON_TEXTINPUT_EDITBAR,   EditBarBmp, 1},
	{ ICON_IDLEDYNAMICWALLPAPER_ONE, DynamicIdleOne, 14},
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_IDLEDYNAMICWALLPAPER_ONE, DynamicIdleOne, 10},
	{ ICON_IDLEDYNAMICWALLPAPER_TWO, DynamicIdleTwo, 8},
#endif

#if(MAIN_LCD_SIZE==3)
	{ ICON_IDLESTATICWALLPAPER, BackgroundIcons, 4},
	{ ICON_MAINMENU_1, menuMainFuncIcn1, 10},
	{ ICON_MAINMENU_2, menuMainFuncIcn2, 10},
	{ ICON_MAINMENU_3, menuMainFuncIcn3, 10},
	{ ICON_MAINMENU_4, menuMainFuncIcn4, 10},
	{ ICON_MAINMENU_5, menuMainFuncIcn5, 10},
	{ ICON_MAINMENU_6, menuMainFuncIcn6, 10},
	{ ICON_MAINMENU_7, menuMainFuncIcn7, 10},
	{ ICON_MAINMENU_8, menuMainFuncIcn8, 10},
	{ ICON_MAINMENU_9, menuMainFuncIcn9, 10},
	{ ICON_MENUTITLE,  titleicons, 9},

#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_IDLESTATICWALLPAPER_1, BackgroundWp1, 1},
	{ ICON_IDLESTATICWALLPAPER_2, BackgroundWp2, 1},
	{ ICON_IDLESTATICWALLPAPER_3, BackgroundWp3, 1},
	{ ICON_IDLESTATICWALLPAPER_4, BackgroundWp4, 1},
	{ ICON_IDLESTATICWALLPAPER_5, BackgroundWp5, 1},
	{ ICON_IDLESTATICWALLPAPER_6, BackgroundWp6, 1},
	{ ICON_MAINMENU_1, menuMainFuncIcn1, 11},
	{ ICON_MAINMENU_2, menuMainFuncIcn2, 12},
	{ ICON_MAINMENU_3, menuMainFuncIcn3, 24},
	{ ICON_MAINMENU_4, menuMainFuncIcn4, 16},
	{ ICON_MAINMENU_5, menuMainFuncIcn5, 12},
	{ ICON_MAINMENU_6, menuMainFuncIcn6, 16},
	{ ICON_MAINMENU_7, menuMainFuncIcn7, 22},
	{ ICON_MAINMENU_8, menuMainFuncIcn8, 12},
	{ ICON_MENUTITLE,  titleicons, 17},
#endif
	{ ICON_LISTCOMMON, colist, 1},
#ifdef COLIST_HASMASK
	{ ICON_LISTCOMMON_MASK, colistMask, 1},
#endif
	{ ICON_IDLEBATTERY, batt_Attr, 5},
	{ ICON_IDLEBATTERY_MASK, battMask_Attr, 5},

	{ ICON_OUTIDLEBATTERY, out_batt_Attr, 5},
	{ ICON_OUTIDLEBATTERY_MASK, out_battMask_Attr, 5},
	

#if (MAIN_LCD_SIZE==3)
    { ICON_OFFCHARGING, OffCharge, 4},
	{ ICON_OFFBATTERYBKG,OffBatteryBkg,1},
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_OFFCHARGING, OffCharge, 3},
#endif
	{ ICON_SMSCOMMON_LIST, textlistIcon, 1},
	{ ICON_SMSNEW_LIST, newsmslist, 1},
	{ ICON_SMSMT_LIST, mtlist, 1},
	{ ICON_SMSMO_LIST, molist, 1},
	{ ICON_SMSUNMO_LIST, unmolist, 1},
	{ ICON_SMSMTTIME, MtSmstimeIcon, 1},
#if (MAIN_LCD_SIZE==3)
	{ ICON_SMSSENDING, SendingSms_Attr, 2},
	{ ICON_SMSSENDSUCCESS, SmsSendSuc_Attr, 2},
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_SMSSENDING, SendingSms_Attr, 3},
	{ ICON_SMSSENDSUCCESS, SmsSendSuc_Attr, 3},
#endif
	{ ICON_IDLESTATE, idl_Attr, 24},
	{ ICON_IDLESTATE_MASK, idl_AttrMask, 24},
	{ ICON_OUTERIDLESTATE, idl_Attr_Outer, 25},
	{ ICON_OUTERIDLESTATE_MASK, idl_AttrMask_Outer, 25},
	{ ICON_OUTERNUMBER, iconOuterNum, 15},
#if (SUB_LCD_SIZE==1)
	{ ICON_OUTERBKG,OTBkgIcns,4},
#endif//shiheng add
#if (SUB_LCD_SIZE==6)
	{ ICON_OUTERBKG,OTBkgIcns,1},
	
#endif
#if (SUB_LCD_SIZE==5)
	{ ICON_OUTERBKG,OTBkgIcns,1},
	
#endif

/*	
#if (MAIN_LCD_SIZE==3)
	{ ICON_IDLESIGNAL, sign_Attr, 5},
	{ ICON_OUTERSIGNAL, outersign_Attr, 5},
	{ ICON_OUTERSIGNAL_MASK, outersignMask_Attr, 5},
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_IDLESIGNAL, sign_Attr, 6},
	{ ICON_IDLESIGNAL_MASK, signMask_Attr, 6},
	{ ICON_OUTERSIGNAL, outersign_Attr, 6},
	{ ICON_OUTERSIGNAL_MASK, outersignMask_Attr, 6},
#endif
	*/
	//shiheng begin
	{ ICON_IDLESIGNAL, sign_Attr, 5},
	{ ICON_IDLESIGNAL_MASK, signMask_Attr, 5},
	{ ICON_OUTERSIGNAL, outersign_Attr, 5},
	{ ICON_OUTERSIGNAL_MASK, outersignMask_Attr, 5},
	//shiheng end
	{ ICON_SITUATION, situationIcon, 1},
	{ ICON_SITUATION3, situation3Icon, 1},
	{ ICON_SITUATION4, situation4Icon, 3},
	{ ICON_SITUATION5, situation5Icon, 1},
#if ( MAIN_LCD_SIZE==4 )
	{ ICON_SITUATION5_MASK, situation5Icon_mask, 1},
#endif
	{ ICON_CB_CHANEL, cb_chanel_icon, 1},

	{ ICON_SCENE, scene_Attr, 5},
	{ ICON_SCENE_MASK, sceneMask_Attr, 5},
	{ ICON_SCENEOUTER, scene_Attr_Outer, 5},
	{ ICON_SCENEOUTER_MASK, sceneMask_Attr_Outer, 5},
#if ( MAIN_LCD_SIZE==4 )
	{ ICON_VOLUME_BK, volume_bk, 1},
	{ ICON_VOLUME_BAR, vloume_bar, 1},
	{ ICON_VOLUME_RATE, vloume_rate, 1},
	{ ICON_RING_IMAGE, ring_image, 3},
	{ ICON_CALCULATE_ON, icnCalcOptOnAttr, 4},
	{ ICON_CALCULATE_OFF, icnCalcOptOffAttr, 4},
#endif
#if(MAIN_LCD_SIZE==3)
	{ ICON_VOLUME_ADJUST, volume_adjust, 6},
	{ ICON_VOLUME_BKG, volume_Bkg, 1},
	{ ICON_VOLUME, icn_Volume, 1},
	{ ICON_MUSIC_PLAY, music_Play, 6},
	{ ICON_CALCULATOR,Calculator,3},
#endif
	{ ICON_STOPWATCH_SEPA, sepa_bmp, 1},
	{ ICON_STOPWATCH_CIRCLE, circle_bmp, 1},

	{ ICON_ALARM_ANIM,	alarm_anim, 2},

	{ ICON_TIMEZONE_WORLDMAP, Timezone_world_map, 1},//ʱӱ
	{ ICON_TIMEARROW_KEY, time_arrow_key, 2},

#if(MAIN_LCD_SIZE==3)//jhxu720
	{ ICON_TIMEARROW_KEY_MASK,time_arrow_key_mask,2},
	{ ICON_TIMEZONE_BMP, Timezone_bmp, 1},
	{ ICON_CALENDARBKG, calendarBkg, 1},
	{ ICON_IMAGEFOCUS, ImageFocus, 1},
	{ ICON_CALENDARICON, calendaricon, 1},
	
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_SCHEDULE_WEEK, schedule_week, 1},
	{ ICON_SCHEDULE_NL, schedule_nl, 1},
	{ ICON_SCHEDULE_PIC, schedule_pic, 1},
	{ ICON_SCHEDULE_FOCUS, schedule_focus, 1},
#endif	
	
	{ ICON_SIMBOOK,	simbookicon, 1},
	{ ICON_NVMBOOK, nvmbookicon, 1},
	{ ICON_PHONEBOOK_GROUP, BookGroupingIcon, 16},
	{ ICON_PHONEBOOK_NAME, nvm_name, 1},
	{ ICON_PHONEBOOK_MOBILE, nvm_mobile, 1},
	{ ICON_PHONEBOOK_HOME, nvm_home, 1},
	{ ICON_PHONEBOOK_OFFICE, nvm_office, 1},
	{ ICON_PHONEBOOK_MEMO, nvm_memo, 1},

	{ ICON_CALLRECORD_NOREAD, M_NotRead_callsicon, 1},
	{ ICON_CALLRECORD_READ, M_Read_callsicon, 1},
	{ ICON_CALLRECORD_LDN, Dcallsicon, 1},
	{ ICON_CALLRECORD_LRN, Rcallsicon, 1},
	{ ICON_CALLRECORD_UNUMBER, Unumbersicon, 1},
	{ ICON_CALLRECORD_LJN, Jcallsicon, 1},
#if ( MAIN_LCD_SIZE==4 )
	{ ICON_CALLING_TEXTPAD, call_scratchpad_icon, 1},
#endif
	{ ICON_CALLACTIVE, CallActiveIcon, 7},
	{ ICON_CALLHOLD, CallHoldIcon, 7},
	{ ICON_CALLINCOMING, callIncoming_Attr, 3},
	{ ICON_CALLOUTGOING, CallOutgoing_Attr, 3},
#if(MAIN_LCD_SIZE==3)//jhxu720
	{ ICON_CALLACTIVE_ANI, CallActive_Attr, 3},
	{ ICON_CALLREDIAL_ANI, CallRedial_Attr, 5},
#endif
	{ ICON_MENUUP, menuup, 1},
#if ( MAIN_LCD_SIZE==4 )
	{ ICON_MENUMID, menumid, 1},
#endif
	{ ICON_SOFTKEYBAR, softkeybarAttr, 1},
#if (MAIN_LCD_SIZE==3)
	{ ICON_LEFTRIGHT_ARROW,LeftRightArrow,1},
	{ ICON_UPDOWN_ARROW,UpDownArrow,1},
	{ ICON_FOURDIRECTION_ARROW,FourDirectionArrow,1},
	{ ICON_MENULISTBKGICONS,mnulistbkgicons,1},
	{ ICON_CURRENTBAR,currentbarIcon,2},
	{ ICON_SPECIAL_BG, icnSpBkgAttr, 1},
	{ ICON_VOICERECORD_PLAY, VoiceRecordPlay, 1},
	{ ICON_VOICERECORD_RECORD, VoiceRecord, 1},
	{ ICON_VOICEMEMO_WIN, record_win, 3},
#elif  (MAIN_LCD_SIZE==4)
	{ ICON_SPECIAL_BG, icnSpBkgAttr, 1},
	{ ICON_VOICERECORD_PLAY, VoiceRecordPlay, 1},
	{ ICON_VOICERECORD_RECORD, VoiceRecord, 1},
	{ ICON_VOICEMEMO_WIN, record_win, 3},
#endif
#if (MAIN_LCD_SIZE==3)
	{ ICON_IMAGEBAR, gImageBar, 1},
	{ ICON_RECORDICON, recordIcons, 3},
	{ ICON_VOICEMEMO_ANIM, memo_animation, 3},
	{ ICON_POPUPBACKGROUND, popup_background, 1},
	{ ICON_POPBACKMASK,iconPopMask,1},//jhxu720
#elif(MAIN_LCD_SIZE==4)
	{ ICON_VOICEMEMO_ANIM, memo_animation, 3},
	{ ICON_POPUPBACKGROUND, popup_background, 1},
#endif
#if (MAIN_LCD_SIZE==3)
	{ ICON_POPUPICON, popIcon, 10},
	{ ICON_CONTRAST_ICONS,contrastIcons,6},
	{ ICON_CONTRAST, contrast, 2},
	{ ICON_POPCALLICON, CallIcon, 2},
#elif( MAIN_LCD_SIZE==4 )
	{ ICON_POPUP_ACTIONBG, PopActionbg, 1},
	{ ICON_POPUPACTION, PopAction, 4},
	{ ICON_POPSMSSEND, Smssend, 2},
	{ ICON_POPCALLICON, CallIcon, 2},
	{ ICON_POPWAITING, waiting, 2},
	{ ICON_POPDELETE, deleteIcon, 3},
	{ ICON_POPCOPY, copyicon, 2},
	{ ICON_POPSAVE, saveicon, 3},
	{ ICON_POPCOMPLETE, completeicon, 2},
	{ ICON_CONTRAST, contrast, 3},
	{ ICON_SWITCHON_DEFAULT, SwitchOn_Attr, 5},
#endif
#if (MAIN_LCD_SIZE==3)
	{ ICON_SWITCHON, SwitchOn_Animination_Attr, 6},
	{ ICON_SWITCHOFF, SwitchOff_Attr, 3},
	{ ICON_SWITCHON_BKG,SwitchOnbkg,1},
	{ ICON_SWITCHOFF_BKG,SwitchOffbkg,1},
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_SWITCHON, SwitchOn_Animination_Attr, 5},
	{ ICON_SWITCHOFF, SwitchOff_Attr, 2},
#endif	

	{ ICON_NETWORKSEARCH, networksearching_Attr, 2},
	{ ICON_NOSIMCARD, NoSim_Attr, 3},
	{ ICON_CONNECT_WAP, Wap_Picture, 1},
#if (MAIN_LCD_SIZE==3)
	{ ICON_DIALINGNUMBER, iconNums, 14},
#elif ( MAIN_LCD_SIZE==4 )
	{ ICON_DIALINGNUMBER, dialingNum, 14},
	{ ICON_IDLEDIALING, newdialing, 1},
	{ ICON_IDLEDIALING_MASK, newdialing_mask, 1},
#endif
	//yhf
	{ ICON_GAME_KEYSETTING, key_iconsindex, 9},
	{ ICON_GAME_CTRL, ctrl_iconsindex, 9},
	{ ICON_GAME_SETTITLE, key_settitle, 1},
	{ ICON_GAME_NUMBER, game_number, 10},
	
	{ ICON_SNAKE_BODY,snakebody,6},
	{ ICON_SNAKE_BODYMASK,snakebody_mask,6},
	{ ICON_SNAKE_FOOD,snakefood,6},
	{ ICON_SNAKE_FOODMASK,snakefood_mask,6},
	{ ICON_SNAKE_WALL,snakewall,6},
	{ ICON_SNAKE_BKG,snakebkg,6},
	
	{ ICON_BOXMAN_BMP,game_boxman,10},
#if(MAIN_LCD_SIZE==3)//jhxu720
	{ ICON_BOXMAN_BKG,BoxmanBkg,1},
#endif
	{ ICON_RUSSIA_DIAMONDS,russia_diamonds,7},	
	{ ICON_RUSSIA_BKG,russia_bkg,1},		

//2004.08.12 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
	//2004-7-26 yangx Add
	{ICON_PREVIEW_BAR, preview_bar_icon, 1},
	{ICON_OPTION_BAR, option_bar_icon, 1},
	{ICON_OPTION_NUM, option_num_icon, 1},
    {ICON_OPTION_NUM_MASK, option_num_mask_icon, 1},
	{ICON_QUALITY, quality_icon, 1},
	{ICON_QUALITY_MASK, quality_mask_icon, 1},
	{ICON_SIZE, size_icon, 1},
    {ICON_SIZE_MASK, size_mask_icon, 1},
	{ICON_BRIGHT, bright_icon, 1},
	{ICON_BRIGHT_MASK, bright_mask_icon, 1},
	{ICON_MODE, mode_icon, 1},
	{ICON_MODE_MASK, mode_mask_icon, 1},
	{ICON_OSD_MASK, osd_mask_icon, 1},
	//end 2004-7-26 yangx
#endif	
	
	{ 0, 0},
};

FfsIcon ffs_picture[10];

/************************************************************************/
/* function part                                                        */
/************************************************************************/
/*******************************************************************************

 $Function:    	Draw_Picture

 $Description:	Draw picture through picture id
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
extern void Draw_Picture( unsigned short    in_X,
						  unsigned short    in_Y,
						  unsigned short    in_Index,
						  unsigned short    in_IconId,
						  unsigned short    in_Rop,
						  unsigned int      in_Attr)
{
	MMI_TRACE_EVENT(("sunsj-----------Draw_Picture()"));
	
	if( in_X > SCREEN_SIZE_X || in_Y > SCREEN_SIZE_Y )
	{
		MMI_TRACE_EVENT(("!!!Wrong location"));
	}

	if( in_IconId > 0 && in_IconId < ICON_MAX_NUMBER )
	{
		Draw_Icon(in_X, in_Y, in_Index, in_IconId, in_Rop, in_Attr);
	}
	else if ( in_IconId == ICON_FFS_PICTURE )
	{
		Draw_FFS_Icon(in_X, in_Y, in_Index, in_IconId, in_Rop, in_Attr);
	}
	else if ( in_IconId == ICON_BUFFER_PICTURE )
	{
		Draw_Buffer_Icon(in_X, in_Y, in_Index, in_IconId, in_Rop, in_Attr);
	}
	else
	{
		MMI_TRACE_EVENT(("None picture"));
	}
}

/*******************************************************************************

 $Function:    	Draw_Icon

 $Description:	Draw the icon in code
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
extern int Draw_Icon( unsigned short    in_X,
                      unsigned short    in_Y,
                      unsigned short    in_Index,
                      unsigned short    in_IconId,
                      unsigned short    in_Rop,
					  unsigned int      in_Attr)
{
	char *icons = NULL;
	char *iconsmask = NULL;
	unsigned short px = 0;
	unsigned short py = 0;
	unsigned short sx = 0;
	unsigned short sy = 0;

	MMI_TRACE_EVENT(("sunsj-----------Draw_Icon()"));

	/* Check iconid if it is large than the totle number of icon then return */
	if( in_IconId > ICON_MAX_NUMBER || icontable[in_IconId].icon == NULL )
	{
		if( in_IconId > ICON_MAX_NUMBER )
		{
			MMI_TRACE_EVENT(("error iconid"));
		}
		else if( icontable[in_IconId].icon == NULL )
		{
			MMI_TRACE_EVENT(("error icon"));
		}
		return 0;
	}

	if( icontable[in_IconId].iconNum != 1 )
	{
		if( in_Index >= icontable[in_IconId].iconNum )
		{
			MMI_TRACE_EVENT(("icon index is large than icon number"));
			return 0;
		}
	}
	else
	{
		if( in_Index >= icontable[in_IconId].icon->nIcons )
		{
			MMI_TRACE_EVENT(("icon index is large than icon buffer"));
			return 0;
		}
	}
	/************************************************************************/
	/* ICON IDһͼƬԸin_Indexеĳһ        */
	/************************************************************************/
	if( in_Index != 0 )
	{
		/************************************************************************/
		/* жͼƬĸ1ôin_Indexָ          */
		/************************************************************************/
		if(icontable[in_IconId].iconNum != 1 )
		{
			icons = icontable[in_IconId].icon[in_Index].icons;
			
			/************************************************************************/
			/* жǷʾλãҪin_Xin_YеõͼƬλãȻͼƬ
			   еõλ                                                       */
			/************************************************************************/
			if( in_Attr & ICON_LOCATION )
			{
				px = in_X;
				py = in_Y;
			}
			else
			{
				px = icontable[in_IconId].icon[in_Index].area.px;
				py = icontable[in_IconId].icon[in_Index].area.py;
			}

			/************************************************************************/
			/* õͼƬС                                                   */
			/************************************************************************/
			sx = icontable[in_IconId].icon[in_Index].area.sx;
			sy = icontable[in_IconId].icon[in_Index].area.sy;
		}
		/************************************************************************/
		/* жͼƬĸ1ôin_IndexָͼƬеĳһ
		   ֲҵõͼƬ                                                 */
		/************************************************************************/
		else
		{
			/************************************************************************/
			/* жin_IndexǷͼƬеĸܵĸֵȡ
			   ȡͼƬ                                                   */
			/************************************************************************/
			if( in_Index > icontable[in_IconId].icon->nIcons )
			{
				in_Index = in_Index%icontable[in_IconId].icon->nIcons;
			}

			icons = icontable[in_IconId].icon->icons + in_Index *
				icontable[in_IconId].icon->area.sx *
				icontable[in_IconId].icon->area.sy * 2;

			/************************************************************************/
			/* жǷʾλãҪin_Xin_YеõͼƬλãȻͼƬ
			   еõλ                                                       */
			/************************************************************************/
			if( in_Attr & ICON_LOCATION )
			{
				px = in_X;
				py = in_Y;
			}
			else
			{
				px = icontable[in_IconId].icon->area.px;
				py = icontable[in_IconId].icon->area.py;
			}

			/************************************************************************/
			/* õͼƬС                                                   */
			/************************************************************************/
			sx = icontable[in_IconId].icon->area.sx;
			sy = icontable[in_IconId].icon->area.sy;
		}
	}
	else
	{
		icons = icontable[in_IconId].icon->icons;

		/************************************************************************/
		/* жǷʾλãҪin_Xin_YеõͼƬλãȻͼƬ
		   еõλ                                                       */
		/************************************************************************/
		if( in_Attr & ICON_LOCATION )
		{
			px = in_X;
			py = in_Y;
		}
		else
		{
			px = icontable[in_IconId].icon->area.px;
			py = icontable[in_IconId].icon->area.py;
		}

		/************************************************************************/
		/* õͼƬС                                                   */
		/************************************************************************/
		sx = icontable[in_IconId].icon->area.sx;
		sy = icontable[in_IconId].icon->area.sy;
	}

	/************************************************************************/
	/* жͼƬǷҪ͸ɫҪ͸ɫӵǰICON IDĺһICON IDõ͸ɫ
	   ͼƬ                                                           */
	/************************************************************************/
	if( in_Attr & ICON_MASK )
	{
		if( in_Index != 0 )
		{
			/************************************************************************/
			/* жmask iconidͼƬ                                      */
			/************************************************************************/
			if( icontable[in_IconId+1].iconNum == 1 )
			{
				/************************************************************************/
				/* жmask iconidͼƬǷȷķΧڣȷõmask icon
				                                                                  */
				/************************************************************************/
				if( icontable[in_IconId+1].icon->nIcons > 1 )
				{
					if( icontable[in_IconId+1].icon->nIcons <= icontable[in_IconId].icon->nIcons)
					{
						iconsmask = icontable[in_IconId+1].icon->icons + in_Index *
							icontable[in_IconId].icon->area.sx *
							icontable[in_IconId].icon->area.sy * 2;
					}
				}
				else
				{
					if( icontable[in_IconId+1].icon->icons != NULL )
					{
						iconsmask = icontable[in_IconId+1].icon->icons;
					}
				}
			}
			else
			{
				if( icontable[in_IconId+1].icon[in_Index].icons != NULL)
				{
					iconsmask = icontable[in_IconId+1].icon[in_Index].icons;
				}
			}	
		}
		else
		{
			if( icontable[in_IconId+1].icon->icons != NULL )
			{
				iconsmask = icontable[in_IconId+1].icon->icons;
			}
		}
	}

	/************************************************************************/
	/* ж͸ɫͼǷͼƬݴһ𣬲ȡiconmask         */
	/************************************************************************/
	if( in_Attr & ICON_MASK_OWN )
	{
		if( in_Index != 0 )
		{
			iconsmask = icontable[in_IconId].icon[in_Index].icons + 
				icontable[in_IconId].icon->area.sx *
				icontable[in_IconId].icon->area.sy * 2;
		}
		else
		{
			iconsmask = icontable[in_IconId].icon->icons + 
				icontable[in_IconId].icon->area.sx *
				icontable[in_IconId].icon->area.sy * 2;
		}
	}

	/************************************************************************/
	/* ǷҪ͸ɫѡͼƬķʽ                                     */
	/************************************************************************/
	if( (in_Attr & ICON_MASK || in_Attr & ICON_MASK_OWN) && iconsmask != NULL )
	{
		pdspl_BitBlt(px, py, sx, sy, 0, icons , DSPL_BMPXOR);
		pdspl_BitBlt(px, py, sx, sy, 0, iconsmask , DSPL_BMPAND);
		pdspl_BitBlt(px, py, sx, sy, 0, icons , DSPL_BMPXOR);
	}
	else
	{
		pdspl_BitBlt(px, py, sx, sy, 0, icons , in_Rop);
	}

	return 1;
}

/*******************************************************************************

 $Function:    	Draw_Idleanimation

 $Description:	Draw dynamic wallpaper through animation id
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
extern int Draw_Idleanimation( unsigned short    in_IconId,
                               unsigned short    anim_frame)
{
	U8 uNewIndex = anim_frame + 1;
	MfwIcnAttr * icnBkg = 0;
	MfwIcnAttr * icnCurrent = 0;
	
	U8 uloop= 0 ;
	U8 uI;

	/* Check iconid if it is large than the totle number of icon then return */
	if(in_IconId > ICON_MAX_NUMBER)
	{
		MMI_TRACE_EVENT(("error dynamic idle iconid"));
		return 0;
	}
	
	if((icnBkg = (MfwIcnAttr *)icontable[in_IconId].icon) == 0)
	{
		return 0xff;
	}
	
	//draw bkg
	drawIconByIcnAttr(icnBkg,NULL);
	
	icnCurrent = (MfwIcnAttr *)icontable[in_IconId].icon + 1;
	
	while(icnCurrent->nIcons && anim_frame)
	{
		if(icnCurrent->icons == 0)
		{
			icnCurrent +=  icnCurrent->nIcons + 1;
			anim_frame -- ;
			if(anim_frame == 0)
				break;
		}
		else
			return 0xff;
	}
	
	
	if(anim_frame || icnCurrent->nIcons == 0)
	{
		return 0xff;
	}
	
	//draw anim
	uloop = icnCurrent->nIcons;
	for(uI = 0; uI < uloop ;uI++)
	{
		drawIconByIcnAttr(++icnCurrent,NULL);
	}
	
	if( (icnCurrent+1)->nIcons == 0)
		uNewIndex = 0;
	return uNewIndex;
}

MfwIcnAttr * GetIconAttr(unsigned short in_IconId, unsigned short in_Index)
{
	return (MfwIcnAttr * )&icontable[in_IconId].icon[in_Index];
}

int GetIconAttrNumber(unsigned short in_IconId)
{
	return icontable[in_IconId].iconNum;
}

extern int Draw_FFS_Icon( unsigned short    in_X,
					      unsigned short    in_Y,
					      unsigned short    in_Index,
					      unsigned short    in_IconId,
					      unsigned short    in_Rop,
					      unsigned int      in_Attr)
{
	return 1;
}

extern int Draw_Buffer_Icon( unsigned short    in_X,
						     unsigned short    in_Y,
						     unsigned short    in_Index,
						     unsigned short    in_IconId,
						     unsigned short    in_Rop,
						     unsigned int      in_Attr)
{
	return 1;
}

void ffs_picture_initialize()
{
	int i=0;
	MMI_TRACE_EVENT(("ffs_picture_initialize()"));

	memset(ffs_picture, 0x00, sizeof(ffs_picture));
	/************************************************************************/
	/* ʼffsϵͼƬб                                                */
	/************************************************************************/
}
