/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Icons
 $File:		    MmiIcons.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the implementation of the icon handling in the basic MMI
                        
********************************************************************************
 $History: MmiIcons.h	
    Date .................. Modification ......................................
    25/10/00	  Original Condat(UK) BMI version.	

 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiIcons.c

    21/06/02			zy	

 Description:change the mainmenu icons :
          from " MainiconCaculator " to"MainiconWap"all ninebitmap
       
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiIcons.c

    22/07/02			zy	

 Description:add the "confirm" Icon for mmidialog show
       
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiIcons.c

    01/08/02	  version 0.100 zy add the "situation"and "situation2"  Icons for listicon menu
    01/08/02      version 0.101 zy add "call_Attr,callAlert_Attr,callIncoming_Attr,UserBusy,NetNotAvail.NetBusy"and relatives icons 
                  for call interface  	   
    04/08/02      version 0.102 zy add icons about animation on and idle use icons and setting menu's icons
    09/08         version 0.103 windy modified
    12/08         version 0.104 zy modified
    14/08         version 0.105 xsf modified for scene mode icons in menu
    15/08         version 0.106 xsf modified for Shows the scene mode icons in idle window
    19/08/02      version 0.107 xusufang modified 
    29/08/02   version 0.108 xsf modified for melody volume bmps
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"
#include "GameDisplay.h"
#include "mmiouterIdle.h"
#include "mmiiconresource.h"	/* 2004/06 sunsj modify for picture manage */

/* sbh...21/01/02 */
#ifdef MMI_GPRS_ENABLED
    #include "MmiGprs.h" 
#endif
/* ...sbh */

//#define TDTRACE 1
#include "mmiutilapi.h"

/*******************************************************************************
                                                                              
                                Local definitions
                                                                              
*******************************************************************************/

#define CLEAR_BOTTOM_ZONE_ICON dspl_Clear(42,54,52,60)

#define LOGOWIDTH 120
#define LOGOHEIGH  160
#define CALLANIMWIDTH 96
#define CALLANIMHEIGH 90


/*******************************************************************************
                                                                              
                                Local function prototypes
                                                                              
*******************************************************************************/

static void iconsEvent( MfwEvt e, MfwIcn *i );
static void iconsBattEvent( MfwEvt e, MfwIcn *i );
static void iconsSignEvent( MfwEvt e, MfwIcn *i );
static void iconsScreenDelete( void );
static void iconsShowAlarmIcon();//gdy add for transparent alarm icon
//static void iconsShowTimerIcon();//gdy add for transparent timer icon


#define CLEAR_ICON_AREA	dspl_Clear(0,7,LCD_X,52);

#if ! defined(WIN32)
extern void scrOnOff (int on);          /* ES!! add. functions      */
#endif


#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
const unsigned char newQQ[]=
{
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0x71,0x8c,0x82,0x10,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x71,0x8c,0xbe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,
    0x71,0x8c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0x8c,0xbe,0xf7,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0x00,0x00,0x00,0x00,0xbe,0xf7,0xb6,0xb5,0x00,0x00,0xb6,0xb5,0xbe,0xf7,0x00,0x00,
    0x00,0x00,0xbe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0x71,0x8c,0x00,0x00,0x00,0x00,0xbe,0xf7,0xb6,0xb5,
    0x00,0x00,0xb6,0xb5,0xbe,0xf7,0x00,0x00,0x00,0x00,0x71,0x8c,0xbe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x40,0x08,0xa2,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xbe,0xf7,0xff,0xff,
    0xff,0xff,0xff,0xff,0xbe,0xf7,0xe5,0xe8,0x00,0x00,0x82,0x8a,0xa5,0xfc,0x85,0xf4,0x85,0xf4,0x85,0xf4,0xa5,0xfc,0x82,0x8a,
    0x00,0x00,0xe5,0xe8,0xbe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0x69,0x4a,0xe5,0xe8,0x20,0x18,0x00,0x00,0xa5,0xfc,
    0xa5,0xfc,0xa5,0xfc,0x00,0x00,0x20,0x18,0xe5,0xe8,0x69,0x4a,0xbe,0xf7,0xff,0xff,0xff,0xff,0x9a,0xd6,0x00,0x00,0x00,0x00,
    0x25,0xa9,0xe5,0xe8,0xe5,0xe8,0xe5,0xe8,0xe5,0xe8,0xe5,0xe8,0xe5,0xe8,0xe5,0xe8,0x00,0x00,0x00,0x00,0x9a,0xd6,0xbe,0xf7,
    0xbe,0xf7,0x41,0x08,0x00,0x00,0x71,0x8c,0xbe,0xf7,0xe5,0xe8,0x25,0xa9,0x25,0xa9,0x25,0xa9,0x25,0xa9,0x25,0xa9,0xbe,0xf7,
    0x71,0x8c,0x00,0x00,0x00,0x00,0xbe,0xf7,0xbe,0xf7,0x00,0x00,0x00,0x00,0xbe,0xf7,0xbe,0xf7,0xe5,0xe8,0x25,0xa9,0xbe,0xf7,
    0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0x00,0x00,0x00,0x00,0xbe,0xf7,0xbe,0xf7,0x41,0x08,0xbe,0xf7,0x00,0x00,
    0xbe,0xf7,0x25,0xa9,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0x00,0x00,0xbe,0xf7,0x00,0x00,0xbe,0xf7,
    0xff,0xff,0xbe,0xf7,0xbe,0xf7,0x00,0x00,0x71,0x8c,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0x71,0x8c,
    0x00,0x00,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xff,0xff,0xff,0xff,0xbe,0xf7,0xc5,0xfc,0x84,0xbb,0x00,0x00,0x00,0x00,0x71,0x8c,
    0x71,0x8c,0x00,0x00,0x00,0x00,0x84,0xbb,0xc5,0xfc,0xbe,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xbe,0xf7,0x84,0xbb,0xc5,0xfc,
    0xc5,0xfc,0xc5,0xfc,0x84,0xbb,0xbe,0xf7,0xbe,0xf7,0x84,0xbb,0xc5,0xfc,0xc5,0xfc,0xc5,0xfc,0x84,0xbb,0xbe,0xf7,0xff,0xff,
    0xff,0xff,0xff,0xff,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,0xff,0xff,0xff,0xff,0xbe,0xf7,0xbe,0xf7,0xbe,0xf7,
    0xbe,0xf7,0xbe,0xf7,0xff,0xff,0xff,0xff
};

const unsigned char newQQmask[]=
{
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
    0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
    0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff
};
#endif


#ifdef EASY_TEXT_ENABLED

// AP - 06/09/2001
/* eZitext Icon
*/

static const unsigned char TextIconeZiText[] = 
{
    0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x07,0x86,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x07,0x86,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01,0x86,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x01,0x86,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x01,0xF8,0x06,0x00,0x1F,0x99,0xFF,0x80,0x01,0x80,
    0x01,0xF8,0x06,0x00,0x1F,0x99,0xFF,0x80,0x01,0x80,
    0x07,0xF8,0x06,0x00,0x01,0x80,0x18,0x00,0x07,0xE0,
    0x07,0xF8,0x06,0x00,0x01,0x80,0x18,0x00,0x07,0xE0,
    0x18,0x78,0x06,0x06,0x01,0x98,0x18,0x61,0x99,0x80,
    0x18,0x78,0x06,0x06,0x01,0x98,0x18,0x61,0x99,0x80,
    0x01,0xE0,0x06,0x19,0x86,0x18,0x19,0x99,0x99,0x80,
    0x01,0xE0,0x06,0x19,0x86,0x18,0x19,0x99,0x99,0x80,
    0x07,0x80,0x06,0x1F,0x98,0x18,0x19,0xF8,0x61,0x80,
    0x07,0x80,0x06,0x1F,0x98,0x18,0x19,0xF8,0x61,0x80,
    0x18,0x60,0x06,0x18,0x18,0x18,0x19,0x81,0x99,0x98,
    0x18,0x60,0x06,0x18,0x18,0x18,0x19,0x81,0x99,0x98,
    0x1F,0x80,0x06,0x07,0x9F,0x98,0x18,0x79,0x98,0x60,
    0x1F,0x80,0x06,0x07,0x9F,0x98,0x18,0x79,0x98,0x60,
    0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00

};

#endif
/*********************zy add for confirm active diaolog************************/

#ifdef EASY_TEXT_ENABLED

MfwIcnAttr IconTexteZiText          =
{
    {2, 12, 80, 20}, 1, (char *) TextIconeZiText 
};


#endif



//hxl add for QQ list icon 2003-3-10
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
MfwIcnAttr QQlist =         
{
    { 0, 0, 16, 16}, 1, (char *) newQQ
};
MfwIcnAttr QQlistmask =         
{
    { 0, 0, 16, 16}, 1, (char *) newQQmask
};
#endif




/*******************************************************************************
                                                                              
                                Additional type definitions
                                                                              
*******************************************************************************/





/*******************************************************************************
                                                                              
                                Static data
                                                                              
*******************************************************************************/
IconState state_Outer[ idlIdMax ]; //2004/03/11 Sunny add

static IconState state[ idlIdMax ];
static IconState battstate[ iconBattMax ];
static IconState Bigbattstate[ iconBattMax ];//hxl add for power-off charging icon 2002-12-6
static IconState signalstate[ iconSignalMax ];
static IconState scenestate[ iconSceneMax ];   //xsf add 2002.08.15 about scene  mode
//static IconState volumestate[ volumebmp*2];   //xsf add 2002.08.27 about adjust melody volume

//static IconState inputstate[ inputIdMax ];




/*******************************************************************************
                                                                              
                                Private Methods
                                                                              
*******************************************************************************/


/*******************************************************************************

 $Function:    	iconsEvent

 $Description:	handle an icon event, empty handler
 
 $Returns:		None.

 $Arguments:	e, event, i, icon
 
*******************************************************************************/

static void iconsEvent( MfwEvt e, MfwIcn *i )
{
}


/*******************************************************************************

 $Function:    	iconsBattEvent

 $Description:	handle a battery icon event, empty handler
 
 $Returns:		None.

 $Arguments:	e, event, i, icon
 
*******************************************************************************/

static void iconsBattEvent( MfwEvt e, MfwIcn *i )
{
}



/*******************************************************************************

 $Function:    	iconsSignEvent

 $Description:	handle a signal icon event, empty handler
 
 $Returns:		None.

 $Arguments:	e, event, i, icon
 
*******************************************************************************/

static void iconsSignEvent( MfwEvt e, MfwIcn *i )
{
}



/*******************************************************************************

 $Function:    	iconsScreenDelete

 $Description:	Clears the icon area of all currently displayed icons
 
 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

static void iconsScreenDelete( void )
{     
    MfwIcnAttr * icnAttr ;
    MfwIcnAttr * icn;

    U8 bgindex; 
    UINT32 oldcolor;
    oldcolor=dspl_GetBkgColor();
    dspl_SetBkgColor( GetGameColor(AZURE));//ʾ˵ͷɫ

    //dspl_Clear( 0, 0, 104, 16 );  xsf change 104 to 103  12.10
    dspl_Clear( 0, 0, 103, 16 );
    dspl_SetBkgColor(oldcolor);

    /* 2003/10/30,talcon add */
    /*
    bgindex=FlashSettingData.BGI;
    icnAttr = get_bkgicnAttr(bgindex);
    if(icnAttr == NULL)return;
     icn = &icnAttr[bgindex];
    dspl_BitBlt  (icn->area.px,icn->area.py,
         icn->area.sx,16,
         0,(void *)icn->icons, 0);
         */
    /*end talcon */
}//zy change 09/18




/*******************************************************************************

 $Function:    	iconsShowIcon

 $Description:	display a single icon if it is currently visible
 
 $Returns:		None

 $Arguments:	Icon, pointer to the icon in question
 
*******************************************************************************/

static void iconsShowIcon( IconState *Icon )
{
    if( Icon->state == ICON_VISIBLE )
        icnShow( Icon->h );
}





/*******************************************************************************
                                                                              
                                Public Methods
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	iconsInit

 $Description:	Initialise the MMI Icon handling
 
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/

void iconsInit()
{
    int i;

    /* Create and initialise each of the icon state tables, to provide
       invisible (initially) icons
    */
    for( i = 0; i < idlIdMax; i++ )
    {
        state[i].state = ICON_INVISIBLE;
        /* 2004/06 sunsj modify for picture manage */
        state[i].h = icnCreate( 0, GET_ICONATTR(ICON_IDLESTATE, i)/*&idl_Attr[i]*/, E_ICN_VISIBLE, (MfwCb) iconsEvent );
    }

    /* Battery icons
    */
    for( i = 0; i < iconBattMax; i++ )
    {
        battstate[i].state = ICON_INVISIBLE;
        /* 2004/06 sunsj modify for picture manage */
        battstate[i].h = icnCreate( 0, GET_ICONATTR(ICON_IDLEBATTERY, i)/*&batt_Attr[i]*/, E_ICN_VISIBLE, (MfwCb) iconsBattEvent );
    }

    /* 2004/06/21 yhf remove */
    //hxl add for power-off charging icon 2002-12-6-------------------------------
    /*for (i = 0; i < iconBattMax; i++)
    {
        Bigbattstate[i].state = ICON_INVISIBLE;
        Bigbattstate[i].h = icnCreate( 0, (MfwIcnAttr *)&Bigbatt_Attr[i], E_ICN_VISIBLE, (MfwCb) iconsBattEvent );
    }*/
    //end of hxl add for power-off charging icon 2002-12-6----------------------------------------
    /* end yhf remove */

    /* Signal icons
    */
    for( i = 0; i < iconSignalMax; i++ )
    {
        signalstate[i].state = ICON_INVISIBLE;
        /* 2004/06 sunsj modify for picture manage */
        signalstate[i].h = icnCreate( 0, GET_ICONATTR(ICON_IDLESIGNAL, i)/*&sign_Attr[i]*/, E_ICN_VISIBLE, (MfwCb) iconsSignEvent );
    }


    /* Scene mode icons    //xsf add 2002.08.15 about scene  mode
 
     */
    for( i = 0; i < iconSceneMax; i++ )
    {
        scenestate[i].state = ICON_INVISIBLE;
        /* 2004/06 sunsj modify for picture manage */
        scenestate[i].h = icnCreate( 0, GET_ICONATTR(ICON_SCENE, i)/*(MfwIcnAttr *)&scene_Attr[i]*/, E_ICN_VISIBLE, (MfwCb) iconsSignEvent );
    }
    //	VolumeIconInit();//zy 2003-04-01
    /* Input icons
    */
    //	for (i = 0; i < inputIdMax; i++)
    //  {
    //      inputstate[i].state = ICON_INVISIBLE;
    //		inputstate[i].h = icnCreate( 0, (MfwIcnAttr *) &inp_Attr[i], E_ICN_VISIBLE, (MfwCb) iconsEvent);
    //	}
}





/*******************************************************************************

 $Function:    	iconsExit

 $Description:	Exit the MMI icons handling
 
 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

void iconsExit( void )
{
    int i;

    /* Delete all of the icons created during the iconsInit routine
    */
    for( i = 0; i < idlIdMax; i++ )
        icnDelete( state[i].h );

    for( i = 0; i < iconBattMax; i++ )
        icnDelete( battstate[i].h );
    //hxl add for power-off charging icon 2002-12-6
    for( i = 0; i < iconBattMax; i++ )
        icnDelete( Bigbattstate[i].h );
    //end of hxl add for power-off charging icon 2002-12-6

    for( i = 0; i < iconSignalMax; i++ )
        icnDelete( signalstate[i].h );

    //xsf add 2002.08.15 about scene  mode

    for( i = 0; i < iconSceneMax; i++ )
        icnDelete( scenestate[i].h );
    //    VolumeIconDel();//zy 2003-04-01
    //	for ( i = 0; i < inputIdMax; i++ )
    //        icnDelete( inputstate[i].h );
}




/*******************************************************************************

 $Function:    	iconsChargeDisplayOnOff

 $Description:	This switches the display on if it is currently off
                and the battery is charging
 
 $Returns:		None

 $Arguments:	on, state to set the display, 0 == off, other == on
 
*******************************************************************************/

void iconsChargeDisplayOnOff( int on )
{
    int i;

    /* Deal with switching the phone off when the "on" flag is cleared
       otherwise we will set the phone on
    */
    if( ! on )
    {
        /* request to turn the display off
        */
        TRACE_FUNCTION("Switch Display off");

        /* delete the icons and clear the display
        */
        for( i = 0; i < iconBattMax; i++ )
            icnDelete(battstate[i].h);
        dspl_ClearAll();

        /* deal with the hardware bits
        */
#if ! defined(WIN32)
        scrOnOff( on );
#endif
    }
    else
    {
        TRACE_FUNCTION("Switch Display on ");

        /* deal with the hardware bits
        */
#if ! defined(WIN32)
        scrOnOff( on );
#endif

        /* Update the charging icons
        */
        for( i = 0; i < iconBattMax; i++ )
        {
            battstate[i].state = ICON_INVISIBLE;
            battstate[i].h = icnCreate(0, GET_ICONATTR(ICON_IDLESTATE, i)/*(batt_Attr+i)*/,
                                       E_ICN_VISIBLE,(MfwCb)iconsBattEvent);
        }

        /* Show the current status
        */
        //  iconsStateOfCharge();
    }

}

/*******************************************************************************

 $Function:    	iconsStateOfCharge

 $Description:	Display the text "Charging.." or if battery full the text
                "Charging complete". This function is only called when the
                mobile switch off
 
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/

void iconsStateOfCharge( void )
{
    if( globalMobileMode & GlobalCharging )
    {
        if( globalBatteryMode == GlobalBatteryFull )
            PROMPT(16,Mmi_layout_second_line(),0, TxtChargComplete);
        else
            PROMPT(16,Mmi_layout_second_line(),0, TxtCharging);
    }
}


/*******************************************************************************

 $Function:    	iconsGetState

 $Description:	Get the state of an icon ICON_VISIBLE/ICON_INVISIBLE
 
 $Returns:		Return state of icon.

 $Arguments:	iconId, the id of the icon to be set
 
*******************************************************************************/

U8 iconsGetState( int iconId )
{
    TRACE_FUNCTION("iconsGetState() ");
    /* Only set the state if the iconId is valid, ie in range
    */
    if( ( iconId >= 0 ) && ( iconId < idlIdMax ) )
        return state[iconId].state;
}

/*******************************************************************************

 $Function:    	iconsGetState_Outer

 $Description:	Get the state of an icon ICON_VISIBLE/ICON_INVISIBLE
 
 $Returns:		Return state of icon.

 $Arguments:	iconId, the id of the icon to be set
 $Author:		Sunny.
 $Date:			2003/03/11
 
*******************************************************************************/

U8 iconsGetState_Outer( int iconId )
{
    TRACE_FUNCTION("iconsGetState() ");
    /* Only set the state if the iconId is valid, ie in range
    */
    if( ( iconId >= 0 ) && ( iconId < idlIdMax ) )
        return state_Outer[iconId].state;
}

/*******************************************************************************

 $Function:    	iconsSetState

 $Description:	Sets the state of an icon to be visible
 
 $Returns:		None

 $Arguments:	iconId, the id of the icon to be set
 
*******************************************************************************/

void iconsSetState( int iconId )
{
    TRACE_FUNCTION("iconsSetState() ");
    /* Only set the state if the iconId is valid, ie in range
    */
    if( ( iconId >= 0 ) && ( iconId < idlIdMax ) )
    {
        state[iconId].state = ICON_VISIBLE;
        //2004/03/11 Sunny add
        state_Outer[iconId].state = ICON_VISIBLE;       
        //2004/03/11 Sunny add end
    }
}

/*******************************************************************************

 $Function:    	iconsDeleteState

 $Description:	Sets the state of an icon to be invisible
 
 $Returns:		None

 $Arguments:	iconId, the id of the icon to be deleted
 
*******************************************************************************/

void iconsDeleteState( int iconId )
{
    TRACE_FUNCTION("iconsDeleteState()");
    /* Only set the state if the iconId is valid, ie in range
    */
    if( ( iconId >= 0 ) && ( iconId < idlIdMax ) )
    {
        state[iconId].state = ICON_INVISIBLE;

        //2004/03/11 Sunny add
        state_Outer[iconId].state = ICON_INVISIBLE;     
        //2004/03/11 Sunny add end
    }
}




/*******************************************************************************

 $Function:    	iconsShow

 $Description:	Show the current set of icons on the display
 
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/

void iconsShow( void )
{
    /*2003/11/13,talcon modify */
    drawIdelIcons();

}



/*******************************************************************************

 $Function:    	iconsShowBattery

 $Description:	Show battery status icons
 
 $Returns:		0 if error detected, otherwise 1

 $Arguments:	batterystatus, the current battery icon to be displayed
 
*******************************************************************************/

int iconsShowBattery( U8 batterystatus )
{
    int i;

    /* If we have an error, ie invalid id then return 0
    */
    if( ( batterystatus < 0 ) || ( batterystatus >= iconBattMax ) )
        return 0;

    /* Otherwise clear all of the battery icons, and then set the
       selected value to be visible
    */
    for( i = 0; i < iconBattMax; i++ )
        battstate[ i ].state = ICON_INVISIBLE;
    battstate[ batterystatus ].state = ICON_VISIBLE;

    /* and display the current selection
    */
    icnShow( battstate[ batterystatus ].h );

    return 1;
}

/*******************************************************************************

 $Function:    	iconShowGoodbye

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void iconShowGoodbye( void)
{
    //	iconsShowIcon( &state[ iconGoodbye ] );
}


/* 2004/06/15 sunsj modify */
/*******************************************************************************

 $Function:    	iconsShowSignal

 $Description:	Shows the signal status icons
 
 $Returns:		0 if error detected, otherwise 1

 $Arguments:	signalstatus, the current signal icon to be displayed
 
*******************************************************************************/

int iconsShowSignal (U8 signalstatus)
{
    if( signalstatus <0 )
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_MASK(ICON_IDLESIGNAL,0);
        //drawIconByIcnAttr((MfwIcnAttr*)&sign_Attr[0],(MfwIcnAttr*)&signMask_Attr[0]);		
    }
    else if( signalstatus >= iconSignalMax )
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL_MASK(ICON_IDLESIGNAL, iconSignalMax-1);
        //drawIconByIcnAttr((MfwIcnAttr*)&sign_Attr[iconSignalMax -1],(MfwIcnAttr*)&signMask_Attr[iconSignalMax -1]);				
    }
    else
    {
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL_MASK(ICON_IDLESIGNAL, (unsigned char)signalstatus);
        //drawIconByIcnAttr((MfwIcnAttr*)&sign_Attr[signalstatus],(MfwIcnAttr*)&signMask_Attr[signalstatus]);
    }

    return 1;
}
/****************************
$Description:
2004/05/21 yhf modify for outeridle
*************************************************************/
int iconsShowSignal_Sub (U8 signalstatus)
{
    //2004-03-21 Sunny remove
    //if ( ( signalstatus < 0 ) || ( signalstatus >= iconSignalMax ) )
    //return 0;

    /* 2004/06 sunsj modify for picture manage */
    if( signalstatus < 0 )
    {
        DRAW_ICON_SEL_MASK(ICON_OUTERSIGNAL, 0);
        //drawIconByIcnAttr((MfwIcnAttr*)&outersign_Attr[0],(MfwIcnAttr*)&outersignMask_Attr[0]);		
    }
    else if( signalstatus >= iconSignalMax )
    {
        DRAW_ICON_SEL_MASK(ICON_OUTERSIGNAL, iconSignalMax -1);
        //drawIconByIcnAttr((MfwIcnAttr*)&outersign_Attr[iconSignalMax -1],(MfwIcnAttr*)&outersignMask_Attr[iconSignalMax -1]);				
    }
    else
    {
        DRAW_ICON_SEL_MASK(ICON_OUTERSIGNAL, signalstatus);
    }
    return 1;
}


/*******************************************************************************

 $Function:    	iconsShowScene

 $Description:	Shows the scene mode icons
 
 $Returns:		0 if error detected, otherwise 1

 $Arguments:	scenestatus, the current scene icon to be displayed
 
*******************************************************************************/

int iconsShowScenemode (U8 scenestatus)
{
    int i;

    /* If we have an error, ie invalid id then return 0
    */
    if( ( scenestatus < 0 ) || ( scenestatus >= iconSceneMax ) )
        return 0;
    // Otherwise clear all of the scene icons, and then set the selected value to be visible
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON_SEL_MASK(ICON_SCENE, scenestatus);
    //drawIconByIcnAttr(&scene_Attr[scenestatus],&sceneMask_Attr[scenestatus]);
#if 0	
    for( i = 0; i < iconSceneMax; i++ )
        scenestate[ i ].state = ICON_INVISIBLE;
    scenestate[ scenestatus ].state = ICON_VISIBLE;

    // and display the current selection

    icnShow( scenestate[ scenestatus ].h );
#endif   
    //xsf changed to display transparent bmp 2002.09.25
    /* switch(scenestatus)
     {
      case NORMAL_ENV:
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)normalbmp, DSPL_BMPXOR);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)normalmask,  DSPL_BMPAND);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)normalbmp, DSPL_BMPXOR);
       break;
      case OUTDOOR_ENV:
       dspl_BitBlt( 36, 2, 15, 12 0, (void *)outbmp, DSPL_BMPXOR);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)outdoormask,  DSPL_BMPAND);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)outbmp, DSPL_BMPXOR);
       break;
      case MEETING_ENV:
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)meetingbmp, DSPL_BMPXOR);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)meetingmask,  DSPL_BMPAND);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)meetingbmp, DSPL_BMPXOR);
       break;
      case INCAR_ENV:
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)incarbmp, DSPL_BMPXOR);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)incarmask,  DSPL_BMPAND);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)incarbmp, DSPL_BMPXOR);
       break;
      case MUTE_ENV:
       dspl_BitBlt( 36, 2, 15, 12, (void *)mutebmp, DSPL_BMPXOR);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)mutemask,  DSPL_BMPAND);
       dspl_BitBlt( 36, 2, 15, 12, 0, (void *)mutebmp, DSPL_BMPXOR);
       break;
      default:
       break;
      }*/
    return 1;
}


/*void iconsShowAlarmIcon()
{
     if(state[iconIdAlarm].state == ICON_VISIBLE)
        {
           dspl_BitBlt( 104, 125, 11, 12, 0, (void *)alarmBit, DSPL_BMPXOR);
           dspl_BitBlt( 104, 125, 11, 12, 0, (void *)alarmBitMask,  DSPL_BMPAND);
           dspl_BitBlt( 104, 125, 11, 12, 0, (void *)alarmBit, DSPL_BMPXOR);
        }
}*/
#if 0

void iconsShowTimerIcon()
{
    if( state[iconIdTimer].state == ICON_VISIBLE )
    {
        dspl_BitBlt( 105,  110, 12, 12, 0, (void *)TimerBit, DSPL_BMPXOR);
        dspl_BitBlt( 105,  110, 12, 12, 0, (void *)TimerBitMask,  DSPL_BMPAND);
        dspl_BitBlt( 105,  110, 12, 12, 0, (void *)TimerBit, DSPL_BMPXOR);
    }
}
#endif
/*******************************************************************************

 $Function:    	iconsShowVolume

 $Description:	Shows the melody volume's adjusting  bmp
 
 $Returns:		0 if error detected, otherwise 1

 $Arguments:	volume, the current volume to be displayed

 $Author:    xsf add for display adjust melody volume'bmp 2002.08.27
 
 $History:
 ********2003/12/02,talcon modify
 
*******************************************************************************/
int iconsShowVolume (U8 volumestatus)
{
    int i;
    // char debug[20];

    //sprintf(debug, "iconsShowVolume: %d", volumestatus);
    //TRACE_EVENT(debug);
    /* If we have an error, ie invalid id then return 0
    */
    if( ( volumestatus < 0 ) || ( volumestatus > 6 ) )
        return 0;

#if (MAIN_LCD_SIZE==3)//jhxu720
	DRAW_ICON(ICON_VOLUME_BKG);//shiheng for pic manage
	DRAW_ICON(ICON_VOLUME);
	for( i = 0; i < volumestatus; i++ )
    {
		//drawIconByIcnAttr((MfwIcnAttr*)&volume_Attr[i],NULL);
		DRAW_ICON_SEL(ICON_VOLUME_ADJUST,i);//shiheng for pic manage
    }
#elif ( MAIN_LCD_SIZE==4 )
    DRAW_ICON(ICON_VOLUME_BK);
    DRAW_ICON(ICON_VOLUME_BAR);
    //dspl_BitBlt(37, 69, 58, 57, 0, (void *)volume_icon, 0);
    //dspl_BitBlt(15, 36,  99, 12,  0, (void *)volume_process, 0);
    for( i = 0; i < volumestatus; i++ )
    {
        DRAW_ICON_LOCATION(ICON_VOLUME_RATE, 17+16*i, 38);
        //dspl_BitBlt(17+16*i, 38, 15, 8, 0, (void *)volume_play, 0);
    }

#elif ( MAIN_LCD_SIZE==2 )
    // 2004.3.18 WYJ modify
    dspl_BitBlt(0, 13, 102, 52, 0, (void *)volumeBkg , 0);
    dspl_BitBlt(3, 48, 15, 17, 0, (void *)icnVolume , 0);


    for( i = 0; i < volumestatus; i++ )
    {
        drawIconByIcnAttr((MfwIcnAttr*)&volume_Attr[i],NULL);
    }
#endif
    return 1;
}

//xsf add 2002.08.27 about adjust melody volume

/* melody volume icons    //xsf add 2002.08.27 

   */
#if 0/*2003/12/03,talcon commit it*/
void  VolumeIconInit(void)
{
    int i;
    for( i = 0; i < volumebmp; i++ )
    {
        volumestate[i].state = ICON_INVISIBLE;
        volumestate[i].h = icnCreate( 0, (MfwIcnAttr *)&volume_Attr[i], E_ICN_VISIBLE, (MfwCb) iconsSignEvent );
    }
}
void  VolumeIconDel(void)
{  
    int i; 
    for( i = 0; i < volumebmp; i++ )
        icnDelete( volumestate[i].h );
}
#endif
/*******************************************************************************

 $Function:    	iconsInputShow

 $Description:	show current input icons
 
 $Returns:		None

 $Arguments:	IconInputId, id of icon to be displayed
 
*******************************************************************************/

void iconsInputShow (int IconInputId)
{
    CLEAR_BOTTOM_ZONE_ICON;
    //	icnShow( inputstate[ IconInputId ].h );
}


/*******************************************************************************

 $Function:    	iconsMainIconsAreaSet

 $Description:	sets the current main icons area
 
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/

void iconsMainIconsAreaSet (MfwRect selected_area)
{
#if 0/*2003/11/19,talcon comment it*/
    mainIconSimToolkit.area   =    selected_area;
    mainIconCalculator.area   = selected_area;
    mainIconSettings.area   =   selected_area;
    mainIconWAP.area      =     selected_area;
    mainIconRecentCalls.area   =   selected_area;
    mainIconSettings.area   =   selected_area;
    mainIconCallDivert.area   = selected_area;
    mainIconSecurity.area   =   selected_area;
    mainIconMessages.area   =   selected_area;
    mainIconPhonebook.area   =  selected_area;
#endif
}
/*2003/12/15,talcon delete*/
#if 0
void dspl_IdleBackBmp(int i)
{
    switch( i )
    {
    case 1:
        dspl_BitBlt  (0,16,128,126,0,(void *)iconMainIdle0, 0);//hxl changed for don't clear the first and last line 20020929
        break;
    case 2:
        dspl_BitBlt  (0,0,128,160,0,(void *)iconMainIdle1, 0);
        break;
    case 3:
        dspl_BitBlt  (0,16,120,126,0,(void *)iconMainIdle2, 0);
        break;
    case 4:
        dspl_BitBlt  (0,16,120,126,0,(void *)iconMainIdle3, 0);
        break;
    case 5:
        dspl_BitBlt  (0,16,120,126,0,(void *)iconMainIdle4, 0);
        break;
    case 6:
        dspl_BitBlt  (0,16,120,126,0,(void *)iconMainIdle5, 0);
        break;
    case 7:
        dspl_BitBlt  (0,16,120,126,0,(void *)iconMainIdle6, 0);
        break;
    case 8:
        dspl_BitBltUser(1);//chenjun 2002-12-30
        break;//chenjun add for user defined pic,2002-12-29, PCSync 
    default:
        break;
    }
}
#endif
/* 2004/01/04 sunsj modify coordinate */
void drawDownbmp(void)
{
    int softkey_y;

    softkey_y = SCREEN_SIZE_Y - dspl_GetFontHeight();
    //dspl_BitBlt(0, SCREEN_SIZE_Y - menudown[FlashSettingData.theme].area.sy, menudown[FlashSettingData.theme].area.sx, menudown[FlashSettingData.theme].area.sy, 0, (void*)menudown[FlashSettingData.theme].icons, 0);
}

/*********************************************************************************
$Function:		drawIconByIcnAttr
$Description:	draw Icon
$Author:		talcon 
$History:
*******2003/11/12,talcon create
*********************************************************************************/
void drawIconByIcnAttr(MfwIcnAttr* icn,MfwIcnAttr* icnMask)
{
    TRACE_EVENT("drawIconByIcnAttr");
    MmiTrace("drawIconByIcnAttr");

    if( icn == NULL || icn->icons == NULL )
    {
        MmiTrace("drawIconByIcnAttr:Invalid argument");
        return;
    }
    if( icnMask && icnMask-> icons )
    {
        pdspl_BitBlt(icn->area.px,icn->area.py, 
                     icn->area.sx,icn->area.sy, 0,
                     icn->icons,
                     DSPL_BMPXOR);

        pdspl_BitBlt(icn->area.px,icn->area.py, 
                     icn->area.sx,icn->area.sy, 0,
                     icnMask->icons,DSPL_BMPAND);
        pdspl_BitBlt(icn->area.px,icn->area.py, 
                     icn->area.sx,icn->area.sy, 0,
                     icn->icons,
                     DSPL_BMPXOR);
    }
    else
    {
        pdspl_BitBlt(icn->area.px,icn->area.py, 
                     icn->area.sx,icn->area.sy, 0,
                     icn->icons,
                     0);
    }

}
void drawIconByAttrRect(MfwRect *area,char* icn,char* icnMask)
{
    if( icn == NULL || area == NULL )return;
    if( icnMask )
    {
        pdspl_BitBlt(area->px,area->py, 
                     area->sx,area->sy, 0,
                     icn,
                     DSPL_BMPXOR);

        pdspl_BitBlt(area->px,area->py, 
                     area->sx,area->sy, 0,
                     icnMask,DSPL_BMPAND);
        pdspl_BitBlt(area->px,area->py, 
                     area->sx,area->sy, 0,
                     icn,
                     DSPL_BMPXOR);
    }
    else
    {
        pdspl_BitBlt(area->px,area->py, 
                     area->sx,area->sy, 0,
                     icn,
                     0);
    }
}
/*********************************************************************************
$Function:		drawIdelIcons
$Description:	draw Idle top icons
$Author:		talcon 
$History:
*******2003/11/12,talcon create
*********************************************************************************/
void drawIdelIcons()
{
    int flagsZoneBeDraw = 0x02 | 0x08;/*ʾ
     *	0x01:(23,1,12,12)
     *  0x02:(23+12,1,12,12))
     ...
     */

    //#define ICNTEST
    TRACE_EVENT("drawIdelIcons");
    MmiTrace("drawIdelIcons");

    if( globalMobileMode == (GlobalCharging|GlobalDisplayFlag) )
    {
        TRACE_FUNCTION(" ! clear GlobalDisplayFlag !");
        globalMobileMode = globalMobileMode & (~GlobalDisplayFlag);

        //globalFlashBattery ();
    }

    //Invalid
    if( GlobalIconStatus & GlobalSMSIconFlag )
    {
        if( state[ iconIdSMS ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdSMS);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdSMS ],(MfwIcnAttr*)&idl_AttrMask[iconIdSMS ]);
        }
    }

    if( GlobalIconStatus & GlobalSignalIconFlag )
        iconsShowSignal( globalSignalPicNumber );

    //xsf add 2002.08.15
    if( GlobalIconStatus & GlobalRingerIconFlag )
    {
        iconsShowScenemode( FlashEnvironmentData.CurrentEnv );
    }
    //nm do it later, step by step
    //InValid		
    if( GlobalIconStatus & GlobalVoiceMailIconFlag )
    {
        if( state[ iconIdVoice ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdVoice);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdVoice],(MfwIcnAttr*)&idl_AttrMask[iconIdVoice]);
        }
    }
    //ת	
#ifndef ICNTEST
    if( GlobalIconStatus & GlobalCallForwardingIconFlag )
        if( state[ iconIdCallFor ].state == ICON_VISIBLE )
#endif
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdCallFor);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdCallFor],(MfwIcnAttr*)&idl_AttrMask[iconIdCallFor]);
        }

        //InValid	
    if( GlobalIconStatus & GlobalKeyplockIconFlag )
    {
        if( state[ iconIdKeyplock ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdKeyplock);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdKeyplock],(MfwIcnAttr*)&idl_AttrMask[iconIdKeyplock]);
        }
    }
    //iconsShowIcon( &state[ iconIdKeyplock ] );
    //InValid	
    if( GlobalIconStatus & GlobalCipheringActivIconFlag )
    {
        if( state[ iconIdCipheringActiv ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdCipheringActiv);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdCipheringActiv],(MfwIcnAttr*)&idl_AttrMask[iconIdCipheringActiv]);
        }
    }

    //Invalid	
    if( GlobalIconStatus & GlobalCipheringDeactivIconFlag )
    {
        if( state[ iconIdCipheringDeActiv ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdCipheringDeActiv);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdCipheringDeActiv],(MfwIcnAttr*)&idl_AttrMask[iconIdCipheringDeActiv]);
        }
    }
    //Gprs		
#ifdef MMI_GPRS_ENABLED
#ifndef ICNTEST
    if( GlobalIconStatus & GlobalGPRSOnIconFlag )
    {
        if( state[ iconIdGPRSAttached ].state == ICON_VISIBLE )
#endif
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdGPRSAttached);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdGPRSAttached],(MfwIcnAttr*)&idl_AttrMask[iconIdGPRSAttached]);
            flagsZoneBeDraw |= 0x01;
        }
#ifndef ICNTEST
    }
#endif

#endif
    /* SPR759 - SH - Show Homezone icon. */
#ifdef MMI_HOMEZONE_ENABLED
    if( GlobalIconStatus & GlobalHomezoneIconFlag )
    {
        if( state[ iconIdHomezone ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdHomezone);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdHomezone],NULL);
        }
    }
#endif


#ifndef ICNTEST	
    if( GlobalIconStatus & GlobalIconRoamFlag )
        if( state[ iconRoam ].state == ICON_VISIBLE )
#endif
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconRoam);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconRoam],(MfwIcnAttr*)&idl_AttrMask[iconRoam]);
            flagsZoneBeDraw |= 0x04;
        }

    if( GlobalIconStatus & GlobalIconServiceFlag )      //xsf add for service line icon 12.09
    {
        if( state[ iconServices1 ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconServices1);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconServices1],(MfwIcnAttr*)&idl_AttrMask[iconServices1]);
        }
        else if( state[ iconServices2 ].state == ICON_VISIBLE )
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconServices2);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconServices2],(MfwIcnAttr*)&idl_AttrMask[iconServices2]);
        }
    }
#ifndef ICNTEST	
    if( GlobalIconStatus & GlobalAlarmIconFlag )
        if( state[ iconIdAlarm ].state == ICON_VISIBLE )
#endif
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdAlarm);
            //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdAlarm],(MfwIcnAttr*)&idl_AttrMask[iconIdAlarm]);
            flagsZoneBeDraw |= 0x10;
        }

#ifndef ICNTEST
    if( GlobalIconStatus & GlobalIconTimerFlag )
        if( state[iconIdTimer].state == ICON_VISIBLE )
#endif
        {
            MfwRect area;
            int flag = 0x01;
            /* 2004/06 sunsj modify for picture manage */
            memcpy(&area,&icontable[ICON_IDLESTATE].icon[iconIdGPRSAttached].area/*&idl_Attr[iconIdGPRSAttached].area*/, sizeof(area));
            while( area.px <= icontable[ICON_IDLESTATE].icon[iconIdAlarm].area.px/*idl_Attr[iconIdAlarm].area.px*/ )
            {
                if( (flag & flagsZoneBeDraw) == 0 )
                {
                    break;
                }
                area.px += icontable[ICON_IDLESTATE].icon[iconIdGPRSAttached].area.sx;//idl_Attr[iconIdGPRSAttached].area.sx;
                flag <<= 1;
            }

            if( area.px <= icontable[ICON_IDLESTATE].icon[iconIdAlarm].area.px/*idl_Attr[iconIdAlarm].area.px*/ )
            {
                /* 2004/06 sunsj modify for picture manage */

                DRAW_ICON_ATTRIBUTE(ICON_IDLESTATE, area.px, area.py, iconIdTimer, ICON_MASK|ICON_LOCATION);

                //drawIconByAttrRect(&area,idl_Attr[iconIdTimer].icons,idl_AttrMask[iconIdTimer].icons);
            }
            else
            {
                /* 2004/06 sunsj modify for picture manage */
                DRAW_ICON_SEL_MASK(ICON_IDLESTATE, iconIdTimer);
                //drawIconByIcnAttr((MfwIcnAttr*)&idl_Attr[iconIdTimer],(MfwIcnAttr*)&idl_AttrMask[iconIdTimer]);
            }
        }
}

/*********************************************************************************
$Function:		drawAnimIcons
$Description:	draw Animation Icons
$Author:		talcon 
$History:
*******2003/11/18,talcon create
*********************************************************************************/
U8 drawAnimIcons(MfwIcnAttr *icnAttr,U8 nIndex)
{   
    U8 uNewIndex = nIndex + 1;
    MfwIcnAttr * icnBkg = 0;
    MfwIcnAttr * icnCurrent = 0;

    U8 uloop= 0 ;
    U8 uI;

    if( (icnBkg = icnAttr) == 0 )
    {
        return 0xff;
    }

    //draw bkg
    drawIconByIcnAttr(icnBkg,NULL);

    icnCurrent = icnAttr + 1;

    while( icnCurrent->nIcons && nIndex )
    {
        if( icnCurrent->icons == 0 )
        {
            icnCurrent +=  icnCurrent->nIcons + 1;
            nIndex -- ;
            if( nIndex == 0 )
                break;
        }
        else
            return 0xff;
    }


    if( nIndex || icnCurrent->nIcons == 0 )
    {
        return 0xff;
    }


    //draw anim
    uloop = icnCurrent->nIcons;
    for( uI = 0; uI < uloop ;uI++ )
    {
        drawIconByIcnAttr(++icnCurrent,NULL);
    }

    if( (icnCurrent+1)->nIcons == 0 )
        uNewIndex = 0;
    return uNewIndex;

}
/*******************************************************************************
                                                                              
                                End Of File
                                                                              
*******************************************************************************/

