#ifndef _MMIICONS_H_
#define _MMIICONS_H_ 1

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Icons
 $File:		    MmiIcons.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the implementation of the icon handling in the basic MMI
                        
********************************************************************************
 $History: MmiIcons.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiIcons.h

	22/07/02			zy Mobile Innovation add "confirm" Icon
	   
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiIcons.h

		Date .................. Modification ......................................
    01/08/02	  version 0.100 zy Mobile Innovation add "situation" "situation2" Icon	
    01/08/02      version 0.101 zy add "call_Attr,callAlert_Attr,callIncoming_Attr,UserBusy,NetNotAvail.NetBusy"and relatives icons 
                  for call interface    
    04/08/02      version 0.102 zy add icons about animation on and idle use icons and setting menu's icons
    09/08         version 0.103 windy modified
    19/08/02      version 0.104 xusufang modified 
  29/08/02   version 0.108 xsf modified for melody volume bmps
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Required Definitions
                                                                              
*******************************************************************************/
#include "mmiQQSwitch.h" //hxl add for check qq func

#include "mfw_mfw.h"
#include "mfw_icn.h"

/* 2004/06 sunsj modify for icon manage */
//#include "mmiicnIdle.h"
//#include "mmiicnOuterIdle.h"
//#include "mmiicnOther.h"
#include "mmiiconresource.h"
//#include "mmiicnMainmnu.h"

#define ALLOC_MEMORY mfwAlloc
#define FREE_MEMORY  mfwFree

typedef struct iconStateTag             /* state icons              */
{
    MfwHnd h;                           /* mfw handle of icon       */
    U8 state;                           /* state of icon            */
} IconState;

extern IconState state_Outer[ idlIdMax ]; //2004/03/11 Sunny add

/*******************************************************************************
                                                                              
                                Public method prototypes
                                                                              
*******************************************************************************/

void iconsInit( void );
void iconsExit( void );

void iconsSetState( int icon );
void iconsDeleteState( int icon );
U8 iconsGetState( int icon );

void iconsShow( void );
int iconsShowVolume (U8 volumestatus);  //xsf add 2002.08.27 for melody volume  3 lines
//void  VolumeIconDel(void);
//void  VolumeIconInit(void);
int  iconsShowBattery( U8 batterystatus );
int  iconsShowSignal( U8 signalstatus );
void iconsInputShow( int IconInputId );

void iconsChargeDisplayOnOff( int on );
void iconsStateOfCharge( void );
void iconsMainIconsAreaSet (MfwRect selected_area);
void iconShowGoodbye();
//void dspl_IdleBackBmp(int i);//zy for select different backbmp  04/08/02

/* 2003/10/30 ,talcon add */
//MfwIcnAttr *  get_bkgicnAttr(int i);
/* 2003/11/12 ,talcon add */
void drawIconByIcnAttr(MfwIcnAttr* icn,MfwIcnAttr* icnMask);
void drawIconByAttrRect(MfwRect *area,char* icn,char* icnMask);
void drawIdelIcons();
/*end talcon add */

/* 2003/11/18 ,talcon add */
U8 drawAnimIcons(MfwIcnAttr *icnAttr,U8 nIndex);

#define ICON_VISIBLE	(0)
#define ICON_INVISIBLE	(0xFF)

/* 2003/1106,talcon add */

/*******************************************************************************
                                                                              
                                End Of File
                                                                              
*******************************************************************************/

#endif

 
