/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Idle
 $File:		    MmiIdle.c 
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

   Handling for the idle screen
                        
********************************************************************************
 $History: MmiIdle.c

    25/10/00			Original Condat(UK) BMI version.	
       
 $End

*******************************************************************************/
/********************************************************************************
 $History: MmiIdle.c  ver1.86
    date         version     comment
    02/09/02     0.10       change the gblink timer to 3seconds, and do not set timer frequentyl ganchh

    21/06/02			zy for forbid update idlewin when the focused win is not focused
                        in idle
    04/08/02            zy change the idle display arrangement
                        and the softkey and relative fuction
    09/08         windy modified
    15/08/02        xsf modified for switch scene mode in idle window
  26/08/02		hxl add for charger
  29/08/02		hxl changed for charger
   18/09/02            xsf add codes for missedcallTone and unreadSMSTone timer 
   11/04/03		talcon,fix bug reboot when evironment setting in idle
 $End

*******************************************************************************/
/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/



#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
//#include <stdio.h>
//#include <string.h>

//#include "mfw_sys.h"

//#include "stddefs.h"
//#include "custom.h"
//#include "gsm.h"
//#include "vsi.h"


#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_cm.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"




#include "dspl.h"
#include "MmiMmi.h"

#include "ksd.h"
#include "psa.h"


#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMain.h"
#include "MmiStart.h"

#include "MmiMenu.h"

#include "MmiBookController.h"
#include "MmiBookUtils.h"

#ifdef MMI_EM_ENABLED	//robert.chen added, 2004-08-02
#include "MmiEm.h"
#endif

#include "MmiCall.h"
#include "MmiNetwork.h"
#include "MmiIcons.h"
#include "MmiEditor.h"


#include "MmiSounds.h"
#include "MmiUserData.h"
#include "MmiSoftKeys.h"
#include "MmiPins.h"

#include "MmiDialogs.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSettings.h"
#include "MmiSmsIdle.h"
#include "mfw_ffs.h"
#include "MmiSmsBroadcast.h"
#include "MmiCPHS.h"
#ifdef MMI_HOMEZONE_ENABLED
    #include "MmiHomezone.h"	/* SPR759 - SH*/
#endif
#include "gdi.h"
#include "audio.h"
#include "GameDisplay.h"//zy add 09/18

#include "cus_aci.h"
#include "p_sim.h"
//GW-Remove? #include "pcm.h"
#include "pwr.h" //hxl add for charger
#include "mmicharging.h"
#include "mmiservices.h" //wufei add 
#include "fieldtest.h"
#include "L1tm_cust_add.h"	//hxl add for pcsync 2003-1-5

#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    #include "mmiqq.h" 
#endif
/*2003/11/20,talcon add */
//#define TDTRACE 1
#include "mmiutilapi.h"
#include "mmiouterIdle.h" /*2003/12/27, wangyan add incoming call outsidescreen*/
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

#include "encrypt.h"
#undef JVJ_USSD_TEST
//#define EDITOR_SIZE 41	// sbh - moved to MmiIdle.h
extern UBYTE mfw_IMSI [];                  /* expanded IMSI (ASCIIZ)   */
extern BOOL phonebook_search_flag;
//#define _DAIENABLE_
/*********************************************************************
**********************************************************************

                    IDLE WINDOW. DECLARATION

*********************************************************************
**********************************************************************/

/*
*  This is a static window (also called dialog), it remains always, so that we dont have to worry a memory allocation
*/
/*
    The typedef for T_idle has been moved into the MmiIdle.h file.
*/

T_idle idle_data;                       // This is a static window, and the related data are also static.

/*
*  These are common functions xxx_create and xxx_destroy
*/
T_MFW_HND idle_create (T_MFW_HND parent_window);
void idle_destroy (T_MFW_HND own_window);
void DAIsignalEnable();   //the function to enable the DAI signal

/*
*  This dialog function (the same name as the window)
* is used to handle the comunication between different windows. The global macro SEND_EVENT can be used with parameter win
* and the corresponding events to send from one mmi dialog to another.
*/

void idle (T_MFW_HND win, USHORT event, SHORT value, void * parameter);


/*
*  These are common optional functions handler
*/


static int idle_win_cb(MfwEvt e, MfwWin *w);
static int idle_kbd_cb (MfwEvt e, MfwKbd *k);
static int idle_kbd_long_cb (MfwEvt e, MfwKbd *k);
extern uint8 MCallHintDleteFlag;  //hu binhao  2003-1-29 





static int idleExeSendMessage(MfwMnu* m, MfwMnuItem* i);
MfwHnd VOS_Idle_Win;                    /* our window               */




extern UBYTE getCurrentRingerSettings(void );
extern UBYTE animation_complete;

void idle_Ciphering (UBYTE gsm_ciph, UBYTE gprs_ciph);

U16 AlarmStatus = 0;   

extern UBYTE HUPKeyOrigin; // sbh - set to 1 if POWER_KEY is pressed in idle screen
UBYTE test_sim; // SH
extern void Force_refresh();
extern void MmiTrace(char * str);
extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13

/*2003/10/30,talcon add*/
//MfwIcnAttr *  get_bkgicnAttr(int i);
static int idlebkganim_timer_cb(MfwEvt e, MfwTim *t);
void dspl_IdleBackBmpAnim(int i,UBYTE * pIndx);
/* end talcon */
/*2003/11/01,talcon add*/
static int draw_idleAnim();
/*end talcon */

/*2003/11/13,talcon add it */
void drawIdle();
/*2003//11/29,talcon add*/
void setIdleDrawFlags(U32 nFlags,U8 nMask);
/*2003/12/03,talcon add*/
extern GLOBAL int get_StringWidth(char *string);
/*********************************************************************
**********************************************************************

                    DIALLING WINDOW. DECLARATION

*********************************************************************
**********************************************************************/

/*
*  This is a dinamic dialog, it must be created only when dialling in idle screen, and destroyed automatically after calling
* or clearing
*/



#define WIN_DIALLING_ORG_X    0
#define WIN_CENTRALIZE_ORG_X 30

#define XOFFSET 1
#define YOFFSET 1

/* 2004/01/04 sunsj modify for different lcd size */
#if (MAIN_LCD_SIZE==3) 
#define IDLEOFFSET_X		5
#define IDLENUMBERWIDTH		15
#define IDLENUMBERHIGH		17
#define IDLEOFFSET			10//60//shiheng 288 for idle dial
#define IDLEPHONE_NUMBER    8
#elif ( MAIN_LCD_SIZE==4 )
#define IDLENUMBERWIDTH		15
#define IDLENUMBERHIGH		17
#define IDLEOFFSET			0
#define IDLEOFFSET_X		4
#define IDLEPHONE_NUMBER    8
#elif ( MAIN_LCD_SIZE==2 )
#define IDLENUMBERWIDTH		10
#define IDLENUMBERHIGH		14
#define IDLEOFFSET			0
#define IDLEPHONE_NUMBER    10
#endif

#define YLINE 9

#define KEYPADLOCK_BUF_SIZE	4
#if ( MAIN_LCD_SIZE==4 )
/* 2004/06 sunsj modify for icon manage */
unsigned int idlewallpaperId[] = 
{
    ICON_IDLESTATICWALLPAPER_1,
    ICON_IDLESTATICWALLPAPER_2,
    ICON_IDLESTATICWALLPAPER_3,
    ICON_IDLESTATICWALLPAPER_4,
    ICON_IDLESTATICWALLPAPER_5,
    ICON_IDLESTATICWALLPAPER_6,
};
#endif
/*
*  The information related to every window must be encapsulated in such an structure
*/

typedef struct
{
    T_MMI_CONTROL   mmi_control;        // common control parameter
    T_MFW_HND win;
    T_MFW_HND kbd;
    T_MFW_HND kbd_long;
    T_MFW_HND edt;
} T_idle_dialling;
#if 0
typedef struct
{
    /* administrative data */

    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         win;
    T_MFW_HND         parent_win;
    T_EDITOR_DATA   editor_data;
    T_MFW_HND          kbd;

    /* internal data */
    char        buffer[100];
    UBYTE       status;

} tSpecialMode;
#endif
//typedef          long  WORD32;


/*
*  These are common functions xxx_create and xxx_destroy
*/

T_MFW_HND idle_dialling_create(MfwHnd parent);
void idle_dialling_exit (void);


/*
*  This dialog function (the same name as the window)
* is used to handle the comunication between different windows. The global macro SEND_EVENT can be used with parameter win
* and the corresponding events to send from one mmi dialog to another.
*/

void idle_dialling (T_MFW_HND win, USHORT event, SHORT value, void * parameter);

/*
*  These are common optional functions handler
*/


static int idle_dialling_kbd_cb (MfwEvt e, MfwKbd *k);
static int idle_dialling_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int idle_dialling_win_cb (MfwEvt e, MfwWin *w);

/*
*  This an optional function, used often to call, create and init a new dialog, with different parameters depending
* on the context
*/


T_MFW_HND idle_dialling_start (T_MFW_HND win_parent,char *character);



/*********************************************************************
**********************************************************************

                    OPTIONS DIALLING WINDOW. DECLARATION

*********************************************************************
**********************************************************************/



#define WIN_OPTIONS_DIALLING_ORG_X 0
#define WIN_OPTIONS_DIALLING_ORG_Y SECOND_LINE

#define WIN_OPTIONS_DIALLING_X_OFFSET 1
#define WIN_OPTIONS_DIALLING_Y_OFFSET 1



T_MFW_HND idle_dialling_options_create(MfwHnd parent);
void idle_dialling_options_destroy (T_MFW_HND own_window);

static int idle_dialling_options_kbd_cb (MfwEvt e, MfwKbd *k);
static int idle_dialling_options_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int idle_dialling_options_win_cb (MfwEvt e, MfwWin *w);
static int idle_dialling_options_mnu_cb (MfwEvt e, MfwMnu *m);

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND win;     // window handle
    T_MFW_HND kbd;
    T_MFW_HND kbd_long;
    T_MFW_HND menu;
} T_idle_dialling_options;





/*********************************************************************
**********************************************************************

                    KEYPADLOCKED WINDOW. DECLARATION

*********************************************************************
**********************************************************************/


T_MFW_HND idle_key_pad_locked_create(MfwHnd parent);
void idle_key_pad_locked_destroy (T_MFW_HND own_window);

static int idle_key_pad_locked_kbd_cb (MfwEvt e, MfwKbd *k);
static int idle_key_pad_locked_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int idle_key_pad_locked_win_cb (MfwEvt e, MfwWin *w);

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND win;     // window handle
    T_MFW_HND kbd;
    T_MFW_HND kbd_long;
    T_MFW_HND edt;
    T_MFW_HND win_info;     // window handle
    UBYTE menuPressed;
    UBYTE keyPadLockBuf[KEYPADLOCK_BUF_SIZE];
} T_idle_key_pad_locked;

void idle_key_pad_locked (T_MFW_HND win, USHORT event, SHORT value, void * parameter);



static void (*showKeyPadLocked) (void);
static void showSOSCallKeyPadLocked(void);
void idle_info_destroy_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void DrawSceneselect_rect(void); //xsf add 11.28

/*********************************************************************
**********************************************************************

                    Information WINDOW. DECLARATION

*********************************************************************
**********************************************************************/



static int lockTimerEvent(MfwEvt e, MfwTim *t);
static void showPressMenuStar(void);
static void showNothing(void);



T_MFW_HND idle_information_create(MfwHnd parent);
void idle_information_destroy (T_MFW_HND own_window);

static int idle_information_kbd_cb (MfwEvt e, MfwKbd *k);
static int idle_information_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int idle_information_win_cb (MfwEvt e, MfwWin *w);

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND win;     // window handle
    T_MFW_HND parent_win;
    T_MFW_HND timer;
    T_VOID_FUNC info_cb;
    T_MFW_HND kbd;
} T_idle_information;



void idle_information (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
T_MFW_HND idle_information_start(MfwHnd win_parent,S32 time,void (*show)(void),T_VOID_FUNC info_cb);





static void (*showInformation)(void);


static int idle_information_tim_cb(MfwEvt e, MfwTim *t);
static int idle_imei_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reason);

extern UBYTE  IsShowGoodbye; //2004-04-23 Sunny add

#if 0
//T_MFW_HND ShowVersion(T_MFW_HND parent_window);
static T_MFW_HND ShowVersion_create(MfwHnd parent_window);
static void ShowVersion_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier, void *parameter);
void ShowVersionSetEditor(T_MFW_HND win);
static void ShowVerionCB (MfwEvt e, MfwKbd *k);
void showVersion_destroy(MfwHnd own_window);
const char * date = "2003.01.27";
const char * ver  = "Ver1.88";
const char * label = "Toolbox_gdy_0127";
const char * purpose    = "";
#endif
extern U8 LockBand;  //xsf add 2002.08.05
extern T_call call_data;  //xsf add 11.19
extern UBYTE anim_real_complete;    //xsf add 2002.11.26 for idle update when PIN or HOSTKEY is open
extern char CBmid[5];//windy added
//hxl add for charger 29/08/02--------------------------------
#define TIME_BLINK     2000
UBYTE CurrentBatPicNum=0;
UBYTE OlderCurrentBatPicNum=0;
UBYTE   BlinkBatPicnum=0;
static MfwHnd gtimeBlink=0;
static UBYTE    IsBlinktimerRun=0;//Ƿcharge
static UBYTE    idleisshown=0;
static MfwHnd gtimeMissedCall;   //xsf add 2002.09.16 2 lines
#define TIME_MISSEDCALLS    5000  // 60*5s = 5 minute
static UBYTE  tim_missedcalls=0;  //xsf add 11.14
static UBYTE  SceneSelect_mode=0;  //xsf add 11.27 for secne mode in idle

static int missedCallEvent (MfwEvt e, MfwTim *t);
static int blinkEvent (MfwEvt e, MfwTim *t);
extern int read_sim_phb_cb(void);
static void batEvent(void);
void GetBatPicnum(void);
static int xpos,ypos;//zy
//end of hxl add for charger 29/08/02--------------------------
//begin of xzy add for test special mode 2002/12/30
#if 0
static T_MFW_HND LayeronePara_create(MfwHnd parent_window);
static void LayeronePara_DialogCB(T_MFW_HND win, USHORT e,  SHORT identifier,void *parameter);
//void LayeroneParaSetEditor(T_MFW_HND win);
//static void LayeroneParaCB( T_MFW_HND win, USHORT Identifier,UBYTE reason);
//static int  LayeronePara_winCB (T_MFW_EVENT event, T_MFW_WIN * win);
static int LayeronePara_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
static T_MFW_CB showRssi_timercb (T_MFW_EVENT event, T_MFW_TIM *tc);
void LayeronePara_destroy(MfwHnd own_window);
extern void layer1_em_get_rxlevqual(WORD32 *l1_rxlev_scell,WORD32 *l1_rxlev_dedic_sub,WORD32 *l1_rxqual_dedic,WORD32 *l1_rxqual_dedic_sub); //xzy add for test mode 2002/12/30
extern void layer1_em_get_mode(WORD32 *l1_mode);
static T_MFW_HND show_timer;         //the timer for show_rssi
static unsigned char refresh_flag;      //the flag for need refresh or not
#endif
//end of xzy add for test special mode 2002/12/30
uint8 SimCFReadFlag=0; //hu binhao 2002-12-23 for bug 5110
UBYTE IsMissedCallAndSms = 0; //2004-04-01 Sunny add
//extern int new_sms_index;
extern SHORT g_sms_list_counter;
//Bob added
//indicate ledblink reason
extern MfwHnd ledblink;
extern UBYTE ledblinkflag;
//Bob added to indicate Hall state 01/23
extern driver_Parameter drvpara;
//Bob added to indicate if incoming call or not 01/23
extern BOOL IncallLedisRun;
extern pwr_Status_Type    pwr_Status;
/*********************************************************************
**********************************************************************

                    IDLE WINDOW. IMPLEMENTATION

*********************************************************************
/*******************************************************************************

 $Function:    	idleInit

 $Description:	init MMI idle handling
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




void idleInit (MfwHnd parent)
{
    T_MFW_HND hnd;
    winAutoFocus(TRUE);
    hnd = idle_create (parent);
}


/*******************************************************************************

 $Function:    	idleExit

 $Description:	 exit MMI idle handling
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idleExit (void)
{
    idle_destroy (idle_data.win);
}



/*******************************************************************************

 $Function:    	idle_create

 $Description:	 Creation of an instance for the Idle dialog.
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



T_MFW_HND idle_create (T_MFW_HND parent_window)
{
    T_idle        * data = &idle_data;
    T_MFW_WIN     * win;
    UBYTE result;

    TRACE_FUNCTION ("idle_create");

    memset(&idle_data,0,sizeof(idle_data));
    /*
     * Create window handler
     */
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)idle_win_cb);

    if( data->win EQ 0 )
        return 0;

    VOS_Idle_Win = data->win;


    /*
     * These assignments are necessary to attach the data to the window, and to handle the mmi event communication.
     */


    data->mmi_control.dialog    = (T_DIALOG_FUNC)idle;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
    * Create any other handler
    */

    data->kbd      = kbd_create (data->win,KEY_ALL|KEY_MAKE,(T_MFW_CB)idle_kbd_cb);
    data->kbd_long = kbd_create (data->win,KEY_ALL|KEY_LONG,(T_MFW_CB)idle_kbd_long_cb);
    data->edt = 0;  
    data->edt_sat = 0; /* SPR759 - SH*/

    gtimeBlink = timCreate(0,TIME_BLINK,(MfwCb)blinkEvent);//hxl add for charger 29/08/02
    gtimeMissedCall = timCreate(0,TIME_MISSEDCALLS,(MfwCb)missedCallEvent); //begin of xsf add timer for missed calls 2002.09.16
    //Bob added 01/23
    ledblink_begin();
    /* 2004/03/30 sunsj modify */
    if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
    {
        /* 2004/01/04 sunsj modify but i don't know the purpose of the editor */
        // memset (CBmid, '\0', 5);
        editor_attr_init_only(&data->edt_attr2,1, 0, SCREEN_SIZE_X-1, SCREEN_SIZE_Y-dspl_GetFontHeight()-2,2,TxtBroadcast,0,
                              MAX_CBMSG_LEN+3, edtCurNone,CBmid);
        //bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_first_line_icons(),120,128,
        //			0,0,edtCurNone,0,(char*)data->incoming_cb_msg,MAX_CBMSG_LEN,&data->edt_attr2);
        /*NM, p019*/                    
        /* 2004/01/04 sunsj modify but i don't know the purpose of the editor */
        editor_attr_init_only(&data->edt_attr3,1, 0, SCREEN_SIZE_X-1, SCREEN_SIZE_Y-dspl_GetFontHeight()-2,2,TxtSRR,(char*)data->incoming_sms_msg,
                              MAX_MSG_LEN, edtCurNone,0);
        //bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_first_line_icons(),84,24,
        //			0,0,edtCurNone,0,(char*)data->incoming_sms_msg,MAX_MSG_LEN,&data->edt_attr3);
        /* SPR759 - SH.  Create attributes for SAT editor. */
        bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_first_line_icons(),84,24,
                              0,0,edtCurNone,0,(char*)data->incoming_sat_msg,MAX_CBMSG_LEN,&data->edt_attr_sat);
    }
    else
    {
        // memset (CBmid, '\0', 5);
        editor_attr_init_only(&data->edt_attr2,1, 0, SCREEN_SIZE_X-1, STANDARD_MENU_VERTICAL_SIZE,2,TxtBroadcast,0,
                              MAX_CBMSG_LEN+3, edtCurNone,CBmid);
        //bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),120,128,
        //			0,0,edtCurNone,0,(char*)data->incoming_cb_msg,MAX_CBMSG_LEN,&data->edt_attr2);
        /*NM, p019*/
        editor_attr_init_only(&data->edt_attr3,1, 0, SCREEN_SIZE_X-1, STANDARD_MENU_VERTICAL_SIZE,2,TxtSRR,(char*)data->incoming_sms_msg,
                              MAX_MSG_LEN, edtCurNone,0);
        //bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),84,24,
        //			0,0,edtCurNone,0,(char*)data->incoming_sms_msg,MAX_MSG_LEN,&data->edt_attr3);
        /* SPR759 - SH.  Create attributes for SAT editor. */
        bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),84,24,
                              0,0,edtCurNone,0,(char*)data->incoming_sat_msg,MAX_CBMSG_LEN,&data->edt_attr_sat);
    }

    /*
        * In the new design the are created and automatically shown.
        */

    //winShow(data->win);  //hxl delete for charger 29/08/02
    data->search=FALSE;
    data->missedCalls = FlashDCTbData.MissedCallNum; //hu binhao 2002-11-29 
    data->flagIdle=FALSE;
    data->right_key_pressed = FALSE;
    addCBCH(NULL, IdleNewCBImmediateMessage);
    data->new_cbch= FALSE;
    data->clean_screen = FALSE; //for clean the DISPLAY ZONE 3
    data->ciphering = DONT_SHOW_CPRS; //use as a default




    //    data->starting_up = TRUE; /*SPR#1083 JVJ New flag for the start up procedure */

    //init the Ciphering indication
    result = sim_init_CPRS ((CallbackCPRI) idle_Ciphering, MFW_SIM_CPRI_SHOW );

    if( result == FALSE )
        TRACE_EVENT("Cant show Ciphering")

        /*2003/10/30,talcon add for idle bkg anim timer */
        data->idxbkganim = 0;
#ifndef FOR_FTA_CTA
    data->idleanimtimer = timCreate ( data->win, idleanim_timeout, (MfwCb)idlebkganim_timer_cb);
#endif
    /*end talcon */
    /*
   * return window handle
   */
    return data->win;
}


/*******************************************************************************

 $Function:    	idle_destroy

 $Description:	 Destroy the idle dialog.
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idle_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win;
    T_idle        * data;

    /*
     * The destruction of this dialog is trivial, because  the information contained is not dynamic. A better example
     * of dialog destruction can be found in dialling_destroy
    */
    TRACE_FUNCTION ("idle_destroy");


    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_idle *)win->user;

        if( data )
        {
            /* 2003/10/30,talcon */
            timStop(data->idleanimtimer);
            timDelete(data->idleanimtimer);
            /* end talcon */
            //hxl add for charger 29/08/02-----------------
            timStop(gtimeBlink);
            IsBlinktimerRun=0;
            timDelete(gtimeBlink);
            //hxl add for charger 29/08/02--------------------
            //xsf add for missed calls 2002.09.16
            timStop(gtimeMissedCall);
            timDelete(gtimeMissedCall);
            /*
             * Exit Keyboard Handler
             */
            /*
             * Delete WIN Handler
             */
            win_delete (data->win);
            data->win=0;
        }
    }
}


/*******************************************************************************

 $Function:    	idle

 $Description:	 Dialog function for idle top window.
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idle (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    U8 * key_code;
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_idle         * data = (T_idle *)win_data->user;


    /*
     * This function is called by the SEND_EVENT macro, when the parameter win is the idle window. the different events
     * come from another mmi modules.
    */


    TRACE_FUNCTION ("idle()");

    switch( event )
    {
    /*
    glowing: add the following statement for processing
    the NETWORK_LIMITED_SERVICE 
 */
    case NETWORK_LIMITED_SERVICE:
        GetSignalPicNumber();         
        data->search=TRUE;
        data->nm_status  = event;

        if( (ledblinkflag==0)&&(drvpara.hallstatusflag == 0)&&(IncallLedisRun==FALSE)&&(pwr_Status.charging_state==0) )
        {
            MmiTrace("Network is no service");
            ledblinkflag=2;
            Green_Off();
            timStart(ledblink);
            MmiTraceInt(ledblinkflag);
        }
        ledblinkflag=2; 
        if( idleIsFocussed() && anim_real_complete )
            windowsUpdate();
        break;
    case NETWORK_NO_SERVICE:
    case NETWORK_SEARCH_NETWORK:

        //Bob added for ledblink 01/23
        //Hall is off and no incoming call and no charging and Hall is off
        if( (ledblinkflag==0)&&(drvpara.hallstatusflag == 0)&&(IncallLedisRun==FALSE)&&(pwr_Status.charging_state==0) )
        {
            MmiTrace("Network is no service");
            ledblinkflag=2;
            Green_Off();
            timStart(ledblink);
            MmiTraceInt(ledblinkflag);
        }
        //Bob 02/19
        //    if((ledblinkflag!=2)&&(ledblinkflag!=0))
        ledblinkflag=2; 
    case NETWORK_NO_PLMN_XXX_AVAIL:
        /*
         * Network management indicates no or limited service
         */
        if( anim_real_complete )
            timStart(gtimeMissedCall);  //xsf add 11.14
        data->nm_status  = event;
        data->search=TRUE;
        //GetSignalPicNumber();			//xzy add for search net work signal pic number update
        SetSignalPicNumberZero();       //xzy add for no network update signal pic number
        if( idleIsFocussed() && anim_real_complete )
            windowsUpdate();
        break;
    case NETWORK_FULL_SERVICE:
        /*
         * Network will be searched or is available
         */
        //Bob added for led blink 01/23
        //Hall is off and no incoming call and no charging and Hall is off
        GetSignalPicNumber();         //xzy add for search net work signal pic number update

        if( (ledblinkflag==0)&&(drvpara.hallstatusflag == 0)&&(IncallLedisRun==FALSE)&&(pwr_Status.charging_state==0) )
        {
            MmiTrace("Network is full service");
            ledblinkflag=1;
            /* 2004/03/15 sunsj remove */
            //Red_Off();
            timStart(ledblink);
            MmiTraceInt(ledblinkflag);
        }
        //Bob 02/19
        //    if((ledblinkflag!=1)&&(ledblinkflag!=0))
        ledblinkflag=1;
#ifdef MMI_HOMEZONE_ENABLED
        if( event==NETWORK_FULL_SERVICE )
            homezoneReadSim(HZ_READ_ONCE_ONLY);     // Read in homezone data. Will do nothing on repeated calls.
#endif
        data->search=FALSE;
        data->nm_status  = event;
        if( (!(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].MissedcallTone) ||
             (FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].MissedcallTone && (!idle_data.missedCalls)))
            &&(!(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].UnreadSMSTone)||
               (FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].UnreadSMSTone&&(! idle_data.new_sms))) )
            timStop(gtimeMissedCall);  //xsf add 11.14
        if( idleIsFocussed() && anim_real_complete )
            windowsUpdate();
        //xsf 2002.07.31 for lock band
        if( LockBand&&(g_nmService==NM_FULL_SERVICE) )
        {
            LockBand=0;
            nm_restrict_bands(FFS_flashData.Band_restriction); 
        }
        break;

    case IDLE_UPDATE:
        if( idleIsFocussed() && anim_real_complete )
            windowsUpdate();
        break;

    case IDLE_NEW_SMS:
        setOuterState(OUTERIDLESTATE_SMS,1,0);//2004-03-23 Sunny modify
        // show the info about incoming sms on the idle screen
        idle_data.clean_screen = FALSE;
        timStart(gtimeMissedCall); //xsf add 2002.09.17
        /*NM, p020*/      
        if( idleIsFocussed() && anim_real_complete )
            windowsUpdate();
        break;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    case IDLE_NEW_QQ://hxl add for qq info 2003-1-5
        // show the info about incoming sms on the idle screen
        idle_data.clean_screen = FALSE;
        if( idleIsFocussed() && anim_real_complete )
            windowsUpdate();
        break;
#endif
    case IDLE_ACTIVE_KEY_PAD_LOCKED:
        /*	idle_key_pad_locked_create(win);
            windowsUpdate();*/
        break;

    case IDLE_DETAILS_NUMBER:
        idle_dialling_create(win);
        windowsUpdate();
        break;

    case IDLE_START_DIALLING_NUMBER:
        key_code = (U8*)parameter;
        memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));
        idle_data.dialshow_buf[0]=editControls[*key_code];
        idle_dialling_start(idle_data.win,NULL);
        break;

    default:
        return;
    }

}

/*******************************************************************************

 $Function:    	idleExec

 $Description:	
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idleExec (int reason, MmiState next)
{
    MmiModuleSet (ModuleIdle); /* Set the global status of Idle */
    switch( reason )
    {
    case IdleNormal:                /* enter normal idle mode   */

        winShow(idle_data.win);
        if( FFS_flashData.PLMN_selection_mode == NM_MANUAL )  //xsf add 2003.01.17
            network_start_full_service ();
        Set_regflag(TRUE);//yq modified 2003/3/17.init finished now we start set flag to record memory
        break;
    default:
        break;
    }
}


/*******************************************************************************

 $Function:    	idleEvent

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idleEvent (int reason)
{
    // sprintf(stringTrace,"IDLE event reason: %d",reason);
    // TRACE_FUNCTION(stringTrace);

    switch( reason )
    {
    case IdleSearchNetwork:
        if( idle_data.win )
            SEND_EVENT(idle_data.win,IDLE_NO_NETWORK,0,0);
        break;
    case IdleUpdate:
        if( idle_data.win )
            SEND_EVENT(idle_data.win,IDLE_UPDATE,0,0);
        break;
    case IdleNewSmsMessage:
        if( idle_data.win )
            SEND_EVENT(idle_data.win,IDLE_NEW_SMS,0,0);
        break;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    case IdleNewQQMessage://hxl add for qq 2003-1-5
        if( idle_data.win )
            SEND_EVENT(idle_data.win,IDLE_NEW_QQ,0,0);
        break;
#endif
    case IdleActiveKeyPadLocked:
        if( idle_data.win )
            SEND_EVENT(idle_data.win,IDLE_ACTIVE_KEY_PAD_LOCKED,0,0);
        break;
    case PhbkDetailListToIdle:
        if( idle_data.win )
            SEND_EVENT(idle_data.win,IDLE_DETAILS_NUMBER,0,0);
        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:    	winEvent

 $Description:	 window event handler
 
 $Returns:		

 $Arguments:	
                
 $History
  GW 03/10/01 - Rewrote to correctly display chinese strings

*******************************************************************************/
extern int gPlayKeytoneFlag;
static int idle_win_cb (MfwEvt e, MfwWin *w)
{
    T_CURRENT_NETWORK current_network;
    char text[20];
    int txtStrId;   //Id of text string to be displayed
    int txtNo;      //Numeric value to be displayed (0=no value)
    int xOfs;       //used to offset text id when a number is to be displayed 
    UINT32 oldcolor;//zy add 09/18
    UINT32 oldfontcolor;
    int8 bgindex; 
    unsigned char uMode;
    //int greetxpos;
    TRACE_FUNCTION("idle_win_cb");
    MmiTrace("idle_win_cb");
    TRACE_EVENT("zy:mfw_IMSI=");      
    TRACE_EVENT((char *) mfw_IMSI);

    if( gPlayKeytoneFlag == 0 ) //2004.2.11 WYJ
        gPlayKeytoneFlag = 1;

    switch( e )
    {
    case MfwWinVisible:

        /*2003/11/13,talcon modify it */
        timStop(idle_data.idleanimtimer);
        if( idle_data.isLCDCover!=1 )
        {
            UBYTE idxbkganimOld = idle_data.idxbkganim;
            uMode = dspl_Enable(0);
            if( !IsShowGoodbye )
            {
                drawIdle();
            }
            dspl_Enable(uMode);

            if( idle_data.isLCDCover == 2 )
                idle_data.isLCDCover -- ;

            if( idxbkganimOld !=idle_data.idxbkganim )
                timStart(idle_data.idleanimtimer);
        }

        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }

    return MFW_EVENT_CONSUMED;

}


/*******************************************************************************

 $Function:    	keyEvent

 $Description:	 keyboard event handler
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/

static int idle_kbd_cb (MfwEvt e, MfwKbd *k)
{
    extern PCCMDSTATUS  PcCmdStatus;//chenjun hxl 2003/01/27
    extern const char picIndex[];//chenjun add for user defined pic 2003-01-15
    static UBYTE right_key_pressed=FALSE;
    UBYTE currentRinger = getCurrentRingerSettings();

    T_MFW_SMS_STAT  sms_idle_list_type = MFW_SMS_MT;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    int txtNo;      //hxl add for qq 2003-1-5
#endif
    char debug[50];
    uint8 scenenum = FlashEnvironmentData.CurrentEnv;   //xsf add 2002.08.15
    uint8 CurrentVol;  //xsf add 2002.09.04 2 lines
    CurrentVol = FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].ringvolume;
    TRACE_FUNCTION("idle_kbd_cb");
    TRACE_EVENT_P1("Key: %d", k->code);

    if( idle_data.starting_up ) /*JVJ Do nothing when starting up */
        return 1;

    //hxl add to stop the blink timer 0905-------------------
    /*timStop(gtimeBlink);
    IsBlinktimerRun=0;
    GlobalIconStatus = GlobalNothingIconFlag;*/
    if( k->code!=KCD_ABC )
    {//for dealed the flag when return to  idle_win_cb  
        pwr_Status.ChargingVirtualKeyFlag=1;
        //ChargeOffset=0;
        MmiTrace("other key");
    }

    //end of hxl add 0905--------------------------------
    if( !animation_complete||!anim_real_complete )
        return;
    if( !(e & KEY_MAKE) )
    {
        switch( k->code )
        {
        case KCD_RIGHT:
            break;

            // sbh - power key pressed in idle screen, we can shut down
        case KCD_POWER:
            HUPKeyOrigin = 1;
            break;

        default:
            break;
        }
        idle_data.right_key_pressed = FALSE;
        return MFW_EVENT_CONSUMED;
    }

    idle_data.right_key_pressed = FALSE;
    /*2004/04/09,talcon comment*/
#if 0
    if( SceneSelect_mode )
    {
        switch( k->code )
        {
        case KCD_VOLUP:
        case KCD_VOLDOWN:
        case KCD_F3:
        case KCD_CALL:
            //case KCD_ABC://hxl changed for charging icon show 2002-12-24
            return MFW_EVENT_CONSUMED;

        case KCD_MNUUP:
        case KCD_MNULEFT:
            if( idle_data.preSelect_num>0 )
                idle_data.preSelect_num--;
            else
                idle_data.preSelect_num =4;
            if( idleIsFocussed() )
            {/*2003/11/04,talcon add timer handle */
                timStop(idle_data.idleanimtimer);
                DrawSceneselect_rect();
                //timStart(idle_data.idleanimtimer);
            }
            return MFW_EVENT_CONSUMED;
        case KCD_MNUDOWN:    
        case KCD_MNURIGHT:   
            if( idle_data.preSelect_num<4 )
                idle_data.preSelect_num++;
            else
                idle_data.preSelect_num =0;
            if( idleIsFocussed() )
            {/*2003/11/04,talcon add timer handle */
                timStop(idle_data.idleanimtimer);
                DrawSceneselect_rect();
                //timStart(idle_data.idleanimtimer);
            }

            return MFW_EVENT_CONSUMED;

        case KCD_LEFT:                  
        case KCD_OK:     
            FlashEnvironmentData.CurrentEnv= idle_data.preSelect_num;
            flash_environmentwrite();
            SceneSelect_mode = 0;
            if( idleIsFocussed() )
                winShow(idle_data.win);

            return MFW_EVENT_CONSUMED;

        case KCD_RIGHT:                 
        case KCD_HUP:
        case KCD_POWER:
            SceneSelect_mode = 0;
            if( idleIsFocussed() )
                winShow(idle_data.win);

            return MFW_EVENT_CONSUMED;
        case KCD_ABC:  //xsf add 2003.03.17
            break;
        default:
            SceneSelect_mode = 0;
            if( idleIsFocussed() )
                winShow(idle_data.win);
            break;
        }
    }
#endif
    if( (!idle_data.clean_screen) && (idle_data.edt) )
    {
        switch( k->code )
        {
        case KCD_MNUUP:
            if( idleIsFocussed() )
            {
                if( idle_data.edt )
                {
                    TRACE_EVENT("CB menu down");
                    edtChar(idle_data.edt,ecUp);
                }
            }
            return MFW_EVENT_CONSUMED;

        case KCD_MNUDOWN:
            if( idleIsFocussed() )
            {
                if( idle_data.edt )
                {
                    TRACE_EVENT("CB menu down");
                    edtChar(idle_data.edt,ecDown);
                }
            }
            return MFW_EVENT_CONSUMED;

            /* 2004/04/01 sunsj add */
        case KCD_LEFT:
        case KCD_RIGHT:                  /* main menu                */
        case KCD_HUP:                     
            statusCBCH(FALSE);                    
            windowsUpdate(); 
            return MFW_EVENT_CONSUMED;
        default:
            break;
        }
    }

    if( (!idle_data.clean_screen) && (idle_data.missedCalls > 0) )
    {
        switch( k->code )
        {
        case KCD_LEFT:
            idle_data.missedCalls = 0;
            timStop(gtimeMissedCall);  //xsf add 2002.09.16
            //bookPhonebookStart(idle_data.win,PhbkMissedCallsListNormal);
            GetLMNrecord();//wufei add
            return MFW_EVENT_CONSUMED;
            //xsf add for press KCD_RIGHT in missed calls  interface 2002.09.17
        case KCD_RIGHT:                  /* main menu                */
            bookPhonebookStart(idle_data.win,PhbkMainMenu);                   
            return MFW_EVENT_CONSUMED;
            /* 2004/03/26 sunsj modify */
            //case KCD_HUP:                     //hu binhao 2003-1-14 
            //    return MFW_EVENT_CONSUMED;   //hu binhao 2003-1-14 
        default:
            break;
        }
    }

    if( idle_data.search )
    {
        switch( idle_data.nm_status )
        {
        /*
           glowing: add the following statement for processing
           the NETWORK_LIMITED_SERVICE 
        */
        case NETWORK_LIMITED_SERVICE:
        case NETWORK_NO_SERVICE :
        case NETWORK_NO_PLMN_XXX_AVAIL:

            switch( k->code )
            {
            case KCD_LEFT:
                //xsf changed 2002.11.11 wake_up_rr();
                nm_registration (NM_AUTOMATIC,0, 0);
                winShow(idle_data.win);
                break;   //xsf add 11.11
            case KCD_HUP:
                idle_data.search=FALSE;
                winShow(idle_data.win);
                break;
                /*CONQ 6436, MC allow entry of emergency number*/
            case KCD_1:
            case KCD_2: 
            case KCD_9:
                memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));
                idle_data.dialshow_buf[0]=editControls[k->code];
                idle_dialling_start(idle_data.win,NULL);
                break;
            default:
                break;
            }

            return MFW_EVENT_CONSUMED;

        default:
            break;
        }
    }

    if( smsidle_get_unread_sms_available() 
        && (!idle_data.clean_screen)
        && idle_data.new_sms )
    {

        switch( k->code )
        {
        case KCD_LEFT:

            if( g_pcsyncstatus )////this need add return if the phone is connect with pc,hxl 
                return 1;
            // terminate the ringing
            //Stopplayingdevice(); //xsf changed 12.31
            StopPlayByReasonId(SMSPLAY);
            //audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );
            timStop(gtimeMissedCall); //xsf add 2002.09.17	
            idle_data.new_sms    = FALSE;
            //windyidle_data.clean_screen = TRUE;
            IdleReadsms(idle_data.win, (T_MFW_SMS_STAT*) &sms_idle_list_type);
            //g_sms_list_counter=0;
            //SmsRead_R_start(idle_data.win, (T_MFW_SMS_STAT*) &sms_idle_list_type);
            return MFW_EVENT_CONSUMED;
            //xsf add for press KCD_RIGHT in new SMS interface 2002.09.17
        case KCD_RIGHT:                  /* main menu                */
            bookPhonebookStart(idle_data.win,PhbkMainMenu);                   
            return MFW_EVENT_CONSUMED;
        default:
            break;
        }
    }

    //this is for cell broadcast
    if( (!idle_data.clean_screen) && idle_data.new_cbch )
    {
        switch( k->code )
        {
        case KCD_LEFT:

            // terminate the ringing
            audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );

            idle_data.new_cbch = FALSE;
            idle_data.clean_screen = TRUE;
            sms_cb_read_msg (ALL_MESSAGE);    
            return MFW_EVENT_CONSUMED;
            //xsf add for press KCD_RIGHT in new cell broadcast interface 2002.09.17
        case KCD_RIGHT:                  /* main menu                */
            bookPhonebookStart(idle_data.win,PhbkMainMenu);                   
            return MFW_EVENT_CONSUMED;
        default:
            break;
        }
    }


#ifdef _MMS_ENABLE_
	if( (!idle_data.clean_screen) && MMS_Get_NewMMS_Sum() > 0)
    {
        switch( k->code )
        {
        case KCD_LEFT:
            // terminate the ringing
            StopPlayByReasonId(SMSPLAY);
            idle_data.clean_screen = TRUE;
            MMS_Initialize_In_Idle();
            MMS_Entry_Recv_Folder_In_Idle(idle_data.win);   
            return MFW_EVENT_CONSUMED;
        case KCD_RIGHT:                  /* main menu                */
            bookPhonebookStart(idle_data.win,PhbkMainMenu);                   
            return MFW_EVENT_CONSUMED;
        default:
            break;
        }
    }
#endif

    switch( k->code )
    {           //xsf add 2002.09.04
    case KCD_VOLUP:
    case KCD_VOLDOWN:
    case KCD_F3:
        MMI_TRACE_EVENT(("sunsj-------------short key volup"));
        //if(FlashEnvironmentData.CurrentEnv != MUTE_ENV) //xsf disabled it 2003.04.29
        /* 2004/04/12 sunsj modify for select outer wallpaper */
        if( HallStatus() )/*2004/0408,talcon add*/
        {
            AdjustRingerVolumeIdle(); 
        }
        /* 2004/04/21 sunsj add */
        else
        {
            LedLightnessAdjust(200);
            timStart(gtVibator);
        }
        /* 2004/04/16 sunsj remove */
        /*
        else
        {
            if( FlashSettingData.OutBGI != 3 )
            {
                FlashSettingData.OutBGI++;
            }
            else
            {
                FlashSettingData.OutBGI = 0;
            }
            LedLightnessAdjust(200);
            timStart(gtVibator);
            drawOuterIdle();
        }
        */
        break;
    case KCD_MNUUP:
        if( idleIsFocussed() )  //xsf add for switch backgroung bmp with pressing KCD_OK in idle window 09.25
        {
            /*if(idle_data.edt)
            {
                TRACE_EVENT("CB menu down");
                 edtChar(idle_data.edt,ecUp);
            }
            else*/
            //chenjun changed for user defined picture 2003-01-15
            //if has pic1stid  7, else 6;
            /* 2004/04/02 sunsj modify for menuup key control */
            GetLMNrecord();
            /*
            if( flash_CheckStat(picIndex)>=0 )
            {
                if( FlashSettingData.BGI>=nBkgIcnAnim + nBkgIcnNormal+1 )
                    FlashSettingData.BGI = 0;//zy add no background bmp
                else
                    FlashSettingData.BGI++;
            }
            else
            {
                if( FlashSettingData.BGI>=nBkgIcnAnim + nBkgIcnNormal )
                    FlashSettingData.BGI = 0;//zy add no background bmp
                else
                    FlashSettingData.BGI++;
            }       
            flash_settingwrite();
            winShow(idle_data.win);                  
            */
        }
        break;

    case KCD_MNUDOWN:   
        //hxl add------------------------------------------
        //this need add return if the phone is connect with pc,hxl 
        if( g_pcsyncstatus )//when pc read sim phb,return
            return 1;
        //end of hxl add----------------------------------
        /*
        //	Indicate that the volume settings menu has been invoked from the 
        //	incoming call screen.
        
        
        setSoundsReason(SettingVolume);
        idle_data.info_win=bookMenuStart(idle_data.win, ringerVolumeSetting(), SettingVolume);
        */
        /*						
                                T_EntryMenuData EntryData;
        
                                EntryData.EntryMode=FromShortCutKey;
                                idle_data.phonebook_win=BookDynamicMenuStart(idle_data.win,&EntryData);						
        */
        /*if(idle_data.edt)
        {
            TRACE_EVENT("CB menu down");
             edtChar(idle_data.edt,ecDown);
        }
        else*/
        /* 2004/04/02 sunsj modify */
        GetLRNrecord();
        //idle_data.phonebook_win=bookPhonebookStart(idle_data.win,PhbkFromShortcutKey);

        break;
#if 0
    case KCD_F3:
        {
            bookPhonebookStart(idle_data.win,PhbkFromVoiceMemo);          
        }
#endif
        break;      
        /*
                        case KCD_MNUDOWN:   
                            if(idle_data.edt)
                            {
                                TRACE_EVENT("CB menu down");
                                 edtChar(idle_data.edt,ecDown);
                            }
                            else
                            {
                                
                                //	Indicate that the volume settings menu has been invoked from the 
                                //	incoming call screen.
                                
                                setSoundsReason(SettingVolume);
                                idle_data.info_win=bookMenuStart(idle_data.win, ringerVolumeSetting(), SettingVolume);
                            }
                            break;
                        break;
        */              
    case KCD_LEFT:                  /* main menu                */
        bookPhonebookStart(idle_data.win,PhbkMainMenu);//zy exchage the left and right softkey 04/08/02					
        break;
    case KCD_CALL:
        //bookPhonebookStart(idle_data.win,PhbkRedialListNormal);
        GetLDNrecord();//wufei add
        break;
    case KCD_RIGHT:                 /* contacts (ADN)           */
        /*
         *  terminate any call even if no alerting was received
         */

        //hxl add------------------------------------------
        //this need add return if the phone is connect with pc,hxl 
        if( g_pcsyncstatus )//when pc read sim phb,return
            return 1;

        //end of hxl add----------------------------------

        cm_force_disconnect();
        call_data.ignore_disconnect=TRUE;//zy 2003-04-07 in idle avoid callwin didn't setup but callcmevent is run
        // terminate the ringing
        //Stopplayingdevice(); //xsf add 2002.08.12 MI18800000126
        //audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );
        /*if(idle_data.edt)
        {
            statusCBCH(FALSE);					  
            windowsUpdate(); 
        }
        else*/
        bookPhonebookStart(idle_data.win,PhbkNormal);//zy exchage the left and right softkey 04/08/02
        break;
    case KCD_HUP:
        /*
         *  terminate any call even if no alerting was received
         */
        cm_force_disconnect();
        call_data.ignore_disconnect=TRUE;//zy 2003-04-07 in idle avoid callwin didn't setup but callcmevent is run
        // terminate the ringing
        //Stopplayingdevice(); //xsf add 2002.08.12 MI18800000126
        //audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );

        //for clean the DISPLAY ZONE 3
        //information like "missed calls" and "receive messages"
        //disappear if the user press the HUP key 
        /*if(idle_data.edt)
        {
            statusCBCH(FALSE);					  
            windowsUpdate(); 
        }
        else*/
        if( smsidle_get_unread_sms_available() && (!idle_data.clean_screen) && idle_data.new_sms ) //xsf add 2003.04.14	
        {
            timStop(gtimeMissedCall); 
            idle_data.new_sms    = FALSE;
            /* 2004/03/26 sunsj add */
            idle_data.missedCalls = 0;
        }
        idle_data.clean_screen = TRUE; 

        /* delete the message buffer  plus the editor */
        statusCBCH(FALSE);                    
        windowsUpdate();
        // set origin to 1 so we know pressed in idle screen->shut down
        break;

        // sbh - power key pressed in idle screen, we can shut down
    case KCD_POWER:
        TRACE_EVENT("glowing: idle_kbd_cb - KCD_POWER");
        HUPKeyOrigin = 1;
        break;
    case KCD_MNULEFT:
        /*2004/04/09,talcon add scenemode shortcut menu*/
        bookMenuStart(idle_data.win,SceneMenuAttributes(),0);
#if 0
        /*if(MorethanMaxPressKeyNum(12))
            break;
         if( idleIsFocussed())
          {
            if(scenenum<4)
            {
             scenenum++;
             FlashEnvironmentData.CurrentEnv= scenenum;
             //flash_environmentwrite();
            }
            else
            {
             scenenum=0;;
             FlashEnvironmentData.CurrentEnv= scenenum;
             //flash_environmentwrite();
            } 	
             winShow(idle_data.win);			    	
            }*/
        SceneSelect_mode = 1;   //xsf changed 11.27
        idle_data.preSelect_num =0;
        if( idleIsFocussed() )
            winShow(idle_data.win);
        if( idleIsFocussed() )
        {/*2003/11/04,talcon add timer handle */
            timStop(idle_data.idleanimtimer);
            DrawSceneselect_rect();
            //timStart(idle_data.idleanimtimer);
        }
#endif
        break;
    case KCD_OK:   
        // AUI_homepageStart(idle_data.win); //zhaowm 2002.12.28
        /*
       if(MorethanMaxPressKeyNum(12))
         break;
         
         */
        break;
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
    case KCD_STAR:
    case KCD_HASH:
        memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));
        idle_data.dialshow_buf[0]=editControls[k->code];
        idle_dialling_start(idle_data.win,NULL);
        break;
    case KCD_ABC:
        MmiTrace("zym:Charging Key");
        //if ( pwr_Status.ChargingVirtualKeyFlag )	

        batEvent();     
        break;
    case KCD_MNURIGHT:
		phonebook_search_flag=FALSE;
        ShortCutMnu_Start(idle_data.win);
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;
}





/*******************************************************************************

 $Function:    	idle_kbd_long_cb

 $Description:	 Creation of an instance for the Idle dialog.
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


static int  idle_kbd_long_cb(MfwEvt e, MfwKbd *k)
{
    MMI_TRACE_EVENT(("sunsj-------------idle_kbd_long_cb"));
    MMI_TRACE_EVENT(("sunsj-------------e %x", e));

    //if ((e & KEY_RIGHT) && (e & KEY_LONG) && (idle_data.right_key_pressed == TRUE))
    /* 2004/04/16 sunsj modify */
    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_OK:
            AUI_homepageStart(idle_data.win); 
            break;
        case KCD_VOLUP:
            MMI_TRACE_EVENT(("sunsj-------------long key of volup"));
            if( !HallStatus() )
            {
                MMI_TRACE_EVENT(("sunsj-------------change outer wallpaper"));
                if( FlashSettingData.OutBGI != 3 )
                {
                    FlashSettingData.OutBGI++;
                }
                else
                {
                    FlashSettingData.OutBGI = 0;
                }
                /* 2004/05/17 sunsj modify for can not save value of outer wallpaper */
                flash_settingwrite();
                LedLightnessAdjust(200);
                timStart(gtVibator);
                drawOuterIdle();
            }
            break;
        case KCD_VOLDOWN:
            MMI_TRACE_EVENT(("sunsj-------------long key of volup"));
            if( !HallStatus() )
            {
                MMI_TRACE_EVENT(("sunsj-------------change outer wallpaper"));
                if( FlashSettingData.OutBGI != 3 )
                {
                    FlashSettingData.OutBGI++;
                }
                else
                {
                    FlashSettingData.OutBGI = 0;
                }
                LedLightnessAdjust(200);
                timStart(gtVibator);
                drawOuterIdle();
            }
            break;
        default:
            MMI_TRACE_EVENT(("sunsj-------------long key of default"));
            break;
        }
    }

    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	idle_get_window

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




MfwHnd idle_get_window (void)
{
    return idle_data.win;
}



/*******************************************************************************
$Function:		idle_get_edt_window()
$Description:
$Author:		Sunny
$Date and Time:	2004-04-12
*******************************************************************************/
MfwHnd idle_get_edt_window (void)
{
    return idle_data.edt;
}



/*******************************************************************************

 $Function:    	idle_set_starting_up

 $Description: Sets a flag that indicates to Idle that the phone is starting up	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




void idle_set_starting_up (UBYTE set)
{
    idle_data.starting_up = set;
}



/*******************************************************************************

 $Function:    	idleIsFocussed

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
int idleIsFocussed(void)
{
    if( winIsFocussed(idle_data.win) )
    {
        TRACE_EVENT("idleIsFocussed");
        MmiTrace("idleIsFocussed");
        return 1;
    }
    else
        return 0;
}

/*******************************************************************************

 $Function:    	addMissedCall

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




void addMissedCall(char *num)
{
    idle_data.missedCalls++;
    //FlashDCTbData.MissedCallNum++;   //change to saveNumCallRecord 2002-11-29
    timStart(gtimeMissedCall);  //xsf add 2002.09.16
    // show the info about missed calls on the idle screen	
    idle_data.clean_screen = FALSE;
    windowsUpdate();
}


/*******************************************************************************

 $Function:    	addCBCH

 $Description:	 this indicates the incoming cell-info cellbroadcast 
                or incoming sms class 0 message
                The Status tells about to show or not on the Idle screen
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void addCBCH(char* cbch_string, UBYTE type)
{


    switch( type )
    {
    case IdleNewCBImmediateMessage:
        if( cbch_string NEQ NULL )
        {

            if( !idle_data.edt )
            {
                UBYTE old_flag;
                old_flag=Set_regflag(0);
                idle_data.edt = edtCreate (idle_data.win,&idle_data.edt_attr2,0,0);
                Set_regflag(old_flag);
            }
            memset(idle_data.incoming_cb_msg, 0,sizeof(idle_data.incoming_cb_msg));
            memcpy((char *)idle_data.incoming_cb_msg, (char *)cbch_string,MAX_CBMSG_LEN);
            edtSetText (idle_data.edt, (char*)idle_data.incoming_cb_msg); 
            //windowsUpdate();
            //this is centralize the cb message if it's a short one
            //12 cos CB messages have some space character after the string
            //it is just a estimate
            /*if ((strlen(cbch_string)) < 12)
                idle_data.edt_attr2.win.px = WIN_CENTRALIZE_ORG_X;
            else
                idle_data.edt_attr2.win.px = WIN_DIALLING_ORG_X;*/

        }
        else
        {
            if( idle_data.edt )
            {
                edtDelete(idle_data.edt);
            }

            //set the centralize for the cb message to default
            idle_data.edt_attr2.win.px = WIN_DIALLING_ORG_X;

            idle_data.edt = 0;      
            memset(idle_data.incoming_cb_msg, 0,sizeof(idle_data.incoming_cb_msg));
        }
        break;

    case IdleNewCBNormalMessage:

        //set back to default
        idle_data.clean_screen = FALSE;

        idle_data.new_cbch = TRUE;
        break;

        /*NM p019*/
    case IdleNewSmsMessage:         
        if( cbch_string NEQ NULL )
        {

            if( !idle_data.edt )
            {
                UBYTE old_flag;
                old_flag=Set_regflag(0);
                idle_data.edt = edtCreate  (idle_data.win,&idle_data.edt_attr3,0,0);
                Set_regflag(old_flag);
            }
            memset(idle_data.incoming_sms_msg, '\0',MAX_MSG_LEN_ARRAY);
            memcpy((char *)idle_data.incoming_sms_msg, (char *)cbch_string,MAX_MSG_LEN_ARRAY);
            edtSetText (idle_data.edt, (char*)idle_data.incoming_sms_msg); 
            //strcpy((char *)idle_data.incoming_sms_msg,  (char *)cbch_string,);

        }
        else
        {
            if( idle_data.edt )
            {
                edtDelete(idle_data.edt);
            }
            idle_data.edt = 0;      
            memset(idle_data.incoming_sms_msg, '\0',MAX_MSG_LEN_ARRAY);
        }
        break;
    }
}

/*******************************************************************************

 $Function:    	statusCBCH

 $Description:	if True -> keep it on the idle screen 
                if FALSE -> remove the message (CB or SMS)
                           and destroy the editor

 $Returns:		

 $Arguments:	
                
*******************************************************************************/

void statusCBCH(UBYTE status)
{
    if( status )
    {
        idle_data.clean_screen = FALSE; 
        windowsUpdate();
    }
    else
    {
        //Dont show the CB on the Idle screen
        idle_data.new_cbch = FALSE;
        if( idle_data.edt )
            edtDelete(idle_data.edt);
        idle_data.edt = 0;  
        //set the centralize for the cb message to default
        idle_data.edt_attr2.win.px = WIN_DIALLING_ORG_X;
    }
}


/*******************************************************************************

 $Function:    	addSatMessage

 $Description:	Store a SAT message to display on the idle screen.

 $Returns:		

 $Arguments:	satMessage	- the text of the message
                
*******************************************************************************/

void addSatMessage(char *satMessage)
{
    /* SPR759 - SH.  Create a new sat message */

    if( satMessage NEQ NULL )
    {
        if( !idle_data.edt_sat )
        {
            idle_data.edt_sat = edtCreate(idle_data.win,&idle_data.edt_attr_sat,0,0);  // Create the editor to hold it
        }
        memset(idle_data.incoming_sat_msg, '\0',MAX_CBMSG_LEN);
        strcpy((char *)idle_data.incoming_sat_msg, (char *)satMessage);

        //Centralize sat message if below 12 characters (so it doesn't look odd on the screen)

        if( (strlen(satMessage)) < 12 )
            idle_data.edt_attr_sat.win.px = (SCREEN_SIZE_X-strlen(idle_data.edt_attr_sat.text)*6)/2;
        else
            idle_data.edt_attr_sat.win.px = WIN_DIALLING_ORG_X;
    }
    else        // If a null string is passed, get rid of the message
    {
        if( idle_data.edt_sat )
        {
            edtDelete(idle_data.edt_sat);
        }

        //set the centralize for the cb message to default
        idle_data.edt_attr_sat.win.px = WIN_DIALLING_ORG_X;

        idle_data.edt_sat = NULL;       
        memset(idle_data.incoming_sat_msg, '\0',MAX_CBMSG_LEN);
    }

    return;
}

/*******************************************************************************

 $Function:    	idleDialBuffer

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idleDialBuffer(char* dialBuffer)
{
    //memset(idle_data.edt_buf,'\0',sizeof(idle_data.edt_buf));
    memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));
    //strncpy((char*)idle_data.edt_buf,(char*)dialBuffer,sizeof(idle_data.edt_buf)-1);
    strncpy((char*)idle_data.dialshow_buf,(char*)dialBuffer,sizeof(idle_data.dialshow_buf)-1);
    idle_dialling_start(idle_data.win,NULL);
}

/*******************************************************************************

 $Function:    	windowsUpdate

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void windowsUpdate(void)
{
    if( idleIsFocussed() )
        winShow(idle_data.win);
}



/*******************************************************************************

 $Function:    	idle_dialling_create

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


T_MFW_HND idle_dialling_create (T_MFW_HND parent_window)
{

    T_MFW_WIN     * win;

    /*
     * This window is dynamic, for that reason the associated data are allocated in the mfw heap
     */


    T_idle_dialling *  data = (T_idle_dialling *)ALLOC_MEMORY (sizeof (T_idle_dialling));

    TRACE_FUNCTION ("idle_dialling_create");

    /*
     * Create window handler
     */

    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)idle_dialling_win_cb);

    if( data->win EQ 0 )
        return 0;


    /*
    * These assignments are necessary to attach the data to the window, and to handle the mmi event communication.
    */


    data->mmi_control.dialog    = (T_DIALOG_FUNC)idle_dialling;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
    * Create any other handler
    */



    data->edt      = edtCreate  (data->win,&idle_data.edt_attr,0,0);
    data->kbd      = kbd_create (data->win,KEY_ALL,(T_MFW_CB)idle_dialling_kbd_cb);
    data->kbd_long = kbd_create (data->win,KEY_ALL|KEY_LONG,(T_MFW_CB)idle_dialling_kbd_long_cb);


    winShow(data->win);
    /*
     * return window handle
     */
    return data->win;
}



/*******************************************************************************

 $Function:    	idle_dialling_destroy

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



void idle_dialling_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win;
    T_idle_dialling        * data;

    TRACE_FUNCTION("idle_dialling_destroy");

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_idle_dialling *)win->user;

        if( data )
        {
            /*
             * Exit Keyboard Handler
             */
            /*NM, 26.3.02*/
            edt_delete(data->edt);
            kbd_delete(data->kbd);
            kbd_delete(data->kbd_long);
            /*
             * Delete WIN Handler
             */
            win_delete (data->win);
        }

        /*
        *  In this case the data attached to window must be also deleted.
        */


        FREE_MEMORY ((void *)data, sizeof (T_idle_dialling));
    }
}


/*******************************************************************************

 $Function:    	idle_dialling_start

 $Description:	 This function just creates and inits the new dialog
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




T_MFW_HND idle_dialling_start (T_MFW_HND win_parent,char *character)
{


    T_MFW_HND win = idle_dialling_create (win_parent);

    TRACE_FUNCTION("idle_dialling_start");

    if( win NEQ NULL )
    {
        SEND_EVENT(win,IDLE_DIALLING_INIT,0,(char*)character);
    }
    return win;

}



/*******************************************************************************

 $Function:    	idle_dialling

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



void idle_dialling (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_idle_dialling         * data = (T_idle_dialling *)win_data->user;

    TRACE_FUNCTION ("idle_dialling()");

    /*
    *  In this case the communication is very simple (only one intern event)
    */


    switch( event )
    {
    case IDLE_DIALLING_INIT:
        /* sbh 28/02/02 - Changed height from 27 to 24 below, as editor was erasing top of softkeys. */
        /*		if (Mmi_getCurrentLanguage() == CHINESE_LANGUAGE)
                        bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_first_line_icons(),120,128,
                            0,0,edtCurBar1,0,(char*)idle_data.edt_buf,EDITOR_SIZE,&idle_data.edt_attr);//zy change the editor size zy 09/11
                else
                    bookSetEditAttributes(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),120,112,
                            0,0,edtCurBar1,0,(char*)idle_data.edt_buf,EDITOR_SIZE,&idle_data.edt_attr);
                    editActivate (data->edt,FALSE);
                    edtUnhide(data->edt);
                    edtChar(data->edt,ecBottom);*/
        //			winShow(data->win);
        break;
    default:
        return;
    }

}



/*******************************************************************************

 $Function:    	idle_dialling_win_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
 $History:    2003/11/10 sunsj modify idle font type

*******************************************************************************/


static int idle_dialling_win_cb (MfwEvt e, MfwWin *w)
{
    char * txt;
    int     nTextLen;
    UINT32 oldcolor;    /* 2004/04/02 sunsj modify */
    int i,j,k=0;
    /* 2003/11/10 sunsj modify */
    int wordwides=IDLENUMBERWIDTH;
    int wordhigh=IDLENUMBERHIGH+3;
    //UINT32 oldfontcolor; 
    TRACE_FUNCTION ("idle_dialling_win_cb()");
    switch( e )
    {
    case MfwWinVisible:
        /* 2004/04/02 sunsj modify */
        oldcolor = dspl_SetBkgColor(0xffffff);
        //oldfontcolor=dspl_GetFrgColor();
        dspl_Clear(0,0,mmiScrX,mmiScrY);
        txt=MmiRsrcGetText(TxtAddNewCall);
        nTextLen = dspl_GetTextExtent(txt,(U16)dspl_str_length(txt));
        //dspl_SetBkgColor(GetPreDefinedColor(ColorMenuTitle));
        //dspl_Clear(0,0,120,16);
        //dspl_colorTextOut((120-nTextLen)/2, 0, 0, txt, GetPreDefinedColor(ColorMenuTitleFont));
        /* 2004/05/25 sunsj modify */
        draw_special_background();
        drawSolidRectangle(3,19,125,100,3,0xffffff,0x8cb9fc);
        /* 2004/06 sunsj modify for picture manage */
        //DRAW_ICON_MASK(ICON_IDLEDIALING);
		DRAW_ICON(ICON_MENUUP);
        //dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
        //             menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,0,menuup[FlashSettingData.theme].icons,0);
#if (MAIN_LCD_SIZE==3)//jhxu720
        dspl_colorTextOut((128-nTextLen)/2, 0, DSPL_TXTATTR_TRANSPARENT, txt, 0xffffff );
#elif ( MAIN_LCD_SIZE==4 )
        dspl_colorTextOut((128-nTextLen)/2, 0, DSPL_TXTATTR_TRANSPARENT, txt, 0x000000 );
#elif ( MAIN_LCD_SIZE==2 )
        /* 2004/04/02 sunsj modify */
        dspl_colorTextOut((102-nTextLen)/2, 0, DSPL_TXTATTR_TRANSPARENT, txt, 0x000000 );
#endif
        //dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
        //dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));
        displaySoftKeys(TxtSave,TxtDelete);
        //dspl_Clear(104, 0, 120, 16);//hxl add to delete the battery icon 0905 zy remove clearall
        //dspl_SetBkgColor(oldcolor);
        //dspl_SetFrgColor(oldfontcolor);
        for( i=0;i<strlen(idle_data.dialshow_buf);i++ )
        {
            /* 2004/05/25sunsj modify */
            j=i/IDLEPHONE_NUMBER;
            k=i%IDLEPHONE_NUMBER;
            if( idle_data.dialshow_buf[i]=='*' )
            {
                DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, k*wordwides+IDLEOFFSET_X, IDLENUMBERHIGH+3+j*wordhigh+IDLEOFFSET,
                                    idle_data.dialshow_buf[i]-32, ICON_LOCATION);
            }
            else if( idle_data.dialshow_buf[i]=='#' )
            {
                DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, k*wordwides+IDLEOFFSET_X, IDLENUMBERHIGH+3+j*wordhigh+IDLEOFFSET,
                                    idle_data.dialshow_buf[i]-24, ICON_LOCATION);
            }
            else if( idle_data.dialshow_buf[i]=='p' )
            {
                DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, k*wordwides+IDLEOFFSET_X, IDLENUMBERHIGH+3+j*wordhigh+IDLEOFFSET,
                                    13, ICON_LOCATION);
            }
            else if( idle_data.dialshow_buf[i]=='+' )
            {
                DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, k*wordwides+IDLEOFFSET_X, IDLENUMBERHIGH+3+j*wordhigh+IDLEOFFSET,
                                    12, ICON_LOCATION);
            }
            else
            {
                DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, k*wordwides+IDLEOFFSET_X, IDLENUMBERHIGH+3+j*wordhigh+IDLEOFFSET,
                                    idle_data.dialshow_buf[i]-'0', ICON_LOCATION);
            }
        }
        //	    Force_refresh();
        /* 2004/04/02 sunsj modify */
        dspl_SetBkgColor(oldcolor);
        break;
    default:
        return 0;
    }

    return 1;
}


/*******************************************************************************

 $Function:    	idle_dialling_kbd_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
 $History:    2003/11/10 sunsj modify idle font type

*******************************************************************************/


static int idle_dialling_kbd_cb (MfwEvt e, MfwKbd *k)
{
    /*
     * The following lines describe the common method to extract the data from the window. This mfw_parent(mfw_header())
     * construction captures the current mfw handled window.
     */
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_idle_dialling         * data = (T_idle_dialling *)win_data->user;
    T_MFW_SS_RETURN ssRes;
    T_MFW_PHB_ENTRY p_pEntry;    
    //tMmiPhbData  *current       = (tMmiPhbData *)ALLOC_MEMORY (sizeof (tMmiPhbData ));zy move 12/24
    U8 uMode;
    U8 finishedHere = FALSE;    /* sbh - used to skip out part of function */

    int position=0;
    char edt_buf_prov[EDITOR_SIZE];
    char addkey[2];
    char jason_string[40];

    int screensize_x = SCREEN_SIZE_X-1; /* 2003/01/04 sunsj add */

    /* try to establish if we have information in the phone book
    */

    TRACE_FUNCTION ("idle_dialling_kbd_cb()");


    sprintf(jason_string, ">JGG> k->code: %d", k->code);    
    TRACE_EVENT(jason_string);

    switch( k->code )
    {
    case KCD_MNUUP:
        //  edtChar(data->edt,ecRight);
        break;
    case KCD_MNUDOWN:
        //	edtChar(data->edt,ecLeft);
        break;
    case KCD_CALL:
#ifdef JVJ_USSD_TEST 
        {
            T_MFW_SS_USSD prov_ussd;

            prov_ussd.len = strlen((char*)idle_data.dialshow_buf);
            memcpy(prov_ussd.ussd,(char*)idle_data.dialshow_buf,prov_ussd.len);
            prov_ussd.dcs = MFW_DCS_7bits;
            ss_send_ussd(&prov_ussd);
        }
#else
        /* 2004/03/02 sunsj modify */
        if( strlen((char*)idle_data.dialshow_buf)>=2 )
        {
            callNumber((UBYTE*)idle_data.dialshow_buf);
            idle_dialling_destroy(data->win);
        }
        else
        {
            idle_dialling_destroy(data->win);
            bookShowInformation(idle_get_window(), TxtFailed,'\0', NULL);
        }

#endif
        break;
    case KCD_LEFT:                      /* call establishment	*/
    case KCD_OK:
        //if (bookPhoneBookLoading()==BOOK_SUCCESS)
        {
            T_MFW_HND phbk_win;
            phbk_win = bookPhonebookStart(idle_data.win,PhbkNameEnterIdle);
            SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)idle_data.dialshow_buf);
        }
        break;
        /* 2003/11/10 sunsj modify */
    case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
	case KCD_CLEAR:
#endif
        //		edtChar(data->edt, ecBack);
        if( strlen(idle_data.dialshow_buf) <= 0 )
            idle_dialling_destroy(data->win);

        idle_data.dialshow_buf[strlen(idle_data.dialshow_buf)-1]='\0';
        xpos=(strlen(idle_data.dialshow_buf))%IDLEPHONE_NUMBER*IDLENUMBERWIDTH;
        ypos=(strlen(idle_data.dialshow_buf))/IDLEPHONE_NUMBER*(IDLENUMBERHIGH+3)+(IDLENUMBERHIGH+3)+IDLEOFFSET;

        if( strlen(idle_data.dialshow_buf) <= 0 )
            idle_dialling_destroy(data->win);
        else
        {
            /* 2004/05/26 sunsj modify */
            dspl_Clear(xpos+IDLEOFFSET_X, ypos, xpos+IDLEOFFSET_X+IDLENUMBERWIDTH, ypos+IDLENUMBERHIGH);
        }
        TRACE_EVENT("zy:dialling kcd_hup or right");
        TraceInt(xpos);
        TraceInt(ypos);
        //		Force_refresh();
        if( xpos==0 )
        {
            if( ypos>IDLENUMBERHIGH )
            {
                /* 2003/11/10 sunsj */
                ypos-=(IDLENUMBERHIGH+3);
                xpos=102;
            }
        }
        else
            xpos-=IDLENUMBERWIDTH;
        break;
    case KCD_HUP:
        idle_dialling_destroy(data->win);
        memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));
        break;
        /* 2003/11/10 sunsj modify */
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
    case KCD_STAR:
        //	edtChar(data->edt, editControls[k->code]);
        if( strlen(idle_data.dialshow_buf)>=EDITOR_SIZE-1 )
            return MFW_EVENT_CONSUMED;

        addkey[0]=editControls[k->code];
        addkey[1]='\0';
        strcat((char *)idle_data.dialshow_buf,(char *)addkey);

        /* 2004/01/04 sunsj modify */
        xpos=(strlen(idle_data.dialshow_buf)-1)%IDLEPHONE_NUMBER*IDLENUMBERWIDTH;
        ypos=(strlen(idle_data.dialshow_buf)-1)/IDLEPHONE_NUMBER*(IDLENUMBERHIGH+3)+(IDLENUMBERHIGH+3)+IDLEOFFSET;
        /*		
                xpos = (strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH;
                /* 2004/01/04 sunsj modify for different lcd size
                if ( xpos > screensize_x )
                {
                    ypos = ((strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH/screensize_x+1)*(IDLENUMBERHIGH + 3)+IDLEOFFSET;
                    xpos = ((strlen(idle_data.dialshow_buf)-1)%(SCREEN_SIZE_X/IDLENUMBERWIDTH))*IDLENUMBERWIDTH;
                }
                else
                {
                    ypos=IDLENUMBERHIGH+3+IDLEOFFSET;
                    /* 2004/01/04 sunsj modify for different lcd size
                    xpos = ((strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH%SCREEN_SIZE_X);
                }
        */
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, xpos+IDLEOFFSET_X, ypos, k->code, ICON_LOCATION);
        //		    Force_refresh();
        TRACE_EVENT("zy:idledialling kbd:");
        TRACE_EVENT((char *)idle_data.dialshow_buf);
        TraceInt(xpos);
        TraceInt(ypos);
        //edtChar(data->edt,ecRight);
        break;
        /* 2003/11/10 sunsj modify */
    case KCD_HASH:
        if( strlen(idle_data.dialshow_buf)>=EDITOR_SIZE-1 )
            return MFW_EVENT_CONSUMED;
        //edtChar(data->edt,editControls[k->code]);
        //edtChar(data->edt,ecRight);
        addkey[0]=editControls[k->code];
        addkey[1]='\0';
        strcat((char *)idle_data.dialshow_buf,(char *)addkey);

        /* 2004/01/04 sunsj modify */
        xpos=(strlen(idle_data.dialshow_buf)-1)%IDLEPHONE_NUMBER*IDLENUMBERWIDTH;
        ypos=(strlen(idle_data.dialshow_buf)-1)/IDLEPHONE_NUMBER*(IDLENUMBERHIGH+3)+(IDLENUMBERHIGH+3)+IDLEOFFSET;
        /*		
                xpos=strlen(idle_data.dialshow_buf)*IDLENUMBERWIDTH;
                /* 2004/01/04 sunsj modify for different lcd size
                if ( xpos>screensize_x )
                    ypos=((strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH/screensize_x+1)*(IDLENUMBERHIGH+3) + IDLEOFFSET;
                else
                    ypos=IDLENUMBERHIGH+3+IDLEOFFSET;
                /* 2004/01/04 sunsj modify for different lcd size
                xpos=((strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH%SCREEN_SIZE_X);
        */
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, xpos+IDLEOFFSET_X, ypos, k->code, ICON_LOCATION);
        //		    Force_refresh();
        //strcat((char *)idle_data.dialshow_buf,(char *)editControls[k->code]);
        memset(edt_buf_prov,'\0',sizeof(edt_buf_prov));
        strcpy((char*)edt_buf_prov,(char*)idle_data.dialshow_buf);

        if( strlen((char *)idle_data.dialshow_buf)==2 && idle_data.dialshow_buf[0]>='1' && idle_data.dialshow_buf[0]<='9' )
        {
            if( bookPhoneBookLoading()==BOOK_SUCCESS )
            {
                unsigned char backstr[21];

                if( FFS_PBOtherData.ShortCutDial[idle_data.dialshow_buf[0]-49].name[0]!='\0' )
                {
                    UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[idle_data.dialshow_buf[0]-49].number,backstr);                                       
                    memcpy((char *)idle_data.dialshow_buf,(char *)backstr,PHB_name_len);
                    winShow(win);
                    //   edtChar(data->edt,ecBottom);
                }
                else
                {
                    //ʾպ   
                    T_DISPLAY_DATA display_info;

                    dialog_info_init(&display_info);
                    display_info.KeyEvents    = KEY_CLEAR;
                    display_info.TextId       = TxtPleaseWait;
                    display_info.TextId2      = TxtNull;
                    display_info.TextString   = '\0';
                    display_info.TextString2  = '\0';
                    display_info.LeftSoftKey  = TxtNull;
                    display_info.RightSoftKey = TxtNull;
                    display_info.Time         = ONE_SECS;
                    display_info.Callback     = (T_VOID_FUNC) NULL;
                    display_info.iconindex    =REMIND_WAITTING;
                    // Call Info Screen			    
                    info_dialog( idle_get_window(), &display_info ); 
                }
            }
            else
            {
                T_DISPLAY_DATA display_info;

                dialog_info_init(&display_info);
                display_info.KeyEvents    = KEY_CLEAR;
                display_info.TextId       = TxtPleaseWait;
                display_info.TextId2      = TxtNull;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.LeftSoftKey  = TxtNull;
                display_info.RightSoftKey = TxtNull;
                display_info.Time         = ONE_SECS;
                display_info.Callback     = (T_VOID_FUNC) NULL;
                display_info.iconindex    =REMIND_WAITTING;
                // Call Info Screen			    
                info_dialog( idle_get_window(), &display_info ); 
            }

            return MFW_EVENT_CONSUMED;
        }

        /* 2004/04/01 sunsj modify */
        //   if ( strcmp((char*)idle_data.dialshow_buf, "*#520#") == 0 )
#if (MAIN_LCD_SIZE==3)
        if( strcmp((char*)idle_data.dialshow_buf, "*#188#") == 0 )/*2003/12/1, wangyan modify*/
#elif (MAIN_LCD_SIZE==4)
        if( strcmp((char*)idle_data.dialshow_buf, "*746*837#") == 0 )/*2003/12/1, wangyan modify*/
#endif
		{
            //ShowVersion(idle_data.win);
            idle_dialling_destroy(data->win);
            //finishedHere = TRUE; /*sbh*/
            //bookMenuStart( idle_data.win, menuSpecialModeAttributes(), NULL);
            bookMenuStart( idle_data.win, menuSpecialModeAttributes(), Phbksoftversion); /*2003/12/1, wangyan modify*/
        }
        else if( strcmp((char*)idle_data.dialshow_buf, "*#8378#") == 0 )
        {
            /* 2004/05/21 sunsj modify */
            idle_dialling_destroy(data->win);
            factoryTest();
        }
        else if( strcmp((char*)idle_data.dialshow_buf, "*#83781#") == 0 )
        {
            idle_dialling_destroy(data->win);
            circle_factoryTest( idle_data.win, 0);
        }
#ifdef TRACETIMER/*2004/04/02,talcon add for timer test trace*/
        else if( strcmp((char*)idle_data.dialshow_buf, "*#19790127#") == 0 )
        {
            extern void traceTime_DisableEnable();
            traceTime_DisableEnable();
            idle_dialling_destroy(data->win);
        }
#endif
#ifdef MMI_EM_ENABLED
		else if(strcmp((char*)idle_data.dialshow_buf, "*#36441#") == 0)
		{	
			TRACE_EVENT("Engineering mode string");
			/*create menu*/
			mmi_em_start_eng_mode_menus(idle_data.win);
			idle_dialling_destroy(data->win);
			finishedHere = TRUE; 
		}
#endif
        else
        {
            ssRes = ss_check_ss_string((UBYTE*)edt_buf_prov); 
            switch( ssRes )
            {
            case MFW_SS_USSD:
            case MFW_SS_SIM_LOCK:
            case MFW_SS_REG_PW:
            case MFW_SS_CF:
            case MFW_SS_CB:
            case MFW_SS_CLIR:
            case MFW_SS_CLIP:
            case MFW_SS_COLR:
            case MFW_SS_COLP:
            case MFW_SS_WAIT:
            case MFW_SS_HOLD:
                finishedHere = TRUE;                    /* Handled on # */
                break;
            case MFW_SS_SIM_REG_PW:
            case MFW_SS_SIM_UNBLCK_PIN:
                gsm_idle(0,(char *)idle_data.dialshow_buf);
                idle_dialling_destroy(data->win);
                finishedHere = TRUE;                    /* Handled on # */
                break;
            case MFW_SS_MMI:
                get_imei((char*)idle_data.imei);
                showIMEI(idle_data.win,(char*)idle_data.imei);
                idle_dialling_destroy(data->win);
                finishedHere = TRUE;                    /* Handled on # */
                break;
            case MFW_SS_DIAL:
            case MFW_SS_DIAL_IDX:
            case MFW_SS_DTMF:
            case MFW_SS_UNKNOWN:
            default:
                //edtChar(data->edt,ecBack);
                break;                      /* Remove #, it will be added later on again */
            }
        }
        /* sbh - skip out this section if we recognised SS code */
#if 0
        if( !finishedHere )
        {
            //nm 450
            //  this functions looks for shortcut 
            sscanf(idle_data.dialshow_buf, "%d", &position);
            current->missedCallsOffset = 0;
            current->index = position;
            current->selectedName = 0;  
            current->KindOfSearch = SEARCH_BY_LOCATION;
            current->status.book = bookActiveBook(READ);
            bookGetCurrentStatus( &(current->status) );

            if( (idle_data.dialshow_buf[0]!='*')&&(bookFindName( 1, current )== MFW_PHB_OK)/*&&(bookFindNumberByPosition((UBYTE)position,&p_pEntry))*/ )
            {
                memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));

                strncpy((char*)idle_data.dialshow_buf,(char*)current->entry[0].number,sizeof(idle_data.dialshow_buf)-1);

                //	edtChar(data->edt,ecBottom);
            }
        }//zy move 12/24
#endif
        //else
        //nm 450 3.5.01 end
        //   edtChar(data->edt,editControls[k->code]);
        break;
        /* 2003/11/10 sunsj close screen */
    case KCD_F4:
        idle_dialling_destroy(data->win);
        memset(idle_data.dialshow_buf,'\0',sizeof(idle_data.dialshow_buf));
        break;
    default:
        //return MFW_EVENT_CONSUMED;
        break;
    }
    //FREE_MEMORY ((void *)current, sizeof (tMmiPhbData));zy move 12/24
    return MFW_EVENT_CONSUMED;
}



/*******************************************************************************

 $Function:    	idle_dialling_kbd_long_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
 $History:    2003/11/10 sunsj modify idle font type
                
*******************************************************************************/

static int idle_dialling_kbd_long_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_idle_dialling         * data = (T_idle_dialling *)win_data->user;
    MfwHdr * edit_hdr=(MfwHdr *)(data->edt);
    MfwEdt *edit_edt=(MfwEdt *)edit_hdr->data;
    TRACE_FUNCTION ("idle_dialling_kbd_long_cb");

    if( e & KEY_LONG )
    {
        if( e & KEY_CLEAR )
        {
            //idle_dialling_destroy(data->win);
            return MFW_EVENT_CONSUMED;
        }
        /* 2004/04/01 sunsj modify */
        if( e & KEY_0 )
        {
            // edtChar(data->edt,ecBack);
            // edtChar(data->edt,'+');
            if( strlen(idle_data.dialshow_buf) <= 0 )
                idle_dialling_destroy(data->win);
            if( strlen(idle_data.dialshow_buf)>=EDITOR_SIZE-1 )
                return MFW_EVENT_CONSUMED;

            idle_data.dialshow_buf[strlen(idle_data.dialshow_buf)-1]='+';

            xpos=(strlen(idle_data.dialshow_buf)-1)%IDLEPHONE_NUMBER*IDLENUMBERWIDTH;
            ypos=(strlen(idle_data.dialshow_buf)-1)/IDLEPHONE_NUMBER*(IDLENUMBERHIGH+3)+(IDLENUMBERHIGH+3)+IDLEOFFSET;
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, xpos+IDLEOFFSET_X, ypos, 12, ICON_LOCATION);
            return MFW_EVENT_CONSUMED;
        }
        if( e & KEY_1 )
        {
            //long press on key 1 start to dial the voicemail 
            /* 2004/06/21 sunsj modify */
            if( strlen(idle_data.dialshow_buf) == 1 )
            {
                M_callVoice(NULL, NULL);
            }
            return MFW_EVENT_CONSUMED;
        }
        /* 2003/11/10 sunsj modify */
        if( e & KEY_HASH )
        {
            /*	edtChar(data->edt,ecBack);
                edtChar(data->edt,'p');
                return MFW_EVENT_CONSUMED;*/
            if( strlen(idle_data.dialshow_buf) <= 0 )
                idle_dialling_destroy(data->win);
            if( strlen(idle_data.dialshow_buf)>=EDITOR_SIZE-1 )
                return MFW_EVENT_CONSUMED;

            idle_data.dialshow_buf[strlen(idle_data.dialshow_buf)-1]='p';

            /* 2004/01/04 sunsj modify */
            xpos=(strlen(idle_data.dialshow_buf)-1)%IDLEPHONE_NUMBER*IDLENUMBERWIDTH;
            ypos=(strlen(idle_data.dialshow_buf)-1)/IDLEPHONE_NUMBER*(IDLENUMBERHIGH+3)+(IDLENUMBERHIGH+3)+IDLEOFFSET;
            /*			
                        xpos=strlen(idle_data.dialshow_buf)*IDLENUMBERWIDTH;
                        if ( xpos>119 )
                            ypos=((strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH/119+1)*(IDLENUMBERHIGH+3)+IDLEOFFSET;
                        else
                            ypos=IDLENUMBERHIGH+3+IDLEOFFSET;
                        xpos=((strlen(idle_data.dialshow_buf)-1)*IDLENUMBERWIDTH%120);
            */
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_DIALINGNUMBER, xpos+IDLEOFFSET_X, ypos, 13, ICON_LOCATION);
            return MFW_EVENT_CONSUMED;
        }
        /* 2004/04/01 sunsj modify */
        if( e & KEY_STAR )
        {
            if( strlen(idle_data.dialshow_buf)==1 )
            {
                /* 2004/05/17 sunsj remove */
                /*
                TRACE_EVENT("new we start voicedial");
                //edtChar(data->edt,ecBack);
                idle_dialling_destroy(data->win);
                bookVoiceRecordStart(idle_data.win);
                */
                return MFW_EVENT_CONSUMED;
            }
        }
        if( e & KEY_RIGHT )
        {
            //	memset(idle_data.edt_buf,'\0',EDITOR_SIZE);
            //	updateWindow(edit_edt,0);
            //	edtUpdate(edit_edt,1);
            idle_data.dialshow_buf[0]='\0';
        }
    }
    return MFW_EVENT_CONSUMED;
}











/*********************************************************************
**********************************************************************

                    KEYPAD LOCKED EVENT WINDOW. IMPLEMENTATION

*********************************************************************
**********************************************************************/



/*******************************************************************************

 $Function:    	idle_key_pad_locked_create

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



T_MFW_HND idle_key_pad_locked_create(MfwHnd parent_window)
{

    T_MFW_WIN     * win;
    T_idle_key_pad_locked *  data = (T_idle_key_pad_locked *)ALLOC_MEMORY (sizeof (T_idle_key_pad_locked));



    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)idle_key_pad_locked_win_cb);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)idle_key_pad_locked;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;
    /*
    * Create any other handler
    */



    data->kbd      = kbd_create (data->win,KEY_ALL,(T_MFW_CB)idle_key_pad_locked_kbd_cb);
    data->kbd_long = kbd_create (data->win,KEY_ALL|KEY_LONG,(T_MFW_CB)idle_key_pad_locked_kbd_long_cb);
    data->edt      = edtCreate(data->win,&idle_data.edt_attr,0,0);

    data->win_info              = 0;

    data->menuPressed = FALSE;

    /*
     * return window handle
     */
    memset(data->keyPadLockBuf,'\0',KEYPADLOCK_BUF_SIZE);
    /*NM p022*/
    edtReset(data->edt);
    showKeyPadLocked = showNothing;
    winShow(data->win);
    return data->win;
}


/*******************************************************************************

 $Function:    	idle_key_pad_locked_destroy

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idle_key_pad_locked_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win;
    T_idle_key_pad_locked        * data;

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_idle_key_pad_locked *)win->user;

        if( data )
        {
            /*
             * Exit Keyboard Handler
             */
            /*
             * Delete WIN Handler
             */
            win_delete (data->win);
        }
        FREE_MEMORY ((void *)data, sizeof (T_idle_key_pad_locked));
    }
}


/*******************************************************************************

 $Function:    	idle_key_pad_locked

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



void idle_key_pad_locked (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_idle_key_pad_locked      * data = (T_idle_key_pad_locked *)win_data->user;
    U8* key_code;
    UBYTE j;


    TRACE_FUNCTION ("idle_key_pad_locked()");

    switch( event )
    {
    case IDLE_KEYPAD_LOCKED_UPDATE:
        key_code = (U8*)parameter;
        switch( *key_code )
        {
        case KCD_CALL:
        case KCD_RIGHT:
            if( cm_check_emergency((UBYTE*)data->keyPadLockBuf)==TRUE )
            {
                edtHide(data->edt);
                callNumber((UBYTE*)idle_data.edt_buf);
                edtReset(data->edt);
                memset(idle_data.edt_buf,'\0',EDITOR_SIZE); /* sbh */
                memset(data->keyPadLockBuf,'\0',KEYPADLOCK_BUF_SIZE);
                showKeyPadLocked = showNothing;
            }
            else
            {
                data->menuPressed = TRUE;
                data->win_info = idle_information_start(win,2000,showPressMenuStar,(T_VOID_FUNC)idle_info_destroy_cb);
            }
            break;
        case KCD_STAR:
            if( data->menuPressed )
            {
                TRACE_EVENT ("dactivate the KEYpad");
                settingsKeyPadLockOff();
                data->menuPressed = FALSE;
                idle_key_pad_locked_destroy(win);
                return;
            }
            else
            {
                edtHide(data->edt);
                edtReset(data->edt);
                memset(idle_data.edt_buf,'\0',EDITOR_SIZE);
                showKeyPadLocked = showNothing;
                data->win_info = idle_information_start(win,2000,showPressMenuStar,(T_VOID_FUNC)idle_info_destroy_cb);
            }
            break;
        case KCD_0:
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
            data->menuPressed = FALSE;
            j = data->keyPadLockBuf[1];data->keyPadLockBuf[0] = j;
            j = data->keyPadLockBuf[2];data->keyPadLockBuf[1] = j;
            data->keyPadLockBuf[2] = editControls[*key_code];
            //sprintf(stringTrace,"data->keyPadLockBuf: %s",(char*)data->keyPadLockBuf);
            //TRACE_EVENT (stringTrace);
            if( cm_check_emergency((UBYTE*)data->keyPadLockBuf)==TRUE )
            {
                strcpy((char*)idle_data.edt_buf,(char*)data->keyPadLockBuf);
                edtShow(data->edt);
                showKeyPadLocked = showSOSCallKeyPadLocked;
                winUpdate((MfwWin*)mfwControl(win));
            }
            else
            {
                edtHide(data->edt);
                edtReset(data->edt);
                memset(idle_data.edt_buf,'\0',EDITOR_SIZE);
                showKeyPadLocked = showNothing;
                data->win_info = idle_information_start(win,2000,showPressMenuStar,(T_VOID_FUNC)idle_info_destroy_cb);
                winUpdate((MfwWin*)mfwControl(win));
            }
            break;
        default:
            edtHide(data->edt);
            edtReset(data->edt);
            memset(idle_data.edt_buf,'\0',EDITOR_SIZE);
            showKeyPadLocked = showNothing;
            data->win_info = idle_information_start(win,2000,showPressMenuStar,(T_VOID_FUNC)idle_info_destroy_cb);
            break;
        }
        break;
    case IDLE_INFO_ENDED:
        data->win_info = 0;
        win_show(win);
        break;
    default:
        return;
    }

}

/*******************************************************************************

 $Function:    	idle_key_pad_locked_win_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



static int idle_key_pad_locked_win_cb(MfwEvt e, MfwWin *w)
{

    T_idle_key_pad_locked * data = (T_idle_key_pad_locked *)w->user;

    TRACE_FUNCTION ("idle_key_pad_locked_win_cb()");

    switch( e )
    {
    case MfwWinVisible:
        break;
        showKeyPadLocked();
    default:
        return 0;
    }

    return 1;
}


/*******************************************************************************

 $Function:    	idle_key_pad_locked_kbd_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/

static int idle_key_pad_locked_kbd_cb (MfwEvt e, MfwKbd *k)
{

    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_idle_key_pad_locked * data = (T_idle_key_pad_locked *)win_data->user;

    TRACE_FUNCTION ("idle_key_pad_locked_kbd_cb()");

    SEND_EVENT(data->win,IDLE_KEYPAD_LOCKED_UPDATE,0,&k->code);
    return MFW_EVENT_CONSUMED;

}



/*******************************************************************************

 $Function:    	idle_key_pad_locked_kbd_long_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



static int idle_key_pad_locked_kbd_long_cb (MfwEvt e, MfwKbd *k)
{
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	showSOSCallKeyPadLocked

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




static void showSOSCallKeyPadLocked(void)
{
    TRACE_FUNCTION("showSOSCallKeyPadLocked");
    /*NM p022*/
    dspl_Clear(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),mmiScrX,mmiScrY);
    PROMPT(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),0,TxtEmergency);
    displaySoftKeys(TxtNull,TxtSoftCall);
}


/*******************************************************************************

 $Function:    	showNothing

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



static void showNothing(void)
{
    TRACE_FUNCTION("showNothing");
}



/*******************************************************************************

 $Function:    	showPressMenuStar

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


static void showPressMenuStar(void)
{
    TRACE_FUNCTION("showPressMenuStar");
    dspl_Clear(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),mmiScrX,Mmi_layout_second_line()+YLINE*2);
    PROMPT(WIN_DIALLING_ORG_X,Mmi_layout_second_line_icons(),0,TxtLocked);
    PROMPT(WIN_DIALLING_ORG_X,Mmi_layout_third_line(),0,TxtPressMenu);
    displaySoftKeys(TxtNull,TxtNull);
}





/*********************************************************************
**********************************************************************

                    Information WINDOW. IMPLEMENTATION

*********************************************************************
**********************************************************************/



/*******************************************************************************

 $Function:    	idle_information_create

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




T_MFW_HND idle_information_create(MfwHnd parent_window)
{

    T_MFW_WIN     * win;
    T_idle_information *  data = (T_idle_information *)ALLOC_MEMORY (sizeof (T_idle_information));

    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)idle_information_win_cb);
    data->kbd = kbd_create (data->win,KEY_ALL,(T_MFW_CB)idle_information_kbd_cb);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)idle_information;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;
    data->parent_win            = parent_window;
    /*
    * Create any other handler
    */



    /*
     * return window handle
     */
    return data->win;

}

/*******************************************************************************

 $Function:    	idle_information_destroy

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void idle_information_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win;
    T_idle_information        * data;

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_idle_information *)win->user;

        if( data )
        {
            /*
             * Exit Keyboard Handler
             */
            /*
             * Delete WIN Handler
             */
            win_delete (data->win);
        }
        SEND_EVENT(data->parent_win,IDLE_INFO_ENDED,0,0);
        FREE_MEMORY ((void *)data, sizeof (T_idle_information));
    }
}


/*******************************************************************************

 $Function:    	idle_information_start

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



T_MFW_HND idle_information_start(MfwHnd win_parent,S32 time,void (*show)(void),T_VOID_FUNC info_cb)
{



    T_MFW_HND win = idle_information_create(win_parent);


    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_idle_information         * data = (T_idle_information *)win_data->user;


    data->timer = timCreate(win,time,(MfwCb)idle_information_tim_cb);
    data->info_cb = (T_VOID_FUNC)info_cb;
    timStart(data->timer);
    showInformation = show;
    winShow(win);
    return win;
}


/*******************************************************************************

 $Function:    	idle_information

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




void idle_information (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_idle_information      * data = (T_idle_information *)win_data->user;

    TRACE_FUNCTION ("idle_information()");

    switch( event )
    {
    default:
        return;
    }

}


/*******************************************************************************

 $Function:    	idle_information_win_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



static int idle_information_win_cb(MfwEvt e, MfwWin *w)
{

    TRACE_FUNCTION("idle_information_win_cb");


    switch( e )
    {
    case MfwWinVisible:
        showInformation();
        break;
    default:
        return 0;
    }

    return 1;
}



/*******************************************************************************

 $Function:    	idle_information_kbd_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


static int idle_information_kbd_cb(MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_idle_information * data = (T_idle_information *)win_data->user;
    T_MFW_HND       keypad_locked_win;
    U8              key_code;


    keypad_locked_win = data->parent_win;
    key_code = k->code;
    TRACE_FUNCTION("idle_information_kbd_cb");
    idle_information_destroy(data->win);
    SEND_EVENT(keypad_locked_win,IDLE_KEYPAD_LOCKED_UPDATE,0,&key_code);
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	idle_information_kbd_long_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


static int idle_information_kbd_long_cb(MfwEvt e, MfwKbd *k)
{
    return MFW_EVENT_CONSUMED;
}




/*******************************************************************************

 $Function:    	idle_information_tim_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



static int idle_information_tim_cb(MfwEvt e, MfwTim *t)
{

    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_idle_information * data = (T_idle_information *)win_data->user;

    TRACE_FUNCTION("idle_information_tim_cb");
    timStop(data->timer);
    data->info_cb(data->parent_win,NULL,NULL);
    idle_information_destroy(win);
    windowsUpdate(); /* p303 - sbh */
    return 1;
}


/*******************************************************************************

 $Function:    	idle_info_destroy_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/




void idle_info_destroy_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{

    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_idle_key_pad_locked * data = (T_idle_key_pad_locked *)win_data->user;

    data->win_info = 0;

}


/*******************************************************************************

 $Function:    	showIMEI

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void showIMEI (T_MFW_HND win, char* IMEI)
{
    T_DISPLAY_DATA   display_info;

#define IMEI_LEN 15         /* IMEI + check digit = 15, IMEI + SW version = 16 */

    dialog_info_init(&display_info);
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtIMEI;
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = IMEI;
    display_info.Time         = FOREVER;
    display_info.Callback     = (T_VOID_FUNC)idle_imei_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT | KEY_RIGHT | KEY_HUP;

    /*
     * Call Info Screen
     */

    idle_data.info_win = info_dialog (win, &display_info);
}


/*******************************************************************************

 $Function:    	idle_imei_info_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/



static int idle_imei_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reason)
{


    switch( reason )
    {
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT:
        break;
    }

    return 1;
}

/*******************************************************************************

 $Function:    	Ciphering

 $Description:	Called by mfw
                Now this function doesn t seperate between the GSM and GPRS status
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/
void idle_Ciphering (UBYTE gsm_ciph, UBYTE gprs_ciph)
{


    if( gsm_ciph == 0 || gprs_ciph == 0 )
    {

        TRACE_FUNCTION ("Ciphering: is deactivated");

        idle_data.ciphering = SHOW_CPRS_DEACTIV;
        //show the DEACTIVATED ciphering indication 
        iconsSetState(iconIdCipheringDeActiv); 
        iconsDeleteState(iconIdCipheringActiv);

    }
    else if( gsm_ciph == 1 || gprs_ciph == 1 )
    {
        //show the ACTIVATED ciphering indication 

        TRACE_EVENT ("Ciphering: is activated");

        idle_data.ciphering = SHOW_CPRS_ACITV;

        iconsSetState(iconIdCipheringActiv); 
        iconsDeleteState(iconIdCipheringDeActiv);       
    }
    else if( gsm_ciph == 2 || gprs_ciph == 2 )
    {
        //dont show ANY indication !!!

        TRACE_EVENT ("Ciphering: is disabled");

        idle_data.ciphering = DONT_SHOW_CPRS;   

        iconsDeleteState(iconIdCipheringActiv);
        iconsDeleteState(iconIdCipheringDeActiv);
    }

    //update the screen
    windowsUpdate();

}
//begin xzy add for special test mode 2002/12/30;

/*******************************************************************************

 $Function:    	showVersion

 $Description:	Displays the version of software and date
        
 $Returns:		

 $Arguments:	
                
*******************************************************************************/

//hxl add for charger 29/08/02-----------------------------------------------
static int blinkEvent (MfwEvt e, MfwTim *t)
{
    UBYTE CurrentChargerStatus;
    MmiTrace("blinkEvent");

    if( idleIsFocussed() )
    {
        MmiTrace("idleIsFocussed");
        if( (pwr_Status.charger_plugged==0)||(pwr_Status.charging_state==0) )
        {//no charger or charging full
            GetBatPicnum(); //2004-03-18 Sunny add
            SetChargingIcon( CurrentBatPicNum );
            DisplayOuterIdleCharge( CurrentBatPicNum );//2004-03-21 Sunny add
            timStop(gtimeBlink);
            IsBlinktimerRun=0;
            ChargeOffset=0;
        }
        else
        {
            //2004-04-05 Sunny modify
            if( !idle_data.edt )
            {
                ALPollingTick();            
            }

            timStart(gtimeBlink);
            IsBlinktimerRun = 1;//2004-03-21 Sunny add
        }
    }
    else
    {
        IsBlinktimerRun=0;
        ChargeOffset=0;
        //	    GlobalIconStatus = GlobalNothingIconFlag;
    }

    return 1;
}
//end of hxl add for charger 29/08/02---------------------------------------------
//begin of xsf add timer for missed calls 2002.09.16
static int missedCallEvent (MfwEvt e, MfwTim *t)
{
    //TRACE_EVENT("XSF:missedCallEvent()");
    if( tim_missedcalls<60 )
        tim_missedcalls++;
    else
        tim_missedcalls=0;

    /*
        glowing: modify the following statement for processing
        the NETWORK_LIMITED_SERVICE
     */
    if( (idle_data.search) && ( (idle_data.nm_status == NETWORK_NO_SERVICE) ||(idle_data.nm_status == NETWORK_LIMITED_SERVICE)) )
    //if ((idle_data.search)&&(idle_data.nm_status == NETWORK_NO_SERVICE))
    {
        if( idleIsFocussed()&& anim_real_complete )
        {
            nm_registration (NM_AUTOMATIC,0, 0);
            windowsUpdate();
        }
    }
    if( (tim_missedcalls==60)&& (!call_data.win) )
    {
        if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].MissedcallTone
            && idle_data.missedCalls )
        {
            //StartTonebypara(3);  //xsf changed 12.31
            StartPlayByReason(MISSEDCALL,0);
        }
        else if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].UnreadSMSTone
                 && idle_data.new_sms )
        {
            //StartTonebypara(2);  //xsf changed 12.31
            StartPlayByReason(UNREADSMS,0);
        }
    }
    timStart(gtimeMissedCall);
    return 1;
}
//end of xsf add 2002.09.16
static void batEvent(void)
{
    //LedLightnessAdjust( 200 );
    //timStart(gtVibator);

    MmiTrace("batEvent");
    if( (idleIsFocussed())||(idleisshown) )
    {
        idleisshown=0;
        pwr_Status.ChargingVirtualKeyFlag=0;
        GetBatPicnum();

        if( (pwr_Status.charger_plugged==0)||(pwr_Status.charging_state==0) )
        {//no charger or charging full

            if( IsBlinktimerRun )
            {
                timStop(gtimeBlink);
                IsBlinktimerRun=0;
                ChargeOffset=0;
            }

            GetBatPicnum();//2004-03-18 Sunny add
            SetChargingIcon( CurrentBatPicNum );
            DisplayOuterIdleCharge( CurrentBatPicNum );//2004-03-21 Sunny add
        }
        else if( pwr_Status.charging_state>0 )
        {//charger in and not full
            if( IsBlinktimerRun==0 )
            {
                BlinkBatPicnum=CurrentBatPicNum;

                //2004-04-05 Sunny modify
                if( !idle_data.edt )
                {
                    ALPollingTick();            
                }

                timStart(gtimeBlink);
                IsBlinktimerRun=1;
            }

        }//end of charger 
    }//end of idle 
}

#if _M188_
void GetBatPicnum(void)
{
    UBYTE   oldbatPicnum=CurrentBatPicNum;

    bat_voltage_info.remain_capacity=pwr_Status.remain_capacity;

    switch( bat_voltage_info.remain_capacity )
    {
    case 100:
    case 95:
    case 90:
        CurrentBatPicNum=4;
        break;
    case 80:
        CurrentBatPicNum=3;
        break;
    case 60:
        CurrentBatPicNum=2;
        break;
    case 40:
        CurrentBatPicNum=1;
        break;
    case 20:
    case 10:
    case 5:
        CurrentBatPicNum=0;
        break;
    default:
        break;
    }

    if( CurrentBatPicNum!=oldbatPicnum )
        bat_voltage_info.batchanged=1;
    else
        bat_voltage_info.batchanged=0;

}
#else
void GetBatPicnum(void)
{
    UBYTE   oldbatPicnum=CurrentBatPicNum;

    bat_voltage_info.remain_capacity=pwr_Status.remain_capacity;
    /* zhq, 2004/06/16, modify for using ranging to decide the CurrentBatPicNum. */
    if( bat_voltage_info.remain_capacity >= 90 )
        CurrentBatPicNum=4;
    else if( bat_voltage_info.remain_capacity >= 70 )
        CurrentBatPicNum=3;
    else if( bat_voltage_info.remain_capacity >= 50 )
        CurrentBatPicNum=2;
    else if( bat_voltage_info.remain_capacity >= 25 )
        CurrentBatPicNum=1;
    else
        CurrentBatPicNum=0;


    if( CurrentBatPicNum!=oldbatPicnum )
        bat_voltage_info.batchanged=1;
    else
        bat_voltage_info.batchanged=0;

}
#endif

/********************************************
$History
*******2003/12/03,talcon modify
**********************************************/
static void DrawSceneselect_rect(void)
{
    // UINT32 oldcolor;
    //UINT32 oldfontcolor;
    int8 i; 
    char *szTitle = 0;

    //oldcolor=dspl_GetBkgColor();
    //oldfontcolor=dspl_GetFrgColor();
    //dspl_SetFrgColor( GetPreDefinedColor(ColorSoftKeyFont));
    //dspl_SetBkgColor(0xffffff);
    dspl_Clear(0, 97, 128, 144);

    //dspl_SetFrgColor(0x4E9C87); 
    //dspl_DrawRect(1, 97, 118, 143);  //draw rectangle
    //dspl_DrawRect(2, 98, 117, 142);
    //drawIconByIcnAttr((MfwIcnAttr*)sceneBarAttr,0);
    //dspl_SetBkgColor(0xffffff);
    //dspl_DrawFillRect(4, 101, 116, 141);
    // dspl_SetFrgColor(0x000000);   //ɫ  cornflowerblue 6495ed 
    switch( idle_data.preSelect_num )
    {
    case 0:
        szTitle = GET_TEXT(TxtNormals);
        break;
    case 1:
        szTitle = GET_TEXT(TxtOut);
        break;
    case 2:
        szTitle = GET_TEXT(TxtMeeting);
        break;
    case 3:
        szTitle = GET_TEXT(TxtIncar);
        break;
    case 4:
        szTitle = GET_TEXT(TxtSilent);
        break;
    default:
        break;
    }
    if( szTitle )
    {
        int x = (128 - get_StringWidth(szTitle))/2;
        dspl_TextOut(x,101,DSPL_TXTATTR_WHITE_EDGE,szTitle);
    }
    // dspl_SetFrgColor(0xd9d9f3);  //ʯӢɫ
    //dspl_DrawLine(3,120,116,120);

    //dspl_SetBkgColor(0x4E9C87);  
    //dspl_Clear(idle_data.preSelect_num*23+4, 124, idle_data.preSelect_num*23+23, 140);
    //dspl_Clear(idle_data.preSelect_num*23+5, 125, idle_data.preSelect_num*23+22, 139); //draw frame of scene mode icons
    for( i=0;i<5;i++ )
    {
        if( i==idle_data.preSelect_num )
        {
            UINT32 oldColor = dspl_SetBkgColor(0x95aeb3);
            dspl_Clear(i*23+6 - 2, 124,i*23+6+15+4, 126 + 16);
            dspl_SetBkgColor(oldColor);
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_SCENE, i*23+6, 126, i, ICON_LOCATION|ICON_MASK);
        }
        else
        {
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_SCENE, i*23+6, 126, i, ICON_LOCATION);
        }
    }              
    // dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
    //dspl_SetFrgColor( GetPreDefinedColor(ColorSoftKeyFont));
    //dspl_SetFrgColor(0x5f9ea0);// (0x2f4f4f); // ɫ darkslategray 2f4f4f 
    //displaySoftKeys(TxtSoftSelect, TxtSoftBack);
    displayColorSoftKeys2(TxtSoftSelect,TxtSoftBack,0xffffffff,0x606060);
    //dspl_SetBkgColor(oldcolor);
    //dspl_SetFrgColor(oldfontcolor);

}//end of xsf add for scene mode select 11.27


/**********************************************************
 Function: DAIsignalEnable
 Description:Enable the DAI signal

***********************************************************/
void DAIsignalEnable()
{
    *((volatile UINT16 *) 0xfffef00a) &= 0xfe1f; // Switch GPIO to MCSI (DAI) mode
}

/**********************************************************
Function: CheckNetWork()
Description: Check the network, register the status for auto reset protection
Return:  void
***********************************************************/
void CheckNetWork()
{
    if( !idle_data.nm_status )
    {
        RegisterNoNetWork();    //gan chunhui 2003/3/23 register it there is no network
    }
    else
    {
        /*gan chunhui
        register the network status, for deciding when reset the mobile phone
        */
        if( idle_data.nm_status==NETWORK_FULL_SERVICE )
            NetWorkFoundRegister();
        else
            RegisterNoNetWork();    //gan chunhui 2003/3/23 register it there is no network
    }
}
//end of hxl add for charger 29/08/02---------------------------------------------

/***********************************************************
* Function: idlebkganim_timer_cb
* Purpose:  Timer of Idle background animation
* Author: talcon
* Date: 2003/10/30
************************************************************/
static int idlebkganim_timer_cb(MfwEvt e, MfwTim *t)
{
    MfwHnd     win  = mfwParent (mfwHeader());

    timStop(idle_data.idleanimtimer);
    MmiTrace("glowing: idlebkganim_timer_cb-- 1" );

    if( idleIsFocussed() && !idle_data.isLCDCover )
    {
        U8 uMode;

        //timSetTime(idle_data.idleanimtimer,10000);
        //uMode = dspl_Enable(0);
        winShow(win);
        //draw_idleAnim();
        //dspl_Enable(uMode);
        //timSetTime(idle_data.idleanimtimer,idleanim_timeout);
    }

    return 0;

}
/*2003/12/15,talcon delete*/
#if 0
/***********************************************************
* Function: get_bkgicnAttr
* Purpose:  get icon attrubite by index
* Author: talcon
* Date: 2003/10/30
************************************************************/
MfwIcnAttr *  get_bkgicnAttr(int i)
{
    char temp[100];
    MfwIcnAttr * icnAttr = 0;

    sprintf(temp,"glowing: get_bkgicnAttr -- i=%d", i );
    MmiTrace(temp );

    //TRACE_EVENT("glowing: get_bkgicnAttr -- enter i=%d");
    switch( i )
    {
    case 1:

        icnAttr = BackgroundIcon1;
        break;
    case 2:
        icnAttr = &BackgroundIcon2;
        break;
    case 3:
        icnAttr = &BackgroundIcon3;
        break;
    case 4:
        icnAttr = &BackgroundIcon4;
        break;
    case 5:
        icnAttr = &BackgroundIcon5;
        break;
    case 6:
        icnAttr = &BackgroundIcon6;
        break;
    case 7:
        icnAttr = &BackgroundIcon7;
        break;
    default:
        break;
    }
    return icnAttr;
}
#endif
/***********************************************************
* Function: dspl_IdleBackBmpAnim
* Purpose:  Idle background animate
* Author: talcon
* Date: 2004/06 sunsj modify for icon manage
************************************************************/
void dspl_IdleBackBmpAnim(int i,UBYTE * pIndx)
{
    // MfwIcnAttr * icnAttr = get_bkgicnAttr(i);
    MfwIcnAttr * icn =0;

    if( i <= DYNAMICWALLPAPER_NUM && i>0 )
    {
        *pIndx = Draw_Idleanimation(i+ICON_IDLEDYNAMICWALLPAPER_ONE-1, *pIndx);//drawAnimIcons((MfwIcnAttr *)BkgIdleAnimIcons[i-1],*pIndx); 
        if( *pIndx == 0xff )
            *pIndx = 0;
    }
    else if( i>DYNAMICWALLPAPER_NUM && i<= DYNAMICWALLPAPER_NUM + STATICWALLPAPER_NUM )
    {
        i -= (DYNAMICWALLPAPER_NUM+1);
#if(MAIN_LCD_SIZE==3)
		DRAW_ICON_SEL(ICON_IDLESTATICWALLPAPER,i);
#elif (MAIN_LCD_SIZE==4)
		DRAW_ICON(idlewallpaperId[i]);
#endif
    }
    else if( i == DYNAMICWALLPAPER_NUM + STATICWALLPAPER_NUM + 1 )
    {
        dspl_BitBltUser(1);
    }
    else
    {
        dspl_ClearAll();
    }
}

/*********************************************************
$Function:drawIdleZoneBack
$Description:back anim
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZoneBack()
{
    if( (idle_data.nIdleDrawFlags & 0x1000) == 0 )
        return ;

    //if (FlashSettingData.BGI!=0)//zy 09/11
    {
        //FlashSettingData.BGI = FlashSettingData.BGI%2 + 1;//2003/10/31,talcon ES!
        //int bgindex=FlashSettingData.BGI %2 + 1 ;
        /*2003/10/30,talcon add*/
        //if ( bgindex == 1 )
        //{
        //timStart(idle_data.idleanimtimer);
        //}

        /* 2003/10/30,talcon modify it */
        //dspl_IdleBackBmp(bgindex);
        dspl_IdleBackBmpAnim(FlashSettingData.BGI, &idle_data.idxbkganim);
        //dspl_IdleBackBmpAnim(bgindex);
        /* end talcon */
    }
}//end drawIdleZoneBack

/*********************************************************
$Function:drawIdleZone1
$Description:icon
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone1()
{
    if( (idle_data.nIdleDrawFlags & 0x01) == 0 )
        return;
    GlobalIconStatus = GlobalSignalIconFlag //| GlobalBatteryIconFlag,hxl delete 20020911
                       | GlobalSMSIconFlag   | GlobalVoiceMailIconFlag
                       | GlobalCallForwardingIconFlag| GlobalKeyplockIconFlag
                       | GlobalRingerIconFlag | GlobalRingVibrIconFlag
                       | GlobalVibratorIconFlag | GlobalAlarmIconFlag
                       | GlobalSilentRingerIconFlag|GlobalCipheringActivIconFlag
                       | GlobalCipheringDeactivIconFlag| GlobalIconTimerFlag|GlobalIconServiceFlag|GlobalIconRoamFlag//zy add 12-23-2002
                       /* sbh...18/01/02. Flag for GPRS On and GPRS Attached icons. */
#ifdef MMI_GPRS_ENABLED
                       | GlobalGPRSOnIconFlag
#endif
                       /* SPR759 - SH - Flag for Homezone icon */
#ifdef MMI_HOMEZONE_ENABLED
                       | GlobalHomezoneIconFlag
#endif
                       ;    
    //idleϱߵicon
    MmiTrace("<<<<<<talcon,function:drawIdle---display icon");
    iconsShow();
}//end drawIdleZone1

/*********************************************************
$Function:drawIdleZone2
$Description:charge icon
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone2()
{
    if( (idle_data.nIdleDrawFlags & 0x02) == 0 )
        return;
#if 1/*2003/12/01,talcon comment it*/
    if( pwr_Status.ChargingVirtualKeyFlag )
    {
        //SetChargingIcon( CurrentBatPicNum );//zy 2003-02-20 show battery when from menu back to idle and charg is plug in
        //2004-03-21 Sunny add
        if( IsBlinktimerRun ==1 )
        {
            SetChargingIcon( OlderCurrentBatPicNum );
        }
        else
        {
            SetChargingIcon( CurrentBatPicNum );
        }
        //2004-03-21 Sunny add end

        batEvent();
    }
    //else
#endif
    //2004-03-21 Sunny add
    if( IsBlinktimerRun ==1 )
    {
        SetChargingIcon( OlderCurrentBatPicNum );
    }
    else
    {
        SetChargingIcon( CurrentBatPicNum );
    }
    //2004-03-21 Sunny add end

}//end drawIdleZone2

/*********************************************************
$Function:drawIdleZone3
$Description:greeting word
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone3()
{
    if( (idle_data.nIdleDrawFlags & 0x04) == 0 )
        return;
    //zy judge flash Greetingword status then show the different icon 04/08/02
    if( FlashSettingData.GreetingWordIsOn )
    {
        /* 2004/03/08 sunsj modify display area */
        displayAlignedText(CENTER,THIRD_LINE,DSPL_TXTATTR_WHITE_EDGE,(char*)FlashSettingData.greeting_word);//jhxu720
    }

}//end drawIdleZone3

/*********************************************************
$Function:drawIdleZone4
$Description:service status
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone4()
{
    /* 2004/03/15 sunsj modify */
#define SERVICE_STATUS_POSY SECOND_LINE
    T_CURRENT_NETWORK current_network;
    int txtStrId;
    if( (idle_data.nIdleDrawFlags & 0x08) == 0 )
        return;
    switch( idle_data.nm_status )
    {
    case 0:
        ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoNetwork);//jhxu720
        break;
    case NETWORK_FULL_SERVICE : 
        /*NM p032
         set the flag when the TEST SIM is inserted*/
        network_get_name (&current_network);
        if( !strcmp((char *)current_network.network_name,"00101") )
        {
            test_sim = TRUE;
        }
        else
        {
            test_sim = FALSE;
        }
        if( ( !strcmp((char *)current_network.network_name,"46000") )
            || ( !strcmp((char *)current_network.network_name,"46001") )
            || ( !strcmp((char *)current_network.plmn_name,"CHINA  MOBILE")) 
            || ( !strcmp((char *)current_network.plmn_name,"CHN-CUGSM") )
            || ( !strcmp((char*)current_network.plmn_name, "CMCC"))
            || ( !strcmp((char*)current_network.plmn_name, "CU-GSM")) )
        {
            if( (!strcmp((char *)current_network.network_name,"46000"))||(!strcmp((char *)current_network.plmn_name,"CHINA  MOBILE"))||(!strcmp((char*)current_network.plmn_name, "CMCC")) )
            {
                txtStrId   = T_China_Telecomm;
            }
            else if( (!strcmp((char *)current_network.network_name,"46001"))||(!strcmp((char *)current_network.plmn_name,"CHN-CUGSM"))||(!strcmp((char*)current_network.plmn_name, "CU-GSM")) )
            {
                txtStrId   = T_China_Unicomm;
            }
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,txtStrId);//jhxu720
        }
        else
        {
            if( current_network.plmn_name[0]!= NULL )   //xsf add for avoid display plmn_name "0000" 12.18
                displayAlignedText(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,(char*)current_network.plmn_name);//jhxu720
            else
                ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoNetwork);//jhxu720
        }
        break;
    case NETWORK_LIMITED_SERVICE :
        if( sim_status_check() == SIM_NOT_ACTIVE )
        {
            RegisterNoSIM();
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoCard);//jhxu720
        }
        else
        {
            network_get_name (&current_network);
            // displayAlignedText(CENTER,FIFTH_LINE,DSPL_TXTATTR_WHITE_EDGE,(char*)current_network.plmn_name);
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtLimitedService);//jhxu720
        }              
        break;
    case NETWORK_SEARCH_NETWORK :
        ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtSearching);//jhxu720
        break;
    case NETWORK_NO_SERVICE :
        /*copy from133s48 ganchh 2002/11/19*/
        if( sim_status_check() == SIM_NOT_ACTIVE )
        {
            RegisterNoSIM();    //ganchh 2003/3/23 register it is a NOSIM event
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoCard);//jhxu720
        }
        else //xsf remarked it 03.04.08 if(FlashSettingData.GreetingWordIsOn)
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoNetwork);//jhxu720
        break;
    case NETWORK_NO_PLMN_XXX_AVAIL:
        if( sim_status_check() == SIM_NOT_ACTIVE )
        {
            RegisterNoSIM();  //ganchh 2003/3/23  register it is NOSIM event
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoCard);//jhxu720
        }
        else
        {
            network_get_name (&current_network);
            displayAlignedText(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,(char*)current_network.plmn_name);//jhxu720
            ALIGNED_PROMPT(CENTER,SERVICE_STATUS_POSY,DSPL_TXTATTR_WHITE_EDGE,TxtNoNetwork);//zy add DSPL_TXTATTR_WHITE_EDGE09/18
        }
        break;
    default:
        return ;
    }
}//end drawIdleZone4

/*********************************************************
$Function:drawIdleZone5
$Description:miss call and miss sms
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone5()
{
    char text[20];
    int txtNo;      //Numeric value to be displayed (0=no value)
    int xOfs;       //used to offset text id when a number is to be displayed 
    int txtStrId = TxtNull;
    if( (idle_data.nIdleDrawFlags & 0x10) == 0 )
        return;
    /* 2004/03/30 sunsj modify for sms report */
    IsMissedCallAndSms = 0; // 2004-04-01 Sunny add
    if( idle_data.edt )
    {
        edtUnhide(idle_data.edt);
        edtShow(idle_data.edt);
    }
    else if( idle_data.missedCalls )
    {
        txtNo = idle_data.missedCalls;
        if( idle_data.missedCalls <= 1 )
        {
            txtStrId = TxtMissedCall;

        }
        else
        {
            txtStrId = TxtMissedCalls;
        }

    }
    else if( txtStrId = (smsidle_display_sms_status(&txtNo )) )
    {
        idle_data.new_sms = TRUE;
    }
    else if( idle_data.new_cbch )
    {
        txtStrId = TxtNewCbMessage;
    }
#ifdef _MMS_ENABLE_
	else if(txtNo = (int)MMS_Get_NewMMS_Sum())
	{
		txtStrId = TxtMMSNewMMSSum;
//		txtNo = (int)MMS_Get_NewMMS_Sum();
//		StartPlayByReason(SMSPLAY,0);
	}
#endif
	
    if( txtStrId != TxtNull )
    {
        /* 2004/03/15 sunsj modify */
        //xOfs = (SCREEN_SIZE_X - wstrBitlen(GET_TEXT(txtStrId))*8)/2;
        xOfs = (SCREEN_SIZE_X - get_StringWidth(GET_TEXT(txtStrId)))/2;

        if( txtNo != 0 )
        {//we have a number to display - number of new messages/missed calls
            memset(text,0,sizeof(text));
            sprintf((char*)text,"%d",txtNo);
            if( txtNo < 10 )   //xsf changed 2003.01.23
            {
                /* 2004/03/15 sunsj modify */
                dspl_TextOut(xOfs-5, THIRD_LINE, DSPL_TXTATTR_WHITE_EDGE,text); 
                xOfs = xOfs+5;
            }
            else if( txtNo < 100 )   //xsf 2003.04.08
            {
                /* 2004/03/15 sunsj modify */
                dspl_TextOut(xOfs-9, THIRD_LINE, DSPL_TXTATTR_WHITE_EDGE,text);//zy add DSPL_TXTATTR_WHITE_EDGE09/18
                xOfs = xOfs+9;
            }
            else   //xsf 2003.04.08
            {
                /* 2004/03/15 sunsj modify */
                dspl_TextOut(xOfs-13, THIRD_LINE, DSPL_TXTATTR_WHITE_EDGE,text);//zy add DSPL_TXTATTR_WHITE_EDGE09/18
                xOfs = xOfs+13;
            }
        }
        /* 2004/03/15 sunsj modify */
        dspl_TextOut(xOfs, THIRD_LINE, DSPL_TXTATTR_WHITE_EDGE,GET_TEXT(txtStrId));// xsf change to DSPL_TXTATTR_WHITE_EDGE09/25
        /* 2004/07/09 sunsj remove */
        //setOuterState(OUTERIDLESTATE_INCOMING,0,0);//2004-03-21 Sunny add.
        IsMissedCallAndSms = 1; // 2004-04-01 Sunny add
    }

}//drawIdleZone5

/*********************************************************
$Function:drawIdleZone6
$Description:clock and date
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone6()
{
    if( (idle_data.nIdleDrawFlags & 0x20) == 0 )
        return;
    showCLOCK();
    //showDATE();
}//drawIdleZone6

/*********************************************************
$Function:drawIdleZone7
$Description:soft key
$History:
********2003/11/29,talcon add
    2004/04/09 sunsj modify sofekey color
**********************************************************/
void drawIdleZone7()
{
    if( (idle_data.nIdleDrawFlags & 0x40) == 0 )
        return;
    //dspl_SetFrgColor( GetPreDefinedColor(ColorSoftKeyFont));//end of zy add 09/18
    if( idle_data.search )
    {
        switch( idle_data.nm_status )
        {
        /*
           glowing: add the following statement for processing
           the NETWORK_LIMITED_SERVICE 
         */
        case NETWORK_LIMITED_SERVICE:
        case NETWORK_NO_SERVICE :
        case NETWORK_NO_PLMN_XXX_AVAIL:
            //displaySoftKeys(TxtSearchName,TxtNull);
            displayColorSoftKeys2(TxtSearchName,TxtNull,0x000000,0x000000);
            //dspl_SetBkgColor(oldcolor);//zy add 09/18
            //dspl_SetFrgColor(oldfontcolor);//zy add 09/18
            return ;
            break;
        default:
            displayColorSoftKeys2(TxtSoftMenu,TxtPhonebook,0x000000,0x000000);
#if(MAIN_LCD_SIZE==3)
			draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
            break;
        }
    }
    else if( (!idle_data.clean_screen) && idle_data.edt )
    {
        //displaySoftKeys(TxtNull,TxtSoftBack);
        displayColorSoftKeys2(TxtNull,TxtSoftBack,0x000000,0x000000);
    }
    else if( (!idle_data.clean_screen) &&(idle_data.missedCalls > 0) )
    {
        //displaySoftKeys(TxtRead,TxtSoftMenu);
        displayColorSoftKeys2(TxtRead,TxtSoftMenu,0x000000,0x000000);
    }
#ifdef QQFUNC
    else if( ( smsidle_get_unread_sms_available() 
               && (!idle_data.clean_screen)//hxl add qq info,2003-3-23
               && idle_data.new_sms )||((!idle_data.clean_screen) && (idle_data.new_QQ)) )
#else
    else if( ( smsidle_get_unread_sms_available() 
               && (!idle_data.clean_screen)
               && idle_data.new_sms ) )
#endif
    {
        //displaySoftKeys(TxtRead,TxtSoftMenu);
        displayColorSoftKeys2(TxtRead,TxtSoftMenu,0x000000,0x000000);
    }
    else if( (!idle_data.clean_screen) && idle_data.new_cbch )
    {
        //displaySoftKeys(TxtRead,TxtSoftMenu);
        displayColorSoftKeys2(TxtRead,TxtSoftMenu,0x000000,0x000000);
    }
#ifdef _MMS_ENABLE_    //add by xie 04-07-29
    else if(!idle_data.clean_screen && MMS_Get_NewMMS_Sum())
    {
        displayColorSoftKeys2(TxtRead,TxtSoftMenu,0x000000,0x000000);
    }
#endif     
    else
    {
        //displaySoftKeys(TxtSoftMenu,TxtPhonebook); //xsf 09.10 TxtNames);////zy change the softkey in idle 04/08/02
        displayColorSoftKeys2(TxtSoftMenu,TxtPhonebook,0x000000,0x000000);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
    }
}//drawIdleZone7

/*********************************************************
$Function:drawIdleZone8
$Description:scene mode
$History:
********2003/11/29,talcon add
**********************************************************/
void drawIdleZone8()
{
    if( (idle_data.nIdleDrawFlags & 0x80) == 0 )
        return;
    if( SceneSelect_mode )  //xsf add for scene mode select 11.27
        DrawSceneselect_rect();
}//drawIdleZone8
/*2003/11/13,talcon add it */
void drawIdle()
{

    UINT32 oldcolor;//zy add 09/18
    UINT32 oldfontcolor;

    MmiTrace("<<<<<<talcon,function:drawIdle");
    idle_data.missedCalls = FlashDCTbData.MissedCallNum; //hu binhao 2002-11-29 
    MCallHintDleteFlag=0;  //hu binhao  2003-1-29 

#ifdef _MMS_ENABLE_	/* robert.chen add, 2004-08-10 */
	{
		extern BOOL gIsMMSInitialized;
		extern BOOL gIsNewMMSIncoming;
		if(TRUE == gIsMMSInitialized || TRUE == gIsNewMMSIncoming)
		{
			MMS_Fresh_NewMMS_Sum();
		}
		if(TRUE == gIsNewMMSIncoming)
		{
		    gIsNewMMSIncoming = FALSE;
		}
		if(TRUE == gIsMMSInitialized)
		{
			MMS_Destroy_In_Idle();
			gIsMMSInitialized = FALSE;
		}
	}
#endif	
    
    // hu binhao 2002-2-11 begin
	drawOuterIdle();//shiheng 0809 add
    if( SimCFReadFlag==0 )
    {
        if( FlashDCTbData.CFFlag&0xf )
        {
            iconsSetState(iconIdCallFor);
        }
        else
        {
            iconsDeleteState(iconIdCallFor);
        }
        SimCFReadFlag=1;  
    }

    //		dspl_ClearAll();
    /* 2004/03/08 sunsj modify lcd size */
    dspl_Clear(0, 14, SCREEN_SIZE_X, SCREEN_SIZE_Y);//don't clear first line,hxl 

    if( idle_data.starting_up ) /*SPR#1083 - JVJ Show please wait since the phone is not ready yet*/
    {
        PROMPT(10,Mmi_layout_first_line_icons(),0,TxtPleaseWait);
        return ;
    }
    idle_data.nIdleDrawFlags = 0xffffffff;  

    //2004-04-21 Sunny add the condition for filtering the power on pic 
#ifndef _INNOVATION_EMULATOR_
    if( idle_data.nm_status == 0 )
    {
        return;
    }
#endif 
    //2004-04-21 Sunny add the condition end

    //draw idle background
    drawIdleZoneBack();

    //start of hxl add for charger 29/08/02--------------------------------------
    idleisshown=1;
    //
    drawIdleZone2();

    //draw icons
    drawIdleZone1();    

    //draw service status
    drawIdleZone4();    
    //drawOuterIdle();//shiheng 0810 remove


    //draw missedcall and missedsms
    drawIdleZone5();

    // 2004-04-01 Sunny add and modify
    if( IsMissedCallAndSms == 0 )
    {
        //draw Greetingword
        /* 2004/04/10 sunsj modify */
        if( !idle_data.edt )
        {
            drawIdleZone3();
        }
    }
    // 2004-04-01 Sunny add and modify end

    /* 2004/03/30 sunsj modify */
    if( !idle_data.edt )
    {
        //draw clock and date
        drawIdleZone6();
    }

    //draw softkey
    drawIdleZone7();

    //draw scene mode
    drawIdleZone8();

    idle_data.nIdleDrawFlags = 0;
}

/*************************************************
$Function:idleHandleByLcdState
$Argument
******uState
            0: lcd off
            1:lcd on
$History
*******2003/11/22,talcon create
*************************************************/
void idleHandleByLcdState(U8 uState)
{
    if( uState == 0 )
    {

        idle_data.isLCDCover = 2;
        //timStop(idle_data.idleanimtimer);
    }
    else if( uState == 1 )
    {

        idle_data.isLCDCover  = 0;
        //timStart(idle_data.idleanimtimer);
        if( idleIsFocussed() )
        {
            winShow(idle_data.win); 
        }
    }
}//end Function:idleHandleByLcdState

U8 isLcdOff()
{
    return idle_data.isLCDCover;
}
/*************************************************
$Function:setIdleDrawFlags
$History
*******2003/11/29,talcon create
*************************************************/
void setIdleDrawFlags(U32 nFlags,U8 nMask)
{
    if( nMask == 0 )
    {
        idle_data.nIdleDrawFlags &= ~nFlags;
    }
    else
    {
        idle_data.nIdleDrawFlags |= nFlags;
    }
}//end Function:setIdleDrawFlags

/* 2004/07/09 sunsj add for hall off */
int FocuseIdlewin()
{
	return winIsFocussed(idle_data.win);
}
