/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Call
 $File:		    MmiIdle.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
                        
********************************************************************************

 $History: MmiIdle.h

	25/10/00			Original Condat(UK) BMI version.	
	20/08/02    ver0.101  fzq modified
	   
 $End

*******************************************************************************/

#include "mfw_edt.h"
#include "mmiQQSwitch.h" //hxl add for check qq func


#define EDITOR_SIZE 22					/* SPR761 - SH - Moved from MmiIdle.c, changed to 41 */

#ifndef _DEF_MMI_IDLE_H_
#define _DEF_MMI_IDLE_H_


typedef enum
{										/* REASONS                  */
 IdleNone = IdleDummy,					/* no reason                */
 IdleNormal,							/* normal idle mode         */
 IdleUpdate,
 IdleSearchNetwork,
 IdleNewSmsMessage,
 IdleActiveKeyPadLocked,
 IdleNewCBImmediateMessage,
 IdleNewCBNormalMessage
 #ifdef QQFUNC//hxl add for qq func switch,2003-3-24
, IdleNewQQMessage
 #endif
};

typedef enum
{										/* REASONS                  */
	IDLE_NO_NETWORK,
	IDLE_UPDATE,
	IDLE_NEW_SMS,
	IDLE_ACTIVE_KEY_PAD_LOCKED,
	IDLE_DETAILS_NUMBER,
	IDLE_DIALLING_INIT,
	IDLE_INFO_ENDED,
	IDLE_KEYPAD_LOCKED_UPDATE,
	IDLE_START_DIALLING_NUMBER
	#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
	,IDLE_NEW_QQ
	#endif
};



#define SHOW_CPRS_DEACTIV   	0
#define SHOW_CPRS_ACITV			1		
#define DONT_SHOW_CPRS			2 //not allowed to show any indication

/*
*  The information related to every window must be encapsulated in such an structure
*/
typedef struct
{
    T_MMI_CONTROL   mmi_control;		// this a common parameter in every structure
	T_MFW_HND win;						// windows handler, another common parameter
	T_MFW_HND kbd;						// To control all of the events, 2 handler are needed kbd that handles the key press
    T_MFW_HND kbd_long;					// event and kbd_long that handles the release and long key event.
    T_MFW_HND edt;
    T_MFW_HND edt_sat;					/* SPR759 - SH*/
	T_MFW_HND info_win;
	T_MFW_HND phonebook_win;
	int missedCalls;
	UBYTE search;
	UBYTE flagIdle;
    USHORT nm_status;
	char edt_buf[EDITOR_SIZE];			/* SPR761 - SH - Changed from a number to a constant */
	char dialshow_buf[EDITOR_SIZE];	
	MfwEdtAttr edt_attr;				//this one for the dialling editor
	MfwEdtAttr edt_attr2;				//this is for the CB editor
	MfwEdtAttr edt_attr3;				//this is for the (only CLASS 0) SMS editor	
	MfwEdtAttr edt_attr_sat;			/* SPR759 - SH*/
	char imei[16];
    UBYTE new_sms;
    UBYTE new_cbch;
	CHAR incoming_cb_msg[MAX_CBMSG_LEN]; 
	/*NM, p019*/
	CHAR incoming_sms_msg[MAX_MSG_LEN_ARRAY]; 	
    UBYTE right_key_pressed;
    UBYTE silent_mode;
    UBYTE clean_screen;
    UBYTE ciphering;
    UBYTE starting_up;                  /*SPR#1083 - JVJ - New field for checking the start up status */
    CHAR incoming_sat_msg[MAX_CBMSG_LEN];		/* SPR759 - SH*/
    UBYTE preSelect_num;  //xsf add for scene mode select 11.27
    #ifdef QQFUNC//hxl add for qq func switch,2003-3-24
    UBYTE	new_QQ;	//hxl add for QQ new info and full info 2003-1-5
    #endif

	/*2003/10/30,talcon add ,for Idle bkg animate*/
	MfwHnd idleanimtimer;
	UBYTE idxbkganim;
	/* end talcon */
	/*2003/11/22,talcon add*/
	UBYTE isLCDCover;/*
	 *	0: Uncover
	 *  1: Cover
	 *  2: Cover but winShow once
	 */
	/*end talcon add*/
	/*2003//11/29,talcon add*/
	U32  nIdleDrawFlags;
} T_idle;

/*2003/10/30,talcon add */
#define idleanim_timeout	350

extern UBYTE KeyPadLock;

                                        /* PROTOTYPES               */
extern void wake_up_rr(void);

void idleInit (MfwHnd parent);
void idleExit (void);
void idleExec (int reason, MmiState next);
void idleEvent(int reason);
void idleDialBuffer(char* dialBuffer);

MfwHnd idle_get_window(void);

int idleIsFocussed(void);
void idle_set_starting_up(UBYTE set);
void windowsUpdate(void);

void addMissedCall(char * num);

void addCBCH(char* cbch_string, UBYTE type);
void statusCBCH(UBYTE status);
void addSatMessage(char *satMessage);		/* SPR759 - SH*/
extern void showIMEI (T_MFW_HND win, char* IMEI);
extern int FocuseIdlewin();	/* 2004/07/09 sunsj add for return to idle */
//T_MFW_HND ShowVersion(T_MFW_HND parent_window);  //xsf add for show version in no simcard window 12.20
//int ShowVersion(MfwMnu* m, MfwMnuItem* i);
//int LayeronePara(MfwMnu* m, MfwMnuItem* i);


#endif

