/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
																			  
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiLists.c
 $Revision:		1.0                                                       
																			  
 $Author:		Condat(UK)                                                         
 $Date:		    22/02/01                                                      
																			   
********************************************************************************
																			  
 Description:

  

********************************************************************************

 $History: MmiLists.c

*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

	#include "typedefs.h"
	#include "vsi.h"
	#include "pei.h"
	#include "custom.h"
	#include "gsm.h"

#else

	#include "stddefs.h"
	#include "custom.h"
	#include "gsm.h"
	#include "vsi.h"

#endif

#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "prim.h"
#include "cus_aci.h"
#include "cnf_aci.h"
#include "mon_aci.h"

#include "tok.h"

#include "pcm.h"



#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"
#include "Mmisettings.h"

#include "pwr.h"   
#include "p_sim.h"
#include "mmibooksearchwindow.h"
#include "mmismsread.h"

#ifdef _MMS_ENABLE_
	#include "mmiMMSGlobalDef.h"
	#include "mmiMMSSetting.h"
#endif


#ifndef MFW_EVENT_PASSED
	#define MFW_EVENT_PASSED 0
#endif

extern MfwRect menuArea; /* menus display area */
extern driver_Parameter drvpara;
extern weeklyAlarm_win;
extern  uint8 CallListFlag;
extern MfwHnd cugwindows;
extern BOOL getMelodyListStatus(void);

typedef enum
{
	E_INIT,
	E_BACK,
	E_RETURN,
	E_ABORT,
	E_EXIT
} e_lists_events;


/*-----------------------------------------------------------------------------
*
* List menu handling functions:
*
*-----------------------------------------------------------------------------*/
#if 0
typedef struct
{
	T_MMI_CONTROL   mmi_control;
	T_MFW_HND winLists;
	SHORT           id;
	T_MFW_HND Parent;
	T_MFW_HND kbdLists;
	T_MFW_HND kbdLists_long;
	T_MFW_HND MenuLists;
	MfwMnuAttr MenuListsAttr;
	ListCbFunc Callback;
	UBYTE   ExitReason;
	ListMenuData MenuData;
} ListWinInfo;

#endif

static int listsKeyEvent(MfwEvt event, MfwKbd *keyboard);
static int listsWinEvent(MfwEvt e, MfwWin *w);
static int listsListCbMenu(MfwEvt EventCode, MfwMnu *MenuHandle);
static void lists_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);


/*******************************************************************************

 $Function:  listDisplayListMenu  

 $Description:	 Creates a list menu from data stored in NVRAM.

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
T_MFW listDisplayListMenu (MfwHnd Parent, ListMenuData *Data, ListCbFunc cbFunc,int inUnicode)
{
	UBYTE i;
	MfwWin * win;
	MfwHnd winLists;
	T_MFW Status = LISTS_OK;

	TRACE_FUNCTION ("listDisplayListMenu()");

	winLists = winCreate(Parent, 0, E_WIN_VISIBLE, (MfwCb)listsWinEvent);

	if (winLists == NULL)
	{
		Status = LISTS_FAIL;				/* Inform caller of failure. */
		TRACE_FUNCTION ("win creation fails");
	}
	else
	{
		ListWinInfo * ListData = (ListWinInfo *)ALLOC_MEMORY (sizeof (ListWinInfo));

		if (!ListData)
			TRACE_FUNCTION ("(ListWinInfo *)ALLOC_MEMORY fails");

		ListData->mmi_control.dialog = (T_DIALOG_FUNC)lists_exec_cb;
		ListData->mmi_control.data   = ListData;
		win = ((MfwHdr *)winLists)->data;
		win->user = (void *) ListData;

		ListData->Parent = Parent;
		ListData->Callback = cbFunc;
		ListData->winLists = winLists;
		ListData->kbdLists =      kbdCreate(winLists,Data->KeyEvents|KEY_MAKE,         (MfwCb)listsKeyEvent);
		ListData->kbdLists_long = kbdCreate(winLists,Data->KeyEvents|KEY_LONG,(MfwCb)listsKeyEvent);

		if ((ListData->kbdLists == NULL) || (ListData->kbdLists_long == NULL))
		{
			Status = LISTS_FAIL;
			TRACE_FUNCTION ("ListData->kbdLists fails");
		}
		else
		{
			/* Create initial list menu for display. */

			/*
			 * set menu list from outside
			 */
			ListData->MenuListsAttr = *Data->Attr; /* copy contents */
			if (Data->List[0].icon!=0)
				ListData->MenuListsAttr.mode = MNU_LEFT | MNU_OVERLAPPED | MNU_CUR_LINE;
			else ListData->MenuListsAttr.mode =MNU_LEFT | MNU_LIST | MNU_CUR_LINE;
			ListData->MenuListsAttr.font = Data->Font; 
			ListData->MenuListsAttr.items = Data->List;
			ListData->MenuListsAttr.nItems = Data->ListLength;

			ListData->MenuData.ListMenuFlag=Data->ListMenuFlag;
			ListData->MenuData.ListMenuHeadStr=Data->ListMenuHeadStr;
	
			/*
			 * Intialize List Menu Data
			 */

			/* view listmenu with title */
			ListData->MenuData.Attr = &ListData->MenuListsAttr;	/* copy pointer*/   
			ListData->MenuData = *Data;	/* copy contents */
			if (ListData->MenuData.ListMenuFlag)
				ListData->MenuLists = mnuListCreate(winLists,&ListData->MenuListsAttr, /* copy pointer*/
													E_MNU_SELECT | E_MNU_ESCAPE, 
													(MfwCb)listsListCbMenu, ListData->MenuData.ListMenuHeadStr);//ͷĶ̬˵
			else
				ListData->MenuLists	= mnuCreate(winLists,&ListData->MenuListsAttr, /* copy pointer*/
												E_MNU_SELECT | E_MNU_ESCAPE, 
												(MfwCb)listsListCbMenu);//̬˵
			ListData->MenuData.win = winLists;
			Data->win = winLists;
			mnuScrollMode(ListData->MenuLists,0);
			if (Data->Strings)
				mnuLang (ListData->MenuLists,0);
			else
				mnuLang	(ListData->MenuLists,mainMmiLng);

			//GW??? Set up whether menu uses strings or ID's
			if (inUnicode != 0)
				mnuStrType(ListData->MenuLists,mainMmiLng);	/* Unicode display */
			mnuChooseVisibleItem(ListData->MenuLists, Data->ListPosition-1);
			mnuUnhide(ListData->MenuLists);
			TRACE_FUNCTION ("mmiList winShow()");
			winShow(winLists);
			return(T_MFW)ListData->MenuLists;  
		}
	}

	return Status;
}


/*******************************************************************************

 $Function:  listsKeyEvent  

 $Description:	list keyboard event handler

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int listsKeyEvent (MfwEvt e, MfwKbd *k) 
{
	T_MFW_HND    win  = mfwParent(mfw_header());
	T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
	ListWinInfo      * data = (ListWinInfo *)win_data->user;
	MfwMnu *MenuHandle;

	TRACE_EVENT("listsKeyEvent()");

	if (!(e & KEY_MAKE))
	{
		return MFW_EVENT_CONSUMED;
	}


	if (e & KEY_LONG)
	{
		switch (k->code)
		{
		case KCD_HUP: /* back to previous menu */
			mnuEscape(data->MenuLists);
			break;
		case KCD_RIGHT:	/* Power Down */
			return MFW_EVENT_PASSED; /* handled by idle */
		default: /* no response to all other keys */
			return MFW_EVENT_CONSUMED;
		}
	}
	else
	{
		switch (k->code)
		{
		case KCD_MNUUP:	/* highlight previous entry */
			// Only required in melody list selection.
			if (data->Parent==GetWindowHandle()||data->Parent==GetCallWindowHandle())
			{
				data->ExitReason = LISTS_REASON_UP;
				data->MenuData.Reason = LISTS_REASON_UP;
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
				data->Callback(data->Parent, &data->MenuData);              
			}
			else if (getMelodyListStatus()== TRUE)
			{
				mnuUp(data->MenuLists);
				MenuHandle = mfwControl(data->MenuLists);

				data->MenuData.Reason = LISTS_REASON_SCROLL;
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level];
				//currentring = data->MenuData.ListPosition;  
				SEND_EVENT(data->Parent,E_START_MELODY,0,(void*)data);          
			}
			else if (GetSMSLISTWINHandle())
			{
				mnuUp(data->MenuLists);
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.Reason = LISTS_REASON_UP;
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
				data->Callback(data->Parent, &data->MenuData);              
			}
#ifdef _MMS_ENABLE_
			else if (data->Parent == MMS_Get_MMSImageMusic_WHnd()) //added by xie 04-07-15
			{
				mnuUp(data->MenuLists);
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.Reason = LISTS_REASON_UP;
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
				data->Callback(data->Parent, &data->MenuData);    
			}
#endif
			else
			{
				mnuUp(data->MenuLists);
				//  winShow(win);
			}                       
			break;

		case KCD_MNUDOWN: /* highlight next entry */
			if (data->Parent==GetWindowHandle()||data->Parent==GetCallWindowHandle())
			{
				TRACE_EVENT("in phb");
				data->ExitReason = LISTS_REASON_DOWN;
				data->MenuData.Reason = LISTS_REASON_DOWN;
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
				data->Callback(data->Parent, &data->MenuData);
			}
			else if (getMelodyListStatus() == TRUE)
			{
				TRACE_EVENT("in melody");
				mnuDown(data->MenuLists);
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.Reason = LISTS_REASON_SCROLL;
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; 
				SEND_EVENT(data->Parent,E_START_MELODY,0,(void*)data);
			}
			else if (GetSMSLISTWINHandle())
			{
				TRACE_EVENT("in sms");
				mnuDown(data->MenuLists);
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.Reason = LISTS_REASON_DOWN;
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
				data->Callback(data->Parent, &data->MenuData);              
			}
#ifdef _MMS_ENABLE_
			else if (data->Parent == MMS_Get_MMSImageMusic_WHnd()) //added by xie 04-07-15
			{
				mnuDown(data->MenuLists);
				MenuHandle = mfwControl(data->MenuLists);
				data->MenuData.Reason = LISTS_REASON_DOWN;
				data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
				data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
				data->Callback(data->Parent, &data->MenuData);    
			}
#endif		
			else
			{
				TRACE_EVENT("we only mnudown");
				mnuDown(data->MenuLists);
			}             
			break;
		case KCD_LEFT: /* activate this entry */
			// mnuSelect(data->MenuLists);

/*2003/11/24, wangyan modify*/
#if 0
			if (getMelodyListStatus() == TRUE)
				dspl_Clear(0,16,16,141);
#endif            
			data->ExitReason = LISTS_REASON_SELECT;
			data->MenuData.Reason = LISTS_REASON_SELECT;
			MenuHandle = mfwControl(data->MenuLists);
			data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
			//currentring = data->MenuData.ListPosition;

			data->Callback(data->Parent, &data->MenuData);

#ifdef _MMS_ENABLE_
			//begin xie  04-07-08
			if (MMS_Get_CurSetList_WHnd() == data->Parent)
			{
				mnuSelect(data->MenuLists);
				break;
			}
			//end xie
#endif	

			if (data->MenuData.autoDestroy)
			{
				winDelete (win);
				FREE_MEMORY ((void*)data, sizeof (ListWinInfo));
			}
			break;

		case KCD_CALL: /* press send key */
			data->ExitReason = LISTS_REASON_SEND;
			data->MenuData.Reason = LISTS_REASON_SEND;
			MenuHandle = mfwControl(data->MenuLists);
			data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
			data->Callback(data->Parent, &data->MenuData);
			if (data->MenuData.autoDestroy)
			{
				winDelete (win);
				FREE_MEMORY ((void*)data, sizeof (ListWinInfo));
			}
			break;
		case KCD_HUP: /* back to previous menu */
			if (weeklyAlarm_win)
			{
				data->ExitReason = LISTS_REASON_HANGUP;
				data->MenuData.Reason = LISTS_REASON_HANGUP;
				data->Callback(data->Parent, &data->MenuData);
			}
			else if (data->Parent==GetWindowHandle()||data->Parent==GetCallWindowHandle())
			{
				TRACE_EVENT("in phb,press hup");
				data->ExitReason = LISTS_REASON_HANGUP;
				data->MenuData.Reason = LISTS_REASON_HANGUP;
				data->Callback(data->Parent, &data->MenuData);
			}
			else if (getMelodyListStatus() == TRUE)
			{
				data->ExitReason = LISTS_REASON_HANGUP;
				data->MenuData.Reason = LISTS_REASON_HANGUP;
				data->Callback(data->Parent, &data->MenuData);
			}
#ifdef _MMS_ENABLE_	
			else if (data->Parent == MMS_Get_MMSNew_WHnd() || data->Parent == MMS_Get_MsgList_WHnd() ||data->Parent == MMS_Get_RecvList_WHnd() || data->Parent == MMS_Get_AllSetList_WHnd() ||data->Parent == MMS_Get_CurSetList_WHnd())//add by xie 2004-7-1
			{
				data->ExitReason = LISTS_REASON_HANGUP;
				data->MenuData.Reason = LISTS_REASON_HANGUP;
				data->Callback(data->Parent, &data->MenuData);
			}
#endif
			else
			{
				mnuEscape(data->MenuLists);
			}
			if (returntoidle(0))
				break;
			if (data->MenuData.autoDestroy)
			{
				listsDestroy(win);
			}
			break;
		case KCD_RIGHT:	/* back to previous menu */
			if (data->Parent==GetWindowHandle()||data->Parent==GetCallWindowHandle())
			{
				TRACE_EVENT("in phb,press right");
				data->ExitReason = LISTS_REASON_BACK;
				data->MenuData.Reason = LISTS_REASON_BACK;
				data->Callback(data->Parent, &data->MenuData);
			}
#ifdef _MMS_ENABLE_
			else if (data->Parent == MMS_Get_RecvList_WHnd())//add by xie 04-07-28
			{
				data->ExitReason = LISTS_REASON_BACK;
				data->MenuData.Reason = LISTS_REASON_BACK;
				data->Callback(data->Parent, &data->MenuData);
				break;
			}
#endif		
			else
			{
				mnuEscape(data->MenuLists);
			}

			if (data->MenuData.autoDestroy)
			{
				listsDestroy(win);
			}
			break;

		case KCD_MNULEFT:
			data->ExitReason = LISTS_REASON_LEFT;
			data->MenuData.Reason = LISTS_REASON_LEFT;
			MenuHandle = mfwControl(data->MenuLists);
			data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; // True cursor position in list menu. 
			data->Callback(data->Parent, &data->MenuData);
			break;
		case KCD_MNURIGHT:
			data->ExitReason = LISTS_REASON_RIGHT;
			data->MenuData.Reason = LISTS_REASON_RIGHT;
			MenuHandle = mfwControl(data->MenuLists);
			data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; // True cursor position in list menu. 
			data->Callback(data->Parent, &data->MenuData);          
			break;      
		case KCD_OK:
			data->ExitReason = LISTS_REASON_OK;
			data->MenuData.Reason = LISTS_REASON_OK;
			MenuHandle = mfwControl(data->MenuLists);
			data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; // True cursor position in list menu. 
			data->Callback(data->Parent, &data->MenuData);            
			if (data->MenuData.autoDestroy)
			{
				winDelete (win);
				FREE_MEMORY ((void*)data, sizeof (ListWinInfo));
			}
			break;

		case KCD_0:
		case KCD_1:
		case KCD_2:
		case KCD_3:
		case KCD_4:
		case KCD_5:
		case KCD_6:
		case KCD_7:
		case KCD_8:
		case KCD_9:
			data->ExitReason =k->code+20;// LISTS_REASON_KCD4;
			data->MenuData.Reason = k->code+20;//LISTS_REASON_KCD4;
			MenuHandle = mfwControl(data->MenuLists);
			data->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			data->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
			data->Callback(data->Parent, &data->MenuData);
			break;

		case KCD_F4:   //stop melody when hall is closed in melody select menu
			if (getMelodyListStatus()== TRUE)
			{
				if (drvpara.hallstatusflag ==0)
					Stopplayingdevice();
				data->ExitReason = LISTS_REASON_HANGUP;
				data->MenuData.Reason = LISTS_REASON_HANGUP;
				data->Callback(data->Parent, &data->MenuData);

			}
			if (!HallStatus())
			{
				returntoidle(1);
			}
			break;
		default: /* no response to all other keys */
			return MFW_EVENT_CONSUMED;
		}
	}
	return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:  listsWinEvent  

 $Description:	 window event handler

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int listsWinEvent(MfwEvt e, MfwWin *w)
{
	ListWinInfo * ListData = (ListWinInfo *)w->user;
	MfwMnu    *MenuHandle;
	UINT32 oldColor,oldFontColor;

	TRACE_FUNCTION("listsWinEvent()");

	switch (e)
	{
	case E_WIN_VISIBLE:
		//  if (w->flags & E_WIN_VISIBLE&&!(CallListFlag==1&&cugwindows))  //CallListFlag==1&&cugwindows represent "in rencent menu list" and "have done a call "
		if (w->flags & E_WIN_VISIBLE)  //CallListFlag==1&&cugwindows represent "in rencent menu list" and "have done a call "
		{

			// 	    dspl_ClearAll();//zy add 09/18
			controlBrowseNew();//zy 10/08
			oldColor=dspl_GetBkgColor();//zy 09/05
			dspl_SetBkgColor(GetPreDefinedColor(ColorSoftKeyBG));
			oldFontColor=dspl_GetFrgColor();
			dspl_SetFrgColor(GetPreDefinedColor(ColorSoftKeyFont));
			displaySoftKeys(ListData->MenuData.LeftSoftKey, ListData->MenuData.RightSoftKey);
			dspl_SetBkgColor(oldColor);
			dspl_SetFrgColor(oldFontColor);//zy 09/05
		}	//  ListData->Callback(ListData->Parent, &ListData->MenuData);
		if (getMelodyListStatus() == TRUE)
		{
			TRACE_EVENT("listsWinEvent():getMelodyListStatus is true");
		}
		else if ((CallListFlag==1&&cugwindows)||ListData->Parent==GetWindowHandle()||ListData->Parent==GetCallWindowHandle()||GetSMSLISTWINHandle())
		//then case of "ListData->Parent==GetWindowHandle()" bemay done displaySoftKeys two times
		//if (CallListFlag==1)
		{


			//  displaySoftKeys(ListData->MenuData.LeftSoftKey, ListData->MenuData.RightSoftKey);
			TRACE_FUNCTION("LISTS_REASON_UPDATE hubh 1-21 ");
			ListData->ExitReason = LISTS_REASON_UPDATE;
			ListData->MenuData.Reason = LISTS_REASON_UPDATE;
			MenuHandle = mfwControl(ListData->MenuLists);
			ListData->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
			ListData->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
			ListData->Callback(ListData->Parent, &ListData->MenuData);
			//SEND_EVENT(ListData->Parent, LISTS_REASON_UPDATE, 0, 0) //2003-1-21

		}
		// else
		//displaySoftKeys(ListData->MenuData.LeftSoftKey, ListData->MenuData.RightSoftKey);


		break;

	default:
		return MFW_EVENT_PASSED;
		break;
	}
	return MFW_EVENT_CONSUMED;
}

static void lists_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
	ListWinInfo    * ListData = (ListWinInfo *)win_data->user;
	T_MFW_HND      * l_parent;
	SHORT            l_id;

	TRACE_FUNCTION ("lists_exec_cb()");

	switch (event)
	{
	case E_INIT:
	case E_BACK:
	case E_RETURN:
	case E_ABORT:
	case E_EXIT:
		/* defaultreaction */
		l_parent = ListData->Parent;
		l_id = ListData->id;
		winDelete (win);
		FREE_MEMORY ((void*) ListData, sizeof (ListWinInfo));
		SEND_EVENT (l_parent, event, l_id, NULL); /* forward event to parent */
		break;
	default:
		return;
	}
}



/*******************************************************************************

 $Function:  listsListCbMenu  

 $Description:	 List menu handler. (mfw callback function)

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
int listsListCbMenu(MfwEvt EventCode, MfwMnu *MenuHandle)
{
	int Status = LISTS_OK;
	T_MFW_HND   win      = mfw_parent (mfw_header());
	T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
	ListWinInfo* ListData = (ListWinInfo *)win_data->user;

	TRACE_FUNCTION("listsCbMenu()");

	switch (EventCode)
	{
	case E_MNU_SELECT:
		ListData->ExitReason = E_MNU_SELECT;
		ListData->MenuData.Reason = LISTS_REASON_SELECT;// MZ 14/2/01 E_MNU_SELECT;
		ListData->MenuData.CursorPosition = MenuHandle->lCursor[MenuHandle->level];
		ListData->MenuData.ListPosition  = MenuHandle->lCursor[MenuHandle->level]; /* True cursor position in list menu. */
		ListData->Callback(ListData->Parent, &ListData->MenuData);
		break;

	case E_MNU_ESCAPE:
		ListData->ExitReason = LISTS_REASON_BACK;
		ListData->MenuData.Reason = LISTS_REASON_BACK;
		ListData->Callback(ListData->Parent, &ListData->MenuData);
		break;

	default:
		Status = LISTS_FAIL;
		TRACE_FUNCTION("Activation 77 error"); 
		break;
	}

	/*
	 * Free all allocated memory and handler
	 */
	if (ListData->MenuData.autoDestroy)
	{
		winDelete (win);
		FREE_MEMORY ((void*) ListData, sizeof (ListWinInfo));
	}
	return Status;
}

void listsDestroy(T_MFW_HND win)
{
	T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
	ListWinInfo * ListData = (ListWinInfo *)win_data->user;
	winDelete (win);
	FREE_MEMORY ((void*) ListData, sizeof (ListWinInfo));

}

