/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   MMI
 $File:       MmiMmi.c
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

    This provides the root mofule for the basic MMI

********************************************************************************
 $History: MmiMmi.c

  25/10/00      Original Condat(UK) BMI version.

 $End

*******************************************************************************/




/*******************************************************************************

                                Include Files

*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"
//GW Removed T9 code

//#include "stddefs.h"
//#include "custom.h"
//#include "gsm.h"
//#include "vsi.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"

#include "ksd.h"
#include "psa.h"


#include "MmiMmi.h"
#include "MmiMain.h"

#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"




#include "dspl.h"

#ifndef _SIMULATION_
extern void AI_Power(unsigned char power);
#endif _SIMULATION_

/*******************************************************************************

                                Global Data Elements

*******************************************************************************/

U16 mmiScrX, mmiScrY;                   /* display sreen size       */

static U8 mfwMem [34720];      //windy increase from 30720 to 34720 0225//yq added 2003/1/15         /* mfw memory pool          */
static int initialized = 0;             /* initialization flag      */



/*******************************************************************************

                                Window Areas

*******************************************************************************/
/*
MfwWinAttr g_MainWin =
{
  {MAIN_AREA},
  {MAIN_AREA},
  0
};

MfwWinAttr g_IconWin =
{
  {ICON_AREA},
  {ICON_AREA},
  0
};

MfwWinAttr g_KeyWin =
{
  {KEY_AREA},
  {KEY_AREA},
  0
};

*/

/*******************************************************************************

                                Public Methods

*******************************************************************************/

/*******************************************************************************

 $Function:     mmi_main

 $Description:  entry point for the MMI, this hands control to mmiInit

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/

#ifdef WIN32
	static int init_the_mmi = 1;	/* only initialise once */
#endif

void mmi_main( void )
{
#ifdef WIN32
//	EF in Windows mode mmi_main is called twice, so ignore the first call	
	if (init_the_mmi)
	{	
		init_the_mmi = 0;
		return;			/* do nothing on 1st call */
	}
	TRACE_FUNCTION ("mmi_init()");
#endif
	mmiInit();
}



/*******************************************************************************

 $Function:     mmiInit

 $Description:  This initialises the MMI application

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/


void mmiInit( void )
{
  /* get the resources running
  */

  /* Initialise the MFW and windowing system
  */
  mfwInit( mfwMem,   sizeof( mfwMem ) );
  winInit( &mmiScrX, &mmiScrY );


  timInit();                          /* init timer handler       */
  kbdInit();                          /* init keyboard handler    */
  lngInit();                          /* init language handler    */
  edtInit();                          /* init editor handler      */
  mnuInit();                          /* init menu handler        */
  icnInit();                          /* init icon handler        */
//JVJE  inpInit();              /* init input handler       */

  mainInit(0);
  /* 2003/12/04 sunsj */
  /* Now intitialize the Zi8 Core Engine */
  Zi8Initialize();
}






/*******************************************************************************

 $Function:     mmiExit

 $Description:  This exits the MMI application

 $Returns:    None.

 $Arguments:  None.

*******************************************************************************/





void mmiExit( void )
{
    TRACE_EVENT("mmiExit");

  /*mainExit(0);
  mmeExit ();                         /* finit mme handler       */
//JVJE  inpExit();                          /* finit input handler      */
  icnExit();                          /* finit icon handler       */
  mnuExit();                          /* finit menu handler       */
  edtExit();                          /* finit edit handler       */
  lngExit();                          /* finit language handler   */
  kbdExit();                          /* finit keyboard handler   */
  timExit();                          /* finit timer handler      */

  winExit();                          /* finit window handler     */
  mfwExit();                          /* exit mfw                 */

  dspl_ClearAll();
  TRACE_EVENT("SWITCHING_OFF!!!!!");
  vsi_t_sleep (VSI_CALLER 50);
  /*
   *  Power off the board
   *
   */
#ifndef _SIMULATION_
  AI_Power(0);
#endif _SIMULATION_

}




/*******************************************************************************

                                End Of File

*******************************************************************************/

