#ifndef _MMIMMI_H_
#define _MMIMMI_H_ 1

/*******************************************************************************

					CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiMmi.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the root mofule for the basic MMI
                        
********************************************************************************
 $History: MmiMmi.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/




/*******************************************************************************
                                                                              
                    Type definitions
                                                                              
*******************************************************************************/


typedef void ( *MmiState )( int, void( * ) ( ) );


										

/*******************************************************************************
                                                                              
                    Definitions provided by the root module
                                                                              
*******************************************************************************/

/* Identifier ranges for applications. These are used to isolate
   particular message numbers for particular applications, hence
   preventing a rogue message being handled incorrectly.
*/
#define MenuDummy		  0
#define ExtrasDummy		 50
#define StartDummy		100
#define IdleDummy		200
#define GlobalDummy		300
#define ServicesDummy	400
#define SoundsDummy		500
#define HostkeyDummy	550   //xsf add for hostkey 12.19
#define TimeDateDummy	600
#define ECTimeDateDummy	680  //zgz,2002.8.26
#define PhbkDummy		700
#define OrganiserDummy	800
#define CallDummy		900
#define PinsDummy		1000
#define SatDummy		1100
#define DialogsDummy	1200
#define MsgsDummy		1300
#define DictDummy		1400
#define QQDummy			1500



/* Define window areas
*/
#define LCD_X 96
#define LCD_Y 64

#define ICON_AREA 0,  0, LCD_X, 12
#define MAIN_AREA 0, 12, LCD_X, 40
#define KEY_AREA  0, 56, LCD_X, LCD_Y
#define SMS_AREA  0,  0, LCD_X, 51


/* Define charging states
*/
#define GlobalDefault            0x00
#define GlobalCharging           0x01
#define GlobalBatteryPower       0x02
#define GlobalMobileOn           0x04
#define GlobalDisplayFlag        0x08

/*******************************************************************************
                                                                              
							Global data elements
                                                                              
*******************************************************************************/

/* Root module attribute structures
*/
extern MfwWinAttr g_MainWin;
extern MfwWinAttr g_IconWin;
extern MfwWinAttr g_KeyWin;

/* Display screen sizes
*/
extern U16 mmiScrX, mmiScrY;

/* Mode for the phone
*/
extern UBYTE globalMobileMode;

//glowing, 2004-05-22, add it for Colorful LED feature
//#define SEVEN_COLORS_LED

// 2004.5.26 WYJ add for E501 E505 E506
#if	 defined(_E505_) || defined(_E511_) || defined(_E513_) || defined(_E515_) || defined(_E508_) || defined(_E512_)
#define SEVEN_COLORS_LED
/* zhq, 2004/07/08, add this for we use MA5 to drive led. */
#define SEVEN_COLORS_LED_YAMAHA
#endif


/*******************************************************************************
                                                                              
							Public Prototypes
                                                                              
*******************************************************************************/

void mmi_main (void);                   /* initial entry point      */
void mmiInit (void);                    /* init MMI                 */
void mmiExit (void);                    /* exit MMI                 */


										
/*******************************************************************************
                                                                              
                                End Of File
                                                                              
*******************************************************************************/

#endif

