/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Network
 $File:		    MmiNetwork.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    22/02/01                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

  

********************************************************************************

 $History:
 
    25/10/00			Original Condat(UK) BMI version.	
       
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_cm.h"
#include "mfw_sat.h"
#include "mfw_phb.h"
#include "mfw_sms.h"


#include "dspl.h"

#include "ksd.h"
#include "psa.h"


#include "MmiDummy.h"
#include "MmiMmi.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"

#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMenu.h"
#include "MmiIdle.h"
#include "MmiCall.h"
#include "MmiBookController.h"
#include "MmiNetwork.h"
#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiPcm.h"
#include "MmiEditor.h"
#include "mfw_ffs.h"
#include "MmiCPHS.h"
#include "Mmiicons.h"
#ifdef MMI_HOMEZONE_ENABLED
    #include "MmiHomezone.h"
#endif

#include "MmiNetwork.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "fieldtest.h"

//#include "mmiicnother.h"

//#define TDTRACE 1
#include "mmiutilapi.h"

/*SPR 1815, moved definition of T_network data struct to MmiNetwork.c*/

T_network network_data;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        win;
    SHORT            id;
    T_MFW_HND        parent;
    T_MFW_HND        kbd;
    T_MFW_HND        kbd_long;
    T_MFW_HND        menu;
    T_MFW_HND        dialog_win;
    ListMenuData     *network_list;       
    T_MFW_NETWORK_STRUCT  *pplmn; /* available List in the MOBILE */
    CHAR               buffer[6];   
    T_EDITOR_DATA     editor_info; /* storage for editor attributes */    
} T_network_OPT;


typedef enum
{
    E_INIT,
    E_BACK,
    E_RETURN,
    E_ABORT,
    E_EXIT
} e_lists_events;




/*
 * Local prototypes
 */
static int            network_win_cb                 (T_MFW_EVENT event, T_MFW_WIN * win);
static int            network_nm_cb                  (T_MFW_EVENT event, T_MFW_HND para);
static void           network_remove_network_log     (void);
static UBYTE          network_log_enabled            (void);
static void           network_list_cb                (T_MFW_HND win, ListMenuData * ListData);
static void           network_pref_list_cb           (T_MFW_HND win, ListMenuData * ListData);
static ListMenuData * network_create_list            (T_network * data, T_MFW_PLMN_LIST * plmn_list);
static ListMenuData * network_create_pref_list       (T_network * data);
static ListMenuData * network_create_mobile_list     (T_network_OPT * data);
static void         network_start_animation_plmn_selection  (int plmn_value);
static void           network_start_animation        (void);
static void           network_stop_animation         (void);
static void           network_selected                       (void);
static void           network_forbidden_plmn         (void);
static void           network_no_plmns               (void);
void           network_animation_cb           (T_MFW_HND win, UBYTE identifier, UBYTE reason);
T_MFW_HND      network_MNU_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
static T_MFW_HND      network_MNU_create(MfwHnd parent_window);
static void           network_MNU_destroy(MfwHnd own_window);
void           network_MNU_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int            network_MNU_mnu_cb (MfwEvt e, MfwMnu *m);
static int            network_MNU_win_cb (MfwEvt e, MfwWin *w);
static int            network_MNU_kbd_cb (MfwEvt e, MfwKbd *k);
static int         network_request_plnm_list (MfwMnu* m, MfwMnuItem* i);
void                network_delete_pref_plnm (T_MFW_HND win , USHORT identifier, UBYTE reason);
void                network_info_screen (T_MFW_HND win, USHORT MessageId);
static int            network_delete(MfwMnu* m, MfwMnuItem* i);
T_MFW_HND network_EDT_start (MfwMnu* m, MfwMnuItem* i);
static T_MFW_HND network_EDT_create (T_MFW_HND parent);
static void network_EDT_destroy (T_MFW_HND window);
static void network_EDT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void network_EDT_editor_cb (T_MFW_HND win, USHORT Identifier, USHORT event);
extern USHORT  rr_get_bcch_channel(void); ////xsf add 2002.08.05 3 lines
extern USHORT * rr_get_found_channel();

/*
 * Local Definitions
 */
/* glowing: comment the following define and add it in the mminetwork.h */
//#define NETWORK_LIMITED_SERVICE   420
#define NETWORK_NO_NETWORK        421
#define NETWORK_PLMN_LIST         422
#define NETWORK_PREFERRED_LIST    423
#define NETWORK_PPLMN_MEM_LIST    424
/* SPR759 - SH - Cell reselection */
#define NETWORK_CELL_SELECT        425

#define NETWORK_LIST_DISPLAY      430
//gb DEAD CODE #define NETWORK_LIST_INIT         431
#define NETWORK_LIST_SELECT_PLMN  432

/*
 * Local Network List Status
 */
#define NETWORK_LIST_DISPLAY_FIRST   1
#define NETWORK_LIST_SELECTED        2
#define NETWORK_LIST_REGISTRATION    3
#define NETWORK_PREF_LIST_SELECTED   4
#define NETWORK_MENU_ITEM            2

//nm 5.3.01 this number will be change
#define MAX_SHOW_OF_PLMN 			99
//static char buf[200];

//xsf add 2002.07.23 5 lines
static T_MFW_NETWORK_STRUCT homeplmn;
static T_MFW_PLMN_LIST availablePlmnList;
static int availablePlmnIndex;
SHORT               Band[MAX_PLMN]; //Get the band indicate whenever we get the network list event
extern USHORT *rr_get_found_channels(void);

static MfwMnuItem network_OPTItems [] =
{
    {0,0,0,(char *)TxtSelectFromList,    0,  (MenuFunc)network_request_plnm_list, item_flag_none},
    {0,0,0,(char *)TxtEnterNetworkCode, 0,  (MenuFunc)network_EDT_start,   item_flag_none},
    {0,0,0,(char *)TxtDelete,           0,  (MenuFunc)network_delete,          item_flag_none}
};

static MfwMnuAttr network_OPTAttrib =
{
    0,
    &network_menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    network_OPTItems,                      /* with these items         */
    sizeof(network_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};



static MfwMnuAttr network_menuAttrib =
{
    0,
    &network_menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};


/*******************************************************************************

 $Function:    	networkInit

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND networkInit (T_MFW_HND parent_window)
{
    return(network_create (parent_window));
}


/*******************************************************************************

 $Function:    	networkExit

 $Description:	exit network handling (Backward Compatibility interface)

 $Returns:		

 $Arguments:	
 *********************************************************************/


void networkExit (void)
{
    network_destroy (network_data.network_win);
}

/*********************************************************************
 *
 * Network Dialog
 *
 * Window - Structure
 *
 * network    -->  network_list
 *            -->  network_search_animation
 *
 *********************************************************************/

/*******************************************************************************

 $Function:    	network_create

 $Description:	create network top window

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND network_create (T_MFW_HND parent_window)
{
    T_network * data = &network_data;
    T_MFW_WIN * win;

    TRACE_FUNCTION ("network_create()");

    data->network_win = win_create (parent_window, 0, 0, (T_MFW_CB)network_win_cb);

    if( data->network_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog = (T_DIALOG_FUNC)network;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->network_win)->data;
    win->user                = (void *) data;

    /*
     * Initialise MFW
     */
    nm_init ();

    /*
     * Create any other handler
     */
    data->nm_handle = nm_create (data->network_win, E_NM_ALL_SERVICES, (T_MFW_CB)network_nm_cb);

    memset (data->plmn_name, 0, 20);
    memset (data->network_name, 0, 6);

    data->aborted = FALSE;
    data->keep_plmn_list = FALSE;

    data->status   = NETWORK_NO_SERVICE;
    data->network_list = NULL;
    data->network_search_win = 0;
    data->Listposition = 0;



    winShow(data->network_win);
    /*
     * return window handle
     */
    return data->network_win;
}

/*******************************************************************************

 $Function:    	network_destroy

 $Description:	destroy network top window

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN * win;
    T_network * data;

    TRACE_FUNCTION ("network_destroy()");

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_network *)win->user;

        if( data )
        {
            /*
             * Exit NM and delete NM handler
             */
            nm_exit ();
            nm_delete (data->nm_handle);

            /*
             * Delete WIN handler
             */
            win_delete (data->network_win);
        }
    }
}

/*******************************************************************************

 $Function:    	network

 $Description:	network top window dialog function

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN         * win_data = ((T_MFW_HDR *) win)->data;
    T_network         * data     = (T_network *)win_data->user;
    T_MFW_NETWORK_STRUCT  * plmn_ident;

    MMI_TRACE_EVENT(("<<<talcon,network--event:%d",event ));


    switch( event )
    {
    case NETWORK_NO_SERVICE:
    case NETWORK_LIMITED_SERVICE:

        TRACE_EVENT ("NETWORK NO/LIMITED SERVICE");
        /*
         * Set Status
         */
        /*
           glowing: modify the following statement for processing
           the NETWORK_LIMITED_SERVICE 
        */
        data->status = event;
        //data->status = NETWORK_NO_SERVICE;

        /*
         * Check if network log is enabled
         */
        if( network_log_enabled () )
        {
            SEND_EVENT (idle_get_window(), NETWORK_NO_PLMN_XXX_AVAIL, 0, 0);
        }
        else
        {
            /*
              glowing: modify the following statement for processing
              the NETWORK_LIMITED_SERVICE 
             */
            //SEND_EVENT (idle_get_window(), NETWORK_NO_SERVICE, 0, 0);
            SEND_EVENT (idle_get_window(), event, 0, 0);

            if( data->network_list NEQ NULL )
            {
                switch( data->network_list_status )
                {
                case NETWORK_LIST_REGISTRATION:
                    /*
                     * Present list of available PLMNs again
                     *
                     * NOTE: if NETWORK_LIMITED_SERVICE has indicated
                     *       that THE manually selected network is now forbidden
                     *       the menu list must be updated (but don't ask me how).
                     */
                    network_stop_animation ();
                    data->network_list_status = NETWORK_LIST_DISPLAY_FIRST;

                    if( network_data.aborted != TRUE )  //xsf add if sentence 11.11
                    {
                        //listDisplayListMenu (win, data->network_list, (ListCbFunc)network_list_cb,0);
                        network_forbidden_plmn();
                        //begin of xsf add 2003.02.25
                        if( data->network_list NEQ NULL )
                        {
                            FREE_MEMORY ((UBYTE *)data->network_list->List, data->network_list->ListLength * sizeof (T_MFW_MNU_ITEM));
                            FREE_MEMORY ((UBYTE *)data->network_list, sizeof (ListMenuData));
                            data->network_list = NULL;
                        }
                        //end of xsf add 2003.02.25
                    }
                    else
                        network_data.aborted = FALSE;
                    break;
                case NETWORK_LIST_SELECTED:
                    /*
                     * After registration start, MFW returns the current status
                     */
                    data->network_list_status= NETWORK_LIST_REGISTRATION;
                    data->keep_plmn_list = TRUE;
                    break;
                }
            }
        }
#ifdef MMI_HOMEZONE_ENABLED
        /* sh - tell homezone there is no network */
        homezoneUpdate(0,0);
#endif
        break;

    case NETWORK_SEARCH_NETWORK:
        TRACE_EVENT ("NETWORK SEARCH NETWORK");
        SEND_EVENT (idle_get_window(), NETWORK_SEARCH_NETWORK, 0, 0);
        break;

    case NETWORK_FULL_SERVICE:
        TRACE_EVENT ("NETWORK FULL SERVICE");

	#ifdef MMS_WAP_ENABLED
		{	
			static BYTE first = TRUE;
			if(first)
			{
				extern void mms_pushfile_init();
				first = FALSE;
				mms_pushfile_init();
			}
		}
	#endif        

        /*
         * Set Status
         */
        data->status = NETWORK_FULL_SERVICE;

        /*
         * Copy Network Name in textual and numerical format
         *
         * NOTE: Service Provider Name is not used
         *       Operator Name from SIM needs CPHS support by MFW
         */
        plmn_ident = (T_MFW_NETWORK_STRUCT *)parameter;

#ifdef NO_ASCIIZ
        memcpy (data->plmn_name, &plmn_ident->network_long.data, 20);
#else
        memcpy (data->plmn_name, plmn_ident->network_long, 20);
#endif      
        memcpy (data->network_name, plmn_ident->network_numeric, 6);

        /*
         * If network name is not known use numeric representation as default.
         */
#ifdef NO_ASCIIZ
        if( plmn_ident->network_long.len EQ 0 )
#else       
        if( strlen ((char *)(plmn_ident->network_long)) EQ 0 )
#endif
            strcpy ((char *)data->plmn_name, (char *)data->network_name);

        /*
         * Store Roaming Indicator
         */
        data->roaming_indicator = plmn_ident->roaming_indicator;

        /*begin of zy add 03y/01m/13d*/
        if( data->roaming_indicator==1 )
            iconsSetState(iconRoam);
        else if( data->roaming_indicator==0 )
            iconsDeleteState(iconRoam);
        /*end of zy add 03y/01m/13d*/
        network_stop_animation ();
        /*
         * Inform Idle screen
         */
        SEND_EVENT (idle_get_window(), NETWORK_FULL_SERVICE, 0, 0);

        /*
         * If network list is available
         */
        if( data->network_list NEQ NULL )
        {
            switch( data->network_list_status )
            {
            case NETWORK_LIST_REGISTRATION:

                data->keep_plmn_list = FALSE;
                break;
            case NETWORK_LIST_SELECTED:
                /*
                 * After registration start, MFW returns the current status
                 */
                data->network_list_status= NETWORK_LIST_REGISTRATION;

                if( network_data.aborted != TRUE )
                    network_selected();
                else
                    network_data.aborted = FALSE;
                //xsf remarked it 2003.02.27 if(data->keep_plmn_list EQ FALSE) 
                if( data->network_list NEQ NULL )
                {
                    TRACE_EVENT("NETWORK_LIST_REGISTRATION No 1");

                    FREE_MEMORY ((UBYTE *)data->network_list->List, data->network_list->ListLength * sizeof (T_MFW_MNU_ITEM));

                    FREE_MEMORY ((UBYTE *)data->network_list, sizeof (ListMenuData));
                    //listsDestroy(data->network_list->win);   //xsf add 2003.03.12
                    data->network_list = NULL;
                }

                break;
            }
            // API - Moved from previous position  //condat 1119
            //		network_selected(); 
        }
        break;

    case NETWORK_NO_NETWORK:
        TRACE_EVENT ("NETWORK NO NETWORK");

        //SetSignalPicNumberZero();		//xzy add for no network update signal pic number
        /*
         * No PLMN found after search for available PLMNs
         */
        network_stop_animation ();
        if( network_log_enabled () )
        {
            data->status = NETWORK_NO_SERVICE;
            SEND_EVENT (idle_get_window(), NETWORK_NO_PLMN_XXX_AVAIL, 0, 0);
        }
        else
        {
            /*
             * No Networks found.
             */
            data->status = NETWORK_NO_SERVICE;
            SEND_EVENT (idle_get_window(), NETWORK_NO_SERVICE, 0, 0);
        }
#ifdef MMI_HOMEZONE_ENABLED
        /* sh - tell homezone there is no network */
        homezoneUpdate(0,0);
#endif
        break;

    case NETWORK_PLMN_LIST:
        TRACE_EVENT ("NETWORK PLMN LIST");
        TRACE_EVENT (">>NETWORK PLMN LIST");
        /*
         * PLMN list found
         */
        if( network_data.aborted != TRUE )
        {
            if( network_log_enabled () )
            {
                data->status = NETWORK_NO_SERVICE;
                SEND_EVENT (idle_get_window(), NETWORK_NO_PLMN_XXX_AVAIL, 0, 0);
            }
            else
            {
                T_MFW_PLMN_LIST * plmn_list;
                /*...................... Networks founds................*/   
                data->status = NETWORK_NO_SERVICE;
                /*...... If network list is available, destroy...... */ 
                if( data->network_list NEQ NULL )
                {

                    FREE_MEMORY ((UBYTE *)data->network_list->List, data->network_list->ListLength * sizeof (T_MFW_MNU_ITEM));  //xsf replace MAX_PLMN_ID with , data->network_list->ListLength 
                    FREE_MEMORY ((UBYTE *)data->network_list, sizeof (ListMenuData));
                    data->network_list = NULL;
                }
                /*
                 * If list is empty, show info screen
                 */
                plmn_list = (T_MFW_PLMN_LIST *)parameter;
                if( plmn_list->count EQ 0 )
                {
                    network_stop_animation ();
                    network_no_plmns ();
                }
                else
                {
                    /*
                     * Create and present list of available PLMNs
                     *
                     */
                    data->network_list = network_create_list (data, parameter);
                    data->network_list_status = NETWORK_LIST_DISPLAY_FIRST;
                    network_stop_animation ();
                    listDisplayListMenu (win, data->network_list,  (ListCbFunc)network_list_cb,0);
                    //xsf remarked 2002.10.31 SEND_EVENT (idle_get_window(), NETWORK_NO_SERVICE, 0, 0);
                }
            }
        }
        else
        {
            network_data.aborted = FALSE;
        }
#ifdef MMI_HOMEZONE_ENABLED
        /* sh - tell homezone there is no network */
        homezoneUpdate(0,0);
#endif
        break;

    case NETWORK_LIST_SELECT_PLMN:
        TRACE_EVENT ("NETWORK LIST_SELECT");
        //TRACE_EVENT (">> NETWORK LIST_SELECT");
        /*
         * A network has been selected from the PLMN available list
         * Start manual registration and start Search animation.
         */
        network_start_animation_plmn_selection (value);
        data->network_list_status = NETWORK_LIST_SELECTED;
        nm_select_plmn ((U8 *)network_data.network_search_name[value]);
        break;
    case NETWORK_PPLMN_MEM_LIST:
        {
            T_MFW_PPLMN_MEM *pplmn_mem;
            UBYTE i;

            TRACE_EVENT ("NETWORK PPLMN MEM LIST");

            TRACE_EVENT (">> NETWORK PPLMN MEM LIST");
            /*  Save the number of PLMN records:
             *  maxRcd  = maximum preferred PLMN records on the SIM card
             *  usedRcd = used preferred PLMN records on the SIM card
             */
            pplmn_mem = (T_MFW_PPLMN_MEM *)parameter; 

            network_data.pplmn_mem.maxRcd  = pplmn_mem->maxRcd;
            network_data.pplmn_mem.usedRcd = pplmn_mem->usedRcd;

            /*
             * Request preferred PLMN list from the SIM
             */


            network_data.pplmn = (T_MFW_NETWORK_STRUCT *)ALLOC_MEMORY ((pplmn_mem->maxRcd) * sizeof (T_MFW_NETWORK_STRUCT));

            if( network_data.pplmn EQ 0 )
            {
                return;
            }

            if( pplmn_mem->usedRcd > 0 )
            {
                // request MFW to fill up the pref. PLMN list
                nm_pref_plmn_list(network_data.pplmn, pplmn_mem->maxRcd, 1);
            }
            else
            {
                // doesnt make sense to request the MFW to fill up the list
                // when the "pplmn_mem->usedRcd" is  0

                for( i=0; i < (network_data.pplmn_mem.maxRcd); i++ )
                {
#ifdef NO_ASCIIZ
                    network_data.pplmn[i].network_long.len = 0;
                    network_data.pplmn[i].network_short.len = 0;
#else			 	
                    memset(network_data.pplmn[i].network_long,   '\0', LONG_NAME);
                    memset(network_data.pplmn[i].network_short,   '\0', SHORT_NAME);
#endif
                    memset(network_data.pplmn[i].network_numeric, '\0', NUMERIC_LENGTH);
                }

                data->network_list = network_create_pref_list (data);
                listDisplayListMenu (win, data->network_list,(ListCbFunc)network_pref_list_cb,0);
            }

        }
        break;

    case NETWORK_PREFERRED_LIST:
        {         

            UBYTE i;


            // TRACE_EVENT ("NETWORK PREFERRED LIST");
            TRACE_EVENT (">>NETWORK PREFERRED LIST");
            /*
             *  Create and present the preferred list of PLMNs
             * 
             */

            //nm      network_stop_animation ();


            data->network_list = network_create_pref_list (data);
            listDisplayListMenu (win, data->network_list,(ListCbFunc)network_pref_list_cb,0);
        }   
        break;

    case NETWORK_CELL_SELECT:
        {
            /* If Homezone is active, inform it of the new cell data */
            T_MFW_CELL_STRUCT *cell_data;

            TRACE_EVENT(">>NETWORK CELL SELECT");

            cell_data = (T_MFW_CELL_STRUCT *)parameter;

#ifdef MMI_HOMEZONE_ENABLED
            /* SPR759 - SH - send cell reselection info to homezone */
            homezoneUpdate(cell_data->lid, cell_data->ci);
#endif
        }
    }
}

/*

/*******************************************************************************

 $Function:    	network_win_cb

 $Description:	network top window

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int network_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}


/*******************************************************************************

 $Function:    	network_nm_cb

 $Description:	network handler (mfw callback handler)

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int network_nm_cb (T_MFW_EVENT event, T_MFW_HND para)
{
    TRACE_FUNCTION("network_nm_cb");

    switch( event )
    {
    case E_NM_FULL_SERVICE:
        g_nmService = NM_FULL_SERVICE;
        SEND_EVENT (network_data.network_win, NETWORK_FULL_SERVICE, 0, para);
        break;

    case E_NM_LIMITED_SERVICE:
        g_nmService = NM_LIMITED_SERVICE;
        SEND_EVENT (network_data.network_win, NETWORK_LIMITED_SERVICE, 0, para);
        break;

    case E_NM_NO_SERVICE:
        g_nmService = NM_NO_SERVICE;
        SEND_EVENT (network_data.network_win, NETWORK_NO_SERVICE, 0, para);
        break;

    case E_NM_SEARCH_NETWORK:
        g_nmService = NM_SEARCHING;
        SEND_EVENT (network_data.network_win, NETWORK_SEARCH_NETWORK, 0, para);
        break;

    case E_NM_NO_NETWORK:
        g_nmService = NM_NO_NETWORK;
        SEND_EVENT (network_data.network_win, NETWORK_NO_NETWORK, 0, para);
        break;

    case E_NM_PLMN_LIST:
        SEND_EVENT (network_data.network_win, NETWORK_PLMN_LIST, 0, para);
        break;

    case E_NM_DEREGISTRATION:
        TRACE_EVENT("MmiNetwork:E_NM_DEREGISTRATION");
        mainShutdown();
        break;
    case E_NM_PREF_PLMN_LIST:
        TRACE_EVENT("MmiNetwork:E_NM_PREF_PLMN_LIST");
        SEND_EVENT (network_data.network_win, NETWORK_PREFERRED_LIST, 0, para);
        break;
    case E_NM_PPLMN_MEM:
        TRACE_EVENT("MmiNetwork:E_NM_PPLMN_MEM");
        SEND_EVENT (network_data.network_win, NETWORK_PPLMN_MEM_LIST, 0, para);
        break;
        /* sbh 29-04-02 - Cell reselection */
    case E_NM_CELL_SELECT:
        TRACE_FUNCTION("MmiNetwork:E_NM_CELL_SELECT");
        SEND_EVENT (network_data.network_win, NETWORK_CELL_SELECT, 0, para);
        break;
        /* SPR919 - SH - Band selection */
    case E_NM_BAND:
        TRACE_EVENT("MmiNetwork:E_NM_BAND");
        nm_registration (nm_get_mode (),0, 0);
        break;
    default:
        return 0;
    }
    return 1;
}

/*******************************************************************************

 $Function:    	nm_flag_log_off

 $Description:	 Attribut function for menu entries.
               It defines whether the network log off function shall
                be displayed or not.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT nm_flag_log_off (T_MFW_MNU * m, T_MFW_MNU_ATTR * ma, T_MFW_MNU_ITEM * mi)
{
    if( FFS_flashData.net_log_status EQ NM_LOG_AVAIL_USED )
        return 0;

    return MNU_ITEM_HIDE;
}
/*******************************************************************************

 $Function:    	nm_flag_log_on

 $Description:	 Attribut function for menu entries.
               It defines whether the network log on function shall
                be displayed or not.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT nm_flag_log_on (T_MFW_MNU * m, T_MFW_MNU_ATTR * ma, T_MFW_MNU_ITEM * mi)
{
    if( FFS_flashData.network_name == NULL )
    {
        return MNU_ITEM_HIDE;
    }
    if( FFS_flashData.net_log_status EQ NM_LOG_AVAIL_NOT_USED )
        return 0;

    return MNU_ITEM_HIDE;
}

/*******************************************************************************

 $Function:    	network_set_mode_auto

 $Description:	 Start a automatic registration
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int network_set_mode_auto(T_MFW_MNU *m, T_MFW_MNU_ITEM *i)
{
    TRACE_FUNCTION ("network_set_mode_auto()");

    // Save the automatic mode in PCM for next power on
    nm_set_mode(NM_AUTOMATIC);

    //Start the registration of full service 
    nm_registration (NM_AUTOMATIC,0, FALSE);

    // remove network log if needed
    network_remove_network_log ();
    mnuUpdate(m);  //xsf add 2002.09.30
    // Remove Main Menu
    //JVJEmenuExit();
    //network_start_animation ();

    return 1;
}
/*******************************************************************************

 $Function:    	network_set_mode_man

 $Description:	 Start a manual registration
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int network_set_mode_man(T_MFW_MNU *m, T_MFW_MNU_ITEM *i)
{
    TRACE_FUNCTION ("network_set_mode_man()");

    // Save the automatic mode in PCM for next power on
    nm_set_mode(NM_MANUAL);  
    //network_data.aborted = FALSE;  xsf remarked it 01.16
    // Start the available plmn search
    //nm_registration (NM_MANUAL,0, FALSE);  xsf remarked it 01.16


    //remove network log if needed
    network_remove_network_log ();
    mnuUpdate(m);  //xsf add 2002.09.30
    // Remove Main Menu
    //nm menuExit();
    //network_start_animation ();  xsf remarked it 01.16

    return 1;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI       (6366)	     MODULE  : MmiNetwork            |
| STATE   : code                     ROUTINE : network_pref_list     |
+--------------------------------------------------------------------+

 PURPOSE : Show the preferred list

*/
int network_pref_list(T_MFW_MNU *m, T_MFW_MNU_ITEM *mi)
{
    //TRACE_FUNCTION ("network_pref_list()");

    /*
     * Request the maximum number of preferred PLMN records 
     * on the SIM card
     */
    nm_pplmn_mem_req();


    //  network_start_animation ();
    //    show on the screen @Please Wait@ instead
    //    @Search for Network@

    return 1;
}


/*******************************************************************************

 $Function:    	network_remove_network_log

 $Description:	Reset network log if set.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_remove_network_log (void)
{

    if( FFS_flashData.net_log_status EQ NM_LOG_AVAIL_USED )
    {
        /*
         * Until now the network log has been used.
         * Now write to FFS
         */
        FFS_flashData.net_log_status = NM_LOG_AVAIL_NOT_USED;
        flash_write();

    }
}

/*******************************************************************************

 $Function:    	network_log_off

 $Description:	Removes a network log and returns to automatic registration.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int network_log_off(T_MFW_MNU *m, T_MFW_MNU_ITEM *i)
{
    TRACE_FUNCTION ("network_log_off()");

    /*
     * Same behaviour as automatic registration
     */
    network_set_mode_auto (m,i);

    /*
     * Remove Main Menu
     */
    //JVJE  menuExit();

    network_start_animation ();

    return 1;
}

/*******************************************************************************

 $Function:    	network_log_on

 $Description:	 Sets a network log.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int network_log_on(T_MFW_MNU *m, T_MFW_MNU_ITEM *i)
{


    TRACE_FUNCTION ("network_log_on()");


    if( FFS_flashData.net_log_status EQ NM_LOG_AVAIL_NOT_USED OR
        FFS_flashData.net_log_status EQ NM_LOG_AVAIL_USED )
    {
        /*
         * Until now the network log has been not used.
         * Now set the PCM.
         */
        FFS_flashData.net_log_status = NM_LOG_AVAIL_USED;
        memcpy (FFS_flashData.plmn_name, network_data.plmn_name, 20);
        memcpy (FFS_flashData.network_name, network_data.network_name, 6);


        flash_write();
        /*
         * Save the manual mode in PCM for next power on
         */
        nm_set_mode(NM_MANUAL);

        /*
         * Start the registration of the logged network
         */
        nm_select_plmn (network_data.network_name);
    }

    /*
     * Remove Main Menu
     */
    //JVJE  menuExit();

    network_start_animation ();

    return 1;
}

/*******************************************************************************

 $Function:    	network_start_full_service

 $Description: Starts a full service registration.
              a) manual selection
              b) automatic selection
              c) network log selection
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network_start_full_service(void)
{

    TRACE_FUNCTION ("network_start_full_service()");

    network_data.status = NETWORK_SEARCH_NETWORK;

    if( FFS_flashData.plmn_name == NULL ) //if no network data
    {
        /*
        * Start normal Registration
        */
#if defined (WIN32_FORREST)
        EXTERN UBYTE mmi_reg_mode;

        if( mmi_reg_mode EQ 0 )
            nm_registration (NM_AUTOMATIC,0, 0);
        else
            nm_registration (NM_MANUAL,0, 0);
#else
        if( nm_get_mode() == NM_MANUAL ) //condat 1119
            SEND_EVENT (idle_get_window(), NETWORK_SEARCH_NETWORK, 0, 0);
        nm_registration (nm_get_mode (),0, 0);
#endif
    }
    else
    {
        switch( FFS_flashData.net_log_status )
        {
        case NM_LOG_AVAIL_USED:
            memcpy (network_data.plmn_name, FFS_flashData.plmn_name, 20);
            memcpy (network_data.network_name, FFS_flashData.network_name, 6);
            nm_select_plmn (network_data.network_name);
            break;
        default:
            TRACE_EVENT("XSF:SECON D default");
            if( nm_get_mode() == NM_MANUAL ) //condat 1119
            {
                TRACE_EVENT("XSF: SECON D NM_MANUAL");
                //SEND_EVENT (idle_get_window(), NETWORK_SEARCH_NETWORK, 0, 0);
                network_data.aborted = FALSE; 
                //nm_registration (NM_MANUAL,0, 0);
                nm_avail_plmn_list();
                network_start_animation ();         
            }
            else
                nm_registration (NM_AUTOMATIC,0, 0);
            //nm_registration (nm_get_mode (),0, 0);
            break;
        }
    }
}

/*******************************************************************************

 $Function:    	network_get_name

 $Description:	 Returns the textual and numeric representation of the
                 network name.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network_get_name(T_CURRENT_NETWORK * nm)
{
    TRACE_FUNCTION ("network_get_name()");
    if( CphsPresent() )//if CPHS supported
    {
        T_MFW_CPHS_OP_NAME* operator_name;
        /*SPR 1815, pass network data to CPHS function*/
        operator_name = CphsRequestOperatorName(&network_data); 

        if( operator_name->longName.data[0] != NULL )//if name not blank
        {
            memcpy(nm->plmn_name, operator_name->longName.data, SIZE_PLMN_NAME);
            TRACE_EVENT("Reading PLMN from SIM");

        }
        else
            memcpy (nm->plmn_name, network_data.plmn_name, SIZE_PLMN_NAME);

        if( operator_name->shortName.data[0] != NULL )//if name not blank
        {
            memcpy(nm->network_name, operator_name->shortName.data, SIZE_NETWORK_NAME);
        }
        else
            memcpy (nm->network_name, network_data.network_name, SIZE_NETWORK_NAME);
    }
    else
    {
        memcpy (nm->plmn_name, network_data.plmn_name, SIZE_PLMN_NAME);
        memcpy (nm->network_name, network_data.network_name, SIZE_NETWORK_NAME);
    }
    nm->roaming_indicator = network_data.roaming_indicator;
}

/*******************************************************************************

 $Function:    	network_log_enabled

 $Description:	 Checks whether a network log is active or not.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static UBYTE network_log_enabled (void)
{

    TRACE_FUNCTION ("network_log_enabled()");

    if( FFS_flashData.net_log_status EQ NM_LOG_AVAIL_USED )
        return TRUE;

    return FALSE;
}

/*******************************************************************************

 $Function:    	ListMenuData

 $Description:	 Creates a list of available PLMNs for selection.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static ListMenuData * network_create_list (T_network * data, T_MFW_PLMN_LIST * plmn_list)
{
    UBYTE i;

    ListMenuData *list_menu_data = (ListMenuData *)ALLOC_MEMORY (sizeof (ListMenuData));

    if( list_menu_data EQ 0 )
        return NULL;

    list_menu_data->List = (T_MFW_MNU_ITEM *) ALLOC_MEMORY (plmn_list->count * sizeof (T_MFW_MNU_ITEM));
    if( list_menu_data->List EQ 0 )
    {
        if( list_menu_data NEQ 0 )   //xsf add 2003.02.25
            FREE_MEMORY ((UBYTE *)list_menu_data, sizeof (ListMenuData));
        return NULL;
    }

    /*
     * Fill Menu List
     */
    for( i=0;i<plmn_list->count;i++ )
    {
        /* 2004/05/26 sunsj modify */
        list_menu_data->List[i].icon = 0; 
        list_menu_data->List[i].exta = 0;
        list_menu_data->List[i].edit = 0;
        list_menu_data->List[i].menu = 0;
        list_menu_data->List[i].func = 0;

        if( i<plmn_list->count )
        {
            /*
             * set network name
             */
#ifdef NO_ASCIIZ
            if( plmn_list->plmn[i].network_long.len NEQ 0 )
            {
                if( !strcmp((char *)(plmn_list->plmn[i].network_long.data), "CHINA  MOBILE")
                    ||!strcmp((char *)(plmn_list->plmn[i].network_long.data), "CHINA MOBILE") ) //xsf add for Chinese display 10.10 
                    list_menu_data->List[i].str = (char *)MmiRsrcGetText(T_China_Telecomm);

                else if( !strcmp((char *)(plmn_list->plmn[i].network_long.data),"CHN-CUGSM") )
                    list_menu_data->List[i].str = (char *)MmiRsrcGetText(T_China_Unicomm);
                else
                    list_menu_data->List[i].str = (char *)(plmn_list->plmn[i].network_long.data);
            }
#else       
            if( strlen((char *)plmn_list->plmn[i].network_long) NEQ 0 )
                list_menu_data->List[i].str = (char *)plmn_list->plmn[i].network_long;
#endif            

            else
                list_menu_data->List[i].str = (char *)plmn_list->plmn[i].network_numeric;

            /*
             * Store numeric network name in any case
             */
            strncpy ((char *)data->network_search_name[i], (char *)plmn_list->plmn[i].network_numeric, 6);


            /*
             * NOTE : add forbidden indicator
             */
            list_menu_data->List[i].flagFunc = item_flag_none;
        }
        else
        {
            //     list_menu_data->List[i].flagFunc = item_flag_hide;
        }
    }

    /*
     * Fill common parameter for list handling
     */

    list_menu_data->ListLength     = plmn_list->count;
    list_menu_data->ListPosition   = 1;
    list_menu_data->CursorPosition = 1;
    list_menu_data->SnapshotSize   = plmn_list->count;
    list_menu_data->Font           = 0;
    list_menu_data->LeftSoftKey    = TxtSoftSelect;
    list_menu_data->RightSoftKey   = TxtSoftBack;
    list_menu_data->KeyEvents      = KEY_RIGHT  | KEY_HUP | KEY_LEFT |KEY_OK| KEY_MNUUP | KEY_MNUDOWN;
    list_menu_data->Reason         = 0;
    list_menu_data->Strings        = TRUE;
    list_menu_data->Attr           = &network_menuAttrib;
    list_menu_data->autoDestroy    = TRUE;
    list_menu_data->ListMenuFlag =1;         //xsf add 2 lines for listmenu title 2002.10.10 
    list_menu_data->ListMenuHeadStr = (char *) MmiRsrcGetText(TxtPLMNavailable);

    return list_menu_data;
}

/*******************************************************************************

 $Function:    	network_create_pref_list

 $Description:	 Creates a list of preferred PLMNs for selection.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static ListMenuData * network_create_pref_list (T_network * data)
{
    UBYTE i;

    ListMenuData *list_menu_data = (ListMenuData *)ALLOC_MEMORY (sizeof (ListMenuData));

    if( list_menu_data EQ 0 )
    {
        return NULL;
    }

    list_menu_data->List = (T_MFW_MNU_ITEM *) ALLOC_MEMORY ((data->pplmn_mem.maxRcd) * sizeof (T_MFW_MNU_ITEM));

    if( list_menu_data->List EQ 0 )
    {
        return NULL;
    }

    TRACE_EVENT ("network_create_pref_list ()");



    /*
     * Fill Menu List
     */
    for( i=0; i < (network_data.pplmn_mem.maxRcd); i++ )
    {
        list_menu_data->List[i].icon = 0;
        list_menu_data->List[i].exta = 0;
        list_menu_data->List[i].edit = 0;
        list_menu_data->List[i].menu = 0;
        list_menu_data->List[i].func = 0;

        /*
         * set network name
         */

#ifdef NO_ASCIIZ
        if( network_data.pplmn[i].network_long.len NEQ 0 )
        {
            list_menu_data->List[i].str = (char *)network_data.pplmn[i].network_long.data;
        }
#else       
        if( strlen((char *)network_data.pplmn[i].network_long) NEQ 0 )
        {
            list_menu_data->List[i].str = (char *)network_data.pplmn[i].network_long;
        }
#endif
        else
        {
            list_menu_data->List[i].str = GET_TEXT(TxtEmpty);
            TRACE_EVENT ("network_long == 0");
        }

        list_menu_data->List[i].flagFunc = item_flag_none;

    }
    /*
     * Fill common parameter for list handling
     */


    list_menu_data->ListLength     = network_data.pplmn_mem.maxRcd;
    list_menu_data->ListPosition    = 1;
    list_menu_data->CursorPosition   = 1;
    list_menu_data->SnapshotSize  = network_data.pplmn_mem.maxRcd;
    list_menu_data->Font          = 0;
    list_menu_data->LeftSoftKey   = TxtSoftSelect;
    list_menu_data->RightSoftKey  = TxtSoftBack;
    list_menu_data->KeyEvents      = KEY_CLEAR | KEY_RIGHT | KEY_LEFT|KEY_OK | KEY_MNUUP | KEY_MNUDOWN;
    list_menu_data->Reason         = 0;
    list_menu_data->Strings        = TRUE;
    list_menu_data->Attr           = &network_menuAttrib;
    list_menu_data->autoDestroy    = TRUE; 


    return list_menu_data;
}

/*******************************************************************************

 $Function:    	network_create_mobile_list

 $Description:	 
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static ListMenuData * network_create_mobile_list (T_network_OPT * data)
{
    UBYTE i;

    ListMenuData *list_menu_data = (ListMenuData *)ALLOC_MEMORY (sizeof(ListMenuData));

    if( list_menu_data EQ 0 )
    {
        return NULL;
        TRACE_EVENT ("failed to create the list");
    }


    list_menu_data->List = (T_MFW_MNU_ITEM *) ALLOC_MEMORY (MAX_SHOW_OF_PLMN * sizeof (T_MFW_MNU_ITEM));

    if( list_menu_data->List EQ 0 )
    {
        return NULL;
        TRACE_EVENT ("failed to create the list");
    }

    TRACE_EVENT ("network_create_mobile_list ()");  



    /*
     * Fill Menu List
     */
    for( i=0; i < MAX_SHOW_OF_PLMN; i++ )
    {
        list_menu_data->List[i].icon = 0;
        list_menu_data->List[i].exta = 0;
        list_menu_data->List[i].edit = 0;
        list_menu_data->List[i].menu = 0;
        list_menu_data->List[i].func = 0;

        /*
         * set network name
         */


#ifdef NO_ASCIIZ
        if( data->pplmn[i].network_long.len NEQ 0 )
        {
            list_menu_data->List[i].str = (char *)data->pplmn[i].network_long.data;
        }
#else     
        if( strlen((char *)data->pplmn[i].network_long) NEQ 0 )
        {
            list_menu_data->List[i].str = (char *)data->pplmn[i].network_long;
        }
#endif
        else
        {
            list_menu_data->List[i].str = GET_TEXT(TxtEmpty);
        }


        list_menu_data->List[i].flagFunc = item_flag_none;

    }
    /*
     * Fill common parameter for list handling
     */


    list_menu_data->ListLength     = MAX_SHOW_OF_PLMN;
    list_menu_data->ListPosition     = 1;
    list_menu_data->CursorPosition  = 1;
    list_menu_data->SnapshotSize   = MAX_SHOW_OF_PLMN;
    list_menu_data->Font           = 0;
    list_menu_data->LeftSoftKey     = TxtSoftSelect;
    list_menu_data->RightSoftKey   = TxtSoftBack;
    list_menu_data->KeyEvents      = KEY_CLEAR | KEY_RIGHT | KEY_LEFT |KEY_OK| KEY_MNUUP | KEY_MNUDOWN;
    list_menu_data->Reason         = 0;
    list_menu_data->Strings        = TRUE;
    list_menu_data->Attr           = &network_menuAttrib;
    list_menu_data->autoDestroy    = TRUE;  /*destroy the menulist after press any sofkey*/

    return list_menu_data;
}


/*******************************************************************************

 $Function:    	network_submenu

 $Description:	Creates a submenu for the preferred list. 
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static ListMenuData * network_submenu (T_network * data, T_MFW_NETWORK_STRUCT * plmn_list)
{
    UBYTE i;


    ListMenuData *list_menu_data = (ListMenuData *)ALLOC_MEMORY (sizeof (ListMenuData));

    if( list_menu_data EQ 0 )
        return NULL;

    list_menu_data->List = (T_MFW_MNU_ITEM *) ALLOC_MEMORY ((NETWORK_MENU_ITEM) * sizeof (T_MFW_MNU_ITEM));
    if( list_menu_data->List EQ 0 )
        return NULL;

    /*
     * Fill Menu List
     */
    for( i=0;i<(NETWORK_MENU_ITEM);i++ )
    {
        list_menu_data->List[i].icon = 0;
        list_menu_data->List[i].exta = 0;
        list_menu_data->List[i].edit = 0;
        list_menu_data->List[i].menu = 0;
        list_menu_data->List[i].func = 0;

        /*
         * set network name
         */
#ifdef NO_ASCIIZ
        if( plmn_list->network_long.len NEQ 0 )
            list_menu_data->List[i].str = (char *)plmn_list->network_long.data;
#else 
        if( strlen((char *)plmn_list->network_long) NEQ 0 )
            list_menu_data->List[i].str = (char *)plmn_list->network_long;
#endif

        else
            ;
        //strncpy ((char *)list_menu_data->List[i].str,(char *)empty, 6);


        plmn_list ++;

    }
    /*
     * Fill common parameter for list handling
     */
    list_menu_data->ListLength     = data->pplmn_mem.maxRcd;
    list_menu_data->ListPosition   = 1;
    list_menu_data->CursorPosition = 1;
    list_menu_data->SnapshotSize   = data->pplmn_mem.maxRcd;
    list_menu_data->Font           = 0;
    list_menu_data->LeftSoftKey    = TxtSoftSelect;
    list_menu_data->RightSoftKey   = TxtSoftBack;
    list_menu_data->KeyEvents      = KEY_CLEAR | KEY_RIGHT | KEY_LEFT | KEY_MNUUP | KEY_MNUDOWN;
    list_menu_data->Reason         = NETWORK_PREF_LIST_SELECTED;
    list_menu_data->Strings        = TRUE;
    list_menu_data->Attr           = &network_menuAttrib;


    return list_menu_data;
}



/*******************************************************************************

 $Function:    	network_list_cb

 $Description:	Callback function list dialog.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_list_cb(T_MFW_HND win, ListMenuData * ListData)
{
    TRACE_FUNCTION ("network_list_cb()");
    if( (ListData->Reason EQ LISTS_REASON_SELECT) || (ListData->Reason EQ LISTS_REASON_OK) )     //xsf add for list menu KCD_OK=KCD_LEFT 2003.02.18
    {
        SEND_EVENT (win, NETWORK_LIST_SELECT_PLMN, ListData->ListPosition, NULL);

    }
    else if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
             || (ListData->Reason EQ LISTS_REASON_HANGUP) )
    {
        FREE_MEMORY ((UBYTE *)network_data.network_list->List, network_data.network_list->ListLength* sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((UBYTE *)network_data.network_list, sizeof (ListMenuData));
        network_data.network_list = NULL;
    }
}

/*******************************************************************************

 $Function:    	network_pref_list_cb

 $Description:	Callback function pref. list dialog.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_pref_list_cb(T_MFW_HND win, ListMenuData * ListData)
{
    TRACE_FUNCTION ("network_pref_list_cb()");

    if( (ListData->Reason EQ LISTS_REASON_SELECT) || (ListData->Reason EQ LISTS_REASON_OK) )     //xsf add for list menu KCD_OK=KCD_LEFT 2003.02.18
    {

        // call here the MenuOptions with the items "Select from the list"
        //		
        FREE_MEMORY ((UBYTE *)network_data.network_list->List, (network_data.pplmn_mem.maxRcd) * sizeof (T_MFW_MNU_ITEM));

        FREE_MEMORY ((UBYTE *)network_data.network_list, sizeof (ListMenuData));


        //keep the position of the selected PLMN, need it later to update the list
        network_data.Listposition = ListData->ListPosition;

        network_MNU_start(win,&network_OPTAttrib);
    }
    else
    {

        //user pressed Exit to go back to the network submenu
        FREE_MEMORY ((UBYTE *)network_data.network_list->List, (network_data.pplmn_mem.maxRcd) * sizeof (T_MFW_MNU_ITEM));

        FREE_MEMORY ((UBYTE *)network_data.network_list, sizeof (ListMenuData));

        FREE_MEMORY ((UBYTE *)network_data.pplmn,(network_data.pplmn_mem.maxRcd) * sizeof (T_MFW_NETWORK_STRUCT));

    }


}

/*******************************************************************************

 $Function:    	network_mobile_list_cb

 $Description:	Callback function international list dialog.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_mobile_list_cb(T_MFW_HND win, ListMenuData * ListData)
{

    //test
    UBYTE i;
    //test

    T_MFW_PPLMN_MODE mode;

    T_MFW_WIN       * win_data = ((T_MFW_HDR *)win)->data;
    T_network_OPT    * data     = (T_network_OPT *)win_data->user;

    TRACE_EVENT ("network_mobile_list_cb()");


    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT: /*  */
    case LISTS_REASON_OK:  //xsf add 2003.03.10	
        mode =   REPLACE_PREF_PLMN;    /* Overwrite an existing entry  at a given index */

        //update now the pref. PLMN list
        //Overwrite an existing entry
        //(network_data.Listposition) "+1" because the zero is counted as well
        nm_change_pref_plmn(mode,(network_data.Listposition) +1 , 0, data->pplmn[ListData->ListPosition].network_numeric);

        // destroy the Menu 
        network_MNU_destroy(data->win);

        // request the pref. PLMN list
        nm_pref_plmn_list(network_data.pplmn, network_data.pplmn_mem.maxRcd, 1);



        break;
    case LISTS_REASON_BACK: /* back to previous menu */

        TRACE_EVENT ("pressed Back-key");
        network_MNU_destroy(data->win);

        break;
    default:
        return;
    }


}

/*******************************************************************************

 $Function:    	network_start_animation

 $Description:	Starts the network animation.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_start_animation(void)
{
    T_DISPLAY_DATA display_info;

    MMI_TRACE_EVENT(("<<<talcon,network_start_animation()" ));

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT;
    display_info.TextId2       = 0;  //TxtSearchingNetwork;
    display_info.TextId      = TxtSearchingNetwork;  //TxtWaiting;
    display_info.TextString   = 0;  //"Searching for";
    display_info.TextString2  = 0;  //"  Networks";
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = 30000;  //FOREVER;  
    display_info.Identifier=MMI_CALLFORWARD_DIALOG_NORMAL;/*2003/12/4, wangyan add*/
    display_info.Callback     = (T_VOID_FUNC)network_animation_cb;
    /*
     * Call Info Screen
     */

    network_data.network_search_win = info_dialog (network_data.network_win, &display_info);
    //mmi_dialogs_insert_fixmov_animation(network_data.network_search_win, 300 ,NETWORKSEARCHING,8);
    mmi_dialogs_insert_fixmov_animation(network_data.network_search_win, 300 ,NETWORKSEARCHINGANIM);/*2003/12/4, wangyan modify*/
}



/*******************************************************************************

 $Function:    	network_start_animation_plmn_selection

 $Description:	Starts the plmn selection animation.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_start_animation_plmn_selection(int plmn_value)
{
    T_DISPLAY_DATA display_info;
    T_MFW_PLMN_LIST * plmn_list;

    TRACE_FUNCTION ("network_start_animation_plmn_selection()");

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT;
    //display_info.TextId2       =TxtPleaseWait;  //
    display_info.TextId2      = TxtRegNetwork;  //TxtWaiting;
    //display_info.TextString   = 0;  //"Requesting....";
    //display_info.TextString2  = '\0';
    //display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         =  20000;  //FOREVER;    
    display_info.iconindex =REMIND_WAITTING;
    display_info.Callback     = (T_VOID_FUNC)network_animation_cb;
    /*
     * Call Info Screen
     */
    network_data.aborted = FALSE;  //xsf add 2003.02.25
    network_data.network_search_win = info_dialog (network_data.network_win, &display_info);
}

/*******************************************************************************

 $Function:    	network_animation3sec_cb

 $Description:	Callback for information dialog (not used)n
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network_animation3sec_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    TRACE_FUNCTION ("network_animation3sec_cb()");
    network_data.network_search_win = 0;
    network_data.aborted = TRUE;

}

/*******************************************************************************

 $Function:    	network_forbidden_plmn

 $Description:	Starts the forbidden plmn data screen.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_forbidden_plmn(void)
{
    T_DISPLAY_DATA display_info;

    MMI_TRACE_EVENT(("<<<talcon,network_forbidden_plmn()" ));

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT;
    //display_info.TextId       = TxtRegNetwork;  //TxtHostKeyChangeFail; 
    display_info.TextId2      = TxtHostKeyChangeFail;  //TxtForbidden;

    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = 3000;
    display_info.iconindex =REMIND_FAILURE;
    display_info.Callback     = (T_VOID_FUNC)network_animation3sec_cb;
    /*
     * Call Info Screen
     */

    network_data.network_search_win = info_dialog (network_data.network_win, &display_info);
}


/*******************************************************************************

 $Function:    	network_selected

 $Description:	displays info screen on network selected
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_selected(void)
{
    T_DISPLAY_DATA display_info;

    MMI_TRACE_EVENT(("<<<talcon,network_selected()" ));

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT;
    //display_info.TextId       = TxtRegNetwork;  //TxtHostKeyChangeOk; //TxtNetwork;
    display_info.TextId2      = TxtHostKeyChangeOk;  //TxtSelected;

    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = 3000;
    display_info.iconindex =REMIND_SUCCEED;
    display_info.Callback     = (T_VOID_FUNC)network_animation3sec_cb;
    /*
     * Call Info Screen
     */

    network_data.network_search_win = info_dialog (network_data.network_win, &display_info);
}

/*******************************************************************************

 $Function:    	network_no_plmns

 $Description:	 Indicate Info Screen that the network list is empty.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_no_plmns(void)
{
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("network_no_plmns()");

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_RIGHT;
    display_info.TextId2       = TxtNoNetwork;
    //display_info.TextId      = 0;
    //display_info.TextString   = '\0';  //" No networks";
    //display_info.TextString2  = '\0';  //" available";
    //display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = THREE_SECS;
    display_info.iconindex  =REMIND_NORECORD;
    display_info.Callback     = (T_VOID_FUNC)network_animation3sec_cb;
    /*
     * Call Info Screen
     */
    info_dialog (0, &display_info);

}
/*******************************************************************************

 $Function:    	network_stop_animation

 $Description:	 Stops the network animation.
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_stop_animation(void)
{
    MMI_TRACE_EVENT(("<<<talcon,network_stop_animation()-type of network_search_win:%d",((MfwHdr *) network_data.network_search_win)->type ));

    /*2004/04/12,talcon modify*/
    /*if (network_data.network_search_win)*/
    if( winIsFocussed(network_data.network_search_win) )
    {
        MMI_TRACE_EVENT(("<<<talcon,network_stop_animation()--1" ));
        SEND_EVENT(network_data.network_search_win,DIALOG_DESTROY,0,0);
        //network_data.network_search_win = 0;
        SetEarMode();
    }
    network_data.network_search_win = 0;
}
/*******************************************************************************

 $Function:    	network_timeout

 $Description:	Indicate Info Screen that the network searching or registering is timed out.
             
 $Returns:		

 $Arguments:	xsf add 2003.02.26
 
*******************************************************************************/
static void network_timeout(void)
{
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("network_timeout()");

    dialog_info_init(&display_info);
    display_info.KeyEvents    = KEY_RIGHT;
    display_info.TextId2       = TxtTimeOut;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         = THREE_SECS;
    display_info.iconindex  =REMIND_NORECORD;

    // Call Info Screen 
    info_dialog (0, &display_info);

}
/*******************************************************************************

 $Function:    	network_animation_cb

 $Description:	Callback for information dialog (not used)n
             
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network_animation_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    MMI_TRACE_EVENT(("<<<talcon,network_animation_cb()" ));
    network_data.network_search_win = 0;
    network_data.aborted = TRUE;
    SetEarMode();
    switch( reason )
    {
    case INFO_TIMEOUT:
        network_timeout();
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	network_MNU_start

 $Description:	called when the user press the Edit Softkey to enter the 
                Option Menu "Select from the list" & "Enter the Network Code" &
                            "Delete"
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

T_MFW_HND network_MNU_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("network_MNU_start()");

    win = network_MNU_create (parent_window);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}

/*******************************************************************************

 $Function:    	network_MNU_create

 $Description:	Create the Option window
 
 $Returns:		mfw window handle

 $Arguments:	parent_window -parent window handle
            
*******************************************************************************/

static T_MFW_HND network_MNU_create(MfwHnd parent_window)
{
    T_network_OPT   * data = (T_network_OPT *)ALLOC_MEMORY (sizeof (T_network_OPT));
    T_MFW_WIN       * win;

    TRACE_FUNCTION ("network_MNU_create()");

    /*
     * Create window handler
     */

    data->win = 
    win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)network_MNU_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }

    /* 
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)network_MNU_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    return data->win;
}

/*******************************************************************************

 $Function:    	network_MNU_destroy

 $Description:	Destroy the Option window
 
 $Returns:		mfw window handle

 $Arguments:	own_window - current window
            
*******************************************************************************/

static void network_MNU_destroy(MfwHnd own_window)
{
    T_MFW_WIN       * win_data;
    T_network_OPT   * data;

    TRACE_FUNCTION ("network_MNU_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data     = (T_network_OPT *)win_data->user;

        if( data )
        {
            kbd_delete(data->kbd);
            kbd_delete(data->kbd_long);
            mnuDelete (data->menu);
            /*
             * Delete WIN handler
             */ 
            win_delete (data->win); 
            if( data->network_list != NULL )
            {
                FREE_MEMORY ((UBYTE *)data->network_list->List, MAX_SHOW_OF_PLMN * sizeof (T_MFW_MNU_ITEM));

                FREE_MEMORY ((UBYTE *)data->network_list, sizeof (ListMenuData));

                FREE_MEMORY ((UBYTE *)data->pplmn,MAX_SHOW_OF_PLMN * sizeof (T_MFW_NETWORK_STRUCT));
            }
            /*     
             * Free Memory
             */

            FREE_MEMORY ((void *)data, sizeof (T_network_OPT));
        }
        else
        {
            TRACE_EVENT ("network_MNU_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	network_MNU_exec_cb

 $Description:	Exec callback function for the Option window
 
 $Returns:		none

 $Arguments:	win - current window
                event - event id
                value - unique id
                parameter - optional data.
            
*******************************************************************************/

void network_MNU_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_network_OPT    * data     = (T_network_OPT *)win_data->user;
    T_MFW_HND        * l_parent;
    SHORT            l_id;
    T_MFW_HDR        * parent      =  data->parent;
    T_MFW_EVENT         MfwEvents;

    TRACE_FUNCTION ("network_MNU_exec_cb()");


    switch( event )
    {
    case E_INIT:
        data->kbd     =   kbdCreate(data->win,KEY_ALL,         (MfwCb)network_MNU_kbd_cb);
        data->kbd_long =   kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)network_MNU_kbd_cb);
        data->menu    =   mnuCreate(data->win,&network_OPTAttrib, E_MNU_ESCAPE, (MfwCb)network_MNU_mnu_cb);
        mnuLang(data->menu,mainMmiLng);

        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);

        break;
    default:
        return;
    }
}

/*******************************************************************************

 $Function:    	network_MNU_mnu_cb

 $Description:	Menu callback function for the Option window
 
 $Returns:		none

 $Arguments:	e - event id
                m - menu handle
*******************************************************************************/

static int network_MNU_mnu_cb (MfwEvt e, MfwMnu *m)
{
    T_MFW_HND        win      = mfwParent(mfw_header());
    T_MFW_WIN      * win_data = ((T_MFW_HDR *)win)->data;
    T_network_OPT   * data     = (T_network_OPT *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;

    TRACE_FUNCTION ("network_MNU_mnu_cb()");

    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu "pref. network list"*/
        network_MNU_destroy(data->win);

        // request MFW to fill up the pref. PLMN list
        nm_pref_plmn_list(network_data.pplmn, network_data.pplmn_mem.maxRcd, 1);


        break;
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	network_MNU_win_cb

 $Description:	Window callback function for the Option window
 
 $Returns:		execution status

 $Arguments:	e - event id
                w - window handle 
*******************************************************************************/

static int network_MNU_win_cb (MfwEvt e, MfwWin *w)
{
    TRACE_FUNCTION ("network_MNU_win_cb()");

    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	network_MNU_kbd_cb

 $Description:	Exec callback function for the Option window
 
 $Returns:		execution status

 $Arguments:	e - event id
                k - keyboard info
*******************************************************************************/

static int network_MNU_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND            win      = mfwParent(mfw_header());
    T_MFW_WIN          * win_data = ((T_MFW_HDR *)win)->data;
    T_network_OPT    * data       = (T_network_OPT *)win_data->user;

    TRACE_FUNCTION ("network_MNU_kbd_cb()");

    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:  //xsf add KCD_OK=KCD_LEFT 2003.02.19
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	network_request_plnm_list

 $Description:	Request existing network list in Mobile
 
 $Returns:		

 $Arguments:	


 *******************************************************************************/
static int network_request_plnm_list(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_network_OPT    * data     = (T_network_OPT *)win_data->user;

    TRACE_FUNCTION("network_request_plnm_list");

    data->pplmn = (T_MFW_NETWORK_STRUCT *)ALLOC_MEMORY ((MAX_SHOW_OF_PLMN) * sizeof (T_MFW_NETWORK_STRUCT));

    if( data->pplmn NEQ 0 )
    {
        //now fill up the "data->pplmn" with the PLMN list from ACI
        nm_plnm_list(data->pplmn, 1, MAX_SHOW_OF_PLMN);

    }
    else
    {
        TRACE_EVENT("create the list failed");
        return 0;
    }

    //show the list on the screen now
    data->network_list = network_create_mobile_list (data);
    listDisplayListMenu (data->win, data->network_list,(ListCbFunc)network_mobile_list_cb,0);


    return 1;
}

/*******************************************************************************

 $Function:    	network_delete

 $Description:	
 
 $Returns:		

 $Arguments:	


 *******************************************************************************/

static int network_delete(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win      = mfwParent(mfw_header());

    TRACE_FUNCTION ("network_delete()");

#ifdef NO_ASCIIZ
    if( network_data.pplmn[network_data.Listposition].network_short.len NEQ 0 )
#else 
    if( strlen((char *)network_data.pplmn[network_data.Listposition].network_short) NEQ 0 )
#endif	
    {
        // if the user selected a pref. PLMN
        network_info_screen (win, TxtDeleted);
    }
    else
    {
        // if the user selected a empty item
        network_info_screen (win, TxtEmptyList);
    }

    // destroy the Menu 
    network_MNU_destroy(win);


}

/*******************************************************************************

 $Function:    	network_delete_pref_plnm

 $Description:	Delete the selected pref. PLMN l
 
 $Returns:		

 $Arguments:	


 *******************************************************************************/
void network_delete_pref_plnm (T_MFW_HND win , USHORT identifier, UBYTE reason)
{

    T_MFW_PPLMN_MODE mode;
    UBYTE i;
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)win)->data;
    T_network_OPT    * data     = (T_network_OPT *)win_data->user;

    TRACE_FUNCTION ("network_delete_pref_plnm()");


    mode =   DELETE_PREF_PLMN;      /* Delete an entry from the list  */

    //update now the pref. PLMN list
    //(network_data.Listposition) "+1" because the zero is counted as well
    nm_change_pref_plmn(mode, (network_data.Listposition) +1 , 0, 0);

    // clear all the PLMN and fill up with updated list
    for( i=0; i < network_data.pplmn_mem.maxRcd; i++ )
    {

#ifdef NO_ASCIIZ
        network_data.pplmn[i].network_long.len = 0;
        network_data.pplmn[i].network_short.len = 0;
#else 
        memset(network_data.pplmn[i].network_long,   '\0', LONG_NAME);
        memset(network_data.pplmn[i].network_short,   '\0', SHORT_NAME);
#endif		
        memset(network_data.pplmn[i].network_numeric, '\0', NUMERIC_LENGTH);
    }


    // request the updated pref. PLMN list
    nm_pref_plmn_list(network_data.pplmn, network_data.pplmn_mem.maxRcd, 1);

}

/*******************************************************************************

 $Function:    	network_info_screen

 $Description:	confirm the deleted PLMN
 
 $Returns:		

 $Arguments:	


 *******************************************************************************/
void network_info_screen (T_MFW_HND win, USHORT MessageId )
{
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("network_info_screen()");

    dialog_info_init(&display_info);
    display_info.TextString   = NULL; 
    display_info.TextString2  = NULL;
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtNull;
    display_info.Time         = THREE_SECS;
    display_info.KeyEvents    = 0;
    display_info.TextId       = MessageId;
    display_info.TextId2      = 0;
    display_info.Identifier   = 0;
    display_info.Callback     = (T_VOID_FUNC) network_delete_pref_plnm;
    info_dialog (win, &display_info); 
}


/*******************************************************************************

 $Function:    	network_OPT_EDT_start

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND network_EDT_start (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND   win;
    T_MFW_HND   parent_window   = mfwParent(mfw_header());

    TRACE_FUNCTION ("network_OPT_EDT_start()");

    win = network_EDT_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return win;
}

/*******************************************************************************

 $Function:    	network_OPT_EDT_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static T_MFW_HND network_EDT_create(MfwHnd parent_window)
{
    T_network_OPT  * data = (T_network_OPT *)ALLOC_MEMORY (sizeof (T_network_OPT));
    T_MFW_WIN     * win;

    TRACE_FUNCTION ("network_EDT_create()");

    /*
     * Create window handler
     */

    data->win = win_create (parent_window, 0, 0, NULL);

    if( data->win EQ NULL )
    {
        return NULL;
    }

    /* 
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)network_EDT_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    winShow(data->win);
    return data->win;
}


/*******************************************************************************

 $Function:    	network_EDT_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_EDT_destroy(MfwHnd own_window)
{
    T_MFW_WIN        * win_data;
    T_network_OPT     * data;


    TRACE_FUNCTION ("networkT_EDT_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data     = (T_network_OPT *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            win_delete (data->win);

            /*     
             * Free Memory
             */
            FREE_MEMORY ((void *)data, sizeof (T_network_OPT));
        }
        else
        {
            TRACE_EVENT ("network_EDT_destroy() called twice");
        }
    }
}


/*******************************************************************************

 $Function:    	network_EDT_exec_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void network_EDT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *) win)->data;
    T_network_OPT    * data     = (T_network_OPT *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT             l_id;
    int                index;

    TRACE_FUNCTION ("network_EDT_exec_cb()");

    switch( event )
    {
    case E_INIT:

        data->editor_info.editor_attr.win.px   = 6;
        data->editor_info.editor_attr.win.py   = 12;
        data->editor_info.editor_attr.win.sx   = 80;
        data->editor_info.editor_attr.win.sy   = 20;
        data->editor_info.editor_attr.fgColor  = 0;
        data->editor_info.editor_attr.font     = 0;
        data->editor_info.editor_attr.mode     = edtCurBar1;
        data->editor_info.editor_attr.controls = 0;
        data->editor_info.editor_attr.text     = data->buffer;  /* buffer to be edited */
        data->editor_info.editor_attr.size     = 6;
        data->editor_info.LeftSoftKey       = TxtSoftOK;        
        data->editor_info.RightSoftKey      = TxtDelete;
        data->editor_info.TextId            = TxtMCCMNC;
        data->editor_info.Identifier        = value;  /* optional */
        data->editor_info.mode              = DIGITS_MODE;
        data->editor_info.Callback          = (T_EDIT_CB)network_EDT_editor_cb;
        data->editor_info.destroyEditor     = TRUE;
        data->editor_info.hide                 = FALSE;
        data->editor_info.AlternateLeftSoftKey = TxtNull;
        data->editor_info.TextString           = NULL;
        data->editor_info.min_enter            = 5;
        data->editor_info.timeout              = FOREVER;

        /* create the dialog handler */
        editor_start(data->win, &data->editor_info);  /* start the editor */ 

        break;
    case E_ABORT:
    case E_EXIT: /* defaultreaction */
        network_EDT_destroy(data->win);
        break;
    default:
        return;
    }
}


/*******************************************************************************

 $Function:    	network_EDT_editor_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void network_EDT_editor_cb (T_MFW_HND win, USHORT Identifier, USHORT event)
{
    T_MFW_WIN    * win_data = ((T_MFW_HDR *)win)->data;
    T_network_OPT * data     = (T_network_OPT *)win_data->user;
    T_MFW_HND    * l_parent;
    T_MFW_PPLMN_MODE mode;

    TRACE_FUNCTION ("network_EDT_editor_cb()");


    l_parent = data->parent;

    switch( event )
    {
    case INFO_KCD_LEFT:

        mode =   REPLACE_PREF_PLMN;    /* Overwrite an existing entry  at a given index */

        //update now the pref. PLMN list
        //Overwrite an existing entry
        //(network_data.Listposition) "+1" because the zero is counted as well
        nm_change_pref_plmn(mode, (network_data.Listposition) +1 , 0, (UBYTE*) data->buffer);

        // destroy the Editor 
        network_EDT_destroy(data->win);
        // destroy the MENU
        network_MNU_destroy(l_parent);

        // request the pref. PLMN list
        nm_pref_plmn_list(network_data.pplmn, network_data.pplmn_mem.maxRcd, 1);            


        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        // destroy the Editor 
        network_EDT_destroy(data->win);
        // destroy the MENU
        network_MNU_destroy(l_parent);

        break;
    default:
        break;
    }
    return;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : BMI_TEST           |
| STATE   : code                        ROUTINE : ShowHomePlmn       |
+--------------------------------------------------------------------+

  PURPOSE : get home plmn

*/

int ShowHomePlmn(T_MFW_MNU *m, T_MFW_MNU_ITEM *i) {
    //char             NetworkName[80];
    T_DISPLAY_DATA display_info;
    MMI_TRACE_EVENT(("<<<talcon,ShowHomePlmn"));

    nm_home_plmn (&homeplmn);

    dialog_info_init(&display_info);//gdy add
    //display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT;
    //if((!strcmp((char *)homeplmn.network_numeric,"46000"))||!strcmp((char *)(homeplmn.network_long.data), "CHINA TELECOM"))
    if( (!strcmp((char *)homeplmn.network_numeric,"46000"))||!strcmp((char *)(homeplmn.network_long.data), "CHINA  MOBILE") )
        display_info.TextId2   = T_China_Telecomm;
    else if( !strcmp((char *)(homeplmn.network_long.data),"CHN-CUGSM") )
        display_info.TextId2   = T_China_Unicomm;
    else
        display_info.TextString   = (char *)(homeplmn.network_long.data);
    //if(g_nmService == NM_FULL_SERVICE) {		
    /*xsf remarked it 2003.03.14 if((rr_get_bcch_channel()>=1)&&(rr_get_bcch_channel()<=124))		
     display_info.TextId2  = TxtGSM900;
    else 
     display_info.TextId2  = TxtDCS1800;*/
    //}

    display_info.RightSoftKey = TxtSoftBack;
    display_info.KeyEvents = KEY_ALL;
    display_info.Time         = THREE_SECS;
    display_info.Callback     = 0;
    display_info.iconindex=REMIND_COMPLETE;
    /*
     * Call Info Screen
     */

    network_data.network_search_win = info_dialog (network_data.network_win, &display_info);

    MMI_TRACE_EVENT(("<<<talcon,ShowHomePlmn--network_data.network_search_win:%p",network_data.network_search_win));

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : BMI_TEST           |
| STATE   : code                        ROUTINE : ShowHomePlmn       |
+--------------------------------------------------------------------+

  PURPOSE : reselect the plmn

*/

int networkreselect(T_MFW_MNU *m, T_MFW_MNU_ITEM *i) {
    network_data.aborted = FALSE;
    nm_avail_plmn_list();
    network_start_animation();
    return 0;
}

/*******************************************************************************/
/*                                                                             */
/*Function Name: networkMenuIcon_check                                         */
/*Purpose:      networkMenuIcon_check                                          */
/*Prarmeter:   struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi */
/*return   :     USHORT                                                        */
/*                                                                             */
/*Author   :     xsf                                                           */
/*Date     :    Sep.28th,2002                                                  */
/*******************************************************************************/
USHORT networkMenuIcon_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    if( ((int)mi->str==TxtAutomatic) && (nm_get_mode()==NM_AUTOMATIC) )
        return FLAGFUNC_TRUE_ICON;
    else if( ((int)mi->str==TxtManual) && (nm_get_mode()==NM_MANUAL) )
        return FLAGFUNC_TRUE_ICON;
    else
        return FLAGFUNC_FALSE_ICON;
}

int SetDualBand(T_MFW_MNU *m, T_MFW_MNU_ITEM *i) {
    nm_restrict_bands(0); 
    FFS_flashData.Band_restriction=0;
    return 1;
}

int SetGSM900(T_MFW_MNU *m, T_MFW_MNU_ITEM *i) {
    nm_restrict_bands(1); 
    FFS_flashData.Band_restriction=1;
    return 1;
}

int SetDCS1800(T_MFW_MNU *m, T_MFW_MNU_ITEM *i) {
    nm_restrict_bands(2); 
    FFS_flashData.Band_restriction=2;
    return 1;
}

