/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		
 $File:		    MmiNetwork.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
                        
********************************************************************************



/*******************************************************************************
                                                                              
                                Required Include Files
                                                                              
*******************************************************************************/


#ifndef _DEF_MMI_NETWORK_H_
#define _DEF_MMI_NETWORK_H_

/*
 * Events from network management dialog
 */
#define NETWORK_NO_SERVICE         400
#define NETWORK_FULL_SERVICE       401
#define NETWORK_SEARCH_NETWORK     402
#define NETWORK_NO_PLMN_XXX_AVAIL  403

/* glowing: comment the following define in the mminetwork.c and add it here */
#define NETWORK_LIMITED_SERVICE   420



/*
 * NETWORK_NO_SERVICE  : no parameter
 *
 * The mobile has no or limited service
 *
 * NETWORK_FULL_SERVICE : no parameter
 *
 * The mobile has full service. The current network as text string and in MCC/MNC format
 * can be requested by the function network_get_plmn.
 *
 * NETWORK_SEARCH_NETWORK : no parameter
 *
 * The mobile indicates searching for a network.
 *
 * NETWORK_NO_PLMN_XXX_AVAIL: no parameter
 *
 * The network has enabled network logging, but this network is not available. The logged
 * network can be requested by the function network_get_plmn.
 * 
 */
#define SIZE_PLMN_NAME 			20
#define SIZE_NETWORK_NAME		6

typedef struct  
{
  UBYTE plmn_name [SIZE_PLMN_NAME];        /* textual format of PLMN */
  UBYTE network_name [SIZE_NETWORK_NAME];      /* numeric format of PLMN */
  UBYTE roaming_indicator;     /* Roaming Indicator      */
} T_CURRENT_NETWORK;

/*SPR 1815, moved definition from MmiNetwork.c*/
/*
 * Data for top window
 */
typedef struct
{
  T_MMI_CONTROL    mmi_control;
  T_MFW_HND        network_win;        /* MFW win handler      */
  T_MFW_HND        nm_handle;          /* MFW network handler  */
  UBYTE			   aborted;
  UBYTE			   keep_plmn_list;
  T_MFW_NETWORK_STRUCT  *pplmn;              /* pref. PLMN list */
  T_MFW_PPLMN_MEM  pplmn_mem;
  UBYTE            plmn_name[SIZE_PLMN_NAME];      /* textual network name */
  UBYTE            network_name[SIZE_NETWORK_NAME];    /* numeric network name */
  USHORT           status;             /* current status       */
  UBYTE            roaming_indicator;  /* Roaming Indicator    */
  ListMenuData   * network_list;       /* PLMN available List  */
  UBYTE            network_list_status;/* Network List Status */
  UBYTE            network_search_name[MAX_PLMN][6]; /* numeric network name */
  T_MFW_HND        network_search_win;
  UBYTE			    Listposition;
} T_network;

/*
 * Prototypes
 */
T_MFW_HND network_create             (T_MFW_HND parent_window);
void      network_destroy            (T_MFW_HND own_window);
void      network                    (T_MFW_HND win, USHORT event, SHORT value, void * parameter);

/*
 * Menu entries
 */
int       network_set_mode_auto      (T_MFW_MNU * m, T_MFW_MNU_ITEM * mi);
int       network_set_mode_man       (T_MFW_MNU * m, T_MFW_MNU_ITEM * mi);
int		  network_pref_list          (T_MFW_MNU * m, T_MFW_MNU_ITEM * mi);
int       network_log_on             (T_MFW_MNU * m, T_MFW_MNU_ITEM * mi);
int       network_log_off            (T_MFW_MNU * m, T_MFW_MNU_ITEM * mi);

USHORT    nm_flag_log_on             (T_MFW_MNU * m, T_MFW_MNU_ATTR * ma, T_MFW_MNU_ITEM * mi);
USHORT    nm_flag_log_off            (T_MFW_MNU * m, T_MFW_MNU_ATTR * ma, T_MFW_MNU_ITEM * mi);

void      network_get_name           (T_CURRENT_NETWORK * nm);
void      network_start_full_service (void);
T_MFW_HND networkInit (T_MFW_HND parent_window);
////xsf add 2002.08.05 5 lines
int ShowHomePlmn(T_MFW_MNU *m, T_MFW_MNU_ITEM *i);
int networkreselect(T_MFW_MNU *m, T_MFW_MNU_ITEM *i);
int SetDualBand(T_MFW_MNU *m, T_MFW_MNU_ITEM *i);
int SetGSM900(T_MFW_MNU *m, T_MFW_MNU_ITEM *i);
int SetDCS1800(T_MFW_MNU *m, T_MFW_MNU_ITEM *i);
USHORT networkMenuIcon_check(struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi);  //xsf add 2002.09.28

#endif

