#ifndef _MMIRESOURCES_H_
#define _MMIRESOURCES_H_ 1
#include "MmiCoordinate.h"


/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   Resource Manager
 $File:       MmiResources.h
 $Revision:   1.0
 
 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

   Define a simple get text routine to fetch a pointer
   to a textual resource given a resource identifier.

   The resource identifiers are given in the MmiBlkResources.h
   module header

********************************************************************************
 $History: MmiResources.h

  25/10/00      Original Condat(UK) BMI version.
  04/08/02      zy display call result place 04/08/02
 $End

*******************************************************************************/

#include "MmiBlkLangDB.h"

#define ENGLISH_LANGUAGE 1
#define GERMAN_LANGUAGE  2
#ifdef CHINESE_MMI
#define CHINESE_LANGUAGE  2
#else
#define CHINESE_LANGUAGE  3
#endif



/********************************/

extern Easy_Text_Available;

extern MfwRect selected_area;

extern MfwRect menuArea;
extern MfwRect menuNamesArea;
extern MfwRect menuListArea;
extern MfwRect menuViewListArea;
extern MfwRect editor_menuArea;
extern MfwRect network_menuArea;
extern MfwRect sat_setup_menuArea;
extern MfwRect sat_select_menuArea;
extern MfwRect smscb_M_CBArea;
extern MfwRect smscb_M_CB_ACTArea;
extern MfwRect smscb_M_CB_TOPArea;
extern MfwRect smscb_M_CB_TOP_CONSArea;
extern MfwRect smscb_M_CB_TOP_CONS_SELArea;
extern MfwRect smscb_CBArea;
extern MfwRect smscb_CB_OPTArea;
extern MfwRect readSMS_menuArea;
extern MfwRect readSMS_menuAreaMo;/*2003/12/4, wangyan add*/
extern MfwRect SmsRead_R_OPTArea;
extern MfwRect SmsSend_R_OPTArea;
extern MfwRect melody_menuArea;
extern MfwRect menuDynamicArea;
extern MfwRect menuDynamicArea_fromcall; /*2003/12/16, wangyan add*/
extern MfwRect menuWeeklyArea;
extern MfwRect ShortCutDynamicArea;		/* 2004/06/08 sunsj modify */



/********************************/




/* Define a simple get text routine to fetch a pointer
   to a textual resource given a resource identifier.

   The resource identifiers are given in the MmiBlkResources.h
   module header
*/


char *MmiRsrcGetText( int Id );

/* For test purposes, allow multiple language selection
*/
void MmiRsrcSetEnglish( void );
void MmiRsrcSetGerman( void );
void MmiRsrcSetChinese( void );

void Mmi_Set2English( void );
void Mmi_Set2German( void );
void Mmi_Set2Chinese( void );

UBYTE Mmi_getCurrentLanguage(void);

UBYTE Mmi_layout_first_line(void);
UBYTE Mmi_layout_second_line(void);
UBYTE Mmi_layout_third_line(void);
UBYTE Mmi_layout_fourth_line(void);
UBYTE Mmi_layout_fifth_line(void);
UBYTE Mmi_layout_Call_Txt_line(void);//zy add for display callreault 04/08/02 
UBYTE Mmi_layout_line_height(void);
UBYTE Mmi_layout_first_line_icons(void);
UBYTE Mmi_layout_second_line_icons(void);

void Mmi_layout_areas(void);

void Mmi_set_area_attr(MfwRect* area,U16 px,U16 py,U16 sx,U16 sy);
void recources_destroy (T_MFW_HND own_window);

typedef struct {
  U16 id;
  U16 count;
  U32 attributes;
} T_RESOURCE_DIRECTORY_HEADER;

// This type identifies the various resources that are listable in the file.
typedef enum
{
	RES_FIRST_RESOURCE_TYPE=0,
	RES_LANGUAGE_TABLE, 
	RES_LANGUAGE, 
	RES_STRING,
	RES_MELODY_TABLE,
	RES_MELODY,
	RES_MELODY_STR,    //xsf add for melodytablestr[] 12.26
	RES_MELODY_SMS,   //xsf add for sms ring 2003.03.13
//???GW Removed T9 reference	RES_T9LDB_TABLE,
	RES_LAST_RESOURCE_TYPE
} res_ResourceID_type;

typedef const T_RESOURCE_DIRECTORY_HEADER * RESOURCE_DIRECTORY_HEADER;

typedef unsigned char ST_DIMENSION ;


/*******************************************************************************

                                End of File

*******************************************************************************/

#endif
