/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
																			  
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI                                                            
 $Module:		SMS
 $File:		    MmiSmsIdle.c
 $Revision:		1.0                                                       
																			  
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
																			   
********************************************************************************
																			  
 Description: Implementation for MMI smsidle unsolicited event handling
 
   
						
********************************************************************************

 $History: MmiSmsIdle.c

	25/10/00			Original Condat(UK) BMI version.	
	09/08         windy modified
 $End

*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

	#include "typedefs.h"
	#include "vsi.h"
	#include "pei.h"
	#include "custom.h"
	#include "gsm.h"

#else

	#include "stddefs.h"
	#include "custom.h"
	#include "gsm.h"
	#include "vsi.h"

#endif
#include "p_sim.h"


#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_icn.h"
#include "mfw_phb.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_smsi.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "mfw_tim.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiCall.h"

#include "MmiBookController.h"


#include "MmiIdle.h"
#include "MmiIcons.h"
#include "mmiSmsIdle.h"
#include "mmiSmsBroadcast.h"
#include "mmismsmenu.h"

/* SPR759 - SH */
#ifdef MMI_HOMEZONE_ENABLED
	#include "MmiHomezone.h"
#endif

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"

#include "gdi.h"
#include "audio.h"

#include "mfw_cnvt.h"//hxl addd for 

#include "l1tm_cust_add.h"  //hxl add for pcsync 20020925

#include "mmiQQSwitch.h" //hxl add for check qq func
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
	#include "mmiqq.h" 
#endif

//#define TDTRACE 1
#include "mmiutilapi.h"

extern char sms_text_ascii[MAX_MSG_LEN+3];//[MAX_LISTSMS_LEN];
/*********************************************************************
**********************************************************************

				 STATIC MENU WINDOW. DECLARATION

*********************************************************************
**********************************************************************/

typedef struct
{
	/* administrative data */

	T_MMI_CONTROL   mmi_control;
	T_MFW_HND       win;
	SHORT           id;
	T_MFW_HND       parent;

	/* associated handlers */

	T_MFW_HND       sms;

	/* internal data */

	BOOL sms_initialised;
	BOOL sms_store_free;
} T_smsidle;


/*********************************************************************

						External Function Prototypes

**********************************************************************/                     
extern UBYTE getcurrentSMSTone(void);
extern UBYTE Delete_1_2_1_vm_icon;
extern UBYTE Display_1_2_1_vm_icon;
extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13
/*********************************************************************

						Function Prototypes
						
**********************************************************************/
static SHORT smsidle_get_new_cb_messages_count(void);
static int smsidle_sr_status_to_text_id(UBYTE status); /* Marcus: Issue 1170: 07/10/2002 */
static T_smsidle smsidle_data;
static char temp_buffer [MAX_CBMSG_LEN+3];


// Used to count the number of deleted messages in delete all
SHORT g_ListLength2;
static char status_report[160];	/* Marcus: Issue 1170: 07/10/2002 */


static T_MFW_HND smsidle_create (T_MFW_HND parent);
static void smsidle_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
int smsidle_sms_cb (MfwEvt e, MfwWin *w);
extern void save_send_sms(T_MFW_SMS_MO_TYPE type);	//hxl add for pc get 2002-11-1
//int new_sms_index;
extern T_MFW_MEM_INFO     memory;
extern T_call call_data;  //windy add 0225
extern USHORT*  charPtrToUSHORTPtr  (char* data);
extern char*    USHORTPtrToCharPtr  ( USHORT* data);
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
extern uint8    In_QQ;//2003-2-28,indicate in qq menu
extern uint8    CanReadQQ;//in new qq read dialog,can't read new qq
extern uint8    In_QQInfo;//if in qq info dialog,don't show read button
extern uint8    HavenewQQ;//have unread qq
extern uint8    nsms;//for check qq,2003-3-16
extern uint8    ReadbtnShow;//if read btn has been shown,it is 1;etherwise it is 0
#endif
/*******************************************************************************

 $Function:    	smsidle_start

 $Description:	This function will be call once.It is create a static sms handle
 
 $Returns:		mfw window handler 

 $Arguments:	parent_window - Parent window handler
				param - optional data
 
*******************************************************************************/

T_MFW_HND smsidle_start(T_MFW_HND parent_window, void *param)
{
	T_MFW_HND win;

	TRACE_FUNCTION ("smsidle_start()");

	win = smsidle_create (parent_window);

	if (win NEQ NULL)
	{
		SEND_EVENT (win, E_INIT, 0, NULL);
	}
	return win;
}
T_MFW_SMS_MEM_INFO l_sms_mem; //static,hxl changed for pc use
char CBmid[5];
static int playdelaysmstone=0;
//extern unsigned char no_wait;

/*******************************************************************************

 $Function:    	smsidle_create

 $Description:	Create sms Idle window
 
 $Returns:		mfw window handler 

 $Arguments:	parent_window - Parent window handler
 
*******************************************************************************/
static T_MFW_HND smsidle_create(MfwHnd parent_window)
{
	T_smsidle  * data = &smsidle_data;
	T_MFW_WIN  * win;

	TRACE_FUNCTION ("smsidle_create()");

	/*
	 * Create window handler
	 */

	if (data->win EQ NULL)
	{
		data->win = 
		win_create (parent_window, 0, 0, NULL);
		if (data->win EQ NULL)
		{
			return NULL;
		}
	}
	else
	{
		TRACE_EVENT ("smsidle_create() called twice");
		return NULL;
	}

	/* 
	 * connect the dialog data to the MFW-window
	 */

	data->mmi_control.dialog = (T_DIALOG_FUNC)smsidle_exec_cb;
	data->mmi_control.data   = data;
	win                      = (T_MFW_WIN *)((T_MFW_HDR *)data->win)->data;
	win->user                = (void *)data;
	data->parent             = parent_window;

	/*
	 * return window handle
	 */

	win_show(data->win);
	return data->win;
}

/*******************************************************************************

 $Function:    	smsidle_destroy

 $Description:	Destroy the sms Idle window.
 
 $Returns:		none

 $Arguments:	none
 
*******************************************************************************/
void smsidle_destroy(void)
{
	T_MFW_WIN     * win_data;
	MfwHnd          own_window;
	T_smsidle     * data;

	own_window = smsidle_data.win;

	TRACE_FUNCTION ("smsidle_destroy()");

	if (own_window)
	{
		win_data = (T_MFW_WIN *)((T_MFW_HDR *)own_window)->data;
		data = (T_smsidle *)win_data->user;

		if (data)
		{
			/*
			 * Delete WIN handler
			 */ 
			win_delete (data->win);

			/*     
			 * Free Memory
			 */
			/* Memory is static! */
		}
		else
		{
			TRACE_EVENT ("smsidle_destroy() called twice");
			return;
		}
	}
}



/*******************************************************************************

 $Function:    	smsidle_exec_cb

 $Description:	Call back function for the sms Idle window.
 
 $Returns:		none

 $Arguments:	win - current window
				event - window event
				value - unique id
				parameter - pointer to optional data.
 
*******************************************************************************/

void smsidle_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
/* callback handler for events sent to to trigger execution */
{
	T_MFW_WIN      * win_data = (T_MFW_WIN *)((T_MFW_HDR *) win)->data;
	T_smsidle      * data     = (T_smsidle *)win_data->user;
	T_MFW_EVENT    smsEvents;

	TRACE_FUNCTION ("smsidle_exec_cb()");

	switch (event)
	{
	case E_INIT:
		/* initialization of administrative data */
		data->id = value;

		/* initialization of the dialog data */

		sms_init();	/* startup sms in MFW */

		smsEvents = 
		E_SMS_MO_AVAIL | E_SMS_CMD_AVAIL | E_SMS_SAVE_AVAIL
		| E_SMS_MT       | E_SMS_MO        | E_SMS_MT_RECEIVED | E_SMS_STATUS
		| E_SMS_MEM      | E_SMS_OK        | E_SMS_ERR         | E_SMS_BUSY   
		| E_SMS_MEM_FULL | E_SMS_MEM_FREE  | E_SMS_RECEIVED    | E_SMS_CB
		| E_SMS_READY    | E_SMS_CB_RECEIVED;


		data->sms = sms_create(win, smsEvents, (T_MFW_CB) smsidle_sms_cb);

		/* "sms_initialised"  indicates that the SMS is ready or not */
		/*api - 10-05-02 - Set To True so the SMS can be recieved (Event not Generated) */
		data->sms_initialised  = FALSE;	/* SMS not ready yet */

		/* "sms_store_free"  indicates that the SMS Memory is full or not */
		/* Set default to True !*/
		data->sms_store_free   = TRUE; // ??? 

		break;
	case E_BACK:
	case E_ABORT:
	case E_EXIT:
		smsidle_destroy(); /* there's no default reaction */
		sms_delete(data->sms);
		sms_exit();	/* ??? implementation of routine is actually empty */
		break;
	default:
		TRACE_EVENT("unhandled event in smsidle_exec_cb()");
		return;
	}
}

/*******************************************************************************

 $Function:    	smsidle_sms_cb

 $Description:	Call back function for the sms Idle window.
 
 $Returns:		none

 $Arguments:	event - window event
				w - current window 
*******************************************************************************/
int smsidle_sms_cb (MfwEvt event, MfwWin *w)
/* smsidle's sms event handler */
{
	T_MFW_HND    win      = mfwParent((MfwHdr *)mfw_header());
	T_MFW_WIN  * win_data = (T_MFW_WIN *)((T_MFW_HDR *)win)->data;
	T_smsidle  * data     = (T_smsidle *)win_data->user;
	UBYTE currentSMSTone;
	static int  nsmsold=0;//for save the old new sms before check new sms,hxl add ,2003-3-25
	static int  noldqq=0;//for save the old qq sms before check new sms,hxl add ,2003-3-25

	/* 
	 * Marcus: Issue 1262: 17/12/2002: Made the msg_list and urd_msg_list arrays
	 * static so that they are not on the stack, in case that causes problems
	 * when the value of MAX_MESSAGES increases.
	 */
	static T_MFW_SMS_IDX msg_list[MAX_MESSAGES];
	static T_MFW_SMS_IDX urd_msg_list[MAX_MESSAGES];
	SHORT urd_count;
	UBYTE alphabet;
	char buf[100];
	T_MFW_SMS_INFO sms_info;

	TRACE_EVENT ("smsidle_sms_cb()");
	MmiTrace("smsidle_sms_cb()");
	switch (event)
	{
	case E_SMS_READY: 
		TRACE_EVENT ("E_SMS_READY");
		/* now sms is now ready for using */
		data->sms_initialised = TRUE;

		/* this function do following :                    */
		/* message will be stored to memory and            */
		/* the index will be indicated "E_SMS_MT_RECEIVED" */
//JVJE	    sms_set_mt_ind(MT_IND_IDX); 



		/* this function do following :                    */
		/* message will be indicated to MMI "E_SMS_CB"     */
		/* but not stored on the memory                    */
		//nm sms_set_mt_ind(MT_CB_MSG);  

		//windysmscb_getCBsettings();  /* Get CB info from SIM or phone */
		Get_CB_Info();/*windy modify Get CB info from  phone */
		//SmsSend_get_config_data(&sms_parameter);
		sms_parameter(&sms_info, TRUE);
		switch (FFS_flashData.SRRONOFF)
		{
		case 0:
			sms_info.srr = SMS_NOT_REQUESTED_SRR;
			sms_parameter(&sms_info, FALSE);
			//sms_set_mt_ind(MT_IND_SRR_OFF);
			break;

		case 1:
			sms_info.srr = SMS_REQUESTED_SRR;
			sms_parameter(&sms_info, FALSE);
			//sms_set_mt_ind(MT_IND_SRR_ON);
			break;

		}
#ifdef MMI_HOMEZONE_ENABLED
		homezoneActivateCB();	/* SPR759 - SH - Activate Cell Broadcast channel for homezone */
#endif

		break;
	case E_SMS_MT_RECEIVED:	/* new SMS received, automatically saved     */
	case E_SMS_MT:			/* new SMS received, NOT automatically saved */
		{   
			/* take the SMS data from MFW  */
			//  T_MFW_SMS_MT *Message = (T_MFW_SMS_MT *) w;

			// check for SMS indicating voice mail.
			urd_count=sms_index_list(MFW_SMS_UNREAD,urd_msg_list,MAX_MESSAGES);

			sms_index_list(MFW_SMS_VOICE,msg_list,MAX_MESSAGES);

			TRACE_EVENT_P4("urd_count %d urd_msg_list-> index %d stat %d msg_type %d",
						   urd_count,urd_msg_list[0].index,urd_msg_list[0].stat,urd_msg_list[0].msg_type);

			//Check SMS indicating voice mail is the received SMS, by checking index is the same.
//#ifdef STEVE_TEST
			if (msg_list[0].msg_type == MFW_SMS_VOICE )
			{
				if (iconsGetState(iconIdVoice) == ICON_VISIBLE || (Delete_1_2_1_vm_icon == TRUE))
				{
					if (iconsGetState(iconIdVoice) == ICON_VISIBLE && Display_1_2_1_vm_icon == TRUE)
					{
						// one-2-one only functionality, do nothing as icon is already being displayed.
						//if (CphsPresent()) //if cphs is supported, check which line 
						//	GetCphsVoicemailStatus(0);
						break;
					}
					else
					{
						Delete_1_2_1_vm_icon  = FALSE;
						Display_1_2_1_vm_icon = FALSE;
						iconsDeleteState(iconIdVoice); 
					}
				}
				else
				{
					iconsSetState(iconIdVoice);		 /*  display voice mail icon.*/
					//if (CphsPresent()) //if cphs is supported, check which line 
					//		GetCphsVoicemailStatus(0);
				}
				idleEvent(IdleUpdate);		/*  update the idle screen.*/
				//Play the Voice Mail tone.
			}
			else if (urd_count > 0 && urd_msg_list[0].stat == MFW_SMS_UNREAD && (event != E_SMS_MT))
			{
				//hxl add for qq check 20021230----------------------------
#ifdef 	QQFUNC//hxl add for qq func switch,2003-3-24
				int ret;
				MmiTrace("new_sms_mt");
				if (!QQsend.QQCheck)
				{
					if (smsidle_get_ready_state())
					{
						nsmsold = sms_message_count (MFW_SMS_UNREAD);
						nsmsold-=1;
					}
					idle_display_QQ_status(&noldqq);
					ret=check_new_sms(0,0);
				}
#else
				//if(g_pcsyncstatus)//when pcsync run
				//	PcCmdStatus.nNewsms++;
#endif
				//end of hxl add------------------------------------------------

				/* set the status: The sms icon and  the string*/
				/* "message(s) received" will be displayed     */			
				iconsSetState(iconIdSMS);//2004/03/11 Sunny add     
#ifndef 	QQFUNC//hxl ,this shoud be moved ,after checked it is not qq
				if (smsidle_get_ready_state())
				{
					//sms_get_memset();
					idleEvent(IdleNewSmsMessage);
					//currentSMSTone = getcurrentSMSTone();
					//XSF CHANGED 2002.08.14 audio_PlaySoundID( AUDIO_BUZZER, currentSMSTone, 200, 0 );
		            LedLightnessAdjust( 200 );		// 2004.4.2 WYJ  
        		    timStart(gtVibator);
					StartPlayByReason(SMSPLAY,0);
				}
				else
				{
					playdelaysmstone=1;
					//sms_get_memset();
				}
#endif
			}
			/*NM p029*/
			/* API - Implemented NM changes from 3.3.3 mainline to show class 0 SMS on idle screen */
			else if (event == E_SMS_MT)	/* this sms identifier "E_SMS_MT" is not saved on the SIM */
			{
				/* take the SMS data from MFW  */
				//hxl add for pc or qq get the msg 20021030----------------------------
				T_MFW_SMS_MT *MtMessage = (T_MFW_SMS_MT *) w;
				char *tmpsms;
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
				static uint8    nqq=0;
				int nnew=0;
				int ret=0;
				static uint8    nleftqq=0;
				int txtinfo;
#endif

				MmiTrace("e_sms_mt");

				memset((char*)sms_text_ascii,'\0', sizeof(sms_text_ascii));
				if (MtMessage->dcs==0x08||MtMessage->dcs==0x18)
				{
					tmpsms=mmi_Sim_Sys(MtMessage->sms_msg,MtMessage->msg_len,MFW_DCS_UCS2,MAX_MSG_LEN);
					memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
				}
				else
				{
					tmpsms=mmi_Sim_Sys(MtMessage->sms_msg,MtMessage->msg_len, MFW_DCS_8bits,MAX_MSG_LEN);
					memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
				}
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
				if (QQReadNewSms)
				{
					QQReadNewSms=0;
					ret=IsQQSms((char *)MtMessage->orig_addr.number,sms_text_ascii,&(MtMessage->sctp),1);
					MmiTraceInt(ret);
					if (ret>0)
					{
						MmiTrace("qq");
						if ((ret==Is_Left_Info))
						{
							nleftqq++;
							ret=Is_Invalid_QQ;
						}
						if ((ret!=Is_Invalid_QQ)&&(ret!=QQ_ALLOC_FAIL))
						{
							if (ret!=Is_Spec_QQ)
								nqq++;
							if (nqq>noldqq)
								StartPlayByReason(QQPLAY,0);

						}
						nnew=check_new_sms(1,MtMessage->index);
					}
					else
					{
						MmiTrace("not qq");
						nsms++;
						if (nsms>nsmsold)
							StartPlayByReason(SMSPLAY,0);
						nnew=check_new_sms(0,0);
					}
					if ((nnew<0)&&(nleftqq>0))
					{
						View_left_info();
						nleftqq=0;
					}
					if ((nnew<0))
					{
						MmiTrace("remiand new");
						QQsend.QQCheck=0;
						if (nsms)
						{
							//if(g_pcsyncstatus)//when pcsync run
							//	PcCmdStatus.nNewsms=nsms;
							if (nsms>nsmsold)
							{
								if (smsidle_get_ready_state())
								{
									idleEvent(IdleNewSmsMessage);
								}
								else
									playdelaysmstone=1;
							}
						}
						else if (nqq>noldqq)
						{
							dspl_BitBlt(0,2,16,16,0,(void*)newQQ,DSPL_BMPXOR);					//place the game name bitmap
							dspl_BitBlt(0,2,16,16,0,(void*)newQQmask,DSPL_BMPAND);					//place the game name bitmap
							dspl_BitBlt(0,2,16,16,0,(void*)newQQ,DSPL_BMPXOR);					//place the game name bitmap
							idleEvent(IdleNewQQMessage);
							idle_display_QQ_status(&txtinfo);
							if ((In_QQ==1)&&(CanReadQQ)&&(!In_QQInfo))
							{//can show "read" button
								ReadbtnShow=1;
								display3SoftKeys(TxtRead);
							}
						}
						nqq=0;
						nsms=0;
					}

					break;
				}
				else
#endif	
					if (PcCmdStatus.isPcCmdRun)
				{
					PcCmdStatus.isPcCmdRun=0;
					MmiTrace("read_sms_mt");

					Get_sms_info(sms_text_ascii,&(MtMessage->orig_addr), &(MtMessage->sctp), MtMessage->sc_addr,0);
					break;
				}
				//end of hxl add---------------------------------------

				/* check for the class 0 message */
				alphabet = cmhSMS_getAlphabetPp ( MtMessage->dcs );

				if (alphabet EQ MFW_DCS_7bits)
				{
					static char temp_buffer [MAX_MSG_LEN_ARRAY];

					TRACE_EVENT ("E_SMS_MT");       

					if (MtMessage->dcs & TEXT_COMPRESSED)
					{
						TRACE_EVENT ("text_compressed");    

						/*
						ACI already (in case of 7bit-dcs!) extract the 7 bit to 8 bit,
						so this is what we get and we have just only to decode from
						7Bit-Default to ASCII
						*/   
						//convert in the right format
						/* SH - commented out convert call below - message already decoded by ACI */
						/*SmsRead_convertSMSmsg(Message->sms_msg, MFW_DCS_8bits, Message->msg_len,
										  temp_buffer, MFW_ASCII, MAX_MSG_LEN, FALSE);*/

						addCBCH(MtMessage->sms_msg, IdleNewSmsMessage);                              

					}
					else
					{
						TRACE_EVENT ("text_uncompressed");

						/*
						 assume uncompressed message is ASCII
						*/

						addCBCH(MtMessage->sms_msg, IdleNewSmsMessage);
					}

					//display now on the idle screen
					statusCBCH(TRUE);

				}

				iconsDeleteState(iconIdVoice);		/* Delete voice mail icon.*/
				idleEvent(IdleUpdate);		  /*  update the idle screen.*/   
			}
			/*NM p029 end*/

		}
		break;
	case E_SMS_CB: /* new CBCH received */
		{
			USHORT i;
			BOOL k=FALSE;
			SHORT geograhical_scope = (SHORT)0xC000;

			T_MFW_SMS_CB *Message = (T_MFW_SMS_CB *)w;
			char *tmpsms;

			TRACE_EVENT ("E_SMS_CB");

			memset(temp_buffer, 0,sizeof(temp_buffer));

			//check: does the incoming CB indicates a immediate scope
			if (! (Message->sn & geograhical_scope) )
			{
				//Immediate scope
				// API - 859 - German characters were not visable in the CB message
				TRACE_EVENT("Immediate Scope");

				MmiTrace("e_sms_mt");
				sprintf(buf, "windy: MeMessage->dcs=%d", Message->dcs);
				TRACE_EVENT(buf);
				//dcs'svalue is reference from EL600		
				memset (CBmid, '\0', 5);
				sprintf(CBmid, "%d", Message->msg_id);
				for (i = 0; i < MAXCB; i++)
					if (Message->msg_id==FFS_flashData.msg_id[i])
					{
						k=TRUE;
						break;
					}
				if (k)
				{
					if (Message->dcs==0x11||((Message->dcs&0xec)==0x48))
					{
						tmpsms=mmi_Sim_Sys(Message->cb_msg,Message->msg_len,MFW_DCS_UCS2,MAX_CBMSG_LEN);
						memcpy(temp_buffer, tmpsms,MAX_CBMSG_LEN+3);
					}
					else
					{
						tmpsms=mmi_Sim_Sys(Message->cb_msg,Message->msg_len, MFW_DCS_8bits,MAX_CBMSG_LEN);
						memcpy(temp_buffer, tmpsms,MAX_CBMSG_LEN+3);
					}       

					// API - 859 - Convert the the incoming GSM Text to ASCII
					//SmsRead_convertSMSmsg(Message->cb_msg, MFW_DCS_8bits, Message->msg_len,
					//						  temp_buffer, MFW_ASCII, MAX_CBMSG_LEN, FALSE);

					for (i=0;i <= Message->msg_len;i++)
					{
						//check now for the termination "0x00D"
						//the message is NOT terminated with '\0'
						if (temp_buffer[i] EQ 0x0d)
						{
							temp_buffer[i]='\0';
						}
					}
#ifdef MMI_HOMEZONE_ENABLED		// SH 11/12/01
					/* SPR759 - SH - Homezone: check to see if CB gives us the coordinates of the centre of the current cell */

					if (Message->msg_id==HZ_IDENTIFIER)
					{
						homezoneCBData(Message->cb_msg);
					}
					else
					{
#endif // HOMEZONE

						//display now on the idle screen
						if ( idleIsFocussed()&& (!call_data.win))
						{
							addCBCH(temp_buffer, IdleNewCBImmediateMessage);
							statusCBCH(TRUE);
						}
						k=FALSE;
					}
#ifdef MMI_HOMEZONE_ENABLED
				} /* SPR759 - SH */
#endif
			}
#if 0
			else //Normal scope
			{
				TRACE_EVENT("Normal Scope");
				//only for single- and the last page of mulitpages
				//other pages have not the termination "0x00D"

				// API - 859 - Convert the the incoming GSM Text to ASCII
				SmsRead_convertSMSmsg(Message->cb_msg, MFW_DCS_8bits, Message->msg_len,
									  temp_buffer, MFW_ASCII, MAX_MSG_LEN, FALSE);

				memcpy(Message->cb_msg, temp_buffer, MAX_CBMSG_LEN);

				if ( (Message->pages) EQ (Message->page) )
				{
					for (i=0;i <= (Message->msg_len);i++)
					{
						//check now for the termination "0x00D"
						//the message is NOT terminated with '\0'
						if (Message->cb_msg[i] EQ 0x0d)
						{
							Message->cb_msg[i]='\0';
						}
					}
				}
				else
				{
					Message->cb_msg[MAX_CBMSG_LEN]='\0';
				}

				//indicate on the idle screen the new incoming cb
				addCBCH( NULL, IdleNewCBNormalMessage );
				statusCBCH(TRUE);

				//save the incoming cb messages in the fifo
				sms_new_incoming_cb (Message);

			}
#endif
		}
		break;

	case E_SMS_MEM_FULL:
		/* the memory of SMS is FULL !!*/
		data->sms_store_free = FALSE;

		/* 	    sendevent IDLE_UPDATE; */
		SEND_EVENT(idle_get_window(),IDLE_UPDATE,0,0);
		break;
	case E_SMS_MEM_FREE:
		/* the memory of SMS is FREE */
		data->sms_store_free = TRUE;

		/* 	    sendevent IDLE_UPDATE; */
		SEND_EVENT(idle_get_window(),IDLE_UPDATE,0,0);
		/* ??? */

		break;
	case E_SMS_STATUS: /* status report from service center */
		/* Marcus: Issue 1170: 07/10/2002: Start */
		{
			T_MFW_SMS_STATUS *sms_status = (T_MFW_SMS_STATUS *)w;
			char text_8bit[50];	 //buffer for conversion from 7bit to 8bit
			USHORT* unicodeStr; 
			USHORT* txtStr;
			int uIndex;
			TRACE_EVENT("E_SMS_STATUS");

			currentSMSTone = getcurrentSMSTone();
			// audio_PlaySoundID( AUDIO_BUZZER, currentSMSTone, 200, 0 );

			if (Mmi_getCurrentLanguage() == CHINESE_LANGUAGE)
			{
				memset(status_report, '\0', sizeof(status_report));
				memset (text_8bit, 0, sizeof(text_8bit));
				sprintf(text_8bit,"%0u%0u/%0u%0u/%0u%0u %0u%0u:%0u%0u:%0u%0u \n",
						sms_status->rctp.year[0],
						sms_status->rctp.year[1],
						sms_status->rctp.month[0],
						sms_status->rctp.month[1],
						sms_status->rctp.day[0],
						sms_status->rctp.day[1],
						sms_status->rctp.hour[0],
						sms_status->rctp.hour[1],
						sms_status->rctp.minute[0],
						sms_status->rctp.minute[1],
						sms_status->rctp.second[0],
						sms_status->rctp.second[1]
					   );
				AscEx_To_Unicode((char* )text_8bit, (char*)status_report );
				memset (text_8bit, 0, sizeof(text_8bit));
				unicodeStr =charPtrToUSHORTPtr(text_8bit);
				uIndex = 0;
				txtStr = charPtrToUSHORTPtr(MmiRsrcGetText(smsidle_sr_status_to_text_id(sms_status->status)));
				while ((*txtStr!= 0) && (uIndex*2 <50))
				{
					unicodeStr[uIndex] = *txtStr;
					txtStr++;
					uIndex++;
				}
				wstrcat(USHORTPtrToCharPtr(unicodeStr),":");
				wstrcat(status_report, text_8bit);
				if (sms_status->addr.ton == MFW_TON_INTERNATIONAL)
					wstrcat(status_report, "+");
				wstrcat(status_report, sms_status->addr.number);
				if ((!call_data.win)) //idleIsFocussed()&& (!call_data.win))
				{
					StartPlayByReason(SMSPLAY,0);
					addCBCH(status_report, IdleNewSmsMessage);
					//display now on the idle screen
					statusCBCH(TRUE);
				}
				/*
					 * There is no support for Chinese in the addCBCH function,
					 * so will be problems with class 0 SMS messages and with cell
					 * broadcast messages that need to be addressed anyway.
					 * A new issue will be raised to handle this problem.
					 */
			}
			else
			{
				memset(status_report, '\0', sizeof(status_report));
				sprintf(status_report,"%0u%0u/%0u%0u/%0u%0u %0u%0u:%0u%0u:%0u%0u \n",
						sms_status->rctp.year[0],
						sms_status->rctp.year[1],
						sms_status->rctp.month[0],
						sms_status->rctp.month[1],
						sms_status->rctp.day[0],
						sms_status->rctp.day[1],
						sms_status->rctp.hour[0],
						sms_status->rctp.hour[1],
						sms_status->rctp.minute[0],
						sms_status->rctp.minute[1],
						sms_status->rctp.second[0],
						sms_status->rctp.second[1]
					   );
				//strcpy(status_report, MmiRsrcGetText(TxtSRR));
				//strcat(status_report, ": ");
				//strcpy(status_report, MmiRsrcGetText(TxtStatus));
				//strcat(status_report, ": ");
				strcat(status_report, MmiRsrcGetText(smsidle_sr_status_to_text_id(sms_status->status)));
				strcat(status_report, ": ");
				//sprintf(&status_report[strlen(status_report)], " (%u): ", sms_status->status);
#ifdef NO_ASCIIZ
				//if (sms_status->addr.len)
				//{
				// memcpy(&status_report[strlen(status_report)], sms_status->addr.tag, sms_status->addr.len);
				//   strcat(status_report, "\n");
				//}
#else
				if (strlen(sms_status->addr.tag))
				{
					strcat(status_report, sms_status->addr.tag);
					strcat(status_report, " ");
				}
#endif
				if (sms_status->addr.ton == MFW_TON_INTERNATIONAL)
					strcat(status_report, "+");
				strcat(status_report, sms_status->addr.number);
				if ((!call_data.win))// idleIsFocussed()&& (!call_data.win))
				{
					StartPlayByReason(SMSPLAY,0);
					addCBCH(status_report, IdleNewSmsMessage);
					//display now on the idle screen
					statusCBCH(TRUE);
				}
			}
		}
		/* Marcus: Issue 1170: 07/10/2002: End */
		break;
	case E_SMS_MEM:	/* indicates status of memory */
		{   
#if 0
			int TxtToShow;
			memcpy(&l_sms_mem, (T_MFW_SMS_MEM_INFO*)w, sizeof(T_MFW_SMS_MEM_INFO));
			//sprintf(tempString, "used:%d\ntotal:%d",(int)l_sms_mem.used,(int)l_sms_mem.total);

			/* retrieve he status of the book, and create a string for output
			based on the status
			*/
			buf == '\0';
			TxtToShow = TxtUsed;
			sprintf( buf, "%d/%d", (int)l_sms_mem.used,(int)l_sms_mem.total );

			{
				T_DISPLAY_DATA display_info;
				dialog_info_init(&display_info);//gdy add
				display_info.KeyEvents    =  KEY_RIGHT|KEY_CLEAR;
				display_info.TextId       = TxtToShow;
				display_info.TextString2  = buf;
				display_info.RightSoftKey  = TxtSoftBack;
				display_info.Time         = THREE_SECS;//FOREVER;
				/* Call Info Screen */
				info_dialog( data->win, &display_info );}
#endif
		}
		break;
	case E_SMS_MO: /* SMS sending has started */
		{
			/* not used */
			//hxl add for pc get the msg 20021030----------------------------
			T_MFW_SMS_MO *MoMessage = (T_MFW_SMS_MO *) w;
			char *tmpsms;           

			if (PcCmdStatus.isPcCmdRun)
			{
				PcCmdStatus.isPcCmdRun=0;
				MmiTrace("read_sms_mo");

				memset(sms_text_ascii, 0, sizeof(sms_text_ascii));
				if (MoMessage->dcs==0x08 ||MoMessage->dcs==0x18)
				{
					tmpsms=mmi_Sim_Sys(MoMessage->sms_msg,MoMessage->msg_len,  MFW_DCS_UCS2,MAX_MSG_LEN);
					memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
				}
				else
				{
					//windy modify here according NOKIA's short message ,if sms is all ASCII it must be 8bits code.
					tmpsms=mmi_Sim_Sys(MoMessage->sms_msg,MoMessage->msg_len,MFW_DCS_8bits,MAX_MSG_LEN);
					memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
				}

				Get_sms_info(sms_text_ascii,&(MoMessage->dest_addr), &(MoMessage->vp_abs), MoMessage->sc_addr, 0);
				break;
			}
			break;
		}
	case E_SMS_MO_AVAIL:
		MmiTrace("e_sms_ok");
		if (PcCmdStatus.isPcCmdRun)
		{
			PcCmdStatus.isPcCmdRun=0;
			save_send_sms(MFW_SMS_SUBMIT_SENT);
		}
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
		else if (QQsend.QQsendmsg)
		{
			SentQQ_CB(send_ok);
		}
#endif
		break;
		//end of hxl add---------------------------------------
	case E_SMS_OK:
		/* Only happens when an SMS message is deleted. */
		MmiTrace("e_sms_ok");
		if (PcCmdStatus.isPcCmdRun)
		{
			PcCmdStatus.isPcCmdRun=0;
			PcCmdStatus.isdelsmsok=1;
		}
		break;
	case E_SMS_BUSY:
		TRACE_EVENT ("E_SMS_BUSY");    
		break;
	case E_SMS_SAVE_AVAIL:
		MmiTrace("e_sms_save_ok");
		if (PcCmdStatus.isPcCmdRun)
		{
			PcCmdStatus.isPcCmdRun=0;

			if (command==SAVE_SEND_SMS)
				send_sms_cb();
		}
		break;
	case E_SMS_CMD_AVAIL:
		break;
	case E_SMS_ERR:
		TRACE_EVENT ("E_SMS_ERR");    
		MmiTrace("e_sms_err");
		if (PcCmdStatus.isPcCmdRun)
		{
			PcCmdStatus.isPcCmdRun=0;
			PcCmdStatus.iscmdreterr=1;

			if (command==SEND_SMS_CMD)
				save_send_sms(MFW_SMS_SUBMIT);
			else if (command==SAVE_SEND_SMS)
				send_sms_cb();
		}
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
		else if (QQsend.QQsendmsg)
		{
			SentQQ_CB(send_fail); 
		}
#endif

		break;
	default:
		TRACE_EVENT("unhandled event in smsidle_sms_cb()");
		return MFW_EVENT_PASSED;
	}
	return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	smsidle_get_memory_full

 $Description:	Call back function for the sms Idle window.
 
 $Returns:		sms memory status.

 $Arguments:	none
 
*******************************************************************************/

BOOL smsidle_get_memory_full(void)
{
	return(!smsidle_data.sms_store_free);
}

/*******************************************************************************

 $Function:    	smsidle_get_new_cb_messages_count

 $Description:	Call back function for the sms Idle window.
 
 $Returns:		sms count.

 $Arguments:	none
*******************************************************************************/

SHORT smsidle_get_new_cb_messages_count(void)
{
	if (smsidle_get_ready_state())
	{
		return smscb_get_new_cb_messages_count();
	}
	else
	{
		return 0;
	}
}


/*******************************************************************************

 $Function:    	smsidle_get_ready_state

 $Description:	This function can be call from anywhere to get the information 
				about the "sms_initialised"
 
 $Returns:		sms status

 $Arguments:	none
 
*******************************************************************************/
BOOL smsidle_get_ready_state(void)
{
#ifdef _VIRTUAL_SIM_
	return TRUE;
#endif
	if (smsidle_data.sms_initialised )//&& !no_wait)//added by windy for wait phonebook's ready
		return TRUE;
	else
		return FALSE;
}

//GW SPR#1035 - Added SAT changes
/*******************************************************************************

 $Function:    	smsidle_unset_ready_state

 $Description:	this unset the flat "sms_initialised"
 
 $Returns:		sms status

 $Arguments:	none
 
*******************************************************************************/
void smsidle_unset_ready_state(void)
{
	smsidle_data.sms_initialised = FALSE;
}

/*******************************************************************************

 $Function:    	smsidle_get_unread_sms_available

 $Description:	This function allows an external process to determine the
				received and unread SMS PP message status.
 
 $Returns:		sms status.

 $Arguments:	none
 
*******************************************************************************/
BOOL smsidle_get_unread_sms_available(void)
{   SHORT unread_sms_count;
	TRACE_FUNCTION("smsidle_get_unread_sms_available() ");
	if (smsidle_get_ready_state())
	{
		iconsSetState(iconIdSMS);//2004/03/11 Sunny add      
		unread_sms_count = sms_message_count(MFW_SMS_UNREAD);
		return(unread_sms_count > 0 && (unread_sms_count > sms_message_count(MFW_SMS_VOICE)));
	}
	else
	{
		iconsDeleteState(iconIdSMS);//2004/03/11 Sunny add
		return FALSE;
	}
}

/*******************************************************************************

 $Function:    	smsidle_display_sms_status

 $Description:	Interogates the SMS unread message count and displays
				the result using the SMS icon and an information text.
 
 $Returns:		id of text string to be displayed 

 $Arguments:	noOfMsgs - returns number of unread messages (or 0 if there are no
					messages or the memory is full).

  GW 02/10/01 - Modified code to work with chinese unicode text.
*******************************************************************************/
int smsidle_display_sms_status(int* noOfMsgs)
{
	SHORT SmsMsgCount;
	SHORT SmsVmailCount;
	int txtMsg;

	TRACE_FUNCTION("smsidle_display_sms_status()  ");
	*noOfMsgs = 0;
	txtMsg = TxtNull;

#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
	if ((QQsend.QQCheck)||(QQReadNewSms))//hxl add for forbid when qq is check ,show sms2002-1-7
		return(txtMsg);
#endif

	if (smsidle_get_ready_state())
	{
		SmsVmailCount = sms_message_count(MFW_SMS_VOICE);
		//sms_get_memset();

//	    if ((SmsVmailCount != 0) /* || (SmsData.ReceivedSmsPp.dcs == SET_VMAIL_ACTIVE) rsa??? */)
//		{
//		    iconsSetState(iconIdVoice);
//		}
//	    else
//		{
//		    iconsDeleteState(iconIdVoice);
//		}		
		SmsMsgCount = sms_message_count (MFW_SMS_UNREAD);

		//2004-04-21 Sunny add for changing the prority of the new sms and sms full
		if (smsidle_get_memory_full()||(memory.used==memory.total  &&  memory.total != 0))//
		{			
			txtMsg =  TxtSmsFull;	
			if(SmsMsgCount > 0)
			{
				iconsSetState(iconIdSMS);				
			}else
			{
				iconsDeleteState(iconIdSMS);
			}
		}
		else if ((SmsMsgCount > 0) && (SmsMsgCount > SmsVmailCount))
		{			
			if (playdelaysmstone)
			{
				StartPlayByReason(SMSPLAY,0);
				playdelaysmstone=0;
			}
			txtMsg = TxtNewMessage;
			iconsSetState(iconIdSMS);
			*noOfMsgs = SmsMsgCount;
		}
		else
		{
			iconsDeleteState(iconIdSMS);
			txtMsg = TxtNull;
		}
		
		//2004-04-21 Sunny add for changing the prority of the new sms and sms full

#if 0   //2004-04-20 Sunny remove
		if ((SmsMsgCount > 0) && (SmsMsgCount > SmsVmailCount))
		{
//			sprintf(TextString,"%d ", SmsMsgCount);
			if (playdelaysmstone)
			{
				StartPlayByReason(SMSPLAY,0);
				playdelaysmstone=0;
			}
			txtMsg = TxtNewMessage;
		    iconsSetState(iconIdSMS);//2004/03/11 Sunny add      
			*noOfMsgs = SmsMsgCount;
		}
		else if (smsidle_get_memory_full()||(memory.used==memory.total  &&  memory.total != 0))//
		{
		    //iconsSetState(iconIdSMS);//2004/04/15 Sunny remove
			txtMsg =  TxtSmsFull;
		}
		else
		{
			iconsDeleteState(iconIdSMS);//2004/03/11 Sunny add
			txtMsg = TxtNull;
		}
#endif

	//	iconsShow();
	}
	return(txtMsg);
}

/*******************************************************************************

 $Function:    	smsidle_get_unread_smscb_available

 $Description:	This function allows an external process to determine the
				received SMS CB message status.
 
 $Returns:		execution status

 $Arguments:	none
 
*******************************************************************************/
BOOL smsidle_get_unread_smscb_available(void)
{
	if (smsidle_get_ready_state())
		return(smsidle_get_new_cb_messages_count() > 0);
	else
		return FALSE;
}

/*******************************************************************************

 $Function:    	smsidle_display_smscb_status

 $Description:	Interogates the SMS CB message received status and
				returns the resulting string to the caller.
 
 $Returns:		none

 $Arguments:	TextString - Text String
*******************************************************************************/
void smsidle_display_smscb_status(char *TextString)
{
	SHORT count;

	/* count the unread cb messagesc */
	count = smsidle_get_new_cb_messages_count();


	/* the unread CB should have a high priority than */
	/* the class 0 CB	                              */
	if (count > 0)
	{
		sprintf(TextString, "%d %s\0",count, GET_TEXT(TxtNewCbMessage));
		iconsSetState(iconIdSMS);      //2004/03/11 Sunny add

	}
}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : BMI_RDSM           |
| STATE   : code                        ROUTINE :					 | 
+--------------------------------------------------------------------+

  PURPOSE : module entry point

*/

int GetCurrentMemory(MfwMnu* m, MfwMnuItem* i) 
{
	T_MFW_HND       win  = mfwParent(mfw_header());
	int TxtToShow;
	char buf[20];
	T_DISPLAY_DATA display_info;

	MMI_TRACE_EVENT(("<<<talcon,GetCurrentMemory"));

	/* retrieve he status of the book, and create a string for output based on the status */
	if (!smsidle_get_ready_state())
	{
	MMI_TRACE_EVENT(("<<<talcon,GetCurrentMemory--1"));
		info_screen(win, TxtSimNot, TxtPleaseWait, NULL,REMIND_WAITTING); 
		/*dialog_info_init(&display_info);//gdy add
		SmsMenu_loadDialogDefault(&display_info);

		display_info.TextId2	= TxtPleaseWait;
		// Generic function for info messages
		display_info.Time   = ONE_SECS;
		display_info.iconindex =REMIND_WAITTING;//REMIND_NORECORD;
		info_dialog(win, &display_info);*/
	}
	else
	{
	MMI_TRACE_EVENT(("<<<talcon,GetCurrentMemory--2"));
		sms_get_memset();
		// clrobert modify, timestamp 2003-9-22 21:04
		// from
		/*
		buf == '\0';
		*/
		// to
		buf[0] = '\0';
		// modify end
		TxtToShow = TxtUsed;
		sprintf( buf, "%d/%d", (int)memory.used,(int)memory.total );
		dialog_info_init(&display_info);//gdy add
		display_info.KeyEvents    =  KEY_RIGHT|KEY_CLEAR|KEY_HUP;		/* 2004/03/31 sunsj modify */
		display_info.TextId       = NULL;//TxtToShow;
		display_info.TextString2  = NULL;//buf;
		display_info.RightSoftKey  = TxtSoftBack;
		display_info.Time         = FOREVER;
		display_info.Identifier=MMI_MESSAGE_MEMORYSTATE;
		/* Call Info Screen */
		info_dialog( win, &display_info );
	}
	//TRACE_FUNCTION("bmi_rdsm.GetCurrentMemory");

	//if(sms_set_pref_memory(MFW_MEM_SIM)==MFW_SMS_OK)
	//if(sms_get_memset()==MFW_SMS_FAIL)
	//sms_set_pref_memory(MFW_MEM_ME);
	//sms_set_mt_ind(MT_IND_IDX);
	//sms_get_memset();
	return 0;
}


/*******************************************************************************

 $Function:    	SetSmsFull

 $Description:	 
 
 $Returns:		

 $Arguments:	
				
*******************************************************************************/
void SetSmsFull()
{
	smsidle_data.sms_store_free = FALSE;
	// show the info about full sms list on the idle screen
	//idle_data.clean_screen = FALSE;
}
/* Marcus: Issue 1170: 07/10/2002: Start */
/*******************************************************************************

 $Function:    	smsidle_sr_status_to_text_id

 $Description:	Returns the text ID for the given status report status
 
 $Returns:		int : text ID

 $Arguments:	UBYTE: SMS-STATUS-REPORT status
*******************************************************************************/
static int smsidle_sr_status_to_text_id(UBYTE status)
{
	int ret = TxtError;
	UBYTE group = ((status & 0x60) >> 5);
	UBYTE value = (status & 0x1F);
	switch (group)
	{
	case 0:	 // Short message transaction completed
		if ((value >= 3) && (value <= 0x0F))
			ret = TxtError;
		else
			ret	= TxtDelivered;
		break;

	case 1:	// Temporary error, SC still trying to transfer SM
		if ((value >= 6) && (value <= 0x0F))
			ret = TxtError;
		else
			ret	= TxtTempError;
		break;

	case 2:	// Permanent error, SC is not making any more transfer attempts
	case 3:	// Temporary error, SC is not making any more transfer attempts
		ret = TxtError;
		break;
	}
	return ret;
}
/* Marcus: Issue 1170: 07/10/2002: End */




