/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI
 $Module:   SMS
 $File:       MmiSmsMenu.c
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

    Implementation SMS dynamic menu handling

********************************************************************************

 $History: MmiSmsMenu.c

  25/10/00      Original Condat(UK) BMI version.
  09/08         windy modified
 $End

*******************************************************************************/

#define MMI_SMSMENU_C

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_smsi.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"


#include "dspl.h"

#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiMmi.h"

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"
#include "MmiBookShared.h"
#include "MmiSmsMenu.h"
#include "MmiSmsRead.h"
#include "MmiSmsSend.h"
#include "MmiSmsIdle.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
//#include "pcm.h"
#include "mmiusersymbolinput.h"
#include "Mmihost.h"  //xsf add 11.27 for hostkey PRO_MSGBOX

//#define TDTRACE 1
#include "mmiutilapi.h"

extern T_MFW_HND SmsRead_R_start(T_MFW_HND parent_window,T_MFW_SMS_STAT *menuAttr);

// Start functions of the windows
T_MFW_HND M_SND_SAV_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
T_MFW_HND M_DEL_ALL_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
T_MFW_HND M_DEL_ALL_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
T_MFW_HND V_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
//T_MFW_HND V_NUM_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);

// Standard callback function for temporary dialog window
int SmsMenu_StandardDialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
//int SmsMenu_V_NUM_editor_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);

/* This structure is used by 'Delete All' function that is common for SMS and SMS-CB */
typedef enum SmsType
{
  SMS_TYPE, /* interfered with macro -> renamed SMS to SMS_TYPE */
  SMS_NVM_TYPE,	
  SMSCB_TYPE
} MySmsType;


typedef enum              /* numbering plan identifier */
{
  MFW_MB_LINE1      = 1,
  MFW_MB_LINE2      = 2,
  MFW_MB_FAX        = 3,
  MFW_MB_DATA       = 4
} T_MFW_MAILBOX_ID;



typedef enum
{
  SMS_DELETING,
  SMS_DISPLAY,
  SMS_READY
} T_SmsMenu_state;

typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */

    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;

    /* internal data */

  T_SmsUserData * user_data; // text and phone number of the message
} T_M_SND_SAV;

typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;
  T_MFW_HND       waiting_win;

    /* associated handlers */
  T_MFW_HND       sms_hnd;         /* MFW sms handler      */

    /* internal data */

  enum SmsType  type; // The type of the SMS to delete (SMS or SMS-CB)
  T_MFW_SMS_MSG g_SmsMenu_messages[MAX_MESSAGES];
  T_MFW_HND   child_dialog;
} T_M_DEL_ALL;

typedef struct
{
    /* administrative data */
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */
    //T_MFW_HND       kbd;
    //T_MFW_HND       kbd_long;
    //T_MFW_HND       menu;
    T_MFW_HND       voice_edit;

    /* internal data */
	UBYTE voice_mail[PHB_MAX_LEN + 1];
} T_V;

  //UBYTE voice_mail[PHB_MAX_LEN + 1];


typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */


    /* internal data */
    UBYTE voice_number_buffer[NUMBER_LENGTH];

} T_V_NUM;

static T_MFW_HND M_SND_SAV_create (T_MFW_HND parent);
static void M_SND_SAV_destroy (T_MFW_HND window);
static void M_SND_SAV_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int M_SND_SAV_win_cb (MfwEvt e, MfwWin *w);
static int M_SND_SAV_kbd_cb (MfwEvt e, MfwKbd *k);
static int M_SND_SAV_mnu_cb (MfwEvt e, MfwMnu *m);

static int ExeSms_sendM_SND_SAV(MfwMnu *, MfwMnuItem *);

static T_MFW_HND M_DEL_ALL_create (T_MFW_HND parent);
static void M_DEL_ALL_destroy (T_MFW_HND window);
static void M_DEL_ALL_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int M_DEL_ALL_mfw_cb (MfwEvt event, void *parameter);
static int M_DEL_ALL_win_cb (MfwEvt e, MfwWin *w);

static T_MFW_HND V_create (T_MFW_HND parent);
static void V_destroy (T_MFW_HND window);
static void V_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int V_win_cb (MfwEvt e, MfwWin *w);
static int V_kbd_cb (MfwEvt e, MfwKbd *k);
static int V_mnu_cb (MfwEvt e, MfwMnu *m);

//static T_MFW_HND V_NUM_create (T_MFW_HND parent);
//static void V_NUM_destroy (T_MFW_HND window);
//static void V_NUM_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
//static int V_NUM_win_cb (MfwEvt e, MfwWin *w);

void SmsMenu_loadEditDefault(T_EDITOR_DATA *editor_data);
int Delete_NVM_ALL_sms();
int Sms_NVM_DEL_ALL_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
int SmsMenu_standard_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);

// State of the SMS menu management
T_SmsMenu_state g_SmsMenu_state = SMS_DISPLAY;
// Sometime we need to know the handle of a child window (delete all)
MfwHnd g_ChildWindow2;
UBYTE g_CenterNumber[NUMBER_LENGTH];
//extern UINT8 Send_state;
extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13
extern T_call call_data;
extern T_MMI_FLASH_SORT_INDEX Flash_sms_sort_index[FLSAH_SMS_NUM];
/*******************************************************************************

 $Function:     M_exeSendNew

 $Description:  This function is called when the user press Send in the
        main SMS menu.

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_exeSendNew(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_SmsUserData   SmsData;

	if(g_pcsyncstatus)//when pcsync run ,return,hxl add 2003-2-13
		return 1;

    /* Copy the number and name information to the SMS buffer
    */
    SmsData.TextBuffer[0] = '\0';
    SmsData.NumberBuffer[0]='\0'; //set the number to null.
    SmsData.called_from_reply_item = FALSE;
    SmsData.Send_state =E_SEND;
   
    SmsSend_SEND_start(win, (void *) &SmsData);
  return 1;
}
/*******************************************************************************

 $Function:     M_callSendNew

 $Description:  This function is called when the user press Send in the
        call menu.If there is already an old send sms win it will copy buffer to new win

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_callSendNew(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_SmsUserData   SmsData;
    char tempt[40];
    sprintf(tempt,"winsms=%d",call_data.win_sms);
    TRACE_EVENT(tempt);
    if(call_data.win_sms)
    {	
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) call_data.win_sms)->data;
	T_SEND         * data = (T_SEND *)win_data->user;
	memset((char*)SmsData.TextBuffer,0,sizeof(SmsData.TextBuffer));/*wx 2003-04-03 copy buffer from out of call old smssend win*/
    memcpy((char*)SmsData.TextBuffer, (char *)data->edt_data.TextBuffer,sizeof(data->edt_data.TextBuffer));
    memcpy((char*)SmsData.NumberBuffer, (char *)data->edt_data.NumberBuffer,sizeof(data->edt_data.NumberBuffer));
    SmsSend_SEND_destroy(call_data.win_sms);
    SmsData.called_from_reply_item = FALSE;
    SmsData.Send_state =E_CALL_SENDER;   
    SmsSend_SEND_start(win, (void *) &SmsData);
    return 1;
    }
	if(g_pcsyncstatus)//when pcsync run ,return,hxl add 2003-2-13
		return 1;

    /* Copy the number and name information to the SMS buffer
    */
    SmsData.TextBuffer[0] = '\0';
    SmsData.NumberBuffer[0]='\0'; //set the number to null.
    SmsData.called_from_reply_item = FALSE;
    SmsData.Send_state =E_SEND;
   
    SmsSend_SEND_start(win, (void *) &SmsData);
  return 1;
}
/*******************************************************************************

 $Function:     M_exeRead

 $Description:  This function is called when the user press Read in the
          main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/
/*2003/11/28, wangyan delete*/
#if 0
int M_exeRead(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
  T_MFW_SMS_STAT  sms_list_type = MFW_SMS_ALL;

  /* Call the function that manages SMS reading */
  SmsRead_R_start(win, &sms_list_type);

  return 1;
}
#endif
/*******************************************************************************

 $Function:     M_exeDelAll

 $Description:  This function is called when the user press Delete all in the
          main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_exeDelAll(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
  MySmsType sms_type;

  sms_type = SMS_TYPE;
  // Here we have to pass the type of sms to delete (SMS or SMS-CB)
  M_DEL_ALL_start(win, (void *)&sms_type);

  return 1;
}
/*******************************************************************************

 $Function:     M_exeDelNVMAll

 $Description:  This function is called when the user press Delete all in the
          main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_exeDelNVMAll(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
  	MySmsType sms_type;

  sms_type = SMS_NVM_TYPE;
  // Here we have to pass the type of sms to delete (SMS or SMS-CB)
  //M_DEL_ALL_start(win, (void *)&sms_type);
  CheckHostkey2(win, PRO_MSGBOX);  //xsf 11.27
  return 1;
}
/*******************************************************************************

 $Function:     M_exeSendSaved

 $Description:  This function is called when the user press Saved messages
          in the main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_exeSendSaved(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());

  M_SND_SAV_start(win, 0);

  return 1;
}



/*******************************************************************************

 $Function:     voice_mail_init

 $Description:  initialization the voice mail buffer


 $Returns:

 $Arguments:


*******************************************************************************/

int voice_mail_init (void)
{

  //nm, later have to read the voice mail number from FFS after switching-on the mobile

  //to clear the buffer is only temporary until we are able to save on Flash
  //memset(voice_mail, '\0', sizeof(voice_mail));



  return 1;
}




/*******************************************************************************

 $Function:     M_exeVoice

 $Description:  This function is called when the user press Voice Mail
          in the main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_exeVoice(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win;

    T_MFW_HND     parent_window  = mfwParent(mfw_header());

    TRACE_FUNCTION ("M_exeVoice()");

    win = V_create (parent_window);

    if (win NEQ NULL)
  {
      SEND_EVENT (win, E_INIT, V_ID_SET, 0);
  }
  return 1;
}


/*******************************************************************************

 $Function:     M_callVoice

 $Description:  This function is called when the user press set Voice Mail
          in the main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_callVoice(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win;
    T_MFW_HND       parent_win  = mfwParent(mfw_header());


    TRACE_FUNCTION ("M_callVoice()");

    win = V_create (parent_win);

    if (win NEQ NULL)
  {
      SEND_EVENT (win, E_INIT, V_ID_CALL, 0);
  }

  return 1;
}


/*******************************************************************************

 $Function:     M_exeBroadcast

 $Description:  This function is called when the user press Cell Broadcast
          in the main SMS menu.

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int M_exeBroadcast(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());

  //windy smscb_M_CB_start(win, 0);

  return 1;
}


/*******************************************************************************

 $Function:     ExeSms_sendM_SND_SAV

 $Description:  Called when the user press Saved SMS from the Send SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

static int ExeSms_sendM_SND_SAV(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());

  // Copy the selected saved message (text and phone number) into user data TBD

  // smssend_txtedt_start(win, NULL);
    return 1;
}

/*******************************************************************************

 $Function:     M_SND_SAV_start

 $Description:  Start the creation of the saved SMS menu window

 $Returns:    Execution status

 $Arguments:  parent_window - parent window
        menuAttr - Menu attributes.

*******************************************************************************/

T_MFW_HND M_SND_SAV_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("M_SND_SAV_start()");

    win = M_SND_SAV_create (parent_window);

    if (win NEQ NULL)
  {
      SEND_EVENT (win, E_INIT, M_SND_SAV_ID, (void *)menuAttr);
  }
    return win;
}

/*******************************************************************************

 $Function:     M_SND_SAV_create

 $Description:  Create the saved SMS menu window

 $Returns:    Execution status

 $Arguments:  parent_window - parent window

*******************************************************************************/

static T_MFW_HND M_SND_SAV_create(MfwHnd parent_window)
{
    T_M_SND_SAV      * data = (T_M_SND_SAV *)ALLOC_MEMORY (sizeof (T_M_SND_SAV));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("M_SND_SAV_create()");

    /*
     * Create window handler
     */

    data->win =
  win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)M_SND_SAV_win_cb);
    if (data->win EQ NULL)
  {
      return NULL;
  }
    /*
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)M_SND_SAV_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    return data->win;
}

/*******************************************************************************

 $Function:     M_SND_SAV_destroy

 $Description:  Destroy the saved SMS menu window

 $Returns:    none

 $Arguments:  own_window - current window

*******************************************************************************/

static void M_SND_SAV_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_M_SND_SAV     * data;

    TRACE_FUNCTION ("M_SND_SAV_destroy()");

    if (own_window)
  {
      win_data = ((T_MFW_HDR *)own_window)->data;
      data = (T_M_SND_SAV *)win_data->user;

      if (data)
    {
        /*
         * Delete WIN handler
         */
        win_delete (data->win);

        /*
         * Free Memory
         */
        FREE_MEMORY ((void *)data->user_data, sizeof (T_SmsUserData));
      FREE_MEMORY ((void *)data, sizeof (T_M_SND_SAV));
    }
      else
    {
        TRACE_EVENT ("M_SND_SAV_destroy() called twice");
    }
  }
}

/*******************************************************************************

 $Function:     M_SND_SAV_exec_cb

 $Description:  Exec callback for the saved SMS menu window

 $Returns:    none

 $Arguments:  win - current window
        event - window event id
        value - Unique Id
        parameter - optional data.

*******************************************************************************/

void M_SND_SAV_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
    /* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_M_SND_SAV          * data = (T_M_SND_SAV *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;

    TRACE_FUNCTION ("M_SND_SAV_exec_cb()");

    switch (event)
  {
  case E_INIT:
      /* initialization of administrative data */
      data->id = value;
    data->user_data = (T_SmsUserData *)ALLOC_MEMORY (sizeof (T_SmsUserData));
    data->user_data->TextBuffer[0] = '\0';
    data->user_data->NumberBuffer[0] = '\0';

      /* initialization of the dialog data */

      /* create the dialog handler */
      data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)M_SND_SAV_kbd_cb);
      data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)M_SND_SAV_kbd_cb);

      /* put the (new) dialog window on top of the window stack */
      mnuUnhide(data->menu);
        winShow(win);
      break;
  case E_ABORT:
  case E_EXIT:
      l_parent = data->parent;
      l_id = data->id;
      M_SND_SAV_destroy(data->win);
      SEND_EVENT (l_parent, event, l_id, NULL); /* forward event to parent */
      break;

  case E_RETURN:
  default:
      return;
  }
}

/*******************************************************************************

 $Function:     M_SND_SAV_mnu_cb

 $Description:  Menu callback for the saved SMS menu window

 $Returns:    Execution status

 $Arguments:  e - event id
        m - menu handle

*******************************************************************************/

static int M_SND_SAV_mnu_cb (MfwEvt e, MfwMnu *m)
    /* M_SND_SAV menu event handler */
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_M_SND_SAV      * data = (T_M_SND_SAV *)win_data->user;
    T_MFW_HND  * l_parent;
    SHORT        l_id;

    TRACE_FUNCTION ("M_SND_SAV_mnu_cb()");

    switch (e)
        {
  case E_MNU_ESCAPE: /* back to previous menu */
      l_parent = data->parent;
      l_id = data->id;
      M_SND_SAV_destroy(data->win);
      SEND_EVENT (data->parent, E_RETURN, data->id, NULL);
      break;
  default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
      return MFW_EVENT_REJECTED;
        }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     M_SND_SAV_win_cb

 $Description:  Window callback for the saved SMS menu window

 $Returns:    Execution status

 $Arguments:  e - event id
        m - window handle

*******************************************************************************/

static int M_SND_SAV_win_cb (MfwEvt e, MfwWin *w)
    /* M_SND_SAV window event handler */
{
    TRACE_FUNCTION ("M_SND_SAV_win_cb()");

    switch (e)
  {
        case MfwWinVisible:  /* window is visible  */
      displaySoftKeys(TxtSoftSelect,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
	  draw_softkeybar_updown_arrow();//jhxu720
#endif
      break;
  case MfwWinFocussed: /* input focus / selected   */
  case MfwWinDelete:   /* window will be deleted   */
        default:
      return MFW_EVENT_REJECTED;
  }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     M_SND_SAV_kbd_cb

 $Description:  Keyboard callback for the saved SMS menu window

 $Returns:    Execution status

 $Arguments:  e - event id
        k - keyboard info

*******************************************************************************/

static int M_SND_SAV_kbd_cb (MfwEvt e, MfwKbd *k)
    /* M_SND_SAV keyboard event handler */
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_M_SND_SAV      * data = (T_M_SND_SAV *)win_data->user;

    TRACE_FUNCTION ("M_SND_SAV_kbd_cb()");

    if (e & KEY_LONG)
  {
      switch (k->code)
    {
    case KCD_HUP: /* back to previous menu */
        mnuEscape(data->menu);
        break;
    case KCD_RIGHT: /* Power Down */
        return MFW_EVENT_REJECTED; /* handled by idle */
    default: /* no response to all other keys */
        return MFW_EVENT_CONSUMED;
    }
  }
    else
  {
      switch (k->code)
    {
    case KCD_MNUUP: /* highlight previous entry */
        mnuUp(data->menu);
        winShow(win);
        break;
    case KCD_MNUDOWN: /* highlight next entry */
        mnuDown(data->menu);
        winShow(win);
        break;
    case KCD_LEFT: /* activate this entry */
	case KCD_OK:
        mnuSelect(data->menu);
        break;
    case KCD_HUP: /* back to previous menu */
    case KCD_RIGHT: /* back to previous menu */
        mnuEscape(data->menu);
        break;
    default: /* no response to all other keys */
        return MFW_EVENT_CONSUMED;
    }
  }
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:     M_DEL_ALL_start

 $Description:  Start the delete all window dialog.

 $Returns:    window handler

 $Arguments:  parent_window - parent window
        menuAttr - Menu attributes.

*******************************************************************************/

T_MFW_HND M_DEL_ALL_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("M_DEL_ALL_start()");

    win = M_DEL_ALL_create (parent_window);

    if (win NEQ NULL)
  {
      SEND_EVENT (win, E_INIT, M_DEL_ALL_ID, (void *)menuAttr);
  }
    return win;
}

/*******************************************************************************

 $Function:     M_DEL_ALL_create

 $Description:  Create the delete all window

 $Returns:    window handler

 $Arguments:  parent_window - parent window

*******************************************************************************/

static T_MFW_HND M_DEL_ALL_create(MfwHnd parent_window)
{
    T_M_DEL_ALL      * data = (T_M_DEL_ALL *)ALLOC_MEMORY (sizeof (T_M_DEL_ALL));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("M_DEL_ALL_create()");

    /*
     * Create window handler
     */

    data->win =  win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)M_DEL_ALL_win_cb);
    if (data->win EQ NULL)
  {
      return NULL;
  }
    /*
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)M_DEL_ALL_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    return data->win;
}

/*******************************************************************************

 $Function:     M_DEL_ALL_destroy

 $Description:  Destroy the delete all window

 $Returns:    none

 $Arguments:  own_window - current window

*******************************************************************************/

static void M_DEL_ALL_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_M_DEL_ALL     * data;

    TRACE_FUNCTION ("M_DEL_ALL_destroy()");

    if (own_window)
  {
      win_data = ((T_MFW_HDR *)own_window)->data;
      data = (T_M_DEL_ALL *)win_data->user;

     if (data)
     {
        /*
         * Delete WIN handler
         */
      if(data->type==SMS_TYPE)
		sms_delete(data->sms_hnd);

      if (data->waiting_win)
      {
        SEND_EVENT(data->waiting_win,DIALOG_DESTROY,0,0 );
        data->waiting_win = 0;
      }

        win_delete (data->win);

        /*
         * Free Memory
         */
        FREE_MEMORY ((void *)data, sizeof (T_M_DEL_ALL));
    }
      else
    {
        TRACE_FUNCTION ("M_DEL_ALL_destroy() called twice");
    }
  }
}

/*******************************************************************************

 $Function:     M_DEL_ALL_exec_cb

 $Description:  Exec callback function for the Delete All window

 $Returns:    none

 $Arguments:  win - current window
        event - event id
        value - Unique id
        parameter - optional data.

*******************************************************************************/

void M_DEL_ALL_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
    /* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_M_DEL_ALL    * data = (T_M_DEL_ALL *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;
  T_MFW_EVENT      MfwEvents;

    T_DISPLAY_DATA  DisplayInfo;

    TRACE_FUNCTION ("M_DEL_ALL_exec_cb()");

//dialog_info_init(&DisplayInfo);//gdy add
    switch (event)
  {
  case E_INIT:
      /* initialization of administrative data */
      data->id = value;

      /* initialization of the dialog data */
   	 data->type = *(enum SmsType *)parameter;
     dialog_info_init(&DisplayInfo);//gdy add
     if(data->type==SMS_TYPE)
     {
    	MfwEvents = E_SMS_MO_AVAIL | E_SMS_ERR | E_SMS_OK;
    	data->sms_hnd = sms_create(data->win,MfwEvents,(MfwCb)M_DEL_ALL_mfw_cb);

    	/* create the dialog handler */
    	// Display the dialog window to delete all the SMS
    	SmsMenu_loadDialogDefault(&DisplayInfo);

    	//NM 29.8 Check before deleting, is SIM ready ?!  */
    	if (!smsidle_get_ready_state())
    	{
      		DisplayInfo.TextId2     = TxtPleaseWait;
      		DisplayInfo.iconindex =REMIND_WAITTING;//REMIND_NORECORD;
      		DisplayInfo.Identifier = SMSMENU_ID_NOTREADY;
      	}
    	else
    	{
/*2004/5/20, wy modify*//*    	
    		DisplayInfo.TextId2       = TxtDeleteAll;//TxtOkToDelete;
     	 	DisplayInfo.Time         = FOREVER;
     	 	DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
    	 	DisplayInfo.Identifier   = SMSMENU_ID_DELETEALL;
     	 	DisplayInfo.LeftSoftKey  = TxtSoftOK;
     	 	DisplayInfo.RightSoftKey  = TxtSoftBack;
       	DisplayInfo.iconindex	 =REMIND_REQUIRE;*/
/*2004/5/20, wy modify*/
    	  	g_ListLength2 = sms_message_list(MFW_SMS_ALL, data->g_SmsMenu_messages, MAX_MESSAGES);
		if (g_ListLength2==0)
		{
      			DisplayInfo.TextId2     = TxtNoMessages;
	      		DisplayInfo.Identifier  = SMSMENU_ID_NOMESSAGES;
     		 	DisplayInfo.Time         = ONE_SECS;
     	 		DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
	     	 	DisplayInfo.LeftSoftKey  =0;
     		 	DisplayInfo.RightSoftKey  = 0;
       		DisplayInfo.iconindex	 =REMIND_NORECORD;
       	}
	 	else
    		{
     	 	DisplayInfo.TextId2       = TxtDeleteAll;//TxtOkToDelete;
     	 	DisplayInfo.Time         = FOREVER;
     	 	DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
    	 	DisplayInfo.Identifier   = SMSMENU_ID_DELETEALL;
     	 	DisplayInfo.LeftSoftKey  = TxtSoftOK;
     	 	DisplayInfo.RightSoftKey  = TxtSoftBack;
       		DisplayInfo.iconindex	 =REMIND_REQUIRE;
    	}
	}
    	// Generic function for info messages
        (void) info_dialog(win, &DisplayInfo);
     }
     else if ( data->type==SMS_NVM_TYPE )
     {
    	/* create the dialog handler */
    	// Display the dialog window to delete all the SMS
        if (FlashSMStotal==0)
    	{
      		DisplayInfo.TextId2     = TxtNoMessages;
      		DisplayInfo.Identifier  = SMSMENU_ID_NOMESSAGES;
  		 	DisplayInfo.Callback     = (T_VOID_FUNC)SmsMenu_standard_dialog_cb;
     	 	DisplayInfo.Time         = ONE_SECS;
     	 	DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
     	 	DisplayInfo.LeftSoftKey  =0;
     	 	DisplayInfo.RightSoftKey  = 0;
       		DisplayInfo.iconindex	 =REMIND_NORECORD;
       }
        else
        {
 	 	 	DisplayInfo.TextId2       = TxtDeleteAll;//TxtOkToDelete;
     	 	DisplayInfo.Time         = FOREVER;
     	 	DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
     	 	DisplayInfo.Identifier   = SMSMENU_ID_DELETEALL;
     	 	DisplayInfo.LeftSoftKey  = TxtSoftOK;
     	 	DisplayInfo.RightSoftKey  = TxtSoftBack;
       		DisplayInfo.iconindex	 =REMIND_REQUIRE;
  		 	DisplayInfo.Callback     = (T_VOID_FUNC)Sms_NVM_DEL_ALL_dialog_cb;
        }
         (void) info_dialog(win, &DisplayInfo);
    }
     winShow(win);
    break;

  case E_ABORT:
  case E_EXIT:
      l_parent = data->parent;
      l_id = data->id;
      M_DEL_ALL_destroy (data->win);
      //NM SEND_EVENT (l_parent, E_EXIT, l_id, NULL); /* forward event to parent */
      break;

  case E_RETURN:
  default:
      return;
  }
}

/*******************************************************************************

 $Function:     M_DEL_ALL_win_cb

 $Description:  Window callback function for the delete all window

 $Returns:    none

 $Arguments:  e - current window
        w - event id

*******************************************************************************/

static int M_DEL_ALL_win_cb (MfwEvt e, MfwWin *w)
    /* V window event handler */
{
    TRACE_FUNCTION ("M_DEL_ALL_win_cb()");

    switch (e)
  {
        case MfwWinVisible:  /* window is visible  */
 		displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
      break;
  case MfwWinFocussed: /* input focus / selected   */
  case MfwWinDelete:   /* window will be deleted   */
        default:
      return MFW_EVENT_REJECTED;
  }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     M_DEL_ALL_mfw_cb

 $Description:  Exec callback function for the DEL_ALL window


 $Returns:    none

 $Arguments:  event - event id
        parameter - optional data.

*******************************************************************************/

int M_DEL_ALL_mfw_cb (MfwEvt event, void *parameter)
{
    T_MFW_HND         win       = mfwParent((MfwHdr *)mfw_header());
    T_MFW_WIN   * win_data = ((T_MFW_HDR *)win)->data;
    T_M_DEL_ALL     * data = (T_M_DEL_ALL *)win_data->user;
    T_MFW_HND      *lparent = data->parent;
  T_MFW_EVENT       MfwEvents;


  T_DISPLAY_DATA DisplayInfo;

    TRACE_FUNCTION ("M_DEL_ALL_ACK_mfw_cb()");

    switch (event)
  {

  case E_SMS_ERR:

    g_SmsMenu_state = SMS_READY;

      /* destroy the dialog at first           */
    //SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0,NULL);
      /* Display "All SMS deleted" and after timeout go back to parent */
     dialog_info_init(&DisplayInfo);//gdy add
    SmsMenu_loadDialogDefault(&DisplayInfo);
    DisplayInfo.Identifier = SMSMENU_ID_DELERR;
    DisplayInfo.TextId2     = TxtFailed;
    DisplayInfo.iconindex    =REMIND_FAILURE;
    info_dialog(win,&DisplayInfo);


    break;

  case E_SMS_OK:
	  //g_ListLength2 = sms_message_list(MFW_SMS_ALL, data->g_SmsMenu_messages, MAX_MESSAGES);
    if (g_ListLength2 > 0)
    {
      g_ListLength2--;

      sms_msg_delete(data->g_SmsMenu_messages[g_ListLength2].index);
    }
    else
    {
      /* there is now anymore sms to delete !! */

     //g_SmsMenu_state = SMS_READY;
      /* go now back to the parent             */
        /* destroy the dialog at first           */
      //SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0,NULL);
        /* Display "All SMS deleted" and after timeout go back to parent */
      #if 0//add this dialog will cause restart so shell it temporaryly by windy
      SmsMenu_loadDialogDefault(&DisplayInfo);
      DisplayInfo.Identifier = SMSMENU_ID_DELOK;
      DisplayInfo.TextId     = TxtDeleted;
    DisplayInfo.iconindex    =REMIND_SUCCEED;
      info_dialog(win,&DisplayInfo);
      #endif
      #if 1/*2004/5/20, wangyan modify*/
      SmsMenu_loadDialogDefault(&DisplayInfo);
      DisplayInfo.Identifier = SMSMENU_ID_DELOK;
      DisplayInfo.TextId     = TxtDeleted;
    DisplayInfo.iconindex    =REMIND_SUCCEED;
      info_dialog(win,&DisplayInfo);
      #endif
       M_DEL_ALL_destroy(win);
      /* Send E_RETURN event to parent of M_DEL_ALL */
      SEND_EVENT (lparent, E_RETURN, data->id, NULL); /* forward event to parent */
    }

    break;

  default:
      return MFW_EVENT_REJECTED;

  }
    return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:     V_start

 $Description:  Start the voice mailbox dialog window.


 $Returns:    window handle

 $Arguments:  parent_window - parent window handle
        menuAttr - Menu attributes

*******************************************************************************/

T_MFW_HND V_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("V_start()");

    win = V_create (parent_window);

    if (win NEQ NULL)
  {
      SEND_EVENT (win, E_INIT, V_ID_SET, (void *)menuAttr);
  }
    return win;
}

/*******************************************************************************

 $Function:     V_create

 $Description:  create the voice mailbox window

 $Returns:    window handle

 $Arguments:  parent_window - parent window handle

*******************************************************************************/

static T_MFW_HND V_create(MfwHnd parent_window)
{
    T_V      * data = (T_V *)ALLOC_MEMORY (sizeof (T_V));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("V_create()");

    /*
     * Create window handler
     */

    data->win =
  win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)V_win_cb);
    if (data->win EQ NULL)
  {
      return NULL;
  }
    /*
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)V_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    return data->win;
}

/*******************************************************************************

 $Function:     V_destroy

 $Description:  Destroy the voice mailbox window

 $Returns:    none

 $Arguments:  own_window - current window

*******************************************************************************/

static void V_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_V     * data;

    TRACE_FUNCTION ("V_destroy()");

    if (own_window)
  {
      win_data = ((T_MFW_HDR *)own_window)->data;
      data = (T_V *)win_data->user;

      if (data)
    {
        /*
         * Delete WIN handler
         */
		if (data->voice_edit)
	  		editor_destroy(data->voice_edit);
        win_delete (data->win);

        /*
         * Free Memory
         */
        FREE_MEMORY ((void *)data, sizeof (T_V));
    }
      else
    {
        TRACE_FUNCTION ("V_destroy() called twice");
    }
  }
}

/*******************************************************************************

 $Function:     V_exec_cb

 $Description:  Exec callback function for the voice mailbox window

 $Returns:    none

 $Arguments:  win - current window
        event - event id
        value - Unique id
        parameter - optional data.

*******************************************************************************/

void V_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
    /* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_V          * data = (T_V *)win_data->user;

  char mail_alpha[10+1] = ""; // size hard coded in pcm.h

    T_EDITOR_DATA editor_data;

    TRACE_FUNCTION ("V_exec_cb()");

  switch (event)
  {
    // On exit from the editor, we try again to call the number
    case E_INIT:

      if ( (value EQ V_ID_SET) )
      {
      /* initialization of administrative data */
      data->id = value;
//nm, later have to save the voicemail number on FFS  !!!

//      if (SmsRead_convertMailbox(MFW_MB_LINE1, (char *)data->FFS_flashData.voice_mail, mail_alpha) == TRUE)
        // If there is a voice mail number stored in PCM, we call it directly
//        callNumber(data->FFS_flashData.voice_mail);
  //    else
        // Open an editor to enter the number
//      {
			memset(data->voice_mail,0,sizeof(data->voice_mail));
      		memcpy(data->voice_mail,FFS_flashData.voice_mail,PHB_MAX_LEN);
        	SmsMenu_loadEditDefault(&editor_data);
			editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtVoicemail,(char*)data->voice_mail,PHB_MAX_LEN,edtCurBar1);
			editor_data.edtInPbk           = 0;
			editor_data.LeftSoftKey          = TxtSave;
			editor_data.AlternateLeftSoftKey = TxtNull;
			editor_data.RightSoftKey         = TxtDelete;
			editor_data.Identifier           = value ; 
			editor_data.destroyEditor		 = FALSE;
			editor_data.mode=PHONENUMONLY_MODE	;
			data->voice_edit=editor_start(data->win, &editor_data);  /* start the editor */ 
        	winShow(win);
//      }
      }
      else
      {
        if (value EQ V_ID_CALL)
        {
	        SmsMenu_loadEditDefault(&editor_data);
      		memcpy(data->voice_mail,FFS_flashData.voice_mail,PHB_MAX_LEN);
			editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtVoicemail,(char*)data->voice_mail,PHB_MAX_LEN,edtCurBar1);
			editor_data.edtInPbk           = 0;
            //if((FFS_flashData.voice_mail[0] != '\0') )        
			editor_data.LeftSoftKey          = TxtSoftCall;
			editor_data.AlternateLeftSoftKey = TxtNull;
			editor_data.RightSoftKey         = TxtDelete;
			editor_data.Identifier           = value ; 
			editor_data.destroyEditor		 = FALSE;
			editor_data.mode=PHONENUMONLY_MODE	;
			data->voice_edit=editor_start(data->win, &editor_data);  /* start the editor */ 
        	winShow(win);
        }
      }

      break;

    case E_ABORT:
        V_destroy(win);

        break;

    case E_RETURN:
    case E_EXIT:

    default:
        return;
  }
}

/*******************************************************************************

 $Function:     V_win_cb

 $Description:  Window callback function for the voice mailbox window

 $Returns:    Execution status

 $Arguments:  e - event id
        w - mfw window handle

*******************************************************************************/

static int V_win_cb (MfwEvt e, MfwWin *w)
    /* V window event handler */
{
    TRACE_FUNCTION ("V_win_cb()");

    switch (e)
  {
        case MfwWinVisible:  /* window is visible  */
      displaySoftKeys(TxtSoftSelect,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
	  draw_softkeybar_updown_arrow();//jhxu720
#endif
      break;
  case MfwWinFocussed: /* input focus / selected   */
  case MfwWinDelete:   /* window will be deleted   */
        default:
      return MFW_EVENT_REJECTED;
  }
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:     V_NUM_start

 $Description:  Start the Voice Mailbox number edition window

 $Returns:    mfw window handle

 $Arguments:  parent_window - parent window
        menuAttr - Menu attribute.

*******************************************************************************/

//T_MFW_HND V_NUM_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
//{
//    T_MFW_HND win;
//
//    TRACE_EVENT ("V_NUM_start()");
//
//    win = V_NUM_create (parent_window);
//
//    if (win NEQ NULL)
//  {
//      SEND_EVENT (win, E_INIT, V_NUM_ID, (void *)menuAttr);
//  }
//    return win;
//}

/*******************************************************************************

 $Function:     V_NUM_create

 $Description:  Create the Voice Mailbox number edition window

 $Returns:    mfw window handle

 $Arguments:  parent_window - parent window

*******************************************************************************/

//static T_MFW_HND V_NUM_create(MfwHnd parent_window)
//{
//    T_V_NUM      * data = (T_V_NUM *)ALLOC_MEMORY (sizeof (T_V_NUM));
//    T_MFW_WIN  * win;
//
//    TRACE_FUNCTION ("V_NUM_create()");
//
//    /*
//     * Create window handler
//     */
//
//    data->win =
//  win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)V_NUM_win_cb);
//    if (data->win EQ NULL)
//  {
//      return NULL;
//  }
//    /*
//     * connect the dialog data to the MFW-window
//     */
//
//    data->mmi_control.dialog = (T_DIALOG_FUNC)V_NUM_exec_cb;
//    data->mmi_control.data   = data;
//    win                      = ((T_MFW_HDR *)data->win)->data;
//    win->user                = (void *)data;
//    data->parent             = parent_window;
//
//    /*
//     * return window handle
//     */
//
//    return data->win;
//}

/*******************************************************************************

 $Function:     V_NUM_destroy

 $Description:  Destroy the Voice Mailbox number edition window

 $Returns:    none

 $Arguments:  own_window - current window

*******************************************************************************/

//static void V_NUM_destroy(MfwHnd own_window)
//{
//    T_MFW_WIN * win_data;
//    T_V_NUM     * data;
//
//    TRACE_FUNCTION ("V_NUM_destroy()");
//
//    if (own_window)
//  {
//      win_data = ((T_MFW_HDR *)own_window)->data;
//      data = (T_V_NUM *)win_data->user;
//
//      if (data)
//    {
//        /*
//         * Delete WIN handler
//         */
//        win_delete (data->win);
//
//        /*
//         * Free Memory
//         */
//        FREE_MEMORY ((void *)data, sizeof (T_V_NUM));
//    }
//      else
//    {
//        TRACE_EVENT ("V_NUM_destroy() called twice");
//    }
//  }
//}

/*******************************************************************************

 $Function:     V_NUM_exec_cb

 $Description:  Exec callback function of the Voice Mailbox number edition window

 $Returns:    none

$Arguments:   win - current window
        event - event id
        value - Unique id
        parameter - optional data.

*******************************************************************************/

//void V_NUM_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
//    /* callback handler for events sent to to trigger execution */
//{
//    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
//    T_V_NUM          * data = (T_V_NUM *)win_data->user;
//    T_MFW_HND      * l_parent;
//    SHORT            l_id;
//
//  T_EDITOR_DATA editor_info;
//
//    TRACE_FUNCTION ("V_NUM_exec_cb()");
//
//  l_parent = data->parent;
//  l_id = data->id;
//
//  switch (event)
//  {
//  case E_INIT:
//      /* initialization of administrative data */
//      data->id = value;
//
//    winShow(win);
//
//    /* initialization of the dialog data */
//
//    editor_info.editor_attr.text     = (char *)data->voice_number_buffer;
//    editor_info.editor_attr.size     = 32;
//
//    editor_info.LeftSoftKey       = TxtSoftBack;
//    editor_info.RightSoftKey      = TxtHelp;
//    editor_info.TextId            = TxtEnterVoiceNumber;
//    editor_info.Identifier        = 0;  /* optional */
//    editor_info.mode              = DIGITS_MODE; /* or ALPHA_MODE */
//    editor_info.destroyEditor     = TRUE;
//    editor_info.Callback          = (T_EDIT_CB)SmsMenu_V_NUM_editor_cb;
//
//    data->voice_number_buffer[0] = '\0';
//
//    editor_start(win,&editor_info);  /* start the editor */
//
//      break;
//
//  case E_ABORT:
//  case E_EXIT:
//      V_NUM_destroy(data->win);
//      SEND_EVENT (l_parent, event, l_id, NULL); /* forward event to parent */
//      break;
//
//  case E_RETURN:
//  default:
//      return;
//  }
//}

/*******************************************************************************

 $Function:     V_NUM_win_cb

 $Description:  Window callback function of the Voice Mailbox number edition window

 $Returns:    Execution status

$Arguments:   e - event id
        w - mfw window handle

*******************************************************************************/

//static int V_NUM_win_cb (MfwEvt e, MfwWin *w)
//    /* V_NUM window event handler */
//{
//    TRACE_FUNCTION ("V_NUM_win_cb()");
//
//    switch (e)
//  {
//        case MfwWinVisible:  /* window is visible  */
//      displaySoftKeys(TxtSoftSelect,TxtSoftBack);
//      break;
//  case MfwWinFocussed: /* input focus / selected   */
//  case MfwWinDelete:   /* window will be deleted   */
//        default:
//      return MFW_EVENT_REJECTED;
//  }
//    return MFW_EVENT_CONSUMED;
//}
/*******************************************************************************

 $Function:    	Delete_NVM_ALL_sms

 $Description:	delete all NVM sms 
 			
 $Returns:		if success return 1 else return 0

 $Arguments:	
*******************************************************************************/
int Delete_NVM_ALL_sms()
{
  	//FlashSms * tmp;
  	int i;
    TRACE_FUNCTION ("Delete_NVM_ALL_sms()");
    memset(Flash_sms_sort_index,0,sizeof(T_MMI_FLASH_SORT_INDEX)*FLSAH_SMS_NUM);
	memset(Flash_sms_messages,0,sizeof(T_MMI_FLASH_SMS_INDEX)*FLSAH_SMS_NUM);
    for (i=0;i<FlashSMS_Table;i++)              
    {                                   
      if (flash_Smsread(FlashSMSTable[i])!=0)
      {
         ConfigFLASHSMSReset();
         flash_Smswrite(FlashSMSTable[i]);                                      
      }
    }
    #if 0
  	
	for(i=0;i<FlashSMStotal;i++)
	{
		tmp=&FFS_SMSData.NVMSMS[i];
		if( (tmp->state == MFW_SMS_MO)||(tmp->state == MMI_SMS_MO)
		||(tmp->state == MFW_SMS_STOR_UNSENT)||(tmp->state == MFW_SMS_STOR_SENT))
		{
			memset(tmp->addr,0,MFW_NUM_LEN);
			memset((char *)tmp->sms_msg,0,MAX_MSG_LEN);
			tmp->msg_len=0;
			tmp->dcs=0xff;
			tmp->state =0;
		}
		else if(( tmp->state == MFW_SMS_MT)||(tmp->state == MMI_SMS_MT))
		{
			memset(tmp->addr,0,MFW_NUM_LEN);
			memset((char *)tmp->sms_msg,0,MAX_MSG_LEN);
			memset((char *)tmp->time.year, 0, MAX_SCTP_DIGITS);
	  		memset((char *)tmp->time.month, 0,MAX_SCTP_DIGITS);
	  		memset((char *)tmp->time.day, 0, MAX_SCTP_DIGITS);
	  		memset((char *)tmp->time.hour,0, MAX_SCTP_DIGITS);
	  		memset((char *)tmp->time.minute, 0, MAX_SCTP_DIGITS);
			tmp->msg_len=0;
			tmp->dcs=0xff;
			tmp->state =0;
		}
	}
	#endif
	FlashSMStotal=0;
	return 1;
}
/*******************************************************************************

 $Function:     SmsMenu_standard_dialog_cb

 $Description:  Handler function for standard dialogs in smsmenu module

 $Returns:    Execution status

 $Arguments:    win - current window
        Identifier - unique id
        Reason- event id

*******************************************************************************/
int Sms_NVM_DEL_ALL_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
  	T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_M_DEL_ALL    * data = (T_M_DEL_ALL *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;
    T_DISPLAY_DATA  DisplayInfo;

    TRACE_FUNCTION ("Sms_NVM_DEL_ALL_dialog_cb()");

  	l_parent = data->parent;
  	l_id = data->id;

    switch (Reason)
    {
    	// User want to delete the SMS
    case INFO_KCD_LEFT:
     	 // Trigger the deletion
     	if(Delete_NVM_ALL_sms())
      	{
      	  dialog_info_init(&DisplayInfo);//gdy add
    	  SmsMenu_loadDialogDefault(&DisplayInfo);
    	  //NM 29.8 Check before deleting, is SIM ready ?!  */
      	  DisplayInfo.TextId2     = TxtDelSucceed;
      	  DisplayInfo.Identifier = SMSMENU_ID_DELOK;
      	  DisplayInfo.iconindex =REMIND_SUCCEED;
          (void) info_dialog(win, &DisplayInfo);
      	}
     	else
      	{
      	  dialog_info_init(&DisplayInfo);//gdy add
    	  SmsMenu_loadDialogDefault(&DisplayInfo);
    	  //NM 29.8 Check before deleting, is SIM ready ?!  */
      	  DisplayInfo.TextId2     = TxtDelFail;
      	  DisplayInfo.Identifier = SMSMENU_ID_DELERR;
      	  DisplayInfo.iconindex =REMIND_FAILURE;
          (void) info_dialog(win, &DisplayInfo);
      	}
     break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_TIMEOUT:
      /* Destroy the owner of the dialog box */
      M_DEL_ALL_destroy(win);
      /* Send E_RETURN event to parent of M_DEL_ALL */
      SEND_EVENT (l_parent, E_RETURN, l_id, NULL); /* forward event to parent */
      break;

    default:
      return MFW_EVENT_REJECTED;
    }
  return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     SmsMenu_standard_dialog_cb

 $Description:  Handler function for standard dialogs in smsmenu module

 $Returns:    Execution status

 $Arguments:    win - current window
        Identifier - unique id
        Reason- event id

*******************************************************************************/

int SmsMenu_standard_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
  T_MFW_WIN      * win_data = 0;//((T_MFW_HDR *) win)->data;
    T_M_DEL_ALL    * data = 0;//(T_M_DEL_ALL *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;
	
    MMI_TRACE_EVENT(("<<<talcon,SmsMenu_standard_dialog_cb()"));
	MMI_TRACE_EVENT(("<<<talcon,SmsMenu_standard_dialog_cb()--win:0x%p,type:%d",win,((T_MFW_HDR *) win)->type));
	if(((T_MFW_HDR *) win)->type != MfwTypWin)
	{
		MMI_TRACE_EVENT(("<<<talcon,SmsMenu_standard_dialog_cb---1"));
		return 	MFW_EVENT_REJECTED;
	}
	if( (win_data = ((T_MFW_HDR *) win)->data ) == 0)
	{
		MMI_TRACE_EVENT(("<<<talcon,SmsMenu_standard_dialog_cb---2"));
		return 	MFW_EVENT_REJECTED;
	}

	if( (data = (T_M_DEL_ALL *)win_data->user) == 0)
	{
		MMI_TRACE_EVENT(("<<<talcon,SmsMenu_standard_dialog_cb---3"));
		return 	MFW_EVENT_REJECTED;
	}

  l_parent = data->parent;
  l_id = data->id;

  switch (Identifier)
  {
  case SMSMENU_ID_DELETEALL:
    switch (Reason)
    {
    // User want to delete the SMS
    case INFO_KCD_LEFT:
      // Trigger the deletion
      SmsMenu_sms_delete_all(win);
      break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_TIMEOUT:
      /* Destroy the owner of the dialog box */
      M_DEL_ALL_destroy(win);
      /* Send E_RETURN event to parent of M_DEL_ALL */
      SEND_EVENT (l_parent, E_RETURN, l_id, NULL); /* forward event to parent */
      break;

    default:
      return MFW_EVENT_REJECTED;
    }
   break;

  case SMSMENU_ID_NOTREADY:
   //break;

  case SMSMENU_ID_DELOK:
  case SMSMENU_ID_DELERR:
  case SMSMENU_ID_NOMESSAGES:
    /* Destroy the owner of the dialog box */
      data->waiting_win = 0;
	  M_DEL_ALL_destroy(win);
    /* Send E_EXIT event to parent of M_DEL_ALL_ACK */
  //JVJE  SEND_EVENT(l_parent, E_EXIT, l_id, NULL); /* forward event to parent */
    break;

  case SMSMENU_ID_WAIT:
    // No reaction to any event (wait to be destroyed when MFW event received)
    break;
    
  case SMSMENU_ID_SAVEOK:
      V_destroy(win);
  	break;
  	
  default:
    return MFW_EVENT_REJECTED;
  }
  return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     SmsMenu_V_NUM_editor_cb

 $Description:  Common handler of the sms menu editor windows

 $Returns:    Execution status

$Arguments:   win - current window
        Identifier - unique id
        Reason- event id

*******************************************************************************/

//int SmsMenu_V_NUM_editor_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
//{
//  T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
//    T_M_DEL_ALL    * data = (T_M_DEL_ALL *)win_data->user;
//    T_MFW_HND      * l_parent;
//    SHORT            l_id;
//
//    TRACE_FUNCTION ("SmsMenu_V_NUM_editor_cb()");
//
//    l_parent = data->parent;
//    l_id = data->id;
//
//  switch (Reason)
//  {
//  case INFO_KCD_LEFT:
//    /* We have to copy the phone number from the editor to the variable corresponding to the voice mailbox number TBD*/
//      V_NUM_destroy(data->win);
//    SEND_EVENT (l_parent, E_EXIT, l_id, NULL); /* forward event to parent */
//    break;
//  case INFO_KCD_RIGHT:
//  case INFO_KCD_HUP:
//      V_NUM_destroy(data->win);
//    SEND_EVENT (l_parent, E_RETURN, l_id, NULL); /* forward event to parent */
//    break;
//  default:
//    return MFW_EVENT_REJECTED;
//  }
//  return MFW_EVENT_CONSUMED;
//}

/*******************************************************************************

 $Function:     SmsMenu_loadDialogDefault

 $Description:  Loads standard default data for SMS information dialogs.

 $Returns:    Execution status

 $Arguments:    DisplayInfo - display settings

*******************************************************************************/

void SmsMenu_loadDialogDefault(T_DISPLAY_DATA * DisplayInfo)
{
    DisplayInfo->TextString   = 0;
    DisplayInfo->TextString2  = 0;
    DisplayInfo->LeftSoftKey  = 0;
    DisplayInfo->RightSoftKey = 0;
    DisplayInfo->Time         = ONE_SECS;
    DisplayInfo->KeyEvents    = KEY_CLEAR|KEY_HUP|KEY_RIGHT;
    DisplayInfo->TextId       = 0;
    DisplayInfo->TextId2      = 0;
    DisplayInfo->Identifier   = DIALOGS_REASON_NULL;
  DisplayInfo->Callback = (T_VOID_FUNC)SmsMenu_standard_dialog_cb;
}


/*******************************************************************************

 $Function:     SmsMenu_call_voice

 $Description:  dummy function.

 $Returns:    none

 $Arguments:    none

*******************************************************************************/

void SmsMenu_call_voice(void)
{
    TRACE_FUNCTION ("call_voice");
}

/*******************************************************************************

 $Function:     SmsMenu_startcall

 $Description:  dummy function.

 $Returns:    Execution status

 $Arguments:    DisplayInfo - display settings

*******************************************************************************/

void SmsMenu_startcall(UBYTE * VoiceNumber)
{
    TRACE_FUNCTION ("startcall");
}

/*******************************************************************************

 $Function:     SmsMenu_sms_delete_all

 $Description:  Delete all SMS messages.

 $Returns:    Execution status

 $Arguments:    win - current window.

*******************************************************************************/

int SmsMenu_sms_delete_all(T_MFW_HND win)
{
    //T_MFW_HND  win  = mfw_parent (mfw_header());
  T_DISPLAY_DATA DisplayInfo;
  T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_M_DEL_ALL    * data = (T_M_DEL_ALL *)win_data->user;

  g_ListLength2 = sms_message_list(MFW_SMS_ALL, data->g_SmsMenu_messages, MAX_MESSAGES);

  //NM 22.8 msgsLoadInfoDefaults2(&DisplayInfo);


    if (g_ListLength2 > 0)
    {
    /* Display "Please wait" on the screen*/
    /* it is start now to delete sms*/
   // SEND_EVENT (win, E_BACK, SMSMENU_ID_WAIT,NULL);
	dialog_info_init(&DisplayInfo);//gdy add
   	SmsMenu_loadDialogDefault(&DisplayInfo);
    DisplayInfo.RightSoftKey = 0;
    DisplayInfo.Time         = FOREVER;
    DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
    DisplayInfo.TextId2       =TxtDeletingSms;
    DisplayInfo.RightSoftKey=TxtSoftBack;
	DisplayInfo.iconindex =REMIND_DELETING;//REMIND_NORECORD;
    DisplayInfo.Identifier = SMSMENU_ID_NOMESSAGES;
	data->waiting_win=info_dialog(win, &DisplayInfo);

      /* delete now the first sms and than wait */
      /* for the MFW EVENT "E_SMS_OK"           */

    g_ListLength2 --;

    sms_msg_delete(data->g_SmsMenu_messages[g_ListLength2].index);

    }
    else
    {
        /* Display "No Messages" on the screen */
        /* and go back to the parent           */
    dialog_info_init(&DisplayInfo);//gdy add
    SmsMenu_loadDialogDefault(&DisplayInfo);
    DisplayInfo.Identifier = SMSMENU_ID_NOMESSAGES;
    DisplayInfo.iconindex =REMIND_NORECORD;
    DisplayInfo.TextId2= TxtNoMessages;
    info_dialog(win,&DisplayInfo);
    //SEND_EVENT (win, E_BACK, SMSMENU_ID_NOMESSAGES,NULL);
  }

    return 1;

}

/*******************************************************************************

 $Function:     SmsRead_convertMailbox

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/
UBYTE SmsRead_convertMailbox(T_MFW_MAILBOX_ID i, char *mail_number, char *mail_alpha)
{
  USHORT max_rcd;
  USHORT nlen;

  char *international = mail_number; // Used to add '+' to the number if international

    TRACE_FUNCTION ("SmsRead_convertMailbox()");


    // If international number, add the '+' symbol
    if (FFS_flashData.mbn_numTp & 0x10)
    {
      international[0] = '+';
      international[1] = '\0';
      international ++;
    }
    // Convert BCD number into string
    cmhPHB_getAdrStr(international, PHB_MAX_LEN - 1, FFS_flashData.mbn_Num, FFS_flashData.mbn_len);

    // If the same number then we get the alpha identifier
    cmhPHB_getMfwTagNt((UBYTE*)FFS_flashData.mbn_AlphId, 10, (UBYTE*)mail_alpha, &nlen );
    mail_alpha[nlen] = '\0';

    return TRUE;

}

static void SmsMenu_StandardEditor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
  T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
  T_V     * voice_data = (T_V *)win_data->user;
  T_DISPLAY_DATA DisplayInfo;

  TRACE_FUNCTION ("SmsSend_NBEDIT_edit_cb()");

  switch (reason)
  {
    case INFO_KCD_LEFT:
      switch (Identifier)
      {
//      case SMSMENU_ID_VOICEMAIL_CALL:
//        voice_data = (T_V *)win_data->user;
//        callNumber(voice_data->FFS_flashData.voice_mail);
      	case V_ID_CALL:
      		memcpy(FFS_flashData.voice_mail,voice_data->voice_mail,PHB_MAX_LEN);
      		flash_write();
          	callNumber(voice_data->voice_mail);
	      	V_destroy(win);
        break;
        
      	case V_ID_SET:
		    //SmsMenu_loadDialogDefault(&DisplayInfo);
     		//DisplayInfo.Identifier = SMSMENU_ID_SAVEOK;
      		//DisplayInfo.TextId = TxtSaved;
      		//info_dialog(voice_data->win,&DisplayInfo);
	        mmi_dialog_information_screen(win, TxtSaved, 0,(T_VOID_FUNC)SmsMenu_standard_dialog_cb, SMSMENU_ID_SAVEOK);
      		memcpy(FFS_flashData.voice_mail,voice_data->voice_mail,PHB_MAX_LEN);
      		flash_write();
        break;

// this is for saving the Voicemail number in PCM
//      case SMSMENU_ID_VOICEMAIL:
//        settings_data = (T_SETTINGS *)win_data->user;
//        if (servicesStoreVoiceMailNumber((char *)settings_data->settings_numbers.FFS_flashData.voice_mail, MFW_MB_LINE1) == MFW_PHB_OK)
//          mmi_dialog_information_screen(win, MMI_DIALOG_INFO_SAVED, (T_VOID_FUNC)SmsMenu_standard_dialog_cb, SMSMENU_ID_SAVEOK);
//        else
//          mmi_dialog_information_screen(win, MMI_DIALOG_INFO_FAILED, (T_VOID_FUNC)SmsMenu_standard_dialog_cb, SMSMENU_ID_SAVEERR);
//      break;
      }
      break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_CLEAR:
    case INFO_KCD_HUP:
//      switch (Identifier)
//      {

//        case SMSMENU_ID_VOICEMAIL:
//          SmsMenu_SETTINGS_destroy(win);
//          break;
//        case SMSMENU_ID_VOICEMAIL_CALL:

    V_destroy(win);

//          break;
//        default:
//          break;
//      }
    default:
      break;
  }
}

/*******************************************************************************

 $Function:     SmsMenu_loadEditDefault

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/
void SmsMenu_loadEditDefault(T_EDITOR_DATA *editor_data)
{
    TRACE_FUNCTION ("SmsMenu_loadEditDefault()");

      editor_data->editor_attr.win.px   = 6;
      editor_data->editor_attr.win.py   = 12;
      editor_data->editor_attr.win.sx   = 80;
      editor_data->editor_attr.win.sy   = 20;
      editor_data->editor_attr.fgColor  = 0;
      editor_data->editor_attr.font     = 0;
      editor_data->editor_attr.mode    = edtCurBar1;
      editor_data->editor_attr.controls   = 0;
      editor_data->editor_attr.text      = '\0';
        editor_data->editor_attr.size       = 0;
    editor_data->hide         = FALSE;
      editor_data->Identifier            = 0;  /* optional */
      editor_data->mode               = DIGITS_MODE;
    editor_data->destroyEditor      = TRUE;
    editor_data->LeftSoftKey          = TxtSoftSelect;
    editor_data->AlternateLeftSoftKey   = TxtNull;
    editor_data->RightSoftKey         = TxtSoftBack;
    editor_data->Identifier            =  0;
    editor_data->TextId              = '\0';
    editor_data->TextString           = NULL;
    editor_data->min_enter         = 1;  // Avoid to return empty strings
      editor_data->timeout              = FOREVER;
    editor_data->Callback             = (T_EDIT_CB)SmsMenu_StandardEditor_cb;

}




#undef MMI_SMSMENU_C
