#ifndef _DEF_MMI_SMSMENU_H_
#define _DEF_MMI_SMSMENU_H_


/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		SMS
 $File:		    MmiSmsMenu.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    header of template for MMI SMS menu dynamic event handling


                        
********************************************************************************

 $History: MmiSmsMenu.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/
#undef GLOBAL_EXT
#if defined (MMI_SMSMENU_C)
	#define GLOBAL_EXT
#else
	#define GLOBAL_EXT extern
#endif


#include "mfw_mfw.h"
#include "mmiicons.h"




#define TIMER_EXIT  0x0BB8             /* Default SMS timer period - 3 secs.  */
#define SHORT_SECS  0x01F4				/* Information dialogue display times. */
#define THREE_SECS  0x0BB8             /* 3000 milliseconds.                  */
#define FIVE_SECS   0x1388             /* 5000 milliseconds.                  */
#define TEN_SECS    0x2710             /* 10000 milliseconds.                 */
#define TWO_MIN     0x1D4C0            /* 2 min                               */
#define FOREVER     0xFFFF             /* Infinite time period.               */

// should keep it only one time e.g in MmiSmsIdle.h
//typedef enum
//{
//    E_INIT = 0x0801,
//    E_BACK,
//    E_ABORT,
//    E_EXIT,
//	E_RETURN,
//	E_OK
//} e_M_events;
/* ID of the different windows (used in SEND_EVENT function to provide the callee the ID of the caller) */
typedef enum
{
  /* Logical frames */
  M_DEL_ALL_ID=MsgsDummy,
  M_SND_SAV_ID,
  V_ID_SET,
  V_ID_CALL,
  V_NUM_ID,
  /* Dialog windows */
  SMSMENU_ID_NOTREADY,
  SMSMENU_ID_DELETEALL,
  SMSMENU_ID_DELOK,
  SMSMENU_ID_DELERR,
  SMSMENU_ID_NOMESSAGES,
  SMSMENU_ID_SAVEOK,
//  SMS_SENDING_MSG,/*2003/12/4, wangyan delete*/
  SMSMENU_ID_WAIT,
  //follow ID is move from mmismssend.h for different value
  /* Logical frames */
  SEND_ID,
  SAVE_ID,
  /* Extern windows */
  PHBK_ID,
  /* Editor windows */
  SMSSEND_ID_TEXTEDIT,
  SMSSEND_ID_NBEDIT,
  SMSSEND_ID_CENTREEDIT,
  SMSSEND_ID_CENTREEDIT_CHANGE,
  /* Dialog windows */
  SMSSEND_ID_WAITING,
  SMSSEND_ID_WAIT_SEND,
  SMSSEND_ID_SENT,
  SMSSEND_ID_NOT_SENT,
  SMSSEND_ID_WAIT_SAVE,
  SMSSEND_ID_SAVED,
  SMSSEND_ID_NOT_SAVED,
  SMSSEND_ID_LIST_FULL,
  SMSSEND_ID_SAVE_NOT_READY, //PATCH TB
  SMSSEND_ID_SC_NOT_READY, //PATCH TB
  SMSSEND_ID_CM_SAVE_READY,
  SMSSEND_ID_CM_TEXTEDIT,
  SMSREAD_EDIT,
 // MMI_MESSAGE_MEMORYSTATE,/*2003/12/4, wangyan delete*/
  SMSSEND_ID_NOT_ALLOWED
} sms_menu_id;

/* 2004/4/20, wangyan modify */
typedef enum
{
	MENU_MMI_SMS_CB,
	MENU_MMI_SMS_MO,
	MENU_MMI_SMS_MT,
	MENU_MMI_SMS_FLASH_MT,
	MENU_MMI_SMS_FLASH_MO
} T_MMI_SMS_STAT_MENU;	
/* 2004/4/20, wangyan modify */

/* This structure must be used by the different modules to pass parameters for SMS sending */
typedef struct
{
  UBYTE TextBuffer[MAX_MSG_LEN_ARRAY];  /* sbh */
    UBYTE NumberBuffer[NUMBER_LENGTH];
    UBYTE CentreBuffer[NUMBER_LENGTH];
	UINT8 Send_state;
	SHORT sms_index; /*2004/4/20, wangyan add*/
	T_MFW_SMS_STAT msg_type; /*2004/4/20, wangyan add*/
	T_MMI_SMS_STAT_MENU sms_type; /*2004/4/20, wangyan add*/

     /* FTA 34.2.8 
        we have to know from where we are calling the 
        sms sending part. We should use the Service
        CenterNumber from the Caller in the case of REPLYING
      */
    UBYTE called_from_reply_item;  
} T_SmsUserData;

// Entry points for the different SMS blocs
GLOBAL_EXT int M_exeSendNew(MfwMnu* m, MfwMnuItem* i);
//GLOBAL_EXT int M_exeRead(MfwMnu* m, MfwMnuItem* i);/*2003/11/28, wangyan delete*/
GLOBAL_EXT int M_exeDelAll(MfwMnu* m, MfwMnuItem* i);
GLOBAL_EXT int M_exeSendSaved(MfwMnu* m, MfwMnuItem* i);
GLOBAL_EXT int M_exeVoice(MfwMnu* m, MfwMnuItem* i);

GLOBAL_EXT int M_exeBroadcast(MfwMnu* m, MfwMnuItem* i);
GLOBAL_EXT int M_exeDelNVMAll(MfwMnu* m, MfwMnuItem* i);

// Dialog window callback function
GLOBAL_EXT void SmsMenu_loadDialogDefault(T_DISPLAY_DATA * DisplayInfo);

int voice_mail_init (void);

/***************************************************
****											****
****				DUMMY DECLARATIONS			****
****											****
***************************************************/

//Dummy defines
//#define TxtNotReady			1//hxl del for it is no use at here,2003-3-17
#define TxtNotDeleted		2
#define TxtAllDeleted		3
#define TxtEnterVoiceNumber 4
//Dummy functions (stubs)
void SmsRead();
void call_voice();
void sms_send(T_SmsUserData *);
int sms_get_ready_state();

int newSmsMenu_Start(MfwMnu* m, MfwMnuItem* i);
int ExeSms_sendM_SND(MfwMnu *, MfwMnuItem *);
int ExeM_SND(MfwMnu *, MfwMnuItem *);
T_MFW_HND M_DEL_ALL_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr); //xsf add 11.27
// Dummy global variables

/***************************************************
****											****
****			END DUMMY DECLARATIONS			****
****											****
***************************************************/

#endif /* _DEF_MMI_SMSMENU_H_ */
