#ifndef _DEF_MMI_SMSREAD_H_
#define _DEF_MMI_SMSREAD_H_

#undef GLOBAL_EXT
#if defined (MMI_SMSREAD_C)
#define GLOBAL_EXT
#else
#define GLOBAL_EXT extern
#endif

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		SMS
 $File:		    MmiSmsRead.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    This module provides definitions of the types and
    constants which are shared across the phone book
    application modules.
   
********************************************************************************
 $History: MmiSmsRead.h

	25/10/00			Original Condat(UK) BMI version.	
  09/08         windy modified
 $End

*******************************************************************************/

/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#include "mfw_mfw.h"

/*******************************************************************************
                                                                              
                        Shared Structure Definitions
                                                                              
*******************************************************************************/

#define MENU_TEXT_LENGTH 16	//TBD: to include in common .h
#define MENU_HEADER_LENGTH MENU_TEXT_LENGTH - 4 //TBD: to include in common .h

// Length = to len("from ") + len(number) + len(sms text) + 4 (for \0 \n and optional ionternational character +)
#define MAX_EDITOR_LEN  320//(5+MFW_NUM_LEN+MAX_MSG_LEN+4)
#define MAX_LISTSMS_LEN  220


typedef enum
{
	MMI_SMS_CB,
	MMI_SMS_MO,
	MMI_SMS_MT,
	MMI_SMS_FLASH_MT,//added by windy
	MMI_SMS_FLASH_MO//added by windy
} T_MMI_SMS_STAT;	

/*******************************************************************************
                                                                              
                                Function Prototypes
                                                                              
*******************************************************************************/

T_MFW_HND SmsRead_R_start(T_MFW_HND parent_window, T_MFW_SMS_STAT *menuAttr);

T_MFW_HND SmsRead_R_TEXTEDT_start(T_MFW_HND parent_window, MfwMnuAttr *data);
T_MFW_HND SmsRead_R_TEXTEDT2_start(T_MFW_HND parent_window, MfwMnuAttr *data);
T_MFW_HND SmsRead_R_OPT_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);


void SmsRead_DisplayStandardDialog(T_MFW_HND win, int TextId, ULONG duration);
MfwHnd smsRead_info_screen(MfwHnd win,int TextId);
void Flash_sms_delete_screen(MfwHnd win,int TextId, ULONG duration);
int SmsRead_convertSMSmsg(			char * ipString,	UBYTE ipDataType,	int ipLength,
										char * opString, 	UBYTE opDataType,	int opLength, UBYTE addNull);
BOOL GetSMSLISTWINHandle();
int IdleReadsms(T_MFW_HND       win,T_MFW_SMS_STAT *menuAttr);

/*******************************************************************************
                                                                              
                              DUMMY DECLARATIONS	
                                                                              
*******************************************************************************/

//Dummy defines
#define SmsRead_R_ID 			100
#define SmsRead_R_TEXTEDT_ID 	101
#define SmsRead_R_TEXTEDT2_ID 	101	// Specific for approval
#define SmsRead_R_OPT_ID 		102
#define SmsRead_SMS_DISPLAY_ID	103
#define SmsRead_R_READSMS_OPT_ID 104

#define DEFAULT_FONT -1

#define SMS_APPROVAL 1

// MZ 6/2/01 temp typedefs.
typedef char * wstring_t;
typedef char * charw_t;
typedef ListCbFunc ListCbFunc_t;

// Dummy global variables
GLOBAL_EXT charw_t g_sms_text_unicode[MAX_MSG_LEN + 1];
GLOBAL_EXT wstring_t g_sms_unicode;



#endif /* _DEF_MMI_SMSMENU_H_ */
