/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI                                                            
 $Module:		SMS
 $File:		    MmiSmsSend.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    Implementation template for MMI yyy dynamic menu handling
                        
********************************************************************************

 $History: MmiSmsSend.c

    25/10/00			Original Condat(UK) BMI version.	
  09/08         windy modified
  19/08/02      ver0.111   wangxia  modified 
 $End

*******************************************************************************/

#define MMI_SMSSEND_C

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
#include "mfw_str.h"

#include "dspl.h"

#include "MmiMain.h"
#include "MmiDummy.h"
//#include "MmiLists.h"
#include "MmiMmi.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"
#include "phb.h"      /* FDN  */
#include "mmiBookshared.h"
#include "mmiSmsMenu.h"
#include "MmiSmsSend.h"
#include "MmiSmsIdle.h"
#include "MmiSat_i.h"
#ifdef EASY_TEXT_ENABLED
    #include "MmiLatinPredText.h"
#endif

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mmiusersymbolinput.h"
#include "Mmiicons.h"
#include "Mfw_cnvt.h"
#include "Mmitextinput.h"			/* 2003/12/04 sunsj add */
//#define TDTRACE 1
#include "mmiutilapi.h" /* 2004/4/20, wangyan modify */
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */
//#include "rtc_api.h" /*2003/11/10, wangyan, modify sms mo time*/

/*********************************************************************
**********************************************************************

                 DYNAMIC MENU WINDOW. DECLARATION

*********************************************************************
**********************************************************************/


/* General functions */
static void SmsSend_NBEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
static int  SmsSend_standard_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
void        SmsSend_loadEditDefault(T_EDITOR_DATA * edit_info);
static void SmsSend_loadUCS2EditDefault(T_EDITOR_DATA *editor_data);

/* prototyps */
static T_MFW_HND SmsSend_SEND_create  (T_MFW_HND parent);
void      SmsSend_SEND_destroy (T_MFW_HND window);

// Main callback function of the frame window
static void      SmsSend_main_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
// Sub-callback functions of the frame window associated to the different emitters
static void      SmsSend_SEND_exec_cb (T_MFW_HND win, USHORT event, void * parameter);
static void      SmsSend_PHBK_exec_cb (T_MFW_HND win, USHORT event, void * parameter);
static void      SmsSend_TEXTEDIT_exec_cb (T_MFW_HND win, USHORT event, void * parameter);
static void      SmsSend_NBEDIT_exec_cb (T_MFW_HND win, USHORT event, void * parameter);
static void      SmsSend_CENTREEDIT_exec_cb (T_MFW_HND win, USHORT event, void * parameter);

// Callback functions of the various editors
static void     SmsSend_TEXTEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
static void     SmsSend_NBEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
static void     SmsSend_CENTREEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
T_MFW_HND smscb_common_msg_start(T_MFW_HND parent_window, void *dummy);
// Callback function for the MFW events
static int       SmsSend_SEND_mfw_cb  (MfwEvt event, void *data);

// This function initiate the sending of the SMS
static int       SmsSend_send_to_mfw    (T_MFW_HND win);
static T_MFW_HND parentWindow4SMS;

UBYTE SmsSend_set_SrvCntr_number (T_MFW_SMS_INFO *config_data);
UBYTE SmsSend_set_dcs_number (T_MFW_SMS_INFO *config_data);
extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13
extern T_call call_data;

/* 2004/4/20, wangyan modify */
//extern int type;
extern T_MMI_FLASH_SORT_INDEX Flash_sms_sort_index[FLSAH_SMS_NUM];/*2004/4/12, wangyan add*/
extern SHORT g_sms_list_counter;
/* 2004/4/20, wangyan modify */

/***************************************************
****											****
****		MANAGEMENT OF SMS OPTIONS			****
****											****
***************************************************/


typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */

    /* !!! **************************************** modify here **************************************** !!!*/
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    /* !!! **************************************** end modify here **************************************** !!! */

    /* internal data */

    /* !!! **************************************** modify here **************************************** !!!*/
    BOOL            answer; /* TRUE == YES, FALSE == NO */
    T_MFW_HND       sms;
    T_MFW_HND       dialog_win;
    T_SEND          *parent_data;
    /* !!! **************************************** end modify here **************************************** !!! */
} T_SMSSEND_R_OPT;

typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       parent;
    //    T_MFW_HND       info;  /* to keep the window of SmsSend_info_xxx*/  
    T_MFW_HND       child_dialog;/* to keep the window of dialog          */    
    T_MFW_HND       sms_handler;
    SHORT           id;
    T_SmsUserData   edt_data; /* pointer of text and number */
    /* will call from idle or phonebook  */
} T_SAVE;
typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */

    /* internal data */
    ListMenuData    list_menu_data;
} T_COMMON_MSG;
static int index;//added by windy for change the common message

static MfwMnuAttr smscb_common_msgAttrib =
{
    0,
    &smscb_M_CB_TOP_CONSArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};
static void smscb_common_msg_lst_create(T_COMMON_MSG *data);
static int SmsCM_R_OPTExeSave(MfwMnu* m, MfwMnuItem* i);
static int SmsCM_R_OPTExeSend(MfwMnu* m, MfwMnuItem* i);

UINT8 Send_ed_state;
UINT8 Send_save;
static T_MFW_HND    SmsSend_SAVE_create  (T_MFW_HND parent);
static void             SmsSend_SAVE_destroy (T_MFW_HND window);
static void             SmsSend_SAVE_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int              SmsSend_SAVE_mfw_cb (MfwEvt event, void *info);

static T_MFW_HND SmsSend_R_OPT_create (T_MFW_HND parent);
static void SmsSend_R_OPT_destroy (T_MFW_HND window);
static void SmsSend_R_OPT_StandardDialog(T_MFW_HND win, char *text, ULONG duration);
static void SmsSend_R_OPT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int SmsSend_R_OPT_win_cb (MfwEvt e, MfwWin *w);
static int SmsSend_R_OPT_mfw_cb (MfwEvt event, void *parameter);
T_MFW_HND SmsSend_OPT_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
static int SmsSend_R_OPT_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
static void SmsSend_SCNBEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
/* !!! **************************************** modify here **************************************** !!!*/
static int SmsSend_R_OPT_kbd_cb (MfwEvt e, MfwKbd *k);
static int SmsSend_R_OPT_mnu_cb (MfwEvt e, MfwMnu *m);
/* !!! **************************************** end modify here **************************************** !!! */



/*********************************************************************
**********************************************************************

                 DYNAMIC MENU WINDOW. CONTENTS DECLARATION

*********************************************************************
**********************************************************************/

/* !!! **************************************** modify here **************************************** !!!*/

static int SmsSend_R_OPTExeSave(MfwMnu* m, MfwMnuItem* i);
static int SmsSend_R_OPTExeSend(MfwMnu* m, MfwMnuItem* i);
static int SmsSend_R_OPTExeSendOnly(MfwMnu* m, MfwMnuItem* i);
static int SmsSend_R_OPTExeDiscard(MfwMnu* m, MfwMnuItem* i);
static int SmsSend_R_OPTExeCmMsg(MfwMnu* m, MfwMnuItem* i);

//char TestBuffer[/*TEXT_LENGTH*/162];
/* 2004/06 sunsj modify for icon manage */
extern const MfwIcnAttr colist[];

static MfwMnuItem SmsSend_R_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSendOnly,0,(MenuFunc)SmsSend_R_OPTExeSendOnly,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSendSave,0,(MenuFunc)SmsSend_R_OPTExeSend,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtInsertCMmsg,0,(MenuFunc)SmsSend_R_OPTExeCmMsg,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSave,0,(MenuFunc)SmsSend_R_OPTExeSave,item_flag_none}
    // {&colist,0,0,(char *)TxtDiscard,0,(MenuFunc)SmsSend_R_OPTExeDiscard,item_flag_none}
};

static MfwMnuAttr SmsSend_R_OPTAttrib =
{
    0,
    &SmsSend_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsSend_R_OPTItems,                      /* with these items         */
    sizeof(SmsSend_R_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};
static MfwMnuItem Sms_rpl_fwr_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSendOnly,0,(MenuFunc)SmsSend_R_OPTExeSendOnly,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSendSave,0,(MenuFunc)SmsSend_R_OPTExeSend,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtInsertCMmsg,0,(MenuFunc)SmsSend_R_OPTExeCmMsg,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSave,0,(MenuFunc)SmsSend_R_OPTExeSave,item_flag_none}   /* 2004/04/05 sunsj add */
};

static MfwMnuAttr Sms_rpl_fwr_OPTAttrib =
{
    0,
    &SmsSend_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    Sms_rpl_fwr_OPTItems,                      /* with these items         */
    sizeof(Sms_rpl_fwr_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};
static MfwMnuItem SmsCM_R_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSend,0,(MenuFunc)SmsCM_R_OPTExeSend,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSaveToFfs,0,(MenuFunc)SmsCM_R_OPTExeSave,item_flag_none}
};

static MfwMnuAttr SmsCM_R_OPTAttrib =
{
    0,
    &SmsSend_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsCM_R_OPTItems,                      /* with these items         */
    sizeof(SmsCM_R_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};

UINT8 Send_state;
//UBYTE LastTextBuffer[MAX_MSG_LEN+2];  /* windy */
//UBYTE LastNumberBuffer[NUMBER_LENGTH];
static char buf[80];
extern T_MFW_MEM_INFO     memory;

UBYTE* convertToUnicodeForOutput( UBYTE * ipText, USHORT* outLen)
{
    static UBYTE temp_conv_buffer[MAX_MSG_LEN_ARRAY];
    int i;
    if( ipText[0] == 0x80 )
    {   //skip first 2 chars
        *outLen = 0;
        for( i=0;i<MAX_MSG_LEN/2;i++ )
        {
            temp_conv_buffer[i*2  ] = ipText[i*2+1];
            temp_conv_buffer[i*2+1] = ipText[i*2+1+1];
            if( (*outLen ==0) && 
                (temp_conv_buffer[i*2] == 0x00) && 
                (temp_conv_buffer[i*2+1] == 0x00) )
                *outLen = i*2+2;
        }
        if( *outLen == 0 )
        {//Reached end of message without finding 0x0000 - set last word to 0x0000
            *outLen = MAX_MSG_LEN;
            temp_conv_buffer[MAX_MSG_LEN-2] = 0x00;
            temp_conv_buffer[MAX_MSG_LEN-1] = 0x00;
        }
        return(temp_conv_buffer);
    }
    else
    {   /*MC*/
        *outLen = strlen((char*)ipText);
        SmsRead_convertSMSmsg(ipText, MFW_ASCII, MAX_MSG_LEN, temp_conv_buffer, MFW_DCS_8bits, MAX_MSG_LEN, FALSE);
        //return (ipText);
        return(temp_conv_buffer);
    }
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPTExeSendOnly

 $Description:	Start the creation of the main window for SMS Send.
 
 $Returns:		none

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsSend_R_OPTExeSendOnly(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT  * data     = (T_SMSSEND_R_OPT *)win_data->user;
    /* access to data from parent   */
    T_SEND  * parent_data =  (T_SEND *)data->parent_data;
    T_EDITOR_DATA editor_data;
    T_MFW_SMS_INFO  sms_parameter;
    USHORT parameter;

    TRACE_FUNCTION("SmsSend_R_OPTExeSendOnly");
    /* delete only the one selected SMS */
    if( Send_state==E_REPLY )
    {
        if( (phb_get_mode() EQ PHB_RESTRICTED)
            && (phb_check_number(parent_data->edt_data.NumberBuffer) EQ MFW_PHB_FAIL) )
        {
            mmi_dialog_information_screen(win,TxtNotImplemented, 0, 
                                          (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_ALLOWED);
        }
        else
        {
            //END TB
            // First check if the SMS center is specified
            SmsSend_get_config_data(&sms_parameter);
            if( sms_parameter.sc_addr[0] EQ '\0' )
            {
                //setup identifier value.
                parameter = SMSSEND_ID_CENTREEDIT;
                //SmsSend_R_OPT_destroy(parent_data->options_win);
                SmsSend_CENTREEDIT_exec_cb(parent_data->win, E_INIT,(void*)&parameter);
            }
            else
            {
                /* 2004/4/20, wangyan modify */
#if 0
                /*NM FTA 34.2.8*/
                if( parent_data->edt_data.called_from_reply_item EQ FALSE )
                {
                    TRACE_EVENT("take the own serviceCenternum");
                    strcpy((char *)parent_data->edt_data.CentreBuffer, (char *)sms_parameter.sc_addr);
                    {
                        char buf[30];
                        sprintf(buf,"serviceNr:%s",parent_data->edt_data.CentreBuffer);
                        TRACE_EVENT(buf);
                    }
                }
                else
                {
                    TRACE_EVENT("from the caller, reply");
                    /* in case of reply the sms, we took already the 
                   the service center number from the caller !!!*/
                    {
                        char buf[30];
                        sprintf(buf,"serviceNr:%s",parent_data->edt_data.CentreBuffer);
                        TRACE_EVENT(buf);
                    }
                }
                /*NM FTA 34.2.8*/
#endif
                /* 2004/4/20, wangyan modify */
                Send_save=E_SENDONLY;
                SmsSend_R_OPT_destroy(parent_data->options_win);
                SmsSend_send_to_mfw(parent_data->win);
            }
        }
    }
    else
    {
        Send_save=E_SENDONLY;
        SmsSend_loadEditDefault(&editor_data);
        /* 2003/12/29 sunsj modify for number buffer size */
        editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtEnterNumber,
                                 (char *)parent_data->edt_data.NumberBuffer,PHB_MAX_LEN+3,edtCurBar1);
        editor_data.edtInPbk           = 0;
        editor_data.LeftSoftKey          = TxtSend;
        editor_data.AlternateLeftSoftKey  = TxtSearchName;
        editor_data.RightSoftKey         = TxtDelete;
        editor_data.Identifier           = SMSSEND_ID_NBEDIT ; 
        editor_data.mode                 = E_EDIT_DIGITS_MODE;
        editor_data.Callback             = (T_EDIT_CB)SmsSend_NBEDIT_edit_cb;
        editor_data.destroyEditor        = FALSE;
        editor_data.mode=PHONENUMONLY_MODE  ;
        parent_data->number_editor = editor_start(parent_data->win, &editor_data);  /* start the editor */ 
        SmsSend_R_OPT_destroy(parent_data->options_win);
    }
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPTExeSend

 $Description:	Start the creation of the main window for SMS Send.
 
 $Returns:		none

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsSend_R_OPTExeSend(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT  * data     = (T_SMSSEND_R_OPT *)win_data->user;
    /* access to data from parent   */
    T_SEND  * parent_data =  (T_SEND *)data->parent_data;

    T_EDITOR_DATA editor_data;
    T_MFW_SMS_INFO  sms_parameter;
    USHORT parameter;

    TRACE_FUNCTION("SmsSend_R_OPTExeSend");
    //sms_get_memset();

    if( memory.used == memory.total )//smsidle_get_memory_full())
    {
        SmsSend_R_OPT_destroy(parent_data->options_win);
        mmi_dialog_information_screen(parent_data->win,TxtSmsFull, 0, 
                                      (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_ALLOWED);
    }
    else
    {
        if( Send_state==E_REPLY )
        {
            if( (phb_get_mode() EQ PHB_RESTRICTED)
                && (phb_check_number(parent_data->edt_data.NumberBuffer) EQ MFW_PHB_FAIL) )
            {
                SmsSend_R_OPT_destroy(parent_data->options_win);
                mmi_dialog_information_screen(parent_data->win,TxtNotImplemented, 0, 
                                              (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_ALLOWED);
            }
            else
            {
                if( !smsidle_get_ready_state() )
                {
                    // SMS init processing not ready to access SIM to store the SMS
                    SmsSend_R_OPT_destroy(parent_data->options_win);
                    mmi_dialog_information_screen(parent_data->win,TxtPleaseWait, TxtSimNot, 
                                                  (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SC_NOT_READY);
                    // Recreate the editor on dialog callback
                }
                else
                {
                    //END TB
                    // First check if the SMS center is specified
                    SmsSend_get_config_data(&sms_parameter);
                    if( sms_parameter.sc_addr[0] EQ '\0' )
                    {
                        //setup identifier value.
                        parameter = SMSSEND_ID_CENTREEDIT;
                        //SmsSend_R_OPT_destroy(parent_data->options_win);
                        SmsSend_CENTREEDIT_exec_cb(parent_data->win, E_INIT,(void*)&parameter);
                    }
                    else
                    {
                        /* 2004/4/20, wangyan modify */
#if 0
                        /*NM FTA 34.2.8*/
                        if( parent_data->edt_data.called_from_reply_item EQ FALSE )
                        {
                            TRACE_EVENT("take the own serviceCenternum");
                            strcpy((char *)parent_data->edt_data.CentreBuffer, (char *)sms_parameter.sc_addr);
                            {
                                char buf[30];
                                sprintf(buf,"serviceNr:%s",parent_data->edt_data.CentreBuffer);
                                TRACE_EVENT(buf);
                            }
                        }
                        else
                        {
                            TRACE_EVENT("from the caller, reply");
                            /* in case of reply the sms, we took already the 
                           the service center number from the caller !!!*/
                            {
                                char buf[30];
                                sprintf(buf,"serviceNr:%s",parent_data->edt_data.CentreBuffer);
                                TRACE_EVENT(buf);
                            }
                        }
                        /*NM FTA 34.2.8*/
#endif
                        /* 2004/4/20, wangyan modify */
                        Send_save=E_SENDSAVE;
                        SmsSend_R_OPT_destroy(parent_data->options_win);
                        SmsSend_send_to_mfw(parent_data->win);
                    }
                }
            }
        }
        else
        {
            Send_save=E_SENDSAVE;
            SmsSend_loadEditDefault(&editor_data);

            // Reset the number if it is sent an other time (supposed to a new number)
            //			if (parent_data->id == SMSSEND_ID_SENT)
            //				parent_data->edt_data.NumberBuffer[0] = '\0';

            //			 parent_data->edt_data.NumberBuffer[0] = '\0';  /* MZ 6/2/01 SMSSEND_ID_SENT is never received need to check!  */
            editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtEnterNumber,(char *)parent_data->edt_data.NumberBuffer,PHB_MAX_LEN,edtCurBar1);
            //bookSetEditAttributes( 0,Mmi_layout_first_line()+2,84 , 20, 0, 0, edtCurBar1, 0, 
            //(char *) parent_data->edt_data.NumberBuffer, /*MAX_SEARCH_CHAR*/NUMBER_LENGTH, &editor_data.editor_attr);
            editor_data.edtInPbk           = 0;
            editor_data.LeftSoftKey          = TxtSend;
            editor_data.AlternateLeftSoftKey = TxtSearchName;
            editor_data.RightSoftKey         = TxtDelete;
            editor_data.Identifier           = SMSSEND_ID_NBEDIT ; 
            editor_data.mode                 = E_EDIT_DIGITS_MODE;
            editor_data.Callback             = (T_EDIT_CB)SmsSend_NBEDIT_edit_cb;
            editor_data.destroyEditor        = FALSE;
            editor_data.mode=PHONENUMONLY_MODE  ;
            parent_data->number_editor = editor_start(parent_data->win, &editor_data);  /* start the editor */ 
            SmsSend_R_OPT_destroy(parent_data->options_win);
        }
    }

}

/*******************************************************************************

 $Function:    	SmsSend_R_OPTExeDiscard

 $Description:	
 
 $Returns:		execution status

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsSend_R_OPTExeDiscard(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT  * data     = (T_SMSSEND_R_OPT *)win_data->user;
    /* access to data from parent   */
    T_SEND  * parent_data =  (T_SEND *)data->parent_data;
    //T_EDITOR_DATA editor_data;
    T_MFW_HDR    * parent      =  parent_data->parent;
    TRACE_FUNCTION("SmsSend_R_OPTExeDiscard");

    SmsSend_R_OPT_destroy(parent_data->options_win);
    /*#if	defined(CHINESE_MMI) && defined(EASY_TEXT_ENABLED)
         if (Mmi_getCurrentLanguage() == CHINESE_LANGUAGE)
            chinese_input_destroy(parent_data->text_editor);
         else
    #endif
    */
    //editor_destroy(parent_data->text_editor);
    //parent_data->text_editor = 0;
    SmsSend_SEND_destroy(parent_data->win);
    if( !call_data.win )
        SEND_EVENT (parent, E_BACK, data->id, NULL);
    return 1;
}


/*******************************************************************************

 $Function:    	SmsSend_R_OPTExeCmMsg

 $Description:	
 
 $Returns:		execution status

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsSend_R_OPTExeCmMsg(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT  * data     = (T_SMSSEND_R_OPT *)win_data->user;
    T_MFW_HND          parent   = data->parent;
    /* access to data from parent   */
    T_SEND  * parent_data =  (T_SEND *)data->parent_data;
    T_EDITOR_DATA editor_data;

    TRACE_FUNCTION("SmsSend_R_OPTExeCmMsg");

    SmsSend_R_OPT_destroy(parent_data->options_win);
    Send_ed_state=SEND_USE_COMMON_MSG;
    // modified by clrobert
    // from
    /*
    smscb_common_msg_start (data->win, NULL);
    */
    // to
    smscb_common_msg_start (parent, NULL);
    // modify end
    return 1;
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPTExeSave

 $Description:	called when the user press Save sender in the Option menu
 
 $Returns:		execution status

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsSend_R_OPTExeSave(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT         * data = (T_SMSSEND_R_OPT *)win_data->user;
#ifdef _VIRTUAL_SIM_
    UBYTE index = 2;
#endif

    TRACE_FUNCTION("SmsSend_R_OPTExeSave");

    if( !smsidle_get_ready_state() )
    {
        // SMS init processing not ready to access SIM to store the SMS
        mmi_dialog_information_screen(win, TxtPleaseWait,TxtSimNot, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SAVE_NOT_READY);
        // Recreate the editor on dialog callback
    }
    else
    //END TB
    // Start a save window and provide it a T_SmsUserData structure (in the future, will allow to save easily text but also number...)
    {
        SmsSend_SAVE_start(data->parent_data->win, &(data->parent_data->edt_data));
        SmsSend_R_OPT_destroy(win);
#ifdef _VIRTUAL_SIM_
        sms_signal(E_SMS_SAVE_AVAIL, &index);
#endif
    }
    return 1;
}

/*******************************************************************************

 $Function:    	SmsSend_OPT_start

 $Description:	called when the user press Call sender in the Option menu
 
 $Returns:		execution status

 $Arguments:	parent_window -parent window handle
                menuAttr - Menu attributes.
 
*******************************************************************************/

T_MFW_HND SmsSend_OPT_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsSend_OPT_start()");

    win = SmsSend_R_OPT_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, NULL, (void *)menuAttr);
    }
    return win;
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPT_create

 $Description:	Create the Option window
 
 $Returns:		mfw window handle

 $Arguments:	parent_window -parent window handle
            
*******************************************************************************/

static T_MFW_HND SmsSend_R_OPT_create(MfwHnd parent_window)
{
    T_SMSSEND_R_OPT      * data = (T_SMSSEND_R_OPT *)ALLOC_MEMORY (sizeof (T_SMSSEND_R_OPT));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsSend_R_OPT_create()");

    /*
     * Create window handler
     */

    data->win = 
    win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)SmsSend_R_OPT_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* 
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsSend_R_OPT_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    return data->win;
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPT_destroy

 $Description:	Destroy the Option window
 
 $Returns:		mfw window handle

 $Arguments:	own_window - current window
            
*******************************************************************************/

static void SmsSend_R_OPT_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SMSSEND_R_OPT     * data;

    TRACE_FUNCTION ("SmsSend_R_OPT_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_SMSSEND_R_OPT *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            data->parent_data->options_win = 0;
            win_delete (data->win);

            /*     
             * Free Memory
             */
            FREE_MEMORY ((void *)data, sizeof (T_SMSSEND_R_OPT));
        }
        else
        {
            TRACE_EVENT ("SmsSend_R_OPT_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPT_exec_cb

 $Description:	Exec callback function for the Option window
 
 $Returns:		none

 $Arguments:	win - current window
                event - event id
                value - unique id
                parameter - optional data.
            
*******************************************************************************/

void SmsSend_R_OPT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
/* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSSEND_R_OPT  * data     = (T_SMSSEND_R_OPT *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SEND  * parent_data =  (T_SEND *)win_data2->user;

    T_MFW_EVENT         MfwEvents;
    char * title;
    /* copy the data of SMS, like index, org_addr*/
    /*!!!	if(parameter)
            memcpy (&data->sms_editor_data, sms_data, sizeof (T_SMS_EDITOR_DATA));
    */
    TRACE_FUNCTION ("SmsSend_R_OPT_exec_cb()");


    switch( event )
    {
    case E_INIT:

        TRACE_EVENT("SmsSend_R_OPT_exec_cb() Event:5.E_INIT");
        /* initialization of administrative data */
        data->parent_data = parent_data;        
        data->id = value;
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)SmsSend_R_OPT_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)SmsSend_R_OPT_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtSoftOptions);  // get the editor title text
        if( Send_state==E_COMMON_MSG )
            data->menu = mnuListCreate(data->win,&SmsCM_R_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsSend_R_OPT_mnu_cb,title);
        else if( Send_state==E_REPLY )
            data->menu = mnuListCreate(data->win,&Sms_rpl_fwr_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsSend_R_OPT_mnu_cb,title);
        else
            data->menu = mnuListCreate(data->win,&SmsSend_R_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsSend_R_OPT_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);
        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
        break;
    default:
        return;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPT_mnu_cb

 $Description:	Menu callback function for the Option window
 
 $Returns:		none

 $Arguments:	e - event id
                m - menu handle
*******************************************************************************/

static int SmsSend_R_OPT_mnu_cb (MfwEvt e, MfwMnu *m)

{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT      * data = (T_SMSSEND_R_OPT *)win_data->user;
    T_MFW_HND  * l_parent;
    SHORT        l_id;

    TRACE_FUNCTION ("SmsRead_R_OPT_mnu_cb()");

    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        SmsSend_R_OPT_destroy(data->win);
        break;
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPT_win_cb

 $Description:	Window callback function for the Option window
 
 $Returns:		execution status

 $Arguments:	e - event id
                w - window handle 
*******************************************************************************/

static int SmsSend_R_OPT_win_cb (MfwEvt e, MfwWin *w)
{
    TRACE_FUNCTION ("SmsSend_R_OPT_win_cb()");

    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPT_kbd_cb

 $Description:	Exec callback function for the Option window
 
 $Returns:		execution status

 $Arguments:	e - event id
                k - keyboard info
*******************************************************************************/

static int SmsSend_R_OPT_kbd_cb (MfwEvt e, MfwKbd *k)
/* SmsRead_R_OPT keyboard event handler */
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT      * data = (T_SMSSEND_R_OPT *)win_data->user;

    TRACE_FUNCTION ("SmsSend_R_OPT_kbd_cb()");

    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
            returntoidle(0);
            //mnuEscape(data->menu);
            break;
        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
            if( returntoidle(0) )
                break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        case KCD_0://2004-05-10 Sunny add
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
            mnuKeyAction(data->menu, k->code);
            break;//2004-05-10 Sunny add end
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsSend_SEND_start

 $Description:	Create SMS send window
 
 $Returns:		execution status

 $Arguments:	parent_window - parent window.
                UserData - SMS data
*******************************************************************************/

T_MFW_HND SmsSend_SEND_start(T_MFW_HND parent_window, T_SmsUserData *UserData)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsSend_SEND_start()");
    parentWindow4SMS = parent_window;
    win = SmsSend_SEND_create (parent_window);

    if( win NEQ NULL )
    {
        //        SEND_EVENT (win, E_INIT, SEND_ID, (void *)UserData,);/* 2004/4/20, wangyan modify */
        SEND_EVENT (win, E_INIT, SEND_ID, (void *)UserData);
        call_data.win_sms=win;//zy 2003-04-01 if there a smssend win call_data.win_sms should have data
    }
    return win;
}

/*******************************************************************************

 $Function:    	SmsSend_SEND_create

 $Description:	Create a window for entering the text
 
 $Returns:		window handle

 $Arguments:	parent_window - parent window.
                
*******************************************************************************/

static T_MFW_HND SmsSend_SEND_create(MfwHnd parent_window)
{
    T_SEND     * data = (T_SEND *)ALLOC_MEMORY (sizeof (T_SEND));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsSend_SEND_create()");

    // Create window handler
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }

    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsSend_main_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (MfwUserDataPtr)data;
    data->parent             = parent_window;
    data->id                                 = SEND_ID;

    winShow(data->win);
    return data->win;
}

/*******************************************************************************

 $Function:    	SmsSend_SEND_destroy

 $Description:	Destroy the windows for entering the text
 
 $Returns:		none

 $Arguments:	own_window - window.
                
*******************************************************************************/
void SmsSend_SEND_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SEND    * data = NULL; 

    TRACE_FUNCTION ("SmsSend_SEND_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        if( win_data != NULL )
            data = (T_SEND *)win_data->user;

        if( data )
        {

            // Delete sms handle
            if( data->sms_handler != NULL )
                sms_delete(data->sms_handler);

            if( data->child_dialog != NULL )
            {
                TRACE_EVENT("child_dialog not deleted?");
            }

            if( data->text_editor != NULL )
            {
                TRACE_EVENT("current_editor not deleted?");
                /* 2003/12/04 sunsj */
                //editor_destroy(data->text_editor);
                text_input_destroy(data->text_editor);
                data->text_editor = 0;

            }
            if( data->number_editor!=NULL )
            {
                editor_destroy(data->number_editor);
                data->number_editor = 0;
            }

            // Delete WIN handler 
            win_delete (data->win);

            // Free Memory
            FREE_MEMORY ((void *)data, sizeof (T_SEND));
            call_data.win_sms=0;//zy 2003-04-01 if smssend win destroy this data should be set to 0
            //win_data->user = NULL; 
        }
        else
        {
            TRACE_EVENT ("SmsSend_SEND_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	SmsSend_main_exec_cb

 $Description:	Main callback handler for events sent to to trigger execution
 
 $Returns:		none

 $Arguments:	win - current window
                event - event id
                identifier - unique id
                parameter - optional data.
*******************************************************************************/

static void SmsSend_main_exec_cb (T_MFW_HND win, USHORT event, SHORT identifier, void * parameter)
{
    TRACE_FUNCTION ("SmsSend_main_exec_cb()");

    /* In this field we get the identifier of the window sending the event */
    switch( identifier )
    {
    case SEND_ID:
    case SAVE_ID:   // events from the SAVE window are also managed in the SEND callback
    case SMSSEND_ID_SAVE_NOT_READY:
        SmsSend_SEND_exec_cb(win, event, parameter);
        break;
    case PHBK_ID:
        SmsSend_PHBK_exec_cb(win, event, parameter);
        break; 
    case SMSSEND_ID_TEXTEDIT:
    case SMSSEND_ID_CM_TEXTEDIT:
        SmsSend_TEXTEDIT_exec_cb(win, event, parameter);
        break;
    case SMSSEND_ID_NBEDIT:
    case SMSSEND_ID_SC_NOT_READY: 
        SmsSend_NBEDIT_exec_cb(win, event, parameter);
        break;
    case SMSSEND_ID_CENTREEDIT:
        SmsSend_CENTREEDIT_exec_cb(win, event, parameter);
        break;
    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_SEND_exec_cb

 $Description:	Callback handler for events sent by the window itself
 
 $Returns:		none

 $Arguments:	win - current window
                event - event id
                parameter - optional data.
*******************************************************************************/

static void SmsSend_SEND_exec_cb(T_MFW_HND win, USHORT event, void *parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND         * data = (T_SEND *)win_data->user;
    T_SmsUserData    UserData;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_SMS_INFO    sms_parameter;


    T_MFW_EVENT     MfwEvents;
    //#ifdef NO_ASCIIZ_MMI
    //#ifdef NO_ASCIIZ			
    //    T_EDITOR2_DATA	editor_data;
    //#else
    T_EDITOR_DATA   editor_data;
    //#endif

    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("SmsSend_SEND_exec_cb()");

    switch( event )
    {
    case E_INIT:
        /* Create a sms handler to receive events  */
        MfwEvents = E_SMS_ERR | E_SMS_MO_AVAIL|E_SMS_SAVE_AVAIL|E_SMS_MEM_FULL;
        data->sms_handler = sms_create(data->win,MfwEvents,(MfwCb)SmsSend_SEND_mfw_cb);
        data->child_dialog = NULL;
        memcpy(&(data->edt_data), (T_SmsUserData *)parameter, sizeof(T_SmsUserData));
        Send_state=data->edt_data.Send_state;
        /* if it 's now forward or reply a sms,we need store NUMBER and TEXT */
        if( Send_state == E_FORWARD||  Send_state ==E_COMMON_MSG )
        {
            memset(data->edt_data.NumberBuffer,0,sizeof(data->edt_data.NumberBuffer));
            if( ((T_SmsUserData *)parameter)->TextBuffer[0]==0x80 &&
                wstrlen((char*)((T_SmsUserData *)parameter)->TextBuffer)>MAX_EDIT_MSG_LEN-2 )
            {
                memset(data->edt_data.TextBuffer,0,sizeof(data->edt_data.TextBuffer));
                memcpy((char*)data->edt_data.TextBuffer,(char*)((T_SmsUserData *)parameter)->TextBuffer,MAX_EDIT_MSG_LEN-2);
            }
            else if( ((T_SmsUserData *)parameter)->TextBuffer[0]!=0x80 &&
                     wstrlen((char*)((T_SmsUserData *)parameter)->TextBuffer)>MAX_EDIT_MSG_LEN+20-3 )
            {
                memset(data->edt_data.TextBuffer,0,sizeof(data->edt_data.TextBuffer));
                memcpy((char*)data->edt_data.TextBuffer,(char*)((T_SmsUserData *)parameter)->TextBuffer,MAX_EDIT_MSG_LEN+20-3);
            }
        }
        else if( Send_state == E_SEND )
        {
            //if( LastTextBuffer[0]!='\0')
            //	memcpy((char*)data->edt_data.TextBuffer,(char*) LastTextBuffer, sizeof(LastTextBuffer));
            //else
            memset(data->edt_data.TextBuffer,0,sizeof(data->edt_data.TextBuffer));//wx 2003-04-03 don't set zero only call sms send
            //if( LastNumberBuffer[0]!='\0')
            //	memcpy((char*)data->edt_data.NumberBuffer, (char*)LastNumberBuffer, sizeof(LastNumberBuffer));
            //else
            memset(data->edt_data.NumberBuffer,0,sizeof(data->edt_data.NumberBuffer));//wx 2003-04-03 don't set zero only call sms send

        }
        else if( Send_state==E_REPLY )
        {
            memset(data->edt_data.TextBuffer,0,sizeof(data->edt_data.TextBuffer));
        }
        /* in case of reply the sms we have to use the service center number from the caller 
         */
        if( data->edt_data.called_from_reply_item EQ FALSE )
        {
            // The SMS center is initialized to '\0'
            data->edt_data.CentreBuffer[0] = '\0';
        }

        /* open the common editor */
        //		#ifdef NO_ASCIIZ_MMI
        //#ifdef NO_ASCIIZ					
        //			SmsSend_loadUCS2EditDefault(&editor_data);

        //			editor_data.text     = (wstring_t *)&data->edt_data.w_TextBuffer;  
        //			editor_data.max_length = MAX_MSG_LEN; 

        //			data->current_editor = editor2_start(win,&editor_data);  /* start the editor */ 			
        //#else

        SmsSend_loadEditDefault(&editor_data);
#if 1//EASY_TEXT_ENABLED
        //editor_attr_init_pred(&editor_data.editor_attr, NULL, edtCurBar1, 0, 0, 0);
        if( Send_state ==E_COMMON_MSG )
        {
            editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtCommonMsg,(char *)data->edt_data.TextBuffer,MAX_COMSG_LEN,edtCurBar1);
            editor_data.Identifier           = SMSSEND_ID_CM_TEXTEDIT ; 
        }
        else
        {
            editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtMessages,(char *)data->edt_data.TextBuffer,MAX_EDIT_MSG_LEN,edtCurBar1);
            editor_data.Identifier           = SMSSEND_ID_TEXTEDIT ; 
        }
        editor_data.min_enter                = 0; 
        //JVJE			editor_data.zone_id				 = ZONE_FULL_EDITOR;				 								
        //if(Send_state == E_FORWARD)
        //editor_data.LeftSoftKey          = TxtSoftOK;
        //else if(Send_state==E_REPLY)
        //editor_data.LeftSoftKey          = TxtSend;
        //else
        editor_data.LeftSoftKey          = TxtConfirm;  /* 2004/03/30 sunsj modify */
        editor_data.edtInPbk             = 0;
        editor_data.AlternateLeftSoftKey = TxtSoftOptions;
        editor_data.RightSoftKey         = TxtDelete;
        editor_data.Callback             = (T_EDIT_CB)SmsSend_TEXTEDIT_edit_cb;
        editor_data.destroyEditor        = FALSE;
        editor_data.mode                 = TEXTINPUT_MODE;     /* 2003/12/04 sunsj modify */
        editor_data.InputMode            = PINYIN_INPUT_MODE;  /* 2003/12/04 sunsj set default input mode */
#endif
        if( Send_state != E_COMMON_MSG )
		{
			/* 2004/06/29 sunsj modify for long message */
#ifdef _M188_
            editor_data.editor_attr.e_size = 163;
#else
			editor_data.editor_attr.e_size = 573;
#endif
		}
        //set_esize (163, data->text_editor);
        Send_ed_state=SEND_EDIT;
        /* 2003/12/04 sunsj modify for new editor mode */
        if( editor_data.mode == TEXTINPUT_MODE )
        {
            data->text_editor = text_input(win, &editor_data);
        }
        else
        {
            data->text_editor = editor_start(win,&editor_data);  /* start the editor */
        }

        //#endif
        /* Marcus: Issue 1170: 07/10/2002: Start */
        /*
         * Set whether status requests are to be indicated according to the
         * value of the srr field of the T_MFW_SMS_INFO structure.
         */
        SmsSend_get_config_data(&sms_parameter);
		
//glowing,2004-06-16, TCS2112 does not define MT_IND_SRR_OFF, MT_IND_SRR_ON
#ifdef _M188_		
        switch( sms_parameter.srr )
        {
        case SMS_NOT_REQUESTED_SRR:
            sms_set_mt_ind(MT_IND_SRR_OFF);
            break;

        case SMS_REQUESTED_SRR:
            sms_set_mt_ind(MT_IND_SRR_ON);
            break;

        default:
            TRACE_EVENT_P1("default: sms_parameter.srr = %d", sms_parameter.srr);
            break;
        }
#endif	
//glowing,2004-06-16, end of modify

        /* Marcus: Issue 1170: 07/10/2002: Start */
        break;
    case E_RETURN: 
        break;
    case E_EXIT:
        if( data->sc_number_editor != NULL )
        {

            //GW Read config data - then set dcs parameter
            SmsSend_get_config_data(&sms_parameter);
            //windy disable followed code because the dcs has been set before
#if 0
            if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
            {   //We have a chinese text message - set dcs parameter to 
                sms_parameter.dcs = MFW_DCS_UCS2;
            }
            else
            {
                sms_parameter.dcs = MFW_DCS_7bits;

            }
            SmsSend_set_dcs_number (&sms_parameter);
#endif

            // copy the SC number into the sms_parameter variable.
            strcpy((char*)sms_parameter.sc_addr,(char*)data->edt_data.CentreBuffer);
            // store the Service center number into the SIM.
            SmsSend_set_SrvCntr_number (&sms_parameter);

            editor_destroy(data->sc_number_editor);
            data->sc_number_editor = NULL;
        }
        //added by windy I think this win is no use
#if 1
        if( data->text_editor != NULL )
        {
            /* 2003/12/04 sunsj modify for new editor mode */
            text_input_destroy(data->text_editor);
            //editor_destroy(data->text_editor);
            data->text_editor = 0;
        }
#endif
        SmsSend_SEND_destroy(data->win);
        if( !call_data.win )
            SEND_EVENT (parent, E_BACK, data->id, NULL);
        break;
    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_PHBK_exec_cb

 $Description:	Callback handler for events sent by the phonebook window
 
 $Returns:		none

 $Arguments:	win - current window
                event - event id
                parameter - optional data.
*******************************************************************************/

static void SmsSend_PHBK_exec_cb(T_MFW_HND win, USHORT event, void *parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND         * data = (T_SEND *)win_data->user;
    T_EDITOR_DATA       editor_data;

    TRACE_FUNCTION ("SmsSend_PHBK_exec_cb()");

    switch( event )
    {
    case SMS_PHBK_NUMBER:
        memcpy(data->edt_data.NumberBuffer, (char *)parameter, MINIMUM(sizeof(data->edt_data.NumberBuffer) - 1, strlen((char *)parameter)+1));
        // NO BREAK!
        /* 2004/05/26 sunsj modify */
        SetPhbkIN(0);
        break;
    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}


/*******************************************************************************

 $Function:    	SmsSend_TEXTEDIT_exec_cb

 $Description:	Callback handler for events sent by the TEXTEDIT editor
 
 $Returns:		none

 $Arguments:	win - current window
                event - event id
                parameter - optional data.
*******************************************************************************/

static void SmsSend_TEXTEDIT_exec_cb(T_MFW_HND win, USHORT event, void *parameter)
{
    TRACE_FUNCTION ("SmsSend_TEXTEDIT_exec_cb()");

    switch( event )
    {
    case E_RETURN:
        // Destroy itself
        SmsSend_SEND_destroy(win);
        break;
    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_NBEDIT_exec_cb

 $Description:	Callback handler for events sent by the NBEDIT editor

 $Returns:		none

 $Arguments:	win - current window
                event - event id
                parameter - optional data.
*******************************************************************************/

static void SmsSend_NBEDIT_exec_cb(T_MFW_HND win, USHORT event, void *parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND         * data = (T_SEND *)win_data->user;
    T_MFW_SMS_INFO sms_parameter;
    T_EDITOR_DATA editor_data;
    T_MFW_HDR    * parent  =  data->parent;

    TRACE_FUNCTION ("SmsSend_NBEDIT_exec_cb()");

#ifdef _INNOVATION_EMULATOR_
    memset((void*)&editor_data, 0, sizeof(T_EDITOR_DATA));
#endif

    switch( event )
    {
    case E_INIT:
        if( (phb_get_mode() EQ PHB_RESTRICTED)
            && (phb_check_number(data->edt_data.NumberBuffer) EQ MFW_PHB_FAIL) )
        {
            mmi_dialog_information_screen(win,TxtNotImplemented, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_ALLOWED);
        }
        else
        {
            if( !smsidle_get_ready_state() )
            {
                // SMS init processing not ready to access SIM to store the SMS
                mmi_dialog_information_screen(win,TxtPleaseWait,TxtSimNot, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SC_NOT_READY);
                // Recreate the editor on dialog callback
            }
            else
            {
                //END TB
                // First check if the SMS center is specified
                SmsSend_get_config_data(&sms_parameter);

                if( sms_parameter.sc_addr[0] EQ '\0' )
                {
                    memset(data->edt_data.CentreBuffer,0,NUMBER_LENGTH);
                }
                else
                {
                    strcpy((char *)data->edt_data.CentreBuffer, (char *)sms_parameter.sc_addr);
                }
                /* start the editor */ 
                editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtServiceCentre,
                                         (char *)data->edt_data.CentreBuffer,PHB_MAX_LEN,edtCurBar1);
                if( data->edt_data.CentreBuffer[0] EQ '\0' )
                {
                    editor_data.LeftSoftKey    = TxtNull;
                    editor_data.AlternateLeftSoftKey = TxtSave;
                }
                else
                {
                    editor_data.LeftSoftKey    = TxtSave;
                    editor_data.AlternateLeftSoftKey = TxtSave;
                }
                /*if don't set edtInpbk's value will cause crash when you press up and down key*/
                editor_data.edtInPbk           = 0;
                editor_data.RightSoftKey       = TxtDelete;
                editor_data.Identifier         = NULL; 
                editor_data.Callback           = (T_EDIT_CB)SmsSend_SCNBEDIT_edit_cb;
                editor_data.mode               = PHONENUMONLY_MODE;
                editor_data.destroyEditor      = FALSE;
                editor_data.timeout= FOREVER;
                editor_data.hide= FALSE;
                data->number_editor = editor_start(data->win,&editor_data);  
            }
        }   
        break;

    case E_RETURN:  //added by windy
        SmsSend_SEND_destroy(data->win);
        SEND_EVENT (parent, E_RETURN, data->id, NULL);
        break;
    case E_BACK:    //added by windy
        break;

    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_CENTREEDIT_exec_cb

 $Description:	Callback handler for events sent by the CENTREEDIT editor

 $Returns:		none

 $Arguments:	win - current window
                event - event id
                parameter - optional data.
*******************************************************************************/

static void SmsSend_CENTREEDIT_exec_cb(T_MFW_HND win, USHORT event, void *parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND         * data = (T_SEND *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;

    T_EDITOR_DATA editor_data;

    TRACE_FUNCTION ("SmsSend_CENTREEDIT_exec_cb()");

    switch( event )
    {
    case E_INIT:
        SmsSend_loadEditDefault(&editor_data);
        editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtServiceCentre,(char *)data->edt_data.CentreBuffer,
                                 NUMBER_LENGTH,edtCurBar1);
        editor_data.edtInPbk           = 0;
        editor_data.LeftSoftKey        = TxtSoftOK;
        editor_data.RightSoftKey       = TxtDelete;
        //memcpy(&editor_data.Identifier,(USHORT*)parameter,sizeof(USHORT)); 
        editor_data.Identifier      =*(USHORT*)parameter;
        editor_data.Callback        = (T_EDIT_CB)SmsSend_CENTREEDIT_edit_cb;
        editor_data.mode            = PHONENUMONLY_MODE;
        editor_data.destroyEditor   = FALSE ; 
        data->sc_number_editor      = editor_start(data->win,&editor_data);  
        /* start the Service Centre Number editor */ 

        break;

    case E_RETURN:
    case E_EXIT:
        editor_destroy(data->sc_number_editor);
        data->sc_number_editor = 0;
        SmsSend_R_OPT_destroy(data->options_win);
        SmsSend_SEND_destroy(data->win);
        SEND_EVENT (parent, E_RETURN, data->id, NULL);
        break;
    default:
        TRACE_EVENT("Err: Default");
        return;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_TEXTEDIT_edit_cb

 $Description:	Callback function for the text editor

 $Returns:		none

 $Arguments:	win - current window
                Identifier - unique id
                reason - event cause
*******************************************************************************/

static void SmsSend_TEXTEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND              * data     = (T_SEND *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    T_EDITOR_DATA editor_data;
    T_MFW_SMS_INFO  sms_parameter;
    USHORT parameter;

    TRACE_FUNCTION ("SmsSend_TEXTEDIT_edit_cb()");

    switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
    case INFO_KCD_LEFT:
        if( Send_state==E_COMMON_MSG )
            data->options_win = SmsSend_OPT_start(win,&SmsCM_R_OPTAttrib);
        else
        {
            //memset((char*)LastTextBuffer,0, sizeof(LastTextBuffer));
            //memcpy((char*)LastTextBuffer,(char*)data->edt_data.TextBuffer, sizeof(LastTextBuffer));
            data->options_win = SmsSend_OPT_start(win,&SmsSend_R_OPTAttrib);
        }
#if 0
        if( Send_state  ==  E_FORWARD )
        {
#if 0
            Send_save=E_SENDSAVE;
            SmsSend_loadEditDefault(&editor_data);
            editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtEnterNumber,
                                     (char *)data->edt_data.NumberBuffer,PHB_MAX_LEN,edtCurBar1);
            /*if don't set edtInpbk's value will cause crash when you press up and down key*/
            editor_data.edtInPbk           = 0;
            editor_data.LeftSoftKey          =TxtSend ;
            editor_data.AlternateLeftSoftKey  = TxtFind;
            editor_data.RightSoftKey         = TxtDelete;
            editor_data.Identifier           = SMSSEND_ID_NBEDIT ; 
            editor_data.Callback             = (T_EDIT_CB)SmsSend_NBEDIT_edit_cb;
            editor_data.destroyEditor        = FALSE;
            editor_data.mode=PHONENUMONLY_MODE  ;
            data->number_editor = editor_start(data->win, &editor_data);  /* start the editor */ 
#endif
            memset((char*)LastTextBuffer,0, sizeof(LastTextBuffer));
            memcpy((char*)LastTextBuffer,(char*)data->edt_data.TextBuffer, sizeof(LastTextBuffer));
            data->options_win = SmsSend_OPT_start(win,&SmsSend_R_OPTAttrib);
        }
        else if( Send_state==E_REPLY )
        {
            if( (phb_get_mode() EQ PHB_RESTRICTED)
                && (phb_check_number(data->edt_data.NumberBuffer) EQ MFW_PHB_FAIL) )
            {
                mmi_dialog_information_screen(win,TxtNotImplemented, 0, 
                                              (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_ALLOWED);
            }
            else
            {
                if( !smsidle_get_ready_state() )
                {
                    // SMS init processing not ready to access SIM to store the SMS
                    mmi_dialog_information_screen(win,TxtPleaseWait, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SC_NOT_READY);
                    // Recreate the editor on dialog callback
                }
                else
                {
                    //END TB
                    // First check if the SMS center is specified
                    SmsSend_get_config_data(&sms_parameter);
                    if( sms_parameter.sc_addr[0] EQ '\0' )
                    {
                        //setup identifier value.
                        parameter = SMSSEND_ID_CENTREEDIT;
                        SmsSend_CENTREEDIT_exec_cb(win, E_INIT,(void*)&parameter);
                    }
                    else
                    {
                        /*NM FTA 34.2.8*/
                        if( data->edt_data.called_from_reply_item EQ FALSE )
                        {
                            TRACE_EVENT("take the own serviceCenternum");
                            strcpy((char *)data->edt_data.CentreBuffer, (char *)sms_parameter.sc_addr);
                            {
                                char buf[30];
                                sprintf(buf,"serviceNr:%s",data->edt_data.CentreBuffer);
                                TRACE_EVENT(buf);
                            }
                        }
                        else
                        {
                            TRACE_EVENT("from the caller, reply");
                            /* in case of reply the sms, we took already the 
                               the service center number from the caller !!!*/
                            {
                                char buf[30];
                                sprintf(buf,"serviceNr:%s",data->edt_data.CentreBuffer);
                                TRACE_EVENT(buf);
                            }
                        }
                        /*NM FTA 34.2.8*/
                        Send_save=E_SENDSAVE;
                        SmsSend_send_to_mfw(win);
                    }
                }
            }
            memset((char*)LastTextBuffer,0, sizeof(LastTextBuffer));
            memcpy((char*)LastTextBuffer,(char*)data->edt_data.TextBuffer, sizeof(LastTextBuffer));
            data->options_win = SmsSend_OPT_start(win,&Sms_rpl_fwr_OPTAttrib);
        }
        else
#endif
            /* Create number editor:                                 
              -the editor min length is 1
                 */
            break;

    case INFO_KCD_CALL:
        Send_ed_state=SEND_USE_COMMON_MSG;
        smscb_common_msg_start (data->win, NULL);
        //SmsSend_SEND_destroy(data->win);
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        // Commit suicide so come back to previous menu
        //#if defined(CHINESE_MMI) && defined(EASY_TEXT_ENABLED)
        //if (Mmi_getCurrentLanguage() == CHINESE_LANGUAGE)
        //	chinese_input_destroy(data->text_editor);
        //else
        //#endif
        /* 2003/12/04 sunsj */
        text_input_destroy(data->text_editor);
        //editor_destroy(data->text_editor);
        data->text_editor = 0;
        SmsSend_SEND_destroy(data->win);
        if( !call_data.win )
            SEND_EVENT (parent, E_RETURN, data->id, NULL);//zy 2003-04-01 move it avoid smssend in call win will crash
        break;

    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}


/*******************************************************************************

 $Function:    	SmsSend_NBEDIT_edit_cb

 $Description:	Callback function for the number editor

 $Returns:		none

 $Arguments:	win - current window
                Identifier - unique id
                reason - event cause
*******************************************************************************/

static void SmsSend_NBEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND      * data     = (T_SEND *)win_data->user;

    T_EDITOR_DATA       editor_data;
    T_MFW_SMS_INFO  sms_parameter;
    USHORT parameter;


    TRACE_FUNCTION ("SmsSend_NBEDIT_edit_cb()");

    //JVJE	data->text_editor = NULL;

    switch( reason )
    {
    case INFO_KCD_LEFT:
        // Check if we can go to the next stage
        if( (phb_get_mode() EQ PHB_RESTRICTED)
            && (phb_check_number(data->edt_data.NumberBuffer) EQ MFW_PHB_FAIL) )
        {

            mmi_dialog_information_screen(win,TxtNotImplemented, 0, 
                                          (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_ALLOWED);

        }
        else
        {

            if( !smsidle_get_ready_state() )
            {
                // SMS init processing not ready to access SIM to store the SMS
                mmi_dialog_information_screen(win,TxtPleaseWait,TxtSimNot, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SAVE_NOT_READY);
                // Recreate the editor on dialog callback
            }
            else
            {
                //END TB
                // First check if the SMS center is specified
                SmsSend_get_config_data(&sms_parameter);

                if( sms_parameter.sc_addr[0] EQ '\0' )
                {
                    //setup identifier value.
                    parameter = SMSSEND_ID_CENTREEDIT;
                    SmsSend_CENTREEDIT_exec_cb(win, E_INIT,(void*)&parameter);
                    SmsSend_R_OPT_destroy(data->options_win);
                }
                else
                {
                    /*NM FTA 34.2.8*/
                    if( data->edt_data.called_from_reply_item EQ FALSE )
                    {
                        TRACE_EVENT("take the own serviceCenternum");
                        strcpy((char *)data->edt_data.CentreBuffer, (char *)sms_parameter.sc_addr);

                        {
                            char buf[30];
                            sprintf(buf,"serviceNr:%s",data->edt_data.CentreBuffer);
                            TRACE_EVENT(buf);
                        }

                    }
                    else
                    {
                        TRACE_EVENT("from the caller, reply");
                        /* in case of reply the sms, we took already the 
                           the service center number from the caller !!!*/
                        {
                            char buf[30];
                            sprintf(buf,"serviceNr:%s",data->edt_data.CentreBuffer);
                            TRACE_EVENT(buf);
                        }
                    }
                    /*NM FTA 34.2.8*/
                    //memset((char*)LastNumberBuffer,0, sizeof(LastNumberBuffer));
                    //memcpy((char*)LastNumberBuffer,(char*)data->edt_data.NumberBuffer, sizeof(LastNumberBuffer));
                    //editor_destroy(data->number_editor);
                    //data->number_editor = 0;
                    if( Send_state  ==  E_SEND|| Send_state ==  E_COMMON_MSG||Send_state    ==  E_FORWARD )
                        SmsSend_R_OPT_destroy(data->options_win);
                    SmsSend_send_to_mfw(win);
                }
            }
        }
        break;

    case INFO_KCD_ALTERNATELEFT:
        /* 2004/05/26 sunsj add */
        SetPhbkIN(1);

        bookPhonebookStart(win, PhbkFromSms);
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        editor_destroy(data->number_editor);
        data->number_editor = 0;
        break;

    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_CENTREEDIT_edit_cb

 $Description:	Callback function for the center number editor

 $Returns:		none

 $Arguments:	win - current window
                Identifier - unique id
                reason - event cause
*******************************************************************************/

static void SmsSend_CENTREEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND      * data     = (T_SEND *)win_data->user;

    TRACE_FUNCTION ("SmsSend_CENTREEDIT_edit_cb()");
    switch( reason )
    {
    case INFO_KCD_LEFT:
        TRACE_EVENT("SmsSend_CENTREEDIT_edit_cb,INFO_KCD_LEFT ");
        if( Identifier==SMSSEND_ID_CENTREEDIT )
        {
            TRACE_EVENT("SmsSend_CENTREEDIT_edit_cb,INFO_KCD_LEFT Send to mfw ");

            //if(	Send_state	==	E_SEND|| Send_state	==	E_COMMON_MSG||Send_state	==	E_REPLY)
            SmsSend_R_OPT_destroy(data->options_win);
            //Submit the SMS message to the service centre.
            SmsSend_send_to_mfw(win);
        }
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        /* send an event that will lead to the display of the number edition window */
        SEND_EVENT (win, E_RETURN, SMSSEND_ID_CENTREEDIT, NULL);
        break;
    default:

        break;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_SEND_mfw_cb

 $Description:	Callback functyion for handling SMS events from the MFW.

 $Returns:		execution status

 $Arguments:	event - window event id
                info -  optional info
                reason - event cause
*******************************************************************************/

static int SmsSend_SEND_mfw_cb (MfwEvt event, void *info)
{
    /* get the top window*/
    T_MFW_HND win         = mfw_parent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SEND     * data     = (T_SEND *)win_data->user;
    T_MFW_SMS_INFO  sms_parameter;
    USHORT outLen;
    UBYTE* msgBuffer;
    int i;/* 2004/4/20, wangyan modify */
    FlashSms * tmp;/* 2004/4/20, wangyan modify */

    MMI_TRACE_EVENT(("SmsSend_SEND_mfw_cb() event=%d",event));

    switch( event )
    {
    case E_SMS_SAVE_AVAIL:
        if( data->child_dialog != NULL )
        {
            SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0, NULL);
            data->child_dialog = NULL; 
        }
        if( data->id == SMSSEND_ID_SENT )
            mmi_dialog_information_screen(win,TxtSent, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SENT);
        else if( data->id == SMSSEND_ID_NOT_SENT )
            mmi_dialog_information_screen(win,TxtNotSent, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_SENT);
        break;

        //case E_SMS_MEM_FULL:
        //TRACE_EVENT ("Memory for sms save is full");
        //mmi_dialog_information_screen(win,TxtSmsFull, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SENT);
        //data->id = E_SMS_LIST_FULL;  
        //SEND_EVENT (data->info, E_EXIT, 0, NULL);
        //break;

    case E_SMS_MO_AVAIL:
        TRACE_EVENT ("Sent was successful -> ok");
        /* Sent was successful */ 
        /* abort the current Dialog "Please wait" */ 
        // and the status dialog is displayed during 3 secs.
        data->id = SMSSEND_ID_SENT; 
        sms_update_unsent_msg_info(MFW_SMS_STOR_SENT);/*2004/5/21, wy add*/
        /* 2004/4/6, wangyan  add */
        if( (data->edt_data.msg_type==MFW_SMS_STOR_UNSENT)&&(data->edt_data.sms_type==MENU_MMI_SMS_FLASH_MO) )
        {
            i=Flash_sms_sort_index[g_sms_list_counter].index%FlashSMS_table_len;
            MMI_TRACE_EVENT(("MFW_FLASH_MO i=%d g_sms_list_counter=%d",i,g_sms_list_counter));
            FFS_SMSData.NVMSMS[i].state = MFW_SMS_STOR_SENT;
            memcpy((char *)FFS_SMSData.NVMSMS[i].addr,(char *)data->edt_data.NumberBuffer,MFW_NUM_LEN);
            Flash_sms_messages[Flash_sms_sort_index[g_sms_list_counter].index].state=MFW_SMS_STOR_SENT;
            data->edt_data.msg_type=MFW_SMS_STOR_SENT;
            flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);     
            MMI_TRACE_EVENT(("wangyan i=%d state=%d len=%d",i,FFS_SMSData.NVMSMS[i].state,FFS_SMSData.NVMSMS[i].msg_len));
        }
        /* 2004/4/6, wangyan  add */
        if( ( Send_save ==E_SENDSAVE ) )
        {
            MMI_TRACE_EVENT(("E_SENDSAVE"));
            msgBuffer = mmi_Sys_Sim((char *)(data->edt_data.TextBuffer), &outLen,&(sms_parameter.dcs));
            SmsSend_set_dcs_number (&sms_parameter);
            sms_store( MFW_SMS_SUBMIT_SENT, (char*)data->edt_data.NumberBuffer, msgBuffer, outLen, NULL);
        }
        else
        {
            if( data->child_dialog != NULL )
            {
                SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0, NULL);
                data->child_dialog = NULL; 
            }
            mmi_dialog_information_screen(win,TxtSent, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SENT);
        }
        break;

    case E_SMS_ERR:
        // Waiting dialog is destroyed
        // and the status dialog is displayed during 3 secs.
        // PMC new dialog			SmsMenu_startDialog(win, SMSSEND_ID_NOT_SENT, TxtNotSent, THREE_SECS, (T_VOID_FUNC)SmsSend_standard_dialog_cb);
        if( data->child_dialog != NULL )
        {
            data->id = SMSSEND_ID_NOT_SENT; //TB3
            //if(Send_save ==E_SENDSAVE)
            //{
            //sms_get_memset();
            if( memory.used == memory.total )//smsidle_get_memory_full())
            {
                SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0, NULL);
                data->child_dialog = NULL; 
                mmi_dialog_information_screen(win,TxtNotSent, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_SENT);
            }
            else
            {
                msgBuffer = mmi_Sys_Sim((char *)(data->edt_data.TextBuffer), &outLen,&(sms_parameter.dcs));
                SmsSend_set_dcs_number (&sms_parameter);
                sms_store( MFW_SMS_SUBMIT, (char*)data->edt_data.NumberBuffer, msgBuffer, outLen, NULL);
            }
            //}
        }
        //mmi_dialog_information_screen(win,TxtNotSent, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_SENT);
        break;

    default:
        TRACE_EVENT("Err: default");
        return 0;          
    }

    return 1;
}

/*******************************************************************************

 $Function:    	SmsSend_SAVE_start

 $Description:	Create the Save SMS text window.

 $Returns:		mfw window handle

 $Arguments:	parent_window - parent window 
                UserData - SMS info

*******************************************************************************/

T_MFW_HND SmsSend_SAVE_start(T_MFW_HND parent_window, T_SmsUserData *UserData)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsSend_SAVE_start()");

    win = SmsSend_SAVE_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, (void *)UserData);
    }
    return win;
}

/*******************************************************************************

 $Function:    	SmsSend_SAVE_create

 $Description:	Create a window for info dialog

 $Returns:		mfw window handle

 $Arguments:	parent_window - parent window 

*******************************************************************************/

static T_MFW_HND SmsSend_SAVE_create(MfwHnd parent_window)
{
    T_SAVE     * data = (T_SAVE *)ALLOC_MEMORY (sizeof (T_SAVE));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsSend_SAVE_create()");

    /*
     * Create window handler
     */
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }

    /* 
     * connect the dialog data to the MFW-window
     */
    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsSend_SAVE_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (MfwUserDataPtr)data;
    data->parent             = parent_window;
    data->id                 = SAVE_ID;

    winShow(data->win);
    return data->win;
}

/*******************************************************************************

 $Function:    	SmsSend_SAVE_destroy

 $Description:	Destroy the windows for info dialog

 $Returns:		none

 $Arguments:	own_window - current window 

*******************************************************************************/

static void SmsSend_SAVE_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SAVE    * data = NULL; 

    TRACE_FUNCTION ("SmsSend_SAVE_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        if( win_data )
            data = (T_SAVE *)win_data->user;

        if( data )
        {
            // Delete sms handle
            if( data->sms_handler != NULL )
                sms_delete(data->sms_handler);

            if( data->child_dialog != NULL )
            {
                TRACE_EVENT("child_dialog not deleted?");
            }

            // Delete WIN handler 
            win_delete (data->win);

            // Free Memory
            FREE_MEMORY ((void *)data, sizeof (T_SAVE));

        }
        else
        {
            TRACE_EVENT ("SmsSend_SAVE_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	SmsSend_SAVE_exec_cb

 $Description:	Callback handler for events sent to to trigger execution

 $Returns:		none

 $Arguments:	own_window - current window 

*******************************************************************************/

void SmsSend_SAVE_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SAVE         * data = (T_SAVE *)win_data->user;
    T_MFW_SMS_INFO  sms_parameter;
    USHORT outLen;

    //TB3 T_MFW_EVENT	   MfwEvents;
    //TB3 T_MFW_HND      * l_parent;
    //TB3 T_DISPLAY_DATA   display_info;
    T_MFW store_status;
    UBYTE* msgBuffer;

    TRACE_FUNCTION ("SmsSend_SAVE_exec_cb()");

    switch( event )
    {
    case E_INIT:        
        data->child_dialog = NULL; 

        /* Create a sms handler to receive events  */
        //MfwEvents = E_SMS_SAVE_AVAIL | E_SMS_ERR | E_SMS_MEM_FULL;
        //data->sms_handler = sms_create(data->win,MfwEvents,(MfwCb)SmsSend_SAVE_mfw_cb);
        data->sms_handler = sms_create(data->win,E_SMS_SAVE_AVAIL | E_SMS_ERR | E_SMS_MEM_FULL
                                       ,(MfwCb)SmsSend_SAVE_mfw_cb);

        // Copy the input data in the private structure of the window
        memcpy(&data->edt_data, (T_SmsUserData *)parameter, sizeof(T_SmsUserData));
#if 0
        if( data->edt_data.TextBuffer[0] == 0x80 )
        {   //String is unicode - 
            sms_parameter.dcs = MFW_DCS_UCS2;
        }
        else
        {
            sms_parameter.dcs = MFW_DCS_7bits;
        }
        SmsSend_set_dcs_number (&sms_parameter);
#endif

#ifdef NO_ASCIIZ
        {
            // have to add this , later
            //msgBuffer = convertToUnicodeForOutput(data->edt_data.TextBuffer, &outLen);
            msgBuffer = mmi_Sys_Sim((char *)(data->edt_data.TextBuffer), &outLen,&(sms_parameter.dcs));
            SmsSend_set_dcs_number (&sms_parameter);
            memset((char*)data->edt_data.NumberBuffer,0,sizeof(data->edt_data.NumberBuffer));
            store_status = sms_store(MFW_SMS_SUBMIT, (char*)data->edt_data.NumberBuffer, msgBuffer, outLen, NULL);
        }
#else		
        {
            //msgBuffer = convertToUnicodeForOutput(data->edt_data.TextBuffer, &outLen);
            msgBuffer = mmi_Sys_Sim((char *)(data->edt_data.TextBuffer), &outLen,&(sms_parameter.dcs));
            SmsSend_set_dcs_number (&sms_parameter);
            memset((char*)data->edt_data.NumberBuffer,0,sizeof(data->edt_data.NumberBuffer));
            store_status = sms_store(MFW_SMS_SUBMIT, (char*)data->edt_data.NumberBuffer, msgBuffer, outLen, NULL);
            // sbh - added length to the above function call, since '@' characters stored as NULL & will stop
            // strlen from working properly.
        }
#endif
#if 0
        /*  display "Please wait" for save sms */
        if( store_status EQ MFW_SMS_OK )
        {
            TRACE_EVENT ("Save operation  -> ok");
            /* show now to user "Please wait" for save*/
            // Do not start please wait if ever the MFW result event as already been received
            if( data->child_dialog == NULL )
                //RAD New dialog					data->child_dialog = SmsMenu_startDialog(win, SMSSEND_ID_WAIT_SAVE, TxtPleaseWait, FOREVER, (T_VOID_FUNC)SmsSend_standard_dialog_cb);
                data->child_dialog = mmi_dialog_information_screen(win,TxtPleaseWait, "SAVING", (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_WAIT_SAVE);


        }
        else
        {
            TRACE_EVENT ("Save operation -> failed");

            // If the memory full event has already been received do not display this message
            if( data->child_dialog == NULL )
                mmi_dialog_information_screen(win, TxtFailed,"NOT SAVED", (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_SAVED);

        }
#endif
        break;

    default:
        TRACE_EVENT("Err: default");
        return;
    }
}

/*******************************************************************************

 $Function:    	SmsSend_SAVE_mfw_cb

 $Description:	Handles SMS events from the MFW.

 $Returns:		none

 $Arguments:	event - event id
                info - optional info

*******************************************************************************/

static int SmsSend_SAVE_mfw_cb (MfwEvt event, void *info)
{
    /* get the top window*/
    T_MFW_HND win         = mfw_parent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SAVE     * data     = (T_SAVE *)win_data->user;

    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION ("SmsSend_SAVE_mfw_cb");

    switch( event )
    {
    /* Save is successful */   
    case E_SMS_SAVE_AVAIL:
        // Waiting dialog is destroyed

        if( data->child_dialog != NULL )
        {
            SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0, NULL);
            data->child_dialog = NULL; 
        }
        // and the status dialog is displayed during 3 secs.
        // set data->child_dialog if ever message received before sms_store is ended
        //PARCH RAD new dialog			data->child_dialog = SmsMenu_startDialog(win, SMSSEND_ID_SAVED, TxtSaved, THREE_SECS, (T_VOID_FUNC)SmsSend_standard_dialog_cb);
        mmi_dialog_information_screen(win, TxtSaved,0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_SAVED);
        break;

    case E_SMS_MEM_FULL:
        TRACE_EVENT ("Memory for sms save is full");

        if( data->child_dialog != NULL )
        {
            // Waiting dialog is destroyed
            SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0, NULL);
            data->child_dialog = NULL; 
        }
        // and the status dialog is displayed during 3 secs.
        // set data->child_dialog as message received before sms_store is ended
        mmi_dialog_information_screen(win,TxtSmsFull, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_LIST_FULL);
        SetSmsFull();
        break;

    case E_SMS_ERR:
        TRACE_EVENT ("Save sms failed -> nok");

        if( data->child_dialog != NULL )
        {
            // Waiting dialog is destroyed
            SEND_EVENT (data->child_dialog, DIALOG_DESTROY, 0, NULL);
            data->child_dialog = NULL; 
        }
        // and the status dialog is displayed during 3 secs.
        // set data->child_dialog if message received before sms_store is ended
        mmi_dialog_information_screen(win,TxtFailed, 0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_SAVED);
        break;

    default:
        TRACE_EVENT("Err: default");
        return 0;
    }   
    return 1;
}

/*******************************************************************************

 $Function:    	SmsSend_send_to_mfw

 $Description:	This function sends a SMS message.

 $Returns:		execution status

 $Arguments:	event - current window

 $History
  GW 09/10/01 - Added code to convert unicode strings from 8 bits to 7 bits.

*******************************************************************************/

static int SmsSend_send_to_mfw (T_MFW_HND win)
{
    T_MFW_WIN               * win_data = ((T_MFW_HDR *)win)->data;
    T_SEND                  * data     = (T_SEND *)win_data->user;
    T_MFW                       submit_status;   /* Result of SMS send operation. */
    T_MFW_SMS_INFO  sms_parameter;
    UBYTE* msgBuffer;   //Pointer to data buffer  
    USHORT outLen;
    T_DISPLAY_DATA display_info;
    T_FindName  searchPhdata;
    char sms_number_buffer[40];

    TRACE_FUNCTION ("SmsSend_send_to_mfw()");
    /* Send the SMS */
#ifdef NO_ASCIIZ
    {
        dialog_info_init(&display_info);//gdy add
        display_info.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
        display_info.TextId       =TxtSending; 
        //followed code for find the name from phbook if there is
        if( data->edt_data.NumberBuffer[0] == '+' )
        {
            if( FindNumber((char*)(data->edt_data.NumberBuffer+3), (T_FindName *)&searchPhdata) )
                memcpy(sms_number_buffer,(char*)searchPhdata.name,sizeof(searchPhdata.name));
            else
                memcpy(sms_number_buffer,(char*)(data->edt_data.NumberBuffer),sizeof(data->edt_data.NumberBuffer));
        }
        else
        {
            if( FindNumber((char*)(data->edt_data.NumberBuffer), (T_FindName *)&searchPhdata) )
                memcpy(sms_number_buffer,(char*)searchPhdata.name,sizeof(searchPhdata.name));
            else
                memcpy(sms_number_buffer,(char*)(data->edt_data.NumberBuffer),sizeof(data->edt_data.NumberBuffer));
        }
        display_info.TextString2   =(char *)sms_number_buffer; 
        display_info.RightSoftKey  = TxtSoftBack;
        display_info.Time         = FOREVER;
        display_info.Identifier   = SMS_SENDING_MSG;
        display_info.Callback     = (T_VOID_FUNC)SmsSend_standard_dialog_cb;
        data->child_dialog = info_dialog(win, &display_info);
        //        mmi_dialogs_insert_fixmov_animation(data->child_dialog, 200 ,SENDINGSMS,6);//xsf add network search animation    
        mmi_dialogs_insert_fixmov_animation(data->child_dialog, 400 ,SENDINGSMSANIM);/*2003/12/4, wangyan modify*/
        data->id = SMSSEND_ID_SENT;
        msgBuffer = mmi_Sys_Sim((char *)(data->edt_data.TextBuffer), &outLen,&(sms_parameter.dcs));
        SmsSend_set_dcs_number (&sms_parameter);

        /* 2004/4/21, wangyan modify */ 
        if( (data->edt_data.msg_type==MFW_SMS_STOR_UNSENT)&&(data->edt_data.sms_type==MENU_MMI_SMS_MO) )
            sms_stored_submit((char*)(data->edt_data.NumberBuffer), (UBYTE)data->edt_data.sms_index);
        else
            /* 2004/4/21, wangyan modify */
            submit_status = sms_submit( MFW_SMS_SUBMIT,                  /* type of the message*/
                                        (char *)data->edt_data.NumberBuffer,        /* dest. address      */
                                        msgBuffer,                            /* sms message        */
                                        outLen,          /* lenght of message  */
                                        (char *)data->edt_data.CentreBuffer);/* sevice center num. */
    }
#else
    {
        msgBuffer = mmi_Sys_Sim((char *)(data->edt_data.TextBuffer), &outLen,&(sms_parameter.dcs));
        SmsSend_set_dcs_number (&sms_parameter);

        /* 2004/4/21, wangyan modify */ 
        if( (data->edt_data.msg_type==MFW_SMS_STOR_UNSENT)&&(data->edt_data.sms_type==MENU_MMI_SMS_MO) )
            sms_stored_submit((char*)(data->edt_data.NumberBuffer), (UBYTE)data->edt_data.sms_index);
        else
            /* 2004/4/21, wangyan modify */
            submit_status = sms_submit( MFW_SMS_SUBMIT,  /* type of the message*/
                                        (char *)data->edt_data.NumberBuffer, /* dest. address      */
                                        msgBuffer,                           /* sms message        */
                                        outLen,                             // sbh - added this, see function definition
                                        (char *)data->edt_data.CentreBuffer);/* sevice center num. */

    }
#endif


    // Deleted just before launching the number editor
    // to be able to save the sms, with its nb
    /* delete the number, because when the user write       */
    /* again a new sms, the user should be able to re enter */
    /* a new number                                         */
    //data->edt_data.NumberBuffer[0] = '\0';	
#if 0
    /*  display "Please wait" for sent sms */
    if( submit_status EQ MFW_SMS_OK )
    {
        T_DISPLAY_DATA display_info;

        TRACE_EVENT ("to give SMS to MFW -> ok");
        /* show the use "Please wait" for send sms */
        // PMC - new dialog		data->child_dialog = SmsMenu_startDialog(win, SMSSEND_ID_WAIT_SEND, TxtPleaseWait, FOREVER, (T_VOID_FUNC)SmsSend_standard_dialog_cb);

        display_info.KeyEvents    = KEY_LEFT;
        display_info.TextId       = TxtSending;
        display_info.TextId2      = '\0';
        display_info.TextString   = '\0';
        display_info.TextString2   ='\0';
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = '\0';
        display_info.Time         = FOREVER;
        display_info.Identifier   = SMSSEND_ID_WAIT_SEND;
        display_info.Callback     = (T_VOID_FUNC)SmsSend_standard_dialog_cb;
        data->child_dialog = info_dialog(win, &display_info);
        data->id = SMSSEND_ID_SENT;
    }
    else
    {
        TRACE_EVENT ("to give SMS to MFW -> failed");
        /* the result operation of sent was NOT OK*/
        // PMC - new dialog		SmsMenu_startDialog(win, SMSSEND_ID_NOT_SENT, TxtNotSent, THREE_SECS, (T_VOID_FUNC)SmsSend_standard_dialog_cb);
        mmi_dialog_information_screen(win,TxtNotSent, "NOT SENT", (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NOT_SENT);
        // No forever dialog to be destroyed
        data->child_dialog = NULL;
        data->id = SMSSEND_ID_NOT_SENT;
    }
#endif
    return 1;
}


/*******************************************************************************

 $Function:    	SmsSend_get_config_data

 $Description:	Called by external processes to read SMS PP config data.

 $Returns:		execution status

 $Arguments:	config_data - SMS info

*******************************************************************************/

UBYTE SmsSend_get_config_data (T_MFW_SMS_INFO *config_data)
{
    T_MFW Submit_Status;   /* store theh result of SMS send operation. */

    TRACE_FUNCTION ("SmsSend_get_config_data()");
    // get the current config data from SIM 
    Submit_Status = sms_parameter(config_data, TRUE);

    if( Submit_Status == MFW_SMS_FAIL )
    {
        TRACE_EVENT  ("ret MFW_SMS_FAIL");
        return FALSE;       
    }
    else
    {
        TRACE_EVENT ("ret OK");
        return TRUE;
    }
}
/*******************************************************************************

 $Function:    	SmsSend_set_SrvCntr_number

 $Description:	Called by external processes to write/Set SMS PP config data.

 $Returns:		execution status

 $Arguments:	config_data - SMS info

*******************************************************************************/

UBYTE SmsSend_set_SrvCntr_number (T_MFW_SMS_INFO *config_data)
{
    T_MFW Submit_Status;   /* store theh result of SMS send operation. */

    TRACE_FUNCTION ("SmsSend_set_SrvCntr_number()");
    // get the current config data from SIM 
    Submit_Status = sms_set_SrvCntr_number(config_data);

    if( Submit_Status == MFW_SMS_FAIL )
    {
        TRACE_EVENT  ("ret MFW_SMS_FAIL");
        return FALSE;       
    }
    else
    {
        TRACE_EVENT ("ret OK");
        return TRUE;
    }
}
UBYTE SmsSend_set_dcs_number (T_MFW_SMS_INFO *config_data)
{
    T_MFW Submit_Status;   /* store theh result of SMS send operation. */

    TRACE_EVENT ("SmsSend_set_dcs_number()");
    // get the current config data from SIM 
    Submit_Status = sms_set_dcs_number(config_data);

    if( Submit_Status == MFW_SMS_FAIL )
    {
        TRACE_EVENT  ("ret MFW_SMS_FAIL");
        return FALSE;       
    }
    else
    {
        TRACE_EVENT ("ret OK");
        return TRUE;
    }
}





/*******************************************************************************

 $Function:    	SmsSend_loadEditDefault

 $Description:	Configure T_EDITOR_DATA structure with default editor settings.

 $Returns:		none
 
 $Arguments:	editor_data - editor data.

*******************************************************************************/

void SmsSend_loadEditDefault(T_EDITOR_DATA *editor_data)
{
    TRACE_FUNCTION ("SmsSend_loadEditDefault()");

    editor_attr_init(&editor_data->editor_attr, NULL, edtCurBar1, 0, 0, 0);
    editor_data->hide                 = FALSE;
    editor_data->min_enter            = 1;  // Avoid to return empty strings
    editor_data->LeftSoftKey          = TxtSoftSelect;
    editor_data->RightSoftKey         = TxtSoftBack;
    //TB3 editor_data->AlternateLeftSoftKey = TxtSoftSelect;
    editor_data->AlternateLeftSoftKey = TxtNull;
    editor_data->TextId               = '\0';  
    editor_data->Identifier           =  0; 
    editor_data->TextString           = NULL;  
    editor_data->timeout              = FOREVER;  // Avoid to return empty strings
    editor_data->mode                 = ALPHA_MODE;
    editor_data->Callback             = NULL;
    editor_data->destroyEditor        = TRUE ; 
    editor_data->edtInPbk             = 0;          /* 2004/03/26 sunsj modify */
}

/*******************************************************************************

 $Function:    	SmsSend_loadUCS2EditDefault

 $Description:	Configure T_EDITOR2_DATA structure with default editor settings.

 $Returns:		none
 
 $Arguments:	editor_data - editor data.

*******************************************************************************/

static void SmsSend_loadUCS2EditDefault(T_EDITOR_DATA *editor_data)
{
    TRACE_FUNCTION ("SmsSend_loadUCS2EditDefault()");

    memset(editor_data, 0, sizeof(T_EDITOR_DATA));
    editor_data->hide                           = FALSE; 
    editor_data->LeftSoftKey                    = TxtSend;
    editor_data->AlternateLeftSoftKey           = TxtSend;
    editor_data->RightSoftKey                   = TxtSave;
    editor_data->Identifier                     = SMSSEND_ID_TEXTEDIT;
    editor_data->mode                           = ALPHA_MODE;
    editor_data->min_enter                      = 0;
    editor_data->timeout                        = FOREVER;
    editor_data->Callback                       = (T_EDIT_CB)SmsSend_TEXTEDIT_edit_cb;
}

/*******************************************************************************

 $Function:    	SmsSend_standard_dialog_cb

 $Description:	Callback function for standard dialogs in smssend module

 $Returns:		none
 
 $Arguments:	win - current window
                Identifier - unique id 
                Reason - event id

*******************************************************************************/

static int SmsSend_standard_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN   * win_data      = ((T_MFW_HDR *) win)->data;
    T_SAVE        * save_data       = NULL;
    T_SEND          * send_data     = NULL;
    T_MFW_HND   * l_parent      = NULL; 

    TRACE_FUNCTION ("SmsSend_standard_dialog_cb()");

    switch( Identifier )
    {
    case SMSSEND_ID_SC_NOT_READY:
    case SMSSEND_ID_SAVE_NOT_READY:
    case SMSSEND_ID_NOT_ALLOWED:
        // SEND an event to recreate the text editor
        // or to recreate the destination address number editor
        SEND_EVENT (win, E_RETURN, Identifier, NULL);
        break;

    case SMSSEND_ID_CM_SAVE_READY   :   
    case SMSSEND_ID_NBEDIT:
        if( (Reason EQ INFO_KCD_RIGHT)|| (Reason EQ INFO_KCD_ALTERNATELEFT)|| (Reason EQ INFO_KCD_HUP) || (Reason EQ INFO_TIMEOUT) )
        {
            send_data = (T_SEND *)win_data->user;
            l_parent=send_data ->parent;
            SmsSend_SEND_destroy(send_data->win);
            SEND_EVENT (l_parent, E_RETURN, send_data->id, NULL);
        }
        break;
    case SMS_SENDING_MSG:
        if( Reason EQ INFO_KCD_RIGHT )
            /* {
                 send_data = (T_SEND *)win_data->user;
                 l_parent=send_data ->parent;
                 SmsSend_SEND_destroy(send_data->win);
                 SEND_EVENT (l_parent, E_RETURN, send_data->id, NULL);
             }*/
            SEND_EVENT(win, E_EXIT, SEND_ID, NULL);/*2004/4/30, wangyan modify*/
        break;

    case SMSSEND_ID_WAIT_SEND:
        if( win_data != NULL )
        {
            send_data = (T_SEND *)win_data->user;
            // Forever child dialog has been destroyed
            if( send_data != NULL )
                send_data->child_dialog = NULL;
        }
        break;

    case SMSSEND_ID_WAIT_SAVE:
        // There is no way to stop SMS send
        if( win_data != NULL )
        {
            save_data = (T_SAVE *)win_data->user;
            // Forever child dialog has been destroyed
            if( save_data != NULL )
                save_data->child_dialog = NULL;
        }
        break;

        // Destroy the window then send the EXIT event to the SEND window->display of the text editor
    case SMSSEND_ID_SENT:
    case SMSSEND_ID_NOT_SENT:
        if( (Reason EQ INFO_KCD_RIGHT) || (Reason EQ INFO_KCD_HUP) || (Reason EQ INFO_TIMEOUT) )
            SEND_EVENT(win, E_EXIT, SEND_ID, NULL);
        // Do not reset child dialog handle, as 3s sending dialogs handle are not saved
        break;

        // Destroy the SAVE window and send an E_EXIT event to the parent window (useful if some actions are needed on return like in SEND)
    case SMSSEND_ID_SAVED:
    case SMSSEND_ID_NOT_SAVED:
    case SMSSEND_ID_LIST_FULL:
        if( (Reason EQ INFO_KCD_RIGHT) || (Reason EQ INFO_KCD_HUP) || (Reason EQ INFO_TIMEOUT) )
        {

            if( win_data != NULL )
            {
                save_data = (T_SAVE *)win_data->user;
                if( save_data != NULL )
                {
                    l_parent = save_data->parent;
                    // Reset child dialog handle, as 3s saving dialogs handle are also saved
                    //Do not reset child dialog handle for not creating a waiting screen
                    //save_data->child_dialog = NULL;
                }
            }
            // Destroy the window
            SmsSend_SAVE_destroy(win);
            // This will make SEND frame to recreate the text editor
            if( l_parent != NULL )
                SEND_EVENT(l_parent, E_EXIT, SAVE_ID, NULL);

        }
        break;


    default:
        TRACE_EVENT("MFW_EVENT_REJECTED");
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsSend_convert_to_inter

 $Description:	Transform a phone number in T_MFW_SMS_ADDR format to a string 
                with a '+' character if international number
                
 $Returns:		none
 
 $Arguments:	source_number - calling number
                dest_number - called number
*******************************************************************************/

void SmsSend_convert_to_inter(T_MFW_SMS_ADDR *source_number,    // The number to convert
                              char *dest_number)                // The dest number with a '+' if needed
{
    USHORT nb_char;
    USHORT i = 0;
    char *pt_digit = dest_number;

    TRACE_FUNCTION ("SmsSend_convert_to_inter()");

    nb_char = strlen(source_number->number);

    if( source_number->ton == TON_International )
    {
        *pt_digit = '+';
        pt_digit++;
    }

    for( i = 0; i <= nb_char; i++ )
        pt_digit[i] = source_number->number[i];
}

/*******************************************************************************

 $Function:    	SmsSend_R_OPTExeCentreEdit

 $Description:	Create editor for entering the Service center number.
 
 $Returns:		none
 
 $Arguments:	m - menu handler
                i - menu item selected.
*******************************************************************************/


int SmsSend_R_OPTExeCentreEdit(MfwMnu* m, MfwMnuItem* i) 
{
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    T_MFW_HND win = SmsSend_SEND_create(parent_win);
    SEND_EVENT(win,E_INIT,SMSSEND_ID_NBEDIT,0);

}
/*******************************************************************************

 $Function:    	SmsSend_SCNBEDIT_edit_cb

 $Description:	Callback function for the SC number editor.

 $Returns:		none

 $Arguments:	win - current window
                Identifier - unique id
                reason - event cause
*******************************************************************************/

static void SmsSend_SCNBEDIT_edit_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_SEND      * data     = (T_SEND *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;

    T_EDITOR_DATA       editor_data;
    T_MFW_SMS_INFO  sms_parameter;


    TRACE_FUNCTION ("SmsSend_SCNBEDIT_edit_cb()");

    //JVJE	data->text_editor = NULL;

    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_ALTERNATELEFT:
        //GW Read config data to get value of dcs
        SmsSend_get_config_data(&sms_parameter);
        if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
        {   //We have a chinese text message - set dcs parameter to 
            sms_parameter.dcs = MFW_DCS_UCS2;
        }
        else
        {
            sms_parameter.dcs = MFW_DCS_7bits;
        }
        //copy the sevice center number into the 

        strcpy((char*)sms_parameter.sc_addr,(char*)data->edt_data.CentreBuffer);
        // store the Service center number into the SIM.
        SmsSend_set_SrvCntr_number (&sms_parameter);
        SmsSend_set_dcs_number (&sms_parameter);

        editor_destroy(data->number_editor);
        data->number_editor = 0;
        mmi_dialog_information_screen(win,TxtSaved, 0, 
                                      (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_NBEDIT);
        break;
#if 0//added by windy 1008 
    case INFO_KCD_ALTERNATELEFT:
        //phbk_start(win, PhbkFromSms, NULL);
        bookPhonebookStart(win, PhbkFromSms);
        break;
#endif 
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        editor_destroy(data->number_editor);
        data->number_editor = 0;
        SmsSend_SEND_destroy(data->win);
        SEND_EVENT (parent, E_RETURN, data->id, NULL);
        break;

    default:
        TRACE_EVENT("Err: Default");
        break;
    }
}
/*******************************************************************************

 $Function:    	smscb_M_common_msg
 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int smscb_M_common_msg(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win      = mfwParent((MfwHdr *)mfw_header());

    if( g_pcsyncstatus )//when pcsync run ,return,hxl add 2003-2-13
        return 1;

    //set the state for distinguish the left key's function
    return(int)smscb_common_msg_start (win, NULL);
}
/*********************************************************************
**********************************************************************/

/*******************************************************************************

 $Function:    	smscb_common_msg_start

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND smscb_common_msg_start(T_MFW_HND parent_window, void *dummy)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("smscb_common_msg_start()");

    win = smscb_common_msg_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, NULL);
    }
    return win;
}


/*******************************************************************************

 $Function:    	smscb_common_msg_create

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static T_MFW_HND smscb_common_msg_create(MfwHnd parent_window)
{
    T_COMMON_MSG * data = (T_COMMON_MSG *)ALLOC_MEMORY (sizeof (T_COMMON_MSG));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("smscb_common_msg_create()");

    /*
     * Create window handler
     */
    data->win =win_create (parent_window, 0, 0, NULL);
    if( data->win EQ NULL )
    {
        return NULL;
    }

    /* 
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)smscb_common_msg_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    winShow(data->win);
    return data->win;
}

static void smscb_common_msg_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_COMMON_MSG     * data;
    USHORT i;

    TRACE_FUNCTION ("smscb_common_msg_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_COMMON_MSG *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            win_delete (data->win);

            /*     
             * Free Memory
             */
            for( i = 0; i < CommonMsgNum; i++ )
                FREE_MEMORY( (void *)(data->list_menu_data.List[i].str), MENU_TEXT_LENGTH-1);
            FREE_MEMORY ((void *)data->list_menu_data.List, CommonMsgNum* sizeof (MfwMnuItem)); // c017 rsa
            FREE_MEMORY ((void *)data, sizeof (T_COMMON_MSG));
        }
        else
        {
            TRACE_EVENT ("smscb_M_CB_TOP_CONS_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	smscb_common_msg_lst_create

 $Description:	

 $Returns:		
 
 $Arguments:	
 
*******************************************************************************/
static void smscb_common_msg_lst_create(T_COMMON_MSG *data)
{
    int i;

    //on RECREATE|INIT: menucreate dynamiclist (List=commonMsg, SoftLeft=SELECT, SoftRight=BACK) /* show: 1. Name 2. MID */ 

    // c017 rsa
    /* allocate sufficient memory to hold the maximum list of menu items */
    data->list_menu_data.List = (MfwMnuItem *)ALLOC_MEMORY (CommonMsgNum * sizeof (MfwMnuItem));
    // end c017 rsa
    data->list_menu_data.ListMenuFlag=1;//for display the title
    data->list_menu_data.ListMenuHeadStr=(char *) MmiRsrcGetText(TxtCommonMsg);
    for( i=0; i < CommonMsgNum; i++ ) /* Fill Menu List */
    {
		/* 2004/06 sunsj modify for picture manage */
        data->list_menu_data.List[i].icon = GET_ICONATTR(ICON_SMSCOMMON_LIST, 0);//&textlistIcon;
        data->list_menu_data.List[i].exta = 0;
        data->list_menu_data.List[i].edit = 0;
        data->list_menu_data.List[i].menu = 0;
        data->list_menu_data.List[i].func = 0; 
        /* get the correct entry in list of CBTopics */
        data->list_menu_data.List[i].str= (char *) ALLOC_MEMORY (MENU_TEXT_LENGTH-1 );
        memcpy(data->list_menu_data.List[i].str ,(char *) (FFS_CoMsg[i].message),MENU_TEXT_LENGTH-1);
        //data->list_menu_data.List[i].str =(char *) (FFS_flashData.CoMsg[i].message);
        data->list_menu_data.List[i].flagFunc = item_flag_none;
    }
    //actual number of entries in list menu
    data->list_menu_data.ListLength = CommonMsgNum; 
    data->list_menu_data.autoDestroy = TRUE;
    listDisplayListMenu(data->win, &data->list_menu_data, (ListCbFunc)smscb_common_msg_listmnu_cb,0);
}
/*******************************************************************************

 $Function:    	smscb_common_msg_exec_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void smscb_common_msg_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * dummy)
/* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN         * win_data = ((T_MFW_HDR *) win)->data;
    T_COMMON_MSG   * data = (T_COMMON_MSG *)win_data->user;
    T_MFW_HND         * l_parent;
    SHORT               l_id;
    UBYTE i;
    int len;
    char * tmp;

    TRACE_FUNCTION ("smscb_common_msg_exec_cb()");

    switch( event )
    {
    case E_INIT:
        data->id = value;
        /* initialization of the dialog data */
        data->list_menu_data.ListPosition   = 1;/* True cursor position in list menu. */
        data->list_menu_data.CursorPosition = 1;/* Cursor position in list snapshot.  */
        data->list_menu_data.SnapshotSize   = CommonMsgNum;/* Number of list entries to view.    */
        data->list_menu_data.Font           = 0;
        data->list_menu_data.LeftSoftKey    = TxtSoftSelect;
        data->list_menu_data.RightSoftKey   = TxtSoftBack;
        data->list_menu_data.KeyEvents      = KEY_RIGHT|KEY_HUP| KEY_LEFT | KEY_MNUUP | KEY_MNUDOWN|KEY_CALL|KEY_OK
                                              |KEY_0|KEY_1|KEY_2|KEY_3|KEY_4|KEY_5|KEY_6|KEY_7|KEY_8|KEY_9;
        data->list_menu_data.Reason         = 0;
        data->list_menu_data.Strings        = TRUE; // c020 rsa
        data->list_menu_data.Attr           = &smscb_common_msgAttrib;
        data->list_menu_data.autoDestroy    = TRUE;
        smscb_common_msg_lst_create(data);
        break;

    case E_RETURN: 
    case E_EXIT: 
    case E_BACK:
        /* (re)create the dialog handler */
        TRACE_FUNCTION ("EXIT in smscb_common_msg_exec_cb");        
        smscb_common_msg_destroy(data->win);
        //smscb_common_msg_lst_create(data);
        break;

    case E_ABORT: /* defaultreaction */
        TRACE_EVENT ("ABORT in smscb_common_msg_exec_cb");      
        l_parent = data->parent;
        l_id = data->id;
        smscb_common_msg_destroy(data->win);
        SEND_EVENT (l_parent, event, l_id, NULL); /* forward event to parent */
        break;
    default:
        return;
    }
}

/*******************************************************************************

 $Function:    	smscb_common_msg_listmnu_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void smscb_common_msg_listmnu_cb (T_MFW_HND * win, ListMenuData * ListData)
/* smscb_M_common_msg menu event handler */
{
    T_MFW_WIN            * win_data = ((T_MFW_HDR *)win)->data;
    T_COMMON_MSG      * data = (T_COMMON_MSG *)win_data->user;
    T_MFW_HND            * l_parent;
    T_MFW_WIN    * win_data2;
    SHORT                  l_id;
    T_SmsUserData   SmsData;
    T_SEND  * parent_data ;
    USHORT i;

    TRACE_FUNCTION ("smscb_common_msg_listmnu_cb()");
    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK: /*  */
        //case LISTS_REASON_SEND:
        //on SELECT: menucreate common_msg_SEL(Index=selection)
        index = ListData->ListPosition;
        if( Send_ed_state==SEND_USE_COMMON_MSG )
        {

            l_parent    =  data->parent;         
            win_data2   =  ((T_MFW_HDR *)l_parent)->data;
            parent_data =  (T_SEND *)win_data2->user;
            /* 2003/12/04 sunsj modify for new editor mode */
            edtInsertAnyString(TextInputActiveEditor(),(char *) (FFS_CoMsg[index].message));// (char *) tmp);
            smscb_common_msg_destroy(data->win);
            Send_ed_state=SEND_EDIT;
        }
        else
        {
            sprintf (buf, "smscb_common_msg_listmnu_cb select the index is %d", index);
            TRACE_EVENT (buf);
            /*Change the format of message read form flash to our general format  */
            SmsData.NumberBuffer[0] = '\0';
            memset(SmsData.TextBuffer,0,sizeof(SmsData.TextBuffer));
            memcpy(SmsData.TextBuffer,(char *) (FFS_CoMsg[index].message) ,MAX_COMSG_LEN);
            SmsData.Send_state =E_COMMON_MSG;
            SmsSend_SEND_start(win, (void *) &SmsData);
        }
        break;

    case LISTS_REASON_BACK: /* back to previous menu */
        l_parent = data->parent;
        l_id = data->id;
        smscb_common_msg_destroy(data->win);
        SEND_EVENT (data->parent, E_RETURN, data->id, NULL); // c007 rsa
        break;

    case LISTS_REASON_KCD0:
    case LISTS_REASON_KCD1:
    case LISTS_REASON_KCD2:
    case LISTS_REASON_KCD3:
    case LISTS_REASON_KCD4:
    case LISTS_REASON_KCD5:
    case LISTS_REASON_KCD6:
    case LISTS_REASON_KCD7:
    case LISTS_REASON_KCD8:
    case LISTS_REASON_KCD9:
        index = ListData->Reason-LISTS_REASON_KCD0;
        if( Send_ed_state==SEND_USE_COMMON_MSG )
        {
            l_parent    =  data->parent;
            win_data2   =  ((T_MFW_HDR *)l_parent)->data;
            parent_data =  (T_SEND *)win_data2->user;
            /* 2003/12/04 sunsj modify for new editor mode */
            //edtInsertAnyString(getactiveEditor(), (char *) (FFS_CoMsg[index].message));
            edtInsertAnyString(TextInputActiveEditor(), (char *)(FFS_CoMsg[index].message));
            smscb_common_msg_destroy(data->win);
            Send_ed_state=SEND_EDIT;
        }
        else
        {
            sprintf (buf, "smscb_common_msg_listmnu_cb select the index is %d", index);
            TRACE_EVENT (buf);
            /*Change the format of message read form flash to our general format  */
            SmsData.NumberBuffer[0] = '\0';
            memset(SmsData.TextBuffer,0,sizeof(SmsData.TextBuffer));
            memcpy(SmsData.TextBuffer,(char *) (FFS_CoMsg[index].message) ,MAX_COMSG_LEN);/* assumption: sms_text_ascii is still filled from reading the SMS*/
            SmsData.Send_state =E_COMMON_MSG;
            SmsSend_SEND_start(win, (void *) &SmsData);
        }
        listsDestroy(ListData->win);
        break;

    default:
        break;
    }
    return;
}


/*******************************************************************************

 $Function:    	SmsCM_R_OPTExeSave

 $Description:	called when the user press Save sender in the Option menu
 
 $Returns:		execution status

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsCM_R_OPTExeSave(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT   * data = (T_SMSSEND_R_OPT *)win_data->user;
    TRACE_FUNCTION("SmsCM_R_OPTExeSave");

    memset((char *) (FFS_CoMsg[index].message) ,0,MAX_COMSG_LEN);
    memcpy((char *) (FFS_CoMsg[index].message) ,(char *) (data->parent_data->edt_data.TextBuffer),MAX_COMSG_LEN);
    Common_Smswrite();
    mmi_dialog_information_screen(data->parent, TxtSaved,0, (T_VOID_FUNC)SmsSend_standard_dialog_cb, SMSSEND_ID_CM_SAVE_READY);
    SmsSend_R_OPT_destroy(win);
    return 1;
}


/*******************************************************************************

 $Function:    	SmsCM_R_OPTExeSend

 $Description:	called when the user press Call sender in the Option menu
 
 $Returns:		execution status

 $Arguments:	m - Menu handle
                i - Menu item selected.
 
*******************************************************************************/

static int SmsCM_R_OPTExeSend(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSSEND_R_OPT   * data = (T_SMSSEND_R_OPT *)win_data->user;
    T_EDITOR_DATA editor_data;
    MfwEdt * edit;

    TRACE_FUNCTION("SmsCM_R_OPTExeSend");

    if( Send_state ==E_COMMON_MSG )
    {
        /* 2003/12/04 sunsj modify */
        //edit=((MfwHdr*)getactiveEditor())->data;
        //edit = ((MfwHdr*)TextInputActiveEditor())->data;

        //edit->attr->title_id=TxtMessages;
        //edit->attr->size=MAX_EDIT_MSG_LEN;
        Send_save=E_SENDONLY;
        SmsSend_loadEditDefault(&editor_data);
        editor_attr_init_fullscr(&editor_data.editor_attr,1,TxtEnterNumber,
                                 (char *)data->parent_data->edt_data.NumberBuffer,PHB_MAX_LEN,edtCurBar1);
        editor_data.edtInPbk             = 0;
        editor_data.LeftSoftKey          = TxtSend;
        editor_data.AlternateLeftSoftKey = TxtSearchName;
        editor_data.RightSoftKey         = TxtDelete;
        editor_data.Identifier           = SMSSEND_ID_NBEDIT ; 
        editor_data.mode                 = E_EDIT_DIGITS_MODE;
        editor_data.Callback             = (T_EDIT_CB)SmsSend_NBEDIT_edit_cb;
        editor_data.destroyEditor        = FALSE;
        editor_data.mode                 = PHONENUMONLY_MODE  ;
        data->parent_data->number_editor = editor_start(data->parent_data->win, &editor_data);  /* start the editor */ 

        SmsSend_R_OPT_destroy(win);
        //        Send_state =E_SEND;/* 2004/4/20, wangyan modify */
    }
    return 1;
}
#undef MMI_SMSSEND_C
