#ifndef _DEF_MMI_SMSSEND_H_
#define _DEF_MMI_SMSSEND_H_

#undef GLOBAL_EXT
#if defined (MMI_SMSREAD_C)
#define GLOBAL_EXT
#else
#define GLOBAL_EXT extern
#endif
/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   SMS
 $File:       MmiSmsSend.h
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description:

    header of template for MMI yyy dynamic event handling

********************************************************************************
 $History: MmiSmsSend.h

  25/10/00      Original Condat(UK) BMI version.
  09/08         windy modified
  19/08/02   ver0.111   wangxia  modified 
 $End

*******************************************************************************/

/*******************************************************************************

                                Include Files

*******************************************************************************/

#include "mfw_mfw.h"
#include "mmiEditor.h" //GW Added for T_EDITOR structure


/*******************************************************************************

                        Shared Structure Definitions

*******************************************************************************/

typedef struct
{
  /* administrative data */

  T_MMI_CONTROL   mmi_control;
  T_MFW_HND       win;
  T_MFW_HND       parent;
  //    T_MFW_HND       info;  /* to keep the window of SmsSend_info_xxx*/
  T_MFW_HND       child_dialog;/* to keep the window of dialog          */
  T_MFW_HND       sms_handler;
  SHORT           id;
  T_SmsUserData edt_data; /* pointer of text and number */
  T_MFW_HND   text_editor;
  T_MFW_HND   number_editor;
  T_MFW_HND   sc_number_editor;
  T_MFW_HND   options_win;
} T_SEND;
typedef enum 
{
    E_DELETE,
    E_REPLY,
    E_CALL_SENDER,
    E_SAVE_NUMBER,
    E_SEND,
    E_EDIT,
    E_COMMON_MSG,
    E_FORWARD
}send_start_state;
typedef enum 
{
    E_SENDSAVE,
    E_SENDONLY
}send_save_state;
typedef enum 
{
    SEND_EDIT,
    SEND_USE_COMMON_MSG
}send_EDIT_state;

#if 0
typedef enum
{
  /* Logical frames */
  SEND_ID,
  SAVE_ID,
  /* Extern windows */
  PHBK_ID,
  /* Editor windows */
  SMSSEND_ID_TEXTEDIT,
  SMSSEND_ID_NBEDIT,
  SMSSEND_ID_CENTREEDIT,
  SMSSEND_ID_CENTREEDIT_CHANGE,
  /* Dialog windows */
  SMSSEND_ID_WAITING,
  SMSSEND_ID_WAIT_SEND,
  SMSSEND_ID_SENT,
  SMSSEND_ID_NOT_SENT,
  SMSSEND_ID_WAIT_SAVE,
  SMSSEND_ID_SAVED,
  SMSSEND_ID_NOT_SAVED,
  SMSSEND_ID_LIST_FULL,
  SMSSEND_ID_SAVE_NOT_READY, //PATCH TB
  SMSSEND_ID_SC_NOT_READY, //PATCH TB
  SMSSEND_ID_CM_SAVE_READY,
  SMSSEND_ID_NOT_ALLOWED

} sms_send_id;
#endif
#define MENU_TEXT_LENGTH 14	//TBD: to include in common .h

/*******************************************************************************

                                Function Prototypes

*******************************************************************************/

GLOBAL_EXT T_MFW_HND SmsSend_SEND_start(T_MFW_HND parent_window, T_SmsUserData *UserData);
GLOBAL_EXT T_MFW_HND SmsSend_SAVE_start(T_MFW_HND parent_window, T_SmsUserData *UserData);
GLOBAL_EXT T_MFW_HND V_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr);
GLOBAL_EXT int M_callVoice(MfwMnu* m, MfwMnuItem* i);
int SmsSend_R_OPTExeCentreEdit(MfwMnu* m, MfwMnuItem* i);

// Used im mmismsread to compare with SMS center number
GLOBAL_EXT UBYTE SmsSend_get_config_data(T_MFW_SMS_INFO *config_data);
GLOBAL_EXT void SmsSend_convert_to_inter(T_MFW_SMS_ADDR *source_number, char *dest_number);
UBYTE SmsSend_set_SrvCntr_number (T_MFW_SMS_INFO *config_data);
GLOBAL int SmsRead_R_KINDExeIncoming(MfwMnu* m, MfwMnuItem* i);
GLOBAL int SmsRead_R_KINDExeOutgoing(MfwMnu* m, MfwMnuItem* i);
GLOBAL int SmsRead_R_NVMExeOutgoing(MfwMnu* m, MfwMnuItem* i);
GLOBAL int SmsRead_R_NVMExeIncoming(MfwMnu* m, MfwMnuItem* i);
GLOBAL_EXT int M_exeNVMMsg(MfwMnu* m, MfwMnuItem* i);
GLOBAL_EXT int smscb_M_common_msg(MfwMnu* m, MfwMnuItem* i);
static T_MFW_HND smscb_common_msg_create(MfwHnd parent_window);
static void smscb_common_msg_destroy(MfwHnd own_window);
void smscb_common_msg_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * dummy);
static void smscb_common_msg_listmnu_cb (T_MFW_HND * win, ListMenuData * ListData);
//GW 29/11/01 - Added 
void		SmsSend_loadEditDefault(T_EDITOR_DATA * edit_info);
void      SmsSend_SEND_destroy (T_MFW_HND window);
#endif /* _DEF_MMI_SMSSEND_H_ */
