/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Softkeys
 $File:		    MmiSoftkeys.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
	
********************************************************************************
 $History: MmiSounds.h

	25/10/00			Original Condat(UK) BMI version.	
	   
 $End

*******************************************************************************/


#ifndef _DEF_MMI_SOFTKEYS_H_
#define _DEF_MMI_SOFTKEYS_H_

#define ALLOC_MEMORY mfwAlloc
#define FREE_MEMORY  mfwFree


#include "MmiResources.h"
#include "mmiQQSwitch.h" //hxl add for check qq func


typedef enum
{
    SOFTKEYS_FAILURE,
    SOFTKEYS_CREATED,
    SOFTKEYS_CHANGED
} SoftKeysResult;

typedef struct
{
    LangTxt leftKeyLabel;
    LangTxt rightKeyLabel;
    MfwCb   leftKeyCallBack;
    MfwCb   rightKeyCallBack;
} SoftKeysSetup;


SoftKeysResult softKeysAttributes( U8 font, UBYTE displayAttibutes);
/*
 * Change the <font> and <displayAttibutes> for _all_ softkeys.
 * All consecutive calls of softKeysUpdate() will reflect the change.
 * Returns SOFTKEYS_CHANGED when everything went fine,
 * or SOFTKEYS_FAILURE on failure.
 */


/*
 * Please note that all functions below come in a softKeysHnd... and softKeysWin...
 * version, which have identical functionality, but get the <window> passed
 * in MfwHnd or MfwWin pointer form respectively.
 * You can just use either one depending on what you got hold of at the moment.
 */


SoftKeysResult softKeysHndCreate( MfwHnd window, SoftKeysSetup *setup);

SoftKeysResult softKeysWinCreate( MfwWin *window, SoftKeysSetup *setup);
/*
 * Creates the softkeys for <window>, which will display the
 * <leftKeyLabel> and <rightKeyLabel> in the softkey area
 * on the screen, and invoke <leftKeyCallBack> or <rightKeyCallBack>
 * when the approrpiate key is pressed. Returns SOFTKEYS_CREATED when
 * everything went fine, or SOFTKEYS_FAILURE on failure.
 */


SoftKeysResult softKeysHndSet( MfwHnd window, SoftKeysSetup *changes);

SoftKeysResult softKeysWinSet( MfwWin *window, SoftKeysSetup *changes);
/*
 * Change the setup of the softkeys for <window>. Use TxtNull if you
 * don't want to change a ...Label, and NULL if you don't want to change
 * a ...CallBack. Returns SOFTKEYS_CHANGED when everything went fine,
 * or SOFTKEYS_FAILURE on failure.
 */


void softKeysHndUpdate(MfwHnd window);

void softKeysWinUpdate(MfwWin *window);
/*
 * You will need to call this whenever <window> is updated.
 */


void softkeysHndDelete(MfwHnd window);

void softkeysWinDelete(MfwWin *window);
/*
 * Deletes the softkeys for <window>.
 */




void displaySoftKeys(int leftSoftKey, int rightSoftKey);
void displayColorSoftKeys(int leftSoftKey,int rightSoftKey,int color);
void displayPhbkEditSoftKeys(int leftSoftKey,int rightSoftKey);
//hxl add for qq 2003-3-2
#ifdef QQFUNC//hxl add for qq func switch,2003-3-24
void display3SoftKeys(int midSoftKey);//(int leftSoftKey,int midSoftKey,int rightSoftKey)
#endif

void displaySoftKeys_edition(int leftSoftKey,int index, int rightSoftKey);

// SH - 25/5/01
// This function provided for WAP, to allow the printing of custom softkeys
// from strings provided (otherwise same as displaySoftKeys).

void displayCustSoftKeys(char *LeftSoftKey, char *RightSoftKey);
void drawDownbmp(void);    //xsf add 12.11

/*2003/11/13,talcon add*/
void displayColorSoftKeys2(int leftSoftKey,int rightSoftKey,int color,int bkgcolor);
/*jhxu720 add for the arrow*/
void draw_softkeybar_leftright_arrow(void);//jhxu 288 add
void draw_softkeybar_updown_arrow(void);//jhxu 288 add
void draw_softkeybar_fourdirection_arrow(void);//jhxu 288 add

#endif

