/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Start
 $File:		    MmiStart.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the start code for the MMI
                        
********************************************************************************
 $History: MmiStart.c

    25/10/00			Original Condat(UK) BMI version.	
        08/08            fzq modified
  26/08/02		hxl add for charger
    29/08/02		move the blinktimer from mmistart to this file, it is after welocome animation

 $End

*******************************************************************************/




/*******************************************************************************
                                                                              
                                Include files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"

#include "mfw_lng.h"
#include "mfw_nm.h"
#include "mfw_icn.h"
#include "mfw_sim.h"
#include "mfw_sat.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_tim.h"
#include "mfw_mme.h" 	// sbh - so we can call mmeInit in show_welcome_cb
#include "mfw_ffs.h"	//xzy add for wdt counter
#include "fieldtest.h"


#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

//#include "MmiCall.h"
#include "MmiMain.h"
#include "MmiCall.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiIdle.h"
#include "MmiIcons.h"
#include "MmiSettings.h"
#include "MmiMenu.h"
#include "MmiNetwork.h"
#include "MmiServices.h"
#include "MmiBookController.h"
#include "MmiNetwork.h"
#include "MmiSimToolkit.h"
#include "MmiVoiceMemo.h"
#include "MmiCPHS.h"

/* SPR759 - SH*/
#ifdef MMI_HOMEZONE_ENABLED
    #include "MmiHomezone.h"
#endif

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mfw_ffs.h"
#include "pwr.h"//hxl add 20020909
#ifndef MFW_EVENT_PASSED
    #define MFW_EVENT_PASSED 0
#endif

#include "mmiouterIdle.h"
// 2004.4.9 wyj add 
#include "mmisounds_defs.h"
void StartPlayByReason(AUDIO_REASON reasonid, BOOLEANS index);

extern int LineControl;
extern int g_switchon;  ///zym added for industrialization 10/21
extern sms_cb_init ();
extern void TM_EnableWatchdog(void);
extern unsigned char IsReset();
/*******************************************************************************
                                                                              
                                Static data
                                                                              
*******************************************************************************/

static MfwHnd win;
static MfwHnd kbd;
extern int g_initfinishflag;
int contrast_intensity;

/* The following information controls the welcome animation
*/
#define WELCOME     1
#define NO_WELCOME  0

static MfwHnd win_animation;
static USHORT animation_index;
static U8 welcome_status;
UBYTE  IsShowGoodbye = FALSE;//2004-04-23 Sunny add
/* SPR877 - SH - set to TRUE if welcome animation has finished */
UBYTE animation_complete = FALSE;
UBYTE anim_real_complete = FALSE;    //xsf add 2002.11.26 for idle update when PIN or HOSTKEY is open
/* zhq, 2004/07/08, modified for we will use pin_outer_wait to init sub screen
and only refresh sub screen until main screen drawIdle. */
UBYTE main_sreen_init_complete = FALSE;
U8    LockBand=0; 

UBYTE   OverleapRegist=0;//hxl add ,when flash error ,we overleap the regist,20021029
int NotCharingMode = TRUE;	/* 2004/07/05 sunsj modify */
/*******************************************************************************
                                                                              
                                Local prototypes
                                                                              
*******************************************************************************/

static int winEvent( MfwEvt e, MfwWin *w );
static int keyEvent( MfwEvt e, MfwKbd *k );

static void (*show)( void );
static void showDefault( void );

/* SH - moved showwelcome primitive to header file */
static int show_welcome_cb(T_MFW_HND win, USHORT identifier, UBYTE reason);

//hxl add 20020905 for correct charger win entry -----------
void AniandSerachon(void);
void BaseWinExit(void);
void SwitchOffMobile(void);
extern int write_imei(U8 *imei);
BOOL IsNumeric(char *s);
extern void Set_ForResetIndication();

//end of hxl add 20020905----------------------------------

/*******************************************************************************
                                                                              
                                Private methods
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	winEvent

 $Description:	Window event handler, handles window visible events and
                ignores all others
 
 $Returns:		MFW_EVENT_CONSUMED or MFW_EVENT_PASSED

 $Arguments:	e, event to be handles, w, window handle
 
*******************************************************************************/

static int winEvent( MfwEvt e, MfwWin *w )
{
    TRACE_FUNCTION("WinEvent(Start)");
    switch( e )
    {
    case MfwWinVisible:
        {
            if( w->flags & MfwWinVisible )
                show();
        }
        break;

    default:
        {
            return MFW_EVENT_PASSED;
        }
    }

    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	winanimEvent

 $Description:	Handle events during the window animation

 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/
#if 0 /*2003/12/16, wangyan modify*/
static int winanimEvent( MfwEvt e, MfwWin *w )
{

    TRACE_FUNCTION("winanimEvent");

    switch( e )
    {
    case MfwWinVisible:
        dspl_ClearAll();
        /*dspl_TextOut(0,20,0,(char*)"CONDAT WELCOME"); (GB)*/

        break;
    default:
        {
            return MFW_EVENT_PASSED;
        }
    }

    return MFW_EVENT_CONSUMED;
}
#endif /*2003/12/16, wangyan modify*/


/*******************************************************************************

 $Function:    	startregis

 $Description:	All we need to do here is start the SIM

 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

static void startregis( void )
{
    TRACE_FUNCTION("start registration");
    sim_activate(); 



}

/*******************************************************************************
                                                                              
                                Public methods
                                                                              
*******************************************************************************/

/*******************************************************************************

 $Function:    	startInit

 $Description:	Initialises the MMI startup functions

 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

void startInit( void )
{
    T_MFW_HND hnd;
    //char temp[100];

    /* Assume the welcome status is welcome
    */
    welcome_status = WELCOME;

    /* setup signalling and AUTOFOCUS
    */
    mfwSetSignallingMethod( 1 );
    winAutoFocus( TRUE );
#if 0
    /* initialise network services
    */
    networkInit( 0 );
    iconsInit();
    smsidle_start(0, NULL); /* create a static SMS handling */
    servicesInit( 0 );

    voice_memo_init ();
    voice_mail_init ();
    sms_cb_init ();


    //JVJE    soundInit( 0 );
    callInit( 0 );
    bookInitialise( 0 );
    simToolkitInit( 0 );
    idleInit( 0 );   
#endif
    //GW-SPR#1035-Added SAT changes by Nebi (changed initialisation order).
    /* initialise network services */
    //JVJE	soundInit( 0 );
    simToolkitInit( 0 );
    bookInitialise( 0 );
    //    callInit( 0 );
    iconsInit();

    Forward_Ffsfile_init(); //hxl add for some needed data before show_welcome_cb,2002-11-26
    TRACE_EVENT("Forward_Ffsfile_init");
    callInit( 0 );/*2004/4/27, wangyan modify*/
    /* Handlers created on windows */
    pin_init( 0 );
    networkInit( 0 );   
    smsidle_start(0, NULL); 
    servicesInit( 0 );

	/* 2004/07/05 sunsj modify */
	if((!IsReset())&&(( pwr_Status.swichonstatus)||(g_switchon == 2)))
	{
		if(pwr_Status.charger_plugged)
		{
/* zhq, 2004/07/08, add for we use pin_outer_wait to init sub screen
and we do not refresh untile main screen drawIdle. */
			/* 2004/07/15 sunsj remove */
			//main_sreen_init_complete = TRUE;
			NotCharingMode = FALSE;
		}
	}
    outerIdleInit();
    idleInit( 0 );  

    voice_memo_init ();
    voice_mail_init ();
    sms_cb_init ();
    FieldTestInit();

    if( !FFS_flashData.language )
        MmiRsrcSetChinese();
    else
        MmiRsrcSetEnglish();

    dspl_SetTextMode();


    if( g_switchon == 1 )
    {
        AniandSerachon();
        //2004.4.4 WYJ modify
        StartPlayByReason(POWERONPLAY, 0);
    }
    else
    {
//glowing,2004-06-16,SendVirtualKeyToMMI use MMIStart_completed to check 
//if it can send the virtual key.
#ifdef _M188_    
        g_initfinishflag = 1;
#endif

        //hxl add for charger win entry 20020905------------------------------------
        if( (!IsReset())&&(( pwr_Status.swichonstatus)||(g_switchon == 2)) )
        {//is charger switch the phone?
            /// 		pwr_Status.charger_plugged=(UBYTE)ChargerPlugIn();
            if( pwr_Status.charger_plugged )
            {//charger is still in
				/* 2004/07/05 sunsj modify */
				NotCharingMode = FALSE;
/* zhq, 2004/07/08, add for we use pin_outer_wait to init sub screen
and we do not refresh untile main screen drawIdle. */
				/* 2004/07/15 sunsj remove */
				//main_sreen_init_complete = TRUE;
				  drawOuterIdle();
                if( pwr_Status.remain_capacity<=5 )
				//glowing,2005-05-25, add _M188_ for compatible with M288B( rita project)
				#ifdef _M188_
                    pwr_start_fast_charge();    ///zym revised 08/14
                #endif
                ChargeWin();
                //2003/12/23,talcon add for outerIdle charge
                //setChargeState(OUTERIDLECHARGE_OFF,0);//2004-03-21 Sunny remove
            }
            else
            {//power off
                //2003/12/23,talcon add for outerIdle charge
                //setChargeState(OUTERIDLECHARGE_NONE,0);//2004-03-21 Sunny remove
                SwitchOffMobile();
            }

        }
        else
        {
            //	if(pwr_Status.remain_capacity>=10)
            AniandSerachon();
            //2004.4.4 WYJ modify
            StartPlayByReason(POWERONPLAY, 0);
            //else//power off
            //	SwitchOffMobile();
            //LowVol_Warning();
        }
    }
    /*
        if(pwr_Status.charger_plugged){//charger is still in
                if(pwr_Status.remain_capacity<=5)
                    pwr_start_fast_charge();    ///zym revised 08/14
                ChargeWin();
            
        }else{
    //  		if(pwr_Status.remain_capacity>=10)
                AniandSerachon();
        }*/
    //end of hxl add 0905--------------------------------------------------------

}

/*******************************************************************************

 $Function:    	startExit

 $Description:	Stops the MMI start windows, basically reverses the effect
                of the startInit above

 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

void startExit( void )
{
    /* remove keyboard handlers
    */
    kbdDelete(kbd);
    kbd = 0;

    /* SH - GPRS */
    /*	#ifdef MMI_GPRS_ENABLED  //hxl moved it to basewinexit 20020905----------
        mmiGprsExit( 0 );
        #endif*//* GPRS */

    //	voice_memo_exit ();

    /* shut down the sim toolkit
    */
    simToolkitExit();

    /* close the phonebook, calls, idle, services, icons, sounds
       and network handlers
    */
    bookExit();
    callExit();
    idleExit();
    //2003/12/23,talcon add
    outerIdleExit();
    smsidle_destroy ();
    //JVJE	soundExit();
    //	servicesExit();  //fails	
    iconsExit();
    //    networkExit();	//fails!
    //   cphs_exit(); //MC  //hxl moved it to basewineixt() 20020905
}

/*******************************************************************************

 $Function:    	startExec

 $Description:	start window execute method

 $Returns:		None.

 $Arguments:	reason, for invoking the execute method,
                next, not used passed for compatibility
 
*******************************************************************************/

void startExec( int reason, MmiState next )
{
    switch( reason )
    {
    case PhoneInit:
        {
            /* initialising, run the animation
            */
            sim_init();                     /* init SIM handler         */
            nm_init();                      /* init REG handler         */
            startInit();                        /* init startup module      */

            //JVJE			welcomeAnimation();
        }
        break;

    case FirstTimeNMFound:
        {
            /* first time through setup window and idle handlers
            */
            TRACE_EVENT("NM Found");

            //gb			show = showWelcomeFound;
            winFocus( win );
            winShow( win );
            idleExec( IdleNormal, 0 );

        }
        break;

    case NmSearching:
        {
            /* just trace on the search event for now
            */
            TRACE_EVENT("Search");

        }
        break;

    default:
        {
            /* no default handling
            */
            break;
        }
    }
}

/*******************************************************************************

 $Function:    	startWhoIsFocused

 $Description:	provides handle of currently focussed window

 $Returns:		mfwFocus

 $Arguments:	None.
 
*******************************************************************************/

MfwHnd startWhoIsFocused( void )
{
    return( mfwFocus );
}

/*******************************************************************************

 $Function:    	showwelcome

 $Description:	 shows a welcome Message when swiching on the mobile
 
 $Returns:		none

 $Arguments:	
                
*******************************************************************************/

void showwelcome (T_MFW_HND win)            /* SH - not static, as now externally called */
{
    T_DISPLAY_DATA   display_info;
    T_MFW_HND   dialogwin;

    TRACE_FUNCTION("showwelcome ()");
    //if(FFS_flashData.PLMN_selection_mode == NM_AUTOMATIC)
    nm_registration (NM_AUTOMATIC,0, 0);
    //dspl_ClearAll();/*2003/12/16, wangyan modify*/
    dialog_info_init(&display_info);//gdy add
    idle_set_starting_up(FALSE); /*SPR#1083-JVJ Starting is finished for Idle */
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.TextId       = '\0';
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
	/* 2004/05/13 sunsj modify */
#if (MAIN_LCD_SIZE==3)
	display_info.Time         = 2100; 
#elif ( MAIN_LCD_SIZE==4 )
    display_info.Time         = 1750;

#elif ( MAIN_LCD_SIZE==2 )
    display_info.Time         = 2100; //Sunny modify. old:3000
#endif
    display_info.Callback     = (T_VOID_FUNC)show_welcome_cb;
    /*zy:2003-02-11 couldn't stop anim avoid have no time*/
    // display_info.KeyEvents    =  KEY_ALL^KEY_POWER;//zy 1016
    display_info.KeyEvents    = NULL;//zy 2003-02-11
    /*end of zy change 2003-02-11*/
    display_info.Identifier    =StartAnimDialog;
    /*
     * Call Icon
     */

    animation_complete = FALSE;    
    dialogwin=info_dialog (win, &display_info);
    /*2003/12/02,talcon add to fix bug no animation*/
    if( dialogwin == NULL )return;

    //2004-04-21 Sunny add 
    switch( FFS_flashData.onoffanimation )
    {
    case 0:
        mmi_dialogs_insert_fixmov_animation(dialogwin, 350 ,WELCOMEANIM);
        break;
    case 1://Mobileinnovation			
        break;
    case 2://flower
        mmi_dialogs_insert_fixmov_animation(dialogwin, 350 ,WELCOMEANIM);
        break;
    case 3://Skyrocket
        break;
    }
    //2004-04-21 Sunny add end

#if 0
    switch( FFS_flashData.onoffanimation )
    {
    /*case 0:  xsf remarked it 2003.01.14
     mmi_dialogs_insert_fixmov_animation(dialogwin, 400 ,WELCOMEANIM,10);
     break;
        */
    case 2:
        //            mmi_dialogs_insert_fixmov_animation(dialogwin, 400 ,ANIM3,7);
        //            mmi_dialogs_insert_fixmov_animation(dialogwin, 400 ,ANIM3);/*2003/12/13, wangyan modify*/
        break;
    case 1:
        //            mmi_dialogs_insert_fixmov_animation(dialogwin, 350 ,ANIM2,12);
        mmi_dialogs_insert_fixmov_animation(dialogwin, 350 ,WELCOMEANIM);/*2003/12/4, wangyan modify*/
        break;
    default:
        break;
    }
    /*2003/12/02,talcon add to fix bug no animation*/
#endif
    r2d_refresh();  
}

/*******************************************************************************

 $Function:    	show_welcome_cb

 $Description:	 shows a welcome Message when swiching on the mobile
 
 $Returns:		none

 $Arguments:	
                
*******************************************************************************/

static int show_welcome_cb(T_MFW_HND win, USHORT identifier, UBYTE reason)
{
    char imei[16];//hxl add for check imei, 2002-11-26

    TRACE_FUNCTION("show_welcome_cb");

    //check imei,if it isn't corret, write the default imei, hxl add 2002-11-26
    memset(imei,0,16);
    get_imei(imei);

    if( IsNumeric(imei)==FALSE )
    {
        strcpy(imei,"446019197507590");
        write_imei((U8 *)imei);
    }
    ffsfile_init();//hxl moved to this 2002-11-25
    wapffsfile_init();//zhaowm 2002/12/26

    /* SH - removed call to startregis, now in startInit */

    mmeInit();  //fieldstrength driver

    /* SPR759 - SH. Initialise homezone */
#ifdef MMI_HOMEZONE_ENABLED
    homezoneInit();
#endif /* HOMEZONE */

    animation_complete = TRUE;
    anim_real_complete = TRUE;  //xsf add 2002.11.26 for idle update when PIN or HOSTKEY is open
    if( FFS_flashData.contrast_intensity<0||FFS_flashData.contrast_intensity>6 )
        FFS_flashData.contrast_intensity=3;
#if ((ModeType ==1) || (ModeType ==2) || (ModeType ==3))
    contrast_intensity=FFS_flashData.contrast_intensity*4+69;
#else
    contrast_intensity=FFS_flashData.contrast_intensity*4+0x14B;
#endif
    //	  ColorLCD_Init(0);
    ContrastAdjust(FFS_flashData.contrast_intensity);//zy avoid white screen
    timStart(gtVibator);
/* zhq, 2004/07/08, add for we use pin_outer_wait to init sub screen
and we do not refresh untile main screen drawIdle. */
    main_sreen_init_complete = TRUE;

    idleExec(IdleNormal, 0);//zy add 0926 for go to idle when animation_complete
    LineControl=1;
    // 2003/10/9, zhq, remove it for test.
    //   TM_EnableWatchdog();  //enable hardware watchdog 2003/4/7 ganchunhui
    Set_ForResetIndication(); //set the value for indication the reset
    //cphs_select_line(MFW_SERV_LINE2); 
}

//hxl add for chargerwin entry0905--------------------------------

void AniandSerachon(void)
{
    //pin_init( 0 );  //xsf removed startInit()
    mmi_cphs_init();
    // SH...17/01/02. 
#ifdef MMI_GPRS_ENABLED
    mmiGprsInit();
#endif // GPRS 

    pwr_Status.ChargingVirtualKeyFlag=1;
    // SH - PIN screen now comes before welcome screen 
    startregis();   
    if( FFS_flashData.Band_restriction!=0 )//If it is not the default setting for band_Locked
        LockBand=1;
    //  ColorLCD_Init(1); //zy move 12/29
    //   ContrastAdjust(3);//zy move 12/29
    if( als_status_checkicon()==1&&LineControl!=0 )
    {
        LineControl=sAT_PercentALS(CMD_SRC_LCL, ALS_MOD_SPEECH);
    }
    else if( als_status_checkicon()==2&&LineControl!=0 )
    {
        LineControl=sAT_PercentALS(CMD_SRC_LCL, ALS_MOD_AUX_SPEECH);

    }

}

void BaseWinExit(void)
{
    cphs_exit(); //MC

    /* SH - GPRS */
#ifdef MMI_GPRS_ENABLED
    mmiGprsExit( 0 );
#endif/* GPRS */

    SIM_PowerOff();

    //  	if(ChargerPlugIn())
    /*  	if(pwr_Status.charger_plugged){
            animation_complete=FALSE;
            ChargeWin();
        }else {*/
    SwitchOffMobile();

}

void SwitchOffMobile(void)
{
    //these are move from mainshutdown
    mmiExit();/* RM 20-07 */
    //   SIM_PowerOff();//hxl moved it to basewinexit() 20020906
#ifndef _SIMULATION_
    AI_Power(0);
#endif

}

//check if string is combined by number(0~9)
BOOL IsNumeric(char *s)
{
    while( *s != '\0' )
    {
        if( *s >'9' && *s <'0' )
            return FALSE;
        s++;
    }
    return TRUE;
    /*
        int len=0;
        int i=0;
        U8  *us=(U8 *)s;
    
        len=strlen(s);
        for(i=0;i<len;i++)
        {
            if((us[i]>0x39)||(us[i]<0x30))
                break;
        }
    
        if(i<len)
            return FALSE;
    
        return TRUE;
        */
}
//end of hxl add 0905------------------------------------

/*******************************************************************************
                                                                             
                                End of File
                                                                              
*******************************************************************************/
