/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MmiTextInput
 $File:		    MmiTextInput.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		sunsj
 $Date:		    2003/12/04
                                                                               
********************************************************************************
                                                                              
 Description:MMI text Input handling.
 

                         
********************************************************************************

 $History: MmiTextInput.c
       
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#include <stdio.h>
#include <string.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiMmi.h"

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiTextInput.h"
#include "Mmieditor_i.h"
#include "MmiSmsBroadcast.h"
#include "MmiSmsMenu.h"
#include "MmiSmsSend.h"
#include "Mmisat_i.h"
#include "Mmisymbol.h"
/* 2004/06 sunsj modify for icon manage */
#include "mmiiconresource.h"

//#define TDTRACE 1
#include "mmiutilapi.h"
/****************************************************************************************
                GLOBAL DEFINE
*****************************************************************************************/
#define   MaxPinYin      402
#define   MAX_TEXT_INPUT_MODE  SHUZI_INPUT_MODE

/***********************************************************************************************
************************************************************************************************/

static const unsigned char TextIconeZiTextSmall[] =
{
    0x03,
    0x03,
    0x18,
    0x7c,
    0xcc,
    0x08,
    0x10,
    0x0c
};

int test = ELEMENT_LINE;
static const char  StrokePrompt[]  = {0x7B, 0x14, 0x52, 0x12, 0x00, 0x3A, 0x00, 0x00};
static const char  PinYinPrompt[]  = {0x62, 0xFC, 0x97, 0xF3, 0x00, 0x3A, 0x00, 0x00};

/* 2003/12/22 sunsj modify table */
static ZI8WCHAR const ZiStrokeKeyMap[10][3] =   /* table for PINYIN */
{
    {0,   ZI8_STROKE_MORE},
    {1,   ZI8_STROKE_OVER},
    {2,   ZI8_STROKE_DOWN},
    {3,   ZI8_STROKE_LEFT},
    {4,   ZI8_STROKE_DOT},
    {5,   ZI8_STROKE_OVER_DOWN},
    {6,   ZI8_STROKE_CURVED_HOOK},
    {7,   ZI8_STROKE_DOWN_OVER},
    {8,   ZI8_STROKE_WILDCARD},
    {9,   ZI8_STROKE_OVER_DOWN_OVER},
};

static ZI8WCHAR const ZiPinYinKeyMap[9][6] =   /* table for PINYIN */
{
    {ZI8_CODE_TONES_1,    ZI8_CODE_TONES_2,   ZI8_CODE_TONES_3,   ZI8_CODE_TONES_4,   ZI8_CODE_TONES_5,   5},
    {ZI8_CODE_PINYIN_A,   ZI8_CODE_PINYIN_B,  ZI8_CODE_PINYIN_C,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_D,   ZI8_CODE_PINYIN_E,  ZI8_CODE_PINYIN_F,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_G,   ZI8_CODE_PINYIN_H,  ZI8_CODE_PINYIN_I,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_J,   ZI8_CODE_PINYIN_K,  ZI8_CODE_PINYIN_L,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_M,   ZI8_CODE_PINYIN_N,  ZI8_CODE_PINYIN_O,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_P,   ZI8_CODE_PINYIN_Q,  ZI8_CODE_PINYIN_R,  ZI8_CODE_PINYIN_S,  0,                  4},
    {ZI8_CODE_PINYIN_T,   ZI8_CODE_PINYIN_U,  ZI8_CODE_PINYIN_V,  0,                  0,                  3},
    {ZI8_CODE_PINYIN_W,   ZI8_CODE_PINYIN_X,  ZI8_CODE_PINYIN_Y,  ZI8_CODE_PINYIN_Z,  0,                  4},
};

static const char  * PinyinTable[MaxPinYin] = {
    "a","ai","an","ang","ao","ba","bai","ban","bang","bao",
    "bei","ben","beng","bi","bian","biao","bie","bin","bing","bo",
    "bu","ca","cai","can","cang","cao","ce","cen","ceng","cha",
    "chai","chan","chang","chao","che","chen","cheng","chi","chong","chou",
    "chu","chuai","chuan","chuang","chui","chun","chuo","ci","cong","cou",
    "cu","cuan","cui","cun","cuo","da","dai","dan","dang","dao",
    "de","deng","di","dia","dian","diao","die","ding","diu","dong",
    "dou","du","duan","dui","dun","duo","e","ei","en","er",
    "fa","fan","fang","fei","fen","feng","fo","fou","fu","ga",
    "gai","gan","gang","gao","ge","gei","gen","geng","gong","gou",
    "gu","gua","guai","guan","guang","gui","gun","guo","ha","hai",
    "han","hang","hao","he","hei","hen","heng","hong","hou","hu",
    "hua","huai","huan","huang","hui","hun","huo","ji","jia","jian",
    "jiang","jiao","jie","jin","jing","jiong","jiu","ju","juan","jue",
    "jun","ka","kai","kan","kang","kao","ke","ken","keng","kong",
    "kou","ku","kua","kuai","kuan","kuang","kui","kun","kuo","la",
    "lai","lan","lang","lao","le","lei","leng","li","lia","lian",
    "liang","liao","lie","lin","ling","liu","long","lou","lu","luan",
    "lue","lun","luo","lv","ma","mai","man","mang","mao","me",
    "mei","men","meng","mi","mian","miao","mie","min","ming","miu",
    "mo","mou","mu","na","nai","nan","nang","nao","ne","nei",
    "nen","neng","ni","nian","niang","niao","nie","nin","ning","niu",
    "nong","nou","nu","nuan","nue","nuo","nv","o","ou","pa",
    "pai","pan","pang","pao","pei","pen","peng","pi","pian","piao",
    "pie","pin","ping","po","pou","pu","qi","qia","qian","qiang",
    "qiao","qie","qin","qing","qiong","qiu","qu","quan","que","qun",
    "ran","rang","rao","re","ren","reng","ri","rong","rou","ru",
    "ruan","rui","run","ruo","sa","sai","san","sang","sao","se",
    "sen","seng","sha","shai","shan","shang","shao","she","shen","sheng",
    "shi","shou","shu","shua","shuai","shuan","shuang","shui","shun","shuo",
    "si","song","sou","su","suan","sui","sun","suo","ta","tai",
    "tan","tang","tao","te","teng","ti","tian","tiao","tie","ting",
    "tong","tou","tu","tuan","tui","tun","tuo","wa","wai","wan",
    "wang","wei","wen","weng","wo","wu","xi","xia","xian","xiang",
    "xiao","xie","xin","xing","xiong","xiu","xu","xuan","xue","xun",
    "ya","yan","yang","yao","ye","yi","yin","ying","yo","yong",
    "you","yu","yuan","yue","yun","za","zai","zan","zang","zao",
    "ze","zei","zen","zeng","zha","zhai","zhan","zhang","zhao","zhe",
    "zhen","zheng","zhi","zhi","zhong","zhou","zhu","zhua","zhuai","zhuan",
    "zhuang","zhui","zhun","zhuo","zi","zong","zou","zu","zuan","zui","zun","zuo"
};

static  UBYTE ec_editControls [KCD_MAX] =      /* edit control keys: */
{
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '*', '#', ecNone, ecNone, ecUp, ecDown, ecLeft, ecRight,
    ecNone, ecNone, ecEnter, ecNone, ecNone, ecNone,
    ecNone, ecNone, ecEnter
};

const static char * l_editAlphaL[14] =   // lowercase key 0123456789*#
{
    "\'\"/.+-=0", " ,.?!:1", "abc2", "def3",        //key 0,1,2,3
    "ghi4", "jkl5", "mno6", "pqrs7",                //key 4,5,6,7
    "tuv8", "wxyz9", "*#%&@ ", " \'\"/","\0","\0"   //key 8,9,*,#
};      

const static char * l_editAlphaU[14] =   // uppercase key 0123456789*#
{
    "\'\"/.+-=0", " ,.?!:1", "ABC2", "DEF3",        //key 0,1,2,3
    "GHI4", "JKL5", "MNO6", "PQRS7",                //key 4,5,6,7
    "TUV8", "WXYZ9", "*#%&@ ", " \'\"/","\0","\0"   //key 8,9,*,#
};

static int    editor_input_mode;
static USHORT TEXT_BUFFER_EDIT_SIZE;
static UBYTE  editAlphaLevel;               /* alpha level selected     */
static UBYTE  editAlphaKey;                 /* alpha mode current key   */
static BOOL   FirstEnterEditor;
static MfwHnd TextInputHandle = 0;
static BOOL   ComponentFlag = FALSE;        /* 2003/12/15 sunsj component flag */
static BOOL   input_key_timer_flag = 0;     /* 2004/06/28 sunsj add */

/***********************************************************************************************
************************************************************************************************/

static T_MFW_HND  text_input_create        (T_MFW_HND  parent_win);
static void       text_input_exec_cb       (T_MFW_HND  win, USHORT event, SHORT value, T_EDITOR_DATA * parameter);
static int        text_input_win_cb        (T_MFW_EVENT event, T_MFW_WIN * win);
static int        text_input_kbd_cb        (T_MFW_EVENT event, T_MFW_KBD * keyboard);
static int        text_input_tim_cb        (T_MFW_EVENT event, T_MFW_TIM *tc);
static int        text_input_key_tim_cb    (T_MFW_EVENT event, T_MFW_TIM *tc);

/* Initialize the defined structure */
static void IMEInitialize(pIME_DATA pIME, PZI8GETPARAM pGetParam, PZI8WCHAR wszTextBuffer, int TextBufferEditSize,
                          int TextBufferSize, PZI8WCHAR wcCandidates, PZI8WCHAR wszElementBuffer, PZI8WCHAR DisplayElementBuffer);
static void IMECursorLeft(pIME_DATA pIME); /* move the candidate cursor left */
static void IMECursorRight(pIME_DATA pIME); /* move the candidate cursor right */
static void IMESelectCandidate(pIME_DATA pIME, PZI8WCHAR wszElementBuffer); /* Select the candidate at cursor */
static void IMEMore(pIME_DATA pIME); /* get the next group of candidates */
static void IMEKeyPress(pIME_DATA pIME, ZI8WCHAR wcStroke); /* enter the stroke and get new candidates */
static void IMEClear(pIME_DATA pIME, PZI8WCHAR wszElementBuffer); /* Clear the last stroke entered */
static void CandidateHighlightDisplayContorl(pIME_DATA pIME, PZI8WCHAR HighlightedCandidate);
static void TextCursorDisplayContorl(pIME_DATA pIME, PZI8WCHAR CursorPosition, int InsertLine);
static void IMEChangeMode(pIME_DATA pIME, PZI8GETPARAM pGetParam);
static void DataConvert(pIME_DATA pIME);
static ZI8WCHAR Uni_strlen(PZI8WCHAR String);

static void Zi_onekey_keypress(pIME_DATA pIME , PZI8WCHAR key_map);    /* enter the key and get pinyin and candidate */
static int  Zi_GetElementCandidates(pIME_DATA pIME);                   /* getcandidate through element */
static void UnicodeConver(USHORT* inputString, USHORT* outputString);
static void Zi_onekey_clear(pIME_DATA pIME);                    /* clear element or text */
static void IMECandidatePageUp(pIME_DATA pIME);             /* page up candidate */
static void IMECandidatePageDown(pIME_DATA pIME);               /* page down candidate */
static void DisplayPinyinElement(pIME_DATA pIME);               /* display pinyin element */
static void IMESetDefaultValue(pIME_DATA pIME);             /* reset IME value */
static int  GetKeyEventConfig( T_TEXT_INPUT* textEditorData );
static void ChangeDisplayArea( MfwHnd TexInputHandle, int DisplayArea, T_TEXT_INPUT* textEditorData );
static void DrawPromptIcon( int InputMode );
static void EditorSoftkey(T_TEXT_INPUT *data);      /* 2004/03/23 sunsj add */
static void DisplayOtherArea(T_TEXT_INPUT *data);   /* 2004/03/23 sunsj add */

/***********************************************************************************************
************************************************************************************************/

static UBYTE LatinChar(ZI8WCHAR char_code)
{
    //if last byte is 0x00 and first byte is between 0x20 and 0x7E
    if( (char_code% 0x100 == 0)&&(char_code>=0x2000) && (char_code<0x7F00) )
        return TRUE;
    else
        return FALSE;
}

/*******************************************************************************

 $Function:    	text_input

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND text_input (T_MFW_HND parent_win, T_EDITOR_DATA* text_input_data)
{
    T_MFW_HND   win;

    win = text_input_create (parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, TEXT_INPUT_INIT, 0, text_input_data);
    }
    return win;
}

/*******************************************************************************

 $Function:    	text_input_create

 $Description:	
 
 $Returns:		Dialogue info win

 $Arguments:	parent win
 
*******************************************************************************/
static T_MFW_HND text_input_create (T_MFW_HND parent_win)
{
    T_MFW_WIN     * win_data;
    T_TEXT_INPUT  * data = (T_TEXT_INPUT *)ALLOC_MEMORY (sizeof (T_TEXT_INPUT));

    data->input_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)text_input_win_cb);
    if( data->input_win EQ 0 )
    {
        return 0;
    }
    /* Create window handler */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)text_input_exec_cb;
    data->mmi_control.data      = data;
    data->parent_win            = parent_win;
    win_data                    = ((T_MFW_HDR *)data->input_win)->data;
    win_data->user              = (void *)data;
    /*return window handle */
    return data->input_win;
}

/*******************************************************************************

 $Function:    	text_input_destroy

 $Description:	Destruction of an information dialog
 
 $Returns:		void

 $Arguments:	win
 
*******************************************************************************/
void text_input_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN        * win  = ((T_MFW_HDR *)own_window)->data;
    T_TEXT_INPUT     * data = (T_TEXT_INPUT *)win->user;

    if( data )
    {
        FirstEnterEditor = 5;
        /* Exit TIMER & KEYBOARD Handle */
        kbd_delete (data->input_kbd);
        /* Delete WIN Handler */
        win_delete (data->input_win);
        /* Free Memory */
        FREE_MEMORY ((void *)data, sizeof (T_TEXT_INPUT));
    }
}

/*******************************************************************************

 $Function:    	text_input_exec

 $Description:	

 $Returns:		void

 $Arguments:	win, window handle event, value, parameter

*******************************************************************************/
static void text_input_exec_cb (T_MFW_HND win, USHORT event, SHORT value, T_EDITOR_DATA * parameter)
{
    T_MFW_WIN       * win_data       = ((T_MFW_HDR *)win)->data;
    T_TEXT_INPUT    * data           = (T_TEXT_INPUT *)win_data->user;
    T_EDIT_CB       Callback         = data->editor_data.Callback;
    T_MFW_HND       parent_win       = data->parent_win;
    UINT32          oldFontColor;
    //MfwHdr          * edit_hdr;
    //MfwEdt          * edit_controll;
    USHORT          Identifier       = data->editor_data.Identifier;

    /* operate the event */
    switch( event )
    {
    case TEXT_INPUT_INIT:
        /* I have not understood the use of label text */
        /*
        if ( data->editor_data.TextString NEQ NULL )
        {
            memcpy (data->LabelText, data->editor_data.TextString, sizeof(data->LabelText));
        }
        */
        data->editor_data     = *parameter;
        data->destroyEditor   = data->editor_data.destroyEditor;

        TEXT_BUFFER_EDIT_SIZE = (data->editor_data.editor_attr.size - 3);

        data->input_kbd       = kbd_create (data->input_win, KEY_ALL, (T_MFW_CB)text_input_kbd_cb);
        data->input_kbd_long  = kbd_create (data->input_win, KEY_ALL|KEY_LONG,(T_MFW_CB)text_input_kbd_cb);
        data->input_edt       = edtCreate  (data->input_win, &data->editor_data.editor_attr,MfwEdtVisible,0);
        data->input_key_tim   = timCreate(data->input_win,750,(MfwCb) text_input_key_tim_cb);

        if( data->editor_data.timeout && (data->editor_data.timeout NEQ FOREVER) )
        {
            data->input_tim   = tim_create (data->input_win, data->editor_data.timeout, (T_MFW_CB)text_input_tim_cb);
            tim_start (data->input_tim);
        }
        else
        {
            data->input_tim   = NULL;
        }

        memset(&data->Ime, 0, sizeof(data->Ime));
        memset(&data->GetParam, 0, sizeof(data->Ime));
        memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
        memset(&data->HighlightedCandidate, 0, sizeof(data->HighlightedCandidate));
        memset(&data->CursorPosition, 0, sizeof(data->CursorPosition));
        memset(&data->DisplayElementBuffer, 0,sizeof(data->DisplayElementBuffer));
        data->StartOfDisplayIndex   = 0;
        data->NumberOfKeyPress      = 0;
        data->PerviousKeyPress      = -1;
        editor_input_mode           = data->editor_data.InputMode;
        data->Ime.EditorMode        = data->editor_data.InputMode;  /* 2004/06/02 sunsj modify */
        data->wszTextBuffer         = (PZI8WCHAR)data->editor_data.editor_attr.text;
        FirstEnterEditor            = 5;
        TextInputHandle             = data->input_edt;

        /* alpha input mode initialize */
        editAlphaLevel = 0; 
        editAlphaKey = KCD_MAX;

        IMEInitialize(&data->Ime, &data->GetParam, data->wszTextBuffer, TEXT_BUFFER_EDIT_SIZE,
                      sizeof(data->wszTextBuffer), data->wcCandidates, data->wszElementBuffer, data->DisplayElementBuffer);

        /* 2003/12/29 sunsj set phone book editor context */
        if( data->editor_data.edtInPbk != 0 )
        {
            data->Ime.pGetParam->Context = ZI8_GETCONTEXT_SURNAME;
        }

        win_show (data->input_win);
        break;
    case TEXT_INPUT_DESTROY:
        /* 2004/05/17 sunsj modify the bug. If delete editor win in callback then will not destroy editor other time */
        {
            T_MFW_HND oldparent = NULL;
            oldparent = data->parent_win;

            if( Callback )
            {
                (Callback) (parent_win, Identifier, value);
            }

            if( data->parent_win == oldparent )
            {
                if( data->destroyEditor == TRUE )
                {
                    text_input_destroy(data->input_win);
                }
            }
        }
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	text_input_win_cb

 $Description:	
 
 $Returns:		void

 $Arguments:	window handle event, win
*******************************************************************************/
static int text_input_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_TEXT_INPUT * data          = (T_TEXT_INPUT *)win->user;
    T_MFW_HND    parent_win      = data->parent_win;
    USHORT       Identifier      = data->editor_data.Identifier;
    T_EDIT_CB    Callback        = data->editor_data.Callback;
    MfwHdr       * edit_hdr      = (MfwHdr *)data->input_edt;
    MfwEdt       * edit_controll = (MfwEdt *)edit_hdr->data;
    U32          OldBackgroundColor;
    U32          OldForegroundColor;
    /* 2003/12/29 sunsj modify buffer size */
    char         DisplayCandidateBufLine1[CANDIDATES_PER_GROUP*2+3];
    char         DisplayCandidateBufLine2[CANDIDATES_PER_GROUP*2+3];
    int          i=0;
    int          fontHeight = Mmi_layout_line_height();

    /* if data is wrong then return */
    if( data == 0 )
    {
        return MFW_EVENT_CONSUMED;
    }

    if( Callback && data->editor_data.edtInPbk )
        (Callback) (parent_win, 1, INFO_EDT_UPDATE);
    if( Callback && data->editor_data.Identifier == SMSREAD_EDIT )
        (Callback) (parent_win, 1, INFO_EDT_UPDATE);

    /* 2004/05/08 sunsj modify */
    if( (data->editor_data.editor_attr.text[0]=='\0' )&&(data->editor_data.Identifier==SMSSEND_ID_TEXTEDIT) )
    {
        if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
        {
            /* 2004/06/30 sunsj modify for m288b */
#ifdef _M188_
            data->editor_data.editor_attr.e_size = 73;
#endif
#if(MAIN_LCD_SIZE==4)
            data->editor_data.editor_attr.e_size = 503;
#elif(MAIN_LCD_SIZE==3)
			data->editor_data.editor_attr.e_size = 73;
#endif
        }
        else
        {
            /* 2004/06/30 sunsj modify for m288b */
#ifdef _M188_
            data->editor_data.editor_attr.e_size = 163;
#endif
#if(MAIN_LCD_SIZE==4)
            data->editor_data.editor_attr.e_size = 573;
#elif(MAIN_LCD_SIZE==3)
			data->editor_data.editor_attr.e_size = 163;
#endif
        }
    }
    else
    {
        if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
        {
            if( (((data->editor_data.editor_attr.size - 3)/2)+3) >= 0 )
            {
                data->editor_data.editor_attr.e_size = (((data->editor_data.editor_attr.size - 3)/2)+3);
            }
            else
            {
                data->editor_data.editor_attr.e_size = 0;
            }
        }
        else
        {
            data->editor_data.editor_attr.e_size = data->editor_data.editor_attr.size;
        }
    }
    /*2003/12/24, wangyan modify*/

    switch( event )
    {
    case E_WIN_VISIBLE:
        {
            if( win->flags & E_WIN_VISIBLE )
            {
                /* If the editor is phonebook editor then we only need update window */
                /* 2004/03/24 sunsj modify for search window cannot refresh */
                if( data->editor_data.edtInPbk )// == 1 )
                {
                    MfwEdt *edt;

                    updateWindow(edit_controll, 0);
                    edt = ((MfwHdr *) data->input_edt)->data;
                    edt->flags |= MfwEdtVisible;
                    /* 2004/03/11 sunsj modify */
                    edtShow(data->input_edt);
                }
                /* display the window */
                else
                {
                    /* do the first display */
                    //if( FirstEnterEditor )
                    {
                        edtShow(data->input_edt);
                        if( data->input_kbd == NULL )
                        {
                            dspl_TextOut(1, ELEMENT_LINE,DSPL_TXTATTR_INVERS, "input_kbd is null");
                        }
                        //FirstEnterEditor--;
                    }
                }
                /* 2004/03/08 sunsj modify */
                {
                    //int currentTheme=FlashSettingData.theme;
                    //dspl_BitBlt(0, 0, menuup[currentTheme].area.sx, menuup[currentTheme].area.sy, 0, (void*)menuup[currentTheme].icons, 0);
                }
                /* 2004/04/16 sunsj add */
                if( data->editor_data.TextId NEQ 0 )
                {
                    /* 2004/06/08 sunsj modify */
                    char *title;
                    MfwEdt *edt;
                    char spareNum[4];

                    edt = ((MfwHdr *) data->input_edt)->data;
                    if( getSymbolNumSpare(edt) >= 0 )
                    {
                        sprintf(spareNum, "%3d", getSymbolNumSpare(edt));
                    }
                    else
                    {
                        sprintf(spareNum, "%3d", 0);
                    }

                    title = (char *) MmiRsrcGetText(data->editor_data.TextId);
                    displayTitle( 15, title, spareNum, TITLE_WITH_NUMBER, 0, 0);
                }
                else if( data->editor_data.TextString NEQ NULL )
                {
                    /* 2004/06/08 sunsj modify */
                    MfwEdt *edt;
                    char spareNum[4];

                    edt = ((MfwHdr *) data->input_edt)->data;
                    if( getSymbolNumSpare(edt) >= 0 )
                    {
                        sprintf(spareNum, "%3d", getSymbolNumSpare(edt));
                    }
                    else
                    {
                        sprintf(spareNum, "%3d", 0);
                    }
                    /* 2004/04/22 sunsj modify */
                    displayTitle( 15, data->editor_data.TextString, spareNum, TITLE_WITH_NUMBER, 0, 0);
                }

                if( data->editor_data.edtInPbk == 1 )
                {
                    //return MFW_EVENT_CONSUMED;
                }
                OldBackgroundColor = dspl_GetBkgColor();
                dspl_SetBkgColor(TEXT_CANDIDATE_BACKGROUND);
                OldForegroundColor = dspl_GetFrgColor();
                dspl_SetFrgColor(TEXT_CANDIDATE_FOREGROUND);

                switch( data->Ime.InputScreenType )
                {
                case TEXT_DISPLAY_SCREEN:
                    {
                        if( data->editor_data.edtInPbk == 1 )
                        {
                            dspl_SetBkgColor(OldBackgroundColor);
                            dspl_SetFrgColor(OldForegroundColor);
                        }
                        else
                        {
                            dspl_SetFrgColor(OldForegroundColor);
                            dspl_SetBkgColor(OldBackgroundColor);
                        }
                    }
                    break;
                case STROKE_INPUT_SCREEN:
                    {
                        if( data->wcCandidates[0] == 0x00 )
                        {
                            break;
                        }
                        /* 20004/01/04 sunsj modify for different lcd size */
                        dspl_Clear(0, (USHORT)(ELEMENT_LINE-1), SCREEN_SIZE_X, (USHORT)(CANDIDATES_LINE+fontHeight) );
                        dspl_TextOut(1, ELEMENT_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)data->DisplayElementBuffer);
                        dspl_TextOut_Blk(LEFT_INDENTATION, CANDIDATES_LINE, SCREEN_SIZE_X, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)data->wcCandidates);
                        CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);

                        dspl_SetBkgColor(OldBackgroundColor);
                        dspl_SetFrgColor(OldForegroundColor);

#if (MAIN_LCD_SIZE==3)//jhxu720				
				        DRAW_ICON(ICON_TEXTINPUT_EDITBAR);
#elif ( MAIN_LCD_SIZE==4 )
                        /* 2004/01/04 sunsj modify for different lcd size */
                        dspl_DrawRect(0, ELEMENT_LINE-2, SCREEN_SIZE_X-1, CANDIDATES_LINE+fontHeight+2);
                        dspl_DrawLine(0, ELEMENT_LINE+fontHeight+1 , SCREEN_SIZE_X-1, ELEMENT_LINE+fontHeight+1);
#elif ( MAIN_LCD_SIZE==2 )
                        //dspl_DrawRect(0, ELEMENT_LINE-1, SCREEN_SIZE_X-1, CANDIDATES_LINE+fontHeight+1);
#endif
                    }
                    break;
                case PINYIN_INPUT_SCREEN:
                    {
                        if( data->wcCandidates[0] == 0x00 )
                        {
                            break;
                        }

                        /* 2004/01/04 sunsj modify for different lcd size */
                        dspl_Clear(0, (USHORT)(ELEMENT_LINE-1), SCREEN_SIZE_X, (USHORT)(CANDIDATES_LINE+fontHeight) );
#if (MAIN_LCD_SIZE==3)//jhxu720		
						DRAW_ICON(ICON_TEXTINPUT_EDITBAR);
#endif
                        DisplayPinyinElement(&data->Ime);
                        dspl_TextOut_Blk(LEFT_INDENTATION, CANDIDATES_LINE, SCREEN_SIZE_X, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)data->wcCandidates);
                        CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);

                        dspl_SetBkgColor(OldBackgroundColor);
                        dspl_SetFrgColor(OldForegroundColor);
                        /* 2004/01/04 sunsj modify for 102x80 screen type */
#if ( MAIN_LCD_SIZE==4 )
                        /* 2004/01/04 sunsj modify for different lcd size */
                        dspl_DrawRect(0, ELEMENT_LINE-2, SCREEN_SIZE_X-1, CANDIDATES_LINE+fontHeight+2);
                        dspl_DrawLine(0, ELEMENT_LINE+fontHeight+1 , SCREEN_SIZE_X-1, ELEMENT_LINE+fontHeight+1);
#endif
#if ( MAIN_LCD_SIZE==2)
                        //dspl_DrawRect(0, ELEMENT_LINE-1, SCREEN_SIZE_X-1, CANDIDATES_LINE+fontHeight+1);
#endif
                    }
                    break;
                case WORD_ASSOCIATION_SCREEN:
                    {
                        if( data->wcCandidates[0] == 0x00 )
                        {
                            break;
                        }

                        /* 20004/01/04 sunsj modify for different lcd size */
                        dspl_Clear(0, (USHORT)(ELEMENT_LINE-1), SCREEN_SIZE_X, (USHORT)(CANDIDATES_LINE+fontHeight) );
#if (MAIN_LCD_SIZE==3)//jhxu720
						DRAW_ICON(ICON_TEXTINPUT_EDITBAR);
#elif ( MAIN_LCD_SIZE==2 )
                        dspl_BitBlt(0, 39, 102, 26, 0, (void *) Edit_bar_bmp, 0);
#endif
                        /* 2003/12/29 sunsj modify buffer size */
                        memset(DisplayCandidateBufLine1, 0x00, (CANDIDATES_PER_GROUP*2+3));
                        memset(DisplayCandidateBufLine2, 0x00, (CANDIDATES_PER_GROUP*2+3));

                        if( (data->Ime.EditorMode == PINYIN_INPUT_MODE) || (data->Ime.EditorMode == STROKE_INPUT_MODE) )
                        {
                            if( data->wcCandidates[0] != 0x00 )
                            {
                                DisplayCandidateBufLine1[0] = 0x80;
                                memcpy(&DisplayCandidateBufLine1[1], (char *)data->wcCandidates, CANDIDATES_PER_GROUP*2 );
                            }
                            if( data->wcCandidates[7] != 0x00 )
                            {
                                DisplayCandidateBufLine2[0] = 0x80;
                                memcpy(&DisplayCandidateBufLine2[1], (char *)data->wcCandidates+CANDIDATES_PER_GROUP*2, CANDIDATES_PER_GROUP*2 );
                            }
                        }
                        /* 2003/12/15 sunsj modify coordinate */
                        dspl_TextOut_NoNewline(LEFT_INDENTATION, ELEMENT_LINE, DSPL_TXTATTR_TRANSPARENT, DisplayCandidateBufLine1);
                        dspl_TextOut_NoNewline(LEFT_INDENTATION, CANDIDATES_LINE, DSPL_TXTATTR_TRANSPARENT, DisplayCandidateBufLine2);
                        CandidateHighlightDisplayContorl(&data->Ime, data->HighlightedCandidate);

                        dspl_SetBkgColor(OldBackgroundColor);
                        dspl_SetFrgColor(OldForegroundColor);
#if ( MAIN_LCD_SIZE==4 )
                        /* 20004/01/04 sunsj modify for different lcd size */
                        dspl_DrawRect(0, ELEMENT_LINE-2, SCREEN_SIZE_X-1, CANDIDATES_LINE+fontHeight+2);
                        dspl_DrawLine(0, ELEMENT_LINE+fontHeight+1 , SCREEN_SIZE_X-1, ELEMENT_LINE+fontHeight+1);
#endif
#if ( MAIN_LCD_SIZE==2)
                        //dspl_DrawRect(0, ELEMENT_LINE-1, SCREEN_SIZE_X-1, CANDIDATES_LINE+fontHeight+1);
#endif
                    }
                    break;
                default:
                    break;
                }

                /* Draw the other area */
                DisplayOtherArea( data );
            }
        }
        break;
    default:
        return MFW_EVENT_PASSED;
    }
    return MFW_EVENT_CONSUMED;  
}

/*******************************************************************************

 $Function:    	text_input_kbd_cb

 $Description:	Keyboard event handler

 $Returns:		status int

 $Arguments:	window handle event, keyboard control block

 $History:      

*******************************************************************************/
static int text_input_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND      win           = mfw_parent (mfw_header());
    T_MFW_WIN      * win_data    = ((T_MFW_HDR *)win)->data;
    T_TEXT_INPUT   * data        = (T_TEXT_INPUT *)win_data->user;
    T_MFW_HND      parent_win    = data->parent_win;
    USHORT         Identifier    = data->Identifier;
    int            temp          = 0;
    PZI8WCHAR      temp_ZiKeyMap;
    int            asciiTextSize = data->editor_data.editor_attr.e_size?data->editor_data.editor_attr.e_size:data->editor_data.editor_attr.size;
    T_TEXT_INPUT   * testptr;

    MMI_TRACE_EVENT(("sunsj-----------text_input_kbd_cb()"));
    /* 2003/12/15 sunsj start input time if the editor has time limit */
    if( data->editor_data.timeout && (data->editor_data.timeout NEQ FOREVER) )
        tim_start (data->input_tim);

    /* 2004/05/08 sunsj modify */
    if( (data->editor_data.editor_attr.text[0]=='\0' )&&(data->editor_data.Identifier == SMSSEND_ID_TEXTEDIT) )
    {
        if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
        {
            /* 2004/06/30 sunsj modify for m288b */
#ifdef _M188_
            data->editor_data.editor_attr.e_size = 73;
#endif
#if(MAIN_LCD_SIZE==4)
            data->editor_data.editor_attr.e_size = 503;
#elif(MAIN_LCD_SIZE==3)
			data->editor_data.editor_attr.e_size = 73;
#endif
        }
        else
        {
            /* 2004/06/30 sunsj modify for m288b */
#ifdef _M188_
            data->editor_data.editor_attr.e_size = 163;
#endif
#if(MAIN_LCD_SIZE==4)
            data->editor_data.editor_attr.e_size = 573;
#elif(MAIN_LCD_SIZE==3)
			data->editor_data.editor_attr.e_size = 163;
#endif
        }
    }
    else
    {
        if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
        {
            if( (((data->editor_data.editor_attr.size - 3)/2)+3) >= 0 )
            {
                data->editor_data.editor_attr.e_size = (((data->editor_data.editor_attr.size - 3)/2)+3);
            }
            else
            {
                data->editor_data.editor_attr.e_size = 0;
            }
        }
        else
        {
            data->editor_data.editor_attr.e_size = data->editor_data.editor_attr.size;
        }
    }
    /*2003/12/24, wangyan modify*/

    if( event & KEY_LONG )
    {
        switch( keyboard->code )
        {
        case KCD_LEFT:
            break;
        case KCD_RIGHT:
            /* 2004/05/08 sunsj remove because of the key press problem maybe empty the text buffer */
            /*
            if( data->editor_data.editor_attr.text[0] NEQ '\0' )
            {
                /* clear the whole buffer 
                memset(data->editor_data.editor_attr.text, 0, sizeof(data->editor_data.editor_attr.text));
                win_show(data->input_win);
            }
            */
            /* 2004/04/02 sunsj modify */
            //else
            //{
            //    SEND_EVENT (win, TEXT_INPUT_DESTROY, INFO_KCD_RIGHT, NULL);
            //}
            break;
        case KCD_HUP:
            break;
        case KCD_MNUUP:
            break;
        case KCD_MNUDOWN:
            break;
        case KCD_MNULEFT:
            break;
        case KCD_MNURIGHT:
            break;
        case KCD_0:
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
            break;
        case KCD_CALL:
            break;
        case KCD_STAR:
            break;
        case KCD_HASH:
            break;
        default:
            break;
        }
    }
    else
    {
        switch( keyboard->code )
        {
        case KCD_LEFT:
            {
                ZI8WCHAR HighByte;
                ZI8WCHAR Temp;
                ZI8WCHAR LowByte;

                /* convert current candidate which is selected by user to insert to text buffer */
                if( (data->Ime.EditorMode == PINYIN_INPUT_MODE) || (data->Ime.EditorMode == STROKE_INPUT_MODE) )
                {
                    Temp     = data->wcCandidates[data->Ime.CandidateCursor];
                    LowByte  = data->wcCandidates[data->Ime.CandidateCursor] & 0x00FF;
                    HighByte = data->wcCandidates[data->Ime.CandidateCursor] & 0xFF00;
                    Temp     = (LowByte << 8) & 0xFF00;
                    HighByte = (HighByte >> 8) & 0x00FF;
                    Temp     = Temp | HighByte;
                }

                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            {
                                if( strlen(data->editor_data.editor_attr.text) >= data->editor_data.min_enter )
                                {
                                    SEND_EVENT(win, TEXT_INPUT_DESTROY, INFO_KCD_LEFT, NULL);
                                }
                                FirstEnterEditor = 5;
                            }
                            break;
                        case PINYIN_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            {
                                if( GetKeyEventConfig(data) )
                                {
                                    /* 2004/04/01 sunsj add */
                                    DisplayOtherArea( data );
                                    return MFW_EVENT_CONSUMED;
                                }
                                IMESelectCandidate(&data->Ime, data->wszElementBuffer);
                                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                                ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                                edtSymbol( data->input_edt, Temp );
                                winShow(data->input_win);
                            }
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case STROKE_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            {
                                if( strlen(data->editor_data.editor_attr.text) >= data->editor_data.min_enter )
                                {
                                    SEND_EVENT(win, TEXT_INPUT_DESTROY, INFO_KCD_LEFT, NULL);
                                }
                                FirstEnterEditor = 5;
                            }
                            break;
                        case STROKE_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            {
                                if( GetKeyEventConfig(data) )
                                {
                                    /* 2004/04/01 sunsj add */
                                    DisplayOtherArea( data );
                                    return MFW_EVENT_CONSUMED;
                                }
                                IMESelectCandidate(&data->Ime, data->wszElementBuffer);
                                data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                                /* 2003/12/15 sunsj if the candidate is component then we need't add it to text */
                                if( ComponentFlag == TRUE )
                                {
                                }
                                else
                                {
                                    ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                                    edtSymbol( data->input_edt, Temp );
                                }
                                winShow(data->input_win);
                            }
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    if( strlen(data->editor_data.editor_attr.text) >= data->editor_data.min_enter )
                    {
                        SEND_EVENT(win, TEXT_INPUT_DESTROY, INFO_KCD_LEFT, NULL);
                    }
                    FirstEnterEditor = 5;
                    break;
                default:
                    break;
                }

            }
            break;
        case KCD_RIGHT:
#ifndef _M188_
        case KCD_CLEAR:
#endif
            {
                if( (strlen((char *)data->wszTextBuffer) == 0) && (strlen((char *)data->wcCandidates) == 0 ) )
                {
                    SEND_EVENT (win, TEXT_INPUT_DESTROY, INFO_KCD_RIGHT, NULL);
                    FirstEnterEditor = 5;
                    //return MFW_EVENT_CONSUMED;
                }
                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    switch( data->Ime.InputScreenType )
                    {
                    case TEXT_DISPLAY_SCREEN:
                        edtSymbol( data->input_edt, ecBack );
                        DisplayOtherArea( data );
                        break;
                    case PINYIN_INPUT_SCREEN:
                        Zi_onekey_clear(&data->Ime);
                        data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                        if( data->Ime.InputScreenType == TEXT_DISPLAY_SCREEN )
                        {
                            ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                            edtShow(data->input_edt);
                            if( data->editor_data.edtInPbk != 0 )
                            {
                                winShow(data->input_win);
                            }
                            else
                            {
                                /* Draw the other area */
                                DisplayOtherArea( data );
                            }
                        }
                        else
                        {
                            winShow(data->input_win);
                        }
                        break;
                    case WORD_ASSOCIATION_SCREEN:
                        data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
                        memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
                        /* 2003/12/15 sunsj */
                        data->Ime.candidates = 0;
                        ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                        edtShow(data->input_edt);
                        if( data->editor_data.edtInPbk != 0 )
                        {
                            winShow(data->input_win);
                        }
                        else
                        {
                            /* Draw the other area */
                            DisplayOtherArea( data );
                        }
                        break;
                    default:
                        break;
                    }
                    break;
                case STROKE_INPUT_MODE:
                    switch( data->Ime.InputScreenType )
                    {
                    case TEXT_DISPLAY_SCREEN:
                        edtSymbol( data->input_edt, ecBack );
                        /* Draw the other area */
                        DisplayOtherArea( data );
                        break;
                    case STROKE_INPUT_SCREEN:
                        /* 2004/05/31 sunsj modify */
                        memset(&data->wcCandidates, 0x00, sizeof(data->wcCandidates));
                        IMEClear(&data->Ime, data->wszElementBuffer);
                        data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                        if( data->Ime.InputScreenType == TEXT_DISPLAY_SCREEN )
                        {
                            ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                            edtShow(data->input_edt);
                            if( data->editor_data.edtInPbk != 0 )
                            {
                                winShow(data->input_win);
                            }
                            else
                            {
                                /* Draw the other area */
                                DisplayOtherArea( data );
                            }
                        }
                        else
                        {
                            winShow(data->input_win);
                        }
                        break;
                    case WORD_ASSOCIATION_SCREEN:
                        data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
                        memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
                        /* 2003/12/15 sunsj */
                        data->Ime.candidates = 0;
                        ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                        edtShow(data->input_edt);
                        if( data->editor_data.edtInPbk != 0 )
                        {
                            winShow(data->input_win);
                        }
                        else
                        {
                            /* Draw the other area */
                            DisplayOtherArea( data );
                        }
                        break;
                    default:
                        break;
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    /* 2004/07/06 sunsj add */
                    if( input_key_timer_flag == 1 )
                    {
                        return;
                    }
                    edtSymbol( data->input_edt, ecBack );
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    break;
                default:
                    break;
                }
                //winShow(data->input_win);
            }
            break;
        case KCD_HUP:
            {
                switch( data->Ime.InputScreenType )
                {
                case TEXT_DISPLAY_SCREEN:
                    SEND_EVENT (data->input_win, TEXT_INPUT_DESTROY, INFO_KCD_HUP, NULL);
                    break;
                case PINYIN_INPUT_SCREEN:
                case STROKE_INPUT_SCREEN:
                case WORD_ASSOCIATION_SCREEN:
                    memset(&data->wcCandidates, 0x00, sizeof(data->wcCandidates));
                    IMESetDefaultValue(&data->Ime);
                    ChangeDisplayArea(data->input_edt, data->Ime.InputScreenType, data );
                    edtShow(data->input_edt);
                    if( data->editor_data.edtInPbk != 0 )
                    {
                        winShow(data->input_win);
                    }
                    else
                    {
                        /* Draw the other area */
                        DisplayOtherArea( data );
                    }
                    //winShow(data->input_win);
                    break;
                default:
                    break;
                }
            }
            break;
        case KCD_MNUUP:
            {
                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            /* if the editor is phone book input, then control will send to phone book */
                            if( data->editor_data.edtInPbk == 1 )
                            {
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TOPREV_EDT, NULL);
                            }
                            else
                            {
                                edtSymbol( data->input_edt, ecUp );
                                /* Draw the other area */
                                DisplayOtherArea( data );
                            }
                            break;
                        case PINYIN_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECandidatePageUp(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case STROKE_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            /* if the editor is phone book input, then control will send to phone book */
                            if( data->editor_data.edtInPbk == 1 )
                            {
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TOPREV_EDT, NULL);
                            }
                            else
                            {
                                edtSymbol( data->input_edt, ecUp );
                                /* Draw the other area */
                                DisplayOtherArea( data );
                            }
                            break;
                        case STROKE_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECandidatePageUp(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    /* if the editor is phone book input, then control will send to phone book */
                    if( data->editor_data.edtInPbk == 1 )
                    {
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TOPREV_EDT, NULL);
                    }
                    else
                    {
                        edtSymbol( data->input_edt, ecUp );
                        /* Draw the other area */
                        DisplayOtherArea( data );
                    }
                    break;
                default:
                    break;
                }
                //winShow(data->input_win);
            }
            break;
        case KCD_MNUDOWN:
            {
                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            /* if the editor is phone book input, then control will send to phone book */
                            if( data->editor_data.edtInPbk == 1 )
                            {
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TONEXT_EDT, NULL);
                            }
                            else
                            {
                                edtSymbol( data->input_edt, ecDown );
                                /* Draw the other area */
                                DisplayOtherArea( data );
                            }
                            break;
                        case PINYIN_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECandidatePageDown(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case STROKE_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            /* if the editor is phone book input, then control will send to phone book */
                            if( data->editor_data.edtInPbk == 1 )
                            {
                                SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TONEXT_EDT, NULL);
                            }
                            else
                            {
                                edtSymbol( data->input_edt, ecDown );
                                /* Draw the other area */
                                DisplayOtherArea( data );
                            }
                            break;
                        case STROKE_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECandidatePageDown(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    /* if the editor is phone book input, then control will send to phone book */
                    if( data->editor_data.edtInPbk == 1 )
                    {
                        SEND_EVENT (win, E_EDITOR_DEINIT, INFO_TONEXT_EDT, NULL);
                    }
                    else
                    {
                        edtSymbol( data->input_edt, ecDown );
                        /* Draw the other area */
                        DisplayOtherArea( data );
                    }
                    break;
                default:
                    break;
                }
                //winShow(data->input_win);
            }
            break;
        case KCD_MNULEFT:
            {
                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            edtSymbol( data->input_edt, ecLeft );
                            /* Draw the other area */
                            DisplayOtherArea( data );
                            break;
                        case PINYIN_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECursorLeft(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case STROKE_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            edtSymbol( data->input_edt, ecLeft );
                            /* Draw the other area */
                            DisplayOtherArea( data );
                            break;
                        case STROKE_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECursorLeft(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    edtSymbol( data->input_edt, ecLeft );
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    break;
                default:
                    break;
                }
                /*
                if ( data->editor_data.edtInPbk != 0 )
                {
                }
                else
                {
                    //winShow(data->input_win);
                }
                */
            }
            break;
        case KCD_MNURIGHT:
            {
                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            edtSymbol( data->input_edt, ecRight );
                            /* Draw the other area */
                            DisplayOtherArea( data );
                            break;
                        case PINYIN_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECursorRight(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case STROKE_INPUT_MODE:
                    {
                        switch( data->Ime.InputScreenType )
                        {
                        case TEXT_DISPLAY_SCREEN:
                            edtSymbol( data->input_edt, ecRight );
                            /* Draw the other area */
                            DisplayOtherArea( data );
                            break;
                        case STROKE_INPUT_SCREEN:
                        case WORD_ASSOCIATION_SCREEN:
                            IMECursorRight(&data->Ime);
                            data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                            winShow(data->input_win);
                            break;
                        default:
                            break;
                        }
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    edtSymbol( data->input_edt, ecRight );
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    break;
                default:
                    break;
                }
                /*
                if ( data->editor_data.edtInPbk != 0 )
                {
                }
                else
                {
                    //winShow(data->input_win);
                }
                */
            }
            break;
        case KCD_CALL:
            break;
        case KCD_0:
            {
                /* control the textbuffer number */
                if( GetKeyEventConfig(data) )
                {
                    /* 2004/04/01 sunsj add */
                    DisplayOtherArea( data );
                    return MFW_EVENT_CONSUMED;
                }

                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    break;
                case STROKE_INPUT_MODE:
                    /* 2003/12/29 sunsj remove */
                    //data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                    //IMEMore(&data->Ime);
                    //data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                    //winShow(data->input_win);
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    TextInputEventKey(0, keyboard);
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    //winShow(data->input_win);
                    break;
                default:
                    break;
                }
            }
            break;
        case KCD_1:
            {
                /* control the textbuffer number */
                if( GetKeyEventConfig(data) )
                {
                    /* 2004/04/01 sunsj add */
                    DisplayOtherArea( data );
                    return MFW_EVENT_CONSUMED;
                }
                /* add for to select different pinyin code */
                switch( data->Ime.EditorMode )
                {
                /* 2004/03/29 sunsj remove */
                /*
            case PINYIN_INPUT_MODE:
                {
                    int candidate_num;

                    if( data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count == 1 )
                    {
                        return MFW_EVENT_CONSUMED;
                    }

                    if( data->Ime.Element_Select == data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count-1 )
                    {
                        data->Ime.Element_Select = 0;
                    }
                    else
                    {
                        data->Ime.Element_Select++;
                    }
                    candidate_num = Zi_GetElementCandidates(&data->Ime);
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                    winShow(data->input_win);
                }
                break;
                */
                case STROKE_INPUT_MODE:
                    data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                    IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[keyboard->code][1] + ZI8_BASE_STROKES));

                    if( data->Ime.candidates == 0 )
                    {
                        ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
                        edtShow( data->input_edt );
                    }
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                    winShow(data->input_win);
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    TextInputEventKey(0, keyboard);
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    //winShow(data->input_win);
                    break;
                default:
                    break;
                }
            }
            break;
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_9:
            {
                if( GetKeyEventConfig(data) )
                {
                    /* 2004/04/01 sunsj add */
                    DisplayOtherArea( data );
                    return MFW_EVENT_CONSUMED;
                }

                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    {
                        temp_ZiKeyMap = (PZI8WCHAR )ZiPinYinKeyMap[(keyboard->code)-1];
                        data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;
                        Zi_onekey_keypress(&data->Ime, temp_ZiKeyMap);

                        if( data->Ime.candidates == 0 )
                        {
                            ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
                            edtShow( data->input_edt );
                        }
                        data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                        winShow(data->input_win);
                    }
                    break;
                case STROKE_INPUT_MODE:
                    {
                        data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                        IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[keyboard->code][1] + ZI8_BASE_STROKES));

                        if( data->Ime.candidates == 0 )
                        {
                            ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
                            edtShow( data->input_edt );
                        }
                        data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                        winShow(data->input_win);
                    }
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    TextInputEventKey(0, keyboard);
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    //winShow(data->input_win);
                    break;
                default:
                    break;
                }
            }
            break;
        case KCD_8:
            {
                /* control the textbuffer number */
                if( GetKeyEventConfig(data) )
                {
                    /* 2004/04/01 sunsj add */
                    DisplayOtherArea( data );
                    return MFW_EVENT_CONSUMED;
                }

                switch( data->Ime.EditorMode )
                {
                case PINYIN_INPUT_MODE:
                    data->Ime.InputScreenType = PINYIN_INPUT_SCREEN;
                    /* the onekey press pinyin need the all pinyin element when the key press
                       so we need a temp key map to store all pinyin element */
                    temp_ZiKeyMap = (PZI8WCHAR )ZiPinYinKeyMap[(keyboard->code)-1];
                    /* the new key press operate function */
                    Zi_onekey_keypress(&data->Ime, temp_ZiKeyMap);
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];

                    if( data->Ime.candidates == 0 )
                    {
                        ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
                        edtShow( data->input_edt );
                    }

                    winShow(data->input_win);
                    break;
                case STROKE_INPUT_MODE:
                    data->Ime.InputScreenType = STROKE_INPUT_SCREEN;
                    IMEKeyPress(&data->Ime, (ZI8WCHAR) (ZiStrokeKeyMap[keyboard->code][1] + ZI8_BASE_STROKES));

                    if( data->Ime.candidates == 0 )
                    {
                        ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
                        edtShow( data->input_edt );
                    }
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                    winShow(data->input_win);
                    break;
                case UPPERCASE_INPUT_MODE:
                case LOWERCASE_INPUT_MODE:
                case SHUZI_INPUT_MODE:
                    TextInputEventKey(0, keyboard);
                    /* Draw the other area */
                    DisplayOtherArea( data );
                    //winShow(data->input_win);
                    break;
                default:
                    break;
                }
            }
            break;
        case KCD_STAR:
            if( GetKeyEventConfig(data) )
            {
                /* 2004/04/01 sunsj add */
                DisplayOtherArea( data );
                return MFW_EVENT_CONSUMED;
            }

            if( data->Ime.EditorMode == PINYIN_INPUT_MODE )
            {
                if( data->Ime.InputScreenType == PINYIN_INPUT_SCREEN )
                {
                    int candidate_num;

                    if( data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count == 1 )
                    {
                        return MFW_EVENT_CONSUMED;
                    }

                    if( data->Ime.Element_Select == data->Ime.PinyinElementBUF[data->Ime.ElementNumber-1].Count-1 )
                    {
                        data->Ime.Element_Select = 0;
                    }
                    else
                    {
                        data->Ime.Element_Select++;
                    }
                    candidate_num = Zi_GetElementCandidates(&data->Ime);
                    data->HighlightedCandidate[0] = data->wcCandidates[data->Ime.CandidateCursor];
                    winShow(data->input_win);
                }
                else
                {
                    data->symbol_input = keystar_start(data->input_win, keyboard);
                }
            }
            else
            {
                data->symbol_input = keystar_start(data->input_win, keyboard);
            }
            FirstEnterEditor = 3;
            break;
        case KCD_HASH:
            {
                if( data->Ime.EditorMode != MAX_TEXT_INPUT_MODE )
                {
                    data->Ime.EditorMode++;
                }
                else
                {
                    data->Ime.EditorMode = PINYIN_INPUT_MODE;
                }

                IMEChangeMode(&data->Ime, data->Ime.pGetParam);
                /* 2004/05/08 sunsj modify */
                if( (data->editor_data.editor_attr.text[0]=='\0' )&&(data->editor_data.Identifier==SMSSEND_ID_TEXTEDIT) )
                {
                    if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
                    {
                        /* 2004/06/30 sunsj modify for m188b */
#ifdef _M188_
                        data->editor_data.editor_attr.e_size = 73;
#endif
#if(MAIN_LCD_SIZE==4)
						data->editor_data.editor_attr.e_size = 503;
#elif(MAIN_LCD_SIZE==3)
						data->editor_data.editor_attr.e_size = 73;
#endif
                    }
                    else
                    {
                        /* 2004/06/30 sunsj modify for m188b */
#ifdef _M188_
                        data->editor_data.editor_attr.e_size = 163;
#endif
#if(MAIN_LCD_SIZE==4)
						data->editor_data.editor_attr.e_size = 573;
#elif(MAIN_LCD_SIZE==3)
						data->editor_data.editor_attr.e_size = 163;
#endif
                    }
                }
                else
                {
                    if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
                    {
                        if( (((data->editor_data.editor_attr.size - 3)/2)+3) >= 0 )
                        {
                            data->editor_data.editor_attr.e_size = (((data->editor_data.editor_attr.size - 3)/2)+3);
                        }
                        else
                        {
                            data->editor_data.editor_attr.e_size = 0;
                        }
                    }
                    else
                    {
                        data->editor_data.editor_attr.e_size = data->editor_data.editor_attr.size;
                    }
                }
                /*2003/12/24, wangyan modify*/

                ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
                edtShow( data->input_edt );
                /* Draw the other area */
                DisplayOtherArea( data );
                if( data->editor_data.edtInPbk != 0 )
                {
                    winShow(data->input_win);
                }
            }
            break;
        case KCD_F4:
            {
                //if( !HallStatus() )
                //{
                //    returntoidle(1);
                //}
            }
            break;
        default:
            break;
        }
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     text_input_tim_cb

 $Description:  Callback function for the editor info timer.

 $Returns:      None.

 $Arguments:    None.

*******************************************************************************/
static int text_input_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)win)->data;
    T_TEXT_INPUT    * data     = (T_TEXT_INPUT *)win_data->user;

    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->editor_data.Identifier;
    T_EDIT_CB       Callback   = data->editor_data.Callback;

    /* timer elapsed => selfdestroy; sendevent INFO_TIMEOUT */
    text_input_destroy (data->input_win);
    if( Callback )
        (Callback) (parent_win, Identifier, INFO_TIMEOUT);

    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:  text_input_key_tim_cb

 $Description:   executes the timer event from the edit component

 $Returns:    none.

 $Arguments:

*******************************************************************************/
static int text_input_key_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND      win           = mfw_parent (mfw_header());
    T_MFW_WIN      * win_data    = ((T_MFW_HDR *)win)->data;
    T_TEXT_INPUT   * data        = (T_TEXT_INPUT *)win_data->user;
    UBYTE old_mode;

    //if((editor_input_mode != UPPERCASE_MODE) && (editor_input_mode != LOWERCASE_MODE))
    //    return MFW_EVENT_CONSUMED;

    old_mode = dspl_Enable(0);
    if( editor_input_mode == STROKE_INPUT_MODE || editor_input_mode == PINYIN_INPUT_MODE )  // it may cause problem
    {
        dspl_Enable(old_mode);
        return MFW_EVENT_CONSUMED;
    }
    edtSymbol(data->input_edt, ecRight);

    /* 2004/07/06 sunsj add */
    input_key_timer_flag = 0;
    editAlphaLevel = 0; 
    editAlphaKey = KCD_MAX;
    dspl_Enable(old_mode);
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	IMEChangeMode

 $Description:	This function change some of the setting when user selected to use 
                different input method. E.g change from Stroke to Pin-yin input.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
static void IMEChangeMode(pIME_DATA pIME, PZI8GETPARAM pGetParam)
{
    /* 2003/12/15 sunsj check editor mode. if editor mode is large than latin 
       we need to reset editor mode */
    if( pIME->EditorMode > MAX_TEXT_INPUT_MODE+1 )
    {
        pIME->EditorMode = PINYIN_INPUT_MODE;
    }

    /* First initialize the members that will be constant */
    switch( pIME->EditorMode )
    {
    case PINYIN_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_PINYIN;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context          = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case STROKE_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_STROKES;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context          = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_ALLCOMPONENTS;
        //pGetParam->GetOptions		= ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case UPPERCASE_INPUT_MODE:
        break;
    case LOWERCASE_INPUT_MODE:
        break;
    case SHUZI_INPUT_MODE:
        break;
    case LATIN_INPUT_MODE:
        break;
    default:
        break;
    }
    editor_input_mode     = pIME->EditorMode;
    pIME->InputScreenType = TEXT_DISPLAY_SCREEN;
    memset(pGetParam->pElements, 0, sizeof(pGetParam->pElements));
    memset(pIME->pDisplayElementBuffer, 0,sizeof(pIME->pDisplayElementBuffer));
    memset(pIME->pGetParam->pCandidates, 0x00, sizeof(pIME->pGetParam->pCandidates));
    /* save the pointer to the ZI8GETPARAM structure in the IME data */
    pIME->pGetParam             = pGetParam;
    /* now initialize the text buffer and element buffer */
    pIME->moreCount             = 0;
    pGetParam->ElementCount     = 0;
    /* 2004/04/10 sunsj add for empty pinyin element param */
    pIME->ElementNumber     = 0;
    /* initialize the WordCharacterCount to zero */
    pGetParam->WordCharacterCount = 0;
    /* initialize the saved number of candidates to zero */
    pIME->candidates = 0;
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}

/*******************************************************************************

 $Function:    	IMEInitialize

 $Description:	This function initializes the ZI8GETPARAM structure defined in the API 
                and the various members of the IME_DATA structure defined in to keep 
                track of the IME.

 $Returns:		void

 $Arguments:

 $History:

*******************************************************************************/
static void IMEInitialize(pIME_DATA pIME, PZI8GETPARAM pGetParam, PZI8WCHAR wszTextBuffer,
                          int TextBufferEditSize, int TextBufferSize, PZI8WCHAR pCandidates, 
                          PZI8WCHAR wszElementBuffer, PZI8WCHAR DisplayElementBuffer)
{
    int i;

    /* modify for select input mode */
    pIME->EditorMode                = editor_input_mode;

    /* First initialize the members that will be constant */
    switch( pIME->EditorMode )
    {
    case STROKE_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_STROKES;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context          = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_ALLCOMPONENTS;
        break;
    case PINYIN_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_ZH;
        pGetParam->GetMode          = ZI8_GETMODE_PINYIN;
        pGetParam->SubLanguage      = ZI8_SUBLANG_ZH;
        pGetParam->Context          = ZI8_GETCONTEXT_SMS;
        pGetParam->GetOptions       = ZI8_GETOPTION_NOCOMPONENTS;
        break;
    case LATIN_INPUT_MODE:
        pGetParam->Language         = ZI8_LANG_EN;
        pGetParam->GetMode          = ZI8_GETMODE_DEFAULT;
        pGetParam->SubLanguage      = ZI8_SUBLANG_DEFAULT;
        pGetParam->Context          = ZI8_GETCONTEXT_DEFAULT;
        pGetParam->GetOptions       = ZI8_GETOPTION_STRINGS;
        break;
    default:
        break;
    }
    /* save the pointer to the ZI8GETPARAM structure in the IME data */
    pIME->pGetParam             = pGetParam;
    /* now initialize the text buffer and element buffer */
    pIME->pTextBuffer           = wszTextBuffer;
    pIME->TextBufferEditSize    = TextBufferEditSize;
    pIME->TextBufferSize        = TextBufferSize;
    pIME->moreCount             = 0;
    pIME->TextBufferCount       = Uni_strlen(wszTextBuffer);;
    pIME->pDisplayElementBuffer = DisplayElementBuffer;
    pIME->InputScreenType       = TEXT_DISPLAY_SCREEN;
    pGetParam->pElements        = wszElementBuffer;
    pGetParam->ElementCount     = 0;
    /* initialize the WordCharacterCount to zero */
    pGetParam->WordCharacterCount = 0;

    /* initialize the current word buffer */
    pIME->pGetParam->pCurrentWord = pIME->Association_Buffer;

    /*initial pointer to the candidate buffer*/
    pGetParam->pCandidates = pCandidates;
    /* initialize the saved number of candidates to zero */
    pIME->candidates = 0;
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;

    /* initialize the display element buffer */
    for( i=0; i<6; i++ )
    {
        memset( &pIME->PinyinDisplayBuf[i], 0x00, (TEXT_BUFFER_EXTRA_SPACE+1)*2 );
    }

    /* initialize the element cursor to zero */
    pIME->Element_Select  = 0;

    /* initialize the total element number */
    pIME->ElementNumber   = 0;

    /* initialize the word association buffer */
    memset( pIME->Association_Buffer, 0x0000, 10);
}

/*******************************************************************************

 $Function:    	IMECursorLeft

 $Description:	Move the candidate cursor left

 $Returns:		void

 $Arguments:

 $History:
*******************************************************************************/
static void IMECursorLeft(pIME_DATA pIME)
{
    /* sunsj pinyin and stroke use the same method */
    if( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        if( pIME->CandidateCursor != 0 )
        {
            pIME->CandidateCursor--;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
        }
        /* check ElementCount to see whether ElementBuffer is empty and check if where is any more tick in the element buffer. */
        else if( pIME->moreCount != 0 )
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;

            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor the character position*/
            /* 2004/02/11 sunsj fix turn page bug */
            pIME->CandidateCursor = CANDIDATES_PER_GROUP-1;
        }
    }
    else if( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if( pIME->CandidateCursor != 0 )
        {
            pIME->CandidateCursor--;
        }
        else if( pIME->moreCount !=0 )
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;

            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor of the new position */
            pIME->CandidateCursor = (CANDIDATES_PER_GROUP * 2) - 1;
        }
        else if( pIME->moreCount != 0 && pIME->pGetParam->WordCharacterCount != 0 )
        {
            /* If the last input is a more tick, remove it */
            pIME->moreCount--;
            /* get candidates with the new stroke */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            DataConvert(pIME);
            /* initialize the candidate cursor of the new position */
            pIME->CandidateCursor = (CANDIDATES_PER_GROUP * 2) - 1;
        }
    }
}

/*******************************************************************************

 $Function:    	IMECursorRight

 $Description:	Move the candidate cursor right

 $Returns:		void

 $Arguments:	

 $History:
*******************************************************************************/
static void IMECursorRight(pIME_DATA pIME)
{
    /* backup old candidate cursor*/
    int oldcandidatecursor=0;
    oldcandidatecursor = pIME->CandidateCursor;

    /* sunsj pinyin and stroke use the same method */
    if( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        /* If the candidate cursor is greater than the display ability, more tick is add to the element buffer */
        /* to request for next set of characters.												 */
        if( pIME->CandidateCursor >= CANDIDATES_PER_GROUP-1 )
        {
            pIME->moreCount++;

            /* get new candidates */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                /* recover candidate cursor */
                pIME->CandidateCursor = oldcandidatecursor;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
        /* Check number of available candidates before increment of candidate cursor is allowed */
        else if( pIME->candidates > (pIME->CandidateCursor + 1) )
        {
            pIME->CandidateCursor++;
        }
    }
    else if( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if( pIME->CandidateCursor < (CANDIDATES_PER_GROUP * 2)-1 )
        {
            pIME->CandidateCursor++;
        }
        else if( pIME->pGetParam->ElementCount != 0 && pIME->pGetParam->WordCharacterCount == 0 )
        {
            /* increase the candidate's page number */
            pIME->moreCount++;

            /* get the new candidate */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
        else if( pIME->pGetParam->WordCharacterCount != 0 )
        {
            /* increase the candidate's page number */
            pIME->moreCount++;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            pIME->CandidateCursor = 0;

            /* if there is no new candidate so we recover the data */
            if( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;

                pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;

                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
    }
}

/*******************************************************************************

 $Function:    	IMESelectCandidate

 $Description:	Select the candidate at cursor.

 $Returns:		void

 $Arguments:	

 $History:
*******************************************************************************/
static void IMESelectCandidate(pIME_DATA pIME, PZI8WCHAR wszElementBuffer)
{
    int i = 0;
    int j = 0;
    ZI8WCHAR HighByte;
    ZI8WCHAR Temp;
    ZI8WCHAR LowByte;

    /* we can allow selection only if we have candidates*/
    if( pIME->candidates == 0 )
        return;
    /* if we have elements in the test we must now remove them */
    while( pIME->pGetParam->ElementCount > 0 )
    {
        pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;
    }
    memset(pIME->PinyinElementBUF, 0x00, sizeof(pIME->PinyinElementBUF));

    /* the more count must be set to zero */
    pIME->moreCount = 0;

    /* clear element number  */
    pIME->ElementNumber = 0;
    pIME->pGetParam->ElementCount = pIME->ElementNumber;

    /* 2003/12/15 sunsj set component flag */
    ComponentFlag = FALSE;

    /* check the limit of the text buffer. Stop user to enter character when text buffer is full */
    if( pIME->TextBufferCount >= TEXT_BUFFER_EDIT_SIZE )
    {
        //messages can be added to inform user when text buffer is full.
        return;
    }

    /* check if the selected candidate is a component. To do that the storage format has to be change. */
    /* Followin bit shifting procedure is used the preform the task.						 */
    LowByte = pIME->pGetParam->pCandidates[pIME->CandidateCursor] & 0x00FF;
    HighByte = pIME->pGetParam->pCandidates[pIME->CandidateCursor] & 0xFF00;
    Temp = (LowByte << 8) & 0xFF00;
    HighByte = (HighByte >> 8) & 0x00FF;
    Temp = Temp | HighByte;

    if( Temp > ZI8_BASE_COMPONENTS && Temp < ZI8_BASE_BPMF ) /* check if the selected candidate is a component */
    {
        memset(pIME->pDisplayElementBuffer, 0, sizeof(pIME->pDisplayElementBuffer));
        pIME->pDisplayElementBuffer[0] = pIME->pGetParam->pCandidates[pIME->CandidateCursor];

        pIME->pGetParam->pElements[0] = Temp;
        pIME->pGetParam->ElementCount = 1;
        pIME->moreCount = 0;
        pIME->CandidateCursor = 0;

        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        /* 2003/12/15 sunsj set component flag because the candidate is component */
        ComponentFlag = TRUE;
    }
    else    /* The selected character is character not a component */
    {
        /* 2003/12/04 sunsj modify */
        /*
        if ( pIME->TextCursor < pIME->TextBufferCount ) //locate the text cursor position for correct character insertion
        {
            for ( i=pIME->TextCursor; i<pIME->TextBufferCount; i++ ) //shift and move characters to make rooms to insert the selected character
            {
                pIME->pTextBuffer[pIME->TextBufferCount - j]=pIME->pTextBuffer[pIME->TextBufferCount - j - 1];
                j++;
            }
        }
        */
        /* 2003/12/15 sunsj set component for get candidate */
        ComponentFlag = FALSE;

        /* 2003/12/04 sunsj display screen through edt */
        /* now added this character to the text */
        //pIME->pTextBuffer[pIME->TextCursor++] = pIME->pGetParam->pCandidates[pIME->CandidateCursor];
        pIME->TextCursor++;

        /* Change input screen type */
        pIME->InputScreenType = WORD_ASSOCIATION_SCREEN;

        /* Adjust the word association. If the candidate we selected was a word candidate,	*/
        /* then we continue the word association. Otherwise this character begins a new word        */      
        if( pIME->pGetParam->wordCandidates > pIME->CandidateCursor )
        {
            pIME->pGetParam->WordCharacterCount++;

            UnicodeConver(pIME->Association_Buffer,pIME->Association_Buffer);
            pIME->Association_Buffer[pIME->pGetParam->WordCharacterCount-1] = pIME->pGetParam->pCandidates[pIME->CandidateCursor];
            UnicodeConver(pIME->Association_Buffer,pIME->Association_Buffer);
        }
        else    /* the new word association */
        {
            memset(pIME->Association_Buffer, 0x00, sizeof(unsigned short)*10);
            pIME->pGetParam->WordCharacterCount = 1;

            pIME->Association_Buffer[pIME->pGetParam->WordCharacterCount-1] = pIME->pGetParam->pCandidates[pIME->CandidateCursor];
            /* update word association element buffer */
            UnicodeConver(pIME->Association_Buffer,pIME->Association_Buffer);
        }
        /* get two group of candidate */
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP * 2;

        /* get two group of candidate */
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP*2;

        //increase TextBufferCount by one
        pIME->TextBufferCount++;
        memset(pIME->pDisplayElementBuffer, 0, sizeof(pIME->pDisplayElementBuffer));
    }
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
    DataConvert(pIME);
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}

/*******************************************************************************

 $Function:    	IMEMore

 $Description:	Get the next group of candidates. For this function, we add the more tick 
                to the element buffer and increase the more count. Then we get the 
                next group of candidates.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
static void IMEMore(pIME_DATA pIME)
{   
    pIME->moreCount++;

    /* get new candidates */
    pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
    pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
    DataConvert(pIME);
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}

/*******************************************************************************

 $Function:    	IMEKeyPress

 $Description:	Enter the stroke and get new candidates. However, any more ticks from 
                the element buffer must be removed before any stroke is to be added.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
static void IMEKeyPress(pIME_DATA pIME, ZI8WCHAR wcStroke)
{   
    /* remove any trailing more ticks and set the more count back to zero */
    while( (pIME->pGetParam->ElementCount > 0) && pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
    {
        pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;
    }
    pIME->moreCount = 0;

    /* Check the limit of the element buffer. Stop user to enter stroke or Pin Yin letter */
    /* when element budder is full 												 */
    if( pIME->pGetParam->ElementCount >= TEXT_BUFFER_EXTRA_SPACE )
    {
        return;
    }
    /* Insert the stroke or the Pin Yin letter into the element buffer for character search */
    pIME->pGetParam->pElements[pIME->pGetParam->ElementCount++] = wcStroke;

    /* get candidates with the new stroke */
    pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
    pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

    if( pIME->candidates > 0 )
    {
        /* Convert the data storage format for display purpose */
        DataConvert(pIME);
        /* initialize the candidate cursor to zero */
        pIME->CandidateCursor = 0;
    }
    else
    {
        //remove this keypress
        IMEClear(pIME, pIME->pGetParam->pElements);
    }
}


/*******************************************************************************

 $Function:    	IMEClear

 $Description:	Clear the last stroke entered. This function first handle the case where 
                the last element is a more tick. If there are no elements, it removes 
                the last text element.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
static void IMEClear(pIME_DATA pIME, PZI8WCHAR wszElementBuffer)
{
    int i = 0;

    /* handle the condition where the last element is a more tick */
    if( pIME->pGetParam->ElementCount != 0 ) //check ElementCount to see whether ElementBuffer is empty
    {
        /* If the last input is a more tick, remove it */
        if( pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1] == ZI8_CODE_MORE )
        {
            pIME->moreCount--;

            /* replace last element with zero */
            pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;
        }
        else
        {
            pIME->pGetParam->pElements[--pIME->pGetParam->ElementCount] = 0;    
            pIME->pDisplayElementBuffer[pIME->pGetParam->ElementCount] = 0;
        }

        /* When ElementCount is zero and InputScreenType is STROKE_INPUT_SCREEN or PINYIN_INPUT_SCREEN, 	 */
        /* InputScreenType will be set to WORD_ASSOCIATION_SCREEN to get the associated character. If no associated */
        /* characters can be found, the most common used character in chinese writing will be provided.	 */
        if( (pIME->pGetParam->ElementCount == 0 && pIME->InputScreenType == STROKE_INPUT_SCREEN) || 
            (pIME->pGetParam->ElementCount == 0 && pIME->InputScreenType == PINYIN_INPUT_SCREEN) )
        {
            /* 2003/12/15 sunsj modify */
            //pIME->InputScreenType = WORD_ASSOCIATION_SCREEN;
            pIME->InputScreenType = TEXT_DISPLAY_SCREEN;
        }
    }
    else
    {
        /* remove the last character from text buffer */
        /* first update count for word association */
        if( pIME->pGetParam->WordCharacterCount > 0 )
            pIME->pGetParam->WordCharacterCount--;

        /* remove the character at cursor position */
        if( pIME->TextCursor != 0 )
        {
            /* replace last character with zero */
            if( pIME->TextBufferCount==pIME->TextCursor )
            {
                pIME->pTextBuffer[--pIME->TextCursor] = 0;
                pIME->TextBufferCount--;
            }
            else if( pIME->TextBufferCount > pIME->TextCursor )
            {
                for( i=pIME->TextCursor; i<pIME->TextBufferCount; i++ )
                {
                    pIME->pTextBuffer[i-1]=pIME->pTextBuffer[i];
                }
                pIME->pTextBuffer[pIME->TextBufferCount-1]=0;
                pIME->TextCursor--;
                pIME->TextBufferCount--;
            }
        }
        /* update location of elements */
        pIME->pGetParam->pElements = wszElementBuffer;
    }
    /* get candidates */
    pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
    pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
    /* 2004/05/14 sunsj modify */
    if( pIME->pGetParam->ElementCount != 0 )
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
    /* Convert the data storage format for display purpose */
    DataConvert(pIME);
    /* initialize the candidate cursor to zero */
    pIME->CandidateCursor = 0;
}

/*******************************************************************************

 $Function:    	CandidateHighlightDisplayContorl

 $Description:	With given candidate cursor position, and character stored in the HighlightedCandidate,
                this function will invert the colour of the candidate to indicate user the current selected
                character.

 $Returns:		void

 $Arguments:	

 $History:		2004/04/06 sunsj modify 
                2004/05/26 sunsj modify

*******************************************************************************/
static void CandidateHighlightDisplayContorl(pIME_DATA pIME, PZI8WCHAR HighlightedCandidate)
{
    int candidatewidth;

    candidatewidth = get_font_width();

    /* highlight candidate display */
    if( pIME->InputScreenType == PINYIN_INPUT_SCREEN )
    {
        dspl_TextOut((USHORT)(LEFT_INDENTATION + ((candidatewidth*2)*pIME->CandidateCursor)),CANDIDATES_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    }
    /* stoke input mode */
    else if( pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        dspl_TextOut((USHORT)(LEFT_INDENTATION + ((candidatewidth*2)*pIME->CandidateCursor)),CANDIDATES_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
    }
    else if( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        if( pIME->CandidateCursor < CANDIDATES_PER_GROUP )
        {
            dspl_TextOut((USHORT)(LEFT_INDENTATION + ((candidatewidth*2)*pIME->CandidateCursor)),ELEMENT_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
        }
        else
        {
            dspl_TextOut((USHORT)(LEFT_INDENTATION + ((candidatewidth*2)*( pIME->CandidateCursor - CANDIDATES_PER_GROUP ))),CANDIDATES_LINE,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)HighlightedCandidate);
        }
    }
}

/*******************************************************************************

 $Function:    	TextCursorDisplayContorl

 $Description:	To display the cursor position to user during text editing.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
static void TextCursorDisplayContorl(pIME_DATA pIME, PZI8WCHAR CursorPosition, int InsertLine)
{
    USHORT TempTextCursor  = 0;
    USHORT x_position = 1;
    int i;
    int line;//position of char at start of line

    TempTextCursor = pIME->TextCursor % CANDIDATES_PER_GROUP;
    line = pIME->TextCursor - TempTextCursor;
    for( i=0; i < TempTextCursor; i++ )
    {
        //if last byte of word is 0x00, and first byte is between 0x20 and 0x7E
        if( LatinChar(pIME->pTextBuffer[line+i]) )
            x_position +=6;
        else
            x_position+=12;
    }
    switch( pIME->InputScreenType )
    {
    case TEXT_DISPLAY_SCREEN:

        if( InsertLine == 1 )
        {
            dspl_TextOut(x_position,Mmi_layout_first_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
        }
        else
        {
            dspl_TextOut(x_position,Mmi_layout_second_line(),DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);
        }
        break;
    case STROKE_INPUT_SCREEN:
    case WORD_ASSOCIATION_SCREEN:
        dspl_TextOut(x_position,0,DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS,(char*)CursorPosition);

    default:
        break;
    }   
}

/*******************************************************************************

 $Function:    	DataConvert

 $Description:	To change to data storage format i.e if a unicode is 0x89D5.
                The DataConvert function will change storage format to 0xD589 (This format 
                is required to display UniCode on LCD). The data format is changed by 
                byte shifting.

 $Returns:		void

 $Arguments:	

*******************************************************************************/
static void DataConvert(pIME_DATA pIME)
{
    ZI8WCHAR HighByte;
    ZI8WCHAR Temp;
    ZI8WCHAR LowByte;
    ZI8WCHAR tempString[25];
    int word_length;
    int i       = 0;
    int count   = 0;
    char debug[20];
    //TRACE_EVENT("DataConvert");


    if( (pIME->InputScreenType == STROKE_INPUT_SCREEN) ||
        (pIME->InputScreenType == PINYIN_INPUT_SCREEN) )
    {
        count = pIME->pGetParam->ElementCount;
        /* The more tick is not to be displayed on LCD therefore it is not considered. */
        while( (count > 0) && pIME->pGetParam->pElements[count - 1] == ZI8_CODE_MORE )
        {
            count--;
        }

        /* Format of the data stored in the array pointed by pElement is coverted and  */
        /* saved in the array pointed by pDisplayElementBuffer. Please note that the    */
        /* the data format stored in the array pointed by pElement was unchanged. This */
        /* is kept that way for eZiText character search.*/
        if( pIME->InputScreenType == STROKE_INPUT_SCREEN )
        {
            for( i = 0; i < count; i++ )
            {
                Temp = pIME->pGetParam->pElements[i];
                LowByte = pIME->pGetParam->pElements[i] & 0x00FF;
                HighByte = pIME->pGetParam->pElements[i] & 0xFF00;
                Temp = (LowByte << 8) & 0xFF00;
                HighByte = (HighByte >> 8) & 0x00FF;
                Temp = Temp | HighByte;
                pIME->pDisplayElementBuffer[i] = Temp;
            }   
            pIME->pDisplayElementBuffer[count] = 0x0000; //terminate string
        }

        if( pIME->InputScreenType == PINYIN_INPUT_SCREEN )
        {
            int no_of_display_chars;
            //word_length = Zi8GetCharInfo2(pIME->pGetParam->pCandidates[pIME->CandidateCursor], tempString, 12, ZI8_GETMODE_PINYIN, pIME->pGetParam->pElements, (ZI8UCHAR)count );
            word_length = Zi8GetCharInfo(pIME->pGetParam->pCandidates[pIME->CandidateCursor], tempString, 12, ZI8_GETMODE_PINYIN);
            //TRACE_EVENT((char*)tempString);
            sprintf(debug, "chars returned: %d", word_length);
            //TRACE_EVENT(debug);

            if( word_length > 0 )
            {
                if( word_length < count )
                    no_of_display_chars = word_length;
                else
                    no_of_display_chars = count;

                for( i = 0; i < no_of_display_chars; i++ )
                {
                    Temp = tempString[i];
                    LowByte = tempString[i] & 0x00FF;
                    HighByte = tempString[i] & 0xFF00;
                    Temp = (LowByte << 8) & 0xFF00;
                    HighByte = (HighByte >> 8) & 0x00FF;
                    Temp = Temp |HighByte;
                    pIME->pDisplayElementBuffer[i] = Temp;
                }
                pIME->pDisplayElementBuffer[no_of_display_chars] = 0x0000;//terminate string
            }
        }
    }

    //if (pIME->CandidateCursor == 0)
    /* format of the data stored in the array pointed by pCandidates is coverted for display */
    for( i = 0; i < pIME->pGetParam->count; i++ )
    {
        Temp = pIME->pGetParam->pCandidates[i];
        LowByte = pIME->pGetParam->pCandidates[i] & 0x00FF;
        HighByte = pIME->pGetParam->pCandidates[i] & 0xFF00;
        Temp = (LowByte << 8) & 0xFF00;
        HighByte = (HighByte >> 8) & 0x00FF;
        Temp = Temp | HighByte;
        pIME->pGetParam->pCandidates[i] = Temp;
    }
    pIME->pGetParam->pCandidates[pIME->candidates] = 0x0000;//terminate string
}

/*******************************************************************************

 $Function:    	Uni_strlen

 $Description:	To count the number of element from the input array

 $Returns:		number of element

 $Arguments:	

*******************************************************************************/
static ZI8WCHAR Uni_strlen(PZI8WCHAR String)
{
    int i = 0;
    ZI8WCHAR count = 0;

    while( String[i] != 0 )
    {
        i++;
        count++;
    }
    return count;
}

/****************************************************************************************
 $Function:    	Zi_onekey_keypress

 $Description:	onekey pinyin input

 $Returns: void
 
 $Author Name:  Sunsj

 $Date:

 $History:
****************************************************************************************/
static void Zi_onekey_keypress(pIME_DATA pIME , PZI8WCHAR key_map)
{
    int i=0,j=0;
    int l=0,k=0;
    BOOL Element_Is_True=FALSE;
    BOOL valid_element=TRUE;
    BOOL if_valid_element=TRUE;
    int Loop;
    BOOL Element_Is_Pinyin = FALSE;
    /* the max pinyin number is 6 so the buf need 7 */
    char temp_pinyin[7];
    /* 2003/12/15 sunsj */
    int element_select_bak = 0;

    /* check the element count. If the element count large than six then return */
    if( pIME->pGetParam->ElementCount > 6 )
        return;

    pIME->pGetParam->wordCandidates = 0;
    pIME->pGetParam->WordCharacterCount = 0;

    /* Note: add code here to check if we are end of buffer */
    pIME->moreCount = 0;
    /* 2003/12/15 sunsj backup the element which select */
    element_select_bak = pIME->Element_Select;
    pIME->Element_Select = 0;

    /* 2003/01/02 sunsj modify for get mode */
    //pIME->pGetParam->GetMode = ZI8_GETMODE_PINYIN;
    //pIME->pGetParam->GetOptions = ZI8_GETOPTION_DEFAULT;

    pIME->ElementNumber++;
    pIME->pGetParam->ElementCount = pIME->ElementNumber;

    if( pIME->pGetParam->ElementCount>1 )
    {
        if( pIME->pGetParam->GetMode == ZI8_GETMODE_PINYIN )
        {
            k = 0;
            for( i=0;i < pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-2].Count;i++ )
            {
                memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-2].PinyinEleBUF[i], (pIME->pGetParam->ElementCount-1)*sizeof(ZI8WCHAR));

                for( l=0;l<key_map[5];l++ )
                {
                    pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-1]=key_map[l];

                    if( key_map[l]==ZI8_CODE_PINYIN_N && (pIME->pGetParam->ElementCount<=3) &&
                        pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_O )
                    {
                        if( pIME->pGetParam->ElementCount==2 )
                        {
                            valid_element=FALSE;
                        }
                        else if( pIME->pGetParam->ElementCount==3 )
                        {
                            switch( pIME->pGetParam->pElements[0] )
                            {
                            case ZI8_CODE_PINYIN_B:
                            case ZI8_CODE_PINYIN_M:
                            case ZI8_CODE_PINYIN_P:
                            case ZI8_CODE_PINYIN_F:
                            case ZI8_CODE_PINYIN_W:
                                valid_element=FALSE;
                                break;
                            }
                        }
                    }
                    else if( (key_map[l]==ZI8_CODE_PINYIN_O)&&(pIME->pGetParam->ElementCount==3) &&
                             (pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_I) )
                    {
                        switch( pIME->pGetParam->pElements[0] )
                        {
                        case ZI8_CODE_PINYIN_B:
                        case ZI8_CODE_PINYIN_M:
                        case ZI8_CODE_PINYIN_P:
                        case ZI8_CODE_PINYIN_C:
                        case ZI8_CODE_PINYIN_D:
                        case ZI8_CODE_PINYIN_L:
                        case ZI8_CODE_PINYIN_N:
                        case ZI8_CODE_PINYIN_R:
                        case ZI8_CODE_PINYIN_S:
                        case ZI8_CODE_PINYIN_Y:
                        case ZI8_CODE_PINYIN_T:
                        case ZI8_CODE_PINYIN_Z:
                            valid_element=FALSE;
                            break;
                        }
                    }
                    else if( (pIME->pGetParam->ElementCount==4)&&(key_map[l]==ZI8_CODE_PINYIN_O) &&  //liu for pinyin
                             (pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_I) )
                    {
                        if( pIME->pGetParam->pElements[1]==ZI8_CODE_PINYIN_H )
                        {
                            switch( pIME->pGetParam->pElements[0] )
                            {
                            case ZI8_CODE_PINYIN_Z:
                            case ZI8_CODE_PINYIN_C:
                            case ZI8_CODE_PINYIN_S:
                                valid_element=FALSE;
                                break;
                            }
                        }
                    }
                    else if( (key_map[l]==ZI8_CODE_PINYIN_A)&&(pIME->pGetParam->ElementCount==3) &&
                             (pIME->pGetParam->pElements[pIME->pGetParam->ElementCount-2]==ZI8_CODE_PINYIN_V) )
                    {
                        switch( pIME->pGetParam->pElements[0] )
                        {
                        case ZI8_CODE_PINYIN_L:
                        case ZI8_CODE_PINYIN_N:
                            valid_element=FALSE;
                            break;
                        }
                    }

                    /* if valid_element is false so we need not check the element */
                    if( valid_element == TRUE )
                    {
                        /* check pinyin code */
                        for( j=0; j<7; j++ )
                        {
                            temp_pinyin[j] = (UCHAR)pIME->pGetParam->pElements[j] & 0x00ff;
                        }

                        Element_Is_Pinyin = FALSE;
                        for( Loop=0;Loop<MaxPinYin;Loop++ )
                        {
                            if( strncmp(PinyinTable[Loop],&temp_pinyin[0],strlen(&temp_pinyin[0])) == 0 )
                            {
                                Element_Is_Pinyin = TRUE;
                                /* if the element is pinyin code then break the search */
                                break;
                            }
                        }
                    }

                    if( (Element_Is_Pinyin == TRUE) && valid_element )
                    {
                        pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].Count++;
                        memcpy(pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[k], pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-2].PinyinEleBUF[i], (pIME->pGetParam->ElementCount-1)*sizeof(ZI8WCHAR));
                        pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[k][pIME->pGetParam->ElementCount-1]=key_map[l];
                        Element_Is_True=TRUE;
                        k++;
                    }
                    valid_element=TRUE;
                }
            }
        }
    }
    else
    {
        memset(pIME->PinyinElementBUF, 0, sizeof(pIME->PinyinElementBUF));

        for( i=0;i<key_map[5];i++ )
        {
            pIME->pGetParam->pElements[0]=key_map[i];
            for( j=0; j<7; j++ )
            {
                temp_pinyin[j] = (UCHAR)pIME->pGetParam->pElements[j] & 0x00ff;
            }

            /* check pinyin code */
            Element_Is_Pinyin = FALSE;
            for( Loop=0;Loop<MaxPinYin;Loop++ )
            {
                if( strncmp(PinyinTable[Loop],temp_pinyin,strlen(temp_pinyin)) == 0 )
                {
                    Element_Is_Pinyin = TRUE;
                    /* if the element is pinyin code break the search */
                    break;
                }
            }

            if( Element_Is_Pinyin == TRUE )
            {
                U8 Temp_element_num=0;
                pIME->PinyinElementBUF[0].Count++;
                Temp_element_num = pIME->PinyinElementBUF[0].Count;
                pIME->PinyinElementBUF[0].PinyinEleBUF[Temp_element_num-1][0]=key_map[i];
                Element_Is_True=TRUE;
            }
        }
    }

    if( Element_Is_True == TRUE )
    {
        memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[0], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
        pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        /* we need convert data after Zi8GetCandidates */
        if( pIME->candidates > 0 )
        {
            /* Convert the data storage format for display purpose */
            DataConvert(pIME);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;
        }
    }
    else
    {
        pIME->ElementNumber--;
        pIME->pGetParam->ElementCount = pIME->ElementNumber;
        memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[0], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
        pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        /* because the candidate buffer has not been changed so need not 
           get candidate again */
        if_valid_element=FALSE;
        /* 2003/12/15 sunsj resume the element select value */
        pIME->Element_Select = element_select_bak;
    }
}

/****************************************************************************************
 $Function:    	Zi_GetElementCandidates

 $Description:	onekey pinyin input get candidates

 $Returns: void
 
 $Author Name:  Sunsj

 $Date:

****************************************************************************************/
static int Zi_GetElementCandidates(pIME_DATA pIME)
{
    /* backup old page number */
    int old_morecount = pIME->moreCount;

    /* judge element number if there is element, we can operate the candidate */
    if( pIME->ElementNumber > 0 )
    {
        pIME->pGetParam->ElementCount = pIME->ElementNumber;
        pIME->moreCount = 0;
        if( pIME->PinyinElementBUF[pIME->ElementNumber-1].Count > 1 )
        {
            memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[pIME->Element_Select % pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].Count], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
        }
        else
        {
            pIME->moreCount = old_morecount;
        }

        if( pIME->candidates > 0 )
        {
            /* Convert the data storage format for display purpose */
            DataConvert(pIME);
            /* initialize the candidate cursor to zero */
            pIME->CandidateCursor = 0;
        }

        return(pIME->candidates);
    }
    else
        return 0;
}

/****************************************************************************************
 $Function:    	UnicodeConver

 $Description:	convert element buffer to display element buffer

 $Returns: void
 
 $Author Name:  Sunsj

 $Date:

****************************************************************************************/
static void UnicodeConver(USHORT* inputString, USHORT* outputString)
{
    USHORT HighByte;
    USHORT Temp;
    USHORT LowByte;
    int i       = 0;

    if( inputString[0] == 0x00 )
    {
        return;
    }

    while( inputString[i] )
    {
        Temp = inputString[i];
        LowByte = Temp & 0x00FF;
        HighByte = Temp & 0xFF00;
        Temp = (LowByte << 8) & 0xFF00;
        HighByte = (HighByte >> 8) & 0x00FF;
        Temp = Temp | HighByte;
        outputString[i] = Temp;
        i++;
    }
}

/****************************************************************************************
 $Function:    	Zi_onekey_clear

 $Description:	onekey pinyin input clear function

 $Returns: void

 $Author Name:  Sunsj

 $Date:
 
****************************************************************************************/
static void Zi_onekey_clear(pIME_DATA pIME)
{
    int i=0;

    /* Note: add code here to check if we are end of buffer */
    if( pIME->ElementNumber != 0 )
    {
        pIME->moreCount = 0;
        pIME->Element_Select = 0;

        pIME->ElementNumber--;
        pIME->pGetParam->ElementCount = pIME->ElementNumber;

        for( i=0; i < pIME->PinyinElementBUF[pIME->pGetParam->ElementCount].Count; i++ )
        {
            memset( pIME->PinyinElementBUF[pIME->pGetParam->ElementCount].PinyinEleBUF[i],0x0,6*sizeof(ZI8WCHAR) );
        }
        pIME->PinyinElementBUF[pIME->pGetParam->ElementCount].Count=0;

        if( pIME->pGetParam->ElementCount != 0 )
        {
            /* now we need to get candidates with the new stroke */
            memcpy(pIME->pGetParam->pElements, pIME->PinyinElementBUF[pIME->pGetParam->ElementCount-1].PinyinEleBUF[0], pIME->pGetParam->ElementCount*sizeof(ZI8WCHAR));
            pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        }
        else
        {
            /* if there is no element, then current input screen is text display screen.
               and reset some parameter */
            pIME->pGetParam->pElements[pIME->pGetParam->ElementCount] = 0x00;
            pIME->candidates    = 0;
            pIME->pGetParam->pCandidates[pIME->candidates] = 0x0000;
            pIME->pDisplayElementBuffer[pIME->pGetParam->ElementCount] = 0x0000;
            pIME->InputScreenType = TEXT_DISPLAY_SCREEN;
            DataConvert(pIME);
            return;
        }

        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        DataConvert(pIME);
        /* initialize the candidate cursor to zero */
        pIME->CandidateCursor = 0;
    }
    else
    {
        if( pIME->pGetParam->WordCharacterCount > 0 )
            pIME->pGetParam->WordCharacterCount--;

        /* remove the character at cursor position */
        if( pIME->TextCursor != 0 )
        {
            /* replace last character with zero */
            if( pIME->TextBufferCount==pIME->TextCursor )
            {
                pIME->pTextBuffer[--pIME->TextCursor] = 0;
                pIME->TextBufferCount--;
            }
            else if( pIME->TextBufferCount > pIME->TextCursor )
            {
                for( i=pIME->TextCursor; i<pIME->TextBufferCount; i++ )
                {
                    pIME->pTextBuffer[i-1]=pIME->pTextBuffer[i];
                }
                pIME->pTextBuffer[pIME->TextBufferCount-1]=0;
                pIME->TextCursor--;
                pIME->TextBufferCount--;
            }
        }
    }
}

/****************************************************************************************
 $Function:    	IMECandidatePageUp

 $Description:	onekey pinyin input candidates pageup

 $Returns: void
 
 $Author Name:  Sunsj

 $Date:

 $History:
****************************************************************************************/
static void IMECandidatePageUp(pIME_DATA pIME)
{
    /* pinyin and stroke use the same method */
    if( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        if( pIME->moreCount != 0 )
        {
            pIME->moreCount--;  
        }

        /* now we need to get candidates */
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        DataConvert(pIME);
    }
    else if( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        /* if the cursor of candidate is in the first line, I'll get new candidate */
        if( pIME->CandidateCursor < CANDIDATES_PER_GROUP )
        {
            if( pIME->moreCount != 0 )
            {
                pIME->moreCount--;

                /* set the new candidate cursor */
                pIME->CandidateCursor += CANDIDATES_PER_GROUP;

                /* now we get the new candidate */
                pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

                DataConvert(pIME);
            }
        }
        else
        {
            /* if the cursor of candidate is in the second line, decrease the cursor value */
            pIME->CandidateCursor -= CANDIDATES_PER_GROUP;
        }
    }
}

/****************************************************************************************
 $Function:    	IMECandidatePageDown

 $Description:	onekey pinyin candidate pagedown

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:

 $History:
****************************************************************************************/
static void IMECandidatePageDown(pIME_DATA pIME)
{
    /* pinyin and stroke use the same method */
    if( pIME->InputScreenType == PINYIN_INPUT_SCREEN || pIME->InputScreenType == STROKE_INPUT_SCREEN )
    {
        pIME->moreCount++;

        /* now we need to get new candidates */
        pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
        pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
        pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

        /* if there is no new candidate, recover the candidate */
        if( pIME->pGetParam->count == 0 )
        {
            pIME->moreCount--;
            pIME->pGetParam->FirstCandidate = pIME->moreCount * CANDIDATES_PER_GROUP;
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
        }

        /* if the number of new candidate is less than cursor of candidate, then I reset the candidate cursor */
        if( pIME->CandidateCursor >= pIME->candidates )
        {
            pIME->CandidateCursor = 0;
        }
        DataConvert(pIME);
    }
    else if( pIME->InputScreenType == WORD_ASSOCIATION_SCREEN )
    {
        /* if the cursor of candidate is in the first line, increase the cursor value */
        if( pIME->CandidateCursor < CANDIDATES_PER_GROUP )
        {
            pIME->CandidateCursor += CANDIDATES_PER_GROUP;
        }
        else
        {
            /* if the cursor of candidate is in the second line, I'll get the new candidate */
            pIME->moreCount++;
            pIME->CandidateCursor -= CANDIDATES_PER_GROUP;

            /* now we get the new candidate */
            pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
            pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP * 2;
            pIME->candidates = Zi8GetCandidates(pIME->pGetParam);

            /* if there is no new candidate then recover candidate buffer */
            if( pIME->pGetParam->count == 0 )
            {
                pIME->moreCount--;
                pIME->pGetParam->FirstCandidate = pIME->moreCount * (CANDIDATES_PER_GROUP * 2);
                pIME->pGetParam->MaxCandidates = CANDIDATES_PER_GROUP;
                pIME->candidates = Zi8GetCandidates(pIME->pGetParam);
            }
            DataConvert(pIME);
        }
    }
}

/* 2004/03/29 sunsj modify */
#define PINYIN_START_X		12
/****************************************************************************************
 $Function:    	DisplayPinyinElement

 $Description:	display pinyin element

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:     2004/04/02 sunsj modify

****************************************************************************************/
static void DisplayPinyinElement(pIME_DATA pIME)
{
    int i = 0;
    int pinyinlength[6];
    int totalpinyinlength = 0;
    int element_curX = PINYIN_START_X;        /* 2003/12/15 sunsj set start x */
    int PinyinPageNum = 0;
    char pinyin_temp[6][(TEXT_BUFFER_EXTRA_SPACE+1)*2+1];
    char star_char[2] = {0x2A, 0x00};
    int elementNum[6] = {0, 0, 0, 0, 0, 0};     /* 2004/04/02 sunsj add */
    int currentPage = 0;

    /* initialize the display buffer */
    for( i=0; i<6; i++ )
    {
        memset( pinyin_temp[i], 0x00, ((TEXT_BUFFER_EXTRA_SPACE+1)*2+1) );
        memset( &pIME->PinyinDisplayBuf[i], 0x00, (TEXT_BUFFER_EXTRA_SPACE+1)*2 );
    }

    for( i=0; i<pIME->PinyinElementBUF[pIME->ElementNumber-1].Count; i++ )
    {
        pinyin_temp[i][0] = (char)0x80;
        UnicodeConver((USHORT*)pIME->PinyinElementBUF[pIME->ElementNumber-1].PinyinEleBUF[i],(USHORT*)pIME->PinyinDisplayBuf[i]);
        memcpy( &pinyin_temp[i][1], &pIME->PinyinDisplayBuf[i], (TEXT_BUFFER_EXTRA_SPACE+1)*2 );
        /* 2003/12/15 sunsj get each pinyin length */
        pinyinlength[i] = get_StringWidth(pinyin_temp[i]);
    }

    /* count the total pinyin width */
    /*
    for( i=0; i<pIME->PinyinElementBUF[pIME->ElementNumber-1].Count; i++ )
    {
        /* 2003/12/15 sunsj remove 
        //pinyinlength[i] = get_StringWidth(pinyin_temp[i]);
        totalpinyinlength += pinyinlength[i];
        /* 2004/03/26 sunsj modify for element line width 
        if( totalpinyinlength >= SCREEN_SIZE_X - PINYIN_START_X )
        {
            nextPagePinyin = i;
            break;
        }
        totalpinyinlength += 2;
    }
    */
    for( i=0; i<pIME->PinyinElementBUF[pIME->ElementNumber-1].Count; i++ )
    {
        totalpinyinlength += pinyinlength[i];

        if( totalpinyinlength >= SCREEN_SIZE_X - PINYIN_START_X )
        {
            PinyinPageNum++;
            elementNum[PinyinPageNum] = i;
            totalpinyinlength = pinyinlength[i];
        }
        else
        {
            totalpinyinlength += 2;
        }

        if( i == pIME->Element_Select )
        {
            currentPage = PinyinPageNum;
        }
    }

    /* if the width is large than Lcd size we need cut the text into one line 
       and we need to display the pinyin element through select element */
    if( PinyinPageNum > 0 )
    {
        dspl_TextOut(2, ELEMENT_LINE, DSPL_TXTATTR_TRANSPARENT, star_char);
        if( currentPage < PinyinPageNum )
        {
            for( i=elementNum[currentPage]; i<elementNum[currentPage+1]; i++ )
            {
                dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)pIME->PinyinDisplayBuf[i]);
                if( i == pIME->Element_Select )
                {
                    dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS, (char*)pIME->PinyinDisplayBuf[i]);
                }
                element_curX += (pinyinlength[i]+2);
            }
        }
        else
        {
            for( i = elementNum[currentPage]; i < pIME->PinyinElementBUF[pIME->ElementNumber-1].Count; i++ )
            {
                dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)pIME->PinyinDisplayBuf[i]);
                if( i == pIME->Element_Select )
                {
                    dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS, (char*)pIME->PinyinDisplayBuf[i]);
                }
                element_curX += (pinyinlength[i]+2);
            }
        }
        /*
        else
        {
            for( i=nextPagePinyin; i<pIME->PinyinElementBUF[pIME->ElementNumber-1].Count; i++ )
            {
                dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)pIME->PinyinDisplayBuf[i]);
                if( i == pIME->Element_Select )
                {
                    dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS, (char*)pIME->PinyinDisplayBuf[i]);
                }
                element_curX += (pinyinlength[i]+2);
            }
        }
        */
    }
    else
    {
        dspl_TextOut(2, ELEMENT_LINE, DSPL_TXTATTR_TRANSPARENT, star_char);
        for( i=0; i<pIME->PinyinElementBUF[pIME->ElementNumber-1].Count; i++ )
        {
            dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_TRANSPARENT, (char*)pIME->PinyinDisplayBuf[i]);
            if( i == pIME->Element_Select )
            {
                dspl_TextOut((USHORT)element_curX, ELEMENT_LINE, DSPL_TXTATTR_UNICODE|DSPL_TXTATTR_INVERS, (char*)pIME->PinyinDisplayBuf[i]);
            }
            element_curX += (pinyinlength[i]+2);
        }
    }
}

/****************************************************************************************
 $Function:    	IMESetDefaultValue

 $Description:	reset IME data

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:

****************************************************************************************/
static void IMESetDefaultValue(pIME_DATA pIME)
{
    memset(pIME->pGetParam->pElements, 0x00, 6*sizeof(pIME->pGetParam->pElements));
    pIME->Element_Select = 0;
    pIME->ElementNumber = 0;
    pIME->moreCount = 0;
    pIME->candidates = 0;
    pIME->InputScreenType = TEXT_DISPLAY_SCREEN;
    pIME->pGetParam->ElementCount = 0;
}

/****************************************************************************************
 $Function:    	TextInputEventKey

 $Description:	operate alphachar input mode

 $Returns: int
 
 $Author Name:  Sunsj
 
 $Date:

****************************************************************************************/
static int TextInputEventKey (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win              = mfw_parent (mfw_header());
    T_MFW_WIN       * win_data       = ((T_MFW_HDR *)win)->data;
    T_TEXT_INPUT    * data           = (T_TEXT_INPUT *)win_data->user;
    MfwEdt          *edit            = ((MfwHdr *) data->input_edt)->data;
    char            alphachar;
    char            ** l_curCharSet;

    switch( editor_input_mode )
    {
    case UPPERCASE_INPUT_MODE:
    case LOWERCASE_INPUT_MODE:
        {
            if( editor_input_mode == UPPERCASE_INPUT_MODE )
                l_curCharSet = (char **)l_editAlphaU;
            else
                l_curCharSet = (char **)l_editAlphaL;

            if( editAlphaKey != KCD_MAX && editAlphaKey != k->code ) //when the cursor is still not right, we press other key
            {
                timStop(data->input_key_tim);
                edtSymbol(data->input_edt,ecRight);
                editAlphaLevel = 0; 
                editAlphaKey = KCD_MAX;
                input_key_timer_flag = 0;
            }
            else if( editAlphaKey != KCD_MAX )     // the cursor is still not right, we press the same key
            {
                editAlphaLevel = (editAlphaLevel + 1) % strlen(l_curCharSet[editAlphaKey]);
            }
            if( k->code <= KCD_HASH )
            {
                /* if the cursor is still not right and we press the same key, we need delete the char */
                if( editAlphaKey != KCD_MAX )
                {
                    /* because the operate is not display so need to hide edt */
                    edtHide(data->input_edt);
                    edtSymbol(data->input_edt,ecDel);
                    edtUnhide(data->input_edt);
                }

                /* get the char we pressed */
                editAlphaKey = k->code;
                alphachar = l_curCharSet[editAlphaKey][editAlphaLevel];

                /* if the char is successful in adding to edt we need move cursor to left and start timer */
                if( edtSymbol(data->input_edt, alphachar)==MfwResOk )
                {
                    edtSymbol(data->input_edt, ecLeft);
                    timStart(data->input_key_tim);
                    input_key_timer_flag = 1;
                }
                else
                {
                    editAlphaLevel = 0; 
                    editAlphaKey = KCD_MAX;
                }
                return 1;
            }
        }
        break;
    case SHUZI_INPUT_MODE:
        edtSymbol(data->input_edt,ec_editControls[k->code]);
        break;
    default:
        break;
    }       
    return 1;
}

/****************************************************************************************
 $Function:    	getactiveEditor

 $Description:	return current edt

 $Returns: int
 
 $Author Name:  Sunsj
 
 $Date:

****************************************************************************************/
MfwHnd TextInputActiveEditor(void)
{
    return TextInputHandle;
}

/****************************************************************************************
 $Function:    	GetKeyEventConfig

 $Description:	return current configuration

 $Returns: int
 
 $Author Name:  Sunsj
 
 $Date:

****************************************************************************************/
static int GetKeyEventConfig( T_TEXT_INPUT* textEditorData )
{
    T_TEXT_INPUT   *data = textEditorData;
    int            asciiTextSize = data->editor_data.editor_attr.e_size?data->editor_data.editor_attr.e_size:data->editor_data.editor_attr.size;
    BOOL           HanZiInputFlag = FALSE;
    MfwEdt         *edt = ((MfwHdr *) data->input_edt)->data;

    /* Set the hanzi input flag if current input mode is pinyin and stroke mode */
    if( data->Ime.EditorMode == PINYIN_INPUT_MODE || data->Ime.EditorMode == STROKE_INPUT_MODE )
    {
        HanZiInputFlag = TRUE;
    }

    /* If the text is unicode or current input mode is hanzi configuration, the text buffer size is 140 */
    if( data->editor_data.editor_attr.text[0] == (char)0x80 || HanZiInputFlag == TRUE )
    {
        /* 2004/04/01 sunsj modify */
        if( GetCharNum(data->editor_data.editor_attr.text) >= ((data->editor_data.editor_attr.size-3)/2) )
        {
            data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
            memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
            ChangeDisplayArea( data->input_edt, data->Ime.InputScreenType, data );
            edtShow( data->input_edt );
            if( data->editor_data.edtInPbk != 0 )
            {
                winShow(data->input_win);
            }
            return 1;
        }
    }
    else
    {
        if( input_key_timer_flag == 1 )
        {
            if( wstrlen(data->editor_data.editor_attr.text) >= (asciiTextSize-2) )
            {
                data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
                memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
                //winShow(data->input_win);
                return 1;
            }
        }
        else
        {
            /* If the text is ascii or current input mode is english mode, the text buffer size is 160 */
            if( wstrlen(data->editor_data.editor_attr.text) >= (asciiTextSize-3) )
            {
                data->Ime.InputScreenType = TEXT_DISPLAY_SCREEN;
                memset(&data->wcCandidates, 0, sizeof(data->wcCandidates));
                //winShow(data->input_win);
                return 1;
            }
        }
    }
    return 0;
}

/****************************************************************************************
 $Function:    	ChangeDisplayArea

 $Description:	change the display area for text

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:

 $History: 2003/12/22 sunsj modify window size

****************************************************************************************/
static void ChangeDisplayArea( MfwHnd TexInputHandle, int DisplayArea, T_TEXT_INPUT* textEditorData )
{
    MfwEdt         *edt  = ((MfwHdr *) TexInputHandle)->data;
    T_TEXT_INPUT   *data = textEditorData;
    /* 2004/02/11 sunsj modify font height for cursor display */
    int            fontHeight = dspl_GetFontHeight()+2;

    if( data->editor_data.edtInPbk != 0 )
    {
        return;
    }

    switch( DisplayArea )
    {
    case TEXT_DISPLAY_SCREEN:
        edt->attr->win.sy = fontHeight*TEXT_EDITOR_LINENUMBER_NOCANDIDATE;
        edt->curOffs = 0;
        break;
    case PINYIN_INPUT_SCREEN:
        edt->attr->win.sy = fontHeight*TEXT_EDITOR_LINENUMBER_CANDIDATE;
        break;
    case STROKE_INPUT_SCREEN:
        edt->attr->win.sy = fontHeight*TEXT_EDITOR_LINENUMBER_CANDIDATE;
        break;
    case WORD_ASSOCIATION_SCREEN:
        edt->attr->win.sy = fontHeight*TEXT_EDITOR_LINENUMBER_CANDIDATE;
        break;
    default:
        break;
    }
}

/****************************************************************************************
 $Function:    	DrawPromptIcon

 $Description:	display input mode icon

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date: 2004/06 sunsj modify for icon manage

****************************************************************************************/
static void DrawPromptIcon( int InputMode )
{
    switch( InputMode )
    {
    case PINYIN_INPUT_MODE:
        DRAW_ICON(ICON_TEXTINPUT_PINYIN);
        break;
    case STROKE_INPUT_MODE:
        DRAW_ICON(ICON_TEXTINPUT_BIHUA);
        break;
    case UPPERCASE_INPUT_MODE:
        DRAW_ICON(ICON_TEXTINPUT_ABC);
        break;
    case LOWERCASE_INPUT_MODE:
        DRAW_ICON(ICON_TEXTINPUT_abc);
        break;
    case SHUZI_INPUT_MODE:
        DRAW_ICON(ICON_TEXTINPUT_SHUZI);
        break;
    case LATIN_INPUT_MODE:
        break;
    default:
        break;
    }
}

/****************************************************************************************
 $Function:    	EditorSoftkey

 $Description:	display softkey area

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:			2004.03.23

****************************************************************************************/
void EditorSoftkey(T_TEXT_INPUT *data)
{
    if( data->editor_data.editor_attr.predText[0] != '\0' && FFS_flashData.PredTextSelected == TRUE )
    {
        displaySoftKeys(TxtSoftOK, TxtDelete);
#if(MAIN_LCD_SZIE==3)
		draw_softkeybar_leftright_arrow();//jhxu720
#endif
    }
    else
    {
        if( wstrlen(data->editor_data.editor_attr.text) < data->editor_data.min_enter )
        {
            if( data->editor_data.edtInPbk )
            {
                /* 2004/04/06 sunsj modify */
                if( wstrlen(data->editor_data.editor_attr.text) == 0 && ((data->editor_data.InputMode == PINYIN_INPUT_MODE || data->editor_data.InputMode == STROKE_INPUT_MODE)) && data->wszElementBuffer[0] != 0x00 )
                {
                    /* 2004/04/06 sunsj modify */
                    displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
                }
                else if( wstrlen(data->editor_data.editor_attr.text) == 0 )
                {
                    displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
                }
                else
                {
                    displaySoftKeys(data->editor_data.LeftSoftKey,TxtDelete);
                }
            }
            else if( wstrlen(data->editor_data.editor_attr.text) == 0 && ((data->editor_data.InputMode == PINYIN_INPUT_MODE || data->editor_data.InputMode == STROKE_INPUT_MODE)) && data->wszElementBuffer[0] != 0x00 )
            {
                /* 2004/04/02 sunsj modify */
                displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
            }
            else if( wstrlen(data->editor_data.editor_attr.text) == 0 && data->editor_data.edtInPbk == 0 )
            {
                displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
            }
            else if( data->editor_data.edtInPbk==0 )
            {
                displaySoftKeys(data->editor_data.AlternateLeftSoftKey, data->editor_data.RightSoftKey);
            }
        }
        else
        {
            /* 2004/04/01 sunsj modify for softkey display */
            if( wstrlen(data->editor_data.editor_attr.text) == 0 && ((data->editor_data.InputMode == PINYIN_INPUT_MODE || data->editor_data.InputMode == STROKE_INPUT_MODE)) && data->wszElementBuffer[0] != 0x00 )
            {
                displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
            }
            else if( wstrlen(data->editor_data.editor_attr.text) == 0 )
            {
                displaySoftKeys(data->editor_data.AlternateLeftSoftKey, TxtSoftBack);
            }
            else
            {
                /* entered sufficient number of chars: Normal Softkey appears */
                displaySoftKeys(data->editor_data.LeftSoftKey, data->editor_data.RightSoftKey);
            }
        }
    }
#if(MAIN_LCD_SIZE==3)
	draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
}

/****************************************************************************************
 $Function:    	DisplayOtherArea

 $Description:	display screen except editor area

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:			2004.03.23

****************************************************************************************/
void DisplayOtherArea(T_TEXT_INPUT *data)
{
    DrawPromptIcon( data->Ime.EditorMode );
    EditorSoftkey( data );
}

/****************************************************************************************
 $Function:    	GetCharNum

 $Description:	count string char number

 $Returns: void
 
 $Author Name:  Sunsj
 
 $Date:			2004.04.01

****************************************************************************************/
int GetCharNum(char * txt)
{
    int lenth = 0;
    unsigned char * ss = (unsigned char*)txt;

    if( *ss == 0x80 )//if unicode
    {
        ss++;
        lenth++;
        while( (*ss<<8)+*(ss+1)!=0 )
        {
            lenth += 2;
            ss    += 2;
        }
        return(lenth/2);
    }
    else//if ascii
    {
        while( *ss++ != 0 )
            lenth++;
        return lenth;
    }
}