/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiTimeDate.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    22/02/01                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

  

********************************************************************************

 $History: MmiMain.c

    25/10/00			Original Condat(UK) BMI version.	
    04/08/02            zy Mobile Innovation add backlight on/off time   
 $End

*******************************************************************************/


#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"
#include "p_sim.h"

//#include <stdio.h>
//#include <string.h>
//#include <stdlib.h>

//#include "mfw_sys.h"

//#include "stddefs.h"
//#include "custom.h"
//#include "gsm.h"
//#include "vsi.h"

#include "mfw_mfw.h"
#include "mfw_win.h"

#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_sat.h"
//lxj
#include "mfw_ffs.h"
//lxj
#include "dspl.h"

#include "gdi.h" //ES!!

#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "Mmischedule.h"
#include "Mmiautopower.h"
//#include "BmiEastAPI.h"
#include "td.h"
#include "mmicall.h"
#include "Mmischedule.h"

//#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiIdle.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiTimeDate.h"
#include "MmiSounds.h"
#include "audio.h"
#include "cus_aci.h"
#include "p_sim.h"

#include "rtc_api.h"  // zgz add,2002.8.15 Mobile Innovation

#include "mmiouterIdle.h"
#include "mmiiconresource.h"	/* 2004/06 sunsj modify for picture manage */
//#define TDTRACE 1
#include "mmiutilapi.h"
//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "mmicamera.h"
#endif


#define CLEAR_BOTTOM_ZONE dspl_Clear( KEY_AREA );
extern void GetTimeDate(int year,short month,short day,TIMEDATE *today);
extern void GetNextWeek(week_date * today, int week_range, week_date * next);
extern void GetNextMinute(date_time_minute * today, int minute_range, date_time_minute * next);

static int tida_edt_kbd_long_cb (MfwEvt e, MfwKbd *kc);
static void tida_edt_tim_out_cb(T_MFW_EVENT event,T_MFW_TIM * t);
static int check_time (T_MFW_HND win, void * edt_dat);
static int check_date (T_MFW_HND win, void * edt_dat);
static int tida_edt_kbd_cb (MfwEvt e, MfwKbd *kc);
static void tida_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int tida_edt_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
static int tida_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void tida_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void reset_edt_attr_sett(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                U8 *controls, char *text,U16 size,MfwEdtAttr* attr);

static void updateRtcDate(Date newDate);  // zgz,2002.8.15 Mobile Innovation
static void updateRtcClock(CLOCK newClock);  // zgz,2002.8.15 Mobile Innovation

static void date_time_edt_destroy  (T_MFW_HND own_window);
static T_MFW_HND date_time_edt_create(T_MFW_HND parent_window);
static void date_time_destroy  (T_MFW_HND own_window);
static T_MFW_HND date_time_create (T_MFW_HND parent_window);



static MfwHnd win;                      /* our window               */
static DisplayData DisplayInfo;
extern MfwHnd timer_win;
void alarm_screen();

#define MAX_DIG_TIDA		20	        /* size of buffer (??)  */
#define MAX_LEN_DATE		11	        /* maximum number of digits date*/
#define MAX_LEN_TIME		6	        /* maximum number of digits time*/
#define DATE_TEXT_X         0
#define DATE_TEXT_Y         0

typedef enum
{
    ALARM,
    SETTING,
    BACKLIGHTONTIME,//zy add 04/08/02
    BACKLIGHTOFFTIME,   //zy add 04/08/02
} timeDateMode;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        tida_win;
    USHORT           display_id1;
    USHORT           display_id2;
    DAT_TIME_CASE    state;               /* setting state            */
    //UBYTE				mode;				//whether we're setting the current time/date or alarm.
} T_tida;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        tida_edt_win;
    T_MFW_HND        kbd_handle;
    T_MFW_HND        kbd_long_handle;
    T_MFW_HND        editor_handle;
    T_MFW_HND        tim_out_handle;
    DAT_TIME_CASE    state;               /* setting state            */
    char edtbuf1[MAX_DIG_TIDA];
    MfwEdtAttr edit1Attr;
    UBYTE            index;
}T_tida_edt;


typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        parent_win;
    T_MFW_HND        win;
    T_MFW_HND        kbd;
    T_MFW_HND        info_time;
    int count;
    int id;
    int AfterCall;
    BOOL animal_id;
    BOOL Melody_index;
}ALARM_DATA;

typedef enum
{
    ALARM_ODINARY=TimeDateDummy+10,
    ALARM_SCHEDULE,
    ALARM_STROKE,
    ALARM_EXIT
}ALARM_EVENT;

typedef enum
{
    SCHEDULE_ALARM=TimeDateDummy+20,
    ORDINARY_ALARM,
    AUTOPOWER
}ALARM_TYPE;

/*
 * Settings menu subs:
 */

/* #define TIMERESULT      1000           time for results         */
#define TIMERCLEAR		2500
extern ScheTable[3][10];
extern RTC_DISABLE_IT_ALARM;
T_MFW_HND alarm_win=NULL;
static BOOL ALARM_FLAG=FALSE;
static BOOL STROKE_FLAG=FALSE;
extern char currentringstr[20];
/*2004/05/31 yhf modify*/
//extern const unsigned char gImage_bar[];

//extern const unsigned char alarmBit[];
extern UINT8 Gu8_Envio_num;
BOOL autopower_flag=FALSE;
extern  T_call call_data;
static T_MFW_HND tim_win=NULL;
static T_MFW_HND stroke_tim_win=NULL;
extern BOOL call_win_flag;
extern  char oldringstr[20];   //xsf add 2002.09.06
extern void stopPlayingMelody( void );
extern void startPlayingMelody(UBYTE melody_id);

//Flag to indicate whether we're setting the current or alarm date/time.
static UBYTE DateTimeEntryMode;
extern T_RTC_DATE_TIME timedate;//zhonghz,globel var,define in mmimain.c

extern UBYTE getcurrentAlarmTone(void);  //mmisounds
void schedule_alarm_screen();
static T_MFW_HND alarm_screen_create(T_MFW_HND parent_window);
void showAlarmIcon(void);
static void alarm_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int alarm_kbd_cb (MfwEvt e, MfwKbd *kc);
static int alarm_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win);
void disp_alarm_screen(ALARM_DATA* data);
static T_MFW_CB  alarm_tim_cb(MfwEvt e, MfwTim *tc);
T_MFW_CB  autopower_tim_cb(MfwEvt e, MfwTim *tc);
void GetNextSeconds(date_time_minute* a,int range,date_time_minute* b);
T_MFW_CB CallAndAlarm_tim_cb(MfwEvt e, MfwTim *tc);


/*******************************************************************************

 $Function:  alarm_check  

 $Description:	 Called by MmiMain.c to check current time/date against that set for alarm
                If they match the alarm screen comes up and the buzzer sounds

 $Returns:		none.

 $Arguments:	none
 
*******************************************************************************/

void alarm_check()
{
    T_MFW_HND    parent_win = mfwParent( mfw_header());   
    T_RTC_DATE_TIME time_date,rtcTime;
    T_RV_RETURN path;
    TIMEDATE today;   
    date_time_minute alarm_timedate,next,alarmtime;
    char s[2];
    TRACE_EVENT("check_alarm");

    GetTimeDate(currdate.year, currdate.month, currdate.day, &today);
    if( (((FFS_flashData.latest_alarm.year==currdate.year)&&(FFS_flashData.latest_alarm.month==currdate.month)//once schedule alarm and weekly alarm
          &&(FFS_flashData.latest_alarm.day==currdate.day)||(FFS_flashData.latest_alarm.wday==today.week+1)||
          (FFS_flashData.weeklyAlarm_switch&(0x01<<today.week)))&&(FFS_flashData.latest_alarm.hour==currclock.hour)
         &&(FFS_flashData.latest_alarm.minute==currclock.min))       
        ||(FFS_flashData.dailyAlarm_switch)&&(FFS_flashData.latest_alarm.hour==currclock.hour)&&(FFS_flashData.latest_alarm.minute==currclock.min)//daily alarm normal
        ||(FFS_flashData.latest_alarm.daily_switch)&&(FFS_flashData.latest_alarm.hour==currclock.hour)&&(FFS_flashData.latest_alarm.minute==currclock.min)//daily alarm
        ||(FFS_flashData.latest_alarm.weekly_switch)&&(FFS_flashData.latest_alarm.wday==today.week)&&(FFS_flashData.latest_alarm.hour==currclock.hour)&&(FFS_flashData.latest_alarm.minute==currclock.min)//weekly schedule alarm 2003.12.3 wyj
        ||(FFS_flashData.latest_alarm.month_switch)&&(FFS_flashData.latest_alarm.day==currdate.day)&&(FFS_flashData.latest_alarm.hour==currclock.hour)&&(FFS_flashData.latest_alarm.minute==currclock.min)//monthly alarm
        ||(FFS_flashData.latest_alarm.year_switch)&&(FFS_flashData.latest_alarm.month==currdate.month)&&(FFS_flashData.latest_alarm.day==currdate.day)&&(FFS_flashData.latest_alarm.hour==currclock.hour)&&(FFS_flashData.latest_alarm.minute==currclock.min) )//mannual alarm
    {
        TRACE_EVENT("ALARM_FLAG=:");
        sprintf((char*)s,"%d",ALARM_FLAG);
        TRACE_EVENT(s);
        if( !ALARM_FLAG )
        {
            ALARM_FLAG=TRUE;  
            if( FFS_flashData.latest_alarm.daily_switch==TRUE )
                FFS_flashData.latest_alarm.daily_switch=FALSE;
            if( FFS_flashData.latest_alarm.weekly_switch==TRUE )
                FFS_flashData.latest_alarm.weekly_switch=FALSE;
            if( FFS_flashData.latest_alarm.month_switch==TRUE )
                FFS_flashData.latest_alarm.month_switch=FALSE;
            if( FFS_flashData.latest_alarm.year_switch==TRUE )
                FFS_flashData.latest_alarm.year_switch=FALSE;
            switch( FFS_flashData.latest_alarm.alarm_type )
            {
            case ORDINARY_ALARM:                  
                if( (!FFS_flashData.dailyAlarm_switch)&&(!FFS_flashData.weeklyAlarm_switch) )
                {
                    TRACE_EVENT("No alarm");
                    break;
                }
                /*2003/12/26,talcon add outer Idle handle */
                //setOuterState(OUTERIDLESTATE_ALERT,1,0);//2004-03-23 Sunny remove

                if( (int)call_data.win_incoming||(int)call_data.win_calling||call_win_flag||timer_win )
                {
                    TIMCREATE_SETFLLAG(tim_win=timCreate(parent_win, 1000, (T_MFW_CB)CallAndAlarm_tim_cb);)
                    timStart(tim_win);                      
                    break;
                }
                alarm_screen();                     
                break;          
            case SCHEDULE_ALARM:                  
                if( (int)call_data.win_incoming||(int)call_data.win_calling||(int)call_win_flag )
                {
                    TIMCREATE_SETFLLAG(tim_win=timCreate(parent_win, 1000, (T_MFW_CB)CallAndAlarm_tim_cb);)
                    timStart(tim_win);
                    break;
                }
                schedule_alarm_screen();                    
                break;
            case AUTOPOWER:
                set_latest_alarm();
                break;
            default:
                break;
            }             
        }
        else
        {
            ALARM_FLAG=FALSE;
        }
    }

    alarm_timedate.year=FFS_flashData.latest_alarm.year;
    alarm_timedate.month=FFS_flashData.latest_alarm.month;
    alarm_timedate.day=FFS_flashData.latest_alarm.day;
    alarm_timedate.hour=FFS_flashData.latest_alarm.hour;
    alarm_timedate.minute=FFS_flashData.latest_alarm.minute;
    GetNextMinute(&alarm_timedate, -2, &next);
    if( (next.year==currdate.year)&&(next.month==currdate.month)&&(next.day==currdate.day)&&(next.hour==currclock.hour)&&
        (next.minute==currclock.min) )
    {
        TRACE_EVENT("RTC_DISABLE_IT_ALARM");
        RTC_DISABLE_IT_ALARM;
        //rvf_disable(25);
    }

    //power off detecting and setting power on time		
    if( FFS_flashData.poweroff_switch )
    {
        if( !autopower_flag )
        {
            if( (FFS_flashData.closetime[0] == currclock.hour)&&
                (FFS_flashData.closetime[1] == currclock.min) )
            {
                set_latest_alarm();
                alarm_timedate.year=FFS_flashData.latest_alarm.year;
                alarm_timedate.month=FFS_flashData.latest_alarm.month;
                alarm_timedate.day=FFS_flashData.latest_alarm.day;
                alarm_timedate.hour=FFS_flashData.latest_alarm.hour;
                alarm_timedate.minute=FFS_flashData.latest_alarm.minute;
                GetNextMinute(&alarm_timedate, -1, &next);
                time_date.year=next.year-2000;
                time_date.month=next.month;
                time_date.day=next.day;
                time_date.hour=next.hour;
                time_date.minute=next.minute;
                time_date.mode_12_hour=FALSE;                     
                if( alarm_win||call_data.win_incoming||call_data.win_calling||call_win_flag )
                {
                    RTC_SetAlarm(time_date, path);
                    TIMCREATE_SETFLLAG(tim_win=timCreate(parent_win, 1000, (T_MFW_CB)autopower_tim_cb);)
                    timStart(tim_win);
                }
                else
                {
                    RTC_SetAlarm(time_date, path);
                    ConfirmAutopower();
                }

                autopower_flag=TRUE;
            }
        }
        else autopower_flag=FALSE;
    }
    if( (FFS_flashData.fullhralert==1)&&(currclock.min==0) )
    {
        if( !call_win_flag&&!call_data.win_incoming&&!call_win_flag&&!alarm_win )
        {
            if( !STROKE_FLAG )
            {
                StartPlayByReason(FULLHRALERT,0);     //wms modified 03-03-05	
                STROKE_FLAG=!STROKE_FLAG;
            }
            else
            {
                STROKE_FLAG=!STROKE_FLAG;
            }
        }
    }
    if( currclock.min>59 )
    {
        currclock.min=0;
        currclock.hour++;
    }
    if( currclock.hour>23 )
    {
        currclock.hour=0;
        currdate.day++;
    }
    switch( currdate.month )
    {
    case 2:
        if( (!(currdate.year%4))&&(currdate.year%100)||(!(currdate.year%400)) )
        {
            if( currdate.day>29 )
            {
                currdate.day=0;
                currdate.month++;
            }
        }
        else
        {
            if( currdate.day>28 )
            {
                currdate.day=0;
                currdate.month++;
            }
        }              
        break;
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
        if( currdate.day>31 )
        {
            currdate.day=0;
            currdate.month++;
        }
        break;
    case 4:
    case 6:
    case 9:
    case 11:
        if( currdate.day>30 )
        {
            currdate.day=0;
            currdate.month++;
        }
        break;
    }
    if( currdate.month>12 )
    {
        currdate.month=1;
        currdate.year++;
    }
    if( currdate.day<1 )
        currdate.day=1;
    if( currdate.month<1 )
        currdate.month=1;
    if( currdate.year<2000 )
        currdate.year=2000;
    if( currclock.hour<0 )
        currclock.hour=0;
    if( currclock.min<0 )
        currclock.min=0;
}
T_MFW_CB  autopower_tim_cb(MfwEvt e, MfwTim *tc)
{
    if( alarm_win||call_data.win_incoming||call_data.win_calling||call_win_flag )
        timStart(tim_win);
    else
    {
        timStop(tim_win);
        ConfirmAutopower();
    }
}

T_MFW_CB CallAndAlarm_tim_cb(MfwEvt e, MfwTim *tc)
{
    if( call_data.win_incoming||call_data.win_calling||call_win_flag||timer_win )
    {
        timStart(tim_win);
    }
    else
    {
        timDelete(tim_win);
        if( FFS_flashData.latest_alarm.alarm_type==ORDINARY_ALARM )
            alarm_screen();
        else schedule_alarm_screen();
    }
}
/*******************************************************************************

 $Function:  alarm_screen

 $Description:	 displays alarm screen

 $Returns:		none.

 $Arguments:	none
 
*******************************************************************************/
#if 0
void alarm_screen()
{
    T_MFW_HND idle_win = idle_get_window();
    T_DISPLAY_DATA display_info;

    char text[25];


    FFS_flashData.alarm_day = 0;//Alarm no longer set	
    flash_write();
    StartTone();

    sprintf(text, "%02d:%02d", FFS_flashData.latest_alarm.hour, FFS_flashData.latest_alarm.minute);
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = TxtAlarm;
    display_info.TextId2      = 0;
    display_info.TextString   ='\0';
    display_info.TextString2  = text;
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftOK;
    display_info.Time         = FOREVER;
    display_info.Callback     = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( idle_win, &display_info );

}
#endif


void alarm_screen()
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win  =alarm_screen_create(idle_win);

    if( win NEQ NULL )
    {
        SEND_EVENT(win, ALARM_ODINARY, 0, 0);
    }
#if 0
    StartTone();

    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = TxtAlarm;
    display_info.TextId2      = 0;
    display_info.TextString   ='\0';//FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position].text;
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftOK;
    display_info.Time         = FOREVER;
    display_info.Callback     = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( idle_win, &display_info );
#endif

}


void schedule_alarm_screen()
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win  =alarm_screen_create(idle_win);

    if( win NEQ NULL )
    {
        SEND_EVENT(win, ALARM_SCHEDULE, 0, 0);
    }
}

static T_MFW_HND alarm_screen_create(T_MFW_HND parent_window)
{
    ALARM_DATA* data = (ALARM_DATA *)ALLOC_MEMORY (sizeof (ALARM_DATA));

    T_MFW_WIN * win;

    data->win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)alarm_win_cb);

    TRACE_FUNCTION("alarm_screen_create");

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)alarm_dialog;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;    

    alarm_win=data->win;
    /*
     * return window handle
     */
    return data->win;
}


static void alarm_dialog(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    ALARM_DATA* data = (ALARM_DATA *)win_data->user;

    data->count=0;
    data->id=event; 
    data->animal_id=FALSE;
    data->Melody_index=FALSE;
    data->AfterCall=0;

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
    CamExit();
#endif


    switch( event )
    {
    case ALARM_ODINARY:
    case ALARM_SCHEDULE:
    case ALARM_STROKE:
        TRACE_EVENT("alarm is on");         
        data->kbd = kbd_create(data->win,KEY_ALL|KEY_F4,(T_MFW_CB)alarm_kbd_cb); 
        data->info_time=timCreate(data->win,500,(T_MFW_CB)alarm_tim_cb);
        //  if(call_data.win_incoming||call_data.win_calling||call_win_flag)
        //		{
        //	StartConnectedTone();
        //	timStart(data->info_time);
        //	showAlarmIcon();
        //	winShow(win);
        //	break;
        //	}
        //if(HallStatus())					// 2004.4.16 WYJ MI18800000262
        //{
        //LCD_ON();
        LedLightnessAdjust( 200 );      // 2004.4.2 WYJ fix MI18800000155
        timStart(gtVibator);
        //}
        setOuterState(OUTERIDLESTATE_ALERT,1,0);//2004-04-22 Sunny add
        if( data->id!=ALARM_STROKE )
        {
#ifndef FOR_FTA_CTA
            timStart(data->info_time);      
#endif
            StartPlayByReason(ALARMPLAY,0);
            //StartMelody2(MelodyTablestr[3],0);
            data->Melody_index=TRUE;
            showAlarmIcon();
        }
        else
        {
            //StartTonebypara(5);  xsf changed 2003.01.06
            StartPlayByReason(FULLHRALERT,0);
            //  StartTone();
            break;
        }
        // else
        // 	{
        //        timStart(data->info_time);
        //        StartTone();
        // 	}
        winShow(win);
        break;
    case ALARM_EXIT:
        alarm_destroy(win);
        break;
    default:
        break;
    }
}


static T_MFW_CB  alarm_tim_cb(MfwEvt e, MfwTim *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    ALARM_DATA* data = (ALARM_DATA*)win_data->user;

    TRACE_EVENT("alarm_tim_cb");
    /* 2004/07/12 sunsj modify for alarm in simtoolkit */
    if( winIsFocussed(data->win) )
    {
    if( (data->id!=ALARM_STROKE)&&(!call_win_flag)&&(!call_data.win_incoming)&&(!call_data.win_calling) )
    {
        /*2004/05/31 yhf modify*/
        if( data->count>60 )              // MI18800000263
        {
            //Stopplayingdevice();  xsf changed 12.31
            StopPlayByReasonId(ALARMPLAY);
            timStop(data->info_time);
            alarm_destroy(win);
        }
        else
        {
            data->count++;
            data->animal_id=!data->animal_id;  
            if( data->AfterCall )
            {
                data->AfterCall++;
                if( data->AfterCall==3 )
                {
                    StartPlayByReason(ALARMPLAY,0);
                }
            }

            if( data->id==ALARM_ODINARY )
            {
                switch( data->count%2 )
                {
                case 0:
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_SEL(ICON_ALARM_ANIM, 0);
                    //dspl_BitBlt(40, 69, 49, 57, 0, (void*)alarm_animal1, 0);
                    break;
                case 1:
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_SEL(ICON_ALARM_ANIM, 0);
                    DRAW_ICON_SEL(ICON_ALARM_ANIM, 1);
                    //dspl_BitBlt(40, 69, 49, 57, 0, (void*)alarm_animal1, 0);
                    //dspl_BitBlt(40, 69, 49, 18, 0, (void*)alarm_animal2, 0);
                    break;
                }                
            }
            //end yhf modify

            timStart(data->info_time);
            /* if(data->id==ALARM_ODINARY)
                 {
                  dspl_Clear(40, 53, 80, 106);
                  if(!data->animal_id)
                     dspl_BitBlt(40, 53, 40, 53, 0, (void*)alarm_animal1, 0);
                  else
                     dspl_BitBlt(0, 17, 120, 128, 0, (void*)alarm_animal2, 0);
                 }*/
        }
    }
    else if( data->id==ALARM_STROKE )
    {
        if( data->count>20 )
        {
            StopTone();
            timDelete(data->info_time);
            alarm_destroy(win);
        }
        else
        {
            data->count++;              
            timStart(data->info_time);                              
        }
    }
    else
    {
        //timDelete(data->info_time);
        //alarm_destroy(win);
        //StopPlayByReasonId(ALARMPLAY);
        if( data->Melody_index )
        {
            data->Melody_index=FALSE;
        }
        //timStart(data->info_time);
    }
}
    else
    {
        StopPlayByReasonId(ALARMPLAY);
        //StopTone();
        timDelete(data->info_time);
        alarm_destroy(win);
    }
}


static int alarm_kbd_cb (MfwEvt e, MfwKbd *kc)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)alarm_win)->data;
    ALARM_DATA* data = (ALARM_DATA *)win_data->user;  


    TraceInt(kc->code);
    switch( kc->code )
    {
    case KCD_LEFT:
        TRACE_EVENT("gdy KCD_LEFT");
        if( data->id==ALARM_SCHEDULE )
        {
            if( Flash_ScheRead((char*)ScheTable[FFS_flashData.latest_alarm.schedule_position/SCHEDULE_NUMBER])>0 )
            {
                if( FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%SCHEDULE_NUMBER].type==PHONE )
                {
                    //Stopplayingdevice();  xsf changed 12.31
                    StopPlayByReasonId(ALARMPLAY);                                    
                    callNumber((UBYTE*)FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%SCHEDULE_NUMBER].text);
                    alarm_destroy(alarm_win);
                    break;
                }
            }
            //Stopplayingdevice();  xsf changed 12.31
            StopPlayByReasonId(ALARMPLAY);
            SEND_EVENT(alarm_win,ALARM_EXIT,0,0);
        }
        break;

    case KCD_F4:
        if( GetHallStatus() )             //hall on 
            break;
    case KCD_RIGHT:
    case KCD_HUP:
        timStop(data->info_time);       //MI18800000246
        StopPlayByReasonId(ALARMPLAY);
        //StopTone();
        SEND_EVENT(alarm_win,ALARM_EXIT,0,0);
        break;

    case KCD_ABC:         // 2004.4.5 WYJ fix MI18800000155
        break;

    default:  
        //timStop(data->info_time);		MI18800000246
        //StopPlayByReasonId(ALARMPLAY);
        //StopTone();
        //SEND_EVENT(alarm_win,ALARM_EXIT,0,0);
        break;
    }
    return MFW_EVENT_CONSUMED;
}


static int alarm_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{
    ALARM_DATA* data = (ALARM_DATA *)win->user;
    T_MFW_WIN * edt_win =((T_MFW_HDR *)data->parent_win)->data;

    TRACE_FUNCTION ("MmiTimeDate:alarm_win_cb");


    if( event EQ MfwWinVisible )
    {
        //dspl_ClearAll();
        disp_alarm_screen(data);

        return 1;
    }

    return 0;  
}

void disp_alarm_screen(ALARM_DATA* data)
{
    char text[5];
    char stroke_string[8];
    int old_color;

    //2004/05/25 yhf modify
    //StartTone();
    switch( data->id )
    {
    case ALARM_ODINARY:
        if( call_data.win_incoming||call_data.win_calling||call_win_flag )
        {

            if( FFS_flashData.latest_alarm.schedule_position )
                dspl_colorTextOut(28, 125 , DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtWeeklyAlarm), 0xffffff);
            else
                dspl_colorTextOut(28, 125 , DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtDailyAlarm), 0xffffff); 

            break;
        }
        dspl_ClearAll();
        draw_special_background();
        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON_SEL(ICON_ALARM_ANIM, 0);
        //dspl_BitBlt(40, 69, 49, 57, 0, (void*)alarm_animal1, 0);
        sprintf(text, "%02d:%02d", FFS_flashData.latest_alarm.hour, FFS_flashData.latest_alarm.minute);
        if( Mmi_getCurrentLanguage()==CHINESE_LANGUAGE )
        {
            dspl_colorTextOut( 45, 28 , DSPL_TXTATTR_TRANSPARENT, text, 0xffffff);
            if( FFS_flashData.latest_alarm.schedule_position )
                dspl_colorTextOut(32, 3 , DSPL_TXTATTR_WHITE_EDGE, MmiRsrcGetText(TxtWeeklyAlarm), 0x000000);
            else
                dspl_colorTextOut(32, 3 , DSPL_TXTATTR_WHITE_EDGE, MmiRsrcGetText(TxtDailyAlarm), 0x000000);  
        }
        else
        {
            if( FFS_flashData.latest_alarm.schedule_position )
                dspl_colorTextOut(25, 3 , DSPL_TXTATTR_WHITE_EDGE, MmiRsrcGetText(TxtWeeklyAlarm), 0x000000);
            else
                dspl_colorTextOut(25, 3 , DSPL_TXTATTR_WHITE_EDGE, MmiRsrcGetText(TxtDailyAlarm), 0x000000);  
            dspl_colorTextOut( 45, 28 , DSPL_TXTATTR_TRANSPARENT, text, 0xffffff);
        }

        displaySoftKeys(0, TxtSoftConfirm);
        break;
    case ALARM_SCHEDULE:
        if( call_data.win_incoming||call_data.win_calling||call_win_flag )
        {
            dspl_colorTextOut(28, 125 , DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtSchedule), 0xffffff);  
            break;
        }
        dspl_ClearAll();
        if( Flash_ScheRead((char*)ScheTable[FFS_flashData.latest_alarm.schedule_position/SCHEDULE_NUMBER])>0 )
        {
            if( FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%SCHEDULE_NUMBER].type==PHONE )
            {
                TRACE_EVENT("PHONE");
                dspl_colorTextOut(35, 20 , 0, MmiRsrcGetText(TxtCall), 0x000000);
                dspl_colorTextOut(60-strlen((char*)(FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%70].text))*4, 60 , 0, (char*)FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%70].text,0xff0000);  
                displaySoftKeys(TxtSoftCall, TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
            }
            else
            {
                scheDataDisplay(&FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%SCHEDULE_NUMBER]);
                // dspl_colorTextOut(0,16,0,(char*)FFS_ScheData.FfsSche[FFS_flashData.latest_alarm.schedule_position%70].text,0x0000ff);
                displaySoftKeys(0, TxtSoftConfirm);
            }       
        }
        /*end yhf modify*/
        break;
    case ALARM_STROKE:
        dspl_colorTextOut(28, 30 , 0, MmiRsrcGetText(TxtStroke), 0x0000ff);  
        memset(stroke_string,0,8);
        sprintf(stroke_string,"%02d:%02d",currclock.hour,currclock.min);
        dspl_colorTextOut(40, 60, 0, (char *)stroke_string, 0x0000ff);
        displaySoftKeys(0, TxtSoftConfirm);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
        break;
    }
    if( data->id!=ALARM_STROKE )
    {
        TRACE_EVENT("ALARM_STROKE");
        TraceInt(data->Melody_index);
        if( !data->Melody_index )
        {
            //StartPlayByReason(ALARMPLAY,0);
            data->AfterCall++;
            data->Melody_index=TRUE;
#ifndef FOR_FTA_CTA
            timStart(data->info_time);
#endif
        }
    }
}

void alarm_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    ALARM_DATA* data   = (ALARM_DATA*)win->user;


    alarm_win=NULL;
    set_latest_alarm();

    /*2003/12/26,talcon add outer Idle handle */
    setOuterState(OUTERIDLESTATE_ALERT,0,0);//2004-03-23 Sunny modify

    TRACE_EVENT("alarm_destroy");
    if( own_window )
    {
        /*
         * Delete WIN Handler
         */


        win_delete (own_window);
        /*
         * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (ALARM_DATA));
    }
}




void set_latest_alarm()
{
    char timedate_string1[20];
    char timedate_string2[20];
    char timedate_string3[20];
    char displaystring[20];
    char temp_str[4];
    long t1=0,t2=0,t3=0,t4=0;
    TIMEDATE today;
    week_date today_date;
    week_date next_date;
    MONTHTABLE month_table;
    T_RTC_DATE_TIME time_date;
    T_RV_RETURN path;
    int i,t_string,t_string1;

    TRACE_EVENT("set_latest_alarm");
    //lxj
    Flash_ScheRead((char *)ScheTable[0]);
    //lxj
    GetTimeDate(currdate.year, currdate.month, currdate.day, &today);

    t1=currdate.year-2000;
    t1=t1*13+currdate.month;
    t1=t1*32+currdate.day;
    t1=t1*61+currclock.hour;
    t1=t1*61+currclock.min;

    FFS_flashData.latest_alarm.alarm_type=0;    
    t3=t1;
    TraceInt(t3);

    //autopower open time
    if( FFS_flashData.poweron_switch )
    {

        t2=currdate.year-2000;
        t2=t2*13+currdate.month;
        t2=t2*32+currdate.day;
        t2=t2*61+FFS_flashData.opentime[0];
        t2=t2*61+FFS_flashData.opentime[1];
        // if(t_string>0)//gdy 03/03/04
        if( t2>t1 )
        {
            if( (t2<t3)||(t1==t3) )
            {
                // strcpy(timedate_string3,timedate_string2);//gdy 03/03/04
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=AUTOPOWER;
            }
            //else if(t_string==0)//gdy 03/03/04
            else if( t2==t3 )
            {
                FFS_flashData.latest_alarm.alarm_type=AUTOPOWER;
            }
        }
        else
        {
            GetMonthTable(&today, 0, 1, &month_table);

            t2=month_table.year-2000;
            t2=t2*13+month_table.month;
            t2=t2*32+month_table.day;
            t2=t2*61+FFS_flashData.opentime[0];
            t2=t2*61+FFS_flashData.opentime[1];
            //	if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                // strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=AUTOPOWER;
            }
            else if( t2==t3 )
            {
                FFS_flashData.latest_alarm.alarm_type=AUTOPOWER;                
            }
        }
    }

    for( i=0;i<SCHEDULE_NUMBER;i++ )
    {
        if( ScheDetailIndex[i].index )
        {
            if( ScheDetailIndex[i].ringandt/16 )
            {
                switch( FFS_ScheData.FfsSche[i%SCHEDULE_NUMBER].ringandf%16 )//schedule need change
                {
                case ONCE:

                    t2=ScheDetailIndex[i].date[0]-2000;
                    t2=t2*13+ScheDetailIndex[i].date[1]/256;
                    t2=t2*32+ScheDetailIndex[i].date[1]%256;
                    t2=t2*61+ScheDetailIndex[i].hour;
                    t2=t2*61+ScheDetailIndex[i].minute;
                    //if(t_string>0)
                    if( t2>t1 )
                    {
                        //t_string=strcmp(timedate_string2,timedate_string3);
                        //t_string1=strcmp(timedate_string1,timedate_string3);
                        //if((t_string<0)||(t_string1==0))
                        if( (t2<t3)||(t1==t3) )
                        {
                            //strcpy(timedate_string3,timedate_string2);
                            t3=t2;
                            FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                            FFS_flashData.latest_alarm.schedule_position=i;                             
                        }
                    }
                    break;
                case EVERYDAY:

                    t2=currdate.year-2000;
                    t2=t2*13+currdate.month;
                    t2=t2*32+currdate.day;
                    t2=t2*61+ScheDetailIndex[i].hour;
                    t2=t2*61+ScheDetailIndex[i].minute;
                    // if(t_string>0)
                    if( t2>t1 )
                    {
                        //t_string=strcmp(timedate_string2,timedate_string3);
                        //t_string1=strcmp(timedate_string1,timedate_string3);
                        //if((t_string<0)||(t_string1==0))
                        if( (t2<t3)||(t1==t3) )
                        {
                            //strcpy(timedate_string3,timedate_string2);
                            t3=t2;
                            FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                            FFS_flashData.latest_alarm.schedule_position=i;
                            FFS_flashData.latest_alarm.daily_switch=TRUE;
                            FFS_flashData.latest_alarm.weekly_switch=FALSE;
                            FFS_flashData.latest_alarm.month_switch=FALSE;
                            FFS_flashData.latest_alarm.year_switch=FALSE;
                        }
                    }
                    else
                    {
                        GetMonthTable(&today, 0, 1, &month_table);

                        t2=month_table.year-2000;
                        t2=t2*13+month_table.month;
                        t2=t2*32+month_table.day;
                        t2=t2*61+ScheDetailIndex[i].hour;
                        t2=t2*61+ScheDetailIndex[i].minute;
                        // if((t_string<0)||(t_string1==0))
                        if( (t2<t3)||(t1==t3) )
                        {
                            //strcpy(timedate_string3,timedate_string2);
                            t3=t2;
                            FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                            FFS_flashData.latest_alarm.schedule_position=i;
                            FFS_flashData.latest_alarm.daily_switch=TRUE;
                            FFS_flashData.latest_alarm.weekly_switch=FALSE;
                            FFS_flashData.latest_alarm.month_switch=FALSE;
                            FFS_flashData.latest_alarm.year_switch=FALSE;               
                        }
                    }
                    break;
                case WEEKLY:            // MI18800000270 
                    if( ScheDetailIndex[i].wday != today.week )
                    {
                        if( ScheDetailIndex[i].wday < today.week )    // next week
                        {
                            GetMonthTable(&today, 0, 7-(today.week-ScheDetailIndex[i].wday), &month_table);
                        }
                        else if( ScheDetailIndex[i].wday > today.week )
                        {
                            GetMonthTable(&today, 0, ScheDetailIndex[i].wday-today.week, &month_table);
                        }
                        t2=month_table.year-2000;
                        t2=t2*13+month_table.month;
                        t2=t2*32+month_table.day;
                        t2=t2*61+ScheDetailIndex[i].hour;
                        t2=t2*61+ScheDetailIndex[i].minute;

                        if( t2>t1 )
                        {
                            if( (t2<t3)||(t1==t3) )
                            {
                                t3=t2;
                                FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                                FFS_flashData.latest_alarm.schedule_position=i;
                                FFS_flashData.latest_alarm.wday=ScheDetailIndex[i].wday;
                                FFS_flashData.latest_alarm.weekly_switch=TRUE;
                                FFS_flashData.latest_alarm.daily_switch=FALSE;
                                FFS_flashData.latest_alarm.month_switch=FALSE;
                                FFS_flashData.latest_alarm.year_switch=FALSE; 
                            }
                        }
                    }
                    else
                    {
                        t2=currdate.year-2000;
                        t2=t2*13+currdate.month;
                        t2=t2*32+currdate.day;
                        t2=t2*61+ScheDetailIndex[i].hour;
                        t2=t2*61+ScheDetailIndex[i].minute;
                        if( t2>t1 )
                        {
                            if( (t2<t3)||(t1==t3) )
                            {
                                t3=t2;
                                FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                                FFS_flashData.latest_alarm.schedule_position=i;
                                FFS_flashData.latest_alarm.wday=ScheDetailIndex[i].wday;
                                FFS_flashData.latest_alarm.weekly_switch=TRUE;
                                FFS_flashData.latest_alarm.daily_switch=FALSE;
                                FFS_flashData.latest_alarm.month_switch=FALSE;
                                FFS_flashData.latest_alarm.year_switch=FALSE; 
                            }
                        }
                        else
                        {
                            GetNextWeek(&today_date, 1, &next_date);
                            t2=today_date.year-2000;
                            t2=t2*13+today_date.month;
                            t2=t2*32+today_date.day;
                            t2=t2*61+ScheDetailIndex[i].hour;
                            t2=t2*61+ScheDetailIndex[i].minute;
                            if( t2>t1 )
                            {
                                if( (t2<t3)||(t1==t3) )
                                {
                                    t3=t2;
                                    FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                                    FFS_flashData.latest_alarm.schedule_position=i;
                                    FFS_flashData.latest_alarm.wday=ScheDetailIndex[i].wday;
                                    FFS_flashData.latest_alarm.weekly_switch=TRUE;
                                    FFS_flashData.latest_alarm.daily_switch=FALSE;
                                    FFS_flashData.latest_alarm.month_switch=FALSE;
                                    FFS_flashData.latest_alarm.year_switch=FALSE; 
                                }
                            }
                        }
                    }
                    break;
                case EVERYMONTH:        // MI18800000270
                    t2=currdate.year-2000;
                    t2=t2*13+currdate.month;
                    t2=t2*32+ScheDetailIndex[i].date[1]%256;
                    t2=t2*61+ScheDetailIndex[i].hour;
                    t2=t2*61+ScheDetailIndex[i].minute;
                    if( t2>t1 )
                    {
                        if( (t2<t3)||(t1==t3) )
                        {
                            t3=t2;
                            FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                            FFS_flashData.latest_alarm.schedule_position=i;
                            FFS_flashData.latest_alarm.month_switch=TRUE;                           
                            FFS_flashData.latest_alarm.daily_switch=FALSE; 
                            FFS_flashData.latest_alarm.weekly_switch=FALSE;
                            FFS_flashData.latest_alarm.year_switch=FALSE;
                        }
                    }
                    else
                    {
                        GetMonthTable(&today, 1, 0, &month_table);

                        t2=month_table.year-2000;
                        t2=t2*13+month_table.month;
                        t2=t2*32+month_table.day;
                        t2=t2*61+ScheDetailIndex[i].hour;
                        t2=t2*61+ScheDetailIndex[i].minute;
                        if( (t2<t3)||(t1==t3) )
                        {
                            t3=t2;
                            FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                            FFS_flashData.latest_alarm.schedule_position=i;
                            FFS_flashData.latest_alarm.month_switch=TRUE;                           
                            FFS_flashData.latest_alarm.daily_switch=FALSE; 
                            FFS_flashData.latest_alarm.weekly_switch=FALSE;
                            FFS_flashData.latest_alarm.year_switch=FALSE;       
                        }
                    }
                    break;
                case ANNUALLY:

                    t2=currdate.year-2000;
                    t2=t2*13+ScheDetailIndex[i].date[1]/256;
                    t2=t2*32+ScheDetailIndex[i].date[1]%256;
                    t2=t2*61+ScheDetailIndex[i].hour;
                    t2=t2*61+ScheDetailIndex[i].minute;
                    if( t2>t1 )
                    {
                        if( (t2<t3)||(t1==t3) )
                        {
                            t3=t2;
                            FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                            FFS_flashData.latest_alarm.schedule_position=i;
                            FFS_flashData.latest_alarm.year_switch=TRUE;                            
                            FFS_flashData.latest_alarm.daily_switch=FALSE;
                            FFS_flashData.latest_alarm.weekly_switch=FALSE;
                            FFS_flashData.latest_alarm.month_switch=FALSE;                              
                        }
                    }
                    else
                    {

                        t2=currdate.year+1-2000;
                        t2=t2*13+ScheDetailIndex[i].date[1]/256;
                        t2=t2*32+ScheDetailIndex[i].date[1]%256;
                        t2=t2*61+ScheDetailIndex[i].hour;
                        t2=t2*61+ScheDetailIndex[i].minute;
                        if( t2>t1 )
                        {
                            if( (t2<t3)||(t1==t3) )
                            {
                                t3=t2;
                                FFS_flashData.latest_alarm.alarm_type=SCHEDULE_ALARM;
                                FFS_flashData.latest_alarm.schedule_position=i;
                                FFS_flashData.latest_alarm.year_switch=TRUE;                            
                                FFS_flashData.latest_alarm.daily_switch=FALSE;
                                FFS_flashData.latest_alarm.weekly_switch=FALSE;
                                FFS_flashData.latest_alarm.month_switch=FALSE;                              
                            }
                        }
                    }
                    break;
                }
            }
        }
    }

    //ordinary weekly alarm
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<today.week) )
    {
        t2=currdate.year-2000;
        t2=t2*13+currdate.month;
        t2=t2*32+currdate.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )// if(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=currdate.year;
            today_date.month=currdate.month;
            today_date.day=currdate.day;
            GetNextWeek(&today_date, 1, &next_date);
            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                // t_string=strcmp(timedate_string2,timedate_string3);
                // t_string1=strcmp(timedate_string1,timedate_string3);
                // if((t_string<0)||(t_string1==0))
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+1)%7)) )//add else
    {
        GetMonthTable(&today, 0, 1, &month_table);

        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);
            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                // t_string=strcmp(timedate_string2,timedate_string3);
                // t_string1=strcmp(timedate_string1,timedate_string3);
                // if((t_string<0)||(t_string1==0))
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+2)%7)) )//add else
    {
        GetMonthTable(&today, 0, 2, &month_table);
        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            //t_string=strcmp(timedate_string2,timedate_string3);
            //t_string1=strcmp(timedate_string1,timedate_string3);
            //if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);

            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+3)%7)) )//add else
    {
        GetMonthTable(&today, 0, 3, &month_table);
        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);

            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                if( (t2<t3)||(t1==t3) )
                {
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+4)%7)) )//add else
    {
        GetMonthTable(&today, 0, 4, &month_table);
        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            //t_string=strcmp(timedate_string2,timedate_string3);
            //t_string1=strcmp(timedate_string1,timedate_string3);
            //if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);

            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+5)%7)) )//add else
    {
        GetMonthTable(&today, 0, 5, &month_table);
        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            //t_string=strcmp(timedate_string2,timedate_string3);
            //t_string1=strcmp(timedate_string1,timedate_string3);
            //if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);

            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                // t_string=strcmp(timedate_string2,timedate_string3);
                // t_string1=strcmp(timedate_string1,timedate_string3);
                // if((t_string<0)||(t_string1==0))
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+6)%7)) )//add else
    {
        GetMonthTable(&today, 0, 6, &month_table);
        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            //t_string=strcmp(timedate_string2,timedate_string3);
            //t_string1=strcmp(timedate_string1,timedate_string3);
            //if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);

            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                // t_string=strcmp(timedate_string2,timedate_string3);
                // t_string1=strcmp(timedate_string1,timedate_string3);
                // if((t_string<0)||(t_string1==0))
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }
    if( FFS_flashData.weeklyAlarm_switch&(0x01<<((today.week+7)%7)) )//add else
    {
        GetMonthTable(&today, 0, 7, &month_table);
        t2=month_table.year-2000;
        t2=t2*13+month_table.month;
        t2=t2*32+month_table.day;
        t2=t2*61+FFS_flashData.weeklyAlarm_hour;
        t2=t2*61+FFS_flashData.weeklyAlarm_min;
        //if(t_string>0)
        if( t2>t1 )
        {
            //t_string=strcmp(timedate_string2,timedate_string3);
            //t_string1=strcmp(timedate_string1,timedate_string3);
            //if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=1;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                //FFS_flashData.latest_alarm.schedule_position=1;
            }
        }
        else
        {
            today_date.year=month_table.year;
            today_date.month=month_table.month;
            today_date.day=month_table.day;
            GetNextWeek(&today_date, 1, &next_date);

            t2=next_date.year-2000;
            t2=t2*13+next_date.month;
            t2=t2*32+next_date.day;
            t2=t2*61+FFS_flashData.weeklyAlarm_hour;
            t2=t2*61+FFS_flashData.weeklyAlarm_min;
            // if(t_string>0)
            if( t2>t1 )
            {
                // t_string=strcmp(timedate_string2,timedate_string3);
                // t_string1=strcmp(timedate_string1,timedate_string3);
                // if((t_string<0)||(t_string1==0))
                if( (t2<t3)||(t1==t3) )
                {
                    // strcpy(timedate_string3,timedate_string2);
                    t3=t2;
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    FFS_flashData.latest_alarm.schedule_position=1;
                }
                else if( t3==t2 )//(t_string==0)
                {
                    FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                    //FFS_flashData.latest_alarm.schedule_position=1;
                }
            }
        }
    }

    if( FFS_flashData.dailyAlarm_switch )
    {
        t2=currdate.year-2000;
        t2=t2*13+currdate.month;
        t2=t2*32+currdate.day;
        t2=t2*61+FFS_flashData.dailyAlarm_hour;
        t2=t2*61+FFS_flashData.dailyAlarm_min;
        // if(t_string>0)
        if( t2>t1 )
        {
            //t_string=strcmp(timedate_string2,timedate_string3);
            //	t_string1=strcmp(timedate_string1,timedate_string3);
            //	if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=0;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;               
            }
        }
        else
        {
            GetMonthTable(&today, 0, 1, &month_table);

            t2=month_table.year-2000;
            t2=t2*13+month_table.month;
            t2=t2*32+month_table.day;
            t2=t2*61+FFS_flashData.dailyAlarm_hour;
            t2=t2*61+FFS_flashData.dailyAlarm_min;
            //if((t_string<0)||(t_string1==0))
            if( (t2<t3)||(t1==t3) )
            {
                //strcpy(timedate_string3,timedate_string2);
                t3=t2;
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;
                FFS_flashData.latest_alarm.schedule_position=0;
            }
            else if( t2==t3 )//(t_string==0)
            {
                FFS_flashData.latest_alarm.alarm_type=ORDINARY_ALARM;               
            }
        }
    }

    if( FFS_flashData.latest_alarm.alarm_type )
    {
        FFS_flashData.latest_alarm.year=t3/61/61/32/13+2000;
        // sprintf(temp_str,"%d",FFS_flashData.latest_alarm.year);
        // TRACE_EVENT(temp_str);
        //strcpy(displaystring,temp_str);
        //zgzTraceData("latest_alarm.year", FFS_flashData.latest_alarm.year);
        //FFS_flashData.latest_alarm.month=((int)timedate_string3[4]-48)*10+(int)timedate_string3[5]-48;
        FFS_flashData.latest_alarm.month=(t3%(61*61*32*13))/61/61/32;
        //zgzTraceData("latest_alarm.month", FFS_flashData.latest_alarm.month);
        // memset(temp_str,0,sizeof(temp_str));
        // sprintf(temp_str,"%d",FFS_flashData.latest_alarm.month);
        // TRACE_EVENT(temp_str);
        //strcat(displaystring,temp_str);
        //FFS_flashData.latest_alarm.day=((int)timedate_string3[6]-48)*10+(int)timedate_string3[7]-48;
        FFS_flashData.latest_alarm.day=((t3%(61*61*32*13))%(61*61*32))/61/61;
        //zgzTraceData("latest_alarm.day", FFS_flashData.latest_alarm.day);
        // memset(temp_str,0,sizeof(temp_str));
        // sprintf(temp_str,"%d",FFS_flashData.latest_alarm.day);
        // TRACE_EVENT(temp_str);
        //strcat(displaystring,temp_str);
        FFS_flashData.latest_alarm.hour=(((t3%(61*61*32*13))%(61*61*32))%(61*61))/61;//((int)timedate_string3[8]-48)*10+(int)timedate_string3[9]-48;
        //zgzTraceData("latest_alarm.hour", FFS_flashData.latest_alarm.hour);
        // memset(temp_str,0,sizeof(temp_str));
        // sprintf(temp_str,"%d",FFS_flashData.latest_alarm.hour);
        // TRACE_EVENT(temp_str);
        // strcat(displaystring,temp_str);
        FFS_flashData.latest_alarm.minute=(((t3%(61*61*32*13))%(61*61*32))%(61*32))%61;//((int)timedate_string3[10]-48)*10+(int)timedate_string3[11]-48;
        //zgzTraceData("latest_alarm.minute", FFS_flashData.latest_alarm.minute);
        // memset(temp_str,0,sizeof(temp_str));
        // sprintf(temp_str,"%d",FFS_flashData.latest_alarm.minute);
        // TRACE_EVENT(temp_str);
        // strcat(displaystring,temp_str);
        // TRACE_EVENT(displaystring);
        flash_write();  
    }
    TraceInt(FFS_flashData.latest_alarm.year);
    TraceInt(FFS_flashData.latest_alarm.month);
    TraceInt(FFS_flashData.latest_alarm.day);
    TraceInt(FFS_flashData.latest_alarm.hour);
    TraceInt(FFS_flashData.latest_alarm.minute);
    TRACE_EVENT("FFS_flashData.latest_alarm.alarm_type");
    TraceInt(FFS_flashData.latest_alarm.alarm_type);
    //AutoPowerOn();
}


void AutoPower_Cb (void* parameter)
{

    MmiTrace("AutoPower_Cb");
    RTC_DISABLE_IT_ALARM;

}

int AutoPowerOn(void)
{

    T_RTC_DATE_TIME  date_time;
    T_RV_RETURN return_path;
    date_time_minute today,next;
    long currentdate=0,latestdate=0;
    int flag=0;
    //flash_read();	//hxl moved this to ffsfile_init 2002-11-26
    TRACE_EVENT("AutoPowerOn");         

    //date_time.year=FFS_flashData.latest_alarm.year;
    if( FFS_flashData.latest_alarm.alarm_type )
    {
        memset(&date_time,0,sizeof(T_RTC_DATE_TIME));
        memset(&today,0,sizeof(date_time_minute));
        memset(&next,0,sizeof(date_time_minute));
        RTC_GetDateTime(&date_time);
        //return_path.callback_func = AutoPower_Cb;   
        return_path.addr_id = 0;

        currentdate=date_time.year;
        currentdate=currentdate*13+date_time.month;
        currentdate=currentdate*32+date_time.day;
        currentdate=currentdate*24+date_time.hour;
        currentdate=currentdate*61+date_time.minute;
        TraceInt(currentdate);
        latestdate=FFS_flashData.latest_alarm.year-2000;
        latestdate=latestdate*13+FFS_flashData.latest_alarm.month;
        latestdate=latestdate*32+FFS_flashData.latest_alarm.day;
        latestdate=latestdate*24+FFS_flashData.latest_alarm.hour;
        latestdate=latestdate*61+FFS_flashData.latest_alarm.minute;
        if( (latestdate>currentdate)&&(latestdate<currentdate+2)||(latestdate==currentdate) )
        {
            today.year=FFS_flashData.latest_alarm.year-2000;
            today.month=FFS_flashData.latest_alarm.month;
            today.day=FFS_flashData.latest_alarm.day;
            today.hour=FFS_flashData.latest_alarm.hour;
            today.minute=FFS_flashData.latest_alarm.minute;
            if( FFS_flashData.latest_alarm.alarm_type!=AUTOPOWER )
            {
                if( latestdate==currentdate )
                {
                    GetNextMinute(&today, 2, &next);
                }
                else
                {
                    GetNextMinute(&today, 1, &next);
                }
                FFS_flashData.latest_alarm.year=next.year+2000;
                FFS_flashData.latest_alarm.month=next.month;
                FFS_flashData.latest_alarm.day=next.day;
                FFS_flashData.latest_alarm.hour=next.hour;
                FFS_flashData.latest_alarm.minute=next.minute;
            }
            else
                next = today;

            if( latestdate==currentdate )
            {
                GetNextMinute(&today, 1, &next);
            }
        }
        else
        {
            today.year=date_time.year;
            today.month=FFS_flashData.latest_alarm.month;
            today.day=FFS_flashData.latest_alarm.day;
            today.hour=FFS_flashData.latest_alarm.hour;
            today.minute=FFS_flashData.latest_alarm.minute;
            GetNextMinute(&today, -1, &next);
        }
        date_time.year=next.year;
        date_time.month=next.month;
        date_time.day=next.day;
        date_time.hour=next.hour;
        date_time.minute=next.minute;
        date_time.second=0;//FFS_flashData.latest_alarm.second;
        date_time.wday=FFS_flashData.latest_alarm.wday;
        date_time.mode_12_hour=FALSE;
        date_time.PM_flag=FALSE;
        TraceInt(next.year);
        TraceInt(next.month);
        TraceInt(next.day);
        TraceInt(next.hour);
        TraceInt(next.minute);

        flag=RTC_SetAlarm(date_time,return_path);
    }
    return flag;
}

void showAlarmIcon()
{
    int i;
    BOOL flag=FALSE;
    int monthandday;

    //flash_read();
    if( FFS_flashData.dailyAlarm_switch||FFS_flashData.weeklyAlarm_switch )
        flag=TRUE;
    Flash_ScheRead((char*)ScheTable[0]);
    monthandday=currdate.month*256+currdate.day;
    for( i=0;i<SCHEDULE_NUMBER;i++ )
    {
        if( FFS_ScheData.FfsSche[i].text[0] )
        {
            if( (FFS_ScheData.FfsSche[i].ringandf%16!=ONCE)&&(FFS_ScheData.FfsSche[i].ringandf/16) )
                flag=TRUE;
            else if( ((FFS_ScheData.FfsSche[i].date[0]>currdate.year)||((FFS_ScheData.FfsSche[i].date[0]==currdate.year)&&(FFS_ScheData.FfsSche[i].date[1]>monthandday))||
                      ((FFS_ScheData.FfsSche[i].date[0]==currdate.year)&&(FFS_ScheData.FfsSche[i].date[1]==monthandday)&&(FFS_ScheData.FfsSche[i].hour>currclock.hour))
                      ||((FFS_ScheData.FfsSche[i].date[0]==currdate.year)&&(FFS_ScheData.FfsSche[i].date[1]==monthandday)&&(FFS_ScheData.FfsSche[i].hour==currclock.hour)&&(FFS_ScheData.FfsSche[i].minute>currclock.min))) 
                     &&FFS_ScheData.FfsSche[i].ringandf/16 )
                flag=TRUE;
        }
    }
    if( flag )
        iconsSetState(iconIdAlarm);
    else
        iconsDeleteState(iconIdAlarm);
}


void GetNextSeconds(date_time_minute* a,int range,date_time_minute* b)
{
    if( (a->second+range)<60 )
    {
        b->year=a->year;
        b->month=a->month;
        b->day=a->day;
        b->hour=a->hour;
        b->minute=a->minute;
        b->second=(a->second+range)%60;
    }
    else if( (a->minute+1)<60 )
    {
        b->year=a->year;
        b->month=a->month;
        b->day=a->day;
        b->hour=a->hour;
        b->minute=a->minute+1;
        b->second=(a->second+range-60)%60;
    }
    else if( (a->hour+1)<24 )
    {
        b->year=a->year;
        b->month=a->month;
        b->day=a->day;
        b->hour=a->hour+1;
        b->minute=0;
        b->second=(a->second+range-60)%60;
    }
    else
    {
        switch( a->month )
        {
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            if( a->day+1<32 )
            {
                b->year=a->year;
                b->month=a->month;
                b->day=a->day+1;
                b->hour=0;
                b->minute=0;
                b->second=(a->second+range-60)%60;
            }
            else if( a->month==12 )
            {
                b->year=a->year+1;
                b->month=1;
                b->day=1;
                b->hour=0;
                b->minute=0;
                b->second=(a->second+range-60)%60;
            }
            break;
        case 4:
        case 6:
        case 9:
        case 11:
            if( a->day+1<31 )
            {
                b->year=a->year;
                b->month=a->month;
                b->day=a->day+1;
                b->hour=0;
                b->minute=0;
                b->second=(a->second+range-60)%60;
            }
            else
            {
                b->year=a->year;
                b->month=a->month+1;
                b->day=0;
                b->hour=0;
                b->minute=0;
                b->second=(a->second+range-60)%60;
            }
            break;
        case 2:
            if( !((a->year)%4)&&((a->year)%100)||!((a->year)%400) )
            {
                if( a->day+1<30 )
                {
                    b->year=a->year;
                    b->month=a->month;
                    b->day=a->day+1;
                    b->hour=0;
                    b->minute=0;
                    b->second=(a->second+range-60)%60;
                }
                else
                {
                    b->year=a->year;
                    b->month=a->month+1;
                    b->day=0;
                    b->hour=0;
                    b->minute=0;
                    b->second=(a->second+range-60)%60;
                }
            }
            else
            {
                if( a->day+1<29 )
                {
                    b->year=a->year;
                    b->month=a->month;
                    b->day=a->day+1;
                    b->hour=0;
                    b->minute=0;
                    b->second=(a->second+range-60)%60;
                }
                else
                {
                    b->year=a->year;
                    b->month=a->month+1;
                    b->day=0;
                    b->hour=0;
                    b->minute=0;
                    b->second=(a->second+range-60)%60;
                }
            }
            break;
        }
    }
}

/*******************************************************************************

 $Function:  clear_alarm 

 $Description:	 handles menu option to cancel any existing alarm setting

 $Returns:		status int

 $Arguments:	menu and item (not used)
 
*******************************************************************************/
#if 0
int clear_alarm(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win =  mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;


    FFS_flashData.alarm_day= 0;
    flash_write();

    dialog_info_init(&display_info);//gdy add		
    display_info.KeyEvents      = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId         = TxtAlarm;
    display_info.TextId2        = TxtCancelled;
    display_info.TextString     = '\0';
    display_info.TextString2    = '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtNull;
    display_info.Time           = 3000;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( win, &display_info );


    return MFW_EVENT_CONSUMED;

}


/*******************************************************************************

 $Function:  	twelve_hour_clock

 $Description:	 handles selection of twleve hour clock in menu

 $Returns:		status int

 $Arguments:	menu and item (not used)
 
*******************************************************************************/
int twelve_hour_clock(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win =  mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;
    char text[25];

    setClockFormat(TWELVE_HOUR);
    dialog_info_init(&display_info);//gdy add
    display_info.KeyEvents      = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId         = TxtClockSetTo;
    display_info.TextId2        = TxtTwelveHour;
    display_info.TextString     = '\0';
    display_info.TextString2    = '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtNull;
    display_info.Time           = 3000;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( win, &display_info );

    return MFW_EVENT_CONSUMED;

}
/*******************************************************************************

 $Function:  	twentyfour_hour_clock

 $Description:	handles selection of twleve hour clock in menu

 $Returns:		status int

 $Arguments:	menu and item (not used)
*******************************************************************************/
int twentyfour_hour_clock(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win =  mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;
    char text[25];

    setClockFormat(TWENTYFOUR_HOUR);
    dialog_info_init(&display_info);//gdy add
    display_info.KeyEvents      = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId         = TxtClockSetTo;
    display_info.TextId2        = TxtTwentyfourHour;
    display_info.TextString     =  '\0';
    display_info.TextString2    =  '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtNull;
    display_info.Time           = 3000;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( win, &display_info );

    return MFW_EVENT_CONSUMED;

}


/*******************************************************************************

 $Function:  alarmTimeDate  

 $Description:	Called when user selects alarm in menu.  Begins editor to enter
                desired alarm time and date.

 $Returns:		status int 

 $Arguments:	menu and item (not used)
 
*******************************************************************************/
int alarmTimeDate(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:alarmTimeDate()");

    tida_data->state = DATE_ENTRY;
    DateTimeEntryMode = ALARM;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,DATE_ENTRY,0,tida_data);

    }
    return 1;
}

/*******************************************************************************

 $Function:  	settingsTimeDate  

 $Description:	 settings date and time menu function

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
int settingsTimeDate(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:settingsTimeDate()");

    tida_data->state = DATE_ENTRY;
    DateTimeEntryMode = SETTING;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,DATE_ENTRY,0,tida_data);

    }
    return 1;
}
/******************************************************/
/*                                                    */
/*Function Name: settingBacklighOnTime                           */
/*Purpose:       settingBacklighOnTime    */
/*Parameter:     MfwMnu* m, MfwMnuItem* i                                */
/*return   :     int                     */
/*                                                    */
/*Author   :    zhou yue                     */
/*Date     :    Aug.4st,2002                           */
/******************************************************/

int settingBacklighOnTime(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:alarmTimeDate()");

    tida_data->state = TIME_ENTRY;
    DateTimeEntryMode = BACKLIGHTONTIME;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,TIME_ENTRY,0,tida_data);

    }
    return 1;
}

/******************************************************/
/*                                                    */
/*Function Name: settingBacklighOffTime                           */
/*Purpose:       settingBacklighOffTime    */
/*Parameter:     MfwMnu* m, MfwMnuItem* i                 */
/*return   :     int                     */
/*                                                    */
/*Author   :    zhou yue                     */
/*Date     :    Aug.4st,2002                           */
/******************************************************/
int settingBacklighOffTime(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = date_time_create(idle_win);//  parent_window is idle

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate:alarmTimeDate()");

    tida_data->state = TIME_ENTRY;
    DateTimeEntryMode = BACKLIGHTOFFTIME;

    if( tida_data->tida_win )
    {
        SEND_EVENT(tida_data->tida_win,TIME_ENTRY,0,tida_data);

    }
    return 1;
}

/*******************************************************************************

 $Function:  date_time_create  

 $Description:	create main dialog for time and date (SINGLE_DYNAMIC)

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static T_MFW_HND date_time_create (T_MFW_HND parent_window)
{
    T_MFW_WIN     * win;

    T_tida * data = (T_tida *)ALLOC_MEMORY (sizeof (T_tida));
    data->tida_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)tida_win_cb);

    TRACE_FUNCTION("MmiTimeDate:date_time_create");

    if( data->tida_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)tida_main;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->tida_win)->data;
    win->user                   = (void *) data;


    /*
     * return window handle
     */

    mfwSetSignallingMethod(1);
    winShow(data->tida_win);


    return data->tida_win;
}
/*******************************************************************************

 $Function:  date_time_destroy  

 $Description:	 destroy main dialog for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void date_time_destroy  (T_MFW_HND own_window)
{
    T_tida * data;
    T_MFW_WIN * win;

    if( own_window )
    {
        TRACE_EVENT("MmiTimeDate:date_time_destroy");
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_tida *)win->user;

        if( data )
        {
            win_delete (data->tida_win);
            FREE_MEMORY((void *)data,(sizeof(T_tida)));
        }
    }
}
/*******************************************************************************

 $Function:  date_time_edt_create  

 $Description:	 create editor dialog for time and date(SINGLE_DYNAMIC)

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static T_MFW_HND date_time_edt_create(T_MFW_HND parent_window)
{
    T_tida_edt * data = (T_tida_edt *)ALLOC_MEMORY (sizeof (T_tida_edt));

    T_MFW_WIN * win;

    data->tida_edt_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)tida_edt_win_cb);

    TRACE_FUNCTION("MmiTimeDate:date_time_edt_create");

    if( data->tida_edt_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)tida_editor;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                         = ((T_MFW_HDR *)data->tida_edt_win)->data;
    win->user                   = (void *) data;
    /*
     * Create any other handler
     */
    //reset_edt_attr_sett(0,10,70,10,0,0,edtCurBar1 | edtModOverWr,0,(char*)data->edtbuf1,MAX_DIG_TIDA,&data->edit1Attr);
    reset_edt_attr_sett(10,48,90,20,0,0,edtCurBar1 | edtModOverWr,0,(char*)data->edtbuf1,MAX_DIG_TIDA,&data->edit1Attr);


    data->tim_out_handle = tim_create(data->tida_edt_win,TIMERCLEAR,(T_MFW_CB)tida_edt_tim_out_cb);
    data->editor_handle = edt_create(data->tida_edt_win,&data->edit1Attr,0,0);
    data->kbd_handle = kbd_create(data->tida_edt_win,KEY_ALL,(T_MFW_CB)tida_edt_kbd_cb);
    data->kbd_long_handle = kbd_create(data->tida_edt_win,KEY_ALL | KEY_LONG,(T_MFW_CB)tida_edt_kbd_long_cb);
    /*
     * return window handle
     */
    return data->tida_edt_win;
}
/*******************************************************************************

 $Function:  date_time_edt_destroy  

 $Description:	destroy editor dialog for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void date_time_edt_destroy  (T_MFW_HND own_window)
{
    T_tida_edt * data ;
    T_MFW_WIN * win;


    if( own_window )
    {
        TRACE_FUNCTION ("MmiTimeDate:date_time_edt_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_tida_edt *)win->user;

        if( data )
        {
            win_delete (data->tida_edt_win);
            FREE_MEMORY((void *)data,(sizeof(T_tida_edt)));
        }
    }
}
/*******************************************************************************

 $Function:  tida_main  

 $Description:	 main dialog function for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void tida_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;//tida main data
    T_tida_edt * tida_edt_data = (T_tida_edt *) parameter;//tida editor data
    T_MFW_HND tida_edt_win;
    T_DISPLAY_DATA display_info;

    TRACE_FUNCTION("MmiTimeDate:tida_main");

    switch( event )
    {
    case DATE_SHOW:
        tida_data->state = DATE_SHOW;
        tida_data->display_id1 = TxtEnterDate;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        if( tida_edt_win )
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case DATE_ENTRY:
        tida_data->state = DATE_ENTRY;
        tida_data->display_id1 = TxtEnterDate;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case TIME_ENTRY:
        tida_data->state = TIME_ENTRY;
        tida_data->display_id1 = TxtEnterTime;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case TIME_SHOW:
        tida_data->state = TIME_SHOW;
        tida_data->display_id1 = TxtEnterTime;
        tida_edt_win = date_time_edt_create(tida_data->tida_win);
        if( tida_edt_win )
        {
            SEND_EVENT(tida_edt_win,event,0,tida_data);
        }
        break;
    case ENTRY_OK:
        dialog_info_init(&display_info);//gdy add
        display_info.TextId = TxtSaved;
        display_info.TextId2 = 0;
        display_info.TextString = 0;
        display_info.TextString2 = 0;
        display_info.LeftSoftKey = 0;
        display_info.RightSoftKey = 0;
        display_info.Time = THREE_SECS;
        display_info.KeyEvents = KEY_ALL;
        display_info.Identifier = SAVED;
        display_info.Callback = (T_VOID_FUNC)tida_info_cb;
        info_dialog(tida_data->tida_win,&display_info); /* information screen "Saved" */
        break;
    case SAVED:
    case TIDA_ABORT:
    case TIDA_CLEAR:
    case TIDA_TO_IDLE:
        date_time_destroy(tida_data->tida_win);
        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:  tida_info_cb  

 $Description:	 callback function from info dialog for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
void tida_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;

    TRACE_FUNCTION ("MmiTimeDate: tida_info_cb");

    switch( identifier )
    {
    case SAVED:
        SEND_EVENT(tida_data->tida_win,identifier,0,NULL);
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:  tida_win_cb  

 $Description:	 windows main callback function for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int tida_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    TRACE_FUNCTION ("MmiTimeDate: tida_win_cb");
    if( event EQ MfwWinVisible )
    {
        /*
         * Top Window has no output
         */
        dspl_ClearAll();
        return 1;
    }
    return 0;
}
/*******************************************************************************

 $Function:  tida_edt_win_cb  

 $Description:	 windows callback function for editor for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int tida_edt_win_cb  (T_MFW_EVENT event,T_MFW_WIN * win)
{


    T_tida_edt * edt_data = (T_tida_edt *)win->user;//tida edt data
    T_MFW_WIN * win_tida =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_tida     * tida_data = (T_tida *)win_tida->user; // tida main data
    //nm  T_DateTime currentTime;
    char lin1[MAX_LEN_DATE];
    char lin2[MAX_LEN_TIME];
    //nm  memset(lin1, '\0', sizeof(lin1));
    //nm  memset(lin2, '\0', sizeof(lin2));


    TRACE_FUNCTION ("MmiTimeDate:tida_edt_win_cb");

    if( event EQ MfwWinVisible )
    {
        dspl_ClearAll();
        PROMPT(DATE_TEXT_X,DATE_TEXT_Y,0,tida_data->display_id1);
        displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SZIE==3)
		draw_softkeybar_leftright_arrow();//jhxu720
#endif
        if( tida_data->state EQ DATE_SHOW )
        {
            if( (DateTimeEntryMode == SETTING) || (FFS_flashData.alarm_day == 0) )
            {
                if( currdate.day == 0 ) //if no date set
                    sprintf(lin1,"dd/mm/yyyy");
                else
                    sprintf(lin1,"%02d/%02d/%04d",currdate.day,currdate.month,currdate.year);
            }
            else
                sprintf(lin1,"%02d/%02d/%04d",FFS_flashData.alarm_day,FFS_flashData.alarm_month,FFS_flashData.alarm_year);

            strncpy(edt_data->edtbuf1,lin1,MAX_LEN_DATE);
            edtShow(edt_data->editor_handle);
        }
        else if( tida_data->state EQ DATE_ENTRY )
        {
            if( (DateTimeEntryMode == SETTING) || (FFS_flashData.alarm_day == 0) )
            {
                if( currdate.day == 0 )
                    sprintf(lin1,"dd/mm/yyyy");//if no date set
                else
                    sprintf(lin1,"%02d/%02d/%04d",currdate.day,currdate.month,currdate.year);
            }
            else
                sprintf(lin1,"%02d/%02d/%04d",FFS_flashData.alarm_day,FFS_flashData.alarm_month,FFS_flashData.alarm_year);  
            strncpy(edt_data->edtbuf1,lin1,MAX_LEN_DATE);
            edt_data->index = 0;
            edtShow(edt_data->editor_handle);
            CLEAR_BOTTOM_ZONE
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
			draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
        }
        else if( tida_data->state EQ TIME_ENTRY )
        {
            if( (DateTimeEntryMode == SETTING) || (FFS_flashData.alarm_day==0) )
                sprintf(lin2,"%02d:%02d",currclock.hour, currclock.min);
            else if( DateTimeEntryMode == BACKLIGHTONTIME )//zy add 04/08/02
                sprintf(lin2,"%02d:%02d",FlashSettingData.backlight_on_time_hour, FlashSettingData.backlight_on_time_minute);
            else if( DateTimeEntryMode == BACKLIGHTOFFTIME )
                sprintf(lin2,"%02d:%02d",FlashSettingData.backlight_off_time_hour, FlashSettingData.backlight_off_time_minute);//end of zy change 04/08/02
            else
                sprintf(lin2,"%02d:%02d",FFS_flashData.alarm_hour, FFS_flashData.alarm_minute);
            strncpy(   edt_data->edtbuf1,lin2,MAX_LEN_TIME);
            edt_data->index = 0;
            edtShow(edt_data->editor_handle);
            CLEAR_BOTTOM_ZONE
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
			draw_softkeybar_fourdirection_arrow();//jhxu720 add
#endif
        }
        else if( tida_data->state EQ TIME_SHOW )
        {
            if( (DateTimeEntryMode == SETTING) || (FFS_flashData.alarm_day == 0) )
                sprintf(lin2,"%02d:%02d",currclock.hour, currclock.min);
            else
                sprintf(lin2,"%02d:%02d",FFS_flashData.alarm_hour, FFS_flashData.alarm_minute);
            strncpy(edt_data->edtbuf1,lin2,MAX_LEN_TIME);
            edtShow(edt_data->editor_handle);
        }
        return 1;
    }
    return 0;

}
/*******************************************************************************

 $Function:  tida_editor  

 $Description:	 dialog function for editor for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void tida_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida_edt * edt_data = (T_tida_edt *)win_data->user;


    T_tida * tida_data = (T_tida *)parameter;//tida main data

    edt_data->state = tida_data->state;

    TRACE_FUNCTION("MmiTimeDate:tida_editor");

    /*
     * depending on event
     */
    switch( event )
    {
    case DATE_SHOW:
    case TIME_SHOW:
        memset(edt_data->edtbuf1, '\0', sizeof(edt_data->edtbuf1));/* initial buffer  */
        edt_data->index = 0;
        winShow(edt_data->tida_edt_win);
        break;
    case DATE_ENTRY:
    case TIME_ENTRY:
        winShow(edt_data->tida_edt_win);
        break;
    default:
        break;
    }
}
/*******************************************************************************

 $Function:  tida_edt_kbd_cb  

 $Description:	 keyboard event handler for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int tida_edt_kbd_cb (MfwEvt e, MfwKbd *kc)
{

    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida_edt * edt_data = (T_tida_edt *)win_data->user;//tida edt data

    T_MFW_WIN * win_tida =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_tida * tida_data = (T_tida *)win_tida->user; // tida main data

    //nm T_DateTime currentTime;
    char lin1[MAX_LEN_DATE];
    char lin2[MAX_LEN_TIME];
    //nm   memset(lin1, '\0', sizeof(lin1));/* initial string  */
    //nm   memset(lin2, '\0', sizeof(lin2));

    TRACE_FUNCTION ("MmiTimeDate: tida_edt_kbd_cb");

    switch( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        if( edt_data->state EQ DATE_ENTRY )                  /* date entering            */
        {
            if( edt_data->index < (MAX_LEN_DATE - 1) )
            {
                if( (edt_data->index NEQ 2) && (edt_data->index NEQ 5) )
                {
                    edt_data->edtbuf1[edt_data->index] = '0' + kc->code;
                    edtChar(edt_data->editor_handle,edt_data->edtbuf1[edt_data->index]);
                    edt_data->index++;
                }

                if( (edt_data->index EQ 2) || (edt_data->index EQ 5) )
                {
                    edtChar(edt_data->editor_handle,'/');
                    edt_data->edtbuf1[edt_data->index] = '/';
                    edt_data->index++;
                }
            }
        }
        else if( edt_data->state EQ TIME_ENTRY )             /* time entering            */
        {
            if( edt_data->index < (MAX_LEN_TIME -1) )
            {
                if( edt_data->index NEQ 2 )
                {
                    edt_data->edtbuf1[edt_data->index] = '0' + kc->code;
                    edtChar(edt_data->editor_handle,edt_data->edtbuf1[edt_data->index]);
                    edt_data->index++;
                }
                if( edt_data->index EQ 2 )
                {
                    edtChar(edt_data->editor_handle,':');
                    edt_data->edtbuf1[edt_data->index] = ':';
                    edt_data->index++;
                }
            }
        }
        break;
    case KCD_LEFT:                                 /* select and ok button */
        if( edt_data->state EQ DATE_ENTRY )
        {
            if( check_date(win,edt_data) )
            {

                TRACE_EVENT("datecheck ok");
                edtClear(edt_data->editor_handle);
                edtHide(edt_data->editor_handle);   /* verification date successfull */
                date_time_edt_destroy(edt_data->tida_edt_win);
                SEND_EVENT(tida_data->tida_win,TIME_ENTRY,0,tida_data);

            }
            else
            {
                memset(edt_data->edtbuf1, '\0', sizeof(edt_data->edtbuf1));/* initial buffer  */
                edt_data->index = 0;

                //sprintf(lin1,"%02d/%02d/%04d",currdate.month,currdate.day,currdate.year);
                sprintf(lin1,"dd/mm/yyyy");
                strncpy(edt_data->edtbuf1,lin1,MAX_LEN_DATE);
                edtReset(edt_data->editor_handle);
                edtShow(edt_data->editor_handle);
            }
        }
        else if( edt_data->state EQ TIME_ENTRY )
        {
            if( check_time(win,edt_data) )
            {
                TRACE_EVENT("timecheck ok");
                edtClear(edt_data->editor_handle);
                edtHide(edt_data->editor_handle);   /* verification date successfull */
                date_time_edt_destroy(edt_data->tida_edt_win);
                SEND_EVENT(tida_data->tida_win,ENTRY_OK,0,tida_data);
            }
            else
            {
                memset(edt_data->edtbuf1, '\0', sizeof(edt_data->edtbuf1));/* initial buffer  */
                edt_data->index = 0;

                sprintf(lin2,"%02d:%02d",currclock.hour, currclock.min);
                strncpy(edt_data->edtbuf1,lin2,MAX_LEN_TIME);
                edtReset(edt_data->editor_handle);
                edtShow(edt_data->editor_handle);
            }
        }
        else if( edt_data->state EQ DATE_SHOW )
        {
            date_time_edt_destroy(edt_data->tida_edt_win);
            SEND_EVENT(tida_data->tida_win,DATE_ENTRY,0,tida_data);
        }                                   /* start date entering      */

        else if( edt_data->state EQ TIME_SHOW )
        {
            date_time_edt_destroy(edt_data->tida_edt_win);
            SEND_EVENT(tida_data->tida_win,TIME_ENTRY,0,tida_data);     /* start time entering      */
        }
        break;
    case KCD_RIGHT:                                /* back to previous menu */
        date_time_edt_destroy(edt_data->tida_edt_win);
        SEND_EVENT(tida_data->tida_win,TIDA_ABORT,0,tida_data);
        break;
    case KCD_MNUUP:                                /* cursor to right  */
        if( (edt_data->state EQ DATE_ENTRY) || (edt_data->state EQ TIME_ENTRY) )    /* cursor to rigt           */
        {
            edt_data->index++;
            edtChar(edt_data->editor_handle,ecRight);

            if( ((edt_data->state EQ DATE_ENTRY) && ((edt_data->index EQ 2)||(edt_data->index EQ 5))) || ((edt_data->state EQ TIME_ENTRY) && (edt_data->index EQ 2)) )
            {
                edt_data->index++;
                edtChar(edt_data->editor_handle,ecRight);
            }

        }
        break;
    case KCD_HUP:
    case KCD_MNUDOWN:                            /* cursor to left or clear  */
        if( (!(edt_data->state EQ DATE_SHOW)) && (!(edt_data->state EQ TIME_SHOW)) )
        {
            if( edt_data->state EQ DATE_ENTRY )
            {
                if( edt_data->index EQ 0 )
                    ;
                else
                    edt_data->index--;

                if( (edt_data->index EQ 2)||(edt_data->index EQ 5) )
                {
                    if( edt_data->index EQ 0 )
                        ;
                    else
                        edt_data->index--;

                    edtChar(edt_data->editor_handle,ecLeft);
                    edtChar(edt_data->editor_handle,ecLeft);
                }
                else
                    edtChar(edt_data->editor_handle,ecLeft);
            }
            if( edt_data->state EQ TIME_ENTRY )
            {
                if( edt_data->index EQ 0 )
                    ;
                else
                    edt_data->index--;

                if( edt_data->index EQ 2 )
                {
                    if( edt_data->index EQ 0 )
                        ;
                    else
                        edt_data->index--;

                    edtChar(edt_data->editor_handle,ecLeft);
                    edtChar(edt_data->editor_handle,ecLeft);
                }
                else
                    edtChar(edt_data->editor_handle,ecLeft);
            }
        }
        else
            timStart(edt_data->tim_out_handle); /* waiting for release clear  otherwise to previous screen */
        break;
    default:
        return MFW_EVENT_CONSUMED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:  check_date  

 $Description:	 check date after date entering

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int check_date (T_MFW_HND win, void * edt_dat)
{
    U8 i;
    T_tida_edt * edt_data = (T_tida_edt *)edt_dat;
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;
    Date tempdate;

    char internday[3];
    char internmonth[3];
    char internyear[5];

    char debug[20];

    TRACE_FUNCTION ("MmiTimeDate:check_date");

    memset(internday, '\0', sizeof(internday));/* initial string  */
    memset(internmonth, '\0', sizeof(internmonth));
    memset(internyear, '\0', sizeof(internyear));

    internday[0] = edt_data->edtbuf1[0];
    internday[1] = edt_data->edtbuf1[1];
    internmonth[0] = edt_data->edtbuf1[3];
    internmonth[1] = edt_data->edtbuf1[4];
    for( i = 0;i<4;i++ )
    {
        internyear[i] = edt_data->edtbuf1[6+i];
    }

    tempdate.month = atoi(internmonth);
    if( (tempdate.month > 12) || (tempdate.month < 1) )
        return FALSE;

    tempdate.day = atoi(internday);
    if( (tempdate.day > 30) || (tempdate.day < 1) )
    {
        if( tempdate.day EQ 31 )
        {
            switch( tempdate.month )
            {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                break;
            default:
                return FALSE;

            }
        }
        else
            return FALSE;
    }

    tempdate.year = atoi(internyear);

    if( tempdate.year < 2000 )
        return FALSE;

    if( (tempdate.month EQ 2) && (tempdate.day EQ 29) )
    {
        if( !(tempdate.year%4) || (tempdate.year EQ 2000) )
        {
            if( DateTimeEntryMode == ALARM )
            {
                FFS_flashData.alarm_day = tempdate.day;
                FFS_flashData.alarm_month = tempdate.month;
                FFS_flashData.alarm_year = tempdate.year;
                flash_write();  // zgz, 2002.8.15 just only write alarm setting to flash
            }
            else
            {
                FFS_flashData.current_day = tempdate.day;
                FFS_flashData.current_month = tempdate.month;
                FFS_flashData.current_year = tempdate.year;
                currdate.day = tempdate.day;
                currdate.month = tempdate.month;
                currdate.year = tempdate.year;
            }
            //flash_write();
            updateRtcDate(tempdate);
            return TRUE;
        }
        else
            return FALSE;
    }
    else
    {
        if( DateTimeEntryMode == ALARM )
        {


            FFS_flashData.alarm_day = tempdate.day;
            FFS_flashData.alarm_month = tempdate.month;
            FFS_flashData.alarm_year = tempdate.year;
            flash_write();  // zgz, 2002.8.15 just only write alarm setting to flash
        }
        else
        {
            FFS_flashData.current_day = tempdate.day;
            FFS_flashData.current_month = tempdate.month;
            FFS_flashData.current_year = tempdate.year;             
            currdate.day = tempdate.day;
            currdate.month = tempdate.month;
            currdate.year = tempdate.year;
        }
        //flash_write();
        updateRtcDate(tempdate);

        return TRUE;
    }
}
/*******************************************************************************

 $Function:  check_time  

 $Description:	check time after time entering

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int check_time (T_MFW_HND win, void * edt_dat)
{
    T_tida_edt * edt_data = (T_tida_edt *)edt_dat;
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida * tida_data = (T_tida *)win_data->user;
    CLOCK tempclock;
    char debug[50];
    char internmin[3];
    char internhour[3];

    memset(internmin, '\0', sizeof(internmin));/* initial string  */
    memset(internhour, '\0', sizeof(internhour));

    internhour[0] = edt_data->edtbuf1[0];
    internhour[1] = edt_data->edtbuf1[1];
    internmin[0] = edt_data->edtbuf1[3];
    internmin[1] = edt_data->edtbuf1[4];

    tempclock.hour = atoi(internhour);
    if( tempclock.hour > 23 )
        return FALSE;

    tempclock.min = atoi(internmin);
    if( tempclock.min >59 )
        return FALSE;
    if( DateTimeEntryMode == ALARM )
    {
        FFS_flashData.alarm_hour = tempclock.hour;      
        FFS_flashData.alarm_minute = tempclock.min;
    }
    else
        /*...........zy change for backlight on/off time .....................*/
        if( DateTimeEntryMode == BACKLIGHTONTIME )
    {
        FlashSettingData.backlight_on_time_hour = tempclock.hour;       
        FlashSettingData.backlight_on_time_minute = tempclock.min;
    }
    else
        if( DateTimeEntryMode == BACKLIGHTOFFTIME )
    {
        FlashSettingData.backlight_off_time_hour = tempclock.hour;      
        FlashSettingData.backlight_off_time_minute = tempclock.min;
    }
    /*.......... end of .zy change for backlight on/off time .....................*/
    else
    {
        FFS_flashData.current_hour = tempclock.hour;        
        FFS_flashData.current_minute = tempclock.min;

        currclock.hour = tempclock.hour;
        currclock.min = tempclock.min;
        //zgz,2002.8.15 ClockSet(&currclock);
    }
    updateRtcClock(tempclock);
    flash_write();
    return TRUE;
}
/*******************************************************************************

 $Function:  tida_edt_tim_out_cb  

 $Description:	 Callback function for timer for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void tida_edt_tim_out_cb(T_MFW_EVENT event,T_MFW_TIM * t)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida_edt * tida_edt_data = (T_tida_edt *)win_data->user;

    T_MFW_WIN * win_tida =((T_MFW_HDR *)tida_edt_data->parent_win)->data;
    T_tida * tida_data = (T_tida *)win_tida->user; // tida main data

    date_time_edt_destroy(tida_edt_data->tida_edt_win);
    SEND_EVENT(tida_data->tida_win,TIDA_CLEAR,0,tida_data);

}
/*******************************************************************************

 $Function:  tida_edt_kbd_long_cb  

 $Description:	 keyboard long event handler for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static int tida_edt_kbd_long_cb (MfwEvt e, MfwKbd *kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_tida_edt * edt_data = (T_tida_edt *)win_data->user;//tida edt data

    T_MFW_WIN * win_tida =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_tida * tida_data = (T_tida *)win_tida->user; // tida main data

    TRACE_FUNCTION("MmiTimeDate:tida_edt_kbd_long_cb");

    if( (e & KEY_CLEAR) && (e & KEY_LONG) )
    {

        if( (!(edt_data->state EQ DATE_SHOW)) && (!(edt_data->state EQ TIME_SHOW)) )
        {

            if( edt_data->state EQ DATE_ENTRY )
            {
                date_time_edt_destroy(edt_data->tida_edt_win);
                SEND_EVENT(tida_data->tida_win,DATE_SHOW,0,tida_data);
            }
            else if( edt_data->state EQ TIME_ENTRY )
            {
                date_time_edt_destroy(edt_data->tida_edt_win);

                SEND_EVENT(tida_data->tida_win,TIME_ENTRY,0,tida_data);

            }
            return MFW_EVENT_CONSUMED;

        }
        else
        {
            timStop(edt_data->tim_out_handle);
            date_time_edt_destroy(edt_data->tida_edt_win);
            SEND_EVENT(tida_data->tida_win,TIDA_TO_IDLE,0,tida_data);
            return MFW_EVENT_CONSUMED;
        }
    }
    else
        return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:  reset_edt_attr_sett  

 $Description:	 initialize editor buffer for time and date

 $Returns:		none.

 $Arguments:	
 
*******************************************************************************/
static void reset_edt_attr_sett(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                                U8 *controls, char *text,U16 size,MfwEdtAttr* attr)
{

    attr->win.px = winPx;
    attr->win.py = winPy;
    attr->win.sx = winSx;
    attr->win.sy = winSy;
    attr->fgColor = fgColor;
    attr->font = font;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
}

static void updateRtcDate(Date newDate)  // zgz,2002.8.15 Mobile Innovation
{
    T_RTC_DATE_TIME rtcTime;

    RTC_GetDateTime(&rtcTime);
    rtcTime.day = newDate.day;
    rtcTime.month = newDate.month;
    rtcTime.year = newDate.year - 2000;

    RTC_SetDateTime(rtcTime);
}

static void updateRtcClock(CLOCK newClock)  // zgz,2002.8.15 Mobile Innovation
{
    T_RTC_DATE_TIME rtcTime;

    RTC_GetDateTime(&rtcTime);
    rtcTime.hour= newClock.hour;
    rtcTime.minute= newClock.min;

    RTC_SetDateTime(rtcTime);
}
#endif
