#ifndef _DEF_MMI_TIMEDATE_H_
#define _DEF_MMI_TIMEDATE_H_

/*******************************************************************************

					CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		MMI
 $File:		    MmiTimeDate.h
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This provides the root mofule for the basic MMI
                        
********************************************************************************
 $History: MmiTimeDate.h

  04/08/02       zy Mobile Innovation add for backlighton/off time fuctions
	   
  *zgz, 2002.8.15 set the follow function to static	   
 $End

*******************************************************************************/
#include "mfw_ffs.h"


#define ALLOC_MEMORY mfwAlloc
#define FREE_MEMORY  mfwFree


								          
/* REASONS                  */
typedef enum
{
	DATE_SHOW = TimeDateDummy,
	TIME_SHOW,
	DATE_ENTRY,
	TIME_ENTRY,
	ENTRY_OK,
	SAVED,
	TIDA_ABORT,
	TIDA_CLEAR,
	TIDA_TO_IDLE
}
DAT_TIME_CASE;


                                        /* PROTOTYPES               */
//menu handler functions                                        
int alarmTimeDate(MfwMnu* m, MfwMnuItem* i);
int settingsTimeDate(MfwMnu* m, MfwMnuItem* i);
int settingBacklighOnTime(MfwMnu* m, MfwMnuItem* i);//zy add 04/08/02
int settingBacklighOffTime(MfwMnu* m, MfwMnuItem* i);//zy add 04/08/02
int clear_alarm(MfwMnu* m, MfwMnuItem* i);
int twelve_hour_clock(MfwMnu* m, MfwMnuItem* i);
int twentyfour_hour_clock(MfwMnu* m, MfwMnuItem* i);
void alarm_check();
void set_latest_alarm();
int AutoPowerOn(void);
void AutoPower_Cb (void* parameter);
void alarm_destroy(T_MFW_HND own_window);


void tida_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons);
/* zgz, 2002.8.15 set the follow function to static
void date_time_edt_destroy  (T_MFW_HND own_window);
T_MFW_HND date_time_edt_create(T_MFW_HND parent_window);
void date_time_destroy  (T_MFW_HND own_window);
T_MFW_HND date_time_create (T_MFW_HND parent_window);

*/

#endif

