/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   VOICEMEMO
 $File:       MmiVoiceMemo.c
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       09/04/01

********************************************************************************

 Description:

    This provides the start code for the MMI

********************************************************************************
 $History: MmiVoiceMemo.c

  09/04/01      Original Condat(UK) BMI version.

 $End

*******************************************************************************/




/*******************************************************************************

                                Include files

*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"
#include "cus_aci.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_cphs.h"
#include "mfw_sat.h"

#include "dspl.h"


#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiIdle.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiSettings.h"

#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiResources.h"


#include "vmd.h"
#include "MmiVoiceMemo.h"
#include "mfw_ffs.h"
#include "Rtc_api.h"
#include "mmibookshared.h"

/*2004/05/18 yhf add */
//#include "mmiicndialogs.h" 
// 2004 WYJ add for record
//#include "mmiicnother.h"
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */
extern const unsigned char gImage_bar[];


//#include "mmibookmenuwindow.h"

#ifndef _SIMULATION_
EXTERN UBYTE vmd_stop_voice_memo_recording  (void);
#endif
/*******************************************************************************

                                internal data

*******************************************************************************/


// Internal events

#define VM_INIT             500

#define VM_DESTROY         501
#define VM_PLAY             502
#define VM_RECORD          503
#define VM_DELETE_BUFFER  504

#define VM_BROWSER        505
#define VM_DELETE          506
#define VM_RECORDCALL     507

#define VOICE_MEMORY_FULL  10

/* glowing: add the following event define for fix the bug that
   it can't record if disconnected
 */
#define MAX_RECORD_SECONDS	30
static U8 recordcall_completed;





static T_MFW_HND dynamic_Phonebook_win;
static UINT8 needback=0;
static UINT8 playneedback=0;
static UINT8 playover=1;
extern UINT32 driverFlag;//yq added for don't keybeep 2003/1/20
extern T_call call_data;
typedef struct
{
    U8 voicename[PHB_name_len];
    U8 index;
} T_voice_name;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       info_win;
    T_MFW_HND       info_tim;
    T_MFW_HND    animation_timer;/*2004/05/19, yhf add*/   
    T_MFW_HND       info_kbd;
    T_MFW_HND       menu_options_win;
    USHORT          Identifier;
    USHORT          time;
    char             elapsed_time[7];
    ListMenuData      *menu_list_data;  
    U8               index;
    U8           current_frame;/*2004/05/19, yhf add*/ 
} T_voice_memo;

static T_voice_name ListName[VM_file];
static signed char sort_List[VM_file];//yq added for sort voicememo record 2003/1/27
U8                ListTotal;
T_MFW_HND        VoiceMemoWin=0;
static T_MFW_HND PlayVoiceMWin=0;
U8                Select_index;

static MfwMnuAttr voicelist_menuAttrib =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};




// this keeps always the position of the voicememo buffer
// it tells the remaining time for the recording
//USHORT record_position;


/*******************************************************************************

                                Local prototypes

*******************************************************************************/
T_MFW_HND        voice_memo_start  (T_MFW_HND  parent_win, SHORT ID);
static T_MFW_HND   voice_memo_create (T_MFW_HND  parent_win);
void          voice_memo_destroy  (T_MFW_HND  own_window);
static void          voice_memo_dialog (T_MFW_HND  win, USHORT event, SHORT value, void * parameter);
static int           voice_memo_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_CB    voice_memo_tim_cb (T_MFW_EVENT event, T_MFW_TIM * tc);
static T_MFW_CB    voice_memo_tim_animation_cb(T_MFW_EVENT event, T_MFW_TIM * tc);/*2004/05/19	yhf modify*/
static int           voice_memo_kbd_cb (T_MFW_EVENT event, T_MFW_KBD * keyboard);
void               voice_memo_dialog_cb (T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void          VmRecordCB (void* parameter);
static void          voice_delete_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);

static T_MFW_HND   GetVoiceMenuWindow();
static void          SetVoiceMenuWindow(T_MFW_HND win);
static void          voice_Information_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void          voicememoRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static T_MFW_HND   voice_play_create (T_MFW_HND parent_win);
static void          voice_play_destroy (T_MFW_HND own_window);
static int           voice_play_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_CB    voice_play_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);
static int           voice_play_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
static void          voice_play_dialog (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void       SortVoiceMemo();
/*******************************************************************************

 $Function:     voice_memo_init

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/
GLOBAL void voice_memo_init (void)
{
    TRACE_FUNCTION ("voice_memo_init()");

}

/*******************************************************************************

 $Function:     voice_memo_exit

 $Description:


 $Returns:

 $Arguments:

*******************************************************************************/
GLOBAL void voice_memo_exit (void)
{
    TRACE_FUNCTION ("voice_memo_exit()");

    //vmd_exit ();
}




/*******************************************************************************

 $Function:     voice_memo_play

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/
/*
GLOBAL int  voice_memo_play (MfwMnu* m, MfwMnuItem* i)
{
  T_MFW_HND win = mfw_parent(mfw_header());

  TRACE_FUNCTION ("voice_memo_play()");

  //create a new voice memo dialog
  voice_memo_start (win, VM_PLAY);

}
*/

/*******************************************************************************

 $Function:     voice_memo_start

 $Description:  create a new voicememo dialog

 $Returns:    Dialogue info win

 $Arguments:  parent win, display info

*******************************************************************************/
T_MFW_HND voice_memo_start (T_MFW_HND  parent_win, SHORT ID)
{
    T_MFW_HND win;

    if( ID==VM_RECORD||ID==VM_RECORDCALL )
        driverFlag|=0x0001;
    win = voice_memo_create (parent_win);

    if( win NEQ NULL )
    {
        if( ID==VM_BROWSER )
            SetWindowsHandle(win);
        SEND_EVENT (win, ID, NULL, NULL);
    }
    if( call_data.win )
    {
        call_data.win_voicerecord=win;//zy 2003-04-01 when start in call win should set this data
    }
    return win;
}
/*******************************************************************************

 $Function:     vocie_memo_create

 $Description:  Creation of window

 $Returns:    Dialogue info win

 $Arguments:  parent win

*******************************************************************************/
static T_MFW_HND voice_memo_create (T_MFW_HND parent_win)
{
    T_MFW_WIN     * win_data;
    T_voice_memo *  data = (T_voice_memo *)ALLOC_MEMORY (sizeof (T_voice_memo));

    TRACE_FUNCTION ("vocie_memo_create()");

    data->info_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)voice_memo_win_cb);

    if( data->info_win EQ 0 ) return 0;

    // Create window handler  
    data->mmi_control.dialog   = (T_DIALOG_FUNC)voice_memo_dialog;
    data->mmi_control.data     = data;
    data->parent_win           = parent_win;
    win_data                   = ((T_MFW_HDR *)data->info_win)->data;
    win_data->user             = (void *)data;

    data->info_tim = tim_create (data->info_win, 1000, (T_MFW_CB)voice_memo_tim_cb);
    data->animation_timer= tim_create (data->info_win, 500, (T_MFW_CB)voice_memo_tim_animation_cb);/*2004/05/19 yhf modify*/
    data->info_kbd = kbd_create (data->info_win, KEY_ALL, (T_MFW_CB)voice_memo_kbd_cb);
    dynamic_Phonebook_win=data->info_win;

    return data->info_win;
}


/*******************************************************************************

 $Function:     voice_memo_destroy

 $Description:  Destruction of an dialog

 $Returns:    void

 $Arguments:  win

*******************************************************************************/
void voice_memo_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    T_voice_memo   * data   = (T_voice_memo *)win->user;

    TRACE_FUNCTION ("voice_memo_destroy()");

    if( data )
    {
        if( call_data.win_voicerecord&&call_data.win )
        {
            call_data.win_voicerecord=0;//zy 2003-04-01 set this data to zero
        }
        kbd_delete (data->info_kbd);
        tim_delete(data->animation_timer);/*2004/05/19 yhf */   
        tim_delete (data->info_tim);        
        win_delete (data->info_win);
        data->info_win=0;

        if( (data->Identifier==VM_RECORD)||(data->Identifier==VM_RECORDCALL) )
            SetVoiceMenuWindow(0);
        if( data->Identifier==VM_BROWSER )
            ClearWindowHandle();
        driverFlag&=0xfffffffe;
        // Free Memory     
        needback=0;
        FREE_MEMORY ((void *)data, sizeof (T_voice_memo));
    }
}



/*******************************************************************************

 $Function:     voice_memo

 $Description:  Dialog function for voice memo dialog

 $Returns:    void

 $Arguments:  win, window handle event, value, parameter

*******************************************************************************/
/*
void voice_memo_dialog (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
  T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
  T_voice_memo    * data         = (T_voice_memo *)win_data->user;

    T_DISPLAY_DATA display_info;

  data->Identifier = value;

  TRACE_FUNCTION ("voice_memo()");

  switch (event)
  {
    case VM_INIT:    	
    {
          TRACE_EVENT ("VM_INIT()");           
          // Create timer and keyboard handler
       
        data->info_tim = tim_create (win, 1000, (T_MFW_CB)voice_memo_tim_cb);
        data->info_kbd = kbd_create (win, KEY_ALL, (T_MFW_CB)voice_memo_kbd_cb);

          switch ( value )
          {
            case VM_PLAY:
            {
                 TRACE_EVENT ("VM_PLAY()");

               //check the voicememo buffer
              if (FFS_flashData.voice_memo_position EQ 0)
              {
                display_info.KeyEvents   = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = '\0';
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     = TxtRecording;
                display_info.TextId      = TxtEmpty;
                display_info.Time       = THREE_SECS;
                display_info.Callback    = (T_VOID_FUNC)voice_memo_dialog_cb;
                   
                // Call Info Screen			           
                info_dialog (win, &display_info);
              }
               else
               {
                 //start the second timer
                 data->time = 0;
                 tim_start (data->info_tim);

                 //start playback
                 //csf_vm_play(0);
                 StartPlayVmRecord();
               } 
            }	
            break;
            case VM_RECORD:
            {
                 TRACE_FUNCTION ("VM_RECORD()");

              if (FFS_flashData.voice_memo_position >= VOICE_MEMORY_FULL)
              {
                TRACE_EVENT ("memory full ");

                //play Keybeep
                audio_PlaySoundID(0, TONES_KEYBEEP, 200, 0 );

                display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
                display_info.LeftSoftKey  = '\0';
                display_info.RightSoftKey = '\0';
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.TextId2     =TxtRecording;
                display_info.TextId      = TxtFull;
                display_info.Time       = THREE_SECS;
                display_info.Callback     = (T_VOID_FUNC)voice_memo_dialog_cb;			          
                // Call Info Screen
                    
                info_dialog (win, &display_info);
              }
              else
              {
                //start the second timer
                data->time = 0;
                tim_start (data->info_tim);
                TRACE_EVENT("Start Record");
                //start the record
                
                StartVmRecord(VmRecordCB,"/vmrecord");
                //csf_vm_record_2 (FFS_flashData.voice_memo_position);
              }
            }	
            break;
            default: break;
          }           
          win_show (win);
    }
    break;  
    case VM_DELETE_BUFFER://if the user selected to clear the Voicememo buffer
    {
         display_info.KeyEvents    = KEY_CLEAR | KEY_RIGHT | KEY_LEFT;
         display_info.LeftSoftKey  = '\0';
         display_info.RightSoftKey = '\0';
         display_info.TextString   = '\0';
         display_info.TextString2  = '\0';
         display_info.TextId2     = 0;
         display_info.Time       = THREE_SECS;
         display_info.TextId     = TxtDeleted;
         display_info.Callback     = (T_VOID_FUNC)voice_memo_dialog_cb;	      
         // Call Info Screen	       
         info_dialog (win, &display_info);
    }
    break;
    case VM_DESTROY:
    {
          voice_memo_destroy(win);
    }      
    break;
    default: break;
  }
}
*/
/*******************************************************************************

 $Function:     voice_memo_win_cb

 $Description:  Callback function for information dialog

 $Returns:    void

 $Arguments:  window handle event, win
*******************************************************************************/
static int voice_memo_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_voice_memo * data = (T_voice_memo *)win->user;
    UINT32 f_color;
    TRACE_FUNCTION ("voice_memo_win_cb()");


    if( data EQ 0 ) return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        {
            if( win->flags & E_WIN_VISIBLE )
            {
                dspl_ClearAll();//Clear Screen
                sprintf(data->elapsed_time,"%02d sec", data->time); 

                if( data->Identifier==VM_RECORD || data->Identifier==VM_RECORDCALL )
                {
					// Print the information screen     
                    draw_special_background();/*2004/1/19, wangyan modify*/
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)					
					DRAW_ICON_SEL(ICON_RECORDICON,data->time%3);//콨
#endif
#if(MAIN_LCD_SIZE==4)
                    DRAW_ICON_SEL(ICON_VOICEMEMO_WIN, 0);
#endif
                    DRAW_ICON_SEL(ICON_VOICEMEMO_WIN, 1);

                    //               ALIGNED_PROMPT(LEFT,Mmi_layout_first_line(),0, TxtRecording);            
                    ALIGNED_PROMPT(CENTER,8,DSPL_TXTATTR_TRANSPARENT, TxtRecording);            
                    // Print the elapsed time             
                    //displayAlignedText(LEFT, Mmi_layout_second_line(), 0, data->elapsed_time);     
                    displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time);     
                    //              dspl_BitBlt(5, 80, 110, 20,0, (void *)record_bmp, 0);
                    // Print softkeys             
                    displaySoftKeys(TxtStop, TxtCancel);   

                }
                else if( data->Identifier==VM_RECORDCALL )
                {
                    draw_special_background();/*2004/1/19, wangyan modify*/
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)					
					DRAW_ICON_SEL(ICON_RECORDICON,data->time%3);//콨
#endif
#if(MAIN_LCD_SIZE==4)
                    DRAW_ICON_SEL(ICON_VOICEMEMO_WIN, 0);
#endif
                    DRAW_ICON_SEL(ICON_VOICEMEMO_WIN, 1);

                    //    ALIGNED_PROMPT(LEFT,Mmi_layout_first_line(),0, TxtRecording);            
                    ALIGNED_PROMPT(CENTER,8,DSPL_TXTATTR_TRANSPARENT, TxtRecording);            
                    //          displayAlignedText(LEFT, Mmi_layout_second_line(), 0, data->elapsed_time);  
                    displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time);  
                    //          dspl_BitBlt(5, 80, 110, 20,0, (void *)record_bmp, 0);
                    displaySoftKeys(TxtStop, TxtCancel);   
                }

/*#if(MAIN_LCD_SIZE==3)//jhxu720
				if (needback)
				{
					needback=0;
					displaySoftKeys(TxtSave, TxtSoftBack);
					f_color=dspl_SetBkgColor(0xFFA402);
					dspl_fill_rectangle(7,83,7+data->time*5,88);
					dspl_SetBkgColor(f_color);
				}
                
#elif(MAIN_LCD_SIZE==4)*/
			if( needback )
                {
                    needback=0;
                    displaySoftKeys(TxtSave, TxtSoftBack);
                    /*               f_color=dspl_SetBkgColor(0xFFA402);
                    dspl_fill_rectangle(7,83,7+data->time*5,88);
                    dspl_SetBkgColor(f_color);*/
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
					DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
					DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 52, 2, ICON_LOCATION);
#endif
                }	
//#endif
            }
        }      
        break;
    default:
		return 0;
    }
    return 1;
}

/* 2004/05/18 yhf modify */
static T_MFW_CB voice_memo_tim_animation_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_voice_memo   * data = (T_voice_memo *)win_data->user;


    timStop(data->animation_timer);
    timStart(data->animation_timer);

    if( data->current_frame < 3 )
    {
        data->current_frame++;
    }
    else
    {
        data->current_frame = 0;
    }
#if(MAIN_LCD_SIZE==4)
    DRAW_ICON_SEL(ICON_VOICEMEMO_ANIM, data->current_frame%3);
#endif

    /*
    switch(data->current_frame%3)
    {
    case 0:
        dspl_BitBlt(75, 68, 17, 27, 0, (void *)memo_animation1, 0);
        break;
    case 1:
        dspl_BitBlt(75, 68, 17, 27, 0, (void *)memo_animation2, 0);  		
        break;
    case 2:
        dspl_BitBlt(75, 68, 17, 27, 0, (void *)memo_animation3, 0);  		
        break;
    }
    */
}

/*******************************************************************************

 $Function:     voice_memo_tim_cb

 $Description:  Callback function for the voice_memo timer.


 $Returns:    MFW event handler

 $Arguments:  window handle event, timer control block

*******************************************************************************/
static T_MFW_CB voice_memo_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_voice_memo   * data = (T_voice_memo *)win_data->user;

    T_RTC_DATE_TIME   T_DateTime;

    char buf[40];
    UINT32 f_color;

    TRACE_FUNCTION ("voice_memo_tim_cb()");
    if( !winIsFocussed(win) )
    {
        StopVmRecord(VmRecordCB);
        needback=1;
        return;
    }
    switch( data->Identifier )
    {
    case VM_RECORD:
        {  
            TRACE_EVENT("glowing: voice_memo_tim_cb -- enter VM_RECORD");
            data->time++;
            //if (data->time < 20)
            if( data->time == MAX_RECORD_SECONDS )
            {
                /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 27, 2, ICON_LOCATION);
#endif           
			}

            if( data->time < MAX_RECORD_SECONDS )
            {
                TRACE_EVENT("glowing: voice_memo_tim_cb -- enter VM_RECORD 1");
                /* 2004/05/18 yhf modify */
#if ( MAIN_LCD_SIZE==2 )	
                // 2004.3.16 WYJ modify icon display
                dspl_BitBlt(recordIcons[data->time%6].area.px, recordIcons[data->time%6].area.py, recordIcons[data->time%6].area.sx, 
                            recordIcons[data->time%6].area.sy, 0, (void *)recordIcons[data->time%6].icons, 0);

                dspl_BitBlt(0, 51, 102, 14, 0, (void *)gImage_bar, 0);
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, 52, DSPL_TXTATTR_TRANSPARENT, data->elapsed_time);
#endif
                sprintf(data->elapsed_time,"%02d sec", data->time); 

#if (MAIN_LCD_SIZE==3)
				DRAW_ICON_SEL(ICON_RECORDICON,data->time%3);//콨
#endif	
#if(MAIN_LCD_SIZE==4)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 27, 2, ICON_LOCATION);
#endif				
				displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time);

                tim_start (data->info_tim);
            }
			else
            {
                TRACE_EVENT("glowing: voice_memo_tim_cb -- enter VM_RECORD 2");

                StopVmRecord(VmRecordCB);

                /* 2004/05/18 yhf modify */
#if ( MAIN_LCD_SIZE==2 )	
                // 2004.3.16 WYJ modify icon display
                dspl_BitBlt(recordIcons[data->time%6].area.px, recordIcons[data->time%6].area.py, recordIcons[data->time%6].area.sx, 
                            recordIcons[data->time%6].area.sy, 0, (void *)recordIcons[data->time%6].icons, 0);

                dspl_BitBlt(0, 51, 102, 14, 0, (void *)gImage_bar, 0);
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, 52, DSPL_TXTATTR_TRANSPARENT, data->elapsed_time);
#endif

                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time); 


                tim_stop (data->info_tim);
                tim_stop (data->animation_timer);/* 2004/05/18 yhf add */


                if( RTC_GetDateTime(&T_DateTime)==RV_OK )
                {
                    memcpy(FFS_VMData.VM[data->index].vm_name,vm_name[data->index],PHB_name_len);
                    /* glowing: add the record time from 20 seconds to 30 seconds */
                    //FFS_VMData.VM[data->index].length=data->time+1>20?20:data->time+1;
                    FFS_VMData.VM[data->index].length=data->time+1>MAX_RECORD_SECONDS?MAX_RECORD_SECONDS:data->time+1;
                    FFS_VMData.VM[data->index].hour         =T_DateTime.hour;
                    FFS_VMData.VM[data->index].minute       =T_DateTime.minute;
                    FFS_VMData.VM[data->index].day          =T_DateTime.day;
                    FFS_VMData.VM[data->index].year         =T_DateTime.year;
                    FFS_VMData.VM[data->index].month        =T_DateTime.month;
                    FFS_VMData.VM[data->index].PM_flag       =T_DateTime.PM_flag;
                    FFS_VMData.VM[data->index].mode_12_hour =T_DateTime.mode_12_hour;
                    flash_VMwrite("VM");

                    bookShowInformation( win, TxtAddSucceed, NULL,(T_VOID_FUNC)voice_Information_cb);//¼ɹ 
                }
                else
                {
                    //read rtc error!                
                }  
            }            
        }  
        break;
    case VM_RECORDCALL:
        {      
            TRACE_EVENT("glowing: voice_memo_tim_cb -- enter VM_RECORDCALL");
            data->time++; 
            TRACE_EVENT_P1("glowing: voice_memo_tim_cb -- data->time=%d", data->time);

            //         if (data->time < 20)
            if( data->time == MAX_RECORD_SECONDS )
            {
                /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 27, 2, ICON_LOCATION);
#endif	
                //dspl_BitBlt(19+3*(data->time-1), 55, 3, 5, 0, (void *)record_play, 0);/* 2004/05/18 yhf modify */		 
            }
            if( data->time < MAX_RECORD_SECONDS )
            {
                // 2004.4.24 WYJ modify icon display
                if( data->time < MAX_RECORD_SECONDS )
                {
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
					DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
					DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 27, 2, ICON_LOCATION);
#endif	
                    //dspl_BitBlt(19+3*(data->time-1), 55, 3, 5, 0, (void *)record_play, 0);
                }
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time); 
                tim_start (data->info_tim);

                recordcall_completed = false; /* glowing: add it to fix the record call bug */
            }
            else
            {
                TRACE_EVENT("glowing: voice_memo_tim_cb -- enter VM_RECORDCALL -- 2");

                StopVmRecord(VmRecordCB);
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time); 

                tim_stop (data->info_tim);
                tim_stop (data->animation_timer);
                /*end yhf modify*/

                if( RTC_GetDateTime(&T_DateTime)==RV_OK )
                {
                    memcpy(FFS_VMData.VM[data->index].vm_name,vm_name[data->index],PHB_name_len);
                    //FFS_VMData.VM[data->index].length=data->time+1>20?20:data->time+1;
                    FFS_VMData.VM[data->index].length=data->time+1>MAX_RECORD_SECONDS?MAX_RECORD_SECONDS:data->time+1;
                    FFS_VMData.VM[data->index].hour         =T_DateTime.hour;
                    FFS_VMData.VM[data->index].minute       =T_DateTime.minute;
                    FFS_VMData.VM[data->index].day          =T_DateTime.day;
                    FFS_VMData.VM[data->index].year=T_DateTime.year;
                    FFS_VMData.VM[data->index].month        =T_DateTime.month;
                    FFS_VMData.VM[data->index].PM_flag       =T_DateTime.PM_flag;
                    FFS_VMData.VM[data->index].mode_12_hour =T_DateTime.mode_12_hour;
                    flash_VMwrite("VM");

                    bookShowInformation( win, TxtAddSucceed, NULL,(T_VOID_FUNC)voice_Information_cb);//¼ɹ 
                }
                else
                {
                    //read rtc error!                
                }  
                recordcall_completed = true; /* glowing: add it to fix the record call bug */
            }            
        }
        break;
    default: break;
    }

    TRACE_EVENT("glowing: voice_memo_tim_cb -- leave voice_memo_tim_cb");


    //winShow(win);
    return 0;
}


/*******************************************************************************

 $Function:     voice_memo_kbd_cb

 $Description:  Keyboard event handler

 $Returns:    status int

 $Arguments:  window handle event, keyboard control block

*******************************************************************************/

static int voice_memo_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)win)->data;
    T_voice_memo     * data = (T_voice_memo *)win_data->user;
    USHORT           Identifier = data->Identifier;
    T_RTC_DATE_TIME   T_DateTime;

    char buf[40];


    TRACE_FUNCTION("voice_memo_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_HUP:
    case KCD_RIGHT:

        if( Identifier EQ VM_RECORD )
        {
            StopVmRecord(VmRecordCB); 
            SEND_EVENT (win, VM_DESTROY, 0, 0);
        }
        else if( Identifier EQ VM_RECORDCALL )
        {
            StopVmRecord(VmRecordCB); 
            SEND_EVENT (win, VM_DESTROY, 0, 0); 
            recordcall_completed = true; /* glowing: add it to fix the record call bug */
        }

        break; 
    case KCD_LEFT:
    case KCD_OK:
        {
            StopVmRecord(VmRecordCB);
            tim_stop (data->info_tim);
            tim_stop (data->animation_timer);/* 2004/05/19 yhf add*/        

            if( RTC_GetDateTime(&T_DateTime)==RV_OK )
            {
                memcpy(FFS_VMData.VM[data->index].vm_name,vm_name[data->index],PHB_name_len);
                if( data->Identifier==VM_RECORD )
                    //FFS_VMData.VM[data->index].length=(data->time+1)>20?20:(data->time+1);
                    FFS_VMData.VM[data->index].length=(data->time+1)>MAX_RECORD_SECONDS?MAX_RECORD_SECONDS:(data->time+1);
                else if( data->Identifier==VM_RECORDCALL )
                    //FFS_VMData.VM[data->index].length=data->time+1>20?20:data->time+1;
                    FFS_VMData.VM[data->index].length=data->time+1>MAX_RECORD_SECONDS?MAX_RECORD_SECONDS:data->time+1;
                FFS_VMData.VM[data->index].hour         =T_DateTime.hour;
                FFS_VMData.VM[data->index].minute       =T_DateTime.minute;
                FFS_VMData.VM[data->index].day          =T_DateTime.day;
                FFS_VMData.VM[data->index].year     =T_DateTime.year;
                FFS_VMData.VM[data->index].month        =T_DateTime.month;
                FFS_VMData.VM[data->index].PM_flag       =T_DateTime.PM_flag;
                FFS_VMData.VM[data->index].mode_12_hour =T_DateTime.mode_12_hour;
                flash_VMwrite("VM");

                bookShowInformation( win, TxtAddSucceed, NULL,(T_VOID_FUNC)voice_Information_cb);//¼ɹ 
            }
            else
            {
                //read rtc error!                
            }
        }
        recordcall_completed = true; /* glowing: add it to fix the record call bug */
        break;    
    default:break;
    }
    return MFW_EVENT_CONSUMED;
}

static void VmRecordCB (void* parameter)
{
    playover=1;
    rvf_free_buf (parameter); 
    return;
}

GLOBAL int voice_memo_browser (MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());

    TRACE_FUNCTION ("voice_memo_Browser()");  

    voice_memo_start (win, VM_BROWSER);
    return ;
}

GLOBAL int voice_memo_record (MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());


    TRACE_FUNCTION ("voice_memo_record()");

    voice_memo_start (win, VM_RECORD);
    return ;
}

#if 0
GLOBAL int voice_memo_DeleteAll (MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND win = mfw_parent(mfw_header());
    U8         j;

    TRACE_FUNCTION ("voice_memo_DeleteAll()");

    for( j=0;j<VM_file;j++ )
    {
        if( FFS_VMData.VM[j].vm_name[0]!='\0' )
        {
            FFS_VMData.VM[j].vm_name[0]='\0';
            FFS_VMData.VM[j].month=0;
            FFS_VMData.VM[j].day=0;
            FFS_VMData.VM[j].year=0;
            FFS_VMData.VM[j].hour=0;
            FFS_VMData.VM[j].minute=0;    
            FFS_VMData.VM[j].length=0;
        }
    }
    flash_VMwrite("VM");
    bookShowInformation( win, TxtDeleted, NULL,NULL);
    return;
}
#endif

/* 2003/10/29, wangyan, modify dialog delete style*/
static T_MFW_HND Voicememo_create(MfwHnd parent_window)
{
    T_VOICEMEMO_INFO * data = (T_VOICEMEMO_INFO *)ALLOC_MEMORY (sizeof(T_VOICEMEMO_INFO));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    data->recentvoice_win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->recentvoice_win EQ NULL )
    {
        return NULL;
    }

    data->mmi_control.dialog = (T_DIALOG_FUNC)NULL;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->recentvoice_win)->data;
    win->user                = (T_VOICEMEMO_INFO *)data;
    data->parent         = parent_window;

    return data->recentvoice_win;
}

void Voicememo_destroy(MfwHnd win)
{
    T_MFW_WIN * win_data;
    T_VOICEMEMO_INFO   * data ;

    if( win )
    {
        win_data = ((T_MFW_HDR *)win)->data;
        if( win_data != NULL )
            data = ( T_VOICEMEMO_INFO   *)win_data->user;

        if( data )
        {
            TRACE_FUNCTION ("Voicememo_destroy()");

            win_delete (data->recentvoice_win);
            FREE_MEMORY (( void *)data, sizeof( T_VOICEMEMO_INFO));
        }
        else
        {
            TRACE_EVENT ("Voicememo_destroy() called twice");
        }
    }
}
static int Voicememo_delete_OK_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    U8         j;
    switch( Reason )
    {
    case INFO_KCD_LEFT:
        for( j=0;j<VM_file;j++ )
        {
            if( FFS_VMData.VM[j].vm_name[0]!='\0' )
            {
                FFS_VMData.VM[j].vm_name[0]='\0';
                FFS_VMData.VM[j].month=0;
                FFS_VMData.VM[j].day=0;
                FFS_VMData.VM[j].year=0;
                FFS_VMData.VM[j].hour=0;
                FFS_VMData.VM[j].minute=0;    
                FFS_VMData.VM[j].length=0;
            }
        }
        flash_VMwrite("VM");
        bookShowInformation( win, TxtDeleted, NULL,NULL);
        Voicememo_destroy(win);
        break;

    case INFO_KCD_RIGHT: 
    case INFO_KCD_HUP:
    case INFO_TIMEOUT:
        Voicememo_destroy(win);
        break;
    }
    return MFW_EVENT_CONSUMED;
}

GLOBAL int voice_memo_DeleteAll (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       parent        = mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;
    T_MFW_HND win = Voicememo_create(parent);
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    T_VOICEMEMO_INFO   *data       = (T_VOICEMEMO_INFO *) win_data->user;
    U8         j,voicejudge=0;

    TRACE_FUNCTION ("voice_memo_DeleteAll()");

    for( j=0;j<VM_file;j++ )
    {
        if( FFS_VMData.VM[j].vm_name[0]!='\0' )
        {
            voicejudge=1;
        }
    }

    dialog_info_init(&display_info);

    if( voicejudge==1 )
    {
        display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT|KEY_HUP;
        display_info.TextId2       = TxtOkToDelete;
        display_info.LeftSoftKey  = TxtSoftOK;  
        display_info.RightSoftKey = TxtSoftBack; 
        display_info.Time         = FOREVER;
        display_info.iconindex=REMIND_REQUIRE;  
        display_info.Callback     = (T_VOID_FUNC) Voicememo_delete_OK_cb;
    }
    else
    {
        display_info.KeyEvents    = KEY_LEFT|KEY_RIGHT;
        display_info.TextId2      = TxtNorecord;
        display_info.LeftSoftKey  = 0;
        display_info.RightSoftKey = 0;
        display_info.iconindex=REMIND_NORECORD;  
        display_info.Time=FOREVER;
        display_info.Callback     = (T_VOID_FUNC) Voicememo_delete_OK_cb;
    }

    info_dialog( win, &display_info );
    return MFW_EVENT_CONSUMED;
}
/* 2003/10/29, wangyan, modify dialog delete style*/



GLOBAL int voice_memo_Memory (MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND win = mfw_parent(mfw_header());
    char              Buffer1[32];
    int              j;
    int          ListTotal=0;
    T_DISPLAY_DATA  display_info;



    TRACE_FUNCTION ("voice_memo_Memory()"); 

    //flash_VMread("VM");

    for( j=0;j<VM_file;j++ )
    {
        if( strlen((char *)FFS_VMData.VM[j].vm_name)!=0 )
            ListTotal=ListTotal+1;
    }
    memset( Buffer1,0, 32);
    sprintf(Buffer1,"%d/%d",ListTotal,VM_file);
    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    =  KEY_RIGHT|KEY_CLEAR;
    display_info.TextId       = ListTotal;
    display_info.TextId2      = 0;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time         =FOREVER;
    display_info.Callback     = NULL;
    display_info.Identifier   = 701;//MMI_VOICEMEMO_MEMORYSTATE

    info_dialog( win, &display_info );

    return ;
}
/*******************************************************************************

 $Function:     voice_memo

 $Description:  Dialog function for voice memo dialog

 $Returns:    void

 $Arguments:  win, window handle event, value, parameter

*******************************************************************************/
void voice_memo_dialog (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
    T_voice_memo    * data         = (T_voice_memo *)win_data->user;

    T_DISPLAY_DATA display_info;

    U8              i;
    char            * titleStr;
    char            temp[100];
    char            NewVoiceMemo[PHB_name_len];

    T_RTC_DATE_TIME   T_DateTime;

    if( event!=VM_DESTROY )
        data->Identifier = event;
    TRACE_FUNCTION ("voice_memo_dialog()");

    switch( event )
    {
    case VM_BROWSER:       
        {
            ListTotal=0;  
            SortVoiceMemo();
            for( i=0;i<VM_file;i++ )
            {
                if( sort_List[i]!=-1 )
                {
                    sprintf(temp,"vm_name:%s",FFS_VMData.VM[sort_List[i]].vm_name);
                    TRACE_EVENT(temp);
                    if( FFS_VMData.VM[sort_List[i]].mode_12_hour==TRUE )
                    {
                        if( FFS_VMData.VM[sort_List[i]].PM_flag==TRUE )
                        {
                            /* glowing: change the display format 2003-10-23*/ 
                            /*
                             sprintf((char *)ListName[ListTotal].voicename,"%02d:%02dP %2d/%02d/%02d",
                                     FFS_VMData.VM[sort_List[i]].hour,
                                     FFS_VMData.VM[sort_List[i]].minute,
                                     FFS_VMData.VM[sort_List[i]].year,
                                     FFS_VMData.VM[sort_List[i]].month,
                                     FFS_VMData.VM[sort_List[i]].day);
                            */
                            sprintf((char *)ListName[ListTotal].voicename,"%02d/%02d,%02d:%02dP",
                                    FFS_VMData.VM[sort_List[i]].month,
                                    FFS_VMData.VM[sort_List[i]].day,
                                    FFS_VMData.VM[sort_List[i]].hour,
                                    FFS_VMData.VM[sort_List[i]].minute
                                   );

                            ListName[ListTotal].index=sort_List[i];
                        }
                        else
                        {
                            /* glowing: change the display format 2003-10-23*/ 
                            /*
                            sprintf((char *)ListName[ListTotal].voicename,"%02d:%02dA %2d/%02d/%02d",
                                    FFS_VMData.VM[sort_List[i]].hour,
                                    FFS_VMData.VM[sort_List[i]].minute,
                                    FFS_VMData.VM[sort_List[i]].year,
                                    FFS_VMData.VM[sort_List[i]].month,
                                    FFS_VMData.VM[sort_List[i]].day);
                            */
                            sprintf((char *)ListName[ListTotal].voicename,"%02d/%02d,%02d:%02dA",
                                    FFS_VMData.VM[sort_List[i]].month,
                                    FFS_VMData.VM[sort_List[i]].day,
                                    FFS_VMData.VM[sort_List[i]].hour,
                                    FFS_VMData.VM[sort_List[i]].minute
                                   );


                            ListName[ListTotal].index=sort_List[i];
                        }                
                    }
                    else
                    {
                        /* glowing: change the display format 2003-10-23*/ 
                        /*
                        sprintf((char *)ListName[ListTotal].voicename,"%02d:%02d %2d/%02d/%02d",
                                FFS_VMData.VM[sort_List[i]].hour,
                                FFS_VMData.VM[sort_List[i]].minute,
                                FFS_VMData.VM[sort_List[i]].year,
                                FFS_VMData.VM[sort_List[i]].month,
                                FFS_VMData.VM[sort_List[i]].day);
                        */
                        sprintf((char *)ListName[ListTotal].voicename,"%02d/%02d,%02d:%02d",//jhxu82
                                FFS_VMData.VM[sort_List[i]].month,
                                FFS_VMData.VM[sort_List[i]].day,
                                FFS_VMData.VM[sort_List[i]].hour,
                                FFS_VMData.VM[sort_List[i]].minute
                               );

                        ListName[ListTotal].index=sort_List[i];
                        TRACE_EVENT("voicename");
                        TRACE_EVENT((char *)ListName[ListTotal].voicename);
                        Sprintf(temp,"listtotal:%d,index:%d",ListTotal,ListName[ListTotal].index);
                        TRACE_EVENT(temp);
                    }
                    ListTotal=ListTotal+1;                      
                }
                else
                    break;
            }  

            /*2004/02/24,talcon add*/
            if( ListTotal == 0 )
            {
                T_DISPLAY_DATA display_info;
                voice_memo_destroy(win);
                dialog_info_init(&display_info);
                //display_info.KeyEvents    = KEY_OK | KEY_RIGHT | KEY_LEFT | KEY_HUP ;
                display_info.LeftSoftKey  = '\0';
                //display_info.RightSoftKey = TxtSoftBack;
                //display_info.TextString   = '\0';
                //display_info.TextString2  = '\0';
                display_info.TextId2      = TxtNorecord;
                //display_info.TextId       = '\0';
                display_info.Time         = 500;
                display_info.iconindex    = REMIND_NORECORD;
                //display_info.Callback     = (T_VOID_FUNC)tida_dialog_cb;
                /*
                * Call Info Screen
                */
                info_dialog(0, &display_info);
                break;
            }//end if

            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                bookShowInformation( win, TxtEmptyList, NULL,(T_VOID_FUNC)voice_Information_cb);//ڴ޹        	          	  
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( ListTotal *sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < ListTotal; i++ )
                    {
                        /* glowing: change the display format 2003-10-23*/ 
                        //data->menu_list_data->List[i].icon = 0;                  
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_LISTCOMMON, 0);//&colist;    /* 2004/06 sunsj modify for icon manage */
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit = 0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].func = NULL;   
                        data->menu_list_data->List[i].str=(char *)ListName[i].voicename;                                                                                               
                        data->menu_list_data->List[i].flagFunc=item_flag_none;
                    }

                    data->menu_list_data->ListLength     = ListTotal;
                    sprintf(temp,"tempindex:%d",(int *)parameter);              
                    TRACE_EVENT(temp);
                    sprintf(temp,"tempindex2:%d",(int) parameter);
                    TRACE_EVENT(temp);


                    data->menu_list_data->SnapshotSize  = ListTotal;
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &voicelist_menuAttrib;            
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;       
                    /* glowing: modify TxtSearchName to TxtBrowse */
                    //titleStr=MmiRsrcGetText(TxtSearchName);
                    titleStr=MmiRsrcGetText(TxtBrowse);
                    data->menu_list_data->ListMenuHeadStr=titleStr;
                    if( (int)parameter!=0 )
                    {
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        data->menu_list_data->ListPosition    = 1;               
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                    }                                                     
                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)voicememoRead_cb,0);                                                                                                                     
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, (T_VOID_FUNC)voice_Information_cb);//Ϊ޷ռ	                              
                }                             
            }                   
        } 
        break;
    case VM_PLAY:
        {
            data->time = 0;
            tim_start (data->info_tim);
            tim_start(data->animation_timer);/*2004/05/19 yhf add*/

            StartPlayVmRecord(VmRecordCB,ListName[Select_index].voicename);         
        } 
        break;    
    case VM_RECORD:
        {       
            for( i=0;i<VM_file;i++ )
            {
                if( FFS_VMData.VM[i].vm_name[0]=='\0' )
                {
                    memset(NewVoiceMemo,'\0',PHB_name_len);
                    strcpy(NewVoiceMemo,"/voicememory/");    /* 2004/04/22 sunsj modify */
                    strcat(NewVoiceMemo,vm_name[i]);
                    /*2004/05/18 sunsj remove*/
                    //sprintf(temp,"vm_name:%s",NewVoiceMemo);
                    //TRACE_EVENT(temp);
                    data->index=i;
                    break;                
                }
            }
            //if (strlen((char *)NewVoiceMemo)!=0)

            if( i<VM_file )
            {
                data->time=0;
                tim_start (data->info_tim);  
                tim_start(data->animation_timer);/* 2004/05/19 yhf modify*/         
                StartVmRecord(VmRecordCB,NewVoiceMemo);
                sprintf(data->elapsed_time,"%02d sec", data->time);
                SetVoiceMenuWindow(win);
                winShow(win);
            }
            else bookShowInformation( win, TxtCapacityFull, NULL,(T_VOID_FUNC)voice_Information_cb);//¼     	   	    	
        }
        break;
    case VM_RECORDCALL:
        TRACE_EVENT("glowing: voice_memo_dialog -- begin VM_RECORDCALL");
        {
            for( i=0;i<VM_file;i++ )
            {
                if( FFS_VMData.VM[i].vm_name[0]=='\0' )
                {
                    memset(NewVoiceMemo,'\0',PHB_name_len);
                    strcpy(NewVoiceMemo,"/voicememory/");    /* 2004/04/22 sunsj modify */
                    strcat(NewVoiceMemo,vm_name[i]);
                    sprintf(temp,"glowing: voice_memo_dialog-vm_name:%s",NewVoiceMemo);
                    TRACE_EVENT(temp);
                    data->index=i;
                    break;                
                }
            }
            //if (strlen((char *)NewVoiceMemo)!=0)

            if( i<VM_file )
            {
                data->time=0;
                tim_start (data->info_tim); 
                tim_start(data->animation_timer);/* 2004/05/19 yhf add*/
                TRACE_EVENT("glowing: voice_memo_dialog -- before StartVmRecord");
                StartVmRecord(VmRecordCB,NewVoiceMemo);
                sprintf(data->elapsed_time,"%02d sec", data->time);
                SetVoiceMenuWindow(win);
                winShow(win);
            }
            else bookShowInformation( win, TxtCapacityFull, NULL,(T_VOID_FUNC)voice_Information_cb);//¼     	   	    	
        }

        TRACE_EVENT("glowing: voice_memo_dialog -- end VM_RECORDCALL");
        break;

        /* glowing: add the following event define for fix the bug that
           it can't record if disconnected
         */
    case VM_SAVERECORDCALL:
        TRACE_EVENT("glowing: voice_memo_dialog -- enter VM_SAVERECORDCALL");

        if( recordcall_completed )
            break;


        StopVmRecord(VmRecordCB);
        tim_stop (data->info_tim);
        tim_stop (data->animation_timer);/*2004/05/19 yhf add*/         

        if( RTC_GetDateTime(&T_DateTime)==RV_OK )
        {
            TRACE_EVENT_P1("glowing: voice_memo_dialog -- data->time=%d", data->time);
            memcpy(FFS_VMData.VM[data->index].vm_name,vm_name[data->index],PHB_name_len);
            //FFS_VMData.VM[data->index].length=data->time+1>20?20:data->time+1;
            FFS_VMData.VM[data->index].length=data->time+1>MAX_RECORD_SECONDS?MAX_RECORD_SECONDS:data->time+1;
            FFS_VMData.VM[data->index].hour         =T_DateTime.hour;
            FFS_VMData.VM[data->index].minute       =T_DateTime.minute;
            FFS_VMData.VM[data->index].day          =T_DateTime.day;
            FFS_VMData.VM[data->index].year     =T_DateTime.year;
            FFS_VMData.VM[data->index].month        =T_DateTime.month;
            FFS_VMData.VM[data->index].PM_flag       =T_DateTime.PM_flag;
            FFS_VMData.VM[data->index].mode_12_hour =T_DateTime.mode_12_hour;
            flash_VMwrite("VM");

            //bookShowInformation( win, TxtAddSucceed, NULL,(T_VOID_FUNC)voice_Information_cb);//¼ɹ 
            bookShowInformation( win, TxtAddSucceed, NULL,NULL );//¼ɹ 
        }
        else
        {
            //read rtc error!                
        }

        TRACE_EVENT("glowing: voice_memo_dialog -- leave VM_SAVERECORDCALL");
        break;
    case VM_DESTROY:
        {       
            TRACE_EVENT("glowing: voice_memo_dialog -- before voice_memo_destry");
            voice_memo_destroy( win ); 
            TRACE_EVENT("glowing: voice_memo_dialog -- after voice_memo_destry");
        } 
        break;
    default: break;
    }
}

static void voice_Information_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{   
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
    T_voice_memo    * data         = (T_voice_memo *)win_data->user; 

    TRACE_FUNCTION ("voice_information_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT:   
        {                                     
            voice_memo_destroy( win );
        }      
        break;                                                   
    default: break;
    }
}

/*******************************************************************************
                                                                              
                                Public Methods
                                                                              
*******************************************************************************/
static void voicememoRead_cb(T_MFW_HND * win, ListMenuData * ListData)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
    T_voice_memo    * data         = (T_voice_memo *)win_data->user;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;

    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {
            //SetVoiceMenuWindow(ListData->win);
            Select_index=ListData->CursorPosition;
            data->menu_options_win=bookMenuStart(data->info_win,bookPhonebookVoiceList(), PhbkFromVoiceMemo);
        }
        break;
    case LISTS_REASON_HANGUP:
        //	if(returntoidle())
        break;
    case LISTS_REASON_BACK:
    case LISTS_REASON_CLEAR:
        {
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List, ListTotal*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData)); 
            SEND_EVENT(win, VM_DESTROY, NULL, NULL);    
        }
        break;  
    case LISTS_REASON_UP:
        {
            dataInfo->MenuListsAttr.pageturnindex=((ListData->CursorPosition-1+ListTotal)%ListTotal)+1;
            mnuUp(dataInfo->MenuLists);
            ListData->CursorPosition=(ListData->CursorPosition-1+ListTotal)%ListTotal;
        }
        break;
    case LISTS_REASON_DOWN:
        {
            dataInfo->MenuListsAttr.pageturnindex=((ListData->CursorPosition+1+ListTotal)%ListTotal)+1;
            mnuDown(dataInfo->MenuLists);
            ListData->CursorPosition=(ListData->CursorPosition+1+ListTotal)%ListTotal;
        }
        break;
    default:break;     
    }                              
}

static void SetVoiceMenuWindow(T_MFW_HND win)
{
    VoiceMemoWin=win; 
}

static T_MFW_HND GetVoiceMenuWindow()
{
    return VoiceMemoWin;
}

GLOBAL int voice_memo_play ()
{  
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    T_MFW_HND win;  

    TRACE_FUNCTION ("voice_memo_play()");  

    win=voice_play_create(parent_win);
    PlayVoiceMWin=win;
    SEND_EVENT(win,VM_PLAY, NULL, NULL);
    winShow(win);
    return 0;
}


static void voice_isdelete_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{     
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)dynamic_Phonebook_win)->data;
    T_voice_memo    * data         = (T_voice_memo *)win_data->user;
    TRACE_FUNCTION ("voice_delete_cb()");
    switch( reason )
    {
    
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:

        {         
            //return to menu;

        }      
        break;   
    case INFO_KCD_LEFT:   
        {
            FFS_VMData.VM[ListName[Select_index].index].vm_name[0]='\0';
            FFS_VMData.VM[ListName[Select_index].index].day=0;
            FFS_VMData.VM[ListName[Select_index].index].hour=0;
            FFS_VMData.VM[ListName[Select_index].index].year=0;
            FFS_VMData.VM[ListName[Select_index].index].minute=0;
            FFS_VMData.VM[ListName[Select_index].index].month=0;
            FFS_VMData.VM[ListName[Select_index].index].length=0;
            flash_VMwrite("VM");
            bookShowInformation( win, TxtDeleted, NULL,(T_VOID_FUNC)voice_delete_cb);//ɾɹ
        }
        break;
    default: break;
    }
}

GLOBAL int voice_memo_Delete()
{  
    T_MFW_HND win = mfw_parent(mfw_header());
    T_DISPLAY_DATA Dialog;
    TRACE_FUNCTION ("voice_memo_delete()"); 
    dialog_info_init(&Dialog);//gdy add
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT | KEY_HUP;  /* 2004/06/01 sunsj modify */
    Dialog.TextId     = 0;
    Dialog.TextId2    = TxtPhbkDelMess;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) voice_isdelete_cb;
    Dialog.Identifier   = 0;
    Dialog.iconindex=REMIND_REQUIRE;

    info_dialog( win, &Dialog );




    return 0;
}

static void voice_delete_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{     
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)dynamic_Phonebook_win)->data;
    T_voice_memo    * data         = (T_voice_memo *)win_data->user;
    TRACE_FUNCTION ("voice_delete_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT:   
        {         
            SEND_EVENT(win, E_MNU_ESCAPE, NULL, NULL);
            listsDestroy(data->menu_list_data->win);
            FREE_MEMORY((void *)data->menu_list_data->List,ListTotal *sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
            voice_memo_destroy(dynamic_Phonebook_win);
        }      
        break;                                                   
    default: break;
    }
}


static T_MFW_HND voice_play_create (T_MFW_HND parent_win)
{
    T_MFW_WIN     * win_data;
    T_voice_memo *  data = (T_voice_memo *)ALLOC_MEMORY (sizeof (T_voice_memo));

    TRACE_FUNCTION ("vocie_play_create()");

    data->info_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)voice_play_win_cb);

    if( data->info_win EQ 0 ) return 0;

    // Create window handler  
    data->mmi_control.dialog   = (T_DIALOG_FUNC)voice_play_dialog;
    data->mmi_control.data     = data;
    data->parent_win           = parent_win;
    win_data                   = ((T_MFW_HDR *)data->info_win)->data;
    win_data->user             = (void *)data;

    data->info_tim = tim_create (data->info_win, 1000, (T_MFW_CB)voice_play_tim_cb);
    data->animation_timer= tim_create (data->info_win, 500, (T_MFW_CB)voice_memo_tim_animation_cb);/*2004/05/19 yhf modify*/   
    data->info_kbd = kbd_create (data->info_win, KEY_ALL, (T_MFW_CB)voice_play_kbd_cb);
    driverFlag|=0x0001;   
    return data->info_win;
}

static void voice_play_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    T_voice_memo   * data   = (T_voice_memo *)win->user;

    TRACE_FUNCTION ("voice_play_destroy()");

    if( data )
    {

        kbd_delete (data->info_kbd);
        tim_delete (data->info_tim); 
        tim_delete(data->animation_timer);/*2004/05/19 yhf add*/    
        win_delete (data->info_win);
        data->info_win=0;
        driverFlag&=0xfffffffe; 
        // Free Memory  
        PlayVoiceMWin=0;
        playneedback=0;
        FREE_MEMORY ((void *)data, sizeof (T_voice_memo));
    }
}

static int voice_play_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_voice_memo * data = (T_voice_memo *)win->user;
    UINT32 f_color;
    char temp[100];
    TRACE_FUNCTION ("voice_play_win_cb()");


    if( data EQ 0 ) return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        {
            if( win->flags & E_WIN_VISIBLE )
            {
                dspl_ClearAll();//Clear Screen

                switch( data->Identifier )
                {
                case VM_PLAY:
                    /*2004/05/19 yhf modify*/
#if ( MAIN_LCD_SIZE==2 )
                    {                      
                        // 2004.3.16 WYJ 
                        dspl_ClearAll();
                        draw_special_background();

                        /* title display*/
                        dspl_BitBlt( menuup[FlashSettingData.theme].area.px,menuup[FlashSettingData.theme].area.py,
                                     menuup[FlashSettingData.theme].area.sx,menuup[FlashSettingData.theme].area.sy,
                                     menuup[FlashSettingData.theme].nIcons,menuup[FlashSettingData.theme].icons,0);

                        ALIGNED_PROMPT(CENTER, 0, DSPL_TXTATTR_TRANSPARENT, TxtPlayback);            

                        //bar display
                        dspl_BitBlt(0, 51, 102, 14, 0, (void *)gImage_bar, 0);

                        //icon display
                        dspl_BitBlt(recordIcons[0].area.px, recordIcons[0].area.py, recordIcons[0].area.sx, 
                                    recordIcons[0].area.sy, 0, (void *)recordIcons[0].icons, 0);

                        // Print the elapsed time    
                        sprintf(data->elapsed_time,"%02d sec", data->time); 
                        displayAlignedText(CENTER, 52, DSPL_TXTATTR_TRANSPARENT, data->elapsed_time);

                        // Print softkeys             
                        displaySoftKeys(TxtNull, TxtSoftBack);

                        if( playneedback )
                        {
                            TRACE_EVENT("we draw the regc");
                            playneedback=0;
                            f_color=dspl_SetBkgColor(0x6A66E5);
                            Sprintf(temp,"length:%d,time:%d",FFS_VMData.VM[ListName[Select_index].index].length,data->time);
                            TRACE_EVENT(temp);
                            Sprintf(temp,"select_index:%d",Select_index);
                            TRACE_EVENT(temp);
                            dspl_fill_rectangle(7,83,7+(103/(FFS_VMData.VM[ListName[Select_index].index].length))*data->time,88);
                            dspl_SetBkgColor(f_color);
                        }
                    }
#endif
                    /*2004/05/19 yhf modify*/
                    // Print the information screen  
                    draw_special_background();/*2004/1/19, wangyan modify*/
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)					
					DRAW_ICON_SEL(ICON_RECORDICON,data->time%3);//콨
#endif
#if(MAIN_LCD_SIZE==4)
                    DRAW_ICON_SEL(ICON_VOICEMEMO_WIN, 0);
#endif
                    DRAW_ICON_SEL(ICON_VOICEMEMO_WIN, 1);

                    //ALIGNED_PROMPT(LEFT,Mmi_layout_first_line(),0, TxtPlayback);            
                    ALIGNED_PROMPT(CENTER,8,DSPL_TXTATTR_TRANSPARENT, TxtPlayback);            
                    // Print the elapsed time    
                    sprintf(data->elapsed_time,"%02d sec", data->time); 
                    //displayAlignedText(LEFT, Mmi_layout_second_line(), 0, data->elapsed_time);
                    displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time);
                    // Print softkeys             
                    displaySoftKeys(TxtNull, TxtSoftBack);
                    if( playneedback )
                    {
                        TRACE_EVENT("we draw the regc");
                        playneedback=0; 
                        /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
                        DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
						DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 52, 2, ICON_LOCATION);
#endif
                    }
                    break;                
                }
            }
        }      
        break;
    default:return 0;
    }
    return 1;
}


/*******************************************************************************

 $Function:     voice_memo_tim_cb

 $Description:  Callback function for the voice_memo timer.


 $Returns:    MFW event handler

 $Arguments:  window handle event, timer control block

*******************************************************************************/
static T_MFW_CB voice_play_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_voice_memo   * data = (T_voice_memo *)win_data->user;

    char buf[40];
    int every_length;
    UINT32 f_color;
    TRACE_FUNCTION ("voice_play_tim_cb()");
    if( !winIsFocussed(win) )
    {
        StopPlayVmRecord(VmRecordCB);
        playneedback=1;
        return;
    }
    every_length=103/(FFS_VMData.VM[ListName[Select_index].index].length);
    switch( data->Identifier )
    {
    case VM_PLAY:
        {
            data->time ++;  
            if( data->time  == FFS_VMData.VM[ListName[Select_index].index].length )
            {
                /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 52, 2, ICON_LOCATION);
#endif	
            }
            if( data->time < FFS_VMData.VM[ListName[Select_index].index].length )
            {
                TRACE_EVENT ("continue the second timer");


                /* 2004/05/18 yhf modify */
#if ( MAIN_LCD_SIZE==2 )
                //            f_color=dspl_SetBkgColor(0x6A66E5);
                TRACE_EVENT("now we fill the rect");

                // 2004.3.16 WYJ modify icon display
                dspl_BitBlt(recordIcons[data->time%6].area.px, recordIcons[data->time%6].area.py, recordIcons[data->time%6].area.sx, 
                            recordIcons[data->time%6].area.sy, 0, (void *)recordIcons[data->time%6].icons, 0);

                dspl_BitBlt(0, 51, 102, 14, 0, (void *)gImage_bar, 0);
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, 52, DSPL_TXTATTR_TRANSPARENT, data->elapsed_time);
#endif
                /*2004/05/19 yhf modify*/
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time);
                if( data->time < MAX_RECORD_SECONDS )
                {
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==4)
					DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 55, 2, ICON_LOCATION);
#elif (MAIN_LCD_SIZE==3)
					DRAW_ICON_ATTRIBUTE(ICON_VOICEMEMO_WIN, 19+3*(data->time-1), 52, 2, ICON_LOCATION);
#endif	
                }


                tim_start (data->info_tim);
            }
            else
            {
                if( !playover )
                {
                    StopPlayVmRecord(VmRecordCB);
                    playover=1;
                }
#if ( MAIN_LCD_SIZE==2 )
                //icon display
                dspl_BitBlt(recordIcons[data->time%6].area.px, recordIcons[data->time%6].area.py, recordIcons[data->time%6].area.sx, 
                            recordIcons[data->time%6].area.sy, 0, (void *)recordIcons[data->time%6].icons, 0);

                dspl_BitBlt(0, 51, 102, 14, 0, (void *)gImage_bar, 0);
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, 52, DSPL_TXTATTR_TRANSPARENT, data->elapsed_time);
                //f_color=dspl_SetBkgColor(0x6A66E5);
                //TRACE_EVENT("finish play,fill the last rect");
                //dspl_fill_rectangle(7,83,112,88);
                //dspl_SetBkgColor(f_color);
#endif
                /*2004/05/19 yhf modify*/
                sprintf(data->elapsed_time,"%02d sec", data->time); 
                displayAlignedText(CENTER, Mmi_layout_second_line(), 0, data->elapsed_time);

            }
        }  
        break;   
    default: break;
    }

    //winShow(win);
    return 0;
}

/*******************************************************************************

 $Function:     voice_memo_kbd_cb

 $Description:  Keyboard event handler

 $Returns:    status int

 $Arguments:  window handle event, keyboard control block

*******************************************************************************/

static int voice_play_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)win)->data;
    T_voice_memo     * data = (T_voice_memo *)win_data->user;
    USHORT           Identifier = data->Identifier;


    TRACE_FUNCTION("voice_play_kbd_cb");

    switch( keyboard->code )
    {
    
    case KCD_RIGHT:
    case KCD_HUP:
        {       
            if( Identifier EQ VM_PLAY )
            {
                if( playover==0 )
                {
                    playover=1;
                    StopPlayVmRecord(VmRecordCB); 
                }
                SEND_EVENT (win, VM_DESTROY, NULL, NULL);
            }
        }     
        break;

    default:break;

    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     voice_memo

 $Description:  Dialog function for voice memo dialog

 $Returns:    void

 $Arguments:  win, window handle event, value, parameter

*******************************************************************************/
static void voice_play_dialog (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
    T_voice_memo    * data         = (T_voice_memo *)win_data->user;

    T_DISPLAY_DATA display_info;

    U8              i;
    char            * titleStr;
    char            temp[100];
    char            NewVoiceMemo[PHB_name_len];

    data->Identifier = event;
    TRACE_FUNCTION ("voice_play_dialog()");

    switch( event )
    {
    case VM_PLAY:
        {
            data->time = 0;
            tim_start (data->info_tim);                    
            tim_start(data->animation_timer);                          
            memset(NewVoiceMemo,'\0',PHB_name_len);
            strcpy(NewVoiceMemo,"/voicememory/");  /* 2004/04/22 sunsj modify */
            strcat(NewVoiceMemo,FFS_VMData.VM[ListName[Select_index].index].vm_name);
            /* 2004/05/19 sunsj modify */
            //sprintf(temp,"play voice record:%s;Select_index:%d",NewVoiceMemo,
            //      Select_index);
            //TRACE_EVENT(temp);  
            playover=0;
            StartPlayVmRecord(VmRecordCB,NewVoiceMemo);         
        } 
        break;        
    case VM_DESTROY:
        {       
            voice_play_destroy( win ); 
        } 
        break;
    default: break;
    }
}
//yq added 2003/1/27 for sort voicememo record
static void SortVoiceMemo()
{
    U32 day[VM_file];
    U16 time[VM_file];
    int i,j;
    char temp[100];
    TRACE_FUNCTION("SortVoiceMemo");
    for( j=0;j<VM_file;j++ )
        sort_List[j]=-1;
    for( i=0;i<VM_file;i++ )
    {
        if( strlen((char *)FFS_VMData.VM[i].vm_name)!=0 )
        {
            day[i]=(FFS_VMData.VM[i].year)*10000+(FFS_VMData.VM[i].month)*100+FFS_VMData.VM[i].day;
            Sprintf(temp,"day:%d",day[i]);
            TRACE_EVENT(temp);
            if( FFS_VMData.VM[i].mode_12_hour==FALSE )
            {
                time[i]=(FFS_VMData.VM[i].hour)*100+FFS_VMData.VM[i].minute;
                Sprintf(temp,"time:%d",time[i]);
                TRACE_EVENT(temp);   
            }
            else
            {
                time[i]=(FFS_VMData.VM[i].hour+(FFS_VMData.VM[i].PM_flag)*12)*100+FFS_VMData.VM[i].minute;
            }
        }
        else
        {
            day[i]=0;
            time[i]=0;
        }
    }//now we have gotten enough data for sort,let's go
    for( i=0;i<VM_file; )
    {
        for( j=0;j<VM_file;j++ )
        {
            if( day[j]==0&&time[j]==0 )
                continue;
            TRACE_EVENT("found a record");
            if( sort_List[i]==-1 )
                sort_List[i]=j;
            if( day[j]>day[sort_List[i]] )//we change the sort 
            {
                sort_List[i]=j;
            }
            else if( day[j]==day[sort_List[i]] )
            {
                if( time[j]>time[sort_List[i]] )
                {
                    sort_List[i]=j;
                }
            }
        }
        if( sort_List[i]!=-1 )
        {
            Sprintf(temp,"i:%d",i);
            TRACE_EVENT(temp);
            Sprintf(temp,"sort_list[i]:%d",sort_List[i]);
            TRACE_EVENT(temp);
            day[sort_List[i]]=0;
            time[sort_List[i]]=0;
            i++;
        }
        else
            break;
    }
}
void StopVoiceMemo()
{
    T_MFW_WIN     * win_data ;
    T_voice_memo   * data;
    if( VoiceMemoWin==0&&PlayVoiceMWin==0 )
        return;
    if( VoiceMemoWin )
    {
        win_data= ((T_MFW_HDR *)VoiceMemoWin)->data;
        data= (T_voice_memo *)win_data->user;
        StopVmRecord(VmRecordCB);
        tim_stop (data->info_tim);
        tim_stop (data->animation_timer);   
        needback=1;
    }
    else if( PlayVoiceMWin )
    {
        win_data= ((T_MFW_HDR *)PlayVoiceMWin)->data;
        data= (T_voice_memo *)win_data->user;
        if( playover==0 )
        {
            playover=1;
            StopPlayVmRecord(VmRecordCB); 
        }
        tim_stop(data->info_tim);
        tim_stop (data->animation_timer);   
        playneedback=1;
    }

}
void SaveVoiceMemo()
{
    T_MFW_WIN     * win_data ;
    T_voice_memo   * data; 
    T_RTC_DATE_TIME   T_DateTime;
    if( VoiceMemoWin==0&&PlayVoiceMWin==0 )
        return;
    if( VoiceMemoWin )
    {
        win_data= ((T_MFW_HDR *)VoiceMemoWin)->data;
        data= (T_voice_memo *)win_data->user;
        //StopVmRecord(VmRecordCB);
        //  tim_stop (data->info_tim);

        if( RTC_GetDateTime(&T_DateTime)==RV_OK )
        {
            memcpy(FFS_VMData.VM[data->index].vm_name,vm_name[data->index],PHB_name_len);
            FFS_VMData.VM[data->index].length=data->time+1>20?20:data->time+1;
            FFS_VMData.VM[data->index].hour         =T_DateTime.hour;
            FFS_VMData.VM[data->index].minute       =T_DateTime.minute;
            FFS_VMData.VM[data->index].day          =T_DateTime.day;
            FFS_VMData.VM[data->index].year=T_DateTime.year;
            FFS_VMData.VM[data->index].month        =T_DateTime.month;
            FFS_VMData.VM[data->index].PM_flag       =T_DateTime.PM_flag;
            FFS_VMData.VM[data->index].mode_12_hour =T_DateTime.mode_12_hour;
            flash_VMwrite("VM");
        }
        voice_memo_destroy(VoiceMemoWin);
    }
    else if( PlayVoiceMWin )
    {
        //if(playover==0)
        //{
        //	playover=1;
        //	StopPlayVmRecord(VmRecordCB); 
        //}
        voice_play_destroy(PlayVoiceMWin);
    }
}