#ifndef _DEF_MMI_FFS_H_
#define _DEF_MMI_FFS_H_
#include "Ffs.h"
#ifndef ATBDATA
   #include "ATBData.h"
#endif

typedef struct
{
   UBYTE       ProfileId;                             // Last profile used
   UBYTE       Status;                                // Stores status flags, inc save history, scale images
   UBYTE       no_of_profiles;                           // Number of profiles used

   UBYTE       no_of_history;                         // Number of history entries
   char        History[MAX_HISTORY][CARD_TITLE_MAX_LEN+NUMBER_PADDING+2];     // History card names
   char        HistoryURL[MAX_HISTORY][URL_MAX_LEN+1];         // History URLs
   UBYTE       no_of_bookmarks;                          // Number of bookmarks
   char        Bookmarks[MAX_BOOKMARKS][CARD_TITLE_MAX_LEN+2]; // Bookmark card names
   char        BookmarksURL[MAX_BOOKMARKS][URL_MAX_LEN+1];     // Bookmark URLs

   T_WAP_PROFILE  Profile[MAX_PROFILES];
} FlashDataWap;

extern FlashDataWap  WapData;

//flash access routines
effs_t flash_wap_write();
effs_t flash_wap_read();
effs_t flash_wap_update();
void wapffsfile_init(void);

#endif



