/********************************************************************************
 $History: Suoha_dspl.c
    Date .................. Modification ......................................
    08/14/2002    version 1.1.0 zhangzg 
    08/23/2002    version 1.1.5 zhangzg 
 $End

*******************************************************************************/

#if defined (NEW_FRAME)

   #include "typedefs.h"
   #include "vsi.h"
   #include "pei.h"
   #include "custom.h"
   #include "gsm.h"

#else  /* NEW_FRAME */

   #include "stddefs.h"
   #include "custom.h"
   #include "gsm.h"
   #include "vsi.h"

#endif /* NEW_FRAME */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "mfw_sys.h"
//#include "stddefs.h"
#include "p_sim.h"
#include "cus_aci.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_sat.h"
#include "dspl.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiSoftkeys.h"
#include "MmiIcons.h"
#include "MmiMenu.h"
#include "gdi.h"
#include "Audio.h"
#include "MmiSounds.h"
#include "MmiBookShared.h"

#include "suoha_common.h"
#include "suoha_algri.h"
#include "suoha_dspl.h"
/*****************************************************************

  unicode and AscII char and bmp data

*****************************************************************/


/********************************************************************************

    data definition

*********************************************************************************/
///////////////////////////////////////////
char* opparray[3] = 
{(char*)opp1,(char*)opp2,(char*)opp3};
char* oppintro[3] = {(char*)introopp1, (char*)introopp2, (char*)introopp3}; 
char* oppname[3] = {(char*)name_opp1,(char*)name_opp2, (char*)name_opp3};
extern  UBYTE focus_opp;
extern unsigned long oppmoney[3];
/********************************************************************************



*********************************************************************************/

void Suoha_Display_Start_Picture();
void Suoha_Display_Opponent();
void Suoha_Display_End();

/********************************************************************************

    function definition 

*********************************************************************************/
void PaintBackground(MfwRect rect, U32 color);
void DrawFigure(MfwRect focus_rect, ULONG color); //draw the profiles of focus things of the main window
void DisplayMMFigure(UBYTE num_MM, UBYTE num_preMM); //draw the profile of focus mm
void DisplayName(UBYTE num_MM, USHORT x, USHORT y);


void DisplayOneCard(UBYTE whoturned, USHORT numcard, USHORT card);
void DisplayCard(UBYTE numcard);
void DrawButton(USHORT x, USHORT y, BOOL isSelected);
void DrawHand(USHORT x, USHORT y);

void DisplayText(USHORT X, USHORT y); //display the info about the situation of playing

void MoveCard(UBYTE who, UBYTE whichCard);
void DisplayZone(UBYTE numzone, char* txt, UBYTE attr);
void ClearZone(UBYTE numzone);
void DisplayMainWinTxtZone();
void DrawSelectedButton(USHORT i);
void DisplayDialog(BOOL yesorno);


char* CardRes(USHORT card);
char* CardResGe(USHORT card);
char* CardResShi(USHORT card);


/********************************************************************************



*********************************************************************************/
void PaintBackground(MfwRect rect, U32 color)
{
   U32 oldcolor;
   oldcolor = dspl_SetBkgColor(color);
   dspl_fill_rectangle(rect.px, rect.py, rect.sx+rect.px, rect.sy+rect.py);
   dspl_SetBkgColor(oldcolor);
}
/********************************************************************************


*********************************************************************************/
void DisplayMMFigure(UBYTE num_MM, UBYTE num_preMM)
{   
   U8 uMode,haveMoney;
   U32 oldcolor;
   USHORT i, j;
   MfwRect rect;


   uMode = dspl_Enable(0); 
   if (oppmoney[focus_opp-1]>=100)       //the opponent has money!!		    	
   {
      haveMoney=1;
   } else
   {
      haveMoney=0;              
   }

   rect.px = LEFT_WIDTH_PPMM+WIDTH_PPMM;                    /* clear the old hand and draw the new              */
   rect.py = TOP_PPMM+(num_preMM-1)*INTERVAL_PPMM+(num_preMM-1)*HEIGHT_PPMM-2;
   rect.sx = (LEFT_WIDTH_PPMM+WIDTH_PPMM+1)+9;
   rect.sy = TOP_PPMM+(num_preMM-1)*INTERVAL_PPMM+(num_preMM-1)*HEIGHT_PPMM+13;
   PaintBackground(rect, 0x80ffff);
   DrawHand(LEFT_WIDTH_PPMM+WIDTH_PPMM+2, TOP_PPMM+(num_MM-1)*INTERVAL_PPMM+(num_MM-1)*HEIGHT_PPMM);


   /* set the background color tangyan0303  		*/     
   rect.px = LEFT_OPPTXT; rect.py = TOP_OPPTXT; rect.sx = RIGHT_OPPTXT-LEFT_OPPTXT; rect.sy = BOTTOM_OPPTXT-TOP_OPPTXT;
   dspl_DrawRect(LEFT_OPPTXT-1, TOP_OPPTXT-1, RIGHT_OPPTXT, BOTTOM_OPPTXT);
   PaintBackground(rect, 0xffff80); //ǳɫ


   if (num_MM!=4)                                                                                              /* focus on one of oppnents				*/
   {
      if (haveMoney)                                         /* oppnent has a lot of money 			 */
      {
         dspl_TextOut(60, 5, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, oppname[num_MM-1]);
         for (i=0; i<=6; i++)
         {
            dspl_TextOut(50, 25+16*i, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (oppintro[num_MM-1])+i*10);
         }
      } else
      {
         dspl_TextOut(LEFT_OPPTXT+15, 50, DSPL_TXTATTR_NORMAL | DSPL_TXTATTR_TRANSPARENT, (char *)"NO");
         dspl_TextOut(LEFT_OPPTXT+5, 66, DSPL_TXTATTR_NORMAL | DSPL_TXTATTR_TRANSPARENT, (char *)"Money!");              
      }
   } else                                                    /* display help content!! 	  			  */
   {
      DrawButton(LEFT_OPPTXT+2, TOP_OPPTXT+10, FALSE);
      dspl_BitBlt(LEFT_OPPTXT+2+10, TOP_OPPTXT+10+2, 13, 11, 0, (void *)checkstake, DSPL_BMPCOPY);
      dspl_TextOut(LEFT_OPPTXT+2+WIDTH_BUTTON+1, TOP_OPPTXT+10, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)chakan);

      DrawButton(LEFT_OPPTXT+2, TOP_OPPTXT+10+HEIGHT_BUTTON+1, FALSE);
      dspl_BitBlt(LEFT_OPPTXT+2+11, TOP_OPPTXT+10+HEIGHT_BUTTON+1+2, 11, 11, 0, (void *)putstake, DSPL_BMPCOPY);           
      dspl_TextOut(LEFT_OPPTXT+2+WIDTH_BUTTON+1, TOP_OPPTXT+10+HEIGHT_BUTTON+1, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)xiazhu);

      DrawButton(LEFT_OPPTXT+2, TOP_OPPTXT+10+2*(HEIGHT_BUTTON+1), FALSE);
      dspl_BitBlt(LEFT_OPPTXT+2+12, TOP_OPPTXT+10+2*(HEIGHT_BUTTON+1)+5, 9, 6, 0, (void *)follow, DSPL_BMPCOPY);
      dspl_TextOut(LEFT_OPPTXT+2+WIDTH_BUTTON+1, TOP_OPPTXT+10+2*(HEIGHT_BUTTON+1), DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)genjin);

      DrawButton(LEFT_OPPTXT+2, TOP_OPPTXT+10+3*(HEIGHT_BUTTON+1), FALSE);
      dspl_BitBlt(LEFT_OPPTXT+2+10, TOP_OPPTXT+10+3*(HEIGHT_BUTTON+1)+2, 14, 13, 0, (void *)quitall, DSPL_BMPCOPY);           
      dspl_TextOut(LEFT_OPPTXT+2+WIDTH_BUTTON+1, TOP_OPPTXT+10+3*(HEIGHT_BUTTON+1), DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)fangqi);

      DrawButton(LEFT_OPPTXT+2, TOP_OPPTXT+10+4*(HEIGHT_BUTTON+1), FALSE);
      dspl_BitBlt(LEFT_OPPTXT+2+11,TOP_OPPTXT+10+4*(HEIGHT_BUTTON+1)+1, 10, 15, 0, (void *)allstake, DSPL_BMPCOPY);
      dspl_TextOut(LEFT_OPPTXT+2+WIDTH_BUTTON+1, TOP_OPPTXT+10+4*(HEIGHT_BUTTON+1), DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)quansuo);

      dspl_TextOut(LEFT_OPPTXT+2, TOP_OPPTXT+10+5*(HEIGHT_BUTTON+1), DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)leftselet);
      dspl_TextOut(LEFT_OPPTXT+2, TOP_OPPTXT+10+5*(HEIGHT_BUTTON+1)+16, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)rightquit);
      dspl_TextOut(LEFT_OPPTXT+2, TOP_OPPTXT+10+5*(HEIGHT_BUTTON+1)+16*2, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)updownmove);

   }

   dspl_Enable(uMode); //zhangzg 08/23/2002

}

//4 ʾһ˿
void DisplayOneCard(UBYTE whoturned, USHORT numcard, USHORT  card)
{
   U32 oldcolor;
   char* ge;
   char* shi;

   shi = CardResShi(card);
   ge = CardResGe(card);
   if (shi && ge)
   {
      if (whoturned == COMPUTER) //display the card of machine
      {
         if (numcard==BACKCARD) //display the back of the first card
         {
            dspl_BitBlt(LEFT_WIDTH_CARD, TOP_WIDTH_CARD, 38, 50, 0, (void *)cardback, DSPL_BMPCOPY);
         } else
         {
            oldcolor = dspl_SetFrgColor(0x000000);
            dspl_DrawRect(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD, TOP_WIDTH_CARD, LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+WIDTH_CARD, TOP_WIDTH_CARD+HEIGHT_CARD);
            dspl_SetFrgColor(oldcolor);
            oldcolor = dspl_SetBkgColor(0xffffff);
            dspl_fill_rectangle(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD, TOP_WIDTH_CARD, LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+WIDTH_CARD, TOP_WIDTH_CARD+HEIGHT_CARD);
            dspl_SetBkgColor(oldcolor);
            dspl_BitBlt(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+LEFT_C1, TOP_WIDTH_CARD+TOP_C1, WIDTH_C12, HEIGHT_C12, 0, (void *)ge, 0);
            dspl_BitBlt(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+LEFT_C2, TOP_WIDTH_CARD+TOP_C2, WIDTH_C12, HEIGHT_C12, 0, (void *)ge, DSPL_BMPINVERT | DSPL_BMPCOPY);
            dspl_BitBlt(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+LEFT_C0, TOP_WIDTH_CARD+TOP_C0, WIDTH_C0, HEIGHT_C0, 0, (void *)shi, 0);
         }
      } else
      {
         oldcolor = dspl_SetFrgColor(0x000000);
         dspl_DrawRect(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD, 160-TOP_WIDTH_CARD-HEIGHT_CARD, LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+WIDTH_CARD, 160-TOP_WIDTH_CARD);
         dspl_SetFrgColor(oldcolor);
         oldcolor = dspl_SetBkgColor(0xffffff);
         dspl_fill_rectangle(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD, 160-TOP_WIDTH_CARD-HEIGHT_CARD, LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+WIDTH_CARD, 160-TOP_WIDTH_CARD);
         dspl_SetBkgColor(oldcolor);
         dspl_BitBlt(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+LEFT_C1, 160-TOP_WIDTH_CARD-HEIGHT_CARD+TOP_C1, WIDTH_C12, HEIGHT_C12, 0, (void *)ge, 0);
         dspl_BitBlt(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+LEFT_C2, 160-TOP_WIDTH_CARD-HEIGHT_CARD+TOP_C2, WIDTH_C12, HEIGHT_C12, 0, (void *)ge, DSPL_BMPINVERT | DSPL_BMPCOPY);
         dspl_BitBlt(LEFT_WIDTH_CARD+(numcard-1)*EXPOSED_WIDTH_CARD+LEFT_C0, 160-TOP_WIDTH_CARD-HEIGHT_CARD+TOP_C0, WIDTH_C0, HEIGHT_C0, 0, (void *)shi, 0);             
      }
   }

}

/***********************************************************************


***********************************************************************/
//4 ťʾºδµ״̬
void DrawButton(USHORT x, USHORT y, BOOL isSelected)
{
   U32 oldcolor;
//UBYTE uMode;
//	uMode = dspl_Enable(0);
   if (isSelected)
      oldcolor = dspl_SetFrgColor(0x000000); //set black color
   else
      oldcolor = dspl_SetFrgColor(0xffffff); //set white color
   dspl_DrawLine(x, y, x, y+HEIGHT_BUTTON-1-2);
   dspl_DrawLine(x, y, x+WIDTH_BUTTON-1-2, y);

   if (isSelected)
      dspl_SetFrgColor(0xc0c0c0);
   else
      dspl_SetFrgColor(0x808080); //set deep grey color
   dspl_DrawLine(x, y+HEIGHT_BUTTON-1-1, x+WIDTH_BUTTON-1-1, y+HEIGHT_BUTTON-1-1);
   dspl_DrawLine(x+WIDTH_BUTTON-1-1, y, x+WIDTH_BUTTON-1-1, y+HEIGHT_BUTTON-1-1);

   if (isSelected)
      dspl_SetFrgColor(0xffffff);
   else
      dspl_SetFrgColor(0x000000); //set black
   dspl_DrawLine(x, y+HEIGHT_BUTTON-1, x+WIDTH_BUTTON-1, y+HEIGHT_BUTTON-1);
   dspl_DrawLine(x+WIDTH_BUTTON-1, y, x+WIDTH_BUTTON-1, y+HEIGHT_BUTTON-1);

   dspl_SetFrgColor(oldcolor);

   if (!isSelected)
   {
      oldcolor = dspl_SetBkgColor(0xc0c0c0); //fill shallow grey color
      dspl_fill_rectangle(x, y, x+WIDTH_BUTTON-2, y+HEIGHT_BUTTON-2);

      dspl_SetBkgColor(oldcolor);
   }
   //  dspl_Enable(uMode);

}

/****************************************************************************



******************************************************************************/
void DrawHand(USHORT x, USHORT y)
{
   dspl_BitBlt(x, y, 9, 12, 0, (void *)handshape, DSPL_BMPXOR);
   dspl_BitBlt(x, y, 9, 12, 0, (void *)handmask,  DSPL_BMPAND);
   dspl_BitBlt(x, y, 9, 12, 0, (void *)handshape, DSPL_BMPXOR);
}

/*****************************************************************************


******************************************************************************/
char* CardResShi(USHORT card)
{
   USHORT shiwei, gewei;

   gewei = FirstNum(card);
   shiwei = SecondNum(card);

   switch (shiwei)
   {
   case 1:
      switch (gewei)
      {
      case 0:
      case 1:
      case 2:
      case 6:
         return(char*)fangpian;
         break;
      case 3:
         return(char*)laoJ;
         break;
      case 4:
         return(char*)laoQ;
         break;
      case 5:
         return(char*)laoK;
         break;
      }
      break;
   case 2:
      switch (gewei)
      {
      case 0:
      case 1:
      case 2:
      case 6:
         return(char*)chaohua;
         break;
      case 3:
         return(char*)laoJ;
         break;
      case 4:
         return(char*)laoQ;
         break;
      case 5:
         return(char*)laoK;
         break;
      }
      break;
   case 3:
      switch (gewei)
      {
      case 0:
      case 1:
      case 2:
      case 6:
         return(char*)hongtao;
         break;
      case 3:
         return(char*)laoJ;
         break;
      case 4:
         return(char*)laoQ;
         break;
      case 5:
         return(char*)laoK;
         break;
      }
      break;
   case 4:
      switch (gewei)
      {
      case 0:
      case 1:
      case 2:
      case 6:
         return(char*)heitao;
         break;
      case 3:
         return(char*)laoJ;
         break;
      case 4:
         return(char*)laoQ;
         break;
      case 5:
         return(char*)laoK;
         break;
      }
      break;
   }
   //return p_dcard;
}

char* CardResGe(USHORT card)
{
   USHORT shiwei, gewei;

   gewei = FirstNum(card);
   shiwei = SecondNum(card);


   switch (shiwei)
   {
   case 1:
      switch (gewei)
      {
      case 0:
         return(char*)fangpian8_1;
         break;
      case 1:
         return(char*)fangpian9_1;
         break;
      case 2:
         return(char*)fangpian10_1;
         break;         
      case 3:
         return(char*)fangpianJ_1;
         break;
      case 4:
         return(char*)fangpianQ_1;
         break;
      case 5:
         return(char*)fangpianK_1;
         break;
      case 6:
         return(char*)fangpianA_1;
         break;         
      }
      break;
   case 2:
      switch (gewei)
      {
      case 0:
         return(char*)chaohua8_1;
         break;
      case 1:
         return(char*)chaohua9_1;
         break;
      case 2:
         return(char*)chaohua10_1;
         break;         
      case 3:
         return(char*)chaohuaJ_1;
         break;
      case 4:
         return(char*)chaohuaQ_1;
         break;
      case 5:
         return(char*)chaohuaK_1;
         break;
      case 6:
         return(char*)chaohuaA_1;
         break;         
      }
      break;
   case 3:
      switch (gewei)
      {
      case 0:
         return(char*)hongtao8_1;
         break;
      case 1:
         return(char*)hongtao9_1;
         break;
      case 2:
         return(char*)hongtao10_1;
         break;         
      case 3:
         return(char*)hongtaoJ_1;
         break;
      case 4:
         return(char*)hongtaoQ_1;
         break;
      case 5:
         return(char*)hongtaoK_1;
         break;
      case 6:
         return(char*)hongtaoA_1;
         break;         
      }
      break;
   case 4:
      switch (gewei)
      {
      case 0:
         return(char*)heitao8_1;
         break;
      case 1:
         return(char*)heitao9_1;
         break;
      case 2:
         return(char*)heitao10_1;
         break;         
      case 3:
         return(char*)heitaoJ_1;
         break;
      case 4:
         return(char*)heitaoQ_1;
         break;
      case 5:
         return(char*)heitaoK_1;
         break;
      case 6:
         return(char*)heitaoA_1;
         break;         
      }
      break;
   }
   //return p_dcard;
}
/*************************************************************************




*************************************************************************/
//4ʾmainwindowµİťĻϵı
void DisplayZone(UBYTE numzone, char* txt, UBYTE attr)
{
   MfwRect rect;
   TRACE_FUNCTION("DisplayZone()");

   switch (numzone)
   {
   case 1:  
      //4mainwindowµĵһı
      dspl_TextOut(LEFT_ZONE1+2, TOP_ZONE1+1, attr, (char *) txt);
      break;
   case 2:  
      //4mainwindowµĵڶı
      dspl_TextOut(LEFT_ZONE2+2, TOP_ZONE2, attr, (char *) txt);        
      break;
   case 3:  //4ʾ鿴ť
      rect.px = LEFT_ZONE3; rect.py = TOP_ZONE3; rect.sx = RIGHT_ZONE3-LEFT_ZONE3; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);  
      DrawButton(rect.px, rect.py, FALSE);
      dspl_BitBlt(rect.px+10, rect.py+2, 13, 11, 0, (void *)checkstake, DSPL_BMPCOPY);       
      break;
   case 4:   //4ʾעĵһť
      rect.px = LEFT_ZONE4; rect.py = TOP_ZONE4; rect.sx = RIGHT_ZONE4-LEFT_ZONE4; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);        

      if (attr==DSPL_TXTATTR_UNICODE) //display bmp
      {
         DrawButton(rect.px, rect.py, FALSE);
         dspl_BitBlt(rect.px+11, rect.py+2, 11, 11, 0, (void *)putstake, DSPL_BMPCOPY);            
      } else
      {
         DrawButton(rect.px, rect.py, FALSE);
         dspl_TextOut(LEFT_ZONE4-1,TOP_ZONE4, attr, (char *) txt);         
      }
      break;
   case 5:  //4ʾעĵڶť
      rect.px = LEFT_ZONE5; rect.py = TOP_ZONE5; rect.sx = RIGHT_ZONE5-LEFT_ZONE5; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);    

      if (attr==DSPL_TXTATTR_UNICODE) //display bmp
      {
         DrawButton(rect.px, rect.py, FALSE);
         dspl_BitBlt(rect.px+12, rect.py+5, 9, 6, 0, (void *)follow, DSPL_BMPCOPY);

      } else
      {
         DrawButton(rect.px, rect.py, FALSE);            
         dspl_TextOut(LEFT_ZONE5-1, TOP_ZONE5, attr, (char *) txt);                 
      }
      break;
   case 6:   //4ʾעĵť
      rect.px = LEFT_ZONE6; rect.py = TOP_ZONE6; rect.sx = RIGHT_ZONE6-LEFT_ZONE6; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);        

      if (attr==DSPL_TXTATTR_UNICODE) //display bmp
      {
         DrawButton(rect.px, rect.py, FALSE);
         dspl_BitBlt(rect.px+10, rect.py+2, 14, 13, 0, (void *)quitall, DSPL_BMPCOPY);          
      } else
      {
         DrawButton(rect.px, rect.py, FALSE);            
         dspl_TextOut(LEFT_ZONE6-1, TOP_ZONE6, attr, (char *) txt);                 
      }
      break;
   case 7:  //4ʾȫİť
      rect.px = LEFT_ZONE7; rect.py = TOP_ZONE7; rect.sx = RIGHT_ZONE7-LEFT_ZONE7; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);

      DrawButton(rect.px, rect.py, FALSE);
      dspl_BitBlt(rect.px+11, rect.py+1, 10, 15, 0, (void *)allstake, DSPL_BMPCOPY);

      break;
   default:
      break;
   }
}
void ClearZone(UBYTE numzone)
{
   MfwRect rect;
   switch (numzone)
   {
   case 1:
      rect.px = LEFT_ZONE1;rect.py = TOP_ZONE1; rect.sx = RIGHT_ZONE1-LEFT_ZONE1; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);
      break;
   case 2:
      rect.px = LEFT_ZONE2; rect.py = TOP_ZONE2; rect.sx = RIGHT_ZONE2-LEFT_ZONE2; rect.sy = HEIGHT_ZONE;
      PaintBackground(rect, BKCOLOR);
      break;
   case 3:
      dspl_Clear(LEFT_ZONE3, TOP_ZONE3, RIGHT_ZONE3, TOP_ZONE3+HEIGHT_ZONE);
      //set backgroud color
      break;
   case 4:
      dspl_Clear(LEFT_ZONE4, TOP_ZONE4, RIGHT_ZONE4, TOP_ZONE4+HEIGHT_ZONE);
      //set backgroud color
      break;
   case 5:
      dspl_Clear(LEFT_ZONE5, TOP_ZONE5, RIGHT_ZONE5, TOP_ZONE5+HEIGHT_ZONE);
      //set backgroud color    		
      break;
   case 6:
      dspl_Clear(LEFT_ZONE6, TOP_ZONE6, RIGHT_ZONE6, TOP_ZONE6+HEIGHT_ZONE);
      //set backgroud color    		
      break;
   case 7:
      dspl_Clear(LEFT_ZONE7, TOP_ZONE7, RIGHT_ZONE7, TOP_ZONE7+HEIGHT_ZONE);
      //set backgroud color    		
      break;
   default:
      break;
   }
}

//4 ııɫͱ߿
void DisplayMainWinTxtZone()
{
   U32 oldcolor;
   MfwRect rect;

   oldcolor = dspl_SetFrgColor(0x000000);
   dspl_DrawRect(LEFT_MAINWINTXT, TOP_MAINWINTXT, RIGHT_MAINWINTXT, BOTTOM_MAINWINTXT);
   dspl_SetFrgColor(oldcolor);

   rect.px=LEFT_MAINWINTXT+1; rect.py = TOP_MAINWINTXT+1; rect.sx = RIGHT_MAINWINTXT-rect.px; rect.sy = BOTTOM_MAINWINTXT-rect.py;
   PaintBackground(rect, 0xffff80);
}

//4 ԲͬĲiȷˢµİť
void DrawSelectedButton(USHORT i)
{
   UBYTE uMode;
   uMode = dspl_Enable(0);
   switch (i)
   {
   case 1:  //4 鿴
      DrawButton(LEFT_ZONE3, TOP_ZONE3, 1);        
      break;
   case 2:  //4 ע
      DrawButton(LEFT_ZONE4, TOP_ZONE4, 1);                 
      break;
   case 3:  //4 
      DrawButton(LEFT_ZONE5, TOP_ZONE5, 1);                 
      break;
   case 4:  //4 
      DrawButton(LEFT_ZONE6, TOP_ZONE6, 1);                 
      break;
   case 5:  //4 ȫ
      DrawButton(LEFT_ZONE7, TOP_ZONE7, 1);                 
      break;
   default:
      break;
   }
   //4 ʹťʾڰµ״̬Ǻܺ
   mfwSleep(100);
   dspl_Enable(uMode);
}

//zhangzg 08/13/2002
void DisplayDialog(BOOL yesorno)
{
   U32 oldcolor;
   MfwRect rect;
//title area of dialog
   oldcolor = dspl_SetFrgColor(0x000000);
   dspl_DrawRect(LEFT_DIALOG, TOP_DIALOG, LEFT_DIALOG+100, TOP_DIALOG+10);
   dspl_SetFrgColor(oldcolor);

   rect.px=LEFT_DIALOG; rect.py = TOP_DIALOG; rect.sx = 100; rect.sy = 10;
   PaintBackground(rect, 0x004080); //display deep blue color

//main area of dialog
   oldcolor = dspl_SetFrgColor(0x000000);
   dspl_DrawRect(LEFT_DIALOG, TOP_DIALOG+10, LEFT_DIALOG+100, TOP_DIALOG+60);
   dspl_SetFrgColor(oldcolor);

   rect.px=LEFT_DIALOG; rect.py = TOP_DIALOG+10; rect.sx = 100; rect.sy = 50;
   PaintBackground(rect, 0xc0c0c0); //display shallow grey color

//display button
   DrawButton(LEFT_DIALOG+8, TOP_DIALOG+40, 0);
   DrawButton(LEFT_DIALOG+60, TOP_DIALOG+40, 0);
   dspl_TextOut(LEFT_DIALOG+8+5, TOP_DIALOG+40+1, DSPL_TXTATTR_NORMAL | DSPL_TXTATTR_TRANSPARENT, "Yes");
   dspl_TextOut(LEFT_DIALOG+60+5, TOP_DIALOG+40+1, DSPL_TXTATTR_NORMAL | DSPL_TXTATTR_TRANSPARENT, "No");

   if (yesorno)//display hand shape on Yes button
      DrawHand(LEFT_DIALOG+8+8, TOP_DIALOG+40+2);
   else
      DrawHand(LEFT_DIALOG+60+8, TOP_DIALOG+40+2);

//display text
   dspl_TextOut(LEFT_DIALOG+20, TOP_DIALOG+15, DSPL_TXTATTR_UNICODE | DSPL_TXTATTR_TRANSPARENT, (char *)issaved);

}

/********************************************************************************



********************************************************************************/
void DrawFigure(MfwRect focus_rect, ULONG color)
{
   U32 oldcolor;
   TRACE_FUNCTION("DrawaFigure()");
   oldcolor =  dspl_SetFrgColor(color);//red color
   dspl_DrawRect(focus_rect.px, focus_rect.py, focus_rect.px+focus_rect.sx, focus_rect.py+focus_rect.sy);
   dspl_SetFrgColor(oldcolor);
}
/********************************************************************************



*********************************************************************************/
void Suoha_Display_Start_Picture()
{
   U32 oldcolor;

   oldcolor = dspl_SetBkgColor(0xffffff);    
   dspl_BitBlt(48, 65, 24, 30, 0, (void *)suoha_startpic1, DSPL_BMPCOPY);
}

void Suoha_Display_Opponent()
{

   USHORT i, j; UBYTE uMode; 
   MfwRect rect = {0,0,120,160};
   uMode = dspl_Enable(0);

   PaintBackground(rect, 0x80ffff);
   dspl_BitBlt(LEFT_WIDTH_PPMM, TOP_PPMM, WIDTH_PPMM, HEIGHT_PPMM, 0, (void *)(opparray[0]), DSPL_BMPCOPY);
   dspl_BitBlt(LEFT_WIDTH_PPMM, TOP_PPMM+INTERVAL_PPMM+HEIGHT_PPMM, WIDTH_PPMM, HEIGHT_PPMM, 0, (void *)(opparray[1]), DSPL_BMPCOPY);
   dspl_BitBlt(LEFT_WIDTH_PPMM, TOP_PPMM+2*INTERVAL_PPMM+2*HEIGHT_PPMM, WIDTH_PPMM, HEIGHT_PPMM, 0, (void *)(opparray[2]), DSPL_BMPCOPY);
   dspl_BitBlt(LEFT_WIDTH_PPMM+8, TOP_PPMM+3*INTERVAL_PPMM+3*HEIGHT_PPMM, 15, 16, 0, (void *)helpicon, DSPL_BMPCOPY);

   dspl_Enable(uMode);

}

