/*
s+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile:: mfw_edt.c       $|
| $Author: jhxu $ CONDAT GmbH           $Revision: 1.7 $|
| CREATED: 21.09.98                     $Modtime:: 23.03.00 8:57    $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : MFW_EDT

   PURPOSE : edit handling functions

   EXPORT  :

   TO DO   :

   $History:: mfw_edt.c                                             $
  2003/11/10    sunsj modify the display method of input mode
  28/10/2003    sunsj ***********************************************
                modify for auto width char display
  *******************************************************************

          *    *     * **************  Version 21*****************
 * zgz,2002.9.6
 * Correct the fatal error that can't input symbol lange than 0x80

       *    *     * **************  Version 20.1*****************
 * zgz,2002.9.6
 * Add function edtInsertAnyString() for inserting any format string to our editor
    *    *     * **************  Version 20.0*****************
 * zgz,2002.8.26
 * encapsulate the title display  to one module inputIndicate_update(), it's parameter changed.

    *    *     * **************  Version 19.1 *****************
 * zgz,2002.8.19
 * include extern function scrText() and scrText_Unicode()
   

 *    *     * **************  Version 19.0 *****************
 * zgz,2002.8.7
 * 
 * update function edtOutTextLines(); correct the display error if a space char in the string on when editing
 * update function updateWindow(), getTotalWidth(); correct the cursor error when editing chinese
   
 *    *     * **************  Version 18.4 *****************
 * zgz,2002.7.31
 * 
 * update function edtCharUnicode(), when the control char ecBack input, and only 0x80 in the buffer, delete it
 *  
   
 *    *     * **************  Version 18.3 *****************
 * zgz,2002.7.30
 * 
 *  comment out the trace function zgzTraceString(char *string,unsigned short* data) for it can 
 *  cause fatal error(phone restart) if the data too long in the trace buffer
   
 *    *     * **************  Version 18.2 *****************
 * zgz,2002.7.29
 * 
 * add bmp define for the input_method_indicate, such as ABC_bmp[], abc_bmp[], D123_bmp[], chinese_bmp[]
 * update edtUpdate(), edtUpdateUnicode() to draw frame_line
   
 *    *     * **************  Version 18.1 *****************
 * zgz,2002.7.11
 * 
 * add function inputIndicate_update()

   *     * **************  Version 18 *****************
 * zgz,2002.7.3
 * 
 * update function edtCharUnicode(),

  *     * **************  Version 17 *****************
 * zgz,2002.7.2
 * added function edtSymbol(), edtSetText(), getSymbolNumSpare()
 * update edtUpdateUnicode(), edtUpdate() for title display


   * *****************  Version 16 *****************
 * zgz,2002.06.24
 * added edtCharf()
 * 

 * *****************  Version 15  *****************
 * User: Es           Date: 23.03.00   Time: 14:40
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * added edtUnhide()
 * 
 * *****************  Version 14  *****************
 * User: Kk           Date: 21.02.00   Time: 9:36
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * changes from es inserted
 *
 * *****************  Version 13  *****************
 * User: Es           Date: 18.02.00   Time: 15:45
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * added edit controls: ecTop, ecBottom
|
| *****************  Version 12  *****************
| User: Le           Date: 6.01.00    Time: 9:23
| Updated in $/GSM/Condat/MS/SRC/MFW
| Alignment of MFW versions
 *
 * *****************  Version 3  *****************
 * User: Kk           Date: 13.12.99   Time: 17:30
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 22.11.99   Time: 10:29
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 1  *****************
 * User: Es           Date: 18.11.99   Time: 16:35
 * Created in $/GSM/Condat/SND-MMI/MFW
 * Initial
 *
 * *****************  Version 11  *****************
 * User: Es           Date: 6.07.99    Time: 12:18
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 10  *****************
 * User: Es           Date: 14.04.99   Time: 17:34
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * moved to CST
|
| *****************  Version 9  *****************
| User: Le           Date: 14.04.99   Time: 9:51
| Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 8  *****************
 * User: Es           Date: 1.04.99    Time: 17:07
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * removed lots of traces
 *
 * *****************  Version 7  *****************
 * User: Es           Date: 18.02.99   Time: 17:01
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 6  *****************
 * User: Es           Date: 17.02.99   Time: 19:10
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 5  *****************
 * User: Es           Date: 8.02.99    Time: 19:06
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * Cursor auf 0 !
 *
 * *****************  Version 4  *****************
 * User: Es           Date: 27.01.99   Time: 15:06
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 3  *****************
 * User: Es           Date: 14.01.99   Time: 17:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 23.12.98   Time: 16:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
*/


#if defined (NEW_FRAME)

    #include "typedefs.h"  
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include <stdio.h>
#include <string.h>

#include "mfw_mfw.h"
#include "mfw_sys.h"
#include "gdi.h"
#include "dspl.h"
#include "mfw_edt.h"
#include "mfw_ffs.h"
/*
#include "mmidummy.h" //zgz, 2002. 7.31
#include "mfw_cnvt.h"   // zgz,2002.0627 for string convert
#include "mmieditor.h"		//zgz,2002.7.31 for useing getNextInputLen()
#include "mmiusersymbolinput.h"  // zgz, 2002. 7.31 to use input_method mode and get_ecinput_mode() 
*/
//#include "bmieastapi.h"  	//zgz, 2002.7.31


#include "cus_aci.h" // zgz - only for tracing
#include "p_sim.h"
#include "pcm.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "..\bmi\mmisettings.h"
#include "..\bmi\Mmiicons.h"
#include "..\bmi\Mmi3dframe.h"
/*#include "cus_aci.h" // sbh - only for tracing
#include "p_sim.h"
#include "pcm.h"
char debug[40];*/
//#define TDTRACE 1
#include "..\bmi\mmiutilapi.h"
//static char *textStart;                 /* start of text            */

//////////////////////////////////////////////////////////////////////
/* 2003/12/04 sunsj remove */
#if 0
    #define PARADISE_MODE  				10     //Paradise input mode
    #define STROKE_MODE				11		/* 2003/11/10 sunsj */
    #define UPPERCASE_MODE				12    // such as A,B,C...
    #define LOWERCASE_MODE			        13    // such as a,b,c...
    #define SHUZI_MODE				14	 //digit input mode, such as 1,2,3...  
    #define ONLYREAD_MODE				15
    #define PHONENUMONLY_MODE		        16    //  Not like SHUZI_MODE, it can not convert to other mode 
#endif

extern int getNextInputLen(void);  //zgz,2002.0628  this func in file mmieditor.c
extern int  get_ecinput_mode(void);
extern void scrText(int x, int y, UBYTE in_Attrib, char * txt);  //zgz,2002.8.19 
extern void scrText_Unicode(int x, int y, UBYTE in_Attrib, char *intxt);//zgz,2002.8.19
extern int editForChineseInput;
#if(MAIN_LCD_SIZE==3)
extern BOOL phonebook_search_flag;
#endif
///////////////////////////////////////////////////////////////////////////
static int fontHeight;                  /* height of current font   */
static int display;                     /* really show the things   */
static U8 curMode;                      /* edit mode & cursor type  */
static U16 curCP;                       /* cursor offset            */
static U16 preCP;                     /*the unicode index pre cursor position*/
static char preZi[6];
static S16 curCX, curCY;                /* screen cursor position   */
static S16 preCX,preCY;                /*previous screen cursor position*/
static S16 curCSize;                    /* size of screen cursor    */
static S16 preCSize;                                /*size of previous screen cursor*/
static UBYTE ecDel_uniFlag = 0;   //zgz, 2002.0626  if the unicode del or back executed, set it to 0;

//zgz, 2002.7.25 the following is the input method indicate bmp

/************************************************************************/
/* 2004/01/14 sunsj remove                                              */
/************************************************************************/
#if 0
/*bmpWidth:37,bmpHigh:12*/
/*After convert 24-bit bmp to 16-bit(565) bmp,
    the datas of 16-bit bmp as follows:*/
/*Note:	RG is combined to make Data[1],GB is combined to make Data[0]. 
    This file is arranged by Data[0],Data[1],...,and so on */
static  const unsigned char ABC_bmp[] =
{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};

const unsigned char abc_bmp[] =
{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};
static  const unsigned char D123_bmp[] =
{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};

static  const unsigned char chinese_bmp[] =
{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
    0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};
#endif

//static U16 curLineStart;                /* start of current line    */
//static U16 curLineChars;                /* chars in current line    */
//static U16 prevLineChars;               /* chars in previous line   */
//static U16 nextLineChars;               /* chars in next line       */
//static U16 firstLineChars;              /* chars in first line      */
//static U16 dispChars;                   /* chars displayed so far   */

//static int edtCurDown (MfwEdt *e, int tbl, int bottom);
//static int edtSplitLine (int px, int py, int ls, int ly, char *tp);
//static void edtShowLine (int px, int py, char *tp);
static int edtInsert (int c, char *b, int s);
static int edtCommand (U32 cmd, void *h);
//static void lineUpDown (MfwEdt *e, U16 start, U16 stop);
void moveLeft (char * str, int ofs);
static void moveRight (char *b, int s, int d);

static void edtUnicodeSplitLine (int px, int py, int ls, int ly, U16 *tp);
static void moveRightUnicode(U16 *unicodeStr, int nChars);
static void moveLeftUnicode(U16 *unicodeStr, int nChars);
static int  edtInsertUnicode (MfwEdt *e, int c, U16 *b, int s);

U16 strlenUnicode(U16* str);

static void edtOutTextLines (int px, int py, int ls, int ly, U16 *tpUnicode, unsigned char* tpAscii);
MfwRes updateWindow (MfwEdt *e, int  dy );

int isAWordChar( char chr);
void redrawcursor(U16 pre_x,U16 pre_y,U16 pre_w,U16 cur_x,U16 cur_y,U16 cur_w,int flag,UINT32 fgcolor);

//Define the chars that correspond to the end of a word.
#define STR_WORDBREAK " .?!"

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtInit            |
+--------------------------------------------------------------------+

  PURPOSE : initialize edit handler

*/

MfwRes edtInit (void)
{
    mfwCommand[MfwTypEdt] = (MfwCb) edtCommand;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtExit            |
+--------------------------------------------------------------------+

  PURPOSE : finalize edit handler

*/

MfwRes edtExit (void)
{
    mfwCommand[MfwTypEdt] = 0;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtCreate          |
+--------------------------------------------------------------------+

  PURPOSE : create editor control

*/

MfwHnd edtCreate (MfwHnd w, MfwEdtAttr *a, MfwEvt e, MfwCb f)
{
    MfwHdr *hdr = (MfwHdr *) mfwAlloc(sizeof(MfwHdr));
    MfwEdt *edt = (MfwEdt *) mfwAlloc(sizeof(MfwEdt));

    if( !hdr || !edt )
        return 0;

    edt->mask = e;
    edt->flags = 0;
    edt->handler = f;
    edt->attr = a;
    edt->cp = 0;                        /* cursor position          */
    edt->curOffs = 0;

    hdr->data = edt;
    hdr->type = MfwTypEdt;

    //zgz, 2002.6.18  edtUpdate(edt);

    return mfwInsert(w,hdr);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtDelete          |
+--------------------------------------------------------------------+

  PURPOSE : delete editor control

*/

MfwRes edtDelete (MfwHnd e)
{
    MfwRes res;

    if( !e )
        return MfwResIllHnd;

    edtHide(e);                         /* hide editor contents     */
    res = (mfwRemove(e)) ? MfwResOk : MfwResIllHnd;

    mfwFree(((MfwHdr *) e)->data,sizeof(MfwEdt));
    mfwFree(e,sizeof(MfwHdr));

    return res;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtReset           |
+--------------------------------------------------------------------+

  PURPOSE : reset editor control

*/

MfwRes edtReset (MfwHnd w)
{
    MfwEdt *e;

    if( !w )
        return MfwResIllHnd;            /* editor does not exist    */

    e = ((MfwHdr *) w)->data;

    if( !e )
        return MfwResIllHnd;            /* editor does not exist    */

    e->cp = 0;                          /* cursor position          */
    e->curOffs = 0;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtShow            |
+--------------------------------------------------------------------+

  PURPOSE : show editor

*/

MfwRes edtShow (MfwHnd e)
{
    MfwEdt *edt;
    U8 uMode;

    if( !e )
        return MfwResIllHnd;            /* editor does not exist    */
    uMode = dspl_Enable(0);//ganchh 2002/6/12

    edt = ((MfwHdr *) e)->data;         /* get control block        */

    edt->flags |= MfwEdtVisible;        /* editor is visible        */
    if( edt->handler )                   /* call event handler       */
        if( edt->mask & MfwEdtVisible )
            edt->handler(MfwEdtVisible,edt);
    display = 1;                        /* really show it           */
    updateWindow(edt, 0);               //zhangxp added 2003/3/27
    edtUpdate(edt,1);                     /* draw editor elements     */
    dspl_Enable(uMode);//ganchh 2002/6/12

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtHide            |
+--------------------------------------------------------------------+

  PURPOSE : hide editor

*/

MfwRes edtHide (MfwHnd e)
{
    MfwEdt *edt;

    if( !e )
        return MfwResIllHnd;            /* element does not exist   */

    edt = ((MfwHdr *) e)->data;         /* get edit control block   */
    edt->flags &= ~MfwEdtVisible;       /* editor is not visible    */
    if( edt->handler )                   /* call event handler       */
        if( edt->mask & MfwEdtVisible )
            edt->handler(MfwEdtVisible,edt);

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtUnhide          |
+--------------------------------------------------------------------+

  PURPOSE : unhide editor (without drawing)

*/

MfwRes edtUnhide (MfwHnd e)
{
    MfwEdt *edt;

    if( !e )
        return MfwResIllHnd;            /* element does not exist   */

    edt = ((MfwHdr *) e)->data;         /* get edit control block   */
    edt->flags |= MfwEdtVisible;        /* editor is visible        */
    if( edt->handler )                   /* call event handler       */
        if( edt->mask & MfwEdtVisible )
            edt->handler(MfwEdtVisible,edt);

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtClear           |
+--------------------------------------------------------------------+

  PURPOSE : clear editor

*/

MfwRes edtClear (MfwHnd e)
{
    MfwEdt *edt;

    if( !e )
        return MfwResIllHnd;            /* element does not exist   */

    edt = ((MfwHdr *) e)->data;         /* get edit control block   */
    if( edtReset(e) && edt->attr->text )
    {
        *(edt->attr->text) = 0;         /* clear buffer             */
        edtUpdate(edt,1);                 /* clear edit area          */
    }

    return MfwResOk;
}

/*
zgz, 2002.06.26 

Just only initialize the editor buffer.
*/

MfwRes edtSetText (MfwHnd e,  char * s)
{
    MfwEdt *edt;

    if( !e )
        return MfwResIllHnd;            /* element does not exist   */

    edt = ((MfwHdr *) e)->data;         /* get edit control block   */
    edt->attr->text = s;

    return MfwResOk;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtUpdate          |
+--------------------------------------------------------------------+

  PURPOSE : draw editor
GW 06/09/01 - Call chinese update if first char is 0x80,0x81 or 0x82.
GW 06/09/01 - Added extra parameters to displ_setCursorPos for the size of cursor.
*/

//Return non-zero result if chr is in the string str.
int chrInString(char chr,char* str)
{
    int i;
    i=0;
    while( str[i] != 0x00 )
    {
        if( str[i]== chr )
            return(i+1);
        else
            i++;
    }
    //Not found -
    return(0);
}

//GW 18/09/01 Use 'isAWordChar' procedure instead of 'chrInString' 
void findWordBounds(MfwEdt *e, int *opStChr, int *opEndChr)
{
    int found;
    int stChr,endChr;
    //Find char before start of the word.
    stChr = e->cp-1;
    found = FALSE;
    while( (stChr >0) && (!found) )
    {
        if( isAWordChar(e->attr->text[stChr])==0 )
            found = TRUE;
        else
            stChr--;
    }
    //find char after end of the word.
    endChr = e->cp;
    found = FALSE;
    while( (e->attr->text[endChr]!=0x00 ) && (!found) )
    {
        if( isAWordChar(e->attr->text[endChr])==0 )
            found = TRUE;
        else
            endChr++;
    }
    *opStChr  = stChr;
    *opEndChr = endChr;
}

//GW 18/09/01 Commented out debug code. 
MfwRes edtUpdate (MfwEdt *e,int all)
{
    UBYTE temp;

    char *tp,*tShow;
    S16 px, py;                         /* top left corner of edit  */
    S16 ls;                             /* width of edit window     */
    S16 ly;                             /* bottom of edit window    */
    U8 oldFont = -1;                    /* store previous font      */
    U8 uMode;
    char* endChar;

    unsigned char *tb;
    //char spareNum[4];    //zgz,2002.06.28  temp buffer for spare number  display
    //char *title; //zgz, 2002.7.2

    //Data used to add word highlight 
    char saveChr[2];
    char text_more[17]="";//the buffer for show the text of the cursor line
    char *tMore=&text_more[0];
    char startHtext[2] = {0x01,0x00};
    char endHtext[2]   = {0x02,0x00};
    char Trace_data[10]="";
    //char *show_text;
    int stChr,endChr;
    int textlen;//the text len from the cursor

    U16* tmp;
    UINT32 oldColor,oldFontColor;
    TRACE_EVENT("edtupdate");
    if( !e )
        return MfwResIllHnd;

    if( !e->attr->text )
        return MfwResErr;               /* no text to display       */

    tb = (unsigned char*)e->attr->text;

    if( (tb[0] == 0x80) || (tb[0] == 0x81) || (tb[0] == 0x82) )
    {
        return( edtUpdateUnicode (e,all ) );
    }
    /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
    //if ( editForChineseInput )
    //    return(edtshowforchineseinput(e) );

    temp = dspl_get_char_type();        
    dspl_set_char_type(DSPL_TYPE_ASCII);


    if( !(e->flags & MfwEdtVisible) )
        display = 0;                    /* invisible editor         */
    else display=1;

    if( display )
        uMode = dspl_Enable(0);

    //    textStart = e->attr->text;          /* start of edit text       */
    tp = e->attr->text + e->curOffs;    /* start of display buffer  */
    tShow=e->attr->text+e->cp;
    px = e->attr->win.px;               /* left of edit window      */
    py = e->attr->win.py;               /* top of edit window       */
    ls = e->attr->win.sx;               /* width of edit window     */
    ly = (S16) (py+e->attr->win.sy);    /* bottom of edit window    */
    if( e->attr->font != (U8) -1 )
        oldFont = dspl_SelectFontbyID(e->attr->font); /* setup font */
    /* 2004/02/11 sunsj modify font height for cursor display */
    fontHeight = dspl_GetFontHeight()+1;  /* get height of curr font  */
    curMode = e->attr->mode;            /* setup edi mode           */

    if( display )
    {

        TRACE_EVENT("now we will clear and display");
        if( all )
        {
            oldColor=dspl_GetBkgColor();
            if( e->attr->fgColor<1 )
                e->attr->fgColor=0xffffff;
            dspl_SetBkgColor(e->attr->fgColor);
            if( (e->attr->titleMode==1) )//|| (e->attr->titleMode == TITLE_TOP)
                //dspl_Clear(1, e->attr->win.py, 119, (U16)(ly));       		    
                dspl_Clear(0,e->attr->win.py,SCREEN_WIDTH,ly);
            else dspl_Clear(e->attr->win.px,e->attr->win.py,(U16)(ls+e->attr->win.px),(U16)(ly));
            edtOutTextLines(e->attr->win.px,e->attr->win.py,ls,ly,NULL,(unsigned char*)tp); // show it 
            dspl_SetCursor(0,(U8)(curMode&edtCurMask));
            dspl_SetBkgColor(oldColor);
            //dspl_SetFrgColor(oldFontColor);
        }
        else
        {
            oldColor=dspl_GetBkgColor();
            //oldFontColor=dspl_GetFrgColor();
            if( e->attr->fgColor<1 )
                e->attr->fgColor=0xffffff;
            dspl_SetBkgColor(e->attr->fgColor);
            //dspl_SetFrgColor(0x000000);
            /* 2003/12/29 sunsj modify for different font hight */
            dspl_Clear(curCX,curCY,(U16)(e->attr->win.px+ls),(U16)(curCY+fontHeight));
            if( e->cp_last_y != curCY )
            {
                /* 2004/04/06 sunsj modify */
                //dspl_Clear((U16)(e->attr->win.px+e->cp_last_x),(U16)e->cp_last_y,(U16)SCREEN_WIDTH,(U16)(e->cp_last_y+fontHeight));
                e->cp_last_y = curCY;
            }
            dspl_Clear(e->attr->win.px,curCY+fontHeight,(U16)(ls+e->attr->win.px),(U16)(ly));       
            textlen=curCX;
            while( *tShow!='\0' )
            {
                /* 2003/10/28 sunsj because *tShow is a char.When *tShow is a negative so it will become a big num when
                  we conver it into unsigned number */
                USHORT temp_char;
                /* 2003/10/28 sunsj modify for auto width char display */
                //textlen+=8;
                temp_char = *tShow & 0x00FF;
                textlen += get_CharWidth((USHORT)temp_char);

                if( textlen>(ls+px) )
                    break;
                if( (*tShow==0x0a)||(*tShow==0x0d) )
                {
                    tShow++;
                    break;
                }

                *tMore=*tShow;
                tMore++;
                tShow++;                    
            }
            *tMore='\0';
            tMore++;
            *tMore='\0';
            dspl_TextOut(curCX,curCY,0,text_more);
            /* 2003/12/29 sunsj modify for different font hight */
            if( (*tShow!='\0')&&(ly-curCY-fontHeight>=fontHeight) )
            {
                edtOutTextLines(e->attr->win.px,curCY+fontHeight,(U16)ls,(U16)ly,NULL,(unsigned char *)tShow);
            }
            redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);
            /*
            if(strlen(tShow)>(120-curCX)/8)
                {
            strncpy(text_more,tShow,(120-curCX)/8);
            text_more[(120-curCX)/8]='\0';
            text_more[(120-curCX)/8+1]='\0';
            dspl_TextOut(curCX,curCY,0,text_more);
            edtOutTextLines(e->attr->win.px,curCY+16,(U16)ls,(U16)ly,NULL,(unsigned char *)(tShow+(120-curCX)/8));
            
            redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);
                }
            else
                {
                    strcpy(text_more,tShow);
                    TRACE_EVENT("the text of this line");
                    TRACE_EVENT(text_more);
                    dspl_TextOut(curCX,curCY,0,text_more);
                    redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);
                }
            */      
            dspl_SetBkgColor(oldColor);
            //dspl_SetFrgColor(oldFontColor);
        }
    }


    //Add a space to the end of the line
    endChar = &tp[strlen(tp)];


    if( display )
    {
        //zgz, 2002.06.28  display my title
        inputIndicate_update(e);
    }

    if( display && (curMode & edtCurMask) )
    {
        //dspl_SetCursorPos(curCX,curCY,curCSize,(S16)fontHeight); /* display cursor           */
        if( all )
            dspl_SetCursorPos(curCX,curCY+1,curCSize,(S16)fontHeight); // sbh 19/02/02, position cursor correctly
    }
    if( oldFont != (U8) -1 )
        dspl_SelectFontbyID(oldFont);   /* restore previous font    */


    if( display )
        dspl_Enable(uMode);
    dspl_set_char_type(temp);

    //	e->attr->curChar    = e->attr->text[e->cp];
    return MfwResOk;
}




//GW 18/09/01 - Corrected linefeed definition and added carriage return definition.
#define UNICODE_SPACE			0x2000
#define UNICODE_LINEFEED		0x0A00
#define UNICODE_CR				0x0D00
#define UNICODE_EOLN			0x0000
#define UNICODE_NONASCII		0x00FF
//#define UNICODE_EXTENDEDASCII	0x8000			// sbh - extended ascii interferes with normal ascii processing
#define UNICODE_STARTHIGHLIGHT	0x0100 
#define UNICODE_ENDHIGHLIGHT	0x0200


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtChar            |
+--------------------------------------------------------------------+

  PURPOSE : handle editing char
//GW 06/09/01 - Call chinese procedure if first char is 0x80,0x81 or 0x82 or display type is not ascii.

*/
char getCursorChar(MfwHnd e, int offset )
{
    MfwEdt *edit; 
    int chPos;

    if( !e )
        return(0xFF);

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return(0xFF);            /* not an editor            */

    edit = ((MfwHdr *) e)->data;


    chPos = offset + edit->cp;
    if( (chPos < 0) || (chPos > strlen(edit->attr->text)) )
        return(0x00);
    else
        return(edit->attr->text[chPos]);
}
int isAWordChar( char chr)
{
    if( ((chr >='A') && (chr <='Z')) || 
        ((chr >='a') && (chr <='z')) )
        return(TRUE);
    else
        return(FALSE);
}

MfwRes edtSymbol (MfwHnd e, int c)
{
    MfwEdt *edit; 
    unsigned char firstChar; 
    U16 bs;    // buffer size
    char *tbString; 
    char tmpBuffer[256];
    unsigned int tmpLen;


    TRACE_EVENT("edtSymbol()");
    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            /* not an editor            */

    edit = ((MfwHdr *) e)->data;
    firstChar = (unsigned char)edit->attr->text[0];
    tbString = &(edit->attr->text[0]);

    if( (firstChar != 0x80) && (c <= 0xff) )  //All text in buffer is ascii or No symbol in buffer, and the input symbol c is ascii or control code;  control code is less than 0
        return edtChar (e, c);
    else if( (firstChar != 0x80) && (c > 0xff) ) //All text in buffer is ascii or No symbol in buffer, and the input symbol c is unicode
    {
        if( firstChar != 0 )  // there are symbol in buffer, and all is ascii
        {
            //ѵǰasciiַȫתΪunicode
            //Note:  ǰasciiתΪ˫ֽں󳬳ռ䣬ʱӦת쳣ֵmmiӦóʾϢ
            strcpy(tmpBuffer, tbString);
            AscEx_To_Unicode(tmpBuffer, tbString); //AscEx_To_Unicode(tmpBuffer, strlen(tmpBuffer), tbString);  //ַΪ0x80
            return edtCharUnicode (e, c);
        }
        else                    // firstChar is zero; for the first time, No symbol in buffer. 
        {
            edit->attr->text[0] = 0x80;  // Set the first Flag Byte to 0x80
            return edtCharUnicode (e, c);
        }
    }
    else if( (firstChar == 0x80) && (c > 0) && (c <= 0xff) ) //All text in buffer is unicode, and the input symbol c is ascii;  
    {
        if( ecDel_uniFlag )
        {
            ecDel_uniFlag = 0;
            //TRACE_EVENT("zgz,ecDel_uniFlag  is reset to 0");
            // һεùunicodeɾƣӦжϵǰַǷȫתΪascii
            //step1: ȫתΪasciiת󣬲һasciiַ 
            //step2: ascii cתΪunicode, 뵽buffer 
            tmpLen = strlenUnicode((U16 *)( tbString + 1));
            if( All_Is_AscEx(tbString, tmpLen) )  //if (All_Is_AscEx(tbString, tmpLen))
            {
                memset(tmpBuffer, 0, sizeof(tmpBuffer));
                Unicode_To_AscEx(tbString, &tmpBuffer[0]); //Unicode_To_AscEx(tbString, tmpLen, &tmpBuffer[0]);
                strcpy(tbString, tmpBuffer);
                return edtChar(e, c);
            }
            else
            {
                return edtCharUnicode(e, ConvertToUni(c));
            }
        }
        else    //ascii cתΪunicode, 뵽buffer 
        {
            return edtCharUnicode(e, ConvertToUni(c));
        }
    }
    else if( (firstChar == 0x80) && ((c < 0) || (c > 0xff)) ) //All text in buffer is unicode, and the input symbol c is also unicode or control code
    {
        if( (c == ecBack) || (c == ecDel) )
        {
            ecDel_uniFlag = 1;

            //note: жϵǰַǷȫתΪascii, txtLen ֵ
            // һԷŵһʵĵطͳһִУȻʾû
        }
        return edtCharUnicode (e, c);
    }

    return MfwResOk;
}

MfwRes edtChar (MfwHnd e, int c)
{
    int warn99;
    MfwEdt *edit; 
    U16 bs; 
    int dy; //Change in cursor y position when moving up/down lines.
    char *tbString; 
    int found;
    U16 pre_offs;
    char Trace_data[10]="";

    TRACE_EVENT("edtChar()");

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            /* not an editor            */

    edit = ((MfwHdr *) e)->data;

    tbString = &edit->attr->text[0];

    if( (unsigned char)tbString[0] == 0x80 )  //zgz change, 2002.9.6
    {
        return(edtCharUnicode(e,c));
    }
    if( wstrlen(edit->attr->text)==0 )
        edit->cp=0;
    curCP = edit->cp;
    if( edit->attr->e_size==0 )
        bs = edit->attr->size;
    else
        bs=edit->attr->e_size;
    curMode = edit->attr->mode;
    dy = 0;
    switch( c )
    {
    
    case ecEscape:                  //* quit editor              
        return MfwResDone;
    case ecLeft:                    //* cursor left     
        if( edit->cp == 0 )
            edit->cp = strlen(tbString);  // zgz, change it
        else
        {
            edit->cp = edit->cp-1;
        }
        pre_offs=edit->curOffs;
        updateWindow( edit, 0);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,0,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdate(edit,1);
        }
        break;
    case ecRight:                   //* cursor right 
        edit->cp = edit->cp+1;


        if( edit->cp > (strlen(tbString)) )
        {
            edit->cp = 0;
        }
        pre_offs=edit->curOffs;
        updateWindow( edit, 0);

        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,0,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdate(edit,1);
        }
        //	redrawcursor(cp_pre_x, cp_pre_y, cp_pre_w,edit->cp_curr_x,edit->cp_curr_y, edit->cp_curr_width,0,edit->attr->fgColor);
        break;
    case ecUp:                      //* cursor up      
        dy =  -1;
        pre_offs=edit->curOffs;
        TRACE_EVENT("press the up in ascii");
        updateWindow( edit, dy);

        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,0,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdate(edit,1);
        }

        break;
    case ecDown:                    //* cursor down           
        dy = 1;
        pre_offs=edit->curOffs;
        TRACE_EVENT("press the down in ascii");

        updateWindow( edit, dy);
        Sprintf(Trace_data,"%d",edit->cp);
        TRACE_EVENT(Trace_data);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,0,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdate(edit,1);
        }
        break;
    case ecTop:                     //* cursor to start of text  
        edit->cp = 0;
        updateWindow(edit,0);
        display=1;
        edtUpdate(edit,1);
        break;
    case ecBottom:                  //* cursor to end of text   
        edit->cp = strlen(tbString);
        updateWindow(edit,0);
        display=1;
        edtUpdate(edit,1);
        break;
    case ecBack:                    //* backspace                *
        if( (edit->cp != 0) && (strlen(tbString)+1 > edit->cp) )
        {
            moveLeft(&tbString[edit->cp-1],1);
            //				edit->cp = edit->cp-1;
        }
        pre_offs=edit->curOffs;
        if( edit->cp == 0 )
            edit->cp = strlen(tbString);  // zgz, change it
        else
        {
            edit->cp = edit->cp-1;
        }
        updateWindow( edit, dy);
        display=1;
        if( pre_offs==edit->curOffs )
            edtUpdate(edit,0);
        else
            edtUpdate(edit,1);

        break;
    case ecDel:                     //* delete                   *
        if( strlen(tbString) > edit->cp )
        {
            moveLeft(&tbString[edit->cp],1);
        }
        break;
    case ecEnter:                   //* cr/lf                    
        c = UNICODE_LINEFEED;
        edtInsert(c,tbString,bs);
        return(edtChar(e,ecRight));
        break;
    default:                        //* normal char     
        if( edtInsert(c,tbString,bs) )   //zgz,2002.5.15 ,if the buffer is full, don't make the cursor right
        {
            updateWindow( edit, 0);
            display=1;
            edtUpdate(edit,0);
            return(edtChar(e,ecRight));
        }
        else
            return MfwResDone;
        break;
    }
    return MfwResOk;
}


/////zgz,2002.0621 this function update the screen by disp. if disp is 1, update the screen . or not do it, just intert c to editor.
MfwRes edtCharf (MfwHnd e, int c, int disp)
{
    int warn99;
    MfwEdt *edit; 
    U16 bs; 
    int dy; //Change in cursor y position when moving up/down lines.
    char *tbString; 
    int found;

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            /* not an editor            */

    edit = ((MfwHdr *) e)->data;
    curCP = edit->cp;
    tbString = &edit->attr->text[0];

    if( (unsigned char)tbString[0] == 0x80 )  //zgz change, 2002.9.6
    {
        return(edtCharUnicode(e,c));
    }
    if( edit->attr->e_size==0 )
        bs = edit->attr->size;
    else
        bs=edit->attr->e_size;
    dy = 0;
    switch( c )
    {
    
    case ecEscape:                  //* quit editor              
        return MfwResDone;
    case ecLeft:                    //* cursor left     
        if( edit->cp == 0 )
            edit->cp = strlen(tbString);  // zgz, change it
        else
        {
            edit->cp = edit->cp-1;
        }

        break;
    case ecRight:                   //* cursor right 
        edit->cp = edit->cp+1;
        if( edit->cp > (strlen(tbString)) )  // zgz, change it
            edit->cp = 0;
        break;
    case ecUp:                      //* cursor up      
        dy =  -1;
        break;
    case ecDown:                    //* cursor down           
        dy = 1;
        break;
    case ecTop:                     //* cursor to start of text  
        edit->cp = 0;
        edit->curOffs = 0;
        break;
    case ecBottom:                  //* cursor to end of text   
        edit->cp = strlen(tbString);
        edit->curOffs = 0;
        //  		dy = 999;
        break;
    case ecBack:                    //* backspace                *
        if( (edit->cp != 0) && (strlen(tbString)+1 > edit->cp) )
        {
            moveLeft(&tbString[edit->cp-1],1);
            //				edit->cp = edit->cp-1;
        }
        return(edtCharf(e,ecLeft, 0));
        break;
    case ecDel:                     //* delete                   *
        if( strlen(tbString) > edit->cp )
        {
            moveLeft(&tbString[edit->cp],1);
        }
        break;
    case ecEnter:                   //* cr/lf                    
        c = UNICODE_LINEFEED;
        edtInsert(c,tbString,bs);
        return(edtCharf(e,ecRight, 0));
        break;
    default:                        //* normal char              
        if( edtInsert(c,tbString,bs) ) //zgz,2002.5.15 ,if the buffer is full, don't make the cursor right
            return(edtCharf(e,ecRight, 0));
        else if( edit->cp != (edit->attr->size - 3) )
            return(edtCharf(e,ecRight, 0));
        else
            return MfwResOk;
        break;
    }
    display = disp;                        //*if really show it by var disp          
    updateWindow( edit, dy);
    edtUpdate(edit,1);

    return MfwResOk;
}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtCharUnicode     |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/
MfwRes edtCharUnicode (MfwHnd e, int c)
{
    MfwEdt *edit; 
    U16 bs; 
    int dy;
    //    char *tb = edit->attr->text;
    U16 *tbUnicode; 
    U16 pre_offs;
    U8 * p;  //zgz, 2002.7.3 point to the string using 8bits len
    UINT32 oldColor;
    fontHeight = dspl_GetFontHeight();  /* 2003/12/29 sunsj add */

    TRACE_EVENT("edtCharUnicode()");

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            //* not an editor            

    edit = ((MfwHdr *) e)->data;
    bs = edit->attr->size;
    tbUnicode = (U16*) &(edit->attr->text[1]);  // zgz,tbUnicode = (U16*) &edit->attr->text[2];
    p =  (U8*) &(edit->attr->text[1]);  
    curMode = edit->attr->mode;

    dy = 0;
    switch( c )
    {
    case ecEscape:                  //* quit editor              
        return MfwResDone;
    case ecLeft:                    //* cursor left              
        preCP=edit->cp;
        preZi[0]=0x80;
        preZi[1]=edit->attr->text[1+2*preCP];
        preZi[2]=edit->attr->text[2+2*preCP];
        preZi[3]=0x00;
        preZi[4]=0x00;
        preZi[5]=0x00;
        if( edit->cp == 0 )
            edit->cp = (wstrlen(edit->attr->text)-1)/2;  // zgz, change it
        else
        {
            edit->cp = edit->cp-1;
        }
        pre_offs=edit->curOffs;
        updateWindow( edit, dy);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,1,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdateUnicode(edit,1);
        }
        break;
    case ecRight:                   //* cursor right             
        //zgz, 2002.7.3 if (tbUnicode[edit->cp]!=UNICODE_EOLN)
        preCP=edit->cp;
        preZi[0]=0x80;
        preZi[1]=edit->attr->text[1+2*preCP];
        preZi[2]=edit->attr->text[2+2*preCP];
        preZi[3]=0x00;
        preZi[4]=0x00;
        preZi[5]=0x00;
        if( (p[2*edit->cp] != 0) || (p[2*edit->cp + 1] != 0) )
        {
            edit->cp = edit->cp +1;
        }
        else
        {
            edit->cp = 0;
        }
        pre_offs=edit->curOffs;
        updateWindow( edit, dy);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,1,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdateUnicode(edit,1);
        }
        break;
    case ecUp:                      //* cursor up                
        dy = -1;
        pre_offs=edit->curOffs;
        preCP=edit->cp;
        preZi[0]=0x80;
        preZi[1]=edit->attr->text[1+2*preCP];
        preZi[2]=edit->attr->text[2+2*preCP];
        preZi[3]=0x00;
        preZi[4]=0x00;
        preZi[5]=0x00;
        updateWindow( edit, dy);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,1,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdateUnicode(edit,1);
        }
        break;
    case ecDown:                    //* cursor down              
        dy = 1;
        pre_offs=edit->curOffs;
        preCP=edit->cp;
        preZi[0]=0x80;
        preZi[1]=edit->attr->text[1+2*preCP];
        preZi[2]=edit->attr->text[2+2*preCP];
        preZi[3]=0x00;
        preZi[4]=0x00;
        preZi[5]=0x00;
        updateWindow( edit, dy);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,1,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdateUnicode(edit,1);
        }
        break;
    case ecTop:                     //* cursor to start of text  
        edit->cp = 0;
        pre_offs=edit->curOffs;
        edit->curOffs = 0;
        dy = 0;
        preCP=edit->cp;
        preZi[0]=0x80;
        preZi[1]=edit->attr->text[1+2*preCP];
        preZi[2]=edit->attr->text[2+2*preCP];
        preZi[3]=0x00;
        preZi[4]=0x00;
        preZi[5]=0x00;
        updateWindow( edit, dy);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,1,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdateUnicode(edit,1);
        }
        break;
    case ecBottom:                  //* cursor to end of text    
        //zgz, 2002.7.3 while (tbUnicode[edit->cp]!=UNICODE_EOLN)
        while( (p[2*edit->cp] != 0) || (p[2*edit->cp + 1] != 0) )
        {
            edit->cp = edit->cp +1;
        }
        pre_offs=edit->curOffs;
        edit->curOffs = 0;
        dy = 0;
        preCP=edit->cp;
        preZi[0]=0x80;
        preZi[1]=edit->attr->text[1+2*preCP];
        preZi[2]=edit->attr->text[2+2*preCP];
        preZi[3]=0x00;
        preZi[4]=0x00;
        preZi[5]=0x00;
        updateWindow( edit, dy);
        if( edit->curOffs==pre_offs )
            redrawcursor(preCX,preCY, preCSize,curCX,curCY,curCSize,1,edit->attr->fgColor);
        else
        {
            display=1;
            edtUpdateUnicode(edit,1);
        }
        break;
    case ecBack:                    //* backspace                
        if( edit->cp != 0 )
        {
            moveLeftUnicode(tbUnicode+edit->cp-1,1);
            if( strlenUnicode(tbUnicode) == 1 )    //zgz, 2002.7.31 add the if case for del the first byte 0x80 in buffer
                edit->attr->text[0] = 0;
        }
        pre_offs=edit->curOffs;
        if( edit->cp == 0 )
        {
            edit->cp = (wstrlen(edit->attr->text)-1)/2;  // zgz, change it

        }
        else
        {
            edit->cp = edit->cp-1; 
        }
        updateWindow( edit, dy);
        display=1;
        if( edit->attr->text[0] ==0 )
        {
            oldColor=dspl_GetBkgColor();
            if( edit->attr->fgColor<1 )
                edit->attr->fgColor=0xffffff;
            dspl_SetBkgColor(edit->attr->fgColor);
            /* 2003/11/29 sunsj modify for different font height */
            //dspl_Clear(edit->attr->win.px,edit->attr->win.py,edit->attr->win.px+32,edit->attr->win.py+32);
            dspl_Clear(edit->attr->win.px,edit->attr->win.py,edit->attr->win.px+32,edit->attr->win.py+fontHeight+1);

            inputIndicate_update(edit);
            /* 2003/12/29 sunsj modify for different font height */
            dspl_DrawLine(edit->attr->win.px,edit->attr->win.py+fontHeight,edit->attr->win.px+8,edit->attr->win.py+fontHeight);
            dspl_SetBkgColor(oldColor);
        }
        else
        {
            if( pre_offs==edit->curOffs )
                edtUpdateUnicode(edit,0);
            else
                edtUpdateUnicode(edit,1);
        }
        break;
    case ecDel:                     //* delete                   
        moveLeftUnicode(tbUnicode+edit->cp,1);
        //return edtCharUnicode(e,ecLeft);
        break;
    case ecEnter:                   //* cr/lf                    
        c = UNICODE_LINEFEED;
        edtInsertUnicode(edit,c,tbUnicode,bs);
        return edtCharUnicode(e,ecRight);
    default:                        //* normal char    


        if( strlenUnicode(tbUnicode) >= (((bs-3)/2)*2+1) )  // zgz,2002.7.25 this if sentense to handle the case when the buffer is full
        {
            /*     		if(edit->cp != (bs - 3) / 2)
                            edtCharUnicode(e, ecDel);
                        else
                            {
                                moveLeftUnicode(tbUnicode+edit->cp-1,1);
                                edtCharUnicode(e,ecLeft);
                            }
                            
                */  
            return MfwResDone;
        }

        else
        {
            edtInsertUnicode(edit,c,tbUnicode,bs);
            pre_offs=edit->curOffs;
            updateWindow(edit,0);
            if( pre_offs==edit->curOffs )
                edtUpdateUnicode(edit, 0);
            else
                edtUpdateUnicode(edit, 1); 

            return(edtCharUnicode(e,ecRight));

        }break;
    }
    return MfwResOk;
}

//zgz,2002.06.27
U16 strlenUnicode(U16* str)  //zgz, str point to text[1]
{
    //U16 len = 2; //First char is 0x80, second char is 0x00
    char *p;
    U16 len = 1; //zgz, First char is 0x80, add it

    p = (char *) str;

    while( (*p++ != 0) || (*p != 0) )
    {
        len += 2;
        p++;
    }
    return len;

}

//Assumptions :-
//str is a null-terminated string 
//edit->cp is the cursor position of the char 
//The string is inserted before the cursor char
//The cursor is moved strlen(str) chars forward.
MfwRes edtInsertString (MfwHnd e, char* insWord)
{
    MfwEdt *edit;
    char *textBfr;

    int lenText;
    int lenInsWord;
    int maxTextBfrLen;
    int i;

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            /* not an editor            */

    edit = ((MfwHdr *) e)->data;
    if( insWord == NULL )
        return(MfwResOk);  //no string to insert - trivial operation.
    if( insWord[0] == 0x00 )
        return(MfwResOk);  //no string to insert - trivial operation.
    textBfr         = edit->attr->text;
    if( (textBfr[0] == 0x80) || (textBfr[1] == 0x81) || (textBfr[2] == 0x82) )
    {//String is unicode
        return(edtInsertUnicodeString (e, insWord));
    }
    if( edit->attr->e_size==0 )
        maxTextBfrLen   = edit->attr->size;
    else
        maxTextBfrLen   = edit->attr->e_size;
    lenText     = strlen(textBfr);
    lenInsWord  = strlen(insWord);
    if( (lenText+lenInsWord) >= maxTextBfrLen )
        return(MfwResErr); //String too long 

    //move text up by 'lemnInsWord' words
    for( i=lenText;i>=edit->cp;i-- )
    {
        textBfr[i+lenInsWord]=textBfr[i];
    }
    //and copy string into buffer.
    for( i=0;i<lenInsWord;i++ )
        textBfr[edit->cp+i] = insWord[i];
    edit->cp = edit->cp+lenInsWord;
    //Update cursor position
    //<TBD>
    //And output updated text
    display = 1;
    updateWindow( edit, 0);
    edtUpdate(edit,1);

    return MfwResOk;
}
#define MAXWORD_ARRAY 32
//Assumptions :-
//'removeWord' is char array of MAXWORD chars 
//edit->cp is the cursor position of the char 
//The word removed is at or just before the cursor char
//The cursor is placed before the previous word.
//a space char (start or end) will be removed if there is one.
//GW 18/09/01 - Use 'isAWordChar' procedure
MfwRes edtRemoveString (MfwHnd e, char* removeWord)
{
    MfwEdt *edit;
    char *textBfr;

    int i,j;
    int stChr,endChr;

    if( dspl_get_char_type() != DSPL_TYPE_ASCII )
    {   //String is unicode - can't remove word (could remove a char but...)
        return(MfwResIllHnd);
    }

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            //* not an editor            *

    edit = ((MfwHdr *) e)->data;
    textBfr         = edit->attr->text;
    if( (textBfr[0] == 0x80) || (textBfr[1] == 0x81) || (textBfr[2] == 0x82) )
    {//String is unicode - can't remove word (could remove a char but...)
        return(MfwResIllHnd);
    }

    findWordBounds(edit, &stChr, &endChr);
    //Copy word out
    j = 0;
    for( i=stChr;i<endChr;i++ )
    {
        if( j<MAXWORD_ARRAY-1 )
        {
            removeWord[j] = textBfr[i];
            if( isAWordChar(removeWord[j]) )
                j++;//not punctuation .
            else if( removeWord[j] == ' ' ) //but do include last space (if it is a space)
                j++;
        }
    }
    removeWord[j] = 0x00;

    //and now move text up by 'j' chars.
    i=stChr;
    j=endChr; 
    //skip one space at start/end.
    if( textBfr[i] != ' ' )
    {
        i++;
        if( textBfr[j] == ' ' )
            j++;
    }
    //else overwrite first space
    edit->cp = i;

    while( (textBfr[i] != 0x00) && (i < j) )
    {
        textBfr[i] = textBfr[j];
        i++;
        j++;
    }

    display = 1;
    updateWindow( edit, 0);
    edtUpdate(edit,1);

    return MfwResOk;
}


//Create a copy of the current word.
//GW 18/09/01 - Use 'isAWordChar' procedure
MfwRes edtCopyString (MfwHnd e, char* removeWord)
{
    MfwEdt *edit;
    char *textBfr;

    int i,j;
    int stChr,endChr;

    if( dspl_get_char_type() != DSPL_TYPE_ASCII )
    {   //String is unicode - can't remove word (could remove a char but...)
        return(MfwResIllHnd);
    }

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            //* not an editor            *

    edit = ((MfwHdr *) e)->data;
    textBfr         = edit->attr->text;
    if( (textBfr[0] == 0x80) || (textBfr[0] == 0x81) || (textBfr[0] == 0x82) )
    {//String is unicode - can't remove word (could remove a char but...)
        return(MfwResIllHnd);
    }

    findWordBounds(edit, &stChr, &endChr);
    //Copy word out
    j = 0;
    for( i=stChr;i<endChr;i++ )
    {
        if( j<MAXWORD_ARRAY-1 )
        {
            removeWord[j] = textBfr[i];
            if( isAWordChar(removeWord[j]) )
                j++;//not punctuation.
            else if( removeWord[j] == ' ' ) //but do include last space (if it is a space)
                j++;
        }
    }
    removeWord[j] = 0x00;

    display = 1;
    updateWindow( edit, 0);
    edtUpdate(edit,1);

    return MfwResOk;
}




MfwRes edtInsertUnicodeString (MfwHnd e, char* insWordChar)
{
    MfwEdt *edit;
    U16 *unicodeBfr;

    int lenText;
    int lenInsWord;
    int maxTextBfrLen;
    int i;
    U16* insWordUnicode;
    insWordUnicode = (U16*) insWordChar;

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            //* not an editor 

    edit = ((MfwHdr *) e)->data;
    if( insWordUnicode == NULL )
        return(MfwResOk);  //no string to insert - trivial operation.
    if( insWordUnicode[0] == 0x0000 )
        return(MfwResOk);  //no string to insert - trivial operation.
    unicodeBfr  = (U16*) &edit->attr->text[2];
    if( (edit->attr->text[0] != (char)0x80) && 
        (edit->attr->text[0] != (char)0x81) && 
        (edit->attr->text[0] != (char)0x82) )
    {//String is unicode
        return(edtInsertString (e, insWordChar));
    }

    maxTextBfrLen   = edit->attr->size;
    lenText     = strlenUnicode(unicodeBfr);
    lenInsWord  = strlenUnicode(insWordUnicode);
    if( (lenText+lenInsWord) >= maxTextBfrLen )
        return(MfwResErr); //String too long 

    //move text up by 'lemnInsWord' chars
    for( i=lenText/2;i>=edit->cp;i-- )
    {
        unicodeBfr[i+lenInsWord]=unicodeBfr[i];
    }
    //and copy string into buffer.
    for( i=0;i<lenInsWord/2;i++ )
        unicodeBfr[edit->cp+i] = insWordUnicode[i];
    edit->cp = edit->cp+lenInsWord/2;
    //Update cursor position
    //<TBD>
    //And output updated text
    display = 1;
    updateWindow( edit, 0);
    edtUpdateUnicode(edit,1);

    return MfwResOk;
}




//Assumptions :-
//insWord is a null-terminated string, it can be Unicode or AsciiEx string.
//edit->cp is the cursor position of the char 
//The string is inserted before the cursor char
//The cursor is moved strlen(str) chars forward.
//zgz add, 2002.9.5
MfwRes edtInsertAnyString (MfwHnd e, char* insWord)
{
    MfwEdt *edit;
    char *textBfr;

    int lenText;
    int lenInsWord;
    int maxTextBfrLen,e_maxTextBfrLen;
    int i;
    char tmpBuffer[256];

    memset(tmpBuffer, 0, sizeof(tmpBuffer));

    if( !e )
        return MfwResIllHnd;

    if( ((MfwHdr *)e)->type != MfwTypEdt )
        return MfwResIllHnd;            /* not an editor            */

    edit = ((MfwHdr *) e)->data;

    if( insWord == NULL )     //zgz,null pointor
        return(MfwResOk);  //no string to insert - trivial operation.
    if( insWord[0] == 0x00 )
        return(MfwResOk);  //no string to insert - trivial operation.


    textBfr         = edit->attr->text;
    maxTextBfrLen   = edit->attr->size;
    if( edit->attr->e_size==0 )
        e_maxTextBfrLen=maxTextBfrLen;
    else
        e_maxTextBfrLen=edit->attr->e_size;

    if( (unsigned char)textBfr[0] != 0x80 )
    {  //textBfr is asciiEx string
        if( (unsigned char)insWord[0] != 0x80 )
        {  // insWord is asciiEx string
            lenText     = strlen(textBfr);
            lenInsWord  = strlen(insWord);
            if( (lenText+lenInsWord) >= (e_maxTextBfrLen -2) )
                return(MfwResErr); //String too long 

            for( i=lenText;i>=edit->cp;i-- )
            {
                textBfr[i+lenInsWord]=textBfr[i];
            }

            for( i=0;i<lenInsWord;i++ )
                textBfr[edit->cp+i] = insWord[i];
            textBfr[lenText+lenInsWord+1]='\0';

            edit->cp = edit->cp+lenInsWord;

        }
        else
        {  // insWord is unicode string
            lenInsWord = wstrlen(insWord);
            lenText = 2 * strlen(textBfr);
            if( (lenText+lenInsWord) >= (maxTextBfrLen -1) )
                return(MfwResErr); //String too long 

            strcpy(tmpBuffer, textBfr);
            AscEx_To_Unicode(tmpBuffer, textBfr);

            for( i=lenText + 1;i>=(2 * edit->cp +1);i-- )
            {
                textBfr[i+lenInsWord -1]=textBfr[i];
            }

            for( i=0;i<(lenInsWord-1);i++ )
                textBfr[2 * edit->cp+i + 1] = insWord[i + 1];
            textBfr[lenText+lenInsWord+1]='\0';
            edit->cp = edit->cp + lenInsWord/2;

        }
    }
    else
    { //textBfr is unicode string
        if( (unsigned char)insWord[0] != 0x80 )
        {  // insWord is asciiEx string
            lenText     = wstrlen(textBfr);
            lenInsWord =  2 * strlen(insWord);

            if( (lenText+lenInsWord) >= (maxTextBfrLen -1) )
                return(MfwResErr); //String too long 

            AscEx_To_Unicode(insWord, tmpBuffer);

            for( i=lenText ;i>=(2 * edit->cp +1);i-- )
            {
                textBfr[i+lenInsWord]=textBfr[i];
            }

            for( i=0;i<lenInsWord;i++ )
                textBfr[2 * edit->cp+i + 1] = tmpBuffer[i + 1];
            textBfr[lenText+lenInsWord+1]='\0';
            edit->cp = edit->cp + lenInsWord/2;
        }
        else
        {// insWord is unicode  string
            lenText     = wstrlen(textBfr);
            lenInsWord =  wstrlen(insWord);

            if( (lenText+lenInsWord - 1) >= (maxTextBfrLen -1) )
                return(MfwResErr); //String too long 

            for( i=lenText ;i>=(2 * edit->cp +1);i-- )
            {
                textBfr[i+lenInsWord -1]=textBfr[i];
            }

            for( i=0;i<(lenInsWord - 1);i++ )
                textBfr[2 * edit->cp+i + 1] = insWord[i + 1];

            textBfr[lenText+lenInsWord]='\0';
            textBfr[lenText+lenInsWord+1]='\0';

            edit->cp = edit->cp + lenInsWord/2;
        }
    }
    //Update cursor position
    //<TBD>
    //And output updated text
    display = 1;
    updateWindow( edit, 0);
    edtUpdate(edit,1);

    return MfwResOk;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtInsert          |
+--------------------------------------------------------------------+

  PURPOSE : insert editing char

*/
static int edtInsert (int c, char *b, int s)  //zgz, 2002.9.6 This func only for insert AsciiEX symbol
{
    //int size = (c > 0x80) ? 2 : 1;  
    int size = 1;  //zgz change,2002.9.6  

    if( !curMode )
        return 0;

    if( !(curMode & edtModOverWr) )
    {
        //zgz,2002.7.1 if ((int) strlen(b) >= s - size)          /* no more space in buffer  */
        if( (int) strlen(b) >= s - size - 2 )          /* no more space in buffer  */  //zgz,2002.7.1 now the null buffer is 3,  before, it's 1
            return 0;

        moveRight(b+curCP,strlen(b+curCP),size);
    }
    else
    {
        if( curCP > s-size )                /* SH - for overwrite mode, only stop input */
            return 0;                       /* when the cursor is at the maximum string size */
    }

    if( size == 2 )
        *((U16 *) (b+curCP)) = (U16) c;
    else
    {
        *(b+strlen(b)+1) = (char) 0;        // SH - make sure string is null terminated
        *(b+curCP) = (char) c;
    }
    return 1;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : moveRight          |
+--------------------------------------------------------------------+

  PURPOSE : move right memory
  s = no of chars to move 
  d = size (no of chars to be inserted in string) 
  b = current position
*/
static void moveRight (char *b, int s, int d)
{
    char *p;

    b += s++;                           /* start with trailing zero */
    p = b + d;                          /* new = old + distance     */
    p[1]=0x00;
    p[2]=0x00;
    while( s-- )
    {
        *p = *b;
        p--;
        b--;
    }
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : moveLeft           |
+--------------------------------------------------------------------+

  PURPOSE : move left memory
  s = no of chars to move 
  d = size (no of chars to be inserted in string) 
  b = current position
  str - string
*/
void moveLeft (char * str, int ofs)
{


    while( *str )
    {
        str[0] = str[ofs];
        //if (*str)
        str++;
    }
    str[0]=0x00;
    str[1]=0x00;

}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE : edtCommand         |
+--------------------------------------------------------------------+

  PURPOSE : handle mfw windows command

*/

static int edtCommand (U32 cmd, void *h)
{
    switch( cmd )
    {
    case MfwCmdDelete:              /* delete me                */
        if( !h )
            return 0;
        edtDelete(h);
#if(MAIN_LCD_SIZE==3)
		phonebook_search_flag=FALSE;
#endif
        return 1;
    case MfwCmdUpdate:              /* repaint                  */
        if( !h || ((MfwHdr *) h)->type != MfwTypEdt )
            return 0;
        //updateWindow(((MfwHdr *) h)->data, 0);
        /* 2003/12/01 sunsj remove because the screen was displaied twice */
        //edtUpdate(((MfwHdr *) h)->data,1);
        return 1;
    default:
        break;
    }

    return 0;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE :        |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/
//Move part of string right (delete char)
static void moveLeftUnicode(U16* unicodeStr, int nChars)
{

    UBYTE *p,  first_byte, second_byte;
    U16 twobytes;
    //Copy until end of line char reached - do not overwrite existing EOLN char 
    p = (UBYTE *) &(unicodeStr[0]);
    first_byte = *p++;
    second_byte = *p;
    twobytes = (U16) ((second_byte<<8) + first_byte);

    //zgz, 2002.0618 while (unicodeStr[0] != UNICODE_EOLN)
    while( twobytes != UNICODE_EOLN )
    {
        //zgz, 2002.06.18 unicodeStr[0] = unicodeStr[nChars];
        p = (UBYTE *) &(unicodeStr[nChars]);
        first_byte = *p++;
        second_byte = *p;
        twobytes = (U16) ((second_byte<<8) + first_byte);

        //unicodeStr[0] = twobytes;
        p = (UBYTE *) &(unicodeStr[0]);
        *p++ = first_byte;
        *p = second_byte;

        //zgz, 2002.06.18 if (unicodeStr[0] != UNICODE_EOLN)
        if( twobytes != UNICODE_EOLN )
            unicodeStr++;
        //else we have copied end of line char - stop.
    }
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE :        |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/
U16 strlenUnicodePixels(U16* str)
{
    U16 len = 0;
    while( *str!=UNICODE_EOLN )
    {   //Is next char an ascii char ? 
        if( (*str & UNICODE_NONASCII) != 0 )
            len = len+16;
        else
            len = len+8;
        str++;
    }
    return(len);
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE :        |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/
U16* strchrUnicode(U16* str,U16 chr)
{
    while( *str!=UNICODE_EOLN )
    {
        if( *str==chr )
            return(str);
        else
            str++;
    }
    return(NULL);
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE :        |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/
//Return pointer to end of unicode string.
U16* strendUnicode(U16* tp)
{
    UBYTE *p;
    p = (UBYTE *) tp;
    //while (*tp!=UNICODE_EOLN)
    while( (*p++ != 0) || (*p !=0) )
    {
        //tp++;
        p++;
    }

    p--;
    //return (tp);
    return((U16*) p);

}

static void moveRightUnicode(U16 *unicodeStr, int nChars)
{
    U16* strEndPtr;
    UBYTE *p, *q;

    strEndPtr = strendUnicode( unicodeStr);
    strEndPtr[1]=0x00;
    strEndPtr[2]=0x00;

    while( strEndPtr >= unicodeStr )
    {
        p = (UBYTE *) &(strEndPtr[nChars]);
        q = (UBYTE *) &(strEndPtr[0]);
        *p++ = *q++;
        *p = *q;
        strEndPtr--;
    }
}

static int edtInsertUnicode (MfwEdt *edit, int c, U16 *b, int s)
{   //Unicode chars are always 2 bytes.
    U16* bCursor;
    UBYTE *p;

    if( !curMode )
        return 0;

    if( strlenUnicode(b) >= s -2 )          //* no more space in buffer  *
        return 0;

    bCursor = b+edit->cp;

    if( !(curMode & edtModOverWr) )
        moveRightUnicode(bCursor,1);
    ////zgz,2002.06.27
    //*((U16 *) (b+edit->cp )) = (U16) c;
    p = (UBYTE *)(b+edit->cp);

    *p++ = (UBYTE)((c >> 8) & 0xff);
    *p = (UBYTE)(c & 0xff);

    return 1;

}

static void edtOutTextLines (int px, int py, int ls, int ly, U16 *tpUnicode, unsigned char* tpAscii)
{
    U16 ctWord;
    unsigned char ctByte;
    unsigned int fitChars;          //No of chars that fit on this line.
    U16 nextChar;                   //next char to display
    U16 afterSpaceChar;             //zgz, 2002.8.6 record the char after the space
    int lineWidth;                  //Width (so far) of the current line of text.
    int dispEnd = 0;
    int spaceChar;
    int charWidth;
    int punctuation;
    char chr;
    UBYTE *pTxt; //zgz added, 2002.06.18
    UBYTE first_byte; //zgz added,
    UBYTE second_byte; //zgz added,

    if( (tpAscii==NULL) && (tpUnicode == NULL) )
        return;

    fitChars = 0;
    if( tpAscii )
    {
        nextChar = (tpAscii[fitChars] << 8) & 0xFF00;
        if( (nextChar == UNICODE_LINEFEED) || (nextChar == UNICODE_CR) )
        {
            fitChars++;
            nextChar = (tpAscii[fitChars] << 8) & 0xFF00;
        }
    }
    else
    {
        pTxt = (UBYTE *) &(tpUnicode[fitChars]);
        //nextChar = (U16)((*pTxt++) + (*pTxt << 8));  //zgz, it can cause problem
        first_byte = *pTxt++;
        second_byte = *pTxt;
        nextChar = (U16) ((second_byte << 8) + first_byte);

        //zgz, nextChar = tpUnicode[fitChars];
        if( (nextChar == UNICODE_LINEFEED) || (nextChar == UNICODE_CR) )
        {
            fitChars++;
            //zgz,nextChar = tpUnicode[fitChars];
            pTxt = (UBYTE *) &(tpUnicode[fitChars]);
            //nextChar = (U16)((*pTxt++) + (*pTxt << 8));  //zgz, it can cause problem
            first_byte = *pTxt++;
            second_byte = *pTxt;
            nextChar = (U16) ((second_byte << 8) + first_byte);
        }
    }

    while( (nextChar != UNICODE_EOLN) && (!dispEnd) )                /* any more to display      */
    {
        fitChars = 0;
        afterSpaceChar = 0;   //zgz, 2002.8.16 initialize the char value
        if( tpAscii )
        {
            /* 2003/12/04 sunsj modify */
            //charWidth = 8;  //zgz, charWidth = 6;
            nextChar = tpAscii[fitChars];
            charWidth = get_CharWidth(nextChar);
            if( (nextChar == UNICODE_LINEFEED) || (nextChar == UNICODE_CR) )
            {   //linefeed - always start a new-line.
                charWidth = ls+1;
            }
        }
        else
        {
            //zgz,nextChar = tpUnicode[fitChars];
            pTxt = (UBYTE *) &(tpUnicode[fitChars]);
            //nextChar = (U16)((*pTxt++) + (*pTxt << 8));  //zgz, it can cause problem
            first_byte = *pTxt++;
            second_byte = *pTxt;
            nextChar = (U16) ((second_byte << 8) + first_byte);

            /* 2003/12/29 sunsj modify different font width */
            if( nextChar  &  UNICODE_NONASCII )
            {
                charWidth = UNI_CJK_WIDTH; //12;
            }
            else
            {
                /* 2003/10/28 modify for auto width char display */
                //charWidth = 8;  //6;
                USHORT temp;
                temp = (USHORT) ((first_byte << 8) + second_byte);
                charWidth = get_CharWidth(temp);
            }
            if( (nextChar == UNICODE_LINEFEED) || (nextChar == UNICODE_CR) )
            {   //linefeed - always start a new-line.
                charWidth = ls+1;
            }
        }
        lineWidth = 0;
        spaceChar = -2;

        while( (lineWidth <= ls) && (nextChar != UNICODE_EOLN) )
        {
            lineWidth = lineWidth + charWidth;

            if( spaceChar == fitChars )
            {   //zgz, 2002.8.6  record the char just after a space
            }

            //If the last char added still fits on the line
            if( lineWidth <= ls )
            {   //move on to the next character.
                fitChars++;
                //if the previous char was a space, we can cut the line on the next char.
                punctuation = FALSE;
                if( (nextChar  &  UNICODE_NONASCII) == 0 )  //zgz, 2002.8.1 if nextchar is ascii
                {
                    chr = (nextChar >> 8) & 0x00FF;
                }
                //Remember when we find a space if it is not the first char of a new line
                if( (fitChars > 1) &&
                    ((punctuation) || 
                     (nextChar == UNICODE_STARTHIGHLIGHT)|| 
                     (nextChar == UNICODE_ENDHIGHLIGHT)) )
                {   //save char after space.
                }

                if( tpAscii )
                {
                    /* 2003/10/28 sunsj only ascii text char width */
                    charWidth = get_CharWidth((USHORT)tpAscii[fitChars]);
                    //charWidth = 8; //6;

                    nextChar = (tpAscii[fitChars] << 8) & 0xFF00;
                }
                else
                {
                    //zgz, nextChar = tpUnicode[fitChars];
                    pTxt = (UBYTE *) &(tpUnicode[fitChars]);
                    //nextChar = (U16)((*pTxt++) + (*pTxt << 8));  //zgz, it can cause problem
                    first_byte = *pTxt++;
                    second_byte = *pTxt;
                    nextChar = (U16) ((second_byte << 8) + first_byte);
                    /* 2003/12/29 sunsj modify for different font width */
                    if( nextChar & UNICODE_NONASCII )
                    {
                        charWidth = UNI_CJK_WIDTH;  //12;
                    }
                    else
                    {
                        USHORT temp;
                        temp = (USHORT) ((first_byte << 8) + second_byte);
                        //charWidth = 8;  //6;
                        charWidth = get_CharWidth(temp);
                    }
                }

                if( (nextChar == UNICODE_LINEFEED) || (nextChar == UNICODE_CR) )
                {   //linefeed - always start a new-line.
                    charWidth = ls+1;
                }

            }
        }
        if( (nextChar == UNICODE_EOLN) && (lineWidth < ls) )  //zgz,2002.8.6 
        {
            /* all fits fine ...        */
            dispEnd = TRUE;
        }
        if( tpAscii )
        {
            ctByte = tpAscii[fitChars];         /* save not fitting char    */      
            tpAscii[fitChars] = 0x00;//UNICODE_EOLN;	/* cut the line             */
            //memset(&tpAscii[fitChars], 0x00, 1);
            if( display )
                //dspl_TextOut((U16)px,(U16)py, 0, (char*)tpAscii); /* display line         */
                scrText(px, py, 0, (char*)tpAscii);  //zgz, 2002.8.19

            //        edtShowLineUnicode(px,py,(char*)tp, fitChars,DSPL_TXTATTR_UNICODE);
            tpAscii[fitChars] = ctByte;         /* restore                  */
            tpAscii = &tpAscii[fitChars];               /* and go ahead             */
            //For linefeed char - move to next char.
            if( ((ctByte <<8) == UNICODE_LINEFEED) || ((ctByte <<8) == UNICODE_CR) )
                tpAscii++;
        }
        else
        {
            //zgzTraceString("All txt in buffer", tpUnicode);
            //zgz, ctWord = tpUnicode[fitChars];
            pTxt = (UBYTE *) &(tpUnicode[fitChars]);
            //ctWord = (U16)((*pTxt++) + ((*pTxt) << 8));
            first_byte = *pTxt++;
            second_byte = *pTxt;
            ctWord = (U16) ((second_byte << 8) + first_byte);   /* save not fitting char    */

            //zgz,  tpUnicode[fitChars] = UNICODE_EOLN;	/* cut the line             */
            *pTxt-- = 0x00;
            *pTxt = 0x00;

            if( display )
            {
                TRACE_EVENT("zgz, mfw_edt.c");
                TRACE_EVENT((char*)tpUnicode);
                //dspl_TextOut((U16)px,(U16)py, DSPL_TXTATTR_UNICODE, (char*)tpUnicode); /* display line         */
                scrText_Unicode(px, py, 0, (char*)tpUnicode);  //zgz, 2002.8.19
            }
            //zgz, 2002.0618  tpUnicode[fitChars] = ctWord;			/* restore                  */
            *pTxt++ = first_byte;
            *pTxt = second_byte;

            //zgzTraceData("tpUnicode[fitChars]",tpUnicode[fitChars]);

            tpUnicode = &(tpUnicode[fitChars]);             /* and go ahead             */
            if( (ctWord == UNICODE_LINEFEED) || (ctWord == UNICODE_CR) )
                tpUnicode++;
        }        
        py = py + fontHeight;           /* move to next screen line */
        if( py > ly - fontHeight )       /* past end of screen ?     */
            dispEnd = TRUE;             /* clip the rest            */
    }
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE :        |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/
MfwRes edtUpdateUnicode (MfwEdt *e,int all)
{
    int warn;
    UBYTE temp;
    S16 ls;                             /* width of edit window     */
    S16 ly;                             /* bottom of edit window    */
    U8 oldFont = -1;                    /* store previous font      */
    U8 uMode;
    U16 *tpWord;    
    U16 *tpShow;
    char *yq_do;
    U16 *endChar;   
    static char bmp[5];
    char text_more[33]="";
    char Trace_data[10]="";
    int len,i,j=0;
    UBYTE *zp;  // zgz added for debug, 2002.0619
    U16 charunicode;//store the current unicode char
    U8 *p;//the temp pointer,=tpshow
    UINT32 oldColor;
    USHORT  tempchar;       /* 2003/12/04 sunsj */

    // char spareNum[4];    //zgz,2002.06.28  temp buffer for spare number display
    //char *title; //zgz, 2002.7.2
    if( !e )
        return MfwResIllHnd;

    if( !e->attr->text )
        return MfwResErr;               /* no text to display       */

    if( ((unsigned char)e->attr->text[0] < 0x80) || ((unsigned char)e->attr->text[0] > 0x83) )
        return MfwResErr;               /* text is not unicode      */

    /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
    //if ( editForChineseInput )
    //    return(edtshowforchineseinput(e) );

    temp = dspl_get_char_type();        
    dspl_set_char_type(DSPL_TYPE_UNICODE);

    if( !(e->flags & MfwEdtVisible) )
        display = 0;                    /* invisible editor         */
    else display=1;

    if( display )
        uMode = dspl_Enable(0);

    //    textStart = &e->attr->text[1];          /* start of edit text -skip 1st char */
    tpWord = ((U16*)(&e->attr->text[1])) + e->curOffs;
    yq_do=(&e->attr->text[1])+(e->cp*2);
    tpShow=(U16*)yq_do;
    ls = e->attr->win.sx;               /* width of edit window     */
    ly = (S16) (e->attr->win.py+e->attr->win.sy);  /* bottom of edit window    */
    if( e->attr->font != (U8) -1 )
        oldFont = dspl_SelectFontbyID(e->attr->font); /* setup font */
    /* 2004/02/11 sunsj modify font height for cursor display */
    fontHeight = dspl_GetFontHeight()+1;  /* get height of curr font  */
    curMode = e->attr->mode;            /* setup edi mode           */
    /*    zgz,2002.7.1  to display title
        if (display)
            dspl_Clear(e->attr->win.px,e->attr->win.py,(U16)(ls+e->attr->win.px-1),(U16)(ly-1));
    */        
    if( display )
    {
        if( all )
        {
            oldColor=dspl_GetBkgColor();
            if( e->attr->fgColor<1 )
                e->attr->fgColor=0xffffff;
            dspl_SetBkgColor(e->attr->fgColor);
            if( (e->attr->titleMode==1) )//|| (e->attr->titleMode == TITLE_TOP)
                //dspl_Clear(1,e->attr->win.py,119,(U16)(ly));       			   
                dspl_Clear(0, e->attr->win.py, SCREEN_WIDTH, ly);
            else dspl_Clear(e->attr->win.px,e->attr->win.py,(U16)(ls+e->attr->win.px),(U16)(ly));
            edtOutTextLines(e->attr->win.px,e->attr->win.py,ls,ly,tpWord,NULL); //* show it     * /
            dspl_SetCursor(0,(U8)(curMode&edtCurMask));
            dspl_SetBkgColor(oldColor);
        }
        else
        {
            oldColor=dspl_GetBkgColor();
            if( e->attr->fgColor<1 )
                e->attr->fgColor=0xffffff;
            dspl_SetBkgColor(e->attr->fgColor);
            /* 2003/12/29 sunsj modify different font hight */
            dspl_Clear(curCX,curCY,(U16)(e->attr->win.px+ls),(U16)(curCY+fontHeight));
            /* 2004/01/02 sunsj clear the end of last line */
            if( e->cp_last_y != curCY )
            {
                /* 2004/04/06 sunsj modify */
                //dspl_Clear((U16)(e->attr->win.px+e->cp_last_x),(U16)e->cp_last_y,(U16)SCREEN_WIDTH,(U16)(e->cp_last_y+fontHeight));
                e->cp_last_y = curCY;
            }
            dspl_Clear(e->attr->win.px,curCY+fontHeight,(U16)(ls+e->attr->win.px),(U16)(ly));
            text_more[0]=0x80;
            i=1;
            len=0;
            p=(U8 *)tpShow;
            charunicode=(U16)((*(p + 1) << 8) + *p);
            /* 2003/12/29 sunsj modify for different font width */
            if( (charunicode& UNICODE_NONASCII) != 0 )
            {
                len = len+UNI_CJK_WIDTH;
            }
            else
            {
                //len = len+8;
                /* 2003/12/04 sunsj modify for get char length */
                tempchar = ((charunicode & 0x00ff)<<8) | ((charunicode & 0xff00) >> 8);
                len += get_CharWidth(tempchar);
            }
            if( (charunicode==0x0a00)||(charunicode==0x0d00) )
            {
                j=-1;
                tpShow++;
            }
            else if( (charunicode&0xffff)==0 )
            {
                j=-1;
            }
            else
            {
                tpShow++;
            }
            if( j!=-1 )
            {
                while( (len+curCX)<=(U16)(e->attr->win.px+ls) )//120 yq modified 2003/3/5
                {
                    p=(U8 *)tpShow;
                    charunicode=(U16)((*(p + 1) << 8) + *p);
                    if( (charunicode&0xffff)==0 )
                    {
                        j=-1;
                        break;
                    }
                    if( (charunicode==0x0a00)||(charunicode==0x0d00) )
                    {
                        j=-1;
                        /* 2004/05/08 sunsj modify for get char length */
                        tempchar = ((charunicode & 0x00ff)<<8) | ((charunicode & 0xff00) >> 8);
                        len = len + get_CharWidth(tempchar);

                        if( (len+curCX)<=(U16)(e->attr->win.px+ls) )//120
                            tpShow++;
                        break;
                    }
                    if( (*tpShow& UNICODE_NONASCII) != 0 )
                    {
                        /* 2004/01/04 sunsj modify */
                        len = len+UNI_CJK_WIDTH;
                    }
                    else
                    {
                        /* 2003/12/04 sunsj modify for get char length */
                        tempchar = ((charunicode & 0x00ff)<<8) | ((charunicode & 0xff00) >> 8);
                        len = len + get_CharWidth(tempchar);
                    }
                    if( (len+curCX)<=(U16)(e->attr->win.px+ls) )//120
                    {
                        i++;
                        tpShow++;
                    }
                }

            }
            if( j==-1 )
            {
                for( j=0;j<i;j++ )
                {
                    text_more[1+2*j]=yq_do[2*j];
                    text_more[2+2*j]=yq_do[2*j+1];
                }
                text_more[1+2*i]=0x00;
                text_more[2+2*i]=0x00;
                dspl_TextOut(curCX,curCY,0,text_more);
                //edtOutTextLines(e->attr->win.px,curCY+16,(U16)ls,(U16)ly,tpShow,NULL);
                /* 2003/12/29 sunsj modify for different font hight */
                if( ((*tpShow&0xffff)!=0)&&(ly-curCY-fontHeight>=fontHeight) )
                {
                    /* 2003/12/29 sunsj modify for different font hight */
                    edtOutTextLines(e->attr->win.px+1, curCY+fontHeight, (U16)ls, (U16)ly, tpShow, NULL);
                    //edtOutTextLines(e->attr->win.px,curCY+16,(U16)ls,(U16)ly,tpShow,NULL);
                }
                redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);                 
            }
            else
            {
                for( j=0;j<i;j++ )
                {
                    text_more[1+2*j]=yq_do[2*j];
                    text_more[2+2*j]=yq_do[2*j+1];
                }
                text_more[1+2*i]=0x00;
                text_more[2+2*i]=0x00;
                dspl_TextOut(curCX,curCY,0,text_more);
                /* 2003/12/29 sunsj modify for different font hight */
                if( ly-curCY-fontHeight >= fontHeight )
                {
                    edtOutTextLines(e->attr->win.px,curCY+fontHeight,(U16)ls,(U16)ly,tpShow,NULL);
                }
                redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);
            }
            dspl_SetBkgColor(oldColor);
        }
    }

    if( display )
    {
        //zgz, 2002.06.28  display my title
        inputIndicate_update(e);
    }

    //Add a space to the end of the line
    endChar = strendUnicode(tpWord);

    zp = (UBYTE*) endChar;
    endChar--;
    zp = (UBYTE*) endChar;

    {   //Cannot add space
        TRACE_EVENT("zgz, Not Add unicode space");
        //zgzTraceString("tpword is:", tpWord);
    }

    if( display && (curMode & edtCurMask) )
    {
        /* 2003/12/29 sunsj modify */
        //dspl_SetCursorPos(curCX,curCY,curCSize,(S16)fontHeight); /* display cursor           */
        dspl_SetCursorPos(curCX,curCY+1,curCSize,(S16)fontHeight); /* display cursor           */
    }
    if( oldFont != (U8) -1 )
        dspl_SelectFontbyID(oldFont);   /* restore previous font    */

    if( display )
        dspl_Enable(uMode);
    dspl_set_char_type(temp);

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_EDT            |
| STATE   : code                        ROUTINE :        |
+--------------------------------------------------------------------+

  PURPOSE : 

  GW 06/09/01 - Created
*/

//Incodmation relating to last 'space' char found.
typedef struct
{
    //	int txtWidth;
    //	int lineXpos;
    int charWidth;
    int lineCharPos;
    int nextCharWidth;  // 2002.8.6  char 's width after the space char
} T_SPACE_EDITINFO;

//Information about current editor
typedef struct
{
    int txtWidth;
    int charWidth;
    int endOfLine;      //TRUE indicates end of a text line
    int endOfText;      //TRUE indicates no more chars in line.
    int lineXpos;       //Current x-pos (in pixels) of cursor.
    int lineCharPos;    //Current char/word position in array
    int lastChar;       //index of last char on cursor line
    BOOL precedingEOL;  // sbh - preceding character was a CR/LF
    T_SPACE_EDITINFO space;
} T_EDITINFO;


//Calculate width of chars on screen so far.
//GW 18/09/01 - Corrected code dealing with linefeeds and also deal with carriage returns.
/* 2003/10/28 sunsj modify */
void getTotalWidth(U16 txtChar, int scrSxPixels, T_EDITINFO *editInfo )
{
    char chr;
    int punctuation;
    USHORT temp;    /* 2003/10/28 sunsj */

    editInfo->endOfLine = FALSE;

    if( editInfo->precedingEOL )             // Previous character was CR/LF
    {
        editInfo->precedingEOL = FALSE;
        editInfo->endOfLine = TRUE;
    }

    if( txtChar == UNICODE_EOLN )
    {
        editInfo->endOfText = TRUE;     
        /* 2004/04/30 sunsj modify for auto ascii char display */
        editInfo->charWidth = 8;  /* 2004/05/26 sunsj modify */									// sbh - Has width, so it can be wrapped if necessary
    }
    else if( (txtChar == UNICODE_LINEFEED) || (txtChar == UNICODE_CR) )
    {
        /* 2004/05/14 sunsj modify */
        editInfo->precedingEOL = TRUE;
        editInfo->charWidth = 8;  /* 2004/05/26 sunsj modify */
    }
    /* 2003/10/28 sunsj modify for auto width char */
    else if( (txtChar & UNICODE_NONASCII) == 0x0000 )
    {
        temp = ((txtChar & 0x00ff)<<8) | ((txtChar & 0xff00) >> 8);
        //editInfo->charWidth = 8; //6;
        editInfo->charWidth = get_CharWidth(temp);
    }
    else
    {
        editInfo->charWidth = UNI_CJK_WIDTH;  //12;
    }

    if( editInfo->txtWidth+editInfo->charWidth > scrSxPixels )
    {   //newline
        editInfo->txtWidth = 0;
        editInfo->endOfLine = TRUE;
    }
}
//Update the cursor position
void updateCursorPos(T_EDITINFO *editInfo,U16 start_x)
{
    /* 2003/10/28 sunsj modify */
    //if ( editInfo->charWidth < 16 )  //zgz,  6)
    //    editInfo->charWidth = 8;  //zgz, 6;
    curCSize    = editInfo->charWidth;
    curCX       = start_x+editInfo->txtWidth;
}

//dy - move cursor up/down screen by dy lines
MfwRes updateWindow (MfwEdt *e, int  dy )
{
    T_EDITINFO editInfo;

    //	int	winPos; - e->curOffs
    int winCharPos;     //char position  in string of the first text line in current window
    int winLineNo;      //line no of the first text line to be displayed

    //	int cursorPos;		//char position in string of start of the line with the cursor on it
    int ipCursorCharPos;    
    int opCursorCharPos;    
    int cursorLineNo;   //line no the cursor is on

    int linePos;        //char pos in string of current line.
    //int lineCharPos;	//character position in string of current (2 byte) char.
    int lineNo;         //overall displayed line (from start of text)

    int editComplete;   //flag indicating cursor position found/updated or end of line reached.

    int scrSxPixels;
    int scrSyLines;

    char* textStartAscii;
    U16* textStartUnicode;
    U16  charUnicode;   //current unicode char.

    int textStrType;
    int unicodeNum;  // zgz,2002.8.5 current unicode numbers in string
    U8 *p;  // zgz,2002.8.5 temp pointer
    //    TraceMMI("---updateWindow---");
    //Set up screen size - the width in pixels and no of lines displayed.
    preCX=curCX;
    preCY=curCY;
    preCSize=curCSize;//backup the previous cursor position and size.yq added 2002.9.24
	fontHeight = dspl_GetFontHeight();
#if(MAIN_LCD_SIZE==3)
    if( fontHeight > 5 )
	{
		if(phonebook_search_flag==TRUE)
			scrSyLines = e->attr->win.sy / (fontHeight+2);
		else
			scrSyLines = e->attr->win.sy / (fontHeight+14);
	}
    else
        scrSyLines = e->attr->win.sy / 6;
#elif(MAIN_LCD_SIZE==4)
    if( fontHeight > 5 )
        scrSyLines = e->attr->win.sy / (fontHeight+2);
    else
        scrSyLines = e->attr->win.sy / 6;
#endif
    scrSxPixels = e->attr->win.sx;

    ipCursorCharPos = e->cp;
    if( (ipCursorCharPos < 0) || (ipCursorCharPos > 32767) )
        ipCursorCharPos = 0;
    opCursorCharPos = ipCursorCharPos;
    lineNo = 0;
    winLineNo = 0;
    winCharPos = 0;
    editComplete = FALSE;
    editInfo.endOfText = FALSE;
    editInfo.lineCharPos = 0;
    editInfo.lastChar = 9999;
    editInfo.space.lineCharPos = 0;
    editInfo.space.nextCharWidth = 0;  //zgz, 2002.8.6 initialize it
    editInfo.precedingEOL = FALSE;
    linePos = 0;

    editInfo.txtWidth = 0;//e->attr->win.px
    cursorLineNo = 0;

    if( (e->attr->text[0] == (char)0x80) || 
        (e->attr->text[0] == (char)0x81) || 
        (e->attr->text[0] == (char)0x82) )
    {
        textStrType = DSPL_TYPE_UNICODE;
        textStartUnicode = (U16*) &e->attr->text[1];    /* start of edit text - 16 bits/char      */   //textStartUnicode = (U16*) &e->attr->text[2];    /* start of edit text - 16 bits/char      */
    }
    else
    {
        textStrType = DSPL_TYPE_ASCII;
        textStartAscii = &e->attr->text[0];             /* start of edit text - 8 bits/char       */
    }

    //Go through editor and work out 
    // (1) current x-pixel position for cursor 
    // (2) line number of the start of the display.
    while( (!editInfo.endOfText) && (!editComplete) )
    {
        if( textStrType == DSPL_TYPE_UNICODE )
        {
            p = (U8 *) &(textStartUnicode[editInfo.lineCharPos]);
            charUnicode = (U16)((*(p + 1) << 8) + *p);
            //charUnicode = textStartUnicode[editInfo.lineCharPos];

            getTotalWidth(charUnicode,scrSxPixels,&editInfo);
        }
        else
        {
            charUnicode = (textStartAscii[editInfo.lineCharPos] << 8) & 0xFF00;
            getTotalWidth(charUnicode,scrSxPixels,&editInfo);
            /* sbh - 21/02/02 - this is causing problems with wrapping symbols like ?(>0x80).
               Unsure as to status of extended ascii, but need to remove it for compliance.
            if (charUnicode & UNICODE_EXTENDEDASCII)
            {	//char is 2 bytes - move to next byte
                if (ipCursorCharPos==editInfo.lineCharPos)
                    ipCursorCharPos = ipCursorCharPos+1;
                editInfo.lineCharPos++;
                charUnicode = charUnicode | (textStartAscii[editInfo.lineCharPos] & 0x00FF);//not required but...
            }*/
        }

        if( editInfo.endOfLine )
        {
            //newline or current char will not fit on previous line.
            lineNo++;
            linePos = editInfo.lineCharPos;
            editInfo.txtWidth = 0;
            //Is this the first line to be displayed in the editor?
            if( editInfo.lineCharPos <= e->curOffs )
            {
                winLineNo = lineNo;
                winCharPos= editInfo.lineCharPos;
            }
            /*if (lineNo == cursorLineNo+dy+1)
            {//line after the cursor - remember number of chars on previous line.
//				editInfo.lastChar = editInfo.lineCharPos-1;
            } - sbh */
        }

        if( editInfo.endOfText )
        {
            //Cursor is past end of line - move to char before end of line.
            if( ipCursorCharPos > editInfo.lineCharPos )
            {
                //				if (editInfo.lineCharPos != 0)
                //					editInfo.lineCharPos = editInfo.lineCharPos-1;
                ipCursorCharPos = editInfo.lineCharPos;
                opCursorCharPos = editInfo.lineCharPos;
            }
        }

        if( editInfo.lineCharPos == ipCursorCharPos )
        {   //found the cursor position - either 
            //		the new pos if dy=0 or 
            //		the old pos if we have moved up/down a line.
            updateCursorPos(&editInfo,e->attr->win.px);
            editInfo.lineXpos  = editInfo.txtWidth;
            cursorLineNo   = lineNo;
            //			if (dy == -1)
            //				editInfo.lastChar = linePos-1;
            //If we are moving down a line (or more) then keep going
            //GW if (dy <= 0)
            //GW	editComplete = TRUE;
        }
        else if( (editInfo.lineCharPos > ipCursorCharPos) &&
                 (lineNo      > cursorLineNo      ) &&
                 (lineNo      > cursorLineNo + dy) )
        {
            //we have moved far enough down to store all required information
            editComplete   = TRUE;
        }
        editInfo.txtWidth = editInfo.txtWidth + editInfo.charWidth;
        editInfo.lineCharPos++;
        /* 2004/01/02 sunsj get current line text width */
        if( e->cp_last_y == lineNo*fontHeight+e->attr->win.py )
        {
            e->cp_last_x = editInfo.txtWidth;
        }
    }   //end while

    //We now know either (a) the line the cursor is on and the char offset of the cursor or (b) the
    //original line the cursor was on and the x-pixel position of the cursor (for dy != 0)  

    if( dy )
    {   //update line with the cursor on it
        if( cursorLineNo+dy >lineNo )
            cursorLineNo = lineNo; //last line of editor.
        else if( cursorLineNo+dy < 0 )
            cursorLineNo = 0;
        else
            cursorLineNo = cursorLineNo+dy;

        //Now we need to calculate cursor char pos. 'opCursorCharPos'

    }
    else
    {
        //Cursor line no is already set up.

        //the new cursor position was passed into the procedure.
        opCursorCharPos = ipCursorCharPos;
    }

    editInfo.lineCharPos = 0;
    lineNo    = 0;
    editInfo.txtWidth  = 0;
    editComplete = FALSE;
    editInfo.endOfText = FALSE;
    editInfo.space.lineCharPos = 0;
    editInfo.space.nextCharWidth = 0;  //zgz, 2002.8.6 initialize it
    editInfo.precedingEOL = FALSE;

    //Update start of windows position
    if( cursorLineNo < winLineNo || !(e->attr->mode & edtCurMask) )
    {//cursor is on a line before current window screen - search from the start
        // sbh - or we're in read-only mode, no cursor, scroll with every up/down press
        winLineNo = cursorLineNo;
        winCharPos = 0;
    }
    else if( cursorLineNo >= winLineNo+scrSyLines )
    {   //cursor is below the bottom of the screen
        winLineNo = cursorLineNo-(scrSyLines-1);
        winCharPos = 0;
    }
    else if( dy != 0 )
    {   //windows line no is unchanged - start search at win char pos.
        editInfo.lineCharPos = winCharPos;
        lineNo = winLineNo;
    }
    else
    {   //we do not need to calculate new window position - it is unchanged.
        //and we have already calculated the new cursor position.
        editComplete = TRUE;
    }

    //Calculate last char on cursor line and winCharPos
    if( !editComplete )
    {
        while( (!editInfo.endOfText) && (!editComplete) )
        {
            if( textStrType == DSPL_TYPE_UNICODE )
            {
                //charUnicode = textStartUnicode[editInfo.lineCharPos];
                p = (U8 *) &(textStartUnicode[editInfo.lineCharPos]);
                charUnicode = (U16)((*(p + 1) << 8) + *p);
                getTotalWidth(charUnicode,scrSxPixels,&editInfo);
            }
            else
            {
                charUnicode = (textStartAscii[editInfo.lineCharPos] << 8) & 0xFF00;
                getTotalWidth(charUnicode,scrSxPixels,&editInfo);
                /* sbh - 21/02/02 - this is causing problems with wrapping symbols like ?(>0x80).
               Unsure as to status of extended ascii, but need to remove it for compliance.
                if (charUnicode & UNICODE_EXTENDEDASCII)
                {	//char is 2 bytes - move to next byte
                    if (ipCursorCharPos==editInfo.lineCharPos)
                        ipCursorCharPos = ipCursorCharPos+1;
                    editInfo.lineCharPos++;
                    charUnicode = charUnicode | (textStartAscii[editInfo.lineCharPos] & 0x00FF);//not required but...
                }*/
            }
            if( editInfo.endOfLine )
            {   //newline
                editInfo.txtWidth = 0;
                //update start of window.
                linePos = editInfo.lineCharPos;

                //Remember char before first char on next line.
                if( lineNo == cursorLineNo )
                {
                    if( ipCursorCharPos >=  editInfo.lineCharPos )
                        ipCursorCharPos = editInfo.lineCharPos-1;
                }
                lineNo++;
                if( winLineNo == lineNo )
                    winCharPos = editInfo.lineCharPos;
            }
            if( dy!=0 )
            {   //line number has changed
                //Once we have found the correct line, look for the char at the same x-pixel pos
                //as before (or the last char before we pass the position).
                if( lineNo == cursorLineNo )
                {
                    if( editInfo.txtWidth <= editInfo.lineXpos )
                    {   //Update cursor char pos...
                        ipCursorCharPos = editInfo.lineCharPos;
                    }
                }
            }

            //else if (lineNo > cursorLineNo) //...or we start a new line    //zgz, 2002.8.5 Maybe this is a wrong
            if( lineNo > cursorLineNo ) //...or we start a new line    //zgz, 2002.8.5 Maybe this is a wrong
            {
                editComplete = TRUE;
            }

            editInfo.txtWidth = editInfo.txtWidth + editInfo.charWidth;
            editInfo.lineCharPos++;
        }   //end while

        editComplete = FALSE;
    }

    editInfo.lineCharPos = winCharPos;
    lineNo    = winLineNo;
    editInfo.txtWidth  = 0;
    editInfo.endOfText = FALSE;
    editInfo.space.lineCharPos = 0;
    editInfo.space.nextCharWidth = 0;  //zgz, 2002.8.6 initialize it
    editInfo.precedingEOL = FALSE;

    //Calculate where the window is to start from
    while( (!editInfo.endOfText) && (!editComplete) )
    {
        if( textStrType == DSPL_TYPE_UNICODE )
        {
            //charUnicode = textStartUnicode[editInfo.lineCharPos];
            p = (U8 *) &(textStartUnicode[editInfo.lineCharPos]);
            charUnicode = (U16)((*(p + 1) << 8) + *p);
            getTotalWidth(charUnicode,scrSxPixels,&editInfo);
        }
        else
        {
            charUnicode = (textStartAscii[editInfo.lineCharPos] << 8) & 0xFF00;
            getTotalWidth(charUnicode,scrSxPixels,&editInfo);
            /* sbh - 21/02/02 - this is causing problems with wrapping symbols like ?(>0x80).
               Unsure as to status of extended ascii, but need to remove it for compliance.
            if (charUnicode & UNICODE_EXTENDEDASCII)
            {	//char is 2 bytes - move to next byte
                if (ipCursorCharPos==editInfo.lineCharPos)
                    ipCursorCharPos = ipCursorCharPos+1;
                editInfo.lineCharPos++;
                charUnicode = charUnicode | (textStartAscii[editInfo.lineCharPos] & 0x00FF);//not required but...
            }*/
        }
        if( editInfo.endOfLine )
        {   //newline
            editInfo.txtWidth = 0;
            //update start of window.
            linePos = editInfo.lineCharPos;
            lineNo++;
        }

        if( (lineNo == cursorLineNo) &&
            (ipCursorCharPos == editInfo.lineCharPos) )
        {   //we have reached desired char.
            opCursorCharPos = editInfo.lineCharPos;
            updateCursorPos(&editInfo,e->attr->win.px);
            cursorLineNo   = lineNo;
            editComplete = TRUE;
        }

        editInfo.txtWidth = editInfo.txtWidth + editInfo.charWidth;
        editInfo.lineCharPos++;
    }   //end while

    //Calculate y position of cursor
    /* 2004/02/11 sunsj modify line height for cursor */
    curCY = (cursorLineNo - winLineNo)*(fontHeight+1)+e->attr->win.py; 
    /* 2004/01/02 sunsj add */
    if( e->cp_last_y == 0 )
    {
        e->cp_last_y = curCY;
    }
    //Output updated window start position
    e->curOffs = winCharPos;
    e->cp = opCursorCharPos;

    if( textStrType == DSPL_TYPE_UNICODE )
    {
        unicodeNum = strlenUnicode(textStartUnicode) / 2;
        if( e->cp > unicodeNum )
            e->cp = unicodeNum;
    }
    return(MfwResOk);
}

//zgz,2002.06.26
//Get  spare Numbers of symbol in the editor buffer, it perhaps be displayed at the title
int getSymbolNumSpare(MfwEdt *e)
{
    char *tbString; 
    U16 bs,ebs; 
    U16  uniStrLen;
    unsigned char firstChar; 
    U8  nextSymLen;

    if( !e )
        return -2;


    //edit = ((MfwHdr *) e)->data;
    tbString = &e->attr->text[0];
    firstChar = (unsigned char)e->attr->text[0];
    bs = e->attr->size;
    //zgzTraceDataFunc("yq:e_size:",e->attr->e_size);
    if( e->attr->e_size==0 )
        ebs=bs;
    else
        ebs=e->attr->e_size;
    nextSymLen = getNextInputLen();

    if( firstChar != 0x80 )
    {
        if( firstChar != 0 )  // Buffer is all Ascii
        {
            if( nextSymLen == 1 )
                return(ebs - 3 - strlen(tbString));
            else
            {
                if( (2 * strlen(tbString)) <= (bs - 3) )    // there are space in buffer
                    return(bs -3 -2 * strlen(tbString)) / 2;
                else                                // no space in buffer
                    return -1;  //error
            }
        }
        else                // fistChar is 0, so buffer have no content
        {
            if( nextSymLen == 1 )
            {
                //zgzTraceDataFunc("null in english",ebs);
                return(ebs - 3);
            }
            else
                return(bs - 3) / 2;
        }
    }
    else                    //firstChar is 0x80,
    {
        if( ecDel_uniFlag )
        {
            if( nextSymLen == 2 )
            {
                uniStrLen = strlenUnicode((U16 *)(tbString + 1));
                return(bs - 3 - uniStrLen + 1) / 2;
            }
            else
            {
                uniStrLen = strlenUnicode((U16 *)(tbString + 1));
                if( All_Is_AscEx(tbString, uniStrLen) )    // if all unicode can be convert to ascii
                    return(ebs - 3 - uniStrLen / 2);
                else                                //there are still unicode in the string
                    return(bs - 3 - uniStrLen + 1) / 2;
            }

        }
        else  // when there are unicode in the buffer, the next input is always unicode or convert to unicode
        {
            uniStrLen = strlenUnicode((U16 *)(tbString + 1));
            return(bs - 3 - uniStrLen + 1) / 2;
        }
    }

    return -2;

}


MfwRes inputIndicate_update(MfwEdt * e)  // zgz, 2002.7.5 Mobile Innovation
{
    S16 px, py;                         /* top left corner of edit  */
    S16 ls;                             /* width of edit window     */
    S16 ly;                             /* bottom of edit window    */
    char spareNum[4];    //zgz,2002.06.28  temp buffer for spare number display
    U8 uMode; 
    int currentTheme;

    S16 x;  
    S16 y;
    int title_len;//the title length in pixels
    char *title;    
    UINT32 oldColor;

    px = e->attr->win.px;               /* left of edit window      */
    py = e->attr->win.py;               /* top of edit window       */
    ls = e->attr->win.sx;               /* width of edit window     */
    ly = (S16) (py+e->attr->win.sy);    /* bottom of edit window    */
    fontHeight = dspl_GetFontHeight();  /* get height of curr font  */
    currentTheme=FlashSettingData.theme;

    //    if(display)
    uMode = dspl_Enable(0);

    if( e->attr->titleMode == TITLE_TOP )
    {
        x = 1;
        y = 1;
        py = 18;
    }
    else
    {
        x = px;
        y = py - fontHeight - 1;
    }

    //    if (display)
    {

        if( (e->attr->titleMode == 1) || (e->attr->titleMode == TITLE_TOP) )
        {
            if( e->attr->title_id )
            {
                /* draw title icon */
				/* 2004/06 sunsj modify for picture manage */
				DRAW_ICON(ICON_MENUUP);

                title = (char *) MmiRsrcGetText(e->attr->title_id);  // get the editor title text
                /* 2004/02/26 sunsj modify */
                //if( title[0] == (char)0x80 )
                {
                    /* 2003/12/04 sunsj modify count title length */
                    //title_len=(wstrlen(title)-1)/2*16;
                    title_len = get_StringWidth(title);
#if (MAIN_LCD_SIZE==3)//jhxu720
                    title_len=(SCREEN_WIDTH-title_len)/2>0?(94-title_len)/2:0;
#elif ( MAIN_LCD_SIZE==4 )
                    title_len=(SCREEN_WIDTH-title_len)/2>0?(94-title_len)/2:0;
#elif ( MAIN_LCD_SIZE==2 )
		    /* 2004/04/02 sunsj modify for title display */
                    title_len=(SCREEN_WIDTH-title_len)/2>0?(102-title_len)/2:0;
#endif
                    //title_len=(e->attr->win.sx-title_len)/2>0?(e->attr->win.sx-title_len)/2:0;						
                    //dspl_colorTextOut(1 + title_len, y,DSPL_TXTATTR_UNICODE, title,GetPreDefinedColor(ColorMenuTitleFont));
                    /* 2004/06/08 sunsj modify get text length. If text length is larger than limit the 
                       display info will be set to zero */
                    if( getSymbolNumSpare(e) >= 0 )
                    {
					sprintf(spareNum, "%3d", getSymbolNumSpare(e));
                    }
                    else
                    {
                        sprintf(spareNum, "%3d", 0);
                    }
#if (MAIN_LCD_SIZE==3)//jhxu720
                    displayTitle( 15, title, spareNum, 4, 0xffffff, 0);//shiheng 288 0618 add
#elif ( MAIN_LCD_SIZE==4 )
					displayTitle( 15, title, spareNum, 4, 0, 0);
                    //drawcolorclarity(1 + title_len,y ,title, 0x000000);
#elif ( MAIN_LCD_SIZE==2 )
                    /* 2004/04/02 sunsj modify for title display */
                    //drawcolorclarity(title_len,y ,title, 0x000000);
					displayTitle( 15, title, spareNum, 4, 0, 0);
#endif
                }
            }
			
            /* 2004/03/02 sunsj remove because we display input method icon on title line */
            /*
            if( e->attr->titleMode == 1 )
            {
                oldColor=dspl_GetBkgColor();
                dspl_SetBkgColor(e->attr->fgColor);
                dspl_Clear(0, ly, SCREEN_WIDTH, (SCREEN_HIGH-fontHeight-2));
                dspl_SetBkgColor(oldColor);
            }
            */
            /* 2003/12/04 sunsj remove */
#if 0
            switch( get_ecinput_mode() )
            {
            case PARADISE_MODE:
                dspl_BitBlt(82, 130, 37, 12, 0, (void *)chinese_bmp, 0);
                //dspl_BitBlt(x, y+1, 14, 14, 0, (void *)chinese_bmp, 0);
                break;
                /* 2003/11/10 sunsj add */
            case STROKE_MODE:
                dspl_BitBlt(82, 130, 37, 12, 0, (void *)chinese_bmp, 0);
                break;
            case UPPERCASE_MODE:
                dspl_BitBlt(82, 130, 37, 12, 0, (void *)ABC_bmp, 0);
                //dspl_BitBlt(x, y+1, 14, 14, 0, (void *)ABC_bmp, 0);
                break;
            case LOWERCASE_MODE:
                dspl_BitBlt(82, 130, 37, 12, 0, (void *)abc_bmp, 0);
                //dspl_BitBlt(x, y+1, 14, 14, 0, (void *)abc_bmp, 0);
                break;
            case SHUZI_MODE:
            case PHONENUMONLY_MODE:
                dspl_BitBlt(82, 130, 37, 12, 0, (void *)D123_bmp, 0);
                //dspl_BitBlt(x, y+1, 14, 14, 0, (void *)D123_bmp, 0);
                break;
            default:
                break;
            }               
#endif           
        }
        else if( e->attr->titleMode == 2 )
        {
			/* 2004/06 sunsj modify for picture manage */
			DRAW_ICON(ICON_MENUUP);

            title = (char *) MmiRsrcGetText(e->attr->title_id);                             
            //dspl_colorTextOut(e->attr->win.px, e->attr->win.py - fontHeight - 1,0, title,GetPreDefinedColor(ColorMenuTitleFont));
            drawcolorclarity(e->attr->win.px+1,1 ,title, 0x000000);
            if( e->attr->textnum )
                //dspl_colorTextOut(120-strlen(e->attr->textnum)*8, 0, 0, e->attr->textnum, GetPreDefinedColor(ColorMenuTitleFont));
                drawcolorclarity(SCREEN_WIDTH-1-strlen(e->attr->textnum)*8,1 ,e->attr->textnum, 0x000000);
        }
    }
    //    if(display)
    dspl_Enable(uMode);

    return MfwResOk;
}

/*****************************************************************************
yq added to redraw the cursor
*****************************************************************************/
void redrawcursor(U16 pre_x,U16 pre_y,U16 pre_w,U16 cur_x,U16 cur_y,U16 cur_w,int flag,UINT32 fgcolor)
{

    UINT32 b_color,f_color;
    char Trace_data[10]=""; 
    fontHeight = dspl_GetFontHeight();  /* 2003/12/29 sunsj add for different font hight */

    /* 2003/10/13 sunsj modify for remove mmihz.c & mmihzapi.c */
    if( pre_x==cur_x&&pre_y==cur_y /*&&!editForChineseInput */ )
        return;
    TRACE_EVENT("redraw cursor");
    Sprintf(Trace_data,"%d",pre_x);
    TRACE_EVENT(Trace_data);
    Sprintf(Trace_data,"%d",pre_y);
    TRACE_EVENT(Trace_data);
    Sprintf(Trace_data,"%d",cur_x);
    TRACE_EVENT(Trace_data);
    Sprintf(Trace_data,"%d",cur_y);
    TRACE_EVENT(Trace_data);
    b_color=dspl_GetBkgColor();
    f_color=dspl_GetFrgColor();

    dspl_SetFrgColor(fgcolor);
    //	if(pre_w==8)
    /* 2003/12/29 sunsj modify for different fong hight */
    dspl_DrawLine(pre_x,pre_y+fontHeight,pre_x-1+pre_w,pre_y+fontHeight);
    dspl_SetBkgColor(fgcolor);
    dspl_SetFrgColor(f_color);
    /* 2003/12/29 sunsj modify different font width */
    if( (pre_w == UNI_CJK_WIDTH) && (flag == 1) )
    {
        dspl_TextOut(pre_x,pre_y,0,preZi);
    }//we refresh the hanzi of pre cursor.
    //	else
    //		dspl_DrawLine(pre_x,pre_y+16,pre_x-1+pre_w,pre_y+16);
    //	dspl_SetFrgColor(f_color);
    //	if(cur_w==8)

    /* 2003/12/29 sunsj modify */
    //dspl_DrawLine(cur_x,cur_y+fontHeight+1,cur_x-1+cur_w,cur_y+fontHeight+1);
    dspl_DrawLine(cur_x,cur_y+fontHeight,cur_x-1+cur_w,cur_y+fontHeight);
    dspl_SetBkgColor(b_color);
    //	else
    //		dspl_DrawLine(cur_x,cur_y+16,cur_x-1+cur_w,cur_y+16);
}

/*********************************************************************************
zhangxp added to show text when exiting from chinese input
*********************************************************************************/
static MfwRes edtshowforchineseinput (MfwEdt *e)
{
    char *tp,*tShow;
    U16  *tpWord,*tpShow;
    S16 px,py,ls,ly;
    char text_more[100];
    U16 pre_offs;
    int len,line;
    U8 *p;
    U16 uniword;
    UINT32 oldColor;
    U8 uMode;

    TRACE_EVENT("edtshowforchineseinput");

    if( !e )
        return MfwResIllHnd;

    if( !e->attr->text )
        return MfwResErr;

    uMode = dspl_Enable(0);
    if( e->attr->text[0]!=0x80 )
    {
        TRACE_EVENT("ASCII");
        tp = e->attr->text + e->curOffs;    /* start of display buffer  */    
        px = e->attr->win.px;               /* left of edit window      */
        py = e->attr->win.py;               /* top of edit window       */
        ls = e->attr->win.sx;               /* width of edit window     */
        ly = (S16) (py+e->attr->win.sy);
        len=0;
        line=0;

        while( (*tp!='\0')&&(line<4) )
        {

            if( (*tp==0x0a)||(*tp==0x0d) )
            {
                tp++;
                line++;
                len=0;
            }
            else
            {
                len+=8;
                tp++;
                if( len>ls )
                {
                    line++;
                    len=8;
                }
            }                   
        }
        oldColor=dspl_GetBkgColor();
        dspl_SetBkgColor(e->attr->fgColor);
        if( line<4 )
            dspl_Clear(0,82,SCREEN_WIDTH,132);
        else
        {
            TRACE_EVENT("line>=4");
            dspl_Clear(0,82,SCREEN_WIDTH,132);
            edtOutTextLines(px,(U16)(py+16*4),ls,ly,NULL,(unsigned char *)(tp-1));
        } 
        dspl_SetBkgColor(oldColor);

    }
    else
    {
        TRACE_EVENT("UNICODE");
        tpWord = ((U16*)(&e->attr->text[1])) + e->curOffs;
        ls = e->attr->win.sx;               /* width of edit window     */
        ly = (S16) (e->attr->win.py+e->attr->win.sy); 
        len=0;
        line=0;
        p=(U8 *)tpWord;
        uniword=(U16)((*(p + 1) << 8) + *p);
        while( ((uniword&0xffff)!=0)&&(line<4) )
        {
            if( (uniword& UNICODE_NONASCII) != 0 )
            {
                len+=16;
                p+=2;
                if( len>ls )
                {
                    line++;
                    len=16;
                }
            }
            else if( (uniword!=0x0a00)&&(uniword!=0x0d00) )
            {
                len+= 8;
                p+=2;
                if( len>ls )
                {
                    line++;
                    len=8;
                }
            }

            else if( (uniword==0x0a00)||(uniword==0x0d00) )
            {
                p+=2;                     
                line++;
                len=0;
            }
            uniword=(U16)((*(p + 1) << 8) + *p);
        }
        oldColor=dspl_GetBkgColor();
        dspl_SetBkgColor(e->attr->fgColor);
        if( line<4 )
        {
            dspl_Clear(0,82,SCREEN_WIDTH,132);
            redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,1,e->attr->fgColor);
        }
        else
        {
            TRACE_EVENT("line>=4");
            dspl_Clear(0,82,SCREEN_WIDTH,132);
            edtOutTextLines(e->attr->win.px,(U16)(e->attr->win.py+16*4),ls,ly,(U16 *)(p-2),NULL);
            redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);

            TRACE_EVENT("end of edtshowforchineseinput");                         
        }
        dspl_SetBkgColor(oldColor);
    }
    //updateWindow(e, 0);            //zhangxp added 2003/3/27
    /*
        if(pre_offs==e->curOffs)
           redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,1,e->attr->fgColor);
        else redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,0,e->attr->fgColor);
    */

    /* 2003/10/13 sunsj mark for remove mmihz.c & mmihzapi.c */
    //if ( editForChineseInput )
    //    editForChineseInput=0;

    // redrawcursor(preCX,preCY,preCSize,curCX,curCY,curCSize,1,e->attr->fgColor);
    inputIndicate_update(e);
    dspl_Enable(uMode);
    return MfwResOk;

}
