/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile:: mfw_kbd.c       $|
| $Author: zhenggl $ CONDAT GmbH           $Revision: 1.4 $|
| CREATED: 21.09.98                     $Modtime:: 23.03.00 8:24    $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : MFW_KBD

   PURPOSE : keyboard handling functions

   EXPORT  :

   TO DO   : adjust PEI/driver interface

   $History:: mfw_kbd.c                                             $
 *
 * *****************  Version 18  *****************
 * User: Es           Date: 23.03.00   Time: 14:48
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * no stddefs ???
 *
 * *****************  Version 17  *****************
 * User: Rm           Date: 23-02-00   Time: 3:15p
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * stop Auto and Long timer finishing with kbdAlways
|
| *****************  Version 16  *****************
| User: Le           Date: 26.01.00   Time: 12:13
| Updated in $/GSM/Condat/MS/SRC/MFW
| Make definition different for Windows and Target
 *
 * *****************  Version 15  *****************
 * User: Be           Date: 25.01.00   Time: 18:20
 * Updated in $/GSM/Condat/MS/SRC/MFW
|
| *****************  Version 14  *****************
| User: Le           Date: 6.01.00    Time: 9:23
| Updated in $/GSM/Condat/MS/SRC/MFW
| Alignment of MFW versions
 *
 * *****************  Version 3  *****************
 * User: Be           Date: 29.11.99   Time: 14:31
 * Updated in $/GSM/Condat/SND-MMI/MFW
 * target integration
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 22.11.99   Time: 10:29
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 1  *****************
 * User: Es           Date: 18.11.99   Time: 16:35
 * Created in $/GSM/Condat/SND-MMI/MFW
 * Initial
 *
 * *****************  Version 13  *****************
 * User: Es           Date: 6.07.99    Time: 12:20
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 11  *****************
 * User: Es           Date: 1.04.99    Time: 17:07
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * removed lots of traces
 *
 * *****************  Version 10  *****************
 * User: Es           Date: 18.02.99   Time: 17:01
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 9  *****************
 * User: Es           Date: 17.02.99   Time: 19:11
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 8  *****************
 * User: Es           Date: 14.01.99   Time: 17:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 7  *****************
 * User: Es           Date: 23.12.98   Time: 16:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * data:            modifier
 * 08/12           zym add in kbdsignal
*/

#define ENTITY_MFW

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include <stdio.h>
#include <string.h>
#include "mfw_mfw.h"
#include "mfw_sys.h"
#include "mfw_tim.h"
#include "drv_key.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "kpd_api.h"
#include "mfw_ffs.h"
#include "mfw_utils.h"
#include "pwr.h"
#include "r2d.h"

#include "light.h"
//#define TDTRACE 1
#include "../bmi/mmiutilapi.h"
// 2004.4.9 WYJ
#include "../bmi/mmisounds_defs.h"
extern void StartPlayByReason(AUDIO_REASON reasonid, BOOLEANS index);

static int kbdCommand (U32 cmd, void *h);
static int toLong (U32 t, void *h);
static int toAuto (U32 t, void *h);
extern MfwHnd gtVibator;

static MfwCb doAlways;                  /* all cases handler        */
static MfwHdr timLongH;                 /* the long press timer     */
static MfwTim timLong;
static MfwHdr timAutoH;                 /* the auto repeat timer    */
static MfwTim timAuto;
static U32 valAuto;                     /* auto start intervall     */
static U32 valRepeat;                   /* auto repeat intervall    */
static U32 curMap;                      /* current key map          */
static U8 curKey;                       /* current key code         */
static int nElements=0;
static int still_processing_flag;
driver_Parameter drvpara;
// PATCH LE 06.06.00
// current MFW element needed for multiple instances
EXTERN MfwHdr * current_mfw_elem;
extern int g_keypadnum;
extern BOOL call_win_flag;

extern UINT32 driverFlag;  //xsf add for KCD_LEFT 2003.01.14

extern INT8 r2d_g_event_was_sent;
extern UBYTE animation_complete ;  //xsf add 2003.02.20
int   g_kpdnum =0 ;   ///zym added 10/18
int   g_kpdtim = 0;  ///zym added 10/18

extern int NotCharingMode;	/* 2004/07/05 sunsj modify */
/* 2004/07/09 sunsj add for forbidden hall off */
extern int HallOffForbid;

#define PRENUMPERSEC 4   //zym added 10/18
// END PATCH LE 06.06.00
/*
** KeyPress Buffer Macros and Limits
*/

#define MAX_KPRESS_BFR 100

typedef struct keyPressDetailsTag
{
    char make;
    char key;
} keyPressDetails;

static keyPressDetails keyPressBfr[MAX_KPRESS_BFR];
static SHORT mfw_kbd_kpress_buf_id;

extern void sendKeyInd( T_KPD_VIRTUAL_KEY_ID virtual_key_id,
                        T_KPD_KEY_STATE key_state,
                        T_KPD_PRESS_STATE press_state);

/*2003/12/20,talcon add*/
extern void idleHandleByLcdState(U8 uState);

/* 2004/07/09 sunsj add */
extern int FocuseIdlewin();

//#define OUTERIDLE_FOR_FTA 
#ifdef OUTERIDLE_FOR_FTA
#define setOuterState(a,b,char *par)
#define setChargeState(a,b)
#else
extern void setOuterState(U32 flags,UBYTE mask,char *par);
extern void setChargeState(U8 flags,void *para);
#endif
//Bob added for ledblink;
//ledblink hander
extern MfwHnd ledblink;
extern UBYTE ledblinkflag;
/*


+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdInit            |
+--------------------------------------------------------------------+

  PURPOSE : initialize keyboard handler

*/

MfwRes kbdInit (void)
{
    timLong.time = 0;                   /* setup long press timer   */
    timLong.left = 0;
    timLong.handler = toLong;
    timLong.next = 0;
    timLongH.data = &timLong;
    timLongH.type = MfwTypTim;

    timAuto.time = 0;                   /* setup auto repeat timer  */
    timAuto.left = 0;
    timAuto.handler = toAuto;
    timAuto.next = 0;
    timAutoH.data = &timAuto;
    timAutoH.type = MfwTypTim;
    valAuto = valRepeat = 0;

    keyInit(kbdSignal);                 /* init keyboard driver     */
    mfwCommand[MfwTypKbd] = (MfwCb) kbdCommand;
    doAlways = 0;

    mfw_kbd_kpress_buf_id = mfw_cbuf_create(MAX_KPRESS_BFR,
                                            sizeof(keyPressDetails),
                                            FALSE,
                                            0xFF,
                                            TRUE,
                                            keyPressBfr);

    if(mfw_kbd_kpress_buf_id < 0)
        TRACE_EVENT_P1("ERROR : mfw_cbuf_create failed with error value %d", mfw_kbd_kpress_buf_id);
    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdExit            |
+--------------------------------------------------------------------+

  PURPOSE : finalize keyboard handler

*/

MfwRes kbdExit (void)
{
    mfwCommand[MfwTypKbd] = 0;
    keyExit();

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdAlways          |
+--------------------------------------------------------------------+

  PURPOSE : create keyboard control for all events

*/

MfwCb kbdAlways (MfwCb f)
{
    MfwCb always = doAlways;

    doAlways = f;
    if(!f)
    {
        timStop(&timLongH);
        timStop(&timAutoH);
    }

    return always;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdTime            |
+--------------------------------------------------------------------+

  PURPOSE : define keyboard timeouts

*/

void kbdTime (long tLong, long tAuto, long tRepeat)
{
    timLong.time = tLong;               /* setup long press timer   */
    timAuto.time = tAuto;               /* setup auto repeat timer  */
    valAuto = tAuto;                    /* save auto start timeout  */
    valRepeat = tRepeat;                /* save repeat intervall    */
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdCreate          |
+--------------------------------------------------------------------+

  PURPOSE : create keyboard control

*/

MfwHnd kbdCreate (MfwHnd w, MfwEvt e, MfwCb f)
{
    MfwHdr *hdr = (MfwHdr *) mfwAlloc(sizeof(MfwHdr));
    MfwKbd *kbd = (MfwKbd *) mfwAlloc(sizeof(MfwKbd));

    if(!hdr || !kbd)
        return 0;

    kbd->map = e;
    kbd->key = 0;
    kbd->handler = f;

    hdr->data = kbd;
    hdr->type = MfwTypKbd;

    return mfwInsert(w,hdr);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdDelete          |
+--------------------------------------------------------------------+

  PURPOSE : delete keyboard control

*/

MfwRes kbdDelete (MfwHnd h)
{
    MfwRes res;

    if(!h)
        return MfwResIllHnd;

    res = (mfwRemove(h)) ? MfwResOk : MfwResIllHnd;

    mfwFree(((MfwHdr *) h)->data,sizeof(MfwKbd));
    mfwFree(h,sizeof(MfwHdr));

    return res;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : sigExec            |
+--------------------------------------------------------------------+

  PURPOSE : execute keyboard signal
            if the registered set of keys match the currently
            pressed key, the event handler is called, if the
            registered flags match the current flags according
            to the following table:
            M: Make/Break (key release events wanted)
            L: Long press event (timeout set via kbdTime())
            A: Auto repeat event (timing defined via kbdTime())

                                            M 0 0 0 0 1 1 1 1
            current event flags ---------   L 0 0 0 0 0 0 1 1
                                            A 0 0 0 0 0 1 0 1
                                      M L A .................
                                      0 0 0 . 0 0 0 0 1 0 0 0
                                      0 0 1 . 0 0 0 0 1 1 0 1
            registered                0 1 0 . 0 0 0 0 0 0 1 1
            event       -----------   0 1 1 . 0 0 0 0 0 1 1 1
            flags                     1 0 0 . 1 1 1 1 1 0 0 0
                                      1 0 1 . 1 1 1 1 1 1 0 1
                                      1 1 0 . 1 1 1 1 0 0 1 1
                                      1 1 1 . 1 1 1 1 0 1 1 1

*/

static int sigExec (MfwHdr *curElem, U32 map, U8 key)
{
    MfwKbd *kc;
    TRACE_FUNCTION("sigExec()");
    while(curElem)
    {
        if(curElem->type == MfwTypKbd)
        {
            kc = curElem->data;
            if(kc->map & map & ~KEY_FLAGS)
            {                           /* keys match               */
                kc->code = key;         /* set current key code     */
                if(map & KEY_MAKE)
                {
                    kc->key |= map;     /* set key in control block */
                }
                else
                {
                    kc->key &= ~map;      /* del key in control block */
                    kc->key &= ~KEY_MAKE; /* del make/break flag      */
                }
                if((KEY_MAKE & ~map & kc->map) ||
                   (KEY_MAKE & map &&
                    ((KEY_LONG & map & kc->map)        ||
                     (!(KEY_LONG & kc->map)
                      && (KEY_AUTO & kc->map & map)) ||
                     (!(KEY_LONG & map)
                      && !(KEY_AUTO & map)
                      && !(KEY_LONG & kc->map))      ||
                     (!(KEY_LONG & map)
                      && (KEY_AUTO & map)
                      && (KEY_AUTO & kc->map)))))
                {
                    if(kc->handler)    /* handler valid            */
                    {
                        // PATCH LE 06.06.00
                        // store current mfw elem
                        current_mfw_elem = curElem;

                        // END PATCH LE 06.06.00
                        if((*(kc->handler))(map,kc)){

                            return 1;   /* event consumed           */
                        	}
                    }
                }
            }
        }
        curElem = curElem->next;
    }

    return 0;   //zy revise
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : sigDistribute      |
+--------------------------------------------------------------------+

  PURPOSE : distribute keyboard event

*/

static void sigDistribute (U32 map, U8 key)
{
    int res = 0;
    int fail=0;
	/*2003/12/16,talcon comment*/
    //char temp[100];
    if(doAlways)
        if(doAlways(map,(void*) -1))
            return;                     /* event consumed           */

    if(mfwSignallingMethod == 0)
    {
        if(mfwFocus)
            res = sigExec(mfwFocus,map,key);
        if(!res && mfwRoot)
            res = sigExec(mfwRoot,map,key);
    }
    else
    {
        MfwHdr *h = mfwFocus;

        if(!h)
        {
            //TRACE_EVENT("nofucus only mfwroot");
            h = mfwRoot;
        }
        if(h)
        {
            fail = sigExec(h,map,key);
            res=1;
           
            if((!fail)&&(map&KEY_MAKE))
            {
                //TRACE_EVENT("the win has't kbdcb");
                //winFocusShow(mfwParent(current_mfw_elem));
            }
        }
        if(!res && mfwRoot && h != mfwRoot)
            res = sigExec(mfwRoot,map,key);
    }

    if(doAlways)
        doAlways(map,(void*) res);

    return;
}

#ifdef DRVPCTMTRACE
void TraceHallVarvalue(void)
{
    /*ljq added for trace_pctm command 2003/1/8*/
    RivieraTrace_Chunhui("TraceHallVarvalue: drvpara.hallstatusflag=", drvpara.hallstatusflag);
    return;
}
#endif
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdSignal          |
+--------------------------------------------------------------------+

  PURPOSE : keyboard event (called by driver/PEI)

*/

#define MAX_CONSEC_KEYS 6   // Maximum number of keys which can be processed before
// allowing the protocol stack processing time


//glowing, 2003-12-18 replace the function that define in 
//mmisounds.c

int HallOnOff(void){
	drvpara.hallstatusflag = GetHallStatus( );
	return drvpara.hallstatusflag;
}
void kbdSignal (char make, char key)
{
    U32 map;
    UBYTE temp;
    USHORT numElem;

    int loopNo;
    int keyNo;

    //	if (key < 0 || key > KCD_MAX)
    //	return;
	PHK_TRACE_EVENT(("glowing: kbdSignal--enter key=%d", key));

#ifndef _INNOVATION_EMULATOR_
    if(key == KCD_F4)
    {   
    	/* filter hall noise */
		PHK_TRACE_EVENT(("glowing: kbdSignal--Hall Interrupt!!!!!!!!!"));
		
        if(HallInterruptHandler())
        {
            AI_UnmaskHall_IT( ); 
            return;
        }
	}

    if((key==KCD_ABC)&&(pwr_Status.charging_state==0))
    {
        if(ledblinkflag!=0)
            timStart(ledblink);
    }

    if(key == KCD_F4)
    {
		drvpara.hallstatusflag = GetHallStatus(); //glowing,2003-12-18
		PHK_TRACE_EVENT(("glowing: kbdSignal--hallstatusflag=%d",drvpara.hallstatusflag));

		
        if(drvpara.hallstatusflag ==1)
        {
        	/* go here that not a noise, so we can turn on LCD backlight */
	        MMIActionKeyPress_flip( ); //glowing, 2004-02-12, for just one backlight
#ifndef _INNOVATION_EMULATOR_
			main_lcd_pwrCtrl(1);	
            sub_lcd_pwrCtrl(0);
#endif
            r2d_refresh();  //ganchh 2002/12/25
            
			/* 2004/03/31 sunsj modify */
            LedLightnessAdjust(200); //glowing : 2004-2-26 add it

			PHK_TRACE_EVENT(("glowing: kbdSignal--before Backlight_ON"));
            Backlight_ON();
            //Bob added 01/23
            Green_Off();
			/* 2004/03/15 sunsj remove */
            //Red_Off();
            if(ledblinkflag!=0)
                timStop(ledblink);

			if( NotCharingMode == TRUE )
			{
				StartPlayByReason(HALLON, 0);
			}

			/*2003/12/20,talcon add*/
			idleHandleByLcdState(1);
			setOuterState(0x04,1,0);//2004-04-22 Sunny modify

			//2004.4.9 WYJ modify
			/* 2004/07/05 sunsj modify */
			#if 0	/* Robert.Chen modified, 2004-08-03, replace it before drawIdle */
			if( NotCharingMode == TRUE )
			{
				StartPlayByReason(HALLON, 0);
			}
			#endif
        }
        else
        {
#ifndef _INNOVATION_EMULATOR_      	

            main_lcd_pwrCtrl(0);
            sub_lcd_pwrCtrl(1);
#endif
			CloseMic();					// ظǹһХ 2004.5.19 WYJ

            MMIActionKeyPress_flip();	/* 2004-04-17, Robert.Chen added */
            
            //LCD_OFF();  //glowing,2003-12-16 comment it
			MMI_TRACE_EVENT(("glowing: kbdSignal--before Backlight_Off"));
            
		    /* 2004/04/02 sunsj modify */
		    //LedLightnessAdjust(200);
		    Backlight_OFF();

            //Bob added for ledblink 01/23
#ifndef SEVEN_COLORS_LED
            /* 2004/04/10 sunsj modify */
            if( FlashSettingData.LedSwitch == 1 )
            {
            	LEDStart();  //glowing, 2004-2-26, add it
            }
#endif
			/*2003/12/20,talcon add*/
			idleHandleByLcdState(0);
			setOuterState(0x02,1,0);//2004-04-22 Sunny modify

			// 2004.4.16 WYJ add
			MC_StopVibra();
			
			//2004.4.9 WYJ modify
			StopPlayingMelody2();
			if( NotCharingMode == TRUE )
			{
				StartPlayByReason(HALLOFF, 0);
			}
        }
        //AI_UnmaskIT(2);
        AI_UnmaskHall_IT( ); 
    }
#else
	if(key == KCD_F4)
    {
	static int lcdcover = 0;
        if(lcdcover)//LCD ON
        {
  
			idleHandleByLcdState(1);
			setOuterState(0x04,1,0);//2004-03-23 Sunny modify
        }
        else
        {
			idleHandleByLcdState(0);
			setOuterState(0x02,1,0);//OUTERIDLESTATE_LCDOFF//2004-04-22 Sunny modify

        }
		lcdcover = 1- lcdcover;
      
    }
#endif //_INNOVATION_EMULATOR_    
    if((key==KCD_ABC)||(key==KCD_F4))    
    {    	
		/*2003/12/23,talcon add*/
		if (key==KCD_ABC)
		{
			//setChargeState(0x01,0);//2004-03-21 Sunny remove
		}/*end talcon add*/
        map = 1L << key;
        if(make)
        {
            map |= KEY_MAKE;
            curMap = map;
            curKey = key;   
        }
        else
        {
            map &= ~KEY_MAKE;
            curMap = map; //ES!!
            curKey = key; //ES!!
        }

        sigDistribute(map,key);
        /* 2004/07/09 sunsj add for forbidden hall off */
        if( key == KCD_F4 )
        {
            if( drvpara.hallstatusflag == 0 )
            {
                if( HallOffForbid == FALSE )
                {
                    if( FocuseIdlewin() == 0 )
                    {
                        MMI_TRACE_EVENT(("sunsj-----------return to idle"));
                        sigDistribute(map, KCD_HUP);
                        returntoidle(1);
                    }
                }
            }
        }
        while(kbd_getMakeAndKey(&make,&key) != -1);
        return;
    }
    
	
    
    if((kbd_processKeyInput()== QUEUE_EVERY_KEY) ||
       (kbd_processKeyInput()== QUEUE_N_KEYS))
        temp = dspl_Enable(0);

    loopNo = 0;
    keyNo = 0;

	while(kbd_getMakeAndKey(&make,&key) != -1)
	{
		if((!HallStatus()))  /* in order to send virtual charging key to mmi when halloff */
        {
			if(call_win_flag&&(key==KCD_VOLDOWN||key==KCD_VOLUP)&&IsHandsetPlugin())
			{
				/* adjust vol when halloff and handsetis plugin and press kcdvoldown kcdvolup */
			}
			/*2004/4/2, wangyan add the control of longkey when halloff */
			else if((key==KCD_VOLUP||key==KCD_F3))
			{
			}
			/*2004/4/2, wangyan add the control of longkey when halloff */
			else
			{
				while(kbd_getMakeAndKey(&make,&key) != -1)
				{
				}              //zy: halloff needn't action keys"	    
				nElements=0;
				if((kbd_processKeyInput()== QUEUE_EVERY_KEY) ||
						(kbd_processKeyInput()== QUEUE_N_KEYS))
					dspl_Enable(temp);//zy must use dspl_enable(temp) with couple

				return;//zy 11/25 lock all key when hall is closed
			}
		}
		
        still_processing_flag = 1;
        //TraceMMIValue("key in signal", key);
        if((key >= 0) && (key <= KCD_MAX))
        {
            loopNo++;
            keyNo++;

            map = 1L << key;

            if(make)
            {
                map |= KEY_MAKE;
                curMap = map;
                curKey = key;
                if((key != KCD_ABC)&&(key != KCD_F4))
                {
					if(key==KCD_HUP || key==KCD_RIGHT)	//MI18800000126
						StopPlayingMelody2();
					
                    if((key == KCD_MNUUP) ||(key == KCD_MNUDOWN)||(key == KCD_RIGHT)||(key == KCD_HUP)
                       || ((key != KCD_MNUUP)&&(key != KCD_MNUDOWN)&&(key != KCD_RIGHT)&&(key != KCD_HUP)
                           &&!(driverFlag&0x04)))
                    {
                        if(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone)  //xsf add 2002.09.16
                        {
                            //xsf add for not play keypad tone when start the phone before entered idle 2003.02.20 
                            if(animation_complete || ((!animation_complete) && (key != KCD_POWER))) //&& (key != KCD_F4)
                                StartPlayByReason(9,key);  //KEYPADTONE = 9
                        }
                    }

                    if(HallStatus() ||  (key!=KCD_VOLUP && key!=KCD_F3)  )/*2004/04/08,talcon add */
				MMIActionKeyPress();///zym added
                    timStart(&timLongH);
                    timAuto.time = valAuto;

                    /*NM, p007a*/
                    if(valAuto)
                        timStart(&timAutoH);
                    /*NM, p007a end*/
                }
            }
            else
            {

                map &= ~KEY_MAKE;
                curMap = map; //ES!!
                curKey = key; //ES!!
                timStop(&timLongH);

                /*NM, p007b*/
                if(valAuto)
                    timStop(&timAutoH);
                /*NM, p007b end*/
            }

            //Select when we update the display
            switch(kbd_processKeyInput())
            {

            case QUEUE_EVERY_KEY:
                sigDistribute(map,key);
                break;

            case PROCESS_EVERY_KEY:
                temp = dspl_Enable(0);
                sigDistribute(map,key);
                dspl_Enable(temp);
                break;

            case QUEUE_N_KEYS:
                if((loopNo %(NUM_QUEUE_KEYS*2))==0)
                {
                    kbd_setDisplayUpdateNeeded(1);
                    sigDistribute(map,key); 
                    dspl_Enable(temp); 
                    temp = dspl_Enable(0);
                    kbd_setDisplayUpdateNeeded(0);
                }
                else
                    sigDistribute(map,key);
                break;
            }
        }
#ifndef _INNOVATION_EMULATOR_
        if(keyNo == MAX_CONSEC_KEYS)
        {
            still_processing_flag = FALSE;
            break;
        }
#endif       

        still_processing_flag = FALSE;
    }

    numElem = mfw_cbuf_num_elements(mfw_kbd_kpress_buf_id);
    TRACE_EVENT_P2("NDH >>> Kbd :- There are %d elements in the buffer (id : %d)" ,
                   numElem, mfw_kbd_kpress_buf_id);

#ifndef _INNOVATION_EMULATOR_
    if((keyNo == MAX_CONSEC_KEYS) && (numElem > 0))
    {
        sendKeyInd(12, 0, 0); // dummy values to trigger another keypress_ind
        /*
        ** This delay is required to slow down the BMI when no trace is being output in order
        ** to permit the Protocol Stack & other tasks to function correctly
        */
        vsi_t_sleep (VSI_CALLER  30); 
    }
#endif
    if((kbd_processKeyInput()== QUEUE_EVERY_KEY) ||
       (kbd_processKeyInput()== QUEUE_N_KEYS))
        dspl_Enable(temp);

    return;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : toLong             |
+--------------------------------------------------------------------+

  PURPOSE : long press timeout handler

*/

static int toLong (U32 t, void *h)
{
    curMap |= KEY_LONG;

    sigDistribute(curMap,curKey);

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : toAuto             |
+--------------------------------------------------------------------+

  PURPOSE : auto repeat timeout handler

*/

static int toAuto (U32 t, void *h)
{
	/* 2004/04/16 sunsj modify */
	curMap &= ~KEY_LONG;
    curMap |= KEY_AUTO;
    sigDistribute(curMap,curKey);
    timAuto.time = valRepeat;
    /* NM p007c*/
    if(valRepeat)
        timStart(&timAutoH);
    /* NM p007c end*/
    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdCommand         |
+--------------------------------------------------------------------+

  PURPOSE : handle mfw windows command

*/

static int kbdCommand (U32 cmd, void *h)
{
    switch(cmd)
    {
    case MfwCmdDelete:              /* delete me                */
        if(!h)
            return 0;
        kbdDelete(h);
        return 1;
    default:
        break;
    }

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbd_putMakeAndKey    |
+--------------------------------------------------------------------+

  PURPOSE : places 'make' (key up/down) and key index into a queue

*/

int kbd_putMakeAndKey( char make, char key)
{
    keyPressDetails localKP;
    SHORT retVal;

    localKP.make = make;
    localKP.key = key;

    retVal = mfw_cbuf_put(mfw_kbd_kpress_buf_id, &localKP);

    if(retVal < 0)
        TRACE_EVENT_P1("ERROR : mfw_cbuf_put failed with error value %d", retVal);

    return(retVal);
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbd_getMakeAndKey    |
+--------------------------------------------------------------------+

  PURPOSE : reads 'make' (key up/down) and key index into a queue
        Return	+ve number - keys left in buffer
                 0 - no keys left - last key press returned
                -1 - no keys and none in buffer
*/

int kbd_getMakeAndKey( char* make, char* key)
{
    keyPressDetails localKP;
    SHORT retVal;

    retVal = mfw_cbuf_get(mfw_kbd_kpress_buf_id, &localKP);

    if(retVal < 0)
    {
        *key = 0x7F;
        *make = 0;
        return(-1);
    }

    *make = !(localKP.make);
    *key =   drvGetKeyIndex(localKP.key);
    return(mfw_cbuf_num_elements(mfw_kbd_kpress_buf_id));
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbd_getNumElements    |
+--------------------------------------------------------------------+

  PURPOSE : returns number of elements in queue

*/
int kbd_getNumElements(void)
{
    return((int)mfw_cbuf_num_elements(mfw_kbd_kpress_buf_id));
}

int kbd_stillProcessingKeys(void)
{
    return(still_processing_flag);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbd_displayUpdateNeeded   |
+--------------------------------------------------------------------+

  PURPOSE : returns TRUE if we need to update the display

*/
int displayUpdateNeeded; //used for output every 'n' key presses
int kbd_displayUpdateNeeded(void)
{
    if(kbd_processKeyInput()==PROCESS_EVERY_KEY)
        return(TRUE);//Processing each key press - always update screen
    else if(displayUpdateNeeded==0)
        return(TRUE);//need to update the display (1 in 6 output) 
    else if(mfw_cbuf_num_elements(mfw_kbd_kpress_buf_id) > 1)
        return(FALSE);//keys in queue - do not update
    else
        return(TRUE);//only 1 key up/down in queue - update display
}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbd_setDisplayUpdateNeeded   |
+--------------------------------------------------------------------+

  PURPOSE : sets/clears the flag indicating we need to update the display

*/
void kbd_setDisplayUpdateNeeded(int set)
{
    displayUpdateNeeded = set;
}

void mfw_TRACE_EVENT(char* str)
{
    /*	TRACE_EVENT(str);*/
    TRACE_FUNCTION(str);
}
void mfw_TRACE_EVENT_data(char* str,int i)
{
    char opStr[100];
    sprintf(opStr,"%s : %d",str,i);
    mfw_TRACE_EVENT(opStr);
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbd_processEveryKeyInput    |
+--------------------------------------------------------------------+

  PURPOSE : indicates if the software should process each keypad input individually 
            (TRUE) or if it should process keypad inputs one at a time (FALSE) 

*/
int kbd_processKeyInput(void)
{
    //	return (QUEUE_N_KEYS);//We buffer multiple key inputs
    return(QUEUE_EVERY_KEY);//We buffer multiple key inputs
    //	return (PROCESS_EVERY_KEY);//We process each key input

}

int  MorethanMaxPressKeyNum(int num)
{
    MmiTrace("MorethanMaxPressKeyNum");
    MmiTraceInt(g_keypadnum);   
    if(g_keypadnum > num)
        return 1;
    return 0;
}


#if 0   // 133s48 version
/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile:: mfw_kbd.c       $|
| $Author: zhenggl $ CONDAT GmbH           $Revision: 1.4 $|
| CREATED: 21.09.98                     $Modtime:: 23.03.00 8:24    $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : MFW_KBD

   PURPOSE : keyboard handling functions

   EXPORT  :

   TO DO   : adjust PEI/driver interface

   $History:: mfw_kbd.c                                             $
 *
 * *****************  Version 18  *****************
 * User: Es           Date: 23.03.00   Time: 14:48
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * no stddefs ???
 *
 * *****************  Version 17  *****************
 * User: Rm           Date: 23-02-00   Time: 3:15p
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * stop Auto and Long timer finishing with kbdAlways
|
| *****************  Version 16  *****************
| User: Le           Date: 26.01.00   Time: 12:13
| Updated in $/GSM/Condat/MS/SRC/MFW
| Make definition different for Windows and Target
 *
 * *****************  Version 15  *****************
 * User: Be           Date: 25.01.00   Time: 18:20
 * Updated in $/GSM/Condat/MS/SRC/MFW
|
| *****************  Version 14  *****************
| User: Le           Date: 6.01.00    Time: 9:23
| Updated in $/GSM/Condat/MS/SRC/MFW
| Alignment of MFW versions
 *
 * *****************  Version 3  *****************
 * User: Be           Date: 29.11.99   Time: 14:31
 * Updated in $/GSM/Condat/SND-MMI/MFW
 * target integration
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 22.11.99   Time: 10:29
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 1  *****************
 * User: Es           Date: 18.11.99   Time: 16:35
 * Created in $/GSM/Condat/SND-MMI/MFW
 * Initial
 *
 * *****************  Version 13  *****************
 * User: Es           Date: 6.07.99    Time: 12:20
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 11  *****************
 * User: Es           Date: 1.04.99    Time: 17:07
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * removed lots of traces
 *
 * *****************  Version 10  *****************
 * User: Es           Date: 18.02.99   Time: 17:01
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 9  *****************
 * User: Es           Date: 17.02.99   Time: 19:11
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 8  *****************
 * User: Es           Date: 14.01.99   Time: 17:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 7  *****************
 * User: Es           Date: 23.12.98   Time: 16:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * data:            modifier
 * 08/12           zym add in kbdsignal
*/

    #if defined (NEW_FRAME)

        #include "typedefs.h"
        #include "vsi.h"
        #include "pei.h"
        #include "custom.h"
        #include "gsm.h"

    #else

        #include "stddefs.h"
        #include "custom.h"
        #include "gsm.h"
        #include "vsi.h"

    #endif

    #include <stdio.h>
    #include "mfw_mfw.h"
    #include "mfw_sys.h"
    #include "mfw_tim.h"
    #include "drv_key.h"
    #include "mfw_win.h"
    #include "mfw_kbd.h"
    #include "pwr.h"
    #include "r2d.h"


static int kbdCommand (U32 cmd, void *h);
static int toLong (U32 t, void *h);
static int toAuto (U32 t, void *h);

extern MfwHnd gtVibator;

static MfwCb doAlways;                  /* all cases handler        */
static MfwHdr timLongH;                 /* the long press timer     */
static MfwTim timLong;
static MfwHdr timAutoH;                 /* the auto repeat timer    */
static MfwTim timAuto;
static U32 valAuto;                     /* auto start intervall     */
static U32 valRepeat;                   /* auto repeat intervall    */
static U32 curMap;                      /* current key map          */
static U8 curKey;                       /* current key code         */

driver_Parameter drvpara;
// PATCH LE 06.06.00
// current MFW element needed for multiple instances
EXTERN MfwHdr * current_mfw_elem;
extern T_R2D_GC_PTR r2d_g_lcd_gc;
extern int g_keypadnum;

extern INT8 r2d_g_event_was_sent;

int   g_kpdnum =0 ;   ///zym added 10/18
int   g_kpdtim = 0;  ///zym added 10/18

    #define PRENUMPERSEC 4   //zym added 10/18
// END PATCH LE 06.06.00
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdInit            |
+--------------------------------------------------------------------+

  PURPOSE : initialize keyboard handler

*/

MfwRes kbdInit (void)
{
    timLong.time = 0;                   /* setup long press timer   */
    timLong.left = 0;
    timLong.handler = toLong;
    timLong.next = 0;
    timLongH.data = &timLong;
    timLongH.type = MfwTypTim;

    timAuto.time = 0;                   /* setup auto repeat timer  */
    timAuto.left = 0;
    timAuto.handler = toAuto;
    timAuto.next = 0;
    timAutoH.data = &timAuto;
    timAutoH.type = MfwTypTim;
    valAuto = valRepeat = 0;

    keyInit(kbdSignal);                 /* init keyboard driver     */
    mfwCommand[MfwTypKbd] = (MfwCb) kbdCommand;
    doAlways = 0;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdExit            |
+--------------------------------------------------------------------+

  PURPOSE : finalize keyboard handler

*/

MfwRes kbdExit (void)
{
    mfwCommand[MfwTypKbd] = 0;
    keyExit();

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdAlways          |
+--------------------------------------------------------------------+

  PURPOSE : create keyboard control for all events

*/

MfwCb kbdAlways (MfwCb f)
{
    MfwCb always = doAlways;

    doAlways = f;
    if(!f)
    {
        timStop(&timLongH);
        timStop(&timAutoH);
    }

    return always;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdTime            |
+--------------------------------------------------------------------+

  PURPOSE : define keyboard timeouts

*/

void kbdTime (long tLong, long tAuto, long tRepeat)
{
    timLong.time = tLong;               /* setup long press timer   */
    timAuto.time = tAuto;               /* setup auto repeat timer  */
    valAuto = tAuto;                    /* save auto start timeout  */
    valRepeat = tRepeat;                /* save repeat intervall    */
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdCreate          |
+--------------------------------------------------------------------+

  PURPOSE : create keyboard control

*/

MfwHnd kbdCreate (MfwHnd w, MfwEvt e, MfwCb f)
{
    MfwHdr *hdr = (MfwHdr *) mfwAlloc(sizeof(MfwHdr));
    MfwKbd *kbd = (MfwKbd *) mfwAlloc(sizeof(MfwKbd));

    if(!hdr || !kbd)
        return 0;

    kbd->map = e;
    kbd->key = 0;
    kbd->handler = f;

    hdr->data = kbd;
    hdr->type = MfwTypKbd;

    return mfwInsert(w,hdr);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdDelete          |
+--------------------------------------------------------------------+

  PURPOSE : delete keyboard control

*/

MfwRes kbdDelete (MfwHnd h)
{
    MfwRes res;

    if(!h)
        return MfwResIllHnd;

    res = (mfwRemove(h)) ? MfwResOk : MfwResIllHnd;

    mfwFree(((MfwHdr *) h)->data,sizeof(MfwKbd));
    mfwFree(h,sizeof(MfwHdr));

    return res;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : sigExec            |
+--------------------------------------------------------------------+

  PURPOSE : execute keyboard signal
            if the registered set of keys match the currently
            pressed key, the event handler is called, if the
            registered flags match the current flags according
            to the following table:
            M: Make/Break (key release events wanted)
            L: Long press event (timeout set via kbdTime())
            A: Auto repeat event (timing defined via kbdTime())

                                            M 0 0 0 0 1 1 1 1
            current event flags ---------   L 0 0 0 0 0 0 1 1
                                            A 0 0 0 0 0 1 0 1
                                      M L A .................
                                      0 0 0 . 0 0 0 0 1 0 0 0
                                      0 0 1 . 0 0 0 0 1 1 0 1
            registered                0 1 0 . 0 0 0 0 0 0 1 1
            event       -----------   0 1 1 . 0 0 0 0 0 1 1 1
            flags                     1 0 0 . 1 1 1 1 1 0 0 0
                                      1 0 1 . 1 1 1 1 1 1 0 1
                                      1 1 0 . 1 1 1 1 0 0 1 1
                                      1 1 1 . 1 1 1 1 0 1 1 1

*/

static int sigExec (MfwHdr *curElem, U32 map, U8 key)
{
    MfwKbd *kc;

    while(curElem)
    {
        if(curElem->type == MfwTypKbd)
        {
            kc = curElem->data;
            if(kc->map & map & ~KEY_FLAGS)
            {                           /* keys match               */
                kc->code = key;         /* set current key code     */
                if(map & KEY_MAKE)
                {
                    kc->key |= map;     /* set key in control block */
                }
                else
                {
                    kc->key &= ~map;    /* del key in control block */
                    kc->key &= ~KEY_MAKE; /* del make/break flag    */
                }
                if((KEY_MAKE & ~map & kc->map) ||
                   (KEY_MAKE & map &&
                    ((KEY_LONG & map & kc->map)        ||
                     (!(KEY_LONG & kc->map)
                      && (KEY_AUTO & kc->map & map)) ||
                     (!(KEY_LONG & map)
                      && !(KEY_AUTO & map)
                      && !(KEY_LONG & kc->map))      ||
                     (!(KEY_LONG & map)
                      && (KEY_AUTO & map)
                      && (KEY_AUTO & kc->map)))))
                {
                    if(kc->handler)    /* handler valid            */
                    {
                        // PATCH LE 06.06.00
                        // store current mfw elem
                        current_mfw_elem = curElem;
                        // END PATCH LE 06.06.00
                        if((*(kc->handler))(map,kc))
                            return 1;   /* event consumed           */
                    }
                }
            }
        }
        curElem = curElem->next;
    }

    return 1;// old is "return 0"change zy 10/10 don't sent this things to above level
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : sigDistribute      |
+--------------------------------------------------------------------+

  PURPOSE : distribute keyboard event

*/

static void sigDistribute (U32 map, U8 key)
{
    int res = 0;

    if(doAlways)
        if(doAlways(map,(void*) -1))
            return;                     /* event consumed           */

    if(mfwSignallingMethod == 0)
    {
        if(mfwFocus)
            res = sigExec(mfwFocus,map,key);
        if(!res && mfwRoot)
            res = sigExec(mfwRoot,map,key);
    }
    else
    {
        MfwHdr *h = mfwFocus;
        if(!h)
            h = mfwRoot;
        while(h)
        {
            if(res = sigExec(h,map,key))
                break;
            if(h == mfwRoot)
                break;
            h = mfwParent(mfwParent(h));
            if(h)
                h = ((MfwWin *)(h->data))->elems;
        }
        if(!res && mfwRoot && h != mfwRoot)
            res = sigExec(mfwRoot,map,key);
    }

    if(doAlways)
        doAlways(map,(void*) res);

    return;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdSignal          |
+--------------------------------------------------------------------+

  PURPOSE : keyboard event (called by driver/PEI)

*/

void kbdSignal (char make, char key)
{
    U32 map;
    UBYTE temp;
    if(key < 0 || key > KCD_MAX)
        return;
    /*NM, p006a
    temp = dspl_Enable(0);
    NM, p006a end*/
    /*
          if((key != 22)&&(key !=27 )){
              //zym added 10/18
            if(!g_kpdnum){
                g_kpdtim = 1;
                StartSecTime();
            }
            g_kpdnum++;
            MmiTrace("kpd_key_handler");
            MmiTraceInt(g_kpdnum);
            if(g_kpdnum>PRENUMPERSEC*2){
                  return ;
            }
            }
    
    */
    map = 1L << key;
    MmiTrace("zym:kbdSignal");
    MmiTraceInt(key);
    MmiTraceInt(drvpara.hallstatusflag);

    if(key == KCD_F4)
    {
        if(drvpara.hallstatusflag ==1)
        {
            ColorLCD_Init(0);
            r2d_refresh();
            // r2d_check_and_send_event_New(r2d_g_lcd_gc);
            LCD_ON();
            LedLightnessAdjust(16);//zy 08/14
            timStart(gtVibator);
            Backlight_ON();

            /*
  
             //set the GPIO0,1,3 ,hxl add 20020929---------------------------------
              *((volatile UINT16 *)(0xfffef008))&=0xfffe; 
              *((volatile UINT16 *)(0xfffe4804))&=0xfffe;  
  
  
              *((volatile UINT16 *)(0xfffef008))&=0xfffd; 
              *((volatile UINT16 *)(0xfffe4804))&=0xfffd;  
  
              *((volatile UINT16 *)(0xfffef008))&=0xfbff; 
              *((volatile UINT16 *)(0xfffe4804))&=0xfff7;  
  
              //open KBD
              *((volatile UINT16 *)(0xfffe4818))&=0xfffd;
              //open LED
              SPIWrite_ABB_Register(1,24,0x0003);
              //end of hxl add 20020929---------------
              */


        }
        else
        {

            Sleep_Or_Quality(1);
            LCD_OFF();
            Backlight_OFF();
            /*
            //set the GPIO0,1,3 to input mode,for power saving 20020929---------------
             *((volatile UINT16 *)(0xfffef008))&=0xfffd; // GPIO1
             *((volatile UINT16 *)(0xfffe4804))|=0x0002;  
 
             *((volatile UINT16 *)(0xfffef008))&=0xfffe; //GPIO0,
             *((volatile UINT16 *)(0xfffe4804))|=0x0001; 
 
             *((volatile UINT16 *)(0xfffef008))&=0xfbff; //GPIO3
             *((volatile UINT16 *)(0xfffe4804))|=0x0008; 
 
             //close KBD
             *((volatile UINT16 *)(0xfffe4818))|=0x0002;
             //close LED
             SPIWrite_ABB_Register(1,24,0x000);
             //end of hxl add for power saving 20020929-------------------------------
             */

        }
        AI_UnmaskIT(2);

        //  	return ;
    }

    if((drvpara.hallstatusflag==0)&&((key != KCD_F4)&&(key != KCD_ABC)))  ///zym modified charging virtual key must send 
        return;//zy 11/25 lock all key when hall is closed


    #if defined (WIN32)
    if(make)
    #else
    //kk    if (!make) //kk only needed for asample board
    if(make)
    #endif
    {
        /* NM, p006b
        old : refresh the LCD for keypress and keyrelease
        new: update only on keypress

        there was a unknown effect (doesnt show the '0')
        so this is the reason to add the 'sigDistribute' in every
        statement.

        NM, p006b end */

        ///	temp = dspl_Enable(0);
        map |= KEY_MAKE;
        curMap = map;
        curKey = key;
        if((key != KCD_ABC)&&(key != KCD_F4))
        {
            if((!MorethanMaxPressKeyNum(3))&&(r2d_g_event_was_sent == 0))
            {
                MMIActionKeyPress();///zym added
                timStart(&timLongH);
                timAuto.time = valAuto;
                /*NM, p007a*/
                if(valAuto)
                    timStart(&timAutoH);
            }
        }
        /*NM, p007a end*/

        /*NM, p006c*/
        sigDistribute(map,key);
        ///  		dspl_Enable(temp); 
        /*NM, p006c end*/
    }
    else
    {
        map &= ~KEY_MAKE;
        curMap = map; //ES!!
        curKey = key; //ES!!
        if((!MorethanMaxPressKeyNum(3))&&(r2d_g_event_was_sent == 0))
        {
            timStop(&timLongH);
            /*NM, p007b*/
            if(valAuto)
                timStop(&timAutoH);
            /*NM, p007b end*/
        }
        /*NM, p006d */
        sigDistribute(map,key);
        /*NM, p006d end */
    }

    /*NM, p006e 
    sigDistribute(map,key); 
    dspl_Enable(temp); 
    NM, p006e end*/


    return;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : toLong             |
+--------------------------------------------------------------------+

  PURPOSE : long press timeout handler

*/

static int toLong (U32 t, void *h)
{
    curMap |= KEY_LONG;
    sigDistribute(curMap,curKey);

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : toAuto             |
+--------------------------------------------------------------------+

  PURPOSE : auto repeat timeout handler

*/

static int toAuto (U32 t, void *h)
{
    curMap |= KEY_AUTO;
    sigDistribute(curMap,curKey);
    timAuto.time = valRepeat;
    /* NM p007c*/
    if(valRepeat)
        timStart(&timAutoH);
    /* NM p007c end*/
    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_KBD            |
| STATE   : code                        ROUTINE : kbdCommand         |
+--------------------------------------------------------------------+

  PURPOSE : handle mfw windows command

*/

static int kbdCommand (U32 cmd, void *h)
{
    switch(cmd)
    {
    case MfwCmdDelete:              /* delete me                */
        if(!h)
            return 0;
        kbdDelete(h);
        return 1;
    default:
        break;
    }

    return 0;
}

int  MorethanMaxPressKeyNum(int num)
{
    MmiTrace("MorethanMaxPressKeyNum");
    MmiTraceInt(g_keypadnum);   
    if(g_keypadnum > num)
        return 1;
    return 0;
}
#endif
