/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile:: mfw_mfw.c       $|
| $Author: root $ CONDAT GmbH           $Revision: 1.1.1.1 $|
| CREATED: 21.09.98                     $Modtime:: 23.03.00 10:47   $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : MFW_MFW

   PURPOSE : element chaining functions

   EXPORT  :

   TO DO   :

   $History:: mfw_mfw.c                                             $
 *
 * *****************  Version 11  *****************
 * User: Es           Date: 23.03.00   Time: 14:43
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * Added 'mfwParent(elem)'
 *
 * *****************  Version 10  *****************
 * User: Es           Date: 18.02.00   Time: 15:45
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * fixed alloc/free bug (shrink)
 * changed MfwMemLarge macro
 * added constants for MMI event handler return values
 *
 * *****************  Version 9  *****************
 * User: Kk           Date: 10.01.00   Time: 14:03
 * Updated in $/GSM/Condat/MS/SRC/MFW
 *
 * *****************  Version 4  *****************
 * User: Rm           Date: 12/22/99   Time: 4:34p
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 3  *****************
 * User: Be           Date: 29.11.99   Time: 14:31
 * Updated in $/GSM/Condat/SND-MMI/MFW
 * target integration
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 22.11.99   Time: 10:24
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 1  *****************
 * User: Es           Date: 18.11.99   Time: 16:35
 * Created in $/GSM/Condat/SND-MMI/MFW
 * Initial
 *
 * *****************  Version 6  *****************
 * User: Es           Date: 1.04.99    Time: 17:07
 * Updated in $/GSM/DEV/MS/SRC/MFW
 * removed lots of traces
 *
 * *****************  Version 5  *****************
 * User: Es           Date: 18.02.99   Time: 17:01
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 4  *****************
 * User: Es           Date: 17.02.99   Time: 19:11
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 3  *****************
 * User: Es           Date: 27.01.99   Time: 15:06
 * Updated in $/GSM/DEV/MS/SRC/MFW
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 23.12.98   Time: 16:19
 * Updated in $/GSM/DEV/MS/SRC/MFW
*/
#define ENTITY_MFW

#undef TRACE_MEMORY

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

//#include <stdio.h>
//#include <string.h>

#include "mfw_mfw.h"
#include "mfw_sys.h"
#include "mfw_win.h"


U16 mfwMemDynTotal = 0;                 /* sample memory usage      */
U16 mfwMemLowWater = 0xffff;            /* sample memory usage      */

MfwHdr *mfwFocus = 0;                   /* the focus node           */
MfwHdr *mfwRoot = 0;                    /* root of MFW elements     */
MfwCb mfwCommand [MfwTypMax];           /* MFW commands to modules  */


// modify by clrobert, for purpose of showing MFW memory usage on emulator
// chang
//static MfwMemHdr mfwMem;				  /* root of free memory list */
//static U8 *mfwMemBase;				  /* mfw dynamic memory pool  */
//static U8 *mfwMemEnd; 				  /* end of mfw memory		  */
//static U16 mfwMemLeft;				  /* space left in pool 	  */
// to
#ifdef _INNOVATION_EMULATOR_

U16 mfwMemBlock = 0;

MfwMemHdr mfwMem;				 /* root of free memory list */
U8 *mfwMemBase; 				 /* mfw dynamic memory pool  */
U8 *mfwMemEnd;					 /* end of mfw memory		 */
U16 mfwMemLeft; 				 /* space left in pool		 */
#else
static MfwMemHdr mfwMem;				/* root of free memory list */
static U8 *mfwMemBase;					/* mfw dynamic memory pool	*/
static U8 *mfwMemEnd;					/* end of mfw memory		*/
static U16 mfwMemLeft;					/* space left in pool		*/
#endif
// modify end

static MfwHdr mfwEorc = {0, MfwTypMax, 0}; /* end of root chain     */

U8     mfwSignallingMethod = 0;           /* default is focus+root    */

EXTERN MfwHdr * current_mfw_elem;
static EcMemInfo *memInfoRoot = 0;		//the start of ec memory link
static EcMemInfo memInfoNull = {0, 0,0, 0};  // end of chain
extern MfwHnd idle_get_window (void);
static void regEcMemory(MfwHnd addr,int size);
static void freeEcMemory(MfwHnd addr,int size);
void Trace_All(char *name,MfwHnd handle);
static unsigned char needreg=0;               //the flag indicate if need call regecmemory function
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwInit            |
+--------------------------------------------------------------------+

  PURPOSE : initialize framework

*/

MfwRes mfwInit (void *externalRoot, U16 dynMemSize)
{
    int i;

	// modify by clrobert
	// add
#ifdef _INNOVATION_EMULATOR_
	mfwMemBlock = 0;
#endif
	// add end

    mfwFocus = 0;                       /* initially no focus       */
    memInfoRoot=&memInfoNull;            //yq add for reset the start of ec memory link 
    dynMemSize &= ~(sizeof(MfwMemHdr)-1); /* align to header size   */
    mfwMemDynTotal = dynMemSize;
    if (dynMemSize)
    {
        mfwRoot = &mfwEorc;             /* points to end of chain   */
        mfwMemBase = (U8 *) externalRoot; /* setup memory handler   */
        mfwMemEnd = (U8 *) externalRoot + dynMemSize;
        mfwMem.next = 0;
        mfwMem.len = 0;
        ((MfwMemHdr *) mfwMemBase)->next = dynMemSize;
        ((MfwMemHdr *) mfwMemBase)->len = dynMemSize;
        mfwMemLeft = dynMemSize;
        memset(mfwMemBase+sizeof(MfwMemHdr),0,
                                    dynMemSize-sizeof(MfwMemHdr));
    }
    else
    {
        mfwRoot = (MfwHdr *) externalRoot; /* setup root pointer    */
        if (!mfwRoot)
            mfwRoot = &mfwEorc;         /* points to end of chain   */
        mfwMemBase = 0;
        mfwMemEnd = 0;
        mfwMem.next = 0;
        mfwMem.len = 0;
    }
    for (i = 0; i < MfwTypMax; i++)     /* init command table       */
        mfwCommand[i] = 0;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwExit            |
+--------------------------------------------------------------------+

  PURPOSE : finalize framework

*/

void mfwExit (void)
{
    TRACE_FUNCTION("mfwExit()");
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwSignallingMethod|
+--------------------------------------------------------------------+

  PURPOSE : Defines the signalling method

*/

MfwRes mfwSetSignallingMethod (U8 method)
{
  mfwSignallingMethod = method;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwInsert          |
+--------------------------------------------------------------------+

  PURPOSE : chain up framework element

*/

MfwHdr *mfwInsert (MfwHdr *h, MfwHdr *e)
{
    if (!e)                             /* nothing to insert        */
        return 0;

    if (!h)                             /* use root chain           */
    {
        e->next = mfwRoot;
        mfwRoot = e;
    }
    else if (h->type == MfwTypWin)      /* use window chain         */
    {
        e->next = ((MfwWin *) (h->data))->elems;
        ((MfwWin *) h->data)->elems = e;
        if (mfwFocus == e->next)        /* was focus window ?       */
            mfwFocus = e;               /* yes: reassign focus      */
    }
    else                                /* insert into any chain    */
    {
      //es        e->next = h->next;
      //es      h->next = e;
      return 0;
    }

    return e;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwAppend          |
+--------------------------------------------------------------------+

  PURPOSE : chain up framework element at end of chain

*/

MfwHdr *mfwAppend (MfwHdr **h, MfwHdr *e)
{
    if (!e)                             /* nothing to append        */
        return 0;

    if (!h)                             /* append to header chain   */
        h = &mfwRoot;

    if ((*h)->type == MfwTypMax)        /* empty chain              */
    {
        if (mfwFocus == *h)
            mfwFocus = e;
        e->next = *h;
        *h = e;
        return e;
    }

    while ((*h)->next && (*h)->next->type != MfwTypMax)
        h = &((*h)->next);

    e->next = (*h)->next;
    (*h)->next = e;

    return e;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwRemove          |
+--------------------------------------------------------------------+

  PURPOSE : unchain element and return its root

*/

MfwHdr **mfwRemove (MfwHdr *e)
{
    MfwHdr **rp, **rpr, *h;

    if (!e)                             /* nothing to remove        */
        return 0;

    h = e;                              /* find elements root       */
    while (h->next && h->type != MfwTypMax)
        h = h->next;
    if (h->type != MfwTypMax)
        return 0;
    h = h->next;                        /* h points to root element */
    if (!h)                             /* remove from header chain */
        rp = &mfwRoot;
    else if (h->type == MfwTypWin)      /* remove from window chain */
        rp = &(((MfwWin*)(h->data))->elems);
    else                                /* don't remove from normal */
        return 0;

    rpr = rp;
    while (*rp && (*rp)->type != MfwTypMax)
    {
        if (*rp == e)
        {
            *rp = e->next;
            if (mfwFocus == e)          /* first element of window  */
                mfwFocus = e->next;
            return rpr;
        }
        rp = &((*rp)->next);
    }

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwParent          |
+--------------------------------------------------------------------+

  PURPOSE : get parent of given element

*/

MfwHnd mfwParent (MfwHdr *h)
{
    if (!h)                             /* no element               */
        return 0;

    while (h->next && h->type != MfwTypMax)
        h = h->next;
    if (h->type != MfwTypMax)
        return 0;                       /* ERROR !                  */
    h = h->next;                        /* h points to root element */
    if (h && h->type == MfwTypWin)      /* parent should be window  */
        return h;

    return 0;                           /* root element             */
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwHeader          |
+--------------------------------------------------------------------+

  PURPOSE : get header of a given element

*/

MfwHnd mfwHeader (void)
{
  return current_mfw_elem;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwControl         |
+--------------------------------------------------------------------+

  PURPOSE : retrieve element control block

*/

MfwHnd mfwControl (MfwHdr *h)
{
    if (!h)
        return 0;
    if (h->type <= MfwTypNone || h->type >= MfwTypMax)
        return 0;

    return h->data;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwAlloc           |
+--------------------------------------------------------------------+

  PURPOSE : alloc MFW memory

*/

U8 *mfwAlloc (U16 size)
{
    MfwMemHdr *p, *n, *l;

    if (!mfwMemBase)
        return (U8 *) sysAlloc(size);

    size = (U16) mfwMemLarge(size);
    if (size >= mfwMemLeft)
    {
        TRACE_ERROR("mfwAlloc(): no memory");
        return 0;
    }
    if (!size)
    {
        TRACE_ERROR("mfwAlloc(): invalid memory request");
        return 0;
    }
    if (mfwMemBase + mfwMem.next > mfwMemEnd
              || mfwMemBase + mfwMem.next < mfwMemBase)
    {
        TRACE_ERROR("mfwAlloc(): corrupted memory");
        return 0;
    }

    p = &mfwMem;                        /* root of dyn memory       */
    n = (MfwMemHdr *) (mfwMemBase + p->next); /* first free block   */
    while ((U8 *) n < mfwMemEnd)
    {
        if (n->len == size)             /* fits exactly:            */
        {
            p->next = n->next;          /* just remove from chain   */
            mfwMemLeft -= size;
            if (mfwMemLeft < mfwMemLowWater)
                mfwMemLowWater = mfwMemLeft;
            memset(n,0,size);
            #ifdef ONEKEY_TOIDLE
            if(needreg==1)
            regEcMemory((MfwHnd)n,size);
            #endif

			// modify by clrobert
			// add
			#ifdef _INNOVATION_EMULATOR_
			mfwMemBlock ++;
			ShowHeapStatus(0);
			#endif
			// add end

            return (U8 *) n;
        }
        if (n->len > size)              /* take it from a big one   */
        {
            l = (MfwMemHdr *) ((U8 *) n + size); /* new header    */
            l->next = n->next;          /* setup chain to next    */
            l->len = (U16) (n->len - size); /* remaining memory   */
            p->next += size;            /* link with previous block */
            mfwMemLeft -= size;
            if (mfwMemLeft < mfwMemLowWater)
                mfwMemLowWater = mfwMemLeft;
            memset(n,0,size);
            #ifdef ONEKEY_TOIDLE
            if(needreg==1)
            regEcMemory((MfwHnd)n,size);
            #endif

			// modify by clrobert
			// add
			#ifdef _INNOVATION_EMULATOR_
			mfwMemBlock ++;
			ShowHeapStatus(0);
			#endif
			// add end
            
            return (U8 *) n;            /* allocated me address     */
        }
        p = n;
        n = (MfwMemHdr *) (mfwMemBase + n->next);
    }
    TRACE_ERROR("mfwAlloc(): no memory");

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW                |
| STATE   : code                        ROUTINE : mfwFree            |
+--------------------------------------------------------------------+

  PURPOSE : free allocated MFW memory

*/

void mfwFree (U8 *mem, U16 size)
{
    MfwMemHdr *p, *n;

#ifdef TRACE_MEMORY
    TRACE_EVENT_P2("MFWFree address = %p - %d bytes",mem,size);
#endif

    if (!mfwMemBase)
    {
        void *m = mem;
//NM later
        sysFree(m);
#ifdef ONEKEY_TOIDLE
		if(needreg==1)
    freeEcMemory((MfwHnd)mem,size);
		#endif
        return;
    }

    size = (U16) mfwMemLarge(size);
    if (!size || !mem || mem < mfwMemBase || mem >= mfwMemEnd
              || mem + size > mfwMemEnd
              || mem + size <= mfwMemBase)
    {
        TRACE_ERROR("mfwFree(): invalid");
        return;                         /* nothing to free          */
    }

    memset(mem,0,size);
    p = &mfwMem;                        /* root of dyn memory       */
    n = (MfwMemHdr *) (mfwMemBase + p->next); /* first free block   */
    while ((U8 *) n < mfwMemEnd && (U8 *) n < mem)
    {                                   /* search allocated area    */
        p = n;
        n = (MfwMemHdr *) (mfwMemBase + n->next);
    }
    if (mem == (U8 *) p || mem == (U8 *) n)
    {
        TRACE_ERROR("mfwFree(): already free");
        return;                         /* already free             */
    }

    if (p != &mfwMem && (U8 *) p + p->len == mem)
    {                                   /* adjacent to left free:   */
        p->len += size;                 /* just add it              */
    }
    else
    {
        p->next = (U16) (mem - mfwMemBase); /* new free link        */
        p = (MfwMemHdr *) mem;          /* to new header            */
        p->next = (U16) ((U8 *) n - mfwMemBase); /* link to next    */
        p->len = size;
    }
    if ((U8 *) n < mfwMemEnd && mem + size == (U8 *) n)
    {                                   /* adjacent to right free:  */
        p->next = n->next;              /* eliminate link and       */
        p->len += n->len;               /* eat up the space         */
    }
    mfwMemLeft += size;
    #ifdef ONEKEY_TOIDLE
    if(needreg==1)
    freeEcMemory((MfwHnd)mem,size);
    #endif

    // modify by clrobert
	// add
	#ifdef _INNOVATION_EMULATOR_
	mfwMemBlock --;
	ShowHeapStatus(0);
	#endif
	// add end
}

U16 mfwCheckMemoryLeft(void){
  char temp[40];
  sprintf(temp,"memory left %d",mfwMemLeft);
  TRACE_EVENT(temp);

  return mfwMemLeft;

}
//yq add for one key to idle
void freeandreg(void *addr)
{
	EcMemInfo *h=memInfoRoot;
	while(h&&(h!=&memInfoNull))
		{
			if(h->addr==addr)
				{
					
					mfwFree((U8 *)h->addr,h->size);
					break;
				}
			else
				h=h->next;
		}
}


int freeAll(void)
{

	EcMemInfo *h=memInfoRoot;
	EcMemInfo *c=0;
	while(h&&(h!=&memInfoNull))
		{
			if(h->win!=idle_get_window())
				{
					c=h;
					h=h->next;
					mfwFree((U8 *)(c->addr),(U16)(c->size));
				}
			else
				break;
		}
	memInfoRoot=&memInfoNull;
	return 1;
}
static void regEcMemory(MfwHnd addr,int size)
{
	EcMemInfo *t;
	unsigned char old_flag;
	MfwHdr *cur_hdr=(MfwHdr *)mfwParent(mfwFocus);
	//TRACE_EVENT("regecmemory");
	if(cur_hdr&&cur_hdr->type==MfwTypWin)
		{
	needreg=0;
	t=(EcMemInfo *)mfwAlloc(sizeof(EcMemInfo));
	needreg=1;
	t->addr=addr;
	t->size=size;
	t->win=(MfwHnd)cur_hdr;
	t->next=memInfoRoot;

	memInfoRoot=t;
		}
	return;
}

static void freeEcMemory(MfwHnd addr,int size)
{
	EcMemInfo **h=&memInfoRoot;
	EcMemInfo *c=0;
	unsigned char old_flag;
	//TRACE_EVENT("freeecmemory");
	while((*h)&&((*h)!=&memInfoNull))
		{
			if((*h)->addr==addr)
				{
					c=*h;
					*h=(*h)->next;
					break;
				}
			else
				h=&((*h)->next);
		}
	if(c)
		{
			needreg=0;
			mfwFree((U8 *)c,sizeof(EcMemInfo));
			needreg=1;
		}
	return;
}
unsigned char Set_regflag(unsigned char flag)
{
	unsigned char old_flag;
	old_flag=needreg;
	needreg=flag;
	return old_flag;
}

void Tracememory()
{
	 MfwMemHdr *p, *n;
	 p = &mfwMem;                        /* root of dyn memory       */
    n = (MfwMemHdr *) (mfwMemBase + p->next); /* first free block   */
    TRACE_EVENT("begin trace memory");
    while ((U8 *) n < mfwMemEnd )
    {                                   /* search allocated area    */
        p = n;
        n = (MfwMemHdr *) (mfwMemBase + n->next);
    }
    TRACE_EVENT("end trace memory");
    return;
}
