/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile:: mfw_mnu.c       $|
| $Author: jhxu $ CONDAT GmbH           $Revision: 1.16 $|
| CREATED: 24.11.98                     $Modtime:: 24.02.00 8:07    $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : MFW_MNU
 
   PURPOSE : menu handling functions

   EXPORT  :
 
   TO DO   :

   $History:: mfw_mnu.c      $

   ****************************************************
   *User:Ganchh        Date:12.06.2002 Time 14:58
   *Updated in MenuShow() add the dspl_Enable() function to make sure 
   *refresh display after the data updated completely.
 *
 * *****************  Version 18  *****************
 * User: Kk           Date: 28.02.00   Time: 10:33
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * font usage corrected for page and list menus. free menus still
 * need rework.
 *
 * *****************  Version 17  *****************
 * User: Es           Date: 17.01.00   Time: 17:37
 * Updated in $/GSM/Condat/MS/SRC/MFW
 * menu mode handling bug (uses only first level settings)
|
| *****************  Version 16  *****************
| User: Le           Date: 6.01.00    Time: 9:23
| Updated in $/GSM/Condat/MS/SRC/MFW
| Alignment of MFW versions
 *
 * *****************  Version 2  *****************
 * User: Es           Date: 22.11.99   Time: 10:29
 * Updated in $/GSM/Condat/SND-MMI/MFW
 *
 * *****************  Version 1  *****************
 * User: Es           Date: 18.11.99   Time: 16:35
 * Created in $/GSM/Condat/SND-MMI/MFW
 * Initial
*/
/****************************************************
  history: mfw_mnu.c
  21/06/02          zy
  change:change the viewlistmenusetting for display the mainmenu
        icons
 ****************************************************/
/****************************************************
 history: mfw_mnu.c
 27/06/02          zy
 change:add the key action mnu:up,down line by line and left,right
****************************************************/
/**********************************************************
   12/07/02	zy Mobile Innovation add static char * ListMenuTitleString;
                              static int    ListMneuFlag;
                              static void SetTitleStr(char * ListMenuTitleStr);
                              static void SetListFlag(int flag);
                              mnuListCreate()
                              and change drawListMenu()
               for add listmenu title
      
 $End
 ****************************************************/
/****************************************************
history: mfw_mnu.c
22/07/02          zy
change:make the dynamic menu flag to zero if menuescape
****************************************************/
/****************************************************
history: mfw_mnu.c
04/08/02          zy change pagemenu 
01/08/02          zy change:add drawlistIconMenu() and change flagFunc() return value
13/08/02          zy change mnupageup and mnupagedown and display right in ascall drawlisticonmenu
                and drawlistmenu
03/09/02          zy change add dynamiclistmnuflg in mnuattr and mnudown 
10/09/02          zy change base gch's listmenu,and menu data
11/04/03		  talcon add function:DomnuPageDown,DomnuPageUp for main mnu pagedown and pageup	
****************************************************/

#include <stdio.h>
#include <string.h>

#define ENTITY_MFW

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_sys.h"
#include "mfw_mfw.h"
#include "mfw_kbd.h"
#include "mfw_tim.h"
#include "gdi.h"
#include "dspl.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_ffs.h"
#include "mfw_win.h"
/*
#include "MmiResources.h" kk 
*///JVJE 
#include "aci_cmh.h"

//#include "mmirender.h"
//Mobile Innovation ganchh 2002/7/30
//#include "BmiEastAPI.h"
#include "..\bmi\mmisettings.h"//zy add 04/08/02
#include "..\bmi\Mmimain.h"//zy add 04/08/02
#include "..\bmi\Mmiicons.h"//zy add 04/08/02
#include "..\bmi\Mmi3dframe.h"

#include "..\bmi\mmiQQSwitch.h" //hxl add for check qq func
#include "..\bmi\mmicoordinate.h"/* 2004/01/13 sunsj */
//#include "rle.c"//2003/10/27,talcon add for decompressing
// 2004.4.9 wyj add
#include "..\bmi\mmisounds_defs.h"
#include "..\bmi\mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */
#include "..\bmi\icons\mainmenuicn.h"//jhxu720
#include "..\bmi\icons\ListIcn.h"//jhxu720
//#define TDTRACE 1
#include "..\bmi\mmiutilapi.h"

#define mainmenu_timeout 350
#define listmnu_timeout  350
#define listmnu_PaoMa_Base 3

/*#include "rvf_api.h"
#include "r2d.h"*/

//2004.1.14 WYJ  ADD
extern void StartPlayingMelody2( UBYTE melody_id, UBYTE count );
extern void StopPlayingMelody2(void);

static int menuIsEmpty (MfwMnu *m, MfwMnuAttr *ma);
static int countVisible (MfwMnu *m, MfwMnuAttr *ma, int start);
static void drawPageMenu (MfwMnu *mnu);
static void drawListMenu (MfwMnu *m);
static void drawFreeMenu (MfwMnu *m);
static void drawListIconMenu(MfwMnu *m);//zy add for list menu has icons each items
static int mnuCommand (U32 cmd, void *h);
static void drawViewListMenu (MfwMnu *mnu);

static int mainmenu_timer_cb(MfwEvt e, MfwTim *t);
/**************************************************/
void playMainMnuTone(U8 uIdx);
void stopMainMnuTone();

/* glowing : add 2003-10-29 */
char * GetMenuTitleString( MfwMnu *mnu, MfwMnuAttr *attr );

extern GLOBAL int get_StringWidth(char *string);

static MfwHnd mainmenutimer = NULL;

static MfwHnd menuTxtAnimtimer = NULL;

//extern T_R2D_GC_PTR r2d_g_lcd_gc;
/*.................................zy change for dynamic listmenu has title.......................................*/


//----------------ganchh 2002/9/6 menu browse action
static MfwMnuBrowseAction MenuBrowseAction=BrowseInit;


/* 2003/11/01,talcon add */
static MfwMnuAnim mfwmnuanim_t;

extern U16 mmiScrX, mmiScrY;
/*talcon 2003/10/31,talcon add */
U8 DomnuPageDown (MfwMnu *mnu);
U8 DomnuPageUp (MfwMnu *mnu);
/*2003//11/05,talcon add */
static void drawListMenuItem (MfwMnu *mnu,int nIdx,int nLines,int posY,char *szPlaceStr);
/*2003//11/08,talcon add */
void drawListMenuItem2(MfwMnu* mnu,int nIdx);
//void drawMnuIcnSel(MfwMnu* mnu);
//public
void drawAnimTimerIcn(MfwMnu* mnu,MfwHnd timer);

/*2003/11/10,talcon add */
static int listmenu_timer_cb(MfwEvt e, MfwTim *t);

extern U16 mmiScrX, mmiScrY;

/* 2004.1.30 WYJ add */
extern int gPlayKeytoneFlag;

extern const MfwIcnAttr currentbarIcon[2];
#if(MAIN_LCD_SIZE==3)
extern BOOL phonebook_search_flag;
#endif
/*................................end of zy change for listmenu has title.......................................*/
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuInit            |
+--------------------------------------------------------------------+

  PURPOSE : initialize menu handler

*/

MfwRes mnuInit (void)
{
    mfwCommand[MfwTypMnu] = (MfwCb) mnuCommand;
    /*2003/11/10,talcon add */
    memset(&mfwmnuanim_t,0,sizeof(mfwmnuanim_t) );
    mfwmnuanim_t.nMainMnuIdx = 0xff;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuExit            |
+--------------------------------------------------------------------+

  PURPOSE : finalize menu handler

*/

MfwRes mnuExit (void)
{
    mfwCommand[MfwTypMnu] = 0;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuCreate          |
+--------------------------------------------------------------------+

  PURPOSE : create menu control
  GW 05/10/01 - Changed single value 'lng' to 2 values indicating if ID's should be 
            used (useStrID) and if the strings are ascii or unicode (uesDefLang).

*/

MfwHnd mnuCreate (MfwHnd w, MfwMnuAttr *a, MfwEvt e, MfwCb f)
{
    MfwHdr *hdr = (MfwHdr *) mfwAlloc(sizeof(MfwHdr));
    MfwMnu *mnu = (MfwMnu *) mfwAlloc(sizeof(MfwMnu));

    if( !hdr || !mnu )
        return 0;

    mnu->mask = e;
    mnu->flags = 0;
    mnu->handler = f;
    mnu->attr = a;
    mnu->curAttr = a;

    mnu->useStrID = 0;
    mnu->useDefLang = 0;
    mnu->level = 0;
    mnu->listmnuflag=0;
    memset(mnu->lCursor,UNUSED,sizeof(mnu->lCursor));
    memset(mnu->lShift,1,sizeof(mnu->lShift));
    mnu->lCursor[0] = 0;
    // mnu->scrollMode = 1;
    mnu->scrollMode = 0;

    /*
    if ((mnu->curAttr->mode & MNU_DISPLAY) == MNU_VIEWLIST)
    {
       mnu->ani_timer = timCreate ( w, mainmenu_timeout, (MfwCb)mainmenu_timer_cb);
       //mnu->ani_timer = NULL;
       mnu->iconIndex = 0;
       //mnu->scrollMode = 1;
    }
    */
#ifndef FOR_FTA_CTA
    mainmenutimer = timCreate ( w, mainmenu_timeout, (MfwCb)mainmenu_timer_cb);

    //menuTxtAnimtimer = timCreate ( w, 200, (MfwCb)menuTxtAnim_timer_cb);
    //mnu->iconIndex = 0;

    /*2003/11/11 ,talcon add */
    if( mfwmnuanim_t.nDepListMnu++ == 0 )
    {
        mfwmnuanim_t.listmnulicontimer = timCreate ( w, 200, (MfwCb)listmenu_timer_cb);

    }
#endif
    mfwmnuanim_t.nMainMnuIdx = 0xff;
    hdr->data = mnu;
    hdr->type = MfwTypMnu;
    MenuBrowseAction=BrowseNew;   //ganchh 2002/9/13

    return mfwInsert(w,hdr);
}

/*********************************************
$History
******2003/11/08,talcon modify
******2003/11/10,talcon modify
************************************************/
static int mainmenu_timer_cb(MfwEvt e, MfwTim *t)
{
    MfwHnd     win  = mfwParent (mfwHeader());

    MfwHdr     *win_data = ( MfwHdr * )mfwHeader( ); 
    MfwMnu    *data = (MfwMnu *)win_data->data;

    MfwWin * win1 = (MfwWin *) ((MfwHdr *)win)->data ;
    MfwMnu    *m=(MfwMnu *)  ((MfwHdr *)  win1 ->elems ) ->data;

    U8 uMode;

    timStop( mainmenutimer );
    if( !winIsFocussed(win) )
    {
        return 0;
    }

    // 
    /* if ((m->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED )
     {	  
         drawAnimTimerIcn(m,mainmenutimer);
     }
     else*/if( (m->curAttr->mode & MNU_DISPLAY) == MNU_VIEWLIST )
    {
        winShow(win);
        if( mfwmnuanim_t.MainMnuIcnAnimIdx == 0xff )
        {
            mfwmnuanim_t.MainMnuIcnAnimIdx = 0;
            timStop( mainmenutimer );
        }
    }

    //   timStart(data->ani_timer);
    // timStart( mainmenutimer );


}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuListCreate          |
+--------------------------------------------------------------------+

  PURPOSE : create list menu control//zy add for display listmenu has tittle and word
  GW 05/10/01 - Changed single value 'lng' to 2 values indicating if ID's should be 
            used (useStrID) and if the strings are ascii or unicode (uesDefLang).

*/

MfwHnd mnuListCreate (MfwHnd w, MfwMnuAttr *a, MfwEvt e, MfwCb f, char * ListMenuTitleStr)
{
    MfwHdr *hdr = (MfwHdr *) mfwAlloc(sizeof(MfwHdr));
    MfwMnu *mnu = (MfwMnu *) mfwAlloc(sizeof(MfwMnu));

    if( !hdr || !mnu )
        return 0;

    mnu->mask = e;
    mnu->flags = 0;
    mnu->handler = f;
    mnu->attr = a;
    mnu->curAttr = a;

    mnu->useStrID = 0;
    mnu->useDefLang = 0;
    mnu->level = 0;
    mnu->listmnuflag=1;
    mnu->titlestr=ListMenuTitleStr;// zy add 0918
    // mnu->curAttr->items[mnu->lCursor[99]].str=ListMenuTitleStr;
    memset(mnu->lCursor,UNUSED,sizeof(mnu->lCursor));
    memset(mnu->lShift,1,sizeof(mnu->lShift));
    mnu->lCursor[0] = 0;
    // mnu->scrollMode = 1;
    mnu->scrollMode = 0;  //ganchh 2002/9/13
    hdr->data = mnu;
    hdr->type = MfwTypMnu;
    MenuBrowseAction=BrowseNew;   //ganchh 2002/9/13

    /*2003/11/10 ,talcon add */
#ifndef FOR_FTA_CTA
    if( mfwmnuanim_t.nDepListMnu++ == 0 )
    {
        mfwmnuanim_t.listmnulicontimer = timCreate ( w, 200, (MfwCb)listmenu_timer_cb);

    }
#endif
    return mfwInsert(w,hdr);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuDelete          |
+--------------------------------------------------------------------+

  PURPOSE : delete menu control

*/

MfwRes mnuDelete (MfwHnd m)
{
    MfwRes res;

    if( !m )
        return MfwResIllHnd;

    /*2003/11/10,talcon add*/
    {
        // MfwMnu * mnu = (MfwMnu *) ((MfwHdr *) m)->data;

        {
            mfwmnuanim_t.nDepListMnu -- ;
            timStop( mfwmnuanim_t.listmnulicontimer );  
        }
        mfwmnuanim_t.currentmnu = 0;
        mfwmnuanim_t.currentwin = 0;
    }
    mnuHide(m);
    res = (mfwRemove(m)) ? MfwResOk : MfwResIllHnd;

    mfwFree(((MfwHdr *) m)->data,sizeof(MfwMnu));
    mfwFree(m,sizeof(MfwHdr));

    return res;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuLang            |
+--------------------------------------------------------------------+

  PURPOSE : set / get whether the string is associated with an ID or if it is null-terminated

  GW 05/10/01 - Changed single value 'lng' to 2 values indicating if ID's should be 
            used (useStrID) and if the strings are ascii or unicode (uesDefLang).
*/

MfwHnd mnuLang (MfwHnd m, MfwHnd l)
{
    MfwHnd ol;
    MfwMnu *mnu;

    if( (mnu = mfwControl(m)) == 0 )
        return(MfwHnd) MfwResIllHnd;

    ol = mnu->useStrID;
    mnu->useStrID = l;
    mnu->useDefLang = l;

    return ol;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuStrType         |
+--------------------------------------------------------------------+

  PURPOSE : set / get language in use (1=use default ascii/unicode, 0=assume ascii)

  GW 05/10/01 - Changed single value 'lng' to 2 values indicating if ID's should be 
            used (useStrID) and if the strings are ascii or unicode (uesDefLang).
*/
MfwHnd mnuStrType (MfwHnd m, MfwHnd l)
{
    MfwHnd ol;
    MfwMnu *mnu;

    if( (mnu = mfwControl(m)) == 0 )
        return(MfwHnd) MfwResIllHnd;

    ol = mnu->useDefLang;
    mnu->useDefLang = l;

    return ol;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuShow            |
+--------------------------------------------------------------------+

  PURPOSE : show menu

*/

MfwRes mnuShow (MfwHnd m)
{
    MfwMnu *mnu;
    U8 uMode;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    uMode = dspl_Enable(0);//ganchh 2002/6/12

    mnu->flags |= E_MNU_VISIBLE;
    mnuUpdate(mnu);

    dspl_Enable(uMode);//ganchh 2002/6/12
    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuHide            |
+--------------------------------------------------------------------+

  PURPOSE : hide menu

*/

MfwRes mnuHide (MfwHnd m)
{
    MfwMnu *mnu;
    U8 dsplOld;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    mnu->flags &= ~E_MNU_VISIBLE;
    if( mnu->handler )
        if( mnu->mask & E_MNU_VISIBLE )
            mnu->handler(E_MNU_VISIBLE,mnu);

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuUnhide          |
+--------------------------------------------------------------------+

  PURPOSE : unhide menu (without drawing)

*/

MfwRes mnuUnhide (MfwHnd m)
{
    MfwMnu *mnu;
    U8 dsplOld;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    mnu->flags |= E_MNU_VISIBLE;
    if( mnu->handler )
        if( mnu->mask & E_MNU_VISIBLE )
            mnu->handler(E_MNU_VISIBLE,mnu);
    return MfwResOk;
}

int IsViewListMenu(MfwHnd m)
{
    MfwMnu *mnu;
    if( (mnu = mfwControl(m)) == 0 )
        return 0;
    if( (mnu->curAttr->mode & MNU_DISPLAY) == MNU_VIEWLIST )
        return 1;
    else
        return 0;

}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuUpdate          |
+--------------------------------------------------------------------+

  PURPOSE : draw menu

*/

MfwRes mnuUpdate (MfwMnu *m)
{

    U8 dsplOld;
    UINT32 oldColor;
    UINT32 oldFontColor;
    if( !m )
        return MfwResIllHnd;
    if( !(m->flags & E_MNU_VISIBLE) )
        return MfwResOk;

    if( m->handler )
        if( m->mask & E_MNU_VISIBLE )
            m->handler(E_MNU_VISIBLE,m);

        /*JVJE Update to fit the menu to a visible item */
    {
        MfwMnuAttr *ma = m->curAttr;
        int index= m->lCursor[m->level];

        while( (ma->items[index].flagFunc(m,ma,&(ma->items[index]))==FLAGFUNC_GRAY) & MNU_ITEM_HIDE )//zy change for flagFunction retun vlaue
        {
            index++;
            if( index>=ma->nItems )
                index =0;
        } 
        m->lCursor[m->level]=index;       
    }
    if( (m->curAttr->mode & MNU_DISPLAY) != MNU_VIEWLIST )
    {
        mfwmnuanim_t.nMainMnuIdx = 0xff;
    }
    //timStop( m->ani_timer );
    if( mainmenutimer != NULL )
        timStop( mainmenutimer );

    /*2003/11/10,talcon add*/
    mfwmnuanim_t.currentmnu = m;

    if( mfwmnuanim_t.listmnulicontimer )
        timStop(mfwmnuanim_t.listmnulicontimer);

    MMI_TRACE_EVENT(("<<<talcon,mnuUpdate--mode:0x%08x",m->curAttr->mode));
    if( (m->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED )
    {
        // _gMenuTextIndex = _gMenuTextAnim = 0;
        mfwmnuanim_t.IsMnuTextAnim = 0;
        mfwmnuanim_t.MnuTextIdx = 0;

        mfwmnuanim_t.MnuLeftIconIdx = 0;
        mfwmnuanim_t.nMainTimer = 0;
        drawListMenu(m);
        mfwmnuanim_t.currentmnu = m;
        if( (m->curAttr->mode & MNU_BOOKPHONE) ==0 )//ų绰
        {
            timSetTime(mfwmnuanim_t.listmnulicontimer,listmnu_timeout);
            timStart( mfwmnuanim_t.listmnulicontimer);
        }


    }
    else if( (m->curAttr->mode & MNU_DISPLAY) == MNU_PAGED )
        drawPageMenu(m);
    else if( (m->curAttr->mode & MNU_DISPLAY) == MNU_VIEWLIST )
    {
        drawViewListMenu( m);
        if( Mmi_getCurrentLanguage()==2 ) // 2004.4.13 WYJ not play voice in English
            gPlayKeytoneFlag = 2;
        else
            gPlayKeytoneFlag = 1;

        //timStart( m->ani_timer);
        timStart( mainmenutimer );
        if( mfwmnuanim_t.nMainMnuIdx != m->lCursor[(int)m->level] )
        {
            mfwmnuanim_t.nMainMnuIdx = m->lCursor[(int)m->level];
            if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].KeypadTone == 2 
                && (Mmi_getCurrentLanguage()== 2) )
            {
                StopPlayingMelody2();
                playMainMnuTone(mfwmnuanim_t.nMainMnuIdx);
            }
        }
    }
    else if( (m->curAttr->mode & MNU_DISPLAY) == MNU_LIST )
    {
        mfwmnuanim_t.MnuLeftIconIdx = 0;
        mfwmnuanim_t.nMainTimer = 0;
        drawListMenu(m);

        mfwmnuanim_t.currentmnu = m;
        timSetTime(mfwmnuanim_t.listmnulicontimer,listmnu_timeout);
        timStart( mfwmnuanim_t.listmnulicontimer);
    }

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuUp              |
+--------------------------------------------------------------------+

  PURPOSE : one step up

*/

MfwRes mnuUp (MfwHnd m)
{
    MfwMnu *mnu;
    MfwMnuAttr *ca;
    MfwMnuItem *ci;
    U8 uMode;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;


    ca = mnu->curAttr;
    if( ca->nItems==1 )
    {
        return MfwResOk;
    }
    uMode = dspl_Enable(0);
    do
    {
        if( mnu->lCursor[mnu->level] == 0 )
        {
            mnu->lCursor[mnu->level] = ca->nItems - 1;
            mnu->flags |= E_MNU_TOPPED;
            if( mnu->handler )
                if( mnu->mask & E_MNU_TOPPED )
                    mnu->handler(E_MNU_TOPPED,mnu);
        }
        else
        {
            mnu->lCursor[mnu->level] -= (U8) 1;
            mnu->flags &= ~E_MNU_TOPPED;
        }
        ci = ca->items + mnu->lCursor[mnu->level];
    } while( (ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY) & MNU_ITEM_HIDE );//zy change for flagFunction retun vlaue

    if( mnu->scrollMode ) /* Simple scrolling */
    {
        U8 shift = mnu->lShift[mnu->level];
        U8 index = countVisible(mnu,ca,mnu->lCursor[mnu->level]);
        U8 visibleItems = countVisible(mnu,ca,ca->nItems); 
        int ah = ca->area->sy;
        int fh = dspl_GetFontHeight();
        int nLines = ah / fh;;

        if( (((mnu->curAttr->mode & MNU_DISPLAY) == MNU_LIST)||((mnu->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED)) && mnu->level>0 ) //zy add mnuup for OVerLAPPED type
            nLines--;
        else if( (((mnu->curAttr->mode & MNU_DISPLAY) == MNU_LIST)||((mnu->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED))&&(mnu->listmnuflag==1) )//zy change when start dynamic listmenu with title
            nLines--;

        if( visibleItems<nLines )
            nLines = visibleItems;
        if( shift>1 )
            shift--;
        mnu->lShift[mnu->level] = shift;    

    }
    //-----------ganchh 2002/9/6-----begin
    if( MenuBrowseAction==BrowseInit )  //ganchh 2002/9/6 
        MenuBrowseAction=BrowseNew;  //ganchh 2002/9/6 
    else
        MenuBrowseAction=BrowseUp;  //ganchh 2002/9/6 
    //-----------ganchh 2002/9/8----end

    mfwmnuanim_t.IsMnuTextAnim = mfwmnuanim_t.MnuTextIdx= 0;

    mnuUpdate(mnu);
    dspl_Enable(uMode);
    return MfwResOk;
}

/*.....................zy for mainmenu pageup and pagedown..............*/

/*talcon 2003/10/31,talcon add */
U8 DomnuPageUp (MfwMnu *mnu)
{
    MfwMnuAttr *ca;
    MfwMnuItem *ci;

    U8 uRet = 0;

    ca = mnu->curAttr;

    if( mnu->lCursor[mnu->level] == 0 )
    {
        mnu->lCursor[mnu->level] = 7;
    }
    else if( mnu->lCursor[mnu->level]<4 )
    {
        mnu->lCursor[mnu->level] += 3;
    }
    else
    {
        mnu->lCursor[mnu->level] -=4;
    }

    if( mnu->lCursor[mnu->level] > ca->nItems-1 )
        return 2;
    ci = ca->items + mnu->lCursor[mnu->level];

    if( (ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY) & MNU_ITEM_HIDE )
        uRet = 1;
    return uRet;
}
////
MfwRes mnuPageUp (MfwHnd m)
{
    MfwMnu *mnu;
    MfwMnuAttr *ca;
    MfwMnuItem *ci;
    U8 uMode;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    /* 2003/10/31,talcon add */
    while( DomnuPageUp(mnu) )
    {
    }
    /* end talcon */

    uMode = dspl_Enable(0);
    TRACE_EVENT("mnuPageUp");

    ca = mnu->curAttr;
    /*2003/10/21,talcon comment it *
    if (mnu->lCursor[mnu->level] == 0)
    {
       mnu->lCursor[mnu->level] = ca->nItems+2 ;           
       do
       {
          mnu->lCursor[mnu->level] -= 3;
          mnu->flags |= E_MNU_TOPPED;
          if (mnu->handler)
             if (mnu->mask & E_MNU_TOPPED)
                mnu->handler(E_MNU_TOPPED,mnu);
          ci = ca->items + mnu->lCursor[mnu->level];
       }while ((ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY) & MNU_ITEM_HIDE);
       mnuUpdate(mnu);
       dspl_Enable(uMode);
       return MfwResOk;
    }
    if (mnu->lCursor[mnu->level] <= 2)
    {
       mnu->lCursor[mnu->level] = ca->nItems -1+mnu->lCursor[mnu->level]-3;
       mnu->flags |= E_MNU_TOPPED;
       if (mnu->handler)
          if (mnu->mask & E_MNU_TOPPED)
             mnu->handler(E_MNU_TOPPED,mnu);
    } else
    {
       mnu->lCursor[mnu->level] -= (U8) 3;
       mnu->flags &= ~E_MNU_TOPPED;
    }
    *end talcon */

    /* 2003/10/21,talcon add */
    /*2003/10/31,talcon comment */
#if 0 
    if( mnu->lCursor[mnu->level] == 0 )
    {
        mnu->lCursor[mnu->level] = ca->nItems - 1;
    }
    else if( mnu->lCursor[mnu->level]<4 )
    {
        mnu->lCursor[mnu->level] +=3;    
    }
    else
    {
        mnu->lCursor[mnu->level] +=4;
    }
    mnu->lCursor[mnu->level] %= ca->nItems;
    ci = ca->items + mnu->lCursor[mnu->level];
    if( mnu->lCursor[mnu->level] == ca->nItems -1 )
    {
        mnu->flags |= E_MNU_TOPPED;
        if( mnu->handler )
            if( mnu->mask & E_MNU_TOPPED )
                mnu->handler(E_MNU_TOPPED,mnu);
        if( (ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY) & MNU_ITEM_HIDE )
        {
            mnu->lCursor[mnu->level] += 4;
            mnu->lCursor[mnu->level] %=ca->nItems;
        }
    }
    else
    {
        mnu->flags |= E_MNU_BOTTOMED;
        if( mnu->handler )
            if( mnu->mask & E_MNU_BOTTOMED )
                mnu->handler(E_MNU_BOTTOMED,mnu);
    }
    /*end talcon*/
    ci = ca->items + mnu->lCursor[mnu->level];
#endif
    mfwmnuanim_t.IsMnuTextAnim = mfwmnuanim_t.MnuTextIdx= 0;

    mnuUpdate(mnu);
    dspl_Enable(uMode);
    return MfwResOk;
}
/*talcon 2003/10/31,talcon add */
U8 DomnuPageDown (MfwMnu *mnu)
{
    MfwMnuAttr *ca;
    MfwMnuItem *ci;

    U8 uRet = 0;

    ca = mnu->curAttr;

    if( mnu->lCursor[mnu->level] == 7 )
    {
        mnu->lCursor[mnu->level] = 0;
    }
    else if( mnu->lCursor[mnu->level]<4 )
    {
        mnu->lCursor[mnu->level] += 4;
    }
    else
    {
        mnu->lCursor[mnu->level] -=3;
    }

    if( mnu->lCursor[mnu->level] > ca->nItems-1 )
        return 2;

    ci = ca->items + mnu->lCursor[mnu->level];

    if( (ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY) & MNU_ITEM_HIDE )
        uRet = 1;
    return uRet;
}//////////
MfwRes mnuPageDown (MfwHnd m)
{
    MfwMnu *mnu;
    MfwMnuAttr *ca;
    MfwMnuItem *ci;
    U8 uMode;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    while( DomnuPageDown(mnu) )
    {
    }

    uMode = dspl_Enable(0);

    ca = mnu->curAttr;
    /*2003/10/21,talcon comment it*
    if (mnu->lCursor[mnu->level]==mnu->curAttr->nItems-1)
    {
       mnu->lCursor[mnu->level] =0;
       mnu->flags |= E_MNU_BOTTOMED;
       if (mnu->handler)
          if (mnu->mask & E_MNU_BOTTOMED)
             mnu->handler(E_MNU_BOTTOMED,mnu);
       ci = ca->items + mnu->lCursor[mnu->level];
       mnuUpdate(mnu);
       dspl_Enable(uMode);
       return MfwResOk;
    }
    if (mnu->lCursor[mnu->level]+3>mnu->curAttr->nItems-1)
    {
       TRACE_EVENT("mainmenu the last line");
       mnu->lCursor[mnu->level] =((mnu->lCursor[mnu->level]+3)-(mnu->curAttr->nItems-1));
       mnu->flags |= E_MNU_BOTTOMED;
       if (mnu->handler)
          if (mnu->mask & E_MNU_BOTTOMED)
             mnu->handler(E_MNU_BOTTOMED,mnu);
    } else
    {
       TRACE_EVENT("mainmenu add one line");
       mnu->lCursor[mnu->level] += (U8) 3;
       mnu->flags &= ~E_MNU_BOTTOMED;
 
    }
    * end talcon */

    /* 2003/10/21,talcon add */
    /* 200310/30,talcon comment it */
#if 0 
    if( mnu->lCursor[mnu->level]<4 )
    {
        mnu->lCursor[mnu->level] += 4;   
    }
    else
    {
        mnu->lCursor[mnu->level] +=5;
    }
    mnu->lCursor[mnu->level] %= 8;
    ci = ca->items + mnu->lCursor[mnu->level];
    /*2003/10/31,talcon modofy*/
    //if(mnu->lCursor[mnu->level] == ca->nItems -1 )
    if( mnu->lCursor[mnu->level] == ca->nItems -1 
        || mnu->lCursor[mnu->level] == ca->nItems -2 )
    {
        mnu->flags |= E_MNU_TOPPED;
        if( mnu->handler )
            if( mnu->mask & E_MNU_TOPPED )
                mnu->handler(E_MNU_TOPPED,mnu);
        if( (ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY) & MNU_ITEM_HIDE )
        {
            mnu->lCursor[mnu->level] ++;
            mnu->lCursor[mnu->level] %=ca->nItems;
        }
    }
    else
    {
        mnu->flags |= E_MNU_BOTTOMED;
        if( mnu->handler )
            if( mnu->mask & E_MNU_BOTTOMED )
                mnu->handler(E_MNU_BOTTOMED,mnu);
    }
    /*end talcon*/

    ci = ca->items + mnu->lCursor[mnu->level];
#endif
    mfwmnuanim_t.IsMnuTextAnim = mfwmnuanim_t.MnuTextIdx= 0;
    mnuUpdate(mnu);
    dspl_Enable(uMode);
    return MfwResOk;
}
/*.....................end of zy for mainmenu pageup and pagedown..............*/
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuDown            |
+--------------------------------------------------------------------+

  PURPOSE : one step down

*/

MfwRes mnuDown (MfwHnd m)
{
    MfwMnu *mnu;
    MfwMnuAttr *ca;
    MfwMnuItem *ci;
    U8 uMode;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    ca = mnu->curAttr;
    if( ca->nItems==1 )
        return MfwResOk;
    uMode = dspl_Enable(0);
    do
    {
        if( mnu->lCursor[mnu->level] >= mnu->curAttr->nItems - 1 )
        {
            mnu->lCursor[mnu->level] = 0;
            mnu->flags |= E_MNU_BOTTOMED;
            if( mnu->handler )
                if( mnu->mask & E_MNU_BOTTOMED )
                    mnu->handler(E_MNU_BOTTOMED,mnu);
        }
        else
        {
            mnu->lCursor[mnu->level] += (U8) 1;
            mnu->flags &= ~E_MNU_BOTTOMED;
        }
        ci = ca->items + mnu->lCursor[mnu->level];
    } while( (ci->flagFunc(mnu,ca,ci)==FLAGFUNC_GRAY)& MNU_ITEM_HIDE );//zy change for flagFunction retun vlaue

    if( mnu->scrollMode ) /* Simple scrolling */
    {
        U8 shift = mnu->lShift[mnu->level];
        U8 index = countVisible(mnu,ca,mnu->lCursor[mnu->level]);
        U8 visibleItems = countVisible(mnu,ca,ca->nItems); 
        int ah = ca->area->sy;
        int fh = dspl_GetFontHeight();
        int nLines = ah / fh;

        if( (((mnu->curAttr->mode & MNU_DISPLAY) == MNU_LIST)||((mnu->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED)) && mnu->level>0 ) //zy add mnudown for MNU_OVERLAPPED type
            nLines--;
        else if( (((mnu->curAttr->mode & MNU_DISPLAY) == MNU_LIST)||((mnu->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED))&&(mnu->listmnuflag==1) )//zy change when start dynamic listmenu with title
            nLines--;

        if( visibleItems<nLines )
            nLines = visibleItems;
        if( shift<nLines )
            shift++;
        mnu->lShift[mnu->level] = shift;    

    }
    //-----------ganchh 2002/9/6-----begin
    if( MenuBrowseAction==BrowseInit )  //ganchh 2002/9/6 
        MenuBrowseAction=BrowseNew;  //ganchh 2002/9/6 
    else
        MenuBrowseAction=BrowseDown;  //ganchh 2002/9/6 
    //-----------ganchh 2002/9/8----end

    mfwmnuanim_t.IsMnuTextAnim = mfwmnuanim_t.MnuTextIdx= 0;

    mnuUpdate(mnu);
    dspl_Enable(uMode);
    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuSelect          |
+--------------------------------------------------------------------+

  PURPOSE : select a menu item; if there is a submenu, go one level
            down

*/

MfwRes mnuSelect (MfwHnd m)
{
    MfwMnu *mnu;
    MfwMnuAttr *submenu, *ca;
    MenuFunc func;
    U8 dsplOld;

    U8 uMode;//nm
    /*2003/11/01,talcon modify */
    //if(_gMenuTextAnim && mainmenutimer)
    if( mainmenutimer )
    {
        gPlayKeytoneFlag = 1; //2004.1.30 WYJ add 
        timStop(mainmenutimer);
    }
    /*	if(mfwmnuanim_t.listmnulicontimer)
        {
            timStop(mfwmnuanim_t.listmnulicontimer);
        }
    */
    mfwmnuanim_t.IsMnuTextAnim = mfwmnuanim_t.MnuTextIdx= 0;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    ca = mnu->curAttr;

    /* glowing : comment the following block */
    /*
    if ((mnu->curAttr->mode & MNU_DISPLAY) == MNU_VIEWLIST)
    {
       timStop(mnu->ani_timer);
    }
    */

    uMode = dspl_Enable(0);//nm

    /*2003/11/10,talcon add*/
    if( (ca->mode & MNU_DISPLAY) == MNU_VIEWLIST )
    {
		/* 2004/05/28 sunsj modify for wap menu */
		if( mnu->lCursor[0] != 6 )
			displaySoftKeys( TxtSoftSelect, TxtSoftBack);
/*#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif*/
    }

    MenuBrowseAction=BrowseNew;   //ganchh 2002/9/6

    submenu = ca->items[mnu->lCursor[mnu->level]].menu;
    func = ca->items[mnu->lCursor[mnu->level]].func;

    if( func )                        /* perform submenu          */
    {
        if( func(mnu,&ca->items[mnu->lCursor[mnu->level]]) != MFW_EVENT_CONSUMED )
            timStart(mainmenutimer);
    }

    if( submenu )                      /* call menu function       */
    {
        MenuBrowseAction=BrowseInit;  //ganchh 2002/9/6 
        if( menuIsEmpty(mnu,submenu) )
        {
            mnu->flags |= E_MNU_EMPTY;
            if( mnu->handler && mnu->mask & E_MNU_EMPTY )
                mnu->handler(E_MNU_EMPTY,mnu);
            mnu->flags &= ~E_MNU_EMPTY;
        }
        else
        {
            dspl_Clear(ca->area->px, ca->area->py,
                       (U16) (ca->area->sx+ca->area->px-1),
                       (U16) (ca->area->sy+ca->area->py-1));
            mnu->level++;
            mnu->lCursor[mnu->level] = 0;
            ca = mnu->curAttr = submenu;
            if( (ca->items->flagFunc(mnu,ca,ca->items)==FLAGFUNC_GRAY)& MNU_ITEM_HIDE )//zy change for flagFunction retun vlaue
                mnuDown(m);
            else
            {
                MenuBrowseAction=BrowseNew;   //ganchh 2002/9/6
                /*2003/11/11,talcon modify */
                //mnuUpdate(mnu);
                mnuCommand(MfwCmdUpdate,m);
            }
        }

        dspl_Enable(uMode);//NM
        return MfwResOk;                      /* we do not have to check for !submenu */
    }

    if( !func && !submenu )                                /* inform mmi               */
    {
        mnu->flags |= E_MNU_SELECT;
        if( mnu->handler && mnu->mask & E_MNU_SELECT )
            mnu->handler(E_MNU_SELECT,mnu);
    }
    dspl_Enable(uMode);//NM
    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuEscape          |
+--------------------------------------------------------------------+

  PURPOSE : go back one level or leave the menu

*/

MfwRes mnuEscape (MfwHnd m)
{
    MfwMnu *mnu;
    MfwMnuAttr *attr;
    U8 lvl;
    U8 dsplOld;

    U8 uMode;//nm


    /*2003/11/01,talcon add*/
    mfwmnuanim_t.IsMnuTextAnim = mfwmnuanim_t.MnuTextIdx= 0;
    if( mainmenutimer )
    {
        timStop(mainmenutimer);
    }
    /*	if(mfwmnuanim_t.listmnulicontimer)
        {
            timStop(mfwmnuanim_t.listmnulicontimer);
        }
    */
    /*end ,talcon */
    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    if( (mnu->curAttr->mode & MNU_DISPLAY) == MNU_VIEWLIST )
    {
        mfwmnuanim_t.nMainMnuIdx = 0xff;
        stopMainMnuTone();
        gPlayKeytoneFlag = 1;
    }

    uMode = dspl_Enable(0);//nm
    MenuBrowseAction=BrowseNew;   //ganchh 2002/9/6
    MC_StopVibra();         //2004.4.16 WYJ modify
    //Stopplayingdevice();   //xsf add 2002.08.12 
    if( mnu->level != 0 )
    {
        mnu->lCursor[mnu->level] = UNUSED;
        mnu->lShift[mnu->level] = 1;
        mnu->level--;
        lvl = 0;                        /* set level 0              */
        attr = mnu->attr;               /* set start point          */
        while( lvl != mnu->level )
        {
            attr = attr->items[mnu->lCursor[lvl]].menu;
            lvl++;
        }
        mnu->curAttr = attr;
        mnuUpdate(mnu);
    }
    else
    {
        mnu->flags |= E_MNU_ESCAPE;
        if( mnu->handler )
            if( mnu->mask & E_MNU_ESCAPE )
                mnu->handler(E_MNU_ESCAPE,mnu);
    }

    dspl_Enable(uMode);//NM
    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuDone            |
+--------------------------------------------------------------------+

  PURPOSE : reset menu

*/

MfwRes mnuDone (MfwHnd m)
{
    MfwMnu *mnu;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    mnu->curAttr = mnu->attr;
    mnu->level = 0;
    memset(mnu->lCursor,UNUSED,sizeof(mnu->lCursor));
    memset(mnu->lShift,1,sizeof(mnu->lShift));
    mnu->lCursor[0] = 0;

    return MfwResOk;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuKeyAction       |
+--------------------------------------------------------------------+

  PURPOSE : perform direct jumping if there was pressed KCD_1
            through KCD_9; in this case function returns 1;
            otherwise function returns 0

*/

MfwRes mnuKeyAction (MfwHnd m, U8 keycode)
{
    MfwMnu *mnu;
    U8 directAccess;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    switch( keycode )
    {
    case KCD_1: directAccess = 0; break;
    case KCD_2: directAccess = 1; break;
    case KCD_3: directAccess = 2; break;
    case KCD_4: directAccess = 3; break;
    case KCD_5: directAccess = 4; break;
    case KCD_6: directAccess = 5; break;
    case KCD_7: directAccess = 6; break;
    case KCD_8: directAccess = 7; break;
    case KCD_9: directAccess = 8; break;
    default: return 0;
    }

    if( directAccess >= mnu->curAttr->nItems )
        return 0;
    //disabled hided menu key action 
    if( mnu->curAttr->items[directAccess].flagFunc(mnu,mnu->curAttr,&(mnu->curAttr->items[directAccess])) & MNU_ITEM_HIDE )
        return 0;
    mnu->lCursor[mnu->level] = directAccess;
    MenuBrowseAction=BrowseNew;   //xsf add 2003.03.13
    mnuShow(m);
    //mnuSelect(m);  xsf remarked it 2003.02.18

    return 1;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuChooseItem      |
+--------------------------------------------------------------------+

  PURPOSE : Chooses the nItemst Item.

*/

MfwRes mnuChooseVisibleItem(MfwHnd m,U8 nItem)
{

    MfwMnu *mnu;
    int i;

    if( (mnu = mfwControl(m)) == 0 )
        return MfwResIllHnd;

    if( (int)nItem<0 )
        return MfwResIllHnd;

    for( i = 0; i < mnu->curAttr->nItems; i++ )
    {
        if( !(mnu->curAttr->items[i].flagFunc(mnu,
                                              mnu->curAttr,
                                              &(mnu->curAttr->items[i]))==FLAGFUNC_GRAY)//zy change for flagFunction retun vlaue
            & MNU_ITEM_HIDE )
        {
            if( !nItem )
            {
                mnu->lCursor[mnu->level] = i;
                MenuBrowseAction=BrowseNew;   //ganchh 2002/9/13
                mnuUpdate(mnu);
                return MfwResOk;
            }
            else
                nItem--;
        }
    }
    return MfwResIllHnd;

}



/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : menuIsEmpty        |
+--------------------------------------------------------------------+

  PURPOSE : check for empty submenu

*/

static int menuIsEmpty (MfwMnu *m, MfwMnuAttr *ma)
{
    int i;

    for( i = 0; i < ma->nItems; i++ )
        if( !(ma->items[i].flagFunc(m,ma,&(ma->items[i]))==FLAGFUNC_GRAY)//zy change for flagFunction retun vlaue
            & MNU_ITEM_HIDE )
            return 0;

    return 1;
}





/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : countVisible       |
+--------------------------------------------------------------------+

  PURPOSE : count visible items up to current item

*/

static int countVisible (MfwMnu *m, MfwMnuAttr *ma, int start)
{
    int i, count;

    for( i = 0, count = 0; i < start; i++ )
    {
        if( !(ma->items[i].flagFunc(m,ma,&(ma->items[i]))==FLAGFUNC_GRAY)//zy change for flagFunction retun vlaue
            & MNU_ITEM_HIDE )
            count++;
    }

    return count;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : countVisible       |
+--------------------------------------------------------------------+

  PURPOSE : search the last be visible line

*/
static int MenuVisibleLastCursor (MfwMnu *m, MfwMnuAttr *ma, int end)
{
    int i, count;

    for( i =end ; i >=0; i-- )
    {
        if( !(ma->items[i].flagFunc(m,ma,&(ma->items[i]))==FLAGFUNC_GRAY)//zy change for flagFunction retun vlaue
            & MNU_ITEM_HIDE )
        {
            count=i;
            i=-1;
        }
    }

    return count;
}
/*****************************************
$Function:
$Description:search the visible item by specied step forword or backwork
*****************************************************/
U8 getVisibleByStep(MfwMnu *m, MfwMnuAttr *ma,int start,int step)
{
    U8 i;
    for( i  = start; i< ma->nItems && i>=0; i+=step )
    {
        if( !(ma->items[i].flagFunc(m,ma,&(ma->items[i]))==FLAGFUNC_GRAY)
            & MNU_ITEM_HIDE )
            return i;
    }
    return 0xff;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : countVisibleItems  |
+--------------------------------------------------------------------+

  PURPOSE : count visible items in the current branch

*/

U8 mnuCountVisibleItems (MfwHnd m)
{
    MfwMnu *mnu;

    if( (mnu = mfwControl(m)) == 0 )
        return 0;

    return(U8)countVisible(mnu, mnu->curAttr,mnu->curAttr->nItems);
}


/*
+--------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU                  |
| STATE   : code                        ROUTINE : countCurrentVisibleItem  |
+--------------------------------------------------------------------------+

  PURPOSE : returns the position of the current Item
*/
#if 0
U8 mnuCountCurrentVisibleItem(MfwMnu* mnu)
{
    U8 i;
    U8 pos=0;

    for( i = 0; i < mnu->curAttr->nItems; i++ )
    {
        if( (mnu->lCursor[mnu->level]) == i )
            return pos;
        if( !(mnu->curAttr->items[i].flagFunc(mnu,
                                              mnu->curAttr,
                                              &(mnu->curAttr->items[i]))==FLAGFUNC_GRAY)//zy change for flagFunction retun vlaue
            & MNU_ITEM_HIDE )
            pos++;
    }
    return pos;

}

#endif


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : checkPredraw       |
+--------------------------------------------------------------------+

  PURPOSE : check / generate predraw event

*/

static int checkPredraw (MfwMnu *mnu, MfwMnuItem *mi,
                         char **t, MfwIcnAttr **icn)
{
    int res = 0;

    if( (mi->flagFunc(mnu,mnu->curAttr,mi)==FLAGFUNC_GRAY)& MNU_ITEM_NOTIFY )//zy change for flagFunction retun vlaue
    {
        mnu->flags |= E_MNU_PREDRAW;
        if( mnu->handler )
            if( mnu->mask & E_MNU_PREDRAW )
            {
                if( mi->exta )
                {
                    ((MfwItmExtPredraw*)(mi->exta))->str = *t;
                    ((MfwItmExtPredraw*)(mi->exta))->icon = *icn;
                }
                res = mnu->handler(E_MNU_PREDRAW,mi);
                if( mi->exta )
                {
                    *t = ((MfwItmExtPredraw*)(mi->exta))->str;
                    *icn = ((MfwItmExtPredraw*)(mi->exta))->icon;
                }
            }
        mnu->flags &= ~E_MNU_PREDRAW;
    }

    return res;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : checkPostdraw      |
+--------------------------------------------------------------------+

  PURPOSE : check / generate postdraw event

*/

static int checkPostdraw (MfwMnu *mnu, MfwMnuItem *mi)
{
    int res = 0;

    if( (mi->flagFunc(mnu,mnu->curAttr,mi)==FLAGFUNC_GRAY) & MNU_ITEM_NOTIFY )//zy change for flagFunction retun vlaue
    {
        mnu->flags |= E_MNU_POSTDRAW;
        if( mnu->handler )
            if( mnu->mask & E_MNU_POSTDRAW )
                res = mnu->handler(E_MNU_POSTDRAW,mi);
        mnu->flags &= ~E_MNU_POSTDRAW;
    }

    return res;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : checkStatus        |
+--------------------------------------------------------------------+

  PURPOSE : check / insert item status (string MUST be in RAM)

*/

static int checkStatus (MfwMnu *m, MfwMnuAttr *ma, MfwMnuItem *mi,
                        char *p)
{
    char *e;                            /* ES!! UNICODE             */

    if( !(mi->flagFunc(m,ma,mi)==FLAGFUNC_GRAY)& MNU_ITEM_STATED )//zy change for flagFunction retun vlaue
        return 0;
    e = mi->exta;
    if( !e )
        return 0;
    while( *p )
    {
        if( *p == '%' )                  /* ES!! : UNICODE           */
        {
            switch( *(p+1) )
            {
            case 'c':               /* single char              */
                strcpy(p+1,p+2);
                *p = *e;
                e++;
                break;
            }
        }
        p++;
    }

    return 1;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : drawPageMenu       |
+--------------------------------------------------------------------+

  PURPOSE : draws menu in page mode

  GW 05/10/01 - Changed single value 'lng' to 2 values indicating if ID's should be 
            used (useStrID) and if the strings are ascii or unicode (uesDefLang).

*/

static void drawPageMenu (MfwMnu *mnu)
{
    MfwMnuAttr *ma;                     /* menu attributes          */
    U16 th, tw, tl;                     /* text height, width, len  */
    U16 ax, ay, aw, ah, x;              /* menu area dimensions     */
    int tLines;                         /* lines in item text       */
    int nLines;                         /* lines in menu area       */
    char *txt, *t2, save;               /* item text & clip saver   */
    MfwIcnAttr * icn;                    /* item icon                */
    U8 oldFont = -1;                    /* save previous font       */
    MfwMnuItem *mi;                     /* current item             */
    char tt [64], *t;                   /* temp item string         */
    int i,currentTheme;

    ma = mnu->curAttr;
    if( ma->font != (U8) -1 )
        oldFont = dspl_SelectFontbyID(ma->font); /* setup font */

    ax = ma->area->px; ay = ma->area->py;
    aw = ma->area->sx; ah = ma->area->sy;
    th = dspl_GetFontHeight();
    currentTheme=FlashSettingData.theme;
    mi = ma->items + mnu->lCursor[mnu->level];
    icn = mi->icon;
    txt =  mi->str;
    if( mnu->useStrID )                       /* use language handler     */
        txt =  (char*)MmiRsrcGetText((int)txt);
    checkPredraw(mnu,mi,&txt,&icn);     /* ES!!                     */
    dspl_Clear(ax,ay,(U16)(ax+aw-1),(U16)(ay+ah-1));
    /*
     zy 2003-02-20 display title icon
    */
	/* 2004/06 sunsj modify for picture manage */
	DRAW_ICON_LOCATION(ICON_MENUUP, ax, ay);
    //dspl_BitBlt(ax, ay, menuup[currentTheme].area.sx, menuup[currentTheme].area.sy, 0, (void*)menuup[currentTheme].icons, 0);
    /*
     end of zy 2003-02-20 
    */
    if( dspl_get_char_type()==DSPL_TYPE_ASCII )
    {
        strncpy(tt,txt,64);                 /* text in RAM !            */
        checkStatus(mnu,ma,mi,tt);          /* process this text        */
        t = tt;

        nLines = ah / th;                   /* text lines in menu area  */
        for( t2 = t, tLines = 1; *t2; t2++ )
        {
            if( *t2 == '\n' )
            {
                tLines++;                   /* number of item lines     */
                *t2 = 0;                    /* make each line a string  */
            }
        }
        if( tLines > nLines )
            tLines = nLines;
        nLines = 0;

        while( nLines < tLines )
        {
            tl = (U16) dspl_str_length(t);
            //2004-03-29 Sunny modify
            //tw = dspl_GetTextExtent(t,tl);
            tw = get_StringWidth(t);
            if( tw > aw )
            {
                tl = dspl_GetMaxTextLen(t,aw);
                //2004-03-29 Sunny modify
                //tw = dspl_GetTextExtent(t,tl);
                tw = get_StringWidth(t);
            }
            save = *(t + tl);
            *(t + tl) = '\0';               /* clip this line           */

            if( (ma->mode & MNU_ALIGN) == MNU_CENTER )
                x = (U16) (ax + (aw - tw) / 2);
            else if( (ma->mode & MNU_ALIGN) == MNU_RIGHT )
                x = (U16) (ax + aw - tw);
            else
                x = ax;                     /* MNU_LEFT (default)       */
            /*
              zy 2003-02-20 english text
            */
            // dspl_TextOut(x,(U16)(ay+nLines*th),DSPL_TXTATTR_CURRENT_MODE,t);
            drawcolorclarity(x,(U16)(ay+nLines*th),t, 0xffffff);
            /* 
              end of zy change 2003-02-20
            */
            *(t + tl) = save;               /* restore clipped line     */
            t += dspl_str_length(t) + 1;             /* next line of item        */
            nLines++;
            if( nLines < tLines )
                *(t-1) = '\n';              /* restore CR in item       */
        }
    }
    else
    {
        if( (ma->mode & MNU_ALIGN) == MNU_CENTER )
            x = (U16) (ax + (aw - tw) / 2);
        else if( (ma->mode & MNU_ALIGN) == MNU_RIGHT )
            x = (U16) (ax + aw - tw);
        else
            x = ax;                     /* MNU_LEFT (default)       */
        /*
        zy 2003-02-20 add chinese language
        */

        drawcolorclarity(x,(U16)ay,txt, 0xffffff);
        //       	dspl_TextOut(x,(U16)ay,DSPL_TXTATTR_CURRENT_MODE,txt);
        /*
        end of zy change 2003-02-20
            */    
    }
    if( icn != NULL )
    {                                   /* show associated icon     */
        /*
           zy change because we need display 120X128 in idle screen,
           but we only need display 120X124 in menu avoid softkey display few so we have to 
           control display at 0,18,120,124
        */
        //  dspl_BitBlt(icn->area.px,icn->area.py,
        //              icn->area.sx,icn->area.sy,
        //              0,icn->icons,0);
        dspl_BitBlt(0,18,
                    120,124,
                    0,icn->icons,0);
        /*
        end of zy 2003-02-20
        */
    }

    if( oldFont != (U8) -1 )
        dspl_SelectFontbyID(oldFont);   /* restore previous font    */

    checkPostdraw(mnu,mi);              /* ES!!                     */
}


/*2003/10/21,talcon,ʵֶ˵ƵЧ*/
static int trunMeneText(char* strDest,char* strOrig,const U16 nIndex,const int areaWidth)
{
    int nRet = 0;
    int nTextWidth;
    int nInterval = 1;
    char *p = strOrig;
    int ncharLen = wstrlen(strOrig);
    char *pEnd, *pBegin = strDest;
	USHORT chr;	//jhxu82add

    if( *(unsigned char*)strOrig == 0x80 )
    {
        nInterval = 2;
        *pBegin++ = *strOrig;
        p++;
    }


    //nTextWidth = dspl_GetTextExtent(strOrig,(U16)dspl_str_length(strOrig));
    nTextWidth = get_StringWidth(strOrig);
    if( nTextWidth <= areaWidth )
    {
        memcpy(strDest,strOrig,ncharLen + nInterval);
        return 0;//nRet;jhxu82 modify
    }
	p += nIndex * nInterval;//jhxu82add
	if(nInterval  ==2)
		*strDest++ = 0x80;
	nTextWidth = 0;	
    /*memcpy(pBegin,p + nIndex * nInterval, ncharLen - nIndex * nInterval +  nInterval);
    pEnd = pBegin + (ncharLen-1) - nIndex * nInterval;*/
	
    while( 1 )
    {
        //nTextWidth = wstrBitlen(strDest) * 8;//= dspl_GetTextExtent(strDest,(U16)dspl_str_length(strDest));
        /*nTextWidth = get_StringWidth(strDest);jhxu82 
        if( nTextWidth <= areaWidth )*/
		if(nInterval ==2)			
        {
			chr = ( (*p & 0x00ff) << 8) | (*(p+1) & 0x00ff);			
            //break;
        }
        else
        {
			chr = *p;			
            //return 1;
        }

/*        *(--pEnd)  = 0;
        if( nInterval == 2 )*/
		if(chr == 0)/*the end if string*/
			return 0;
		nTextWidth += get_CharWidth(chr);
		if(nTextWidth > areaWidth)
			break;
		
		*strDest ++ =*p++;
		if(nInterval ==2)			
        {
			*strDest ++ =*p++;
            //*(--pEnd)  = 0;
        }
        nRet ++;
    }

    return 1;//nRet;jhxu82
}//end trunMeneText

/*************************************
$Description:menu item 
****************************************/
U8 getListMnuLines(MfwMnu *mnu)
{
    MfwMnuAttr *ma  = mnu->curAttr;
    MfwIcnAttr* icnTitleBar = GET_ICONATTR(ICON_MENUTITLE, 0);//(MfwIcnAttr*)&titleicons[0];/* 2004/06 sunsj modify for icon manage */
    return(ma->area->sy - icnTitleBar->area.sy - icnTitleBar->area.py - MNULIST_ITEM_TOPOFFSET)/MNULIST_ITEM_HEIGHT;
}//end getListMnuLines
/*************************************
$Description:menu item Yʼ
****************************************/
U8 getListMnuPosY(MfwMnu *mnu)
{
    MfwMnuAttr *ma  = mnu->curAttr;
    MfwIcnAttr* icnTitleBar = GET_ICONATTR(ICON_MENUTITLE, 0);//(MfwIcnAttr*)&titleicons[0];/* 2004/06 sunsj modify for icon manage */
    return icnTitleBar->area.sy + icnTitleBar->area.py + MNULIST_ITEM_TOPOFFSET;
}//end getListMnuPosY
static void drawListMenu (MfwMnu *mnu)
{
    char *txt;
    U8 nTextLen,nTextHgt;
    int nPosX,nPosY;
    U8 nLines;//menu list menu item
    U8 nLineFirst,nLineEnd;//ҪµʼкͽУ
    U8 nLineCurr;//ǰѡе
    U8 nLineStep;
    U8 i;
    MfwMnuAttr *ma  = mnu->curAttr;
    if( MenuBrowseAction==BrowseInit )
    {
        MenuBrowseAction  = BrowseNew;
    }

    /*******caculate nLines ,nLineCurr,nLineFist,nLineEnd***************/
    nLines =  getListMnuLines(mnu);
    nLineCurr = mnu->lCursor[(int)mnu->level];
    nLineFirst = nLineCurr - nLineCurr%nLines;
    nLineEnd = nLineFirst + nLines -1;
    if( nLineEnd >= ma->nItems )
        nLineEnd = ma->nItems - 1;
    nLineStep = 1;
    switch( MenuBrowseAction )
    {
    U8 temp;
    case BrowseUp:
        temp = getVisibleByStep(mnu,ma,nLineCurr+1,1);
        if( temp < nLineFirst || temp> nLineEnd )
        {
            MenuBrowseAction = BrowseNew;
            break;
        }
        nLineEnd = temp;
        nLineFirst = nLineCurr;
        nLineStep = nLineEnd - nLineCurr;
        break;
    case BrowseDown:                      
        temp = getVisibleByStep(mnu,ma,nLineCurr-1,-1);
        if( temp < nLineFirst || temp> nLineEnd )
        {
            MenuBrowseAction = BrowseNew;
            break;
        }
        nLineFirst = temp;
        nLineEnd = nLineCurr;
        nLineStep = nLineCurr - nLineFirst;
        break;        
    }
    /***end caculate nLines ,nLineCurr,nLineFist,nLineEnd***************/

    /**************draw title bar and title***************/
    if( MenuBrowseAction == BrowseNew )
    {
        MfwIcnAttr* icnTitleBar = GET_ICONATTR(ICON_MENUTITLE, 0);//(MfwIcnAttr*)&titleicons[0];/* 2004/06 sunsj modify for icon manage */

#if(MAIN_LCD_SIZE==4)
        UINT32 color =  dspl_SetBkgColor(MNULIST_BKGCOLOR);
		dspl_Clear(ma->area->px,ma->area->py,ma->area->px + ma->area->sx, ma->area->py + ma->area->sy); 
        dspl_SetBkgColor(color);
#endif
   
#if(MAIN_LCD_SIZE==3)
		
		draw_softkeybar_updown_arrow();//jhxu720
		if(phonebook_search_flag==TRUE)
			nPosX=0;
		else
			DRAW_ICON(ICON_MENULISTBKGICONS);
		DRAW_ICON_SEL(ICON_MENUTITLE, 0);
        DRAW_ICON_SEL(ICON_MENUTITLE, ma->titleicon);
		//DRAW_ICON_SEL(ICON_CURRENTBAR,0);
		//draw title on right
		txt = GetMenuTitleString( mnu, ma );  //ò˵;
		nPosX = icnTitleBar->area.sx + icnTitleBar->area.px - get_StringWidth((char *)txt);
		nPosX -=2;
		if(nPosX < icnTitleBar->area.px)
			nPosX = icnTitleBar->area.sx;
		
		nPosY = icnTitleBar->area.py + (icnTitleBar->area.sy - dspl_GetFontHeight())/2;
		if(nPosY < icnTitleBar->area.py)
			nPosY = icnTitleBar->area.sy;
		
		if(txt)
			dspl_TextOut_NoNewline(nPosX, nPosY,DSPL_TXTATTR_TRANSPARENT, (char *)txt);
	
#endif
#if(MAIN_LCD_SIZE==4)
        //draw title bar
        DRAW_ICON_SEL(ICON_MENUTITLE, 0);
        //draw title icon
		DRAW_ICON_SEL(ICON_MENUTITLE, ma->titleicon);
        //drawIconByIcnAttr((MfwIcnAttr*)(icontable[ICON_MENUTITLE].icon+ma->titleicon)/*(MfwIcnAttr*)&titleicons[ma->titleicon]*/,0);/* 2004/06 sunsj modify for icon manage */
        //draw memu list background
        //drawIconByIcnAttr((MfwIcnAttr*)&mnulistbkgicons[0],0);
        //draw title on right
        if( (ma->mode & MNU_NOTITLE) == 0 )//2004/05/25 yhf modify for game title
        {
            txt = GetMenuTitleString( mnu, ma );  //ò˵;
            nPosX = icnTitleBar->area.sx + icnTitleBar->area.px - get_StringWidth((char *)txt);
            nPosX -=2;
            if( nPosX < icnTitleBar->area.px )
                nPosX = icnTitleBar->area.sx;
            /* 2004/05/14 yhf modify */
            else if( nPosX > MNULIST_TITLE_POSX )
                nPosX = MNULIST_TITLE_POSX ; //˵λ

            nPosY = icnTitleBar->area.py + (icnTitleBar->area.sy - dspl_GetFontHeight())/2;
            if( nPosY < icnTitleBar->area.py )
                nPosY = icnTitleBar->area.sy;
            if( txt )
                dspl_TextOut_NoNewline(nPosX, nPosY,DSPL_TXTATTR_WHITE_EDGE, (char *)txt);//˵

#if ( MAIN_LCD_SIZE==2 )
            if( txt )
                dspl_TextOut_NoNewline(nPosX, nPosY,DSPL_TXTATTR_TRANSPARENT, (char *)txt);
#endif
        }
#endif
    }
    //end draw title bar and title

    /*********draw menu item *****************/
    nPosY = getListMnuPosY(mnu);
    for( i = nLineFirst;i <=nLineEnd; i+=nLineStep )
    {
        drawListMenuItem(mnu,i,nLines,
                         nPosY,
                         NULL);
    }
    /*******end draw menu item *****************/
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : drawFreeMenu       |
+--------------------------------------------------------------------+

  PURPOSE : draws menu in overlapped mode

*/
static void drawFreeMenu (MfwMnu *mnu)
{
    // ES!! to be revised
    //kk needs font entry
    int nFontHeight;
    int i, x;
    int nIdx;
    int nTextLen;
    MfwIcnAttr * icn;

    MfwMnuAttr *wa;                     /* working attribute        */


    wa = mnu->curAttr;
    dspl_Clear(wa->area->px,wa->area->py,
               (U16)(wa->area->sx+wa->area->px-1),
               (U16)(wa->area->sy+wa->area->py-1));
    nFontHeight = dspl_GetFontHeight();

    //2004-03-29 Sunny modify
    /*nTextLen = dspl_GetTextExtent(wa->items[mnu->lCursor[mnu->level]].str,
                                  (U16)dspl_str_length(wa->items[mnu->lCursor[mnu->level]].str));*/
    nTextLen = get_StringWidth(wa->items[mnu->lCursor[mnu->level]].str);

    if( (wa->mode & MNU_ALIGN) == MNU_CENTER )
        x = wa->area->px + (wa->area->sx - nTextLen) / 2;
    else if( (wa->mode & MNU_ALIGN) == MNU_RIGHT )
        x = wa->area->px + wa->area->sx - nTextLen;
    else
        x = wa->area->px;

    dspl_TextOut((U16)x,(U16)(wa->area->py+wa->area->sy-nFontHeight),DSPL_TXTATTR_CURRENT_MODE,
                 wa->items[mnu->lCursor[mnu->level]].str);

    for( i = 0; i < wa->nItems; i++ )
    {
        nIdx = (mnu->lCursor[mnu->level] + i + 1) % wa->nItems;
        icn = wa->items[nIdx].icon;
        if( icn != NULL )
            dspl_BitBlt(icn->area.px,icn->area.py,
                        icn->area.sx,icn->area.sy,
                        0/*icn->usIndex*/,icn->icons,0);
    }
}

/************zy Mobile Innovation add this function for draw listicon menu**************/
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : drawListIconMenu       |
+--------------------------------------------------------------------+

  PURPOSE : draws menu in ListIcon mode

*/
static void drawListIconMenu (MfwMnu *mnu)
{
    MfwMnuAttr *ma;                     /* menu attributes          */
    U16 fh, fw;                         /* font height & width      */
    U16 ax, ay, aw, ah;                 /* menu area dimensions     */
    U16 x;
    int nLines;
    int nFirstLine, nEndLine,nMenuItemCounts,nLineStep;  //ganchh 2002/9/9
    int i;
    int nIdx;
    int nTextLen;
    MfwIcnAttr * icn;
    int fit;
    char *txt;                          /* item text                */
    static char tempLine [64];          /* for inverting            */
    U8 oldFont = -1;                    /* save previous font       */
    char t [64];                        /* temp item string         */
    UBYTE temp; 
    int UniHeight = 16;//zhonghz,12
    MfwMnuAttr *attr;                     /* menu attributes by ST   */
    UINT32 oldcolor;
    int iconIdx;
    UINT32 itemUnselect;

    if( !mnu->useDefLang )                   /*Show ASCII characters if string defined*/
    {
        temp = dspl_get_char_type();     
        dspl_set_char_type(DSPL_TYPE_ASCII);       
    }
    ma = mnu->curAttr;
    if( ma->font != (U8) -1 )
        oldFont = dspl_SelectFontbyID(ma->font); /* setup font */

    ax = ma->area->px; ay = ma->area->py;
    aw = ma->area->sx; ah = ma->area->sy;
    // TraceMMIValueFunction("primary AH", ah);
    fh = dspl_GetFontHeight();
    // fw = dspl_GetTextExtent("X",1); // ES!! only for normal fonts !
    //--------ganchh 2002/9/8  draw title firstly-----------
    //display menu title if level != 0
    /*...........................................zy change for listmenu.............................*/
    if( mnu->level != 0||(mnu->level == 0&&mnu->listmnuflag==1) )
    {
        if( mnu->level != 0 )// zy add 0918 
        {
            i = 0;                        /* set level 0              */
            attr = mnu->attr;               /* set start point          */
            while( i != mnu->level-1 )
            {
                attr = attr->items[mnu->lCursor[i]].menu;
                i++;
            }
            if( mnu->useStrID )                   /* use language handler     */
                txt = (char*)MmiRsrcGetText((int)attr->items[mnu->lCursor[i]].str);
            else
                txt =  ma->items[mnu->lCursor[i]].str;
        }
        else
        {
            txt = mnu->titlestr;// zy add 0918 
        }
        /*.............................end of zy change........................................................*/
        memcpy(t,txt,64);              /* text in RAM !            */

        //2004-03-29 Sunny modify
        //nTextLen = dspl_GetTextExtent(t,(U16)dspl_str_length(t));  
        nTextLen = get_StringWidth(t); 
        x = (U16) (ax + (aw - nTextLen) / 2);
        //---------ganchh 2002/9/9---begin
        if( (MenuBrowseAction==BrowseInit)||(MenuBrowseAction==BrowseNew) )//ganchh 2002/9/8
        {
            oldcolor=dspl_GetBkgColor();
            dspl_SetBkgColor(GetPreDefinedColor(ColorMenuTitle));//ʾ˵ͷɫ
            dspl_Clear(ax, ay,ax+aw, ay+fh);
            dspl_colorTextOut(x,(U16)ay,0,t,GetPreDefinedColor(ColorMenuTitleFont));//zy changed 04/08/02

            dspl_SetBkgColor(oldcolor);
        }
        //------------end of ganchh 2002/9/8	

        // modify menu area to reduce title
        ay += fh;
        ah -= fh;

    }

    nLines = ah / fh;

    //check whether to draw whole screen-------------ganchh 2002/9/8
    nMenuItemCounts=countVisible(mnu,ma,ma->nItems);//ganchh 2002/9/8 menu items
    if( (nMenuItemCounts>nLines) )  //lines larger than one screen
        MenuBrowseAction=BrowseNew;
    if( (MenuBrowseAction==BrowseInit)||(MenuBrowseAction==BrowseNew) )
    {
        oldcolor=dspl_GetBkgColor();
        dspl_SetBkgColor(GetPreDefinedColor(ColorMenuBG));//˵ɫ
        dspl_Clear(ax,ay,(U16)(aw+ax-1),(U16)(ah+ay));
        dspl_SetBkgColor(oldcolor);
    }
    //----------------------end of ganchh 2002/9/8	
    //-----------ganchh begin---------2002/9/9
    if( (!mnu->scrollMode)||nMenuItemCounts<=nLines ) /* Simple scrolling ganchh 2002/9/8 */
    {
        nLineStep=1;
        nIdx = (countVisible(mnu,ma,mnu->lCursor[mnu->level])/nLines)*nLines;
        switch( MenuBrowseAction )
        {
        case BrowseUp:
            nFirstLine=mnu->lCursor[mnu->level];
            nEndLine=nFirstLine+1;
            nIdx+=nFirstLine;
            break;
        case BrowseDown:               
            nEndLine=mnu->lCursor[mnu->level];
            if( nEndLine==0 )
            {
                nFirstLine=0;
                nEndLine=nMenuItemCounts-1;
                nLineStep=nEndLine;
            }
            else
            {
                nFirstLine=nEndLine-1;
                nIdx+=nFirstLine;
            }  
            break;
        case BrowseInit:
            MenuBrowseAction=BrowseNew;
        case BrowseNew:
        default:
            nFirstLine=0;
            //nEndLine=nLines;
            nEndLine=nLines-1;
            break;        
        }
        nEndLine++;
        //  TraceMMIValueFunction("nLineStep", nLineStep);
        for( i=nFirstLine; i<nEndLine;nIdx+=nLineStep,i+=nLineStep )
        //  for (i = 0; i < nLines; nIdx++)     /* ES!! not so nice...      */
        {

            memset(&t,'\0',64);
            if( nIdx >= ma->nItems )
                break;
            if( ma->items[nIdx].flagFunc(mnu,ma,&(ma->items[nIdx]))
                & MNU_ITEM_HIDE )
                continue;
            if( mnu->useStrID )                   /* use language handler     */
                txt = (char*)MmiRsrcGetText((int)ma->items[nIdx].str);
            else
                txt =  ma->items[nIdx].str;
            icn = ma->items[nIdx].icon;
            checkPredraw(mnu,ma->items+nIdx,&txt,&icn); /* ES!!         */
            memcpy(t,txt,64);              /* text in RAM !            */
            checkStatus(mnu,ma,ma->items+nIdx,t); /* process t          */
            //2004-03-29 Sunny modify
            //nTextLen = dspl_GetTextExtent(t,(U16)dspl_str_length(t));
            nTextLen = get_StringWidth(t);
            if( (ma->mode & MNU_ALIGN) == MNU_CENTER )
                x = (U16) (ax + (aw - nTextLen) / 2);
            else if( (ma->mode & MNU_ALIGN) == MNU_RIGHT )
                x = (U16) (ax + aw - nTextLen);
            else
                x = (U16) (ax + fw);        /* MNU_LEFT (default)       */
            if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_LINE )
                x =0;

            //       dspl_colorTextOut(x,(U16)ay+i*UniHeight,0,&t[0],GetPreDefinedColor(ColorMenuItemFont));//ʾ˵ɫ//zy changed 04/08/02
            if( icn != NULL )
            {
                x=0;
                if( ma->items[i].flagFunc(mnu,ma,&(ma->items[i]))==FLAGFUNC_TRUE_ICON )
                    iconIdx = 1;
                else
                    iconIdx = 0;
                dspl_BitBlt(x,(U16)ay+i*UniHeight,
                            icn->area.sx,icn->area.sy, 0,icn->icons+iconIdx*icn->area.sx*icn->area.sy*2,0);

                x +=16;
            }
            if( nIdx == mnu->lCursor[mnu->level] )
            {
                if( (ma->mode & MNU_ITEMSEL) == MNU_FRAMED )
                    dspl_DrawRect(ax,(U16)(ay+i*fh),(U16)(aw-2+ax),
                                  (U16)(fh-1+ay+i*fh));
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_ARROW )
                    dspl_TextOut(ax,(U16)(ay+i*fh),DSPL_TXTATTR_CURRENT_MODE,">");
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_STAR )
                    dspl_TextOut(ax,(U16)(ay+i*fh),DSPL_TXTATTR_CURRENT_MODE,"*");
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_BLOCK )
                    dspl_TextOut(ax,(U16)(ay+i*fh),
                                 DSPL_TXTATTR_CURRENT_MODE|DSPL_TXTATTR_INVERS," ");
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_LINE )
                {
                    itemUnselect=dspl_GetBkgColor();
                    dspl_SetBkgColor(GetPreDefinedColor(ColorMenuItemSel)); 
                    memset(tempLine,' ',13);
                    tempLine[13]=0;
                    dspl_colorTextOut(x,(U16)(ay+i*fh),0,tempLine, GetPreDefinedColor(ColorMenuItemSelFont));//zy changed 04/08/02
                    dspl_colorTextOut(x,(U16)ay+i*UniHeight,0,t, GetPreDefinedColor(ColorMenuItemSelFont));//ѡеĲ˵//zy changed 04/08/02
                    dspl_SetBkgColor(itemUnselect); 
                }

            }
            else  //ganchh do not display two time---------ganchh 2002/9/9-------------begin
            {

                if( (MenuBrowseAction!=BrowseInit)&&(MenuBrowseAction!=BrowseNew) )
                {
                    oldcolor=dspl_GetBkgColor();
                    dspl_SetBkgColor(GetPreDefinedColor(ColorMenuBG));//˵ɫ
                    dspl_Clear(x,(U16)(ay+i*fh),x+aw,(U16)(ay+i*fh+fh));
                    dspl_SetBkgColor(oldcolor);
                }

                dspl_colorTextOut(x,(U16)ay+i*UniHeight,0,&t[0],GetPreDefinedColor(ColorMenuItemFont));//ʾ˵ɫ//zy changed 04/08/02
            }
            //---------ganchh 2002/9/9--------------end    	    
            //  checkPostdraw(mnu,ma->items+nIdx); /* ES!!                  */

        } 
    }
    else
    {
        int count=mnu->lShift[mnu->level];
        int index= mnu->lCursor[mnu->level]+1;
        int nVisibles = countVisible(mnu,ma,ma->nItems);

        while( ma->items[index-1].flagFunc(mnu,ma,&(ma->items[index-1])) & MNU_ITEM_HIDE )
        {
            index++;
        } 

        while( count>0 )
        {
            if( index<=0 )
                index = ma->nItems-1;
            else
                index--;
            if( !(ma->items[index].flagFunc(mnu,ma,&(ma->items[index]))& MNU_ITEM_HIDE) )
                count--;
        }
        if( nVisibles<nLines )
            nLines = nVisibles;
        nIdx = index;

        for( i = 0; i < nLines; nIdx++ )
        {
            memset(&t,'\0',64);
            if( nIdx>=ma->nItems )
                nIdx=0;
            if( ma->items[nIdx].flagFunc(mnu,ma,&(ma->items[nIdx]))
                & MNU_ITEM_HIDE )
                continue;
            if( mnu->useStrID )                   /* use language handler     */
                txt = (char*)MmiRsrcGetText((int)ma->items[nIdx].str);   //JVJE
            else
                txt = ma->items[nIdx].str;
            icn = ma->items[nIdx].icon;
            checkPredraw(mnu,ma->items+nIdx,&txt,&icn); /* ES!!         */
            memcpy(t,txt,64);              /* text in RAM !            */
            checkStatus(mnu,ma,ma->items+nIdx,t); /* process t          */

            //2004-03-29 Sunny modify
            //nTextLen = dspl_GetTextExtent(t,(U16)dspl_str_length(t));
            nTextLen = get_StringWidth(t);
            if( (ma->mode & MNU_ALIGN) == MNU_CENTER )
                x = (U16) (ax + (aw - nTextLen) / 2);
            else if( (ma->mode & MNU_ALIGN) == MNU_RIGHT )
                x = (U16) (ax + aw - nTextLen);
            else
                x = (U16) (ax + fw);        /* MNU_LEFT (default)       */
            if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_LINE )
                x =0;
            if( icn != NULL )
            {
                x=0;
                if( ma->items[i].flagFunc(mnu,ma,&(ma->items[i]))==FLAGFUNC_TRUE_ICON )
                    iconIdx = 1;
                else
                    iconIdx = 0;
                dspl_BitBlt(x,(U16)ay+i*UniHeight,
                            icn->area.sx,icn->area.sy, 0,icn->icons+iconIdx*icn->area.sx*icn->area.sy*2,0);

                x +=16;
            }
            if( nIdx == mnu->lCursor[mnu->level] )
            {
                if( (ma->mode & MNU_ITEMSEL) == MNU_FRAMED )
                    dspl_DrawRect(ax,(U16)(ay+i*fh),(U16)(aw-2+ax),
                                  (U16)(fh-1+ay+i*fh));
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_ARROW )
                    dspl_TextOut(ax,(U16)(ay+i*fh),DSPL_TXTATTR_CURRENT_MODE,">");
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_STAR )
                    dspl_TextOut(ax,(U16)(ay+i*fh),DSPL_TXTATTR_CURRENT_MODE,"*");
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_BLOCK )
                    dspl_TextOut(ax,(U16)(ay+i*fh),
                                 DSPL_TXTATTR_CURRENT_MODE|DSPL_TXTATTR_INVERS," ");
                else if( (ma->mode & MNU_ITEMSEL) == MNU_CUR_LINE )
                {
                    itemUnselect=dspl_GetBkgColor();
                    dspl_SetBkgColor(GetPreDefinedColor(ColorMenuItemSel)); 
                    memset(tempLine,' ',13);
                    tempLine[13]=0;
                    dspl_colorTextOut(x,(U16)(ay+i*fh),0,tempLine,GetPreDefinedColor(ColorMenuItemSelFont));//zy changed 04/08/02
                    dspl_colorTextOut(x,(U16)(ay+i*fh),0,t,GetPreDefinedColor(ColorMenuItemSelFont));//zy changed 04/08/02		
                    dspl_SetBkgColor(itemUnselect); 
                }
#if 0
                if( icn != NULL && icn->nIcons > nIdx )
                {
                    dspl_BitBlt(icn->area.px,icn->area.py,
                                icn->area.sx,icn->area.sy,
                                (U16)nIdx,icn->icons,0);
                }
#endif
            }
            else
                dspl_colorTextOut(x,(U16)(ay+i*fh),0,t,GetPreDefinedColor(ColorMenuItemFont));//zy changed 04/08/02		
            //-------ganchh 2002/9/9----------end
            i++;
            //  checkPostdraw(mnu,ma->items+nIdx); /* ES!!                  */
        } 
    }  

    if( oldFont != (U8) -1 )
        dspl_SelectFontbyID(oldFont);   /* restore previous font    */
    if( !mnu->useDefLang )                   /*Back to the defined type*/
    {
        dspl_set_char_type(temp);      
    }

}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : drawViewListMenu       |
+--------------------------------------------------------------------+

  PURPOSE : draws menu in Viewlist mode

  ST 05/09/02 - Create.
*/


/***************************************************************
$History
*******2003/11/06,talcon midify*
       2004/05/14 sunsj modify 
***************************************************************/
static void drawViewListMenu (MfwMnu *mnu)
{
    extern const MfwIcnAttr menuPublic[];
    MfwMnuAttr *ma;                     /* menu attributes          */
    U16 fh, fw;                         /* font height & width      */
    U16 ax, ay, aw, ah;                 /* menu area dimensions     */
    U16 x,y,TxtX,TxtY;

    int i;
    int nTextLen;
    MfwIcnAttr * icn,*icnBkg,*icnFuncSel1;
    char *txt;                          /* item text                */
    U8 oldFont = -1;                    /* save previous font       */
    char t [64];                        /* temp item string         */
    UBYTE temp; 
    int UniHeight = 28;
    UINT32 oldcolor;
    int currentTheme;

    //glowing    
    int nLines = 5;
    int nItemCount;

    MfwMnuItem *pMnuItem ;

    if( mnu->lCursor[(int)mnu->level] != mfwmnuanim_t.PreMnuIdx )
    {
        mfwmnuanim_t.PreMnuIdx = mnu->lCursor[(int)mnu->level];
        mfwmnuanim_t.MainMnuIcnAnimIdx = 0;
    }
    currentTheme=FlashSettingData.theme;
    if( !mnu->useDefLang )                   /*Show ASCII characters if string defined*/
    {
        temp = dspl_get_char_type();             
        dspl_set_char_type(DSPL_TYPE_ASCII);         
    }
    ma = mnu->curAttr;

    pMnuItem =  &ma->items[ (int)mnu->lCursor[(int)mnu->level] ];
#if (MAIN_LCD_SIZE==3)//jhxu720
	icnBkg = pMnuItem->icon ;
	mfwmnuanim_t.MainMnuIcnAnimIdx = drawAnimIcons(icnBkg, mfwmnuanim_t.MainMnuIcnAnimIdx);
#elif ( MAIN_LCD_SIZE==4 )
    icn = pMnuItem->icon;
    icnBkg = pMnuItem->icon + 1;

    mfwmnuanim_t.MainMnuIcnAnimIdx = drawAnimIcons(icnBkg, mfwmnuanim_t.MainMnuIcnAnimIdx);

    dspl_Clear(0,icnBkg->area.sy + 1,128,icn->area.sy);

    icn = (MfwIcnAttr *)menuPublic;
    while( icn->icons )
        drawIconByIcnAttr(icn ++,0);

    icn = pMnuItem->icon;
    //ѡ
    dspl_BitBlt( icn->area.px,
                 icn->area.py,
                 icn->area.sx,
                 icn->area.sy,
                 1,
                 icn->icons,
                 0);
#elif ( MAIN_LCD_SIZE==2 )
    icn = (MfwIcnAttr *)menuPublic;
    icnBkg = pMnuItem->icon ;

    mfwmnuanim_t.MainMnuIcnAnimIdx = drawAnimIcons(icnBkg, mfwmnuanim_t.MainMnuIcnAnimIdx);

    //dspl_Clear(0,icnBkg->area.sy + 1,WIDTH_MAINMNUSEL,icn->area.sy);
    drawIconByIcnAttr(icn,0);
#endif
    if( ma->font != (U8) -1 )
        oldFont = dspl_SelectFontbyID(ma->font); /* setup font */

    ax = ma->area->px; ay = ma->area->py;
    aw = ma->area->sx; ah = ma->area->sy;
    // fh = dspl_GetFontHeight();
	/* 2004/06 sunsj modify for picture manage */
    fh= GET_ICONATTR(ICON_MENUUP, 0)->area.sy;//menuup[currentTheme].area.sy;
    /* 2003/12/04 sunsj modify for get title text length */
    //fw = dspl_GetTextExtent("X",1); // ES!! only for normal fonts !
    fw = get_StringWidth("X");
    // dspl_Clear(ax,ay,(U16)(aw+ax),(U16)(ah+ay));//zy 09/12
    i = mnu->lCursor[mnu->level];

    if( mnu->useStrID )                   /* use language handler     */
        txt = (char*)MmiRsrcGetText((int)ma->items[i].str);
    else
        txt =  ma->items[i].str;


    memset(&t,'\0',64);
    memcpy(t,txt,64);              /* text in RAM !            */
    checkStatus(mnu,ma,ma->items+i,t); /* process t          */

    /* 2003/12/04 sunsj modify for title width */
    nTextLen = get_StringWidth(t);
    //nTextLen = dspl_GetTextExtent(t,(U16)dspl_str_length(t));

    if( (ma->mode & MNU_ALIGN) == MNU_CENTER )
        x = (U16) (ax + (aw - nTextLen) / 2);
    else if( (ma->mode & MNU_ALIGN) == MNU_RIGHT )
        x = (U16) (ax + aw - nTextLen);
    else
        x = (U16) ax;        /* MNU_LEFT       */

    //oldcolor = dspl_GetBkgColor();
    //dspl_SetBkgColor(GetPreDefinedColor(ColorMenuTitle));
    //dspl_Clear(ax, ay,ax+aw, ay+fh);
#if (MAIN_LCD_SIZE==3)//jhxu720
	
	//ʾ˵
    TxtX=get_StringWidth((char*)t);
    TxtY=6;//shiheng 288 modify
	
	oldcolor=dspl_GetFrgColor();
    dspl_SetFrgColor(0x000000);
    dspl_TextOut_NoNewline(128-TxtX, TxtY,DSPL_TXTATTR_WHITE_EDGE, (char *)t);
    dspl_SetFrgColor(oldcolor);
	
    //ʾ˵softkey//shiheng 288 add begin
    TxtX=13;
    TxtY=POSY_MAINMNUSEL + (HEIGHT_MAINMNUSEL-dspl_GetFontHeight())/2-15;
    oldcolor=dspl_GetFrgColor();
    dspl_SetFrgColor(0x000000);
    dspl_TextOut_NoNewline(TxtX, TxtY,DSPL_TXTATTR_WHITE_EDGE, (char *)MmiRsrcGetText(TxtSoftConfirm));
    dspl_SetFrgColor(oldcolor);
    
    TxtX=86;
    TxtY=POSY_MAINMNUSEL + (HEIGHT_MAINMNUSEL-dspl_GetFontHeight())/2-15;
    oldcolor=dspl_GetFrgColor();
    dspl_SetFrgColor(0x000000);
    dspl_TextOut_NoNewline(TxtX, TxtY,DSPL_TXTATTR_WHITE_EDGE, (char *)MmiRsrcGetText(TxtSoftBack));
    dspl_SetFrgColor(oldcolor);
#elif ( MAIN_LCD_SIZE==4 )
    TxtX=x;
    TxtY=(fh-dspl_GetFontHeight())/2;

    //drawcolorclarity( TxtX+10, 124 ,t, 0x000000);
    /*2003/10/31,talcon modify it*/
    //drawcolorclarity( TxtX, 4 ,t, 0x000000);
    oldcolor=dspl_GetFrgColor();
    dspl_SetFrgColor(0x000000);
    dspl_TextOut_NoNewline(TxtX, 4,DSPL_TXTATTR_WHITE_EDGE, (char *)t);
    dspl_SetFrgColor(oldcolor);
    /* end talcon modify */

    nItemCount=countVisible(mnu,ma,ma->nItems);
    if( (nItemCount>nLines) )  //lines larger than one screen
    {
        MenuBrowseAction=BrowseNew;
    }

    if( (MenuBrowseAction==BrowseInit)||(MenuBrowseAction==BrowseNew) )
    {
        //¼ͷ
        //begin of xsf add to display up/down arrow when num of menu items up to 6 2003.04.11
        //end of xsf add to display up/down arrow when num of menu items up to 6 2003.04.11
    }

#elif ( MAIN_LCD_SIZE==2 )
    TxtX=5;
    TxtY=POSY_MAINMNUSEL + (HEIGHT_MAINMNUSEL-dspl_GetFontHeight())/2;


    oldcolor=dspl_GetFrgColor();
    dspl_SetFrgColor(0x000000);
    dspl_TextOut_NoNewline(TxtX, TxtY,DSPL_TXTATTR_WHITE_EDGE, (char *)t);
    dspl_SetFrgColor(oldcolor);
#endif

    if( oldFont != (U8) -1 )
        dspl_SelectFontbyID(oldFont);   /* restore previous font    */
    if( !mnu->useDefLang )                   /*Back to the defined type*/
    {
        dspl_set_char_type(temp);           
    }

}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuCommand         |
+--------------------------------------------------------------------+

  PURPOSE : handle mfw windows command

*/

static int mnuCommand (U32 cmd, void *h)
{
    MfwMnu *mnu = 0;
    switch( cmd )
    {
    case MfwCmdDelete:              /* delete me                */
        if( !h )
            return 0;
        mnuDelete(h);
        return 1;
    case MfwCmdUpdate:              /* repaint                  */
        if( !h || ((MfwHdr *) h)->type != MfwTypMnu )
            return 0;
        mnu = ((MfwHdr *) h)->data;
        mnuUpdate(mnu);
        if( mnu && 
            ( (mnu->curAttr->mode & MNU_DISPLAY) == MNU_LIST ||
              (mnu->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED ) )
        {
            mfwmnuanim_t.currentwin = mfwParent(h);
        }
        else
            mfwmnuanim_t.currentwin  = 0;
        return 1;
    default:
        break;
    }

    return 0;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnuScrollMode      |
+--------------------------------------------------------------------+

  PURPOSE : handle mfw windows command

*/

void mnuScrollMode (MfwHnd menu,U8 mode)
{
    MfwMnu *mnu;

    if( (mnu = mfwControl(menu)) == 0 )
        return;
    mnu->scrollMode = mode; 
}
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_MNU            |
| STATE   : code                        ROUTINE : mnufordynamicMenushow
  author :zy 10/08
+--------------------------------------------------------------------+

  PURPOSE : for show whole dynamicMenu window

*/

void controlBrowseNew(void)
{
    MenuBrowseAction=BrowseNew; 
}

/********************************************
$History
  *2003/10/24,talcon add*
  *2003/11/05,talcon modify *
**********************************************/
void ShowPBNumOnItem(char *outstr,MfwMnu* mnu)
{
    //2004-04-29 Sunny add
    int nTotoalChars = 0;
    char tpText[15];
    //2004-04-29 Sunny add end

    MfwMnuAttr *ma = mnu->curAttr;                     /* menu attributes          */
    int nLines = getListMnuLines(mnu);

    MfwIcnAttr* icnTitleBar = GET_ICONATTR(ICON_MENUTITLE, 0);//(MfwIcnAttr*)&titleicons[0];/* 2004/06 sunsj modify for icon manage */

    //2004-04-29 Sunny add
    nTotoalChars = strlen(outstr);
    if( nTotoalChars > 13 ) //ʱô
    {
        memcpy(tpText, outstr, 12);
        tpText[12] = '.';
        tpText[13] = 0;
    }
    else
    {
        memcpy(tpText, outstr, nTotoalChars);
        tpText[nTotoalChars] = 0;
    }

    //2004-04-29 Sunny add end

    drawListMenuItem(mnu,mnu->lCursor[(int)mnu->level],nLines,
                     getListMnuPosY(mnu),tpText);   //2004-04-29 Sunny modify old: outstr
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();//jhxu720
#endif
}
/* end talcon */

/* glowing : add 2003-10-29 */
char * GetMenuTitleString( MfwMnu *mnu, MfwMnuAttr *attr )
{
    int i;
    MfwMnuAttr * curMnuAttr;                     /* menu attributes  */
    //MfwMnuAttr * attr;
    char *txtTitle;

    curMnuAttr = mnu->curAttr;

    if( mnu->level != 0 )
    {
        i = 0;                        /* set level 0              */
        attr = mnu->attr;               /* set start point          */
        while( i != mnu->level-1 )
        {
            attr = attr->items[mnu->lCursor[i]].menu;
            i++;
        }
        if( mnu->useStrID )                   /* use language handler     */
            txtTitle = (char*)MmiRsrcGetText((int)attr->items[mnu->lCursor[i]].str);
        else
            txtTitle =  curMnuAttr->items[mnu->lCursor[i]].str;
    }
    else
        txtTitle = mnu->titlestr;

    return txtTitle;
}

/********************************talcon add it 2003-10-13**********************************
 *fuction : dspl_BitBlt_ext
 *author : talcon
 *description :dspl_BitBltչ 
 *history:
 ********2003/10/31, remove malloc
 *********************************************************************************/
UBYTE dspl_BitBlt_ext       (USHORT              in_X,
                             USHORT              in_Y,
                             USHORT              in_BmpX,    
                             USHORT              in_BmpY,
                             USHORT              in_Width,
                             USHORT              in_Height,
                             USHORT              in_BmpWidth,
                             USHORT              in_BmpHeight,
                             USHORT              in_Index,
                             void              * in_BmpPtr,
                             USHORT              in_Rop)
{

    USHORT uRow = 0;
    char *p = in_BmpPtr;
    U8 uModeOld = 0;

    uModeOld = dspl_Enable(0);

    if( in_Width == in_BmpWidth && in_BmpX == 0 )
    {
        p = (char *)in_BmpPtr + in_BmpWidth * 2 * in_BmpY;
        dspl_BitBlt(in_X, in_Y , in_Width, in_Height, in_Index,(void *)p,in_Rop);
    }
    else
    {
        for( uRow = 0; uRow < in_Height; uRow++ )
        {
            p = (char *)in_BmpPtr + in_BmpWidth * 2 * (in_BmpY+ uRow) + in_BmpX * 2;
            dspl_BitBlt(in_X, in_Y + uRow, in_Width, 1, in_Index,(void *)p,in_Rop);
        }
    }


    dspl_Enable(uModeOld);

    return 0;
}

/********************************talcon add it 2003-11-05**********************************
 *fuction : drawListMenuItem
 *author : talcon
 *description :draw menu item by nIdx
 *history:
 ********2003/11/05, talcon create
 ********2003/11/06, talcon add mask handle
 *********************************************************************************/
static void drawListMenuItem (MfwMnu *mnu,int nIdx,int nLines,int mnuposY,char *szPlaceStr)
{
    MfwMnuAttr *ma = mnu->curAttr;
    MfwIcnAttr *icn;
    int nPosX,nPosY;
    int iconIdx;
    U8 i = nIdx%nLines;

    static char tag[42];
    static char t[64];
    char *txt;

    nPosX = 0;
    nPosY = mnuposY+i*MNULIST_ITEM_HEIGHT;
#if (MAIN_LCD_SIZE==3)//jhxu720
	if(nIdx == mnu->lCursor[(int)mnu->level])
		icn = (MfwIcnAttr*)&mnulistbkgicons[0];
	else
		icn = (MfwIcnAttr*)&mnulistbkgicons[0];
	
	if(icn)
		{
			dspl_BitBlt(nPosX,nPosY,
		                 icn->area.sx,MNULIST_ITEM_HEIGHT,0,
		(void*) (icn->icons + i*(MNULIST_ITEM_HEIGHT * icn->area.sx * 2) ),
		0);
		}

#elif ( MAIN_LCD_SIZE==4 )
    if( MenuBrowseAction != BrowseNew )
    {
        UINT32 color =  dspl_SetBkgColor(MNULIST_BKGCOLOR);
        dspl_Clear(nPosX,nPosY,128,nPosY + MNULIST_ITEM_HEIGHT);
        dspl_SetBkgColor(color);
    }
    //ѡ
    if( nIdx == mnu->lCursor[mnu->level] )
    {
		/* 2004/06 sunsj modify for picture manage */
        U8 sy = GET_ICONATTR(ICON_MENUMID, 0)->area.sy;
        if( sy > MNULIST_ITEM_HEIGHT )
            sy = MNULIST_ITEM_HEIGHT;
		DRAW_ICON_LOCATION(ICON_MENUMID, nPosX, nPosY);
		/*
        dspl_BitBlt(nPosX,nPosY,
                    menumid[0].area.sx,
                    sy  ,
                    0,menumid[0].icons,0);
		*/
    }

#elif ( MAIN_LCD_SIZE==2 )
    if( nIdx == mnu->lCursor[(int)mnu->level] )
    {
        icn = (MfwIcnAttr*)&mnulistbkgicons[0];
    }
    else
    {
        icn = (MfwIcnAttr*)&mnulistbkgicons[0];
    }
    if( icn )
    {
        dspl_BitBlt(nPosX,nPosY,
                    icn->area.sx,MNULIST_ITEM_HEIGHT,
                    1,
                    (void*) (icn->icons + i*(MNULIST_ITEM_HEIGHT * icn->area.sx * 2) ),
                    0);
    }
#endif
    /***end draw menu item background****************/

    /*******ߵicon************************/
    icn = ma->items[nIdx].icon;
    if( icn != NULL )
    {
        U16 nIcnPosY = (U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn->area.sy)/2);
        iconIdx = nIdx ;
        nPosX = (MNULIST_ITEM_LEFTOFFSET - icn->area.sx)/2;
        if( icn == GET_ICONATTR(ICON_LISTCOMMON, 0) || icn == GET_ICONATTR(ICON_SITUATION4, 0)/*situation4Icon*/ )///* 2004/06 sunsj modify for icon manage */
        {
            if( nIdx == mnu->lCursor[mnu->level] )
            {
                /*2004/06 sunsj modify for picture manage */
                MfwIcnAttr *icn1 = GET_ICONATTR(ICON_SITUATION5, 0);//(MfwIcnAttr *)&situation5Icon[0];
#if ( MAIN_LCD_SIZE==4 )
                MfwIcnAttr *icn2 = GET_ICONATTR(ICON_SITUATION5_MASK, 0);//(MfwIcnAttr *)&situation5Icon[1];
#endif
                nPosX = (MNULIST_ITEM_LEFTOFFSET - icn1->area.sx)/2;
                nIcnPosY = (U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn1->area.sy)/2);
#if(MAIN_LCD_SIZE==3)
				if( nIdx == mnu->lCursor[mnu->level] )//jhxu720 add
				{
					DRAW_ICON_ATTRIBUTE(ICON_CURRENTBAR,nPosX+MNULIST_ITEM_HIGHLIGHTOFFSET_X,nPosY+MNULIST_ITEM_HIGHLIGHTOFFSET_Y,1,ICON_LOCATION);
				}
#endif
                if( mfwmnuanim_t.MnuLeftIconIdx >= icn1->nIcons )
					mfwmnuanim_t.MnuLeftIconIdx = 0;
#if(MAIN_LCD_SIZE==3)
				DRAW_ICON_ATTRIBUTE(ICON_SITUATION5, nPosX, nIcnPosY, mfwmnuanim_t.MnuLeftIconIdx, ICON_LOCATION);//jhxu720
#elif (MAIN_LCD_SIZE==4)
				DRAW_ICON_ATTRIBUTE(ICON_SITUATION5, nPosX, nIcnPosY, mfwmnuanim_t.MnuLeftIconIdx, ICON_LOCATION|ICON_MASK);
#endif
				/*
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn1->area.sx,icn1->area.sy, 0,
                            icn1->icons + mfwmnuanim_t.MnuLeftIconIdx * icn1->area.sx * icn1->area.sy *2,
                            DSPL_BMPXOR);
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn2->area.sx,icn2->area.sy, 0,
                            icn2->icons,DSPL_BMPAND);
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn1->area.sx,icn1->area.sy, 0,
                            icn1->icons + mfwmnuanim_t.MnuLeftIconIdx * icn1->area.sx * icn1->area.sy *2,
                            DSPL_BMPXOR);
							*/
                mfwmnuanim_t.MnuLeftIconIdx++;
            }
            else
            {
                MfwIcnAttr *icn1 = GET_ICONATTR(ICON_LISTCOMMON, 0);/* 2004/06 sunsj modify for icon manage */
#ifdef COLIST_HASMASK
                MfwIcnAttr *icn2 = GET_ICONATTR(ICON_LISTCOMMON_MASK, 0);/* 2004/06 sunsj modify for icon manage */
#endif
                int offset = nIdx%icn1->nIcons * icn1->area.sx * icn1->area.sy * 2;//jhxu720

                nPosX = (MNULIST_ITEM_LEFTOFFSET - icn1->area.sx)/2;
                nIcnPosY = (U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn1->area.sy)/2);
#ifdef COLIST_HASMASK	
				/* 2004/06 sunsj modify for picture manage */
				DRAW_ICON_ATTRIBUTE(ICON_LISTCOMMON, nPosX, nIcnPosY, nIdx, ICON_LOCATION|ICON_MASK);
				/*
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn1->area.sx,icn1->area.sy, 0,
                            icn1->icons + offset,
                            DSPL_BMPXOR);
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn2->area.sx,icn2->area.sy, 0,
                            icn2->icons + offset,DSPL_BMPAND);
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn1->area.sx,icn1->area.sy, 0,
                            icn1->icons + offset,
                            DSPL_BMPXOR);
							*/
#else
				DRAW_ICON_ATTRIBUTE(ICON_LISTCOMMON, nPosX, nIcnPosY, nIdx, ICON_LOCATION);
				/*
                dspl_BitBlt(nPosX,nIcnPosY, 
                            icn1->area.sx,icn1->area.sy, 0,
                            icn1->icons + offset,DSPL_BMPCOPY);
							*/
#endif
            }
        }
		else if( (icn == GET_ICONATTR(ICON_SITUATION3, 0)/*&situation3Icon*/) || (icn == GET_ICONATTR(ICON_SITUATION, 0)/*&situationIcon*/) )//ѡͼ	/* 2004/06 sunsj modify for picture manage */
        {
            //MfwIcnAttr *icn1 = icn++;
            /* 2004/05/18 sunsj modify for current bar */
#if ( MAIN_LCD_SIZE==2 )
            if( nIdx == mnu->lCursor[mnu->level] )
            {
                dspl_BitBlt(nPosX+14, nPosY, currentbarIcon[1].area.sx, currentbarIcon[1].area.sy, 0, currentbarIcon[1].icons, 0);
            }
#endif
#if(MAIN_LCD_SIZE==3)
			if( nIdx == mnu->lCursor[mnu->level] )//jhxu720
			{
				DRAW_ICON_ATTRIBUTE(ICON_CURRENTBAR,nPosX+MNULIST_ITEM_HIGHLIGHTOFFSET_X,nPosY+MNULIST_ITEM_HIGHLIGHTOFFSET_Y,1,ICON_LOCATION);
			}
#endif
            if( ma->items[nIdx].flagFunc(mnu,ma,&(ma->items[nIdx]))==FLAGFUNC_TRUE_ICON )  //xsf changed i to nIdx 2002.09.27
                iconIdx = 1;
            else
                iconIdx = 0;
#if(MAIN_LCD_SIZE==4)
            dspl_BitBlt( nPosX, nIcnPosY, 
                         icn->area.sx, icn->area.sy, 
                         0, icn->icons+iconIdx*icn->area.sx*icn->area.sy*2, DSPL_BMPXOR);
            dspl_BitBlt( nPosX, nIcnPosY, 
                         icn->area.sx, icn->area.sy, 
                         0, icn->icons+icn->area.sx*icn->area.sy*4, DSPL_BMPAND);
            dspl_BitBlt( nPosX, nIcnPosY, 
                         icn->area.sx, icn->area.sy, 
                         0, icn->icons+iconIdx*icn->area.sx*icn->area.sy*2, DSPL_BMPXOR);
#elif(MAIN_LCD_SIZE==3)
			dspl_BitBlt( nPosX, nIcnPosY, //jhxu720
				icn->area.sx, icn->area.sy, 
				0, icn->icons+iconIdx*icn->area.sx*icn->area.sy*2, 0);
#endif
        }
        else if( icn == GET_ICONATTR(ICON_SCENE, 0)/*(MfwIcnAttr *)scene_Attr*/ )/*scene*//* 2004/06 sunsj modify for picture manage */
        {
			/* 2004/06 sunsj modify for picture manage */
            MfwIcnAttr *icn1 = GET_ICONATTR(ICON_SCENE, 0);//(MfwIcnAttr *)&scene_Attr[nIdx];
            //MfwIcnAttr *icn2 = (MfwIcnAttr *)&sceneMask_Attr[nIdx];
            //int offset = nIdx%icn1->nIcons * icn1->area.sx * icn1->area.sy * 2;

            nPosX = (MNULIST_ITEM_LEFTOFFSET - icn1->area.sx)/2;
            nIcnPosY = (U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn1->area.sy)/2);
			DRAW_ICON_ATTRIBUTE(ICON_SCENE, nPosX, nIcnPosY, nIdx ,ICON_LOCATION|ICON_MASK);
			/*
            dspl_BitBlt(nPosX,nIcnPosY, 
                        icn1->area.sx,icn1->area.sy, 0,
                        icn1->icons + offset,
                        DSPL_BMPXOR);
            dspl_BitBlt(nPosX,nIcnPosY, 
                        icn2->area.sx,icn2->area.sy, 0,
                        icn2->icons + offset,DSPL_BMPAND);
            dspl_BitBlt(nPosX,nIcnPosY, 
                        icn1->area.sx,icn1->area.sy, 0,
                        icn1->icons + offset,
                        DSPL_BMPXOR);
			*/
        }
        else
        {
            /* 2004/05/17 sunsj modify for current bar */
#if ( MAIN_LCD_SIZE==2)
            if( nIdx == mnu->lCursor[mnu->level] )
            {
                dspl_BitBlt(nPosX+14, nPosY, currentbarIcon[1].area.sx, currentbarIcon[1].area.sy, 0, currentbarIcon[1].icons, 0);
            }
#endif
#if ( MAIN_LCD_SIZE==3)
			if( nIdx == mnu->lCursor[mnu->level] )//jhxu720
			{
				DRAW_ICON_ATTRIBUTE(ICON_CURRENTBAR,nPosX+MNULIST_ITEM_HIGHLIGHTOFFSET_X,nPosY+MNULIST_ITEM_HIGHLIGHTOFFSET_Y,1,ICON_LOCATION);
			}
#endif
            if( ma->items[nIdx].flagFunc(mnu,ma,&(ma->items[nIdx]))==FLAGFUNC_TRUE_ICON )  //xsf changed i to nIdx 2002.09.27
                iconIdx = 1;
            else
                iconIdx = 0;

            /* 2004/03/11 sunsj modify */
            if( icn->nIcons > 1 )
            {//Knuth730
                dspl_BitBlt( nPosX, nIcnPosY, 
                             icn->area.sx, icn->area.sy, 
                             0, icn->icons+iconIdx*icn->area.sx*icn->area.sy*2, DSPL_BMPXOR);
                dspl_BitBlt( nPosX, nIcnPosY, 
                             icn->area.sx, icn->area.sy, 
                             0, icn->icons+(iconIdx+1)*icn->area.sx*icn->area.sy*2, DSPL_BMPAND);
                dspl_BitBlt( nPosX, nIcnPosY, 
                             icn->area.sx, icn->area.sy, 
                             0, icn->icons+iconIdx*icn->area.sx*icn->area.sy*2, DSPL_BMPXOR);
            }
            else
            {
                dspl_BitBlt( nPosX, nIcnPosY, 
                             icn->area.sx, icn->area.sy, 
                             0, icn->icons+iconIdx*icn->area.sx*icn->area.sy*2, 0);
            }
        }
        nPosX = MNULIST_ITEM_LEFTOFFSET;
    }//end if( icn != NULL )
	else
    {
#if(MAIN_LCD_SIZE==3)
		if( nIdx == mnu->lCursor[mnu->level] )//jhxu720
			DRAW_ICON_ATTRIBUTE(ICON_CURRENTBAR,nPosX+MNULIST_ITEM_HIGHLIGHTOFFSET_X,nPosY+MNULIST_ITEM_HIGHLIGHTOFFSET_Y,1,ICON_LOCATION);
			
		nPosX = MNULIST_ITEM_LEFTOFFSET;//ûͼб 
#endif
    }
    /***end ߵicon************************/

    /*********draw text ****************************************/
    if( szPlaceStr )
        txt = szPlaceStr;
    else if( mnu->useStrID )                   /* use language handler     */
        txt = (char*)MmiRsrcGetText((int)ma->items[nIdx].str);
    else
        txt =  ma->items[nIdx].str; 
    memset(tag,0,sizeof(tag) );

    //memset(t, 0 ,sizeof(t) );
    memcpy(t,txt,sizeof(t));

    if( nIdx == mnu->lCursor[mnu->level] )
    {

        if( trunMeneText((char*)tag,t,
                         (mfwmnuanim_t.MnuTextIdx > listmnu_PaoMa_Base)? (mfwmnuanim_t.MnuTextIdx - listmnu_PaoMa_Base):0 ,
                         ma->area->sx - (nPosX - ma->area->px)) )
        {
            mfwmnuanim_t.MnuTextIdx++   ;
            mfwmnuanim_t.IsMnuTextAnim = 1;
        }
        else
        {
            if( mfwmnuanim_t.MnuTextIdx )
                //mfwmnuanim_t.MnuTextIdx = 1;
                mfwmnuanim_t.IsMnuTextAnim = 1;
            else
                mfwmnuanim_t.IsMnuTextAnim = 0;
            mfwmnuanim_t.MnuTextIdx = 0;
        }
        MMI_TRACE_EVENT(("<<<talcon,drawListMenuItem--t:%s",t));
        MMI_TRACE_EVENT(("<<<talcon,drawListMenuItem--MnuTextIdx:%d,IsMnuTextAnim:%d",mfwmnuanim_t.MnuTextIdx,mfwmnuanim_t.IsMnuTextAnim));
        /* 2004/05/26 sunsj modify */
        if( tag[0] == (char)0x80 )
#if( MAIN_LCD_SIZE==3)
            drawcolorclarity_NoNewline(nPosX+MNULIST_ITEM_DISPLAYOFFSET_X,nPosY+MNULIST_ITEM_DISPLAYOFFSET_Y,(char*)tag, 0);//jhxu720
#elif( MAIN_LCD_SIZE==4)
		    drawcolorclarity_NoNewline(nPosX,nPosY+1,(char*)tag, 0);
#endif
        else
#if(MAIN_LCD_SIZE==4)
            drawcolorclarity_NoNewline(nPosX,nPosY+2,(char*)tag, 0);
#elif (MAIN_LCD_SIZE==3)
            drawcolorclarity_NoNewline(nPosX+MNULIST_ITEM_DISPLAYOFFSET_X,nPosY+2,(char*)tag, 0);
#endif
    }
    else  //ganchh do not display two time
    {
        trunMeneText((char*)tag,t,0,ma->area->sx - (nPosX - ma->area->px));
        
		if( tag[0] == (char)0x80 )
#if( MAIN_LCD_SIZE==3)
            drawcolorclarity_NoNewline(nPosX+MNULIST_ITEM_DISPLAYOFFSET_X, nPosY+MNULIST_ITEM_DISPLAYOFFSET_Y, (char*)tag,0);//jhxu720
#elif( MAIN_LCD_SIZE==4)
		    drawcolorclarity_NoNewline(nPosX,nPosY+1,(char*)tag, 0);
#endif
        else
#if(MAIN_LCD_SIZE==4)
            drawcolorclarity_NoNewline(nPosX,nPosY+2,(char*)tag, 0);
#elif (MAIN_LCD_SIZE==3)
            drawcolorclarity_NoNewline(nPosX+MNULIST_ITEM_DISPLAYOFFSET_X,nPosY+MNULIST_ITEM_DISPLAYOFFSET_Y,(char*)tag, 0);
#endif
	}
    /*****end draw text ****************************************/

    /***************draw right icon*********************/
	/* 2004/06 sunsj modify for picture manage */
    if( icn == GET_ICONATTR(ICON_SITUATION4, 0)/*situation4Icon*/ )
    {
        MfwIcnAttr * icn1 = icn+2;
        if( ma->items[nIdx].flagFunc(mnu,ma,&(ma->items[nIdx]))==FLAGFUNC_TRUE_ICON )  //xsf changed i to nIdx 2002.09.27
            iconIdx = 1;
        else
            iconIdx = 0;
        icn ++;
        /* 2004/05/18 sunsj modify */
        dspl_BitBlt(mmiScrX - icn->area.sx,(U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn->area.sy)/2),
                    icn->area.sx,icn->area.sy, 0,icn->icons+iconIdx*icn->area.sx*icn->area.sy*2,DSPL_BMPXOR);
        dspl_BitBlt(mmiScrX - icn->area.sx,(U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn->area.sy)/2),
                    icn->area.sx,icn->area.sy, 0,
                    icn->icons+icn->area.sx*icn->area.sy*4,DSPL_BMPAND);
        dspl_BitBlt(mmiScrX - icn->area.sx,(U16)(nPosY + (MNULIST_ITEM_HEIGHT - icn->area.sy)/2),
                    icn->area.sx,icn->area.sy, 0,icn->icons+iconIdx*icn->area.sx*icn->area.sy*2,DSPL_BMPXOR);
    }
    /***********end draw right icon*********************/
}

/********************************************
$History
  *2003/11/08,talcon create *
**********************************************/
void drawListMenuItem2(MfwMnu* mnu,int nIdx)
{
    MfwMnuAttr *ma = mnu->curAttr;                     /* menu attributes          */

    MfwIcnAttr* icnTitleBar = GET_ICONATTR(ICON_MENUTITLE, 0);//(MfwIcnAttr*)&titleicons[0];/* 2004/06 sunsj modify for icon manage */

    int nLines = getListMnuLines(mnu);

    drawListMenuItem(mnu,nIdx,nLines,
                     getListMnuPosY(mnu) ,
                     NULL);


}/*end drawListMenuItem2*/


/********************************************
$History
  *2003/11/08,talcon create *
**********************************************/

/********************************************
$History
  *2003/11/08,talcon create *
**********************************************/
void drawAnimTimerIcn(MfwMnu* mnu,MfwHnd timer)
{
    U8 uMode; 
    uMode = dspl_Enable(0);
    timStop( timer );
    /*2004/04/15,talcon modify*/
    /*
    if( mfwmnuanim_t.nMainTimer<4 )
    {
        int oldIconIdx = mfwmnuanim_t.MnuLeftIconIdx;
        drawListMenuItem2 (mnu,mnu->lCursor[(int)mnu->level] );//drawMnuIcnSel(mnu );
        if( oldIconIdx  != mfwmnuanim_t.MnuLeftIconIdx )
        {
            timStart( timer );
        }
    }
    else
    {

        mfwmnuanim_t.nMainTimer = 0;
        drawListMenuItem2 (mnu, mnu->lCursor[(int)mnu->level] );
        timStart( timer );
    }*/
    if( mfwmnuanim_t.nMainTimer == 4 )
        mfwmnuanim_t.nMainTimer = 0;
    {
        int oldIconIdx = mfwmnuanim_t.MnuLeftIconIdx;
        drawListMenuItem2 (mnu,mnu->lCursor[(int)mnu->level] );
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        if( oldIconIdx  != mfwmnuanim_t.MnuLeftIconIdx || mfwmnuanim_t.IsMnuTextAnim )
        {
            timStart( timer );
        }
    }
    dspl_Enable(uMode);
    mfwmnuanim_t.nMainTimer ++;
}/*end drawAnimTimerIcn*/


/*********************************************
$History
******2003/11/10,talcon create
************************************************/
static int listmenu_timer_cb(MfwEvt e, MfwTim *t)
{
    /* MfwHnd     win  = mfwParent (mfwHeader());
     MfwHdr     *win_data = ( MfwHdr * )mfwHeader( ); 
     MfwMnu    *data = (MfwMnu *)win_data->data;
  
    MfwWin * win1 = (MfwWin *) ((MfwHdr *)win)->data ;
     MfwMnu    *m=(MfwMnu *)  ((MfwHdr *)  win1 ->elems ) ->data;
   */  
    MfwMnu    *m = 0;
    timStop( mfwmnuanim_t.listmnulicontimer );

    if( !winIsFocussed(mfwmnuanim_t.currentwin) )//&& mfwmnuanim_t.currentmnu == NULL)
    {
        return 0;
    }

    if( mfwmnuanim_t.currentmnu == NULL )
        return  0;
    m = mfwmnuanim_t.currentmnu;
    if( m->curAttr->mode & MNU_BOOKPHONE )return 0;
    if( (m->curAttr->mode & MNU_DISPLAY) == MNU_LIST  
        || (m->curAttr->mode & MNU_DISPLAY) == MNU_OVERLAPPED )
    {
        drawAnimTimerIcn(mfwmnuanim_t.currentmnu,mfwmnuanim_t.listmnulicontimer);
    }
}/*******************menu tone******************/
/******************
$Description:ܲ˵ĺӿڣ
$Argument:
    @uIdx:0Ĳ˵0˵һ:Ϣ
***************************/
void playMainMnuTone(U8 uIdx)
{
    // 2004.4.9 WYJ modify
    StartPlayByReason(MAINMENU_VOICE, uIdx);
}
void stopMainMnuTone()
{
    //StopPlayingMelody2(); MI18800000126
}
