/*
+-------------------------------------------------------------------+
| PROJECT: PC Synchronization                    
| $Workfile: mfw_pcsyn.c
| $Author: Talcon Hu
| CREATED: 06.07.2004                 
+-------------------------------------------------------------------+
*/

#define ENTITY_MFW

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

#include "p_sim.h"
#include "aci_cmh.h"
#include "psa.h"
#include "psa_sim.h"
#include "pcm.h"
#include "mfw_mfw.h"
#include "mfw_nm.h"
#include "mfw_sim.h"
#include "mfw_sima.h"
#include "mfw_simi.h"
#include "mfw_nmi.h"
#include "mfw_nma.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_cmi.h"
#include "mfw_acie.h"
#include "mfw_sms.h"
#include "mfw_smsi.h"
#include "mfw_win.h"


#include "ksd.h"
#include "psa.h"

#if defined (FAX_AND_DATA)
#include "aci_fd.h"
#endif

#include "cmh.h"
#include "phb.h"
#include "cmh_phb.h"

#include "mfw_ss.h"
#include "mfw_ssi.h"

#ifdef SIM_TOOLKIT
#include "mfw_sat.h"
#endif

static int pSlotPcsyn = 0; 

#define PCSYN_TRACE_EVENT(f)

/*********************************************
$Description:
	handle pcsyn-->mmi 
**********************************************/
GLOBAL BOOL pcsyn_response_cb (ULONG opc, void * data)
{
	TRACE_FUNCTION ("pcsyn_response_cb()");

	PCSYN_TRACE_EVENT(("hyl:%08x",opc));
	  switch (opc)
	  {
	    case PCSYN_MMI_IND:
		{

			typedef struct
			{
				U8                        event_id;                 /*<  0:  1> Identifier of the event.                           */
				U8                        _align0;                  /*<  1:  1> alignment                                          */
				U8                        _align1;                  /*<  2:  1> alignment                                          */
				U8                        _align2;                  /*<  3:  1> alignment                                          */
				T_sdu                     sdu;                      /*<  4: ? > Service Data Unit                                  */
			} 
			T_PCSYN_MMI_IND;
extern GLOBAL const void pcsyn_mmi_ind (T_PCSYN_MMI_IND  *pcsyn_mmi_ind);

			pcsyn_mmi_ind((T_PCSYN_MMI_IND*)data);
		}
	    		return TRUE;//bot processed by aci
	  }

	  return FALSE;       /* not processed by extension */
}

/*********************************************
$Description:
	initialize pcsyn manager
**********************************************/
int pcsynmfw_init (void)
{
    TRACE_FUNCTION("pcsynmfw_init()");

    pSlotPcsyn = aci_create(pcsyn_response_cb,NULL);

    return TRUE;
}

/*********************************************
$Description:
	finalize pcsyn manager
**********************************************/
void pcsynmfw_exit (void)
{
    TRACE_FUNCTION("pcsynmfw_exit()");

    /* 
     * remove prim handler      
     */
    aci_delete(pSlotPcsyn);
}



