/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         $Workfile:: mfw_sms.c       $|
| $Author: zkc $Revision: 1.3 $|
| CREATED: 21.12.98                     $Modtime:: 24.03.00 10:25   $|
| STATE  : code                                                      |
+--------------------------------------------------------------------+

   MODULE  : MFW_SMS

   PURPOSE : This module contains SMS management functions.

   SPR 2260:  Merged in bugfixes 1833, 1669, 872,1830, 1828, 2031, and 2007 
   fom the 1.6.3 branch into this file.

*/

#define ENTITY_MFW

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif

#include "cus_aci.h"
#include "message.h"
#include "prim.h"
#include "aci_cmh.h"
#include "ksd.h"
#include "p_sim.h"
#include "pcm.h"
#include "P_MNSMS.val"

#include "psa.h"
#include "psa_sim.h"

#include "mfw_mfw.h"
#include "mfw_nm.h"
#include "mfw_sima.h"
#include "mfw_nmi.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_cmi.h"
#include "mfw_sim.h"
#include "mfw_simi.h"
#include "mfw_phbi.h"
#include "mfw_sms.h"
#include "mfw_smsi.h"
#include "mfw_win.h"
#include "mfw_cphs.h"
#include "mfw_cphsi.h"
#include "aci_lst.h"
#include "conc_sms.h"


#ifdef SIM_TOOLKIT
#include "mfw_sat.h"
#endif

#include <string.h>
#include <stdio.h>

/* robert.chen add, 2004-08-10, integrated MMS module */
#if _MMS_ENABLE_	
#include "mmiutilapi.h"
#include "ffs.h"

#define _PUSH_DETECT_ENABLE_  1
#endif




/********* current define *******************************************/
/*SPR 2260 added definitions*/
/* glowing,2004-06-11, import from TCS2112 */
#define FIRST_READ_OF_MEMORY_USE 1
#define POST_DELETE_CHECK        2
/* glowing,2004-06-11, end of import */
static T_MFW_SMS_MSG msg_info[MAX_MESSAGES]; /* message table */

static T_MFW_SMS_MO sms_mo;
static T_MFW_SMS_MT sms_mt;
static T_MFW_SMS_CB sms_cb;
static T_MFW_SMS_ID sms_id, sms_id_wait;

/* glowing,2004-06-12,modify */
//static T_MFW_MEM_INFO     memory;
T_MFW_MEM_INFO     memory;
/*glowing,2004-06-12, end of modify */

static SHORT              first_id;
static SHORT              flag;
static SHORT			 status_change_index;
static SHORT			 deleting_index;
static SHORT			 storage_index;
static SHORT              mt_flag;
static UBYTE              f_update;
static UBYTE              int_req;
static UBYTE              smsReady;
static UBYTE              phbReady;
static UBYTE              sentStatus;
static UBYTE              sms_update = FALSE;

static UBYTE              coll_sms_send;   /* mt sms during send process */
static UBYTE              coll_sms_read;   /* mt sms during read process */
static UBYTE              coll_sms_delete; /* mt sms during delete process */
static UBYTE              coll_sms_req;    /* mt sms during request process */

static UBYTE              data[30];

static UBYTE			initialising_flag;

UBYTE     sms_type;
UBYTE     mt_type;
UBYTE     int_init_req;
CHAR     *wr_addr;
UBYTE Delete_1_2_1_vm_icon=FALSE;
UBYTE Display_1_2_1_vm_icon =FALSE;
static UBYTE     cb_mid[10];  /* cell broadcast message identifier */
static UBYTE     fg;
EXTERN MfwHdr * current_mfw_elem;

static BOOL cmgr_awaiting_ok = FALSE; // Marcus: Issue 2260: 03/10/2002
/*********************Prototypes****************************************/

/*SPR2260 added prototype for new function*/
BOOL delete_sms_from_table (SHORT index); //glowing,2004-06-11, import from TCS2112

/* robert.chen add, 2004-08-10, integrated MMS module */
#if (_PUSH_DETECT_ENABLE_ == 1)

	#define MAX_MMS_SI		6
	#define MAX_SEG_NUM		5
	#define MAX_DEL_STORE	20

	#define MERGE_STA_CONTINUE		0
	#define MERGE_STA_COMPLETE		1
	#define MERGE_STA_ERROR			2

typedef struct pushSeg
{
	UBYTE   seq;	/* sequence number */
	UBYTE   idx;	/* index in memory storage */
	UBYTE   len;	/* length of the segment */
	UBYTE   *data;	/* pointer to seg data buffer */
	struct pushSeg *next;
} T_PUSH_SEG;

typedef struct pushSegBug
{
	UBYTE   fuse;		/* occupying flag */
	UBYTE   idx_num;    
	UBYTE   mem_idx[MAX_SEG_NUM];
	//	UBYTE	seg_seq[MAX_SEG_NUM];
	USHORT  ref_num;	/* reference number of the segments */
	T_PUSH_SEG *list;	/* segments list of the same reference number */
} T_PUSH_SEGBUF;

typedef struct pushMergeBuf
{
	UBYTE   fuse;		/* occupying flag */
	UBYTE   next_seg;	/* number of next seg to be added to data buffer */
	UBYTE   total;		/* total nuber of segs */
	UBYTE   left;		/* number of left segs to be assembly */
	USHORT  ref_num;	/* ref number of the segs */
	USHORT  len;		/* length of concatenated seg data */
	UBYTE   *data;		/* concatenated seg data */
} T_PUSH_MERGE;

typedef struct delStore
{
	UBYTE   rd;
	UBYTE   wr;
	UBYTE   mem_idx[MAX_DEL_STORE]; 
	MfwHnd  t_post;		/* timer for deleting SMS carrying PUSH PDU in background */
} T_DEL_STORE;

	#define PUSH_DET_TRACE(msg) MI_dbgPrintf msg

/* if a specific IE included in the SMS UDH */
UBYTE* is_ie_include(UBYTE iei, UBYTE *udh, UBYTE udh_len);

/* if a SMS carrying WAP PUSH message */
UBYTE* is_push(UBYTE *udh, UBYTE udh_len);

/* when a WAP PUSH message detected, remove the port addressing IE from UDH */
UBYTE  udh_adjust(UBYTE index, T_ACI_CMGL_SM *sm);

/* route PUSH PDU to destination application, at present only MMS agent available */
UBYTE*  push_appli_dispatch(UBYTE *data, USHORT* retLen, USHORT len);

/* notice the MMS application a MMS PDU from PUSH incoming */
UBYTE  MMS_SI_ind(UBYTE *data, USHORT len, UBYTE index);

/* get a existing entry for SMS concatenating in process */
T_PUSH_MERGE *push_mbuf_getSlot(USHORT ref_num);

/* get a new merge entry for a new concatenation */
T_PUSH_MERGE *push_mbuf_getNewSlot(USHORT ref_num, UBYTE max_num);

/* add a piece of concatenated SMS data to concatenating data block */
T_PUSH_MERGE *push_mbuf_addData(USHORT ref_num, UBYTE max_num, UBYTE len, UBYTE * data);

/* clear a merge buffer entry */
void push_mbuf_clear(T_PUSH_MERGE *mergeBuf_slot, UBYTE startup, UBYTE idx);

/* get a existing segment buffer entry identified by reference number */
T_PUSH_SEGBUF *push_sbuf_getSlot(USHORT ref_num);

/* allocate and init a new segment buffer entry */
T_PUSH_SEGBUF *push_sbuf_getNewSlot(USHORT ref_num);

/* add a SMS segments to the segment entry identified by reference number */
UBYTE push_sbuf_addSeg(USHORT ref_num, UBYTE seq_num, UBYTE mem_idx, UBYTE len, UBYTE * data);

/* remove the SMS segment specified by reference number and sequence number from segments list */
T_PUSH_SEG *push_sbuf_removeSeg(USHORT ref_num, UBYTE seq_num);

/* clear a segments buffer entry */
void push_sbuf_clear(T_PUSH_SEGBUF *segbuf_slot, UBYTE startup, UBYTE idx);

/* init data for push detection */
void push_init(void);

/* merge segmented SMS to a PUSH PDU */
UBYTE  push_merge_sms(T_ACI_CMGL_SM *sm, T_PUSH_MERGE **idx);

/* timer callback for delete PUSH SMS in background */
int push_sms_del_timCB(MfwEvt e, MfwHnd h);

/* add one or more index to delete waiting list (ring buffer) */ 
void push_delLst_add(UBYTE* idx, UBYTE len);

/* remove the first index from delete waiting list */
void push_delLst_remove(void);

/* get current index to be delete from waiting list */
UBYTE push_delLst_get(void);

#endif

#if (_PUSH_DETECT_ENABLE_ == 1)

/* buffer array for segmented SMS concatenation */
T_PUSH_MERGE    pMergeBuf[MAX_MMS_SI];  

/* buffer array for uncontinuous SMS segments */
T_PUSH_SEGBUF   pSegBuf[MAX_MMS_SI];

/* the array carrying SMS that should be delete after PUSH PDU merge */
T_DEL_STORE pushDelList;    

/****
* Check if a specific IE is included in UDH, if found return 
* the pointer to the IE position in UDH, otherwise return NULL
*/
UBYTE* is_ie_include(UBYTE iei, UBYTE * udh, UBYTE udh_len)
{
	UBYTE len;
	UBYTE *p_udh;

	PUSH_DET_TRACE(("is_ie_include():iei=%d, udh=%d", iei, (UINT32)udh));
	p_udh   = udh;

	if (udh_len == 0)
		return NULL;	/* normal SM */

	
	while ((UINT32)p_udh < (UINT32)(udh + udh_len))	/* searching */
	{
		PUSH_DET_TRACE(("is_ie_include():searching ie..."));
		if (*p_udh == iei)
		{
			PUSH_DET_TRACE(("is_ie_include():iei=%d included!", iei));
			return p_udh;
		}
		else
		{
			len = *(p_udh+1);
			p_udh += len + 2;
			PUSH_DET_TRACE(("is_ie_include():next, udh=%d", (UINT32)p_udh));
		}
	}

	PUSH_DET_TRACE(("is_ie_include():NO"));
	return NULL;
}

/****
* Check the UDH to see if a SMS is a WAP PUSH message, if so, return 
* a pointer to the position in UDH where the IE located, otherwise 
* return NULL.
*/
UBYTE* is_push(UBYTE *udh, UBYTE udh_len)
{
	USHORT srcPort, desPort;
	UBYTE  *pIE;

	PUSH_DET_TRACE(("is_push():udh_len=%d", udh_len));

	if ((pIE = is_ie_include(0x05, udh, udh_len)) != NULL)
	{
		//16 bit application port addressing scheme
		desPort = (*(pIE+2)<<8) | (*(pIE+3));
		srcPort = (*(pIE+4)<<8) | (*(pIE+5));
		PUSH_DET_TRACE(("is_push():dP=%d,sP=%d", desPort, srcPort));

		if (desPort == 0x0b84 && srcPort == 0x23f0)	//0x0b80 is push port
		{
			PUSH_DET_TRACE(("is_push():YES"));
			return pIE;
		}
	}

	return NULL;
}

/****
* Check if the SMS carrying WAP PUSH PDU, if yes, adjust the UDH header by
* removing the port addressing IE for following SMS concatenation process
* if need, and return 1 indicating the SMS is a WAP PUSH PDU, otherwise 
* the SMS will be remained as the original and return 0.
* refer to GSM 03.40 for detail of UDH structure.
*/
UBYTE udh_adjust(UBYTE index, T_ACI_CMGL_SM * sm)
{
	UBYTE *pIE, *concIE;
	UBYTE ie_len;
	UBYTE i;

	PUSH_DET_TRACE(("udh_adjust():idx=%d, uL=%d", index, sm->udh.len));

	if (sm->udh.len == 0)
		return 0;	// no adjust

	pIE = sm->udh.data;
	//PUSH_DET_TRACE(("udh_adjust():u0=%d, u1=%d, u2=%d, u3=%d, u4=%d, u5=%d, u6=%d", *pIE++,*pIE++,*pIE++,*pIE++,*pIE++,*pIE++,*pIE++));

	if ((pIE = is_push(sm->udh.data, sm->udh.len)) != NULL)
	{
		// it is a SMS carrying push information, we adjust the udh so that MFW can do concatenate if need
		ie_len = *(pIE+1) +2;	//total IE len including IEI and IE length field
		sm->udh.len -= ie_len;	// calculate left udh length

		// adjust udh data buffer to remove port addressing IE
		for (i = 0; i < sm->udh.len; i ++)
		{
			sm->udh.data[i] = sm->udh.data[i + ie_len];
		}

		pIE = sm->udh.data;
		//PUSH_DET_TRACE(("udh_adjust():finish!uL=%d, u0=%d,u1=%d,u2=%d,u3=%d,u4=%d,u5=%d,u6=%d", sm->udh.len,*pIE++,*pIE++,*pIE++,*pIE++,*pIE++,*pIE++,*pIE++));
		return 1;
	}
	return 0;
}

/****
* Dispathing push data to destination application, at preset only MMS
* application desires PUSH.
* Return: NULL failed, else return a pointer to PUSH data for MMS
*/
UBYTE* push_appli_dispatch(UBYTE *data, USHORT* retLen, USHORT len)
{
	UBYTE   *pData, tmp;
	UBYTE   vintLen = 0;
	UINT32  nHdLen = 0;	//PDU header length preset in UINT32 format

	pData = data;
	PUSH_DET_TRACE(("push_appli_dispatch():DP=%d,L=%d,d0-7:0x%2X,0x%2X,0x%2X,0x%2X,0x%2X,0x%2X,0x%2X,0x%2X", (UINT32)data,len,*pData++,*pData++,*pData++,*pData++,*pData++,*pData++,*pData++,*pData));

	pData = data + 1;	//skip TID field

	/* check PDU type */
	if (*pData != 0x06)
	{
		PUSH_DET_TRACE(("push_appli_dispatch():failed, not a push PDU, type=0x%X", *pData));
		return NULL;
	}

	pData ++;	//skip PDU type octet

	/* extract PDU header length */
	do
	{
		if (vintLen > 4)
		{
			PUSH_DET_TRACE(("push_appli_dispatch():failed, vint length overflow!"));
			return NULL;
		}

		tmp = *pData++;
		nHdLen = (nHdLen << 7) | (tmp & 0x7f);
		vintLen ++;
	}
	while (tmp > 0x7f);

	*retLen = len - nHdLen - vintLen - 2; 

	PUSH_DET_TRACE(("push_appli_dispatch():hdLen=%d", nHdLen));

	/* check content-type, only a simple implementation for MMS agent acceptable content type */
	if (*pData == 0xBE)/* content-type presents as a Constrained-media */
	{
		PUSH_DET_TRACE(("push_appli_dispatch():content-type=0x%X", *pData & 0x7f));
		pData ++;
		nHdLen--;  
	}
	else if (*pData > 31 && *pData < 127) //content-type presents as a string
	{
		if (strcmp((void*)pData, "application/vnd.wap.mms-message") != 0)
		{
			PUSH_DET_TRACE(("push_appli_dispatch():failed!"));
			return NULL;
		}
		else
		{
			nHdLen  -= (strlen((void*)pData) + 1); 
			pData   += strlen((void*)pData) + 1;	//shift to PUSH header			
			PUSH_DET_TRACE(("push_appli_dispatch():content-type=\"mms-message\""));
		}
	}
	else
	{
		PUSH_DET_TRACE(("push_appli_dispatch():failed, content-type=0x%X", *pData));
		return NULL;
	}

	/* check Application-ID field */        
	return(pData + nHdLen);
}

/****
* Save PUSH data desired by MMS application to a FFS file, and
* indicating the MMS application
*/
UBYTE MMS_SI_ind(UBYTE * data, USHORT len, UBYTE index)
{
extern void MMS_Content_REQ(
						UBYTE urlID,
						char *Data,
						ULONG data_length,
						BOOL moreData,
						ULONG totalSize,
						SHORT errorNo);
	UBYTE i;
	char fname[15];
	T_FFS_RET error;
	T_FFS_STAT stat;

	PUSH_DET_TRACE(("MMS_SI_ind():len=%d", len));
#ifdef MMS_WAP_ENABLED	
	MMS_Content_REQ(230,(char*)data,len,FALSE,0,0);
#else
	for (i = 0; i < MAX_MMS_SI; i ++)
	{
		sprintf(fname, "/mmi/mms_si%d", i); 
		if ((error = ffs_stat(fname, &stat)) == EFFS_NOTFOUND)
		{
			/* here we find a entry for writing the SI data */
			error = ffs_fwrite(fname, data, len);
			if (error == EFFS_OK)
			{
				PUSH_DET_TRACE(("MMS_SI_ind():write FFS file \"%s\" ok!", fname));
				return 1;
			}
			else
			{
				PUSH_DET_TRACE(("MMS_SI_ind():P0, fail to write FFS files!"));
			}

			break;
		}
	}
	PUSH_DET_TRACE(("MMS_SI_ind():P1, fail to write FFS files!"));
#endif
	return 0;
}

/****
* Get the existing merge buffer for SMS concatenation
*/
T_PUSH_MERGE *push_mbuf_getSlot(USHORT ref_num)
{
	UBYTE i;
	PUSH_DET_TRACE(("push_mbuf_getSlot()"));

	for (i = 0; i < MAX_MMS_SI; i ++)
	{
		if (pMergeBuf[i].ref_num == ref_num && pMergeBuf[i].fuse)
		{
			PUSH_DET_TRACE(("push_mbuf_getSlot():find a existing slot, idx=%d", i));
			return(&pMergeBuf[i]);
		}
	}

	return NULL;
}

/****
* Allocate and initialize a new merge buffer according to the specified
* concatenated SMS reference number and segments number
*/
T_PUSH_MERGE *push_mbuf_getNewSlot(USHORT ref_num, UBYTE max_num)
{
	UBYTE i;

	PUSH_DET_TRACE(("push_mbuf_getNewSlot():ref_num=%d, max_num=%d", ref_num, max_num));

	for (i = 0; i < MAX_MMS_SI; i ++)
	{
		if (pMergeBuf[i].fuse == 0)
		{
			pMergeBuf[i].fuse       = 1;
			pMergeBuf[i].next_seg   = 1;

			pMergeBuf[i].ref_num    = ref_num;
			pMergeBuf[i].len        = 0;

			if (max_num > MAX_SEG_NUM)
				max_num = MAX_SEG_NUM;

			pMergeBuf[i].left       = max_num;
			pMergeBuf[i].total      = max_num;

			MALLOC(pMergeBuf[i].data, MAX_SM_LEN * max_num);
			PUSH_DET_TRACE(("push_mbuf_getNewSlot():a buffer allocated, idx=%d", i));
			return(&pMergeBuf[i]);
		}
	}

	PUSH_DET_TRACE(("push_mbuf_getNewSlot(): failed!"));
	return NULL;
}

/****
* Add a piece of SMS segment to the merge buffer specified by the SMS
* reference number
*/
T_PUSH_MERGE *push_mbuf_addData(USHORT ref_num, UBYTE max_num, UBYTE len, UBYTE *data)
{
	T_PUSH_MERGE *merge_slot;

	PUSH_DET_TRACE(("push_mbuf_addData():ref_num=%d,max_num=%d,len=%d", ref_num, max_num, len));
	merge_slot = push_mbuf_getSlot(ref_num);

	if (merge_slot == NULL)
		merge_slot = push_mbuf_getNewSlot(ref_num, max_num);

	if (merge_slot == NULL)
	{
		PUSH_DET_TRACE(("push_mbuf_addData():failed, can get buffer!"));
		return NULL;
	}

	memcpy(merge_slot->data + merge_slot->len, data, len);
	merge_slot->len += len;
	merge_slot->next_seg ++;
	merge_slot->left --;

	PUSH_DET_TRACE(("push_mbuf_addData():after add a segment,next_seg=%d", merge_slot->next_seg));
	return merge_slot;
}

/****
* Empty a merge buffer specified by a pointer or a index,
* the pointer is prefered
*/
void push_mbuf_clear(T_PUSH_MERGE *mergeBuf_slot, UBYTE startup, UBYTE idx)
{
	T_PUSH_MERGE *bufPtr;

	PUSH_DET_TRACE(("push_mbuf_clear():bufPtr=%d, startup=%d, idx=%d", (UINT32)mergeBuf_slot, startup, idx));

	if (mergeBuf_slot != NULL)
		bufPtr = mergeBuf_slot;
	else
	{
		if (idx >= MAX_MMS_SI)
			return;
		else
			bufPtr = &pMergeBuf[idx];
	}   

	bufPtr->fuse        = 0;
	bufPtr->next_seg    = 0;
	bufPtr->total       = 0;
	bufPtr->left        = 0;
	bufPtr->ref_num     = 0xFFFF;
	bufPtr->len         = 0;

	if (!startup &&bufPtr->data != NULL)
	{
		PUSH_DET_TRACE(("push_mbuf_clear():free the merge data block!"));
		MFREE(bufPtr->data);            
	}

	bufPtr->data    = NULL;
}

/****
* Get a existing segment buffer for uncontinuous SMS
*/
T_PUSH_SEGBUF *push_sbuf_getSlot(USHORT ref_num)
{
	UBYTE i;

	PUSH_DET_TRACE(("push_sbuf_getSlot():ref_num=%d", ref_num));
	for (i = 0; i < MAX_MMS_SI; i ++)
	{
		if (pSegBuf[i].ref_num == ref_num && pSegBuf[i].fuse)
		{
			PUSH_DET_TRACE(("push_sbuf_getSlot():existing!"));
			return(&pSegBuf[i]);
		}
	}
	return NULL;
}

/****
* Allocate and initialize a segment buffer accoring to the concatenation
* SMS reference number.
*/
T_PUSH_SEGBUF *push_sbuf_getNewSlot(USHORT ref_num)
{
	UBYTE i;

	PUSH_DET_TRACE(("push_sbuf_getNewSlot():ref_num=%d", ref_num));
	for (i = 0; i < MAX_MMS_SI; i ++)
	{
		if (pSegBuf[i].fuse == 0)
		{
			memset((void*)pSegBuf[i].mem_idx, 0xFF, MAX_SEG_NUM);           
			//memset((void*)pSegbuf[i].seg_seq, 0xFF, MAX_SEG_NUM);
			pSegBuf[i].idx_num  = 0;
			pSegBuf[i].fuse     = 1;
			pSegBuf[i].ref_num  = ref_num;
			pSegBuf[i].list     = NULL;
			PUSH_DET_TRACE(("push_sbuf_getSlot():allocate a new buffer,idx=%d", i));
			return(&pSegBuf[i]);
		}
	}

	return NULL;
}

/****
* Add uncontinuous segment data to segment buf
*/
UBYTE push_sbuf_addSeg(USHORT ref_num, UBYTE seq_num, UBYTE mem_idx, UBYTE len, UBYTE *data)
{
	UBYTE i;    
	T_PUSH_SEGBUF *segbuf_slot;
	T_PUSH_SEG  *seg_elem, *list, *pre;

	PUSH_DET_TRACE(("push_sbuf_addSeg():ref_num=%d,seq_num=%d,mem_idx=%d,len=%d,data=%d",ref_num, seq_num, mem_idx, len, (UINT32)data));

	if (seq_num > MAX_SEG_NUM)
		return 1;

	segbuf_slot = push_sbuf_getSlot(ref_num);

	if (segbuf_slot == NULL)
	{
		segbuf_slot = push_sbuf_getNewSlot(ref_num);
	}

	if (segbuf_slot != NULL)
	{
		for (i = 0; i < segbuf_slot->idx_num; i ++)
		{
			if (segbuf_slot->mem_idx[i] == mem_idx)
				break;
		}

		if (i >= segbuf_slot->idx_num)
		{
			segbuf_slot->mem_idx[segbuf_slot->idx_num] = mem_idx;
			segbuf_slot->idx_num ++;
		}

		if (data != NULL)	 //need add data block
		{
			MALLOC(seg_elem, sizeof(T_PUSH_SEG));
			seg_elem->seq   = seq_num;
			seg_elem->idx   = mem_idx;
			seg_elem->len   = len;
			seg_elem->data  = NULL;
			seg_elem->next  = NULL;

			MALLOC(seg_elem->data, seg_elem->len);
			memcpy(seg_elem->data, data, seg_elem->len);

			/* insert to seg chain */
			list = segbuf_slot->list;
			pre  = NULL;
			while (list)
			{
				if (seg_elem->seq >= list->seq)
				{
					pre  = list;
					list = list->next;
				}
				else
					break;
			}

			if (pre == NULL) // the first element of the list
			{
				segbuf_slot->list   = seg_elem;
				seg_elem->next      = list;
			}
			else
			{
				if (pre->seq == seg_elem->seq)
					return 1; // don't save the same seg twice
				else
				{
					seg_elem->next  = list;
					pre->next       = seg_elem;
				}   
			}

			return 1;
		}

		return 1;
	}

	return 0;
}

/****
* Get a piece of SMS segment specified by SMS reference number and 
* sequence number from the segment buffer
*/
T_PUSH_SEG *push_sbuf_removeSeg(USHORT ref_num, UBYTE seq_num)
{
	T_PUSH_SEGBUF *segbuf_slot;
	T_PUSH_SEG    *pre = NULL, *cur;

	PUSH_DET_TRACE(("push_sbuf_removeSeg():ref_num=%d, seq_num=%d", ref_num, seq_num));
	segbuf_slot = push_sbuf_getSlot(ref_num);

	if (segbuf_slot == NULL)
		return NULL;

	cur = segbuf_slot->list;

	if (cur == NULL)
		return NULL;

	while (cur != NULL)
	{
		if (cur->seq == seq_num)
			break;

		pre = cur;
		cur = cur->next;        
	}

	if (pre == NULL)
	{
		segbuf_slot->list = cur->next;      
	}
	else
	{
		if (cur != NULL)
			pre->next = cur->next;
	}
	return(cur);
}

/****
* Empty a seg buffer specified by a pointer or a index, the pointer
* is prefered
*/
void push_sbuf_clear(T_PUSH_SEGBUF *segbuf_slot, UBYTE startup, UBYTE idx)
{
	UBYTE   i;
	T_PUSH_SEG *list, *del;
	T_PUSH_SEGBUF *bufPtr;

	PUSH_DET_TRACE(("push_sbuf_clear():segbuf=%d, startup=%d, idx=%d", (UINT32)segbuf_slot, startup, idx));

	if (segbuf_slot != NULL)
		bufPtr = segbuf_slot;
	else
	{
		if (idx >= MAX_MMS_SI)
			return;
		else
			bufPtr = &pSegBuf[idx];
	}       

	bufPtr->fuse        = 0;
	bufPtr->ref_num     = 0xFFFF;

	if (!startup)
	{
		list = bufPtr->list;        
		while (list != NULL)
		{
			del  = list;
			list = del->next;

			if (del->data)
				MFREE(del->data);

			MFREE(del);
		}
	}
	bufPtr->list    = NULL;

	/* delete all SMS of the same reference number */
	if (!startup)
		push_delLst_add(bufPtr->mem_idx, bufPtr->idx_num);

	memset(bufPtr->mem_idx, 0xFF, MAX_SEG_NUM);
	bufPtr->idx_num = 0;
}

/****
* Initialize the data for WAP PUSH SMS concatenation
*/
void push_init()
{
	UBYTE i;

	PUSH_DET_TRACE(("push_init()"));
	for (i = 0; i < MAX_MMS_SI; i ++)
	{
		push_sbuf_clear(NULL, 1, i);
		push_mbuf_clear(NULL, 1, i);
	}

	/* clear delete list */
	memset((char*)pushDelList.mem_idx, 0xff, sizeof(pushDelList.mem_idx));
	pushDelList.rd = pushDelList.wr = 0;
	pushDelList.t_post  = NULL;
}

/****
*	Merge concatenation SMS to a push message, return status code when everytime
*  invoked, the returned idx is available if the returned status code is complete
*
*	RETURN  0 continue, 1 completed, 2 error.
*/
UBYTE push_merge_sms(T_ACI_CMGL_SM *sm, T_PUSH_MERGE **idx)
{
	UBYTE   i, error;
	UBYTE   max_num, seq_num; 
	UBYTE   *add_data, add_data_len;
	UBYTE   except_num;
	USHORT  ref_num;
	T_PUSH_MERGE    *merge_slot;
	T_PUSH_SEGBUF   *segbuf_slot;
	T_PUSH_SEG      *seg_slot;


	/* parsing user data header */  
	if (sm->udh.data[0] EQ SMS_IEI_CONC_8BIT) /* 8-bit reference number */
	{
		ref_num = sm->udh.data[2];
		max_num = sm->udh.data[3];
		seq_num = sm->udh.data[4];
	}
	else if (sm->udh.data[0] EQ SMS_IEI_CONC_16BIT)	/* 16-bit reference number */
	{
		ref_num = (sm->udh.data[2] & 0x00FF) << 8;	/* MSB */       
		ref_num += sm->udh.data[3];		/* LSB */
		max_num = sm->udh.data[4];
		seq_num = sm->udh.data[5];
	}
	else
		return MERGE_STA_ERROR;

	PUSH_DET_TRACE(("push_merge_sms():ref_num=%d, max_num=%d, seq_num=%d", ref_num, max_num, seq_num)); 

	merge_slot = push_mbuf_getSlot(ref_num);

	if (merge_slot == NULL)
		except_num = 1;
	else
		except_num = merge_slot->next_seg;

	PUSH_DET_TRACE(("push_merge_sms():except segment=%d",except_num));

	if (seq_num == 0 || seq_num > max_num || seq_num < except_num)
		return MERGE_STA_ERROR;

	if (seq_num > MAX_SEG_NUM)
	{
		push_delLst_add(&seq_num, 1);
		return MERGE_STA_CONTINUE;
	}

	/* only add memory index info */
	push_sbuf_addSeg( ref_num, seq_num, sm->msg_ref, 0, NULL);

	add_data        = sm->data.data;
	add_data_len    = sm->data.len;

	if (seq_num > except_num)
	{
		error = push_sbuf_addSeg(ref_num, seq_num, sm->msg_ref, add_data_len, add_data);
		if (error == 0)
		{
			PUSH_DET_TRACE(("push_merge_sms():error to add seg %d", seq_num));
			return MERGE_STA_ERROR;
		}

		return MERGE_STA_CONTINUE;
	}
	else
	{
		while (1)
		{
			merge_slot = push_mbuf_addData(ref_num, max_num, add_data_len, add_data);

			if (sm->data.data != add_data)
			{
				MFREE(add_data);
			}

			if (merge_slot == NULL)
			{
				PUSH_DET_TRACE(("push_merge_sms(): buffer full!"));
				return MERGE_STA_ERROR;
			}

			if (merge_slot->left == 0)
			{
				PUSH_DET_TRACE(("push_merge_sms(): complete!"));
				*idx = merge_slot;              
				return MERGE_STA_COMPLETE;
			}

			seg_slot = push_sbuf_removeSeg(ref_num, merge_slot->next_seg);
			if (seg_slot == NULL)
			{
				return MERGE_STA_CONTINUE;
			}

			add_data        = seg_slot->data;
			add_data_len    = seg_slot->len;            
			MFREE(seg_slot);
		}
	}
}

/****
*  Timer callback for delete SMS carrying PUSH PDU, should be called
*  before any executing of SMS rAT_xxx functions
*/
int push_sms_del_timCB(MfwEvt e, MfwHnd h)
{
	UBYTE idx;  
	T_ACI_RETURN    ret;

	idx = push_delLst_get();
	PUSH_DET_TRACE(("push_sms_del_timCB(), idx=%d", idx));

	if (idx != 0xff) /* if 0xff, empty, no more index to be delete */
	{
		if ((ret = sAT_PlusCMGD(CMD_SRC_LCL, idx)) NEQ AT_EXCT)
		{
			PUSH_DET_TRACE(("push_sms_del_timCB(): delete error, ret=%d", ret));

			/* restart timer for next try */
			if (ret == AT_BUSY)
				timStart(pushDelList.t_post);

			return 0;
		}

		coll_sms_delete = MFW_SMS_WAIT;
		deleting_index  = idx;
		return 1;
	}

	return 0;
}

/****
*  Add one or more index to delete waiting list (a ring buffer)
*/

void push_delLst_add(UBYTE* idx, UBYTE len)
{
	UBYTE i;
	UBYTE flag;

	while (len--)
	{
		PUSH_DET_TRACE(("push_delLst_add():add to list, idx =%d, wr=%d, len=%d", *idx, pushDelList.wr, len));

		pushDelList.mem_idx[pushDelList.wr++] = *idx++;

		pushDelList.wr = pushDelList.wr % MAX_DEL_STORE;
	}

	if (pushDelList.t_post == NULL)
	{
		flag = Set_regflag(0);
		pushDelList.t_post = (MfwHnd)timCreate(0, 500, push_sms_del_timCB);
		PUSH_DET_TRACE(("push_delLst_add():create timer for post process, timer=%d", (UINT32)pushDelList.t_post));
		Set_regflag(flag);
		
		if (pushDelList.t_post != NULL)
		{
			PUSH_DET_TRACE(("push_delLst_add(): timer first run!"));
			timStart(pushDelList.t_post);           
		}
	}

	if (!timFindOut(pushDelList.t_post)) //if timer is not running
	{
		PUSH_DET_TRACE(("push_delLst_add(): start timer!"));
		timStart(pushDelList.t_post);
	}
}

/****
*  Remove the first index from delete waiting list
*/
void push_delLst_remove(void)
{
	PUSH_DET_TRACE(("push_delLst_remove(): rd=%d, idx=%d", pushDelList.rd, pushDelList.mem_idx[pushDelList.rd]));

	pushDelList.mem_idx[pushDelList.rd++]   = 0xFF;	// marked as empty
	pushDelList.rd = pushDelList.rd % MAX_DEL_STORE;
}

/****
*  Get current index to be delete from waiting list
*/
UBYTE push_delLst_get(void)
{
	PUSH_DET_TRACE(("push_delLst_get(): wr=%d, rd=%d, idx=%d", pushDelList.wr, pushDelList.rd, pushDelList.mem_idx[pushDelList.rd]));       

	return(pushDelList.mem_idx[pushDelList.rd]);
}

#endif //_PUSH_DETECT_ENABLE_

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_init          |
+--------------------------------------------------------------------+

   PURPOSE : initialize for SMS management

*/


void sms_init(void)
{
  UBYTE i;

  TRACE_FUNCTION ("sms_init()");

  /* Setting the default SMS parameter */
  sms_type = MFW_NO_MESSAGE;
  mt_type = MFW_NO_MESSAGE;
  flag = 0;
  status_change_index = 0;
  deleting_index = 0;
  mt_flag = 0;
  smsReady = 0;
  phbReady = 0;
  sms_id.index = sms_id_wait.index = 0;

  for (i=0; i<MAX_MESSAGES; i++)
  {
    msg_info[i].index = -1;
    msg_info[i].addr.number[0] = '\0';
    msg_info[i].addr.tag[0] = '\0';
    msg_info[i].addr.ton = MFW_TON_UNKNOWN;
    msg_info[i].addr.npi = MFW_NPI_UNKNOWN;
    msg_info[i].first_index = -1; /*SPR 2260*/
	msg_info[i].concat_status = MFW_SMS_NO_CONC;

  }
  /* PATCH-6363 VO 30.01.01 */
  memory.mem = SMS_STOR_Sm;
  memory.used = 0;
  memory.total = 0;
  /* PATCH-6363 end */

/* robert.chen add, 2004-08-10, integrated MMS module */
#if (_PUSH_DETECT_ENABLE_ == 1)	
	push_init();
#endif

  
  /* glowing,2004-06-11, import from M188 */
  sAT_PlusCMGF(CMD_SRC_LCL, CMGF_MOD_Txt);    // Marcus: Issue 1388: 06/01/2003
  /* glowing,2004-06-11, end of import */

}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_exit          |
+--------------------------------------------------------------------+

   PURPOSE : initialize for SMS management

*/

void sms_exit(void)
{
  TRACE_FUNCTION ("sms_exit()");
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_phbReady_ind  |
+--------------------------------------------------------------------+

   PURPOSE : finished initialize from the SIM card

*/

void sms_phbReady_ind(void)
{
  if (smsReady)
  {
    TRACE_FUNCTION("sms_phbReady_ind");

    f_update = MFW_SMS_NEW;
    TRACE_EVENT("all free");
    coll_sms_send = coll_sms_read = coll_sms_delete = coll_sms_req = MFW_SMS_FREE;
    sms_read_msg_info();
    smsReady = 0;
    phbReady = 0;
  }
  else
    phbReady = 1;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_sms_ready     |
+--------------------------------------------------------------------+

   PURPOSE : finished initialize from the SIM card

*/

void rAT_sms_ready(void)
{
    TRACE_FUNCTION("rAT_sms_ready()");

    if (phbReady)
    {
      f_update = MFW_SMS_NEW;
      sms_read_msg_info();
      smsReady = 0;
      phbReady = 0;
    }
    else
      smsReady = 1;
}

/*
+--------------------------------------------------------------------+
| PROJECT : GSM-F&D (8411)              MODULE  : MFW_CB             |
| STATE   : code                        ROUTINE : rAT_SignalSMS      |
+--------------------------------------------------------------------+

  PURPOSE : handles rAT_SignalSMS call back

*/

GLOBAL void rAT_SignalSMS ( UBYTE state )
{
  TRACE_FUNCTION("rAT_SignalSMS()");
  switch (state)
  {
	case SMS_STATE_INITIALISING: initialising_flag = TRUE; break;
  	case SMS_STATE_READY: initialising_flag = FALSE; break;
  }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_create        |
+--------------------------------------------------------------------+

   PURPOSE : create SMS control

*/

T_MFW_HND sms_create(T_MFW_HND hWin, T_MFW_EVENT event, T_MFW_CB cbfunc)
{
  T_MFW_HDR *hdr;
  T_MFW_SMS *sms_para;
  MfwHdr *insert_status =0;
  
  TRACE_FUNCTION ("sms_create()");

  hdr      = (T_MFW_HDR *) mfwAlloc(sizeof(T_MFW_HDR));
  sms_para = (T_MFW_SMS *) mfwAlloc(sizeof(T_MFW_SMS));

  if (!hdr OR !sms_para)
  	{
    	TRACE_ERROR("ERROR: sms_create() Mem Alloc Failed.");
			
	   	if(hdr)
   			mfwFree((U8*)hdr,sizeof(MfwHdr));

   		if(sms_para)
   			mfwFree((U8*)sms_para,sizeof(T_MFW_SMS));
   		
	   	return FALSE;
    }
  /* initialisation of the handler */
  sms_para->emask   = event;
  sms_para->handler = cbfunc;

  hdr->data = sms_para;         /* store parameter in node */
  hdr->type = MFW_TYP_SMS;     /* store type of event handler */

  /* installation of the handler */

  insert_status =  mfwInsert((T_MFW_HDR *)hWin, hdr);/*SPR 1968, inserted inadvertently deleted function call*/
  
  if(!insert_status)
  	{
  		TRACE_ERROR("ERROR: sms_create() Failed to Install Handler. ");
   		mfwFree((U8*)hdr,sizeof(MfwHdr));
   		mfwFree((U8*)sms_para,sizeof(T_MFW_SIM)); 	
		return 0;
  	}
    return insert_status;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_delete        |
+--------------------------------------------------------------------+

   PURPOSE : delete SMS control

*/

T_MFW_RES sms_delete(T_MFW_HND h)
{
  TRACE_FUNCTION ("sms_delete()");

  if (!h OR !((T_MFW_HDR *)h)->data)
    return MFW_RES_ILL_HND;

  if (!mfwRemove((T_MFW_HDR *) h))
    return MFW_RES_ILL_HND;

  mfwFree((U8 *)(((T_MFW_HDR *) h)->data),sizeof(T_MFW_SMS));
  mfwFree((U8 *)h,sizeof(T_MFW_HDR));

 return MFW_RES_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_signal        |
+--------------------------------------------------------------------+

   PURPOSE : send a event.

*/

void sms_signal(T_MFW_EVENT event, void * para)
{
	UBYTE temp = dspl_Enable(0);
  TRACE_FUNCTION ("sms_signal()");
 if (mfwSignallingMethod EQ 0)
  {
  /* focus is on a window */
  if (mfwFocus)
    /* send event to sim management handler if available */
    if (sms_sign_exec (mfwFocus, event, para))
	{
	  dspl_Enable(temp);
      return;
	}

  /* acutal focussed window is not available or has no
   * network management registration handler, then search
   * all nodes from the root. */
   if (mfwRoot)
     sms_sign_exec (mfwRoot, event, para);
  }
  else
    {
      MfwHdr * h = 0;

      /*
       * Focus set, then start here
       */
      if (mfwFocus)
        h = mfwFocus;
      /*
       * Focus not set, then start root
       */
      if (!h)
        h = mfwRoot;

      /*
       * No elements available, return
       */

      while (h)


      {
        /*
         * Signal consumed, then return
         */
        if (sms_sign_exec (h, event, para))
	{
	  dspl_Enable(temp);
      return;
	}

        /*
         * All windows tried inclusive root
         */
        if (h == mfwRoot)
	{
	  dspl_Enable(temp);
      return;
	}

        /*
         * get parent window
         */
        h = mfwParent(mfwParent(h));
		if(h)
			h = ((MfwWin * )(h->data))->elems;
      }
      sms_sign_exec (mfwRoot, event, para);
    }
	  dspl_Enable(temp);
      return;
 }


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_sign_exec     |
+--------------------------------------------------------------------+

   PURPOSE : Send a signal if there is an SMS management handler.

*/

BOOL sms_sign_exec (T_MFW_HDR * cur_elem,
                    T_MFW_EVENT event,
                    T_MFW_SMS_PARA * para)
{//char debug[50];
//	sprintf(debug, "sms_sign_exec(): %d", event);
//  TRACE_EVENT (debug);

  while (cur_elem)
  {
    /* event handler is available */
    if (cur_elem->type EQ MFW_TYP_SMS)
    {
      T_MFW_SMS * sms_data;
      /* handler is SMS management handler */
      sms_data = (T_MFW_SMS *)cur_elem->data;
      if (sms_data->emask & event)
      {
        /* event is expected by the call back function */
        sms_data->event = event;
        switch (event)
        {
          case E_SMS_MO_AVAIL:
            memcpy (&sms_data->para.index, para, sizeof (UBYTE));
            break;
          case E_SMS_CMD_AVAIL:
            memcpy (&sms_data->para.index, para, sizeof (UBYTE));
            break;
          case E_SMS_SAVE_AVAIL:
            memcpy (&sms_data->para.index, para, sizeof (UBYTE));
            break;
          case E_SMS_MT:
            memcpy (&sms_data->para.sms_mt, para, sizeof (T_MFW_SMS_MT));
            break;
          case E_SMS_MO:
            memcpy (&sms_data->para.sms_mo, para, sizeof (T_MFW_SMS_MO));
            break;
          case E_SMS_CB:
            memcpy (&sms_data->para.sms_cb, para, sizeof (T_MFW_SMS_CB));
            break;
          case E_SMS_CB_RECEIVED:
            memcpy (&sms_data->para.sms_id, para, sizeof (T_MFW_SMS_ID));
            break;
          case E_SMS_MT_RECEIVED:
            memcpy (&sms_data->para.sms_id, para, sizeof (T_MFW_SMS_ID));
            break;
          case E_SMS_STATUS:
            memcpy (&sms_data->para.sms_status, para, sizeof (T_MFW_SMS_STATUS));
            break;
          case E_SMS_MEM:
            memcpy (&sms_data->para.sms_mem, para, sizeof (T_MFW_SMS_MEM_INFO));
            break;
          case E_SMS_OK:
#ifdef WIN32
			  // EF we only copy if non null
			  if (para != NULL)
#endif
			  memcpy (&sms_data->para.cmd_ind, para, sizeof (UBYTE));
            break;
          case E_SMS_ERR:
            memcpy (&sms_data->para.cmd_ind, para, sizeof (UBYTE));
            break;
        }

        /* if call back defined, call it */
        if (sms_data->handler)
        {
          // PATCH LE 06.06.00
          // store current mfw elem
          current_mfw_elem = cur_elem;
          // END PATCH LE 06.06.00
          if ((*(sms_data->handler)) (sms_data->event, (void *)&sms_data->para))
          {
            TRACE_EVENT("send SMS event");
            return TRUE;
          }
        }
      }
    }
    cur_elem = cur_elem->next;
  }

  return FALSE;
}


/*
+-------------------------------------------------------------------+
| PROJECT : GSM-PS (6147)         MODULE  : MFW_PHB                 |
| STATE   : code                  ROUTINE : sms_read_msg_info       |
+-------------------------------------------------------------------+

  PURPOSE : This function is used to read total information about SMS.
*/

void sms_read_msg_info()
{
    int i;

    TRACE_FUNCTION("sms_read_msg_info()");

    first_id = 1;

    for (i=0; i<MAX_MESSAGES; i++)
    {
        msg_info[i].index = -1;
        msg_info[i].addr.number[0] = '\0';
        msg_info[i].addr.tag[0] = '\0';
        msg_info[i].addr.ton = MFW_TON_UNKNOWN;
        msg_info[i].addr.npi = MFW_NPI_UNKNOWN;
    }

    f_update = MFW_SMS_NEW;
    if (sAT_PlusCMGL (CMD_SRC_LCL, SMS_STAT_All,
                      0, READ_PREVIEW) NEQ AT_EXCT)
    {
        TRACE_EVENT("sAT_PlusCMGL error");
        f_update = MFW_SMS_FREE;
    }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)  MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : rAT_PlusCMGL             |
+--------------------------------------------------------------------+

  PURPOSE : Response of read SMS list from ACI
*/

void rAT_PlusCMGL ( T_ACI_CMGL_SM * smLst )
{
  int i;
  int j;
  int n;
  T_SMS_TYPE received_sms_type;
  T_CONC_ASSEMBLY_RETURN concatenated_status;
  T_SM_DATA_EXT conc_data_ext;

#if (_PUSH_DETECT_ENABLE_ == 1)
	UBYTE push_msg_flag = 0;
#endif

  
  TRACE_FUNCTION ("rAT_PlusCMGL()");

#if (_PUSH_DETECT_ENABLE_ == 1)
	PUSH_DET_TRACE(("Robert:rAT_PlusCMGL() idx=%d, uL=%d, dL=%d", smLst->msg_ref, smLst->udh.len, smLst->data.len));

	if (smLst->udh.len > 0)	/* is not a normal SM */
	{
		push_msg_flag = udh_adjust(smLst->msg_ref, smLst);

		if (push_msg_flag)
		{
			/* delete the SMS */
			PUSH_DET_TRACE(("rAT_PlusCMGL():delete a push SMS"));
			push_delLst_add(&smLst->msg_ref, 1);
			return;     
		}
	}
#endif	//_PUSH_DETECT_ENABLE_

  
  received_sms_type = SMS_getSMSType( &smLst->udh);
  TRACE_EVENT_P1("SMS Type is = %d", received_sms_type);
  TRACE_EVENT_P1("SMS message status:%d", smLst->stat);

  if (received_sms_type == CONCATE)
	  {
	  if(initialising_flag == TRUE)
	  	concatenated_status =concSMS_Collect(&conc_data_ext, smLst, FALSE);
	  else
		concatenated_status =concSMS_Collect(&conc_data_ext, smLst, TRUE);
		TRACE_EVENT_P2("conc status: %d, conc length: %d", concatenated_status, conc_data_ext.len);


	  
	  }
/*SPR 2260, removed condition, update_mem parameter should be true so that each message is counted*/
	sms_store_new_msg_info(smLst->msg_ref, smLst, TRUE/*MC SPR 2260*/, concatenated_status);
	

			f_update = MFW_SMS_NEW;
{
	TRACE_EVENT_P4("CMGL Msg table: %d,%d,%d, %d", msg_info[0].index, msg_info[1].index,msg_info[2].index,msg_info[3].index);
	TRACE_EVENT_P4("CMGL Msg table: %d,%d,%d, %d", msg_info[4].index, msg_info[5].index,msg_info[6].index,msg_info[7].index);
}
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)  MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : sms_update_ready         |
+--------------------------------------------------------------------+

  PURPOSE : message list update is ready
*/

void sms_update_ready(void)
{
  TRACE_FUNCTION("sms_update_ready()");

    sms_signal(E_SMS_MT_RECEIVED, &sms_id);
  sms_id.index = 0;

  //glowing,2004-06-10, replace the following statement
  //if (memory.used == memory.total)
  if (memory.used == memory.total && memory.total !=0)
    sms_signal(E_SMS_MEM_FULL, 0);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)  MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : sms_update_msg_info      |
+--------------------------------------------------------------------+

  PURPOSE : update the SMS information list
*/

void sms_update_msg_info(T_MFW_SMS_STAT stat)
{
    int i;

    TRACE_FUNCTION("sms_update_msg_info()");

    for (i=0; i<MAX_MESSAGES; i++)
    {
        if (msg_info[i].index EQ status_change_index)
        	{
            	msg_info[i].stat = stat;
        	}
    }

    status_change_index = 0;
}


/*
+-------------------------------------------------------------------+
| PROJECT : GSM-PS (6147)         MODULE  : MFW_PHB                 |
| STATE   : code                  ROUTINE : sms_mem_cvt             |
+-------------------------------------------------------------------+

  PURPOSE : This function is used to convert the type of memory
            used by MFW to the type of memory used by ACI.
*/
LOCAL T_ACI_SMS_STOR sms_mem_cvt(UBYTE mem)
{
  switch ( mem )
  {
    case ( MFW_MEM_ME ):  return SMS_STOR_Me;
    case ( MFW_MEM_SIM ): return SMS_STOR_Sm;
    default:          return SMS_STOR_NotPresent;
  }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_set_mt_ind    |
+--------------------------------------------------------------------+

   PURPOSE :  MMI selects, how the receiving of new messages
              from the network is indicated.

*/

void sms_set_mt_ind(T_MFW_SMS_MT_IND mt_ind)
{
  TRACE_FUNCTION("sms_set_mt_ind()");

  switch (mt_ind)
  {
    case MT_IND_IDX:
      sAT_PlusCNMI ( CMD_SRC_LCL,
                     CNMI_MT_SmsDeliverInd,
                     CNMI_BM_NotPresent,
                     CNMI_DS_SmsStatRpt );
      break;

    case MT_IND_MSG:
      sAT_PlusCNMI ( CMD_SRC_LCL,
                     CNMI_MT_SmsDeliver,
                     CNMI_BM_NotPresent,
                     CNMI_DS_SmsStatRpt );
      break;

    case MT_IND_NO_IDX:
      sAT_PlusCNMI ( CMD_SRC_LCL,
                     CNMI_MT_NoSmsDeliverInd,
                     CNMI_BM_NotPresent,
                     CNMI_DS_SmsStatRpt );
      break;

    case MT_CB_IDX:
      sAT_PlusCNMI ( CMD_SRC_LCL,
                     CNMI_MT_NotPresent,
                     CNMI_BM_CbmInd,
                     CNMI_DS_NotPresent );
      break;

    case MT_CB_MSG:
      sAT_PlusCNMI ( CMD_SRC_LCL,
                     CNMI_MT_NotPresent,
                     CNMI_BM_Cbm,
                     CNMI_DS_NotPresent );
      break;

    case MT_CB_NO_IDX:
      sAT_PlusCNMI ( CMD_SRC_LCL,
                     CNMI_MT_NotPresent,
                     CNMI_BM_NoCbmInd,
                     CNMI_DS_NotPresent );
      break;

    default:
      break;
  }
}


/*
+-------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                |
| STATE   : code                         ROUTINE : sms_change_read_status |
+-------------------------------------------------------------------------+

   PURPOSE :  Change SMS status from MFW_SMS_UNREAD to MFW_SMS_READ

GW-SPR#779-Modified code to abort if status has already been updated or if no match is found

*/

T_MFW sms_change_read_status(SHORT index)
{
    SHORT i;
    //UBYTE fg;
    T_ACI_RETURN ret;
    TRACE_FUNCTION("sms_change_read_status()");

    fg = 0;
    for (i=0; i<MAX_MESSAGES; i++)
    {
        if (msg_info[i].index == index)
        {
            if ((msg_info[i].stat == MFW_SMS_UNREAD) ||
               (msg_info[i].stat == MFW_SMS_STOR_UNSENT))
            {
            	fg = 1;
            }
            else
            {
            	/* status is not unread/unsent - no need to change it*/
            	return (1);
            }
            /* Stop search as soon as the index matches */
            break;
        }
    }

/* This change is no completely right, because the SIM will be always updated,
but it makes possible that the read message doesn't come up as new every time
that the mobile is switched on.
GW - Replaced code that returns if no match is found
*/

    if (!fg)
    {
        TRACE_EVENT("sms_change_read_status No index match-ERROR");
        return 0;
    }

    sms_type = MFW_NO_MESSAGE;/* SPR 2260 Don't do anything scary in rAT_PlusCMGR callback func*/
/*CONQUEST 5991- MC- Changed third parameter in function call*/
    ret = sAT_PlusCMGR(CMD_SRC_LCL, (UBYTE)index, SMS_READ_StatusChange);

    if (ret NEQ AT_CMPL AND ret NEQ AT_EXCT)
    {
        TRACE_EVENT("sms_change_read_status ERROR");
        fg = 0;
        return 0;
    }
    /*CONQUEST 5991- MC- Added line to set current message to "read" status*/
    if ( msg_info[i].stat == MFW_SMS_STOR_UNSENT)
    	msg_info[i].stat = MFW_SMS_STOR_SENT;
    else
    	msg_info[i].stat = MFW_SMS_READ;//MC
    status_change_index = index;
    return 1;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_submit        |
+--------------------------------------------------------------------+

   PURPOSE :  Send a mobile originated short massage.

   GW 09/10/01 - Modified code to always copy entire (possible) message length
*/

#ifdef NO_ASCIIZ
T_MFW sms_submit(T_MFW_SMS_MO_TYPE type,
                 CHAR *dest_addr,
                 UBYTE *msg,
                 USHORT msg_len,
                 CHAR *sca)
#else
T_MFW sms_submit(T_MFW_SMS_MO_TYPE type,
                 CHAR *dest_addr,
                 UBYTE *msg,
                 USHORT msg_len,
                 CHAR *sca)
// sbh - added length to the above definition, since '@' characters stored as NULL & will stop
// strlen from working properly.
#endif
{

  T_SM_DATA_EXT		conc_data_ext;

  SHORT            rp;

  TRACE_FUNCTION ("sms_submit()");

  if (type == MFW_SMS_REPLY)
    rp = 0;   /* reply path = 0 */
  else
    rp = -1;  /* reply path = default */



conc_data_ext.len = msg_len;
conc_data_ext.data = msg;
  if (sAT_PlusCMGS(CMD_SRC_LCL, dest_addr, NULL, &conc_data_ext, sca, NULL, rp) NEQ AT_EXCT)
    return MFW_SMS_FAIL;


  flag = 0;
  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_stored_submit |
+--------------------------------------------------------------------+

   PURPOSE :  Send a stored mobile originated short massage.

*/

T_MFW sms_stored_submit(CHAR *dest_addr, UBYTE index)
{
  TRACE_FUNCTION ("sms_stored_submit()");

  if (sAT_PlusCMSS(CMD_SRC_LCL, index, dest_addr, NULL) NEQ AT_EXCT)
  {
    return MFW_SMS_FAIL;
  }
  storage_index = index;

  return MFW_SMS_OK;
}

/* glowing,2004-06-11, import from M188 */
/* 2004/4/26, wangyan add */
void sms_update_unsent_msg_info(T_MFW_SMS_STAT stat)
{
    int i;

    TRACE_FUNCTION("sms_update_msg_info()");

    for (i=0; i<MAX_MESSAGES; i++)
    {
        if (msg_info[i].index EQ storage_index)
        	{
            	msg_info[i].stat = stat;
				//MMI_TRACE_EVENT(("wangyan status_change_index=%d stat=%d",status_change_index,msg_info[i].stat));
        	}
    }

    storage_index = 0;
}
/* 2004/4/26, wangyan add */
/*glowing,2004-06-11, end of import */
/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCMSS      |
+--------------------------------------------------------------------+

   PURPOSE :  Response of Send a stored mobile originated
              short massage.

*/

void rAT_PlusCMSS (UBYTE mr, UBYTE numSeg)
{
    TRACE_FUNCTION ("rAT_PlusCMSS()");

    sms_update_msg_info(MFW_SMS_STOR_SENT);
    sms_signal(E_SMS_MO_AVAIL, &mr);

}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCMT       |
+--------------------------------------------------------------------+

   PURPOSE :  Receive a new short message.

*/

void rAT_PlusCMT(T_ACI_CMGL_SM*  sm)
{	T_SMS_TYPE received_sms_type;
	T_CONC_ASSEMBLY_RETURN concatenated_status;
	T_SM_DATA_EXT conc_data_ext;
	int i;
  TRACE_FUNCTION ("rAT_PlusCMT()");

  TRACE_EVENT_P1("CMT, sm->data.len: %d", sm->data.len);


  received_sms_type = SMS_getSMSType( &sm->udh);

  if (received_sms_type == CONCATE)
  {
		concatenated_status =concSMS_Collect(&conc_data_ext, sm, FALSE);
	TRACE_EVENT_P2("conc status: %d, conc length: %d", concatenated_status, conc_data_ext.len);
	for(i=0;i<conc_data_ext.len;i++)
		{
			TRACE_EVENT_P2("%02x, %c", conc_data_ext.data[i],conc_data_ext.data[i]);
		}
		switch (concatenated_status)
		{
			case CONC_ERR_UNKN:
				TRACE_EVENT("Concatenated SMS error");break;
			case CONC_ERR_BUF_FULL:
				TRACE_EVENT("Concatented SMS buffer Full Error");break;
			case CONC_CONTINUED: //not last SMS
				TRACE_EVENT("Concatenated Continued!");
				break;
			case CONC_COMPLETED:
			{
				  TRACE_EVENT("COncatenation Completed!");
				  memset(&sms_mt, 0, sizeof(sms_mt));

#ifdef NO_ASCIIZ
				  memcpy(sms_mt.orig_addr.tag,
				         sm->alpha.data,
				         sm->alpha.len);
				  sms_mt.orig_addr.len = sm->alpha.len;
#else
				  phb_Alpha2Gsm(sm->alpha, (UBYTE *)sms_mt.orig_addr.tag);
#endif
				  strcpy(sms_mt.orig_addr.number, sm->adress);
				  sms_mt.orig_addr.ton =
				      phb_cvtTon(sm->toa.ton);
				  sms_mt.orig_addr.npi =
				      phb_cvtNpi(sm->toa.npi);
				  if (sm->tosca.ton == TON_International)
				    sprintf(sms_mt.sc_addr, "+%s", sm->sca);
				  else
				    strcpy(sms_mt.sc_addr, sm->sca);
				  sms_mt.prot_id = (UBYTE)sm->pid;
				  sms_mt.dcs     = (UBYTE)sm->dcs & 0xFC;	/* Ignore message class */

				  sms_mt.rp      = sm->fo >> 7 & 1;

				/* SBH */
				if (sm->dcs & 0x10)		/* Bit 5 indicates that we should get message class from bits 0 & 1 */
				{
					sms_mt.ti = sm->dcs & 3;
				}
				else					/* Otherwise, set to default value */
				{
					sms_mt.ti = 1;
				}
				TRACE_EVENT_P2("dcs: %d, ti: %d", sms_mt.dcs, sms_mt.ti);
				/* SBH end */

				  memcpy((char *)sms_mt.sctp.year, (char *)sm->scts.year, MAX_SCTP_DIGITS);
				  memcpy((char *)sms_mt.sctp.month, (char *)sm->scts.month, MAX_SCTP_DIGITS);
				  memcpy((char *)sms_mt.sctp.day, (char *)sm->scts.day, MAX_SCTP_DIGITS);
				  memcpy((char *)sms_mt.sctp.hour, (char *)sm->scts.hour, MAX_SCTP_DIGITS);
				  memcpy((char *)sms_mt.sctp.minute, (char *)sm->scts.minute, MAX_SCTP_DIGITS);
				  memcpy((char *)sms_mt.sctp.second, (char *)sm->scts.second, MAX_SCTP_DIGITS);
				  sms_mt.sctp.timezone = sm->scts.timezone;

				/* copy length of whole concat SMS*/
				  sms_mt.msg_len = conc_data_ext.len;
				  memset(sms_mt.sms_msg, 0, sm->data.len);
				/*copy all data from concat SMS*/
				  memcpy(sms_mt.sms_msg, (char*)conc_data_ext.data, conc_data_ext.len);
				  sms_mt.udh_len = sm->udh.len;
				  memcpy((char *)sms_mt.udh, (char *)sm->udh.data, sm->udh.len);
		
				  /*SPR#1408 - DS - Now done at end of function
				   *sms_signal(E_SMS_MT, &sms_mt);
				   */

  			}

  		}
  	}
  else
  {

		
	  memset(&sms_mt, 0, sizeof(sms_mt));

#ifdef NO_ASCIIZ
	  memcpy(sms_mt.orig_addr.tag,
	         sm->alpha.data,
	         sm->alpha.len);
	  sms_mt.orig_addr.len = sm->alpha.len;
#else
	  phb_Alpha2Gsm(sm->alpha, (UBYTE *)sms_mt.orig_addr.tag);
#endif
	  strcpy(sms_mt.orig_addr.number, sm->adress);
	  sms_mt.orig_addr.ton =
	      phb_cvtTon(sm->toa.ton);
	  sms_mt.orig_addr.npi =
	      phb_cvtNpi(sm->toa.npi);
	  if (sm->tosca.ton == TON_International)
	    sprintf(sms_mt.sc_addr, "+%s", sm->sca);
	  else
	    strcpy(sms_mt.sc_addr, sm->sca);
	  sms_mt.prot_id = (UBYTE)sm->pid;
	  sms_mt.dcs     = (UBYTE)sm->dcs & 0xFC;	/* Ignore message class */
	  sms_mt.rp      = sm->fo >> 7 & 1;
	/* PATCH JPS 04.10 END */

	/* SBH */
	if (sm->dcs & 0x10)		/* Bit 5 indicates that we should get message class from bits 0 & 1 */
	{
		sms_mt.ti = sm->dcs & 3;
	}
	else					/* Otherwise, set to default value */
	{
		sms_mt.ti = 1;
	}
	TRACE_EVENT_P2("dcs: %d, ti: %d", sms_mt.dcs, sms_mt.ti);
	/* SBH end */

	  memcpy((char *)sms_mt.sctp.year, (char *)sm->scts.year, MAX_SCTP_DIGITS);
	  memcpy((char *)sms_mt.sctp.month, (char *)sm->scts.month, MAX_SCTP_DIGITS);
	  memcpy((char *)sms_mt.sctp.day, (char *)sm->scts.day, MAX_SCTP_DIGITS);
	  memcpy((char *)sms_mt.sctp.hour, (char *)sm->scts.hour, MAX_SCTP_DIGITS);
	  memcpy((char *)sms_mt.sctp.minute, (char *)sm->scts.minute, MAX_SCTP_DIGITS);
	  memcpy((char *)sms_mt.sctp.second, (char *)sm->scts.second, MAX_SCTP_DIGITS);
	  sms_mt.sctp.timezone = sm->scts.timezone;

	  sms_mt.msg_len = sm->data.len;
	  memcpy(sms_mt.sms_msg, (char *)sm->data.data, sm->data.len);
	  sms_mt.udh_len = sm->udh.len;
	  memcpy((char *)sms_mt.udh, (char *)sm->udh.data, sm->udh.len);
	  
	  /*SPR#1408 - DS - Now done at end of function
	    *sms_signal(E_SMS_MT, &sms_mt);
	    */
  	}
  
  /*MC SPR 1364, need to call this function to update CPHS voicemail data*/ 
 /*SPR#1408 - DS - Modified to store voicemail status in SMS structure. Port of 1669 */
  if (sms_check_voice_mail(sm->pid, sm->dcs, sm->adress,
           &sm->toa, &sm->udh) == MFW_SMS_VOICE)
  {
	sms_mt.voicemail = TRUE;
	TRACE_EVENT("MT SMS is a voicemail message");
  }
  else
  {
	sms_mt.voicemail = FALSE;
  }
  sms_signal(E_SMS_MT, &sms_mt);
  
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCMTI      |
+--------------------------------------------------------------------+

   PURPOSE :  Receive a new short message identifier.

*/

void rAT_PlusCMTI(T_ACI_SMS_STOR mem, UBYTE index, T_ACI_CMGL_SM* sm)
{
/* MZ 2260 Handset displays Message Full on receiving an SMS. */
  //T_MFW_MEM_INFO memory;
  T_ACI_RETURN ret;
  T_SMS_TYPE received_sms_type;
  T_CONC_ASSEMBLY_RETURN concatenated_status;
  T_SM_DATA_EXT conc_data_ext;
  int i, j;

#if (_PUSH_DETECT_ENABLE_ == 1)
	UBYTE *push_data, push_msg_flag = 0;
	USHORT	push_data_len;
	T_PUSH_MERGE 	*mergeBuf_slot;
	T_PUSH_SEGBUF	*segbuf_slot;
#endif
  

 if (initialising_flag == FALSE)
  	{
  		/* Ignore CMTI if initialising */

	#if (_PUSH_DETECT_ENABLE_ == 1)
		PUSH_DET_TRACE(("Robert:rAT_PlusCMTI() idx=%d, uL=%d, dL=%d", sm->msg_ref, sm->udh.len, sm->data.len));
		
		if(sm->udh.len > 0) /* is not a normal SM */
		{
			push_msg_flag = udh_adjust(sm->msg_ref, sm);
		#ifdef _INNOVATION_EMULATOR_
			if(sm->udh.len > 0)
			{
				if(sm->udh.data[0] == 0 || sm->udh.data[0] == 0x08)
					received_sms_type = CONCATE;
			}
			else
				received_sms_type = NORMAL;
		#else
			received_sms_type = SMS_getSMSType(&sm->udh);		
		#endif	

			if(push_msg_flag)
			{
				if(received_sms_type == CONCATE)
					concatenated_status = push_merge_sms(sm, &mergeBuf_slot);

				if((received_sms_type == CONCATE && concatenated_status == MERGE_STA_COMPLETE)
				   || (received_sms_type != CONCATE))
				{
					if(received_sms_type != CONCATE)
					{
						push_data		= sm->data.data;				
						push_data_len	= sm->data.len;					
					}	
					else
					{
						push_data		= mergeBuf_slot->data;
						push_data_len	= mergeBuf_slot->len;					
					}
					
					if((push_data = push_appli_dispatch(push_data, &push_data_len, push_data_len)) != NULL)
					{
						PUSH_DET_TRACE(("rAT_PlusCMTI():write push msg to FFS:len=%d,DP=%d!", push_data_len, (UINT32)push_data));

						MMS_SI_ind(push_data, push_data_len, sm->msg_ref);
	            	}
	            	else
	            	{
	            		if(received_sms_type != CONCATE)
		            		ffs_fwrite("/mmi/pusherr", push_data, sm->data.len);
		            	else
		            		ffs_fwrite("/mmi/pusherr", push_data, mergeBuf_slot->len);
		            		
	            		PUSH_DET_TRACE(("rAT_PlusCMTI():receive a port address message, but nott a MMS PUSH!"));
	            	}

	            	/* release merge buffer */
	            	if(received_sms_type == CONCATE)
	            	{
		            	segbuf_slot = push_sbuf_getSlot(mergeBuf_slot->ref_num);
		            	push_sbuf_clear(segbuf_slot, 0, 0xff);
		            	push_mbuf_clear(mergeBuf_slot, 0, 0xff);
	            	}
				}
				
				return;
			}		
		}
	#endif	//_PUSH_DETECT_ENABLE_
  		 	

	  TRACE_FUNCTION ("rAT_PlusCMTI()");
	  TRACE_EVENT_P1("f_update is = % in CMTI", f_update);

	  received_sms_type = SMS_getSMSType( &sm->udh);
	  TRACE_EVENT_P1("SMS Type is = %d", received_sms_type);
	  TRACE_EVENT_P2("msg_ref: %d, index: %d", sm->msg_ref, index);
 

	  if (received_sms_type == CONCATE)
		  {
		  if(initialising_flag == TRUE)
		  	concatenated_status =concSMS_Collect(&conc_data_ext, sm, FALSE);
		  else
			concatenated_status =concSMS_Collect(&conc_data_ext, sm, TRUE);
			TRACE_EVENT_P2("conc status: %d, conc length: %d", concatenated_status, conc_data_ext.len);

		 
		  
		  }

	    sms_store_new_msg_info(index,sm,TRUE, concatenated_status);

	  if (f_update EQ MFW_SMS_UPDATE OR
	    coll_sms_send EQ MFW_SMS_WAIT OR
	    coll_sms_read EQ MFW_SMS_WAIT OR
	    coll_sms_delete EQ MFW_SMS_WAIT OR
	    coll_sms_req EQ MFW_SMS_WAIT)
		{
			if (sms_id_wait.index <= 0)
			{
				sms_id_wait.index = index;
				sms_id_wait.mem = (mem EQ SMS_STOR_Me)? MFW_MEM_ME: MFW_MEM_SIM;
				sms_id_wait.concat_status = concatenated_status;
				sms_id_wait.received_sms_type = received_sms_type;
			}
			else
			{
				TRACE_EVENT("Indication Overrun");
			}
		  f_update = MFW_SMS_UPDATE;
		}
	  else
	  {
	  	sms_send_new_msg_ind(sm,index, mem, received_sms_type, concatenated_status);
	  }
     f_update = MFW_SMS_FREE;
     /* glowing,2004-06-10, import from TCS2112 */
     if(memory.total == memory.used)
  	{
  		TRACE_EVENT_P2("memory used is = %d, of %d", memory.used, memory.total);
  		sms_signal(E_SMS_MEM_FULL, NULL);
  	} 
     /* glowing,2004-06-10, end of import */
  	}
 	
  {
	TRACE_EVENT_P4("CMTI Msg table: %d,%d,%d, %d", msg_info[0].index, msg_info[1].index,msg_info[2].index,msg_info[3].index);
	TRACE_EVENT_P4("CMTI Msg table: %d,%d,%d, %d", msg_info[4].index, msg_info[5].index,msg_info[6].index,msg_info[7].index);
}
/*MC SPR 1364, need to call this function to update CPHS voicemail data*/ 
  	 sms_check_voice_mail(sm->pid, sm->dcs, sm->adress,
                                       &sm->toa, &sm->udh);
 /*SPR 2260, this is already called in sms_store_new_msg_info, BUT we need it in for initialisation*/
}

/*
+------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS               |
| STATE   : code                         ROUTINE : find_slot_in_msg_info |
+------------------------------------------------------------------------+

   PURPOSE :  Find a slot in msg_info for the index of the SMS supplied

*/

static int find_slot_in_msg_info(UBYTE index, UBYTE update_mem)
{
    int ret = -1;
    int i;

    TRACE_FUNCTION("find_slot_in_msg_info");
    
    if (index >= 1)
    {
        /* A valid index, so look for it already being in msg_info */
        for (i = 0; (i < MAX_MESSAGES) && (ret == -1); i++)
        {
            if (msg_info[i].index == index)
            {
                /* Index already in msg_info, so replace */
                ret = i;
            }
        }

        if (ret == -1)
        {
            /* Index was not already in msg_info, so look for unused slot */
            for (i = 0; (i < MAX_MESSAGES) && (ret == -1); i++)
            {
                if (msg_info[i].index == -1)
                {
                    /* First unused slot in msg_info found */
                    ret = i;
               		if (update_mem)
            			memory.used++;
               }
            }
        }
    }

    TRACE_EVENT_P1("find_slot_in_msg_info returning %d", ret);

    return ret;
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_store_new_msg_info |
+--------------------------------------------------------------------+

   PURPOSE :  Store message information

*/

T_MFW sms_store_new_msg_info(UBYTE index, T_ACI_CMGL_SM* sm, UBYTE update_mem, T_CONC_ASSEMBLY_RETURN conc_stat)
{
  int j;
  T_SMS_TYPE received_sms_type;
  T_CONC_ASSEMBLY_RETURN concatenated_status;
  T_SM_DATA_EXT conc_data_ext;
 int i;


  TRACE_EVENT("sms_store_new_msg_info");
  
  sms_type = MFW_SMS_MESSAGE;
 
    if ((j = find_slot_in_msg_info(index, update_mem)) != -1)
	{
	    received_sms_type = SMS_getSMSType(&sm->udh);
	    TRACE_EVENT_P1("SMS Type is = %d", received_sms_type);
	 	

	
			/*SPR 2260*/
		  if (received_sms_type == CONCATE)
		  {	 
/* glowing,2004-06-11, import from TCS2112 */		   	 	
	   	  	if (conc_stat == CONC_COMPLETED)
		   	{	/*replace index withat of first message*/
		   		index = concSMS_GetFirstIndex(concSMS_GetMsgRef ( sm ), sm->adress);
				msg_info[j].concat_status = MFW_SMS_CONC_WHOLE;
				TRACE_EVENT("Setting to WHOLE");
						
		   	 }
		   	 else /*otherwise leave index as it is*/
		   	 {	 /*check if message already complete*/
  				for (i=0; i<MAX_MESSAGES; i++)
				{	if (msg_info[i].index != -1)
					{	if (msg_info[i].first_index == concSMS_GetFirstIndex(concSMS_GetMsgRef ( sm ), sm->adress)
						&& msg_info[i].concat_status == MFW_SMS_CONC_WHOLE)
							return;/*don't bother copying this message into the table*/
					}
				}
						
		   	  msg_info[j].concat_status = MFW_SMS_CONC_PART;
		   	  TRACE_EVENT("Setting to PART");
		   	  }
		   	 
		   	  TRACE_EVENT_P1("index = %d",index);

		   	  msg_info[j].first_index =concSMS_GetFirstIndex(concSMS_GetMsgRef ( sm ), sm->adress);
		   	  	
	   	  		
		  		/*if complete SMS, delete old fragments*/
		  		if (conc_stat == CONC_COMPLETED)
		  		for (i=0; i<MAX_MESSAGES; i++)
		   	  	{	
					if (msg_info[i].index != -1)
					{
			   	  		if (msg_info[i].first_index == concSMS_GetFirstIndex(concSMS_GetMsgRef ( sm ), sm->adress)
			   	  	&& msg_info[i].concat_status==MFW_SMS_CONC_PART)
						{	TRACE_EVENT_P1("Deleting index number:%d", msg_info[i].index);
			  				delete_sms_from_table(msg_info[i].index);;
			  			}
					}
		  			
		  	  	}
		  }
		  else
		  {	msg_info[j].first_index = 0xFF;/*invalid index*/
		  	msg_info[j].concat_status = MFW_SMS_NO_CONC;
		  	TRACE_EVENT("Setting to NO CONC");
		  }
	
/* glowing,2004-06-11, end of import */	   	
   	    sm->index = index;
   		msg_info[j].index = index;

		msg_info[j].stat = sms_decodeStatus(sm->stat);
		strcpy((char *)msg_info[j].addr.number, sm->adress);
		msg_info[j].addr.ton = phb_cvtTon(sm->toa.ton);
		msg_info[j].addr.npi = phb_cvtNpi(sm->toa.npi);


#ifdef NO_ASCIIZ
			memcpy(msg_info[j].addr.tag, 
			sm->alpha.data, 
			sm->alpha.len);
			msg_info[j].addr.len = sm->alpha.len;
#else
			phb_Alpha2Gsm(&sm->alpha, 
			(UBYTE *)msg_info[j].addr.tag);
#endif

		memcpy(&msg_info[j].rctp, &sm->scts, sizeof(T_MFW_SMS_SCTP));

		// check voice mail status
		if (sms_check_voice_mail(sm->pid, sm->dcs, sm->adress,
		    &sm->toa, &sm->udh) EQ MFW_SMS_VOICE)
		    msg_info[j].msg_type = MFW_SMS_VOICE;
		else
		    msg_info[j].msg_type = MFW_SMS_NotVOICE;

		coll_sms_read = MFW_SMS_FREE;
        f_update = MFW_SMS_FREE;
        TRACE_EVENT_P1("UDH Length is = %d", sm->udh.len);
    }
    /*SPR 2260, check if memory full*/
    TRACE_EVENT_P2("memory used is = %d, of %d", memory.used, memory.total);
    if(memory.total == memory.used)
  	{
  		
  		sms_signal(E_SMS_MEM_FULL, NULL);
  	}  
}



/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_stored_submit |
+--------------------------------------------------------------------+

   PURPOSE :  Send a new message indication to the MMI

*/

T_MFW sms_send_new_msg_ind(T_ACI_CMGL_SM* sm,UBYTE index, UBYTE mem, UBYTE received_sms_type, UBYTE concatenated_status)
{
	TRACE_FUNCTION("sms_send_new_msg_ind");

	if (received_sms_type == CONCATE)
	{
		switch (concatenated_status)
		{
			case CONC_ERR_UNKN:
			TRACE_EVENT("Concatenated SMS error");break;
			case CONC_ERR_BUF_FULL:
			TRACE_EVENT("Concatented SMS buffer Full Error");break;
			case CONC_CONTINUED: //not last SMS
			TRACE_EVENT("Concatenation Continued");
			break;
			case CONC_COMPLETED:
			{
				TRACE_EVENT("Concatenation Completed");
				memset(&sms_mt, 0, sizeof(sms_mt));
                /* glowing,2004-06-11, import from TCS2112 */
				/*SPR 2260*/
 	 			if (sms_check_voice_mail(sm->pid, sm->dcs, sm->adress,
                &sm->toa, &sm->udh) == MFW_SMS_VOICE)
                  	sms_mt.voicemail = TRUE;
  	 			else
  	 				sms_mt.voicemail = FALSE;
                /* glowing,2004-06-11, end of import */
				if(initialising_flag == TRUE)
					sms_signal(E_SMS_MT, &sms_mt);
				else
					sms_signal(E_SMS_MT_RECEIVED, &sms_mt);
			}
		}
	}
	else
	{
		memset(&sms_mt, 0, sizeof(sms_mt));

		if(initialising_flag == TRUE)
		sms_signal(E_SMS_MT, &sms_mt);
		else
		sms_signal(E_SMS_MT_RECEIVED, &sms_mt);
	}
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCBM       |
+--------------------------------------------------------------------+

   PURPOSE :  Receive a new cell broadcast message.

*/

void rAT_PlusCBM(SHORT           sn,
                 SHORT           mid,
                 SHORT           dcs,
                 UBYTE           page,
                 UBYTE           pages,
                 T_ACI_CBM_DATA* data)
{
  TRACE_FUNCTION ("rAT_PlusCBM()");

  /* copy parameter */
  sms_cb.sn     = sn;
  sms_cb.msg_id = mid;
  sms_cb.dcs    = (UBYTE)dcs;
  sms_cb.page   = page;
  sms_cb.pages  = pages;
  sms_cb.msg_len = data->len;
  memcpy((char *)sms_cb.cb_msg, (char *)data->data, data->len);

  /* send cell broadcast message event */
  sms_signal(E_SMS_CB, &sms_cb);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCBMI      |
+--------------------------------------------------------------------+

   PURPOSE :  Receive a new cell broadcast message identifier.

*/

void rAT_PlusCBMI(T_ACI_SMS_STOR mem, UBYTE index)
{
  TRACE_EVENT ("rAT_PlusCBMI()");

  switch ( mem )
  {
    case ( SMS_STOR_Me ):
        sms_id.mem = MFW_MEM_ME;
        break;
    case ( SMS_STOR_Sm ):
        sms_id.mem = MFW_MEM_SIM;
        break;
    default:
        break;
  }

  sms_id.index = index;

  /* send a short message identifier event */
  sms_signal(E_SMS_CB_RECEIVED, &sms_id);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCDS       |
+--------------------------------------------------------------------+

   PURPOSE :  Receive a status report message.

*/

void rAT_PlusCDS(T_ACI_CDS_SM *st)
{
  T_MFW_SMS_STATUS sms_status;
  T_MFW_PHB_ENTRY  phb_entry;
  T_MFW_PHB_LIST   phb_list;
  UBYTE            phb_index;
#ifdef NO_ASCIIZ
  T_MFW_PHB_TEXT  findText;
#endif

  TRACE_FUNCTION ("rAT_PlusCDS()");

  memset(&phb_entry, 0, sizeof(phb_entry));
  memset(&phb_list, 0, sizeof(phb_list));
  phb_list.entry = &phb_entry;

  sms_status.msg_id  = 0x03 & (UBYTE)st->fo;
  sms_status.msg_ref = st->msg_ref;
  strcpy(sms_status.addr.number, st->addr);
  sms_status.addr.ton = phb_cvtTon(st->toa.ton);
  sms_status.addr.npi = phb_cvtNpi(st->toa.npi);

#ifdef NO_ASCIIZ
  strcpy((char *)findText.data, st->addr);
  findText.len = (UBYTE)strlen(st->addr);
  if (phb_find_entries  (PHB_ADN,   &phb_index,
                         MFW_PHB_NUMBER,
                         1, &findText,
                         &phb_list) EQ MFW_PHB_OK)
  {
    if (phb_list.num_entries)
    {
      memcpy(sms_status.addr.tag,
             phb_list.entry->name.data,
             phb_list.entry->name.len);
      sms_status.addr.len = phb_list.entry->name.len;
    }
  }
#else
  if (phb_find_entries  (PHB_ADN,	&phb_index,
                         MFW_PHB_NUMBER,
                         1,
                         st->ra,
                         &phb_list) EQ MFW_PHB_OK)
  {
    if (phb_list.num_entries)
    {
      strcpy((char *)sms_status.addr.tag, (char *)phb_list.entry->name);
    }
  }
#endif

  sms_status.status  = st->tp_status;

  memcpy((char *)sms_status.rctp.year, (char *)st->vpabs_scts.year, MAX_SCTP_DIGITS);
  memcpy((char *)sms_status.rctp.month, (char *)st->vpabs_scts.month, MAX_SCTP_DIGITS);
  memcpy((char *)sms_status.rctp.day, (char *)st->vpabs_scts.day, MAX_SCTP_DIGITS);
  memcpy((char *)sms_status.rctp.hour, (char *)st->vpabs_scts.hour, MAX_SCTP_DIGITS);
  memcpy((char *)sms_status.rctp.minute, (char *)st->vpabs_scts.minute, MAX_SCTP_DIGITS);
  memcpy((char *)sms_status.rctp.second, (char *)st->vpabs_scts.second, MAX_SCTP_DIGITS);
  sms_status.rctp.timezone = st->vpabs_scts.timezone;

  /* send status report message event */
  sms_signal(E_SMS_STATUS, &sms_status);
}


/*
+------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)      MODULE  : MFW_SMS            |
| STATE   : code                      ROUTINE : sms_set_pref_memory|
+------------------------------------------------------------------+

   PURPOSE :  Set preferred message storage.

*/

T_MFW sms_set_pref_memory(UBYTE mem)
{
  TRACE_FUNCTION ("sms_set_pref_memory()");

int_init_req = FALSE;

  if (sAT_PlusCPMS(CMD_SRC_LCL,
                   sms_mem_cvt(mem),
                   sms_mem_cvt(mem),
                   sms_mem_cvt(mem)) NEQ AT_EXCT)
    return MFW_SMS_FAIL;
  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_read          |
+--------------------------------------------------------------------+

   PURPOSE :  Read a SMS message.

*/

T_MFW sms_read(UBYTE type, UBYTE index)
{
  TRACE_EVENT_P1("sms_read():%d",index);

  coll_sms_read = MFW_SMS_WAIT;

  if (sAT_PlusCMGR(CMD_SRC_LCL, index, SMS_READ_Preview) NEQ AT_EXCT)
    return MFW_SMS_FAIL;
  /*SPR 2260, set sms type so we get event from rAT_plusCMGR*/
  sms_type = MFW_SMS_MESSAGE;

  flag = index;
  memset(&sms_mt, 0, sizeof(sms_mt));
  sms_mt.index = index;
  cmgr_awaiting_ok = FALSE; // Marcus: Issue 2260: 03/10/2002

  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : rAT_PlusCMGR      |
+--------------------------------------------------------------------+


   PURPOSE :  Call back for read message.

*/

void rAT_PlusCMGR(T_ACI_CMGL_SM  * sm, T_ACI_CMGR_CBM * cbm)
{
  T_ACI_RETURN ret;
  T_SMS_TYPE received_sms_type;
  T_CONC_ASSEMBLY_RETURN concatenated_status;
  T_SM_DATA_EXT conc_data_ext;
  char debug[20];
  int j, s = 0;

  UBYTE decoded_dcs;


  TRACE_FUNCTION ("rAT_PlusCMGR()");

  TRACE_EVENT_P2("messagepointer:%d, Cellbroadcast pointer:%d", sm, cbm);

  cmgr_awaiting_ok = TRUE; // Marcus: Issue 2260: 03/10/2002

  switch (sms_type)
  {
    case MFW_SMS_MESSAGE:
    {	if (sm != NULL)  /*SPR2260 make sure we have a valid pointer*/
      	{   switch (0x03 & sm->fo)
	      {
	        case 0x00:
	        { USHORT conc_msg_ref;
	          UBYTE conc_index;
	          int i;/*SPR2260*/
			  BOOL continue_flag=FALSE;/*SPR2260*/
	          TRACE_EVENT_P1("UDH Length is = %d", sm->udh.len);
	    	received_sms_type = SMS_getSMSType( &sm->udh);
			TRACE_EVENT_P1("SMS Type is = %d", received_sms_type);
  		
	  		if (received_sms_type == CONCATE)
	  		{
			  concatenated_status =concSMS_Collect(&conc_data_ext, sm, FALSE);
			  TRACE_EVENT_P2("conc status: %d, conc length: %d", concatenated_status, conc_data_ext.len);
	  		}
	  		
	       

		  	  if (received_sms_type == CONCATE)
		      {
				switch (concatenated_status)
				{
				  
				  case CONC_ERR_BUF_FULL:
				    TRACE_EVENT("Concatented SMS buffer Full Error");
				     sms_signal(E_SMS_ERR, NULL);
					break;
				case CONC_ERR_UNKN:
				    TRACE_EVENT("Concatenated SMS error");
				  case CONC_CONTINUED: //not last SMS
				  	TRACE_EVENT("Concatenation Continued");
					/*SPR 2260*/
	                cmgr_awaiting_ok = FALSE; // Marcus: Issue 2260: 03/10/2002
					
					/*if the index exists in the message table, process the message*/
					for (i=0; i <MAX_MESSAGES;i++)
						if (msg_info[i].index == sm->msg_ref && msg_info[i].concat_status == MFW_SMS_CONC_PART)
							continue_flag = TRUE;
					if (!continue_flag)
						break;
				  
				  case CONC_COMPLETED:
				  {
				    TRACE_EVENT("Concatenation Completed");
					memset(&sms_mt, 0, sizeof(sms_mt));
					conc_msg_ref =concSMS_GetMsgRef ( sm );
					conc_index = concSMS_GetFirstIndex(conc_msg_ref, sm->adress);

#ifdef NO_ASCIIZ
					memcpy(sms_mt.orig_addr.tag,
						         sm->alpha.data,
						         sm->alpha.len);
					sms_mt.orig_addr.len = sm->alpha.len;
#else
					phb_Alpha2Gsm(sm->alpha, (UBYTE *)sms_mt.orig_addr.tag);
#endif
					strcpy(sms_mt.orig_addr.number, sm->adress);
					sms_mt.orig_addr.ton =
						      phb_cvtTon(sm->toa.ton);
				    sms_mt.orig_addr.npi =
						      phb_cvtNpi(sm->toa.npi);
					if (sm->tosca.ton == TON_International)
					  sprintf(sms_mt.sc_addr, "+%s", sm->sca);
					else
					  strcpy(sms_mt.sc_addr, sm->sca);
					sms_mt.prot_id = (UBYTE)sm->pid;
					sms_mt.dcs     = (UBYTE)sm->dcs & 0xFC;	/* Ignore message class */

					/*MC SPR 2260, message index should be set to that of first index in
					concatenated message if this is a complete message*/
					if (concatenated_status == CONC_COMPLETED)
						sms_mt.index = conc_index;
					else
						sms_mt.index = sm->msg_ref;

					sms_mt.rp      = sm->fo >> 7 & 1;

					/* SBH */
					if (sm->dcs & 0x10)		/* Bit 5 indicates that we should get message class from bits 0 & 1 */
					{
						sms_mt.ti = sm->dcs & 3;
					}
					else					/* Otherwise, set to default value */
					{
						sms_mt.ti = 1;
					}
					/* SBH end */
					
					memcpy((char *)sms_mt.sctp.year, (char *)sm->scts.year, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.month, (char *)sm->scts.month, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.day, (char *)sm->scts.day, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.hour, (char *)sm->scts.hour, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.minute, (char *)sm->scts.minute, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.second, (char *)sm->scts.second, MAX_SCTP_DIGITS);
					sms_mt.sctp.timezone = sm->scts.timezone;
						  
					/* copy length of whole concat SMS*/
					if (conc_data_ext.len > MAX_MSG_LEN)
					  sms_mt.msg_len = MAX_MSG_LEN;
					else
					  sms_mt.msg_len = conc_data_ext.len;
					/*copy all data from concat SMS*/
									/*SPR 2260*/
		         	if (sm->stat == SMS_STAT_Invalid)
						memset(sms_mt.sms_msg, NULL, MAX_MSG_LEN_ARRAY);
		         	else /*SPR2260 */
					{	if (concatenated_status == CONC_COMPLETED)
				    	{	memcpy(sms_mt.sms_msg, (char*)conc_data_ext.data, sms_mt.msg_len);}
				    	else/*copy data from sm pointer if message not complete*/
				    	{	memcpy(sms_mt.sms_msg, (char*)sm->data.data, sm->data.len);
							sms_mt.msg_len = sm->data.len;
						}
		         	}
					/* Free memory allocated by the ACI */
					MFREE(conc_data_ext.data);
					sms_mt.udh_len = sm->udh.len;
					memcpy((char *)sms_mt.udh, (char *)sm->udh.data, sm->udh.len);
					
				  /*MC SPR 2260, need to call this function to update CPHS voicemail data*/ 
  	 				if (sms_check_voice_mail(sm->pid, sm->dcs, sm->adress,
                                       &sm->toa, &sm->udh) == MFW_SMS_VOICE)
                  		sms_mt.voicemail = TRUE;
  	 				else
  	 					sms_mt.voicemail = FALSE;
  	 				
	          			  sms_type = MFW_NO_MESSAGE;

	          			  coll_sms_read = MFW_SMS_FREE;
	         			  sms_signal(E_SMS_MT, &sms_mt);
//zkc add 07/23/04
#ifdef MMI_PCSYN_ENABLED
					Waitdata_getsms(&sms_mt,MFW_SMS_MT,MFW_SMS_OK);//
#endif
//
						}
					}
		  		}
				else
				{
#ifdef NO_ASCIIZ
					memcpy(sms_mt.orig_addr.tag,
		            	     sm->alpha.data,
		                	 sm->alpha.len);

					sms_mt.orig_addr.len = sm->alpha.len;
#else
					phb_Alpha2Gsm(&sm->alpha, (UBYTE *)sms_mt.orig_addr.tag);
#endif

					if (sm->toa.ton == TON_International)
						sprintf(sms_mt.orig_addr.number, "+%s", sm->adress);
					else	
						strcpy(sms_mt.orig_addr.number, sm->adress);

					sms_mt.orig_addr.ton = phb_cvtTon(sm->toa.ton);
					sms_mt.orig_addr.npi = phb_cvtNpi(sm->toa.npi);
		          
					if (sm->tosca.ton == TON_International)
						sprintf(sms_mt.sc_addr, "+%s", sm->sca);
					else
						strcpy(sms_mt.sc_addr, sm->sca);
		          
					sms_mt.prot_id = (UBYTE)sm->pid;
					sms_mt.dcs     = (UBYTE)sm->dcs & 0xFC;	/* Ignore message class */
					sms_mt.rp		 = sm->fo >> 7 & 1;

					// PATCH JPS 04.10 END
					/* SBH */
					if (sm->dcs & 0x10)		/* Bit 5 indicates that we should get message class from bits 0 & 1 */
					{
						sms_mt.ti = sm->dcs & 3;
					}
					else					/* Otherwise, set to default value */
					{
						sms_mt.ti = 1;
					}
					/* SBH end */

					TRACE_EVENT_P2("dcs: %d, ti: %d", sms_mt.dcs, sms_mt.ti);
					
					memcpy((char *)sms_mt.sctp.year, (char *)sm->scts.year, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.month, (char *)sm->scts.month, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.day, (char *)sm->scts.day, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.hour, (char *)sm->scts.hour, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.minute, (char *)sm->scts.minute, MAX_SCTP_DIGITS);
					memcpy((char *)sms_mt.sctp.second, (char *)sm->scts.second, MAX_SCTP_DIGITS);
					sms_mt.sctp.timezone = sm->scts.timezone;
					sms_mt.msg_len = sm->data.len;
					TRACE_EVENT_P2("msg_len %d, data.len %d", sms_mt.msg_len, sm->data.len);
				/*SPR 2260, if invalid message just set text to NULL*/
		         if (sm->stat == SMS_STAT_Invalid)
					memset(sms_mt.sms_msg, NULL, MAX_MSG_LEN_ARRAY);
		         else
				 {
				  	memcpy(sms_mt.sms_msg, (char*)sm->data.data, sm->data.len);
					sms_mt.msg_len = sm->data.len;
				  
				 }
		         /*SPR 2260 end*/
					sms_mt.udh_len = sm->udh.len;
					memcpy((char *)sms_mt.udh, (char *)sm->udh.data, sm->udh.len);
					sms_type = MFW_NO_MESSAGE;
					TRACE_EVENT("read=free1");
					coll_sms_read = MFW_SMS_FREE;
					
				  /*MC SPR 2260, need to call this function to update CPHS voicemail data*/ 
  	 				if (sms_check_voice_mail(sm->pid, sm->dcs, sm->adress,
                                       &sm->toa, &sm->udh) == MFW_SMS_VOICE)
                  		sms_mt.voicemail = TRUE;
  	 				else
  	 					sms_mt.voicemail = FALSE;
					sms_signal(E_SMS_MT, &sms_mt);
//zkc add 07/23/04
#ifdef MMI_PCSYN_ENABLED
				Waitdata_getsms(&sms_mt,MFW_SMS_MT,MFW_SMS_OK);//
#endif
//

				}
	        }
	          break;

	        case 0x01:
	        	{	 int i;/*SPR2260*/
			  		BOOL continue_flag=FALSE;
					USHORT conc_msg_ref;/*SPR 2260*/
	          		UBYTE conc_index;
			  		
	        	received_sms_type = SMS_getSMSType( &sm->udh);
			  	TRACE_EVENT_P1("SMS Type is = %d", received_sms_type);
	  			if (received_sms_type == CONCATE)
		  		{
					concatenated_status =concSMS_Collect(&conc_data_ext, sm, FALSE);
					TRACE_EVENT_P2("conc status: %d, conc length: %d", concatenated_status, conc_data_ext.len);
		  		}
	  		
	          	TRACE_EVENT_P1("UDH Length is = %d", sm->udh.len);

		  		if (received_sms_type == CONCATE)
		  		{
				switch (concatenated_status)
				{
					
					case CONC_ERR_BUF_FULL:
						TRACE_EVENT("Concatented SMS buffer Full Error");
						  sms_signal(E_SMS_ERR, NULL);
						break;
					case CONC_ERR_UNKN:
						TRACE_EVENT("Concatenated SMS error");
					case CONC_CONTINUED: //not last SMS
						TRACE_EVENT("Concatenation Continued");
						cmgr_awaiting_ok = FALSE; // Marcus: Issue 2260: 03/10/2002
					/*SPR 2260,if the index exists in the message table, continue processing message*/
					for (i=0; i <MAX_MESSAGES;i++)
						if (msg_info[i].index == sm->msg_ref && msg_info[i].concat_status == MFW_SMS_CONC_PART)
							continue_flag = TRUE;
					if (!continue_flag)
						break;
					case CONC_COMPLETED:
					{ 	
	          			
						  TRACE_EVENT("Concatenation Completed");
						  memset(&sms_mo, 0, sizeof(sms_mo));
						  /*SPR 2260*/
							conc_msg_ref =concSMS_GetMsgRef ( sm );
						conc_index = concSMS_GetFirstIndex(conc_msg_ref, sm->adress);
						  TRACE_EVENT_P2("msg_len: %d conc len: %d", sms_mo.msg_len, conc_data_ext.len);

#ifdef NO_ASCIIZ
				          memcpy(sms_mo.dest_addr.tag,
				                 sm->alpha.data,
				                 sm->alpha.len);
				          sms_mo.dest_addr.len = sm->alpha.len;
#else
				          phb_Alpha2Gsm(&sm->alpha, (UBYTE *)sms_mo.dest_addr.tag);
#endif
				          strcpy(sms_mo.dest_addr.number, sm->adress);
				          sms_mo.dest_addr.ton = phb_cvtTon(sm->toa.ton);
				          sms_mo.dest_addr.npi = phb_cvtNpi(sm->toa.npi);
				          if (sm->tosca.ton == TON_International)
				            sprintf(sms_mo.sc_addr, "+%s", sm->sca);
				          else
					        strcpy((char *)sms_mo.sc_addr, sm->sca);

				          sms_mo.prot_id = (UBYTE)sm->pid;
				          sms_mo.dcs     = sm->dcs;

				        /*MC SPR 2260, message index should be set to that of first index in
						concatenated message if this is a complete message*/
						if (concatenated_status == CONC_COMPLETED)
							sms_mo.msg_ref = conc_index;
						else
							sms_mo.msg_ref = sm->msg_ref;
				          
				   
				          sms_mo.vp_mode = 0x03 & sm->fo << 2;
				          sms_mo.vp_rel  = (UBYTE)sm->vp_rel;

				          memcpy((char *)sms_mo.vp_abs.year, (char *)sm->scts.year, MAX_SCTP_DIGITS);
				          memcpy((char *)sms_mo.vp_abs.month, (char *)sm->scts.month, MAX_SCTP_DIGITS);
				          memcpy((char *)sms_mo.vp_abs.day, (char *)sm->scts.day, MAX_SCTP_DIGITS);
				          memcpy((char *)sms_mo.vp_abs.hour, (char *)sm->scts.hour, MAX_SCTP_DIGITS);
				          memcpy((char *)sms_mo.vp_abs.minute, (char *)sm->scts.minute, MAX_SCTP_DIGITS);
				          memcpy((char *)sms_mo.vp_abs.second, (char *)sm->scts.second, MAX_SCTP_DIGITS);
				          sms_mo.vp_abs.timezone = sm->scts.timezone;
						  
						/* copy length of whole concat SMS*/
						  if (conc_data_ext.len > MAX_MSG_LEN)
						  	sms_mo.msg_len = MAX_MSG_LEN;
						  else
						    sms_mo.msg_len = conc_data_ext.len;
						/*SPR 2260  if invalid message just set text to NULL*/
				         if (sm->stat == SMS_STAT_Invalid)
							memset(sms_mo.sms_msg, NULL, MAX_MSG_LEN_ARRAY);
				         else
				         {	if (concatenated_status == CONC_COMPLETED)
				         	{	memcpy(sms_mo.sms_msg, (char*)conc_data_ext.data, sms_mo.msg_len);}
				         	else
				         	{	memcpy(sms_mo.sms_msg, (char*)sm->data.data, sm->data.len);
				         	    sms_mo.msg_len = sm->data.len;
				         	}
				         }
		
						/* Free memory allocated by the ACI */
						  MFREE(conc_data_ext.data);
				          sms_type = MFW_NO_MESSAGE;
				          sms_signal(E_SMS_MO, &sms_mo);
//zkc add 07/23/04
#ifdef MMI_PCSYN_ENABLED
					Waitdata_getsms(&sms_mo,MFW_SMS_MO,MFW_SMS_OK);
#endif
//
						}
					}
		  		}
				else
				{
#ifdef NO_ASCIIZ
	          memcpy(sms_mo.dest_addr.tag,
	                 sm->alpha.data,
	                 sm->alpha.len);
	          sms_mo.dest_addr.len = sm->alpha.len;
#else
	          phb_Alpha2Gsm(&sm->alpha, (UBYTE *)sms_mo.dest_addr.tag);
#endif
	          strcpy(sms_mo.dest_addr.number, sm->adress);
	          sms_mo.dest_addr.ton = phb_cvtTon(sm->toa.ton);
	          sms_mo.dest_addr.npi = phb_cvtNpi(sm->toa.npi);
	          if (sm->tosca.ton == TON_International)
	            sprintf(sms_mo.sc_addr, "+%s", sm->sca);
	          else
	          	strcpy((char *)sms_mo.sc_addr, sm->sca);

	          sms_mo.prot_id = (UBYTE)sm->pid;
	          sms_mo.dcs     = sm->dcs;
	          sms_mo.msg_ref = sm->msg_ref;
	          sms_mo.vp_mode = 0x03 & sm->fo << 2;
	          sms_mo.vp_rel  = (UBYTE)sm->vp_rel;

	          memcpy((char *)sms_mo.vp_abs.year, (char *)sm->scts.year, MAX_SCTP_DIGITS);
	          memcpy((char *)sms_mo.vp_abs.month, (char *)sm->scts.month, MAX_SCTP_DIGITS);
	          memcpy((char *)sms_mo.vp_abs.day, (char *)sm->scts.day, MAX_SCTP_DIGITS);
	          memcpy((char *)sms_mo.vp_abs.hour, (char *)sm->scts.hour, MAX_SCTP_DIGITS);
	          memcpy((char *)sms_mo.vp_abs.minute, (char *)sm->scts.minute, MAX_SCTP_DIGITS);
	          memcpy((char *)sms_mo.vp_abs.second, (char *)sm->scts.second, MAX_SCTP_DIGITS);
	          sms_mo.vp_abs.timezone = sm->scts.timezone;

			  TRACE_EVENT("Normal MO Message");
	          sms_mo.msg_len = sm->data.len;
	          	/*SPR 2260 if invalid message just set text to NULL*/
		         if (sm->stat == SMS_STAT_Invalid)
					memset(sms_mo.sms_msg, NULL, MAX_MSG_LEN_ARRAY);
		         else
		         	memcpy(sms_mo.sms_msg, (char *)sm->data.data, sm->data.len);

	          sms_type = MFW_NO_MESSAGE;
	          sms_signal(E_SMS_MO, &sms_mo);
//zkc add 	07/23/04
#ifdef MMI_PCSYN_ENABLED
				Waitdata_getsms(&sms_mo,MFW_SMS_MO,MFW_SMS_OK);
#endif
//
					}
	        	}
	          break;

	        default:
	          sms_signal(E_SMS_ERR, NULL);
	      	}
    	}
    
  	else
  	{	TRACE_EVENT("rAT_plusCMGR: SMS pointer error");

  	}
  }
      break;

      case MFW_CB_MESSAGE:
      	if (cbm != NULL) /*SPR2260 make sure we have a valid pointer*/
      	{
	        sms_cb.sn     = cbm->sn;
	        sms_cb.msg_id = cbm->mid;
	        sms_cb.dcs    = cbm->dcs;
	        sms_cb.page   = cbm->page;
	        sms_cb.pages  = cbm->pages;
	        sms_cb.msg_len = cbm->data.len;
	        memcpy((char *)sms_cb.cb_msg, (char *)cbm->data.data, cbm->data.len);

	        /* send cell broadcast message event */
	        sms_type = MFW_NO_MESSAGE;
	        sms_signal(E_SMS_CB, &sms_cb);
      	}
      	else
      		TRACE_EVENT("rAT_plusCMGR: SMS CB pointer error");
        break;

      case MFW_NO_MESSAGE:
        TRACE_EVENT("read=free no msg");
        coll_sms_read = MFW_SMS_FREE;
        if(coll_sms_read EQ MFW_SMS_WAIT)
          coll_sms_read = MFW_SMS_FREE;
        break;
  }

  sms_check_mt_update();

{	
	TRACE_EVENT_P4("CMGR Msg table: %d,%d,%d, %d", msg_info[0].index, msg_info[1].index,msg_info[2].index,msg_info[3].index);
	TRACE_EVENT_P4("CMGR Msg table: %d,%d,%d, %d", msg_info[4].index, msg_info[5].index,msg_info[6].index,msg_info[7].index);
}
}


/*
+--------------------------------------------------------------------+
| PROJECT : GSM-PS (6147)         MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : rAT_PlusCMGD             |
+--------------------------------------------------------------------+

  PURPOSE :
*/
GLOBAL void rAT_PlusCMGD ()
{
  TRACE_FUNCTION ("rAT_PlusCMGD");
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_store         |
+--------------------------------------------------------------------+

   PURPOSE :  Save a short message.

  GW 09/10/01 - Modified code to always save the maximum message length
*/
#ifdef NO_ASCIIZ
T_MFW sms_store(T_MFW_SMS_MO_TYPE type,
				CHAR *addr,
                UBYTE *msg,
                USHORT msg_len,
				CHAR *sca)
#else
T_MFW sms_store(T_MFW_SMS_MO_TYPE type,
				CHAR *addr,
				UBYTE *msg,
				USHORT msg_len,
				CHAR *sca)
// sbh - added length to the above definition, since '@' characters stored as NULL & will stop
// strlen from working properly.
#endif
{

  T_SM_DATA_EXT		conc_data_ext;

  SHORT            rp;


  TRACE_FUNCTION ("sms_store()");


  /* check whether memory is full */
  if (memory.used == memory.total)
  {
    sms_signal(E_SMS_MEM_FULL, 0);
    return MFW_SMS_FAIL;
  }

  if (type == MFW_SMS_REPLY     OR
      type == MFW_SMS_REPLY_SENT  )
    rp = 0;   /* reply path = 0 */
  else
    rp = -1;  /* reply path = default */


	conc_data_ext.len = msg_len;
  conc_data_ext.data = msg;


  if (type == MFW_SMS_REPLY_SENT  OR
      type == MFW_SMS_SUBMIT_SENT   )
    sentStatus =  SMS_STAT_StoSent;
  else
    sentStatus =  SMS_STAT_StoUnsent;


  if (sAT_PlusCMGW(CMD_SRC_LCL, 0, addr, NULL, /* => addr analysed by ACI */
                       sentStatus, 0xFF,   /* unknown message reference */
                       &conc_data_ext, sca,
                       NULL, rp) NEQ AT_EXCT)

  {
    TRACE_EVENT("sAT_PlusCMGW error");
    return MFW_SMS_FAIL;
  }

  wr_addr = addr;
  sms_type = MFW_WR_NEW_MESSAGE;
  return MFW_SMS_OK;
}




/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS           |
| STATE   : code                         ROUTINE : sms_mt_store      |
+--------------------------------------------------------------------+

   PURPOSE :  Save a MT message.

*/

T_MFW sms_mt_store(T_MFW_SMS_MT *mt_msg, T_MFW_SMS_STAT stat)
{

  T_SM_DATA_EXT		conc_data_ext;
  T_ACI_TOA        toa;

  TRACE_FUNCTION ("sms_mt_store()");

  /* check whether memory is full */
  if (memory.used == memory.total)
  {
    sms_signal(E_SMS_MEM_FULL, 0);
    return MFW_SMS_FAIL;
  }


  conc_data_ext.len = mt_msg->msg_len;
  conc_data_ext.data = (UBYTE *)mt_msg->sms_msg;


  toa.ton = phb_ncvtTon(mt_msg->orig_addr.ton);
  toa.npi = phb_ncvtNpi(mt_msg->orig_addr.npi);


  if (sAT_PlusCMGW(CMD_SRC_LCL, 0, mt_msg->orig_addr.number,
                   &toa, sms_codeStatus(stat), 0,  /* no message reference */
                   &conc_data_ext,
                   mt_msg->sc_addr, NULL, -1) NEQ AT_EXCT)

  {
    TRACE_EVENT("sAT_PlusCMGW error");
    return MFW_SMS_FAIL;
  }

  sms_type = MFW_WR_NEW_MESSAGE;
  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_change          |
+--------------------------------------------------------------------+


   PURPOSE :  Save a changed short message.

  GW 09/10/01 - Copy entire message length.

*/

#ifdef NO_ASCIIZ
T_MFW sms_change(CHAR *addr, UBYTE *msg,
                 USHORT msg_len, UBYTE index)
#else
T_MFW sms_change(CHAR *addr, USHORT *msg, USHORT msg_len, UBYTE index)
// sbh - added length to the above function call, since '@' characters stored as NULL & will stop
// strlen from working properly.
#endif
{

  T_SM_DATA_EXT		conc_data_ext;


  TRACE_FUNCTION ("sms_change()");


  conc_data_ext.len = msg_len;
  conc_data_ext.data = (UBYTE *)msg;
    if (sAT_PlusCMGW(CMD_SRC_LCL, index, addr, NULL,
                       SMS_STAT_StoUnsent, 0xFF,    /* message reference */
                       &conc_data_ext,
                       NULL, NULL, -1) NEQ AT_EXCT)
    return MFW_SMS_FAIL;



  sms_type = MFW_WR_CHG_MESSAGE;
  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: rAT_PlusCMGW        |
+--------------------------------------------------------------------+


   PURPOSE :  Call back for saving a short message.

*/

void rAT_PlusCMGW(UBYTE index, UBYTE numSeg)
{
  int i;
  T_MFW_PHB_ENTRY phb_entry;
  T_MFW_PHB_LIST  phb_list;
  UBYTE           phb_index;
#ifdef NO_ASCIIZ
  T_MFW_PHB_TEXT  findText;
#endif

  TRACE_FUNCTION ("rAT_PlusCMGW()");
  TRACE_EVENT_P2("Index: %d, numseg: %d", index, numSeg);

  memset(&phb_entry, 0, sizeof(phb_entry));
	memset(&phb_list, 0, sizeof(phb_list));
	phb_list.entry = &phb_entry;

  if (sms_type == MFW_WR_NEW_MESSAGE)
  {
    for (i=0; i<MAX_MESSAGES; i++)
    {
      if (msg_info[i].index == -1)
        break;
    }
    if (i < MAX_MESSAGES)
    {
      msg_info[i].index = index;
      strncpy (msg_info[i].addr.number, wr_addr, MFW_NUM_LEN-1);
      msg_info[i].addr.number[MFW_NUM_LEN-1] = 0;
      /* search the name in phonebook */
#ifdef NO_ASCIIZ
      strcpy((char *)findText.data, wr_addr);
      findText.len = strlen(wr_addr);
      if (phb_find_entries  (PHB_ADN,	&phb_index,
                             MFW_PHB_NUMBER,
                             1, &findText,
                             &phb_list) EQ MFW_PHB_OK)
      {
        if (phb_list.num_entries == 1)
        {
          memcpy((char *)msg_info[i].addr.tag,
                 (char *)phb_list.entry->name.data,
                 phb_list.entry->name.len);
          msg_info[i].addr.len = phb_list.entry->name.len;
        }
      }
#else
      if (phb_find_entries  (PHB_ADN,	&phb_index,
                             MFW_PHB_NUMBER,
                             1, (CHAR *)wr_addr,
                             &phb_list) EQ MFW_PHB_OK)
      {
        if (phb_list.num_entries == 1)
        {
          strcpy((char *)msg_info[i].addr.tag, (char *)phb_list.entry->name);
        }
      }
#endif

      if (sentStatus EQ SMS_STAT_StoUnsent)
        msg_info[i].stat = MFW_SMS_STOR_UNSENT;
      else
        msg_info[i].stat = MFW_SMS_STOR_SENT;
/* glowing, 2004-06-10, import from TCS2112 */
	/*SPR 2260, we're making the assumption that only complete concat SMSs or single SMSs
	can be saved successfully*/
      if (numSeg == 1)
      	msg_info[i].concat_status = MFW_SMS_NO_CONC;
      else
      	msg_info[i].concat_status = MFW_SMS_CONC_WHOLE;

      msg_info[i].first_index = index;/*SPR 2260*/
/* glowing, 2004-06-11, end of import */
      msg_info[i].msg_type = MFW_SMS_NotVOICE; // ???
      memory.used +=numSeg;/*SPR2260*/
    }
  }
  /*SPR 2260*/
/* glowing,2004-06-11, import from TCS2112 */
  TRACE_EVENT_P2("memory used is = %d, of %d", memory.used, memory.total);
 if(memory.total == memory.used)
  {
  	
  	sms_signal(E_SMS_MEM_FULL, NULL);
  }  
/* glowing,2004-06-11, end of import */
  sms_type = MFW_NO_MESSAGE;

  sms_check_mt_update();
#ifdef MMI_PCSYN_ENABLED
//zkc add   07/22/04
	Waitdata_storesms(MFW_SMS_OK);
//
#endif

  sms_signal(E_SMS_SAVE_AVAIL, &index);
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_msg_delete      |
+--------------------------------------------------------------------+


   PURPOSE :  Delete a short message.

*/

T_MFW sms_msg_delete(UBYTE index)
{
  TRACE_FUNCTION ("sms_msg_delete()");

  coll_sms_delete = MFW_SMS_WAIT;

  if (sAT_PlusCMGD(CMD_SRC_LCL, index) NEQ AT_EXCT)
    return MFW_SMS_FAIL;
/*MC*/
  deleting_index = index;
  return MFW_SMS_OK;
}

/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_ok_change       |
+--------------------------------------------------------------------+

   PURPOSE :  Call back for the status change of a short message.form
              UNREAD to READ

*/

void sms_ok_change()
{
    T_MFW_SMS_IDX msg_list;
    TRACE_FUNCTION ("sms_ok_change()");

    /* Marcus: Issue 2260: 03/10/2002: Start */
    if (cmgr_awaiting_ok == TRUE)
    {
        cmgr_awaiting_ok = FALSE;
    /* Marcus: Issue 2260: 03/10/2002: End */

        if (fg)
        {
            fg = 0;
            sms_update_msg_info(MFW_SMS_READ);
            sms_signal(E_SMS_OK, 0);
        }

        sms_check_mt_update();

        //MZ Delete if VM SMS 
        if(sms_index_list(MFW_SMS_VOICE,&msg_list,MAX_MESSAGES) > 0)
            sms_msg_delete(msg_list.index);
    /* Marcus: Issue 2260: 03/10/2002: Start */
    }
    else
    {
         TRACE_EVENT("Ignoring unexpected OK");
    }
    /* Marcus: Issue 2260: 03/10/2002: End */
}

/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_ok_delete       |
+--------------------------------------------------------------------+


   PURPOSE :  Call back for deleting a short message.

*/

void sms_ok_delete()
{
#if (_PUSH_DETECT_ENABLE_ == 1)
	UBYTE idx;
#endif
 
  	TRACE_FUNCTION ("sms_ok_delete()");
  	
#if  (_PUSH_DETECT_ENABLE_ == 1)
	idx = push_delLst_get();

	/* check if return for deleting a push SMS success */	
	if(idx == deleting_index)	
	{
		PUSH_DET_TRACE(("sms_ok_delete(): a push SMS deleted, idx =%d", deleting_index));
		push_delLst_remove();

		/* another SMS to be delete? */
		PUSH_DET_TRACE(("sms_ok_delete(): check if another SMS to be delete!" ));
		push_sms_del_timCB(0, NULL);	
		sms_signal(E_SMS_MEM_FREE, 0);
		sms_check_mt_update();
		return;
	}
#endif

  	
  	/*SPR 2260, replaces section of code with function call*/
  	if (delete_sms_from_table (deleting_index))
  	{
	   	deleting_index = -1; /*Hope this fixes multiple deletions*/
		/*SPR 2260, we have to request the SMS storage status to update memory.used*/
		/*as we have no idea how many segments the deleted SMS had*/
	     int_req = POST_DELETE_CHECK;/*update memory variable, don't send an event to MMI*/
		qAT_PlusCPMS(CMD_SRC_LCL);

/* zkc add 08/12/2004 */
#ifdef MMI_PCSYN_ENABLED
            Waitdata_delsms(MFW_SMS_OK);
#endif
//

	  	sms_signal(E_SMS_OK, 0);
		sms_signal(E_SMS_MEM_FREE, 0);

	  	sms_check_mt_update();
  	}
  	{	
		TRACE_EVENT_P4("CMGD Msg table: %d,%d,%d, %d", msg_info[0].index, msg_info[1].index,msg_info[2].index,msg_info[3].index);
		TRACE_EVENT_P4("CMGD Msg table: %d,%d,%d, %d", msg_info[4].index, msg_info[5].index,msg_info[6].index,msg_info[7].index);
	}
}
/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: delete_sms_from_table       |
+--------------------------------------------------------------------+


   PURPOSE :  deletes a message from the MFW message table
   created for SPR2260

*/

BOOL delete_sms_from_table (SHORT index)
{
  int i;
 
  TRACE_FUNCTION ("delete_sms_from_table()");

  if(coll_sms_delete EQ MFW_SMS_WAIT)
    coll_sms_delete = MFW_SMS_FREE;

  for (i=0; i<MAX_MESSAGES; i++)
  {
    if (msg_info[i].index == index)
    {
      msg_info[i].index = -1;
      msg_info[i].stat = MFW_SMS_UNKNOWN;
      msg_info[i].msg_type = MFW_SMS_UNKNOWN;
      msg_info[i].addr.number[0] = '\0';
      msg_info[i].addr.tag[0] = '\0';
      msg_info[i].addr.ton = MFW_TON_UNKNOWN;
      msg_info[i].addr.npi = MFW_NPI_UNKNOWN;
      /*SPR 2260, reset new elements*/
      msg_info[i].first_index = -1;
      msg_info[i].concat_status = MFW_SMS_NO_CONC;
      return TRUE;
    }
  }
  
return FALSE;
}
/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_command         |
+--------------------------------------------------------------------+


   PURPOSE :  Send a mobile originated short massage command.

*/

T_MFW sms_command(CHAR *dest_addr, UBYTE command, UBYTE msg_ref)
{
  TRACE_FUNCTION ("sms_command()");

  switch (command)
  {
    case SMS_ENQ_PREV_SMS:
      if (sAT_PlusCMGC(CMD_SRC_LCL,
                       0x22,       // SMS command with Status Report Request
                       0x00,       // Command Type
                       0x00,       // Protocol Identifier
                       msg_ref,    // message reference of previous SMS
                       dest_addr,  // destination address
                       NULL,       // type of destination address
                       NULL)       // command data
                       NEQ AT_EXCT)
        return MFW_SMS_FAIL;
      break;

    case SMS_CAN_STAT_REQ:
      if (sAT_PlusCMGC(CMD_SRC_LCL,
                       0x02,       // SMS command without Status Report Request
                       0x01,       // Command Type
                       0x00,       // Protocol Identifier
                       msg_ref,    // message reference of previous SMS
                       dest_addr,  // destination address
                       NULL,       // type of destination address
                       NULL)       // command data
                       NEQ AT_EXCT)
        return MFW_SMS_FAIL;
      break;

    case SMS_DEL_PREV_SMS:
      if (sAT_PlusCMGC(CMD_SRC_LCL,
                       0x02,       // SMS command without Status Report Request
                       0x02,       // Command Type
                       0x00,       // Protocol Identifier
                       msg_ref,    // message reference of previous SMS
                       dest_addr,  // destination address
                       NULL,       // type of destination address
                       NULL)       // command data
                       NEQ AT_EXCT)
        return MFW_SMS_FAIL;
      break;

    case SMS_REQ_STAT_REP:
      if (sAT_PlusCMGC(CMD_SRC_LCL,
                       0x02,       // SMS command without Status Report Request
                       0x03,       // Command Type
                       0x00,       // Protocol Identifier
                       msg_ref,    // message reference of previous SMS
                       dest_addr,  // destination address
                       NULL,       // type of destination address
                       NULL)       // command data
                       NEQ AT_EXCT)
        return MFW_SMS_FAIL;
      break;
    default:
      /*
       * non-supported command type
       */
      return MFW_SMS_FAIL;
  }
  return MFW_SMS_OK;
}

/*
+-------------------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS                        |
| STATE  : code                         ROUTINE: sms_set_SrvCntr_number           |
+-------------------------------------------------------------------------------+

   PURPOSE :  MMI sets the Service Center Number on the SIM

*/

T_MFW sms_set_SrvCntr_number(T_MFW_SMS_INFO *sms_info)
{
  T_ACI_RETURN     res;

  TRACE_FUNCTION ("sms_set_SrvCntr_Nmbr_parameter()");


  if(sms_info == 0)
      return MFW_SMS_FAIL;

  if (sAT_PlusCSCA(CMD_SRC_LCL, (char *)sms_info->sc_addr, 0) NEQ AT_CMPL)
          	return MFW_SMS_FAIL;
      /* Send text mode parameters to ACI */


   if (sAT_PlusCSMP(CMD_SRC_LCL, ACI_NumParmNotPresent, ACI_NumParmNotPresent,
                       NULL, NULL, ACI_NumParmNotPresent,
                       ACI_NumParmNotPresent) NEQ AT_CMPL)
      	    return MFW_SMS_FAIL;

      res = sAT_PlusCSAS(CMD_SRC_LCL, (SHORT) 1);
      switch (res)
      {
        case AT_FAIL:
          return MFW_SMS_FAIL;
        case AT_CMPL:
          sms_signal(E_SMS_OK, 0);
          return MFW_SMS_OK;
        case AT_EXCT:
          return MFW_SMS_OK;
        default:
          return MFW_SMS_FAIL;
      }

  return MFW_SMS_OK;
}

/*
+-------------------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS                        |
| STATE  : code                         ROUTINE: sms_set_dcs_number           |
+-------------------------------------------------------------------------------+

   PURPOSE :  MMI sends the dcs data to the sim (control 7bit ascii (compressed),
			  8bit or 16bit (unicode) uncompressed data


*/
T_MFW sms_set_dcs_number(T_MFW_SMS_INFO *sms_info)
{
  T_ACI_RETURN     res;

  TRACE_FUNCTION ("sms_set_dcs_parameter()");


  if(sms_info == 0)
      return MFW_SMS_FAIL;


   if (sAT_PlusCSMP(CMD_SRC_LCL, ACI_NumParmNotPresent, ACI_NumParmNotPresent,
                       NULL, NULL, ACI_NumParmNotPresent,
                       sms_info->dcs ) NEQ AT_CMPL)
      	    return MFW_SMS_FAIL;

  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_parameter       |
+--------------------------------------------------------------------+


   PURPOSE :  MMI sets SMS parameters.

*/


T_MFW sms_parameter(T_MFW_SMS_INFO *sms_info, BOOL fGet)
{
  T_ACI_TOA        sc_typ;

  CHAR				sca[MAX_LEN];
  SHORT            first_oct;

  SHORT            vprel;
  T_ACI_VP_ABS     vpabs;
  SHORT            pid;
  SHORT            dcs;
  T_ACI_RETURN     res;

  TRACE_FUNCTION ("sms_parameter()");

  if(sms_info == 0)
      return MFW_SMS_FAIL;

  if(fGet) {

      memset(sms_info, 0, sizeof(T_MFW_SMS_INFO));

      if (qAT_PlusCSCA(CMD_SRC_LCL,
                       sca,
                       &sc_typ) EQ AT_FAIL
          OR qAT_PlusCSMP(CMD_SRC_LCL,
                          &first_oct,
                          &vprel,
                          &vpabs,
                          NULL,
                          &pid,
                          &dcs ) EQ AT_FAIL)
      {

        return MFW_SMS_FAIL;
      }

      if (sc_typ.ton == TON_International)
        sprintf(sms_info->sc_addr, "+%s", sca);
      else
      strcpy((char *)sms_info->sc_addr, (char *)sca);
      sms_info->prot_id = pid;
      sms_info->dcs = dcs;
      sms_info->vp_rel = (UBYTE)vprel;
      memcpy(&sms_info->vp_abs, &vpabs, sizeof(T_MFW_SMS_SCTP));

      if ((first_oct & 0x18) EQ 0x10)
        sms_info->vp_mode = SMS_VPF_NUMERICAL;
      if ((first_oct & 0x18) EQ 0x18)
        sms_info->vp_mode = SMS_VPF_STRING;
      if ((first_oct & 0x18) EQ 0x00)
        sms_info->vp_mode = SMS_VPF_NOTPRESENT;

      sms_info->rd = first_oct >> 2 & 1;
	    sms_info->rp = first_oct >> 7 & 1;
	    sms_info->srr = first_oct >> 5 & 1;

  } else {

      if (sAT_PlusCSCA(CMD_SRC_LCL, (char *)sms_info->sc_addr, 0) NEQ AT_CMPL)
      	{
        	return MFW_SMS_FAIL;
      	}
      /* Send text mode parameters to ACI */
      if (sms_info->vp_mode EQ SMS_VPF_NUMERICAL)
        first_oct = 0x11;
      if (sms_info->vp_mode EQ SMS_VPF_STRING)
        first_oct = 0x19;
      if (sms_info->vp_mode EQ SMS_VPF_NOTPRESENT)
        first_oct = 0x01;

      first_oct |= sms_info->rd << 2;
      first_oct |= sms_info->rp << 7;
      first_oct |= sms_info->srr << 5;

      if (sAT_PlusCSMP(CMD_SRC_LCL, first_oct, sms_info->vp_rel,
                       (T_ACI_VP_ABS *)&sms_info->vp_abs, NULL, sms_info->prot_id,
                       sms_info->dcs) NEQ AT_CMPL)
      	{
    	    return MFW_SMS_FAIL;
      	}
      res = sAT_PlusCSAS(CMD_SRC_LCL, (SHORT) 1);
      switch (res)
      {
        case AT_FAIL:
          return MFW_SMS_FAIL;
        case AT_CMPL:
          sms_signal(E_SMS_OK, 0);
          return MFW_SMS_OK;
        case AT_EXCT:
          return MFW_SMS_OK;
        default:
          return MFW_SMS_FAIL;
      }
  }

  return MFW_SMS_OK;
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: sms_busy_ind        |
+--------------------------------------------------------------------+


   PURPOSE :  SMS busy indication to MMI.

*/

void sms_busy_ind(void) // bugfix for SIM refresh
{
  int_req = 0;
  sms_signal(E_SMS_BUSY, 0);
}


/*
+----------------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS                      |
| STATE  : code                         ROUTINE: sms_set_cell_broadcast_info |
+----------------------------------------------------------------------------+


   PURPOSE :  MMI sets SMS cell broadcast parameters.

*/

T_MFW sms_set_cell_broadcast_info(UBYTE mode, T_MFW_SMS_CB_INFO *sms_cb_info)
{
  T_ACI_RETURN     res;

  TRACE_FUNCTION ("sms_set_cell_broadcast_info()");

  if (sAT_PlusCSCB(CMD_SRC_LCL, mode, sms_cb_info->msg_id, sms_cb_info->dcs) NEQ AT_CMPL)
    return MFW_SMS_FAIL;

  res = sAT_PlusCSAS(CMD_SRC_LCL, (SHORT) 1);
  switch (res)
  {
    case AT_FAIL:
      return MFW_SMS_FAIL;
    case AT_CMPL:
      sms_signal(E_SMS_OK, 0);
      return MFW_SMS_OK;
    case AT_EXCT:
      return MFW_SMS_OK;
    default:
      return MFW_SMS_FAIL;
  }

    return MFW_SMS_OK;
}

/*
+----------------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS                      |
| STATE  : code                         ROUTINE: sms_get_cell_broadcast_info |
+----------------------------------------------------------------------------+


   PURPOSE :  MMI gets SMS cell broadcast parameters.

*/

T_MFW sms_get_cell_broadcast_info(T_MFW_SMS_CB_INFO *sms_cb_info)
{
  T_ACI_CSCB_MOD   mode;
  USHORT            mids[MAX_IDENTS];
  UBYTE            dcss[MAX_IDENTS];

  TRACE_FUNCTION ("sms_get_cell_broadcast_info()");

  memset(dcss,0xFF,MAX_IDENTS);
  memset(mids,0xFFFF,MAX_IDENTS);

  if (qAT_PlusCSCB(CMD_SRC_LCL, &mode, mids, dcss) EQ AT_CMPL)
  {

    sms_cb_info->mode   = mode;
    memcpy((char *)sms_cb_info->dcs, (char *)dcss, MAX_IDENTS);

     memcpy((char *)sms_cb_info->msg_id, (char *)mids, sizeof(mids));

    return MFW_SMS_OK;
  }
  else
    return MFW_SMS_FAIL;
}

/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: rAT_PlusCMGS        |
+--------------------------------------------------------------------+


   PURPOSE :  Call back to inform about the successful sending of
              a mobile originated short massage.

*/

void rAT_PlusCMGS(UBYTE mr, UBYTE numSeg)
{
  TRACE_FUNCTION ("rAT_PlusCMGS()");

   if(coll_sms_send EQ MFW_SMS_WAIT)
		coll_sms_send = MFW_SMS_FREE;

  sms_check_mt_update();
#ifdef MMI_PCSYN_ENABLED
//zkc add   07/22/04
	Waitdata_sendsms(MFW_SMS_OK);
#endif
  sms_signal(E_SMS_MO_AVAIL, &mr);
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: rAT_PlusCMGC        |
+--------------------------------------------------------------------+


   PURPOSE :  Call back to inform about the successful sending of a
              mobile originated short massage command.

*/

void rAT_PlusCMGC(UBYTE mr)
{
  TRACE_FUNCTION ("rAT_PlusCMGC()");

  sms_check_mt_update();

  sms_signal(E_SMS_CMD_AVAIL, &mr);
}


/*
+--------------------------------------------------------------------+
| PROJECT: MMI-Framework (8417)         MODULE: MFW_SMS              |
| STATE  : code                         ROUTINE: rAT_PlusCMS         |
+--------------------------------------------------------------------+


   PURPOSE :  Report the error result on failures of the last
              executed functions

*/

void rAT_PlusCMS (T_ACI_AT_CMD cmdId, T_ACI_CMS_ERR err, T_EXT_CMS_ERROR *ce)
{
  T_MFW_SMS_CMD_IND cmd_ind;

  TRACE_FUNCTION ("rAT_PlusCMS()");
  TRACE_EVENT_P1("Error: %d",cmdId);

  switch (cmdId)
  {
    case AT_CMD_CMGS:
    case AT_CMD_CMSS:
      cmd_ind = CMD_SMS_SUBMIT;
      coll_sms_send = MFW_SMS_FREE;
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_sendsms(CMD_SMS_SUBMIT);
#endif
//
      sms_signal(E_SMS_ERR, &cmd_ind);
      break;

    case AT_CMD_CMGC:
      cmd_ind = CMD_SMS_COMMAND;
      coll_sms_req = MFW_SMS_FREE;
      sms_signal(E_SMS_ERR, &cmd_ind);
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_sms(cmdId);
#endif
//						 
      break;

    case AT_CMD_CPMS:
      cmd_ind = CMD_SMS_MEMORY;
      sms_signal(E_SMS_ERR, &cmd_ind);
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_sms(cmdId);
#endif
//						 
      break;

    case AT_CMD_CMGR:
      cmd_ind = CMD_SMS_READ;
      coll_sms_read = MFW_SMS_FREE;
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_getsms(NULL, 0,CMD_SMS_READ);
#endif
//
      sms_signal(E_SMS_ERR, &cmd_ind);
      break;

    case AT_CMD_CMGL:
      cmd_ind = CMD_SMS_READ;
      coll_sms_read = MFW_SMS_FREE;
      sms_signal(E_SMS_ERR, &cmd_ind);
      sms_ok_CMGL(); /*JVJ SPR1118 This case has been added to handle the Error of CMGL
                       when the SIM Card has no messages. Even without SMS in the SIM card,
                       the call to qAT_PlusCPMS to query the memory status is still needed */
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_sms(cmdId);
#endif
//						 
      break;

    case AT_CMD_CMGW:
      sms_type = MFW_NO_MESSAGE;
      cmd_ind = CMD_SMS_STORE;
      coll_sms_send = MFW_SMS_FREE;
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_storesms(CMD_SMS_STORE);
#endif
//
      sms_signal(E_SMS_ERR, &cmd_ind);
      break;

    case AT_CMD_CMGD:
      cmd_ind = CMD_SMS_SET_PARA;
      coll_sms_delete = MFW_SMS_FREE;
      sms_signal(E_SMS_ERR, &cmd_ind);
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_sms(cmdId);
#endif
//						 
      break;

    case AT_CMD_CSAS:
      cmd_ind = CMD_SMS_DELETE;
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
	Waitdata_delsms(CMD_SMS_DELETE);
#endif
//
      sms_signal(E_SMS_ERR, &cmd_ind);
      break;
    default:
//zkc add   08/12/04
#ifdef MMI_PCSYN_ENABLED
		Waitdata_sms(cmdId);
#endif
//
		break;
  }

  sms_check_mt_update();
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)  MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : sms_get_memset           |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to request the preferred SMS memory
*/
T_MFW sms_get_memset(void)
{
    TRACE_FUNCTION ("sms_get_memset()");

    coll_sms_req = MFW_SMS_WAIT;

    if (qAT_PlusCPMS(CMD_SRC_LCL) EQ AT_EXCT)
        return MFW_SMS_OK;
    return MFW_SMS_FAIL;
}


/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : rAT_PlusCPMS             |
+---------------------------------------------------------------------------+

  PURPOSE : Call back for request of preferred SMS memory.
*/

GLOBAL void rAT_PlusCPMS (T_ACI_SMS_STOR_OCC * mem1,
                          T_ACI_SMS_STOR_OCC * mem2,
                          T_ACI_SMS_STOR_OCC * mem3)
{
    T_MFW_SMS_MEM_INFO sms_mem;

    TRACE_FUNCTION ("rAT_PlusCPMS");

    sms_mem.mem = mem1->mem;
    sms_mem.used = (UBYTE)mem1->used;
    sms_mem.total = (UBYTE)mem1->total;

    /* HLE temp for testing iface and for WIN32 simulation */

#if defined (WIN32)
	mem1->total = 10;
#endif

	if(coll_sms_req EQ MFW_SMS_WAIT)
        coll_sms_req = MFW_SMS_FREE;

    if (int_req || int_init_req)
    {	TRACE_EVENT_P2("memory.used:%d,memory.total:%d",mem1->used, mem1->total);
        memory.mem = mem1->mem;
        memory.used = (UBYTE)mem1->used;
        memory.total = (UBYTE)mem1->total;
		if (int_req ==FIRST_READ_OF_MEMORY_USE)
        	sms_signal(E_SMS_READY, 0);
        int_req = 0;
        int_init_req = 0;

        if (mem1->used == mem1->total)
            sms_signal(E_SMS_MEM_FULL, 0);

#ifdef SIM_TOOLKIT
        if (sms_update)
        {
            sms_update = FALSE;
            sms_sat_update_cnf();
        }
#endif
        return;
    }
    else
        sms_signal(E_SMS_MEM, &sms_mem);

  sms_check_mt_update();
}


/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_message_count        |
+---------------------------------------------------------------------------+

  PURPOSE : Request number of SMS message

*/

SHORT sms_message_count (T_MFW_SMS_STAT stat)
{
    SHORT count;
    int i;
    TRACE_FUNCTION("sms_message_count");

    count = 0;
    if ((stat == MFW_SMS_UNREAD)
        OR (stat == MFW_SMS_READ)
        OR (stat == MFW_SMS_STOR_UNSENT)
        OR (stat == MFW_SMS_STOR_SENT))
    {
        for (i=0; i<MAX_MESSAGES; i++)
        {
// PATCH JPS 20.09 - Don't look at SMS with index -1 because it means it is deleted
			if (msg_info[i].index != -1)
			{

				if (msg_info[i].stat == stat)
					count++;
			}
// PATCH JPS 20.09 END - Don't look at SMS with index -1 because it means it is deleted
        }
        return count;
    }

    if (stat == MFW_SMS_ALL)
    {
        for (i=0; i<MAX_MESSAGES; i++)
        {
            if (msg_info[i].index != -1)
                count++;
        }
        return count;
    }

    if (stat == MFW_SMS_MO)
    {
        for (i=0; i<MAX_MESSAGES; i++)
        {
// PATCH JPS 20.09 - Don't look at SMS with index -1 because it means it is deleted
			if (msg_info[i].index != -1)
			{
				if ((msg_info[i].stat == MFW_SMS_STOR_UNSENT)
				   OR (msg_info[i].stat == MFW_SMS_STOR_SENT))
					count++;
			}
// PATCH JPS 20.09 END - Don't look at SMS with index -1 because it means it is deleted
		}
        return count;
    }
    if (stat == MFW_SMS_MT)
    {
        for (i=0; i<MAX_MESSAGES; i++)
        {
// PATCH JPS 20.09 - Don't look at SMS with index -1 because it means it is deleted
			if (msg_info[i].index != -1)
			{
				if ((msg_info[i].stat == MFW_SMS_UNREAD)
					OR (msg_info[i].stat == MFW_SMS_READ))
					count++;
			}
// PATCH JPS 20.09 END - Don't look at SMS with index -1 because it means it is deleted
		}
        return count;
    }
    if (stat == MFW_SMS_VOICE)
    {
        for (i=0; i<MAX_MESSAGES; i++)
        {
// PATCH JPS 20.09 - Don't look at SMS with index -1 because it means it is deleted
			if (msg_info[i].index != -1)
			{
				if (msg_info[i].msg_type == stat)
					count++;
			}
// PATCH JPS 20.09 END - Don't look at SMS with index -1 because it means it is deleted
        }
        return count;
    }
    return 0;
}


/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_message_list         |
+---------------------------------------------------------------------------+

  PURPOSE : Request a stored message list

  Note: msg_type is not used in this implementation
*/

SHORT sms_message_list(T_MFW_SMS_STAT stat,
                       T_MFW_SMS_MSG * msg_list,
                       int max_entries)
{
    SHORT count;
    int i;

    TRACE_FUNCTION("sms_message_list()");

    count = 0;
    switch (stat)
    {
        case MFW_SMS_ALL:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if (msg_info[i].index != -1)
                {
					sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_MO:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND ((msg_info[i].stat == MFW_SMS_STOR_UNSENT)
                         OR (msg_info[i].stat == MFW_SMS_STOR_SENT)))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_STOR_UNSENT:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_STOR_UNSENT))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_STOR_SENT:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_STOR_SENT))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_MT:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND ((msg_info[i].stat == MFW_SMS_UNREAD)
                         OR (msg_info[i].stat == MFW_SMS_READ)))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_UNREAD:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_UNREAD))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_READ:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_READ))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_VOICE:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].msg_type == MFW_SMS_VOICE))
                {
                    sms_copy_msg_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        default:
            return count;
    }
}


/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_copy_msg_list        |
+---------------------------------------------------------------------------+

  PURPOSE : copy a stored message list

*/

void sms_copy_msg_list(int num, T_MFW_SMS_MSG *msg_list)
{
    TRACE_FUNCTION("sms_copy_msg_list()");

	  msg_list->index = msg_info[num].index;
    /*
     * forward message reference to MMI
     */
    msg_list->msg_ref = msg_info[num].msg_ref;
    msg_list->stat = msg_info[num].stat;
    msg_list->msg_type = msg_info[num].msg_type;
    strcpy(msg_list->addr.number, msg_info[num].addr.number);
    msg_list->addr.ton = msg_info[num].addr.ton;
    msg_list->addr.npi = msg_info[num].addr.npi;
#ifdef NO_ASCIIZ
    memcpy(msg_list->addr.tag,
           msg_info[num].addr.tag,
           msg_info[num].addr.len);
    msg_list->addr.len = msg_info[num].addr.len;
#else
    strcpy(msg_list->addr.tag, msg_info[num].addr.tag);
#endif
	memcpy(&msg_list->rctp, &msg_info[num].rctp, sizeof(T_MFW_SMS_SCTP));
}

/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_ok_csas              |
+---------------------------------------------------------------------------+

  PURPOSE : Setting of SMS parameter/cell broadcast parameter
            is successful.

*/

void sms_ok_csas(void)
{
  TRACE_FUNCTION("sms_ok_csas() ");
  sms_signal(E_SMS_OK, 0);

  sms_check_mt_update();
}

/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_error_csas           |
+---------------------------------------------------------------------------+

  PURPOSE : Setting of SMS parameter/cell broadcast parameter
            is failed.

*/

void sms_error_csas(void)
{
  sms_signal(E_SMS_ERR, 0);
}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)  MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : sms_codeStatus           |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to convert the status
            used by MFW to the status used by ACI.
*/

T_ACI_SMS_STAT sms_codeStatus(T_MFW_SMS_STAT stat)
{
    switch (stat)
    {
        case MFW_SMS_UNREAD:        return SMS_STAT_RecUnread;
        case MFW_SMS_READ:          return SMS_STAT_RecRead;
        case MFW_SMS_STOR_UNSENT:   return SMS_STAT_StoUnsent;
        case MFW_SMS_STOR_SENT:     return SMS_STAT_StoSent;
        case MFW_SMS_ALL:           return SMS_STAT_All;
        default:                    return SMS_STAT_NotPresent;
    }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)  MODULE  : MFW_SMS                  |
| STATE   : code                  ROUTINE : sms_decodeStatus         |
+--------------------------------------------------------------------+

  PURPOSE : This function is used to convert the status
            used by ACI to the status used by MFW.
*/

T_MFW_SMS_STAT sms_decodeStatus(T_ACI_SMS_STAT stat)
{
    switch (stat)
    {	case SMS_STAT_Invalid:		return MFW_SMS_INVALID;/*SPR 2260*/
        case SMS_STAT_RecUnread:        return MFW_SMS_UNREAD;
        case SMS_STAT_RecRead:          return MFW_SMS_READ;
        case SMS_STAT_StoUnsent:        return MFW_SMS_STOR_UNSENT;
        case SMS_STAT_StoSent:          return MFW_SMS_STOR_SENT;
        case SMS_STAT_All:              return MFW_SMS_ALL;
        default:                        return MFW_SMS_UNKNOWN;
    }
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_SIM            |
| STATE   : code                        ROUTINE : sms_get_cbm_id     |
+--------------------------------------------------------------------+

  PURPOSE : get cell broadcast message identifier
            cbmid: array for cell broadcast message identifier
            len:    size of array

*/

void sms_get_cbm_id (USHORT *cbmid, UBYTE len)
{
    UBYTE max;
    int   i;
    int   p;

    if (len > 6) /* maximal 5 cell broadcast message identifiers + '\0' */
        max = 6;
    else
        max = len;

    p = 0;
    // from 0-4
    for (i=0; i<(max-1); i++)
    {
        if (cb_mid[p] == 0xFF AND cb_mid[p+1] == 0xFF)
            break;
        cbmid[i] = ( ( SHORT )cb_mid[p] << 8 ) + cb_mid[p+1];
        p += 2;
    }
    cbmid[i] = '\0';
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_SIM            |
| STATE   : code                        ROUTINE : sms_save_cbm_id    |
+--------------------------------------------------------------------+

  PURPOSE : save cell broadcast message identifier

*/

void sms_save_cbm_id (USHORT *cbmid, UBYTE len)
{
    int   i;
    UBYTE p;
    UBYTE max;

    memset(cb_mid, 0xFF, sizeof(cb_mid));

    if (len > 5)
        max = 5;
    else
        max = len;

    p = 0;
    for (i=0; i<max; i++)
    {
        if (!cbmid[i])
            break;

        cb_mid[p++] = (UBYTE)(cbmid[i] >> 8);
        cb_mid[p++] = (UBYTE)cbmid[i];
    }

    memset(data, 0xFF, sizeof(data));

    memcpy(data, cb_mid, 10);

    sim_write_sim(SIM_CBMI, data, 10);
}


/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_SIM            |
| STATE   : code                        ROUTINE : sms_check_mt_update|
+--------------------------------------------------------------------+

  PURPOSE : save cell broadcast message identifier

*/

void sms_check_mt_update()
{

  T_ACI_SMS_STOR mem;
  UBYTE index;
  TRACE_EVENT("sms_check_mt_update() ");

if (sms_id.index > 0)
  {
	sms_send_new_msg_ind(NULL,sms_id.index, sms_id.mem, sms_id.received_sms_type, sms_id.concat_status);

    sms_id.index = 0;
  }
  if (sms_id_wait.index > 0)
  {
  sms_send_new_msg_ind(NULL,sms_id_wait.index, sms_id_wait.mem, sms_id_wait.received_sms_type, sms_id_wait.concat_status);

    sms_id_wait.index = 0;

  }


}

/*
+--------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)        MODULE  : MFW_SIM            |
| STATE   : code                        ROUTINE : sms_check_voice_mail|
+--------------------------------------------------------------------+

  PURPOSE : Check voice mail.

*/

T_MFW sms_check_voice_mail(UBYTE pid, UBYTE dcs, char *addr,
                           T_ACI_TOA *toa, T_ACI_UDH_DATA *udh)
{	T_MFW status =MFW_SMS_UNKNOWN;//MC
    TRACE_FUNCTION("sms_check_voice_mail()");

  if (dcs == 0xC0      /* check data coding scheme */
      OR dcs == 0xC8
      OR dcs == 0xD0
      OR dcs == 0xD8
      OR dcs == 0xE0
      OR dcs == 0xE8)
  	{
    	
    	status = MFW_SMS_VOICE;
  	}
  else if (udh->len > 0
           AND udh->data[0] == 0x01
           AND (udh->data[2] == 0x80 OR udh->data[2] == 0x00)) /* check user data header */
  	{
  		status = MFW_SMS_VOICE;
    	
  	}
  else if (pid == 0x5F OR pid ==0x42 /*On power-up check pid to determine SMS VM */)                              /* check message identifier */
  	{	status = MFW_SMS_VOICE;
    	
  	}
  else if (toa->ton == TON_Alphanumeric
  		 // 0x30 special case for one-2-one when voice mail has been deleted.
           AND (addr[0] == 0x10 OR addr[0] == 0x11 OR addr[0]==0x31 OR addr[0]==0x30)) /* check CPHS */
  	{
  		// Fix for one-2-one VM icon control. 26/6/01 MZ
  		if(addr[0]==0x30)
  		{
  			Delete_1_2_1_vm_icon = TRUE;
	  		Display_1_2_1_vm_icon = FALSE;
  		}
  		else if(addr[0]==0x31 && Delete_1_2_1_vm_icon == FALSE)
  			Display_1_2_1_vm_icon = TRUE;

  		status = MFW_SMS_VOICE;
    	
  	}
	TRACE_EVENT_P2("Addr[0]:%x, Addr[1]:%x", addr[0], addr[1]);
	TRACE_EVENT_P2("Addr[2]:%x, Addr[3]:%x", addr[2], addr[3]);
  /*MC1364, improved this to check if voicemail indicator to be set or cleared*/
  	if (status == MFW_SMS_VOICE && addr[0]&0x01) //if a voicemail indication
  	{	Delete_1_2_1_vm_icon = FALSE;/*SPR2260*/
	  	Display_1_2_1_vm_icon = TRUE;
  		/*MC, if MSB set, bit 0 of second char in 7-bit encoding)*/
 	 	if (addr[1] & 0x08) /*SPR 2260 experimentally, bit set by orange*/
  			cphs_set_mailbox_status(0,MFW_CFLAG_SET , 0, 0);/*set line2*/
  		else
  			cphs_set_mailbox_status(MFW_CFLAG_SET, 0, 0, 0);/*set line1*/
  	}
	if (status == MFW_SMS_VOICE && !(addr[0]&0x01)) //if a voicemail deletion
  	{	Delete_1_2_1_vm_icon = TRUE;/*SPR2260*/
	  	Display_1_2_1_vm_icon = FALSE;
  		/*MC, if MSB set, bit 0 of second char in 7-bit encoding)*/
 	 	if (addr[1] & 0x08) /*SPR 2260 experimentally, bit set by orange*/
  			cphs_set_mailbox_status(0,MFW_CFLAG_NOTSet , 0, 0);/*clear line2*/
  		else
  			cphs_set_mailbox_status(MFW_CFLAG_NOTSet, 0, 0, 0);/*clear line1*/
  	}
  	
    return status;
}

#ifdef SIM_TOOLKIT
/*
+---------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)   MODULE  : MFW_SMS                  |
| STATE   : code                   ROUTINE : sms_sat_file_update      |
+---------------------------------------------------------------------+

  PURPOSE : SIM file change indication

*/

void sms_sat_file_update(USHORT dataId)
{
  TRACE_FUNCTION("sms_sat_file_update()");

  sms_update = TRUE;
  switch (dataId)
  {
    case SIM_SMS:
      sms_read_msg_info();
      break;
    default:
      break;
  }
}
#endif

#ifdef SIM_TOOLKIT
/*
+---------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)   MODULE  : MFW_SMS                  |
| STATE   : code                   ROUTINE : sms_sat_update_cnf       |
+---------------------------------------------------------------------+

  PURPOSE : SIM file change indication

*/

void sms_sat_update_cnf (void)
{
    TRACE_FUNCTION("sms_sat_update_cnf()");
    satUpdateFiles ( TRUE, SIM_SMS );
}
#endif

/* PATCH JPS 29.09: like sms_message_list but returns only index and status

/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_index_list	        |
+---------------------------------------------------------------------------+

  PURPOSE : Request a stored message index and status
*/

SHORT sms_index_list(T_MFW_SMS_STAT stat,
                       T_MFW_SMS_IDX * msg_list,
                       int max_entries)
{
    SHORT count;
    int i;

    TRACE_FUNCTION("sms_index_list()");

    count = 0;
    switch (stat)
    {
        case MFW_SMS_ALL:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if (msg_info[i].index != -1)
                {
					sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_MO:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND ((msg_info[i].stat == MFW_SMS_STOR_UNSENT)
                         OR (msg_info[i].stat == MFW_SMS_STOR_SENT)))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_STOR_UNSENT:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_STOR_UNSENT))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_STOR_SENT:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_STOR_SENT))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_MT:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND ((msg_info[i].stat == MFW_SMS_UNREAD)
                         OR (msg_info[i].stat == MFW_SMS_READ)))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_UNREAD:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_UNREAD))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_READ:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].stat == MFW_SMS_READ))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        case MFW_SMS_VOICE:
            for (i=0; i<MAX_MESSAGES; i++)
            {
                if (count >= max_entries)
                    return count;

                if ((msg_info[i].index != -1)
                    AND (msg_info[i].msg_type == MFW_SMS_VOICE))
                {
                    sms_copy_idx_list(i, &msg_list[count]);
                    count++;
                }
            }
            return count;

        default:
            return count;
    }
}


/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                  |
| STATE   : code                         ROUTINE : sms_copy_idx_list        |
+---------------------------------------------------------------------------+

  PURPOSE : copy the index and status of a short message

*/

void sms_copy_idx_list(int num, T_MFW_SMS_IDX *msg_list)
{
    TRACE_FUNCTION("sms_copy_idx_list()");

	  msg_list->index = msg_info[num].index;
    /*
     * forward message reference to MMI
     */
    msg_list->stat = msg_info[num].stat;
    msg_list->msg_type = msg_info[num].msg_type;

}
void sms_copy_idx(UBYTE index, T_MFW_SMS_IDX *msg_list)
{int i;
    TRACE_FUNCTION("sms_copy_idx()");

	for (i=0;i<MAX_MESSAGES; i++)
	{
	    if (index==msg_info[i].index)
    	/*
     	* forward message reference to MMI
     	*/
    	{	
			msg_list->concat_status = msg_info[i].concat_status;/*SPR 2260*/
    		msg_list->stat = msg_info[i].stat;
    		msg_list->msg_type = msg_info[i].msg_type;
    		break;
    	}
	}
}

//GW-SPR#780 - Removed procedure - status is already updated by 'sms_change_read_status'
/* PATCH JPS 29.09 END */
/*
+---------------------------------------------------------------------------+
| PROJECT : MMI-Framework (8417)         MODULE  : MFW_SMS                |
| STATE   : code                         ROUTINE : sms_ok_CMGL             |
+---------------------------------------------------------------------------+

  PURPOSE : End of the rAT_PlusCMGL()

*/
void sms_ok_CMGL (void)
{
        TRACE_FUNCTION("sms_ok_CMGL: rAT_PlusCMGL cmpl");
			  /* request default memory */
          f_update = MFW_SMS_FREE;
          int_req = FIRST_READ_OF_MEMORY_USE;/*SPR2260*/

          qAT_PlusCPMS(CMD_SRC_LCL);
}
