#ifdef _MMS_ENABLE_
#ifndef _MMI_MMS_GLOBAL_DEF_H_
#define _MMI_MMS_GLOBAL_DEF_H_

#include "mmsgloble.h"

#define MMS_PATH            "/mms"
#define MMS_TEMP_PATH       "/mms/temp"
#define MMS_MESSAGE_PATH    "/mms/message"
#define MMS_MUSIC_FILEPATH  "/mms/musicfiles"
#define MMS_IMAGE_FILEPATH  "/mms/imagefiles"

#define MMS_TITLE_NUM_LENGTH 60 
#define MMS_IMAGE_NUM_LENGTH 60
#define MMS_RING_NUM_LENGTH  60
#define MMS_CONTEXT_NUM_LENGTH 600

typedef enum 
{
	STOP,
	PLAY,
	PREVIEW	
}MMS_PLAYER_STATE;
extern MMS_PLAYER_STATE mmsPlayerState;

//add by xie 04-07-22
typedef struct 
{
    T_MFW_HND    *hndInfo;
	T_MFW_HND    *hndParent;
}INFO_DIALOG_DATA;

typedef enum 
{
	MMS_NEW = 0,
	MMS_SEND_FOLDER,
	MMS_RECV_FOLDER,
	MMS_DRAFT_FOLDER,
	MMS_SENT_FOLDER
}MMS_FOLDER_TYPE;
#define FRAME_NUMBER_MAX   5    //֡
extern MMS_FOLDER_TYPE gCurMMSPos;

typedef struct _MMS
{
	pManager		manager;
	pEditor			editor;
	pPlayer			player;
}MMS;
typedef MMS *P_MMS;
P_MMS	getMMS();

void MMS_Initialize();
void MMS_Test_Send_Message();
void MMS_Exit();

BOOL MMS_File_Type(const char *filename, int fileType);

void MMS_Set_MMSNew_WHnd(T_MFW_HND win);
T_MFW_HND MMS_Get_MMSNew_WHnd();
void MMS_Set_MsgList_WHnd(T_MFW_HND win);
T_MFW_HND MMS_Get_MsgList_WHnd();
void MMS_Set_RecvList_WHnd(T_MFW_HND win);
T_MFW_HND MMS_Get_RecvList_WHnd(void );
void MMS_Set_MMSImageMusic_WHnd(T_MFW_HND win);
T_MFW_HND MMS_Get_MMSImageMusic_WHnd(void );

//add by xie 04-07-29 for idle display when new mms incoming
#if 0
void MMS_Increase_NewMMS_Sum();
void MMS_Decrease_NewMMS_Sum();
void MMS_Set_NewMMS_Sum(unsigned int uiSum);
#endif
unsigned int MMS_Get_NewMMS_Sum();
void MMS_Initialize_In_Idle();
void MMS_Destroy_In_Idle();



//for emulator
#ifdef  _INNOVATION_EMULATOR_
#define _MAC
typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef struct  _FILETIME
{
	DWORD dwLowDateTime;
	DWORD dwHighDateTime;
}	FILETIME;
typedef char CHAR;

typedef struct _WIN32_FIND_DATAA {
	DWORD dwFileAttributes;
	FILETIME ftCreationTime;
	FILETIME ftLastAccessTime;
	FILETIME ftLastWriteTime;
	DWORD nFileSizeHigh;
	DWORD nFileSizeLow;
	DWORD dwReserved0;
	DWORD dwReserved1;
	CHAR   cFileName[ 260 ];
	CHAR   cAlternateFileName[ 14 ];
#ifdef _MAC
	DWORD dwFileType;
	DWORD dwCreatorType;
	WORD  wFinderFlags;
#endif
} WIN32_FIND_DATAA, *PWIN32_FIND_DATAA, *LPWIN32_FIND_DATAA;

typedef WIN32_FIND_DATAA WIN32_FIND_DATA;

typedef void * HANDLE;
#define INVALID_HANDLE_VALUE (HANDLE)-1
#define ERROR_FILE_NOT_FOUND (HANDLE)2
#define FILE_ATTRIBUTE_DIRECTORY 0x00000010

HANDLE __stdcall FindFirstFileA ( const char* lpFileName, LPWIN32_FIND_DATAA lpFindFileData );
BOOL __stdcall FindNextFileA ( HANDLE hFindFile, LPWIN32_FIND_DATAA lpFindFileData );
BOOL __stdcall FindClose ( HANDLE hFindFile );
DWORD __stdcall GetCurrentDirectoryA( DWORD nBufferLength, char* lpBuffer );
#endif

#ifdef MMI_MMSTASK_ENABLED
typedef struct
{
	T_MFW_HND temp_win ;
	T_MFW_HND  current_win;
	BYTE 		    folderType;
}T_MMSUI_DATA;
extern T_MMSUI_DATA *mmsui_data;
#endif

T_MFW_HND info_mms_dialog (T_MFW_HND parent_win );

#define MANAGER_MASK_MMSMNU 0x01
#define MANAGER_MASK_MMSAGT 0x10
void  MI_manager_on_initialize(unsigned int mask);
void  MI_manager_on_destroy(unsigned int mask);

typedef enum
{
	MMS_SCREEN_ID_NORMAL = 0 ,/*for wait mms task handle*/
	MMS_SCREEN_ID_SENDING,
	MMS_SCREEN_ID_SENDSUCCESS,
	MMS_SCREEN_ID_SENDFAILED,
	MMS_SCREEN_ID_SENDCANCLED,
	MMS_SCREEN_ID_AUTORECVFAILED,
	MMS_SCREEN_ID_RETRIEVE,
	MMS_SCREEN_ID_RETRIEVESUCCESS,
	MMS_SCREEN_ID_RETRIEVEFAILED,
	MMS_SCREEN_ID_RETRIEVECANCLED,
	MMS_SCREEN_ID_BAD_PDU,

	MMS_SCREEN_ID_MUSIC_FILETOOBIG, //Add by xie 04-08-02
	MMS_SCREEN_ID_IMAGE_FILETOOBIG,

	MMS_SCREEN_ID_NULL,
};

T_MFW_HND info_mms_screen(T_MFW_HND parent_win, BYTE id );

#endif 
#endif