#ifdef _MMS_ENABLE_
#ifndef	_MMI_MMS_TO_MOBILESOFT_H_
#define _MMI_MMS_TO_MOBILESOFT_H_

typedef unsigned char	MMS_U8; 
typedef unsigned short	MMS_U16; 
typedef unsigned int	MMS_U32; 
typedef unsigned long	MMS_U64; 
typedef char			MMS_S8; 
typedef short			MMS_S16; 
typedef int				MMS_S32; 
typedef long			MMS_S64; 
typedef void			MMS_VOID;


typedef MMS_S32 MMS_BOOL;
typedef MMS_S32 MMS_COLOR;

typedef T_FFS_FD MMS_FILE;
#define MMS_SEEK_SET	FFS_SEEK_SET
#define MMS_SEEK_CUR	FFS_SEEK_CUR
#define MMS_SEEK_END	FFS_SEEK_END


//#define MMS_RGB(r, g ,b)		(MMS_U16)(((r/8)<<11)+((g/4)<<5)+(b/8))

#if __cplusplus 
extern "C" {
#endif

/* define string process functions */
MMS_U32 MMS_strlen (const MMS_S8* str);
MMS_S8 *MMS_strstr (const MMS_S8 *str, const MMS_S8 *find);
MMS_S8 *MMS_strcpy (MMS_S8 *dst,  const MMS_S8 *src);
MMS_S8 *MMS_strncpy (MMS_S8 *dst, const MMS_S8 *src, MMS_U32 num);
MMS_S32 MMS_strcmp (MMS_S8 *str1,  const MMS_S8* str2);
MMS_S32 MMS_strncmp (MMS_S8 *str1,  const MMS_S8 *str2,  MMS_U32 num);
MMS_S32 MMS_strcasecmp (MMS_S8 *str1, MMS_S8 *str2);
MMS_S8 *MMS_strcat (MMS_S8 *str,  const MMS_S8 *append);
MMS_S8 *MMS_strncat (MMS_S8 *str,  const MMS_S8 *append, MMS_U32 num);

/* define memory process functions */
MMS_VOID *MMS_malloc_big(MMS_S32 line, MMS_U32 size);
MMS_VOID MMS_free_big(MMS_S32 line, MMS_VOID *ptr);
MMS_VOID MMS_memset(MMS_VOID *ptr, MMS_U8 value, MMS_U32 size);
MMS_VOID MMS_memcpy(MMS_VOID *dptr, MMS_VOID *sptr, MMS_U32 size);
MMS_VOID *MMS_remalloc(MMS_VOID *address, MMS_U16 oldsize, MMS_U16 size );
/* define file process functions */
MMS_FILE MMS_fopen(MMS_S8 *filename, const MMS_S8 *option);
MMS_BOOL MMS_fclose(MMS_FILE fp);
MMS_U32 MMS_fread(MMS_VOID *buf, MMS_U32 size, MMS_U32 times, MMS_FILE fp);
MMS_U32 MMS_fwrite(MMS_VOID *buf, MMS_U32 size, MMS_U32 times, MMS_FILE fp);
MMS_S32 MMS_fseek(MMS_FILE fp, MMS_S32 size, MMS_S32 base);
MMS_S32 MMS_ftell(MMS_FILE fp);
MMS_S32 MMS_deletefile(MMS_S8 *filename, MMS_S8 *pathname);
MMS_S32 MMS_deletefiles(MMS_S8 *pathname);

/* define other ansi c functions */
MMS_S8 *MMS_itoa (MMS_U32 value,  MMS_S8 *buf, MMS_U32 radix);
MMS_S64 MMS_atol (MMS_S8 *str);
MMS_S32	MMS_getms();
MMS_S32 MMS_getrandstr(MMS_S8 *str);
MMS_S32	MMS_time_ltoa(MMS_U32 datetime, char *timestr);
MMS_S32	MMS_getsystemtime();

MMS_U8  MMSSaveImageData(MMS_S8 *pixelData, MMS_U32  pixelNum, MMS_U32  pixelPos, MMS_U8 pixelType);
MMS_S8 * MMSGetImageData(MMS_S32  pixelPos, MMS_U32  pixelNum);
MMS_U8 MMSBitBlt( MMS_U32              posX,
				 MMS_U32              posY,
				 MMS_U32              width,
				 MMS_U32              height,
				 MMS_VOID              * BmpPtr
				 );
MMS_VOID	*MMS_settimer(MMS_S32 value, MMS_VOID * callback);
MMS_S32		MMS_restarttimer(MMS_VOID *timer);
MMS_S32		MMS_resettimervalue(MMS_VOID *timer, MMS_S32 fast);  
MMS_S32		MMS_killtimer(MMS_VOID *timer);
MMS_U8		IsMMSLoseFocus(MMS_VOID);

MMS_U8 sys_getcharwidth(MMS_U8 ch);
MMS_S32		MMS_char2utf8(MMS_S8 *strin, MMS_S8 *strout, MMS_S32 length);
MMS_S32		MMS_utf82char(MMS_S8 *strin, MMS_S8 *strout, MMS_S32 length);
MMS_S32     MMS_Get_Free_Space(MMS_VOID);
MMS_U8		ECC_MidiStop(MMS_S8 *filename);//MMS_clib
MMS_U8		ECC_MidiPlay(MMS_S8 *filename, MMS_U8 loop);//MMS_clib.h
MMS_VOID	ECC_Sleep(MMS_U32 ms);

#ifndef SUPPORT_JPEG//ʹEastcom
MMS_S32		JPEGDrawE(MMS_S8 *filename, MMS_U32 x, MMS_U32 y, MMS_U32 w, MMS_U32 h);
MMS_S32		JPEGGetDimensionE(MMS_S8 *filename, MMS_S32 *w, MMS_S32 *h);
#endif
MMS_S32	Get_Gif_First_Slide_Data(MMS_S8 *filename,
								 MMS_U8 *p_buffer, 
								 MMS_S32 max_w, 
								 MMS_S32 max_h, 
								 MMS_S32 *width, 
								 MMS_S32 *height);
MMS_VOID	MMSDrawTitleBar(MMS_U8 curSlide, MMS_U8 slideNum, MMS_U8 audioFlag);
MMS_VOID	MMSDrawScrollBar(MMS_U8 curPage, MMS_U8 pageNum);

#if __cplusplus 
}
#endif

#endif
#endif
  
