
#ifndef _MMSTEST_H_
#define _MMSTEST_H_


#include "mms_clib.h"
#include "wap_interface.h"



typedef enum _MMS_NET_EVENT_TYPE
{
	MMS_NET_ERROR=0,
	MMS_NET_OPEN,
	MMS_NET_CLOSE,
	MMS_NET_CANCEL,
	MMS_NET_SEND,
	MMS_NET_RECV
}MMS_NET_EVENT_TYPE;


typedef enum _MMS_NET_STATE
{
	MMS_NET_STATE_NULL=0,
	MMS_NET_STATE_CONNECTING,
	MMS_NET_STATE_CONNECTED,
	MMS_NET_STATE_SENDING,
	MMS_NET_STATE_RECVING,
	MMS_NET_STATE_NOTSENDING,
	MMS_NET_STATE_ACKSENDING,
	MMS_NET_STATE_CLOSEING,
	MMS_NET_STATE_CANCELING
//	/*added by JeffreyYao, 1-15-2004*/
//	MMS_NET_STATE_PUSHARRIVED
}MMS_NET_STATE;



/* define for wap open */
typedef struct _MMS_OPEN_Tag
{
	int  status;
}MMS_OPEN_DATA, *pMMS_OPEN_DATA;

/* define for wap post */
typedef struct _MMS_SEND_DATA_Tag
{
	int				status;
}MMS_SEND_DATA, *pMMS_SEND_DATA;

/* define for wap get */
typedef struct _MMS_RECV_DATA_Tag
{
	int				status;
}MMS_RECV_DATA, *pMMS_RECV_DATA;

/* define for wap close */
typedef struct _MMS_CLOSE_DATA_Tag
{
	int  status;
}MMS_CLOSE_DATA, *pMMS_CLOSE_DATA;

/* define for wap cancel */
typedef struct _MMS_CANCEL_DATA_Tag
{
	int  status;
}MMS_CANCEL_DATA, *pMMS_CANCEL_DATA;



typedef struct _MMS_NET_EVENTTag
{
	MMS_NET_EVENT_TYPE	type;
	union
	{
		pMMS_OPEN_DATA		popendata;
		pMMS_CLOSE_DATA		pclosedata;
		pMMS_CANCEL_DATA	pcanceldata;
		pMMS_SEND_DATA		psenddata;
		pMMS_RECV_DATA		precvdata;
	}data;
	//added by JeffreyYao 1-15-2004
	MMS_S8 *filename;
	MMS_S8 *mmsc;
	MMS_S8 *url;
}MMS_NET_EVENT, *pMMS_NET_EVENT;


typedef enum 
{
	NULL_FUNC = 0,
	SEND_CALLBACK,
	RECV_CALLBACK
}MMSNetHandleFuncType;


typedef		int (*mmsnetproc)(pMMS_NET_EVENT mmsevt);
//modified by JeffreyYao, 1-15-2004
//typedef		int (*mmsnetproc)(pMMS_NET_EVENT mmsevt, MMS_S8 *filename, MMS_S8 *mmsc);


/* lib init and destroy interfaces */
int MMS_Net_Init(char *appapth);
int MMS_Net_Destroy(void);




/*  */
int MMS_Open(char *gwaddr, int port, mmsnetproc mproc, MMSNetHandleFuncType functype);

/* ر */
int MMS_Close(void);

/* ȡ */
int MMS_Cancel();

/* Ͳ */
int MMS_Send(char *mmsfile, char *mmscaddr);

/* ղ */
int MMS_Recv(char *address, char *recvfile);

/* wap յ confirm , invoke this function */
int MMS_NET_EVENT_HANDLE(pWAP_MMS_EVENT evt);

//MMSHANDLE MMS_OnPushData(MMS_U8 *data, MMS_S32 length);

//test:
int mms_test_send_message();
int mms_test_recv_message();


#endif
