
#ifndef	_MMS_SMIL_H_
#define _MMS_SMIL_H_





//#include "mmscore.h"
#include "mms_codec.h"


#if __cplusplus 
extern "C" {
#endif

/* define bool integer */
#define		TRUE		1
#define		FALSE		0

#define MMS_TXT_SIZE_SMALL	12
#define MMS_TXT_SIZE_NORMAL	16
#define MMS_TXT_SIZE_LARGE	20

#define MMS_TYPE_TEXT	0x01
#define MMS_TYPE_WBMP	0x02
#define MMS_TYPE_GIF	0x03
#define MMS_TYPE_JPEG	0x04
#define MMS_TYPE_WAV	0x05
#define MMS_TYPE_AMR	0x06		/*Adpatative Multi Rate*/
#define MMS_TYPE_MIDI	0x07
#define MMS_TYPE_MP3	0x08
#define MMS_TYPE_BMP	0x09
#define MMS_TYPE_IMY	0x0A
#define MMS_TYPE_PNG	0x0B
#define MMS_TYPE_MMF 0x0C /*MMF for ET*/

#define DEFAULT_SLIDE_TIMES		3000
#define MMS_RGB(r, g ,b)		(MMS_U16)(((b/8)<<11)+((g/4)<<5)+(r/8))
	//((MMS_U32) (((MMS_U8)(r) | ((MMS_U16)(g)<<8)) | ((MMS_U32)((MMS_U8)(b))<<16)))


/* define document type */
#define		DOCUMENT_TYPE_WML			1
#define		DOCUMENT_TYPE_SMIL			2
#define		DOCUMENT_TYPE_MMS			3




/*=============== structures define ===================================*/

/* Purpose: to support text layout required by EASTCOM - Longqiangl 2004-02-22 */
typedef struct tagTextLine T_TEXTLINE;
typedef  T_TEXTLINE *pT_TEXTLINE;
struct tagTextLine
{
	MMS_S32		page_no;
	MMS_S32		start_byte;
	MMS_S32		end_byte;
	pT_TEXTLINE	p_next;
};


typedef struct MMS_F2xml{
	MMS_FILE	head;	
	MMS_FILE	body;	
}MMS_F2XML,*pMMS_F2xml;

typedef struct MMS_Content{
	struct MMS_Content	*prev,			/*һ*/
						*next;			/*һ*/
	MMS_U32				contentsize;	/* content size */
	MMS_S32				x,				/*λx*/
						y,				/*λy*/
						width,			/*ʾ*/
						height;			/*ʾ߶*/
	MMS_U32				type;			/**/
	MMS_U32				time_start,		/*ʼʱ(ms)*/
						time_end;		/*ʱ(ms)*/
	MMS_U8				*data;			/*text data, define for text content */
	MMS_U32				color;			/*ɫ, define for text content */
	//MMS_U8				size;			/*С, define for text content */
	MMS_U8				fontsize;			/*Сmodified by JeffreyYao*/
	MMS_S8				filename[64];
	
	/* Added by Longqiangl 2004-01-13*/
	MMS_S32				offset_img_line;

/* Purpose: to support text layout required by EASTCOM - Longqiangl 2004-02-22 */
	pT_TEXTLINE			pTextLine;
	
}MMS_CONTENT,*pMMS_Content;

typedef struct MMS_Slide{
	struct MMS_Slide	*prev,			/*һ֡*/
						*next;			/*һ֡*/
	MMS_U32			times;			/*ʱ(ms)*/
	MMS_U32			color;			/*ɫ*/
	MMS_U32			audiolength;
	MMS_S8			audiofile[64];
	MMS_S8			audio_type;		/*ʽ*/
	MMS_S8			text_flag;
	MMS_S8			image_flag;
	pMMS_Content	content_root,	/*֡ݽṹ*/
					content_cur;	/*֡ǰ*/
					
	/* Added by Longqiangl 2004-01-13*/
	MMS_S8			flag_image_decoded;
	/* top of current document */
	MMS_S32			pagetop;
	/* pagelength of current document */
	MMS_S32			pagelength;

	/* Purpose: to support text layout required by EASTCOM - Longqiangl 2004-02-22 */
	MMS_S32			page_no;
					
}MMS_SLIDE,*pMMS_Slide;

typedef struct MMS_EDocument{
	MMS_U32			size;			/* message size */
	MMS_S32			width,			/*ĬĻ*/
					height;			/*ĬĻ߶*/
	pMMS_Slide		slide_root,		/*MMS֡ṹ*/
					slide_cur;		/*MMSǰ֡*/
}MMS_EDOCUMENT,*pMMS_EDocument;





MMS_S32 cms_parse_mms(MMS_S8 * filename, pMMS_EDocument theDocument, MMS_S8 * apppath);
MMSHANDLE	cms_integrate_mms(pMMS_EDocument pMms_edoc, MMS_S8 *apppath);



#if __cplusplus 
}
#endif





#endif