
#ifndef _MMSEDITOR_H_
#define _MMSEDITOR_H_


#include "mmsgloble.h"

#define		MAX_MSG_LENGTH			(1024*29)
#define		CONTENT_HEAD_LENGTH		256
#define		TEXT_BUFF_LENGTH		512

#define		EDITOR_INIT_NEW			0x01	
#define		EDITOR_INIT_REPLY		0x02
#define		EDITOR_INIT_REPLYALL	0x03
#define		EDITOR_INIT_FARWARD		0x04	
#define		EDITOR_INIT_EDIT		0x05


#if __cplusplus 
extern "C" {
#endif
	
pEditor		editor_on_initialize(MMS_S8 event, pMessage pMsg);
MMS_S32		editor_on_destroy();
MMS_S32		editor_save_message();

MMS_S32		editor_text_new(MMS_S8 *text);
//MMS_S32		editor_image_new(MMS_S8 *filename);
//redifined on 1.6 2004 for Eastcom
MMS_S32		editor_image_new(MMS_S8 *filename, MMS_U8 IMAGETYPE);

//MMS_S32		editor_audio_new(MMS_S8 *filename);
//redifined on 1.6 2004 for Eastcom
MMS_S32 editor_audio_new(MMS_S8 *filename, MMS_U8 AUDIOTYPE);


MMS_S32		editor_slide_add();
MMS_S32		editor_slide_insert();

MMS_S32		editor_slide_last();
MMS_S32		editor_slide_next();

/* type ==1: for text content */
/* type ==2: for image content */
/* type ==3: for music content */
MMS_S32		editor_content_del(MMS_S8 type);
MMS_S32		editor_slide_del();

MMS_S32		editor_set_modifyflag(MMS_S8 flag);
MMS_S8		editor_get_modifyflag();

MMS_S8		*editor_get_textstring();
MMS_S32		editor_set_textstring(MMS_S8 *text);

//MMS_S32		editor_get_edocmsgSize();//صǰ༭ϢĴС
MMS_S32		editor_get_messageSize();
MMS_S32		editor_get_slidecount();
MMS_S32		editor_get_slideindex();

MMS_S32		editor_get_slidetime(MMS_S32 *seconds);
MMS_S32		editor_set_slidetime(MMS_S32 seconds);

MMS_S32		editor_get_slidecolor(MMS_U32 *color);
MMS_S32		editor_set_slidecolor(MMS_U32 color);

MMS_S32		editor_get_textcolor(MMS_U32 *color);
MMS_S32		editor_set_textcolor(MMS_U32 color);

pMessage		editor_get_msg();
pMMS_EDocument	editor_get_document();
pEditor			editor_get_editor();

//new added for test only
#ifdef _EASTCOM_MMS_SIMULATOR_
MMS_S32	editor_on_othersend(pMessage smsg);
#endif

//added for EC
MMS_S32 editor_text_new_ec(MMS_S8 *text, MMS_U32 size);
MMS_S32 editor_audio_new_ec(MMS_U8 AUDIOTYPE, MMS_S8 *audiobuffer, MMS_U32 size);
MMS_S32 editor_image_new_ec(MMS_U8 IMAGETYPE, MMS_S8 *imagebuffer, MMS_U32 size);

//added for MobileInnovation
MMS_S8 *editor_get_imagefilename();
MMS_S8 *editor_get_audiofilename();
MMS_S8 *editor_get_mmstitle();

#if __cplusplus 
}
#endif


#endif /* _MMSEDITOR_H_ */
