#ifndef _MMSGLOBLE_H_
#define _MMSGLOBLE_H_


#include "mmscfg.h"
#include "mms_clib.h"
#include "Guifunc.h"
#include "mms_codec.h"
#include "mms_smil.h"
#include "mms_net.h"



#if (MAIN_LCD_SIZE == 4)		/*128*160*/
	#define     SCREEN_H		160
	#define     SCREEN_W		128
	#define     TITLE_H			(18)	//title bar hight
	#define     SCROLLBAR_W		(3)		//right scroll width
	#define     BOTTOM_H		(18)	//the bottom menu bar's height, mobilesoft may not use this value
	#define     PLAYER_X		(0)			//strat x for play
	#define     PLAYER_Y		(TITLE_H)   //start y for play
	#define     PLAYER_W		(SCREEN_W-SCROLLBAR_W)
	#define     PLAYER_H		(SCREEN_H-TITLE_H-BOTTOM_H)
#elif (MAIN_LCD_SIZE == 3)		/*128*128*/
	#define     SCREEN_H		128
	#define     SCREEN_W		128
	#define     TITLE_H			(15)
	#define     SCROLLBAR_W		(3)
	#define     BOTTOM_H		(15)
	#define     PLAYER_X		(0)    		//strat x for play
	#define     PLAYER_Y		(TITLE_H)	//start y for play
	#define     PLAYER_W		(SCREEN_W-SCROLLBAR_W)
	#define     PLAYER_H		(SCREEN_H-TITLE_H-BOTTOM_H)
#endif

#define     EDITOR_X				PLAYER_X
#define     EDITOR_Y				PLAYER_Y
#define     EDITOR_W				PLAYER_W     //no scroll bar
#define     EDITOR_H				PLAYER_H


/* DEFINE GLOBLE COLOR */
#ifndef	COLOR_BLACK
	#define     COLOR_BLACK		0
	#define     COLOR_WHITE		0xFFFFFF
#endif



#define	MMS_FOLDER_TYPE_RECV		1
#define	MMS_FOLDER_TYPE_SEND		2
#define	MMS_FOLDER_TYPE_DRAFT		3
#define	MMS_FOLDER_TYPE_UNSEND		4


#define	MMS_MSG_TYPE_SEND			1	/* ѷ */
#define	MMS_MSG_TYPE_UNSEND			2	/* δ */
#define	MMS_MSG_TYPE_UNREAD			3	/* δ */
#define	MMS_MSG_TYPE_READ			4	/* Ѷ */
#define	MMS_MSG_TYPE_DRAFT			5	/* ݸ */
#define	MMS_MSG_TYPE_UNNOTI			6	/* ²֪ͨ-δظ */
#define	MMS_MSG_TYPE_NOTI			7	/* ²֪ͨ-ѻظ */
#define	MMS_MSG_TYPE_DREPORT		8	/* 䱨 */
#define	MMS_MSG_TYPE_RREPORT		9	/* Ķ */


/* struct define: messagesetting */
/* value of setting is "1" or "2" */
typedef struct tagMSETTING MSETTING;
typedef MSETTING *pMSetting;
struct tagMSETTING
{
	/* system setting */
	MMS_S8		wapaddress[64];
	MMS_S8		mmscaddress[64];
	/* style setting */
	MMS_U8		auto_receive;
	MMS_U8		auto_save;
	MMS_U8		send_report;
	/* other */
	MMS_U8		fontsize;
	MMS_U8		displaymode_r;
	MMS_U8		displaymode_s;
};

/* struct define: messagelist */
typedef struct tagMessagelist MESSAGELIST;
typedef  MESSAGELIST *pMessage;
struct tagMessagelist
{
	MMS_S8		*filename;
	MMS_U8		state;
	MMS_U8		ptted;
	MMS_U32		size;	
//	MMS_S8		*title;
	MMS_S8		date[24];
	MMS_S8		*sender;

//revised by JeffreyYao, 1-14-2004	
#ifdef MULTI_RECEPIENT
	p_MMS_RECEPIENT receiver;
	p_MMS_RECEPIENT cc;
	p_MMS_RECEPIENT bcc;
#else
	MMS_S8		*receiver;
	MMS_S8		*cc;
	MMS_S8		*bcc;
#endif


	pMessage	next;

	MMS_S8		*title;
};

/* struct define: messagelist */
typedef struct tagMessageFolder MESSAGEFOLDER;
typedef  MESSAGEFOLDER *pFolder;
struct tagMessageFolder
{
	MMS_U8		type;
	MMS_U8		messagenumber;
	MMS_U8		unsettlednumber;
	MMS_U8		protectednumber;
	MMS_U32		size;
	pMessage	currentmessage;
	pMessage	root;
};


/* struct define: CmsMMSDocument
 *  CmsMMSDocument describe a mms pdu
 */
typedef struct _ManagerDocument
{
	pFolder		currentfolder;
	pFolder		receivefolder;
	pFolder		sendfolder;
	pFolder		draftfolder;
	pFolder		unsendfolder;
	pMSetting	setting;
}ManagerDocument;
typedef ManagerDocument *pManager;


/* struct define: CmsMMSDocument
 *  CmsMMSDocument describe a mms pdu
 */
typedef struct _Editor
{
	MMS_S8		modified;
	MMS_S32		type;
	pMessage	pMsg;
	/* mmseditor document pointer */
	pMMS_EDocument	eDoc;
}Editor;
typedef Editor *pEditor;



/*************** Macros For MMS Browser ************************/


/* define user event */
#define		USER_EVENT_TIMER		1
#define		USER_EVENT_PENDOWN		2
#define		USER_EVENT_KEYDOWN		3

/* define TIMER event action */
#define		TIMER_CARD_END			1
#define		TIMER_ELEMENT_START		2
#define		TIMER_ELEMENT_END		3
#define		TIMER_TEXT_SCROLL		4
#define		TIMER_PLAY_SLIDE		5

#define		PLAY_STYLE_AUTO			1
#define		PLAY_STYLE_NONAUTO		2




#if __cplusplus 
extern "C" {
#endif

typedef struct tagEventlist EVENTLIST;
typedef EVENTLIST *pEventlist;
struct tagEventlist
{
	MMS_U8		type;			/* event type */
    MMS_S32		id;				/* timer event id --- timer id */
	MMS_U8		action;			/* timer event action -- do some thing*/
	MMS_U32		start;			/* timer event start time*/
	MMS_U32		value;			/* timer event value---intervar value */
	MMS_VOID	*reference;		/* reference -- element or card */
	MMS_VOID	*timer;			/* timer structure */
	pEventlist	nextevent;		/* next event */
};

/********************* MMS Browser  information ****************/
typedef struct _BROWSERINFO 
{
	/* player styler */
	MMS_U8			style;

	/* define for time slide display */
	MMS_U32			allseconds;
	MMS_U32			seconds;

	/* define for non-auto play */
	/* top of current document */
	MMS_U32			pagetop;
	/* pagelength of current document */
	MMS_U32			pagelength;

	/* event list , defien for auto play*/
	pEventlist	firstevent;
	MMS_U32				eventnum;

	/* mmseditor document pointer */
	pMMS_EDocument	eDocument;
	pMMS_Slide		slide;
} BROWSERINFO, *pPlayer;


#if __cplusplus 
}
#endif



#endif /* _MMSGLOBLE_H_ */
