/*
+-------------------------------------------------------------------+
| PROJECT: mms task                  
| $Workfile: pcsyn.h
| $Author: Talcon Hu
| CREATED: 2004.07.17               
+-------------------------------------------------------------------+
*/
#ifndef _MMSTASK_H_
#define _MMSTASK_H_

#include "mmiutilapi.h"

#define MMSTASK_DELAY(x) rvf_delay(x)

#ifndef MMS_COMPILE_FORAPP
#ifdef ENTITY_MMS
#define _ENTITY_PREFIXED(N) mms_##N
#else
#define _ENTITY_PREFIXED(N)
#endif

#define hCommMMI        _ENTITY_PREFIXED(hCommMMI)
#define hCommMMS     _ENTITY_PREFIXED(hCommMMS)

extern T_HANDLE  hCommMMI;
extern T_HANDLE  hCommMMS;

#ifdef OPTION_MULTITHREAD
extern T_HANDLE mms_handle;
#define VSI_CALLER mms_handle,
#define VSI_CALLER_SINGLE mms_handle
#else
#define VSI_CALLER
#define VSI_CALLER_SINGLE
#endif


typedef struct
{
	U8                        event_id;                 /*<  0:  1> Identifier of the event.                           */
	U8                        _align0;                  /*<  1:  1> alignment                                          */
	U8                        _align1;                  /*<  2:  1> alignment                                          */
	U8                        _align2;                  /*<  3:  1> alignment                                          */
	T_sdu                     sdu;                      /*<  4: ? > Service Data Unit                                  */
} 
T_MMI_MMS_IND;

typedef struct
{
	U8                        event_id;                 /*<  0:  1> Identifier of the event.                           */
	U8                        _align0;                  /*<  1:  1> alignment                                          */
	U8                        _align1;                  /*<  2:  1> alignment                                          */
	U8                        _align2;                  /*<  3:  1> alignment                                          */
	T_sdu                     sdu;                      /*<  4: ? > Service Data Unit                                  */
} 
T_MMS_MMI_IND;


GLOBAL const void   mmi_mms_ind ( T_MMI_MMS_IND *mmi_pcsyn_ind);



/************************************************/


#define VERSION_MMS "MMS 1.0"

#define T_VERSION   char
typedef struct
{
  T_VERSION *version;
}
T_MONITOR;

#define MMS_NAME      "MMS"

/*
 * Bitoffset for encoding/decoding
 */
#define ENCODE_OFFSET             0

#endif//#ifndef MMS_COMPILE_FORAPP

typedef struct
{
	U8 dummy;
}
T_MMI_MMS_PLAYERONDRAW_IND;

typedef struct
/*MMS_S32		manager_set_currentmessage(pFolder folder, MMS_U8 index);*/
{
	void *pFolder;
	U8   index;
}
T_MMI_MMS_MSETCMSG_IND;

typedef struct
/*pEditor		editor_on_initialize(MMS_S8 event, pMessage pMsg);*/
{
	U8 		event;
	void* 	pMsg;
}
T_MMI_MMS_EDTONINIT_IND;

typedef struct
/*player_on_pageup,player_on_pagedown,player_on_pagenext,player_on_pagelast*/
{
	U8 		event;
}
T_MMI_MMS_PLAYERONPAGE_IND;

typedef struct
/*pPlayer		player_initialize(MMS_S32 event, PlayerInitRetVal *retval); */
{
	int 		event;
}
T_MMI_MMS_PLAYERINITIALIZE_IND;

typedef struct
/*	MMS_VOID MMS_DrawJPEGAlbum(MMS_S8 *filepath);
	MMS_VOID MMS_DrawGIFAlbum(MMS_S8 *filepath);
	*/
{
	U8
	   type;
	char   filename[64];
}
T_MMI_MMS_DRAWAIBUM_IND;

typedef struct
/*	MMS_TimerCallBackFn*/
{
	void *  fn;
	U32 	    e;
	void *   t;
}
T_MMI_MMS_TMCBFN_IND;

typedef struct
/*	MI_manager_on_initialize*/
{
	U8 mask;
}
T_MMI_MMS_MIMNGRINIT_IND;


/**********************************************/
typedef struct
{
	U8 event_id;
	void *pData;
}
T_MMS_MMI_READY_CNF;

typedef struct
{
	void *pPlayer;
	int     retval;
}
T_MMS_MMI_PLAYERINITIALIZE_CNF;

typedef struct
/*	MMS_U8 MMSBitBlt( MMS_U32 posX,	MMS_U32 posY, MMS_U32 width, MMS_U32 height,MMS_VOID * BmpPtr)*/
{
	U32  posX;
	U32 	 posY;
	U32 width;
	U32 height;
	void *BmpPtr;
}
T_MMS_MMI_MMSBITBLT_IND;

typedef struct
/*	MMS_VOID sys_drawpoint(MMS_S32 x, MMS_S32 y, MMS_COLOR color)*/
{
	int x;
	int y;
	int color;
}
T_MMS_MMI_DRAWPOINT_IND;

typedef struct
/*	MMS_S32 sys_drawtext(MMS_S32 x, MMS_S32 y, MMS_S8* string, MMS_U8 font, MMS_COLOR color)*/
{
	int x;
	int y;
	char *string;
	U8 font;
	int color;
}
T_MMS_MMI_DRAWTEXT_IND;

typedef struct
/*	MMS_VOID sys_drawfillrect(MMS_S32 x, MMS_S32 y, MMS_S32 width, MMS_S32 height, MMS_COLOR color)*/
{
	int x;
	int y;
	int width;
	int height;
	int color;
}
T_MMS_MMI_DRAWFILLRECT_IND;

typedef struct
/*	MMS_VOID	sys_refreshwindow()*/
{
	U8 dummy;
}
T_MMS_MMI_REFRESHWINDOW_IND;


/***************************************************/
void M_MMI_MMS_PLAYERONDRAW_IND(T_MMI_MMS_PLAYERONDRAW_IND * parameter);
void M_MMI_MMS_MSETCMSG_IND(T_MMI_MMS_MSETCMSG_IND * parameter);
void M_MMI_MMS_EDTONINIT_IND(T_MMI_MMS_EDTONINIT_IND * parameter);
void M_MMI_MMS_PLAYERONPAGE_IND(T_MMI_MMS_PLAYERONPAGE_IND * parameter);
void M_MMI_MMS_PLAYERINITIALIZE_IND(T_MMI_MMS_PLAYERINITIALIZE_IND * parameter);
void M_MMI_MMS_DRAWAIBUM_IND(T_MMI_MMS_DRAWAIBUM_IND * parameter);
void M_MMI_MMS_MIMNGRINIT_IND(T_MMI_MMS_MIMNGRINIT_IND * parameter);


void S_MMS_MMI_READY_CNF(T_MMS_MMI_READY_CNF * parameter);
void S_MMS_MMI_PLAYERINITIALIZE_CNF(T_MMS_MMI_PLAYERINITIALIZE_CNF * parameter);
void S_MMS_MMI_MMSBITBLT_IND(T_MMS_MMI_MMSBITBLT_IND * parameter);
void S_MMS_MMI_DRAWPOINT_IND(T_MMS_MMI_DRAWPOINT_IND * parameter);
void S_MMS_MMI_DRAWTEXT_IND(T_MMS_MMI_DRAWTEXT_IND * parameter);
void S_MMS_MMI_DRAWFILLRECT_IND(T_MMS_MMI_DRAWFILLRECT_IND * parameter);
void S_MMS_MMI_REFRESHWINDOW_IND(T_MMS_MMI_REFRESHWINDOW_IND * parameter);



void   psa_MMS_MMI_IND (BYTE event_id,void* data, USHORT data_size);

/*************
event id
**************************/
typedef enum
{
	M_MMI_MMS_PLAYERONDRAW_IND_ID,//player_on_draw
	M_MMI_MMS_MSETCMSG_IND_ID,//manager_set_currentmessage, 
	M_MMI_MMS_EDTONINIT_IND_ID,//editor_on_initialize
	M_MMI_MMS_PLAYERONPAGE_IND_ID,//player_on_pageXXX
	M_MMI_MMS_PLAYERINITIALIZE_IND_ID,//player_initialize
	M_MMI_MMS_DRAWAIBUM_IND_ID,//MMS_DrawXXXAlbum
	M_MMI_MMS_TMCBFN_IND_ID,//MMS_TimerCallBackFn
	M_MMI_MMS_MIMNGRINIT_IND_ID,
	
	S_MMS_MMI_READY_CNF_ID = 0x80,
	S_MMS_MMI_PLAYERINITIALIZE_CNF_ID,
	S_MMS_MMI_MMSBITBLT_IND_ID,//MMS_BitBlt
	S_MMS_MMI_DRAWPOINT_IND_ID,
	S_MMS_MMI_DRAWTEXT_IND_ID,
	S_MMS_MMI_DRAWFILLRECT_IND_ID,
	S_MMS_MMI_REFRESHWINDOW_IND_ID,
};

#endif
