
#ifndef _MMS_WAP_INTERFACE_H_
#define _MMS_WAP_INTERFACE_H_

#define NEW_MMI_MMS_INTERFACE

typedef enum _MMS_WAP_EVENT_TYPE
{
	NET_ERROR=0,
	NET_CONFIGURE_CNF,
	NET_CLOSE_CNF,
	NET_CANCEL_CNF,
	NET_POST_CNF,
	NET_GET_CONTENT_IND,
	/*added by JeffreyYao, 1-15-2004*/
	NET_PUSH_IND
}MMS_WAP_EVENT_TYPE;

/* define for wap open */
typedef struct _CONFIGURE_CNF_DATA_Tag
{
	int		status;
}CONFIGURE_CNF_DATA, *pCONFIGURE_CNF_DATA;

/* define for wap post */
typedef struct _POST_CNF_DATA_Tag
{
	int		status;
	char	*filename;
}POST_CNF_DATA, *pPOST_CNF_DATA;

/* define for wap get */
typedef struct _GET_CONTENT_IND_DATA_Tag
{
	int		status;
	char	*filename;
}GET_CONTENT_IND_DATA, *pGET_CONTENT_IND_DATA;

/* define for wap close */
typedef struct _CLOSE_CNF_DATA_Tag
{
	int		status;
}CLOSE_CNF_DATA, *pCLOSE_CNF_DATA;

/* define for wap cancel */
typedef struct _CANCEL_CNF_DATA_Tag
{
	int		status;
}CANCEL_CNF_DATA, *pCANCEL_CNF_DATA;


/************************************* 
		define for PUSH indication 
	added by JeffreyYao, 1-15-2004
**************************************/
typedef struct _PUSH_IND_DATA_Tag
{
	char	*filename;
	int		status;
	//־һPUSHϢǷǿ,--JeffreyYao 1-17-2004
	//1Ϊǿ
	char	forcerecv;
}PUSH_IND_DATA, *pPUSH_IND_DATA;


typedef struct _WAP_MMS_EVENTTag
{
	MMS_WAP_EVENT_TYPE	type;
	union
	{
		pCONFIGURE_CNF_DATA		pconfiguredata;
		pCLOSE_CNF_DATA			pclosedata;
		pCANCEL_CNF_DATA		pcanceldata;
		pPOST_CNF_DATA			ppostdata;
		pGET_CONTENT_IND_DATA	pgetdata;
		//added by JeffreyYao, 1-15-2004
		pPUSH_IND_DATA			ppushdata;
	}data;
}WAP_MMS_EVENT, *pWAP_MMS_EVENT;

#ifdef NEW_MMI_MMS_INTERFACE
typedef enum
{
	MMS_NEW_NOTIF,  // յµNOTIFICATION,  ԶʱMMSʧʱʾ
	MMS_NEW_MMS,  // ԶպʾյµMMS
	MMS_DELIVERY,    // յʹﱨ棬Ҫݷ
	MMS_RETRIVE,  //ûֶMMSɹ
	MMS_SEND  //sendwapյconfirm
}MMI_MMS_EVENT_TYPE;

typedef enum
{
 	MMI_MMS_FAILED = 0,
 	MMI_MMS_SUCCESS,
 	MMI_MMS_CANCLED,
 	MMI_MMS_BAD_PDU
}MMI_MMS_EVENT_STATUS;

typedef struct _MMI_NEW_NOTIF_DATA_Tag
{
	MMI_MMS_EVENT_STATUS	status;
	char*   filename; 
}MMI_NEW_NOTIF_DATA, *pMMI_NEW_NOTIF_DATA;

typedef struct _MMI_NEW_MMS_DATA_Tag
{
	MMI_MMS_EVENT_STATUS	status;
	char*   filename; 
}MMI_NEW_MMS_DATA, *pMMI_NEW_MMS_DATA;

typedef struct _MMI_DELIVERY_DATA_Tag
{
	char*   sender; 
}MMI_DELIVERY_DATA, *pMMI_DELIVERY_DATA;

typedef struct _MMI_RETRIVE_DATA_Tag
{
	MMI_MMS_EVENT_STATUS	status;
	char*  filename;
}MMI_RETRIVE_DATA, *pMMI_RETRIVE_DATA;

typedef struct _MMI_SEND_DATA_Tag
{
	MMI_MMS_EVENT_STATUS	status;
}MMI_SEND_DATA, *pMMI_SEND_DATA;

typedef struct _MMI_MMS_EVENT_Tag
{
	MMI_MMS_EVENT_TYPE   type;
	union
	{
		pMMI_NEW_NOTIF_DATA  pnew_notif_data;
		pMMI_NEW_MMS_DATA    pnew_mms_data;//statusΪ0ʱɾµmmsļ
		pMMI_DELIVERY_DATA    pdelivery_data;
		pMMI_RETRIVE_DATA      pretrive_data;
		pMMI_SEND_DATA          psend_data;
	}data;
}MMI_MMS_EVENT, *pMMI_MMS_EVENT;
#else
typedef enum
{
	MMS_NEW_MMS,
	MMS_NEW_PUSH,
	MMS_DELIVERY,
	MMS_SEND_OK,//sendwapյconfirm

	MMS_BAD_PDU//WAPʾdestroy mmsṹ
}T_NEW_MMS_TYPE;

#endif

#if __cplusplus 
extern "C" {
#endif
	
int MMS_WAP_Open(void);

int MMS_WAP_Close(void);

int MMS_WAP_Cancel();

//int MMS_WAP_Send(unsigned char *data_p, int size, char *mmscaddr);
//modified by JeffreyYao, 1-7-2004
int MMS_WAP_Send(char *filename, char *mmscaddr);

int MMS_WAP_Recv(char *filename, char *url);

#ifdef NEW_MMI_MMS_INTERFACE
void MMS_MMI_NewMMS_notification(pMMI_MMS_EVENT event);
#else
void MMS_MMI_NewMMS_notification(T_NEW_MMS_TYPE type);
#endif

void MMS_Close_All(void);

#if __cplusplus 
}
#endif
	
#endif





















