#$history#	
#
#	2004-06-28 Robert.Chen created for MMS integration
#
#

include $(CONDAT_BASE_DIR)/condat_lib_ip.mak
OBJ := $(SRCMMS)/obj$(LMSZ)
#
# Settings for the compilation process
# depending whether traces will be compressed or not
#
ifeq ($(CTRACE), 0)
# without str2ind - compilation only
PRE := $(CC) -c
INT := @echo OLD STYLE TRACES - the following file will not be build:
COM := @echo OLD STYLE TRACES - the following file will not be build:
else
# with str2ind - preprocessing, str2ind, compilation
PRE := $(CC) -po -p?
INT := str2ind -a -l $(STR2IND_LOG) -t $(STR2IND_TAB) -v $(STR2IND_C) -f
COM := $(CC) -c
endif

MMSOPT :=
ifeq ($(MMSTRACE), 1)
MMSOPT += -dMMSTRACE_EN=1
else
MMSOPT += -dMMSTRACE_EN=0
endif

ifeq ($(TK),1)	
COPT1 += -dSIM_TOOLKIT
else
COPT1 += -uSIM_TOOLKIT
endif

INC_WAPMMI	= -I$(SRCWAPMMI)/src -I$(SRCWAPMMI)/inc 

INC_MISC	= -I$(TOP_DIR)/$(SYSTEM_DIR)/main  -I$(TOP_DIR)/$(SYSTEM_DIR)/config -I$(TOP_DIR)/../services/audio
INC_RIV		= -I$(TOP_DIR)/$(RIVIERA_DIR)/rv -I$(TOP_DIR)/$(RIVIERA_DIR)/rvf
INC_CONDAT	= -I$(SRCMFW) -I$(SRCACI) -I$(SRCKSD) -I$(GPF_DIR)/INC -I$(SRCBMI) -I$(SRCBMI)/icons

ifeq ($(ZHQ_MMI_BUILD),1)
INC_DRIVER  = -I$(TOP_DIR)/Drivers-lib-mmi/header
else
INC_DRIVER	= -I$(TOP_DIR)/../drivers/common/rtc -I$(TOP_DIR)/../drivers/board/ffs -I$(TOP_DIR)/../drivers/board/spi -I$(TOP_DIR)/../Layer1/tm_cust0 \
			  -I$(TOP_DIR)/../drivers/board/melody  -I$(TOP_DIR)/../drivers/common	-I$(TOP_DIR)/../drivers/board

ifeq ($(MIDICHIP), 1)
INC_DRIVER += -I$(TOP_DIR)/../drivers/board/melody/762
else
INC_DRIVER += -I$(TOP_DIR)/../drivers/board/melody/765
endif

endif



INC_MMS		= -I$(SRCMMS)/src -I$(SRCMMS)/inc   
		 
SRCOBJ = $(MMSOBJ)

MMSOBJ = $(OBJ)/mmiMMSDeleteAll.$(OBJ_TAIL) \
 	     $(OBJ)/mmiMMSFolders.$(OBJ_TAIL) \
 	     $(OBJ)/mmiMMSGlobalDef.$(OBJ_TAIL) \
 	     $(OBJ)/mmiMMSNew.$(OBJ_TAIL) \
 	     $(OBJ)/mmiMMSSetting.$(OBJ_TAIL) \
 	     $(OBJ)/mmiMMStoMobileSoft.$(OBJ_TAIL)\
 	     $(OBJ)/mmiMMSMenu.$(OBJ_TAIL)\
 	     $(OBJ)/mmiMMSffs.$(OBJ_TAIL)

ifeq ($(MMSTASK),1)
MMSOBJTASK= $(OBJ)/mms_pei.$(OBJ_TAIL) \
 	     $(OBJ)/mms_mmis.$(OBJ_TAIL) \
 	     $(OBJ)/mms_mmip.$(OBJ_TAIL) \
 	     $(OBJ)/mms_timer.$(OBJ_TAIL)
SRCOBJ += $(MMSOBJTASK)
endif
		
#
# Creating mms_mmi.lib
#

$(MMS_MMI_LIB) : $(OBJ) $(SRCOBJ)
	-$(PERL) $(CONDAT_DIR)/int/bin/make_ver.pl
	$(AR) r  $(MMS_MMI_LIB)  $(SRCOBJ) ver.$(OBJ_TAIL)

FORCE:

$(OBJ):	
	mkdir $(subst /,$(SLASH),$(OBJ))
	
clean: 
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(MMSOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCMMS)/src/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo -DAUS_CONDAT_TYPE_PORTING >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -D_MMS_ENABLE_ >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(MMSOPT) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INC_DRIVER) >> cmd
	echo $(INC_RIV) >> cmd
	echo -I$(CONDAT_BASE_DIR)/com/include >> cmd
	echo -I$(ICDG) >> cmd
#	echo -I$(IAUS) >> cmd
#	echo -I$(IGLE) >> cmd
#	echo -I$(IAUSC) >> cmd
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
#	echo $(ZHQDRV0) >> cmd
#	echo $(ZHQDRV1) >> cmd
#	echo $(ZHQDRV2) >> cmd
	echo $(INCDRV2) >> cmd
	echo -I$(SRCWAP) >> cmd
	echo -I$(INC_WAPMMI) >> cmd
	echo $(INC_CONDAT) >> cmd
	echo $(INC_MMS) >> cmd
#	echo $(INC_MISC) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd

ifeq ($(MMSTASK),1)
$(MMSOBJTASK): $(OBJ)/%.$(OBJ_TAIL) : $(SRCMMS)/src2/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo -DAUS_CONDAT_TYPE_PORTING >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo -D_MMS_ENABLE_ >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(MMSOPT) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INC_DRIVER) >> cmd
#	echo $(INC_RIV) >> cmd
	echo -I$(CONDAT_BASE_DIR)/com/include >> cmd
	echo -I$(ICDG) >> cmd
#	echo -I$(IAUS) >> cmd
#	echo -I$(IGLE) >> cmd
#	echo -I$(IAUSC) >> cmd
	echo -I$(SRCWAP) >> cmd
	echo $(INC_CONDAT) >> cmd
	echo $(INC_MMS) >> cmd
#	echo $(INC_MISC) >> cmd
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
#	echo $(ZHQDRV0) >> cmd
#	echo $(ZHQDRV1) >> cmd
#	echo $(ZHQDRV2) >> cmd
	echo $(INCDRV2) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd
endif


