#ifdef _MMS_ENABLE_

#define ENTITY_MFW

#include <string.h>
#include <stdio.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "p_sim.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_cm.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"

#include "dspl.h"

#include "MmiMmi.h"

#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMain.h"
#include "MmiStart.h"

#include "MmiMenu.h"

#include "MmiBookController.h"
#include "MmiBookUtils.h"

#include "MmiCall.h"
#include "MmiNetwork.h"
#include "MmiIcons.h"
#include "MmiEditor.h"


#include "MmiSounds.h"
#include "MmiUserData.h"
#include "MmiSoftKeys.h"
#include "MmiPins.h"

#include "MmiDialogs.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSettings.h"
#include "MmiSmsIdle.h"
#include "mfw_ffs.h"
#include "MmiSmsBroadcast.h"
#include "MmiCPHS.h"
#ifdef MMI_HOMEZONE_ENABLED
    #include "MmiHomezone.h"
#endif

#include "mmimms_cfg.h"
#include "ffs.h" 
#include "mms_clib.h"
#include "wap_interface.h"
#include "td.h"
#include "mmsgloble.h"
#include "mmiMMSGlobalDef.h"
#include "Rtc_api.h"

//#include "Zi8api.h"
//#include "Rvf_api.h"
#ifndef _INNOVATION_EMULATOR_
#include "melody_cfg.h"
#include "melody_struct_i.h"
#include "melody_api.h"
#include "melody_env.h"
#endif

#include "mmimmsmenu.h"
#include "mmiutilapi.h"

#ifdef MMI_MMSTASK_ENABLED
#define MMS_COMPILE_FORAPP
#include "mmstask.h"
#include "mms_timer.h"
#endif

/* define for FFS files */ 
#define MMS_FILENAME_LEN		20
#define MMS_PATHNAME_LEN		20
#define MMS_FILEFULLNAME_LEN	(MMS_FILENAME_LEN + MMS_PATHNAME_LEN + 1)

#define MMS_TIMECRITICAL	1	/* Robert.Chen add, 2004-07-15 */

/*talcon add, 2004.07.07 */ 
static int g_codememalloc = 0;
#if 1
#define MMS_new(ptr, size)  		MI_ALLOC(ptr, size,g_codememalloc)
#define MMS_free(ptr,size)      	MI_FREE(ptr, g_codememalloc)
#else
#define MMS_new(ptr, size)  \
	ptr = (void *)mfwAlloc(size);\
	if(ptr ==0)\
		g_codememalloc  = 1;\
	else\
		g_codememalloc  = 0;
#define MMS_free(ptr,size)      			mfwFree((U8*)ptr, size)
#endif

/*end talcon add*/

BOOL isIncomingCall = FALSE;

#define TOLOWER(c) ((c) >= 'A' && (c) <= 'Z' ? (c) - 'A' + 'a' : (c))
#define UNI_TOLOWER(c)  ((c)>=0x41 &&(c)<=0x5a ? (c)+0x20 : (c))

extern void AscEx_To_Unicode(MMS_S8* ascEx_txt, MMS_S8* uni_txt);

//add by xie 04-07-31 for configuring the max size of mms file
#define MMS_MAX_SIZE    (1024*80) 
MMS_U32  MMS_Get_Maxsize()
{
	return MMS_MAX_SIZE;
}

//ַΪգNULL0򷵻ַռֽڵĸunicodeȥͷβֽڣASCIIȥβһֽ
MMS_U32 MMS_strlen(const MMS_S8* str)
{	
#if (MMS_TIMECRITICAL == 0)
	return((MMS_U32)wstrlen(str));
#else
	unsigned int len = 0;
	
	if(!str)
		return 0;

	if((unsigned char)*str != 0x80)
	{
		while(*str++ != 0)
			len++;
	}
	else
	{
		str++;
		len++;

		while (((unsigned char)*str<<8)+(unsigned char)*(str+1) != 0)
		{
			len += 2;
			str += 2;
		}
	}

	return len;	
#endif
}

MMS_S8 *MMS_strstr(const MMS_S8 *str, const MMS_S8 *find)
{

	MMS_S32 len,lenth;
	MMS_S8 *point,*find2;
	MMS_S32 flag=0;
	
	
	if( (MMS_U8)*str != 0x80 && (MMS_U8)*find != 0x80 )
	{	
		return strstr(str, find);
	}
	else if((MMS_U8)*str == 0x80 && (MMS_U8)*find == 0x80)
	{
		len = MMS_strlen(find);
		if((MMS_U8)*find == 0x80)
			len -= 1;
			
		point = (MMS_S8 *)(str+1);  //ָָǰλ,strõ
		find2 = (MMS_S8 *)(find+1);
		lenth = len;
		while(lenth!=0)
		{
			if((MMS_S8)(*point) == (MMS_S8)(*find2))
			{
				lenth--;
				point++;
				find2++;
			}
			else
			{
				str++;
				point= (MMS_S8 *)str;
				find2= (MMS_S8 *)(find+1);
				lenth=len;
				if(1==flag&&0==*str)
					return NULL;
				if(0==*str)
				{
					flag=1;
				}else{
					flag=0;
				}			
			}
		}
		return (MMS_S8 *)str;		
	}
	else
		return NULL;

}

MMS_S8 *MMS_strcpy (MMS_S8 *dst,  const MMS_S8 *src)
{
#if (MMS_TIMECRITICAL == 0)
	if(src == NULL || dst == NULL)
		return NULL;	

	wstrcpy(dst, src);
	return dst;
#else

	char *dsttmp = dst;

	if(src == NULL || dst == NULL)
		return NULL;
		
	if((unsigned char)*src != 0x80)
	{
		while((unsigned char)*src != 0)
		{
			*dsttmp++ = *src++;
		}

		*dsttmp = 0;
	}	
	else
	{
		*dsttmp++ = *src++;		
		
		while((unsigned short)(((unsigned char)*src<<8)+((unsigned char)*(src+1))) != 0)
		{
			*dsttmp++ = *src++;
			*dsttmp++ = *src++;
		}

		*dsttmp++	= 0;
		*dsttmp		= 0;
	}	
	return dst;	
#endif
	
}

//ΪunicodenumΪunicodeͷ\x80ֽڸ
MMS_S8 	  *MMS_strncpy (MMS_S8 *dst, const MMS_S8 *src, MMS_U32 num)
{
#if (MMS_TIMECRITICAL == 0)
	unsigned int tmplen = num;
	int lenth = wstrlen((char *)src);

	if(src == NULL || dst == NULL)
		return NULL;

	if((unsigned char)*src == 0x80)
		tmplen += 1;
		
	if(lenth > tmplen)
		lenth = tmplen;
		
	memcpy(dst, src, lenth);
	dst[lenth] = 0;
	
	if((unsigned char)*src == 0x80)
		dst[lenth+1] = 0;

	return dst;
#else
	char *dsttmp = dst;
	
	if(src == NULL || dst == NULL)
		return NULL;

	if((unsigned char)*src != 0x80)	//ASCII
	{
		while(*src != 0 && num)
		{
			*dsttmp++ = *src++;
			num--;
		}
		*dsttmp = 0;
	}
	else //Unicode
	{
		*dsttmp++ = *src++;
		while((unsigned short)(((unsigned char)*src<<8)+((unsigned char)*(src+1))) != 0 && num)
		{
			*dsttmp++ = *src++;
			*dsttmp++ = *src++;
			num -= 2;
		}

		*dsttmp++	= 0;
		*dsttmp		= 0;
	}

	return dst;
#endif
}

MMS_S32 MMS_strcmp (MMS_S8 *str1,  const MMS_S8* str2)
{
#if (MMS_TIMECRITICAL == 0)
	MMS_S32 ret;
	char *ss1 = str1;
	const char *ss2 = str2;
	if((unsigned char)*ss1 == 0x80 && (unsigned char)*ss2 == 0x80)
	{
		ret = wstrcmp((unsigned short*)(ss1+1),(unsigned short *)(ss2+1));
		if(ret > 0 )
			return 1;
		else if (ret == 0)
			return 0;
		else 
			return -1;
	}
	else if((U8)*ss1 != 0x80 && (U8)*ss2 != 0x80)
	{
		ret = strcmp(ss1, ss2);
    	return ret;
	}
	else
		return -2;
#else
	char *ss1 = str1;
	const char *ss2 = str2;
	short diff;
	unsigned short uch;
	
	if((unsigned char)*ss1 != 0x80 && (unsigned char)*ss2 != 0x80)
	{		
		while((diff = (*ss1 - *ss2)) == 0 && (unsigned char)*ss1)
		{
			ss1++;
			ss2++;
		}
	}
	else if((unsigned char)*ss1 == 0x80 && (unsigned char)*ss2 == 0x80)
	{
		ss1++;
		ss2++;
		uch = ((unsigned char)*ss1<<8) + (unsigned char)*(ss1+1);
		while((diff = (uch - (((unsigned char)*ss2<<8) + (unsigned char)*(ss2+1)))) == 0 && uch)
		{
			ss1 += 2;
			ss2 += 2;
			uch = ((unsigned char)*ss1<<8) + (unsigned char)*(ss1+1);	
		}
	}
	else
		return -2;

	if(diff > 0)
		return 1;
	else if(diff < 0)
		return -1;

	return 0;	
#endif
}

MMS_S8 *MMS_strcat (MMS_S8 *str,  const MMS_S8 *append)
{
#if (MMS_TIMECRITICAL == 0)
	char *tmpstr;
	unsigned char *ss1=(unsigned char*)str;
	unsigned char *ss2=(unsigned char*)append;
	int len1 = wstrlen((char*)ss1);
	int len2 = wstrlen((char*)ss2);
	
	if ((MMS_U8)*ss1 != 0x80 && (MMS_U8)*ss2 != 0x80)
	{
		memcpy(&str[len1],ss2,len2);
		str[len1+len2]=0x00;
	} 
	else if ((MMS_U8)*ss1 == 0x80 && (MMS_U8)*ss2 == 0x80)
	{
		memcpy(&str[len1],&ss2[1],len2-1);
		str[len1+len2-1]=0;
		str[len1+len2]=0;
	} 
	else if ((MMS_U8)*ss1 == 0x80 && (MMS_U8)*ss2 != 0x80)
	{
		int sizeAlloc;
		MMS_new(tmpstr, sizeAlloc = 2*len2+3);
		AscEx_To_Unicode((char *)ss2, tmpstr);
		memcpy(&str[len1],&tmpstr[1],2*len2);
		str[len1+2*len2]=0;
		str[len1+2*len2+1]=0;
		
		MMS_free(tmpstr, sizeAlloc);
	}
	else if ((MMS_U8)*ss1 != 0x80 && (MMS_U8)*ss2 == 0x80)
	{
		int sizeAlloc;
		MMS_new( tmpstr, sizeAlloc = 2*len1+3);
		AscEx_To_Unicode((char *)ss1, tmpstr);
		memcpy(str,tmpstr,2*len1+1);
		memcpy(&str[2*len1+1],&ss2[1],len2-1);
		str[2*len1+len2]=0;
		str[2*len1+len2+1]=0;
		
		MMS_free(tmpstr,sizeAlloc);
	}
	return str;
#else
	char *strtmp = str;
	char *aptmp = (char*)append;
	char *tmpstr;
	int len1, len2;
	
	if((unsigned char)*strtmp != 0x80 && (unsigned char)*aptmp != 0x80)
	{
		while(*strtmp != 0)
			strtmp++;
			
		while(*aptmp != 0)		
			*strtmp ++ = *aptmp++;
		
		*strtmp = 0;
	}
	else if((unsigned char)*strtmp == 0x80 && (unsigned char)*aptmp == 0x80)
	{
		strtmp++;
		aptmp++;
		while((((unsigned char)*strtmp<<8) + ((unsigned char)*(strtmp+1))) != 0)
			strtmp += 2;

		while((((unsigned char)*aptmp<<8) + ((unsigned char)*(aptmp+1))) != 0)	
		{
			*aptmp++ = *strtmp++;
			*aptmp++ = *strtmp++;
		}

		*strtmp++	= 0;
		*strtmp		= 0;
	}
	else if ((MMS_U8)*strtmp == 0x80 && (MMS_U8)*aptmp != 0x80)
	{
		int sizeAlloc;

		len1 = wstrlen((char*)str);
		len2 = wstrlen((char*)append);
	
		MMS_new(tmpstr, sizeAlloc = 2*len2+3);
		AscEx_To_Unicode((char *)aptmp, tmpstr);
		memcpy(&str[len1],&tmpstr[1],2*len2);
		str[len1+2*len2]=0;
		str[len1+2*len2+1]=0;
		
		MMS_free(tmpstr, sizeAlloc);
	}
	else if ((MMS_U8)*strtmp != 0x80 && (MMS_U8)*aptmp == 0x80)
	{
		int sizeAlloc;

		len1 = wstrlen((char*)str);
		len2 = wstrlen((char*)append);
		MMS_new( tmpstr, sizeAlloc = 2*len1+3);
		AscEx_To_Unicode((char *)strtmp, tmpstr);
		memcpy(str,tmpstr,2*len1+1);
		memcpy(&str[2*len1+1],&aptmp[1],len2-1);
		str[2*len1+len2]=0;
		str[2*len1+len2+1]=0;
		
		MMS_free(tmpstr,sizeAlloc);
	}
	return str;
#endif
}

#if 0
//no
MMS_S32    MMS_strncmp (MMS_S8 *str1,  const MMS_S8 *str2,  MMS_U32 num)
{
	MMS_S32 ret;
	char *ss1 = str1;
	const char *ss2 = str2;
	if((unsigned char)ss1[0] == 0x80 && (unsigned char)ss2[0] == 0x80)
	{
		ret = wstrncmp((unsigned short*)(ss1+1),(unsigned short *)(ss2+1));
		if(ret > 0 )
			return 1;
		else if (ret == 0)
			return 0;
		else 
			return -1;
	}
	else if((unsigned char)ss1[0] != 0x80 && (unsigned char)ss2[0] != 0x80)
	{
		ret = strncmp(ss1, ss2 ,num);
		return ret;
	}
	else
		return -2;
/*
	MMS_S32 ret; 
	ret = wstrncmp(str1, str2, num);
	return ret;*/
}

//no
MMS_S32    MMS_strcasecmp (MMS_S8 *str1, MMS_S8 *str2)
{
    if ((str1 == 0)||(str2 == 0))
    {
        return(1);
    }
    
    if((MMS_U8)*str1==0x80&&(MMS_U8)*str2!=0x80
    	||(MMS_U8)*str1!=0x80&&(MMS_U8)*str2==0x80)
    	return(1);
    	
    	
    	if((MMS_U8)*str1==0x80&&(MMS_U8)*str2==0x80)
    	{
    		str1++;
    		str2++;
    		while(((*str1<<8)+*(str1+1)!=0)
    			&&((*str2<<8)+*(str2+1)!=0))
    		{
    			if(UNI_TOLOWER((MMS_U8)*(str1+1))!=UNI_TOLOWER((MMS_U8)*(str2+1)))
    			{
    				return(1);
    			}
    			str1+=2;
    			str2+=2;
    		}
    		if(((*str1<<8)+*(str1+1)==0)&&((*str2<<8)+*(str2+1)==0))
    		{
    			return(0);
    		}
    		else
    		{
    			return(1);
    		}
    	}
    	else
    	{
	
    /*
	* While not at the end of the string, if they ever differ
	* they are not equal.
	*/
	    while ((*str1 != '\0')&&(*str2 != '\0'))
	    {
	        if (TOLOWER((MMS_U8) *str1) != TOLOWER((MMS_U8) *str2))
	        {
	            return(1);
	        }
	        str1++;
	        str2++;
	    }
		
	    /*
		* One of the strings has ended, if they are both ended, then they
		* are equal, otherwise not.
		*/
	    if ((*str1 == '\0')&&(*str2 == '\0'))
		{
	        return(0);
		}
	    else
		{
	        return(1);
		}
	}
}

//no
//ΪunicodenumΪunicodeͷ\x80ֽڸ
MMS_S8 	  *MMS_strncat (MMS_S8 *str,  const MMS_S8 *append, MMS_U32 num)
{
	int lenth=wstrlen(append);
	int tmplen=num;

	char *ss = NULL;
	int sizeAlloc;
	
	MMS_new( ss, sizeAlloc = lenth+2);
	if ((unsigned char)*append==0x80)
		tmplen+=1;
	if (lenth>=tmplen)
		lenth=tmplen;
	memcpy(ss,append,lenth);
	ss[lenth]=0;
	ss[lenth+1]=0;
	MMS_strcat(str,ss);

	MMS_free(ss, sizeAlloc);
	return str;
	
}
#endif

MMS_VOID MMS_free_big2(MMS_VOID *ptr,MMS_S32 size)
{
	MMS_TRACE_EVENT(("MMS_free_big2: %d",size));
	MMS_free(ptr,size);
    return;
}

MMS_VOID *MMS_malloc_big(MMS_S32 line, MMS_U32 size)
{
	MMS_VOID *address = NULL;

	MMS_TRACE_EVENT(("MMS_malloc_big: %d",size));
	
	MMS_new(address,size);
	if(g_codememalloc != EC_MMIMEM_OK)
	{
		MMS_TRACE_EVENT(("******MMS_malloc_big fail: %d!!******",g_codememalloc));
	}
	return address;
}

#if 0
MMS_VOID 	MMS_free_big(MMS_S32 line, MMS_VOID *ptr)
{
	MMS_TRACE_EVENT(("MMS_free_big: %p",ptr));
	return;
}
#endif

MMS_VOID 	MMS_memset(MMS_VOID *ptr, MMS_U8 value, MMS_U32 size)
{
	memset(ptr,value,size);
	return;
}

MMS_VOID MMS_memcpy(MMS_VOID *dptr, MMS_VOID *sptr, MMS_U32 size)
{
	memcpy(dptr,sptr,size);
	return;
}

MMS_VOID 	*MMS_remalloc(MMS_VOID *address, MMS_U16 oldsize, MMS_U16 size )
{
	MMS_VOID *address2 = NULL;

	MMS_TRACE_EVENT(("MMS_remalloc: %d, %d",oldsize,size));
#if 0	
	address2 =MMS_malloc_big(__LINE__,size);
	if(address2 == NULL)
	{	
		MMS_TRACE_EVENT(("******MMS_remalloc fail!!******"));
		MMS_free_big2(address, oldsize);
		return address2;

	}
#else
	MMS_new(address2, size);
	if(g_codememalloc != EC_MMIMEM_OK)
	{
		MMS_TRACE_EVENT(("******MMS_malloc_big fail: %d!!******",g_codememalloc));
		MMS_free(address, oldsize);
		return NULL;
	}
#endif
	
	memcpy(address2, address, oldsize);
	
	//MMS_free_big2(address, oldsize);
	MMS_free(address, size);
	return address2;
}
/*************************************************************/
/***************ļӿ**********************************/
/*************************************************************/

//ɹļ򷵻0
MMS_FILE MMS_fopen(MMS_S8 *filename, const MMS_S8 *option)
{
#ifdef _INNOVATION_EMULATOR_
	char fullName[254];
	MMS_FILE	fp;
    char path[128];
	
	GetCurrentDirectoryA(sizeof(path),path);
	strcat(path,"\\filesystem");
	strcat(path, filename);
	fp = fopen(path,option);
	if(fp <= 0)
		return 0;
	return fp;

#else
	MMS_FILE	fp;
	MMS_U16		style=0;

	MMS_TRACE_EVENT (("MMS_fopen(): %s %s",filename,option));
	
	if(MMS_strstr(option, "w"))
	{
		ffs_remove(filename);
		style |= FFS_O_WRONLY;
		style |= FFS_O_CREATE;
	}
	else if(MMS_strstr(option, "r"))
	{
		style |= FFS_O_RDONLY;
	}
	else if(MMS_strstr(option, "a"))
	{
		style |= FFS_O_WRONLY;
		style |= FFS_O_APPEND;
	}
	
	fp = ffs_open((const MMS_S8 *)filename, style);
	MMS_TRACE_EVENT (("MMS_fopen(): get fp=%d", fp));
	if(fp<=0)
	{
		MMS_TRACE_EVENT (("MMS_fopen:error,fp=%d", fp));
		return 0;
	}
	
	return fp; 
#endif	   
}

//ɹ10
MMS_BOOL 	MMS_fclose(MMS_FILE fp)
{
#ifdef _INNOVATION_EMULATOR_
	int ret;
	ret = fclose(fp);
	return ret;
#else
	signed char r ;

	MMS_TRACE_EVENT( ("MMS_fclose:%d", fp) );
	
	r = ffs_close(fp);
	if(r==EFFS_OK)
	{			
		return 1;
	}
	else
	{
		MMS_TRACE_EVENT( ("MMS_fclose:err! fp=%d, ret=%d", fp, r));
		return 0;
	}
#endif	
}

MMS_U32 	MMS_fread(MMS_VOID *buf, MMS_U32 size, MMS_U32 times, MMS_FILE fp)
{
#ifdef _INNOVATION_EMULATOR_
	int ret;
	ret = fread(buf,size,times,fp);
	return ret;
#else
	MMS_S32 ts;
	MMS_TRACE_EVENT(("MMS_fread: fp=%d, bytes=%d", fp, size*times));
	ts = ffs_read(fp, buf, size*times);

	MMS_TRACE_EVENT(("MMS_fread: fp=%d, get %d bytes", fp, ts));
	if(ts>0)
	{
		return (ts/size);
	}
	else
	{
		return 0;
	}
#endif	
}

MMS_U32 	MMS_fwrite(MMS_VOID *buf, MMS_U32 size, MMS_U32 times, MMS_FILE fp)
{
#ifdef _INNOVATION_EMULATOR_
	int ret;
	if(buf == NULL || size <= 0)
		return 0;

	ret = fwrite(buf,size,times,fp);
	return ret;
#else
	MMS_S32 ts;
	MMS_TRACE_EVENT(("MMS_fwrite: fp=%d, bytes=%d", fp, size*times));
	
	if(buf == NULL || size == 0)
		return 0;	

	ts = ffs_write(fp, buf, size*times);

	MMS_TRACE_EVENT(("MMS_fwrite: fp=%d, %d bytes writed", fp, ts));
	
	if(ts>0)
	{
		return (ts/size);
	}
	else
	{
		MMS_TRACE_EVENT(("MMS_fwrite: err! fp=%d, ret=%d", fp, ts));
		return 0;
	}
#endif 	
}

MMS_S32 	MMS_fseek(MMS_FILE fp, MMS_S32 size, MMS_S32 base)
{
#ifdef _INNOVATION_EMULATOR_
	int ret;
	ret = fseek(fp, size, base);
	return ret;
#else	
	MMS_S32 i;
	MMS_TRACE_EVENT(("MMS_fseek: fp=%d, sz=%d, base=%d", fp, size, base));
	i = ffs_seek(fp, size, base);
	return i;
#endif		
}

MMS_S32 	MMS_ftell(MMS_FILE fp)
{
#ifdef _INNOVATION_EMULATOR_
	int ret;
	ret = ftell(fp);
	return ret;
#else
	MMS_S32 i;		
	i =  MMS_fseek(fp, 0, MMS_SEEK_CUR);
	MMS_TRACE_EVENT(("MMS_ftell: fp=%d, pos=%d", fp, i));
	return i;
#endif 	
}

//ɹ1򷵻0
MMS_S32 	MMS_deletefile(MMS_S8 *filename, MMS_S8 *path)
{
#ifdef _INNOVATION_EMULATOR_
	MMS_S8 fullname[128];
	char appPath[128];	

	if(!filename)
	{
		return 0;
	}
	GetCurrentDirectoryA(sizeof(appPath),appPath);
	strcpy(fullname,appPath);
	strcat(fullname,"\\filesystem");
	strcat(fullname,path);
	strcat(fullname,filename);	
	if(remove(fullname))
	{
		return 1;  
	}
	else
	{
		return 0;
	}

#else

	MMS_S8 fullname[MMS_FILEFULLNAME_LEN];	
	
	MMS_TRACE_EVENT(("MMS_deletefile():file \"%s\", path \"%s\"", filename, path));

	if(!filename || !path)
	{
		return 0;
	}
	MMS_TRACE_EVENT(("MMS_deletefile:%s %s ",path ,filename));

	sprintf(fullname,"%s%s", path,filename);
	
	if(EFFS_OK == ffs_remove(fullname))
	{
		MMS_TRACE_EVENT(("MMS_deletefile success "));
		return 1;  
	}
	else
	{
		MMS_TRACE_EVENT(("MMS_deletefile failed "));
		return 0;
	}
#endif 
	
}

//ɹ1򷵻0
MMS_S32 	MMS_deletefiles(MMS_S8 *pathname)
{
#ifdef  _INNOVATION_EMULATOR_
	MMS_S8 fullname[128];
	MMS_S8 path[128];
	int len;
	WIN32_FIND_DATA FileData; 
	HANDLE hSearch; 
	BOOL fFinished = FALSE; 
	BOOL isDirectory;
	int nfiles = 0;
	int i = 0;

	GetCurrentDirectoryA(sizeof(path),path);
	strcat(path,"\\filesystem");
	strcat(path, pathname);
	strcpy(fullname, path, strlen(path));
	strcat(fullname, "*.*");
	
	hSearch = FindFirstFileA(fullname, &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		return;
	} 
	  
	while (!fFinished) 
	{
		if( (FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0x00)
		{
			if(FileData.cFileName[0] != 0)
			{
				strcpy(fullname, path, strlen(path));
				strcat(fullname, FileData.cFileName);				
                remove(fullname);				
				nfiles ++;
			}
		}
		
		if (!FindNextFileA(hSearch, &FileData)) 
		{
			fFinished = TRUE; 
		}
	}	
	FindClose(hSearch );
				  
#else 
	T_FFS_DIR  sDir;
	int len;
//	MMS_S8 path[MMS_PATHNAME_LEN];
	MMS_S8 filename[MMS_FILENAME_LEN];
	MMS_S8 fullname[MMS_FILEFULLNAME_LEN];	
	int iRet=0;
	
	MMS_TRACE_EVENT(("MMS_deletefiles():path=\"%s\"", pathname));
	//MMS_DELAY(30);
	if(!pathname)
	{
		return 0;
	}

	strcpy(fullname, pathname);
	len = strlen(fullname);
	fullname[len-1] = '\0';
	
	if((iRet=ffs_opendir(fullname, &sDir)) > 0)
	{
		strcpy(fullname, pathname);
		memset(filename, 0, sizeof(filename));
		while((iRet = ffs_readdir(&sDir, filename, sizeof(filename))) > 0 )
		{
			MMS_TRACE_EVENT(("MMS_deletefiles():file names: %s", filename));
			fullname[len] = '\0';
			strcat(fullname, filename);
			ffs_remove(fullname);
		}
		
		//rvf_delay(10);

		if(iRet < 0 )
		{
			MMS_TRACE_EVENT(("MMS_deletefiles(): delete err, ret = %d", iRet));
			return 0;
		}	
		else
			return 1;
	}
	else
	{
		MMS_TRACE_EVENT(("MMS_deletefiles():open dir err = %d", iRet));
	}	

//	rvf_delay(10);
	return 0;

#endif 
}

//return 1 if file named by filename exist, otherwise 0
MMS_S32 MMS_fstat(MMS_S8 *filename)
{
#ifdef  _INNOVATION_EMULATOR_
	char fullName[254];
	MMS_FILE	fp;
    char path[128];
	int ret;
	
	GetCurrentDirectoryA(sizeof(path),path);
	strcat(path,"\\filesystem");
	strcat(path, filename);
	fp = fopen(path,"r");
	if(fp <= 0)
		return -1;
	ret = fseek(fp, 0, SEEK_END);
	ret  = ftell(fp);
	if(ret < 0)
		return -1;
	return ret;	
#else 
	T_FFS_STAT stat;
    //stat.flags == OF_READONLY;
	if(EFFS_OK == ffs_stat(filename, &stat))
	{
		if(stat.type == OT_FILE)
		{
		   MMS_TRACE_EVENT(("MMS_fstat:the size of %s =%d", filename, stat.size));
		   return stat.size;
		}
		else
		{
		   MMS_TRACE_EVENT(("MMS_fstat: %s is derectory",filename));
		   return -1;
		}
	}
	else
	{
        MMS_TRACE_EVENT(("MMS_fstat:error when open file %s", filename));
		return -1;
	}
	
#endif
}

/*************************************************************/
/***************ӿ**************************************/
/*************************************************************/
MMS_S8 	  *MMS_itoa (MMS_U32 value,  MMS_S8 *buf, MMS_U32 radix)
{
	//long          strtol (const char *st, char **endptr, int base);
	//unsigned long strtoul(const char *st, char **endptr, int base);
	//double        strtod (const char *st, char **endptr); //stdlib.h
	if(radix == 16)
	{
		sprintf(buf, "%.6x", value);
	}
	else
	{
		sprintf(buf, "%d", value);
	}
	return buf;
}

MMS_S32    MMS_atol(MMS_S8 *str)
{
	return (MMS_S32)atol(str); //stdlib.h
}

MMS_S32    MMS_getms()
{
	int	ms;
	MMS_TRACE_EVENT(("MMS_getms"));
//	srand((unsigned int)time(NULL));
	ms = rand();	
	return ms;
}

MMS_S32	   MMS_getrandstr(MMS_S8 *str)
{
	//modified by xie to avoid  there is .mms files with the same filename in /mms/message/ folder.	
	//04-07-09
#ifdef  _INNOVATION_EMULATOR_
	MMS_S8 fullname[128];
	MMS_S8 path[128];
	int len;
	WIN32_FIND_DATA FileData; 
	HANDLE hSearch; 
	BOOL fFinished = FALSE; 
	BOOL isDirectory;
	int nfiles = 0;
	int i = 0;
	
	GetCurrentDirectoryA(sizeof(path),path);
	strcat(path,"\\filesystem");
	strcat(path, "/mms/message/");

	while(1) 
	{
		HANDLE ret;
		memset(fullname, 0, sizeof(fullname));
		MMS_itoa(MMS_getms(), str, 10);
		strcpy(fullname, path, strlen(path));
		strcat(fullname,str);
		strcat(fullname, ".mms");
		if(INVALID_HANDLE_VALUE == FindFirstFileA(fullname, &FileData))
			return 1;
	}
		
#else
extern const char MMS_DIR[];
	T_FFS_STAT stat;
	char filename[MMS_FILEFULLNAME_LEN];
	
	MMS_TRACE_EVENT(("MMS_getrandstr"));
	if(!str)
	{
		return 0;
	}
	
	while(1) 
	{
		//memset(filename, 0, sizeof(filename));
		MMS_itoa(MMS_getms(), str, 10);
		sprintf(filename,"%s%s.mms", MMS_DIR, str);
		MMS_TRACE_EVENT(("%s",str));
		if(EFFS_NOTFOUND == ffs_stat(filename, &stat))
		{
			MMS_TRACE_EVENT(("produce new mms filename %s in MMS_getrandstr()",filename));
			return 1;
		}
	}
#endif	
}

MMS_S32	   MMS_time_ltoa(MMS_U32 datetime, char *timestr)
{
	TIMEDATE today;  
	T_RTC_DATE_TIME rtcTime;
	GetTimeDate(currdate.year, currdate.month, currdate.day, &today); 	
	RTC_GetDateTime(&rtcTime);

	sprintf(timestr, "%d-%d-%d %d:%d", currdate.year,currdate.month,currdate.day,rtcTime.hour,rtcTime.minute);
	return 1;
}

MMS_S32	   MMS_getsystemtime()
{
	return (MMS_S32)time(NULL);
}

/*************************************************************/
/***************ʾʱӿ*****************************/
/*************************************************************/
#define RGBX(r,g,b) (unsigned short)(((r/8)<<11)+((g/4)<<5)+(b/8))
#define IMAGE_BUFFER_SIZE (40*1024)
unsigned char image_buf[IMAGE_BUFFER_SIZE];

MMS_VOID MMSSetImageData(MMS_U8 value)
{
	memset(image_buf, value, IMAGE_BUFFER_SIZE);
	return;
}

MMS_U8  MMSSaveImageData(MMS_S8 *pixelData, MMS_U32  pixelNum, MMS_U32  pixelPos, MMS_U8 pixelType)
{
	unsigned char *img_buf = image_buf;
	int i = 0;
	
	if(pixelType == 1)
	{/* Gray Image */
	 		
		for(i = 0; i < pixelNum; i++)
		{
			*(img_buf +pixelPos*2 + i * 2 + 1) = *(pixelData + i);
			*(img_buf +pixelPos*2 + i * 2 + 0) = (char)0;
		}
	}
	else
	{/* 24 bit Color Image*/		
		for(i = 0; i < pixelNum; i++)
		{
			unsigned char r , g, b;
			unsigned short * pValue = (unsigned short *)(img_buf + pixelPos*2 + i * 2);
			r = *(pixelData + 3*i + 2);
			g = *(pixelData + 3*i + 1);
			b = *(pixelData + 3*i + 0);
		    *pValue = RGBX(r,g,b);
		}		
	}

	return 0;
}

MMS_S8 * MMSGetImageData(MMS_S32  pixelPos, MMS_U32  pixelNum)
{
	//MMS_TRACE_EVENT(("MMSGetImageData"));
	return (char*)(image_buf + pixelPos * 2);	
}

MMS_U8 MMSBitBlt( MMS_U32 posX,	MMS_U32 posY, MMS_U32 width, MMS_U32 height,MMS_VOID * BmpPtr)
{
	MMS_TRACE_EVENT(("MMSBitBlt: %d ,%d,%d,%d",posX,posY,width,height));
#if 0
	{
		typedef int OS_HANDLE; 
   		 extern  LONG os_GetTaskName (OS_HANDLE Caller, OS_HANDLE TaskHandle, char * Name);
		  extern OS_HANDLE os_MyHandle ( void );
		  char task[10];
		  os_GetTaskName(NULL,os_MyHandle(),task);
    		MMS_TRACE_EVENT(("task: %s",task));
   	}
#endif   	

#ifdef MMI_MMSTASK_ENABLED
	/*if(!IsWinFocus_MMSTask())
		return 0;
	return dspl_BitBlt(posX,posY,width,height,0,BmpPtr,DSPL_BMPCOPY);
	*/
	{
		T_MMS_MMI_MMSBITBLT_IND parameter;
		parameter.posX = posX;
		parameter.posY = posY;
		parameter.width = width;
		parameter.height = height;
		parameter.BmpPtr = BmpPtr;
		/*mmi taskMMS_BitBlt*/
		S_MMS_MMI_MMSBITBLT_IND(&parameter);
	}
#else
	return dspl_BitBlt(posX,posY,width,height,0,BmpPtr,DSPL_BMPCOPY);
#endif
}

#ifdef MMI_MMSTASK_ENABLED
MMS_U8 mmiMMSBitBlt( MMS_U32 posX,	MMS_U32 posY, MMS_U32 width, MMS_U32 height,MMS_VOID * BmpPtr)
{
	MMS_TRACE_EVENT(("mmiMMSBitBlt: %d ,%d,%d,%d",posX,posY,width,height));

	if(!IsWinFocus_MMSTask())
		return 0;
	
	return dspl_BitBlt(posX,posY,width,height,0,BmpPtr,DSPL_BMPCOPY);
}
#endif

/*talcon added for mms timer callback function*/
MMS_VOID * MMS_callbackfn = 0;
static int MMS_TimerCallBackFn(MfwEvt e, MfwTim *t)
{
	MMS_TRACE_EVENT(("MMS_TimerCallBackFn"));
#ifdef MMI_MMSTASK_ENABLED
	{
		extern BYTE get_mmstask_proc();
		if( get_mmstask_proc() )
		{
			MMS_TRACE_EVENT(("MMS_TimerCallBackFn:mms task in proc"));
			return 0;
		}
		else
		{
			T_MMI_MMS_TMCBFN_IND parameter;
			parameter.e = e;
			parameter.t = t;
			parameter.fn = MMS_callbackfn;
			M_MMI_MMS_TMCBFN_IND(&parameter);
		}
	}
#else
	((MfwCb)MMS_callbackfn)(e,t);
#endif
	return 0;
}

MMS_VOID	*MMS_settimer(MMS_S32 value, MMS_VOID * callback)
{
#ifdef MMI_MMSTASK_ENABLED
	MMS_TRACE_EVENT(("MMS_settimer"));
	return  mms_settimer(value,callback);
#else
	MMS_VOID *pTim;
	MMS_TRACE_EVENT(("MMS_settimer"));
	if(!callback)
	{
		MMS_TRACE_EVENT(("MMS_settimer():null callback!"));
		return NULL;
	}
	
	//pTim = timCreate(0,value,(MfwCb)callback);
	pTim = timCreate(mfw_parent (mfwFocus),value,(MfwCb)MMS_TimerCallBackFn);
	if(pTim)
	{
		timStart(pTim);
		MMS_callbackfn = callback;
		return pTim;
	}
	else
		return NULL;
#endif
}

MMS_S32		MMS_restarttimer(MMS_VOID *timer)
{
#ifdef MMI_MMSTASK_ENABLED
	MMS_TRACE_EVENT(("MMS_restarttimer"));
	return mms_restarttimer(timer);
#else
	MMS_TRACE_EVENT(("MMS_restarttimer"));
    	timStop(timer);
    	return (MMS_S32)timStart(timer);
#endif
}

MMS_S32		MMS_resettimervalue(MMS_VOID *timer, MMS_S32 fast)
{
#ifdef MMI_MMSTASK_ENABLED
	MMS_TRACE_EVENT(("MMS_resettimervalue"));
	return mms_resettimervalue(timer,fast);
#else
	MMS_TRACE_EVENT(("MMS_resettimervalue"));
	timStop(timer);
       return timSetTime(timer,fast);	 
#endif
}

MMS_S32		MMS_killtimer(MMS_VOID *timer)
{
#ifdef MMI_MMSTASK_ENABLED
	MMS_TRACE_EVENT(("MMS_killtimer"));
	return mms_killtimer( timer);
#else
	MMS_TRACE_EVENT(("MMS_killtimer"));
    	timStop(timer);
	MMS_callbackfn = 0;
    	return (MMS_S32)timDelete(timer);
#endif
}

MMS_U8		IsMMSLoseFocus(MMS_VOID)
{
  	MMS_TRACE_EVENT(("IsMMSLoseFocus()"));
 	return isIncomingCall;
}				 


MMS_U8 sys_getcharwidth(MMS_U8 ch)
{
//	MMS_TRACE_EVENT(("sys_getcharwidth(%c)",ch));
}


//Convert a UTF-8 byte sequence to a wide character.
//If the sequence is illegal or truncated by a NUL the first byte is
//returned.
//Does not include composing characters, of course.
unsigned short utf2unicode(unsigned char *p,int len)
{	
	if(!p)
		return 0;
	switch (len)
	{
	case 1:
	    return p[0];
	    /*lint -e527 */
		break;
		/*lint +e527 */		
	case 2:
		if ((p[1] & 0xc0) == 0x80)
		{
			return ((p[0] & 0x1f) << 6) + (p[1] & 0x3f);
		}
		break;
	case 3:
		if ((p[1] & 0xc0) == 0x80 && (p[2] & 0xc0) == 0x80)
		{
			return ((p[0] & 0x0f) << 12) + ((p[1] & 0x3f) << 6) + (p[2] & 0x3f);
		}
		break;
	default:
		break;
	}
	
	// Illegal value, just return the first byte 
	return p[0];
}


int unicode2utf(unsigned short unicode, char *word)
{
    word[0] = (0xe0 | (unicode>>12));
	word[1] = (0x80 | (unicode>>6&0x3f));
	word[2] = (0x80 | (unicode&0x3f));
	return 1;
}

MMS_S32	   MMS_char2utf8(MMS_S8 *strin, MMS_S8 *strout, MMS_S32 length )
{


	MMS_S32		outlen=0;
	MMS_U8	*p=(MMS_U8 *)(strin+1);
	
	MMS_U16	unicode;
	MMS_U8	word[4];
	MMS_TRACE_EVENT(("MMS_char2utf8"));

	if(!strin || !strout)
	{
		return 0;
	}
	
	if((MMS_U8)*strin != 0x80)
	{
		strcpy(strout,strin);
		return strlen(strin);
	}
	
	while(p[0] || p[1])
	{
		if((p[0]) == 0x00)
		{
			if(outlen < length)
			{
				strout[outlen++] = p[1];
				p +=2;
			}
			else
			{
				break;
			}
		}
		else
		{
			/* transfer from unicode ucs 16 to utf-8 */
			memset(word, 0, 3);
			unicode = (p[0]<<8)+p[1];
			unicode2utf(unicode, (MMS_S8 *)word);
			
			//printf("utf8 code: %.2x %.2x %.2x \r\n", word[0], word[1], word[2]);
			/* add word to strout buffer */
			strout[outlen++] = word[0];
			strout[outlen++] = word[1];
			strout[outlen++] = word[2];
			
			/* move strin buffer pointer */
			p += 2;
	
		}
	}
	strout[outlen] = 0;
	return outlen;
//#endif
}

MMS_S32	   MMS_utf82char(MMS_S8 *strin, MMS_S8 *strout, MMS_S32 length)
{

	MMS_S32 outlen=0;
	MMS_U8 *p=(MMS_U8 *)strin;
	MMS_S8 *pOut = strout;

	MMS_S32 len;
	MMS_U16	unicode;
	MMS_U8 word[2];
	
	// Lookup table to quickly get the length in bytes of a UTF-8 character from
	// the first byte of a UTF-8 string.  Bytes which are illegal when used as the
	// first byte have a one, because these will be used separately.
	static MMS_S8 utf8len_tab[256] =
	{
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, 
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, 
		2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
		3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,5,5,5,5,6,6,1,1,
	};

	MMS_TRACE_EVENT(("MMS_utf82char"));
	
	if(!strin || !strout)
	{
		return 0;
	}

	if(p[0]==0xef && p[1]==0xbb && p[2]==0xbf)
	{	//jump over identify bytes
		p += 3;
	}
	else if(p[0]==0xff && p[1]==0xfe)
	{	//jump over identify bytes 
		p += 2;
	}

	pOut[0] = '\x80';
	pOut++;

	while(p[0])
	{
		// get a utf-8 word 
		len = utf8len_tab[p[0]];
		if(len > (MMS_S32)strlen((MMS_S8*)p))
		{
			break;
		}

		// transfer it to unicode ucs-16, and  
		if(len>1)
		{
			//printf("utf8 code: %.2x %.2x %.2x \r\n", p[0], p[1], p[2]);
			unicode = utf2unicode(p, len);
		}
		else
		{
			//printf("utf8 code: %.2x \r\n", p[0]);
			unicode = p[0];
		}

		//printf("ucs2 code: %.4x \r\n", unicode);

		// transfer unicode to ansi gb2312 
		memset(word, 0, 2);
		if(len>1)
		{
			word[0] = (unicode&0xff00)>>8;
			word[1] = (MMS_S8)(unicode&0x00ff);
			//printf("gb code: %.2x %.2x \r\n", word[0], word[1]);
		}
		else
		{
			//printf("gb code: %.2x \r\n", word[0]);
			word[1] = p[0];
		}

		// add word to strout buffer 
		if(outlen <= length-len)
		{
			pOut[outlen++] = word[0];
            pOut[outlen++] = word[1];
		}
		else
		{
			break;
		}

		// move strin buffer pointer 
		p += len;
	}

	pOut[outlen] = 0;
	pOut[outlen+1] = 0;
	return outlen;
}

MMS_U8	   MMS_MidiStop(MMS_S8 *filename)
{
#ifndef _INNOVATION_EMULATOR_
	MMS_TRACE_EVENT(("MMS_MidiStop(%s)",filename));
	MI_PlayMusic_Stop();
	return 0;
#endif
}

MMS_U8	   MMS_MidiPlay(MMS_S8 *filename, MMS_U8 loop)
{
#ifndef _INNOVATION_EMULATOR_
	MMS_TRACE_EVENT(("MMS_MidiPlay(%s,%d)",filename, loop));
	MI_PlayFile_Start((const char*)filename, 0xff, loop);
	return 0;
#endif
}

MMS_VOID   MMS_Sleep(MMS_U32 ms)
{
#ifndef  MMI_MMSTASK_ENABLED
    //rvf_delay(ms);
    rvf_delay((MMS_U32)(ms+4)/5);	//convert ms to system tick(one tick = 4.62ms)
#endif
}

/*************************************
$Description:
	check free space for mms,if returnvalus is smaller than new mms size, 
	manager will handle it as autorecv is off
$Author: Talcon Hu
*****************************************/
MMS_S32    MMS_Get_Free_Space(MMS_VOID)
{
/*ps: this function is must be channge,ti is a dummy function to enable aoturecv talcon*/
	P_MMS mms  =getMMS();
	if(mms ->manager == 0)
		return 0;
	if(mms ->manager ->receivefolder ==0)
		return;
	TRACE_FUNCTION("MMS_Get_Free_Space");
	MMS_TRACE_EVENT(("MMS_Get_Free_Space:%d", 128000 - mms ->manager ->receivefolder->size));
	return 128000 - mms ->manager ->receivefolder->size;
}

MMS_U8		ECC_MidiStop(MMS_S8 *filename)
{
#ifndef _INNOVATION_EMULATOR_
	MMS_TRACE_EVENT(("MMS_MidiStop(%s)",filename));
	MI_PlayMusic_Stop();
	return 0;
#endif
}

MMS_U8		ECC_MidiPlay(MMS_S8 *filename, MMS_U8 loop)
{
#ifndef _INNOVATION_EMULATOR_
	MMS_TRACE_EVENT(("MMS_MidiPlay(%s,%d)",filename, loop));
	MI_PlayFile_Start((const char*)filename, 0xff, loop);
	return 0;
#endif
}

MMS_VOID	ECC_Sleep(MMS_U32 ms)
{
#ifndef  MMI_MMSTASK_ENABLED
	MMS_TRACE_EVENT(("ECC_Sleep"));
	rvf_delay((ms+4)/5);	
#endif
}


/*
#define LINE_HEIGHT				16
#define LINE_HEIGHT_CHINESE		16

#define SCREEN_SIZE_X			128	
#define SCREEN_SIZE_Y			160	

#define TITLE_HEIGHT			18
#define SOFTKEY_HEIGHT			18
#define MENU_PER_HEIGHT			18	*/

MMS_VOID	MMSDrawTitleBar(MMS_U8 curSlide, MMS_U8 slideNum, MMS_U8 audioFlag)
{
	char title[10];
	sprintf(title,"%d/%d",curSlide,slideNum);
    dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT,title, 0x0);    	  
}

#define BarWidth 3
#define BarHeight (SCREEN_SIZE_Y-SOFTKEY_HEIGHT-TITLE_HEIGHT)
#define BarPosX (SCREEN_SIZE_X -BarWidth)
#define BarPosY TITLE_HEIGHT

MMS_VOID	MMSDrawScrollBar(MMS_U8 curPage, MMS_U8 pageNum)
{	
	U8 uMode = 0;
	int height;
	MMS_U32 oldfgcolor;
	int xPos1,xPos2,yPos1,yPos2;
	float lenPerPage;
//	uMode = dspl_Enable(0);	
//	dspl_ClearAll();
	oldfgcolor = dspl_SetFrgColor(0x80ecf0);
	dspl_DrawFillRect(BarPosX, BarPosY, BarPosX+BarWidth-1, BarPosY+BarHeight-1 );
	dspl_SetFrgColor(oldfgcolor);
//	dspl_BitBlt(BarPosX, BarPosY, BarWidth, BarHeight, 0, (void *)vScrollBar, DSPL_BMPCOPY);
	if(curPage>0 && pageNum>1 && curPage<= pageNum)
	{
		lenPerPage = (float)BarHeight/pageNum;
		xPos1 = BarPosX; 
		yPos1 = (int)((curPage-1)*lenPerPage)+ BarPosY;
        xPos2 = xPos1+BarWidth-1;
		yPos2 = yPos1 +(int)lenPerPage-1;
		oldfgcolor = dspl_SetFrgColor(0x000080);
    	dspl_DrawFillRect(xPos1,yPos1,xPos2,yPos2);
    	dspl_SetFrgColor(oldfgcolor);
	}
//	dspl_Enable(uMode );
}

MMS_VOID sys_drawpoint(MMS_S32 x, MMS_S32 y, MMS_COLOR color)
{
	MMS_TRACE_EVENT(("sys_drawpoint()"));
#ifdef MMI_MMSTASK_ENABLED
	{
		T_MMS_MMI_DRAWPOINT_IND parameter;
		parameter.x = x;
		parameter.y = y;
		parameter.color = color;
		/*mmi task*/
		S_MMS_MMI_DRAWPOINT_IND(&parameter);
	}
#else
	{	
		MMS_U32 oldfgcolor;

		oldfgcolor = dspl_SetFrgColor(color);
		dspl_DrawPoint (x, y);
		dspl_SetFrgColor(oldfgcolor);
	}
#endif
}

MMS_S32 sys_drawtext(MMS_S32 x, MMS_S32 y, MMS_S8* string, MMS_U8 font, MMS_COLOR color)
{
	MMS_TRACE_EVENT(("sys_drawtext()"));
#ifdef MMI_MMSTASK_ENABLED
	{
		T_MMS_MMI_DRAWTEXT_IND parameter;
		parameter.x = x;
		parameter.y = y;
		//parameter.string = string;
		MMS_new(parameter.string ,wstrlen(string) + 2);
		wstrcpy(parameter.string,string);
		
		parameter.font = font;
		parameter.color = color;
		/*mmi task*/
		S_MMS_MMI_DRAWTEXT_IND(&parameter);
	}
#else

	switch(font)
	{
	case 12:
		set_font_type(UNI12X12_FONT);
		break;

	case 16:
		set_font_type(UNI24X24_FONT);
		break;

	case 20:
		set_font_type(UNI24X24_FONT);
		break;

	default:
        set_font_type(NORMAL_FONT);
		break;
	}
	
    dspl_colorTextOut(x, y, DSPL_TXTATTR_NORMAL,string,color);
#endif
}

MMS_VOID sys_drawfillrect(MMS_S32 x, MMS_S32 y, MMS_S32 width, MMS_S32 height, MMS_COLOR color)
{
	MMS_TRACE_EVENT(("sys_drawfillrect()"));
#ifdef MMI_MMSTASK_ENABLED
	{
		T_MMS_MMI_DRAWFILLRECT_IND parameter;
		parameter.x = x;
		parameter.y = y;
		parameter.width = width;
		parameter.height = height;
		parameter.color = color;
		/*mmi task*/
		S_MMS_MMI_DRAWFILLRECT_IND(&parameter);
	}
#else
	{	
		MMS_U32 oldfgcolor;

		oldfgcolor = dspl_SetFrgColor(color);
		dspl_DrawFillRect (x, y, x+width, y+height);
		dspl_SetFrgColor(oldfgcolor);
	}
#endif
}

MMS_VOID	sys_refreshwindow()
{
	MMS_TRACE_EVENT(("sys_refreshwindow()"));
#ifdef MMI_MMSTASK_ENABLED
	{
		T_MMS_MMI_REFRESHWINDOW_IND parameter;
		/*mmi task*/
		S_MMS_MMI_REFRESHWINDOW_IND(&parameter);
	}
#else

	dspl_ClearAll();
#endif
}
#ifdef MMI_MMSTASK_ENABLED
MMS_VOID mmisys_drawpoint(MMS_S32 x, MMS_S32 y, MMS_COLOR color)
{
	MMS_U32 oldfgcolor;
	if(!IsWinFocus_MMSTask())
		return ;

	oldfgcolor = dspl_SetFrgColor(color);
	dspl_DrawPoint (x, y);
	dspl_SetFrgColor(oldfgcolor);
}

MMS_S32 mmisys_drawtext(MMS_S32 x, MMS_S32 y, MMS_S8* string, MMS_U8 font, MMS_COLOR color)
{
	if(IsWinFocus_MMSTask())
	{	
		switch(font)
		{
		case 12:
			set_font_type(UNI12X12_FONT);
			break;

		case 16:
			set_font_type(UNI24X24_FONT);
			break;

		case 20:
			set_font_type(UNI24X24_FONT);
			break;

		default:
	        set_font_type(NORMAL_FONT);
			break;
		}
	
   		 dspl_colorTextOut(x, y, DSPL_TXTATTR_NORMAL,string,color);
	}
	MMS_free(string,wstrlen(string) + 2);
}

MMS_VOID mmisys_drawfillrect(MMS_S32 x, MMS_S32 y, MMS_S32 width, MMS_S32 height, MMS_COLOR color)
{
	MMS_U32 oldfgcolor;
	if(!IsWinFocus_MMSTask())
		return ;

	oldfgcolor = dspl_SetFrgColor(color);
	dspl_DrawFillRect (x, y, x+width, y+height);
	dspl_SetFrgColor(oldfgcolor);
}

MMS_VOID	mmisys_refreshwindow()
{
	MMS_TRACE_EVENT(("sys_refreshwindow()"));
	if(!IsWinFocus_MMSTask())
		return ;

	dspl_ClearAll();
}
#endif

MMS_S8 Eastcom_Jpeg_Delay(MMS_U32 pos, MMS_U32 line, MMS_U32 saved_line, MMS_U32 width)
{
	char *pbmp=NULL;
	int count=saved_line+1;

	MMS_TRACE_EVENT(("Eastcom_Jpeg_Delay:%d,%d,%d,%d",pos, line,saved_line,width));

	if((line %80) == 0)
		rvf_delay(2);
	if((count%10) == 0 )
	{
		rvf_delay(2);
		MMSBitBlt((PLAYER_W - width)/2, pos, width , count,  image_buf);
	}
	return 1;  	
}

#ifndef MMS_WAP_ENABLED/*dummy*/
/***************************************************************************/
/**************************WAP Interface************************************/
/***************************************************************************/
static char FORCERECV = 0;


/*****************************************
$Description:
	encapsulate WAP_MMS_EVENT and call MMS_NET_EVENT_HANDLE
$Argument
	@type: MMS_WAP_EVENT_TYPE
	@status:MMI_MMS_EVENT_STATUS
	@filename
*********************************************/
void wap_mms_evt_cb(
			UBYTE    type, 
			UBYTE    status, 
			char *    filename 
			)
{
	pWAP_MMS_EVENT evt;
 

	TRACE_FUNCTION("wap_mms_evt_cb()");

 	/*initialize manager and codec*/
	MI_manager_on_initialize(MANAGER_MASK_MMSAGT);
	/*{
		extern T_MMS_NET_SETTINGS mmsSettings;
		manager_set_autorecv(mmsSettings.allSettings[mmsSettings.curSettingsIndex].recvSettings.stateAutoRecv);
	}*/
  	WAP_TRACE_EVENT(("type:%d, status:%d",type,status));
	WAP_DELAY(30);
	 
	MMS_new(evt, sizeof(WAP_MMS_EVENT));
	if(!evt)
	{
		TRACE_FUNCTION("memory alloc error");
		return;
	}
	
#if 0	
	MmsBusy = TRUE; 
#endif	
	evt->type = type;
	switch(type)
	{
	case NET_ERROR:
		TRACE_FUNCTION("NET_ERROR");
		
		MMS_NET_EVENT_HANDLE(evt);
		break;
		
	case NET_CONFIGURE_CNF:
		TRACE_EVENT("NET_CONFIGURE_CNF");
		MMS_new(evt->data.pconfiguredata, sizeof(CONFIGURE_CNF_DATA));
		evt->data.pconfiguredata->status = status;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pconfiguredata, sizeof(CONFIGURE_CNF_DATA));
		break;
		
	case NET_CLOSE_CNF:
		TRACE_EVENT("NET_CLOSE_CNF");
		MMS_new(evt->data.pclosedata,sizeof(CLOSE_CNF_DATA));
		evt->data.pclosedata->status = status;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pclosedata, sizeof(CLOSE_CNF_DATA));
#if 0
		RcvFromMenu = FALSE;
#endif
		break;
		
	case NET_CANCEL_CNF:
		TRACE_EVENT("NET_CANCEL_CNF");
		MMS_new(evt->data.pcanceldata,sizeof(CANCEL_CNF_DATA));
		evt->data.pcanceldata->status = status;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pcanceldata, sizeof(CANCEL_CNF_DATA));
#if 0
		RcvFromMenu = FALSE;
#endif
		break;
		
	case NET_POST_CNF:
		TRACE_EVENT("NET_POST_CNF");
		if(filename ==0)
		{
			WAP_TRACE_EVENT(("NET_POST_CNF-notiresp.mms"));
			break;
		}

		MMS_new(evt->data.ppostdata,sizeof(POST_CNF_DATA));
		evt->data.ppostdata->status = status;
		evt->data.ppostdata->filename = filename;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.ppostdata, sizeof(POST_CNF_DATA));
		break;
		
	case NET_GET_CONTENT_IND:
		TRACE_EVENT("NET_GET_CONTENT_IND");
		MMS_new(evt->data.pgetdata,sizeof(GET_CONTENT_IND_DATA));
		evt->data.pgetdata->status = status;
		evt->data.pgetdata->filename = filename;

		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pgetdata,sizeof(GET_CONTENT_IND_DATA));

		break;
		
	case NET_PUSH_IND:
		TRACE_EVENT("NET_PUSH_IND");
		MMS_new(evt->data.ppushdata,sizeof(PUSH_IND_DATA));
		evt->data.ppushdata->status = status;
		evt->data.ppushdata->filename= filename;
		evt->data.ppushdata->forcerecv = FORCERECV;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.ppushdata, sizeof(PUSH_IND_DATA));
		break;
		
	default:
		TRACE_FUNCTION("default");
		break;
	}

	MMS_free(evt, sizeof(WAP_MMS_EVENT));
	WAP_TRACE_EVENT(("end wap_mms_evt_cb"));
	WAP_DELAY(30);
}
	
int MMS_WAP_Open(void)
{
	MMS_TRACE_EVENT(("MMS_WAP_Open"));
	wap_mms_evt_cb(
 		NET_CONFIGURE_CNF,
		 MMI_MMS_SUCCESS, 
 		NULL);
}

int MMS_WAP_Close(void)
{
	MMS_TRACE_EVENT(("MMS_WAP_Close"));
}

int MMS_WAP_Cancel()
{
	pWAP_MMS_EVENT evt;
	
	MMS_TRACE_EVENT(("MMS_WAP_Cancel"));
	
	 
	MMS_new(evt, sizeof(WAP_MMS_EVENT));
	if(!evt)
	{
		TRACE_FUNCTION("memory alloc error");
		return;
	}
	
	evt->type = NET_CANCEL_CNF;
	MMS_new(evt->data.pcanceldata,sizeof(CANCEL_CNF_DATA));
	evt->data.pcanceldata->status = MMI_MMS_SUCCESS;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pcanceldata, sizeof(CANCEL_CNF_DATA));

	MMS_free(evt, sizeof(WAP_MMS_EVENT));

}

int MMS_WAP_Send(char *filename, char *mmscaddr)
{
	MMS_TRACE_EVENT(("MMS_WAP_Send"));
	wap_mms_evt_cb(
		NET_POST_CNF,
		MMI_MMS_SUCCESS,
		"sendconf.mms"
		);
}

int MMS_WAP_Recv(char *filename, char *url)
{
	MMS_TRACE_EVENT(("MMS_WAP_Recv"));
}

#ifdef NEW_MMI_MMS_INTERFACE
void MMS_MMI_NewMMS_notification(pMMI_MMS_EVENT event)
{
#if 0
    extern void MMS_Sending_End(void );   //add by xie 04-07-22
	P_MMS mms;
	info_screen(NULL, TxtMMS, TxtMMSSendSuccess, NULL, REMIND_SUCCEED);
	MMS_Sending_End();
	
		// Ҫٱ༭ڣϢӲݸɾ
		// ٲŴڡ
		//Destroy_editor();
		mms = getMMS();
		if(mms->manager && mms->manager->unsendfolder && mms->manager->unsendfolder->currentmessage)
		{
			pMessage pMsg;
			pMsg = (pMessage)manager_on_pickout(mms->manager->unsendfolder);
			pMsg->state = MMS_MSG_TYPE_SEND;
			manager_on_addmsg(mms->manager->sendfolder, pMsg);
			manager_on_store();
		}

//		info_screen(NULL, TxtNull, TxtMMSSendFaild, NULL, REMIND_FAILURE);

//		info_screen(NULL, TxtMMS, TxtMMSSendCancelled, NULL, REMIND_COMPLETE);

//		info_screen(NULL, TxtMMS, TxtMMSSendFaild, NULL, REMIND_FAILURE);
//#else
		void MMS_Retrieving_End(void);
		MMS_Retrieving_End();	
		info_screen(NULL, TxtMMS, TxtMMSRecvSuccess, NULL, REMIND_COMPLETE);	
//		info_screen(NULL, TxtMMS, TxtMMSRecvCancelled, NULL, REMIND_COMPLETE);	
//		info_screen(NULL, TxtNull, TxtMMSRecvFailed, NULL, REMIND_FAILURE);
//		info_screen(NULL, TxtNull, TxtMMSDataError, NULL, REMIND_FAILURE);

#endif
}

#else
void MMS_MMI_NewMMS_notification(T_NEW_MMS_TYPE type)
{
	MMS_TRACE_EVENT(("void MMS_MMI_NewMMS_notification(T_NEW_MMS_TYPE type)"));
}
#endif

void MMS_Close_All(void)
{
	MMS_TRACE_EVENT(("MMS_Close_All"));
}
#endif

#ifdef MMI_MMSTASK_ENABLED
/***********************************************
$Description:

***********************************************/
BOOL IsWinFocus_MMSTask()
{
	extern BYTE get_mmstask_proc();
	if(!get_mmstask_proc())
		return TRUE;
	if(winIsFocussed(mmsui_data->current_win))
		return TRUE;
	MMS_TRACE_EVENT(("hyl,not is IsWinFocus_MMSTask!!!"));
	return FALSE;
}
#endif


#endif

