#include <windows.h>
#include <string.h>

#include "pcsyn_protocoldll.h"
//#include "uart.h"
//#include "pcsyn.h"
#include "pcsyn_serial.h"
#include "pcsyn_protocol.h"

//洢ڽİ
#define MAX_IN 256
static BYTE buff_in[MAX_IN];
static BYTE size_buff_in = 0;

//洢Ҫдڵİ
#define MAX_OUT 256
static BYTE buff_out[MAX_OUT];
static BYTE size_buff_out = 0;


//ط
static BYTE buff_out_resend[MAX_OUT];
static BYTE size_buff_out_resend  = 0;

#define MAX_INTOTAL   364000
static BYTE buff_intotal[MAX_INTOTAL];
static int  size_buff_intotal = 0;

#define MAX_OUTTOTAL 364000
BYTE buff_outtotal[MAX_OUTTOTAL];
static int  size_buff_outtotal = 0;
static int  transfer_buff_outtotal = 0;

HWND hwndProtocol;
//#define SIZESENDUINT 26

PC_Packet_UL pc_packet_ul;
PC_Packet_DL pc_packet_dl;

/* no response from target */
static int timeout_nores = 0;
/* no data from target, fix to PC_Error_WaitData*/
static int timeout_nodata = 0;

static PC_Protocol pc_protocol=
{
 	STX,
	ETX,
	DLE,
	HEADER_UL,
	HEADER_DL,
	0,			//frameid
	0x00,         //frametype
	PC_NOCONNECT
};

static  PC_Interface_Info *interface_info;

BYTE pc_checksum(BYTE *buf, int size);
int pc_readbuffer(BYTE *buffer ,int size,int type);
VOID TimerProc(
			   HWND hwnd,         // handle to window
			   UINT uMsg,         // WM_TIMER message
			   UINT_PTR idEvent,  // timer identifier
			   DWORD dwTime       // current system time
			   );
int read_packetDL(BYTE *buffer, unsigned int size);

#define  PCSYN_TIMEOUT 100
#define  PCSYN_TIMERID 0x01

static unsigned int pcsyn_tmID = 0; 
static unsigned int pcsyn_timeout = 0;

BYTE isdle(BYTE b)
{
	if(b == pc_protocol.stx ||
	   b == pc_protocol.dle ||
	   b == pc_protocol.etx)
	   return 0x01;
	return 0x00;
}

int pc_connect()
{
	pcsyn_timeout = 0;

	pc_packet_ul.frametype = 0x40;
	pc_packet_ul.frameid = PC_FRAME_MIN;
	pc_packet_ul.datasize = 0xff;
//	pc_writebyulpkt();

	size_buff_out_resend = 0;
	buff_out_resend[size_buff_out_resend ++ ] = pc_protocol.header_ul;
	buff_out_resend[size_buff_out_resend ++ ] = PC_FT_Control | PC_CF_Connect;
	buff_out_resend[size_buff_out_resend ++ ] =PC_FRAME_MIN;
	buff_out_resend[size_buff_out_resend ++ ] = pc_checksum(buff_out_resend, size_buff_out_resend);
	
	send_pcsyn_event(1);

	pcsyn_tmID = SetTimer(hwndProtocol,PCSYN_TIMERID ,PCSYN_TIMEOUT,(TIMERPROC )TimerProc);
	return  PC_Error_NoError;
}
int pc_disconnect()
{
	size_buff_intotal = 0;
	size_buff_outtotal= 0;

	pc_packet_ul.frametype = 0x41;
	if(pc_packet_ul.frameid == PC_FRAME_MAX)
		pc_packet_ul.frameid = PC_FRAME_MIN;
	else
		pc_packet_ul.frameid ++;
	pc_packet_ul.datasize = 0xff;
	pc_writebyulpkt();

	
	return  PC_Error_NoError;
}
int  serial2protocol(BYTE *buffer,int size)
{
	if(size > MAX_IN && size<5)
		return 1;
	size_buff_in = size;
	memcpy(buff_in,buffer,size);
	send_pcsyn_event(0);
	return 0;
}

void indicate_resend()
{
	pcsyn_timeout =100;
}


int pc_dldata()
{
	
	memcpy(&interface_info->pdata_dlbuff[interface_info->size_dlbuff],pc_packet_dl.data,pc_packet_dl.datasize);
	
	interface_info->size_dlbuff += pc_packet_dl.datasize;
	return PC_Error_NoError;				
}

//tx data
int pc_txdata()
{
	BYTE size = 3;
	BYTE iuldata = 0;

	pc_packet_ul.frametype = PC_IF_Data | PC_FT_Info;

	if(isdle(pc_packet_ul.frametype))
		size ++;
	
	if(pc_packet_ul.frameid == PC_FRAME_MAX)
	{
		pc_packet_ul.frameid = PC_FRAME_MIN;
	}
	else
	{
		pc_packet_ul.frameid ++;
	}

	if(isdle(pc_packet_ul.frameid))
		size ++;
	while(size < PACKET_MAXSIZE && transfer_buff_outtotal < size_buff_outtotal)
	{
		pc_packet_ul.data[iuldata] = buff_outtotal[transfer_buff_outtotal++];
		if(isdle( pc_packet_ul.data[iuldata] ))
			size ++;
		size++;
		iuldata ++;

	}
	//memcpy(pc_packet_ul.data , buff_outtotal + transfer_buff_outtotal, pc_packet_ul.datasize);
	pc_packet_ul.datasize = iuldata;
	
	
	pc_writebyulpkt();		
}




int handle_inbuffer()
{
	int status = 0;

/* if receive packet from target,reset timeout_nores to 0*/	
	timeout_nores = 0;
	
	
	if(pc_checksum(buff_in,size_buff_in) != (BYTE)pc_protocol.header_dl )
	{//checksum error
		return PC_Error_CheckSum;
	}
/*
	if(size_buff_in<4)
	{//invalid bufffer size
		return PC_Error_InvalidPktSize;
	}
*/
	read_packetDL(buff_in ,size_buff_in - 1 );
	if(pc_packet_dl.status == PC_Error_WaitData)
	{
		return PC_Error_WaitData;
	}
	//checkframe id
	if(pc_packet_ul.frameid !=  pc_packet_dl.frameid)
	{
		indicate_resend();
		return PC_Error_InvalidFrameid;
	}

	//checkframe type
	if(pc_packet_ul.frametype != pc_packet_dl.frametype_ul)
	{
		indicate_resend();
		return PC_Error_InvalidFrameType;
	}
	
	if(pc_packet_dl.status >= 0x80)//application error
	{
		interface_info->status = pc_packet_dl.status;
	/*	if(interface_info->callback)
		{
			
			interface_info->callback((void*) interface_info);
		}
		*/
		//disconnect it
		return pc_packet_dl.status;
	}
	
	
		
	switch(pc_packet_dl.frametype_ul & 0xc0)

	{
	case PC_FT_Monitor:// monitor frame
		if(pc_protocol.status == PC_NOCONNECT)
		{
			return PC_Error_NoConnect;
		}
		break;
	case PC_FT_Control: //control frame
		switch(pc_packet_dl.frametype_ul & 0x3f)
		{
			case PC_CF_Connect:
				if(pc_protocol.status == PC_NOCONNECT)// a connect
				{
					pc_protocol.status = PC_CONNECTED;
				}
				else
				{
					return PC_Error_ConnectExisted;
				}
				break;
			case PC_CF_Cmd://begin rx data or tx data
				switch(pc_protocol.status)
				{
					case PC_CONNECTED:
						//pc_protocol.status  = PC_CMDRECV;
						if(interface_info->flag == PC_IF_FLAGS_DATAUL)
						{
							pc_protocol.status = PC_DATAUL;
						}
						else if(interface_info->flag == PC_IF_FLAGS_DATADL)
						{
							pc_protocol.status = PC_DATADL;
						}
						break;
					default:
						return PC_Error_InvalidFrameType;
				}
				break;

			case PC_CF_DataEnd:
				switch(pc_protocol.status)
				{
					case PC_DATAULEND:
					case PC_DATADLEND:
					
						pc_protocol.status = PC_WAITDISCONNECT;
						break;
					default:
						return PC_Error_InvalidFrameType;
				}
				break;

			case PC_CF_DisConnect:
				switch(pc_protocol.status)
				{
				case PC_WAITDISCONNECT:
					pc_protocol.status = PC_NOCONNECT;
					KillTimer(hwndProtocol,pcsyn_tmID);
					//success a transaction
					if(interface_info->callback)
					{
						interface_info->callback((void*) interface_info);
					}
					break;
				default:
					return PC_Error_InvalidFrameType;
				}
				break;
			default:
				return PC_Error_InvalidFrameType;
		}
		break;
	case PC_FT_Info://info frame
		if(pc_protocol.status == PC_NOCONNECT)
		{
			return PC_Error_NoConnect;
		}
		switch(pc_packet_dl.frametype_ul & 0x3f)
		{
		case PC_IF_Data:
			switch(pc_protocol.status)
			{
				case PC_CMDRECV:
					pc_protocol.status = PC_DATAUL;
					pc_protocol.frameid = PC_FRAME_MIN - 1;
					size_buff_intotal = 0;
					break;
				case PC_DATAUL:
					//pcsyndebug("data rx\n",strlen("data rx\n"));
					//status = pc_rxdata();
					if(pc_packet_ul.datasize == 0 )
						pc_protocol.status = PC_DATAULEND;
					break;
				case PC_DATADL://tx
					status = pc_dldata();
					if(pc_packet_dl.datasize == 0)
					{
						pc_protocol.status = PC_DATADLEND;
					}
					
					break;
					//if(size_buff_out == 0)
					//	pc_protocol.status = PC_DATATXEND;
				case PC_DATAULEND://tx end
					break;
				case PC_DATADLEND:
					break;
				default:
					status = PC_Error_InvalidFrameType;
					break;
			}
		       break;
			case PC_IF_DataAck:
				break;
		default:
			status = PC_Error_InvalidFrameType;
			break;
		}

		break;
	default://incalid frame type
		return PC_Error_InvalidFrameType;
	}
	return status;
}

BYTE pc_checksum(BYTE *buf, int size)
{
    int cksum = 0;

    while (size--)
        cksum ^= *buf++;
	
    return cksum;
}


/******************************************************/
int read_packetDL(BYTE *buffer, unsigned int size)
{
	if((unsigned int)buffer[iDL_DATASIZE] != size - iDL_DATA)
		return PC_Error_InvalidDataSize;
	memcpy(&pc_packet_dl.frametype, buffer ,size);
	return PC_Error_NoError;
}
/******************************************************/


/*****************************************/

VOID TimerProc(
			   HWND hwnd,         // handle to window
			   UINT uMsg,         // WM_TIMER message
			   UINT_PTR idEvent,  // timer identifier
			   DWORD dwTime       // current system time
			   )
{

	pcsyn_timeout++;

	if(pcsyn_timeout > 5)
	{
		timeout_nores++;
		//protocol2serial(buff_out_resend,size_buff_out_resend);
		if(timeout_nores >= 10)
		{
			timeout_nores = 0;
/* error,˵targetӦtimeoutfor exampleserial is invalid*/
			if(interface_info->callback)
			{
				interface_info->status = PC_Error_SerialNoResponse;
				interface_info->callback((void*) interface_info);
				KillTimer(hwndProtocol,pcsyn_tmID);
			}
			pc_disconnect();
		}
		else
		{
			send_pcsyn_event(1);
		}
		pcsyn_timeout = 0;
		
	}
}

/*********************************************
ack info
-------------------------------------------------------------
| frametype | frameid | status | frametype from  pc |datasize |  data |
---------------------------------------------------------------
|   81	    |	 00       |           |                           |            |        |
-----------------------------------------------------------------
**********************************************/
int pc_writebystatus(int status)
{
	int size = 0;
	BYTE * pbuff;

	if(status >= 0x80)/*a app error occur,disconnect the session*/
	{
		pc_protocol.status = PC_WAITDISCONNECT;
		if(interface_info->callback)
		{
			interface_info->callback((void*) interface_info);
			interface_info->callback = 0;
		}
		status = PC_Error_NoError;
	}

	
	switch(status)
	{
	case PC_Error_NoError:
		switch(pc_protocol.status)
		{
		case PC_CONNECTED:
			pc_packet_ul.frametype = PC_FT_Control | PC_CF_Cmd;
			
			if(pc_packet_ul.frameid == PC_FRAME_MAX)
			{
				pc_packet_ul.frameid = PC_FRAME_MIN;
			}
			else
			{
				pc_packet_ul.frameid ++;
			}
			pc_packet_ul.datasize = size_buff_out;
			memcpy(pc_packet_ul.data , buff_out, size_buff_out);
			pc_writebyulpkt();
			break;
		case PC_DATAUL://tx data
			pc_txdata();
			break;
		case PC_DATAULEND:
		case PC_DATADLEND:
			pc_packet_ul.frametype = PC_FT_Control | PC_CF_DataEnd;
			
			if(pc_packet_ul.frameid == PC_FRAME_MAX)
			{
				pc_packet_ul.frameid = PC_FRAME_MIN;
			}
			else
			{
				pc_packet_ul.frameid ++;
			}
			pc_packet_ul.datasize = 0xff;
			//memcpy(pc_packet_ul.data , buff_out, size_buff_out);
			pc_writebyulpkt();
			break;

		case PC_DATADL://rx data
			pc_packet_ul.frametype = PC_IF_Data | PC_FT_Info;
			
			if(pc_packet_ul.frameid == PC_FRAME_MAX)
			{
				pc_packet_ul.frameid = PC_FRAME_MIN;
			}
			else
			{
				pc_packet_ul.frameid ++;
			}
			pc_packet_ul.datasize = 0;

			

			pc_writebyulpkt();
			
			break;
		case PC_WAITDISCONNECT:
			pc_disconnect();
			break;
		case PC_NOCONNECT:
			break;
		default:
			break;
		}
		
		break;
	case PC_Error_FrameIsReRX:
		//UA_EncapsulateNChars(0, buff_out_resend, size = size_buff_out_resend);
		break;
	case PC_Error_WaitData:
		break;
	case PC_Error_MMINotAllow:
		KillTimer(hwndProtocol,pcsyn_tmID);
	default:
	
		break;
	}

	return size;
}

int pc_writebyulpkt()
{
	static BYTE buffer[256];
	int size = 0;
	BYTE * pbuff;

	pbuff = (BYTE *)buffer;

	pbuff [size++] = pc_packet_ul.frametype;
	pbuff [size++] = pc_packet_ul.frameid;
	if(pc_packet_ul.datasize != 0xff)
	{
		pbuff [size++] = pc_packet_ul.datasize;

		memcpy(pbuff  + size, pc_packet_ul.data, pc_packet_ul.datasize);
		size += pc_packet_ul.datasize;
	}
	return pc_write_serial(pbuff, size);
}
/*********************************************
ack info
-------------------------------------------------------------
| head |    data                 | checksum|
---------------------------------------------------------------
|   80  |	  pc_writebystatus |             |
-----------------------------------------------------------------
**********************************************/
int pc_write_serial(BYTE* buf ,int size)
{
	static BYTE buffer[256];
	int size_buffer = 0;
	BYTE * pbuff = buffer;
	
	//set tim out
	pcsyn_timeout = 0;
	
	
	pbuff[size_buffer ++ ] = pc_protocol.header_ul;
	memcpy(pbuff + size_buffer, buf ,size);
	size_buffer += size;
	pbuff[size_buffer ++ ] = pc_checksum(pbuff,size_buffer);

	//ط
	memcpy(buff_out_resend,pbuff ,size_buff_out_resend = size_buffer);
	
	protocol2serial(pbuff, size_buffer);

	return 0;
}



/***************************************/
//call bu user, transmit a quest
int pc_writebuffer(BYTE *bufcmd ,int size_bufcmd,BYTE *buf_context,int size_buf_context)
{
	//initialize
	pc_protocol.frameid = PC_FRAME_MIN;
	pc_protocol.status = PC_NOCONNECT;
	memcpy(buff_out, bufcmd, size_buff_out = size_bufcmd);
	
	size_buff_outtotal = 0;
	transfer_buff_outtotal = 0 ;
	if(buf_context)	
	{
		memcpy(buff_outtotal,buf_context  ,size_buff_outtotal = size_buf_context);
	}

	//connect
	pc_connect();
	
	return 0;
}

//imple by user
int pc_readbuffer(BYTE *buffer ,int size)
{
	return 0;
}

int  pc_resend()
{
	return protocol2serial(buff_out_resend,size_buff_out_resend);
}

int pc_sendmonitor()
{
	return 0;
}
//demo,imple by protocol ,call by user
DllExport int pc_interface(PC_Interface_Info * info)
{
	BYTE *p; 

#ifdef FILE_DEBUG
	emptyMonitorFile();
#endif
	interface_info = info;
	//initialize
	pc_protocol.frameid = PC_FRAME_MIN;
	pc_protocol.status = PC_NOCONNECT;
	memcpy(buff_out, info->pdata_cmd, size_buff_out = info->size_cmd);
	
	
	switch(info->flag)
	{
	case PC_IF_FLAGS_DATAUL:
		p = buff_outtotal;
		size_buff_outtotal = 0;
		transfer_buff_outtotal = 0;
		
		if(info->pdata_ulbuff)	
		{
			memcpy(p, &info->size_ulbuff, sizeof(info->size_ulbuff));
			p += sizeof(info->size_ulbuff);
			size_buff_outtotal+= sizeof(info->size_ulbuff);
			memcpy(p,info->pdata_ulbuff  , info->size_ulbuff);
			size_buff_outtotal += info->size_ulbuff;
		}
		break;	
	case PC_IF_FLAGS_DATADL:
		interface_info->size_dlbuff = 0;
		break;
	default:
		//error flag
		break;
		
	}
	//connect
	pc_connect();
	return 0;
	
}

DllExport void pcsyn_protocol_init()
{
	extern HANDLE hApp;

	TCHAR   szTitle[] = TEXT("PCSyn_Protocol");      // The title bar text
	TCHAR   szWindowClass[] = TEXT("Window PCSyn_Protocol");      // The window class name
	MSG msg;
	WNDCLASS   wc; // The window class for this application
	
	// Register the window class:
	
	wc.style             = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc      = (WNDPROC) DefWindowProc; //The function to handle the window messages
	wc.cbClsExtra      = 0;
	wc.cbWndExtra      = 0;
	wc.hInstance      = hApp;
	wc.hIcon           = 0;
	wc.hCursor         = 0;
	wc.lpszMenuName      = 0;
	wc.hbrBackground = COLOR_WINDOW;
	wc.lpszClassName   = szWindowClass;
	
	if (!RegisterClass(&wc)) 
		return FALSE;//Failed to register the window
	
	// Create the main window
	
	hwndProtocol = CreateWindow(szWindowClass, szTitle, 0,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hApp, NULL);
	ShowWindow(hwndProtocol, SW_HIDE);

	pcsyn_start_task();
}

DllExport void pcsyn_protocol_close()
{
	DestroyWindow(hwndProtocol);
	pcsyn_stop_task();
}






















