/*
+-------------------------------------------------------------------+
| PROJECT: PC Synchronization                    
| $Workfile: pcsyn.h
| $Author: Talcon Hu
| CREATED: 18.05.2004                 
+-------------------------------------------------------------------+
*/
#ifndef _PCSYN_
#define _PCSYN_

#include "mmiutilapi.h"

#ifndef PCSYN_COMPILE_FORAPP

#ifdef ENTITY_PCSYN
#define _ENTITY_PREFIXED(N) pcsyn_##N
#else
#define _ENTITY_PREFIXED(N)
#endif

#define hCommMMI        _ENTITY_PREFIXED(hCommMMI)
#define hCommPCSYN     _ENTITY_PREFIXED(hCommPCSYN)

extern T_HANDLE  hCommMMI;
extern T_HANDLE  hCommPCSYN;

typedef struct
{
	U8                        event_id;                 /*<  0:  1> Identifier of the event.                           */
	U8                        _align0;                  /*<  1:  1> alignment                                          */
	U8                        _align1;                  /*<  2:  1> alignment                                          */
	U8                        _align2;                  /*<  3:  1> alignment                                          */
	T_sdu                     sdu;                      /*<  4: ? > Service Data Unit                                  */
} 
T_HISR_PCSYN_IND;

typedef struct
{
	U8                        event_id;                 /*<  0:  1> Identifier of the event.                           */
	U8                        _align0;                  /*<  1:  1> alignment                                          */
	U8                        _align1;                  /*<  2:  1> alignment                                          */
	U8                        _align2;                  /*<  3:  1> alignment                                          */
	T_sdu                     sdu;                      /*<  4: ? > Service Data Unit                                  */
} 
T_MMI_PCSYN_IND;

typedef struct
{
	U8                        event_id;                 /*<  0:  1> Identifier of the event.                           */
	U8                        _align0;                  /*<  1:  1> alignment                                          */
	U8                        _align1;                  /*<  2:  1> alignment                                          */
	U8                        _align2;                  /*<  3:  1> alignment                                          */
	T_sdu                     sdu;                      /*<  4: ? > Service Data Unit                                  */
} 
T_PCSYN_MMI_IND;

GLOBAL const void   psa_HISR_PCSYN_IND ( T_HISR_PCSYN_IND *hisr_pcsyn_ind);

GLOBAL const void   mmi_pcsyn_ind ( T_MMI_PCSYN_IND *mmi_pcsyn_ind);



/************************************************/


#define VERSION_PCSYN "PCSYN 1.0"

#define T_VERSION   char
typedef struct
{
  T_VERSION *version;
}
T_MONITOR;

#define PCSYN_NAME      "PCSYN"

/*
 * Bitoffset for encoding/decoding
 */
#define ENCODE_OFFSET             0
#endif


typedef struct
{
	U8 dummy;
}
T_MMI_PCSYN_DATAWAIT_IND;

typedef struct
{
	BYTE controlid;/* PC_CFType */
	BYTE cid1;	  /* PC_AppCID1 */
	BYTE cid2;	/* PC_AppCID1 */
}T_PCSYN_MMI_STATUS_IND;

typedef struct
{
	void *info;
	BYTE stype;
	BYTE rptype;
}T_PCSYN_MMI_SENDMMS_IND;

/***************************************************/
void M_MMI_PCSYN_WAITDATA_IND(T_MMI_PCSYN_DATAWAIT_IND *parameter);

void P_PCSYN_MMI_STATUS_IND(T_PCSYN_MMI_STATUS_IND *parameter);
void P_PCSYN_MMI_SENDMMS_IND(T_PCSYN_MMI_SENDMMS_IND *parameter);

void   psa_PCSYN_MMI_IND (BYTE event_id,void* data, USHORT data_size);

/*************
event id
**************************/
typedef enum
{
	P_PCSYN_MMI_SATTUS_IND_ID,
	P_PCSYN_MMI_SENDMMS_IND_ID
};


//#define PCSYN_DEBUG

#ifdef PCSYN_DEBUG
extern void MI_dbgPrintf(const char* const format, ...);
	#define PCSYN_TRACE_EVENT(f) MI_dbgPrintf f
	#define PCSYN_DELAY(x) rvf_delay(x)
#else
	#define PCSYN_TRACE_EVENT(f)
	#define PCSYN_DELAY(x)
#endif


/*talcon add, 2004.07.07 */ 
//#define PCSYN_MEM_STATIC
/*talcon add, 2004.07.07 */ 
#ifdef PCSYN_MEM_STATIC
extern BYTE mem_buffer[];
extern int g_codepcsynmem ;
#define PCSYN_new(ptr, size)  	ptr = (void*)mem_buffer
#define PCSYN_free(ptr,size)      	ptr = 0
#else
extern int g_codepcsynmem ;
#define PCSYN_new(ptr, size)  		MI_ALLOC(ptr, size,g_codepcsynmem)
#define PCSYN_free(ptr,size)      	MI_FREE(ptr, g_codepcsynmem)
#endif


#endif
