/*
+-------------------------------------------------------------------+
| PROJECT: PC Synchronization                    
| $Workfile: pcsyn_protocol.h
| $Author: Talcon Hu
| CREATED: 18.05.2004                 
+-------------------------------------------------------------------+
*/
#ifndef _PCSYN_PROTOCOL_
#define _PCSYN_PROTOCOL_

#define BYTE unsigned char

#define STX 0x02
#define ETX 0x02
#define DLE 0x10
#define HEADER_DL 0x80 //target ->pc
#define HEADER_UL 0x12 //pc->target,L1 trace

//֡ŵʼĩβ
#define PC_FRAME_MIN 0x11
#define PC_FRAME_MAX 0xe0

//defien falg for pc_interface
#define PC_IF_FLAGS_DATAUL  0x01
#define PC_IF_FLAGS_CMD       0x02
#define PC_IF_FLAGS_DATADL  0x10

//һСsizestx,header,etx
#define PACKET_MINSIZE 3
//һsizestx,header,etx
#define PACKET_MAXSIZE 50

//ֶελ
typedef enum
{
	iDL_HEADER 		=	-1,
	iDL_FRAMETYPE 	 ,
	iDL_FRAMEID,
	iDL_STATUS	,		
	iDL_FRAMEIDUL,  		
	iDL_DATASIZE  ,      
	iDL_DATA
};

//ֶελ
typedef enum
{
	iUL_HEADER 		=	-1,
	iUL_FRAMETYPE ,
	iUL_FRAMEID,
	iUL_DATASIZE,
	iUL_DATA
};

 
typedef enum
{
	PC_FT_Monitor = 0x00,/*0000 0000*/
	PC_FT_Control = 0x40,/*0100 0000*/
	PC_FT_Info     = 0x80 /*1000 0000*/
}PC_FrameType;

/*control frame type*/ 
typedef enum
{
	PC_CF_Connect = 0x00,
	PC_CF_DisConnect,
	PC_CF_Cmd  = 0x11, 
	PC_CF_DataEnd
}PC_CFType;

/*info frame type*/
typedef enum
{
	PC_IF_Data,
	PC_IF_DataAck
}PC_IFType;


/*define status machine of a connect*/
typedef enum
{
	PC_NOCONNECT,//û
	PC_CONNECTED,//
	PC_CMDRECV,//յݰݰ
	PC_DATAUL,//ݰ
	PC_DATADL,
	PC_DATAULEND,//ݰͽ
	PC_WAITDISCONNECT//wsit disconect
}PC_CNNT_STATUS;

/***********************************

<0x80: protocol error
>=0x80: application error
*************************/
typedef enum
{
	PC_Error_NoError = 0x00,
	PC_Error_CheckSum, //checksumerror
	PC_Error_InvalidPktSize = 0x03,//invalid packed size
	PC_Error_InvalidDataSize ,
	PC_Error_NoConnect,//NO connect
	PC_Error_ConnectExisted,// a connect existed
	PC_Error_InvalidFrameType,
	PC_Error_InvalidFrameid,
	PC_Error_FrameIsReRX = 0x20, //frame Ǳط
	PC_Error_WaitData,//    첽Ĳdataõ
	PC_Error_SerialNoResponse=0x81,//˵targetӦtimeoutfor exampleserial is invalid
	App_Error_DefaultError	 = 0x82,//Ĭʧ
	App_Error_ReadError	 = 0x83,//˵ȡʧ
	App_Error_WriteError ,//˵дʧ
	App_Error_DeleteError ,//˵ɾʧ
	App_Error_CopyError ,//˵ʧ
	App_Error_InfoError ,//˵ȡϢʧ
	App_Error_SendError,  //ͶϢʧ
	App_Error_StoreError, //洢Ϣʧ
	PC_Error_MMINotAllow =  0x90,//ֻpcͬ ҪȽ˵->pcͬ
	PC_Error_MMINeedPause,//е绰Ҫͣ
	PC_Error_MemoryAlloc,/*ڴʧܣܲ*/
	App_Error_ModifyError, //ĶϢʧ
}PC_Error;
	
typedef struct
{
	BYTE stx;
	BYTE etx;
	BYTE dle;
	BYTE header_ul;//pc ->target
	BYTE header_dl;//target->pc
	BYTE frameid;
	BYTE frametype;
	unsigned int status	;//the status machine of connect
							
}PC_Protocol;

//packet of  pc-->target
typedef struct 
{
	BYTE frametype;
	BYTE frameid;
	BYTE datasize;
	BYTE data[128];
}PC_Packet_UL;

//packet of target-->pc
typedef struct 
{
	BYTE frametype;
	BYTE frameid;
	BYTE status;
	BYTE frametype_ul;
	BYTE datasize;
	BYTE data[128];
}PC_Packet_DL;

typedef struct
{
	unsigned int flag;
	BYTE *pdata_cmd;
	unsigned int  size_cmd;
	BYTE *pdata_ulbuff;
	unsigned int size_ulbuff;
	BYTE *pdata_dlbuff;
	unsigned int size_dlbuff;

	unsigned int status;//ֵ
}PC_Interface_Info;


/*
*flag:
	0x01: write data to target
	0x02: transfer cmd to target
*/

int handle_inbuffer(BYTE *buff_in,unsigned short size_buff_in);
int pc_writebystatus(int status);
//zkc add 	07/22/04
int pc_writebyinfo(unsigned int status);

unsigned int pc_interface(PC_Interface_Info * info);

extern unsigned long SER_tr_WriteNBytes (int serial_data_flow,
                                       BYTE *buffer,
                                       unsigned long chars_to_write);

#endif
