#$history#	
#
#	2004-07-55 Talcon Hu created for pcsyn integration
#
#

include $(CONDAT_BASE_DIR)/condat_lib_ip.mak
OBJ := $(SRCPCSYN)/obj


	
#
# Settings for the compilation process
# depending whether traces will be compressed or not
#
ifeq ($(CTRACE), 0)
# without str2ind - compilation only
PRE := $(CC) -c
INT := @echo OLD STYLE TRACES - the following file will not be build:
COM := @echo OLD STYLE TRACES - the following file will not be build:
else
# with str2ind - preprocessing, str2ind, compilation
PRE := $(CC) -po -p?
INT := str2ind -a -l $(STR2IND_LOG) -t $(STR2IND_TAB) -v $(STR2IND_C) -f
COM := $(CC) -c
endif


INC_MISC	= -I$(TOP_DIR)/$(SYSTEM_DIR)/main  -I$(TOP_DIR)/$(SYSTEM_DIR)/config -I$(TOP_DIR)/../services/audio
INC_RIV		= -I$(TOP_DIR)/$(RIVIERA_DIR)/rv -I$(TOP_DIR)/$(RIVIERA_DIR)/rvf
INC_CONDAT	= -I$(SRCMFW) -I$(SRCACI) -I$(SRCKSD) -I$(GPF_DIR)/INC -I$(SRCBMI)

ifeq ($(ZHQ_MMI_BUILD),1)
INC_DRIVER  = -I$(TOP_DIR)/Drivers-lib-mmi/header
else
INC_DRIVER	= -I$(TOP_DIR)/../drivers/common/rtc -I$(TOP_DIR)/../drivers/board/ffs -I$(TOP_DIR)/../drivers/board/spi -I$(TOP_DIR)/../Layer1/tm_cust0 \
			  -I$(TOP_DIR)/../drivers/board/melody  -I$(TOP_DIR)/../drivers/common	
endif			  
 
INC_PCSYN		= -I$(SRCPCSYN)/src -I$(SRCPCSYN)/inc 	 

PCSYNOBJ = $(OBJ)/pcsyn.$(OBJ_TAIL) \
			$(OBJ)/pcsyn_protocol.$(OBJ_TAIL)\
			$(OBJ)/pcsyn_application.$(OBJ_TAIL)\
			$(OBJ)/pcsyn_pei.$(OBJ_TAIL)\
			$(OBJ)/pcsyn_hisrp.$(OBJ_TAIL)\
			$(OBJ)/pcsyn_mmip.$(OBJ_TAIL)\
			$(OBJ)/pcsyn_mmis.$(OBJ_TAIL)


	
#
# Creating pcsyn lib
#
$(PCSYN_LIB) : $(OBJ) $(PCSYNOBJ)
	$(AR) r $(PCSYN_LIB) $(PCSYNOBJ)
	
FORCE:

$(OBJ):	
	mkdir $(subst /,$(SLASH),$(OBJ))
	
clean: 
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(PCSYNOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCPCSYN)/src/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INC_DRIVER) >> cmd
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
#	echo $(ZHQDRV0) >> cmd
#	echo $(ZHQDRV1) >> cmd
#	echo $(ZHQDRV2) >> cmd
#	echo $(INC_RIV) >> cmd
	echo $(INCDRV2) >> cmd
	echo -I$(ICOM) >> cmd
	echo -I$(ICDG) >> cmd
	echo $(INC_CONDAT) >> cmd
	echo $(INC_PCSYN) >> cmd
#	echo $(INC_MISC) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd

	
