#line 9 "c:/tms4701x/stdarg.h"
typedef int *va_list;
 
#line 15 "c:/tms4701x/string.h"
typedef unsigned size_t;
#line 24
static inline size_t  strlen(const char *s);
static inline char   *strcpy(char *s1, const char *s2);
static inline char   *strncpy(char *s1, const char *s2, size_t n);
static inline char   *strcat(char *s1, const char *s2);
static inline char   *strncat(char *s1, const char *s2, size_t n);
static inline char   *strchr(const char *s, int c);
static inline char   *strrchr(const char *s, int c);
         int     strcmp(const char *s1, const char *s2);
         int     strncmp(const char *s1, const char *s2, size_t n);
        
         int     strcoll(const char *s1, const char *s2);
         size_t  strxfrm(char *s1, const char *s2, size_t n);
         char   *strpbrk(const char *s1, const char *s2);
         size_t  strspn(const char *s1, const char *s2);
         size_t  strcspn(const char *s1, const char *s2);
         char   *strstr(const char *s1, const char *s2);
         char   *strtok(char *s1, const char *s2);
         char   *strerror(int errno);
        
         void   *memmove(void *s1, const void *s2, size_t n);
         void   *memcpy(void *s1, const void *s2, size_t n);
         int     memcmp(const void *s1, const void *s2, size_t n);
static inline void   *memchr(const void *s, int c, size_t n);
static inline void   *memset(void *s, int c, size_t n);

#line 54
static inline size_t strlen(const char *s)
{
   const char *r = s - 1;

   while (*++r);
   return r - s;
}

 
 
 
static inline char *strcpy(char *s1, const char *s2)
{
   char *result = s1;

   while (*s1++ = *s2++);
   return result;
}

 
 
 
static inline char *strncpy(char *s1, const char *s2, size_t n)
{
   char *result = s1;

   if (n == 0) return result; 
   while ((*s1++ = *s2++) && --n != 0);   
   if (n > 1)
   {
      --n;
      do *s1++ = 0; while (--n);          
   }
   return result;
}

 
 
 
static inline char *strcat(char *s1, const char *s2)
{
   char *result = s1;

   while (*s1++);			      
   --s1;				      
   while (*s1++ = *s2++);	              
   return result;
}

 
 
 
static inline char *strncat(char *s1, const char *s2, size_t n)
{
   char *result = s1;

   while (*s1++);			    
   --s1;  				    
   while (n-- != 0) 
      if (!(*s1++ = *s2++)) return result;  
   *s1 = 0;
   return result;
}

 
 
 
static inline char *strchr(const char *s, int c)
{
   do
      if (*s == c) return (char *)s;
   while (*s++);
 
   return 0;
}

 
 
 
static inline char *strrchr(const char *s, int c)
{
   char *result = 0;
 
   do
      if (*s == c) result = (char *)s;
   while (*s++);
 
   return(result);
}

 
 
 
static inline void *memchr(const void *s, int c, size_t n)
{
   const unsigned char *st = (unsigned char *)s;
   unsigned char        ch = c;

   while (n-- != 0) 
      if (*st++ == ch) { return (void *)--st; }
   return 0;
}

 
 
 
static inline void *memset(void *s, int c, size_t n)
{
   unsigned char *st = (unsigned char *)s;
   unsigned char  ch = c;

   while (n-- > 0)  *st++ = ch;
   return s;
}

#line 13 "c:/tms4701x/stdlib.h"
typedef struct { int quot, rem; } div_t, ldiv_t;

#line 28
typedef char wchar_t;
#line 47
         int           abs (int val); 
         long          labs(long val);
        
         int           atoi(const char *st);
static inline long          atol(const char *st);
static inline double        atof(const char *st);

         long          strtol (const char *st, char **endptr, int base);
         unsigned long strtoul(const char *st, char **endptr, int base);
         double        strtod (const char *st, char **endptr);

         int           rand (void);
         void          srand(unsigned seed);

         void         *calloc  (size_t num, size_t size);
         void         *malloc  (size_t size);
         void         *realloc (void *ptr, size_t size);
         void          free    (void *ptr);
	 void         *memalign(size_t aln, size_t size);

         void          abort  (void); 
         int           atexit (void (*func)(void));
         void         *bsearch(const void *key, 
			       const void *base, 
			       size_t nmemb, 
			       size_t size, 
			       int (*compar)(const void *,const void *)); 
         void          qsort  (void *base, 
			       size_t nmemb,
			       size_t size, 
			       int (*compar)(const void *, const void *));
         void          exit   (int status);

         div_t         div (int numer, int denom);
         ldiv_t        ldiv(long numer, long denom);

         char         *getenv(const char *string);
	 int           system(const char *name);

#line 91
static inline double atof(const char *st)
{
   return strtod(st, (char **)0);
}

 
 
 
static inline long atol(register const char *st)
{
   return atoi(st);
}

#line 13 "c:/tms4701x/stddef.h"
typedef int ptrdiff_t;

#line 69 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/typedefs.h"
typedef unsigned char       U8;
typedef signed char         S8;
typedef unsigned short      U16;
typedef signed short        S16;
typedef unsigned long       U32;
typedef signed long         S32;
  
#line 82
typedef unsigned short UINT16;  
#line 89
typedef unsigned int UINT32;
#line 96
typedef long                LONG;


typedef unsigned char       UBYTE;
typedef short               SHORT;
typedef UBYTE               BYTE;




typedef char                CHAR;
#line 119
typedef UBYTE             BOOL;
#line 126
typedef unsigned char       UCHAR;

typedef unsigned short      USHORT;
typedef unsigned long       ULONG;

typedef unsigned int        UINT;
#line 136
typedef unsigned long T_VOID_STRUCT;

typedef unsigned long T_ENUM; 

#line 209 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/ccdapi.h"
typedef struct
{
  USHORT l_buf;
  USHORT o_buf;
  UBYTE  buf [1];
} T_MSGBUF;


 
#line 224
typedef ULONG T_ERR_INFO;



typedef struct
{
  T_ERR_INFO  err_info;
  ULONG       err_IEaddr;
} T_CCD_ERR_TYPE;

 



typedef struct
{
  UBYTE  num_para;
  USHORT err_list[3];
} T_CCD_PARA_LIST;

 


typedef union
{
  T_CCD_PARA_LIST  para_list;
  T_CCD_ERR_TYPE   err_type;
} T_CCD_ERR_PARA;

 


typedef struct
{
  UBYTE error;
  UBYTE kind;
  T_CCD_ERR_PARA para;
} T_CCD_ERR_ENTRY;



 
#line 349
  extern BYTE  ccd_init                   (void);
  extern void  ccd_exit                   (void);

  extern UBYTE *ccd_begin                 (void);

  extern void  ccd_end                    (void);

  extern BYTE  ccd_decodeMsg              (UBYTE           entity,
                                           UBYTE           direction,
                                           T_MSGBUF       *mBuf,
                                           UBYTE          *mStruct,
                                           UBYTE           pt);

  extern int  ccd_decodeElem              (ULONG           ccdid,
                                           USHORT          l_buf,
                                           USHORT          o_buf,
                                           UCHAR          *buf,
                                           UCHAR          *eStruct);

  extern BYTE ccd_decodeMsgPtr            (UBYTE          entity,
                                           UBYTE          direction,
                                           USHORT         l_buf,
                                           USHORT         o_buf,
                                           UBYTE         *buf,
                                           UBYTE        **mStructPtr,
                                           UBYTE          pt);

  extern BYTE  ccd_codeMsg                (UBYTE           entity,
                                           UBYTE           direction,
                                           T_MSGBUF        *mBuf,
                                           UBYTE           *mStruct,
                                           UBYTE           pt);

  extern BYTE ccd_codeMsgPtr              (UBYTE           entity,
                                           UBYTE           direction,
                                           USHORT         *l_buf,
                                           USHORT          o_buf,
                                           UBYTE          *buf,
                                           UBYTE          *mStruct,
                                           UBYTE           pt);

  extern int  ccd_encodeElem              (ULONG           ccdid,
                                           USHORT         *l_buf,
                                           USHORT          o_buf,
                                           UCHAR          *buf,
                                           UCHAR          *eStruct);





  extern UBYTE ccd_getFirstError          (UBYTE           entity,
                                           USHORT         *parlist);

  extern UBYTE ccd_getNextError           (UBYTE           entity,
                                           USHORT         *parlist);

  extern ULONG ccd_getFirstFault          (T_CCD_ERR_ENTRY **ccd_err_entry);

  extern ULONG ccd_getNextFault           (T_CCD_ERR_ENTRY **ccd_err_entry);

  extern void  ccd_free_faultlist         ();

  extern int   ccd_get_numFaults          ();




  extern BYTE  ccd_decodeByte             (UBYTE          *bitstream,
                                           USHORT          startbit,
                                           USHORT          bitlen,
                                           UBYTE          *value);

  extern BYTE  ccd_codeByte               (UBYTE          *bitstream,
                                           USHORT          startbit,
                                           USHORT          bitlen,
                                           UBYTE           val);

  extern BYTE  ccd_codeLong               (UBYTE          *bitstream,
                                           USHORT          startbit,
                                           USHORT          bitlen,
                                           ULONG           value);

  extern BYTE  ccd_decodeLong             (UBYTE          *bitstream,
                                           USHORT          startbit,
                                           USHORT          bitlen,
                                           ULONG          *value);

  extern void  ccd_bitcopy                (UBYTE          *dest,
                                           UBYTE          *source,
                                           USHORT          bitlen,
                                           USHORT          offset);
#line 42 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/header.h"
typedef struct
{
  USHORT l_buf;
  USHORT o_buf;
  UBYTE  buf[1];
} T_sdu;

#line 54
typedef struct
{
  USHORT          list_len;        
  ULONG           first;           
} T_desc_list;

#line 68
typedef struct
{
  ULONG           next;            
  USHORT          len;             
  UBYTE           buffer[1];       
} T_desc;
#line 80
typedef struct
{
  UBYTE  *Adr[2];
  USHORT  Len[2];
} T_FRAME_DESC;

#line 109
typedef struct
{
  ULONG opc;          
  ULONG len;          
  ULONG use_cnt;     
  T_sdu *sdu;         
  ULONG sh_offset;    
  ULONG dph_offset;   
} T_PRIM_HEADER;




typedef struct _T_DP_HEADER
{
  ULONG magic_nr;     
  ULONG size;         
  ULONG use_cnt;     
  ULONG offset;       
  ULONG est_size;    
  struct _T_DP_HEADER *next;
} T_DP_HEADER;

typedef struct
{
  int ref_cnt;       
} T_M_HEADER;

 
#line 161
typedef struct
{
  ULONG magic_nr;
  ULONG time;
  char  snd     [8];
  char  rcv     [8];
  char  org_rcv [8];
} T_S_HEADER;

typedef struct
{
  T_PRIM_HEADER p_hdr;
  T_PRIM_HEADER *prim_ptr;
} T_PRIM_X;

#line 71 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/gdi.h"
typedef void * drv_ProcHandle_Type;

 
#line 82
typedef struct
{
  USHORT              SignalType;
  USHORT              DrvHandle;
  ULONG               DataLength;
  T_VOID_STRUCT       *UserData;
} T_DRV_SIGNAL;

 
#line 102
typedef void (*T_DRV_CB_FUNC ) (T_DRV_SIGNAL * Signal);

struct _T_DRV_EXPORT;

typedef struct
{



  void (*drv_Exit)(void);
  USHORT (*drv_Read)(void*, ULONG*);
  USHORT (*drv_Write)(void*, ULONG*);
  USHORT (*drv_Look)(void*, ULONG*);
  USHORT (*drv_Clear)(USHORT);
  USHORT (*drv_Flush)(void);
  USHORT (*drv_SetSignal)(USHORT);
  USHORT (*drv_ResetSignal)(USHORT);
  USHORT (*drv_SetConfig)(char*);
  USHORT (*drv_GetConfig)(char*);
  void (*drv_Callback)(T_DRV_SIGNAL*);
} T_DRV_FUNC;

typedef struct _T_DRV_EXPORT 
{
  const char    *Name;
  USHORT   	    Flags;              
  T_DRV_FUNC DrvFunc;
} T_DRV_EXPORT;


typedef struct
{
  char const *Name;
  USHORT (*drv_Init)(USHORT, T_DRV_CB_FUNC, T_DRV_EXPORT const **);
  char const *Process;
  void const *DrvConfig;
} T_DRV_LIST_ENTRY;

typedef struct
{
  T_DRV_LIST_ENTRY DrvEntry [ 5 ];
} T_DRV_LIST;

 
#line 57 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/drvconf.h"
typedef struct
{
  T_DRV_LIST_ENTRY entry;  
  USHORT drv_pos;
} T_TST_DRV_ENTRY;

 

SHORT tst_drv_open (char *drv_name, T_TST_DRV_ENTRY **drv_info );


#line 156 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/vsi.h"
typedef ULONG T_TIME;
typedef int T_HANDLE;

#line 35 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/pei.h"
typedef int    T_PEI_RETURN;
typedef char * T_PEI_CONFIG;
typedef void   T_PEI_MONITOR;

 
#line 49
typedef void   (*T_VOID_FUNC)();
typedef short  (*T_SHORT_FUNC)();

typedef struct { T_VOID_FUNC func; size_t size; size_t soff; ULONG opc; } T_FUNC;
#line 59
typedef struct
{
  SHORT (*pei_init)(T_HANDLE);
  SHORT (*pei_exit)(void);
  SHORT (*pei_primitive)(void*);
  SHORT (*pei_timeout)(USHORT);
  SHORT (*pei_signal)(ULONG,void*);
  SHORT (*pei_run)(T_HANDLE,T_HANDLE);
  SHORT (*pei_config)(char*);
  SHORT (*pei_monitor)(void**);
} T_PEI_FUNC;


typedef struct                                         
{
  char const *Name;
  T_PEI_FUNC PeiTable;
  ULONG      StackSize;
  USHORT     QueueEntries;
  USHORT     Priority;
  USHORT   	 NumOfTimers;
  UBYTE      Flags;
} T_PEI_INFO;


#line 34 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/alert.h"
  extern BOOL _Alert(char *, T_HANDLE, ULONG);
  extern BOOL alert_info(char *, ...);
#line 162 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/vsi.h"
union T_MSG
{
  struct T_Prim
  {
    T_VOID_STRUCT *Prim;
    ULONG		      PrimLen;
  } Primitive;
  struct Sig
  {
    ULONG		      SigOPC;
    T_VOID_STRUCT *SigBuffer;
    ULONG		SigLen;
  } Signal;
  struct Tim
  {
    ULONG    Index;
  } Timer;
};

typedef	struct
{
   USHORT		 MsgType;
   union T_MSG Msg;
} T_QMSG;

typedef struct 
{
   char const *Str;
   USHORT  Ind;
} T_STR_IND;

 

T_HANDLE        vsi_p_create      (T_HANDLE Caller, 
                                   SHORT (*pei_create)(T_PEI_INFO const ** info),
                                   void (*TaskEntry)(T_HANDLE, ULONG), 
                                   T_HANDLE MemPoolHandle );
int             vsi_p_exit        (T_HANDLE Caller, T_HANDLE TaskHandle);
int             vsi_p_delete      (T_HANDLE Caller, T_HANDLE TaskHandle);
int             vsi_p_start       (T_HANDLE Caller, T_HANDLE TaskHandle);
int             vsi_p_stop        (T_HANDLE Caller, T_HANDLE TaskHandle);
int             vsi_p_name        (T_HANDLE Caller, T_HANDLE Handle, char *Name);
T_HANDLE        vsi_p_handle      (T_HANDLE Caller, char *Name);
void            vsi_o_set_htrace  (T_HANDLE comhandle);

T_VOID_STRUCT * vsi_m_new         (ULONG Size, USHORT type );
T_VOID_STRUCT * vsi_m_new_size    (ULONG size, USHORT type, 
                                   ULONG *partition_size );
int             vsi_m_free        (T_VOID_STRUCT **Addr );
int             vsi_m_status      (T_HANDLE caller, ULONG size, USHORT type, USHORT *free, USHORT *alloc);
int             vsi_m_init        (char enable_init, char pattern);
T_VOID_STRUCT * vsi_m_cnew        (ULONG size, USHORT type );
int             vsi_m_cfree       (T_VOID_STRUCT **ptr );
int             vsi_m_attach      (T_VOID_STRUCT *ptr );

T_HANDLE        vsi_c_open        (T_HANDLE Caller, char *Name);
int             vsi_c_close       (T_HANDLE Caller, T_HANDLE ComHandle);
int             vsi_c_clear       (T_HANDLE Caller, T_HANDLE ComHandle);
T_VOID_STRUCT * vsi_c_pnew        (ULONG Size, ULONG opc );
T_VOID_STRUCT * vsi_c_new_sdu     (ULONG Size, ULONG opc, USHORT sdu_len, 
                                   USHORT sdu_offset, USHORT encode_offset );
T_VOID_STRUCT * vsi_c_ppass       (T_VOID_STRUCT *prim, ULONG opc );
void            vsi_c_pstore      (T_VOID_STRUCT *prim );
int             vsi_c_pfree       (T_VOID_STRUCT **Msg );
int             vsi_c_ssend       (T_HANDLE ComHandle, ULONG opc,
                                   T_VOID_STRUCT *ptr, ULONG MsgLen );
int             vsi_c_psend       (T_HANDLE ComHandle, T_VOID_STRUCT *ptr );
T_VOID_STRUCT * vsi_c_reuse       (T_PRIM_HEADER *ptr, ULONG Size, 
                                   ULONG opc, USHORT sdu_len, USHORT sdu_offset, 
                                   USHORT encode_offset );
T_VOID_STRUCT * vsi_c_new         (T_HANDLE Caller, ULONG Size, ULONG opc );
int             vsi_c_send        (T_HANDLE Caller, T_HANDLE ComHandle, 
                                   T_QMSG *Msg );
int             vsi_c_free        (T_HANDLE Caller, T_VOID_STRUCT **Msg );
int             vsi_c_pmax_size   (void);
int             vsi_c_sync        (T_HANDLE Caller, T_TIME timeout);
T_VOID_STRUCT * vsi_drpo_new      (ULONG size, ULONG opc, ULONG guess );
T_VOID_STRUCT * vsi_drp_new       (ULONG size, ULONG guess );
T_VOID_STRUCT * vsi_dp_new        (ULONG size, T_VOID_STRUCT *addr, ULONG guess );
int             vsi_free          (T_VOID_STRUCT **Msg );
int             vsi_dp_sum        (T_VOID_STRUCT *addr, ULONG *size);
int             vsi_dp_max_size   (void);
int             vsi_c_await       (T_HANDLE Caller, T_HANDLE ComHandle, T_QMSG *Msg, 
                                   ULONG Timeout);
int             vsi_c_primitive   (T_HANDLE Caller, void *Prim);
int             vsi_c_awake       (T_HANDLE caller );
int             vsi_c_status      (T_HANDLE q_handle, unsigned int *used, unsigned int *free);

int             vsi_t_start       (T_HANDLE Caller, USHORT Index, T_TIME Value);
int             vsi_t_pstart      (T_HANDLE Caller, USHORT Index, T_TIME Value1, 
                                   T_TIME Value2 );
int             vsi_t_stop        (T_HANDLE Caller, USHORT Index );
int             vsi_t_status      (T_HANDLE Caller, USHORT Index, T_TIME *Value );
int             vsi_t_config      (T_HANDLE Caller, USHORT Index, UBYTE Mode, ULONG Value );
int             _vsi_t_config     (T_HANDLE Caller, char *CfgString, const T_STR_IND *pTable );

T_HANDLE        vsi_s_open        (T_HANDLE Caller, char *Name, USHORT Count);
int             vsi_s_close       (T_HANDLE Caller, T_HANDLE SemHandle);
int             vsi_s_get         (T_HANDLE Caller, T_HANDLE SemHandle);
int             vsi_s_release     (T_HANDLE Caller, T_HANDLE SemHandle);
int             vsi_s_status      (T_HANDLE Caller, T_HANDLE SemHandle, USHORT *Count);

int             vsi_o_func_ttrace (const char * const format, ... );
int             vsi_o_event_ttrace(const char * const format, ... );
int             vsi_o_error_ttrace(const char * const format, ... );
int             vsi_o_state_ttrace(const char * const format, ... );
int             _vsi_o_ttrace     (ULONG TraceClass, const char * const format, ... );
int             vsi_o_ttrace      (T_HANDLE Caller, ULONG TraceClass, const char * const format, ... );
int             vsi_o_func_itrace (ULONG index, const char * const format, ... );
int             vsi_o_event_itrace(ULONG index, const char * const format, ... );
int             vsi_o_error_itrace(ULONG index, const char * const format, ... );
int             vsi_o_state_itrace(ULONG index, const char * const format, ... );
int             _vsi_o_itrace     (ULONG TraceClass, ULONG index, const char * const format, ... );
int             vsi_o_itrace      (T_HANDLE Caller, ULONG TraceClass, ULONG index, const char * const format, ... );
int             vsi_o_ptrace      (T_HANDLE Caller, ULONG opc, UBYTE dir );
int             vsi_o_strace      (T_HANDLE Caller,  const char *const machine,
                                   const char *const curstate,
                                   const char *const newstate);
int             vsi_o_assert      (T_HANDLE Caller, USHORT cause, const char *file, int line, const char * const format, ...);
int             vsi_settracemask  (T_HANDLE Caller, T_HANDLE Handle, ULONG Mask );
int             vsi_gettracemask  (T_HANDLE Caller, T_HANDLE Handle, ULONG *Mask );
int             vsi_trcsuspend    (T_HANDLE Caller, T_HANDLE Handle, ULONG Suspend );
int             vsi_trc_free      (T_HANDLE Caller, T_VOID_STRUCT **Msg);

void            vsi_ppm_new       (T_HANDLE Caller, ULONG Size, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_rec       (T_HANDLE Caller, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_access    (T_HANDLE Caller, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_store     (T_HANDLE Caller, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_send      (T_HANDLE Caller, T_HANDLE rcv, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_reuse     (T_HANDLE Caller, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_free      (T_HANDLE Caller, T_PRIM_HEADER *prim, const char* file, int line );
void            vsi_ppm_setend    (T_PRIM_HEADER *Prim, ULONG Size );

int             vsi_gettaskname   (T_HANDLE Caller, T_HANDLE Handle, char *Name);
T_HANDLE        vsi_gettaskhandle (T_HANDLE Caller, char *Name);
int             vsi_e_name        (T_HANDLE Caller, T_HANDLE Handle, char *Name);
T_HANDLE        vsi_e_handle      (T_HANDLE Caller, char *Name);
int             vsi_gettaskflags  (T_HANDLE Caller, T_HANDLE Handle, ULONG *Flags);
int             vsi_t_time        (T_HANDLE Caller, T_TIME *Value);
int             vsi_t_sleep       (T_HANDLE Caller, T_TIME Value);
int             vsi_object_info   (T_HANDLE caller, USHORT Id, USHORT Index, char *Buffer, USHORT Size);

void            vsi_d_callback    (T_DRV_SIGNAL *Signal );
int             vsi_d_create      (T_HANDLE Caller, T_TST_DRV_ENTRY *drv_info );
int             vsi_d_init        (T_HANDLE Caller );
int             vsi_d_exit        (T_HANDLE Caller, T_HANDLE DrvHandle );
int             vsi_d_open        (T_HANDLE Caller, char *Name );
int             vsi_d_close       (T_HANDLE Caller, T_HANDLE DrvHandle );
int             vsi_d_read        (T_HANDLE Caller, T_HANDLE DrvHandle, void *Buffer, ULONG *Size );
int             vsi_d_write       (T_HANDLE Caller, T_HANDLE DrvHandle, void *Buffer, ULONG Size );
int             vsi_d_flush       (T_HANDLE Caller, T_HANDLE DrvHandle );
int             vsi_d_setsignal   (T_HANDLE Caller, T_HANDLE DrvHandle, USHORT SignalType );
int             vsi_d_resetsignal (T_HANDLE Caller, T_HANDLE DrvHandle, USHORT SignalType );
int             vsi_d_setconfig   (T_HANDLE Caller, T_HANDLE DrvHandle, char *Config );
int             vsi_d_getconfig   (T_HANDLE Caller, T_HANDLE DrvHandle, char *Config );

 

#line 497
extern char EntityNameBuf[];
#line 33 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/../../gpf/INC/tok.h"
typedef struct KW_DATA
{
   const char * const keyword;
   const SHORT code;   
} KW_DATA;

typedef struct TOK_DCB
{
  char   * tokbuf;
  char   * nexttok;
  char   lastchar;
} TOK_DCB;

 

void  tok_init (char *);
SHORT tok_next (char **, char **);
SHORT tok_key  (KW_DATA *, char *);

#line 59 "D:/work/M288S/ssa/system-mmi/../riviera/rv/general.h"
typedef unsigned char   UINT8;
typedef signed char     INT8;
typedef short           INT16; 
typedef int             INT32;
typedef unsigned char   BOOLEAN;

typedef void (*FUNC)(void);       

#line 50 "D:/work/M288S/ssa/system-mmi/../riviera/rv/rv_general.h"
typedef enum {
	RV_OK						= 0,
	RV_NOT_SUPPORTED				= -2,
	RV_NOT_READY					= -3,
	RV_MEMORY_WARNING				= -4,
	RV_MEMORY_ERR					= -5,
	RV_MEMORY_REMAINING				= -6,
	RV_INTERNAL_ERR					= -9,
	RV_INVALID_PARAMETER			        = -10
} T_RV_RET;


 


typedef UINT8 T_RVF_G_ADDR_ID;
#line 70
typedef void (*callback_func)(void *);
 


 
#line 81
typedef struct
{
	T_RVF_G_ADDR_ID	addr_id;
	void			(*callback_func)(void *);
} T_RV_RETURN_PATH;


#line 105
typedef struct {
    UINT32			msg_id;
	void			(*callback_func)(void *);
    T_RVF_G_ADDR_ID	src_addr_id;
	T_RVF_G_ADDR_ID	dest_addr_id;
} T_RV_HDR;

#line 167
typedef UINT8 T_BD_ADDR[(6)];		



typedef UINT8 T_LINK_KEY[(16)];



typedef UINT8 T_PIN_CODE[(16)];



typedef UINT8 T_DEV_CLASS[(3)];



typedef UINT8 T_BD_NAME[(248)];



typedef UINT8 T_EVENT_MASK[(8)];



typedef UINT8 T_LAP[(3)];
typedef UINT8 T_INQ_LAP[(3)];


typedef UINT8 T_RAND_NUM[(16)];



typedef UINT8 T_ACO[(12)];



typedef UINT8 T_COF[(12)];


typedef UINT8 T_RV_BUFFER;

#line 49 "D:/work/M288S/ssa/system-mmi/../riviera/rvf/rvf_api.h"
void rvf_send_trace1(char * msg, UINT8 msg_length, UINT32 val, UINT8 trace_level, UINT32 swe_use_id);
#line 56
typedef T_RV_RET T_RVF_RET;

#line 66
typedef enum{
	RVF_GREEN,
	RVF_YELLOW,
	RVF_RED
}T_RVF_MB_STATUS;

 
typedef enum { SUSPEND, RUNNING} T_RVF_TASK_STATE;

 
#line 128
typedef UINT16 T_RVF_MB_ID;

typedef char T_RVF_MB_NAME[10];

typedef void (*CALLBACK_FUNC)(void *);
typedef void (*MB_CALLBACK_FUNC)(T_RVF_MB_ID);

typedef struct{
	UINT32 size;
	UINT32 watermark;
} T_RVF_MB_PARAM;



 

typedef struct _tle
{
	T_RV_HDR	  hdr;
	struct _tle  *p_next;
	struct _tle  *p_prev;
	UINT32        ticks;
	UINT16        event;			 
	UINT32        param;			 
	UINT32		  t_init;
	void*		  p_data;
} T_RVF_TIMER_LIST_ENT;

typedef T_RVF_TIMER_LIST_ENT*	P_NODE;

 

typedef struct 
{
    T_RVF_TIMER_LIST_ENT   *p_first;
    T_RVF_TIMER_LIST_ENT   *p_last;
    UINT32           last_ticks;
	UINT16			 timerCnt;
} T_RVF_TIMER_LIST_Q;


 


typedef struct 
{   void    *p_first;
    void    *p_last;
    UINT16  count;
} T_RVF_BUFFER_Q;

#line 185
typedef struct {
	T_RV_HDR				hdr;
	UINT32			tm_id;
	UINT8					cont;
	void*					action;
} T_RVF_TMS_MSG;

 
typedef struct
{	UINT32	words[11];
}T_RVF_MUTEX;

 
#line 216
typedef void (*TASKPTR)(UINT32);
#line 234
void			rvf_init(void);
T_RVF_RET		rvf_create_legacy_task (TASKPTR task_entry, UINT8 task_id, char *taskname, UINT8 *stack, UINT16 stacksize, UINT8 priority, UINT8 time_slicing, T_RVF_TASK_STATE is_suspend) ;
T_RVF_RET		rvf_create_task (TASKPTR task_entry, T_RVF_G_ADDR_ID task_id, char *taskname, UINT8 *stack, UINT16 stacksize, UINT8 priority, UINT8 tcode, UINT8 time_slicing, T_RVF_TASK_STATE is_suspend);
T_RVF_RET		rvf_resume_task( T_RVF_G_ADDR_ID taskid);
void			rvf_exit_task(T_RVF_G_ADDR_ID vtask);
T_RVF_RET		rvf_suspend_task(T_RVF_G_ADDR_ID vtask);
T_RVF_G_ADDR_ID	rvf_get_taskid(void);
char *			rvf_get_taskname(void);
T_RVF_G_ADDR_ID rvf_get_context();

 
typedef T_RV_HDR T_RVF_MSG ;
typedef UINT32	  T_RVF_MSG_ID;

T_RVF_RET		rvf_send_msg			(T_RVF_G_ADDR_ID addr_id, void * p_msg);
T_RVF_MB_STATUS rvf_get_msg_buf			(T_RVF_MB_ID mb_id,
											UINT32 message_size,
											T_RVF_MSG_ID msg_id,
											T_RVF_MSG ** pp_msg);
T_RVF_RET		rvf_free_msg			(T_RVF_MSG * p_msg);
T_RVF_RET		rvf_free_timer_msg		(T_RVF_MSG *p_msg);



 
void *			rvf_read_mbox  (UINT8 mbox);
void *			rvf_read_addr_mbox (T_RVF_G_ADDR_ID  task_id, UINT8 mbox);
UINT8			rvf_send_event (T_RVF_G_ADDR_ID task_id, UINT16 event);

 
T_RVF_RET		rvf_initialize_mutex( T_RVF_MUTEX * mutex);
T_RVF_RET		rvf_lock_mutex( T_RVF_MUTEX * mutex);
T_RVF_RET		rvf_unlock_mutex( T_RVF_MUTEX * mutex);
T_RVF_RET		rvf_delete_mutex( T_RVF_MUTEX * mutex);


 
T_RVF_RET		rvf_create_mb(T_RVF_MB_NAME mb_name, T_RVF_MB_PARAM mb_param, T_RVF_MB_ID *mb_id);
T_RVF_RET		rvf_delete_mb(T_RVF_MB_NAME mb_name);
T_RVF_RET		rvf_get_mb_id(T_RVF_MB_NAME mb_name, T_RVF_MB_ID *mb_id);
T_RVF_MB_STATUS	rvf_get_mb_status(T_RVF_MB_ID mb_id);
T_RVF_RET		rvf_mb_is_used(T_RVF_MB_NAME mb_name, UINT8* isUsed) ;

T_RVF_MB_STATUS	rvf_get_buf(T_RVF_MB_ID mb_id, UINT32 buffer_size, void** p_buffer);
T_RVF_MB_STATUS	rvf_count_buf(T_RVF_MB_ID mb_id, void * p_buffer);
T_RVF_RET		rvf_free_buf( void * p_buffer);
T_RVF_RET		rvf_set_callback_func(T_RVF_MB_ID mb_id, MB_CALLBACK_FUNC func);
T_RVF_RET		rvf_change_callback_func(T_RVF_MB_ID mb_id, MB_CALLBACK_FUNC func);

void rvf_get_protected_buf(T_RVF_MB_ID mb_id, UINT32 buffer_size, void** p_buffer);
  

UINT32			rvf_get_buf_size (void *bptr);
				 
T_RVF_RET		rvf_get_mb_param( T_RVF_MB_NAME mb_name, T_RVF_MB_PARAM * param);
				 
T_RVF_RET		rvf_set_mb_param( T_RVF_MB_NAME mb_name, T_RVF_MB_PARAM * param);


 
T_RVF_RET		rvf_enqueue (T_RVF_BUFFER_Q *p_q, void *p_buf);
T_RVF_RET		rvf_enqueue_head (T_RVF_BUFFER_Q *p_q, void *p_buf);
void *			rvf_dequeue  (T_RVF_BUFFER_Q *p_q);
void *	rvf_scan_next (T_RVF_BUFFER_Q * p_q, void * p_buf);
T_RVF_RET		rvf_remove_from_queue (T_RVF_BUFFER_Q * p_q, void * p_buf);

 

UINT16			rvf_wait(UINT16 flag, UINT32 ticks);
UINT16			rvf_evt_wait(T_RVF_G_ADDR_ID rtask, UINT16 flag, UINT32 timeout) ;
void			rvf_delay(UINT32 ticks);

void			rvf_start_timer(UINT8 tnum, UINT32 ticks, BOOLEAN is_continuous);
void			rvf_stop_timer (UINT8 tnum);
char *			rvf_get_time_stamp(char *tbuf);
UINT32			rvf_get_tick_count(void);
void			rvf_init_timer_list (T_RVF_TIMER_LIST_Q *p_timer_listq);
void			rvf_init_timer_list_entry (T_RVF_TIMER_LIST_ENT  *p_tle);
UINT16			rvf_update_timer_list (T_RVF_TIMER_LIST_Q *p_timer_listq);
void			rvf_add_to_timer_list (T_RVF_TIMER_LIST_Q *p_timer_listq, T_RVF_TIMER_LIST_ENT  *p_tle);
void			rvf_remove_from_timer_list (T_RVF_TIMER_LIST_Q *p_timer_listq, T_RVF_TIMER_LIST_ENT  *p_tle);
T_RVF_TIMER_LIST_ENT*	rvf_get_expired_entry (T_RVF_TIMER_LIST_Q *p_timer_listq);


#line 324
UINT32	rvf_create_timer(	T_RVF_G_ADDR_ID			g_addrId,
									UINT32					timerDuration,
									BOOLEAN					isContinuous,
									void*					p_action);

void			rvf_del_timer	(	UINT32 tm_id) ;

void			rvf_reset_timer	(	UINT32 tm_id, UINT32 new_duration,
									BOOLEAN isContinuous);


 
void			rvf_enable(void);
void			rvf_disable(UINT8 who);

 
void rvf_dump_mem();
void rvf_dump_tasks();
void rvf_dump_pool();

 
void * rvf_wait_for_specific_msg(UINT16 msg_code, UINT8 mbox, UINT32 timeout);

 
#line 96 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/ms/src/bmi/mmiutilapi.h"
typedef struct mmimem_pcb_s
{
	unsigned int	magicWord;	
	void*			pStartAddr;
	unsigned int	poolSize;
	unsigned int	partSize;
	unsigned int	aviableNum;
	unsigned int	totalNum;
	unsigned int	idx;
	struct mmimem_pmHdr_s *pFree;
	struct mmimem_pmHdr_s *pAllocated;
} T_MMIMEM_PCB;

 

typedef struct mmimem_pmHdr_s
{
	struct mmimem_pmHdr_s *next;
	T_MMIMEM_PCB	*pPCB;

	unsigned int	inuse;


	unsigned int line;
	char caller[8];	

} T_MMIMEM_PMHDR;







typedef struct mmimem_dcb_s
{
	unsigned int	magicWord;	
	void*			pStartAddr;
	unsigned int	poolSize;
	struct mmimem_dmHdr_s *pAllocated;	
} T_MMIMEM_DCB;

 
typedef struct mmimem_dmHdr_s
{
	struct mmimem_dmHdr_s *next;
	T_MMIMEM_DCB	*pDCB;
	unsigned int	size;

	unsigned int	inuse;


	unsigned int line;
	char caller[8];	

} T_MMIMEM_DMHDR;

#line 210
typedef struct mmimem_info_s
{
	unsigned int	min_reqsz;		 
	unsigned int	max_reqsz;		 
	unsigned int	max_allocsz;	 
	unsigned char	max_allocpart[10];
	unsigned char	cur_allocpart[10];
	unsigned char	max_dyn_used;	 
	unsigned char	cur_dyn_used;
} T_MMIMEM_INFO;
#line 265
extern void MI_dbgPrintf(const char* const format, ...);

 
extern int MI_mmimem_Init(void);

 



extern int MI_mmimem_Alloc(void **buf, unsigned int size, char* name, int line);
#line 284
extern int MI_mmimem_Free(void *buf, char* name, int line);
#line 297
extern void MI_mmimem_Dump(void);




extern void MI_mmimem_Info(T_MMIMEM_INFO *pInfo);
#line 25 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/ms/src/pcsyn/inc/pcsyn.h"
extern T_HANDLE  pcsyn_hCommMMI;
extern T_HANDLE  pcsyn_hCommPCSYN;

typedef struct
{
	U8                        event_id;                  
	U8                        _align0;                   
	U8                        _align1;                   
	U8                        _align2;                   
	T_sdu                     sdu;                       
} 
T_HISR_PCSYN_IND;

typedef struct
{
	U8                        event_id;                  
	U8                        _align0;                   
	U8                        _align1;                   
	U8                        _align2;                   
	T_sdu                     sdu;                       
} 
T_MMI_PCSYN_IND;

typedef struct
{
	U8                        event_id;                  
	U8                        _align0;                   
	U8                        _align1;                   
	U8                        _align2;                   
	T_sdu                     sdu;                       
} 
T_PCSYN_MMI_IND;

 const void   psa_HISR_PCSYN_IND ( T_HISR_PCSYN_IND *hisr_pcsyn_ind);

 const void   mmi_pcsyn_ind ( T_MMI_PCSYN_IND *mmi_pcsyn_ind);



 






typedef struct
{
  char *version;
}
T_MONITOR;

#line 85
typedef struct
{
	U8 dummy;
}
T_MMI_PCSYN_DATAWAIT_IND;

typedef struct
{
	BYTE controlid; 
	BYTE cid1;	   
	BYTE cid2;	 
}T_PCSYN_MMI_STATUS_IND;

typedef struct
{
	void *info;
	BYTE stype;
	BYTE rptype;
}T_PCSYN_MMI_SENDMMS_IND;

 
void M_MMI_PCSYN_WAITDATA_IND(T_MMI_PCSYN_DATAWAIT_IND *parameter);

void P_PCSYN_MMI_STATUS_IND(T_PCSYN_MMI_STATUS_IND *parameter);
void P_PCSYN_MMI_SENDMMS_IND(T_PCSYN_MMI_SENDMMS_IND *parameter);

void   psa_PCSYN_MMI_IND (BYTE event_id,void* data, USHORT data_size);

 


typedef enum
{
	P_PCSYN_MMI_SATTUS_IND_ID,
	P_PCSYN_MMI_SENDMMS_IND_ID
};






extern void MI_dbgPrintf(const char* const format, ...);
#line 139
extern BYTE mem_buffer[];
extern int g_codepcsynmem ;
#line 35 "D:/work/M288S/ssa/system-mmi/../../condat/gsm/condat/ms/src/pcsyn/inc/pcsyn_protocol.h"
typedef enum
{
	iDL_HEADER 		=	-1,
	iDL_FRAMETYPE 	 ,
	iDL_FRAMEID,
	iDL_STATUS	,		
	iDL_FRAMEIDUL,  		
	iDL_DATASIZE  ,      
	iDL_DATA
};


typedef enum
{
	iUL_HEADER 		=	-1,
	iUL_FRAMETYPE ,
	iUL_FRAMEID,
	iUL_DATASIZE,
	iUL_DATA
};

 
typedef enum
{
	PC_FT_Monitor = 0x00, 
	PC_FT_Control = 0x40, 
	PC_FT_Info     = 0x80  
}PC_FrameType;

  
typedef enum
{
	PC_CF_Connect = 0x00,
	PC_CF_DisConnect,
	PC_CF_Cmd  = 0x11, 
	PC_CF_DataEnd
}PC_CFType;

 
typedef enum
{
	PC_IF_Data,
	PC_IF_DataAck
}PC_IFType;


 
typedef enum
{
	PC_NOCONNECT,
	PC_CONNECTED,
	PC_CMDRECV,
	PC_DATAUL,
	PC_DATADL,
	PC_DATAULEND,
	PC_WAITDISCONNECT
}PC_CNNT_STATUS;

 
#line 98
typedef enum
{
	PC_Error_NoError = 0x00,
	PC_Error_CheckSum, 
	PC_Error_InvalidPktSize = 0x03,
	PC_Error_InvalidDataSize ,
	PC_Error_NoConnect,
	PC_Error_ConnectExisted,
	PC_Error_InvalidFrameType,
	PC_Error_InvalidFrameid,
	PC_Error_FrameIsReRX = 0x20, 
	PC_Error_WaitData,
	PC_Error_SerialNoResponse=0x81,
	App_Error_DefaultError	 = 0x82,
	App_Error_ReadError	 = 0x83,
	App_Error_WriteError ,
	App_Error_DeleteError ,
	App_Error_CopyError ,
	App_Error_InfoError ,
	App_Error_SendError,  
	App_Error_StoreError, 
	PC_Error_MMINotAllow =  0x90,
	PC_Error_MMINeedPause,
	PC_Error_MemoryAlloc, 
	App_Error_ModifyError, 
}PC_Error;
	
typedef struct
{
	unsigned char stx;
	unsigned char etx;
	unsigned char dle;
	unsigned char header_ul;
	unsigned char header_dl;
	unsigned char frameid;
	unsigned char frametype;
	unsigned int status	;
							
}PC_Protocol;


typedef struct 
{
	unsigned char frametype;
	unsigned char frameid;
	unsigned char datasize;
	unsigned char data[128];
}PC_Packet_UL;


typedef struct 
{
	unsigned char frametype;
	unsigned char frameid;
	unsigned char status;
	unsigned char frametype_ul;
	unsigned char datasize;
	unsigned char data[128];
}PC_Packet_DL;

typedef struct
{
	unsigned int flag;
	unsigned char *pdata_cmd;
	unsigned int  size_cmd;
	unsigned char *pdata_ulbuff;
	unsigned int size_ulbuff;
	unsigned char *pdata_dlbuff;
	unsigned int size_dlbuff;

	unsigned int status;
}PC_Interface_Info;


 
#line 178
int handle_inbuffer(unsigned char *buff_in,unsigned short size_buff_in);
int pc_writebystatus(int status);

int pc_writebyinfo(unsigned int status);

unsigned int pc_interface(PC_Interface_Info * info);

extern unsigned long SER_tr_WriteNBytes (int serial_data_flow,
                                       unsigned char *buffer,
                                       unsigned long chars_to_write);

#line 62 "d:/work/m288s/ssa/system-mmi/../../condat/gsm/condat/ms/src/pcsyn/src/pcsyn.c"
int g_codepcsynmem  = 0;

unsigned char mem_buffer[64000];
#line 73
void pcsyn_RX_process(unsigned char *buffer,unsigned short size)
{
	if(size >= 3)
	{
		unsigned short l_buf =  8*size;
		T_HISR_PCSYN_IND*hisr_pcsyn_ind = (T_HISR_PCSYN_IND*)vsi_c_new_sdu(((ULONG)(sizeof(T_PRIM_HEADER)+sizeof(T_HISR_PCSYN_IND))),0x2c00 ,l_buf,((size_t)(&((T_HISR_PCSYN_IND *)0)->sdu)),0 );;
		hisr_pcsyn_ind->event_id = 0;
		hisr_pcsyn_ind->sdu.o_buf     = 0;
		hisr_pcsyn_ind->sdu.l_buf     = l_buf;
		memcpy(hisr_pcsyn_ind->sdu.buf,buffer,size);

		
        	PSENDX (PCSYN, hisr_pcsyn_ind);
	}
}

  

unsigned char pcsyn_id;
int pcsyn_init (void)
{
	static int pcsyninit   = 0;
	if(pcsyninit )return 1;
	
	rvt_register_id("L1",&pcsyn_id, pcsyn_RX_process) ;

	pcsyninit = 1;
  
  return 0;
}

