
/*
+-------------------------------------------------------------------+
| PROJECT: PC Synchronization                    
| $Workfile: pcsyn_application.c
| $Author: Talcon Hu
| CREATED: 18.05.2004                 
+-------------------------------------------------------------------+
*/
#define ENTITY_PCSYN
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif



#include "mfw_sys.h"
#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_sms.h"


#include "mfw_ffs.h"
#include "mfw_smsi.h"

#include "mmiutilapi.h"
//#include "mmibookshared.h"

#include "pconst.cdg"

#define PCSYN_COMPILE_FORAPP
#include "pcsyn.h"

#include "pcsyn_protocol.h"
#include "pcsyn_application.h"


typedef struct
{
	UBYTE status;
	PC_Interface_Info *info;
}T_PC_WaitData;
static T_PC_WaitData pc_waitdata = 
	{
		0,0
	};

PC_App_Cmd appcmd;

extern UINT8 g_pcsyncstatus ;
/**********************file operate*****************/

unsigned int pc_interface_file(PC_Interface_Info * info, PC_App_Cmd_File *cmd)
{
	static T_FFS_DIR ffs_dir;
	static T_FFS_SIZE ffs_size;
	static T_FFS_STAT state;

	static PC_FILEHead_info_dl * headinfo;
	static char filename[32];
	static char pathname[50];
	static char fullname[128];
	char * p;
	static int dlbuffsize;
	static int namelenth;
	T_FFS_RET re;
	char * pdest;
	int posi=0;
	

	switch(cmd->cid2)
	{
		case PC_AppCID2_Read:
		{
			T_FFS_STAT stat;
			if(ffs_stat((char*)cmd->file, &stat) != EFFS_OK)
				return App_Error_InfoError;
			info->flag = PC_IF_FLAGS_DATADL;
			info->size_dlbuff = ffs_fread((char*)cmd->file,
				(void*)info->pdata_dlbuff,
				(int)stat.size);
		}
			break;
		case PC_AppCID2_Write:
			if(info->flag == PC_IF_FLAGS_CMD)
				info->flag = PC_IF_FLAGS_DATAUL;
			else
			{
				memset(filename, '\0', sizeof(filename) );
				memset(pathname, '\0', sizeof(pathname) );
				pdest=strchr((char *)cmd->file, '/');
				while (pdest != NULL)
				{
					posi=pdest-(char *)(cmd->file);//ȡĿ¼
					pdest++;
					pdest=strchr(pdest, '/');
				};
				memcpy(pathname,(char *)cmd->file,posi);
				if (pathname[0]=='\0') pathname[0]='/';//ǸĿ¼ӦΪ'/'
				pdest=(char *)cmd->file+posi+1;
				memcpy(filename,pdest,strlen((char *)cmd->file)-posi-1);

//				MI_dbgPrintf("<<<<pathname=%s,filename=%s,cmdfile=%s>>>>",pathname,filename,cmd->file);
				
				if (ffs_opendir ((char*)pathname,&ffs_dir)==EFFS_NOTFOUND)
					ffs_mkdir((char*)pathname);
				info->size_ulbuff = ffs_fwrite(
					(char *)cmd->file,
					(void *)info->pdata_ulbuff,
					(int)info->size_ulbuff);
			}
			
			break;
		case PC_AppCID2_Delete :
			info->flag = PC_IF_FLAGS_DATADL;
			info->size_dlbuff = 0;

			memset(filename, '\0', sizeof(filename) );
			memset(pathname, '\0', sizeof(pathname) );
//			MI_dbgPrintf("<<<1cmdfile=%s>>>>",cmd->file);
			pdest=strchr((char *)cmd->file, '/');
			while (pdest != NULL)
			{
				posi=pdest-(char *)(cmd->file);//ȡĿ¼
				pdest++;
				pdest=strchr(pdest, '/');
			};
			memcpy(pathname,(char *)cmd->file,posi);
			if (pathname[0]=='\0') pathname[0]='/';//ǸĿ¼ӦΪ'/'
			pdest=(char *)cmd->file+posi+1;
			memcpy(filename,pdest,strlen((char *)cmd->file)-posi-1);

//			MI_dbgPrintf("<<<<pathname=%s,filename=%s,cmdfile=%s>>>>",pathname,filename,cmd->file);

			if (filename[0]!='\0')//ļ
			{
				if (strcmp((char *)pathname,"/")!=0 ) strcat(pathname,"/");
				ffs_remove((char *)strcat(pathname,filename));
			}	
			else
			{//Ŀ¼
				ffs_size = ffs_opendir ((char*)pathname,&ffs_dir);
				if (ffs_size <0)//ֵ=0ʾĿ¼
					return App_Error_DeleteError;//Ŀ¼򲻿
				
				while(ffs_readdir(&ffs_dir , filename , sizeof(filename))>0)
				{
					strcat(fullname,pathname);
					if (strcmp((char *)pathname,"/")!=0 ) strcat(fullname,"/");
					strcat(fullname,filename);
					re=ffs_stat((char*)fullname, &state);
					if(re!=EFFS_OK) 	continue;
					if ((state.type=OT_FILE)&&(state.flags!=OF_READONLY))
					{
//						MI_dbgPrintf("<<<<delfilename=%s>>>>",fullname);
						ffs_remove((char*)fullname);
					}
					memset(fullname, '\0', sizeof(fullname) );
				}
//				PCSYN_TRACE_EVENT(("<<<<deldirname=%s>>>>",pathname));
				re=ffs_remove((char*)pathname);
				if (re !=EFFS_OK) return App_Error_DeleteError;
//					PCSYN_TRACE_EVENT(("<<<<deldir failed=%d>>>>",re));
			}
			break;
		case PC_AppCID2_Info:
			ffs_size = ffs_opendir ((char*)cmd->file,&ffs_dir);
			info->flag = PC_IF_FLAGS_DATADL;
			if (ffs_size <0)
			{
				info->size_dlbuff=0;
				return App_Error_InfoError;//Ŀ¼򲻿
			}			
			headinfo=(PC_FILEHead_info_dl *)info->pdata_dlbuff;
			p=(char *)headinfo+sizeof(PC_FILEHead_info_dl);
			memset(filename, '\0', sizeof(filename) );
			memset(pathname, '\0', sizeof(pathname) );
			dlbuffsize=0;
			namelenth=0;
			while(ffs_readdir(&ffs_dir , filename , sizeof(filename) ) >0)
			{
				strcpy((char*)pathname,(char*)cmd->file);
				if (strcmp((char *)cmd->file,"/")!=0 ) strcat(pathname,"/");
				re=ffs_stat(strcat(pathname,filename), &state);
				if(re!=EFFS_OK) 	continue;
				
				memcpy(&(headinfo->stat),&state,sizeof(T_FFS_STAT));
				namelenth=strlen(filename);
				namelenth=(namelenth+3)&(~3);//ĸֽ
				headinfo->fnsize=namelenth;
				strcpy(p,filename);
				dlbuffsize=dlbuffsize+sizeof(PC_FILEHead_info_dl)+namelenth;
//				MI_dbgPrintf("<<<<2dlbuffsize=%d,fnsize=%d,filename=%s,namelenth=%d>>>>",dlbuffsize,strlen(filename),filename,namelenth);
				headinfo=(PC_FILEHead_info_dl *)(info->pdata_dlbuff+dlbuffsize);
				p=(char *)headinfo+sizeof(PC_FILEHead_info_dl);
				memset(filename, '\0', sizeof(filename) );
				memset(pathname, '\0', sizeof(pathname));
			}
			info->size_dlbuff = dlbuffsize;
			break;
		default:
			return App_Error_UnknownCID2;
	}
	return App_Error_NoError;
}

/******************************Phone Book********************************/

unsigned int delphonebook(DelRec *delphb_content,int count )
{
	int  i=0,k;
	static T_MFW_PHB_STATUS     status;
	T_MFW   ret;
	DelRec  *buffer = delphb_content;
	short  index;
	short  ctype;
	
	for(k=0;k<count;k++,buffer++)
	{
		ctype=buffer->ctype;
		switch(ctype)
		{
		case NVM_BOOK_SEL:
			index=buffer->index-1;//֤Ӽ¼0ʼ
			if (index>ALL_NVM_LIST) return App_Error_DeleteError;
			for( i=0;i<ALL_NVM_LIST;i++ )
			{
				if(CheckFlag(i))
				{
					if (l_phb_index[i].index==index)
					{
						l_phb_index[i].flag=SetDelFlag(i);
						if( (i/PHB_table_len)==CurrentTable)
						{
							T_EasyName smsdata;
							char smsnumber[22]="";
							memset(&smsdata,0,sizeof(T_EasyName));
							if( !l_phb_index[i].number[0] )
							{
								UnCompressNum((char *)FFS_PBData.NVMBook[i%PHB_table_len].number, (unsigned char *)smsnumber);
								memcpy(smsdata.number,smsnumber,PHB_number_len);
								ChangeSmsDataName(smsdata);
							}
							if( !l_phb_index[i].number[1] )
							{
								UnCompressNum((char *)FFS_PBData.NVMBook[i%PHB_table_len].office, (unsigned char *)smsnumber);
								memcpy(smsdata.number,smsnumber,PHB_number_len);
								ChangeSmsDataName(smsdata);
							}
							if( !l_phb_index[i].number[2] )
							{
								UnCompressNum((char *)FFS_PBData.NVMBook[i%PHB_table_len].home, (unsigned char *)smsnumber);
								memcpy(smsdata.number,smsnumber,PHB_number_len);
								ChangeSmsDataName(smsdata);
							}
						}
						else
						{
							T_EasyName smsdata;
							char smsnumber[22]="";
							memset(&smsdata,0,sizeof(T_EasyName));

							if( flash_PBread(PBTable[i/PHB_table_len])!=0 )
							    CurrentTable=i/PHB_table_len;
							if( !l_phb_index[i].number[0] )
							{
								UnCompressNum((char *)FFS_PBData.NVMBook[i%PHB_table_len].number, (unsigned char *)smsnumber);
								memcpy(smsdata.number,smsnumber,PHB_number_len);
								ChangeSmsDataName(smsdata);
							}
							if( !l_phb_index[i].number[1] )
							{
								UnCompressNum((char *)FFS_PBData.NVMBook[i%PHB_table_len].office, (unsigned char *)smsnumber);
								memcpy(smsdata.number,smsnumber,PHB_number_len);
								ChangeSmsDataName(smsdata);
							}
							if( !l_phb_index[i].number[2] )
							{
								UnCompressNum((char *)FFS_PBData.NVMBook[i%PHB_table_len].home, (unsigned char *)smsnumber);
								memcpy(smsdata.number,smsnumber,PHB_number_len);
								ChangeSmsDataName(smsdata);
							}
						}   
						FFS_PBData.NVMBook[i%PHB_table_len].info=l_phb_index[i].flag;
						flash_PBwrite(PBTable[CurrentTable]);  
						NVMTotal=NVMTotal-1;
						break;//ѭ
					}
				}		
			}	
			break;
		case SIM_BOOK_SEL:
			index=buffer->index;
			if (index>ALL_SIM_LIST) return App_Error_DeleteError;

			for( i=ALL_NVM_LIST;i<ALL_NUMBER_LIST;i++ )
			{
				if(CheckFlag(i))
				{
					if (l_phb_index[i].index==index)
					{
						l_phb_index[i].flag=SetDelFlag(i);
					 	ret=phb_delete_entry(PHB_ADN,l_phb_index[i].index,&status);
						if( ret != MFW_PHB_OK )
						{
							return App_Error_DeleteError;
						}
						else
						{
							 //update the smsdata
							T_EasyName smsdata;
							T_MFW_PHB_ENTRY smsentry;

							memset(&smsdata,0,sizeof(T_EasyName));
							memset(&smsentry,0,sizeof(T_MFW_PHB_ENTRY));
							ReadSIMRecord(i,&smsentry);
							memcpy(smsdata.number,smsentry.number,PHB_number_len);
							ChangeSmsDataName(smsdata);
						}	
						break;//ѭ
					}
				}	
			}
			break;
		default:
			return App_Error_IllegalCmdData;
		}
	}	
       GetSIMData();
	return App_Error_NoError;
}

	
unsigned int editPhonebook(PC_PHB_Content *PHB_content,BYTE type, BYTE index)
{
	PhbkDetailItem *buffer = &(PHB_content->phkitem);
	int  i;
	//PhbkDetailItem      l_phb_NVMentry;  
	static T_MFW_PHB_STATUS     status;
	T_MFW_PHB_ENTRY entry;
	short  cindex;
	short  ctype;

	
	//index=0, it means to insert a record into list,else to modify a record in list.     
	if(index==0) 
	{
		switch(type)
		{
		case NVM_BOOK_SEL:
			if (NVMTotal>=ALL_NVM_LIST) return App_Error_WriteError;
			for( i=0;i<ALL_NVM_LIST;i++ )
			{
				if(!CheckFlag(i))
				{
					l_phb_index[i].phonebook=NVM_BOOK_SEL;
					break;
				}		
			}	
			break;
		case SIM_BOOK_SEL:
			GetSIMData();
			status.book=PHB_ADN;
			if (phb_get_status(&status)!=MFW_PHB_OK) return App_Error_WriteError;
			if (SIMTotal>=status.max_entries) return App_Error_WriteError;
				
			for( i=ALL_NVM_LIST;i<ALL_NUMBER_LIST;i++ )
			{
				if(!CheckFlag(i))
				{
					l_phb_index[i].phonebook=SIM_BOOK_SEL;
					break;
				}		
			}	
 			break;
		default:
			return App_Error_IllegalCmdData;
		}
	}
	else
	{ 
		switch(type)
		{
		case NVM_BOOK_SEL:
//			index--;//Ϊindexl_phb_indexǴ0ʼ
			if (index>ALL_NVM_LIST) return App_Error_ModifyError;
			for( i=0;i<ALL_NVM_LIST;i++ )
			{
				if(CheckFlag(i))
				{
					if (l_phb_index[i].index==index-1) //ֻl_phb_index[i].indexǴ0ʼ
					{
//						PCSYN_TRACE_EVENT(("<<<<write NVM=%d>>>>",index));
						break;
					}	
				}
			}
			if (i>=ALL_NVM_LIST) return App_Error_ModifyError;//ûҵҪ޸ĵļ¼
			break;
		case SIM_BOOK_SEL:
			GetSIMData();
			//ֹsim绰Χ
			status.book=PHB_ADN;
			if (phb_get_status(&status)!=MFW_PHB_OK) return App_Error_ModifyError;
			if (index>status.max_entries) return App_Error_ModifyError;

			for( i=ALL_NVM_LIST;i<ALL_NUMBER_LIST;i++ )
			{
				if(CheckFlag(i))
				{
					if (l_phb_index[i].index==index) //siml_phb_index[i].indexǴ1ʼ
					{
						break;
					}	
				}
			}
			if (i>=ALL_NUMBER_LIST) return App_Error_ModifyError;//ûҵҪ޸ĵļ¼
			break;
		}	
	}   
        
 //Ϸصil_phb_indexе       
	switch(l_phb_index[i].phonebook)
	{
	case NVM_BOOK_SEL:
		memcpy(l_phb_index[i].name,buffer->name,PHB_name_len+3);  //һҪȫȸ  
		l_phb_index[i].number[0]=GetShortNumber((char *)buffer->number);
		l_phb_index[i].number[1]=GetShortNumber((char *)buffer->home);
		l_phb_index[i].number[2]=GetShortNumber((char *)buffer->office);
		l_phb_index[i].flag=buffer->info;
/*		l_phb_index[i].flag=SetAddFlag(i);//#define SetAddFlag(i)  ((l_phb_index[i].flag & 0x3F) | 0x40)
        	l_phb_index[i].flag|=0x0F;// set grouping=0x0f,it means no group;ʱһΪ0x4FSetGroupingFlag(i,j)ָ
		l_phb_index[i].flag=SetFirstNumFlag(i, 1);//õһΪײ,ʱһΪ0x5F
*/
		if( CurrentTable!=(i/PHB_table_len) )
		{
			if( flash_PBread(PBTable[i/PHB_table_len])!=0 )
			CurrentTable=i/PHB_table_len;
		}
		
		memcpy(FFS_PBData.NVMBook[i%PHB_table_len].name,buffer->name,PHB_name_len+3);//һҪȫȸ
		CompressNum((char *)buffer->number,FFS_PBData.NVMBook[i%PHB_table_len].number);
		CompressNum((char *)buffer->home,FFS_PBData.NVMBook[i%PHB_table_len].home);
		CompressNum((char *)buffer->office,FFS_PBData.NVMBook[i%PHB_table_len].office);
		memcpy(FFS_PBData.NVMBook[i%PHB_table_len].memo,buffer->memo,PHB_memo_len+3);                                   
		FFS_PBData.NVMBook[i%PHB_table_len].info=l_phb_index[i].flag;                                    
		
		flash_PBwrite(PBTable[CurrentTable]);
		if (index==0)//ֻ¼Ӽ¼
		{
                   	NVMTotal=NVMTotal+1;
			PHBKTotal=PHBKTotal+1;                                    
		}
		Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
		break;
	case SIM_BOOK_SEL:
              memset(&entry,0,sizeof(T_MFW_PHB_ENTRY));
              ReadSIMRecord(i,&entry);

		memcpy(entry.name.data, buffer->name, PHB_name_len);
		entry.name.len=PHB_name_len;
		//smsentry.name.len =wstrlen((char*)entries.name.data);
		memcpy(entry.number, buffer->number, PHB_number_len);
		
		
		if(phb_store_entry(PHB_ADN,&entry,&status)!=MFW_PHB_OK)
			return App_Error_ModifyError;
              GetSIMData();
		Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
                //GetSIMData() will do SetAddFlag, SIMTotal++, PHBKTotal++, Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST )
 		break;
	default:
		return App_Error_IllegalCmdData;
	}
		
	return App_Error_NoError;
}


unsigned int getPhoneBook(PC_PHB_Content *PHB_content, BYTE type, BYTE index)
{
	PhbkDetailItem *buffer = &(PHB_content->phkitem);
	PhbkDetailItem   l_phb_NVMEntry;    
	int i,j;  
        
	if(index>PHBKTotal) //indexǴ1ʼ˳
		return App_Error_InfoError;
	 //l_phb_indexǰ500NVM͵ģ256SIM͵
//	Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);

//ÿȫֲl_phb_indexеЧ绰¼
//õi  ǵindexЧ¼Ӧl_phb_indexеֵ
	for (i=0,j=0;i<ALL_NUMBER_LIST;i++)
	{
		if (CheckFlag(i))
		{
			j=j+1;     
			if (j==index) break;
		}
	}
//	PCSYN_TRACE_EVENT(("<<<<found index=%d>>>>",i));

	switch(l_phb_index[i].phonebook)
	{
	case NVM_BOOK_SEL:
		// memset((char *)l_phb_NVMentry.name,'\0',sizeof(PhbkDetailItem));
		if (ReadNVMRecord(l_phb_index[i].index,&l_phb_NVMEntry)==TRUE)	   
		{
			PHB_content->phonebook=NVM_BOOK_SEL;
			PHB_content->id=l_phb_index[i].index+1;//֤index1ʼ0Ϊ¼¼ı־
	        	memcpy(buffer, &l_phb_NVMEntry, sizeof(PhbkDetailItem));
		}
		else
			return App_Error_ReadError;	
		break;
	case SIM_BOOK_SEL:
		PHB_content->phonebook=SIM_BOOK_SEL;
		PHB_content->id=l_phb_index[i].index;
		memcpy((char *)buffer->name,(char *)l_phb_index[i].name,PHB_name_len+3);//PHB_name_len+3);
		UnCompressNum((char *)SimNumber[i-ALL_NVM_LIST],buffer->number);
		memset(buffer->office, '\0', sizeof(buffer->office) );
		memset(buffer->home, '\0', sizeof(buffer->home) );
		memset(buffer->memo, '\0', sizeof(buffer->memo) );
		buffer->info=l_phb_index[i].flag;//info has the phbitem group infomation
		break;
	default:
		return App_Error_ReadError;
	}

	return App_Error_NoError;
}

unsigned int pc_interface_PHB(PC_Interface_Info * info, PC_App_Cmd_PHB *cmd)
{
	static PC_PHB_Info_dl*  PHB_info_dl;  
	static T_MFW_PHB_STATUS     status;
	
	switch(cmd->cid2)
	{
	case PC_AppCID2_Read:
		info->flag = PC_IF_FLAGS_DATADL;
		info->size_dlbuff = sizeof(PC_PHB_Content);
		return getPhoneBook((PC_PHB_Content *)( info->pdata_dlbuff),cmd->type, cmd->index);
		break;
	case PC_AppCID2_Write:
		if(info->flag == PC_IF_FLAGS_CMD)
			info->flag = PC_IF_FLAGS_DATAUL;
		else
			return editPhonebook((PC_PHB_Content *)(info->pdata_ulbuff),cmd->type,cmd->index);
		break;
	case PC_AppCID2_Delete:
		if(info->flag == PC_IF_FLAGS_CMD)
			info->flag = PC_IF_FLAGS_DATAUL;
		else
			{
				if (info->size_ulbuff>0)
					return delphonebook((DelRec *)info->pdata_ulbuff,((int)info->size_ulbuff)/4);
			}
		break;
	case PC_AppCID2_Info://get phonebook info
		info->flag = PC_IF_FLAGS_DATADL;
		info->size_dlbuff = sizeof(PC_PHB_Info_dl);
		PHB_info_dl = (PC_PHB_Info_dl *)info->pdata_dlbuff;
		
              GetSIMData();
		PHBKTotal=NVMTotal+SIMTotal; 
		PHB_info_dl->NVMTotal = NVMTotal;
		PHB_info_dl->SIMTotal = SIMTotal;
		PHB_info_dl->MaxNVM= ALL_NVM_LIST;

		status.book=PHB_ADN;
		if (phb_get_status(&status)==MFW_PHB_OK)
			PHB_info_dl->MaxSIM=status.max_entries;
		else
			PHB_info_dl->MaxSIM=0;
		break;
	default:
		return App_Error_UnknownCID2;
	}
	return App_Error_NoError;
}
/******************************phone book end*********************************/

/******************************short message *********************************/
#if 0
unsigned int getShortMessage(PC_Interface_Info * info,BYTE type, BYTE index)
{
	PC_SMS_Content * SMS_content=(PC_SMS_Content *)info->pdata_dlbuff; 
	FlashSms *buffer = &(SMS_content->flashsmsitem);
       int i,count;
	T_FindName  searchPhdata;
	static T_MFW_SMS_MSG msg_list[MAX_MESSAGES];
	//static T_MFW_SMS_IDX msg_list[MAX_MESSAGES];

//	if(index>FlashSMStotal) 
//	   return App_Error_NoFound;

	   
	if (type==PCSYN_SMS_FLASH_MO||type==PCSYN_SMS_FLASH_MT)
	{
		if (type==PCSYN_SMS_FLASH_MO)//ҪpcsynͷMFW
			SortFlashSms(MFW_SMS_FLASH_MO,Flash_sms_messages);
		if (type==PCSYN_SMS_FLASH_MT)
			SortFlashSms(MFW_SMS_FLASH_MT,Flash_sms_messages);
		
		if( CurrentFlashSmsTable!=Flash_sms_sort_index[index-1].index/FlashSMS_table_len )
		{
			CurrentFlashSmsTable=Flash_sms_sort_index[index-1].index/FlashSMS_table_len;
			flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
		}
		i=Flash_sms_sort_index[index-1].index%FlashSMS_table_len;
		memcpy(buffer, &FFS_SMSData.NVMSMS[i], sizeof(FlashSms));
		switch (FFS_SMSData.NVMSMS[i].state)//pc˶ͺֻͿܲһ£Դpc˵ϢҪpc˿ʶ
		{
			case MFW_SMS_UNKNOWN:buffer->state=PCSYN_SMS_UNKNOWN;break;
			case MFW_SMS_UNREAD: buffer->state=PCSYN_SMS_UNREAD;break;       /* received unread message */
			case MFW_SMS_READ: buffer->state=PCSYN_SMS_READ;break;       /* received read message   */
			case MFW_SMS_STOR_UNSENT: buffer->state=PCSYN_SMS_STOR_UNSENT;break;  /* stored unsent messgae   */
			case MFW_SMS_STOR_SENT: buffer->state=PCSYN_SMS_STOR_SENT;break;    /* stored sent message     */
			case MFW_SMS_ALL: buffer->state=PCSYN_SMS_ALL;break;
			case MFW_SMS_NotVOICE: buffer->state=PCSYN_SMS_NotVOICE;break;
			case MFW_SMS_FLASH: buffer->state=PCSYN_SMS_FLASH;break;      /*FLASH SMS*/
			case MFW_SMS_FLASH_MO: buffer->state=PCSYN_SMS_FLASH_MO;break;  
			case MFW_SMS_FLASH_MT: buffer->state=PCSYN_SMS_FLASH_MT;break;  
			case MFW_SMS_MO: buffer->state=PCSYN_SMS_MO;break;           /* MO SMS message          */
			case MFW_SMS_MT: buffer->state=PCSYN_SMS_MT;break;           /* MT SMS message          */
			case MFW_SMS_INVALID: buffer->state=PCSYN_SMS_INVALID;break;/*SPR1830*/
			case MFW_SMS_VOICE: buffer->state=PCSYN_SMS_VOICE;break;        /* voice mail message */
		}
		if( FindNumber((char*)FFS_SMSData.NVMSMS[i].addr, (T_FindName *)&searchPhdata) )
			memcpy((char*)SMS_content->name,(char*)searchPhdata.name,13);
		else
			memcpy((char*)SMS_content->name,(char*)FFS_SMSData.NVMSMS[i].addr,12);
	}
	else	
		if(type==PCSYN_SMS_ALL)
		{	
			memset(msg_list,0,sizeof(msg_list));
			count=sms_message_list(MFW_SMS_ALL,msg_list, MAX_MESSAGES);
			//			count=sms_index_list(MFW_SMS_ALL,msg_list, MAX_MESSAGES);
			buffer->id=msg_list[index-1].index;
			if (msg_list[index-1].index==-1) return App_Error_ReadError;
			memcpy((char*)buffer->addr,(char*)msg_list[index-1].addr.number,MFW_NUM_LEN);
			memcpy(&buffer->time,&msg_list[index-1].rctp, sizeof(T_MFW_SMS_SCTP));
			memset(buffer->sms_msg,0,MAX_MSG_LEN);
			switch (msg_list[index-1].stat)
			{
				case MFW_SMS_UNKNOWN:buffer->state=PCSYN_SMS_UNKNOWN;break;
				case MFW_SMS_UNREAD: buffer->state=PCSYN_SMS_UNREAD;break;       /* received unread message */
				case MFW_SMS_READ: buffer->state=PCSYN_SMS_READ;break;       /* received read message   */
				case MFW_SMS_STOR_UNSENT: buffer->state=PCSYN_SMS_STOR_UNSENT;break;  /* stored unsent messgae   */
				case MFW_SMS_STOR_SENT: buffer->state=PCSYN_SMS_STOR_SENT;break;    /* stored sent message     */
				case MFW_SMS_ALL: buffer->state=PCSYN_SMS_ALL;break;
				case MFW_SMS_NotVOICE: buffer->state=PCSYN_SMS_NotVOICE;break;
				case MFW_SMS_FLASH: buffer->state=PCSYN_SMS_FLASH;break;      /*FLASH SMS*/
				case MFW_SMS_FLASH_MO: buffer->state=PCSYN_SMS_FLASH_MO;break;  
				case MFW_SMS_FLASH_MT: buffer->state=PCSYN_SMS_FLASH_MT;break;  
				case MFW_SMS_MO: buffer->state=PCSYN_SMS_MO;break;           /* MO SMS message          */
				case MFW_SMS_MT: buffer->state=PCSYN_SMS_MT;break;           /* MT SMS message          */
				case MFW_SMS_INVALID: buffer->state=PCSYN_SMS_INVALID;break;/*SPR1830*/
				case MFW_SMS_VOICE: buffer->state=PCSYN_SMS_VOICE;break;        /* voice mail message */
			}
			buffer->flag=TRUE;
			if( FindNumber((char*)msg_list[index-1].addr.number, (T_FindName *)&searchPhdata) )
				memcpy((char*)SMS_content->name,(char*)searchPhdata.name,13);
			else
				memcpy((char*)SMS_content->name,(char*)msg_list[index-1].addr.number,12);

			g_pcsyncstatus = 1;
			if( sms_read(MFW_SMS_MESSAGE, msg_list[index-1].index)!=MFW_SMS_OK )
			{
				g_pcsyncstatus  =0;
				return App_Error_ReadError;//Ϣ
			}
/*			switch( sAT_PlusCMGR(CMD_SRC_LCL, msg_list[index-1].index, SMS_READ_Preview))
			{
				case AT_EXCT :
					break;
				case AT_CMPL:
					break;
				case AT_FAIL:
					return 0x81;
					break;
				case AT_BUSY:
					return 0x82;
					break;
			}*/
			info->status = PC_Error_WaitData; 
			pc_waitdata.info = info; 
			pc_waitdata.status=1;
//			PCSYN_TRACE_EVENT(("<<<<smstype=sim,count=%d,index :%d,%08x>>>>",count,msg_list[index-1].index,buffer));
			return PC_Error_WaitData;//ֵΪȴ첽
		}
		else 
			return App_Error_InfoError;
		
		
	return App_Error_NoError;
}
#else
unsigned int getShortMessage(PC_Interface_Info * info,BYTE type, BYTE index)
{
	PC_SMS_Content * SMS_content=(PC_SMS_Content *)info->pdata_dlbuff; 
       int i,count;
	T_FindName  searchPhdata;
	static T_MFW_SMS_MSG msg_list[MAX_MESSAGES];
	//static T_MFW_SMS_IDX msg_list[MAX_MESSAGES];

//	if(index>FlashSMStotal) 
//	   return App_Error_NoFound;

	   
	if (type==PCSYN_SMS_FLASH_MO||type==PCSYN_SMS_FLASH_MT)
	{
		if (type==PCSYN_SMS_FLASH_MO)//ҪpcsynͷMFW
			SortFlashSms(MFW_SMS_FLASH_MO,Flash_sms_messages);
		if (type==PCSYN_SMS_FLASH_MT)
			SortFlashSms(MFW_SMS_FLASH_MT,Flash_sms_messages);
		
		if( CurrentFlashSmsTable!=Flash_sms_sort_index[index-1].index/FlashSMS_table_len )
		{
			CurrentFlashSmsTable=Flash_sms_sort_index[index-1].index/FlashSMS_table_len;
			flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
		}
		i=Flash_sms_sort_index[index-1].index%FlashSMS_table_len;
		SMS_content->id=FFS_SMSData.NVMSMS[i].id;
		memcpy((char *)SMS_content->addr,(char *)FFS_SMSData.NVMSMS[i].addr,40);
		memcpy(&SMS_content->time, &FFS_SMSData.NVMSMS[i].time, sizeof(T_MFW_SMS_SCTP));
		switch (FFS_SMSData.NVMSMS[i].state)//pc˶ͺֻͿܲһ£Դpc˵ϢҪpc˿ʶ
		{
			case MFW_SMS_UNKNOWN:SMS_content->state=PCSYN_SMS_UNKNOWN;break;
			case MFW_SMS_UNREAD:SMS_content->state=PCSYN_SMS_UNREAD;break;       /* received unread message */
			case MFW_SMS_READ: SMS_content->state=PCSYN_SMS_READ;break;       /* received read message   */
			case MFW_SMS_STOR_UNSENT: SMS_content->state=PCSYN_SMS_STOR_UNSENT;break;  /* stored unsent messgae   */
			case MFW_SMS_STOR_SENT: SMS_content->state=PCSYN_SMS_STOR_SENT;break;    /* stored sent message     */
			case MFW_SMS_ALL: SMS_content->state=PCSYN_SMS_ALL;break;
			case MFW_SMS_NotVOICE: SMS_content->state=PCSYN_SMS_NotVOICE;break;
			case MFW_SMS_FLASH: SMS_content->state=PCSYN_SMS_FLASH;break;      /*FLASH SMS*/
			case MFW_SMS_FLASH_MO: SMS_content->state=PCSYN_SMS_FLASH_MO;break;  
			case MFW_SMS_FLASH_MT: SMS_content->state=PCSYN_SMS_FLASH_MT;break;  
			case MFW_SMS_MO: SMS_content->state=PCSYN_SMS_MO;break;           /* MO SMS message          */
			case MFW_SMS_MT: SMS_content->state=PCSYN_SMS_MT;break;           /* MT SMS message          */
			case MFW_SMS_INVALID: SMS_content->state=PCSYN_SMS_INVALID;break;/*SPR1830*/
			case MFW_SMS_VOICE: SMS_content->state=PCSYN_SMS_VOICE;break;        /* voice mail message */
		}
		if( FindNumber((char*)FFS_SMSData.NVMSMS[i].addr, (T_FindName *)&searchPhdata) )
			memcpy((char*)SMS_content->name,(char*)searchPhdata.name,13);
		else
			memcpy((char*)SMS_content->name,(char*)FFS_SMSData.NVMSMS[i].addr,12);
		SMS_content->flag=FFS_SMSData.NVMSMS[i].flag;
		SMS_content->dcs=FFS_SMSData.NVMSMS[i].dcs;
		SMS_content->msg_len=FFS_SMSData.NVMSMS[i].msg_len;
		memcpy((char*)SMS_content->sms_msg,(char*)FFS_SMSData.NVMSMS[i].sms_msg,SMS_content->msg_len);
		info->size_dlbuff=sizeof(PC_SMS_Content)-1+SMS_content->msg_len;
	}
	else
	{
		if(type==PCSYN_SMS_ALL)
		{	
			memset(msg_list,0,sizeof(msg_list));
			count=sms_message_list(MFW_SMS_ALL,msg_list, MAX_MESSAGES);
			//			count=sms_index_list(MFW_SMS_ALL,msg_list, MAX_MESSAGES);
			SMS_content->id=msg_list[index-1].index;
			if (msg_list[index-1].index==-1) return App_Error_ReadError;
			memcpy((char*)SMS_content->addr,(char*)msg_list[index-1].addr.number,40);
			memcpy(&SMS_content->time,&msg_list[index-1].rctp, sizeof(T_MFW_SMS_SCTP));
			//memset(SMS_content->sms_msg,0,SMS_content->msg_len);
			switch (msg_list[index-1].stat)
			{
				case MFW_SMS_UNKNOWN:SMS_content->state=PCSYN_SMS_UNKNOWN;break;
				case MFW_SMS_UNREAD:SMS_content->state=PCSYN_SMS_UNREAD;break;       /* received unread message */
				case MFW_SMS_READ: SMS_content->state=PCSYN_SMS_READ;break;       /* received read message   */
				case MFW_SMS_STOR_UNSENT: SMS_content->state=PCSYN_SMS_STOR_UNSENT;break;  /* stored unsent messgae   */
				case MFW_SMS_STOR_SENT: SMS_content->state=PCSYN_SMS_STOR_SENT;break;    /* stored sent message     */
				case MFW_SMS_ALL: SMS_content->state=PCSYN_SMS_ALL;break;
				case MFW_SMS_NotVOICE: SMS_content->state=PCSYN_SMS_NotVOICE;break;
				case MFW_SMS_FLASH: SMS_content->state=PCSYN_SMS_FLASH;break;      /*FLASH SMS*/
				case MFW_SMS_FLASH_MO: SMS_content->state=PCSYN_SMS_FLASH_MO;break;  
				case MFW_SMS_FLASH_MT: SMS_content->state=PCSYN_SMS_FLASH_MT;break;  
				case MFW_SMS_MO: SMS_content->state=PCSYN_SMS_MO;break;           /* MO SMS message          */
				case MFW_SMS_MT: SMS_content->state=PCSYN_SMS_MT;break;           /* MT SMS message          */
				case MFW_SMS_INVALID: SMS_content->state=PCSYN_SMS_INVALID;break;/*SPR1830*/
				case MFW_SMS_VOICE: SMS_content->state=PCSYN_SMS_VOICE;break;        /* voice mail message */
			}
			SMS_content->flag=TRUE;
			if( FindNumber((char*)msg_list[index-1].addr.number, (T_FindName *)&searchPhdata) )
				memcpy((char*)SMS_content->name,(char*)searchPhdata.name,13);
			else
				memcpy((char*)SMS_content->name,(char*)msg_list[index-1].addr.number,12);

			g_pcsyncstatus = 1;
			if( sms_read(MFW_SMS_MESSAGE, msg_list[index-1].index)!=MFW_SMS_OK )
			{
				g_pcsyncstatus  =0;
				return App_Error_ReadError;//Ϣ
			}
			info->status = PC_Error_WaitData; 
			pc_waitdata.info = info; 
			pc_waitdata.status=1;
//			PCSYN_TRACE_EVENT(("<<<<smstype=sim,count=%d,index :%d,%08x>>>>",count,msg_list[index-1].index,buffer));
			return PC_Error_WaitData;//ֵΪȴ첽
		}
		else 
			return App_Error_InfoError;
	}	
		
	return App_Error_NoError;
}

#endif


#if 0
void Waitdata_getsms(void * p, BYTE ctype,U8 para)
{
	static T_MFW_SMS_MT *mt;
	static T_MFW_SMS_MO *mo;
		
	PC_SMS_Content * SMS_content;
	FlashSms *buffer;
	
	if(pc_waitdata.status == 0)
		return;
	
	pc_waitdata.status = 0;
	if(pc_waitdata.info == 0)
		return;
	if(pc_waitdata.info->status != PC_Error_WaitData)
		return;
	//fill info by parameter
	if (p NEQ NULL)
	{
		SMS_content=(PC_SMS_Content *)(pc_waitdata.info->pdata_dlbuff); 
		buffer= &(SMS_content->flashsmsitem);
		switch(ctype)
		{
			case MFW_SMS_MT:
				mt=(T_MFW_SMS_MT *)p; 
				buffer->msg_len=mt->msg_len;
				memcpy((char*)buffer->sms_msg,(char*)mt->sms_msg,mt->msg_len);
				buffer->dcs=mt->dcs;
				break;
			case MFW_SMS_MO:
				mo=(T_MFW_SMS_MO *)p; 
				buffer->msg_len=mo->msg_len;
				memcpy((char*)buffer->sms_msg,(char*)mo->sms_msg,mo->msg_len);
				buffer->dcs=mo->dcs;
				break;
		}
	} 
		

	//PCSYN_TRACE_EVENT(("<<<<callback size=%d ,%08x>>>>",buffer->msg_len,buffer));
	//PCSYN_TRACE_EVENT(("<<<<g_pcsyncstatus=%d>>>>",g_pcsyncstatus));	
	pc_waitdata.info  =0;
	{
		T_MMI_PCSYN_DATAWAIT_IND parameter;
//zkc add	07/22/04
		switch(para)
		{
			case MFW_SMS_OK:
				parameter.dummy=PC_Error_NoError;
				PCSYN_TRACE_EVENT(("<<<<get sms ok callback >>>>"));
				break;
			case CMD_SMS_READ:             /* read message */
				parameter.dummy=App_Error_ReadError;
				PCSYN_TRACE_EVENT(("<<<<get sms fail callback >>>>"));
				break;
			default:
				parameter.dummy=App_Error_DefaultError;
				PCSYN_TRACE_EVENT(("<<<<get sms default fail callback=%d>>>>",para));
		}
		M_MMI_PCSYN_WAITDATA_IND(&parameter);

	}
	g_pcsyncstatus  =0;
}
#else
void Waitdata_getsms(void * p, BYTE ctype,U8 para)
{
	static T_MFW_SMS_MT *mt;
	static T_MFW_SMS_MO *mo;

	PC_SMS_Content * SMS_content;
//	FlashSms *buffer;
	
	if(pc_waitdata.status == 0)
		return;
	
	pc_waitdata.status = 0;
	if(pc_waitdata.info == 0)
		return;
	if(pc_waitdata.info->status != PC_Error_WaitData)
		return;
	//fill info by parameter
	if (p NEQ NULL)
	{
		SMS_content=(PC_SMS_Content *)(pc_waitdata.info->pdata_dlbuff); 
		//buffer= &(SMS_content->flashsmsitem);
		switch(ctype)
		{
			case MFW_SMS_MT:
				mt=(T_MFW_SMS_MT *)p; 
				SMS_content->msg_len=mt->msg_len;
				memcpy((char*)SMS_content->sms_msg,(char*)mt->sms_msg,mt->msg_len);
				SMS_content->dcs=mt->dcs;
				break;
			case MFW_SMS_MO:
				mo=(T_MFW_SMS_MO *)p; 
				SMS_content->msg_len=mo->msg_len;
				memcpy((char*)SMS_content->sms_msg,(char*)mo->sms_msg,mo->msg_len);
				SMS_content->dcs=mo->dcs;
				break;
		}
		pc_waitdata.info->size_dlbuff=sizeof(PC_SMS_Content)-1+SMS_content->msg_len;
	} 
		

	//PCSYN_TRACE_EVENT(("<<<<callback size=%d ,%08x>>>>",buffer->msg_len,buffer));
	//PCSYN_TRACE_EVENT(("<<<<g_pcsyncstatus=%d>>>>",g_pcsyncstatus));	
	pc_waitdata.info  =0;
	{
		T_MMI_PCSYN_DATAWAIT_IND parameter;
//zkc add	07/22/04
		switch(para)
		{
			case MFW_SMS_OK:
				parameter.dummy=PC_Error_NoError;
				PCSYN_TRACE_EVENT(("<<<<get sms ok callback >>>>"));
				break;
			case CMD_SMS_READ:             /* read message */
				parameter.dummy=App_Error_ReadError;
				PCSYN_TRACE_EVENT(("<<<<get sms fail callback >>>>"));
				break;
			default:
				parameter.dummy=App_Error_DefaultError;
				PCSYN_TRACE_EVENT(("<<<<get sms default fail callback=%d>>>>",para));
		}
		M_MMI_PCSYN_WAITDATA_IND(&parameter);

	}
	g_pcsyncstatus  =0;
}
#endif

unsigned int delshortmessage(PC_Interface_Info * info,BYTE ctype, BYTE index)
{
	switch(ctype)
	{
		case PCSYN_SMS_FLASH://delete sms in flash
			if(index>FlashSMStotal) 
				return App_Error_DeleteError;
			Fresh_Del_TableId(index);
			FlashSMStotal--;
			break;
		case PCSYN_SMS_ALL://delete sms in sms
//				MI_dbgPrintf("<<<<DelSIMSMS index=:%d>>>>",delsms_content->index);
			//Ҫ	
			if (sms_exists(index) NEQ MFW_SMS_OK)
				return App_Error_DeleteError;
			g_pcsyncstatus = 1;
			sms_msg_delete(index);
			info->status = PC_Error_WaitData; 
			pc_waitdata.info = info; 
			pc_waitdata.status=1;
			return PC_Error_WaitData;//ֵΪȴ첽

			break;
		default:
			return App_Error_DeleteError;
	}
	return App_Error_NoError;
}


void Waitdata_delsms(U8 para)
{
	if(pc_waitdata.status == 0)
		return;
	
	pc_waitdata.status = 0;
	if(pc_waitdata.info == 0)
		return;
	if(pc_waitdata.info->status != PC_Error_WaitData)
		return;
	//fill info by parameter
	
//	PCSYN_TRACE_EVENT(("<<<<delsms callback >>>>"));
	pc_waitdata.info  =0;
	{
//zkc add    07/22/04
		T_MMI_PCSYN_DATAWAIT_IND parameter;
		switch(para)
		{
			case MFW_SMS_OK:
				parameter.dummy=PC_Error_NoError;
				PCSYN_TRACE_EVENT(("<<<<delete sms ok callback >>>>"));
				break;
			case CMD_SMS_DELETE:		/* delete message */
				parameter.dummy=App_Error_DeleteError;
				PCSYN_TRACE_EVENT(("<<<<delete sms fail callback >>>>"));
				break;
			default:
				parameter.dummy=App_Error_DefaultError;
				PCSYN_TRACE_EVENT(("<<<<delete sms default fail callback=%d>>>>",para));
		}
		M_MMI_PCSYN_WAITDATA_IND(&parameter);

	}
	g_pcsyncstatus  =0;
}

void Waitdata_sms(U8 para)
{
	if(pc_waitdata.status == 0)
		return;
	
	pc_waitdata.status = 0;
	if(pc_waitdata.info == 0)
		return;
	if(pc_waitdata.info->status != PC_Error_WaitData)
		return;
	//fill info by parameter
	
	pc_waitdata.info  =0;
	{
//zkc add    07/22/04
		T_MMI_PCSYN_DATAWAIT_IND parameter;
		switch(para)
		{
			case MFW_SMS_OK:
				parameter.dummy=PC_Error_NoError;
				PCSYN_TRACE_EVENT(("<<<<delete sms ok callback >>>>"));
				break;
			default:
				parameter.dummy=App_Error_DefaultError;
				PCSYN_TRACE_EVENT(("<<<<dafault sms fail callback=%d>>>>",para));
		}
		M_MMI_PCSYN_WAITDATA_IND(&parameter);

	}
	g_pcsyncstatus  =0;
}

unsigned int CopyShortMessage(PC_Interface_Info * info,BYTE ctype, BYTE cindex)
{
//ctypeָͬʱɾ¼
	PC_SMS_Content * SMS_content=(PC_SMS_Content *)info->pdata_ulbuff; 
//	FlashSms *buffer = &(SMS_content->flashsmsitem);


	int j,index;
	FlashSms * tmp;//flashsmsϢ
	T_MMI_FLASH_SMS_INDEX * tmp_index;
	T_MFW_SMS_IDX smsmsg_info;//simsmsϢ

//	PCSYN_TRACE_EVENT(("<<<<service center:%s>>>>",sms_parameter.sc_addr));
//	PCSYN_TRACE_EVENT(("<<<<add1=%s,Send add=:%s,SendMsg=:%s,len=%d>>>>",buffer->addr,NumberBuffer,TextBuffer,buffer->msg_len));

	if (sms_exists(cindex) NEQ MFW_SMS_OK)
			return App_Error_CopyError;


	j=Find_avail();//	find available flash sms table location,һյļ¼ԴҪĶ
	index=j+CurrentFlashSmsTable*FlashSMS_table_len;
	tmp=&FFS_SMSData.NVMSMS[j];//tmpдŵFFS_SMSDataڴдݵָ
	tmp_index=&Flash_sms_messages[index];//tmpдŵFlash_sms_messagesڴдݵָ

	if( FlashSMStotal < FLSAH_SMS_NUM )
	{
		g_pcsyncstatus  =1;
		if ((SMS_content->state==PCSYN_SMS_STOR_UNSENT) ||(SMS_content->state==PCSYN_SMS_STOR_SENT) )
		{
			FlashSMStotal++;
			sms_copy_idx(cindex, &smsmsg_info);//ҪƵsim¼Ϣ
			tmp->id=FlashSMStotal;//ƵĶϢŵflashlistĩβ
			memcpy((char *)tmp->addr,
			       (char *)SMS_content->addr,MFW_NUM_LEN);
			if (SMS_content->dcs!=0x00)
			{//unicode룬Ҫ0x80
				memcpy((char *)tmp->sms_msg, &SMS_content->sms_msg[1],SMS_content->msg_len-1);
				tmp->msg_len=SMS_content->msg_len-1;
			}
			else
			{
				memcpy((char *)tmp->sms_msg,
				       (char *)SMS_content->sms_msg,SMS_content->msg_len);
				tmp->msg_len=SMS_content->msg_len;
			}	
			if( smsmsg_info.stat == MFW_SMS_STOR_UNSENT )
			{
				tmp->state=MFW_SMS_STOR_UNSENT;
				Flash_sms_messages[index].state=MFW_SMS_STOR_UNSENT;
			}
			else// if(msg_info.stat == PCSYN_SMS_STOR_UNSENT)
			{
//				PCSYN_TRACE_EVENT(("<<<<copy stat=%d,msg_type=%d,unsent=%d>>>>",smsmsg_info.stat,smsmsg_info.msg_type,MFW_SMS_STOR_UNSENT));
				tmp->state=MFW_SMS_STOR_SENT;
				Flash_sms_messages[index].state=MFW_SMS_STOR_SENT;
			}
			tmp->dcs=SMS_content->dcs;
			tmp->flag=TRUE;
			Flash_sms_messages[index].index=index;
			Flash_sms_messages[index].id=FlashSMStotal;
			memcpy((char *)Flash_sms_messages[index].addr,
			       (char *)SMS_content->addr,MFW_NUM_LEN);
			Flash_sms_messages[index].flag=TRUE;
			flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);       
		}
		else if(SMS_content->state==PCSYN_SMS_MT)
		{
			FlashSMStotal++;
			tmp->id=FlashSMStotal;
			memcpy((char *)tmp->addr,
			       (char *)SMS_content->addr,MFW_NUM_LEN);
			memcpy(&tmp->time, 
			       &SMS_content->time, sizeof(T_MFW_SMS_SCTP));
			if (SMS_content->dcs!=0x00)
			{//unicode룬Ҫ0x80
				memcpy((char *)tmp->sms_msg, &SMS_content->sms_msg[1],SMS_content->msg_len-1);
				tmp->msg_len=SMS_content->msg_len-1;
			}
			else
			{
				memcpy((char *)tmp->sms_msg,
				       (char *)SMS_content->sms_msg,SMS_content->msg_len);
				tmp->msg_len=SMS_content->msg_len;
			}	
			tmp->state=MFW_SMS_MT;
			tmp->dcs=SMS_content->dcs;
			tmp->flag=TRUE;
			memcpy(&tmp_index->time, 
			       &SMS_content->time, sizeof(T_MFW_SMS_SCTP));//ռʱϢû
			tmp_index->index=index;
			tmp_index->id=FlashSMStotal;
			tmp_index->state=MFW_SMS_MT;
			memcpy((char *)tmp_index->addr,(char *)SMS_content->addr,MFW_NUM_LEN);
			tmp_index->flag=TRUE;
			flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);        
		}
		g_pcsyncstatus  =0;

		if (ctype==1) //ʾҪɾsimеļ¼
		{
//			PCSYN_TRACE_EVENT(("<<<<Copy finished,del=%d>>>>",ctype));
			g_pcsyncstatus = 1;
			sms_msg_delete(cindex);
			info->status = PC_Error_WaitData; 
			pc_waitdata.info = info; 
			pc_waitdata.status=1;
			return PC_Error_WaitData;//ֵΪȴ첽
		}
	}
	else
	{
//		PCSYN_TRACE_EVENT(("<<<<sms full>>>>"));
		return App_Error_CopyError;
	}
	return App_Error_NoError;
}


unsigned int SendShortMessage(PC_Interface_Info * info, BYTE stype,BYTE rptype)
{
	PC_SMS_Content * SMS_content=(PC_SMS_Content *)info->pdata_ulbuff; 
//	FlashSms *buffer = &(SMS_content->flashsmsitem);
	USHORT outLen;
	T_MFW submit_status;   /* Result of SMS send operation. */
	
	static T_MFW_SMS_MSG msg_list[MAX_MESSAGES];
	static T_MFW_SMS_INFO  sms_parameter;
	static char NumberBuffer[NUMBER_LENGTH];  
	static char TextBuffer[MAX_MSG_LEN_ARRAY];
	static UBYTE* msgBuffer;   //Pointer to data buffer 
	T_MFW_SMS_MO_TYPE sendtype;
	
	memset(&NumberBuffer,0,sizeof(NumberBuffer));
	memset(&TextBuffer,0,sizeof(TextBuffer));
	strcpy(NumberBuffer,SMS_content->addr);
	memcpy(TextBuffer,SMS_content->sms_msg,SMS_content->msg_len);
	msgBuffer = mmi_Sys_Sim(TextBuffer, &outLen,&(sms_parameter.dcs));
	
	SmsSend_set_dcs_number (&sms_parameter);
//	SmsSend_get_config_data(&sms_parameter);
//	MI_dbgPrintf("<<<<service center:%s>>>>",sms_parameter.sc_addr);
//	PCSYN_TRACE_EVENT(("<<<<add1=%s,Send add=:%s,len=%d>>>>",buffer->addr,NumberBuffer,buffer->msg_len));

	g_pcsyncstatus = 1;

#define SMSDEBUG
#ifdef	SMSDEBUG
       switch (stype)
       {
	case PC_SMS_status_SendSMS:
		if (rptype==0)//ʾҪ
			sendtype=MFW_SMS_REPLY;
		else
			sendtype=MFW_SMS_SUBMIT;
		submit_status = sms_submit( sendtype,                  /* type of the message*/
                                    (char *)NumberBuffer,        /* dest. address      */
                                    msgBuffer,                            /* sms message        */
                                    outLen,          /* lenght of message  */
                                    (char *)sms_parameter.sc_addr);/* sevice center num. */
		break;
	case PC_SMS_status_SaveSendSMS:		
		if( memory.used == memory.total && memory.total !=0 )
			return App_Error_StoreError;
		/*if (rptype==0)
			sendtype=MFW_SMS_REPLY_SENT;
		else*/
			sendtype=MFW_SMS_SUBMIT_SENT;
 		submit_status=sms_store( sendtype, (char *)NumberBuffer, msgBuffer, outLen, NULL);
		break;
 	case PC_SMS_status_SaveSMS:		
		if( memory.used == memory.total && memory.total !=0 )
			return App_Error_StoreError;
		/*if (rptype==0)
			sendtype=MFW_SMS_REPLY;
		else*/
			sendtype=MFW_SMS_SUBMIT;
		submit_status=sms_store( sendtype, (char *)NumberBuffer, msgBuffer, outLen, NULL);
		
		break;
	 }
   
	info->status = PC_Error_WaitData; 
	pc_waitdata.info = info; 
	pc_waitdata.status=1;
	return PC_Error_WaitData;//ֵΪȴ첽
#else
	return App_Error_NoError;
#endif
}	


void Waitdata_sendsms(U8 para)
{
	if(pc_waitdata.status == 0)
		return;
	
	pc_waitdata.status = 0;
	if(pc_waitdata.info == 0)
		return;
	if(pc_waitdata.info->status != PC_Error_WaitData)
		return;
	//fill info by parameter
	
	pc_waitdata.info  =0;
	{
	//zkc add 07/22/04
		T_MMI_PCSYN_DATAWAIT_IND parameter;
		switch(para)
		{
			case MFW_SMS_OK:
				parameter.dummy=PC_Error_NoError;
				PCSYN_TRACE_EVENT(("<<<<send sms ok callback >>>>"));
				break;
			case CMD_SMS_SUBMIT:           /* send message */
				parameter.dummy=App_Error_SendError;
				PCSYN_TRACE_EVENT(("<<<<Send sms fail callback >>>>"));
				break;
			case CMD_SMS_READ:             /* read message */
				parameter.dummy=App_Error_ReadError;
				break;
			case CMD_SMS_STORE:            /* save message */
				parameter.dummy=App_Error_StoreError;
				break;
			case CMD_SMS_DELETE:		/* delete message */
				parameter.dummy=App_Error_DeleteError;
				break;
			default:
				parameter.dummy=App_Error_DefaultError;
				PCSYN_TRACE_EVENT(("<<<<send sms default fail callback=%d>>>>",para));
		}

		M_MMI_PCSYN_WAITDATA_IND(&parameter);

	}
	//
	g_pcsyncstatus  =0;
}

void Waitdata_storesms(U8 para)
{
	if(pc_waitdata.status == 0)
		return;
	
	pc_waitdata.status = 0;
	if(pc_waitdata.info == 0)
		return;
	if(pc_waitdata.info->status != PC_Error_WaitData)
		return;
	//fill info by parameter
	
	pc_waitdata.info  =0;
	{
	//zkc add 07/22/04
		T_MMI_PCSYN_DATAWAIT_IND parameter;
		switch(para)
		{
			case MFW_SMS_OK:
				parameter.dummy=PC_Error_NoError;
				PCSYN_TRACE_EVENT(("<<<<store sms ok callback >>>>"));
				break;
			case CMD_SMS_STORE:            /* save message */
				parameter.dummy=App_Error_StoreError;
				PCSYN_TRACE_EVENT(("<<<<store sms fail callback >>>>"));
				break;
			default:
				parameter.dummy=App_Error_DefaultError;
				PCSYN_TRACE_EVENT(("<<<<store sms default fail callback=%d>>>>",para));
		}

		M_MMI_PCSYN_WAITDATA_IND(&parameter);

	}
	//
	g_pcsyncstatus  =0;
}


unsigned int pc_interface_SMS(PC_Interface_Info * info, PC_App_Cmd_SMS *cmd)
{
	static PC_SMS_Info_dl*  SMS_info_dl;  
	int i=0;
	
	switch(cmd->cid2)
	{
	case PC_AppCID2_Read:
		info->flag = PC_IF_FLAGS_DATADL;
		//info->size_dlbuff = sizeof(PC_SMS_Content);
		return getShortMessage( info,cmd->type, cmd->index);
		break;
	case PC_AppCID2_Write:
		if(info->flag == PC_IF_FLAGS_CMD)
			info->flag = PC_IF_FLAGS_DATAUL;
		else
		{
//			PCSYN_TRACE_EVENT(("<<<<write_size_ulbuff:%d>>>>",info->size_ulbuff));
			T_PCSYN_MMI_SENDMMS_IND parameter;
			parameter.info = info;
			parameter.stype = cmd->type;
			parameter.rptype = cmd->index;
			P_PCSYN_MMI_SENDMMS_IND(&parameter);
			//return SendShortMessage(info,cmd->type,cmd->index);
			return PC_Error_WaitData;
		}	
		break;
	case PC_AppCID2_Delete:
		info->flag = PC_IF_FLAGS_DATADL;
		info->size_dlbuff = 0;
		return delshortmessage(info,cmd->type,cmd->index);
		break;
	case PC_AppCID2_Copy:
		if(info->flag == PC_IF_FLAGS_CMD)
			info->flag = PC_IF_FLAGS_DATAUL;
		else
		{
			return CopyShortMessage(info,cmd->type,cmd->index);
		}	
		break;
	case PC_AppCID2_Info://get shortmessage info
		info->flag = PC_IF_FLAGS_DATADL;
		info->size_dlbuff = sizeof(PC_SMS_Info_dl);
		SMS_info_dl = (PC_SMS_Info_dl *)info->pdata_dlbuff;

		
		SMS_info_dl->FlashMOtotal=sms_flash_count(MFW_SMS_FLASH_MO);
		SMS_info_dl->FlashMTtotal=sms_flash_count(MFW_SMS_FLASH_MT);
		//sms_message_list(MFW_SMS_ALL, list_data->sms_messages, MAX_MESSAGES)
//		SMS_info_dl->FlashSMStotal = FlashSMStotal;
		SMS_info_dl->SIMMOTotal= sms_message_count(MFW_SMS_MO);
		SMS_info_dl->SIMMTTotal=sms_message_count(MFW_SMS_MT);
//		SmsSend_get_config_data(&sms_parameter);
//		memcpy(SMS_info_dl->p0,sms_parameter.sc_addr,MAX_LEN+3);
              SMS_info_dl->MaxFlashNum=FLSAH_SMS_NUM;
              SMS_info_dl->MaxSIMNum=memory.total;//simԴϢĸ
		break;
	default:
		return App_Error_UnknownCID2;
	}
	return App_Error_NoError;
}

SHORT sms_flash_count (T_MFW_SMS_STAT stat)
{
	SHORT count;
	int i;

	count = 0;

	if( stat == MFW_SMS_FLASH_MO )
	{
	    for( i=0; i<FLSAH_SMS_NUM; i++ )
	    {
	        if( Flash_sms_messages[i].flag !=FALSE)
	        {
	            if(  Flash_sms_messages[i].state== MFW_SMS_STOR_UNSENT||
			 Flash_sms_messages[i].state== MFW_SMS_STOR_SENT)
			count++;
	        }
	    }
	    return count;
	}
	if( stat == MFW_SMS_FLASH_MT )
	{
	    for( i=0; i<FLSAH_SMS_NUM; i++ )
	    {
	        if( Flash_sms_messages[i].flag !=FALSE)
	        {
	            if(  Flash_sms_messages[i].state== MFW_SMS_MT)
			count++;
	        }
	    }
	    return count;
	}
	return 0;
}		

T_MFW sms_exists(SHORT index)
{
	SHORT i;
	static T_MFW_SMS_MSG msg_list[MAX_MESSAGES];

	memset(msg_list,0,sizeof(msg_list));
	sms_message_list(MFW_SMS_ALL,msg_list, MAX_MESSAGES);
	
	for( i=0; i<MAX_MESSAGES; i++ )
	{
		if( msg_list[i].index EQ index )
			return	MFW_SMS_OK;
	}
	return	MFW_SMS_FAIL;
}	

/******************************short message end*********************************/


/********************Call Record******************/
/**************ؼFlashDCTbData**************/

unsigned int delCallRecord(DelRec *delCR_content,int count )
{
	int  k;
	DelRec  *buffer = delCR_content;
	short  index;
	short  ctype;
	BYTE  idx , n;
	
	for(k=0;k<count;k++,buffer++)
	{
		ctype=buffer->ctype;
		index=buffer->index;//ɾ0ʼ 
		switch(ctype)
		{
		case CR_TYPE_LMN:
 			if(index>FlashDCTbData.LMNID-1) 
				return App_Error_DeleteError;
			n=FlashDCTbData.LMNID;
			memset((char*)FlashDCTbData.LMNTable[index],'\0',24);
			memset((char*)FlashDCTbData.LMNTime[index],'\0',21);
			memset((char*)FlashDCTbData.Mname[index],'\0',24);
			FlashDCTbData.MForNameFlag[index]=0;  
			for( idx=index;idx<n-1;idx++ )
			{
			    memcpy((char*)FlashDCTbData.LMNTable[idx],(char*)FlashDCTbData.LMNTable[idx+1],24);
			    memcpy((char*)FlashDCTbData.Mname[idx],(char*)FlashDCTbData.Mname[idx+1],24);  
			    FlashDCTbData.MForNameFlag[idx]=FlashDCTbData.MForNameFlag[idx+1];       
			    memcpy((char*)FlashDCTbData.LMNTime[idx],(char*)FlashDCTbData.LMNTime[idx+1],21);
			}
			memset((char*)FlashDCTbData.LMNTable[n-1],'\0',24);  
			memset((char*)FlashDCTbData.LMNTime[n-1],'\0',21);
			memset((char*)FlashDCTbData.Mname[n-1],'\0',24); 
			FlashDCTbData.MForNameFlag[n-1]=0; 
			FlashDCTbData.LMNID--;
			FlashDCTbData.LMNflag[n-1]=0;
			if (FlashDCTbData.MissedCallNum>0) 
				FlashDCTbData.MissedCallNum=FlashDCTbData.LMNID;
			flash_DCTbwrite();
			break;
		case CR_TYPE_LRN:
			if(index>FlashDCTbData.LRNID-1) 
				return App_Error_DeleteError;
			n=FlashDCTbData.LRNID;
			memset((char*)FlashDCTbData.LRNTable[index],'\0',24);
			memset((char*)FlashDCTbData.LRNTime[index],'\0',21);
			memset((char*)FlashDCTbData.Rname[index],'\0',24);
			FlashDCTbData.RForNameFlag[index]=0;  
			for( idx=index;idx<n-1;idx++ )
			{
			    memcpy((char*)FlashDCTbData.LRNTable[idx],(char*)FlashDCTbData.LRNTable[idx+1],24);
			    memcpy((char*)FlashDCTbData.Rname[idx],(char*)FlashDCTbData.Rname[idx+1],24);  
			    FlashDCTbData.RForNameFlag[idx]=FlashDCTbData.RForNameFlag[idx+1];       
			    memcpy((char*)FlashDCTbData.LRNTime[idx],(char*)FlashDCTbData.LRNTime[idx+1],21);
			}
			memset((char*)FlashDCTbData.LRNTable[n-1],'\0',24);  
			memset((char*)FlashDCTbData.LRNTime[n-1],'\0',21);
			memset((char*)FlashDCTbData.Rname[n-1],'\0',24); 
			FlashDCTbData.RForNameFlag[n-1]=0; 
			FlashDCTbData.LRNID--;
			flash_DCTbwrite();
			break;
		case CR_TYPE_LDN:
			if(index>FlashDCTbData.LDNID-1) 
				return App_Error_DeleteError;
			n=FlashDCTbData.LDNID;
			memset((char*)FlashDCTbData.LDNTable[index],'\0',24);
			memset((char*)FlashDCTbData.LDNTime[index],'\0',21);
			memset((char*)FlashDCTbData.Dname[index],'\0',24);
			FlashDCTbData.DForNameFlag[index]=0;  
			for( idx=index;idx<n-1;idx++ )
			{
			    memcpy((char*)FlashDCTbData.LDNTable[idx],(char*)FlashDCTbData.LDNTable[idx+1],24);
			    memcpy((char*)FlashDCTbData.Dname[idx],(char*)FlashDCTbData.Dname[idx+1],24);  
			    FlashDCTbData.DForNameFlag[idx]=FlashDCTbData.DForNameFlag[idx+1];       
			    memcpy((char*)FlashDCTbData.LDNTime[idx],(char*)FlashDCTbData.LDNTime[idx+1],21);
			}
			memset((char*)FlashDCTbData.LDNTable[n-1],'\0',24);  
			memset((char*)FlashDCTbData.LDNTime[n-1],'\0',21);
			memset((char*)FlashDCTbData.Dname[n-1],'\0',24); 
			FlashDCTbData.DForNameFlag[n-1]=0; 
			FlashDCTbData.LDNID--;
			flash_DCTbwrite();
			break;
		default:
			return App_Error_DeleteError;
		}
	}	
	return App_Error_NoError;
}


// ҵһͨ¼Ϣ롢ʱÿգindex09
/*unsigned int delCallRecord(BYTE type, BYTE index)
{
	BYTE idx , n;
	
	switch(type)
	{
	case CR_TYPE_LMN:
		if(index>FlashDCTbData.LMNID-1) 
			return App_Error_NoFound;
		n=FlashDCTbData.LMNID;
		memset((char*)FlashDCTbData.LMNTable[index],'\0',24);
		memset((char*)FlashDCTbData.LMNTime[index],'\0',21);
		memset((char*)FlashDCTbData.Mname[index],'\0',24);
		FlashDCTbData.MForNameFlag[index]=0;  
		for( idx=index;idx<n-1;idx++ )
		{
		    memcpy((char*)FlashDCTbData.LMNTable[idx],(char*)FlashDCTbData.LMNTable[idx+1],24);
		    memcpy((char*)FlashDCTbData.Mname[idx],(char*)FlashDCTbData.Mname[idx+1],24);  
		    FlashDCTbData.MForNameFlag[idx]=FlashDCTbData.MForNameFlag[idx+1];       
		    memcpy((char*)FlashDCTbData.LMNTime[idx],(char*)FlashDCTbData.LMNTime[idx+1],21);
		}
		memset((char*)FlashDCTbData.LMNTable[n-1],'\0',24);  
		memset((char*)FlashDCTbData.LMNTime[n-1],'\0',21);
		memset((char*)FlashDCTbData.Mname[n-1],'\0',24); 
		FlashDCTbData.MForNameFlag[n-1]=0; 

		FlashDCTbData.LMNID--;
		flash_DCTbwrite();
		break;
	case CR_TYPE_LRN:
		if(index>=FlashDCTbData.LRNID-1) 
			return App_Error_NoFound;
		n=FlashDCTbData.LRNID;
		memset((char*)FlashDCTbData.LRNTable[index],'\0',24);
		memset((char*)FlashDCTbData.LRNTime[index],'\0',21);
		memset((char*)FlashDCTbData.Rname[index],'\0',24);
		FlashDCTbData.RForNameFlag[index]=0;  
		for( idx=index;idx<n-1;idx++ )
		{
		    memcpy((char*)FlashDCTbData.LRNTable[idx],(char*)FlashDCTbData.LRNTable[idx+1],24);
		    memcpy((char*)FlashDCTbData.Rname[idx],(char*)FlashDCTbData.Rname[idx+1],24);  
		    FlashDCTbData.RForNameFlag[idx]=FlashDCTbData.RForNameFlag[idx+1];       
		    memcpy((char*)FlashDCTbData.LRNTime[idx],(char*)FlashDCTbData.LRNTime[idx+1],21);
		}
		memset((char*)FlashDCTbData.LRNTable[n-1],'\0',24);  
		memset((char*)FlashDCTbData.LRNTime[n-1],'\0',21);
		memset((char*)FlashDCTbData.Rname[n-1],'\0',24); 
		FlashDCTbData.RForNameFlag[n-1]=0; 

		FlashDCTbData.LRNID--;
		flash_DCTbwrite();
		break;
	case CR_TYPE_LDN:
		if(index>=FlashDCTbData.LDNID-1) 
			return App_Error_NoFound;
		n=FlashDCTbData.LDNID;
		memset((char*)FlashDCTbData.LDNTable[index],'\0',24);
		memset((char*)FlashDCTbData.LDNTime[index],'\0',21);
		memset((char*)FlashDCTbData.Dname[index],'\0',24);
		FlashDCTbData.DForNameFlag[index]=0;  
		for( idx=index;idx<n-1;idx++ )
		{
		    memcpy((char*)FlashDCTbData.LDNTable[idx],(char*)FlashDCTbData.LDNTable[idx+1],24);
		    memcpy((char*)FlashDCTbData.Dname[idx],(char*)FlashDCTbData.Dname[idx+1],24);  
		    FlashDCTbData.DForNameFlag[idx]=FlashDCTbData.DForNameFlag[idx+1];       
		    memcpy((char*)FlashDCTbData.LDNTime[idx],(char*)FlashDCTbData.LDNTime[idx+1],21);
		}
		memset((char*)FlashDCTbData.LDNTable[n-1],'\0',24);  
		memset((char*)FlashDCTbData.LDNTime[n-1],'\0',21);
		memset((char*)FlashDCTbData.Dname[n-1],'\0',24); 
		FlashDCTbData.DForNameFlag[n-1]=0; 

		FlashDCTbData.LDNID--;
		flash_DCTbwrite();
		break;
	default:
		return App_Error_IllegalCmdData;
	}
	return App_Error_NoError;
}
*/

/***********************************************/
// õһͨ¼Ϣcr_content.content
unsigned int getCallRecord(PC_CR_Content * cr_content, BYTE type, BYTE index)
{
	BYTE *buffer = cr_content->content;
	BYTE *table, *name, *time;
//	BYTE i = 0;

	   
	switch(type)
	{
	case CR_TYPE_LMN:
		if(index>FlashDCTbData.LMNID-1) 
			return App_Error_InfoError;
		table = (BYTE *)FlashDCTbData.LMNTable[index];
		name = (BYTE *)FlashDCTbData.Mname[index];
		time  = (BYTE *)FlashDCTbData.LMNTime[index];
		break;
	case CR_TYPE_LRN:
		if(index>FlashDCTbData.LRNID-1) 
			return App_Error_InfoError;
		table = (BYTE *)FlashDCTbData.LRNTable[index];
		name = (BYTE *)FlashDCTbData.Rname[index];
		time  = (BYTE *)FlashDCTbData.LRNTime[index];
		break;
	case CR_TYPE_LDN:
		if(index>FlashDCTbData.LDNID-1) 
			return App_Error_InfoError;
		table = (BYTE *)FlashDCTbData.LDNTable[index];
		name = (BYTE *)FlashDCTbData.Dname[index];
		time  = (BYTE *)FlashDCTbData.LDNTime[index];
		break;
	default:
		return App_Error_IllegalCmdData;
	}
	

	memcpy(buffer, table, 24);
	buffer += 24;
	
	memcpy(buffer,name, 24);
	buffer += 24;
	
	memcpy(buffer,time, 21);

	return App_Error_NoError;
	
}//

unsigned int pc_interface_CR(PC_Interface_Info * info, PC_App_Cmd_CR *cmd)
{
	static PC_CR_Info_dl*  cr_info_dl;  
	BYTE *table, * name, *time;
   
	switch(cmd->cid2)
	{
		case PC_AppCID2_Read:
			info->flag = PC_IF_FLAGS_DATADL;
			info->size_dlbuff = sizeof(PC_CR_Content);
			return getCallRecord((PC_CR_Content *) info->pdata_dlbuff,cmd->type, cmd->index);
			break;
		case PC_AppCID2_Write:
			return App_Error_WriteError;		
			break;
		case PC_AppCID2_Delete:
			if(info->flag == PC_IF_FLAGS_CMD)
				info->flag = PC_IF_FLAGS_DATAUL;
			else
				{
					if (info->size_ulbuff>0)
						return delCallRecord((DelRec *)info->pdata_ulbuff,((int)info->size_ulbuff)/4);
				}
			break;
		case PC_AppCID2_Info://get call record info
			info->flag = PC_IF_FLAGS_DATADL;
			info->size_dlbuff = sizeof(PC_CR_Info_dl);
			cr_info_dl = (PC_CR_Info_dl *)info->pdata_dlbuff;
			cr_info_dl->LMNID = FlashDCTbData.LMNID;
			cr_info_dl->LRNID = FlashDCTbData.LRNID;
			cr_info_dl->LDNID = FlashDCTbData.LDNID;
			break;
		default:
			return App_Error_UnknownCID2;
	}
	return App_Error_NoError;
}


/**************Call Record end********************/

/******************Target˽ӿ*******************/

unsigned int pc_interface(PC_Interface_Info * info)
{
	memset(&pc_waitdata, 0 ,sizeof(pc_waitdata) );
	
	PCSYN_TRACE_EVENT(("pc_interface: %d, %d, %d", info->size_cmd, info->size_dlbuff, info->size_ulbuff));
	//info->size_dlbuff = 0;
	switch(info->flag)
	{ 
	case PC_IF_FLAGS_CMD:
		memset(appcmd.data, 0 ,sizeof(appcmd.data) );
		appcmd.size = info->size_cmd;
			memcpy(appcmd.data, info->pdata_cmd, info->size_cmd);
	case PC_IF_FLAGS_DATAUL:
		switch(appcmd.data[0])
		{
			case PC_AppCID1_File://file cmd
				info->status = pc_interface_file(info, (PC_App_Cmd_File*) appcmd.data);
				break;
			case PC_AppCID1_PHB://phone book
				info->status = pc_interface_PHB(info, (PC_App_Cmd_PHB*) appcmd.data);
				break;
			case PC_AppCID1_SMS://Short message
				info->status = pc_interface_SMS(info, (PC_App_Cmd_SMS*) appcmd.data);
				break;
			case PC_AppCID1_CR://call record
				info->status = pc_interface_CR(info, (PC_App_Cmd_CR*) appcmd.data);
				break;
			default:
				info->status = App_Error_UnknownCID1;
				break;
		}
		
		break;
	default:
		//error flag 
		break;
				
	}
	return info->status;
}




















