/*
+-----------------------------------------------------------------------------
|  File     : pcsyn_mmip.c
+-----------------------------------------------------------------------------
|  Purpose  : This Modul defines the functions for processing
|             of incomming primitives for pcsyn task
+-----------------------------------------------------------------------------
*/
 
#define ENTITY_PCSYN

/*==== INCLUDES ===================================================*/
#if defined (NEW_FRAME)

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "typedefs.h"
#include "pcm.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "pei.h"
#include "tok.h"

#else

#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "stddefs.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"

#endif

#include "pcsyn.h"
#include "pcsyn_protocol.h"

extern T_HANDLE hCommPCSYN;

#define TRACE_EVENT(f) PCSYN_TRACE_EVENT((f));

/*****************MMI TASK**********************************/
void M_MMI_PCSYN_WAITDATA_IND(T_MMI_PCSYN_DATAWAIT_IND *parameter)
{
	TRACE_EVENT("M_MMI_PCSYN_WAITDATA_IND");
	{
		unsigned short l_buf =  8*sizeof(T_MMI_PCSYN_DATAWAIT_IND);
		PALLOC_SDU ( mmi_pcsyn_ind, MMI_PCSYN_IND , l_buf);
		mmi_pcsyn_ind->event_id = 0;
		mmi_pcsyn_ind->sdu.o_buf     = 0;
		mmi_pcsyn_ind->sdu.l_buf     = l_buf;
		memcpy(mmi_pcsyn_ind->sdu.buf,parameter,sizeof(T_MMI_PCSYN_DATAWAIT_IND) );

		
        	PSENDX (PCSYN, mmi_pcsyn_ind);
	}

	return;
}

/***********************PCSYN TASK*********************/
void P_MMI_PCSYN_WAITDATA_IND(T_MMI_PCSYN_DATAWAIT_IND *parameter)
{
	TRACE_EVENT("P_MMI_PCSYN_WAITDATA_IND");

	 //zkc add    07/22/04
	pc_writebyinfo(parameter->dummy);

	return;
}


/*
$Description:
	process mmi->pcsyn ind
*/
GLOBAL const void   mmi_pcsyn_ind (
                                  T_MMI_PCSYN_IND *mmi_pcsyn_ind
                                )
{
	  PACCESS(mmi_pcsyn_ind);

	  TRACE_EVENT("mmi_pcsyn_ind()");

	 	  switch(mmi_pcsyn_ind->event_id)
	  {
	 	case 0:
			{
				T_MMI_PCSYN_DATAWAIT_IND parameter;
				memcpy(&parameter,mmi_pcsyn_ind->sdu.buf,sizeof(T_MMI_PCSYN_DATAWAIT_IND) );
				P_MMI_PCSYN_WAITDATA_IND(&parameter);
	 		}
			break;
		default:
			break;
	  }
	  
	  PFREE(mmi_pcsyn_ind);

}


