#----------------------------------------------------------------------------- 
#  Project :  
#  Modul   :  J:\g23m-aci\smi\smi.mak
#----------------------------------------------------------------------------- 
#  Copyright 2002 Texas Instruments Berlin, AG 
#                 All rights reserved. 
# 
#                 This file is confidential and a trade secret of Texas 
#                 Instruments Berlin, AG 
#                 The receipt of or possession of this file does not convey 
#                 any rights to reproduce or disclose its contents or to 
#                 manufacture, use, or sell anything it may describe, in 
#                 whole, or in part, without the specific written consent of 
#                 Texas Instruments Berlin, AG. 
#----------------------------------------------------------------------------- 
#|  Purpose :  
#----------------------------------------------------------------------------- 
#
#	Setting Directory for Layer4 Objects
#
OBJ := $(L23_OBJ_DIR)/smi

#containing compileroptions specific for this library
SPECOPT = $(FDOPT) $(MMIOPT) $(BTOPT)

INCLAYER4 = -I$(SRCSMI) -I$(SRCACI) -I$(SRCKSD) -I$(SRCMMI)
SRCOBJ = $(ACIOBJ) $(KSDOBJ) $(SMIOBJ) $(MMIOBJ)

ifneq ($(BT),0)
INCLAYER4 += $(INCBTI)
endif

#
# Sim apllication setting
#	
ifeq ($(TK),1)
COPT1 += -dSIM_TOOLKIT
else
COPT1 += -uSIM_TOOLKIT
endif

#
# Begin SMI
#
SMIOBJ := $(OBJ)/smi_wm.$(OBJ_TAIL) \
     $(OBJ)/smi_aca.$(OBJ_TAIL) $(OBJ)/smi_cal.$(OBJ_TAIL) $(OBJ)/smi_csf.$(OBJ_TAIL) \
     $(OBJ)/smi_dmy.$(OBJ_TAIL) $(OBJ)/smi_inp.$(OBJ_TAIL) $(OBJ)/smi_lng.$(OBJ_TAIL) \
     $(OBJ)/smi_reg.$(OBJ_TAIL) $(OBJ)/smi_sec.$(OBJ_TAIL) $(OBJ)/smi_sms.$(OBJ_TAIL) \
     $(OBJ)/smi_ss.$(OBJ_TAIL) $(OBJ)/smi_ui.$(OBJ_TAIL) $(OBJ)/smi_pei.$(OBJ_TAIL) \
     $(OBJ)/smi_tim.$(OBJ_TAIL) $(OBJ)/mmi_sld.$(OBJ_TAIL) $(OBJ)/mmi_men.$(OBJ_TAIL)

ifneq ($(BT),0)
SMIOBJ += $(OBJ)/smi_bt.$(OBJ_TAIL)
endif


#
# Creating smi.lib
#


$(TOP_DIR)/$(SMI_LIB) : $(OBJ) $(SRCOBJ)
	-$(PERL) $(CONDAT_DIR)/int/bin/make_ver.pl
	$(AR) r $(TOP_DIR)/$(SMI_LIB) $(SRCOBJ) ver.$(OBJ_TAIL)

$(OBJ):	
	mkdir $(subst /,$(SLASH),$(OBJ))
	
clean: 
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(SMIOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCSMI)/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DDTI2 >> cmd
	echo $(SPECOPT) >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INCDRV1) >> cmd
	echo -I$(ICOM) >> cmd
	echo $(INCDRV2) >> cmd
	echo -I$(ICDG) >> cmd
	echo $(INCLAYER4) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd
