/* 
+----------------------------------------------------------------------------- 
|  Project :  GSM-F&D (8411)
|  Modul   :  SMI_TIM
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  This Modul defines the timer handling functions
|             for the Slim Man Machine Interface
+----------------------------------------------------------------------------- 
*/ 

#ifndef SMI_TIM_C
#define SMI_TIM_C

#define ENTITY_SMI

/*==== INCLUDES ===================================================*/

#include <string.h>
#include "typedefs.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "tok.h"
#include "message.h"

#include "aci_cmh.h"
#include "ksd.h"
#include "aca.h"
#include "smi.h"
#include "l4_tim.h"

/*==== EXPORT =====================================================*/

/*==== PRIVAT =====================================================*/

/*==== VARIABLES ==================================================*/

/*==== FUNCTIONS ==================================================*/
/*
+--------------------------------------------------------------------+
| PROJECT : GSM-F&D (8411)          MODULE  : SMI_TIM                |
| STATE   : code                    ROUTINE : smi_timeout            |
+--------------------------------------------------------------------+

  PURPOSE : execute timeout function if it is a SMI timer.
*/
#if defined (NEW_FRAME)
GLOBAL BOOL smi_timeout (USHORT index)
{
/*  TRACE_FUNCTION ("smi_timeout()"); */

  if (index EQ SMI_TBACKLIGHT)
  {
    ui_timeoutBacklight ();
    return TRUE;
  }

  if (index EQ SMI_TSLIDER)
  {
    ui_timeoutSlider ();
    return TRUE;
  }

  if (index EQ SMI_TSHIFTKEY)
  {
    ui_timeoutShiftKey ();
    return TRUE;
  }

  if (index EQ SMI_TUNIVERSAL)
  {
    ui_timeoutUniversal ();
    return TRUE;
  }

  return FALSE;
}
#else
GLOBAL BOOL smi_timeout (T_VSI_THANDLE handle)
{
/*  TRACE_FUNCTION ("smi_timeout()"); */

  if (handle EQ t_backlight_handle)
  {
    ui_timeoutBacklight ();
    return TRUE;
  }

  if (handle EQ t_slider_handle)
  {
    ui_timeoutSlider ();
    return TRUE;
  }

  if (handle EQ t_shiftkey_handle)
  {
    ui_timeoutShiftKey ();
    return TRUE;
  }

  if (handle EQ t_universal_handle)
  {
    ui_timeoutUniversal ();
    return TRUE;
  }

  return FALSE;
}
#endif /* NEW_FRAME */
#endif