/*
+-----------------------------------------------------------------------------
|  Modul   :  $Workfile:: cus_wap.h                                         $
+-----------------------------------------------------------------------------
|  Copyright 1999 Condat DV Beratung Organisation Software AG
|                 All rights reserved.
|
|                 This file is confidential and a trade secret of Condat AG
|                 The receipt of or possession of this file does not convey
|                 any rights to reproduce or disclose its contents or to
|                 manufacture, use, or sell anything it may describe, in
|                 whole, or in part, without the specific written consent of
|                 Condat AG.
+-----------------------------------------------------------------------------
|  Purpose :  Custom dependent definitions for the 
|             Protocol Stack Entity
|             Point-to-Point Protocol (PPP)
+-----------------------------------------------------------------------------
*/


#ifndef CUS_WAP_H
#define CUS_WAP_H

/*==== CONSTANTS ==================================================*/

/*
 * VERSION
 *
 * Description :  The constants define the type and the value
 *                of a version identification. The version
 *                is part of the monitor struct.
 */

#define T_VERSION      char
#define VERSION_WAP  "WAP 1.0"

/*
 * VSI_CALLER
 *
 * Description :  For multithread applicat  ions the constant VSI_CALLER
 *                must be defined to identify the calling thread of the
 *                VSI-Interface. This must be done correponding to the
 *                type of T_VSI_CALLER in VSI.H. The comma symbol is
 *                neccessary because the vsi-functions are called
 *                like this vsi_xxx (VSI_CALLER par2, par3 ...)
 */

#if defined (NEW_FRAME)

#ifdef OPTION_MULTITHREAD
#define VSI_CALLER wap_handle,
#define VSI_CALLER_SINGLE wap_handle
#else
#define VSI_CALLER
#define VSI_CALLER_SINGLE
#endif

#else

#ifdef OPTION_MULTITHREAD
#define VSI_CALLER WAP_NAME,
#define VSI_CALLER_SINGLE WAP_NAME
#else
#define VSI_CALLER
#define VSI_CALLER_SINGLE
#endif

#endif

#endif
