/*
+-----------------------------------------------------------------------------
|  File     : wap_mem.c
+-----------------------------------------------------------------------------
|                 Copyright Condat AG 1999-2001, Berlin
|                 All rights reserved.
|
|                 This file is confidential and a trade secret of Condat AG
|                 The receipt of or possession of this file does not convey
|                 any rights to reproduce or disclose its contents or to
|                 manufacture, use, or sell anything it may describe, in
|                 whole, or in part, without the specific written consent of
|                 Condat AG.
+-----------------------------------------------------------------------------
|  Purpose :  callbacks for AUS browser
|  History  :  15/05/2003 - SPR#1983 - SH - Updated to latest from 1.6.3 version.
|            
+----------------------------------------------------------------------------- 
*/

#ifndef WAP_MEM_C
#define WAP_MEM_C
#endif

#define ENTITY_WAP


/*==== INCLUDES ===================================================*/
#if defined (NEW_FRAME)

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "typedefs.h"
#include "pcm.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "pei.h"
#include "tok.h"
#include "dti.h"      /* functionality of the dti library */

#else

#include <string.h>
#include "stddefs.h"
#include "pconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "prim.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"

#endif

#include "wap.h"
#include "cus_wap.h"

#include "aapimem.h"
#if     defined LOG_EXTERNAL
#include "aapiclnt.h"
#endif

#include "wap_types.h"
#include "confvars.h"

UBYTE cache[WAP_cache_size];

UBYTE database[DATABASE_STORAGESIZE];


VOID WAP_init_cache(void)
{

	memset(cache, 0, WAP_cache_size);

	return;
}

VOID    MEMa_cachePrepared (VOID)
{
	void W_WAP_MMI_READY_CNF (T_WAP_MMI_READY_CNF *); /* care about this */
	T_WAP_MMI_READY_CNF parameter;
	
#if     defined LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_cachePrepared\nVOID\n");
#endif

#ifdef TRACE_WAP_AUS
TRACE_EVENT ("MEMa_cachePrepared()");
#endif

	/* Notify MMI that cache is prepared for shutdown */
	parameter.event_id = WAP_CACHE_PREPARE_IND_ID;
	W_WAP_MMI_READY_CNF(&parameter);

	return;
}



ULONG MEMa_readCache (
                      ULONG pos, 
                      ULONG size, 
                      CHAR *buffer
                     )
{
#if     defined LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_readCache\nULONG \t pos \t %u\nULONG \t size \t %u\nCHAR * \t buffer\n", pos, size);
#endif

#ifdef TRACE_WAP_AUS
  TRACE_EVENT ("MEMa_readCache()");
#endif

  memcpy(buffer, cache + pos, size);

  return size;
}



ULONG  MEMa_writeCache (
                        ULONG pos, 
                        ULONG size, 
                        const CHAR *buffer
                       )
{
#if     defined LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_writeCache\nULONG \t pos \t %u\nULONG \t size \t %u\nconst CHAR * \t buffer\n", pos, size);
#endif

#ifdef TRACE_WAP_AUS

  TRACE_EVENT ("MEMa_writeCache()");

#endif

  memcpy(cache + pos, buffer, size);

  return size;
}


ULONG  MEMa_readDatabase  (
                           ULONG pos, 
                           ULONG size, 
                           CHAR *buffer
                          )
{
#if     defined LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_readDatabase\nULONG \t pos \t %u\nULONG \t size \t %u\nconst CHAR * \t buffer\n", pos, size);
#endif

#if     defined LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_readCache\nULONG \t pos \t %u\nULONG \t size \t %u\nCHAR * \t buffer\n", pos, size);
#endif

#ifdef TRACE_WAP_AUS
  TRACE_EVENT ("MEMa_readCache()");
#endif

  memcpy(buffer, database + pos, size);

  return size;

}


ULONG  MEMa_writeDatabase (
                           ULONG pos, 
                           ULONG size, 
                           const CHAR *buffer
                          )
{
#if     defined LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_writeDatabase\nULONG \t pos \t %u\nULONG \t size \t %u\nconst CHAR * \t buffer\n", pos, size);
#endif

  memcpy(database + pos, buffer, size);

  return size;
}

#ifdef CONFIG_WTA



ULONG  MEMa_readServiceRepository (
                                   ULONG pos, 
                                   ULONG size, 
                                   CHAR *buffer
                                  )
{
#ifdef  LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_readServiceRepository\nULONG \t pos \t %u\nULONG \t size \t %u\nCHAR * \t buffer\n", pos, size);
#endif

    return 0;
}

ULONG  MEMa_writeServiceRepository (ULONG pos, ULONG size, const CHAR *buffer)
{
#ifdef  LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_writeServiceRepository\nULONG \t pos \t %u\nULONG \t size \t %u\nconst CHAR * \t buffer\n", pos, size);
#endif

    return 0;
}

#endif

#ifdef CONFIG_PUSH

ULONG  MEMa_readPushRepository (ULONG pos, ULONG size, CHAR *buffer)
{
#ifdef  LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_readPushRepository\nULONG \t pos \t %u\nULONG \t size \t %u\nCHAR * \t buffer\n", pos, size);
#endif

    return 0;
}

ULONG  MEMa_writePushRepository (ULONG pos, ULONG size, const CHAR *buffer)
{
#ifdef  LOG_EXTERNAL
    CLNTa_log(0, 0, "MEMa_writePushRepository\nULONG \t pos \t %u\nULONG \t size \t %u\nconst CHAR * \t buffer\n", pos, size);
#endif

    return 0;
}

#endif
VOID	MEMa_pushRepositoryClosed (VOID)
{
}

