/*
+-----------------------------------------------------------------------------
|  File     : wap_mmis.c
+-----------------------------------------------------------------------------
|                 Copyright Condat AG 1999-2000, Berlin
|                 All rights reserved.
|
|                 This file is confidential and a trade secret of Condat AG
|                 The receipt of or possession of this file does not convey
|                 any rights to reproduce or disclose its contents or to
|                 manufacture, use, or sell anything it may describe, in
|                 whole, or in part, without the specific written consent of
|                 Condat AG.
+-----------------------------------------------------------------------------
|  Purpose  : This Modul defines functions for the UDP interface of the 
|             entity wap
+-----------------------------------------------------------------------------
*/

#ifndef WAP_MMIS_C
#define WAP_MMIS_C
#endif

#define ENTITY_WAP

/*==== INCLUDES ===================================================*/
#if defined (NEW_FRAME)

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "typedefs.h"
#include "pcm.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "pei.h"
#include "tok.h"

#else

#include <string.h>
#include <stdlib.h>
#include "stddefs.h"
#include "pconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "prim.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"

#endif

/*XXX  check XXX*/
#include "dti.h"
#include "wap.h"
#include "Cus_wap.h"

#include "capiclnt.h"
#include "aapiudp.h"
#include "capiudp.h"


/****                     ***/

/*==== CONST =======================================================*/

/*==== TYPES =======================================================*/

/*==== VAR EXPORT ==================================================*/

/*==== VAR LOCAL ===================================================*/

/*==== FUNCTIONS ===================================================*/

SHORT wap_WAP_MMI_IND (UBYTE event_id,void* data, USHORT data_size)
{
		
        PALLOC_SDU (wap_mmi_ind, WAP_MMI_IND, 8*data_size);
		wap_mmi_ind->event_id = event_id;
		wap_mmi_ind->sdu.o_buf     = 0;
		wap_mmi_ind->sdu.l_buf     = 8*data_size;
		memcpy(wap_mmi_ind->sdu.buf,data,data_size);
        PSENDX (ACI, wap_mmi_ind);

}

SHORT wap_WAP_MMI_REQ(UBYTE event_id,UBYTE ti,void* data, USHORT data_size)
{
		
        PALLOC_SDU (wap_mmi_req, WAP_MMI_REQ, 8*data_size);
		{
			char temp[30];
			sprintf(temp,"WAP_MMI_REQ opt = %d",WAP_MMI_REQ);
			TRACE_EVENT(temp);
		}
		wap_mmi_req->event_id = event_id;
		wap_mmi_req->ti     = ti;
		wap_mmi_req->sdu.o_buf     = 0;
		wap_mmi_req->sdu.l_buf     = 8*data_size;
		memcpy(wap_mmi_req->sdu.buf,data,data_size);
        PSENDX (ACI, wap_mmi_req);

}

SHORT wap_WAP_MMI_CNF (UBYTE event_id,UBYTE ti,void* data, USHORT data_size)
{
		
        PALLOC_SDU (wap_mmi_cnf, WAP_MMI_CNF, 8*data_size);
		{
			char temp[30];
			sprintf(temp,"WAP_MMI_CNF opt = %d",WAP_MMI_CNF);
			TRACE_EVENT(temp);
		}
		wap_mmi_cnf->event_id = event_id;
		wap_mmi_cnf->ti     = ti;
		wap_mmi_cnf->sdu.o_buf     = 0;
		wap_mmi_cnf->sdu.l_buf     = 8*data_size;
		memcpy(wap_mmi_cnf->sdu.buf,data,data_size);
        PSENDX (ACI, wap_mmi_cnf);

}


