/*
+-----------------------------------------------------------------------------
|  File     : wap_push.c
+-----------------------------------------------------------------------------
|                 Copyright Condat AG 1999-2001, Berlin
|                 All rights reserved.
|
|                 This file is confidential and a trade secret of Condat AG
|                 The receipt of or possession of this file does not convey
|                 any rights to reproduce or disclose its contents or to
|                 manufacture, use, or sell anything it may describe, in
|                 whole, or in part, without the specific written consent of
|                 Condat AG.
+-----------------------------------------------------------------------------
|  Purpose :  callback for AUS browser, NULL, NOT IMPLEMENTED YET
|            
+----------------------------------------------------------------------------- 
*/

#ifndef WAP_PUSH_C
#define WAP_PUSH_C
#endif

#define ENTITY_WAP


/*==== INCLUDES ===================================================*/
#if defined (NEW_FRAME)

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include "typedefs.h"
#include "pcm.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "pei.h"
#include "tok.h"
#include "dti.h"      /* functionality of the dti library */

#else

#include <string.h>
#include "stddefs.h"
#include "pconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "custom.h"
#include "gsm.h"
#include "cnf_wap.h"
#include "mon_wap.h"
#include "prim.h"
#include "vsi.h"
#include "pei.h"
#include "tok.h"

#endif

#include "wap.h"
#include "cus_wap.h"




#include "wipprdct.h"

#if defined CONFIG_PUSH

#include "aapipush.h"
#include "capipush.h"
#if defined LOG_EXTERNAL
#include "aapiclnt.h"
#include "cmmnrsrc.h"
#endif


VOID PUSHa_newSIReceived (
                          INT16 id, 
                          UINT32 created, 
                          UINT32 expires, 
                          const WCHAR *message, 
                          BOOL expired, 
                          const CHAR *url, 
                          UINT8 priority, 
                          const BYTE *initURL, 
                          UINT8 applicationType, 
                          UINT8 newChannelId
                         )
{
}




VOID PUSHa_SIinfo (
                   INT16 id, 
                   UINT8 status, 
                   UINT32 created, 
                   UINT32 expires, 
                   const WCHAR *message, 
                   BOOL expired, 
                   const CHAR *url, 
                   UINT8 priority, 
                   const CHAR *initURL
                  )
{

#if defined LOG_EXTERNAL
    CLNTa_log(0, 0, "PUSHa_SIinfo\n INT16 \t id \t %i\n, UINT8 \t status \t %i\n, UINT32 \t created \t %i\n, UINT32 \t expires \t %i\n, const WCHAR * \t message \t %s\n, BOOL \t expired \t %i\n, const CHAR * \t InitUri \t %s\n",id,status,created,expires,message,expired, initURL);
#endif
	
}




VOID PUSHa_newSLReceived (
                          INT16 id, 
                          const CHAR *url, 
                          UINT8 priority, 
                          const BYTE *initURL, 
                          UINT8 applicationType, 
                          UINT8 newChannelId
                         )
{

}




VOID	PUSHa_requestConnection(
                              UINT8 siaid, 
                              UINT16 stackmode, 
                              UINT8 accesstype, 
                              const CHAR *address, 
                              UINT8 length
                             )
{
#if defined LOG_EXTERNAL
	CLNTa_log(0, 0, "PUSHa_requestConnection\nUINT8 \t siaid \t %u\n, UINT16 \t stackmode \t %i\n, UINT8 \t accesstype \t %i\n, const CHAR * \t address \t %s\n,UINT8 \t length \t %i\n", siaid, stackmode, accesstype, address, length );
#endif
}




VOID PUSHa_SLinfo (
                   INT16 id, 
                   UINT8 status, 
                   const CHAR *url, 
                   UINT8 priority, 
                   const CHAR *initURL
                  )
{

#if defined LOG_EXTERNAL
    CLNTa_log(0, 0, "PUSHa_SLinfo\n INT16 \t id \t %i\n, UINT8 \t status \t %i\n, const CHAR * \t url \t %s\n, UINT8 \t priority \t %i\n, const CHAR * \t InitUri \t %s\n ",id,status,url,priority, initURL);
#endif

}


VOID PUSHa_messagechange (
                          INT16 id, 
                          UINT8 change, 
                          UINT32 created, 
                          UINT32 expires, 
                          const WCHAR *message, 
                          BOOL expired, 
                          const CHAR *url, 
                          UINT8 priority, 
                          const BYTE *initURL, 
                          UINT8 applicationType
                         )
{
}


VOID    PUSHa_repositoryFull(VOID){
}

#endif

