/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	                                                      
 $Project code:	                                                           
 $Module:		
 $File:		    wap_wapmmi.h
 $Revision:		                                                      
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
                                                                               
********************************************************************************
                                                                              
 Description:
 	Function prototypes for WAP/MMI interface.
    
                        
********************************************************************************

 $History: wap_wapmmi.h

	20/05/2003 - SPR#1934 - SH - Synchronised latest with 1.7.0 version.
	   
 $End

*******************************************************************************/

void WAP_trace_string(char *String, UBYTE length);
void WAP_trace_ushort_string(USHORT *String, USHORT length);

void W_MMI_WAP_READY_IND(T_MMI_WAP_READY_IND *parameter);
void W_MMI_WAP_START_IND(T_MMI_WAP_START_IND *parameter);
void W_MMI_WAP_NEW_VIEW_IND(T_MMI_WAP_NEW_VIEW_IND *parameter);
void W_MMI_WAP_TERMINATE_IND(T_MMI_WAP_TERMINATE_IND *parameter);
void W_MMI_WAP_CLOSE_VIEW_IND(T_MMI_WAP_CLOSE_VIEW_IND *parameter);
void W_MMI_WAP_CONFIGURE_IND(T_MMI_WAP_CONFIGURE_IND *parameter);
void W_MMI_WAP_CONNECTION_CONFIGURE_IND(T_MMI_WAP_CONNECTION_CONFIGURE_IND *parameter);
void W_MMI_WAP_DOWNLOAD_URL_IND(T_MMI_WAP_DOWNLOAD_URL_IND *parameter);
void W_MMI_WAP_BROWSE_CONTROL_IND(T_MMI_WAP_BROWSE_CONTROL_IND *parameter);
void W_MMI_WAP_KEY_SELECTED_IND(T_MMI_WAP_KEY_SELECTED_IND *parameter);
void W_MMI_WAP_INPUT_DIALOG_CNF(T_MMI_WAP_INPUT_DIALOG_CNF *parameter);
void W_MMI_WAP_PASSWORD_DIALOG_CNF(T_MMI_WAP_PASSWORD_DIALOG_CNF *parameter);
void W_MMI_WAP_CONFIRM_DIALOG_CNF(T_MMI_WAP_CONFIRM_DIALOG_CNF *parameter);
void W_MMI_WAP_INFO_DIALOG_CNF(T_MMI_WAP_INFO_DIALOG_CNF *parameter);
void W_MMI_WAP_DRAW_CARD_REQ(T_MMI_WAP_DRAW_CARD_REQ *parameter);
void W_MMI_WAP_CONNECT_CNF(T_MMI_WAP_CONNECT_CNF *parameter);
void W_MMI_WAP_DISCONNECT_IND(T_MMI_WAP_DISCONNECT_IND *parameter);
void W_MMI_WAP_CACHE_PREPARE_IND(T_MMI_WAP_CACHE_PREPARE_IND *parameter);
void W_WAP_MMI_CONTROL_IND(T_WAP_MMI_CONTROL_IND *parameter);
void W_WAP_MMI_NEW_KEY_IND(T_WAP_MMI_NEW_KEY_IND *parameter);
void W_WAP_MMI_INPUT_DIALOG_REQ(T_WAP_MMI_INPUT_DIALOG_REQ *parameter);
void W_WAP_MMI_PASSWORD_DIALOG_REQ(T_WAP_MMI_PASSWORD_DIALOG_REQ *parameter);
void W_WAP_MMI_CONFIRM_DIALOG_REQ(T_WAP_MMI_CONFIRM_DIALOG_REQ *parameter);
void W_WAP_MMI_INFO_DIALOG_REQ(T_WAP_MMI_INFO_DIALOG_REQ *parameter);	
void W_WAP_MMI_NEW_CARD_IND(T_WAP_MMI_NEW_CARD_IND *parameter);
void W_WAP_MMI_DRAW_CARD_IND(T_WAP_MMI_DRAW_CARD_IND *parameter);
void W_WAP_MMI_CLEAR_CARD_IND(T_WAP_MMI_CLEAR_CARD_IND *parameter);
void W_WAP_MMI_SEND_TEXT_IND(T_WAP_MMI_SEND_TEXT_IND *parameter);
void W_WAP_MMI_SEND_IMAGE_IND(T_WAP_MMI_SEND_IMAGE_IND *parameter);
void W_WAP_MMI_SEND_TABLE_IND(T_WAP_MMI_SEND_TABLE_IND *parameter);
void W_WAP_MMI_CARD_DRAW_COMPLETED_IND(T_WAP_MMI_CARD_DRAW_COMPLETED_IND *parameter);
void W_WAP_MMI_CONNECT_REQ(T_WAP_MMI_CONNECT_REQ *parameter);
void W_WAP_MMI_DISCONNECTED_IND(T_WAP_MMI_DISCONNECTED_IND *parameter);
void W_WAP_MMI_READY_CNF(T_WAP_MMI_READY_CNF *parameter);

/* Functions in wap_gle.c */

void setupDisplayData(USHORT view_width_in, USHORT view_height_in, UBYTE *font_width_in, UBYTE font_height_in, UBYTE unicode_width_in, UBYTE unicode_height_in);
void freeDisplayData(void);

#ifdef MMS_WAP_ENABLED
/***talcon add for mms*************/
void W_MMI_WAP_MMSSTART_IND(T_MMI_WAP_MMSSTART_IND *parameter);
void W_MMI_WAP_MMSTERMINATE_IND(T_MMI_WAP_MMSTERMINATE_IND *parameter);

void W_MMI_WAP_POSTCONTENT_IND(T_MMI_WAP_POSTCONTENT_IND *parameter);
void W_WAP_MMI_CONTENT_REQ(T_WAP_MMI_CONTENT_REQ *parameter);

void W_MMI_WAP_POSTMORECONTENT_IND(T_MMI_WAP_POSTMORECONTENT_IND *parameter);
void W_WAP_MMI_ACKPOSTCONTENT_REQ(T_WAP_MMI_ACKPOSTCONTENT_REQ *parameter);

void W_MMI_WAP_GETCONTENT_IND(T_MMI_WAP_GETCONTENT_IND *parameter);
void W_MMI_WAP_ACKCONTENT_IND(T_MMI_WAP_ACKCONTENT_IND *parameter);

void W_MMI_WAP_CANCELCONTENT_IND(T_MMI_WAP_CANCELCONTENT_IND *parameter);
#endif

