/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	                                                      
 $Project code:	                                                           
 $Module:		
 $File:		    ATBWapAUI.h
 $Revision:		                                                      
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
                                                                               
********************************************************************************
                                                                              
 Description:
 	This file...
    
                        
********************************************************************************

 $History: ATBWapAUI.h

	
	   
 $End

*******************************************************************************/
#include "MMiResources.h"

//#include "AUIWap.h"
#if defined(TRACE_ATBWAPAUI) || defined(TRACE_ATBWAPACI)

void ATB_trace_string(char *String, USHORT length);

void ATB_trace_ushort_string(USHORT *String, USHORT length);

#endif
/* SPR#1437 - SH - All display constants stored here, except checkbox sizes
 * which are in wap_types.h */
//zhaowm 2002.1130. changed the value

#define WAP_CHAR_HEIGHT			(LINE_HEIGHT)	//8		// Height of a line of text
#define WAP_CHAR_WIDTH  		8           	//6		// Width of a character
#define WAP_TOTAL_WIDTH			SCREEN_SIZE_X	//84	// Total width of screen
#define WAP_TOTAL_HEIGHT		SCREEN_SIZE_Y	//48	// Total height of screen
#define WAP_LEFT_BORDER			0		// Border at left of screen
#define WAP_RIGHT_BORDER		4		// Border at right of screen
#define WAP_TOP_BORDER			18          	//8		// Border at top of screen (title)
#define WAP_BOTTOM_BORDER		18          	//8		// Border at bottom of screen (softkeys)
#define WAP_SCREEN_RIGHT		(WAP_TOTAL_WIDTH - WAP_RIGHT_BORDER)
#define WAP_SCREEN_BOTTOM		(WAP_TOTAL_HEIGHT - WAP_BOTTOM_BORDER)
#define WAP_SCREEN_WIDTH		(WAP_TOTAL_WIDTH - WAP_LEFT_BORDER - WAP_RIGHT_BORDER)		// No of pixels available to the wap browser in width...
#define WAP_SCREEN_HEIGHT		(WAP_TOTAL_HEIGHT - WAP_TOP_BORDER - WAP_BOTTOM_BORDER)		// and height (not including title & softkeys)
#define WAP_PAGE_SCROLL 		(WAP_SCREEN_HEIGHT-WAP_CHAR_HEIGHT)		// Long scrolling size
#define WAP_TEXT_LOWEST			(WAP_SCREEN_HEIGHT-WAP_CHAR_HEIGHT)	 // Lowest point we can draw text
#define WAP_VSCROLLBAR_WIDTH	3		// Total width of the vertical scrollbar
#define WAP_HSCROLLBAR_WIDTH	4		// Total width of the horizontal scrollbar
#define WAP_SOFTKEY_SPACING	 2			// Minimum spacing between softkey texts
#define WAP_SOFTKEY_MIN_LENGTH 5		// Minimum length for softkey text (including two dots for truncated strings)

/*******************************************************************************

 $Function:    	ATB_wap_start

 $Description:	Starts the WAP application
 
 $Returns:		

 $Arguments:	parameter - a dummy parameter
 
*******************************************************************************/

void ATB_wap_start(T_MMI_WAP_START_IND *parameter);


/*******************************************************************************

 $Function:    	ATB_wap_new_view

 $Description:	Starts a new view, defining the graphical size of the screen to
 				be handled.
 
 $Returns:		Pointer to the data structure of the new view

 $Arguments:	parameter		- width and height of the WAP view
 				UIdata			- Optional generic pointer, for use by the user
 								interface.  This can point to window information, etc,
 								but is not used by ATB.
 
*******************************************************************************/

T_WAP_VIEW* ATB_wap_new_view(T_MMI_WAP_NEW_VIEW_IND *parameter, void* UIdata);


/*******************************************************************************

 $Function:    	ATB_wap_get_view

 $Description:	Returns a pointer to a view, given its object_id
 
 $Returns:		Pointer to the data structure of the specified view

 $Arguments:	object_id  - the id of the view
 
*******************************************************************************/

T_WAP_VIEW* ATB_wap_get_view(UBYTE object_id);


/*******************************************************************************

 $Function:    	ATB_wap_terminate

 $Description:	Closes the WAP application and frees all the memory allocated
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 
*******************************************************************************/

T_WAP_RES ATB_wap_terminate();


/*******************************************************************************

 $Function:    	ATB_wap_destroy_view

 $Description:	Destroys a view
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				
 
*******************************************************************************/

T_WAP_RES ATB_wap_destroy_view(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_destroy

 $Description:	Destroys the wap application, including all views (calls ATB_wap_terminate)
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				
 
*******************************************************************************/

T_WAP_RES ATB_wap_destroy();


/*******************************************************************************

 $Function:    	ATB_wap_UIdata

 $Description:	Returns the UI pointer, for use by AUI
 
 $Returns:		The void pointer

 $Arguments:	
 				
 
*******************************************************************************/

void *ATB_wap_UIdata();


/*******************************************************************************

 $Function:    	ATB_wap_configure

 $Description:	Sends configuration information to the browser, the more important being:
 				- ConfigHISTORY_SIZE, the number of URLs stored in the history
 				- ConfigCACHE_AGE, period for the cache to store a card
 				- ConfigDISPLAY_IMAGES, images to be displayed or not
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				Configure		- Properties of configuration
 
*******************************************************************************/

T_WAP_RES ATB_wap_configure(T_MMI_WAP_CONFIGURE_IND *Configure);


/*******************************************************************************

 $Function:    	ATB_wap_connection_configure

 $Description:	Sends network configuration information to the browser, such as the
 				bearer, IP addresses, passwords and ids, etc.
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	objectId				- Identifier of the session
 				Connection				- Properties of configuration
 
*******************************************************************************/

T_WAP_RES ATB_wap_connection_configure(T_MMI_WAP_CONNECTION_CONFIGURE_IND *Connection);


/*******************************************************************************

 $Function:    	ATB_wap_download_url

 $Description:	Requests the WAP browser to download a particular URL
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				DownloadURL		- Properties of the URL download
 
*******************************************************************************/

T_WAP_RES ATB_wap_download_url(T_MMI_WAP_DOWNLOAD_URL_IND *DownloadURL);

/*******************************************************************************

 $Function:    	ATB_wap_stop_download

 $Description:	Requests the WAP browser to stop downloading a particular URL
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	View - the current view
 
*******************************************************************************/

T_WAP_RES ATB_wap_stop_download(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_card_refresh

 $Description:	Requests the WAP browser to refresh the current card from the network
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 
*******************************************************************************/

T_WAP_RES ATB_wap_card_refresh(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_card_display

 $Description:	Requests the WAP browser to redisplay a card held in the cache
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	View - the current view
 
*******************************************************************************/

T_WAP_RES ATB_wap_card_display(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_card_go_back

 $Description:	Requests the WAP browser to go to the previous card
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	View - the current view
 
*******************************************************************************/

T_WAP_RES ATB_wap_card_go_back(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_card_key_event

 $Description:	Requests the WAP browser react to a key event, up/down etc.
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	View - the current view
 
*******************************************************************************/

T_WAP_RES ATB_wap_card_key_event(T_WAP_VIEW *View, WAP_CONTROL_TYPES keyType);


/*******************************************************************************

 $Function:    	ATB_wap_key_selected

 $Description:	Send the id of the selected WAP key to the AUS browser.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	View - the current view
 				keyId - Key identifier
 
*******************************************************************************/

T_WAP_RES ATB_wap_key_selected(T_WAP_VIEW *View, USHORT keyId);


/*******************************************************************************

 $Function:    	ATB_wap_card scroll

 $Description:	Scroll to a y position on the current card
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	scrollPos			- Y position on card to which to scroll
 
*******************************************************************************/

T_WAP_RES ATB_wap_card_scroll(T_WAP_VIEW *View, SHORT scrollPos);


/*******************************************************************************

 $Function:    	AUI_wap_input_dialog_open

 $Description:	Prompts the MMI to open an input dialog given a particular format and
 				string.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	Dialog			- Dialog information
 				View			- The current view
 
*******************************************************************************/

T_WAP_RES AUI_wap_input_dialog_open(T_WAP_MMI_INPUT_DIALOG_REQ *Dialog, T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_input_dialog_closed

 $Description:	Provides the answer of an input dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				DialogCnf		- Dialog confirmation information
 
*******************************************************************************/


T_WAP_RES ATB_wap_input_dialog_closed(T_MMI_WAP_INPUT_DIALOG_CNF *DialogCnf);


/*******************************************************************************

 $Function:    	AUI_wap_password_dialog_open

 $Description:	Prompts the MMI to open a password dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				Dialog			- Dialog information
 
*******************************************************************************/

T_WAP_RES AUI_wap_password_dialog_open(T_WAP_MMI_PASSWORD_DIALOG_REQ *Dialog,T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_password_dialog_closed

 $Description:	Provides the answer of a password dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				DialogCnf		- Dialog confirmation information
 
*******************************************************************************/

T_WAP_RES ATB_wap_password_dialog_closed(T_MMI_WAP_PASSWORD_DIALOG_CNF *DialogCnf);


/*******************************************************************************

 $Function:    	AUI_wap_confirm_dialog_open

 $Description:	Prompts the MMI to open a confirmation dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				Dialog			- Dialog information
 
*******************************************************************************/

T_WAP_RES AUI_wap_confirm_dialog_open(T_WAP_MMI_CONFIRM_DIALOG_REQ *Dialog, T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_confirm_dialog_closed

 $Description:	Provides the answer of a confirmation dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				DialogCnf		- Dialog confirmation information
 
*******************************************************************************/

T_WAP_RES ATB_wap_confirm_dialog_closed(T_MMI_WAP_CONFIRM_DIALOG_CNF *DialogCnf);


/*******************************************************************************

 $Function:    	AUI_wap_info_dialog_open

 $Description:	Prompts the MMI to open an info dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				Dialog			- Dialog information
 
*******************************************************************************/

T_WAP_RES AUI_wap_info_dialog_open(T_WAP_MMI_INFO_DIALOG_REQ *Dialog, T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_info_dialog_closed

 $Description:	Provides the answer of an info dialog.
 				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 				DialogCnf		- Dialog confirmation information
 
*******************************************************************************/

T_WAP_RES ATB_wap_info_dialog_closed(T_MMI_WAP_INFO_DIALOG_CNF *DialogCnf);


/*******************************************************************************

 $Function:    	ATB_wap_update_display_cnf

 $Description:	The WAP AUI will ask the ATB to finally display the card.
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 
*******************************************************************************/

T_WAP_RES ATB_wap_update_display_cnf();


/*******************************************************************************

 $Function:    	AUI_wap_options_menu_open

 $Description:	The ATB will send to the AUI the contents of the menu list
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	contextType	- the context, to specify the first item in the menu
 
*******************************************************************************/

T_WAP_RES AUI_wap_options_menu_open(UBYTE contextType);


/*******************************************************************************

 $Function:    	AUI_wap_options_menu_select

 $Description:	The AUI will notify to the WAP.ATB the id of the selected item
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	
 
*******************************************************************************/

T_WAP_RES AUI_wap_options_menu_select();


/*******************************************************************************

 $Function:    	ATB_wap_options_menu_select

 $Description:	The AUI will notify to the WAP.ATB the id of the selected item
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	View - the current view
 
*******************************************************************************/

T_WAP_RES ATB_wap_options_menu_select(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_add_element

 $Description:	Add a new element to the element chain
 
 $Returns:		Pointer to the element

 $Arguments:	object_id - the id of the session
 				type	- the type of element (text, fieldset, image)
 
*******************************************************************************/

T_WAP_ELEMENT * ATB_wap_buffer_add_element(UBYTE object_id, WAP_ELEMENT_TYPE type);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_display

 $Description:	Displays the card from the buffer
 
 $Returns:		

 $Arguments:	View - the current view
 
*******************************************************************************/

void ATB_wap_buffer_display(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_image_display

 $Description:	Trims an image to fit into the specified space, then displays it
 
 $Returns:		

 $Arguments:	View - pointer to the appropriate view
 
*******************************************************************************/

void ATB_wap_buffer_image_display(T_WAP_MMI_SEND_IMAGE_IND *image);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_text_draw

 $Description:	Draws text
 
 $Returns:		

 $Arguments:	pX, pY			- position of text
 				pWidth, pHeight	- dimensions of text
 				text_length		- length of text
 				Text			- text itself
 				type			- type of text
 				invert			- TRUE if text is highlighted
 				format			- format of text
 				selected		- TRUE if option is selected
 				is_link			- TRUE if text is a link
 
*******************************************************************************/

void ATB_wap_buffer_text_draw(T_WAP_MMI_SEND_TEXT_IND *parameter);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_table_draw

 $Description:	Draws a table, or a fieldset
 
 $Returns:		

 $Arguments:	pX, pY			- position of table
 				pWidth, pHeight	- dimensions of table
 				title_length	- length of title
 				Title			- title text
 				noOfCols		- number of columns (tables only)
 				noOfRows		- number of rows (tables only)
 				ColWidth		- list of column widths (tables only)
 				RowHeight		- list of row heights (tables only)
 
*******************************************************************************/

void ATB_wap_buffer_table_draw(T_WAP_MMI_SEND_TABLE_IND *parameter);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_line_draw

 $Description:	Draws a line, making sure it fits on-screen
 
 $Returns:		

 $Arguments:	x1,y1 - Coordinates of the start of the line
 				x2,y2 - Coordinates of the end of the line
 
*******************************************************************************/

void ATB_wap_buffer_line_draw(SHORT x1, SHORT y1, SHORT x2, SHORT y2);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_onscreen

 $Description:	Returns TRUE if the point supplied is on-screen
 
 $Returns:		

 $Arguments:	x,y - coordinates of the point
 				deltaX, deltaY - returns offset from screen
 
*******************************************************************************/

static BOOL ATB_wap_buffer_onscreen(SHORT x, SHORT y, SHORT *deltaX, SHORT *deltaY);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_clear

 $Description:	Clears the element buffer
 
 $Returns:		

 $Arguments:	View - the current view
 
*******************************************************************************/

void ATB_wap_buffer_clear(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_buffer_identify_element

 $Description:	Identifies which element is selected (based on the invert property) and
 				returns an appropriate type.
 
 $Returns:		The type of the element that is selected, or NULL if none

 $Arguments:	View	- pointer to the view
 
*******************************************************************************/

UBYTE ATB_wap_buffer_identify_element(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_profile_create

 $Description:	Allocates memory for profile information in RAM
 
 $Returns:		Pointer to the newly created profile

 $Arguments:	
 
*******************************************************************************/

T_WAP_PROFILE* ATB_wap_profile_create();


/*******************************************************************************

 $Function:    	ATB_wap_profile_destroy

 $Description:	Destroys a profile
 
 $Returns:		

 $Arguments:	Profile		- pointer to the profile to destroy
 
*******************************************************************************/

void ATB_wap_profile_destroy(T_WAP_PROFILE *Profile);


/*******************************************************************************

 $Function:    	ATB_wap_profile_read

 $Description:	Reads in the current profile (specified by a number in ProfileId)
 				from the flash.
 
 $Returns:		

 $Arguments:	View		- Pointer to the current view
 				ProfileId	- the id of the profile to read from the flash
 
*******************************************************************************/

T_WAP_RES ATB_wap_profile_read(T_WAP_VIEW *View, UBYTE ProfileId);


/*******************************************************************************

 $Function:    	ATB_wap_profile_names_read

 $Description:	Reads in the names of all profiles stored in flash
 
 $Returns:		

 $Arguments:	Profile		- Pointer to the current profile
 
*******************************************************************************/

T_WAP_RES ATB_wap_profile_names_read(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_profiles_save

 $Description:	Store the current updated profile in flash
 
 $Returns:		

 $Arguments:	Profile		- Pointer to the current profile
 
*******************************************************************************/

T_WAP_RES ATB_wap_profile_save(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_profile_default_create

 $Description:	Creates a default profile in the flash if one isn't already there
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

T_WAP_RES ATB_wap_profile_default_create();


/*******************************************************************************

 $Function:    	ATB_wap_profile_send

 $Description:	Reads the current profile and sends it to WAP task.
 
 $Returns:		

 $Arguments:	Profile 	- Pointer to the current selected profile.
 
*******************************************************************************/

void ATB_wap_profile_send(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	ATB_wap_entry_list_create

 $Description:	Creates an entries list
 
 $Returns:		

 $Arguments:	max_entries	- maximum number of entries in list
 
*******************************************************************************/

T_WAP_LIST * ATB_wap_entry_list_create(WAP_LIST_TYPE type, UBYTE max_entries, UBYTE entry_size);


/*******************************************************************************

 $Function:    	ATB_wap_entry_list_destroy

 $Description:	Destroys an entries list
 
 $Returns:		

 $Arguments:	EntryList	- pointer to entry list data
 
*******************************************************************************/

T_WAP_RES ATB_wap_entry_list_destroy(T_WAP_LIST *EntryList);


/*******************************************************************************

 $Function:    	ATB_wap_entry_add

 $Description:	Adds an entry in the bookmarks or history list
 
 $Returns:		

 $Arguments:	Entrylist	- Pointer to entries table
 				Entry		- Entry to add
 
*******************************************************************************/

T_WAP_RES ATB_wap_entry_add(T_WAP_LIST *EntryList, char *Entry);


/*******************************************************************************

 $Function:    	ATB_wap_entry_change

 $Description:	Changes an entry in an entry list, destroying the old entry and
 				creating a new one.
 
 $Returns:		

 $Arguments:	type			- Type of entry list
 				Entrylist 		- Pointer to entries table
 				Entry			- New entry text
 				entryIndex		- Number of entry to change
 
*******************************************************************************/

T_WAP_RES ATB_wap_entry_change(WAP_LIST_TYPE type, T_WAP_LIST *EntryList, char *Entry, UBYTE entryIndex);


/*******************************************************************************

 $Function:    	ATB_wap_entry_insert

 $Description:	Insert an entry into an entry list, shifting all subsequent entries up one.
 				If the maximum limit of the entry list is reached, the last entry is
 				deleted.
 
 $Returns:		

 $Arguments:	type			- Type of entry list
 				Entrylist 		- Pointer to entries table
 				Entry			- Entry to insert
 				entryIndex 		- Position at which to insert the new entry
 
*******************************************************************************/

T_WAP_RES ATB_wap_entry_insert(WAP_LIST_TYPE type, T_WAP_LIST *EntryList, char *Entry, UBYTE entryIndex);


/*******************************************************************************

 $Function:    	ATB_wap_entry_remove

 $Description:	Removes an entry from the bookmarks or history list
 
 $Returns:		

 $Arguments:	Entrylist 		- Pointer to entries table
 				entryIndex 		- Number of the entry to delete
 
*******************************************************************************/

T_WAP_RES ATB_wap_entry_remove(T_WAP_LIST *EntryList, UBYTE entryIndex);


/*******************************************************************************

 $Function:    	ATB_wap_entry_remove_all

 $Description:	Removes all entries from a Entry List
 
 $Returns:		

 $Arguments:	EntryList 	- Pointer to bookmarks table
 				string_size	- Size of string for each entry
 
*******************************************************************************/

T_WAP_RES ATB_wap_entry_remove_all(T_WAP_LIST *EntryList);


/*******************************************************************************

 $Function:    	ATB_wap_renumber_history

 $Description:	Renumber history list, changing prefixes to all entries
 
 $Returns:		

 $Arguments:	History - pointer to history list	
 
*******************************************************************************/

int ATB_wap_renumber_history(T_WAP_LIST *History);


/*******************************************************************************
















 $Function:    	AUI_wap_memory_alloc

 $Description:	Requests memory allocation through the AUI.
 
 $Returns:		address of the allocated block.

 $Arguments:	size - amount of memory to allocate.
 
*******************************************************************************/
U8* AUI_wap_memory_alloc(USHORT size);


/*******************************************************************************

 $Function:    	AUI_wap_memory_free.

 $Description:	Requests AUI to free memory.
 
 $Returns:		error code.

 $Arguments:	address - address of the memory to be freed.
	
				size    - amount of memory to free.
 
*******************************************************************************/

U8 AUI_wap_memory_free(U8* address,U16 size);


/*******************************************************************************

 $Function:    	ATB_wap_card_show

 $Description:	Called by the WAP.ATB to show the and/or create the card window.
 
 $Returns:		

 $Arguments:	View			- The current view

 
*******************************************************************************/

void AUI_wap_card_show_req(T_WAP_VIEW *View);


/*******************************************************************************

 $Function:    	AUI_wap_status_notify

 $Description:	Called by the WAP.ATB when a status flag has changed
 				SPR#1574 - SH - Removed parameter
 
 $Returns:		

 $Arguments:	View			- The current view
				status			- New value of status
 
*******************************************************************************/


void AUI_wap_status_notify(T_WAP_VIEW *View, USHORT status);

/*******************************************************************************

 $Function:    	ATB_wap_status_change

 $Description:	Called to change a status flag
 				SPR#1574 - SH - Removed parameter
 
 $Returns:		

 $Arguments:	View			- The current view
				status			- New value of status
 
*******************************************************************************/


void ATB_wap_status_change(T_WAP_VIEW *View, USHORT status);

/*******************************************************************************

 $Function:    	ATB_wap_status_get

 $Description:	
 
 $Returns:		The status (TRUE/FALSE) of a particular flag

 $Arguments:	View			- The current view
				flag			- parameter which status has changed
 
*******************************************************************************/


BOOL ATB_wap_status_get(T_WAP_VIEW *View, USHORT status);


/*******************************************************************************

 $Function:    	ATB_ushort2char

 $Description:	Converts a USHORT string to a char string
 
 $Returns:		the copy

 $Arguments:	dst			- the destination string
				src			- the source string
				srclen		- the length of the source string
 
*******************************************************************************/

char* ATB_ushort2char (char *dst, USHORT *src, USHORT srclen);

char* ATB_ushort2char_old (char *dst, USHORT *src, USHORT srclen);  //zhaowm 2003.1.17

/*******************************************************************************

 $Function:    	ATB_char2ushort

 $Description:	Converts a char string to a USHORT string
 
 $Returns:		the length of the destination string

 $Arguments:	dst			- the destination string
				src			- the source string
 
*******************************************************************************/

USHORT ATB_char2ushort (USHORT *dst, char *src);


/*******************************************************************************

 $Function:    	ATB_char2char

 $Description:	Copies a CHAR string that is not necessarily terminated with a NULL
 
 $Returns:		the copy

 $Arguments:	dst			- the destination string
				src			- the source string
				srclen		- the length of the source string
 
*******************************************************************************/

char* ATB_char2char (char *dst, char *src, USHORT srclen);


/*******************************************************************************

 $Function:    	ATB_wap_char_to_BCD

 $Description:	Converts an ascii string of digits into BCD form, with 4 bits representing
 				each digit.
 
 $Returns:		

 $Arguments:	src 	- source string (ascii)
 				dest	- destination string for BCD digits
 
*******************************************************************************/

void ATB_char_to_BCD(char *dest, char *src);


/*******************************************************************************

 $Function:    	ATB_textWidth

 $Description:	Returns width of string in pixels
 
 $Returns:		

 $Arguments:	str			- the string
				length		- the length of string to measure
 
*******************************************************************************/

USHORT ATB_textWidth(char *str, USHORT length);


/*******************************************************************************

 $Function:    	ATB_crop_text

 $Description:	Crops text if necessary to fit the supplied width
 
 $Returns:		

 $Arguments:	str			- the string
 				length		- the original length
				width		- the maximum permitted width in pixels of the string
 
*******************************************************************************/

void ATB_crop_text(char *str, USHORT length, SHORT width);


/*******************************************************************************

 $Function:    	ATB_conv_str_to_IP

 $Description:	Converts a string IP address to a long type IP address
 
 $Returns:		

 $Arguments:	str			- the string
 				len			- the original length
				ip			- pointer to where the result will be placed
 
*******************************************************************************/

GLOBAL const void ATB_conv_str_to_IP(const char* str, USHORT len, ULONG* ip);




/*******************************************************************************

 $Function:    	ATB_data_call_connected

 $Description:
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void ATB_data_call_connected(void);


/*******************************************************************************

 $Function:    	ATB_wap_start_done

 $Description:	Confirms that WAP_START has completed
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void ATB_wap_start_done(void);
void AUI_wap_start_done(void);

/*******************************************************************************

 $Function:    	ATB_wap_new_view_done

 $Description:	Confirms that WAP_NEW_VIEW has completed
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void ATB_wap_new_view_done(void);
void AUI_wap_new_view_done(void);


/*******************************************************************************

 $Function:    	ATB_wap_terminate_done

 $Description:	Confirms that WAP_TERMINATE has completed
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void ATB_wap_terminate_done(void);
void AUI_wap_terminate_done(void);

/*******************************************************************************

 $Function:    	ATB_wap_close_view_done

 $Description:	Confirms that WAP_CLOSE_VIEW has completed
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void ATB_wap_close_view_done(void);
void AUI_wap_close_view_done(void);
USHORT ATB_uni2ushort (USHORT *dst, char *src);
/*******************************************************************************

 $Function:    	ATB_wap_disconnect

 $Description:	SPR#1189 - SH - Added this function
 				Informs WAP browser that a disconnection has occurred
 
 $Returns:		

 $Arguments:	View - the current View
 
*******************************************************************************/

void ATB_wap_disconnect(T_WAP_VIEW *View);

#ifdef MMS_WAP_ENABLED

/*************************talcon add for mms***********/
void ATB_mms_start_done(void);

void  ATB_mms_terminate_done();

void ATB_mms_profile_send(T_MMS_VIEW *View);

void ATB_wap_content_post(T_MMI_WAP_POSTCONTENT_IND *parameter);
	
void ATB_wap_morecontent_post(T_MMI_WAP_POSTMORECONTENT_IND *parameter);

void ATB_wap_wiew_add(T_WAP_VIEW *View);
void ATB_wap_view_delete(T_WAP_VIEW *View);

void ATB_mms_cancel(UBYTE urlID);

#endif


