
#ifndef _MMS_AGENT_H_
#define _MMS_AGENT_H_

/*url id for content */
#define URLID_MMS_RECV		230
#define URLID_MMS_SEND		231

#define MMS_MESSAGE_FIRSTGROUP_SIZE      864
#define MMS_MESSAGE_GROUP_SIZE      968

#define MMS_WAP_TEST
/* MMS_WAP STATUS */
typedef enum
{
	MMS_WAP_NOSTATUS,
	MMS_WAP_OPENED,
	MMS_WAP_SENDCONNECTING,
	MMS_WAP_SENDING,
	MMS_WAP_SENT,
	MMS_WAP_RECVCONNECTING,
	MMS_WAP_RECVING,
	MMS_WAP_RECVED
}MMS_WAP_STATUS;

/*MMS TYPE, MMS SEND OR MMS RECEIVE*/
typedef enum
{
	MMS_TYPE_SEND,
	MMS_TYPE_RECV
};

typedef struct MMS_WAP_DATA_SEND
{
	UBYTE	 urlID;
	int 		  fdi;
	SHORT     sizeSent;
	SHORT     sizeTotal;
	char 	  filename[24];
	char         mmscaddr[24];
}
T_MMS_WAP_DATA_SEND;

typedef struct MMS_WAP_DATA_RECV
{
	UBYTE	 urlID;
	int 		  fdi;
	SHORT     sizeRecv;
	SHORT     sizeTotal;
	char 	  filename[24];
	char         url[256];
}
T_MMS_WAP_DATA_RECV;


/*MMS data structurer*/
typedef struct MMS_WAP_DATA
{
	SHORT status;/*MMS_WAP_STATUS*/
	UBYTE type;/* MMS_TYPE_SEND or MMS_TYPE_RECV*/
	UBYTE urlID;/* URLID_MMS_RECV or URLID_MMS_SEND */
	int fp;       /* file pointer */
	U32		 sizeUsed;
	U32     	 sizeTotal;
	char 	 filename[24];
	union
	{
		char        mmscaddr[24];
		char 	 url[256];
	}pubbuff; 
	struct MMS_WAP_DATA* next;
}
T_MMS_WAP_DATA;

typedef enum
{
	MMS_PQ_TYPE_NOTI= 0,
	MMS_PQ_TYPE_DLVRYIND,
	MMS_PQ_TYPE_FILE
};
typedef struct MMS_PUSH_QUEUE
{
	UBYTE type;//isDelivery;
	char filename[12];
	struct MMS_PUSH_QUEUE *next;
}T_MMS_PUSH_QUEUE;


UBYTE MMS_Get_MessageType(char *data);


/*push queue*/
 void mms_pushfile_init();
T_MMS_PUSH_QUEUE * handle_push_queue();
T_MMS_PUSH_QUEUE *get_pushlist_head();
T_MMS_PUSH_QUEUE *remove_pushlist(T_MMS_PUSH_QUEUE *data);
T_MMS_PUSH_QUEUE * append_pushlist(T_MMS_PUSH_QUEUE * data);

/*mms send and recv queue*/
 BOOL isMMSQueueEmpty();
 T_MMS_WAP_DATA *get_mmslist_head(UBYTE type);
T_MMS_WAP_DATA*  mms_sendnew(char *filename, char *mmscaddr);
 void handle_mmssend(T_MMS_WAP_DATA* data);
 T_MMS_WAP_DATA*  mms_recvnew(char *filename, char *url);
 void handle_mmsrecv(T_MMS_WAP_DATA* data, T_WAP_MMI_CONTENT_REQ *parameter);
 void handle_mms_queue_begin();
 void handle_mms_queue_err(SHORT errorCode);
//void set_mmslist_process(T_MMS_WAP_DATA *data);


 int MMS_Random(int min,int max);

 void MMS_Content_REQ(
						UBYTE urlID,
						char *Data,
						ULONG data_length,
						BOOL moreData,
						ULONG totalSize,
						SHORT errorNo);
 void wap_mms_evt_cb(
			UBYTE    type, 
			UBYTE    status, 
			char *    filename 
			);

BOOL isPushInRecvFolder(char *filename);

 #define MMS_WAP_TEST
#endif


