/****************************************************************************************
* Copyright  (c) 2003 by Mobile Innovation All rights reserved.                         *
*                                                                                       *
* This software is copyrighted by and is the sole property of Mobile Innovation and its *
* licensors, if any. All rights, title, ownership, or other interests in the software   *
* remain the property of Mobile Innovation and its licensors, if any.                   *
*                                                                                       *
* This software may only be used in accordance with the corresponding license agreement *
* license agreement. Any unauthorized use, duplication, transmission, distribution or   *
* disclosure of this software is expressly forbidden.                                   *
*                                                                                       *
*                                                                                       *
*   Mobile Innovation(Shanghai)Co.,Ltd.                                                 *
*   Shanghai - China                        http://www.mobileinnovation.com.cn          *
*****************************************************************************************/

/****************************************************************************************
* File Name            :                                      
* File Description     : 
*                   
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* History:  Date:                                                                  
*           Author:                                                               
*           Modify:                                                                
****************************************************************************************/

/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	                                                      
 $Project code:	                                                           
 $Module:		
 $File:		    ATBWapACI.c
 $Revision:		                                                      
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
                                                                               
********************************************************************************
                                                                              
 Description:
 	Provides an interface between the ATB and the ACI. 
    
                        
********************************************************************************

 $History: ATBWapACI.c

	20/05/2003 - SPR#1934 - SH - Synchronised latest with 1.7.0 version.
	   
 $End

*******************************************************************************/

 

#ifndef PSA_WAPS_C
#define PSA_WAPS_C
#endif

#define MFW

#ifdef MFW
#define ENTITY_MFW
#else
#ifdef SMI
#define ENTITY_SMI
#else
#define ENTITY_ACI
#endif
#endif

#define ACI_MEMBER

/*==== INCLUDES ===================================================*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef NEW_FRAME
#include "typedefs.h"
#include "pconst.cdg"
#include "mconst.cdg"
#include "message.h"
#include "ccdapi.h"
#include "vsi.h"
#include "custom.h"
#include "gsm.h"
#include "prim.h"
#include "cnf_aci.h"
#include "mon_aci.h"
#include "pei.h"
#include "tok.h"
#include "aci_cmh.h"
#include "ati_cmd.h"
#include "aci_cmd.h"

#else  /* NEW_FRAME */
#include "stddefs.h"
#endif /* NEW_FRAME */

#include "Ffs.h"
#include "gledef.h"
#include "capiclnt.h"
#include "aapiclnt.h"
#include "wap_types.h"
#include "ATBWapACI.h"
#include "ATBData.h"
#include "wap_codec.h"
#include "ATBWapAUI.h"
#include "AUIWap.h"

#ifdef GPRS
#include "Gaci_cmh.h"
#endif

#ifdef MMS_WAP_ENABLED
#include "MMSAgent.h"
#include "mms_codec.h"
#endif
#define WAP_TRACE 1
#define TRACE_ATBWAPACI
#include "mmiutilapi.h"
#define TRACE_EVENT(f) WAP_TRACE_EVENT(("bmi--Atbwapaci.c<<<talcon,%s",f));
#define TRACE_FUNCTION(f) WAP_TRACE_EVENT(("bmi--Atbwapaci.c<<<talcon,%s",f));


EXTERN char *atD (char *cl,UBYTE srcId);


/*******************************************************************************

 $Function:    	M_MMI_WAP_READY_IND
 
 $Description:	Indicate to WAP that MMI is ready to receive events
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/


void M_MMI_WAP_READY_IND(T_MMI_WAP_READY_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_READY_IND");
#endif
	
	mmi_coder(WAP_READY_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************

 $Function:    	M_MMI_WAP_START_IND
 
 $Description:	Tell WAP Browser to start up
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/


void M_MMI_WAP_START_IND(T_MMI_WAP_START_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_START_IND");
#endif
	
	mmi_coder(WAP_START_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************

 $Function:    	M_MMI_WAP_NEW_VIEW_IND
 
 $Description:	Tell WAP Browser to start a new view
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/


void M_MMI_WAP_NEW_VIEW_IND(T_MMI_WAP_NEW_VIEW_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_NEW_VIEW_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2("id/uamode: %d, %d", parameter->object_id, parameter->uaMode);
	TRACE_EVENT_P2("width/height: %d, %d", parameter->view_width, parameter->view_height);
	TRACE_EVENT_P2("font height: %d, width of 'A': %d", parameter->font_height, parameter->font_width[65]);
	TRACE_EVENT_P2("unicode height: %d, unicode width: %d", parameter->unicode_width, parameter->unicode_height);
#endif
	
	mmi_coder(WAP_NEW_VIEW_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************

 $Function:    	M_MMI_WAP_TERMINATE_IND
 
 $Description:	Tell WAP Browser to terminate.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_TERMINATE_IND(T_MMI_WAP_TERMINATE_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_TERMINATE_IND");
#endif

	mmi_coder(WAP_TERMINATE_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************

 $Function:    	M_MMI_WAP_CLOSE_VIEW_IND
 
 $Description:	Close the specified view.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_CLOSE_VIEW_IND(T_MMI_WAP_CLOSE_VIEW_IND *parameter)
{
#ifdef TRACE_WAP_WAPMMI
	TRACE_FUNCTION("M_MMI_WAP_CLOSE_VIEW_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	mmi_coder(WAP_CLOSE_VIEW_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_CONFIGURE_IND
 
 $Description:	Send configuration information to WAP Browser
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_CONFIGURE_IND(T_MMI_WAP_CONFIGURE_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_CONFIGURE_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P3( "Type, Param, Length: %d, %d, %d", parameter->type, parameter->param, parameter->length);
	TRACE_EVENT_P1( "Integer Value: %d", parameter->intvalue);
	if (parameter->length>0)
		ATB_trace_string(parameter->strvalue, parameter->length);
#endif

	mmi_coder(WAP_CONFIGURE_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_CONNECTION_CONFIGURE_IND
 
 $Description:	Send configuration information to WAP Browser
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_CONNECTION_CONFIGURE_IND(T_MMI_WAP_CONNECTION_CONFIGURE_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_CONNECTION_CONFIGURE_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P3( "Type, Channel_id, Length: %d, %d, %d", parameter->type, parameter->channel_id, parameter->length);
	TRACE_EVENT_P1( "Integer Value: %d", parameter->intvalue);
	ATB_trace_string(parameter->strvalue, parameter->length);
#endif

	mmi_coder(WAP_CONNECTION_CONFIGURE_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_DOWNLOAD_URL_IND
 
 $Description:	Requests WAP Browser to download a URL
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_DOWNLOAD_URL_IND(T_MMI_WAP_DOWNLOAD_URL_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_DOWNLOAD_URL_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2( "URL length, Reload: %d, %d", parameter->url_length, parameter->reload);
	ATB_trace_string(parameter->Url, parameter->url_length);
#endif

	mmi_coder(WAP_DOWNLOAD_URL_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_BROWSE_CONTROL_IND
 
 $Description:	Sends browsing request to WAP Browser
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_BROWSE_CONTROL_IND(T_MMI_WAP_BROWSE_CONTROL_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_BROWSE_CONTROL_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "Browse command: %d", parameter->browse_command);
#endif

	mmi_coder(WAP_BROWSE_CONTROL_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_KEY_SELECTED_IND
 
 $Description:	Indicate to Browser that a WAP Key has been selected.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_KEY_SELECTED_IND(T_MMI_WAP_KEY_SELECTED_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_KEY_SELECTED_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "keyId: %d", parameter->keyId);
#endif

	mmi_coder(WAP_KEY_SELECTED_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_INPUT_DIALOG_CNF
 
 $Description:	Confirmation of input dialog.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_INPUT_DIALOG_CNF(T_MMI_WAP_INPUT_DIALOG_CNF *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_INPUT_DIALOG_CNF");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2( "dialog_id, edited: %d, %d", parameter->dialog_id, parameter->edited);
	ATB_trace_ushort_string(parameter->Text, parameter->text_length);
#endif

	mmi_coder(WAP_INPUT_DIALOG_CNF_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_PASSWORD_DIALOG_CNF
 
 $Description:	Confirmation of password dialog.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_PASSWORD_DIALOG_CNF(T_MMI_WAP_PASSWORD_DIALOG_CNF *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_PASSWORD_DIALOG_CNF");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "MMI dialog_id: %d", parameter->dialog_id);
	ATB_trace_string(parameter->Input, parameter->input_length);
	ATB_trace_string(parameter->Password, parameter->password_length);
#endif

	mmi_coder(WAP_PASSWORD_DIALOG_CNF_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_CONFIRM_DIALOG_CNF
 
 $Description:	Confirmation of confirm dialog.
 
 $Returns:		None

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_CONFIRM_DIALOG_CNF(T_MMI_WAP_CONFIRM_DIALOG_CNF *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_CONFIRM_DIALOG_CNF");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2( "MMI dialog_id: %d, Answer: %d", parameter->dialog_id, parameter->answer);
#endif

	mmi_coder(WAP_CONFIRM_DIALOG_CNF_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_INFO_DIALOG_CNF
 
 $Description:	Confirmation of info dialog.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_INFO_DIALOG_CNF(T_MMI_WAP_INFO_DIALOG_CNF *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_INFO_DIALOG_CNF");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "MMI dialog_id: %d", parameter->dialog_id);
#endif

	mmi_coder(WAP_INFO_DIALOG_CNF_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_DRAW_CARD_REQ
 
 $Description:	Request WAP Browser to draw the current card.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_DRAW_CARD_REQ(T_MMI_WAP_DRAW_CARD_REQ *parameter)
{
	T_WAP_VIEW *View = ATB_wap_get_view(parameter->object_id);
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_DRAW_CARD_REQ");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	if (View)
	mmi_coder(WAP_DRAW_CARD_REQ_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_CONNECT_CNF
 
 $Description:	Confirmation to WAP Browser that WAP call is connected
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_CONNECT_CNF(T_MMI_WAP_CONNECT_CNF *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_CONNECT_CNF");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	mmi_coder(WAP_CONNECT_CNF_ID,(void*)parameter);

	return;
}


/*******************************************************************************

 $Function:    	M_MMI_WAP_DISCONNECT_IND
 
 $Description:	Tell WAP Browser to disconnect
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_DISCONNECT_IND(T_MMI_WAP_DISCONNECT_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_DISCONNECT_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	mmi_coder(WAP_DISCONNECT_IND_ID,(void*)parameter);

	return;
}


/*******************************************************************************


 $Function:    	M_MMI_WAP_CACHE_PREPARE_IND
 
 $Description:	Tell WAP Browser to prepare the cache for shutdown
 
 $Returns:		None

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_MMI_WAP_CACHE_PREPARE_IND(T_MMI_WAP_CACHE_PREPARE_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_CACHE_PREPARE_IND");
#endif

	mmi_coder(WAP_CACHE_PREPARE_IND_ID,(void*)parameter);

	return;
}



/*******************************************************************************


 $Function:    	M_WAP_MMI_CONTROL_IND
 
 $Description:	Send control information to MMI
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_CONTROL_IND(T_WAP_MMI_CONTROL_IND *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI	
	TRACE_FUNCTION("M_WAP_MMI_CONTROL_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P3( "Status, Error, Click: %d, %d, %d", parameter->status_code, parameter->error_code,
parameter->play_standard_click);
#endif

	View = ATB_wap_get_view(parameter->object_id);

	
	/* Intercept fatal error */
	
	if (parameter->error_code==8002)
	{
		AUI_error_dialog(View, parameter->error_code);
		return;
	}

	/* For non-fatal error, do not report if there is no view open */
	
	if (!View)
	{
		TRACE_EVENT("View is NULL");	
		return;
	}
	
	if (parameter->status_code==14)			// Data is being downloaded; update status display
	{
		/* SPR#1574 - SH - Change function parameters */
		ATB_wap_status_change(View, ATB_WAP_DOWNLOADING);
	}
	
	if (parameter->status_code==15)			// Data is no longer being downloaded
	{
		/* SPR#1574 - SH - Change function parameters */
		ATB_wap_status_change(View, ATB_WAP_NO_STATUS);
	}
#ifdef MMS_WAP_ENABLED
        if (parameter->status_code==14)	
	{
	}
#endif 
	if (parameter->error_code!=0 && parameter->error_code != 0x20)
	{
		TRACE_EVENT("Opening error dialog");
		AUI_error_dialog(View, parameter->error_code);
	}

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_NEW_KEY_IND
 
 $Description:	A new WAP key is to be created.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_NEW_KEY_IND(T_WAP_MMI_NEW_KEY_IND *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_NEW_KEY_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2( "Key ID, Key Type: %d, %d", parameter->keyId, parameter->key_type);
	ATB_trace_ushort_string(parameter->Label, parameter->label_length);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;

	if (parameter->key_type == WAP_KEY_PREV)
		AUI_wap_change_soft_key(View, parameter->Label,
			(USHORT)parameter->label_length, parameter->keyId);
	
	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_INPUT_DIALOG_REQ
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_INPUT_DIALOG_REQ(T_WAP_MMI_INPUT_DIALOG_REQ *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_INPUT_DIALOG_REQ");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2( "MMI dialog_id, is_password: %d, %d", parameter->dialog_id, parameter->is_password);
	TRACE_EVENT_P3( "MMI empty_ok, visible, size: %d, %d, %d", parameter->empty_ok, 
parameter->visible, parameter->size);
	ATB_trace_ushort_string(parameter->Title, parameter->title_length);
	ATB_trace_ushort_string(parameter->Input, parameter->input_length);
	ATB_trace_ushort_string(parameter->Format, parameter->format_length);
#endif // TRACE_ATBWAPACI

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
	AUI_wap_input_dialog_open(parameter, View);

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_PASSWORD_DIALOG_REQ
 
 $Description:	A password dialog is to be displayed.
 
 $Returns:		None

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_PASSWORD_DIALOG_REQ(T_WAP_MMI_PASSWORD_DIALOG_REQ *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_PASSWORD_DIALOG_REQ");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P2( "MMI dialog_id, dialog_type: %d, %d", parameter->dialog_id, parameter->dialog_type);
	/* SPR#2393 - SH - Changed password fields */
	ATB_trace_string(parameter->Realm, parameter->realm_length);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
#ifdef MMS_WAP_ENABLED
	if(View->object_id == 128)
	{
		T_MMI_WAP_PASSWORD_DIALOG_CNF parameter2;
		parameter2.dialog_id = parameter->dialog_id;
		parameter2.object_id = parameter->object_id;
		parameter2.Input = View->Profile->Username;
		parameter2.input_length = strlen(parameter2.Input);
		parameter2.Password= View->Profile->Password;
		parameter2.password_length= strlen(parameter2.Password);
		M_MMI_WAP_PASSWORD_DIALOG_CNF(&parameter2);
	}
	else
	{
		AUI_wap_password_dialog_open(parameter,View);
	}
#else		
	AUI_wap_password_dialog_open(parameter,View);
#endif

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_CONFIRM_DIALOG_REQ
 
 $Description:	A confirmation dialog is to be displayed.
 
 $Returns:		None

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_CONFIRM_DIALOG_REQ(T_WAP_MMI_CONFIRM_DIALOG_REQ *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_CONFIRM_DIALOG_REQ");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "MMI dialog_id: %d", parameter->dialog_id);
	ATB_trace_ushort_string(parameter->Message, parameter->message_length);
	ATB_trace_ushort_string(parameter->Ok_key, parameter->ok_key_length);
	ATB_trace_ushort_string(parameter->Cancel_key, parameter->cancel_key_length);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
	AUI_wap_confirm_dialog_open(parameter, View);

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_INFO_DIALOG_REQ
 
 $Description:	An info/alert dialog is to be displayed.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_INFO_DIALOG_REQ(T_WAP_MMI_INFO_DIALOG_REQ *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_INFO_DIALOG_REQ");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "MMI dialog_id: %d", parameter->dialog_id);
	ATB_trace_ushort_string(parameter->Message, parameter->message_length);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
	AUI_wap_info_dialog_open(parameter, View);

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_NEW_CARD_IND
 
 $Description:	A new card is to be created.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_NEW_CARD_IND(T_WAP_MMI_NEW_CARD_IND *parameter)
{
	T_WAP_VIEW	*View;
	char    *temp1;   //zhaowm 2003.1.8
	char    *temp;
	UBYTE *History = (UBYTE *)parameter->History;
	U32	historyPointer = History[4] + History[5]*0x100 + History[6]*0x10000 + History[7]*0x1000000;
	/* Look at second history entry (bytes 4 to 7) - this is the previous card.
	 * If this is zero, then there shouldn't be a "back" key */
	USHORT historyIndex;

#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_NEW_CARD_IND");
	TRACE_EVENT_P1("object ID: %d",parameter->object_id);
	TRACE_EVENT_P1( "is_bookmarkable: %d", parameter->is_bookmarkable);
	ATB_trace_ushort_string(parameter->Title, parameter->title_length);
	ATB_trace_string(parameter->Url, parameter->url_length);
	TRACE_EVENT_P2( "History pointer: value %x at %x", historyPointer, History+4);
#endif
	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
	// Convert title to char and crop it if necessary

	if (parameter->title_length > CARD_TITLE_MAX_LEN)
	{
		parameter->title_length = CARD_TITLE_MAX_LEN;
		parameter->Title[CARD_TITLE_MAX_LEN] = NULL;
	}

	if (parameter->title_length == 0)
	{
		temp = MmiRsrcGetText(Txtnotitle);  //zhaowm 2003.0305 
		if (temp[0] == 0x80)
		  {
		   parameter->title_length = 3;
           wstrncpy(View->Title, temp, wstrlen(temp));
		   }
		else
		  {
		   parameter->title_length = 8;
		   strcpy(View->Title, temp);	
		   }


	}
    else
       {
	    temp1 = (char *)AUI_wap_memory_alloc(((CARD_TITLE_MAX_LEN)*2+3)*sizeof(char)); 
		ATB_ushort2char(temp1, parameter->Title, parameter->title_length);
        truncateString(View->Title,(char *)temp1,10,1,".");
        AUI_wap_memory_free((UBYTE *)temp1, ((CARD_TITLE_MAX_LEN)*2+3)*sizeof(char));    
        }

	// Make sure URL is not too long

	if (parameter->url_length > URL_MAX_LEN)
	{
		parameter->url_length = URL_MAX_LEN;
		*(parameter->Url+URL_MAX_LEN) = NULL;
	}
	strncpy(View->URL, parameter->Url, URL_MAX_LEN);

	// Add card name & URL to top of history list

	if (View->Status & WAP_STATUS_SAVEHISTORY)
	{
		ATB_wap_entry_insert(WAP_HISTORY_LIST, View->History, View->Title, 0);	// Add as entry 0 (last entry lost)
		ATB_wap_entry_insert(WAP_URL_LIST, View->HistoryURL, View->URL, 0);
		ATB_wap_profile_save(View);												// Save change to flash
	}

	// Check to see if user can go back from this card

	if (historyPointer != 0)
	{
		View->CanGoBack = TRUE;
	}
	else
	{
		View->CanGoBack = FALSE;
	}
	
	View->CustSoftKeys = FALSE;					// Default softkeys
	
	/* SPR#1575 - SH - New card is being read in */
	ATB_wap_status_change(View, ATB_WAP_CARD_READING);

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_DRAW_CARD_IND
 
 $Description:	Tell MMI to draw the card.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_DRAW_CARD_IND(T_WAP_MMI_DRAW_CARD_IND *parameter)
{
	T_WAP_VIEW	*View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_DRAW_CARD_IND");
	TRACE_EVENT_P1("object ID: %d",parameter->object_id);
	TRACE_EVENT_P2("contentWidth: %d, contentHeight: %d",parameter->contentWidth, parameter->contentHeight);
	TRACE_EVENT_P2("contentPosX: %d, contentPosY: %d",parameter->contentPosX, parameter->contentPosY);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;

	View->cardWidth		= parameter->contentWidth;
	View->cardHeight	= parameter->contentHeight;
	View->cardXPosition	= parameter->contentPosX;
	View->cardYPosition	= parameter->contentPosY;

	View->acceptUpdate	= FALSE;
	// Set to FALSE as default, to ignore any attempts to redraw parts of the card
	// rather than the whole card (e.g. when selecting an option).  Only allows a card
	// to be updated if M_WAP_MMI_CLEAR_CARD_IND is called.
}


/*******************************************************************************

 $Function:    	M_WAP_MMI_CLEAR_CARD_IND

 $Description:	Clear the card display.  Allows card to be updated.
 
 $Returns:		None.

 $Arguments:	parameter - data block
 
*******************************************************************************/

void M_WAP_MMI_CLEAR_CARD_IND(T_WAP_MMI_CLEAR_CARD_IND *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_CLEAR_CARD_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;

	View->acceptUpdate = TRUE;

	// Clearing the card means we're going to update the whole thing, so this update
	// is permitted (see M_WAP_MMI_DRAW_CARD_IND).
	
	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_SEND_TEXT_IND

 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_SEND_TEXT_IND(T_WAP_MMI_SEND_TEXT_IND *parameter)
{
	T_WAP_VIEW					*View;
	T_WAP_ELEMENT				*Element;
	T_WAP_MMI_SEND_TEXT_IND		*copy;

#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_SEND_TEXT_IND");
	ATB_trace_ushort_string(parameter->Text, parameter->text_length);
	ATB_trace_ushort_string(parameter->Formatstring, parameter->formatstring_length);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
	
	// If an update is forbidden, ignore this event

	if (!View->acceptUpdate)
		return;
			
	// Allocate memory and copy the data
	
 	Element = ATB_wap_buffer_add_element(parameter->object_id, WAP_TEXT);
 
	copy = (T_WAP_MMI_SEND_TEXT_IND *)AUI_wap_memory_alloc(sizeof(T_WAP_MMI_SEND_TEXT_IND));
	memcpy((void *)copy, (void *)parameter, sizeof(T_WAP_MMI_SEND_TEXT_IND));

	if (parameter->text_length != 0)
	{
		copy->Text 			= (USHORT *)AUI_wap_memory_alloc(parameter->text_length*sizeof(USHORT));
		memcpy((void *)copy->Text, (void *)parameter->Text, parameter->text_length*sizeof(USHORT));
	}
	if (parameter->formatstring_length != 0)
	{
		copy->Formatstring 	=  (USHORT *)AUI_wap_memory_alloc(parameter->formatstring_length*sizeof(USHORT));
		memcpy((void *)copy->Formatstring, (void *)parameter->Text, parameter->formatstring_length*sizeof(USHORT));
	}
	
	Element->data = (void *)copy;

	return;
}


/*******************************************************************************



























































 $Function:    	M_WAP_MMI_SEND_IMAGE_IND

 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_SEND_IMAGE_IND(T_WAP_MMI_SEND_IMAGE_IND *parameter)
{
	T_WAP_VIEW					*View;
	T_WAP_ELEMENT				*Element;
	T_WAP_MMI_SEND_IMAGE_IND	*copy;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_SEND_IMAGE_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;

	// If an update is forbidden, ignore this event

	if (!View->acceptUpdate)
		return;

	Element = ATB_wap_buffer_add_element(parameter->object_id, WAP_IMAGE);
 
	copy = (T_WAP_MMI_SEND_IMAGE_IND *)AUI_wap_memory_alloc(sizeof(T_WAP_MMI_SEND_IMAGE_IND));
	memcpy((void *)copy, (void *)parameter, sizeof(T_WAP_MMI_SEND_IMAGE_IND));

	if (parameter->image_length != 0)
	{
		copy->Image 		= (UBYTE *)AUI_wap_memory_alloc(parameter->image_length*sizeof(UBYTE));
		memcpy((void *)copy->Image, (void *)parameter->Image, parameter->image_length*sizeof(UBYTE));
	}
	
	Element->data = (void *)copy;
	
	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_SEND_TABLE_IND

 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_SEND_TABLE_IND(T_WAP_MMI_SEND_TABLE_IND *parameter)
{
	T_WAP_VIEW					*View;
	T_WAP_ELEMENT				*Element;
	T_WAP_MMI_SEND_TABLE_IND	*copy;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_SEND_TABLE_IND");
	TRACE_EVENT_P1("object ID: %d",parameter->object_id);
	TRACE_EVENT_P2("Columns: %d, Rows: %d",parameter->cols_length, parameter->rows_length);
	TRACE_EVENT_P4("pX: %d, pY: %d, pWidth: %d, pHeight: %d",parameter->pX, parameter->pY, parameter->pWidth, parameter->pHeight);
	WAP_trace_ushort_string(parameter->Title, parameter->title_length);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;

// If an update is forbidden, ignore this event

	if (!View->acceptUpdate)
		return;
	
	// Allocate memory and copy the data
	
 	Element = ATB_wap_buffer_add_element(parameter->object_id, WAP_TABLE);
 
	copy = (T_WAP_MMI_SEND_TABLE_IND *)AUI_wap_memory_alloc(sizeof(T_WAP_MMI_SEND_TABLE_IND));
	memcpy((void *)copy, (void *)parameter, sizeof(T_WAP_MMI_SEND_TABLE_IND));

	if (parameter->title_length != 0)
	{
		copy->Title = (USHORT *)AUI_wap_memory_alloc(parameter->title_length*sizeof(USHORT));
		memcpy((void *)copy->Title, (void *)parameter->Title, parameter->title_length*sizeof(USHORT));
	}
	if (parameter->cols_length != 0)
	{
		copy->ColWidth = (SHORT *)AUI_wap_memory_alloc(parameter->cols_length*sizeof(SHORT));
		memcpy((void *)copy->ColWidth, (void *)parameter->ColWidth, parameter->cols_length*sizeof(SHORT));
	}
	if (parameter->rows_length != 0)
	{
		copy->RowHeight = (SHORT *)AUI_wap_memory_alloc(parameter->rows_length*sizeof(SHORT));
		memcpy((void *)copy->RowHeight, (void *)parameter->RowHeight, parameter->rows_length*sizeof(SHORT));
	}
	Element->data = (void *)copy;

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_CARD_DRAW_COMPLETED_IND

 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_CARD_DRAW_COMPLETED_IND(T_WAP_MMI_CARD_DRAW_COMPLETED_IND *parameter)
{
	T_WAP_VIEW *View;

	UBYTE temp;

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;
	
	temp = dspl_Enable(0);

#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_CARD_DRAW_COMPLETED_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	// If an update is forbidden, ignore this event

	if (!View->acceptUpdate)
	{
		dspl_Enable(temp);
		return;
	}
	
	// Destroy the current card, and make the new buffered card the current card
	
	ATB_wap_buffer_clear(View);
	View->ElementHeader = View->NewElementHeader;
	View->NewElementHeader = NULL;
		
	AUI_wap_card_show_req(View);
	dspl_Enable(temp);
	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_CONNECT_REQ
 
 $Description:	The connection (GSM or GPRS) can now be made
 				SPR#1575 - SH - Split the GPRS part of this function into two.
 				The GPRS attachment is made in this function.  Once GPRS is
 				attached, the connection proceeds in function connect_gprs() below.
 
 $Returns:		None.

 $Arguments:	parameter - the appropriate data type for the WAP_MMI_CONNECT_REQ
 				event.
 
*******************************************************************************/

void M_WAP_MMI_CONNECT_REQ(T_WAP_MMI_CONNECT_REQ *parameter)
{
	T_WAP_VIEW *View;
	char temp[NUMBER_MAX_LEN+1];
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_CONNECT_REQ");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

WAP_TRACE_EVENT(("objectid: %d",parameter->object_id));
if (!(View = ATB_wap_get_view(parameter->object_id)))
	return;

switch (View->Profile->AccessType)
{
	case WAP_CS_DATA:
		//robert chen modified, to adapte new ACI API, 2004-08-10
		//sAT_PercentPPP(0,1,View->Profile->Username, View->Profile->Password);
		sAT_PercentPPP(0,1,View->Profile->Username, View->Profile->Password,USE_NO_PPP_FOR_AAA);
		sAT_PercentWAP(0,0);
		sAT_PercentWAP(0,1);
		sprintf(temp, "=%s", View->Profile->DialupNumber);
		atD(temp,CMD_SRC_ATI_1);	
	break;
#ifdef GPRS 
	case WAP_GPRS_DATA:
	{
		T_CGATT_STATE regstate; 	
		/* SPR#1574 - SH - Modified to detect if GPRS attach fails.
		/* SPR#1575 - SH - Check to see if attached */

		qAT_PlusCGATT ( CMD_SRC_LCL, &regstate );
  		WAP_TRACE_EVENT(("Reg state: %d", regstate));

		/* If we're not attached, attempt to do so */
		
  		if (regstate!=CGATT_STATE_ATTACHED)
  		{
  			/* Display status "attaching" */
			ATB_wap_status_change(View, ATB_WAP_ATTACHING);
			/* Attempt to attach */
  			sAT_PlusCGATT ( CMD_SRC_LCL, CGATT_STATE_ATTACHED );	
  		}
		/* Otherwise, go straight to GPRS connection */
  		else
  		{
  			connect_gprs(parameter->object_id);
		}
	}
#endif
	}
}


#ifdef GPRS
/*******************************************************************************


 $Function:    	connect_gprs
 
 $Description:	SPR#1575 - SH - Added this function
 				Already attached; now activate PDP context
 
 $Returns:		

 $Arguments:	View - the current view
 
*******************************************************************************/
#ifdef MMS_WAP_ENABLED
ULONG IPAddressSaved = 0;
#endif
void connect_gprs(UBYTE object_id)
{
	SHORT tst_cid[MAX_CID_PLUS_EINS];
	T_GPRS_CONT_REC context;
	T_ACI_RETURN ret;
	UBYTE minsize;
	BOOL states[MAX_CID_PLUS_EINS];
	T_CGCLASS_CLASS m_class;
	USHORT lac, cid;
	T_WAP_VIEW *View;

	TRACE_FUNCTION("connect_gprs()");
	
	if (!(View = ATB_wap_get_view(object_id)))
		return;
	
	/*   Check to see if context already active */
	
	qAT_PlusCGACT ( CMD_SRC_LCL, states, tst_cid );
		TRACE_EVENT_P1("Context 0: %d", tst_cid[0]);

	/* If context doesn't exist, define it */
	
    if ( tst_cid[0] == INVALID_CID)
	{
        TRACE_EVENT("Defining new context.");
        minsize = (MAX_APN_LEN<(URL_MAX_LEN+1))?MAX_APN_LEN:(URL_MAX_LEN+1);
		memset(&context.apn,'\0',MAX_APN_LEN);
		memcpy(&context.apn,&View->Profile->APN,minsize);
		strcpy((char*)context.pdp_type,"IP");
		minsize = (MAX_PDP_ADDR_LEN<(IPADDRESS_MAX_LEN+1))?MAX_PDP_ADDR_LEN:(IPADDRESS_MAX_LEN+1);
		memset(&context.pdp_addr,'\0',MAX_PDP_ADDR_LEN);
		context.d_comp = CGDCONT_D_COMP_OMITTED;
		context.h_comp = CGDCONT_H_COMP_OMITTED;
		memset(&context.qos,0,sizeof(T_QOS));
		memset(&context.min_qos,0,sizeof(T_QOS));
		ret = sAT_PlusCGDCONT(CMD_SRC_LCL,GPRS_CID_1,&context);
		TRACE_EVENT_P1("CGDCONT Return = %d",ret);

		if (ret==AT_FAIL)
		{
			TRACE_EVENT("*** GPRS NOT SUPPORTED ***");
			AUI_error_dialog(View, ERROR_GPRS_NOT_SUPPORTED);
			return;
		}
	}

	/*  If context isn't activated, call ATD */

	qAT_PlusCGACT ( CMD_SRC_LCL, states, tst_cid );

	if (states[0])
	{
		TRACE_EVENT("Context is activated.");
		ATB_data_call_connected();	/* SPR#2138 */
	}
	else
	{
		TRACE_EVENT("Context not activated.");
		//robert chen modified, to adapte new ACI API, 2004-08-10
		//ret = sAT_PercentCGPCO (CMD_SRC_LCL,1,ACI_PCO_AUTH_PROT_PAP,(CHAR *)View->Profile->Username,(CHAR *)View->Profile->Password);
		ret = sAT_PercentCGPCO (
			CMD_SRC_LCL,
			GPRS_CID_1,
			ACI_PCO_AUTH_PROT_PAP,
			(CHAR *)View->Profile->Username,
			(CHAR *)View->Profile->Password,
			NULL,
			NULL
			);
			
		TRACE_EVENT_P1("CGPCO Return = %d", ret);
		
		if (ret==AT_FAIL)
		{
			TRACE_EVENT("*** GPRS NOT SUPPORTED ***");
			//AUI_error_dialog(View, ERROR_GPRS_NOT_SUPPORTED);
			return;
		}
		
	  ret = sAT_Dn(CMD_SRC_LCL,"*98*1#",D_CLIR_OVRD_Default,D_CUG_CTRL_NotPresent,D_TOC_Data);

		switch (ret)
		{
		    case (AT_CMPL):                         /*operation completed*/
		    case (AT_EXCT):
		    	TRACE_EVENT("Connection proceeding OK");
		    	break;
		    	
		    default:
		    	TRACE_EVENT("*** GPRS NOT SUPPORTED ***");
				/*talcoin*/
		  	AUI_error_dialog(View, ERROR_GPRS_NOT_SUPPORTED);
		    	TRACE_EVENT("Error occurred in connection.");
		    	return;
				break;
		}
	}
		
}
#endif

/*******************************************************************************


 $Function:    	M_WAP_MMI_DISCONNECTED_IND
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_DISCONNECTED_IND(T_WAP_MMI_DISCONNECTED_IND *parameter)
{
	T_WAP_VIEW *View;
	
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_DISCONNECTED_IND");
	TRACE_EVENT_P1("MMI object ID: %d",parameter->object_id);
#endif

	if (!(View = ATB_wap_get_view(parameter->object_id)))
		return;

	/* SPR#1574 - SH - Removed parameter */
	ATB_wap_status_change(View,ATB_WAP_ONLINE_CONNECTION_CLOSED);

	return;
}


/*******************************************************************************


 $Function:    	M_WAP_MMI_READY_CNF
 
 $Description:	SPR#1569 - SH - Added this function
 				Confirm that WAP has completed the operation.
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void M_WAP_MMI_READY_CNF(T_WAP_MMI_READY_CNF *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_WAP_MMI_READY_CNF");
	TRACE_EVENT_P1("Event id = %d", parameter->event_id);
#endif

	switch (parameter->event_id)
	{
		case WAP_START_IND_ID:
			ATB_wap_start_done();
			break;
		case WAP_NEW_VIEW_IND_ID:
			ATB_wap_new_view_done();
			break;
		case WAP_CLOSE_VIEW_IND_ID:
			ATB_wap_close_view_done();
			break;
		case WAP_TERMINATE_IND_ID:
			ATB_wap_terminate_done();
			break;
#ifdef MMS_WAP_ENABLED
		/*talcon add for mms*/
		case WAP_MMSSTART_IND_ID:
			ATB_mms_start_done();
			//ATB_wap_start_done();
			break;
		case WAP_MMSTERMINATE_IND_ID:
			ATB_mms_terminate_done();
			break;
		/*end talcon add*/
#endif
	}
	return;
}


/*******************************************************************************


 $Function:    	disconnect_wap_call
 
 $Description:	Disconnect GPRS WAP call in progress.
 				SPR#1547 - SH - Added parameter 'access_type' to check if GPRS
 				is in use, rather than CSD
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void disconnect_wap_call(UBYTE access_type)
{
	UBYTE disconnected;
	T_ACI_RETURN ret;
#ifdef GPRS
	SHORT cids[MAX_CID_PLUS_EINS] = {GPRS_CID_1, INVALID_CID}; 
#endif /* GPRS */
	TRACE_FUNCTION("disconnect_wap_call()");

	disconnected = TRUE;

#ifdef GPRS
	if (access_type==WAP_GPRS_DATA)
	{
		/* Update data counter */

		sAT_PercentSNCNT(CMD_SRC_LCL, TRUE);
		/* SPR#1560 - SH - Only call sAT_H if there is an active context */
		
		/* Disconnect */

		ret = sAT_PlusCGACT(CMD_SRC_LCL, CGACT_STATE_DEACTIVATED, cids);

#ifdef TRACE_ATBWAPACI
		TRACE_EVENT_P1("Result of sAT_PlusCGACT = %d", ret);
#endif

		/* If detaching will take a little time, show a please wait dialog */

		if (ret==AT_EXCT)
		{
			disconnected = FALSE;
		}
	}
#endif /* GPRS */
	return;
}


#ifdef MMS_WAP_ENABLED
/********************mms************************
*************************************************/
/*initialize wap statck*/
void M_MMI_WAP_MMSSTART_IND(T_MMI_WAP_MMSSTART_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_MMSSTART_IND");
#endif
	
	mmi_coder(WAP_MMSSTART_IND_ID,(void*)parameter);

	return;
}


void M_MMI_WAP_MMSTERMINATE_IND(T_MMI_WAP_MMSTERMINATE_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_MMSTERMINATE_IND");
#endif

	mmi_coder(WAP_MMSTERMINATE_IND_ID,(void*)parameter);

	return;
}

/******content post**********/
/*******************************************
$Description:
	Post first content
*******************************************/
void M_MMI_WAP_POSTCONTENT_IND(T_MMI_WAP_POSTCONTENT_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_POSTCONTENT_IND");
#endif
	mmi_coder(WAP_POSTCONTENT_IND_ID,(void*)parameter);
 
	return;
} 

/*******************************************
$Description:
	post more content
*******************************************/
void M_MMI_WAP_POSTMORECONTENT_IND(T_MMI_WAP_POSTMORECONTENT_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_POSTMORECONTENT_IND");
#endif

	mmi_coder(WAP_POSTMORECONTENT_IND_ID,(void*)parameter);

	return;
}
/**************************************/

/******content get**********/
/******************************************
$Description:
	get first content
****************************************/
void M_MMI_WAP_GETCONTENT_IND(T_MMI_WAP_GETCONTENT_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_GETCONTENT_IND");
#endif
	mmi_coder(WAP_GETCONTENT_IND_ID,(void*)parameter);
 
	return;
} 

/*******************************************
$Description:
	get more content
*******************************************/
void M_MMI_WAP_ACKCONTENT_IND(T_MMI_WAP_ACKCONTENT_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_ACKCONTENT_IND");
#endif

	mmi_coder(WAP_ACKCONTENT_IND_ID,(void*)parameter);

	return;
}
/**************************************/

/*******************************************
$Description:
	post: response to post the last content
	get : response to get content
*******************************************/ 
void M_WAP_MMI_CONTENT_REQ(T_WAP_MMI_CONTENT_REQ *parameter)
{
#ifdef MMS_MESSAGE_SAR_USED
	if(parameter->data2)
	{
		parameter->data = parameter->data2;
		parameter->data_length = parameter->data_length2;
	}
#endif

#ifdef TRACE_WAP_WAPMMI
	WAP_TRACE_EVENT(("M_WAP_MMI_CONTENT_REQ: %d, %d , %d, %d, %d, %d", parameter->urlID, parameter->data_length, parameter->moreData,parameter->contentType_length,parameter->totalSize,parameter->errorNo));
	if(parameter->data)
	{
		WAP_TRACE_EVENT(("data: %02x,%02x", parameter->data[0],parameter->data[1]));
	}
#endif

	if(parameter->urlID == URLID_MMS_SEND && 
		MMS_Get_MessageType((char*)parameter->data) != MMS_MESSAGE_TYPE_SEND_CONF)
	{
		parameter->data_length = 0;
		WAP_TRACE_EVENT(("sent notires.mms"));
	}
	MMS_Content_REQ(parameter->urlID,
					   parameter->data, 
					   parameter->data_length,
					   parameter->moreData,
					   parameter->totalSize,
					   parameter->errorNo
					   );
#ifdef MMS_MESSAGE_SAR_USED
{
static int g_codememalloc = 0;
#define MMS_new(ptr, size)  		MI_ALLOC(ptr, size,g_codememalloc)
#define MMS_free(ptr,size)             MI_FREE(ptr, g_codememalloc);
	if(parameter->data2)
	{
		MMS_free(parameter->data2, parameter->data_length2);
	}
}
#endif
	return;
}


/*******************************************
$Description:
	response to post the non-last content
*******************************************/
void M_WAP_MMI_ACKPOSTCONTENT_REQ(T_WAP_MMI_ACKPOSTCONTENT_REQ *parameter)
{
#ifdef TRACE_WAP_WAPMMI
	WAP_TRACE_EVENT(("M_WAP_MMI_ACKPOSTCONTENT_REQ:%d",parameter->urlID));
#endif

	handle_mmssend(NULL);

	return;
}

/*******************************************
$Description:
	cancel content
*******************************************/
void M_MMI_WAP_CANCELCONTENT_IND(T_MMI_WAP_CANCELCONTENT_IND *parameter)
{
#ifdef TRACE_ATBWAPACI
	TRACE_FUNCTION("M_MMI_WAP_CANCELCONTENT_IND");
#endif

	mmi_coder(WAP_CANCELCONTENT_IND_ID,(void*)parameter);

	return;
}

#endif

