
/*
+-------------------------------------------------------------------+
| PROJECT: MMS               
| $Workfile: mmsagent.c
| $Author: Talcon Hu
| CREATED: 06.20.2004                 
+-------------------------------------------------------------------+
*/
#define NEW_FRAME
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else 

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif


#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#include "mfw_sys.h"
#include "p_sim.h"

#include "vsi.h"

#include "mfw_mfw.h"
#include "mfw_win.h"

#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_tim.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_cm.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_sat.h"
#include "mmiicons.h"

#include "mfw_ffs.h"

#include "wap_types.h"
#include "ATBWapACI.h"  
#include "ATBData.h"
#include "ATBWapAUI.h"
#include "AUIWap.h"

#include "mms_codec.h"
#include "mmscfg.h"
#include "manager.h"

#include "mmimmsglobaldef.h"

#include "mmimmsffs.h"

#include "MMSAgent.h"
#include "wap_interface.h"

#ifdef MMI_MMSTASK_ENABLED
#define MMS_COMPILE_FORAPP
#include "mmstask.h"
#endif


#define WAP_TRACE 1
#include "mmiutilapi.h"
#define TRACE_EVENT(f) WAP_TRACE_EVENT(("bmi--mmsagent.c<<<talcon,%s",f));
#define TRACE_FUNCTION(f) TRACE_EVENT(f)




/* mme send and queue*/
static T_MMS_WAP_DATA    *mmslist_head = 0;
/* pocess at current*/
static T_MMS_WAP_DATA    *mmslist_process = 0;

static T_MMS_PUSH_QUEUE *mmspushlist_head = 0;

//mms directory
const char MMS_DIR[]="/mms/message/";
const char MMS_SENDCONF[]="sendconf.mms";

static char  g_fullname[30];
static char g_filename[12];

/************FORCERECV*************/
/*talcon added 2004.07.15,for forcerecv*/
static char FORCERECV = 0;

#define MMS_RANDOM_MIN     10000
#define MMS_RANDOM_MAX    99999

/*talcon add, 2004.07.07 */ 
static int g_codememalloc = 0;
#if 1
#define MMS_new(ptr, size)  		MI_ALLOC(ptr, size,g_codememalloc)
#define MMS_free(ptr,size)     \
	MI_FREE(ptr, g_codememalloc);\
	WAP_TRACE_EVENT(("hyl,mmsagent.c--MMS_free"))
#else
#define MMS_new(ptr, size)  \
	ptr = (void *)mfwAlloc(size);\
	if(ptr ==0)\
		g_codememalloc  = 1;\
	else\
		g_codememalloc  = 0;
#define MMS_free(ptr,size)      			mfwFree((U8*)ptr, size)
#endif


UBYTE MMS_Get_MessageType(char *data)
{
	if(data[0] !=0x8c)
		return 0xff;
	return data[1];
}


int mms_check_status()
{
	if(ATB_wap_get_view(0))
		return 1;
	return 0;	
}
/************************push queue operate************/

T_MMS_PUSH_QUEUE * mmspushlist_wait = 0;
void checkrecv_push_queue()
{
	T_MMS_PUSH_QUEUE *p1 = mmspushlist_head;
	T_MMS_PUSH_QUEUE *p2 = mmspushlist_head;
	while(p1)
	{
		if(p1->type = MMS_PQ_TYPE_FILE && isMMSQueueEmpty(p1->filename) )
		{
			if(p1 == mmspushlist_head)
			{
				mmspushlist_head = p1->next;
			}
			p2 = p1->next;
			
			MMS_free(p1);
			if(mmspushlist_head == 0)
				break;
			p1 = p2;
		}
		else
		{
			WAP_TRACE_EVENT((p1->filename));
			p1 = p1->next;
		}

	}
}
T_MMS_PUSH_QUEUE * handle_push_queue()
{
	TRACE_FUNCTION("handle_push_queue"); 
	if(mmspushlist_head && mmspushlist_wait==0 )
	{

		mmspushlist_wait = mmspushlist_head;
		WAP_TRACE_EVENT(("handle_push_queue-%s",mmspushlist_head->filename));
		remove_pushlist(mmspushlist_head);
		wap_mms_evt_cb(
				NET_PUSH_IND,
				MMI_MMS_SUCCESS,
				mmspushlist_wait->filename  //ֻļ·
				);
		if(mmspushlist_wait)
		{
			if(mmspushlist_wait->type == MMS_PQ_TYPE_DLVRYIND)
#ifndef MMS_WAP_TEST
			{/*remove deli ind*/
				sprintf(g_fullname,"%s%s",MMS_DIR,mmspushlist_wait->filename);
				ffs_remove(g_fullname);
			}
#endif
			MMS_free(mmspushlist_wait);
			mmspushlist_wait = 0;
		}
			
	}

	TRACE_EVENT("end handle_push_queue");
	return mmspushlist_head;
}
T_MMS_PUSH_QUEUE * append_pushlist(T_MMS_PUSH_QUEUE * data)
{
	TRACE_FUNCTION("append_pushlist");
	if(mmspushlist_head == 0)
	{
		mmspushlist_head = data;
	}
	else
	{
		T_MMS_PUSH_QUEUE *p1 = mmspushlist_head;
		while(p1->next)
			p1  = p1->next;
		p1->next = data;
	}
	return data;
}//

T_MMS_PUSH_QUEUE * append_pushlist_byfile(char * filename,BYTE type)
{
	T_MMS_PUSH_QUEUE* p;
	TRACE_FUNCTION("append_pushlist_byfile");
	
	MMS_new(p,sizeof(T_MMS_PUSH_QUEUE));

	memset(p, 0 , sizeof(T_MMS_PUSH_QUEUE) );
	memcpy(p->filename, filename, strlen(filename) );
	p->type = type;
	return append_pushlist(p);
}

/*************************************************
$Description:
	remove mms push queue by data
$argument
	@return: data returned if data is in queue,otherwise 0 returned
****************************************************/
T_MMS_PUSH_QUEUE *remove_pushlist(T_MMS_PUSH_QUEUE *data)
{
	T_MMS_PUSH_QUEUE *p1 = mmspushlist_head;

	TRACE_FUNCTION("remove_pushlist");
	if(data == 0)
		return data;
	
	if(data == mmspushlist_head)
	{
		mmspushlist_head = mmspushlist_head->next;
	}
	
	else
	{
		while(p1)
		{
			if(p1->next == data)
			{
				p1->next = data->next;
				break;
			}
			p1 = p1->next;
		}
	}
	//MMS_free(data, sizeof(T_MMS_PUSH_QUEUE));
	
	return  data;
}

/*************************************************
$Description:
	get mms push queue head 
****************************************************/
T_MMS_PUSH_QUEUE *get_pushlist_head()
{
	TRACE_FUNCTION("get_mmslist_head");
	
	return mmspushlist_head;
}


/*****************************************************/



/*************************************************
$Description:
	determine if mms queu is empty
****************************************************/
BOOL isMMSQueueEmpty()
{
	TRACE_FUNCTION("isMMSQueueEmpty");
	return mmslist_head == 0 ;
}

/*void set_mmslist_process(T_MMS_WAP_DATA *data)
{
	TRACE_FUNCTION("set_mmslist_process");
	mmslist_process = data;
}*/
/*************************************************
$Description:
	append mms queue 
****************************************************/
T_MMS_WAP_DATA *append_mmslist(T_MMS_WAP_DATA *data)
{
	TRACE_FUNCTION("append_mmslist");
	if(mmslist_head == 0)
	{
		mmslist_head = data;
	}
	else
	{
		T_MMS_WAP_DATA *p1 = mmslist_head;
		while(p1->next)
			p1  = p1->next;
		p1->next = data;
	}
	return data;
}

/*************************************************
$Description:
	remove mms queue 
$argument
	@return: data returned if data is in queue,otherwise 0 returned
****************************************************/
T_MMS_WAP_DATA *remove_mmslist(T_MMS_WAP_DATA *data)
{
	T_MMS_WAP_DATA *p1 = mmslist_head;

	TRACE_FUNCTION("remove_mmslist");
	if(data == mmslist_head)
	{
		mmslist_head = mmslist_head->next;
		return data;
	}
	
	while(p1)
	{
		if(p1->next == data)
		{
			p1->next = data->next;
			break;
		}
		p1 = p1->next;
	}
	
	return  p1->next;
}

/*************************************************
$Description:
	get mms queue head by type
****************************************************/
T_MMS_WAP_DATA *get_mmslist_head(UBYTE type)
{
	TRACE_FUNCTION("get_mmslist_head");
	switch(type)
	{
	case MMS_TYPE_SEND:
		return mmslist_head;
	case MMS_TYPE_RECV:
		return mmslist_head;
	}
	return mmslist_head;
}



/****************************************
$Description:
	create a mmssend by filename and mmsaddr, then append to sned queue
************************************************/
T_MMS_WAP_DATA*  mms_sendnew(char *filename, char *mmscaddr)
{
	T_MMS_WAP_DATA* mmssend ;
	TRACE_FUNCTION("mms_sendnew");
	
	MMS_new(mmssend, sizeof(T_MMS_WAP_DATA));

	if(mmssend ==0)return mmssend;

	mmssend->status = MMS_WAP_NOSTATUS;
		
	mmssend->type = MMS_TYPE_SEND;
	mmssend->urlID = URLID_MMS_SEND;

	mmssend->fp = 0;
	
	memcpy(mmssend->filename,filename,strlen(filename) + 1);
	memcpy(mmssend->pubbuff.mmscaddr , mmscaddr, strlen(mmscaddr) + 1);

	mmssend->next = 0;

	append_mmslist(mmssend);
	
	return mmssend;
}

/*************************************************
$Description:
	remove a send quest from send  queue
****************************************************/
void mms_senddelete(T_MMS_WAP_DATA* data)
{
	TRACE_EVENT("mms_senddelete");
	handle_mms_queue_end();
}

//static const char mmscaddr[] = "http://mmsc.monternet.com";
static const char acceptHeader[] = "application/vnd.wap.mms-message" ;
static const char ContentType[] = "application/vnd.wap.mms-message" ;

/*************************************************
$Description:
	create a mms receive quest
****************************************************/
void handle_mmssend(T_MMS_WAP_DATA* data)
{

	//SHORT data_length ; Robert.Chen
	U32	 data_length;
	char *buffer;
	BOOL first;
	BOOL moreData;

	TRACE_FUNCTION("handle_mmssend");
		
	if(data == 0)
	{
		if(mmslist_process == 0)
		{
			TRACE_EVENT("handle_mmssend--exit because mmslist_process is null");
			return;
		}	
		data = mmslist_process;
	}
	
	if(data->fp <=0)/*first*/
	{
		struct stat_s stat;

		sprintf(g_fullname,"%s%s",MMS_DIR,data->filename);

		TRACE_EVENT(data->filename);
		
		if(ffs_stat(g_fullname, &stat) != EFFS_OK)
		{
			TRACE_EVENT("find file error");
			handle_mms_queue_end();
			return ;	
		}
		data->sizeUsed = 0;
		data->sizeTotal = stat.size;
		
		data->fp    = ffs_open(g_fullname, FFS_O_RDONLY);
		if(data->fp    <=0 )
		{
			TRACE_EVENT("open file error");
			handle_mms_queue_end();
			return;
		}
		first = TRUE;
		data_length = MMS_MESSAGE_FIRSTGROUP_SIZE;
	}
	else 
	{
		first = FALSE;
		data_length = MMS_MESSAGE_GROUP_SIZE;
	}
	if(data_length > data->sizeTotal  - data->sizeUsed)
		data_length = data->sizeTotal  - data->sizeUsed;
	 
	MMS_new(buffer,data_length);

	ffs_read(data->fp, buffer,  data_length);
	data->sizeUsed += data_length;

	WAP_TRACE_EVENT(("%d, %d, %d",data_length,data->sizeUsed,data->sizeTotal));
	//WAP_TRACE_EVENT(("%02x %02x %02x %02x",buffer[0],buffer[1],buffer[2],buffer[3]));
	
	if( data->sizeUsed == data->sizeTotal)
	{
		moreData = FALSE;//FALSE
	}
	else
	{
		moreData = TRUE;  
	}


	if(first)
	{ 
		T_MMI_WAP_POSTCONTENT_IND parameter;
		parameter.moreData = moreData;
		parameter.urlID = data->urlID;
		parameter.addr_length= strlen(data->pubbuff.mmscaddr)+1;
		parameter.addr = (char *)data->pubbuff.mmscaddr;
		parameter.reload = TRUE;						//reload
		parameter.acceptHeader = (char *)acceptHeader;
		parameter.acceptHeader_length = strlen(acceptHeader )+1;
		parameter.data = buffer;
		parameter.data_length = data_length;
		parameter.contentType = (char *)ContentType;
		parameter.contentType_length = strlen(ContentType) + 1;
		parameter.sendMode = 3;//SENDMODE_BINARY;
		parameter.contentDisp = 0;
		parameter.contentDisp_length = 0;
		parameter.totalSize = data->sizeTotal;
  
		ATB_wap_content_post(&parameter);
	}
	else
	{
		T_MMI_WAP_POSTMORECONTENT_IND parameter;
		parameter.moreData = moreData;
		parameter.urlID = data->urlID;
		parameter.data = buffer;
		parameter.data_length = data_length;
		
		ATB_wap_morecontent_post(&parameter);
	}

	MMS_free(buffer, data_length);
}


/*************************************************
$Description:
	determine if mms queu is empty
****************************************************/
T_MMS_WAP_DATA*  mms_recvnew(char *filename, char *url)
{
	T_MMS_WAP_DATA* mmsrecv ;
	TRACE_FUNCTION("mms_recvnew:");
	TRACE_FUNCTION(filename);
	TRACE_FUNCTION(url);
	
	MMS_new(mmsrecv,sizeof(T_MMS_WAP_DATA));

	if(mmsrecv ==0)return 0;

	mmsrecv->status = MMS_WAP_NOSTATUS;
	
	mmsrecv->type = MMS_TYPE_RECV;
	mmsrecv->urlID = URLID_MMS_RECV;

	mmsrecv->fp = 0;
	
	{
		char *p = strrchr(filename,'/' );
		p ++;
		//memcpy(mmsrecv->filename,filename,strlen(filename) + 1);
		sprintf(mmsrecv->filename,"%s%s",MMS_DIR,p);
	}
	memcpy(mmsrecv->pubbuff.url , url, strlen(url) + 1);

	mmsrecv->next = 0;
	
	append_mmslist(mmsrecv);
	
	return mmsrecv;
}


void mms_recvdelete(T_MMS_WAP_DATA* data)
{
	TRACE_FUNCTION("mms_recvdelete");
	
	handle_mms_queue_end();
	
}


void handle_mmsrecv(T_MMS_WAP_DATA* data, T_WAP_MMI_CONTENT_REQ *parameter)
{


	TRACE_FUNCTION("handle_mmsrecv");
		
	if(data == 0)
	{
		if(mmslist_process == 0)
		{	
			TRACE_FUNCTION("handle_mmsrecv error--data is null");
			return;
		}	
		data = mmslist_process;
	}
	
	if(data->fp <=0 && parameter == 0)/*first*/
	{
		T_MMI_WAP_GETCONTENT_IND parameter2;
		data->sizeUsed = 0;
		data->sizeTotal = 0;
		
		data->fp    = ffs_open(data->filename, FFS_O_CREATE |FFS_O_WRONLY );
		if(data->fp    <=0 )
		{
			WAP_TRACE_EVENT(("open file error---%s", data->filename));
			handle_mms_queue_end();
			return;
		}

		parameter2.urlID = data->urlID;
		parameter2.reload = TRUE;
		parameter2.addr = data->pubbuff.url;
		parameter2.addr_length = strlen(parameter2.addr);
		parameter2.acceptHeader = (char *)acceptHeader;
		parameter2.acceptHeader_length = strlen(parameter2.acceptHeader);
		
		M_MMI_WAP_GETCONTENT_IND(&parameter2);
	}
	else  if(parameter)
	{
		if(parameter->data == NULL)
		{//error
			TRACE_EVENT("handle_mmsrecv error-no data");
			handle_mms_queue_end();
			return ;
		}
		if(data->sizeTotal ==0)
			data->sizeTotal = parameter->totalSize;
		data->sizeUsed += parameter->data_length;
		ffs_write(data->fp, parameter->data, parameter->data_length);
		WAP_TRACE_EVENT(("hyl,handle_mmsrecv %d Bytes", data->sizeUsed));
		if(parameter->moreData)
		{
			T_MMI_WAP_ACKCONTENT_IND parameter2;
			parameter2.urlID = data->urlID;
			M_MMI_WAP_ACKCONTENT_IND(&parameter2);
		}
		else
		{
			ffs_close(data->fp);
			data->fp = 0;
			TRACE_EVENT("handle_mmsrecv finished");
			//handle_mms_queue_end();
			//notify get complete
			return;
		}	
	}
	else
	{
		TRACE_FUNCTION("handle_mmsrecv error--parameter is null");
	}
	
}

/*****************************************
$Description:
	
*********************************************/
void handle_mms_queue_begin()
{

	TRACE_FUNCTION("handle_mms_queue_begin");
	if(mmslist_head == 0)
	{
		WAP_TRACE_EVENT(("Error, mmslist_head is null"));
		//MMS_WAP_Close();
		return;
	}
	if(mmslist_process !=0)/*process has begined,return*/
	{
		WAP_TRACE_EVENT(("Error, process has begined "));
		return;
	}
	mmslist_process = mmslist_head;
	switch(mmslist_head->type)
	{
	case MMS_TYPE_SEND:
		mmslist_process->status = MMS_WAP_SENDING;
		handle_mmssend(mmslist_process );
		break;
	case MMS_TYPE_RECV:
		mmslist_process->status = MMS_WAP_RECVING;
		handle_mmsrecv(mmslist_process , NULL);
		break;
	}
}

/*****************************************
$Description:
	
*********************************************/
void handle_mms_queue_end()
{

	TRACE_FUNCTION("handle_mms_queue_end");

	if(mmslist_process == 0)
	{
		TRACE_EVENT("handle_mms_queue_end-error");
		return;

	}
	
	remove_mmslist(mmslist_process);
	
	if(mmslist_process->fp >0)
	{
		ffs_close(mmslist_process->fp);
	}
	MMS_free(mmslist_process, sizeof(T_MMS_WAP_DATA) );

	mmslist_process = 0 ;
}

/*****************************************
$Description:
	
*********************************************/
void handle_mms_queue_err(SHORT errorCode)
{

	TRACE_FUNCTION("handle_mms_queue_err");


	switch(mmslist_process->urlID)
	{
	case URLID_MMS_RECV:
		strcpy(g_filename,get_mmslist_head(MMS_TYPE_RECV)->filename);
		handle_mms_queue_end();
		wap_mms_evt_cb(
					     NET_GET_CONTENT_IND,
					     MMI_MMS_FAILED, 
					     g_filename
					     );
		break;
	case URLID_MMS_SEND:
		handle_mms_queue_end();
		//here reprot a error to mms
		wap_mms_evt_cb(
					     NET_POST_CNF,
					     MMI_MMS_FAILED, 
					     NULL
					     );
		break;

	}

}


/*****************************************
$Description:
	encapsulate WAP_MMS_EVENT and call MMS_NET_EVENT_HANDLE
$Argument
	@type: MMS_WAP_EVENT_TYPE
	@status:MMI_MMS_EVENT_STATUS
	@filename
*********************************************/
void wap_mms_evt_cb(
			UBYTE    type, 
			UBYTE    status, 
			char *    filename 
			)
{
	pWAP_MMS_EVENT evt;
 

	TRACE_FUNCTION("wap_mms_evt_cb()");

 	/*initialize manager and codec*/
	MI_manager_on_initialize(MANAGER_MASK_MMSAGT);
	/*{
		extern T_MMS_NET_SETTINGS mmsSettings;
		manager_set_autorecv(mmsSettings.allSettings[mmsSettings.curSettingsIndex].recvSettings.stateAutoRecv);
	}*/
  	WAP_TRACE_EVENT(("type:%d, status:%d",type,status));
	WAP_DELAY(30);
	 
	MMS_new(evt, sizeof(WAP_MMS_EVENT));
	if(!evt)
	{
		TRACE_FUNCTION("memory alloc error");
		return;
	}
	
#if 0	
	MmsBusy = TRUE; 
#endif	
	evt->type = type;
	switch(type)
	{
	case NET_ERROR:
		TRACE_FUNCTION("NET_ERROR");
		
		MMS_NET_EVENT_HANDLE(evt);
		break;
		
	case NET_CONFIGURE_CNF:
		TRACE_EVENT("NET_CONFIGURE_CNF");
		MMS_new(evt->data.pconfiguredata, sizeof(CONFIGURE_CNF_DATA));
		evt->data.pconfiguredata->status = status;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pconfiguredata, sizeof(CONFIGURE_CNF_DATA));
		break;
		
	case NET_CLOSE_CNF:
		TRACE_EVENT("NET_CLOSE_CNF");
		MMS_new(evt->data.pclosedata,sizeof(CLOSE_CNF_DATA));
		evt->data.pclosedata->status = status;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pclosedata, sizeof(CLOSE_CNF_DATA));
#if 0
		RcvFromMenu = FALSE;
#endif
		break;
		
	case NET_CANCEL_CNF:
		TRACE_EVENT("NET_CANCEL_CNF");
		MMS_new(evt->data.pcanceldata,sizeof(CANCEL_CNF_DATA));
		evt->data.pcanceldata->status = status;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pcanceldata, sizeof(CANCEL_CNF_DATA));
#if 0
		RcvFromMenu = FALSE;
#endif
		break;
		
	case NET_POST_CNF:
		TRACE_EVENT("NET_POST_CNF");
		
		MMS_new(evt->data.ppostdata,sizeof(POST_CNF_DATA));
		evt->data.ppostdata->status = status;
		evt->data.ppostdata->filename = filename;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.ppostdata, sizeof(POST_CNF_DATA));
		break;
		
	case NET_GET_CONTENT_IND:
		MMS_TRACE_EVENT(("NET_GET_CONTENT_IND,file: %s",filename));
		MMS_new(evt->data.pgetdata,sizeof(GET_CONTENT_IND_DATA));
		evt->data.pgetdata->status = status;
		evt->data.pgetdata->filename = filename;

		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.pgetdata,sizeof(GET_CONTENT_IND_DATA));

		break;
		
	case NET_PUSH_IND:
		TRACE_EVENT("NET_PUSH_IND");
#if 0
		if(mmspushlist_wait && mmspushlist_wait->type == MMS_PQ_TYPE_FILE&&isPushInRecvFolder(filename))
		{/*is in recv folder,ingore it*/
			WAP_TRACE_EVENT(("push file is in recv folder-%s",filename));
			//MMS_free(mmspushlist_wait );
			 //mmspushlist_wait = 0;
			 mmspushlist_wait->type == MMS_PQ_TYPE_DLVRYIND;
			 break;
		}
#endif
		MMS_new(evt->data.ppushdata,sizeof(PUSH_IND_DATA));
		evt->data.ppushdata->status = status;
		evt->data.ppushdata->filename= filename;
		evt->data.ppushdata->forcerecv = FORCERECV;
		
		MMS_NET_EVENT_HANDLE(evt);
		MMS_free(evt->data.ppushdata, sizeof(PUSH_IND_DATA));
		break;
		
	default:
		TRACE_FUNCTION("default");
		break;
	}

	MMS_free(evt, sizeof(WAP_MMS_EVENT));
	WAP_TRACE_EVENT(("end wap_mms_evt_cb"));
	WAP_DELAY(30);
}

/************************************
$Description:
	force recv mms for delag recv
*****************************************/
void MMS_Force_Recv(char* filename)
{
	FORCERECV = 1;
	wap_mms_evt_cb(NET_PUSH_IND,MMI_MMS_SUCCESS,filename);
	FORCERECV = 0;
}

/*****************************************
$Description:
	handle repuest from CLNTa_Content(send cnf and receive acknowledge)
	handle mms push message
	handle mms delivery ind
*********************************************/
void MMS_Content_REQ(
						UBYTE urlID,
						char *data,
						ULONG data_length,
						BOOL moreData,
						ULONG totalSize,
						SHORT errorNo)
{
	static BYTE wait_urlID = 0;
	static UBYTE MessageType = 0;
	static ULONG totalsize = 0;
	TRACE_FUNCTION("MMS_Content_REQ");
	
	if (!data)
	{
		TRACE_FUNCTION("Content REQ wap data error");
		//total_size = 0;
		return;
	}
	
	if(errorNo != 0)//a error occur
	/*4001,ERR_WTP_ErrorNORESPONSE*/
	{
		WAP_TRACE_EVENT(("MMS_Content_REQ-errorNo: %d",errorNo ));
		/*determine error type, assign to send or receive */
		switch(urlID)
		{
			case URLID_MMS_RECV:
				//here reprot a error to mmi
				switch(errorNo)
				{
					case 0x09:/*ERR_WTP_MESSAGETOOLARGE
								Due to a message size bigger than the capabilities of the receiver the transaction cannot be completed.*/
						WAP_TRACE_EVENT(("recv error,message too large!"));
						break;
					case  0x44:/*HTTPFileNotFound*/
						break;
					case 0x48:
						break;/*HTTPRequestTimeout*/
					default:
						break;
				}
				strcpy(g_filename,get_mmslist_head(MMS_TYPE_RECV)->filename);

				handle_mms_queue_end();

				wap_mms_evt_cb(
					     NET_GET_CONTENT_IND,
					     MMI_MMS_FAILED, 
					     g_filename
					     );
				//WAP_TRACE_EVENT(("mms recv error ,remove %s",g_filename ));
				//ffs_remove(g_filename);
				break;
			case URLID_MMS_SEND:
				handle_mms_queue_end();
				//here reprot a error to mms
				 wap_mms_evt_cb(
					     NET_POST_CNF,
					     MMI_MMS_FAILED, 
					     NULL
					     );

				break;
		}
		return;
	}

	 
	if(data_length == 0)
	{/*notifi.res*/

		   if(urlID == URLID_MMS_SEND)
		   {
	   		    TRACE_FUNCTION("Rcv Packet: send success, data=Null");
			    handle_mms_queue_end();
			   // set_mmslist_process(NULL);
			    wap_mms_evt_cb(
			    NET_POST_CNF,
			    MMI_MMS_SUCCESS, 
			    NULL
			    );
		   }
		  
 
	}
	else/*push,delivery ind,receive acknownledge*/
	{
		
		
		//if(total_size == 0)
		if(urlID != wait_urlID || totalsize == 0)   //ݻ
		{
			MessageType = MMS_Get_MessageType((char*)data);
		}
		WAP_TRACE_EVENT(("MessageType:%d",MessageType));

		switch(MessageType)
		{
		case MMS_MESSAGE_TYPE_SEND_CONF://send finished,call by M_WAP_MMI_CONTENT_REQ 
		{
			TRACE_EVENT("MMS_MESSAGE_TYPE_SEND_CONF");

			handle_mms_queue_end();
			
			sprintf(g_fullname, "%s%s", MMS_DIR, MMS_SENDCONF);
			ffs_remove(g_fullname);
			ffs_file_write((const char *)g_fullname, data, data_length, FFS_O_TRUNC|FFS_O_CREATE);
			wap_mms_evt_cb(
				NET_POST_CNF,
				MMI_MMS_SUCCESS,
				(char *)MMS_SENDCONF
				);
			break;
			
		}
		case MMS_MESSAGE_TYPE_DELIVERY_IND://push message 
		{
			char  filename[15];
			
			TRACE_EVENT("MMS_MESSAGE_TYPE_DELIVERY_IND");

			MMS_CreatePushfilename(filename, g_fullname,TRUE);
			
			TRACE_EVENT(filename);
	
			ffs_file_write((const char *)g_fullname, data, data_length, FFS_O_TRUNC|FFS_O_CREATE);
			// æʱеȴ
			//if(AUI_check_mms_status())
			if(get_mmslist_head(0))
			{
				T_MMS_PUSH_QUEUE * NewPush = NULL;
				MMS_new(NewPush , sizeof(T_MMS_PUSH_QUEUE));
				
				strcpy(NewPush->filename, filename);
				NewPush->type = MMS_PQ_TYPE_DLVRYIND;//is a delivery.ind
				NewPush->next = NULL;
				append_pushlist(NewPush);
				return;
				
			}
			#if 0
			AutoRcv_status = TRUE;  // 2004/3/9
			#endif
			//mmspushlist_wait = 0;
			wap_mms_evt_cb(
				NET_PUSH_IND,
				MMI_MMS_SUCCESS,
				filename
				);
			break;
			
		}
		case MMS_MESSAGE_TYPE_NOTIFICATION_IND://MMS_MESSAGE_TYPE_NOTIFICATION_IND
		{
			char  filename[15];
			//char  g_fullname[30];
			int    temp;
			
			TRACE_EVENT("MMS_MESSAGE_TYPE_NOTIFICATION_IND");

			MMS_CreatePushfilename(filename, g_fullname,FALSE);	
			TRACE_EVENT(g_fullname);
			
			ffs_file_write((const char *)g_fullname, data, data_length, FFS_O_TRUNC|FFS_O_CREATE);

			// æʱеȴ
			if(get_mmslist_head(0))
			{
				T_MMS_PUSH_QUEUE * NewPush = NULL;
				MMS_new(NewPush , sizeof(T_MMS_PUSH_QUEUE));
				
				strcpy(NewPush->filename, filename);
				NewPush->type = MMS_PQ_TYPE_NOTI;//is a notification.ind
				NewPush->next = NULL;
				append_pushlist(NewPush);
				return;
				
			}
		#if 0	
			AutoRcv_status = TRUE;  //2004/3/9
	#endif
			//mmspushlist_wait = 0;
			wap_mms_evt_cb(
				NET_PUSH_IND,
				MMI_MMS_SUCCESS,
				filename  //ֻļ·
				);
			break;
			
		}
		case MMS_MESSAGE_TYPE_RETRIVE_CONF://receive,call by M_WAP_MMI_CONTENT_REQ
		{			
			T_WAP_MMI_CONTENT_REQ parameter;
			parameter.urlID = urlID;
			parameter.data = data;
			parameter.data_length = data_length;
			parameter.moreData = moreData;
			parameter.totalSize = totalSize;
			parameter. errorNo= errorNo;
			TRACE_EVENT("MMS_MESSAGE_TYPE_RETRIVE_CONF");
			
			handle_mmsrecv(get_mmslist_head(MMS_TYPE_RECV), &parameter);
			if(!moreData)
			{
					strcpy(g_filename,&get_mmslist_head(MMS_TYPE_RECV)->filename[13]);

					WAP_TRACE_EVENT(("recv file:%s", g_filename));
					handle_mms_queue_end();
					
					wap_mms_evt_cb(
						NET_GET_CONTENT_IND, 
						MMI_MMS_SUCCESS,
						g_filename/* ֻļ·*/
						);		
			} 
			break;
		}
		default:
			break;
  	}
 }
 
 
 if(urlID == wait_urlID || wait_urlID == 0)
 {
	 if(moreData)
	 {
		 totalsize += data_length;
		 wait_urlID = urlID;
	 }
	 else
	 {
		 wait_urlID = 0;
		 totalsize = 0;
	 }
 }
 
 return;
}


/***************push file manage*********/

/**************************************
$Descritpion:
	ʼʱȡĿ¼/mmi/mmsµļ%06u.mms
*****************************************/
const char mmspushfile[] = "/mms/push.txt";
#define MMS_PUSHFILE_LEN 	sizeof(T_MMS_PUSH_QUEUE)
#define MMS_FUSHFILE_TEST

BOOL isPushInRecvFolder(char *filename)
{
	P_MMS mms = getMMS();
	pMessage message;
	TRACE_FUNCTION("isInRecvFolder");
	message = mms->manager->receivefolder->root;
	while(message)
	{
		if(strcmp(filename,message->filename) ==0)
			return TRUE;
		message = message->next;
	}
	return FALSE;
}
void mms_pushfile_init()
{
	T_FFS_DIR ffs_dir;
	T_FFS_SIZE ffs_size;
	T_FFS_STAT stat;
	
	char filename[15];

	T_MMS_PUSH_QUEUE * p ;

	TRACE_FUNCTION("mms_pushfile_init");
	//mmspushlist_head = 0;
	//return;
#ifdef MMS_FUSHFILE_TEST
	if(ffs_stat(mmspushfile, &stat) <0)/*ػ*/
	{	
#endif
		ffs_size = ffs_opendir ("/mms/message",&ffs_dir);

		if(ffs_size <=0)return;
		
		p = mmspushlist_head;
		while(ffs_readdir(&ffs_dir , filename , sizeof(filename) ) >0)
		{
			WAP_TRACE_EVENT(("filename:%s",filename));
			
			if( ( filename[0]!= 'd' && filename[0]!= 'p') || strcmp(&filename[6],".mms") !=0)
				continue;
			WAP_TRACE_EVENT(("%s", filename));
			
			if( filename[0] == 'd')
			{

				char fullname[30];
				sprintf(fullname,"/mms/message/%s",filename);
				WAP_TRACE_EVENT(("remove filename:%s",filename));
				ffs_remove(fullname);
			}
			else
			{	
				append_pushlist_byfile(filename, MMS_PQ_TYPE_FILE );
				WAP_TRACE_EVENT(("add filename:%s",filename));
			}
		}
#ifdef MMS_FUSHFILE_TEST
	}
	else
	{
		T_MMS_PUSH_QUEUE push ;
		int fp    = ffs_open(mmspushfile, FFS_O_RDONLY);
		if(fp    <=0 )
		{
			TRACE_EVENT("open file error--/mms/push.txt");
			return;
		}

		
		while(MMS_PUSHFILE_LEN ==ffs_read(fp, &push, MMS_PUSHFILE_LEN ))
		{
			WAP_TRACE_EVENT((push.filename));
			append_pushlist_byfile(push.filename,push.type);
			WAP_TRACE_EVENT((push.filename));
		}
		
		ffs_close(fp);
		ffs_remove(mmspushfile);
	}
#endif

	
	//handle_push_queue();
	if(mmspushlist_head)
	{
#ifdef MMI_MMSTASK_ENABLED	
		T_MMI_MMS_MIMNGRINIT_IND  parameter;
		parameter.mask = MANAGER_MASK_MMSAGT;
		M_MMI_MMS_MIMNGRINIT_IND(  &parameter);
#else
		MI_manager_on_initialize(MANAGER_MASK_MMSAGT);
#endif
	}

}

void mms_pushfile_exit()
{
	
	T_MMS_PUSH_QUEUE * p ;
#ifdef MMS_FUSHFILE_TEST
	int fp = ffs_open(mmspushfile,  FFS_O_CREATE |FFS_O_WRONLY);;
#endif
	TRACE_FUNCTION("mms_pushfile_exit");
	
	p = mmspushlist_head;
	while(p)
	{
		if(p->type == MMS_PQ_TYPE_DLVRYIND)
		{
			sprintf(g_fullname, "%s%s", MMS_DIR, p->filename);
			ffs_remove(g_fullname);
			WAP_TRACE_EVENT(("MMS_PQ_TYPE_DLVRYIND: %s", p->filename));
			continue;
		}
#ifdef MMS_FUSHFILE_TEST
		if(fp > 0)
		{
			WAP_TRACE_EVENT(("save push: %s", p->filename));
			ffs_write(fp, p, MMS_PUSHFILE_LEN );
		}
		
#endif
		p = p->next;
	}
#ifdef MMS_FUSHFILE_TEST
	if(fp>0)
		ffs_close(fp);
#endif
}
/***********end push file manage*********/

/**************************************
MMS_Random
********************************************/
int MMS_Random(int min,int max)
{
	return rand()%(max-min) + min;
}

/*******************************************
$Descrition:
	vreate a new push file name
***********************************************/
void MMS_CreatePushfilename(char * filename, char* fullname,BOOL isDelivery)
{
	T_FFS_RET  result;
	T_FFS_STAT stat;
	
	TRACE_EVENT("MMS_CreatePushfilename");

	do
	{
		if(isDelivery)
			sprintf(filename, "d%05u.mms", MMS_Random(MMS_RANDOM_MIN, MMS_RANDOM_MAX));
		else
			sprintf(filename, "p%05u.mms", MMS_Random(MMS_RANDOM_MIN, MMS_RANDOM_MAX));
		sprintf(fullname, "%s%s", MMS_DIR, filename);
	}while(ffs_stat((const char *)fullname, &stat) == EFFS_OK);

	WAP_TRACE_EVENT((fullname));
			
}

#if 0
void DumpCurrentStack()
{

	extern LONG os_TaskInformation ( USHORT Index, char *Buffer);
	extern int os_MyHandle ( void );
	static char buffer[124];
	os_TaskInformation(os_MyHandle(),buffer);
	WAP_TRACE_EVENT(("***hyl,%s",buffer));
}

void MI_dump_partitioninfo()
{
 
#include "glob_defs.h"
#define         NU_PARTITION_POOL_SIZE          15
#define         NU_TASK_SIZE                    42
typedef unsigned long           UNSIGNED;
   typedef unsigned short  USHORT;
 
typedef struct NU_PARTITION_POOL_STRUCT
{
    UNSIGNED       words[NU_PARTITION_POOL_SIZE];
} NU_PARTITION_POOL;
 
typedef struct NU_TASK_STRUCT
{
    UNSIGNED      words[NU_TASK_SIZE];
} NU_TASK;
 
typedef struct
{
  ULONG            Size;                   /* partition size */
  NU_PARTITION_POOL *PoolCB;                   /* pointer to control block of the pool */ 
} T_PARTITION_POOL_TABLE;
 
typedef struct
{
  char                Name [ RESOURCE_NAMELEN ];      /* name of the partition pool group */
  T_PARTITION_POOL_TABLE Pools [ MAX_POOLS_PER_GROUP ];  /* table of pools in this group */
} T_PARTITION_GROUP_TABLE;
extern T_PARTITION_GROUP_TABLE PartitionGroupTable [ MAX_POOL_GROUPS+1 ];  
 static char buffer[80];
 char Name[ RESOURCE_NAMELEN ];
 
 ULONG PoolSize,PartitionSize,Available,Waiting, Allocated;
 void *pStartAddress;
 NU_TASK *First;
 USHORT Group, Pool;
 unsigned char SuspendType;
 
 for(Group= 0; Group<= MAX_POOL_GROUPS; Group++)
 {
  for(Pool = 0; Pool < MAX_POOLS_PER_GROUP; Pool++)
  {
   if ( PMF_Partition_Pool_Information ( PartitionGroupTable[Group].Pools[Pool].PoolCB, Name, 
                                        &pStartAddress, &PoolSize, &PartitionSize, &Available, 
                                        &Allocated, &SuspendType, &Waiting, &First ) == 0 )
     {
        sprintf (buffer, "Name:%s Addr:%lx PoolSize:%ld PartSize:%ld Free:%ld Used:%ld",
                 Name, (ULONG)pStartAddress, PoolSize, PartitionSize, Available, Allocated );                  
        WAP_TRACE_EVENT((buffer));  
     }
  }
 }
}

#endif

