#$history#	
#
#	2004-07-05 Talcon Hu created for wap-mms integration
#
#

include $(CONDAT_BASE_DIR)/condat_lib_ip.mak
OBJ := $(SRCWAPMMI)/obj$(LMSZ)
#
# Settings for the compilation process
# depending whether traces will be compressed or not
#
ifeq ($(CTRACE), 0)
# without str2ind - compilation only
PRE := $(CC) -c
INT := @echo OLD STYLE TRACES - the following file will not be build:
COM := @echo OLD STYLE TRACES - the following file will not be build:
else
# with str2ind - preprocessing, str2ind, compilation
PRE := $(CC) -po -p?
INT := str2ind -a -l $(STR2IND_LOG) -t $(STR2IND_TAB) -v $(STR2IND_C) -f
COM := $(CC) -c
endif

SRCWAP=$(CONDAT_DIR)/ms/src/wapaus

INC_MISC	= -I$(TOP_DIR)/$(SYSTEM_DIR)/main  -I$(TOP_DIR)/$(SYSTEM_DIR)/config -I$(TOP_DIR)/../services/audio
INC_RIV		= -I$(TOP_DIR)/$(RIVIERA_DIR)/rv -I$(TOP_DIR)/$(RIVIERA_DIR)/rvf
INC_CONDAT	= -I$(SRCMFW) -I$(SRCACI) -I$(SRCKSD) -I$(GPF_DIR)/INC -I$(SRCBMI) -I$(SRCBMI)/icons

ifeq ($(ZHQ_MMI_BUILD),1)
INC_DRIVER  = -I$(TOP_DIR)/Drivers-lib-mmi/header
else
INC_DRIVER	= -I$(TOP_DIR)/../drivers/common/rtc -I$(TOP_DIR)/../drivers/board/ffs -I$(TOP_DIR)/../drivers/board/spi -I$(TOP_DIR)/../Layer1/tm_cust0 \
			  -I$(TOP_DIR)/../drivers/board/melody  -I$(TOP_DIR)/../drivers/common	-I$(TOP_DIR)/../drivers/board
endif			  

INC_MMS		= -I$(SRCMMS)/src -I$(SRCMMS)/inc 
INC_WAPMMI	= -I$(SRCWAPMMI)/src -I$(SRCWAPMMI)/inc   
		 

WAPMMIOBJ =  $(OBJ)/MmiWapFfs.$(OBJ_TAIL) \
				$(OBJ)/ATBWapAUI.$(OBJ_TAIL) \
				$(OBJ)/ATBWapACI.$(OBJ_TAIL) \
				$(OBJ)/AUIWap.$(OBJ_TAIL)
				
WAPCODEC = $(OBJ)/wap_codec.$(OBJ_TAIL) 
 	   
ifeq ($(MMS),1)
	WAPMMIOBJ+=   $(OBJ)/mmsagent.$(OBJ_TAIL)\
 	     			      $(OBJ)/mmswap_interface.$(OBJ_TAIL)

endif

ifeq ($(WAP),1)
COPT1 += -dMMI_WAP_ENABLED
else
COPT1 += -uMMI_WAP_ENABLED
endif

ifeq ($(TK),1)	
COPT1 += -dSIM_TOOLKIT
else
COPT1 += -uSIM_TOOLKIT
endif

#
# Creating wap_mmi.lib
#
$(WAP_MMI_LIB) : $(OBJ) $(WAPMMIOBJ) $(WAPCODEC)
	$(AR) r $(WAP_MMI_LIB) $(WAPMMIOBJ)  
	$(AR) r $(WAP_MMI_LIB) $(WAPCODEC) 

FORCE:

$(OBJ):	
	mkdir $(subst /,$(SLASH),$(OBJ))
	
clean: 
	$(REMOVE) $(subst /,$(SLASH),$(OBJ))

$(WAPMMIOBJ): $(OBJ)/%.$(OBJ_TAIL) : $(SRCWAPMMI)/src/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo -DAUS_CONDAT_TYPE_PORTING >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INC_DRIVER) >> cmd
#	echo $(INC_RIV) >> cmd
	echo -I$(CONDAT_BASE_DIR)/com/include >> cmd
	echo -I$(ICDG) >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IGLE) >> cmd
	echo -I$(IAUSC) >> cmd
	echo -I$(SRCWAP) >> cmd
	echo -I$(ICOM0) >> cmd
	echo -I$(ICOM1) >> cmd
	echo -I$(ICOM2) >> cmd
#	echo $(ZHQDRV0) >> cmd
#	echo $(ZHQDRV1) >> cmd
#	echo $(ZHQDRV2) >> cmd
	echo $(INCDRV2) >> cmd
	echo $(INC_CONDAT) >> cmd
	echo $(INC_MMS) >> cmd
	echo $(INC_WAPMMI) >> cmd
#	echo $(INC_MISC) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd

$(WAPCODEC): $(OBJ)/%.$(OBJ_TAIL) : $(SRCWAP)/%.c
	echo -D$(NCONFIG) >  cmd
	echo -D$(NTRACE) >> cmd
	echo -D$(NWARN) >> cmd
	echo -DTRGT_G23 >> cmd
	echo -DAUS_CONDAT_TYPE_PORTING >> cmd
	echo -DUSE_WIP_MALLOC >> cmd
	echo $(COPT) >> cmd
	echo $(COPT1) >> cmd
	echo $(COTAR) >> cmd
	echo $(FDOPT) >> cmd
	echo $(INC_DRIVER) >> cmd
	echo $(INC_RIV) >> cmd
	echo -I$(CONDAT_BASE_DIR)/com/include >> cmd
	echo -I$(ICDG) >> cmd
	echo -I$(IAUS) >> cmd
	echo -I$(IGLE) >> cmd
	echo -I$(IAUSC) >> cmd
	echo -I$(SRCWAP) >> cmd
	echo $(INC_CONDAT) >> cmd
	echo $(INC_MMS) >> cmd
	echo $(INC_WAPMMI) >> cmd
	echo $(INC_MISC) >> cmd
	echo -fr$(OBJ) >> cmd
	$(CC_PRE) $^ -@cmd
	$(CC_INT) $(addsuffix .pp,$(basename $^))
	$(CC_COM) $(addsuffix .pp_,$(basename $^)) -@cmd


