/*
 * DRV_DUMMY.C
 *
 * Set of dummy functions needed (because called by Condat or Layer1) when Riviera SWEs
 * are disabled (R2D, KPD, etc...)
 *
 * Copyright (c) Texas Instruments 2002
 *
 */

#include "rv_defined_swe.h"

#ifndef RVM_KPD_SWE
  #include "nucleus.h"

/* This structure defines the two functions to call when PWR key is pressed */
typedef struct {  void (*pressed)(int);
                  void (*released)(void);
               } T_KPD_KEYPAD; 

T_KPD_KEYPAD Kp = {0};

  void KP_Init(void (pressed(int)), void (released(void)))
  {
    Kp.pressed = pressed;
    Kp.released = released;
  }

  void kpd_power_key_pressed(void)
  {
      //Dummy
  }

  void kpd_key_handler(void)
  {
      //Dummy
  }
#endif // RVM_KPD_SWE

#ifndef RVM_R2D_SWE
  void *r2d_g_lcd_gc;

  void r2d_draw_point(void *gc, short x, short y)
  {
      //Dummy
  }

  void r2d_erase_point(void *gc, short x, short y)
  {
      //Dummy
  }

  void r2d_erase(void *gc)
  {
      //Dummy
  }

  void LCD_Cursor(unsigned char y, unsigned char x)
  {
      //Dummy
  }

  void LCD_SetPower(void)
  {
      //Dummy
  }

  void LCD_Clear(void)
  {
      //Dummy
  }

  void LCD_Reset(void)
  {
      //Dummy
  }

  void LCD_Enable(unsigned char x)
  {
      //Dummy
  }
#endif // RVM_R2D_SWE

#ifndef RVM_ETM_SWE
  int etm_hook(unsigned char *inbuf, unsigned short size)
  {
    // Return 1 so that the received packets are processed like TM3 packets.
    return 1;
  }
#endif // RVM_ETM_SWE
