#
#       Makefile for KPD Riviera driver (ARM compiler) 
#
#       Copyright (c) Texas Instruments 2002
# 
#               Author: Laurent Sollier
#       Date : 17 May 2002

KPD_FLAGS   := -g -mt -mn $(CFLAGSDRIVERS)

LIB_KPD	    := $(OUT_LIB_DIR)/kpd$(NBRD)$(NCHP)$(NANALOG).lib 
CFG_LIBS    += $(LIB_KPD)

SRC_KPD +=	$(DRIVERS_DIR)/common/kpd/kpd_api.c      $(DRIVERS_DIR)/common/kpd/kpd_functions.c \
                $(DRIVERS_DIR)/common/kpd/kpd_power_api.c      $(DRIVERS_DIR)/common/kpd/kpd_process_internal_msg.c \
                $(DRIVERS_DIR)/common/kpd/kpd_virtual_key_table_mgt.c $(BOARD_DIR)/kpd/kpd_scan_functions.c


ifdef KPD_SOURCE
    SRC_KPD += $(DRIVERS_DIR)/common/kpd/kpd_env.c $(DRIVERS_DIR)/common/kpd/kpd_task.c \
               $(DRIVERS_DIR)/common/kpd/kpd_handle_message.c $(DRIVERS_DIR)/common/kpd/kpd_handle_timer.c
endif

OBJ_KPD     := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_KPD)))

CFG_OBJS += $(OBJ_KPD)
CFG_DEPS += $(OBJ_KPD:.obj=.d)


$(LIB_KPD) : $(OBJ_KPD)
	ar470 r $(LIB_KPD) $(OBJ_KPD)


$(OBJ_KPD) : %.obj: %.c
	cl470 $(KPD_FLAGS) -fr$(@D) $<