/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: macnvprf.h
 *
 *		Description	: MA Stream Converter profile
 *
 *		Version		: 2.0.6 	2003.07.30
 *
 ****************************************************************************/

#ifndef __MACNVPRF_H__
#define __MACNVPRF_H__

#if MASMW_SRMCNV_SMAF
 #include "mammfcnv.h"
#endif
#if MASMW_SRMCNV_SMAF_PHRASE
 #include "maphrcnv.h"
#endif
#if MASMW_SRMCNV_REALTIME_MIDI
 #include "marmdcnv.h"
#endif
#if MASMW_SRMCNV_SMF
 #include "mamidcnv.h"
#endif
#if MASMW_SRMCNV_HVS
 #include "mahvcnv.h"
#endif
#if MASMW_SRMCNV_WAV
 #include "mawavcnv.h"
#endif

#define DUMMY_FUNC		\
	{					\
		dummy_Init,		\
		dummy_Load,		\
		dummy_Open,		\
		dummy_Control,	\
		dummy_Standby,	\
		dummy_Seek,		\
		dummy_Start,	\
		dummy_Stop,		\
		dummy_Stop,		\
		dummy_Start,	\
		dummy_Close,	\
		dummy_Unload,	\
		dummy_End		\
	}

static MASRMCNVFUNC ma_srmcnv_func[MASMW_NUM_SRMCNV] =
{
	DUMMY_FUNC,							/* 0 */
	
#if MASMW_SRMCNV_SMAF
	{									/* 1 */
		MaMmfCnv_Initialize,
		MaMmfCnv_Load,
		MaMmfCnv_Open,
		MaMmfCnv_Control,
		MaMmfCnv_Standby,
		MaMmfCnv_Seek,
		MaMmfCnv_Start,
		MaMmfCnv_Stop,
		MaMmfCnv_Stop,
		MaMmfCnv_Start,
		MaMmfCnv_Close,
		MaMmfCnv_Unload,
		MaMmfCnv_End
	},
#else
	DUMMY_FUNC,
#endif

	DUMMY_FUNC,							/* 2 */
	
#if MASMW_SRMCNV_REALTIME_MIDI
	{									/* 3 */
		MaRmdCnv_Initialize,
		MaRmdCnv_Load,
		MaRmdCnv_Open,
		MaRmdCnv_Control,
		MaRmdCnv_Standby,
		MaRmdCnv_Seek,
		MaRmdCnv_Start,
		MaRmdCnv_Stop,
		MaRmdCnv_Stop,
		MaRmdCnv_Start,
		MaRmdCnv_Close,
		MaRmdCnv_Unload,
		MaRmdCnv_End
	},
#else
	DUMMY_FUNC,
#endif

#if MASMW_SRMCNV_SMAF_AUDIO
	{									/* 4 */
		MaAudCnv_Initialize,
		MaAudCnv_Load,
		MaAudCnv_Open,
		MaAudCnv_Control,
		MaAudCnv_Standby,
		MaAudCnv_Seek,
		MaAudCnv_Start,
		MaAudCnv_Stop,
		MaAudCnv_Pause,
		MaAudCnv_Restart,
		MaAudCnv_Close,
		MaAudCnv_Unload,
		MaAudCnv_End
	},
#else
	DUMMY_FUNC,
#endif

#if MASMW_SRMCNV_SMF
	{									/* 5 */
		MaMidCnv_Initialize,
		MaMidCnv_Load,
		MaMidCnv_Open,
		MaMidCnv_Control,
		MaMidCnv_Standby,
		MaMidCnv_Seek,
		MaMidCnv_Start,
		MaMidCnv_Stop,
		MaMidCnv_Stop,
		MaMidCnv_Start,
		MaMidCnv_Close,
		MaMidCnv_Unload,
		MaMidCnv_End
	},
#else
	DUMMY_FUNC,
#endif

	DUMMY_FUNC,							/* 6 */
	DUMMY_FUNC,							/* 7 */
	DUMMY_FUNC,							/* 8 */

#if MASMW_SRMCNV_HVS
	{									/* 9 */
		MaHvCnv_Initialize,
		MaHvCnv_Load,
		MaHvCnv_Open,
		MaHvCnv_Control,
		MaHvCnv_Standby,
		MaHvCnv_Seek,
		MaHvCnv_Start,
		MaHvCnv_Stop,
		MaHvCnv_Stop,
		MaHvCnv_Start,
		MaHvCnv_Close,
		MaHvCnv_Unload,
		MaHvCnv_End
	},
#else
	DUMMY_FUNC,
#endif

	DUMMY_FUNC,							/* 10 */
	
#if MASMW_SRMCNV_WAV
	{									/* 11 */
		MaWavCnv_Initialize,
		MaWavCnv_Load,
		MaWavCnv_Open,
		MaWavCnv_Control,
		MaWavCnv_Standby,
		MaWavCnv_Seek,
		MaWavCnv_Start,
		MaWavCnv_Stop,
		MaWavCnv_Pause,
		MaWavCnv_Restart,
		MaWavCnv_Close,
		MaWavCnv_Unload,
		MaWavCnv_End
	},
#else
	DUMMY_FUNC,
#endif

	DUMMY_FUNC							/* 12 */
};

#endif /*__MACNVPRF_H__*/
