/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION
 *
 *		Module		: madebug.h
 *
 *		Description	: for MA Sound Middleware debug
 *
 *		Version		: 2.0.7 	2003.07.30
 *
 ****************************************************************************/

#ifndef __MADEBUG_H__
#define __MADEBUG_H__

#define MASMW_MODULE_DEBUG		(0)


#if MASMW_MODULE_DEBUG
#define DEBUG_MA_SMF_STREAM_CONVERTER
#define DEBUG_MA_SMAF_AUDIO_STREAM_CONVERTER
#define DEBUG_MA_REALTIME_MIDI_STREAM_CONVERTER
#define DEBUG_MA_SMAF_PHRASE_STREAM_CONVERTER
#define DEBUG_MA_SMAF_CONVERTER
#define DEBUG_MA_WAVE_CONVERTER
#define DEBUG_MA_HV_CONVERTER


#define DEBUG_MA_SOUND_SEQUENCER
#define DEBUG_MA_SOUND_DRIVER
#define DEBUG_MA_RESOURCE_MANAGER
#define DEBUG_MA_DEVICE_DRIVER
#endif	/* MASMW_MODULE_DEBUG */

#if MASMW_MODULE_DEBUG
#define MASMW_ASSERT(f)	((void)0)
#else
#define MASMW_ASSERT(f)	((void)0)
#endif


#ifdef DEBUG_MA_SMF_STREAM_CONVERTER			/* SMF Converter */
 #define MASMFCNV_DBGMSG(a)	printf a
#else
 #define MASMFCNV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_SMAF_AUDIO_STREAM_CONVERTER		/* SMAF/Audio Converter */
 #define MAAUDCNV_DBGMSG(a)	printf a
#else
 #define MAAUDCNV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_REALTIME_MIDI_STREAM_CONVERTER	/* Realtime MIDI Converter */
 #define MARMDCNV_DBGMSG(a)	printf a
#else
 #define MARMDCNV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_SMAF_PHRASE_STREAM_CONVERTER	/* SMAF/Phrase Converter */
 #define MAPHRCNV_DBGMSG(a)	printf a
#else
 #define MAPHRCNV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_SMAF_CONVERTER					/* MA SMAF Converter */
 #define MAMMFCNV_DBGMSG(a)	printf a
#else
 #define MAMMFCNV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_HV_CONVERTER					/* MA HV Converter */
 #define MAHVCNV_DBGMSG(a)	printf a
#else
 #define MAHVCNV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_WAVE_CONVERTER					/* WAVE Converter */
 #define MAWAVCNV_DBGMSG(a)	printf a
#else
 #define MAWAVCNV_DBGMSG(a)
#endif



#ifdef DEBUG_MA_SOUND_SEQUENCER					/* MA Sound Sequencer */
 #define MASNDSEQ_DBGMSG(a)	MI_dbgPrintf a
#else
 #define MASNDSEQ_DBGMSG(a)
#endif

#ifdef DEBUG_MA_SOUND_DRIVER					/* MA Sound Driver */
 #define MASNDDRV_DBGMSG(a)	printf a
#else
 #define MASNDDRV_DBGMSG(a)
#endif

#ifdef DEBUG_MA_RESOURCE_MANAGER				/* MA Resource Manager */
 #define MARESMGR_DBGMSG(a)	printf a
#else
 #define MARESMGR_DBGMSG(a)
#endif

#ifdef DEBUG_MA_DEVICE_DRIVER					/* MA Device Driver */
 #define MADEVDRV_DBGMSG(a)	MI_dbgPrintf a
#else
 #define MADEVDRV_DBGMSG(a)
#endif


#define DEBUG_HALL_DEVICE_DRIVER
#ifdef DEBUG_HALL_DEVICE_DRIVER					/* MA Device Driver */
 #define HALLDEVDRV_DBGMSG(a)	MI_dbgPrintf a
#else
 #define HALLDEVDRV_DBGMSG(a)
#endif

#define DEBUG_POWER_DEVICE_DRIVER
#ifdef DEBUG_POWER_DEVICE_DRIVER					/* MA Device Driver */
 #define POWERDRV_DBGMSG(a)	MI_dbgPrintf a
#else
 #define POWERDRV_DBGMSG(a)
#endif



#endif /*__MA_DEBUG_H__*/
