/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: madevdrv.h
 *
 *		Description	: MA-5 Device Driver
 *
 *
 *		Version		: 2.1.7 	2003.05.14
 *
 *
 ****************************************************************************/

#ifndef __MADEVDRV_H__
#define __MADEVDRV_H__

#include "mamachdep.h"
#include "madefs.h"

#define	MADEVDRV_ACCESS_WRITE			0
#define	MADEVDRV_ACCESS_READ			1

/* Function Definitions */

SINT32	MaDevDrv_Initialize			( void );
SINT32	MaDevDrv_Terminate			( void );
SINT32	MaDevDrv_HardwareInitialize	( void );
SINT32	MaDevDrv_PowerManagement	( UINT8 bMode );
SINT32	MaDevDrv_WriteIntermediateReg	( UINT32 dNumber, UINT8 bData);
UINT8	MaDevDrv_ReadIntermediateReg	( UINT32 dNumber );
SINT32 	MaDevDrv_ReceiveData		( UINT32 dAddress );
SINT32	MaDevDrv_SendDirectPacket	( const UINT8 * pbData, UINT32 dSize );
SINT32	MaDevDrv_SendDelayedPacket	( const UINT8 * pbData, UINT32 dSize );
SINT32	MaDevDrv_SendDirectRamData	( UINT32 dAddress, UINT8 bType, const UINT8 * pbData, UINT32 dSize );
SINT32	MaDevDrv_SendDirectRamVal	( UINT32 dAddress, UINT32 dSize, UINT8 bVal );

SINT32	MaDevDrv_StartSequencer		( SINT32 sdSeqId );
SINT32	MaDevDrv_StopSequencer		( SINT32 sdSeqId );
SINT32	MaDevDrv_EndofSequence		( void );

SINT32	MaDevDrv_ClearFifo			( void );
void	MaDevDrv_Fifo				( UINT32 dCtrl );

UINT8 * MaDevDrv_GetSeekBuffer		( UINT32 * pdSize );
SINT32	MaDevDrv_SeekControl		( UINT32 dSize );

void	MaDevDrv_IntHandler			( void );
SINT32	MaDevDrv_StreamHandler		( UINT32 dSeqId, UINT32 dSaId, UINT32 dCtrl, UINT8 bRamVal , UINT32 dSeek);

void 	MaDevDrv_IrqProc			( UINT32 dIrqFlag, UINT8 bOldSetting );
void	MaDevDrv_ClearIrqProc		( void );

SINT32	MaDevDrv_VerifyRegisters	( void );
void	MaDevDrv_EnableIrq			( void );
void	MaDevDrv_DisableIrq			( void );

#endif /*__MADEVDRV_H__*/
