/****************************************************************************
 *
 *		Copyright (C) 2002-2003 YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: mamachdep.h
 *
 *		Description	: Define machine dependent types for MA SMW
 *
 *		Version		: 2.0.7 	2003.08.20
 *
 ****************************************************************************/

#ifndef __MAMACHDEP_H__
#define __MAMACHDEP_H__

#define SINT8 signed char
#define SINT16 signed short
#define SINT32 signed long
#define UINT8 unsigned char
#define UINT16 unsigned short
#define UINT32 unsigned long

#ifndef NULL
 #define  NULL           ((void *)0)
#endif

// modify for V0.1
//#define MA_STATUS_REG		(*(volatile UINT8*)0x2000000)
//#define MA_DATA_REG			(*(volatile UINT8*)0x2000002)

/* to V0.2 */
#if (TARGET == 4)	/* 288C */ 
#define MA_STATUS_REG		(*(volatile UINT8*)0x2000000)
#define MA_DATA_REG			(*(volatile UINT8*)0x2000002)
#else
#define MA_STATUS_REG		(*(volatile UINT8*)0x2400000)
#define MA_DATA_REG			(*(volatile UINT8*)0x2400002)
#endif

#define	MA_ADJUST1_VALUE	(12)	/* register bank 0, B_Address #30 CKSEL & ADJUST1 */
#define	MA_ADJUST2_VALUE	(68)	/* register bank 0, B_Address #31 ADJUST2 */
#define	MA_PLL_OUT			(73666)	/* PLL Output value (kHz) ex.:73728 */
									/* (CLKI / (MA_ADJUST1_VALUE & 0x1F)) * MA_ADJUST2_VALUE */
#define MA_VSEL				(0x2)	/* VSEL2:VSEL1 */
#define MA_STATUS_TIMEOUT	(15000)	/* 1.5msec */

#define MA_DEVICETYPE		(1)		/* Device type */
									/* MA-5:1  MA-5S:2 MA-5i:3 */

#define MASMW_GENERATE_TASK	(0)		/* process MaDrvDrv_IrqProc in a IrqHandler : 0 */
									/*                          in a Task       : 1 */
#define MA_STOPWAIT			(1)


#if 1
 #define MA_INT_POINT		(4)
 #define MA_FIFO_SIZE		(256)
 #define MA_SBUF_NUM		(4)
#else
 #define MA_INT_POINT		(6)
 #define MA_FIFO_SIZE		(128)
 #define MA_SBUF_NUM		(8)
#endif

/* Select stream converter */
#define MASMW_SRMCNV_SMAF			1
#define MASMW_SRMCNV_SMAF_PHRASE	1
#define MASMW_SRMCNV_REALTIME_MIDI	1
#define MASMW_SRMCNV_SMAF_AUDIO		1
#define MASMW_SRMCNV_SMF			1
#define MASMW_SRMCNV_HVS			0
#define MASMW_SRMCNV_WAV			1

/*===================================================================*/
/* Key Control Selection for MA-1/3 data                             */
/*      0:dependent on KCS bit of the data (default)                 */
/*      1:MA-1 -- work on all channel                                */
/*        MA-3 -- work on all channel except drum channel            */
/*===================================================================*/
#define	MASMW_MMF13_KCS_IGNORE		(0)

#endif /*__MAMACHDEP_H__*/
