/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: maphrcnv.h
 *
 *		Description	: Header of MA-5 SMAF/Phrase and Audio Stream Converter Module.
 *
 *		Version		: 1.1.0 	2003.03.19
 *
 ****************************************************************************/
#ifndef	_MAPHRCNV_H_
#define	_MAPHRCNV_H_

/*=========================================================
	for SMAF/Phrase
 =========================================================*/
struct	event {
	int	ch;
	int	mode;
};

struct info {
	long	MakerID;
	int		DeviceID;
	int		VersionID;
	int		MaxVoice;
	int		MaxChannel;
	int		SupportSMAF;
	long	Latency;
};


/*==============================================================================
//	prototype functions
//============================================================================*/
int		Phrase_Initialize	(void);
int		Phrase_Terminate	(void);
int		Phrase_GetInfo		(struct info* dat);
int		Phrase_CheckData	(unsigned char* data, unsigned long len);
int		Phrase_SetData		(int ch, unsigned char* data, unsigned long len, int check);
int		Phrase_Seek			(int ch, long pos);
int		Phrase_Play			(int ch, int loop);
int		Phrase_Stop			(int ch);
int		Phrase_Pause		(int ch);
int		Phrase_Restart		(int ch);
int		Phrase_Kill			(void);
void	Phrase_SetVolume	(int ch, int vol);
int		Phrase_GetVolume	(int ch);
void	Phrase_SetPanpot	(int ch, int vol);
int		Phrase_GetPanpot	(int ch);
int		Phrase_GetStatus	(int ch);
long	Phrase_GetPosition	(int ch);
long	Phrase_GetLength	(int ch);
int		Phrase_RemoveData	(int ch);
int		Phrase_SetEvHandler(void (* func)(struct event*));
int		Phrase_SetLink		(int ch, unsigned long slave);
unsigned long	Phrase_GetLink(int ch);

/*=========================================================
	for SMAF/Audio
 =========================================================*/

/*==============================================================================
//	prototype functions
//============================================================================*/
SINT32	PhrAudCnv_Initialize(void);

SINT32	MaAudCnv_Initialize	(void);
SINT32	MaAudCnv_End		(void);
SINT32	MaAudCnv_Load		(UINT8* pbFile, UINT32 dFileSize, UINT32 dMode,
								 SINT32 (*pfnFunc)(UINT8 id), void* pvExtArgs);
SINT32	MaAudCnv_Unload		(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Open		(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Close		(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Standby	(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Seek		(SINT32 sdFileid, UINT32 dPos, void* pvExtArgs);
SINT32	MaAudCnv_Start		(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Pause		(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Restart	(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Stop		(SINT32 sdFileid, void* pvExtArgs);
SINT32	MaAudCnv_Control	(SINT32 sdFileid, UINT32 dCtrlNum,
												 void* pvPrm, void* pvExtArgs);

#endif	/*	_MAPHRCNV_H_	*/

