/****************************************************************************
 *
 *		Copyright (C) 2002-2003	YAMAHA CORPORATION. All rights reserved.
 *
 *		Module		: marmdcnv.h
 *
 *		Description	: Header of Realtime MIDI/GML Stream Converter Module.
 *
 *		Version		: 1.0.1 	2003.04.14
 *
 ****************************************************************************/
#ifndef	_MARMDCNV_H_
#define	_MARMDCNV_H_

#include "mamachdep.h"
#include "masnddrv.h"		/*	MA-X Sound Driver		*/
#include "maresmgr.h"		/*	MA-X Resource Manager	*/
#include "madebug.h"


/*==============================================================================*/
/* prototype functions                                                          */
/*==============================================================================*/

SINT32	MaRmdCnv_Initialize	(void);
SINT32	MaRmdCnv_End		(void);
SINT32	MaRmdCnv_Load		(UINT8* pbFile, UINT32 dFileSize, UINT32 dMode, SINT32 (*pfnFunc)(UINT8 bID), void* pvExtArgs);
SINT32	MaRmdCnv_Unload		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaRmdCnv_Open		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaRmdCnv_Close		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaRmdCnv_Standby	(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaRmdCnv_Seek		(SINT32 sdFileID, UINT32 dPos, void* pvExtArgs);
SINT32	MaRmdCnv_Start		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaRmdCnv_Stop		(SINT32 sdFileID, void* pvExtArgs);
SINT32	MaRmdCnv_Control	(SINT32 sdFileID, UINT32 dCtrlNum, void* pvPrm, void* pvExtArgs);

#endif	/*	_MARMDCNV_H_	*/

