#ifndef _MELODY_CFG_H_
#define _MELODY_CFG_H_

#if (MIDI_TRACE == 1)
  #define MELODY_TRACE	1 
#else
  #define MELODY_TRACE	0  
#endif

#if (MELODY_DEVICE == 1)
  #define MIDI_DEVICE		1	/* 762 */
#endif

#if (MELODY_DEVICE == 2)
  #define MIDI_DEVICE		2	/* 765 */
#endif

#define MIDI_STEREO				1	/* 0: only spk output, 1: spk and hp output */					

#ifdef  MELODY_POWERSAVE
  #undef  MELODY_POWERSAVE
#endif

#if ( MODEL == 1 || MODEL == 5 || MODEL == 10 || MODEL == 11)	/* M188 serial board */
  #define PIN_EXTAMP_CTRL		6
  #define BIT_EXTAMP_IO_SEL		2		/* IO_CONF_REG bit */
#else	/* M288 serial board */
  #define PIN_EXTAMP_CTRL		10
  #define BIT_EXTAMP_IO_SEL		6		
#endif

#define CAL_SYS_CPU_FREQ		40	/* system freq 40MHz */
#define CAL_SYS_MA_DELAY		5	/* delay 5 system clock */

#define DEEPSLEEP_SUPPORTED		1	/* give support to system deep sleep */

#define HANDFREE_SUPPORTED		0 	/* buildin Amp as UE handfree output amp */

#define MELODY_FFS_SUPPORT		1

#if (MELODY_FFS_SUPPORT == 1)
	#define MELODY_DATA_STATIC		0	/* using static music data buffer */
	#define MELODY_INFO_BUF_SZ		20
	 
  #if (MELODY_DATA_STATIC == 1)
	#define MELODY_DATA_BUF_SZ		6500	/* maximum 64K */
  #endif
#endif

#endif
