#ifndef _MELODY_STRUCT_H_
#define _MELODY_STRUCT_H_

#include "mamachdep.h"
#include "madefs.h"


typedef enum PowerState
{
	MI_pwrDown,    /* power saving apply state */
	MI_pwrRelease  /* normal mode, no power saving applied */
} T_PWR_STA;


/* Vibrator setting and status */
typedef struct VbrSetting
{
	UINT8	frcCtrl;	/* 0 off, 1 on */
	UINT8	ctrlSrc;	/* 0 off, 1 forced control, 2 sequenc sync */
	UINT8	blink;		/* 0 no blinking, 1 ~ 5 blinking frequency */
	UINT8	res;		/* reserved */
} T_MELODY_VBR_SETTING;

typedef struct MelodyCtrlBlock
{
	UINT8			initialized;	/* 1: melody middleware init has completed
               			             * 0: middleware init has not executed
                             		 */
  /* for music play control */
    UINT8			musicID;		/* music file number */                         
	UINT8			curVolume;		/* current speaker volume */
	UINT8			remainCnt;		/* remained replay count */		
	UINT8 			fileType;		/* type of the file is playing */
	UINT32  		curPos;			/* current playing file position */
	SINT32          fileID;			/* loaded music file ID, return value of MaSound_Load() */
	SINT32			funcID[MASMW_NUM_SRMCNV];/* converter ID to function ID table  */
	
    T_MELODY_VBR_SETTING  vbrSta;			
    
  /* for power saving control */	
  #ifdef	MELODY_POWERSAVE
	T_PWR_STA		pwrState;		/* power management state */
	NU_TIMER		pwrSaveTmr; 	/* timer to apply power saving process */
  #endif
	
} T_MELODY_CTRL_BLK;

#endif /* _MELODY_STRUCT_H_ */