#include <assert.h>
#include "iq.h"
#include "mem.h"
#include "inth.h"
#include "armio.h"
#include "spi_drv.h"

//#include "spi_drv_188.h"
#include "abb.h"

#include "general.h"
#include "mmedev.h"
#include "Rvf_target.h"

#include "lls_api.h"

#include "board.cfg"


static BOOL ledAIsOn  = 0;         
static BOOL backlightIsOn = 0;


#define _M188_

#if( MODEL == 1 )
unsigned short gl_mainboardtype=MAINBOARD_288;
#elif( MODEL == 3 )
unsigned short gl_mainboardtype=MAINBOARD_288B;
#elif( MODEL == 4 )
unsigned short gl_mainboardtype=MAINBOARD_288C;
#elif( MODEL == 5 )
unsigned short gl_mainboardtype=MAINBOARD_288S;
#endif




extern void MI_dbgPrintf(const char* const format, ...);
//#include "madebug.h"

extern void LCDBackLightControl(int level);

extern UINT8 g_pcsyncstatus;
unsigned g_HandsetPcsycMode = 0;
unsigned g_HeadsetMode=0;
unsigned g_PCSyncMode=0;

UINT8 offsetflag= 0 ;   //0:lcd 1:backlight 2 :calling 3 :charging offset flag
static unsigned short status_fortest=0;
extern UINT32 driverFlag;

unsigned short IsHandsetPlugin(void){
   if (g_HandsetPcsycMode == 2)
      return 1;
   else
      return 0;
}

int IsPcsyncLinePlugin(void){

   unsigned char i = 0;
   i = (*((volatile unsigned short *)MEM_ARMIO)) & 0x2000;
   if (i)
      return 0;
   else
      return 1;
}

unsigned short IsHeadsetPlugin(void){
	
	unsigned short i = 0;
    i = (*((volatile unsigned short *)(0xFFFE4800) ) & 0x08);
	
#if( MODEL == 3 || MODEL ==4 || MODEL == 5 ) //M288B, M288C, M288S
   if( i !=0 )
   	 return 0;
   else
   	 return 1;
#elif( MODEL == 1 ) // M288
   if( i !=0 )
   	 return 1;
   else
   	 return 0;
#endif
}

unsigned short IsHeadsetKey(void){
	
   unsigned short  i = 0;
   unsigned short stat;

#if( MODEL == 3 || MODEL ==4 || MODEL == 5 ) //M288, M288C, M288S
	stat =  ( *( (volatile unsigned short *)MEM_ARMIO ) & 0x08);
MI_dbgPrintf("IsHeadsetKey ---------1-- stat = 0x%x", stat);
   if ((*( (volatile unsigned short *)MEM_ARMIO ) & 0x0008)==0) //headset is plugin
  {
      stat = (*((volatile unsigned short *)MEM_ARMIO ) & 0x2000);
	  MI_dbgPrintf("IsHeadsetKey ---------2-- stat = 0x%x", stat);
	  
      while (((*((volatile unsigned short *)MEM_ARMIO ) & 0x2000)==0x0000)&&(i < 256))
#elif( MODEL == 1 ) //M288   	      
   if ((*( (volatile unsigned short *)MEM_ARMIO ) & 0x0008)==1) 
   {
      while (((*((volatile unsigned short *)MEM_ARMIO ) & 0x2000)==0x2000)&&(i < 256))
#endif	  	
      {
		//stat = (* (volatile unsigned short *)MEM_ARMIO ) & 0x2000;
         i ++;
      }
      if (i < 256)
         return 0;
      else
         return 1;
   } else
      return 0;   
}


unsigned short IsHandsetKey(void){
	
   unsigned short  i = 0;
   unsigned short stat;

#if( MODEL == 3 || MODEL ==4 || MODEL == 5 ) //M288, M288C, M288S
	stat =  ( *( (volatile unsigned short *)MEM_ARMIO ) & 0x08);
MI_dbgPrintf("IsHeadsetKey ---------1-- stat = 0x%x", stat);
   if ((*( (volatile unsigned short *)MEM_ARMIO ) & 0x0008)==0) //headset is plugin
  {
      stat = (*((volatile unsigned short *)MEM_ARMIO ) & 0x2000);
	  MI_dbgPrintf("IsHeadsetKey ---------2-- stat = 0x%x", stat);
	  
      while (((*((volatile unsigned short *)MEM_ARMIO ) & 0x2000)==0x0000)&&(i < 256))
#elif( MODEL == 1 ) //M288   	      
   if ((*( (volatile unsigned short *)MEM_ARMIO ) & 0x0008)==1) 
   {
      while (((*((volatile unsigned short *)MEM_ARMIO ) & 0x2000)==0x2000)&&(i < 256))
#endif	  	
      {
		//stat = (* (volatile unsigned short *)MEM_ARMIO ) & 0x2000;
         i ++;
      }
      if (i < 256)
         return 0;
      else
         return 1;
   } else
      return 0;   
}


void QueryPcsyncHandsetStatus(void){
   return;
}



void LED_ON(void)
{
	    volatile int status;
	    
#if 0
	/* Start spi clock */   
	Spi->SPI_SET_UN.SPI_SET_ST.SPI_REG_SET1 |= SpiClkOn;
	
	//PAGE1    
	SPI_WriteTX_MSB(0x01<<6|PAGEREG);
	SPI_StartWrite();    
	while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);

	
	SPI_WriteTX_MSB(0x08<<6|0x05<<1);
	SPI_StartWrite();    
	while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
	 
	SPI_WriteTX_MSB(0x02<<6|PAGEREG);
	SPI_StartWrite();    
	while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
	SPI_WriteTX_MSB(0x01<<6|0x18<<1);
	SPI_StartWrite();    
	while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
#endif	
}
 
 void LED_OFF(void)
{
	    volatile int status;
#if 0	 
	/* Start spi clock */   
	Spi->SPI_SET_UN.SPI_SET_ST.SPI_REG_SET1 |= SpiClkOn;
	SPI_WriteTX_MSB(0x02<<6|PAGEREG);
	SPI_StartWrite();    
	while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
	 SPI_WriteTX_MSB(0x00<<6|0x18<<1);
	SPI_StartWrite();    
	while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
#endif
}
//  brightness adjust

void LedLightnessAdjust(int value){
#if 0
       int i;
       voltageoffsetvalue[0] = (voltageoffsetvalue[0]/16)*value;
       SPIWrite_ABB_Register(PAGE0,TOGBR1,0x20);
       for(i = 0;i <1000; i++){;}

	SPIWrite_ABB_Register (PAGE0, TOGBR2, 0x0008); 
	if (value==0)//zy 08/16/02
	 value=1023;	
    else
	 value=1024-value*64; //end of zy 08/16/02
	SPIWrite_ABB_Register (PAGE0, AUXDAC, value);//0 to 0x03ff
#endif 
#if 0
       int i;
       voltageoffsetvalue[0] = (voltageoffsetvalue[0]/16)*value;
       spi_abb_write(PAGE0,TOGBR1,0x20);
	       for(i = 0;i <1000; i++){;}

	spi_abb_write (PAGE0, TOGBR2, 0x0008); 
	if (value==0)//zy 08/16/02
		 value=1023;	
	else
		 value=1024-value*64; //end of zy 08/16/02
	spi_abb_write(PAGE0, AUXDAC, value);//0 to 0x03ff
	return; 
#endif
	#if( MODEL == 4) // M288C, OLD doesn't need backlight
	if( HallStatus() ){
		LCDBackLightControl(value );
	}
	else
	{
		if( value == 0)
			sub_lcd_pwrCtrl(0);
	}
	
	#else
		LCDBackLightControl(value );
	#endif
	
	return;

}

void CBBacklight_ON(UINT16* value){
	UINT16 status ;
	status =(*value)|0x02;
		
//	spi_abb_write(PAGE1,ACDLED,status);
	spi_abb_write(PAGE1,AUXLED, status);
	return;
}

 // Keypad backlight
 void Backlight_ON(void)
{

	UINT16 status;
   
    offsetflag |= 0x2;
MI_dbgPrintf("glowing: mmedev -- Backlight_ON -enter");	
#if 0
	//glowing,2004-05-17, use the new SPI module
	//spi_abb_read(PAGE1,ACDLED,CBBacklight_ON);
	spi_abb_read(PAGE1, AUXLED, CBBacklight_ON);
#else
	if(backlightIsOn== 0 ){
	   lls_switch_on( LLS_BACKLIGHT );
	}
	backlightIsOn = 1;
#endif
	
MI_dbgPrintf("glowing: mmedev -- Backlight_ON -leave");	

	return ;
	
}

 void CBBacklight_OFF(UINT16 * value){
	UINT16 status ;
	status =(*value)&0x0fffd;
	//glowing,2004-05-17,use the new SPI module
	//spi_abb_write(PAGE1,ACDLED,status);
	spi_abb_write(PAGE1,AUXLED,status);
	return;
 }
 
 void Backlight_OFF(void)
{
	UINT16 status;
	 offsetflag &= 0xfd;
MI_dbgPrintf("glowing: mmedev -- Backlight_OFF -enter");	
#if 0
	//glowing,2004-05-17, use the new SPI module
	//spi_abb_read(PAGE1,ACDLED,CBBacklight_OFF);
	spi_abb_read(PAGE1,AUXLED,CBBacklight_OFF);
#else
    if( backlightIsOn == 1){
    	backlightIsOn= 0;
		lls_switch_off(LLS_BACKLIGHT);
    }
#endif
MI_dbgPrintf("glowing: mmedev -- Backlight_OFF -leave");	

}

void LCD_ON(void)
{
	 offsetflag |= 0x1;

    *((volatile UINT16*) ARMIO_OUT) |= 0X0100;//UWORD16
}
 
void LCD_OFF(void)
{
     offsetflag &= 0xfe;

   *((volatile UINT16 *) ARMIO_OUT) &= 0XFEFF;//UWORD16
}


void LEDC_OFF(void)
{////use message api
#if 0
	MmiTrace("LEDC_OFF");
	SPIWrite_ABB_Register(PAGE0,BCICTL2,0);    //disable charger

       MmiTraceInt( SPIRead_ABB_Register(PAGE1,BCICTL2)& 0xfdf);
	SPIWrite_ABB_Register (PAGE0, BCICTL2, SPIRead_ABB_Register(PAGE0,BCICTL2)& 0xfdf);

        *((volatile UINT16 *)0xfffe4804)&=0xdfff;//set GPIO13 0
	  *((volatile UINT16 *)0xfffe4802)&=0xdfff;
#endif
}

void LEDC_ON(void)
{
#if 0
	MmiTrace("LEDC_ON");
	if(ChargerPlugIn()){
		MmiTrace("ChargerPlugIn");

		SPIWrite_ABB_Register(PAGE0,BCICTL2,0);    //disable charger
		MmiTraceInt(SPIRead_ABB_Register(PAGE0,BCICTL2)| 0x020);
		SPIWrite_ABB_Register (PAGE0, BCICTL2, SPIRead_ABB_Register(PAGE0,BCICTL2)| 0x020);
	}
	else{
		MmiTrace("ChargerPlugOut");

	       *((volatile UINT16 *)0xfffe4804)&=0xdfff;
	       *((volatile UINT16 *)0xfffe4802)|=0x2000;
	}
#endif

}

void Green_On()
{
	*((volatile UINT16 *)ARMIO_OUT)|=0x0001; 
	 driverFlag|=0x0040;
}

void Green_Off()
{
	*((volatile UINT16 *)ARMIO_OUT)&= 0xfffe; 
     driverFlag&=0xffffffcf;
     
}


/* 
 * glowing,2004-05-21, the following function is special for 7 colors LED
 * Blue_On, Blue_Off, Red_On, Red_Off, Green2_Off, Green2_On
 */
void Blue_On()
{
	  AI_ConfigBitAsOutput(1);  // LCD_A0
	  AI_SETBIT(1);
      driverFlag|=0x0040;
}

void Blue_Off()
{

	//*((volatile UINT16 *)ARMIO_OUT)&=0xfffd; 
	 AI_RESETBIT(1);
	 AI_ConfigBitAsInput(1);  // LCD_A0	
	 driverFlag|=0x0040;
}

void Green2_On()
{
	  AI_ConfigBitAsOutput(0);  // LCD_A0
      AI_SETBIT(0);
	 //*((volatile UINT16 *)ARMIO_OUT)|=0x0001; 
	 driverFlag|=0x0040;
}

void Green2_Off()
{
	//*((volatile UINT16 *)ARMIO_OUT)&= 0xfffe; 
	 AI_RESETBIT(1);
     driverFlag&=0xffffffcf;
	 AI_ConfigBitAsInput(0);  // LCD_A0	
}


void red_on_cb(UINT16* value)
{
	UINT16 status ;
	status =(*value)|0x01;
	spi_abb_write(PAGE1,AUXLED,status);
}
void red_off_cb(UINT16* value)
{
	UINT16 status ;
	status =(*value)&0x0fffe;
	spi_abb_write(PAGE1,AUXLED,status);
	return;
}


void Red_On()
{
#if 0
     spi_abb_read(PAGE1,AUXLED,red_on_cb);
#else
    if( ledAIsOn== 0 ){
		lls_switch_on( LLS_LED_A );
   }
   ledAIsOn = 1;
   
#endif

}
void Red_Off()
{
#if 0
    spi_abb_read(PAGE1,AUXLED,red_off_cb);
#else
    if( ledAIsOn == 1 ){
	   ledAIsOn = 0;	
		lls_switch_off( LLS_LED_A );
   }
#endif
}

void CBOpenMic(UINT16* value){
   UINT16 status;
   status=(*value)&0xFFFC;
   status=status|0x0002;
   //glowing,2004-05-17, use the new SPI module
   //spi_abb_write(1,0x0008,status);
   spi_abb_write( PAGE0, TOGBR1, status );
   
   return ;
}

void OpenMic(void)    //set the bit VULON to one -----Power Up
{
   //glowing,2004-05-17, use the new SPI module
   //spi_abb_write(2,0x0e,0x1c6 );////reset Micphone set //wms set VBUR to 1c6 04-14
   //spi_abb_read(1,0x0008,CBOpenMic);
   spi_abb_write( PAGE1, VBUCTRL, 0X1c6 );
   spi_abb_read(PAGE0,TOGBR1,CBOpenMic );
   return ;
}

void CBCloseMic(UINT16* value){
   UINT16 status;
   status=(*value)&0xFFFC;
   status=status|0x0001;
   //glowing,2004-05-17, use the new SPI module
   //spi_abb_write(1,0x0008,status);
   spi_abb_write(PAGE0, TOGBR1, status );
   return ;
}

void CloseMic(void)   //zym://set the bit VULON to zero -------Power Down  ///zym 030110 use callback fuction 1
{
   spi_abb_write(2,0x0e,0x310 );   ///Mute Microphone  Mute sidetone
   spi_abb_read(1,0x0008,CBCloseMic);
   return ;
}

void mic_off_cb(int status)
{
     status&=0xfffc;
     status|=0x0001;
     spi_abb_write(1,8,status);   
}
void Mic_off()
{
    //spi_abb_read(1,8,mic_ff_cb); 
    int status;

	//glowing,2004-05-17 use the new SPI module
    //status=ABB_Read_Register_on_page(1,8);
    status=ABB_Read_Register_on_page(PAGE0, TOGBR1);
    status&=0xfffc;
    status|=0x0001;

	//glowing,2004-05-17, use the new SPI module
    //spi_abb_write(1,8,status);  
    spi_abb_write(PAGE0, TOGBR1, status );
}
void mic_on_cb(int status)
{
     status&=0xfffc;
     status|=0x0002;

	 //glowing,2004-05-17, use the new SPI module
     //spi_abb_write(1,8,status);   
     spi_abb_write(PAGE0, TOGBR1, status);   
}
void Mic_on()
{
	//glowing,2004-05-17, use the new SPI module
	//spi_abb_read(1,8,mic_on_cb); 
	spi_abb_read(PAGE0, TOGBR1, mic_on_cb); 
}

void spk_off_cb(int status)
{
     status&=0xfff3;
     status|=0x0004;
	//glowing,2004-05-17, use the new SPI module
    // spi_abb_write(1,8,status);   
    spi_abb_write( PAGE0, TOGBR1, status );
}
void Spk_off()
{
	//glowing, 2004-05-17, use the new SPI module
    //spi_abb_read(1,8,spk_off_cb); 
    spi_abb_read( PAGE0, TOGBR1, spk_off_cb );
}
void spk_on_cb(int status)
{
     status&=0xfff3;
     status|=0x0008;

	 //glowing,2004-05-17, use the new SPI module 
     //spi_abb_write(1,8,status);   
     spi_abb_write(PAGE0, TOGBR1, status);   
}
void Spk_on()
{
    //glowing,2004-05-17, use the new SPI module
    //spi_abb_read(1,8,spk_on_cb); 
    spi_abb_read(PAGE0, TOGBR1, spk_on_cb); 
}

void red_status_cb(USHORT status)
{
     status=status&0x0001;
     status_fortest=status;
   //  return status_fortest;
}
int Red_Status()
{
     status_fortest=0;
     //spi_abb_read(2,48,red_status_cb);

	 //glowing,2004-05-17, use the new SPI module
     //status_fortest=SPIRead_ABB_Register(2,48);
     status_fortest=ABB_Read_Register_on_page(PAGE1, AUXLED);
     status_fortest&=0x0001;
     return status_fortest;
}
int Green_Status()
{
     USHORT status;
     *((volatile UINT16 *)(0xfffef00a))|=0x0200; 
	 *((volatile UINT16 *)(0xfffe4804))&=0xdfff;
	 if(((*((volatile UINT16 *)(0xfffe4802)))&0x2000)==0x2000)
	 	return 1;
	 else 
	    return 0;
}
void speaker_status_cb(USHORT status)
{
     status&=0x0003;
     status_fortest=status;
}
int	speaker_status()
{
     status_fortest=0;

	 //glowing,2004-05-17, use the new SPI module
     //spi_abb_read(2,18,speaker_status_cb);
     status_fortest=ABB_Read_Register_on_page(PAGE1,PWDNRG);
     status_fortest&=0x0002;
     //return status_fortest;
     if(status_fortest)
     	return 1;
     else 
     	return 0;

}
int	Mic_status()
{
     status_fortest=0;

	 //glowing,2004-05-17, use the new SPI module
     //spi_abb_read(2,18,speaker_status_cb);
     status_fortest=ABB_Read_Register_on_page(PAGE1, PWDNRG);
     status_fortest&=0x0001;
     if(status_fortest)
     	return 1;
     else 
     	return 0;

}

#define GPIO_VIBRATOR 5


void Vibrator_on()
{
#if( MODEL == 6 ) //GTMobile M288G!
	AI_SETBIT(GPIO_VIBRATOR);
#endif	  
}
void Vibrator_off()
{
#if(MODEL == 6 )
	AI_RESETBIT(GPIO_VIBRATOR );
#endif	  
}

int Vibrator_Status()
{
      //SET_BIT(io_conf_reg_g,2);
      *((volatile UINT16 *)(0xfffef00a))|=0x0004;
      //RESET_BIT(io_cntl_reg_g,6);
      *((volatile UINT16 *)(0xfffe4804))&=0x0040;
      //SET_BIT(armio_latch_out_g,6);
      //vib_playing = 1;
      //vibra_status = VIBRA_BUSY;
       if(((*((volatile UINT16 *)(0xfffe4802)))&0x0040)==0x0040)
       	return 1;
       else
       	return 0;

}
/*void Backlight_Status_cb(USHORT status)
{
     status=status&0x02;
     status_fortest=status;
}
*/
int Backlight_Status()
{
     status_fortest=0;

	 //glowing,2004-05-17, use the new SPI module
     //spi_abb_read(spi_abb_read(2,48,Backlight_Status_cb));//PAGE1,ACDLED
     status_fortest=ABB_Read_Register_on_page( PAGE1, AUXLED );
     status_fortest&=0x02;
     if(status_fortest)
        return 1;
     else 
     	return 0;
}
int LCD_Status()
{
   //if((*((volatile UINT16*) GPIO_OUT) & 0x0100)==0x0100)
   if((*((volatile UINT16*) ARMIO_OUT) & 0x0100)==0x0100)
   	return 1;
   else
   	return 0;
}

//Voice baseband control register'status
int VBCR_status()
{
     status_fortest=0;

	 //glowing, 2004-05-17, use the new SPI module
     //spi_abb_read(2,18,speaker_status_cb);
     status_fortest=ABB_Read_Register_on_page(PAGE1, VBCTRL1 );//page=1,offset=8
     
     //status_fortest&=0x0001;
     return status_fortest;
}

//Voice baseband control register2'status
int VBCR2_status()
{
     status_fortest=0;

	 //glowing, 2004-05-17, use the new SPI module
     //spi_abb_read(2,18,speaker_status_cb);
     status_fortest=ABB_Read_Register_on_page(PAGE1, VBCTRL2);//page=1,offset=11
     //status_fortest&=0x0001;
     return status_fortest;
}

//Voice baseband uplink register'status
int VBUR_status()
{
     status_fortest=0;
	 //glowing,2004-05-17, use the new SPI module
     //spi_abb_read(2,18,speaker_status_cb);
     status_fortest=ABB_Read_Register_on_page(PAGE1, VBUCTRL);//page=1,offset=7
     //status_fortest&=0x0001;
     return status_fortest;
}

//Voice baseband downlink register'status
int VBDR_status()
{
     status_fortest=0;

	 //glowing, 2004-05-17, use the new SPI module
     //spi_abb_read(2,18,speaker_status_cb);
     status_fortest=ABB_Read_Register_on_page( PAGE1, VBDCTRL);//page=0,offset=6
     //status_fortest&=0x0001;
     return status_fortest;
}

int PWDNRG_status( )
{
     status_fortest=0;

     status_fortest=ABB_Read_Register_on_page( PAGE1, PWDNRG);
     return status_fortest;

}
	

unsigned short IsPcsyncRemove(void)
{
   if ( (*((volatile unsigned short *)MEM_ARMIO ) & 0x0400)==1 &&(g_pcsyncstatus == 1))
   {
      return 1;
   } else
      return 0;   
}

void Audio_Loop_Test()
{

	volatile unsigned short status;
	int i;
	for(i=0;i<100;i++)
	{
//glowing,2004-06-17,use the new spi api	
#if 0	
//		 SPI_WriteTX_MSB(0x0A << 6 |TOGBR1);      // Initialize transmit register. This transmission
// 		 SPI_StartWrite();                        // enables selected OMEGA modules  
		 SPI_WRITE_TX_MSB(0x0A << 6 |TOGBR1);      // Initialize transmit register. This transmission
 		 SPI_START_WRITE                           // enables selected OMEGA modules  
		 while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
#else
		 ABB_Write_Register_on_page( PAGE0, TOGBR1, 0x0A );
#endif

	     rvf_delay( RVF_MS_TO_TICKS(50 ) ) ;

         ABB_UlMute(0);
         ABB_DlMute(0);
		 ABB_DlVolume(255);
		 ABB_SideTone(255);
		}
		 return;
}

void Audio_Loop_Test_pctm_start()
{

	volatile unsigned short status;
	int i;
	for(i=0;i<100;i++)
	{
//glowing,2004-06-17,use the new spi api	
#if 0	
		 //SPI_WriteTX_MSB(0x0A << 6 |TOGBR1);      // Initialize transmit register. This transmission
 		 //SPI_StartWrite();                        // enables selected OMEGA modules  
		 SPI_WRITE_TX_MSB(0x0A << 6 |TOGBR1);      // Initialize transmit register. This transmission
 		 SPI_START_WRITE();                        // enables selected OMEGA modules  
		 while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
#else
		 ABB_Write_Register_on_page( PAGE0, TOGBR1, 0x0A );
#endif

	     //rvf_delay( RVF_MS_TO_TICKS(50 ) ) ;
		 

         ABB_UlMute(0);
         ABB_DlMute(0);
		 ABB_DlVolume(255);
		 ABB_SideTone(255);
	}
	return;
}

void Audio_Loop_Test_pctm_stop()
{

	volatile unsigned short status;
//glowing,2004-06-17, use the new spi api
#if 0
//	 SPI_WriteTX_MSB(0x5 << 6 |TOGBR1);      // Initialize transmit register. This transmission
// 	 SPI_StartWrite();                        // enables selected OMEGA modules  

	 while(((status = Spi->SPI_CTRL_STAT_UN.SPI_CTRL_STAT_ST.SPI_REG_STATUS) & WE_ST) == 0);
#else
		 ABB_Write_Register_on_page( PAGE0, TOGBR1, 0x05 );
#endif
	 return;
}

void Speaker_Vibrator_Test_Start()
{
 	SetMVol_DownLinkPGA(6); 
	StartPlayingMelody2(5, 0); //glowing,2003-12-23, use the yamaha api
	StartVibrator();
    
}

void Speaker_Vibrator_Test_Stop()
{
 	StopPlayingMelody2(); //glowing,2003-12-23, use the yamaha api
   	StopVibrator();
    
}



typedef enum              /* %CPI parameter <msg> */
{
  CPI_MSG_NotPresent = -1,
  CPI_MSG_Setup,
  CPI_MSG_Disc,
  CPI_MSG_Alert,
  CPI_MSG_Proc,
  CPI_MSG_Sync,
  CPI_MSG_Progr,
  CPI_MSG_Conn
}
T_ACI_CPI_MSG;


void fixTone(UINT8 type, UINT8 ibt)
{
	if(type == CPI_MSG_Alert && ibt)
	{
		vocoder_mute_ul(FALSE);
		vocoder_mute_dl(FALSE);
	}
}

/* Robert.Chen added, 2004-06-08 */
void getVolSetting(UINT8* amp)
{
	UINT8	i;
	UINT16	vbdctrl;
	/* NOTE: to get correct result, this table must match to the SetASpk_DownLinkPGA() func's methonology */
	UINT8	value2lel[7] = {72/*-16*/, 6/*-12*/, 10/*-8*/, 34/*-4*/, 38/*0*/, 41/*3*/, 43/*5*/};
	
#ifndef _INNOVATION_EMULATOR_
     status_fortest=ABB_Read_Register_on_page(PAGE0, VBDCTRL);//page=1,offset=11
#endif
	vbdctrl	= (UBYTE)(vbdctrl & 0x7f);

	for(i = 0; i < 7; i ++)
	{
		if(value2lel[i] == (UINT8)vbdctrl)
			break;
	}

	if(i < 7)
		*amp = i;
	else
		*amp = 1;	/* default */
}
/* add end */

unsigned short Set_MainboardType(unsigned short mainboard_type)
{
/* 2004/06/08, zhq, add for production test purpose. 
0 indicate 188 serial of mainboard.
1 indicate 288 serial of mainboard.
2 indicate 388 serial of mainboard.
3 indicate 588 serial of mainboard.
etc.
*/
	return Set_MainboardType_MMI(mainboard_type);
}

unsigned short Get_MainboardType(unsigned short* mainboard_type)
{
/* 2004/06/08, zhq, add for production test purpose. 
0 indicate 188 serial of mainboard.
1 indicate 288 serial of mainboard.
2 indicate 388 serial of mainboard.
3 indicate 588 serial of mainboard.
etc.
*/
	return Get_MainboardType_MMI(mainboard_type);
}

unsigned short Set_Encrypt_Key(unsigned short  encrypt_key)
{
	return Set_Encrypt_Key_MMI(encrypt_key);
}

unsigned short Get_Encrypt_Key(unsigned short*  encrypt_key)
{
	return Get_Encrypt_Key_MMI(encrypt_key);
}



