#
#       Makefile for PWR Riviera driver (ARM compiler) 
#
#       Copyright (c) Texas Instruments 2002
# 
#               Author: Laurent Sollier
#       Date : 17 May 2002

PWR_FLAGS   := -g -mn -x -mt -o -mw $(CFLAGSDRIVERS)

LIB_PWR	    := $(OUT_LIB_DIR)/pwr$(NBRD)$(NCHP)$(NANALOG).lib 
CFG_LIBS    += $(LIB_PWR)

SRC_PWR +=      $(DRIVERS_DIR)/common/pwr/pwr_cust.c	$(DRIVERS_DIR)/common/pwr/pwr_liion_cha.c \
                $(DRIVERS_DIR)/common/pwr/pwr_disch.c	$(DRIVERS_DIR)/common/pwr/pwr_api.c \
                $(DRIVERS_DIR)/common/pwr/pwr_messages.c \
                $(DRIVERS_DIR)/common/pwr/pwr_messages_i.c 	$(DRIVERS_DIR)/common/pwr/pwr_process.c \


ifdef PWR_SOURCE
   SRC_PWR += $(DRIVERS_DIR)/common/pwr/pwr_env.c
endif


OBJ_PWR     := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_PWR)))


CFG_OBJS += $(OBJ_PWR)
CFG_DEPS += $(OBJ_PWR:.obj=.d)


$(LIB_PWR) : $(OBJ_PWR)
	ar470 r $(LIB_PWR) $(OBJ_PWR)


$(OBJ_PWR) : %.obj: %.c
	cl470 $(PWR_FLAGS) -fr$(@D) $<