#
#       Makefile for RTC Riviera driver (ARM compiler) 
#
#       Copyright (c) Texas Instruments 2002
# 
#               Author: Laurent Sollier
#       Date : 17 May 2002

RTC_FLAGS   := -g -mt -mn $(CFLAGSDRIVERS)

LIB_RTC	    := $(OUT_LIB_DIR)/rtc$(NBRD)$(NCHP)$(NANALOG).lib 
CFG_LIBS    += $(LIB_RTC)

SRC_RTC += $(BOARD_DIR)/rtc/rtc_functions.c $(DRIVERS_DIR)/common/rtc/rtc_process.c  


ifdef RTC_SOURCE
   SRC_RTC += $(DRIVERS_DIR)/common/rtc/rtc_env.c $(DRIVERS_DIR)/common/rtc/rtc_task.c \
              $(DRIVERS_DIR)/common/rtc/rtc_handle_message.c
endif


OBJ_RTC     := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_RTC)))

CFG_OBJS += $(OBJ_RTC)
CFG_DEPS += $(OBJ_RTC:.obj=.d)


$(LIB_RTC) : $(OBJ_RTC)
	ar470 r $(LIB_RTC) $(OBJ_RTC)


$(OBJ_RTC) : %.obj: %.c
	cl470 $(RTC_FLAGS) -fr$(@D) $<