#
#       Makefile for SPI Riviera driver (ARM compiler) 
#
#       Copyright (c) Texas Instruments 2002
# 
#               Author: Laurent Sollier
#       Date : 17 May 2002

SPI_FLAGS   := -g -mt -mn $(CFLAGSDRIVERS)

ifeq ($(SRVC),0)
  SPI_FLAGS += -dIDS=0
else
  SPI_FLAGS += -dIDS=1
endif

LIB_SPI	    := $(OUT_LIB_DIR)/spi$(NBRD)$(NCHP)$(NANALOG).lib 
CFG_LIBS    += $(LIB_SPI)

SRC_SPI += $(BOARD_DIR)/spi/spi_drv.c 	$(BOARD_DIR)/spi/abb.c $(BOARD_DIR)/spi/abb_inth.c \
           $(DRIVERS_DIR)/common/spi/spi_process.c  $(DRIVERS_DIR)/common/spi/spi_api.c


ifdef SPI_SOURCE
   SRC_SPI += $(DRIVERS_DIR)/common/spi/spi_env.c $(DRIVERS_DIR)/common/spi/spi_task.c
endif


OBJ_SPI     := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_SPI)))

CFG_OBJS += $(OBJ_SPI)
CFG_DEPS += $(OBJ_SPI:.obj=.d)


$(LIB_SPI) : $(OBJ_SPI)
	ar470 r $(LIB_SPI) $(OBJ_SPI)


$(OBJ_SPI) : %.obj: %.c
	cl470 $(SPI_FLAGS) -fr$(@D) $<