/*===========================================================================
** MultiFrame.h - Common routines to support MultiFrame JPEG File Format
**---------------------------------------------------------------------------
**	Copyright (c) 2002 Epson Research and Development, Inc.
**	All Rights Reserved.
**===========================================================================
*/

#ifndef _MULTI_FRAME_H
#define _MULTI_FRAME_H

//---------------------------------------------------------------------------
// Include Files
//---------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "datatype.h"

//---------------------------------------------------------------------------
// type definitions
//---------------------------------------------------------------------------
typedef struct tagJPEGMULTIFRAME
{
	Int8	Signature[4];
	UInt32	ResultSize;
	UInt32	PaddedSize;
	UInt32	FrameNumber;
} JPEGMULTIFRAME;

//---------------------------------------------------------------------------
// Funciton Prototypes
//---------------------------------------------------------------------------
#ifndef MV850E
Boolean mfCreateFile( const char* pszFileName, FILE** ppStream );
Boolean mfGetOpenSize( const char* pszFileName, FILE** ppStream, long* pSize );
#endif //MV850E
void mfInitializeMultiFrame( JPEGMULTIFRAME* pJpegMultiFrame, UInt32 size );
#ifndef MV850E
Boolean mfReadFile( const char* pszFileName, FILE* pStream, void* pBuffer, UInt32 size );
Boolean mfReadInputfile( const char* pszFileName, UInt8** ppJpegData, UInt32* pJpegSize, UInt32* pFrameCount );
Boolean mfReadJfif( const char* pszFileName, FILE* pStream, UInt8** ppJfif, UInt32* pSize );
#endif //MV850E
Boolean mfValidateMultiFrame( JPEGMULTIFRAME* pJpegMultiFrame );
#ifndef MV850E
Boolean mfWriteFile( const char* pszFileName, FILE* pStream, void* pBuffer, UInt32 size );
#endif //MV850E

#endif

