#
# June. 7, 2004, Robert.Chen, Create this makefile for EPSON camera and graphic codec driver
#							  and MI's wrapper
#
# according to the Rita makefile system structure
#

#root of codec driver and wrapper files
CAM_DRV_DIR := $(DRIVERS_DIR)/common/camera
CAM_DRV_HAL_DIR := $(CAM_DRV_DIR)/src_hal
CAM_DRV_LIB_DIR := $(CAM_DRV_DIR)/src_lib
CAM_DRV_LIB_INC_DIR := $(CAM_DRV_DIR)/include


# hardware abstract layer source files
SRC_CAMERA_HAL := $(CAM_DRV_HAL_DIR)/hal.c \
				  $(CAM_DRV_HAL_DIR)/hal_config.c \
				  $(CAM_DRV_HAL_DIR)/hal_indirect.c \
				  $(CAM_DRV_HAL_DIR)/hal_i2c.c \
				  $(CAM_DRV_HAL_DIR)/i2c.c \
				  $(CAM_DRV_HAL_DIR)/camera.c

# codec chip function library files
SRC_CAMERA_LIB := $(CAM_DRV_LIB_DIR)/chiplib/chiplib.c \
				  $(CAM_DRV_LIB_DIR)/jpeg/jdecode.c \
				  $(CAM_DRV_LIB_DIR)/jpeg/jencode.c \
				  $(CAM_DRV_LIB_DIR)/jpeg/jpegcomm.c \
				  $(CAM_DRV_LIB_DIR)/jpeg/multiframe.c \
				  $(CAM_DRV_LIB_DIR)/jpeg/resize.c \
				  $(CAM_DRV_LIB_DIR)/topc/topc.c

SRC_CAMERA := $(SRC_CAMERA_LIB) $(SRC_CAMERA_HAL)


LIB_CAMERA := $(OUT_LIB_DIR)/camera$(NBRD)$(NCHP)$(NANALOG).lib

OBJ_CAMERA	:= $(patsubst %.c,%.obj,$(filter %.c,$(SRC_CAMERA)))

CFG_OBJS += $(OBJ_CAMERA)

CFG_DEPS += $(OBJ_CAMERA:.obj=.d)

CFG_LIBS += $(LIB_CAMERA)

$(LIB_CAMERA) : $(OBJ_CAMERA)
	ar470 r $(LIB_CAMERA) $(OBJ_CAMERA)
	
$(OBJ_CAMERA) : %.obj: %.c
	cl470 $(DRIVERS_FLAGS) -fr$(@D) $<
