/***
 *	Camera and LCD controller functional config header files
 *
 *	Robert.Chen created, 2004-06-05
 */

extern MI_dbgPrintf(const char * const format,...);

/***
 *	following macros for trace control
 */
#define CAMERA_TRACE_ENABLE		1	/* 1 enable, 0 disable */

#define CAM_TR_MASK_HAL			0x01	/* HAL function trace */
#define CAM_TR_MASK_CHIP		0x02	/* chip lib function trace */
#define CAM_TR_MASK_JPEG		0x04	/* jpeg lib function trace */
#define CAM_TR_MASK_CAMERA		0x08	/* camera lib function trace */
#define CAM_TR_MASK_APP			0x10	/* camera and lcd application trace */

#define CAMERA_TRACE_EN_MASK	(0xff)	/* default, trace all */


#if (CAMERA_TRACE_ENABLE == 1)
#define CAMERA_TR(mask, msg)		if(mask & CAMERA_TRACE_EN_MASK) MI_dbgPrintf msg
#else
#define CAMERA_TR(mask, msg)		
#endif

