//===============================================================================
//  HAL_STRUCT information generated by 13716CFG.EXE (Build 47)
//  Copyright (c) 2002 Epson Research and Development, Inc.
//  All rights reserved.
//
//  DISPLAYS      WxHxBPP     FREQ    SUBTYPE                                    
//  ------------- ----------- ------- -------------------------------------------
// *LCD1=None
//  LCD2=Parallel 128x160x16  NA      5.6.5 (16-bit)
//  LCD3=None
// 
//  DIMENSIONS    WxHxBPP 	@ STRIDE   START   SADDR     ADDITIONAL                
//  ------------- ------------------ ------- --------- --------------------------
//  Main/Resizer	128x160x16 	@ 256   		0,0	00000000h Swivel=0 Scaling=OFF
//  Overlay		128x160x8 	@ 128    		NA	0000A000h Swivel=OFF Scaling=OFF
// 
//  CLOCKS        FREQ        SOURCE                                             
//  ------------- ----------- ---------------------------------------------------
//  INCLK         54.001 MHz  PLL (via CLKI)
//  SYSCLK        54.001 MHz  INCLK/1
//  LCDPCLK       2.250 MHz   SYSCLK/24
//  CMCLKOUT      13.500 MHz  SYSCLK/4
//  I2CCLK        9.000 MHz   INCLK/6
//
//  This file INSTANTIATES the HalInfo structure, and should
//  only be included, one time, by the mini-HAL.
//===============================================================================

#include "hal_private.h"

#ifndef HAL_STRUCT_NAME
#define HAL_STRUCT_NAME HalInfo
#endif

#ifdef EPSON_ORIGINAL
#define S1D10251
//#define S1D10253
//#define S1D10237
//#define S1D50173
#else
#define INNOVATION_M288
#endif

//#ifdef INNOVATION_M288	/* Robert.Chen added, 2004-06-05 */
#if( MODEL == 5 ) //M288S
HAL_STRUCT HAL_STRUCT_NAME =
{
	50000000,					//PllClk 50M
	32768,						//internal OSC frequency
	0x02200000,					//dwBaseAddress	
	0x00000000,					//dwRegisterOffset
	0x00000000,					//dwMemoryOffset

	640, 480,					//wCam1Width, wCam1Height

	0,							//dwRequiredVRAM
	0,							//dwFlags

	/* LCD register initialization sequence (LCD1) */
	{
		HAL_LCD_ENDOFTABLE
	},

	/* LCD register initialization sequence (LCD2) */
	{
		HAL_LCD_COMMAND + 0x01, 	//main_lcd_sendcommand(0x0001);
		HAL_LCD_DELAY	+ 100,		//wait_ARM_cycles(convert_nanosec_to_cycles(100000000)); 

		//enable factory default
		HAL_LCD_COMMAND	+ 0xee,		//main_lcd_sendcommand(0x00ee);

		//set multiplication factor
		HAL_LCD_COMMAND	+ 0xc2,		//main_lcd_sendcommand(0x00c2);
		HAL_LCD_PARAM	+ 0x03,		//main_lcd_senddata(0x0003);

		//set Vop
		HAL_LCD_COMMAND	+ 0xb0,		//main_lcd_sendcommand(0x00b0);
		HAL_LCD_PARAM	+ 0x09,		//main_lcd_senddata(0x0009);
		HAL_LCD_PARAM	+ 0x0a,		//main_lcd_senddata(0x0010);

		//set contrast
		HAL_LCD_COMMAND	+ 0x25,		//main_lcd_sendcommand(0x0025);
		HAL_LCD_PARAM	+ 0x0,		//main_lcd_senddata(0x0000);

		//set bias system
		HAL_LCD_COMMAND	+ 0xc7,		//main_lcd_sendcommand(0x00c7);
		HAL_LCD_PARAM	+ 0x0b,		//main_lcd_senddata(0x000b);

		//set divider frequency
		HAL_LCD_COMMAND	+ 0xc5,		//main_lcd_sendcommand(0x00c5);
		HAL_LCD_PARAM	+ 0x20,		//main_lcd_senddata(0x0020);
		HAL_LCD_PARAM	+ 0x20,		//main_lcd_senddata(0x0020);
		HAL_LCD_PARAM	+ 0x20,		//main_lcd_senddata(0x0020);
		HAL_LCD_PARAM	+ 0x20,		//main_lcd_senddata(0x0020);

		//set TCVOP slopes A and B
		HAL_LCD_COMMAND	+ 0xc3,		//main_lcd_sendcommand(0x00c3);
		HAL_LCD_PARAM	+ 0x30,		//main_lcd_senddata(0x0030);

		//set TCVOP slopes C and D
		HAL_LCD_COMMAND	+ 0xc4,		//main_lcd_sendcommand(0x00c4);
		HAL_LCD_PARAM	+ 0x65,		//main_lcd_senddata(0x0065);

		//sleepout
		HAL_LCD_COMMAND	+ 0x11,		//main_lcd_sendcommand(0x0011);

		//colour interface pixel format
		HAL_LCD_COMMAND	+ 0x3a,		//main_lcd_sendcommand(0x003a);
		HAL_LCD_PARAM	+ 0x05,		//main_lcd_senddata(0x0005);

		//booster voltage 
		HAL_LCD_COMMAND	+ 0x03,		//main_lcd_sendcommand(0x0003);
		HAL_LCD_DELAY	+ 500,		//wait_ARM_cycles(convert_nanosec_to_cycles(500000000)); 

		//display on
		HAL_LCD_COMMAND	+ 0x29,		//main_lcd_sendcommand(0x0029);	

		//normal display mode on
		HAL_LCD_COMMAND + 0x13,		//main_lcd_sendcommand(0x0013);		

		//display inversion on
		HAL_LCD_COMMAND	+ 0x21,		//main_lcd_sendcommand(0x0021);		

		//n-line inversion
		HAL_LCD_COMMAND	+ 0xc9,		//main_lcd_sendcommand(0x00c9);		
		HAL_LCD_PARAM	+ 0x25,		//main_lcd_senddata(0x0025);

		//super frame inversion
		HAL_LCD_COMMAND	+ 0xb9,		//main_lcd_sendcommand(0x00b9);

		//memory data access control
		HAL_LCD_COMMAND	+ 0x36,		//main_lcd_sendcommand(0x0036);
		HAL_LCD_PARAM	+ 0xc0,		//main_lcd_senddata(0x00c0);

		//bottom row swap
		HAL_LCD_COMMAND	+ 0xb4,		//main_lcd_sendcommand(0x00b4);

		//top row swap
		HAL_LCD_COMMAND	+ 0xb6,		//main_lcd_sendcommand(0x00b6);

		//column address set
		HAL_LCD_COMMAND	+ 0x2a,	 	//main_lcd_sendcommand(0x002a);
		HAL_LCD_PARAM	+ 0x04,		//main_lcd_senddata(0x0004);
		HAL_LCD_PARAM	+ 0x83,		//main_lcd_senddata(0x0083);

		//page address set
		HAL_LCD_COMMAND	+ 0x2b,	  	//main_lcd_sendcommand(0x002b);
		HAL_LCD_PARAM	+ 0x04,		//main_lcd_senddata(0x0004);
		HAL_LCD_PARAM	+ 0x83,		//main_lcd_senddata(0x0083);

		HAL_LCD_COMMAND	+ 0x2c,
		
		HAL_LCD_DELAY	+ 500,		//wait_ARM_cycles(convert_nanosec_to_cycles(500000000)); 
		HAL_LCD_ENDOFTABLE
		
	},

	/* LCD register initialization sequence (LCD3) */
	{
		HAL_LCD_ENDOFTABLE
	},

	/* Initialization S1D13716 registers */
	{                    
		{ REG0018_POWERSAVE,			0x01 },//enable power save mode to set clock.	
		{ REG0014_CLKSRC,				0x00 },//select external CLKI for SYSCLK, PLL source	
		{ REG0010_PLL0,					0x19 },//0xdd },//this setting is 40M,50M is 0xDD 13M is 0x60
		{ REG0011_PLL1,					0x1d }, //0x1c },//this setting is 40M,50M is 0x1C 13M is 0xF0
		{ REG0012_PLL2,					0x20 },
		{ REG0015_SERLCDCLK,			0x21 },//I2C Clock=sysclock/8
		{ REG0014_CLKSRC,				0x31 },//LCDPCLK=sysclock/12
		{ REG0016_LCDPCLKDIV,			0x00 },//lcdpclk predivider = 1/1
		{ REG0018_POWERSAVE,			0x04 },//disable power save mode, internal pll and oscillator disable
	 	{ REGFLAG_DELAY,				0xFF },//delay for pll lock
		{ REG0070_PWMCTRL0,				0x05 },//      
		{ REG007F_PWMWHITECYCLE,		0x3F },      
		{ REG0072_PWMCTRL1,				0x01 }, 
		{ REGFLAG_DELAY,				0x50 },
		{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
		{ REG0108_CMCONTROL,			0x00 },
		{ REG0202_RESIZE,				0x81 },//Reset resizer
		{ REG0202_RESIZE,				0x01 },//Reset resizer
		{ REG0040_LCD1SETTING,			0x03 },//Data bus width 8 bits format 565
		{ REG0044_LCD2SETTING,			0x03 },//Data bus width 8 bits format 565
		{ REG0048_LCD3SETTING,			0x00 },//Not set
		{ REG004E_SCALEUP,				0x00 },//Encode Scale Overlay Disable
		{ REG004C_DISPSETTING,			0x42 },//Overlay with Main  and Overlay is 8 bits and select lcd2 62
		{ REG0036_LCDTRIG,				0x00 },
		{ REG003C_LCDXFER,				0x00 },//lcd auto transfer disable
		{ REG0248_OIMAGE,				0x10 },//The host output image to overlay 00 to main
		{ REG0216_RYC,					0x05 },//Ryc format is 565
		{ REG0220_YUVRGBXLATE0,			0x05 },//YUV,565Default value
		{ REG0222_YUVRGBXLATE1,			0x00 },//yuv/rgb converter is enabled.original UV,YUV format VYUV
		{ REG0202_RESIZE,				0x00 },//Reset and enable resizer03
		{ REG0204_RESIZESX0,			0x00 },
		{ REG0205_RESIZESX1,			0x00 },
		{ REG0206_RESIZESY0,				0x00 },
		{ REG0207_RESIZESY1,				0x00 },
		{ REG0208_RESIZEEX0,				0x7F },//127
		{ REG0209_RESIZEEX1,				0x00 },
		{ REG020A_RESIZEEY0,				0x7F },//128
		{ REG020B_RESIZEEY1,				0x00 },
		{ REG020C_RESIZEHSCALE,			0x01 },//H-scale	1:1
		{ REG020E_RESIZEVSCALE,			0x01 },//V-scale	1:1
		{ REG0210_RESIZEOP,				0x20 },//Scale mode is no scale
		{ REG024A_SWIVELVIEW,			0x00 },//Not swivel, not rotated, not mirriored
		{ REG0224_YUVWRSTART0,			0x00 },//Main window adress
		{ REG0225_YUVWRSTART1,			0x20 },//0x2000 8K
		{ REG0226_YUVWRSTART2,			0x00 },//
		{ REG0240_OSADDR0,				0x00 },//Overlay adress
		{ REG0241_OSADDR1,				0xA0 },//0xc000 so the main window size is 0xc000-0x2000
		{ REG0242_OSADDR2,				0x00 },
		{ REG0244_OHRES,				0x7F },//Overlay width
		{ REG0246_OVRES,				0x7F },//Overlay height
		{ REG0212_MEMHORZRES,			0x7F },//Actual Horizontal Resolution in Pixels -1. jpeg encode use
		{ REG0214_MEMVERTRES,			0x7F },//159
		{ REG0228_XOFFSET0,				0x00 },//Main window's position in overlay
		{ REG0229_XOFFSET1,				0x00 },
		{ REG022A_YOFFSET0,				0x10 },
		{ REG022B_YOFFSET1,				0x00 },
		{ REG0100_CMCLK,				0x02 },//camera clock setting.1 is 1/4 sysclock
		{ REG0102_CMSIGNAL,				0x02 },
		{ REG0104_CMMODE0,				0x08 },
		{ REG0106_CMMODE1,				0x00 },
		{ REGFLAG_ENDOFTABLE,			0x00 }
    },
	

	/* Initialization camera data */
	{
		// VGA MODE FOR OV7645FB
	{ 0x12, 0x80 },
	{ 0x03, 0xa4 },			//0x04----black & white//0xa4----normal
	{ 0x04, 0x30 },
	{ 0x05, 0x88 },
	{ 0x06, 0x60 },
	{ 0x11, 0x00 },			//{ 0x11, 0x00 }, //;value 01 for 15 fps
	{ 0x12, 0x15 },
	{ 0x13, 0xa3 },
	{ 0x14, 0x14 },
	{ 0x15, 0x14 },
	{ 0x1f, 0x41 },
	{ 0x20, 0xd0 },
	{ 0x23, 0xde },
	{ 0x24, 0xa0 },
	{ 0x25, 0x80 },
	{ 0x26, 0xb2 },
	{ 0x27, 0xe0 },			//0xe2----black & white//0xe0----normal
	{ 0x28, 0x20 },
	{ 0x2a, 0x01 },
	{ 0x2b, 0x00 },
	{ 0x2d, 0x05 },
	{ 0x2f, 0x9d },
	{ 0x30, 0x00 },
	{ 0x31, 0xc4 },
	{ 0x60, 0x86 },
	{ 0x61, 0xe0 },
	{ 0x62, 0x88 },
	{ 0x63, 0x11 },
	{ 0x64, 0x89 },
	{ 0x65, 0x00 },
	{ 0x67, 0x94 },
	{ 0x68, 0x7a },
	{ 0x69, 0x08 },
	{ 0x6c, 0x11 },			//0xFF----black & white//0x11----normal
	{ 0x6d, 0x33 },			//0xFF----black & white//0x33----normal
	{ 0x6e, 0x22 },			//0xFF----black & white//0x22----normal
	{ 0x6f, 0x00 },			
	{ 0x74, 0x20 },			//{ 0x74, 0x60 },  low light use 0x60
	{ 0x75, 0x0e },			//{ 0x75, 0x06 },
	{ 0x77, 0xc4 },			//{ 0x77, 0xb5 },
	//{ 0x79, 0x80 },			//set----black & white//remove----normal
	//{ 0x7a, 0x80 },			//set----black & white//remove----normal
	{ REGFLAG_ENDOFTABLE,0xFFFF}	//for end
	}	
};
#elif( MODEL == 1 )
HAL_STRUCT HAL_STRUCT_NAME =
{
	50000000,					//PllClk 50M
	32768,						//internal OSC frequency
	0x02200000,					//dwBaseAddress	
	0x00000000,					//dwRegisterOffset
	0x00000000,					//dwMemoryOffset

	640, 480,					//wCam1Width, wCam1Height

	0,							//dwRequiredVRAM
	0,							//dwFlags

	/* LCD register initialization sequence (LCD1) */
	{
		HAL_LCD_DELAY	+ 100,

		HAL_LCD_COMMAND + 0x2C, 

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x02, 
		HAL_LCD_COMMAND	+ 0x01,

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x2A, 
		HAL_LCD_COMMAND	+ 0xD5,			//213
		
		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x2B, 
		HAL_LCD_COMMAND	+ 0xA0,

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x26, 
		HAL_LCD_COMMAND	+ 0x0F,

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x10, 
		HAL_LCD_COMMAND	+ 0x02,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x20, 
		HAL_LCD_COMMAND	+ 0x05,

		//HAL_LCD_DELAY	+ 200,
//		HAL_LCD_COMMAND + 0x01, 
//		HAL_LCD_COMMAND	+ 0x00,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x40, 
		HAL_LCD_COMMAND	+ 0x00,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x22, 
		HAL_LCD_COMMAND	+ 0x11,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x24, 
		HAL_LCD_COMMAND	+ 0x11,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x28, 
		HAL_LCD_COMMAND	+ 0x00,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x34, 
		HAL_LCD_COMMAND	+ 0x8d,   //0xCF

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x2E, 
	
		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x45, 
		HAL_LCD_COMMAND	+ 0x00,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x42, 
		HAL_LCD_COMMAND	+ 0x00,
		HAL_LCD_COMMAND	+ 0x7f,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x43, 
		HAL_LCD_COMMAND	+ 0x00,
		HAL_LCD_COMMAND	+ 0x7F,

		HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x51, 
		HAL_LCD_ENDOFTABLE
	},


	/* LCD register initialization sequence (LCD2) */
	{

		HAL_LCD_DELAY	+ 100,

		HAL_LCD_COMMAND + 0xD1, 

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x81, 
		HAL_LCD_PARAM	+ 0x28,
		HAL_LCD_PARAM	+ 0x06,

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0x20, 
		HAL_LCD_PARAM	+ 0x0F,			
		
		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0xFB, 
		HAL_LCD_PARAM	+ 0x04,

		HAL_LCD_DELAY	+ 100,
		HAL_LCD_COMMAND + 0xCA, 
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x10,
		HAL_LCD_PARAM	+ 0x00,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xBC, 
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x02,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xBB, 
		HAL_LCD_PARAM	+ 0x01,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x94, 

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xA7, 

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xF2, 
		HAL_LCD_PARAM	+ 0x0F,
		HAL_LCD_PARAM	+ 0x00,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xF7, 
		HAL_LCD_PARAM	+ 0x28,
		HAL_LCD_PARAM	+ 0x2C,
		HAL_LCD_PARAM	+ 0x05,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xAF, 

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x15, 
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x60,

		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0x75, 
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x40,
		
		//HAL_LCD_DELAY	+ 200,
		HAL_LCD_COMMAND + 0xBC, 
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x00,
		HAL_LCD_PARAM	+ 0x01,  //0x01--256 color  0x02--4096 color
	
		HAL_LCD_ENDOFTABLE
	},

	/* LCD register initialization sequence (LCD3) */
	{
		HAL_LCD_ENDOFTABLE
	},

	/* Initialization S1D13716 registers */
	{  

	{ REG0018_POWERSAVE,                    0x01 },//power save enabled,crystal interface disabled, pll disabled.
	{ REG0014_CLKSRC,                       0x00 },//pll source is CLKI,sysclk is CLKI,sysclk divide ration is default, lcdpclk divide ration is defatult.

//	{ REG0010_PLL0,					0xDD },//this setting is 40M,50M is 0xDD
//	{ REG0011_PLL1,					0x1C },//this setting is 40M,50M is 0x1C
//	{ REG0012_PLL2,					0x20 },
	{ REG0010_PLL0,                         0xC2 },
	{ REG0011_PLL1,                         0x34 },
	{ REG0012_PLL2,                         0x20 },// this setting is 40M
	{ REG0015_SERLCDCLK,			0x41 },//1     //1/16 
	{ REG0014_CLKSRC,                       0xF1 },//sysclk source is pll,pll source is CLKI,sysclk divide ration is 1:1,lcdpclk divide ratio is 1/32.
	{ REG0016_LCDPCLKDIV,                   0x00 },//lcdpclk divide ration is 1:1.
	{ REG0018_POWERSAVE,                    0x04 },//pll enabled
	{ REGFLAG_DELAY,                        0xFF }, //  delay for pll lock    
	{ REG0070_PWMCTRL0,                 0x05 }, //     
	{ REG007F_PWMWHITECYCLE,       0x3F },      
	{ REG0072_PWMCTRL1,                 0x01 }, 
	{ REGFLAG_DELAY,                        0x50 },//first step
	{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
	{ REG0108_CMCONTROL,			0x00 },//software reset camera mode
	{ REG0202_RESIZE,				0x81 },//Reset resizer
	{ REG0202_RESIZE,				0x01 }, //Reset resizer,enable resize block
	{ REG0040_LCD1SETTING,                  0x03 },//
	{ REG0044_LCD2SETTING,                  0x00 },
	{ REG0048_LCD3SETTING,                  0x00 },
	{ REG004E_SCALEUP,                      0x00 },//sec step
	{ REG004C_DISPSETTING,                0x41 },// lcd1 select.
	{ REG0036_LCDTRIG,				0x00 },
	{ REG003C_LCDXFER,				0x00 },

	{ REG0248_OIMAGE,				0x10 },
	{ REG0216_RYC,					0x05 },
	{ REG0220_YUVRGBXLATE0,		0x05 },
	{ REG0222_YUVRGBXLATE1,		0x00 },//01
	{ REG0202_RESIZE,				0x00 },//0D
	{ REG0204_RESIZESX0,                    0x00 },
	{ REG0205_RESIZESX1,                    0x00 },
	{ REG0206_RESIZESY0,                    0x00 },
	{ REG0207_RESIZESY1,                    0x00 },
	{ REG0208_RESIZEEX0,                    0x7f },////7f
	{ REG0209_RESIZEEX1,                    0x01 },////0
	{ REG020A_RESIZEEY0,                    0x7f },////77
	{ REG020B_RESIZEEY1,                    0x01 },////0
	{ REG020C_RESIZEHSCALE,                 0x1 },//1
	{ REG020E_RESIZEVSCALE,                 0x1 },//1
	{ REG0210_RESIZEOP,                     0x01 },
	//{ REG0248_OIMAGE,				0x10 },
	{ REG024A_SWIVELVIEW,			0x10 },
	{ REG0224_YUVWRSTART0,                  0x00 },
	{ REG0225_YUVWRSTART1,                  0x80 },		//0x20
	{ REG0226_YUVWRSTART2,                  0x00 },
	{ REG0240_OSADDR0,                      0x00 },
	{ REG0241_OSADDR1,                      0x80 },
	{ REG0242_OSADDR2,                      0x00 },
	{ REG0244_OHRES,                        0x7F },
	{ REG0246_OVRES,                        0x7F },
	{ REG0212_MEMHORZRES,			0x7F },
	{ REG0214_MEMVERTRES,			0x7F},
	{ REG0228_XOFFSET0,                     0x00 },
	{ REG0229_XOFFSET1,                     0x00 },
	{ REG022A_YOFFSET0,                     0x00 },
	{ REG022B_YOFFSET1,                     0x00 },
	{ REG0100_CMCLK,				0x02 },
	{ REG0102_CMSIGNAL,				0x02 },
	{ REG0104_CMMODE0,				0x08 },
	{ REG0106_CMMODE1,				0x00 },
        
	{ REG0060_GPIOCONFIG,			0x02 },		//config gpio1 output, supply the core power of the sensor	/*wanghaixiang*/
	{ REG0064_GPIOSTATUS,			0x02 },		//output is high
        { REGFLAG_ENDOFTABLE,                   0x00 }

	
/*	
	{ REG0018_POWERSAVE,                    0x01 },
	{ REG0014_CLKSRC,                       0x00 },
	//{ REG0010_PLL0,                         0xC2 },
	//{ REG0011_PLL1,                         0x34 },
	//{ REG0012_PLL2,                         0x20 },
	{ REG0015_SERLCDCLK,			0x41 },		//0x41
	{ REG0014_CLKSRC,                       0xf1 },		//0xf1
	{ REG0016_LCDPCLKDIV,                   0x00 },
	{ REG0018_POWERSAVE,                    0x00 },
	{ REGFLAG_DELAY,                        0xFF },        
	{ REG0070_PWMCTRL0,                 0x05 },      
	{ REG007F_PWMWHITECYCLE,       0x3F },      
	{ REG0072_PWMCTRL1,                 0x01 }, 
	{ REGFLAG_DELAY,                        0x50 },//first step
	{ REG0108_CMCONTROL,			0x01 },
	{ REG0108_CMCONTROL,			0x00 },
	{ REG0202_RESIZE,				0x81 },
	{ REG0202_RESIZE,				0x01 }, 
	{ REG0040_LCD1SETTING,                  0x03 },
	{ REG0044_LCD2SETTING,                  0x00 },
	{ REG0048_LCD3SETTING,                  0x00 },
	{ REG004E_SCALEUP,                      0x00 },//sec step
	{ REG004C_DISPSETTING,                0x41 },
	{ REG0036_LCDTRIG,				0x00 },
	{ REG003C_LCDXFER,				0x00 },

	{ REG0248_OIMAGE,				0x10 },
	{ REG0216_RYC,					0x05 },
	{ REG0220_YUVRGBXLATE0,		0x05 },
	{ REG0222_YUVRGBXLATE1,		0x00 },//01
	{ REG0202_RESIZE,				0x00 },//0D
	{ REG0204_RESIZESX0,                    0x00 },
	{ REG0205_RESIZESX1,                    0x00 },
	{ REG0206_RESIZESY0,                    0x00 },
	{ REG0207_RESIZESY1,                    0x00 },
	{ REG0208_RESIZEEX0,                    0xff },		//0xff
	{ REG0209_RESIZEEX1,                    0x00 },		//0x01
	{ REG020A_RESIZEEY0,                    0xdf },		//0xdf
	{ REG020B_RESIZEEY1,                    0x00 },		//0x01
	{ REG020C_RESIZEHSCALE,                 0x1 },//1
	{ REG020E_RESIZEVSCALE,                 0x1 },//1
	{ REG0210_RESIZEOP,                     0x01 },
	//{ REG0248_OIMAGE,				0x10 },
	{ REG024A_SWIVELVIEW,			0x00 },
	{ REG0224_YUVWRSTART0,                  0x00 },
	{ REG0225_YUVWRSTART1,                  0x20 },
	{ REG0226_YUVWRSTART2,                  0x00 },
	{ REG0240_OSADDR0,                      0x00 },
	{ REG0241_OSADDR1,                      0x80 },
	{ REG0242_OSADDR2,                      0x00 },
	{ REG0244_OHRES,                        0x7F },
	{ REG0246_OVRES,                        0x7F },
	{ REG0212_MEMHORZRES,			0x7F },
	{ REG0214_MEMVERTRES,			0x7F},
	{ REG0228_XOFFSET0,                     0x00 },
	{ REG0229_XOFFSET1,                     0x00 },
	{ REG022A_YOFFSET0,                     0x00 },
	{ REG022B_YOFFSET1,                     0x00 },
	{ REG0100_CMCLK,				0x01 },
	{ REG0102_CMSIGNAL,				0x02 },
	{ REG0104_CMMODE0,				0x08 },
	{ REG0106_CMMODE1,				0x00 },
        
        { REGFLAG_ENDOFTABLE,                   0x00 }
*/

/*
		{ REG0018_POWERSAVE,			0x01 },	
		{ REG0014_CLKSRC,				0x00 },//select external CLKI for SYSCLK, PLL source	
		//{ REG0010_PLL0,					0x60 },//this setting is 40M,50M is 0xDD 13M is 0x60
		//{ REG0011_PLL1,					0xf0 },//this setting is 40M,50M is 0x1C 13M is 0xF0
		//{ REG0012_PLL2,					0x20 },
		{ REG0015_SERLCDCLK,			0x21 },//I2C Clock=sysclock/16
		{ REG0014_CLKSRC,				0x31 },//LCDPCLK=sysclock/24
		{ REG0016_LCDPCLKDIV,			0x00 },
		{ REG0018_POWERSAVE,			0x00 },
	 	{ REGFLAG_DELAY,				0xFF },        
		{ REG0070_PWMCTRL0,				0x05 },      
		{ REG007F_PWMWHITECYCLE,		0x3F },      
		{ REG0072_PWMCTRL1,				0x01 }, 
		{ REGFLAG_DELAY,				0x50 },
		{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
		{ REG0108_CMCONTROL,			0x00 },
		{ REG0202_RESIZE,				0x81 },//Reset resizer
		{ REG0202_RESIZE,				0x01 },//Reset resizer
		{ REG0040_LCD1SETTING,			0x03 },//Data bus width 8 bits format 565
		{ REG0044_LCD2SETTING,			0x00 },//Data bus width 8 bits format 565
		{ REG0048_LCD3SETTING,			0x00 },//Not set
		{ REG004E_SCALEUP,				0x00 },//Encode Scale Overlay Disable
		{ REG004C_DISPSETTING,			0x41 },//Overlay with Main  and Overlay is 8 bits and select lcd2 62
		{ REG0036_LCDTRIG,				0x00 },
		{ REG003C_LCDXFER,				0x00 },//lcd auto transfer disable
		{ REG0248_OIMAGE,				0x10 },//The host output image to overlay 00 to main
		{ REG0216_RYC,					0x05 },//Ryc format is 565
		{ REG0220_YUVRGBXLATE0,			0x05 },//Default value
		{ REG0222_YUVRGBXLATE1,			0x00 },
		{ REG0202_RESIZE,				0x00 },//Reset and enable resizer03
		{ REG0204_RESIZESX0,			0x00 },
		{ REG0205_RESIZESX1,			0x00 },
		{ REG0206_RESIZESY0,				0x00 },
		{ REG0207_RESIZESY1,				0x00 },
		{ REG0208_RESIZEEX0,				0x7F },//127
		{ REG0209_RESIZEEX1,				0x00 },
		{ REG020A_RESIZEEY0,				0x7F },//128
		{ REG020B_RESIZEEY1,				0x00 },
		{ REG020C_RESIZEHSCALE,			0x01 },//H-scale
		{ REG020E_RESIZEVSCALE,			0x01 },//V-scale
		{ REG0210_RESIZEOP,				0x00 },//Scale mode is no scale
		{ REG024A_SWIVELVIEW,			0x00 },//Not swivel
		{ REG0224_YUVWRSTART0,			0x00 },//Main window adress
		{ REG0225_YUVWRSTART1,			0x20 },//0x2000 8K
		{ REG0226_YUVWRSTART2,			0x00 },//
		{ REG0240_OSADDR0,				0x00 },//Overlay adress
		{ REG0241_OSADDR1,				0xC0 },//0xc000 so the main window size is 0xc000-0x2000
		{ REG0242_OSADDR2,				0x00 },
		{ REG0244_OHRES,				0x7F },//Overlay width
		{ REG0246_OVRES,				0x7F },//Overlay height
		{ REG0212_MEMHORZRES,			0x7F },//Actual Horizontal Resolution in Pixels -1. jpeg encode use
		{ REG0214_MEMVERTRES,			0x7F },//159
		{ REG0228_XOFFSET0,				0x00 },//Main window's position in overlay
		{ REG0229_XOFFSET1,				0x00 },
		{ REG022A_YOFFSET0,				0x00 },
		{ REG022B_YOFFSET1,				0x00 },
		{ REG0100_CMCLK,				0x01 },//camera clock setting.1 is 1/4 sysclock
		{ REG0102_CMSIGNAL,				0x02 },
		{ REG0104_CMMODE0,				0x08 },
		{ REG0106_CMMODE1,				0x00 },
		{ REGFLAG_ENDOFTABLE,			0x00 }
*/
    },
	

	/* Initialization camera data */
	{
		// VGA MODE FOR OV7645FB
	{ 0x12, 0x80 },
	{ 0x03, 0xa4 },			//0x04----black & white//0xa4----normal
	{ 0x04, 0x30 },
	{ 0x05, 0x88 },
	{ 0x06, 0x60 },
	{ 0x11, 0x00 },			//{ 0x11, 0x00 }, //;value 01 for 15 fps
	{ 0x12, 0x15 },
	{ 0x13, 0xa3 },
	{ 0x14, 0x14 },
	{ 0x15, 0x14 },
	{ 0x1f, 0x41 },
	{ 0x20, 0xd0 },
	{ 0x23, 0xde },
	{ 0x24, 0xa0 },
	{ 0x25, 0x80 },
	{ 0x26, 0xb2 },
	{ 0x27, 0xe0 },			//0xe2----black & white//0xe0----normal
	{ 0x28, 0x20 },
	{ 0x2a, 0x01 },
	{ 0x2b, 0x00 },
	{ 0x2d, 0x05 },
	{ 0x2f, 0x9d },
	{ 0x30, 0x00 },
	{ 0x31, 0xc4 },
	{ 0x60, 0x86 },
	{ 0x61, 0xe0 },
	{ 0x62, 0x88 },
	{ 0x63, 0x11 },
	{ 0x64, 0x89 },
	{ 0x65, 0x00 },
	{ 0x67, 0x94 },
	{ 0x68, 0x7a },
	{ 0x69, 0x08 },
	{ 0x6c, 0x11 },			//0xFF----black & white//0x11----normal
	{ 0x6d, 0x33 },			//0xFF----black & white//0x33----normal
	{ 0x6e, 0x22 },			//0xFF----black & white//0x22----normal
	{ 0x6f, 0x00 },			
	{ 0x74, 0x20 },			//{ 0x74, 0x60 },  low light use 0x60
	{ 0x75, 0x0e },			//{ 0x75, 0x06 },
	{ 0x77, 0xc4 },			//{ 0x77, 0xb5 },
	//{ 0x79, 0x80 },			//set----black & white//remove----normal
	//{ 0x7a, 0x80 },			//set----black & white//remove----normal
	{ REGFLAG_ENDOFTABLE,0xFFFF}	//for end
	}	
};

#endif


#ifdef S1D50173
HAL_STRUCT HAL_STRUCT_NAME =
{
    HALCHIPID" HAL EXE",    // HAL ID string
    "\x00",				// Configuration description
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD1 strings pool
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD2 strings pool
    "\x01" "disctl\x00\x05" "com scan\x00\abug fix\x00\bpageset\x00\vcolset\x00\x0E" "dactl\x00\x12" "disinv\x00\x13slpout\x00\x14power\x00\x17volume\x00\x1A" "dison\x00\x1Bramwr\x00",  // Serial LCD3 strings pool
    sizeof(HAL_STRUCT),	// Sizeof this structure
    0x0000,			// CRC of the rest of structure

    HALCHIPID,		// Chip ID
    0x1234,			// Endian detect (LE=0x1234)
    0,					// Reserved for alignment

    32768L,			// CLKI frequency (in Hz)
    32768L,			// Internal OSC frequency (in Hz)

    0x01000000,             // Physical base memory address
    0x00000000,             // Physical register address offset
    0x00000000,             // Physical memory address offset

    640, 480,			// Camera1 expected image size

    81920L,			// Required VRAM (in bytes)
    0,					// Hal Information flags//fNO_INIT_I2C

    {                       // LCD1 init sequence
        HAL_LCD_ENDOFTABLE
    },
    {                       // LCD2 init sequence//NEW
    	 //Gray set start
	HAL_LCD_DELAY   + 25,
	HAL_LCD_COMMAND + 0xCB,     
	HAL_LCD_PARAM   + 0x28,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x42,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x59,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x73,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x9a,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x9e, 
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xaf,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xbd,     
	HAL_LCD_PARAM   + 0x00, 
	//////////////////////
	HAL_LCD_PARAM   + 0xc9,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xd3,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xdb,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xe3,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xea,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xf0, 
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xf5,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xf9,     
	HAL_LCD_PARAM   + 0x00, 
	//////////////////////
	HAL_LCD_PARAM   + 0xfe,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x02,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x05,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x09,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x0c,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x0f, 
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x12,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x15,     
	HAL_LCD_PARAM   + 0x01, 
	//////////////////////
	HAL_LCD_PARAM   + 0x18,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x1b,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x1d,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x1f,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x21,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x23, 
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x25,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x27,     
	HAL_LCD_PARAM   + 0x01,         
	//////////////////////   
	HAL_LCD_PARAM   + 0x29,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x2b,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x2c,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x2e,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x2f,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x31, 
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x32,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x34,     
	HAL_LCD_PARAM   + 0x01,         
	//////////////////////         
	HAL_LCD_PARAM   + 0x35,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x36,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x38,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x39,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x3a,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x3b, 
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x3c,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x3d,     
	HAL_LCD_PARAM   + 0x01,         
	//////////////////////         
	HAL_LCD_PARAM   + 0x3e,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x3f,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x40,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x41,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x42,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x43, 
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x44,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x45,     
	HAL_LCD_PARAM   + 0x01,         
	//////////////////////         
	HAL_LCD_PARAM   + 0x46,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x47,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x48,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x49,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x4a,     
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0x4b, 
	HAL_LCD_PARAM   + 0x01,     
	HAL_LCD_PARAM   + 0xf4,     
	HAL_LCD_PARAM   + 0x01,     
	//Gray set end
	//Display control set start
	HAL_LCD_COMMAND + 0xCA,     
	HAL_LCD_PARAM   + 0x4C,     
	HAL_LCD_PARAM   + 0x01, 
	HAL_LCD_PARAM   + 0x66,     
	HAL_LCD_PARAM   + 0x00,  
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0xB4,  
	HAL_LCD_PARAM   + 0x9F,     
	HAL_LCD_PARAM   + 0x0A,  
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,  
	//Display control set end
	//Data control set strat
	HAL_LCD_COMMAND + 0xBC,     
	HAL_LCD_PARAM   + 0x22,     
	HAL_LCD_PARAM   + 0x00, 
	//Data control set end
	//page address set start
	HAL_LCD_COMMAND + 0x75,     
	HAL_LCD_PARAM   + 0x00,     
	HAL_LCD_PARAM   + 0x9F,
	//page address set end
	//column address set 
	HAL_LCD_COMMAND + 0x15,     
	HAL_LCD_PARAM   + 0x8C,     
	HAL_LCD_PARAM   + 0x00, 
	HAL_LCD_PARAM   + 0x0B,     
	HAL_LCD_PARAM   + 0x01,  
	// Sleep out set start
	HAL_LCD_COMMAND + 0x94,     
	HAL_LCD_DELAY   + 500, 
	//Sleep out set end
	//Display on
	HAL_LCD_COMMAND + 0xAF,
	HAL_LCD_DELAY   + 100,  
	//Power ic control for evr
	HAL_LCD_COMMAND + 0xC6,
	HAL_LCD_PARAM   + 0x80,
	HAL_LCD_DELAY   + 200, 
	HAL_LCD_COMMAND + 0xC6, 
	HAL_LCD_PARAM   + 0x47,//47,
	//contranst up set start 

	HAL_LCD_DELAY   + 200,
	HAL_LCD_COMMAND + 0xC6,// 1
	HAL_LCD_PARAM   + 0x9D, 
	HAL_LCD_DELAY   + 100, 

	HAL_LCD_COMMAND + 0xC6,// 2
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100,  
	HAL_LCD_COMMAND + 0xC6,// 3    
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100,  
	HAL_LCD_COMMAND + 0xC6,// 4     
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100, 
	HAL_LCD_COMMAND + 0xC6,// 5     
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100, 
	HAL_LCD_COMMAND + 0xC6,// 6     
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100, 
	HAL_LCD_COMMAND + 0xC6,//7     
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100, 
	HAL_LCD_COMMAND + 0xC6,// 8     
	HAL_LCD_PARAM   + 0x9D,     
	HAL_LCD_DELAY   + 100, 

	//contranstup set end
	// read for write
	HAL_LCD_COMMAND + 0x5C,     
	HAL_LCD_ENDOFTABLE
    },
    {                       // LCD3 init sequence
        HAL_LCD_ENDOFTABLE
    },

    {                       // S1D13716 init registers
	{ REG0018_POWERSAVE,			0x01 },
	{ REG0014_CLKSRC,				0x00 },
	{ REG0010_PLL0,					0xDD },//this setting is 40M,50M is 0xDD
	{ REG0011_PLL1,					0x1C },//this setting is 40M,50M is 0x1C
	{ REG0012_PLL2,					0x20 },
	{ REG0015_SERLCDCLK,			0x41 },//I2C Clock=sysclock/16
	{ REG0014_CLKSRC,				0x51 },//LCDPCLK=sysclock/24
	{ REG0016_LCDPCLKDIV,			0x00 },
	{ REG0018_POWERSAVE,			0x04 },
 	{ REGFLAG_DELAY,				0xFF },        
	//{ REG0070_PWMCTRL0,				0x05 }, //Trun on back light     
	//{ REG007F_PWMWHITECYCLE,		0x3F },      
	//{ REG0072_PWMCTRL1,				0x01 }, 
	{ REGFLAG_DELAY,				0x50 },
	{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
	{ REG0108_CMCONTROL,			0x00 },
	{ REG0202_RESIZE,				0x81 },//Reset resizer
	{ REG0202_RESIZE,				0x01 },//Reset resizer
	{ REG0040_LCD1SETTING,			0x05 },//Data bus width 16 bits format 565
	{ REG0044_LCD2SETTING,			0x05 },//Data bus width 16 bits format 565
	{ REG0048_LCD3SETTING,			0x00 },//Not set
	{ REG004E_SCALEUP,				0x00 },//Encode Scale Overlay Disable
	{ REG004C_DISPSETTING,			0x62 },//Overlay with Main  and Overlay is 8 bits and select lcd2
	{ REG0036_LCDTRIG,				0x00 },
	{ REG003C_LCDXFER,				0x00 },//lcd auto transfer disable
	{ REG0248_OIMAGE,				0x10 },//The host output image to overlay 00 to main
	{ REG0216_RYC,					0x05 },//Ryc format is 565
	{ REG0220_YUVRGBXLATE0,			0x05 },//Default value
	{ REG0222_YUVRGBXLATE1,			0x00 },
	//{ REG0202_RESIZE,				0x03 },//Reset and enable resizer
	{ REG0204_RESIZESX0,			0x00 },
	{ REG0205_RESIZESX1,			0x00 },
	{ REG0206_RESIZESY0,				0x00 },
	{ REG0207_RESIZESY1,				0x00 },
	{ REG0208_RESIZEEX0,				0x7F },//127
	{ REG0209_RESIZEEX1,				0x00 },
	{ REG020A_RESIZEEY0,				0x9F },//160
	{ REG020B_RESIZEEY1,				0x00 },
	{ REG020C_RESIZEHSCALE,			0x01 },//H-scale
	{ REG020E_RESIZEVSCALE,			0x01 },//V-scale
	{ REG0210_RESIZEOP,				0x00 },//Scale mode is no scale
	{ REG024A_SWIVELVIEW,			0x00 },//Not swivel
	{ REG0224_YUVWRSTART0,			0x00 },//Main window adress
	{ REG0225_YUVWRSTART1,			0x20 },//0x2000 8K
	{ REG0226_YUVWRSTART2,			0x00 },//
	{ REG0240_OSADDR0,				0x00 },//Overlay adress
	{ REG0241_OSADDR1,				0xC0 },//0xc000 so the main window size is 0xc000-0x2000
	{ REG0242_OSADDR2,				0x00 },
	{ REG0244_OHRES,				0x7F },//Overlay width
	{ REG0246_OVRES,				0x9F },//Overlay height
	{ REG0212_MEMHORZRES,			0x7F },//Actual Horizontal Resolution in Pixels -1. jpeg encode use
	{ REG0214_MEMVERTRES,			0x9F },//159
	{ REG0228_XOFFSET0,				0x00 },//Main window's position in overlay
	{ REG0229_XOFFSET1,				0x00 },
	{ REG022A_YOFFSET0,				0x00 },
	{ REG022B_YOFFSET1,				0x00 },
	{ REG0100_CMCLK,				0x02 },//camera clock setting.1 is 1/4 sysclock
	{ REG0102_CMSIGNAL,				0x02 },
    { REG0104_CMMODE0,				0x08 },
    { REG0106_CMMODE1,				0x00 },
	{ REG0110_CMSTROBECTRL,			0x80 },
	{ REGFLAG_ENDOFTABLE,			0x00 }
    },
    {
	// VGA MODE FOR OV7645FB
	{ 0x12, 0x80 },
	{ 0x03, 0xa4 },			//0x04----black & white//0xa4----normal
	{ 0x04, 0x30 },
	{ 0x05, 0x88 },
	{ 0x06, 0x60 },
	{ 0x11, 0x00 },			//{ 0x11, 0x00 }, //;value 01 for 15 fps
	{ 0x12, 0x15 },
	{ 0x13, 0x0B3 },			//{ 0x13, 0x0A3 },
	{ 0x14, 0x14 },
	{ 0x15, 0x14 },
	{ 0x1f, 0x41 },
	{ 0x20, 0xd0 },
	{ 0x23, 0xde },
	{ 0x24, 0xa0 },
	{ 0x25, 0x80 },
	{ 0x26, 0xb2 },
	{ 0x27, 0xe2 },			//0xe2----black & white//0xe0----normal
	{ 0x28, 0x20 },
	{ 0x2a, 0x01 },
	{ 0x2b, 0x00 },
	{ 0x2d, 0x05 },
	{ 0x2f, 0x9d },
	{ 0x30, 0x00 },
	{ 0x31, 0xc4 },
	{ 0x60, 0x86 },
	{ 0x61, 0xe0 },
	{ 0x62, 0x88 },
	{ 0x63, 0x11 },
	{ 0x64, 0x89 },
	{ 0x65, 0x00 },
	{ 0x67, 0x94 },
	{ 0x68, 0x7a },
	{ 0x69, 0x08 },
	{ 0x6c, 0x11 },			//0xFF----black & white//0x11----normal
	{ 0x6d, 0x33 },			//0xFF----black & white//0x33----normal
	{ 0x6e, 0x22 },			//0xFF----black & white//0x22----normal
	{ 0x6f, 0x00 },			
	{ 0x74, 0x20 },			//{ 0x74, 0x60 },  low light use 0x60
	{ 0x75, 0x0e },			//{ 0x75, 0x06 },
	{ 0x77, 0xc4 },			//{ 0x77, 0xb5 },
	//{ 0x79, 0x80 },			//set----black & white//remove----normal
	//{ 0x7a, 0x80 },			//set----black & white//remove----normal
	{ REGFLAG_ENDOFTABLE,0xFFFF}	//for end
   }
};
#endif

#ifdef S1D10251
HAL_STRUCT HAL_STRUCT_NAME =
{
    HALCHIPID" HAL EXE",    // HAL ID string
    "\x00",				// Configuration description
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD1 strings pool
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD2 strings pool
    "\x01" "disctl\x00\x05" "com scan\x00\abug fix\x00\bpageset\x00\vcolset\x00\x0E" "dactl\x00\x12" "disinv\x00\x13slpout\x00\x14power\x00\x17volume\x00\x1A" "dison\x00\x1Bramwr\x00",  // Serial LCD3 strings pool
    sizeof(HAL_STRUCT),	// Sizeof this structure
    0x0000,			// CRC of the rest of structure

    HALCHIPID,		// Chip ID
    0x1234,			// Endian detect (LE=0x1234)
    0,					// Reserved for alignment

    32768L,			// CLKI frequency (in Hz)
    32768L,			// Internal OSC frequency (in Hz)

    0x01000000,             // Physical base memory address
    0x00000000,             // Physical register address offset
    0x00000000,             // Physical memory address offset

    640, 480,			// Camera1 expected image size

    81920L,			// Required VRAM (in bytes)
    0,					// Hal Information flags//fNO_INIT_I2C

    {                       // LCD1 init sequence
        HAL_LCD_ENDOFTABLE
    },
    {                       // LCD2 init sequence//NEW
	//Soft reset
	HAL_LCD_PARAM   + 0x100,
	HAL_LCD_COMMAND + 0x01,  
	HAL_LCD_PARAM   + 0x100,
	//Soft reset end

	//Contrast
	HAL_LCD_COMMAND + 0x25, 
	HAL_LCD_PARAM   + 0x3D, 
	
	//column address set
	HAL_LCD_COMMAND + 0x2A, 
	HAL_LCD_PARAM   + 0x02, 
	HAL_LCD_PARAM   + 0x81,
	
	//page address set
	HAL_LCD_COMMAND + 0x2B, 
	HAL_LCD_PARAM   + 0x02, 
	HAL_LCD_PARAM   + 0x81,	

	//memory access control
	HAL_LCD_COMMAND + 0x36, 
	HAL_LCD_PARAM   + 0x48, 

	//interface pixel format
	HAL_LCD_COMMAND + 0x3A, 
	HAL_LCD_PARAM   + 0x05,

	//gray scale position set(GCPSET0)
	HAL_LCD_COMMAND + 0xB3, 
	HAL_LCD_PARAM   + 0x03,     
	HAL_LCD_PARAM   + 0x05,     
	HAL_LCD_PARAM   + 0x09,     
	HAL_LCD_PARAM   + 0x0D,     
	HAL_LCD_PARAM   + 0x12,     
	HAL_LCD_PARAM   + 0x14,     
	HAL_LCD_PARAM   + 0x17,     
	HAL_LCD_PARAM   + 0x1C,     
	HAL_LCD_PARAM   + 0x20,     
	HAL_LCD_PARAM   + 0x23,     
	HAL_LCD_PARAM   + 0x26, 
	HAL_LCD_PARAM   + 0x2A,     
	HAL_LCD_PARAM   + 0x2D,     
	HAL_LCD_PARAM   + 0x30,     
	HAL_LCD_PARAM   + 0x32,     
	HAL_LCD_PARAM   + 0x35, 
	//////////////////////
	HAL_LCD_PARAM   + 0x37,     
	HAL_LCD_PARAM   + 0x39,     
	HAL_LCD_PARAM   + 0x3B,     
	HAL_LCD_PARAM   + 0x3D,     
	HAL_LCD_PARAM   + 0x3F,     
	HAL_LCD_PARAM   + 0x41,     
	HAL_LCD_PARAM   + 0x43,     
	HAL_LCD_PARAM   + 0x45,     
	HAL_LCD_PARAM   + 0x46,     
	HAL_LCD_PARAM   + 0x48,     
	HAL_LCD_PARAM   + 0x4A, 
	HAL_LCD_PARAM   + 0x4B,     
	HAL_LCD_PARAM   + 0x4D,     
	HAL_LCD_PARAM   + 0x4E,     
	HAL_LCD_PARAM   + 0x4F,     
	HAL_LCD_PARAM   + 0x51, 
	//////////////////////
	HAL_LCD_PARAM   + 0x52,     
	HAL_LCD_PARAM   + 0x53,     
	HAL_LCD_PARAM   + 0x54,     
	HAL_LCD_PARAM   + 0x55,     
	HAL_LCD_PARAM   + 0x56,     
	HAL_LCD_PARAM   + 0x57,     
	HAL_LCD_PARAM   + 0x58,     
	HAL_LCD_PARAM   + 0x5A,     
	HAL_LCD_PARAM   + 0x5B,     
	HAL_LCD_PARAM   + 0x5C,     
	HAL_LCD_PARAM   + 0x5D, 
	HAL_LCD_PARAM   + 0x5E,     
	HAL_LCD_PARAM   + 0x5F,     
	HAL_LCD_PARAM   + 0x60,     
	HAL_LCD_PARAM   + 0x61,     
	HAL_LCD_PARAM   + 0x62, 
	//////////////////////
	HAL_LCD_PARAM   + 0x63,     
	HAL_LCD_PARAM   + 0x64,     
	HAL_LCD_PARAM   + 0x65,     
	HAL_LCD_PARAM   + 0x66,     
	HAL_LCD_PARAM   + 0x67,     
	HAL_LCD_PARAM   + 0x68,     
	HAL_LCD_PARAM   + 0x69,     
	HAL_LCD_PARAM   + 0x6A,     
	HAL_LCD_PARAM   + 0x6B,     
	HAL_LCD_PARAM   + 0x6C,     
	HAL_LCD_PARAM   + 0x6D, 
	HAL_LCD_PARAM   + 0x6F,     
	HAL_LCD_PARAM   + 0x70,     
	HAL_LCD_PARAM   + 0x73,     
	HAL_LCD_PARAM   + 0x76,     
	HAL_LCD_PARAM   + 0x7E,         

	//gray scale position set(GCPSET1)
	HAL_LCD_COMMAND + 0xB4,     
	HAL_LCD_PARAM   + 0x0A,     
	HAL_LCD_PARAM   + 0x10,     
	HAL_LCD_PARAM   + 0x1C,     
	HAL_LCD_PARAM   + 0x28,     
	HAL_LCD_PARAM   + 0x32,     
	HAL_LCD_PARAM   + 0x3A,     
	HAL_LCD_PARAM   + 0x41,     
	HAL_LCD_PARAM   + 0x47,     
	HAL_LCD_PARAM   + 0x4C,     
	HAL_LCD_PARAM   + 0x51,     
	HAL_LCD_PARAM   + 0x55, 
	HAL_LCD_PARAM   + 0x5A,     
	HAL_LCD_PARAM   + 0x5F,     
	HAL_LCD_PARAM   + 0x67,     
	HAL_LCD_PARAM   + 0x72,     
	HAL_LCD_PARAM   + 0x7E, 

	//Display control set start
	HAL_LCD_COMMAND + 0xB6,     
	HAL_LCD_PARAM   + 0x7E,     
	HAL_LCD_PARAM   + 0x0A, 
	HAL_LCD_PARAM   + 0x8C,     
	HAL_LCD_PARAM   + 0x86,  
	HAL_LCD_PARAM   + 0x82,     

	//Temperature gradients of LCD driver voltage set start
	HAL_LCD_COMMAND + 0xB7,
	HAL_LCD_PARAM   + 0x02,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,	
	HAL_LCD_PARAM   + 0x1C,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,	
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,

	//Drive position set start ***************??
	HAL_LCD_COMMAND + 0xBA,     
	HAL_LCD_PARAM   + 0x3F,  
	HAL_LCD_PARAM   + 0x3F, 
	
	//Drive position set start
	HAL_LCD_COMMAND + 0xBB,     
	HAL_LCD_PARAM   + 0x04,  

	//Power control set start
	HAL_LCD_COMMAND + 0xBE,     
	HAL_LCD_PARAM   + 0x69,     
	HAL_LCD_PARAM   + 0x02,

	//sleep out
	HAL_LCD_COMMAND + 0x11,   
	HAL_LCD_DELAY   + 100,  
	
	//normal display mode on
	HAL_LCD_COMMAND + 0x13,   
	
	//Display on
	HAL_LCD_COMMAND + 0x29,
	HAL_LCD_DELAY   + 100,  
	
	//Memory write
	HAL_LCD_COMMAND + 0x2C,
	HAL_LCD_DELAY   + 100, 
	
	//10251 Set end
	HAL_LCD_ENDOFTABLE
    },
    {                       // LCD3 init sequence
        HAL_LCD_ENDOFTABLE
    },

    {                       // S1D13716 init registers
	{ REG0018_POWERSAVE,			0x01 },
	{ REG0014_CLKSRC,				0x00 },
	//{ REG0010_PLL0,					0xc4 },//test26M, 13M is 60
	//{ REG0011_PLL1,					0xF0 },//test26M, 13M is F0
	{ REG0010_PLL0,					0xDD },//this setting is 40M,50M is 0xDD
	{ REG0011_PLL1,					0x1C },//this setting is 40M,50M is 0x1C
	{ REG0012_PLL2,					0x20 },
	{ REG0015_SERLCDCLK,			0x41 },//I2C Clock=sysclock/16
	{ REG0014_CLKSRC,				0xB1 },//LCDPCLK=sysclock/24 0x21=sysclock/6
	{ REG0016_LCDPCLKDIV,			0x00 },
	{ REG0018_POWERSAVE,			0x04 },
 	{ REGFLAG_DELAY,				0xFF },        
	{ REG0070_PWMCTRL0,				0x05 },      
	{ REG007F_PWMWHITECYCLE,		0x3F },      
	{ REG0072_PWMCTRL1,				0x01 }, 
	{ REGFLAG_DELAY,				0x50 },
	{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
	{ REG0108_CMCONTROL,			0x00 },
	{ REG0202_RESIZE,				0x81 },//Reset resizer
	{ REG0202_RESIZE,				0x01 },//Reset resizer
	{ REG0040_LCD1SETTING,			0x03 },//Data bus width 8 bits format 565
	{ REG0044_LCD2SETTING,			0x03 },//Data bus width 8 bits format 565
	{ REG0048_LCD3SETTING,			0x00 },//Not set
	{ REG004E_SCALEUP,				0x00 },//Encode Scale Overlay Disable
	{ REG004C_DISPSETTING,			0x62 },//Overlay with Main  and Overlay is 8 bits and select lcd2
	{ REG0036_LCDTRIG,				0x00 },
	{ REG003C_LCDXFER,				0x00 },//lcd auto transfer disable
	{ REG0248_OIMAGE,				0x10 },//The host output image to overlay 00 to main
	{ REG0216_RYC,					0x05 },//Ryc format is 565
	{ REG0220_YUVRGBXLATE0,			0x05 },//Default value
	{ REG0222_YUVRGBXLATE1,			0x00 },
	{ REG0202_RESIZE,				0x03 },//Reset and enable resizer
	{ REG0204_RESIZESX0,			0x00 },
	{ REG0205_RESIZESX1,			0x00 },
	{ REG0206_RESIZESY0,				0x00 },
	{ REG0207_RESIZESY1,				0x00 },
	{ REG0208_RESIZEEX0,				0x7F },//127
	{ REG0209_RESIZEEX1,				0x00 },
	{ REG020A_RESIZEEY0,				0x7F },//128
	{ REG020B_RESIZEEY1,				0x00 },
	{ REG020C_RESIZEHSCALE,			0x01 },//H-scale
	{ REG020E_RESIZEVSCALE,			0x01 },//V-scale
	{ REG0210_RESIZEOP,				0x40 },//Scale mode is no scale
	{ REG024A_SWIVELVIEW,			0x00 },//Not swivel
	{ REG0224_YUVWRSTART0,			0x00 },//Main window adress
	{ REG0225_YUVWRSTART1,			0x40 },//0x2000 8K
	{ REG0226_YUVWRSTART2,			0x00 },//
	{ REG0240_OSADDR0,				0x00 },//Overlay adress
	{ REG0241_OSADDR1,				0xC0 },//0xc000 so the main window size is 0xc000-0x2000
	{ REG0242_OSADDR2,				0x00 },
	{ REG0244_OHRES,				0x7F },//Overlay width
	{ REG0246_OVRES,				0x7F },//Overlay height
	{ REG0212_MEMHORZRES,			0x7F },//Actual Horizontal Resolution in Pixels -1. jpeg encode use
	{ REG0214_MEMVERTRES,			0x7F },//159
	{ REG0228_XOFFSET0,				0x00 },//Main window's position in overlay
	{ REG0229_XOFFSET1,				0x00 },
	{ REG022A_YOFFSET0,				0x00 },
	{ REG022B_YOFFSET1,				0x00 },
	{ REG0100_CMCLK,				0x00 },//camera clock setting.1 is 1/4 sysclock
	{ REG0102_CMSIGNAL,				0x02 },
       { REG0104_CMMODE0,				0x08 },
       { REG0106_CMMODE1,				0x00 },
	{ REGFLAG_ENDOFTABLE,			0x00 }
    },
    {
	// VGA MODE FOR OV7645FB
	{ 0x12, 0x80 },
	{ 0x03, 0xa4 },			//0x04----black & white//0xa4----normal
	{ 0x04, 0x30 },
	{ 0x05, 0x88 },
	{ 0x06, 0x60 },
	{ 0x11, 0x00 },			//{ 0x11, 0x00 }, //;value 01 for 15 fps
	{ 0x12, 0x15 },
	{ 0x13, 0xa3 },
	{ 0x14, 0x14 },
	{ 0x15, 0x14 },
	{ 0x1f, 0x41 },
	{ 0x20, 0xd0 },
	{ 0x23, 0xde },
	{ 0x24, 0xa0 },
	{ 0x25, 0x80 },
	{ 0x26, 0xb2 },
	{ 0x27, 0xe2 },			//0xe2----black & white//0xe0----normal
	{ 0x28, 0x20 },
	{ 0x2a, 0x01 },
	{ 0x2b, 0x00 },
	{ 0x2d, 0x05 },
	{ 0x2f, 0x9d },
	{ 0x30, 0x00 },
	{ 0x31, 0xc4 },
	{ 0x60, 0x86 },
	{ 0x61, 0xe0 },
	{ 0x62, 0x88 },
	{ 0x63, 0x11 },
	{ 0x64, 0x89 },
	{ 0x65, 0x00 },
	{ 0x67, 0x94 },
	{ 0x68, 0x7a },
	{ 0x69, 0x08 },
	{ 0x6c, 0x11 },			//0xFF----black & white//0x11----normal
	{ 0x6d, 0x33 },			//0xFF----black & white//0x33----normal
	{ 0x6e, 0x22 },			//0xFF----black & white//0x22----normal
	{ 0x6f, 0x00 },			
	{ 0x74, 0x20 },			//{ 0x74, 0x60 },  low light use 0x60
	{ 0x75, 0x0e },			//{ 0x75, 0x06 },
	{ 0x77, 0xc4 },			//{ 0x77, 0xb5 },
	//{ 0x79, 0x80 },			//set----black & white//remove----normal
	//{ 0x7a, 0x80 },			//set----black & white//remove----normal
	{ REGFLAG_ENDOFTABLE,0xFFFF}	//for end
   }
};
#endif

#ifdef S1D10237
HAL_STRUCT HAL_STRUCT_NAME =
{
    HALCHIPID" HAL EXE",    // HAL ID string
    "\x00",				// Configuration description
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD1 strings pool
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD2 strings pool
    "\x01" "disctl\x00\x05" "com scan\x00\abug fix\x00\bpageset\x00\vcolset\x00\x0E" "dactl\x00\x12" "disinv\x00\x13slpout\x00\x14power\x00\x17volume\x00\x1A" "dison\x00\x1Bramwr\x00",  // Serial LCD3 strings pool
    sizeof(HAL_STRUCT),	// Sizeof this structure
    0x0000,			// CRC of the rest of structure

    HALCHIPID,		// Chip ID
    0x1234,			// Endian detect (LE=0x1234)
    0,					// Reserved for alignment

    32768L,			// CLKI frequency (in Hz)
    32768L,			// Internal OSC frequency (in Hz)

    0x01000000,             // Physical base memory address
    0x00000000,             // Physical register address offset
    0x00000000,             // Physical memory address offset

    640, 480,			// Camera1 expected image size

    81920L,			// Required VRAM (in bytes)
    0,					// Hal Information flags//fNO_INIT_I2C

    {                       // LCD1 init sequence
        HAL_LCD_ENDOFTABLE
    },
    {                       // LCD2 init sequence//NEW
	//Soft reset
	HAL_LCD_PARAM   + 0x100,
	HAL_LCD_COMMAND + 0x01,  
	HAL_LCD_PARAM   + 0x100,
	//Soft reset end

	//Contrast
	HAL_LCD_COMMAND + 0x25, 
	HAL_LCD_PARAM   + 0x3D, 
	
	//column address set
	HAL_LCD_COMMAND + 0x2A, 
	HAL_LCD_PARAM   + 0x02, 
	HAL_LCD_PARAM   + 0x81,
	
	//page address set
	HAL_LCD_COMMAND + 0x2B, 
	HAL_LCD_PARAM   + 0x02, 
	HAL_LCD_PARAM   + 0x81,	

	//memory access control
	HAL_LCD_COMMAND + 0x36, 
	HAL_LCD_PARAM   + 0x48, 

	//interface pixel format
	HAL_LCD_COMMAND + 0x3A, 
	HAL_LCD_PARAM   + 0x05,

	//gray scale position set(GCPSET0)
	HAL_LCD_COMMAND + 0xB3, 
	HAL_LCD_PARAM   + 0x03,     
	HAL_LCD_PARAM   + 0x05,     
	HAL_LCD_PARAM   + 0x09,     
	HAL_LCD_PARAM   + 0x0D,     
	HAL_LCD_PARAM   + 0x12,     
	HAL_LCD_PARAM   + 0x14,     
	HAL_LCD_PARAM   + 0x17,     
	HAL_LCD_PARAM   + 0x1C,     
	HAL_LCD_PARAM   + 0x20,     
	HAL_LCD_PARAM   + 0x23,     
	HAL_LCD_PARAM   + 0x26, 
	HAL_LCD_PARAM   + 0x2A,     
	HAL_LCD_PARAM   + 0x2D,     
	HAL_LCD_PARAM   + 0x30,     
	HAL_LCD_PARAM   + 0x32,     
	HAL_LCD_PARAM   + 0x35, 
	//////////////////////
	HAL_LCD_PARAM   + 0x37,     
	HAL_LCD_PARAM   + 0x39,     
	HAL_LCD_PARAM   + 0x3B,     
	HAL_LCD_PARAM   + 0x3D,     
	HAL_LCD_PARAM   + 0x3F,     
	HAL_LCD_PARAM   + 0x41,     
	HAL_LCD_PARAM   + 0x43,     
	HAL_LCD_PARAM   + 0x45,     
	HAL_LCD_PARAM   + 0x46,     
	HAL_LCD_PARAM   + 0x48,     
	HAL_LCD_PARAM   + 0x4A, 
	HAL_LCD_PARAM   + 0x4B,     
	HAL_LCD_PARAM   + 0x4D,     
	HAL_LCD_PARAM   + 0x4E,     
	HAL_LCD_PARAM   + 0x4F,     
	HAL_LCD_PARAM   + 0x51, 
	//////////////////////
	HAL_LCD_PARAM   + 0x52,     
	HAL_LCD_PARAM   + 0x53,     
	HAL_LCD_PARAM   + 0x54,     
	HAL_LCD_PARAM   + 0x55,     
	HAL_LCD_PARAM   + 0x56,     
	HAL_LCD_PARAM   + 0x57,     
	HAL_LCD_PARAM   + 0x58,     
	HAL_LCD_PARAM   + 0x5A,     
	HAL_LCD_PARAM   + 0x5B,     
	HAL_LCD_PARAM   + 0x5C,     
	HAL_LCD_PARAM   + 0x5D, 
	HAL_LCD_PARAM   + 0x5E,     
	HAL_LCD_PARAM   + 0x5F,     
	HAL_LCD_PARAM   + 0x60,     
	HAL_LCD_PARAM   + 0x61,     
	HAL_LCD_PARAM   + 0x62, 
	//////////////////////
	HAL_LCD_PARAM   + 0x63,     
	HAL_LCD_PARAM   + 0x64,     
	HAL_LCD_PARAM   + 0x65,     
	HAL_LCD_PARAM   + 0x66,     
	HAL_LCD_PARAM   + 0x67,     
	HAL_LCD_PARAM   + 0x68,     
	HAL_LCD_PARAM   + 0x69,     
	HAL_LCD_PARAM   + 0x6A,     
	HAL_LCD_PARAM   + 0x6B,     
	HAL_LCD_PARAM   + 0x6C,     
	HAL_LCD_PARAM   + 0x6D, 
	HAL_LCD_PARAM   + 0x6F,     
	HAL_LCD_PARAM   + 0x70,     
	HAL_LCD_PARAM   + 0x73,     
	HAL_LCD_PARAM   + 0x76,     
	HAL_LCD_PARAM   + 0x7E,         

	//gray scale position set(GCPSET1)
	HAL_LCD_COMMAND + 0xB4,     
	HAL_LCD_PARAM   + 0x0A,     
	HAL_LCD_PARAM   + 0x10,     
	HAL_LCD_PARAM   + 0x1C,     
	HAL_LCD_PARAM   + 0x28,     
	HAL_LCD_PARAM   + 0x32,     
	HAL_LCD_PARAM   + 0x3A,     
	HAL_LCD_PARAM   + 0x41,     
	HAL_LCD_PARAM   + 0x47,     
	HAL_LCD_PARAM   + 0x4C,     
	HAL_LCD_PARAM   + 0x51,     
	HAL_LCD_PARAM   + 0x55, 
	HAL_LCD_PARAM   + 0x5A,     
	HAL_LCD_PARAM   + 0x5F,     
	HAL_LCD_PARAM   + 0x67,     
	HAL_LCD_PARAM   + 0x72,     
	HAL_LCD_PARAM   + 0x7E, 

	//Display control set start
	HAL_LCD_COMMAND + 0xB6,     
	HAL_LCD_PARAM   + 0x7E,     
	HAL_LCD_PARAM   + 0x0A, 
	HAL_LCD_PARAM   + 0x84,     
	HAL_LCD_PARAM   + 0x86,  
	HAL_LCD_PARAM   + 0x82,     

	//Temperature gradients of LCD driver voltage set start
	HAL_LCD_COMMAND + 0xB7,
	HAL_LCD_PARAM   + 0x02,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,	
	HAL_LCD_PARAM   + 0x1C,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,	
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,
	HAL_LCD_PARAM   + 0x00,

	//Drive position set start ***************??
	HAL_LCD_COMMAND + 0xBA,     
	HAL_LCD_PARAM   + 0x3F,  
	HAL_LCD_PARAM   + 0x3F, 
	
	//Drive position set start
	HAL_LCD_COMMAND + 0xBB,     
	HAL_LCD_PARAM   + 0x04,  

	//Power control set start
	HAL_LCD_COMMAND + 0xBE,     
	HAL_LCD_PARAM   + 0x69,     
	HAL_LCD_PARAM   + 0x01,

	//sleep out
	HAL_LCD_COMMAND + 0x11,   
	HAL_LCD_DELAY   + 100,  
	
	//normal display mode on
	HAL_LCD_COMMAND + 0x13,   
	
	//Display on
	HAL_LCD_COMMAND + 0x29,
	HAL_LCD_DELAY   + 100,  
	
	//Memory write
	HAL_LCD_COMMAND + 0x2C,
	HAL_LCD_DELAY   + 100, 
	
	//10251 Set end
	HAL_LCD_ENDOFTABLE
    },
    {                       // LCD3 init sequence
        HAL_LCD_ENDOFTABLE
    },

    {                       // S1D13716 init registers
	{ REG0018_POWERSAVE,			0x01 },
	{ REG0014_CLKSRC,				0x00 },
	{ REG0010_PLL0,					0xDD },//this setting is 40M,50M is 0xDD 13M is 0x60
	{ REG0011_PLL1,					0x1C },//this setting is 40M,50M is 0x1C 13M is 0xF0
	{ REG0012_PLL2,					0x20 },
	{ REG0015_SERLCDCLK,			0x41 },//I2C Clock=sysclock/16
	{ REG0014_CLKSRC,				0xB1 },//LCDPCLK=sysclock/24
	{ REG0016_LCDPCLKDIV,			0x00 },
	{ REG0018_POWERSAVE,			0x04 },
 	{ REGFLAG_DELAY,				0xFF },        
	{ REG0070_PWMCTRL0,				0x05 },      
	{ REG007F_PWMWHITECYCLE,		0x3F },      
	{ REG0072_PWMCTRL1,				0x01 }, 
	{ REGFLAG_DELAY,				0x50 },
	{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
	{ REG0108_CMCONTROL,			0x00 },
	{ REG0202_RESIZE,				0x81 },//Reset resizer
	{ REG0202_RESIZE,				0x01 },//Reset resizer
	{ REG0040_LCD1SETTING,			0x03 },//Data bus width 8 bits format 565
	{ REG0044_LCD2SETTING,			0x03 },//Data bus width 8 bits format 565
	{ REG0048_LCD3SETTING,			0x00 },//Not set
	{ REG004E_SCALEUP,				0x00 },//Encode Scale Overlay Disable
	{ REG004C_DISPSETTING,			0x62 },//Overlay with Main  and Overlay is 8 bits and select lcd2
	{ REG0036_LCDTRIG,				0x00 },
	{ REG003C_LCDXFER,				0x00 },//lcd auto transfer disable
	{ REG0248_OIMAGE,				0x10 },//The host output image to overlay 00 to main
	{ REG0216_RYC,					0x05 },//Ryc format is 565
	{ REG0220_YUVRGBXLATE0,			0x05 },//Default value
	{ REG0222_YUVRGBXLATE1,			0x00 },
	{ REG0202_RESIZE,				0x03 },//Reset and enable resizer
	{ REG0204_RESIZESX0,			0x00 },
	{ REG0205_RESIZESX1,			0x00 },
	{ REG0206_RESIZESY0,				0x00 },
	{ REG0207_RESIZESY1,				0x00 },
	{ REG0208_RESIZEEX0,				0x7F },//127
	{ REG0209_RESIZEEX1,				0x00 },
	{ REG020A_RESIZEEY0,				0x7F },//128
	{ REG020B_RESIZEEY1,				0x00 },
	{ REG020C_RESIZEHSCALE,			0x01 },//H-scale
	{ REG020E_RESIZEVSCALE,			0x01 },//V-scale
	{ REG0210_RESIZEOP,				0x00 },//Scale mode is no scale
	{ REG024A_SWIVELVIEW,			0x00 },//Not swivel
	{ REG0224_YUVWRSTART0,			0x00 },//Main window adress
	{ REG0225_YUVWRSTART1,			0x20 },//0x2000 8K
	{ REG0226_YUVWRSTART2,			0x00 },//
	{ REG0240_OSADDR0,				0x00 },//Overlay adress
	{ REG0241_OSADDR1,				0xC0 },//0xc000 so the main window size is 0xc000-0x2000
	{ REG0242_OSADDR2,				0x00 },
	{ REG0244_OHRES,				0x7F },//Overlay width
	{ REG0246_OVRES,				0x7F },//Overlay height
	{ REG0212_MEMHORZRES,			0x7F },//Actual Horizontal Resolution in Pixels -1. jpeg encode use
	{ REG0214_MEMVERTRES,			0x7F },//159
	{ REG0228_XOFFSET0,				0x00 },//Main window's position in overlay
	{ REG0229_XOFFSET1,				0x00 },
	{ REG022A_YOFFSET0,				0x00 },
	{ REG022B_YOFFSET1,				0x00 },
	{ REG0100_CMCLK,				0x01 },//camera clock setting.1 is 1/4 sysclock
	{ REG0102_CMSIGNAL,				0x02 },
       { REG0104_CMMODE0,				0x08 },
       { REG0106_CMMODE1,				0x00 },
	{ REGFLAG_ENDOFTABLE,			0x00 }
    },
    {
	// VGA MODE FOR OV7645FB
	{ 0x12, 0x80 },
	{ 0x03, 0xa4 },			//0x04----black & white//0xa4----normal
	{ 0x04, 0x30 },
	{ 0x05, 0x88 },
	{ 0x06, 0x60 },
	{ 0x11, 0x00 },			//{ 0x11, 0x00 }, //;value 01 for 15 fps
	{ 0x12, 0x15 },
	{ 0x13, 0xa3 },
	{ 0x14, 0x14 },
	{ 0x15, 0x14 },
	{ 0x1f, 0x41 },
	{ 0x20, 0xd0 },
	{ 0x23, 0xde },
	{ 0x24, 0xa0 },
	{ 0x25, 0x80 },
	{ 0x26, 0xb2 },
	{ 0x27, 0xe2 },			//0xe2----black & white//0xe0----normal
	{ 0x28, 0x20 },
	{ 0x2a, 0x01 },
	{ 0x2b, 0x00 },
	{ 0x2d, 0x05 },
	{ 0x2f, 0x9d },
	{ 0x30, 0x00 },
	{ 0x31, 0xc4 },
	{ 0x60, 0x86 },
	{ 0x61, 0xe0 },
	{ 0x62, 0x88 },
	{ 0x63, 0x11 },
	{ 0x64, 0x89 },
	{ 0x65, 0x00 },
	{ 0x67, 0x94 },
	{ 0x68, 0x7a },
	{ 0x69, 0x08 },
	{ 0x6c, 0x11 },			//0xFF----black & white//0x11----normal
	{ 0x6d, 0x33 },			//0xFF----black & white//0x33----normal
	{ 0x6e, 0x22 },			//0xFF----black & white//0x22----normal
	{ 0x6f, 0x00 },			
	{ 0x74, 0x20 },			//{ 0x74, 0x60 },  low light use 0x60
	{ 0x75, 0x0e },			//{ 0x75, 0x06 },
	{ 0x77, 0xc4 },			//{ 0x77, 0xb5 },
	//{ 0x79, 0x80 },			//set----black & white//remove----normal
	//{ 0x7a, 0x80 },			//set----black & white//remove----normal
	{ REGFLAG_ENDOFTABLE,0xFFFF}	//for end
   }
};
#endif

#ifdef S1D10253
HAL_STRUCT HAL_STRUCT_NAME =
{
    HALCHIPID" HAL EXE",    // HAL ID string
    "\x00",				// Configuration description
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD1 strings pool
    "\x01" "6 SLPIN 95\x00\x02" "2 DISOFF AE\x00\x03" "DISCTL\x00\x0F" "13 DATCTL BC\x00\x12" "8 PSET 75\x00\x15" "9 CSET 15\x00\x1A" "7 SLPOUT\x00\x1BPAUSE\x00\x1C" "1 DISON AF\x00\x1DPAUSE\x00\x1E" "14 RAMWR 5C\x00",  // Parallel LCD2 strings pool
    "\x01" "disctl\x00\x05" "com scan\x00\abug fix\x00\bpageset\x00\vcolset\x00\x0E" "dactl\x00\x12" "disinv\x00\x13slpout\x00\x14power\x00\x17volume\x00\x1A" "dison\x00\x1Bramwr\x00",  // Serial LCD3 strings pool
    sizeof(HAL_STRUCT),	// Sizeof this structure
    0x0000,			// CRC of the rest of structure

    HALCHIPID,		// Chip ID
    0x1234,			// Endian detect (LE=0x1234)
    0,					// Reserved for alignment

    32768L,			// CLKI frequency (in Hz)
    32768L,			// Internal OSC frequency (in Hz)

    0x01000000,             // Physical base memory address
    0x00000000,             // Physical register address offset
    0x00000000,             // Physical memory address offset

    640, 480,			// Camera1 expected image size

    81920L,			// Required VRAM (in bytes)
    0,					// Hal Information flags//fNO_INIT_I2C

    {                       // LCD1 init sequence
        HAL_LCD_ENDOFTABLE
    },
    {                       // LCD2 init sequence//NEW

	//Soft reset
	HAL_LCD_DELAY+ 0x100,
	HAL_LCD_COMMAND + 0x2C,  
	HAL_LCD_DELAY   + 0x100,
	
	HAL_LCD_COMMAND + 0x02,		//internal oscillation on
	HAL_LCD_COMMAND + 0x01,		//DIV2=0,clock=OSC(DB2)	
	
	HAL_LCD_COMMAND + 0x26,		//DCDC,AMP on
	HAL_LCD_COMMAND + 0x01,		//DCDC1 on
	HAL_LCD_COMMAND + 0x26,
	HAL_LCD_COMMAND + 0x09,		//AMP on
	HAL_LCD_COMMAND + 0x26,
	HAL_LCD_COMMAND + 0x0B,		//DCDC2	on
	HAL_LCD_COMMAND + 0x26,
	HAL_LCD_COMMAND + 0x0F,		//DCDC3 on
	
	
	HAL_LCD_COMMAND + 0x10,		//duty=1/160,SDIR=0,SWP=0
	HAL_LCD_COMMAND + 0x22,		//SWP=0	
	
	HAL_LCD_COMMAND + 0x20,		//DC-DC
	HAL_LCD_COMMAND + 0x05,
	
	HAL_LCD_COMMAND + 0x22,		//Bias=1/5
	HAL_LCD_COMMAND + 0x33,
	
	HAL_LCD_COMMAND + 0x24,		//initial status,DCDC clock division set:fPCK=fOSC/16
	HAL_LCD_COMMAND + 0x22,

	HAL_LCD_COMMAND + 0x28,		//temperature compensation TCS=00:0.00%degC
	HAL_LCD_COMMAND + 0x11,
//notice-------------------------------------------------	
	HAL_LCD_COMMAND + 0x2A,		//contrast control:
	HAL_LCD_COMMAND + 0x3F,		//normal and partial mode0:1/7bias,<0x6D???1/6 bias,<0xA9?
	HAL_LCD_COMMAND + 0x2B,
	HAL_LCD_COMMAND + 0x3F,		//partial mode1:1/7bias,<0x6D,1/6bias,<0xA9??
		
	HAL_LCD_COMMAND + 0x30,		//GSM:00,65536 color,DSG:0,dummy SG is 1 SG,SGF:0,SG Frame inversion off,
	HAL_LCD_COMMAND + 0x0F,		//SGM:0,SG inversion off,SGP:11
	
	HAL_LCD_COMMAND + 0x32,		//INC:000,every subgroup row vector increment,VEC:0,normal sequence
	HAL_LCD_COMMAND + 0x0E,

	
	HAL_LCD_COMMAND + 0x34,		//N-block inversion:
	HAL_LCD_COMMAND + 0x90,		//FIM:0,FIP:0,N-block inversion:0
	
	HAL_LCD_COMMAND + 0x40,		//MDI:0,memory data inversion off,
	HAL_LCD_COMMAND + 0x00,		//X/Y:0,Y address counter mode
	
	HAL_LCD_COMMAND + 0x42,		//X address set:COM0-COM127
	HAL_LCD_COMMAND + 0x00,
	HAL_LCD_COMMAND + 0x9F,
	
	HAL_LCD_COMMAND + 0x43,		//Y address set:SEG0-COM127
	HAL_LCD_COMMAND + 0x08,
	HAL_LCD_COMMAND + 0x87,
	
	HAL_LCD_COMMAND + 0x45,		//RSK:00,no RAM skip
	HAL_LCD_COMMAND + 0x00,
	
	HAL_LCD_COMMAND + 0x53,		//SDP:00,normal display
	HAL_LCD_COMMAND + 0x00,		//if this flag:01,display reverse,not change DDRAM
	
	HAL_LCD_COMMAND + 0x55,		//PT:0,partial display off,PDM:0,partial mode0 selction
	HAL_LCD_COMMAND + 0x00,
	
	HAL_LCD_COMMAND + 0x56,		//partial start line:line 0
	HAL_LCD_COMMAND + 0x00,
	
	HAL_LCD_COMMAND + 0x57,		//partial end line:line 159
	HAL_LCD_COMMAND + 0x9F,
	
	HAL_LCD_COMMAND + 0x59,		//area scroll set
	HAL_LCD_COMMAND + 0x00,		//SCM:00,entire display,01,upper,10,lower,11,center
	HAL_LCD_COMMAND + 0x00,		//scroll area start line:line 0
	HAL_LCD_COMMAND + 0x9F,		//scroll area end line:line 159
	HAL_LCD_COMMAND + 0x00,		//lower fixed number:0

	
	HAL_LCD_COMMAND + 0x5A,		//scroll start line:line 0
	HAL_LCD_COMMAND + 0x00,

	HAL_LCD_COMMAND + 0x51,		//display on

	//10253 Set end
	HAL_LCD_ENDOFTABLE
    },
    {                       // LCD3 init sequence
        HAL_LCD_ENDOFTABLE
    },

    {                       // S1D13716 init registers
	{ REG0018_POWERSAVE,			0x01 },
	{ REG0014_CLKSRC,				0x00 },
	{ REG0010_PLL0,					0xDD },//this setting is 40M,50M is 0xDD
	{ REG0011_PLL1,					0x1C },//this setting is 40M,50M is 0x1C
	{ REG0012_PLL2,					0x20 },
	{ REG0015_SERLCDCLK,			0x41 },//I2C Clock=sysclock/16
	{ REG0014_CLKSRC,				0xB1 },//LCDPCLK=sysclock/24
	{ REG0016_LCDPCLKDIV,			0x00 },
	{ REG0018_POWERSAVE,			0x04 },
 	{ REGFLAG_DELAY,				0xFF },        
	{ REG0070_PWMCTRL0,				0x05 },      
	{ REG007F_PWMWHITECYCLE,		0x3F },      
	{ REG0072_PWMCTRL1,				0x01 }, 
	{ REGFLAG_DELAY,				0x50 },
	{ REG0108_CMCONTROL,			0x01 },//software reset camera mode
	{ REG0108_CMCONTROL,			0x00 },
	{ REG0202_RESIZE,				0x81 },//Reset resizer
	{ REG0202_RESIZE,				0x01 },//Reset resizer
	{ REG0040_LCD1SETTING,			0x03 },//Data bus width 16 bits format 565
	{ REG0044_LCD2SETTING,			0x03 },//Data bus width 16 bits format 565
	{ REG0048_LCD3SETTING,			0x00 },//Not set
	{ REG004E_SCALEUP,				0x00 },//Encode Scale Overlay Disable
	{ REG004C_DISPSETTING,			0x62 },//Overlay with Main  and Overlay is 8 bits and select lcd2
	{ REG0036_LCDTRIG,				0x00 },
	{ REG003C_LCDXFER,				0x00 },//lcd auto transfer disable
	{ REG0248_OIMAGE,				0x10 },//The host output image to overlay 00 to main
	{ REG0216_RYC,					0x05 },//Ryc format is 565
	{ REG0220_YUVRGBXLATE0,			0x05 },//Default value
	{ REG0222_YUVRGBXLATE1,			0x00 },
	{ REG0202_RESIZE,				0x03 },//Reset and enable resizer
	{ REG0204_RESIZESX0,			0x00 },
	{ REG0205_RESIZESX1,			0x00 },
	{ REG0206_RESIZESY0,				0x00 },
	{ REG0207_RESIZESY1,				0x00 },
	{ REG0208_RESIZEEX0,				0x7F },//127
	{ REG0209_RESIZEEX1,				0x00 },
	{ REG020A_RESIZEEY0,				0x9F },//160
	{ REG020B_RESIZEEY1,				0x00 },
	{ REG020C_RESIZEHSCALE,			0x01 },//H-scale
	{ REG020E_RESIZEVSCALE,			0x01 },//V-scale
	{ REG0210_RESIZEOP,				0x00 },//Scale mode is no scale
	{ REG024A_SWIVELVIEW,			0x00 },//Not swivel
	{ REG0224_YUVWRSTART0,			0x00 },//Main window adress
	{ REG0225_YUVWRSTART1,			0x20 },//0x2000 8K
	{ REG0226_YUVWRSTART2,			0x00 },//
	{ REG0240_OSADDR0,				0x00 },//Overlay adress
	{ REG0241_OSADDR1,				0xC0 },//0xc000 so the main window size is 0xc000-0x2000
	{ REG0242_OSADDR2,				0x00 },
	{ REG0244_OHRES,				0x7F },//Overlay width
	{ REG0246_OVRES,				0x9F },//Overlay height
	{ REG0212_MEMHORZRES,			0x7F },//Actual Horizontal Resolution in Pixels -1. jpeg encode use
	{ REG0214_MEMVERTRES,			0x9F },//159
	{ REG0228_XOFFSET0,				0x00 },//Main window's position in overlay
	{ REG0229_XOFFSET1,				0x00 },
	{ REG022A_YOFFSET0,				0x00 },
	{ REG022B_YOFFSET1,				0x00 },
	{ REG0100_CMCLK,				0x01 },//camera clock setting.1 is 1/4 sysclock
	{ REG0102_CMSIGNAL,				0x02 },
       { REG0104_CMMODE0,				0x08 },
       { REG0106_CMMODE1,				0x00 },
	{ REGFLAG_ENDOFTABLE,			0x00 }
    },
    {
	// VGA MODE FOR OV7645FB
	{ 0x12, 0x80 },
	{ 0x03, 0xa4 },			//0x04----black & white//0xa4----normal
	{ 0x04, 0x30 },
	{ 0x05, 0x88 },
	{ 0x06, 0x60 },
	{ 0x11, 0x00 },			//{ 0x11, 0x00 }, //;value 01 for 15 fps
	{ 0x12, 0x15 },
	{ 0x13, 0xa3 },
	{ 0x14, 0x14 },
	{ 0x15, 0x14 },
	{ 0x1f, 0x41 },
	{ 0x20, 0xd0 },
	{ 0x23, 0xde },
	{ 0x24, 0xa0 },
	{ 0x25, 0x80 },
	{ 0x26, 0xb2 },
	{ 0x27, 0xe2 },			//0xe2----black & white//0xe0----normal
	{ 0x28, 0x20 },
	{ 0x2a, 0x01 },
	{ 0x2b, 0x00 },
	{ 0x2d, 0x05 },
	{ 0x2f, 0x9d },
	{ 0x30, 0x00 },
	{ 0x31, 0xc4 },
	{ 0x60, 0x86 },
	{ 0x61, 0xe0 },
	{ 0x62, 0x88 },
	{ 0x63, 0x11 },
	{ 0x64, 0x89 },
	{ 0x65, 0x00 },
	{ 0x67, 0x94 },
	{ 0x68, 0x7a },
	{ 0x69, 0x08 },
	{ 0x6c, 0x11 },			//0xFF----black & white//0x11----normal
	{ 0x6d, 0x33 },			//0xFF----black & white//0x33----normal
	{ 0x6e, 0x22 },			//0xFF----black & white//0x22----normal
	{ 0x6f, 0x00 },			
	{ 0x74, 0x20 },			//{ 0x74, 0x60 },  low light use 0x60
	{ 0x75, 0x0e },			//{ 0x75, 0x06 },
	{ 0x77, 0xc4 },			//{ 0x77, 0xb5 },
	//{ 0x79, 0x80 },			//set----black & white//remove----normal
	//{ 0x7a, 0x80 },			//set----black & white//remove----normal
	{ REGFLAG_ENDOFTABLE,0xFFFF}	//for end
   }
};
#endif

