// NOT UPDATED FOR 13713


//===========================================================================
//	HAL_I2C.H
// (Tabs set to every 4)
//---------------------------------------------------------------------------
//  Copyright (c) 2002 Epson Research and Development, Inc.
//  All Rights Reserved.
//===========================================================================


#ifndef _HAL_I2C_H_
#define _HAL_I2C_H_


#include "datatype.h"
#include "hal_i2c.h"

// Allow both standard C and C++ linkages.
#ifdef __cplusplus
   extern "C" {
#endif

//---------------------------------------------------------------------------
//  FUNCTION: halpInitI2C()
//
//  DESCRIPTION:
//		This routine initializes the I2C bus, and pre-programs the known
//		devices that reside on the I2C bus to a pre-defined initial state.
//
//  PARAMETERS:
//		DeviceId    If DeviceId == -1, initialize all devices
//		            Otherwise, set DeviceId to the device for initialization
//
//  RETURNS:
//		True if successful, False if I2C errors.
//---------------------------------------------------------------------------
Boolean		halpInitI2C( int DeviceId );


#ifdef __cplusplus
   }
#endif


#endif	// _HAL_I2C_H_
