//===========================================================================
//	HAL_PLATFORM.H
// (Tabs set to every 4)
//---------------------------------------------------------------------------
//  Copyright (c) 2003 Epson Research and Development, Inc.
//  All Rights Reserved.
//===========================================================================


#ifndef _HAL_PLATFORM_H_
#define _HAL_PLATFORM_H_


#include "datatype.h"



// Allow both standard C and C++ linkages.
#ifdef __cplusplus
   extern "C" {
#endif


Boolean		halpDelayUS( UInt32 microseconds );
int			halpMapPhysicalToVirtual( UInt32 PhysicalAddr, UInt32 *pVirtualAddr, UInt32 *pBlockSize );
int			halpAddInterruptRegister( UInt32 EnableReg, UInt32 StatusReg, UInt32 BitMask, UInt32 AccessSize, Boolean fRawStatus );
int			halpSetISRCallback( void(*pISRCallback)(void) );

UInt32		halpDirectRead(  int Size, UInt32 Address );
void		halpDirectWrite( int Size, UInt32 Address, UInt32 Value, UInt32 Count );
void		halpDirectReadData(  int Size, UInt32 Address,       void* pData, UInt32 Count );
void		halpDirectWriteData( int Size, UInt32 Address, const void* pData, UInt32 Count );
void		halSetProcessExclusivity( Boolean fExclusive );


#ifdef __cplusplus
   }
#endif


#endif	// _HAL_PLATFORM_H_
