/******************************************************************************
 * Power Task (pwr)
 * Design and coding by Svend Kristian Lindholm, skl@ti.com
 *
 * PWR SW Modulation
 *
 * $Id: lcc_modulate.h,v 1.1.1.1 2004/06/19 06:00:29 root Exp $
 *
 ******************************************************************************/
#ifndef __PWR_MODULATE_H__
#define __PWR_MODULATE_H__

#include "lcc.h"

// SW modulation using the following addresses
#ifdef USE_PWL_AS_MODULATOR
// D-Sample - no modulation - just envelope function to simulate GPIO 6
    #define PWL_LEVEL_REG (*(volatile unsigned char*) 0xFFFE8000)
    #define PWL_CTRL_REG  (*(volatile unsigned char*) 0xFFFE8001)
    #define BUZZ_LIGHT_REG (*(volatile short*) 0xFFFE480E) // Enable buzzer (bit 0) and PWL (bit 1)
#endif
/******************************************************************************
 * Function prototypes
 ******************************************************************************/

void pwr_modulate_init(void);
void pwr_modulate_on(void);
void pwr_modulate_off(void);

#endif
