/******************************************************************************
 * PWR task (pwr)
 * Adapted from FFS by Svend Kristian Lindholm, skl@ti.com
 * Idea, design and coding by Mads Meisner-Jensen, mmj@ti.com
 *
 * pwr tracing
 *
 * $Id: lcc_trace.c,v 1.1.1.1 2004/06/19 06:00:29 root Exp $
 *
 ******************************************************************************/

#include "lcc_trace.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define _RVF 1
#if (_RVF == 1)
#include "rvf_api.h"
#include "rv_general.h"
#include "rvm_use_id_list.h"
#else
#include "btf.h"
#include "bt_general.h"
#endif

/******************************************************************************
 * Target Tracing
 *****************************************************************************/

static unsigned int pwr_mask = TTrFatal | TTrWarning;

void pwr_ttr_init(unsigned int mask)
{
    pwr_mask = mask | TTrFatal | TTrWarning;
}

void pwr_ttr(unsigned int mask, char *format, ...)
{
    va_list args;
    static char buf[256];


    if (pwr_mask & mask)
    {
        // build string ala tr() then call str()
        va_start(args, format);
        vsprintf(buf, format, args);
        str(mask, buf);
        va_end(args);
    }
}

void pwr_str(unsigned mask, char *string)
{
    if (pwr_mask & mask) {
#if (_RVF == 1)
        rvf_send_trace(string, strlen(string), NULL_PARAM,
                       RV_TRACE_LEVEL_WARNING, LCC_USE_ID);
        rvf_delay(5);
#endif
    }
}

/******************************************************************************
 ** Common Tracing and logging
 *****************************************************************************/

int pwr_tr_query(int mask)
{
    return (pwr_mask & mask);
}
