/******************************************************************************
 * PWR task (pwr)
 * Adapted from FFS by Svend Kristian Lindholm, skl@ti.com
 * Idea, design and coding by Mads Meisner-Jensen, mmj@ti.com
 *
 * pwr tracing
 *
 * $Id: lcc_trace.h,v 1.1.1.1 2004/06/19 06:00:29 root Exp $
 *
 ******************************************************************************/


/******************************************************************************
 ** Common Tracing and logging
 *****************************************************************************/

int pwr_tr_query(int mask);


/******************************************************************************
 ** Target Tracing
 ******************************************************************************/

#define tw(contents)
#define TRACE_WANTED 1

#if TRACE_WANTED
    #define ttw(contents) contents
    // To distinguish from FFS trace system rename to pwr_ttr and pwr_str
    #define ttr pwr_ttr
    #define str pwr_str
#else
    #define ttw(contents)
#endif

#define tlw(contents)
#define NL
void pwr_ttr_init(unsigned int mask);
#if 1
void pwr_ttr(unsigned trmask, char *format, ...);
void pwr_str(unsigned mask, char *string);
#endif

enum TargetTraceMask {
    TTrMem        = 0x00000001,
    TTrMemLow     = 0x00000002,

    TTrApi        = 0x00000010,
    TTrTimer      = 0x00000020,
    TTrTimerLow   = 0x00000040,

    TTrInit       = 0x00000100,
    TTrInitLow    = 0x00000200,

    TTrCharge     = 0x00000400,
    TTrChargeLow  = 0x00000800,

    TTrEvent      = 0x00001000,
    TTrEventLow   = 0x00002000,

    TTrEnv        = 0x00020000,
    TTrEnvLow     = 0x00040000,

    TTrTask       = 0x00100000,
    TTrTaskLow    = 0x00200000,

    TTrTmpwr      = 0x08000000,

    TTrTaskDelays = 0x10000000,
    TTrWarning    = 0x40000000,
    TTrFatal      = 0x80000000,

    TTrAll        = 0xFFFFFFFF
};

