/*******************************************************************************
 *
 * pwr_analog_dev.h
 *
 * Purpose: This file contains definitions that can be used by any SWE
 *          for power management services.
 *
 * Author    Candice Bazanegue (c-brille@ti.com)
 *
 * (C) Texas Instruments 2001
 *
 ******************************************************************************/

#ifndef __PWR_ANALOG_DEV_H__
#define __PWR_ANALOG_DEV_H__

#ifndef _WINDOWS
   #include "chipset.cfg"
#endif

/* Constants relative to the analog device */

#if (ANALOG == 1) 

#define VOLTAGE_LOOP_OFFSET   400   /* (mV) measured */
#define MADC_OFFSET           160   /* (mV) measured */

#define DAC_THRESHOLD         240   /* (mV) spec */
#define DAC_VOLTAGE_STEP      1875  /* (uV) spec */
#define DAC_CURRENT_STEP      937   /* (uA) */
#define MADC_VOLTAGE_STEP     1710  /* (uV) spec */
#define MADC_CURRENT_STEP     855   /* (uA) spec */

#elif (ANALOG == 2)

#define VOLTAGE_LOOP_OFFSET   200   /* (mV) measured */
#define MADC_OFFSET           160   /* (mV) measured */

#define DAC_THRESHOLD         0     /* (mV) spec */
#define DAC_VOLTAGE_STEP      1710  /* (uV) spec */
#define DAC_CURRENT_STEP      855   /* (uA) */
#define MADC_VOLTAGE_STEP     1710  /* (uV) spec */
#define MADC_CURRENT_STEP     855   /* (uA) spec */

#endif	// ANALOG

#endif /* __PWR_ANALOG_DEV_H__ */