/*******************************************************************************
 *
 *  pwr_liion_cha.h
 *
 * Purpose:    This file contains definitions for managing the Li-ion batteries 
 *             charging process.
 *
 * Author      Candice Bazanegue (c-brille@ti.com)
 *
 * (C) Texas Instruments 2001
 *
 ******************************************************************************/

#ifndef __PWR_LIION_CHA_H__
#define __PWR_LIION_CHA_H__

/* Define for battery qualification */

#define BATTERY_OK      (0)
#define OPEN_BATTERY    (1)
#define SHORT_BATTERY   (2)


/* Prototypes */

void pwr_start_CI_charging(unsigned short DAC_current);
void pwr_start_CV_charging(unsigned short charging_voltage);
void pwr_stop_charging(void);
void pwr_current_loop_cal(void);
void pwr_calibration_process(void);
void pwr_battery_qualification(void);
void pwr_start_fast_charge(void);
void pwr_CI_charge_process(void);
void pwr_CV_charge_process(void);
void pwr_bat_test_timer_process(void);
void pwr_short_test_timer_process(void);
void pwr_open_test_timer_process(void);
void pwr_cal_timer_process(void);
void pwr_CI_charge_timer_process(void);
void pwr_CV_charge_timer_process(void);

#endif /* __PWR_LIION_CHA_H__ */