/******************************************************************************
                 PROJECT
         
    for epson 120*160 colorful lcd 

        baseed on ti calypso
        
        data: 2002 3/12
        version 0.1
********************************************************************************/

#define LCD_Control_ADDR     0x2800000       /*cs4 address*/
#define LCD_DATA_ADDR       0x2000000      /*cs3 address*/
#define LCD_COMMAND_CHANGE      0x03      /*command change*/
#define LCD_DATA_CHANGE          0x07   /*data  change*/
#define LCD_RST_CHANGE            0x03  /*lcd reset*/
#define LCD_BACKLIGHT_TURNON     0x03  /*turn on backlight*/
#define LCD_BACKLIGHT_TURNOFF    0x02  /*turn off backlight*/
#define LCD_REFRESH_WIDTH        R2D_WIDTH/2-1
#define LCD_REFRESH_HEIGHT       R2D_HEIGHT-1


#define LCD_Control_ADDR         0x1800000
#define LCD_DATA_ADDR           0x1800000
#define LCD_REFRESH_WIDTH       R2D_WIDTH-1
#define LCD_REFRESH_HEIGHT      R2D_HEIGHT-1
#define IO_PIN_SELEC_ADDR       0xfffef00a
#define IO_FUNC_SELEC_ADDR      0xfffe4804
#define IO_OUT_DATA_ADDR        0xfffe4802
#define LT_OUT_COTR_ADDR        0xfffe480e
#define LT_LEVEL_COTR_ADDR      0xfffe4810





void Lcd_Initial_Func(void)
{

    Lcd_Reset();
    Lcd_BackLight_TurnOn();

    Lcd_Send_Command_Func(0xae);
    
    Lcd_Send_Command_Func(0xca);
    Lcd_Send_Data_Func(0x0c);
    Lcd_Send_Data_Func(0x28);
    Lcd_Send_Data_Func(0x0b);

    Lcd_Send_Command_Func(0xbb);
    Lcd_Send_Data_Func(0x02);

    Lcd_Send_Command_Func(0x0d1);

    Lcd_Send_Command_Func(0x75);
    Lcd_Send_Data_Func(0x00);
    Lcd_Send_Data_Func(0x9f);

    Lcd_Send_Command_Func(0x15);
    Lcd_Send_Data_Func(0x00);
    Lcd_Send_Data_Func(0x77);

    Lcd_Send_Command_Func(0xbc);
    Lcd_Send_Data_Func(0x02);
    Lcd_Send_Data_Func(0x01);
    Lcd_Send_Data_Func(0x02);
    Lcd_Send_Command_Func(0xbe);

    Lcd_Send_Command_Func(0xa7);

    Lcd_Send_Command_Func(0x94);

    Lcd_Send_Command_Func(0x20);
    Lcd_Send_Data_Func(0x0f);

    Lcd_Send_Command_Func(0x81);
    Lcd_Send_Data_Func(0x28);
    Lcd_Send_Data_Func(0x03);

    Lcd_Send_Command_Func(0xaf);  
   
}


/*********************************************************
         LCD
         ں:Lcd_Command lcd
       
 *********************************************************/        

void Lcd_Send_Command_Func(unsigned char Lcd_Command)
{

  *((volatile unsigned char *) LCD_Control_ADDR) = LCD_COMMAND_CHANGE;
  *((volatile unsigned char *) LCD_DATA_ADDR) = Lcd_Command;

}


/*********************************************************
         LCD
         ں:Lcd_Data lcd
         
 *********************************************************/

void Lcd_Send_Data_Func(unsigned char Lcd_Data)
{
  *((volatile unsigned char *) LCD_Control_ADDR) = LCD_DATA_CHANGE;
  *((volatile unsigned char *) LCD_DATA_ADDR) = Lcd_Data;
}

/*************************************************************
          READ LCD DATA LCD
          ں: lcd_buffer_data
*************************************************************/

unsigned char Read_Lcd_Buffer_Data(void)
{
  unsigned char Lcd_Buffer_Data;
  
  Lcd_Send_Command_Func(0x5d);
  *((volatile unsigned char *) LCD_Control_ADDR) = LCD_DATA_CHANGE;
  Lcd_Buffer_Data = *((volatile unsigned char *) LCD_DATA_ADDR);

  return(Lcd_Buffer_Data);
}



/***********************************************************
           Lcd Reset
 ************************************************************/
 void Lcd_Reset(void)
{
   *((volatile unsigned char *) LCD_Control_ADDR) =  0x0;
   Lcd_Delay();
   Lcd_Delay();
   Lcd_Delay();
   *((volatile unsigned char *) LCD_Control_ADDR) =  LCD_RST_CHANGE;
   
}

/***************************************************************
      lcd back_light turn on
 ****************************************************************/

void Lcd_BackLight_TurnOn(void)
{
   *((volatile unsigned char *) LCD_Control_ADDR) = LCD_BACKLIGHT_TURNON;
}


/********************************************************************
         lcd back_light turn off
*********************************************************************/

void Lcd_BackLight_TurnOff(void)
{
    *((volatile unsigned char *) LCD_Control_ADDR) = LCD_BACKLIGHT_TURNOFF;
}


/**********************************************************************
                              CS3CS4Ĺʽ
 **********************************************************************/
void Set_Cs3_Cs4_Mode(void)
{
   	*(volatile unsigned short *)0xfffffb06 = 0xf9f; // and config. as 8-bit I/O
    *(volatile unsigned short*)0xfffffb0a = 0xf9f; // max waitstates and dummy cycles on CS3 and CS4
    
}

/************************************************************************
                 clear   all screen
*************************************************************************/
void Clear_Screen(void)
{
   unsigned char i,j;

   Lcd_Send_Command_Func(0x75);
   Lcd_Send_Data_Func(0);
   Lcd_Send_Data_Func(LCD_REFRESH_HEIGHT);

   Lcd_Send_Command_Func(0x25);

   Lcd_Send_Command_Func(0x15);
   Lcd_Send_Data_Func(0);
   Lcd_Send_Data_Func(LCD_REFRESH_WIDTH);

   Lcd_Send_Command_Func(0x5c);


  for(i=0;i<=LCD_REFRESH_HEIGHT;i++)
  {
    for(j=0;j<=LCD_REFRESH_WIDTH;j++)
    {
       Lcd_Send_Data_Func(0Xff);
       Lcd_Send_Data_Func(0Xff);
       Lcd_Send_Data_Func(0Xff);
       
  	}
  }

}

/******************************************************************
                һ
    lighting a pixel  x x position ,y y position, clolor_data  show pixel color
    
*******************************************************************/    
void Lighting_One_Pixel(unsigned char x,unsigned char y,unsigned short color_data)

{
    unsigned char color_temp;
    
   
     Lcd_Send_Command_Func(0x75);
     Lcd_Send_Data_Func(x);
     Lcd_Send_Data_Func(x);

     Lcd_Send_Command_Func(0x25);

     Lcd_Send_Command_Func(0x15);
     Lcd_Send_Data_Func(y);
     Lcd_Send_Data_Func(y);

     Lcd_Send_Command_Func(0x5c);

     color_temp = (color_data&0xff00)>>8;
     Lcd_Send_Data_Func(color_temp);
     color_temp = (color_data&0xff);
     Lcd_Send_Data_Func(color_temp);
     Lcd_Send_Command_Func(0x25);
     Lcd_Send_Command_Func(0x25);
     Lcd_Send_Command_Func(0x25);

     

}



void Lcd_Send_Two_Pixel(unsigned short First_Data,unsigned short Second_Data)
{
  unsigned char Color_Temp_1,Color_Temp_2;
  unsigned short Left_Data_Temp,Change_Data;
  

  Left_Data_Temp = (First_Data<<4)&0xfff0; 
  Change_Data = (Second_Data>>8)&0x000f;
  Left_Data_Temp |= Change_Data;
  Color_Temp_2 = (Second_Data&0x00ff);

  Color_Temp_1 = (Left_Data_Temp>>8)&0x00ff;
  Lcd_Send_Data_Func(Color_Temp_1);
  Color_Temp_1 = (Left_Data_Temp&0x00ff);
  Lcd_Send_Data_Func(Color_Temp_1);
  Lcd_Send_Data_Func(Color_Temp_2);

}


/*********************************************************
         LCD
         ں:Lcd_Command lcd
       
 *********************************************************/        

void Lcd_Send_Command_Func(unsigned short Lcd_Command)
{

  *(volatile unsigned short *)IO_OUT_DATA_ADDR &=0xfeff;
  *(volatile unsigned short *)LCD_Control_ADDR   = Lcd_Command;

}



/*********************************************************
         LCD
         ں:Lcd_Data lcd
         
 *********************************************************/

void Lcd_Send_Data_Func(unsigned short Lcd_Data)
{

   *(volatile unsigned short *)IO_OUT_DATA_ADDR |=0x0100;
   *(volatile unsigned short *)LCD_DATA_ADDR     =Lcd_Data;

}

/***********************************************************
           Lcd Reset
 ************************************************************/
 void Lcd_Reset(void)
{
   
  *(volatile unsigned short *)IO_OUT_DATA_ADDR &= 0xff7f;
  Lcd_Delay();
  
  *(volatile unsigned short *)IO_OUT_DATA_ADDR |= 0x0080;
   
}


/***************************************************************
      lcd back_light turn on
 ****************************************************************/

void Lcd_BackLight_TurnOn(void)
{

 *(volatile unsigned short *)LT_OUT_COTR_ADDR |= 0x02;

}


/********************************************************************
         lcd back_light turn off
*********************************************************************/
void Lcd_BackLight_TurnOff(void)
{

  *(volatile unsigned short *)LT_OUT_COTR_ADDR &= 0xfffd;

}

/************************************************************************
                 clear   all screen
*************************************************************************/
void Clear_Screen(void)
{
   unsigned char i,j;

   Lcd_Send_Command_Func(0x75);
   Lcd_Send_Data_Func(0);
   Lcd_Send_Data_Func(LCD_REFRESH_HEIGHT);

   Lcd_Send_Command_Func(0x25);

   Lcd_Send_Command_Func(0x15);
   Lcd_Send_Data_Func(0);
   Lcd_Send_Data_Func(LCD_REFRESH_WIDTH);

   Lcd_Send_Command_Func(0x5c);


  for(i=0;i<=LCD_REFRESH_HEIGHT;i++)
  {
    for(j=0;j<=LCD_REFRESH_WIDTH;j++)
    {

       Lcd_Send_Data_Func(0xffff);
              
  	}
  }

}

/******************************************************************
                һ
    lighting a pixel  x x position ,y y position, clolor_data  show pixel color
    
*******************************************************************/    
void Lighting_One_Pixel(unsigned char x,unsigned char y,unsigned short color_data)

{
    unsigned char color_temp;
    
   
     Lcd_Send_Command_Func(0x75);
     Lcd_Send_Data_Func(x);
     Lcd_Send_Data_Func(x);

     Lcd_Send_Command_Func(0x25);

     Lcd_Send_Command_Func(0x15);
     Lcd_Send_Data_Func(y);
     Lcd_Send_Data_Func(y);

     Lcd_Send_Command_Func(0x5c);

     Lcd_Send_Data_Func(color_data);
     
     Lcd_Send_Command_Func(0x25);

     

}

/***********************************************************************************
                              ڵĵ
       ڲ: First_Data ,Second_Data                       

************************************************************************************/

void Lcd_Send_Two_Pixel(unsigned short First_Data,unsigned short Second_Data)
{
  unsigned char Color_Temp_1,Color_Temp_2;
  unsigned short Left_Data_Temp,Change_Data;
  
  *(volatile unsigned short *)LCD_DATA_ADDR = First_Data;
  *(volatile unsigned short *)LCD_DATA_ADDR = Second_Data;

}




void Lcd_Delay(void)
{
  unsigned short i;

    for(i;i<500;)
    	i++;
}





