/*******************************

   LCD DESCRIPTION

Revision History:
	1. Oct. 24, 2003, Jeffrey Zhao, Modified for Topply TFT LCD module,
				   LCD size, LCD commands macros, etc.
	2. Dec. 11, 2003, Jeffrey Zhao, Modified for Truly LCM on PCB Version 2.
*******************************/
#ifndef __R2D_CUSTOMER_LCD_I_H_
#define __R2D_CUSTOMER_LCD_I_H_

/* Robert.Chen defined, for sub LCD, 2003-12-13 */
#define R2D_SUBLCD_SUPPORT  1	/* 1 for supporting sublcd, 0 not support sublcd */

/* Robert.Chen defined, for control LCD refresh measure, 2003-12-13 */
#define R2D_COMPARE_REFRESH	0	/* 1 for LCD refresh measure based on comparing result, 0 for entire LCD refresh */


#if (MAIN_LCD_SIZE == 4 )
#define R2D_WIDTH		128  
#define R2D_HEIGHT		160
#elif (MAIN_LCD_SIZE == 3 )
#define R2D_WIDTH		128  
#define R2D_HEIGHT		128
#endif


/* Robert.Chen defined, for sub LCD */
#define R2D_SUB_WIDTH	96
#define R2D_SUB_HEIGHT	64


#define R2D_DITHERING R2D_ON

// Kind of display
#define R2D_LCD_DISPLAY R2D_COLOR

// Refresh mode of LCD
#define R2D_REFRESH R2D_HORIZONTAL

// ln2 of the number of bits to code a pixel value
// (color depth)
#define R2D_PIXEL_DEPTH 16 

// ln2 of previous value
#define R2D_PIXEL_POS_TO_BIT_POS 4

// Mirrorred mode
//#define R2D_MIRRORED


// ln2 of the number of pixels in one memory word
// (Number of pixels MUST BE A POWER OF TWO 
// for optimization reasons since to compute the address of a pixel
// in memory one would like to avoid division and would prefer
// to use shifts)
// 2^5 = 32 pixels
#define R2D_PIXELS_PER_MEMORY_WORD 1


#define MAIN_LCD_COMMAND_ADDR     	0x01800000 // use nCS2 16bit
#define MAIN_LCD_DATA_ADDR         	0x01800002 // use A1 for RS(Command/Data)
#define SUB_LCD_COMMAND_ADDR		0x02200000 // use nCS3 & A22 8bit
#define SUB_LCD_DATA_ADDR			0x02200002 // use A1 for RS(Command/Data)


//#define MAIN_LCD_COMMAND_ADDR     	0x02200000 // use nCS2 16bit
//#define MAIN_LCD_DATA_ADDR         	0x02200002 // use A1 for RS(Command/Data)
//#define SUB_LCD_COMMAND_ADDR		0x01800000 // use nCS3 & A22 8bit
//#define SUB_LCD_DATA_ADDR			0x01800002 // use A1 for RS(Command/Data)


#endif
