/*
  * Revision History:
  * 	1. Oct. 27, 2003 Jeffrey modified this for new TFT-LCD module 
  * 	2. Nov. 18, 2003 Jeffrey modified for Truly LCM Test
  */

#ifndef _WINDOWS
	#ifndef _INNOVATION_EMULATOR_
		#include "uwire.h"
	#endif	
#endif

#include  "R2D_customer_lcd_i.h"
#include  "..\..\r2d_config.h" 
#include "r2d_task_init_i.h"

#if(LCDC_DRV_CHIP == 1 )
#include "..\..\common\camera\include\chiplib.h"
#include "..\..\common\camera\src_hal\camera.h"
#endif


#ifndef _INNOVATION_EMULATOR_


#if R2D_COMPARE_REFRESH	

#pragma DATA_SECTION (OriginLCDData, ".DISP_BUF");
UINT32  OriginLCDData[R2D_MWWIDTH*R2D_HEIGHT]; //modified by ljq from 9760 to 2003/4/10
#endif

/* zhq, 2004/08/03, added for we use explicit OR to compare frame buffer. */
#ifdef _XOR_COMPARE_

#define XOR_SIZE 16
#define XOR_BLOCK	(XOR_SIZE*XOR_SIZE)
#define HOR_SIZE (R2D_WIDTH/XOR_SIZE)	/* 8 for 128. */
#define VER_SIZE (R2D_HEIGHT/XOR_SIZE)	/* 10 for 160. */

UINT16   Compare_subblock[VER_SIZE][HOR_SIZE];
UINT32   Compare_block[VER_SIZE][HOR_SIZE];
UINT32	 Compare_result[HOR_SIZE];

UINT16 Temp_Compare_subblock[HOR_SIZE];
UINT32 Temp_Compare_block[HOR_SIZE];

int ver_begin, ver_end, hor_begin, hor_end;

#endif //_XOR_COMPARE_


UINT16  g_needrefreshline = 0;



#if (R2D_BENCHMARKING == R2D_ON)
UINT32 r2d_g_tick=0;
#endif


//static unsigned char temp_frame[64*12];

void r2d_lcd_power_on(void)
{
}

void r2d_lcd_power_off(void)
{
}

UINT8 CompareLcdData(void)
{
	int  i, j;
	UINT32 Lcd_Temp,*pPmemory_Words_Pointer,*ptr1,*ptr2,originarr[160];
	//MmiTrace("zym:CompareLcdData");

	g_needrefreshline = 0;
	pPmemory_Words_Pointer=r2d_g_framebuffer->p_memory_words;

    #if R2D_COMPARE_REFRESH	/* Robert.Chen add, 2003-12-13 */
	for ( i = 0; i < 160 ; i++ )
	{
		//	originarr[i] = OriginLCDData[61*(i +1)-1];
		OriginLCDData[R2D_MWWIDTH*(i +1)-1] =  *(pPmemory_Words_Pointer +R2D_MWWIDTH*(i +1)-1);//modified by ljq from 61 to R2d_MWWIDTH 2003/4/10
	}

	for ( i = 0; i < 10 ; i ++ )
	{
		ptr1 = &OriginLCDData[0] +16*R2D_MWWIDTH*i ;//modified by ljq from 61 to R2d_MWWIDTH 2003/4/10
		ptr2 = pPmemory_Words_Pointer +16*R2D_MWWIDTH*i;//modified by ljq from 61 to R2d_MWWIDTH 2003/4/10
		if ( !memcmp( ptr1,ptr2 ,16*R2D_MWWIDTH*4) )
		{  //ptr1  equal to  ptr2 //modified by ljq from 61 to R2d_MWWIDTH 2003/4/10

			/*
				for(j =0 ; j <16 ;j ++){
					OriginLCDData[61*(16*i+j) ]= originarr[61*(16*i+j)];
				}
				*/
			;
		} else
		{
			//	MmiTrace("not equal ");
			g_needrefreshline |=(1<<i);
		}           
	}   

	memcpy( &OriginLCDData[0],pPmemory_Words_Pointer ,R2D_MWWIDTH*R2D_HEIGHT*4);//modified by ljq from 39040 to R2d_MWWIDTH*R2D_HEIGHT*4 2003/4/10
	#endif
}

void r2d_new_refresh(void)
{
	int i,x1= -1,y1=-1 ,x2 = -1,y2 = -1;
	UINT32 pdata;

	if ( g_needrefreshline == 0x3ff )
	{
		r2d_refresh();
		return ;
	}

	for ( i = 0; i < 11; i++ )
	{
		if ( (g_needrefreshline >> i) & 0x01 )
		{
			x1 = 0;
			if ( y1 == -1 )
				y1 = i *16;
			x2 = R2D_WIDTH-1;		   //by ljq from 119 to R2D_WIDTH-1 2003/4/11
			y2 = (i+1)*16 - 1;
		} 
		else
		{
			if ( x1 != -1 )
				r2d_refresh_rect(x1,y1,x2,y2);
			x1= y1 = x2 =y2 = -1;           
		}
	}
	r2d_reinit_update_region();

}

void r2d_refresh_rect(int x1 ,int y1, int x2 ,int y2 )
{
	unsigned char i,j;
	UINT16  x , y, firstpoint ,Lcd_Byte_1,Lcd_Byte_2;
	UINT32 Lcd_Temp,*pPmemory_Words_Pointer;

	pPmemory_Words_Pointer = &Lcd_Temp; 
	pPmemory_Words_Pointer = r2d_g_framebuffer->p_memory_words + y1 * 61;

	x = x2 << 8 + x1;
	y = y2 << 8 + y1;
	firstpoint = y1 << 8 + x1;

	//X address set
	main_lcd_sendcommand( XADDRESS_AREA_SET );
	main_lcd_sendcommand( y1 );
	main_lcd_sendcommand( y2 );

	if ( (x1 == 0) && (x2 == (R2D_WIDTH - 1)) )
	{
		i=0;
		while ( i < (y2 - y1 + 1) )
		{
			j = 0;
			while ( j < (R2D_MWWIDTH -1) )
			{
				Lcd_Temp = *pPmemory_Words_Pointer++;
				Lcd_Byte_1 = Lcd_Temp & 0x0000ffff;
				Lcd_Byte_2 = (Lcd_Temp & 0xffff0000) >> 16;

				main_lcd_senddata(Lcd_Byte_1 | Lcd_Byte_2);

				j++; 
			}
			pPmemory_Words_Pointer++;   
			i++;
		} 
	}
}

/* zhq, 2004/08/03, added for we use explicit OR to compare frame buffer. */
#ifdef _XOR_COMPARE_

void init_XOR_Compare()
{
	int i,j;
	ver_begin = VER_SIZE;
	hor_begin = HOR_SIZE;
	ver_end = 0;
	hor_end = 0;
	for(j=0;j<VER_SIZE;j++)
	{
		for(i=0;i<HOR_SIZE;i++)
		{
			Compare_subblock[j][i] = 0;
			Compare_block[j][i] = 0;
			//Compare_result[i] = 0;

		}
	}
}

BOOL XOR_Compare(UINT32* pPmemory_Words_Pointer)
{
	UINT16 Lcd_Short_1,Lcd_Short_2;
	UINT32 Lcd_Word;
	UINT16* Orin_frabuf;
	int i,j;
	BOOL all_match;

	MI_dbgPrintf("zhq: XOR compare entered");

	all_match = TRUE;
	Orin_frabuf = (UINT16*)pPmemory_Words_Pointer;
	for(i=0;i<R2D_HEIGHT;i++)
	{
		for(j=0;j<(R2D_WIDTH);j+=2)
		{
			Lcd_Word = *pPmemory_Words_Pointer++;
			
			Lcd_Short_1 = Lcd_Word & 0x0000ffff;
			Lcd_Short_2 = (Lcd_Word & 0xffff0000) >> 16;
			Temp_Compare_subblock[j/XOR_SIZE] ^= Lcd_Short_1;
			Temp_Compare_subblock[j/XOR_SIZE] ^= Lcd_Short_2;
			Temp_Compare_block[j/XOR_SIZE] += Lcd_Word;
		}
		if(((i+1)%XOR_SIZE) == 0)
			for(j=0;j<(R2D_WIDTH);j+=XOR_SIZE)
			if((Compare_subblock[i/XOR_SIZE][j/XOR_SIZE] == Temp_Compare_subblock[j/XOR_SIZE])&&(Compare_block[i/XOR_SIZE][j/XOR_SIZE] == Temp_Compare_block[j/XOR_SIZE]))
			{
				//MI_dbgPrintf("zhq: XOR compare match, i = %d", i);
				//Compare_result[i/XOR_SIZE]&= ~(1L<<(j/XOR_SIZE));
				Temp_Compare_subblock[j/XOR_SIZE] = 0;
				Temp_Compare_block[j/XOR_SIZE] = 0;
			}
			else
			{
				MI_dbgPrintf("zhq: XOR compare mismatch, i = %d, j = %d", i, j);
				//Draw_Block(i/XOR_SIZE,j/XOR_SIZE,Orin_frabuf);
				//Compare_result[i/XOR_SIZE] |= 1L<<(j/XOR_SIZE);
				all_match = FALSE;

				
				if(ver_begin > (i/XOR_SIZE )) ver_begin = (i/XOR_SIZE );
				if(hor_begin > (j/XOR_SIZE )) hor_begin = (j/XOR_SIZE );
				if(ver_end < (i/XOR_SIZE )) ver_end = (i/XOR_SIZE );
				if(hor_end < (j/XOR_SIZE )) hor_end = (j/XOR_SIZE );
				
				Compare_subblock[i/XOR_SIZE][j/XOR_SIZE] = Temp_Compare_subblock[j/XOR_SIZE];
				Compare_block[i/XOR_SIZE][j/XOR_SIZE] = Temp_Compare_block[j/XOR_SIZE];
				Temp_Compare_subblock[j/XOR_SIZE] = 0;
				Temp_Compare_block[j/XOR_SIZE] = 0;
			}
				
	}
	return all_match;
}

void Draw_Block(int ver_ind, int hor_ind,UINT16* Orin_frabuf)
{
	int i,j;
	UINT16* Loc_frabuf;
	UINT16 Lcd_Short;
	
	if((ver_ind> VER_SIZE) || (hor_ind> HOR_SIZE))
		return;
	main_lcd_sendcommand( XADDRESS_AREA_SET );
	main_lcd_sendcommand(ver_ind*XOR_SIZE);
	main_lcd_sendcommand(ver_ind*XOR_SIZE+XOR_SIZE-1);
					
	main_lcd_sendcommand( YADDRESS_AREA_SET );
	main_lcd_sendcommand( hor_ind*XOR_SIZE );
	main_lcd_sendcommand( hor_ind*XOR_SIZE+XOR_SIZE-1);  

	Orin_frabuf += ver_ind*XOR_SIZE*R2D_WIDTH + hor_ind*XOR_SIZE;
	Loc_frabuf = Orin_frabuf;
	for(i=0;i<XOR_SIZE;i++)
	{
		for(j=0;j<XOR_SIZE;j++)
		{
				
				
				Lcd_Short = *Loc_frabuf++;
				main_lcd_senddata(Lcd_Short);
		}
		Loc_frabuf = Orin_frabuf + (i+1)*R2D_WIDTH;
	}


}

void Draw_Bluk(int ver_ind_begin, int hor_ind_begin, int ver_ind_end, int hor_ind_end, UINT16* Orin_frabuf)
{
	int i,j;
	UINT16* Loc_frabuf;
	UINT16 Lcd_Short;
	
	if((ver_ind_begin> VER_SIZE) || (hor_ind_begin> HOR_SIZE) ||(ver_ind_end> VER_SIZE) || (hor_ind_end> HOR_SIZE))
		return;
	main_lcd_sendcommand( XADDRESS_AREA_SET );
	main_lcd_sendcommand(ver_ind_begin*XOR_SIZE);
	main_lcd_sendcommand((ver_ind_end - ver_ind_begin)*XOR_SIZE+XOR_SIZE-1);
					
	main_lcd_sendcommand( YADDRESS_AREA_SET );
	main_lcd_sendcommand( hor_ind_begin*XOR_SIZE );
	main_lcd_sendcommand( (hor_ind_end - hor_ind_begin)*XOR_SIZE+XOR_SIZE-1);  

	Orin_frabuf += ver_ind_begin*XOR_SIZE*R2D_WIDTH + hor_ind_begin*XOR_SIZE;
	Loc_frabuf = Orin_frabuf;
	for(i=0;i<(ver_ind_end - ver_ind_begin + 1)*XOR_SIZE;i++)
	{
		for(j=0;j<(hor_ind_end - hor_ind_begin + 1)*XOR_SIZE;j++)
		{
				
				
				Lcd_Short = *Loc_frabuf++;
				main_lcd_senddata(Lcd_Short);
		}
		Loc_frabuf = Orin_frabuf + (i+1)*R2D_WIDTH;
	}


}

#endif // _XOR_COMPARE_


/* zhq, 2004/08/03, modified for we use update region to do refresh to save power and time. */
void Draw_Rectangle(int ver_ind_begin, int hor_ind_begin, int ver_ind_end, int hor_ind_end, UINT16* Orin_frabuf)
{
	int i,j;
	UINT16* Loc_frabuf;
	UINT16 Lcd_Short;
	
	if((ver_ind_begin> R2D_HEIGHT) || (hor_ind_begin> R2D_WIDTH) ||(ver_ind_end> R2D_HEIGHT) || (hor_ind_end> R2D_WIDTH))
		return;
	main_lcd_sendcommand( XADDRESS_AREA_SET );
	main_lcd_sendcommand(ver_ind_begin);
	main_lcd_sendcommand(ver_ind_end);
					
	main_lcd_sendcommand( YADDRESS_AREA_SET );
	main_lcd_sendcommand( hor_ind_begin);
	main_lcd_sendcommand( hor_ind_end);  

	Orin_frabuf += ver_ind_begin*R2D_WIDTH + hor_ind_begin;
	Loc_frabuf = Orin_frabuf;
	for(i=0;i<(ver_ind_end - ver_ind_begin + 1);i++)
	{
		for(j=0;j<(hor_ind_end - hor_ind_begin + 1);j++)
		{
				
				
				Lcd_Short = *Loc_frabuf++;
				main_lcd_senddata(Lcd_Short);
		}
		Loc_frabuf = Orin_frabuf + (i+1)*R2D_WIDTH;
	}


}


void r2d_update_region(INT16 ul_x,INT16 ul_y,INT16 br_x,INT16 br_y)
{

	if (ul_x < r2d_update_ul_x)
		r2d_update_ul_x=ul_x;
    if (ul_y < r2d_update_ul_y)
		r2d_update_ul_y=ul_y;
	if (br_x > r2d_update_br_x)
		r2d_update_br_x=br_x;
	if (br_y > r2d_update_br_y)
		r2d_update_br_y=br_y;

	if (r2d_update_ul_x<0)
       r2d_update_ul_x=0;
    if (r2d_update_ul_y<0)
       r2d_update_ul_y=0;
    if (r2d_update_br_x>=R2D_WIDTH)
       r2d_update_br_x=R2D_WIDTH-1;
    if (r2d_update_br_y>=R2D_HEIGHT)
       r2d_update_br_y=R2D_HEIGHT-1;
}


void r2d_refresh(void)
{
#if(LCDC_DRV_CHIP == 0 )	
	unsigned char i,j;
	UINT32 Lcd_Temp,*pPmemory_Words_Pointer;
	UINT16 Lcd_Byte_1,Lcd_Byte_2;
	UINT16 Lcd_Byte_temp;

	pPmemory_Words_Pointer=r2d_g_framebuffer->p_memory_words;

	MI_dbgPrintf("zhq: r2d_refresh r2d_update_ul_x = %d",r2d_update_ul_x);
	MI_dbgPrintf("zhq: r2d_refresh r2d_update_ul_y = %d",r2d_update_ul_y);
	MI_dbgPrintf("zhq: r2d_refresh r2d_update_br_x = %d",r2d_update_br_x);
	MI_dbgPrintf("zhq: r2d_refresh r2d_update_br_y = %d",r2d_update_br_y);



/* zhq, 2004/08/03, modified for we use update region to do refresh to save power and time. */
	Draw_Rectangle(r2d_update_ul_y, r2d_update_ul_x, r2d_update_br_y, r2d_update_br_x, (UINT16*)pPmemory_Words_Pointer);

/* zhq, 2004/08/03, added for we use explicit OR to compare frame buffer. */
#ifdef _XOR_COMPARE_
	if(!XOR_Compare(pPmemory_Words_Pointer)) Draw_Bluk(ver_begin, hor_begin, ver_end, hor_end, (UINT16*)pPmemory_Words_Pointer);
#endif // _XOR_COMPARE_

#if 0
	MI_dbgPrintf("zhq: XOR result, CompareFramebuffer_result = %x", CompareFramebuffer_result);


	//X address set
	/*
	main_lcd_sendcommand( XADDRESS_AREA_SET );
	main_lcd_sendcommand( 0x0 );
	main_lcd_sendcommand( 0x9f );
	*/
	//Y address set
	/*
	main_lcd_sendcommand( YADDRESS_AREA_SET );
	main_lcd_sendcommand( 0x0 );
	main_lcd_sendcommand( 0x7f );  
	*/
	i=0;
	while ( i < R2D_HEIGHT )
	{
		j=0;
		while ( j < (R2D_MWWIDTH) )
		{
			if(!(Compare_result[i/XOR_SIZE] & (1L<<(j/XOR_SIZE))))
			{/* zhq, this XOR_BLOCK match. */
				j += XOR_SIZE;
				pPmemory_Words_Pointer += (R2D_MWWIDTH);
				continue;	
			}	
			else
			{
				if(((i)%16) == 0)
				{
					main_lcd_sendcommand( XADDRESS_AREA_SET );
					main_lcd_sendcommand(i);
					main_lcd_sendcommand(i+15);
					
					main_lcd_sendcommand( YADDRESS_AREA_SET );
					main_lcd_sendcommand( 0x0 );
					main_lcd_sendcommand( 0x7f );  
					
				}
			}
			
			Lcd_Temp = *pPmemory_Words_Pointer++;

			#if 1
			Lcd_Byte_1 = Lcd_Temp & 0x0000ffff;
			Lcd_Byte_2 = (Lcd_Temp & 0xffff0000) >> 16;
			

			main_lcd_senddata(Lcd_Byte_1);
			main_lcd_senddata(Lcd_Byte_2);
			#else
			
			*((volatile UINT16 *) MAIN_LCD_DATA_ADDR) = (UINT16)Lcd_Temp & 0x0000ffff;
			*((volatile UINT16 *) MAIN_LCD_DATA_ADDR) = (UINT16)(Lcd_Temp & 0xffff0000) >> 16;
		    #endif
			
			j++;          
		}
		//pPmemory_Words_Pointer++;   
		i++;
	} 
#endif
#elif( LCDC_DRV_CHIP == 1 )
	UINT32 addr1;
	UINT16 *pframeBuf;
/*
	if(pCamConfig.m_nCurAction == CAMERA_MODE)
		return;

	pframeBuf=( UINT16 *)r2d_g_framebuffer->p_memory_words;
	addr1=GetStartAddress(cl_MAIN_WINDOW);
	halWriteData(2, addr1,pframeBuf, R2D_HEIGHT*R2D_WIDTH*2);
	
	clStartOneFrameTransfer();
*/

	unsigned char i,j;
	UINT32 Lcd_Temp,*pPmemory_Words_Pointer;
	UINT16 Lcd_Byte_1,Lcd_Byte_2;
	UINT16 Lcd_Byte_temp;

	extern CAMCONFIG pCamConfig;


	if(pCamConfig.m_nCurAction == CAMERA_MODE)
		return;

	pPmemory_Words_Pointer=r2d_g_framebuffer->p_memory_words;

	//X address set
	main_lcd_sendcommand( 0x2a );
	main_lcd_senddata( 0x04 );
	main_lcd_senddata( 0x83 );

	//Y address set
	main_lcd_sendcommand( 0x2b );
	main_lcd_senddata( 0x04 );
	main_lcd_senddata( 0x83 );  

	main_lcd_sendcommand( 0x2c );
	
	i=0;
	while ( i < 128 )
	{
		j=0;
		while ( j < (R2D_MWWIDTH) )
		{

		
			Lcd_Temp = *pPmemory_Words_Pointer++;

			#if 1
			Lcd_Byte_1 = Lcd_Temp & 0x0000ffff;
			Lcd_Byte_2 = (Lcd_Temp & 0xffff0000) >> 16;
			
			main_lcd_senddata8((Lcd_Byte_1>>8 )& 0x00ff);		
			main_lcd_senddata8(Lcd_Byte_1 & 0x00ff);
			
			main_lcd_senddata8((Lcd_Byte_2>>8 )& 0x00ff);
			main_lcd_senddata8(Lcd_Byte_2 & 0x00ff);
			#else
			
			*((volatile UINT16 *) MAIN_LCD_DATA_ADDR) = (UINT16)Lcd_Temp & 0x0000ffff;
			*((volatile UINT16 *) MAIN_LCD_DATA_ADDR) = (UINT16)(Lcd_Temp & 0xffff0000) >> 16;
		    #endif
			
			j++;          
		}
		//pPmemory_Words_Pointer++;   
		i++;
	} 

#endif

	r2d_reinit_update_region();

	#if (R2D_BENCHMARKING == R2D_ON)
	if ( r2d_g_tick==0 )
	{
		time=rvf_get_tick_count()-time;
		r2d_g_tick=1;
		rvf_send_trace("R2D : Nb refreshs",17,R2D_REFRESH_LOOP, 
					   RV_TRACE_LEVEL_ERROR, TRACE_R2D );
		rvf_send_trace("R2D : Ms=",9,time*10, 
					   RV_TRACE_LEVEL_ERROR, TRACE_R2D );
	}
	#endif
}


#if( LCMS_DRV_CHIP == 0 )
#define SUBLCD_PAGES 			8
#define SUBLCD_COLUMNS 			96
#define SUBLCD_BYTESPER_PAGE 	96

#define DIV8(v)  ((v)>>3)
#define MOD8(v) ((v) & 0x07)

#define DISPLAY_SELECT_COMMAND		0xa4
#define DISPLAY_LINE_COMMAND			0x40

static unsigned char temp_frame[64*12];
#elif(LCMS_DRV_CHIP == 1)

#define SUBLCD_PAGES 			8
#define SUBLCD_COLUMNS 			96
#define SUBLCD_BYTESPER_PAGE 	96

#define DIV8(v)  ((v)>>3)
#define MOD8(v) ((v) & 0x07)

#define DISPLAY_SELECT_COMMAND		0xa4
#define DISPLAY_LINE_COMMAND			0x40

static unsigned char temp_frame[64*12];


//#define SUBLCD_PAGES 			5
//#define SUBLCD_COLUMNS 			96
//#define SUBLCD_BYTESPER_PAGE 	96
#elif(LCMS_DRV_CHIP == 2)
#define SUBLCD_PAGES 			16
#define SUBLCD_COLUMNS 			96
#define SUBLCD_BYTESPER_PAGE 	96
#endif

void r2d_sub_refresh(void)
{
#if( LCMS_DRV_CHIP == 0 )
	UINT16 iPage, iCol, iBytes, iBits, iPageBase;
	UINT8 *oPixels, *nPixels, val, *p_temp_frame;
	UINT16* pbuffer;
	UINT8 byte = 0x00;
	int i,j;
	
	//pbuffer = r2d_g_subframebuffer->p_memory_words; 
	p_temp_frame = temp_frame;


	for( i = 0; i < R2D_SUB_HEIGHT; i++ )
	{
		//pbuffer = (UINT16*)( i * (R2D_MWWIDTH-1) + r2d_g_subframebuffer->p_memory_words);
		pbuffer = (UINT16*)( i * (R2D_MWWIDTH) + r2d_g_subframebuffer->p_memory_words);
		
		for(j = 0; j < (R2D_SUB_WIDTH >> 3); j++)
		{
			byte = 0x00;
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 7);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 6);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 5);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 4);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 3);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 2);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 1);
			byte |= (UINT8)(((*pbuffer++) & 0x0001) << 0);
			*p_temp_frame++ = ~byte;

		}

	}

	oPixels = temp_frame;

	sub_lcd_sendcommand(DISPLAY_LINE_COMMAND);
	for ( iPage = 0; iPage < SUBLCD_PAGES; iPage ++ )
	{
		iPageBase = SUBLCD_BYTESPER_PAGE * iPage;
		/*page address set*/
		sub_lcd_sendcommand( 0xb0 | iPage);
		/*column address set*/
		sub_lcd_sendcommand( 0x00 );
		sub_lcd_sendcommand( 0x10 );
		for ( iCol = 0; iCol < SUBLCD_COLUMNS; iCol ++ )
		{
			/*Get Data for Updating*/
			val = 0;
			iBytes = iPageBase + DIV8(iCol);
			iBits = MOD8(iCol);
			val = val |((((0x80>>iBits) & oPixels[iBytes]) << iBits)>>7);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 12]) << iBits)>>6);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 24]) << iBits)>>5);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 36]) << iBits)>>4);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 48]) << iBits)>>3);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 60]) << iBits)>>2);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 72]) << iBits)>>1);
			val = val |((((0x80>>iBits) & oPixels[iBytes + 84]) << iBits)>>0);
			/*Get Data OK!*/
			/*Send the Data to Physical Screen*/
			sub_lcd_senddata(val); 
		}
	}
#elif(  LCMS_DRV_CHIP == 1 )	

   UINT16 *pbuffer;
   char i,j;
   UINT8 byte;
   UINT8 page=0xb1;
   UINT8 H_col=0x11;
   UINT8 L_col=0x04;
   
   for(i=0;i<5;i++)
   {
	  pbuffer = (UINT16*)(  i*8*(R2D_MWWIDTH) + r2d_g_subframebuffer->p_memory_words);
   
      i2c_setaddress(page, L_col, H_col );
      i2c_senddata_continue_cmd();
      for(j=0;j<96;j++)
      {
	     byte = 0;
		 byte |= (UINT8)(((*pbuffer) & 0x0001) << 0); 
		 byte |= (UINT8)(((*(pbuffer+2*R2D_MWWIDTH)) & 0x0001) << 1); 	
		 byte |= (UINT8)(((*(pbuffer+4*R2D_MWWIDTH)) & 0x0001) << 2); 
		 byte |= (UINT8)(((*(pbuffer+6*R2D_MWWIDTH)) & 0x0001) << 3); 
		 byte |= (UINT8)(((*(pbuffer+8*R2D_MWWIDTH)) & 0x0001) << 4); 
		 byte |= (UINT8)(((*(pbuffer+10*R2D_MWWIDTH)) & 0x0001) << 5); 
		 byte |= (UINT8)(((*(pbuffer+12*R2D_MWWIDTH)) & 0x0001) << 6); 
		 byte |= (UINT8)(((*(pbuffer+14*R2D_MWWIDTH)) & 0x0001) << 7); 
		 *pbuffer++;
		
		i2c_senddata_continue_data(~byte);
		//i2c_senddata(~byte);	
         //i2c_senddata(0xcc);
      }
      i2c_end();
      page++;
   }

#elif(  LCMS_DRV_CHIP == 2 ) //for PHILIPS   (PCF8820)  (M288S)
	UINT16 *pbuffer;
	UINT8 byte = 0x00;
	int iPage,iCol;
	int page=0x41;
	int col =0x80;
	
	for ( iPage = 0; iPage < SUBLCD_PAGES; iPage ++ )
	{
		pbuffer = (UINT16*)(  iPage*4*(R2D_MWWIDTH) + r2d_g_subframebuffer->p_memory_words);
		
		/*page address set*/
         i2c_setaddress(page, col );
	     i2c_senddata_continue_cmd();
		for ( iCol = 0; iCol < SUBLCD_COLUMNS; iCol ++ )
		{
			/*Get Data for Updating*/

			byte = 0;
			byte |= (UINT8)(((*pbuffer) & 0x0003) << 0); 
			byte |= (UINT8)(((*(pbuffer+2*R2D_MWWIDTH)) & 0x0003) << 2); 	
			byte |= (UINT8)(((*(pbuffer+4*R2D_MWWIDTH)) & 0x0003) << 4); 
			byte |= (UINT8)(((*(pbuffer+6*R2D_MWWIDTH)) & 0x0003) << 6); 

			*pbuffer++;

			i2c_senddata_continue_data(~byte);
		}
	   page++;	
       i2c_end(); 
	}

#endif


}



#else
/*
	Convert LCD format framebuffer to windows 32bit ARGB data buffer,
	applications that use this function must allocate enough memory 
	pointed by buf before invoke it
*/
	#define lcd2win_red(lcdPixel,lcdStat)	(UINT32)(((lcdPixel & 0xf800) << 8) >> lcdStat)
	#define lcd2win_green(lcdPixel,lcdStat)	(UINT32)(((lcdPixel & 0x07e0) << 5) >> lcdStat)	
	#define lcd2win_blue(lcdPixel,lcdStat)	(UINT32)(((lcdPixel & 0x001f) << 3) >> lcdStat)
void GetAndConvertR2DGC(char * buf, int lcdStatus, int sub)
{
	UINT32 *memoryWordPtr, *desBuf;
	int	row, col, ls;
	UINT16 firstPixel, secondPixel;
		
	if(buf == NULL) 
		return;
		
	desBuf = (UINT32*)buf;
	if(sub == 1)	/* get sub LCD framebuffer */
	{
		
		ls = 0;		
		
		for(row = 0; row < 64; row++)
		{
			memoryWordPtr = r2d_g_subframebuffer->p_memory_words + row * R2D_MWWIDTH;
			
			for(col = 0; col < 48; col++)
			{
				firstPixel = (UINT16)(*memoryWordPtr & 0x0000ffff);
				secondPixel = (UINT16)((*memoryWordPtr & 0xffff0000) >> 16);				
					
				*desBuf = 0;
				*desBuf |= lcd2win_red(firstPixel,ls) | lcd2win_green(firstPixel,ls) | lcd2win_blue(firstPixel,ls);
				desBuf ++;

				*desBuf = 0;
				*desBuf |= lcd2win_red(secondPixel,ls) | lcd2win_green(secondPixel,ls) | lcd2win_blue(secondPixel,ls);
				desBuf ++;

				memoryWordPtr++;
			}
		}
	}
	else
	{
		memoryWordPtr = r2d_g_framebuffer->p_memory_words; 
		
		for(row = 0; row < R2D_HEIGHT; row++)
		{
// robert.chen modified, 2004-07-30, for compatiable with new R2D framebuffer (jpeg codec directly refresh LCD)		
//			for(col = 0; col < R2D_MWWIDTH - 1; col++)
			for(col = 0; col < R2D_MWWIDTH; col++)
			{
				firstPixel = (UINT16)(*memoryWordPtr & 0x0000ffff);
				secondPixel = (UINT16)((*memoryWordPtr & 0xffff0000) >> 16);

				if(lcdStatus)
					ls = 0;
				else
					ls = 1;
					
				*desBuf = 0;
				*desBuf |= lcd2win_red(firstPixel,ls) | lcd2win_green(firstPixel,ls) | lcd2win_blue(firstPixel,ls);
				desBuf ++;

				*desBuf = 0;
				*desBuf |= lcd2win_red(secondPixel,ls) | lcd2win_green(secondPixel,ls) | lcd2win_blue(secondPixel,ls);
				desBuf ++;

				memoryWordPtr++;
			}
		// robert.chen removed, 2004-07-30, for compatiable with new R2D framebuffer (jpeg codec directly refresh LCD)		
		//	memoryWordPtr++;
		}
	}	
	return;
	
}
#endif

