/************************************************************************************
* i2c.h :            contains driver for the i2c HD module						*
*																					*	
*																					*
*	Author: wanghaixiang														*
*																					*
*	version: 1.0																	*
*																					*
*	Date: 22/09/2000																*
*   (C) Copyright 2000 ,All Rights Reserved		*		
************************************************************************************/

#ifndef  _R2D_TASK_INIT_I_H
#define  _R2D_TASK_INIT_I_H

#define I2C_CLK	 	(1<<7)
#define I2C_DATA	(1<<12)

#define MEM_I2C 						0xfffe2800

#define I2C_DEVICE_REG				0xfffe2800
#define I2C_ADDRESS_REG			0xfffe2801
#define I2C_DATA_WR_REG			0xfffe2802
#define I2C_DATA_RD_REG			0xfffe2803
#define I2C_CMD_REG					0xfffe2804
#define I2C_CONF_FIFO_REG			0xfffe2805
#define I2C_CONF_CLK_REG			0xfffe2806
#define I2C_CONF_CLK_FUNC_REG		0xfffe2807
#define I2C_STATUS_FIFO_REG		0xfffe2808
#define I2C_STATUS_ACTIVITY_REG	0xfffe2809


#define I2C_EN_CLK 	(1<<1)
#define I2C_START	(1<<2)
#define I2C_RW		(1<<3)

#define SLAVE_DEVICE_IDENTIFICATION	0x78


//#define MAIN_LCD_COMMAND_ADDR 		0x01800000
//#define MAIN_LCD_DATA_ADDR			0x01800002

#define BUZZ_LIGHT_CONTROL_REG		0xfffe480e
#define LIGHT_LEVEL_REG					0xfffe4810

//MAIN_LCD  Command
#define START_OSC						0x02
#define DRIVER_OUTPUT_MODE_SET		0x10
#define DCDC_SELECT						0x20
#define BIAS_SET							0x22
#define DCDC_CLOCK_DIVISION_SET		0x24
#define DCDC_AMP_SET					0x26
#define TEMP_COMPENSATION_SET			0x28
#define CONTRAST_CONTROL1_SET			0x2a
#define CONTRAST_CONTROL2_SET			0x2b
#define STANDBY_MODE_OFF				0x2c
#define STANDBY_MODE_ON				0x2d
#define DDRAM_BURST_MODE_OFF			0x2e
#define DDRAM_BURST_MODE_ON			0x2f
#define ADDRESS_MODE_SET				0x30
#define ROW_VECTOR_MODE_SET			0x32
#define NBLOCK_INVERSION_SET			0x34
#define ENTRY_MODE_SET					0x40
#define XADDRESS_AREA_SET				0x42
#define YADDRESS_AREA_SET				0x43
#define SKIP_RAM_AREA_SET				0x45
#define DISPLAY_OFF						0x50
#define DISPLAY_ON						0x51
#define DISPLAY_PATTERN_SET			0x53
#define PARTIAL_DISPLAY_SET			0x55
#define PARTIAL_DISPLAY_START_LINE	0x56
#define PARTIAL_DISPLAY_END_LINE		0x57
#define AREA_SCROLL_SET				0x59
#define AREA_SCROLL_START_LINE		0x5a



//#define LCD_cmd(c)	*(volatile unsigned short*) 0x01800000 = (c)
//#define LCD_data(c) *(volatile unsigned short*) 0x01800002 = (c)
void main_lcd_disp( );
void main_lcd_init(void);
void sub_lcd_init(void);
#endif

