open Freetype
open Lcd
open Coding
open Ptset

type metrics ={ascent:int;
 descent:int;
 leading:int;
 max_width:int;
 max_height:int;
 underline:int;
 max_char_size:int
}

type glyph_metrics =
{
  glyph_index:int;
  width:int;
  height:int;
  x_advance : int;
  y_advance : int;
  x_org : int;
  y_org : int
}

type font =
{
   framebuffer : number list ;
   global_metrics : metrics ;
   local_metrics : glyph_metrics list ;
   transcodage : Ptset.t
}

val empty_global_metrics : metrics
val empty_font : font

val combine_metrics : metrics -> metrics -> metrics
val combine_fonts : font -> font -> font
val unicode_of_win_latin1 : int -> int
val process_font : metrics -> unicode_block list -> face -> reversex:bool -> reversey:bool  -> vertical:bool -> font
val process_ti_font : metrics -> reversex:bool -> reversey:bool  -> vertical:bool -> font
val extract_ti_bitmap : int -> int -> bool -> bool-> bool -> int Freetype.matrix
