/**
                                                                          
	@file:	r2d_lcds.c
	
	@author Christophe Favergeon                              
                                                                          
    @version	0.5	

    Purpose:	Include LCDs dependent definitions (the LCD APIs)
	
*/

/*
																			
 	Date       	Modification												
  ------------------------------------									
    06/02/2001	Create		
	10/18/2001  Version 0.5 for first integration with Riviera database
																											    
																			
 (C) Copyright 2001 by Texas Instruments Incorporated, All Rights Reserved
*/

#include "general.h"
#include "rvf_api.h"
#include "r2d_config.h"
#include "r2d.h"
#include "r2d_i.h"
#include "r2d_independance_layer.h"
#if (R2D_DEBUG == R2D_ON)
#include <stdio.h>
#endif

#if (R2D_EMBEDDED_LCD == R2D_PC_COLOR_LCD)
#include "Windows.h"
#endif

#ifndef _WINDOWS
	#include "board.cfg"
#endif

//////////////////////////////////
//
// Include LCD dependent C code
//
#if (R2D_EMBEDDED_LCD == R2D_SIMPLE_LCD)
  #include "LCDs/Simple/R2D_simple_lcd_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_PC_COLOR_LCD)
  #include "LCDs/ColorPC/R2D_pc_color_lcd_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_MIRRORED_LCD)
  #include "LCDs/Simple/R2D_simple_lcd_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_CUSTOMER_LCD)
  #include "LCDs/Customer/R2D_customer_lcd_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_HORIZONTAL_LCD)
  #include "LCDs/Horizontal/R2D_horizontal_lcd_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_BOARD_COLOR_LCD)
  #include "LCDs/ColorBoard/R2D_board_color_lcd_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_BOARD_DSAMPLE)
#include "LCDs/D_Sample/R2D_board_dsample_lcd_i.c"
#endif