/**
                                                                          
	@file:	r2d_refresh.c
	
	@author Christophe Favergeon                              
                                                                          
    @version 0.5	

    Purpose: Includes LCDs depend definitions for the refresh task
	         (Second part of LCD APIs)
	
*/

/*
																			
 	Date       	Modification												
  ------------------------------------									
    06/02/2001	Create		
	10/18/2001  Version 0.5 for first integration with Riviera database
																											    
																			
 (C) Copyright 2001 by Texas Instruments Incorporated, All Rights Reserved
*/



// modified by clrobert
// change from
/*
#include "general.h"
#include "rvf_api.h"
#include "r2d_messages.h"
#include "r2d_env.h"
#include "lcd_messages_ti.h"
#include "lcd_messages.h"
#include "r2d_config.h"
#include "r2d.h"
#include "r2d_i.h"
#include "uwire.h"
*/
// to
#ifndef _INNOVATION_EMULATOR_
#include "general.h"
#include "rvf_api.h"
#include "r2d_messages.h"
#include "r2d_env.h"
#include "lcd_messages_ti.h"
#include "lcd_messages.h"
#include "r2d_config.h"
#include "r2d.h"
#include "r2d_i.h"
#include "uwire.h"
#else
#include "general.h"
#include "r2d_messages.h"
#include "r2d_env.h"
#include "r2d_config.h"
#include "r2d.h"
#include "r2d_i.h"
#endif
// modify end, for the purpose of building emulator 


// modified by clrobert
// from
/*
extern T_RVF_MB_ID r2d_mb_id;
*/
// to 
#ifndef _INNOVATION_EMULATOR_
extern T_RVF_MB_ID r2d_mb_id;
#endif

INT16 r2d_update_ul_x,r2d_update_ul_y,r2d_update_br_x,r2d_update_br_y;

//xmzhou to put R2D buffer 
#if 1
#ifndef _INNOVATION_EMULATOR_
#pragma DATA_SECTION (r2d_lcd_memory_words, ".DISP_BUF");
#if R2D_SUBLCD_SUPPORT	/* Robert.Chen add, for sub LCD, 2003-12-13 */
#pragma DATA_SECTION (r2d_sublcd_memory_words, ".DISP_BUF");
#endif
#endif
#endif

#if (R2D_REFRESH == R2D_VERTICAL)
  UINT32 r2d_lcd_memory_words[(((R2D_WIDTH*R2D_MWHEIGHT)+1))];
  /* Robert.Chen add, for sub LCD framebuffer, 2003-12-13 */	
  #if R2D_SUBLCD_SUPPORT
  UINT32 r2d_sublcd_memory_words[(((R2D_WIDTH*R2D_MWHEIGHT)+1))];
  #endif
#else
  UINT32 r2d_lcd_memory_words[(((R2D_MWWIDTH*R2D_HEIGHT)+1))];
  /* Robert.Chen add, for sub LCD framebuffer, 2003-12-13 */	
  #if R2D_SUBLCD_SUPPORT
  UINT32 r2d_sublcd_memory_words[(((R2D_MWWIDTH*R2D_HEIGHT)+1))];
  #endif
#endif

void r2d_reinit_update_region(void)
{
	r2d_update_ul_x=R2D_WIDTH;
	r2d_update_ul_y=R2D_HEIGHT;
	r2d_update_br_x=-1;
	r2d_update_br_y=-1;
}



#if (R2D_EMBEDDED_LCD == R2D_PC_COLOR_LCD)
#include "LCDs/ColorPC/r2d_task_i.c"
#endif


#if (R2D_EMBEDDED_LCD == R2D_SIMPLE_LCD) 
#include "LCDs/Simple/r2d_task_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_MIRRORED_LCD) 
#include "LCDs/Simple/r2d_task_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_CUSTOMER_LCD) 
#include "LCDs/Customer/r2d_task_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_HORIZONTAL_LCD) 
#include "LCDs/Horizontal/r2d_task_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_BOARD_COLOR_LCD) 
#include "LCDs/ColorBoard/r2d_task_i.c"
#endif

#if (R2D_EMBEDDED_LCD == R2D_BOARD_DSAMPLE)
#include "LCDs/D_Sample/r2d_task_i.c"
#endif

