RIVIERA_FLAGS   := -g -mt -mn $(CFLAGSRIV)

LIB_RIVIERA_CORE_FLASH   := $(OUT_LIB_DIR)/riviera_core$(NBRD)$(NBLUETOOTH)$(NGOLITE)$(NWCP)_flash.lib
LIB_RIVIERA_CORE_INT_RAM := $(OUT_LIB_DIR)/riviera_core$(NBRD)$(NBLUETOOTH)$(NGOLITE)$(NWCP)_int_ram.lib
LIB_RIVIERA_CUST_FLASH   := $(OUT_LIB_DIR)/riviera_cust$(NBRD)$(NBLUETOOTH)$(NGOLITE)$(NWCP)_flash.lib
LIB_RIVIERA_CUST_INT_RAM := $(OUT_LIB_DIR)/riviera_cust$(NBRD)$(NBLUETOOTH)$(NGOLITE)$(NWCP)_int_ram.lib

CFG_LIBS      += $(LIB_RIVIERA_CORE_FLASH) $(LIB_RIVIERA_CORE_INT_RAM) $(LIB_RIVIERA_CUST_FLASH) $(LIB_RIVIERA_CUST_INT_RAM)

ifdef RIVIERA_SOURCE
SRC_RIVIERA_CORE_FLASH += $(RIVIERA_DIR)/rvm/rvm_api.c $(RIVIERA_DIR)/rvm/rvm_swe_db.c \
                          $(RIVIERA_DIR)/rvm/rvm_task.c $(RIVIERA_DIR)/rvm/rvm_group_swe.c \
                          $(RIVIERA_DIR)/rvm/rvm_mem.c $(RIVIERA_DIR)/rvm/rvm_swe_hdlr.c \
                          $(RIVIERA_DIR)/rvf/rvf_buffer.c $(RIVIERA_DIR)/rvf/rvf_task.c \
                          $(RIVIERA_DIR)/rvf/rvf_time.c $(RIVIERA_DIR)/rvf/rvf_trace_adapt.c \
                          $(RIVIERA_DIR)/rvt/ti_profiler/ti_profiler.c \
                          $(RIVIERA_DIR)/rvt/ti_profiler/ti_profiler_env.c $(RIVIERA_DIR)/rvf/rvf_msg.c \
                          $(RIVIERA_DIR)/support/exception.c
SRC_RIVIERA_CORE_INT_RAM +=
endif

SRC_RIVIERA_CORE_FLASH += $(RIVIERA_DIR)/rvt/rvt_api.c $(RIVIERA_DIR)/rvt/rvt_env.c \
                          $(RIVIERA_DIR)/rvt/rvt_task.c

SRC_RIVIERA_CUST_FLASH +=  $(RIVIERA_DIR)/rvf/rvf_mem_pool.c $(RIVIERA_DIR)/rvm/rvm_swe.c
SRC_RIVIERA_CUST_INT_RAM +=


OBJ_RIVIERA_CORE_FLASH   := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_RIVIERA_CORE_FLASH)))
OBJ_RIVIERA_CORE_INT_RAM := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_RIVIERA_CORE_INT_RAM)))
OBJ_RIVIERA_CUST_FLASH   := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_RIVIERA_CUST_FLASH)))
OBJ_RIVIERA_CUST_INT_RAM := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_RIVIERA_CUST_INT_RAM)))


CFG_OBJS += $(OBJ_RIVIERA_CORE_FLASH) $(OBJ_RIVIERA_CORE_INT_RAM) $(OBJ_RIVIERA_CUST_FLASH) $(OBJ_RIVIERA_CUST_INT_RAM)
CFG_DEPS += $(OBJ_RIVIERA_CORE_FLASH:.obj=.d) $(OBJ_RIVIERA_CORE_INT_RAM:.obj=.d) $(OBJ_RIVIERA_CUST_FLASH:.obj=.d) $(OBJ_RIVIERA_CUST_INT_RAM:.obj=.d)


$(LIB_RIVIERA_CORE_FLASH) : $(OBJ_RIVIERA_CORE_FLASH)
	ar470 r $(LIB_RIVIERA_CORE_FLASH) $(OBJ_RIVIERA_CORE_FLASH)

$(LIB_RIVIERA_CORE_INT_RAM) : $(OBJ_RIVIERA_CORE_INT_RAM)
	ar470 r $(LIB_RIVIERA_CORE_INT_RAM) $(OBJ_RIVIERA_CORE_INT_RAM)

$(LIB_RIVIERA_CUST_FLASH) : $(OBJ_RIVIERA_CUST_FLASH)
	ar470 r $(LIB_RIVIERA_CUST_FLASH) $(OBJ_RIVIERA_CUST_FLASH)

$(LIB_RIVIERA_CUST_INT_RAM) : $(OBJ_RIVIERA_CUST_INT_RAM)
	ar470 r $(LIB_RIVIERA_CUST_INT_RAM) $(OBJ_RIVIERA_CUST_INT_RAM)

$(OBJ_RIVIERA_CORE_FLASH) $(OBJ_RIVIERA_CORE_INT_RAM) $(OBJ_RIVIERA_CUST_FLASH) $(OBJ_RIVIERA_CUST_INT_RAM) : %.obj: %.c
	cl470 $(RIVIERA_FLAGS)  -fr$(@D) $<