#
#       Makefile for Audio Riviera service (ARM compiler)
#
#       Copyright (c) Texas Instruments 2001
#
#               Author: Mazard Francois
#       Date : 12 July 2001

AUDIO_FLAGS := -g -mt -mn $(CFLAGSSERVICES)

LIB_AUDIO := $(OUT_LIB_DIR)/audio$(NANALOG)$(NDSP)$(NGOLITE).lib
CFG_LIBS  += $(LIB_AUDIO)

ifdef AUDIO_SOURCE
SRC_AUDIO += $(SERVICES_DIR)/audio/audio_env.c             $(SERVICES_DIR)/audio/audio_api.c           \
             $(SERVICES_DIR)/audio/audio_error_hdlr.c      $(SERVICES_DIR)/audio/audio_task.c          \
             $(SERVICES_DIR)/audio/audio_keybeep.c         $(SERVICES_DIR)/audio/audio_tones.c         \
             $(SERVICES_DIR)/audio/audio_melody_E1.c       $(SERVICES_DIR)/audio/audio_ffs.c           \
             $(SERVICES_DIR)/audio/audio_vm.c              $(SERVICES_DIR)/audio/audio_vm_play.c       \
             $(SERVICES_DIR)/audio/audio_vm_record.c       $(SERVICES_DIR)/audio/audio_vm_amr.c        \
             $(SERVICES_DIR)/audio/audio_vm_amr_play.c     $(SERVICES_DIR)/audio/audio_vm_amr_record.c \
             $(SERVICES_DIR)/audio/audio_compatibilities.c $(SERVICES_DIR)/audio/audio_sr_enroll.c     \
             $(SERVICES_DIR)/audio/audio_sr_update.c       $(SERVICES_DIR)/audio/audio_sr_reco.c       \
             $(SERVICES_DIR)/audio/audio_sr.c              $(SERVICES_DIR)/audio/audio_mode.c          \
             $(SERVICES_DIR)/audio/audio_mode_full_write.c $(SERVICES_DIR)/audio/audio_mode_load.c     \
             $(SERVICES_DIR)/audio/audio_mode_save.c       $(SERVICES_DIR)/audio/audio_mode_drivers.c  \
             $(SERVICES_DIR)/audio/audio_mode_volume.c     $(SERVICES_DIR)/audio/audio_melody_E2.c     \
             $(SERVICES_DIR)/audio/audio_driver.c          $(SERVICES_DIR)/audio/audio_ps_api.c
endif

OBJ_AUDIO := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_AUDIO)))


CFG_OBJS += $(OBJ_AUDIO)
CFG_DEPS += $(OBJ_AUDIO:.obj=.d)


$(LIB_AUDIO) : $(OBJ_AUDIO)
	ar470 r $(LIB_AUDIO) $(OBJ_AUDIO)

$(OBJ_AUDIO) : %.obj: %.c
	cl470 $(AUDIO_FLAGS) -fr$(@D) $<