#
#       Makefile for CST service (ARM compiler) 
#
#       Copyright (c) Texas Instruments 2001
# 
#               Author: Laurent Sollier
#       Date : 11 February 2002

CST_DEFS    := -dNTRACE -d_TARGET_ -dNEW_ENTITY -uFF_EM_MODE -dSHARED_VSI -dSMI -dNWARN -dOPTION_MULTITHREAD -dNEW_FRAME
#   Compilation flag for memory supervision
#CST_DEFS    := -dNTRACE -d_TARGET_ -dNEW_ENTITY -uFF_EM_MODE -dSHARED_VSI -dSMI -dNWARN -dOPTION_MULTITHREAD -dNEW_FRAME -dMEMORY_SUPERVISION

#TISH031124 modify include path and folder name CST_IP      := -i$(CONDAT_BASE_DIR)/../../gpf/inc -i$(CONDAT_BASE_DIR)/cdginc/cdginc$(NSRVC)$(NWAP)$(NBT)$(NPMODE)$(NDP)$(NEOTD)$(NTTY) -i$(CONDAT_BASE_DIR)/ms/src/aci
CST_IP      := -i$(CONDAT_BASE_DIR)/../../gpf/inc -i$(CONDAT_BASE_DIR)/cdginc/cdginc$(L23_NAMES) -i$(CONDAT_BASE_DIR)/ms/src/aci
CST_FLAGS   := -g -me -mt -o -x -mw $(CST_DEFS) $(CST_IP) $(CFLAGSSERVICES) -i$(SERVICES_DIR)/cst

LIB_CST    := $(OUT_LIB_DIR)/cst$(NPMODE)$(NCHP)$(NBRD)$(NNF)$(NNTRC)$(NWCP).lib
#   Name of the lib for memory supervision
#LIB_CST     := $(OUT_LIB_DIR)/cst$(NPMODE)$(NCHP)$(NBRD)$(NNF)$(NNTRC)$(NWCP)_ps.lib 
CFG_LIBS    += $(LIB_CST)

SRC_CST     +=	$(SERVICES_DIR)/cst/cst_csf.c $(SERVICES_DIR)/cst/cst_exts.c  $(SERVICES_DIR)/cst/cst_pei.c \
                $(SERVICES_DIR)/cst/cst_stack.c

OBJ_CST     := $(patsubst %.c,%.obj,$(filter %.c,$(SRC_CST)))


CFG_OBJS += $(OBJ_CST)
#Generation of dependencies is not performed for CST
#CFG_DEPS += $(OBJ_CST:.obj=.d)


$(LIB_CST) : $(OBJ_CST)
	ar470 r $(LIB_CST) $(OBJ_CST)


$(OBJ_CST) : %.obj: %.c
	cl470 $(CST_FLAGS) -fr$(@D) $<
