/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Resource Manager
 $File:		    MmiBlkLangDB.c
 $Revision:		1.0                                                        
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:

    This file contains the basic resource manager information relating
	to the textual entries managed.

    There are two routines provided by this module, one returning the
	number of resource tables supported, the other giving the base address
	of the resource tables.

    This module is derived from an auto generated version of the file with
	additional commenting added.
                        
********************************************************************************
 $History: MmiBlkLangDB.c
    Date .................. Modification ......................................
	25/10/00			Original Condat(UK) BMI version.	
    01/08/02      version 0.100 zy add "TxtAddNewCall,TxtEndOne"two words for call menu
	04/08/02      version 0.101 zy add settings related words 
	06/08/02	  wufei modified
        07/08/02         xsf modified	   
        08/08            fzq modified
        08/09                     windy modified    
    08/14/2002    version 0.102 zhangzg add "TxtSuohaNew, TxtSuohaPre" and their chinese verions
	15/08/02          gdy modified
    16/08/02      version 0.103 tangyan modified  "chineseTxtSuohaNew[], chineseTxtSuohaPre[]"
    19/08/02      version 0.104 wnagxia modified
    19/08/02      version 0.105 xusufang modified 
  26/08/02		hxl add for charger(TxtNeedChargering)
  28/08/02      wufei modified
      29/08/02       xsf modified
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

#include "typedefs.h"
#include "vsi.h"
#include "pei.h"
#include "custom.h"
#include "gsm.h"

#else

#include "stddefs.h"
#include "custom.h"
#include "gsm.h"
#include "vsi.h"

#endif
#include "MmiBlkLangDB.h"
#include "mmisounds_defs.h"			// 2004.5.24 wyj add for E505 E506


/*******************************************************************************
                                                                              
                                Local structures                                 
                                                                              
*******************************************************************************/

/* The tPointerStructure provides the basic entry type for the resource
   tables indicated below.

   The structure provides a simple one-to-one mapping between the identifier
   and it's associated text string.
*/
/*
typedef struct _tPointerStructure_
{
    long int Id;
    char *Text;
} tPointerStructure, *pPointerStructure;

*/

/*******************************************************************************
                                                                              
                                Local data tables                                 
                                                                              
*******************************************************************************/
/* Text table 2, autogenerated to provide English text associations.
*/
char DCTbVar[10][40]={{0},{0},{0},{0},{0},{0},{0},{0},{0},{0}};//WUFEI APPEND


const char chineseTxtInsertnote[] = {0x80, 0x00,'I',0x00,'n',0x00,'s',0x00,'e',0x00,'r',0x00,'t',0x00,' ',0x00,'N',0x00,'o',0x00,'t',0x00,'e',0x00,0x00,0x00 };
const char chineseTxtMelodygenerator[] = {0x80, 0x00,'M',0x00,'e',0x00,'l',0x00,'o',0x00,'d',0x00,'y',0x00,'g',0x00,'e',0x00,'n',0x00,'e',0x00,'r',0x00,'a',0x00,'t',0x00,'o',0x00,'r',0x00,0x00,0x00 };
const char chineseTxtOctaveHigher[] = {0x80, 0x00,'O',0x00,'c',0x00,'t',0x00,'a',0x00,'v',0x00,'e',0x00,' ',0x00,'h',0x00,'i',0x00,'g',0x00,'h',0x00,'e',0x00,'r',0x00,0x00,0x00 };
const char chineseTxtOctaveLower[] = {0x80, 0x00,'O',0x00,'c',0x00,'t',0x00,'a',0x00,'v',0x00,'e',0x00,' ',0x00,'l',0x00,'o',0x00,'w',0x00,'e',0x00,'r',0x00,0x00,0x00 };
const char chineseTxtLoadMelody[] = {0x80, 0x00,'L',0x00,'o',0x00,'a',0x00,'d',0x00,' ',0x00,'m',0x00,'e',0x00,'l',0x00,'o',0x00,'d',0x00,'y',0x00,0x00,0x00 };
const char chineseTxtEasyText[] = {0x80, 0x00,'e',0x00,'Z',0x00,'i',0x00,'T',0x00,'e',0x00,'x',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtDataCount[] = {0x80, 0x00,'D',0x00,'a',0x00,'t',0x00,'a',0x00,' ',0x00,'C',0x00,'o',0x00,'u',0x00,'n',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtQoS[] = {0x80, 0x00,'Q',0x00,'o',0x00,'S',0x00,0x00,0x00 };
const char chineseTxtTypeofConnection[] = {0x80, 0x00,'C',0x00,'o',0x00,'n',0x00,'n',0x00,'e',0x00,'c',0x00,'t',0x00,'i',0x00,'o',0x00,'n',0x00,0x00,0x00 };
const char chineseTxtResetCount[] = { 0x80,0x00,'R',0x00,'e',0x00,'s',0x00,'e',0x00,'t',0x00,' ',0x00,'C',0x00,'o',0x00,'u',0x00,'n',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtDataCounter[] = { 0x80,0x00,'D',0x00,'a',0x00,'t',0x00,'a',0x00,' ',0x00,'C',0x00,'o',0x00,'u',0x00,'n',0x00,'t',0x00,'e',0x00,'r',0x00,0x00,0x00 };
const char chineseTxtV42bis[] = { 0x80,0x00,'v',0x00,'.',0x00,'4',0x00,'2',0x00,'b',0x00,'i',0x00,'s',0x00,0x00,0x00 };
const char chineseTxtNormal[] = {0x80, 0x00,'N',0x00,'o',0x00,'r',0x00,'m',0x00,'a',0x00,'l',0x00,0x00,0x00 };
const char chineseTxtCSD[] = {0x80, 0x00,'C',0x00,'S',0x00,'D',0x00,0x00,0x00 };
const char chineseTxtClassB[] = {0x80, 0x00,'C',0x00,'l',0x00,'a',0x00,'s',0x00,'s',0x00,' ',0x00,'B',0x00,0x00,0x00 };
const char chineseTxtClassC[] = {0x80, 0x00,'C',0x00,'l',0x00,'a',0x00,'s',0x00,'s',0x00,' ',0x00,'C',0x00,0x00,0x00 };
const char chineseTxtIPAddress[] = "\x80\x00I\x00P\x57\x30\x57\x40\x00\x00" ;	///IPַ
const char chineseTxtErrorNotImp[] = {0x80, 0x00,'N',0x00,'o',0x00,'t',0x00,' ',0x00,'i',0x00,'m',0x00,'p',0x00,'l',0x00,'e',0x00,'m',0x00,'e',0x00,'n',0x00,'t',0x00,'e',0x00,'d',0x00,0x00,0x00 };
const char chineseTxtErrorUnsupported[] = {0x80, 0x00,'U',0x00,'n',0x00,'s',0x00,'u',0x00,'p',0x00,'p',0x00,'o',0x00,'r',0x00,'t',0x00,'e',0x00,'d',0x00,' ',0x00,'v',0x00,'e',0x00,'r',0x00,'s',0x00,'i',0x00,'o',0x00,'n',0x00,0x00,0x00 };
const char chineseTxtErrorOverload[] = {0x80, 0x00,'O',0x00,'v',0x00,'e',0x00,'r',0x00,'l',0x00,'o',0x00,'a',0x00,'d',0x00,',',0x00,' ',0x00,'W',0x00,'T',0x00,'P',0x00,' ',0x00,'A',0x00,'b',0x00,'o',0x00,'r',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtErrorNoResponse[] = {0x80, 0x00,'N',0x00,'o',0x00,' ',0x00,'r',0x00,'e',0x00,'s',0x00,'p',0x00,'o',0x00,'n',0x00,'s',0x00,'e',0x00,0x00,0x00 };
const char chineseTxtErrorTooLarge[] = {0x80, 0x00,'M',0x00,'e',0x00,'s',0x00,'s',0x00,'a',0x00,'g',0x00,'e',0x00,' ',0x00,'t',0x00,'o',0x00,'o',0x00,' ',0x00,'l',0x00,'a',0x00,'r',0x00,'g',0x00,'e',0x00,0x00,0x00 };
const char chineseTxtErrorBadRequest[] = {0x80, 0x00,'B',0x00,'a',0x00,'d',0x00,' ',0x00,'r',0x00,'e',0x00,'q',0x00,'u',0x00,'e',0x00,'s',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtErrorUnauthorized[] = {0x80, 0x00,'U',0x00,'n',0x00,'a',0x00,'u',0x00,'t',0x00,'h',0x00,'o',0x00,'r',0x00,'i',0x00,'z',0x00,'e',0x00,'d',0x00,0x00,0x00 };
const char chineseTxtErrorPaymentReq[] = {0x80, 0x00,'P',0x00,'a',0x00,'y',0x00,'m',0x00,'e',0x00,'n',0x00,'t',0x00,' ',0x00,'r',0x00,'e',0x00,'q',0x00,'u',0x00,'i',0x00,'r',0x00,'e',0x00,'d',0x00,0x00,0x00 };
const char chineseTxtErrorForbidden[] = {0x80, 0x00,'F',0x00,'o',0x00,'r',0x00,'b',0x00,'i',0x00,'d',0x00,'d',0x00,'e',0x00,'n',0x00,0x00,0x00 };
const char chineseTxtErrorFileNotFnd[] = {0x80, 0x00,'F',0x00,'i',0x00,'l',0x00,'e',0x00,' ',0x00,'n',0x00,'o',0x00,'t',0x00,' ',0x00,'f',0x00,'o',0x00,'u',0x00,'n',0x00,'d',0x00,0x00,0x00 };
const char chineseTxtErrorNotAllowed[] = {0x80, 0x00,'M',0x00,'e',0x00,'t',0x00,'h',0x00,'o',0x00,'d',0x00,' ',0x00,'n',0x00,'o',0x00,'t',0x00,' ',0x00,'a',0x00,'l',0x00,'l',0x00,'o',0x00,'w',0x00,'e',0x00,'d',0x00,0x00,0x00 };
const char chineseTxtErrorNotAcceptable[] = {0x80, 0x00,'N',0x00,'o',0x00,'t',0x00,' ',0x00,'a',0x00,'c',0x00,'c',0x00,'e',0x00,'p',0x00,'t',0x00,'a',0x00,'b',0x00,'l',0x00,'e',0x00,0x00,0x00 };
const char chineseTxtErrorAuthReq[] = {0x80, 0x00,'P',0x00,'r',0x00,'o',0x00,'x',0x00,'y',0x00,' ',0x00,'A',0x00,'u',0x00,'t',0x00,'h',0x00,'e',0x00,'n',0x00,'t',0x00,'.',0x00,' ',0x00,'R',0x00,'e',0x00,'q',0x00,'u',0x00,'i',0x00,'r',0x00,'e',0x00,'d',0x00,0x00,0x00};
const char chineseTxtErrorReqTimeout[] = {0x80, 0x00,'R',0x00,'e',0x00,'q',0x00,'u',0x00,'e',0x00,'s',0x00,'t',0x00,' ',0x00,'t',0x00,'i',0x00,'m',0x00,'e',0x00,'o',0x00,'u',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtErrorHTTPConf[] = {0x80, 0x00,'H',0x00,'T',0x00,'T',0x00,'P',0x00,' ',0x00,'C',0x00,'o',0x00,'n',0x00,'f',0x00,'l',0x00,'i',0x00,'c',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtErrorOutOfMem[] = {0x80, 0x00,'O',0x00,'u',0x00,'t',0x00,' ',0x00,'o',0x00,'f',0x00,' ',0x00,'m',0x00,'e',0x00,'m',0x00,'o',0x00,'r',0x00,'y',0x00,0x00,0x00 };
const char chineseTxtErrorWMLError[] = {0x80, 0x00,'W',0x00,'M',0x00,'L',0x00,' ',0x00,'e',0x00,'r',0x00,'r',0x00,'o',0x00,'r',0x00,0x00,0x00 };
const char chineseTxtErrorDisplay[] = {0x80, 0x00,'D',0x00,'i',0x00,'s',0x00,'p',0x00,'l',0x00,'a',0x00,'y',0x00,' ',0x00,'e',0x00,'r',0x00,'r',0x00,'o',0x00,'r',0x00,',',0x00,' ',0x00,'W',0x00,'M',0x00,'L',0x00,' ',0x00,'s',0x00,'y',0x00,'n',0x00,'t',0x00,'a',0x00,'x',0x00,0x00,0x00};
const char chineseTxtErrorCardEmpty[] = {0x80, 0x00,'C',0x00,'a',0x00,'r',0x00,'d',0x00,' ',0x00,'e',0x00,'m',0x00,'p',0x00,'t',0x00,'y',0x00,0x00,0x00 };
const char chineseTxtErrorURLInvalid[] = {0x80, 0x00,'U',0x00,'R',0x00,'L',0x00,' ',0x00,'i',0x00,'n',0x00,'v',0x00,'a',0x00,'l',0x00,'i',0x00,'d',0x00,0x00,0x00 };
const char chineseTxtErrorMemLow[] = {0x80, 0x00,'M',0x00,'e',0x00,'m',0x00,'o',0x00,'r',0x00,'y',0x00,' ',0x00,'l',0x00,'o',0x00,'w',0x00,0x00,0x00 };
const char chineseTxtErrorPeerAbort[] = {0x80, 0x00,'P',0x00,'e',0x00,'e',0x00,'r',0x00,' ',0x00,'r',0x00,'e',0x00,'q',0x00,'u',0x00,'e',0x00,'s',0x00,'t',0x00,'e',0x00,'d',0x00,' ',0x00,'o',0x00,'p',0x00,'e',0x00,'r',0x00,'a',0x00,'t',0x00,'i',0x00,'o',0x00,'n',0x00,' ',0x00,'a',0x00,'b',0x00,'o',0x00,'r',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtError[] = "\x80\x6e\xa2\x51\xfa\x00\x00";
const char chineseCloseAnim[] = "\x80\x51\x73\x52\xa8\x75\x3b\x00\x00" ;	///ض
const char chineseTxtGameWinCondition[]="\x80\x80\xdc\x52\x29\x67\x61\x4e\xf6\x00\x3a\x00\x00"; //ʤ:
const char chineseTxtGameExitConfirm[]="\x80\x90\x00\x51\xfa\x54\x17\x00\x00";//˳
const char chineseTxtGameNext[]= "\x80\x4e\x0b\x4e\x00\x51\x73\x00\x00";//һ
const char chineseTxtBoxmanHelp[] = "\x80\x00\x31\x00\x2e\x89\xc4\x52\x19\xff\x1a\x00\x0A\x00\x20\x00\x20\x62\x40\x67\x09\x7b\xb1\x5b\x50\x5f\xc5\x98\x7b\x63\xa8\x52\x30\x76\xee\x68\x07\x4f\x4d\x7f\x6e\x30\x02\x00\x0A\x00\x32\x00\x2e\x64\xcd\x4f\x5c\x63\xa7\x52\x36\xff\x1a\x00\x0A\x00\x20\x00\x20\x65\xb9\x54\x11\x63\xa7\x52\x36\xff\x1a\x4e\x0a\x4e\x0b\x5d\xe6\x53\xf3\x65\xb9\x54\x11\x95\x2e\x63\xa8\x7b\xb1\x5b\x50\x30\x02\x00\x0A\x00\x20\x00\x20\x60\x94\x68\xcb\xff\x1a\x53\xf3\x8f\x6f\x95\x2e\x30\x02\x00\x00";//1.99  ӱƵĿλá992.ƣ99  ƣҷӡ99  壺
const char chineseTxtSnakeHelp[]=  "\x80\x00\x31\x00\x2e\x89\xc4\x52\x19\xff\x1a\x00\x0A\x00\x20\x00\x20\x5f\x15\x5b\xfc\x86\xc7\x54\x1e\x98\xdf\x98\xdf\x72\x69\xff\x0c\x86\xc7\x59\x34\x4e\x0d\x89\x81\x78\xb0\x86\xc7\x8e\xab\x30\x02\x00\x0A\x00\x32\x00\x2e\x64\xcd\x4f\x5c\x63\xa7\x52\x36\xff\x1a\x00\x0A\x00\x20\x00\x20\x65\xb9\x54\x11\x63\xa7\x52\x36\xff\x1a\x4e\x0a\x4e\x0b\x5d\xe6\x53\xf3\x95\x2e\x5f\x15\x5b\xfc\x86\xc7\x6e\x38\x52\xa8\x65\xb9\x54\x11\x30\x02\x00\x0A\x00\x20\x00\x20\x5f\x00\x59\xcb\x4e\x0e\x66\x82\x50\x5c\xff\x1a\x75\x35\x8b\xdd\x63\xa5\x54\x2c\x95\x2e\x30\x02\x00\x00";//1.ʳʳͷҪ 2.ƣƣҼζ ʼͣ绰
const char chineseYear[]={"\x80\x5e\x74\x00" };//jhxu720 add 
const char chineseMonth[]={"\x80\x67\x08\x00" };//jhxu720 add
#ifdef CHINESE_MMI 
//2004/06/18 yhf modify
//ӣ
const unsigned char chineseTxtBmHelp1[]="\x80\x80\xdc\x52\x29\x67\x61\x4e\xf6\x00\x3a\x00";   //4ʤ
const unsigned char chineseTxtBmHelp2[]="\x80\x62\x40\x67\x09\x7b\xb1\x5b\x50\x54\x8c\x76\xee\x68\x07\x70\xb9\x91\xcd\x54\x08\x00";	
///ӺĿغ
const unsigned char chineseTxtPublicHelp1[]="\x80\x63\x09\x95\x2e\x4f\xe1\x60\x6f\x00\x3a\x00"; 	//4 Ϣ
const unsigned char chineseTxtPublicHelp2[]="\x80\x8b\xf7\x67\xe5\x77\x0b\x6e\x38\x62\x0f\x8b\xbe\x7f\x6e\x00";	//4 鿴Ϸ
const unsigned char chineseTxtPublicHelp3[]="\x80\x4f\xa7\x97\xf3\x95\x2e\x00\x3a\x79\xfb\x52\xa8\x7b\xad\x59\x34\x00";	//4 :ƶͷ
const unsigned char chineseTxtPublicHelp4[]="\x80\x00\x22\x00\x2a\x00\x22\x95\x2e\x00\x3a\x90\x00\x51\xfa\x8b\xbe\x7f\x6e\x00"; 
//4 "*":˳
const unsigned char chineseTxtGameExplain[]="\x80\x8b\xf4\x66\x0e\x00" ;	///˵
//˹
const unsigned char chineseTxtTerrisHelp1[]="\x80\x6b\xcf\x6b\x21\x8d\x85\x8f\xc7\x00\x31\x00\x30\x00\x30\x00\x30\x00\x30\x52\x06\x90\x1f\x5e\xa6\x52\xa0\x4e\x00\x00" ;
///ÿγ10000ٶȼһ	
const char stringTest[] = {0x80,0x00,0x48,0x00,0x49,0x4E,0x33};
const char chineseTxtNull[] = {0x80,0x00,0x00};
const char chineseTxtNotImplemented[] = {0x80,0x4E,0x0D,0x53,0xEF,0x4F,0x98,0x67,0x0D,0x52,0xA1,0x00,0x00};
const char chineseTxtManu[] = {0x80,0x00,0x43,0x00,0x4F,0x00,0x4E,0x00,0x44,0x00,0x41,0x00,0x54,0x00,0x00};
const char chineseTxtEnterPin1[] = "\x80\x8b\xf7\x8f\x93\x51\x65\x00P\x00I\x00N\x00\x31\x78\x01\x00\x00" ;	///PIN1
const char chineseTxtEnterPin2[]= "\x80\x8b\xf7\x8f\x93\x51\x65\x00P\x00I\x00N\x00\x32\x78\x01\x00\x00" ;	///PIN2
const char chineseTxtEnterPuk1[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x50,0x00,0x55,0x00,0x4B,0x00,0x31,0x00,0x00}; 
const char chineseTxtEnterPuk2[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x50,0x00,0x55,0x00,0x4B,0x00,0x32,0x00,0x00};
const char chineseTxtInvalidCard[] = "\x80\x8b\xf7\x63\xd2\x51\x65\x00S\x00I\x00M\x53\x61\x00\x00" ;///SIMzy change
const char chineseTxtNoCard[] = "\x80\x8b\xf7\x68\xc0\x67\xe5\x00S\x00I\x00M\x53\x61\x00\x00" ; ///SIM{0x80,0x65,0xE0,0x00,0x53,0x00,0x49,0x00,0x4D,0x00,0x00};
const char chineseTxtSoftCall[] = {0x80,0x8B,0xDD,0x00,0x00};
const char chineseTxtSoftOK[] = {0x80,0x78,0x6E,0x8B,0xA4,0x00,0x00};
const char chineseTxtSoftMenu[] = "\x80\x52\x9f\x80\xfd\x88\x68\x00" ;  ///ܱ{0x80,0x83,0xDC,0x53,0x55,0x00,0x00};
const char chineseTxtHelp[] = {0x80,0x5E,0x2E,0x52,0xA9,0x00,0x00};
const char chineseTxtSoftContacts[] = {0x80,0x75,0x35,0x8b,0xdd,0x7c,0x3f,0x00,0x00};//WUFEI Modify
const char chineseTxtPlay[] = {0x80,0x62,0xE8,0x65,0x3E,0x00,0x00};
const char chineseTxtMessages[] = {0x80,0x77,0xED,0x4F,0xE1,0x00,0x00}; 
const char chineseTxtAlarm[] = "\x80\x95\xf9\x94\x9f\x00" ;	///
const char chineseTxtSettings[] = {0x80,0x8B,0xBE,0x5B,0x9A,0x00,0x00};
const char chineseTxtExtra[] = {0x80,0x98,0x9D,0x59,0x16,0x00,0x00};
const char chineseTxtSend[] = {0x80,0x53,0xD1,0x90,0x01,0x00,0x00}; 
const char chineseTxtSent[] = {0x80,0x5D,0xF1,0x53,0xD1,0x90,0x01,0x00,0x00};
const char chineseTxtNotSent[] = {0x80,0x67,0x2A,0x53,0xD1,0x90,0x01,0x00,0x00};
const char chineseTxtServiceCentre[] = {0x80,0x67,0x0D,0x52,0xA1,0x4E,0x2D,0x5F,0xC3,0x00,0x00};
const char chineseTxtPleaseWait[] = {0x80,0x8B,0xF7,0x7B,0x49,0x50,0x19,0x00,0x00};
const char chineseTxtSmsEnterNumber[] = {0x80,0x8F,0x93,0x51,0x65,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtRead[] =  {0x80,0x96,0x05,0x8B,0xFB,0x00,0x00};
const char chineseTxtDeleteAll[] = {0x80,0x51,0x68,0x90,0xE8,0x52,0x20,0x96,0x64,0x00,0x00};
const char chineseTxtSave[] = {0x80,0x50,0xA8,0x5B,0x58,0x00,0x00};
const char chineseTxtVoicemail[] = {0x80,0x8B,0xED,0x97,0xF3,0x4f,0xe1,0x7b,0xb1,0x00,0x00};
const char chineseTxtBroadcast[] =  {0x80,0x4F,0xE1,0x60,0x6F,0x53,0xF0,0x00,0x00}; 
const char chineseTxtNew[] = {0x80,0x65,0xB0,0x4f,0xe1,0x60,0x6f,0x00,0x00};
const char chineseTxtDigits[] = {0x00,0x31,0x00,0x32,0x00,0x33,0x00,0x00};
const    char    chineseTxtLowercase[] = {0x00,0x61,0x00,0x62,0x00,0x63,0x00,0x00};
const char chineseTxtUppercase[] = {0x00,0x41,0x00,0x42,0x00,0x43,0x00,0x00};
const char chineseTxtApplications[] = "\x80\x5d\xe5\x51\x77\x7b\xb1\x00\x00" ;	///
/* glowing: "" Ϊ "¼"  */
//    const char chineseTxtVoiceMemo[] = {0x80,0x8B,0xED,0x97,0xF3,0x59,0x07,0x5f,0xD8,0x00,0x00};
const char chineseTxtVoiceMemo[] = "\x80\x8b\xed\x97\xf3\x8b\xb0\x5f\x55\x00\x00";

	
const char chineseTxtSim[] = "\x80\x00\x53\x00\x49\x00\x4d\x53\x61\x00\x00" ;	///SIM
const char chineseTxtSimNot[] = {0x00,0x53,0x00,0x49,0x00,0x4D,0x00,0x4E,0xED,0x00,0x00};
const char chineseTxtNotReady[] = "\x80\x67\x2a\x51\xc6\x59\x07\x59\x7d\x00\x00" ;	///δ׼
const char chineseTxtSmsListFull[] = {0x80,0x4F,0xE1,0x7B,0xB1,0x5D,0xF1,0xBE,0xE1,0x00,0x00}; 
const char chineseTxtNewCbMessage[] = {0x80,0x00,0x31,0x65,0xB0,0x51,0x6C,0x51,0x71,0x8B,0xAF,0x60,0x6F,0x00,0x00};
const char chineseTxtSaved[] = "\x80\x5d\xf2\x5b\x58\x50\xa8\x00\x00";
const char chineseTxtDelete[] = {0x80,0x52,0x20,0x96,0x64,0x00,0x00};
const char chineseTxtReply[] = {0x80,0x56,0xDE,0x4F,0xE1,0x00,0x00};
const char chineseTxtStoreNumber[] = {0x80,0x50,0xA8,0x5B,0x58,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtForward[] = "\x80\x7f\x16\x8f\x91\x8f\x6c\x53\xd1\x00\x00";

const char chineseTxtActivate[] = "\x80\x5f\x00\x54\x2f\x00\x00";//WUFEI Modify
const char chineseTxtTopics[] = {0x80,0x98,0x79,0x76,0xEE,0x00,0x00};
const char chineseTxtConsult[] = {0x80,0x8C,0x18,0x8B,0xE2,0x00,0x00};
const char chineseTxtAddNew[] = {0x80,0x65,0xB0,0x58,0x9E,0x00,0x00};
const char chineseTxtContacts[] = {0x80,0x62,0xE8,0x54,0x7C,0x00,0x00};
/* glowing: "Ѱ" Ϊ "" */
//const char chineseTxtSearchName[] = {0x80,0x67,0xE5,0x5B,0xFB,0x00,0x00};
const char chineseTxtSearchName[] = {0x80,0x67,0xE5,0x62,0x7E,0x00,0x00};
const char chineseTxtMemory[] = {0x80,0x8B,0xB0,0x61,0xB6,0x72,0xb6,0x60,0x01,0x00,0x00};
const char chineseTxtRinger[] = "\x80\x67\x65\x75\x35\x63\xd0\x79\x3a\x00" ;	///ʾ{0x80,0x54,0xCD,0x94,0xC3,0x00,0x00};
const char chineseTxtVolume[] = {0x80,0x97,0xF3,0x91,0xCF,0x00,0x00};
const char chineseTxtKeypadTones[] = "\x80\x63\x09\x95\x2e\x97\xf3\x00\x00" ;  ///{0x80,0x63,0x09,0x95,0x2E,0x58,0xF0,0x97,0xF3,0x00,0x00};
const char chineseTxtNewMessage[] = {0x80,0x65,0xB0,0x75,0x59,0x8A,0x00,0x00,0x00};
const char chineseTxtNewBroadcast[] = {0x80,0x65,0xB0,0x65,0xB0,0x51,0x6C,0x51,0x71,0x8B,0xAF,0x60,0x6F,0x00,0x00};
const char chineseTxtAutoAnswer[] = "\x80\x81\xea\x52\xa8\x5e\x94\x7b\x54\x00\x00";//WUFEI Modify
const char chineseTxtTimeDate[] = {0x80,0x65,0xF6,0x95,0xF4,0x65,0xE5,0x67,0x1F,0x00,0x00};
const char chineseTxtLanguages[] = {0x80,0x8B,0xED,0x8A,0x00,0x00,0x00};
const char chineseTxtVoiceMail[] = {0x80,0x8B,0xED,0x97,0xF3,0x4F,0xE1,0x7B,0xB1,0x00,0x00};
const char chineseTxtPinCode[] = "\x80\x00P\x00I\x00N\x001\x78\x01\x00" ;  ///PIN1{0x80,0x00,0x50,0x00,0x69,0x00,0x6E,0x00,0x20,0x00,0x43,0x00,0x6F,0x00,0x64,0x00,0x65,0x00,0x00};
const char chineseTxtAutoredial[] = "\x80\x81\xea\x52\xa8\x91\xcd\x62\xe8\x00\x00";//WUFEI Modify
const char chineseTxtDTMF[] = {0x80,0x00,0x44,0x00,0x54,0x00,0x4D,0x00,0x46,0x00,0x00};
const char chineseTxtOn[] = {0x80,0x5F,0x00,0x00,0x00};
const char chineseTxtOff[] = {0x80,0x51,0x73,0x00,0x00};
const char chineseTxtNetworkSel[] = "\x80\x7f\x51\x7e\xdc\x8b\xbe\x7f\x6e\x00\x00" ;  ///{0x80,0x7F,0x51,0x7E,0xDC,0x90,0x09,0x62,0xE9,0x00,0x00};
const char chineseTxtSendID[] = {0x80,0x96,0x90,0x85,0xCF,0x8E,0xAB,0x4E,0xFD,0x00,0x00};
const char chineseTxtChargeTimers[] = "\x80\x90\x1a\x8b\xdd\x8d\x39\x75\x28\x00\x00";//WUFEI Modify
const char chineseTxtCallDivert[] = "\x80\x67\x65\x75\x35\x8f\x6c\x63\xa5\x00\x00"; //hu binhao modify 2003-2-18ת
const char chineseTxtDateTime[] = "\x80\x65\xf6\x94\x9f\x00\x00";	//sunsj030918
const char chineseTxtCallWaiting[] = {0x80,0x90,0x1A,0x8B,0xDD,0x7B,0x49,0x5F,0x85,0x00,0x00}; 
const char chineseTxtIfBusy[] = "\x80\x62\x4b\x67\x3a\x53\x60\x7e\xbf\x00\x00";//WUFEI Modifyֻռ
const char chineseTxtIfNoAnswer[] = "\x80\x65\xe0\x4e\xba\x63\xa5\x54\x2c\x00\x00";//WUFEI Modify˽
const char chineseTxtIfNotReachable[] = {0x80,0x6C,0x92,0x63,0xA5,0x90,0x1A,0x00,0x00};
const char chineseTxtAllCalls[] = "\x80\x51\x68\x90\xe8\x67\x65\x75\x35\x00\x00";//WUFEI Modifyȫ
const char chineseTxtCancelAll[] = {0x80,0x51,0x68,0x90,0xE8,0x53,0xD6,0x6D,0x88,0x00,0x00};
const char chineseTxtAll[] = {0x80,0x51,0x68,0x90,0xE8,0x00,0x00};
const char chineseTxtVoice[] = {0x80,0x8B,0xED,0x97,0xF3,0x00,0x00};
const char chineseTxtFax[] = {0x80,0x4F,0x20,0x77,0x1F,0x00,0x00};
const char chineseTxtData[] = {0x80,0x8D,0x44,0x65,0x99,0x00,0x00};
const char chineseTxtStatus[] = {0x80,0x72,0xB6,0x60,0x01,0x00,0x00};
const char chineseTxtCancel[] = {0x80,0x53,0xD6,0x6D,0x88,0x00,0x00};
const char chineseTxtCalculator[] = "\x80\x8b\xa1\x7b\x97\x56\x68\x00\x00";
const char chineseTxtSoftBack[] = {0x80,0x8F,0xD4,0x56,0xDE,0x00,0x00};
const char chineseTxtSoftSelect[] = {0x80,0x90,0x09,0x62,0xE9,0x00,0x00};
const char chineseTxtSoftOptions[] = {0x80,0x90,0x09,0x62,0xE9,0x98,0x79,0x76,0xEE,0x00,0x00}; 
const char chineseTxtEmptyList[] = {0x80,0x65,0xE0,0x8D,0x44,0x65,0x99,0x00,0x00}; 
const char chineseTxtSendMessage[] = {0x80,0x53,0xD1,0x90,0x01,0x77,0xED,0x4F,0xE1,0x00,0x00};
const char chineseTxtChange[] = "\x80\x4f\xee\x65\x39\x00\x00";
const char chineseTxtWriteError[] = {0x80,0x4E,0x66,0x51,0x99,0x95,0x19,0x8B,0xEF,0x00,0x00};
const char chineseTxtEntryDeleted[] = {0x80,0x8F,0x93,0x51,0x65,0x52,0x20,0x96,0x64,0x00,0x00}; 
const char chineseTxtDetails[] = {0x80,0x7E,0xC6,0x82,0x82,0x00,0x00}; 
const char chineseTxtHold[] = {0x80,0x4F,0xDD,0x75,0x59,0x00,0x00};
const char chineseTxtUnhold[] = "\x80\x60\x62\x59\x0d\x00\x00" ;	///ָzy Mobile Innovation 23/09/02
const char chineseTxtMute[] = {0x80,0x97,0x59,0x97,0xF3,0x00,0x00};
const char chineseTxtSendDTMF[] = {0x80,0x53,0xD1,0x90,0x01,0x00,0x44,0x00,0x54,0x00,0x4D,0x00,0x46,0x00,0x00};
const char chineseTxtMainMenu[] = {0x80,0x4E,0x3B,0x76,0xEE,0x5F,0x55,0x00,0x00};
const char chineseTxtSwap[] = {0x80,0x4E,0xA4,0x63,0x62,0x00,0x00}; 
const char chineseTxtEndAll[] = {0x80,0x51,0x68,0x90,0xE8,0x7E,0xD3,0x67,0x5F,0x00,0x00};
const char chineseTxtPrivateCall[] = {0x80,0x79,0xC1,0x4E,0xBA,0x75,0x35,0x8B,0xDD,0x00,0x00};
const char chineseTxtStartConference[] = {0x80,0x4F,0x1A,0x8B,0xAE,0x5F,0x00,0x59,0xCB,0x00,0x00};
const char chineseTxtReStartConference[] = {0x80,0x4F,0x1A,0x8B,0xAE,0x91,0xCD,0x65,0xB0,0x5F,0x00,0x59,0xCB,0x00,0x00};
const char chineseTxtFind[] = {0x80,0x5B,0xFB,0x62,0x7E,0x00,0x00};
const char chineseTxtServiceNumbers[] = {0x80,0x67,0x0D,0x52,0xA1,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtOutofRange[] = {0x5C,0x80,0x83,0xD3,0x56,0xF4,0x00,0x00};
const char chineseTxtDone[] = {0x80,0x5B,0x8C,0x62,0x10,0x00,0x00};
const char chineseTxtFailed[] = {0x80,0x59,0x31,0x8D,0x25,0x00,0x00};
const char chineseTxtEnterNewPin[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xB0,0x5B,0xC6,0x78,0x01,0x00,0x00};
const char chineseTxtConfPin[] = {0x80,0x78,0x6E,0x5B,0x9A,0x5B,0xC6,0x78,0x01,0x00,0x00};
const char chineseTxtChangPin[] = {0x80,0x5B,0xC6,0x78,0x01,0x5D,0xF1,0x65,0x39,0x53,0xD8,0x00,0x00};
const char chineseTxtEnd[] = {0x80,0x7E,0xD3,0x67,0x5f,0x00,0x00};
const char chineseTxtPINFail[] = "\x80\x00P\x00I\x00N\x78\x01\x59\x31\x8d\x25\x00\x00";  ///PINʧ
const char chineseTxtSOS[] = "\x80\x7d\x27\x60\x25\x54\x7c\x53\xeb\x00\x00" ;	///
const char chineseTxtAutomatic[] = {0x80,0x81,0xEA,0x52,0xA8,0x00,0x00};
const char chineseTxtManual[] = {0x80,0x4E,0xBA,0x5D,0xE5,0x00,0x00}; 
const char chineseTxtFixedNames[] = "\x80\x56\xfa\x5b\x9a\x62\xe8\x53\xf7\x00" ; ///̶{0x80,0x56,0xFA,0x5B,0x9A,0x59,0xD3,0x54,0x0D,0x00,0x00};
const char chineseTxtFactoryReset[] = "\x80\x51\xfa\x53\x82\x8b\xbe\x7f\x6e\x00\x00" ;	//
const char chineseTxtSearching[] = {0x80,0x67,0xE5,0x5B,0xFB,0x00,0x00}; 
const char chineseTxtChangePIN2[] = "\x80\x00P\x00I\x00N\x00\x32\x66\xf4\x65\x39\x62\x10\x52\x9f\x00\x00" ; //PIN2ĳɹ{0x80,0x65,0x39,0x53,0xD8,0x00,0x20,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x00,0x00};
const char chineseTxtOldPIN[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xE7,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x31,0x78,0x01,0x00,0x00};
const char chineseTxtOldPIN2[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xE7,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x78,0x01,0x00,0x00};
const char chineseTxtNotAcc[] = {0x80,0x65,0xE0,0x6C,0xD5,0x63,0xA5,0x53,0xD7,0x00,0x00};  //޷
const char chineseTxtEnabled[] = "\x80\x00P\x00I\x00N\x00\x31\x5d\xf2\x5f\x00\x54\x2f\x00\x00" ; ///PIN1ѿ
const char chineseTxtDisabled[] = "\x80\x00P\x00I\x00N\x00\x31\x5d\xf2\x51\x73\x95\xed\x00\x00" ; ///PIN1ѹر
const char chineseTxtPINOK[] = {0x80,0x00,0x50,0x00,0x49,0x00,0x4E,0x6B,0x63,0x78,0x6E,0x00,0x00};
const char chineseTxtSimBlocked[] = "\x80\x00S\x00I\x00M\x5d\xf2\x5c\x01\x95\x01\x00" ; ///SIMѷ {0x80,0x00,0x53,0x00,0x4D,0x00,0x53,0x5D,0xF1,0x5C,0x01,0x95,0x01,0x00,0x00};
const char chineseTxtNewPIN[] =  {0x80,0x65,0xB0,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x00};
const char chineseTxtAcc[] = {0x80,0x5D,0xF1,0x63,0xA5,0x53,0xD7,0x00,0x00};
const char chineseTxtNoNetwork[] = {0x80,0x65,0xE0,0x7F,0x51,0x7E,0xDC,0x00,0x00};
const char chineseTxtNo[] = {0x80,0x54,0x26,0x00,0x00};
const char chineseTxtEnterDate[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xE5,0x67,0x1F,0x00,0x00};
const char chineseTxtEnterTime[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xF6,0x95,0xF4,0x00,0x00};
const char chineseTxtScratchPad[] = {0x80,0x7B,0x14,0x8B,0xB0,0x67,0x2C,0x00,0x00}; 
const char chineseTxtDeleted[] = {0x80,0x5D,0xF1,0x52,0x20,0x96,0x64,0x00,0x00};
const char chineseTxtActivated[] = "\x80\x5d\xf2\x5f\x00\x54\x2f\x00\x00"; //WUFEI Modify 
const char chineseTxtDeActivated[] = {0x80,0x5D,0xF2,0x51,0x73,0x95,0xED,0x00,0x00};
const char chineseTxtDeactivate[] = {0x80,0x51,0x73,0x95,0xED,0x00,0x00};
const char chineseTxtCheck[] = {0x80,0x68,0xC0,0x67,0xE5,0x00,0x00};
const char chineseTxtYes[] = {0x80,0x66,0x2F,0x00,0x00};
const char chineseTxtCallNumber[] = {0x80,0x62,0xE8,0x53,0xD1,0x53,0xF7,0x78,0x01,0x00,0x00}; 
const char chineseTxtEnterMid[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x4D,0x00,0x49,0x00,0x44,0x00,0x00};
const char chineseTxtReadError[] = {0x80,0x96,0x05,0x8B,0xFB,0x95,0x19,0x8B,0xEF,0x00,0x00};
const char chineseTxtUsed[] = {0x80,0x5D,0xF2,0xCF,0x5D,0x7A,0x7A,0x95,0xF4,0x00,0x00};
const char chineseTxtOutgoing[] = {0x80,0x62,0xE8,0x5C,0x80,0x75,0x35,0x8B,0xDD,0x00,0x00};
const char chineseTxtMuted[] = {0x80,0x65,0xE0,0x58,0xF0,0x00,0x00}; 
const char chineseTxtCallEnded[] = {0x80,0x90,0x1A,0x8B,0xDD,0x5D,0xF1,0x7E,0xD3,0x67,0x5F,0x00,0x00}; 
//ͬchineseTxtIncomingCall
const char chineseTxtIncomingCalls[] = {0x80,0x5d,0xf2,0x63,0xa5,0x75,0x35,0x8b,0xdd,0x00,0x00};//WUFEI Add
const char chineseTxtIncomingCall[] = "\x80\x54\x7c\x51\x65\x75\x35\x8b\xdd\x00\x00";//WUFEI Modify
const char chineseTxtIncomingData[] = {0x80,0x5d,0xf2,0x63,0xa5,0x65,0x36,0x65,0x70,0x63,0x6e,0x91,0xcf,0x00,0x00}; //WUFEI APPEND
const char chineseTxtNumberWithheld[] = {0x80,0x4F,0xDD,0x75,0x59,0x76,0x84,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtAccept[] = {0x80,0x63,0xA5,0x53,0xD7,0x00,0x00};
const char chineseTxtReject[] = {0x80,0x62,0xD2,0x7E,0xDD,0x00,0x00};
const char chineseTxtCalling[] = {0x80,0x6B,0x63,0x57,0x28,0x63,0xA5,0x90,0x1A,0x00,0x00};
const char chineseWaitingAnswer[]="\x80\x7b\x49\x5f\x85\x63\xa5\x54\x2c\x00\x00";	///ȴ
const char chineseTxtMissedCalls[] = "\x80\x67\x2a\x63\xa5\x75\x35\x8b\xdd\x00\x00"; 	 //2003/12/27, wanyan Ϊδӵ绰
//	const char chineseTxtMissedCalls[] = "\x80\x67\x2a\x63\xa5\x75\x35\x8b\xdd\x00\x00"; 	 //2003/12/27, wanyan Ϊδӵ绰
const char chineseTxtMissedCall[] =  "\x80\x67\x2a\x63\xa5\x75\x35\x8b\xdd\x00\x00"; 	 //2003/12/27, wanyan  Ϊδӵ绰
//2004-03-8 Suuny add.begin
const char chineseTxtCallSingle[] = "\x80\x4e\x00\x65\xb9\x90\x1a\x8b\xdd\x00\x00";
const char chineseTxtCallTwo[] = "\x80\x4e\x24\x65\xb9\x90\x1a\x8b\xdd\x00\x00";
 const char chineseTxtCallConfernce[] = "\x80\x75\x35\x8b\xdd\x4f\x1a\x8b\xae\x00\x00";
const char chineseTxtCallPrivateCall[] =  "\x80\x79\xc1\x4e\xba\x90\x1a\x8b\xdd\x00\x00";
const char chineseTxtCallSingleMultiparty[] = "";
const char chineseTxtCallMultipartySingle[] = "";  
//2004-03-8 Sunny add.end
const char chineseTxtLocked[] = {0x80,0x63,0x09,0x95,0x2E,0x5D,0xF1,0x95,0x01,0x00,0x00};
const char chineseTxtUnmute[] = {0x80,0x59,0x0D,0x97,0xF3,0x00,0x00};
const char chineseTxtNeedCharging[] = "\x80\x8b\xf7\x51\x45\x75\x35\x00\x00" ;	///
const char chineseTxtCharging[] = "\x80\x6b\x63\x57\x28\x51\x45\x75\x35\x00\x00" ;	///ڳ
const char chineseTxtChargComplete[] = {0x80,0x51,0x45,0x75,0x35,0x5B,0x8C,0x62,0x10,0x00,0x00};
//2004-04-01 Sunny add
const char chineseTxtNoPower[] = "\x80\x75\x35\x91\xcf\x4e\x0d\x8d\xb3\x00\x00";
const char chineseTxtSwitchOff[] = "\x80\x9a\x6c\x4e\x0a\x51\x73\x67\x3a\x00\x00";
//2004-04-01 Sunny add end
const char chineseTxtOperationNotAvail[] = {0x80,0x4E,0x0D,0x53,0xEF,0x4F,0x9B,0x67,0x0D,0x52,0xA1,0x00,0x00};
const char chineseTxtNetUselessInCall[]="\x80\x7f\x51\x7e\xdc\x5f\xd9\x7a\x0d\x54\x0e\x51\x8d\x62\xe8\x00\x00" ;	///æԺٲ
const char chineseTxtNetUselessCallAgain[]="\x80\x7f\x51\x7e\xdc\x5f\xd9\xff\x0c\x91\xcd\x62\xe8\xff\x1f\x00\x00" ;	///æز
const char chineseTxtAddToConference[] = {0x80,0x52,0xA0,0x51,0x65,0x4F,0x1A,0x8B,0xAE,0x00,0x00};
const char chineseTxtEmpty[] = {0x80,0x65,0xE0,0x8D,0x44,0x65,0x99,0x00,0x00};
const char chineseTxtSelectFromList[] = {0x80,0x4E,0xCE,0x54,0x0D,0x53,0x55,0x91,0xCC,0x90,0x09,0x00,0x00};
const char chineseTxtEnterNetworkCode[] = {0x80,0x7F,0x51,0x7E,0xDC,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtMCCMNC[] = {0x80,0x62,0x4B,0x67,0x3A,0x56,0xFD,0x5B,0xB6,0x53,0xF7,0x78,0x01,0x00,0x2F,0x62,0x4B,0x67,0x3A,0x7F,0x51,0x7E,0xDC,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtRecord[] = {0x80,0x5F,0x55,0x97,0xF3,0x00,0x00};
const char chineseTxtSecurity[] = "\x80\x5b\x89\x51\x68\x8b\xbe\x7f\x6e\x00\x00" ;  ///ȫ{0x80,0x5B,0x89,0x51,0x68,0x00,0x00};
const char chineseTxtEnglish[] = {0x80,0x82,0xF1,0x8B,0xED,0x00,0x00};
const char chineseTxtGerman[] = {0x80,0x5F,0xB7,0x8B,0xED,0x00,0x00};
const char chineseTxtValidity[] = {0x80,0x67,0x09,0x65,0x48,0x67,0x1F,0x00,0x00};
const char chineseTxtMessageTyp[] = {0x80,0x75,0x59,0x8A,0x00,0x79,0xCD,0x7C,0x7B,0x00,0x00};
const char chineseTxtSetVoiceMail[] = {0x80,0x8B,0xBE,0x5B,0x9A,0x8B,0xED,0x97,0xF3,0x4F,0xE1,0x7B,0xB1,0x00,0x00}; 
const char chineseTxtCallTimers[] = "\x80\x90\x1a\x8b\xdd\x8b\xa1\x65\xf6\x00\x00";//WUFEI Modify
const char chineseTxtLastCharge[] = "\x80\x4e\x0a\x6b\x21\x90\x1a\x8b\xdd\x8d\x39\x75\x28\x00\x00";//WUFEI Modify
const char chineseTxtTotalCharge[] = "\x80\x7d\x2f\x8b\xa1\x90\x1a\x8b\xdd\x8d\x39\x75\x28\x00\x00";//WUFEI Modify
const char chineseTxtResetCharge[] = "\x80\x8b\xa1\x4e\xf7\x56\x68\x6e\x05\x96\xf6\x00\x00";//WUFEI Modify
const char chineseTxtIfNoService[] = "\x80\x65\xe0\x6c\xd5\x63\xa5\x90\x1a\x00\x00";//WUFEI Modify//޷ͨ
const char chineseTxtDiscard[] = {0x80,0x65,0x3E,0x5F,0x03,0x00,0x00};
const char chineseTxtEDIT[] = {0x80,0x7F,0x16,0x8F,0x91,0x00,0x00};
const char chineseTxtExtractNumber[] = "\x80\x63\xd0\x53\xd6\x53\xf7\x78\x01\x00\x00";//ȡ
const char chineseTxtWrite[] = {0x80,0x7F,0x16,0x8F,0x91,0x00,0x00};
const char chineseTxtCheckStatus[] = "\x80\x67\xe5\x8b\xe2\x72\xb6\x60\x01\x00\x00";//ѯ״̬
const char chineseTxtSetDivert[] = {0x80,0x8B,0xBE,0x5B,0x9A,0x54,0x7C,0x53,0xEB,0x8F,0x6C,0x63,0xA5,0x00,0x00};
const char chineseTxtCancelDivert[] = {0x80,0x53,0xD6,0x6D,0x88,0x54,0x7C,0x53,0xEB,0x8F,0x6C,0x63,0xA5,0x00,0x00};
const char chineseTxtHideID[] = {0x80,0x96,0x90,0x85,0xCF,0x8E,0xAB,0x4E,0xFD,0x00,0x00};
const char chineseTxtTones[] = {0x80,0x97,0xF3,0x8C,0x03,0x00,0x00};
const char chineseTxtClock[] = {0x80,0x95,0xF9,0x94,0x9F,0x00,0x00};
const char chineseTxtPhone[] = {0x80,0x75,0x35,0x8B,0xDD,0x00,0x00};
const char chineseTxtStop[] = {0x80,0x50,0x5c,0x6b,0x62,0x00,0x00};	//ֹͣ
const char chineseTxtRecording[] = {0x80,0x6B,0x63,0x57,0x28,0x5F,0x55,0x97,0xF3,0x00,0x00};
const char chineseTxtPlaying[] = {0x80,0x64,0xad,0x65,0x3e,0x00,0x00};
const char chineseTxtPlayback[] = {0x80,0x56,0xDE,0x65,0x3E,0x00,0x00};
const char chineseTxtNoNumber[] = {0x80,0x65,0xE0,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtOkToDelete[] = {0x80,0x51,0x68,0x90,0xE8,0x52,0x20,0x96,0x64,0x00,0x00};
const char chineseTxtBalance[] = "\x80\x4f\x59\x98\x9d\x00\x00";//WUFEI MODIFY
const char chineseTxtLimit[] = "\x80\x8d\x39\x75\x28\x4e\x0a\x96\x50\x00\x00";//WUFEI Modify
const char chineseTxtLimitEq[] = {0x80,0x96,0x50,0x5E,0xA6,0x00,0x00}; 
const char chineseTxtRate[] = "\x80\x90\x1a\x8b\xdd\x8d\x39\x73\x87\x00\x00";//WUFEI Modify
const char chineseTxtMinutes[] = {0x80,0x52,0x06,0x94,0x9F,0x00,0x00}; 
const char chineseTxtCost[] = "\x80\x8d\x39\x75\x28\x00\x00";//WUFEI MODIFY
const char chineseTxtCredit[] = "\x80\x52\x69\x4f\x59\x91\xd1\x98\x9d\x00\x00";//WUFEI Modify
const char chineseTxtPressOk[] = {0x80,0x63,0x09,0x78,0x6E,0x8B,0xA4,0x00,0x00};
const char chineseTxtReset[] = "\x80\x6e\x05\x96\xf6\x00\x00";//WUFEI Modify
const char chineseTxtIncoming[] = {0x80,0x63,0xA5,0x8F,0xDB,0x00,0x00};
const char chineseTxtCounter[] = {0x80,0x8B,0xB0,0x65,0xF6,0x67,0x3A,0x00,0x00};
const char chineseTxtOutgoingCalls[] = {0x80,0x5D,0xF2,0x62,0xE8,0x75,0x35,0x8B,0xDD,0x00,0x00};
const char chineseTxtCostCounter[] = {0x80,0x8B,0xB0,0x8D,0x39,0x67,0x3A,0x00,0x00};
const char chineseTxtEnterCurrency[] = {0x80,0x8F,0x93,0x51,0x65,0x8D,0x27,0x5E,0x01,0x00,0x00};
const char chineseTxt1Unit[] = "\x80\x00\x31\x90\x1a\x8b\xdd\x53\x55\x4f\x4d\xff\x1d\x00\x00";//WUFEI MODIFY
const char chineseTxtChanged[] = {0x80,0x5D,0xF1,0x65,0x39,0x53,0xD8,0x00,0x00};
const char chineseTxtEnterLimit[] = {0x80,0x8F,0x93,0x51,0x65,0x96,0x50,0x5E,0xA6,0x00,0x00}; 
const char chineseTxtCancelled[] = {0x80,0x5D,0xF1,0x53,0xD6,0x6D,0x88,0x00,0x00};
const char chineseTxtView[] = {0x80,0x96,0x05,0x89,0xC8,0x00,0x00};
const char chineseTxtEnterPCK[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x50,0x00,0x43,0x00,0x4B,0x00,0x00};
const char chineseTxtEnterCCK[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x43,0x00,0x43,0x00,0x4B,0x00,0x00};
const char chineseTxtEnterNCK[] =  {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x4E,0x00,0x43,0x00,0x4B,0x00,0x00};
const char chineseTxtEnterNSCK[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x4E,0x00,0x53,0x00,0x43,0x00,0x4B,0x00,0x00};
const char chineseTxtEnterSPCK[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x53,0x00,0x50,0x00,0x43,0x00,0x4B,0x00,0x00};
const char chineseTxtCodeInc[] = {0x80,0x53,0xF7,0x78,0x01,0x95,0x19,0x8B,0xEE,0x00,0x00};
const char chineseTxtBlckPerm[] = {0x80,0x6C,0x38,0x8F,0xDC,0x5C,0x01,0x95,0x01,0x00,0x00};
const char chineseTxtDealer[] =  {0x80,0x80,0x54,0x7C,0xFB,0x4E,0xE3,0x74,0x06,0x4E,0xBA,0x00,0x00};
const char chineseTxtSendingDTMF[] = {0x80,0x53,0xD1,0x90,0x01,0x00,0x44,0x00,0x54,0x00,0x4D,0x00,0x46,0x00,0x00}; 
const char chineseTxtCheckNumber[] = {0x80,0x68,0xC0,0x67,0xE5,0x53,0xF7,0x78,0x01,0x00,0x00};
const char chineseTxtNumberBusy[] = {0x80,0x53,0xF7,0x78,0x01,0x5F,0xD9,0x00,0x00};
const char chineseTxtNoAnswer[] = {0x80,0x65,0xE0,0x5E,0x94,0x7B,0x54,0x00,0x00};
const char chineseTxtNumberChanged[] = {0x80,0x53,0xF7,0x78,0x01,0x5D,0xF1,0x65,0x39,0x53,0xD8,0x00,0x00};
const char chineseTxtNetworkBusy[] = {0x80,0x7F,0x51,0x7E,0xDC,0x5F,0xD9,0x00,0x00};
const char chineseTxtNotSubscribed[] = {0x80,0x67,0x2A,0x76,0x7B,0x8B,0xB0,0x00,0x00};
const char chineseTxtAnyKeyAnswer[] = "\x80\x4e\xfb\x61\x0f\x95\x2e\x63\xa5\x54\x2c\x00\x00" ;  ///{0x80,0x63,0x09,0x4E,0xFB,0x4F,0x55,0x95,0x2E,0x56,0xDE,0x7B,0x54,0x00,0x00};
const char chineseTxtPINBlock[] = "\x80\x00P\x00I\x00N\x78\x01\x5d\xf2\x5c\x01\x95\x01\x00\x00" ; ///PINѷ{0x80,0x5B,0xC6,0x78,0x01,0x5D,0xF1,0x5C,0x01,0x95,0x01,0x00,0x00};
const char chineseTxtEdit[] = {0x80,0x7F,0x16,0x8F,0x91,0x00,0x00};
const char chineseTxtChangePassword[] = {0x80,0x65,0x39,0x53,0xD8,0x5B,0xC6,0x78,0x01,0x00,0x00};
const char chineseTxtSetBar[] = {0x80,0x5C,0x01,0x95,0x01,0x8B,0xBE,0x7F,0x6E,0x00,0x00};
const char chineseTxtSmsTone[] = "\x80\x77\xed\x4f\xe1\x63\xd0\x79\x3a\x00\x00" ;	///ʾ{0x80,0x00,0x53,0x00,0x4D,0x00,0x53,0x97,0xF3,0x8C,0x03,0x00,0x00};
const char chineseTxtMelody[] = "\x80\x94\xc3\x58\xf0\x7c\x7b\x57\x8b\x00\x00" ;     ///{0x80,0x65,0xCB,0x5F,0x8B,0x00,0x00};
const char chineseTxtSilent[] = {0x80,0x97,0x59,0x97,0xf3,0x73,0xaf,0x58,0x83,0x00,0x00};	//sunsj030918
const char chineseTxtClick[] = {0x80,0x63,0x09,0x00,0x00};
const char chineseTxtClearAlarm[] = {0x80,0x53,0xD6,0x6D,0x88,0x95,0xF9,0x94,0xC3,0x00,0x00};
const char chineseTxtTimeFormat[] = "\x80\x65\xf6\x95\xf4\x68\x3c\x5f\x0f\x00";	///ʱʽzgz changed//{0x80,0x65,0xF6,0x95,0xF4,0x66,0x3E,0x79,0x3A,0x5F,0x62,0x5F,0x0F,0x00,0x00};
const char chineseTxtTwelveHour[] = "\x80\x00\x31\x00\x32\x5c\x0f\x65\xf6\x52\x36\x00" ;	///12Сʱ
const char chineseTxtTwentyfourHour[] = "\x80\x00\x32\x00\x34\x5c\x0f\x65\xf6\x52\x36\x00";	///24Сʱ
const char chineseTxtInCallTimer[]= {0x80,0x8B,0xA1,0x65,0xF6,0x00,0x00};
const char chineseTxtStore[] = {0x80,0x50,0xA8,0x5B,0x58,0x00,0x00}; 
const char chineseTxtNone[] = {0x80,0x5D,0xF1,0x00,0x00};	
const char chineseTxtPIN[] =  {0x80,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x31,0x78,0x01,0x00,0x00}; ///PIN1
const char chineseTxtPIN2[] =  "\x80\x66\xf4\x65\x39\x00P\x00I\x00N\x00\x32\x00\x00" ;	///PIN2 {0x80,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x00,0x00};
const char chineseTxtConfPin2[] = {0x80,0x6B,0x63,0x78,0x6E,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x00,0x00};
const char chineseTxtNewPIN2[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xB0,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x00,0x00};
const char chineseTxtUnlockOK[] = {0x80,0x5B,0xC6,0x95,0x01,0x00,0x4F,0x00,0x4B,0x00,0x00};
const char chineseTxtIMEI[] = {0x80,0x00,0x49,0x00,0x4D,0x00,0x45,0x00,0x49,0x00,0x00}; 
const char chineseTxtList[] = {0x80,0x54,0x0D,0x53,0x55,0x00,0x00};
const char chineseTxtFull[] = {0x80,0x6E,0xE1,0x00,0x00};
const char chineseTxtCapacityFull[]={0x80,0x5b,0xb9,0x91,0xcf,0x5d,0xf2,0x6e,0xe1,0x00,0x00} ;//
const char chineseTxtNotAvailable[] = {0x80,0x4E,0x0D,0x53,0xEF,0x4F,0x9B,0x67,0x0D,0x52,0xA1,0x00,0x00};
const char chineseTxtCallBAOC[]= {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x4F,0x00,0x43,0x00,0x00};
const char chineseTxtCallBAOIC[] = {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x4F,0x00,0x49,0x00,0x43,0x00,0x00};
const char chineseTxtCallBAOICexH[] = {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x4F,0x00,0x49,0x00,0x43,0x00,0x65,0x00,0x78,0x00,0x48,0x00,0x00};
const char chineseTxtCallBAIC[] = {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x49,0x00,0x43,0x00,0x00};
const char chineseTxtCallBAICroam[] = {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x49,0x00,0x43,0x00,0x72,0x00,0x6F,0x00,0x61,0x00,0x6D,0x00,0x00};
const char chineseTxtCallBarringAll[] = {0x80,0x54,0x7C,0x53,0xEB,0x96,0x50,0x52,0x36,0x00,0x00};
const char chineseTxtCallBAOCAll[] = {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x4F,0x00,0x43,0x00,0x41,0x00,0x6C,0x00,0x6C,0x00,0x00};
const char chineseTxtCallBAICAll[] = {0x80,0x8B,0xDD,0x00,0x42,0x00,0x41,0x00,0x49,0x00,0x43,0x00,0x41,0x00,0x6C,0x00,0x6C,0x00,0x00};
const char chineseTxtCLIP[] = {0x80,0x00,0x43,0x00,0x4C,0x00,0x49,0x00,0x50,0x00,0x00};
const char chineseTxtCOLP[] = {0x80,0x00,0x4F,0x00,0x4C,0x00,0x50,0x00,0x00};
const char chineseTxtCOLR[] = {0x80,0x00,0x4F,0x00,0x4C,0x00,0x52,0x00,0x00};
const char chineseTxtSimToolkit[] = {0x80,0x00,0x53,0x00,0x4D,0x00,0x53,0x5D,0xE5,0x51,0x77,0x7B,0xB1,0x00,0x00};
/* glowing : "ڵ绰" Ϊ "ͨ¼" \x80\x90\x1a\x8b\xdd\x8b\xb0\x5f\x55\x00\x00 */	
//const char chineseTxtRecentCalls[] = {0x80,0x8F,0xD1,0x67,0x1F,0x75,0x35,0x8B,0xDD,0x00,0x00};
const char chineseTxtRecentCalls[] = "\x80\x90\x1a\x8b\xdd\x8b\xb0\x5f\x55\x00\x00";
const char chineseTxtRecordName[] = "\x80\x8b\xb0\x5f\x55\x54\x0d\x79\xf0\x00\x00";//2004-04-06 Sunny add
const char chineseTxtInterCalls[] =  {0x80,0x56,0xFD,0x96,0x45,0x75,0x35,0x8B,0xDD,0x00,0x00};
//const char chineseTxtInterHome[] =  {0x80,0x56,0xFD,0x96,0x45,0x00,0x28,0x65,0xE0,0x5B,0xB6,0x00,0x29,0x75,0x35,0x8B,0xDD,0x00,0x00}; 
const char chineseTxtInterHome[]="\x80\x56\xfd\x96\x45\x00\x28\x6f\x2b\x6e\x38\x00\x29\x75\x35\x8b\xdd\x00\x00";//wufei modify 0827
const char chineseTxtWhenRoaming[] = {0x80,0x6F,0x2B,0x6E,0x38,0x00,0x00};
const char chineseTxtCancelAllBars[] =  {0x80,0x52,0x20,0x96,0x64,0x51,0x68,0x90,0xE8,0x00,0x00};
const char chineseTxtWaiting[] = "\x80\x8b\xf7\x7b\x49\x50\x19\x00\x00" ;  ///Ⱥ...{0x80,0x7B,0x49,0x50,0x19,0x00,0x00};
const char chineseTxtBarred[] =   {0x80,0x58,0x35,0x58,0x5E,0x00,0x00};
const char chineseTxtForwarded[] = {0x80,0x5D,0xF1,0x8F,0x6C,0x90,0x01,0x00,0x00};
const char chineseTxtCallDivertNoReach[] = {0x80,0x8F,0x6C,0x79,0xFB,0x67,0x2A,0x90,0x1A,0x00,0x00};
const char chineseTxtCallDivertNoReply[] = {0x80,0x8F,0x6C,0x79,0xFB,0x65,0xE0,0x5E,0x94,0x7B,0x54,0x00,0x00};
const char chineseTxtCallDivertIfBusy[] = {0x80,0x8F,0x6C,0x79,0xFB,0x82,0xE5,0x5F,0xD9,0x00,0x00};
const char chineseTxtPressMenu[] = {0x80,0x63,0x09,0x67,0xEE,0x5F,0x55,0x95,0x2E,0x00,0x00};
const char chineseTxtSending[] = {0x80,0x53,0xD1,0x90,0x01};
const char chineseTxtMessage[] = {0x80,0x57,0x79,0x8A,0x00,0x00,0x00}; 
const char chineseTxtSoftNext[] = {0x80,0x4E,0x0B,0x4E,0x00,0x4E,0x2A,0x00,0x00};
const char chineseTxtLastCall[] = "\x80\x4e\x0a\x6b\x21\x90\x1a\x8b\xdd\x00\x00";//WUFEI Modify
//ͬ153
const char chineseTxtLow[] = {0x80,0x4F,0x4E,0x00,0x00};
const char chineseTxtMedium[] = {0x80,0x4E,0x2D,0x00,0x00};
const char chineseTxtHigh[] = {0x80,0x9A,0xD8,0x00,0x00};
const char chineseTxtIncreasing[] =  {0x80,0x6E,0x10,0x58,0x9E,0x00,0x00};
//    const char chineseTxtTimerReset[] =  "\x80\x8b\xa1\x65\xf6\x56\x68\x6e\x05\x96\xf6\x00\x00";//WUFEI Modify
/* "ʱ" Ϊ "ʱ" */
const char chineseTxtTimerReset[] =  "\x80\x8b\xa1\x65\xf6\x6e\x05\x96\xf6\x00\x00";//WUFEI Modify
const char chineseTxtClockSetTo[] =   {0x80,0x95,0xF9,0x94,0x9F,0x8B,0xBE,0x5B,0x9A,0x4E,0x3A,0x00,0x00};
//Ѿ
const char chineseTxtValiditySet[] = {0x80,0x67,0x09,0x65,0x48,0x67,0x1F,0x8B,0xBE,0x5B,0x91,0x00,0x00};
const char chineseTxt1Hour[] = {0x80,0x00,0x31,0x00,0x20,0x5c,0x0f,0x65,0xF6,0x00,0x00};
const char chineseTxt12Hour[] = {0x80,0x00,0x31,0x00,0x32,0x00,0x20,0x5C,0x0F,0x65,0xF6,0x00,0x00};
const char chineseTxt24Hours[] = {0x80,0x00,0x32,0x00,0x34,0x00,0x20,0x5C,0x0F,0x65,0xF6,0x00,0x00};
const char chineseTxt1Week[] = {0x80,0x00,0x31,0x00,0x20,0x66,0x1f,0x67,0x1f,0x00,0x00};
//ѾTxtPIN2б
const char chineseTxtEnablePIN[] = {0x80,0x5B,0xC6,0x78,0x01,0x5F,0x00,0x8D,0xFF,0x00,0x00};
const char chineseTxtRequesting[]= {0x80,0x6B,0x63,0x57,0x28,0x89,0x81,0x6C,0x42,0x00,0x00};
const char chineseTxtNotAllowed[] = {0x80,0x4E,0x0D,0x51,0x41,0x8B,0xB8,0x00,0x00};
const char chineseTxtEmergency[] = {0x80,0x7D,0x27,0x60,0x25,0x00,0x00};
const char chineseTxtChinese[] =   {0x80,0x4E,0x2D,0x65,0x87,0x00,0x00};
const char chineseTxtPassword[] =  {0x80,0x5B,0xC6,0x78,0x01,0x00,0x00};
const char chineseTxtConfirmPassword[] = {0x80,0x78,0x6E,0x5B,0x9A,0x5B,0xC6,0x78,0x01,0x00,0x00};
const char chineseTxtNewPassword[] = {0x80,0x65,0xB0,0x5B,0xC6,0x78,0x01,0x00,0x00}; 
const char chineseTxtNoMessages[] = {0x80,0x65,0xE0,0x77,0xED,0x4F,0xE1,0x00,0x00};
const char chineseTxtTwoAttemptsLeft[] = "\x80\x52\x69\x4f\x59\x4e\x24\x6b\x21\x67\x3a\x4f\x1a\x00\x00" ; ///ʣλ
const char chineseTxtOneAttemptLeft[] = "\x80\x52\x69\x4f\x59\x4e\x00\x6b\x21\x67\x3a\x4f\x1a\x00\x00" ;  ///ʣһλ
const char chineseTxtblacklistedt[]="\x80\x88\xab\x79\x81\x6b\x62\x76\x84\x53\xf7\x78\x01\x00\x00"; 
const char chineseTxtErrUnknown[]="\x80\x67\x2a\x77\xe5\x95\x19\x8b\xef\x00\x00" ;
const char chineseTxtSSErr[]="\x80\x95\x19\x8b\xef\x00\x00" ;
const char chineseTxtUnknownSub[]="\x80\x67\x2a\x77\xe5\x75\x28\x62\x37\x00\x00" ;//????
const char chineseTxtIllSub[]="\x80\x4e\x0d\x54\x08\x6c\xd5\x75\x28\x62\x37\x00\x00" ;//?????
const char chineseTxtIllEqip[]="\x80\x4e\x0d\x54\x08\x6c\xd5\x8b\xbe\x59\x07\x00\x00" ;//?????
const char chineseTxtIllOp[]="\x80\x4e\x0d\x54\x08\x6c\xd5\x64\xcd\x4f\x5c\x00\x00" ;//?????
const char chineseTxtSubVil[]="\x80\x4e\x0d\x54\x08\x6c\xd5\x75\x28\x62\x37\x00\x00" ;//?????
const char chineseTxtInComp[]="\x80\x77\xdb\x76\xfe\x00\x00" ;//??
const char chineseTxtFacNoSup[]="\x80\x8b\xbe\x59\x07\x4e\x0d\x65\x2f\x63\x01\x00\x00" ;//?????
const char chineseTxtAbsSub[]="\x80\x75\x28\x62\x37\x4e\x0d\x57\x28\x00\x00" ;//????
const char chineseTxtSysFail[]="\x80\x7c\xfb\x7e\xdf\x59\x31\x8d\x25\x00\x00" ;//????
const char chineseTxtMissDta[]="\x80\x65\x70\x63\x6e\x4e\x22\x59\x31\x00\x00" ;//????
const char chineseTxtUnexDta[]="\x80\x95\x19\x8b\xef\x65\x70\x63\x6e\x00\x00" ;//????
const char chineseTxtPwdErr[]="\x80\x8f\x93\x51\x65\x95\x19\x8b\xef\x00\x00" ;//????
const char chineseTxtUnkAlph[]="\x80\x67\x2a\x77\xe5\x5b\x57\x6b\xcd\x00\x00" ;//????
const char chineseTxtMaxMpty[]="\x80\x67\x00\x59\x27\x90\xe8\x52\x06\x91\x4d\x7f\x6e\x00\x00" ;//??????
const char chineseTxtNoReply[]="\x80\x67\x2a\x77\xe5\x00\x00" ;//??
const char chineseTxtUnRec[]="\x80\x67\x2a\x77\xe5\x00\x00" ;//??
const char chineseTxtMisTyp[]="\x80\x4e\x0d\x53\x39\x91\x4d\x7c\x7b\x57\x8b\x00\x00" ;//?????
const char chineseTxtBadStruct[]="\x80\x95\x19\x8b\xef\x7e\xd3\x67\x84\x00\x00" ;//????
const char chineseTxtDupInv[]="\x80\x59\x0d\x52\x36\x75\x28\x6c\xd5\x00\x00" ;//????
const char chineseTxtResLim[]="\x80\x65\xe0\x8d\x44\x6e\x90\x00\x00"; //???
const char chineseTxtIniRel[]="\x80\x52\x1d\x59\xcb\x53\x16\x00\x00" ;//???
const char chineseTxtFatRes[]="\x80\x4e\x25\x91\xcd\x95\x19\x8b\xef\x00\x00" ;//????
const char chineseTxtEntAnw[]="\x80\x5e\x94\x7b\x54\x00\x00" ;//??
const char chineseTxtSsMsg[]="\x80\x88\x65\x51\x45\x4e\x1a\x52\xa1\x6d\x88\x60\x6f\x00\x00" ;//??????
const char chineseTxtOld[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0xE7,0x00,0x00};
const char chineseTxtTotalCount[] = {0x80, 0x00,'T',0x00,'o',0x00,'t',0x00,'a',0x00,'l',0x00,' ',0x00,'C',0x00,'o',0x00,'u',0x00,'n',0x00,'t',0x00,0x00,0x00 };
const char chineseTxtIPAddress1[] = "\x80\x00I\x00P\x57\x30\x57\x40\x00\x31\x00\x00" ;	///IPַ1
const char chineseTxtIPAddress2[] = "\x80\x00I\x00P\x57\x30\x57\x40\x00\x32\x00\x00" ;	///IPַ2
const char chineseTxtPort1[] = "\x80\x7a\xef\x53\xe3\x00\x31\x00\x00\x00" ;	///˿1
const char chineseTxtPort2[] = "\x80\x7a\xef\x53\xe3\x00\x32\x00\x00\x00" ;	///˿2
const char chineseTxtAPN[] = "\x80\x00\x47\x00\x50\x00\x52\x00\x53\x63\xa5\x51\x65\x70\xb9\x00\x00" ;	///GPRS
const char chineseTxtConnectionType[] = "\x80\x8f\xde\x63\xa5\x7c\x7b\x57\x8b\x00\x00" ;	///
const char chineseTxtGPRS[] = {0x80, 0x00,'G',0x00,'P',0x00,'R',0x00,'S',0x00,0x00,0x00 };
const char chineseTxtGPRSInfo[] = "\x80\x00\x47\x00\x50\x00\x52\x00\x53\x4f\xe1\x60\x6f\x00\x00";//WUFEI APPEND
const char chineseTxtOutgoingData[] = "\x80\x5d\xf2\x53\xd1\x90\x01\x65\x70\x63\x6e\x91\xcf\x00\x00";//WUFEI Modify
///////////////////////////////
const char chineseTxtHomepage[] = "\x80\x4e\x3b\x98\x75\x00\x00"; 	///ҳ
const char chineseTxtBookmarks[] = "\x80\x4e\x66\x7b\x7e\x00\x00";	///ǩ
const char chineseTxtGoTo[] = "\x80\x8f\xdb\x51\x65\x7f\x51\x57\x40\x00\x00";///ַ
const char chineseTxtHistory[] = "\x80\x53\x86\x53\xf2\x8b\xb0\x5f\x55\x00\x00" ;	///ʷ¼
const char chineseTxtSetup[] = "\x80\x8b\xbe\x7f\x6e\x00\x00" ;	///
const char chineseTxtNewBookmark[] = "\x80\x6d\xfb\x52\xa0\x4e\x66\x7b\x7e\x00\x00"; 	///ǩ
const char chineseTxtSMS[] = {0x80, 0x00,'S',0x00,'M',0x00,'S',0x00,0x00,0x00 };
const char chineseTxtEmail[] = {0x80, 0x00,'E',0x00,'m',0x00,'a',0x00,'i',0x00,'l',0x00,0x00,0x00 };
const char chineseTxtClear[] = "\x80\x52\x20\x96\x64\x8b\xb0\x5f\x55\x00\x00" ;	///ɾ¼
const char chineseTxtBookmark[] = "\x80\x6d\xfb\x52\xa0\x4e\x66\x7b\x7e\x00\x00";	///ǩ
const char chineseTxtSelectProfile[] = "\x80\x5f\x53\x52\x4d\x67\x0d\x52\xa1\x8b\xbe\x7f\x6e\x00\x00"; ///ǰ
const char chineseTxtSetupProfiles[] = "\x80\x4f\xee\x65\x39\x67\x0d\x52\xa1\x8b\xbe\x7f\x6e\x00\x00"; ///޸ķ
const char chineseTxtSaveHistory[] = "\x80\x4f\xdd\x5b\x58\x7f\x51\x57\x40\x00\x00";	///ַ
const char chineseTxtEditName[] = "\x80\x7f\x16\x8f\x91\x68\x07\x98\x98\x00\x00" ;///༭
const char chineseTxtEditURL[] = "\x80\x7f\x16\x8f\x91\x7f\x51\x57\x40\x00\x00" ; ///༭ַ
const char chineseTxtAccessType[] = "\x80\x8f\xde\x63\xa5\x65\xb9\x5f\x0f\x00\x00";///ӷʽ
const char chineseTxtResponseTimer[] = "\x80\x8f\xde\x63\xa5\x65\xf6\x95\xf4\x00\x00" ; ///ʱ
const char chineseTxtDialupNumber[] = "\x80\x62\xe8\x53\xf7\x53\xf7\x78\x01\x00\x00" ;	///ź
const char chineseTxtTemporary[] = "\x80\x4e\x34\x65\xf6\x8f\xde\x63\xa5\x00\x00" ;  	///ʱ
const char chineseTxtContinuous[] = "\x80\x63\x01\x7e\xed\x8f\xde\x63\xa5\x00\x00" ;	///
const char chineseTxtGPRSData[] = {0x80, 0x00,'G',0x00,'P',0x00,'R',0x00,'S',0x00,0x00,0x00 };//GPRS
const char chineseTxtCSData[] = "\x80\x65\x70\x63\x6e\x00\x00" ;	    ///
const char chineseTxtWAP[] = "\x80\x4e\x92\x80\x54\x7f\x51\x00\x00" ;	///
const char chineseTxtExit[] = "\x80\x90\x00\x51\xfa\x00\x00" ;	///˳
const char chineseTxtReload[] = "\x80\x51\x8d\x4e\x0b\x8f\x7d\x00\x00" ;	///
const char chineseTxtStored[] = "\x80\x5d\xf2\x4f\xdd\x5b\x58\x00\x00";	///ѱ
const char chineseTxtOther[] = {0x80,0x51,0x76,0x5B,0x83,0x00,0x00};
const char chineseTxtConnecting[] ="\x80\x6b\x63\x57\x28\x8f\xde\x63\xa5\x00\x2e\x00\x2e\x00\x00" ;	///
const char chineseTxtDownloading[] = "\x80\x4e\x0b\x8f\x7d\x00\x2e\x00\x2e\x00\x00" ;	///..
const char chineseTxtUpdating[] = {0x80, 0x00,'U',0x00,'p',0x00,'d',0x00,'a',0x00,'t',0x00,'i',0x00,'n',0x00,'g',0x00,'.',0x00,'.',0x00,'.',0x00,0x00,0x00 };
const char chineseTxtEnterURL[] = {0x80, 0x00,'E',0x00,'n',0x00,'t',0x00,'e',0x00,'r',0x00,' ',0x00,'U',0x00,'R',0x00,'L',0x00,':',0x00,0x00,0x00 };
const char chineseTxtProfileName[] = {0x80, 0x00,'P',0x00,'r',0x00,'o',0x00,'f',0x00,'i',0x00,'l',0x00,'e',0x00,' ',0x00,'N',0x00,'a',0x00,'m',0x00,'e',0x00,':',0x00,' ',0x00,0x00,0x00 };
const char chineseTxtISPUsername[] = "\x80\x75\x28\x62\x37\x54\x0d\x00\x00" ;	///û
const char chineseTxtISPPassword[] = "\x80\x5b\xc6\x78\x01\x00\x00" ;	///
const char chineseTxtGoToLink[] = "\x80\x8f\xdb\x51\x65\x00\x00" ;	///
const char chineseTxtSelect[] = { 0x80,0x90,0x09,0x62,0xe9,0x00,0x00 }; //WUFEI MODIFY
const char chineseTxtNotConnected[] = "\x80\x4e\x0d\x80\xfd\x8f\xde\x63\xa5\x00\x00";	///
const char chineseTxtScaleImages[] = "\x80\x56\xfe\x50\xcf\x66\x3e\x79\x3a\x00\x00" ;	///ͼʾ
const char chineseTxtLoggingIn[] = "\x80\x6c\xe8\x51\x8c\x00\x00" ;	///ע
const char chineseTxtAcceptEndWAP[] = {0x80, 0x00,'A',0x00,'c',0x00,'c',0x00,'e',0x00,'p',0x00,'t',0x00,' ',0x00,'w',0x00,'i',0x00,'l',0x00,'l',0x00,' ',0x00,'d',0x00,'i',0x00,'s',0x00,'c',0x00,'o',0x00,'n',0x00,'n',0x00,'e',0x00,'c',0x00,'t',0x00,' ',0x00,'W',0x00,'A',0x00,'P',0x00,0x00,0x00 };
const char chineseTxtErrorUnknown[] = {0x80, 0x00,'U',0x00,'n',0x00,'k',0x00,'n',0x00,'o',0x00,'w',0x00,'n',0x00,' ',0x00,'e',0x00,'r',0x00,'r',0x00,'o',0x00,'r',0x00,0x00,0x00 };
const char chineseTxtErrorHTTP[] = {0x80, 0x00,'H',0x00,'T',0x00,'T',0x00,'P',0x00,0x00,0x00 };
const char chineseTxtErrorWSP[] = {0x80, 0x00,'W',0x00,'S',0x00,'P',0x00,0x00,0x00 };
const char chineseTxtErrorWAE[] = {0x80, 0x00,'W',0x00,'A',0x00,'E',0x00,0x00,0x00 };
const char chineseTxtErrorWSPCL[] = {0x80, 0x00,'W',0x00,'S',0x00,'P',0x00,'C',0x00,'L',0x00,0x00,0x00 };
const char chineseTxtErrorWSPCM[] = {0x80, 0x00,'W',0x00,'S',0x00,'P',0x00,'C',0x00,'M',0x00,0x00,0x00 };
const char chineseTxtErrorWTP[] = {0x80, 0x00,'W',0x00,'T',0x00,'P',0x00,0x00,0x00 };
const char chineseTxtErrorWTLS[] = {0x80, 0x00,'W',0x00,'T',0x00,'L',0x00,'S',0x00,0x00,0x00 };
const char chineseTxtErrorWDP[] = {0x80, 0x00,'W',0x00,'D',0x00,'P',0x00,0x00,0x00 };
const char chineseTxtErrorUDCP[] = {0x80, 0x00,'U',0x00,'D',0x00,'C',0x00,'P',0x00,0x00,0x00 };
const char chineseTxtNotSupported[] = {0x80,0x4e,0x0d,0x65,0x2f,0x63,0x01,0x00,0x00 }; //hu binhao 10-31 ֧
const char chineseTxtSelectLine[] = "\x80\x7e\xbf\x8d\xef\x52\x07\x63\x62\x00\x00"; //sunsj030918//·л
const char chineseTxtLine1[] = {0x80,0x7e,0xbf,0x8d,0xef,0x00,0x31,0x00,0x00};//WUFEI Modify
const char chineseTxtLine2[] = {0x80,0x7e,0xbf,0x8d,0xef,0x00,0x32,0x00,0x00};//WUFEI Modify
const char chineseTxtInfoNumbers[]= "\x80\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x4e\x00\x75\x00\x6d\x00\x62\x00\x65\x00\x72\x00\x73\x00\x00";//zhonghz,2002/8/1,???
const char chineseTxtAttach[] = "\x80\x96\x44\x77\x40\x00\x00" ;	///
const char chineseTxtDetach[] = "\x80\x53\xbb\x96\x44\x77\x40\x00\x00" ;	///ȥ
const char chineseTxtGPRSAuto[]="\x80\x67\x09\x7f\x51\x7e\xdc\x4f\xe1\x53\xf7\x65\xf6\x00\x00" ;	///źʱ
const char chineseTxtGPRSNeed[]="\x80\x5f\x53\x97\x00\x89\x81\x65\xf6\x00\x00" ;	///Ҫʱ
const char chineseTxtAttachMode[]="\x80\x00\x47\x00\x50\x00\x52\x00\x53\x63\xa5\x51\x65\x00\x00" ;	///GPRS
const char chineseTxtDefineContext[] = {0x80,0x00,'D',0x00,'e',0x00,'f',0x00,'i',0x00,'n',0x00,'e',0x00,0x00};
const char chineseTxtActivateContext[] = {0x80,0x00,'A',0x00,'c',0x00,'t',0x00,'i',0x00,'v',0x00,'a',0x00,'t',0x00,'e',0x00,0x00};
const char chineseTxtDeactivateContext[] = {0x80,0x00,'D',0x00,'e',0x00,'a',0x00,'c',0x00,'t',0x00,'i',0x00,'v',0x00,'a',0x00,'t',0x00,'e',0x00,0x00};
const char chineseTxtGPRSPreferred[] = {0x80,0x00,'G',0x00,'P',0x00,'R',0x00,'S',0x00,' ',0x00,'P',0x00,'r',0x00,'e',0x00,'f',0x00,'e',0x00,'r',0x00,'r',0x00,'e',0x00,'d',0x00,0x00}; // sbh 25/01/02
const char chineseTxtCSDPreferred[] = {0x80,0x00,'C',0x00,'S',0x00,'D',0x00,' ',0x00,'P',0x00,'r',0x00,'e',0x00,'f',0x00,'e',0x00,'r',0x00,'r',0x00,'e',0x00,'d',0x00,0x00}; // sbh 25/01/02
const char chineseTxtNotAttached[] = "\x80\x5d\xf2\x65\xad\x5f\x00\x00\x00" ;	///GPRSѶϿ
const char chineseTxtAlreadyAttached[] = "\x80\x5d\xf2\x7e\xcf\x96\x44\x77\x40\x00\x00" ;	///Ѿ
const char chineseTxtSelected[] = {0x80, 0x00,'S',0x00,'e',0x00,'l',0x00,'e',0x00,'c',0x00,'t',0x00,'e',0x00,'d',0x00,0x00}; /*ap 06/02/02*/
const char chineseTxtNetwork[] = {0x80, 0x00,'N',0x00,'e',0x00,'t',0x00,'w',0x00,'o',0x00,'r',0x00,'k',0x00,0x00};/*ap 06/02/02*/
const char chineseTxtForbidden[] = {0x80, 0x00,'F',0x00,'o',0x00,'r',0x00,'b',0x00,'i',0x00,'d',0x00,'d',0x00,'e',0x00,'n',0x00,0x00}; /*ap 06/02/02*/
const char chineseTxtActivateFDN[] = {0x80, 0x00,'A',0x00,'c',0x00,'t',0x00,'i',0x00,'v',0x00,'a',0x00,'t',0x00,'e',0x00,' ',0x00,'F',0x00,'D',0x00,'N',0x00,0x00}; /*ap 06/02/02*/
const char chineseTxtPlease[] = {0x80, 0x00,'P',0x00,'l',0x00,'e',0x00,'a',0x00,'s',0x00,'e',0x00,0x00};
const char chineseTxtTimedOut[] = {0x80,0x00, 'T',0x00,'i',0x00,'m',0x00,'e',0x00,'d',0x00,' ',0x00,'O',0x00,'u',0x00,'t',0x00,0x00}; // sbh 13/02/02
const char chineseTxtWillChangeOn[] = {0x80,0x00, 'W',0x00,'i',0x00,'l',0x00,'l',0x00,' ',0x00,'C',0x00,'h',0x00,'a',0x00,'n',0x00,'g',0x00,'e',0x00,' ',0x00,'O',0x00,'n',0x00,0x00 }; // sbh 13/02/02
const char chineseTxtAttached[] = "\x80\x96\x44\x77\x40\x62\x10\x52\x9f\x00\x00" ;	///ųɹ
const char chineseTxtDetached[] = "\x80\x53\xbb\x96\x44\x77\x40\x62\x10\x52\x9f\x00\x00" ;	///ȥųɹ
const char chineseTxtVoiceCallDivert[] = {0x80,0x8b,0xed,0x97,0xf3,0x67,0x65,0x75,0x35,0x8f,0x6c,0x79,0xfb,0x00,0x00}; // WUFEI
const char chineseTxtAllFaxCallDivert[] = {0x80,0x62,0x40,0x67,0x09,0x4f,0x20,0x77,0x1f,0x67,0x65,0x75,0x35,0x00,0x00}; // WUFEI
const char chineseTxtAllDataCallDivert[] = {0x80,0x62,0x40,0x67,0x09,0x65,0x70,0x63,0x6e,0x67,0x65,0x75,0x35,0x00,0x00}; // WUFEI
const char chineseTxtVoiceMailBox[] = {0x80,0x8b,0xed,0x97,0xf3,0x4f,0xe1,0x7b,0xb1,0x00,0x00}; // WUFEI
const char chineseTxtOtherNumber[] = {0x80,0x51,0x76,0x5b,0x83,0x53,0xf7,0x78,0x01,0x00,0x00}; // WUFEI
const char chineseTxtNumberInCommonUse[] = {0x80,0x5e,0x38,0x75,0x28,0x53,0xf7,0x78,0x01,0x00,0x00}; // WUFEI
const char chineseTxtCallSettings[] = {0x80,0x90,0x1a,0x8b,0xdd,0x8b,0xbe,0x7f,0x6e,0x00,0x00};//WUFEI APPEND
const char chineseTxtMinuteHint[] = {0x80,0x52,0x06,0x94,0x9f,0x63,0xd0,0x79,0x3a,0x00,0x00};//WUFEI APPEND
const char chineseTxtNextCall[] = {0x80,0x4e,0x0b,0x6b,0x21,0x90,0x1a,0x8b,0xdd,0x00,0x00};//WUFEI APPEND
const char chineseTxtCUGNumber[] = {0x80,0x7f,0x16,0x7e,0xc4,0x75,0x35,0x8b,0xdd,0x00,0x00};//WUFEI APPEND
const char chineseTxtPreDefine[] = {0x80,0x98,0x84,0x5b,0x9a,0x4e,0x49,0x00,0x00};//WUFEI APPEND
const char chineseTxtEnterIndex[] = {0x80,0x8f,0x93,0x51,0x65,0x7d,0x22,0x5f,0x15,0x53,0xf7,0x00,0x00};//WUFEI APPEND
const char chineseTxtAddCUG[] = {0x80,0x6d,0xfb,0x52,0xa0,0x00,0x00};//WUFEI APPEND
const char chineseTxtModify[] = {0x80,0x4f,0xee,0x65,0x39,0x00,0x00};//WUFEI APPEND
const char chineseTxtEnerNRyTime[]="\x80\x65\xf6\x95\xf4\x00\x28\x00\x35\x00\x2d\x00\x33\x00\x30\x00\x29\x79\xd2\x00\x00";//WUFEI APPEND hu binhao 12-16 append "second"
const char chineseTxtCancelAffirm[] ="\x80\x78\x6e\x5b\x9e\x89\x81\x53\xd6\x6d\x88\x00\x00";//WUFEI APPEND hubinhao 2003-2-12
const char chineseTxtWithout[] ="\x80\x65\xe0\x00\x00";//WUFEI APPEND
//xsf add 2002.08.05  2 lines
const char chineseTxtGSM900[] = "\x80\x00G\x00S\x00M\x00\x39\x00\x30\x00\x30\x00\x00" ;  ///GSM900 { 0x00,'G',0x00,'S',0x00,'M',0x00,'9',0x00,'0',0x00,'0',0x00,0x00,0x00 }; //GSM900
const char chineseTxtDCS1800[] = "\x80\x00D\x00C\x00S\x00\x31\x00\x38\x00\x30\x00\x30\x00\x00" ; ///DCS1800 { 0x00,'D',0x00,'C',0x00,'S',0x00,'1',0x00,'8',0x00,'0',0x00,'0',0x00,0x00,0x00 }; //DCS1800


///////////////////////////////////////////////////////////////////////////////////////////
//
//  these won't be used in enum tangyan 7.31 check them out
//
//////////////////////////////////////////////////////////////////////////////////////////////////
    const char chineseTxtNetSearch[] = {0x80,0x67,0xE5,0x5B,0xFB,0x00,0x00};    
    const char chineseTxtDownload[] = {0x80,0x50,0xA8,0x5B,0x58,0x00,0x00};     
    const char chineseTxtNotEnough[] = {0x80,0x4E,0x0D,0x59,0x1F,0x00,0x00};
    const char chineseTxtCharacter[] = {0x80,0x65,0x87,0x5B,0x57,0x00,0x00}; 
    const char chineseTxtMemUsage[] = {0x80,0x8B,0xB0,0x5F,0xC6,0x7A,0x7A,0x95,0xF4,0x4E,0x58,0x00,0x00};
    const char chineseTxtOperator[] =  {0x80,0x64,0xCD,0x4F,0x5C,0x54,0x58,0x00,0x00};
    const char chineseTxtOrganiser[] = {0x80,0x8B,0XB0,0X4E,0X8B,0X67,0X2C,0x00,0x00}; 
    const char chineseTxtSounds[] = {0x80,0x58,0xF0,0x97,0xF3,0x00,0x00};
    const char chineseTxtServices[] = {0x80,0x67,0x0D,0x52,0xA1,0x00,0x00};
    const char chineseTxtEnterMessage[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x2C,0x00,0x4D,0x00,0x65,0x00,0x73,0x00,0x73,0x00,0x61,0x00,0x67,0x00,0x65,0x00,0x00};
    const char chineseTxtSmsReceived[] =  {0x80,0x65,0x36,0x52,0x30,0x75,0x59,0x8A,0x00,0x00,0x00};
   const char chineseTxtCbEnterMid[] = {0x80,0x00,0x43,0x00,0x42,0x00,0x20,0x8F,0x93,0x51,0x65,0x00,0x20,0x00,0x4D,0x00,0x49,0x00,0x44,0x00,0x00}; // No Translation
    const char chineseTxtNotSaved[] = {0x80,0x67,0x2A,0x50,0xA8,0x5B,0x58,0x00,0x00};
    const char chineseTxtTimeReceived[] = {0x80,0x63,0xA5,0x65,0x36,0x65,0xF6,0x95,0xF4,0x00,0x00};
    const char chineseTxtAddNewEvent[] = {0x80,0x65,0xB0,0x58,0x9E,0x98,0x79,0x76,0xEE,0x00,0x00};
    const char chineseTxtModifyEvent[] = {0x80,0x4F,0xEE,0x65,0x39,0x98,0x79,0x76,0xEE,0x00,0x00};
    const char chineseTxtDeleteEvent[] = {0x80,0x52,0x20,0x96,0x64,0x98,0x79,0x76,0xEE,0x00,0x00};
    const char chineseTxtShowEvent[] = {0x80,0x66,0x3E,0x79,0x3A,0x98,0x79,0x76,0xEE};  
    const char chineseTxtBatteryLow[] = {0x80,0x75,0x35,0x6C,0x60,0x4E,0x0D,0x8D,0xC3,0x00,0x00};
    const char chineseTxtCreditLow[] = {0x80,0x5B,0x58,0x6B,0x3E,0x4E,0x0D,0x8D,0xC3,0x00,0x00};
    const char chineseTxtAlarmClock[] = {0x80,0x95,0xF9,0x94,0x9F,0x00,0x00};
    const char chineseTxtKeypadLock[] = {0x80,0x63,0x09,0x95,0x2E,0x95,0x01,0x00,0x00};  
    const char chineseTxtPin2Code[] = {0x80,0x00,0x50,0x00,0x69,0x00,0x6E,0x00,0x32,0x00,0x20,0x00,0x43,0x00,0x6F,0x00,0x64,0x00,0x65,0x00,0x00};  
    const char chineseTxtVibrator[] = {0x80,0x63,0x2F,0x52,0xA8,0x00,0x00};
    const char chineseTxtVibraThenRing[] = {0x80,0x63,0x2F,0x52,0xA8,0x51,0x8D,0x54,0xCD,0x94,0xC3,0x00,0x00};
    const char chineseTxtCommands[] = {0x80,0x63,0x07,0x4E,0xCA,0x00,0x00};
    const char chineseTxtNumbers[] = {0x80,0x53,0xF7,0x78,0x01,0x00,0x00}; 
    const char chineseTxtInfraRed[] = {0x80,0x7E,0xA2,0x59,0x15,0x7E,0xBF,0x00,0x00};
    const char chineseTxtStopwatch[] = "\x80\x79\xd2\x88\x68\x00\x00";     
    const char chineseTxtTransfer[] = {0x80,0x8F,0x6C,0x79,0xFB,0x00,0x00};
    const char chineseTxtCorrect[] = {0x80,0x5B,0xC6,0x78,0x01,0x6B,0x63,0x78,0x6E,0x00,0x00};
    const char chineseTxtReceiveSMS[] = {0x80,0x63,0xA5,0x65,0x36,0x00,0x53,0x00,0x4D,0x00,0x53,0x00,0x00};
    const char chineseTxtCenterNumber[] = {0x80,0x4E,0x2D,0x5F,0xC3,0x53,0xF7,0x78,0x01,0x00,0x00};
    const char chineseTxtChangePIN[] = {0x80,0x65,0x39,0x53,0xD8,0x00,0x20,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x00};
    const char chineseTxtDisablePIN[] = {0x80,0x5B,0xC6,0x78,0x01,0x51,0x73,0x95,0xED,0x00,0x00};
    const char chineseTxtPINincorrect[] = {0x80,0x5B,0xC6,0x78,0x01,0x95,0x19,0x8B,0xEF,0x00,0x00};
    const char chineseTxtManualSelected[] = {0x80,0x4E,0xBA,0x5D,0xE5,0x90,0x09,0x5B,0x9A,0x00,0x00};
    const char chineseTxtAutomaticSelected[] = {0x80,0x81,0xEA,0x52,0xA8,0x90,0x09,0x5B,0x9A,0x00,0x00};    
    const char chineseTxtNoAccess[] = {0x80,0x65,0xE0,0x6C,0xD5,0x8F,0xDB,0x51,0x65,0x00,0x00};
    const char chineseTxtNoNetworksAvailable[] = {0x80,0x65,0xE0,0x7F,0x51,0x7E,0xDC,0x00,0x00};
    const char chineseTxtEnterNewPIN2[] =  {0x80,0x65,0xB0,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x00,0x32,0x00,0x00};
    const char chineseTxtChPIN[] = {0x80,0x4F,0xEE,0x65,0x39,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x00};
    const char chineseTxtChPIN2[] = {0x80,0x4F,0xEE,0x65,0x39,0x00,0x50,0x00,0x49,0x00,0x4E,0x00,0x32,0x00,0x00};
    const char chineseTxtAttempts[] = {0x80,0x65,0x3E,0x5F,0x03,0x5C,0x1D,0x8B,0xD5,0x00,0x00};
    const char chineseTxtMidSaved[] = {0x80,0x5D,0xF1,0x50,0xA8,0x5B,0x58,0x00,0x00};
    const char chineseTxtPressCToConfirm[] = {0x80,0x63,0x09,0x00,0x43,0x95,0x2E,0x78,0x6E,0x5B,0x9A,0x00,0x00};
    const char chineseTxtCallFailed[] = {0x80,0x62,0xE8,0x53,0xD1,0x59,0x31,0x8D,0x25,0x00,0x00};
    const char chineseTxtTune1[] = {0x80,0x8C,0x03,0x65,0x74,0x00,0x20,0x00,0x31,0x00,0x00};
    const char chineseTxtTune2[] = {0x80,0x8C,0x03,0x65,0x74,0x00,0x20,0x00,0x32,0x00,0x00}; 
    const char chineseTxtTune3[] = {0x80,0x8C,0x03,0x65,0x74,0x00,0x20,0x00,0x33,0x00,0x00}; 
    const char chineseTxtTune4[] = {0x80,0x8C,0x03,0x65,0x74,0x00,0x20,0x00,0x34,0x00,0x00}; 
    const char chineseTxtTune5[] = {0x80,0x8C,0x03,0x65,0x74,0x00,0x20,0x00,0x35,0x00,0x00};
    const char chineseTxtSelectLevel[] = {0x80,0x7E,0xA7,0x52,0x2B,0x90,0x09,0x62,0xE9,0x00,0x00};
    const char chineseTxtNewGame[] = {0x80,0x65,0xB0,0x6E,0x38,0x62,0x0F,0x00,0x00};
    const char chineseTxtFriend[] = {0x80,0x67,0x0B,0x53,0xCB,0x00,0x00};
    const char chineseTxtDemo[] = {0x80,0x6F,0x14,0x79,0x3A,0x00,0x00};
    const char chineseTxtSelectMode[] = {0x80,0x5F,0x62,0x5F,0x0F,0x00,0x00};
    const char chineseTxtBattery[] = {0x80,0x75,0x35,0x6C,0x60,0x00,0x00};
    const char chineseTxtFully[] = {0x80,0x6E,0xE1,0x00,0x00};
    const char chineseTxtCharged[] = {0x80,0x51,0x45,0x75,0x35,0x00,0x00};
    const char chineseTxtRemaining[] = {0x80,0x52,0x69,0x4F,0x59,0x00,0x00};
    const char chineseTxtIngoingMinutes[] = {0x80,0x59,0x16,0x63,0x02,0x52,0x06,0x94,0x9F,0x00,0x00};
    const char chineseTxtCreditLimit[] = {0x80,0x5B,0x58,0x6B,0x3E,0x96,0x50,0x5E,0xA6,0x00,0x00};
    const char chineseTxtSendTo[] = {0x80,0x53,0xD1,0x90,0x01,0x52,0x30,0x00,0x00};
    const char chineseTxtOnce[] = {0x80,0x4E,0x00,0x6B,0x21,0x00,0x00};
    const char chineseTxtDaily[] = {0x80,0x6B,0xCF,0x65,0xE5,0x00,0x00};
    const char chineseTxtWeekdays[] = {0x80,0x5D,0xE5,0xCF,0x5C,0x65,0xE5,0x00,0x00};
    const char chineseTxtWeekly[] = {0x80,0x6B,0xCF,0x66,0xEF,0x67,0x1F,0x00,0x00};
    const char chineseTxtMonthly[] = {0x80,0x6B,0xCF,0x67,0x08,0x00,0x00};
    const char chineseTxtYearly[] = {0x80,0x6B,0xCF,0x5E,0x74,0x5E,0x74,0x00,0x00};
    const char chineseTxtEnterText[] = {0x80,0x8F,0x93,0x51,0x65,0x65,0x87,0x5B,0x57,0x00,0x00};
    const char chineseTxtStartTime[] = {0x80,0x5F,0x00,0x59,0xCB,0x65,0xF6,0x95,0xF4,0x00,0x00};
    const char chineseTxtEndTime[] = {0x80,0x7E,0xD3,0x67,0x5F,0x65,0xF6,0x95,0xF4,0x00,0x00};
    const char chineseTxtAlarmOffset[] = {0x80,0x00,0x55,0x00,0x6E,0x00,0x6B,0x00,0x6E,0x00,0x6F,0x00,0x77,0x00,0x6E,0x00,0x00};
    const char chineseTxtAlarmRepeat[] = {0x80,0x91,0xCD,0x59,0x0D,0x95,0xF9,0x94,0xC3,0x00,0x00};
    const char chineseTxtIcon[] = {0x80,0x63,0xD2,0x75,0x3B,0x00,0x00};
    const char chineseTxtDeleteEntry[] = {0x80,0x52,0x20,0x96,0x94,0x8F,0x93,0x51,0x65,0x00,0x00};
    const char chineseTxtMonday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x4E,0x00,0x00,0x00};
    const char chineseTxtTuesday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x4E,0x8C,0x00,0x00};
    const char chineseTxtWednesday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x4E,0x09,0x00,0x00};
    const char chineseTxtThursday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x56,0xDB,0x00,0x00};
    const char chineseTxtFriday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x4E,0x94,0x00,0x00};
    const char chineseTxtSaturday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x51,0x6D,0x00,0x00};
    const char chineseTxtSunday[] = {0x80,0x6B,0xCF,0x66,0xEF,0x65,0xE5,0x00,0x00};
    const char chineseTxtGoto[] = {0x80,0x53,0xBB,0x00,0x00};
    const char chineseTxtListAll[] = {0x80,0x5C,0x55,0x79,0x3A,0x51,0x68,0x90,0xE8,0x00,0x00};
    const char chineseTxtSetDateTime[] = {0x80,0x8B,0xBE,0x5B,0x9A,0x65,0xE5,0x67,0x1F,0x65,0xF6,0x95,0xF4,0x00,0x00};
    const char chineseTxtAlarm_5[] = {0x80,0x63,0xD0,0x52,0x4D,0x00,0x35,0x52,0x06,0x94,0x9F,0x00,0x00}; 
    const char chineseTxtAlarm_10[] = {0x80,0x63,0xD0,0x52,0x4D,0x00,0x31,0x00,0x30,0x52,0x06,0x94,0x9F,0x00,0x00};
    const char chineseTxtAlarm_15[] = {0x80,0x63,0xD0,0x52,0x4D,0x00,0x31,0x00,0x35,0x52,0x06,0x94,0x9F,0x00,0x00};
    const char chineseTxtAlarm_60[] = {0x80,0x63,0xD0,0x52,0xD4,0x00,0x36,0x00,0x30,0x52,0x06,0x94,0x9F,0x00,0x00};
    const char chineseTxtBeep[] = {0x80,0x8B,0x66,0x7B,0x1B,0x58,0xF0,0x00,0x00};
    const char chineseTxtPressOKToConfirm[] = {0x80,0x63,0x09,0x00,0x4F,0x00,0x4B,0x78,0x6E,0x5B,0x9A,0x00,0x00};
    const char chineseTxtNwLogOff[] = {0x80,0x90,0x00,0x5C,0x80,0x57,0x51,0x7E,0xDC,0x00,0x00};
    const char chineseTxtNwLogOn[] = {0x80,0x8F,0xDB,0x51,0x65,0x57,0x51,0x7E,0xDC,0x00,0x00};
    const char chineseTxtIncorrect[] = {0x80,0x95,0x19,0x8B,0xEF,0x00,0x00};
    const char chineseTxtPUK2[] = {0x80,0x00,0x50,0x00,0x55,0x00,0x4B,0x00,0x32,0x00,0x00};
    const char chineseTxtPause[] = {0x80,0x66,0x82,0x50,0x5C,0x00,0x00};
    const char chineseTxtMore[] = {0x80,0x59,0x1A,0x00,0x00};
    const char chineseTxtNotOk[] = {0x80,0x4E,0x0D,0x00,0x00};
   const char chineseTxtUSSD[] = {0x80,0x00,0x55,0x00,0x53,0x00,0x53,0x00,0x44,0x00,0x00};
    const char chineseTxtSearchNumber[] = {0x80,0x67,0xE5,0x5B,0xFB,0x53,0xF7,0x78,0x01,0x00,0x00};
    const char chineseTxtSearchLocation[] = {0x80,0x67,0xE5,0x5B,0xFB,0x57,0x30,0x57,0x40,0x00,0x00};
    const char chineseTxtVMCenter[] = {0x80,0x8F,0x93,0x51,0x65,0x00,0x56,0x00,0x4D,0x4E,0x2D,0x5F,0xC3,0x00,0x00};
    const char chinesexTxtPUK2[] = {0x80,0x00,0x50,0x00,0x55,0x00,0x4B,0x00,0x32,0x00,0x00};
	const char chineseTxtMax[] = {0x80,0x67,0x00,0x59,0x1A,0x00,0x00};
	const char chineseTxtBufferFull[]= "\x80\x5d\xf2\x8f\x93\x51\x65\x76\x84\x5b\x57\x7b\x26\x59\x2a\x59\x1a\xff\x0c\x65\xe0\x6c\xd5\x8f\x93\x51\x65\x6c\x49\x5b\x57\xff\x01\x00";
    const char chineseAddNewCall[] = "\x80\x65\xb0\x62\xe8\x75\x35\x8b\xdd\x00\x00";///²绰//zy Mobile Innovation 01/08/02 
    const char chineseEndOne[] = "\x80\x7e\xd3\x67\x5f\x4e\x00\x65\xb9\x00\x00" ;///һ//zy Mobile Innovation 01/08/02 
    const char chineseCallMenu[]= "\x80\x54\x7c\x53\xeb\x83\xdc\x53\x55\x00\x00" ;///в˵//zy Mobile Innovation 23/09/02
/*..........................................zy change for idle and setting 04/08/02....................................*/
    const char chineseBackgroud[] = "\x80\x58\x99\x7e\xb8\x00\x00";	///ǽֽ	//sunsj030918
    const char chineseSelectBackgroud[]		= "\x80\x90\x09\x62\xe9\x58\x99\x7e\xb8\x00\x00" ;	//ѡǽֽ
    const char chineseBackgroundDisabled[]	= "\x80\x51\x73\x95\xed\x58\x99\x7e\xb8\x00\x00" ;	//رǽֽ
    const char chineseA[] = "\x80\x56\xfe\x72\x47\x00\x31\x00\x00" ;	///ûͼƬ1
    const char chineseB[]= "\x80\x56\xfe\x72\x47\x00\x32\x00\x00" ;	///ûͼƬ2
    const char chineseUserdefine[] = "\x80\x75\x28\x62\x37\x5b\x9a\x4e\x49\x00\x00" ;	///û
    const char chineseUserdefine1[]="\x80\x56\xfe\x72\x47\x00\x33\x00\x00" ;	///ûͼƬ3
    const char chineseUserdefine2[]="\x80\x56\xfe\x72\x47\x00\x34\x00\x00" ;	///ûͼƬ4
    const char chineseUserdefine3[]="\x80\x56\xfe\x72\x47\x00\x35\x00\x00" ;	///ûͼƬ5
    const char chineseUserdefine4[]="\x80\x56\xfe\x72\x47\x00\x36\x00\x00" ;	///ûͼƬ6
    const char chineseUserdefine5[]="\x80\x56\xfe\x72\x47\x00\x37\x00\x00" ;	///ûͼƬ7
    const char chineseUserDefinedPic[]="\x80\x75\x28\x62\x37\x81\xea\x8b\xbe\x56\xfe\x72\x47\x00\x00";//chenjun 2002-12-29 add for user defined pic, PCSync 
    const char chineseNoUserPic[]="\x80\x65\xe0\x56\xfe\x72\x47\x00\x00";  //chenjun add 2003-01-14 for user defined picture
    const char chineseRename[] = "\x80\x91\xcd\x54\x7d\x54\x0d\x00\x00";	///
    const char chineseAdjustContrast[]="\x80\x5b\xf9\x6b\xd4\x5e\xa6\x8c\x03\x82\x82\x00\x00" ;	//Աȶȵ
    const char chineseOnOffAnimation[] =  "\x80\x5f\x00\x51\x73\x67\x3a\x52\xa8\x75\x3b\x00\x00";	///ػ
    const char chineseBacklight[] = "\x80\x80\xcc\x51\x49\x00\x00\x00" ;	///
    const char chineseBmpAlbum[] = "\x80\x56\xfe\x72\x47\x5e\x93\x00\x00" ;	///ͼƬ
    const char chineseGreetingWord[] = "\x80\x5f\x85\x67\x3a\x95\xee\x50\x19\x8b\xed\x00\x00" ;	///ʺ
    const char chineseDisplaySetting[]= "\x80\x66\x3e\x79\x3a\x8b\xbe\x7f\x6e\x00\x00" ;	///ʾ
    const char chineseBacklightOnTime[] = "\x80\x80\xcc\x51\x49\x5f\x00\x54\x2f\x65\xf6\x95\xf4\x00\x00" ;	///⿪ʱ
    const char chineseBacklightOffTime[] = "\x80\x80\xcc\x51\x49\x51\x73\x95\xed\x65\xf6\x95\xf4\x00\x00" ;	///رʱ
    const char chineseBacklightIntensity[] = "\x80\x80\xcc\x51\x49\x5f\x3a\x5e\xa6\x00\x00" ;	///ǿ
    const char chineseSavingSetting[] = "\x80\x77\x01\x75\x35\x8b\xbe\x7f\x6e\x00\x00" ;	///ʡ
    const char chineseGreetingWordOn[] = "\x80\x95\xee\x50\x19\x8b\xed\x5f\x00\x00\x00" ;	///ʺ￪
    const char chineseGreetingWordOff[] = "\x80\x95\xee\x50\x19\x8b\xed\x51\x73\x00\x00" ;	///ʺ 
    const char chineseEditGreetingWord[] ="\x80\x7f\x16\x8f\x91\x95\xee\x50\x19\x8b\xed\x00\x00" ;	///༭ʺ
    const char chineseMobileInnovation[] = "\x80\x64\x69\x52\x1b\x00\x00" ;	///Ħ
    const char chineseFlower[] = "\x80\x82\xb1\x5f\x00\x00\x00" ;	///
    const char chineseSkyrocket[] = "\x80\x70\xdf\x82\xb1\x00\x00" ;	///̻
    const char chineseRabbit[]=  "\x80\x51\x54\x5b\x50\x00\x00" ;	///
    const char chineseSavingMode[] = "\x80\x77\x01\x75\x35\x6a\x21\x5f\x0f\x00\x00" ;	///ʡģʽ
    const char chineseNormalMode[] = "\x80\x6b\x63\x5e\x38\x6a\x21\x5f\x0f\x00\x00" ;///ģ
    const char chineseTxtScience[] ="\x80\x79\xd1\x5b\x66\x00\x00" ;	///ѧ
    const char chineseTxtSensibility[]="\x80\x60\xc5\x61\x1f\x00\x00" ;	///
    const char chineseTxtTravel[] ="\x80\x65\xc5\x88\x4c\x00\x00" ;	///
    const char chineseTxtPerson[]="\x80\x4e\xba\x72\x69\x00\x00" ;	///
    const char chineseTxtSport[]="\x80\x8f\xd0\x52\xa8\x00\x00" ;	///˶
    const char chineseTxtRelax[]="\x80\x4f\x11\x95\xf2\x00\x00" ;	///
    const char chineseTxtMusic[]="\x80\x97\xf3\x4e\x50\x00\x00" ;	///
    const char chinese1[]="\x80\x56\xfe\x72\x47\x00\x31\x00\x00" ;	///ͼƬ1 
    const char chinese2[]="\x80\x56\xfe\x72\x47\x00\x32\x00\x00" ;	///ͼƬ2
    const char chinese3[]="\x80\x56\xfe\x72\x47\x00\x33\x00\x00" ;	///ͼƬ3
    const char chinese4[]="\x80\x56\xfe\x72\x47\x00\x34\x00\x00" ;	///ͼƬ4
    const char chinese5[]="\x80\x56\xfe\x72\x47\x00\x35\x00\x00" ;	///ͼƬ5
    const char chinese6[]="\x80\x56\xfe\x72\x47\x00\x36\x00\x00" ;	///ͼƬ6
    const char chinese7[]="\x80\x56\xfe\x72\x47\x00\x37\x00\x00" ;	///ͼƬ7
    const char chinese8[]="\x80\x56\xfe\x72\x47\x00\x38\x00\x00" ;	///ͼƬ8
    const char chinese9[]="\x80\x56\xfe\x72\x47\x00\x39\x00\x00" ;	///ͼƬ9
    const char chinese10[]="\x80\x56\xfe\x72\x47\x00\x31\x00\x30\x00\x00" ;	///ͼƬ10
    const char chinesehandsetsetting[]="\x80\x62\x4b\x67\x3a\x8b\xbe\x7f\x6e\x00\x00" ;	///ֻ
  
/*.....................................2003.10.22 wyj תӲ˵޸...........................*/

	const char chineseTxtOpenDivert[] = "\x80\x62\x53\x5f\x00\x8f\x6c\x63\xa5\x00\x00";//ת
	const char chineseTxtCloseDivert[] = "\x80\x51\x73\x95\xed\x8f\x6c\x63\xa5\x00\x00";//رת
	
	const char chineseTxtLimitedService[] = {0x80, 0x96, 0x50, 0x52, 0x36, 0x67, 0x0d, 0x52, 0xa1, 0x00, 0x00};//Ʒ 
	const char chineseTxtCallDuration[] = "\x80\x8b\xa1\x65\xf6\x7e\xdf\x8b\xa1\x00\x00";//ʱͳ
    const char chineseTxtAocStatistics[] = "\x80\x8d\x39\x75\x28\x7e\xdf\x8b\xa1\x00\x00";/* 2003/10/28, wangyan, modify AOC statistics menu*/	
    const char chineseTxtInvalidService[] = "\x80\x6b\x64\x67\x0d\x52\xa1\x65\xe0\x65\x48\x00\x00"; /* 2003/11/23, glowing add ˷Ч */

//2004.1.13 WYJ add On&Off ring
	const char chineseTxtOnRing[] = "\x80\x5f\x00\x67\x3a\x94\xc3\x58\xf0\x00\x00"; // 
	const char chineseTxtOffRing[] = "\x80\x51\x73\x67\x3a\x94\xc3\x58\xf0\x00\x00"; //ػ
//end of 2004.1.13 WYJ add On&Off ring

//2004.2.12 WYJ add Hall On&Off ring
	const char chineseTxtHallOnRing[] = "\x80\x5f\x00\x76\xd6\x94\xc3\x58\xf0\x00\x00"; // 
	const char chineseTxtHallOffRing[] = "\x80\x51\x73\x76\xd6\x94\xc3\x58\xf0\x00\x00"; //ظ
//end of 2004.2.12 WYJ add Hall On&Off ring

const char chineseTxtToolkit[] = "\x80\x5d\xe5\x51\x77\x7b\xb1\x00\x00";
const char chineseTxtCamera[] = "\x80\x71\x67\x76\xf8\x67\x3a\x00\x00";
const char chineseTxtSeparately[]="\x80\x52\x06\x52\x2b\x8b\xa1\x65\xf6\x00\x00";
const char chineseTxtBycircle[]="\x80\x4e\xe5\x57\x08\x8b\xa1\x65\xf6\x00\x00";
const char chineseTxtBrowseRecord[]="\x80\x6d\x4f\x89\xc8\x8b\xb0\x5f\x55\x00\x00";
const char chineseTxtContinue[]={0x80,0x7e,0xe7,0x7e,0xed,0x8b,0xa1,0x65,0xf6,0x00,0x00,0x00};
const char chineseTxtRestart[]="\x80\x91\xcd\x65\xb0\x8b\xa1\x65\xf6\x00\x00";
const char chineseTxtNorecord[]="\x80\x65\xe0\x8b\xb0\x5f\x55\x00";
const char chineseTxtConfirm[]="\x80\x78\x6e\x5b\x9a\x00\x00";
const char chineseTxtOnebyone[]="\x80\x90\x10\x4e\x2a\x52\x20\x96\x64\x00\x00";
const char chineseTxtDeleteError[]="\x80\x52\x20\x96\x64\x51\xfa\x95\x19\x00\x00";
const char chineseTxtSaveError[]="\x80\x5b\x58\x50\xa8\x95\x19\x8b\xef\x00\x00";
const char chineseTxtTimer[]="\x80\x5b\x9a\x65\xf6\x56\x68\x00\x00";
const char chineseTxtSetontime[]="\x80\x8f\x93\x51\x65\x5f\x00\x67\x3a\x65\xf6\x95\xf4\x00\x00";
const char chineseTxtOpen[]="\x80\x5f\x00\x54\x2f\x00\x00";
const char chineseTxtClose[]="\x80\x51\x73\x95\xed\x00\x00";
const char chineseTxtSettime[]="\x80\x8b\xbe\x5b\x9a\x5b\x9a\x65\xf6\x65\xf6\x95\xf4\x00\x00";
const char chineseTxtLefttime[]="\x80\x79\xbb\x62\x40\x5b\x9a\x65\xf6\x95\xf4\x8f\xd8\x52\x69\x00\x00";
const char chineseTxtStart[]="\x80\x54\x2f\x52\xa8\x00\x00";
const char chineseTxtTimeup[]="\x80\x5b\x9a\x65\xf6\x65\xf6\x95\xf4\x52\x30\x00\x00";
const char chineseTxtAutopower[]="\x80\x81\xea\x52\xa8\x5f\x00\x51\x73\x67\x3a\x00\x00";
const char chineseTxtOpentime[]="\x80\x8f\x93\x51\x65\x5f\x00\x67\x3a\x65\xf6\x95\xf4\x00\x00";
const char chineseTxtClosetime[]="\x80\x8f\x93\x51\x65\x51\x73\x67\x3a\x65\xf6\x95\xf4\x00\x00";
const char chineseTxtNote[]="\x80\x5f\x85\x52\x9e\x4e\x8b\x98\x79\x00\x00"; 
const char chineseTxtNotebrowse[]="\x80\x67\xe5\x77\x0b\x00\x00";
const char chineseTxtAdd[]="\x80\x58\x9e\x52\xa0\x00\x00";
const char chineseTxtChpriority[]="\x80\x65\x39\x53\xd8\x4f\x18\x51\x48\x7e\xa7\x00\x00";
const char chineseTxtToschedule[]="\x80\x5b\x58\x4e\x3a\x65\xe5\x7a\x0b\x00\x00";
const char chineseTxtTomessage[]="\x80\x53\xd1\x77\xed\x4f\xe1\x00\x00";
const char chineseTxtFre_Once[]="\x80\x4e\x00\x6b\x21\x00\x00";
const char chineseTxtDay[]="\x80\x6b\xcf\x59\x29\x00\x00";
const char chineseTxtWeek[]="\x80\x6b\xcf\x54\x68\x00\x00";
const char chineseTxtMonth[]="\x80\x6b\xcf\x67\x08\x00\x00";
const char chineseTxtYear[]="\x80\x6b\xcf\x5e\x74\x00\x00";
const char chineseTxtRing[]="\x80\x52\xa0\x95\xf9\x94\x9f\x54\x17\x00\x00";
const char chineseTxtSchedule[]="\x80\x65\xe5\x7a\x0b\x7b\xa1\x74\x06\x00\x00";
	/*talcon add for pcsyn,2004.07.06*/
#ifdef MMI_PCSYN_ENABLED
const char chineseTxtPCSyn[]="\x80\x00\x50\x00\x43\x54\x0c\x6b\x65\x00\x00";
#endif
const char chineseTxtWeekDay[]="\x80\x65\xe5\x4e\x00\x4e\x8c\x4e\x09\x56\xdb\x4e\x94\x51\x6d\x00\x00";
const char chineseTxtNewSche[]="\x80\x65\xb0\x65\xe5\x7a\x0b\x00\x00";
const char chineseTxtToday[]="\x80\x5f\x53\x59\x29\x65\xe5\x7a\x0b\x00\x00";
const char chineseTxtAllSche[]="\x80\x51\x68\x90\xe8\x65\xe5\x7a\x0b\x00\x00";
const char chineseTxtDeleteOld[]="\x80\x52\x20\x96\x64\x5d\xf2\x8f\xc7\x65\xe5\x7a\x0b\x00\x00";
const char chineseTxtScheMeeting[]="\x80\x4f\x1a\x8b\xae\x00\x00";
const char chineseTxtBirthday[]="\x80\x75\x1f\x65\xe5\x00\x00";
const char chineseTxtAppointment[]="\x80\x7e\xa6\x4f\x1a\x00\x00";
const char chineseTxtRemind[]="\x80\x63\xd0\x91\x92\x00\x00";
const char chineseTxtReConfirm[]="\x80\x78\x6e\x5b\x9a\x54\x17\x00\x00";
const char chineseInputError[]="\x80\x8f\x93\x51\x65\x95\x19\x8b\xef\x00\x00";
const char chineseTxtResult[]="\x80\x7e\xd3\x67\x9c\x00\x00";
const char chineseTxtDeleteOnebyOne[]="\x80\x90\x10\x4e\x2a\x52\x20\x96\x64\x00\x00";
const char chineseTxtConversion[]="\x80\x53\x55\x4f\x4d\x63\x62\x7b\x97\x00\x00";
const char chineseTxtLength[]="\x80\x95\x7f\x5e\xa6\x00\x00";
const char chineseTxtAcre[]="\x80\x97\x62\x79\xef\x00\x00";
const char chineseVolume[]="\x80\x4f\x53\x79\xef\x00\x00";
const char chineseWeight[]="\x80\x91\xcd\x91\xcf\x00\x00";
const char chineseInitValue[]="\x80\x52\x1d\x59\xcb\x50\x3c\x00\x00";
const char chineseResultValue[]="\x80\x8f\x6c\x63\x62\x50\x3c\x00\x00";
const char chineseNext[]="\x80\x52\x36\x5f\x0f\x52\x07\x63\x62\x00\x00";
const char chineseOverflow[]="\x80\x6e\xa2\x51\xfa\x00\x00";
const char chineseCall[]="\x80\x8b\xf7\x81\xf4\x75\x35\xff\x1a\x00\x00";
const char chineseUnitchange[]="\x80\x53\x55\x4f\x4d\x52\x07\x63\x62\x00\x00";
const char chineseTxtStroke[]="\x80\x65\x74\x70\xb9\x62\xa5\x65\xf6\x00\x00";
const char chineseTxtYMD[]="\x80\x5e\x74\x00/\x67\x08\x00/\x65\xe5\x00\x00";
const char chineseTxtBrowseAlarm[]="\x80\x67\xe5\x77\x0b\x72\xb6\x60\x01\x00\x00";
const char chineseTxtAutoOff[]="\x80\x81\xea\x52\xa8\x51\x73\x67\x3a\x54\x2f\x52\xa8\x00\x00";
const char chineseTxtAutoConfirm[]="\x80\x66\x2f\x54\x26\x51\x73\x67\x3a\x00\x00";
const char chineseTxtScheSMS[]="\x80\x8f\x6c\x53\xd1\x4e\x3a\x77\xed\x4f\xe1\x00\x00";
const char chineseTxtTooLong[]="\x80\x6d\x88\x60\x6f\x59\x2a\x95\x7f\x00\x00";
const char chineseTxtMemo[]="\x80\x59\x07\x5f\xd8\x5f\x55\x00\x00";
const char chineseTxtCover[]="\x80\x89\x86\x76\xd6\x7b\x2c\x4e\x00\x67\x61\x00\x00";
const char chineseTxtAddMemo[]="\x80\x6d\xfb\x52\xa0\x59\x07\x5f\xd8\x5f\x55\x00\x00";
 /***********************************tangyan add it ******************************************/
 const char chineseTxtGamestart[] ="\x80\x5f\x00\x59\xcb\x6e\x38\x62\x0f\x00\x00" ;	///ʼϷ
 //2004-04-02 Sunny add
 const char chineseTxtGameStageCruTtl[]="\x80\x5f\x53\x52\x4d\x00\x2f\x60\x3b\x51\x71\x00\x00";//ǰ/ܹ
 const char chineseTxtGameStageInput[]="\x80\x8f\x93\x51\x65\x51\x73\x65\x70\x00\x00";//
 //2004-04-02 Sunny add end
 const char chineseTxtGameedit[] = "\x80\x7f\x16\x8f\x91\x6e\x38\x62\x0f\x00\x00" ;	///༭Ϸ
const char chineseTxtGameselect[] = "\x80\x90\x09\x62\xe9\x6e\x38\x62\x0f\x00\x00" ;	///ѡϷ
const char chineseTxtGamesetting[] = "\x80\x6e\x38\x62\x0f\x8b\xbe\x7f\x6e\x00\x00" ;	///Ϸ
const char chineseTxtGamehelp[] = "\x80\x6e\x38\x62\x0f\x5e\x2e\x52\xa9\x00\x00" ;	///Ϸ
const char chineseTxtGamescore[]="\x80\x79\xef\x52\x06\x69\x9c\x00";	   //4 ְ
const char chineseTxtGamerestart[]="\x80\x91\xcd\x65\xb0\x5f\x00\x59\xcb\x00";	//4 ¿ʼ
const char chineseTxtGameExit[]="\x80\x90\x00\x51\xfa\x00";	//4 ˳
const char chineseTxtGamegoon[]="\x80\x7e\xe7\x7e\xed\x00";	//4
const char chineseTxtBoxmangame[] = "\x80\x63\xa8\x7b\xb1\x5b\x50\x00\x00" ;	///
const char chineseTxtSnakegame[] = "\x80\x8d\x2a\x54\x03\x86\xc7\x00\x00";//̰
const char chineseTxtBalloongame[]="\x80\x62\x53\x6c\x14\x74\x03\x00\x00" ;	///
const char chineseTxtRussiagame[]="\x80\x4f\xc4\x7f\x57\x65\xaf\x65\xb9\x57\x57\x00";	///˹
const char chineseTxtClearall[]="\x80\x6e\x05\x96\x64\x8b\xb0\x5f\x55\x00";
const char chineseTxtFlashErr[]="\x80\x00\x46\x00\x4c\x00\x41\x00\x53\x00\x48\x51\xfa\x95\x19\xff\x01\x00\x00";	///FLASH
const char chineseTxtGame[] = "\x80\x6e\x38\x62\x0f\x00\x00";
const char chineseTxtSuoha[] = "\x80\x68\xad\x54\xc8\x00\x00";
const char chineseTxtSuohaNew[] = "\x80\x65\xb0\x6e\x38\x62\x0f\x00\x00" ;	///Ϸ//zhangzg 08/14/2002
const char chineseTxtSuohaPre[] = "\x80\x4e\x0a\x4e\x00\x6b\x21\x00\x00" ;	///һ//zhangzg 08/14/2002
const char chineseTxtShortCutMenu[]="\x80\x5f\xeb\x63\x77\x83\xdc\x53\x55\x00\x00";
const char chineseTxtFunctionSelect[]="\x80\x52\x9f\x80\xfd\x90\x09\x62\xe9\x00\x00";
const char chineseTxtDeleteAllFunctions[]="\x80\x78\x6e\x5b\x9a\x52\x20\x96\x64\x62\x40\x67\x09\x52\x9f\x80\xfd\x98\x79\x54\x17\x00?\x00\x00";	///ɾй?
const char chineseTxtHallOnConnect[]="\x80\x7f\xfb\x76\xd6\x63\xa5\x54\x2c\x00\x00";	///ǽ
const char chineseTxtLedControl[]="\x80\x63\x07\x79\x3a\x70\x6f\x8b\xbe\x7f\x6e\x00\x00" ;	///ָʾ
const char chineseTxtIncomingFax[] = { 'I',0x00,'n',0x00,'c',0x00,'o',0x00,'m',0x00,'i',0x00,'n',0x00,'g',0x00,' ',0x00,'F',0x00,'a',0x00,'x',0x00,0x00}; //SPR#1147 - DS - Added string for incoming fax.
const char chineseTxtSRR[] = { 0x00,'S',0x00,'t',0x00,'a',0x00,'t',0x00,'u',0x00,'s',0x00,' ',0x00,'R',0x00,'e',0x00,'p',0x00,'o',0x00,'r',0x00,'t',0x00,0x00 }; // Marcus: Issue 1170: 30/09/2002
const char chineseTxtDelivered[] = { 0x00,'D',0x00,'e',0x00,'l',0x00,'i',0x00,'v',0x00,'e',0x00,'r',0x00,'e',0x00,'d',0x00,0x00 }; // Marcus: Issue 1170: 07/10/2002
const char chineseTxtTempError[] = { 0x00,'T',0x00,'e',0x00,'m',0x00,'p',0x00,'.',0x00,' ',0x00,'E',0x00,'r',0x00,'r',0x00,'o',0x00,'r',0x00, 0x00 }; // Marcus: Issue 1170: 07/10/2002

const char chineseTxtRejectCalls[]="\x80\x62\xd2\x63\xa5\x75\x35\x8b\xdd\x00\x00";	///ܽӵ绰hu binhao 2002-11-22
const char chineseTxtIncomingCallTime[]="\x80\x67\x65\x75\x35\x65\xf6\x95\xf4\x00\x3a\x00\x00";	///ܽӵ绰hu binhao 2002-11-22
const char chineseTxtDialTime[]="\x80\x62\xe8\x62\x53\x65\xf6\x95\xf4\x00\x3a\x00\x00";	///ܽӵ绰hu binhao 2002-11-22
const char chineseTxtName[]="\x80\x59\xd3\x54\x0d\x00\x3a\x00\x00";	///ܽӵ绰hu binhao 2002-11-22
const char chineseTxtNumberShow[]="\x80\x53\xf7\x78\x01\x00\x3a\x00\x00";	///ܽӵ绰hu binhao 2002-11-22
const char chineseTXTNoRecentNumber[]="\x80\x65\xe0\x8f\xd1\x67\x1f\x75\x35\x8b\xdd\x00\x00";	///hu binhao 2002-12-3
const char chineseTxtEnterDivertNumber[]="\x80\x8f\x6c\x79\xfb\x53\xf7\x78\x01\x00\x3a\x00\x00";         //תƺhu binhao 2002-12-17 for fix 5109 bug:
const char chineseTxTMakeSureTimeReset[]="\x80\x6e\x05\x96\xf6\x54\x17\x00\x00";         ////hu binhao 2002 12-26 
const char chineseTxtHaveReset[]="\x80\x5d\xf2\x6e\x05\x96\xf6\x00\x00";         ////hu binhao 2003-1-17 
const char chineseTxtonlinefunction[]="\x80\x57\x28\x7e\xbf\x52\x9f\x80\xfd\x88\x68\x00\x00" ;	///߹ܱ	///zhaowm 2002.12.15
const char chineseTxtnotitle[]="\x80\x65\xe0\x4e\x3b\x98\x98\x00\x00" ;	///	///zhaowm 2002.12.15
const char chineseTxtnoGPRSservice[]="\x80\x65\xe0\x00\x47\x00\x50\x00\x52\x00\x53\x4e\x1a\x52\xa1\x00\x00" ;	///GPRSҵ
const char chineseTxtTxtRange[]="\x80\x83\x03\x56\xf4\x00\x00" ;	///Χ

const char chinese5sec[]="\x80\x00\x35\x79\xd2\x00\x00" ;	///5
const char chinese10sec[]="\x80\x00\x31\x00\x30\x79\xd2\x00\x00" ;	///10
const char chinese15sec[]="\x80\x00\x31\x00\x35\x79\xd2\x00\x00" ;	///15
const char chinese20sec[]="\x80\x00\x32\x00\x30\x79\xd2\x00\x00" ;	///20
const char chinese25sec[]="\x80\x00\x32\x00\x35\x79\xd2\x00\x00" ;	///25
const char chinese30sec[]="\x80\x00\x33\x00\x30\x79\xd2\x00\x00" ;	///30
const char chineseCFTime[]="\x80\x8f\x6c\x79\xfb\x65\xf6\x95\xf4\x00\x00" ;	///תʱ
const char chineseTxtfunction[]="\x80\x52\x9f\x80\xfd\x88\x68\x00\x00" ;	///ܱTxtdisconnectionbrow
const char chineseTxtdisconnectionbrow[]="\x80\x65\xad\x5f\x00\x8f\xde\x63\xa5\x00\x00" ;	///Ͽ
const char chineseTxtSOFTBACK[]="\x80\x54\x0e\x90\x00\x00\x00" ;	///
const char chineseTxtLIST[]="\x80\x52\x17\x88\x68\x00\x00" ;	///б
const char chineseShowDetail[]		=	{"\x80\x8b\xe6\x60\xc5\x00\x00"};			//
const char chineseAddVoiceDial[]={"\x80\x6d\xfb\x52\xa0\x8b\xed\x97\xf3\x62\xe8\x53\xf7\x00\x00"};//
const char chineseVoiceDialFull[]={"\x80\x8b\xed\x97\xf3\x8b\xb0\x5f\x55\x5d\xf2\x6e\xe1\x00\x00"};//¼
const char chineseNoVoiceDial[]={"\x80\x65\xe0\x8b\xed\x97\xf3\x8b\xb0\x5f\x55\x00\x00"};//δ¼
const char chineseModifyVoiceDial[]={"\x80\x4f\xee\x65\x39\x8b\xed\x97\xf3\x62\xe8\x53\xf7\x00\x00" };//޸
const char chineseStartEnroll[]={"\x80\x51\xc6\x59\x07\x5f\x55\x51\x65\x8b\xed\x97\xf3\x00\x00"};//ʼ¼
const char chineseEnrolling[]={"\x80\x6b\x63\x57\x28\x5f\x55\x51\x65\x8b\xed\x97\xf3\x00\x00"};//¼
const char chineseEnrollSucess[]={"\x80\x5f\x55\x51\x65\x62\x10\x52\x9f\x00\x00"};// ¼ɹ
const char chinesePlayingNow[]={"\x80\x6b\x63\x57\x28\x64\xad\x65\x3e\x8b\xed\x97\xf3\x00\x00"};//ڲ
const char chineseStartUpdate[]={"\x80\x51\xc6\x59\x07\x78\x6e\x8b\xa4\x8b\xed\x97\xf3\x00\x00"};//ʼȷ
const char chineseVoiceUpdating[]={"\x80\x6b\x63\x57\x28\x78\x6e\x8b\xa4\x8b\xed\x97\xf3\x00\x00"};//ȷ
const char chineseUpdateSucess[]={"\x80\x78\x6e\x8b\xa4\x62\x10\x52\x9f\x00\x00"};//ȷϳɹ
const char chineseRecordSucess[]={"\x80\x5f\x55\x52\x36\x8b\xed\x97\xf3\x62\x10\x52\x9f\x00\x00"};//¼ɹ
const char chineseEnrollError[]={"\x80\x5f\x55\x51\x65\x95\x19\x8b\xef\x00\x00"};//¼
const char chineseEnrollOnceMore[]={"\x80\x51\x8d\x6b\x21\x5f\x55\x51\x65\x00\x00" };//ٴ¼
const char chineseUpdateError[]={"\x80\x78\x6e\x8b\xa4\x95\x19\x8b\xef\x00\x00" };//ȷϴ
const char chineseStartDial[]={"\x80\x51\xc6\x59\x07\x8b\xc6\x52\x2b\x8b\xed\x97\xf3\x00\x00" };//ʼʶ
const char chineseDialing[]={"\x80\x6b\x63\x57\x28\x8b\xc6\x52\x2b\x8b\xed\x97\xf3\x00\x00" };//ʶ
const char chineseDialOk[]={"\x80\x8b\xc6\x52\x2b\x62\x10\x52\x9f\x00\x00"};//ʶɹ
const char chineseCallReady[]={"\x80\x51\xc6\x59\x07\x62\xe8\x53\xf7\x00\x00" };//׼
const char chineseDialRedial[]={"\x80\x91\xcd\x65\xb0\x8b\xc6\x52\x2b\x00\x00" };//ʶ
const char chineseDialError[]={"\x80\x8b\xc6\x52\x2b\x59\x31\x8d\x25\x00\x00" };//ʶʧ
//tangyan add it 816
//#define LEN_LANGUAGE2 437

//2004.08.05 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
//2004-7-29 yangx Add
const char chinesePhotoFrameChoice[]={"\x80\x90\x09\x62\xe9\x76\xf8\x68\x46\x00\x00"};//ѡ
const char chinesePhotoCapacity[]={"\x80\x76\xf8\x72\x47\x5b\xb9\x91\xcf\x00\x00"};//Ƭ
const char chineseMemoryCapacity[]={"\x80\x51\x85\x5b\x58\x5b\xb9\x91\xcf\x00\x00"};//ڴ
const char chinesePhotoProperty[]={"\x80\x76\xf8\x72\x47\x5c\x5e\x60\x27\x00\x00"};//Ƭ
const char chinesePhotoSize[]={"\x80\x59\x27\x5c\x0f\x00\x00"};//С
const char chinesePhotoType[]={"\x80\x7c\x7b\x57\x8b\x00\x00"};//
//end yangx
#endif


tPointerStructure LanguageIndex_2[LEN_LANGUAGE2+1] = {
    { TxtNull,(char*)   chineseTxtNull},
    { TxtNotImplemented,(char*)   chineseTxtNotImplemented},
    { TxtManu,(char*) chineseTxtManu},
    { TxtEnterPin1,(char*)   chineseTxtEnterPin1},
    { TxtEnterPin2,(char*)   chineseTxtEnterPin2},
    { TxtEnterPuk1,(char*)   chineseTxtEnterPuk1},
    { TxtEnterPuk2,(char*)   chineseTxtEnterPuk2},
    { TxtInvalidCard,(char*)   chineseTxtInvalidCard},
    { TxtNoCard,(char*)   chineseTxtNoCard},
    { TxtSoftCall,(char*)   "\x80\x54\x7c\x53\xeb\x00"},
    { TxtSoftOK,(char*)   chineseTxtSoftOK},
    { TxtSoftMenu,(char*)   chineseTxtSoftMenu},
    { TxtHelp,(char*)   chineseTxtHelp},
    { TxtSoftContacts,(char*)   chineseTxtSoftContacts},
    { TxtPlay,(char*)   chineseTxtPlay},
    { TxtMessages,(char*)   chineseTxtMessages},
    { TxtAlarm,(char*)   chineseTxtAlarm},
    { TxtAlarmPrompt, "\x80\x95\xf9\x94\x9f\x63\xd0\x79\x3a\x00\x00" },	///ʾxsf 2002.09.24
    { TxtSettings,(char*)   chineseTxtSettings},
    { TxtExtra ,(char*)    chineseTxtExtra},
    { TxtSend ,"\x80\x53\xd1\x90\x01\x00" },	///
    { TxtSent ,(char*)    chineseTxtSent},
    { TxtNotSent ,(char*)    chineseTxtNotSent},
    { TxtServiceCentre,"\x80\x77\xed\x4f\xe1\x4e\x2d\x5f\xc3\x00" },	///
    { TxtPleaseWait,(char*)    chineseTxtPleaseWait},
    { TxtSmsEnterNumber,(char*)    chineseTxtSmsEnterNumber},
    { TxtRead,(char*)    chineseTxtRead},
    { TxtDeleteAll,(char*)    chineseTxtDeleteAll},
    { TxtSave,"\x80\x4f\xdd\x5b\x58\x00\x00" },	///
    { TxtVoicemail,(char*)    chineseTxtVoicemail},
    { TxtBroadcast,"\x80\x5c\x0f\x53\x3a\x5e\x7f\x64\xad\x00" },	///С㲥
    { TxtNew,(char*)    chineseTxtNew},
    { TxtDigits,(char*) chineseTxtDigits },
    { TxtLowercase,(char*) chineseTxtLowercase },
    { TxtUppercase,(char*) chineseTxtUppercase },
    { TxtApplications,(char*)    chineseTxtApplications},
    { TxtVoiceMemo,(char*)    chineseTxtVoiceMemo},
    { TxtSim,(char*) chineseTxtSim },
    { TxtSimNot,"\x80\x00S\x00I\x00M\x53\x61\x52\x1d\x59\xcb\x53\x16\x00" },	///SIMʼ
    { TxtNotReady,(char*) chineseTxtNotReady },
    { TxtSmsListFull,(char*)    chineseTxtSmsListFull},
    { TxtNewCbMessage,(char*)    chineseTxtNewCbMessage},
    { TxtSaved,(char*)    chineseTxtSaved},
    { TxtDelete,(char*)    chineseTxtDelete},
    { TxtReply,"\x80\x56\xde\x59\x0d\x00\x00" },	///ظ
    { TxtStoreNumber,(char*)    chineseTxtStoreNumber},
    { TxtForward,"\x80\x8f\x6c\x53\xd1\x00" },	///ת
    { TxtActivate,(char*)    chineseTxtActivate},
    { TxtTopics,(char*)    chineseTxtTopics},
    { TxtConsult,(char*)    chineseTxtConsult},
    { TxtAddNew,(char*)    chineseTxtAddNew},
    { TxtContacts,(char*)    chineseTxtContacts},
    { TxtSearchName,(char*)    chineseTxtSearchName},
    { TxtMemory,"\x80\x51\x85\x5b\x58\x72\xb6\x60\x01\x00" },	///ڴ״̬
    { TxtRinger,(char*)    chineseTxtRinger},
    { TxtVolume,(char*)    chineseTxtVolume},
    { TxtRingVolume, "\x80\x94\xc3\x58\xf0\x97\xf3\x91\xcf\x00\x00" },	///xsf add 2002.08.28 2 lines
    { TxtAlarmVolume, "\x80\x95\xf9\x94\x9f\x97\xf3\x91\xcf\x00\x00" },	///
    { TxtSpeakerVolume,"\x80\x90\x1a\x8b\xdd\x97\xf3\x91\xcf\x00\x00" },  ///ͨxsf add 2002.08.30
    { TxtKeypadTones,(char*)    chineseTxtKeypadTones},
    { TxtNewMessage,"\x80\x4e\x2a\x65\xb0\x6d\x88\x60\x6f\x00\x00" },	///Ϣ
    { TxtNewBroadcast,(char*)    chineseTxtNewBroadcast},
    { TxtAutoAnswer,(char*)    chineseTxtAutoAnswer},
    { TxtTimeDate,(char*)    chineseTxtTimeDate},
    { TxtLanguages,(char*)    chineseTxtLanguages},
    { TxtPinCode, "\x80\x00P\x00I\x00N\x00\x31\x78\x01\x00\x00" },	///PIN1
    { TxtAutoredial,(char*)    chineseTxtAutoredial},
    { TxtDTMF,(char*)    chineseTxtDTMF},
    { TxtOn,(char*)    chineseTxtOn},
    { TxtOff,(char*)    chineseTxtOff},
    { TxtNetworkSel,(char*)    chineseTxtNetworkSel},
    { TxtSendID,(char*)    chineseTxtSendID},
    { TxtChargeTimers,(char*)    chineseTxtChargeTimers},
    { TxtCallDivert,(char*)    chineseTxtCallDivert},
    { TxtDateTime,(char *)chineseTxtDateTime},		//sunsj030918
    { TxtCallWaiting,(char*)    chineseTxtCallWaiting},
    { TxtIfBusy,(char*)    chineseTxtIfBusy},
    { TxtIfNoAnswer,(char*)    chineseTxtIfNoAnswer},
    { TxtIfNotReachable,(char*)    chineseTxtIfNotReachable},
    { TxtAllCalls,(char*)    chineseTxtAllCalls},
    { TxtCancelAll,(char*)    chineseTxtCancelAll},
    { TxtAll,(char*)    chineseTxtAll},
    { TxtVoice,(char*)    chineseTxtVoice},
    { TxtFax,(char*)    chineseTxtFax},
    { TxtData,(char*)    chineseTxtData},
    { TxtStatus,"\x80\x72\xb6\x60\x01\x00" },	///״̬
    { TxtCancel,(char*)    chineseTxtCancel},
    { TxtCalculator,(char*)    chineseTxtCalculator},
    { TxtSoftBack,(char*)    chineseTxtSoftBack},
    { TxtSoftSelect,(char*)    chineseTxtSoftSelect},
    { TxtSoftConfirm,"\x80\x78\x6e\x5b\x9a\x00" },	///ȷ //zgz,add
    { TxtSoftOptions,"\x80\x90\x09\x98\x79\x00\x00" },	///ѡ
    { TxtEmptyList,(char*)    chineseTxtEmptyList},
    { TxtSendMessage,(char*)    chineseTxtSendMessage},
    { TxtChange,(char*)    chineseTxtChange},
    { TxtWriteError,(char*)    chineseTxtWriteError},
    { TxtEntryDeleted,(char*)    chineseTxtEntryDeleted},
    { TxtDetails,(char*)    chineseTxtDetails},
    { TxtHold,(char*)    chineseTxtHold},
    { TxtUnhold,(char*)    chineseTxtUnhold},
    { TxtMute,(char*)    chineseTxtMute},
    { TxtSendDTMF,(char*)    chineseTxtSendDTMF},
    { TxtMainMenu,(char*)    chineseTxtMainMenu},
    { TxtSwap,(char*)    chineseTxtSwap},
    { TxtEndAll,(char*)    chineseTxtEndAll},
    { TxtPrivateCall,(char*)    chineseTxtPrivateCall},
    { TxtStartConference,(char*)    chineseTxtStartConference},
    { TxtReStartConference,(char*)    chineseTxtReStartConference},
    { TxtFind,(char*)    chineseTxtFind},
    { TxtServiceNumbers,(char*)    chineseTxtServiceNumbers},
    { TxtOutofRange,(char*) chineseTxtOutofRange},
    { TxtDone,"\x80\x5d\xf2\x5b\x8c\x62\x10\x00\x00" },	///
    { TxtFailed,(char*)    chineseTxtFailed},
    { TxtEnterNewPin, "\x80\x8f\x93\x51\x65\x65\xb0\x00P\x00I\x00N\x00\x31\x00\x00" }, ///PIN1(char*)   chineseTxtEnterNewPin,
    { TxtConfPin, "\x80\x78\x6e\x8b\xa4\x65\xb0\x00P\x00I\x00N\x00\x31\x00\x00" }, ///ȷPIN1(char*) chineseTxtConfPin},
    { TxtChangPin, "\x80\x00P\x00I\x00N\x00\x31\x66\xf4\x65\x39\x62\x10\x52\x9f\x00\x00" }, ///PIN1ĳɹ(char*) chineseTxtChangPin,
    { TxtEnd,(char*)    chineseTxtEnd},
    { TxtPINFail,(char*)    chineseTxtPINFail},
    { TxtSOS,(char*)    chineseTxtSOS},
    { TxtAutomatic,(char*)    chineseTxtAutomatic},
    { TxtManual,(char*)    chineseTxtManual},
    { TxtFixedNames,(char*)    chineseTxtFixedNames},
    { TxtFactoryReset,(char*)    chineseTxtFactoryReset},
    { TxtSearching,(char*)    chineseTxtSearching },
    { TxtChangPIN2,(char*)    chineseTxtChangePIN2 },
    { TxtOldPIN,(char*)    chineseTxtOldPIN },
    { TxtOldPIN2,(char*)    chineseTxtOldPIN2 },
    { TxtNotAcc,(char*)    chineseTxtNotAcc },
    { TxtEnabled,(char*)    chineseTxtEnabled },
    { TxtDisabled,(char*)    chineseTxtDisabled },
    { TxtPINOK,(char*)    chineseTxtPINOK },
    { TxtSimBlocked,(char*)    chineseTxtSimBlocked },
    { TxtNewPIN, "\x80\x65\xb0\x00P\x00I\x00N\x00\x31\x78\x01\x00\x00" }, ///PIN1(char*)   chineseTxtNewPIN ,
    { TxtAcc,(char*)    chineseTxtAcc },
    { TxtNoNetwork,(char*)    chineseTxtNoNetwork },
    { TxtNo,(char*)    chineseTxtNo },
    { TxtEnterDate,(char*)    chineseTxtEnterDate },
    { TxtEnterTime,(char*)    chineseTxtEnterTime },
    { TxtScratchPad,(char*)    chineseTxtScratchPad },
    { TxtDeleted,(char*)    chineseTxtDeleted },
    { TxtActivated,(char*)    chineseTxtActivated },
    { TxtDeActivated,(char*)    chineseTxtDeActivated },
    { TxtDeactivate,(char*)    chineseTxtDeactivate },
    { TxtCheck,(char*)    chineseTxtCheck },
    { TxtYes,(char*)    chineseTxtYes },
    { TxtCallNumber,"\x80\x54\x7c\x53\xeb\x00\x00" },	///
    { TxtEnterMid,(char*)    chineseTxtEnterMid },
    { TxtReadError,(char*)    chineseTxtReadError },
    { TxtUsed,"\x80\x5d\xf2\x75\x28\x7a\x7a\x95\xf4\x00" },	///ÿռ
    { TxtOutgoing,(char*)    chineseTxtOutgoing },
    { TxtMuted,(char*)    chineseTxtMuted },
    { TxtCallEnded,(char*)    chineseTxtCallEnded },
    { TxtIncomingCall,(char*)    chineseTxtIncomingCall },
    { TxtIncomingData,(char*)    chineseTxtIncomingData }, //WUFEI MODIFY//s.b should translate the "incoming data" in chinese
    { TxtIncomingFax,(char*)    chineseTxtIncomingFax }, //SPR#1147 - DS - Added string for incoming fax.TxtReadError,(char*)    chineseTxtReadError ,
    { TxtNumberWithheld,(char*)    chineseTxtNumberWithheld },
    { TxtAccept,(char*)    chineseTxtAccept },
    { TxtReject,(char*)    chineseTxtReject },
    { TxtCalling,(char*)    chineseTxtCalling },
    { TxtWaitingAnswer,(char*)chineseWaitingAnswer},
    { TxtMissedCalls,(char*)    chineseTxtMissedCalls },
    { TxtMissedCall,(char*)    chineseTxtMissedCall },
    { TxtCallSingle,(char*)    chineseTxtCallSingle},
    { TxtCallTwo,(char*)    chineseTxtCallTwo},
    { TxtCallPrivateCall,(char*)    chineseTxtCallPrivateCall},
    { TxtCallConfernce,(char*)    chineseTxtCallConfernce},
    { TxtCallSingleMultiparty,(char*)    chineseTxtCallSingleMultiparty},
    { TxtCallMultipartySingle,(char*)    chineseTxtCallMultipartySingle},
    { TxtLocked,(char*)    chineseTxtLocked },
    { TxtUnmute,(char*)    chineseTxtUnmute },
    { TxtNeedCharging,(char*)    chineseTxtNeedCharging },
    { TxtCharging,(char*)    chineseTxtCharging },
    { TxtChargComplete,(char*)    chineseTxtChargComplete },
    { TxtNoPower, (char *) chineseTxtNoPower},
    { TxtSwitchOff, (char *) chineseTxtSwitchOff},
    { TxtOperationNotAvail,(char*)    chineseTxtOperationNotAvail },
    { TxtNetUselessInCall,(char*)    chineseTxtNetUselessInCall},
    { TxtNetUselessCallAgain,(char*)    chineseTxtNetUselessCallAgain },
    { TxtAddToConference,(char*)    chineseTxtAddToConference },
    { TxtEmpty,(char*)    chineseTxtEmpty },
    { TxtSelectFromList,(char*)    chineseTxtSelectFromList },
    { TxtEnterNetworkCode,(char*)    chineseTxtEnterNetworkCode },
    { TxtMCCMNC,(char*)    chineseTxtMCCMNC },
    { TxtRecord,(char*)    chineseTxtRecord },
    { TxtSecurity,(char*)    chineseTxtSecurity },
    { TxtEnglish,(char*)    chineseTxtEnglish },
    { TxtGerman,(char*)    chineseTxtGerman },
    { TxtValidity,(char*)    chineseTxtValidity },
    { TxtMessageTyp,(char*)    chineseTxtMessageTyp },
    { TxtSetVoiceMail,(char*)    chineseTxtSetVoiceMail },
    { TxtCallTimers,(char*)    chineseTxtCallTimers },
    { TxtLastCharge,(char*)    chineseTxtLastCharge },
    { TxtTotalCharge,(char*)    chineseTxtTotalCharge },
    { TxtResetCharge,(char*)    chineseTxtResetCharge },
    { TxtIfNoService,(char*)    chineseTxtIfNoService },
    { TxtDiscard,(char*)    chineseTxtDiscard },
    { TxtEDIT,(char*)    chineseTxtEDIT },
    { TxtExtractNumber,"\x80\x63\xd0\x53\xd6\x53\xf7\x78\x01\x00\x00" },	///ȡ
    { TxtWrite,(char*)    chineseTxtWrite },
    { TxtCheckStatus,(char*)    chineseTxtCheckStatus },
    { TxtSetDivert,(char*)    chineseTxtSetDivert },
    { TxtCancelDivert,(char*)    chineseTxtCancelDivert },
    { TxtHideID,(char*)    chineseTxtHideID },
    { TxtTones,(char*)    chineseTxtTones },
    { TxtClock,(char*)    chineseTxtClock },
    { TxtPhone,(char*)    chineseTxtPhone },
    { TxtStop,(char*)    chineseTxtStop },
    { TxtRecording,(char*)    chineseTxtRecording },
    { TxtPlaying,(char*)    chineseTxtPlaying },
    { TxtPlayback,(char*)    chineseTxtPlayback },
    { TxtNoNumber,(char*)    chineseTxtNoNumber },
    { TxtOkToDelete,(char*)    chineseTxtOkToDelete },
    { TxtBalance,(char*)    chineseTxtBalance },
    { TxtLimit,(char*)    chineseTxtLimit },
    { TxtLimitEq,(char*)    chineseTxtLimitEq },
    { TxtRate,(char*)    chineseTxtRate },
    { TxtMinutes,(char*)    chineseTxtMinutes },
    { TxtCost,(char*)    chineseTxtCost },
    { TxtCredit,(char*)    chineseTxtCredit },
    { TxtPressOk,(char*)    chineseTxtPressOk },
    { TxtReset,(char*)    chineseTxtReset },
    { TxtIncoming,(char*)    chineseTxtIncoming },
    { TxtCounter,(char*)    chineseTxtCounter },
    { TxtOutgoingCalls,(char*)    chineseTxtOutgoingCalls },
    { TxtCostCounter,(char*)    chineseTxtCostCounter },
    { TxtEnterCurrency,(char*)    chineseTxtEnterCurrency },
    { Txt1Unit,(char*)    chineseTxt1Unit },
    { TxtChanged,(char*)    chineseTxtChanged },
    { TxtEnterLimit,(char*)    chineseTxtEnterLimit },
    { TxtCancelled,(char*)    chineseTxtCancelled },
    { TxtView,(char*)    chineseTxtView },
    { TxtEnterPCK,(char*)    chineseTxtEnterPCK },
    { TxtEnterCCK,(char*)    chineseTxtEnterCCK },
    { TxtEnterNCK,(char*)    chineseTxtEnterNCK },
    { TxtEnterNSCK,(char*)    chineseTxtEnterNSCK },
    { TxtEnterSPCK,(char*)    chineseTxtEnterSPCK },
    { TxtCodeInc, "\x80\x5b\xc6\x78\x01\x95\x19\x8b\xef\x00!\x00\x00" }, ///(char*)  chineseTxtCodeInc ,
    { TxtPuk1Inc, "\x80\x00P\x00U\x00K\x78\x01\x95\x19\x8b\xef\x00!\x00\x00" },  ///PUK
    { TxtChangeFail, "\x80\x66\xf4\x65\x39\x59\x31\x8d\x25\x00!\x00\x00" }, ///ʧܣ
    { TxtBlckPerm,(char*)    chineseTxtBlckPerm },
    { TxtDealer,(char*)    chineseTxtDealer },
    { TxtSendingDTMF,(char*)    chineseTxtSendingDTMF },
    { TxtCheckNumber,(char*)    chineseTxtCheckNumber },
    { TxtNumberBusy,(char*)    chineseTxtNumberBusy },
    { TxtNoAnswer,(char*)    chineseTxtNoAnswer }, 
    { TxtNumberChanged,(char*)    chineseTxtNumberChanged },
    { TxtNetworkBusy,(char*)    chineseTxtNetworkBusy },   
    { TxtNotSubscribed,(char*)    chineseTxtNotSubscribed },
    { TxtAnyKeyAnswer,(char*)    chineseTxtAnyKeyAnswer },
    { TxtPINBlock,(char*)    chineseTxtPINBlock },
    { TxtEdit,(char*)    chineseTxtEdit },
    { TxtChangePassword,(char*)    chineseTxtChangePassword },
    { TxtSetBar,(char*)    chineseTxtSetBar },
    { TxtSmsTone,(char*)    chineseTxtSmsTone },
    { TxtSmsVolume,"\x80\x6d\x88\x60\x6f\x97\xf3\x91\xcf\x00\x00" },  ///Ϣ
    { TxtKeypadToneVolume, "\x80\x63\x09\x95\x2e\x97\xf3\x91\xcf\x00\x00"},	/* 2003/12/08 sunsj */
    { TxtKeypadToneRing, "\x80\x53\x55\x97\xf3\x00\x00"},	/* 2003/12/08 sunsj */
    { TxtKeypadToneSpecialRing, "\x80\x8b\xed\x97\xf3\x00\x00"},	/* 2003/12/08 sunsj */
    { TxtMelody,(char*)    chineseTxtMelody },
    { TxtSilent,(char*)    chineseTxtSilent },
    { TxtClick,(char*)    chineseTxtClick },
    { TxtClearAlarm,(char*)    chineseTxtClearAlarm },
    { TxtTimeFormat,(char*)    chineseTxtTimeFormat },
    { TxtTwelveHour,(char*)    chineseTxtTwelveHour },
    { TxtTwentyfourHour,(char*)    chineseTxtTwentyfourHour }, 
    { TxtInCallTimer,(char*)    chineseTxtInCallTimer },
    { TxtStore,(char*)    chineseTxtStore },
    { TxtNone,(char*)    chineseTxtNone }, 
    { TxtPIN,(char*)    chineseTxtPIN },
    { TxtPIN2,(char*)    chineseTxtPIN2 },
    { TxtConfPin2, "\x80\x78\x6e\x8b\xa4\x65\xb0\x00P\x00I\x00N\x00\x32\x00\x00" }, ///ȷPIN2(char*) chineseTxtConfPin2 ,
    { TxtNewPIN2,(char*)    chineseTxtNewPIN2 }, 
    { TxtUnlockOK,(char*)    chineseTxtUnlockOK },
    { TxtIMEI,(char*)    chineseTxtIMEI },
    { TxtList,(char*)    chineseTxtList },
    { TxtFull,(char*)    chineseTxtFull },
    { TxtCapacityFull,(char*)    chineseTxtCapacityFull},
    { TxtNotAvailable,(char*)    chineseTxtNotAvailable },
    { TxtCallBAOC,(char*) chineseTxtCallBAOC},
    { TxtCallBAOIC,(char*) chineseTxtCallBAOIC },
    { TxtCallBAOICexH,(char*) chineseTxtCallBAOICexH },
    { TxtCallBAIC,(char*) chineseTxtCallBAIC },
    { TxtCallBAICroam,(char*) chineseTxtCallBAICroam},
    { TxtCallBarringAll,(char*) chineseTxtCallBarringAll},
    { TxtCallBAOCAll,(char*) chineseTxtCallBAOCAll },
    { TxtCallBAICAll,(char*) chineseTxtCallBAICAll},
    { TxtCLIP,(char*) chineseTxtCLIP},
    { TxtCOLP,(char*) chineseTxtCOLP},
    { TxtCOLR,(char*) chineseTxtCOLR},
    { TxtSimToolkit,(char*)    chineseTxtSimToolkit },
    { TxtRecentCalls,(char*)    chineseTxtRecentCalls },
    { TxtRecordName,(char*)    chineseTxtRecordName }, //2004-04-06 Sunny add
    { TxtInterCalls,(char*)    chineseTxtInterCalls },
    { TxtInterHome,(char*)    chineseTxtInterHome }, 
    { TxtWhenRoaming,(char*)    chineseTxtWhenRoaming },
    { TxtCancelAllBars,(char*)    chineseTxtCancelAllBars },
    { TxtWaiting,(char*)    chineseTxtWaiting }, 
    { TxtBarred,(char*)    chineseTxtBarred }, 
    { TxtForwarded,(char*)    chineseTxtForwarded },
    { TxtCallDivertNoReach,(char*)    chineseTxtCallDivertNoReach },
    { TxtCallDivertNoReply,(char*)    chineseTxtCallDivertNoReply },
    { TxtCallDivertIfBusy,(char*)    chineseTxtCallDivertIfBusy }, 
    { TxtPressMenu,(char*) chineseTxtPressMenu},
    {TxtSending,"\x80\x6b\x63\x57\x28\x53\xd1\x5f\x80\x00" },	///ڷ
    {TxtMessage,(char*)    chineseTxtMessage },
    {TxtSoftNext,(char*)    chineseTxtSoftNext },
    {TxtLastCall,(char*)    chineseTxtLastCall },
    {TxtIncomingCalls,(char*)    chineseTxtIncomingCalls },//WUFEI Modify
    {TxtLow,(char*)    chineseTxtLow },
    {TxtMedium,(char*)    chineseTxtMedium },
    {TxtHigh,(char*)    chineseTxtHigh },
    {TxtIncreasing,(char*)    chineseTxtIncreasing },
    {TxtTimerReset,(char*)    chineseTxtTimerReset },
    {TxtClockSetTo,(char*)    chineseTxtClockSetTo }, 
    {TxtSilentMode,(char*) chineseTxtSilent},
    {TxtSmsValidityPeriodSet,"\x80\x67\x09\x65\x48\x67\x1f\x5d\xf2\x8b\xbe\x5b\x9a\x00" },	///Ч趨
    {Txt1Hour,(char*) chineseTxt1Hour},
    {Txt12Hours,(char*) chineseTxt12Hour},
    {Txt24Hours,(char*) chineseTxt24Hours},
    {Txt1Week,(char*) chineseTxt1Week},
    {TxtPin2Code,(char*) chineseTxtPIN2},
    {TxtEnablePIN,"\x80\x00P\x00I\x00N\x00\x31\x67\x2a\x6f\xc0\x6d\x3b\x00\x00" },	///PIN1δ(char*) chineseTxtEnablePIN,
    {TxtRequesting,(char*) chineseTxtRequesting},
    {TxtNotAllowed,(char*) chineseTxtNotAllowed},
    {TxtEmergency,(char*) chineseTxtEmergency},
    {TxtChinese,(char*)  chineseTxtChinese },
    {TxtPassword,(char*) chineseTxtPassword },
    {TxtConfirmPassword,(char*) chineseTxtConfirmPassword},
    {TxtNewPassword,(char*) chineseTxtNewPassword},
    {TxtNoMessages,(char*) chineseTxtNoMessages},
    {TxtTwoAttemptsLeft,(char*) chineseTxtTwoAttemptsLeft},
    {TxtOneAttemptLeft,(char*) chineseTxtOneAttemptLeft},
{Txtblacklisted, (char *)chineseTxtblacklistedt},
{TxtErrUnknown, (char *)chineseTxtErrUnknown},
{TxtSSErr, (char *)chineseTxtSSErr},
{TxtUnknownSub, (char *)chineseTxtUnknownSub},
{TxtIllSub, (char *)chineseTxtIllSub},
{TxtIllEqip, (char *)chineseTxtIllEqip},
{TxtIllOp, (char *)chineseTxtIllOp},
{TxtSubVil, (char *)chineseTxtSubVil},
{TxtInComp, (char *)chineseTxtInComp},
{TxtFacNoSup, (char *)chineseTxtFacNoSup},
{TxtAbsSub, (char *)chineseTxtAbsSub},
{TxtSysFail, (char *)chineseTxtSysFail},
{TxtMissDta, (char *)chineseTxtMissDta},
{TxtUnexDta, (char *)chineseTxtUnexDta},
{TxtPwdErr, (char *)chineseTxtPwdErr},
{TxtUnkAlph, (char *)chineseTxtUnkAlph},
{TxtMaxMpty, (char *)chineseTxtMaxMpty},
{TxtResNoAvai, (char *)chineseTxtNoReply},
{TxtUnRec, (char *)chineseTxtUnRec},
{TxtMisTyp, (char *)chineseTxtMisTyp},
{TxtBadStruct, (char *)chineseTxtBadStruct},
{TxtDupInv, (char *)chineseTxtDupInv},
{TxtResLim, (char *)chineseTxtResLim},
{TxtIniRel, (char *)chineseTxtIniRel},
{TxtFatRes, (char *)chineseTxtFatRes},
{TxtEntAnw, (char *)chineseTxtEntAnw},
{TxtSsMsg, (char *)chineseTxtSsMsg},
{TxtOld,(char*) chineseTxtOld},
{ TxtInsertnote, (char*)chineseTxtInsertnote },
{ TxtMelodygenerator, (char*)chineseTxtMelodygenerator },
{ TxtOctaveHigher, (char*)chineseTxtOctaveHigher },
{ TxtOctaveLower, (char*)chineseTxtOctaveLower },
{ TxtLoadMelody, (char*)chineseTxtLoadMelody },
{ TxtEasyText, (char*)chineseTxtEasyText },
{ TxtDataCount, (char*)chineseTxtDataCount },
{ TxtQoS, (char*)chineseTxtQoS },
{ TxtTypeofConnection, (char*)chineseTxtTypeofConnection },
{ TxtTotalCount, "\x80\x60\x3b\x51\x71\x00" },	///ܹ
{ TxtResetCount, (char*)chineseTxtResetCount },
{ TxtDataCounter, (char*)chineseTxtDataCounter },
{ TxtV42bis, (char*)chineseTxtV42bis },
{ TxtNormal, (char*)chineseTxtNormal },
{ TxtCSD, (char*)chineseTxtCSD },
{ TxtClassB, (char*)chineseTxtClassB },
{ TxtClassC, (char*)chineseTxtClassC },
{ TxtIPAddress, (char*)chineseTxtIPAddress },
{ TxtIPAddress1, (char*)chineseTxtIPAddress1 },
{ TxtIPAddress2, (char*)chineseTxtIPAddress2 },
{ TxtPort1, (char*)chineseTxtPort1 },
{ TxtPort2, (char*)chineseTxtPort2 },
{ TxtAPN, (char*)chineseTxtAPN },
{ TxtConnectionType, (char*)chineseTxtConnectionType },
{ TxtGPRS, (char*)chineseTxtGPRS },
{ TxtGPRSInfo, (char*)chineseTxtGPRSInfo },//WUFEI APPEND
{ TxtOutgoingData, (char*)chineseTxtOutgoingData },
{ TxtHomepage, (char*)chineseTxtHomepage},
{ TxtBookmarks, (char*)chineseTxtBookmarks},
{ TxtGoTo, (char*)chineseTxtGoTo}, 
{ TxtHistory, (char*)chineseTxtHistory}, 
{ TxtSetup, (char*)chineseTxtSetup},
{ TxtNewBookmark, (char*)chineseTxtNewBookmark },
{ TxtWWWdot, "http://www." },
{ TxtWAPdot, "http://wap."  },
{ TxtSMS, (char*)chineseTxtSMS },
{ TxtEmail, (char*)chineseTxtEmail },
 { TxtClear, (char*)chineseTxtClear },
 { TxtBookmark, (char*)chineseTxtBookmark },
 { TxtSelectProfile, (char*)chineseTxtSelectProfile },
 { TxtSetupProfiles, (char*)chineseTxtSetupProfiles },
 { TxtSaveHistory, (char*)chineseTxtSaveHistory },
 { TxtEditName, (char*)chineseTxtEditName },
 { TxtEditURL, (char*)chineseTxtEditURL },
 { TxtAccessType, (char*)chineseTxtAccessType },
 { TxtResponseTimer, (char*)chineseTxtResponseTimer },
 { TxtDialupNumber, (char*)chineseTxtDialupNumber },
 { TxtTemporary, (char*)chineseTxtTemporary },
 { TxtContinuous, (char*)chineseTxtContinuous },
 { TxtGPRSData, (char*)chineseTxtGPRSData },
 { TxtCSData, (char*)chineseTxtCSData },
 { TxtWAP, (char*)chineseTxtWAP },
 { TxtExit, (char*)chineseTxtExit },
 { TxtReload, (char*)chineseTxtReload },
 { TxtStored, (char*)chineseTxtStored },
 { TxtOther, (char*)chineseTxtOther },
 { TxtConnecting, (char*)chineseTxtConnecting },
 { TxtDownloading, (char*)chineseTxtDownloading },
 { TxtUpdating, (char*)chineseTxtUpdating },
 { TxtEnterURL, (char*)chineseTxtEnterURL },
 { TxtProfileName, (char*)chineseTxtProfileName },
 { TxtISPUsername, (char*)chineseTxtISPUsername },
 { TxtISPPassword, (char*)chineseTxtISPPassword },
 { TxtGoToLink, (char*)chineseTxtGoToLink },
 { TxtSelect, (char*)chineseTxtSelect },
 { TxtNotConnected, (char*)chineseTxtNotConnected },
 { TxtScaleImages, (char*)chineseTxtScaleImages },
 { TxtLoggingIn, (char*)chineseTxtLoggingIn },
 { TxtAcceptEndWAP, (char*)chineseTxtAcceptEndWAP },
 { TxtErrorUnknown, (char*)chineseTxtErrorUnknown },
 { TxtErrorNotImp, (char*)chineseTxtErrorNotImp },
 { TxtErrorUnsupported, (char*)chineseTxtErrorUnsupported },
 { TxtErrorOverload, (char*)chineseTxtErrorOverload },
 { TxtErrorNoResponse, (char*)chineseTxtErrorNoResponse },
 { TxtErrorTooLarge, (char*)chineseTxtErrorTooLarge },
 { TxtErrorBadRequest, (char*)chineseTxtErrorBadRequest },
 { TxtErrorUnauthorized, (char*)chineseTxtErrorUnauthorized },
 { TxtErrorPaymentReq, (char*)chineseTxtErrorPaymentReq },
 { TxtErrorForbidden, (char*)chineseTxtErrorForbidden },
 { TxtErrorFileNotFnd, (char*)chineseTxtErrorFileNotFnd },
 { TxtErrorNotAllowed, (char*)chineseTxtErrorNotAllowed },
 { TxtErrorNotAcceptable, (char*)chineseTxtErrorNotAcceptable },
 { TxtErrorAuthReq, (char*)chineseTxtErrorAuthReq },
 { TxtErrorReqTimeout, (char*)chineseTxtErrorReqTimeout },
 { TxtErrorHTTPConf, (char*)chineseTxtErrorHTTPConf },
 { TxtErrorOutOfMem, (char*)chineseTxtErrorOutOfMem },
 { TxtErrorWMLError, (char*)chineseTxtErrorWMLError },
 { TxtErrorDisplay, (char*)chineseTxtErrorDisplay },
 { TxtErrorCardEmpty, (char*)chineseTxtErrorCardEmpty },
 { TxtErrorURLInvalid, (char*)chineseTxtErrorURLInvalid },
 { TxtErrorMemLow, (char*)chineseTxtErrorMemLow },
 { TxtErrorPeerAbort, (char*)chineseTxtErrorPeerAbort },
 { TxtError, (char*)chineseTxtError },
 { TxtErrorHTTP, (char*)chineseTxtErrorHTTP },
 { TxtErrorWSP, (char*)chineseTxtErrorWSP },
 { TxtErrorWAE, (char*)chineseTxtErrorWAE },
 { TxtErrorWSPCL, (char*)chineseTxtErrorWSPCL },
 { TxtErrorWSPCM, (char*)chineseTxtErrorWSPCM },
 { TxtErrorWTP, (char*)chineseTxtErrorWTP },
 { TxtErrorWTLS, (char*)chineseTxtErrorWTLS },
 { TxtErrorWDP, (char*)chineseTxtErrorWDP },
 { TxtErrorUDCP, (char*)chineseTxtErrorUDCP },
 { TxtNotSupported, (char*)chineseTxtNotSupported },
 { TxtSelectLine, (char *)chineseTxtSelectLine},
 { TxtLine1, (char *)chineseTxtLine1},
 { TxtLine2, (char *)chineseTxtLine2},
 {TxtInfoNumbers, (char *)chineseTxtInfoNumbers},
 { TxtAttach, (char *)chineseTxtAttach }, /* sbh 18/01/02 */
 { TxtDetach, (char *)chineseTxtDetach }, /* sbh 18/01/02 */
 { TxtGPRSAuto,(char *)chineseTxtGPRSAuto},/*zy 2003-03-04*/
 { TxtGPRSNeed,(char *)chineseTxtGPRSNeed},/*zy 2003-03-04*/
 { TxtAttachMode,(char *)chineseTxtAttachMode},/*zy 2003-03-04*/
 { TxtDefineContext, (char *)chineseTxtDefineContext}, /*sbh 22/01/02 */
 { TxtActivateContext, (char *)chineseTxtActivateContext}, /*sbh 22/01/02 */
 { TxtDeactivateContext, (char *)chineseTxtDeactivateContext}, /*sbh 22/01/02 */
 { TxtGPRSPreferred, (char *)chineseTxtGPRSPreferred}, /*sbh 25/01/02 */
 { TxtCSDPreferred, (char *)chineseTxtCSDPreferred},/*sbh 22/01/02 */
 { TxtNotAttached, (char *)chineseTxtNotAttached},/*sbh 22/01/02 */
 { TxtAlreadyAttached, (char *)chineseTxtAlreadyAttached},/*sbh 8/02/02 */
 { TxtSelected, (char *)chineseTxtSelected}, /*ap 06/02/02*/
 { TxtNetwork, (char *)chineseTxtNetwork}, /*ap 06/02/02*/
 { TxtForbidden, (char *)chineseTxtForbidden}, /*ap 06/02/02*/
 { TxtActivateFDN, (char *)chineseTxtActivateFDN}, /*ap 06/02/02*/
 { TxtPlease, (char *)chineseTxtPlease},
 { TxtTimedOut, (char *)chineseTxtTimedOut},
 { TxtWillChangeOn, (char *)chineseTxtWillChangeOn},
 { TxtAttached, (char *)chineseTxtAttached},
 { TxtDetached, (char *)chineseTxtDetached},
 { TxtUnknown, "Unknown"}, //api 13/04/02
 { TxtCallTransfer, "Transfer Calls"},//MC
 {TxtBufferFull, (char *)chineseTxtBufferFull},
 { TxtAddNewCall,(char *)chineseAddNewCall},//zy Mobile Innovation 01/08/02 
 { TxtEndOne, (char *)chineseEndOne },//zy Mobile Innovation 01/08/02 
 { TxtCallMenu,(char *)chineseCallMenu},//zy Mobile Innovation 23/09/02
 { TxtBackgroud, (char *)chineseBackgroud},
 { TxtSelBackgroud, (char *)chineseSelectBackgroud},
 { TxtBackgroundDisabled,(char*)chineseBackgroundDisabled},
 { TxtA, (char *)chineseA},
 { TxtB, (char *)chineseB}, 
 { TxtUserDefine, (char *)chineseUserdefine},
 { TxtUserdefine1,(char *)chineseUserdefine1},
 { TxtUserdefine2,(char *)chineseUserdefine2},
 { TxtUserdefine3,(char *)chineseUserdefine3},
 { TxtUserdefine4,(char *)chineseUserdefine4},
 { TxtUserdefine5,(char *)chineseUserdefine5},
 {TxtUserDefinedPic,(char*)chineseUserDefinedPic},//chenjun 2002-12-29 add for user defined pic, PCSync
 {TxtNoUserPic,(char*)chineseNoUserPic},//chenjun 2003-01-15 for info dialog when there is not any user pic
 { TxtRename, (char *)chineseRename},
 { TxtAdjustContrast,(char *)chineseAdjustContrast},
 { TxtOnOffAnimation, (char *)chineseOnOffAnimation },
 { TxtBackLight, (char *)chineseBacklight },
 { TxtBmpAlbum, (char *)chineseBmpAlbum },
 { TxtGreetingWord,(char *)chineseGreetingWord },
 { TxtDsplSetting, (char *)chineseDisplaySetting },
 { TxtBacklightOnTime,(char *)chineseBacklightOnTime },
 { TxtBacklightOffTime,(char *)chineseBacklightOffTime },
 { TxtBacklightIntensity,(char *)chineseBacklightIntensity },
 { TxtSavingSetting,  (char *)chineseSavingSetting },  
 { TxtGreetingWordOn, (char *)chineseGreetingWordOn },  
 { TxtGreetingWordOff, (char *)chineseGreetingWordOff },  
 { TxtGreetingWordEdit, (char *)chineseEditGreetingWord},  
 { TxtMobileInnovation,  (char *)chineseMobileInnovation }, 
 { TxtFlower, (char *)chineseFlower },
 { TxtSkyrocket,  (char *)chineseSkyrocket },
 { TxtCloseAnim,  (char *)chineseCloseAnim },
 { TxtSavingMode, (char *)chineseSavingMode }, 
 { TxtNormalMode, (char *)chineseNormalMode },
 { TxtMobileSettings,(char *)chinesehandsetsetting},
 { TxtVoiceCallDivert, (char *)chineseTxtVoiceCallDivert}, //WUFEI APPPEND
 { TxtAllFaxCallDivert, (char *)chineseTxtAllFaxCallDivert}, //WUFEI APPEND
 { TxtAllDataCallDivert, (char *)chineseTxtAllDataCallDivert}, //WUFEI APPEND
 { TxtVoiceMailBox, (char *)chineseTxtVoiceMailBox},  //WUFEI APPEND
 { TxtOtherNumber, (char *)chineseTxtOtherNumber},  //WUFEI APPEND
 { TxtNumberInCommonUse, (char *)chineseTxtNumberInCommonUse}, //WUFEI APPEND
 { TxtCallSettings, (char *)chineseTxtCallSettings},//WUFEI APPEND
 { TxtMinuteHint, (char *)chineseTxtMinuteHint},//WUFEI APPEND
 { TxtNextCall, (char *)chineseTxtNextCall},//WUFEI APPEND
 { TxtCUGNumber, (char *)chineseTxtCUGNumber},//WUFEI APPEND
 { TxtPreDefine, (char *)chineseTxtPreDefine},//WUFEI APPEND
 { TxtEnterIndex, (char *)chineseTxtEnterIndex},//WUFEI APPEND
 { TxtAddCUG, (char *)chineseTxtAddCUG},//WUFEI APPEND
 { TxtModify, (char *)chineseTxtModify},//WUFEI APPEND
 {TxtDCTbVar0, DCTbVar[0]},//wufei add
 {TxtDCTbVar1, DCTbVar[1]},//wufei add
 {TxtDCTbVar2, DCTbVar[2]},//wufei add
 {TxtDCTbVar3, DCTbVar[3]},//wufei add
 {TxtDCTbVar4, DCTbVar[4]},//wufei add
 {TxtDCTbVar5, DCTbVar[5]},//wufei add
 {TxtDCTbVar6, DCTbVar[6]},//wufei add
 {TxtDCTbVar7, DCTbVar[7]},//wufei add
 {TxtDCTbVar8, DCTbVar[8]},//wufei add
 {TxtDCTbVar9, DCTbVar[9]},//WUFEI APPEND
 {TxtEnterNRyTime,(char*)chineseTxtEnerNRyTime},//WUFEI APPEND
 {TxtCancelAffirm,(char*)chineseTxtCancelAffirm},//WUFEI APPEND
 {TxtWithout,(char*)chineseTxtWithout},//WUFEI APPEND
 {TxtScene, "\x80\x60\xc5\x66\x6f\x6a\x21\x5f\x0f\x00\x00"}, //begin of xsf add 07/08/02  龰ģʽ
 {TxtNormals,		"\x80\x66\x6e\x90\x1a\x73\xaf\x58\x83\x00\x00"},//ͨ	//sunsj030918
 {TxtOut,			"\x80\x62\x37\x59\x16\x73\xaf\x58\x83\x00\x00"},//⻷
 {TxtMeeting,		"\x80\x4f\x1a\x8b\xae\x73\xaf\x58\x83\x00\x00"}, //黷
 {TxtIncar,			"\x80\x5b\xa4\x51\x85\x73\xaf\x58\x83\x00\x00"}, //ڻ	//sunsj030918
 {TxtStart,			"\x80\x54\x2f\x52\xa8\x00\x00" }, ///
 {TxtPssetting,		"\x80\x8b\xbe\x7f\x6e\x00\x00" }, ///
 {TxtAnswer,"\x80\x63\xa5\x54\x2c\x8b\xbe\x7f\x6e\x00\x00" }, ///
 {Txtmelody1,			"\x80\x62\x11\x76\x84\x5f\xc3\x59\x2a\x4e\x71\x00\x00" },//ҵ̫
 {Txtmelody2,			"\x80\x4e\xd6\x4e\x00\x5b\x9a\x5f\x88\x72\x31\x4f\x60\x00\x00" },//һܰ	
 {Txtmelody3,			"\x80\x66\x6e\x90\x1a\x94\xc3\x58\xf0\x00\x31\x00\x00" },//ͨ1	
 {Txtmelody4,			"\x80\x66\x6e\x90\x1a\x94\xc3\x58\xf0\x00\x32\x00\x00" },//ͨ2
 {Txtmelody5,			"\x80\x66\x6e\x90\x1a\x94\xc3\x58\xf0\x00\x33\x00\x00" },//ͨ3
 {Txtmelody6,			"\x80\x56\xdb\x5b\x63\x00\x2d\x66\x25\x4e\x4b\x9e\x1f\x9e\x23\x00\x00" },//ļ-֮
 {Txtmelody7,			"\x80\x00\x62\x5c\x0f\x8c\x03\x53\x4f\x59\x4f\x66\xf2\x00\x00" },//bСЭ
 {Txtmelody8,			"\x80\x80\x6a\x66\x0e\x76\x84\x5b\xb6\x4f\x19\x00\x00" },//ļһ
 {Txtmelody9,			"\x80\x5f\x00\x5f\xc3\x5e\x03\x9c\x81\x65\xaf\x00\x00" },//Ĳ³˹
 {Txtmelody10,			"\x80\x52\x4d\x5f\x80\x66\x6e\x6d\x4e\x5c\x9b\x00\x00" },//ǰռõ
 {Txtmelody11,			"\x80\x64\x47\x6e\xda\x82\x1e\x66\xf2\x00\x00" },//ҡ
 {Txtmelody12,			"\x80\x72\x35\x58\xeb\x4e\x50\x00\x00" },//ʿ
 {Txtmelody13,			"\x80\x6d\x77\x6e\xe8\x4e\x4b\x66\x68\x00\x00" },//֮
 {Txtmelody14,			"\x80\x9b\x54\x73\x8b\x5b\xab\x4e\x2d\x00\x00" },//ħ
 {Txtmelody15,			"\x80\x72\x35\x58\xeb\x00\x00" },//ʿ
 {Txtmelody16,			"\x80\x98\xde\x5f\x39\x00\x00" },//ɵ
 {Txtmelody17,			"\x80\x5f\xeb\x4e\x50\x76\x84\x51\x9c\x59\x2b\x00\x00" },//ֵũ
 {Txtmelody18,			"\x80\x6d\x77\x6e\xe8\x4e\x4b\x6b\x4c\x00\x00" },//֮
 {Txtmelody19,			"\x80\x9e\xc4\x73\xab\x74\x70\x00\x00" },//õ
 {Txtmelody20,			"\x80\x59\x73\x5b\x69\x4e\x0e\x56\xdb\x91\xcd\x59\x4f\x00\x00" },//Ů
 {TxtmelodyNone,		"\x80\x65\xe0\x94\xc3\x58\xf0\x00\x00" },		 //
 {TxtSmsRing1, "\x80\x94\xc3\x58\xf0\x00\x31\x00\x00"},  //xsf add 1 03.03.13
 {TxtSmsRing2, "\x80\x94\xc3\x58\xf0\x00\x32\x00\x00"},  // 2
 {TxtSmsRing3, "\x80\x94\xc3\x58\xf0\x00\x33\x00\x00"},  // 3
 {TxtSmsRing4, "\x80\x94\xc3\x58\xf0\x00\x34\x00\x00"},  // 4
 {TxtSmsRing5, "\x80\x94\xc3\x58\xf0\x00\x35\x00\x00"}, // 5
 {TxtHostKey,		"\x80\x62\x4b\x67\x3a\x5b\xc6\x78\x01\x00\x00" }, //ֻ
 {TxtHostSwitchOn,"\x80\x5f\x00\x67\x3a\x4f\xdd\x62\xa4\x00\x00" }, ///
 {TxtHostSimLock, "\x80\x00S\x00I\x00M\x53\x61\x95\x01\x5b\x9a\x00\x00" }, ///SIM
 {TxtHostDelPbkall,"\x80\x6e\x05\x7a\x7a\x75\x35\x8b\xdd\x67\x2c\x00\x00" },	///յ绰
 {TxtHostReset, "\x80\x60\x62\x59\x0d\x51\xfa\x53\x82\x8b\xbe\x7f\x6e\x00\x00" }, ///ָ
 {TxtHostMsgbox, "\x80\x62\x4b\x67\x3a\x4f\xe1\x7b\xb1\x4f\xdd\x62\xa4\x00\x00" }, ///ֻ䱣
 {TxtHostKeySet, "\x80\x62\x4b\x67\x3a\x5b\xc6\x78\x01\x5f\x00\x54\x2f\x00\x00" },  //ֻ뿪
 {TxtHostKeyChange, "\x80\x62\x4b\x67\x3a\x5b\xc6\x78\x01\x4f\xee\x65\x39\x00\x00" }, ///ֻ޸
 {TxtHostKeyItems, "\x80\x4f\xdd\x62\xa4\x98\x79\x00\x00" },						/// xsf changed 2002.11.08
 {TxtEnterHostKey, "\x80\x8b\xf7\x8f\x93\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x00\x00" }, ///
 {TxtSimReplaced, "\x80\x00S\x00I\x00M\x53\x61\x88\xab\x66\xf4\x63\x62\x00\x00"},  //xsf add "SIM"2003.04.10
 {TxtHostKeyOk, "\x80\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x6b\x63\x78\x6e\x00\x00" }, ///ȷ
 {TxtHostKeyFail, "\x80\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x95\x19\x8b\xef\x00\x00" }, ///
 {TxtOldHostKey, "\x80\x65\xe7\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x00\x00" }, ///ɻ  
 {TxtNewHostKey, "\x80\x65\xb0\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x00\x00" }, ///»  
 {TxtHostKeyConfirm, "\x80\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x78\x6e\x8b\xa4\x00\x00" }, ///ȷ
 {TxtHostKeyChangeOk, "\x80\x62\x10\x52\x9f\x00!\x00\x00" },	///ɹ
 {TxtHostKeyChangeFail, "\x80\x59\x31\x8d\x25\x00!\x00\x00" },        ///ʧ!
 {TxtHostKeyNotOn, "\x80\x5b\xc6\x78\x01\x67\x2a\x6f\xc0\x6d\x3b\x00\x00" }, ///δ xsf add 2002.08.29
 {TxtHostKeyOpen, "\x80\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x5f\x00\x54\x2f\x00\x00" },	///뿪
 {TxtHostKeyClose, "\x80\x67\x3a\x4e\x3b\x5b\xc6\x78\x01\x51\x73\x95\xed\x00\x00" },	///ر
 {TxtHostkeySelect, "\x80\x8b\xf7\x63\x09\x00O\x00K\x95\x2e\x90\x09\x62\xe9\x00\x00" }, ///밴OKѡxsf add for noticing user to select pro_options with kcd_ok 2003.04.16
 {TxtAnswerTone, "\x80\x63\xa5\x90\x1a\x63\xd0\x79\x3a\x97\xf3\x00\x00" },	///ͨʾ
 {TxtUndoEvent, "\x80\x6f\x0f\x52\x9e\x4e\x8b\x4e\xf6\x63\xd0\x79\x3a\x97\xf3\x00\x00" }, ///©¼ʾ
 {TxtUnreadSMSTone, "\x80\x67\x2a\x8b\xfb\x6d\x88\x60\x6f\x63\xd0\x79\x3a\x00\x00" },	///δϢʾ
 {TxtMissedCallTone, "\x80\x67\x2a\x63\xa5\x75\x35\x8b\xdd\x63\xd0\x79\x3a\x00\x00" },   ///δӵ绰ʾ
 {TxtAlerttype, "\x80\x63\xd0\x79\x3a\x65\xb9\x5f\x0f\x00\x00" }, ///ʾʽ
 {TxtRingmode, "\x80\x54\xcd\x94\xc3\x00\x00" },    //
 {TxtRingPrompt,	"\x80\x94\xc3\x58\xf0\x63\xd0\x79\x3a\x00\x00" },	///ʾxsf add for ring prompt of alarm 09.24
 {TxtVibramode, "\x80\x63\x2f\x52\xa8\x00\x00" }, ///
 {TxtVibraRing, "\x80\x51\x48\x63\x2f\x54\x0e\x94\xc3\x00\x00" }, ///
 {TxtRingandVib,"\x80\x63\x2f\x94\xc3\x54\x0c\x65\xf6\x00\x00" }, ///ͬʱ
 {TxtSmsRing, "\x80\x66\x6e\x90\x1a\x94\xc3\x58\xf0\x00\x00" }, ///ͨ       
 {TxtSpecialRing, "\x80\x72\x79\x6b\x8a\x94\xc3\x58\xf0\x00\x00" }, ///      
 {TxtSmsVibra, "\x80\x63\x2f\x52\xa8\x63\xd0\x79\x3a\x00\x00" }, ///ʾ
 {TxtSmsRVibra, "\x80\x51\x48\x63\x2f\x54\x0e\x94\xc3\x00\x00" }, ///
 {TxtSmsMute, "\x80\x97\x59\x97\xf3\x00\x00" }, ///
 {T_China_Telecomm, "\x80\x4e\x2d\x56\xfd\x79\xfb\x52\xa8\x00\x00" }, ///йƶ
 {T_China_Unicomm, "\x80\x4e\x2d\x56\xfd\x80\x54\x90\x1a\x00\x00" }, ///йͨ
 {TxtDualBand, "\x80\x53\xcc\x98\x91\x00\x00" }, ///˫Ƶ
 {TxtGSM900, "GSM900"}, //(char *)chineseTxtGSM900},  //GSM900
 {TxtDCS1800, "DCS1800"},   //(char *)chineseTxtDCS1800 }, ///DCS1800
 {TxtPLMNInfo, "\x80\x62\x40\x5c\x5e\x7f\x51\x7e\xdc\x00\x00" }, ///
 {TxtPLMNReselect, "\x80\x91\xcd\x65\xb0\x90\x09\x7f\x51\x00\x00" }, ///ѡ
 {TxtRegMode, "\x80\x6c\xe8\x51\x8c\x6a\x21\x5f\x0f\x00\x00" }, ///עģʽ
 {TxtLockBand, "\x80\x95\x01\x5b\x9a\x98\x91\x6b\xb5\x00\x00" }, //end of xsf add 07/08/02 Ƶ
 {TxtSearchingNetwork, "\x80\x6b\x63\x57\x28\x64\x1c\x5b\xfb\x7f\x51\x7e\xdc\x00\x00" },  ///Ѱ xsf add 09.25
 {TxtRegNetwork, "\x80\x7f\x51\x7e\xdc\x6c\xe8\x51\x8c\x00\x00" },	///עxsf add 09.25
 {TxtPLMNavailable, "\x80\x53\xef\x90\x09\x7f\x51\x7e\xdc\x00\x00" },   //xsf add for listmenu title of PLMN reselect ѡ10.10
 {TxtTimeOut, "\x80\x8d\x85\x65\xf6\x00!\x00\x00"},    //ʱ!
 {TxtPhonebook,		"\x80\x75\x35\x8B\xDD\x67\x2C\x00\x00" },//绰
 {TxtPhoneSearch,		"\x80\x67\xe5\x62\x7e\x00\x00"},				//
 {TxtPhoneAdd,			"\x80\x6d\xfb\x52\xa0\x00\x00"},				//
 {TxtGroupingSetting,	"\x80\x52\x06\x7e\xc4\x00\x00"},				//
 {TxtMultiCopy,			"\x80\x59\x0d\x52\x36\x00\x00"},				//
 {TxtClearAll,			"\x80\x51\x68\x90\xe8\x52\x20\x96\x64\x00\x00"},//ȫɾ
 {TxtShortCutDial,		"\x80\x5f\xeb\x63\x77\x62\xe8\x53\xf7\x00\x00"},//ݲ 
 {TxtMyNumber,			"\x80\x67\x2c\x67\x3a\x53\xf7\x78\x01\x00\x00"},//
 {TxtVoiceList,      "\x80\x8B\xED\x97\xF3\x52\x17\x88\x68\x00\x00"},	//б
 {TxtSearchItem,    "\x80\x67\xe5\x8b\xe2\x90\x09\x98\x79\x00\x00"},	//ѯѡ
 {TxtChangeRecord,		"\x80\x7f\x16\x8f\x91\x00\x00"},				//༭
 {TxtCopyRecord,		"\x80\x59\x0d\x52\x36\x00\x00"},				//
 {TxtDeleteRecord,		"\x80\x52\x20\x96\x64\x00\x00"},				//ɾ
 {TxtVoiceCall,			"\x80\x8b\xed\x97\xf3\x62\xe8\x53\xf7\x00\x00"},//   
 {TxtSIMBook,			"\x80\x00\x53\x00\x49\x00\x4d\x53\x61\x75\x35\x8b\xdd\x7c\x3f\x00\x00"},//SIM绰 
 {TxtNVMBook,			"\x80\x62\x4b\x67\x3a\x75\x35\x8b\xdd\x7c\x3f\x00\x00"},//ֻ绰
 {TxtPhoneNew,   "\x80\x65\xb0\x58\x9e\x00\x00"},//
 {TxtEnterName,  "\x80\x54\x0D\x5B\x57\x00\x00"},  //  
 {TxtEnterNumber,		"\x80\x62\x4b\x67\x3a\x00\x00"},						//ֻ
 {TxtEnterHome,			"\x80\x4f\x4f\x5b\x85\x75\x35\x8b\xdd\x00\x00"},		//סլ绰
 {TxtEnterOffice,		"\x80\x52\x9e\x51\x6c\x75\x35\x8b\xdd\x00\x00"},		//칫绰
 {TxtEnterMemo,   "\x80\x59\x07\x6c\xE8\x4f\xe1\x60\x6f\x00\x3a\x00\x00"},  //עϢ:
 {TxtGroupingOne, "\x80\x52\x06\x7e\xc4\x4e\x00\x00\x00"},//һ
 {TxtGroupingTwo, "\x80\x52\x06\x7e\xc4\x4e\x8c\x00\x00"},//
 {TxtGroupingThree, "\x80\x52\x06\x7e\xc4\x4e\x09\x00\x00"},//
 {TxtGroupingFour,  "\x80\x52\x06\x7e\xc4\x56\xdb\x00\x00"},// 
 {TxtGroupingFive,  "\x80\x52\x06\x7e\xc4\x4e\x94\x00\x00"},//
 {TxtGroupingSix,   "\x80\x52\x06\x7e\xc4\x51\x6d\x00\x00"},//
 {TxtGroupingSeven, "\x80\x52\x06\x7e\xc4\x4e\x03\x00\x00"},//
 {TxtGroupingEight, "\x80\x52\x06\x7e\xc4\x51\x6b\x00\x00"},//
 {TxtGroupingNine, "\x80\x52\x06\x7e\xc4\x4e\x5d\x00\x00"},//
 {TxtGroupingTen, "\x80\x9e\xd1\x54\x0d\x53\x55\x00\x00"},//
 {TxtGroupingItem,"\x80\x52\x06\x7e\xc4\x90\x09\x98\x79\x00\x00"},//ѡ
 {TxtBrowserMember,		"\x80\x62\x10\x54\x58\x52\x17\x88\x68\x00\x00"},		//Աб
 {TxtAddMember,"\x80\x90\x09\x62\xe9\x62\x10\x54\x58\x00\x00"},//ѡԱ
 {TxtGroupingIcon,"\x80\x52\x06\x7e\xc4\x56\xfe\x68\x07\x00\x00"},//ͼ 
 {TxtGroupingRing,"\x80\x52\x06\x7e\xc4\x94\xc3\x58\xf0\x00\x00"},//
 {TxtGroupingRename,"\x80\x91\xcd\x65\xb0\x54\x7d\x54\x0d\x00\x00"},//                                                          //
 {TxtCopyAll,     "\x80\x51\x68\x90\xE8\x59\x0D\x52\x36\x00\x00"},//ȫ 
 {TxtCopySIMtoNVM,		"\x80\x00\x53\x00\x49\x00\x4d\x53\x61\x52\x30\x62\x4b\x67\x3a\x00\x00"},//SIMֻ
 {TxtCopyNVMtoSIM,		"\x80\x62\x4b\x67\x3a\x52\x30\x00\x53\x00\x49\x00\x4d\x53\x61\x00\x00"},//ֻSIM  
 {TxtChoiceCopy, "\x80\x90\x09\x62\xE9\x59\x0D\x52\x36\x00\x00"},//ѡ 
 {TxtNullNumber,		"\x80\x67\x2a\x5b\x9a\x4e\x49\x00\x00"},				//δ
 {TxtPhoneSelect, "\x80\x90\x09\x62\xe9\x53\xf7\x78\x01\x00\x00"},//ѡ
 {TxtEditSucceed, "\x80\x4f\xee\x65\x39\x62\x10\x52\x9f\x00\x00"},//޸ĳɹ
 {TxtEditFail    , "\x80\x4f\xee\x65\x39\x59\x31\x8d\x25\x00\x00"},//޸ʧ
 {TxtAddSucceed, "\x80\x6d\xfb\x52\xa0\x62\x10\x52\x9f\x00\x00"},//ӳɹ
 {TxtAddFail,     "\x80\x6d\xfb\x52\xa0\x59\x31\x8d\x25\x00\x00"},//ʧ
 {TxtCopySucceed,"\x80\x59\x0d\x52\x36\x62\x10\x52\x9f\x00\x00"},//Ƴɹ
 {TxtCopyFail    ,"\x80\x59\x0d\x52\x36\x59\x31\x8d\x25\x00\x00"},//ʧ
 {TxtDelSucceed, "\x80\x52\x20\x96\x64\x62\x10\x52\x9f\x00\x00"},//ɾɹ
 {TxtDelFail,     "\x80\x52\x20\x96\x64\x59\x31\x8d\x25\x00\x00"},//ɾʧ
 {TxtPhbkFull,    "\x80\x75\x35\x8B\xDD\x67\x2C\x5D\xF1\x6E\xE1\x00\x21\x00\x00"},//绰!   
 {TxtBrowse,     "\x80\x6d\x4f\x89\xc8\x00\x00"}, 
 {TxtVoiceMemoAdd,"\x80\x5f\x55\x97\xf3\x00\x00"},
 {TxtVoiceMemory,"\x80\x5f\x55\x97\xf3\x5b\xb9\x91\xcf\x00\x00"},//         
 {TxtRecVoice,   "\x80\x5F\x55\x52\x36\x8B\xED\x97\xF3\x00\x00"}, //¼ 
 {TxtPhbkFind,   "\x80\x4e\x2a\x62\x7e\x52\x30\x00\x21\x00\x00"},//ҵ!
 {TxtPhbkCopy,  "\x80\x4e\x2a\x88\xab\x59\x0d\x52\x36\x00\x21\x00\x00"},// !
 {TxtPhbkDelMess,"\x80\x66\x2f\x54\x26\x52\x20\x96\x64\x00\x00"},//Ƿɾ
 {TxtPhbkCopyMess,"\x80\x66\x2f\x54\x26\x59\x0d\x52\x36\x00\x00"},//Ƿ
 {TxtDelMember,  "\x80\x52\x20\x96\x64\x62\x10\x54\x58\x62\x10\x52\x9f\x00\x21\x00\x00"},//ɾԱɹ!
 {TxtMemberAdd,  "\x80\x6d\xfb\x52\xa0\x62\x10\x54\x58\x62\x10\x52\x9f\x00\x21\x00\x00"},//ӳԱɹ!
 {TxtDelMemberError, "\x80\x52\x20\x96\x64\x62\x10\x54\x58\x59\x31\x8d\x25\x00\x21\x00\x00"},//ɾԱɹ!
 {TxtMemberAddError, "\x80\x6d\xfb\x52\xa0\x62\x10\x54\x58\x59\x31\x8d\x25\x00\x21\x00\x00"},//ӳԱʧ!
 {TxtPhbkNvmFull,    "\x80\x8b\xdd\x67\x3a\x75\x35\x8b\xdd\x67\x2c\x6e\xe1\x00\x21\x00\x00"},//绰!
 {TxtPhbkSimFull,     "\x80\x00\x53\x00\x49\x00\x4d\x75\x35\x8b\xdd\x67\x2c\x6e\xe1\x00\x21\x00\x00"},//SIM绰! 
 {TxtPhbkNvmEmpty,  "\x80\x8b\xdd\x67\x3a\x75\x35\x8b\xdd\x67\x2c\x65\xe0\x8b\xb0\x5f\x55\x21\x00\x00\x00"},//绰޼¼!
 {TxtPhbkSimEmpty,   "\x80\x00\x53\x00\x49\x00\x4d\x75\x35\x8b\xdd\x67\x2c\x65\xe0\x8b\xb0\x5f\x55\x21\x00\x00\x00"},//SIM绰޼¼!
 {TxtPhbkSIMCopyAll,  "\x80\x59\x0d\x52\x36\x00\x53\x00\x49\x00\x4d\x53\x61\x62\x40\x67\x09\x8b\xb0\x5f\x55\x00\x3f\x00\x00"},//SIMм¼?   
 {TxtPhbkNVMCopyAll,  "\x80\x59\x0d\x52\x36\x8b\xdd\x67\x3a\x75\x35\x8b\xdd\x67\x2c\x62\x40\x67\x09\x8b\xb0\x5f\x55\x00\x3f\x00\x00"},//ƻ绰м¼?  
 {TxtPhbkSIMCopyError,"\x80\x00\x53\x00\x49\x00\x4d\x53\x61\x7a\x7a\x95\xf4\x4e\x0d\x8d\xb3\x00\x00"},//SIM ռ䲻,? 
 {TxtPhbkNVMCopyError,"\x80\x8b\xdd\x67\x3a\x75\x35\x8b\xdd\x67\x2c\x7a\x7a\x95\xf4\x4e\x0d\x8d\xb3\x00\x00"},//绰  ռ䲻,? 
 {TxtPhbkCopying,     "\x80\x6b\x63\x57\x28\x59\x0d\x52\x36\x00\x2e\x00\x2e\x00\x2e\x00\x00"},//ڸ... 
 {TxtPhbkDeleteSIMAll, "\x80\x52\x20\x96\x64\x00\x53\x00\x49\x00\x4d\x53\x61\x62\x40\x67\x09\x8b\xb0\x5f\x55\x54\x17\x00\x3f\x00\x00"},//ɾSIMм¼?
 {TxtPhbkDeleteNVMAll,"\x80\x52\x20\x96\x64\x8b\xdd\x67\x3a\x75\x35\x8b\xdd\x67\x2c\x62\x40\x67\x09\x8b\xb0\x5f\x55\x54\x17\x00\x3f\x00\x00"},//ɾ绰м¼?
 {TxtPhbkChange,     "\x80\x4f\xee\x65\x39\x00\x00"},//޸ 
 {TxtPhbkNumber,     "\x80\x53\xf7\x78\x01\x00\x00"},// 
 {TxtPhbkUse,     "\x80\x5d\xf2\x4f\x7f\x75\x28\x00\x00"},//ʹ
 {TxtPhbkleft,     "\x80\x52\x69\x4f\x59\x00\x00"},//ʣ 
 {TxtMemoryState,	"\x80\x51\x85\x5b\x58\x72\xb6\x60\x01\x00\x00"},//ڴ״̬
 {TxtGroupingIconSucceed, "\x80\x52\x06\x7e\xc4\x56\xfe\x68\x07\x8b\xbe\x7f\x6e\x62\x10\x52\x9f\x00!\x00\x00"},//ͼóɹ!
 {TxtGroupingIconError,    "\x80\x52\x06\x7e\xc4\x56\xfe\x68\x07\x8b\xbe\x7f\x6e\x59\x31\x8d\x25\x00!\x00\x00"},//ͼʧ!
 {TxtGroupingClassmate,	"\x80\x54\x0c\x5b\x66\x00\x00"},//ͬѧ
 {TxtGroupingFriend,	"\x80\x67\x0b\x53\xcb\x00\x00"},//
 {TxtGroupingFamily,	"\x80\x5b\xb6\x4e\xba\x00\x00"},//
 {TxtGroupingWorkmate,	"\x80\x54\x0c\x4e\x8b\x00\x00"},//ͬ
 {TxtRenameForbidden,	"\x80\x79\x81\x6b\x62\x66\xf4\x54\x0d\x00\x00"},//ֹ
 {TxtChangeIconForbidden, "\x80\x79\x81\x6b\x62\x66\xf4\x65\x39\x56\xfe\x68\x07\x00\x00"}, //ֹͼ	/* 2004/04/16 sunsj add */
 {TxtOnlyforBlacklist,	"\x80\x9e\xd1\x54\x0d\x53\x55\x4e\x13\x75\x28\x00\x00"},//ר
 {TxtTestCommand,	"\x80\x6d\x4b\x8b\xd5\x54\x7d\x4e\xe4\x00\x00"},//
 {TxtSoftwareVersion,	"\x80\x8f\x6f\x4e\xf6\x72\x48\x67\x2c\x00\x00"},//汾
 {TxtSpkMic,			"Spk&Mic"},//Spk&Mic Status
 {TxtMemFlashRtc,			"Mem&Flash&Rtc"},//Mem&Flash&Rtc Status
 {TxtProductTest,	"\x80\x75\x1f\x4e\xa7\x6d\x4b\x8b\xd5\x00\x00"},//
 {TxtLCDDisplay,	"\x80\x00\x4c\x00\x43\x00\x44\x6d\x4b\x8b\xd5\x00\x00"},//LCD
 {TxtLEDBacklight,	"\x80\x00\x4c\x00\x45\x00\x44\x63\x09\x95\x2e\x80\xcc\x51\x49\x00\x00"},//LED,
 {TxtMelodyandVibrator,	"\x80\x63\x2f\x94\xc3\x63\x2f\x5b\x50\x6d\x4b\x8b\xd5\x00\x00"},//Ӳ
 {TxtKeyPressTest,	"\x80\x63\x09\x95\x2e\x6d\x4b\x8b\xd5\x00\x00"},//
 { TxtToolkit, (char *)chineseTxtToolkit},
 #if(MAIN_LCD_SIZE==3)
 { TxtCamera, (char *)chineseTxtCamera},//Knuth
#endif
 { TxtStopwatch,(char*)    chineseTxtStopwatch},
 {TxtSeparately,(char*)  chineseTxtSeparately},
 {TxtBycircle,(char*)  chineseTxtBycircle},
 {TxtBrowseRecord,(char*)  chineseTxtBrowseRecord},
 {TxtContinue,(char*) chineseTxtContinue},
 {TxtRestart,(char*) chineseTxtRestart},
 {TxtNorecord,(char*) chineseTxtNorecord},
 {TxtConfirm,(char*) chineseTxtConfirm},
 {TxtBack,"Back"},
 {TxtOnebyone,(char*) chineseTxtOnebyone},
 {TxtDeleteError,(char*) chineseTxtDeleteError},
 {TxtSaveError,(char *) chineseTxtSaveError},
 {TxtTimer,(char*) chineseTxtTimer},
 {TxtSetontime,(char*) chineseTxtSetontime},
 {TxtOpen,(char*) chineseTxtOpen},
 {TxtClose,(char*) chineseTxtClose},
 {TxtSettime,(char*) chineseTxtSettime},
 {TxtLefttime,(char*) chineseTxtLefttime},
 {TxtTimeup,(char*) chineseTxtTimeup},
 {TxtAutopower,(char*) chineseTxtAutopower},
 {TxtOpentime,(char*) chineseTxtOpentime},
 {TxtClosetime,(char*) chineseTxtClosetime},
 {TxtNote,(char*) chineseTxtNote},
 {TxtNotebrowse,(char*) chineseTxtNotebrowse},
 {TxtAdd,(char*) chineseTxtAdd},
 {TxtChpriority,(char*) chineseTxtChpriority},
 {TxtToschedule,(char*) chineseTxtToschedule},
 {TxtTomessage,(char*) chineseTxtTomessage},
 {TxtOnce,(char*) chineseTxtFre_Once},
 {TxtDay,(char*) chineseTxtDay},
 {TxtWeek,(char*) chineseTxtWeek},
 {TxtMonth,(char*) chineseTxtMonth},
 {TxtYear,(char*) chineseTxtYear},
 {TxtRing,(char*) chineseTxtRing},
 {TxtSchedule,(char*) chineseTxtSchedule},
	/*talcon add for pcsyn,2004.07.06*/
#ifdef MMI_PCSYN_ENABLED
 {TxtPCSyn,(char*) chineseTxtPCSyn},
#endif
 {TxtWeekDay,(char*) chineseTxtWeekDay},
 {TxtNewSche,(char*) chineseTxtNewSche},
 {TxtToday,(char*) chineseTxtToday},
 {TxtAllSche,(char*) chineseTxtAllSche},
 {TxtDeleteOld,(char*) chineseTxtDeleteOld},
 {TxtScheMeeting,(char*) chineseTxtScheMeeting},
 {TxtBirthday,(char*) chineseTxtBirthday},
 {TxtAppointment,(char*) chineseTxtAppointment},
 {TxtRemind,(char*) chineseTxtRemind},
 {TxtReConfirm,(char*) chineseTxtReConfirm},
 {TxtInputError,(char*) chineseInputError},
 {TxtResult,(char*) chineseTxtResult},
 {TxtDeleteOnebyOne,(char*) chineseTxtDeleteOnebyOne},
 {TxtConversion,(char*) chineseTxtConversion},
 {TxtLength,(char*) chineseTxtLength},
 {TxtAcre,(char*) chineseTxtAcre},
 {TxtUnitVolume,(char*) chineseVolume},
 {TxtWeight,(char*) chineseWeight},
 {TxtInitValue,(char*) chineseInitValue},
 {TxtResultValue,(char*) chineseResultValue},
 {TxtNext,(char*) chineseNext},
 {TxtOverflow,(char*) chineseOverflow},
 {TxtCall,(char*) chineseCall},
 {TxtUnitChange,(char*) chineseUnitchange},
 {TxtStroke,(char*) chineseTxtStroke},
 {TxtYMD,(char*) chineseTxtYMD},
 {TxtBrowseAlarm,(char*) chineseTxtBrowseAlarm},
 {TxtAutoOff,(char*) chineseTxtAutoOff},
 {TxtAutoConfirm,(char*) chineseTxtAutoConfirm},
 {TxtScheSMS,(char*) chineseTxtScheSMS},
 {TxtTooLong,(char*) chineseTxtTooLong},
 {TxtMemo,(char*) chineseTxtMemo},
 {TxtCover,(char*) chineseTxtCover},
 {TxtAddMemo,(char*) chineseTxtAddMemo},
 {TxtCalinder,"\x80\x65\xe5\x7a\x0b\x88\x68\x00\x00"},
 {TxtPowerOnTime,"\x80\x5f\x00\x67\x3a\x65\xf6\x95\xf4\x00\x00"},
 {TxtPowerOffTime,"\x80\x51\x73\x67\x3a\x65\xf6\x95\xf4\x00\x00"},
 {TxtAutoPowerOn,"\x80\x81\xea\x52\xa8\x5f\x00\x67\x3a\x00\x00"},
 {TxtAutoPowerOff,"\x80\x81\xea\x52\xa8\x51\x73\x67\x3a\x00\x00"},
 {TxtValue,"\x80\x50\x3c\x00"},
 {TxtSelectDate,"\x80\x63\x09\x00\x4f\x00\x4b\x95\x2e\x90\x09\x62\xe9\x65\xe5\x67\x1f\x00\x00"},	// wyj MI18800000423
 {TxtGamestart,(char *)chineseTxtGamestart},
 {TxtGameedit,(char *)chineseTxtGameedit},
 {TxtGameselect,(char *)chineseTxtGameselect},
 {TxtGamesetting,(char *)chineseTxtGamesetting},
 {TxtGamehelp,(char *)chineseTxtGamehelp},
 {TxtGameScore,(char *)chineseTxtGamescore},
 {TxtGameRestart,(char *)chineseTxtGamerestart},
 {TxtGameWinCondition,(char *)chineseTxtGameWinCondition},
 {TxtGameStageCruTtl,(char *)chineseTxtGameStageCruTtl},
 {TxtGameStageInput,(char *)chineseTxtGameStageInput},
 {TxtGameExit,(char *)chineseTxtGameExit},
 {TxtGameExitConfirm,(char *)chineseTxtGameExitConfirm},//2004-04-20 Sunny add
 {TxtGameNext,(char *)chineseTxtGameNext},//2004-04-19 Sunny add
 {TxtGameGoon,(char *)chineseTxtGamegoon},
 {TxtSnakegame,(char *)chineseTxtSnakegame},//2003/12/19,talcon add
 {TxtBoxmangame, (char *)chineseTxtBoxmangame},
 {TxtBoxmanHelp, (char *)chineseTxtBoxmanHelp},//2004-04-23 Sunny add
 {TxtSnakeHelp, (char *)chineseTxtSnakeHelp},//2004-04-23 Sunny add
 {TxtCalendarYear,(char *)chineseYear},
 {TxtCalendarMonth,(char *)chineseMonth},
  {TxtBalloongame, (char *)chineseTxtBalloongame},
  {TxtRussiagame, (char *)chineseTxtRussiagame},
 {TxtSoftClearall,(char *)chineseTxtClearall},
 {TxtFlashErr, (char *)chineseTxtFlashErr},	//hxl add 20021029
 { TxtGame, "\x80\x6e\x38\x62\x0f\x00\x00" },
{ TxtSuoha, "\x80\x68\xad\x54\xc8\x00\x00" },
{ TxtSuohaNew, "\x80\x65\xb0\x6e\x38\x62\x0f\x00\x00"}, //zhangzg 08/14/2002
{ TxtSuohaPre, "\x80\x4e\x0a\x4e\x00\x6b\x21\x00\x00"}, //zhangzg 08/14/2002
    { TxtConnected, "Connected"}, // SH
    { TxtGSM_900,"GSM 900"},	// SH
    { TxtDCS_1800,"DCS 1800"},
	{ TxtPCS_1900,"PCS 1900"},
    { TxtE_GSM, "E GSM"},
	{ TxtGSM_850, "GSM 850"},
    { TxtCallTimeout, "\x80\x54\x7c\x53\xeb\x8d\x85\x65\xf6\x00\x00" },	///гʱ   
	{ TxtBand, "Band"},       
    { TxtSatRefresh, "SAT refresh" }, 
    { TxtCallBlocked, "\x80\x54\x7c\x53\xeb\x96\x50\x52\x36\x00" },	///
	{ TxtSRR, "\x80\x72\xb6\x60\x01\x62\xa5\x54\x4a\x00" },	///״̬// Marcus: Issue 1170: 30/09/2002
 	{ TxtDelivered, "\x80\x5d\xf2\x53\xd1\x5f\x80\x00" },	///ѷ// Marcus: Issue 1170: 07/10/2002
 	{ TxtTempError, (char *)chineseTxtTempError }, // Marcus: Issue 1170: 07/10/2002
    	{TxtSetDate, "\x80\x8b\xbe\x7f\x6e\x65\xe5\x67\x1f\x00" },	///
    	{TxtSetTime, "\x80\x8b\xbe\x7f\x6e\x65\xf6\x95\xf4\x00" },	///ʱ
    	{TxtFullHrAlert, "\x80\x65\x74\x70\xb9\x62\xa5\x65\xf6\x00" },	///㱨ʱ
    	{TxtWorldTime, "\x80\x4e\x16\x75\x4c\x65\xf6\x94\x9f\x00\x00" },	///ʱ
    {TxtKwajalein, "\x80\x59\x38\x8d\x3e\x67\x97\x5c\x9b\x00" },	///ֵ
    {TxtMidwayIs, "\x80\x4e\x2d\x90\x14\x5c\x9b\x00" },	///;
    {TxtSamoa, "\x80\x84\x28\x64\x69\x4e\x9a\x7f\xa4\x5c\x9b\x00" },	///ĦȺ
    {TxtHawaii, "\x80\x59\x0f\x5a\x01\x59\x37\x00" },	///
    {TxtHonolulu, "\x80\x70\x6b\x59\x74\x9c\x81\x9c\x81\x00" },	///ū³³
    {TxtAlaska, "\x80\x96\x3f\x62\xc9\x65\xaf\x52\xa0\x00" },	///˹
    {TxtLosAngeles, "\x80\x6d\x1b\x67\x49\x77\xf6\x00" },	///ɼ
    {TxtSanFrancisco, "\x80\x65\xe7\x91\xd1\x5c\x71\x00" },	///ɽɽ
    {TxtDenver, "\x80\x4e\x39\x4f\x5b\x00" },	///
    {TxtChicago, "\x80\x82\x9d\x52\xa0\x54\xe5\x00" },	///֥Ӹ
    {TxtMexicoCity, "\x80\x58\xa8\x89\x7f\x54\xe5\x57\xce\x00" },	///ī
    {TxtNewYork, "\x80\x7e\xbd\x7e\xa6\x00" },	///ŦԼ
    {TxtLima, "\x80\x52\x29\x9a\x6c\x00" },	///
    {TxtMontreal, "\x80\x84\x99\x72\x79\x52\x29\x5c\x14\x00" },	///
    {TxtSantiago, "\x80\x57\x23\x57\x30\x4e\x9a\x54\xe5\x00" },	///ʥǸ
    {TxtLaPaz, "\x80\x62\xc9\x5d\xf4\x65\xaf\x00" },	///˹
    {TxtBrasilia, "\x80\x5d\xf4\x89\x7f\x52\x29\x4e\x9a\x00" },	///
    {TxtRioDeJaneiro, "\x80\x91\xcc\x7e\xa6\x70\xed\x51\x85\x53\x62\x00" },	///Լ¬
    {TxtMidAtlantic, "\x80\x4e\x2d\x59\x27\x89\x7f\x6d\x0b\x00" },	///д
    {TxtCapeVerdeIs, "\x80\x4f\x5b\x5f\x97\x89\xd2\x7f\xa4\x5c\x9b\x00" },	///ýȺ
    {TxtLondon, "\x80\x4f\x26\x65\x66\x00" },	///׶
    {TxtCasablanca, "\x80\x53\x61\x84\x28\x5e\x03\x51\x70\x53\x61\x00" },	///
    {TxtLisbon, "\x80\x91\xcc\x65\xaf\x67\x2c\x00" },	///˹
    {TxtRome, "\x80\x7f\x57\x9a\x6c\x00" },	///
    {TxtBerlin, "\x80\x67\xcf\x67\x97\x00" },	///
    {TxtParis, "\x80\x5d\xf4\x9e\xce\x00" },	///
    {TxtMadrid, "\x80\x9a\x6c\x5f\xb7\x91\xcc\x00" },	///
    {TxtAthens, "\x80\x96\xc5\x51\x78\x00" },	///ŵ
    {TxtEasternEurope, "\x80\x4e\x1c\x6b\x27\x00" },	///ŷ
    {TxtHelsinki, "\x80\x8d\x6b\x5c\x14\x8f\x9b\x57\xfa\x00" },	///ն
    {TxtBaghdad, "\x80\x5d\xf4\x68\x3c\x8f\xbe\x00" },	///͸
    {TxtKoweit, "\x80\x79\xd1\x5a\x01\x72\x79\x00" },	///
    {TxtMoscow, "\x80\x83\xab\x65\xaf\x79\xd1\x00" },	///Ī˹
    {TxtTbilisi, "\x80\x7b\x2c\x6b\xd4\x52\x29\x65\xaf\x00" },	///ڱ˹
    {TxtIslamabad, "\x80\x4f\x0a\x65\xaf\x51\x70\x58\x21\x00" },	///˹
    {TxtAlmaty, "\x80\x96\x3f\x9a\x6c\x63\xd0\x00" },	///
    {TxtDhaKa, "\x80\x8f\xbe\x53\x61\x00" },	///￨
    {TxtBangkok, "\x80\x66\xfc\x8c\x37\x00" },	///
    {TxtJaKarta, "\x80\x96\xc5\x52\xa0\x8f\xbe\x00" },	///żӴ
    {TxtBeiJing, "\x80\x53\x17\x4e\xac\x00" },	///
    {TxtHongkong, "\x80\x99\x99\x6e\x2f\x00" },	///
    {TxtSingapore, "\x80\x65\xb0\x52\xa0\x57\x61\x00" },	///¼
    {TxtSeoul, "\x80\x6c\x49\x57\xce\x00" },	///
    {TxtTokyo, "\x80\x4e\x1c\x4e\xac\x00" },	///
    {TxtGuam, "\x80\x51\x73\x5c\x9b\x00" },	///ص
    {TxtSydney, "\x80\x60\x89\x5c\x3c\x00" },	///Ϥ
    {TxtVladivostok, "\x80\x6d\x77\x53\xc2\x5d\x34\x00" },	///
    {TxtSolomonIs, "\x80\x62\x40\x7f\x57\x95\xe8\x7f\xa4\x5c\x9b\x00" },	///Ⱥ
    {TxtFiji, "\x80\x65\x90\x6d\x4e\x00" },	///쳼
    {TxtMarshallIs, "\x80\x9a\x6c\x7e\xcd\x5c\x14\x7f\xa4\x5c\x9b\x00" },	///ܶȺ
    {TxtWellington, "\x80\x60\xe0\x70\x75\x98\x7f\x00" },	///
    {TxtDailyAlarm, "\x80\x6b\xcf\x65\xe5\x95\xf9\x94\x9f\x00" },	///ÿ
    {TxtWeeklyAlarm, "\x80\x6b\xcf\x54\x68\x95\xf9\x94\x9f\x00" },	///ÿ
       {TxtSoftChange, "\x80\x4f\xee\x65\x39\x00" },	///޸
    	{TxtSunday,"\x80\x66\x1f\x67\x1f\x65\xe5\x00" },	///
    	{TxtMonday,"\x80\x66\x1f\x67\x1f\x4e\x00\x00" },	///һ
    	{TxtTuesday,"\x80\x66\x1f\x67\x1f\x4e\x8c\x00" },	///ڶ
    	{TxtWednesday,"\x80\x66\x1f\x67\x1f\x4e\x09\x00" },	///
    	{TxtThursday,"\x80\x66\x1f\x67\x1f\x56\xdb\x00" },	///
    	{TxtFriday,"\x80\x66\x1f\x67\x1f\x4e\x94\x00" },	///
    	{TxtSaturday,"\x80\x66\x1f\x67\x1f\x51\x6d\x00" },	///
    {TxtSendTo,      "\x80\x53\xd1\x5f\x80\x00\x00" },	///
    {TxtRecieveFrom,  "\x80\x67\x65\x81\xea\x00\x00" },	///
 {TxtReadSms,"\x80\x8b\xfb\x6d\x88\x60\x6f\x00\x00" },	///Ϣ//windy
 {TxtReadMt,"\x80\x65\x36\x4e\xf6\x7b\xb1\x00\x00" },	///ռ
 {TxtReadMo,"\x80\x53\xd1\x4e\xf6\x7b\xb1\x00\x00" },	///
 {TxtSendSms, "\x80\x51\x99\x6d\x88\x60\x6f\x00\x00" },	///дϢ
 {TxtUNSend,"\x80\x67\x2a\x53\xd1\x90\x01\x00\x00" },	///δ
 { TxtSMSSettings, "\x80\x77\xed\x4f\xe1\x8b\xbe\x7f\x6e\x00\x00" },///
	{T_CBLanguageAll ,    "\x80\x62\x40\x67\x09\x8b\xed\x8a\x00\x00\x00" },	///
	{T_CBLanguageNone , "\x80\x79\x81\x6b\x62\x62\x40\x67\x09\x00\x00" },	///ֹ
	{T_CBGerman ,      "\x80\x5f\xb7\x65\x87\x00\x00" },	///
	{T_CBEnglish  ,    "\x80\x82\xf1\x65\x87\x00\x00" },	///Ӣ
	{T_CBItalian,       "\x80\x61\x0f\x59\x27\x52\x29\x8b\xed\x00\x00" },	///
	{T_CBFrench ,      "\x80\x6c\xd5\x65\x87\x00\x00" },	///
	{T_CBSpanish,      "\x80\x89\x7f\x73\xed\x72\x59\x8b\xed\x00\x00" },	///
	{T_CBDutch ,       "\x80\x83\x77\x51\x70\x8b\xed\x00\x00" },	///
	{T_CBSwedish ,     "\x80\x74\x5e\x51\x78\x8b\xed\x00\x00" },	///
	{T_CBDanish   ,    "\x80\x4e\x39\x9e\xa6\x8b\xed\x00\x00" },	///
	{T_CBPortuguese ,  "\x80\x84\x61\x84\x04\x72\x59\x8b\xed\x00\x00" },	///
	{T_CBFinnish   ,   "\x80\x82\xac\x51\x70\x8b\xed\x00\x00" },	///
	{T_CBNorwegian  ,  "\x80\x63\x2a\x5a\x01\x8b\xed\x00\x00" },	///Ų
	{T_CBGreek ,         "\x80\x5e\x0c\x81\x4a\x8b\xed\x00\x00" },	///ϣ
	{T_CBTurkish         ,"\x80\x57\x1f\x80\x33\x51\x76\x8b\xed\x00\x00" },	///
	{T_CBHungarian      ,"\x80\x53\x08\x72\x59\x52\x29\x8b\xed\x00\x00" },	///
	{T_CBPolish        ,"\x80\x6c\xe2\x51\x70\x8b\xed\x00\x00" },	///      
	{T_CBLanguage      ,"\x80\x8b\xed\x8a\x00\x90\x09\x62\xe9\x00" },	///ѡ
 	{TxtOnOff,    "\x80\x5f\x00\x51\x73\x00\x00" },	///
	{TxtCBCHSET,   "\x80\x98\x91\x90\x53\x8b\xbe\x7f\x6e\x00\x00" },	///Ƶ
 	{TxtCommonMsg,    "\x80\x5e\x38\x75\x28\x4f\xe1\x60\x6f\x00\x00" },	///Ϣ
 	{TxtSaveToFfs,   "\x80\x4f\xdd\x5b\x58\x4e\x3a\x6a\x21\x67\x7f\x00\x00" },	///Ϊģ
  	{TxtSendOnly,    "\x80\x4e\xc5\x53\xd1\x90\x01\x00\x00" },	///
 	{TxtSendSave,    "\x80\x53\xd1\x90\x01\x4e\x14\x4f\xdd\x5b\x58\x00\x00" },	///ұ
 	{TxtInsertCMmsg, "\x80\x63\xd2\x51\x65\x5e\x38\x75\x28\x4f\xe1\x60\x6f\x00\x00" },	//볣Ϣ
 	{TxtNVMMsg,    	  "\x80\x62\x4b\x67\x3a\x4f\xe1\x7b\xb1\x00" },	///ֻ
 	{TxtSaveToNVM,    "\x80\x5b\x58\x52\x30\x62\x4b\x67\x3a\x4f\xe1\x7b\xb1\x00\x00" },	///ת浽ֻ
  	{TxtSMSNVMFull,   "\x80\x62\x4b\x67\x3a\x4f\xe1\x7b\xb1\x5d\xf2\x6e\xe1\x00\x00" },	///ֻ
 	{TxtDeletingSms,  "\x80\x6b\x63\x57\x28\x52\x20\x96\x64\x00" },	///ɾ
 	{TxtSavingSms,    "\x80\x6b\x63\x57\x28\x4f\xdd\x5b\x58\x00" },	///ڱ
 	{TxtSmsFull,    "\x80\x00S\x00I\x00M\x53\x61\x4f\xe1\x7b\xb1\x5d\xf2\x6e\xe1\x00" },	///SIM
 	{TxtSIMSms,    "\x80\x00\x53\x00\x49\x00\x4d\x53\x61\x4f\xe1\x7b\xb1\x00" },///SIM
    {TxtCBChanel,"\x80\x98\x91\x90\x53\x00" },	///Ƶ
    {TxtDelThisMsg1,"\x80\x52\x20\x96\x64\x00S\x00I\x00M\x53\x61\x4e\x2d\x00" },	///ɾSIM
    {TxtDelThisMsg2,"\x80\x8b\xe5\x6d\x88\x60\x6f\xff\x1f\x00" },	///Ϣ
    {TxtTryAgain,"\x80\x8b\xf7\x91\xcd\x8b\xd5\x00" },	///
    {TxtUselessSMS,"\x80\x65\xe0\x65\x48\x6d\x88\x60\x6f\x00" },	///ЧϢ
    {TxtAdviceDel,"\x80\x5e\xfa\x8b\xae\x52\x20\x96\x64\x00" },	///ɾ
    {TxtReadingSms,"\x80\x6b\x63\x57\x28\x8b\xfb\x53\xd6\x00" },	///ڶȡ
    {TxtInvalidMessage, "\x80\x65\xe0\x65\x48\x6d\x88\x60\x6f\x00" },	///ЧϢ
 	{TxtChanelFull,    "\x80\x98\x91\x90\x53\x5d\xf2\x6e\xe1\x00" },	///Ƶ
 	{TxtNVMInbox, "\x80\x62\x4b\x67\x3a\x65\x36\x4e\xf6\x7b\xb1\x00\x00" },	///ֻռ
 	{TxtNVMOutbox, "\x80\x62\x4b\x67\x3a\x53\xd1\x4e\xf6\x7b\xb1\x00\x00" },	///ֻ
 { TxtRussia, "\x80\x4f\xc4\x7f\x57\x65\xaf\x65\xb9\x57\x57\x00"},
 { TxtActive, "\x80\x90\x1a\x8b\xdd\x4e\x2d\x00\x00" },	//ͨ/*2003/12/9, wangyan modify*/
 { TxtCallSetup, "\x80\x54\x7c\x53\xeb\x00\x00" }, //
 {TxtShortCutMenu,(char *)chineseTxtShortCutMenu},
 {TxtFunctionSelect,(char *)chineseTxtFunctionSelect},
 {TxtDeleteAllFunctions,(char *)chineseTxtDeleteAllFunctions},
 {TxtHallOnConnect,(char *)chineseTxtHallOnConnect},
 {TxtLedSetting,(char *)chineseTxtLedControl},//zy 2003-02-11
 {TxtRejectCalls,(char *)chineseTxtRejectCalls},  //hu binhao 11-22
 {TxtIncomingCallTime,(char *)chineseTxtIncomingCallTime},  //hu binhao 11-22
 {TxtDialTime,(char *)chineseTxtDialTime},  //hu binhao 11-22
 {TxtName,(char *)chineseTxtName},  //hu binhao 11-22
 {TxtNumberShow,(char *)chineseTxtNumberShow},  //hu binhao 11-22
 {TXTNoRecentNumber,(char *)chineseTXTNoRecentNumber},  //hu binhao 12-3
 {TxtEnterDivertNumber,(char *)chineseTxtEnterDivertNumber},  //hu binhao 12-17
 { TxtOutgoingDataNew, (char*)chineseTxtOutgoingData },   //hu binhao 2002-12-25
 { TxTMakeSureTimeReset, (char*)chineseTxTMakeSureTimeReset },   //hu binhao 2002 12-26
 { TxtHaveReset, (char*)chineseTxtHaveReset },   //hu binhao 2003-1-17
 {Txtonlinefunction,(char *)chineseTxtonlinefunction},  //zhaowm 2002.12.15
 {Txtnotitle,(char *)chineseTxtnotitle},         //zhaowm 2002.12.18
 {TxtnoGPRSservice,(char *)chineseTxtnoGPRSservice},   
 { Txt5sec,       (char *)chinese5sec },
 { Txt10sec,      (char *)chinese10sec }, 
 { Txt15sec,      (char *)chinese15sec },
 { Txt20sec,      (char *)chinese20sec },
 { Txt25sec,      (char *)chinese25sec },
 { Txt30sec,      (char *)chinese30sec },
 { TxtSetCFTime,  (char *)chineseCFTime },    
 {Txtfunction,(char *)chineseTxtfunction},    
 {Txtdisconnectionbrow,(char *)chineseTxtdisconnectionbrow},    
 {TxtSOFTBACK,(char *)chineseTxtSOFTBACK},    
 {TxtLIST,(char *)chineseTxtLIST},    
 {TxtShowDetails, (char *)chineseShowDetail },		//
 {TxtAddVoiceDial,(char *)chineseAddVoiceDial},//yq added for add voicedial 2003/3/12
 {TxtModifyVoiceDial,(char *)chineseModifyVoiceDial},
 {TxtVoiceDialFull,(char *)chineseVoiceDialFull},
 {TxtNoVoiceDial,(char *)chineseNoVoiceDial},
 {TxtStartEnroll,(char *)chineseStartEnroll},
 {TxtEnrolling,(char *)chineseEnrolling},
 {TxtEnrollSucess,(char *)chineseEnrollSucess},
 {TxtStartUpdate,(char *)chineseStartUpdate},
 {TxtVoiceUpdating,(char *)chineseVoiceUpdating},
 {TxtUpdateSucess,(char *)chineseUpdateSucess},
 {TxtRecordSucess,(char *)chineseRecordSucess},
 {TxtEnrollError,(char *)chineseEnrollError},
 {TxtUpdateError,(char *)chineseUpdateError},
 {TxtStartDial,(char *)chineseStartDial},
 {TxtDialing,(char *)chineseDialing},
 {TxtDialOk,(char *)chineseDialOk},
 {TxtDialRedial,(char *)chineseDialRedial},
 {TxtDialError,(char *)chineseDialError},
 {TxtPlayingNow,(char *)chinesePlayingNow},
 {TxtEnrollOnceMore,(char *)chineseEnrollOnceMore},
 {TxtCallReady,(char *)chineseCallReady},//end yq added for voicedial
 {TxtRange,(char *)chineseTxtTxtRange},
 {TxtConnection,"\x80\x8f\xde\x63\xa5\x00\x00"},   //ganchunhui 2003/4/6
 {TxtRoaming,"\x80\x6f\x2b\x6e\x38\x00\x00"},  //ganchunhui 2003/4/6  roaming
 {TxtOpenDivert,		(char *)chineseTxtOpenDivert},
 {TxtCloseDivert,	(char *)chineseTxtCloseDivert},
 { TxtLimitedService,(char*)chineseTxtLimitedService },
 { TxtCallDuration,(char*)chineseTxtCallDuration },
 { TxtAocStatistics,(char*)    chineseTxtAocStatistics},/* 2003/10/28, wangyan, modify AOC statistics menu*/
 {TxtInvalidService, (char*)chineseTxtInvalidService},/* 2003/11/23, glowing, add invalid service*/
 {TxtOnRing, (char*)chineseTxtOnRing},
 {TxtOffRing, (char*)chineseTxtOffRing},
 {TxtOnOffRing, "\x80\x5f\x00\x51\x73\x67\x3a\x94\xc3\x58\xf0\x00\x00"},
 {TxtOnVolume, "\x80\x94\xc3\x58\xf0\x97\xf3\x91\xcf\x00\x00"},
 {TxtOffVolume,"\x80\x94\xc3\x58\xf0\x97\xf3\x91\xcf\x00\x00"},
 {TxtHallOnRing, (char*)chineseTxtHallOnRing},
 {TxtHallOffRing, (char*)chineseTxtHallOffRing},
 {TxtHallOnOffRing,"\x80\x5f\x00\x51\x73\x76\xd6\x94\xc3\x58\xf0\x00\x00"},
 {TxtHallOnVolume, "\x80\x94\xc3\x58\xf0\x97\xf3\x91\xcf\x00\x00"},//
 {TxtHallOffVolume,"\x80\x94\xc3\x58\xf0\x97\xf3\x91\xcf\x00\x00"},//
 {TxtGroupSelect, "\x80\x94\xc3\x58\xf0\x90\x09\x62\xe9\x00\x00"},//ѡ
 {TxtGroupMute,"\x80\x65\xe0\x52\x06\x7e\xc4\x94\xc3\x58\xf0\x00\x00"},//޷
 {TxtSwitchLED, "\x80\x4e\x03\x5f\x69\x70\x6f\x00\x00"},
 {TxtCheckHideID,"\x80\x8b\xf7\x68\xc0\x67\xe5\x96\x90\x85\xCF\x8E\xAB\x4E\xFD\x00\x00"},//

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
	{TxtCamCatch,	"\x80\x62\xcd\x71\x67\x00\x00"},	//
	{TxtCamBook,	"\x80\x76\xf8\x51\x8c\x00\x00"},	//
	{TxtCamProperty,"\x80\x5c\x5e\x60\x27\x00\x00"},	//
	{TxtCamMirror, 		"\x80\x95\x5c\x50\xcf\x00\x00"},//
	{TxtCamSize,		"\x80\x56\xfe\x72\x47\x59\x27\x5c\x0f\x00\x00"},//ͼƬС
	{TxtCamRotation,	"\x80\x65\xcb\x8f\x6c\x00\x00"},//ת
	{TxtCamVGA, 		"VGA(640*480)"},
    {TxtCamQVGA,        "QVGA(320*240)"},
    {TxtCamQQVGA,       "QQVGA(160*120)"},
	{TxtCamMobile,		"Moblie(128*120)"},

    {TxtCam90,      "\x80\x65\xcb\x8f\x6c\x00\x39\x00\x30\x5e\xa6\x00\x00"},//ת90
    {TxtCam180,     "\x80\x65\xcb\x8f\x6c\x00\x31\x00\x38\x00\x30\x5e\xa6\x00\x00"},//ת180
    {TxtCam270,     "\x80\x65\xcb\x8f\x6c\x00\x32\x00\x37\x00\x30\x5e\xa6\x00\x00"},//ת270

    {TxtCamQuality, "\x80\x56\xfe\x72\x47\x8d\x28\x91\xcf\x00\x00"}, //ͼƬ
    {TxtCamFine,    "\x80\x7c\xbe\x7e\xc6\x00\x00"},//ϸ
    {TxtCamNor,     "\x80\x4e\x00\x82\x2c\x00\x00"},//һ
    {TxtCamEco,     "\x80\x7e\xcf\x6d\x4e\x00\x00"},//

    {TxtCamOSD,     "\x80\x76\xf8\x68\x46\x00\x00"},//

    {TxtCamM1,      "\x80\x94\xc3\x58\xf0\x00\x31\x00\x00"},//1
    {TxtCamM2,      "\x80\x94\xc3\x58\xf0\x00\x32\x00\x00"},//2
    {TxtCamMelody,  "\x80\x62\xcd\x71\x67\x94\xc3\x58\xf0\x00\x00"},//
#endif


/* 2004/06/19 yhf add */
{TxtBmHelp1, (char*)chineseTxtBmHelp1},
{TxtBmHelp2, (char*)chineseTxtBmHelp2},
{TxtPublicHelp1, (char*)chineseTxtPublicHelp1},
{TxtPublicHelp2, (char*)chineseTxtPublicHelp2},
{TxtPublicHelp3, (char*)chineseTxtPublicHelp3},
{TxtPublicHelp4, (char*)chineseTxtPublicHelp4},
{TxtTerrisHelp1, (char*)chineseTxtTerrisHelp1},
{TxtGameExplain,(char*)chineseTxtGameExplain},	
/* end yhf add */
{TxtExitGame,"\x80\x90\x00\x51\xfa\x54\x17\x00"},
#if MMI_EM_ENABLED
	{ TxtEngineeringMode, "\x80\x5d\xe5\x7a\x0b\x6a\x21\x5f\x0f\x00\x00"},
	{ TxtMobileInfo,  "\x80\x62\x4b\x67\x3a\x4f\xe1\x60\x6f\x00\x00"},
  	{ TxtServingCell,   "\x80\x67\x0d\x52\xa1\x5c\x0f\x53\x3a\x00\x00"},
 	{ TxtNeighbourCell, "\x80\x4e\x34\x8f\xd1\x5c\x0f\x53\x3a\x00\x00"},
 	{ TxtLocation, "\x80\x4f\x4d\x7f\x6e\x53\x3a\x4f\xe1\x60\x6f\x00\x00"}, 
	{ TxtCiphHopDTX, "\x80\x52\xa0\x5b\xc6\x8d\xf3\x98\x91\x00\x00"},
#endif


#ifdef _MMS_ENABLE_
	{TxtMMS,"\x80\x59\x1a\x5a\x92\x4f\x53\x4f\xe1\x60\x6f\x00\x00"},
	{TxtMMSNew,"\x80\x65\xb0\x5e\xfa\x4f\xe1\x60\x6f\x00\x00"},
	{TxtMMSSendFolder,"\x80\x53\xd1\x4e\xf6\x7b\xb1\x00\x00"},
	{TxtMMSRecvFolder,"\x80\x65\x36\x4e\xf6\x7b\xb1\x00\x00"},
	{TxtMMSDraftFolder,"\x80\x83\x49\x7a\x3f\x7b\xb1\x00\x00"},
	{TxtMMSSentFolder,  "\x80\x5d\xf2\x53\xd1\x90\x01\x4f\xe1\x60\x6f\x00\x00"},
	{TxtMMSDeleteAll,"\x80\x51\x68\x90\xe8\x52\x20\x96\x64\x00\x00"},
	{TxtMMSSettings,"\x80\x53\xc2\x65\x70\x8b\xbe\x7f\x6e\x00\x00"},

	{TxtNewMMSTo, "\x80\x81\xf3\xff\x1a\x00\x00"},
	{TxtNewMMSCC,"\x80\x62\x84\x90\x01\xff\x1a\x00\x00"},
	{TxtNewMMSBCC, "\x80\x5b\xc6\x90\x01\xff\x1a\x00\x00"},
	{TxtNewMMSTitle,"\x80\x4e\x3b\x98\x98\xff\x1a\x00\x00"},
	{TxtNewMMSText,"\x80\x65\x87\x67\x2c\xff\x1a\x00\x00"},
	{TxtNewMMSPicture,"\x80\x56\xfe\x72\x47\xff\x1a\x00\x00"},
	{TxtNewMMSMusic, "\x80\x97\xf3\x4e\x50\xff\x1a\x00\x00"},

	{TxtMMSNoImage, "\x80\x56\xfe\x72\x47\x4e\x3a\x7a\x7a\x00\x00"},
	{TxtMMSNoMusic, "\x80\x97\xf3\x4e\x50\x4e\x3a\x7a\x7a\x00\x00"},
	//new
	{TxtMMSSendToNumber,"\x80\x53\xd1\x90\x01\x52\x30\x53\xf7\x78\x01\x00\x00"},
	{TxtMMSSendToEmail,"\x80\x53\xd1\x90\x01\x52\x30\x75\x35\x5b\x50\x90\xae\x4e\xf6\x00\x00"},
	{TxtMMSPreview,"\x80\x98\x84\x89\xc8\x00\x00"},
	{TxtMMSExitNewMsg, "\x80\x90\x00\x51\xfa\x00\x00"},

	//end new

	{TxtAddText,"\x80\x6d\xfb\x52\xa0\x65\x87\x67\x2c\x00\x00"},
	{TxtAddImage,"\x80\x6d\xfb\x52\xa0\x56\xfe\x72\x47\x00\x00"},
	{TxtAddMusic,"\x80\x6d\xfb\x52\xa0\x97\xf3\x4e\x50\x00\x00"},
	{TxtDeleteText,"\x80\x52\x20\x96\x64\x65\x87\x67\x2c\x00\x00"},
	{TxtTextColor,"\x80\x65\x87\x67\x2c\x98\x9c\x82\x72\x00\x00"},
	{TxtAddSlide, "\x80\x6d\xfb\x52\xa0\x4e\x00\x5e\x27\x00\x00"},
	{TxtDeleteSlide,"\x80\x52\x20\x96\x64\x4e\x00\x5e\x27\x00\x00"},
	{TxtSlideColor,"\x80\x5e\x27\x76\x84\x98\x9c\x82\x72\x00\x00"},
	{TxtSlideTime,"\x80\x5e\x27\x76\x84\x65\xf6\x95\xf4\x00\x00"},
	{TxtPreviousSlide, "\x80\x63\xd2\x51\x65\x4e\x00\x5e\x27\x00\x00"},
	{TxtNextSlide,"\x80\x54\x0e\x97\x62\x4e\x00\x5e\x27\x00\x00"},
	{TxtInsertSlide,"\x80\x63\xd2\x51\x65\x4e\x00\x5e\x27\x00\x00"},
	{TxtMMSStoreMsg,"\x80\x5b\x58\x50\xa8\x4f\xe1\x60\x6f\x00\x00"},

	{TxtMMSSendReportOn,"\x80\x62\x53\x5f\x00\x00\x00"},
	{TxtMMSSendReportOff,"\x80\x51\x73\x95\xed\x00\x00"},
	{TxtMMSAutoSaveOn,"\x80\x62\x53\x5f\x00\x00\x00"},
	{TxtMMSAutoSaveOff,"\x80\x51\x73\x95\xed\x00\x00"},
	{TxtMMSAutoRecvOn,"\x80\x62\x53\x5f\x00\x00\x00"},
	{TxtMMSAutoRecvOff,"\x80\x51\x73\x95\xed\x00\x00"},

	{TxtMMSSendReport,"\x80\x53\xd1\x90\x01\x62\xa5\x54\x4a\x00\x00"},
	{TxtMMSAutoSave,"\x80\x81\xea\x52\xa8\x4f\xdd\x5b\x58\x00\x00"},
	{TxtMMSAutoRecv,"\x80\x81\xea\x52\xa8\x63\xa5\x65\x36\x00\x00"},
	{TxtMMSSendSettings, "\x80\x53\xd1\x90\x01\x8b\xbe\x7f\x6e\x00\x00"},
	{TxtMMSRecvSettings, "\x80\x63\xa5\x65\x36\x8b\xbe\x7f\x6e\x00\x00"},
	{TxtMMSNetSettings,"\x80\x00\x4d\x00\x4d\x00\x53\x7f\x51\x7e\xdc\x8b\xbe\x7f\x6e\x00\x00"},

	{TxtMMSDelAll,"\x80\x51\x68\x90\xe8\x4f\xe1\x7b\xb1\x00\x00"},
	{TxtMMSDelSendFolder,"\x80\x53\xd1\x4e\xf6\x7b\xb1\x00\x00"},
	{TxtMMSDelRecvFolder, "\x80\x65\x36\x4e\xf6\x7b\xb1\x00\x00"},  
	{TxtMMSDelDraftFolder, "\x80\x83\x49\x7a\x3f\x7b\xb1\x00\x00"},
	{TxtMMSDelSentFolder,"\x80\x5d\xf2\x53\xd1\x4f\xe1\x7b\xb1\x00\x00"},
	{TxtMMSSendFolderEmpty, "\x80\x53\xd1\x4e\xf6\x7b\xb1\x66\x2f\x7a\x7a\x76\x84\x00\x00"},
	{TxtMMSRecvFolderEmpty,  "\x80\x65\x36\x4e\xf6\x7b\xb1\x66\x2f\x7a\x7a\x76\x84\x00\x00"},  
	{TxtMMSDraftFolderEmpty,"\x80\x83\x49\x7a\x3f\x7b\xb1\x66\x2f\x7a\x7a\x76\x84\x00\x00"},
	{TxtMMSSentFolderEmpty,"\x80\x5d\xf2\x53\xd1\x4f\xe1\x7b\xb1\x66\x2f\x7a\x7a\x76\x84\x00\x00"},
	{TxtMMSDelAllMsg,"\x80\x52\x20\x96\x64\x51\x68\x90\xe8\x4f\xe1\x60\x6f\x00\x00"},


	{TxtMMSPicture, "\x80\x56\xfe\x72\x47\x00\x00"},
	{TxtMMSMusic,  "\x80\x97\xf3\x4e\x50\x00\x00"},
	{TxtMMSRetrieve,"\x80\x53\xd6\x56\xde\x00\x00"},
	{TxtMMSDelete, "\x80\x52\x20\x96\x64\x00\x00" } , 
	{TxtMMSPlay,"\x80\x64\xad\x65\x3e\x00\x00"},
	{TxtMMSReplay,  "\x80\x91\xcd\x65\x3e\x00\x00"},
	{TxtMMSReply, "\x80\x56\xde\x59\x0d\x00\x00" },       
	{TxtMMSFarward,  "\x80\x8f\x6c\x53\xd1\x00\x00"}, 
	{TxtMMSCallback,  "\x80\x56\xde\x53\xeb\x00\x00"},  
	{TxtMMSCutMedia,"\x80\x52\x6a\x52\x07\x5a\x92\x4f\x53\x00\x00"}, 
	{TxtMMSCutAddress,  "\x80\x52\x6a\x52\x07\x57\x30\x57\x40\x00\x00"} ,      
	{TxtMMSDetails,   "\x80\x8b\xe6\x7e\xc6\x8d\x44\x65\x99\x00\x00"},
	{TxtMMSMoveToSentFolder ,"\x80\x79\xfb\x52\x30\x5d\xf2\x53\xd1\x4f\xe1\x7b\xb1\x00\x00" } ,

	{TxtMMSIPAddress,"\x80\x00\x49\x00\x50\x57\x30\x57\x40\x00\x00"},
	{TxtMMSIPPort,  "\x80\x00\x49\x00\x50\x7a\xef\x53\xe3\x00\x00"},
	{TxtMMSISDN, "\x80\x00\x49\x00\x53\x00\x44\x00\x4e\x00\x00"},
	{TxtMMSAnologue,"\x80\x6a\x21\x62\xdf\x00\x00"},
	{TxtMMSGateway,"\x80\x7f\x51\x51\x73\x00\x00"},
	{TxtMMSDataCallType, "\x80\x65\x70\x63\x6e\x90\x1a\x8b\xdd\x7c\x7b\x57\x8b\x00\x00"},
	{TxtMMSDiaNumber,"\x80\x62\xe8\x53\xf7\x53\xf7\x78\x01\x00\x00" },

	{TxtMMSAPN, "\x80\x00\x47\x00\x50\x00\x52\x00\x53\x63\xa5\x51\x65\x70\xb9\x00\x00"},   
	{TxtMMSLoginID, "\x80\x75\x28\x62\x37\x54\x0d\x00\x00"},
	{TxtMMSPassword,"\x80\x5b\xc6\x78\x01\x00\x00"},
	{TxtMMSOnlyGPRS, "\x80\x4e\xc5\x00\x47\x00\x50\x00\x52\x00\x53\x00\x00"},
	{TxtMMSOnlyGSM,  "\x80\x4e\xc5\x00\x47\x00\x53\x00\x4d\x00\x00"},
	{TxtMMSMMSCURL, "\x80\x5f\x69\x4f\xe1\x4e\x2d\x5f\xc3\x00\x00"},
	{TxtMMSGSMSettings,"\x80\x00\x47\x00\x53\x00\x4d\x8b\xbe\x7f\x6e\x00\x00"},
	{TxtMMSGPRSSettings,"\x80\x00\x47\x00\x50\x00\x52\x00\x53\x8b\xbe\x7f\x6e\x00\x00"},
	{TxtMMSTransportMode, "\x80\x4f\x20\x8f\x93\x65\xb9\x5f\x0f\x90\x09\x62\xe9\x00\x00"},		
	{TxtMMSCurSettings,"\x80\x5f\x53\x52\x4d\x8b\xbe\x7f\x6e\x00\x00"},//add by xie 04-07-08
	{TxtMMSAllSettings,"\x80\x8b\xbe\x7f\x6e\x00\x00"},
	{TxtMMSEditGroupName,"\x80\x7f\x16\x8f\x91\x54\x0d\x79\xf0\x00\x00"},

	{TxtMMSDetailFrom, "\x80\x67\x65\x81\xea\x00\x00"},
	{TxtMMSDetailDate,"\x80\x65\xe5\x67\x1f\x00\x00"},
	{TxtMMSDetailTo,"\x80\x52\x30\x00\x00"},
	{TxtMMSDetailSize,"\x80\x59\x27\x5c\x0f\x00\x00"},
	{TxtMMSEmpty,"\x80\x7a\x7a\x00\x00"},

	{TxtMMSTelNumber, "\x80\x75\x35\x8b\xdd\x53\xf7\x78\x01\x00\x00"},
	{TxtMMSEmail,"\x80\x75\x35\x5b\x50\x90\xae\x4e\xf6\x00\x00"},

	{TxtMMSSenderIsEmpty,"\x80\x53\xd1\x90\x01\x80\x05\x66\x2f\x7a\x7a\x76\x84\x00\x00"}, 
	{TxtMMSSendFailed,"\x80\x53\xd1\x90\x01\x59\x31\x8d\x25\x00\x00"},
	{TxtMMSSendSuccess,"\x80\x53\xd1\x90\x01\x62\x10\x52\x9f\x00\x00"},
	{TxtMMSSendCancelled,"\x80\x53\xd1\x90\x01\x88\xab\x53\xd6\x6d\x88\x00\x00"},

	{TxtMMSRecvSuccess,"\x80\x63\xa5\x65\x36\x62\x10\x52\x9f\x00\x00"},
	{TxtMMSRecvCancelled, "\x80\x63\xa5\x65\x36\x88\xab\x53\xd6\x6d\x88\x00\x00"},
	{TxtMMSDataError,"\x80\x65\x70\x63\x6e\x95\x19\x8b\xef\x00\x00"},
	{TxtMMSRecvFailed, "\x80\x63\xa5\x65\x36\x59\x31\x8d\x25\x00\x00"},

	{TxtMMSRetrieving,"\x80\x6b\x63\x57\x28\x53\xd6\x56\xde\x59\x1a\x5a\x92\x4f\x53\x6d\x88\x60\x6f\x00\x00"},
	{TxtMMSSending,"\x80\x53\xd1\x90\x01\x4e\x2d\x00\x00"},
	{TxtMMSPleaseWaitting, "\x80\x8b\xf7\x7a\x0d\x54\x0e\x00\x2e\x00\x2e\x00\x2e\x00\x00"},

	{TxtMMSFileTooBig,"\x80\x65\x87\x4e\xf6\x59\x2a\x59\x27\x00\x00"},
	{TxtMMSSystemError, "\x80\x7c\xfb\x7e\xdf\x51\xfa\x95\x19\x00\x00"},
	{TxtMMSSave, "\x80\x4f\xdd\x5b\x58\x00\x00"},
	{TxtMMSAlreadyExist,"\x80\x65\x87\x4e\xf6\x5d\xf2\x5b\x58\x57\x28\x8b\xf7\x66\xf4\x65\x39\x65\x87\x4e\xf6\x54\x0d\x00\x00"},
	{TxtMMSNoEnoughFlashSpace, "\x80\x00\x66\x00\x6c\x00\x61\x00\x73\x00\x68\x7a\x7a\x95\xf4\x4e\x0d\x59\x1f\x00\x00"},

	{TxtMMSNoImageInCurSlide, "\x80\x5f\x53\x52\x4d\x5e\x27\x6c\xa1\x67\x09\x56\xfe\x72\x47\x00\x00"},
	{TxtMMSNoMusicInCurSlide,"\x80\x5f\x53\x52\x4d\x5e\x27\x6c\xa1\x67\x09\x97\xf3\x4e\x50\x00\x00"},
	{TxtMMSReceiverCanNotBeEmpty,"\x80\x65\x36\x4e\xf6\x4e\xba\x4e\x0d\x80\xfd\x4e\x3a\x7a\x7a\x00\x00"},
	{TxtMMSInvalidInput,"\x80\x8f\x93\x51\x65\x4e\x0d\x6b\x63\x78\x6e\x00\x00"},
	{TxtMMSPleaseInputAgain,"\x80\x8b\xf7\x91\xcd\x65\xb0\x8f\x93\x51\x65\x00\x00"},
	{TxtMMSEdit,  "\x80\x7f\x16\x8f\x91\x00\x00"},
	{TxtMMSNewMMSSum,"\x80\x67\x61\x65\xb0\x59\x1a\x5a\x92\x4f\x53\x4f\xe1\x60\x6f\x00\x00"},
	//end xie

	//begin feng
	{TxtMMSDeleteMusic,"\x80\x52\x20\x96\x64\x97\xf3\x4e\x50\x00\x00"},
	{TxtMMSDeleteImage,"\x80\x52\x20\x96\x64\x56\xfe\x50\xcf\x00\x00"},
	{TxtMMSDeleteContent,"\x80\x52\x20\x96\x64\x65\x87\x67\x2c\x00\x00"},
	{TxtMMSSend,"\x80\x53\xd1\x90\x01\x00\x00"},
	{TxtMMSAddpage,"\x80\x6d\xfb\x52\xa0\x4e\x00\x5e\x27\x00\x00"},
	{TxtMMSDeletepage,"\x80\x52\x20\x96\x64\x4e\x00\x5e\x27\x00\x00"},
	{TxtMMSPageUp,"\x80\x54\x11\x52\x4d\x4e\x00\x5e\x27\x00\x00"},
	{TxtMMSExit, "\x80\x90\x00\x51\xfa\x00\x00"},
	{TxtMMSPageDown,"\x80\x54\x11\x54\x0e\x4e\x00\x5e\x27\x00\x00"},
	{TxtMMSErrorPre,"\x80\x8f\xd9\x5d\xf2\x66\x2f\x67\x00\x52\x4d\x5e\x27\x00\x00"},
	{TxtMMSErrorLast,"\x80\x8f\xd9\x5d\xf2\x66\x2f\x67\x00\x54\x0e\x5e\x27\x00\x00"},
	{TxtMMSErrorLarge,"\x80\x5e\x27\x5d\xf2\x6e\xe1\x00\x00"},
	{TxtMMSErrorZero,"\x80\x5d\xf2\x7e\xcf\x4e\x3a\x7a\x7a\x00\x00"},
	{TxtMMSTitleisnotNull,"\x80\x4e\x3b\x98\x98\x4e\x0d\x80\xfd\x4e\x3a\x7a\x7a\x00\x00"},
	{TxtMMSSent,"\x80\x6d\x88\x60\x6f\x5d\xf2\x53\xd1\x90\x01\x00\x00"},
	//end feng
#endif

//2004.08.05 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
 {TxtPhotoFrameChoice, (char*)chinesePhotoFrameChoice}, //yangx Add
 {TxtPhotoCapacity, (char*)chinesePhotoCapacity}, //yangx Add
 {TxtMemoryCapacity, (char*)chineseMemoryCapacity},  //ynagx Add
 {TxtPhotoProperty, (char*)chinesePhotoProperty},  //yangx Add
 {TxtPhotoSize, (char*)chinesePhotoSize}, //yangx Add
 {TxtPhotoType, (char*)chinesePhotoType}, //yangx Add
#endif


{ 0, 0 }
};
#else

const unsigned char chineseTxtBmHelp1[]="\x80\x52\xdd\x52\x29\x68\x9d\x4e\xf6\x00\x3a\x00";   //4ʤ
const unsigned char chineseTxtBmHelp2[]="\x80\x62\x40\x67\x9\x7b\xb1\x5b\x50\x54\x8c\x76\xee\x6a\x19\x91\xcd\x54\x8\x00";	
///ӺĿغ
const unsigned char chineseTxtPublicHelp1[]="\x80\x63\x9\x93\x75\x8c\xc7\x8a\xa\x00\x3a\x00"; 	//4 Ϣ
const unsigned char chineseTxtPublicHelp2[]="\x80\x8a\xcb\x67\xe5\x77\xb\x90\x4a\x62\x32\x8a\x2d\x7f\x6e\x00";	//4 鿴Ϸ
const unsigned char chineseTxtPublicHelp3[]="\x80\x50\x74\x97\xf3\x93\x75\x00\x3a\x79\xfb\x52\xd5\x7b\xad\x98\x2d\x00";	//4 :ƶͷ
const unsigned char chineseTxtPublicHelp4[]="\x80\x00\x22\x00\x2a\x00\x22\x93\x75\x00\x3a\x90\x0\x51\xfa\x8a\x2d\x7f\x6e\x00"; 
const unsigned char chineseTxtGameExplain[]="\x80\x8a\xaa\x66\x0e\x00" ;	///˵
//˹
const unsigned char chineseTxtTerrisHelp1[]="\x80\x6b\xcf\x6b\x21\x8d\x85\x90\x4e\x00\x31\x00\x30\x00\x30\x00\x30\x00\x30\x52\x06\x90\x1f\x5e\xa6\x52\xa0\x4e\x00\x00" ;
///ÿγ10000ٶȼһ

tPointerStructure LanguageIndex_2[LEN_LANGUAGE2+1] = {
{ TxtNull, "\x80\x00\x00" },
{ TxtNotImplemented, "\x80\x4e\xd\x53\xef\x4f\x9b\x67\xd\x52\xd9\x00\x00" },
{ TxtManu, "\x80\x00C\x00O\x00N\x00D\x00A\x00T\x00\x00" },
{ TxtEnterPin1, "\x80\x8a\xcb\x8f\x38\x51\x65\x00P\x00I\x00N\x0\x31\x78\xbc\x00\x00" },
{ TxtEnterPin2, "\x80\x8a\xcb\x8f\x38\x51\x65\x00P\x00I\x00N\x0\x32\x78\xbc\x00\x00" },
{ TxtEnterPuk1, "\x80\x8f\x38\x51\x65\x00 \x00P\x00U\x00K\x0\x31\x00\x00" },
{ TxtEnterPuk2, "\x80\x8f\x38\x51\x65\x00 \x00P\x00U\x00K\x0\x32\x00\x00" },
{ TxtInvalidCard, "\x80\x8a\xcb\x6a\xa2\x67\xe5\x00S\x00I\x00M\x53\x61\x00\x00" },
{ TxtNoCard, "\x80\x8a\xcb\x63\xd2\x51\x65\x00S\x00I\x00M\x53\x61\x00\x00" },
{ TxtSoftCall, "\x80\x54\x7c\x53\xeb\x00\x00" },
{ TxtSoftOK, "\x80\x78\xba\x8a\x8d\x00\x00" },
{ TxtSoftMenu, "\x80\x52\x9f\x80\xfd\x88\x68\x00\x00" },
{ TxtHelp, "\x80\x5e\x6b\x52\xa9\x00\x00" },
{ TxtSoftContacts, "\x80\x96\xfb\x8a\x71\x7c\x3f\x00\x00" },
{ TxtPlay, "\x80\x64\xad\x65\x3e\x00\x00" },
{ TxtMessages, "\x80\x77\xed\x4f\xe1\x00\x00" },
{ TxtAlarm, "\x80\x9b\x27\x94\x18\x00\x00" },
{ TxtAlarmPrompt , "\x80\x9b\x27\x94\x18\x63\xd0\x79\x3a\x00\x00" },
{ TxtSettings, "\x80\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtExtra, "\x80\x98\x4d\x59\x16\x00\x00" },
{ TxtSend , "\x80\x76\x7c\x90\x1\x00\x00" },
{ TxtSent, "\x80\x5d\xf2\x76\x7c\x90\x1\x00\x00" },
{ TxtNotSent , "\x80\x67\x2a\x76\x7c\x90\x1\x00\x00" },
{ TxtServiceCentre, "\x80\x67\xd\x52\xd9\x4e\x2d\x5f\xc3\x00\x00" },
{ TxtPleaseWait, "\x80\x8a\xcb\x7b\x49\x5f\x85\x00\x00" },
{ TxtSmsEnterNumber , "\x80\x8f\x38\x51\x65\x86\x5f\x78\xbc\x00\x00" },
{ TxtRead, "\x80\x95\xb1\x8b\x80\x00\x00" },
{ TxtDeleteAll , "\x80\x51\x68\x90\xe8\x52\x2a\x96\x64\x00\x00" },
{ TxtSave, "\x80\x51\x32\x5b\x58\x00\x00" },
{ TxtVoicemail, "\x80\x8a\x9e\x97\xf3\x4f\xe1\x7b\xb1\x00\x00" },
{ TxtBroadcast , "\x80\x8c\xc7\x8a\xa\x53\xf0\x00\x00" },
{ TxtNew, "\x80\x65\xb0\x8c\xc7\x8a\xa\x00\x00" },
{ TxtDigits, "\x80\x0\x31\x0\x32\x0\x33\x00\x00" },
{ TxtLowercase, "\x80\x00a\x00b\x00c\x00\x00" },
{ TxtUppercase, "\x80\x00A\x00B\x00C\x00\x00" },
{ TxtApplications , "\x80\x5d\xe5\x51\x77\x7b\xb1\x00\x00" },
{ TxtVoiceMemo, "\x80\x8a\x9e\x97\xf3\x8a\x18\x93\x4\x00\x00" },
{ TxtSim, "\x80\x00S\x00I\x00M\x53\x61\x00\x00" },
{ TxtSimNot, "\x80\x00S\x00I\x00M\x53\x61\x52\x1d\x59\xcb\x53\x16\x00\x00" },
{ TxtNotReady , "\x80\x67\x2a\x6e\x96\x50\x99\x59\x7d\x00\x00" },
{ TxtSmsListFull, "\x80\x4f\xe1\x7b\xb1\x5d\xf2\x6e\xff\x00\x00" },
{ TxtNewCbMessage , "\x80\x0\x31\x65\xb0\x76\x84\x51\x6c\x51\x71\x8a\xa\x60\x6f\x00\x00" },
{ TxtSaved, "\x80\x5d\xf2\x5b\x58\x51\x32\x00\x00" },
{ TxtDelete , "\x80\x52\x2a\x96\x64\x00\x00" },
{ TxtReply, "\x80\x56\xde\x4f\xe1\x00\x00" },
{ TxtStoreNumber, "\x80\x51\x32\x5b\x58\x86\x5f\x78\xbc\x00\x00" },
{ TxtForward, "\x80\x7d\xe8\x8f\x2f\x8f\x49\x76\x7c\x00\x00" },
{ TxtActivate, "\x80\x95\x8b\x55\x53\x00\x00" },
{ TxtTopics, "\x80\x5c\x8\x68\x48\x00\x00" },
{ TxtConsult, "\x80\x8a\xee\x8a\x62\x00\x00" },
{ TxtAddNew, "\x80\x65\xb0\x58\x9e\x00\x00" },
{ TxtContacts , "\x80\x64\xa5\x54\x7c\x00\x00" },
{ TxtSearchName, "\x80\x67\xe5\x62\x7e\x00\x00" },
{ TxtMemory, "\x80\x8a\x18\x61\xb6\x72\xc0\x61\x4b\x00\x00" },
{ TxtRinger, "\x80\x4f\x86\x96\xfb\x63\xd0\x79\x3a\x00\x00" },
{ TxtVolume, "\x80\x97\xf3\x91\xcf\x00\x00" },
{ TxtRingVolume, "\x80\x92\x34\x80\x72\x97\xf3\x91\xcf\x00\x00" },
{ TxtAlarmVolume, "\x80\x9b\x27\x94\x18\x97\xf3\x91\xcf\x00\x00" },
{ TxtSpeakerVolume, "\x80\x90\x1a\x8a\x71\x97\xf3\x91\xcf\x00\x00" },
{ TxtKeypadTones, "\x80\x63\x9\x93\x75\x97\xf3\x00\x00" },
{ TxtNewMessage, "\x80\x65\xb0\x75\x59\x8a\x0\x00\x00" },
{ TxtNewBroadcast , "\x80\x65\xb0\x51\x6c\x51\x71\x8c\xc7\x8a\xa\x00\x00" },
{ TxtAutoAnswer, "\x80\x81\xea\x52\xd5\x56\xde\x61\xc9\x00\x00" },
{ TxtTimeDate , "\x80\x66\x42\x95\x93\x00/\x65\xe5\x67\x1f\x00\x00" },
{ TxtLanguages , "\x80\x8a\x9e\x8a\x0\x00\x00" },
{ TxtPinCode, "\x80\x00P\x00I\x00N\x0\x31\x78\xbc\x00\x00" },
{ TxtAutoredial, "\x80\x81\xea\x52\xd5\x91\xcd\x64\xa5\x00\x00" },
{ TxtDTMF, "\x80\x00D\x00T\x00M\x00F\x00\x00" },
{ TxtOn, "\x80\x95\x8b\x00\x00" },
{ TxtOff, "\x80\x95\xdc\x00\x00" },
{ TxtNetworkSel, "\x80\x7d\xb2\x8d\xef\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtSendID, "\x80\x96\xb1\x85\xcf\x8e\xab\x4e\xfd\x00\x00" },
{ TxtChargeTimers, "\x80\x90\x1a\x8a\x71\x8c\xbb\x75\x28\x00\x00" },
{ TxtCallDivert, "\x80\x4f\x86\x96\xfb\x8f\x49\x79\xfb\x00\x00" },
{ TxtDateTime, "\x80\x66\x42\x94\x18\x00\x00" },
{ TxtCallWaiting, "\x80\x90\x1a\x8a\x71\x7b\x49\x5f\x85\x00\x00" },
{ TxtIfBusy, "\x80\x62\x4b\x6a\x5f\x53\x60\x7d\xda\x00\x00" },
{ TxtIfNoAnswer, "\x80\x71\x21\x4e\xba\x63\xa5\x80\x7d\x00\x00" },
{ TxtIfNotReachable, "\x80\x4e\xd\x80\xfd\x52\x30\x90\x54\x00\x00" },
{ TxtAllCalls, "\x80\x51\x68\x90\xe8\x4f\x86\x96\xfb\x00\x00" },
{ TxtCancelAll, "\x80\x51\x68\x90\xe8\x53\xd6\x6d\x88\x00\x00" },
{ TxtAll, "\x80\x51\x68\x90\xe8\x00\x00" },
{ TxtVoice, "\x80\x8a\x9e\x97\xf3\x00\x00" },
{ TxtFax, "\x80\x50\xb3\x77\x1f\x00\x00" },
{ TxtData, "\x80\x8c\xc7\x65\x99\x00\x00" },
{ TxtStatus, "\x80\x72\xc0\x61\x4b\x00\x00" },
{ TxtCancel, "\x80\x53\xd6\x6d\x88\x00\x00" },
{ TxtCalculator, "\x80\x8a\x8\x7b\x97\x56\x68\x00\x00" },
{ TxtSoftBack, "\x80\x8f\xd4\x56\xde\x00\x00" },
{ TxtSoftSelect, "\x80\x90\x78\x64\xc7\x00\x00" },
{ TxtSoftConfirm, "\x80\x78\xba\x5b\x9a\x00\x00" },
{ TxtSoftOptions, "\x80\x90\x78\x64\xc7\x52\x9f\x80\xfd\x88\x68\x00\x00" },
{ TxtEmptyList, "\x80\x71\x21\x8c\xc7\x65\x99\x00\x00" },
{ TxtSendMessage, "\x80\x76\x7c\x90\x1\x77\xed\x4f\xe1\x00\x00" },
{ TxtChange, "\x80\x4f\xee\x65\x39\x00\x00" },
{ TxtWriteError, "\x80\x66\xf8\x5b\xeb\x93\x2f\x8a\xa4\x00\x00" },
{ TxtEntryDeleted, "\x80\x8f\x38\x51\x65\x52\x2a\x96\x64\x00\x00" },
{ TxtDetails, "\x80\x7d\x30\x7b\xc0\x00\x00" },
{ TxtHold, "\x80\x4f\xdd\x75\x59\x00\x00" },
{ TxtUnhold, "\x80\x60\x62\x5f\xa9\x00\x00" },
{ TxtMute, "\x80\x97\x5c\x97\xf3\x00\x00" },
{ TxtSendDTMF, "\x80\x76\x7c\x90\x1\x00D\x00T\x00M\x00F\x00\x00" },
{ TxtMainMenu, "\x80\x4e\x3b\x76\xee\x93\x4\x00\x00" },
{ TxtSwap, "\x80\x4e\xa4\x63\xdb\x00\x00" },
{ TxtEndAll, "\x80\x51\x68\x90\xe8\x7d\x50\x67\x5f\x00\x00" },
{ TxtPrivateCall, "\x80\x79\xc1\x4e\xba\x96\xfb\x8a\x71\x00\x00" },
{ TxtStartConference, "\x80\x67\x3\x8b\x70\x95\x8b\x59\xcb\x00\x00" },
{ TxtReStartConference, "\x80\x67\x3\x8b\x70\x91\xcd\x65\xb0\x95\x8b\x59\xcb\x00\x00" },
{ TxtFind, "\x80\x5c\xb\x62\x7e\x00\x00" },
{ TxtServiceNumbers, "\x80\x67\xd\x52\xd9\x86\x5f\x78\xbc\x00\x00" },
{ TxtOutofRange, "\x80\x8d\x85\x51\xfa\x7b\xc4\x57\xd\x00\x00" },
{ TxtDone, "\x80\x5b\x8c\x62\x10\x00\x00" },
{ TxtFailed, "\x80\x59\x31\x65\x57\x00\x00" },
{ TxtEnterNewPin, "\x80\x8f\x38\x51\x65\x65\xb0\x5b\xc6\x78\xbc\x00\x00" },
{ TxtConfPin, "\x80\x78\xba\x5b\x9a\x5b\xc6\x78\xbc\x00\x00" },
{ TxtChangPin, "\x80\x5b\xc6\x78\xbc\x5d\xf2\x65\x39\x8b\x8a\x00\x00" },
{ TxtEnd, "\x80\x7d\x50\x67\x5f\x00\x00" },
{ TxtPINFail, "\x80\x00P\x00I\x00N\x78\xbc\x59\x31\x65\x57\x00\x00" },
{ TxtSOS, "\x80\x7d\xca\x60\x25\x54\x7c\x53\xeb\x00\x00" },
{ TxtAutomatic, "\x80\x81\xea\x52\xd5\x00\x00" },
{ TxtManual, "\x80\x4e\xba\x5d\xe5\x00\x00" },
{ TxtFixedNames, "\x80\x56\xfa\x5b\x9a\x64\xa5\x86\x5f\x00\x00" },
{ TxtFactoryReset, "\x80\x51\xfa\x5e\xe0\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtSearching, "\x80\x67\xe5\x5c\xb\x00\x00" },
{ TxtChangPIN2, "\x80\x00P\x00I\x00N\x0\x32\x66\xf4\x65\x39\x62\x10\x52\x9f\x00\x00" },
{ TxtOldPIN, "\x80\x8f\x38\x51\x65\x82\xa\x00P\x00I\x00N\x0\x31\x78\xbc\x00\x00" },
{ TxtOldPIN2, "\x80\x8f\x38\x51\x65\x82\xa\x00P\x00I\x00N\x0\x32\x78\xbc\x00\x00" },
{ TxtNotAcc, "\x80\x71\x21\x6c\xd5\x63\xa5\x53\xd7\x00\x00" },
{ TxtEnabled, "\x80\x00P\x00I\x00N\x0\x31\x5d\xf2\x95\x8b\x55\x53\x00\x00" },
{ TxtDisabled , "\x80\x00P\x00I\x00N\x0\x31\x5d\xf2\x95\xdc\x95\x89\x00\x00" },
{ TxtPINOK, "\x80\x00P\x00I\x00N\x6b\x63\x78\xba\x00\x00" },
{ TxtSimBlocked, "\x80\x00S\x00I\x00M\x5d\xf2\x5c\x1\x93\x96\x00\x00" },
{ TxtNewPIN, "\x80\x65\xb0\x00P\x00I\x00N\x00\x00" },
{ TxtAcc, "\x80\x5d\xf2\x63\xa5\x53\xd7\x00\x00" },
{ TxtNoNetwork, "\x80\x71\x21\x7d\xb2\x8d\xef\x00\x00" },
{ TxtNo, "\x80\x54\x26\x00\x00" },
{ TxtEnterDate, "\x80\x8f\x38\x51\x65\x65\xe5\x67\x1f\x00\x00" },
{ TxtEnterTime, "\x80\x8f\x38\x51\x65\x66\x42\x95\x93\x00\x00" },
{ TxtScratchPad, "\x80\x7b\x46\x8a\x18\x67\x2c\x00\x00" },
{ TxtDeleted, "\x80\x5d\xf2\x52\x2a\x96\x64\x00\x00" },
{ TxtActivated, "\x80\x5d\xf2\x95\x8b\x55\x53\x00\x00" },
{ TxtDeActivated, "\x80\x5d\xf2\x95\xdc\x95\x89\x00\x00" },
{ TxtDeactivate, "\x80\x95\xdc\x95\x89\x00\x00" },
{ TxtCheck, "\x80\x6a\xa2\x67\xe5\x00\x00" },
{ TxtYes, "\x80\x66\x2f\x00\x00" },
{ TxtCallNumber, "\x80\x54\x7c\x53\xeb\x86\x5f\x78\xbc\x00\x00" },
{ TxtEnterMid, "\x80\x8f\x38\x51\x65\x00M\x00I\x00D\x00\x00" },
{ TxtReadError, "\x80\x95\xb1\x8b\x80\x93\x2f\x8a\xa4\x00\x00" },
{ TxtUsed, "\x80\x5d\xf2\x75\x28\x7a\x7a\x95\x93\x00\x00" },
{ TxtOutgoing, "\x80\x64\xa5\x51\xfa\x96\xfb\x8a\x71\x00\x00" },
{ TxtMuted, "\x80\x97\x5c\x97\xf3\x00\x00" },
{ TxtCallEnded, "\x80\x90\x1a\x8a\x71\x5d\xf2\x7d\x50\x67\x5f\x00\x00" },
{ TxtIncomingCall, "\x80\x54\x7c\x51\x65\x96\xfb\x8a\x71\x00\x00" },
{ TxtIncomingData, "\x80\x5d\xf2\x63\xa5\x65\x36\x8c\xc7\x65\x99\x91\xcf\x00\x00" },
{ TxtIncomingFax, "\x80\x00I\x00n\x00c\x00o\x00m\x00i\x00n\x00g\0x00 \x00f\x00a\x00x\x00\x00" },
{ TxtNumberWithheld, "\x80\x4f\xdd\x75\x59\x76\x84\x86\x5f\x78\xbc\x00\x00" },
{ TxtAccept, "\x80\x63\xa5\x53\xd7\x00\x00" },
{ TxtReject, "\x80\x62\xd2\x7d\x55\x00\x00" },
{ TxtCalling, "\x80\x6b\x63\x57\x28\x63\xa5\x90\x1a\x00\x00" },
{ TxtWaitingAnswer  , "\x80\x7b\x49\x5f\x85\x63\xa5\x80\x7d\x00\x00" },
{ TxtMissedCalls, "\x80\x59\x1a\x50\xb\x67\x2a\x63\xa5\x96\xfb\x8a\x71\x00\x00" },
{ TxtMissedCall, "\x80\x67\x2a\x63\xa5\x96\xfb\x8a\x71\x00\x00" },
{ TxtCallSingle, "\x80\x4e\x00\x65\xb9\x90\x1a\x8a\x71\x00\x00" },
{ TxtCallTwo, "\x80\x51\x69\x65\xb9\x90\x1a\x8a\x71\x00\x00" },
{ TxtCallPrivateCall, "\x80\x79\xc1\x4e\xba\x90\x1a\x8a\x71\x00\x00" },
{ TxtCallConfernce, "\x80\x96\xfb\x8a\x71\x67\x3\x8b\x70\x00\x00" },
{ TxtCallSingleMultiparty, "\x80\x00S\x00i\x00n\x00g\x00l\x00e\0x00 \x00M\x00u\x00l\x00t\x00i\x00P\x00a\x00r\x00t\x00y\x00\x00" },
{ TxtCallMultipartySingle, "\x80\x00M\x00u\x00l\x00t\x00i\x00P\x00a\x00r\x00t\x00y\x00 \x00S\x00i\x00n\x00g\x00l\x00e\x00\x00" },
{ TxtLocked, "\x80\x63\x9\x93\x75\x5d\xf2\x93\x96\x00\x00" },
{ TxtUnmute, "\x80\x89\x7\x97\xf3\x00\x00" },
{ TxtNeedCharging, "\x80\x8a\xcb\x51\x45\x96\xfb\x00\x00" },
{ TxtCharging, "\x80\x6b\x63\x57\x28\x51\x45\x96\xfb\x00\x00" },
{ TxtChargComplete, "\x80\x51\x45\x96\xfb\x5b\x8c\x62\x10\x00\x00" },
{ TxtNoPower, "\x80\x96\xfb\x91\xcf\x4e\xd\x8d\xb3\x00\x00" },
{ TxtSwitchOff, "\x80\x99\xac\x4e\xa\x95\xdc\x6a\x5f\x00\x00" },
{ TxtOperationNotAvail, "\x80\x4e\xd\x53\xef\x4f\x9b\x67\xd\x52\xd9\x00\x00" },
{ TxtNetUselessInCall, "\x80\x7d\xb2\x8d\xef\x5f\xd9\x8a\xcb\x7a\xd\x5f\x8c\x51\x8d\x64\xa5\x00\x00" },
{ TxtNetUselessCallAgain, "\x80\x7d\xb2\x8d\xef\x5f\xd9\xff\xc\x91\xcd\x64\xa5\xff\x1f\x00\x00" },
{ TxtAddToConference, "\x80\x52\xa0\x51\x65\x67\x3\x8b\x70\x00\x00" },
{ TxtEmpty, "\x80\x71\x21\x8c\xc7\x65\x99\x00\x00" },
{ TxtSelectFromList, "\x80\x5f\x9e\x54\xd\x55\xae\x88\xcf\x90\x78\x00\x00" },
{ TxtEnterNetworkCode, "\x80\x7d\xb2\x8d\xef\x86\x5f\x78\xbc\x00\x00" },
{ TxtMCCMNC, "\x80\x62\x4b\x6a\x5f\x57\xb\x5b\xb6\x86\x5f\x78\xbc\x00 \x00/\x00 \x62\x4b\x6a\x5f\x7d\xb2\x8d\xef\x86\x5f\x78\xbc\x00\x00" },
{ TxtRecord, "\x80\x93\x4\x97\xf3\x00\x00" },
{ TxtSecurity, "\x80\x5b\x89\x51\x68\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtEnglish, "\x80\x82\xf1\x8a\x9e\x00\x00" },
{ TxtGerman, "\x80\x5f\xb7\x8a\x9e\x00\x00" },
{ TxtValidity, "\x80\x67\x9\x65\x48\x67\x1f\x00\x00" },
{ TxtMessageTyp, "\x80\x75\x59\x8a\x0\x7a\x2e\x98\x5e\x00\x00" },
{ TxtSetVoiceMail, "\x80\x8a\x2d\x5b\x9a\x8a\x9e\x97\xf3\x4f\xe1\x7b\xb1\x00\x00" },
{ TxtCallTimers, "\x80\x90\x1a\x8a\x71\x8a\x8\x66\x42\x00\x00" },
{ TxtLastCharge, "\x80\x4e\xa\x6b\x21\x90\x1a\x8a\x71\x8c\xbb\x75\x28\x00\x00" },
{ TxtTotalCharge, "\x80\x7d\x2f\x8a\x8\x90\x1a\x8a\x71\x8c\xbb\x75\x28\x00\x00" },
{ TxtResetCharge, "\x80\x8a\x8\x50\xf9\x56\x68\x6e\x5\x96\xf6\x00\x00" },
{ TxtIfNoService, "\x80\x71\x21\x6c\xd5\x63\xa5\x90\x1a\x00\x00" },
{ TxtDiscard, "\x80\x65\x3e\x68\xc4\x00\x00" },
{ TxtEDIT  , "\x80\x7d\xe8\x8f\x2f\x00\x00" },
{ TxtExtractNumber, "\x80\x63\xd0\x53\xd6\x86\x5f\x78\xbc\x00\x00" },
{ TxtWrite, "\x80\x7d\xe8\x8f\x2f\x00\x00" },
{ TxtCheckStatus, "\x80\x67\xe5\x8a\x62\x72\xc0\x61\x4b\x00\x00" },
{ TxtSetDivert, "\x80\x8a\x2d\x5b\x9a\x54\x7c\x53\xeb\x8f\x49\x79\xfb\x00\x00" },
{ TxtCancelDivert, "\x80\x53\xd6\x6d\x88\x54\x7c\x53\xeb\x8f\x49\x79\xfb\x00\x00" },
{ TxtHideID, "\x80\x96\xb1\x85\xcf\x8e\xab\x4e\xfd\x00\x00" },
{ TxtTones, "\x80\x97\xf3\x8a\xbf\x00\x00" },
{ TxtClock, "\x80\x9b\x27\x94\x18\x00\x00" },
{ TxtPhone, "\x80\x96\xfb\x8a\x71\x00\x00" },
{ TxtStop, "\x80\x50\x5c\x6b\x62\x00\x00" },
{ TxtRecording, "\x80\x6b\x63\x57\x28\x93\x4\x97\xf3\x00\x00" },
{ TxtPlaying, "\x80\x64\xad\x65\x3e\x00\x00" },
{ TxtPlayback, "\x80\x91\xcd\x64\xad\x00\x00" },
{ TxtNoNumber, "\x80\x71\x21\x86\x5f\x78\xbc\x00\x00" },
{ TxtOkToDelete, "\x80\x51\x68\x90\xe8\x52\x2a\x96\x64\x00\x00" },
{ TxtBalance, "\x80\x99\x18\x98\x4d\x00\x00" },
{ TxtLimit, "\x80\x8c\xbb\x75\x28\x4e\xa\x96\x50\x00\x00" },
{ TxtLimitEq, "\x80\x96\x50\x5e\xa6\x00\x00" },
{ TxtRate, "\x80\x90\x1a\x8a\x71\x8c\xbb\x73\x87\x00\x00" },
{ TxtMinutes, "\x80\x52\x6\x94\x18\x00\x00" },
{ TxtCost, "\x80\x8c\xbb\x75\x28\x00\x00" },
{ TxtCredit, "\x80\x52\x69\x99\x18\x99\x18\x98\x4d\x00\x00" },
{ TxtPressOk, "\x80\x63\x9\x78\xba\x8a\x8d\x00\x00" },
{ TxtReset, "\x80\x6e\x5\x96\xf6\x00\x00" },
{ TxtIncoming, "\x80\x63\xa5\x90\x32\x00\x00" },
{ TxtCounter, "\x80\x8a\x8\x66\x42\x6a\x5f\x00\x00" },
{ TxtOutgoingCalls, "\x80\x5d\xf2\x64\xa5\x96\xfb\x8a\x71\x00\x00" },
{ TxtCostCounter, "\x80\x8a\x8\x8c\xbb\x6a\x5f\x00\x00" },
{ TxtEnterCurrency, "\x80\x8f\x38\x51\x65\x8c\xa8\x5e\x63\x00\x00" },
{ Txt1Unit, "\x80\x0\x31\x90\x1a\x8a\x71\x55\xae\x4f\x4d\x00=\x00\x00" },
{ TxtChanged, "\x80\x5d\xf2\x65\x39\x8b\x8a\x00\x00" },
{ TxtEnterLimit, "\x80\x8f\x38\x51\x65\x96\x50\x5e\xa6\x00\x00" },
{ TxtCancelled , "\x80\x5d\xf2\x53\xd6\x6d\x88\x00\x00" },
{ TxtView, "\x80\x95\xb1\x89\xbd\x00\x00" },
{ TxtEnterPCK, "\x80\x8f\x38\x51\x65\x00 \x00P\x00C\x00K\x00\x00" },
{ TxtEnterCCK, "\x80\x8f\x38\x51\x65\x00 \x00C\x00C\x00K\x00\x00" },
{ TxtEnterNCK, "\x80\x8f\x38\x51\x65\x00 \x00N\x00C\x00K\x00\x00" },
{ TxtEnterNSCK, "\x80\x8f\x38\x51\x65\x00 \x00N\x00S\x00C\x00K\x00\x00" },
{ TxtEnterSPCK, "\x80\x8f\x38\x51\x65\x00 \x00S\x00P\x00C\x00K\x00\x00" },
{ TxtCodeInc, "\x80\x5b\xc6\x78\xbc\x93\x2f\x8a\xa4\x00\x00" },
{ TxtPuk1Inc, "\x80\x00P\x00U\x00K\x78\xbc\x93\x2f\x8a\xa4\x00\x00" },
{ TxtChangeFail, "\x80\x66\xf4\x65\x39\x59\x31\x65\x57\xff\x1\x00\x00" },
{ TxtBlckPerm, "\x80\x6c\x38\x90\x60\x5c\x1\x93\x96\x00\x00" },
{ TxtDealer, "\x80\x80\x6f\x7e\x6b\x4e\xe3\x74\x6\x4e\xba\x00\x00" },
{ TxtSendingDTMF, "\x80\x76\x7c\x90\x1\x00D\x00T\x00M\x00F\x00\x00" },
{ TxtCheckNumber, "\x80\x6a\xa2\x67\xe5\x86\x5f\x78\xbc\x00\x00" },
{ TxtNumberBusy, "\x80\x86\x5f\x78\xbc\x5f\xd9\x00\x00" },
{ TxtNoAnswer, "\x80\x71\x21\x61\xc9\x7b\x54\x00\x00" },
{ TxtNumberChanged, "\x80\x86\x5f\x78\xbc\x5d\xf2\x65\x39\x8b\x8a\x00\x00" },
{ TxtNetworkBusy, "\x80\x7d\xb2\x8d\xef\x5f\xd9\x00\x00" },
{ TxtNotSubscribed, "\x80\x67\x2a\x76\x7b\x8a\x18\x00\x00" },
{ TxtAnyKeyAnswer, "\x80\x4e\xfb\x61\xf\x93\x75\x63\xa5\x80\x7d\x00\x00" },
{ TxtPINBlock, "\x80\x00P\x00I\x00N\x78\xbc\x5d\xf2\x5c\x1\x93\x96\x00\x00" },
{ TxtEdit, "\x80\x7d\xe8\x8f\x2f\x00\x00" },
{ TxtChangePassword, "\x80\x65\x39\x8b\x8a\x5b\xc6\x78\xbc\x00\x00" },
{ TxtSetBar, "\x80\x5c\x1\x93\x96\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtSmsTone, "\x80\x77\xed\x4f\xe1\x63\xd0\x79\x3a\x00\x00" },
{ TxtSmsVolume, "\x80\x77\xed\x6d\x88\x60\x6f\x97\xf3\x91\xcf\x00\x00" },
{ TxtKeypadToneVolume, "\x80\x63\x9\x93\x75\x97\xf3\x91\xcf\x00\x00" },
{ TxtKeypadToneRing, "\x80\x55\xae\x97\xf3\x00\x00" },
{ TxtKeypadToneSpecialRing, "\x80\x8a\x9e\x97\xf3\x00\x00" },
{ TxtMelody, "\x80\x92\x34\x80\x72\x98\x5e\x57\x8b\x00\x00" },
{ TxtSilent, "\x80\x97\x5c\x97\xf3\x74\xb0\x58\x83\x00\x00" },
{ TxtClick, "\x80\x63\x9\x00\x00" },
{ TxtClearAlarm, "\x80\x53\xd6\x6d\x88\x9b\x27\x92\x34\x00\x00" },
{ TxtTimeFormat, "\x80\x66\x42\x95\x93\x68\x3c\x5f\xf\x00\x00" },
{ TxtTwelveHour, "\x80\x0\x31\x0\x32\x5c\xf\x66\x42\x52\x36\x00\x00" },
{ TxtTwentyfourHour, "\x80\x0\x32\x0\x34\x5c\xf\x66\x42\x52\x36\x00\x00" },
{ TxtInCallTimer, "\x80\x8a\x8\x66\x42\x00\x00" },
{ TxtStore, "\x80\x51\x32\x5b\x58\x00\x00" },
{ TxtNone, "\x80\x5d\xf2\x00\x00" },
{ TxtPIN, "\x80\x00P\x00I\x00N\x0\x31\x78\xbc\x00\x00" },
{ TxtPIN2 , "\x80\x66\xf4\x65\x39\x00P\x00I\x00N\x0\x32\x00\x00" },
{ TxtConfPin2, "\x80\x6b\x63\x78\xba\x00P\x00I\x00N\x0\x32\x78\xbc\x00\x00" },
{ TxtNewPIN2, "\x80\x8f\x38\x51\x65\x65\xb0\x00P\x00I\x00N\x0\x32\x78\xbc\x00\x00" },
{ TxtUnlockOK, "\x80\x93\x96\x5b\x9a\x89\xe3\x96\x64\x00\x00" },
{ TxtIMEI , "\x80\x00I\x00M\x00E\x00I\x00\x00" },
{ TxtList, "\x80\x54\xd\x55\xae\x00\x00" },
{ TxtFull , "\x80\x6e\xff\x00\x00" },
{ TxtCapacityFull, "\x80\x5b\xb9\x91\xcf\x5d\xf2\x6e\xff\x00\x00" },
{ TxtNotAvailable , "\x80\x4e\xd\x53\xef\x4f\x9b\x67\xd\x52\xd9\x00\x00" },
{ TxtCallBAOC, "\x80\x8a\x71\x00B\x00A\x00O\x00C\x00\x00" },
{ TxtCallBAOIC , "\x80\x8a\x71\x00B\x00A\x00O\x00I\x00C\x00\x00" },
{ TxtCallBAOICexH , "\x80\x8a\x71\x00B\x00A\x00O\x00I\x00C\x00e\x00x\x00H\x00 \x00\x00" },
{ TxtCallBAIC, "\x80\x8a\x71\x00B\x00A\x00I\x00C\x00\x00" },
{ TxtCallBAICroam , "\x80\x8a\x71\x00B\x00A\x00I\x00C\x00r\x00o\x00a\x00m\x00 \x00\x00" },
{ TxtCallBarringAll, "\x80\x54\x7c\x53\xeb\x96\x50\x52\x36\x00\x00" },
{ TxtCallBAOCAll, "\x80\x8a\x71\x00B\x00A\x00O\x00C\x00A\x00l\x00l\x00\x00" },
{ TxtCallBAICAll, "\x80\x8a\x71\x00B\x00A\x00I\x00C\x00A\x00l\x00l\x00\x00" },
{ TxtCLIP , "\x80\x00C\x00L\x00I\x00P\x00\x00" },
{ TxtCOLP , "\x80\x00C\x00O\x00L\x00P\x00\x00" },
{ TxtCOLR, "\x80\x00C\x00O\x00L\x00R\x00\x00" },
{ TxtSimToolkit, "\x80\x00S\x00I\x00M\x00 \x5d\xe5\x51\x77\x7b\xb1\x00\x00" },
{ TxtRecentCalls, "\x80\x90\x1a\x8a\x71\x8a\x18\x93\x4\x00\x00" },
{ TxtRecordName, "\x80\x8a\x18\x93\x4\x54\xd\x7a\x31\x00\x00" },
{ TxtInterCalls, "\x80\x57\xb\x96\x9b\x96\xfb\x8a\x71\x00\x00" },
{ TxtInterHome, "\x80\x57\xb\x96\x9b\xff\x8\x6f\x2b\x90\x4a\xff\x9\x96\xfb\x8a\x71\x00\x00" },
{ TxtWhenRoaming, "\x80\x6f\x2b\x90\x4a\x00\x00" },
{ TxtCancelAllBars, "\x80\x51\x68\x90\xe8\x52\x2a\x96\x64\x00\x00" },
{ TxtWaiting, "\x80\x8a\xcb\x7b\x49\x50\x19\x00\x00" },
{ TxtBarred , "\x80\x58\x35\x58\x5e\x00\x00" },
{ TxtForwarded , "\x80\x5d\xf2\x50\xb3\x90\x1\x00\x00" },
{ TxtCallDivertNoReach , "\x80\x8f\x49\x79\xfb\x67\x2a\x90\x1a\x00\x00" },
{ TxtCallDivertNoReply , "\x80\x8f\x49\x79\xfb\x71\x21\x61\xc9\x7b\x54\x00\x00" },
{ TxtCallDivertIfBusy , "\x80\x8f\x49\x79\xfb\x82\xe5\x5f\xd9\x00\x00" },
{ TxtPressMenu, "\x80\x0\x00\x00" },
{ TxtSending, "\x80\x76\x7c\x90\x1\x00\x00" },
{ TxtMessage, "\x80\x6d\x88\x60\x6f\x00\x00" },
{ TxtSoftNext, "\x80\x4e\xb\x4e\x00\x50\xb\x00\x00" },
{ TxtLastCall, "\x80\x4e\xa\x6b\x21\x90\x1a\x8a\x71\x00\x00" },
{ TxtIncomingCalls, "\x80\x63\xa5\x90\x32\x96\xfb\x8a\x71\x00\x00" },
{ TxtLow, "\x80\x4f\x4e\x00\x00" },
{ TxtMedium, "\x80\x4e\x2d\x00\x00" },
{ TxtHigh, "\x80\x9a\xd8\x00\x00" },
{ TxtIncreasing, "\x80\x6f\x38\x58\x9e\x00\x00" },
{ TxtTimerReset, "\x80\x8a\x8\x66\x42\x6e\x5\x96\xf6\x00\x00" },
{ TxtClockSetTo, "\x80\x9b\x27\x94\x18\x8a\x2d\x5b\x9a\x72\x32\x00\x00" },
{ TxtSilentMode, "\x80\x97\x5c\x97\xf3\x74\xb0\x58\x83\x00\x00" },
{ TxtSmsValidityPeriodSet, "\x80\x67\x9\x65\x48\x67\x1f\x8a\x2d\x5b\x9a\x72\x32\x00\x00" },
{ Txt1Hour, "\x80\x0\x31\x5c\xf\x66\x42\x00\x00" },
{ Txt12Hours, "\x80\x0\x31\x0\x32\x5c\xf\x66\x42\x00\x00" },
{ Txt24Hours, "\x80\x0\x32\x0\x34\x5c\xf\x66\x42\x00\x00" },
{ Txt1Week, "\x80\x0\x31\x54\x68\x00\x00" },
{ TxtPin2Code, "\x80\x00P\x00i\x00n\x0\x32\x00 \x00C\x00o\x00d\x00e\x00\x00" },
{ TxtEnablePIN, "\x80\x5b\xc6\x78\xbc\x95\x8b\x55\x53\x00\x00" },
{ TxtRequesting, "\x80\x6b\x63\x57\x28\x89\x81\x6c\x42\x00\x00" },
{ TxtNotAllowed, "\x80\x4e\xd\x51\x41\x8a\x31\x00\x00" },
{ TxtEmergency, "\x80\x7d\xca\x60\x25\x54\x7c\x53\xeb\x00\x00" },
{ TxtChinese, "\x80\x4e\x2d\x65\x87\x00\x00" },
{ TxtPassword, "\x80\x5b\xc6\x78\xbc\x00\x00" },
{ TxtConfirmPassword, "\x80\x78\xba\x5b\x9a\x5b\xc6\x78\xbc\x00\x00" },
{ TxtNewPassword, "\x80\x65\xb0\x5b\xc6\x78\xbc\x00\x00" },
{ TxtNoMessages, "\x80\x71\x21\x77\xed\x4f\xe1\x00\x00" },
{ TxtTwoAttemptsLeft, "\x80\x52\x69\x99\x18\x51\x69\x6b\x21\x6a\x5f\x67\x3\x00\x00" },
{ TxtOneAttemptLeft, "\x80\x52\x69\x99\x18\x4e\x00\x6b\x21\x6a\x5f\x67\x3\x00\x00" },
{ Txtblacklisted, "\x80\x88\xab\x79\x81\x6b\x62\x76\x84\x86\x5f\x78\xbc\x00\x00" },
{ TxtErrUnknown, "\x80\x67\x2a\x77\xe5\x93\x2f\x8a\xa4\x00\x00" },
{ TxtSSErr, "\x80\x93\x2f\x8a\xa4\x00\x00" },
{ TxtUnknownSub, "\x80\x67\x2a\x77\xe5\x75\x28\x62\x36\x00\x00" },
{ TxtIllSub, "\x80\x97\x5e\x6c\xd5\x75\x28\x62\x36\x00\x00" },
{ TxtIllEqip, "\x80\x97\x5e\x6c\xd5\x8a\x2d\x50\x99\x00\x00" },
{ TxtIllOp, "\x80\x97\x5e\x6c\xd5\x64\xcd\x4f\x5c\x00\x00" },
{ TxtSubVil, "\x80\x67\x2a\x77\xe5\x75\x28\x62\x36\x00\x00" },
{ TxtInComp, "\x80\x77\xdb\x76\xfe\x00\x00" },
{ TxtFacNoSup, "\x80\x8a\x2d\x50\x99\x4e\xd\x65\x2f\x63\xf4\x00\x00" },
{ TxtAbsSub, "\x80\x75\x28\x62\x36\x4e\xd\x57\x28\x00\x00" },
{ TxtSysFail, "\x80\x7c\xfb\x7d\x71\x59\x31\x65\x57\x00\x00" },
{ TxtMissDta, "\x80\x8c\xc7\x65\x99\x4e\x1f\x59\x31\x00\x00" },
{ TxtUnexDta, "\x80\x93\x2f\x8a\xa4\x8c\xc7\x65\x99\x00\x00" },
{ TxtPwdErr, "\x80\x8f\x38\x51\x65\x93\x2f\x8a\xa4\x00\x00" },
{ TxtUnkAlph, "\x80\x67\x2a\x77\xe5\x5b\x57\x6b\xcd\x00\x00" },
{ TxtMaxMpty, "\x80\x67\x00\x59\x27\x90\xe8\x52\x6\x91\x4d\x7f\x6e\x00\x00" },
{ TxtResNoAvai, "\x80\x71\x21\x61\xc9\x7b\x54\x00\x00" },
{ TxtUnRec, "\x80\x67\x2a\x77\xe5\x00\x00" },
{ TxtMisTyp, "\x80\x4e\xd\x53\x39\x91\x4d\x98\x5e\x57\x8b\x00\x00" },
{ TxtBadStruct, "\x80\x93\x2f\x8a\xa4\x7d\x50\x69\xcb\x00\x00" },
{ TxtDupInv, "\x80\x89\x7\x88\xfd\x75\x28\x6c\xd5\x00\x00" },
{ TxtResLim, "\x80\x71\x21\x8c\xc7\x6e\x90\x00\x00" },
{ TxtIniRel, "\x80\x52\x1d\x59\xcb\x53\x16\x00\x00" },
{ TxtFatRes, "\x80\x56\xb4\x91\xcd\x93\x2f\x8a\xa4\x00\x00" },
{ TxtEntAnw, "\x80\x61\xc9\x7b\x54\x00\x00" },
{ TxtSsMsg, "\x80\x88\xdc\x51\x45\x69\x6d\x52\xd9\x6d\x88\x60\x6f\x00\x00" },
{ TxtOld, "\x80\x8f\x38\x51\x65\x82\xa\x00\x00" },
{ TxtInsertnote, (char*)chineseTxtInsertnote },
{ TxtMelodygenerator, (char*)chineseTxtMelodygenerator },
{ TxtOctaveHigher, (char*)chineseTxtOctaveHigher },
{ TxtOctaveLower, (char*)chineseTxtOctaveLower },
{ TxtLoadMelody, (char*)chineseTxtLoadMelody },
{ TxtEasyText, (char*)chineseTxtEasyText },
{ TxtDataCount, (char*)chineseTxtDataCount },
{ TxtQoS, (char*)chineseTxtQoS },
{ TxtTypeofConnection, (char*)chineseTxtTypeofConnection },
{ TxtTotalCount, "\x80\x60\x3b\x51\x71\x00" },	///ܹ
{ TxtResetCount, (char*)chineseTxtResetCount },
{ TxtDataCounter, (char*)chineseTxtDataCounter },
{ TxtV42bis, (char*)chineseTxtV42bis },
{ TxtNormal, (char*)chineseTxtNormal },
{ TxtCSD, (char*)chineseTxtCSD },
{ TxtClassB, (char*)chineseTxtClassB },
{ TxtClassC, (char*)chineseTxtClassC },
{ TxtIPAddress, (char*)chineseTxtIPAddress },
{ TxtIPAddress1, "\x80\x00I\x00P\x57\x30\x57\x40\x0\x31\x00\x00" },
{ TxtIPAddress2, "\x80\x00I\x00P\x57\x30\x57\x40\x0\x32\x00\x00" },
{ TxtPort1, "\x80\x57\xe0\x0\x31\x00\x00" },
{ TxtPort2, "\x80\x57\xe0\x0\x32\x00\x00" },
{ TxtAPN, "\x80\x00G\x00P\x00R\x00S\x63\xa5\x51\x65\x9e\xde\x00\x00" },
{ TxtConnectionType, "\x80\x90\x23\x63\xa5\x98\x5e\x57\x8b\x00\x00" },
{ TxtGPRS, "\x80\x00G\x00P\x00R\x00S\x00\x00" },
{ TxtGPRSInfo, "\x80\x00G\x00P\x00R\x00S\x8c\xc7\x8a\xa\x00\x00" },
{ TxtOutgoingData, "\x80\x5d\xf2\x76\x7c\x90\x1\x8c\xc7\x65\x99\x91\xcf\x00\x00" },
{ TxtHomepage, "\x80\x4e\x3b\x98\x1\x00\x00" },
{ TxtBookmarks, "\x80\x66\xf8\x7c\x3d\x00\x00" },
{ TxtGoTo, "\x80\x90\x32\x51\x65\x7d\xb2\x57\x40\x00\x00" },
{ TxtHistory, "\x80\x6b\x77\x53\xf2\x8a\x18\x93\x4\x00\x00" },
{ TxtSetup, "\x80\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtNewBookmark, "\x80\x6d\xfb\x52\xa0\x66\xf8\x7c\x3d\x00\x00" },
{ TxtWWWdot, "http://www." },
{ TxtWAPdot, "http://wap."  },
//{ TxtWWWdot, "\x80\x00h\x00t\x00t\x00p\x00:\x00/\x00/\x00w\x00w\x00w\x00.\x00\x00" },
//{ TxtWAPdot, "\x80\x00h\x00t\x00t\x00p\x00:\x00/\x00/\x00w\x00a\x00p\x00.\x00\x00" },
{ TxtSMS, "\x80\x00S\x00M\x00S\x00\x00" },
{ TxtEmail, "\x80\x00E\x00m\x00a\x00i\x00l\x00\x00" },
{ TxtClear, "\x80\x52\x2a\x96\x64\x8a\x18\x93\x4\x00\x00" },
{ TxtBookmark, "\x80\x6d\xfb\x52\xa0\x66\xf8\x7c\x3d\x00\x00" },
{ TxtSelectProfile, "\x80\x75\x76\x52\x4d\x67\xd\x52\xd9\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtSetupProfiles, "\x80\x4f\xee\x65\x39\x67\xd\x52\xd9\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtSaveHistory, "\x80\x4f\xdd\x5b\x58\x7d\xb2\x57\x40\x00\x00" },
{ TxtEditName, "\x80\x7d\xe8\x8f\x2f\x6a\x19\x98\x4c\x00\x00" },
{ TxtEditURL, "\x80\x7d\xe8\x8f\x2f\x7d\xb2\x57\x40\x00\x00" },
{ TxtAccessType, "\x80\x90\x23\x63\xa5\x65\xb9\x5f\xf\x00\x00" },
{ TxtResponseTimer, "\x80\x90\x23\x63\xa5\x66\x42\x95\x93\x00\x00" },
{ TxtDialupNumber, "\x80\x64\xa5\x86\x5f\x86\x5f\x78\xbc\x00\x00" },
{ TxtTemporary, "\x80\x81\xe8\x66\x42\x90\x23\x63\xa5\x00\x00" },
{ TxtContinuous, "\x80\x63\x1\x7e\x8c\x90\x23\x63\xa5\x00\x00" },
{ TxtGPRSData, "\x80\x00G\x00P\x00R\x00S\x00\x00" },
{ TxtCSData, "\x80\x8c\xc7\x65\x99\x00\x00" },
{ TxtWAP, "\x80\x4e\x92\x80\x6f\x7d\xb2\x00\x00" },
{ TxtExit, "\x80\x90\x0\x51\xfa\x00\x00" },
{ TxtReload, "\x80\x51\x8d\x4e\xb\x8f\x9\x00\x00" },
{ TxtStored, "\x80\x5d\xf2\x4f\xdd\x5b\x58\x00\x00" },
{ TxtOther, "\x80\x51\x76\x4e\xd6\x00\x00" },
{ TxtConnecting, "\x80\x6b\x63\x57\x28\x90\x23\x63\xa5\x00\x00" },
{ TxtDownloading, "\x80\x4e\xb\x8f\x9\x00.\x00.\x00\x00" },
{ TxtUpdating, "\x80\x00U\x00p\x00d\x00a\x00t\x00i\x00n\x00g\x00.\x00.\x00.\x00\x00" },
{ TxtEnterURL, "\x80\x00E\x00n\x00t\x00e\x00r\x00 \x00U\x00R\x00L\x00:\x00\x00" },
{ TxtProfileName, "\x80\x00P\x00r\x00o\x00f\x00i\x00l\x00e\x00 \x00N\x00a\x00m\x00e\x00:\x00\x00" },
{ TxtISPUsername, "\x80\x75\x28\x62\x36\x54\xd\x00\x00" },
{ TxtISPPassword, "\x80\x5b\xc6\x78\xbc\x00\x00" },
{ TxtGoToLink, "\x80\x90\x32\x51\x65\x00\x00" },
{ TxtSelect, "\x80\x90\x78\x64\xc7\x00\x00" },
{ TxtNotConnected, "\x80\x4e\xd\x80\xfd\x90\x23\x63\xa5\x00\x00" },
{ TxtScaleImages, "\x80\x57\x16\x50\xcf\x98\x6f\x79\x3a\x00\x00" },
{ TxtLoggingIn, "\x80\x8a\x3b\x51\x8a\x00\x00" },
{ TxtAcceptEndWAP, "\x80\x00A\x00c\x00c\x00e\x00p\x00t\x00 \x00w\x00i\x00l\x00l\x00 \x00d\x00i\x00s\x00c\x00o\x00n\x00n\x00e\x00c\x00t\x00 \x00W\x00A\x00P\x00\x00" },
{ TxtErrorUnknown, "\x80\x00U\x00n\x00k\x00n\x00o\x00w\x00n\x00 \x00e\x00r\x00r\x00o\x00r\x00\x00" },
 { TxtErrorNotImp, (char*)chineseTxtErrorNotImp },
 { TxtErrorUnsupported, (char*)chineseTxtErrorUnsupported },
 { TxtErrorOverload, (char*)chineseTxtErrorOverload },
 { TxtErrorNoResponse, (char*)chineseTxtErrorNoResponse },
 { TxtErrorTooLarge, (char*)chineseTxtErrorTooLarge },
 { TxtErrorBadRequest, (char*)chineseTxtErrorBadRequest },
 { TxtErrorUnauthorized, (char*)chineseTxtErrorUnauthorized },
 { TxtErrorPaymentReq, (char*)chineseTxtErrorPaymentReq },
 { TxtErrorForbidden, (char*)chineseTxtErrorForbidden },
 { TxtErrorFileNotFnd, (char*)chineseTxtErrorFileNotFnd },
 { TxtErrorNotAllowed, (char*)chineseTxtErrorNotAllowed },
 { TxtErrorNotAcceptable, (char*)chineseTxtErrorNotAcceptable },
 { TxtErrorAuthReq, (char*)chineseTxtErrorAuthReq },
 { TxtErrorReqTimeout, (char*)chineseTxtErrorReqTimeout },
 { TxtErrorHTTPConf, (char*)chineseTxtErrorHTTPConf },
 { TxtErrorOutOfMem, (char*)chineseTxtErrorOutOfMem },
 { TxtErrorWMLError, (char*)chineseTxtErrorWMLError },
 { TxtErrorDisplay, (char*)chineseTxtErrorDisplay },
 { TxtErrorCardEmpty, (char*)chineseTxtErrorCardEmpty },
 { TxtErrorURLInvalid, (char*)chineseTxtErrorURLInvalid },
 { TxtErrorMemLow, (char*)chineseTxtErrorMemLow },
 { TxtErrorPeerAbort, (char*)chineseTxtErrorPeerAbort },
 { TxtError, (char*)chineseTxtError },
{ TxtErrorHTTP, "\x80\x00H\x00T\x00T\x00P\x00\x00" },
{ TxtErrorWSP, "\x80\x00W\x00S\x00P\x00\x00" },
{ TxtErrorWAE, "\x80\x00W\x00A\x00E\x00\x00" },
{ TxtErrorWSPCL, "\x80\x00W\x00S\x00P\x00C\x00L\x00\x00" },
{ TxtErrorWSPCM, "\x80\x00W\x00S\x00P\x00C\x00M\x00\x00" },
{ TxtErrorWTP, "\x80\x00W\x00T\x00P\x00\x00" },
{ TxtErrorWTLS, "\x80\x00W\x00T\x00L\x00S\x00\x00" },
{ TxtErrorWDP, "\x80\x00W\x00D\x00P\x00\x00" },
{ TxtErrorUDCP, "\x80\x00U\x00D\x00C\x00P\x00\x00" },
{ TxtNotSupported, "\x80\x4e\xd\x65\x2f\x63\xf4\x00\x00" },
{ TxtSelectLine, "\x80\x7d\xda\x8d\xef\x52\x7\x63\xdb\x00\x00" },
{ TxtLine1, "\x80\x7d\xda\x8d\xef\x0\x31\x00\x00" },
{ TxtLine2, "\x80\x7d\xda\x8d\xef\x0\x32\x00\x00" },
{ TxtInfoNumbers, "\x80\x00I\x00n\x00f\x00o\x00 \x00N\x00u\x00m\x00b\x00e\x00r\x00s\x00\x00" },
{ TxtAttach, "\x80\x96\x44\x84\x57\x00\x00" },
{ TxtDetach, "\x80\x53\xbb\x96\x44\x84\x57\x00\x00" },
{ TxtGPRSAuto, "\x80\x67\x9\x7d\xb2\x8d\xef\x4f\xe1\x86\x5f\x66\x42\x00\x00" },
{ TxtGPRSNeed, "\x80\x75\x76\x97\x0\x89\x81\x66\x42\x00\x00" },
{ TxtAttachMode, "\x80\x00G\x00P\x00R\x00S\x63\xa5\x51\x65\x00\x00" },
{ TxtDefineContext, "\x80\x00D\x00e\x00f\x00i\x00n\x00e\x00 \x00C\x00t\x00x\x00t\x00\x00" },
{ TxtActivateContext, "\x80\x00A\x00c\x00t\x00i\x00v\x00a\x00t\x00e\x00 \x00C\x00t\x00x\x00t\x00\x00" },
{ TxtDeactivateContext, "\x80\x00D\x00e\x00a\x00c\x00t\x00i\x00v\x00.\x00 \x00C\x00t\x00x\x00t\x00\x00" },
{ TxtGPRSPreferred, "\x80\x00G\x00P\x00R\x00S\x00 \x00P\x00r\x00e\x00f\x00e\x00r\x00r\x00e\x00d\x00\x00" },
{ TxtCSDPreferred, "\x80\x00C\x00S\x00D\x00 \x00P\x00r\x00e\x00f\x00e\x00r\x00r\x00e\x00d\x00\x00" },
{ TxtNotAttached, "\x80\x00G\x00P\x00R\x00S\x5d\xf2\x65\xb7\x95\x8b\x00\x00" },
{ TxtAlreadyAttached, "\x80\x5d\xf2\x7d\x93\x96\x44\x84\x57\x00\x00" },
{ TxtSelected, "\x80\x00S\x00e\x00l\x00e\x00c\x00t\x00e\x00d\x00\x00" },
{ TxtNetwork, "\x80\x00N\x00e\x00t\x00w\x00o\x00r\x00k\x00\x00" },
{ TxtForbidden, "\x80\x00F\x00o\x00r\x00b\x00i\x00d\x00d\x00e\x00n\x00\x00" },
{ TxtActivateFDN, "\x80\x00A\x00c\x00t\x00i\x00v\x00a\x00t\x00e\x00 \x00F\x00D\x00N\x00\x00" },
{ TxtPlease, "\x80\x00P\x00l\x00e\x00a\x00s\x00e\x00\x00" },
{ TxtTimedOut, "\x80\x00T\x00i\x00m\x00e\x00d\x00 \x00O\x00u\x00t\x00\x00" },
{ TxtWillChangeOn, "\x80\x00W\x00i\x00l\x00l\x00 \x00C\x00h\x00a\x00n\x00g\x00e\x00 \x00O\x00n\x00\x00" },
{ TxtAttached, "\x80\x96\x44\x84\x57\x62\x10\x52\x9f\x00\x00" },
{ TxtDetached, "\x80\x53\xbb\x96\x44\x84\x57\x62\x10\x52\x9f\x00\x00" },
{ TxtUnknown, "\x80\x00U\x00n\x00k\x00n\x00o\x00w\x00n\x00\x00" },
{ TxtCallTransfer, "\x80\x00T\x00r\x00a\x00n\x00s\x00f\x00e\x00r\x00 \x00C\x00a\x00l\x00l\x00s\x00\x00" },
{ TxtBufferFull, "\x80\x5d\xf2\x8f\x38\x51\x65\x76\x84\x5b\x57\x51\x43\x59\x2a\x59\x1a\xff\xc\x71\x21\x6c\xd5\x8f\x38\x51\x65\x6f\x22\x5b\x57\x00\x00" },
{ TxtAddNewCall, "\x80\x65\xb0\x64\xa5\x96\xfb\x8a\x71\x00\x00" },
{ TxtEndOne, "\x80\x7d\x50\x67\x5f\x4e\x00\x65\xb9\x00\x00" },
{ TxtCallMenu, "\x80\x54\x7c\x53\xeb\x52\x9f\x80\xfd\x88\x68\x00\x00" },
{ TxtBackgroud, "\x80\x72\x46\x7d\x19\x00\x00" },
{ TxtSelBackgroud, "\x80\x90\x78\x64\xc7\x72\x46\x7d\x19\x00\x00" },
{ TxtBackgroundDisabled, "\x80\x95\xdc\x95\x89\x72\x46\x7d\x19\x00\x00" },
{ TxtA, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x31\x00\x00" },
{ TxtB, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x32\x00\x00" },
{ TxtUserDefine, "\x80\x75\x28\x62\x36\x5b\x9a\x7f\xa9\x00\x00" },
{ TxtUserdefine1, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x33\x00\x00" },
{ TxtUserdefine2, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x34\x00\x00" },
{ TxtUserdefine3, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x35\x00\x00" },
{ TxtUserdefine4, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x36\x00\x00" },
{ TxtUserdefine5, "\x80\x75\x28\x62\x36\x57\x16\x72\x47\x0\x37\x00\x00" },
{ TxtUserDefinedPic, "\x80\x75\x28\x62\x36\x81\xea\x8a\x2d\x57\x16\x72\x47\x00\x00" },
{ TxtNoUserPic, "\x80\x71\x21\x57\x16\x72\x47\x00\x00" },
{ TxtRename, "\x80\x91\xcd\x54\x7d\x54\xd\x00\x00" },
{ TxtAdjustContrast, "\x80\x5c\xd\x6b\xd4\x5e\xa6\x8a\xbf\x7b\xc0\x00\x00" },
{ TxtOnOffAnimation, "\x80\x95\x8b\x6a\x5f\x52\xd5\x75\x6b\x00\x00" },
{ TxtBackLight, "\x80\x80\xcc\x51\x49\x00\x00" },
{ TxtBmpAlbum, "\x80\x57\x16\x72\x47\x5e\xab\x00\x00" },
{ TxtGreetingWord, "\x80\x5f\x85\x6a\x5f\x55\x4f\x50\x19\x8a\x9e\x00\x00" },
{ TxtDsplSetting, "\x80\x98\x6f\x79\x3a\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtBacklightOnTime, "\x80\x80\xcc\x51\x49\x95\x8b\x55\x53\x66\x42\x95\x93\x00\x00" },
{ TxtBacklightOffTime, "\x80\x80\xcc\x51\x49\x95\xdc\x95\x89\x66\x42\x95\x93\x00\x00" },
{ TxtBacklightIntensity, "\x80\x80\xcc\x51\x49\x5f\x37\x5e\xa6\x00\x00" },
{ TxtSavingSetting, "\x80\x77\x1\x96\xfb\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtGreetingWordOn, "\x80\x55\x4f\x50\x19\x8a\x9e\x95\x8b\x00 \x00\x00" },
{ TxtGreetingWordOff, "\x80\x55\x4f\x50\x19\x8a\x9e\x95\xdc\x00\x00" },
{ TxtGreetingWordEdit, "\x80\x7d\xe8\x8f\x2f\x55\x4f\x50\x19\x8a\x9e\x00\x00" },
{ TxtMobileInnovation, "\x80\x64\x69\x52\x75\x00\x00" },
{ TxtFlower, "\x80\x82\xb1\x95\x8b\x00\x00" },
{ TxtSkyrocket, "\x80\x71\x59\x82\xb1\x00\x00" },
 { TxtCloseAnim,  "\x80\x95\xdc\x52\xd5\x75\x6b\x00\x00"},
{ TxtSavingMode, "\x80\x77\x1\x96\xfb\x6a\x21\x5f\xf\x00\x00" },
{ TxtNormalMode, "\x80\x6b\x63\x5e\x38\x6a\x21\x5f\xf\x00\x00" },
{ TxtMobileSettings, "\x80\x62\x4b\x6a\x5f\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtVoiceCallDivert, "\x80\x8a\x9e\x97\xf3\x4f\x86\x96\xfb\x8f\x49\x79\xfb\x00\x00" },
{ TxtAllFaxCallDivert, "\x80\x62\x40\x67\x9\x50\xb3\x77\x1f\x4f\x86\x96\xfb\x00\x00" },
{ TxtAllDataCallDivert, "\x80\x62\x40\x67\x9\x8c\xc7\x65\x99\x4f\x86\x96\xfb\x00\x00" },
{ TxtVoiceMailBox, "\x80\x8a\x9e\x97\xf3\x4f\xe1\x7b\xb1\x00\x00" },
{ TxtOtherNumber, "\x80\x51\x76\x4e\xd6\x86\x5f\x78\xbc\x00\x00" },
{ TxtNumberInCommonUse, "\x80\x5e\x38\x75\x28\x86\x5f\x78\xbc\x00\x00" },
{ TxtCallSettings, "\x80\x90\x1a\x8a\x71\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtMinuteHint, "\x80\x52\x6\x94\x18\x63\xd0\x79\x3a\x00\x00" },
{ TxtNextCall, "\x80\x4e\xb\x6b\x21\x90\x1a\x8a\x71\x00\x00" },
{ TxtCUGNumber, "\x80\x52\x6\x7d\x44\x96\xfb\x8a\x71\x00\x00" },
{ TxtPreDefine, "\x80\x98\x10\x5b\x9a\x7f\xa9\x00\x00" },
{ TxtEnterIndex, "\x80\x8f\x38\x51\x65\x7d\x22\x5f\x15\x86\x5f\x00\x00" },
{ TxtAddCUG, "\x80\x6d\xfb\x52\xa0\x00\x00" },
{ TxtModify, "\x80\x4f\xee\x65\x39\x00\x00" },
{ TxtDCTbVar0, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x30\x00]\x00\x00" },
{ TxtDCTbVar1, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x31\x00]\x00\x00" },
{ TxtDCTbVar2, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x32\x00]\x00\x00" },
{ TxtDCTbVar3, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x33\x00]\x00\x00" },
{ TxtDCTbVar4, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x34\x00]\x00\x00" },
{ TxtDCTbVar5, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x35\x00]\x00\x00" },
{ TxtDCTbVar6, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x36\x00]\x00\x00" },
{ TxtDCTbVar7, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x37\x00]\x00\x00" },
{ TxtDCTbVar8, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x38\x00]\x00\x00" },
{ TxtDCTbVar9, "\x80\x00D\x00C\x00T\x00b\x00V\x00a\x00r\x00[\x0\x39\x00]\x00\x00" },
{ TxtEnterNRyTime, "\x80\x66\x42\x95\x93\xff\x8\x0\x35\x00-\x0\x33\x0\x30\x79\xd2\xff\x9\x00\x00" },
{ TxtCancelAffirm, "\x80\x78\xba\x5b\xe6\x89\x81\x53\xd6\x6d\x88\x00\x00" },
{ TxtWithout, "\x80\x71\x21\x00\x00" },
{ TxtScene, "\x80\x60\xc5\x66\x6f\x6a\x21\x5f\xf\x00\x00" },
{ TxtNormals, "\x80\x66\x6e\x90\x1a\x74\xb0\x58\x83\x00\x00" },
{ TxtOut, "\x80\x62\x36\x59\x16\x74\xb0\x58\x83\x00\x00" },
{ TxtMeeting, "\x80\x67\x3\x8b\x70\x74\xb0\x58\x83\x00\x00" },
{ TxtIncar, "\x80\x5b\xa4\x51\x67\x74\xb0\x58\x83\x00\x00" },
{ TxtStart, "\x80\x55\x53\x52\xd5\x00\x00" },
{ TxtPssetting, "\x80\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtAnswer, "\x80\x63\xa5\x80\x7d\x8a\x2d\x7f\x6e\x00\x00" },
{ Txtmelody1, "\x80\x67\x00\x7f\x8e\x00\x00" },
{ Txtmelody2, "\x80\x62\x11\x76\x84\x5f\xc3\x59\x2a\x4e\x82\x00\x00" },
{ Txtmelody3, "\x80\x4e\xd6\x4e\x00\x5b\x9a\x5f\x88\x61\x1b\x4f\x60\x00\x00" },
{ Txtmelody4, "\x80\x56\xdb\x5b\x63\x00-\x66\x25\x4e\x4b\x9c\xe5\x9c\xf4\x00\x00" },
{ Txtmelody5, "\x80\x95\x8b\x5f\xc3\x5e\x3\x9b\x6f\x65\xaf\x00\x00" },
{ Txtmelody6, "\x80\x96\x3f\x91\xcc\x5c\x71\x76\x84\x59\xd1\x5a\x18\x00\x00" },
{ Txtmelody7, "\x80\x00\x62\x5c\xf\x8a\xbf\x53\x54\x59\x4f\x66\xf2\x00\x00" },
{ Txtmelody8, "\x80\x80\x70\x66\xe\x76\x84\x50\xa2\x59\x25\x00\x00" },
{ Txtmelody9, "\x80\x50\xb3\x59\x47\x65\x45\x4e\x8b\x00\x00" },
{ Txtmelody10, "\x80\x52\x4d\x5f\x80\x66\x6e\x6f\xdf\x5c\xf6\x00\x00" },
{ Txtmelody11, "\x80\x64\x16\x6e\xfe\x82\x1e\x66\xf2\x00\x00" },
{ Txtmelody12, "\x80\x72\x35\x58\xeb\x6a\x2\x00\x00" },
{ Txtmelody13, "\x80\x6d\x77\x6f\xf1\x4e\x4b\x66\x68\x00\x00" },
{ Txtmelody14, "\x80\x9b\x54\x73\x8b\x5b\xae\x4e\x2d\x00\x00" },
{ Txtmelody15, "\x80\x72\x35\x58\xeb\x00\x00" },
{ Txtmelody16, "\x80\x98\xdb\x5f\x48\x00\x00" },
{ Txtmelody17, "\x80\x5f\xeb\x6a\x2\x76\x84\x8f\xb2\x59\x2b\x00\x00" },
{ Txtmelody18, "\x80\x6d\x77\x6f\xf1\x4e\x4b\x6b\x4c\x00\x00" },
{ Txtmelody19, "\x80\x9e\xc3\x73\xab\x74\x70\x00\x00" },
{ Txtmelody20, "\x80\x59\x73\x5b\x69\x82\x7\x56\xdb\x91\xcd\x59\x4f\x00\x00" },
{ TxtmelodyNone, "\x80\x71\x21\x92\x34\x80\x72\x00\x00" },
{ TxtSmsRing1, "\x80\x92\x34\x80\x72\x0\x31\x00\x00" },
{ TxtSmsRing2, "\x80\x92\x34\x80\x72\x0\x32\x00\x00" },
{ TxtSmsRing3, "\x80\x92\x34\x80\x72\x0\x33\x00\x00" },
{ TxtSmsRing4, "\x80\x92\x34\x80\x72\x0\x34\x00\x00" },
{ TxtSmsRing5, "\x80\x92\x34\x80\x72\x0\x35\x00\x00" },
{ TxtHostKey, "\x80\x62\x4b\x6a\x5f\x5b\xc6\x78\xbc\x00\x00" },
{ TxtHostSwitchOn, "\x80\x95\x8b\x6a\x5f\x4f\xdd\x8b\x77\x00\x00" },
{ TxtHostSimLock , "\x80\x00S\x00I\x00M\x53\x61\x93\x96\x5b\x9a\x00\x00" },
{ TxtHostDelPbkall, "\x80\x6e\x5\x7a\x7a\x96\xfb\x8a\x71\x67\x2c\x00\x00" },
{ TxtHostReset , "\x80\x60\x62\x5f\xa9\x51\xfa\x5e\xe0\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtHostMsgbox, "\x80\x62\x4b\x6a\x5f\x4f\xe1\x7b\xb1\x4f\xdd\x8b\x77\x00\x00" },
{ TxtHostKeySet , "\x80\x62\x4b\x6a\x5f\x5b\xc6\x78\xbc\x95\x8b\x55\x53\x00\x00" },
{ TxtHostKeyChange, "\x80\x62\x4b\x6a\x5f\x5b\xc6\x78\xbc\x4f\xee\x65\x39\x00\x00" },
{ TxtHostKeyItems, "\x80\x4f\xdd\x8b\x77\x98\x5\x00\x00" },
{ TxtEnterHostKey, "\x80\x8a\xcb\x8f\x38\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x00\x00" },
{ TxtSimReplaced, "\x80\x00S\x00I\x00M\x53\x61\x88\xab\x66\xf4\x63\xdb\x00\x00" },
{ TxtHostKeyOk , "\x80\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x6b\x63\x78\xba\x00\x00" },
{ TxtHostKeyFail, "\x80\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x93\x2f\x8a\xa4\x00\x00" },
{ TxtOldHostKey, "\x80\x82\xa\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x00\x00" },
{ TxtNewHostKey , "\x80\x65\xb0\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x00\x00" },
{ TxtHostKeyConfirm, "\x80\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x78\xba\x8a\x8d\x00\x00" },
{ TxtHostKeyChangeOk, "\x80\x62\x10\x52\x9f\xff\x1\x00\x00" },
{ TxtHostKeyChangeFail, "\x80\x59\x31\x65\x57\x00!\x00\x00" },
{ TxtHostKeyNotOn, "\x80\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x67\x2a\x55\x5f\x52\xd5\x00\x00" },
{ TxtHostKeyOpen, "\x80\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x95\x8b\x55\x53\x00\x00" },
{ TxtHostKeyClose, "\x80\x4e\x3b\x6a\x5f\x5b\xc6\x78\xbc\x95\xdc\x95\x89\x00\x00" },
{ TxtHostkeySelect, "\x80\x8a\xcb\x63\x9\x00O\x00K\x93\x75\x90\x78\x64\xc7\x00\x00" },
{ TxtAnswerTone, "\x80\x63\xa5\x90\x1a\x63\xd0\x79\x3a\x97\xf3\x00\x00" },
{ TxtUndoEvent, "\x80\x6f\xf\x8f\xa6\x4e\x8b\x4e\xf6\x63\xd0\x79\x3a\x97\xf3\x00\x00" },
{ TxtUnreadSMSTone, "\x80\x67\x2a\x8b\x80\x6d\x88\x60\x6f\x63\xd0\x79\x3a\x00\x00" },
{ TxtMissedCallTone, "\x80\x67\x2a\x63\xa5\x96\xfb\x8a\x71\x63\xd0\x79\x3a\x00\x00" },
{ TxtAlerttype, "\x80\x63\xd0\x79\x3a\x65\xb9\x5f\xf\x00\x00" },
{ TxtRingmode, "\x80\x97\xff\x92\x34\x00\x00" },
{ TxtRingPrompt, "\x80\x92\x34\x80\x72\x63\xd0\x79\x3a\x00\x00" },
{ TxtVibramode, "\x80\x63\x2f\x52\xd5\x00\x00" },
{ TxtVibraRing, "\x80\x51\x48\x63\x2f\x5f\x8c\x92\x34\x00\x00" },
{ TxtRingandVib, "\x80\x63\x2f\x92\x34\x54\xc\x66\x42\x00\x00" },
{ TxtSmsRing, "\x80\x66\x6e\x90\x1a\x92\x34\x80\x72\x00\x00" },
{ TxtSpecialRing      , "\x80\x72\x79\x6b\x8a\x92\x34\x80\x72\x00\x00" },
{ TxtSmsVibra, "\x80\x63\x2f\x52\xd5\x63\xd0\x79\x3a\x00\x00" },
{ TxtSmsRVibra, "\x80\x51\x48\x63\x2f\x5f\x8c\x92\x34\x00\x00" },
{ TxtSmsMute, "\x80\x97\x5c\x97\xf3\x00\x00" },
{ T_China_Telecomm, "\x80\x4e\x2d\x57\xb\x79\xfb\x52\xd5\x00\x00" },
{ T_China_Unicomm, "\x80\x4e\x2d\x57\xb\x80\x6f\x90\x1a\x00\x00" },
{ TxtDualBand, "\x80\x96\xd9\x98\x3b\x00\x00" },
{ TxtGSM900, "\x80\x00G\x00S\x00M\x0\x39\x0\x30\x0\x30\x00\x00" },
{ TxtDCS1800, "\x80\x00D\x00C\x00S\x0\x31\x0\x38\x0\x30\x0\x30\x00\x00" },
{ TxtPLMNInfo, "\x80\x62\x40\x5c\x6c\x7d\xb2\x8d\xef\x00\x00" },
{ TxtPLMNReselect, "\x80\x91\xcd\x65\xb0\x90\x78\x7d\xb2\x00\x00" },
{ TxtRegMode, "\x80\x8a\x3b\x51\x8a\x6a\x21\x5f\xf\x00\x00" },
{ TxtLockBand, "\x80\x93\x96\x5b\x9a\x98\x3b\x6b\xb5\x00\x00" },
{ TxtSearchingNetwork, "\x80\x6b\x63\x57\x28\x64\x1c\x5c\xb\x7d\xb2\x8d\xef\x00\x00" },
{ TxtRegNetwork, "\x80\x7d\xb2\x8d\xef\x8a\x3b\x51\x8a\x00\x00" },
{ TxtPLMNavailable, "\x80\x53\xef\x90\x78\x7d\xb2\x8d\xef\x00\x00" },
{ TxtTimeOut, "\x80\x8d\x85\x66\x42\x00!\x00\x00" },
{ TxtPhonebook, "\x80\x96\xfb\x8a\x71\x67\x2c\x00\x00" },
{ TxtPhoneSearch, "\x80\x67\xe5\x62\x7e\x00\x00" },
{ TxtPhoneAdd , "\x80\x6d\xfb\x52\xa0\x00\x00" },
{ TxtGroupingSetting, "\x80\x52\x6\x7d\x44\x00\x00" },
{ TxtMultiCopy, "\x80\x89\x7\x88\xfd\x00\x00" },
{ TxtClearAll, "\x80\x51\x68\x90\xe8\x52\x2a\x96\x64\x00\x00" },
{ TxtShortCutDial, "\x80\x5f\xeb\x63\x77\x64\xa5\x86\x5f\x00\x00" },
{ TxtMyNumber, "\x80\x67\x2c\x6a\x5f\x86\x5f\x78\xbc\x00\x00" },
{ TxtVoiceList, "\x80\x8a\x9e\x97\xf3\x52\x17\x88\x68\x00\x00" },
{ TxtSearchItem, "\x80\x67\xe5\x8a\x62\x90\x78\x98\x5\x00\x00" },
{ TxtChangeRecord, "\x80\x7d\xe8\x8f\x2f\x00\x00" },
{ TxtCopyRecord, "\x80\x89\x7\x88\xfd\x00\x00" },
{ TxtDeleteRecord, "\x80\x52\x2a\x96\x64\x00\x00" },
{ TxtVoiceCall, "\x80\x8a\x9e\x97\xf3\x64\xa5\x86\x5f\x00\x00" },
{ TxtSIMBook, "\x80\x00S\x00I\x00M\x53\x61\x96\xfb\x8a\x71\x7c\x3f\x00\x00" },
{ TxtNVMBook   , "\x80\x62\x4b\x6a\x5f\x96\xfb\x8a\x71\x7c\x3f\x00\x00" },
{ TxtPhoneNew, "\x80\x65\xb0\x58\x9e\x00\x00" },
{ TxtEnterName, "\x80\x54\xd\x5b\x57\x00\x00" },
{ TxtEnterNumber, "\x80\x62\x4b\x6a\x5f\x00\x00" },
{ TxtEnterHome, "\x80\x4f\x4f\x5b\x85\x96\xfb\x8a\x71\x00\x00" },
{ TxtEnterOffice, "\x80\x8f\xa6\x51\x6c\x96\xfb\x8a\x71\x00\x00" },
{ TxtEnterMemo, "\x80\x50\x99\x8a\x3b\x8c\xc7\x8a\xa\x00:\x00\x00" },
{ TxtGroupingOne, "\x80\x52\x6\x7d\x44\x0\x31\x00\x00" },
{ TxtGroupingTwo, "\x80\x52\x6\x7d\x44\x0\x32\x00\x00" },
{ TxtGroupingThree, "\x80\x52\x6\x7d\x44\x0\x33\x00\x00" },
{ TxtGroupingFour, "\x80\x52\x6\x7d\x44\x0\x34\x00\x00" },
{ TxtGroupingFive, "\x80\x52\x6\x7d\x44\x0\x35\x00\x00" },
{ TxtGroupingSix, "\x80\x52\x6\x7d\x44\x0\x36\x00\x00" },
{ TxtGroupingSeven, "\x80\x52\x6\x7d\x44\x0\x37\x00\x00" },
{ TxtGroupingEight, "\x80\x52\x6\x7d\x44\x0\x38\x00\x00" },
{ TxtGroupingNine, "\x80\x52\x6\x7d\x44\x0\x39\x00\x00" },
{ TxtGroupingTen            , "\x80\x9e\xd1\x54\xd\x55\xae\x00\x00" },
{ TxtGroupingItem, "\x80\x52\x6\x7d\x44\x90\x78\x98\x5\x00\x00" },
{ TxtBrowserMember, "\x80\x62\x10\x54\xe1\x52\x17\x88\x68\x00\x00" },
{ TxtAddMember, "\x80\x90\x78\x64\xc7\x62\x10\x54\xe1\x00\x00" },
{ TxtGroupingIcon, "\x80\x52\x6\x7d\x44\x57\x16\x79\x3a\x00\x00" },
{ TxtGroupingRing, "\x80\x52\x6\x7d\x44\x92\x34\x97\xf3\x00\x00" },
{ TxtGroupingRename, "\x80\x91\xcd\x65\xb0\x54\x7d\x54\xd\x00\x00" },
{ TxtCopyAll, "\x80\x51\x68\x90\xe8\x89\x7\x88\xfd\x00\x00" },
{ TxtCopySIMtoNVM, "\x80\x00S\x00I\x00M\x53\x61\x52\x30\x62\x4b\x6a\x5f\x00\x00" },
{ TxtCopyNVMtoSIM, "\x80\x62\x4b\x6a\x5f\x52\x30\x00S\x00I\x00M\x53\x61\x00\x00" },
{ TxtChoiceCopy   , "\x80\x90\x78\x64\xc7\x89\x7\x88\xfd\x00\x00" },
{ TxtNullNumber, "\x80\x67\x2a\x5b\x9a\x7f\xa9\x00\x00" },
{ TxtPhoneSelect, "\x80\x90\x78\x64\xc7\x86\x5f\x78\xbc\x00\x00" },
{ TxtEditSucceed, "\x80\x4f\xee\x65\x39\x62\x10\x52\x9f\x00\x00" },
{ TxtEditFail   , "\x80\x4f\xee\x65\x39\x59\x31\x65\x57\x00\x00" },
{ TxtAddSucceed, "\x80\x6d\xfb\x52\xa0\x62\x10\x52\x9f\x00\x00" },
{ TxtAddFail, "\x80\x6d\xfb\x52\xa0\x59\x31\x65\x57\x00\x00" },
{ TxtCopySucceed, "\x80\x89\x7\x88\xfd\x62\x10\x52\x9f\x00\x00" },
{ TxtCopyFail, "\x80\x89\x7\x88\xfd\x59\x31\x65\x57\x00\x00" },
{ TxtDelSucceed, "\x80\x52\x2a\x96\x64\x62\x10\x52\x9f\x00\x00" },
{ TxtDelFail, "\x80\x52\x2a\x96\x64\x59\x31\x65\x57\x00\x00" },
{ TxtPhbkFull, "\x80\x96\xfb\x8a\x71\x67\x2c\x6e\xff\x00\x00" },
{ TxtBrowse               , "\x80\x70\xf\x89\xbd\x00\x00" },
{ TxtVoiceMemoAdd, "\x80\x8a\x9e\x97\xf3\x5b\xb9\x91\xcf\x00\x00" },
{ TxtVoiceMemory           , "\x80\x93\x4\x88\xfd\x8a\x9e\x97\xf3\x00\x00" },
{ TxtRecVoice, "\x80\x93\x4\x88\xfd\x8a\x9e\x97\xf3\x00\x00" },
{ TxtPhbkFind, "\x80\x50\xb\x62\x7e\x52\x30\x00\x00" },
{ TxtPhbkCopy, "\x80\x50\xb\x88\xab\x89\x7\x88\xfd\x00\x00" },
{ TxtPhbkDelMess, "\x80\x66\x2f\x54\x26\x52\x2a\x96\x64\x00\x00" },
{ TxtPhbkCopyMess, "\x80\x66\x2f\x54\x26\x89\x7\x88\xfd\x00\x00" },
{ TxtDelMember, "\x80\x52\x2a\x96\x64\x62\x10\x54\xe1\x62\x10\x52\x9f\x00\x00" },
{ TxtMemberAdd, "\x80\x6d\xfb\x52\xa0\x62\x10\x54\xe1\x62\x10\x52\x9f\x00\x00" },
{ TxtDelMemberError, "\x80\x52\x2a\x96\x64\x62\x10\x54\xe1\x62\x10\x52\x9f\x00\x00" },
{ TxtMemberAddError, "\x80\x6d\xfb\x52\xa0\x62\x10\x54\xe1\x59\x31\x65\x57\x00\x00" },
{ TxtPhbkNvmFull, "\x80\x8a\x71\x6a\x5f\x96\xfb\x8a\x71\x67\x2c\x6e\xff\x00\x00" },
{ TxtPhbkSimFull, "\x80\x00S\x00I\x00M\x53\x61\x96\xfb\x8a\x71\x67\x2c\x6e\xff\x00\x00" },
{ TxtPhbkNvmEmpty, "\x80\x8a\x71\x6a\x5f\x96\xfb\x8a\x71\x67\x2c\x71\x21\x8a\x18\x93\x4\x00\x00" },
{ TxtPhbkSimEmpty, "\x80\x00S\x00I\x00M\x53\x61\x96\xfb\x8a\x71\x67\x2c\x71\x21\x8a\x18\x93\x4\x00\x00" },
{ TxtPhbkSIMCopyAll, "\x80\x89\x7\x88\xfd\x00S\x00I\x00M\x53\x61\x62\x40\x67\x9\x8a\x18\x93\x4\x00\x00" },
{ TxtPhbkNVMCopyAll  , "\x80\x89\x7\x88\xfd\x8a\x71\x6a\x5f\x96\xfb\x8a\x71\x67\x2c\x62\x40\x67\x9\x8a\x18\x93\x4\x00\x00" },
{ TxtPhbkSIMCopyError, "\x80\x00S\x00I\x00M\x53\x61\x00 \x7a\x7a\x95\x93\x4e\xd\x8d\xb3\x00,\x89\x7\x88\xfd\x55\xce\x00\x00" },
{ TxtPhbkNVMCopyError, "\x80\x8a\x71\x6a\x5f\x96\xfb\x8a\x71\x67\x2c\x00 \x00 \x7a\x7a\x95\x93\x4e\xd\x8d\xb3\x00,\x89\x7\x88\xfd\x55\xce\x00\x00" },
{ TxtPhbkCopying, "\x80\x6b\x63\x57\x28\x89\x7\x88\xfd\x00.\x00.\x00.\x00\x00" },
{ TxtPhbkDeleteSIMAll, "\x80\x52\x2a\x96\x64\x00S\x00I\x00M\x53\x61\x62\x40\x67\x9\x8a\x18\x93\x4\x55\xce\x00\x00" },
{ TxtPhbkDeleteNVMAll, "\x80\x52\x2a\x96\x64\x8a\x71\x6a\x5f\x96\xfb\x8a\x71\x67\x2c\x62\x40\x67\x9\x8a\x18\x93\x4\x55\xce\x00\x00" },
{ TxtPhbkChange, "\x80\x4f\xee\x65\x39\x00\x00" },
{ TxtPhbkNumber, "\x80\x86\x5f\x78\xbc\x00\x00" },
{ TxtPhbkUse, "\x80\x5d\xf2\x4f\x7f\x75\x28\x00\x00" },
{ TxtPhbkleft, "\x80\x52\x69\x99\x18\x00\x00" },
{ TxtMemoryState, "\x80\x8a\x18\x61\xb6\x9a\xd4\x72\xc0\x61\x4b\x00\x00" },
{ TxtGroupingIconSucceed, "\x80\x52\x6\x7d\x44\x57\x16\x79\x3a\x8a\x2d\x7f\x6e\x62\x10\x52\x9f\x00\x00" },
{ TxtGroupingIconError, "\x80\x52\x6\x7d\x44\x57\x16\x79\x3a\x8a\x2d\x7f\x6e\x59\x31\x65\x57\x00\x00" },
{ TxtGroupingClassmate, "\x80\x54\xc\x5b\x78\x00\x00" },
{ TxtGroupingFriend, "\x80\x67\xb\x53\xcb\x00\x00" },
{ TxtGroupingFamily, "\x80\x5b\xb6\x4e\xba\x00\x00" },
{ TxtGroupingWorkmate, "\x80\x54\xc\x4e\x8b\x00\x00" },
{ TxtRenameForbidden, "\x80\x79\x81\x6b\x62\x66\xf4\x54\xd\x00\x00" },
{ TxtOnlyforBlacklist, "\x80\x9e\xd1\x54\xd\x55\xae\x5c\x8\x75\x28\x00\x00" },
{ TxtTestCommand, "\x80\x6e\x2c\x8a\x66\x54\x7d\x4e\xe4\x00\x00" },
{ TxtSoftwareVersion, "\x80\x8e\xdf\x9a\xd4\x72\x48\x67\x2c\x00\x00" },
{ TxtSpkMic, "\x80\x00S\x00p\x00k\x00&\x00M\x00i\x00c\x00\x00" },
 {TxtSpkMic,			"Spk&Mic"},//Spk&Mic Status
{ TxtMemFlashRtc, "\x80\x00M\x00e\x00m\x00&\x00F\x00l\x00a\x00s\x00h\x00&\x00R\x00t\x00c\x00\x00" },
{ TxtProductTest, "\x80\x75\x1f\x75\x23\x6e\x2c\x8a\x66\x00\x00" },
{ TxtLCDDisplay, "\x80\x00L\x00C\x00D\x6e\x2c\x8a\x66\x00\x00" },
{ TxtLEDBacklight, "\x80\x00L\x00E\x00D\x00,\x63\x9\x93\x75\x80\xcc\x51\x49\x6e\x2c\x8a\x66\x00\x00" },
{ TxtMelodyandVibrator, "\x80\x63\x2f\x92\x34\x54\x8c\x97\x7\x5b\x50\x6e\x2c\x8a\x66\x00\x00" },
{ TxtKeyPressTest, "\x80\x63\x9\x93\x75\x6e\x2c\x8a\x66\x00\x00" },
{ TxtToolkit, "\x80\x5d\xe5\x51\x77\x7b\xb1\x00\x00" },
{ TxtCamera,"\x80\x71\x67\x76\xf8\x67\x3a\x00\x00"},
{ TxtStopwatch, "\x80\x79\xd2\x93\x36\x00\x00" },
{ TxtSeparately, "\x80\x52\x6\x52\x25\x8a\x8\x66\x42\x00\x00" },
{ TxtBycircle, "\x80\x4e\xe5\x57\x8\x8a\x8\x66\x42\x00\x00" },
{ TxtBrowseRecord, "\x80\x70\xf\x89\xbd\x8a\x18\x93\x4\x00\x00" },
{ TxtContinue, "\x80\x7e\x7c\x7e\x8c\x8a\x8\x66\x42\x00\x00" },
{ TxtRestart, "\x80\x91\xcd\x65\xb0\x8a\x8\x66\x42\x00\x00" },
{ TxtNorecord, "\x80\x71\x21\x8a\x18\x93\x4\x00\x00" },
{ TxtConfirm, "\x80\x78\xba\x5b\x9a\x00\x00" },
{ TxtBack, "\x80\x8f\xd4\x56\xde\x00\x00" },
{ TxtOnebyone, "\x80\x90\x10\x50\xb\x52\x2a\x96\x64\x00\x00" },
{ TxtDeleteError, "\x80\x52\x2a\x96\x64\x51\xfa\x93\x2f\x00\x00" },
{ TxtSaveError, "\x80\x5b\x58\x51\x32\x93\x2f\x8a\xa4\x00\x00" },
{ TxtTimer, "\x80\x8a\x8\x66\x42\x56\x68\x00\x00" },
{ TxtSetontime, "\x80\x8f\x38\x51\x65\x95\x8b\x6a\x5f\x66\x42\x95\x93\x00\x00" },
{ TxtOpen, "\x80\x95\x8b\x55\x53\x00\x00" },
{ TxtClose, "\x80\x95\xdc\x95\x89\x00\x00" },
{ TxtSettime, "\x80\x8a\x2d\x5b\x9a\x5b\x9a\x66\x42\x66\x42\x95\x93\x00\x00" },
{ TxtLefttime, "\x80\x96\xe2\x62\x40\x5b\x9a\x66\x42\x95\x93\x90\x84\x52\x69\x00\x00" },
{ TxtTimeup, "\x80\x5b\x9a\x66\x42\x66\x42\x95\x93\x52\x30\x00\x00" },
{ TxtAutopower, "\x80\x81\xea\x52\xd5\x95\x8b\x95\xdc\x6a\x5f\x00\x00" },
{ TxtOpentime, "\x80\x8f\x38\x51\x65\x95\x8b\x6a\x5f\x66\x42\x95\x93\x00\x00" },
{ TxtClosetime, "\x80\x8f\x38\x51\x65\x95\xdc\x6a\x5f\x66\x42\x95\x93\x00\x00" },
{ TxtNote, "\x80\x5f\x85\x8f\xa6\x4e\x8b\x98\x5\x00\x00" },
{ TxtNotebrowse, "\x80\x67\xe5\x77\xb\x00\x00" },
{ TxtAdd, "\x80\x58\x9e\x52\xa0\x00\x00" },
{ TxtChpriority, "\x80\x65\x39\x8b\x8a\x51\x2a\x51\x48\x98\x6\x5e\x8f\x00\x00" },
{ TxtToschedule, "\x80\x5b\x58\x72\x32\x65\xe5\x7a\xb\x00\x00" },
{ TxtTomessage, "\x80\x76\x7c\x77\xed\x4f\xe1\x00\x00" },
{ TxtOnce, "\x80\x4e\x00\x6b\x21\x00\x00" },
{ TxtDay, "\x80\x6b\xcf\x59\x29\x00\x00" },
{ TxtWeek, "\x80\x6b\xcf\x54\x68\x00\x00" },
{ TxtMonth, "\x80\x6b\xcf\x67\x8\x00\x00" },
{ TxtYear, "\x80\x6b\xcf\x5e\x74\x00\x00" },
{ TxtRing, "\x80\x52\xa0\x9b\x27\x94\x18\x55\xce\x00\x00" },
{ TxtSchedule, "\x80\x65\xe5\x7a\xb\x7b\xa1\x74\x6\x00\x00" },
{ TxtWeekDay, "\x80\x65\xe5\x4e\x00\x4e\x8c\x4e\x9\x56\xdb\x4e\x94\x51\x6d\x00\x00" },
{ TxtNewSche, "\x80\x65\xb0\x65\xe5\x7a\xb\x00\x00" },
{ TxtToday, "\x80\x75\x76\x59\x29\x65\xe5\x7a\xb\x00\x00" },
{ TxtAllSche, "\x80\x51\x68\x90\xe8\x65\xe5\x7a\xb\x00\x00" },
{ TxtDeleteOld, "\x80\x52\x2a\x96\x64\x5d\xf2\x90\x4e\x65\xe5\x7a\xb\x00\x00" },
{ TxtScheMeeting, "\x80\x67\x3\x8b\x70\x00 \x00\x00" },
{ TxtBirthday, "\x80\x75\x1f\x65\xe5\x00\x00" },
{ TxtAppointment, "\x80\x7d\x4\x67\x3\x00\x00" },
{ TxtRemind, "\x80\x63\xd0\x91\x92\x00\x00" },
{ TxtReConfirm, "\x80\x78\xba\x5b\x9a\x55\xce\x00\x00" },
{ TxtInputError, "\x80\x8f\x38\x51\x65\x93\x2f\x8a\xa4\x00\x00" },
{ TxtResult, "\x80\x7d\x50\x67\x9c\x00\x00" },
{ TxtDeleteOnebyOne, "\x80\x90\x10\x50\xb\x52\x2a\x96\x64\x00\x00" },
{ TxtConversion, "\x80\x55\xae\x4f\x4d\x63\xdb\x7b\x97\x00\x00" },
{ TxtLength, "\x80\x95\x77\x5e\xa6\x00\x00" },
{ TxtAcre, "\x80\x97\x62\x7a\x4d\x00\x00" },
{ TxtUnitVolume, "\x80\x9a\xd4\x7a\x4d\x00\x00" },
{ TxtWeight, "\x80\x91\xcd\x91\xcf\x00\x00" },
{ TxtInitValue, "\x80\x52\x1d\x59\xcb\x50\x3c\x00\x00" },
{ TxtResultValue, "\x80\x8f\x49\x63\xdb\x50\x3c\x00\x00" },
{ TxtNext, "\x80\x52\x36\x5f\xf\x52\x7\x63\xdb\x00\x00" },
{ TxtOverflow, "\x80\x76\xca\x86\x55\x00\x00" },
{ TxtCall, "\x80\x8a\xcb\x81\xf4\x96\xfb\xff\x1a\x00\x00" },
{ TxtUnitChange, "\x80\x55\xae\x4f\x4d\x52\x7\x63\xdb\x00\x00" },
{ TxtStroke, "\x80\x65\x74\x9e\xde\x58\x31\x66\x42\x00\x00" },
{ TxtYMD, "\x80\x5e\x74\x00/\x67\x8\x00/\x65\xe5\x00\x00" },
{ TxtBrowseAlarm, "\x80\x67\xe5\x77\xb\x72\xc0\x61\x4b\x00\x00" },
{ TxtAutoOff, "\x80\x81\xea\x52\xd5\x95\xdc\x6a\x5f\x55\x53\x52\xd5\x00\x00" },
{ TxtAutoConfirm, "\x80\x66\x2f\x54\x26\x95\xdc\x6a\x5f\x00\x00" },
{ TxtScheSMS, "\x80\x8f\x49\x76\x7c\x72\x32\x77\xed\x4f\xe1\x00\x00" },
{ TxtTooLong, "\x80\x6d\x88\x60\x6f\x59\x2a\x95\x77\x00\x00" },
{ TxtMemo, "\x80\x50\x99\x5f\xd8\x93\x4\x00\x00" },
{ TxtCover, "\x80\x89\x86\x84\xcb\x7b\x2c\x4e\x00\x68\x9d\x00\x00" },
{ TxtAddMemo, "\x80\x6d\xfb\x52\xa0\x50\x99\x5f\xd8\x93\x4\x00\x00" },
{ TxtCalinder, "\x80\x65\xe5\x7a\xb\x88\x68\x00\x00" },
{ TxtPowerOnTime, "\x80\x95\x8b\x6a\x5f\x66\x42\x95\x93\x00\x00" },
{ TxtPowerOffTime, "\x80\x95\xdc\x6a\x5f\x66\x42\x95\x93\x00\x00" },
{ TxtAutoPowerOn, "\x80\x81\xea\x52\xd5\x95\x8b\x6a\x5f\x00\x00" },
{ TxtAutoPowerOff, "\x80\x81\xea\x52\xd5\x95\xdc\x6a\x5f\x00\x00" },
{ TxtValue, "\x80\x50\x3c\x00\x00" },
{ TxtSelectDate, "\x80\x8a\xcb\x90\x78\x64\xc7\x65\xe5\x67\x1f\x00\x00" },
{ TxtGamestart, "\x80\x95\x8b\x59\xcb\x90\x4a\x62\x32\x00\x00" },
{ TxtGameedit, "\x80\x7d\xe8\x8f\x2f\x90\x4a\x62\x32\x00\x00" },
{ TxtGameselect, "\x80\x90\x78\x64\xc7\x90\x4a\x62\x32\x00\x00" },
{ TxtGamesetting, "\x80\x90\x4a\x62\x32\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtGamehelp, "\x80\x90\x4a\x62\x32\x5e\x6b\x52\xa9\x00\x00" },
{ TxtGameScore, "\x80\x7a\x4d\x52\x6\x69\x9c\x00\x00" },
{ TxtGameRestart, "\x80\x91\xcd\x65\xb0\x95\x8b\x59\xcb\x00\x00" },
 {TxtGameWinCondition,"\x80\x90\x0\x51\xfa\x55\xce\x00\x00"},
{ TxtGameStageCruTtl, "\x80\x75\x76\x52\x4d\x00/\x7e\x3d\x51\x71\x00\x00" },
{ TxtGameStageInput, "\x80\x8f\x38\x51\x65\x95\xdc\x65\x78\x00\x00" },
{ TxtGameExit, "\x80\x90\x0\x51\xfa\x00\x00" },
 {TxtGameExitConfirm,"\x80\x90\x0\x51\xfa\x55\xce\x00\x00"},//2004-04-20 Sunny add
 {TxtGameNext,"\x80\x4e\xb\x4e\x00\x95\xdc\x00\x00"},//2004-04-19 Sunny add
{ TxtGameGoon, "\x80\x7e\x7c\x7e\x8c\x00\x00" },
{ TxtSnakegame, "\x80\x8c\xaa\x54\x3\x86\xc7\x00\x00" },
{ TxtBoxmangame, "\x80\x63\xa8\x7b\xb1\x5b\x50\x00\x00" },
 {TxtBoxmanHelp, "\x80\x52\xdd\x52\x29\x68\x9d\x4e\xf6\xff\x1a\x62\x40\x67\x9\x7b\xb1\x5b\x50\x54\x8c\x76\xee\x6a\x19\x91\xcd\x54\x8\x63\x9\x93\x75\x8c\xc7\x8a\xa\xff\x1a\x8a\xcb\x67\xe5\x77\xb\x90\x4a\x62\x32\x8a\x2d\x7f\x6e\x50\x74\x97\xf3\x93\x75\xff\x1a\x79\xfb\x52\xd5\x7b\xad\x98\x2d\x00*\xff\x1a\x90\x0\x51\xfa\x8a\x2d\x7f\x6e\x0\xb\x00\x00"},
 {TxtSnakeHelp, (char *)chineseTxtSnakeHelp},//2004-04-23 Sunny add
{ TxtBalloongame, "\x80\x62\x53\x6c\x23\x74\x3\x00\x00" },
{ TxtRussiagame, "\x80\x4f\xc4\x7f\x85\x65\xaf\x65\xb9\x58\x4a\x00\x00" },
{ TxtSoftClearall , "\x80\x6e\x5\x69\x5a\x8a\x18\x93\x4\x00\x00" },
{ TxtFlashErr , "\x80\x00F\x00L\x00A\x00S\x00H\x51\xfa\x93\x2f\xff\x1\x00\x00" },
{ TxtGame, "\x80\x90\x4a\x62\x32\x00\x00" },
{ TxtSuoha, "\x80\x68\xad\x54\xc8\x00\x00" },
{ TxtSuohaNew, "\x80\x65\xb0\x90\x4a\x62\x32\x00\x00" },
{ TxtSuohaPre, "\x80\x4e\xa\x4e\x00\x6b\x21\x00\x00" },
{ TxtConnected , "\x80\x00C\x00o\x00n\x00n\x00e\x00c\x00t\x00e\x00d\x00\x00" },
{ TxtGSM_900 , "\x80\x00G\x00S\x00M\x00 \x0\x39\x0\x30\x0\x30\x00\x00" },
{ TxtDCS_1800, "\x80\x00D\x00C\x00S\x00 \x0\x31\x0\x38\x0\x30\x0\x30\x00\x00" },
{ TxtPCS_1900, "\x80\x00P\x00C\x00S\x00 \x0\x31\x0\x39\x0\x30\x0\x30\x00\x00" },
{ TxtE_GSM, "\x80\x00E\x00 \x00G\x00S\x00M\x00\x00" },
{ TxtGSM_850, "\x80\x00G\x00S\x00M\x00 \x0\x38\x0\x35\x0\x30\x00\x00" },
{ TxtCallTimeout, "\x80\x54\x7c\x53\xeb\x8d\x85\x66\x42\x00\x00" },
{ TxtBand, "\x80\x00B\x00a\x00n\x00d\x00\x00" },
{ TxtSatRefresh, "\x80\x00S\x00A\x00T\x00 \x00r\x00e\x00f\x00r\x00e\x00s\x00h\x00\x00" },
{ TxtCallBlocked, "\x80\x54\x7c\x53\xeb\x96\x50\x52\x36\x00\x00" },
{ TxtSRR, "\x80\x72\xc0\x61\x4b\x58\x31\x54\x4a\x00\x00" },
{ TxtDelivered, "\x80\x5d\xf2\x76\x7c\x5f\x80\x00\x00" },
{ TxtTempError, "\x80\x0\x00\x00" },
{ TxtSetDate, "\x80\x8a\x2d\x7f\x6e\x65\xe5\x67\x1f\x00\x00" },
{ TxtSetTime, "\x80\x8a\x2d\x7f\x6e\x66\x42\x95\x93\x00\x00" },
{ TxtFullHrAlert, "\x80\x65\x74\x9e\xde\x58\x31\x66\x42\x00\x00" },
{ TxtWorldTime, "\x80\x4e\x16\x75\x4c\x66\x42\x93\x7e\x00\x00" },
{ TxtKwajalein, "\x80\x8a\x87\x8c\xc8\x67\x97\x5c\xf6\x00\x00" },
{ TxtMidwayIs, "\x80\x4e\x2d\x90\x14\x5c\xf6\x00\x00" },
{ TxtSamoa, "\x80\x85\xa9\x64\x69\x4e\x9e\x7f\xa4\x5c\xf6\x00\x00" },
{ TxtHawaii, "\x80\x59\xf\x5a\x1\x59\x37\x00\x00" },
{ TxtHonolulu, "\x80\x70\x6b\x59\x74\x9b\x6f\x9b\x6f\x00\x00" },
{ TxtAlaska, "\x80\x96\x3f\x62\xc9\x65\xaf\x52\xa0\x00\x00" },
{ TxtLosAngeles, "\x80\x6d\x1b\x67\x49\x78\xef\x00\x00" },
{ TxtSanFrancisco, "\x80\x82\xa\x91\xd1\x5c\x71\x00\x00" },
{ TxtDenver, "\x80\x4e\x39\x4f\x5b\x00\x00" },
{ TxtChicago, "\x80\x82\x9d\x52\xa0\x54\xe5\x00\x00" },
{ TxtMexicoCity, "\x80\x58\xa8\x89\x7f\x54\xe5\x57\xce\x00\x00" },
{ TxtNewYork, "\x80\x7d\x10\x7d\x4\x00\x00" },
{ TxtLima, "\x80\x52\x29\x99\xac\x00\x00" },
{ TxtMontreal, "\x80\x84\x99\x72\x79\x52\x29\x72\x3e\x00\x00" },
{ TxtSantiago, "\x80\x80\x56\x57\x30\x72\x59\x54\xe5\x00\x00" },
{ TxtLaPaz, "\x80\x62\xc9\x5d\xf4\x65\xaf\x00\x00" },
{ TxtBrasilia, "\x80\x5d\xf4\x89\x7f\x52\x29\x4e\x9e\x00\x00" },
{ TxtRioDeJaneiro, "\x80\x91\xcc\x7d\x4\x71\xb1\x51\x67\x76\xe7\x00\x00" },
{ TxtMidAtlantic, "\x80\x4e\x2d\x59\x27\x89\x7f\x6d\xb\x00\x00" },
{ TxtCapeVerdeIs, "\x80\x4f\x5b\x5f\x97\x89\xd2\x7f\xa4\x5c\xf6\x00\x00" },
{ TxtLondon, "\x80\x50\x2b\x65\x66\x00\x00" },
{ TxtCasablanca, "\x80\x53\x61\x85\xa9\x5e\x3\x86\x2d\x53\x61\x00\x00" },
{ TxtLisbon, "\x80\x91\xcc\x65\xaf\x67\x2c\x00\x00" },
{ TxtRome, "\x80\x7f\x85\x99\xac\x00\x00" },
{ TxtBerlin, "\x80\x67\xcf\x67\x97\x00\x00" },
{ TxtParis, "\x80\x5d\xf4\x9e\xce\x00\x00" },
{ TxtMadrid, "\x80\x99\xac\x5f\xb7\x91\xcc\x00\x00" },
{ TxtAthens, "\x80\x96\xc5\x51\x78\x00\x00" },
{ TxtEasternEurope, "\x80\x67\x71\x6b\x50\x00\x00" },
{ TxtHelsinki, "\x80\x8d\x6b\x72\x3e\x8f\x9b\x57\xfa\x00\x00" },
{ TxtBaghdad, "\x80\x5d\xf4\x68\x3c\x90\x54\x00\x00" },
{ TxtKoweit, "\x80\x79\xd1\x5a\x1\x72\x79\x00\x00" },
{ TxtMoscow, "\x80\x83\xab\x65\xaf\x79\xd1\x00\x00" },
{ TxtTbilisi, "\x80\x7b\x2c\x6b\xd4\x52\x29\x65\xaf\x00\x00" },
{ TxtIslamabad, "\x80\x4f\xa\x65\xaf\x86\x2d\x58\x21\x00\x00" },
{ TxtAlmaty, "\x80\x96\x3f\x99\xac\x63\xd0\x00\x00" },
{ TxtDhaKa, "\x80\x90\x54\x53\x61\x00\x00" },
{ TxtBangkok, "\x80\x66\xfc\x8c\x37\x00\x00" },
{ TxtJaKarta, "\x80\x96\xc5\x52\xa0\x90\x54\x00\x00" },
{ TxtBeiJing, "\x80\x53\x17\x4e\xac\x00\x00" },
{ TxtHongkong, "\x80\x99\x99\x6e\x2f\x00\x00" },
{ TxtSingapore, "\x80\x65\xb0\x52\xa0\x57\x61\x00\x00" },
{ TxtSeoul, "\x80\x6f\x22\x57\xce\x00\x00" },
{ TxtTokyo, "\x80\x67\x71\x4e\xac\x00\x00" },
{ TxtGuam, "\x80\x95\xdc\x5c\xf6\x00\x00" },
{ TxtSydney, "\x80\x60\x89\x5c\x3c\x00\x00" },
{ TxtVladivostok, "\x80\x6d\x77\x53\xc3\x5d\x34\x00\x00" },
{ TxtSolomonIs, "\x80\x62\x40\x7f\x85\x95\x80\x7f\xa4\x5c\xf6\x00\x00" },
{ TxtFiji, "\x80\x65\x90\x6f\xdf\x00\x00" },
{ TxtMarshallIs, "\x80\x99\xac\x7d\x39\x72\x3e\x7f\xa4\x5c\xf6\x00\x00" },
{ TxtWellington, "\x80\x60\xe0\x97\x48\x98\x13\x00\x00" },
{ TxtDailyAlarm, "\x80\x6b\xcf\x65\xe5\x9b\x27\x94\x18\x00\x00" },
{ TxtWeeklyAlarm, "\x80\x6b\xcf\x54\x68\x9b\x27\x94\x18\x00\x00" },
{ TxtSoftChange, "\x80\x4f\xee\x65\x39\x00\x00" },
{ TxtSunday, "\x80\x66\x1f\x67\x1f\x65\xe5\x00\x00" },
{ TxtMonday, "\x80\x66\x1f\x67\x1f\x4e\x00\x00\x00" },
{ TxtTuesday, "\x80\x66\x1f\x67\x1f\x4e\x8c\x00\x00" },
{ TxtWednesday, "\x80\x66\x1f\x67\x1f\x4e\x9\x00\x00" },
{ TxtThursday, "\x80\x66\x1f\x67\x1f\x56\xdb\x00\x00" },
{ TxtFriday, "\x80\x66\x1f\x67\x1f\x4e\x94\x00\x00" },
{ TxtSaturday, "\x80\x66\x1f\x67\x1f\x51\x6d\x00\x00" },
{ TxtSendTo, "\x80\x76\x7c\x5f\x80\x00\x00" },
{ TxtRecieveFrom, "\x80\x4f\x86\x81\xea\x00\x00" },
{ TxtReadSms, "\x80\x8b\x80\x6d\x88\x60\x6f\x00\x00" },
{ TxtReadMt, "\x80\x65\x36\x4e\xf6\x7b\xb1\x00\x00" },
{ TxtReadMo, "\x80\x76\x7c\x4e\xf6\x7b\xb1\x00\x00" },
{ TxtSendSms, "\x80\x5b\xeb\x6d\x88\x60\x6f\x00\x00" },
{ TxtUNSend, "\x80\x67\x2a\x76\x7c\x90\x1\x00\x00" },
{ TxtSMSSettings, "\x80\x77\xed\x4f\xe1\x8a\x2d\x7f\x6e\x00\x00" },
{ T_CBLanguageAll , "\x80\x62\x40\x67\x9\x8a\x9e\x8a\x0\x00\x00" },
{ T_CBLanguageNone , "\x80\x79\x81\x6b\x62\x62\x40\x67\x9\x00\x00" },
{ T_CBGerman    , "\x80\x5f\xb7\x65\x87\x00\x00" },
{ T_CBEnglish    , "\x80\x82\xf1\x65\x87\x00\x00" },
{ T_CBItalian    , "\x80\x7f\xa9\x59\x27\x52\x29\x8a\x9e\x00\x00" },
{ T_CBFrench    , "\x80\x6c\xd5\x65\x87\x00\x00" },
{ T_CBSpanish   , "\x80\x89\x7f\x73\xed\x72\x59\x8a\x9e\x00\x00" },
{ T_CBDutch    , "\x80\x83\x77\x86\x2d\x8a\x9e\x00\x00" },
{ T_CBSwedish    , "\x80\x74\x5e\x51\x78\x8a\x9e\x00\x00" },
{ T_CBDanish  , "\x80\x4e\x39\x9e\xa5\x8a\x9e\x00\x00" },
{ T_CBPortuguese , "\x80\x84\x61\x84\x4\x72\x59\x8a\x9e\x00\x00" },
{ T_CBFinnish , "\x80\x82\xac\x86\x2d\x8a\x9e\x00\x00" },
{ T_CBNorwegian, "\x80\x63\x2a\x5a\x1\x8a\x9e\x00\x00" },
{ T_CBGreek       , "\x80\x5e\xc\x81\xd8\x8a\x9e\x00\x00" },
{ T_CBTurkish       , "\x80\x57\x1f\x80\x33\x51\x76\x8a\x9e\x00\x00" },
{ T_CBHungarian     , "\x80\x53\x8\x72\x59\x52\x29\x8a\x9e\x00\x00" },
{ T_CBPolish       , "\x80\x6c\xe2\x86\x2d\x8a\x9e\x00\x00" },
{ T_CBLanguage, "\x80\x8a\x9e\x8a\x0\x90\x78\x64\xc7\x00\x00" },
{ TxtOnOff, "\x80\x95\x8b\x95\xdc\x00\x00" },
{ TxtCBCHSET, "\x80\x98\x3b\x90\x53\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtCommonMsg, "\x80\x5e\x38\x75\x28\x8c\xc7\x8a\xa\x00\x00" },
{ TxtSaveToFfs, "\x80\x4f\xdd\x5b\x58\x72\x32\x6a\x21\x67\x7f\x00\x00" },
{ TxtSendOnly, "\x80\x50\xc5\x76\x7c\x90\x1\x00\x00" },
{ TxtSendSave, "\x80\x76\x7c\x90\x1\x4e\x14\x4f\xdd\x5b\x58\x00\x00" },
{ TxtInsertCMmsg, "\x80\x63\xd2\x51\x65\x5e\x38\x75\x28\x8c\xc7\x8a\xa\x00\x00" },
{ TxtNVMMsg, "\x80\x62\x4b\x6a\x5f\x4f\xe1\x7b\xb1\x00\x00" },
{ TxtSaveToNVM, "\x80\x8f\x49\x5b\x58\x52\x30\x62\x4b\x6a\x5f\x4f\xe1\x7b\xb1\x00\x00" },
{ TxtSMSNVMFull, "\x80\x62\x4b\x6a\x5f\x4f\xe1\x7b\xb1\x5d\xf2\x6e\xff\x00\x00" },
{ TxtDeletingSms, "\x80\x6b\x63\x57\x28\x52\x2a\x96\x64\x00\x00" },
{ TxtSavingSms, "\x80\x6b\x63\x57\x28\x4f\xdd\x5b\x58\x00\x00" },
{ TxtSmsFull, "\x80\x00S\x00I\x00M\x53\x61\x4f\xe1\x7b\xb1\x5d\xf2\x6e\xff\x00\x00" },
{ TxtSIMSms, "\x80\x00S\x00I\x00M\x53\x61\x4f\xe1\x7b\xb1\x00\x00" },
{ TxtCBChanel, "\x80\x98\x3b\x90\x53\x00\x00" },
{ TxtDelThisMsg1, "\x80\x52\x2a\x96\x64\x00S\x00I\x00M\x53\x61\x4e\x2d\x00\x00" },
{ TxtDelThisMsg2, "\x80\x8a\x72\x6d\x88\x60\x6f\xff\x1f\x00\x00" },
{ TxtTryAgain, "\x80\x8a\xcb\x91\xcd\x8a\x66\x00\x00" },
{ TxtUselessSMS, "\x80\x71\x21\x65\x48\x6d\x88\x60\x6f\x00\x00" },
{ TxtAdviceDel, "\x80\x5e\xfa\x8b\x70\x52\x2a\x96\x64\x00\x00" },
{ TxtReadingSms, "\x80\x6b\x63\x57\x28\x8b\x80\x53\xd6\x00\x00" },
{ TxtInvalidMessage, "\x80\x71\x21\x65\x48\x6d\x88\x60\x6f\x00\x00" },
{ TxtChanelFull, "\x80\x98\x3b\x90\x53\x5d\xf2\x6e\xff\x00\x00" },
{ TxtNVMInbox, "\x80\x62\x4b\x6a\x5f\x65\x36\x4e\xf6\x7b\xb1\x00\x00" },
{ TxtNVMOutbox, "\x80\x62\x4b\x6a\x5f\x76\x7c\x4e\xf6\x7b\xb1\x00\x00" },
{ TxtRussia, "\x80\x4f\xc4\x7f\x85\x65\xaf\x65\xb9\x58\x4a\x00\x00" },
{ TxtActive, "\x80\x90\x1a\x8a\x71\x4e\x2d\x00\x00" },
{ TxtCallSetup, "\x80\x54\x7c\x53\xeb\x00\x00" },
{ TxtShortCutMenu, "\x80\x5f\xeb\x98\x6f\x52\x9f\x80\xfd\x88\x68\x00\x00" },
{ TxtFunctionSelect, "\x80\x52\x9f\x80\xfd\x90\x78\x64\xc7\x00\x00" },
{ TxtDeleteAllFunctions, "\x80\x52\x2a\x96\x64\x62\x40\x67\x9\x52\x9f\x80\xfd\x98\x5\x55\xce\x00?\x00\x00" },
{ TxtHallOnConnect, "\x80\x7f\xfb\x84\xcb\x63\xa5\x80\x7d\x00\x00" },
{ TxtLedSetting, "\x80\x63\x7\x79\x3a\x71\xc8\x8a\x2d\x7f\x6e\x00\x00" },
{ TxtRejectCalls, "\x80\x62\xd2\x63\xa5\x96\xfb\x8a\x71\x00\x00" },
{ TxtIncomingCallTime, "\x80\x4f\x86\x96\xfb\x66\x42\x95\x93\xff\x1a\x00\x00" },
{ TxtDialTime, "\x80\x64\xa5\x62\x53\x66\x42\x95\x93\x00\x00" },
{ TxtName, "\x80\x59\xd3\x54\xd\xff\x1a\x00\x00" },
{ TxtNumberShow, "\x80\x86\x5f\x78\xbc\xff\x1a\x00\x00" },
{ TXTNoRecentNumber, "\x80\x71\x21\x8f\xd1\x67\x1f\x96\xfb\x8a\x71\x00\x00" },
{ TxtEnterDivertNumber, "\x80\x8f\x49\x79\xfb\x86\x5f\x78\xbc\xff\x1a\x00\x00" },
{ TxtOutgoingDataNew, "\x80\x5d\xf2\x76\x7c\x90\x1\x8c\xc7\x65\x99\x91\xcf\x00\x00" },
{ TxTMakeSureTimeReset, "\x80\x6e\x5\x96\xf6\x55\xce\x00\x00" },
{ TxtHaveReset, "\x80\x5d\xf2\x6e\x5\x96\xf6\x00\x00" },
{ Txtonlinefunction, "\x80\x57\x28\x7d\xda\x52\x9f\x80\xfd\x88\x68\x00\x00" },
{ Txtnotitle, "\x80\x71\x21\x4e\x3b\x98\x4c\x00\x00" },
{ TxtnoGPRSservice, "\x80\x71\x21\x00G\x00P\x00R\x00S\x69\x6d\x52\xd9\x00\x00" },
{ Txt5sec  , "\x80\x0\x35\x79\xd2\x00\x00" },
{ Txt10sec, "\x80\x0\x31\x0\x30\x79\xd2\x00\x00" },
{ Txt15sec, "\x80\x0\x31\x0\x35\x79\xd2\x00\x00" },
{ Txt20sec, "\x80\x0\x32\x0\x30\x79\xd2\x00\x00" },
{ Txt25sec, "\x80\x0\x32\x0\x35\x79\xd2\x00\x00" },
{ Txt30sec, "\x80\x0\x33\x0\x30\x79\xd2\x00\x00" },
{ TxtSetCFTime, "\x80\x8f\x49\x79\xfb\x66\x42\x95\x93\x00\x00" },
{ Txtfunction, "\x80\x52\x9f\x80\xfd\x88\x68\x00\x00" },
{ Txtdisconnectionbrow, "\x80\x65\xb7\x95\x8b\x90\x23\x63\xa5\x00\x00" },
{ TxtSOFTBACK, "\x80\x5f\x8c\x90\x0\x00\x00" },
{ TxtLIST, "\x80\x52\x17\x88\x68\x00\x00" },
{ TxtShowDetails, "\x80\x8a\x73\x60\xc5\x00\x00" },
{ TxtAddVoiceDial, "\x80\x6d\xfb\x52\xa0\x8a\x9e\x97\xf3\x64\xa5\x86\x5f\x00\x00" },
{ TxtModifyVoiceDial, "\x80\x4f\xee\x65\x39\x8a\x9e\x97\xf3\x64\xa5\x86\x5f\x00\x00" },
{ TxtVoiceDialFull, "\x80\x8a\x9e\x97\xf3\x8a\x18\x93\x4\x5d\xf2\x6e\xff\x00\x00" },
{ TxtNoVoiceDial, "\x80\x67\x2a\x8f\x38\x51\x65\x8a\x9e\x97\xf3\x8a\x18\x93\x4\x00\x00" },
{ TxtStartEnroll, "\x80\x95\x8b\x59\xcb\x93\x4\x51\x65\x8a\x9e\x97\xf3\x00\x00" },
{ TxtEnrolling, "\x80\x6b\x63\x57\x28\x93\x4\x51\x65\x8a\x9e\x97\xf3\x00\x00" },
{ TxtEnrollSucess, "\x80\x93\x4\x51\x65\x62\x10\x52\x9f\x00\x00" },
{ TxtStartUpdate, "\x80\x6e\x96\x50\x99\x78\xba\x8a\x9e\x97\xf3\x00\x00" },
{ TxtVoiceUpdating, "\x80\x6b\x63\x57\x28\x78\xba\x8a\x8d\x8a\x9e\x97\xf3\x00\x00" },
{ TxtUpdateSucess, "\x80\x78\xba\x8a\x8d\x62\x10\x52\x9f\x00\x00" },
{ TxtRecordSucess, "\x80\x93\x4\x88\xfd\x8a\x9e\x97\xf3\x62\x10\x52\x9f\x00\x00" },
{ TxtEnrollError, "\x80\x93\x4\x51\x65\x93\x2f\x8a\xa4\x00\x00" },
{ TxtUpdateError, "\x80\x78\xba\x8a\x8d\x93\x2f\x8a\xa4\x00\x00" },
{ TxtStartDial, "\x80\x95\x8b\x59\xcb\x8b\x58\x52\x25\x8a\x9e\x97\xf3\x00\x00" },
{ TxtDialing, "\x80\x6b\x63\x57\x28\x8b\x58\x52\x25\x8a\x9e\x97\xf3\x00\x00" },
{ TxtDialOk, "\x80\x8b\x58\x52\x25\x62\x10\x52\x9f\x00\x00" },
{ TxtDialRedial, "\x80\x91\xcd\x65\xb0\x8b\x58\x52\x25\x00\x00" },
{ TxtDialError, "\x80\x8b\x58\x52\x25\x59\x31\x65\x57\x00\x00" },
{ TxtPlayingNow, "\x80\x6b\x63\x57\x28\x64\xad\x65\x3e\x8a\x9e\x97\xf3\x00\x00" },
{ TxtEnrollOnceMore, "\x80\x51\x8d\x6b\x21\x93\x4\x51\x65\x00\x00" },
{ TxtCallReady, "\x80\x6e\x96\x50\x99\x64\xa5\x86\x5f\x00\x00" },
{ TxtRange, "\x80\x7b\xc4\x57\xd\x00\x00" },
{ TxtConnection, "\x80\x90\x23\x63\xa5\x00\x00" },
{ TxtRoaming, "\x80\x6f\x2b\x90\x4a\x00\x00" },
{ TxtOpenDivert, "\x80\x62\x53\x95\x8b\x8f\x49\x63\xa5\x00\x00" },
{ TxtCloseDivert, "\x80\x95\xdc\x95\x89\x8f\x49\x63\xa5\x00\x00" },
{ TxtLimitedService, "\x80\x96\x50\x52\x36\x67\xd\x52\xd9\x00\x00" },
{ TxtCallDuration, "\x80\x8a\x8\x66\x42\x7d\x71\x8a\x8\x00\x00" },
{ TxtAocStatistics, "\x80\x8c\xbb\x75\x28\x7d\x71\x8a\x8\x00\x00" },
{ TxtInvalidService, "\x80\x6b\x64\x67\xd\x52\xd9\x71\x21\x65\x48\x00\x00" },
{ TxtOnRing, "\x80\x95\x8b\x6a\x5f\x92\x34\x80\x72\x00\x00" },
{ TxtOffRing, "\x80\x95\xdc\x6a\x5f\x92\x34\x80\x72\x00\x00" },
{ TxtOnOffRing, "\x80\x95\x8b\x6a\x5f\x95\xdc\x6a\x5f\x92\x34\x80\x72\x00\x00" },
{ TxtOnVolume, "\x80\x95\x8b\x6a\x5f\x92\x34\x80\x72\x97\xf3\x91\xcf\x00\x00" },
{ TxtOffVolume, "\x80\x95\xdc\x6a\x5f\x92\x34\x80\x72\x97\xf3\x91\xcf\x00\x00" },
{ TxtHallOnRing, "\x80\x95\x8b\x84\xcb\x92\x34\x80\x72\x00\x00" },
{ TxtHallOffRing, "\x80\x95\xdc\x84\xcb\x92\x34\x80\x72\x00\x00" },
{ TxtHallOnOffRing, "\x80\x95\x8b\x95\xdc\x84\xcb\x92\x34\x80\x72\x00\x00" },
{ TxtHallOnVolume, "\x80\x95\x8b\x84\xcb\x92\x34\x80\x72\x97\xf3\x91\xcf\x00\x00" },
{ TxtHallOffVolume, "\x80\x95\xdc\x84\xcb\x92\x34\x80\x72\x97\xf3\x91\xcf\x00\x00" },
{ TxtGroupSelect, "\x80\x92\x34\x80\x72\x90\x78\x64\xc7\x00\x00" },
{ TxtGroupMute, "\x80\x71\x21\x52\x6\x7d\x44\x92\x34\x80\x72\x00\x00" },
{ TxtSwitchLED, "\x80\x4e\x3\x5f\x69\x71\xc8\x00\x00" },
{TxtCheckHideID, "\x80\x8a\xcb\x6a\xa2\x67\xe5\x96\xb1\x85\xcf\x8e\xab\x4e\xfd\x00\x00"},	/* 2004/05/20 wy add */

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
	{TxtCamCatch,	"Take photos"},	//
	{TxtCamBook,	"My photos"},	//
	{TxtCamProperty,"Property"},	//
	{TxtCamMirror, 		"Mirror Display"},  //
	{TxtCamSize,		"Size"},    //ͼƬС
	{TxtCamRotation,	"Rotation"},//ת
	{TxtCamVGA, 		"VGA(640*480)"},
	{TxtCamMobile,		"Moblie(128*120)"},
	
    {TxtCam90,      "Rotate 90"},
    {TxtCam180,     "Rotate 180"},
    {TxtCam270,     "Rotate 270"},

    {TxtCamQuality, "Quality"}, //ͼƬ
    {TxtCamFine,    "Fine"},    //ϸ
    {TxtCamNor,     "Normal"},  //һ
    {TxtCamEco,     "Economy"}, //
    
    {TxtCamOSD,     "Frame"},   //
    {TxtCamM1,      "Melody1"}, //1
    {TxtCamM2,      "Melody2"}, //2
    {TxtCamMelody,  "Melody"},//
#endif


/* 2004/06/19 yhf add */
{TxtBmHelp1, (char*)chineseTxtBmHelp1},
{TxtBmHelp2, (char*)chineseTxtBmHelp2},
{TxtPublicHelp1, (char*)chineseTxtPublicHelp1},
{TxtPublicHelp2, (char*)chineseTxtPublicHelp2},
{TxtPublicHelp3, (char*)chineseTxtPublicHelp3},
{TxtPublicHelp4, (char*)chineseTxtPublicHelp4},
{TxtTerrisHelp1, (char*)chineseTxtTerrisHelp1},
{TxtGameExplain,(char*)chineseTxtGameExplain},	
/* end yhf add */

//2004.08.05 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
//2004-7-29 yangx Add
{TxtPhotoFrameChoice, "\x80\x90\x78\x64\xc7\x76\xf8\x68\x46\x00\x00"};//ѡ
{TxtPhotoCapacity, "\x80\x76\xf8\x72\x47\x5b\xb9\x91\xcf\x00\x00"};//Ƭ
{TxtMemoryCapacity, "\x80\x51\x85\x5b\x58\x5b\xb9\x91\xcf\x00\x00"};//ڴ
{TxtPhotoProperty, "\x80\x76\xf8\x72\x47\x5c\x6c\x60\x27\x00\x00"};//Ƭ
{TxtPhotoSize, "\x80\x59\x27\x5c\x0f\x00\x00"};//С
{TxtPhotoType, "\x80\x98\x5e\x57\x8b\x00\x00"};//
//end yangx
#endif


{ 0, 0 }
};
#endif

/* Text table 1, autogenerated to provide English text associations.
*/


tPointerStructure LanguageIndex_1[LEN_LANGUAGE1+1] = {
    { TxtNull, "" },
    { TxtNotImplemented, "Inval. Request" },
    { TxtManu, "CONDAT" },
    { TxtEnterPin1, "Enter PIN1" },
    { TxtEnterPin2, "Enter PIN2" },
    { TxtEnterPuk1, "Enter PUK1" },
    { TxtEnterPuk2, "Enter PUK2" },
    { TxtInvalidCard, "SIM Invalid" },
    { TxtNoCard, "Insert SIM" },
    { TxtSoftCall, " Call" },
    { TxtSoftOK, "OK" },
    { TxtSoftMenu, "Menu" },
    { TxtHelp, "Help" },
    { TxtSoftContacts, "Contacts" },
    { TxtPlay, "Play" },
    { TxtMessages, "Messages" },
    { TxtAlarm, "Alarm" },
    { TxtAlarmPrompt, "Alarm Alert" },  //xsf add for environment set 2002.09.24
    { TxtSettings, "Settings" },
    { TxtExtra, "Extra" },
    { TxtSend, "Send" },
    { TxtSent, "Sent" },
    { TxtNotSent, "Not sent" },
    { TxtServiceCentre, "Service Cen." },
    { TxtPleaseWait, "Please wait" },
    { TxtSmsEnterNumber, "Enter number" },
    { TxtRead, "Read" },
    { TxtDeleteAll, "Delete all" },
    { TxtSave, "Save" },
    { TxtVoicemail, "VoiceMail" },
    { TxtBroadcast, "Cell Broadcast" },
    { TxtNew, "New" },
    { TxtDigits, "123" },
    { TxtLowercase, "abc" },
    { TxtUppercase, "ABC" },
    { TxtApplications, "Applications" },
    { TxtVoiceMemo, "Voice Memo" },
    { TxtSim, "SIM" },
    { TxtSimNot, "Initializing" },//"SIM not ready" 
    { TxtNotReady, "Not ready !" },
    { TxtSmsListFull, "Message list full" },
    { TxtNewCbMessage, "New CB" },
    { TxtSaved, "Saved" },
    { TxtDelete, "Delete" },
    { TxtReply, "Reply" },
    { TxtStoreNumber, "Store Number" },
    { TxtForward, "Forward" },
    { TxtActivate, "Activate" },
    { TxtTopics, "Topics" },
    { TxtConsult, "Consult" },
    { TxtAddNew, "Add New Entry" },
    { TxtContacts, "Contacts" },
    { TxtSearchName, "Search" },
    { TxtMemory, "Memory Status" },
    { TxtRinger, "Call Alert" },
    { TxtVolume, "Volume" },
    { TxtRingVolume, "Ring Volume" },  //xsf add 2002.08.28 2 lines
    { TxtAlarmVolume, "Alarm Volume" },
    { TxtSpeakerVolume, "SpeakerVolume" },  //xsf add 2002.08.30
    { TxtKeypadTones, "Keypad Tone" },
    { TxtNewMessage, "New Message" },
    { TxtNewBroadcast, "New Broadcast" },
    { TxtAutoAnswer, "Auto Answer" },
    { TxtTimeDate, "Time/Date" },
    { TxtLanguages, "Languages" },
    { TxtPinCode, "Pin Code" },
    { TxtAutoredial, "AutoRedial" },
    { TxtDTMF, "DTMF" },
    { TxtOn, "On" },
    { TxtOff, "Off" },
    { TxtNetworkSel, "Network Set" },
    { TxtSendID, "Hide ID" },
    { TxtChargeTimers, "Call Charge" },
    { TxtCallDivert, "Divert" },
    { TxtDateTime,"Clock"},		//sunsj030918
    { TxtCallWaiting, "Call Waiting" },
    { TxtIfBusy, "If Busy" },
    { TxtIfNoAnswer, "If No Answer" },
    { TxtIfNotReachable, "If Not Reach." },
    { TxtAllCalls, "All Calls" },
    { TxtCancelAll, "Cancel All" },
    { TxtAll, "All" },
    { TxtVoice, "Voice" },
    { TxtFax, "Fax" },
    { TxtData, "Data" },
    { TxtStatus, "Status" },
    { TxtCancel, "Cancel" },
    { TxtCalculator, "Calculator" },
    { TxtSoftBack, "Back" },
    { TxtSoftSelect, "Select   " },
    { TxtSoftConfirm,"Confirm"},
    { TxtSoftOptions, "Options" },
    { TxtEmptyList, "Empty List" },
    { TxtSendMessage, "Send message" },
    { TxtChange, "Change" },
    { TxtWriteError, "Write error" },
    { TxtEntryDeleted, "Entry deleted" },
    { TxtDetails, "Details" },
    { TxtHold, "Hold" },
    { TxtUnhold, "Unhold" },
    { TxtMute, "Mute" },
    { TxtSendDTMF, "Send DTMF" },
    { TxtMainMenu, "Main menu" },
    { TxtSwap, "Swap" },
    { TxtEndAll, "End all" },
    { TxtPrivateCall, "Private call" },
    { TxtStartConference, "Start conference" },
    { TxtReStartConference, "Re-start conference" },
    { TxtFind, "Find:" },
    { TxtServiceNumbers, "Service no." },
    { TxtOutofRange, "Out of Range" },
    { TxtDone, "Done" },
    { TxtFailed, "Failed" },
    { TxtEnterNewPin, "Enter New PIN1" },
    { TxtConfPin, "Confirm PIN1" },
    { TxtChangPin, "PIN1 Changed" },
    { TxtEnd, "End" },
    { TxtPINFail, "PIN Failed" },
    { TxtSOS, "Calling SOS" },
    { TxtAutomatic, "Automatic" },
    { TxtManual, "Manual" },
    { TxtFixedNames, "Fixed Names" },
    { TxtFactoryReset, "Reset settings" },
    { TxtSearching, "Searching" },
    { TxtChangPIN2, "PIN2 Changed" },
    { TxtOldPIN, "Enter Old PIN" },
    { TxtOldPIN2, "Enter Old PIN2" },
    { TxtNotAcc, "Not Accepted" },
    { TxtEnabled, "PIN Enabled" },
    { TxtDisabled, "PIN Disabled" },
    { TxtPINOK, "PIN OK" },
    { TxtSimBlocked, "SIM Blocked" },
    { TxtNewPIN, "New PIN1" },
    { TxtAcc, "Accepted" },
    { TxtNoNetwork, "No Network" },
    { TxtNo, "No" },
    { TxtEnterDate, "Enter Date" },
    { TxtEnterTime, "Enter Time" },
    { TxtScratchPad, "Scratchpad" },
    { TxtDeleted, "Deleted" },
    { TxtActivated, "Activated" },
    { TxtDeActivated, "DeActivated" },
    { TxtDeactivate, "Deactivate" },
    { TxtCheck, "Check" },
    { TxtYes, "Yes" },
    { TxtCallNumber, "Call Number" },
    { TxtEnterMid, "Enter MID" },
    { TxtReadError, "Read Error" },
    { TxtUsed, "Used" },
    { TxtOutgoing, "Outgoing" },
    { TxtMuted, "Muted" },
    { TxtCallEnded, "Call ended" },
    { TxtIncomingCall, "Incoming call" },
    { TxtIncomingData, "IncomingData" },
    { TxtIncomingFax, "Incoming fax" }, //SPR#1147 - DS - Added string to lang table.
    { TxtNumberWithheld, "Num. withheld" }, //SPR#1147 - DS - Modified to fit on screen.
    { TxtAccept, "Accept" },
    { TxtReject, "Reject" },
    { TxtCalling, "Calling" },
    { TxtWaitingAnswer,"WaitingAnswer"},
    { TxtMissedCalls, "Missed calls" }, //2004-04-13 Sunny modify old: missed calls
    { TxtMissedCall, "Missed call" },//2004-04-13 Sunny modify old: missed call
    //2004-03-8 Sunny add.begin
    {TxtCallSingle, "Single Call"},
    {TxtCallTwo, "Two Call"},
    {TxtCallPrivateCall, "Private Call"},
    {TxtCallConfernce, "Confernce"}, 
    {TxtCallSingleMultiparty, "Single MultiParty"},
    {TxtCallMultipartySingle, "MultiParty Single"},    
    //2004-03-8 Sunny add.end
    { TxtLocked, "Keys Locked" },
    { TxtUnmute, "Unmute" },
    { TxtNeedCharging, "Need Charging" },
    { TxtCharging, "Charging..." },
    { TxtChargComplete, "Charge Complete" }, /* 2004/07/19 sunsj modify */
    //2004-04-01 Sunny add 
    { TxtNoPower, "No Power"},
    { TxtSwitchOff, "Switch Off"},
    //2004-04-01 Sunny add end
    { TxtOperationNotAvail, "Not available" },
    { TxtNetUselessInCall,"NetBusy" },
    { TxtNetUselessCallAgain,"TryCallAgain" },
    { TxtAddToConference, "Add to conference" },
    { TxtEmpty, "Empty" },
    { TxtSelectFromList, "Select f.List" },
    { TxtEnterNetworkCode, "Network Code" },
    { TxtMCCMNC, "MCC / MNC ?" },
    { TxtRecord, "Record" },
    { TxtSecurity, "Security" },
    { TxtEnglish, "English" },
    { TxtGerman, "German" },
    { TxtValidity,"Validity" }, 
    { TxtMessageTyp,"Message Typ" }, 
    { TxtSetVoiceMail,"Set VoiceMail" }, 
    { TxtCallTimers,"Call Timers" }, 
    { TxtLastCharge,"Last Charge" },
    { TxtTotalCharge,"Total Charge" },
    { TxtResetCharge,"Reset Charge" },
    { TxtIfNoService,"If No Service" },
    { TxtDiscard, "Discard" }, 
    { TxtEDIT, "Edit" }, 
    { TxtExtractNumber, "Extr.Number." },
    { TxtWrite, "Write" },
    { TxtCheckStatus,"Check Status" },
    { TxtSetDivert,"Set Divert" },
    { TxtCancelDivert,"Cancel Divert" },
    { TxtHideID,"Hide ID" }, 
    { TxtTones,"Tones" },
    { TxtClock,"Clock" },
    { TxtPhone, "Phone" },
    { TxtStop, "Stop" },
    { TxtRecording, "Recording" },
    { TxtPlaying, "Playing"},
    { TxtPlayback, "Playback" },
    { TxtNoNumber, "No number" },
    { TxtOkToDelete, "Delete all ?" },
    { TxtBalance, "Balance" },
    { TxtLimit, "Limit" },
    { TxtLimitEq, "Limit=" },
    { TxtRate, "Rate" },
    { TxtMinutes, "Minutes=" },
    { TxtCost, "Cost=" },
    { TxtCredit, "Credit" },
    { TxtPressOk, "Press Ok to" },
    { TxtReset, "Reset" },
    { TxtIncoming, "Incoming" },
    { TxtCounter, "counter" },
    { TxtOutgoingCalls, "Dialled calls" },
    { TxtCostCounter, "cost counter" },
    { TxtEnterCurrency, "Enter currency" },
    { Txt1Unit, "1 Unit=..." },
    { TxtChanged, "Changed" },
    { TxtEnterLimit, "Enter limit:" },
    { TxtCancelled, "Cancelled" },
    { TxtView, "View" },
    { TxtEnterPCK, "Enter PCK:" },
    { TxtEnterCCK, "Enter CCK:" },
    { TxtEnterNCK, "Enter NCK:" },
    { TxtEnterNSCK, "Enter NSCK:" },
    { TxtEnterSPCK, "Enter SPCK:" },
    { TxtCodeInc, "Password incorrect" },
    { TxtPuk1Inc, "PUKincorrect" },  ///PUK1
    { TxtChangeFail, " incorrect" },
    { TxtBlckPerm, "Blocked permanently" },
    { TxtDealer, "contact your dealer" },
    { TxtSendingDTMF, "Sending DTMF" },
    { TxtCheckNumber, "Check number" },
    { TxtNumberBusy, "Number busy" },
    { TxtNoAnswer, "No answer" },
    { TxtNumberChanged, "Number changed" },
    { TxtNetworkBusy, "Network busy" },
    { TxtNotSubscribed, "Not subscribed" },
    { TxtAnyKeyAnswer, "AnyKeyAnswer" },
    { TxtPINBlock, "PIN Blocked" },
    { TxtEdit, "Edit" },
    { TxtChangePassword,"Change Passw." },
    { TxtSetBar,"Set Bar" },
    { TxtSmsTone,"SMS Alert" },
    { TxtSmsVolume,"SMS Volume" },  ///Ϣ
    { TxtKeypadToneVolume, "Key Tone Volume" },	/* 2003/12/08 sunsj */
    { TxtKeypadToneRing , "Single Ring"},	/* 2003/12/08 sunsj */
    { TxtKeypadToneSpecialRing, "Voice"},	/* 2003/12/08 sunsj */
    { TxtMelody,"Ring Type" },
    { TxtSilent,"Silent" },
    { TxtClick,"Click" },
    { TxtClearAlarm,"Clear Alarm" },
    { TxtTimeFormat,"Time Format" },
    { TxtTwelveHour,"12 Hour"},
    { TxtTwentyfourHour,"24 Hour"},
    { TxtInCallTimer,"In-callTimer" },
    { TxtStore, "Store" },
    { TxtNone, "None" },
    { TxtPIN, "PIN1" },
    { TxtPIN2, "Change PIN2" },     //xsf change "PIN2" to "CHANGE PIN2"  2002.08.28
    { TxtConfPin2, "Confirm PIN2" },
    { TxtNewPIN2, "Enter New PIN2" },
    { TxtUnlockOK, "Unlock OK" },
    { TxtIMEI, "IMEI" },
    { TxtList, "List" },
    { TxtFull, "Full" },
    { TxtCapacityFull,"CapacityFull"},
    { TxtNotAvailable, "NotAvailable" },
    { TxtCallBAOC, "CallBAOC" },
    { TxtCallBAOIC, "CallBAOIC" },
    { TxtCallBAOICexH, "CallBAOICexH" },
    { TxtCallBAIC, "CallBAIC" },
    { TxtCallBAICroam, "CallBAICroam" },
    { TxtCallBarringAll, "Call Barring" },
    { TxtCallBAOCAll, "CallBAOCAll" },
    { TxtCallBAICAll, "CallBAICAll" },
    { TxtCLIP, "CLIP" },
    { TxtCOLP, "COLP" },
    { TxtCOLR, "COLR" },
    { TxtSimToolkit, "SIM Toolkit" },
    { TxtRecentCalls, "RecentCall" },
    { TxtRecordName, "Record Name" },//2004-04-06 Sunny add
    { TxtInterCalls,"Internat.Calls" },
    { TxtInterHome,"Internat.but Home" },
    { TxtWhenRoaming,"when Roaming" },
    { TxtCancelAllBars,"Cancel All B." },
    { TxtWaiting, "Waiting" },
    { TxtBarred, "Barred" },
    { TxtForwarded, "Forwarded" },
    { TxtCallDivertNoReach, "Divert No Reach" },
    { TxtCallDivertNoReply, "Divert No Reply" },
    { TxtCallDivertIfBusy, "Divert If Busy" },
    { TxtPressMenu, "Press Menu, * " },
	/*2003/12/29,talcon comment*/
    { TxtSending, "Sending to"},
    { TxtMessage, "Message"},
    { TxtSoftNext,"Next"},  
    { TxtLastCall,"Last Call"},
    { TxtIncomingCalls,"Received calls"},
    { TxtLow,"Low"},
    { TxtMedium,"Medium"},
    { TxtHigh,"High"},
    { TxtIncreasing,"Increasing"},
    { TxtTimerReset, "Timer Reset"}, 
    { TxtClockSetTo, "Clock Set to"},
    { TxtSilentMode, "Silent Mode"},
    { TxtSmsValidityPeriodSet,"Message Validity Period Set"},
    { Txt1Hour,"1 Hour"},
    { Txt12Hours,"12 Hours"},
    { Txt24Hours,"24 Hours"},
    { Txt1Week,"1 Week"},
    { TxtPin2Code,"Pin2 Code"},
    { TxtEnablePIN,"Activate PIN"},
    { TxtRequesting,"Requesting"},
    { TxtNotAllowed,"Not Allowed"},
    { TxtEmergency,"Emergency ?"},
    { TxtChinese,"Chinese"},
    { TxtPassword,"Password"},
    { TxtConfirmPassword,"Confirm Password"},
    { TxtNewPassword,"New Password"},
    { TxtNoMessages,"List Empty"},
    { TxtTwoAttemptsLeft, "2 tries left" },
    { TxtOneAttemptLeft, "1 try left"},
    { Txtblacklisted, "Numblacklisted"},
    { TxtErrUnknown, "Unknown Error"},
    { TxtSSErr,"SS error"},
    { TxtUnknownSub,"Unknown subscr"},
    { TxtIllSub,"Illegal subscr"},
    { TxtIllEqip,"Illegal device"},
    { TxtIllOp, "Illegal Op"},
    { TxtSubVil,"Subs Violation"},
    { TxtInComp,"Incompatible"},
    { TxtFacNoSup,"Facility unsup"},
    { TxtAbsSub,"Subs absent"},
    { TxtSysFail,"System failure"},
    { TxtMissDta,"Data missing"},
    { TxtUnexDta,"Uexpec data"},
    { TxtPwdErr,"Input Error"},
    { TxtUnkAlph,"Unknown letter"},
    { TxtMaxMpty,"Max part. conf"},
    { TxtResNoAvai,"No Reply"},
    { TxtUnRec,"Unrecognized"},
    { TxtMisTyp,"Mistyped"},
    { TxtBadStruct,"Bad structure"},
    { TxtDupInv,"Duplicated use"},
    { TxtResLim,"No Resource"},
    { TxtIniRel,"Initial Rel."},
    { TxtFatRes,"Fatal Result"},
    { TxtEntAnw,"Answer:"},
    { TxtSsMsg,"SS Message"},
    { TxtOld,"Old"},
    { TxtInsertnote, "Insert Note"},
    { TxtMelodygenerator, "Melodygenerator"},
    { TxtOctaveHigher, "Octave higher"},
    { TxtOctaveLower, "Octave lower"},
    { TxtLoadMelody, "Load melody"},
    { TxtEasyText, "eZiText"},
    { TxtDataCount, "Data Count"},
    { TxtQoS, "QoS"},
    { TxtTypeofConnection, "Connection"},
    { TxtTotalCount, "Total"},
    { TxtResetCount, "Reset Count"},
    { TxtDataCounter, "Data Counter"},
    { TxtV42bis, "v.42bis"},
    { TxtNormal, "Normal"},
    { TxtCSD, "CSD"},
    { TxtClassB, "Class B"},
    { TxtClassC, "Class C"},
    { TxtIPAddress, "IP Address"},
    { TxtIPAddress1, "IP Address 1"},
    { TxtIPAddress2, "IP Address 2"},
    { TxtPort1, "Port 1"},
    { TxtPort2, "Port 2"},
    { TxtAPN, "APN"},
    { TxtConnectionType, "Connect Type"},
    { TxtGPRS, "GPRS"},
    { TxtGPRSInfo, "GPRS Info" },//WUFEI APPEND
    { TxtOutgoingData, "Outgoing Data"},
    { TxtHomepage, "Homepage" },
    { TxtBookmarks, "Bookmarks" },
    { TxtGoTo, "Go to URL" },
    { TxtHistory, "History" },
    { TxtSetup, "Settings" },
    { TxtNewBookmark, "New Bookmark" },
    { TxtWWWdot, "http://www." },
    { TxtWAPdot, "http://wap." },
    { TxtSMS, "SMS" },
    { TxtEmail, "Email" },
    { TxtClear, "Clear" },
    { TxtBookmark, "Add Bookmark" },
    { TxtSelectProfile, "Select Profile" },
    { TxtSetupProfiles, "Setup Profiles" },
    { TxtSaveHistory, "Save History" },
    { TxtEditName, "Edit Name" },
    { TxtEditURL, "Edit URL" },
    { TxtAccessType, "Access type" },
    { TxtResponseTimer, "Response timer" },
    { TxtDialupNumber, "Dial-up Number" },
    { TxtTemporary, "Temporary" },
    { TxtContinuous, "Continuous" },
    { TxtGPRSData, "GPRS data" },
    { TxtCSData, "CS data" },
    { TxtWAP, "WAP" },
    { TxtExit, "Exit" },
    { TxtReload, "Reload" },
    { TxtStored, "Stored"},
    { TxtOther, "Other"},
    { TxtConnecting, "Connecting..." },
    { TxtDownloading, "Loading..." },
    { TxtUpdating, "Updating..." },
    { TxtEnterURL, "Enter URL:" },
    { TxtProfileName, "Profile Name: " },
    { TxtISPUsername, "Username" },
    { TxtISPPassword, "Password" },
    { TxtGoToLink, "Go to Link" },
    { TxtSelect, "Select" },
    { TxtNotConnected, "Not connected" },
    { TxtScaleImages, "Image scaling"},
    { TxtLoggingIn, "Logging in to" },
    { TxtAcceptEndWAP, "Accept will disconnect WAP"},
    { TxtErrorUnknown, "Unknown error"},
    { TxtErrorNotImp, "Not implemented"},
    { TxtErrorUnsupported, "Unsupported version"},
    { TxtErrorOverload, "Overload, WTP Abort"},
    { TxtErrorNoResponse, "No response"},
    { TxtErrorTooLarge, "Message too large"},
    { TxtErrorBadRequest, "Bad request"},
    { TxtErrorUnauthorized, "Unauthorized"},
    { TxtErrorPaymentReq, "Payment required"},
    { TxtErrorForbidden, "Forbidden"},
    { TxtErrorFileNotFnd, "File not found"},
    { TxtErrorNotAllowed, "Method not allowed"},
    { TxtErrorNotAcceptable, "Not acceptable"},
    { TxtErrorAuthReq, "Proxy Authent. Required"},
    { TxtErrorReqTimeout, "Request timeout"},
    { TxtErrorHTTPConf, "HTTP Conflict"},
    { TxtErrorOutOfMem, "Out of memory"},
    { TxtErrorWMLError, "WML error"},
    { TxtErrorDisplay, "Display error, WML syntax"},
    { TxtErrorCardEmpty, "Card empty"},
    { TxtErrorURLInvalid, "URL invalid"},
    { TxtErrorMemLow, "Memory low"},
    { TxtErrorPeerAbort, "Peer requested operation abort"},
    { TxtError, "Error"},
    { TxtErrorHTTP, "HTTP"},
    { TxtErrorWSP, "WSP"},
    { TxtErrorWAE, "WAE"},
    { TxtErrorWSPCL, "WSPCL"},
    { TxtErrorWSPCM, "WSPCM"},
    { TxtErrorWTP, "WTP"},
    { TxtErrorWTLS, "WTLS"},
    { TxtErrorWDP, "WDP"},
    { TxtErrorUDCP, "UDCP"},
    { TxtNotSupported, "Not Supported"},
    { TxtSelectLine, "Select Line"},
    { TxtLine1, "Line 1"},
    { TxtLine2, "Line 2"},
    {TxtInfoNumbers, "Info Numbers"},
    { TxtAttach, "Attach"},
    { TxtDetach, "Detach"},
    { TxtGPRSAuto,"Attach Auto"},/*zy 2003-03-04*/
    { TxtGPRSNeed,"When Need"},/*zy 2003-03-04*/
    { TxtAttachMode,"GRRS Attach"},/*zy 2003-03-04*/
    { TxtDefineContext, "Define Ctxt" },
    { TxtActivateContext, "Activate Ctxt"},
    { TxtDeactivateContext, "Deactiv. Ctxt"},
    { TxtGPRSPreferred, "GPRS Preferred"}, // sbh 25/01/02
    { TxtCSDPreferred, "CSD Preferred"}, // sbh 25/01/02
    { TxtNotAttached, "Not Attached"}, // sbh 28/01/02
    { TxtAlreadyAttached, "Already Att."}, // sbh 8/2/02
    { TxtSelected, "Selected"}, /*ap 06/02/02*/
    { TxtNetwork, "Network"}, /*ap 06/02/02*/
    { TxtForbidden, "Forbidden"}, /*ap 06/02/02*/
    { TxtActivateFDN, "Activate FDN"}, /*ap 06/02/02*/
    { TxtPlease, "Please"},
    { TxtTimedOut, "Timed Out"}, // sbh 13/02/02
    { TxtWillChangeOn, "Will Change On"}, // sbh 13/02/02
    { TxtAttached, "Attached"}, // sbh 14/02/02
    { TxtDetached, "Detached"}, // sbh 14/02/02
    { TxtUnknown, "Unknown"}, //api 13/04/02
    { TxtCallTransfer, "Transfer Calls"},//MC
    {TxtBufferFull, "Too many symbols in buffer, Can't input Chinese."},
    { TxtAddNewCall, "AddNewCall" },//zy Mobile Innovation 01/08/02 
    { TxtEndOne, "EndOne" },//zy Mobile Innovation 01/08/02 
    { TxtCallMenu,"CallMenu"},//zy Mobile Innovation 23/09/02
    { TxtBackgroud, "Wallpaper"},	//sunsj030918
    { TxtSelBackgroud, "Select"},
    { TxtBackgroundDisabled,"Deactivate"},
    { TxtA, "A"},
    { TxtB, "B"}, 
    { TxtUserDefine, "Userdefine"},
    { TxtUserdefine1,"C"},
    { TxtUserdefine2,"D"},
    { TxtUserdefine3,"E"},
    { TxtUserdefine4,"F"},
    { TxtUserdefine5,"G"},
    {TxtUserDefinedPic,"UserDefinedPic"},//chenjun 2002-12-29 add for user defined pic, PCSync
    {TxtNoUserPic,"No Picture"},//chenjun 2003-01-15 for info dialog when there is not any user pic
    { TxtRename, "Rename"},
//    { TxtTheme, "Theme" },/*2003/1201,talcon comment*/
    { TxtAdjustContrast,"Contrast"},
    { TxtOnOffAnimation, "On/Off Anim" },
    { TxtBackLight, "Backlight" },
    { TxtBmpAlbum, "BmpAlbum" },
    { TxtGreetingWord, "Greeting" },	/* 2004/04/12 sunsj modify */
    { TxtDsplSetting, "DisplaySetting" },
    { TxtBacklightOnTime,"BacklightOnTime" },
    { TxtBacklightOffTime,"BacklightOffTime" },
    { TxtBacklightIntensity,"BacklightIntensity" },
    { TxtSavingSetting,  "SavingSetting" },  
    { TxtGreetingWordOn, "GreetingOn" },  
    { TxtGreetingWordOff, "GreetingOff" },
    { TxtGreetingWordEdit, "Edit"},
//    { TxtBlue,  "Scarlet" },  /*2003/1201 talcon comment it*/
//    { TxtPink,  "Blue Crystal" },
//    { TxtJazz,  "Spring Field" }, 
//    { TxtPopular, "Fall Fruit" },
//    { TxtBlackWhite,"Latin Charm" },   
    { TxtMobileInnovation,  "Mobile Innovation" }, 
    { TxtFlower, "Flower" },
    { TxtSkyrocket,  "Skyrocket" },
    { TxtCloseAnim,  "Close" },
    { TxtSavingMode, "SavingMode" }, 
    { TxtNormalMode, "NormalMode" },
    { TxtMobileSettings,"Phone settings"},
    { TxtVoiceCallDivert, "Voice Call Divert"}, //WUFEI APPPEND
    { TxtAllFaxCallDivert, "All Fax Call"}, //WUFEI APPEND
    { TxtAllDataCallDivert, "All Data Call"}, //WUFEI APPEND
    { TxtVoiceMailBox, "Voice Mail Box"},  //WUFEI APPEND
    { TxtOtherNumber, "Other Number"},  //WUFEI APPEND
    { TxtNumberInCommonUse, "Favorite No."}, //WUFEI APPEND
    { TxtCallSettings, "Call Settings"},//WUFEI APPEND
    { TxtMinuteHint, "Minute Minder"},//WUFEI APPEND
    { TxtNextCall, "Next Call"},//WUFEI APPEND
    { TxtCUGNumber, "Grouped Number"},//WUFEI APPEND
    { TxtPreDefine, "Predefine"},//WUFEI APPEND
    { TxtEnterIndex, "Input Index:"},//WUFEI APPEND
    { TxtAddCUG, "Add New CUG"},//WUFEI APPEND
    { TxtModify, "Modify"},//WUFEI APPEND
    {TxtDCTbVar0, DCTbVar[0]},//wufei add
    {TxtDCTbVar1, DCTbVar[1]},//wufei add
    {TxtDCTbVar2, DCTbVar[2]},//wufei add
    {TxtDCTbVar3, DCTbVar[3]},//wufei add
    {TxtDCTbVar4, DCTbVar[4]},//wufei add
    {TxtDCTbVar5, DCTbVar[5]},//wufei add
    {TxtDCTbVar6, DCTbVar[6]},//wufei add
    {TxtDCTbVar7, DCTbVar[7]},//wufei add
    {TxtDCTbVar8, DCTbVar[8]},//wufei add
    {TxtDCTbVar9, DCTbVar[9]},//WUFEI APPEND
    {TxtEnterNRyTime, "Enter Time(5-30sec)"},//WUFEI APPEND
    {TxtCancelAffirm, "cancel"},//WUFEI APPEND
    {TxtWithout,"NO"},//WUFEI APPEND
    {TxtScene, "Profiles"}, //xsf 07/08/02 begin
    {TxtNormals, "Normal"},
    {TxtOut, "Outdoors"},
    {TxtMeeting, "Meeting"},
    {TxtIncar, "Indoors"},	//sunsj030918
    {TxtStart, "Start"},
    {TxtPssetting, "Change"},
    {TxtAnswer,"Answer Set"},   //xsf 24/04/02

    {Txtmelody1, "song1"},
    {Txtmelody2, "song2"},
    {Txtmelody3, "ring1"},	
    {Txtmelody4, "ring2"},
    {Txtmelody5, "ring3"},
    {Txtmelody6, "music1"},
    {Txtmelody7, "music2"},
    {Txtmelody8, "music3"},
    {Txtmelody9, "music4"},
    {Txtmelody10, "music5"},
    {Txtmelody11, "music6"},
    {Txtmelody12, "music7"},
    {Txtmelody13, "music8"},
    {Txtmelody14, "music9"},
    {Txtmelody15, "music10"},
    {Txtmelody16, "music11"},
    {Txtmelody17, "music12"},
    {Txtmelody18, "music13"},
    {Txtmelody19, "music14"},
    {Txtmelody20, "music15"},


    {TxtmelodyNone, "none"},
    {TxtSmsRing1, "music1"},  //xsf add 03.03.13
    {TxtSmsRing2, "music2"},
    {TxtSmsRing3, "music3"},
    {TxtSmsRing4, "music4"},
    {TxtSmsRing5, "music5"},
    {TxtHostKey,"Host Key"},
    {TxtHostSwitchOn,"Switch On"},
    {TxtHostSimLock, "Sim Lock"},
    {TxtHostDelPbkall, "Del NVM Pbk"},
    {TxtHostReset, "FactoryReset"},
    {TxtHostMsgbox, "NVM Message"},
    {TxtHostKeySet, "Hostkey set"},
    {TxtHostKeyChange, "Change"},
    {TxtHostKeyItems, "Protect Item"},     //xsf 14/05/02  9items
    {TxtEnterHostKey, "Host Key"},		/* 2004/04/12 sunsj modify */
    {TxtSimReplaced, "SIM Replaced"},  //xsf add "SIMѸı"2003.04.10
    {TxtHostKeyOk, "Host Key OK!"},   
    {TxtHostKeyFail, "Host Key Incorrect!"},  
    {TxtOldHostKey, "Old Host Key"},   
    {TxtNewHostKey, "New Host Key"},   
    {TxtHostKeyConfirm, "Confirm Host Key"},  
    {TxtHostKeyChangeOk, "Host Key Changed!"}, 
    {TxtHostKeyChangeFail, "Fail!"}, 
    {TxtHostKeyNotOn, "Activate Hostkey!"},  //xsf add 2002.08.29
    {TxtHostKeyOpen, "Hostkey Activated!"}, 
    {TxtHostKeyClose, "Hostkey Deactivated!"}, 
    {TxtHostkeySelect, "OK To Select"},//xsf add for noticing user to select pro_options with kcd_ok 2003.04.16
    {TxtAnswerTone, "Answer Tone"},
    {TxtUndoEvent, "UndoEventTon"},
    {TxtUnreadSMSTone, "UnreadSMSTon"},
    {TxtMissedCallTone, "MissCallTone"},
    {TxtAlerttype, "Alert type"},
    {TxtRingmode, "Ring"},
    {TxtRingPrompt, "Ring Prompt" },	///ʾxsf add for ring prompt of alarm 09.24
    {TxtVibramode, "Vibra"},
    {TxtVibraRing, "R After V"},
    {TxtRingandVib,"Ring&Vibra"}, 
    {TxtSmsRing, "Normal Ring" },	///ͨ       
    {TxtSpecialRing, "Special Ring" },	///      
    {TxtSmsVibra, "Vibration" },	///ʾ
    {TxtSmsRVibra, "RingAfterVib" },	///
    {TxtSmsMute, "Mute" },	///
    {T_China_Telecomm, "CHINA MOBILE"},
    {T_China_Unicomm, "CHINA UNICOM"},
    {TxtDualBand, "DualBand"},
    {TxtGSM900, "GSM900"},
    {TxtDCS1800, "DCS1800"},
    {TxtPLMNInfo, "Home PLMN"},
    {TxtPLMNReselect, "PLMN Select"},
    {TxtRegMode, "RegisterMode"},
    {TxtLockBand, "Lock Band"},  //end of xsf add 07/08/02
    {TxtSearchingNetwork, "Searching Network"},  //searching for network
    {TxtRegNetwork, "Registering"},  //Registering network
    {TxtPLMNavailable, "Available PLMN"},  //xsf add for listmenu title of PLMN reselect ѡ10.10
    {TxtTimeOut, "Time Out!"}, 
    {TxtPhonebook,    "Names"    }, //绰    
    {TxtPhoneSearch,  "Search"        }, //ѯ
    {TxtPhoneAdd,     "Add"          }, //Ӻ
    {TxtGroupingSetting,"Group Setting"}, //    /* 2004/04/02 sunsj modify */	/* 2004/04/02 sunsj modify */
    {TxtMultiCopy,     "Copy"    }, //
    {TxtClearAll,      "Delete All"     }, //ɾȫ
    {TxtShortCutDial,  "ShortCut Dial"  }, //ݲ
    {TxtMyNumber,    "Own Number"   }, //
    {TxtVoiceList,      "Voice List"    }, //б    
    {TxtSearchItem,   "Search Menu"  }, //ѯѡ
    {TxtChangeRecord, "Change"      }, //޸ļ¼
    {TxtCopyRecord,   "Copy"        }, //Ƽ¼
    {TxtDeleteRecord,  "Delete"       }, //ɾ¼
    {TxtVoiceCall,      "Voice Call"   }, //
    {TxtSIMBook,      "SIM Book"    }, //SIM绰
    {TxtNVMBook,      "NVM Book"   }, //绰
    {TxtPhoneNew,     "New Record"  }, //
    {TxtEnterName,    "Name:"       }, //    
    {TxtEnterNumber,  "Number:"      }, //ƶ
    {TxtEnterHome,    "Home:"       }, //լ
    {TxtEnterOffice,    "Office:"       }, //칫    
    {TxtEnterMemo,    "Memo:"       }, //עϢ
    {TxtGroupingOne,  "<Group 1>" },//һ /*2003/12/1, wangyan modify*/
    {TxtGroupingTwo,  "<Group 2>" },//
    {TxtGroupingThree, "<Group 3>"},//
    {TxtGroupingFour,  "<Group 4>" },// 
    {TxtGroupingFive,  "<Group 5>" },//
    {TxtGroupingSix,   "<Group 6>" },//
    {TxtGroupingSeven,"<Group 7>"},//
    {TxtGroupingEight, "<Group 8>"},//
    {TxtGroupingNine,  "<Group 9>"},//
    {TxtGroupingTen,  "<Black list>" },//
    {TxtGroupingItem, "Grouping Menu"},//ѡ
    {TxtBrowserMember,"Browser Member"},//Ա
    {TxtAddMember,   "Add Member"},//ӳԱ
    {TxtGroupingIcon,  "GroupingIcon"},//ͼ        
    {TxtGroupingRing,  "GroupingRing"},//
    {TxtGroupingRename,"Rename"   },//
    {TxtCopyAll,       "Copy All"},//ȫ
    {TxtCopySIMtoNVM,"Copy SIM to NVM"},//sim
    {TxtCopyNVMtoSIM,"Copy NVM to SIM"},//ƻsim
    {TxtChoiceCopy,   "Choice Copy"},//ѡ
    {TxtNullNumber,   "<Null>"},//ռ¼
    {TxtPhoneSelect,   "Select Number"},//ѡ
	{TxtEditSucceed,"Changed!"},/*talcon 2004.05.22,talcon modify*///޸ĳɹ//{TxtEditSucceed,"Change Succeed"},//޸ĳɹ
    {TxtEditFail    ,"Change Fail"    },//޸ʧ
    {TxtAddSucceed,"Add Succeed"},//ӳɹ
    {TxtAddFail,    "Add Fail"    },//ʧ
    {TxtCopySucceed,"Copy  Succeed"},//Ƴɹ
    {TxtCopyFail    ,"Copy  Fail"    },//ʧ
    {TxtDelSucceed, "Delete Succeed"},//ɾɹ
    {TxtDelFail,     "Delete Fail"    },//ɾʧ    
    {TxtPhbkFull,     "Phonebook full" },//绰                        
    {TxtBrowse,      "Browse"},
    {TxtVoiceMemoAdd,"Voice Add"},
    {TxtVoiceMemory, "Voice Memory"},                 		
    {TxtRecVoice,     "REC Voice"},//¼  
    {TxtPhbkFind, "Found"},//ҵ
    {TxtPhbkCopy," Copied"},//
    {TxtPhbkDelMess, "Confirm delete!"},//Ƿɾ
    {TxtPhbkCopyMess, "confirm copy!"},//Ƿ
    {TxtDelMember,  "Delete Member Succeed!"},//ɾԱɹ!
    {TxtMemberAdd,  "Add Member Succedd!"},//ӳԱɹ!
    {TxtDelMemberError, "Delete Member Fail!"},//ɾԱɹ!
    {TxtMemberAddError, "Add Member Fail!"},//ӳԱʧ!
    {TxtPhbkNvmFull,    "NVM full!"},//绰!
    {TxtPhbkSimFull,     "SIM full!"},//SIM绰! 
    {TxtPhbkNvmEmpty,  "NVM Empty!"},//绰޼¼!
    {TxtPhbkSimEmpty,  "SIM Empty!"},//SIM绰޼¼!
    {TxtPhbkSIMCopyAll,"Copy SIM All Record?"},//SIMм¼?   
    {TxtPhbkNVMCopyAll,"Copy NVM All Record?"},//ƻ绰м¼?  
    {TxtPhbkSIMCopyError,"SIM not enough free,Copy?"},//SIM ռ䲻,? 
    {TxtPhbkNVMCopyError,"NVM not enough free,Copy?"},//绰  ռ䲻,? 
    {TxtPhbkCopying,"Copying..."},//ڸ...
    {TxtPhbkDeleteSIMAll, "SIM Delete All?"},//ɾSIMм¼?
    {TxtPhbkDeleteNVMAll,"NVM Delete All?"},//ɾ绰м¼?
    {TxtPhbkChange,     "Change"},//޸ 
    {TxtPhbkNumber,     "Number"},//
    {TxtPhbkUse,     "Used"},//ʹ
    {TxtPhbkleft,     "Left"},//ʣ 
    {TxtMemoryState,	"Memory State"},//ڴ״̬
    {TxtGroupingIconSucceed,	"Set Grouping Icon Succeed!"},//ͼóɹ!
    {TxtGroupingIconError,	"Set Grouping Icon Fail!"},//ͼʧ!
    {TxtGroupingClassmate,	"Classmate"},//ͬѧ
    {TxtGroupingFriend,	"Friend"},//
    {TxtGroupingFamily,	"family"},//
    {TxtGroupingWorkmate,	"Workmate"},//ͬ
    {TxtRenameForbidden,		"Rename forbidden"},//ֹ
    {TxtChangeIconForbidden,	"ChangeIcon forbidden"},	//ֹͼ	/* 2004/04/16 sunsj add */
    {TxtOnlyforBlacklist,		"Only for Black List"},//ר
    {TxtTestCommand,	"TestCommand"},//
    {TxtSoftwareVersion,		"Software Version"},//汾
    {TxtSpkMic,			"Spk&Mic"},//Spk&Mic Status
    {TxtMemFlashRtc,			"Mem&Flash&Rtc"},//Mem&Flash&Rtc Status
    {TxtProductTest,	"ProductTest"},//
    {TxtLCDDisplay,	"LCDDisplay"},//LCD
    {TxtLEDBacklight,	"LEDBacklight"},//LED,
    {TxtMelodyandVibrator,	"MelodyandVibrator"},//Ӳ
    {TxtKeyPressTest,	"KeyPressTest"},//
    { TxtToolkit, "Toolkit"},
#if(MAIN_LCD_SIZE==3)
	{TxtCamera,"Camera"},//Knuth
#endif
	{TxtStopwatch,"Stopwatch"},
    {TxtSeparately,"Separately"},
    {TxtBycircle,"Bycircle"}, 
    {TxtBrowseRecord,"BrowseRecord"},
    {TxtContinue,"Continue"},
    {TxtRestart,"Restart"},
    {TxtNorecord,"No record!"},
    {TxtConfirm,"Confirm"},
    {TxtBack,"Back"},
    {TxtOnebyone,"One by one"},
    {TxtDeleteError,"Delete error!"},
    {TxtSaveError,"Save error!"},
    {TxtTimer,"Countdown"},
    {TxtSetontime,"Please input power on time"},
    {TxtOpen,"On"},
    {TxtClose,"Off"},
    {TxtSettime,"setting time"},
    {TxtLefttime,"The left time "},
    {TxtTimeup,"time is up"},
    {TxtAutopower,"Autopower"},
    {TxtOpentime,"Power on time"},
    {TxtClosetime,"Power off time"}, 
    {TxtNote,"Note"},
    {TxtNotebrowse,"browse"},
    {TxtAdd,"Add"},
    {TxtChpriority,"change priority"},
    {TxtToschedule,"save to schedule"},
    {TxtTomessage,"send as message"},
    {TxtOnce,"Once"},
    {TxtDay,"Daily"},
    {TxtWeek,"Weekly"},
    {TxtMonth,"Monthly"},
    {TxtYear,"Annually"},
    {TxtRing,"Need alarm"},
    {TxtSchedule,"Schedule"},
    {TxtWeekDay,"Sun Mon Tue Wen Thu Fri Sat"},
    {TxtNewSche,"New schedule"},
    {TxtToday,"Today's"},
    {TxtAllSche,"All"},
    {TxtDeleteOld,"Delete the bypast"},
    {TxtScheMeeting,"Meeting"},
    {TxtBirthday,"Birthday"},
    {TxtAppointment,"Appointment"},
    {TxtRemind,"Remind"},
    {TxtReConfirm,"ReConfirm"},
    {TxtInputError,"Input error!"},
    {TxtResult,"Result"},
    {TxtDeleteOnebyOne,"Delete one by one"},
    {TxtConversion,"Unit conversion"},
    {TxtLength,"Length"},
    {TxtAcre,"Acre"},
    {TxtUnitVolume,"Volume"},
    {TxtWeight,"Weight"},
    {TxtInitValue,"Initial"},
    {TxtResultValue,"Converted"},
    {TxtNext,"Next"},
    {TxtOverflow,"Overflow"},
    {TxtCall,"Please call"},
    {TxtUnitChange,"unit change"},
    {TxtStroke,"stroke"},
    {TxtYMD,"yyyy/mm/dd"},
    {TxtBrowseAlarm,"Browse status"},
    {TxtAutoOff,"Auto power off starting"},
    {TxtAutoConfirm,"Confirm?"},
    {TxtScheSMS,"Send as message"},
    {TxtTooLong,"Message is too long!"},
    {TxtMemo,"Memo"},
    {TxtCover,"Cover first?"},
    {TxtAddMemo,"Add memo"},
    {TxtCalinder,"calendar"},
    {TxtPowerOnTime,"Power on time"},
    {TxtPowerOffTime,"Power off time"},
    {TxtAutoPowerOn,"Power on"},
    {TxtAutoPowerOff,"Power off"},
    {TxtValue,"value"},
    {TxtSelectDate,"No date"},
    {TxtGamestart,"start"},
    {TxtGameedit,"edit"},
    {TxtGameselect,"select"},
    {TxtGamesetting,"setting"},
    {TxtGamehelp,"help"},
    {TxtGameScore,"Score"},
    {TxtGameRestart,"Restart"},
    {TxtGameWinCondition, "Win Condition:"},//2004-04-23 Sunny add
	//2004-04-02 Sunny add	
    {TxtGameStageCruTtl,"Current/Total"},
	{TxtGameStageInput,"Input"},
	//2004-04-02 Sunny add ends
    {TxtGameExit,"Exit"},
    {TxtGameExitConfirm,"Exit?"},//2004-04-20 Sunny add
    {TxtGameNext,"Next"},//2004-04-19 Sunny add
    {TxtGameGoon,"Continue"},
	{TxtSnakegame,"SnakeGame"},//2003/12/19,talcon add
    {TxtBoxmangame, "BoxGame"},
    {TxtBoxmanHelp, "1.Rules:\n move all of the objects to The marked floor positions.\n2.Operation:\n up, left, right, and down. Press \"right softkey\" to Undo."},//2004-04-23 Sunny add
    {TxtSnakeHelp, "1.Rules:\n Don't run the snake into the wall, or his own tail. Eat the colored fruit to gain points.\n2.Operation:\n up, left, right, and down. Key \"CALL\" may also be used for \"Play\" and \"Pause\"."},//2004-04-23 Sunny add
	{TxtCalendarYear,"Year"},
	{TxtCalendarMonth,"Month"},
    {TxtBalloongame, "Balloon"},//tangyan 816 add it
    {TxtRussiagame, "Terris"},
    {TxtSoftClearall, "clear"},
    {TxtFlashErr,"Flash Error"},	//hxl add 20021029
    {TxtGame, "Game"},
    {TxtSuoha, "Suoha"},
    {TxtSuohaNew, "New Game"}, //zhangzg 08/14/2002
    {TxtSuohaPre, "Old Game"},    //zhangzg 08/14/2002  //tangyan add these 821
    { TxtConnected, "Connected"}, // SH
    { TxtGSM_900,"GSM 900"},	// SH
    { TxtDCS_1800,"DCS 1800"},
    { TxtPCS_1900,"PCS 1900"},
    { TxtE_GSM, "E GSM"},
    { TxtGSM_850, "GSM 850"},
    { TxtCallTimeout, "Call timeout" },    
    { TxtBand, "Band"},       
    { TxtSatRefresh, "SAT refresh" }, 
    { TxtCallBlocked, "Call blocked" },
    { TxtSRR, "Status Report" }, // Marcus: Issue 1170: 30/09/2002
    { TxtDelivered, "Delivered" }, // Marcus: Issue 1170: 07/10/2002
    { TxtTempError, "Temp. Error" }, // Marcus: Issue 1170: 07/10/2002	//-----------end of copy ganchh------------------
    {TxtSetDate, "Set Date"},  
    {TxtSetTime, "Set Time"},
    {TxtFullHrAlert, "Stroke"},
    {TxtWorldTime, "World clock"},
    {TxtKwajalein, "Kwajalein"},
    {TxtMidwayIs, "Midway Is."},
    {TxtSamoa, "Samoa"},
    {TxtHawaii, "Hawaii"},
    {TxtHonolulu, "Honolulu"},
    {TxtAlaska, "Alaska"},
    {TxtLosAngeles, "Los Angeles"},
    {TxtSanFrancisco, "SanFrancisco"},
    {TxtDenver, "Denver"},
    {TxtChicago, "Chicago"},
    {TxtMexicoCity, "Mexico City"},
    {TxtNewYork, "New York"},
    {TxtLima, "Lima"},
    {TxtMontreal, "Montreal"},
    {TxtSantiago, "Santiago"},
    {TxtLaPaz, "La Paz"},
    {TxtBrasilia, "Brasilia"},
    {TxtRioDeJaneiro, "RioDeJaneiro"},
    {TxtMidAtlantic, "Mid Atlantic"},
    {TxtCapeVerdeIs, "CapeVerdeIs."},
    {TxtLondon, "London"},
    {TxtCasablanca, "Casablanca"},
    {TxtLisbon, "Lisbon"},
    {TxtRome, "Rome"},
    {TxtBerlin, "Berlin"},
    {TxtParis, "Paris"},
    {TxtMadrid, "Madrid"},
    {TxtAthens, "Athens"},
    {TxtEasternEurope, "EasternEur"},
    {TxtHelsinki, "Helsinki"},
    {TxtBaghdad, "Baghdad"},
    {TxtKoweit, "Koweit"},
    {TxtMoscow, "Moscow"},
    {TxtTbilisi, "Tbilisi"},
    {TxtIslamabad, "Islamabad"},
    {TxtAlmaty, "Almaty"},
    {TxtDhaKa, "Dhaka"},
    {TxtBangkok, "Bangkok"},
    {TxtJaKarta, "Jakarta"},
    {TxtBeiJing, "Beijing"},
    {TxtHongkong, "Hongkong"},
    {TxtSingapore, "Singapore"},
    {TxtSeoul, "Seoul"},
    {TxtTokyo, "Tokyo"},
    {TxtGuam, "Guam"},
    {TxtSydney, "Sydney"},
    {TxtVladivostok, "Vladivostok"},
    {TxtSolomonIs, "Solomon Is."},
    {TxtFiji, "Fiji"},
    {TxtMarshallIs, "Marshal Is."},
    {TxtWellington, "Wellington"},
    {TxtDailyAlarm, "Daily Alarm"},
    {TxtWeeklyAlarm, "Weekly Alarm"},
    {TxtSoftChange, "Change"},
    {TxtSunday,"Sunday"},
    {TxtMonday,"Monday"},
    {TxtTuesday,"Tuesday"},
    {TxtWednesday,"Wednesday"},
    {TxtThursday,"Thursday"},
    {TxtFriday,"Friday"},
    {TxtSaturday,"Saturday"},
    {TxtSendTo,      "To"},
    {TxtRecieveFrom,  "From"},
    {TxtReadSms,"Read"},//windy
    {TxtReadMt,"Inbox"},
    {TxtReadMo,"Outbox"},
    {TxtSendSms,"Write Message" },	
    {TxtUNSend,"Unsent"},
    { TxtSMSSettings, "Settings" },
    {T_CBLanguageAll  ,   "All" },
    {T_CBLanguageNone ,   "None" },
    {T_CBGerman  ,        "German" },
    {T_CBEnglish   ,      "English" },
    {T_CBItalian   ,      "Italian" },
    {T_CBFrench   ,       "French" },
    {T_CBSpanish  ,       "Spanish" },
    {T_CBDutch  ,        "Dutch" },
    {T_CBSwedish ,        "Swedish"},
    {T_CBDanish  ,        "Danish" },
    {T_CBPortuguese,      "Portuguese"},
    {T_CBFinnish ,        "Finnish"},
    {T_CBNorwegian   ,    "Norwegian" },
    {T_CBGreek   ,        "Greek" },
    {T_CBTurkish   ,      "Turkish" },
    {T_CBHungarian   ,    "Hungarian" },
    {T_CBPolish ,         "Polish" },       
    {T_CBLanguage      ,"CB Language" },	///ѡ
    {TxtOnOff,    "CB Switch" },
    {TxtCBCHSET,    "Channel Set"},
    {TxtCommonMsg,    "Preset Msg"},
    {TxtSaveToFfs,    "Save"},
    {TxtSendOnly,    "Send Only"},
    {TxtSendSave,    "Send&Save"},
    {TxtInsertCMmsg,    "Use Preset msg"}, 
    {TxtNVMMsg,    	  "NVM message"}, 
    {TxtSaveToNVM,    "Save to NVM"}, 
    {TxtSMSNVMFull,    "NVM Full"}, 	
    {TxtDeletingSms,    "Deleting..."}, 
    {TxtSavingSms,    "Saving..."}, 
    {TxtSmsFull,    "SMS Full!"}, 
    {TxtSIMSms,    "SIM message"}, 
    {TxtCBChanel, "Channel"},
    {TxtDelThisMsg1,"Delete This"},
    {TxtDelThisMsg2,"SIM Msg?"},
    {TxtTryAgain,"Pls try again"},
    {TxtUselessSMS,"Useless Msg"},
    {TxtAdviceDel,"Advice Delete"},
    {TxtReadingSms,"Reading"},
    {	TxtInvalidMessage, "Invalid Message"},/*SPR 1830*/
    {TxtChanelFull,    "Channel Full!"}, 
    {TxtNVMInbox,    	  "NVM Inbox"}, 
    {TxtNVMOutbox,    	  "NVM Outbox"}, 
    {TxtRussia,"Russia"},
    {TxtActive,"Active"},
    {TxtCallSetup,"Call"},//WUFEI 1010
    {TxtShortCutMenu, "Shortcut menu"},
    {TxtFunctionSelect, "Function select"},
    {TxtDeleteAllFunctions,"Delete all functions"},
    {TxtHallOnConnect,"Fold Answer" },
    {TxtLedSetting,"LedControl"},//zy 2003-02-11
    {TxtRejectCalls,"Rejected" },  //hu binhao 2002-11-22
    {TxtIncomingCallTime,"call time: " },  //hu binhao 2002-11-22
    {TxtDialTime,"call time: " },  //hu binhao 2002-11-22
    {TxtName,"Name: " },  //hu binhao 2002-11-22
    {TxtNumberShow,"Num: " },  //hu binhao 2002-11-22
    {TXTNoRecentNumber,"NO Recent Calls: " },  //hu binhao 2002-12-3
    {TxtEnterDivertNumber,"Number:" },  //hu binhao 2002-12-17
    {TxtOutgoingDataNew, "OutgoingData"}, //hu binhao 2002-12-25 for 3125 bug 
    {TxTMakeSureTimeReset, "Time Reset"}, //hu binhao 2002 12-26 for 3126 bug 
    {TxtHaveReset,"Have Reset"},     //hu binhao 2003-1-17
    {Txtonlinefunction,"Online function"},   //zhaowm 2002.12.15
    {Txtnotitle,"No title"},                 //zhaowm 2002.12.18
    {TxtnoGPRSservice,"No GPRS service"}, 
    { Txt5sec,       "5 Sec" },
    { Txt10sec,      "10 Sec" }, 
    { Txt15sec,      "15 Sec" },
    { Txt20sec,      "20 Sec" },
    { Txt25sec,      "25 Sec" },
    { Txt30sec,      "30 Sec" },
    { TxtSetCFTime,     "CF Time" },
    {Txtfunction,"function"}, 
    {Txtdisconnectionbrow,"Exit browser"}, 
    {TxtSOFTBACK,"Back"}, 
    {TxtLIST,"List"}, 
    { TxtShowDetails,     "Show Details" },
    {TxtAddVoiceDial,"Add VoiceDial"},//yq added for add voicedial 2003/3/12
    {TxtModifyVoiceDial,"Modify VoiceDial"},
    {TxtVoiceDialFull,"voice Record Full"},
    {TxtNoVoiceDial,"Voice Record Empty"},
    {TxtStartEnroll,"Start Enroll"},
    {TxtEnrolling,"Voice Enrolling"},
    {TxtEnrollSucess,"EnrollSucess"},
    {TxtStartUpdate,"Start Update"},
    {TxtVoiceUpdating,"Voice Updating"},
    {TxtUpdateSucess,"Update Sucess"},
    {TxtRecordSucess,"Record Sucess"},
    {TxtEnrollError,"Enroll Error"},
    {TxtUpdateError,"Update Error"},
    {TxtStartDial,"Start Recognize"},
    {TxtDialing,"Recognizing"},
    {TxtDialOk,"Recognize Sucess"},
    {TxtDialRedial,"Recognize once more"},
    {TxtDialError,"Recognize error"},
    {TxtPlayingNow,"Playing Voice"},
    {TxtEnrollOnceMore,"Enroll once more"},
    {TxtCallReady,"Ready for call"},//end yq added for voicedial
    {TxtRange,"Range"},
    {TxtConnection,"Connection"},   //ganchunhui 2003/4/6
    {TxtRoaming,"Roaming"},  //ganchunhui 2003/4/6
    {TxtOpenDivert, "On"},
    {TxtCloseDivert, "Off"},
    { TxtLimitedService,"Limited Service" },//glowing add it for processing NETWORK_LIMITED_SERVICE
    { TxtCallDuration ,"Call Duration" },//glowing add it for processing NETWORK_LIMITED_SERVICE
    {TxtAocStatistics,"Charge Stat"},/* 2003/12/1, wangyan, modify AOC statistics menu*/
    {TxtInvalidService,"Invalid Service"},/* 2003/12/1, wangyan, add invalid service*/
	
//2004.1.13 WYJ add On&Off ring
	{TxtOnRing, "Power On Ring "},
	{TxtOffRing, "Power Off Ring"},
	{TxtOnOffRing, 	"On&Off Ring "},
	{TxtOnVolume, "Power On Volume"},
	{TxtOffVolume, "Power Off Volume"},
//end of 2004.1.13 WYJ add On&Off ring
	
//2004.2.12 WYJ add On&Off hall ring
	{TxtHallOnRing, 	"Hall On Ring "},
	{TxtHallOffRing, 	"Hall Off Ring"},
	{TxtHallOnOffRing,	"Hall On&Off Ring"},
	{TxtHallOnVolume, 	"Hall On Volume"},
	{TxtHallOffVolume, 	"Hall Off Volume"},
//end of 2004.2.12 WYJ add On&Off hall ring

//2004.3.18 WYJ add group ring menu
	{TxtGroupSelect,	"Ring Select"},
	{TxtGroupMute, 		"No Ring"},
//end of 2004.3.18 WYJ add group ring menu


	/* 2004/04/10 sunsj add start */
	{TxtSwitchLED, "Color LED" },
	/* 2004/04/10 sunsj add end */
	//end of hxl 06/28/02-----------------------------------------
	{TxtCheckHideID,"Pls Check HideID" }, 	/* 2004/05/20 wy add */
	/* 2004/06/19 yhf add */
	{TxtBmHelp1, (char*)chineseTxtBmHelp1},
	{TxtBmHelp2, (char*)chineseTxtBmHelp2},
	{TxtPublicHelp1, (char*)chineseTxtPublicHelp1},
	{TxtPublicHelp2, (char*)chineseTxtPublicHelp2},
	{TxtPublicHelp3, (char*)chineseTxtPublicHelp3},
	{TxtPublicHelp4, (char*)chineseTxtPublicHelp4},
	{TxtTerrisHelp1, (char*)chineseTxtTerrisHelp1},
	{TxtGameExplain,(char*)chineseTxtGameExplain},	
	/* end yhf add */
	{TxtExitGame," Exit?"},
#ifdef MMI_EM_ENABLED
	{ TxtEngineeringMode, "Engine Mode"},
	{ TxtMobileInfo,  "Mobile Info"},  
  	{ TxtServingCell,  "Serving Cell"},
 	{ TxtNeighbourCell, "Neighbour Cell"},
 	{ TxtLocation, "Location"},
	{ TxtCiphHopDTX, "Ciph Hop DTX"},
#endif	

#ifdef _MMS_ENABLE_ 	/* robert.chen add, 2004-08-10 */
	{TxtMMS,"Multimedia message"},
	{TxtMMSNew,"New MMS"},
	{TxtMMSSendFolder,"MMS sendFolder"},
	{TxtMMSRecvFolder,"MMS recvFolder"},
	{TxtMMSDraftFolder,"MMS draftFolder"},
	{TxtMMSSentFolder,"MMS sentFolder"},
	{TxtMMSDeleteAll,"Delete all MMS"},
	{TxtMMSSettings,"MMS settings"},

	{TxtNewMMSTo, "To:"},
	{TxtNewMMSCC,"Cc:"},
	{TxtNewMMSBCC, "Bcc:"},
	{TxtNewMMSTitle,"Title:"},
	{TxtNewMMSText,"Text:"},
	{TxtNewMMSPicture,"Picture:"},
	{TxtNewMMSMusic, "Music:"},

	{TxtMMSNoImage,"No image"},
	{TxtMMSNoMusic,"No music"},

	{TxtMMSSendToNumber,"Send to number"},
	{TxtMMSSendToEmail,"Send to Email"},
	{TxtMMSPreview,"Preview"},
	{TxtMMSExitNewMsg,"Exit editor"},


	{TxtAddText,"Add text"},
	{TxtAddImage,"Add image"},
	{TxtAddMusic,"Add music"},
	{TxtDeleteText,"Delete text"},
	{TxtTextColor,"Text color"},
	{TxtSlideTime,"Slide time"},
	{TxtAddSlide,"Add slide"},
	{TxtDeleteSlide,"Delete slide"},
	{TxtSlideColor,"Slide color"},
	{TxtPreviousSlide,"Previous slide"},
	{TxtNextSlide,"Next slide"},
	{TxtInsertSlide,"Insert slide"},
	{TxtMMSStoreMsg,"Store message"},

	{TxtMMSSendReportOn,"On"},
	{TxtMMSSendReportOff,"Off"},
	{TxtMMSAutoSaveOn,"On"},
	{TxtMMSAutoSaveOff,"Off"},
	{TxtMMSAutoRecvOn,"On"},
	{TxtMMSAutoRecvOff,"Off"},
	{TxtMMSSendReport,"Send report"},
	{TxtMMSAutoSave,"Auto save"},
	{TxtMMSAutoRecv,"Auto receive"},
	{TxtMMSSendSettings,"Send settings"},
	{TxtMMSRecvSettings,"Receive settings"},
	{TxtMMSNetSettings,"MMS net settings"},

	{TxtMMSDelAll,"All folders"},
	{TxtMMSDelSendFolder,"Send folder"},
	{TxtMMSDelRecvFolder, "Receive folder"},  
	{TxtMMSDelDraftFolder,"Draft folder"},
	{TxtMMSDelSentFolder,"Sent folder"},
	{TxtMMSSendFolderEmpty,"Send folder is empty"},
	{TxtMMSRecvFolderEmpty, "Recv folder is empty"},  
	{TxtMMSDraftFolderEmpty,"Draft folder is empty"},
	{TxtMMSSentFolderEmpty,"Sent folder is empty"},
	{TxtMMSDelAllMsg,"Delete all message"},

	{TxtMMSPicture, "Picture"},
	{TxtMMSMusic,  "Music"},
	{TxtMMSRetrieve,"Retrieve"},
	{TxtMMSDelete, "Delete" } , 
	{TxtMMSReplay,  "Replay"},
	{TxtMMSReply, "Reply" },       
	{TxtMMSFarward,  "Farward"}, 
	{TxtMMSCallback,  "Callback"},
	{TxtMMSCutMedia,"Cut media"},
	{TxtMMSCutAddress,  "Cut address"} ,      
	{TxtMMSDetails,   "Details"},
	{TxtMMSMoveToSentFolder ,"Move to sent folder" } ,


	{TxtMMSIPAddress,"IP address"},
	{TxtMMSIPPort, "IP port"},
	{TxtMMSISDN,"ISDN"},
	{TxtMMSAnologue,"Anologue"},
	{TxtMMSGateway,"Gateway"  },
	{TxtMMSDataCallType,"Data call type"},
	{TxtMMSDiaNumber,"Dial number" },
	{TxtMMSAPN, "APN" },   
	{TxtMMSLoginID,"Login ID"},
	{TxtMMSPassword,"Password"},
	{TxtMMSOnlyGPRS, "Only GPRS"  },
	{TxtMMSOnlyGSM,"Only GSM"    },
	{TxtMMSMMSCURL,"MMSC URL"          },
	{TxtMMSGSMSettings,"GSM settings"      },
	{TxtMMSGPRSSettings,"GPRS settings"          },
	{TxtMMSTransportMode,"Transport mode"},
	{TxtMMSCurSettings,"Current settings"},
	{TxtMMSAllSettings,"Settings"},
	{TxtMMSEditGroupName,"Edit name"},

	{TxtMMSDetailFrom, "From"},
	{TxtMMSDetailDate,"Data"},
	{TxtMMSDetailTo,"To"},
	{TxtMMSDetailSize,"Size"},
	{TxtMMSEmpty,"Empty"},

	{TxtMMSTelNumber, "Telephone"},
	{TxtMMSEmail,"Email"},

	{TxtMMSSenderIsEmpty,"Sender is empty"},
	{TxtMMSSendFailed,"Send failed"},
	{TxtMMSSendSuccess,"Send success"},
	{TxtMMSSendCancelled,"Send cancelled"},

	{TxtMMSRecvSuccess,"Receive successfully"},
	{TxtMMSRecvCancelled, "Receive Cancelled"},
	{TxtMMSDataError,"Data error when receiving"},
	{TxtMMSRecvFailed, "Fail to receive"},

	{TxtMMSRetrieving,"Retrieving"},
	{TxtMMSSending,"Sending"},
	{TxtMMSPleaseWaitting, "Please waitting..."},

	{TxtMMSFileTooBig,"File too big"},
	{TxtMMSSystemError,"System error"},
	{TxtMMSSave, "Save"},
	{TxtMMSAlreadyExist,"File already exist,please change file name"},
	{TxtMMSNoEnoughFlashSpace,"Flash space is not enough"},
	{TxtMMSNoImageInCurSlide, "No image in current slide"},
	{TxtMMSNoMusicInCurSlide,"No music in current slide"},
	{TxtMMSReceiverCanNotBeEmpty,"Receiver can not be empty"},
	{TxtMMSInvalidInput,"Invalid Input"},
	{TxtMMSPleaseInputAgain,"Please input again"},
	{TxtMMSEdit,  "Edit"},
	{TxtMMSNewMMSSum,"new multimedia message"},

	{TxtMMSDeleteMusic,"Delete music"},
	{TxtMMSDeleteImage,"Delete image"},
	{TxtMMSDeleteContent,"Delete text"},
	{TxtMMSSend,"Send"},
	{TxtMMSAddpage,"Add a page"},
	{TxtMMSDeletepage,"Delete a page"},
	{TxtMMSPageUp,"Page up"},
	{TxtMMSExit,"Exit editor"},
	{TxtMMSPageDown,"Page down"},

	{TxtMMSErrorPre,"This is the first page"},
	{TxtMMSErrorLast,"This is the last page"},
	{TxtMMSErrorLarge,"This is the largest"},
	{TxtMMSErrorZero,"This is NULL"},
	{TxtMMSTitleisnotNull,"Title can  not be empty"},
	{TxtMMSSent,"News is sent"},
#endif

    { 0, 0 }
};



//start of xsf changed 2002.12.16  

const int MelodyTable[]={
        Txtmelody1,
        Txtmelody2,
        Txtmelody3,
        Txtmelody4,
        Txtmelody5,
        Txtmelody6,
        Txtmelody7,
        Txtmelody8,
        Txtmelody9,
        Txtmelody10,
        Txtmelody11,
        Txtmelody12,
        Txtmelody13,
        Txtmelody14,
        Txtmelody15,
        Txtmelody16,
        Txtmelody17,
        Txtmelody18,
        Txtmelody19,        
        Txtmelody20,
        TxtmelodyNone,
        0
};


//end of xsf changed 2002.12.16

/* Master Index Table, autogenerated to create the relationships
   between the two tables given above.
*/
long int MasterIndexTable[][3] = {
    {   1, LEN_LANGUAGE1, (long int) LanguageIndex_1 },
#ifndef CHINESE_MMI
    {   2, LEN_LANGUAGE2, (long int) LanguageIndex_2 },
#else
    {   2, LEN_LANGUAGE2,(long int) LanguageIndex_2 },
#endif
 	{   3,  14, (long int) MelodyTable },
    { 0, 0, 0 }
};


/*******************************************************************************
                                                                              
                                Public routines
                                                                              
*******************************************************************************/


/*******************************************************************************

 $Function:    	Mmir_BaseAddress

 $Description:	returns the base address of the Master Index Table

 $Returns:		As above

 $Arguments:	none.
 
*******************************************************************************/

void *Mmir_BaseAddress()
{
    return (char *) MasterIndexTable;
}






/*******************************************************************************
 $Function:    	Mmir_NumberOfEntries

 $Description:	returns the number of entries in the master index table.

 $Returns:		As above

 $Arguments:	none.
 
*******************************************************************************/

int Mmir_NumberOfEntries()
{
    return 2;
}


/*******************************************************************************
                                                                              
                                End of File
                                                                              
*******************************************************************************/























