/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		PhoneBook
 $File:		    MmiSearchWindow.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    This module provides the phone book search window functionality for the
    phone book module of the basic MMI
                        
********************************************************************************
 $History: MmiBooksearchwindow.c

    25/10/00			Original Condat(UK) BMI version.	
    28/10/2003			sunsj **************************************************
                        modify for phone book record display
    ****************************************************************************
    01/11/2003			sunsj **************************************************
                        modify the method of input and display about phone book
                        record
    ****************************************************************************
    2003/11/10          sunsj **************************************************
                        Modify the display method of phone book record
    ****************************************************************************
    2003/11/19          sunsj add name icon
 $End

*******************************************************************************/


/*******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/
#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif

#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"
#include "mmiusersymbolinput.h"

#include "MmiBookShared.h"
#include "mmiSmsMenu.h"
#include "MmiSmsSend.h"
#include "MmiBookPhonebook.h"
#include "mmibooksearchwindow.h"
#include "mmiusersymbolinput.h"
#include "mmieditor_i.h"
#include "mmitextinput.h"		/* 2003/12/04 sunsj modify for new eidtor mode */
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

#define TDTRACE 1
#include "mmiutilapi.h"
#if(MAIN_LCD_SIZE==3)
BOOL phonebook_search_flag=FALSE;
#endif
typedef enum
{
    NONE,
    TOLEFT,
    TORIGHT
} T_BrowserWay;

typedef enum
{
    KEY0,
    KEY1,
    KEY2,
    KEY3,
    KEY4,
    KEY5,
    KEY6,
    KEY7,
    KEY8,
    KEY9
} T_KEY;  

typedef enum
{
    B_NUMBER,
    B_HOME,
    B_OFFICE,
    B_MEMO
} T_BrowserType;
#if(MAIN_LCD_SIZE==4)
#define		PHONEBOOK_RECORD_PERPAGE	3
#define SEARCH_NUMBER_SHOW			126
#elif(MAIN_LCD_SIZE==3)
#define		PHONEBOOK_RECORD_PERPAGE	4
#define SEARCH_NUMBER_SHOW			93
#endif

/* sunsj: 2003-10-26 use as a bar in ShowDetailNumber */

/* 2004/06/08 sunsj add */
static MfwMnuAttr Shortcut_menuAttrib =//the default menu attr
{
    0,
    &ShortCutDynamicArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};

//end yq added
static MfwMnuAttr readName_menuAttrib =
{
    0,
    &menuDynamicArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE , /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                  /* number of items     */

};

static MfwMnuAttr new_menuAttrib =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0 
};

static int      DoNextLongPress = FALSE;

static T_MFW_HND          GetWin;
//static unsigned char        LastKey;
static U8                  SetFlag;
T_BrowserType       CurrentType;
static T_CopyWay          CopyWay;
int                  SelectTotal;
int      menu_start_index;//the index of the start index of the dynamic menu
T_DynamicBuffer           DataItem[MAX_Grouping];

T_SearchResult            bookname[ALL_NUMBER_LIST];
T_DynamicBuffer           DynamicBuffer[PHONEBOOK_RECORD_PERPAGE];
extern T_DynamicBuffer Dynamic_menu[PHONEBOOK_RECORD_PERPAGE];
T_CopyResult              CopyResult;
int                       SearchTotal;
static   int                  freetotal=0;//yq added for the dynamicfree
int                       CopyNumber;
USHORT                  ShortName;
static char                temp[100];
int                       RingSelect;
int                      IconSelect;    //add by xzy for grouping icon
//yq added
/* 2004/05/17 sunsj modify */
//extern const unsigned char iconWaitting[];   //the cursor
T_MFW_HND show_timer=0;         //the timer for show_number
static unsigned short show_index;       //the index of the number to show
static unsigned char refresh_flag;      //the flag for need refresh or not
/* 2004/06 sunsj modify for icon manage */
//extern const unsigned char abc_bmp[];  // the cursor abc
T_MFW_HND edt_timer=0;       //the timer for the editor of input shorcut character
static unsigned char cursor_correct=1;   //the flag indicate the cursor correct or not
static unsigned char key_before=0xff;      //the key you pressed before this key
static unsigned char key_index=0;          //the index of the key in edt_key
static const unsigned char edt_key[8][5]={"abc","def","ghi","jkl","mno","pqrs","tuv","wxyz"};//the key array for edt
//end yq added
//yq add for voice dial

MfwHnd voice_win;//the voice_dial win
static unsigned char        LastKey;
static int current_voice_index;//the index of current add or modify voice_dial info in voice_dial
voice_info voice_dial[VOICEDIAL_MAX];
char voice_filename[VOICEDIAL_MAX][12]={"VoiceD1","VoiceD2","VoiceD3","VoiceD4","VoiceD5","VoiceD6","VoiceD7",
    "VoiceD8","VoiceD9","VoiceD10"};
static voice_mode current_mode;//the mode of current,use in kbdcb
static unsigned char dial_mode;
static char voice_namefile[20]="/voiceD/VoiceName";
static char voice_name[PHB_MAX_LEN+3];
static char voice_number[PHB_MAX_LEN+1];
static unsigned char current_operation;// indicate the window from,1 from search.0 from add.
unsigned char voice_total;//the total voice_dial info .
unsigned char voice_index[VOICEDIAL_MAX];//store the current list item's index in voice_total
unsigned char voice_buffer[PHONEBOOK_RECORD_PERPAGE][PHB_MAX_LEN+3];//the text for the list
static unsigned char dial_index;
extern UINT32 driverFlag;
static UBYTE Add_Modify;//the falg indicate the operation.add or modify.1 add.2 modify
static UBYTE needgetvoicedata=0;
static BYTE recoginze_call_index=-1;
static UBYTE fromwinshow=0;
//end yq added
static UBYTE Phbk_DynamicMenu;//yq added for indicate phbk
static int         SearchIndex(T_MFW_PHB_SORT_INDEX *SortData,int RecordLen,char * Inputchr,int *Index);
static int         GetIndex(T_SearchResult *SortData,int RecordLen,char * Inputchr,int *Index);
static T_MFW_HND bookSearchCreate(MfwHnd parent);
static int         bookSearchWindowCB(MfwEvt e, MfwWin *w);
static void        bookSearchDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static void        bookSearchRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);
static void        bookCopyRecordCB(T_MFW_HND win, USHORT id, UBYTE reason);
static void        bookDeleteRecordCB(T_MFW_HND win, USHORT id, UBYTE reason);

static T_MFW_HND bookGroupingCreate( MfwHnd parent );
static int         bookGroupingWindowCB( MfwEvt e, MfwWin *w);
static void        bookGroupingDialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static void        bookGroupingRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static T_MFW_HND bookShortCutDialCreate( MfwHnd parent);
static int         bookShortCutDialWindowCB( MfwEvt e,MfwWin *w);
static void        bookShortCutDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static void        bookShortCutItemRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);
static void        bookShortCutBrowserRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static T_MFW_HND bookGroupingAddCreate( MfwHnd parent );
static void        bookGroupingAddDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
static int          bookGroupingAddWindowCB( MfwEvt e, MfwWin *w );
static void        bookGroupingAddRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static T_MFW_HND bookGroupingBrowserCreate(MfwHnd parent);
static void        bookGroupingBrowserDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
static int         bookGroupingBrowserWindowCB( MfwEvt e, MfwWin *w );
static void        bookGroupingBrowserRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static T_MFW_HND bookGroupingRenameCreate( MfwHnd parent );
static int         bookGroupingRenameKbdCB( MfwEvt e, MfwKbd *k );
static void        bookGroupingRenameDialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static int         bookGroupingRenameWindowCB( MfwEvt e, MfwWin *w );

static void        bookMultiCopyNvmToSimCB(T_MFW_HND win, USHORT id, UBYTE reason );
static void        bookMultiCopySimToNvmCB(T_MFW_HND win, USHORT id, UBYTE reason );

static T_MFW_HND bookChoiceCopyCreate( MfwHnd parent );
static int         bookChoiceCopyWindowCB( MfwEvt e, MfwWin *w);
static void        bookChoiceCopyDialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter);
static void        bookChoiceCopyRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static T_MFW_HND bookOwnNumberCreate( MfwHnd parent );
static void        bookOwnNumberDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
static int          bookOwnNumberWindowCB( MfwEvt e, MfwWin *w );
static void        bookOwnNumberRead_cb(T_MFW_HND * Parent, ListMenuData * ListData);

static void        bookInputDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
static T_MFW_HND bookInputCreate( MfwHnd parent );
static int         bookInputWindowCB( MfwEvt e, MfwWin *w );

static T_MFW_HND bookCopyAllCreate( MfwHnd parent );
static int         bookCopyAllWindowCB( MfwEvt e, MfwWin *w);
static void        bookCopyAllDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );

static void        book_Inofrmation_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void        book_AddMember_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void        book_DelMember_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void        book_CopyRecord_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static T_MFW_CB  book_copytim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);
static void        book_copytim_information(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static T_MFW_CB  book_choicecopytim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);
static void        book_choicecopy_information(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void        book_choicecopytim_information(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void        ShowPhoneBookNumber(int Index,T_BrowserWay way);//
void        ShortCutLocation(ListWinInfo  * dataInfo, char * NewKey,TABLE_TYPE table,int *BufferIndex,int flag);
static unsigned char SwitchChar(unsigned char InputChar);
static void        book_DeleteRecord_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void        bookCopyAllSimToNvmStart( T_MFW_HND Window,USHORT TxtContent);
static void        bookCopyAllNvmToSimStart( T_MFW_HND Window,USHORT TxtContent);

void        ClearWindowHandle();
static void        bookDeleteAllNVMRecordCB( T_MFW_HND win, USHORT id, UBYTE reason );
static void        bookDeleteAllSIMRecordCB( T_MFW_HND win, USHORT id, UBYTE reason );
static int  iconselect_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void iconSelect_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter);
static int iconselect_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
void iconSelect_destroy(T_MFW_HND own_window);
//yq added 
static void show_number(void);
static T_MFW_CB show_timercb (T_MFW_EVENT event, T_MFW_TIM *tc);
static void yq_edtchar(T_MFW_HND edt,unsigned char code);
static T_MFW_CB edt_timer_cb (T_MFW_EVENT event, T_MFW_TIM *tc);
//end yq added
//yq add for voicedial
static void bookVoiceAddCB(T_MFW_HND win, USHORT id, UBYTE reason );
static T_MFW_CB Recognize_Dial_CB (T_MFW_EVENT event, T_MFW_TIM *tc);
MfwHnd VdRecordStart( MfwHnd parent);
static T_MFW_HND VdRecordCreate( MfwHnd parent );
static void voice_record( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
void VdRecordDestroy( MfwHnd window );
static T_MFW_CB voice_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc);
static int voice_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
void VdRecordPlayCB (void* parameter);
void VdUpdatePlayCB (void* parameter);
void getVoiceTotal();
//end yq added

static void bookDeleteShortCutCB( T_MFW_HND win, USHORT id, UBYTE reason );//yq added for delete shortcutdial record
void bookVoiceModifyDestory( MfwHnd window );
void ShowVoiceListNumber(int Index);
static void ShowDetailBookNumber(MfwHnd window,int direct);

//begin xzy added for grouping icon 2002/10/31
//static T_MFW_HND bookGroupingIconCreate( MfwHnd parent );
//static void bookGroupingIconDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter );
//end xzy added for grouping icon 2002/10/31

/*******************************************************************************
                                                                              
                                Private Methods
                                                                              
*******************************************************************************/


/*******************************************************************************

 $Function:    	bookSearchDialog

 $Description:	dialog handler for the search window functionality
 
 $Returns:		None

 $Arguments:	win, window handle
                event, event to be handled
                value, not used
                parameter, not used
 
*******************************************************************************/

static void bookSearchDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;

    int i;
    char * titleStr;
    PhbkDetailItem       l_phb_NVMEntry;
    T_MFW_PHB_ENTRY   l_phb_Shortentry;
    T_MFW_PHB_LIST     l_phb_list;  /* phonebook list */
    T_MFW              ret;
    int                  NewIndex;
    UBYTE oldmode=dspl_Enable(0);
    TRACE_FUNCTION( "bookSearchDialog()" );

    switch( event )
    {
    case SEARCH_INPUT:
        {
            memset(Phbk->edt_buf_name,'\0',PHB_name_len+5);
            editor_attr_init_fullscr(&data->editor_data.editor_attr,1,TxtSearchName,NULL,PHB_name_len+3,edtCurBar1);  
            data->editor_data.hide            = FALSE;
            data->editor_data.min_enter       = 0;
            data->editor_data.Identifier      = 0xFFFF;
            data->editor_data.timeout         = FOREVER;
            data->editor_data.destroyEditor   = FALSE;
            data->editor_data.editor_attr.text = (char *)Phbk->edt_buf_name;
            data->editor_data.TextId          = TxtSearchName;
            data->editor_data.LeftSoftKey     = TxtSoftOK;
            data->editor_data.AlternateLeftSoftKey = TxtSearchName;     /* 2004/04/01 sunsj add */
            data->editor_data.RightSoftKey    = TxtDelete;
            data->editor_data.mode            = TEXTINPUT_MODE;        /* 2003/12/04 sunsj */
            data->editor_data.InputMode       = PINYIN_INPUT_MODE;     /* 2003/12/04 sunsj */
            data->editor_data.Callback        = (T_EDIT_CB)bookSearchCB;                        
            data->editor_data.edtInPbk        = 2;    /* 2003/12/04 sunsj */
            data->edtname                     = text_input(win, &data->editor_data);    /* 2003/12/04 sunsj */               
            winShow( data->win );    
        }   
        break;
    case SEARCH_INIT:
        {           
            TRACE_EVENT("SEARCH_INIT");
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                TRACE_EVENT("no memory");
                bookShowInformation( win, TxtEmptyList, NULL,(T_VOID_FUNC)book_Inofrmation_cb);//ڴ޹        	          	  
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(SearchTotal) *sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < GetFree(SearchTotal); i++ )
                    {
                        data->menu_list_data->List[i].icon =&DynamicBuffer[i].bookicon;                     
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit = 0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].func = NULL;  
                        data->menu_list_data->List[i].str=(char *)DynamicBuffer[i].name;    
                        Sprintf(temp,"len:%d",wstrlen((char *)DynamicBuffer[i].name));
                        TRACE_EVENT(temp);
                        data->menu_list_data->List[i].flagFunc=item_flag_none;
                    }

                    data->menu_list_data->ListLength     = GetFree(SearchTotal);


                    data->menu_list_data->SnapshotSize  = GetFree(SearchTotal);
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &readName_menuAttrib;                 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;           
                    titleStr=MmiRsrcGetText(TxtSearchName);
                    data->menu_list_data->ListMenuHeadStr=titleStr;

                    if( (int)parameter!=0 )
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                        Sprintf(temp,"index in rigthtop:%d",data->menu_list_data->Attr->pageturnindex);
                        TRACE_EVENT(temp);
                    }
                    //LastKey=0xFF;
#if(MAIN_LCD_SIZE==3)
                    phonebook_search_flag=TRUE;
#endif
                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookSearchRead_cb,0);

                    if( Phbk->BufferTable==GlobalTable )
                    {
                        show_index=l_phb_sort_index[Phbk->BufferIndex].index;
                    }
                    else if( Phbk->BufferTable==SearchTable )
                        show_index=bookname[Phbk->BufferIndex].index;
                    refresh_flag=1;
#if(MAIN_LCD_SIZE==4)
                    /* 2004/05/26 sunsj modify */
                    dspl_Clear(0,108,SCREEN_SIZE_X,126);
                    /* 2004/06 sunsj modify for icon manage */
                    //dspl_BitBlt(1, 110, 14, 14, 0, (void *)abc_bmp, 0);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
                    //dspl_TextOut(0,113,0,"sht:");
                    show_number();
#elif(MAIN_LCD_SIZE==3)
                    /* 2004/05/26 sunsj modify */
                    dspl_Clear(0,87,SCREEN_SIZE_X,110);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
                    show_number();
#endif
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, (T_VOID_FUNC)book_Inofrmation_cb);//Ϊ޷ռ	                              
                }                               
            }           
        }
        break;
    case SEARCH_DESTROY:
        {               
            TRACE_EVENT("search_destroy");
            if( !freetotal )
                FREE_MEMORY((void *)data->menu_list_data->List, GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            else
            {
                FREE_MEMORY((void *)data->menu_list_data->List, GetFree(freetotal)*sizeof(T_MFW_MNU_ITEM));
                freetotal=0;
            }
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
            switch( value )
            {
            case 2:
                /* 2003/12/04 sunsj modify for new editor mode */
                text_input_destroy(data->edtname);
            case 0:               
                {
                    bookSearchDestroy( win );
                }    
                break;
            case 1:
                {
                    memset(DynamicBuffer,0,sizeof(DynamicBuffer));
                    if( Phbk->BufferTable==GlobalTable )
                    {
                        SearchTotal=PHBKTotal;
                        if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
                        {
                            for( i=0;i<SearchTotal;i++ )
                            {
                                /* 2004/06 sunsj modify for picture manage */
                                memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);
                                if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                                else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                            }   
                        }
                        else
                        {
                            if( Phbk->BufferIndex>=SearchTotal ) Phbk->BufferIndex=0;
                            for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                            {
                                /* 2004/06 sunsj modify for picture manage */
                                memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);   
                                if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                                else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                            }   
                        }               
                    }
                    else if( Phbk->BufferTable==SearchTable )
                    {
                        if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
                        {
                            TRACE_EVENT("searchtotal<PHONEBOOK_RECORD_PERPAGE searchtable");
                            for( i=0;i<SearchTotal;i++ )
                            {
                                /* 2004/06 sunsj modify for picture manage */
                                memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len); 
                                if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                                else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                            }   
                        }
                        else
                        {
                            if( Phbk->BufferIndex>=SearchTotal ) Phbk->BufferIndex=0;
                            for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                            {
                                /* 2004/06 sunsj modify for picture manage */
                                memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);                                 
                                if( l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                                else if( l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                                    DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                            }    
                        }                   
                    }
                    SEND_EVENT(win, SEARCH_INIT, NULL,(int *)Phbk->BufferIndex);  
                    Sprintf(temp,"bufferindex:%d",Phbk->BufferIndex);
                    TRACE_EVENT(temp);
                }    
                break;
            default: break;               
            }                       
        }
        break;
    default: break;
    }
    dspl_Enable(oldmode);
}

/*******************************************************************************

 $Function:    	bookSearchWindowCB

 $Description:	Window call back function
 
 $Returns:		MFW_EVENT_CONSUMED, or MFW_EVENT_PASSED

 $Arguments:	e, event, w, window handle
 
*******************************************************************************/
static int bookSearchWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard   *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookSearchWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            //MmiBookShowDefault();//Clear Screen	
            edtShow(data->edt);
            edtChar(data->edt,ecBottom);
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	bookSearchCreate

 $Description:	Create the search window
 
 $Returns:		handle of window or NULL if error

 $Arguments:	parent, handle of parent window
 
*******************************************************************************/

static T_MFW_HND bookSearchCreate( MfwHnd parent )
{
    T_MFW_WIN       *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    T_phbk          *phbk = (T_phbk *)parent_win_data->user;
    T_MFW_WIN       *win_data;
    tBookStandard   *data;

    TRACE_FUNCTION ("bookSearchCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookSearchWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    // Okay, we have created the control block and the window, so
    //   we now need to configure the dialog and data pointers	
    data->mmi_control.dialog    = (T_DIALOG_FUNC) bookSearchDialog;
    data->mmi_control.data      = data;
    win_data                    = ((T_MFW_HDR *)data->win)->data;
    win_data->user              = (void *) data;
    data->phbk                  = phbk;
    data->parent_win            = parent;
#if(MAIN_LCD_SIZE==3)
	bookSetEditAttributes(35,72,20, 18,0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#elif (MAIN_LCD_SIZE==4)
    bookSetEditAttributes(20, 108, 32, 18, 0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#endif
    data->edt=edtCreate(data->win,&data->attr,0,0);
    if( !show_timer )
        show_timer=timCreate(data->win,300,(MfwCb)show_timercb);
    if( !edt_timer )
        edt_timer=timCreate(data->win,500,(MfwCb)edt_timer_cb);
    winShow(data->win); 
    return data->win;
}
/*******************************************************************************
                                                                              
                                Public Methods
                                                                              
*******************************************************************************/
static void bookSearchRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user;
    T_phbk           * Phbk     = data->phbk;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;

    T_MFW_PHB_ENTRY   l_phb_Shortentry;
    PhbkDetailItem       l_phb_NVMEntry; 
    int                 i;
    UBYTE oldmode=dspl_Enable(0);

    TRACE_EVENT("booksearchread_cb");
    switch( ListData->Reason )
    {
    case LISTS_REASON_SEND:
        {
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            if( Phbk->BufferTable==GlobalTable )
            {
                if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                {
                    if( ReadNVMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_NVMEntry) )
                    {
                        switch( CurrentType )
                        {
                        case B_NUMBER:
                            {    
                                T_EasyName data;
                                memset(&data, 0x00, sizeof(data));
                                memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                                memcpy(data.number,(char *)l_phb_NVMEntry.number,PHB_number_len);
                                SetCallData(data);
                                callNumber((UBYTE *)l_phb_NVMEntry.number);
                            }   
                            break;
                        case B_HOME:
                            {       
                                T_EasyName data;
                                memset(&data, 0x00, sizeof(data));
                                memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                                memcpy(data.number,(char *)l_phb_NVMEntry.home,PHB_number_len);
                                SetCallData(data);
                                callNumber((UBYTE *)l_phb_NVMEntry.home);
                            }   
                            break;
                        case B_OFFICE:
                            {    
                                T_EasyName data;
                                memset(&data, 0x00, sizeof(data));
                                memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                                memcpy(data.number,(char *)l_phb_NVMEntry.office,PHB_number_len);
                                SetCallData(data);
                                callNumber((UBYTE *)l_phb_NVMEntry.office);
                            }   
                            break;
                        default:break;
                        }                  
                    }
                }
                else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                {
                    if( ReadSIMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_Shortentry) )
                    {
                        T_EasyName data;
                        /* 2004/06/30 sunsj modify */
                        memset(&data, 0x00, sizeof(data));
                        memcpy(data.name,(char *)l_phb_Shortentry.name.data,PHB_name_len);
                        memcpy(data.number,(char *)l_phb_Shortentry.number,PHB_number_len);
                        SetCallData(data);
                        callNumber((UBYTE *) l_phb_Shortentry.number);
                    }
                }
            }
            else if( Phbk->BufferTable==SearchTable )
            {
                if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                {
                    if( ReadNVMRecord(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_NVMEntry) )
                    {
                        switch( CurrentType )
                        {
                        case B_NUMBER:
                            {       
                                T_EasyName data;
                                memset(&data, 0x00, sizeof(data));
                                memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                                memcpy(data.number,(char *)l_phb_NVMEntry.number,PHB_number_len);
                                SetCallData(data);
                                callNumber((UBYTE *)l_phb_NVMEntry.number);
                            }   
                            break;
                        case B_HOME:
                            {        
                                T_EasyName data;
                                memset(&data, 0x00, sizeof(data));
                                memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                                memcpy(data.number,(char *)l_phb_NVMEntry.number,PHB_number_len);
                                SetCallData(data);
                                callNumber((UBYTE *)l_phb_NVMEntry.home);
                            }   
                            break;
                        case B_OFFICE:
                            {     
                                T_EasyName data;
                                memset(&data, 0x00, sizeof(data));
                                memcpy(data.name,(char *)l_phb_NVMEntry.name,PHB_name_len+2);
                                memcpy(data.number,(char *)l_phb_NVMEntry.number,PHB_number_len);
                                SetCallData(data);
                                callNumber((UBYTE *)l_phb_NVMEntry.office);
                            }   
                            break;
                        default:break;
                        }                  
                    }
                }
                else if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                {
                    if( ReadSIMRecord(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_Shortentry) )
                    {
                        T_EasyName data;
                        /* 2004/06/30 sunsj modify */
                        memset(&data, 0x00, sizeof(data));
                        memcpy(data.name,(char *)l_phb_Shortentry.name.data,PHB_name_len);
                        memcpy(data.number,(char *)l_phb_Shortentry.number,PHB_number_len);
                        SetCallData(data);
                        callNumber((UBYTE *) l_phb_Shortentry.number);
                    }
                }
            }
        } 
        break;
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {
            timStop(show_timer);
            timStop(edt_timer);
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            switch( data->phbk->EntryType )
            {
            case PhbkFromShortcutKey:
            case PhbkNormal:
                {
                    data->phbk->dynamicmenu_win =ListData->win;
                    data->phbk->select_index      =(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal;
                    if( Phbk->BufferTable==GlobalTable )
                        show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition+SearchTotal)%SearchTotal].index;
                    else if( Phbk->BufferTable==SearchTable )
                        show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition+SearchTotal)%SearchTotal].index;
                    timStop(show_timer);
                    data->phbk->menu_options_win =bookMenuStart( data->phbk->win, bookNameMenuAttributes(),PhbkSearchItem);                 
                }
                break;
            case PhbkFromSms:
                {
                    if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                    {
                        if( ReadNVMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_NVMEntry) )
                        {
                            switch( CurrentType )
                            {
                            case B_NUMBER:
                                {
                                    SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,
                                                (UBYTE *)l_phb_NVMEntry.number);
                                    edtSymbol(getactiveEditor(),ecBottom);
                                }   
                                break;
                            case B_HOME:
                                {
                                    SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,
                                                (UBYTE *)l_phb_NVMEntry.home);
                                    edtSymbol(getactiveEditor(),ecBottom);
                                }   
                                break;
                            case B_OFFICE:
                                {
                                    SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,
                                                (UBYTE *)l_phb_NVMEntry.office);
                                    edtSymbol(getactiveEditor(),ecBottom);
                                }   
                                break;
                            default:break;
                            }                  
                        }
                    }
                    else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                    {
                        if( ReadSIMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_Shortentry) )
                        {
                            SEND_EVENT( data->phbk->parent_win, SMS_PHBK_NUMBER, PHBK_ID,(UBYTE *) l_phb_Shortentry.number);
                            edtSymbol(getactiveEditor(),ecBottom);
                        }
                    }
                    listsDestroy(ListData->win);
                    FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                                                                       
                    bookSearchDestroy(data->win);               
                }
                break;
            case PhbkFromDivert:
                {
                    if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                    {
                        if( ReadNVMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_NVMEntry) )
                        {
                            switch( CurrentType )
                            {
                            case B_NUMBER:
                                {
                                    SEND_EVENT( data->phbk->parent_win, DIVERT_PHBK_NUMBER, 0,
                                                (UBYTE *)l_phb_NVMEntry.number);
                                    edtSymbol(getactiveEditor(),ecBottom);
                                }   
                                break;
                            case B_HOME:
                                {
                                    SEND_EVENT( data->phbk->parent_win, DIVERT_PHBK_NUMBER, 0,
                                                (UBYTE *)l_phb_NVMEntry.home);
                                    edtSymbol(getactiveEditor(),ecBottom);
                                }   
                                break;
                            case B_OFFICE:
                                {
                                    SEND_EVENT( data->phbk->parent_win, DIVERT_PHBK_NUMBER, 0,
                                                (UBYTE *)l_phb_NVMEntry.office);
                                    edtSymbol(getactiveEditor(),ecBottom);
                                }   
                                break;
                            default:break;
                            }                  
                        }
                    }
                    else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                    {
                        if( ReadSIMRecord(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,&l_phb_Shortentry) )
                        {
                            SEND_EVENT( data->phbk->parent_win, DIVERT_PHBK_NUMBER, 0,(UBYTE *) l_phb_Shortentry.number);
                            edtSymbol(getactiveEditor(),ecBottom);
                        }
                    }
                    listsDestroy(ListData->win);
                    FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                                                                       
                    bookSearchDestroy(data->win);               
                }
                break;
            default:break;
            }
        }
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //	break;
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            timStop(show_timer);
            timStop(edt_timer);
            memset(data->phbk->edt_buf_name,'\0',PHB_name_len+5);
            listsDestroy(ListData->win);
            if( data->phbk->EntryType != PhbkNormal )
                SEND_EVENT(data->win, SEARCH_DESTROY, NULL, NULL);
            else
            {
                FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                      
                edtChar(data->edtname,ecBottom);                 
            }   
        }
        break;
    case LISTS_REASON_BACK:
        {

            if( wstrlen(data->edtBuf)==0 )
            {
                timStop(show_timer);
                timStop(edt_timer);
                memset(data->phbk->edt_buf_name,'\0',PHB_name_len+5);
                listsDestroy(ListData->win);
                if( data->phbk->EntryType != PhbkNormal )
                    SEND_EVENT(data->win, SEARCH_DESTROY, NULL, NULL);
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                     
                    edtChar(data->edtname,ecBottom);                 
                }  
            }
            else
                edtChar(data->edt,ecBack);
        }
        break;
    case LISTS_REASON_UPDATE:
        {
            if( Phbk->BufferTable==GlobalTable )
                show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;
            else if( Phbk->BufferTable==SearchTable )
                show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;

            refresh_flag=1;
#if(MAIN_LCD_SIZE==4)
            /* 2004/05/26 sunsj modify */
            dspl_Clear(0, 108, SCREEN_SIZE_X, 126);
            /* 2004/06 sunsj modify for icon manage */
            //dspl_BitBlt(0, 110, 14, 14, 0, (void *)abc_bmp, 0);
            DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);

            ShowPhoneBookNumber(show_index,NONE);
            edtChar(data->edt,ecBottom);
#elif(MAIN_LCD_SIZE==3)
			dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
            phonebook_search_flag=TRUE;
            ShowPhoneBookNumber(show_index,NONE);
            edtChar(data->edt,ecBottom);
#endif
        } 
        break;
    case LISTS_REASON_UP:
        {
            if( Phbk->BufferTable==GlobalTable )
            {
                if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
                {
                    dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                    mnuUp(dataInfo->MenuLists);              
                    show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                    show_number();
                }
                else
                {
                    Phbk->BufferIndex=(Phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                    dataInfo->MenuListsAttr.pageturnindex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal+1;             
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                        if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }   
                    mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                    show_index=l_phb_sort_index[(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal].index;
                    show_number();
                }
            }
            else if( Phbk->BufferTable==SearchTable )
            {
                if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
                {
                    dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                    mnuUp(dataInfo->MenuLists);

                    show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                    show_number();
                }
                else
                {
                    Phbk->BufferIndex=(Phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                    dataInfo->MenuListsAttr.pageturnindex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal+1;          
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                        if( l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                    mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                    show_index=bookname[(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal].index;
                    show_number();
                }
            }
        }
        break;
    case LISTS_REASON_DOWN:
        {
            if( Phbk->BufferTable==GlobalTable )
            {
                if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
                {
                    dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                    mnuDown(dataInfo->MenuLists);             
                    show_index=l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal].index;
                    show_number();
                }
                else
                {
                    Phbk->BufferIndex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                    dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex)%SearchTotal)+1; 
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                        if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }   
                    mnuChooseVisibleItem(dataInfo->MenuLists,0);
                    show_index=l_phb_sort_index[(Phbk->BufferIndex)%SearchTotal].index;
                    show_number();
                }
            }
            else if( Phbk->BufferTable==SearchTable )
            {
                if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
                {
                    dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                    mnuDown(dataInfo->MenuLists);
                    show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal].index;
                    show_number();
                }
                else
                {
                    Phbk->BufferIndex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                    dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex)%SearchTotal)+1;                  
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                        if( l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                    mnuChooseVisibleItem(dataInfo->MenuLists,0);
                    show_index=bookname[(Phbk->BufferIndex)%SearchTotal].index;
                    show_number();
                }
            }
        } 
        break;
    case LISTS_REASON_LEFT:       
        {
            if( Phbk->BufferTable==GlobalTable )
            {
                if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                    ShowPhoneBookNumber(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
            }
            else if( Phbk->BufferTable==SearchTable )
            {
                if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                    ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
            }
        } 
        break;
    case LISTS_REASON_RIGHT:
        {
            if( Phbk->BufferTable==GlobalTable )
            {
                if( l_phb_index[l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                    ShowPhoneBookNumber(l_phb_sort_index[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
            }
            else if( Phbk->BufferTable==SearchTable )
            {
                if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                    ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
            }
        }
        break;
    case LISTS_REASON_KCD0:
        {
        }                     
        break;                                             
    case LISTS_REASON_KCD1:                                            
        {
        }   
        break;
    case LISTS_REASON_KCD2:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_2);
        }   
        break;                                              
    case LISTS_REASON_KCD3: 
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_3);
        }   
        break;
    case LISTS_REASON_KCD4:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_4);
        }   
        break;                                                                                                 
    case LISTS_REASON_KCD5:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_5);
        }   
        break;                                                 
    case LISTS_REASON_KCD6:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_6);
        }   
        break;                                              
    case LISTS_REASON_KCD7:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_7);
        }   
        break;                                                  
    case LISTS_REASON_KCD8:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_8);
        }   
        break;                                              
    case LISTS_REASON_KCD9:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_9);
        }   
        break;                                             
    default:break;        
    }                                 
    dspl_Enable(oldmode);
}

/*******************************************************************************

 $Function:    	bookSearchStart

 $Description:	Starts the search window
 
 $Returns:		handle of newly created window, or NULL if error

 $Arguments:	parent, handle of parent window
 
*******************************************************************************/

T_MFW_HND bookSearchStart( MfwHnd parent )
{   
    T_MFW_WIN       *parent_win_data   = ( (T_MFW_HDR *) parent )->data;
    T_phbk           *Phbk              = (T_phbk *) parent_win_data->user;         
    T_MFW_HND       win;
    int                i;


    if( ( win = bookSearchCreate( parent ) ) == NULL ) return NULL;
    else
    {
        SetWindowsHandle(win);
        SetPhbkIN(1);
        ShortName=0;
        switch( Phbk->EntryType )
        {
        case PhbkFromShortcutKey:
        case PhbkFromSms:
        case PhbkFromDivert:    
            {
                Phbk->BufferTable=GlobalTable;                    
                if( PHBKTotal<=PHONEBOOK_RECORD_PERPAGE )
                {
                    for( i=0;i<PHBKTotal;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);                      
                        if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                }
                else
                {
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);                                       
                        if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                }
                Phbk->BufferIndex=0;
                SearchTotal=PHBKTotal;
                SEND_EVENT(win, SEARCH_INIT, NULL, NULL);                    
            }
            break;                      
        case PhbkNormal:
            {
                Phbk->BufferTable=SearchTable;
                SEND_EVENT (win, SEARCH_INPUT, NULL, NULL);
            }
            break;
        }               
    }                   
    return win;
}

/*******************************************************************************

 $Function:    	bookSearchDestroy

 $Description:	Destroy the search window
 
 $Returns:		None

 $Arguments:	Window, handle of the window to be destroyed
 
*******************************************************************************/

void bookSearchDestroy( MfwHnd window )
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookSearchDestroy()" );

    // Only destroy if the data is valid	
    if( data )
    {
        // If we're the root window we destroy using it's function		
        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );
            return;
        }

        if( show_timer )
        {
            timStop(show_timer);
            timDelete(show_timer);
            show_timer=0;
        }
        if( edt_timer )
        {
            timStop(edt_timer);
            timDelete(edt_timer);
            edt_timer=0;
        }
        key_before=0xff;
        cursor_correct=1;
        key_index=0;
        // delete ourself		
        data->phbk->search_win = 0;
        ClearWindowHandle();
        SetPhbkIN(0);
        winDelete( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

static void book_Inofrmation_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  *data      = (tBookStandard *) win_data->user;
    T_phbk         *Phbk       =data->phbk;

    TRACE_FUNCTION ("book_Inofrmation_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            if( (Phbk->EntryType==PhbkFromShortcutKey) || (Phbk->EntryType==PhbkFromSms)||(Phbk->EntryType==PhbkFromDivert) )
                bookSearchDestroy( win );
        }      
        break;                                                   
    default: break;
    }
}

static void book_DelMember_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  *data      = (tBookStandard *) win_data->user;
    T_phbk         *Phbk       =data->phbk;

    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            bookGroupingBrowserDestroy(win);   
        }      
        break;                                                   
    default: break;
    }
}

static void book_AddMember_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     *win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  *data      = (tBookStandard *) win_data->user;
    T_phbk         *Phbk       =data->phbk;

    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            bookGroupingAddDestroy(win); 
        }      
        break;                                                   
    default: break;
    }
}

static void bookCopyRecordCB( T_MFW_HND win, USHORT id, UBYTE reason )
{  
    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       = (tBookStandard *) win_data->user;
    T_phbk          *phbk       = data->phbk;

    T_MFW_HND      Dynamicwin   =data->phbk->dynamicmenu_win;
    T_MFW_HND      ParentWin    =data->phbk->search_win;

    int                 i;
    T_MFW_PHB_ENTRY   l_phb_Shortentry;

    T_MFW_PHB_LIST     l_phb_list;   /* phonebook list */
    T_MFW_PHB_STATUS  status,getstatus;   
    T_MFW              ret;
    int                  Index,NotFound,CompFlag;//

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            //         dspl_ClearAll();
            //         dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);//2003/12/1, wangyan modify
            switch( phbk->BufferTable )
            {
            case GlobalTable:
                {
                    if( l_phb_index[l_phb_sort_index[phbk->select_index].index].phonebook==SIM_BOOK_SEL )
                    {
                        if( NVMTotal<ALL_NVM_LIST )
                        {
                            for( i=0;i<ALL_NVM_LIST;i++ )
                            {
                                if( !CheckFlag(i) )
                                {
                                    if( CurrentTable!=i/PHB_table_len )
                                    {
                                        if( flash_PBread(PBTable[i/PHB_table_len])!=0 )
                                            CurrentTable=i/PHB_table_len;
                                    }

                                    if( ReadSIMRecord(l_phb_sort_index[phbk->select_index].index,&l_phb_Shortentry)==TRUE )
                                    {
                                        TRACE_EVENT("fzq Add!");
                                        memcpy(l_phb_index[i].name,l_phb_index[l_phb_sort_index[phbk->select_index].index].name,PHB_name_len);                   
                                        l_phb_index[i].phonebook=NVM_BOOK_SEL;
                                        l_phb_index[i].index=i;
                                        //================================================================================                   
                                        l_phb_index[i].number[0]=l_phb_index[l_phb_sort_index[phbk->select_index].index].number[0];
                                        l_phb_index[i].flag=SetAddFlag(i);
                                        l_phb_index[i].flag=SetFirstNumFlag(i, 1);
                                        //================================================================================                    

                                        memcpy(FFS_PBData.NVMBook[i%PHB_table_len].name,l_phb_Shortentry.name.data,PHB_name_len);
                                        CompressNum((char *)l_phb_Shortentry.number,FFS_PBData.NVMBook[i%PHB_table_len].number); 
                                        FFS_PBData.NVMBook[i%PHB_table_len].info=l_phb_index[i].flag;

                                        flash_PBwrite(PBTable[CurrentTable]);                                             
                                        NVMTotal=NVMTotal+1;
                                        PHBKTotal=PHBKTotal+1;
                                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST); 
                                        MmiBookSetCurrentText(TxtCopySucceed);
                                    }
                                    else MmiBookSetCurrentText( TxtReadError  );//SIM Card Read Fail	                                                           
                                    break;
                                }
                            }
                        }
                        else MmiBookSetCurrentText( TxtPhbkFull  );//ʾNVM绰                       
                    }
                    else if( l_phb_index[l_phb_sort_index[phbk->select_index].index].phonebook==NVM_BOOK_SEL )
                    {
                        Index=l_phb_sort_index[phbk->select_index].index;
                        //read sim card free value
                        status.book=bookActiveBook(READ);   
                        if( phb_get_status(&status)==MFW_PHB_OK )
                        {


                            if( SIMTotal<status.max_entries && status.avail_entries!=0 )
                            {

                                memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                                l_phb_Shortentry.book=bookActiveBook(WRITE);
                                getstatus.book=l_phb_Shortentry.book;
                                if( CurrentTable!=Index/PHB_table_len )
                                {
                                    if( flash_PBread(PBTable[CurrentTable])!=0 )
                                        CurrentTable=Index/PHB_table_len;
                                }

                                memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len);
                                l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                                //================================================================================================                      
                                switch( CheckFirstNumFlag(Index) )
                                {
                                case 0x01:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                    break;  
                                case 0x02:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                    break;
                                case 0x03:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                    break;
                                    //================================================================================================                                  
                                }                                                                                       

                                switch( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&getstatus) )
                                {
                                case MFW_PHB_OK :
                                    {                               
                                        MmiBookSetCurrentText(TxtCopySucceed);
                                        GetSIMData();
                                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST );
                                    }
                                    break;

                                case MFW_PHB_FULL :
                                    {                               
                                        MmiBookSetCurrentText( TxtPhbkFull  );
                                    }
                                    break;

                                case MFW_PHB_FAIL :
                                    {                              
                                        MmiBookSetCurrentText( TxtWriteError  );                                
                                    }
                                    break;

                                default: break;                       
                                }                                                                                                                            
                            }
                            else MmiBookSetCurrentText( TxtPhbkFull  );//show SIM full                                                                                                             
                        }
                        else MmiBookSetCurrentText( TxtWriteError );//ʾSIM    	                                                      	                            
                    }
                    bookShowInformation( win,MmiBookCurrentText(), NULL,(T_VOID_FUNC)book_CopyRecord_cb); 
                }                
                break;
            case SearchTable:
                {
                    if( l_phb_index[bookname[phbk->select_index].index].phonebook==SIM_BOOK_SEL )
                    {
                        if( NVMTotal<ALL_NVM_LIST )
                        {
                            for( i=0;i<ALL_NVM_LIST;i++ )
                            {
                                if( !CheckFlag(i) )
                                {
                                    if( CurrentTable!=i/PHB_table_len )
                                    {
                                        if( flash_PBread(PBTable[i/PHB_table_len])!=0 )
                                            CurrentTable=i/PHB_table_len;
                                    }

                                    if( ReadSIMRecord(bookname[phbk->select_index].index,&l_phb_Shortentry)==TRUE )
                                    {
                                        memcpy(l_phb_index[i].name,l_phb_index[bookname[phbk->select_index].index].name,PHB_name_len);                   
                                        l_phb_index[i].phonebook=NVM_BOOK_SEL;
                                        l_phb_index[i].index=i;
                                        //================================================================================                   
                                        l_phb_index[i].number[0]=l_phb_index[bookname[phbk->select_index].index].number[0];
                                        l_phb_index[i].flag=SetAddFlag(i);
                                        l_phb_index[i].flag=SetFirstNumFlag(i, 1);
                                        //================================================================================                   	                    
                                        memcpy(FFS_PBData.NVMBook[i%PHB_table_len].name,l_phb_Shortentry.name.data,PHB_name_len);
                                        CompressNum((char *)l_phb_Shortentry.number,FFS_PBData.NVMBook[i%PHB_table_len].number); 
                                        FFS_PBData.NVMBook[i%PHB_table_len].info=l_phb_index[i].flag;

                                        flash_PBwrite(PBTable[CurrentTable]);                                             
                                        NVMTotal=NVMTotal+1;
                                        PHBKTotal=PHBKTotal+1;
                                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
                                        NotFound=TRUE;
                                        CompFlag=FALSE;
                                        SearchTotal=0;
                                        memset(bookname,0,sizeof(T_SearchResult)*ALL_NUMBER_LIST);
                                        for( i=0;i<PHBKTotal;i++ )
                                        {
                                            if( (l_phb_sort_index[i].name==ShortName)||((l_phb_sort_index[i].name&0xff00)==ShortName) )
                                            {
                                                bookname[SearchTotal].index=l_phb_sort_index[i].index;
                                                CompFlag=TRUE;
                                                NotFound= FALSE;
                                                SearchTotal=SearchTotal+1;
                                            }
                                            else CompFlag=FALSE;
                                            if( (NotFound==FALSE) && (CompFlag=FALSE) ) break;
                                        }
                                        phbk->BufferIndex=0;
                                        freetotal=SearchTotal-1;
                                        /**/        

                                        MmiBookSetCurrentText(TxtCopySucceed);
                                    }
                                    else MmiBookSetCurrentText( TxtReadError  );//SIM Card Read Fail	                                                           
                                    break;
                                }
                            }
                        }
                        else MmiBookSetCurrentText( TxtPhbkFull  );//ʾNVM绰                       
                    }
                    else if( l_phb_index[bookname[phbk->select_index].index].phonebook==NVM_BOOK_SEL )
                    {
                        Index=bookname[phbk->select_index].index;
                        //read sim card free value
                        status.book=bookActiveBook(READ);   
                        if( phb_get_status(&status)==MFW_PHB_OK )
                        {


                            if( SIMTotal<status.max_entries && status.avail_entries!=0 )
                            {

                                memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                                l_phb_Shortentry.book=bookActiveBook(WRITE);
                                getstatus.book=l_phb_Shortentry.book;
                                if( CurrentTable!=Index/PHB_table_len )
                                {
                                    if( flash_PBread(PBTable[CurrentTable])!=0 )
                                        CurrentTable=Index/PHB_table_len;
                                }

                                memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len);
                                l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                                //================================================================================================                      
                                switch( CheckFirstNumFlag(Index) )
                                {
                                case 0x01:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                    break;  
                                case 0x02:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                    break;
                                case 0x03:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                                    break;
                                    //================================================================================================                                  
                                }                                                                                       

                                switch( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&getstatus) )
                                {
                                case MFW_PHB_OK :
                                    {                               
                                        MmiBookSetCurrentText(TxtCopySucceed);
                                        GetSIMData();
                                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST); 
                                        NotFound=TRUE;
                                        CompFlag=FALSE;
                                        SearchTotal=0;
                                        memset(bookname,0,sizeof(T_SearchResult)*ALL_NUMBER_LIST);
                                        for( i=0;i<PHBKTotal;i++ )
                                        {
                                            if( (l_phb_sort_index[i].name==ShortName)||((l_phb_sort_index[i].name&0xff00)==ShortName) )
                                            {
                                                bookname[SearchTotal].index=l_phb_sort_index[i].index;
                                                CompFlag=TRUE;
                                                NotFound= FALSE;
                                                SearchTotal=SearchTotal+1;
                                            }
                                            else CompFlag=FALSE;
                                            if( (NotFound==FALSE) && (CompFlag=FALSE) ) break;
                                        }
                                        phbk->BufferIndex=0;
                                        freetotal=SearchTotal-1;    
                                    }
                                    break;

                                case MFW_PHB_FULL :
                                    {                               
                                        MmiBookSetCurrentText( TxtPhbkFull  );
                                    }
                                    break;

                                case MFW_PHB_FAIL :
                                    {                              
                                        MmiBookSetCurrentText( TxtWriteError  );                                
                                    }
                                    break;

                                default: break;                       
                                }                                                                                                                            
                            }
                            else MmiBookSetCurrentText( TxtPhbkFull  );//show SIM full                                                                                                             
                        }
                        else MmiBookSetCurrentText( TxtWriteError );//ʾSIM    	                                                      	                            
                    }
                    else MmiBookSetCurrentText( TxtReadError);
                    bookShowInformation( win,MmiBookCurrentText(), NULL,(T_VOID_FUNC)book_CopyRecord_cb); 
                }    
                break;
            }                     
        }
        break;

    default: break;   
    }    
}

static void book_CopyRecord_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard   * data     = (tBookStandard *) win_data->user;
    T_phbk         * phbk     = data->phbk;

    T_MFW_HND     Dynamicwin= data->phbk->dynamicmenu_win;
    T_MFW_HND     ParentWin  = data->phbk->search_win;

    TRACE_FUNCTION ("book_copyrecord_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            SEND_EVENT(win, E_MNU_ESCAPE, NULL, NULL);
            listsDestroy(Dynamicwin);              
            SEND_EVENT(ParentWin, SEARCH_DESTROY, 1, NULL); 
        }      
        break;                                                   
    default: break;
    }
}

void bookCopyRecord(T_MFW_HND Window, USHORT TxtContent )
{    
    T_DISPLAY_DATA Dialog;

    dialog_info_init(&Dialog);//gdy add
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = TxtContent;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookCopyRecordCB;
    Dialog.Identifier   = 0;
    Dialog.iconindex=REMIND_REQUIRE;

    info_dialog( Window, &Dialog );      
}  

static void bookDeleteRecordCB( T_MFW_HND win, USHORT id, UBYTE reason )
{

    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       =(tBookStandard *)win_data->user;
    T_phbk          *phbk       =(T_phbk *)data->phbk;

    static T_MFW_PHB_STATUS     status;
    int                          i;
    T_MFW                       ret;
    BOOL                       NotFound,CompFlag;
    char temp[100];          
    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            /*         dspl_ClearAll();
                     dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);*///2003/12/1, wangyan modify
            switch( phbk->BufferTable )
            {
            case GlobalTable:
                {                  
                    if( l_phb_index[l_phb_sort_index[phbk->select_index].index].phonebook==SIM_BOOK_SEL )
                    {
                        TRACE_EVENT("Entry SIM Delete!");
                        ret=phb_delete_entry(PHB_ADN,l_phb_index[l_phb_sort_index[phbk->select_index].index].index,&status);
                        if( ret != MFW_PHB_OK )
                        {
                            bookShowInformation( win, TxtDelFail,NULL,(T_VOID_FUNC)book_DeleteRecord_cb);                                 
                        }
                        else
                        {
                            //update the smsdata
                            T_EasyName smsdata;
                            T_MFW_PHB_ENTRY smsentry;
                            memset(&smsdata,0,sizeof(T_EasyName));
                            memset(&smsentry,0,sizeof(T_MFW_PHB_ENTRY));
                            ReadSIMRecord(l_phb_sort_index[phbk->select_index].index,&smsentry);
                            memcpy(smsdata.number,smsentry.number,PHB_number_len);
                            ChangeSmsDataName(smsdata);
                            //===============================================================================================                              
                            l_phb_index[l_phb_sort_index[phbk->select_index].index].flag=SetDelFlag(l_phb_sort_index[phbk->select_index].index);

                            //===============================================================================================                                                                                                
                            GetSIMData();
                            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST); 
                            bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb );                                                                              
                        }
                    }
                    else if( l_phb_index[l_phb_sort_index[phbk->select_index].index].phonebook==NVM_BOOK_SEL )
                    {
                        int Index;

                        TRACE_EVENT("Entry NVM Delete!");
                        Index=l_phb_sort_index[phbk->select_index].index;
                        if( (Index/PHB_table_len)==CurrentTable )
                        {
                            T_EasyName smsdata;
                            char smsnumber[22]="";
                            memset(&smsdata,0,sizeof(T_EasyName));
                            if( !l_phb_index[Index].number[0] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[1] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[2] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            //==================================================================================================                              
                            l_phb_index[l_phb_sort_index[phbk->select_index].index].flag=SetDelFlag(l_phb_sort_index[phbk->select_index].index);

                            //==================================================================================================               
                            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[l_phb_sort_index[phbk->select_index].index].flag;

                        }
                        else
                        {
                            T_EasyName smsdata;
                            char smsnumber[22]="";
                            memset(&smsdata,0,sizeof(T_EasyName));
                            if( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                                CurrentTable=Index/PHB_table_len;
                            if( !l_phb_index[Index].number[0] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[1] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[2] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            //==================================================================================================                              
                            l_phb_index[l_phb_sort_index[phbk->select_index].index].flag=SetDelFlag(l_phb_sort_index[phbk->select_index].index);

                            //==================================================================================================                                   	                
                            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[l_phb_sort_index[phbk->select_index].index].flag;

                        }    
                        flash_PBwrite(PBTable[CurrentTable]);  
                        NVMTotal=NVMTotal-1;
                        PHBKTotal=PHBKTotal-1;
                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
                        bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);   

                    }
                }    
                break;
            case SearchTable:
                {
                    if( l_phb_index[bookname[phbk->select_index].index].phonebook==SIM_BOOK_SEL )
                    {
                        ret=phb_delete_entry(PHB_ADN,l_phb_index[bookname[phbk->select_index].index].index,&status);
                        if( ret != MFW_PHB_OK )
                        {
                            bookShowInformation( win, TxtDelFail,NULL,(T_VOID_FUNC)book_DeleteRecord_cb);                 
                        }
                        else
                        {
                            T_EasyName smsdata;
                            T_MFW_PHB_ENTRY smsentry;
                            memset(&smsdata,0,sizeof(T_EasyName));
                            memset(&smsentry,0,sizeof(T_MFW_PHB_ENTRY));
                            ReadSIMRecord(bookname[phbk->select_index].index,&smsentry);
                            memcpy(smsdata.number,smsentry.number,PHB_number_len);
                            ChangeSmsDataName(smsdata);
                            //===============================================================================================                              
                            l_phb_index[bookname[phbk->select_index].index].flag=SetDelFlag(bookname[phbk->select_index].index);

                            //===============================================================================================                                                                                                
                            GetSIMData();
                            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST); 

                            if( !PHBKTotal )
                            {
                                TRACE_EVENT("no phb record");
                                bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);
                            }
                            else
                            {

                                NotFound=TRUE;
                                CompFlag=FALSE;
                                SearchTotal=0;
                                for( i=0;i<PHBKTotal;i++ )
                                {
                                    if( (l_phb_sort_index[i].name==ShortName)||((l_phb_sort_index[i].name&0xff00)==ShortName) )
                                    {
                                        bookname[SearchTotal].index=l_phb_sort_index[i].index;
                                        CompFlag=TRUE;
                                        NotFound= FALSE;
                                        SearchTotal=SearchTotal+1;
                                    }
                                    else CompFlag=FALSE;
                                    if( (NotFound==FALSE) && (CompFlag=FALSE) ) break;
                                }

                                freetotal=SearchTotal+1;
#if 0
                                if( NotFound==FALSE )
                                {
                                    TRACE_EVENT("we founded record");
                                    Sprintf(temp,"searchtotal:%d",SearchTotal);
                                    TRACE_EVENT(temp);

                                    if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
                                    {
                                        for( i=0;i<SearchTotal;i++ )
                                        {
                                            memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);
                                            if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                                DynamicBuffer[i].bookicon=nvmbookicon;
                                            else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                                DynamicBuffer[i].bookicon=simbookicon;
                                        }       
                                        phbk->BufferIndex=0;                        
                                    }
                                    else
                                    {
                                        for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                                        {
                                            memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);
                                            if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                                DynamicBuffer[i].bookicon=nvmbookicon;
                                            else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                                DynamicBuffer[i].bookicon=simbookicon;
                                        }    
                                        phbk->BufferIndex=0;                        
                                    }

                                    bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);                               
                                }
                                else
#endif
                                {
                                    bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);                                     
                                } 

                            }
                        }

                    }
                    else if( l_phb_index[bookname[phbk->select_index].index].phonebook==NVM_BOOK_SEL )
                    {
                        int Index;

                        Index=bookname[phbk->select_index].index;
                        if( (Index/PHB_table_len)==CurrentTable )
                        {
                            T_EasyName smsdata;
                            char smsnumber[22]="";
                            memset(&smsdata,0,sizeof(T_EasyName));
                            if( !l_phb_index[Index].number[0] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[1] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[2] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            //==================================================================================================                              
                            l_phb_index[bookname[phbk->select_index].index].flag=SetDelFlag(bookname[phbk->select_index].index);

                            //==================================================================================================               
                            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[bookname[phbk->select_index].index].flag;

                        }
                        else
                        {
                            T_EasyName smsdata;
                            char smsnumber[22]="";
                            if( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                                CurrentTable=Index/PHB_table_len;

                            memset(&smsdata,0,sizeof(T_EasyName));
                            if( !l_phb_index[Index].number[0] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[1] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            if( !l_phb_index[Index].number[2] )
                            {
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home, (unsigned char *)smsnumber);
                                memcpy(smsdata.number,smsnumber,PHB_number_len);
                                ChangeSmsDataName(smsdata);
                            }
                            //==================================================================================================                              
                            l_phb_index[bookname[phbk->select_index].index].flag=SetDelFlag(bookname[phbk->select_index].index);

                            //==================================================================================================                                   	                
                            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[bookname[phbk->select_index].index].flag;

                        }                                                                                        
                        NVMTotal=NVMTotal-1;
                        PHBKTotal=PHBKTotal-1;
                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);        
                        flash_PBwrite(PBTable[CurrentTable]); 
                        if( !PHBKTotal )
                        {
                            bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);                              
                        }
                        else
                        {
                            NotFound=TRUE;
                            CompFlag=FALSE;
                            for( i=0,SearchTotal=0;i<PHBKTotal;i++ )
                            {
                                if( (l_phb_sort_index[i].name==ShortName)||((l_phb_sort_index[i].name&0xff00)==ShortName) )
                                {
                                    bookname[SearchTotal].index=l_phb_sort_index[i].index;
                                    CompFlag=TRUE;
                                    NotFound= FALSE;
                                    SearchTotal=SearchTotal+1;
                                }
                                else CompFlag=FALSE;
                                if( (NotFound==FALSE) && (CompFlag=FALSE) ) break;
                            }
                            freetotal=SearchTotal+1;
#if 0
                            if( NotFound==FALSE )
                            {
                                if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
                                {
                                    for( i=0;i<SearchTotal;i++ )
                                    {
                                        memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);
                                        if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                            DynamicBuffer[i].bookicon=nvmbookicon;
                                        else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                            DynamicBuffer[i].bookicon=simbookicon;
                                    }       
                                    phbk->BufferIndex=0;                        
                                }
                                else
                                {
                                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                                    {
                                        memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                             
                                        if( l_phb_index[bookname[i].index].phonebook==NVM_BOOK_SEL )
                                            DynamicBuffer[i].bookicon=nvmbookicon;
                                        else if( l_phb_index[bookname[i].index].phonebook==SIM_BOOK_SEL )
                                            DynamicBuffer[i].bookicon=simbookicon;
                                    }    
                                    phbk->BufferIndex=0;                        
                                }
                                bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);        

                            }
                            else
#endif
                            {
                                bookShowInformation( win, TxtDelSucceed,NULL, (T_VOID_FUNC)book_DeleteRecord_cb);        

                            }                      
                        }
                    }
                }    
                break;
            default: break;
            }                                                  
        }
        break;

    default: break;
    }           
}

static void book_DeleteRecord_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  *data      = (tBookStandard *) win_data->user;
    T_phbk         *Phbk       =data->phbk;

    T_MFW_HND      Dynamicwin   =data->phbk->dynamicmenu_win;
    T_MFW_HND      ParentWin    =data->phbk->search_win;

    TRACE_FUNCTION ("call_failure_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            SEND_EVENT(win,E_MNU_ESCAPE, NULL, NULL);
            listsDestroy(Dynamicwin);
            if( (!PHBKTotal) || (!SearchTotal) )
            {
                if( Phbk->EntryType==PhbkFromShortcutKey )
                    SEND_EVENT(ParentWin, SEARCH_DESTROY, 0, NULL);
                else if( Phbk->EntryType==PhbkNormal )
                    SEND_EVENT(ParentWin, SEARCH_DESTROY,2, NULL);
            }
            else SEND_EVENT(ParentWin, SEARCH_DESTROY, 1, NULL);            
        }      
        break;                                                   
    default: break;
    }
}


void bookDeleteRecord(T_MFW_HND Window)
{
    T_DISPLAY_DATA Dialog;

    dialog_info_init(&Dialog);//gdy add
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = TxtPhbkDelMess;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookDeleteRecordCB;
    Dialog.Identifier   = 0;
    Dialog.iconindex=REMIND_REQUIRE;

    info_dialog( Window, &Dialog );
}

void bookDeleteAllNVMRecord(T_MFW_HND Window)
{
    T_DISPLAY_DATA Dialog;
    if( NVMTotal==0 )
    {
        dialog_info_init(&Dialog);//gdy add 
        Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
        Dialog.TextId     = 0;
        Dialog.TextId2    = TxtNorecord;
        Dialog.TextString  =  '\0';
        Dialog.TextString2  = '\0';
        Dialog.LeftSoftKey  = TxtSoftOK;
        Dialog.RightSoftKey = TxtCancel;
        Dialog.Time       = FOREVER;
        Dialog.Callback    = NULL;
        Dialog.Identifier   = 0;
        Dialog.iconindex=REMIND_NORECORD;
        info_dialog( Window, &Dialog );
        return;
    }
    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    //   Dialog.TextId2    = TxtPhbkDelMess;
    Dialog.TextId2    = TxtDeleteAll;/* 2003/12/3, wangyan, modify dialog delete style*/
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    //  Dialog.RightSoftKey = TxtCancel;
    Dialog.RightSoftKey = TxtSoftBack;/* 2003/12/3, wangyan, modify dialog delete style*/
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookDeleteAllNVMRecordCB;
    Dialog.Identifier   = 0;
    Dialog.iconindex=REMIND_REQUIRE;

    info_dialog( Window, &Dialog );
}

static void bookDeleteAllNVMRecordCB( T_MFW_HND win, USHORT id, UBYTE reason )
{

    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       =(tBookStandard *)win_data->user;
    char             getpath[20],filepath[6]="/bmi/";   /* 2004/06/14 sunsj modify */
    char             temp[50];
    int               i;

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            /*          dspl_ClearAll();
                      dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);*///2003/12/1, wangyan modify
            for( i=0;i<PHB_PBTable;i++ )
            {
                memset(getpath,0,sizeof(getpath));
                memcpy(getpath,filepath,sizeof(filepath));                          
                strcat(getpath,PBTable[i]);
                ConfigPhbkReset();
                flash_PBwrite(PBTable[i]);                      
            }

            for( i=0;i<ALL_NVM_LIST;i++ )
                l_phb_index[i].flag=SetDelFlag(i)|0x0f; 

            NVMTotal=0;
            PHBKTotal=SIMTotal+NVMTotal;       
            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
            SetSmsDataNull();
            bookShowInformation( data->win, TxtDelSucceed,NULL, NULL );   

        }
        break;
    default: break;
    }           
}

void bookDeleteAllSIMRecord(T_MFW_HND Window)
{
    T_DISPLAY_DATA Dialog;
    if( SIMTotal==0 )
    {
        dialog_info_init(&Dialog);//gdy add 
        Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
        Dialog.TextId     = 0;
        Dialog.TextId2    = TxtNorecord;
        Dialog.TextString  =  '\0';
        Dialog.TextString2  = '\0';
        Dialog.LeftSoftKey  = TxtSoftOK;
        Dialog.RightSoftKey = TxtCancel;
        Dialog.Time       = FOREVER;
        Dialog.Callback    = NULL;
        Dialog.Identifier   = 0;
        Dialog.iconindex=REMIND_NORECORD;
        info_dialog( Window, &Dialog );
        return;
    }
    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    //    Dialog.TextId2    = TxtPhbkDelMess;
    Dialog.TextId2    = TxtDeleteAll;/* 2003/10/29, wangyan, modify dialog delete style*/

    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    //    Dialog.RightSoftKey = TxtCancel;
    Dialog.RightSoftKey = TxtSoftBack;/* 2003/10/29, wangyan, modify dialog delete style*/

    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookDeleteAllSIMRecordCB;
    Dialog.Identifier   = 0;
    Dialog.iconindex=REMIND_REQUIRE;

    info_dialog( Window, &Dialog );
}

static void bookDeleteAllSIMRecordCB( T_MFW_HND win, USHORT id, UBYTE reason )
{

    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       =(tBookStandard *)win_data->user;
    int              i;

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            /*           dspl_ClearAll();
                       dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);*/ //2003/12/1, wangyan modify
            data->phbk->current.status.book= bookActiveBook(WRITE);
            phb_delete_book(data->phbk->current.status.book);
            for( i=ALL_NVM_LIST;i<ALL_NUMBER_LIST;i++ )
                l_phb_index[i].flag=SetDelFlag(i);             
            GetSIMData();
            if( SIMTotal==0 )
            {
                SetSmsDataNull();
                MmiBookSetCurrentText(TxtDelSucceed);                                                                          
            }
            else MmiBookSetCurrentText(TxtDelFail);

            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);               
            bookShowInformation( data->win, MmiBookCurrentText(),NULL, NULL );                                                                                                               
        }
        break;
    default: break;
    }           
}


//------------------------------------------------------------------------------
//-----------------------------GroupingSetting------------------------------------
/**********************************************************************************
$History:
  #2003/11/01, talcon	
**********************************************************************************/
void bookGroupingDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;
    T_MFW_HND      parent_win   =data->parent_win;
    int i;
    char * titleStr;
    char   temp[100];

    TRACE_FUNCTION( "bookGroupingDialog()" );

    for( i=0;i<MAX_Grouping;i++ )
    {
        memset(DataItem[i].name,'\0',PHB_name_len);
        if( FFS_PBOtherData.GroupingItem[i].GroupingName[0]=='\0' )
        {
            switch( i )
            {
            case 0:
                {                              
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingOne),PHB_name_len);               
                }      
                break;
            case 1:
                {                              
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingTwo),PHB_name_len);               
                }      
                break;  
            case 2:
                {                                  
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingThree),PHB_name_len);               
                }      
                break;  
            case 3:
                {                                  
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingFour),PHB_name_len);               
                }      
                break;  
            case 4:
                {                               
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingFive),PHB_name_len);               
                }      
                break;  
            case 5:
                {                              
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingSix),PHB_name_len);               
                }      
                break;  
            case 6:
                {                                           
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingSeven),PHB_name_len);               
                }      
                break;  
            case 7:
                {                               
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingEight),PHB_name_len);               
                }      
                break;  
            case 8:
                {               
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingNine),PHB_name_len);               
                }      
                break;  
            case 9:
                {               
                    memcpy((char *)DataItem[i].name,MmiRsrcGetText(TxtGroupingTen),PHB_name_len);               
                }      
                break;                  
            }
        }
        else memcpy((char *)DataItem[i].name,(char *)FFS_PBOtherData.GroupingItem[i].GroupingName,PHB_name_len);
        ////zgzTraceDataFunc("len of num1:",(unsigned short)wstrlen((char *)DataItem[0].name));
    }

    switch( event )
    {
    case Grouping_INIT:
        {               
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                bookShowInformation( win, TxtEmptyList, NULL, NULL );
                bookGroupingDestroy( win );
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( MAX_Grouping * sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < MAX_Grouping; i++ )
                    {
                        if( i==9 )
                        {
                            /* 2004/06 sunsj modify for picture manage */
                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 15);//&BookGroupingIcon[15];
                        }
                        else
                        {
                            if( FFS_PBOtherData.GroupingItem[i].GroupingIcon-85 <= 14 && FFS_PBOtherData.GroupingItem[i].GroupingIcon-85 >= 0 )
                            {
                                data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, FFS_PBOtherData.GroupingItem[i].GroupingIcon-85);
                            }
                            else
                            {
                                data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_NVMBOOK, 0);
                            }
                            /*
                                        switch( FFS_PBOtherData.GroupingItem[i].GroupingIcon-85 )
                                        {
                                        case 0:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 0);//&BookGroupingIcon[0];
                                            break;
                                        case 1:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 1);//&BookGroupingIcon[1];
                                            break;                          
                                        case 2:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 2);//&BookGroupingIcon[2];
                                            break;                          
                                        case 3:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 3);//&BookGroupingIcon[3];
                                            break;
                                        case 4:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 4);//&BookGroupingIcon[4];
                                            break;
                                        case 5:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 5);//&BookGroupingIcon[5];
                                            break;
                                        case 6:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 6);//&BookGroupingIcon[6];
                                            break;
                                        case 7:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 7);//&BookGroupingIcon[7];
                                            break;
                                        case 8:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 8);//&BookGroupingIcon[8];
                                            break;
                                        case 9:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 9);//&BookGroupingIcon[9];
                                            break;
                                        case 10:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 10);//&BookGroupingIcon[10];
                                            break;
                                        case 11:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 11);//&BookGroupingIcon[11];
                                            break;
                                        case 12:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 12);//&BookGroupingIcon[12];
                                            break;
                                        case 13:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 13);//&BookGroupingIcon[13];
                                            break;
                                        case 14:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 14);//&BookGroupingIcon[14];
                                            break;
                                            //case 15:		
                                            //data->menu_list_data->List[i].icon = &BookGroupingIcon[15];
                                            //break;
            
                                        default:
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_NVMBOOK, 0);//&nvmbookicon;
                                            break;
                                        }
                            */
                        }

                        //data->menu_list_data->List[i].icon = 0;
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit = 0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].func = NULL;
                        data->menu_list_data->List[i].str=(char *)DataItem[i].name;
                        data->menu_list_data->List[i].flagFunc =item_flag_none;                     
                    }

                    data->menu_list_data->ListLength     = MAX_Grouping;
                    data->menu_list_data->ListPosition    = 1;
                    data->menu_list_data->CursorPosition = 1;
                    data->menu_list_data->SnapshotSize  = MAX_Grouping;
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &new_menuAttrib; 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;
                    titleStr=MmiRsrcGetText(TxtGroupingSetting);
                    data->menu_list_data->ListMenuHeadStr=titleStr;

                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookGroupingRead_cb,0);
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ
                    bookGroupingDestroy( win );                    
                }
            }           
        }
        break;                  
    default: break;
    }
}

static int bookGroupingWindowCB( MfwEvt e, MfwWin *w)
{
    tBookStandard *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookSearchWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            //MmiBookShowDefault();//Clear Screen												
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

static T_MFW_HND bookGroupingCreate( MfwHnd parent )
{
    T_MFW_WIN        *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    tBookStandard    *parentdata=(tBookStandard *)parent_win_data->user;
    T_phbk           *phbk = parentdata->phbk;
    T_MFW_WIN        *win_data;
    tBookStandard    *data;

    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookGroupingWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }
    ////zgzTraceDataFunc("yq:the handle create",(unsigned short)data->win);
    data->mmi_control.dialog = (T_DIALOG_FUNC) bookGroupingDialog;
    data->mmi_control.data   = data;
    win_data                 = ((T_MFW_HDR *)data->win)->data;
    win_data->user           = (void *) data;
    data->phbk               = phbk;
    data->parent_win         = parent;

    winShow(data->win);

    return data->win;
}

static void bookGroupingRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;

    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {
            data->phbk->select_index=ListData->CursorPosition;
            RingSelect=ListData->CursorPosition;
            IconSelect=ListData->CursorPosition;
            data->phbk->menu_options_win = bookMenuStart( data->phbk->win, bookGroupingSettingAttributes(),PhbkFromGroupingItem); 
        }    
        break;
    case LISTS_REASON_BACK:     
        {
            setSoundsReason(SoundsNone);  //xsf add 2003.01.15
            listsDestroy(ListData->win);                   
            FREE_MEMORY((void *)data->menu_list_data->List,MAX_Grouping*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                   
            bookGroupingDestroy(data->win);
        }
        break;       
    default: break;      
    }                   
}

T_MFW_HND bookGroupingStart( MfwHnd parent )
{
    T_MFW_HND       win;

    if( ( win = bookGroupingCreate( parent ) ) == NULL ) return NULL;
    else
    {

        SEND_EVENT(win,Grouping_INIT,NULL,NULL);
    }

    return win;      
}

void bookGroupingDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard *data = (tBookStandard *) win->user;

    // Only destroy if the data is valid	
    if( data )
    {
        // If we're the root window we destroy using it's function

        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );            
            return;
        }

        winDelete( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }

}

T_MFW_HND bookGroupingAddStart( MfwHnd parent )
{
    T_MFW_HND      win;     


    if( ( win = bookGroupingAddCreate( parent ) ) == NULL ) return NULL;
    else
    {
        SetWindowsHandle(win);
        SetPhbkIN(1);

        SEND_EVENT (win, Grouping_ADDINIT, 0, 0);
    }                   
    return win;
}

static T_MFW_HND bookGroupingAddCreate( MfwHnd parent )
{
    T_MFW_WIN       *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    tBookStandard    *parent_data     = (tBookStandard *) parent_win_data->user;
    T_phbk          *phbk               = parent_data->phbk;
    //T_phbk			*phbk = (T_phbk *)parent_win_data->user;
    T_MFW_WIN       *win_data;
    tBookStandard   *data;

    TRACE_FUNCTION ("bookSearchCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookGroupingAddWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    // Okay, we have created the control block and the window, so
    // we now need to configure the dialog and data pointers	
    data->mmi_control.dialog    = (T_DIALOG_FUNC) bookGroupingAddDialog;
    data->mmi_control.data      = data;
    win_data                    = ((T_MFW_HDR *)data->win)->data;
    win_data->user              = (void *) data;
    data->phbk                  = phbk;
    data->parent_win            = parent;
#if(MAIN_LCD_SIZE==3)
	bookSetEditAttributes(20,85,32, 18,0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#elif (MAIN_LCD_SIZE==4)
    bookSetEditAttributes(20, 108, 32, 18, 0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#endif
    data->edt=edtCreate(data->win,&data->attr,0,0);

#ifndef FOR_FTA_CTA
    if( !show_timer )
        show_timer=timCreate(data->win,300,(MfwCb)show_timercb);
#endif

    if( !edt_timer )
        edt_timer=timCreate(data->win,500,(MfwCb)edt_timer_cb);
    winShow(data->win); 
    return data->win;   
}

static void bookGroupingAddDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;
    T_MFW_HND      parent_win   =data->parent_win;
    U8              GetFlag,GetIndex;
    int              i,j;
    char            * titleStr;
    UBYTE old_mode=dspl_Enable(0);
    TRACE_FUNCTION( "bookGroupingAddDialog()" );


    switch( event )
    {
    case Grouping_ADDINIT:
        {               
            for( i=0,SearchTotal=0;i<PHBKTotal;i++ )
            {
                GetFlag=(l_phb_index[l_phb_sort_index[i].index].flag) & 0x0F;
                GetIndex=Phbk->select_index & 0x0F;

                if( (l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL) && (GetFlag!=GetIndex) )
                {
                    bookname[SearchTotal].index=l_phb_sort_index[i].index;
                    SearchTotal=SearchTotal+1;
                }
            }

            Phbk->BufferIndex=0;
            Phbk->BufferTable=SearchTable;
            if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
            {
                for( i=0;i<SearchTotal;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                                        
                }    
            }
            else
            {
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                                                           
                }    
            }    

            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( (!data->menu_list_data) || (!GetFree(SearchTotal)) )
            {
                if( data->menu_list_data )
                {
                    FREE_MEMORY((U8 *)data->menu_list_data,sizeof(ListMenuData));

                }
                /* 2004/06/08 sunsj modify */
                bookGroupingAddDestroy( win );

                if( ! GetFree(SearchTotal) )
                {
                    bookShowInformation( win, TxtEmptyList, (char *)MmiRsrcGetText(TxtNVMBook), NULL );
                }
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(SearchTotal)* sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i <  GetFree(SearchTotal); i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_NVMBOOK, 0);//&nvmbookicon;
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit =  0;
                        data->menu_list_data->List[i].menu =0;
                        data->menu_list_data->List[i].func = NULL;                        
                        data->menu_list_data->List[i].str=(char *)DynamicBuffer[i].name;
                        data->menu_list_data->List[i].flagFunc = item_flag_none;                                     
                    }

                    data->menu_list_data->ListLength     = GetFree(SearchTotal);
                    data->menu_list_data->ListPosition    = 1;
                    data->menu_list_data->CursorPosition = 1;
                    data->menu_list_data->SnapshotSize  = GetFree(SearchTotal);
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &readName_menuAttrib; 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;
                    titleStr=MmiRsrcGetText(TxtAddMember);
                    data->menu_list_data->ListMenuHeadStr=titleStr;   

                    if( (int)parameter!=0 )
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;

                    }
                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookGroupingAddRead_cb,0);
                    refresh_flag=1;
                    
/* 2004/05/26 sunsj modify */                   
/* 2004/06 sunsj modify for icon manage */
#if(MAIN_LCD_SIZE==4)
					dspl_Clear(0,108, SCREEN_SIZE_X, 126);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
                    dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
					show_index=bookname[Phbk->BufferIndex].index;
                    show_number();
					
				}
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ
                    bookGroupingAddDestroy( win );                   
                }
            }           
        }
        break;                  
    default: break;
    }
    dspl_Enable(old_mode);
}

static int bookGroupingAddWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard   *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookSearchWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            //MmiBookShowDefault();//Clear Screen
            edtShow(data->edt);
            edtChar(data->edt,ecBottom);
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

static void bookGroupingAddRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user; 
    T_phbk           * Phbk     = data->phbk;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;
    int               i,j;
    U8               GetFlag,GetIndex;
    int               Index;
    TRACE_FUNCTION("bookGroupingAddRead_cb");
    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {
            timStop(show_timer);
            timStop(edt_timer);
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            Index=bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;
            if( CurrentTable!=Index/PHB_table_len )
            {
                if( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                    CurrentTable=Index/PHB_table_len;
            }
            l_phb_index[Index].flag=l_phb_index[Index].flag & 0xF0;
            l_phb_index[Index].flag=l_phb_index[Index].flag+(Phbk->select_index & 0x0F);
            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[Index].flag;
            /*            dspl_ClearAll();
                        dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);*///2003/12/1, wangyan modify
            flash_PBwrite(PBTable[CurrentTable]);

            bookShowInformation(data->win,TxtMemberAdd,NULL,(T_VOID_FUNC)book_AddMember_cb);   
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));

        }
        break;
    case LISTS_REASON_BACK:



        if( wstrlen(data->edtBuf)==0 )
        {
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                
            bookGroupingAddDestroy(data->win);  
        }
        else
            edtChar(data->edt,ecBack);
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //	break;
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));             
            bookGroupingAddDestroy(data->win);  
        }   
        break;
    case LISTS_REASON_UP:
        {
#if(MAIN_LCD_SIZE==3)
			phonebook_search_flag=TRUE;
#endif
            TRACE_EVENT("press up in grouping");
            if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                mnuUp(dataInfo->MenuLists);
                show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal)+1;  
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);              
                }   
                mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                show_index=bookname[(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1+SearchTotal)%SearchTotal].index;
                show_number();
            } 
        } 
        break;
    case LISTS_REASON_DOWN:
        {
#if(MAIN_LCD_SIZE==3)
			phonebook_search_flag=TRUE;
#endif
            if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                mnuDown(dataInfo->MenuLists);
                show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition+1+SearchTotal)%SearchTotal].index;
                show_number();

            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex)%SearchTotal)+1; 
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);              
                }            
                mnuChooseVisibleItem(dataInfo->MenuLists,0);
                show_index=bookname[(Phbk->BufferIndex+SearchTotal)%SearchTotal].index;
                show_number();

            } 
        }
        break;    
    case LISTS_REASON_UPDATE:
        {
#if(MAIN_LCD_SIZE==4)
			dspl_Clear(0,108, SCREEN_SIZE_X, 126);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
			dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
            ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,NONE);
            edtChar(data->edt,ecBottom);
        }
        break;
    case LISTS_REASON_LEFT:
        {
            if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
        } 
        break;
    case LISTS_REASON_RIGHT:
        {
            if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
        } 
        break;
    case LISTS_REASON_KCD0:
        {
        }                     
        break;                                             
    case LISTS_REASON_KCD1:                                            
        {
        }   
        break;
    case LISTS_REASON_KCD2:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_2);
        }   
        break;                                              
    case LISTS_REASON_KCD3: 
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_3);
        }   
        break;
    case LISTS_REASON_KCD4:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_4);
        }   
        break;                                                                                                 
    case LISTS_REASON_KCD5:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_5);
        }   
        break;                                                 
    case LISTS_REASON_KCD6:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_6);
        }   
        break;                                              
    case LISTS_REASON_KCD7:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_7);
        }   
        break;                                                  
    case LISTS_REASON_KCD8:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_8);
        }   
        break;                                              
    case LISTS_REASON_KCD9:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_9);
        }   
        break;
    default: break;
    }                           
}

void bookGroupingAddDestroy( MfwHnd window )
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookGroupingAddDestroy()" );

    if( data )
    {
        if( show_timer )
        {
            timStop(show_timer);
            timDelete(show_timer);
            show_timer=0;
        }
        if( edt_timer )
        {
            timStop(edt_timer);
            timDelete(edt_timer);
            edt_timer=0;
        }
        /* 2004/06/08 sunsj add */
        edtDelete( data->edt );
#if(MAIN_LCD_SIZE==3)
		phonebook_search_flag=FALSE;
#endif
        key_before=0xff;
        cursor_correct=1;
        key_index=0;
        winDelete( data->win );
        ClearWindowHandle();
        SetPhbkIN(0);
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }

}

T_MFW_HND bookGroupingBrowserStart( MfwHnd parent )
{
    T_MFW_HND      win;     


    if( ( win = bookGroupingBrowserCreate( parent ) ) == NULL ) return NULL;
    else
    {
        SetWindowsHandle(win);
        SetPhbkIN(1);
        SEND_EVENT (win, Grouping_BROWSERINIT, NULL, NULL);
    }                   
    return win;
}

static T_MFW_HND bookGroupingBrowserCreate(MfwHnd parent)
{
    T_MFW_WIN       *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    tBookStandard    *parent_data     = (tBookStandard *) parent_win_data->user;
    T_phbk          *phbk               = parent_data->phbk;
    //T_phbk			*phbk = (T_phbk *)parent_win_data->user;
    T_MFW_WIN       *win_data;
    tBookStandard   *data;

    TRACE_FUNCTION ("bookSearchCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookGroupingBrowserWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    // Okay, we have created the control block and the window, so
    // we now need to configure the dialog and data pointers	
    data->mmi_control.dialog    = (T_DIALOG_FUNC) bookGroupingBrowserDialog;
    data->mmi_control.data      = data;
    win_data                    = ((T_MFW_HDR *)data->win)->data;
    win_data->user              = (void *) data;
    data->phbk                  = phbk;
    data->parent_win            = parent;
#if(MAIN_LCD_SIZE==3)
	bookSetEditAttributes(20,85,32, 18,0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);//kashima
#elif (MAIN_LCD_SIZE==4)
    bookSetEditAttributes(20, 108, 32, 18, 0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#endif
    data->edt=edtCreate(data->win,&data->attr,0,0);
#ifndef FOR_FTA_CTA
    if( !show_timer )
        show_timer=timCreate(data->win,300,(MfwCb)show_timercb);
    if( !edt_timer )
        edt_timer=timCreate(data->win,500,(MfwCb)edt_timer_cb);
#endif
    /* 2004/06/29 sunsj modify for name table bug */
    //winShow(data->win); 
    return data->win;   
}

static void bookGroupingBrowserDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;
    T_MFW_HND      parent_win   =data->parent_win;
    U8              GetFlag,GetIndex;
    int              i,j;
    char            * titleStr;
    UBYTE oldmode=dspl_Enable(0);
    TRACE_FUNCTION( "bookGroupingBrowserDialog()" );

    switch( event )
    {
    case Grouping_BROWSERINIT:
        {   
            for( i=0,SearchTotal=0;i<PHBKTotal;i++ )
            {
                GetFlag=(l_phb_index[l_phb_sort_index[i].index].flag) & 0x0F;
                GetIndex=Phbk->select_index & 0x0F;

                if( (l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL) && (GetFlag==GetIndex) )
                {
                    bookname[SearchTotal].index=l_phb_sort_index[i].index;
                    SearchTotal=SearchTotal+1;
                }
            }

            Phbk->BufferIndex=0;
            Phbk->BufferTable=SearchTable;
            if( SearchTotal <= PHONEBOOK_RECORD_PERPAGE )
            {
                for( i=0;i<SearchTotal;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                                        
                }    
            }
            else
            {
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                                                            
                }    
            }    


            data->menu_list_data= (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( (!data->menu_list_data) || (! GetFree(SearchTotal)) )
            {
                if( ! GetFree(SearchTotal) )
                    bookShowInformation( win, TxtEmptyList, NULL, NULL );
                bookGroupingBrowserDestroy( win );
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(SearchTotal) * sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    //begin added by xzy for grouping icon 2002/11/1

                    for( i = 0; i < GetFree(SearchTotal); i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        if( IconSelect==9 )
                        {
                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 15);//&BookGroupingIcon[15];
                        }
                        else
                        {
                            if( FFS_PBOtherData.GroupingItem[i].GroupingIcon-85 <= 14 && FFS_PBOtherData.GroupingItem[i].GroupingIcon-85 >= 0 )
                            {
                                data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, FFS_PBOtherData.GroupingItem[i].GroupingIcon-85);
                            }
                            else
                            {
                                data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_NVMBOOK, 0);
                            }
                            /*
                                        switch( FFS_PBOtherData.GroupingItem[IconSelect].GroupingIcon-85 )
                                        {
                                        
                                        case 0:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 0);//&BookGroupingIcon[0];
                                            break;
                                        case 1:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 1);//&BookGroupingIcon[1];
                                            break;                          
                                        case 2:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 2);//&BookGroupingIcon[2];
                                            break;                          
                                        case 3:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 3);//&BookGroupingIcon[3];
                                            break;
                                        case 4:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 4);//&BookGroupingIcon[4];
                                            break;
                                        case 5:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 5);//&BookGroupingIcon[5];
                                            break;
                                        case 6:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 6);//&BookGroupingIcon[6];
                                            break;
                                        case 7:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 7);//&BookGroupingIcon[7];
                                            break;
                                        case 8:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 8);//&BookGroupingIcon[8];
                                            break;
                                        case 9:     
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 9);//&BookGroupingIcon[9];
                                            break;
                                        case 10:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 10);//&BookGroupingIcon[10];
                                            break;
                                        case 11:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 11);//&BookGroupingIcon[11];
                                            break;
                                        case 12:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 12);//&BookGroupingIcon[12];
                                            break;
                                        case 13:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 13);//&BookGroupingIcon[13];
                                            break;
                                        case 14:        
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, 14);//&BookGroupingIcon[14];
                                            break;
                                        default:
                                            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_NVMBOOK, 0);//&nvmbookicon;
                                            break;
                                        }
                            */
                        }

                        //end added by xzy for grouping icon 2002/11/1

                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit =  0;
                        data->menu_list_data->List[i].menu =0;
                        data->menu_list_data->List[i].func = NULL;                        
                        data->menu_list_data->List[i].str=(char *)DynamicBuffer[i].name;
                        data->menu_list_data->List[i].flagFunc = item_flag_none;
                    }

                    data->menu_list_data->ListLength     = GetFree(SearchTotal);
                    data->menu_list_data->ListPosition    = 1;
                    data->menu_list_data->CursorPosition = 1;
                    data->menu_list_data->SnapshotSize  = GetFree(SearchTotal);
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtDelete;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &readName_menuAttrib; 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;
                    titleStr=MmiRsrcGetText(TxtBrowserMember);
                    data->menu_list_data->ListMenuHeadStr=titleStr;
                    if( (int)parameter!=0 )
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                    }
                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookGroupingBrowserRead_cb,0);

                    /* 2004/06/29 sunsj modify for group select */
                    winShow(data->win);

                    refresh_flag=1;
#if(MAIN_LCD_SIZE==4)
					dspl_Clear(0,108, SCREEN_SIZE_X, 126);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
                    /* 2004/05/26 sunsj modify */
                    dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
                    show_index=bookname[Phbk->BufferIndex].index;
                    show_number();
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ
                    bookGroupingBrowserDestroy( win );                   
                }
            }           
        }
        break;                  
    default: break;
    }
    dspl_Enable(oldmode);
}

static int bookGroupingBrowserWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard   *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookSearchWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            edtShow(data->edt);
            edtChar(data->edt,ecBottom);
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

static void bookGroupingBrowserRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user; 
    T_phbk           * Phbk     = data->phbk;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;
    int               i,j;
    U8               GetFlag,GetIndex;

    int Index;

    TRACE_FUNCTION("bookgroupingbrowserread_cb");
    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {         
            timStop(show_timer);
            timStop(edt_timer);
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            Index=bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;
            if( CurrentTable!=Index/PHB_table_len )
            {
                if( flash_PBread(PBTable[Index/PHB_table_len])!=0 )
                    CurrentTable=Index/PHB_table_len;
            }
            l_phb_index[Index].flag=(l_phb_index[Index].flag & 0xF0) | 0x0F;
            /* 2004/03/26 sunsj add for save change of group */
            FFS_PBData.NVMBook[Index%PHB_table_len].info=l_phb_index[Index].flag;
            /*           dspl_ClearAll();
                       dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);*///2003/12/1, wangyan modify
            flash_PBwrite(PBTable[CurrentTable]);

            bookShowInformation(data->win,TxtDelMember,NULL,(T_VOID_FUNC)book_DelMember_cb);       
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                         

        } 
        break;
    case LISTS_REASON_UP:
        {
            if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                mnuUp(dataInfo->MenuLists);
                show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal)+1; 
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);              
                }   
                mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                show_index=bookname[(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1+SearchTotal)%SearchTotal].index;
                show_number();
            } 
        } 
        break;
    case LISTS_REASON_DOWN:
        {
#if(MAIN_LCD_SIZE==3)
			phonebook_search_flag=TRUE;
#endif
            if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                mnuDown(dataInfo->MenuLists);
                show_index=bookname[(Phbk->BufferIndex+ListData->CursorPosition+1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex)%SearchTotal)+1; 
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(Phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);

                }   
                mnuChooseVisibleItem(dataInfo->MenuLists,0);
                show_index=bookname[(Phbk->BufferIndex+SearchTotal)%SearchTotal].index;
                show_number();
            } 
        }
        break;
    case LISTS_REASON_BACK:
        //case LISTS_REASON_CLEAR:
        if( wstrlen(data->edtBuf)==0 )
        {
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List, GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));             
            bookGroupingBrowserDestroy(data->win);
        }
        else
            edtChar(data->edt,ecBack);
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //		break;
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);
            FREE_MEMORY((void *)data->menu_list_data->List, GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                
            bookGroupingBrowserDestroy(data->win);
        } 
        break;
    case LISTS_REASON_UPDATE:
        {
#if(MAIN_LCD_SIZE==4)
			dspl_Clear(0,108, SCREEN_SIZE_X, 126);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
			dspl_Clear(0, 72, SCREEN_SIZE_X, 110);//kashima
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
			ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,NONE);
            edtChar(data->edt,ecBottom);
        }
        break;
    case LISTS_REASON_LEFT:
        {
            if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
        } 
        break;
    case LISTS_REASON_RIGHT:
        {
            if( l_phb_index[bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(bookname[(Phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
        } 
        break;
    case LISTS_REASON_KCD0:
        {
        }                     
        break;                                             
    case LISTS_REASON_KCD1:                                            
        {
        }   
        break;
    case LISTS_REASON_KCD2:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_2);
        }   
        break;                                              
    case LISTS_REASON_KCD3: 
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_3);
        }   
        break;
    case LISTS_REASON_KCD4:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_4);
        }   
        break;                                                                                                 
    case LISTS_REASON_KCD5:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_5);
        }   
        break;                                                 
    case LISTS_REASON_KCD6:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_6);
        }   
        break;                                              
    case LISTS_REASON_KCD7:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_7);
        }   
        break;                                                  
    case LISTS_REASON_KCD8:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_8);
        }   
        break;                                              
    case LISTS_REASON_KCD9:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_9);
        }   
        break;
    default: break;
    }                    
}

void bookGroupingBrowserDestroy( MfwHnd window )
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookGroupingBrowserDestroy()" );

    if( data )
    {
        if( show_timer )
        {
            timStop(show_timer);
            timDelete(show_timer);
            show_timer=0;
        }
        if( edt_timer )
        {
            timStop(edt_timer);
            timDelete(edt_timer);
            edt_timer=0;
        }
        key_before=0xff;
        cursor_correct=1;
        key_index=0;
        winDelete( data->win );
        ClearWindowHandle();
        SetPhbkIN(0);
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

T_MFW_HND  bookGroupingRenameStart( MfwHnd parent,void *buffer )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) parent )->data;
    tBookStandard     *data       = (tBookStandard *) win_data->user;
    T_phbk           *Phbk       = data->phbk;
    T_EDITOR_DATA   DefaultParameters;
    T_MFW_HND       win;

    //return bookGroupingBrowserStart(parent);
    DefaultParameters.hide                 =FALSE;
    DefaultParameters.min_enter            =1;  
    DefaultParameters.Identifier             =0xFFFF;
    DefaultParameters.timeout           = FOREVER;  // Avoid returning empty strings
    DefaultParameters.destroyEditor     = FALSE; 
    DefaultParameters.editor_attr.text  = (char *)buffer;
    DefaultParameters.TextId               = TxtRename;                                              
    DefaultParameters.LeftSoftKey       = TxtSoftOK;
    DefaultParameters.RightSoftKey      = TxtDelete;        
    DefaultParameters.mode              = TEXTINPUT_MODE;// PARADISE_MODE;	/* 2003/12/04 sunsj modify for new editor mode */
    DefaultParameters.Callback          = (T_EDIT_CB)bookGroupingRenameCB;

    if( ( win = bookGroupingRenameCreate( parent ) ) != NULL )
        SEND_EVENT( win, INPUT_INIT, 0, &DefaultParameters);
    return win;
}

static T_MFW_HND bookGroupingRenameCreate( MfwHnd parent )
{
    T_MFW_WIN        *parent_win_data    = ( (T_MFW_HDR *) parent )->data;
    tBookStandard     *parent_data        = (tBookStandard *) parent_win_data->user;
    T_phbk           *phbk               = parent_data->phbk;
    T_MFW_WIN        *win_data;
    tBookStandard    *data;

    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookGroupingRenameWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *)data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog = (T_DIALOG_FUNC) bookGroupingRenameDialog;
    data->mmi_control.data   = data;
    win_data                 = ((T_MFW_HDR *)data->win)->data;
    win_data->user           = (void *) data;
    data->phbk               = phbk;
    data->parent_win         = parent;

    winShow(data->win);

    return data->win;
}

static void bookGroupingRenameDialog(T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{
    T_MFW_WIN        *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard    *data       = (tBookStandard *) win_data->user;
    T_EDITOR_DATA   *editor_data = (T_EDITOR_DATA *) parameter;

    switch( event )
    {
    case INPUT_INIT:
        {   
            editor_attr_init_fullscr(&data->editor_data.editor_attr,1,editor_data->TextId,NULL,GroupingName_len,edtCurBar1); 
            data->editor_data.hide             = editor_data->hide;
            data->editor_data.min_enter        = editor_data->min_enter;
            data->editor_data.Identifier       = editor_data->Identifier;
            data->editor_data.timeout          = editor_data->timeout;
            data->editor_data.destroyEditor    = editor_data->destroyEditor;
            data->editor_data.editor_attr.text = editor_data->editor_attr.text;
            data->editor_data.TextId           = editor_data->TextId;
            data->editor_data.LeftSoftKey      = editor_data->LeftSoftKey;
            data->editor_data.RightSoftKey     = editor_data->RightSoftKey;
            data->editor_data.mode             = editor_data->mode;
            data->editor_data.Callback         = editor_data->Callback;                     
            ////zgzTraceDataFunc("len of name",(unsigned short)wstrlen((char *)editor_data->editor_attr.text));
            /* 2003/12/04 sunsj modify for new editor mode */
            if( data->editor_data.mode == TEXTINPUT_MODE )
            {
                data->editor_data.InputMode    = PINYIN_INPUT_MODE;
                data->edt                      = text_input(win, &data->editor_data);
            }
            else
            {
                data->edt                      = editor_start(win, &data->editor_data);  /* start the editor */ 
            }
            winShow( data->win );
        }
        break;

    case INPUT_DESTROY:
        {           
            bookGroupingRenameDestroy( win );
        }
        break;
    }

}

static int bookGroupingRenameWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard *data = (tBookStandard *) w->user;

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {   

        }
        break;

    case MfwWinDelete:
        break;
    default: return MFW_EVENT_PASSED;       
    }

    return MFW_EVENT_CONSUMED;
}

void bookGroupingRenameDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;

    if( data )
    {
        if( data->edt )
        {
            /* 2003/12/04 sunsj modify for new editor mode */
            if( data->editor_data.mode == TEXTINPUT_MODE )
            {
                text_input_destroy(data->edt);
            }
            else
            {
                editor_destroy(data->edt);
            }
            data->edt=0;
        }
        winDelete ( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}
//------------------------------------------------------------------------------
//------------------------------ShortCutDial-------------------------------------
void bookShortCutDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter)
{   
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;
    T_MFW_HND      parent_win  =data->parent_win;
    int i;
    char * titleStr;
    unsigned char     backstr[21];
    UBYTE old_mode=dspl_Enable(0);
    MfwMnuAttr      name_list_attr;
    TRACE_FUNCTION( "bookShortCutDialog()" );

    switch( event )
    {
    case ShortCut_Item:
        {       
            for( i=0;i<MAX_ShortCutDial;i++ )
            {
                memset(DataItem[i].name,'\0',PHB_name_len);
                if( FFS_PBOtherData.ShortCutDial[i].name[0]=='\0' )
                    memcpy(DataItem[i].name,MmiRsrcGetText(TxtNullNumber),PHB_name_len);
                else memcpy(DataItem[i].name,FFS_PBOtherData.ShortCutDial[i].name,PHB_name_len);

            }

            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                bookShowInformation( win, TxtEmptyList, NULL, NULL );               
                bookShortCutDialDestroy( win );
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( MAX_ShortCutDial * sizeof(T_MFW_MNU_ITEM) );

                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < MAX_ShortCutDial; i++ )
                    {
                        /* 2004/06 sunsj modify for icon manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_LISTCOMMON, 0);//&colist;//2004-04-07 Sunny modify old: &nvmbookicon;
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit = 0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].func = NULL;
                        data->menu_list_data->List[i].str=(char *)DataItem[i].name;                     
                        data->menu_list_data->List[i].flagFunc = item_flag_none;                    
                    }

                    data->menu_list_data->ListLength     = MAX_ShortCutDial;
                    data->menu_list_data->ListPosition    = 1;
                    data->menu_list_data->CursorPosition = 1;
                    data->menu_list_data->SnapshotSize  = MAX_ShortCutDial;
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtModify;
                    data->menu_list_data->RightSoftKey   = TxtDelete;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &Shortcut_menuAttrib;
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;
                    titleStr=MmiRsrcGetText(TxtShortCutDial);
                    data->menu_list_data->ListMenuHeadStr=titleStr;
                    if( (int)parameter!=0 )
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                    }

                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookShortCutItemRead_cb,0);                  
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ
                    bookShortCutDialDestroy( win );                    
                }
            }           
        }
        break;
    case ShortCut_Browser:
        {                               
            data->menu_list_data2 = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( (!data->menu_list_data2) || (! PHBKTotal) )
            {
                if( ! PHBKTotal )
                {
                    if( data->menu_list_data2 )
                        FREE_MEMORY((void *)data->menu_list_data2,sizeof(ListMenuData));
                    bookShowInformation( win, TxtEmptyList, NULL, NULL );        
                }
            }
            else
            {
                if( PHBKTotal<=PHONEBOOK_RECORD_PERPAGE )
                {
                    for( i=0;i<PHBKTotal;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);                      
                        if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                }
                else
                {
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[i].index].name,PHB_name_len);                                         
                        if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[l_phb_sort_index[i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                }
                Phbk->BufferIndex=0;    
                Phbk->BufferTable=GlobalTable;
                SearchTotal=PHBKTotal;  
#if(MAIN_LCD_SIZE==3)
				phonebook_search_flag=TRUE;
#endif
                data->menu_list_data2->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(SearchTotal) * sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data2->List!=0 )
                {
                    for( i = 0; i < GetFree(SearchTotal); i++ )
                    {
                        data->menu_list_data2->List[i].icon = &DynamicBuffer[i].bookicon;
                        data->menu_list_data2->List[i].exta = 0;
                        data->menu_list_data2->List[i].edit = 0;
                        data->menu_list_data2->List[i].menu = 0;
                        data->menu_list_data2->List[i].func = NULL; 
                        data->menu_list_data2->List[i].str=(char *)DynamicBuffer[i].name;
                        data->menu_list_data2->List[i].flagFunc = item_flag_none; 
                    }

                    data->menu_list_data2->ListLength     = GetFree(SearchTotal);
                    data->menu_list_data2->ListPosition    = 1;
                    data->menu_list_data2->CursorPosition = 1;
                    data->menu_list_data2->SnapshotSize  = GetFree(SearchTotal);
                    data->menu_list_data2->Font          = 0;
                    data->menu_list_data2->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data2->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data2->KeyEvents     = KEY_ALL;
                    data->menu_list_data2->Reason        = 0;
                    data->menu_list_data2->Strings        = TRUE;
                    data->menu_list_data2->Attr           = &readName_menuAttrib; 
                    data->menu_list_data2->autoDestroy    = FALSE;
                    data->menu_list_data2->ListMenuFlag    =1;
                    titleStr=MmiRsrcGetText(TxtPhoneSelect);//ѡ
                    data->menu_list_data2->ListMenuHeadStr=titleStr;
                    if( (int)parameter!=0 )
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                    }
                    listDisplayListMenu(win, data->menu_list_data2, (ListCbFunc)bookShortCutBrowserRead_cb,0);
                    refresh_flag=1;
#if(MAIN_LCD_SIZE==4)
					dspl_Clear(0,108, SCREEN_SIZE_X, 126);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
                    /* 2004/05/26 sunsj modify */
                    dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
                    show_index=l_phb_sort_index[Phbk->BufferIndex].index;
                    show_number();
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data2,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ	                    
                }
            }           
        }
        break;
    default: break;
    }
    dspl_Enable(old_mode);
}

static int bookShortCutDialWindowCB( MfwEvt e,MfwWin *w)
{
    tBookStandard *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookSearchWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            //MmiBookShowDefault();//Clear Screen	
            edtShow(data->edt);
            edtChar(data->edt,ecBottom);
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

static T_MFW_HND bookShortCutDialCreate( MfwHnd parent )
{
    T_MFW_WIN        *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    tBookStandard    *parentdata=(tBookStandard *)parent_win_data->user;
    T_phbk           *phbk = parentdata->phbk;
    T_MFW_WIN        *win_data;
    tBookStandard    *data;

    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookShortCutDialWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog = (T_DIALOG_FUNC) bookShortCutDialog;
    data->mmi_control.data   = data;
    win_data                 = ((T_MFW_HDR *)data->win)->data;
    win_data->user           = (void *) data;
    data->phbk               = phbk;
    data->parent_win         = parent;

#if(MAIN_LCD_SIZE==3)
	bookSetEditAttributes(20,85,32, 18,0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#elif (MAIN_LCD_SIZE==4)
    bookSetEditAttributes(20, 108, 32, 18, 0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#endif
    data->edt=edtCreate(data->win,&data->attr,0,0);
#ifndef FOR_FTA_CTA
    if( !show_timer )
        show_timer=timCreate(data->win,300,(MfwCb)show_timercb);
    if( !edt_timer )
        edt_timer=timCreate(data->win,500,(MfwCb)edt_timer_cb);
#endif
    winShow(data->win);
    return data->win;
}

static void bookShortCutItemRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;
    unsigned char     backstr[23];
    UINT32  b_color,f_color;



    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {
            data->phbk->select_index=ListData->CursorPosition;
            SEND_EVENT(data->win,ShortCut_Browser,NULL,NULL);
        } 
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //		break;
            listsDestroy(ListData->win);                     
            FREE_MEMORY((void *)data->menu_list_data->List,MAX_ShortCutDial*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));          
            bookShortCutDialDestroy(data->win);
        }
        break;
    case LISTS_REASON_BACK:
        //case LISTS_REASON_CLEAR:
        //
        {
            if( FFS_PBOtherData.ShortCutDial[ListData->CursorPosition].name[0]=='\0' )//we return 
            {
                listsDestroy(ListData->win);                     
                FREE_MEMORY((void *)data->menu_list_data->List,MAX_ShortCutDial*sizeof(T_MFW_MNU_ITEM));
                FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));          
                bookShortCutDialDestroy(data->win);
            }
            else//we need delete this record
            {
                T_DISPLAY_DATA Dialog;
                TRACE_EVENT("press back,but delete");
                data->phbk->select_index=ListData->CursorPosition;
                dialog_info_init(&Dialog);//gdy add 
                Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
                Dialog.TextId     = 0;
                Dialog.TextId2    = TxtPhbkDelMess;
                Dialog.TextString  =  '\0';
                Dialog.TextString2  = '\0';
                Dialog.LeftSoftKey  = TxtSoftOK;
                Dialog.RightSoftKey = TxtCancel;
                Dialog.Time       = FOREVER;
                Dialog.Callback    = (T_VOID_FUNC) bookDeleteShortCutCB;
                Dialog.Identifier   = 0;
                Dialog.iconindex=REMIND_REQUIRE;
                info_dialog( Parent, &Dialog );
            }
        } 
        break;
    case LISTS_REASON_UP:
        {
            dataInfo->MenuListsAttr.pageturnindex=((ListData->CursorPosition-1+MAX_ShortCutDial)%MAX_ShortCutDial)+1;
            mnuUp(dataInfo->MenuLists);

            /* 2004/06/08 sunsj modify */
            //dspl_Clear(0, 108, SCREEN_SIZE_X, 126);
            //dspl_BitBlt(0, 110, 14, 14, 0, (void *)abc_bmp, 0);

            b_color=dspl_SetBkgColor(0xF8E0EE);
            f_color=dspl_SetFrgColor(0x000000);

            
#if(MAIN_LCD_SIZE==4)
			dspl_Clear (0,126,SCREEN_SIZE_X,142);
			UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial].number,backstr);
			dspl_TextOut(1, 126, 0, (char *)backstr);
#elif(MAIN_LCD_SIZE==3)
			//dspl_Clear (0,SEARCH_NUMBER_SHOW,SCREEN_SIZE_X,128);
			//UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial].number,backstr);
			//dspl_TextOut(1, SEARCH_NUMBER_SHOW, 0, (char *)backstr);
#endif
            
            dspl_SetFrgColor(f_color);
            dspl_SetBkgColor(b_color);

            ListData->CursorPosition=(ListData->CursorPosition-1+MAX_ShortCutDial)%MAX_ShortCutDial;
            if( FFS_PBOtherData.ShortCutDial[ListData->CursorPosition].name[0]=='\0' )
			{
                displaySoftKeys(TxtModify,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();
#endif
			}
            else
			{
                displaySoftKeys(TxtModify,TxtDelete);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();
#endif
			}
        }
        break;
    case LISTS_REASON_DOWN:
        {
            dataInfo->MenuListsAttr.pageturnindex=((ListData->CursorPosition+1)%MAX_ShortCutDial)+1;
            mnuDown(dataInfo->MenuLists);

            /* 2004/06/08 sunsj modify */
            //dspl_Clear(0, 108, SCREEN_SIZE_X, 126);
            //dspl_BitBlt(0, 110, 14, 14, 0, (void *)abc_bmp, 0);

            b_color=dspl_SetBkgColor(0xF8E0EE);
            f_color=dspl_SetFrgColor(0x000000);

#if(MAIN_LCD_SIZE==4)
			dspl_Clear (0,126,SCREEN_SIZE_X,142);
			UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial].number,backstr);
			dspl_TextOut(1, 126, 0, (char *)backstr);
#elif(MAIN_LCD_SIZE==3)
			//dspl_Clear (0,SEARCH_NUMBER_SHOW,SCREEN_SIZE_X,128);
			//UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial].number,backstr);
			//dspl_TextOut(1, SEARCH_NUMBER_SHOW, 0, (char *)backstr);
#endif
            dspl_SetFrgColor(f_color);
            dspl_SetBkgColor(b_color);

            ListData->CursorPosition=(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial;
            if( FFS_PBOtherData.ShortCutDial[ListData->CursorPosition].name[0]=='\0' )
			{
                displaySoftKeys(TxtModify,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();
#endif
			}
            else
			{
                displaySoftKeys(TxtModify,TxtDelete);
#if(MAIN_LCD_SIZE==3)
				draw_softkeybar_updown_arrow();
#endif
			}

        } 
        break;
    case LISTS_REASON_UPDATE:
        {
            /* 2004/06/08 sunsj modify */
            //dspl_Clear(0, 108, SCREEN_SIZE_X, 126);
            //dspl_BitBlt(0, 110, 14, 14, 0, (void *)abc_bmp, 0);

            b_color=dspl_SetBkgColor(0xF8E0EE);
            f_color=dspl_SetFrgColor(0x000000);

#if(MAIN_LCD_SIZE==4)
			dspl_Clear (0,126,SCREEN_SIZE_X,142);
			UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial].number,backstr);
			dspl_TextOut(1, 126, 0, (char *)backstr);
#elif(MAIN_LCD_SIZE==3)
			dspl_Clear (0,SEARCH_NUMBER_SHOW,SCREEN_SIZE_X,128);
			UnCompressNum((char *)FFS_PBOtherData.ShortCutDial[(ListData->CursorPosition+1+MAX_ShortCutDial)%MAX_ShortCutDial].number,backstr);
			dspl_TextOut(1, SEARCH_NUMBER_SHOW, 0, (char *)backstr);
#endif
            dspl_SetFrgColor(f_color);
            dspl_SetBkgColor(b_color);
#if(MAIN_LCD_SIZE==4)            
			if ( FFS_PBOtherData.ShortCutDial[ListData->CursorPosition].name[0]=='\0' )
                displaySoftKeys(TxtModify,TxtSoftBack);
            else
                displaySoftKeys(TxtModify,TxtDelete);
#elif (MAIN_LCD_SIZE==3)
            if ( FFS_PBOtherData.ShortCutDial[ListData->CursorPosition].name[0]=='\0' )
			{
#if(MAIN_LCD_SIZE==3)
			    phonebook_search_flag=FALSE;
#endif
				displaySoftKeys(TxtModify,TxtSoftBack);
			    draw_softkeybar_updown_arrow();
			}
            else
			{
#if(MAIN_LCD_SIZE==3)
			    phonebook_search_flag=FALSE;
#endif
				displaySoftKeys(TxtModify,TxtDelete);
				draw_softkeybar_updown_arrow();
			}
#endif
        }
        break;
    default: break;
    }    

}

static void bookShortCutBrowserRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN         * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard       * data     = (tBookStandard  *)win_data->user;
    T_phbk             * phbk     = data->phbk;

    T_MFW_WIN         * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo          * dataInfo = (ListWinInfo *)windata->user;

    T_MFW_PHB_ENTRY   l_phb_Shortentry;
    T_MFW_PHB_LIST     l_phb_list;  /* phonebook list */
    int                  Index,i;
    U8                  SaveNumber[(PHB_number_len/2)+2];
    T_MFW              ret;


    switch( ListData->Reason )
    {
    case LISTS_REASON_SEND:
        {
        } 
        break;
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {
            timStop(show_timer);
            timStop(edt_timer);
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
            {
                Index=l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;
                if( CurrentTable!=Index/PHB_table_len )
                {
                    CurrentTable=Index/PHB_table_len;        
                    flash_PBread(PBTable[CurrentTable]);
                }
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        memcpy(SaveNumber,FFS_PBData.NVMBook[Index%PHB_table_len].number,(PHB_name_len/2)+1); 
                    }
                    break;
                case B_HOME:
                    {
                        memcpy(SaveNumber,FFS_PBData.NVMBook[Index%PHB_table_len].home,(PHB_name_len/2)+1);
                    } 
                    break;
                case B_OFFICE:
                    {
                        memcpy(SaveNumber,FFS_PBData.NVMBook[Index%PHB_table_len].office,(PHB_name_len/2)+1);
                    } 
                    break;
                case B_MEMO:
                    {
                        TRACE_EVENT("select the memo");
                        memset(SaveNumber,0,sizeof(SaveNumber));
                    }
                    break;
                default: break;
                }
                if( wstrlen(SaveNumber)!=0 )
                {
                    //flash_PBOtherRead("PBOption");
                    TRACE_EVENT((char *)SaveNumber);
                    memcpy(FFS_PBOtherData.ShortCutDial[data->phbk->select_index].name,l_phb_index[Index].name,PHB_name_len);                
                    memcpy(FFS_PBOtherData.ShortCutDial[data->phbk->select_index].number,SaveNumber,(PHB_number_len/2)+1);
                    memcpy(DataItem[data->phbk->select_index].name,l_phb_index[Index].name,PHB_name_len);

                    flash_PBOtherWrite("PBOption");

                    //flash_PBread(PBTable[CurrentTable]); yq deleted 2003/2/12,need't read phb 
                    listsDestroy(ListData->win);                     
                    FREE_MEMORY((void *)data->menu_list_data2->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                    FREE_MEMORY((void *)data->menu_list_data2,sizeof(ListMenuData)); 
                }

            }
            else if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
            {
                Index=l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;                       
                // flash_PBOtherRead("PBOption");	//hxl moved this to ffsfile_init 2002-11-26

                memcpy(FFS_PBOtherData.ShortCutDial[data->phbk->select_index].name,l_phb_index[Index].name,PHB_name_len);             
                memcpy(DataItem[data->phbk->select_index].name,l_phb_index[Index].name,PHB_name_len);
                memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                memset(&l_phb_list,0,sizeof(l_phb_list));

                l_phb_list.entry=&l_phb_Shortentry;
                l_phb_list.num_entries=1;

                ret=phb_read_entries(PHB_ADN,l_phb_index[Index].index,MFW_PHB_PHYSICAL,1,&l_phb_list);//Index+1-ALL_NVM_LIST
                if( ret==MFW_PHB_OK )
                {
                    CompressNum((char *)l_phb_Shortentry.number,FFS_PBOtherData.ShortCutDial[data->phbk->select_index].number);            
                }
                flash_PBOtherWrite("PBOption");
                //flash_PBread(PBTable[CurrentTable]);
                listsDestroy(ListData->win);                    
                FREE_MEMORY((void *)data->menu_list_data2->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                FREE_MEMORY((void *)data->menu_list_data2,sizeof(ListMenuData)); 
            }
        } 
        break;
    case LISTS_REASON_BACK:  
        if( wstrlen(data->edtBuf)==0 )
        {
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);                   
            FREE_MEMORY((void *)data->menu_list_data2->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data2,sizeof(ListMenuData)); 
        }
        else
            edtChar(data->edt,ecBack);
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //		break;
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);                     
            FREE_MEMORY((void *)data->menu_list_data2->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data2,sizeof(ListMenuData)); 
        } 
        break;
    case LISTS_REASON_UPDATE:
        {
#if(MAIN_LCD_SIZE==4)
			dspl_Clear(0,108, SCREEN_SIZE_X, 126);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
			/* 2004/05/26 sunsj modify */
			dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
            show_index=l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index;
            ShowPhoneBookNumber(show_index,NONE);
            edtChar(data->edt,ecBottom);
            //show_number();
        } 
        break;
    case LISTS_REASON_UP:
        {
            if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                mnuUp(dataInfo->MenuLists);  
                show_index=l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                phbk->BufferIndex=(phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal)+1;  
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    /* 2004/06 sunsj modify for picture manage */
                    memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[(phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                    if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                        DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                    else if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                        DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                }    
                mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                show_index=l_phb_sort_index[(phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1+SearchTotal)%SearchTotal].index;
                show_number();
            }   
        }   
        break;
    case LISTS_REASON_DOWN:
        {
            if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                mnuDown(dataInfo->MenuLists);  
                show_index=l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition+1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                phbk->BufferIndex=(phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex)%SearchTotal)+1; 
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    /* 2004/06 sunsj modify for picture manage */
                    memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[(phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                    if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+i)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                        DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                    else if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+i)%SearchTotal].index].phonebook==SIM_BOOK_SEL )
                        DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                }    
                mnuChooseVisibleItem(dataInfo->MenuLists,0);
                show_index=l_phb_sort_index[(phbk->BufferIndex+SearchTotal)%SearchTotal].index;
                show_number();
            }           
        } 
        break;
    case LISTS_REASON_LEFT:
        {
            if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
        } 
        break;
    case LISTS_REASON_RIGHT:
        {
            if( l_phb_index[l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(l_phb_sort_index[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
        } 
        break;      
    case LISTS_REASON_KCD0:
        {
        }                     
        break;                                             
    case LISTS_REASON_KCD1:                                            
        {
        }   
        break;
    case LISTS_REASON_KCD2:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_2);
        }   
        break;                                              
    case LISTS_REASON_KCD3: 
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_3);
        }   
        break;
    case LISTS_REASON_KCD4:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_4);
        }   
        break;                                                                                                 
    case LISTS_REASON_KCD5:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_5);
        }   
        break;                                                 
    case LISTS_REASON_KCD6:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_6);
        }   
        break;                                              
    case LISTS_REASON_KCD7:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_7);
        }   
        break;                                                  
    case LISTS_REASON_KCD8:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_8);
        }   
        break;                                              
    case LISTS_REASON_KCD9:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_9);
        }   
        break;
    default: break;
    }                           
}

T_MFW_HND bookShortCutDialStart( MfwHnd parent )
{
    T_MFW_HND       win;


    if( ( win = bookShortCutDialCreate( parent ) ) == NULL ) return NULL;
    else
    {
        SetWindowsHandle(win);
        SetPhbkIN(1);
        SEND_EVENT(win,ShortCut_Item,NULL,NULL);
    }

    return win;   
}

void bookShortCutDialDestroy( MfwHnd window )
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookShortCutDialDestroy()" );

    // Only destroy if the data is valid	
    if( data )
    {
        // If we're the root window we destroy using it's function
        if( show_timer )
        {
            timStop(show_timer);
            timDelete(show_timer);
            show_timer=0;
        }
        if( edt_timer )
        {
            timStop(edt_timer);
            timDelete(edt_timer);
            edt_timer=0;
        }
        key_before=0xff;
        cursor_correct=1;
        key_index=0;
        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );
            return;
        }

        /* 2004/06/08 sunsj add */
        edtDelete( data->edt );

        // delete ourself		
        data->phbk->shortcutdial_win= 0;
        winDelete( data->win );
        ClearWindowHandle();
        SetPhbkIN(0);
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

static void bookCopyAllSimToNvmStart(T_MFW_HND Window,USHORT TxtContent)
{
    T_DISPLAY_DATA Dialog;

    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = TxtContent;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookMultiCopySimToNvmCB;
    Dialog.Identifier   = 0;   
    Dialog.iconindex=REMIND_REQUIRE;
    if( TxtContent==TxtPhbkNVMCopyError )
    {
        //       Dialog.TextId     = TxtPhbkNVMCopyError;
        //        Dialog.TextId2    = TxtPhbkCopyMess;/*2003/12/3, wangyan modify*/
    }
    info_dialog( Window, &Dialog );
}

static void bookCopyAllNvmToSimStart(T_MFW_HND Window,USHORT TxtContent)
{
    T_DISPLAY_DATA Dialog;

    dialog_info_init(&Dialog);//gdy add 
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = TxtContent;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookMultiCopyNvmToSimCB;
    Dialog.Identifier   = 0;  
    Dialog.iconindex=REMIND_REQUIRE;
    if( TxtContent==TxtPhbkSIMCopyError )
    {
        //       Dialog.TextId     = TxtPhbkSIMCopyError;
        //        Dialog.TextId2    = TxtPhbkCopyMess;/*2003/12/3, wangyan modify*/
    }
    info_dialog( Window, &Dialog );
}

T_MFW_HND bookCopyAllStart( MfwHnd parent, T_CopyWay  NewCopyWay )//NVMToSIM,SIMToNVM
{
    T_MFW_HND         win;

    if( ( win = bookCopyAllCreate( parent ) ) == NULL ) return NULL;
    else
    {
        //CopyWay=NewCopyWay;
        SEND_EVENT(win,NewCopyWay,NULL,NULL);
    }
    return win; 
}

static T_MFW_HND bookCopyAllCreate( MfwHnd parent )
{
    T_MFW_WIN        *parent_win_data = ( (T_MFW_HDR *) parent )->data;   
    tBookStandard     *parent_data        = (tBookStandard *) parent_win_data->user;
    T_phbk           *phbk               = parent_data->phbk;
    T_MFW_WIN        *win_data;
    tBookStandard    *data;

    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookCopyAllWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog = (T_DIALOG_FUNC) bookCopyAllDialog;
    data->mmi_control.data   = data;
    win_data         = ((T_MFW_HDR *)data->win)->data;
    win_data->user       = (void *) data;
    data->phbk           = phbk;
    data->parent_win     = parent;

    //    data->copy_tim=tim_create(data->win,100, (T_MFW_CB)book_copytim_cb);    
    data->copy_tim=tim_create(data->win,500, (T_MFW_CB)book_copytim_cb); /*2003/12/3, wangyan modify*/   
    winShow(data->win);

    return data->win;
}

static int bookCopyAllWindowCB( MfwEvt e, MfwWin *w)
{
    tBookStandard *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookSearchWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            //	 MmiBookShowDefault();//Clear Screen
            //	 dspl_TextOut(50,100,0,MmiRsrcGetText(TxtPhbkCopying));			 
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

static void bookCopyAllDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    //tBookStandard	*data		= (tBookStandard *) win_data->user;
    //T_phbk          *Phbk           = data->phbk;

    T_MFW_PHB_STATUS  status;

    TRACE_FUNCTION( "bookChoiceCopyNVMToSIMDialog()" );

    switch( event )
    {
    case NVMToSIM:
        {                 
            if( !NVMTotal )
            {
                bookShowInformation( win, TxtPhbkNvmEmpty, NULL,(T_VOID_FUNC)book_copytim_information);             
            }
            else
            {
                status.book=PHB_ADN;   
                if( phb_get_status(&status)==MFW_PHB_OK )
                {
                    if( status.avail_entries==0 )
                    {
                        bookShowInformation( win, TxtPhbkSimFull, NULL,(T_VOID_FUNC)book_copytim_information);                          
                    }
                    else
                    {
                        if( NVMTotal<=status.avail_entries )
                            bookCopyAllNvmToSimStart(win,TxtPhbkCopyMess);
                        else
                            bookCopyAllNvmToSimStart(win,TxtPhbkSIMCopyError);                
                    }
                }
            }                   
        }
        break;
    case SIMToNVM:
        {

            status.book=PHB_ADN;   
            if( phb_get_status(&status)==MFW_PHB_OK )
            {
                if( !status.used_entries )
                    bookShowInformation( win, TxtPhbkSimEmpty, NULL,(T_VOID_FUNC)book_copytim_information);
                else if( NVMTotal>=ALL_NVM_LIST )
                    bookShowInformation( win, TxtPhbkNvmFull,NULL,(T_VOID_FUNC)book_copytim_information);
                else
                {
                    //glowing, 2003/11/21, modify status.avail_entries as status.used_entries
                    //if ( status.avail_entries<=ALL_NVM_LIST-NVMTotal )
                    if( status.used_entries<=ALL_NVM_LIST-NVMTotal )
                        bookCopyAllSimToNvmStart(win,TxtPhbkCopyMess);
                    else bookCopyAllSimToNvmStart(win,TxtPhbkNVMCopyError);
                    winShow(win);
                }  
            }
        }
        break;
    }


}

void bookCopyAllDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookChoiceCopyDestroy()" );

    // Only destroy if the data is valid	
    if( data )
    {
        // If we're the root window we destroy using it's function		
        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );
            return;
        }
        timDelete( data->copy_tim );       
        winDelete( data->win );               
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

#if 0  /*2003/12/1, wangyan modify*/
static void bookMultiCopyNvmToSimCB(T_MFW_HND win, USHORT id, UBYTE reason )
{
    T_MFW_WIN          *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard        *data       = (tBookStandard *)win_data->user;
    T_phbk              *phbk       = (T_phbk *)data->phbk;

    T_MFW_PHB_ENTRY    l_phb_Shortentry;
    T_MFW_PHB_STATUS   status;   
    int                  Index,i;
    char                info[30];
    UINT32  b_color;
    T_MFW_PHB_RETURN   retvalue;            

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            MmiBookShowDefault();//Clear Screen

            wstrcpy(info,(char *)MmiRsrcGetText(TxtPhbkCopying));
            wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
            b_color=dspl_SetFrgColor(0xff0000);
            dspl_TextOut(10,40,0,info);

            dspl_SetFrgColor(b_color);
            //  if (NVMTotal<ALL_NVM_LIST)
            {                 
                CopyNumber=0;
                for( i=0;i<PHBKTotal;i++ )
                {
                    if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                    {
                        Index=l_phb_sort_index[i].index;

                        if( CurrentTable!=Index/PHB_table_len )
                        {
                            flash_PBread(PBTable[Index/PHB_table_len]);
                            CurrentTable=Index/PHB_table_len;                    
                        }

                        memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                        l_phb_Shortentry.book=bookActiveBook(WRITE);
                        status.book=l_phb_Shortentry.book;

                        memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len);
                        l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                        //================================================================================================                      
                        switch( CheckFirstNumFlag(Index) )
                        {
                        case 0x01:
                            if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                            break;  
                        case 0x02:
                            if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                            break;
                        case 0x03:
                            if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                            break;
                            //================================================================================================                                  
                        }    

                        phonebookstatus=COPYINGALL;

                        switch( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&status) )
                        {
                        case MFW_PHB_OK :
                            {                              
                                CopyResult.CopyEnd=FALSE;
                                CopyResult.complete=0xF0;
                                CopyNumber=CopyNumber+1;                        
                                timStart(data->copy_tim);                                                                        
                            }
                            break;                      
                        default: break;    
                        }
                        Copyidx=i+1;
                        break;              
                    }
                }                                                           
            }             
        }
        break;   
    case INFO_KCD_RIGHT:
        bookCopyAllDestroy(win);
        break;
    default: break;
    }              
}
#endif /*2003/12/1, wangyan modify*/

static void book_copy_remove_show(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  * data     = (tBookStandard *) win_data->user;
    T_phbk         * Phbk       =data->phbk;

    switch( reason )
    {
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        {            
            bookCopyAllDestroy(win);
        }      
        break;                                                   
    default: break;
    }
}

static void bookMultiCopyNvmToSimCB(T_MFW_HND win, USHORT id, UBYTE reason )
{
    T_MFW_WIN          *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard        *data       = (tBookStandard *)win_data->user;
    T_phbk              *phbk       = (T_phbk *)data->phbk;

    T_MFW_PHB_ENTRY    l_phb_Shortentry;
    T_MFW_PHB_STATUS   status;   
    int                  Index,i;
    char                info[30];
    UINT32  b_color;
    T_MFW_PHB_RETURN   retvalue;            

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            /*           MmiBookShowDefault();//Clear Screen
           
                       wstrcpy(info,(char *)MmiRsrcGetText(TxtPhbkCopying));
                       wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
                       b_color=dspl_SetFrgColor(0xff0000);
                       dspl_TextOut(10,40,0,info);
           
                       dspl_SetFrgColor(b_color);*//*2003/12/3, wangyan modify*/
            memset(info,0,30);
            wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
            bookShowPhbkInformation(data->win, 0, info, (T_VOID_FUNC)book_copy_remove_show);
            memset(info,0,30);     
            //  if (NVMTotal<ALL_NVM_LIST)
            {                 
                CopyNumber=0;
                for( i=0;i<PHBKTotal;i++ )
                {
                    if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                    {
                        Index=l_phb_sort_index[i].index;

                        if( CurrentTable!=Index/PHB_table_len )
                        {
                            flash_PBread(PBTable[Index/PHB_table_len]);
                            CurrentTable=Index/PHB_table_len;                    
                        }

                        memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                        l_phb_Shortentry.book=bookActiveBook(WRITE);
                        status.book=l_phb_Shortentry.book;

                        memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[Index%PHB_table_len].name,PHB_name_len);
                        l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                        //================================================================================================                      
                        switch( CheckFirstNumFlag(Index) )
                        {
                        case 0x01:
                            if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                            break;  
                        case 0x02:
                            if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                            break;
                        case 0x03:
                            if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].office,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].number,l_phb_Shortentry.number);
                            else if( wstrlen((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home)!=0 )
                                UnCompressNum((char *)FFS_PBData.NVMBook[Index%PHB_table_len].home,l_phb_Shortentry.number);
                            break;
                            //================================================================================================                                  
                        }    

                        phonebookstatus=COPYINGALL;

                        switch( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&status) )
                        {
                        case MFW_PHB_OK :
                            {                              
                                CopyResult.CopyEnd=FALSE;
                                CopyResult.complete=0xF0;
                                CopyNumber=CopyNumber+1;                        
                                timStart(data->copy_tim);                                                                        
                            }
                            break;                      
                        default: break;    
                        }
                        Copyidx=i+1;
                        break;              
                    }
                }                                                           
            }             
        }
        break;   
    case INFO_KCD_RIGHT:
        bookCopyAllDestroy(win);
        break;
    default: break;
    }              
}

static T_MFW_CB book_copytim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       = (tBookStandard *) win_data->user;  
    T_phbk           *phbk= (T_phbk *)data->phbk;
    char              info[30];

    TRACE_EVENT("book_copytim_cb");
    timStop(data->copy_tim);
    if( CopyResult.CopyEnd==FALSE )
    {
        TRACE_EVENT("copy not finished!");
        timStart(data->copy_tim);
        //winShow(data->win);
    }
    else
    {
        TRACE_EVENT("copy finished");
        if( CopyNumber!=0 )
        {
            sprintf(info,"%d",CopyNumber);
            wstrcat((char *)info, MmiRsrcGetText(TxtPhbkCopy));                   
            bookShowPhbkInformation(data->win,NULL,info,(T_VOID_FUNC)book_copytim_information);               
        }
        else
        {
            TRACE_EVENT("copy no one");
            bookShowInformation(data->win, TxtCopyFail , NULL,(T_VOID_FUNC)book_copytim_information);
        } 
    }
    return 0;
}

static void book_copytim_information(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  * data     = (tBookStandard *) win_data->user;
    T_phbk         * Phbk       =data->phbk;

    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {            
            timStop(data->copy_tim);
            bookCopyAllDestroy(win);
        }      
        break;                                                   
    default: break;
    }
}

static void bookMultiCopySimToNvmCB(T_MFW_HND win, USHORT id, UBYTE reason )
{
    T_MFW_WIN         *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard       *data       =(tBookStandard *)win_data->user;
    T_phbk             *phbk       =(T_phbk *)data->phbk;

    T_MFW_PHB_ENTRY   l_phb_Shortentry;              
    int                  i,j;
    char                info[30];
    UINT32  b_color;
    switch( reason )
    {
    case INFO_KCD_LEFT:
        {     
            /*       MmiBookShowDefault();//Clear Screen
         
                     wstrcpy(info,(char *)MmiRsrcGetText(TxtPhbkCopying));
                     wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
                     b_color=dspl_SetFrgColor(0xff0000);
                     dspl_TextOut(10,40,0,info);
                     dspl_SetFrgColor(0x00ff00);
                     //dspl_DrawRect(5,80,115,90);
         
                     Force_refresh();*/
            memset(info,0,30);
            wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
            bookShowPhbkInformation(data->win, 0, info, (T_VOID_FUNC)book_copy_remove_show);
            memset(info,0,30); 
            //timStart(Multi_copy);
            CopyNumber=0;
            for( i=ALL_NVM_LIST,j=0;i<ALL_NUMBER_LIST;i++ )
            {
                if( l_phb_index[i].phonebook==SIM_BOOK_SEL )
                {
                    if( ReadSIMRecord(i,&l_phb_Shortentry)==TRUE )
                    {
                        for( ;j<ALL_NVM_LIST;j++ )
                        {
                            if( !CheckFlag(j) )
                            {
                                if( CurrentTable!=j/PHB_table_len )
                                {
                                    flash_PBwrite(PBTable[CurrentTable]);
                                    if( flash_PBread(PBTable[j/PHB_table_len])!=0 )
                                    {
                                        CurrentTable=j/PHB_table_len; 


                                        memcpy(l_phb_index[j].name,l_phb_Shortentry.name.data,PHB_name_len);
                                        l_phb_index[j].number[0]=GetShortNumber((char *)l_phb_Shortentry.number);
                                        l_phb_index[j].phonebook=NVM_BOOK_SEL;
                                        l_phb_index[j].index=j;
                                        l_phb_index[j].flag=SetAddFlag(j);
                                        l_phb_index[j].flag=SetFirstNumFlag(j, 1);

                                        CompressNum((char *)l_phb_Shortentry.number,FFS_PBData.NVMBook[j%PHB_table_len].number);
                                        memcpy(FFS_PBData.NVMBook[j%PHB_table_len].name,l_phb_Shortentry.name.data,PHB_name_len);
                                        FFS_PBData.NVMBook[j%PHB_table_len].info=l_phb_index[j].flag;
                                        //flash_PBwrite(PBTable[CurrentTable]);

                                        NVMTotal=NVMTotal+1;
                                        PHBKTotal=PHBKTotal+1;
                                        CopyNumber= CopyNumber+1;                              
                                    }
                                    else MmiBookSetCurrentText(TxtReadError);                          
                                }
                                else
                                {

                                    memcpy(l_phb_index[j].name,l_phb_Shortentry.name.data,PHB_name_len);
                                    l_phb_index[j].number[0]=GetShortNumber((char *)l_phb_Shortentry.number);
                                    l_phb_index[j].phonebook=NVM_BOOK_SEL;
                                    l_phb_index[j].index=j;
                                    l_phb_index[j].flag=SetAddFlag(j);
                                    l_phb_index[j].flag=SetFirstNumFlag(j, 1);  

                                    CompressNum((char *)l_phb_Shortentry.number,FFS_PBData.NVMBook[j%PHB_table_len].number);
                                    memcpy(FFS_PBData.NVMBook[j%PHB_table_len].name,l_phb_Shortentry.name.data,PHB_name_len);
                                    FFS_PBData.NVMBook[j%PHB_table_len].info=l_phb_index[j].flag;


                                    NVMTotal=NVMTotal+1;
                                    PHBKTotal=PHBKTotal+1;
                                    CopyNumber= CopyNumber+1;                            
                                }                           
                                break;
                            }

                        }      

                        if( (NVMTotal==ALL_NVM_LIST) || (i-ALL_NVM_LIST+1>=SIMTotal) ) break;
                    }
                }
            }  
            flash_PBwrite(PBTable[CurrentTable]);
            //           dspl_SetFrgColor(b_color);

            CopyResult.CopyEnd=TRUE; /*2003/12/5, wangyan modify*/


            timStart(data->copy_tim);   
            /*            if ( CopyNumber!=0 )
                        {
                            sprintf(info,"%d",CopyNumber);                   
                            wstrcat((char *)info, MmiRsrcGetText(TxtPhbkCopy)); 
            //                bookShowInformation(data->win,NULL,info,(T_VOID_FUNC)book_copytim_information);
                        bookShowPhbkInformation(data->win, 0, info, (T_VOID_FUNC)book_copytim_information);
                        }
                       else bookShowInformation( data->win, MmiBookCurrentText(),NULL, (T_VOID_FUNC)book_copytim_information);
             */
            /*2003/12/3, wangyan modify*/
            Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);
        }
        break;        
    case INFO_KCD_RIGHT:
        bookCopyAllDestroy(win);
    default: break;
    }              
}


T_MFW_HND bookOwnNumberStart( MfwHnd parent )
{
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) parent )->data;
    tBookStandard     *data       = (tBookStandard *) win_data->user;
    T_phbk           *Phbk       = data->phbk;
    T_MFW_HND       win;

    if( ( win = bookOwnNumberCreate( parent ) ) == NULL ) return NULL;
    else
    {
        if( Phbk->upnList->count>0 ) SEND_EVENT (win,OwnNumber_INIT,0,0);
        else
        {
            memset(Phbk->edt_buf_number,0,sizeof(Phbk->edt_buf_number));
            SEND_EVENT (win, OwnNumber_UPDATE, 0, 0);
        } 
    }                    
    return win;
}

static T_MFW_HND bookOwnNumberCreate( MfwHnd parent )
{
    T_MFW_WIN        *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    tBookStandard     *parent_data        = (tBookStandard *) parent_win_data->user;
    T_phbk           *phbk               = parent_data->phbk;
    T_MFW_WIN        *win_data;
    tBookStandard    *data;

    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookOwnNumberWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog = (T_DIALOG_FUNC) bookOwnNumberDialog;
    data->mmi_control.data   = data;
    win_data                 = ((T_MFW_HDR *)data->win)->data;
    win_data->user           = (void *) data;
    data->phbk               = phbk;
    data->parent_win         = parent;

    winShow(data->win);

    return data->win;
}

static void bookOwnNumberDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;
    T_MFW_HND      parent_win   =data->parent_win;

    int              i;
    char            * titleStr;

    TRACE_FUNCTION( "bookOwnNumberDialog()" );

    switch( event )
    {
    case OwnNumber_INIT:
        {               
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));              
            if( !data->menu_list_data )
            {
                bookShowInformation( win, TxtEmptyList, NULL, NULL );//޹
                bookOwnNumberDestroy( win );
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( (Phbk->upnList->count) * sizeof(T_MFW_MNU_ITEM) );

                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < Phbk->upnList->count; i++ )
                    {
                        data->menu_list_data->List[i].icon = 0;
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit =  0;
                        data->menu_list_data->List[i].menu =0;
                        data->menu_list_data->List[i].func = NULL;                        
                        data->menu_list_data->List[i].str=(char *)Phbk->upnList->upn[i].number;
                        data->menu_list_data->List[i].flagFunc = item_flag_none;                                                                     
                    }

                    data->menu_list_data->ListLength     = Phbk->upnList->count;
                    data->menu_list_data->ListPosition    = 1;
                    data->menu_list_data->CursorPosition = 1;
                    data->menu_list_data->SnapshotSize  = Phbk->upnList->count;
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftChange;   /* 2004/04/10 sunsj modify */
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &new_menuAttrib; 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;
                    titleStr=MmiRsrcGetText(TxtMyNumber);
                    data->menu_list_data->ListMenuHeadStr=titleStr;

                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookOwnNumberRead_cb,0);
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ
                    bookOwnNumberDestroy( win );                   
                }
            }           
        }
        break;          
    case OwnNumber_UPDATE:
        {                                   
            editor_attr_init_fullscr(&data->editor_data.editor_attr,1,TxtPhbkNumber,NULL,PHB_number_len,edtCurBar1);  
            data->editor_data.hide            = FALSE;
            data->editor_data.min_enter       = 0;
            data->editor_data.Identifier        = 0xFFFF;
            data->editor_data.timeout         = FOREVER;
            data->editor_data.destroyEditor     = FALSE;
            data->editor_data.editor_attr.text   = (char *)Phbk->edt_buf_number;
            data->editor_data.TextId          = TxtPhbkNumber;
            data->editor_data.LeftSoftKey      = TxtSoftOK;
            data->editor_data.AlternateLeftSoftKey = TxtSoftOK;     /* 2004/04/16 sunsj modify */
            data->editor_data.RightSoftKey     = TxtDelete;
            data->editor_data.mode           = PHONENUMONLY_MODE;
            data->editor_data.Callback        = (T_EDIT_CB)bookOwnNumberEditCB;                     
            data->edt                      = editor_start(win, &data->editor_data);  /* start the editor */              
            /* 2004/05/19 sunsj remove */
            //winShow( data->win );                        
        }
        break;
    case OwnNumber_DESTROY:         
        {            
            bookOwnNumberDestroy( win );
        }
        break;
    default: break;
    }
}

static int bookOwnNumberWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard   *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookOwnNumberWindowCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {                   
            //MmiBookShowDefault();//Clear Screen												
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}

void bookOwnNumberDestroy( MfwHnd window )
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookGroupingAddDestroy()" );

    // Only destroy if the data is valid	
    if( data )
    {
        // If we're the root window we destroy using it's function		
        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );
            return;
        }
        // delete ourself				
        winDelete( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

static void bookOwnNumberRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user; 
    T_phbk           * Phbk     = data->phbk;

    if( ListData->Reason EQ LISTS_REASON_SELECT||ListData->Reason EQ LISTS_REASON_OK )
    {

        memcpy(Phbk->edt_buf_number,Phbk->upnList->upn[ListData->CursorPosition].number,PHB_number_len);
        Phbk->select_index=ListData->CursorPosition;//yq add for make the index of upn true
        Phbk->OwnNumberItem_win=ListData->win;            
        SEND_EVENT(Parent,OwnNumber_UPDATE ,NULL, NULL);                                           
    }
    else if( ListData->Reason EQ LISTS_REASON_BACK )
    /*		
            if ( (ListData->Reason EQ LISTS_REASON_BACK
                 || (ListData->Reason EQ LISTS_REASON_CLEAR
                 || (ListData->Reason EQ LISTS_REASON_HANGUP))	// sbh - added hangup key
    */
    {
        listsDestroy(ListData->win);
        FREE_MEMORY((void *)data->menu_list_data->List, (Phbk->upnList->count) *sizeof(T_MFW_MNU_ITEM));
        FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                
        bookOwnNumberDestroy(data->win);
    }
}


void bookChoiceCopyDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk           = data->phbk;
    int              i;
    PhbkDetailItem       l_phb_NVMEntry;
    T_MFW_PHB_ENTRY   l_phb_Shortentry;
    char                * titleStr;
    UBYTE oldmode=dspl_Enable(0);
    TRACE_FUNCTION( "bookChoiceCopyDialog()" );

    switch( CopyWay )
    {
    case NVMToSIM:
        /* 2003/11/04 ,talcom comment */
#if 0
        {
            for( i=0,SearchTotal=0;i<PHBKTotal;i++ )
            {
                if( l_phb_index[l_phb_sort_index[i].index].phonebook==NVM_BOOK_SEL )
                {
                    bookname[SearchTotal].index=l_phb_sort_index[i].index;
                    bookname[SearchTotal].selectflag=FALSE;
                    SearchTotal=SearchTotal+1;
                }
            }

            Phbk->BufferIndex=0;
            Phbk->BufferTable=SearchTable;
            menu_start_index=Phbk->BufferIndex;
            if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
            {
                for( i=0;i<SearchTotal;i++ )
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                      
            }
            else
            {
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                                          
            }                    
        }
        break;
#endif/*end talcon comment */
    case SIMToNVM:
        {
            /* 2003/11/04 ,talcom add */
            int nBoolSel = SIM_BOOK_SEL;
            if( NVMToSIM == CopyWay )
            {
                nBoolSel = NVM_BOOK_SEL;
            }
            /*end talcon add */
            for( i=0,SearchTotal=0;i<PHBKTotal;i++ )
            {
                /*2003/11/04,talcon modify SIM_BOOK_SEL to nBoolSel */
                if( l_phb_index[l_phb_sort_index[i].index].phonebook==nBoolSel )
                {
                    bookname[SearchTotal].index=l_phb_sort_index[i].index;
                    bookname[SearchTotal].selectflag=FALSE;
                    SearchTotal=SearchTotal+1;
                }
            }

            Phbk->BufferIndex=0;
            Phbk->BufferTable=SearchTable;
            menu_start_index=Phbk->BufferIndex;
            if( SearchTotal<=PHONEBOOK_RECORD_PERPAGE )
            {
                for( i=0;i<SearchTotal;i++ )
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                      
            }
            else
            {
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[i].index].name,PHB_name_len);                                          
            }            
        }
        break;
    }

    switch( event )
    {
    case COPY_INIT:
        {             
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                bookShowInformation( win, TxtEmptyList, NULL, NULL );
                bookChoiceCopyDestroy( win );
            }
            else
            {
                MfwMnu *mnu;//2003/11/05,talcon add 
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(SearchTotal) * sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < GetFree(SearchTotal); i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SITUATION3, 0);//&situation3Icon;
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit =  0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].Dynamicindex=i;
                        data->menu_list_data->List[i].func = NULL;
                        data->menu_list_data->List[i].str=(char *)DynamicBuffer[i].name;                    
                        data->menu_list_data->List[i].flagFunc = ChoiceCopyItem;                      
                    }

                    data->menu_list_data->ListLength     = GetFree(SearchTotal);
                    data->menu_list_data->ListPosition    = 1;
                    data->menu_list_data->CursorPosition = 1;
                    data->menu_list_data->SnapshotSize  = GetFree(SearchTotal);
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftOK;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &readName_menuAttrib; 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;                    
                    titleStr=MmiRsrcGetText(TxtChoiceCopy);
                    data->menu_list_data->ListMenuHeadStr=titleStr;

                    //LastKey=0xFF;
                    SelectTotal=0;
                    if( (int)parameter!=0 )
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                    }
                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookChoiceCopyRead_cb,0);                                  
                    refresh_flag=1;
#if(MAIN_LCD_SIZE==4)
					dspl_Clear(0,108, SCREEN_SIZE_X, 126);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
                    /* 2004/05/26 sunsj modify */
                    dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
                    DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
                    show_index=bookname[Phbk->BufferIndex].index;
                    show_number();
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    bookShowInformation(win, TxtEmptyList, NULL, NULL );//Ϊ޷ռ
                    bookChoiceCopyDestroy( win );                    
                }
            }          
        }
        break;                    
    default: break;
    }
    dspl_Enable(oldmode);
}


static int bookChoiceCopyWindowCB( MfwEvt e, MfwWin *w)
{
    tBookStandard *data       = (tBookStandard *) w->user;    

    TRACE_FUNCTION( "bookChoiceCopyCB()" );

    switch( e )
    {
    case MfwWinVisible:
    case MfwWinFocussed:    
        {
            //MmiBookShowDefault();//Clear Screen	
            edtShow(data->edt);
            edtChar(data->edt,ecBottom);
            TRACE_EVENT("MfwWinVisible&MfwWinFocussed fzq");                                                                                                    
        }
        break;      
    case MfwWinDelete:
        {
            TRACE_EVENT("MfwWinDelete fzq");
        }
        break;

    default:
        {
            // default is to pass event back for further handling			
            return MFW_EVENT_PASSED;
        }
        break;
    }   
    return MFW_EVENT_CONSUMED;
}


static T_MFW_HND bookChoiceCopyCreate( MfwHnd parent )
{
    T_MFW_WIN        *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    T_phbk           *phbk = (T_phbk *)parent_win_data->user;
    T_MFW_WIN        *win_data;
    tBookStandard    *data;

    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookChoiceCopyWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog = (T_DIALOG_FUNC) bookChoiceCopyDialog;
    data->mmi_control.data   = data;
    win_data         = ((T_MFW_HDR *)data->win)->data;
    win_data->user       = (void *) data;
    data->phbk           = phbk;
    data->parent_win     = parent;
#if(MAIN_LCD_SIZE==3)
	bookSetEditAttributes(20,85,32, 18,0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#elif (MAIN_LCD_SIZE==4)
    bookSetEditAttributes(20, 108, 32, 18, 0, 0, edtCurBar1, 0,(char *)data->edtBuf,5,&data->attr);
#endif
    data->edt=edtCreate(data->win,&data->attr,0,0);
#ifndef FOR_FTA_CTA
    if( !show_timer )
        show_timer=timCreate(data->win,300,(MfwCb)show_timercb);
    if( !edt_timer )
        edt_timer=timCreate(data->win,500,(MfwCb)edt_timer_cb);
#endif
    winShow(data->win);

    return data->win;
}


static T_MFW_CB book_choicecopytim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       = (tBookStandard *) win_data->user;
    T_phbk           *phbk= (T_phbk *)data->phbk;
    char              info[30];
    char info2[60];
    TRACE_FUNCTION("book_choicecopytim_cb");
    timStop(data->copy_tim);
    if( CopyResult.CopyEnd==FALSE ) timStart(data->copy_tim);
    else
    {
        ////zgzTraceDataFunc("copyNUmber:",(unsigned short)CopyNumber);
        ////zgzTraceDataFunc("complete?:",(unsigned short)CopyResult.complete);
        if( CopyNumber!=0 )
        {
            if( CopyResult.complete==MFW_PHB_OK )
            {
                TRACE_EVENT("copy sucess in choicecopycb");
                sprintf(info,"%d",CopyNumber);                   
                wstrcat((char *)info, MmiRsrcGetText(TxtPhbkCopy));                   
                bookShowPhbkInformation(win,NULL,info,(T_VOID_FUNC)book_choicecopytim_information);      
            }
            else if( CopyResult.complete==MFW_PHB_FULL )
            {
                TRACE_EVENT("sim full in choicecopycb");
                //wstrcpy(info2,(char *)MmiRsrcGetText(TxtPhbkSimFull));
                sprintf(info,"\n,%d",CopyNumber);                   
                wstrcat((char *)info, MmiRsrcGetText(TxtPhbkCopy));   
                wstrcpy(info2,info);
                //   wstrcat(info2,"\n");
                //   wstrcat(info2,(char *)MmiRsrcGetText(TxtPhbkSimFull));
                bookShowPhbkInformation(win,NULL,info2,(T_VOID_FUNC)book_choicecopytim_information);   
            }
            else
            {
                TRACE_EVENT("copy fail in choicecopycb");
                bookShowInformation(win, TxtCopyFail,NULL, (T_VOID_FUNC)book_choicecopytim_information);
            }
        }
        else bookShowInformation(win, TxtCopyFail,NULL, (T_VOID_FUNC)book_choicecopytim_information);
    }   
    return 0;
}

static void book_choicecopytim_information(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  * data     = (tBookStandard *) win_data->user;
    //T_phbk         * Phbk       =data->phbk;
    TRACE_FUNCTION("book_choicecopytim_information");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            if( data->copy_tim )
            {
                timStop(data->copy_tim);
                timDelete(data->copy_tim);
                data->copy_tim=0;
            }
            bookChoiceCopyDestroy(win);
        }      
        break;                                                   
    default: break;
    }
}

static void bookChoiceCopyRead_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user;
    T_phbk           * phbk      = data->phbk;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;

    int                  i,j;
    T_MFW_PHB_ENTRY   l_phb_Shortentry;
    PhbkDetailItem       l_phb_NVMEntry;    
    T_MFW_PHB_STATUS  status;
    char                info[60];
    UINT32 b_color;  

    TRACE_EVENT("bookchoicecopyread_cb");
    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
        {   
            if( SelectTotal!=0 )
            {
                timStop(show_timer);
                timStop(edt_timer);
                memset(data->edtBuf,0,sizeof(data->edtBuf));
                //           MmiBookShowDefault();//Clear Screen

                //            wstrcpy(info,(char *)MmiRsrcGetText(TxtPhbkCopying));
                //           wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
                //          b_color=dspl_SetFrgColor(0xff0000);
                //          dspl_TextOut(10,40,0,info);
                //          dspl_SetFrgColor(b_color);
                //dspl_DrawRect(5,80,115,90);
                memset(info,0,60);
                wstrcat(info,(char *)MmiRsrcGetText(TxtPleaseWait));
                bookShowPhbkInformation(data->win, 0, info, (T_VOID_FUNC)book_copy_remove_show);
                memset(info,0,60); 

                Force_refresh();
                switch( CopyWay )
                {
                case NVMToSIM:
                    {               
                        CopyNumber=0;
                        for( i=0; i<SearchTotal; i++ )
                        {
                            if( bookname[i].selectflag==TRUE )
                            {
                                if( CurrentTable!=bookname[i].index/PHB_table_len )
                                {
                                    if( flash_PBread(PBTable[bookname[i].index/PHB_table_len])!=0 )
                                        CurrentTable=bookname[i].index/PHB_table_len;
                                }

                                memset(&l_phb_Shortentry,0,sizeof(l_phb_Shortentry));
                                l_phb_Shortentry.book=bookActiveBook(WRITE);
                                status.book=l_phb_Shortentry.book;

                                memcpy(l_phb_Shortentry.name.data,FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].name,PHB_name_len);
                                l_phb_Shortentry.name.len=wstrlen((char *)l_phb_Shortentry.name.data);
                                //================================================================================================                      
                                switch( CheckFirstNumFlag(bookname[i].index) )
                                {
                                case 0x01:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].home,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].office,l_phb_Shortentry.number);
                                    break;  
                                case 0x02:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].home,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].office,l_phb_Shortentry.number);
                                    break;
                                case 0x03:
                                    if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].office)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].office,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number,l_phb_Shortentry.number);
                                    else if( wstrlen((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].home)!=0 )
                                        UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].home,l_phb_Shortentry.number);
                                    break;
                                    //================================================================================================                                  
                                }    
                                //UnCompressNum((char *)FFS_PBData.NVMBook[bookname[i].index%PHB_table_len].number,l_phb_Shortentry.number);

                                phonebookstatus=COPYINGSELECT;

                                switch( addName(l_phb_Shortentry.book,&l_phb_Shortentry,&status) )
                                {
                                case MFW_PHB_OK :
                                    {
                                        TRACE_EVENT("copy one sucess in choicecopy!");
                                        CopyResult.CopyEnd=FALSE;
                                        CopyResult.complete=0xF0;
                                        data->copy_tim=tim_create (data->win,100, (T_MFW_CB)book_choicecopytim_cb);
                                        CopyResult.CopyEnd=FALSE;
                                        CopyNumber=CopyNumber+1;
                                        timStart(data->copy_tim);

                                    }   
                                    break;
                                default: 

                                    break;
                                }                      
                                Copyidx=i+1;
                                ////zgzTraceDataFunc("Copyidx:",(unsigned short)Copyidx);
                                ////zgzTraceDataFunc("phonebookstatus:",phonebookstatus);
                                break;                      
                            }
                        }
                        listsDestroy(ListData->win);                
                        FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                        FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData)); 
                        //                  dspl_Clear(38,110,70, 126);

                    }   
                    break;
                case SIMToNVM:  
                    {
                        CopyNumber=0;
                        for( i=0,j=0; i<SearchTotal; i++ )
                        {
                            if( bookname[i].selectflag==TRUE )
                            {
                                if( ReadSIMRecord(bookname[i].index,&l_phb_Shortentry)==TRUE )
                                {
                                    for( ; j<ALL_NVM_LIST; j++ )
                                    {
                                        if( !CheckFlag(j) )
                                        {
                                            if( CurrentTable!=j/PHB_table_len )
                                            {
                                                if( flash_PBread(PBTable[j/PHB_table_len])!=0 )
                                                    CurrentTable=j/PHB_table_len;
                                            }

                                            memcpy(l_phb_index[j].name,l_phb_Shortentry.name.data,PHB_name_len);
                                            l_phb_index[j].number[0]=GetShortNumber((char *)l_phb_Shortentry.number);
                                            l_phb_index[j].phonebook=NVM_BOOK_SEL;
                                            l_phb_index[j].flag=SetAddFlag(j);
                                            l_phb_index[j].flag=SetFirstNumFlag(j, 1);

                                            CompressNum((char *)l_phb_Shortentry.number,FFS_PBData.NVMBook[j%PHB_table_len].number);
                                            memcpy(FFS_PBData.NVMBook[j%PHB_table_len].name,l_phb_Shortentry.name.data,PHB_name_len);
                                            FFS_PBData.NVMBook[j%PHB_table_len].info=l_phb_index[j].flag;
                                            flash_PBwrite(PBTable[CurrentTable]);

                                            CopyNumber=CopyNumber+1;
                                            NVMTotal=NVMTotal+1;
                                            PHBKTotal=PHBKTotal+1;                                 
                                            break;
                                        }
                                    }                                                                         
                                }
                            }

                            if( NVMTotal==ALL_NVM_LIST ) break;

                        }
                        Create_SORT_Table(l_phb_index,ALL_NUMBER_LIST);

                        listsDestroy(ListData->win);                
                        FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
                        FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                        //
                        bookChoiceCopyDestroy(data->win);
                        memset(info,0,sizeof(info));
                        sprintf(info,"%d",CopyNumber);                   
                        wstrcat((char *)info, (char *)MmiRsrcGetText(TxtPhbkCopy));
                        bookShowPhbkInformation(data->win,NULL,info,(T_VOID_FUNC)book_choicecopy_information);//

                        //
                    }
                    break;
                default: break;
                }                                           
            }
            else    /* 2004/04/06 sunsj add */
            {
                HostkeyProtectOpts_notice();
            }
        }
        break;
    case LISTS_REASON_BACK:
        if( wstrlen(data->edtBuf)==0 )
        {
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);              
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                   
            bookChoiceCopyDestroy(data->win);
        }
        else
            edtChar(data->edt,ecBack);
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            //		break;
            memset(data->edtBuf,0,sizeof(data->edtBuf));
            timStop(show_timer);
            timStop(edt_timer);
            listsDestroy(ListData->win);              
            FREE_MEMORY((void *)data->menu_list_data->List,GetFree(SearchTotal)*sizeof(T_MFW_MNU_ITEM));
            FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));                   
            bookChoiceCopyDestroy(data->win);
        }
        break;
    case LISTS_REASON_UP:
        {
            if( (ListData->CursorPosition-1>=0) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal)+1; 
                mnuUp(dataInfo->MenuLists);
                show_index=bookname[(phbk->BufferIndex+ListData->CursorPosition-1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                phbk->BufferIndex=(phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+SearchTotal)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal)+1; 
                menu_start_index=phbk->BufferIndex;
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                show_index=bookname[(phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1+SearchTotal)%SearchTotal].index;
                show_number();
            }
        } 
        break;
    case LISTS_REASON_DOWN:
        {
            if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (SearchTotal<=PHONEBOOK_RECORD_PERPAGE) )
            {
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex+ListData->CursorPosition+1)%SearchTotal)+1;
                mnuDown(dataInfo->MenuLists);
                show_index=bookname[(phbk->BufferIndex+ListData->CursorPosition+1+SearchTotal)%SearchTotal].index;
                show_number();
            }
            else
            {
                phbk->BufferIndex=(phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%SearchTotal;
                dataInfo->MenuListsAttr.pageturnindex=((phbk->BufferIndex)%SearchTotal)+1; 
                menu_start_index=phbk->BufferIndex;
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(phbk->BufferIndex+i)%SearchTotal].index].name,PHB_name_len);
                mnuChooseVisibleItem(dataInfo->MenuLists,0);
                show_index=bookname[(phbk->BufferIndex+SearchTotal)%SearchTotal].index;
                show_number();
            }           
        } 
        break;
    case LISTS_REASON_UPDATE:
        {
#if(MAIN_LCD_SIZE==4)
			dspl_Clear(0,108, SCREEN_SIZE_X, 126);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 110);
#elif(MAIN_LCD_SIZE==3)
			/* 2004/05/26 sunsj modify */
			dspl_Clear(0, 72, SCREEN_SIZE_X, 110);
			DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
            ShowPhoneBookNumber(bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,NONE);   
            edtChar(data->edt,ecBottom);
        } 
        break;
    case LISTS_REASON_OK:
        {                
            TRACE_EVENT("LISTS_REASON_OK");
            //select total<=sim or NVM free
            if( bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].selectflag==TRUE )
            {
                SelectTotal=SelectTotal-1;
                bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].selectflag=FALSE;                                               
            }
            else
            {
                SelectTotal=SelectTotal+1;
                bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].selectflag=TRUE;                           
            }  
            winShow(ListData->win);                             
        }
        break;
    case LISTS_REASON_LEFT:
        {          
            if( l_phb_index[bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TOLEFT);
        }
        break;
    case LISTS_REASON_RIGHT:
        {

            if( l_phb_index[bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index].phonebook==NVM_BOOK_SEL )
                ShowPhoneBookNumber(bookname[(phbk->BufferIndex+ListData->CursorPosition)%SearchTotal].index,TORIGHT);
        }
        break;
    case LISTS_REASON_KCD0:
        {
        }                     
        break;                                             
    case LISTS_REASON_KCD1:                                            
        {
        }   
        break;
    case LISTS_REASON_KCD2:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_2);
        }   
        break;                                              
    case LISTS_REASON_KCD3: 
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_3);
        }   
        break;
    case LISTS_REASON_KCD4:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_4);
        }   
        break;                                                                                                 
    case LISTS_REASON_KCD5:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_5);
        }   
        break;                                                 
    case LISTS_REASON_KCD6:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_6);
        }   
        break;                                              
    case LISTS_REASON_KCD7:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_7);
        }   
        break;                                                  
    case LISTS_REASON_KCD8:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_8);
        }   
        break;                                              
    case LISTS_REASON_KCD9:
        {
            if( wstrlen(data->edtBuf)<2||(cursor_correct==0&&wstrlen(data->edtBuf)==2) )
                yq_edtchar(data->edt,KCD_9);
        }   
        break;
    default: break;        
    }   
}

static void book_choicecopy_information(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    TRACE_FUNCTION("book_choicecopy_information");
    // tBookStandard	 * data		= (tBookStandard *) win_data->user;
    //T_phbk         * Phbk       =data->phbk;

    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT: 
        {
            // bookChoiceCopyDestroy(win);
        }      
        break;                                                   
    default: break;
    }
}

T_MFW_HND bookChoiceCopyStart( MfwHnd parent, T_CopyWay  NewCopyWay )//NVMToSIM,SIMToNVM
{
    T_MFW_HND         win;

    if( ( win = bookChoiceCopyCreate( parent ) ) == NULL ) return NULL;
    else
    {
        TRACE_EVENT("ERROR2");
        SetWindowsHandle(win);
        SetPhbkIN(1);
        CopyWay=NewCopyWay;
        SEND_EVENT(win,COPY_INIT,NULL,NULL);
    }
    return win;      
}

void bookChoiceCopyDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard *data = (tBookStandard *) win->user;

    TRACE_FUNCTION( "bookChoiceCopyDestroy()" );

    // Only destroy if the data is valid	
    if( data )
    {
        // If we're the root window we destroy using it's function
        TRACE_EVENT("has data");
        if( show_timer )
        {
            timStop(show_timer);
            timDelete(show_timer);
            show_timer=0;
        }
        if( edt_timer )
        {
            timStop(edt_timer);
            timDelete(edt_timer);
            edt_timer=0;
        }
        key_before=0xff;
        cursor_correct=1;
        key_index=0;
        if( data->phbk->root_win == window )
        {
            bookPhonebookDestroy( data->phbk->win );
            return;
        }


        data->phbk->choicecopy_win=0;
        winDelete( data->win );
        ClearWindowHandle();
        SetPhbkIN(0);
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

static int SearchIndex(T_MFW_PHB_SORT_INDEX *SortData,int RecordLen,char * Inputchr,int *Index)
{
    int i,SearchFlag;
    USHORT TempName;
    USHORT inputstr,tempstr,tempstr1;


    SearchFlag=0;
    if( strlen((char *)Inputchr) )
    {

        switch( strlen((char *)Inputchr) )
        {
        case 1:   
            inputstr=(((USHORT)*Inputchr)<<8)&0xff00; 
            break;
        case 2:
            {
                tempstr=*Inputchr;
                Inputchr++;
                tempstr1=*Inputchr;
                inputstr=((tempstr<<8)&0xff00)|(tempstr1&0x00ff);
                Inputchr--;

                break;
            }   
        default : break;

        }

        for( i=0;i<=RecordLen;i++ )
        {
            switch( strlen((char *)Inputchr) )
            {
            case 1:
                TempName=(USHORT)((SortData[i].name)&0xff00);
                break;
            case 2:
                TempName=(USHORT)(SortData[i].name);
                break;
            default:    break;
            }

            if( TempName==inputstr )
            {
                SearchFlag=1;
                *Index=i;

                break;
            }
            if( TempName>inputstr )
            {
                *Index=i;
                break;
            }
        }
    }
    return SearchFlag;
}

static int GetIndex(T_SearchResult *SortData,int RecordLen, char * Inputchr,int *Index)
{
    int    i,SearchFlag;
    USHORT TempName;
    USHORT inputstr,tempstr,tempstr1;


    SearchFlag=0;
    if( strlen((char *)Inputchr) )
    {

        switch( strlen((char *)Inputchr) )
        {
        case 1:
            inputstr=(((USHORT)*Inputchr)<<8)&0xff00;
            break;
        case 2:
            {
                tempstr=*Inputchr;
                Inputchr++;
                tempstr1=*Inputchr;
                inputstr=((tempstr<<8)&0xff00)|(tempstr1&0x00ff);
                Inputchr--;
                break;
            }   
        default:
            break;
        }
        for( i=0;i<=RecordLen;i++ )
        {
            switch( strlen((char *)Inputchr) )
            {
            case 1:
                TempName=(USHORT) ((GetShortName(l_phb_index[SortData[i].index].name))&0xff00);
                break;
            case 2:
                TempName=(USHORT) (GetShortName(l_phb_index[SortData[i].index].name));
                break;
            default:    break;
            }


            if( TempName==inputstr )
            {
                SearchFlag=1;
                *Index=i;

                break;
            }
            if( TempName>inputstr )
            {
                *Index=i;
                break;
            }
        }  
    }
    return SearchFlag;
}

MfwHnd bookInputStart( MfwHnd parent)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("bookInputStart()");


    if( ( win = bookInputCreate( parent ) ) != NULL )
        SEND_EVENT( win, INPUT_NAME, 0, 0 );
    return win;
}

/*******************************************************************************
 $Function:		bookInputDialog

 $Description:	Dialog function for the input window
 
 $Returns:		None

 $Arguments:	win, window handle
                event, event to be handled
                value, not used
                parameter, not used 

 $History:	2003/11/1  sunsj modify the editor area
            2003/11/10 sunsj modify the number display method
*******************************************************************************/
static void bookInputDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data    = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data        = (tBookStandard *) win_data->user;    
    T_EDITOR_DATA  *editor_data = (T_EDITOR_DATA *) parameter;
    T_MFW_HND      ParentWin    =data->phbk->menu_main_win;
    int               title_id;
    T_MFW_PHB_STATUS status;
    U16 basesize;
    if( data->phbk->UpdateAction==CREATE_ENTRY ) title_id=TxtPhoneNew;
    else if( data->phbk->UpdateAction==MODIFY_EXISTING ) title_id=TxtPhbkChange;

    TRACE_FUNCTION ("bookInputDialog()");

    switch( event )
    {
    case INPUT_NAME:
        {             
            data->phbk->MODE=NAME;
            //data->phbk->CurrentEdit=TOP;
            if( data->phbk->BookType==NVM_BOOK_SEL )
            {
                /* 2004/01/14 sunsj modify for LCD width */
                editor_attr_init_only(&data->editor_data.editor_attr,PHONEEDITOR_SCREEN_X_OFFSET,PHONE_NAME_Y,PHONEEDITOR_SCREEN_WIDTH, MENU_PER_HEIGHT,TITLE_TOP,title_id,NULL,PHB_name_len+3,edtCurBar1,0);      
                //editor_attr_init_only(&data->editor_data.editor_attr,6,42,108,34,TITLE_TOP,title_id,NULL,PHB_name_len+3,edtCurBar1,0);
                /* 2003/11/1 sunsj modify the name editor color */
                data->editor_data.editor_attr.fgColor = 0xF9F900;//0xFFF6C1; //2004-04-05 Sunny modify
                data->editor_data.hide                = FALSE;
                data->editor_data.edtInPbk            = 1;
                data->editor_data.min_enter           = 1;              /* 2004/03/24 sunsj modify */
                data->editor_data.Identifier          = 0xFFFF;
                data->editor_data.timeout             = FOREVER;
                data->editor_data.destroyEditor       = FALSE;
                data->editor_data.editor_attr.text    = (char *)data->phbk->edt_buf_name;
                data->editor_data.TextId              = title_id;
                data->editor_data.LeftSoftKey         = TxtSoftOK;      /* 2004/03/24 sunsj modify */
                data->editor_data.AlternateLeftSoftKey = TxtNull;       /* 2004/03/24 sunsj modify */
                data->editor_data.RightSoftKey        = TxtDelete;
                /* 2003/11/27 sunsj set editor mode with language mode */
                if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
                {
                    /* 2003/12/04 sunsj modify */
                    data->editor_data.mode            = TEXTINPUT_MODE;
                    data->editor_data.InputMode       = PINYIN_INPUT_MODE;
                }
                else if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
                {
                    /* 2003/12/04 sunsj modify */
                    data->editor_data.mode            = TEXTINPUT_MODE;
                    /* 2004/04/16 sunsj modify */
                    data->editor_data.InputMode       = LOWERCASE_INPUT_MODE;   /* 2004/06/02 sunsj modify */
                }
                data->editor_data.Callback            = (T_EDIT_CB)bookAddCB;                     
                /* 2003/12/04 sunsj modify for new editor mode */
                data->edtname                         = text_input(win, &data->editor_data);  /* start the editor */                                     

                //winShow( data->win );	
            }
            else if( data->phbk->BookType==SIM_BOOK_SEL )
            {
                status.book=PHB_ADN;   
                if( phb_get_status(&status)==MFW_PHB_OK )
                {
                    /* 2004/03 24 sunsj modify */
                    //basesize=status.tag_len+2;
                    basesize = 1;

                    /* 2004/01/14 sunsj modify for LCD width */
                    editor_attr_init_only(&data->editor_data.editor_attr,PHONEEDITOR_SCREEN_X_OFFSET,PHONE_NAME_Y,PHONEEDITOR_SCREEN_WIDTH,MENU_PER_HEIGHT,TITLE_TOP,title_id,NULL,PHB_name_len+3,edtCurBar1,0);
                    //editor_attr_init_only(&data->editor_data.editor_attr,6,42,108,34,TITLE_TOP,title_id,NULL,basesize,edtCurBar1,0);
                    /* 2003/11/1 sunsj modify the name editor color */
                    data->editor_data.editor_attr.fgColor = 0xF9F900;//0xFFF6C1; //2004-04-05 Sunny modify
                    data->editor_data.hide                = FALSE;
                    data->editor_data.edtInPbk            = 1;
                    data->editor_data.min_enter           = basesize;
                    data->editor_data.Identifier          = 0xFFFF;
                    data->editor_data.timeout             = FOREVER;
                    data->editor_data.destroyEditor       = FALSE;
                    data->editor_data.editor_attr.text    = (char *)data->phbk->edt_buf_name;
                    data->editor_data.TextId              = title_id;                      
                    data->editor_data.LeftSoftKey         = TxtSoftOK;      /* 2004/03/24 sunsj modify */           
                    data->editor_data.AlternateLeftSoftKey = TxtNull;       /* 2004/03/24 sunsj modify */
                    data->editor_data.RightSoftKey        = TxtDelete;
                    /* 2003/11/27 sunsj set editor mode with language mode */
                    if( Mmi_getCurrentLanguage() == CHINESE_LANGUAGE )
                    {
                        /* 2003/12/04 sunsj modify */
                        data->editor_data.mode            = TEXTINPUT_MODE;
                        data->editor_data.InputMode       = PINYIN_INPUT_MODE;
                    }
                    else if( Mmi_getCurrentLanguage() == ENGLISH_LANGUAGE )
                    {
                        /* 2003/12/04 sunsj modify */
                        data->editor_data.mode            = TEXTINPUT_MODE;
                        data->editor_data.InputMode       = PINYIN_INPUT_MODE;  /* 2004/04/27 sunsj modify */
                    }
                    data->editor_data.Callback            = (T_EDIT_CB)bookAddCB;                     
                    /* 2003/12/04 sunsj modify for new editor mode */
                    data->edtname                         = text_input(win, &data->editor_data);  /* start the editor */                                     

                    //winShow( data->win );	
                }
                else
                {
                    TRACE_EVENT("sim not avaible");
                }
            }
        }
        break;
    case INPUT_NUMBER:
        {
            data->phbk->MODE=NUMBER; 
            if( data->edtnumber )
            {
                MfwWin * win = ((MfwHdr *)(data->edtnumber))->data;
                T_EDITOR_INFO *info = win->user;
                T_EDITOR_DATA *editor_data = &(info->editor_data);
                editor_data->mode = PHONENUMONLY_MODE;
                ec_editActivate(info->edt_edt,editor_data->mode);
                data->editor_data.min_enter = 1;    /* 2004/03/24 sunsj modify the minimum size */
                editor_data->editor_attr.text = (char *)data->phbk->edt_buf_number;
                if( data->phbk->BookType == SIM_BOOK_SEL )
                    editor_data->editor_attr.size = PHB_number_len+2;
                else if( data->phbk->BookType==NVM_BOOK_SEL )
                    editor_data->editor_attr.size = PHB_number_len+3;
                winShow(data->edtnumber);
            }
            else
            {
                if( data->phbk->BookType==NVM_BOOK_SEL )
                {
                    /* 2004/01/14 sunsj modify for LCD width */
                    editor_attr_init_only(&data->editor_data.editor_attr,PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MOBILENUM_Y,PHONEEDITOR_SCREEN_WIDTH,MENU_PER_HEIGHT,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);
                    //editor_attr_init_only(&data->editor_data.editor_attr,6,105,108,34,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);	             	               	             
                }
                else if( data->phbk->BookType==SIM_BOOK_SEL )
                {
                    /* 2004/01/14 sunsj modify for LCD width */
                    editor_attr_init_only(&data->editor_data.editor_attr,PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MOBILENUM_Y,PHONEEDITOR_SCREEN_WIDTH,MENU_PER_HEIGHT,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);
                    //editor_attr_init_only(&data->editor_data.editor_attr,6,105,108,34,TITLE_TOP,title_id,NULL,PHB_number_len+2,edtCurBar1,0);
                }
                data->editor_data.editor_attr.fgColor = 0xF9F900;//0xFFF6C1; //2004-04-05 Sunny modify
                data->editor_data.hide                = FALSE;
                data->editor_data.min_enter           = 1;  /* 2004/03/24 sunsj modify the minimum size */
                data->editor_data.Identifier          = 0xFFFF;
                data->editor_data.edtInPbk            = 1;
                data->editor_data.timeout             = FOREVER;
                data->editor_data.destroyEditor       = FALSE;
                data->editor_data.editor_attr.text    = (char *)data->phbk->edt_buf_number;
                data->editor_data.TextId              = title_id;
                data->editor_data.LeftSoftKey         = TxtSoftOK;      /* 2004/03/24 sunsj modify */
                data->editor_data.AlternateLeftSoftKey = TxtNull;       /* 2004/03/24 sunsj modify */
                data->editor_data.RightSoftKey        = TxtDelete;
                data->editor_data.mode                = PHONENUMONLY_MODE;
                data->editor_data.Callback            = (T_EDIT_CB)bookAddCB;                      
                data->edtnumber                       = editor_start(win, &data->editor_data);  /* start the editor */
            }            
            //winShow( data->win ); 
        }
        break;
    case INPUT_HOME:
        { 
            data->phbk->MODE=HOME; 
            if( data->edtnumber )
            {
                MfwWin * win = ((MfwHdr *)(data->edtnumber))->data;
                T_EDITOR_INFO *info = win->user;
                T_EDITOR_DATA *editor_data = &(info->editor_data);
                editor_data->mode = PHONENUMONLY_MODE;
                ec_editActivate(info->edt_edt,editor_data->mode);
                data->editor_data.min_enter = 1;    /* 2004/03/24 sunsj modify the minimum size */
                editor_data->editor_attr.text = (char *)data->phbk->edt_buf_home;
                editor_data->editor_attr.size = PHB_number_len+3;
                winShow(data->edtnumber);
            }
            else
            {
                /* 2004/01/14 sunsj modify for LCD width */
                editor_attr_init_only(&data->editor_data.editor_attr,PHONEEDITOR_SCREEN_X_OFFSET,PHONE_HOMENUM_Y,PHONEEDITOR_SCREEN_WIDTH,MENU_PER_HEIGHT,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);
                //editor_attr_init_only(&data->editor_data.editor_attr,6,105,108,34,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);

                data->editor_data.editor_attr.fgColor = 0xF9F900;//0xFFF6C1; //2004-04-05 Sunny modify
                data->editor_data.hide                = FALSE;           
                data->editor_data.min_enter           = 1;  /* 2004/03/24 sunsj modify the minimum size */
                data->editor_data.Identifier          = 0xFFFF;
                data->editor_data.edtInPbk            = 1;
                data->editor_data.timeout             = FOREVER;
                data->editor_data.destroyEditor       = FALSE;
                data->editor_data.editor_attr.text    = (char *)data->phbk->edt_buf_home;
                data->editor_data.TextId              = title_id;
                data->editor_data.LeftSoftKey         = TxtSoftOK;      /* 2004/03/24 sunsj modify */
                data->editor_data.AlternateLeftSoftKey = TxtNull;       /* 2004/03/24 sunsj modify */
                data->editor_data.RightSoftKey        = TxtDelete;
                data->editor_data.mode                = PHONENUMONLY_MODE;
                data->editor_data.Callback            = (T_EDIT_CB)bookAddCB;                      
                data->edtnumber= editor_start(win, &data->editor_data);  /* start the editor */             
            }
            //winShow( data->win ); 
        }
        break;
    case INPUT_OFFICE:
        {
            data->phbk->MODE=OFFICE;
            if( data->edtnumber )
            {
                MfwWin * win = ((MfwHdr *)(data->edtnumber))->data;
                T_EDITOR_INFO *info = win->user;
                T_EDITOR_DATA *editor_data = &(info->editor_data);
                editor_data->mode = PHONENUMONLY_MODE;
                ec_editActivate(info->edt_edt,editor_data->mode);
                data->editor_data.min_enter = 1;    /* 2004/03/24 sunsj modify the minimum size */
                editor_data->editor_attr.text = (char *)data->phbk->edt_buf_office;
                editor_data->editor_attr.size = PHB_number_len+3;
                winShow(data->edtnumber);
            }
            else
            {
                /* 2004/01/14 sunsj modify for LCD width */
                editor_attr_init_only(&data->editor_data.editor_attr,PHONEEDITOR_SCREEN_X_OFFSET,PHONE_OFFICENUM_Y,PHONEEDITOR_SCREEN_WIDTH,MENU_PER_HEIGHT,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);
                //editor_attr_init_only(&data->editor_data.editor_attr,6,105,108,34,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);              

                //             editor_attr_init_only(&data->editor_data.editor_attr,6,105,108,34,TITLE_TOP,title_id,NULL,PHB_number_len+3,edtCurBar1,0);              
                data->editor_data.editor_attr.fgColor = 0xF9F900;//0xFFF6C1; //2004-04-05 Sunny modify
                data->editor_data.hide                = FALSE;
                data->editor_data.min_enter           = 1;  /* 2004/03/24 sunsj modify the minimum size */
                data->editor_data.Identifier          = 0xFFFF;
                data->editor_data.edtInPbk            = 1;
                data->editor_data.timeout             = FOREVER;
                data->editor_data.destroyEditor       = FALSE;
                data->editor_data.editor_attr.text    = (char *)data->phbk->edt_buf_office;
                data->editor_data.TextId              = title_id;
                data->editor_data.LeftSoftKey         = TxtSoftOK;      /* 2004/03/24 sunsj modify */
                data->editor_data.AlternateLeftSoftKey = TxtNull;       /* 2004/03/24 sunsj modify */
                data->editor_data.RightSoftKey        = TxtDelete;
                data->editor_data.mode                = PHONENUMONLY_MODE;
                data->editor_data.Callback            = (T_EDIT_CB)bookAddCB;                     
                data->edtnumber                       = editor_start(win, &data->editor_data);  /* start the editor */ 
            }
            //winShow( data->win );
        }
        break;
    case INPUT_MEMO:
        {
            data->phbk->MODE=MEMO;
            /* 2003/12/04 sunsj */
            if( data->edtmemo )
            {
                MfwWin * win = ((MfwHdr *)(data->edtnumber))->data;
                T_EDITOR_INFO *info = win->user;
                T_EDITOR_DATA *editor_data = &(info->editor_data);
                editor_data->mode = TEXTINPUT_MODE; /* 2003/12/04 sunsj modify for new editor mode */
                ec_editActivate(info->edt_edt,editor_data->mode);
                data->editor_data.min_enter = 1;    /* 2004/03/24 sunsj modify the minimum size */
                editor_data->editor_attr.text = (char *)data->phbk->edt_buf_memo;
                editor_data->editor_attr.size = PHB_memo_len+3;
                /* 2003/12/04 sunsj modify */
                winShow(data->edtmemo);
            }
            else
            {
                /* 2004/06/01 sunsj modify for LCD width */
#if(MAIN_LCD_SIZE==4)
                editor_attr_init_only(&data->editor_data.editor_attr, 0, 20, 128, 122, TITLE_TOP, title_id,NULL,PHB_memo_len+3,edtCurBar1,0);
#elif (MAIN_LCD_SIZE==3)
				editor_attr_init_only(&data->editor_data.editor_attr, 0, 16, 128, 113, TITLE_TOP, title_id,NULL,PHB_memo_len+3,edtCurBar1,0);
#endif
                //editor_attr_init_only(&data->editor_data.editor_attr,6,105,108,34,TITLE_TOP,title_id,NULL,PHB_memo_len+3,edtCurBar1,0);
                data->editor_data.editor_attr.fgColor = 0xE6FFFF;//0xFFF6C1; //2004-04-05 Sunny modify
                data->editor_data.hide                = FALSE;
                data->editor_data.min_enter           = 1;  /* 2004/03/24 sunsj modify the minimum size */
                data->editor_data.Identifier          = 0xFFFF;
                data->editor_data.edtInPbk            = 1;
                data->editor_data.timeout             = FOREVER;
                data->editor_data.destroyEditor       = FALSE;
                data->editor_data.editor_attr.text    = (char *)data->phbk->edt_buf_memo;
                data->editor_data.TextId              = title_id;
                data->editor_data.LeftSoftKey         = TxtSoftOK;      /* 2004/03/24 sunsj modify */
                data->editor_data.AlternateLeftSoftKey = TxtNull;       /* 2004/03/24 sunsj modify */
                data->editor_data.RightSoftKey        = TxtDelete;
                data->editor_data.mode                = TEXTINPUT_MODE;         /* 2003/12/04 sunsj modify for new editor mode */
                data->editor_data.Callback            = (T_EDIT_CB)bookAddCB;                      
                data->editor_data.InputMode           = PINYIN_INPUT_MODE;      /* 2003/12/04 sunsj */
                /* 2003/12/04 sunsj modify for new editor mode */
                data->edtmemo = text_input(win, &data->editor_data);  /* start the editor */ 
            }
            //winShow( data->win );             
        }
        break;
    case INPUT_DESTROY:
        {                                               
            bookInputDestroy( win );                       
        }
        break;
    }        
}

static int bookInputWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard *data = (tBookStandard *) w->user;

    TRACE_FUNCTION ("bookInputWindowCB()");

    // Handle the visible event, otherwise return MFW_EVENT_PASSED	
    switch( e )
    {
    case MfwWinVisible:
        {
            TRACE_EVENT("fzq windowcb");            
        }
        break;

    default:
        {
            // unabel to handle event, pass handling of event back up tree			
            return MFW_EVENT_PASSED;
        }
    }
    // if we get here, we have handled the event	
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:		bookInputCreate

 $Description:	Create the input window and asociate it's handlers
 
 $Returns:		handle of new window, or NULL if failure

 $Arguments:	parent, handle of the parent window
 
*******************************************************************************/

static T_MFW_HND bookInputCreate( MfwHnd parent )
{
    T_MFW_WIN       *parent_win_data    = ( (T_MFW_HDR *) parent )->data;
    tBookStandard    *parent_data        = (tBookStandard *) parent_win_data->user;
    T_phbk          *phbk               = parent_data->phbk;
    T_MFW_WIN       *win_data;
    tBookStandard   *data;

    TRACE_FUNCTION ("bookInputCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookInputWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *)data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog    = (T_DIALOG_FUNC) bookInputDialog;
    data->mmi_control.data      = data;
    win_data                    = ((T_MFW_HDR *)data->win)->data;
    win_data->user              = (void *) data;
    data->phbk                  = phbk;
    data->parent_win            = parent;

    return data->win;
}

/*******************************************************************************

 $Function:		bookInputDestroy

 $Description:	Destroy Input Window
 
 $Returns:		None

 $Arguments:	Handle of window to be destroyed
 
*******************************************************************************/

void bookInputDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard *data = (tBookStandard *) win->user;

    TRACE_FUNCTION ("bookInputDestroy()");

    if( data )
    {
        winDelete ( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

void SetWindowsHandle(T_MFW_HND win)
{ 
    GetWin=win;
}

T_MFW_HND GetWindowHandle()
{
    return GetWin;
}

void ClearWindowHandle()
{
    GetWin=0;  
}

void  getPhoneBookNumber(char *outstr,int Index ,T_BrowserWay way)
{
    T_MFW_PHB_ENTRY l_phb_Shortentry;
    PhbkDetailItem     l_phb_NVMentry;
    UINT32 b_color,f_color;
    U8 uStrLen = 15;


    if( Index<0 )
        return;
    switch( way )
    {
    case NONE:
        {
            if( l_phb_index[Index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(Index,&l_phb_Shortentry)==TRUE )
                {
                    truncateString(outstr,(char *)l_phb_Shortentry.number,uStrLen,1,".");                                                                                                            
                }
            }
            else if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
            {
                if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
                {
                    TRACE_EVENT("readnvmrecord sucess");
                    if( l_phb_NVMentry.number[0]!='\0' )
                    {
                        CurrentType=B_NUMBER;
                        // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                        //memcpy(outstr,(char *)l_phb_NVMentry.number,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.number,uStrLen,1,".");        
                    }
                    else if( l_phb_NVMentry.home[0]!='\0' )
                    {
                        CurrentType=B_HOME;
                        //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                        //memcpy(outstr,(char *)l_phb_NVMentry.home,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                    }
                    else if( l_phb_NVMentry.office[0]!='\0' )
                    {
                        CurrentType=B_OFFICE;
                        // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                        //memcpy(outstr,(char *)l_phb_NVMentry.office,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                    }
                }
            }
        }   
        break; 
    case TOLEFT:
        {
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,uStrLen,1,".");

                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                        else
                        {
                            //	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            truncateString(outstr,(char *)l_phb_NVMentry.number,uStrLen,1,".");

                        }   
                    }
                    break;
                case B_HOME:
                    {
                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,uStrLen,1,".");

                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //	 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));


                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            // dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                        else
                        {
                            //		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                    }   
                    break;
                case B_OFFICE:  
                    {
                        if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);

                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,uStrLen,1,".");

                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);


                        }
                        else
                        {
                            //     	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //     	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office); 
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                    }   
                    break;
                case B_MEMO:
                    {
                        if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //  	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,uStrLen,1,".");

                        }
                        else
                        {

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,uStrLen,1,".");

                        }   
                    }
                    break;
                default:break;
                } 
            }
        }  
        break;
    case TORIGHT:
        {  
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //      dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //    	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,uStrLen,1,".");


                        }
                        else
                        {
                            //     	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //     	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,uStrLen,1,".");

                        }
                    }  
                    break;
                case B_HOME:
                    {
                        if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);


                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;

                        }
                        else
                        {
                            //   		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //   		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                    }  
                    break;
                case B_OFFICE: 
                    {
                        if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //	 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);


                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {

                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //   	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //   	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                        else
                        {
                            //        		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //       		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office); 
                            truncateString(outstr,(char *)l_phb_NVMentry.office,uStrLen,1,".");

                        }
                    }  
                    break;
                case B_MEMO:
                    {
                        if( l_phb_NVMentry.number[0]!='\0' )
                        {


                        }

                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            // 	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,uStrLen,1,".");

                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {

                        }
                        else
                        {

                        }  
                    }
                    break;
                default:break;

                }
            }
        }  
        break;
    default:    break;
    }


}
void ShowPhoneBookNumber(int Index,T_BrowserWay way)
{
    T_MFW_PHB_ENTRY l_phb_Shortentry;
    PhbkDetailItem     l_phb_NVMentry;
    UINT32 b_color,f_color;
    char outstr[20]="";
#if(MAIN_LCD_SIZE==4)
	b_color=dspl_SetBkgColor(0xF8E0EE);
    dspl_Clear(0,126,SCREEN_SIZE_X,142);//128
#elif(MAIN_LCD_SIZE==3)
	dspl_Clear(0, 72, SCREEN_SIZE_X, 110);//콨
	b_color=dspl_SetBkgColor(0xffffff);
	DRAW_ICON_LOCATION(ICON_TEXTINPUT_abc, 0, 72);
#endif
    //dspl_DrawRect(0,112,119,144);//128
    f_color=dspl_SetFrgColor(0x000000);
    //dspl_SetBkgColor(0x0000ff);


    TRACE_EVENT("ShowPhoneBookNumber");

    if( Index<0 )
        return;
#if(MAIN_LCD_SIZE==4)
    switch( way )
    {
    case NONE:
        {
            if( l_phb_index[Index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(Index,&l_phb_Shortentry)==TRUE )
                {
                    truncateString(outstr,(char *)l_phb_Shortentry.number,12,1,".");
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                    dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);                                                                                                                
                }
            }
            else if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
            {
                if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
                {
                    TRACE_EVENT("readnvmrecord sucess");
                    if( l_phb_NVMentry.number[0]!='\0' )
                    {
                        CurrentType=B_NUMBER;
                        // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                        //memcpy(outstr,(char *)l_phb_NVMentry.number,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                        dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,(char *)outstr);                      
                    }
                    else if( l_phb_NVMentry.home[0]!='\0' )
                    {
                        CurrentType=B_HOME;
                        //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                        //memcpy(outstr,(char *)l_phb_NVMentry.home,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                        dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,(char *)outstr);
                    }
                    else if( l_phb_NVMentry.office[0]!='\0' )
                    {
                        CurrentType=B_OFFICE;
                        // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                        //memcpy(outstr,(char *)l_phb_NVMentry.office,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                        dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,(char *)outstr); 
                    }
                }
            }
        }  
        break; 
    case TOLEFT:
        {
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");

                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }   
                    }
                    break;
                case B_HOME:
                    {
                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //	 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                            //     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            // dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_OFFICE: 
                    {
                        if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);  
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);    
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //     	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //     	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office); 
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_MEMO:
                    {
                        if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //  	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);    
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }   
                    }
                    break;
                default:break;
                } 
            }
        }  
        break;
    case TORIGHT:
        {  
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //      dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //    	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);            
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //     	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //     	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);      
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_HOME:
                    {
                        if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);    
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //   		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //   		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);            
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_OFFICE: 
                    {
                        if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //	 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);               
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //   	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //   	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);                
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //        		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //       		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office); 
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);                 
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_MEMO:
                    {
                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //    	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //    	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);               
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }

                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            // 	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);       
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //      dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //    	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //      		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //     		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);
                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }   
                    }
                    break;
                default:break;

                }
            }
        }  
        break;
    default:    break;
    }
#elif(MAIN_LCD_SIZE==3)
	switch( way )
    {
    case NONE:
        {
            if( l_phb_index[Index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(Index,&l_phb_Shortentry)==TRUE )
                {
                    truncateString(outstr,(char *)l_phb_Shortentry.number,12,1,".");
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                    dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);                                                                                                                
                }
            }
            else if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
            {
                if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
                {
                    TRACE_EVENT("readnvmrecord sucess");
                    if( l_phb_NVMentry.number[0]!='\0' )
                    {
                        CurrentType=B_NUMBER;
                        // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                        //memcpy(outstr,(char *)l_phb_NVMentry.number,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                        dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,(char *)outstr);                      
                    }
                    else if( l_phb_NVMentry.home[0]!='\0' )
                    {
                        CurrentType=B_HOME;
                        //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                        //memcpy(outstr,(char *)l_phb_NVMentry.home,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                        dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,(char *)outstr);
                    }
                    else if( l_phb_NVMentry.office[0]!='\0' )
                    {
                        CurrentType=B_OFFICE;
                        // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                        //memcpy(outstr,(char *)l_phb_NVMentry.office,14);
                        truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                        //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                        dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,(char *)outstr); 
                    }
                }
            }
        }  
        break; 
    case TOLEFT:
        {
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");

                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }   
                    }
                    break;
                case B_HOME:
                    {
                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //	 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                            //     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            // dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            // dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_OFFICE: 
                    {
                        if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);  
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);    
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //     	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //     	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office); 
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_MEMO:
                    {
                        if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //  	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);    
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }   
                    }
                    break;
                default:break;
                } 
            }
        }  
        break;
    case TORIGHT:
        {  
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                switch( CurrentType )
                {
                case B_NUMBER:
                    {
                        if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //      dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //    	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);            
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //     	dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //     	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);      
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_HOME:
                    {
                        if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //		 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);    
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //   		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //   		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);            
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_OFFICE: 
                    {
                        if( wstrlen(l_phb_NVMentry.memo)!=0 )
                        {
                            CurrentType=B_MEMO;
                            //	 dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);

                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);        
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //    dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //  	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);               
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //   	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            //   	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);                
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //        		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //       		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office); 
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);                 
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                    }    
                    break;
                case B_MEMO:
                    {
                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            CurrentType=B_NUMBER;
                            //    	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterNumber));
                            //    	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.number);
                            truncateString(outstr,(char *)l_phb_NVMentry.number,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MOBILE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);               
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }

                        else if( l_phb_NVMentry.home[0]!='\0' )
                        {
                            CurrentType=B_HOME;
                            //  	     dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterHome));
                            // 	     dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.home);
                            truncateString(outstr,(char *)l_phb_NVMentry.home,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_HOME, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);       
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else if( l_phb_NVMentry.office[0]!='\0' )
                        {
                            CurrentType=B_OFFICE;
                            //      dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterOffice));
                            //    	dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.office);
                            truncateString(outstr,(char *)l_phb_NVMentry.office,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_OFFICE, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);         
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }
                        else
                        {
                            //      		dspl_TextOut(1,113,0,MmiRsrcGetText(TxtEnterMemo));
                            //     		dspl_TextOut(1,126,0,(char *)l_phb_NVMentry.memo);
                            truncateString(outstr,(char *)l_phb_NVMentry.memo,12,1,".");
                            /* 2004/06 sunsj modify for picture manage */
                            DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_MEMO, 1, SEARCH_NUMBER_SHOW, 0, ICON_LOCATION|ICON_MASK_OWN);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR); 
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                            //dspl_BitBlt(1,126,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                            dspl_TextOut(17,SEARCH_NUMBER_SHOW,0,outstr);
                        }   
                    }
                    break;
                default:break;

                }
            }
        }  
        break;
    default:    break;
    }
#endif
    dspl_SetBkgColor(b_color);
    dspl_SetFrgColor(f_color);
}
void ShortCutLocation(ListWinInfo  * dataInfo, char * NewKey,TABLE_TYPE table,
                      int *BufferIndex,int flag)    
{
    unsigned char SaveKey;
    BOOL        SetFlag,NoUpdate; 
    int           i,NewIndex;



    SetFlag=FALSE;   
    if( table==GlobalTable )
    {

        if( SearchIndex(&l_phb_sort_index[0],SearchTotal,(char *)NewKey,&NewIndex) )
            SetFlag=TRUE;

    }
    else if( table==SearchTable )
    {
        if( GetIndex(&bookname[0],SearchTotal,(char *)NewKey,&NewIndex) )
            SetFlag=TRUE;
    }
    if( SetFlag )
    {
        if( table==GlobalTable )
        {
            // 
            if( ((*BufferIndex)<=((*BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal)) && (NewIndex>=(*BufferIndex)) && (NewIndex<=(*BufferIndex)+PHONEBOOK_RECORD_PERPAGE-1) )
            {
                dataInfo->MenuListsAttr.pageturnindex=NewIndex+1;
                mnuChooseVisibleItem(dataInfo->MenuLists,NewIndex-(*BufferIndex));
                ShowPhoneBookNumber(l_phb_sort_index[NewIndex].index,NONE);   
            }
            else
            {
                NoUpdate=FALSE;
                if( (*BufferIndex)>(((*BufferIndex)+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal) )
                {
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        if( (*BufferIndex+i)%SearchTotal==NewIndex )
                        {
                            dataInfo->MenuListsAttr.pageturnindex=NewIndex+1;
                            mnuChooseVisibleItem(dataInfo->MenuLists,i);
                            ShowPhoneBookNumber(l_phb_sort_index[NewIndex].index,NONE);   
                            NoUpdate=TRUE;
                            break;
                        }
                    }
                }

                if( NoUpdate==FALSE )
                {
                    if( flag==200 )
                    {
                        for( i=0;i<GetFree(SearchTotal);i++ )
                        {
                            /* 2004/06 sunsj modify for picture manage */
                            memcpy(DynamicBuffer[i].name,l_phb_index[l_phb_sort_index[(NewIndex+i+SearchTotal)%SearchTotal].index].name,PHB_name_len);
                            if( l_phb_index[l_phb_sort_index[NewIndex+i].index].phonebook==NVM_BOOK_SEL )
                                DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                            else if( l_phb_index[l_phb_sort_index[NewIndex+i].index].phonebook==SIM_BOOK_SEL )
                                DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                        }    
                    }
                    else if( flag==100 )
                    {
                        for( i=0;i<GetFree(SearchTotal);i++ )
                        {
                            /* 2004/06 sunsj modify for picture manage */
                            memcpy(Dynamic_menu[i].name,l_phb_index[l_phb_sort_index[(NewIndex+i+SearchTotal)%SearchTotal].index].name,PHB_name_len);
                            if( l_phb_index[l_phb_sort_index[NewIndex+i].index].phonebook==NVM_BOOK_SEL )
                                Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                            else if( l_phb_index[l_phb_sort_index[NewIndex+i].index].phonebook==SIM_BOOK_SEL )
                                Dynamic_menu[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                        }    
                    }
                    dataInfo->MenuListsAttr.pageturnindex=NewIndex+1;
                    *BufferIndex=NewIndex;
                    mnuChooseVisibleItem(dataInfo->MenuLists,0);
                    ShowPhoneBookNumber(l_phb_sort_index[NewIndex].index,NONE); 
                }
            }  

        }
        else if( table==SearchTable )
        {
            // 
            if( ((*BufferIndex)<=((*BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal)) && (NewIndex>=(*BufferIndex)) && (NewIndex<=(*BufferIndex)+PHONEBOOK_RECORD_PERPAGE-1) )
            {
                dataInfo->MenuListsAttr.pageturnindex=NewIndex+1;
                mnuChooseVisibleItem(dataInfo->MenuLists,NewIndex-(*BufferIndex));
                ShowPhoneBookNumber(bookname[NewIndex].index,NONE);  
            }
            else
            {
                NoUpdate=FALSE;
                if( (*BufferIndex)>(((*BufferIndex)+PHONEBOOK_RECORD_PERPAGE-1)%SearchTotal) )
                {
                    for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                    {
                        if( (*BufferIndex+i)%SearchTotal==NewIndex )
                        {
                            dataInfo->MenuListsAttr.pageturnindex=NewIndex+1;
                            mnuChooseVisibleItem(dataInfo->MenuLists,i);
                            ShowPhoneBookNumber(bookname[NewIndex].index,NONE); 
                            NoUpdate=TRUE;
                            break;
                        }
                    }
                }

                if( NoUpdate==FALSE )
                {
                    for( i=0;i<GetFree(SearchTotal);i++ )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        memcpy(DynamicBuffer[i].name,l_phb_index[bookname[(NewIndex+i+SearchTotal)%SearchTotal].index].name,PHB_name_len);
                        if( l_phb_index[bookname[NewIndex+i].index].phonebook==NVM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_NVMBOOK, 0);//nvmbookicon;
                        else if( l_phb_index[bookname[NewIndex+i].index].phonebook==SIM_BOOK_SEL )
                            DynamicBuffer[i].bookicon = *GET_ICONATTR(ICON_SIMBOOK, 0);//simbookicon;
                    }    
                    dataInfo->MenuListsAttr.pageturnindex=NewIndex+1;
                    *BufferIndex=NewIndex;
                    menu_start_index=*BufferIndex;//yq added for choicecopy menu update icon.2003/2/28
                    mnuChooseVisibleItem(dataInfo->MenuLists,0);
                    ShowPhoneBookNumber(bookname[NewIndex].index,NONE);    
                }
            } 
        }
    }

}

static unsigned char SwitchChar(unsigned char InputChar)
{
    unsigned char backstr;

    switch( InputChar )
    {
    case 0x00: backstr='0';
        break;
    case 0x10: backstr='1';
        break;
    case 0x20: backstr='2';
        break;
    case 0x21: backstr='a';
        break;
    case 0x22: backstr='b';
        break;
    case 0x23: backstr='c';
        break;
    case 0x30: backstr='3';
        break;
    case 0x31: backstr='d';
        break;
    case 0x32: backstr='e';
        break;
    case 0x33: backstr='f';
        break;
    case 0x40: backstr='4';
        break;
    case 0x41: backstr='g';
        break;
    case 0x42: backstr='h';
        break;
    case 0x43: backstr='i';
        break;
    case 0x50: backstr='5';
        break;
    case 0x51: backstr='j';
        break;
    case 0x52: backstr='k';
        break;
    case 0x53: backstr='l';
        break;
    case 0x60: backstr='6';
        break;
    case 0x61: backstr='m';
        break;
    case 0x62: backstr='n';
        break;
    case 0x63: backstr='o';
        break;
    case 0x70: backstr='7';
        break;
    case 0x71: backstr='p';
        break;
    case 0x72: backstr='q';
        break;
    case 0x73: backstr='r';
        break;
    case 0x74: backstr='s';
        break;
    case 0x80: backstr='8';
        break;
    case 0x81: backstr='t';
        break;
    case 0x82: backstr='u';
        break;
    case 0x83: backstr='v';
        break;
    case 0x90: backstr='9';
        break;
    case 0x91: backstr='w';
        break;
    case 0x92: backstr='x';
        break;
    case 0x93: backstr='y';
        break;
    case 0x94: backstr='z';
        break;
    default:    backstr='^';
        break;                                                      
    }
    return backstr;
}


/*******************************************************************************

 $Function:    	bookSearchName

 $Description:	locate a requested name in the phone book
 
 $Returns:		status of the findName routine

 $Arguments:	pattern, to be searched for
                number,  of elements to limit the search to
                current, pointer to a buffer to store the results
 
*******************************************************************************/

UBYTE bookSearchName (char *pattern,UBYTE number,tMmiPhbData *current)
{
    UBYTE ret;
#ifdef NO_ASCIIZ
    T_MFW_PHB_TEXT l_name;
    char debug[50];
#else
    UBYTE l_name[PHB_name_len];
#endif
    UBYTE len;
    int   i;

    TRACE_EVENT( "bookSearchName()" );

    /* if using UPN phone book, return status of findname
    */
    if( current->status.book == PHB_UPN )
        return ret = current->result = bookFindName( MAX_SEARCH_NAME, current );

    /* otherwise we need to be a little bit more clever with this
    */
    memset( current->entry, 0, MAX_SEARCH_CALL_LIST * sizeof( T_MFW_PHB_ENTRY ) );
    bookGetCurrentStatus( &current->status );

    current->list.entry         = current->entry;
    current->list.num_entries   = number;

    /* convert from GSM characters
    */
#ifdef NO_ASCIIZ

    memset( l_name.data, 0, PHB_name_len );
    mfw_Gsm2SIMStr( MFW_DCS_7bits, (UBYTE *) pattern, PHB_name_len, l_name.data, &l_name.len );
#else
    memset( l_name, 0, PHB_name_len );
    mfw_Gsm2SIMStr( MFW_DCS_7bits, (UBYTE *) pattern, PHB_name_len, l_name, &len );
#endif
    /* perform a search to locate a match with this criteria
    */
    if( strlen(pattern) != 0 )
    {
#ifdef WIN32
#ifndef NO_ASCIIZ
        sprintf(debug, "Search str: %s", l_name.data);
        TRACE_EVENT(debug);
        ret = phb_find_entries( current->status.book, &current->index, MFW_PHB_ALPHA, number, (UBYTE *) l_name, len, &current->list );
#endif
#else
        //not WIN32

#ifdef NO_ASCIIZ
        ret = phb_find_entries( current->status.book, &current->index, MFW_PHB_ALPHA, number, &l_name, &current->list );
#else
        ret = phb_find_entries( current->status.book, &current->index, MFW_PHB_ALPHA, number, (char *) l_name, &current->list );
#endif //NO_ASCIIZ

#endif //WIN32
    }
    else
    {
        /* we don't have any name information, so start at the beginning
        */
        current->index = 1;
        current->selectedName = 0;
        bookFindName( MAX_SEARCH_NAME, current );
    }

    /* check for match
    */
    if( ( current->list.num_entries < MAX_SEARCH_NAME )
        || ( current->list.result == MFW_NO_ENTRY ) || ( ret == PHB_FAIL ) )
    {
        /* no, then try to find again
        */
        ret = bookFindName( MAX_SEARCH_NAME, current );
    }
    else
    {
        for( i = 0; i < number; i++ )
#ifdef NO_ASCIIZ


#ifdef EASY_TEXT_ENABLED
            if( ret != PHB_FAIL &&  strlen(pattern) != 0 ) //if a match was found 
            {
                /* convert from Sim to GSM and then copy to output buffer
                */

                int actual_length;
                char temp[PHB_name_len+1];
                int j;

                if( current->entry[i].name.data[0] == 0x80 )
                {
                    for( j=1; j<PHB_name_len; j+=1 )
                    {
                        temp[j+1] = current->entry[i].name.data[j];

                    }
                    temp[0] =   current->entry[i].name.data[0]; 
                    temp[1] = PHB_name_len;

                    memcpy( current->entry[i].name.data, (char*)temp, PHB_name_len );


                    for( j=0; j < PHB_name_len; j+=2 ) //work out string length
                    {
                        if( current->entry[i].name.data[j] == 0 && current->entry[i].name.data[j+1] == 0 )
                        {
                            if( j== 0 )
                                actual_length =0;
                            else
                                actual_length = j -2;
                            break;
                        }
                    }
                    current->entry[i].name.len = actual_length;


                }

                else
                {
                    bookGsm2Alpha( (UBYTE *) current->entry[i].name.data );
                    //mfw_SIM2GsmStr( current->entry[i].name.len, current->entry[i].name.data, PHB_name_len, l_name );
                    //memcpy( current->entry[i].name.data, l_name.data, PHB_name_len );
                }
            }
            else
#endif
            {

                bookGsm2Alpha( (UBYTE *) current->entry[i].name.data );
                //mfw_SIM2GsmStr( current->entry[i].name.len, current->entry[i].name.data, PHB_name_len, l_name );
                //memcpy( current->entry[i].name.data, l_name.data, PHB_name_len );
            }
#else
            /* convert from GSM to Alpha characters
                        */
            bookGsm2Alpha( (UBYTE *) current->entry[i].name );

#endif
    }

    /* return the status, and store it as part of current as well
    */
    return current->result = ret;
}

//begin xzy add 2002/10/24 for grouping icon



T_MFW_HND iconSelect_create( MfwHnd parent_window)
{
    T_MFW_WIN  * win;
    iconSelect_data* data = (iconSelect_data *)ALLOC_MEMORY (sizeof (iconSelect_data ));

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->win = win_create(parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)iconselect_win_cb);
    if( data->win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)iconSelect_DialogCB;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent_win         = parent_window;
    data->kbd=kbd_create(data->win,KEY_ALL,(T_MFW_CB)iconselect_kbd_cb);

    return data->win;
}

/* 2004/03/11 sunsj modify group icon */
static int  iconselect_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    iconSelect_data* data = (iconSelect_data *)win->user;    
    //const unsigned char str[];
    int i;
    int old_color;

    TRACE_EVENT ("iconselect_win_cb");


    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        if( win->flags & E_WIN_VISIBLE )
        {
            /*
             * Clear Screen
             */
            dspl_ClearAll();

            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_MENUUP);
            //dspl_BitBlt(0, 0, menuup[0].area.sx, menuup[0].area.sy, 0, (void *)menuup[0].icons, 0);
            dspl_colorTextOut(28, 0, DSPL_TXTATTR_TRANSPARENT, (char *)MmiRsrcGetText(TxtGroupingIcon),0x000000 );

            old_color=dspl_GetBkgColor();
            dspl_SetBkgColor(0x0000ff);
            dspl_Clear(data->position/4*30+5, data->position%4*30+18+5, data->position/4*30+23, data->position%4*30+18+23);
            //dspl_Clear(data->position/4*25+6, data->position%4*13+12, data->position/4*25+20, data->position%4*13+26);
            //memset(str,0,20);

            for( i=0;i<16;i++ )
            {
                /* 2004/06 sunsj modify for picture manage */
                DRAW_ICON_ATTRIBUTE(ICON_PHONEBOOK_GROUP, i/4*30+7, i%4*30+18+7, i, ICON_LOCATION);
                //dspl_BitBlt(i/4*30+7, i%4*30+18+7, 14, 14, 0, (void *)BookGroupingIcon[i].icons, 0);   
            }
            dspl_SetBkgColor(old_color);                
            displaySoftKeys(TxtSoftSelect, TxtSoftBack);
        }
        break;
    default:
        return 0;
    }
    return 1;
}


static void iconSelect_DialogCB(T_MFW_HND win, USHORT event,  SHORT value, void * parameter)
{
    T_MFW_WIN  * win_data   = ( (T_MFW_HDR *) win )->data;
    iconSelect_data * data = (iconSelect_data *) win_data->user;


    TRACE_EVENT("iconSelect_DialogCB"); 
    switch( event )
    {
    case ICONSELECT_INIT:
        data->position=0;
        winShow(win);
        break;
    case ICONSELECT_EXIT:
        iconSelect_destroy(win);
        break;
    }
}

/* 2004/05/20 sunsj modify */
static int iconselect_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    iconSelect_data * data=(iconSelect_data *)win_data->user;

    T_DISPLAY_DATA  display_info;
    int i;
    char temp[22];

    MfwHdr *temp_hdr;
    T_MFW_WIN    *   temp_win;
    tBookStandard *  temp_data;

    TRACE_EVENT("iconselect_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_MNUDOWN:
        if( data->position%4<3 )

            data->position++;

        else
            data->position-=3;

        winShow(win);
        break;

    case KCD_MNUUP:
        if( data->position%4>0 )

            data->position--;

        else
            data->position+=3;

        winShow(win);
        break;

    case KCD_MNULEFT:
        if( data->position/4>0 )

            data->position-=4;

        else
            data->position+=12;

        winShow(win);
        break;

    case KCD_MNURIGHT:
        if( data->position/4<3 )

            data->position+=4;

        else
            data->position-=12;

        winShow(win);
        break;

    case KCD_LEFT:
    case KCD_OK:
        {
            if( data->position==15 )
            {
                display_info.KeyEvents    = KEY_CLEAR;
                display_info.TextId       = TxtOnlyforBlacklist;
                display_info.TextId2      = 0;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.LeftSoftKey  = TxtNull;
                display_info.RightSoftKey = TxtNull;
                display_info.Time         =500;
                display_info.Callback     = NULL;
                //display_info.iconindex    =data->position+85;TxtEditSucceed
            }
            else
            {
                FFS_PBOtherData.GroupingItem[IconSelect].GroupingIcon=data->position+85;
                TRACE_EVENT("now we show the father win!");
                temp_hdr = (MfwHdr *)mfwParent(mfwParent(mfwParent( mfw_header() )));   ///return mfwhdr of grouping dialog
                ////zgzTraceDataFunc("yq:temp_hdr:",(unsigned short)(temp_hdr));
                ////zgzTraceDataFunc("yq:temp_hdr's fater:",(unsigned short)mfwParent(temp_hdr));
                temp_hdr=(MfwHdr *)mfwParent(temp_hdr);
                temp_win=(T_MFW_WIN *)(temp_hdr->data);
                temp_data = (tBookStandard *) (temp_win->user);
                /* 2004/06 sunsj modify for picture manage */
                temp_data->menu_list_data->List[IconSelect].icon = GET_ICONATTR(ICON_PHONEBOOK_GROUP, data->position);//&BookGroupingIcon[data->position];
                //ListData->MenuData = *Data; /* copy contents */

                //temp_win->data->menu_list_data->List[i].icon = &BookGroupingIcon[data];

                //wstrcpy(temp,MmiRsrcGetText(TxtEditSucceed));
                /*
                display_info.KeyEvents    = KEY_CLEAR;
                display_info.TextId       = TxtRenameForbidden;
                display_info.TextId2      = 0;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.LeftSoftKey  = TxtNull;
                display_info.RightSoftKey = TxtNull;
                display_info.Time         =2000;
                display_info.Callback     = NULL;
                display_info.iconindex    =data->position+85;TxtEditSucceed
                */
                dialog_info_init(&display_info);//gdy add 
                display_info.KeyEvents    = KEY_CLEAR;
                display_info.TextId       = 0;
                display_info.TextId2      = TxtGroupingIconSucceed;
                display_info.TextString   = '\0';
                display_info.TextString2  = '\0';
                display_info.LeftSoftKey  = TxtNull;
                display_info.RightSoftKey = TxtNull;
                display_info.Time         =ONE_SECS;
                display_info.Callback     = NULL;
                display_info.iconindex=REMIND_SUCCEED;
                //display_info.iconindex    =data->position+85;
            }
            info_dialog( win, &display_info );

            flash_PBOtherWrite("PBOption");
        }
        break;

    case KCD_RIGHT:
    case KCD_HUP:
        iconSelect_destroy(data->win);
        break;
    }

    return MFW_EVENT_CONSUMED;
}


void iconSelect_destroy(T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    iconSelect_data* data   = (iconSelect_data*)win->user;

    TRACE_EVENT ("iconSelect_destroy()");


    if( own_window )
    {
        /*
         * Delete WIN Handler
         */


        win_delete (own_window);
        /*
         * Free Memory
        */
        FREE_MEMORY ((void *)data, sizeof (iconSelect_data));
    }
}
//end xzy add 2002/10/24 for grouping icon


static void show_number()
{
    UBYTE old_mode;
    UINT32 b_color;
    TRACE_EVENT("show_number");
    if( show_timer )
    {
        timStop(show_timer);
        timStart(show_timer);
    }
    if( refresh_flag==1 )
    {
        old_mode=dspl_Enable(0);
        b_color=dspl_SetBkgColor(0xF8E0EE);
#if(MAIN_LCD_SIZE==4)
        dspl_Clear (0,126,SCREEN_SIZE_X,142);
#endif
        dspl_SetBkgColor(b_color);
		refresh_flag=0;
        dspl_Enable(old_mode);
    }
}

static T_MFW_CB show_timercb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHdr *win=(MfwHdr *)mfwParent((MfwHdr *)show_timer);
    T_MFW_WIN     *win_data=(MfwWin *)(win->data);
    tBookStandard   *data=(tBookStandard *)(win_data->user);
    T_phbk           * Phbk     = data->phbk;
    MfwHdr *mnu_win=data->menu_list_data->win;//yq modified 2003/3/12.(MfwHdr *)mfwParent(mfwFocus)	
    MfwHdr *mnu_win1;
    if( data->menu_list_data2!=NULL )
    {
        mnu_win1=data->menu_list_data2->win;
    }
    timStop(show_timer);
    refresh_flag=1;
    if( winIsFocussed(mnu_win)||winIsFocussed(mnu_win1) )//current we have't call win
        ShowPhoneBookNumber(show_index,NONE);
    return 0;
}

static void yq_edtchar(T_MFW_HND edt,unsigned char code)
{
    MfwHdr *win=(MfwHdr *)mfwParent((MfwHdr *)edt);
    T_MFW_WIN     *win_data=(MfwWin *)(win->data);
    tBookStandard   *data=(tBookStandard *)(win_data->user);
    TRACE_EVENT("yq_edtchar");
    if( edt_timer )
        timStop(edt_timer);
    if( cursor_correct )
    {
        edtChar(edt,edt_key[code-2][key_index]);
        edtChar(edt,ecLeft);
        timStart(edt_timer);

        key_index=0;
    }
    else
    {
        if( code==key_before )
        {
            key_index++;
            if( key_index>=wstrlen((char *)edt_key[code-2]) )
                key_index=0;
            edtChar(edt,ecDel);
            edtChar(edt,edt_key[code-2][key_index]);
            edtChar(edt,ecLeft);
            timStart(edt_timer);
        }
        else
        {
            edtChar(edt,ecRight);
            edtChar(edt,edt_key[code-2][0]);
            edtChar(edt,ecLeft);
            timStart(edt_timer);

            key_index=0;

        }
    }
    cursor_correct=0;
    key_before=code;
    TRACE_EVENT("yq:now the edt buffer:");
    TRACE_EVENT((char *)data->edtBuf);
}

static T_MFW_CB edt_timer_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    MfwHdr *win=(MfwHdr *)mfwParent((MfwHdr *)edt_timer);
    T_MFW_WIN     *win_data=(MfwWin *)(win->data);
    tBookStandard   *data=(tBookStandard *)(win_data->user);
    T_phbk           * Phbk     = data->phbk;
    MfwHdr *mnu_win=data->menu_list_data->win;//yq modified 2003/3/12.(MfwHdr *)mfwParent(mfwFocus)
    T_MFW_WIN *mnu_data=(MfwWin *)(mnu_win->data);
    ListWinInfo        * dataInfo = (ListWinInfo *)mnu_data->user;
    MfwHdr *mnu_win1;
    TRACE_EVENT("edt_timer_cb");
    if( data->menu_list_data2 )
    {
        mnu_win1=data->menu_list_data2->win;
        if( mnu_win1 )
            mnu_data=(MfwWin *)(mnu_win1->data);
        if( mnu_data )
            dataInfo=(ListWinInfo *)mnu_data->user;
    }
    timStop(edt_timer);
    key_before=0xff;
    cursor_correct=1;
    key_index=0;
    if( winIsFocussed(mnu_win)||winIsFocussed(mnu_win1) )//current we have't call win
    {
        ShortCutLocation(dataInfo,(char *)data->edtBuf,Phbk->BufferTable,&(Phbk->BufferIndex),200);
        edtChar(data->edt,ecRight);
    }
    return 0;
}

//begin yq add for the detail window
static void ShowDetailNumber(MfwHnd window,int direct)
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard *data = (tBookStandard *) win->user;
    T_phbk          *phbk       = data->phbk;
    int Index;
    PhbkDetailItem     l_phb_NVMentry;

    UINT32          oldFontColor,oldbackcolor;      /* 2003/10/21 sunsj */

    if( phbk->BufferTable==GlobalTable )
        Index=l_phb_sort_index[phbk->select_index].index;
    else if( phbk->BufferTable==SearchTable )
        Index=bookname[phbk->select_index].index;
    else
        return ;
    if( direct==1 )//show next number
    {
        if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
        {
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                /* 2003/11/1 sunsj modify for softkey display */
                displaySoftKeys(TxtSoftCall,TxtSoftBack);
                if( data->status_of_timer == 1 )//current is number
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 2;

                    /* 2004/03/11 sunsj modify the display area */
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    dspl_Clear(0,PHONE_MOBILENUM_Y-2,SCREEN_SIZE_X,PHONE_MOBILENUM_Y+PHONE_LINE_HEIGHT);
              /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);

                    /* 2003/10/28 sunsj */
                    if( l_phb_NVMentry.number[0]!='\0' )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)l_phb_NVMentry.number, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, 0, (char *)l_phb_NVMentry.number);
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, 0, MmiRsrcGetText(TxtEnterNumber));
                    }
                    /* when in mobile number line the user press down key. Clear the mobile number
                       line, refresh the mobile number line. */

                    /* 2004/03/11 sunsj modify display area*/
                    dspl_Clear(0,PHONE_HOMENUM_Y-2,SCREEN_SIZE_X,PHONE_HOMENUM_Y+PHONE_LINE_HEIGHT);//jhxu modify
                    /* 2004/06 sunsj modify for picture manage */

                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_HOMENUM_Y-1);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_HOME);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);

                    /* 2004/03/30 sunsj modify */
                    oldFontColor=dspl_SetFrgColor(0x000000);
                    if( l_phb_NVMentry.home[0]!='\0' )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)l_phb_NVMentry.home, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_HOMENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.home);
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_HOMENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterHome));
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /* clear the home number line, display homenumber icon and home number */

                    dspl_SetFrgColor(oldFontColor);
                    dspl_SetBkgColor(oldbackcolor);

                    /*
                    if ( l_phb_NVMentry.office[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        data->status_of_timer=2;
                    }
                    else if ( l_phb_NVMentry.home[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        data->status_of_timer=3;
                    }
                    else if ( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                        data->status_of_timer=4;
                    }
                    */
                }
                /* 2003/10/21 sunsj modify for home detail */
                else if( data->status_of_timer==2 )//current is home
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 3;
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_HOMENUM_Y-2,SCREEN_SIZE_X,PHONE_HOMENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_HOME);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);

                    if( strlen((char *)l_phb_NVMentry.home)!=0 )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)l_phb_NVMentry.home, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)l_phb_NVMentry.home); 
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
                    }
                    /* when in home line the user press down key. Clear the home number
                       line, refresh the home number line. */

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_OFFICENUM_Y-2,SCREEN_SIZE_X,PHONE_OFFICENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/03/30 sunsj modify */
                    oldFontColor=dspl_SetFrgColor(0x000000);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_OFFICENUM_Y-1);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_OFFICE);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);

                    if( l_phb_NVMentry.office[0]!='\0' )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)l_phb_NVMentry.office, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_OFFICENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.office);
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_OFFICENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterOffice));
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /* clear the office number line, display office number line */

                    dspl_SetFrgColor(oldFontColor);
                    dspl_SetBkgColor(oldbackcolor);
                    /*
                    if ( l_phb_NVMentry.home[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        data->status_of_timer=3;
                    }
                    else if ( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                        data->status_of_timer=4;
                    }
                    else if ( l_phb_NVMentry.number[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        data->status_of_timer=1;
                    }
                    */
                }
                /* 2004/03/30 sunsj modify for phone detail */
                else if( data->status_of_timer==3 )//current is office
                {
#if 0
                    if( l_phb_NVMentry.office[0]!='\0' )
                    {
                        displaySoftKeys(TxtCall,TxtSoftBack);
                    }
                    else
                    {
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
#endif
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 4;
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_OFFICENUM_Y-2,SCREEN_SIZE_X,PHONE_OFFICENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_OFFICE);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);

                    if( strlen((char *)l_phb_NVMentry.office)!=0 )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)l_phb_NVMentry.office, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)l_phb_NVMentry.office); 
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
                    }
                    /* when in office line the user press down key. Clear the office number
                       line, refresh the office line. */

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_MEMO_Y-2,SCREEN_SIZE_X,PHONE_MEMO_Y+PHONE_LINE_HEIGHT);
                    /* 2004/03/30 sunsj modify */
                    oldFontColor=dspl_SetFrgColor(0x000000);

                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_MEMO_Y-1);
                    //dspl_BitBlt(2,PHONE_MEMO_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MEMO);
                    //dspl_BitBlt(2,PHONE_MEMO_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MEMO_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_MEMO_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);

                    if( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    else
                    {
                        dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MEMO_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterMemo));
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /* clear the memo line, display the memo icon and momo line */

                    dspl_SetFrgColor(oldFontColor);
                    dspl_SetBkgColor(oldbackcolor);
                    /*
                    if ( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                        data->status_of_timer=4;
                    }
                    else if ( l_phb_NVMentry.number[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        data->status_of_timer=1;
                    }
                    else if ( l_phb_NVMentry.office[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        data->status_of_timer=2;
                    }
                    */
                }
                else if( data->status_of_timer == 4 )//current is memo
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    /* when in memo line the downkey is no respond */
                    data->status_of_timer = 4;

                    /* 2003/11/1 sunsj modify for softkey display */
                    displaySoftKeys(TxtNull,TxtSoftBack);
                    /*
                    if ( l_phb_NVMentry.number[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        data->status_of_timer=1;
                    }
                    else if ( l_phb_NVMentry.office[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        data->status_of_timer=2;
                    }
                    else if ( l_phb_NVMentry.home[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        data->status_of_timer=3;
                    }
                    */
                }
            }
            else
                TRACE_EVENT("read nvm error");
        }
    }
    else if( direct==2 )//show previous number
    {
        if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
        {
            if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
            {
                /* 2003/10/21 sunsj softkey display */
                displaySoftKeys(TxtSoftCall,TxtSoftBack);
                if( data->status_of_timer == 1 )//current is number
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 1;

                    /* 2003/11/1 sunsj modify for softkey display */
                    if( strlen((char *)l_phb_NVMentry.number)!=0 )
                    {
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                    }
                    else
                    {
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /*
                    if ( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                        data->status_of_timer=4;
                    }
                    else if ( l_phb_NVMentry.home[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        data->status_of_timer=3;
                    }
                    else if ( l_phb_NVMentry.office[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        data->status_of_timer=2;
                    }
                    */
                }
                /* 2003/10/21 sunsj modify for home detail */
                else if( data->status_of_timer == 2 )//current is home
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 1;
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_HOMENUM_Y-2,SCREEN_SIZE_X,PHONE_HOMENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_HOME);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);

                    if( strlen((char *)l_phb_NVMentry.home)!=0 )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)l_phb_NVMentry.home, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)l_phb_NVMentry.home); 
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
                    }
                    /* when user press up key in home number. Clear the home number line, refresh 
                       the home number line */

                    /* 2004/03/30 sunsj modify display area */
                    oldFontColor=dspl_SetFrgColor(0x000000);
                    dspl_Clear(2,PHONE_MOBILENUM_Y-2,SCREEN_SIZE_X,PHONE_MOBILENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_MOBILENUM_Y-1);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);

                    if( l_phb_NVMentry.number[0]!='\0' )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)l_phb_NVMentry.number, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.number);
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterNumber));
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /* clear mobile number line, display mobilenumber icon and mobile number */

                    dspl_SetBkgColor(oldbackcolor);
                    dspl_SetFrgColor(oldFontColor);
                    /*
                    if ( l_phb_NVMentry.number[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        data->status_of_timer=1;
                    }
                    else if ( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                        data->status_of_timer=4;
                    }
                    else if ( l_phb_NVMentry.home[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        data->status_of_timer=3;
                    }
                    */
                }
                /* 2003/10/21 sunsj modify for home detail */
                else if( data->status_of_timer==3 )//current is office
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 2;
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_OFFICENUM_Y-2,SCREEN_SIZE_X,PHONE_OFFICENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_OFFICE);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);

                    if( strlen((char *)l_phb_NVMentry.office)!=0 )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)l_phb_NVMentry.office, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)l_phb_NVMentry.office); 
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
                    }
                    /* when user press up key in office number. Clear the office number line, refresh 
                       the office number line */

                    /* 2004/03/30 sunsj modify */
                    oldFontColor=dspl_SetFrgColor(0x000000);
                    dspl_Clear(2,PHONE_HOMENUM_Y-2,SCREEN_SIZE_X,PHONE_HOMENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_HOMENUM_Y-1);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_HOME);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_HOMENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)homeicon,DSPL_BMPXOR);

                    if( l_phb_NVMentry.home[0]!='\0' )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)l_phb_NVMentry.home, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_HOMENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.home);
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_HOMENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterHome));
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /* clear home number line, display homenumber icon and home number */

                    dspl_SetBkgColor(oldbackcolor);
                    dspl_SetFrgColor(oldFontColor);
                    /*
                    if ( l_phb_NVMentry.office[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        data->status_of_timer=2;
                    }
                    else if ( l_phb_NVMentry.number[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        data->status_of_timer=1;
                    }
                    else if ( l_phb_NVMentry.memo[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                        displaySoftKeys(TxtNull,TxtSoftBack);
                        data->status_of_timer=4;
                    }
                    */
                }
                else if( data->status_of_timer==4 )//current is memo
                {
                    /* 2003/10/21 sunsj modify for new book detail */
                    data->status_of_timer = 3;
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/03/11 sunsj modify display area */
                    dspl_Clear(2,PHONE_MEMO_Y-2,SCREEN_SIZE_X,PHONE_MEMO_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MEMO);
                    //dspl_BitBlt(2,PHONE_MEMO_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MEMO_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memofficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_MEMO_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)memoicon,DSPL_BMPXOR);

                    if( strlen((char *)l_phb_NVMentry.memo)!=0 )
                    {
                        dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MEMO_Y,110,0,(char *)l_phb_NVMentry.memo); 
                    }
                    else
                    {
                        dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MEMO_Y,110,0,(char *)MmiRsrcGetText(TxtEnterMemo)); 
                    }
                    /* when user press up key in memo. Clear the memo line, refresh 
                       the memo line */

                    /* 2004/03/30 sunsj modify */
                    oldFontColor=dspl_SetFrgColor(0x000000);
                    dspl_Clear(2,PHONE_OFFICENUM_Y-2,SCREEN_SIZE_X,PHONE_OFFICENUM_Y+PHONE_LINE_HEIGHT);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_OFFICENUM_Y-1);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_OFFICE);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_OFFICENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)officeicon,DSPL_BMPXOR);

                    if( l_phb_NVMentry.office[0]!='\0' )
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)l_phb_NVMentry.office, dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_OFFICENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.office);
                    }
                    else
                    {
                        /* 2003/11/10 sunsj the number is one line display */
                        drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
                        //dspl_TextOut_Blk(22, PHONE_OFFICENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterOffice));
                        displaySoftKeys(TxtNull,TxtSoftBack);
                    }
                    /* clear office number line, display officenumber icon and office number */

                    dspl_SetBkgColor(oldbackcolor);
                    dspl_SetFrgColor(oldFontColor);
                    /*
                    if ( l_phb_NVMentry.home[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        data->status_of_timer=3;
                    }
                    else if ( l_phb_NVMentry.office[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        data->status_of_timer=2;
                    }
                    else if ( l_phb_NVMentry.number[0]!='\0' )
                    {
                        dspl_Clear(0,84,119,138);
                        dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                        dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        data->status_of_timer=1;
                    }
                    */
                }
            }
            else
                TRACE_EVENT("read nvm error");
        }
    }
}

static void bookShowDetailDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard *data = (tBookStandard *) win->user;

    TRACE_EVENT ("bookInputDestroy()");

    if( data )
    {
        winDelete ( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}

static int bookShowDetailKbdCB(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN		* ww=(MfwWin *)(((MfwHdr *)win)->data);
    tBookStandard	*data = (tBookStandard *) ww->user;
    T_phbk          *phbk       = data->phbk;
    int Index;
    T_MFW_PHB_ENTRY l_phb_SIMentry;
    PhbkDetailItem  l_phb_NVMentry;
    TRACE_EVENT("bookShowDetailKbdCB");
    if( phbk->BufferTable==GlobalTable )
	{
        Index=l_phb_sort_index[phbk->select_index].index;
	}
    else if( phbk->BufferTable==SearchTable )
	{
        Index=bookname[phbk->select_index].index;
	}

	/* 2004/06/30 sunsj modify */
	memset(&l_phb_SIMentry, 0x00, sizeof(l_phb_SIMentry));
	memset(&l_phb_NVMentry, 0x00, sizeof(l_phb_NVMentry));

    //Index=l_phb_sort_index[phbk->select_index].index;
    switch( keyboard->code )
    {
    case KCD_MNUDOWN:
    case KCD_MNURIGHT:
        //ShowDetailBookNumber(win,1);
        ShowDetailNumber(win,1);
        break;
    case KCD_MNUUP:
    case KCD_MNULEFT:
        ShowDetailNumber(win,2);
        //ShowDetailBookNumber(win,2);
        break;
    case KCD_CALL:
    case KCD_LEFT:
    case KCD_OK:
        {
            if( l_phb_index[Index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(Index,&l_phb_SIMentry)==TRUE )
                {
                    T_EasyName data;
                    memset(&data, 0x00, sizeof(data));
                    memcpy(data.name,(char *)l_phb_SIMentry.name.data,PHB_name_len+2);
                    memcpy(data.number,(char *)l_phb_SIMentry.number,PHB_number_len);
                    SetCallData(data);
                    callNumber((UBYTE *)l_phb_SIMentry.number);
                }
                else
                    TRACE_EVENT("read sim error");
            }
            else if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
            {
                if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
                {
                    T_EasyName data1;
                    memset(&data1, 0x00, sizeof(data));
                    memcpy(data1.name,(char *)l_phb_NVMentry.name,PHB_name_len+2);
                    /* 2003/11/1 sunsj modify the turn of home and office number */
                    if( data->status_of_timer==1 )
                    {
                        memcpy(data1.number,(char *)l_phb_NVMentry.number,PHB_number_len);
                    }
                    else if( data->status_of_timer==2 )
                    {
                        //memcpy(data1.number,(char *)l_phb_NVMentry.office,PHB_number_len);
                        memcpy(data1.number,(char *)l_phb_NVMentry.home,PHB_number_len);
                    }
                    else if( data->status_of_timer==3 )
                    {
                        //memcpy(data1.number,(char *)l_phb_NVMentry.home,PHB_number_len);
                        memcpy(data1.number,(char *)l_phb_NVMentry.office,PHB_number_len);
                    }
                    SetCallData(data1);
                    callNumber((UBYTE *)data1.number);
                }
                else
                    TRACE_EVENT("read nvm error");
            }
        }
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        bookShowDetailDestroy(win);
        break;
    }

}

/* 2003/11/1 sunsj modify display area and display method */
static int bookShowDetailWindowCB( MfwEvt e, MfwWin *w )
{
    tBookStandard	*data = (tBookStandard *) w->user;
    T_phbk          *phbk       = data->phbk;
    UINT32			oldbackcolor,oldFontColor, oldfontcolor;   /* 2003/10/21 sunsj */
    int Index;
    T_MFW_PHB_ENTRY		l_phb_SIMentry;
    PhbkDetailItem		l_phb_NVMentry;  
    TRACE_EVENT("bookShowDetailWindowCB()");

	/* 2004/06/30 sunsj modify */
	memset(&l_phb_SIMentry, 0x00, sizeof(l_phb_SIMentry));
	memset(&l_phb_NVMentry, 0x00, sizeof(l_phb_NVMentry));
    // Handle the visible event, otherwise return MFW_EVENT_PASSED	
    switch( e )
    {
    case MfwWinVisible:
        {
            dspl_ClearAll();


            /* 2004/03/08 sunsj modify for phone book display */
            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON(ICON_MENUUP);
            //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
            drawcolorclarity((SCREEN_SIZE_X-wstrBitlen(MmiRsrcGetText(TxtShowDetails))*8)/2,1,MmiRsrcGetText(TxtShowDetails), 0x000000);

            //yq show the title and the draw the line;

            /* 2003/10/21 sunsj remove for new book detail */
            //oldcolor=dspl_SetFrgColor(0x0000ff);dspl_DrawLine(0,19,119,19);dspl_DrawLine(0,78,119,78);dspl_SetFrgColor(oldcolor);

            /* 2003/11/1 sunsj remove */
            //dspl_TextOut(1,22,0,MmiRsrcGetText(TxtEnterName));

            /* 2003/10/21 sunsj remove for new book detail */
            //oldcolor=dspl_SetFrgColor(0x0000ff);dspl_DrawLine(0,81,119,81);dspl_DrawLine(0,140,119,140);dspl_SetFrgColor(oldcolor);

            if( phbk->BufferTable==GlobalTable )
                Index=l_phb_sort_index[phbk->select_index].index;
            else if( phbk->BufferTable==SearchTable )
                Index=bookname[phbk->select_index].index;
            else
                return 0;

            if( l_phb_index[Index].phonebook==SIM_BOOK_SEL )
            {
                if( ReadSIMRecord(Index,&l_phb_SIMentry)==TRUE )
                {
                    /* 2003/11/1 sunsj sim code showdetail */
                    oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                    /* 2004/06/30 sunsj modify for sim detail */
                    dspl_Clear(0, FIRST_LINE, SCREEN_SIZE_X, STANDARD_MENU_VERTICAL_SIZE);

                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_NAME);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)nameicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)namefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_NAME_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)nameicon,DSPL_BMPXOR);

                    /* 2003/11/10 sunsj the number is one line display */
                    drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)l_phb_SIMentry.name.data, dspl_GetFrgColor());
                    //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)l_phb_SIMentry.name.data);

                    /* 2004/03/23 sunsj modify */
                    oldFontColor=dspl_SetFrgColor(0x000000);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_MOBILENUM_Y-1);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                    //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);

                    /* 2003/11/10 sunsj the number is one line display */
                    drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)l_phb_SIMentry.number, dspl_GetFrgColor());
                    //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_SIMentry.number);

                    dspl_SetFrgColor(oldFontColor);
                    dspl_SetBkgColor(oldbackcolor);
                    /*
                    dspl_TextOut(1,40,0,(char *)l_phb_SIMentry.name.data);
                    dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                    dspl_TextOut(1,102,0,(char *)l_phb_SIMentry.number);
                    */
                }
                else
                    TRACE_EVENT("read sim error");
                displaySoftKeys(TxtSoftCall,TxtSoftBack);
            }
            else if( l_phb_index[Index].phonebook==NVM_BOOK_SEL )
            {
                memset(&l_phb_NVMentry,0,sizeof(PhbkDetailItem));
                if( ReadNVMRecord(Index,&l_phb_NVMentry)==TRUE )
                {
                    /* 2003/11/1 sunsj remove */
                    //dspl_TextOut(1,40,0,(char *)l_phb_NVMentry.name);
                    if( data->status_of_timer == 0 )//first create this win
                    {
                        data->status_of_timer = 1;
                        /* 2003/10/21 sunsj/ modify new book detail */
                        ShowDetailView(TxtEnterName, TxtEnterName);
                        oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                        if( strlen((char *)l_phb_NVMentry.name)!=0 )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)l_phb_NVMentry.name, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)l_phb_NVMentry.name); 
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)MmiRsrcGetText(TxtEnterName), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)MmiRsrcGetText(TxtEnterName)); 
                        }
                        /* display record name */

                        /* 2004/03/23 sunsj modify */
                        oldFontColor=dspl_SetFrgColor(0x000000);

                        /* 2004/05/25 sunsj modify */
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_MOBILENUM_Y-1);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,12,0,(void *)mobileicon,DSPL_BMPXOR);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,12,0,(void *)mobilefficon,DSPL_BMPAND);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,12,0,(void *)mobileicon,DSPL_BMPXOR);

                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)l_phb_NVMentry.number, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.number);
                            displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterNumber));
                            displaySoftKeys(TxtNull,TxtSoftBack);
                        }
                        dspl_SetFrgColor(oldFontColor);
                        /* display the record's mobile number and the menuicon */

                        if( strlen((char *)l_phb_NVMentry.home)!=0 )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)l_phb_NVMentry.home, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)l_phb_NVMentry.home); 
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
                        }
                        /* display the home number.If there is null then display the text */

                        if( strlen((char *)l_phb_NVMentry.office)!=0 )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)l_phb_NVMentry.office, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)l_phb_NVMentry.office); 
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
                        }
                        /* display the office number.If there is null then display the text */

                        if( strlen((char *)l_phb_NVMentry.memo)!=0 )
                        {
                            dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MEMO_Y,110,0,(char *)l_phb_NVMentry.memo); 
                        }
                        else
                        {
                            dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MEMO_Y,110,0,(char *)MmiRsrcGetText(TxtEnterMemo)); 
                        }
                        /* display the memo text. If there is null then display nothing */

                        dspl_SetBkgColor(oldbackcolor);

                        /*
                        if ( l_phb_NVMentry.number[0]!='\0' )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                            data->status_of_timer=1;
                        }
                        else if ( l_phb_NVMentry.office[0]!='\0' )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                            data->status_of_timer=2;
                        }
                        else if ( l_phb_NVMentry.home[0]!='\0' )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                            data->status_of_timer=3;
                        }
                        */
                    }
                    else
                    {
                        /* 2003/11/1 sunsj modify for callback display */
                        data->status_of_timer = 1;
                        /* 2003/10/21 sunsj/ modify new book detail */
                        ShowDetailView(TxtEnterName, TxtEnterName);
                        oldbackcolor=dspl_SetBkgColor(0xDBF4FF);

                        if( strlen((char *)l_phb_NVMentry.name)!=0 )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)l_phb_NVMentry.name, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)l_phb_NVMentry.name); 
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_NAME_Y, (char *)MmiRsrcGetText(TxtEnterName), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_NAME_Y,110,0,(char *)MmiRsrcGetText(TxtEnterName)); 
                        }
                        /* display record name */

                        /* 2004/03/23 sunsj modify */
                        oldFontColor=dspl_SetFrgColor(0x000000);

                        /* 2004/05/25 sunsj modify */
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_LOCATION(ICON_MENUUP, 2, PHONE_MOBILENUM_Y-1);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y-1,128,PHONE_LINE_HEIGHT,0,(void *)iconMnuup0,0);
                        /* 2004/06 sunsj modify for picture manage */
                        DRAW_ICON_MASK_OWN(ICON_PHONEBOOK_MOBILE);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobilefficon,DSPL_BMPAND);
                        //dspl_BitBlt(2,PHONE_MOBILENUM_Y,PHONEBOOK_ICON_WIDTH,PHONEBOOK_ICON_HEIGHT,0,(void *)mobileicon,DSPL_BMPXOR);

                        if( l_phb_NVMentry.number[0]!='\0' )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)l_phb_NVMentry.number, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, (char *)l_phb_NVMentry.number);
							/* 2004/07/06 sunsj add */
							displaySoftKeys(TxtSoftCall,TxtSoftBack);
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_MOBILENUM_Y, (char *)MmiRsrcGetText(TxtEnterNumber), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22, PHONE_MOBILENUM_Y, 98, DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtEnterNumber));
                            displaySoftKeys(TxtNull,TxtSoftBack);
                        }
                        dspl_SetFrgColor(oldFontColor);
                        /* display the record's mobile number and the menuicon */

                        if( strlen((char *)l_phb_NVMentry.home)!=0 )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)l_phb_NVMentry.home, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)l_phb_NVMentry.home); 
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_HOMENUM_Y, (char *)MmiRsrcGetText(TxtEnterHome), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_HOMENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterHome)); 
                        }
                        /* display the home number.If there is null then display the text */

                        if( strlen((char *)l_phb_NVMentry.office)!=0 )
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)l_phb_NVMentry.office, dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)l_phb_NVMentry.office); 
                        }
                        else
                        {
                            /* 2003/11/10 sunsj the number is one line display */
                            drawcolorclarity_NoNewline(PHONEEDITOR_SCREEN_X_OFFSET, PHONE_OFFICENUM_Y, (char *)MmiRsrcGetText(TxtEnterOffice), dspl_GetFrgColor());
                            //dspl_TextOut_Blk(22,PHONE_OFFICENUM_Y,110,0,(char *)MmiRsrcGetText(TxtEnterOffice)); 
                        }

                        /* display the office number.If there is null then display the text */
                        if( strlen((char *)l_phb_NVMentry.memo)!=0 )
                        {
                            dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MEMO_Y,110,0,(char *)l_phb_NVMentry.memo); 
                        }
                        else
                        {
                            dspl_TextOut_Blk(PHONEEDITOR_SCREEN_X_OFFSET,PHONE_MEMO_Y,110,0,(char *)MmiRsrcGetText(TxtEnterMemo)); 
                        }
                        /* display the memo text. If there is null then display nothing */

                        dspl_SetBkgColor(oldbackcolor);

                        /*
                        if ( data->status_of_timer==1 )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterNumber));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.number);
                        }
                        else if ( data->status_of_timer==2 )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterOffice));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.office);
                        }
                        else if ( data->status_of_timer==3 )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterHome));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.home);
                        }
                        else if ( data->status_of_timer==4 )
                        {
                            dspl_TextOut(1,84,0,MmiRsrcGetText(TxtEnterMemo));
                            dspl_TextOut(1,102,0,(char *)l_phb_NVMentry.memo);
                            displaySoftKeys(TxtNull,TxtSoftBack);
                        }
                        */
                    }
                }
                else
                    TRACE_EVENT("read nvm error");
            }
            //displaySoftKeys(TxtSoftCall,TxtSoftBack);
        }
        break;

    default:
        {
            // unabel to handle event, pass handling of event back up tree			
            return MFW_EVENT_PASSED;
        }
    }
    // if we get here, we have handled the event	
    return MFW_EVENT_CONSUMED;
}

static T_MFW_HND bookShowDetailCreate( MfwHnd parent )
{
    T_MFW_WIN       *parent_win_data    = ( (T_MFW_HDR *) parent )->data;
    tBookStandard    *parent_data        = (tBookStandard *) parent_win_data->user;
    T_phbk          *phbk               = parent_data->phbk;
    T_MFW_WIN       *win_data;
    tBookStandard   *data;

    TRACE_EVENT ("bookShowDetailCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, (T_MFW_CB) bookShowDetailWindowCB ) ) == NULL )
    {
        FREE_MEMORY( (void *)data, sizeof( tBookStandard ) );
        return NULL;
    }

    data->mmi_control.dialog    = NULL;
    data->mmi_control.data      = data;
    win_data                    = ((T_MFW_HDR *)data->win)->data;
    win_data->user              = (void *) data;
    data->phbk                  = phbk;
    data->parent_win            = parent;
    data->status_of_timer       = 0;    /* 2003/10/21 sunsj */      
    data->kbd=kbdCreate(data->win, KEY_ALL,(MfwCb)bookShowDetailKbdCB);
    return data->win;
}


MfwHnd bookShowDetailStart( MfwHnd parent)
{
    T_MFW_HND win;

    TRACE_EVENT ("bookShowDetailStart()");


    if( ( win = bookShowDetailCreate( parent ) ) != NULL )
        winShow(win);
    return win;
}
//end yq added
//yq added for delete shortcutitem
static void bookDeleteShortCutCB( T_MFW_HND win, USHORT id, UBYTE reason )
{
    T_MFW_WIN      *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard    *data       =(tBookStandard *)win_data->user;
    T_phbk          *phbk       =(T_phbk *)data->phbk;
    T_MFW_HND       curwin  = mfw_parent (mfwFocus);//mfw_header()
    TRACE_FUNCTION("bookdeleteshortcutcb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        {
            TRACE_EVENT("press left");
            memset(FFS_PBOtherData.ShortCutDial[phbk->select_index].name,0,PHB_name_len+3);
            memset(FFS_PBOtherData.ShortCutDial[phbk->select_index].number,0,(PHB_number_len/2)+1);
            memcpy(DataItem[phbk->select_index].name,MmiRsrcGetText(TxtNullNumber),PHB_name_len);
            flash_PBOtherWrite("PBOption");
            bookShowInformation(curwin,TxtDeleted,NULL,NULL);
            //winShow(curwin);
        }
        break;
    case INFO_KCD_RIGHT:
        TRACE_EVENT("press right");
        break;
    default:
        break;
    }
}
//end yq added

/*******************************************************************************
                             yq add for voice_dial
*******************************************************************************/
void bookVoiceAddStart(T_MFW_HND Window,int Id,char *name,char *number)//char * TxtContent
{
    T_DISPLAY_DATA Dialog;
    int i;
    struct stat_s status;
    TRACE_FUNCTION("bookVoiceAddStart()");
    if( ffs_stat("/voiceD",&status)<0 )
    {
        TRACE_EVENT("dir do't exist,create it");
        ffs_mkdir("/voiceD");

    }
    for( i=0;i<VOICEDIAL_MAX;i++ )
    {
        if( wstrlen(voice_dial[i].name)==0 )
        {
            memset(voice_name,0,sizeof(voice_name));
            memset(voice_number,0,sizeof(voice_number));
            wstrcpy(voice_name,name);
            wstrcpy(voice_number,number);
            current_voice_index=i;
            break;
        }
    }//copy the name and number to voice_dial.and set the current_voice_index to i;

    current_operation=0;
    dialog_info_init(&Dialog);//gdy add
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = Id;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookVoiceAddCB;
    Dialog.Identifier   = 0;   
    Dialog.iconindex=REMIND_REQUIRE;
    info_dialog( Window, &Dialog );

}


static void bookVoiceAddCB(T_MFW_HND win, USHORT id, UBYTE reason )
{
    T_MFW_WIN         *win_data   = ( (T_MFW_HDR *) win )->data;
    tBookStandard       *data       =(tBookStandard *)win_data->user;
    T_phbk             *phbk       =(T_phbk *)data->phbk;


    char                info[60];
    TRACE_FUNCTION("bookVoiceAddCB()");
    switch( reason )
    {
    case INFO_KCD_LEFT:
        VdRecordStart(win);
        break;        
    case INFO_KCD_RIGHT:

    default: break;
    }              
}

int IsNumberIn(char *number)
{
    int i;
    for( i=0;i<VOICEDIAL_MAX;i++ )
    {

        if( strcmp(number,voice_dial[i].number)==0 )
            return i+1;
    }
    return 0;
}

int MayAddVoice(void)
{
    getVoiceTotal();
    if( voice_total>=VOICEDIAL_MAX )
        return 0;
    else return 1;
}

MfwHnd VdRecordStart( MfwHnd parent)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("VdRecordStart()");


    if( ( win = VdRecordCreate( parent ) ) != NULL )
    {
        current_mode=recordready;
        winShow(win);
    }


    return win;
}
static int bookVdRecordWindowCB( MfwEvt e, MfwWin *w )
{
    MfwHdr *elements;
    MfwHdr *win;
    TRACE_FUNCTION("bookVdRecordWindowCB");
    if( !w )
        return 0;
    elements=w->elems;
    if( !elements )
        return 0;
    w=mfwParent(elements);
    if( !w )
        return 0;
    dspl_ClearAll();
    draw_popup_background();

    switch( current_mode )
    {
    case recordready:
        SEND_EVENT(w, record_ready,NULL,NULL);
        break;
    case updateready:
        fromwinshow=1;
        SEND_EVENT(w, record_update_ready,NULL,NULL);
        break;
    case recorderror:
        SEND_EVENT(w, record_error,NULL,NULL);
        break;
    case updateerror:
        SEND_EVENT(w, record_update_error,NULL,NULL);
        break;
    case recordsucess:
        fromwinshow=1;
        SEND_EVENT(w, record_sucess,NULL,NULL);
        break;
    default:
        SEND_EVENT(w, record_destroy,NULL,NULL);//error mode,so destroy the window
        break;
    }
    return 1;
}
static T_MFW_HND VdRecordCreate( MfwHnd parent )
{
    T_MFW_WIN     * win_data;
    T_voice_info *  data = (T_voice_info *)ALLOC_MEMORY (sizeof (T_voice_info));

    TRACE_FUNCTION ("Vd_Record_create()");

    data->win = win_create (parent, 0, E_WIN_VISIBLE,(MfwCb)bookVdRecordWindowCB );//(T_MFW_CB)voice_win_cb

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)voice_record;
    data->mmi_control.data     = data;
    data->parent_win           = parent;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;

    /*
     * return window handle
     */
    data->tim=timCreate(data->win,250,(MfwCb)voice_tim_cb);
    data->kbd             = kbd_create (data->win, KEY_ALL, (T_MFW_CB)voice_kbd_cb);
    voice_win=data->win;
    return data->win;

}

static void voice_record( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN      *win_data    = ((T_MFW_HDR *) win)->data;
    T_voice_info *data       = (T_voice_info*) win_data->user; 
    T_MFW_HND parent_win=data->parent_win;
    int i;
    TRACE_FUNCTION("voice_record");
    switch( event )
    {
    case record_ready:
        TRACE_EVENT("record_ready");
        {

            if( !data->kbd )
                data->kbd             = kbd_create (win, KEY_ALL, (T_MFW_CB)voice_kbd_cb);
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
            /* 2004/06 sunsj modify for picture manage */           
#if(MAIN_LCD_SIZE==3)
			DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);//shiheng for pic manage
#else
			DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
            //dspl_BitBlt(41, 17, 21, 18, 0, (void *)iconRequire, 0);
            dspl_TextOut(10,95,0,MmiRsrcGetText(TxtStartEnroll));
            driverFlag|=0x0001;
            current_mode=recordready;
        }
        break;
    case record_begin:
        TRACE_EVENT("record_begin");
        {
            if( Add_Modify==2 )
            {
                StartVDEnroll("VoiceDM");
            }
            else
                StartVDEnroll((char *)voice_filename[current_voice_index]);
            driverFlag&=0xfffffffe;
            dspl_Clear(10,40,108,123);
            /* 2004/06 sunsj modify for icon manage */
            //dspl_BitBlt(46, 59, 28, 20, 0, (void *)iconRecord, 0);
            DRAW_ICON(ICON_VOICERECORD_RECORD);
            dspl_TextOut(10,95,0,MmiRsrcGetText(TxtEnrolling));
            displaySoftKeys(TxtNull,TxtSoftBack);
            current_mode=recording;
        }
        break;
    case record_over:
        TRACE_EVENT("record_over");
        {
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtNull,TxtSoftBack);
            /* 2004/06 sunsj modify for icon manage */
            //dspl_BitBlt(46, 55, 27, 30, 0, (void *)iconVoicePlay, 0);
            DRAW_ICON(ICON_VOICERECORD_PLAY);
            dspl_TextOut(26,86,0,MmiRsrcGetText(TxtEnrollSucess));
            dspl_TextOut(10,106,0,MmiRsrcGetText(TxtPlayingNow));
            current_mode=playing1;
        }
        break;
    case record_error:
        TRACE_EVENT("record_error");
        {
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
            /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
			DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);//shiheng for pic manage
#else
			DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
            //dspl_BitBlt(41, 17, 21, 18, 0, (void *)iconRequire, 0);
            dspl_TextOut(26,86,0,MmiRsrcGetText(TxtEnrollError));
            dspl_TextOut(26,106,0,MmiRsrcGetText(TxtEnrollOnceMore));
            current_mode=recorderror;
        }
        break;
    case record_update_ready:
        TRACE_EVENT("record_update_ready");
        {
            if( winIsFocussed(voice_win)||fromwinshow )
            {
                fromwinshow=0;
                dspl_Clear(10,40,108,123);
                displaySoftKeys(TxtSoftOK,TxtSoftBack);
                /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
				DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);//shiheng for pic manage
#else
				DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
                //dspl_BitBlt(41, 17, 21, 18, 0,(void *)iconRequire, 0);
                dspl_TextOut(10,95,0,MmiRsrcGetText(TxtStartUpdate));
                driverFlag|=0x0001;
                current_mode=updateready;
            }
            else
            {
                fromwinshow=0;
                SetCurrentMode(updateready);
            }
        }
        break;
    case record_update:
        TRACE_EVENT("record_update");
        {
            StartVDUpdate();
            driverFlag&=0xfffffffe;
            TRACE_EVENT((char *)voice_filename[current_voice_index]);
            //            dspl_Clear(10,40,108,123);/*2003/12/1, wangyan modify */
            //           dspl_BitBlt(42,54,27,27,0,(void*)waiting1,0);
            draw_popup_background();/*2004/1/2, wangyan modify */
            displaySoftKeys(TxtNull,TxtSoftBack);
            dspl_TextOut(10,TOP_POSITION+35,0,MmiRsrcGetText(TxtVoiceUpdating));
            current_mode=updating;
        }

        break;
    case record_update_over:
        TRACE_EVENT("record_update_over");
        {
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtNull,TxtSoftBack);
            /* 2004/06 sunsj modify for icon manage */
            //dspl_BitBlt(46, 55, 27, 30, 0, (void *)iconVoicePlay, 0);
            DRAW_ICON(ICON_VOICERECORD_PLAY);
            dspl_TextOut(26,86,0,MmiRsrcGetText(TxtUpdateSucess));
            dspl_TextOut(10,106,0,MmiRsrcGetText(TxtPlayingNow));
            current_mode=playing2;
        }

        break;
    case record_update_error:
        TRACE_EVENT("record_update_error");
        {
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
            /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
			DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);//shiheng for pic manage
#else
			DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
            //dspl_BitBlt(41, 17, 21, 18, 0,(void *)iconRequire, 0);
            dspl_TextOut(26,86,0,MmiRsrcGetText(TxtUpdateError));
            dspl_TextOut(26,106,0,MmiRsrcGetText(TxtEnrollOnceMore));
            current_mode=updateerror;   
        }
        break;
    case record_sucess:
        TRACE_EVENT("record_sucess");
        {
            if( winIsFocussed(voice_win)||fromwinshow )
            {
                fromwinshow=0;
                wstrcpy(voice_dial[current_voice_index].name,voice_name);
                wstrcpy(voice_dial[current_voice_index].number,voice_number);
                WriteVoiceData();
                dspl_Clear(10,40,108,123);
                displaySoftKeys(TxtNull,TxtSoftBack);
                /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
				DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);//shiheng for pic manage
#else
				DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
                //dspl_BitBlt(41, 17, 21, 18, 0, (void *)iconSucess, 0);
                dspl_TextOut(10,95,0,MmiRsrcGetText(TxtRecordSucess));
                current_mode=recordsucess;
                timStart(data->tim);
            }
            else
            {
                fromwinshow=0;
                SetCurrentMode(recordsucess);
            }
        }
        break;

    case record_destroy:
        {
            VdRecordDestroy(win);
        }
        break;
    default:break;
    }
}

static int voice_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_voice_info*  data       = (T_voice_info*)win_data->user;
    switch( keyboard->code )
    {
    case KCD_LEFT:
    case KCD_OK:
        {
            switch( current_mode )
            {
            case recordready:
                SEND_EVENT(win,record_begin,0,0);
                break;
            case recorderror:
            case updateerror:
                SEND_EVENT(win,record_ready,0,0);
                break;                                                      
            case updateready:
                SEND_EVENT(win,record_update,0,0);
                break;
            case recordsucess:
                SEND_EVENT(win,record_destroy,0,0);//record_dial
            default:
                break;
            }

        }
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        {
            switch( current_mode )
            {
            case recording:
                StopVDEnroll();
                //StopSREnroll();

                break;
            case updating:
                TRACE_EVENT("break updating");
                StopVDUpdate();
                //StopSRUpdate();

                break;
            case playing1:
                StopPlayVmRecord((callback_func)VdRecordPlayCB);
                break;
            case playing2:
                StopPlayVmRecord((callback_func)VdUpdatePlayCB);
                break;  
            case recordsucess:
                timStop(data->tim);
            default:

                break;
            }
            TRACE_EVENT("destroy voicerecord win");
            SEND_EVENT(win,record_destroy,0,0);
        }
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;

}

static T_MFW_CB voice_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_voice_info*  data       = (T_voice_info*)win_data->user;
    TRACE_EVENT("voice_tim_cb");
    timStop(data->tim);
    SEND_EVENT(voice_win,record_destroy,0,0);
}

void VdRecordDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    T_voice_info*data = (T_voice_info*) win->user;

    T_MFW_HND     ParentWin  = data->parent_win;
    char filename[40];
    char filename2[40];
    driverFlag&=0xfffffffe;

    if( data )
    {
        if( Add_Modify==2 )//current opertion is modify
        {
            if( current_mode==recordsucess )//record sucess.we delete the backup file
            {
                TRACE_EVENT("modify sucess");

                wstrcpy(filename,"/voiceD/");
                wstrcat(filename,(char *)voice_filename[current_voice_index]);
                ffs_remove(filename);
                wstrcpy(filename2,filename);
                wstrcat(filename2,"_sr");
                ffs_remove(filename2);
                ffs_rename("/voiceD/VoiceDM",filename);
                ffs_rename("/voiceD/VoiceDM_sr",filename2);
                /**/
            }
            else
            {
                wstrcpy(filename,"/voiceD/VoiceDM");
                ffs_remove(filename);
                wstrcat(filename,"_sr");
                ffs_remove(filename);
            }
        }
        timDelete(data->tim);
        winDelete ( data->win );

        FREE_MEMORY( (void *) data, sizeof( T_voice_info) );
        voice_win=0;
        Add_Modify=0;//reset the flag
    }
    if( current_operation )
        bookVoiceModifyDestory(ParentWin);

}

void WriteVoiceData(void)
{
    struct stat_s status;
    TRACE_EVENT("writevoicedata()");
    if( ffs_stat("/voiceD",&status)<0 )
    {
        TRACE_EVENT("dir do't exist,create it");
        ffs_mkdir("/voiceD");

    }
    ffs_fwrite(voice_namefile,voice_dial,VOICEDIAL_MAX*sizeof(voice_info));
}

void GetVoiceData(void)
{   
    if( !needgetvoicedata )
    {
        ffs_fread(voice_namefile,voice_dial,VOICEDIAL_MAX*sizeof(voice_info));
        needgetvoicedata=1;
    }
    return;
}

void VdRecordPlayCB (void* parameter)
{

    rvf_free_buf (parameter); 
    SEND_EVENT(voice_win,record_update_ready,0,0);//record_sucess
    return;
}

void VdUpdatePlayCB (void* parameter)
{

    rvf_free_buf (parameter); 
    SEND_EVENT(voice_win,record_sucess,0,0);
    return;
}


void bookVoiceModifyDestory( MfwHnd window )
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)window)->data;
    tBookStandard   * data     = (tBookStandard *) win_data->user;
    T_phbk         * phbk     = data->phbk;

    T_MFW_HND     Dynamicwin= data->phbk->dynamicmenu_win;
    T_MFW_HND     ParentWin  = data->phbk->search_win;



    SEND_EVENT(window, E_MNU_ESCAPE, NULL, NULL);
    listsDestroy(Dynamicwin);              
    SEND_EVENT(ParentWin, SEARCH_DESTROY, 1, NULL); 



}

static void bookVoiceModifyCB(T_MFW_HND win, USHORT id, UBYTE reason )
{



    switch( reason )
    {
    case INFO_KCD_LEFT:
        VdRecordStart(win);
        break;        
    case INFO_KCD_RIGHT:
        //bookVoiceModifyDestory(win);
        break;
    default: break;
    }              
}

void bookVoiceModifyStart(T_MFW_HND Window,unsigned char  TxtContent,char *name,char *number)
{
    T_DISPLAY_DATA Dialog;
    int i,String_Id;
    //char text[30];
    struct stat_s status;
    if( ffs_stat("/voiceD",&status)<0 )
    {
        TRACE_EVENT("dir do't exist,create it");
        ffs_mkdir("/voiceD");

    }
    current_operation=1;//set the flag where the window from
    if( TxtContent )//we modify the voice
    {
        memset(voice_name,0,sizeof(voice_name));
        memset(voice_number,0,sizeof(voice_number));
        wstrcpy(voice_name,name);
        wstrcpy(voice_number,number);
        current_voice_index=TxtContent-1;
        String_Id=TxtModifyVoiceDial;
        Add_Modify=2;//indicate current operation is modify
        //strcpy(text,"modify voice!");

    }
    else//add voice
    {
        if( !MayAddVoice() )//can add voice
        {
            bookShowInformation(Window,TxtVoiceDialFull,NULL,NULL);
            Add_Modify=0;//reset the flag;
            return;//showerror();//no space to add,so show error information
        }
        else//we can add voice
        {
            for( i=0;i<VOICEDIAL_MAX;i++ )
            {
                if( wstrlen(voice_dial[i].name)==0 )
                {
                    memset(voice_name,0,sizeof(voice_name));
                    memset(voice_number,0,sizeof(voice_number));
                    wstrcpy(voice_name,name);
                    wstrcpy(voice_number,number);
                    current_voice_index=i;
                    break;
                }
            }//copy the name and number to voice_dial.and set the current_voice_index to i;
            String_Id=TxtAddVoiceDial;
            Add_Modify=1;//indicate current operation is add;
            //strcpy(text,"add voice!");
        }
    }
    dialog_info_init(&Dialog);//gdy add
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = String_Id;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookVoiceModifyCB;
    Dialog.Identifier   = 0;   
    Dialog.iconindex=REMIND_REQUIRE;
    info_dialog( Window, &Dialog ); 
}


void getVoiceTotal()
{

    int i;
    char temp[100];
    TRACE_EVENT("getVoiceTotal");
    voice_total=0;
    memset(voice_index,0,sizeof(voice_index));
    for( i=0;i<VOICEDIAL_MAX;i++ )
    {
        if( (wstrlen(voice_dial[i].name)!=0)&&(wstrlen(voice_dial[i].number)!=0) )
        {
            voice_index[voice_total]=i;
            voice_total++;
        }
    }
}


static void setVoiceBuffer()
{
    int i;
    TRACE_EVENT("setVoiceBuffer");
    memset(voice_buffer,0,sizeof(voice_buffer));
    if( voice_total<=PHONEBOOK_RECORD_PERPAGE )
        for( i=0;i<voice_total;i++ )
            memcpy(voice_buffer[i],voice_dial[voice_index[i]].name,PHB_MAX_LEN+2);
    else
        for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
            memcpy(voice_buffer[i],voice_dial[voice_index[i]].name,PHB_MAX_LEN+2);   
}

static void bookVoiceList_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    tBookStandard     * data     = (tBookStandard  *)win_data->user;
    T_phbk           * Phbk     = data->phbk;
    T_MFW_WIN       * windata = ((T_MFW_HDR *)ListData->win)->data;
    ListWinInfo        * dataInfo = (ListWinInfo *)windata->user;


    int                 i;


    switch( ListData->Reason )
    {
    
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        {


            data->phbk->dynamicmenu_win =ListData->win;
            data->phbk->select_index      =(Phbk->BufferIndex+ListData->CursorPosition)%voice_total;              
            data->phbk->menu_options_win =bookMenuStart( data->phbk->win,bookPhonebookPhoneVoiceList(),PhbkVoiceList);             
        }
        break;
    case LISTS_REASON_UPDATE:
        {

            ShowVoiceListNumber(voice_index[(Phbk->BufferIndex+ListData->CursorPosition)%voice_total]);

        } 
        break;
    case LISTS_REASON_HANGUP:
        {
            //if(returntoidle())
            break;
        }
    case LISTS_REASON_BACK:


        {

            listsDestroy(ListData->win);
            SEND_EVENT(data->win, SEARCH_DESTROY, NULL, NULL);

        }
        break;

    case LISTS_REASON_UP:
        {
            TRACE_EVENT("lists_reason_up");
            if( (ListData->CursorPosition-1>=0) || (voice_total<=PHONEBOOK_RECORD_PERPAGE) )
            {
                TRACE_EVENT("we need't refresh all");
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition-1+voice_total)%voice_total)+1; 
                mnuUp(dataInfo->MenuLists);  

                ShowVoiceListNumber(voice_index[(Phbk->BufferIndex+ListData->CursorPosition-1+voice_total)%voice_total]);                                 
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex-PHONEBOOK_RECORD_PERPAGE+voice_total)%voice_total;
                dataInfo->MenuListsAttr.pageturnindex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%voice_total+1;             
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(voice_buffer[i],voice_dial[voice_index[(Phbk->BufferIndex+i)%voice_total]].name,PHB_name_len+2);

                }   
                mnuChooseVisibleItem(dataInfo->MenuLists,PHONEBOOK_RECORD_PERPAGE-1);
                ShowVoiceListNumber(voice_index[(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE-1)%voice_total]);

            }


        }
        break;
    case LISTS_REASON_DOWN:
        {
            TRACE_EVENT("lists_reason_down");
            if( (ListData->CursorPosition+1<PHONEBOOK_RECORD_PERPAGE) || (voice_total<=PHONEBOOK_RECORD_PERPAGE) )
            {
                TRACE_EVENT("we need't refresh all");
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex+ListData->CursorPosition+1)%voice_total)+1;
                mnuDown(dataInfo->MenuLists);

                ShowVoiceListNumber(voice_index[(Phbk->BufferIndex+ListData->CursorPosition+1)%voice_total]);
            }
            else
            {
                Phbk->BufferIndex=(Phbk->BufferIndex+PHONEBOOK_RECORD_PERPAGE)%voice_total;
                dataInfo->MenuListsAttr.pageturnindex=((Phbk->BufferIndex)%voice_total)+1; 
                for( i=0;i<PHONEBOOK_RECORD_PERPAGE;i++ )
                {
                    memcpy(voice_buffer[i],voice_dial[voice_index[(Phbk->BufferIndex+i)%voice_total]].name,PHB_name_len+2);
                }   
                mnuChooseVisibleItem(dataInfo->MenuLists,0);
                ShowVoiceListNumber(voice_index[(Phbk->BufferIndex)%voice_total]);
            }

        } 
        break;


    default:break;        
    }                                 
}



void ShowVoiceListNumber(int Index)
{
    UINT32 b_color,f_color;
    char outstr[20];
    b_color=dspl_SetBkgColor(0xF8E0EE);
    dspl_Clear (0,111,SCREEN_SIZE_X,142);
    f_color=dspl_SetFrgColor(0x000000);

    dspl_TextOut(1,111,0,MmiRsrcGetText(TxtVoiceCall));
    truncateString(outstr,(char *)voice_dial[Index].number,12,1,".");
    dspl_TextOut(1,126,0,outstr);   
    TRACE_EVENT((char *)voice_dial[Index].number);
    dspl_SetBkgColor(b_color);
    dspl_SetFrgColor(f_color);

}

void bookVoiceListDestroy( MfwHnd window )
{
    T_MFW_WIN       *win  = ((T_MFW_HDR *) window)->data;
    tBookStandard   *data = (tBookStandard *) win->user;


    if( data )
    {

        data->phbk->search_win = 0;
        ClearWindowHandle();
        winDelete( data->win );
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
    }
}


static void bookVoiceListDialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN       *win_data   = ((T_MFW_HDR *) win)->data;
    tBookStandard   *data       = (tBookStandard *) win_data->user;
    T_phbk          *Phbk       =data->phbk;
    char * titleStr;
    int i;


    switch( event )
    {
    case voicelist_init:
        {           
            TRACE_EVENT("voicelist_init");
            data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

            if( !data->menu_list_data )
            {
                //show no memory
                return;
            }
            else
            {
                data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( GetFree(voice_total) *sizeof(T_MFW_MNU_ITEM) );
                if( data->menu_list_data->List!=0 )
                {
                    for( i = 0; i < GetFree(voice_total); i++ )
                    {
                        data->menu_list_data->List[i].icon =0;                      
                        data->menu_list_data->List[i].exta = 0;
                        data->menu_list_data->List[i].edit = 0;
                        data->menu_list_data->List[i].menu = 0;
                        data->menu_list_data->List[i].func = NULL;  
                        data->menu_list_data->List[i].str=(char *)voice_buffer[i];                                                                                                                              
                        data->menu_list_data->List[i].flagFunc=item_flag_none;
                        TRACE_EVENT((char *)voice_buffer[i]);
                        TRACE_EVENT(data->menu_list_data->List[i].str);
                    }

                    data->menu_list_data->ListLength=GetFree(voice_total);


                    Phbk->BufferIndex=0;
                    data->menu_list_data->SnapshotSize  = GetFree(voice_total);
                    data->menu_list_data->Font          = 0;
                    data->menu_list_data->LeftSoftKey    = TxtSoftSelect;
                    data->menu_list_data->RightSoftKey   = TxtSoftBack;
                    data->menu_list_data->KeyEvents     = KEY_ALL;
                    data->menu_list_data->Reason        = 0;
                    data->menu_list_data->Strings        = TRUE;
                    data->menu_list_data->Attr           = &readName_menuAttrib;                 
                    data->menu_list_data->autoDestroy    = FALSE;
                    data->menu_list_data->ListMenuFlag    =1;           
                    titleStr=MmiRsrcGetText(TxtVoiceList);
                    data->menu_list_data->ListMenuHeadStr=titleStr;
                    LastKey=0xFF;
                    if( (int)parameter!=0 )//we change the pageturnindex,this will change the readName_menuAttrib;yq 2003/2/21
                    {
                        TRACE_EVENT("parameter not 0");
                        data->menu_list_data->ListPosition    = (int)parameter+1;
                        data->menu_list_data->CursorPosition = (int)parameter+1;
                        data->menu_list_data->Attr->pageturnindex=(int)parameter+1;
                    }
                    else
                    {
                        TRACE_EVENT("parameter is 0");
                        data->menu_list_data->ListPosition    = 1;                    
                        data->menu_list_data->CursorPosition = 1;
                        data->menu_list_data->Attr->pageturnindex=1;
                    }

                    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc)bookVoiceList_cb,0);
                    ShowVoiceListNumber(voice_index[Phbk->BufferIndex]);
                }
                else
                {
                    FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
                    //show no memory
                    return;
                }                               
            }           
        }
        break;
    case SEARCH_DESTROY:
        FREE_MEMORY((void *)data->menu_list_data->List, GetFree(voice_total)*sizeof(T_MFW_MNU_ITEM));
        FREE_MEMORY((void *)data->menu_list_data,sizeof(ListMenuData));
        switch( value )
        {
        
        case 0:               
            {
                bookVoiceListDestroy(win);
            }    
            break;
        case 1:
            {


                getVoiceTotal();
                if( Phbk->BufferIndex>=voice_total )
                    Phbk->BufferIndex=0;
                setVoiceBuffer();

                SEND_EVENT(win, voicelist_init, NULL,(int *)Phbk->BufferIndex);  
            }    

            break;
        }
    default: break;
    }
}

static T_MFW_HND bookVoiceListCreate( MfwHnd parent )
{
    T_MFW_WIN       *parent_win_data = ( (T_MFW_HDR *) parent )->data;
    T_phbk          *phbk = (T_phbk *)parent_win_data->user;
    T_MFW_WIN       *win_data;
    tBookStandard   *data;

    TRACE_FUNCTION ("bookSearchCreate()");

    // allocate memory for our control block	
    if( ( data = (tBookStandard *) ALLOC_MEMORY( sizeof( tBookStandard ) ) ) == NULL )
        return NULL;

    // Create the window if we can	
    if( ( data->win = win_create( parent, 0, E_WIN_VISIBLE, NULL) ) == NULL )
    {
        FREE_MEMORY( (void *) data, sizeof( tBookStandard ) );
        return NULL;
    }

    // Okay, we have created the control block and the window, so
    //   we now need to configure the dialog and data pointers	
    data->mmi_control.dialog    = (T_DIALOG_FUNC) bookVoiceListDialog;
    data->mmi_control.data      = data;
    win_data                    = ((T_MFW_HDR *)data->win)->data;
    win_data->user              = (void *) data;
    data->phbk                  = phbk;
    data->parent_win            = parent;


    return data->win;
}  

T_MFW_HND bookVoiceListStart(MfwHnd window)
{

    T_MFW_HND       win;

    TRACE_EVENT("bookVoiceListStart");

    getVoiceTotal();
    if( voice_total==0 )
    {
        bookShowInformation(window, TxtEmptyList, NULL, NULL);
        //bookShowInformation(window, TxtNone,0,NULL);
        return 0;
    }
    else
    {
        setVoiceBuffer();
        win=bookVoiceListCreate(window);
        SetWindowsHandle(win);
        SEND_EVENT(win,voicelist_init,0,0);
        return win;
    }
}



void bookVoiceDelete_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    tBookStandard  *data      = (tBookStandard *) win_data->user;
    T_phbk         *Phbk       =data->phbk;

    T_MFW_HND     Dynamicwin= data->phbk->dynamicmenu_win;
    T_MFW_HND     ParentWin  = data->phbk->search_win;
    unsigned char delete_file[20];
    TRACE_FUNCTION ("call_failure_cb()");
    switch( reason )
    {
    
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        {
            TRACE_EVENT("press the right to quit");
        }
        break;
    case INFO_KCD_LEFT: 
        {
            dspl_ClearAll();
            /* 2004/05/17 sunsj modify */
            //dspl_BitBlt(44,50,32,32,0,(void *)iconWaitting,0);
            /* 2004/06 sunsj modify for picture manage */
 
#if(MAIN_LCD_SIZE==3)
			dialog_drawPopIcon(POP_ICONWAIT);
#else
			DRAW_ICON_SEL(ICON_POPWAITING, 0);
#endif
            //dspl_BitBlt(48, 52, 32, 32,0,(void*)waiting1,0);

            memset(voice_dial[voice_index[Phbk->phbk->select_index]].name,0,PHB_MAX_LEN+3);
            memset(voice_dial[voice_index[Phbk->phbk->select_index]].number,0,PHB_MAX_LEN+1);
            wstrcpy(delete_file,"/voiceD/");
            wstrcat(delete_file,(char *)voice_filename[voice_index[Phbk->phbk->select_index]]);
            ffs_remove((char *)delete_file);
            wstrcat(delete_file,"_sr");
            ffs_remove((char *)delete_file);
            WriteVoiceData();
            getVoiceTotal();
            SEND_EVENT(win, E_MNU_ESCAPE, NULL, NULL);
            listsDestroy(Dynamicwin);
            if( voice_total!=0 )
                SEND_EVENT(ParentWin, SEARCH_DESTROY, 1, NULL);
            else
                SEND_EVENT(ParentWin,SEARCH_DESTROY,0,0);
        }      
        break;                                                   
    default: break;
    }
}

void bookDeleteRecordStart(T_MFW_HND Window)
{
    T_DISPLAY_DATA Dialog;
    dialog_info_init(&Dialog);//gdy add
    Dialog.KeyEvents  = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
    Dialog.TextId     = 0;
    Dialog.TextId2    = TxtPhbkDelMess;
    Dialog.TextString  =  '\0';
    Dialog.TextString2  = '\0';
    Dialog.LeftSoftKey  = TxtSoftOK;
    Dialog.RightSoftKey = TxtCancel;
    Dialog.Time       = FOREVER;
    Dialog.Callback    = (T_VOID_FUNC) bookVoiceDelete_cb;
    Dialog.Identifier   = 0;   
    Dialog.iconindex=REMIND_REQUIRE;
    info_dialog( Window, &Dialog );
}

void boodVoiceRecordDestroy( MfwHnd window )
{
    T_MFW_WIN     *win  = ((T_MFW_HDR *) window)->data;
    T_voice_info*data = (T_voice_info*) win->user;

    T_MFW_HND     ParentWin  = data->parent_win;

    if( data )
    {
        winDelete ( data->win );
        driverFlag&=0xfffffffe;
        FREE_MEMORY( (void *) data, sizeof( T_voice_info) );
        voice_win=0;
    }

}

static int dial_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_voice_info*  data       = (T_voice_info*)win_data->user;
    switch( keyboard->code )
    {
    case KCD_LEFT:
    case KCD_OK:
        {
            switch( dial_mode )
            {
            case dial_ready:
            case redial1:
                SEND_EVENT(win,dialing,0,0);
                break;

            default:
                break;
            }

        }
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        {
            switch( dial_mode )
            {
            case dial_ready:
            case redial1:
            case dial_error:
                SEND_EVENT(win,dial_destroy,0,0);
                break;
            case  dialing:
                StopVDReco();
                SEND_EVENT(win,dial_destroy,0,0);
                break;
            default:
                break;
            }
        }
        break;
    default:
        break;
    }
    return MFW_EVENT_CONSUMED;

}


static void voice_dialog( T_MFW_HND win, USHORT event, SHORT value, void *parameter )
{
    T_MFW_WIN      *win_data    = ((T_MFW_HDR *) win)->data;
    T_voice_info *data       = (T_voice_info*) win_data->user; 
    T_MFW_HND parent_win=data->parent_win;
    int i,j;

    TRACE_EVENT("voice_dial");
    switch( event )
    {
    
    case dial_ready:
        TRACE_EVENT("dial_ready");
        {
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
            /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
            DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);
#else
			DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
            //dspl_BitBlt(41, 17, 21, 18, 0,(void *)iconRequire, 0);
            dspl_TextOut(10,95,0,MmiRsrcGetText(TxtStartDial));
            driverFlag|=0x0001;
            dial_mode=dial_ready;
        }
        break;
    case redial1:
        TRACE_EVENT("redial1");
        {
            dspl_Clear(10,40,108,123);
            displaySoftKeys(TxtSoftOK,TxtSoftBack);
            /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
            DRAW_ICON_SEL_MASK(ICON_POPUPICON, 2);
#elif (MAIN_LCD_SIZE==4)
			DRAW_ICON_SEL(ICON_POPUPACTION, 2);
#endif
            //dspl_BitBlt(41, 17, 21, 18, 0, (void *)iconRequire, 0);
            dspl_TextOut(26,86,0,MmiRsrcGetText(TxtDialError));
            dspl_TextOut(26,106,0,MmiRsrcGetText(TxtDialRedial));
            driverFlag|=0x0001;
            dial_mode=redial1;
        }
        break;
    case dialing:
        TRACE_EVENT("dialing");
        {
            int a;
            a=StartVDReco();
            if( a==-1 )//start recognize error
            {
                StopVDReco();
                SEND_EVENT(win,dial_destroy,0,0);
                return;
            }
            driverFlag&=0xfffffffe;
            dial_index++;
            //           dspl_Clear(10,40,108,123);/*2003/12/1, wangyan modify */
            displaySoftKeys(TxtNull,TxtSoftBack);
            //            dspl_BitBlt(42,54,27,27,0,(void*)waiting1,0);
            draw_popup_background();/*2003/1/2, wangyan modify */
            dspl_TextOut(10,TOP_POSITION+35,0,MmiRsrcGetText(TxtDialing));
            dial_mode=dialing;
        }
        break;
    case dial_error:

        TRACE_EVENT("yq:dial_error in voice_dialog");
        {
            if( dial_index<4 )
            {
                if( winIsFocussed(voice_win)||fromwinshow )
                    SEND_EVENT(win,redial1,0,0);
                else
                    SetDialMode(redial1);
            }
            else
            {
                if( winIsFocussed(voice_win)||fromwinshow )
                {
                    dspl_Clear(10,40,108,123);
                    displaySoftKeys(TxtNull,TxtSoftBack);
                    /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
					DRAW_ICON_SEL_MASK(ICON_POPUPICON, 1);
#elif (MAIN_LCD_SIZE==4)
					DRAW_ICON_SEL(ICON_POPUPACTION, 1);
#endif
                    //dspl_BitBlt(41, 17, 21, 18, 0, (void *)iconFailed, 0);
                    dspl_TextOut(26,95,0,MmiRsrcGetText(TxtDialError));
                    dial_mode=dial_error;
                }
                else
                    SetDialMode(dial_error);
            }
            fromwinshow=0;
        }
        break;

    case dial_ok:

        dial_index=0;//we reset the dialindex
        {
            if( winIsFocussed(voice_win)||fromwinshow )
            {

                if( winIsFocussed(voice_win) )
                {
                    strcpy(voice_name,(char *)((char *)parameter+8));
                    for( i=0;i<VOICEDIAL_MAX;i++ )
                    {
                        if( strcmp(voice_name,voice_filename[i])==0 )
                        {
                            break;
                        }
                    }
                    if( i<10 )
                    {
                        recoginze_call_index=i;
                        dspl_Clear(10,40,108,123);
                        /* 2004/06 sunsj modify for picture manage */
#if(MAIN_LCD_SIZE==3)
						DRAW_ICON_SEL_MASK(ICON_POPUPICON, 0);
#elif (MAIN_LCD_SIZE==4)
						DRAW_ICON_SEL(ICON_POPUPACTION, 0);
#endif
                        //dspl_BitBlt(41, 17, 21, 18, 0, (void *)iconSucess, 0);
                        dspl_TextOut(26,86,0,MmiRsrcGetText(TxtDialOk));
                        dspl_TextOut(26,106,0,MmiRsrcGetText(TxtCallReady));
                        timStart(data->tim);
                    }
                    else
                    {
                        StopVDReco();
                        SEND_EVENT(win,dial_error,NULL,NULL);
                    }
                }
                else
                {
                    timStart(data->tim);
                }
            }
            else
            {
                strcpy(voice_name,(char *)((char *)parameter+8));
                for( i=0;i<VOICEDIAL_MAX;i++ )
                {
                    if( strcmp(voice_name,voice_filename[i])==0 )
                    {
                        break;
                    }
                }
                if( i<10 )
                {
                    recoginze_call_index=i;
                    SetDialMode(dial_ok);
                }
                else
                {
                    SetDialMode(dial_error);
                }
            }
        }
        break;
    case dial_destroy:
        TRACE_EVENT("dial_destroy");
        {
            boodVoiceRecordDestroy(win);                    
        }
        break;
    default:break;
    }
}

static int bookVdDialWindowCB( MfwEvt e, MfwWin *w )
{
    MfwHdr *elements;
    MfwHdr *win;
    if( !w )
        return 0;
    elements=w->elems;
    if( !elements )
        return 0;
    w=mfwParent(elements);
    if( !w )
        return 0;
    dspl_ClearAll();
    draw_popup_background();
    switch( dial_mode )
    {
    case dial_error:
    case dial_ok:
        fromwinshow=1;
        SEND_EVENT(w,dial_mode,NULL,NULL);
        break;
    case redial1:
    case dial_ready:
        fromwinshow=0;
        SEND_EVENT(w,dial_mode,NULL,NULL);
        break;
    default:
        SEND_EVENT(w,dial_destroy,NULL,NULL);//error mode,destroy the win
        break;
    }

    return 1;
}

static T_MFW_HND bookVoiceRecordCreate( MfwHnd parent )
{
    T_MFW_WIN     * win_data;
    T_voice_info *  data = (T_voice_info *)ALLOC_MEMORY (sizeof (T_voice_info));

    TRACE_FUNCTION ("Vd_Record_create()");

    data->win = win_create (parent, 0, E_WIN_VISIBLE,(MfwCb)bookVdDialWindowCB);//(T_MFW_CB)voice_win_cb

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)voice_dialog;
    data->mmi_control.data     = data;
    data->parent_win           = parent;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;

    /*
     * return window handle
     */
    //data->tim=timCreate(data->win,250,(MfwCb)voice_tim_cb);
    data->kbd             = kbd_create (data->win, KEY_ALL, (T_MFW_CB)dial_kbd_cb);
    data->tim             = timCreate(data->win,500,(MfwCb)Recognize_Dial_CB);
    voice_win=data->win;
    //  winShow(data->win);
    return data->win;

}

MfwHnd bookVoiceRecordStart( MfwHnd parent)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("bookVoiceRecordStart()");

    GetVoiceData();
    getVoiceTotal();
    if( voice_total==0 )
    {
        bookShowInformation(parent,TxtNoVoiceDial,NULL,NULL);
        return;
    }
    if( ( win = bookVoiceRecordCreate( parent ) ) != NULL )
    {
        dial_index=0;
        SetDialMode(dial_ready);
        winShow(win);
    }
    return win;
}

static T_MFW_CB Recognize_Dial_CB (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win        = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data   = ((T_MFW_HDR *)win)->data;
    T_voice_info*  data       = (T_voice_info*)win_data->user;
    int j;

    TRACE_EVENT("recoginze_dial_cb()");
    if( winIsFocussed(voice_win) )
    {
        j=dspl_Enable(0);
        if( voice_win )
            SEND_EVENT(voice_win,dial_destroy,0,0);
        TRACE_EVENT("now start call");
        callNumber((UBYTE *)voice_dial[recoginze_call_index].number);
        dspl_Enable(j);
        recoginze_call_index=-1;
    }
    else
    {
        j=dspl_Enable(0);
        if( voice_win )
            SEND_EVENT(voice_win,dial_destroy,0,0);//we destroy the voice_win
        TRACE_EVENT("error start call");
        dspl_Enable(j);
        recoginze_call_index=-1;
    }
}

void SetCurrentMode(voice_mode  mode)
{
    current_mode=mode;
    return;
}

void SetDialMode(unsigned char mode)
{
    dial_mode=mode;
    return;
}
//yq added for indicate phbk 2003/3/17
void SetPhbkIN(UBYTE flag)
{
    TRACE_FUNCTION("SetPhbkIN");
    Phbk_DynamicMenu=flag;
}

int IsPhbIN()
{
    return Phbk_DynamicMenu;
}
/******************************************************************************
                                End of File
*******************************************************************************/
