/*******************************************************************************

          CONDAT (UK)

********************************************************************************

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.

********************************************************************************

 $Project name: Basic MMI
 $Project code: BMI (6349)
 $Module:   Call
 $File:       MmiCall.c
 $Revision:   1.0

 $Author:   Condat(UK)
 $Date:       25/10/00

********************************************************************************

 Description

    This module provides the call functionality


********************************************************************************
 $History: MmiCall.c
    Date .................. Modification ......................................
  25/10/00      Original Condat(UK) BMI version.
    01/08/02      version 0.100 zy add "addNewCall(),endOneExec()"two functions for call menu
  15/08/02       zy add adjust volume
  29/08/02       zy adjust volume
 $End

*******************************************************************************/


/******************************************************************************

                                Include Files

*******************************************************************************/

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_lng.h"
#include "mfw_edt.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_tim.h"

#include "mfw_sim.h"
#include "mfw_cm.h"
#include "mfw_nm.h"
#include "mfw_phb.h"
#include "mfw_mme.h"
#include "mfw_sat.h"
#include "mfw_sms.h"

#include "dspl.h"

#include "ksd.h"
#include "psa.h"

#include "MmiMain.h"
#include "MmiBookController.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"



#include "MmiMenu.h"
#include "MmiCall.h"
#include "MmiIcons.h"
#include "MmiIdle.h"
#include "Mmimemo.h"

#include "MmiSoftKeys.h"
#include "MmiSounds.h"
#include "MmiIdle.h"
#include "MmiNetwork.h"
#include "MmiSat_i.h"
#include "MmiAoc.h"
#include "MmiResources.h"	/* sbh */

#include "gdi.h"
#include "audio.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "mfw_ffs.h"
#include "MmiTimers.h"
#include "Mmihost.h"  //xsf add 2002.08.05

//glowing: add it to fix the bug of record call */
#include "mmivoicememo.h" 

#include "psa_cc.h"
/* SPR#1656 - SH - Required for WAP disconnect event */
#ifdef MMI_WAP_ENABLED
    #include "AUIWapExt.h"
#endif
#include "pwr.h"   //zym added 09/05/02
#include "Rtc_api.h" //wufei 1009
#include "Mmisettings.h"
#include "GameDisplay.h"

//#define TDTRACE 1
#include "Mmiutilapi.h"
#include "mmiouterIdle.h" /*2003/12/27, wangyan add incoming call outsidescreen*/
//#include "mmiicndialogs.h"
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
#include "mmicamera.h"
#endif

/*******************************************************************************

                              External Function Prototypes.

*******************************************************************************/
static char InterNat_Plus[33];
extern UBYTE getCurrentRingerSettings(void );
extern T_RTC_DATE_TIME timedate;//wufei 1009
extern int M_callSendNew(MfwMnu* m, MfwMnuItem* i); // 2003-04-01 zy add add new message in call
extern pwr_Status_Type    pwr_Status;  ///zym added 09/05/02
extern driver_Parameter drvpara;//zy 10/22 for hall action in call
extern uint8 SimReadyFlag; //for 3120 (change in findnumber()) hu binhao2002-12-26
extern UINT32 driverFlag;// wms added 03-01-22
extern uint8 CallListFlag;  //hu binhao  2003-1-21
extern MfwHnd cugwindows; //hu binhao  2003-1-21
extern uint8 MCallHintDleteFlag;  //hu binhao  2003-1-29 the flag will set 1 when browse recent call neme and a missed call happened.
extern UINT8   melody_status;//zy 2003-03-3 if before is play sound we couldn't set handsetmode
extern char oldringstr[20];//wsm added 03-04-07
extern void voice_memo_destroy (T_MFW_HND own_window);//zy 2003-04-01 
//extern int incoming_call_kbd_long_cb (MfwEvt e, MfwKbd *k);/*2004/3/31, wangyan add*/
extern int incoming_call_kbd_long_KeyAction ();/*2004/3/31, wangyan add*/
/* Marcus: Issue 1057: 21/01/2003: Added the following two external prototypes 
zy checkin 2003-04-16
*/
extern T_MFW_HND sat_get_setup_menu_win (void);
extern T_MFW_HND sat_get_call_setup_win (void);

/*end of zy change 2003-04-16*/
/*******************************************************************************
                End
*******************************************************************************/
#define TRACE_MMI_CALL

#ifndef TRACE_MMI_CALL
//#define TRACE_EVENT(a)
#endif

#if defined (WIN32)
    #define TONES_AUTH_NUM  3
    #define TONES_BUSY      4
    #define TONES_DROPPED   5
    #define TONES_CONGEST   6
#endif



#ifndef MFW_EVENT_PASSED
    #define MFW_EVENT_PASSED 0
#endif

//#define FIELD_TEST_MODE 			/* 2003/12/1, wangyan modify */


#define NUMERIC_KEYS 		0x8FF	/*MC for setting up dialogue key events*/

#define MAX_SOUND 255
static UBYTE LocalRing=FALSE;
UBYTE  call_SATCall = FALSE;//zy 2003-04-16 make it be global
static UBYTE InCallTimer = TRUE; //This ought to be stored in ffs
BOOL call_win_flag=FALSE;
extern char currTryAccept;
static int notavailtryone=1;//zy 2003-04-04 "1" not try yet,"0" have tryed one time

int removeCall (SHORT cid);
int addCall (SHORT cid);
void call_scratchpad_destroy (T_MFW_HND own_window);
int callCmEvent (MfwEvt e, void *para);
static int InformationTimerEvent(MfwEvt e, MfwTim *t);


static int callWaitingAnswerKeyEvent (MfwEvt e, MfwKbd *k);
void callAutoRedialKeyEvent(T_MFW_HND win, USHORT identifier, USHORT reason);

static void callSetMode(int mode);

static int contactsExec(MfwMnu* m, MfwMnuItem* i);
static int holdExec(MfwMnu* m, MfwMnuItem* i);
static int muteExec(MfwMnu* m, MfwMnuItem* i);
static int addNewCall(MfwMnu* m, MfwMnuItem* i);//zy Mobile Innovation 01/08/02 add a new call by dialing use scratch window
//static int scratchPadExec(MfwMnu* m, MfwMnuItem* i);
static int mainMenuExec(MfwMnu* m, MfwMnuItem* i);
static int startConferenceExec(MfwMnu* m, MfwMnuItem* i);
static int swapExec(MfwMnu* m, MfwMnuItem* i);
static int endAllExec(MfwMnu* m, MfwMnuItem* i);
static int endConferSingleExec(MfwMnu* m, MfwMnuItem* i);//zy Mobile Innovation 10/08
static int endOneExec(MfwMnu* m, MfwMnuItem* i);//zy Mobile Innovation 01/08/02 end the call active now
static int transferExec(MfwMnu* m, MfwMnuItem* i);
static int privateStartAddConferenceExec(MfwMnu* m, MfwMnuItem* i);
static int exeSendMessage(MfwMnu* m, MfwMnuItem* i);
static int callExeNameEnter(MfwMnu* m, MfwMnuItem* i);
static void showCCNotify (T_MFW_HND win, T_MFW_CM_NOTIFY  * cc_notify);

static void showSelectPrivateCall(void);
static void showWaitingAnswer(void);
static void showAutoRedial(void);
static void SaveVolumeSetting (void);


static void endingCall(void);
static void rebuildCalls(void);
static int getCallStatus(SHORT call_number,T_MFW_CM_STATUS* call);
void incomingCall(const T_MFW_CM_CW_INFO* p_pCwInfo);
void callConnect(SHORT cid);
void getTimeString(long time,char *timeString);
static void refreshCallTimer();

static void callFailureCause(UBYTE cause);
static void sendDTMFString(void);
static void callCalcCost(char* line);

//static void saveNumCallRecord(char callrecordtype,const char* num );  //hubinhao 2002-11-20
static void saveNumCallRecord(char callrecordtype, char* num, uint8 IsfindNumRes,uint8 SRFlag,T_FindName  * searchdata); //hubinhao 2002-11-20
static int CallRecord(MfwMnu* m, MfwMnuItem* i);
//static int TestModeStart(MfwMnu* m, MfwMnuItem* i);      /*2003/12/1, wangyan delete*/
char* getViewStatus(int);//2004-03-8 Sunny add
char* callInformation;
int callIndex(SHORT cid);
char line[MAX_LINE];
static void (*show) (void);
//xsf add 2002.08.05 2 lines
extern char SimLock1;
extern char ProOnLock;//hostkey protect switchon flag
extern MfwHnd gtVibator; //XSF 08.14 static MfwHnd gtVibator;
//static SHORT singleCall;
short singleCall;/*2004/4/14, wangyan modify*/
//char  latestInNum[21];  //hu binhao 2002-
char  latestInNum[24];  //hu binhao 2002-12-23 for fix 3128
//char  latestOutNum[21]; //hu binhao 2002-
char  latestOutNum[24]; //hu binhao 2002-12-23 for fix 3128
char  latestReceivedNum[24];  //hu binhao 2002-12-23 for fix 3128
//char  latestReceivedNum[21];  //
char extnum[CALL_NAME_LENGTH+2];
static tMmiCallTable calls;
int idwithheld;
uint8 SpeakerVols;
uint8 animnum;
uint8 CALLRINGOFF;
uint8 Isfromcallwin,Iscallnumber1;//zy add 0107/2003 judge if is from call win so we can judge if need action to active leave call when a new call is failured;	
static uint8  IsIngroup;  //hu binhao 2002-12-29 bug 3120 bug  3120
static T_FindName  searchPhdata; //hu binhao 2002-12-29 bug 3120
extern uint8 SimReadyFlag; //hu binhao 2002-12-29 for bug    3120
extern BOOL IncallLedisRun;

/*************begin ganchunhui adding*****************/
//#ifdef FIELD_TEST_MODE
//unsigned char gucEarPhoneSupport=1;           //flag for supporting earphone or not , 
//#endif
/************end  ganchunhui adding******************/
BOOL IncallLedControl;/* zy add 01-23-2003 for led incomingcall light on or off*/
//18/12/2001  MC added sms message option
//2004-03-5 Sunny modify for item icon
extern const MfwIcnAttr colist[];

static T_MFW_MNU_ITEM menuCallSingleItems[] =
{
    // {0,0,0,(char *)TxtSoftContacts,  0,(MenuFunc)contactsExec,  item_flag_none},//zy Mobile Innovation 01/08/02 seemed not need
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtHold,         0,(MenuFunc)holdExec,      item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtMute,         0,(MenuFunc)muteExec,      item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtAddNewCall,      0,(MenuFunc)addNewCall,      item_flag_none},//zy Mobile Innovation 01/08/02 add new call menu
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtSendMessage,   0,   (MenuFunc)M_callSendNew,   item_flag_none},//zy 2003-04-01 
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtRecVoice,   0,   (MenuFunc)CallRecord,   item_flag_none},//zy 12/03
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtMemo,    0,   (MenuFunc)memoAdd,   item_flag_none},//gdy add 03/01/07
    /*#ifdef FIELD_TEST_MODE
       {0,0,0,(char*) TxtTestCommand,   0,   (MenuFunc)TestModeStart,   item_flag_none}//xzy add 03/02/12 for testmode
    #endif*//*2003/12/1, wangyan delete*/
};

static const MfwMnuAttr menuCallSingle =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE,               /* centered page menu       */
    -1,                                                /* use default font         */
    menuCallSingleItems,                               /* with these items         */
    sizeof(menuCallSingleItems)/sizeof(T_MFW_MNU_ITEM) /* number of items          */
};

//18/12/2001  MC added sms message option
//2004-03-5 Sunny modify for item icon
static T_MFW_MNU_ITEM menuCallTwoItems[] =
{
    // {0,0,0,(char *)TxtContacts,        0,(MenuFunc)contactsExec,         item_flag_none},//zy Mobile Innovation 01/08/02 seemed not need
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtSwap,            0,(MenuFunc)swapExec,             item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtEndAll,          0,(MenuFunc)endAllExec,           item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtEndOne,          0,(MenuFunc)endOneExec,           item_flag_none},//zy Mobile Innovation 01/08/02 add end active call
    //   {0,0,0,(char *)TxtMute,            0,(MenuFunc)muteExec,             item_flag_none},
    //  {0,0,0,(char *)TxtCallTransfer,         0,(MenuFunc)transferExec,      item_flag_none},//MC//zy dont use it temp
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtStartConference,  0,(MenuFunc)startConferenceExec,         item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtSendMessage,   0,   (MenuFunc)M_callSendNew,   item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtRecVoice,   0,   (MenuFunc)CallRecord,   item_flag_none},//zy 12/03
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtMemo,    0,   (MenuFunc)memoAdd,   item_flag_none},//gdy add 03/01/07
    /*#ifdef FIELD_TEST_MODE
       {0,0,0,(char*) TxtTestCommand,   0,   (MenuFunc)TestModeStart,   item_flag_none}//xzy add 03/02/12 for testmode
    #endif*//*2003/12/1, wangyan delete*/

};

static const MfwMnuAttr menuCallTwo =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    menuCallTwoItems,                /* with these items         */
    sizeof(menuCallTwoItems)/sizeof(T_MFW_MNU_ITEM) /* number of items     */
};

//18/12/2001  MC added sms message option
//2004-03-5 Sunny modify for item icon
static T_MFW_MNU_ITEM menuCallConferenceItems[] =
{
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtPrivateCall,  0,(MenuFunc)privateStartAddConferenceExec,  item_flag_none},
    //   {0,0,0,(char *)TxtSwap,         0,(MenuFunc)swapExec,                       item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtEndAll,       0,(MenuFunc)endConferSingleExec,                     item_flag_none},/*zy 2003-03-19 replace endAllExec*/
    //	{0,0,0,(char *)TxtContacts,     0,(MenuFunc)contactsExec,                   item_flag_none},//zy Mobile Innovation 01/08/02 seemed not need
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtHold,         0,(MenuFunc)holdExec,                       item_flag_none},
    //    {0,0,0,(char *)TxtMute,         0,(MenuFunc)muteExec,                       item_flag_none},
    //    {0,0,0,(char *)TxtScratchPad,   0,(MenuFunc)scratchPadExec,                 item_flag_none},
    //    {0,0,0,(char *)TxtMainMenu,     0,(MenuFunc)mainMenuExec,                   item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtAddNewCall,      0,(MenuFunc)addNewCall,      item_flag_none},//zy Mobile Innovation 01/08/02 add new call menu
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtSendMessage,  0,   (MenuFunc)M_callSendNew,   item_flag_none},
    //     {0,0,0,(char *)TxtEndOne,          0,(MenuFunc)endOneExec,           item_flag_none},//zy 2003-03-04move it zy Mobile Innovation 01/08/02 add end active call
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtRecVoice,  0,   (MenuFunc)CallRecord,   item_flag_none},//zy 12/03
    {(MfwIcnAttr*)&colist,0,0,(char*)TxtMemo,    0,   (MenuFunc)memoAdd,   item_flag_none},//gdy add 03/01/07
    /*#ifdef FIELD_TEST_MODE
       {0,0,0,(char*) TxtTestCommand,   0,   (MenuFunc)TestModeStart,   item_flag_none}//xzy add 03/02/12 for testmode
    #endif*//*2003/12/1, wangyan delete*/
};

static const MfwMnuAttr menuCallConference =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    (T_MFW_MNU_ITEM *)menuCallConferenceItems,                /* with these items         */
    sizeof(menuCallConferenceItems)/sizeof(T_MFW_MNU_ITEM) /* number of items     */
};
/****************zy 10/08/2002 add for single conferenceItems needn't hold items******/
//2004-03-5 Sunny modify for item icon
static T_MFW_MNU_ITEM menuCallConferSingleItems[] =
{
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtPrivateCall,  0,(MenuFunc)privateStartAddConferenceExec,  item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtSwap,         0,(MenuFunc)swapExec,                       item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtEndAll,       0,(MenuFunc)endConferSingleExec,                     item_flag_none},
    //  {0,0,0,(char *)TxtAddNewCall,      0,(MenuFunc)addNewCall,      item_flag_none},//zy Mobile Innovation 01/08/02 add new call menu
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtSendMessage,   0,   (MenuFunc)M_callSendNew,   item_flag_none},
    {(MfwIcnAttr*)&colist,0,0,(char *)TxtEndOne,          0,(MenuFunc)endOneExec,           item_flag_none},//zy Mobile Innovation 01/08/02 add end active call
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtRecVoice,   0,   (MenuFunc)CallRecord,   item_flag_none},//zy 12/03
    {(MfwIcnAttr*)&colist,0,0,(char*) TxtMemo,    0,   (MenuFunc)memoAdd,   item_flag_none},//gdy add 03/01/07
    /*#ifdef FIELD_TEST_MODE
       {0,0,0,(char*) TxtTestCommand,   0,   (MenuFunc)TestModeStart,   item_flag_none}//xzy add 03/02/12 for testmode
    #endif*//*2003/12/1, wangyan delete*/
};

static const MfwMnuAttr menuCallConferSingle =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    (T_MFW_MNU_ITEM *)menuCallConferSingleItems,                /* with these items         */
    sizeof(menuCallConferSingleItems)/sizeof(T_MFW_MNU_ITEM) /* number of items     */
};
/****************end of zy 10/08/2002 add**********************************/
#if 0 /*2003/12/16, wangyan delete*/
static const T_MFW_MNU_ITEM menuDTMFItems [] =
{
    {0,0,0, (char*)TxtSendMessage,  0,(MenuFunc)exeSendMessage,    item_flag_none},
    {0,0,0, (char*)TxtAddNew,       0,(MenuFunc)callExeNameEnter,  item_flag_none}
};



static const T_MFW_MNU_ATTR menuDTMF =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    (T_MFW_MNU_ITEM *)menuDTMFItems,                      /* with these items         */
    sizeof(menuDTMFItems)/sizeof(T_MFW_MNU_ITEM) /* number of items     */
};
#endif /*2003/12/16, wangyan delete*/


/*********************************************************************
**********************************************************************

          CALL WINDOW. DECLARATION

*********************************************************************
**********************************************************************/



T_call call_data;


void call(T_MFW_HND win, USHORT event, SHORT value, void * parameter);


static int call_win_cb(MfwEvt e, MfwWin *w);
static int call_kbd_cb (MfwEvt e, MfwKbd *k);
static int call_kbd_long_cb (MfwEvt e, MfwKbd *k);


/*********************************************************************
**********************************************************************

          MENU WINDOW. DECLARATION

*********************************************************************
**********************************************************************/

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    T_VOID_FUNC     func_cb;
    T_MFW_HND       parent;
    /*
     * internal data
     */
} T_call_menu;


static T_MFW_HND call_menu_create(MfwHnd parent);
static void call_menu_destroy(MfwHnd window);

T_MFW_HND call_menu_start(MfwHnd parent,MfwMnuAttr* menuAttr,T_VOID_FUNC func_cb);

void call_menu (T_MFW_HND win, USHORT event, SHORT value, void * parameter);


static int call_menu_win_cb (MfwEvt e, MfwWin *w);
static int call_menu_kbd_cb (MfwEvt e, MfwKbd *k);
static int call_menu_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int call_menu_mnu_cb (MfwEvt e, MfwMnu *m);



/*********************************************************************
**********************************************************************

          CALL FUNCTIONS. DECLARATION

*********************************************************************
**********************************************************************/

void call_incoming_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void call_calling_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void call_ending_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void call_waiting_answer_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void call_sending_dtmf_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void call_menu_end_cb(void);
void call_failtryagain_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
void call_failure_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void call_calling_show (USHORT Identifier);
void call_info_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
/* Marcus: Issue 1057: 21/01/2003: Added the following function prototype
   zy 2003-04-16 checkin
*/
void call_acm_max_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);


/*********************************************************************
**********************************************************************

          DIALLING WINDOW. DECLARATION

*********************************************************************
**********************************************************************/



typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND win;     // window handle
    T_MFW_HND kbd;
    T_MFW_HND kbd_long;
    T_MFW_HND edt;
    UBYTE mode;
    UBYTE callstatus;
} T_call_scratchpad;




T_MFW_HND call_scratchpad_create(MfwHnd parent);
void call_scratchpad_exit (void);
static int call_scratchpad_kbd_cb (MfwEvt e, MfwKbd *k);
static int call_scratchpad_kbd_long_cb (MfwEvt e, MfwKbd *k);
static int call_scratchpad_win_cb (MfwEvt e, MfwWin *w);

void call_scratchpad (T_MFW_HND win, USHORT event, SHORT value, void * parameter);

T_MFW_HND call_scratchpad_start (T_MFW_HND win_parent,char character,UBYTE mode, UBYTE callstatus);
void StartAutoDtmf(void);

/*******************************************************************************

                                Private Methods

*******************************************************************************/

/*******************************************************************************

 $Function:     callInit

 $Description:  initiates the window

 $Returns:    none

 $Arguments:  parent window

*******************************************************************************/

void callInit (MfwHnd parent)
{

    //	MMI_TRACE_EVENT(("wangyan callInit"));

    cm_init();
    call_data.cm = cm_create(0, E_CM_ALL_SERVICES, (MfwCb)callCmEvent);
    MMI_TRACE_EVENT(("wangyan callInit call_data.cm=%d",call_data.cm));
    call_data.win = 0;
    call_data.callStatus = CallInactive;
    call_data.win_sms=0;//zy 2003-04-01 just initial smssend=0 at here it means there are a smssend win whereever it be



}


/*******************************************************************************

 $Function:     callExit

 $Description:  Exits the window

 $Returns:    none

 $Arguments:  none

*******************************************************************************/


void callExit (void)
{

    MMI_TRACE_EVENT(("wangyan callExit"));
    cm_delete(call_data.win);
    cm_exit();
}




/*******************************************************************************

 $Function:     callAutoRedialKeyEvent

 $Description:  keyboard event handler

 $Returns:    none

 $Arguments:  typical

*******************************************************************************/


void callAutoRedialKeyEvent(T_MFW_HND win, USHORT identifier, USHORT reason)
{

    TRACE_FUNCTION("callAutoRedialKeyEvent");

    call_data.win_redial = 0;
    switch( reason )
    {
    case INFO_KCD_LEFT:
        /*
           callSetMode(ViewAutoRedial);
           cm_redial();
        */       
        break;
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
    case INFO_KCD_CLEAR:
    case INFO_KCD_F4:/*2004/4/27, wangyan add*/
        cm_redial_abort();
        callSetMode(ViewConnect);
        /*2004/4/27, wangyan add*/
        if( call_data.win_redial )
        {
            SEND_EVENT(call_data.win_redial,DIALOG_DESTROY,0,0);
            MMI_TRACE_EVENT(("wangyan call_data.win_calling DIALOG_DESTROY"));
            call_data.win_redial = 0;
        }
        /*2004/4/27, wangyan add*/
        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:     callCmEvent

 $Description:  call management event handler

 $Returns:    1, processed, 0 ignored

 $Arguments:  event and parameter

*******************************************************************************/



int callCmEvent(MfwEvt e, void *para)
{

    UBYTE currentRinger;
    int i;
    SHORT       *cid;
    T_MFW_CM_DISCONNECT *dc;
    T_MFW_CM_COMMAND  *comm;
    SHORT       callId;
    T_MFW_CM_REDIAL     *pRedial;
    T_MFW_CM_CPI        *cmCpi;
    //T_FindName  searchPhdata;
    //char * num;/*2004/04/05,talcon delete*/
    int old_color;/*2003/12/10, wangyan modify*/


    /*2004/04/05,talcon delete*/
    //sprintf(stringTrace,"%s %d","callCmEvent",e);
    //MMI_TRACE_EVENT((stringTrace));
    switch( e )
    {

    /*
     * Handle call notifications
     */
    case E_CM_NOTIFY:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_NOTIFY"));
        SEND_EVENT (call_data.win, E_CM_NOTIFY, 0, para);
        break;

    case E_CM_COLP:

        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_COLP"));
        SEND_EVENT (call_data.win, E_CM_COLP,0, para);
        break;

    case E_CM_CW:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_CW"));
        TraceInt(call_data.calls.numCalls);//zy 09/05 begin
        StopVoiceMemo();

        if( call_data.win_scratch )
        {
            call_scratchpad_destroy(call_data.win_scratch);
            call_data.win_scratch =0;
        }
        if( call_data.win_menu )
        {
            call_menu_destroy(call_data.win_menu);
            call_data.win_menu = 0;
        }
        /*begin of zy change 2003-04-01
          if there are incoming call we must destroy all these wins;
          avoid it will build the same wins several times
        */
        if( call_data.win_adjustvolume )
        {
            SEND_EVENT(call_data.win_adjustvolume,CALLVOLDESTROY,0,0);
            call_data.win_adjustvolume = 0;
        }
        if( call_data.win_memo )
        {
            Memo_destroy(call_data.win_memo);
            call_data.win_memo = 0;
        }
        if( call_data.win_phb )
        {
            bookPhonebookDestroy(call_data.win_phb);
            call_data.win_phb=0;
        }
        if( call_data.win_voicerecord )
        {
            voice_memo_destroy (call_data.win_voicerecord);
            call_data.win_voicerecord=0;
        }
        /*end of zy change 2003-04-01*/
        /*begin of zy change 2003-02-28 
          only destroy calling_win
        */

        if( call_data.win_calling )
        {
            cm_disconnect(call_data.outCall);
            SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
            call_data.win_calling = 0;
        }

        /*end of zy change 2003-02-28*/
        if( para )
        {
#ifdef _MMS_ENABLE_
		extern BOOL isIncomingCall ;
		isIncomingCall = TRUE;//04-6-29 added by xie for jugding whether there is call incoming.			
#endif
		
            incomingCall((T_MFW_CM_CW_INFO*)para);
        }
        //  mmeSetVolume (1, FFS_flashData.output_volume);//zy 09/18 its needn't

        break;
    case E_CM_RING_OFF:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_RING_OFF"));
        //Stopplayingdevice(); //xsf changed 12.31
        //StopPlayByReasonId(INCALLPLAY);zy 2003-02-28 needn't
        break;
    case E_CM_DISCONNECT:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_DISCONNECT"));
        if( strlen((char*)call_data.colp_number) > 0 )
            memset(call_data.colp_number,'\0',sizeof(call_data.colp_number));

#ifdef MMI_WAP_ENABLED
        /* SPR#1656 - SH - Inform WAP of a disconnection */
        AUI_wap_call_disconnect();
#endif

        if( call_data.ignore_disconnect )
        {
            MMI_TRACE_EVENT(("call_data.ignore_disconnect"));
            return 1;
        }
        dc = (T_MFW_CM_DISCONNECT *)para;

        if( LocalRing )
        {
            LocalRing = FALSE;
        }
        TRACE_EVENT("Disconnect Event");
        cm_get_aoc_value(CM_AOC_CCM,&call_data.aocInfo);
        if( !dc->call_number )
        {       // Delete multiparty
            i = 0;
            while( i<call_data.calls.numCalls )
            {
                /*2004/04/05,talcon delete*/
                //sprintf(stringTrace,"callId %d; numCalls  %d",callId,call_data.calls.numCalls);
                //TRACE_EVENT(stringTrace);
                //MMI_TRACE_EVENT(("wangyan: E_CM_DISCONNECT: %s",stringTrace));
                if( call_data.calls.status[i].call_number!=singleCall )
                {

                    if( !removeCall(call_data.calls.status[i].call_number) )
                    {
                        i++;
                        /* 2004/04/16 sunsj modify */
                        LedLightnessAdjust( 200 );
                        timStart(gtVibator);
                    }

                }
                else
                    i++;
            }
        }
        if( callIndex(dc->call_number)<MAX_CALLS )
        {
            MMI_TRACE_EVENT(("wangyan: E_CM_DISCONNECT: callIndex(dc->call_number):%d",dc->call_number));
            removeCall(dc->call_number);  // Delete active call
            /* 2004/04/16 sunsj modify */
            LedLightnessAdjust( 200 );
            timStart(gtVibator);
        }
        else
        {                // Delete not executed call

            if( (dc->call_number==call_data.incCall) )
            {

                if( call_data.win_incoming )
                {
                    extern void set_lcdOffControl(int status);
                    MMI_TRACE_EVENT(("wangyan: E_CM_DISCONNECT: before win_incoming DIALOG_DESTROY"));
                    if( idwithheld == TRUE )
                        idCounter = idCounter + 1;

                    SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
                    call_data.win_incoming = 0;
                    MMI_TRACE_EVENT(("wangyan: E_CM_DISCONNECT: after win_incoming DIALOG_DESTROY"));

                    /* 2004/04/12 sunsj add for close */
                    timStart(gtVibator);
                    /*2004/05/15,talcon add*/
                    set_lcdOffControl(2);

                    stopIncallLed();/* zy add 01-23-2003 for led incomingcall stop*/

                }
                /*2003/12/16, wangyan add*//*
                if (call_data.win_active)
                {
                    SEND_EVENT(call_data.win_active,DIALOG_DESTROY,0,0);
                    call_data.win_active = 0;
                }*/
                /*2003/12/16, wangyan add*/
                //glowing,2005-05-25, add _M188_ for compatible with M288B( rita project)	    
#ifdef _M188_
                if( dc->cause!=CAUSE_NOT_PRES )
#else
                if( GET_CAUSE_VALUE(dc->cause) != NOT_PRESENT_8BIT )
#endif
                {
                    MMI_TRACE_EVENT(("wangyan CAUSE_NOT_PRES"));
                    //Calling side has terminated the call, turn of ringer MZ.
                    currentRinger = getCurrentRingerSettings();
                    //Stopplayingdevice(); //xsf add 2002.08.12
                    // audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );
                    //Check if incoming call has been rejected by user, call is not regarded as a missed call. MZ
                    if( dc->cause != CAUSE_USER_BUSY )
                    {
                        if( call_data.globalCWInfo.type EQ VOICE_CALL )
                        {
                            /*(2004/04/05,talcon modify*//*
                            wstrcpy(num, (char *)call_data.calls.status[(int)dc->call_number].number);
                            MMI_TRACE_EVENT(("<<<talcon,callCmEvent--num:%d,%p",wstrlen(num),num));
                            addMissedCall(num);*/
                            addMissedCall((char *)call_data.calls.status[(int)dc->call_number].number);

                            // saveNumCallRecord('M',latestInNum ); //hu binhao 2002-11-26
                            setOuterState(OUTERIDLESTATE_CALL,0, 0);//2004-03-23 Summy modify
                            setOuterState(OUTERIDLESTATE_MISSCALL,1, 0);//2004-03-23 Summy modify
                            saveNumCallRecord('M',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29
                            /*begin of zy 2003-03-11
                              when "A" connected to "B" then "C" call "A";
                              "A" accept the same time "C" reject; 
                              so "B" Always heard "in hold" but "A"display "actived"
                              now we try to retrive it
                            *///TRACE_EVENT("zy:disconect currTryAccept=");
                            TraceInt(currTryAccept);
                            if( currTryAccept==1 )
                            {
                                call_data.calls.status[callIndex(call_data.calls.selected)].stat =CALL_HELD;
                                /* cm_command(call_data.calls.selected, CM_RETRIEVE, '\0');
                                 call_data.current_command = CM_RETRIEVE;*/
                                currTryAccept=0;
                                winShow(call_data.win);
                            }
                            /*end of zy 2003-03-11*/
                        }
                    }
                }
                call_data.incCall = 0;
                if( !call_data.calls.numCalls )
                    if( call_data.win )
                    {
                        MMI_TRACE_EVENT(("wangyan, E_CM_DISCONNECT call_destroy"));
                        //	call_data.win=0;
                        setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add
                        call_destroy(call_data.win);//wangyan 2005
                        return 1;
                    }
            }
            if( (dc->call_number==call_data.outCall) )
            {
                /*2004/04/05,talcon delete*/
                //sprintf(stringTrace,"out_call_number %d;",call_data.outCall);	
                //MMI_TRACE_EVENT(("wangyan:E_CM_DISCONNECT %s",stringTrace));

                if( call_data.win_calling )
                {
                    TRACE_EVENT("Dialog Destroy No 2");
                    SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                    call_data.win_calling = 0;
                    callFailureCause(dc->cause);//zy move to here01/21/2003 avoid 
                }
                /*2003/12/16, wangyan add*//*
                if (call_data.win_active)
                {
                    SEND_EVENT(call_data.win_active,DIALOG_DESTROY,0,0);
                    call_data.win_active = 0;
                }*/
                /*2003/12/16, wangyan add*/
                call_data.outCall = 0;
                //callFailureCause(dc->cause);//before zy move 01/21/2003 when one call is actived an incomingcall failure will show this information
                /*2003/12/16, wangyan add*/
                /*if (!call_data.calls.numCalls)
                    if (call_data.win)
                    {
                        call_destroy(call_data.win);
                        return 1;
                    }/*
                /*2003/12/16, wangyan add*/
            }
        }
        if( call_data.callsToEnd )
        {
            call_data.callsToEnd=call_data.callsToEnd-1;
            cm_disconnect(call_data.calls.status[0].call_number);
        }
        //GW-SPR#1035 - Added SAT changed
        /*NM, 110702
         in case that the SAT initiate the setup call (open a new editor);
         so we want to make sure that the editor disappear after disconnect
        */
        sat_release_the_editor ();
        /*NM, 110702 END*/

        break;
    case E_CM_CONNECT_ACK:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_CONNECT_ACK"));
        cid = (SHORT*)para;
        /*    TRACE_EVENT_P5("CId %d . outCall %d . win_calling %d . incCall %d win_incoming %d",
                           *cid,call_data.outCall,call_data.win_calling,call_data.incCall,
                           call_data.win_incoming);*/

        if( call_data.mintalert==0&&FFS_flashData.call_minute_flag )
        {
            call_data.mintalert=1;
        }

        /* 2004/04/16 sunsj modify */
        LedLightnessAdjust( 200 );
        timStart(gtVibator);

        if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].connecttone )
        { //xsf add 10/18 
            //StartSpecialTone(1); //xsf add for connect_ack tone //wms changed the function 02/12/29
            StartPlayByReason(CONNECTTONE,0);
        }
        //StartPlayByReason(INCALL, 0);//xsf 2003-04-07 make it in incall if add may makeconnecttone  notplay
        if( LocalRing )
        {
            LocalRing = FALSE;
        }

        if( (*cid==call_data.incCall)&&(call_data.win_incoming) )
        {
            SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
            call_data.win_incoming = 0;

            stopIncallLed();/*zy add 01-23-2003 for led incomingcall stop*/

        }

        if( (*cid==call_data.outCall)&&(call_data.win_calling) )
        {
            SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
            call_data.win_calling = 0;
        }
        //Quick check to see if we're duplicating call table
        for( i =0; i++; i<MAX_CALL_NR )
        {
            if( *cid == call_data.calls.status[i].call_number )
            {
                return 1;//zy 2003-04-16 turn from"return" to "return 1;"
            }
        }


        call_data.outCall = 0;
        call_data.incCall = 0;
        callConnect(*cid);
        //    mmeSetVolume (1, FFS_flashData.output_volume);//zy 09/18 its needn't
        /*begin of zy change 12/11*/
        SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);//wms added 01-21
        if( call_data.isHandSetMode )
        {
            SetHandsetMode();
            call_data.handSetOldStatus=1;
        }
        else
        {
            //SetEarMode();
            call_data.handSetOldStatus=0;
        }
        /*end of zy change 12/11 for handsetmode*/
        //  SetSpk_UplinkSLT(6);//zy 11/05
        //SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);//wms added 01-21
        OpenMic();
        winShow(call_data.win);//zy add 2003-02-21 show connect win imediately
        //SetASpk_DownLinkPGA(SpeakerVols);
        if( extnum[0]!='\0' )
            StartAutoDtmf();
        TRACE_EVENT(extnum);
        break;
    case E_CM_CONNECT:

        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_CONNECT"));
        if( LocalRing )
        {
            LocalRing = FALSE;
        }

        if( (*cid==call_data.incCall)&&(call_data.win_incoming) )
        {
            SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
            call_data.win_incoming = 0;
            stopIncallLed();/* zy add 01-23-2003 for led incomingcall stop*/

        }
        if( (*cid==call_data.outCall)&&(call_data.win_calling) )
        {
            SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
            call_data.win_calling = 0;
        }
        call_data.outCall = 0;
        call_data.incCall = 0;
        callConnect(*cid);

        // mmeSetVolume (1, FFS_flashData.output_volume);//zy 09/18 its needn't
        break;
    case E_CM_WAP_CALL_CONNECTED:
        break;

    case E_CM_COMMAND:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_COMMAND"));

        comm = (T_MFW_CM_COMMAND*)para;
        /*2004/04/05,talcon delete*/
        //sprintf((char*)stringTrace,"comm.result = %d comm.command = %d",comm->result,comm->command);
        if( comm->command!=CM_RETRIEVE )
        {
            Iscallnumber1=0;
        }//zy 2003-02-24 active indeed hold
        if( comm->result == Present )
        {
            /*2004/04/05,talcon delete*/
            //sprintf((char*)stringTrace,"okcomm.result = %d comm.command = %d",comm->result,comm->command);
            //TRACE_EVENT((char*)stringTrace);
            switch( comm->command )
            {
            
            case CM_RETRIEVE:
                TRACE_EVENT("call CM_RETRIEVED received");
                /*begin of zy change 2003-02-24 if callnumber(1) successed Iscallnumber1 reset*/
                if( Iscallnumber1 )
                    Iscallnumber1=0;
                /*end of zy change 2003-02-24 if callnumber(1) successed Iscallnumber1 reset*/
                break;
            case CM_HOLD:
                TRACE_EVENT("call CM_HOLD received");
                break;
            case CM_BUILD_MULTIPARTY:
                TRACE_EVENT("call CM_BUILDMULTIPARTY received");
                call_data.calls.mode = CallConference;
                break;
            case CM_SPLIT_MULTIPARTY:
                TRACE_EVENT("call CM_SPLIT_MULTIPARTY received");
                call_data.singleCall = comm->call_number;
                //            call_data.calls.mode = CallPrivateCall;
                call_data.calls.mode = CallSingleMultiparty;//zy 2003-03-12 private mode is needn't,if split multiparty mode is callsinglemultiparty
                break;
            case CM_HOLD_MULTIPARTY:
                TRACE_EVENT("call CM_HOLD_MULTIPARTY received");
                call_data.calls.mode = CallConference;
                break;
            case CM_RETRIEVE_MULTIPARTY:
                TRACE_EVENT("call CM_RETRIEVE_MULTIPARTY received");
                call_data.calls.mode = CallConference;
                break;
            case CM_SWAP:
                TRACE_EVENT("call CM_SWAP received");
                break;
            case CM_SWAP_MULTIPARTY:
                TRACE_EVENT("call CM_SWAP MULTIPARTYreceived");
                if( call_data.calls.mode == CallSingleMultiparty )
                    call_data.calls.mode = CallMultipartySingle;
                else
                    call_data.calls.mode = CallSingleMultiparty;
                break;
            case CM_ETC:
                TRACE_EVENT("call CM_ETC received");
                i=0;
                while( i<call_data.calls.numCalls )
                {
                    if( call_data.calls.status[i].call_number!=singleCall )
                    {
                        if( !removeCall(call_data.calls.status[i].call_number) )
                            i++;
                    }
                    else
                        i++;
                }
                break;
            case CM_DTMF_AUTO:
                break;
            default:
                break;
            }
            rebuildCalls();

            if( call_data.win_waiting )
            {
                SEND_EVENT(call_data.win_waiting,DIALOG_DESTROY,0,0);
                call_data.win_waiting = 0;
                TRACE_EVENT("destroy call win h");
            }
            if( call_data.win_calling )
            {
                SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                call_data.win_calling = 0;
                //         TRACE_EVENT("destroy call win i");
            }
            /*2003/12/16, wangyan modify*//*
            if (call_data.win_active)
            {
                SEND_EVENT(call_data.win_active,DIALOG_DESTROY,0,0);
                call_data.win_active = 0;
            }*/
            /*2003/12/16, wangyan modify*/

        }
        if( call_data.accessEnd )
        {
            callSetMode(ViewConnect);
        }

        /* indicates if a command has failed e.g. ECT MC 12/04/02*/
        if( comm->result == NotPresent )
        {
            if( call_data.win_waiting )
            { /*If we're waiting for current command*/
                /*Get rid of waiting window*/
                SEND_EVENT(call_data.win_waiting,DIALOG_DESTROY,0,0);
                call_data.win_waiting = 0;
                //       TRACE_FUNCTION("destroy call win h");
            }
            if( call_data.win_calling&&comm->command==CM_HOLD )
            {
                //       TRACE_EVENT("zy:1861 new call");
                cm_disconnect(call_data.outCall);
                //       call_destroy(call_data.win_calling);
                //      TRACE_EVENT("E_CM_CW:call_destroy(callingwin)");
                /*begin of zy change 2003-02-26 don't call call_destroy()
                 only destroy calling_win
               */
                SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                call_data.win_calling = 0;
                call_data.ignore_disconnect = TRUE;
                /*end of zy change 2003-02-26 don't call call_destroy()
                  only destroy calling_win
                */
            }
            /*zy 2003-02-21 if onecall exit and add new call failed the now call shouls display hold*/
            if( Iscallnumber1&&comm->command==CM_RETRIEVE )
            {
                call_data.calls.status[callIndex(call_data.calls.selected)].stat =CALL_HELD;
                Iscallnumber1=0;
            }

            /*end of zy 2003-02-21 if onecall exit and add new call failed the now call shouls display hold*/

            //	bookShowInformation(call_data.win, TxtFailed,'\0',  (T_VOID_FUNC)call_failure_cb);//zy change 11/13 "call_failure_cb" old is null
            winShow(call_data.win);


        }
        break;
    case E_CM_DTMF:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_DTMF"));
        if( call_data.sendingDTMF )
        {
            call_data.charSent++;
            sendDTMFString();
        }

        break;
    case E_CM_REDIAL:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_REDIAL"));

        pRedial = (T_MFW_CM_REDIAL*)para;
        if( pRedial == NULL )
        {
        }
        switch( pRedial->redial_mode )
        {
        
        case CM_REDIAL_BLACKLIST:
            TRACE_EVENT("CM_REDIAL_BLACKLIST");
            TRACE_EVENT("the blacklist is now full");
            /*
               GSM 2.07
               when the blacklist is full the MT 
               shall prohibit further automatic call 
               attempts to any one number until 
               the blacklist is manually cleared at the MT
   
               The blacklist is cleared after switch off/on ?!
            */
            break;
        case CM_REDIAL_NO_SERVICE:
            TRACE_EVENT("CM_REDIAL_NO_SERVICE");
            break;
        case CM_REDIAL_OUTGOING:
            TRACE_EVENT("CM_REDIAL_OUTGOING");
        case CM_REDIAL_INCOMING:
            TRACE_EVENT("CM_REDIAL_INCOMING");
        case CM_REDIAL_ABORTED:
            TRACE_EVENT("CM_REDIAL_ABORTED");
        case CM_REDIAL_BLACKLISTED :
            TRACE_EVENT("CM_REDIAL_BLACKLISTED");

            if( call_data.win_redial )
            {
                SEND_EVENT(call_data.win_redial,DIALOG_DESTROY,0,0);
                call_data.win_redial = 0;
                TRACE_EVENT("destroy redial win ");
            }

            break;
        case CM_REDIAL_SUCCESS:
            TRACE_EVENT("CM_REDIAL_SUCCESS");

            if( call_data.win_redial )
            {
                SEND_EVENT(call_data.win_redial,DIALOG_DESTROY,0,0);
                call_data.win_redial = 0;
                TRACE_EVENT("destroy redial win ");
            }
            rebuildCalls();
            break;

        case CM_REDIAL_STARTED:
            TRACE_EVENT("CM_REDIAL_STARTED");
            /*  */




            if( call_data.win_calling )
            {
                SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                call_data.win_calling = 0;
                TRACE_EVENT("destroy call call_win");
            }
            /*2003/12/16, wangyan modify*//*
            if (call_data.win_active)
            {
                SEND_EVENT(call_data.win_active,DIALOG_DESTROY,0,0);
                call_data.win_active = 0;

            }*/
            /*2003/12/16, wangyan modify*/
            if( pRedial->left_attempts EQ 0 )
            {      // Not yet started redial attempts
                /* start the 1st repeat attempt */
                MMI_TRACE_EVENT(("wangyan redial"));
                cm_autoredial_start();
            }
            callSetMode(ViewAutoRedial);

            break;

        case CM_REDIAL_STOP:

            TRACE_EVENT("E_CM_REDIAL_STOP");

            if( call_data.win_redial )
            {
                SEND_EVENT(call_data.win_redial,DIALOG_DESTROY,0,0);
                call_data.win_redial = 0;
            }
            rebuildCalls();
            break;
        case CM_REDIAL_ATTEMPT:
            TRACE_EVENT("E_CM_REDIAL ATTEMPT");

            break;
        default:
            break;
        }

        break;
    case E_CM_MO_RES:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_MO_RES"));
        {
            T_MFW_PHB_ENTRY phb_entry;
            T_MFW_CM_STATUS outgoing_call_data;
            T_MFW_CM_AOC_INFO   aoc_info;
            char * v_Number = NULL;
            CALLRINGOFF=0;
            memset(&outgoing_call_data, 0, sizeof(T_MFW_CM_STATUS));
            cid = (SHORT*)para;

            // this is used for the "last charge"
            cm_get_aoc_value(CM_AOC_ACM, &aoc_info);

            acm_last_call = aoc_info.acm;


            TRACE_EVENT ("E_CM_MO_RES");
            /*2004/04/05,talcon delete*/
            //sprintf(stringTrace,"Call Id %d",*cid);
            //TRACE_EVENT(stringTrace);

            /* If we have no active call window, create one */
            if( !call_data.win )
            {
                call_create(0);
            }
            MMI_TRACE_EVENT(("wangyan: callCmEvent --call_data.win=%d",call_data.win));
            if( call_data.calls.numCalls == 0 )
                SEND_EVENT(call_data.win,CALL_INIT,0,0);

            /* set the outcall ID */
            // rsa done previously (in SAT) or done later (see below):

            call_data.outCall = *cid;
            call_data.call_direction = OUTGOING;


            /* end any locally generated tones, this is for late assignment
             * and should be managed within ACI
             */
            if( LocalRing )
            {
            }

            if( call_SATCall == TRUE )
            {
                TRACE_EVENT ("SAT_CALL_DIALOG");

                //zy 2003-04-16 checkin Marcus: Issue 1057: 21/01/2003: Removed: call_SATCall = FALSE;
                /* create the outgoing call dialog */
                getCallStatus(*cid, &outgoing_call_data);
                /*zy 2003-04-16 display from "cid",not from satstructure
                set local pointer to number from call table */
                v_Number = (char*)(outgoing_call_data.number);
                memcpy(call_data.phbNameNumber,v_Number, sizeof(call_data.phbNameNumber)-1);
                call_data.phbNameNumber[sizeof(call_data.phbNameNumber)-1] = 0;
                call_calling_show(MMI_OUTGOING_CALL_DIALOG_SAT);
                /*end of zy 2003-04-16*/
            }
            else
            {
                TRACE_EVENT ("NORMAL_CALL_DIALOG");

                /* set the outcall ID */
                call_data.outCall = *cid;
                call_data.call_direction = OUTGOING;
                /* fill the call status information from the
    call table in MFW/ACI */
                getCallStatus(*cid, &outgoing_call_data);
                /* set local pointer to number from call
    table */
                v_Number = (char*)(outgoing_call_data.number);
                /* Check whether the dialled number appears in the phonebook and set the
                 * status information if it does
                 */
                /*
                 zy 2003-02-14 before findname add "+" if it is international number 
                 */
                if( (outgoing_call_data.ton == MFW_TON_INTERNATIONAL) && (outgoing_call_data.number[0] != '+') )
                {
                    TRACE_EVENT("International Call Required!");
                    // API - 826 - Create a buffer and a plus to the start of the buffer then add the out going number
                    strcpy(InterNat_Plus, "+");
                    strcat(InterNat_Plus, (char *)v_Number);

                    memcpy(call_data.phbNameNumber, (char*)InterNat_Plus, sizeof(call_data.phbNameNumber)-1);
                    call_data.phbNameNumber[sizeof(call_data.phbNameNumber)-1] = 0;
                    // This is an international number so a '+' must be added to this number.
                    // It must be Pre-pended to the number and should come after the ss string
                    // if there is one present:
                    // e.g. **21*+44121675489#
                    //JVJE                 phbk_add_plus_to_number((char*)call_data.phbNameNumber);
                    wstrcpy( (char *)v_Number,call_data.phbNameNumber);
                }
                /*
                end of zy 2003-02-14 before findname add "+" if it is international number
                */
                wstrcpy( latestOutNum,(char *)v_Number);

                // saveNumCallRecord('D',latestOutNum );  //hu binhao 2002-11-26
                // saveNumCallRecord('D',latestOutNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29

                if( cm_check_emergency((UBYTE*)v_Number) == TRUE )
                {
                    call_data.emergencyCall = TRUE;
                    memset(call_data.phbNameNumber,'\0',sizeof(call_data.phbNameNumber));
                    searchPhdata.GroupIndex=0xff;
                    searchPhdata.GroupingIcon=0xff;
                    searchPhdata.GroupingRing=0xff;
                    IsIngroup=0;
                    SimReadyFlag=0;
                    /*begin of zy change 2003-01-29 when emergency call need setearmode here */
                    SetEarMode();
                    SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);//wms added 01-21
                    /*end of zy change 2003-01-29*/
                }

                /* else if ( (bookFindNameInSDNPhonebook(v_Number, &phb_entry) == 1) && (phb_entry.name.len != 0) )
                 {
                     memcpy(call_data.phbNameNumber, (char*)phb_entry.name.data, sizeof(call_data.phbNameNumber)-1);
                     call_data.phbNameNumber[sizeof(call_data.phbNameNumber)-1] = 0;
                 }
                 else if(bookFindNameInPhonebook(v_Number, &phb_entry) == 1 && (phb_entry.name.len != 0) )
                 {
                    memcpy(call_data.phbNameNumber, (char*)phb_entry.name.data, sizeof(call_data.phbNameNumber)-1);
                    call_data.phbNameNumber[sizeof(call_data.phbNameNumber)-1] = 0;
                  }*/
                //else if (FindNumber((char *)v_Number, (T_FindName *)&searchPhdata))//zy 09/19 test search phb 
                else if( IsIngroup=FindCallNumber((char *)v_Number, (T_FindName *)&searchPhdata) )
                {//zy 09/19 test search phb 2002-12-29

                    wstrcpy((char *)call_data.phbNameNumber,(char *)searchPhdata.name);
		    if (sizeof(searchPhdata.name) > (CALL_NAME_LENGTH+2))
		    {
		        call_data.phbNameNumber[CALL_NAME_LENGTH+1] = '\0';//zy change 2003-04-07 make it same as phb 24
		        call_data.phbNameNumber[CALL_NAME_LENGTH+2] = '\0';
		    }
                }
                else
                {
                    memcpy(call_data.phbNameNumber,v_Number, sizeof(call_data.phbNameNumber)-1);
                    call_data.phbNameNumber[sizeof(call_data.phbNameNumber)-1] = 0;

                }
                /*begin of zy change 2003-0428 make "p" number save in dialed number correct*/
                if( wstrlen(extnum) )
                {
                    strcat(latestOutNum,"p");
                    strcat(latestOutNum,extnum);
                }
                /*end of zy change 2003-04-28*/
                saveNumCallRecord('D',latestOutNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2003-1-7

                call_data.phbNameNumber[sizeof(call_data.phbNameNumber)-1] = 0;

                /* create the outgoing call dialog */
                call_calling_show(MMI_OUTGOING_CALL_DIALOG_NORMAL);
            }
        }

        break;
    case E_CM_TIMER_EVERY_SECOND:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_TIMER_EVERY_SECOND"));
#if 0
        if( call_data.win_incoming )
        {
            if( animnum<4 )
            {
                dspl_BitBlt( callIncoming_Attr [animnum].area.px,callIncoming_Attr [animnum].area.py,
                             callIncoming_Attr [animnum].area.sx,callIncoming_Attr [animnum].area.sy,
                             callIncoming_Attr [animnum].nIcons,callIncoming_Attr [animnum].icons,0);
                animnum++;

            }
            else
                animnum=0;
        }
        if( call_data.win_calling&&CALLRINGOFF==1 )
        {
            if( animnum<4 )
            {
                dspl_BitBlt( callAlert_Attr [animnum].area.px,callAlert_Attr [animnum].area.py,
                             callAlert_Attr [animnum].area.sx,callAlert_Attr [animnum].area.sy,
                             callAlert_Attr [animnum].nIcons,callAlert_Attr [animnum].icons,0);
                animnum++;

            }
            else
                animnum=0;
        }
        if( call_data.win_calling&&CALLRINGOFF==2 )
        {
            if( animnum<4 )
            {
                dspl_BitBlt( call_Attr [animnum].area.px,call_Attr [animnum].area.py,
                             call_Attr [animnum].area.sx,call_Attr [animnum].area.sy,
                             call_Attr [animnum].nIcons,call_Attr [animnum].icons,0);
                animnum++;

            }
            else
                animnum=0;
        }
#endif
        QueryPcsyncHandsetStatus();    ////zym added for querying handset 030313
        refreshCallTimer();
        cm_get_aoc_value(CM_AOC_CCM,&call_data.aocInfo);

#if 0   //2004-03-8 Sunny removed
        // TRACE_EVENT_P1("winIsFocussed(call_data.win) %d",winIsFocussed(call_data.win));
        // if ((call_data.calls.mode == CallSingle))//&&(winIsFocussed(call_data.win)))
        if( (call_data.calls.mode == CallSingle)&&(winIsFocussed(call_data.win)||winIsFocussed(call_data.win_scratch)) )
        /*2003/12/16, wangyan modify*/
        //if ((call_data.calls.mode == CallSingle)&&(winIsFocussed(call_data.win)||winIsFocussed(call_data.win_scratch)||winIsFocussed(call_data.win_active)))
        /* 2003-03-13 when there is single call and focused at callwin or scratch win display time */
        {
            // winShow(call_data.win);zy remove needn't show all screen

            memset(line,'\0',sizeof(line));
            getTimeString(call_data.calls.time[0],(char*)line);
            //         dspl_TextOut((120-64)/2, Mmi_layout_third_line(), 0, (char *)line);/*2003/12/9, wangyan modify*/
            old_color=dspl_GetBkgColor();
            //		dspl_GetBkgColor(0x5AC7FF);
            dspl_TextOut(52, 2, 0, (char *)line);
            //			dspl_TextOut(1, STANDARD_CALL_TXT_VERTICAL-Mmi_layout_second_line(), 0, (char *)line);
            dspl_SetBkgColor(old_color);

            if( call_data.calls.time[0]<3 )
            {
                //if (melody_status==MELODY_BUSY)//wms added to avoid play melody when call begin 03-=04-07
                //	StopMelody2(oldringstr);
                StopPlayingMelody2( ); //glowing: use the yamaha api
                SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);
            }
        }//zy add only show time 2003-02-14
        else if( /*(call_data.calls.mode == CallSingle)&&(*/winIsFocussed(call_data.win_scratch) )
        {/*begin of zy change 2003-03-12
is dial a new call need show time
*/
            T_MFW_WIN      * win_data = ((T_MFW_HDR *) call_data.win_scratch)->data;
            T_call_scratchpad         * data = (T_call_scratchpad *)win_data->user;
            if( data->mode==ViewMulticallControl )
            {
                memset(line,'\0',sizeof(line));
                getTimeString(call_data.calls.time[0],(char*)line);
                if( /*FFS_flashData.*/InCallTimer == TRUE )
                    dspl_TextOut((SCREEN_SIZE_X-get_StringWidth(line)), 2, 0, (char *)line);//2004-03-8 Sunny Modify
                /*end of zy change 2003-03-12*/
            }
        }/*end of zy add for scratch win has time update*/

        else //2004-03-8 Sunny add for displaying the time.
        {
            memset(line,'\0',sizeof(line));
            getTimeString(call_data.calls.time[0],(char*)line);
            if( InCallTimer == TRUE )
                dspl_TextOut((SCREEN_SIZE_X-get_StringWidth(line)), 2, 0, (char *)line);//2004-03-8 Sunny Modify
        }//2004-03-8 Sunny add for displaying the time.end
#endif

        //2004-03-08 Sunny add for displaying the time.
        if( (call_data.calls.mode == CallSingle)&&(winIsFocussed(call_data.win)||winIsFocussed(call_data.win_scratch)) )
        {

            memset(line,'\0',sizeof(line));
            getTimeString(call_data.calls.time[0],(char*)line);
            old_color=dspl_GetBkgColor();
            dspl_TextOut(SCREEN_SIZE_X-get_StringWidth(line), 2, 0, (char *)line);
            dspl_SetBkgColor(old_color);

            if( call_data.calls.time[0]<3 )
            {
                StopPlayingMelody2( ); //glowing: use the yamaha api
                SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);
            }
        }
        //2004-03-08 Sunny add for displaying the time.end

        /*
        In field test, need to connect trace line, the earphone check will disconnect the call, need more check
        */
        /*beging of zy add 01-23-2003 for led incomingcall*/
        if( !HallStatus()&&IncallLedisRun )
        {
            if( IncallLedControl==TRUE )
            {
                IncallLed(TRUE);
                IncallLedControl=FALSE;
            }
            else
            {
                IncallLed(FALSE);
                IncallLedControl=TRUE;
            }
        }
        if( HallStatus()&&IncallLedisRun )
        {
            stopIncallLed();/* zy add 01-23-2003 for led incomingcall stop*/
        }
        /*end of zy add 01-23-2003 for led incomingcall*/

        /*begin of zy for handset mode 12/11*/
        call_data.isHandSetMode=IsHandsetPlugin();
        //      zgzTraceDataFunc("EVERYSECOND isHandSetMode", (unsigned short) call_data.isHandSetMode);
        if( call_data.isHandSetMode==1 )
        {//zy 12/12 only value is 1,the handset is on
            TRACE_EVENT("handset is plugin");
            if( call_data.handSetOldStatus==0&&!call_data.win_incoming&&melody_status==MELODY_IDLE )
            {//zy 2003-03-03 if there is any sound playing we couldn't set handset mode
                SetHandsetMode();
                call_data.handSetOldStatus=1;
            }
            /* else
               call_data.handSetOldStatus=0;zy move here otherewise there will wrong status*/
#ifdef _M188_
            if( IsHandsetKey() )
#else
            if( IsHeadsetKey() )
#endif
            {
                //glowing,2004-04-12, fix the bug that can't disconnect emergency call
                if( call_data.emergencyCall == 1 )
                {
                    cm_disconnect(call_data.outCall);

                    if( !call_data.calls.numCalls )
                    {
                        call_data.ignore_disconnect = TRUE;
                        MMI_TRACE_EVENT(("wangyan, call_calling_cb else call_destroy"));
                        call_destroy(call_data.win);
                        return 1;
                    }
                }


                if( call_data.win_incoming&&call_data.handSetKeyDone==0 )
                {
                    //Stopplayingdevice(); //xsf changed 12.31
                    StartPlayByReason(INCALL, 0);
                    cm_mt_accept();
                    wstrcpy( latestReceivedNum,  latestInNum);
                    //saveNumCallRecord('R',latestReceivedNum );  //hu binhao 2002-11-26
                    saveNumCallRecord('R',latestReceivedNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29
                    call_data.handSetKeyDone=1;//zy avoid accept twice
                }
                else if( !call_data.win_incoming )
                {
                    if( !call_data.calls.numCalls )
                    {
                        cm_force_disconnect();
                        MMI_TRACE_EVENT(("wangyan, E_SECOND call_destroy"));
                        call_data.ignore_disconnect = TRUE;
                        call_destroy(call_data.win);
                        return 1;
                    }
                    /*zy 2003-03-03 if there is a outcall calling handsetkey disconnect it*/
                    if( call_data.win_calling )
                    {
                        cm_disconnect(call_data.outCall);
                        SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                        call_data.win_calling = 0;
                        if( Isfromcallwin==1&&call_data.calls.mode!=CallConference )
                        {//zy add 0303/2003 for one call add a new call failure need retrive call
                            //if condat solved this problem all these"Isfromcallwin"will be move immediately
                            Isfromcallwin=0;
                            callNumber((UBYTE *) "1");
                            Iscallnumber1=1;//zy add 2003-03-03 Iscallnumber1 is judge if callnumber(1);failed we call make display is hold
                        }
                        else if( Isfromcallwin==1&&call_data.calls.mode==CallConference )
                        /*begin of zy change 2003-03-14 if it's conferencecall mode needn't retrive
                          just display "hold"
                        */
                        {
                            TRACE_EVENT("conferset held and numCalls=");
                            TraceInt(call_data.calls.numCalls);
                            Isfromcallwin=0;    
                            for( i=0;i<call_data.calls.numCalls;i++ )
                            {
                                call_data.calls.status[i].stat = CALL_HELD;
                            }

                        }
                        return 1;
                    }
                    /*end of zy change 2003-03-03*/
                    switch( call_data.calls.mode )
                    {
                    case CallConference:
                    case CallMultipartySingle:
                    case CallSingleMultiparty:
                        cm_disconnect(0);
                        break;
                    default:
                        cm_disconnect(call_data.calls.selected);
                        if( call_data.calls.numCalls==1 )
                        {
                            call_data.ignore_disconnect = TRUE;
                            removeCall(call_data.calls.selected);
                        }
                        break;
                    }
                }
            }
        }
        else if( !call_data.win_incoming&&call_data.handSetOldStatus==1 )
        {
            call_data.handSetOldStatus=0;
            call_data.handSetKeyDone=0;
            SetEarMode();
            SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);//wms added 01-21
            OpenMic();
        }
        /*end of zy change 12/11*/
        //  if (call_data.call_direction == OUTGOING)//zy 09/18 
        // SetEarMode();
        //      zgzTraceDataFunc("mintalert=", (unsigned short) call_data.mintalert);
        if( call_data.mintalert>=1 )
        {
            call_data.mintalert++;
            if( call_data.mintalert==50 )
            {
                StartToneByID(TONE_MINALERT);
                //            TRACE_EVENT("zy:minalert being called");
            }
            if( call_data.mintalert>=61 )
            {
                call_data.mintalert=1;
            }
        }
        break;
    case E_CM_CPI:
        MMI_TRACE_EVENT(("wangyan: callCmEvent -- E_CM_CPI"));
        cmCpi = (T_MFW_CM_CPI*)para;

        fixTone(cmCpi->type, cmCpi->inband);

#ifndef _INNOVATION_EMULATOR_		
        if( cmCpi->type == CPI_MSG_Alert && cmCpi->tch )
        {
            ccShrdPrm.ctb[cmCpi->call_number-1].inBndTns = 1;
        }
#endif

        if( cmCpi->type == CPI_MSG_Alert )
        { //&& (!cmCpi->inband))
            /*begin of zy change 2003-04-16 if alert show callringoff but different from normal and sat */  
            USHORT Identifier;
            if( call_data.win_calling )
            {
                Identifier=GetDiaolgIden(call_data.win_calling);
                SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                call_data.win_calling = 0;
                if( Identifier==MMI_OUTGOING_CALL_DIALOG_NORMAL )
                    call_calling_show(MMI_OUTGOING_CALL_DIALOG_RINGOFF);
                else if( Identifier==MMI_OUTGOING_CALL_DIALOG_SAT )
                    call_calling_show(MMI_OUTGOING_CALL_SAT_RINGOFF);
            }
            /*end of zy change 2003-04-16*/
#if 0 
            if( !cmCpi->inband )
            {
                /* Testcase 26.8.x - generated internal alert */
                audio_PlaySoundID(AUDIO_BUZZER, TONES_CW, 0, AUDIO_PLAY_INFINITE);
                LocalRing = TRUE;
            }
            else if( LocalRing )
            {
                audio_StopSoundbyID(AUDIO_BUZZER,TONES_CW);
                LocalRing = FALSE;
            }
#endif
        }
        else if( (cmCpi->type == CPI_MSG_Disc) && (!cmCpi->inband) )
        {
            //audio_SetMute(AUDIO_SPEAKER, AUDIO_MUTING_ON);zy move we don't use this system function to control audio
            /*zy 2003-02-21 if onecall exit and add new call failed the now call should display hold
                 zy 2003-04-07 only 2 will still have old call connected
           */
            if( cmCpi->call_number==2 )
            {
                //TRACE_EVENT("zy:cpi disconect currTryAccept=");
                //TraceInt(currTryAccept);
                if( currTryAccept==1 )
                {
                    call_data.calls.status[callIndex(call_data.calls.selected)].stat =CALL_HELD;
                    /* cm_command(call_data.calls.selected, CM_RETRIEVE, '\0');
                     call_data.current_command = CM_RETRIEVE;*/
                    currTryAccept=0;
                    winShow(call_data.win);
                }
            }
            else if( cmCpi->call_number==1 )
            {/*zy 2003-04-07 only this case has disconnect all calls now */
                //TRACE_EVENT("zy:cpi disconect only one num=");    
                if( call_data.calls.numCalls==1 )
                {
                    //TRACE_EVENT("zy:call_data.calls.numCalls=1");
                    // RELEASEAllCALL();
                }
            }

            /*end of zy 2003-02-21 if onecall exit and add new call failed the now call shouls display hold*/
        }
        break;

    default:
        return 0;
    }
    return 1;
}



/*******************************************************************************

 $Function:     callWaitingAnswerKeyEvent

 $Description:

 $Returns:    1, processed, 0 ignored

 $Arguments:  event and parameter

*******************************************************************************/

static int callWaitingAnswerKeyEvent (MfwEvt e, MfwKbd *k)
{
    MMI_TRACE_EVENT(("callWaitingAnswerKeyEvent"));
    switch( k->code )
    {
    
    case KCD_LEFT:
        cm_command_abort(call_data.current_command);
        break;
    default:
        break;
    }
    return 1;
}





/*******************************************************************************

 $Function:     showDefault

 $Description:  common display content

 $Returns:

 $Arguments:

*******************************************************************************/


#if 0 /*2003/11/20, wangyan, del useless function */
static void showDefault (void)
{
    dspl_ClearAll();
    GlobalIconStatus = GlobalSignalIconFlag //hxl delete the battery icon 0905
                       | GlobalVoiceMailIconFlag
                       | GlobalCallForwardingIconFlag| GlobalKeyplockIconFlag
                       | GlobalRingerIconFlag | GlobalRingVibrIconFlag
                       | GlobalVibratorIconFlag | GlobalAlarmIconFlag
                       | GlobalSilentRingerIconFlag |GlobalCipheringActivIconFlag
                       | GlobalCipheringDeactivIconFlag
                       /* SH 18/01/02. Flag for GPRS On icon.
                          Note: Homezone icon not displayed during call. */
#ifdef MMI_GPRS_ENABLED
                       | GlobalGPRSOnIconFlag
#endif
                       /* ...sbh */
                       ;
    iconsShow();
}

#endif






/*******************************************************************************

 $Function:     showSelectPrivateCall

 $Description:  multiparty private call handling

 $Returns:

 $Arguments:

*******************************************************************************/
// define position we will display number/name of caller
//#define CALLID_NUM_XPOS (8)/*2003/12/15, wangyan delete*/
// define number of chars that can be displayed (at this position)
#define STR_DISPLAY_NCHAR (12)//zy change 09/27 for num
//#define CALL_SEVERIALS_XPOS (32)/*2003/12/15, wangyan delete*/
#if 0
void showSelectPrivateCall(void){


    int i = 0;
    char line[MAX_LINE];
    char tag[MAX_CHAR];
    int topLine;

    TRACE_FUNCTION("showSelectPrivateCall");
    dspl_ClearAll();//zy 09/05
    //showDefault();
    memset(tag,'\0',sizeof(tag));
    if( call_data.calls.numCalls<MAX_CALLS )
        topLine = Mmi_layout_second_line();
    else
        topLine = Mmi_layout_first_line();
    for( i=0;i<call_data.calls.numCalls;i++ )
    {
        memset(line,'\0',sizeof(line));
        memset(tag,'\0',sizeof(tag));
        sprintf(line,"%d",i+1);
        if( call_data.calls.status[i].stat == CALL_ACTIVE )
            /*      sprintf(&line[1],"%s",".A.");
              else
                 sprintf(&line[1],"%s",".H.");*/
            sprintf(&line[1],"%s:",MmiRsrcGetText(TxtActive));
        else
            sprintf(&line[1],"%s:",MmiRsrcGetText(TxtHold));

        if( i==callIndex(call_data.calls.selected) )
            dspl_TextOut(8, (USHORT)(topLine+LINE_HEIGHT*i), DSPL_TXTATTR_INVERS, (char*)line);
        else
            dspl_TextOut(8, (USHORT)(topLine+LINE_HEIGHT*i), 0, (char*)line);

#ifdef NO_ASCIIZ
        if( call_data.calls.status[i].name.len > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_CHAR-2,POS_END,".");

#else
        if( strlen((char*)call_data.calls.status[i].name) > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].name,MAX_CHAR-2,POS_END,".");
#endif
        else
            if( strlen((char*)call_data.calls.status[i].number) > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].number,MAX_CHAR-2,POS_BEGIN,".");
        else
            truncateString((char*)tag,GET_TEXT(TxtSoftCall),MAX_CHAR-2,POS_END,".");
        if( i==callIndex(call_data.calls.selected) )
            dspl_TextOut(CALLID_NUM_XPOS,(USHORT)(topLine+LINE_HEIGHT*i), DSPL_TXTATTR_INVERS, (char *)tag);
        else
            dspl_TextOut(CALLID_NUM_XPOS,(USHORT)(topLine+LINE_HEIGHT*i), 0, (char *)tag);
    }
    displaySoftKeys(TxtSoftSelect,TxtEnd);
}
#endif
#if 0
void showSelectPrivateCall(void){
    int i = 0;
    char line[MAX_LINE];
    char tag[MAX_CHAR];
    int topLine;
    int startpos;

    dspl_ClearAll();


    topLine = Mmi_layout_first_line();
    for( i=0;i<call_data.calls.numCalls;i++ )
    {
        memset(line,'\0',sizeof(line));
        memset(tag,'\0',sizeof(tag));
        sprintf(line,"%d",i+1);
        line[1]='.';line[2]=' ';
        if( i==callIndex(call_data.calls.selected) )
        {
            dspl_TextOut(8, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_INVERS, (char*)line);
            if( call_data.calls.status[i].stat == CALL_ACTIVE )
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_INVERS, MmiRsrcGetText(TxtActive));
            else
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_INVERS, MmiRsrcGetText(TxtHold));
        }
        else
        {
            dspl_TextOut(8, (USHORT)(topLine+LINE_HEIGHT*2*i), 0, (char*)line);
            if( call_data.calls.status[i].stat == CALL_ACTIVE )
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), 0, MmiRsrcGetText(TxtActive));
            else
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), 0, MmiRsrcGetText(TxtHold));
        }

#ifdef NO_ASCIIZ
        if( call_data.calls.status[i].name.len > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_CHAR-2,POS_END,".");
#else
        if( strlen((char*)call_data.calls.status[i].name) > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].name,MAX_CHAR-2,POS_END,".");
#endif
        else
            if( strlen((char*)call_data.calls.status[i].number) > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].number,MAX_CHAR-2,POS_BEGIN,".");
        else
            truncateString((char*)tag,GET_TEXT(TxtSoftCall),MAX_CHAR-2,POS_END,".");
        startpos=(120 - get_StringWidth(tag)) / 2;
        if( i==callIndex(call_data.calls.selected) )
            dspl_TextOut(startpos,(USHORT)(topLine+LINE_HEIGHT*(2*i+1)), DSPL_TXTATTR_INVERS, (char *)tag);
        else
            dspl_TextOut(startpos,(USHORT)(topLine+LINE_HEIGHT*(2*i+1)), 0, (char *)tag);
    }
    displaySoftKeys(TxtSoftSelect,TxtEnd);
    dspl_Enable(mode);
}
#endif
void showSelectPrivateCall(void){
    int i = 0;
    char line[MAX_LINE];
    char tag[MAX_CHAR];
    int topLine;
    int startpos;

    UBYTE mode;
    draw_special_background();

    topLine = Mmi_layout_first_line();
    for( i=0;i<call_data.calls.numCalls;i++ )
    {
        memset(line,'\0',sizeof(line));
        memset(tag,'\0',sizeof(tag));
        sprintf(line,"%d",i+1);
        line[1]='.';line[2]=' ';
        if( i==callIndex(call_data.calls.selected) )
        {
            dspl_TextOut(8, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_INVERS, (char*)line);
            if( call_data.calls.status[i].stat == CALL_ACTIVE )
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_INVERS, MmiRsrcGetText(TxtActive));
            else
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_INVERS, MmiRsrcGetText(TxtHold));
        }
        else
        {
            dspl_TextOut(8, (USHORT)(topLine+LINE_HEIGHT*2*i), 0, (char*)line);
            if( call_data.calls.status[i].stat == CALL_ACTIVE )
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtActive));
            else
                dspl_TextOut(32, (USHORT)(topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_TRANSPARENT, MmiRsrcGetText(TxtHold));
        }

#ifdef NO_ASCIIZ
        if( call_data.calls.status[i].name.len > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_CHAR-2,POS_END,".");
#else
        if( strlen((char*)call_data.calls.status[i].name) > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].name,MAX_CHAR-2,POS_END,".");
#endif
        else
            if( strlen((char*)call_data.calls.status[i].number) > 0 )
            truncateString((char*)tag,(char*)call_data.calls.status[i].number,MAX_CHAR-2,POS_BEGIN,".");
        else
            truncateString((char*)tag,GET_TEXT(TxtSoftCall),MAX_CHAR-2,POS_END,".");
        startpos=(SCREEN_SIZE_X - get_StringWidth(tag)) / 2;
        if( i==callIndex(call_data.calls.selected) )
            dspl_TextOut(startpos,(USHORT)(topLine+LINE_HEIGHT*(2*i+1)), DSPL_TXTATTR_INVERS, (char *)tag);
        else
            dspl_TextOut(startpos,(USHORT)(topLine+LINE_HEIGHT*(2*i+1)), DSPL_TXTATTR_TRANSPARENT, (char *)tag);
    }
    displaySoftKeys(TxtSoftSelect,TxtEnd);
    dspl_Enable(mode);
}

#if 0 /*2003/11/19, wangyan, del useless function*/
/*******************************************************************************
 $Function:     showWaitingAnswer

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/


void showWaitingAnswer(void){


    TRACE_FUNCTION("showWaitingAnswer");
    //   showDefault();//zy 09/05
    dspl_ClearAll();
    PROMPT(20, Mmi_layout_second_line(), 0, TxtPleaseWait);
    displaySoftKeys(TxtCancel,'\0');
}



/*******************************************************************************

 $Function:     showSendingDTMF

 $Description:  displays sending DTMF

 $Returns:

 $Arguments:

*******************************************************************************/


void showSendingDTMF(void){


    TRACE_FUNCTION("showSendingDTMF");
    //    showDefault();//zy 09/05
    dspl_ClearAll();
    PROMPT(20, Mmi_layout_second_line(), 0, TxtSendingDTMF);
    displaySoftKeys(TxtCancel,'\0');
}





/*******************************************************************************

 $Function:     showInformation

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/


void showInformation(void){


    TRACE_FUNCTION("showInformation");
    //    showDefault();//zy 09/05
    dspl_ClearAll();
    dspl_TextOut(24, 16, 0, callInformation);
}
#endif
/*******************************************************************************

 $Function:     WaitWhile

 $Description:   Just show please wait 

 $Returns:

 $Arguments:

*******************************************************************************/
static void WaitWhile ()
{
    T_DISPLAY_DATA   display_info;
    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    = KEY_RIGHT|KEY_HUP;
    display_info.TextId       = TxtPleaseWait;
    display_info.TextId2      = 0;
    display_info.TextString   = '\0';
    // display_info.TextString2   = (char*)line;zy move 11/15 needn't display time
    display_info.TextString2   = '\0';
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtBack;
    display_info.Time         = ONE_SECS; // 1s delay
    display_info.Callback     =NULL;
    display_info.iconindex    =REMIND_WAITTING;
    display_info.Identifier    =0;
    call_data.win_waiting = info_dialog (call_data.win, &display_info);
}
/*******************************************************************************

 $Function:     callSetMode

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static void callSetMode (int mode){
    T_DISPLAY_DATA   display_info;
    /*	game_Rectangle param;
        param.x1=0;
        param.y1=0;
        param.x2=SCREEN_SIZE_X;
        param.y2=SCREEN_SIZE_Y;
        param.fillcolor=0x5AC7FF;
        param.color=0x5AC7FF;*//*2003/12/15, wangyan modify*/
    switch( mode )
    {
    case ViewConnect:
        Isfromcallwin=0;//zy add 0107/2003
        if( call_data.calls.numCalls )
        {
            call_data.refreshConnect = 1;
            call_data.calls.view =  ViewConnect;

        }
        else
        {
            if( (!call_data.win_incoming)&&(!call_data.win_calling)&&(call_data.win) )
            {
                MMI_TRACE_EVENT(("wangyan, callSetMode call_destroy"));
                call_destroy(call_data.win);
            }
            return;
        }
        break;
    case ViewMenu:
        call_data.calls.view = ViewMenu;
        break;
    case ViewEnd:
        {
            T_MFW_CM_AOC_INFO   aoc_info;

            TRACE_EVENT(" Call ended  read the AOC again");

            // this is used for the "last charge"
            cm_get_aoc_value(CM_AOC_ACM, &aoc_info);

            if( aoc_info.acm > acm_last_call )
            {
                //for the last charge
                acm_last_call = aoc_info.acm - acm_last_call;
            }
            else
            {
                TRACE_EVENT(" ACM value didnt change");
            }


            memset(line,'\0',sizeof(line));
            if( /*FFS_flashData.*/InCallTimer == TRUE )
                getTimeString(call_data.timeEnded,(char*)line);
            setLastCallDuration(call_data.timeEnded, call_data.call_direction);

            dialog_info_init(&display_info);//gdy add 
            display_info.KeyEvents    = KEY_RIGHT|KEY_HUP;
            display_info.TextId       = TxtCallEnded;
            display_info.TextId2      = 0;
            display_info.TextString   = '\0';
            display_info.TextString2   = (char*)line;
            display_info.LeftSoftKey  = '\0';
            display_info.RightSoftKey = '\0';
            display_info.Time         = ONE_SECS * 3; //2004-03-4 Sunny change the time from ONE_SECS to ONE_SECS * 3
            display_info.Callback     = (T_VOID_FUNC)call_ending_cb;
            display_info.Identifier    =0;
            display_info.iconindex=REMIND_COMPLETE;/*2003/12/9, wangyan add*/
            /*
             * Call Info Screen
             */

            call_data.win_ending = info_dialog (call_data.win, &display_info);
        }
        break;
    case ViewAutoRedial:
        memset(line,'\0',sizeof(line));
        //getTimeString(call_data.timeEnded,(char*)line);
        /*dspl_Clear(0, 0, 120, 160);
        DrawRectagle(param); *//*2003/12/9, wangyan add*/
        dialog_info_init(&display_info);//gdy add 
        //display_info.KeyEvents    = KEY_RIGHT|KEY_CLEAR|KEY_HUP;
        display_info.KeyEvents    = KEY_RIGHT|KEY_CLEAR|KEY_HUP|KEY_F4;/*2004/4/27, wangyan modify*/
        display_info.TextId       = TxtAutoredial;
        display_info.TextId2      = TxtNull;
        display_info.TextString   = '\0'; 
        display_info.TextString2  = (char*)call_data.phbNameNumber;
        display_info.LeftSoftKey  = TxtNull;
        display_info.RightSoftKey = TxtCancel;
        display_info.Time         = FOREVER;
        display_info.Callback     = (T_VOID_FUNC)callAutoRedialKeyEvent;
        //display_info.Identifier    =0;
        display_info.Identifier    =MMI_OUTGOING_REDIAL;/*2004/4/27, wangyan add*/


        call_data.win_redial = info_dialog (call_data.win, &display_info);
        mmi_dialogs_insert_fixmov_animation(call_data.win_redial,500,CALLREDIALANIM);
        break;
    default:
        break;
    }


    switch( mode )
    {
    case ViewDTMF:
        call_data.calls.view = ViewDTMF;
        call_data.edtAttrDTMF.mode = edtCurBar1;
        break;

    case ViewScratchPad:
        call_data.calls.view = ViewScratchPad;
        call_data.edtAttrDTMF.mode = edtCurBar1;
        break;
    case ViewSelectPrivateCall:
        call_data.calls.view = ViewSelectPrivateCall;
        show = showSelectPrivateCall;
        break;
        //GW Added
    case ViewShortWait:
        dialog_info_init(&display_info);//gdy add 
        display_info.KeyEvents    = KEY_RIGHT|KEY_HUP;
        display_info.TextId       = TxtPleaseWait;
        display_info.TextId2      = 0;
        display_info.TextString   = '\0';
        // display_info.TextString2   = (char*)line;zy move 11/15 needn't display time
        display_info.TextString2   = '\0';
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = TxtCancel;
        display_info.Time         = ONE_SECS; // 1s delay
        display_info.Callback     = (T_VOID_FUNC)call_waiting_answer_cb;
        display_info.iconindex    =REMIND_WAITTING;
        display_info.Identifier    =0;
        call_data.win_waiting = info_dialog (call_data.win, &display_info);
        break;

    case ViewWaitingAnswer:

        //display_info.KeyEvents    = KEY_LEFT;zy move 11/15 cancel is no use
        dialog_info_init(&display_info);//gdy add 
        display_info.KeyEvents    = KEY_RIGHT|KEY_HUP;
        display_info.TextId       = TxtPleaseWait;
        display_info.TextId2      = 0;
        display_info.TextString   = '\0';
        // display_info.TextString2   = (char*)line;:zy move 11/15 needn't display time
        display_info.TextString2   = '\0';
        //display_info.LeftSoftKey  = TxtCancel;zy move 11/15 cancel is no use
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey =  TxtCancel;
        display_info.Time         = FOREVER;
        display_info.Callback     = (T_VOID_FUNC)call_waiting_answer_cb;
        display_info.iconindex    =REMIND_WAITTING;
        display_info.Identifier    =0;
        call_data.win_waiting = info_dialog (call_data.win, &display_info);
        break;
    case ViewSendingDTMF:
        dialog_info_init(&display_info);//gdy add 
        display_info.KeyEvents    = KEY_LEFT|KEY_RIGHT|KEY_HUP;
        display_info.TextId       = TxtSendingDTMF;
        display_info.TextId2      = 0;
        display_info.TextString   = '\0';
        display_info.TextString2   = (char*)line;
        /*      display_info.LeftSoftKey  = TxtCancel;
              display_info.RightSoftKey = '\0';*/
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = TxtCancel;

        display_info.Time         = FOREVER;
        display_info.Callback     = (T_VOID_FUNC)call_sending_dtmf_cb;
        display_info.Identifier    =0;
        display_info.iconindex    =REMIND_WAITTING;/*2003/12/9, wangyan add*/
        call_data.win_sending_dtmf = info_dialog (call_data.win, &display_info);
        break;
    default:
        break;
    }
    winShow(call_data.win);
}






/*******************************************************************************

 $Function:     contactsExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int contactsExec(MfwMnu* m, MfwMnuItem* i)
{

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;


    bookPhonebookStart(call_data.win,PhbkNormal);
    return 1;

}


/*******************************************************************************

 $Function:     holdExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int holdExec(MfwMnu* m, MfwMnuItem* i){

    TRACE_FUNCTION("holdExec");
    switch( call_data.calls.mode )
    {
    case CallSingle:
    case CallTwo:
        callSetMode(ViewWaitingAnswer);//zy 11/15 move to here before command execute display here
        if( call_data.calls.status[call_data.calls.selected].stat == CALL_HELD )
        {
            cm_command(call_data.calls.selected, CM_RETRIEVE, '\0');
            call_data.current_command = CM_RETRIEVE;
        }
        else
        {
            cm_command(call_data.calls.selected, CM_HOLD,'\0' );
            call_data.current_command = CM_HOLD;
        }
        //  callSetMode(ViewWaitingAnswer);
        break;
    case CallConference:
        callSetMode(ViewWaitingAnswer);//zy 11/15 move to here before command execute display here
        if( call_data.calls.status[call_data.calls.selected].stat == CALL_HELD )
        {
            cm_command(call_data.calls.selected, CM_RETRIEVE_MULTIPARTY, '\0');
            call_data.current_command = CM_RETRIEVE_MULTIPARTY;
        }
        else
        {
            cm_command(call_data.calls.selected, CM_HOLD_MULTIPARTY, '\0');
            call_data.current_command = CM_HOLD_MULTIPARTY;
        }
        //      callSetMode(ViewWaitingAnswer);
        break;
    case CallPrivateCall:
    case CallMultipartySingle:
    case CallSingleMultiparty:
    default:
        break;
    }
    return 1;
}

/*******************************************************************************

 $Function:     muteExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int muteExec(MfwMnu* m, MfwMnuItem* i){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;


    if( call_data.calls.muted )
    {
        // if (mmeSetVolume(100, 100) == MfwResOk)
        // {
        OpenMic();
        call_data.calls.muted = false;
        menuCallSingleItems[1].str = (char*)TxtMute;
        //}
    }
    else
    // if (mmeSetVolume(0, 0) == MfwResOk)
    {
        CloseMic();
        call_data.calls.muted = true;
        menuCallSingleItems[1].str = (char*)TxtUnmute;

    }
    call_menu_destroy(win);
    call_data.win_menu = 0;
    return 1;
}
/**********************************************************************
$ Function Name:  addNewCall                                              
$ Purpose:        when in call dailing add a new call                          
$ Parameter:      MfwMnu* m, MfwMnuItem* i                               
$ return:         int                                                    
$ Author:         zhou yue                                               
$ Date:          Aug.1st,2002   
**********************************************************************/
static int addNewCall(MfwMnu* m, MfwMnuItem* i){
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;
    dspl_ClearAll();
    call_data.win_scratch=call_scratchpad_start(call_data.win,'\0',ViewMulticallControl,0 );

    call_menu_destroy(win);
    call_data.win_menu = 0;
    return 1;
}
/*******************************************************************************

 $Function:     scratchPadExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/
#if 0
static int scratchPadExec(MfwMnu* m, MfwMnuItem* i){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;


    call_data.win_scratch=call_scratchpad_start(win,ecBack,ViewScratchPad, 0);
    return 1;
}
#endif
/*******************************************************************************

 $Function:     mainMenuExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int mainMenuExec(MfwMnu* m, MfwMnuItem* i){

    //JVJE  menuEnter();
    return 1;

}

/*******************************************************************************

 $Function:     startConferenceExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int startConferenceExec(MfwMnu* m, MfwMnuItem* i){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;
    dspl_ClearAll();
#define TRACE_EVE
    TRACE_EVENT("start conference!");
#undef TRACE_EVE
    cm_command(0,CM_BUILD_MULTIPARTY,'\0');
    call_data.current_command = CM_BUILD_MULTIPARTY;
    callSetMode(ViewWaitingAnswer);
    call_menu_destroy(win);
    call_data.win_menu = 0;
    return 0;

}

/*******************************************************************************

 $Function:     privateStartAddConferenceExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int privateStartAddConferenceExec(MfwMnu* m, MfwMnuItem* i){


    switch( call_data.calls.mode )
    {
    case CallConference:
        callSetMode(ViewWaitingAnswer);  //zy 11/15 move to here before command execute display here
        cm_command(call_data.calls.selected,CM_SPLIT_MULTIPARTY,'\0');
        //			callSetMode(ViewWaitingAnswer);
        //			callSetMode(ViewSelectPrivateCall);

        //GW
        /* (call_data.calls.view == ViewSelectPrivateCall)
     {	//We have now selectede our party... I think.
        cm_command(call_data.calls.selected, CM_SPLIT_MULTIPARTY, '\0');
        call_data.current_command = CM_SPLIT_MULTIPARTY;
        callSetMode(ViewWaitingAnswer);
        }
        else
        callSetMode(ViewSelectPrivateCall);*/
        break;
    case CallPrivateCall:
    case CallMultipartySingle :
    case CallSingleMultiparty :
    case CallTwo:
        TRACE_EVENT("call to BUILD_MULTIPARTY------------------------------------");
        callSetMode(ViewWaitingAnswer);//zy 11/15 move to here before command execute display here
        cm_command(0,CM_BUILD_MULTIPARTY,'\0');
        call_data.current_command = CM_BUILD_MULTIPARTY;
        // callSetMode(ViewWaitingAnswer);
        break;
    default:
        break;
    }
    return 1;

}




/*******************************************************************************

 $Function:     swapExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int swapExec(MfwMnu* m, MfwMnuItem* i){

    switch( call_data.calls.mode )
    {
    case CallSingleMultiparty :
    case CallMultipartySingle :
    case CallPrivateCall :
        callSetMode(ViewWaitingAnswer);//zy 11/15 move to here before command execute display here
        cm_command(0,CM_SWAP_MULTIPARTY, '\0');
        call_data.current_command = CM_SWAP_MULTIPARTY;
        //  callSetMode(ViewWaitingAnswer);
        break;
    case CallTwo:
        callSetMode(ViewWaitingAnswer);//zy 11/15 move to here before command execute display here
        cm_command(call_data.calls.selected,CM_SWAP, '\0');
        call_data.current_command = CM_SWAP;
        //     callSetMode(ViewWaitingAnswer);
        break;
    default:
        break;
    }
    return 1;
}

/*******************************************************************************

 $Function:     endAllExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int endAllExec(MfwMnu* m, MfwMnuItem* i){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;


    call_data.callsToEnd = call_data.calls.numCalls-1;
    cm_disconnect(call_data.calls.status[0].call_number);
    callSetMode(ViewConnect);
    return 1;

}
/*******************************************************************************

 $Function:     endConferSingleExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int endConferSingleExec(MfwMnu* m, MfwMnuItem* i){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;
    int h;

    cm_force_disconnect();
    call_data.ignore_disconnect = TRUE;
    MMI_TRACE_EVENT(("wangyan, endConferSingleExec call_destroy"));
    call_destroy(call_data.win);    
    return 1;

}

/**********************************************************************
$ Function Name:  addNewCall                                              
$ Purpose:        when in call dailing add a new call                          
$ Parameter:      MfwMnu* m, MfwMnuItem* i                               
$ return:         int                                                    
$ Author:         zhou yue                                               
$ Date:          Aug.1st,2002   
**********************************************************************/

static int endOneExec(MfwMnu* m, MfwMnuItem* i){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;


    cm_disconnect(call_data.calls.selected);
    if( call_data.calls.numCalls==1 )
    {
        call_data.ignore_disconnect = TRUE;
        removeCall(call_data.calls.selected);
    }
    return 1;

}
/*******************************************************************************

 $Function:     transferExec

 $Description:

 $Returns:

 $Arguments:

*******************************************************************************/

static int transferExec(MfwMnu* m, MfwMnuItem* i){
    callSetMode(ViewWaitingAnswer);//zy 11/15 move to here before command execute display here
    cm_command(0,CM_ETC,'\0');
    call_data.current_command = CM_ETC;
    //  callSetMode(ViewWaitingAnswer);
    return 1;

}




/*******************************************************************************

 $Function:     removeCall

 $Description:  removes a managed call

 $Returns:

 $Arguments:  call id

*******************************************************************************/




int removeCall(SHORT cid) {
    int i;
    TYPEQUEUE* first;
    /*2004/04/05,talcon delete*/
    //sprintf(stringTrace,"Remove call %d",cid);
    //TRACE_FUNCTION(stringTrace);

    if( !call_data.accessEnd )
    {
        TRACE_EVENT("not access end");
        first = call_data.endQueue;
        while( call_data.endQueue )
        {
            call_data.endQueue = call_data.endQueue->next;
        }
        call_data.endQueue = (TYPEQUEUE*)ALLOC_MEMORY(sizeof(TYPEQUEUE));
        call_data.endQueue->call_number = cid;
        call_data.endQueue->next = 0;
        if( first ) call_data.endQueue = first;
        return 0;
    }
    if( call_data.endQueue )
    {
        first = call_data.endQueue->next;
        FREE_MEMORY( (void *)call_data.endQueue, sizeof(TYPEQUEUE));
        call_data.endQueue = first;
    }
    call_data.accessEnd = FALSE;
    call_data.timeEnded = call_data.calls.time[callIndex(cid)];
    for( i = 0; i < MAX_CALLS; i++ )
    {
        if( call_data.calls.status[i].call_number == cid )
            call_data.calls.status[i].call_number = 0;

        if( i < (MAX_CALLS -1) )
        {
            if( call_data.calls.status[i].call_number == 0 && call_data.calls.status[i+1].call_number != 0 )
            {
                call_data.calls.status[i] = call_data.calls.status[i+1];
                call_data.calls.time[i] = call_data.calls.time[i+1];
                call_data.calls.status[i+1].call_number= 0;
            }
        }
    }
    call_data.calls.numCalls--;
    if( call_data.calls.selected == cid )
        call_data.calls.selected = 0;
    if( call_data.calls.numCalls ==1 )
    {
        call_data.calls.mode = CallSingle;

    }
    if( (call_data.calls.mode == CallSingleMultiparty)&& (call_data.singleCall == cid) )//zy 2003-03-12 if remove one call only it's the single one if mode is  CallSingleMultiparty it still is confersingle
        call_data.calls.mode = CallConference;
    if( call_data.singleCall == cid )
        call_data.singleCall = 0;
    if( call_data.calls.numCalls )
        rebuildCalls();
    callSetMode(ViewEnd);
    return 1;
}

/*******************************************************************************

 $Function:     addCall

 $Description:

 $Returns:

 $Arguments:  call id

*******************************************************************************/


int addCall(SHORT cid) {


    MmiModuleDel(ModuleInCall);
    if( !call_data.calls.numCalls )
    {
        MmiModuleSet(ModuleCall);
        call_data.callStatus = CallActive;

        TRACE_EVENT("active call!!");
    }
    if( call_data.calls.numCalls >= MAX_CALLS )
        return 0;
    if( call_data.calls.status[call_data.calls.numCalls].call_number != 0 )
        return 0;
#ifdef NO_ASCIIZ
    //GW Removed 'sizeof' and set up length.
    if( wstrlen(call_data.phbNameNumber) > sizeof(call_data.calls.status[call_data.calls.numCalls].name.data) )
        call_data.calls.status[call_data.calls.numCalls].name.len = sizeof(call_data.calls.status[call_data.calls.numCalls].name.data)-1;
    else
        call_data.calls.status[call_data.calls.numCalls].name.len = wstrlen(call_data.phbNameNumber);
    memset(call_data.calls.status[call_data.calls.numCalls].name.data,'\0',sizeof(call_data.calls.status[call_data.calls.numCalls].name.data));
    /*
    zy 2003-04-07
    when there a new incoming call and a old call is hangup so it will
     make it be the new name
    */ 
    memcpy(call_data.calls.status[call_data.calls.numCalls].name.data,
           call_data.phbNameNumber,PHB_MAX_LEN+2);
    call_data.calls.status[call_data.calls.numCalls].name.data[PHB_MAX_LEN+2]=0;
#else

    wstrncpy((char*)call_data.calls.status[call_data.calls.numCalls].name,
             (char*)call_data.phbNameNumber,sizeof(call_data.calls.status[call_data.calls.numCalls].name));
#endif
    getCallStatus(cid, &call_data.calls.status[call_data.calls.numCalls]);
    call_data.calls.time[call_data.calls.numCalls] = 0;
    call_data.calls.numCalls++;
    call_data.calls.selected = cid;
    switch( call_data.calls.mode )
    {
    case CallSingle:
        if( call_data.calls.numCalls > 1 )
            call_data.calls.mode = CallTwo;
        break;
    case CallConference:
        call_data.singleCall = cid;
        call_data.calls.mode = CallSingleMultiparty;
        break;
    default:
        if( call_data.calls.numCalls == 1 )
            call_data.calls.mode = CallSingle;
        break;
    }
    rebuildCalls();
    return 1;
}

/*******************************************************************************

 $Function:     callIndex

 $Description:

 $Returns:    returns the cm call id

 $Arguments:  call id

*******************************************************************************/


int callIndex(SHORT cid) {

    int i;

    for( i = 0; i < MAX_CALLS; i++ )
    {
        if( call_data.calls.status[i].call_number == cid )
            return i;
    }
    return MAX_CALLS;
}

/*******************************************************************************

 $Function:     callConnect

 $Description:

 $Returns:

 $Arguments:  call id

*******************************************************************************/



void callConnect(SHORT cid){

    TRACE_FUNCTION("Call Connect");
    addCall(cid);
    callSetMode(ViewConnect);

}

/*******************************************************************************

 $Function:     callNumber

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



void callNumber(UBYTE *number){

    T_MFW     res;
    T_MFW_PHB_ENTRY phb_entry;
    T_MFW_SS_RETURN ssRes;
    char edt_buf_prov[CALL_NAME_LENGTH+2];
    char mainnum[CALL_NAME_LENGTH+2];
    int i;
    UINT8 mainlen=0;
    memset(extnum,'\0',sizeof(extnum));
    //#define TEST/* 2004/02/28,talcon add */
#ifdef TEST
    if( number[0] <'0' || number[0]>'9' || strlen((char *)number)==2 )
    {
        ss_execute_transaction((unsigned char *)number,0);
        return ;
    }
#endif
    call_data.emergencyCall = FALSE;
    /*begin of zy change 2003-04-29 only dial 24num*/
    memset(edt_buf_prov,0,sizeof(edt_buf_prov));
    memset(mainnum,0,sizeof(mainnum));
    memcpy((char*)edt_buf_prov,(char*)number,CALL_NAME_LENGTH+2);
    /*end of zy change 2003-04-29*/
    for( i=0;i<=strlen((char *)edt_buf_prov);i++ )
    {
        if( edt_buf_prov[i]=='p' )
        {
            //     TRACE_EVENT("zy:callnumber has 'p'");
            mainlen=i;
            //    TraceInt(mainlen);
        }
        if( mainlen>0&&i>mainlen )
        {
            extnum[i-mainlen-1]=edt_buf_prov[i];
        }
        if( mainlen==0 )
        {
            mainnum[i]=edt_buf_prov[i];
        }
    }
    if( mainlen>0 )
    {
        mainnum[mainlen]='\0';
        extnum[strlen((char *)edt_buf_prov)-mainlen]='\0';
    }
    else
        wstrcpy((char*)mainnum,(char*)edt_buf_prov);
    /*   TRACE_EVENT("callnumber mainnum:");
       TRACE_EVENT(mainnum);
       TRACE_EVENT(extnum);*/
    //   TRACE_EVENT_P1("wangyan:%s",extnum);
    //  TraceInt((int)mainlen);
    ssRes = ss_check_ss_string((UBYTE*)mainnum);
    switch( ssRes )
    {
    case MFW_SS_USSD:
    case MFW_SS_SIM_LOCK:
    case MFW_SS_REG_PW:
    case MFW_SS_CF:
    case MFW_SS_CB:
    case MFW_SS_CLIR:
    case MFW_SS_CLIP:
    case MFW_SS_COLR:
    case MFW_SS_COLP:
    case MFW_SS_WAIT:
    case MFW_SS_HOLD:

    case MFW_SS_SIM_REG_PW:
    case MFW_SS_SIM_UNBLCK_PIN:
    case MFW_SS_MMI:
        cm_mo_call((UBYTE*)mainnum, VOICE_CALL);
        return;           /* Handled on # */
        /*MC 12/04/02*/
    case MFW_SS_ECT:
        TRACE_EVENT("Recognised ECT string");
        cm_mo_call((UBYTE*)mainnum, VOICE_CALL);
        return;           /* Handled on # */
    case MFW_SS_DIAL:
    case MFW_SS_DIAL_IDX:
    case MFW_SS_DTMF:
    case MFW_SS_UNKNOWN:
    default:
        break;            /* Remove #, it will be added later on again */
    }

    res = cm_mo_call((UBYTE*)mainnum, VOICE_CALL);
    switch( res )
    {
    case CM_OK :
        TRACE_EVENT("call OK");
        break;
    case CM_EC:
        call_data.emergencyCall = TRUE;
        break;
    case CM_BLACKLIST:
        TRACE_EVENT("number blacklisted now");
        /*NM, p018*/               
        if( call_data.win )
            bookShowInformation(call_data.win,Txtblacklisted,NULL,(T_VOID_FUNC)call_failure_cb);
        break;
    case CM_SIM:
    case CM_SS :
    case CM_MMI:
    case CM_USSD:
        return;
        break;
        //GW-SPR#1035 - Added from SAT changes baseline
    case CM_CFDN_ERR:             
    case CM_CBDN_ERR:  
        TRACE_EVENT("MO-Call blocked by FDN or BDN");
        info_screen(0, TxtNull, TxtCallBlocked, NULL,REMIND_FAILURE); 
        break;
    default:
        TRACE_EVENT("call not OK");
        //check if call ended because ACM>=ACMMAX
        {T_MFW_CM_AOC_INFO aocInfo;

            cm_get_aoc_value(CM_AOC_ACMMAX,&aocInfo);

            //Get ACM and ACMMAX
            cm_get_aoc_value(CM_AOC_ACM,&aocInfo);

            //display "No Credit" to user
            if( (aocInfo.acm >= aocInfo.acm_max) &&
                ( aocInfo.acm_max > 0) )
            {
                T_DISPLAY_DATA display_info;

                dialog_info_init(&display_info);//gdy add 
                display_info.TextString  = '\0';
                display_info.TextId2  = TxtCredit;
                // TRACE_EVENT("acm_max exceeded");
                display_info.KeyEvents    = KEY_LEFT | KEY_RIGHT;
                display_info.TextId       = TxtNo;
                display_info.TextString   = '\0';
                display_info.LeftSoftKey  = TxtSoftOK;
                display_info.RightSoftKey = 0;
                display_info.Time         = ONE_SECS;
                display_info.Callback     = (T_VOID_FUNC)NULL;
                info_dialog (call_data.win, &display_info);
                return;
            }
            else
            {
                TRACE_FUNCTION("call not OK to show error");
                /*API - 917 - Added code so that when trying to generate an MO call when FDN is
                           activated an entry is not in the FDN phonebook this screen should be displayed
                */
                /*NM, p018*/               
                if( call_data.win )
                {
                    bookShowInformation(call_data.win,TxtOperationNotAvail,NULL,(T_VOID_FUNC)call_failure_cb);
                }
                else
                {
                    /* to show any notification even in the case  "call_data.win == 0" */
                    info_screen(0, TxtNull,TxtOperationNotAvail , NULL,REMIND_FAILURE); 
                }
            }
        }
        return;
    }

}




/*******************************************************************************

 $Function:     getTimeString

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



void getTimeString(long time,char *timeString){

    int hour,min,sec;

    hour = time/3600;
    min = (time-hour*3600)/60;
    sec = (time-hour*3600-min*60);
    sprintf(timeString,"%02d:%02d:%02d",hour,min,sec);
    return;
}


/*******************************************************************************

 $Function:     refreshCallTimer

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/




static void refreshCallTimer(){

    int i;

    TRACE_FUNCTION("refreshCallTimer");
    for( i = 0; i < call_data.calls.numCalls; i++ )
        call_data.calls.time[i]++;
    return;
}



/*******************************************************************************

 $Function:     call_HeadsetKeyDetection

 $Description:

 $Returns:    Return TRUE if call or incoming call or outgoing call in progress

 $Arguments:  None
*******************************************************************************/



UBYTE call_HeadsetKeyDetection  (void)
{
    if( call_data.incCall || call_data.outCall || call_data.calls.numCalls )
        return 1;
    else
        return 0;
}




/*******************************************************************************

 $Function:     endingCall

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



static void endingCall(void){

    call_data.accessEnd = TRUE;
    if( call_data.endQueue )
    {
        removeCall(call_data.endQueue->call_number);
        MMI_TRACE_EVENT(("wangyan endingCall:%d ",call_data.endQueue->call_number));
        return;
    }
    if( !call_data.calls.numCalls )
    {
        if( (!call_data.win_incoming)&&(!call_data.win_calling) )
        {
            MmiModuleDel(ModuleCall);
            MMI_TRACE_EVENT(("wangyan endingCall MmiModule:%d ",MmiModule));
            call_data.callStatus = CallInactive;

            if( call_data.win )
            {
                MMI_TRACE_EVENT(("wangyan, endingCall call_destroy"));
                call_destroy(call_data.win);
            }
        }
    }

    callSetMode(ViewConnect);

}



/*******************************************************************************

 $Function:     rebuildCalls

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



static void rebuildCalls(void){

    int i;
    char debug[50];

    TRACE_FUNCTION("rebuildCalls");
    if( call_data.calls.selected == 0 )
        call_data.calls.selected = call_data.calls.status[0].call_number;
    if( call_data.calls.mode != CallConference )
    {
        for( i=0;i < call_data.calls.numCalls;i++ )
        {
            sprintf(debug, "Getting call number %d", i);
            TRACE_EVENT(debug);
            getCallStatus(call_data.calls.status[i].call_number, &call_data.calls.status[i]);
            if( call_data.calls.status[i].stat == CALL_ACTIVE )
                call_data.calls.selected = call_data.calls.status[i].call_number;
        }
    }
    else
        for( i=0;i < call_data.calls.numCalls;i++ )
        {
            sprintf(debug, "Getting call number %d", i);
            TRACE_EVENT(debug);
            getCallStatus(call_data.calls.status[i].call_number, &call_data.calls.status[i]);
        }
    if( call_data.win_menu )
    {
        call_menu_destroy(call_data.win_menu);
        call_data.win_menu = 0;
    }
}


/*******************************************************************************

 $Function:     getCallStatus

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


static int getCallStatus(SHORT call_number,T_MFW_CM_STATUS* call){

    char prov[MFW_TAG_LEN];
    int p;
    int i;
    char debug[100];
#ifdef NO_ASCIIZ
    //For future compatibility with unicode 
    memset(prov, '\0', MFW_TAG_LEN);
    memcpy(prov,(char*)call->name.data,call->name.len );
    p = cm_status(call_number,call, 1);
    i=0;
    while( (i <call->name.len) && (call->number[i]==prov[i]) )
    {
        i++;
    }
    if( i == call->name.len )
        memcpy(call->name.data, prov, call->name.len);

#else
    //copy current name to temp var
    wstrcpy((char*)prov,(char*)call->name);
    //read status from MFW
    p = cm_status(call_number,call, 1);
    sprintf(debug, "CID:%d,orig name:%s new name: %s, Call number: %s", prov, call->name, prov, call->number);
    TRACE_EVENT(debug);
    //if number alphabetically  ahead of orig name
    if( wstrcmp((char*)call->number,(char*)prov) )
        wstrcpy((char*)call->name,(char*)prov); //copy orig name to structure
#endif
    return p;

}


/*******************************************************************************

 $Function:     exeSendMessage

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


int exeSendMessage(MfwMnu* m, MfwMnuItem* i)
{
    return 0;
}


/*******************************************************************************

 $Function:     callExeNameEnter

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



static int callExeNameEnter(MfwMnu* m, MfwMnuItem* i){
    return 0;
}

/* 2004/05/13 sunsj modify */
/*******************************************************************************

 $Function:     callFailureCause

 $Description:

 $Returns:

 $Arguments:

 $History: sunsj 2004/05/13
           2004/06/01 sunsj
*******************************************************************************/
static void callFailureCause(UBYTE cause)
{
    switch( cause )
    {
    case CAUSE_UNASSIGN:
    case CAUSE_BARRED:
    case CAUSE_NUM_FORMAT:
    case CAUSE_BARRED_IN_CUG:
    case CAUSE_USER_NOT_IN_CUG:
        bookShowCallInformation(idle_get_window(),TxtCheckNumber, NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        break;
    case CAUSE_USER_BUSY:
        bookShowCallInformation(idle_get_window(),TxtNumberBusy,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        StartToneByID(TONE_BUSYZ);//zy 09/04
        break;
    case CAUSE_NO_RESPONSE:
    case CAUSE_ALERT_NO_ANSWER:
    case CAUSE_CALL_REJECT:
        bookShowCallInformation(idle_get_window(),TxtNoAnswer,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        break;
    case CAUSE_NUM_CHANGED:
        bookShowCallInformation(idle_get_window(),TxtNumberChanged,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        break;
    case CAUSE_FACILITY_REJECT:
    case CAUSE_STATUS_ENQUIRY:
    case CAUSE_QOS_UNAVAIL:
    case CAUSE_BEARER_CAP_UNAVAIL:
    case CAUSE_SERVICE_UNAVAIL:
    case CAUSE_BEARER_NOT_IMPLEM:
    case CAUSE_ACM_MAX:
    case CAUSE_FACILITY_NOT_IMPLEM:
    case CAUSE_SERVICE_NOT_IMPLEM:
        bookShowCallInformation(idle_get_window(),TxtNetUselessInCall,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        StartToneByID(TONE_BUSYZ);//zy 09/04
        break;
    case CAUSE_NO_CHAN_AVAIL:
    case CAUSE_TEMP_FAIL:
    case CAUSE_SWITCH_CONGEST:
    case CAUSE_REQ_CHAN_UNAVAIL:
        bookShowCallInformation(idle_get_window(),TxtNetworkBusy,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);//zy 08/01/02 show dialog with icon
        StartToneByID(TONE_BUSYZ);//zy 09/04
        break;
    case CAUSE_FACILITY_UNSUBSCRIB:
    case CAUSE_BEARER_CAP_AUTHORIZ:
        bookShowCallInformation(idle_get_window(),TxtNotSubscribed,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);//zy 2003-04-16
        break;
        //GW-SPR#1035 - Added SAT changed
        /*NM, 110702
        the "202" stands for timer 303 expired;
        unfortunately there is no define for that in the SAP/MNCC */
    case 202:
        bookShowCallInformation(idle_get_window(),TxtCallTimeout,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        break;
    case 16:
        bookShowCallInformation(idle_get_window(),TxtNotAvailable,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);//zy 2003-04-16
        break;
        /*NM, 110702 END*/
    default:
        bookShowCallInformation(idle_get_window(),TxtNetUselessInCall,NULL,(T_VOID_FUNC)call_failure_cb,MMI_SHOWCALLICON_DIALOG);
        StartToneByID(TONE_BUSYZ);
        break;
    }
    return;
}


/*******************************************************************************

 $Function:     sendDTMFString

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

static void sendDTMFString(void)
{


    call_data.sendingDTMF = TRUE;
    if( call_data.charSent<strlen(call_data.edtBufDTMF) )
    {
        cm_command(call_data.calls.selected,CM_DTMF_AUTO,(UBYTE)call_data.edtBufDTMF[call_data.charSent]);
        call_data.current_command = CM_DTMF_AUTO;
    }
    else if( wstrlen(extnum) )
    {
        call_data.charSent = 0;
        call_data.sendingDTMF = FALSE;
        //    callSetMode(ViewConnect);zy 11/11 remove temp
    }
}


/*******************************************************************************

 $Function:     callCalcCost

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void callCalcCost (char* line)
{
    char line2[MAX_LINE];
    char *pdest,*src,*dst,*POINT;
    LONG result;
    int  ch = '.';
    UBYTE counter=0;

    memset(line2,'\0',sizeof(line2));

    cm_get_aoc_value(CM_AOC_CCM,&call_data.aocInfo);  /* Get CCM  */
    cm_get_aoc_value(CM_AOC_PUCT,&call_data.aocInfo); /* Get currency and price per unit */

    /* Search for '.' */
    pdest = strchr((char*) call_data.aocInfo.ppu, ch );
    if( pdest EQ NULL )
    {                              /* '.' not founded  */
        result = atol((char*)call_data.aocInfo.ppu );          /* STRING => LONG   */
        result= result *  call_data.aocInfo.ccm;               /* CCM * PPU        */
        sprintf(line, "%ld %s", result,call_data.aocInfo.cur); /* LONG => STRING   */
    }
    else
    {                                             /* '.' found  */
        /*
         * '.' found, *pdest EQ '.'
         */
        counter = strlen(pdest + 1); /* store the decimal place */

        src = (char*)call_data.aocInfo.ppu;
        dst = line;
        do                           /* remove the '.'   */
        {
            if( *src NEQ '.' )
            {
                *dst++ = *src;
            }
        } while( *src++ NEQ '\0' );
        /* STRING => LONG   */
        result= atol(line) *  call_data.aocInfo.ccm;   /*  CCM * PPU       */
        sprintf(line, "%ld", result);        /* LONG => STRING   */

        if( strlen(line) < counter )
        {
            src = line;
            dst = line2;
            *dst++ = '0';
            *dst++ = '.';
            counter = counter - strlen(line);
            do                               /* fill up with '0'   */
            {
                *dst++ = '0';
            } while( --counter NEQ 0 );

            memcpy (dst,src,sizeof(src));
            sprintf(line, "%s %s", line2,call_data.aocInfo.cur);     /* add the currency */
            return;
        }
        src = line;
        dst = line2;
        POINT= src + strlen(src) - counter;
        do                                  /* set the '.'   */
        {
            if( src EQ POINT )
            {
                *dst++ = '.';
            }
            *dst++ = *src++;

        } while( *src NEQ '\0' );
        if( line2[0] EQ '.' )
            sprintf(line, "0%s %s", line2,call_data.aocInfo.cur);    /* add the currency */
        if( line2[0] NEQ '.' )
            sprintf(line, "%s %s", line2,call_data.aocInfo.cur);     /* add the currency */
    }
    return;
}


/*******************************************************************************

 $Function:     call_create

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/
/*void call_active_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call        * data = (T_call *)win_data->user;


    if(!winIsFocussed(data->win))
    {
        timStop(data->active_tim);
        return;
    }
    timStop(data->active_tim);
    timStart(data->active_tim);

    if (data->active_current_frame< (data->active_number_of_frames-1))
    {
        data->active_current_frame++;
    }
    else				    	
    {
        data->active_current_frame= 0;
    }
    dspl_BitBlt( CallActive_Attr[data->active_current_frame].area.px,CallActive_Attr [data->active_current_frame].area.py,
                CallActive_Attr [data->active_current_frame].area.sx,CallActive_Attr [data->active_current_frame].area.sy,
                CallActive_Attr [data->active_current_frame].nIcons,CallActive_Attr [data->active_current_frame].icons,0);
}*/

T_MFW_HND call_create (T_MFW_HND parent_window){

    T_call        * data = &call_data;
    T_MFW_WIN     * win;

    TRACE_FUNCTION("call_create()");

    pwr_Status.mobilestatusflag = 1; ///zym added 09/05/02
    // MmiTrace("call_destroy");
    // MmiTraceInt(pwr_Status.mobilestatusflag);
    call_win_flag=TRUE;
    Isfromcallwin=0;//zy add 0107/2003
    Iscallnumber1=0;//zy zdd 0220/2003 for one call and call new failured need retrive
    SpeakerVols=FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume;
    if( (SpeakerVols<0)||(SpeakerVols>12) )
        SpeakerVols=6;
    SetASpk_DownLinkPGA(FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].speakervolume);
    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)call_win_cb);

    if( data->win EQ 0 )
        return 0;

//2004.08.02 Added by Cathy for Camera
#ifdef CAMERA_ENABLED
     CamExit();
#endif


    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)call;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
    * Create any other handler
    */
    memset(data->phbNameNumber,'\0',sizeof(data->phbNameNumber));
    bookSetEditAttributes(4,28,80,20,0,0,edtCurBar1,0,(char*)data->phbNameNumber,CALL_NAME_LENGTH,&data->edtAttrCall);

    data->kbd      = kbd_create (data->win,KEY_ALL,(T_MFW_CB)call_kbd_cb);
    data->kbd_long = kbd_create (data->win,KEY_ALL|KEY_LONG,(T_MFW_CB)call_kbd_long_cb);
    data->cm = cm_create(data->win, E_CM_ALL_SERVICES, (MfwCb)callCmEvent);
    MMI_TRACE_EVENT(("wangyan call_create data->cm=%d;data->win=%d",data->cm,data->win));
    data->editCall = edtCreate(data->win,&data->edtAttrCall,0,0);
    //	data->active_tim= tim_create (data->win, 500, (T_MFW_CB)call_active_tim_cb);


    SEND_EVENT(data->win,CALL_INIT,0,0);
    winShow(data->win);
    /*
     * return window handle
     */
    return data->win;



}


/*******************************************************************************

 $Function:     call_destroy

 $Description:  we should make it only be called at all call is disconnected :zy note 2003-02-25

 $Returns:

 $Arguments:
*******************************************************************************/

extern UINT8 vibra_status;

void call_destroy (T_MFW_HND own_window){

    T_MFW_WIN     * win;
    T_call        * data;

    MMI_TRACE_EVENT(("wangyan call_destroy() call_data.cm=%d",call_data.cm));
    setOuterState(OUTERIDLESTATE_INCOMING,0,0); 
    /*
  zy move if(!call_data.calls.numCalls) only at there is no call or we decide destroy all callwin should we call calldestroy
    */
    //if(!call_data.calls.numCalls)
    {
        notavailtryone=1;
        pwr_Status.mobilestatusflag = 0; ///zym added 09/05/02
        //  MmiTrace("call_destroy");
        // MmiTraceInt(pwr_Status.mobilestatusflag);
        call_win_flag=FALSE;
        Isfromcallwin=0;//zy add 0107/2003
        Iscallnumber1=0;//zy 2003-02-24 active indeed hold
        memset(extnum,'\0',sizeof(extnum));
        MMI_TRACE_EVENT(("wangyan call_destroy() call_data=%d own_window=%d",&call_data,own_window));       
        // 2004.3.22 WYJ 

        MC_StopVibra(); // 2004.4.16 WYJ add

        StopPlayByReasonId(INCALL);
        //SetEarMode();
        call_data.isHandSetMode=0;
        call_data.handSetKeyDone=0;
        call_data.handSetOldStatus=0;
        call_data.mintalert=0;
    }
    /*
     end of zy change 2003-02-26
    */
    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_call *)win->user;

        if( data )
        {
            /*
             * Exit Keyboard Handler
             */
            /*
             * Delete WIN Handler
             */


            /*NM 003
            Dont destroy any call related windows
            for spec. cases (FTA) :
            User has one activ call and we get a new
            incoming call (incoming screen pops up).
            The user hasnt press a key to accept
            or reject the call yet but  the active 
            call on the other side is released at this
            time.
            Here we have to keep the incoming call
            screen and just only to destroy all other
            call related windows !
      
            if (call_data.win_incoming)
            {
               SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
               call_data.win_incoming = 0;
            }
            */

            /*		if (call_data.win_incoming)
                    {
                            MMI_TRACE_EVENT(("wangyan call_data.win_incoming DIALOG_DESTROY finished"));
                        return;
                    }*/
            /*
            NM 003 END
            */    
            /*2003/12/16, wangyan add*//*
            if (call_data.win_active)
            {
                SEND_EVENT(call_data.win_active,DIALOG_DESTROY,0,0);
                call_data.win_active = 0;
            }*/
            /*2003/12/16, wangyan add*/

            if( call_data.win_calling )
            {
                SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
                MMI_TRACE_EVENT(("wangyan call_data.win_calling DIALOG_DESTROY"));
                call_data.win_calling = 0;
            }
            if( call_data.win_ending )
            {
                SEND_EVENT(call_data.win_ending,DIALOG_DESTROY,0,0);
                MMI_TRACE_EVENT(("wangyan call_data.win_ending DIALOG_DESTROY"));
                call_data.win_ending = 0;
            }
            if( call_data.win_menu )
            {
                call_menu_destroy(call_data.win_menu);
                MMI_TRACE_EVENT(("wangyan call_data.win_menu DIALOG_DESTROY"));
                call_data.win_menu = 0;
            }
            if( call_data.win_waiting )
            {
                SEND_EVENT(call_data.win_waiting,DIALOG_DESTROY,0,0);
                MMI_TRACE_EVENT(("wangyan call_data.win_waiting DIALOG_DESTROY"));
                call_data.win_waiting = 0;
            }
            if( call_data.win_sending_dtmf )
            {
                SEND_EVENT(call_data.win_sending_dtmf,DIALOG_DESTROY,0,0);
                MMI_TRACE_EVENT(("wangyan call_data.win_sending_dtmf DIALOG_DESTROY"));
                call_data.win_sending_dtmf = 0;
            }
            if( call_data.win_scratch )
            {
                call_scratchpad_destroy(call_data.win_scratch);
                MMI_TRACE_EVENT(("wangyan call_data.win_scratch DIALOG_DESTROY"));
                call_data.win_scratch =0;
            }
            /*begin of zy change 2003-04-01
             we should destroy all these win build in call.
             we needn't it if all call end 
            */
            if( call_data.win_adjustvolume )
            {
                SEND_EVENT(call_data.win_adjustvolume,CALLVOLDESTROY,0,0);
                MMI_TRACE_EVENT(("wangyan call_data.win_adjustvolume DIALOG_DESTROY"));
                call_data.win_adjustvolume = 0;
            }
            if( call_data.win_memo )
            {
                Memo_destroy(call_data.win_memo);
                MMI_TRACE_EVENT(("wangyan call_data.win_memo DIALOG_DESTROY"));
                call_data.win_memo = 0;
            }
            if( call_data.win_phb )
            {
                TRACE_EVENT("we have callphb win");
                MMI_TRACE_EVENT(("wangyan call_data.win_phb DIALOG_DESTROY"));
                bookPhonebookDestroy(call_data.win_phb);
                call_data.win_phb=0;
            }
            if( call_data.win_voicerecord )
            {
                SEND_EVENT (call_data.win_voicerecord, VM_SAVERECORDCALL, NULL, NULL);
                MMI_TRACE_EVENT(("wangyan call_data.win_voicerecord DIALOG_DESTROY"));
                voice_memo_destroy (call_data.win_voicerecord);
                call_data.win_voicerecord=0;
            }

            /*end of zy change 2003-04-01*/
            if( call_data.win_incoming )
            {
                MMI_TRACE_EVENT(("wangyan win_incoming call_destroy() call_data.cm=%d",call_data.cm));
                MMI_TRACE_EVENT(("wangyan win_incoming before destroy"));
                SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
                MMI_TRACE_EVENT(("wangyan win_incoming after destroy"));
                call_data.win_incoming = 0;
                //			return;
            }
            //			tim_delete (data->active_tim);
            SetEarMode();
            win_delete (data->win);

            data->win=0;
        }
    }
    MMI_TRACE_EVENT(("wangyan call_destroy() call_data.cm=%d",call_data.cm));
    //driverFlag&=0xFFFFFFEF;//wms set the keybeep initial status
}

/*******************************************************************************

 $Function:     call

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void call (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_call         * data = (T_call *)win_data->user;


    TRACE_FUNCTION ("call()");

    switch( event )
    {
    case CALL_INIT:
        {


            memset(&data->calls,0,sizeof(data->calls));
            memset(call_data.colp_number,'\0',sizeof(call_data.colp_number));
            phb_set_auto_off(PHB_AUTO_ON);
            data->win_incoming=0;
            //data->win_active=0;/*2003/12/16, wangyan add*/
            data->win_calling=0;
            data->win_menu=0;
            /*begin of zy change 2003-04-01*/
            data->win_memo=0;
            data->win_phb=0;
            data->win_adjustvolume=0;
            data->win_voicerecord=0;
            /*end of zy change 2003-04-01*/
            data->win_waiting=0;
            data->win_scratch=0;
            data->calls.numCalls = 0;
            data->accessEnd = TRUE;
            data->callWaitingEnd = 0;
            data->emergencyCall = FALSE;
            data->callsToEnd = 0;
            data->incCall = 0;
            data->callStatus = CallInactive;
            data->outCall=0;
            data->call_direction=INVALID;
            data->refreshConnect = 0;
            data->firstChar=FIRST_TYPED;
            data->currentVolume=MAX_SOUND;
            data->endQueue = 0;
            data->singleCall = 0;
            data->charSent=0;
            data->sendingDTMF=FALSE;
            data->ignore_disconnect = FALSE;
            data->isHandSetMode=0;
            data->handSetKeyDone=0;
            data->handSetOldStatus=0;
            data->mintalert=0;
            //GW Ensure a valid (non-zero) number for currentVolume
            if( FFS_flashData.output_volume > MAX_SOUND )
                FFS_flashData.output_volume = MAX_SOUND;
            else if( FFS_flashData.output_volume <= 0 )
                FFS_flashData.output_volume = MAX_SOUND;

            //      mmeSetVolume (1, FFS_flashData.output_volume);//zy 09/18 its needn't

            data->calls.muted=FALSE;//2003-04-04zy 
            //			data->active_current_frame=0;/*2003/12/16, wangyan add*/
            //			data->active_number_of_frames=6;/*2003/12/16, wangyan add*/
            winUnhide(call_data.win);
        }
        break;

    case CALL_DESTROY_WAITING:
        if( call_data.win_waiting )
        {
            SEND_EVENT(call_data.win_waiting,DIALOG_DESTROY,0,0);
            call_data.win_waiting = 0;
            if( !call_data.calls.numCalls )
            {
                MMI_TRACE_EVENT(("wangyan, call call_destroy"));
                call_destroy(call_data.win);
            }
        }
        break;
    case CALL_DESTROY_CALLING_WINDOW:
        cm_disconnect(call_data.calls.selected);   //zhaowm 2003 0328
        if( call_data.calls.numCalls==1 )
        {
            call_data.ignore_disconnect = TRUE;
            removeCall(call_data.calls.selected);
        }
        /*      
        if (call_data.win_calling) // Implemented to patch a WAP disconnection problem. Only WAP use!! JVJ
        {
            SEND_EVENT(call_data.win_calling,DIALOG_DESTROY,0,0);
            call_data.win_calling = 0;
            call_data.outCall = 0;
            cm_disconnect(call_data.outCall);
            if (!call_data.calls.numCalls){
              call_data.ignore_disconnect = TRUE;
              call_destroy(call_data.win);
              return;
          }
          endingCall();
        }
        */
        break;
    case E_CM_NOTIFY:
        /*
         * Show all cc related notifications
         */
        showCCNotify( win, (T_MFW_CM_NOTIFY*) parameter );
        break;
    case E_CM_COLP:
        {
            /* NM 056, FTA Testcase 31.1.3.1
             * add COLP only for the singlecall and have
             * to be done for multicall as well !
             */

            T_MFW_CM_MO_INFO *colp  = (T_MFW_CM_MO_INFO*) parameter ;

            TRACE_EVENT ("E_CM_COLP");

            if( wstrlen((char*)colp->number) > 0 )
            {
                memset(call_data.colp_number,'\0',sizeof(call_data.colp_number));
                wstrcpy ((char*)call_data.colp_number , (char*)colp->number);
            }
        } 
        break;
    case CALL_OUTGOING_SAT:
        {/*zy change 2003-04-16 all these things will be done at callcmevent()E_cm_mo_res:
         */
            /* this means the SIM toolkit is about to start a call - this means we will
             * shortly receive E_CM_MO_RES from MFW, so we do some initialisation of    data
             * parameters before we receive this event
             */

            /*  T_SAT_call_setup_parameter * call_setup_parameter = (
         T_SAT_call_setup_parameter *)parameter;zy 2003-04-14 move needn't here,in
                                 callcmevent()E_CM_MO_RES
                              */

            TRACE_EVENT ("CALL_OUTGOING_SAT");

            /* if this is the first call then initialise the window data */
            /*     if (call_data.calls.numCalls == 0)
                     SEND_EVENT(call_data.win,CALL_INIT,0,0);zy 2003-04-14 move needn't here,in
                     callcmevent()E_CM_MO_RES
                  */

            /* set the outcall ID */
            /*call_data.outCall = call_setup_parameter->callId;
            call_data.call_direction = OUTGOING;zy 2003-04-14 move needn't here,in
                                  callcmevent()E_CM_MO_RES
                               */
            /* set the display string from the SIM toolkit label */
            /*                if (call_setup_parameter->TextString NEQ NULL)
                            {
              wstrncpy(
                                    call_data.phbNameNumber,
                                    call_setup_parameter->TextString,
                                    sizeof(call_data.phbNameNumber)-1);
                            }
                            else
                            {
                                call_data.phbNameNumber[0] = '\0';
                            }zy 2003-04-14 needn't this num is wrong*/
            /*end of zy change 2003-04-16*/
            call_SATCall = TRUE;
            TRACE_EVENT ("Set SatCall");
        }
        break;
    case CALL_DESTROY_ALL:
        switch( call_data.calls.mode )
        {
        case CallMultipartySingle:
        case CallSingleMultiparty:
        case CallConference:
            endConferSingleExec(0, 0);
            break;
        default:
            endAllExec(0, 0);
            break;
        }  
        break;
    default:
        break;
    }

}

#if 0
/*******************************************************************************

 $Function:     call_win_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/
//GW-SPR#???-Truncate phone numbers at the beginning (lose first x chars)

static int call_win_cb(MfwEvt e, MfwWin *w){


    T_call        * data=(T_call *)w->user;
    int i = 0;
    char line[MAX_LINE];
    char tag[MAX_CHAR];
    int topLine;
    TRACE_FUNCTION("call_win_cb");
    switch( e )
    {
    case MfwWinVisible:
        memset(tag,'\0',sizeof(tag));
        //  showDefault();//zy 09/05
        if( !call_data.calls.numCalls )
        {
            //    	
            //       dspl_Enable(1);
            return 1;
        }//zy move here 11/15 avoid white dspl
        /*if(call_data.win_scratch==0)
            dspl_Clear(0, 0, 120, 160);
        else
        dspl_Clear(0,8,119,79);*///zy move 2003-02-13 needn't show every sec
        //  	TRACE_FUNCTION("call new edit begin");
        dspl_Clear(0, 0, 120, 160);//zy add 2003-02-14
        switch( call_data.calls.mode )
        {
        case CallSingle :
            if( call_data.calls.muted )
            {
                dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.");
                PROMPT(24, Mmi_layout_first_line(), 0, TxtMuted);
            }

            else
            {
                i = callIndex(call_data.calls.selected);
                if( call_data.calls.status[i].stat == CALL_ACTIVE )
                /*            dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.A.");
                                  else
                                    dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.H.");*/
                //GW Truncation now MAX_CHAR-4 (as there are 4 chars in above strings).
                {
                    dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.");
                    PROMPT(24, Mmi_layout_first_line(), 0, TxtActive);
                }
                else
                {
                    dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.");
                    PROMPT(24, Mmi_layout_first_line(), 0, TxtHold);
                }
            }
            memset(tag,'\0',sizeof(tag));
            if( call_data.calls.status[i].name.len > 0 )
                truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_ONENAMELEN,POS_END,".");
            else

                if( strlen((char*)call_data.calls.status[i].number) > 0 )
            {
                TRACE_EVENT("output COLP number");
                /* NM,  Testcase 31.1.3.1 COLP,
                   show the real connected number,
                   for single call							 
                */
                if( strlen((char*)call_data.colp_number) > 0 )
                {

                    truncateString(tag,(char*)call_data.colp_number,STR_DISPLAY_NCHAR,POS_END,".");
                }
                else
                {
                    truncateString(tag,(char*)call_data.calls.status[i].number,STR_DISPLAY_NCHAR,POS_END,".");
                }

            }
            else
            {
                truncateString(tag,GET_TEXT(TxtSoftCall),MAX_ONENAMELEN,POS_END,".");
            }
            dspl_TextOut(8,Mmi_layout_second_line(),0,tag);     

            memset(line,'\0',sizeof(line));

            if( /*FFS_flashData.*/InCallTimer == TRUE )
                dspl_TextOut((120-64)/2, Mmi_layout_third_line(), 0, (char *)line);
            break;
        case CallTwo :
        case CallPrivateCall:
        case CallConference :
        case CallSingleMultiparty:
        case CallMultipartySingle:
        default:
            if( call_data.calls.numCalls<MAX_CALLS )
                topLine = Mmi_layout_first_line();
            else
                topLine = Mmi_layout_first_line();
            for( i=0;i<call_data.calls.numCalls;i++ )
            {
                memset(line,'\0',sizeof(line));
                memset(tag,'\0',sizeof(tag));
                sprintf(line,"%d",i+1);

                if( call_data.calls.status[i].stat == CALL_ACTIVE )
                    sprintf(&line[1],"%s",".A.");
                else
                    sprintf(&line[1],"%s",".H.");
                dspl_TextOut(0, (USHORT)(topLine+LINE_HEIGHT*i), 0, (char*)line);

                memset(tag,'\0',sizeof(tag));
                if( call_data.calls.status[i].name.len > 0 )
                {
                    TRACE_EVENT("call name");
                    TRACE_EVENT((char*)call_data.calls.status[i].name.data);
                    TraceInt(strlen((char *)call_data.calls.status[i].name.data));
                    truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_ONENAMELEN-2,POS_END,".");//zy 09/27

                }
                else

                {
                    if( strlen((char*)call_data.calls.status[i].number) > 0 )
                    {

                        TRACE_EVENT("output COLP number");
                        /* 
                         *COLP,  show the real connected number,
                          for multi call
                        */
                        if( strlen((char*)call_data.colp_number) > 0 )
                        {
                            truncateString(tag,(char*)call_data.colp_number,STR_DISPLAY_NCHAR-2,POS_END,".");
                        }
                        else
                        {
                            truncateString((char*)tag,(char*)call_data.calls.status[i].number,STR_DISPLAY_NCHAR-2,POS_END,".");
                        }

                    }
                    else
                    {
                        truncateString((char*)tag,(char*)GET_TEXT(TxtSoftCall),MAX_ONENAMELEN-2,POS_END,".");
                    }
                }

                if( (call_data.calls.mode== CallConference) &&
                    (i==callIndex(call_data.calls.selected)) )
                    dspl_TextOut(CALL_SEVERIALS_XPOS,(USHORT)(topLine+LINE_HEIGHT*i), DSPL_TXTATTR_INVERS, (char *)tag);
                else
                    dspl_TextOut(CALL_SEVERIALS_XPOS,(USHORT)(topLine+LINE_HEIGHT*i), 0, (char *)tag);


            }
            break;
        }
        displaySoftKeys(TxtSoftOptions,TxtPhonebook);
        break;
    default:
        break;
    }
    return 1;
}
#endif

static int call_win_cb(MfwEvt e, MfwWin *w){
    T_call        * data=(T_call *)w->user;
    int i = 0;
    char line[MAX_LINE];
    char tag[MAX_CHAR];
    int topLine;
    int startpos;
    int old_color;
    T_DISPLAY_DATA display_info;/*2003/12/15, wangyan modify*/
    T_MFW_HND       activewin;
    //	int i;
    /*2003/12/9, wangyan modify*/
    /*	game_Rectangle param;
        param.x1=0;
        param.y1=0;
        param.x2=120;
        param.y2=160;
        param.fillcolor=0x5AC7FF;
        param.color=0x5AC7FF;*/
    /*2003/12/9, wangyan modify*/
    TRACE_FUNCTION("call_win_cb");



    switch( e )
    {
    case MfwWinVisible:
        if( !call_data.calls.numCalls )
        {
            return 1;
        }//zy move here 11/15 avoid white dspl
        /*if(call_data.win_scratch==0)
        dspl_Clear(0, 0, 120, 160);
        else
        dspl_Clear(0,8,119,79);*///zy move 2003-02-13 needn't show every sec
        //  	TRACE_FUNCTION("call new edit begin");
        /*			dspl_Clear(0, 0, 120, 160);
                    DrawRectagle(param); *//*2003/12/9, wangyan modify*/
        /*		dialog_info_init(&display_info);   
                display_info.KeyEvents=KEY_RIGHT |KEY_HUP|KEY_LEFT;
                display_info.TextId = TxtActive;
                display_info.LeftSoftKey  = TxtSoftSelect;
                display_info.RightSoftKey = TxtSoftBack;
                display_info.Time         =FOREVER;
                display_info.Callback     =(T_VOID_FUNC)call_kbd_cb;
                display_info.Identifier=MMI_CALL_ACTIVE;
                data->win_active=info_dialog( data->win, &display_info );
                mmi_dialogs_insert_fixmov_animation(data->win_active,500,CALLACTIVEANIM);*//*2003/12/16, wangyan modify*/
        draw_special_background();
        //ALIGNED_PROMPT(CENTER,DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, TxtActive);
        //		timStart(data->active_tim);
        switch( call_data.calls.mode )
        {
        case CallSingle :
            memset(tag,'\0',sizeof(tag));
            if( call_data.calls.muted )
            {
                //				tag[0]='1';tag[1]='.';tag[2]=' ';
                /*						dspl_TextOut(8, Mmi_layout_first_line(), 0, (char *)tag);
                                        PROMPT(32, Mmi_layout_first_line(), 0, TxtMuted);*//*2003/12/9, wangyan modify*/
                //				dspl_TextOut(1, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, (char *)tag);
                //				PROMPT(25, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtMuted);
                ALIGNED_PROMPT(LEFT, 2, DSPL_TXTATTR_TRANSPARENT, TxtMuted);
            }
            else
            {
                MMI_TRACE_EVENT(("wangyan: call_win_cb"));
                i = callIndex(call_data.calls.selected);
                if( call_data.calls.status[i].stat == CALL_ACTIVE )
                /* dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.A.");
                else
                dspl_TextOut(8, Mmi_layout_first_line(), 0, "1.H.");*/
                //GW Truncation now MAX_CHAR-4 (as there are 4 chars in above strings).
                {
                    //	tag[0]='1';tag[1]='.';tag[2]=' ';
                    /*dspl_TextOut(8, Mmi_layout_first_line(), 0, (char *)tag);
                    PROMPT(32, Mmi_layout_first_line(), 0, TxtActive);*//*2003/12/9, wangyan modify*/
                    //	dspl_TextOut(1, DIALOG_FIRST_LINE,  DSPL_TXTATTR_TRANSPARENT, (char *)tag);
                    //	PROMPT(25, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, TxtActive);/*2003/12/9, wangyan modify*/
                    ALIGNED_PROMPT(LEFT, 2, DSPL_TXTATTR_TRANSPARENT, TxtActive);
                }
                else
                {
                    //				tag[0]='1';tag[1]='.';tag[2]=' ';
                    /*dspl_TextOut(8, Mmi_layout_first_line(), 0, (char *)tag);
                    PROMPT(32, Mmi_layout_first_line(), 0, TxtHold);*/
                    //				dspl_TextOut(1, DIALOG_FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, (char *)tag);
                    //				PROMPT(25,  DIALOG_FIRST_LINE,DSPL_TXTATTR_TRANSPARENT, TxtHold);/*2003/12/9, wangyan modify*/
                    ALIGNED_PROMPT(LEFT, 2, DSPL_TXTATTR_TRANSPARENT, TxtHold);
                }
            }
            memset(tag,'\0',sizeof(tag));
            if( call_data.calls.status[i].name.len > 0 )
                truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_ONENAMELEN,POS_END,".");
            else if( strlen((char*)call_data.calls.status[i].number) > 0 )
            {
                /* NM,  Testcase 31.1.3.1 COLP, show the real connected number, for single call */
                if( strlen((char*)call_data.colp_number) > 0 )
                {
                    truncateString(tag,(char*)call_data.colp_number,STR_DISPLAY_NCHAR,POS_END,".");
                }
                else
                {
                    truncateString(tag,(char*)call_data.calls.status[i].number,STR_DISPLAY_NCHAR,POS_END,".");
                }

            }
            else
            {
                truncateString(tag,GET_TEXT(TxtSoftCall),MAX_ONENAMELEN,POS_END,".");
            }

            /* 2004/06 sunsj modify for picture manage */
            DRAW_ICON_ATTRIBUTE(ICON_CALLACTIVE, 2, FIRST_LINE+4, 0, ICON_LOCATION);
            //dspl_BitBlt(2, FIRST_LINE+4, 8, 8, 0,(void *)call_icon_active1,0);
            dspl_TextOut(12, FIRST_LINE, DSPL_TXTATTR_TRANSPARENT,(char *)tag);/*2003/12/9, wangyan modify*/

            /*		startpos=(SCREEN_SIZE_X - get_StringWidth(tag)) / 2;
                    if (startpos<0)	startpos=0;
                    //dspl_TextOut(startpos,Mmi_layout_second_line(),0,(char *)tag);
                    dspl_TextOut(startpos,20, DSPL_TXTATTR_TRANSPARENT,(char *)tag);*//*2003/12/9, wangyan modify*/

            memset(line,'\0',sizeof(line));
            getTimeString(call_data.calls.time[i],(char*)line);
            /*startpos=(SCREEN_SIZE_X - get_StringWidth(line)) / 2;
            if (startpos<0)	startpos=0;
            old_color=dspl_GetBkgColor();*/
            if( /*FFS_flashData.*/InCallTimer == TRUE )
                //dspl_TextOut(startpos, Mmi_layout_third_line(), 0, (char *)line);
                dspl_TextOut((SCREEN_SIZE_X-get_StringWidth(line)), 2, 0, (char *)line);/*2003/12/9, wangyan modify*/
            //dspl_SetBkgColor(old_color);
            break;

        case CallTwo :
        case CallPrivateCall:
        case CallConference :
        case CallSingleMultiparty:
        case CallMultipartySingle:
        default:
            topLine = DIALOG_FIRST_LINE;
            for( i=0;i<call_data.calls.numCalls;i++ )
            {
                memset(line,'\0',sizeof(line));
                memset(tag,'\0',sizeof(tag));
                //				sprintf(line,"%d",i+1);
                /*2003/11/19, wangyan, modify call waiting show*/
                /*           if (call_data.calls.status[i].stat == CALL_ACTIVE)
                    sprintf(&line[1],"%s",".A.");
                else
                    sprintf(&line[1],"%s",".H.");
                dspl_TextOut(0, (USHORT)(topLine+LINE_HEIGHT*i), 0, (char*)line);*/
                /*				line[1]='.';
                                dspl_TextOut(1, (topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_TRANSPARENT, (char*)line);
                
                                if (call_data.calls.status[i].stat == CALL_ACTIVE)
                                {
                                    dspl_BitBlt(17, (topLine+LINE_HEIGHT*2*i), 16, 16, 0, (void *)newSMS, 0);
                                    PROMPT(33, (topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_TRANSPARENT, TxtActive);
                                }
                                else
                                {
                                    dspl_BitBlt(17, (topLine+LINE_HEIGHT*2*i),  16, 16, 0, (void *)newSMS, 0);
                                    PROMPT(33, (topLine+LINE_HEIGHT*2*i),DSPL_TXTATTR_TRANSPARENT, TxtHold);
                                }*/
                /*2003/11/19, wangyan, modify call waiting show*/            
                if( call_data.calls.status[i].stat == CALL_ACTIVE )
                {
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_ATTRIBUTE(ICON_CALLACTIVE, 2, FIRST_LINE+i*LINE_HEIGHT, i, ICON_LOCATION);
                    /*
                    switch( i )
                    {
                    case 0:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active1,0);break;
                    case 1:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active2,0);break;
                    case 2:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active3,0);break;
                    case 3:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active4,0);break;
                    case 4:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active5,0);break;
                    case 5:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active6,0);break;
                    case 6:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_active7,0);break;
                    default:
                        break;
                    }
                    */
                    //					dspl_BitBlt(17, (topLine+LINE_HEIGHT*2*i), 16, 16, 0, (void *)newSMS, 0);
                    //					PROMPT(33, (topLine+LINE_HEIGHT*2*i), DSPL_TXTATTR_TRANSPARENT, TxtActive);
                }
                else
                {
                    /* 2004/06 sunsj modify for picture manage */
                    DRAW_ICON_ATTRIBUTE(ICON_CALLHOLD, 2, FIRST_LINE+i*LINE_HEIGHT, i, ICON_LOCATION);
                    /*
                    switch( i )
                    {
                    case 0:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold1,0);break;
                    case 1:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold2,0);break;
                    case 2:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold3,0);break;
                    case 3:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold4,0);break;
                    case 4:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold5,0);break;
                    case 5:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold6,0);break;
                    case 6:
                        dspl_BitBlt(2, FIRST_LINE+i*LINE_HEIGHT, 8, 8, 0,(void *)call_icon_hold7,0);break;
                    default:
                        break;
                    }
                    */
                    //					dspl_BitBlt(17, (topLine+LINE_HEIGHT*2*i),  16, 16, 0, (void *)newSMS, 0);
                    //					PROMPT(33, (topLine+LINE_HEIGHT*2*i),DSPL_TXTATTR_TRANSPARENT, TxtHold);
                }
                /*2003/11/19, wangyan, modify call waiting show*/     


                memset(tag,'\0',sizeof(tag));
                if( call_data.calls.status[i].name.len > 0 )
                {
                    //TRACE_EVENT("call name");
                    //TRACE_EVENT((char*)call_data.calls.status[i].name.data);
                    truncateString((char*)tag,(char*)call_data.calls.status[i].name.data,MAX_ONENAMELEN-2,POS_END,".");//zy 09/27
                }
                else
                {
                    if( strlen((char*)call_data.calls.status[i].number) > 0 )
                    {
                        /* COLP,  show the real connected number, for multi call */
                        if( strlen((char*)call_data.colp_number) > 0 )
                        {
                            truncateString(tag,(char*)call_data.colp_number,STR_DISPLAY_NCHAR-2,POS_END,".");
                        }
                        else
                        {
                            truncateString((char*)tag,(char*)call_data.calls.status[i].number,STR_DISPLAY_NCHAR-2,POS_END,".");
                        }
                    }
                    else
                    {
                        truncateString((char*)tag,(char*)GET_TEXT(TxtSoftCall),MAX_ONENAMELEN-2,POS_END,".");
                    }
                }
                /*2003/11/19, wangyan, modify call waiting show*/            
                /* if ((call_data.calls.mode== CallConference) &&
                    (i==callIndex(call_data.calls.selected)))
                    dspl_TextOut(CALL_SEVERIALS_XPOS,(USHORT)(topLine+LINE_HEIGHT*i), DSPL_TXTATTR_INVERS, (char *)tag);
                else
                    dspl_TextOut(CALL_SEVERIALS_XPOS,(USHORT)(topLine+LINE_HEIGHT*i), 0, (char *)tag);*/
                /*2003/11/19, wangyan, modify call waiting show*/            
                //				startpos=(SCREEN_SIZE_X - get_StringWidth(tag)) / 2;
                /* 2004/05/28 sunsj modify */
                if( (call_data.calls.mode== CallConference) &&(i==callIndex(call_data.calls.selected)) )
                    dspl_TextOut(10,i*LINE_HEIGHT, DSPL_TXTATTR_INVERS, (char *)tag);
                else
                    dspl_TextOut(10,FIRST_LINE+i*LINE_HEIGHT, DSPL_TXTATTR_TRANSPARENT, (char *)tag);
            }

            //2004-03-8 Sunny add codes to display time and status.	
            if( (call_data.calls.mode >=CallTwo) && (call_data.calls.mode <=CallMultipartySingle) )
            {
                dspl_TextOut(0, 2, 0, (char *)getViewStatus(call_data.calls.mode));
            }
            /*			memset(line,'\0',sizeof(line));
                        getTimeString(call_data.calls.time[i],(char*)line);
                        if (InCallTimer == TRUE)			
                            dspl_TextOut((SCREEN_SIZE_X-get_StringWidth(line)), 2, DSPL_TXTATTR_TRANSPARENT, (char *)line);*/
            //2004-03-8 Sunny add end.
            break;
        }       
        displaySoftKeys(TxtSoftOptions,TxtPhonebook);
        break;
    default:
        break;
    }
    return 1;
}


/*******************************************************************************

 $Function:     call_kbd_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


static int call_kbd_cb (MfwEvt e, MfwKbd *k){

    T_MFW_HND       win  = mfwParent(mfw_header()); //GW Added
    int index;
    int volStep;

    MMI_TRACE_EVENT(("wangyan call_kbd_cb"));
    //GW Change volume in large steps if sound has a large range	
    if( MAX_SOUND < 8 )
        volStep = 1;
    else
        volStep = MAX_SOUND / 4;

    switch( k->code )
    {
    /*2004/04/09,talcon modify record key KCD_F3 to KCD_OK*/
    //case KCD_F3:
    case KCD_OK:
        {
            //   bookPhonebookStart(win,PhbkFromVoiceMemo);  
            CallRecord(NULL, NULL);//zy imediately begin record voice
        }
        break; //lif
    case KCD_MNUUP:
        if( call_data.calls.mode== CallConference )
        {
            index = callIndex(call_data.calls.selected);
            if( index ==0 )
                index = call_data.calls.numCalls;
            index = index - 1;
            call_data.calls.selected = call_data.calls.status[index].call_number;
            winShow(win);
        }
        else
        {
            /*if (FFS_flashData.output_volume < MAX_SOUND)
            {
               if (FFS_flashData.output_volume <= MAX_SOUND-volStep)
                  FFS_flashData.output_volume = FFS_flashData.output_volume + volStep;
               else
                  FFS_flashData.output_volume = MAX_SOUND;
      //			mmeSetVolume (1, FFS_flashData.output_volume);//zy 09/18 its needn't
   
               SaveVolumeSetting();
            }*///zy 11/18 move
        }
        break;

    case KCD_MNUDOWN:
        if( call_data.calls.mode== CallConference )
        {
            index = callIndex(call_data.calls.selected);
            index = index + 1;
            if( index >= call_data.calls.numCalls )
                index = 0;
            call_data.calls.selected = call_data.calls.status[index].call_number;
            winShow(win);
        }
        else
        {
            /*if (FFS_flashData.output_volume > 0)
            {
               if (FFS_flashData.output_volume>= volStep+1)
                  FFS_flashData.output_volume = FFS_flashData.output_volume - volStep;
               else
                  FFS_flashData.output_volume = 1;
      //			mmeSetVolume (1, FFS_flashData.output_volume);//zy 09/18 its needn't
               SaveVolumeSetting();
            }*///zy move 11/18
        }

        break;
    case KCD_LEFT:
        /*begin of zy 2003-04-24 before tryaccept has result we don't want it call any menu*/
        if( currTryAccept==1 )
        {
            WaitWhile();
            return;
        }
        /*end of zy change 2003-04-24*/
        switch( call_data.calls.mode )
        {
        case CallSingle:
            if( call_data.calls.status[callIndex(call_data.calls.selected)].stat == CALL_ACTIVE )
                menuCallSingleItems[0].str = (char*)TxtHold;
            else
                menuCallSingleItems[0].str = (char*)TxtUnhold;
            call_data.win_menu = call_menu_start(call_data.win,(T_MFW_MNU_ATTR *)&menuCallSingle,(T_VOID_FUNC)call_menu_end_cb);
            break;
        case CallTwo:
            /*   if (call_data.calls.status[callIndex(call_data.calls.selected)].stat == CALL_ACTIVE)
               menuCallTwoItems[5].str = (char*)TxtHold;
                       else
               menuCallTwoItems[5].str = (char*)TxtUnhold;*/
            call_data.win_menu = call_menu_start(call_data.win,(T_MFW_MNU_ATTR *)&menuCallTwo,(T_VOID_FUNC)call_menu_end_cb);
            break;
        case CallConference:
            if( call_data.calls.status[callIndex(call_data.calls.selected)].stat == CALL_ACTIVE )
                menuCallConferenceItems[2].str = (char*)TxtHold;
            else
                menuCallConferenceItems[2].str = (char*)TxtUnhold;
            menuCallConferenceItems[0].str = (char*)TxtPrivateCall;
            call_data.win_menu = call_menu_start(call_data.win,(T_MFW_MNU_ATTR *)&menuCallConference,(T_VOID_FUNC)call_menu_end_cb);
            break;
        case CallPrivateCall:
            menuCallConferSingleItems[0].str = (char*)TxtReStartConference;
            call_data.win_menu = call_menu_start(call_data.win,(T_MFW_MNU_ATTR *)&menuCallConferSingle,(T_VOID_FUNC)call_menu_end_cb);
            break;
        case CallSingleMultiparty:
        case CallMultipartySingle:
            menuCallConferSingleItems[0].str = (char*)TxtAddToConference;
            call_data.win_menu = call_menu_start(call_data.win,(T_MFW_MNU_ATTR *)&menuCallConferSingle,(T_VOID_FUNC)call_menu_end_cb);
            break;
        default:
            break;
        }
        break;
    case KCD_CALL:
        //    holdExec(0, 0);zy use it after need now remove temp
        break;

    case KCD_HUP:
        if( !call_data.calls.numCalls )
        {
            cm_force_disconnect();
            call_data.ignore_disconnect = TRUE;
            setOuterState(OUTERIDLESTATE_INCOMING,0,0);         
            MMI_TRACE_EVENT(("wangyan, KCD_HUP call_destroy"));
            call_destroy(call_data.win);
            return 1;
        }
        switch( call_data.calls.mode )
        {
        case CallConference:
            //      	endAllExec(0, 0);
            endConferSingleExec(0,0);
            return;
            break;
        case CallSingleMultiparty:
        case CallMultipartySingle:
            endConferSingleExec(0, 0);
            return;
            break;
        default:
            /*zy 2003-04-17 only when there are two calls and they are all hold should we hangup all calls*/
            if( call_data.calls.mode==CallTwo )
            {
                int i,j;
                j=0;
                for( i=0;i<2;i++ )
                {
                    if( call_data.calls.status[i].stat == CALL_HELD )
                        j++;
                }
                if( j==2 )
                {
                    endConferSingleExec(0, 0);
                    return;
                }
            }
            /*end of zy change 2003-04-17*/
            {
                char temp[30];
                sprintf(temp,"call Id %d",call_data.calls.selected);
                TRACE_EVENT(temp);
            }
            cm_disconnect(call_data.calls.selected);
            if( call_data.calls.numCalls==1 )
            {
                call_data.ignore_disconnect = TRUE;
                removeCall(call_data.calls.selected);
            }
            break;
        }
        break;
    case KCD_RIGHT:
        call_data.win_phb= bookPhonebookStart(call_data.win, PhbkFromCall);
        break;
    case KCD_F4:
        //  	TRACE_EVENT("zy:KCD_F4 in mmicall");
        //  	TraceInt((int)KCD_F4);zy 10/22
        if( IsHandsetPlugin()&&(!HallStatus()) )
        {
            MMI_TRACE_EVENT(("handsetplugin and hall is off"));
            return 1; 
        }
        if( !HallStatus() )
        {
            switch( call_data.calls.mode )
            {
            case CallMultipartySingle:
            case CallSingleMultiparty:
            case CallConference:
                endConferSingleExec(0, 0);
                break;
            default:
                endAllExec(0, 0);
                break;
            }
        }
        break;     
        /*............................zy add 08/29........................................*/
    case KCD_VOLUP:
        TRACE_EVENT("call kcd_volup");
        if( IsHandsetPlugin()&&(!HallStatus()) )
            AdjustSpkHandsetHallOff_VolUp();
        else
            AdjustSpk_VolUp();
        break;
        /*2004/04/09,talcon add key KCD_F3*/
    case KCD_F3:
    case KCD_VOLDOWN:
        TRACE_EVENT("call kcd_volDown");
        if( IsHandsetPlugin()&&(!HallStatus()) )
            AdjustSpkHandsetHallOff_VolDown();
        else
            AdjustSpk_VolDown();
        break;
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
    case KCD_STAR:
    case KCD_HASH:
        /*...........................end of zy change................................*/
        /*begin of zy 2003-04-24 before tryaccept has result we also dont want it call any at command at that time*/
        if( currTryAccept==1 )
        {
            WaitWhile();
            return;
        }
        /*end of zy change 2003-04-24*/
        /* use the DTMF only for single call */
        if( !call_data.win_incoming )
        {
            if( call_data.calls.mode EQ CallNormal ||call_data.calls.mode EQ CallDone ||
                call_data.calls.mode EQ CallNew  ||call_data.calls.mode EQ CallSingle )
            {
                TRACE_EVENT("send DTMF");

                call_data.win_scratch=call_scratchpad_start(call_data.win,editControls[k->code],ViewDTMF, 0);            
            }
            if( call_data.calls.mode EQ CallTwo ||call_data.calls.mode EQ CallConference ||
                call_data.calls.mode EQ CallPrivateCall  ||call_data.calls.mode EQ CallSingleMultiparty ||call_data.calls.mode EQ CallMultipartySingle )
            {
                TRACE_EVENT("send no DTMF and the keys are able for multicall controll");
                //call_data.win_scratch=call_scratchpad_start(call_data.win,editControls[k->code],ViewMulticallControl, ViewMulticallControlCallWaiting);
                call_data.win_scratch=call_scratchpad_start(call_data.win,editControls[k->code],ViewDTMF, 0);            
            }
        }
        break;
    default:
        break;

    }
    return 1;


}

/*******************************************************************************

 $Function:     call_kbd_long_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/
static int call_kbd_long_cb (MfwEvt e, MfwKbd *k){
    return MFW_EVENT_CONSUMED;
}

/*int incoming_call_kbd_long_cb (MfwEvt e, MfwKbd *k)
{
    if((e & KEY_LONG))
    {
        if(!HallStatus()){
            switch(k->code)
            {
                    case KCD_F3:
                    MMI_TRACE_EVENT(("wangyan KCD_F3"));   
                            if( call_data.win_incoming )
                            {
                        stopIncallLed();				
                        if(vibra_status==VIBRA_BUSY)
                            StopVibrator();
                        cm_mt_reject();
                        saveNumCallRecord('R',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); 
                        setOuterState(OUTERIDLESTATE_INCOMING,0,0); 
                                    SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
                                call_data.win_incoming = 0;
                            }
                    break;
                case KCD_VOLUP:
                        LedLightnessAdjust(200);
                    timStart(gtVibator);
                            break;
                default:
                    break;
            }
            return;
        }
        return;
    }
    return;
}*/

int incoming_call_kbd_long_KeyAction()
{
    if( call_data.win_incoming )
    {
        stopIncallLed();                
        MC_StopVibra(); // 2004.4.16 WYJ
        cm_mt_reject();
        saveNumCallRecord('R',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
        setOuterState(OUTERIDLESTATE_INCOMING,0,0); 
        SEND_EVENT(call_data.win_incoming,DIALOG_DESTROY,0,0);
        call_data.win_incoming = 0;
        call_destroy(call_data.win);
    }
}
/*******************************************************************************

 $Function:     call_incoming_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/
void call_incoming_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call * data     = (T_call *)win_data->user;
    UBYTE currentRinger;
    //char time[50];
    //UBYTE n,m,len,avail;//wufei 1009
    //int year,month,day,hour,min,sec,i;
    int i;
    T_DISPLAY_DATA display_info;
    /*
     * special case: Identifier is used only for the Multicall Control
     */


    MMI_TRACE_EVENT(("wangyan call_incoming_cb()"));

    call_data.win_incoming = 0;
    stopIncallLed();/* zy add 01-23-2003 for led incomingcall stop*/
    currentRinger = getCurrentRingerSettings();
    switch( reason )
    {
    case INFO_KCD_F4:
        //TRACE_EVENT("zy:KCD_F4 in mmicall");
        //TraceInt((int)KCD_F4);
        //TraceInt((int)drvpara.hallstatusflag);zy 10/22
        //		if (!HallStatus()) /*2004/4/27, wangyan modify*/
        if( (!HallStatus())&&(!IsHandsetPlugin()) )
        {
            MMI_TRACE_EVENT(("wangyan call reject"));
            // terminate the ringing
            //xsf 2002.08.05 audio_StopSoundbyID( AUDIO_BUZZER, currentRinger );

            //StopPlayByReasonId(INCALLPLAY);
            cm_mt_reject();
            //saveNumCallRecord('J',latestInNum);
            //			saveNumCallRecord('J',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
            saveNumCallRecord('R',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
            setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add
            returntoidle(1);/*2004/4/2, wangyan add*/
        }
        else if( FlashSettingData.hallonconnect||FlashDCTbData.AutoAnswerFlag )
        {//zy 2003-05-08 if autoanswerhallon connect immediately
            StartPlayByReason(INCALL, 0);
            cm_mt_accept();
            wstrcpy( latestReceivedNum,  latestInNum);
            // saveNumCallRecord('R',latestReceivedNum );  //hu binhao 2002-11-26
            saveNumCallRecord('R',latestReceivedNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29
            setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add
        }
        break;  
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        MC_StopVibra(); // 2004.4.16 WYJ

        // terminate the ringing
        //StopPlayByReasonId(INCALLPLAY);
        cm_mt_reject();
        //saveNumCallRecord('J',latestInNum);
        //		saveNumCallRecord('J',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
        saveNumCallRecord('R',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata);/*2003/12/16, wangyan modify*/
        setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add

        dialog_info_init(&display_info);
        display_info.Time         = ONE_SECS;
        display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
        display_info.TextId       = TxtReject;
        display_info.iconindex    =REMIND_NORECORD;
        info_dialog (win, &display_info); 


        //      SetEarMode();//zy 09/18 
        break;
    case INFO_KCD_OFFHOOK:
    case INFO_KCD_LEFT:
    case INFO_KCD_CALL://zy 08/01/02 KCD_call can accept call too
        //StopPlayByReasonId(INCALLPLAY);
        // 2004.3.22 WYJ 
        MC_StopVibra(); // 2004.4.16 WYJ
        SaveVoiceMemo();//yq added 2003/4/4,we save the voicememo
        StartPlayByReason(INCALL, 0);
        cm_mt_accept();
        wstrcpy( latestReceivedNum,  latestInNum);
        //  saveNumCallRecord('R',latestReceivedNum );  //hu binhao 2002-11-26
        saveNumCallRecord('R',latestReceivedNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29
        setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add
        break;
        /*       case INFO_KCD_UP:
               case INFO_KCD_DOWN:
                
             // MZ 3/4/01set the sound reason to volume setting from incomingcall.
         //    setSoundsReason(SettingVolume);
       
             // MZ 3/4/01 display the volume settings menu.
         //        call_data.win_menu=bookMenuStart(call_data.win, ringerVolumeSetting(), SettingVolume);
       zy 09/27/02 move not use yet
                 break;*/
        //this is for the auto answer
    case INFO_TIMEOUT:
        //StopPlayByReasonId(INCALLPLAY);
        StartPlayByReason(INCALL, 0);
        cm_mt_accept();
        wstrcpy( latestReceivedNum,  latestInNum);
        //saveNumCallRecord('R',latestReceivedNum );
        saveNumCallRecord('R',latestReceivedNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29
        setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add
        break;

    case INFO_KCD_ALL:
        // only allowed if Keypadlock -> off and the AnyKeyAnswer -> on
        // xsf 2002.07.04  if ((FFS_flashData.settings_status & SettingsAnyKeyAnswerOn) AND

        if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag )
        { //zy 09/18 
            TRACE_EVENT ("call_incoming_cb() with Anykeyanswer");
            mmeAudioTone(0, 0, TONE_SWT_OFF);
            //StopPlayByReasonId(INCALLPLAY);
            StartPlayByReason(INCALL, 0);
            cm_mt_accept();
            wstrcpy( latestReceivedNum,  latestInNum);
            //saveNumCallRecord('R',latestReceivedNum );
            saveNumCallRecord('R',latestReceivedNum ,IsIngroup,SimReadyFlag,&searchPhdata); //hu binhao 2002-12-29
            setOuterState(OUTERIDLESTATE_INCOMING,0,0); //2004-03-23 Sunny add
        }
        //	else /* open the scratchpad for the Multicall Control */
        //	{
        //		call_scratchpad_start(call_data.win, editControls[identifier], ViewMulticallControl, ViewMulticallControlIncomingCall);
        //	}zy move for avoid call when incomingcall
        break;

    default:

        break;
    }
}

/*******************************************************************************

 $Function:     incomingCall

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void incomingCall(const T_MFW_CM_CW_INFO* p_pCwInfo){

    T_DISPLAY_DATA   display_info;
    char  trace[50];
    UBYTE currentRinger;
    USHORT groupIcon;
    // T_FindName  searchPhdata;
    //int IsIngroup;

    TRACE_FUNCTION("incomingCall");

    dialog_info_init(&display_info);//gdy add 
    if( p_pCwInfo == 0 )
    {
        return;
    }
    //xsf add 2002.08.05 2 lines
#if 0
    if( (CheckPassWord(PRO_SIMLOCK)&&(!SimLock1))||(CheckPassWord(PRO_ON)&&(!ProOnLock)) )
    {
        return;
    }
#endif
    memcpy(&call_data.globalCWInfo, p_pCwInfo, sizeof(call_data.globalCWInfo));

    // bookFindNameInPhonebook((char*)call_data.globalCWInfo.number,&call_data.entry);
    /*
    begin of zy add 2003-02-14 before find name add "+" if it is international number
    */
    if( (call_data.globalCWInfo.ton == MFW_TON_INTERNATIONAL) && (call_data.globalCWInfo.number[0] != (UBYTE)'+') )
    {
        wstrcpy((char*)call_data.phbNameNumber,"+");
        TRACE_EVENT("Adding plus.");
    }
    else
        wstrcpy((char*)call_data.phbNameNumber,"");

    /* sbh end */

    wstrcat((char*)call_data.phbNameNumber,(char*)call_data.globalCWInfo.number);
    wstrcpy((char*)call_data.globalCWInfo.number,(char*)call_data.phbNameNumber);
    wstrcpy( latestInNum,(char *)call_data.phbNameNumber);
    /*
    end of zy add 2003-02-14 before find name add "+" if it is international number
    */
    IsIngroup=FindNumber((char *)call_data.globalCWInfo.number,(T_FindName *)&searchPhdata);//zy 09/19 test search phb 
    if( searchPhdata.GroupIndex==9 )
    {
        cm_mt_reject();
        //saveNumCallRecord('J',latestInNum);
        //		saveNumCallRecord('J',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
        return;
    }
    currentRinger=getCurrentRingerSettings();
    //  TraceInt(IsIngroup);
    //  TRACE_EVENT((char *)searchPhdata->name);
    //  TRACE_EVENT("zy:groupicon is");
    TraceInt((int)searchPhdata.GroupingIcon);
    wstrcpy((char *)call_data.entry.name.data,(char *)searchPhdata.name);//zy 09/19 test search phb

    if( !call_data.win )
    {//xsf 2002.08.06 
        CloseMic();//zy 09/23
        call_create(0);
    }
    if( !call_data.calls.numCalls )
    {//zy add 2003-02-28 only there are no call
        if( IsIngroup )
        {
            if( searchPhdata.GroupIndex==0xff || searchPhdata.GroupIndex==0x0f ) //2004.4.5 WYJ fix MI18800000140
            {
                StartPlayByReason(INCALLPLAY,currentRinger);
                groupIcon=0;
            }
            else
            {
                /*
              chenjun, 2003-01-23 ,the ring index may overflow when we delete a user ring , 
              in this situation, no ring is selected indeed, if so ,set the ring index to 0.
              */
                /* 
                if(searchPhdata.GroupingRing>=(GetUserRingNum()+resource_GetListCount(RES_MELODY)))
                   searchPhdata.GroupingRing=0;
                 //chenjnu add over here 2003-01-23
                           */ 
                groupIcon=searchPhdata.GroupingIcon;            
                //   	 TraceInt((int)groupIcon);
                StartPlayByReason(INCALLPLAYGROUP,searchPhdata.GroupingRing);
                //   	 TraceInt((int)searchPhdata.GroupingRing);
            }
        }
        else
        {
            groupIcon=0;//zy 11/04temp test   	 
            StartPlayByReason(INCALLPLAY,currentRinger);   //XSF 2002.09.10 CHANGED
        }
    }
    else
    {   //zy 09/05   

        StartToneByID( TONE_BUSYZ);//zy 09/18

    }
    //Find the current ringer id settings.
    //  sprintf(trace," >>>> CurrentRinger:%d",currentRinger);
    //  TRACE_EVENT(trace);

    //xsf 2002.08.05 audio_PlaySoundID( AUDIO_BUZZER, currentRinger, 0 , 0 );
    /*..........................zy add judge hall is on and light the lcd...................................*/

    //glowing,2004-02-11, comment the following block
#if 0
    if( HallStatus() )
    {
        LCD_ON();
        timStart(gtVibator);
    }
    else
    {
        if( FlashSettingData.ledon==1 )
        {
            StartIncallLed();
            IncallLedControl=TRUE;
        }
    }
#endif
    //glowing,2004-02-11, add the following block



    /* 2004/03/31 sunsj modify */
    LedLightnessAdjust(200);
    /* 2004/04/12 sunsj remove */
    //timStart(gtVibator);
    timStop(gtVibator);//talcon add 2004/05/15

    /*................................end of zy change..........................................................*/       

    if( call_data.calls.numCalls == 0 )
        SEND_EVENT(call_data.win,CALL_INIT,0,0);

    //set the global status
    MmiModuleSet(ModuleInCall);

    //


    sprintf((char*)trace,"number %s",call_data.globalCWInfo.number);
    TRACE_EVENT ((char*)trace);


    call_data.incCall = p_pCwInfo->call_number;
    call_data.call_direction = INCOMING;

    sprintf((char*)trace,"incomingCall Id-%d",call_data.incCall);
    TRACE_EVENT ((char*)trace);
    display_info.TextId2      = 0;
    display_info.TextString2 = '\0';

    idwithheld = FALSE;

    // if (call_data.entry.name.len > 0)
    if( IsIngroup )
    {//zy 09/19 test search phb
        sprintf((char*)trace,"name %s",call_data.entry.name.data);

        TRACE_EVENT ((char*)trace);

        //  bookGsm2Alpha(call_data.entry.name.data);                
        wstrncpy(call_data.phbNameNumber,(char*)call_data.entry.name.data, sizeof(call_data.entry.name.data));
        //GW-SPR#762 - String may not be null terminated - add null at end.
        if (call_data.entry.name.len > (CALL_NAME_LENGTH+2))
        {
            call_data.phbNameNumber[CALL_NAME_LENGTH+1] = '\0';
            call_data.phbNameNumber[CALL_NAME_LENGTH+2] = '\0';
        }
        display_info.TextString2  = call_data.phbNameNumber;
        //  display_info.TextString2 = (char*)call_data.entry.name.data;
        sprintf((char*)trace,"TextString2:%s",display_info.TextString2);
        TRACE_EVENT((char *)trace);
    }

    else if( wstrlen((char*)call_data.globalCWInfo.number) > 0 )
    {
        /* sbh 12/02/02.  Ensure that '+' is included before international numbers. */
        TRACE_EVENT("Got here!");
        /*
           if ((call_data.globalCWInfo.ton == MFW_TON_INTERNATIONAL) && (call_data.globalCWInfo.number[0] != (UBYTE)'+') )
              {
              wstrcpy((char*)call_data.phbNameNumber,"+");
              TRACE_EVENT("Adding plus.");
              }
           else
              wstrcpy((char*)call_data.phbNameNumber,"");
         
         /* sbh end */

        //wstrcat((char*)call_data.phbNameNumber,(char*)call_data.globalCWInfo.number);

        display_info.TextString2  = (char*)call_data.globalCWInfo.number;
    }
    else
    {
        idwithheld = TRUE;
        display_info.TextId2  = TxtNumberWithheld;
    }
    //GW-SPR#762 - Wrap number/name onto 2nd line (if too long)
    display_info.WrapStrings = WRAP_STRING_2;

    /* NM 26.02.02
       We want to enable the multicall control when we have
       an incoming call. The user is now able to enter any keysequences 
       (like  hold, connect, ..)
    
        // if SettingsKeyPadLockOn->off AND SettingsAnyKeyAnswerOn->on
        // then use all the key events
          if ((FFS_flashData.settings_status & SettingsAnyKeyAnswerOn) AND
            !(FFS_flashData.settings_status & SettingsKeyPadLockOn))
        {
            display_info.KeyEvents    = INFO_KCD_ALL;
        }
        else
        {
            display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_MNUUP |
                           KEY_MNUDOWN|KEY_HUP|KEY_CALL;
        }
    */
    if( FlashEnvironmentData.EnviroProfile[FlashEnvironmentData.CurrentEnv].Anykeyanswerflag )
    { //zy 09/18 
        /*		display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_MNUUP |
                                            KEY_MNUDOWN|KEY_HUP|KEY_CALL|KEY_ALL|KEY_LONG; *//*2004/5/17, wangyan modify*/
        display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_MNUUP |
                                    KEY_MNUDOWN|KEY_HUP|KEY_F3|KEY_VOLUP|KEY_CALL|KEY_ALL|KEY_LONG; 

    }
    else
    {
        display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_HUP|KEY_CALL|KEY_F4|KEY_LONG;//zy 10/22 add KEY_F4 //2004-04-15 Sunny remove KEY_ALL
    }//end of zy 09/18 
    /*if (!ALSPresent(NULL, NULL, NULL))
    {	if (call_data.globalCWInfo.type EQ  VOICE_CALL)
          display_info.TextId       = TxtLine1;
       if (call_data.globalCWInfo.type EQ AuxVOICE_CALL)
          display_info.TextId       = TxtLine2;
    }	zy move 12/23*/

    /*2003/11/12, wangyan, modify call window*/
    /*   if (!ALSPresent(NULL, NULL, NULL))
       {
          switch (GetAlsLine())
          {
          case (MFW_SERV_LINE1):
             TRACE_EVENT("zy:is line1");
             display_info.TextId       = TxtLine1;
             break;
          case (MFW_SERV_LINE2): 
             TRACE_EVENT("zy:is line2");
             display_info.TextId       = TxtLine2;
             break;
          default: 
             break;
          }
       }
       else*//*2003/11/12, wangyan, modify call window*/

    if( call_data.globalCWInfo.type EQ  VOICE_CALL )
        display_info.TextId       = TxtIncomingCall;
    if( call_data.globalCWInfo.type EQ  DATA_CALL )
        display_info.TextId       = TxtIncomingData; // Only to be able to compile.

    if( call_data.globalCWInfo.type EQ  FAX_CALL )
        display_info.TextId       = TxtIncomingFax; //SPR#1147 - DS - changed text id from "Fax" to "Incoming fax".

    display_info.TextString   = '\0';
    display_info.LeftSoftKey  = TxtAccept;
    display_info.RightSoftKey = TxtReject;

    //nm   here should test the hands-free kit !!
    //nm 2.2.00  the detection is not possible now
    //nm     if ((FFS_flashData.settings_status & SettingsAutoAnswerOn) &&
    //nm       Check_HandsFreeKIt() == ACTIV )
    //xsf 2002.07.04   if (FFS_flashData.settings_status & SettingsAutoAnswerOn)
    if( FlashDCTbData.AutoAnswerFlag&&(IsHandsetPlugin()||HallOnOff()) )
    {//zy 2003-05-08 if autoanswer only when halloff andno handsetplugin don't start 3sec 
        //		display_info.Time   = THREE_SECS;
        display_info.Time   = FIVE_SECS;/*2004/4/27, wangyan add*/
    }
    else
    {
        display_info.Time     = FOREVER;
    }

    display_info.Callback     = (T_VOID_FUNC)call_incoming_cb;
    /*
     * Call Info Screen
     */
    //    display_info.BackColor =0x00008b;
    //    display_info.FontColor=0xffffff;
    display_info.Identifier =MMI_INCOMING_CALL_DIALOG_NORMAL;
    display_info.iconindex=groupIcon;
    call_data.handSetKeyDone=0;//zy add 2003-01-28for can accept incomingcall by handsetkey

    setOuterState(OUTERIDLESTATE_INCOMING,1,display_info.TextString2); //2004-03-23 Sunny modify

    call_data.win_incoming = info_dialog (call_data.win, &display_info);
    //   mmi_dialogs_insert_fixmov_animation(call_data.win_incoming, 400,CALLINCOMINGANIM);/*2003/12/8, wangyan modify*/
    //      mmi_dialogs_insert_fixmov_animation (call_data.win_incoming, 700 ,CALLINCOMINGANIM,4);//zy Mobile Innovation add call_Animation
    animnum=0;
    /*       dspl_BitBlt( callIncoming_Attr [0].area.px,callIncoming_Attr [0].area.py,
                       callIncoming_Attr [0].area.sx,callIncoming_Attr [0].area.sy,
                       callIncoming_Attr [0].nIcons,callIncoming_Attr [0].icons,0);*/
}




/*******************************************************************************

 $Function:     call_calling_show

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/




static void call_calling_show (USHORT Identifier)
{

    T_DISPLAY_DATA   display_info;
    MMI_TRACE_EVENT(("call_calling_show"));

    dialog_info_init(&display_info);//gdy add 		
    display_info.TextString2  = NULL;
    display_info.TextId2      = 0;
    Isfromcallwin=1;//zy add 0107/2003
#if(MAIN_LCD_SIZE==3)
     if (call_data.emergencyCall)
        display_info.TextId2  = TxtSOS;
     else
      display_info.TextString2  = (char*)call_data.phbNameNumber;
#endif
    /* MC 11/04/02*/
    display_info.KeyEvents    = KEY_RIGHT | KEY_HUP|KEY_F4;//lxj 09/27 move anyother Key action
    display_info.TextId       = TxtCalling;
    display_info.TextString   = NULL;
    /*   display_info.LeftSoftKey  = '\0';*/
    display_info.LeftSoftKey  = 0;
    display_info.RightSoftKey = TxtEnd;
    display_info.Time         = FOREVER;
    display_info.Callback     = (T_VOID_FUNC)call_calling_cb;
    /* set the user defined identifier */
    display_info.Identifier   = Identifier;
    display_info.BackColor =0x00008b;
    display_info.FontColor=0xffffff;
    //GW-SPR#762 - Wrap number/name onto 2nd line (if too long)
    display_info.WrapStrings = WRAP_STRING_2;
    display_info.iconindex=0;
    /***zy add 11/13****/
    if( call_data.emergencyCall )
        display_info.LeftSoftKey  = TxtSOS;
    else
        display_info.TextString2  = (char*)call_data.phbNameNumber;
    /****end of zy 11/13********/
    switch( Identifier )
    {
    case MMI_OUTGOING_CALL_DIALOG_RINGOFF:
    case MMI_OUTGOING_CALL_SAT_RINGOFF://zy add 2003-04-16 add sat ringoff
        display_info.TextId       = TxtWaitingAnswer;
        call_data.win_calling= info_dialog (call_data.win, &display_info);
        //	mmi_dialogs_insert_fixmov_animation(call_data.win_calling, 400,CALLOUTGOINGANIM);/*2003/12/8, wangyan modify*/

        CALLRINGOFF=1;
        animnum=0;
        /*           dspl_BitBlt( callAlert_Attr [0].area.px,callAlert_Attr  [0].area.py,
                            callAlert_Attr  [0].area.sx,callAlert_Attr  [0].area.sy,
                            callAlert_Attr  [0].nIcons,callAlert_Attr  [0].icons,0);*/
        break;
    default:
        call_data.win_calling= info_dialog (call_data.win, &display_info);
        CALLRINGOFF=2;
        animnum=0;
        /*          dspl_BitBlt( call_Attr [0].area.px,call_Attr   [0].area.py,
                           call_Attr   [0].area.sx,call_Attr   [0].area.sy,
                           call_Attr   [0].nIcons,call_Attr   [0].icons,0);*/
        //      mmi_dialogs_insert_fixmov_animation(call_data.win_calling, 400,CALLOUTGOINGANIM);/*2003/12/8, wangyan modify*/
        break;
    }
}


/*******************************************************************************

 $Function:     call_calling_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void call_calling_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    int i;
    /*
     * Who has initiated the information screen
     */
    TRACE_FUNCTION ("call_calling_cb()");
    call_data.win_calling = 0;
    switch( reason )
    {
    case INFO_TIMEOUT:
        break;
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
    case INFO_KCD_F4://zy 10/22 hall off hangup call

        /* destroy the redial windows if exit*/
        cm_redial_abort();

        if( identifier==MMI_OUTGOING_CALL_SAT_RINGOFF||identifier==MMI_OUTGOING_CALL_DIALOG_SAT )//zy add 2003-04-16 add for all kinds of satcall
        /* in the SAT case, MFW does not know about the call, we therefore
         * need to disconnect the call without using MFW's call table
         */
        {
            satDisc();
            /*begin of zy 2003-04-16 Marcus: Issue 1057: 21/01/2003: Start */
            SEND_EVENT(sat_get_call_setup_win(), SAT_CALL_END, 0, NULL);
            //      SEND_EVENT(sat_get_setup_menu_win(), SAT_RETURN, 0, NULL); 
            /*zy 2003-04-16 If use this word maybe make mem leak
            recreate the SETUP MENU */
            if( sat_get_setup_menu_win() )  //zhaowm 2003.1.6
                SEND_EVENT (sat_get_setup_menu_win(), SAT_EXIT, 0, NULL);
            call_SATCall = FALSE;
            /*end of zy 2003-04-16 Marcus: Issue 1057: 21/01/2003: End */

            call_data.ignore_disconnect = TRUE;
            if( !call_data.calls.numCalls )
            {
                MMI_TRACE_EVENT(("wangyan, call_calling_cb call_destroy"));
                call_destroy(call_data.win);
                return;
            }
        }
        else
        {
            /*2004/04/05,talcon delete*/
            //sprintf(stringTrace,"disconnecting call %d",call_data.outCall);
            //TRACE_EVENT(stringTrace);
            cm_disconnect(call_data.outCall);

            if( !call_data.calls.numCalls )
            {
                call_data.ignore_disconnect = TRUE;
                MMI_TRACE_EVENT(("wangyan, call_calling_cb else call_destroy"));
                call_destroy(call_data.win);
                return;
            }
            if( Isfromcallwin==1&&call_data.calls.mode!=CallConference )
            {/*
zy add 0107/2003 for one call add a new call failure need retrive call 2003-03-14 
but if conference call needn't retrive
*/
                Isfromcallwin=0;
                callNumber((UBYTE *) "1");
                Iscallnumber1=1;//zy add 2003-02-24 Iscallnumber1 is judge if callnumber(1);failed we call make display is hold
            }
            if( Isfromcallwin==1&&call_data.calls.mode==CallConference )
            {/*if is conference call just display "held"*/
                TRACE_EVENT("conferset held and numCalls=");
                TraceInt(call_data.calls.numCalls);
                Isfromcallwin=0;    
                for( i=0;i<call_data.calls.numCalls;i++ )
                {
                    call_data.calls.status[i].stat = CALL_HELD;
                }
            }
            endingCall();
        }
        break;
    case INFO_KCD_LEFT:
        break;
    case INFO_KCD_ALL:    
        /*MC 12.04.02  allows scratchpad to be started when call not yet connected*/
        /* use the DTMF only for single call */
        /*		if (call_data.calls.mode EQ CallNormal ||call_data.calls.mode EQ CallDone ||
                 call_data.calls.mode EQ CallNew  ||call_data.calls.mode EQ CallSingle || call_data.calls.mode EQ NULL)
              {
                 TRACE_FUNCTION("send DTMF");
              
                 call_scratchpad_start(call_data.win,editControls[identifier],ViewDTMF, 0);   
              }
     
              if (call_data.calls.mode EQ CallTwo ||call_data.calls.mode EQ CallConference ||
                 call_data.calls.mode EQ CallPrivateCall  ||call_data.calls.mode EQ CallSingleMultiparty ||call_data.calls.mode EQ CallMultipartySingle)
              {
                 TRACE_FUNCTION("send no DTMF and the keys are able for multicall controll");
                 call_scratchpad_start(call_data.win,editControls[identifier],ViewMulticallControl, ViewMulticallControlCallWaiting);
              }*///lxj move any numkey in callingwin 09/27

        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:     call_menu_end_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void call_menu_end_cb(void)
{
    call_data.win_menu=0;
}


/*******************************************************************************

 $Function:     call_waiting_answer_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void call_waiting_answer_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call * data     = (T_call *)win_data->user;
    /*
     * Who has initiated the information screen
     */
    TRACE_FUNCTION ("call_ending_cb()");

    call_data.win_waiting=0;

    switch( reason )
    {
    call_data.win_waiting=0;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        if( call_data.current_command )
            cm_command_abort(call_data.current_command);
        call_data.current_command = 0;
        callSetMode(ViewConnect);
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:     call_sending_dtmf_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void call_sending_dtmf_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call * data     = (T_call *)win_data->user;
    /*
     * Who has initiated the information screen
     */
    TRACE_EVENT ("call_sending_dtmf_cb()");
    call_data.win_sending_dtmf=0;
    switch( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT: 
    case INFO_KCD_HUP:
        call_data.charSent = 0;
        call_data.sendingDTMF = FALSE;
        cm_command_abort(CM_DTMF_AUTO);
        call_data.current_command = CM_DTMF_AUTO;
        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:     call_ending_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

/*
 * Marcus: Issue 1057: 21/01/2003: Modified this function to use call_acm_max_cb
 * in the call to dlg_initDisplayData_events, and to handle the end of a SAT
 * call is not in the "No credit" situation
 */

void call_ending_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call * data     = (T_call *)win_data->user;
    T_MFW_CM_AOC_INFO aocInfo;
    /*
     * Who has initiated the information screen
     */
    MMI_TRACE_EVENT (("wangyan call_ending_cb()"));
    call_data.win_ending=0;
    //call_data.win_active=0;/*2003/12/16, wangyan modify*/
    switch( reason )
    {
    default:
        endingCall();
        break;
    }
    //MC 17/12/2001
    //check if call ended because ACM>=ACMMAX

    cm_get_aoc_value(CM_AOC_ACMMAX,&aocInfo);

    //Get ACM and ACMMAX
    cm_get_aoc_value(CM_AOC_ACM,&aocInfo);

    //display "No Credit" to user
    if( (aocInfo.acm >= aocInfo.acm_max) &&
        ( aocInfo.acm_max > 0) )
    {
        T_DISPLAY_DATA display_info;
        dialog_info_init(&display_info);//gdy add 

        display_info.TextString  = '\0';
        display_info.TextId2  = TxtCredit;
        TRACE_EVENT("acm_max exceeded");
        display_info.KeyEvents    = KEY_LEFT | KEY_RIGHT;
        display_info.TextId       = TxtNo;
        display_info.TextString   = '\0';
        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = 0;
        display_info.Time         = ONE_SECS;
        display_info.Callback     = (T_VOID_FUNC)NULL;
        info_dialog (call_data.win, &display_info);
        return;
    }/*zy 2003-04-16 checkin*/
    else if( call_SATCall == TRUE )
    {
        call_SATCall = FALSE;
        SEND_EVENT(sat_get_call_setup_win(), SAT_CALL_END, 0, NULL);
        SEND_EVENT(sat_get_setup_menu_win(), SAT_RETURN, 0, NULL); /* recreate the SETUP MENU */
    }
    /*end of zy checkin */

    //2004-03-6 Sunny modify.
    /*	if ((!call_data.calls.numCalls) &&(call_data.win))
        {
            call_destroy(call_data.win);
        MMI_TRACE_EVENT (("wangyan call_ending_cb call_destroy()"));	
    
        }*//*2003/12/15, wangyan add*/
}

/*
 * Marcus: Issue 1057: 21/01/2003: Added the call_acm_max_cb function to handle
 * the end of a SAT call in the "No credit" situation
 */
/*******************************************************************************

 $Function:     call_acm_max_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

void call_acm_max_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    TRACE_FUNCTION ("call_acm_max_cb()");
    if( call_SATCall == TRUE )
    {
        call_SATCall = FALSE;
        SEND_EVENT(sat_get_call_setup_win(), SAT_CALL_END, 0, NULL);
        SEND_EVENT (sat_get_setup_menu_win(), SAT_RETURN, 0, NULL); /* recreate the SETUP MENU */
    }
}

/*******************************************************************************

 $Function:     call_menu_create

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


static T_MFW_HND call_menu_create(MfwHnd parent){

    T_MFW_WIN     * win_data;
    T_call_menu *  data = (T_call_menu *)ALLOC_MEMORY (sizeof (T_call_menu));


    TRACE_FUNCTION ("call_menu_create()");

    data->win = win_create (parent, 0, E_WIN_VISIBLE, (T_MFW_CB)call_menu_win_cb);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)call_menu;
    data->mmi_control.data     = data;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;
    data->parent              =parent;
    /*
     * return window handle
     */

    data->kbd = kbdCreate(data->win,KEY_ALL,(MfwCb)call_menu_kbd_cb);
    data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)call_menu_kbd_long_cb);


    return data->win;



}

/*******************************************************************************

 $Function:     call_menu_destroy

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



static void call_menu_destroy(MfwHnd window){

    T_MFW_WIN     * win_data  = ((T_MFW_HDR *)window)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;

    TRACE_FUNCTION ("call_menu_destroy()");

    if( data )
    {
        call_data.win_menu = 0;
        winDelete (data->win);
        /*     * Free Memory
           */
        FREE_MEMORY ((void *)data, sizeof (T_call_menu));
    }

}


/*******************************************************************************

 $Function:     call_menu_start

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



T_MFW_HND call_menu_start(MfwHnd parent,MfwMnuAttr* menuAttr,T_VOID_FUNC func_cb){


    T_MFW_HND win;
    Isfromcallwin=0;//zy add 0107/2003
    Iscallnumber1=0;//zy zdd 0220/2003 for one call and call new failured need retrive

    win = call_menu_create (parent);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, CALL_INIT, 0, (MfwMnuAttr*) menuAttr);
    }
    return win;



}



/*******************************************************************************

 $Function:     call_menu

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


void call_menu (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_call_menu      * data = (T_call_menu *)win_data->user;
    MfwMnu * mnu;

    TRACE_FUNCTION ("T_call_menu()");

    switch( event )
    {
    case CALL_INIT:
        mnu = (MfwMnu *)mfwControl(data->menu);
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        data->menu = mnuListCreate(data->win,(MfwMnuAttr*)parameter,E_MNU_ESCAPE,(MfwCb)call_menu_mnu_cb,MmiRsrcGetText(TxtCallMenu));
        mnuLang(data->menu,mainMmiLng);
        mnuUnhide(data->menu);
        winShow(data->win);
        break;
    default:
        return;
    }

}

/*******************************************************************************

 $Function:     call_menu_win_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/




static int call_menu_win_cb (MfwEvt e, MfwWin *w){

    T_call_menu * data = (T_call_menu *)w->user;
    UINT32 oldfontcolor;
    UINT32 oldbkgcolor; 



    TRACE_FUNCTION ("call_menu_win_cb()");
    switch( e )
    {
    case MfwWinVisible:
        dspl_ClearAll();
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
        controlBrowseNew();
        break;
    default:
        return 0;
    }

    return 1;

}


/*******************************************************************************

 $Function:     call_menu_kbd_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



static int call_menu_kbd_cb (MfwEvt e, MfwKbd *k){


    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;

    TRACE_FUNCTION ("call_menu_kbd_cb()");


    switch( k->code )
    {
    case KCD_MNUUP:
        mnuUp(data->menu);
        //      winShow(win);
        break;
    case KCD_MNUDOWN:
        mnuDown(data->menu);
        //     winShow(win);
        break;
    case KCD_LEFT:
    case KCD_OK://zy add 2003-02-25 keyok is same function with keyleft
        mnuSelect(data->menu);
        break;
    case KCD_RIGHT:
    case KCD_HUP:
        mnuEscape(data->menu);
        break;
    case KCD_1://2004-03-5 Sunny add.
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        mnuKeyAction(data->menu,k->code);
        break;//2004-03-5 Sunny add end.
    default:
        return MFW_EVENT_CONSUMED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:     call_menu_kbd_long_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/




static int call_menu_kbd_long_cb (MfwEvt e, MfwKbd *k){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;


    if( (e & KEY_CLEAR) && (e & KEY_LONG) )
    {
        mnuEscape(data->menu);
        return MFW_EVENT_CONSUMED;
    }
    return  MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:     call_menu_mnu_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



static int call_menu_mnu_cb (MfwEvt e, MfwMnu *m){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_menu * data = (T_call_menu *)win_data->user;

    TRACE_FUNCTION ("call_menu_mnu_cb()");

    switch( e )
    {
    case E_MNU_ESCAPE:
        call_menu_destroy(win);
        call_data.win_menu = 0;
        break;
    default:
        return 0;
    }
    return 1;
}




/*******************************************************************************

 $Function:     call_scratchpad_create

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


T_MFW_HND call_scratchpad_create (T_MFW_HND parent_window)
{
    T_MFW_WIN     * win;
    T_call_scratchpad *  data = (T_call_scratchpad *)ALLOC_MEMORY (sizeof (T_call_scratchpad));



    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)call_scratchpad_win_cb);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)call_scratchpad;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
    * Create any other handler
    */

    memset( (void *) call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
    //bookSetEditAttributes(0,112,120,32,0,0,edtCurBar1,0,(char*)call_data.edtBufDTMF,EDITOR_SIZE,&call_data.edtAttrDTMF);

    //data->edt      = edtCreate  (data->win,&call_data.edtAttrDTMF,MfwEdtVisible,0);
    data->kbd      = kbd_create (data->win,KEY_ALL|KEY_F4,(T_MFW_CB)call_scratchpad_kbd_cb);
    data->kbd_long = kbd_create (data->win,KEY_ALL|KEY_LONG,(T_MFW_CB)call_scratchpad_kbd_long_cb);



    /*
     * return window handle
     */
    return data->win;
}





/*******************************************************************************

 $Function:     call_scratchpad_destroy

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

void call_scratchpad_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win;
    T_call_scratchpad        * data;

    if( own_window )
    {
        win  = ((T_MFW_HDR *)own_window)->data;
        data = (T_call_scratchpad *)win->user;

        if( data )
        {
            /*
             * Exit Keyboard Handler
             */
            /*
             * Delete WIN Handler
             */
            win_delete (data->win);
            FREE_MEMORY ((void *)data, sizeof (T_call_scratchpad));
        }

        call_data.win_scratch=0;
        call_data.charSent = 0;
    }
    memset(extnum,'\0',sizeof(extnum));
}


/*******************************************************************************

 $Function:     call_scratchpad_start

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


T_MFW_HND call_scratchpad_start (T_MFW_HND win_parent,char character,UBYTE mode, UBYTE callstatus)
{
    T_MFW_WIN       *win_data;
    T_call_scratchpad         * data;


    T_MFW_HND win = call_scratchpad_create (win_parent);


    if( win NEQ NULL )
    {
        win_data = ((T_MFW_HDR *) win)->data;
        data = (T_call_scratchpad *)win_data->user;
        data->mode = mode;
        data->callstatus = callstatus;
        SEND_EVENT(win,CALL_SCRATCHPAD_INIT,0,(char*)character);
    }
    return win;

}




/*******************************************************************************

 $Function:     call_scratchpad

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

void call_scratchpad (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_call_scratchpad         * data = (T_call_scratchpad *)win_data->user;
    int i;
    int ok;
    int die=0;
    TRACE_FUNCTION ("call_scratchpad()");
    switch( event )
    {
    case CALL_SCRATCHPAD_INIT:
        memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
        //edtUnhide(data->edt);
        if( data->mode EQ ViewDTMFAuto )
        {
            // wstrcpy(call_data.edtAttrDTMF.text,(char *)extnum);
            wstrcpy(call_data.edtBufDTMF,(char *)extnum);
            //edtShow(data->edt);
            //edtChar(data->edt,ecBottom);
            sendDTMFString();
            /*  for( i=0;i<strlen(extnum);i++)
              {
               die=0;
               do
                {
                 ok=cm_command(call_data.calls.selected,CM_DTMF_AUTO,(UBYTE)extnum[i]);
               call_data.current_command = CM_DTMF_AUTO;
                die++;
                zgzTraceDataFunc("zy:dtmf die=", (unsigned short) die);
                zgzTraceDataFunc("zy:dtmf i=", (unsigned short) i);
                zgzTraceDataFunc("zy:dtmf ok=", (unsigned short) ok);
                 }
                while(ok==FALSE&&die<10);
                }*/
        }
        else
        {
            //  edtChar(data->edt,(char)parameter);
            // edtChar(data->edt,ecRight);
            if( data->mode EQ ViewDTMF )
            {
                //TRACE_EVENT("zy:mode:viewDTMF");
                call_data.edtBufDTMF[0]=(char)parameter;
                //cm_command(call_data.calls.selected,CM_DTMF_AUTO,(UBYTE)call_data.edtBufDTMF[0]);
                sendDTMFString();
                call_data.current_command = CM_DTMF_AUTO;
            }
            else if( data->mode EQ ViewMulticallControl )
            {
                call_data.edtBufDTMF[0]=(char)parameter;
            }
        }
        winShow(data->win);
        break;
        /*
         zy add 2003-02-14 add this case for low voltage win begin should destroy this win first
        */
    case CALL_SCRATCHPAD_DESTROY:
        call_scratchpad_destroy(call_data.win_scratch);
        call_data.win_scratch =0;  
        break;
        /*
        end of zy add 2003-02-14 add this case for low voltage win begin should destroy this win first
        */
    default:
        return;
    }
}




/*******************************************************************************

 $Function:     call_scratchpad_win_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

static int call_scratchpad_win_cb (MfwEvt e, MfwWin *w)
{
    T_call_scratchpad         * data = (T_call_scratchpad *)w->user;
    UINT32 oldbkgcolor;
    game_Line param;

    TRACE_FUNCTION ("call_scratchpad_win_cb()");
    switch( e )
    {
    case MfwWinVisible:
        // dspl_ClearAll();
        // edtShow(data->edt);
        if( data->mode==ViewMulticallControl )
        {
            //2004-03-4 Sunny change the y-coordirate frome 10 t0 16			
            ALIGNED_PROMPT(CENTER, 16, 0, TxtAddNewCall);//jhxu720 modify
        }/*zy 2003-03-12 when dial new call display Txtaddnewcall*/
#if (MAIN_LCD_SIZE==3)//jhxu720
		oldbkgcolor=dspl_GetBkgColor();
		dspl_SetBkgColor(0xE5DBCD);
		dspl_Clear(1, 40, SCREEN_SIZE_X, 64);//shiheng scratch
		param.color=0xffffff;
		param.x1=0;
		param.x2=0;
		param.y1=40;
		param.y2=63;
		DrawLine(param);
		param.color=0xffffff;
		param.x1=0;
		param.x2=SCREEN_SIZE_X;
		param.y1=40;
		param.y2=40;
		DrawLine(param);
		param.color=0xffffff;
		param.x1=SCREEN_SIZE_X-1;
		param.x2=SCREEN_SIZE_X-1;
		param.y1=40;
		param.y2=63;
		DrawLine(param);
		param.color=0xffffff;
		param.x1=0;
		param.x2=SCREEN_SIZE_X-1;
		param.y1=63;
		param.y2=63;
		DrawLine(param);
		param.color=0xF8F5F1;
		param.x1=0;
		param.x2=SCREEN_SIZE_X-1;
		param.y1=52;
		param.y2=52;
		DrawLine(param);
		param.color=0xF8F5F1;
		param.x1=0;
		param.x2=SCREEN_SIZE_X-1;
		param.y1=54;
		param.y2=54;
		drawcolorclarity(0, 40,(char *) call_data.edtBufDTMF,0x000000);
		dspl_SetBkgColor(oldbkgcolor);
#elif ( MAIN_LCD_SIZE==4 )
        oldbkgcolor=dspl_GetBkgColor();
        dspl_SetBkgColor(0xE5DBCD);

        /* 2004/06 sunsj modify for picture manage */
        DRAW_ICON(ICON_CALLING_TEXTPAD);
        //dspl_BitBlt(0, 110, 128, 32, 0, (void *)call_scratchpad_bgicon, 0);	

        drawcolorclarity(0, 110,(char *) call_data.edtBufDTMF,0x000000);
        dspl_SetBkgColor(oldbkgcolor);
#elif ( MAIN_LCD_SIZE==2 )
        oldbkgcolor=dspl_GetBkgColor();
        dspl_SetBkgColor(0xE5DBCD);
        dspl_Clear(1, 40, SCREEN_SIZE_X, 64);
        param.color=0xffffff;
        param.x1=0;
        param.x2=0;
        param.y1=40;
        param.y2=63;
        DrawLine(param);
        param.color=0xffffff;
        param.x1=0;
        param.x2=SCREEN_SIZE_X;
        param.y1=40;
        param.y2=40;
        DrawLine(param);
        param.color=0xffffff;
        param.x1=SCREEN_SIZE_X-1;
        param.x2=SCREEN_SIZE_X-1;
        param.y1=40;
        param.y2=63;
        DrawLine(param);
        param.color=0xffffff;
        param.x1=0;
        param.x2=SCREEN_SIZE_X-1;
        param.y1=63;
        param.y2=63;
        DrawLine(param);
        param.color=0xF8F5F1;
        param.x1=0;
        param.x2=SCREEN_SIZE_X-1;
        param.y1=52;
        param.y2=52;
        DrawLine(param);
        param.color=0xF8F5F1;
        param.x1=0;
        param.x2=SCREEN_SIZE_X-1;
        param.y1=54;
        param.y2=54;
        drawcolorclarity(0, 40,(char *) call_data.edtBufDTMF,0x000000);
        dspl_SetBkgColor(oldbkgcolor);
#endif
        displaySoftKeys(TxtSoftCall,TxtDelete);//MC
        break;
    default:
        return 0;
    }

    return 1;
}



/*******************************************************************************

 $Function:     call_scratchpad_kbd_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/


static int call_scratchpad_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_scratchpad         * data = (T_call_scratchpad *)win_data->user;

    int position=0;
    UBYTE callstatus = data->callstatus;
    char addkey[2];
    TRACE_FUNCTION ("call_scratchpad_kbd_cb()");


    switch( data->mode )
    {
    
    case ViewDTMFAuto:
        switch( k->code )
        {
        case KCD_F4:
            //  	TRACE_EVENT("zy:KCD_F4 in mmicall");
            //  	TraceInt((int)KCD_F4);zy 10/22
            if( IsHandsetPlugin()&&(!HallStatus()) )
            {
                TRACE_EVENT("handsetplugin and hall is off")
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                //         winShow(data->win);
                call_scratchpad_destroy(data->win);
                return 1; 
            }
            if( !HallStatus() )
            {
                /* memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
          //         winShow(data->win);
                   call_scratchpad_destroy(data->win);*/
                switch( call_data.calls.mode )
                {
                case CallMultipartySingle:
                case CallSingleMultiparty:
                case CallConference:
                    endConferSingleExec(0, 0);
                    break;
                default:
                    endAllExec(0, 0);
                    break;
                }
            }
            break;     
        case KCD_0:
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
        case KCD_STAR:
        case KCD_HASH:
            if( wstrlen(call_data.edtBufDTMF)>=30 )
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            addkey[0]=editControls[k->code];
            addkey[1]='\0';
            wstrcat(call_data.edtBufDTMF,(char *)addkey);
            call_data.current_command = CM_DTMF_AUTO;
            sendDTMFString();
            break;
        case KCD_HUP:
            //   edtChar(data->edt, ecBack);
            /*     call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='\0';
               if (call_data.edtBufDTMF[0]=='\0')
                 call_scratchpad_destroy(data->win);*///zy move 11/13
            memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            //          winShow(data->win);
            call_scratchpad_destroy(data->win);
            return 1;
            break;             

        case KCD_RIGHT://MC adding delete key
            //TRACE_EVENT("zy;dtmf kcdright");
            //	edtChar(data->edt, ecBack);
            call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='\0';
            if( strlen(call_data.edtBufDTMF) <= 0 )
            {
                call_scratchpad_destroy(data->win);
                //		        dspl_Enable(1);		
                return 1;
            }
            break;
            /*............................zy add 08/29........................................*/
        case KCD_VOLUP:
            TRACE_EVENT("call kcd_volup");        
            if( IsHandsetPlugin()&&(!HallStatus()) )
                AdjustSpkHandsetHallOff_VolUp();
            else
            {
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                call_scratchpad_destroy(data->win);
                AdjustSpk_VolUp();
            }
            break;
        case KCD_VOLDOWN:
            TRACE_EVENT("call kcd_volDown");
            if( IsHandsetPlugin()&&(!HallStatus()) )
                AdjustSpkHandsetHallOff_VolDown();
            else
            {
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                call_scratchpad_destroy(data->win);
                AdjustSpk_VolDown();
            }
            break;
            /*.............................end of zy change............................*/
        default:
            break;
        }
        break;
    case ViewDTMF:
        switch( k->code )
        {
        case KCD_F4:
            //  	TRACE_EVENT("zy:KCD_F4 in mmicall");
            //  	TraceInt((int)KCD_F4);zy 10/22
            if( IsHandsetPlugin()&&(!HallStatus()) )
            {
                TRACE_EVENT("handsetplugin and hall is off")
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                //      winShow(data->win);
                call_scratchpad_destroy(data->win);
                return 1; 
            }
            if( !HallStatus() )
            {
                /*	  memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
               //       winShow(data->win);
                      call_scratchpad_destroy(data->win);*/
                switch( call_data.calls.mode )
                {
                case CallMultipartySingle:
                case CallSingleMultiparty:
                case CallConference:
                    endConferSingleExec(0, 0);
                    break;
                default:
                    endAllExec(0, 0);
                    break;
                }
            }
            break;     
        case KCD_0:
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
        case KCD_STAR:
        case KCD_HASH:
            //  edtChar(data->edt, editControls[k->code]);
            // edtChar(data->edt,ecRight);
            // wstrcpy(call_data.edtBufDTMF,(char *)extnum);
            // cm_command(call_data.calls.selected,CM_DTMF_AUTO,(UBYTE)editControls[k->code]);
            if( strlen(call_data.edtBufDTMF)>=30 )
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            addkey[0]=editControls[k->code];
            addkey[1]='\0';
            wstrcat(call_data.edtBufDTMF,(char *)addkey);
            // wstrcpy(call_data.edtAttrDTMF.text,call_data.edtBufDTMF);
            //edtShow(data->edt);
            //edtChar(data->edt,ecBottom);
            //sendDTMFString();
            //       zgzTraceDataFunc("zy:dtmfviewkey:",(UBYTE)call_data.edtBufDTMF);
            call_data.current_command = CM_DTMF_AUTO;

            sendDTMFString();
            //        winShow(data->win);zy move this function "winshow"s 2003-02-14 only show at end of this function
            break;
        case KCD_HUP:
            //   edtChar(data->edt, ecBack);
            /*   call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='\0';
               if (call_data.edtBufDTMF[0]=='\0')
                 {
                 call_scratchpad_destroy(data->win);
                         return 1;
               }*///zy move 11/12

            memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            //        winShow(data->win);
            call_scratchpad_destroy(data->win);
            return 1;
            break;
        case KCD_CALL:
        case KCD_LEFT:
            /*			if(call_data.edtBufDTMF[0]== '*' )	
                            ss_execute_transaction((UBYTE*)call_data.edtBufDTMF,0);
                        else */
            callNumber((UBYTE*)call_data.edtBufDTMF);
            call_scratchpad_destroy(win);

            //        dspl_Enable(1);
            return 1;
            break;
        case KCD_RIGHT://MC adding delete key
            //TRACE_EVENT("zy;dtmf kcdright");
            //	edtChar(data->edt, ecBack);
            call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='\0';
            if( strlen(call_data.edtBufDTMF) <= 0 )
            {
                call_scratchpad_destroy(data->win);
                //		        dspl_Enable(1);		
                return 1;
            }
            break;
            /*............................zy add 08/29........................................*/
        case KCD_VOLUP:
            TRACE_EVENT("call kcd_volup");
            if( IsHandsetPlugin()&&(!HallStatus()) )
                AdjustSpkHandsetHallOff_VolUp();
            else
            {
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                call_scratchpad_destroy(data->win);
                AdjustSpk_VolUp();
            }
            break;
        case KCD_VOLDOWN:
            TRACE_EVENT("call kcd_volDown");
            if( IsHandsetPlugin()&&(!HallStatus()) )
                AdjustSpkHandsetHallOff_VolDown();
            else
            {
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                call_scratchpad_destroy(data->win);
                AdjustSpk_VolDown();
            }
            break;
            /*......................end of zy change.....................................*/
        default:
            break;
        }
        break;
    case ViewScratchPad:
        switch( k->code )
        {
        case KCD_F4:
            //  	TRACE_EVENT("zy:KCD_F4 in mmicall");
            //  	TraceInt((int)KCD_F4);zy 10/22
            if( IsHandsetPlugin()&&(!HallStatus()) )
            {
                TRACE_EVENT("handsetplugin and hall is off")
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                //     winShow(data->win);
                call_scratchpad_destroy(data->win);
                return 1; 
            }
            if( !HallStatus() )
            {
                /*	  memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                //      winShow(data->win);
                      call_scratchpad_destroy(data->win);*/
                switch( call_data.calls.mode )
                {
                case CallMultipartySingle:
                case CallSingleMultiparty:
                case CallConference:
                    endConferSingleExec(0, 0);
                    break;
                default:
                    endAllExec(0, 0);
                    break;
                }
            }
            break;     
        case KCD_0:
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
        case KCD_STAR:
        case KCD_HASH:
            //  edtChar(data->edt, editControls[k->code]);
            if( strlen(call_data.edtBufDTMF)>=30 )
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            addkey[0]=editControls[k->code];;
            addkey[1]='\0';
            wstrcat(call_data.edtBufDTMF,(char *)addkey);
            //     wstrcpy(call_data.edtAttrDTMF.text,call_data.edtBufDTMF);
            break;
        case KCD_HUP:
            memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            //          winShow(data->win);
            call_scratchpad_destroy(data->win);
            return 1;
            break;
        case KCD_LEFT:
            sendDTMFString();
            break;
        case KCD_RIGHT:
            memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
            //          winShow(data->win);
            call_scratchpad_destroy(data->win);
            return 1;
            break;
            /*............................zy add 08/29........................................*/
        case KCD_VOLUP:
            TRACE_EVENT("call kcd_volup");
            if( IsHandsetPlugin()&&(!HallStatus()) )
                AdjustSpkHandsetHallOff_VolUp();
            else
            {
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                call_scratchpad_destroy(data->win);
                AdjustSpk_VolUp();
            }
            break;
        case KCD_VOLDOWN:
            TRACE_EVENT("call kcd_volDown");
            if( IsHandsetPlugin()&&(!HallStatus()) )
                AdjustSpkHandsetHallOff_VolDown();
            else
            {
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                call_scratchpad_destroy(data->win);
                AdjustSpk_VolDown();
            }
            break;
            /*......................end of zy change.....................................*/
        default:
            break;
        }
        break;
    case ViewMulticallControl:
        {
            TRACE_FUNCTION ("ViewMulticallControl()");
            switch( k->code )
            {
            case KCD_F4:
                //  	TRACE_EVENT("zy:KCD_F4 in mmicall");
                //  	TraceInt((int)KCD_F4);zy 10/22
                if( IsHandsetPlugin()&&(!HallStatus()) )
                {
                    TRACE_EVENT("handsetplugin and hall is off")
                    memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                    //   winShow(data->win);
                    call_scratchpad_destroy(data->win);
                    return 1; 
                }
                if( !HallStatus() )
                {
                    /*	  memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                       //   winShow(data->win);
                          call_scratchpad_destroy(data->win);*/
                    switch( call_data.calls.mode )
                    {
                    case CallMultipartySingle:
                    case CallSingleMultiparty://zy 2003-03-13 these two case all should be end all call
                    case CallConference:
                        endConferSingleExec(0, 0);
                        break;
                    default:
                        endAllExec(0, 0);
                        break;
                    }
                }
                break;   
            case KCD_0:
            case KCD_1:
            case KCD_2:
            case KCD_3:
            case KCD_4:
            case KCD_5:
            case KCD_6:
            case KCD_7:
            case KCD_8:
            case KCD_9:
            case KCD_STAR:
            case KCD_HASH:
                //edtUnhide(data->edt);
                //edtChar(data->edt, editControls[k->code]);
                //edtChar(data->edt,ecRight);
                if( wstrlen(call_data.edtBufDTMF)>=30 )
                    memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                addkey[0]=editControls[k->code];
                addkey[1]='\0';
                wstrcat(call_data.edtBufDTMF,(char *)addkey);
                //   wstrcpy(call_data.edtAttrDTMF.text,call_data.edtBufDTMF);
                break;
            case KCD_MNUUP:
                //   edtChar(data->edt,ecRight);
                break;
            case KCD_MNUDOWN:
                //	edtChar(data->edt,ecLeft);
                break;
            case KCD_CALL:
            case KCD_LEFT:
                /*MC 12/04/02 Check for ECT string  and display appropriate waiting screen*/
                if( call_data.edtBufDTMF[0]== '4' && strlen(call_data.edtBufDTMF) == 1 )
                {
                    call_data.current_command = CM_ETC;
                    callSetMode(ViewWaitingAnswer);
                }
                //cm_mo_call((UBYTE*)call_data.edtBufDTMF, VOICE_CALL);zy 11/13move
                /*****************zy add 11/13*****************************/
                /*				if(call_data.edtBufDTMF[0]== '*' )	
                                    ss_execute_transaction((UBYTE*)call_data.edtBufDTMF,0);
                                else */
                callNumber((UBYTE*)call_data.edtBufDTMF);
                //callNumber((UBYTE*)call_data.edtBufDTMF);
                call_scratchpad_destroy(win);
                return 1;
                break;
            case KCD_RIGHT:
                TRACE_EVENT ("press right");
                call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='\0';
                if( strlen(call_data.edtBufDTMF) <= 0 )
                {
                    call_scratchpad_destroy(data->win);
                    //		        dspl_Enable(1);		
                    return 1;
                }
                /*	if (wstrlen(call_data.edtBufDTMF) > 0)
                   {
                      //edtChar(data->edt, ecBack);
                      call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='\0';
                   }
                   else
                   {
                      TRACE_EVENT ("now destroy");
                      call_scratchpad_destroy(data->win);
                      //data = NULL;
                   }*///zy move 11/13
                break;
            case KCD_HUP:
                memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                //           winShow(data->win);
                call_scratchpad_destroy(data->win);
                return 1;
                break;
                /*............................zy add 08/29........................................*/
            case KCD_VOLUP:
                TRACE_EVENT("call kcd_volup");
                if( IsHandsetPlugin()&&(!HallStatus()) )
                    AdjustSpkHandsetHallOff_VolUp();
                else
                {
                    memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                    call_scratchpad_destroy(data->win);
                    AdjustSpk_VolUp();
                }
                break;
            case KCD_VOLDOWN:
                TRACE_EVENT("call kcd_volDown");
                if( IsHandsetPlugin()&&(!HallStatus()) )
                    AdjustSpkHandsetHallOff_VolDown();
                else
                {
                    memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
                    call_scratchpad_destroy(data->win);
                    AdjustSpk_VolDown();
                }
                break;
                /*............................end of zy add 08/29........................................*/
            default:
                break;
            }


            /* if true, call the incoming call screen back on the screen because it
              was destroyed by the scratchpad function */
            if( callstatus EQ ViewMulticallControlIncomingCall && data EQ NULL )
            {
                TRACE_EVENT ("call the incoming call screen back on the screen");
                incomingCall(&call_data.globalCWInfo);
            }
        }
        break;
    default:
        break;
    }
    //          dspl_Enable(1);
    winShow(data->win);

    return MFW_EVENT_CONSUMED;
}





/*******************************************************************************

 $Function:     call_scratchpad_kbd_long_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

static int call_scratchpad_kbd_long_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call_scratchpad         * data = (T_call_scratchpad *)win_data->user;
    if( wstrlen(call_data.edtBufDTMF)<=0 )
    {
        memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
        return MFW_EVENT_PASSED;
    }
    if( wstrlen(call_data.edtBufDTMF)>30 )
    {
        memset(call_data.edtBufDTMF,'\0',sizeof(call_data.edtBufDTMF));
        return MFW_EVENT_PASSED;
    }
    if( e & KEY_LONG )
    {
        {
            /*  if (e & KEY_CLEAR)
              {
              call_scratchpad_destroy(data->win);
              return MFW_EVENT_CONSUMED;
              }zy 2003-03-21 seemed no use,zy 2003-03-21 make o and # can be use*/
            if( e & KEY_0 )
            {
                call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='+';
                winShow(data->win);
                return MFW_EVENT_CONSUMED;
            }
            if( e & KEY_HASH )
            {
                call_data.edtBufDTMF[strlen(call_data.edtBufDTMF)-1]='p';
                winShow(data->win);
                return MFW_EVENT_CONSUMED;
            }
        }
    }
    return MFW_EVENT_PASSED;
}

UBYTE call_status(void){
    return call_data.callStatus;
}
/*******************************************************************************

 $Function:     call_failure_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/
void call_failtryagain_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    switch( reason )
    {
    case INFO_TIMEOUT:
        callNumber(FlashDCTbData.LDNTable[0]);
        notavailtryone=0;
        break;
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        if( !call_data.calls.numCalls )
        {
            if( call_data.win )
            {
                MMI_TRACE_EVENT (("wangyan call_failtryagain_cb call_destroy()"));  
                call_destroy(call_data.win);
            }
        }


        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:     call_failure_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

void call_failure_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_call * data     = (T_call *)win_data->user;
    int i;
    /*
     * Who has initiated the information screen
     */
    TRACE_FUNCTION ("call_failure_cb()");
    switch( reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_HUP:
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
        if( !call_data.calls.numCalls )
        {
            if( call_data.win )
            {
                MMI_TRACE_EVENT (("wangyan call_failure_cb call_destroy()"));   
                call_destroy(call_data.win);
            }
            return;
        }
        /* if (sAT_PlusCHLD(CMD_SRC_LCL, CHLD_MOD_HldActDial, 0)  NEQ AT_EXCT)
    {
     TRACE_EVENT("sAT_PlusCHLD(CMD_SRC_LCL, CHLD_MOD_RelActAndAcpt, 0)  error");
    }*/
        else if( call_data.win&&Isfromcallwin==1&&call_data.calls.mode!=CallConference )
        {/*
zy 2003-03-14 fi is conferencecall don't retrive
*/

            //callNumber((UBYTE *)"2");
            // callNumber((UBYTE *)"12");
            /*set these AT command sometimes will make callmode confused
            if AT command set failured zy 2003-03-21
            */
            call_data.calls.status[callIndex(call_data.calls.selected)].stat =CALL_HELD;
            Isfromcallwin=0;//zy 2003-02-24 active indeed hold
            Iscallnumber1=0;//zy 2003-02-24 active indeed hold
        }
        else if( call_data.win&&Isfromcallwin==1&&call_data.calls.mode==CallConference )
        /*if is conference call display "held"*/
        {
            TRACE_EVENT("conferset held and numCalls=");
            TraceInt(call_data.calls.numCalls);                      
            Isfromcallwin=0;    
            for( i=0;i<call_data.calls.numCalls;i++ )
            {
                TRACE_EVENT("call_data.calls.status[i].stat=");
                TraceInt(call_data.calls.status[i].stat);
                call_data.calls.status[i].stat = CALL_HELD;
            }

        }
        if( call_data.win )
            winShow(call_data.win);/*after these stat changed should winshow again*/
        break;
    default:
        break;
    }

    /*zy 2003-04-16 checkin SPR#1779 - DS - If failed call was a SAT call, clean up SAT */
    if( call_SATCall == TRUE )
    {
        call_SATCall = FALSE;
        SEND_EVENT(sat_get_call_setup_win(), SAT_CALL_END, 0, NULL);

        /* May be necessary to reinstate if there is no call result editor sent from SAT */
        //SEND_EVENT(sat_get_setup_menu_win(), SAT_RETURN, 0, NULL); /* recreate the SETUP MENU */
    }
    /*end of zy checkin 2003-04-16*/
}

/*******************************************************************************

 $Function:     call_get_window

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/



MfwHnd call_get_window(void){
    return call_data.win;
}



/*******************************************************************************

 $Function:     showCCNotify

 $Description:  Show result from E_CC_NOTIFY being returned. Short cc-related
            notification window.

 $Returns:

 $Arguments:
*******************************************************************************/


static void showCCNotify (T_MFW_HND win, T_MFW_CM_NOTIFY  * cc_notify)
{
    T_DISPLAY_DATA   display_info;

    TRACE_FUNCTION("++ showCCNotify");

    dialog_info_init(&display_info);//gdy add 
    display_info.TextId       = 0;
    display_info.TextId2      = 0;

    switch( cc_notify->notification )
    {
    case MFW_CM_HOLD:
        display_info.TextId       = TxtSoftCall;
        display_info.TextId2      = TxtHold;
        break;

    case MFW_CM_RETRIEVED:
        display_info.TextId       = TxtSoftCall;
        display_info.TextId2      = TxtUnhold;
        break;

    default:
        break;
    }

    if( display_info.TextId NEQ 0 )
    {

        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = '\0';
        display_info.TextString   = '\0';
        display_info.TextString2   = '\0';
        display_info.Time         = ONE_SECS;
        display_info.Identifier   = E_CM_NOTIFY;
        display_info.Callback     = (T_VOID_FUNC)call_info_cb;
        display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

        /*
         * Call Info Screen
         */

        info_dialog (win, &display_info);
    }
}

/*******************************************************************************

 $Function:     call_info_cb

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

void call_info_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    TRACE_FUNCTION ("call_info_cb()");
}



/*******************************************************************************

 $Function:     SaveVolumeSetting

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

static void SaveVolumeSetting (void)
{

    //FFS_flashData.output_volume = currentVolume;
    flash_write();
}

/*******************************************************************************

 $Function:     StartsendDTMFString

 $Description:

 $Returns:

 $Arguments:
*******************************************************************************/

void StartsendDTMFString(char * String)
{

    wstrcpy (call_data.edtBufDTMF, String );
    call_data.charSent = 0;
    call_data.sendingDTMF = TRUE;
    callSetMode(ViewSendingDTMF);
    sendDTMFString();

}

/*******************************************************************************

 $Function:  menuInCallTimerOn

 $Description: Handles user selection of the "on" option in the In-call Timer menu

 $Returns:  status int

 $Arguments:  not used
*******************************************************************************/
int menuInCallTimerOn(MfwMnu* m, MfwMnuItem* i)
{T_MFW_HND win =  mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;

    int j;

    /*FFS_flashData.*/InCallTimer = TRUE;
    flash_write();

    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = TxtInCallTimer;
    display_info.TextId2      = TxtActivated;
    display_info.TextString     = '\0';
    display_info.TextString2    = '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtNull;
    display_info.Time           = ONE_SECS;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( win, &display_info );

    return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:  menuInCallTimerOff

 $Description: Handles user selection of the "off" option in the In-call Timer menu

 $Returns:  status int

 $Arguments:  not used
*******************************************************************************/
int menuInCallTimerOff(MfwMnu* m, MfwMnuItem* i)
{T_MFW_HND win =  mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;

    int j;

    /*FFS_flashData.*/InCallTimer = FALSE;
    flash_write();

    dialog_info_init(&display_info);//gdy add 
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = TxtInCallTimer;
    display_info.TextId2      = TxtDeActivated;
    display_info.TextString     = '\0';
    display_info.TextString2    = '\0';
    display_info.LeftSoftKey    = TxtNull;
    display_info.RightSoftKey   = TxtNull;
    display_info.Time           = ONE_SECS;
    display_info.Callback       = (T_VOID_FUNC) NULL;

    /* Call Info Screen
    */
    info_dialog( win, &display_info );

    return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:  StartAutoDtmf

 $Description: when 'p' dial extent number auto

 $Returns:  null

 $Arguments:  
*******************************************************************************/
void StartAutoDtmf(void)
{
    call_data.win_scratch=call_scratchpad_start(call_data.win,NULL,ViewDTMFAuto, 0);           

}

/**********************hu binhao 2002-11-20********************************************

 $Function:  saveNumCallRecord

 $Description: write last number and time to flash according the callrecordtype
               glowing: 2003-10-22
               in order to remove the menuitem "ܽӵ绰", all the "reject number" 
               add to "received number", so comment the statements of the case 'J'
               
 $Returns:  null
 $Arguments: char callrecordtype
             case 'M': missed number
             case 'J': reject number
             case 'R'; received number
             case 'D'  dialed   number
*******************************************************************************/
//static void saveNumCallRecord(char callrecordtype,const char* num ) //hubinhao 2002-11-20

static void saveNumCallRecord(char callrecordtype, char* num, uint8 IsfindNumRes,uint8 SRFlag,T_FindName  * searchdata) //hubinhao 2002-11-20
{
    UBYTE n,m,len,avail;
    int year,month,day,hour,min,sec,i;
    char    time[   50];

    len=wstrlen(num);  //hu binhao 1
    if( len>23 )
    {
        num[23]='\0';

    }
    TRACE_FUNCTION("saveNumCallRecord");

    CallListFlag=1; //hu binhao 2003-1-21
    if( len!=0 )
    {
        switch( callrecordtype )
        {
        case 'M':  //δӵ绰
            n=FlashDCTbData.LMNID;
            break;
        case 'J':  //ܽӵ绰
#if 0
            n=FlashDCTbData.LJNID;
            break;
#endif
        case 'R':  //ѽӵ绰
            n=FlashDCTbData.LRNID;
            break;
        case 'D':  //Ѳ绰
            n=FlashDCTbData.LDNID;
            break;
        }


        m=0;
        avail=1;  // 1 new number
        month=timedate.month;
        day=timedate.day;
        hour=timedate.hour;
        min=timedate.minute;
        sec=timedate.second;
        while( avail==1 AND m<n )
        {
            switch( callrecordtype )
            {
            case 'M': 
                //if(strstr((char*)FlashDCTbData.LMNTable[m],num)!=NULL)
                //if(strcmp((char*)FlashDCTbData.LMNTable[m],num)==0)   //hubinhao 2002-12-25 for 3131
                //avail=0;
                //2003-4-25 for optimization
                if( GetShortNumber((char *)FlashDCTbData.LMNTable[m])==GetShortNumber((char *)num) )
                {
                    if( strcmp((char*)FlashDCTbData.LMNTable[m],num)==0 )
                    {
                        avail=0;
                    }
                }


                break;
            case 'J':
#if 0
                //if(strstr((char*)FlashDCTbData.LJNTable[m],num)!=NULL)
                //if(strcmp((char*)FlashDCTbData.LJNTable[m],num)==0)   //hubinhao 2002-12-25 for 3131
                //avail=0;
                if( GetShortNumber((char *)FlashDCTbData.LJNTable[m])==GetShortNumber((char *)num) )
                {
                    if( strcmp((char*)FlashDCTbData.LJNTable[m],num)==0 )
                    {
                        avail=0;
                    }
                }
                break;
#endif
            case 'R':
                //if(strstr((char*)FlashDCTbData.LRNTable[m],num)!=NULL)
                //if(strcmp((char*)FlashDCTbData.LRNTable[m],num)==0)   //hubinhao 2002-12-25 for 3131
                //avail=0;
                if( GetShortNumber((char *)FlashDCTbData.LRNTable[m])==GetShortNumber((char *)num) )
                {
                    if( strcmp((char*)FlashDCTbData.LRNTable[m],num)==0 )
                    {
                        avail=0;
                    }
                }
                break;
            case 'D':
                //if(strstr((char*)FlashDCTbData.LDNTable[m],num)!=NULL)
                //if(strcmp((char*)FlashDCTbData.LDNTable[m],num)==0)   //hubinhao 2002-12-25 for 3131
                //avail=0;
                if( GetShortNumber((char *)FlashDCTbData.LDNTable[m])==GetShortNumber((char *)num) )
                {
                    if( strcmp((char*)FlashDCTbData.LDNTable[m],num)==0 )
                    {
                        avail=0;
                    }
                }
                break;
            }

            //	if(strstr((char*)FlashDCTbData.LMNTable[m],latestInNum)!=NULL)
            //		avail=0;

            m++;
        }
        if( avail==1 )
        {
            if( n<10 )
            {
                for( i=n;i>0;i-- )
                {  //be pay atterntion :while i=0,do not inter
                    switch( callrecordtype )
                    {
                    case 'M': 
                        wstrcpy((char*)FlashDCTbData.LMNTable[i],(char*)FlashDCTbData.LMNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LMNTime[i],(char*)FlashDCTbData.LMNTime[i-1]);
                        // wstrcpy((char*)FlashDCTbData.LMNflag[i],(char*)FlashDCTbData.LMNflag[i-1]);  //hu binhao 2002-12-18\

                        FlashDCTbData.LMNflag[i]=FlashDCTbData.LMNflag[i-1];  //hu binhao 2002-12-18

                        FlashDCTbData.MForNameFlag[i]=FlashDCTbData.MForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Mname[i],(char*)FlashDCTbData.Mname[i-1]);  //hu binhao 2002-12-29
                        break;
                    case 'J':
#if 0
                        wstrcpy((char*)FlashDCTbData.LJNTable[i],(char*)FlashDCTbData.LJNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LJNTime[i],(char*)FlashDCTbData.LJNTime[i-1]);

                        FlashDCTbData.JForNameFlag[i]=FlashDCTbData.JForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Jname[i],(char*)FlashDCTbData.Jname[i-1]);  //hu binhao 2002-12-29

                        break;
#endif
                    case 'R':
                        wstrcpy((char*)FlashDCTbData.LRNTable[i],(char*)FlashDCTbData.LRNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LRNTime[i],(char*)FlashDCTbData.LRNTime[i-1]);

                        FlashDCTbData.RForNameFlag[i]=FlashDCTbData.RForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Rname[i],(char*)FlashDCTbData.Rname[i-1]);  //hu binhao 2002-12-29

                        break;
                    case 'D':
                        wstrcpy((char*)FlashDCTbData.LDNTable[i],(char*)FlashDCTbData.LDNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LDNTime[i],(char*)FlashDCTbData.LDNTime[i-1]);

                        FlashDCTbData.DForNameFlag[i]=FlashDCTbData.DForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Dname[i],(char*)FlashDCTbData.Dname[i-1]);  //hu binhao 2002-12-29
                        break;
                    }

                }
                switch( callrecordtype )
                {
                case 'M': 
                    FlashDCTbData.LMNID++;
                    break;
                case 'J':
#if 0
                    FlashDCTbData.LJNID++;
                    break;
#endif
                case 'R':
                    FlashDCTbData.LRNID++;
                    break;
                case 'D':
                    FlashDCTbData.LDNID++;
                    break;
                }
            }
            else
            {  //last number

                switch( callrecordtype )
                {
                case 'M': 
                    for( i=9;i>0;i-- )
                    {
                        wstrcpy((char*)FlashDCTbData.LMNTable[i],(char*)FlashDCTbData.LMNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LMNTime[i],(char*)FlashDCTbData.LMNTime[i-1]);

                        //wstrcpy((char*)FlashDCTbData.LMNflag[i],(char*)FlashDCTbData.LMNflag[i-1]);
                        FlashDCTbData.LMNflag[i]=FlashDCTbData.LMNflag[i-1];  //hu binhao 2002-12-18


                        FlashDCTbData.MForNameFlag[i]=FlashDCTbData.MForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Mname[i],(char*)FlashDCTbData.Mname[i-1]);  //hu binhao 2002-12-29
                    }
                    FlashDCTbData.LMNID=10;
                    break;
                case 'J':
#if 0
                    for( i=9;i>0;i-- )
                    {
                        wstrcpy((char*)FlashDCTbData.LJNTable[i],(char*)FlashDCTbData.LJNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LJNTime[i],(char*)FlashDCTbData.LJNTime[i-1]);

                        FlashDCTbData.JForNameFlag[i]=FlashDCTbData.JForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Jname[i],(char*)FlashDCTbData.Jname[i-1]);  //hu binhao 2002-12-29

                    }
                    FlashDCTbData.LJNID=10;
                    break;
#endif
                case 'R':
                    for( i=9;i>0;i-- )
                    {
                        wstrcpy((char*)FlashDCTbData.LRNTable[i],(char*)FlashDCTbData.LRNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LRNTime[i],(char*)FlashDCTbData.LRNTime[i-1]);

                        FlashDCTbData.RForNameFlag[i]=FlashDCTbData.RForNameFlag[i-1];          //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Rname[i],(char*)FlashDCTbData.Rname[i-1]);  //hu binhao 2002-12-29

                    }
                    FlashDCTbData.LRNID=10;
                    break;
                case 'D':
                    for( i=9;i>0;i-- )
                    {
                        wstrcpy((char*)FlashDCTbData.LDNTable[i],(char*)FlashDCTbData.LDNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LDNTime[i],(char*)FlashDCTbData.LDNTime[i-1]);

                        FlashDCTbData.DForNameFlag[i]=FlashDCTbData.DForNameFlag[i-1];  //hu binhao 2002-12-29
                        wstrcpy((char*)FlashDCTbData.Dname[i],(char*)FlashDCTbData.Dname[i-1]);  //hu binhao 2002-12-29

                    }
                    FlashDCTbData.LDNID=10;
                    break;
                }
                //  FlashDCTbData.LMNID=10;
            }

        }
        else
        {  // old number
            for( i=m-1;i>0;i-- )
            {
                switch( callrecordtype )
                {
                case 'M': 
                    wstrcpy((char*)FlashDCTbData.LMNTable[i],(char*)FlashDCTbData.LMNTable[i-1]);
                    wstrcpy((char*)FlashDCTbData.LMNTime[i],(char*)FlashDCTbData.LMNTime[i-1]);
                    FlashDCTbData.LMNflag[i]=FlashDCTbData.LMNflag[i-1];  //hu binhao 2002-12-18
                    FlashDCTbData.MForNameFlag[i]=FlashDCTbData.MForNameFlag[i-1];  //hu binhao 2002-12-29
                    wstrcpy((char*)FlashDCTbData.Mname[i],(char*)FlashDCTbData.Mname[i-1]);  //hu binhao 2002-12-29
                    break;
                case 'J':
#if 0
                    wstrcpy((char*)FlashDCTbData.LJNTable[i],(char*)FlashDCTbData.LJNTable[i-1]);
                    wstrcpy((char*)FlashDCTbData.LJNTime[i],(char*)FlashDCTbData.LJNTime[i-1]);

                    FlashDCTbData.JForNameFlag[i]=FlashDCTbData.JForNameFlag[i-1];  //hu binhao 2002-12-29
                    wstrcpy((char*)FlashDCTbData.Jname[i],(char*)FlashDCTbData.Jname[i-1]);  //hu binhao 2002-12-29

                    break;
#endif
                case 'R':
                    wstrcpy((char*)FlashDCTbData.LRNTable[i],(char*)FlashDCTbData.LRNTable[i-1]);
                    wstrcpy((char*)FlashDCTbData.LRNTime[i],(char*)FlashDCTbData.LRNTime[i-1]);

                    FlashDCTbData.RForNameFlag[i]=FlashDCTbData.RForNameFlag[i-1];  //hu binhao 2002-12-29
                    wstrcpy((char*)FlashDCTbData.Rname[i],(char*)FlashDCTbData.Rname[i-1]);  //hu binhao 2002-12-29

                    break;
                case 'D':
                    wstrcpy((char*)FlashDCTbData.LDNTable[i],(char*)FlashDCTbData.LDNTable[i-1]);
                    wstrcpy((char*)FlashDCTbData.LDNTime[i],(char*)FlashDCTbData.LDNTime[i-1]);

                    FlashDCTbData.DForNameFlag[i]=FlashDCTbData.DForNameFlag[i-1];  //hu binhao 2002-12-29
                    wstrcpy((char*)FlashDCTbData.Dname[i],(char*)FlashDCTbData.Dname[i-1]);  //hu binhao 2002-12-29
                    break;
                }
            }

            /*

                for(i=m-1;i>0;i--)
                    {	
                        wstrcpy((char*)FlashDCTbData.LMNTable[i],(char*)FlashDCTbData.LMNTable[i-1]);
                        wstrcpy((char*)FlashDCTbData.LMNTime[i],(char*)FlashDCTbData.LMNTime[i-1]);
                        
                    }*/


        }
        switch( callrecordtype )
        {
        case 'M': 
            wstrcpy((char*)FlashDCTbData.LMNTable[0],num);
            sprintf(time, "%d%d.%d%d %d%d:%d%d:%d%d", month/10,month%10, day/10,day%10, hour/10,hour%10, min/10,min%10, sec/10,sec%10);
            wstrcpy((char*)FlashDCTbData.LMNTime[0],time);
            FlashDCTbData.LMNflag[0]=1;  //hu binhao 2002-11-29 12-18
            FlashDCTbData.MissedCallNum++; //hu binhao 2002-11-29
            if( IsfindNumRes )
            {           //hu binhao 2002-12-29 for bug3120
                //FlashDCTbData.Mname[0]=searchdata->name;
                wstrncpy((char *) FlashDCTbData.Mname[0], (char *) searchdata->name, wstrlen(searchdata->name));
            }
            else
            {//FlashDCTbData.Mname[0]=NULL;
                memset(FlashDCTbData.Mname[0], '\0', sizeof(FlashDCTbData.Mname[0]));
            }
            if( SRFlag )
            {   //hu binhao 2002-12-29 for bug3120
                FlashDCTbData.MForNameFlag[0]=1;
            }
            else
            {
                FlashDCTbData.MForNameFlag[0]=0;
            }
            break;
        case 'J':
#if 0
            wstrcpy((char*)FlashDCTbData.LJNTable[0],num);
            sprintf(time, "%d%d/%d%d %d%d:%d%d:%d%d", month/10,month%10, day/10,day%10, hour/10,hour%10, min/10,min%10, sec/10,sec%10);
            wstrcpy((char*)FlashDCTbData.LJNTime[0],time);

            if( IsfindNumRes )
            {           //hu binhao 2002-12-29 for bug3120
                //FlashDCTbData.Jname[0]=searchdata->name;
                wstrncpy((char *) FlashDCTbData.Jname[0], (char *) searchdata->name, wstrlen(searchdata->name));

            }
            else
            {
                //FlashDCTbData.Jname[0]=NULL;
                memset(FlashDCTbData.Jname[0], '\0', sizeof(FlashDCTbData.Jname[0]));

            }
            if( SRFlag )
            {   //hu binhao 2002-12-29 for bug3120
                FlashDCTbData.JForNameFlag[0]=1;
            }
            else
            {
                FlashDCTbData.JForNameFlag[0]=0;
            }

            break;
#endif
        case 'R':
            wstrcpy((char*)FlashDCTbData.LRNTable[0],num);
            sprintf(time, "%d%d.%d%d %d%d:%d%d:%d%d", month/10,month%10, day/10,day%10, hour/10,hour%10, min/10,min%10, sec/10,sec%10);
            wstrcpy((char*)FlashDCTbData.LRNTime[0],time);
            if( IsfindNumRes )
            {           //hu binhao 2002-12-29 for bug3120
                //	FlashDCTbData.Rname[0]=searchdata->name;
                wstrncpy((char *) FlashDCTbData.Rname[0], (char *) searchdata->name, wstrlen(searchdata->name));

            }
            else
            {
                //FlashDCTbData.Rname[0]=NULL;
                memset(FlashDCTbData.Rname[0], '\0', sizeof(FlashDCTbData.Rname[0]));
            }
            if( SRFlag )
            {   //hu binhao 2002-12-29 for bug3120
                FlashDCTbData.RForNameFlag[0]=1;
            }
            else
            {
                FlashDCTbData.RForNameFlag[0]=0;
            }
            break;
        case 'D':
            wstrcpy((char*)FlashDCTbData.LDNTable[0],num);
            //sprintf(time, "%d%d/%d%d %d%d:%d%d:%d%d", month/10,month%10, day/10,day%10, hour/10,hour%10, min/10,min%10, sec/10,sec%10);
            sprintf(time, "%d%d.%d%d %d%d:%d%d:%d%d", month/10,month%10, day/10,day%10, hour/10,hour%10, min/10,min%10, sec/10,sec%10);/*2003/12/16, wangyan modify*/
            wstrcpy((char*)FlashDCTbData.LDNTime[0],time);
            if( IsfindNumRes )
            {           //hu binhao 2002-12-29 for bug3120
                //FlashDCTbData.Dname[0]=searchdata->name;
                wstrncpy((char *) FlashDCTbData.Dname[0], (char *) searchdata->name, wstrlen(searchdata->name));

            }
            else
            {
                //FlashDCTbData.Dname[0]=NULL;
                memset(FlashDCTbData.Dname[0], '\0', sizeof(FlashDCTbData.Dname[0]));
            }
            if( SRFlag )
            {   //hu binhao 2002-12-29 for bug3120
                FlashDCTbData.DForNameFlag[0]=1;
            }
            else
            {
                FlashDCTbData.DForNameFlag[0]=0;
            }
            break;
        }

        //wstrcpy((char*)FlashDCTbData.LMNTable[0],latestInNum);
        //sprintf(time, "%d%d/%d%d %d%d:%d%d:%d%d", month/10,month%10, day/10,day%10, hour/10,hour%10, min/10,min%10, sec/10,sec%10);
        //wstrcpy((char*)FlashDCTbData.LMNTime[0],time);
        //FlashDCTbData.LMNID++;
        if( callrecordtype='M'&&cugwindows )
        //we are in recent call menu ,cugwindows have value,and happen a missed call ,we set MCallHintDleteFlag 1 to mark we can not delte miised call hind this time.
        {
            MCallHintDleteFlag=1;
        }

        flash_DCTbwrite();

    }


}

static int CallRecord(MfwMnu* m, MfwMnuItem* i)
{
    voice_memo_start(call_data.win_menu,507);
    return 0;
}

/*2003/12/1, wangyan delete*/
/*static int TestModeStart(MfwMnu* m, MfwMnuItem* i)    
{
 //  bookMenuStart( call_data.win, menuSpecialModeAttributes(), NULL);
   bookMenuStart( idle_data.win, menuSpecialModeAttributes(), Phbksoftversion); //2003/12/1, wangyan modify
   return 0;
}*/
/*2003/12/1, wangyan delete*/

/*zy 2003-03-19 add this function  when callcm error release all call*/
void  RELEASEAllCALL(void)
{
    cm_force_disconnect();
    call_data.ignore_disconnect=TRUE;
    MMI_TRACE_EVENT (("wangyan RELEASEAllCALL call_destroy()"));    
    call_destroy(call_data.win);
}
/*yq 2003-03-19 */
void tracewin(MfwHdr* h)
{
    MfwHdr *eoc;
    char temp[100];
    if( h->type!=MfwTypWin )
        return;
    MmiTrace("trace win");
    MmiTrace("h is win begin:");
    Sprintf(temp,"hdr of h:%d",h);
    MmiTrace(temp);
    Sprintf(temp,"data of h:%d",h->data);
    MmiTrace(temp);
    MmiTrace("now we trace the win elems");
    eoc=((MfwWin *)h->data)->elems;
    while( eoc->type!=MfwTypMax )
    {
        Sprintf(temp,"current h->elem type:%d",eoc->type);
        MmiTrace(temp);
        Sprintf(temp,"hdr of this ele:%d",eoc);
        MmiTrace(temp);
        if( eoc->type==MfwTypWin )
            tracewin(eoc);
        eoc=eoc->next;
        MmiTrace("now the next eoc is");
    }
    Sprintf(temp,"end of all ele:%d",eoc);
    MmiTrace(temp);
    Sprintf(temp,"eoc->type:%d",eoc->type);
    MmiTrace(temp);
    Sprintf(temp,"eoc->next:%d",eoc->next);
    MmiTrace(temp);
    Sprintf(temp,"lastlink mfwfocus=:%d",mfwFocus);
    MmiTrace(temp);
    Sprintf(temp,"lastlink mfwFocus.type=:%d",mfwFocus->type);
    MmiTrace(temp);

}

void print_mfw_link()
{   MfwHdr * h;
    char tempt[40];
    h=mfwRoot;
    Sprintf(tempt,"firstlink mfwroot=:%d",mfwRoot);
    MmiTrace(tempt);
    Sprintf(tempt,"firstlink mfwfocus=:%d",mfwFocus);
    MmiTrace(tempt);
    Sprintf(tempt,"firstlink mfwFocus.type=:%d",mfwFocus->type);
    MmiTrace(tempt);
    while( h )
    {
        if( h == mfwFocus )
        {
            //dspl_Enable(temp);            
            return;
        }


        /*
         * get parent window
         */



        if( h->type==MfwTypWin )
        {
            MmiTrace("we found first win");
            tracewin(h);
            break;
        }
        h = h->next;
    }
    return;
}
void saveRejNuminhalloff(void)
{
    //	saveNumCallRecord('J',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
    saveNumCallRecord('R',latestInNum ,IsIngroup,SimReadyFlag,&searchPhdata); /*2003/12/16, wangyan modify*/
}

char* getViewStatus(int mode)
{   char *tag = 0;
    switch( mode )
    {
    case CallSingle:
        tag = MmiRsrcGetText(TxtCallSingle);
        break;
    case CallTwo:
        tag = MmiRsrcGetText(TxtCallTwo);
        break;
    case CallPrivateCall:
        tag = MmiRsrcGetText(TxtCallPrivateCall);
        break;
    case CallConference:
        tag = MmiRsrcGetText(TxtCallConfernce);
        break;
    case CallSingleMultiparty:
        tag = MmiRsrcGetText(TxtCallSingleMultiparty);
        break;
    case CallMultipartySingle:
        tag = MmiRsrcGetText(TxtCallMultipartySingle);
        break;
    }

    return tag;
}

/************************************************************************************************
 $Function:		GetIncomingCallWin
 $Description:
 $Author:
 $Date:
************************************************************************************************/

MfwHnd GetIncomingCallWin()
{
    return call_data.win_incoming;
}
