
/*******************************************************************************

                    CONDAT (UK) 

********************************************************************************									      

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.				   
                                          
********************************************************************************

 $Project name: Basic MMI						       
 $Project code: BMI (6349)							     
 $Module:		MMI
 $File: 	    MmiPins.c
 $Revision:		1.0							  
                                          
 $Author:		Condat(UK)							   
 $Date: 	    25/10/00							  
                                           
********************************************************************************
                                           
 Description:
 
  MMI PIN / PUK entry handling
            
********************************************************************************

 $History: MmiPins.c

    25/10/00			Original Condat(UK) BMI version.	
    19/08/02      version 0.101 xusufang modified    
    29/08/02      version 0.102 xusufang modified   
    04/09/02      version 0.103 ganchunhui change ss_check_ss_string ss_check_ss_string_pin
    05/09/02      version 0.104 ganchunhui add patch to make power off available while no sim card or input pins
 $End

*******************************************************************************/



/*******************************************************************************
                                          
                Include Files
                                          
*******************************************************************************/
#define ENTITY_MFW
#undef _PINAUTOINPUT_
/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "mfw_sys.h"

#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_cm.h"
#include "mfw_icn.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_ss.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_sat.h"
#include "mfw_tim.h"
#include "mfw_mnu.h"
#include "mfw_sms.h"

#include "dspl.h"


#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"

// #include "MmiLang.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiMenu.h"
#include "MmiSoftkeys.h"
#include "MmiIdle.h"
#include "mmiCall.h"
#include "MmiNetwork.h"
#include "MmiSounds.h"
#include "MmiSettings.h"
#include "MmiServices.h"
#include "MmiIcons.h"
#include "MmiDialogs.h"
#include "MmiEditor.h"
#include "MmiPins.h"
#include "MmiCphs.h"
#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mfw_ffs.h"  //xsf add 2002.08.05 2 lines
#include "Mmihost.h"
#include "Mmitoolkit_timer.h"  //xsf add for display drawSolidRectangle() 12.28
#include "Gamedisplay.h"
#include "mmicharging.h" //hxl add 2002-9-25 for charger icon
#include "pwr.h"
#include "Mmismsidle.h" //GW SPR#1035 - For smsidle_unset_ready_state(void) definition.
#include "fieldtest.h"

#include "mmiutilapi.h"

#define CLEAR_PIN_EDIT_AREA dspl_Clear(0,30,120,91);

extern UBYTE HUPKeyOrigin; // xsf - set to 1 if POWER_KEY is pressed in input pin1/puk1 screen when switch on the mobile

extern UBYTE animation_complete;
static unsigned char IsFirstPinReq=1;

/* PROTOTYPES */

static int pin_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int pin_edt_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int pin_edt_kbd_cb (T_MFW_EVENT event, T_MFW_KBD * kc);
static void check_pins (T_MFW_HND win,void * edt_pin);
static void gsm_sec_execute(T_MFW_HND win,void *string);
static void pin_edt_tim_out_cb (T_MFW_EVENT event,T_MFW_TIM * t);
static int pin_mess_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
//static void pin_icons(void);//2003/12/20,talcon comment
static void clear_edit_array (void * parameter);
static void emerg_pin(void * string);
static int sim_rem_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void pin_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int gsm_test(T_MFW_HND win,void * edt_pin);
static void pin_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static void sim_rem_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int pin_edt_kbd_long_cb (T_MFW_EVENT event,T_MFW_KBD *  kc);
static void main_call_edit(T_MFW_HND win, USHORT event);
static void main_call_mess(T_MFW_HND win,USHORT event);
static int setting_pin_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int set_pin_mess_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static void sett_pin_mess(T_MFW_HND win,USHORT event);
static void check_set_pins (T_MFW_HND win,void * edt_pin);
static int set_pin_kbd_cb (T_MFW_EVENT event,T_MFW_KBD *  kc);
static void set_pin_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int set_pin_win_cb (T_MFW_EVENT event,T_MFW_WIN * win);
static void sett_pin_edit(T_MFW_HND win,USHORT event);
static int gsm_set_test(T_MFW_HND win,void * edt_pin);
static void set_mode_fdn_adn(T_MFW_HND win,void * string);
static void check_plock_to_clock(T_MFW_HND win,USHORT event);
static void check_nlock_to_clock(T_MFW_HND win,USHORT event);
static void check_splock_to_clock(T_MFW_HND win,USHORT event);
static void check_nslock_to_clock(T_MFW_HND win,USHORT event);
static void check_sim_clock(T_MFW_HND win,USHORT event);
static void pin_ch_end_or_abort (T_MFW_HND win);
static void pin_verif_or_check2_end(T_MFW_HND win);
static void pin1_en_dis_verify(T_MFW_HND win);
static int set_pin_edt_win_cb (T_MFW_EVENT event,T_MFW_WIN * win);
static void reset_edt_attr(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                           U8 *controls, char *text,U16 size,MfwEdtAttr* attr);
static int set_pin_edt_kbd_long_cb (T_MFW_EVENT event,T_MFW_KBD *  kc);
static void gsm_sec_execute_set(T_MFW_HND win,void *string);
void pin2_not_available_screen();
static void not_avail_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void pins_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
void pin1_not_enabled_screen();

static void pins_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason);
void pins_loadEditDefault (T_EDITOR_DATA *editor_data);
void show_confirmation (T_MFW_HND win);
static int show_confirmation_cb(T_MFW_HND win, USHORT identifier, UBYTE reason);
//hxl add for charger 2002-9-25---------------------------------
extern  UBYTE   BlinkBatPicnum;
extern  UBYTE CurrentBatPicNum;
static UBYTE    pinsentpoweroff=0;
static MfwHnd gtimeBlink=0;
static UBYTE    IsBlinktimerRun=0;
static void batEvent(void);
static int pin_charger_tim_cb (MfwEvt e, MfwTim *t);
//end of hxl add-----------------------------------------------------

/* EDITOR DEFINITION						    */

/*
static char one_attempts[] =
{
    "1 try left "
};

static char two_attempts[] =
{
    "2 tries left "
};
*/

#define MAX_DIG 	 12  //xsf change 30 to 9 12.28		/* maximum number of digits */
#define MAX_PIN 	 8		/* maximum number of PIN/PUK */
#define MIN_PIN 	 4
#define TIMERESULT	500		/*   time for results(later to change!!*/
#define TIMEOUT 	30000		 /* time for entering	     */



// the coordinate of the TxtId 
#if (MAIN_LCD_SIZE==3)
#define INFO_TEXT_X	14 //xsf change 0 to 10  2002.08.21
#define INFO_TEXT_Y	30  //xsf change from 6 to 30 2002.08.16
#elif ( MAIN_LCD_SIZE==4 )
#define INFO_TEXT_X	14 //xsf change 0 to 10  2002.08.21
#define INFO_TEXT_Y	30  //xsf change from 6 to 30 2002.08.16
#elif ( MAIN_LCD_SIZE==2 )
#define INFO_TEXT_X 10
#define INFO_TEXT_Y SECOND_LINE
#endif
#define PIN_ENTRY_MAX	3
#define STAR		0x2a
#define HASH		0x23
#define FIRST_DIGIT	  1
#define NUM_OF_PLOCK	 6
#define IDENT_GSM_1	 5
#define IDENT_GSM_2	 6
#define TIM_LOCK	 0x01
#define TIM_LOCK_JUMP	 1000

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND    parent_win;
    T_MFW_HND    pin_win;
    T_MFW_HND    sim_handle;
    int          pin_retries;     /* number of  pin attempts  */
    UBYTE        puk_request;
    USHORT           display_id1;
    USHORT           display_id2;
    UBYTE        gsm_state;       /* status gsm in security   */
    SET_CASE     set_state;       /* setting state	    */
    UBYTE        pin[MAX_DIG+1];      /* number string pin	*/
    UBYTE        puk[MAX_PIN+1];  /* number string puk	    */
    UBYTE        new_pin[MAX_PIN+1];  /* store new pin	    */
    UBYTE        old_pin[MAX_PIN+1];  /* store old pin	    */
    PIN_CASE     pin_case;        /* editor state 	    */
    char              edtbuf[MAX_DIG];  
} T_pin;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND    parent_win;
    T_MFW_HND    pin_mess_win;
    USHORT           display_id1;
    USHORT           display_id2;
    PIN_CASE     pin_case;
}T_pin_mess;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND    parent_win;
    T_MFW_HND    pin_edt_win;
    T_MFW_HND    kbd_handle;
    T_MFW_HND    kbd_long_handle;
    T_MFW_HND    editor_handle;
    T_MFW_HND    tim_out_handle;
    UBYTE        pin[MAX_PIN+1];      /* number string pin	*/
    UBYTE        puk[MAX_PIN+1];  /* number string puk	    */
    UBYTE        new_pin[MAX_PIN+1];  /* store new pin	    */
    UBYTE        old_pin[MAX_PIN+1];  /* store old pin	    */
    UBYTE        editor_index;
    PIN_CASE     pin_case_edit;
    UBYTE        gsm_state;       /* status gsm in security   */
    UBYTE        emergency_call;
    char edtbuf[MAX_DIG];
    MfwEdtAttr editpinAttr;
    char     pin_dspl[MAX_PIN+1];
}T_pin_edt;

typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND    parent_win;
    T_MFW_HND    sim_rem_win;
    T_MFW_HND    sim_handle;
    PIN_CASE     pin_case;
    USHORT           display_id1;
} T_sim_rem;

LOCAL T_sim_rem sim_rem_data;

static T_MFW_HND pin_windows;
static T_MFW_HND pin_edit_windows;
static T_MFW_HND pin_mess_windows;
static T_MFW_HND set_pin_windows;
static T_MFW_HND sim_rem_handle;

/*******************************************************************************

 $Function:	pin_init 

 $Description:	This is the start-up time initialisation routine.
        call from init routine in the idle
 
 $Returns:		None

 $Arguments:	parent window
 
*******************************************************************************/
void pin_init (T_MFW_HND parent_window)
{
    pin_create (parent_window);
}


/*******************************************************************************

 $Function:	pin_exit 

 $Description:	power down in security screen
 $Returns:		None

 $Arguments:	None
 
*******************************************************************************/
void pin_exit (void)
{
    if ( pin_mess_windows )
        pin_mess_destroy(pin_mess_windows);
    if ( pin_edit_windows )
        pin_edt_destroy(pin_edit_windows);
    if ( pin_windows )
    {
        TRACE_EVENT("pin_destroy 1");
        pin_destroy (pin_windows);

    }
}


/*******************************************************************************

 $Function:	pin_create

 $Description:	Creation of an instance for the PIN dialog (sim activation)

        Type of dialog : SINGLE_DYNAMIC
 $Returns:		Window

 $Arguments:	Parent window
 
*******************************************************************************/
T_MFW_HND pin_create (T_MFW_HND parent_window)
{

    T_MFW_WIN * win;
    T_pin * data = (T_pin *)ALLOC_MEMORY (sizeof (T_pin));

    data->pin_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)pin_win_cb);

    pin_windows = data->pin_win;
    pin_edit_windows = NULL;
    pin_mess_windows = NULL;

    TRACE_FUNCTION("MmiPins:pin_create");

    if ( data->pin_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)pin_main;/* dialog main function    */
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->pin_win)->data;
    win->user           = (void *) data;


    /*
     * Create any other handler
     */

    data->sim_handle = sim_create(data->pin_win,E_SIM_ALL_SERVICES,(MfwCb)sim_event_cb_main);

    /*
     * return window handle
     */

    mfwSetSignallingMethod(1);//mfw focus handling
    winShow(data->pin_win);


    return data->pin_win;
}


/*******************************************************************************

 $Function:	pin_destroy

 $Description:	Destroy the pin dialog.
 $Returns:		None

 $Arguments:	window
 
*******************************************************************************/
void pin_destroy  (T_MFW_HND own_window)
{

    T_pin *      data;
    T_MFW_WIN *   win;

    TRACE_FUNCTION("MmiPins:pin_destroy");

    if ( own_window )
    {
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_pin *)win->user;

        if ( data )
        {
            /*
             * Exit SIM and Delete SIM Handler
             */
            sim_delete (data->sim_handle);

            /*
             * Delete WIN Handler
             */
            win_delete (data->pin_win);
            pin_windows = 0;
            // + KGT 19.7.2000
            //mfwFree((U8 *)data,(sizeof(T_pin)));
            FREE_MEMORY((void *)data,(sizeof(T_pin)));
            // - KGT 19.7.2000
        }
    }
}


/*******************************************************************************

 $Function:	pin_win_cb

 $Description:	Callback function for windows
 $Returns:		Status int
 $Arguments:	window handler event, window
 
*******************************************************************************/
static int pin_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{ 
    if ( event EQ MfwWinVisible )
    {   
#if(MAIN_LCD_SIZE==4)
		DRAW_ICON_SEL(ICON_SWITCHON, 0);
#endif
    	//dspl_BitBlt(0, 0, 102, 80, 0, (void*)pin_wait, 0);*///jhxu720 delete
        return 1;
    }
    
    return 0;
}




/*******************************************************************************

 $Function:	sim_event_cb_main

 $Description:	PURPOSE : SIM event handler for Pins
 $Returns:		Status int
 $Arguments:	window handler event, sim status
 
*******************************************************************************/
int sim_event_cb_main (T_MFW_EVENT event, T_MFW_HND para)
{
/**********************/
#define NO_ACTION	0

    BYTE reconf_handling = NO_ACTION;
    BYTE reconf_defreeze_display = 1;
/*********************/

    T_MFW_SIM_STATUS * status;
    UBYTE limited;

    T_MFW_HND win = mfw_parent(mfw_header());


    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;

    T_pin * pin_data = (T_pin *)win_data->user;
    char debug[50];

    status = (T_MFW_SIM_STATUS *)para;

    limited = TRUE;         /* initial limited mode     */
    sprintf(debug, "sim event handler,event:%d, status:%d, proc:%d",event, status->sim_status, status->sim_procedure);
    TRACE_EVENT(debug);

    switch ( event )
    {
    case E_SIM_INSERTED:    /*  there not handled */
        return 0;       /* (handled in sim_rem dialog, commented out currently */


        //GW-SPR#1035-Added STK Changes
    case E_SIM_RESET:   
        TRACE_EVENT("E_SIM_RESET");
        /*NM, 110702
            the MM-entity initated the de-registration already (MMI dont have to do it); 
            after this event we should avoid any cases to access the SIM
            (e.g. reading phonebook, reading sms....)
            
            - how to do it ???
            ->  unset the "sms_initialised" flag to FALSE

            - when does it set back to TRUE ???
            -> the flag will be set after the event "E_SMS_READY"
        */  
        smsidle_unset_ready_state ();
        info_screen(0, TxtSim, TxtNotReady, NULL,REMIND_NORECORD); 
        /*NM, 110702 END*/
        return 0;       


    case E_SIM_STATUS:
        /*
         * check whether decoded message is available
         */
        if ( para EQ (T_MFW_SIM_STATUS *)NULL )
            return MFW_RES_ILL_HND;

        status = (T_MFW_SIM_STATUS *)para;


/********************************/



        switch ( status->sim_procedure )
        {
        /*
         * Initial activation of the SIM card
         */
        case MFW_SIM_ACTIVATION:
            /*
             * check the result of activation
             */
            switch ( status->sim_status )
            {
            /*
             * PIN 1 must be entered
             */
            case MFW_SIM_PIN_REQ:					
                if ( status->sim_pin_retries < PIN_ENTRY_MAX )
                {
                    TRACE_EVENT("sim_event_cb_main:PIN1 req-retr");					
                    pin_data->pin_retries = status->sim_pin_retries;/* number of retries */
                    SEND_EVENT(pin_data->pin_win,PIN1_REQ_ATT,0,pin_data);
                }
                else
                {

/********************************/

                    TRACE_EVENT("sim_event_cb_main:PIN1 req");					
                    SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);
                }
                break;

                /*
                 * SIM card is blocked, PUK 1 is needed
                 */
            case MFW_SIM_PUK_REQ:
                TRACE_EVENT("sim_event_cb_main:PUK1 req");
                SEND_EVENT(pin_data->pin_win,PUK1_REQ_ACT_INFO,0,pin_data);
                break;

                /*
                 * no PIN is needed
                 */
            case MFW_SIM_NO_PIN:
                limited = FALSE;
                TRACE_EVENT("sim_event_cb_main:no Pin");
                mmi_cphs_refresh();
                if ( sim_pin_count(MFW_SIM_PIN1) EQ 0 ) //xsf add 2003.04.11
                    SEND_EVENT(pin_data->pin_win,PUK1_REQ_ACT_INFO,0,pin_data);
                else
                    SEND_EVENT(pin_data->pin_win,PIN_OK, 0, NULL);//back to idle
                break;

                /*
                 * SIM card is broken
                 */
            case MFW_SIM_INVALID_CARD:
                TRACE_EVENT("sim_event_cb_main: invalid card");
                SEND_EVENT(pin_data->pin_win,INVALID_CARD, 0, pin_data);
                break;

                /*
                 * No SIM card is inserted
                 */
            case MFW_SIM_NO_SIM_CARD:
                TRACE_EVENT("sim_event_cb_main: no SIM Card");
                SEND_EVENT(pin_data->pin_win,NO_SIM_CARD, 0, pin_data);
                break;
            default:
                return 0;
            }
            /*
             * start limited or full service */

            if ( limited )
            {
                /*
                 * limited shall be the requested service
                 * if no service is reached, the limited
                 * service is requested*/

                if ( nm_reg_status() EQ NOT_PRESENT_8BIT
                     AND
                     status->sim_procedure EQ MFW_SIM_ACTIVATION )
                {
                    TRACE_EVENT("registration in limited mode ");
                    nm_registration (NM_AUTOMATIC, 0, TRUE);
                }
            }
            break;
        case MFW_SIM_VERIFY:
            /*
             * check the result of verify
             */
            switch ( status->sim_status )
            {
            /*
             * PIN 1 must be entered
             */
            case MFW_SIM_PIN_REQ:
                if ( status->sim_pin_retries < PIN_ENTRY_MAX )
                {
                    TRACE_EVENT("sim_event_cb_main:Ver:PIN1 req-retr");				
                    pin_data->pin_retries = status->sim_pin_retries;
                    SEND_EVENT(pin_data->pin_win,PIN1_REQ_ATT,0,pin_data);
                }
                else
                {
                    TRACE_EVENT("SimEventPins:V:PIN1 req");					
                    SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);
                }
                break;
                /*
                 * SIM card is blocked, PUK 1 is needed
                 */
            case MFW_SIM_PUK_REQ:
                TRACE_EVENT("SimEventPins:V:PUK1 req");
                SEND_EVENT(pin_data->pin_win,PUK1_REQ_VER_INFO,0,pin_data);
                break;

                /*
                 * PIN entering successfull
                 */
            case MFW_SIM_NO_PIN:
                TRACE_EVENT("sim_event_cb_main:PIN ok without sim unlock");
                mmi_cphs_refresh();
                pin_data->pin_case = PIN_OK_INFO;
                if ( pin_data->set_state == PIN2_CHECK )
                {
                    set_mode_fdn_adn(win,pin_data);
                }
                SEND_EVENT(pin_data->pin_win,PIN_OK_INFO,0,pin_data);
                break;
                /*
                 * SIM card is broken
                 */
            case MFW_SIM_INVALID_CARD:
                TRACE_EVENT("sim_event_cb_main: invalid card");
                SEND_EVENT(pin_data->pin_win,INVALID_CARD, 0, pin_data);
                break;

                /*
                 * No SIM card is inserted
                 */
            case MFW_SIM_NO_SIM_CARD:
                TRACE_EVENT("sim_event_cb_main: no SIM Card");
                SEND_EVENT(pin_data->pin_win,NO_SIM_CARD, 0, pin_data);
                break;
            default:
                return 0;
            }
            break;
            /*
             * response to PUK entering
             */
        case MFW_SIM_UNBLOCK:
            switch ( status->sim_status )
            {
            case MFW_SIM_PUK_REQ:
                TRACE_EVENT("sim_event_cb_main:unblock failure");
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_FAIL_INFO,0,pin_data);
                break;
            case MFW_SIM_SUCCESS:
                vSavePinData(pin_data->new_pin);   //save data in the RAM  GANCHH 2003/3/21
                TRACE_EVENT("sim_event_cb_main:unblock success");
                mmi_cphs_refresh();
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_SUCC,0,pin_data);
                break;
            case MFW_SIM_FAILURE:
                TRACE_EVENT("sim_event_cb_main:unblock fatal error");
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_FATAL_ERROR,0,pin_data);
                break;              
            case MFW_SIM_INVALID_CARD:
                TRACE_EVENT("sim_event_cb_main:unblock failed, no more retries");
                SEND_EVENT(pin_data->pin_win,INVALID_CARD,0,pin_data);
                break;
            default:
                return 0;
            }
            break;

        case MFW_SIM_REMOVED:/*  there not handled */
            return 0;    /* (handled in sim_rem dialog, commented out currently */
        default:
            return 0;
        }

        return 1;
#ifdef BMI_TEST_MC_SIM_EVENT
        break;
    case BMI_TEST_MC_SIM_EVENT:
        {
            T_MFW_READ_CALLBACK* sim_read_data;

            sim_read_data = (T_MFW_READ_CALLBACK*)para;

            TRACE_EVENT_P3("SIM READ Error: %d, %x%x", sim_read_data->error_code,
                           sim_read_data->read_buffer[0], sim_read_data->read_buffer[1]);
        }
        break;
#endif
    }
}


/*******************************************************************************

 $Function:	pin_main

 $Description:	PIN MAIN Dialog Handling function
 $Returns:		void
 $Arguments:	window, window handler event, value, parameters
 
*******************************************************************************/
static void pin_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;//pin main data
    T_pin_mess * mess_data = (T_pin_mess *) parameter;//pin message data
    T_pin_edt * edt_data = (T_pin_edt *) parameter;//pin editor data
    char debug[100];

    T_EDITOR_DATA   editor_data;

    sprintf(debug,"MmiPins:pin_main: %d", event);
    TRACE_FUNCTION(debug);
    switch ( event )
    {
    
    case PIN1_STATUS:         //Text "Pin disabled" or "enabled"
    case PIN1_REQ_ATT:            //info screen "xx attempts "
    case PUK1_REQ_ACT_INFO:       //info screen "SIM blocked "
        //case PUK1_REQ:		      //Text "Enter Puk "

    case GSM_FAIL:            // gsm not allowed
    case NEW_PIN_FAIL:            // new pin failed
    case PUK1_REQ_VER_INFO:       // Text "Pin blocked "
    case PUK1_UNBL_FAIL_INFO:     // unblock error - new puk requ
    case PUK1_UNBL_FATAL_ERROR:


    case SIM_UNLOCK_OK:           //Text "Unlock ok "
    case SIM_LOCK_ERR:
        //begin of xsf add 2002.08.21          (1)
    case PUK1_REQ:              //Text "Enter Puk "
    case INPUT_NEW_PIN:
    case INPUT_NEW_PIN_AGAIN:
    case PIN1_REQ:            //Text "Enter Pin "
#ifdef _M188_    
    case NO_SIM_CARD:         //Text "No Sim Card "
#endif    
        //end of xsf add 2002.08.21
#ifdef _PINAUTOINPUT_
        if ( event==PIN1_REQ )
        {
            if ( IsReset()&&(IsFirstPinReq)&&(GetPinData(pin_data->old_pin)) )
            {
                IsFirstPinReq=0;
                //GetPinData(pin_data->old_pin); //ganchunhui move to the before
                winShow(pin_data->pin_win);  //xsf add for big capacity simcard(such as STK card) 12.25
                sim_verify_pin(MFW_SIM_PIN1,(char*)pin_data->old_pin);/* verification pin1 */
            }

            else
            {
                IsFirstPinReq=0;    //disable to get the pin from RAM
                main_call_mess(win,event);   
            }
        }
        else
        {
#endif
            IsFirstPinReq=0;    //disable to get the pin from RAM
            main_call_mess(win,event);
#ifdef _PINAUTOINPUT_
        }
#endif
        break; 
#if 0
    case PUK1_REQ:            //Text "Enter Puk "
        pins_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(pin_data->edtbuf,'\0',sizeof(pin_data->edtbuf));

        editor_data.editor_attr.text    = pin_data->edtbuf;  /* buffer to be edited */
        editor_data.editor_attr.size    = MAX_PIN + 1;   /* limit to 8 digits */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        editor_data.TextId              = TxtEnterPuk1;
        editor_data.Identifier          = PUK1_REQ;  
        editor_data.min_enter           = 4;
        editor_data.hide                = TRUE;

        /* create the dialog handler */
        pin_edit_windows = editor_start(win, &editor_data);  /* start the editor */ 
        break;          

    case INPUT_NEW_PIN:
        pins_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(pin_data->edtbuf,'\0',sizeof(pin_data->edtbuf));

        editor_data.editor_attr.text    = pin_data->edtbuf;  /* buffer to be edited */
        editor_data.editor_attr.size    = MAX_PIN + 1;   /* limit to 8 digits */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        editor_data.TextId              = TxtEnterNewPin;
        editor_data.Identifier          = INPUT_NEW_PIN;  
        editor_data.min_enter           = 4;
        editor_data.hide                = TRUE;

        /* create the dialog handler */
        pin_edit_windows = editor_start(win, &editor_data);  /* start the editor */ 
        break;          

    case INPUT_NEW_PIN_AGAIN:
        pins_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(pin_data->edtbuf,'\0',sizeof(pin_data->edtbuf));

        editor_data.editor_attr.text    = pin_data->edtbuf;  /* buffer to be edited */
        editor_data.editor_attr.size    = MAX_PIN + 1;   /* limit to 8 digits */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        editor_data.TextId              = TxtConfPin;
        editor_data.Identifier          = INPUT_NEW_PIN_AGAIN;  
        editor_data.min_enter           = 4;
        editor_data.hide                = TRUE;

        /* create the dialog handler */
        pin_edit_windows = editor_start(win, &editor_data);  /* start the editor */ 
        break;
    case PIN1_REQ:            //Text "Enter Pin "

        pins_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(pin_data->edtbuf,'\0',sizeof(pin_data->edtbuf));

        editor_data.editor_attr.text    = pin_data->edtbuf;  /* buffer to be edited */
        editor_data.editor_attr.size    = MAX_PIN + 1;   /* limit to 8 digits */
        editor_data.LeftSoftKey         = TxtSoftOK;        
        editor_data.RightSoftKey        = TxtDelete;
        editor_data.TextId              = TxtEnterPin1;
        editor_data.Identifier          = PIN1_REQ;  
        editor_data.min_enter           = 4;
        editor_data.hide                = TRUE;

        /* create the dialog handler */
        pin_edit_windows = editor_start(win, &editor_data);  /* start the editor */ 
        break;

    case NO_SIM_CARD:         //Text "No Sim Card "

        pins_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(pin_data->edtbuf,'\0',sizeof(pin_data->edtbuf));

        editor_data.editor_attr.text    = pin_data->edtbuf;  /* buffer to be edited */
        editor_data.editor_attr.size    = MIN_PIN;   /* limit to 3 digits */
        editor_data.LeftSoftKey         = TxtNull;      
        editor_data.RightSoftKey        = TxtDelete;
        editor_data.TextId              = TxtNoCard;
        editor_data.Identifier          = INSERT_CARD;  
        editor_data.min_enter           = 3;
        editor_data.destroyEditor       = FALSE;

        /* create the dialog handler */
        pin_edit_windows = editor_start(win, &editor_data);  /* start the editor */ 
        break;
#endif

#ifndef _M188_    
    case NO_SIM_CARD:         //Text "No Sim Card "
#endif    
    case INVALID_CARD:            //Text "Invalid SIM card " zy 0902 change

        pins_loadEditDefault (&editor_data);

        //clear the editor-buffer
        memset(pin_data->edtbuf,'\0',sizeof(pin_data->edtbuf));
#if(MAIN_LCD_SIZE==4)
        editor_data.editor_attr.win.px   = 10;  //xsf changed 6 to 10 2002.10.24 
        editor_data.editor_attr.win.py   = 124;  //30;	/* 2004/06/08 sunsj modify */
        editor_data.editor_attr.win.sx   = 90;  //108+4;
        editor_data.editor_attr.win.sy   = 18;  //60+10;	/* 2004/07/13 sunsj modify */
#elif(MAIN_LCD_SIZE==3)
		editor_data.editor_attr.win.px   = 10;  //xsf changed 6 to 10 2002.10.24 
        editor_data.editor_attr.win.py   = 90;  //30;	/* 2004/06/08 sunsj modify */
        editor_data.editor_attr.win.sx   = 90;  //108+4;
        editor_data.editor_attr.win.sy   = 18;  //60+10;	/* 2004/07/13 sunsj modify */
#endif
        editor_data.editor_attr.text    = pin_data->edtbuf;  // buffer to be edited 
        editor_data.editor_attr.size    = MAX_DIG;   // limit to 3 digits 
        editor_data.LeftSoftKey         = TxtNull;      
        editor_data.RightSoftKey        = TxtDelete;
        editor_data.TextId              = 0;//TxtInvalidCard; //2004-03-10 Sunny modified
        editor_data.Identifier          = CARD_REJECTED;  
        editor_data.min_enter           = 1;
        editor_data.destroyEditor       = FALSE;
        editor_data.edtInPbk            = 0;
        // create the dialog handler 
        MmiTrace("pin_main_timcreat");
        gtimeBlink=timCreate(win, 2000, (MfwCb)pin_charger_tim_cb);

        pin_edit_windows = editor_start(win, &editor_data);  // start the editor  

        break;


    case TXT_SIM_PLOCK:
        pin_data->pin_case = SIM_PLOCK;
        main_call_edit(win,SIM_PLOCK);             // Start: enter P unlock
        break;
    case TXT_SIM_SPLOCK:
        pin_data->pin_case = SIM_SPLOCK;
        main_call_edit(win,SIM_SPLOCK);            // Start: enter SP unlock
        break;
    case TXT_SIM_NLOCK:
        pin_data->pin_case = SIM_NLOCK;
        main_call_edit(win,SIM_NLOCK);             // Start: enter N unlock
        break;
    case TXT_SIM_CLOCK:
        pin_data->pin_case = SIM_CLOCK;
        main_call_edit(win,SIM_CLOCK);             // Start: enter C unlock
        break;
    case TXT_SIM_NSLOCK:
        pin_data->pin_case = SIM_NSLOCK;
        main_call_edit(win,SIM_NSLOCK);            // Start: enter NS unlock
        break;
        //begin of xsf add 2002.08.21   (2)
    case TXT_INVALID_CARD:
        pin_data->pin_case = CARD_REJECTED;
        main_call_edit(win,CARD_REJECTED);             // Start: enter only emerg call
        break;
    case TXT_NO_CARD:
        pin_data->pin_case = INSERT_CARD;
        main_call_edit(win,INSERT_CARD);           // Start: enter only emerg call
        break;
    case TXT_ENTER_PIN1:
        pin_data->pin_case = INPUT_PIN1;//enter PIN1 start
        main_call_edit(win,INPUT_PIN1);
        break;
    case TXT_ENTER_PUK1:
        pin_data->pin_case = INPUT_PUK1;//enter PUK1 start
        main_call_edit(win,INPUT_PUK1);
        break;
    case TXT_ENTER_NEW_PIN:
        pin_data->pin_case = INPUT_NEW_PIN;//enter new PIN start
        main_call_edit(win,INPUT_NEW_PIN);
        break;
    case TXT_ENTER_NEW_PIN_AGAIN:
        pin_data->pin_case = INPUT_NEW_PIN_AGAIN;
        main_call_edit(win,INPUT_NEW_PIN_AGAIN);// Start: enter New PIN1 again
        break;

    case PIN1_END:     //xsf (3)
        winShow(pin_data->pin_win);  //xsf add for big capacity simcard(such as STK card) 12.25

        sim_verify_pin(MFW_SIM_PIN1,(char*)pin_data->old_pin);/* verification pin1 */
        break;
    case NEW_PIN_END:
        sim_unblock_pin(MFW_SIM_PUK1, (char*)pin_data->puk, (char*)pin_data->new_pin);/* unblock pin1 */
        break;
        //end of xsf add 2002.08.21 case NEW_PIN_FAIL:

//		  case TXT_INVALID_CARD:
//				   pin_data->pin_case = CARD_REJECTED;
//				   main_call_edit(win,CARD_REJECTED);		      // Start: enter only emerg call
//				   break;
//		  case TXT_NO_CARD:
//				   pin_data->pin_case = INSERT_CARD;
//				   main_call_edit(win,INSERT_CARD);		      // Start: enter only emerg call
//				   break;



//		  case PIN1_END:
//				   winShow(pin_data->parent_win);
//				   sim_verify_pin(MFW_SIM_PIN1,(char*)pin_data->pin);	 /*verification pin1 */
//				   break;

    }

    switch ( event )
    {
    case PIN_OK_INFO: // PIN was needed
    case PIN_OK:      // PIN wasn't needed
        check_plock_to_clock(win,event);/* start sim lock procedure   */
        break;
    case PIN_OK_END:  // PIN was needed and pin1 entered correctly
        //U8 uMode;
        // registration in full service mode case: PIN was  necessary
        //uMode = dspl_Enable(0);
        vSavePinData(pin_data->old_pin);   //save data in the ram 2003/3/21
        TRACE_EVENT("xsfxsf pin_destroy 2");
#ifdef _PINAUTOINPUT_
        if ( (!IsReset())&&(CheckPassWord(PRO_ON) || CheckPassWord(PRO_SIMLOCK)) )
#else
        if ( (CheckPassWord(PRO_ON) || CheckPassWord(PRO_SIMLOCK)) )
#endif
        {
            if ( CheckPassWord(PRO_ON) )
            {
                hostkey_init(0);    //xsf 2002.05.15
            }
            else if ( CheckPassWord(PRO_SIMLOCK) )
            {
                if ( FlashHostkeyData.SimLockFlag==0 )
                {
                    showwelcome(idle_get_window());
                    //Pin1OKOrNoPin1();  //xsf add 2002.10.09
                    //network_start_full_service ();
                    ReadSimIMSI();
                }
                else
                    JudgeSim();            
            }
        }
        else
        {
            /* SH - show welcome screen */
            TRACE_EVENT("xsfxsf pin_main():showwelcome()");
            showwelcome(idle_get_window());
            //Pin1OKOrNoPin1();  //xsf add 2002.10.09
            //network_start_full_service ();
        }
/* NM, 110702
   this destroy the only ONE SIM-handler which we have 
   after switching on !!
   It should be at least one SIM-handler activ all the  time 
                pin_destroy(pin_data->pin_win);// finish main pin dialog
*/

        //windowsUpdate();
        //dspl_Enable(uMode);			    		
        break;
        //begin of xsf add 2002.08.21
    case SETT_ABORT:
        dspl_ClearAll();
        pin_destroy(pin_data->pin_win);// destroy pin settings dialog
        break;
        //end of xsf add 2002.08.21
//nm insert new one
    case PIN1_STATUS_END:
        pin_destroy(pin_data->pin_win);// finish main pin dialog
        TRACE_EVENT("pin_destroy 3");
        break;
//nm		       
    case TXT_SIM_LOCK_ALL:
        pin_destroy(pin_data->pin_win);// finish main pin dialog
        TRACE_EVENT("pin_destroy 4");
        break;
    case PUK1_UNBL_SUCC:
        if ( (pin_data->pin_case EQ PUK1_END) || (pin_data->gsm_state && (pin_data->pin_case EQ INPUT_PUK1)) )
        /*	 sim lock check only after power on and puk verified */
        /* by PUK (normal way) or by gsm unblock string */
        {
            check_plock_to_clock(win,event);
        }
        else
        {

            main_call_mess(win,event);         

        }
        break;
    }

    switch ( event )
    {
    

    case SIM_NLOCK_REQ:
    case SIM_NSLOCK_REQ:
    case SIM_SPLOCK_REQ:
    case SIM_CLOCK_REQ:
        main_call_mess(win,event);
        break;
    case SIM_PLOCK:
        check_nlock_to_clock(win,event);
        break;
    case SIM_NLOCK:
        check_splock_to_clock(win,event);
        break;
    case SIM_SPLOCK:
        check_nslock_to_clock(win,event);
        break;
    case SIM_NSLOCK:
        check_sim_clock(win,event);
        break;
    case SIM_CLOCK:
        if ( sim_unlock_sim_lock(MFW_SIM_CLOCK,(UBYTE *)pin_data->pin)EQ MFW_SIM_CLOCK )/* unlock code  */
        {
            main_call_mess(win,SIM_UNLOCK_OK);        /* finish sim unlock procedure */
        }
        else if ( sim_unlock_sim_lock(MFW_SIM_CLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_UNLOCK_ERR )
        {
            main_call_mess(win,SIM_LOCK_ERR);
        }
        break;
    default:
        break;
    }
}


/*******************************************************************************

 $Function:	check_plock_to_clock 

 $Description:	sim lock check from PLOCK to CLOCK
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void check_plock_to_clock(T_MFW_HND win,USHORT event)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins:check_plock_to_clock");

    if ( sim_check_sim_Plock() EQ MFW_SIM_BLOCKED )
    {
        main_call_mess(win,SIM_LOCK_ALL);
    }
    else if ( sim_check_sim_Plock() EQ MFW_SIM_LOCKED )
    {
        main_call_mess(win,SIM_PLOCK_REQ);
    }
    else if ( sim_check_sim_Nlock() EQ MFW_SIM_LOCKED )
    {
        main_call_mess(win,SIM_NLOCK_REQ);
    }
    else if ( sim_check_sim_SPlock() EQ MFW_SIM_LOCKED )
    {
        main_call_mess(win,SIM_SPLOCK_REQ);
    }
    else if ( sim_check_sim_NSlock() EQ MFW_SIM_LOCKED )
    {
        main_call_mess(win,SIM_NSLOCK_REQ);
    }
    else if ( sim_check_sim_Clock() EQ MFW_SIM_LOCKED )
    {
        main_call_mess(win,SIM_CLOCK_REQ);
    }
    else
    {
        switch ( event )
        {
        case PIN_OK:

            /*
            *** registration in full service mode case: PIN was not necessary
            */
            /* SH - show welcome screen*/
            //xsf remarked 2002.10.08 showwelcome(idle_get_window());
            //nm_registration (NM_AUTOMATIC, 0, FALSE);
//GW-SPR#1035-Added STK Changes
/* NM, 110702
   this destroy the only ONE SIM-handler which we have 
   after switching on !!
   It should be at least one SIM-handler activ all the  time 
                pin_destroy(pin_data->pin_win);// finish main pin dialog
*/
            TRACE_EVENT("pin_destroy 5");
            //begin of xsf change 2002.10.09
            if ( CheckPassWord(PRO_ON) || CheckPassWord(PRO_SIMLOCK) )
            {
                if ( CheckPassWord(PRO_ON) )
                {
                    hostkey_init(0);    //xsf 2002.05.15
                }
                else if ( CheckPassWord(PRO_SIMLOCK) )
                {
                    if ( FlashHostkeyData.SimLockFlag==0 )
                    {
                        showwelcome(idle_get_window());
                        //Pin1OKOrNoPin1();  //xsf add 2002.10.09
                        //network_start_full_service ();
                        ReadSimIMSI();
                    }
                    else
                        JudgeSim();            
                }
            }
            else
            {
                /* SH - show welcome screen */
                showwelcome(idle_get_window());
                //Pin1OKOrNoPin1();  //xsf add 2002.10.09
                //network_start_full_service ();
            }
            //end of xsf add 2002.10.09		    

            break;
        case PIN_OK_INFO:
            main_call_mess(win,PIN_OK_INFO);
            break;
        case PUK1_UNBL_SUCC:
            main_call_mess(win,event);
            break;
        default:
            break;
        }
    }
}


/*******************************************************************************

 $Function:	check_nlock_to_clock
 $Description:	sim lock check from NLOCK to CLOCK
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void check_nlock_to_clock(T_MFW_HND win,USHORT event)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins:check_nlock_to_clock");

    if ( sim_unlock_sim_lock(MFW_SIM_PLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_PLOCK )/* P unlock code ok */
    {
        if ( sim_check_sim_Nlock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_NLOCK_REQ);        //check N unlock code
        }
        else if ( sim_check_sim_SPlock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_SPLOCK_REQ);       //check SP unlock code
        }
        else if ( sim_check_sim_NSlock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_NSLOCK_REQ);       //check NS unlock code
        }
        else if ( sim_check_sim_Clock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_CLOCK_REQ);        //check C unlock code
        }
        else                          /* finish sim unlock procedure */
        {
            main_call_mess(win,SIM_UNLOCK_OK);
        }
    }
    else if ( sim_unlock_sim_lock(MFW_SIM_PLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_UNLOCK_ERR )
    {
        main_call_mess(win,SIM_LOCK_ERR);
    }
}


/*******************************************************************************

 $Function:	check_splock_to_clock
 $Description:	sim lock check from SPLOCK to CLOCK
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void check_splock_to_clock(T_MFW_HND win,USHORT event)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins:check_splock_to_clock");

    if ( sim_unlock_sim_lock(MFW_SIM_NLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_NLOCK )
    {
        if ( sim_check_sim_SPlock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_SPLOCK_REQ);       //check SP unlock code
        }
        else if ( sim_check_sim_NSlock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_NSLOCK_REQ);       //check NS unlock code
        }
        else if ( sim_check_sim_Clock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_CLOCK_REQ);        //check C unlock code
        }
        else                          /* finish sim unlock procedure */
        {
            main_call_mess(win,SIM_UNLOCK_OK);        /* finish sim unlock procedure */
        }
    }
    else if ( sim_unlock_sim_lock(MFW_SIM_NLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_UNLOCK_ERR )
    {
        main_call_mess(win,SIM_LOCK_ERR);
    }
}


/*******************************************************************************

 $Function:	check_nslock_to_clock
 $Description:	sim lock check from NSLOCK to CLOCK
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void check_nslock_to_clock(T_MFW_HND win,USHORT event)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins:check_nslock_to_clock");

    if ( sim_unlock_sim_lock(MFW_SIM_SPLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_SPLOCK )/* unlock code ok */
    {
        if ( sim_check_sim_NSlock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_NSLOCK_REQ);       //check NS unlock code
        }
        else if ( sim_check_sim_Clock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_CLOCK_REQ);        //check C unlock code
        }
        else                          /* finish sim unlock procedure */
        {
            main_call_mess(win,SIM_UNLOCK_OK);        /* finish sim unlock procedure */
        }
    }
    else if ( sim_unlock_sim_lock(MFW_SIM_SPLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_UNLOCK_ERR )
    {
        main_call_mess(win,SIM_LOCK_ERR);
    }
}


/*******************************************************************************

 $Function:	check_sim_clock
 $Description:	sim lock check	CLOCK
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void check_sim_clock(T_MFW_HND win,USHORT event)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins:check_sim_lock");

    if ( sim_unlock_sim_lock(MFW_SIM_NSLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_NSLOCK )/* unlock code ok */
    {
        if ( sim_check_sim_Clock() EQ MFW_SIM_LOCKED )
        {
            main_call_mess(win,SIM_CLOCK_REQ);        //check C unlock code
        }
        else                          /* finish sim unlock procedure */
        {
            main_call_mess(win,SIM_UNLOCK_OK);        /* finish sim unlock procedure */
        }
    }
    else if ( sim_unlock_sim_lock(MFW_SIM_NSLOCK,(UBYTE *)pin_data->pin) EQ MFW_SIM_UNLOCK_ERR )
    {
        main_call_mess(win,SIM_LOCK_ERR);
    }
}

/*******************************************************************************

 $Function:	main_call_mess 
 $Description:	help function for message dialog
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void main_call_mess(T_MFW_HND win, USHORT event)
{

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    T_MFW_HND pin_mess_win;
    TRACE_EVENT("MmiPins: main_call_mess");
    animation_complete = 1;    //GANCHH 2002/9/4 make power off availabe in pin input

    pin_mess_win = pin_mess_create(pin_data->pin_win);
    if ( pin_mess_win )
    {
        SEND_EVENT(pin_mess_win,event,0,pin_data);
    }
}


/*******************************************************************************

 $Function:	main_call_edit 
 $Description:	help function for editor dialog
 $Returns:		void
 $Arguments:	window, window handler event
 
*******************************************************************************/
static void main_call_edit(T_MFW_HND win,USHORT event)
{

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    T_MFW_HND pin_edt_win;

    HUPKeyOrigin=1;//ganchh for power off while no sim card
    animation_complete=1;
    pin_edt_win = pin_edt_create(pin_data->pin_win);
    if ( pin_edt_win )
    {
        SEND_EVENT(pin_edt_win,event,0,pin_data);
    }
}


/*******************************************************************************

 $Function:	pin_edt_create 
 $Description:	Creation of an instance  for the PIN Editor dialog.
        Type of dialog : SINGLE_DYNAMIC
 $Returns:		void
 $Arguments:	parent window
 
*******************************************************************************/
T_MFW_HND pin_edt_create (T_MFW_HND parent_window)
{
    T_pin_edt * data = (T_pin_edt *)ALLOC_MEMORY (sizeof (T_pin_edt));

    T_MFW_WIN * win;

    data->pin_edt_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)pin_edt_win_cb);
    TRACE_FUNCTION("pin_edt_create");
    if ( data->pin_edt_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    pin_edit_windows = data->pin_edt_win;
    data->mmi_control.dialog    = (T_DIALOG_FUNC)pin_editor;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->pin_edt_win)->data;
    win->user           = (void *) data;

    /*
     * Create any other handler
     */

    data->tim_out_handle = tim_create(data->pin_edt_win,TIMEOUT,(T_MFW_CB)pin_edt_tim_out_cb);
    data->editor_handle = edt_create(data->pin_edt_win,&data->editpinAttr,0,0);
    data->kbd_handle = kbd_create(data->pin_edt_win,KEY_ALL|KEY_MAKE,(T_MFW_CB)pin_edt_kbd_cb);
    data->kbd_long_handle = kbd_create(data->pin_edt_win,KEY_ALL | KEY_LONG,(T_MFW_CB)pin_edt_kbd_long_cb);
    /*
     * return window handle
     */
    return data->pin_edt_win;
}


/*******************************************************************************

 $Function:	pin_edt_destroy 
 $Description:	Destroy the pin editor dialog.
 $Returns:		void
 $Arguments:	window
 
*******************************************************************************/
void pin_edt_destroy  (T_MFW_HND own_window)
{
    T_pin_edt * data ;
    T_MFW_WIN * win;


    if ( own_window )
    {
        TRACE_FUNCTION("pin_edt_destroy");
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_pin_edt *)win->user;

        if ( data )
        {
            /*
             * Delete WIN Handler and children handler
             */
            pin_edit_windows = 0;
            win_delete (data->pin_edt_win);
            // + KGT 19.7.2000
            //mfwFree((U8 *)data,(sizeof(T_pin_edt)));;
            FREE_MEMORY((void *)data,(sizeof(T_pin_edt)));;
            // - KGT 19.7.2000
        }
    }
}


/*******************************************************************************

 $Function:	pin_edt_win_cb
 $Description:	Callback function for editor windows
 $Returns:		Status int
 $Arguments:	window handle event, window
 
*******************************************************************************/
static int pin_edt_win_cb (T_MFW_EVENT event,T_MFW_WIN * win)
{
    T_pin_edt * edt_data = (T_pin_edt *)win->user;//pin edt data
    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin     * pin_data = (T_pin *)win_pin->user; // pin main data
    game_Line line;
    
    
    if ( event EQ MfwWinVisible )
    {
        dspl_ClearAll();   

#if  (MAIN_LCD_SIZE==3)//jhxu720
		drawSolidRectangle(11,26,107,76, 1,0x5ac7ff,0x4E9C87);
#elif ( MAIN_LCD_SIZE==4 )
		drawSolidRectangle(11,26,107,76, 1,0x5ac7ff,0x4E9C87);
#elif ( MAIN_LCD_SIZE==2 )
		drawSolidRectangle(10, FIRST_LINE-2, 92, THIRD_LINE+1 , 1, 0x5ac7ff, 0x4E9C87);
#endif
		//2004-04-06 Sunny add end

        //dspl_Clear(6,30,120,141);   //clear text of TxtPleaseWait
        //begin of xsf add 2003.04.10
        if ( ((pin_data->pin_retries EQ 1) ||(pin_data->pin_retries EQ 2)) && (pin_data->display_id1 == TxtEnterPin1) )
        {
			//2004-04-06 Sunny modify
            ALIGNED_PROMPT(CENTER,FOURTH_LINE, DSPL_TXTATTR_TRANSPARENT, pin_data->display_id2);   
            ALIGNED_PROMPT(CENTER,FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, pin_data->display_id1);   
        }
        //end of xsf add 2003.04.10
        else
            ALIGNED_PROMPT(CENTER,FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, pin_data->display_id1);    

		//2004-04-06 Sunny remove
		// drawSolidRectangle(14,70,105,88, 1,0x5ac7ff,0x4E9C87);

		
	
        if ( edt_data->editor_index NEQ 0 )
        {
            memset(edt_data->pin_dspl, '\0', MAX_PIN+1);
            memset(edt_data->pin_dspl, '*', edt_data->editor_index);


			//2004-04-06 Sunny remove
			//dspl_colorTextOut(16, 72, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );

#if (MAIN_LCD_SIZE==3)//jhxu720
dspl_colorTextOut(16, 54, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );    
#elif ( MAIN_LCD_SIZE==4 )
dspl_colorTextOut(16, 54, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );    
#elif ( MAIN_LCD_SIZE==2)
dspl_colorTextOut(16, SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );
#endif
			//2004-04-06 Sunny add end
		 
            check_pins(win, edt_data); 
        }
        else if ( edt_data->editor_index EQ 0 )
        {
            displaySoftKeys('\0','\0');   
        }

		//2004-04-06 Sunny remove
        /*line.x1=14;
        line.y1=70;
        line.x2=14;
        line.y2=88;
        line.color=0x5ac7ff;
        DrawLine(line);
        line.x1=16+8*edt_data->editor_index;
        line.y1=86;
        line.x2=22+8*edt_data->editor_index;
        line.y2=86;*/

#if (MAIN_LCD_SIZE==3)//jhxu720
		line.x1=16+8*edt_data->editor_index;
		line.y1=66;
		line.x2=22+8*edt_data->editor_index;
		line.y2=66;    
#elif ( MAIN_LCD_SIZE==4 )
			line.x1=16+8*edt_data->editor_index;
			line.y1=66;
			line.x2=22+8*edt_data->editor_index;
			line.y2=66;
#elif ( MAIN_LCD_SIZE==2 )
			line.x1=16+6*edt_data->editor_index;
			line.y1=THIRD_LINE;
			line.x2=22+6*edt_data->editor_index;
			line.y2=THIRD_LINE;
#endif
		//2004-04-06 Sunny add end

        line.color=0x00008b ;  // ɫ darkblue 00008b 
        DrawLine(line);  //draw cursor line
        return 1;
    }
    return 0;
}


/*******************************************************************************

 $Function:	pin_edt_kbd_cb 
 $Description:	Callback function for keyboard
 $Returns:		Status int
 $Arguments:	window handle event, keyborad control block
 
*******************************************************************************/
static int pin_edt_kbd_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;//pin edt data

    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin * pin_data = (T_pin *)win_pin->user; // pin main data
    T_sim_rem * sim_rem_data = (T_sim_rem *)win_pin->user; //sim_rem data possible too

    char timer = TRUE;
    timStop(edt_data->tim_out_handle);/* stop entering timer      */

    TRACE_EVENT("MmiPins:pin_edt_kbd_cb");

    if ( !(event & KEY_MAKE) )
        return MFW_EVENT_CONSUMED;

    switch ( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        //case KCD_STAR:
        if ( edt_data->editor_index < MAX_DIG )
        {
            if ( kc->code EQ KCD_STAR )
                edt_data->pin[edt_data->editor_index] = STAR;
            else
                edt_data->pin[edt_data->editor_index] = '0' + kc->code;

            if ( (edt_data->pin_case_edit NEQ CARD_REJECTED) AND (edt_data->pin_case_edit NEQ INSERT_CARD) )
            {
                //xsf 2003.02.20 edtChar(edt_data->editor_handle,'*');			       /* hide security code */
                //		edtChar(edt_data->editor_handle,ecRight);

            }
            else
            {

                edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);     /* not hide emergency call */
                //		edtChar(edt_data->editor_handle,ecRight);
            }
            edt_data->editor_index++;
            check_pins(win, edt_data);          /*	digits check depends on status pin_case */
            if ( edt_data->gsm_state )
                pin_data->gsm_state = edt_data->gsm_state;

        }
        winShow(edt_data->pin_edt_win);
        break;
        //case KCD_HASH:
    case KCD_LEFT:
    case KCD_OK:  //xsf add KCD_OK=KCD_LEFT 2003.02.19
        switch ( edt_data->pin_case_edit )
        {
        case INSERT_CARD:
        case CARD_REJECTED:
            if ( edt_data->emergency_call )
            {
                emerg_pin(edt_data);                /* start emergency call  */
                timer = FALSE;
            }
            else
            {
                clear_edit_array (edt_data);
                memset(edt_data->pin,'\0', sizeof(edt_data->pin));/* initial string */
                edt_data->editor_index = 0;
            }
            break;
            //begin of xsf add 2002.08.21
        case INPUT_PIN1:    /* finish of PIN entering */
            //begin of xsf add for making emergency call in pin enter window 2003.05.06
            if ( edt_data->emergency_call )
            {
                emerg_pin(edt_data);                /* start emergency call  */
                timer = FALSE;
                break;
            }
            //end of xsf add for making emergency call in pin enter window 2003.05.06

            if ( (strlen((char*)edt_data->pin) >= MIN_PIN) && !(edt_data->gsm_state) )
            {
                clear_edit_array(edt_data);     /*	   clear editor array */
                timer = FALSE;
                strncpy((char*)edt_data->old_pin,(char*)edt_data->pin,MAX_PIN);
                strncpy((char*)pin_data->old_pin, (char*)edt_data->old_pin,MAX_PIN);
                pin_edt_destroy(edt_data->pin_edt_win);
                SEND_EVENT(pin_data->pin_win,PIN1_END,0,pin_data);
            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) ) /* could become gsm */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) ) /* finish gsm string */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    if ( edt_data->pin_case_edit EQ INPUT_PIN1 )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    gsm_sec_execute_set(win,edt_data);      /* execute gsm string */
                }
            }
            break;
        case INPUT_PUK1:
            //begin of xsf add for making emergency call in pin enter window 2003.05.06
            if ( edt_data->emergency_call )
            {
                emerg_pin(edt_data);                /* start emergency call  */
                timer = FALSE;
                break;
            }
            //end of xsf add for making emergency call in pin enter window 2003.05.06
            if ( (strlen((char*)edt_data->pin) EQ MAX_PIN) && !(edt_data->gsm_state) ) /* finish of PUK entering */
            {
                TRACE_EVENT("clear softkey 13");                                
                clear_edit_array (edt_data);        /* clear editor array */
                timer = FALSE;
                strncpy((char*)edt_data->puk,(char*)edt_data->pin,MAX_PIN);/* store puk  */
                strncpy((char*)pin_data->puk, (char*)edt_data->puk,MAX_PIN);
                if ( pin_data->pin_case EQ INPUT_PUK1 )
                {
                    dspl_ClearAll();
                    pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN,0,pin_data);/* entering new pin1 start*/
                }

            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) )/* could become gsm	    */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) )/* finish gsm string  */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    gsm_sec_execute_set(win,edt_data);        /* execute gsm string  */
                }
            }
            break;
        case INPUT_NEW_PIN:
            /* finish of new PIN entering */
            if ( (strlen((char*)edt_data->pin) >= MIN_PIN) && !(edt_data->gsm_state) )
            {
                clear_edit_array (edt_data);              /* clear editor array */
                timer = FALSE;
                strncpy((char*)edt_data->new_pin, (char*)edt_data->pin,MAX_PIN);      /*  store new pin	  */
                strncpy((char*)pin_data->new_pin, (char*)edt_data->new_pin,MAX_PIN);
                pin_edt_destroy(edt_data->pin_edt_win);       /* entering new pin1 again*/
                SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN_AGAIN,0,pin_data);

            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) ) /* could become gsm	    */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) )/* finish gsm string  */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    if ( edt_data->pin_case_edit EQ INPUT_NEW_PIN )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    gsm_sec_execute_set(win,edt_data);        /* execute gsm string  */
                }
            }
            break;
        case INPUT_NEW_PIN_AGAIN:     /* finish of new PIN confirm */
            if ( (strlen((char*)edt_data->pin) >= MIN_PIN) && !(edt_data->gsm_state) )
            {
                clear_edit_array (edt_data);              /* clear editor array */
                timer = FALSE;
                if ( strcmp((char*)edt_data->pin, (char*)pin_data->new_pin) EQ 0 ) /* compare PINs successfull*/
                {
                    strncpy((char*)pin_data->new_pin, (char*)edt_data->pin,MAX_PIN);
                    pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,NEW_PIN_END,0,pin_data);/* changing PIN1 */
                }
                else
                {
                    pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,NEW_PIN_FAIL,0,NULL);
                }
            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) ) /* could become gsm	    */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) )/* finish gsm string  */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    if ( edt_data->pin_case_edit EQ INPUT_NEW_PIN_AGAIN )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    gsm_sec_execute_set(win,edt_data);         /* execute gsm string */
                }
            }
            break;

            //end of xsf add 2002.08.21
        case SIM_PLOCK:
            timer = FALSE;
            strncpy((char*)pin_data->pin,(char*)edt_data->pin,MAX_PIN);
            pin_edt_destroy(edt_data->pin_edt_win);
            SEND_EVENT(pin_data->pin_win,SIM_PLOCK,0,pin_data);//check P unlock code
            break;
        case SIM_NLOCK:
            strncpy((char*)pin_data->pin,(char*)edt_data->pin,MAX_PIN);
            pin_edt_destroy(edt_data->pin_edt_win);
            timer = FALSE;
            SEND_EVENT(pin_data->pin_win,SIM_NLOCK,0,pin_data);
            break;
        case SIM_SPLOCK:
            strncpy((char*)pin_data->pin,(char*)edt_data->pin,MAX_PIN);
            pin_edt_destroy(edt_data->pin_edt_win);
            timer = FALSE;
            SEND_EVENT(pin_data->pin_win,SIM_SPLOCK,0,pin_data);
            break;
        case SIM_NSLOCK:
            strncpy((char*)pin_data->pin,(char*)edt_data->pin,MAX_PIN);
            pin_edt_destroy(edt_data->pin_edt_win);
            timer = FALSE;
            SEND_EVENT(pin_data->pin_win,SIM_NSLOCK,0,pin_data);
            break;
        case SIM_CLOCK:
            strncpy((char*)pin_data->pin,(char*)edt_data->pin,MAX_PIN);
            pin_edt_destroy(edt_data->pin_edt_win);
            timer = FALSE;
            SEND_EVENT(pin_data->pin_win,SIM_CLOCK,0,pin_data);
            break;
        default:
            break;
        }
        break;
        //begin of xsf add 2002.08.21 
    case KCD_HUP:
        HUPKeyOrigin = 1;   //ganchh 2002/9/5
    case KCD_RIGHT:
#ifndef _M188_	/* 2004/06/29 sunsj modify for m288b */
	case KCD_CLEAR:
#endif
        if ( edt_data->editor_index EQ 0 )
            ;
        else
            edt_data->editor_index--;

        edt_data->pin[edt_data->editor_index] = '\0';
        //xsf 2003.02.20 edtChar(edt_data->editor_handle,ecBack);/* delete character    */

        if ( strlen((char*)edt_data->pin) < MIN_PIN )
        {
            TRACE_EVENT("clear softknr 4");
            //CLEAR_PIN_EDIT_AREA
        }

        edt_data->emergency_call = FALSE;
        //begin of xsf comment 2003.05.06
        // if(edt_data->pin_case_edit EQ INPUT_PUK1)  /* special case ?? */
        //	winShow(edt_data->pin_edt_win);
        //else
        //end of xsf comment 2003.05.06
        check_pins(win,edt_data);      /* check remain for emergency call  */
        winShow(edt_data->pin_edt_win);
        break;
    default:
        return MFW_EVENT_CONSUMED;
    }
    if ( timer )
        tim_start(edt_data->tim_out_handle);/* start timer for entering */
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:	check_pins  
 $Description:	check pins input string
 $Returns:		none
 $Arguments:	window, pin editor attributes
 
*******************************************************************************/
static void check_pins (T_MFW_HND win, void * edt_pin)
{
    T_pin_edt * edt_data = (T_pin_edt *)edt_pin;
    TRACE_FUNCTION("MmiPins:check_pins");

    if ( strlen((char*)edt_data->pin)NEQ 0 )
    {
        displaySoftKeys(TxtNull,TxtDelete);
        if ( strlen((char*)edt_data->pin) > FIRST_DIGIT )        /* for every character  */
        {
            if ( strlen((char*)edt_data->pin) >= MAX_PIN )   //xsf change 3 to 4 2002.08.21)  //MIN_PIN
            {
                TRACE_EVENT("Softkeys:INPUT_PUK1/2");
                displaySoftKeys(TxtSoftOK,TxtDelete);  
            }
            else if ( strlen((char*)edt_data->pin) >= MIN_PIN )   //xsf change 3 to 4 2002.08.21)  //MIN_PIN
            {
                TRACE_EVENT("Softkeys:nr 1");
                //CLEAR_PIN_EDIT_AREA /* clear button */
                if ( (edt_data->pin_case_edit NEQ INPUT_PUK1) && (edt_data->pin_case_edit NEQ INPUT_PUK2) )
                    displaySoftKeys(TxtSoftOK,TxtDelete);
            }

            else
            {
                TRACE_EVENT("Softkeys:nr 1a");
                displaySoftKeys('\0',TxtDelete);
            }
//nm insert +
// this is after switch on the mobile, 
// it is requesting the pin 1 
//			else
//			{
//				TRACE_EVENT("Softkeys:nr 1a");
//				displaySoftKeys('\0',TxtDelete);
//			}
//nm insert -

            gsm_test(win,edt_data);       /* test if GSM string or not*/
        }

        if ( strlen((char*)edt_data->pin) EQ (MIN_PIN - 1) )
        {
            if ( cm_check_emergency((U8*)edt_data->pin) )/* test emergency call*/
            {
                TRACE_EVENT("MmiPins:check_pins:emercall");
                edt_data->emergency_call = TRUE;
                displaySoftKeys(TxtSoftCall,'\0');/*display CALL button*/
            }
            else
            {
                if ( (edt_data->pin_case_edit EQ CARD_REJECTED) OR (edt_data->pin_case_edit EQ INSERT_CARD) )
                {             /* delete all digits	    */
                    clear_edit_array (edt_data);  /*  clear editor array	 */
                    memset(edt_data->pin, '\0', sizeof(edt_data->pin));/* initial string */
                    edt_data->editor_index = 0;
//JVJE					soundExec(SoundsErrorTone,0); /* error tone will be generated  */
                }
                edt_data->emergency_call = FALSE;
            }
        }
        if ( (strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) < (MAX_PIN + 1)) )
        {
            if ( ((edt_data->pin_case_edit EQ CARD_REJECTED) OR (edt_data->pin_case_edit EQ INSERT_CARD)) && !(edt_data->gsm_state) )
            {
                if ( edt_data->editor_index EQ 0 )
                    ;
                else
                    edt_data->editor_index--;         /* only emergency calls, 3 digits */

                edt_data->pin[edt_data->editor_index] = '\0';
                edtChar(edt_data->editor_handle,ecBack);
//JVJE				soundExec(SoundsErrorTone,0); /* error tone will be generated  */
            }
            else
            {
                TRACE_EVENT("clear softknr 5");
                //CLEAR_PIN_EDIT_AREA /* clear button */
                if ( ((edt_data->pin_case_edit EQ INPUT_PUK1) ||(edt_data->pin_case_edit EQ INPUT_PUK2)) && !(edt_data->gsm_state) )
                {       /* PUK 1/2 (not by gsm string) max. 8 digits  */
                    if ( strlen((char*)edt_data->pin) >= MAX_PIN )
                    {
                        TRACE_EVENT("Softkeys:nr 2");
                        //displaySoftKeys(TxtSoftOK,TxtDelete);/* display OK button */
                    }
                }
                else if ( (edt_data->pin_case_edit EQ SIM_CLOCK) ||
                          (edt_data->pin_case_edit EQ SIM_NLOCK) ||
                          (edt_data->pin_case_edit EQ SIM_NSLOCK) ||
                          (edt_data->pin_case_edit EQ SIM_SPLOCK) )
                {        /* sim lock code  max. 8 digits exept PLOCK  */
                    if ( strlen((char*)edt_data->pin) >= MAX_PIN )
                    {
                        TRACE_EVENT("Softkeys:nr 3");
                        //displaySoftKeys(TxtSoftOK,TxtDelete);/* display OK button */
                    }
                }
                else if ( edt_data->pin_case_edit EQ SIM_PLOCK )
                {          /* sim lock	PLOCK code  max. 6 digits */
                    if ( strlen((char*)edt_data->pin) >= NUM_OF_PLOCK )
                    {
                        TRACE_EVENT("Softkeys:nr 4");
                        //displaySoftKeys(TxtSoftOK,TxtDelete);/* display OK button */
                    }
                }
                else
                {
                    if ( !(edt_data->gsm_state) )    /* usual way for PIN 4 digits     */
                    {
                        TRACE_EVENT("softkey 5");
                        //displaySoftKeys(TxtSoftOK,TxtDelete);

                    }
                    else
                    {
                        TRACE_EVENT("clear softkey 6");
                        CLEAR_PIN_EDIT_AREA /* clear button */
                    }
                }
                edt_data->emergency_call = FALSE;
            }
        }
        if ( (strlen((char*)edt_data->pin) > MAX_PIN) && !(edt_data->gsm_state) ) /* >8 digits not allowed    */
        {
            if ( edt_data->editor_index EQ 0 )
                ;
            else
                edt_data->editor_index--;

            edt_data->pin[edt_data->editor_index] = '\0';
            //xsf 2003.02.20 edtChar(edt_data->editor_handle,ecBack);
        }
    }
    else
        displaySoftKeys('\0','\0');
}


/*******************************************************************************

 $Function:	gsm_test 
 $Description:	test if gsm string
 $Returns:		Status int
 $Arguments:	window, pin editor attributes
 
*******************************************************************************/
static int gsm_test(T_MFW_HND win,void * edt_pin)
{
    int status;
    T_pin_edt * edt_data = (T_pin_edt *)edt_pin;

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin * pin_data = (T_pin *)win_pin->user; // pin main data

    TRACE_FUNCTION("MmiPins:gsm_test");

    //status = ss_check_ss_string((UBYTE*)edt_data->pin);/* check GSM-String */
    status =ss_check_ss_string_pin((UBYTE*)edt_data->pin);/* check GSM-String  ganchh 2002/9/4*/
    switch ( status )
    {
    case MFW_SS_SIM_UNBLCK_PIN:
        if ( !(edt_data->gsm_state) )
        {
            switch ( edt_data->pin_case_edit )
            {
            case INPUT_PUK1:/* replace * with string id */
                if ( !(strncmp((char*)edt_data->pin,"**05*",IDENT_GSM_1)) )
                {
                    edt_data->gsm_state = TRUE;
                    strncpy((char*)edt_data->edtbuf,(char*)edt_data->pin,edt_data->editor_index-1);
                    edtShow(edt_data->editor_handle);
                }
                else
                {
                    edt_data->gsm_state = FALSE;
                    TRACE_EVENT("dsplClearAll 2");                              
                    dspl_ClearAll();
                    clear_edit_array (edt_data);
                    pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                }
                break;
            default:
                edt_data->gsm_state = FALSE;
                TRACE_EVENT("dsplClearAll 3");                          
                dspl_ClearAll();
                clear_edit_array (edt_data);
                pin_edt_destroy(edt_data->pin_edt_win);
                SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                break;
            }
        }
        return status;
    case MFW_SS_DIAL:          /* string not yet detected  */
    case MFW_SS_USSD:  /*JVJ SPR 1040- The short USSD strings should also be 
                          considered in this case, since they can be confused with dialled numbers  
                         */
        edt_data->gsm_state = FALSE;
        return status;
    default:
        TRACE_EVENT("MmiPins:default in gsm_test");     
        edt_data->gsm_state = FALSE;
        TRACE_EVENT("dsplClearAll 4");                          
        dspl_ClearAll();
        clear_edit_array (edt_data);
        pin_edt_destroy(edt_data->pin_edt_win);
        SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
        return status;
    }
}



/*******************************************************************************

 $Function:	gsm_sec_execute
 $Description:	GSM-String will be executed
 $Returns:		None
 $Arguments:	window, string
 
*******************************************************************************/
static void gsm_sec_execute(T_MFW_HND win,void *string)
{

    T_pin_edt * edt_data = (T_pin_edt *)string;

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin * pin_data = (T_pin *)win_pin->user; // pin main data

    int result;

    TRACE_FUNCTION("MmiPins:gsm_sec_execute");

    result = ss_execute_transaction((UBYTE*)edt_data->pin,0);/* ussd_man = 0 while SSD */

    TRACE_EVENT("dsplClearAll 5"); 
    dspl_ClearAll();
    clear_edit_array (edt_data);
    pin_edt_destroy(edt_data->pin_edt_win);

    switch ( result )
    {
    case MFW_SS_SIM_REG_PW:     /* change PIN1/2	     */
        TRACE_EVENT("MmiPins:gsm_sec_execute:MFW_SS_SIM_REG_PW");
        break;
    case MFW_SS_SIM_UNBLCK_PIN: /* unblock PIN1/2	    */
        TRACE_EVENT("MmiPins:gsm_sec_execute:MFW_SS_SIM_UNBLCK_PIN");
        break;
    case MFW_SS_FAIL:
        TRACE_EVENT("MmiPins:gsm_sec_execute:MFW_SS_FAIL");
        SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/* new PIN and new PIN again are not the same */
        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:	pin_edt_kbd_long_cb
 $Description:	Callback function for keyboard long
 $Returns:		Status int
 $Arguments:	window handler event, keyboard control block 
 
*******************************************************************************/
static int pin_edt_kbd_long_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;//pin edt data

    TRACE_FUNCTION("MmiPins:pin_edt_kbd_long_cb");

    if ( (event & KEY_CLEAR) && (event & KEY_LONG) )
    {
        timStop(edt_data->tim_out_handle); /* stop entering timer	*/
        clear_edit_array(edt_data);
        memset(edt_data->pin,'\0',sizeof(edt_data->pin));/* initial string */
        edt_data->editor_index = 0;
        edt_data->emergency_call = FALSE;
        winShow(edt_data->pin_edt_win);
        return MFW_EVENT_CONSUMED;
    }
    if ( (kc->code == KCD_HUP) && (event & KEY_LONG) )
    {
        HUPKeyOrigin = 1;
        TRACE_EVENT("XSF:pin_edt_kbd_long_cb KCD_HUP");
        return MFW_EVENT_CONSUMED;
    }
    return MFW_EVENT_CONSUMED;
}




/*******************************************************************************

 $Function:	pin_edt_tim_out_cb
 $Description:	Callback function for timer (watchdog entering)
 $Returns:		void
 $Arguments:	window handler event, timer control block 
 
*******************************************************************************/
static void pin_edt_tim_out_cb (T_MFW_EVENT event,T_MFW_TIM * t)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;

    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin * pin_data = (T_pin *)win_pin->user; // pin main data

    TRACE_FUNCTION("MmiPins:pin_edt_tim_out_cb");
    // clear the input
    dspl_Clear(0,30,SCREEN_SIZE_X,STANDARD_MENU_VERTICAL_SIZE);
    TRACE_EVENT("clear softkey 7");

    clear_edit_array(edt_data);
    // clear the softkeys
    dspl_Clear(0,STANDARD_MENU_VERTICAL_SIZE,SCREEN_SIZE_X,SCREEN_SIZE_Y);  
    memset(edt_data->pin, '\0', sizeof(edt_data->pin));/* initial string  */
    edt_data->editor_index = 0;
    edt_data->gsm_state = FALSE;
    pin_data->gsm_state = FALSE;

    winShow(edt_data->pin_edt_win);
}



/*******************************************************************************

 $Function:	pin_editor 
 $Description:	Pin editor Dialog Signal Handling function
 $Returns:		void
 $Arguments:	window, window handler event, value, parameter 
 
*******************************************************************************/
static void pin_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;
    T_pin * pin_data = (T_pin *)parameter;//pin main data

    edt_data->pin_case_edit = pin_data->pin_case;

    TRACE_EVENT("MmiPins:pin_editor");

    /*
     * depending on event
     */
    switch ( event )
    {
    case INPUT_PIN1:
    case INPUT_PUK1:
    case INPUT_NEW_PIN:
    case INPUT_NEW_PIN_AGAIN:
    case CARD_REJECTED:
    case INSERT_CARD:
    case SIM_PLOCK:
    case SIM_NLOCK:
    case SIM_NSLOCK:
    case SIM_SPLOCK:
    case SIM_CLOCK:
        //SPR#717 - GW - Wrong structures being cleared
        memset(edt_data->pin, '\0', sizeof(edt_data->pin));/* initial string  */
        memset(edt_data->puk, '\0', sizeof(edt_data->puk));
        memset(edt_data->new_pin, '\0', sizeof(edt_data->new_pin));
        memset(edt_data->old_pin, '\0', sizeof(edt_data->old_pin));
        clear_edit_array(edt_data);      //clear editor buffer xsf add 2002/10/16

        // the coordinate of the editor (enter the pin)
        //reset_edt_attr(16,71,72,16,0,0,edtCurBar1,0,(char*)edt_data->edtbuf,MAX_DIG,&edt_data->editpinAttr);

        edt_data->editor_index = 0;
//		edtShow(edt_data->editor_handle);
        winShow(edt_data->pin_edt_win);

        break;
    default:
        break;
    }
}


/*******************************************************************************

 $Function:	pin_mess_create 
 $Description:	Creation of an instance  for the PIN Message dialog.
        Type of dialog : SINGLE_DYNAMIC
 $Returns:		window
 $Arguments:	parent win
 
*******************************************************************************/
T_MFW_HND pin_mess_create (T_MFW_HND parent_window)
{
    T_pin_mess * data = (T_pin_mess *)ALLOC_MEMORY (sizeof (T_pin_mess));

    T_MFW_WIN * win;

    data->pin_mess_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)pin_mess_win_cb);

    TRACE_FUNCTION("MmiPins:pin_mess_create");

    if ( data->pin_mess_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    pin_mess_windows = data->pin_mess_win;
    data->mmi_control.dialog    = (T_DIALOG_FUNC)pin_messages;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->pin_mess_win)->data;
    win->user           = (void *) data;

    /*
     * return window handle
     */
    return data->pin_mess_win;
}


/*******************************************************************************

 $Function:	pin_mess_destroy 
 $Description:	Destroy the pin message dialog.
 $Returns:		none
 $Arguments:	win
 
*******************************************************************************/
void pin_mess_destroy  (T_MFW_HND own_window)
{
    T_pin_mess * data;
    T_MFW_WIN * win;

    if ( own_window )
    {
        TRACE_FUNCTION("MmiPins:pin_mess_destroy ");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_pin_mess *)win->user;

        if ( data )
        {
            //Delete WIN Handler

            pin_mess_windows = 0;
            win_delete (data->pin_mess_win);
            // + KGT 19.7.2000
            //mfwFree((U8 *)data,(sizeof(T_pin_mess)));
            FREE_MEMORY((void *)data,(sizeof(T_pin_mess)));
            // - KGT 19.7.2000
        }
    }
}


/*******************************************************************************

 $Function:	pin_mess_win_cb 
 $Description:	Callback function for message windows
 $Returns:		Status int
 $Arguments:	event, window
 
*******************************************************************************/
static int pin_mess_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}




/*******************************************************************************

 $Function:	pin_messages
 $Description:	Pin message Dialog Handling function
 $Returns:		none
 $Arguments:	window, event, value, parameter
 
*******************************************************************************/
void pin_messages(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_mess * mess_data = (T_pin_mess *)win_data->user;

    T_DISPLAY_DATA display_info;
    T_MFW_SIM_PIN_STATUS status; //need to check the Pin 1 status
    EF_SIMLCK simlck;
    ULONG timcount = TIM_LOCK;
    UBYTE i;
    char debug[20];
    T_pin * pin_data = (T_pin *)parameter;
    T_sim_rem * sim_rem_data = (T_sim_rem *)parameter;// sim_rem_data possible too

    TRACE_FUNCTION("Mmi.Pins:pin_messages");
    sprintf(debug, "Event: %d", event);
    TRACE_EVENT(debug);

    dialog_info_init(&display_info);//gdy add
    /*
     * depending on signal
     */
    switch ( event )
    {
    case PIN1_REQ_ATT:
    case PUK1_REQ_ACT_INFO:
    case PUK1_REQ_VER_INFO:
    case GSM_FAIL:
    case NEW_PIN_FAIL:
    case PIN_OK_INFO:
    case PUK1_UNBL_FAIL_INFO:
    case PUK1_UNBL_SUCC:
    case PUK1_UNBL_FATAL_ERROR:
    case SIM_UNLOCK_OK:
    case PIN1_STATUS:

        switch ( event )
        {
        case PIN1_REQ_ATT:

            pin_data->pin_case = PIN1_REQ;
            if ( pin_data->display_id1 EQ TxtEnterPin1 )   //xsf changed for check pin1 when turning on 2003.04.10
            {
                display_info.TextId2 = TxtPINFail;
                //display_info.TextId = 0;
                /*if(pin_data->pin_retries EQ 1)
                  display_info.TextId = TxtOneAttemptLeft;
                else
                  display_info.TextId = TxtTwoAttemptsLeft; xsf 2003.04.10*/
                display_info.iconindex = REMIND_FAILURE; 
                break;
            }
            else   //xsf changed for check pin1 when turning on(don't disply the fail dialog)2003.04.10
            {
                pin_mess_destroy(mess_data->pin_mess_win);
                SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);       
                return;
            }
        case PUK1_REQ_ACT_INFO:  //checked when start the phone
            pin_data->pin_case = PUK1_REQ;
            display_info.TextId2 = TxtSimBlocked;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex  =REMIND_NORECORD;
            break;
        case PUK1_REQ_VER_INFO:  //checked when input pin1 up to 3 three times
            pin_data->pin_case = PUK1_REQ;
            display_info.TextId2 =TxtPINBlock;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex  =REMIND_NORECORD;

            break;
        case GSM_FAIL:
            display_info.TextId2 = TxtNotAcc;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex  =REMIND_NORECORD;
            break;
        case PUK1_UNBL_FATAL_ERROR:
            pin_data->pin_case = PUK1_REQ;
            display_info.TextId2 = TxtNotAcc;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex  =REMIND_NORECORD;
            break;
        case NEW_PIN_FAIL:
            pin_data->pin_case = INPUT_NEW_PIN;
            //display_info.TextId = TxtNewPIN;
            display_info.TextId2 = TxtChangeFail;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PIN_OK_INFO:
            pin_data->pin_case = PIN_OK;
            display_info.TextId2 = TxtPINOK;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_SUCCEED; 
            break;
        case PUK1_UNBL_FAIL_INFO:
            pin_data->pin_case = PUK1_REQ;
            display_info.TextId2 = TxtPuk1Inc;   //xsf change TxtCodeInc to TxtPuk1Inc 2002.08.29
            //display_info.TextId = TxtNull;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PUK1_UNBL_SUCC:
            pin_data->pin_case = PIN_OK;
            //display_info.TextId = TxtNewPIN;
            display_info.TextId2 = TxtChangPin;  //TxtChanged;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_SUCCEED; 
            break;
        case SIM_UNLOCK_OK:
            pin_data->pin_case = PIN_OK;
            display_info.TextId2 = TxtUnlockOK;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_SUCCEED; 
            break;
//nm insert new one
        case PIN1_STATUS:
            pin_data->pin_case = PIN1_STATUS;

            if ( pin_data->set_state EQ ENABLE )
            {
                display_info.TextId2 = TxtEnabled;
            }
            else
            {
                display_info.TextId2 = TxtDisabled;
            }

            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_COMPLETE; 
            break;
//NM

        }
        //display_info.TextString = 0;
        //display_info.LeftSoftKey = 0;
        //display_info.RightSoftKey = 0;
        display_info.Time = THREE_SECS;  //xsf 2002.09.04 THREE_SECS;
        display_info.KeyEvents = KEY_LEFT | KEY_RIGHT|KEY_HUP;  //xsf changed KEY_ALL to KEY_LEFT | KEY_RIGHT 2002.11.08;
        display_info.Identifier = pin_data->pin_case;
        display_info.Callback = (T_VOID_FUNC)pin_info_cb;
        pin_mess_destroy(mess_data->pin_mess_win);
        if ( event == PIN_OK_INFO )
        {
            PROMPT(6, 64,0, display_info.TextId);  
            SEND_EVENT(pin_data->pin_win,PIN_OK_END,0,NULL);//PIN was needed
        }
        else
            info_dialog(pin_data->pin_win,&display_info); //information screen
        //pin_mess_destroy(mess_data->pin_mess_win);

        break;
    case SIM_LOCK_ERR:
        display_info.TextId2 = TxtCodeInc;
        display_info.TextId = TxtPleaseWait;
        //display_info.TextString = 0;
        //display_info.TextString2 = 0;
        //display_info.LeftSoftKey = 0;
        display_info.RightSoftKey = 0;
        display_info.KeyEvents = 0;
        display_info.Identifier = pin_data->pin_case;//last pin_case
        display_info.Callback = (T_VOID_FUNC)pin_info_cb;
//glowing,2004-06-16, modify for M288 does not define sim_get_simlock_count		
#ifdef _M188_
        sim_get_simlock_count(&simlck.cnt);/* time for information screen */
        for ( i=0;i<simlck.cnt;i++ )
        {
            timcount = timcount << 1;
        }
        display_info.Time = timcount*TIM_LOCK_JUMP;
#else
        display_info.Time = 5*TIM_LOCK_JUMP;
#endif
        pin_mess_destroy(mess_data->pin_mess_win);
        info_dialog(pin_data->pin_win,&display_info); //information screen
        break;
        //begin of xsf add 2002.08.21

    case PUK1_REQ:          //Text "Enter Puk1 "

        pin_data->display_id1 = TxtEnterPuk1;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PUK1,0,pin_data);            
        break;
    case PIN1_REQ:

        pin_data->display_id1 = TxtEnterPin1;
        if ( pin_data->pin_retries EQ 1 )   //xsf add 2003.04.10
            pin_data->display_id2 = TxtOneAttemptLeft;
        else if ( pin_data->pin_retries EQ 2 )
            pin_data->display_id2 = TxtTwoAttemptsLeft;

        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PIN1,0,pin_data);            
        break;
    case INPUT_NEW_PIN:

        pin_data->display_id1 = TxtEnterNewPin;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_NEW_PIN,0,pin_data);     
        break;
    case INPUT_NEW_PIN_AGAIN:
        pin_data->display_id1 = TxtConfPin;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_NEW_PIN_AGAIN,0,pin_data);       
        break;
        //end of xsf add 2002.08.21	
    case SIM_REMOVED:
        pin_data->display_id1 = TxtNoCard;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(sim_rem_data->sim_rem_win,TXT_INSERT_CARD,0,pin_data);
        break;    

    case INVALID_CARD:     //Text "Invalid SIM card "
        pin_data->display_id1 = TxtInvalidCard;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_INVALID_CARD,0,pin_data);
        break;
    case NO_SIM_CARD:              //Text "No Sim Card "
        pin_data->display_id1 = TxtNoCard;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_NO_CARD,0,pin_data);
        break;
    case SIM_LOCK_ALL:
        pin_data->display_id1 = TxtBlckPerm;
        pin_data->display_id2 = TxtDealer;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_SIM_LOCK_ALL,0,pin_data);
        break;
    case SIM_PLOCK_REQ:
        pin_data->display_id1 = TxtEnterPCK;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_SIM_PLOCK,0,pin_data);
        break;
    case SIM_NLOCK_REQ:
        pin_data->display_id1 = TxtEnterNCK;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_SIM_NLOCK,0,pin_data);
        break;
    case SIM_CLOCK_REQ:
        pin_data->display_id1 = TxtEnterCCK;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_SIM_CLOCK,0,pin_data);
        break;
    case SIM_NSLOCK_REQ:
        pin_data->display_id1 = TxtEnterNSCK;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_SIM_NSLOCK,0,pin_data);
        break;
    case SIM_SPLOCK_REQ:
        pin_data->display_id1 = TxtEnterSPCK;
        pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_SIM_SPLOCK,0,pin_data);
        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:	pin_icons 
 $Description:	display back from pins
 $Returns:		none
 $Arguments:	none
 
*******************************************************************************/
#if 0//2003/12/20,talcon comment it
void pin_icons(void)
{

    TRACE_FUNCTION("pin_icons");

    // clear the input
//	dspl_Clear(15,16,84,24);	
    //JVJE dspl_Clear(0,16,LCD_X,36); //nm better

    // clear the softkeys
    TRACE_EVENT("clear softkey 8");
    CLEAR_PIN_EDIT_AREA

    TRACE_EVENT("dsplClearAll 6");
    dspl_ClearAll();

    GlobalIconStatus = GlobalSignalIconFlag |//hxl delete the battery icon 0905
                       GlobalVoiceMailIconFlag 
                       | GlobalCallForwardingIconFlag| GlobalKeyplockIconFlag
                       | GlobalRingVibrIconFlag
                       | GlobalVibratorIconFlag | GlobalAlarmIconFlag
                       | GlobalSilentRingerIconFlag
/* SH 18/01/02. Flag for GPRS icon.
   Note: SPR877 - Homezone icon not displayed in PIN screen. */
#ifdef MMI_GPRS_ENABLED
                       | GlobalGPRSOnIconFlag
#endif
                       /* ...sbh */
                       ;
    iconsShow();        /* representation of the desired icons */
}
#endif


/*******************************************************************************

 $Function:	clearEditArray 
 $Description:	clear EditArray
 $Returns:		none
 $Arguments:	pin editor attributes
*******************************************************************************/
static void clear_edit_array (void * parameter)
{
    U8 i;
    T_pin_edt * edt_data = (T_pin_edt *)parameter;

    TRACE_FUNCTION("MmiPins:clearEditArray");

//nm	for(i=0;i<edt_data->editor_index;i++)
//nm	{
//nm		edtChar(edt_data->editor_handle,ecBack);/*clear editor array*/
//nm	}
//nm	edtClear (edt_data->editor_handle);

//nm 
    memset(edt_data->edtbuf,'\0',sizeof(edt_data->edtbuf));
    edtReset(edt_data->editor_handle);


    edtUnhide(edt_data->editor_handle);

//	edtShow(edt_data->editor_handle);

//nm
}


/*******************************************************************************

 $Function:	pinsIsFocussed
 $Description:	check MmiPins windows focussed
 $Returns:		Status int
 $Arguments:	none
*******************************************************************************/

int pinsIsFocussed(void)
{
    int status;

    if ( winIsFocussed(pin_windows) || winIsFocussed(pin_edit_windows)||winIsFocussed(pin_mess_windows) )
        status = FOCUSSED_PINS;
    else
        status = NOT_FOCUSSED_PINS;

    return status;
}


/*******************************************************************************

 $Function:	pinsSetIsFocussed
 $Description:	check MmiPins in settings windows focussed
 $Returns:		Status int
 $Arguments:	none
*******************************************************************************/
int pinsSetIsFocussed(void)
{
    int status;

    if ( winIsFocussed(set_pin_windows) )
        status = FOCUSSED_PINS;
    else
        status = NOT_FOCUSSED_PINS;

    return status;
}


/*******************************************************************************

 $Function:	emerg_pin
 $Description:	emergency call
 $Returns:		none
 $Arguments:	pin editor attributes
*******************************************************************************/
static void emerg_pin(void * string)
{
    T_pin_edt * edt_data = (T_pin_edt *)string;

    edt_data->emergency_call = FALSE;
    clear_edit_array(edt_data);       /*   clear editor array	*/
    callNumber((UBYTE*)edt_data->pin);     /* emergency call	*/
    memset(edt_data->pin, '\0', sizeof(edt_data->pin));/*initial string*/
    edt_data->editor_index = 0;
    TRACE_EVENT("clear softkey 9"); 
    //CLEAR_PIN_EDIT_AREA /* clear button */
}



/*******************************************************************************

 $Function:	pin_info_cb
 $Description:	pin information screen call back
 $Returns:		none
 $Arguments:	win, identifier, reason for callback (not used)
*******************************************************************************/
void pin_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    char debug[20];

    sprintf(debug, "pin_info_cb() %d", identifier);
    TRACE_FUNCTION (debug);

    switch ( identifier )
    {
    case PIN_OK:
        TRACE_EVENT("pin_info_cb: PIN_OK");
        SEND_EVENT(pin_data->pin_win,PIN_OK_END,0,NULL);//PIN was needed
        break;
    case PIN1_REQ:
    case PUK1_REQ:
    case INPUT_NEW_PIN:
        SEND_EVENT(pin_data->pin_win,identifier,0,NULL);//pin_main data !!
        break;
    case INPUT_PIN1:
        SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,NULL);//pin_main data !!
        break;
    case INPUT_PUK1:
        SEND_EVENT(pin_data->pin_win,PUK1_REQ,0,NULL);//pin_main data !!
        break;
    case SIM_PLOCK:
        SEND_EVENT(pin_data->pin_win,SIM_PLOCK_REQ,0,NULL);//pin_main data !!
        break;
    case SIM_NLOCK:
        SEND_EVENT(pin_data->pin_win,SIM_NLOCK_REQ,0,NULL);//pin_main data !!
        break;
    case SIM_SPLOCK:
        SEND_EVENT(pin_data->pin_win,SIM_SPLOCK_REQ,0,NULL);//pin_main data !!
        break;
    case SIM_NSLOCK:
        SEND_EVENT(pin_data->pin_win,SIM_NSLOCK_REQ,0,NULL);//pin_main data !!
        break;
    case SIM_CLOCK:
        SEND_EVENT(pin_data->pin_win,SIM_CLOCK_REQ,0,NULL);//pin_main data !!
        break;

    case PIN1_STATUS:
        SEND_EVENT(pin_data->pin_win,PIN1_STATUS_END,0,NULL);//pin_main data !!
        break;


    default:
        break;
    }
}



/*******************************************************************************

 $Function:	sim_rem_init
 $Description:	This is the start-up time initialisation routine.
        For compatibility reasons the functions is still there.
 $Returns:		none
 $Arguments:	parent window
*******************************************************************************/
void sim_rem_init (T_MFW_HND parent_window)
{
    sim_rem_create (parent_window);
}




/*******************************************************************************

 $Function:	sim_rem_exit
 $Description:	his is the shutdown time clean-up routine.
 $Returns:		none
 $Arguments:	parent window
*******************************************************************************/
void sim_rem_exit(T_MFW_HND parentWindow)
{
    sim_rem_destroy (sim_rem_data.sim_rem_win);
}



/*******************************************************************************

 $Function:	sim_rem_create 
 $Description:	Creation of an instance for the SIM remove dialog.
                Type of dialog : SINGLE_STATIC
                Top Window must be available at any time, only one instance.
 $Returns:		window
 $Arguments:	parent window
*******************************************************************************/
T_MFW_HND sim_rem_create (T_MFW_HND parent_window)
{

    T_sim_rem * data = &sim_rem_data;
    T_MFW_WIN  * win;

    data->sim_rem_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)sim_rem_win_cb);

    if ( data->sim_rem_win EQ 0 )
        return 0;
    else
    {
        /*
         * Create window handler
         */
        data->mmi_control.dialog    = (T_DIALOG_FUNC)sim_rem_main;
        data->mmi_control.data      = data;
        data->parent_win = parent_window;
        win                 = ((T_MFW_HDR *)data->sim_rem_win)->data;
        win->user           = (void *) data;

//RM Test 18-07   sim_init();
        /*
         * Create any other handler
         */

        data->sim_handle = sim_create(0,E_SIM_ALL_SERVICES,(MfwCb)sim_rem_cb_main);
        winShow(data->sim_rem_win);
        /*
         * return window handle
         */
        return data->sim_rem_win;
    }
}



/*******************************************************************************

 $Function:	sim_rem_destroy 
 $Description:	Destroy the sim remove dialog.
 $Returns:		none
 $Arguments:	window
*******************************************************************************/
void sim_rem_destroy (T_MFW_HND own_window)
{
    T_sim_rem  * data;
    T_MFW_WIN * win;

    if ( own_window )
    {
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_sim_rem *)win->user;

        if ( data )
        {
            /*
             * Exit SIM and Delete SIM Handler
             */
            sim_delete (data->sim_handle);

            /*
             * Delete WIN Handler
             */
            win_delete (data->sim_rem_win);
        }
    }
}


/*******************************************************************************

 $Function:	sim_rem_win_cb	
 $Description:	Callback function for windows
 $Returns:		Status int
 $Arguments:	event, window
*******************************************************************************/
static int sim_rem_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    if ( event EQ MfwWinVisible )
    {
        /*
         * Top Window has no output
         */
        TRACE_EVENT("dsplClearAll 7");     
        dspl_ClearAll();
        return 1;
    }
    return 0;
}



/*******************************************************************************

 $Function:	sim_rem_cb_main 
 $Description:	SIM remove handler
 $Returns:		Status int
 $Arguments:	event, sim status
*******************************************************************************/
int sim_rem_cb_main (T_MFW_EVENT event, T_MFW_HND para)
{

    T_MFW_SIM_STATUS * status;

    T_MFW_HND sim_rem_win;

    status = (T_MFW_SIM_STATUS *)para;
    TRACE_FUNCTION("MmiPins:sim_rem_cb_main");

    switch ( event )
    {
    case E_SIM_STATUS:
        /*
         * check whether decoded message is available
         */
        if ( para EQ (T_MFW_SIM_STATUS *)NULL )
            return MFW_RES_ILL_HND;

        status = (T_MFW_SIM_STATUS *)para;
        switch ( status->sim_procedure )
        {
        case MFW_SIM_REMOVED:
            switch ( status->sim_status )
            {
            /*
             *  SIM card is removed
             */
            case MFW_SIM_NO_SIM_CARD:
                TRACE_EVENT("sim_rem_cb_main:SIM removed");
                sim_rem_win = sim_rem_create(0);
                if ( sim_rem_win )
                {
                    SEND_EVENT(sim_rem_win,SIM_REMOVED,0,NULL);
                }
                /*
                 * limited shall be the requested service
                 * if no service is reached, the limited
                 * service is requested*/
                nm_registration (NM_AUTOMATIC, 0, TRUE);
                break;
            default:
                return 0;
            }
            break;
        default:
            return 0;
        }
        return 1;
    }
}



/*******************************************************************************

 $Function:	sim_rem_main 
 $Description:	SIM remove main Dialog Handling function
 $Returns:		None
 $Arguments:	window, event, value, parameter
*******************************************************************************/
static void sim_rem_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_sim_rem * sim_rem_data = (T_sim_rem *)win_data->user;//sim remove main data
    T_pin_mess * mess_data = (T_pin_mess *) parameter;//pin message data

    T_MFW_HND pin_mess_win;
    T_MFW_HND pin_edt_win;

    TRACE_FUNCTION("MmiPins:sim_rem_main");

    switch ( event )
    {
    case SIM_REMOVED:                       //Text "Insert Card "
        pin_mess_win = pin_mess_create(sim_rem_data->sim_rem_win);
        if ( pin_mess_win )
        {
            SEND_EVENT(pin_mess_win,event,0,sim_rem_data);
        }
        break;
    case TXT_INSERT_CARD:
        sim_rem_data->pin_case = INSERT_CARD;
        pin_edt_win = pin_edt_create(sim_rem_data->sim_rem_win);// Start: enter only emerg call
        if ( pin_edt_win )
        {
            SEND_EVENT(pin_edt_win,INSERT_CARD,0,sim_rem_data);
        }
        break;
    default:
        break;
    }

}




/*******************************************************************************

 $Function:	setting_pin_init 
 $Description:	This is the start-up time initialisation routine.
        Start in the Menu
 $Returns:		None
 $Arguments:	parent window
*******************************************************************************/
void setting_pin_init (T_MFW_HND parent_window)
{
    setting_pin_create (parent_window);
}



/*******************************************************************************

 $Function:	setting_pin_create
 $Description:	Creation of an instance for the Settings PIN main dialog.
                Type of dialog : SINGLE_DYNAMIC
                Top Window must be available at any time, only one instance.
 $Returns:		window
 $Arguments:	parent window
*******************************************************************************/
T_MFW_HND setting_pin_create (T_MFW_HND parent_window)
{

    T_pin * data = (T_pin *)ALLOC_MEMORY (sizeof (T_pin));
    T_MFW_WIN * win;

    data->pin_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)setting_pin_win_cb);

    TRACE_FUNCTION("MmiPins:setting_pin_create");

    set_pin_windows = data->pin_win;

    if ( data->pin_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)setting_pin_main;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->pin_win)->data;
    win->user           = (void *) data;

    /*
     * Create any other handler
     */

    data->sim_handle = sim_create(data->pin_win,E_SIM_ALL_SERVICES,(MfwCb)sim_event_cb_setting);

    /*
     * Initialise
     */
    data->set_state = DEFAULT;
    data->puk_request = FALSE;


    //mfwSetSignallingMethod(1);//mfw focus handling
    winShow(data->pin_win);//focus on settings:PIN/PIN2 Change/act/Deac


    /*
     * return window handle
     */
    return data->pin_win;
}


/*******************************************************************************

 $Function:	setting_pin_destroy 
 $Description:	Destroy the settings pin main dialog.
 $Returns:		none
 $Arguments:	window
*******************************************************************************/
void setting_pin_destroy  (T_MFW_HND own_window)
{
    T_pin * data;
    T_MFW_WIN * win;

    if ( own_window )
    {
        TRACE_FUNCTION("MmiPins:setting_pin_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_pin *)win->user;

        if ( data )
        {
            /*
             * Exit SIM and Delete SIM Handler
             */
            sim_delete (data->sim_handle);

            /*
             * Delete WIN Handler
             */
            set_pin_windows = 0;
            win_delete (data->pin_win);
            // + KGT 19.7.2000
            //mfwFree((U8 *)data,(sizeof(T_pin)));
            FREE_MEMORY((void *)data,(sizeof(T_pin)));
            // - KGT 19.7.2000
        }
    }
}


/*******************************************************************************

 $Function:	setting_pin_win_cb 
 $Description:	Callback function for main windows in settings
 $Returns:		Status int
 $Arguments:	event, window
*******************************************************************************/
static int setting_pin_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_pin * pin_data = (T_pin *)win->user;

    TRACE_FUNCTION("setting_pin_win_cb");
    if ( event EQ MfwWinVisible )
    {
        /*
         * Top Window has no output
         */
        //dspl_ClearAll();
        if ( pin_data->pin_case EQ FDN_WAIT )
            PROMPT(INFO_TEXT_X,INFO_TEXT_Y,0,pin_data->display_id1);

        return 1;
    }
    return 0;

}


/*******************************************************************************

 $Function:	sim_event_cb_setting 
 $Description:	SIM event handler for Setttings Pins
 $Returns:		Status int
 $Arguments:	event, sim status
*******************************************************************************/
int sim_event_cb_setting (T_MFW_EVENT event, T_MFW_HND para)
{

    T_MFW_SIM_STATUS * status;

    T_MFW_HND win = mfw_parent(mfw_header());


    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;

    status = (T_MFW_SIM_STATUS *)para;

    TRACE_EVENT("Sim Event Handler of Settings Pin"); 
    switch ( event )
    {
    case E_SIM_INSERTED://handle in sim_rem_cb_main
        return 0;
    case E_SIM_STATUS:
        /*
         * check whether decoded message is available
         */
        if ( para EQ (T_MFW_SIM_STATUS *)NULL )
            return MFW_RES_ILL_HND;

        status = (T_MFW_SIM_STATUS *)para;
        switch ( status->sim_procedure )
        {
        /*
         * Initial activation of the SIM card
         */
        case MFW_SIM_VERIFY:
            /*
             * check the result of verify
             */
            switch ( status->sim_status )
            {
            /*
             * PIN 1 must be entered
             */
            case MFW_SIM_PIN_REQ:
                if ( status->sim_pin_retries < PIN_ENTRY_MAX )
                {
                    TRACE_EVENT("sim_event_cb_settings V:PIN1 req-retr");
                    pin_data->pin_retries = status->sim_pin_retries;
                    SEND_EVENT(pin_data->pin_win,PIN1_REQ_ATT,0,pin_data);
                }
                else
                {
                    TRACE_EVENT("sim_event_cb_setting V:PIN1 req");
                    SEND_EVENT(pin_data->pin_win,PIN1_REQ_OLD,0,pin_data);
                }
                break;
                /*
                 * PIN 2 must be entered
                 */
            case MFW_SIM_PIN2_REQ:
                if ( status->sim_pin_retries < PIN_ENTRY_MAX )
                {
                    TRACE_EVENT("sim_event_cb_settings V:PIN2 req-retr");
                    pin_data->pin_retries = status->sim_pin_retries;
                    SEND_EVENT(pin_data->pin_win,PIN2_REQ_ATT,0,pin_data);
                }
                else
                {
                    TRACE_EVENT("sim_event_cb_setting V:PIN2 req");
                    if ( pin_data->set_state EQ CHANGE_PIN2 )  //xsf add 2003.04.10
                        SEND_EVENT(pin_data->pin_win,PIN2_REQ_OLD,0,pin_data);
                    else
                        SEND_EVENT(pin_data->pin_win,PIN2_REQ,0,pin_data);
                }
                break;
                /*
                 * SIM card is blocked, PUK 1 is needed
                 */
            case MFW_SIM_PUK_REQ:
                pin_data->puk_request = TRUE;
                TRACE_EVENT("sim_event_cb_setting V:PUK1 req");
                SEND_EVENT(pin_data->pin_win,PUK1_REQ_VER_INFO,0,pin_data);
                break;
                /*
                 * SIM card is blocked, PUK 2 is needed
                 */
            case MFW_SIM_PUK2_REQ:
                pin_data->puk_request = TRUE;
                TRACE_EVENT("sim_event_cb_setting V:PUK2 req");
                SEND_EVENT(pin_data->pin_win,PUK1_REQ_VER_INFO,0,pin_data);
                break;

                /*
                 * PIN entering successfull
                 */
            case MFW_SIM_NO_PIN:
                TRACE_EVENT("sim_event_cb_setting V:PIN ok ");
                pin_data->pin_case = PIN_OK_INFO;
                if ( pin_data->set_state == PIN2_CHECK )
                {
                    set_mode_fdn_adn(win,pin_data);
                }
                SEND_EVENT(pin_data->pin_win,PIN_OK_INFO,0,pin_data);
                break;

                /* Marcus: Issue 1419: 16/12/2002: Start */
            case MFW_SIM_FAILURE:
                /* An attempt to verify a PIN has failed */
                if ( status->sim_status_type == MFW_SIM_PIN2 )
                {
                    /* PIN2 verification not supported by this SIM */
                    SEND_EVENT(pin_data->pin_win,PIN2_SIM_FAILURE,0,pin_data);
                }
                else /* Not verifying PIN2, presumably verifying PIN1 */
                    return 0;
                break;
                /* Marcus: Issue 1419: 16/12/2002: End */

            default:
                return 0;
            }
            break;
            /*
             * response to PUK entering
             */
        case MFW_SIM_UNBLOCK:
            switch ( status->sim_status )
            {
            case MFW_SIM_PUK_REQ:
                TRACE_EVENT("sim_event_cb_setting:unblock failure");
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_FAIL_INFO,0,pin_data);
                break;
            case MFW_SIM_PUK2_REQ:
                TRACE_EVENT("sim_event_cb_setting:unblock failure");
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_FAIL_INFO,0,pin_data);
                break;
            case MFW_SIM_SUCCESS:
                vSavePinData(pin_data->new_pin);   //save data in the RAM  GANCHH 2003/3/21
                TRACE_EVENT("sim_event_cb_setting:unblock success");
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_SUCC,0,pin_data);
                break;
            case MFW_SIM_FAILURE:
                TRACE_EVENT("sim_event_cb_setting:unblock fatal error");
                SEND_EVENT(pin_data->pin_win,PUK1_UNBL_FATAL_ERROR,0,pin_data);
                break;              
            case MFW_SIM_INVALID_CARD:
                TRACE_EVENT("sim_event_cb_main:unblock failed, no more retries");
                SEND_EVENT(pin_data->pin_win,INVALID_CARD,0,pin_data);
                break;
            default:
                return 0;
            }
            break;

        case MFW_SIM_REMOVED:
            return 0;/* there not handled  */
        case MFW_SIM_CHANGE:
            switch ( status->sim_status )
            {
            case MFW_SIM_SUCCESS:
                TRACE_EVENT("sim_event_cb_setting: succ/CH");
                vSavePinData(pin_data->new_pin);   //save data in the RAM  GANCHH 2003/3/21
                if ( pin_data->set_state EQ IDLE_GSM )
                {
                    SEND_EVENT(pin_data->pin_win,PIN1_CH_SUCC,0,pin_data);/* change PIN by	gsm string in idle */
                }
                else if ( pin_data->pin_case EQ INPUT_NEW_PIN_AGAIN OR (status->sim_status_type EQ MFW_SIM_PIN1) )
                {
                    SEND_EVENT(pin_data->pin_win,PIN1_CH_SUCC,0,pin_data);/* change PIN, also by gsm string */
                }
                else
                {
                    SEND_EVENT(pin_data->pin_win,PIN2_CH_SUCC,0,pin_data);/* change PIN2, also by gsm string */
                }
                break;
            case MFW_SIM_FAILURE:
                TRACE_EVENT("sim_event_cb_setting: fail/CH");
                if ( !pin_data->puk_request )
                {
                    if ( pin_data->pin_case EQ INPUT_NEW_PIN_AGAIN )
                    {
                        SEND_EVENT(pin_data->pin_win,NEW_PIN_FAIL,0,pin_data);/* new Pin failed */
                    }
                    else if ( pin_data->pin_case EQ INPUT_NEW_PIN2_AGAIN )
                    {
                        SEND_EVENT(pin_data->pin_win,NEW_PIN2_FAIL,0,pin_data);/* new Pin2 failed */
                    }
                    else if ( pin_data->gsm_state )
                    {
                        SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,pin_data);
                    }
                }
                else
                {
                    if ( pin_data->pin_case EQ INPUT_NEW_PIN_AGAIN )
                    {
                        SEND_EVENT(pin_data->pin_win,PUK1_REQ,0,pin_data);
                    }
                    else
                    {
                        SEND_EVENT(pin_data->pin_win,PUK2_REQ,0,pin_data);
                    }

                }
                break;
            default:
                return 0;
            }
            break;
        case MFW_SIM_DISABLE:
        case MFW_SIM_ENABLE:
            switch ( status->sim_status )
            {
            case MFW_SIM_SUCCESS:
                TRACE_EVENT("sim_event_cb_setting: succ/DIS/E");

                if ( status->sim_procedure EQ MFW_SIM_ENABLE )
                {
                    SEND_EVENT(pin_data->pin_win,PIN1_ENAB_END,0,pin_data);
                }
                else
                {
                    SEND_EVENT(pin_data->pin_win,PIN1_DISAB_END,0,pin_data);
                }
                break;
            case MFW_SIM_FAILURE:
                TRACE_EVENT("sim_event_cb_setting: fail/DIS/E");
                pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN1);
                SEND_EVENT(pin_data->pin_win,PIN1_ENDIS_FAIL,0,pin_data);
                break;
            default:
                return 0;
            }
            break;
        default:
            return 0;
        }
        return 1;
    }
}



/*******************************************************************************

 $Function:	set_pin_ch_item_flag
 $Description:	decision about show entry "PIN change"
 $Returns:		Status int; 0 if PIN enabled, 1 if disabled
 $Arguments:	menu tag, menu attribute tag, menu item tag
*******************************************************************************/
U16 set_pin_ch_item_flag (struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi)
{
    T_MFW_SIM_PIN_STATUS status;

    TRACE_FUNCTION("MmiPins:set_pin_item_flag_state:pinChange");

    status.type = MFW_SIM_PIN1;
    sim_pin_status(&status);
    if ( status.set EQ MFW_SIM_DISABLE ) /*if PIN disabled no change PIN */
        return MNU_ITEM_HIDE;
    else
        return 0;             /* PIN enabled, change PIN possible */
}


/*******************************************************************************

 $Function:	set_pin_en_item_flag
 $Description:	decision about show entry "PIN enable"
 $Returns:		Status int; 0 if show, 1 if don't show
 $Arguments:	menu tag, menu attribute tag, menu item tag
*******************************************************************************/
U16 set_pin_en_item_flag (struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi)
{
    T_MFW_SIM_PIN_STATUS status;

    TRACE_FUNCTION("MmiPins:set_pin_en_item_flag:pinEnable");

    status.type = MFW_SIM_PIN1;
    sim_pin_status(&status);
    if ( status.set EQ MFW_SIM_ENABLE ) /*if PIN enabled no show menu entry */
        return MNU_ITEM_HIDE;
    else
        return 0;             /* PIN disabled show menu entry */
}


/*******************************************************************************

 $Function:	set_pin_dis_item_flag 
 $Description:	decision about show entry "PIN enable"
 $Returns:		Status int; 0 if show, 1 if don't show
 $Arguments:	menu tag, menu attribute tag, menu item tag
*******************************************************************************/
U16 set_pin_dis_item_flag (struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi)
{
    T_MFW_SIM_PIN_STATUS status;

    TRACE_FUNCTION("MmiPins:set_pin_en_item_flag:pinDisable");

    status.type = MFW_SIM_PIN1;
    sim_pin_status(&status);
    if ( status.set EQ MFW_SIM_DISABLE ) /*if PIN disabled no show menu entry */
        return MNU_ITEM_HIDE;
    else
        return 0;             /* PIN enabled show menu entry */
}


/*******************************************************************************

 $Function:	set_pin2_ch_item_flag
 $Description:	decision about show entry "PIN2 change"
 $Returns:		Status int; 0 if show, 1 if don't show
 $Arguments:	menu tag, menu attribute tag, menu item tag
*******************************************************************************/
//change back to old version
U16 set_pin2_ch_item_flag (struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi)
{
    T_MFW_SIM_PIN_STATUS status;

    TRACE_FUNCTION("MmiPins:set_pin2_ch_item_flag:pin2Change");

    status.type = MFW_SIM_PIN2;
    sim_pin_status(&status);
    /*if(status.set EQ MFW_SIM_DISABLE)*/ /*if PIN disabled no change PIN */
    if ( status.set EQ MFW_SIM_UNKNOWN )
        return MNU_ITEM_HIDE;
    else
        return 0;             /* PIN enabled, change PIN possible */
}



/*******************************************************************************

 $Function:	setting_pin_main 
 $Description:	PIN Settings Dialog Handling function
 $Returns:		none
 $Arguments:	win, event, value, parameters
*******************************************************************************/
void setting_pin_main(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;//pin main data
    T_pin_mess * mess_data = (T_pin_mess *) parameter;//pin message data
    T_pin_edt * edt_data = (T_pin_edt *) parameter;//pin editor data
    T_MFW_WIN * par_window;
    //T_MFW_WIN * pin_win_data = ((T_MFW_HDR *)pin_data->pin_win)->data;
    //T_pin * pin_pin_data = (T_pin *)pin_win_data->user;//pin main data


    switch ( event )
    {
    case PIN1_REQ_OLD:                      // Text "Enter Old Pin "
    case PIN2_REQ_OLD:                      // Text "Enter Old Pin2 "
    case PIN1_REQ_ATT:                      // info screen "xx attempts "
    case PIN2_REQ_ATT:                      // info screen "xx attempts "
    case PUK1_REQ:                      // Text "Enter Puk "
    case PIN1_REQ:                      // Text "Enter Pin "
    case PUK2_REQ:                      // Text "Enter Puk2 "
    case PIN2_REQ:                      // Text "Enter Pin2 "
    case PIN1_STATUS:                   // Text "Pin enabled"or disabled
    case INPUT_NEW_PIN:                     // Text "Enter New PIN "
    case INPUT_NEW_PIN2:                    // Text "Enter New PIN2 "
    case INPUT_NEW_PIN_AGAIN:               // Text "Enter New PIN again "
    case INPUT_NEW_PIN2_AGAIN:                  // Text "Enter New PIN2 again "
    case GSM_FAIL:                      // gsm not allowed
    case NEW_PIN_FAIL:                      // new pin2 failed
    case NEW_PIN2_FAIL:                     // new pin failed
    case PUK1_REQ_VER_INFO:                 // Text "Pin blocked "
    case PUK1_UNBL_FAIL_INFO:               // unblock error - new puk requ
    case PUK1_UNBL_FATAL_ERROR:
    case PIN1_CH_SUCC:
    case PIN2_CH_SUCC:
    case PIN1_ENAB_END:
    case PIN1_DISAB_END:
    case PIN2_SIM_FAILURE:    // Marcus: Issue 1419: 16/12/2002 - failure to verify PIN2

    case FDN_ACTIVATED:
    case ADN_ACTIVATED:
    case FDN_FAIL:
    case FDN_ACT_END:
    case FDN_DEACT_END:
        sett_pin_mess(win,event);
        break;
    case PUK1_UNBL_SUCC: 
        sett_pin_mess(win,event);
        break;

    }

    switch ( event )
    {
    case TXT_ENTER_PIN1:
        pin_data->pin_case = INPUT_PIN1;//enter PIN1 start
        sett_pin_edit(win,INPUT_PIN1);
        break;
    case TXT_ENTER_PIN2:
        pin_data->pin_case = INPUT_PIN2;//enter PIN2 start
        sett_pin_edit(win,INPUT_PIN2);
        break;
    case TXT_ENTER_PUK1:
        pin_data->pin_case = INPUT_PUK1;//enter PUK1 start
        sett_pin_edit(win,INPUT_PUK1);
        break;
    case TXT_ENTER_PUK2:
        pin_data->pin_case = INPUT_PUK2;//enter PUK2 start
        sett_pin_edit(win,INPUT_PUK2);
        break;
    case TXT_ENTER_NEW_PIN:
        pin_data->pin_case = INPUT_NEW_PIN;//enter new PIN start
        sett_pin_edit(win,INPUT_NEW_PIN);
        break;
    case TXT_ENTER_NEW_PIN2:
        pin_data->pin_case = INPUT_NEW_PIN2;//enter new PIN2 start
        sett_pin_edit(win,INPUT_NEW_PIN2);
        break;
    case TXT_ENTER_NEW_PIN_AGAIN:
        pin_data->pin_case = INPUT_NEW_PIN_AGAIN;
        sett_pin_edit(win,INPUT_NEW_PIN_AGAIN);// Start: enter New PIN1 again
        break;
    case TXT_ENTER_NEW_PIN_AGAIN2:
        pin_data->pin_case = INPUT_NEW_PIN2_AGAIN;
        sett_pin_edit(win,INPUT_NEW_PIN2_AGAIN);// Start: enter New PIN2 again
        break;
    case PIN1_END:    
        pin1_en_dis_verify(win); 
        break;
    case PIN2_END:
        sim_verify_pin(MFW_SIM_PIN2,(char*)pin_data->old_pin);/* verification pin2 */
        break;
    case NEW_PIN_END:
        if ( !pin_data->puk_request )
            sim_change_pin(MFW_SIM_PIN1,(U8*)pin_data->old_pin,(U8*)pin_data->new_pin);/* change PIN1 */
        else
        {
            sim_unblock_pin(MFW_SIM_PUK1, (char*)pin_data->puk, (char*)pin_data->new_pin);/* unblock pin1 */
        }
        break;
    case NEW_PIN2_END:
        if ( !pin_data->puk_request )
            sim_change_pin(MFW_SIM_PIN2,(U8*)pin_data->old_pin,(U8*)pin_data->new_pin);/* change PIN2 */
        else
            sim_unblock_pin(MFW_SIM_PUK2, (char*)pin_data->puk, (char*)pin_data->new_pin);/* unblock pin2 */
        break;
    case PIN_OK_INFO: // PIN was need
        //  vSavePinData(pin_data->old_pin);   //save data in the RAM  GANCHH 2003/3/21
        if ( (pin_data->set_state NEQ FDN_ACTIV) AND (pin_data->set_state NEQ FDN_DEACTIV) )
        {
            sett_pin_mess(win,PIN_OK_INFO);// for pin2 change and pin2 check from serv/phoneb

        }
        else
        {
            set_mode_fdn_adn(win,pin_data);
        }
        break;
    }

    switch ( event )
    {
    case PIN_OK_END:
        pin_verif_or_check2_end(win);
        break;
    case PIN1_CH_END:
    case PIN2_CH_END:
    case UNBL_OK:
        pin_ch_end_or_abort(win);
        break;

    case PIN1_STATUS_END:           
    case IDLE_GSM_FAIL:
        pin_ch_end_or_abort(win);
        break;
    case SETT_ABORT:
        TRACE_EVENT("clear softkey 10");          
        //CLEAR_PIN_EDIT_AREA			 /* clear button */	
        dspl_ClearAll();
        if ( pin_data->set_state EQ PIN1_CHECK )
        {
            par_window = pin_data->parent_win;
            setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
            //SEND_EVENT(par_window,PIN1_ABORT,0,NULL);// pin1 check
            //winShow(par_window);
        }
        else if ( pin_data->set_state EQ PIN2_CHECK )
        {
            par_window = pin_data->parent_win;
            setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
            /*SPR 1562, send event to AOC window*/
            SEND_EVENT(par_window,PIN2_ABORT,0,NULL);  
            //winShow(par_window);
        }
        else
        {
            setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
        }
        break;
        //begin xsf add for pin2 check of  2003.04.09
    case PIN2_CHECK_ABORT:   
        par_window = pin_data->parent_win;
        setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
        /*SPR 1562, send event to AOC window*/
        SEND_EVENT(par_window,PIN2_CHECK_ABORT,0,NULL);  
        break;
        //end xsf add for pin2 check of  2003.04.09
    case FDN_UNBL_OK:
        TRACE_EVENT("clear softkey 11");          
        //CLEAR_PIN_EDIT_AREA			/* clear button */

        //mnuEscape(pin_pin_data->parent_win);
        setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
        break;
    case PIN1_ENDIS_FAIL:
        if ( sim_pin_count(MFW_SIM_PIN1) EQ 0 )
        {
            pin_data->puk_request = TRUE;
            sett_pin_mess(win,PUK1_REQ_VER_INFO);
        }
        else
        {
            sett_pin_mess(win,PIN1_ENDIS_FAIL);
        }
        break;
    case FDN_WAIT:
        pin_data->pin_case = FDN_WAIT;
        winShow(pin_data->pin_win);
        break;  // waiting for call back from phonebook handler
    default:
        break;
    }
}



/*******************************************************************************

 $Function:	pin_ch_end_or_abort 
 $Description:	PIN change finished or abort (settings)
 $Returns:		none
 $Arguments:	win
*******************************************************************************/
static void pin_ch_end_or_abort (T_MFW_HND win)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data
    T_MFW_WIN * par_window;

    TRACE_FUNCTION("MmiPins:pin_ch_end_or_abort");

    if ( pin_data->set_state NEQ PIN2_CHECK )
    {
        if ( (pin_data->set_state EQ FDN_ACTIV) ||(pin_data->set_state EQ FDN_DEACTIV) )
        {
            set_mode_fdn_adn(win,pin_data);
        }
        else if ( pin_data->set_state EQ PIN1_CHECK )
        {
            par_window = pin_data->parent_win;
            setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
            SEND_EVENT(par_window,PIN1_OK,0,NULL);// pin1 check over PUK1
        }
        /*else if(pin_data->set_state EQ ENABLE)
            {
                TRACE_EVENT("MmiPins:Pin1 now enabled");   
                sim_enable_pin((U8*)pin_data->new_pin);      /* start enabling PIN1 */

        /*	}
        
        else if(pin_data->set_state EQ DISABLE)
            {
                TRACE_EVENT("MmiPins:Pin1 now disabled");   
                sim_disable_pin((U8*)pin_data->new_pin);     /* start disabling PIN1 */
        //	}
        else
        {

            U8 uMode;
//    uMode = dspl_Enable(0);

            TRACE_EVENT("clear softkey 12");        
            CLEAR_PIN_EDIT_AREA            /* clear button */
            setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog,also idle gsm

//	dspl_Enable(uMode);			  

        }                                       /* back to menu tree	  */
    }
    else
    {
        par_window = pin_data->parent_win;
        setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
        SEND_EVENT(par_window,PIN2_OK,0,NULL);// pin2 check over PUK2
    }

}




/*******************************************************************************

 $Function:	pin_verif_or_check2_end
 $Description:	PIN change finished or abort (settings)
 $Returns:		none
 $Arguments:	win
****************************************************************************/
static void pin_verif_or_check2_end(T_MFW_HND win)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data
    T_MFW_WIN * par_window;

    TRACE_FUNCTION("MmiPins:pin_verif_or_check2_end");

    if ( pin_data->set_state NEQ PIN2_CHECK )
    {
        if ( pin_data->set_state NEQ CHANGE_PIN2 )
        {
            TRACE_EVENT("MmiPins:changing PIN 2");
            SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN,0,pin_data);//pin change
        }
        else if ( pin_data->set_state EQ PIN1_CHECK )
        {
            par_window = pin_data->parent_win;
            setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
            SEND_EVENT(par_window,PIN1_OK,0,NULL);// pin1 check (not over PUK1)
        }
        else
        {
            TRACE_EVENT("MmiPins:changing PIN 2");
            SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN2,0,pin_data);// pin2 change
        }

    }
    else
    {
        TRACE_EVENT("MmiPins:checking PIN 2");
        par_window = pin_data->parent_win;
        setting_pin_destroy(pin_data->pin_win);// destroy pin settings dialog
        SEND_EVENT(par_window,PIN2_OK,0,NULL);// pin2 check (not over PUK2)
    }

}




/*******************************************************************************

 $Function:	pin1_en_dis_verify 
 $Description:	PIN enab/disab/verify start
 $Returns:		none
 $Arguments:	win
****************************************************************************/
static void pin1_en_dis_verify(T_MFW_HND win)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins:pin1_en_dis_verify");

    if ( (pin_data->set_state NEQ ENABLE) AND (pin_data->set_state NEQ DISABLE) )
    {
        TRACE_EVENT("We're verifying pin 1");
        sim_verify_pin(MFW_SIM_PIN1,(char*)pin_data->old_pin);/* verification pin1 */
    }
    else if ( pin_data->set_state EQ ENABLE )
    {
        TRACE_EVENT("MmiPins:Pin1 now enabled");   
        sim_enable_pin((U8*)pin_data->old_pin);      /* start enabling PIN1 */ 
    }
    else
    {
        TRACE_EVENT("MmiPins:Pin1 now disabled");   
        sim_disable_pin((U8*)pin_data->old_pin);     /* start disabling PIN1 */
    }

}

/*******************************************************************************

 $Function:	pin_change 
 $Description:	PIN change : call from menu Settings
 $Returns:		Status int
 $Arguments:	menu, item
*******************************************************************************/

int pin_change (struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = setting_pin_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    T_MFW_SIM_PIN_STATUS status;
    pin_data->set_state = CHANGE_PIN;

    TRACE_FUNCTION("MmiPins:pin_change");

    status.type = MFW_SIM_PIN1;
    sim_pin_status(&status);
    if ( status.set EQ MFW_SIM_ENABLE ) /*if PIN enabled no show menu entry */
    {
        if ( sim_pin_count(MFW_SIM_PIN1) > 0 )
        {
            pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN1);
            SEND_EVENT(pin_data->pin_win,PIN1_REQ_OLD,0,pin_data);
        }
        else
        {   /* not included the state of the puk counter ! */
            pin_data->puk_request = TRUE;
            SEND_EVENT(pin_data->pin_win,PUK1_REQ,0,pin_data);
        }
    }
    else
    {
        setting_pin_destroy(win);
        pin1_not_enabled_screen();
    }
    return 1;
}


/*******************************************************************************

 $Function:	pin2_change 
 $Description:	PIN2 change : call from menu Settings
 $Returns:		Status int
 $Arguments:	menu, item
*******************************************************************************/
int pin2_change (struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = setting_pin_create(idle_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;

    pin_data->set_state = CHANGE_PIN2;

    TRACE_EVENT("MmiPins:pin2_change");

    if ( sim_pin_count(MFW_SIM_PIN2) > 0 )
    {
        pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN2);
        SEND_EVENT(pin_data->pin_win,PIN2_REQ_OLD,0,pin_data);
    }
    else
    {   /* not included the state of the puk counter ! */
        pin_data->puk_request = TRUE;
        SEND_EVENT(pin_data->pin_win,PUK2_REQ,0,pin_data);
    }
    return 1;
}


/*******************************************************************************

 $Function:	pin_enable
 $Description:	PIN1 enable : call from menu Settings
 $Returns:		Status int
 $Arguments:	menu, item
*******************************************************************************/
int pin_enable (struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    T_MFW_HND idle_win = mfwParent( mfw_header() );
    T_MFW_HND win = setting_pin_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    T_MFW_SIM_PIN_STATUS status;


    status.type = MFW_SIM_PIN1;//get pin1 status
    sim_pin_status(&status);
	/* 2004/05/20 sunsj modify */
#ifdef _INNOVATION_EMULATOR_
	status.set = MFW_SIM_DISABLE;
#endif
    if ( status.set EQ MFW_SIM_DISABLE ) /*if PIN disabled*/
    {
        pin_data->set_state = ENABLE;
#ifdef _INNOVATION_EMULATOR_
		pin_data->pin_retries = 2;
		SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);
#endif
#ifndef _INNOVATION_EMULATOR_
        if ( sim_pin_count(MFW_SIM_PIN1) > 0 ) //if PIN1 not blocked
        {
            //ask for PIN1
            pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN1);
            SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);    
        }
        else
        {   //ask for PUK1
            pin_data->puk_request = TRUE;
            SEND_EVENT(pin_data->pin_win,PUK1_REQ,0,pin_data);
        }
#endif
    }
    else //PIN already enabled
        SEND_EVENT(pin_data->pin_win,PIN1_ENAB_END,0,pin_data);

    return 1;
}



/*******************************************************************************

 $Function:	pin_disable
 $Description:	PIN1 disable : call from menu Settings
 $Returns:		Status int
 $Arguments:	menu, item
*******************************************************************************/
int pin_disable (struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    T_MFW_HND idle_win =mfwParent( mfw_header() );
    T_MFW_HND win = setting_pin_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    T_MFW_SIM_PIN_STATUS status;

    TRACE_FUNCTION("MmiPins:pin_disable");
    status.type = MFW_SIM_PIN1; //get pin1 status
    sim_pin_status(&status);
    /*MC CONQ 5578, 27/05/02, if pin disabling NOT available*/
    if ( status.stat EQ MFW_SIM_NO_DISABLE )
    {   /*tell user and destroy PIN window*/
        ShowMessage(win,  TxtNull,TxtNotAllowed,REMIND_FAILURE);
        setting_pin_destroy(win);
    }
    else
    {
        /*if PIN enabled */
        if ( status.set EQ MFW_SIM_ENABLE )
        {
            pin_data->set_state = DISABLE;
            if ( sim_pin_count(MFW_SIM_PIN1) > 0 ) //if PIN not blocked
            {
                //ask for PIN
                pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN1);
                SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);
            }
            else
            {   //ask for PUK1
                pin_data->puk_request = TRUE;
                SEND_EVENT(pin_data->pin_win,PUK1_REQ,0,pin_data);
            }
        }
        else //if PIN already disabled no need to ask for PIN
            SEND_EVENT(pin_data->pin_win,PIN1_DISAB_END,0,pin_data);
    }
    return 1;
}


/*******************************************************************************

 $Function:	pin_status  
 $Description:	how if pin request is on or off
 $Returns:		Status int
 $Arguments:	menu, item
*******************************************************************************/
int pin_status (struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{

    T_MFW_HND idle_win = idle_get_window();
    T_MFW_HND win = setting_pin_create(idle_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;


    TRACE_EVENT("MmiPins:pin_status");

    SEND_EVENT(pin_data->pin_win,PIN1_STATUS,0,pin_data);

    return 1;

}



/*******************************************************************************

 $Function:	pin2_fdn_activate 
 $Description:	PIN2 activate fdn    call from menu Settings
 $Returns:		Status int
 $Arguments:	none
*******************************************************************************/
int pin2_fdn_activate (void)
{       T_MFW_HND parent_win = mfwParent( mfw_header() );
    T_MFW_HND win = setting_pin_create(parent_win);

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    T_MFW_SIM_PIN_STATUS status;
    char debug[30];

    pin_data->set_state = FDN_ACTIV;

    TRACE_FUNCTION("MmiPins:pin2_check");

    status.type = MFW_SIM_PIN2;
    sim_pin_status(&status);
    SimHasPin(MFW_SIM_PIN2);
    sprintf(debug, "PIN2 status is: %d",status.stat);
    TRACE_EVENT(debug);
    if ( (sim_pin_count(MFW_SIM_PIN2) > 0) )
    {
        pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN2);
        SEND_EVENT(pin_data->pin_win,PIN2_REQ,0,pin_data);
    }
    else
    {
        //PIN2 blocked or no PIN2

        //if (/*(status.stat == MFW_SIM_NO_PIN)||(status.stat == MFW_SIM_PIN2_REQ)*/sim_pin_count(MFW_SIM_PIN2) != -1)
        //	if (SimHasPin(MFW_SIM_PIN2))	
        //	{   /* not included the state of the puk counter ! */
        pin_data->puk_request = TRUE;
        SEND_EVENT(pin_data->pin_win,PUK2_REQ,0,pin_data);
        //	}
        /*	else
            {
            pin2_not_available_screen();
            setting_pin_destroy(win);
            }*/
    }

    return 1;
}
void pin1_not_enabled_screen()
{       
    T_MFW_HND       parent_window    = mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info; 
    U8 uMode;

    dialog_info_init(&display_info);//gdy add	
    display_info.KeyEvents    = KEY_LEFT|KEY_RIGHT|KEY_HUP;
    display_info.TextId2      = TxtEnablePIN;
    display_info.RightSoftKey = TxtNull;
    display_info.Time     = TWO_SECS;  //xsf 2002.09.04 THREE_SECS;;
    display_info.Callback     = (T_VOID_FUNC)not_avail_cb;
    display_info.iconindex  =REMIND_NORECORD;
    info_dialog( parent_window, &display_info );

}

void pin2_not_available_screen()
{       
    T_MFW_HND       parent_window    = mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info; 
    U8 uMode;

    dialog_info_init(&display_info);//gdy add	
    display_info.KeyEvents    = KEY_LEFT|KEY_RIGHT|KEY_HUP;
    display_info.TextId   = TxtPin2Code;
    display_info.TextId2      = TxtNotAvailable;
    display_info.RightSoftKey = TxtNull;
    display_info.Time     = TWO_SECS;  //xsf 2002.09.04 THREE_SECS;;
    display_info.Callback     = (T_VOID_FUNC)not_avail_cb;
    display_info.iconindex  =REMIND_NORECORD;
    info_dialog( parent_window, &display_info );

}

static void not_avail_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{

    switch ( reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:

    case INFO_TIMEOUT:
        winShow(win);
        break;
    }

}
/*******************************************************************************

 $Function:	pin2_fdn_deactivate
 $Description:	PIN2 deactivate fdn    call from menu Settings
 $Returns:		Status int
 $Arguments:	none
*******************************************************************************/
int pin2_fdn_deactivate (void)
{
    T_MFW_HND parent_win = mfwParent( mfw_header() );
    T_MFW_HND win = setting_pin_create(parent_win);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
//test if sim card has a PIN2
    pin_data->set_state = FDN_DEACTIV;

    TRACE_EVENT("MmiPins:pin2_fdn_deactivate");

    if ( sim_pin_count(MFW_SIM_PIN2) > 0 ) //if there is a sim pin2 count
    //RM Test		if(sim_pin_count(MFW_SIM_PIN2) == 0)
    {
        pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN2);
        SEND_EVENT(pin_data->pin_win,PIN2_REQ,0,pin_data);
    }
    else
    {   /* not included the state of the PUK counter */
        pin_data->puk_request = TRUE;
        SEND_EVENT(pin_data->pin_win,PUK2_REQ,0,pin_data);
    }
    return 1;
}




/*******************************************************************************

 $Function:	sett_pin_edit
 $Description:	help function for editor dialog
 $Returns:		none
 $Arguments:	window, event
*******************************************************************************/
static void sett_pin_edit(T_MFW_HND win, USHORT event)
{
//open the editor for entering the pin

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data
    T_MFW_HND pin_edt_win;

    pin_edt_win = set_pin_edt_create(pin_data->pin_win);
    if ( pin_edt_win )
    {
        SEND_EVENT(pin_edt_win,event,0,pin_data);
    }

}



/*******************************************************************************

 $Function:	set_pin_edt_create
 $Description:	Creation of an instance  for the PIN Editor dialog settings
                Type of dialog : SINGLE_DYNAMIC
 $Returns:		window
 $Arguments:	parent window
*******************************************************************************/
T_MFW_HND set_pin_edt_create (T_MFW_HND parent_window)
{
    T_pin_edt * data = (T_pin_edt *)ALLOC_MEMORY (sizeof (T_pin_edt));
    T_MFW_WIN * win;

    data->pin_edt_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)set_pin_edt_win_cb);

    TRACE_FUNCTION("MmiPins:set_pin_edt_create");

    if ( data->pin_edt_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)set_pin_editor;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->pin_edt_win)->data;
    win->user           = (void *) data;

    /*
     * Create any other handler
     */

    data->tim_out_handle = tim_create(data->pin_edt_win,TIMEOUT,(T_MFW_CB)pin_edt_tim_out_cb);
    data->editor_handle = edt_create(data->pin_edt_win,&data->editpinAttr,0,0);
    data->kbd_handle = kbd_create(data->pin_edt_win,KEY_ALL,(T_MFW_CB)set_pin_kbd_cb);
    data->kbd_long_handle = kbd_create(data->pin_edt_win,KEY_ALL | KEY_LONG,(T_MFW_CB)set_pin_edt_kbd_long_cb);
    /*
     * return window handle
     */
    return data->pin_edt_win;
}


/*******************************************************************************

 $Function:	set_pin_edt_destroy
 $Description:	Destroy the pin editor dialog
 $Returns:		none
 $Arguments:	window
*******************************************************************************/
void set_pin_edt_destroy  (T_MFW_HND own_window)
{
    T_pin_edt * data ;
    T_MFW_WIN * win;

    if ( own_window )
    {
        TRACE_EVENT("MmiPins:set_pin_edt_destroy");

        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_pin_edt *)win->user;

        if ( data )
        {
            /*
             * Delete WIN Handler
             */
            win_delete (data->pin_edt_win);
            // + KGT 19.7.2000
            //mfwFree((U8 *)data,(sizeof(T_pin_edt)));
            FREE_MEMORY((void *)data,(sizeof(T_pin_edt)));
            // - KGT 19.7.2000
        }
    }
}


/*******************************************************************************

 $Function:	set_pin_win_cb 
 $Description:	Callback function for editor windows
 $Returns:		status int
 $Arguments:	event, window
*******************************************************************************/
static int set_pin_win_cb (T_MFW_EVENT event,T_MFW_WIN * win)
{

    TRACE_FUNCTION("set_pin_win_cb");
    if ( event EQ MfwWinVisible )
    {

        dspl_ClearAll();
        return 1;
    }
    return 0;
}


/*******************************************************************************

 $Function:	set_pin_edt_win_cb
 $Description:	Callback function for editor windows
 $Returns:		status int
 $Arguments:	event, window
 $History:		2003/11/10 sunsj modify the display method in pin input
*******************************************************************************/
static int set_pin_edt_win_cb (T_MFW_EVENT event,T_MFW_WIN * win)
{
    T_pin_edt * edt_data = (T_pin_edt *)win->user;//pin edt data
    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin     * pin_data = (T_pin *)win_pin->user; // pin main data
    U32       old_color_back;
    game_Line line;
    TRACE_FUNCTION("set_pin_edt_win_cb");

    if ( event EQ MfwWinVisible )
    {
        //pin_icons();	
        //dspl_Clear(0,0,120,141); xsf changed 2003.01.13
        dspl_ClearAll();
#if (MAIN_LCD_SIZE==3)//jhxu720
        drawSolidRectangle(12,36,112,80, 1,0x5ac7ff,0x4E9C87);
#elif ( MAIN_LCD_SIZE==4 )
        drawSolidRectangle(11,26,117,76, 1,0x5ac7ff,0x4E9C87);
#elif ( MAIN_LCD_SIZE==2 )
		drawSolidRectangle(10, FIRST_LINE-2, 92, THIRD_LINE+1 , 1, 0x5ac7ff, 0x4E9C87);
#endif
        old_color_back = dspl_SetBkgColor(0x5ac7ff);
#if (MAIN_LCD_SIZE==3)//jhxu720
		ALIGNED_PROMPT(CENTER, FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, pin_data->display_id1);
#elif ( MAIN_LCD_SIZE==4 )
        ALIGNED_PROMPT(CENTER, SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, pin_data->display_id1);
#elif ( MAIN_LCD_SIZE==2 )
		ALIGNED_PROMPT(CENTER, FIRST_LINE, DSPL_TXTATTR_TRANSPARENT, pin_data->display_id1);
#endif

        dspl_SetBkgColor(old_color_back);

        /* 2003/11/10 sunsj remove */
        //drawSolidRectangle(14,70,105,88, 1,0x5ac7ff,0x4E9C87);
        if ( edt_data->editor_index NEQ 0 )
        {
            memset(edt_data->pin_dspl, '\0', MAX_PIN+1);
            memset(edt_data->pin_dspl, '*', edt_data->editor_index);
#if (MAIN_LCD_SIZE==3)//jhxu720
			dspl_colorTextOut(16, 54, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );    
#elif ( MAIN_LCD_SIZE==4 )
            dspl_colorTextOut(16, THIRD_LINE, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );    
#elif ( MAIN_LCD_SIZE==2 )
			dspl_colorTextOut(16, SECOND_LINE, DSPL_TXTATTR_TRANSPARENT, edt_data->pin_dspl,0 );
#endif
            check_set_pins(win,edt_data); 
        }
        else
            displaySoftKeys('\0',TxtSoftBack);    /* Delete/Back button in menu	*/

        /* 2003/11/10 sunsj remove */
        //line.x1=14;
        //line.y1=50;
        //line.x2=14;
        //line.y2=68;
        //line.color=0x5ac7ff;
        //DrawLine(line);
#if (MAIN_LCD_SIZE==3)//jhxu720
		line.x1=16+8*edt_data->editor_index;
        line.y1=64;
        line.x2=22+8*edt_data->editor_index;
        line.y2=64;
#elif ( MAIN_LCD_SIZE==4 )
        line.x1=16+8*edt_data->editor_index;
        line.y1=66;
        line.x2=22+8*edt_data->editor_index;
        line.y2=66;
#elif ( MAIN_LCD_SIZE==2 )
		line.x1=16+6*edt_data->editor_index;
        line.y1=THIRD_LINE;
        line.x2=22+6*edt_data->editor_index;
        line.y2=THIRD_LINE;
#endif
        line.color=0x00008b ;  // ɫ darkblue 00008b 
        DrawLine(line);  //draw cursor line

        /* 2003/11/10 sunsj */
        if ( ((pin_data->pin_retries EQ 1) ||(pin_data->pin_retries EQ 2)) && 
             ((pin_data->display_id1 == TxtEnterPin1) || (pin_data->display_id1 == TxtEnterPin2)
              ||(pin_data->display_id1 == TxtOldPIN)||(pin_data->display_id1 == TxtOldPIN2)) )
        {
#if (MAIN_LCD_SIZE==3)//jhxu720
            ALIGNED_PROMPT(CENTER,90, 0, pin_data->display_id2);
#elif ( MAIN_LCD_SIZE==4 )
            ALIGNED_PROMPT(CENTER,90, 0, pin_data->display_id2);
#elif ( MAIN_LCD_SIZE==2 )
			ALIGNED_PROMPT(CENTER,FOURTH_LINE, 0, pin_data->display_id2);
#endif
        }

        return 1;
    }
    return 0;
}



/*******************************************************************************

 $Function:	set_pin_editor
 $Description:	Pin editor Dialog Signal Handling function
 $Returns:		void
 $Arguments:	window, event, value, parameters
*******************************************************************************/
static void set_pin_editor(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;

    T_pin * pin_data = (T_pin *)parameter;//pin main data
    MfwHdr *edt_hdr=(MfwHdr *)(edt_data->editor_handle);
    MfwEdt *edt_edt=(MfwEdt *)edt_hdr->data;
    edt_data->pin_case_edit = pin_data->pin_case;

    TRACE_FUNCTION("MmiPins:set_pin_editor");

    /*
     * depending on event
     */
    switch ( event )
    {
    case INPUT_PIN1:
    case INPUT_PIN2:
    case INPUT_PUK1:
    case INPUT_PUK2:
    case INPUT_NEW_PIN:
    case INPUT_NEW_PIN_AGAIN:
    case INPUT_NEW_PIN2:
    case INPUT_NEW_PIN2_AGAIN:
        //SPR#717 - GW - Wrong structures being cleared
        memset(edt_data->pin, '\0', sizeof(edt_data->pin));/* initial string  */
        memset(edt_data->puk, '\0', sizeof(edt_data->puk));
        memset(edt_data->new_pin, '\0', sizeof(edt_data->new_pin));
        memset(edt_data->old_pin, '\0', sizeof(edt_data->old_pin));
        memset(edt_data->edtbuf, '\0', sizeof(edt_data->edtbuf));

        // the coordinate of the editor (to enter the pin)
        clear_edit_array(edt_data);      /*    clear editor buffer	    */
        edt_data->editor_index = 0;
        //reset_edt_attr(16,71,72,16,0,0,edtCurBar1,0,(char*)edt_data->edtbuf,MAX_DIG,&edt_data->editpinAttr);
        //updateWindow(edt_edt,0);
        //edtShow(edt_data->editor_handle);
        winShow(edt_data->pin_edt_win);

        break;
    default:
        break;
    }
}



/*******************************************************************************

 $Function:	set_pin_kbd_cb
 $Description:	Callback function for keyboard settings pin
 $Returns:		status int
 $Arguments:	event, keyboard control block
*******************************************************************************/
static int set_pin_kbd_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{

    T_MFW_HND win = mfw_parent(mfw_header());
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;

    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;//pin edt data

    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin * pin_data = (T_pin *)win_pin->user; // pin main data
    MfwHdr *edt_hdr=(MfwHdr *)(edt_data->editor_handle);
    MfwEdt *edt_edt=(MfwEdt *)(edt_hdr->data);

    char timer = TRUE;

    timStop(edt_data->tim_out_handle);/* stop entering timer      */

    TRACE_FUNCTION("MmiPins:set_pin_kbd_cb");
    switch ( kc->code )
    {
    case KCD_0:
    case KCD_1:
    case KCD_2:
    case KCD_3:
    case KCD_4:
    case KCD_5:
    case KCD_6:
    case KCD_7:
    case KCD_8:
    case KCD_9:
        //case KCD_STAR:     //ganchh 2002/9/4
        if ( edt_data->editor_index < MAX_DIG )
        {
            if ( kc->code EQ KCD_STAR )
                edt_data->pin[edt_data->editor_index] = STAR;
            else
                edt_data->pin[edt_data->editor_index] = '0' + kc->code;

            //xsf 2003.02.20 edtChar(edt_data->editor_handle,'*');/* hide security code */
            //	edtChar(edt_data->editor_handle,ecRight);
            edt_data->editor_index++;
            check_set_pins(win,edt_data); /* digits check depends on status pin_case */
            if ( edt_data->gsm_state )
                pin_data->gsm_state = edt_data->gsm_state;

        }
        winShow(edt_data->pin_edt_win);
        break;
        //case KCD_HASH:   //ganchh 2002/9/4
    case KCD_LEFT:
    case KCD_OK:  //xsf add KCD_OK=KCD_LEFT 2003.02.19
        switch ( edt_data->pin_case_edit )
        {
        case INPUT_PIN1:/* finish of PIN entering */
        case INPUT_PIN2:
            if ( (strlen((char*)edt_data->pin) >= MIN_PIN)  && !(edt_data->gsm_state) )
            {
                clear_edit_array(edt_data);     /*	   clear editor array */
                timer = FALSE;
                strncpy((char*)edt_data->old_pin,(char*)edt_data->pin,MAX_PIN);
                strncpy((char*)pin_data->old_pin, (char*)edt_data->old_pin,MAX_PIN);
                if ( edt_data->pin_case_edit EQ INPUT_PIN1 )
                {
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,PIN1_END,0,pin_data);
                }
                else
                {
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,PIN2_END,0,pin_data);
                }
            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) )  /* could become gsm */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) ) /* finish gsm string */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    if ( edt_data->pin_case_edit EQ INPUT_PIN1 )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    else
                        pin_data->pin_case = PIN2_REQ_OLD;
                    gsm_sec_execute_set(win,edt_data);      /* execute gsm string */
                }
            }
            break;
        case INPUT_PUK1:
        case INPUT_PUK2:
            if ( (strlen((char*)edt_data->pin) EQ MAX_PIN) && !(edt_data->gsm_state) ) /* finish of PUK entering */
            {
                TRACE_EVENT("clear softkey 13");                                
                //CLEAR_PIN_EDIT_AREA /* clear button */
                clear_edit_array (edt_data);        /* clear editor array */
                timer = FALSE;
                strncpy((char*)edt_data->puk,(char*)edt_data->pin,MAX_PIN);/* store puk  */
                strncpy((char*)pin_data->puk, (char*)edt_data->puk,MAX_PIN);
                if ( pin_data->pin_case EQ INPUT_PUK1 )
                {
                    dspl_ClearAll();
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN,0,pin_data);/* entering new pin1 start*/
                }
                else
                {
                    dspl_ClearAll();
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN2,0,pin_data);/* entering new pin2 start*/
                }
            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) )/* could become gsm	    */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) )/* finish gsm string  */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    gsm_sec_execute_set(win,edt_data);        /* execute gsm string  */
                }
            }
            break;
        case INPUT_NEW_PIN:
        case INPUT_NEW_PIN2:
            /* finish of new PIN entering */
//								if (((strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) < (MAX_PIN + 1))) && !(edt_data->gsm_state))
            if ( (strlen((char*)edt_data->pin) >= MIN_PIN)  && !(edt_data->gsm_state) )
            {
                clear_edit_array (edt_data);              /* clear editor array */
                timer = FALSE;
                strncpy((char*)edt_data->new_pin, (char*)edt_data->pin,MAX_PIN);      /*  store new pin	  */
                strncpy((char*)pin_data->new_pin, (char*)edt_data->new_pin,MAX_PIN);
                if ( pin_data->pin_case EQ INPUT_NEW_PIN )
                {
                    set_pin_edt_destroy(edt_data->pin_edt_win);       /* entering new pin1 again*/
                    SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN_AGAIN,0,pin_data);
                }
                else
                {
                    set_pin_edt_destroy(edt_data->pin_edt_win);       /* entering new pin1 again*/
                    SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN2_AGAIN,0,pin_data);
                }
            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) ) /* could become gsm	    */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) )/* finish gsm string  */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    if ( edt_data->pin_case_edit EQ INPUT_NEW_PIN )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    else
                        pin_data->pin_case = PIN2_REQ_OLD;
                    gsm_sec_execute_set(win,edt_data);        /* execute gsm string  */
                }
            }
            break;
        case INPUT_NEW_PIN_AGAIN:
        case INPUT_NEW_PIN2_AGAIN:
            /* finish of new PIN confirm */
//								if (((strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) < (MAX_PIN + 1))) && !(edt_data->gsm_state))
            if ( (strlen((char*)edt_data->pin) >= MIN_PIN) && !(edt_data->gsm_state) )
            {
                clear_edit_array (edt_data);              /* clear editor array */
                timer = FALSE;
                if ( strcmp((char*)edt_data->pin, (char*)pin_data->new_pin) EQ 0 ) /* compare PINs successfull*/
                {
                    strncpy((char*)pin_data->new_pin, (char*)edt_data->pin,MAX_PIN);
                    if ( pin_data->pin_case EQ INPUT_NEW_PIN_AGAIN )
                    {
                        set_pin_edt_destroy(edt_data->pin_edt_win);
                        SEND_EVENT(pin_data->pin_win,NEW_PIN_END,0,pin_data);/* changing PIN1 */
                    }
                    else
                    {
                        set_pin_edt_destroy(edt_data->pin_edt_win);
                        SEND_EVENT(pin_data->pin_win,NEW_PIN2_END,0,pin_data);/* changing PIN2 */
                    }
                }
                else
                {                                   /* new PIN != new PIN again */

                    if ( pin_data->pin_case EQ INPUT_NEW_PIN_AGAIN )
                    {
                        set_pin_edt_destroy(edt_data->pin_edt_win);
                        SEND_EVENT(pin_data->pin_win,NEW_PIN_FAIL,0,NULL);
                    }
                    else
                    {
                        set_pin_edt_destroy(edt_data->pin_edt_win);
                        SEND_EVENT(pin_data->pin_win,NEW_PIN2_FAIL,0,NULL);
                    }
                }
            }
            else
            {
                if ( kc->code EQ KCD_HASH && !(edt_data->gsm_state) ) /* could become gsm	    */
                {
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    check_pins(win,edt_data);
                    if ( edt_data->gsm_state )
                        pin_data->gsm_state = edt_data->gsm_state;
                }
                else if ( kc->code EQ KCD_HASH && (edt_data->gsm_state) )/* finish gsm string  */
                {
                    timer = FALSE;
                    edt_data->pin[edt_data->editor_index] = HASH;
                    edtChar(edt_data->editor_handle,edt_data->pin[edt_data->editor_index]);
                    edt_data->editor_index++;
                    if ( edt_data->pin_case_edit EQ INPUT_NEW_PIN_AGAIN )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    else
                        pin_data->pin_case = PIN2_REQ_OLD;
                    gsm_sec_execute_set(win,edt_data);         /* execute gsm string */
                }
            }
            break;
        default:
            break;
        }
        break;
//nm old			case KCD_RIGHT: 
// it was right for the customer mobile but not for the B Sample
    case KCD_HUP:
        clear_edit_array(edt_data);
        timer = FALSE;
        set_pin_edt_destroy(edt_data->pin_edt_win);
        if ( pin_data->set_state EQ PIN2_CHECK )  //xsf add 2003.04.09
            SEND_EVENT(pin_data->pin_win,PIN2_CHECK_ABORT,0,NULL);
        else
            SEND_EVENT(pin_data->pin_win,SETT_ABORT,0,NULL); // abort settings menu
        break;
//nm old			case KCD_HUP:
// it was right for the customer mobile but not for the B Sample

    case KCD_RIGHT:     

//nm, go back to the submenu if there is no character on the screen
        if ( strlen((char*)edt_data->pin) == 0 )
        {
            clear_edit_array(edt_data);
            timer = FALSE;
            set_pin_edt_destroy(edt_data->pin_edt_win);
            if ( pin_data->set_state EQ PIN2_CHECK )  //xsf add 2003.04.09
                SEND_EVENT(pin_data->pin_win,PIN2_CHECK_ABORT,0,NULL);
            else
                SEND_EVENT(pin_data->pin_win,SETT_ABORT,0,NULL); // abort settings menu
            return 1;               
        }
//nm


        if ( edt_data->editor_index EQ 0 )
            ;
        else
            edt_data->editor_index--;

        edt_data->pin[edt_data->editor_index] = '\0';
        //xsf 2003.02.20 edtChar(edt_data->editor_handle,ecBack);/* delete character    */

        if ( strlen((char*)edt_data->pin)<MIN_PIN )
        {
//						TRACE_EVENT("clear softkey 14");					
//						CLEAR_PIN_EDIT_AREA		   /* clear button	   */
//nm						displaySoftKeys('\0',TxtSoftBack);    /* Back button in menu  */
        }

        edt_data->emergency_call = FALSE;
        if ( edt_data->pin_case_edit EQ INPUT_PUK1 )  /* special case ?? */
            winShow(edt_data->pin_edt_win);
        else
            check_set_pins(win,edt_data);          /* check remain for emergency call  */
        winShow(edt_data->pin_edt_win);
        break;
    default:
        break;
    }
    if ( timer )
        tim_start(edt_data->tim_out_handle);/* start timer for entering */
    return 1;
}


/*******************************************************************************

 $Function:	set_pin_edt_kbd_long_cb
 $Description:	Callback function for keyboard long
 $Returns:		status int
 $Arguments:	event, keyboard control block
*******************************************************************************/
static int set_pin_edt_kbd_long_cb (T_MFW_EVENT event,T_MFW_KBD *  kc)
{
    T_MFW_HND win = mfw_parent(mfw_header());

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_edt * edt_data = (T_pin_edt *)win_data->user;//pin edt data

    TRACE_FUNCTION("MmiPins:set_pin_edt_kbd_long_cb");

    if ( (event & KEY_CLEAR) && (event & KEY_LONG) )
    {
        timStop(edt_data->tim_out_handle); /* stop entering timer	*/
        clear_edit_array(edt_data);
        memset(edt_data->pin,'\0',sizeof(edt_data->pin));/* initial string */
        edt_data->editor_index = 0;
        edt_data->emergency_call = FALSE;
        winShow(edt_data->pin_edt_win);
    }

    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:	check_set_pins 
 $Description:	check input string for settings
 $Returns:		void
 $Arguments:	window pin editor attributes
*******************************************************************************/
static void check_set_pins (T_MFW_HND win,void * edt_pin)
{
    T_pin_edt * edt_data = (T_pin_edt *)edt_pin;

    TRACE_FUNCTION("MmiPins: check_set_pins");

    if ( strlen((char*)edt_data->pin)NEQ 0 )
    {
        if ( strlen((char*)edt_data->pin) > FIRST_DIGIT )  /* for every character  */
            gsm_set_test(win,edt_data); /* test if GSM string or not*/

        if ( (strlen((char*)edt_data->pin) >= MIN_PIN) && (strlen((char*)edt_data->pin) <= (MAX_PIN + 1)) )
        {
            //TRACE_EVENT("clear softkey 15");		
            if ( ((edt_data->pin_case_edit EQ INPUT_PUK1) ||(edt_data->pin_case_edit EQ INPUT_PUK2)) && !(edt_data->gsm_state) )
            {     /* PUK 1/2 (not by gsm string) max. 8 digits  */
                if ( strlen((char*)edt_data->pin) >= MAX_PIN )
                {
                    TRACE_EVENT("Softkeys:nr 7");
                    displaySoftKeys(TxtSoftOK,TxtDelete);
                    //displaySoftKeys(TxtSoftOK,TxtSoftBack);/* display OK + back  button *///		
                }
                else
                {
                    TRACE_EVENT("Softkeys:nr 8");
                    displaySoftKeys('\0',TxtDelete);
                    //displaySoftKeys(TxtSoftOK,TxtSoftBack);/* display back button */						
                }
            }
            else
            {
                if ( !(edt_data->gsm_state) )    /* usual way for PIN 4 digits     */
                {
                    //nm displaySoftKeys(TxtSoftOK,TxtSoftBack);
                    TRACE_EVENT("Softkeys:nr 9");
                    displaySoftKeys(TxtSoftOK,TxtDelete);
                }
                else
                {
                    TRACE_EVENT("clear softkey 16");                  
                    CLEAR_PIN_EDIT_AREA /* clear button */
                }
            }
        }
        else        //xsf add 2002.10.08 for strlen((char*)edt_data->pin) < MIN_PIN
            displaySoftKeys('\0',TxtDelete);

        if ( (strlen((char*)edt_data->pin) > MAX_PIN) && !(edt_data->gsm_state) ) /* >8 digits not allowed    */
        {

            if ( edt_data->editor_index EQ 0 )
                ;
            else
                edt_data->editor_index--;

            edt_data->pin[edt_data->editor_index] = '\0';
            //xsf 2003.02.20 edtChar(edt_data->editor_handle,ecBack);
        }
    }
    else
        displaySoftKeys('\0',TxtSoftBack); 
}



/*******************************************************************************

 $Function:	sett_pin_mess 
 $Description:	help function for message dialog
 $Returns:		void
 $Arguments:	window, event
*******************************************************************************/
static void sett_pin_mess(T_MFW_HND win,USHORT event)
{

    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    T_MFW_HND pin_mess_win;
    TRACE_FUNCTION("MmiPins:sett_pin_mess");

    pin_mess_win = set_pin_mess_create(pin_data->pin_win);
    if ( pin_mess_win )
    {
        SEND_EVENT(pin_mess_win,event,0,pin_data);
    }
}


/*******************************************************************************

 $Function:	set_pin_mess_create
 $Description:	Creation of an instance  for the PIN Message dialog settings
                Type of dialog : SINGLE_DYNAMIC
 $Returns:		void
 $Arguments:	parent window
*******************************************************************************/
T_MFW_HND set_pin_mess_create(T_MFW_HND parent_window)
{
    T_pin_mess * data = (T_pin_mess *)ALLOC_MEMORY (sizeof (T_pin_mess));
    T_MFW_WIN * win;

    data->pin_mess_win = win_create (parent_window, 0, MfwWinVisible, (T_MFW_CB)set_pin_mess_win_cb);

    TRACE_FUNCTION("MmiPins: set_pin_mess_create");

    if ( data->pin_mess_win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)set_pin_messages;
    data->mmi_control.data      = data;
    data->parent_win = parent_window;
    win                 = ((T_MFW_HDR *)data->pin_mess_win)->data;
    win->user           = (void *) data;

    /*
     * return window handle
     */
    return data->pin_mess_win;
}


/*******************************************************************************

 $Function:	set pin_mess_destroy
 $Description:	Destroy the pin message dialog settings
 $Returns:		void
 $Arguments:	window
*******************************************************************************/
void set_pin_mess_destroy  (T_MFW_HND own_window)
{
    T_pin_mess * data;
    T_MFW_WIN * win;


    TRACE_FUNCTION("MmiPins: set_pin_mess_destroy");

    if ( own_window )
    {
        win = ((T_MFW_HDR *)own_window)->data;
        data = (T_pin_mess *)win->user;

        if ( data )
        {

            /*
             * Delete WIN Handler
             */
            win_delete (data->pin_mess_win);
            // + KGT 19.7.2000
            //mfwFree((U8*)data,(sizeof(T_pin_mess)));
            FREE_MEMORY((void*)data,(sizeof(T_pin_mess)));
            // - KGT 19.7.2000
        }
    }
}


/*******************************************************************************

 $Function:	set_pin_mess_win_cb
 $Description:	Callback function for message windows
 $Returns:		void
 $Arguments:	event, window
*******************************************************************************/
static int set_pin_mess_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    /*
     * Top Window has no output
     */
    return 1;
}


/*******************************************************************************

 $Function:	set_pin_messages
 $Description:	Message Dialog for PIN/PUK handling in settings
 $Returns:		void
 $Arguments:	win, event, value, parameter
*******************************************************************************/
void set_pin_messages(T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin_mess * mess_data = (T_pin_mess *)win_data->user;

    T_DISPLAY_DATA display_info;
    U8 uMode;
    T_MFW_SIM_PIN_STATUS status; //need to check the Pin 1 status
    T_pin * pin_data = (T_pin *)parameter;

    TRACE_FUNCTION("Mmi.Pins:set_pin_messages");

    /*
     * depending on signal
     */
    dialog_info_init(&display_info);//gdy add
    switch ( event )
    {
    case PIN1_REQ_ATT:
    case PIN2_REQ_ATT:
    case PUK1_REQ_VER_INFO:
    case GSM_FAIL:
    case NEW_PIN_FAIL:
    case NEW_PIN2_FAIL:
    case PIN_OK_INFO:
    case PIN1_CH_SUCC:
    case PIN2_CH_SUCC:
    case PUK1_UNBL_FAIL_INFO:
    case PUK1_UNBL_SUCC:
    case PUK1_UNBL_FATAL_ERROR:
    case PIN1_ENAB_END:
    case PIN1_DISAB_END:
    case PIN1_ENDIS_FAIL:
    case FDN_FAIL:
    case FDN_ACT_END:
    case FDN_DEACT_END:
    case PIN1_STATUS:
    case PIN2_SIM_FAILURE:      // Marcus: Issue 1419: 16/12/2002 - failure to verify PIN2
        switch ( event )
        {
        case PIN1_REQ_ATT:
            pin_data->pin_case = PIN1_REQ_OLD;
            display_info.TextId2 = TxtPINFail;
            /*if(pin_data->pin_retries EQ 1)
              display_info.TextId = TxtOneAttemptLeft;
            else
              display_info.TextId = TxtTwoAttemptsLeft; xsf 2003.04.10*/
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PIN2_REQ_ATT:
            if ( pin_data->set_state EQ CHANGE_PIN2 )  //xsf add 2003.04.10
                pin_data->pin_case = PIN2_REQ_OLD;
            else
                pin_data->pin_case = PIN2_REQ;
            display_info.TextId2 = TxtPINFail;
            /*if(pin_data->pin_retries EQ 1)
              display_info.TextId = TxtOneAttemptLeft;
            else
              display_info.TextId = TxtTwoAttemptsLeft;xsf 2003.04.10*/
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PIN1_CH_SUCC:
            pin_data->pin_case = PIN1_CH_END;
            display_info.TextId2 = TxtChangPin;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_SUCCEED; 
            break;
        case PIN2_CH_SUCC:
            pin_data->pin_case = PIN2_CH_END;
            display_info.TextId2 = TxtChangPIN2;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_SUCCEED; 
            break;
        case PUK1_REQ_VER_INFO:
            if ( (pin_data->set_state EQ CHANGE_PIN2) ||
                 (pin_data->set_state EQ PIN2_CHECK) ||
                 (pin_data->set_state EQ FDN_ACTIV) ||
                 (pin_data->set_state EQ FDN_DEACTIV) )
            {
                pin_data->pin_case = PUK2_REQ;
            }
            else
            {
                pin_data->pin_case = PUK1_REQ;
            }
            display_info.TextId2 =TxtPINBlock;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_NORECORD; 

            break;
        case GSM_FAIL:
            if ( pin_data->set_state EQ IDLE_GSM )
                pin_data->pin_case = IDLE_GSM_FAIL;
            display_info.TextId2 = TxtNotAcc;
            //display_info.TextId = 0;
            //display_info.TextString2= 0;
            display_info.iconindex = REMIND_NORECORD; 
            break;   
        }
        switch ( event )
        {
        case PUK1_UNBL_FATAL_ERROR:
            if ( (pin_data->set_state EQ CHANGE_PIN2) ||
                 (pin_data->set_state EQ FDN_ACTIV) ||
                 (pin_data->set_state EQ FDN_DEACTIV) )
            {
                pin_data->pin_case = PUK2_REQ;
            }
            else if ( pin_data->set_state == IDLE_GSM )
                pin_data->pin_case = IDLE_GSM_FAIL;
            else
            {
                pin_data->pin_case = PUK1_REQ;
            }
            display_info.TextId2 = TxtNotAcc;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_NORECORD; 
            break;
        case NEW_PIN_FAIL:
            pin_data->pin_case = INPUT_NEW_PIN;
            //display_info.TextId= TxtNewPIN;
            display_info.TextId2 = TxtChangeFail;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case NEW_PIN2_FAIL:
            pin_data->pin_case = INPUT_NEW_PIN2;
            //display_info.TextId = TxtPIN2;
            display_info.TextId2 = TxtChangeFail;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PIN_OK_INFO:
            //TRACE_EVENT("PIN_OK_INFO");
            pin_data->pin_case = PIN_OK;
            display_info.TextId2 = TxtPINOK;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;           
        case PUK1_UNBL_FAIL_INFO:
            if ( (pin_data->set_state EQ CHANGE_PIN2) ||
                 (pin_data->set_state EQ PIN2_CHECK) ||
                 (pin_data->set_state EQ FDN_ACTIV) ||
                 (pin_data->set_state EQ FDN_DEACTIV) )
            {
                pin_data->pin_case = PUK2_REQ;

            }
            else if ( pin_data->set_state EQ IDLE_GSM )
            {
                pin_data->pin_case = IDLE_GSM_FAIL;

            }
            else
            {
                pin_data->pin_case = PUK1_REQ;

            }

            //display_info.TextId = TxtNull;
            display_info.TextId2 = TxtPuk1Inc;   //xsf change TxtCodeInc to TxtPuk1Inc 2002.08.29

            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PUK1_UNBL_SUCC:
            vSavePinData(pin_data->new_pin);   //save data in the RAM  GANCHH 2003/3/21
            if ( (pin_data->set_state EQ CHANGE_PIN2) ||
                 (pin_data->set_state EQ PIN2_CHECK) ||
                 (pin_data->set_state EQ FDN_ACTIV) ||
                 (pin_data->set_state EQ FDN_DEACTIV) )
                //display_info.TextId = TxtNewPIN2;
                display_info.TextId2 = TxtChangPIN2;
            else
                //display_info.TextId = TxtNewPIN;
                display_info.TextId2 = TxtChangPin;
            pin_data->pin_case = UNBL_OK;    
            //display_info.TextId2 = TxtChanged;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED; 
            break;
        case PIN1_ENAB_END:
            pin_data->pin_case = UNBL_OK;
            pin_data->set_state = DEFAULT;
            //display_info.TextId = TxtPinCode;
            display_info.TextId2 = TxtActivated;
            //display_info.TextString2 = 0;
            display_info.iconindex=REMIND_COMPLETE;
            break;
        case PIN1_DISAB_END:
            pin_data->pin_case = UNBL_OK;
            pin_data->set_state = DEFAULT;
            //display_info.TextId = TxtPinCode;
            display_info.TextId2 = TxtDeActivated;
            //display_info.TextString2 = 0;
            display_info.iconindex=REMIND_COMPLETE;
            break;
        case FDN_ACT_END:
            pin_data->pin_case = FDN_UNBL_OK;
            display_info.TextId2 = TxtActivated;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;
        case FDN_DEACT_END:
            pin_data->pin_case = FDN_UNBL_OK;
            display_info.TextId2 = TxtDeActivated;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex =REMIND_SUCCEED;  //xsf add 01.17 ok
            break;
        case FDN_FAIL:
            pin_data->pin_case = UNBL_OK;
            display_info.TextId2 = TxtFailed;
            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex = REMIND_FAILURE; 
            break;
        case PIN1_ENDIS_FAIL:  //enable or disable pin1 xsf 2003.04.11 
            pin_data->pin_case = PIN1_REQ;
            display_info.TextId2 = TxtPINFail;
            //display_info.TextId = 0;
            /*if(pin_data->pin_retries EQ 1)
              display_info.TextId = TxtOneAttemptLeft;
            else
              display_info.TextId = TxtTwoAttemptsLeft;xsf 2003.04.11 */
            display_info.iconindex = REMIND_FAILURE; 
            break;

        case PIN1_STATUS:
            pin_data->pin_case = PIN1_STATUS;

            //TRACE_EVENT("set_pin_messages:check the pinrequest status");

            status.type = MFW_SIM_PIN1;//check the PIN1
            sim_pin_status(&status);

            if ( status.set EQ MFW_SIM_DISABLE ) /*Display the "Disabled Pin1 */
            {
                display_info.TextId2 = TxtDisabled;
            }
            else
            {
                display_info.TextId2 = TxtEnabled; /*Display the "Enabled Pin1 */
            }   

            //display_info.TextId = 0;
            //display_info.TextString2 = 0;
            display_info.iconindex=REMIND_COMPLETE;
            break;

            /* Marcus: Issue 1419: 16/12/2002: Start */
        case PIN2_SIM_FAILURE:
            /*
             * Failure to verify PIN2. Display
             *  PIN2 Code
             *  Not Available
             * Then cancel back to the menu.
             */
            pin_data->pin_case        = SETT_ABORT;
            display_info.TextId       = TxtPin2Code;
            display_info.TextId2      = TxtNotAvailable;
            display_info.iconindex = REMIND_NORECORD; 
            //display_info.TextString2 = 0;
            break;
            /* Marcus: Issue 1419: 16/12/2002: End */

        }

//uMode = dspl_Enable(0);

        //display_info.TextString = 0;
        //display_info.LeftSoftKey = 0;
        display_info.RightSoftKey = 0;
        if ( (display_info.TextId == TxtOneAttemptLeft) || (display_info.TextId == TxtTwoAttemptsLeft) )
            display_info.Time = FIVE_SECS;
        else
            display_info.Time = THREE_SECS;  //xsf 2002.09.04 THREE_SECS;;
        display_info.KeyEvents = KEY_LEFT|KEY_RIGHT|KEY_HUP;
        display_info.Identifier = pin_data->pin_case;
        display_info.Callback = (T_VOID_FUNC)set_pin_info_cb;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        info_dialog(pin_data->pin_win,&display_info); //information screen


//dspl_Enable(uMode);	

        break;
    case PUK1_REQ:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtEnterPuk1;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PUK1,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case PIN1_REQ:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtEnterPin1;
        if ( pin_data->pin_retries EQ 1 )   //xsf add 2003.04.10
            pin_data->display_id2 = TxtOneAttemptLeft;
        else if ( pin_data->pin_retries EQ 2 )
            pin_data->display_id2 = TxtTwoAttemptsLeft;

        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PIN1,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case PUK2_REQ:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtEnterPuk2;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PUK2,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case PIN2_REQ:
//		uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtEnterPin2;
        if ( pin_data->pin_retries EQ 1 )   //xsf add 2003.04.10
            pin_data->display_id2 = TxtOneAttemptLeft;
        else if ( pin_data->pin_retries EQ 2 )
            pin_data->display_id2 = TxtTwoAttemptsLeft;

        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PIN2,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case INPUT_NEW_PIN:
//uMode = dspl_Enable(0);

        pin_data->display_id1 = TxtEnterNewPin;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_NEW_PIN,0,pin_data);

//dspl_Enable(uMode);			
        break;
    case INPUT_NEW_PIN2:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtNewPIN2;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_NEW_PIN2,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case INPUT_NEW_PIN_AGAIN:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtConfPin;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_NEW_PIN_AGAIN,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case INPUT_NEW_PIN2_AGAIN:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtConfPin2;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_NEW_PIN_AGAIN2,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case PIN1_REQ_OLD:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtOldPIN;
        if ( pin_data->pin_retries EQ 1 )   //xsf add 2003.04.10
            pin_data->display_id2 = TxtOneAttemptLeft;
        else if ( pin_data->pin_retries EQ 2 )
            pin_data->display_id2 = TxtTwoAttemptsLeft;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PIN1,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case PIN2_REQ_OLD:
//uMode = dspl_Enable(0);
        pin_data->display_id1 = TxtOldPIN2;
        if ( pin_data->pin_retries EQ 1 )   //xsf add 2003.04.10
            pin_data->display_id2 = TxtOneAttemptLeft;
        else if ( pin_data->pin_retries EQ 2 )
            pin_data->display_id2 = TxtTwoAttemptsLeft;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,TXT_ENTER_PIN2,0,pin_data);
//dspl_Enable(uMode);			
        break;
    case FDN_ACTIVATED:
        pin_data->display_id1 = TxtPleaseWait;//TxtActivated;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,FDN_WAIT,0,pin_data);
        break;
    case ADN_ACTIVATED:
        pin_data->display_id1 = TxtPleaseWait;//TxtDeActivated;
        set_pin_mess_destroy(mess_data->pin_mess_win);
        SEND_EVENT(pin_data->pin_win,FDN_WAIT,0,pin_data);
        break;
    default:
        break;
    }
}


/*******************************************************************************

 $Function:	set_pin_info_cb
 $Description:	settings pin information screen call back
 $Returns:		void
 $Arguments:	win, identifier, reason
*******************************************************************************/
void set_pin_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reasons)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;

    TRACE_FUNCTION("MmiPins: set_pin_info_cb");



    switch ( identifier )
    {
    case PIN_OK:
        SEND_EVENT(pin_data->pin_win,PIN_OK_END,0,NULL);//PIN was needed
        break;
    case PIN1_STATUS:
        SEND_EVENT(pin_data->pin_win,PIN1_STATUS_END,0,NULL);
        break;
    case UNBL_OK:
    case PIN1_REQ:
    case PIN2_REQ:
    case PUK1_REQ:
    case PUK2_REQ:
    case INPUT_NEW_PIN:
    case INPUT_NEW_PIN2:
    case PIN1_CH_END:
    case PIN2_CH_END:
    case FDN_UNBL_OK:
    case PIN1_REQ_OLD:
    case PIN2_REQ_OLD:
    case IDLE_GSM_FAIL:
    case SETT_ABORT:        // Marcus: Issue 1419: 16/12/2002
        SEND_EVENT(pin_data->pin_win,identifier,0,NULL);//pin_main data !!
        break;
    default:        
        switch ( reasons )
        {
        case INFO_KCD_LEFT:
        case INFO_KCD_RIGHT:

        case INFO_TIMEOUT:
            dspl_ClearAll();
            break;
        }
        break;
    }
}


/*******************************************************************************

 $Function:	gsm_set_test 
 $Description:	test if gsm string
 $Returns:		status int
 $Arguments:	win, pin editor attributes 
*******************************************************************************/
static int gsm_set_test(T_MFW_HND win,void * edt_pin)
{
    int status;
    T_pin_edt * edt_data = (T_pin_edt *)edt_pin;


    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_MFW_WIN * win_pin =((T_MFW_HDR *)edt_data->parent_win)->data;
    T_pin * pin_data = (T_pin *)win_pin->user; // pin main data

    TRACE_FUNCTION("MmiPins:gsm_set_test");

//	status = ss_check_ss_string((UBYTE*)edt_data->pin);/* check GSM-String */
    status =ss_check_ss_string_pin((UBYTE*)edt_data->pin);/* check GSM-String  ganchh 2002/9/4*/

    switch ( status )
    {
    case MFW_SS_SIM_REG_PW:
        if ( !(edt_data->gsm_state) )
        {
            switch ( pin_data->set_state )
            {
            case CHANGE_PIN:/* replace * with string id */
                if ( !(strncmp((char*)edt_data->pin,"**04*",IDENT_GSM_1)) )
                {
                    edt_data->gsm_state = TRUE;
                    strncpy((char*)edt_data->edtbuf,(char*)edt_data->pin,edt_data->editor_index-1);
                    edtShow(edt_data->editor_handle);
                }
                else
                {
                    edt_data->gsm_state = FALSE;
                    dspl_ClearAll();
                    clear_edit_array (edt_data);
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    if ( pin_data->puk_request )
                    {
                        pin_data->pin_case = PUK1_REQ;
                    }
                    else
                    {
                        if ( (pin_data->set_state EQ ENABLE) || (pin_data->set_state EQ DISABLE) )
                            pin_data->pin_case = PIN1_REQ;
                        else
                            pin_data->pin_case = PIN1_REQ_OLD;/* pin1/2 change */
                    }
                    SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                }
                break;
            case CHANGE_PIN2:/* replace * with string id */
                if ( !(strncmp((char*)edt_data->pin,"**042*",IDENT_GSM_2)) )
                {
                    edt_data->gsm_state = TRUE;
                    strncpy((char*)edt_data->edtbuf,(char*)edt_data->pin,edt_data->editor_index-1);
                    edtShow(edt_data->editor_handle);
                }
                else
                {
                    edt_data->gsm_state = FALSE;
                    dspl_ClearAll();
                    clear_edit_array (edt_data);
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    if ( pin_data->puk_request )
                    {
                        pin_data->pin_case = PUK2_REQ;
                    }
                    else
                    {
                        pin_data->pin_case = PIN2_REQ_OLD;
                    }
                    SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                }
                break;
            default:
                edt_data->gsm_state = FALSE;
                dspl_ClearAll();
                clear_edit_array (edt_data);
                set_pin_edt_destroy(edt_data->pin_edt_win);
                if ( pin_data->puk_request )
                {
                    if ( pin_data->set_state EQ CHANGE_PIN2 )
                        pin_data->pin_case = PUK2_REQ;
                    else
                        pin_data->pin_case = PUK1_REQ;
                }
                else
                {
                    if ( pin_data->set_state EQ CHANGE_PIN )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    else if ( pin_data->set_state EQ CHANGE_PIN2 )
                        pin_data->pin_case = PIN2_REQ_OLD;
                    else
                        pin_data->pin_case = PIN1_REQ;/* PIN enable/disable */
                }
                SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                break;
            }
        }
        return status;

    case MFW_SS_SIM_UNBLCK_PIN:
        if ( !(edt_data->gsm_state) )
        {
            switch ( edt_data->pin_case_edit )
            {
            case INPUT_PUK1:/* replace * with string id */
                if ( !(strncmp((char*)edt_data->pin,"**05*",IDENT_GSM_1)) )
                {
                    edt_data->gsm_state = TRUE;
                    strncpy((char*)edt_data->edtbuf,(char*)edt_data->pin,edt_data->editor_index-1);
                    edtShow(edt_data->editor_handle);
                }
                else
                {
                    edt_data->gsm_state = FALSE;
                    dspl_ClearAll();
                    clear_edit_array (edt_data);
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    pin_data->pin_case = PUK1_REQ;
                    SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                }
                break;
            case INPUT_PUK2:/* replace * with string id */
                if ( !(strncmp((char*)edt_data->pin,"**052*",IDENT_GSM_2)) )
                {
                    edt_data->gsm_state = TRUE;
                    strncpy((char*)edt_data->edtbuf,(char*)edt_data->pin,edt_data->editor_index-1);
                    edtShow(edt_data->editor_handle);
                }
                else
                {
                    edt_data->gsm_state = FALSE;
                    dspl_ClearAll();
                    clear_edit_array (edt_data);
                    set_pin_edt_destroy(edt_data->pin_edt_win);
                    pin_data->pin_case = PUK2_REQ;
                    SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                }
                break;
            default:
                edt_data->gsm_state = FALSE;
                dspl_ClearAll();
                clear_edit_array (edt_data);
                set_pin_edt_destroy(edt_data->pin_edt_win);
                if ( pin_data->puk_request )
                {
                    if ( pin_data->set_state EQ CHANGE_PIN2 )
                        pin_data->pin_case = PUK2_REQ;
                    else
                        pin_data->pin_case = PUK1_REQ;/* pin1 change,disable,enable */
                }
                else
                {
                    if ( pin_data->set_state EQ CHANGE_PIN )
                        pin_data->pin_case = PIN1_REQ_OLD;
                    else if ( pin_data->set_state EQ CHANGE_PIN2 )
                        pin_data->pin_case = PIN2_REQ_OLD;
                    else
                        pin_data->pin_case = PIN1_REQ; /* pin enable/disable */
                }
                SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
                break;
            }
        }
        return status;
    case MFW_SS_DIAL:          /* string not yet detected  */
    case MFW_SS_USSD:  /*JVJ SPR 1040- The short USSD strings should also be 
                          considered in this case, since they can be confused with dialled numbers  
                         */
        edt_data->gsm_state = FALSE;
        return status;
    default:
        edt_data->gsm_state = FALSE;
        dspl_ClearAll();
        clear_edit_array (edt_data);
        set_pin_edt_destroy(edt_data->pin_edt_win);
        SEND_EVENT(pin_data->pin_win,GSM_FAIL,0,NULL);/*entering screeen not allowed */
        return status;
    }
}


/*******************************************************************************

 $Function:	set_mode_fdn_adn
 $Description:	activate/deactivate FDN/ADN
 $Returns:		none
 $Arguments:	win, pin editor attributes
*******************************************************************************/
static void set_mode_fdn_adn(T_MFW_HND win, void * string)
{
    T_pin * pin_data = (T_pin *)string;

    TRACE_FUNCTION("MmiPins:set_mode_fdn_adn");

    if ( (pin_data->set_state EQ FDN_ACTIV) || (pin_data->set_state EQ PIN2_CHECK) )
    {
        if ( phb_set_mode(PHB_FDN,pin_data->old_pin) EQ MFW_PHB_OK )
        {
            SEND_EVENT(pin_data->pin_win,FDN_ACTIVATED,0,pin_data);/* activate FDN successfull */
        }
        else
        {
            SEND_EVENT(pin_data->pin_win,FDN_FAIL,0,pin_data);/* activate FDN unsuccessfull */
        }
    }
    else
    {
        if ( phb_set_mode(PHB_ADN,pin_data->old_pin) EQ MFW_PHB_OK )
        {
            SEND_EVENT(pin_data->pin_win,ADN_ACTIVATED,0,pin_data);/* deactivate FDN  successfull */
        }
        else
        {
            SEND_EVENT(pin_data->pin_win,FDN_FAIL,0,pin_data);/* deactivate FDN unsuccessfull */
        }
    }
}


/*******************************************************************************

 $Function:	backpinFDNactdeact
 $Description:	when callback event is received from phonebook
        (MmiPhbk:phbkEvent)
 $Returns:		none
 $Arguments:	none
*******************************************************************************/
void backpinFDNactdeact(void)
{

    T_MFW_WIN * win_data = ((T_MFW_HDR *)set_pin_windows)->data;
    T_pin * pin_data = (T_pin *)win_data->user; // pin main data

    TRACE_FUNCTION("MmiPins.backpinFDNactdeact");

    if ( pin_data->set_state EQ FDN_ACTIV )
    {
        SEND_EVENT(pin_data->pin_win,FDN_ACT_END,0,pin_data);
    }
    else if ( pin_data->set_state EQ FDN_DEACTIV )
    {
        SEND_EVENT(pin_data->pin_win,FDN_DEACT_END,0,pin_data);
    }
}


/*******************************************************************************

 $Function:     pin2_avail_check

 $Description:   If there is no support for PIN2 on SIM card
                 the item PIN2 should not appear in the menulist

 $Returns:

 $Arguments:

*******************************************************************************/
USHORT pin2_avail_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{
    int retVal;

    TRACE_FUNCTION("pin2_avail_check");

    if ( sim_pin_count(MFW_SIM_PIN2) != (-1) )
    {
        //show the PIN2 item in the menulist
        return 0;
    }
    else
    {
        //hide the PIN2 item in the menulist
        return 1;
    }
}


/*******************************************************************************

 $Function:	pin2_check 
 $Description:	PIN2 check :call from menu Services and Phonebook
 $Returns:		status int
 $Arguments:	parent window
*******************************************************************************/
int pin2_check (T_MFW_HND parent_window)
{
    T_MFW_HND win = setting_pin_create(parent_window);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;

    //T_DISPLAY_DATA display_info;
    T_MFW_SIM_PIN_STATUS status;

    pin_data->set_state = PIN2_CHECK;

    TRACE_EVENT("MmiPins:pin2_check");

    status.type = MFW_SIM_PIN2;
    sim_pin_status(&status);
    if ( (sim_pin_count(MFW_SIM_PIN2) > 0) )
    {
        pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN2);
        SEND_EVENT(pin_data->pin_win,PIN2_REQ,0,pin_data);
    }
    else
    {
        /* not included the state of the puk counter ! */
        pin_data->puk_request = TRUE;
        SEND_EVENT(pin_data->pin_win,PUK2_REQ,0,pin_data);
    }
    return 1;
}


/*******************************************************************************

 $Function:	pin1_check 
 $Description:	PIN1 check :call from menu Services (AOC)
 $Returns:		status int
 $Arguments:	parent window
*******************************************************************************/
int pin1_check (T_MFW_HND parent_window)
{
    T_MFW_HND win = setting_pin_create(parent_window);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    T_MFW_SIM_PIN_STATUS status;

    pin_data->set_state = PIN1_CHECK;

    TRACE_FUNCTION("MmiPins:pin1_check");
    //status.type = MFW_SIM_PIN1;
    //sim_pin_status(&status);
    if ( sim_pin_count(MFW_SIM_PIN1) > 0 )
    {
        pin_data->pin_retries = sim_pin_count(MFW_SIM_PIN1);
        SEND_EVENT(pin_data->pin_win,PIN1_REQ,0,pin_data);
    }
    else
    {   /* not included the state of the puk counter ! */
        pin_data->puk_request = TRUE;
        SEND_EVENT(pin_data->pin_win,PUK1_REQ,0,pin_data);
    }
    return 1;
}

/*******************************************************************************

 $Function:	reset_edt_attr 
 $Description:	initialize parameter in the edit buffer
 $Returns:		void
 $Arguments:	editor attributes
*******************************************************************************/
void reset_edt_attr(U16 winPx,U16 winPy,U16 winSx,U16 winSy,U8 fgColor,U8 font,U8 mode,
                    U8 *controls, char *text,U16 size,MfwEdtAttr* attr){

    attr->win.px = winPx;
    attr->win.py = winPy;
    attr->win.sx = winSx;
    attr->win.sy = winSy;
    attr->fgColor = fgColor;
    attr->font = font;
    attr->mode = mode;
    attr->controls = controls;
    attr->text = text;
    attr->size = size;
}


/*******************************************************************************

 $Function:     fdn_service_check

 $Description:   If there is no support for FDN on SIM card
                 the item Fixed Names should not appear in the menulist

 $Returns:

 $Arguments:

*******************************************************************************/
USHORT fdn_service_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{

    TRACE_FUNCTION("fdn_service_check")

    if ( sim_serv_table_check(3) EQ ALLOCATED_AND_ACTIVATED )
    {
        //show the FDN item in the menulist
        return 0;
    }
    else
    {
        //hide the FDN item in the menulist
        return 1;
    }
}

/*******************************************************************************

 $Function:	fdnActivate
 $Description:	activate FDN
 $Returns:		status int
 $Arguments:	menu, item
*******************************************************************************/
int fdnActivate(struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{
    TRACE_FUNCTION("MmiPins:fdnActivate");
    pin2_fdn_activate();/*	check if PIN2 */
    return 1;
}



/*******************************************************************************

 $Function:	fdnDeactivate 
 $Description:	deactivate FDN
 $Returns:		status int
 $Arguments:	menu, item
*******************************************************************************/
int fdnDeactivate(struct MfwMnuTag * m, struct MfwMnuItemTag * i)
{

    TRACE_FUNCTION("MmiPins:fdnDeactivate");
    pin2_fdn_deactivate(); //	check if PIN2
    return 1;
}


/*******************************************************************************

 $Function:	set_fdn_on_item_flag 
 $Description:	decision about menu entry FDN "on"
 $Returns:		0 if show entry, 1 if not
 $Arguments:	menu, menu attributes, item
*******************************************************************************/
U16 set_fdn_on_item_flag (struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi)
{

    TRACE_FUNCTION("MmiPins:set_fdn_on_item_flag");

    if ( phb_get_mode()EQ PHB_RESTRICTED ) /*if FDN on */
        return MNU_ITEM_HIDE;       /* show no entry "on" */
    else
        return 0;              /* show entry "on"  */
}


/*******************************************************************************

 $Function:	set_fdn_off_item_flag
 $Description:	decision about menu entry FDN "off"
 $Returns:		0 if show entry off, 1 if not
 $Arguments:	menu, menu attributes, item
*******************************************************************************/
U16 set_fdn_off_item_flag (struct MfwMnuTag * m, struct MfwMnuAttrTag * ma, struct MfwMnuItemTag * mi)
{
    TRACE_FUNCTION("MmiPins:set_fdn_off_item_flag");

    if ( phb_get_mode() NEQ PHB_RESTRICTED ) /* if FDN off */
        return MNU_ITEM_HIDE;        /* show no entry "off" */
    else
        return 0;            /* show entry "off"  */
}



/*******************************************************************************

 $Function:	gsm_idle 
 $Description:	handle gsm string in idle screen (unblock and change pin)
 $Returns:		Status int
 $Arguments:	parent window, string
*******************************************************************************/
int gsm_idle (T_MFW_HND parent_window,char * string)
{
    T_MFW_HND win = setting_pin_create(parent_window);
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;

    pin_data->set_state = IDLE_GSM;
    pin_data->gsm_state = TRUE;

    TRACE_FUNCTION("MmiPins:gsm_idle");

    gsm_sec_execute_set(win,string);

    return 1;
}


/*******************************************************************************

 $Function:	gsm_sec_execute_set
 $Description:	GSM-String will be executed in settings and idle
 $Returns:		none
 $Arguments:	win, pin attributes
*******************************************************************************/
static void gsm_sec_execute_set(T_MFW_HND win,void *string)
{
    T_MFW_WIN * win_data = ((T_MFW_HDR *)win)->data;
    T_pin * pin_data = (T_pin *)win_data->user;
    int result;

    TRACE_FUNCTION("MmiPins:gsm_sec_execute_set");

    if ( pin_data->set_state NEQ IDLE_GSM )
    {
        T_pin_edt * edt_data = (T_pin_edt *)string;

        result = ss_execute_transaction((UBYTE*)edt_data->pin,0);/* ussd_man = 0 while SSD */
        dspl_ClearAll();
        clear_edit_array (edt_data);
        pin_edt_destroy(edt_data->pin_edt_win);
    }
    else
        result = ss_execute_transaction((UBYTE*)string,0);/* ussd_man = 0 while SSD */

    switch ( result )
    {
    case MFW_SS_SIM_REG_PW:     /* change PIN1/2		*/
        TRACE_EVENT("MmiPins:gsm_idle:MFW_SS_SIM_REG_PW");
        break;
    case MFW_SS_SIM_UNBLCK_PIN: /* unblock PIN1/2		*/
        TRACE_EVENT("MmiPins:gsm_idle:MFW_SS_SIM_UNBLCK_PIN");
        break;
    case MFW_SS_FAIL:
        TRACE_EVENT("MmiPins:gsm_idle:MFW_SS_FAIL");
        sett_pin_mess(win,GSM_FAIL);/* new PIN and new PIN again are not the same */
        break;
    default:
        break;
    }
}


/*******************************************************************************

 $Function:	pins_editor_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void pins_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_pin         * data     = (T_pin *)win_data->user;

    T_pin * pin_data = (T_pin *)win_data->user;//pin main data

    char buf[60];


    TRACE_FUNCTION ("pins_editor_cb()");
    MmiTrace("pins_editor_cb()");
    HUPKeyOrigin=1;//ganchh for power off while no sim card
    animation_complete=1;

    switch ( reason )
    {
    
    case INFO_EMERGENCY:        
        sprintf(buf, " call %s", data->edtbuf); 
        TRACE_EVENT(buf);   
        callNumber ((UBYTE*)data->edtbuf);   
 //       show_confirmation (win);/* 2004/4/20, wangyan modify */

        break;

    case INFO_KCD_LEFT:
        switch ( Identifier )
        {
        
        case PIN1_REQ:
            {   TRACE_EVENT ("PIN1_REQ");           

                // verification pin1
                sim_verify_pin(MFW_SIM_PIN1, data->edtbuf);  
            }
            break;
        case PUK1_REQ:
            {
                TRACE_EVENT ("PUK1-REQ");   
                strncpy((char*)pin_data->puk, data->edtbuf,MAX_PIN);  
                SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN,0,pin_data);
            }
            break;
        case INPUT_NEW_PIN: 
            {   TRACE_EVENT ("INPUT_NEW_PIN");  
                strncpy((char*)pin_data->new_pin, data->edtbuf,MAX_PIN);  
                SEND_EVENT(pin_data->pin_win,INPUT_NEW_PIN_AGAIN,0,pin_data);
            }
            break;

        case INPUT_NEW_PIN_AGAIN:
            {   //if new pins match
                if ( strcmp((char*)pin_data->new_pin, (char*)data->edtbuf) EQ 0 )
                    sim_unblock_pin(MFW_SIM_PUK1, (char*)pin_data->puk, (char*)pin_data->new_pin);/* unblock pin1 */
                else    //otherwise ask for new pin again
                    SEND_EVENT(pin_data->pin_win,NEW_PIN_FAIL,0,NULL);
            }
            break;
        default:
            break;
        }
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_CLEAR:

        TRACE_EVENT ("INFO_KCD_RIGHT pressed");

        switch ( Identifier )
        {

        default:
            break;
        }
        break;
    case INFO_KCD_HUP:// zy add 0918 for nosimcard to shut down mobile
        //hxl add for stop charger icon show when poweroff-----------------
        pinsentpoweroff=1;
        HUPKeyOrigin = 1; 
        break;
    case INFO_KCD_ABC:
    case INFO_EDT_UPDATE:
        if ( pinsentpoweroff ==1 )
            break;

        MmiTrace("pins:Charging Key");
        //if(pwr_Status.ChargingVirtualKeyFlag)
        batEvent();
        //else if(IsBlinktimerRun==0){
        //	MmiTrace("iconshow");
        //	SetChargingIcon( CurrentBatPicNum );
        //}
        break;
    default:
        break;
    }
}


/*******************************************************************************

 $Function:	call emergency confirmation

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/


void show_confirmation (T_MFW_HND win)
{
    T_DISPLAY_DATA   display_info;

    dialog_info_init(&display_info);//gdy add
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextId2       = TxtSoftCall;
    display_info.TextId      = TxtEmergency;
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Callback     = (T_VOID_FUNC)show_confirmation_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT| KEY_RIGHT;

    /*
     * Call Info Screen
     */

    info_dialog (win, &display_info);

}


/*******************************************************************************

 $Function:	idle_imei_info_cb

 $Description:	 
 
 $Returns:		

 $Arguments:	
                
*******************************************************************************/

static int show_confirmation_cb(T_MFW_HND win, USHORT identifier, UBYTE reason)
{

    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_pin         * data     = (T_pin *)win_data->user;

    switch ( reason )
    {
    
    case INFO_KCD_LEFT:
        // call emergency number
        callNumber ((UBYTE*)data->edtbuf);          
        break;

    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        //SEND_EVENT(win, INVALID_CARD, 0, data);	//xsf commented it 2003.04.16		
        break;
    }

    return 1;
}

/*******************************************************************************

 $Function:	pins_loadEditDefault

 $Description:	fill up editor-sttribut with default
 
 $Returns:		
 
 $Arguments:		
                
*******************************************************************************/
//GW-SPR#844 - Zero editor data structure to reset all values to a known state.

void pins_loadEditDefault (T_EDITOR_DATA *editor_data)
{
    TRACE_FUNCTION ("pins_loadEditDefault()");
    memset(editor_data,0x00,sizeof(T_EDITOR_DATA));

    editor_data->editor_attr.win.px   = 0;
    editor_data->editor_attr.win.py   = 12;
    editor_data->editor_attr.win.sx   = 84;
    editor_data->editor_attr.win.sy   = 20;
    editor_data->editor_attr.fgColor  = 0;
    editor_data->editor_attr.font     = 0;
    editor_data->editor_attr.mode    = edtCurBar1;
    editor_data->editor_attr.controls   = 0;
    editor_data->editor_attr.text      = '\0';  
    editor_data->editor_attr.size       = 0;
    editor_data->hide               = FALSE;
    editor_data->Identifier        = 0;  /* optional */
    editor_data->mode           = PIN_SECURITY;
    editor_data->destroyEditor      = TRUE;
    editor_data->LeftSoftKey      = TxtSoftSelect;
    editor_data->AlternateLeftSoftKey   = TxtNull;
    editor_data->RightSoftKey     = TxtSoftBack;
    editor_data->TextId      = '\0';  
    editor_data->TextString       = NULL;  
    editor_data->min_enter           = 1;  // Avoid to return empty strings
    editor_data->timeout          = FOREVER;
    editor_data->Callback         = (T_EDIT_CB)pins_editor_cb;

}

static void batEvent(void)
{
    MmiTrace("pin batEvent");

    pwr_Status.ChargingVirtualKeyFlag=0;
    GetBatPicnum();

    if ( (pwr_Status.charger_plugged==0)||(pwr_Status.charging_state==0) )
    {//no charger or charging full
        MmiTrace("stop charging");
        if ( IsBlinktimerRun )
        {
            timStop(gtimeBlink);
            IsBlinktimerRun=0;
            ChargeOffset=0;
        }
//			if ( GlobalIconStatus & GlobalBatteryIconFlag )
		GetBatPicnum(); //2004-03-18 Sunny add
        SetChargingIcon( CurrentBatPicNum );
		DisplayOuterIdleCharge( CurrentBatPicNum );//2004-03-21 Sunny add
// 		}else if((pwr_Status.charging_state==1)||(pwr_Status.charging_state==2)){//charger in and not full
    }
    else if ( pwr_Status.charging_state>0 )
    {//charger in and not full
        MmiTrace("charging");
        if ( IsBlinktimerRun==0 )
        {
            BlinkBatPicnum=CurrentBatPicNum;
            ALPollingTick();
            timStart(gtimeBlink);
            IsBlinktimerRun=1;
        }
#if 0
        if ( CurrentBatPicNum>1 )
            SetChargingIcon( CurrentBatPicNum-1);
        else
            SetChargingIcon( CurrentBatPicNum);
#endif
    }//end of charger 
}

static int pin_charger_tim_cb (MfwEvt e, MfwTim *t)
{
    MmiTrace("pin_charger_tim_cb");

    if ( pinsentpoweroff ==1 )
        return 1;

    if ( (pwr_Status.charger_plugged==0)||(pwr_Status.charging_state==0) )
    {//no charger or charging full
		GetBatPicnum(); //2004-03-18 Sunny add
        SetChargingIcon( CurrentBatPicNum );
		DisplayOuterIdleCharge( CurrentBatPicNum );//2004-03-21 Sunny add
        timStop(gtimeBlink);
        IsBlinktimerRun=0;
        ChargeOffset=0;
    }
    else
    {
        ALPollingTick();
        timStart(gtimeBlink);
    }

    return 1;
}


