/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI (6349)                                                           
 $Module:		Supplementary services
 $File:		    MmiServices.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description

    This module provides the supplementary services functionality

  
********************************************************************************
 $History: MmiServices.c

    25/10/00			Original Condat(UK) BMI version.	
    28/08/02      wufei modified
       
 $End

*******************************************************************************/


/******************************************************************************
                                                                              
                                Include Files
                                                                              
*******************************************************************************/

#define BUGS 0

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "p_sim.h"


#include "mfw_sys.h"
#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_lng.h"
#include "mfw_icn.h"
#include "mfw_tim.h"
#include "mfw_mnu.h"
#include "mfw_phb.h"
#include "mfw_sat.h"
#include "mfw_ffs.h" //WUFEI APPEND
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_sim.h"
#include "mfw_nm.h"
#include "mfw_cm.h"
#include "mfw_ss.h"
#include "dspl.h"
#include "MmiMmi.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMain.h"
#include "MmiStart.h"
#include "MmiPins.h"
#include "MmiIdle.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiIcons.h"
#include "MmiCall.h"
#include "MmiServices.h"
#include "MmiEditor.h"
#include "MmiCPHS.h"
#include "Mmiblklangdb.h" //WUFEI APPEND
#include "Mmibooksearchwindow.h"//WUFEI APPEND
#include "mmismsmenu.h"
#include "mmismssend.h"
#include "mmibookmenuwindow.h"

#include "MmiBookUtils.h"
#include "MmiBookShared.h " // MZ 26/02/01
#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mmiusersymbolinput.h"

#include "mmiutilapi.h"
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */


extern char DCTbVar[10][40];//WUFEI APPEND
extern T_idle idle_data;    // hu binhao 2002-11-29
extern const unsigned char IconBookGrouping15[];  // hu binhao 2002-12-4
uint8  recentcallbook;
static uint8 CallsDeleteAllFlag=0;  //hu binhao  2003-1-7
uint8 CallListFlag=0;  //hu binhao  2003-1-21  mark it has been have a call,and mark in recent calls menu list
uint8 MCallHintDleteFlag=0;  //hu binhao  2003-1-29 the flag will set 1 when browse recent call neme and a missed call happened.
uint8 iniNoRecord=0; //hu binhao 2003-3-18 when falg is 0 ,means  after "delete all";when flag is 1, means just after inter memu 
extern void bookMenuDestroy( MfwHnd window ); //hu binhao 2003 1-14


extern void msgsGetVoiceAddress(CHAR *Buffer);
#define MAX_USSD_LEN          161
//define masks for call forwarding types hubinhao 2003-2-10 begin
#define GetFourbits      0xf   /* 00001111 &*/

#define SetCFNRc        0x8  /* 00001000 |*/   //Call Forwarding on Mobile Subscriber Not Reachable
#define ReSetCFNRc      0xf7  /* 11110111 & */  

#define SetCFB           0x4  /* 00000100 | */  //Call Forwarding on Mobile Subscriber Busy
#define ReSetCFB         0xfb  /* 11111011 & */  

#define SetCFNRy        0x2  /* 00000010  |*/  //Call Forwarding on No Reply
#define ReSetCFNRy      0xfd  /* 11111101 & */ 

#define SetCFU           0x1  /* 00000001  |*/  //Call Forwarding Unconditional
#define ReSetCFU         0xfe  /* 11111110 & */  
//hubinhao 2003-2-10 begin


//when we look showdetail from rencent missed call menu,It have a new missed call.
//then,go into the deeper nemu to save number ,made a call ,or delet then item ,but,the infor does not correspond to showdetail,becuase the new missed call have change the array.
static char NameShowDetail[24];  //hu binhao 2003-4-29
static uint8 NumShowDetail[24];   //hu binhao 2003-4-29
static UBYTE GetPosition(char Rcalltype,const uint8 * Mnum); //hu binhao 2003-4-29
static void (*show) (void);

static void showWait (T_MFW_HND win);
static void showOk (T_MFW_HND win);
static void showFailed (T_MFW_HND win);
static void showError (T_MFW_HND win, T_MFW_SS_ERROR ss_error);
static void showCLIStatus (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf );
static void showSSNotify (T_MFW_HND win, T_MFW_SS_NOTIFY  * ss_notify);



static void showIMEI2 (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf);
static void showUSSDREQ (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf);
static void showUSSDCNF (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf);
static void showUSSDEnter (void);
static void showUSSDFull (T_MFW_HND win);
static void sendUSSD (T_MFW_SS_PARA *ussd_senddata);
static int servicesSendCallDivert(char * divert_number);
int servicesUSSDEdit(struct MfwMnuTag* m, struct MfwMnuItemTag* i);
int servicesUSSDDelete(struct MfwMnuTag* m, struct MfwMnuItemTag* i);
int NoRplyTime(struct MfwMnuTag* m, struct MfwMnuItemTag* i);
static void servicesShowUSSDMenu(void);
static void servicesStoreUSSD(void);

static void ServicesGetOtherNumber(T_MFW_HND win);
static void servicesStoreVoiceMailNumber( void );
static void services_get_voice_number_cb(T_MFW_HND win, USHORT reason);

static void ServicesGetUsedNumber(void); //WUFEI APPEND
static void UsedNumberList_cb(T_MFW_HND * Parent, ListMenuData * ListData); //WUFEI APPEND
static T_MFW_HND  buildUsedNumberMenu( MfwHnd parent_window);//WUFEI APPEND
void numbers_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);//WUFEI APPEND
static void usednumber_destroy(MfwHnd own_window);//WUFEI APPEND
static int usednumber_win_cb (MfwEvt e, MfwWin *w);//WUFEI APPEND
static int usednumber_menu_cb (MfwEvt e, MfwMnu *m);//WUFEI APPEND
int usednumber_GetListCount(res_ResourceID_type res);//WUFEI APPEND
static void CUG_Add_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);//WUFEI APPEND
void AddCUGIndex(uint8* index);//WUFEI APPEND
static void ServicesCUGMenu(void); //WUFEI APPEND
void services_info_screen (T_MFW_HND win, USHORT MessageId );//WUFEI APPEND

static T_MFW_HND  buildCUGMenu( MfwHnd parent_window);//WUFEI APPEND
void cug_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);//WUFEI APPEND
static void CUGList_cb(T_MFW_HND * Parent, ListMenuData * ListData);//WUFEI APPEND
static void cugWin_destroy(MfwHnd own_window);//WUFEI APPEND
static int cug_win_cb (MfwEvt e, MfwWin *w); //WUFEI APPEND
int cugNameSubMnu(void);//WUFEI APPEND
static void CUGSubList_cb(T_MFW_HND * Parent, ListMenuData * ListData);//WUFEI APPEND
void AddCUGName(uint8* name); //WUFEI APPEND
void PreDefinedCUG(void);//WUFEI APPEND
void ChangeToUcs2(char* srcStr, char * Ucs2Str);//WUFEI APPEND
static void CFNRy_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);//WUFEI APPEND
static void showCFanimation (T_MFW_HND win);//WUFEI APPEND

//---------------hu binhao append 2002-12-2------------------
static T_MFW_HND Rnum_create(MfwHnd parent_window);
void Rnum_destroy(MfwHnd own_window);
static int Rnum_reset_OK_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
void Reset_all_calls();
void display_reset_calls(T_MFW_HND parent);
static int Rnum_NoCalls_OK_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
//---------------hu binhao append 2002-12-2 end ---------------
//static char recentname[10][21];   //hu binhao append 2002-11-19
void servicesDivertVoice(void); //hu binhao 2003-2-11
static void showDetail (T_MFW_HND win);

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       info_win;
    T_MFW_HND       info_tim;
    T_MFW_HND       info_kbd;
    T_MFW_HND       info_kbd_long;
    USHORT          LeftSoftKey;     /* used for Ok */
    USHORT          RightSoftKey;    /* Used for Back */
    ULONG           Time;
    T_MFW_EVENT     KeyEvents;
    USHORT          TextId1;          /* Line 1 */
    USHORT          TextId2;          /* Line 2 */
    char *          TextString4;
    USHORT          Identifier;
    T_VOID_FUNC     Callback;
} T_dialog_ext_info;

T_MFW_HND dialog_ext_info_dialog (T_MFW_HND            parent_win,
                                  T_dialog_ext_info  * display_info);

static MfwHnd lastFocus;                /* store old focus			*/
static MfwHnd win;                      /* our window               */
static MfwHnd kbd;                      /* our keyboard handler     */
static MfwHnd tim;                      /* exit timer				*/
static MfwHnd times;                    /* timeout				    */

static MmiState nextState;              /* next state when finished */
static int servicesState;               /* current state of module	*/


static T_MFW_SS_PARA *ss_cnf;           /* union container for all SS confirmations */

/* decode service type - tele/bearer */
static unsigned int serviceGetServiceType( UBYTE ss_telecom_type, UBYTE ss_telecom_service);
static unsigned int serviceGetCategory( T_MFW_SS_CATEGORY cat );
static unsigned int serviceGetType( T_MFW_SS_CODES type );
static unsigned int ServiceGetStatus( UBYTE pStatus);
static unsigned int serviceGetError( T_MFW_SS_ERROR ss_error);

unsigned int mCurrentServiceNum;        /* current CF or CB service number */
unsigned int mFeatureCount;             /* current CF or CB or CW number of list elements */





#define CB_PSW_LEN  4



typedef enum
{
    CFBusy = 0,
    CFNoReach,
    CFNoReply,
    CFAllConditional,
    CFUnconditional,
    CFAllCalls
} SERVICE_CF_TYPE;

typedef enum
{
    CBAllOutgoing = 0,
    CBInternational,
    CBInternationalHome,
    CBAllIncoming,
    CBIncomingRoaming
} SERVICE_CB_TYPE;



typedef enum
{
    CFVoice = 0,
    CFAuxVoice, /*MC, ALS line 2*/ 
    CFFax,
    CFData,
    CFAll
} SERVICE_CF_SERVICE;

typedef enum
{
    CFActivate = 0,
    CFDeactivate,
    CFCheck
} SERVICE_CF_ACTION;

typedef enum
{
    CBActivate = 0,
    CBDeactivate,
    CBCheck,
    CBCheckPassword,
    CBNewPassword,
    CBConfirmNewPassword
} SERVICE_CB_ACTION;

typedef enum
{
    CUGActivate = 0,
    CUGDeactive,
    CUGCheck,
    CUGName,
    CUGIndex,
    CUGNameMod,
    CUGIndexMod
} SERVICE_CUG_ACTION; //WUFEI APPEND

UBYTE cugListPosition=100; //WUFEI APPEND for test
MfwHnd cugwindows; //wufei add 0827
//MfwHnd Listwindows; //wufei add 0827
UBYTE listlen;//wufei add 0905
UBYTE cwflag;//wufei 0930
UBYTE hideflag;//hubinhao 2002-11-28
/* NOTE that these are needed in new architecture */
static SERVICE_CF_TYPE       CFType;        /* Type of Call Forwarding */
static SERVICE_CF_SERVICE    CFService;     /* basic service for Call Forwarding */
static SERVICE_CF_ACTION     CFAction;      /* action for Call Forwarding */
static SERVICE_CB_TYPE       CBType;        /* Type of Call Barring */
static SERVICE_CB_ACTION     CBAction;      /* action for Call Barring */

static char                 CFNumber[MAX_LEN]; /* number to forward calls to */



static MfwMnuItem menuServicesUSSDOptionsItems[] =
{
    {0,0,0,(char *)TxtChange,0,(MenuFunc)servicesUSSDEdit,0},
    {0,0,0,(char *)TxtDelete,0,(MenuFunc)servicesUSSDDelete,0}
};

static MfwMnuAttr menuServicesUSSDOptions =
{
    0,
    &menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    menuServicesUSSDOptionsItems,                /* with these items         */
    sizeof(menuServicesUSSDOptionsItems)/sizeof(MfwMnuItem) /* number of items     */
};

#define MAX_STORED_USSD_LEN 10          /* max len. of stored USSD */
#define MAX_USSD_NAME_LEN   12          /* max len of stored USSD name */
static char  mCurrentUSSDNumber[MAX_USSD_LEN];      /* memory for USSD number editing */
static char  mCurrentUSSDName[MAX_USSD_NAME_LEN+1]; /* memory for USSD name editing */
static unsigned int mCurrentUSSD;       /* number of currently selected USSD in list */

static MfwHnd ussdMenu;                     /* ussd menu */
static MfwHnd ussdedt;                      /* ussd editor		        */

static char USSDedtBuf[MAX_USSD_LEN];       /* ussd edit buffer         */

static MfwEdtAttr USSDedtAttr =             /* ussd edit attributes:    */
{
    {6,30,84,20},                       /* edit area                */
    0,0,edtCurNone,                     /* fg color, font, mode = read only     */
    0,                                  /* control key array        */
    USSDedtBuf,MAX_USSD_LEN                 /* edit buffer, size        */
};

/* end of bits for USSD */



#define CF_ACTIVE_STATUS    1
#define CF_INACTIVE_STATUS  2
#define CF_UNKNOWN_STATUS   3

typedef struct
{
    USHORT service;
    USHORT status;
    char   forwarded_to_number[16];
} T_ss_feature_cf_data;

typedef struct
{
    T_ss_feature_cf_data ss[MFW_MAX_FEAT_NR];
} T_ss_feature_cf;


typedef struct
{
    USHORT service;
} T_ss_feature_cw_data;

typedef struct
{
    USHORT               status;
    T_ss_feature_cw_data ss[MFW_MAX_FEAT_NR];
} T_ss_feature_cw;

typedef struct
{
    USHORT service;
    USHORT status;
} T_ss_feature_cb_data;

typedef struct
{
    T_ss_feature_cb_data ss[MFW_MAX_FEAT_NR];
} T_ss_feature_cb;

typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;     // window handle
    T_MFW_HND       ss_handle;   /* MFW services handler  */
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_CM_AOC_INFO aocInfo;
    T_MFW_HND       info_win;  /* handle to info dialog */
    T_MFW_HND       info_wait;  /* handle to wait dialog */
    T_MFW_HND       cb_menu_win;  /* handle to ussd number dialog */
    T_MFW_HND       ussd_num_win;  /* handle to ussd number dialog */
    T_MFW_HND       ussd_name_win;  /* handle to ussd name dialog */
    T_MFW_HND       input_number_win;  /* handle to call forward dialog */
    T_MFW_HND       input_tim_menu;
    USHORT            event;
    char              edt_buf_name[PHB_MAX_LEN];
    char              edt_buf_number[PHB_MAX_LEN];
    char              edt_buf_cb_password[CB_PSW_LEN+1];
    char              edt_buf_cb_new_password[CB_PSW_LEN+1];
    char              edt_buf_cb_conf_new_password[CB_PSW_LEN+1];
    char              edt_buf_CUG_new_Name[9]; //WUFEI APPEND
    char              edt_buf_CUG_new_Index[2];//WUFEI APPEND
    char              edt_buf_NoAnswerTime[4];//WUFEI APPEND
    MfwEdtAttr        edt_attr_name;
    MfwEdtAttr        edt_attr_number;
    T_ss_feature_cf * mfw_ss_cf;
    T_ss_feature_cw * mfw_ss_cw;
    T_ss_feature_cb * mfw_ss_cb;
    UBYTE             current_feature;
    UBYTE             max_feature;
    UBYTE             dcs;  /* need it for sending ussd to mfw */
    char               text[25];                //25
    char               name[24];   //2003-4-8 change 21 to 24
    char               textNumbert[24];  //2003-4-8 change 21 to 24
} T_ss;


T_ss ss_data = {0};


static MfwMnuAttr UsedNumber_menuAttrib =
{
    0,
    &menuListArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
}; //WUFEI Append


static void srv_empty_list_result (UBYTE ss_category);

/* 2003/11/06, glowing, copy from the new release of TI */
static void srv_empty_list_result_new (UBYTE ss_category, USHORT event, UBYTE ss_status);  /* Marcus: Issue 1214: 22/10/2002 */

static void showCFStatus (T_MFW_HND win , T_ss  * data );
static UBYTE srv_copy_feature_list_cf (T_ss_feature_cf * out_list, T_MFW_SS_CF_CNF * in_list);
static void srv_get_forwarded_to_number ( char * textString,
                                          char * forwarded_to_number);
static UBYTE srv_get_service_type ( USHORT * textId,
                                    UBYTE ss_telecom_type, UBYTE ss_telecom_service);
static void srv_get_status (USHORT *textId, UBYTE pStatus);
static UBYTE srv_check_CF_telephony_status (T_MFW_SS_CF_CNF * in_list);

static void showCWStatus (T_MFW_HND win, T_ss  * data );
static UBYTE srv_copy_feature_list_cw (T_ss_feature_cw * out_list, T_MFW_SS_CW_CNF * in_list);

static void showCBStatus (T_MFW_HND win, T_ss  * data );
static UBYTE srv_copy_feature_list_cb (T_ss_feature_cb * out_list, T_MFW_SS_CB_CNF * in_list);


static int services_win_cb(T_MFW_EVENT e, T_MFW_SS_PARA * para);
static int services_ss_cb(T_MFW_EVENT e, T_MFW_HND para);

static int services_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reason);


static void srv_display_status (UBYTE ss_status);



typedef struct
{
    int            text;
    MfwEdtAttr*    edt_attr_input;
    int            left_soft_key;
    int            right_soft_key;
    short          abc;   /* numeric or alpha? */
    void (* callback)(T_MFW_HND win,USHORT reason);
} T_input_properties;



typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       edt_input;
    T_input_properties properties;
} T_ussd_input;



static T_MFW_HND ussd_input_create (MfwHnd parent);
static void ussd_input_destroy (MfwHnd window);

static MfwHnd ussd_input_start(MfwHnd parent,T_input_properties *properties);

void ussd_input (T_MFW_HND win, USHORT event, SHORT value, void * parameter);

static int ussd_input_win_cb(MfwEvt e, MfwWin *w);
static int ussd_input_kbd_cb(MfwEvt e, MfwKbd *k);
static int ussd_input_kbd_long_cb(MfwEvt e, MfwKbd *k);



typedef struct
{
    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       parent_win;
    T_MFW_HND       win;
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       edt_input;
    T_input_properties properties;
} T_services_input;


typedef struct
{
    T_MMI_CONTROL    mmi_control;
    T_MFW_HND        numbers_win;                    /* MFW win handler      */
    T_MFW_HND        parent;
    T_MFW_HND        usednumber_handler;         /* MFW sms handler      */
    unsigned char      local_status;
    ListMenuData     * menu_list_data;
} T_USEDNUMBER_INFO;  //WUFEI APPEND

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         cug_win;
    T_MFW_HND         parent;
    T_MFW_HND         cug_handler;
    unsigned char     local_status;
    ListMenuData      *menu_list_data;
}T_CUG_INFO; //WUFEI APPEND

typedef struct
{
    T_MMI_CONTROL     mmi_control;
    T_MFW_HND         recentcall_win;
    T_MFW_HND         parent;
    T_MFW_HND         cug_handler;
    unsigned char     local_status;
    ListMenuData      *menu_list_data;
}T_RecentCall_INFO; //WUFEI APPEND

typedef enum
{
    E_INIT = 0x0801,
    E_BACK,
    E_ABORT,
    E_EXIT,
    E_RETURN,
    E_OK,
    E_UPDATE//wufei add 0905
} e_UsedNumber_events; //WUFEI APPEND





static T_MFW_HND services_input_create (MfwHnd parent);
static void services_input_destroy (MfwHnd window);

static MfwHnd services_input_start(MfwHnd parent,T_input_properties *properties);

void services_input (T_MFW_HND win, USHORT event, SHORT value, void * parameter);

static int services_input_win_cb(MfwEvt e, MfwWin *w);
//static int services_input_kbd_cb(MfwEvt e, MfwKbd *k);
static int services_input_kbd_long_cb(MfwEvt e, MfwKbd *k);




/* editor   */
#define SAT_EDITOR_TOP_LEFT_POS_X   6
#define SAT_EDITOR_TOP_LEFT_POS_Y   30
#define SAT_EDITOR_HORIZONTAL_SIZE  84
#define SAT_EDITOR_VERTICAL_SIZE    20
#define SAT_EDITOR_COLOR            0
#define SAT_EDITOR_FONT             0
#define SAT_EDITOR_CONTROLS         0
#define SAT_EDITOR_BUFFER_SIZE      32
/*    */









/*******************************************************************************

 $Function:    	servicesInit

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/



T_MFW_HND servicesInit (T_MFW_HND parent)
{

    //	TRACE_FUNCTION("servicesInit function");

    /*
     * Initialise MFW
     */
    ss_mfw_init();
    /*
    * Create any other handler
    */
    ss_data.ss_handle = ss_create (0,
                                   0x0FFF,
                                   (T_MFW_CB)services_ss_cb);

    ss_data.win = 0;
    return(services_create (0));


}


/*******************************************************************************

 $Function:    	servicesExit

 $Description:	exit services handling

 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesExit (void)
{
    //    TRACE_FUNCTION("servicesExit");

    ss_delete(ss_data.win);
    ss_exit();
}


/*******************************************************************************

 $Function:    	services_create

 $Description:	Creation of an instance for the Services dialog.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/


T_MFW_HND services_create (T_MFW_HND parent_window)
{
    T_ss     * data = &ss_data;
    T_MFW_WIN     * win;

    //   TRACE_FUNCTION("services_create");

    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)services_win_cb);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog    = (T_DIALOG_FUNC)services;
    data->mmi_control.data      = data;
    win                         = ((T_MFW_HDR *)data->win)->data;
    win->user                   = (void *) data;

    /*
     * Create any other handler
     */
    data->info_win = 0;
    data->info_wait = 0;
    data->cb_menu_win = 0;
    data->ussd_num_win = 0;
    data->ussd_name_win = 0;
    data->input_number_win = 0;
    memset(data->edt_buf_name,'\0',sizeof(data->edt_buf_name));
    memset(data->edt_buf_number,'\0',sizeof(data->edt_buf_number));
    memset(data->edt_buf_cb_password,'\0',sizeof(data->edt_buf_number));
    bookSetEditAttributes(4,Mmi_layout_first_line()+2,120,32,0,0,edtCurBar1,0,(char*)data->edt_buf_name,PHB_MAX_LEN,&data->edt_attr_name);
    bookSetEditAttributes(4,Mmi_layout_first_line()+2,120,32,0,0,edtCurBar1,0,(char*)data->edt_buf_number,PHB_MAX_LEN,&data->edt_attr_number);


    winShow (data->win);

    /*
     * return window handle
     */
    return data->win;
}


/*******************************************************************************

 $Function:    	services_destroy

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void services_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win;
    T_ss     * data = &ss_data;

    // TRACE_FUNCTION("=== services_destroy");

    if( data )
    {
        /*
         * Delete WIN Handler
         */

        if( data->info_win )
        {
            SEND_EVENT(data->info_win, DIALOG_DESTROY, 0, 0);
            data->info_win=0;
        }
        if( ss_data.info_wait )
        {
            TRACE_EVENT("destroying the wait screen b");
            SEND_EVENT(ss_data.info_wait, DIALOG_DESTROY, 0, 0);
            ss_data.info_wait = 0;
        }
        if( data->ussd_name_win )
        {
            SEND_EVENT(data->ussd_name_win, DIALOG_DESTROY, 0, 0);
            data->ussd_name_win=0;
        }
        if( data->ussd_num_win )
        {
            SEND_EVENT(data->ussd_num_win, DIALOG_DESTROY, 0, 0);
            data->ussd_num_win=0;
        }
        if( data->input_number_win )
        {
            TRACE_FUNCTION("killing input number win");
            services_input_destroy( data->input_number_win );
            data->input_number_win=0;
        }
    }
}

/*******************************************************************************

 $Function:    	services_win_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static int services_win_cb(T_MFW_EVENT e, T_MFW_SS_PARA * para)
{
    /*
     * Top Window has no output
     */
    TRACE_FUNCTION ("services_win_cb()");
    switch( e )
    {
    case MfwWinVisible:
        break;
    default:
        return 0;
    }
    return 1;

}

/*******************************************************************************

 $Function:    	destroyInfoWindow

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void destroyInfoWindow( void)
{
    // TRACE_FUNCTION("destroyInfoWindow");

    /* kill info win if there */
    if( ss_data.info_wait )
    {
        TRACE_EVENT("destroying the wait screen a");
        SEND_EVENT(ss_data.info_wait, DIALOG_DESTROY, 0, 0);
        ss_data.info_wait = 0;
    }
    if( ss_data.input_number_win )
    {
        TRACE_FUNCTION("destroying input window!!!");
        SEND_EVENT(ss_data.input_number_win, SERVICES_INPUT_DESTROY, 0, 0);
        ss_data.input_number_win = 0;
    }

}
/*******************************************************************************

 $Function:    	services_ss_cb

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static int services_ss_cb(T_MFW_EVENT e, T_MFW_HND para)
{

    TRACE_FUNCTION ("services_ss_cb()");

    {
        char buf[40];
        T_MFW_WIN * win;

        //    sprintf (buf, "event = %d", e);
        //   TRACE_EVENT (buf);
        win = (T_MFW_WIN *) ((T_MFW_HDR *)ss_data.win)->data;
        //   sprintf (buf, "win->user = %d", win->user);
        //    TRACE_FUNCTION (buf);
    }

    switch( e )
    {
    case E_SS_RES:
        if( !ss_data.info_wait )
        {
            TRACE_EVENT ("show the wait screen");
            // showWait( ss_data.win ); //WUFEI Disabled it 0710
            showCFanimation( ss_data.win);// animation test 0710 wufei 
        }
        /*
         * ignore the event
         */
        break;

    case E_SS_NOTIFY:
        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_NOTIFY,0, para);

        destroyInfoWindow();
        break;

    case E_SS_CF_CNF:

        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_CF_CNF,0, para);

        destroyInfoWindow();
        break;

    case E_SS_CW_CNF:
        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_CW_CNF,0, para);

        destroyInfoWindow();
        break;

    case E_SS_CLI_CNF:
        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_CLI_CNF,0, para);

        destroyInfoWindow();
        break;

    case E_SS_CB_CNF:
        //    {
        //      char buf[40];
        //      T_MFW_WIN * win;

        //      sprintf (buf, "event = %d", e);
        //      TRACE_FUNCTION (buf);
        //      win = ((T_MFW_HDR *)ss_data.win)->data;
        //      sprintf (buf, "win->user = %d", win->user);
        //      TRACE_FUNCTION (buf);
        //    }

        //    {
        //      char buf[40];
        //      T_MFW_WIN * win;

        //      sprintf (buf, "event = %d", e);
        //      TRACE_FUNCTION (buf);
        //      win = ((T_MFW_HDR *)ss_data.win)->data;
        //      sprintf (buf, "win->user = %d", win->user);
        //      TRACE_FUNCTION (buf);
        //    }
        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_CB_CNF,0, para);

        destroyInfoWindow();
        break;

        /* we must display the ussd info and then edit and send a user ussd */
    case E_SS_USSD_REQ:

        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_USSD_REQ,0, para);

        destroyInfoWindow();        
        break;

        /* just display the ussd info */
    case E_SS_USSD_CNF:

        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_USSD_CNF,0, para);

        destroyInfoWindow();
        break;

    case E_SS_IMEI:

        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_IMEI,0, para);

        destroyInfoWindow();
        break;


    case E_SS_GET_PW:

        if( !ss_data.info_win )
            SEND_EVENT(ss_data.win,E_SS_GET_PW,0, para);

        destroyInfoWindow();
        break;
    default:
        break;
    }

    return 1;  /* consumed */
}


/*******************************************************************************

 $Function:    	services

 $Description:	

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
//--------------------------wufei modified-------------------------------------------
void services (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_ss           * data = (T_ss *)win_data->user;

    T_MFW_SS_PARA  * ss_cnf = (T_MFW_SS_PARA *)parameter;
    T_DISPLAY_DATA   display_info;

    unsigned int i = 0;//WUFEI APPEND
    unsigned int avail;//WUFEI APPEND	
    unsigned int n; //WUFEI APPEND

    char line[MAX_LINE];
    //MmiTrace("serviceshbh");

    TRACE_FUNCTION ("services()");

    switch( event )
    {
    

    case ServicesError:
        TRACE_FUNCTION ("ServicesError");
        //showError(win, ss_cnf->cb_cnf.ss_error);
        services_info_screen(win,TxtFailed);//WUFEI Modify
        break;

    case ServicesFailed:
        TRACE_FUNCTION ("ServicesFailed");
        showFailed(win);
        break;

    case ServicesOtherNumber:
        TRACE_FUNCTION("ServicesOtherNumber");
        ServicesGetOtherNumber(win);
        break;

    case ServicesUsedNumber:       //WUFEI APPEND
        TRACE_FUNCTION("ServicesUsedNumber");
        ServicesGetUsedNumber();
        break;

    case ServicesCUGSetting:     //WUFEI APPEND
        TRACE_FUNCTION("ServicesCUGSetting");
        ServicesCUGMenu();
        break;

    case ServicesOk:
        TRACE_FUNCTION ("ServicesOk");
        showOk(win);
        break;

    case ServicesUSSDEnter:
        {
            T_EDITOR_DATA   editor_data;

            TRACE_EVENT("ServicesUSSDEnter");


            memset(ss_data.edt_buf_number,'\0',PHB_MAX_LEN);
            editor_data.editor_attr.win.px   = 6;
            editor_data.editor_attr.win.py   = 18;
            editor_data.editor_attr.win.sx   = 80;
            editor_data.editor_attr.win.sy   = 28;
            editor_data.editor_attr.fgColor  = 0xffffff;
            editor_data.editor_attr.font     = 0;
            editor_data.editor_attr.mode    = edtCurBar1;
            editor_data.editor_attr.controls   = 0;
            editor_data.hide                = FALSE;

            editor_data.editor_attr.text    = (char*)ss_data.edt_buf_number;

            editor_data.editor_attr.size    = MAX_USSD_LEN;
            editor_data.LeftSoftKey         = TxtSoftOK;
            editor_data.RightSoftKey        = TxtSoftBack;
            editor_data.AlternateLeftSoftKey     = TxtNull;
            editor_data.TextString          = '\0';
            editor_data.TextId              = TxtEntAnw;
            editor_data.Identifier          = ServicesUSSDEnter;
            editor_data.mode                = DIGITS_MODE;
            editor_data.timeout             = FOREVER;
            editor_data.min_enter           = 1;
            editor_data.Callback            = (T_EDIT_CB)services_info_cb;
            editor_data.destroyEditor       = TRUE;


            /* create the dialog handler */
            editor_start(ss_data.win, &editor_data);  /* start the editor */
        }
        break;

    case SERVICES_DO_CALL_VOICE_DIVERT:
        servicesStoreVoiceMailNumber();
        servicesSendCallDivert(0);
        break;
    case ServicesDoCallDivert:
        servicesSendCallDivert(0);
        break;

    case E_SS_RES:
        /*
         * event is ignored
         */
        break;
    case E_SS_NOTIFY:
        //TRACE_FUNCTION(" E_SS_NOTIFY");
        /*zy move 2003-03-12
          we needn't show these information during call
        */
        //        showSSNotify( win, (T_MFW_SS_NOTIFY*) parameter );  /* all short ss-related notfications */
        break;

        /*
         * modified handling for results taking lists in account
         */
    case E_SS_CF_CNF: //wufei modified
        /*
         * check whether we received data what was requested / consistent
         */
        if( CFAction==CFActivate )
        {
            if( CFService==CFVoice )
            {

                //step 1 according whether in CFU state and CFType ,set FlashDCTbData.CFFlag 
                if( !(FlashDCTbData.CFFlag&SetCFU) )   //in CFU state in whick we can not active the other 3 state
                {

                    switch( CFType )
                    {
                    case CFNoReach:
                        FlashDCTbData.CFFlag |=SetCFNRc;
                        break;
                    case CFBusy:
                        FlashDCTbData.CFFlag |=SetCFB;
                        break;
                    case CFNoReply:
                        FlashDCTbData.CFFlag |=SetCFNRy;
                        break;
                    case CFUnconditional:
                        FlashDCTbData.CFFlag |=SetCFU;
                        break;
                    }

                }
                flash_DCTbwrite();  

                //if in CFU state ,we do not change bits in FlashDCTbData.CFFlag,because it can not active CFNoReach CFBusy CFNoReply when in CFUnconditional

                //step 2 show iconIdCallFor
                switch( srv_check_CF_telephony_status ( &ss_cnf->cf_cnf ) )
                {
                case  CF_ACTIVE_STATUS:

                    iconsSetState(iconIdCallFor);
                    showCFStatus(win, data);  //hu binhao 2003-2-21 

                    break;
                case CF_INACTIVE_STATUS:
                    iconsDeleteState(iconIdCallFor);
                    break;
                default:  // CF_UNKNOWN_STATUS
                    //iconsDeleteState(iconIdCallFor); //SPR#984 - DS - Commented out. Leave state unchanged as default.
                    services_info_screen(win,TxtFailed);//hu binhao 2003-2
                    break;
                }
                //step 3 show dialog 
                // showCFStatus(win, data);
                FREE_MEMORY ((void *)data->mfw_ss_cf, sizeof (T_ss_feature_cf));  //hu binhao 2003-2-19
                data->mfw_ss_cf = NULL;    

                //step 4 save number to usually used number list
                /***********************************WUFEI APPEND*********************************************/
                if( strlen(ss_data.edt_buf_number)!=0 )
                {
                    n=usednumber_GetListCount(RES_USEDNUMBER);
                    i=0;
                    avail=1;
                    while( avail==1 AND i<n )
                    {
                        if( strstr((char*)FlashDCTbData.UsedNumberTable[i],ss_data.edt_buf_number)!=NULL )
                            avail=0;
                        i++;
                    }
                    if( avail==1 )
                    {
                        if( FlashDCTbData.UsedTbIdx==10 )
                        {
                            FlashDCTbData.UsedTbIdx=0;
                        }
                        if( FlashDCTbData.UsedTbIdx<10 )
                        {
                            strcpy((char*)FlashDCTbData.UsedNumberTable[FlashDCTbData.UsedTbIdx],ss_data.edt_buf_number);
                            FlashDCTbData.UsedTbIdx++;
                            flash_DCTbwrite();
                        }

                    }
                    memset(ss_data.edt_buf_number,'\0',PHB_MAX_LEN);
                }
                /*************************************************************************************/
            }
            else
            {
                switch( srv_check_CF_telephony_status ( &ss_cnf->cf_cnf ) )
                {
                case  CF_ACTIVE_STATUS:
                    iconsSetState(iconIdCallFor);
                    break;
                case CF_INACTIVE_STATUS:
                    iconsDeleteState(iconIdCallFor);
                    break;
                default:  // CF_UNKNOWN_STATUS
                    //iconsDeleteState(iconIdCallFor); //SPR#984 - DS - Commented out. Leave state unchanged as default.
                    break;
                }
                showCFStatus(win, data);
                /***********************************WUFEI APPEND*********************************************/
                if( strlen(ss_data.edt_buf_number)!=0 )
                {
                    n=usednumber_GetListCount(RES_USEDNUMBER);
                    i=0;
                    avail=1;
                    while( avail==1 AND i<n )
                    {
                        if( strstr((char*)FlashDCTbData.UsedNumberTable[i],ss_data.edt_buf_number)!=NULL )
                            avail=0;
                        i++;
                    }
                    if( avail==1 )
                    {
                        if( FlashDCTbData.UsedTbIdx==10 )
                        {
                            FlashDCTbData.UsedTbIdx=0;
                        }
                        if( FlashDCTbData.UsedTbIdx<10 )
                        {
                            strcpy((char*)FlashDCTbData.UsedNumberTable[FlashDCTbData.UsedTbIdx],ss_data.edt_buf_number);
                            FlashDCTbData.UsedTbIdx++;
                            flash_DCTbwrite();  
                        }
                    }
                    memset(ss_data.edt_buf_number,'\0',PHB_MAX_LEN);
                }
                /*************************************************************************************/
            } 
        }
        else
        {
            switch( ss_cnf->cf_cnf.ss_code )
            {
            case SS_CODES_UNKNOWN:
                //break;/*2004/4/30, wangyan modify*/
            case SS_CF_CFU:
            case SS_CF_ALL:
            case SS_CLIR:
            case SS_CF_ALL_COND:
            case SS_CF_CFNRy:
            case SS_CF_CFNR:
            case SS_CF_CFB:       
                switch( ss_cnf->cf_cnf.ss_error )
                {
                case MFW_SS_NO_ERROR:
                    //  HU begin
                    //SPR#984 - DS - Only update icons if activating / cancelling.

                    //	MmiTrace("mmiservices.c MFW_SS_NO_ERROR hubh11");

                    if( CFAction==CFDeactivate )
                    {
                        //step1 if CFDeactivate,then change CFFlag according CFType
                        switch( CFType )
                        {
                        case CFNoReach:
                            FlashDCTbData.CFFlag &=ReSetCFNRc;
                            break;
                        case CFBusy:
                            FlashDCTbData.CFFlag &=ReSetCFB;
                            break;
                        case CFNoReply:
                            FlashDCTbData.CFFlag &=ReSetCFNRy;
                            break;
                        case CFUnconditional:
                            FlashDCTbData.CFFlag &=ReSetCFU;
                            break;
                        case CFAllCalls:
                            FlashDCTbData.CFFlag =0;
                            break;
                        }
                        //if CFFlag equal 0, iconsDeleteState(iconIdCallFor)
                        if( !(FlashDCTbData.CFFlag&GetFourbits) )
                        {

                            if( ss_cnf->cf_cnf.ss_category != SS_INTERROGATION )
                            {
                                switch( srv_check_CF_telephony_status ( &ss_cnf->cf_cnf ) )
                                {
                                case  CF_ACTIVE_STATUS:

                                    iconsSetState(iconIdCallFor);
                                    // MmiTrace("ser MFW_SS_NO_ERROR  hubh11");

                                    break;
                                case CF_INACTIVE_STATUS:
                                    iconsDeleteState(iconIdCallFor);
                                    break;
                                default:  // CF_UNKNOWN_STATUS
                                    //iconsDeleteState(iconIdCallFor); //SPR#984 - DS - Commented out. Leave state unchanged as default.
                                    break;
                                }
                            }
                        }
                        flash_DCTbwrite();  //wriite to flash hu binhao 2003-2-11
                    }
                    /*
                     * now store the MFW data under the SS window
                     */
                    data->mfw_ss_cf = (T_ss_feature_cf *)ALLOC_MEMORY (sizeof (T_ss_feature_cf));

                    /*
                     * copy all interesting feature entries
                     */
                    data->max_feature = srv_copy_feature_list_cf (data->mfw_ss_cf, &ss_cnf->cf_cnf);
                    data->current_feature = /*CFService*/0;

                    if( data->max_feature EQ 0 )
                    {
                        srv_empty_list_result (ss_cnf->cf_cnf.ss_category);
                        FREE_MEMORY ((void *)data->mfw_ss_cf, sizeof (T_ss_feature_cf));
                        data->mfw_ss_cf = NULL;

                        //consider the change sim card sitation ,for delet the call forward icon in idile interface.
                        // begin hu binhao 2003-4-30
                        {
                            unsigned char Tempflag;
                            Tempflag=0;
                            switch( CFType )
                            {
                            //step1 1:to adjust the bit in FlashDCTbData.CFFlag after check state ,according CFType
                            case CFNoReach:
                                if( (FlashDCTbData.CFFlag&SetCFNRc)!=0 )
                                {
                                    FlashDCTbData.CFFlag &=ReSetCFNRc;
                                    Tempflag=1;
                                }
                                break;
                            case CFBusy:
                                if( (FlashDCTbData.CFFlag&SetCFB)!=0 )
                                {
                                    FlashDCTbData.CFFlag &=ReSetCFB;
                                    Tempflag=1;
                                }
                                break;
                            case CFNoReply:
                                if( (FlashDCTbData.CFFlag&SetCFNRy)!=0 )
                                {

                                    FlashDCTbData.CFFlag &=ReSetCFNRy;
                                    Tempflag=1;
                                }
                                break;
                            case CFUnconditional:
                                if( (FlashDCTbData.CFFlag&SetCFU)!=0 )
                                {
                                    FlashDCTbData.CFFlag &=ReSetCFU;
                                    Tempflag=1;
                                }
                                break;
                            }
                            //step 2: if there are some change,we must write the DCTB flash file
                            if( Tempflag!=0 )
                            {
                                flash_DCTbwrite();  
                            }
                            //step 3: if it has not any type of call forward ,we delete the icon in idile interface
                            if( !(FlashDCTbData.CFFlag&GetFourbits) )
                            {
                                iconsDeleteState(iconIdCallFor);  
                            }
                        }
                        //2003-4-30  hu binhao end
                    }
                    else
                    {
                        /*
                         * now display status
                         */
                        showCFStatus(win, data);
                        FREE_MEMORY ((void *)data->mfw_ss_cf, sizeof (T_ss_feature_cf));  //hu binhao 2003-2-19
                        data->mfw_ss_cf = NULL;                                       //hu binhao 2003-2-19
                    }
                    break;

                default:
                    // TRACE_FUNCTION("ERROR in CFU,INTERROGATION");
                    //showError(win, ss_cnf->cf_cnf.ss_error);
                    services_info_screen(win,TxtFailed);//WUFEI Modify
                    break;
                }
                break;

            default:
                break;
            } /* end switch(ss_cnf->cf_cnf.ss_code) */

        }
        break;


    case E_SS_CW_CNF:
        if( ss_cnf->cw_cnf.ss_error == MFW_SS_NO_ERROR )
        {
            /*
             * now store the MFW data under the SS window
             */
            data->mfw_ss_cw = (T_ss_feature_cw *)ALLOC_MEMORY (sizeof (T_ss_feature_cw));

            /*
             * copy all interesting feature entries
             */
            data->max_feature = srv_copy_feature_list_cw (data->mfw_ss_cw, &ss_cnf->cw_cnf);
            data->current_feature = 0;

            if( data->max_feature EQ 0 )
            {
                //glowing, 2003/11/21, fix the bug that if the SIMcard does not have calling
                // waiting function, it still give the active info.
                if( ss_cnf->cw_cnf.ss_status NEQ 0xFF AND ss_cnf->cw_cnf.ss_status NEQ 0x00 )
                    //if (ss_cnf->cw_cnf.ss_status NEQ 0xFF)
                    srv_display_status (ss_cnf->cw_cnf.ss_status);
                else
                    //srv_empty_list_result (ss_cnf->cw_cnf.ss_category);
                    srv_empty_list_result_new (ss_cnf->cw_cnf.ss_category, event, ss_cnf->cw_cnf.ss_status);  /* Marcus: Issue 1214: 22/10/2002 */

                FREE_MEMORY ((void *)data->mfw_ss_cw, sizeof (T_ss_feature_cw));
                data->mfw_ss_cw = NULL;
            }
            else
            {
                /*
                 * now display status
                 */
                showCWStatus(win, data);
                /*
                if(cwflag)
                  services_info_screen(win,TxtActivated);
                else
                  services_info_screen(win,TxtDeActivated);
                  */
            }
            if( cwflag )
            {
                FlashDCTbData.callwaitflag=1;
                flash_DCTbwrite();
            }
            else
            {
                FlashDCTbData.callwaitflag=0;
                flash_DCTbwrite();
            }   
        }
        else
        {
            //showError(win, ss_cnf->cw_cnf.ss_error);
            services_info_screen(win,TxtFailed);//WUFEI Modify
        }
        break;

    case E_SS_CLI_CNF:
        //TRACE_FUNCTION("  E_SS_CLI_CNF");    //hu hubh marked 11-28

        if( ss_cnf->cli_cnf.ss_error == MFW_SS_NO_ERROR )
        {

            showCLIStatus(win, ss_cnf);
        }
        else
        {
            //showError(win, ss_cnf->cli_cnf.ss_error);
            services_info_screen(win,TxtFailed);//WUFEI Modify
        }
        break;


    case E_SS_CB_CNF:
        switch( ss_cnf->cb_cnf.ss_error )
        {
        case MFW_SS_NO_ERROR:
            /*
             * now store the MFW data under the SS window
             */
            data->mfw_ss_cb = (T_ss_feature_cb *)ALLOC_MEMORY (sizeof (T_ss_feature_cb));

            /*
             * copy all interesting feature entries
             */
            data->max_feature = srv_copy_feature_list_cb (data->mfw_ss_cb, &ss_cnf->cb_cnf);
            data->current_feature = 0;

            if( data->max_feature EQ 0 )
            {
                srv_empty_list_result (ss_cnf->cb_cnf.ss_category);
                FREE_MEMORY ((void *)data->mfw_ss_cb, sizeof (T_ss_feature_cb));
                data->mfw_ss_cb = NULL;
            }
            else
            {
                /*
                 * now display status
                 */
                showCBStatus(win, data);
            }
            break;

        default:
            //showError(win, ss_cnf->cb_cnf.ss_error);
            services_info_screen(win,TxtFailed);//WUFEI Modify
            break;
        }
        break;

    case E_SS_IMEI:   /* present IMEI */
        /* T_MFW_IMEI imei_cnf;*/
        //TRACE_FUNCTION("  E_SS_IMEI");

        switch( ss_cnf->imei_info.error )
        {
        case MFW_SS_NO_ERROR:
            //TRACE_FUNCTION( "Handling IMEI no error" );
            showIMEI2(win, ss_cnf);
            break;

        default:
            //TRACE_FUNCTION("ERROR in IMEI");
            //showError(win, ss_cnf->imei_info.error);
            services_info_screen(win,TxtFailed);//WUFEI MODIFY
            break;
        }
        break;

        /* we must display the ussd info and then edit and send a user ussd */
    case E_SS_USSD_REQ:
        //TRACE_FUNCTION(" E_SS_USSD_REQ");

        switch( ss_cnf->ussd_info.error )
        {
        case MFW_SS_NO_ERROR:
            //TRACE_FUNCTION( "Handling USSD_REQ no error" );
            showUSSDREQ(win, ss_cnf );
            break;

        default:
            //TRACE_FUNCTION("ERROR in USSD REQ");
            //showError(win, ss_cnf->ussd_info.error);
            services_info_screen(win,TxtFailed);//WUFEI Modify
            break;
        }

        break;

        /* just display the ussd info */
    case E_SS_USSD_CNF:
        // TRACE_FUNCTION(" E_SS_USSD_CNF");
        switch( ss_cnf->ussd_info.error )
        {
        case MFW_SS_NO_ERROR:
            //TRACE_FUNCTION( "Handling USSD_CNF no error" );
            showUSSDCNF(win, ss_cnf );
            break;

        default:
            //TRACE_FUNCTION("ERROR in USSD_CNF");
            //showError(win, ss_cnf->ussd_info.error);
            services_info_screen(win,TxtFailed);//WUFEI APPEND
            break;
        }
        break;
    case E_SS_GET_PW:
        if( ss_cnf->pw_cnf.ss_error == MFW_SS_NO_ERROR )
        {
            showOk(win);
            strncpy((char*)ss_data.edt_buf_cb_password,
                    (char*)ss_cnf->pw_cnf.ss_new_pwd,CB_PSW_LEN);
        }
        else
        {
            //showError(win, ss_cnf->pw_cnf.ss_error);
            services_info_screen(win,TxtFailed);//WUFEI APPEND
        }
        break;
    default:
        return;
    }

}
//-----------------------end of wufei modified-------------------------------------

/*******************************************************************************

 $Function:    	srv_check_CF_telephony_status

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static UBYTE srv_check_CF_telephony_status (T_MFW_SS_CF_CNF * in_list)
{
    UBYTE i;

    for( i=0;i<in_list->ss_feature_count;i++ )
    {
        T_MFW_FEATURE * pFeature = &in_list->ss_feature_list[i];

        /*
         * first check service type
         */
        if( pFeature->ss_telecom_type EQ MFW_BST_TELE )
        {
            switch( pFeature->ss_telecom_service )
            {
            case MFW_TS_ALL_TS:        
            case MFW_TS_ALL_SPCH:
            case MFW_TS_TLPHNY:
            case MFW_TS_ALL_XCPT_SMS:
                if( pFeature->ss_status & SS_STAT_ACTIVE )
                    return CF_ACTIVE_STATUS;
                else
                    return CF_INACTIVE_STATUS;
                break;

            default:
                break;
            }
        }

        //SPR#984 - DS - Added code below for when no service type is specified.
        if( pFeature->ss_telecom_type EQ MFW_BST_UNKNOWN ) //When no service type is specfied
        {
            switch( pFeature->ss_telecom_service )
            {
            case MFW_BS_TS_UNKNOWN:
                if( pFeature->ss_status & SS_STAT_ACTIVE )
                    return CF_ACTIVE_STATUS;
                else
                    return CF_INACTIVE_STATUS;
                break;

            default:
                break;
            }
        }

    }
    return CF_UNKNOWN_STATUS;
}


/*******************************************************************************

 $Function:    	srv_check_CF_telephony_status

 $Description:	copies only the interesting parts of the call forwarding
            feature list.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static UBYTE srv_copy_feature_list_cf (T_ss_feature_cf * out_list, T_MFW_SS_CF_CNF * in_list)
{
    UBYTE found_entries = 0;
    UBYTE i;

    {
        char temp[50];

        sprintf(temp,"ss_feature_count %d",in_list->ss_feature_count);
        //TRACE_FUNCTION(temp);		
    }

    for( i=0;i<in_list->ss_feature_count;i++ )
    { //MC Trying got rid of pointer arithmetic

        T_MFW_FEATURE * pFeature = &in_list->ss_feature_list[i]; //SPR#1081 - DS - Removed mem allocation. Uses assignment instead.
        T_ss_feature_cf_data * cf_data = &out_list->ss[found_entries];

        /*
         * first check teleservice
         */
        if( srv_get_service_type (&cf_data->service, pFeature->ss_telecom_type,
                                  pFeature->ss_telecom_service) )
        {
            /*
             * second set status
             */
            srv_get_status (&cf_data->status, pFeature->ss_status);

            if( (ss_cnf->cf_cnf.ss_code==SS_CF_CFU)||(ss_cnf->cf_cnf.ss_code==SS_CF_ALL) )
            {
                if( pFeature->ss_status & SS_STAT_ACTIVE )
                    iconsSetState(iconIdCallFor);
                else
                    iconsDeleteState(iconIdCallFor);
            }

            /*
             * third set forwarded to number
             */
            srv_get_forwarded_to_number ((CHAR *)cf_data->forwarded_to_number,
                                         (CHAR *)pFeature->ss_forwarded_to_number);
            {
                char temp[80];

                sprintf(temp,"ss_forwarded_to_number %s",
                        (CHAR *)pFeature->ss_forwarded_to_number);
                //TRACE_FUNCTION(temp);		
            }
            found_entries++;
        }


        //SPR#1081 - DS - Do not output number or basic service when there is more than one divert
        //				activated for a particular divert type e.g. All Calls '21'.
        //				Output "All Calls Activated" when all of Voice, Fax and Data are activated.

        if( in_list->ss_feature_count > 1 ) //More than one divert active for a divert type.
        {
            int i = 0;

            if( in_list->ss_feature_count == 3 ) //Voice, Fax and Data are all activated
                cf_data->service = TxtAllCalls;
            else //Do not display service
                cf_data->service = TxtNull; 

            for( i=0; i<15; i++ ) //Do not display number
                cf_data->forwarded_to_number[i] = 0x00; //Zero each element
        }

    }

    /*
     * return the number of interesting entries
     */
    return found_entries;
}


/*******************************************************************************

 $Function:    	srv_get_forwarded_to_number

 $Description:	sets the forwarded to number if available.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static void srv_get_forwarded_to_number ( char * textString,
                                          char * forwarded_to_number)
{
    //TRACE_FUNCTION("srv_get_forwarded_to_number");

    memset (textString, 0, 16);
    strncpy (textString, forwarded_to_number, 15);
}


/*******************************************************************************

 $Function:    	srv_get_service_type

 $Description:	checks if the service is interesting or not.
            
 $Returns:		

 $Arguments:	
 
 $History:
 //SPR#0776 - DS - Added default value for textId. Changed references from TxtNotImplemented
                    to TxtNull.
*******************************************************************************/


static UBYTE srv_get_service_type ( USHORT * textId,
                                    UBYTE ss_telecom_type, UBYTE ss_telecom_service)
{
    //TRACE_FUNCTION("srv_get_service_type");
    *textId = TxtNull; //Set to TxtNull in case no match found below.

    switch( ss_telecom_type )
    {
    case MFW_BST_UNKNOWN:
        break;

    case MFW_BST_TELE:
        switch( ss_telecom_service )
        {
        case MFW_TS_ALL_TS:
            *textId = TxtAllCalls;
            return TRUE;

        case MFW_TS_ALL_SPCH:       /* All speech transmission services */
        case MFW_TS_TLPHNY:         /* telephony                      */
        case MFW_TS_PLMN1: /*MC, this is returned for auxiliary telephony status, 742*/
            *textId = TxtVoice;
            return TRUE;

        case MFW_TS_ALL_XCPT_SMS:
            *textId = TxtNull;
            return TRUE;

        case MFW_TS_ALL_DATA:
            *textId = TxtData;
            return TRUE;

        case MFW_TS_ALL_FAX:
            *textId = TxtFax;
            return TRUE;
        }

        break;

    case MFW_BST_BEARER:
        switch( ss_telecom_service )
        {
        case MFW_BS_ALL_BS:
            *textId = TxtData; //SPR#933 - DS - Changed TxtNull to TxtData.
            return TRUE;
        case MFW_BS_ALL_DATA_CDA: //SPR#933 - DS - Added so MMI displays correct info to user.
            *textId = TxtData;
            return TRUE;

            /* SPR - DS - Fix for FTA 31.2.1.3 DO NOT REMOVE
             * MFW_BS_xxx added to synch with ACI
             */
        case MFW_BS_CDA_300:        /* data CDA  300 bps              */
        case MFW_BS_CDA_1200:        /* data CDA 1200 bps              */
        case MFW_BS_CDA_1200_75:        /* data CDA 1200/75 bps           */
        case MFW_BS_CDA_2400:        /* data CDA 2400 bps              */
        case MFW_BS_CDA_4800:        /* data CDA 4800 bps              */
        case MFW_BS_CDA_9600:        /* data CDA 9600 bps              */
        case MFW_BS_ALL_DATA_CDS:        /* all data CDS services          */
        case MFW_BS_CDS_1200:        /* data CDS 1200 bps              */
        case MFW_BS_CDS_2400:        /* data CDS 2400 bps              */
        case MFW_BS_CDS_4800:        /* data CDS 4800 bps              */
        case MFW_BS_CDS_9600:        /* data CDS 9600 bps              */
        case MFW_BS_ALL_DATA_PAD:        /* all data PAD services          */
        case MFW_BS_PAD_300:        /* data PAD  300 bps              */
        case MFW_BS_PAD_1200:        /* data PAD 1200 bps              */
        case MFW_BS_PAD_1200_75:        /* data PAD 1200/75 bps           */
        case MFW_BS_PAD_2400:        /* data PAD 2400 bps              */
        case MFW_BS_PAD_4800:        /* data PAD 4800 bps              */
        case MFW_BS_PAD_9600:        /* data PAD 9600 bps              */
        case MFW_BS_ALL_DATA_PDS:        /* all data PDS services          */
        case MFW_BS_PDS_2400:        /* data PDS 2400 bps              */
        case MFW_BS_PDS_4800:        /* data PDS 4800 bps              */
        case MFW_BS_PDS_9600:        /* data PDS 9600 bps              */
        case MFW_BS_SPCH_ALT_CDA:        /* all data CDA alter. speech     */
        case MFW_BS_SPCH_ALT_CDS:        /* all data CDS alter. speech     */
        case MFW_BS_SPCH_FLD_CDA:        /* all data speech followed CDA   */
        case MFW_BS_SPCH_FLD_CDS:        /* all data speech followed CDA   */
        case MFW_BS_ALL_DC_ASYN:        /* all data circuit asynchronous  */
        case MFW_BS_ALL_ASYN:        /* all asynchronous services      */
        case MFW_BS_ALL_DC_SYN:        /* all data circuit synchronous   */
        case MFW_BS_ALL_SYN:        /* all synchronous services       */ 
            *textId = TxtData;
            return TRUE;
        default:
            break;
        }
        break;
    }

    return FALSE;
}

/*******************************************************************************

 $Function:    	srv_get_status

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void srv_get_status (USHORT *textId, UBYTE pStatus)
{
    //TRACE_FUNCTION("srv_get_status");

    if( pStatus & SS_STAT_ACTIVE )    // handles also the case of invalid status
        *textId = TxtActivated;
    else
        *textId = TxtDeActivated;
}


/*******************************************************************************

 $Function:    	srv_copy_feature_list_cw

 $Description:	 copies only the interesting parts of the call waiting
            service list.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static UBYTE srv_copy_feature_list_cw (T_ss_feature_cw * out_list, T_MFW_SS_CW_CNF * in_list)
{
    UBYTE found_entries = 0;
    UBYTE i;

    for( i=0;i<in_list->ss_service_count;i++ )
    {
        T_MFW_SRV_GROUP      * pFeature = &in_list->ss_service_list[i];
        T_ss_feature_cw_data * cw_data = &out_list->ss[found_entries];

        /*
         * first check teleservice
         */
        if( srv_get_service_type (&cw_data->service, pFeature->ss_telecom_type,
                                  pFeature->ss_telecom_service) )
        {
            /*
             * second set status
             */
            srv_get_status (&out_list->status, in_list->ss_status);
            found_entries++;
        }
    }

    /*
     * return the number of interesting entries
     */
    return found_entries;
}

/*******************************************************************************

 $Function:    	srv_copy_feature_list_cb

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static UBYTE srv_copy_feature_list_cb (T_ss_feature_cb * out_list, T_MFW_SS_CB_CNF * in_list)
{
    UBYTE found_entries = 0;
    UBYTE i;

    for( i=0;i<in_list->ss_telecom_count;i++ )
    {
        T_MFW_TELECOM * pFeature = &in_list->ss_telecom_list[i];
        T_ss_feature_cb_data * cb_data = &out_list->ss[found_entries];

        /*
         * first check teleservice
         */
        if( srv_get_service_type (&cb_data->service, pFeature->ss_telecom_type,
                                  pFeature->ss_telecom_service) )
        {
            /*
             * second set status
             */

            srv_get_status (&cb_data->status, pFeature->ss_status);
            found_entries++;
        }
    }

    /*
     * return the number of interesting entries
     */
    return found_entries;
}



/*******************************************************************************

 $Function:    	services_info_cb

 $Description:	Callback function from information dialog.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static int services_info_cb(T_MFW_HND win, USHORT identifier, UBYTE reason)
{

    T_DISPLAY_DATA   display_info;
    UBYTE PWD;

    char buf[40];
    sprintf (buf, "Service Info CB %d", win);
    //TRACE_FUNCTION (buf);

    ss_data.info_wait = 0;
    ss_data.info_win = 0;


    /*
     * Who has initiated the information screen
     */
    switch( identifier )
    {
    case SS_WAIT:

        break;
    case ServicesOk:
    case ServicesFailed:
    case ServicesCheckCLI_OK:
    case ServicesCheckCW_OK:
    case ServicesIMEI_OK:
    case ServicesError:
    case ServicesUSSD_CNF_OK:
    case ServicesUSSDAlreadyFull:   /* already full message screen */
    case ServicesCFU_OK:
    case ServicesCB_OK:

    case E_SS_NOTIFY:
    case E_SS_IMEI:   /* present IMEI */
    case E_SS_CLI_CNF:
    case E_SS_USSD_CNF:
        switch( reason )
        {
        case INFO_TIMEOUT:
            /* info dialog timed out, where to now? */
            /* no break; */
        case INFO_KCD_HUP:
            /* clear key in info dialog, where to now? */
            /* no break;*/
        case INFO_KCD_LEFT:
            /* left soft key in info dialog, where to now? */
            /* no break;*/
        case INFO_KCD_RIGHT:
            /* right soft key in info dialog, where to now? */
            //			ss_data.info_wait = 0;
            services_destroy(win);
            break;
        }
        break;

    case E_SS_CB_CNF:
        {
            T_MFW_WIN * win_data;
            T_ss      * data;

            win_data = ((T_MFW_HDR *)win)->data;
            data     = (T_ss *)win_data->user;

            switch( reason )
            {
            case INFO_TIMEOUT:
                /*
                 * not started, so it is not possible
                 */
                break;
            case INFO_KCD_HUP:
            case INFO_KCD_LEFT:
                /*
                 * stop the display of the results
                 */
                if( data->mfw_ss_cb )
                {
                    FREE_MEMORY ((void *)data->mfw_ss_cb, sizeof (T_ss_feature_cb));
                    data->mfw_ss_cb = NULL;
                    data->current_feature = 0;
                    {
                        char buf[40];
                        sprintf (buf, "SS_data.win %d %d",ss_data.win, data);
                        //TRACE_FUNCTION (buf);
                    }
                }
                break;

            case INFO_KCD_UP:
                if( data->mfw_ss_cb )
                {
                    if( data->max_feature > data->current_feature + 1 )
                        data->current_feature++;
                    showCBStatus (win, data);
                }
                break;
            case INFO_KCD_DOWN:
                if( data->mfw_ss_cb )
                {
                    if( data->current_feature > 0 )
                        data->current_feature--;
                    showCBStatus (win, data);
                }
                break;

            default:
                break;
            }
        }
        break;

    case E_SS_CW_CNF:
        {
            T_MFW_WIN * win_data;
            T_ss      * data;

            win_data = ((T_MFW_HDR *)win)->data;
            data     = (T_ss *)win_data->user;

            switch( reason )
            {
            case INFO_TIMEOUT:
                /*
                 * not started, so it is not possible
                 */
                break;
            case INFO_KCD_HUP:
            case INFO_KCD_LEFT:
                /*
                 * stop the display of the results
                 */
                if( data->mfw_ss_cw )
                {
                    FREE_MEMORY ((void *)data->mfw_ss_cw, sizeof (T_ss_feature_cw));
                    data->mfw_ss_cw = NULL;
                    data->current_feature = 0;
                }
                break;

            case INFO_KCD_UP:
                if( data->mfw_ss_cw )
                {
                    if( data->max_feature > data->current_feature + 1 )
                        data->current_feature++;
                    showCWStatus (win, data);
                }
                break;
            case INFO_KCD_DOWN:
                if( data->mfw_ss_cw )
                {
                    if( data->current_feature > 0 )
                        data->current_feature--;
                    showCWStatus (win, data);
                }
                break;

            default:
                break;
            }
        }
        break;
    case CFCancelAffirm://WUFEI APPEND
        switch( reason )
        {
        case INFO_TIMEOUT:
            /* info dialog timed out, where to now? */
            /* no break; */
        case INFO_KCD_HUP:
            /* clear key in info dialog, where to now? */
            /* no break;*/
        case INFO_KCD_RIGHT:
            /* right soft key in info dialog, where to now? */
            //			ss_data.info_wait = 0;
            services_destroy(win);
            break;
        case INFO_KCD_LEFT:
            if( CFType != CFAllCalls )
                servicesDivertDeactivate();
            else
                servicesSendCallDivert(0);
            break;
        default:
            break;
        }
        break;
    case E_SS_CF_CNF:
        {
            T_MFW_WIN * win_data;
            T_ss      * data;

            win_data = ((T_MFW_HDR *)win)->data;
            data     = (T_ss *)win_data->user;

            switch( reason )
            {
            case INFO_TIMEOUT:
                /*
                 * not started, so it is not possible
                 */
                break;
            case INFO_KCD_HUP:
            case INFO_KCD_LEFT:
                /*
                 * stop the display of the results
                 */
                if( data->mfw_ss_cf )
                {
                    FREE_MEMORY ((void *)data->mfw_ss_cf, sizeof (T_ss_feature_cf));
                    data->mfw_ss_cf = NULL;
                    data->current_feature = 0;
                }
                break;
                /*
              case INFO_KCD_UP:
                if (data->mfw_ss_cf)
                {
                  if (data->max_feature > data->current_feature + 1)
                    data->current_feature++;
                  showCFStatus (win, data);
                }
                break;
              case INFO_KCD_DOWN:
                if (data->mfw_ss_cf)
                {
                  if (data->current_feature > 0)
                    data->current_feature--;
                  showCFStatus (win, data);
                }
                break;
                */
            default:
                break;
            }
            break;
        }
    case ServicesUSSD_REQ_OK:
        switch( reason )
        {
        case INFO_KCD_HUP:
            /* clear key in info dialog, where to now? */
            // no break;
        case INFO_TIMEOUT:
            /* info dialog timed out, where to now? */
            // no break;
        case INFO_KCD_RIGHT:
            /* right soft key in info dialog, where to now?
               all above mean cancelled so go back to whatever was before (idle?)*/
            services_destroy(win);
            break;

        case INFO_KCD_LEFT:
            /* left soft key in info dialog, where to now?
              This means confirm, so now go to USSD entry screen */
            SEND_EVENT(ss_data.win,ServicesUSSDEnter,0,0);
            break;
        default:
            break;
        }
        break;

    case ServicesUSSDEnter:
        {
            T_MFW_SS_PARA ussd_data;


            ussd_data.ussd_info.len = strlen((char*)ss_data.edt_buf_number);
            ussd_data.ussd_info.dcs = ss_data.dcs;
            ussd_data.ussd_info.error = MFW_SS_NO_ERROR;

            memcpy(ussd_data.ussd_info.ussd, ss_data.edt_buf_number, ussd_data.ussd_info.len);


            sendUSSD (&ussd_data);
        }
        break;

    }
    return 1;
}


/*******************************************************************************

 $Function:    	servicesNumbers

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int servicesNumbers(MfwMnu* m, MfwMnuItem* i){
    CFAction = CFActivate;
    //	servicesDoOtherNumber();	
}


/*******************************************************************************

 $Function:    	servicesInfraRed

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int servicesInfraRed(void){return 11;}


/*******************************************************************************

 $Function:    	servicesExec

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void servicesExec (int reason, MmiState next)
{
    UBYTE PWD;
    T_MFW_HND win = mfw_parent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;

    nextState = next;


    if( !winIsFocussed(win) )
        lastFocus = winFocus(win);

    servicesState = reason;                     /* save reason now !! */

    switch( reason )
    {
    case ServicesIdle:                          /* giving back control to last module*/
        winFocus(lastFocus);
        winShow(lastFocus);
        lastFocus = 0;
        return;                                 /* return from module */

    case ServicesOk:
        //TRACE_FUNCTION("Service OK");
        winShow(win);
        timStart(times);  /* start timer to go back in the submenu */
        break;

    case ServicesFailed:
        //TRACE_FUNCTION("Service Failed");
        winShow(win);
        timStart(times);  /* start timer to go back in the submenu */
        break;

    case ServicesError:
        //TRACE_FUNCTION("Service Error");
        winShow(win);
        timStart(times);  /* start timer to go back in the submenu */
        break;

    case ServicesExecCF:          /* all Call forwarding from menu */
    case ServicesActCF:             /* show "Please Wait" screen/animation */
    case ServicesDeactCF:
    case ServicesCheckCF:
    case ServicesActCW:
    case ServicesDeactCW:
    case ServicesCheckCW:
    case ServicesActCLIR:
    case ServicesDeactCLIR:
    case ServicesCheckCLIR:
        winShow(win);
        timStart(times);  /* start timer to go back in the submenu */
        break;

    case ServicesCheckCW_OK:
        //TRACE_FUNCTION(" ServicesCheckCW_OK");
        winShow(win);
        timStart(times);  /* start timer to go back in the submenu */
        break;

    case ServicesCheckCLI_OK:
        //TRACE_FUNCTION("ServicesCheckCLI_OK");
        winShow(win);
        timStart(times);
        break;

    case ServicesIMEI_OK:
        //TRACE_FUNCTION("ServicesIMEI_OK");
        winShow(win);
        timStart(times);
        break;

    case ServicesUSSDListMenu:
        /* display list of stored USSDs from NVM */
        //TRACE_FUNCTION("ServicesUSSDListMenu");
        servicesUSSDDisplayList();

        break;

    case ServicesUSSDOptions:
        //TRACE_FUNCTION("ServicesUSSDOptions");
        servicesShowUSSDMenu();
        break;


    case ServicesUSSD_REQ_OK:
        //TRACE_FUNCTION("ServicesUSSD_REQ_OK");
        strcpy((char*)USSDedtBuf, (char*)ss_cnf->ussd_info.ussd );
        USSDedtAttr.mode=edtCurNone;    /* Make field readonly */

        edtShow(ussdedt);

        winShow(win);
        timStart(times);
        break;

    case ServicesUSSD_CNF_OK:
        //TRACE_FUNCTION("ServicesUSSD_CNF_OK");
        strcpy((char*)USSDedtBuf, (char*)ss_cnf->ussd_info.ussd );
        USSDedtAttr.mode=edtCurNone;    /* Make field readonly */

        edtShow(ussdedt);

        winShow(win);
        timStart(times);
        break;

    case ServicesUSSDAlreadyFull:
        //TRACE_FUNCTION("ServicesUSSDAlreadyFull");  /* no break */
        winShow(win);
        timStart(times);
        break;

    case ServicesUSSDChange:
        {
            unsigned int x = 0;
            //TRACE_FUNCTION("ServicesUSSDChange");
            /* set up buffer with currently selected number */
            strcpy((char*)USSDedtBuf, (char*)mCurrentUSSDNumber);
            USSDedtAttr.size=MAX_STORED_USSD_LEN;    /* limited to 10 (?) chars ! */
            USSDedtAttr.mode=edtCurBar1;      /* Make field editable */
            for( x=0;x<strlen(mCurrentUSSDNumber);x++ )          /* if already something there, leave it */
            {
                /* move cursor to end of string */
                edtChar(ussdedt,ecRight);
            }
            editActivate(ussdedt,FALSE);        /* numeric mode */
            show = showUSSDEnter;
            winShow(win);
            timStart(times);
        }
        break;

    case ServicesUSSDChange_OK:             /*Change Name of stored USSD */
        {
            unsigned int x = 0;
            //TRACE_FUNCTION("ServicesUSSDChange_OK");
            /* set up buffer with currently selected number */
            strcpy((char*)USSDedtBuf, (char*)mCurrentUSSDName);
            USSDedtAttr.size=MAX_USSD_NAME_LEN;    /* limited to 12 (?) chars ! */
            USSDedtAttr.mode=edtCurBar1;      /* Make field editable */
            for( x=0;x<strlen(mCurrentUSSDName);x++ )          /* if already something there, leave it */
            {
                /* move cursor to end of string */
                edtChar(ussdedt,ecRight);
            }
            editActivate(ussdedt,FALSE);        /* numeric mode */
            show = showUSSDEnter;
            winShow(win);
            timStart(times);
        }
        break;

    case ServicesUSSDNew:
        //TRACE_FUNCTION("ServicesUSSDNew");  /* no break */
    case ServicesUSSDSendEdit:
        //TRACE_FUNCTION("ServicesUSSDSendEdit");  /* no break */
    case ServicesUSSDEnter:
        //TRACE_FUNCTION("ServicesUSSDEnter");
        USSDedtAttr.size=MAX_USSD_LEN-1;    /* limited to 160 chars ! */
        USSDedtAttr.mode=edtCurBar1;      /* Make field editable */
        if( strlen((char*)USSDedtBuf)==0 )          /* if already something there, leave it */
        {
            strcpy((char*)USSDedtBuf, "*#");
            /* move cursor to end of string */
            edtChar(ussdedt,ecRight);
            edtChar(ussdedt,ecRight);
        }
        editActivate(ussdedt,FALSE);        /* numeric mode */
        winShow(win);
        timStart(times);
        break;

    case ServicesUSSDEnter_Send:  /* have sent USSD, now display waiting animation */
    case ServicesUSSDSendEdit_Ok:
        edtHide(ussdedt);
        editDeactivate();
        winShow(win);
        timStart(times);
        break;


    case ServicesResShow:
        //TRACE_FUNCTION("ServicesResShow");
        winShow(win);
        timStart(times);
        break;

    case ServicesCB_OK:
        //TRACE_FUNCTION("ServicesCB_OK");
        lastFocus = winFocus(win);
        winShow(win);
        timStart(times);
        break;

    case ServicesCFU_OK:
        //TRACE_FUNCTION("ServicesCFUShow");
        lastFocus = winFocus(win);
        winShow(win);
        timStart(times);
        break;

    case ServicesDoCallDivert:
        servicesSendCallDivert(0);
        break;

    case PIN2_ABORT:
        //TRACE_FUNCTION("ServicesPin2_Abort");
        break;
    default:
        break;
    }
}




/*******************************************************************************

 $Function:    	showWait

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void showWait (T_MFW_HND win)
{

    T_DISPLAY_DATA   display_info;

    //TRACE_FUNCTION("showWait");

    dialog_info_init(&display_info);
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtRequesting;
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = SS_WAIT;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT;

    /*
     * Call Info Screen
     */

    ss_data.info_wait = info_dialog (win, &display_info);
}

/*******************************WUFEI APPEND**************************************
$Function:    	showCFanimation




*********************************************************************************/
static void showCFanimation (T_MFW_HND win)
{
    T_DISPLAY_DATA   display_info;

    ////TRACE_EVENT("showCFanimation ()");

    dialog_info_init(&display_info);
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = TxtSoftBack;  //hu binhao 2003-2-21
    display_info.TextId       = '\0';
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = SS_WAIT;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT|KEY_RIGHT;
    display_info.Identifier   = MMI_CALLFORWARD_DIALOG_NORMAL;
    display_info.WrapStrings = WRAP_STRING_2;
    ss_data.info_wait= info_dialog (win, &display_info);

    /*
     * Call Icon
     */
    //	mmi_dialogs_insert_fixmov_animation (ss_data.info_wait, 300 ,CALLFORWARDANIM,8); 
    mmi_dialogs_insert_fixmov_animation (ss_data.info_wait, 300 ,CALLFORWARDANIM); /*2003/12/4, wangyan modify*/
    //mmi_dialogs_insert_animation (ss_data.info_wait, 400 ,(MfwIcnAttr*)&CFanim_Attr,animCF);


}


/*******************************************************************************

 $Function:    	showOk

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void showOk (T_MFW_HND win)
{

    T_DISPLAY_DATA   display_info;


    dialog_info_init(&display_info);
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtDone;
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = ServicesOk;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT;

    /*
     * Call Info Screen
     */

    ss_data.info_win = info_dialog (ss_data.win, &display_info);

}

/*******************************************************************************

 $Function:    	showFailed

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void showFailed (T_MFW_HND win)
{

    T_DISPLAY_DATA   display_info;

    dialog_info_init(&display_info);//gdy add
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtFailed;
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = ServicesFailed;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT;
    display_info.iconindex    =REMIND_FAILURE;
    /*
     * Call Info Screen
     */
    ss_data.info_win = info_dialog (ss_data.win, &display_info);
}

/*******************************************************************************

 $Function:    	showError

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void showError (T_MFW_HND win, T_MFW_SS_ERROR ss_error)
{

    T_DISPLAY_DATA   display_info;

    //TRACE_FUNCTION("showError");

    dialog_info_init(&display_info);//gdy add
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtFailed;
    display_info.TextId2      = serviceGetError(ss_error);
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = ServicesError;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT;
    display_info.iconindex    =REMIND_FAILURE;
    /*
     * Call Info Screen
     */

    ss_data.info_win = info_dialog (ss_data.win, &display_info);

}


/*******************************************************************************

 $Function:    	showSSNotify

 $Description:	Show result from E_SS_NOTIFY being returned. Short ss-related
            notification window.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void showSSNotify (T_MFW_HND win, T_MFW_SS_NOTIFY  * ss_notify)
{

    T_DISPLAY_DATA   display_info;

    //TRACE_FUNCTION("++ showSSNotify");

    dialog_info_init(&display_info);//gdy add
    display_info.TextId       = 0;
    display_info.TextId2      = 0;

    switch( ss_notify->code )
    {
    case MFW_SS_MO_unconFORWARD:    /* CFU activated */
        iconsSetState(iconIdCallFor);

        /* Activate the CFU icon */
        /* break; */ /***** NO BREAK ******/
    case MFW_SS_MO_conFORWARD:      /* Conditional CF active */
        display_info.TextId       = TxtForward;
        display_info.TextId2      = TxtActivated;
        return;//zy add needn't show this dialog 12/02/2002
        break;
    case MFW_SS_MT_FORWARDED:           /* incoming call fowarded           */
        display_info.TextId       = TxtIncomingCall;
        display_info.TextId2      = TxtForwarded;
        break;

    case MFW_SS_MO_FORWARDED:       /* our call is being forwarded */
        display_info.TextId       = TxtSoftCall;
        display_info.TextId2      = TxtForwarded;

        break;

    case MFW_SS_MO_WAITING:     /* outgoing call is waiting signal received */
        display_info.TextId       = TxtSoftCall;
        display_info.TextId2      = TxtWaiting;
        break;

    case MFW_SS_MO_moBARRED:  /* outgoing calls barred */
        display_info.TextId       = TxtOutgoingCalls;
        display_info.TextId2      = TxtBarred;
        break;

    case MFW_SS_MO_mtBARRED:  /* incoming calls barred */
        display_info.TextId       = TxtIncomingCall;
        display_info.TextId2      = TxtBarred;
        break;

    case MFW_SS_MO_DEFLECTED:  /* incoming call diverted  */
        display_info.TextId       = TxtIncomingCall;
        display_info.TextId2      = TxtCallDivert;
        break;

    default:
        break;
    }

    if( display_info.TextId NEQ 0 )
    {

        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = '\0';
        display_info.TextString   = '\0';
        display_info.TextString2   = '\0';
        display_info.Time         = THREE_SECS;
        display_info.Identifier   = E_SS_NOTIFY;
        display_info.Callback     = (T_VOID_FUNC)services_info_cb;
        display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

        /*
         * Call Info Screen
         */

        ss_data.info_win = info_dialog (ss_data.win, &display_info);
    }
}

/*******************************************************************************

 $Function:    	srv_display_status

 $Description:	Indicate a sensefull response to the user if only the .
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void srv_display_status (UBYTE ss_status)
{
    T_DISPLAY_DATA   display_info;

    //TRACE_FUNCTION("srv_cw_display_status");
    //TraceInt((int) ss_status);
    dialog_info_init(&display_info);//gdy add
    //GW Swapped text strings over
    if( ss_status & SS_STAT_ACTIVE||ss_status== 0 )
    {
        FlashDCTbData.callwaitflag=1;
        flash_DCTbwrite();//wufie 0827
        display_info.TextId2      = TxtActivated;
    }
    else
    {
        FlashDCTbData.callwaitflag=0;
        flash_DCTbwrite();//wufie 0827
        display_info.TextId2      = TxtDeActivated;
    }
    display_info.iconindex=REMIND_COMPLETE;  //hu binhao 2003-1-13
    display_info.TextId    = 0;
    //display_info.LeftSoftKey  = TxtSoftOK;
    display_info.LeftSoftKey  = '\0';  //hu bihhao 2003-1-14
    display_info.RightSoftKey = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = E_SS_CB_CNF;  // can be used also for CF and CW
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

    /*
     * Call Info Screen
     */

    ss_data.info_win = info_dialog (ss_data.win, &display_info);
}

/*******************************************************************************

 $Function:    	ysrv_empty_list_result

 $Description:	Indicate a sensefull response to the user if an
            activation / deactivation or interrogation leads to an
            empty list.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void srv_empty_list_result (UBYTE ss_category)
{
    T_DISPLAY_DATA   display_info;

    //TRACE_FUNCTION("srv_empty_list_result");

    dialog_info_init(&display_info);//gdy add


    switch( ss_category )
    {
    case SS_ACTIVATION:
    case SS_REGISTRATION:
        //TRACE_FUNCTION ("ACTIVATED !");
        FlashDCTbData.callwaitflag=1;
        flash_DCTbwrite();//wufie 0827
        display_info.TextId      = TxtActivated;
        break;
    case SS_INTERROGATION:
    case SS_ERASURE:
    case SS_DEACTIVATION:
        //TRACE_FUNCTION ("DEACTIVATED !");
        FlashDCTbData.callwaitflag=0;
        flash_DCTbwrite();//wufie 0827
        display_info.TextId      = TxtDeActivated;
        break;
    default:
        display_info.TextId      = 0;
        break;
    }

    if( display_info.TextId NEQ 0 )
    {
        display_info.iconindex=REMIND_COMPLETE; //hu binhao 2003-2-19
        display_info.TextId      = 0;               
        display_info.TextId2      = TxtDeActivated;   //hu binhao 2003-2-19
        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = '\0';
        display_info.TextString   = '\0';
        display_info.TextString2   = '\0';
        display_info.Time         = FOREVER;
        display_info.Identifier   = E_SS_CB_CNF;  // can be used also for CF and CW
        display_info.Callback     = (T_VOID_FUNC)services_info_cb;
        display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

        /*
         * Call Info Screen
         */

        ss_data.info_win = info_dialog (ss_data.win, &display_info);
    }
}



/*******************************************************************************

 $Function:    	srv_empty_list_result_new

 $Description:
            Copy from the new release of TI, and change the function name from
            srv_empty_list_result to srv_empty_list_result
            
            Indicate a sensible response to the user if an
            activation / deactivation or interrogation leads to an
            empty list.
            
 $Returns:		

 $Arguments:	

 $Author:  Glowing, 2003/11/23
 
*******************************************************************************/

static void srv_empty_list_result_new (UBYTE ss_category, USHORT event, UBYTE ss_status) /* Marcus: Issue 1214: 22/10/2002 */
{
    T_DISPLAY_DATA   display_info;
    USHORT TxtId1 = TxtNull;  
    //TRACE_FUNCTION("srv_empty_list_result_new");

    dialog_info_init(&display_info);// 2003/11/06, glowing add 

#if defined (WIN32)
    {
        char buf[40];
        sprintf (buf, "SS CAT %d", ss_category);
        TRACE_FUNCTION (buf);
    }
#endif

    ////TRACE_EVENT_P3("ss_category %d, event %d, ss_status %d", ss_category, event, ss_status);

    //  MMI_TRACE_EVENT("glowing: ss_category %d, event %d, ss_status %d", ss_category, event, ss_status);

    switch( ss_category )
    {
    case SS_ACTIVATION:
    case SS_REGISTRATION:
        //     TRACE_FUNCTION ("ACTIVATED !");
        TxtId1      = TxtActivated;
        break;
        /* Marcus: Issue 1214: 22/10/2002: Start */
    case SS_INTERROGATION:
        //	MMI_TRACE_EVENT("glowing: srv_empty_list_result_new -- SS_INTERROGATION ");

        if( (event == E_SS_CW_CNF) || (event == E_SS_CF_CNF) ) // Marcus: Issue 1651: 30/01/2003
        {
            if( ss_status & SS_STAT_ACTIVE )
            {
                //         TRACE_EVENT ("INTERROGATION:ACTIVATED !");
                //		MMI_TRACE_EVENT("glowing: srv_empty_list_result_new -- 1");
                TxtId1      = TxtActivated; //SPR#1356 - DS - Changed display_info.TextId to TxtId1.
            }
            /* Marcus: Issue 1651: 30/01/2003: Start */
            else if( ss_status & SS_STAT_PROVISIONED )
            {
                //       TRACE_EVENT ("INTERROGATION:PROVISIONED !");
                //		MMI_TRACE_EVENT("glowing: srv_empty_list_result_new -- 2");
                //TxtId1      = TxtProvisioned; //SPR#1356 - DS - Changed display_info.TextId to TxtId1.
                TxtId1      = TxtDeActivated; //SPR#1356 - DS - Changed display_info.TextId to TxtId1.
            }
            /* Marcus: Issue 1651: 30/01/2003: End */
            else
            {
                /* 2003/11/06, glowing modify, if the user did not apply the call waiting service,
                 * the INTERROGATION action should return invalid
                 */
                if( event== E_SS_CW_CNF )
                {
                    //				MMI_TRACE_EVENT("glowing: srv_empty_list_result_new -- 3");
                    TxtId1 = TxtInvalidService;
                }
                else
                {
                    //				MMI_TRACE_EVENT("glowing: srv_empty_list_result_new -- 4");
                    //	            TRACE_EVENT ("INTERROGATION:DEACTIVATED !");
                    TxtId1      = TxtDeActivated; //SPR#1356 - DS - Changed display_info.TextId to TxtId1.
                }
            }
        }
        else
        {
            //        TRACE_EVENT ("DEACTIVATED !");
            TxtId1      = TxtDeActivated; //SPR#1356 - DS - Changed display_info.TextId to TxtId1.
        }
        break;
        /* Marcus: Issue 1214: 22/10/2002: End */
    case SS_ERASURE:
    case SS_DEACTIVATION:
        //    TRACE_FUNCTION ("DEACTIVATED !");
        TxtId1      = TxtDeActivated;
        break;
    default:
        TxtId1      = TxtNull;
        break;
    }



    if( TxtId1 != TxtNull )
    {

        display_info.iconindex=REMIND_COMPLETE; //hu binhao 2003-2-19
        //display_info.TextId      = 0;               
        display_info.TextId      = TxtId1;               
        // display_info.TextId2      = TxtDeActivated;   //hu binhao 2003-2-19
        display_info.TextId2      = 0;   //hu binhao 2003-2-19

        //display_info.LeftSoftKey  = TxtSoftOK;
        display_info.LeftSoftKey  = '\0';
        display_info.RightSoftKey = '\0';
        display_info.TextString   = '\0';
        display_info.TextString2   = '\0';
        display_info.Time         = FOREVER;
        display_info.Identifier   = E_SS_CB_CNF;  // can be used also for CF and CW
        display_info.Callback     = (T_VOID_FUNC)services_info_cb;
        display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;


        /*
         * Call Info Screen
         */

        ss_data.info_win = info_dialog (ss_data.win, &display_info);
    }
}


/*******************************************************************************

 $Function:    showCWState

 $Description:	display CW state
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void showCWStatus (T_MFW_HND win , T_ss * data)

{
    // T_dialog_ext_info      display_info ;
    T_DISPLAY_DATA  display_info;  //hu binhao 2002-1-14
    T_ss_feature_cw_data * pFeature;

    // TRACE_FUNCTION("showCWStatus");
    pFeature = &data->mfw_ss_cw->ss[data->current_feature];

    dialog_info_init(&display_info);  //hu binhao 2003-1-14
    if( data->mfw_ss_cw->status==TxtActivated )
    {
        display_info.TextId2 =TxtActivated;
        FlashDCTbData.callwaitflag=1;
        flash_DCTbwrite();//wufie 0827
    }
    else if( data->mfw_ss_cw->status==TxtDeActivated )
    {
        display_info.TextId2 =TxtDeActivated;
        FlashDCTbData.callwaitflag=0;
        flash_DCTbwrite();//wufie 0827
    }
    //display_info.LeftSoftKey  = TxtSoftOK;
    display_info.LeftSoftKey  = '\0';
    display_info.RightSoftKey = '\0';
    //MC got rid of dodgy pointer arithmetic

    display_info.iconindex=REMIND_COMPLETE; //hu binhao 2002-1-14

    //display_info.TextId1      = pFeature->service;
    display_info.TextId      = 0; //SPR#1038 - DS - Do not display service text Id.
    //display_info.TextId2      = data->mfw_ss_cw->status;
    //display_info.TextString4  = NULL;
    display_info.Time         = FOREVER;
    //display_info.Identifier   = E_SS_CW_CNF;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT | KEY_MNUUP | KEY_MNUDOWN;

    /*
     * Call Info Screen
     */

    //ss_data.info_win = dialog_ext_info_dialog(win, &display_info);
    ss_data.info_win = info_dialog(win, &display_info);

    if( ss_data.info_win EQ NULL )
    {
        //    TRACE_FUNCTION("NOT ENOUGH RESOURCES TO CREATE EXT INFO DIALOG");
    }
}

/*******************************************************************************

 $Function:    	showCLIStatus 

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void  showCLIStatus(T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf)
{

    T_DISPLAY_DATA   display_info;

    //	TRACE_FUNCTION("showCLIStatus()");

    dialog_info_init(&display_info);//gdy add
    if( ss_cnf->cli_cnf.ss_status == SS_STAT_UNKNOWN )
    {
        // Unknown status. By defaut say that the id is sent
        //FlashDCTbData.hideIDflag=1;
        //flash_DCTbwrite(); //wufei add 0827
        display_info.TextId2 = TxtActivated;
        //MmiTrace("showCLIStatus hbh1");
    }
    else if( ss_cnf->cli_cnf.ss_status & SS_STAT_ACTIVE )
    {
        switch( ss_cnf->cli_cnf.ss_clir_option )
        {
        // By defaut the caller id is not sent
        case MFW_CL_TEMP_DEF_REST:
            switch( CFAction )
            {
            // ActivateCLIR, so deactivate the sending of caller id
            case CFActivate:
                // By defaut the caller id is not sent
                //FlashDCTbData.hideIDflag=1;
                //flash_DCTbwrite(); //wufei add 0827
                display_info.TextId2 = TxtActivated;
                //MmiTrace("showCLIStatus hbh2");
                // No CLIR suppress or invoke
                cm_mo_prefix(0x04);
                break;                      
                // Deactivate CLIR, so activate the sending of caller id
            case CFDeactivate:
                // By defaut the caller id is not sent
                //FlashDCTbData.hideIDflag=0;
                //flash_DCTbwrite(); //wufei add 0827
                display_info.TextId2 = TxtDeActivated;
                //MmiTrace("showCLIStatus hbh3");
                // CLIR suppress needed
                cm_mo_prefix(0x08);
                break;
            case CFCheck:
            default:
                // Check if CLIR suppress is activated: caller id sent
                if( (cm_mo_prefix(0) & 0x0c) == 0x08 )
                {
                    display_info.TextId2 = TxtDeActivated;
                    //MmiTrace("showCLIStatus hbh4");
                }
                // By defaut the caller id is not sent
                else
                {
                    display_info.TextId2 = TxtActivated;
                    //MmiTrace("showCLIStatus hbh5");
                }
                break;
            }
            break;
            // By defaut the caller id is sent
        case MFW_CL_TEMP_DEF_ALLOWED:
            switch( CFAction )
            {
            // ActivateCLIR, so deactivate the sending of caller id
            case CFActivate:
                // By defaut the caller id is sent
                //FlashDCTbData.hideIDflag=1;
                //flash_DCTbwrite(); //wufei add 0827
                display_info.TextId2 =TxtActivated;
                //MmiTrace("showCLIStatus hbh6");
                // CLIR invoke needed
                cm_mo_prefix(0x0c);
                break;
                // Deactivate CLIR, so activate the sending of caller id
            case CFDeactivate:
                // By defaut the caller id is sent
                //FlashDCTbData.hideIDflag=0;
                //flash_DCTbwrite(); //wufei add 0827
                display_info.TextId2 = TxtDeActivated;
                // No CLIR suppress or invoke
                //MmiTrace("showCLIStatus hbh7");

                cm_mo_prefix(0x04);
                break;
            case CFCheck:
            default:
                // Check if CLIR invoke is activated: caller id not sent
                if( (cm_mo_prefix(0) & 0x0c) == 0x0c )
                {
                    display_info.TextId2 = TxtActivated;
                    //MmiTrace("showCLIStatus hbh8");

                }
                // By defaut the caller id is sent
                else
                {
                    display_info.TextId2 = TxtDeActivated;
                    //MmiTrace("showCLIStatus hbh9");

                }
            }
            break;
        case MFW_CL_PERM:
            // No CLIR suppress or invoke
            cm_mo_prefix(0x04);
            // No break
        case MFW_CL_UNKNOWN:
        default:
            // The CLIR is active and permanent the caller id is not sent
            display_info.TextId2 = TxtActivated;
            //MmiTrace("showCLIStatus hbh10");
            break;
        }           
    }
    // CLIR service is not activated: The caller id is sent
    else
    {
        //display_info.TextId2 = TxtDeActivated;
        // "open hideID" and "close hide ID" come to here 
        if( hideflag )
            display_info.TextId2 = TxtActivated;
        else
            display_info.TextId2 = TxtDeActivated;  //hu binhao 11-28,becase it have successed
        //MmiTrace("showCLIStatus hbh11");
        //	MmiTraceInt(ss_cnf->cli_cnf.ss_status);   //the value always is 0 whether open or close
        //MmiTrace("hbh11 end");
        // No CLIR suppress or invoke
        cm_mo_prefix(0x04);
    }
    display_info.iconindex=REMIND_COMPLETE;  //hu binhao 2002-1-14
    //display_info.LeftSoftKey  = TxtSoftOK;
    display_info.LeftSoftKey  = '\0';  //hu binhao 2003-1-14
    display_info.RightSoftKey = '\0';
    // display_info.TextId       = serviceGetType(ss_cnf->cli_cnf.ss_code);
    display_info.TextId       =0; //hu binhao 2003-1-14
    display_info.TextString   = NULL;
    display_info.TextString2  = NULL;
    display_info.Time         = FOREVER;
    display_info.Identifier   = ServicesCheckCLI_OK;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

    // Call Info Screen
    ss_data.info_win = info_dialog (ss_data.win, &display_info);

}



/*******************************************************************************

 $Function:    	showIMEI2 

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void showIMEI2 (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf)
{
    T_DISPLAY_DATA   display_info;

#define IMEI_LEN 15         /* IMEI + check digit = 15, IMEI + SW version = 16 */
    char imei_array[IMEI_LEN+1] = {'\0'};
    char * pIMEI = imei_array;
    memcpy(imei_array, ss_cnf->imei_info.imei_number, sizeof(ss_cnf->imei_info.imei_number));

    dialog_info_init(&display_info);//gdy add
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtIMEI;
    display_info.TextId2      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = pIMEI;
    display_info.Time         = FOREVER;
    display_info.Identifier   = ServicesIMEI_OK;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

    /*
     * Call Info Screen
     */

    ss_data.info_win = info_dialog (ss_data.win, &display_info);

}

/*******************************************************************************

 $Function:    	showUSSDInfo 

 $Description:	this is used for both USSD types (confirm and request).
                The USSD request is keep going after "showUSSDInfo"
                function and open the editor to enter the string.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static void showUSSDInfo (T_MFW_HND win, USHORT ident, T_MFW_SS_PARA  * ss_cnf, USHORT sk1, USHORT sk2)
{
    T_EDITOR_DATA   editor_data;

    //	TRACE_EVENT("showUSSDInfo");

    editor_data.editor_attr.win.px   = 6;
    editor_data.editor_attr.win.py   = 18;
    editor_data.editor_attr.win.sx   = 80;
    editor_data.editor_attr.win.sy   = 28;
    editor_data.editor_attr.fgColor  = 0xffffff;
    editor_data.editor_attr.font     = 0;
    editor_data.editor_attr.mode    = edtCurNone;
    editor_data.editor_attr.controls   = 0;

    editor_data.hide                = FALSE;            
    editor_data.editor_attr.text    = (char*)ss_cnf->ussd_info.ussd;
    editor_data.editor_attr.size    = MAX_USSD_LEN;

    if( ident EQ ServicesUSSD_REQ_OK )
    {
        editor_data.LeftSoftKey         = TxtSoftOK;
        editor_data.RightSoftKey        = TxtSoftBack;
    }
    else
    {
        editor_data.LeftSoftKey         = TxtNull;
        editor_data.RightSoftKey        = TxtSoftBack;
    }

    editor_data.AlternateLeftSoftKey     = TxtNull;
    editor_data.TextString          = TxtNull;
    editor_data.TextId              = TxtSsMsg;
    editor_data.Identifier          = ident;
    editor_data.mode                = READ_ONLY_MODE;
    editor_data.timeout             = FOREVER;
    editor_data.min_enter           = 1;
    editor_data.Callback            = (T_EDIT_CB)services_info_cb;
    editor_data.destroyEditor       = TRUE;

    /* keep the dcs; need it later for sending */
    ss_data.dcs = ss_cnf->ussd_info.dcs;

    /* create the dialog handler */
    editor_start(ss_data.win, &editor_data);  /* start the editor */ 

}


/*******************************************************************************

 $Function:    	 showUSSDREQ

 $Description:	show USSD info from Request, and then allow user to enter a response.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void showUSSDREQ (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf)
{
    //   TRACE_FUNCTION("showUSSDREQ");

    showUSSDInfo(win, ServicesUSSD_REQ_OK, ss_cnf, TxtSoftOK, TxtSoftBack);

}



/*******************************************************************************

 $Function:    	 showUSSDCNF

 $Description:	display USSD message
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void showUSSDCNF (T_MFW_HND win, T_MFW_SS_PARA  * ss_cnf)
{
    //    TRACE_EVENT("showUSSDCNF");

    showUSSDInfo(win, ServicesUSSD_CNF_OK, ss_cnf, TxtNull, TxtSoftBack);

}


/*******************************************************************************

 $Function:    	 showUSSDFull

 $Description:	Display error full message
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void showUSSDFull (T_MFW_HND win)
{


    T_DISPLAY_DATA   display_info;

    //  TRACE_FUNCTION("showUSSDFull");

    dialog_info_init(&display_info);//gdy add
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = '\0';
    display_info.TextId       = TxtList;
    display_info.TextId2      = TxtFull;
    display_info.TextString   = '\0';
    display_info.TextString2  = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = ServicesUSSDAlreadyFull;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT;

    /*
     * Call Info Screen
     */

    ss_data.info_win = info_dialog (ss_data.win, &display_info);

}


/*******************************************************************************

 $Function:    	 showUSSDEnter

 $Description:	Enter USSD message
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void showUSSDEnter (void)
{
    //    TRACE_FUNCTION("showUSSDEnter");
    ussd_input_create(ss_data.win);
}



/*******************************************************************************

 $Function:    	 servicesShowUSSDMenu

 $Description:	display ussd menu window
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/




static void servicesShowUSSDMenu(void)
{

    MfwMnu * mnu;
    //   TRACE_FUNCTION("servicesShowUSSDMenu");
    mnu = (MfwMnu *)mfwControl(ussdMenu);
    mnuUpdate (mnu);
    mnuShow(ussdMenu);
    displaySoftKeys(TxtSoftSelect,TxtSoftBack);
}

/*******************************************************************************

 $Function:    	 sendUSSD

 $Description:	Send USSD message
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void sendUSSD (T_MFW_SS_PARA *ussd_senddata)
{

    unsigned int tLen = ussd_senddata->ussd_info.len;

    ss_cnf = ussd_senddata;

    if( ss_send_ussd( (T_MFW_SS_USSD *) ss_cnf ) == MFW_SS_FAIL )
    {
        /*   ussd data is wrong */
        showFailed( ss_data.win );
    }
    else
        if( servicesState == ServicesUSSDSendEdit )
        servicesExec(ServicesUSSDSendEdit_Ok, 0);
    else
        servicesExec(ServicesUSSDEnter_Send, 0);
}


/*******************************************************************************

 $Function:    	 showCFStatus

 $Description:	display CFU state
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void showCFStatus (T_MFW_HND win , T_ss * data)
{
    T_dialog_ext_info      display_info ;
    T_ss_feature_cf_data * pFeature;

    //  TRACE_FUNCTION("showCFStatus");

    switch( CFAction )
    {
    case CFActivate:


    case CFDeactivate:
        {
            T_DISPLAY_DATA display_info_CF;

            //			TRACE_FUNCTION ("services_info_screen()");
            dialog_info_init(&display_info_CF);//gdy add

            display_info_CF.iconindex=REMIND_COMPLETE;
            if( CFAction==CFActivate )
            {
                //hubinhao 2003-2-11
                //if already in CFU,when Activate CFNRy or CFB or CFNRy,the dialog show "failed"
                if( (FlashDCTbData.CFFlag&SetCFU)&&((CFType==CFNoReach)||(CFType==CFBusy)||(CFType==CFNoReply)) )
                {
                    display_info_CF.TextId2=TxtFailed;
                }
                else
                {
                    display_info_CF.TextId2=TxtActivate;
                }

            }
            else
            {
                display_info_CF.TextId2=TxtDeactivate;

            }


            display_info_CF.Time=FOREVER;

            display_info_CF.TextString   = '\0'; 
            display_info_CF.TextString2  = '\0';
            display_info_CF.LeftSoftKey  = TxtNull;
            display_info_CF.RightSoftKey = TxtNull;
            // display_info.Time         = 1000;
            display_info_CF.KeyEvents    = KEY_CLEAR;
            display_info_CF.TextId       = NULL;
            display_info_CF.Identifier   = NULL;
            display_info_CF.Callback     = (T_VOID_FUNC)NULL;
            info_dialog (win, &display_info_CF); 
        }

        break;
    case CFCheck:
        display_info.LeftSoftKey  = TxtSoftOK;
        display_info.RightSoftKey = 0;
        //MC got rid of dodgy pointer arithmetic
        pFeature = &data->mfw_ss_cf->ss[data->current_feature];

        // display_info.TextId1      = pFeature->service;

        if( pFeature->service==TxtVoice )    //hu binhao 2002-1-14
        {
            display_info.TextId1=TxtVoiceCallDivert;
            //		  		TRACE_FUNCTION("showCFStatus_TxtVoiceCallDivert");
        }
        else
        {
            display_info.TextId1      = pFeature->service;
            //		  	TRACE_FUNCTION("showCFStatus_hubh_status");
        }
        display_info.TextId2      = pFeature->status;

        //Only show the number when activating call diverts
        if( pFeature->status == TxtActivated )
        {
            //display_info.TextString4  = pFeature->forwarded_to_number;
            /* 2004/05/08 sunsj modify */
            if( pFeature->forwarded_to_number[0] == 0x38 && pFeature->forwarded_to_number[1] == 0x36 )
            {
                display_info.TextString4 = &pFeature->forwarded_to_number[2];
            }
            else
            {
                display_info.TextString4  = pFeature->forwarded_to_number;
            }
            display_info.TextId2 = 0;
            // 2003-4-8   consider change sim card or chang handset. begin
            {
                unsigned char Tempflag;
                Tempflag=0;
                switch( CFType )
                {
                case CFNoReach:
                    if( (FlashDCTbData.CFFlag&SetCFNRc)==0 )
                    {
                        FlashDCTbData.CFFlag |=SetCFNRc;
                        Tempflag=1;
                    }
                    break;
                case CFBusy:
                    if( (FlashDCTbData.CFFlag&SetCFB)==0 )
                    {
                        FlashDCTbData.CFFlag |=SetCFB;
                        Tempflag=1;
                    }
                    break;
                case CFNoReply:
                    if( (FlashDCTbData.CFFlag&SetCFNRy)==0 )
                    {

                        FlashDCTbData.CFFlag |=SetCFNRy;
                        Tempflag=1;
                    }
                    break;
                case CFUnconditional:
                    if( (FlashDCTbData.CFFlag&SetCFU)==0 )
                    {
                        FlashDCTbData.CFFlag |=SetCFU;
                        Tempflag=1;
                    }
                    break;
                }
                if( Tempflag!=0 )
                {
                    flash_DCTbwrite();  
                }
                iconsSetState(iconIdCallFor);  
            }
            //2003-4-8   consider change sim card or chang handset. end
        }
        else //Don't show number
        {
            display_info.TextString4  = "";
        }
        /* 2004/05/08 sunsj modify */
        display_info.Time         = THREE_SECS;
        display_info.Identifier   = E_SS_CF_CNF;
        display_info.Callback     = (T_VOID_FUNC)services_info_cb;
        display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT|KEY_HUP;
        /*
 * Call Info Screen
 */

        ss_data.info_win = dialog_ext_info_dialog(win, &display_info);

        if( ss_data.info_win EQ NULL )
        {
            //		    TRACE_FUNCTION("NOT ENOUGH RESOURCES TO CREATE EXT INFO DIALOG");
        }


        break;
    default:
        break;
    }



}


/*******************************************************************************

 $Function:    	 showCBStatus

 $Description:	display CB state
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static void showCBStatus (T_MFW_HND win , T_ss * data)
{
    T_dialog_ext_info      display_info ;
    T_ss_feature_cb_data * pFeature;

    // TRACE_FUNCTION("showCBStatus");

    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = 0;
    //MC got rid of dodgy pointer arithmetic
    pFeature = &data->mfw_ss_cb->ss[data->current_feature];

    //display_info.TextId1      = pFeature->service;
    display_info.TextId1      = 0; //SPR#1038 - DS - Do not display service text Id.
    display_info.TextId2      = pFeature->status;
    display_info.TextString4  = NULL;
    display_info.Time         = FOREVER;
    display_info.Identifier   = E_SS_CB_CNF;
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_CLEAR | KEY_LEFT | KEY_MNUUP | KEY_MNUDOWN;

    /*
     * Call Info Screen
     */

    ss_data.info_win = dialog_ext_info_dialog(win, &display_info);

    if( ss_data.info_win EQ NULL )
    {
        //  TRACE_FUNCTION("NOT ENOUGH RESOURCES TO CREATE EXT INFO DIALOG");
    }
}

/*******************************************************************************

 $Function:    	 getCFAction

 $Description:	To return a string corresponding to call forwarding action.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void getCFAction(char * pSSstring)
{ 
    switch( CFAction )
    {
    case CFActivate:
        strcpy(pSSstring, "**");
        break;
    case CFDeactivate:
        strcpy(pSSstring, "##");
        break;
    case CFCheck:
        strcpy(pSSstring, "*#");
        break;
    default:
        break;
    }

}


/*******************************************************************************

 $Function:    	 getCFType

 $Description:	To return a string corresponding to call forwarding type:
            CFU, CFNRy, CFU, etc.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void getCFType(char* pSSstring)
{
    switch( CFType )
    {
    case CFBusy:
        strcat(pSSstring, "67*");
        break;
    case CFNoReply:
        strcat(pSSstring, "61*");
        break;
    case CFNoReach:
        strcat(pSSstring, "62*");
        break;
    case CFUnconditional:
        strcat(pSSstring, "21*");
        break;
    case CFAllConditional:
        strcat(pSSstring, "004*");
        break;
    case CFAllCalls:
        strcat(pSSstring, "002*");
        break;
    default:
        break;
    }
}




/*******************************************************************************

 $Function:    	 getCFNumber

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void getCFNumber(char * pSSstring)
{

    strcat(pSSstring, ss_data.edt_buf_number); 
}



/*******************************************************************************

 $Function:    	 getCFService

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void getCFService(char * pSSstring)
{

    switch( CFService )
    {
    case CFVoice:
        strcat(pSSstring, "*11"); //SPR#0776 - DS -changed from 10 to 11
        break;
        /*MC SPR 742, handle line 2, auxiliary telephony*/
    case CFAuxVoice:
        strcat(pSSstring, "*89"); 
        break;
    case CFFax:
        strcat(pSSstring, "*13");
        break;
    case CFData:
        strcat(pSSstring, "*20");
        break;
    default:
        break;
    }
}
/********************************WUFEI APPEND*********************************

 $Function:    	 getNoAnswerTime

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void getNoAnswerTime(char * pSSstring)
{
    //U8 time,len,i;
    U8 time=0,len; 
    char timestr[4];
    strcpy(timestr,ss_data.edt_buf_NoAnswerTime);


    len=strlen(timestr);
    if( len==1 )
        time=(timestr[0]-48);
    if( len==2 )
        time=(timestr[0]-48)*10+(timestr[1]-48);

    if( time<5 )
    {
        strcpy(timestr,"5");
    }
    if( time>30 )
    {
        strcpy(timestr,"30");
    }

    strcat(pSSstring,timestr);

}

/*******************************************************************************

 $Function:    	 servicesSendCallDivert

 $Description:	Send out Call Divert String to MFW according to static variables.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int servicesSendCallDivert( char * divert_number)
{   
    char SS_string[60] = {'\0'};
    //UBYTE n;
    UBYTE i;
    T_MFW_SS_RETURN res;
    /* build up SS string according to menu selections */

    //	TRACE_EVENT_P1("glowing: servicesSendCallDivert -- enter divert_number=%s",divert_number);
    getCFAction(SS_string);
    getCFType(SS_string);
    if( divert_number )
        strcat(SS_string, divert_number);
    else
        getCFNumber(SS_string);

    getCFService(SS_string);
    if( CFType==CFNoReply )//wufei add
    {
        strcat(SS_string,"*");
        //strcat(SS_string,ss_data.edt_buf_NoAnswerTime);
        getNoAnswerTime(SS_string);
    }
    strcat(SS_string, "#");

    //TRACE_EVENT(SS_string);
    //   	TRACE_EVENT_P1("glowing: servicesSendCallDivert -- SS_string=%s",SS_string);
    res=ss_execute_transaction((UBYTE*)SS_string, 0);

    if( res == MFW_SS_FAIL OR res==MFW_SS_UNKNOWN )
    {
        //	   	TRACE_EVENT("glowing: servicesSendCallDivert -- before service_info_screen");
        services_info_screen(ss_data.win,TxtFailed);
        //	   	TRACE_EVENT("glowing: servicesSendCallDivert -- after service_info_screen");
    }
    else
    {
        /* hubh 2003-2-10 commented
        if (CphsPresent())
            {	//save the status to SIM
                //if (CFAction == CFActivate && CFType == CFUnconditional || CFType == CFAllCalls)
                if (CFAction == CFActivate ) // hu binhao 2002-12-20
                    switch (CFService)
                    {
                        case (CFVoice):
                        case CFAuxVoice:
                            if (GetAlsLine() == MFW_SERV_LINE1)
                                cphs_set_divert_status(MFW_CFLAG_SET,0,0,0);
                            else
                                cphs_set_divert_status(0,MFW_CFLAG_SET,0,0);
                        break;
                        case (CFData): 	cphs_set_divert_status(0,0,0,MFW_CFLAG_SET);break;
                        case (CFFax):	cphs_set_divert_status(0,0,MFW_CFLAG_SET,0);break;
                        case (CFAll):	if (GetAlsLine() == MFW_SERV_LINE1)
                                cphs_set_divert_status(MFW_CFLAG_SET,0,MFW_CFLAG_SET,MFW_CFLAG_SET);
                            else
                                cphs_set_divert_status(0,MFW_CFLAG_SET,MFW_CFLAG_SET,MFW_CFLAG_SET);
                        break;
                    }
                //if (CFAction == CFDeactivate && CFType == CFUnconditional || CFType == CFAllCalls)
                if (CFAction == CFDeactivate)  // hu binhao 2002-12-20
                
                    switch (CFService)
                    {
                        case (CFVoice):	
                        case CFAuxVoice:
                            MmiTraceInt("hubinhao CFAction");
                            MmiTraceInt(CFAction);

                            if (GetAlsLine() == MFW_SERV_LINE1)
                                {
                                cphs_set_divert_status(MFW_CFLAG_NOTSet,0,0,0);
                                MmiTrace("hubinhao MFW_SERV_LINE1");
                                }
                            else
                                {
                                cphs_set_divert_status(0,MFW_CFLAG_NOTSet,0,0);
                                MmiTrace("hubinhao MFW_SERV_LINE2");
                                }

                        break;
                        case (CFData): 	cphs_set_divert_status(0,0,0,MFW_CFLAG_NOTSet);break;
                        case (CFFax):	cphs_set_divert_status(0,0,MFW_CFLAG_NOTSet,0);break;
                        case (CFAll):						if (GetAlsLine() == MFW_SERV_LINE1)
                                cphs_set_divert_status(MFW_CFLAG_NOTSet,0,MFW_CFLAG_NOTSet,MFW_CFLAG_NOTSet);
                            else
                                cphs_set_divert_status(0,MFW_CFLAG_NOTSet,MFW_CFLAG_NOTSet,MFW_CFLAG_NOTSet);
                        break;
                    }
                }
        else
            {
                if (CFAction == CFDeactivate) 
                    {
                        FlashDCTbData.CFFlag=0; 
                        flash_DCTbwrite();
                    }
                if (CFAction == CFActivate) 
                    {
                        FlashDCTbData.CFFlag=1; 
                        flash_DCTbwrite();
                    }
                    
            }
        */  

    }

    //	TRACE_EVENT("glowing: servicesSendCallDivert -- leave");
    return 0;
}



/*******************************************************************************

 $Function:    	 servicesActivateCLIR

 $Description:	activate CLIR
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

int servicesActivateCLIR(MfwMnu* m, MfwMnuItem* i) {
    char actstr[8];

    CFAction = CFActivate;
    strcpy(actstr, "#31#");  
    //strcpy(actstr, "#31");  
    hideflag=1;  //hu binhao 2002-11-28

    if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
    {
        //MmiTrace("hbhhideopen 1");
        showFailed( ss_data.win );
    }
    else
    {
        strcpy(actstr, "*#31#");   
        //MmiTrace("hbhhideopen 2");

        if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
        {
            showFailed( ss_data.win );
            //	MmiTrace("hbhhideopen 3");
            return 0;
        }
        //MmiTrace("hbhhideopen 4");
        //change succedd ,must write to flash momery
        FlashDCTbData.hideIDflag=1;   //hu binhao 2002-11-28
        flash_DCTbwrite();           //hu binhao 2002-11-28
    }


    return 0;
}
/*******************************************************************************

 $Function:    	 servicesSuppressCLIR

 $Description:	suppress CLIR
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int servicesDeactivateCLIR(MfwMnu* m, MfwMnuItem* i) {
    char actstr[8];

    CFAction = CFDeactivate;
    strcpy(actstr, "*31#");    
    //strcpy(actstr, "*31");    
    hideflag=0;  //hu binhao 2002-11-28

    if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
    {
        showFailed( ss_data.win );
        //MmiTrace("hbhhideclose 1");
    }
    else
    {
        strcpy(actstr, "*#31#");    
        //MmiTrace("hbhhideclose 2");

        if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
        {
            //MmiTrace("hbhhideclose 3");
            showFailed( ss_data.win );
            return 0;
        }
        //change succedd ,must write to flash momery
        FlashDCTbData.hideIDflag=0;  //hu binhao 2002-11-28
        flash_DCTbwrite();          //hu binhao 2002-11-28
        // MmiTrace("hbhhideclose 4");

    }

    return 0;
}
/*******************************wufei 0827************************************************

 $Function:    	 hideid_check

 $Description:	hideid_check 
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
USHORT hideid_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{



    if( ((FlashDCTbData.hideIDflag==1)&&(((int)mi->str)==TxtActivate))||
        ((FlashDCTbData.hideIDflag==0)&&(((int)mi->str)==TxtDeactivate)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}

/*******************************************************************************

 $Function:    	 servicesCheckCLIR

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



int servicesCheckCLIR(MfwMnu* m, MfwMnuItem* i) {
    char actstr[8];

    CFAction = CFCheck;

    strcpy(actstr, "*#31#"); //wufei modified 0827

    if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );

    return 0;
}


/*******************************************************************************

 $Function:    	 servicesCheckCWaiting

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

int servicesCheckCWaiting(MfwMnu* m, MfwMnuItem* i) {
    char actstr[8];

    strcpy(actstr, "*#43#");

    if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );

    return 0;
}


/*******************************************************************************

 $Function:    	 servicesActivateCWaiting

 $Description:	activate CallWaiting functionality
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


int servicesActivateCWaiting(MfwMnu* m, MfwMnuItem* i) {
    char actstr[8];

    strcpy(actstr, "*43*10#");
    cwflag=1;
    if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );
    //flash write in mmiservice.c , hubin 2002-11-28
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	 servicesDeactivateCWaiting

 $Description:	deactivate CallWaiting functionality
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



int servicesDeactivateCWaiting(MfwMnu* m, MfwMnuItem* i) {
    char actstr[8];

    strcpy(actstr, "#43*10#");
    cwflag=0;
    if( ss_execute_transaction((UBYTE*)actstr, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );
    //flash write in mmiservice.c line , hubin 2002-11-28
    return  MFW_EVENT_CONSUMED;
}
/********************************wufei 0827***********************************************

 $Function:    	 callwaite_check

 $Description:	 callwaite_check

            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

USHORT callwaite_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{



    if( ((FlashDCTbData.callwaitflag==1)&&(((int)mi->str)==TxtActivate))||
        ((FlashDCTbData.callwaitflag==0)&&(((int)mi->str)==TxtDeactivate)) )

        return FLAGFUNC_TRUE_ICON;

    else

        return FLAGFUNC_FALSE_ICON;


}



/*******************************************************************************

 $Function:    	servicesInterCFU

 $Description:	Interrogate the CFU functionality
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/




int servicesInterCFU(void)
{
    char actstr[8];

    strcpy(actstr, "*#21#");

    ss_execute_transaction((UBYTE*)actstr, 0);

    return 0;
}










/*******************************************************************************

 $Function:    	ServiceGetStatus

 $Description:	return the code for the MMI text string for the service status.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


unsigned int ServiceGetStatus( UBYTE pStatus)
{
    unsigned int strStatusCode = 0;

    //	TRACE_FUNCTION("++ ServiceGetStatus");

    if( pStatus & SS_STAT_ACTIVE )
        strStatusCode = TxtActivated;
    else
        strStatusCode = TxtDeActivated;
    return strStatusCode;
}


/*******************************************************************************

 $Function:    	serviceGetServiceType

 $Description:	return the code for the MMI text string for the service type.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


unsigned int serviceGetServiceType( UBYTE ss_telecom_type, UBYTE ss_telecom_service)
{
    unsigned int strServCode = 0;

    //	TRACE_FUNCTION("++ serviceGetServiceType");
    switch( ss_telecom_type )
    {
    case MFW_BST_UNKNOWN:
        break;

    case MFW_BST_TELE:
        switch( ss_telecom_service )
        {
        case MFW_TS_ALL_TS:         strServCode = TxtAllCalls; break;/* all teleservices               */
        case MFW_TS_ALL_SPCH:       /* All speech transmission services */
        case MFW_TS_TLPHNY:         /* telephony                      */
        case MFW_TS_EMRGNCY:        /* emergency calls                */
            strServCode = TxtVoice;
            break;
        case MFW_TS_ALL_SMS:        /* all SMS services               */
        case MFW_TS_SMS_MT:         /* SMS MT PP                      */
        case MFW_TS_SMS_MO:         /* SMS MO PP                      */
            /*strServCode = TxtSMS;*/
            break;
        case MFW_TS_ALL_FAX:        /* all FAX transmission services  */
        case MFW_TS_FAX3_ALT_SPCH:  /* FAX group 3 alter. speech      */
        case MFW_TS_FAX3_AUTO:      /* FAX group 3 automatic          */
        case MFW_TS_FAX4:           /* FAX group 4                    */
            strServCode = TxtFax;
            break;
        case MFW_TS_ALL_DATA:       strServCode = TxtData; break;/* all FAX and SMS services       */
        case MFW_TS_ALL_XCPT_SMS:   strServCode = TxtNotImplemented;
            //                TRACE_FUNCTION("all x SMS"); break;/* all FAX and speech services    */
        case MFW_TS_ALL_PSSS:       strServCode = 0; break;/* all PLMN specific TS           */
        case MFW_TS_PLMN1:          /* PLMN specific TS 1             */
        case MFW_TS_PLMN2:          /* PLMN specific TS 2             */
        case MFW_TS_PLMN3:          /* PLMN specific TS 3             */
        case MFW_TS_PLMN4:          /* PLMN specific TS 4             */
        case MFW_TS_PLMN5:          /* PLMN specific TS 5             */
        case MFW_TS_PLMN6:          /* PLMN specific TS 6             */
        case MFW_TS_PLMN7:          /* PLMN specific TS 7             */
        case MFW_TS_PLMN8:          /* PLMN specific TS 8             */
        case MFW_TS_PLMN9:          /* PLMN specific TS 9             */
        case MFW_TS_PLMNA:          /* PLMN specific TS A             */
        case MFW_TS_PLMNB:          /* PLMN specific TS B             */
        case MFW_TS_PLMNC:          /* PLMN specific TS C             */
        case MFW_TS_PLMND:          /* PLMN specific TS D             */
        case MFW_TS_PLMNE:          /* PLMN specific TS E             */
        case MFW_TS_PLMNF:          /* PLMN specific TS F             */
            strServCode = 0;
            break;

        default: break;

        }
        break;

        /* NOTE that we are returning "Data" for all Bearer services until otherwise spec'ed */
    case MFW_BST_BEARER:
        switch( ss_telecom_service )
        {
        case MFW_BS_ALL_BS       : strServCode = TxtNotImplemented; /* strServCode = TxtAllServices; */ break; /* all bearer services            */
        case MFW_BS_ALL_DATA_CDA : /* all data CDA services          */
        case MFW_BS_CDA_300      : /* data CDA  300 bps              */
        case MFW_BS_CDA_1200     : /* data CDA 1200 bps              */
        case MFW_BS_CDA_1200_75  : /* data CDA 1200/75 bps           */
        case MFW_BS_CDA_2400     : /* data CDA 2400 bps              */
        case MFW_BS_CDA_4800     : /* data CDA 4800 bps              */
        case MFW_BS_CDA_9600     : /* data CDA 9600 bps              */
        case MFW_BS_ALL_DATA_CDS : /* all data CDS services          */
        case MFW_BS_CDS_1200     : /* data CDS 1200 bps              */
        case MFW_BS_CDS_2400     : /* data CDS 2400 bps              */
        case MFW_BS_CDS_4800     : /* data CDS 4800 bps              */
        case MFW_BS_CDS_9600     : /* data CDS 9600 bps              */
        case MFW_BS_ALL_DATA_PAD : /* all data PAD services          */
        case MFW_BS_PAD_300      : /* data PAD  300 bps              */
        case MFW_BS_PAD_1200     : /* data PAD 1200 bps              */
        case MFW_BS_PAD_1200_75  : /* data PAD 1200/75 bps           */
        case MFW_BS_PAD_2400     : /* data PAD 2400 bps              */
        case MFW_BS_PAD_4800     : /* data PAD 4800 bps              */
        case MFW_BS_PAD_9600     : /* data PAD 9600 bps              */
        case MFW_BS_ALL_DATA_PDS : /* all data PDS services          */
        case MFW_BS_PDS_2400     : /* data PDS 2400 bps              */
        case MFW_BS_PDS_4800     : /* data PDS 4800 bps              */
        case MFW_BS_PDS_9600     : /* data PDS 9600 bps              */
        case MFW_BS_SPCH_ALT_CDA : /* all data CDA alter. speech     */
        case MFW_BS_SPCH_ALT_CDS : /* all data CDS alter. speech     */
        case MFW_BS_SPCH_FLD_CDA : /* all data speech followed CDA   */
        case MFW_BS_SPCH_FLD_CDS : /* all data speech followed CDA   */
        case MFW_BS_ALL_DC_ASYN  : /* all data circuit asynchronous  */
        case MFW_BS_ALL_ASYN     : /* all asynchronous services      */
        case MFW_BS_ALL_DC_SYN   : /* all data circuit synchronous   */
        case MFW_BS_ALL_SYN      : /* all synchronous services       */
        case MFW_BS_ALL_PSSS     : /* all PLMN specific BS           */
        case MFW_BS_PLMN1        : /* PLMN specific 1                */
        case MFW_BS_PLMN2        : /* PLMN specific 2                */
        case MFW_BS_PLMN3        : /* PLMN specific 3                */
        case MFW_BS_PLMN4        : /* PLMN specific 4                */
        case MFW_BS_PLMN5        : /* PLMN specific 5                */
        case MFW_BS_PLMN6        : /* PLMN specific 6                */
        case MFW_BS_PLMN7        : /* PLMN specific 7                */
        case MFW_BS_PLMN8        : /* PLMN specific 8                */
        case MFW_BS_PLMN9        : /* PLMN specific 9                */
        case MFW_BS_PLMNA        : /* PLMN specific A                */
        case MFW_BS_PLMNB        : /* PLMN specific B                */
        case MFW_BS_PLMNC        : /* PLMN specific C                */
        case MFW_BS_PLMND        : /* PLMN specific D                */
        case MFW_BS_PLMNE        : /* PLMN specific E                */
        case MFW_BS_PLMNF        : /* PLMN specific F                */
            strServCode = TxtData /*0*/; break; //SPR - DS - 04/12/02 FTA fix 31.2.1.3

        default: break;

        }
        break;

    default:
        break;
    }
    return strServCode;
}


/*******************************************************************************

 $Function:    	serviceGetError

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static unsigned int serviceGetError( T_MFW_SS_ERROR ss_error )
{
    unsigned int errStrCode = TxtNotAvailable;
    //    TRACE_FUNCTION("serviceGetError");

    switch( ss_error )
    {
    case MFW_SS_ERR_UNKNOWN:
        errStrCode=TxtErrUnknown;
        break;
    case MFW_SS_ERROR:
        errStrCode=TxtSSErr;
        break;
    case MFW_SS_ERR_UNKNOWN_SUBSCRIBER:
        errStrCode=TxtUnknownSub;
        break;
    case MFW_SS_ERR_ILLEGAL_SUBSCRIBER:
        errStrCode=TxtIllSub;
        break;
    case MFW_SS_ERR_BEARER_SVC_NOT_PROV:
    case MFW_SS_ERR_TELE_SVC_NOT_PROV:
        errStrCode = TxtNotSubscribed;
        break;
    case MFW_SS_ERR_ILLEGAL_EQUIPMENT:
        errStrCode = TxtIllEqip;
        break;
    case MFW_SS_ERR_CALL_BARRED:
        errStrCode = TxtBarred;
        break;
    case MFW_SS_ERR_ILLEGAL_SS_OPERATION:
        errStrCode = TxtIllOp;
        break;
    case MFW_SS_ERR_SS_ERR_STATUS:
        errStrCode = TxtCheckStatus;
        break;
    case MFW_SS_ERR_SS_NOT_AVAIL:
        errStrCode = TxtNotAvailable;
        break;
    case MFW_SS_ERR_SS_SUBS_VIOLATION:
        errStrCode = TxtSubVil;
        break;
    case MFW_SS_ERR_SS_INCOMP:
        errStrCode = TxtInComp;
        break;
    case MFW_SS_ERR_FAC_NOT_SUPPORTED:
        errStrCode = TxtFacNoSup;
        break;
    case MFW_SS_ERR_ABSENT_SUBS:
        errStrCode = TxtAbsSub;
        break;
    case MFW_SS_ERR_SYSTEM_FAIL:
        errStrCode = TxtSysFail;
        break;
    case MFW_SS_ERR_DATA_MISSING:
        errStrCode = TxtMissDta;
        break;
    case MFW_SS_ERR_UNEXPECT_DATA:
    case MFW_SS_ERR_PROB_UNEXP_ERR:
    case MFW_SS_RES_PROB_RET_RES_UNEXP:
    case MFW_SS_ERR_PROB_RET_ERR_UNEXP:
    case MFW_SS_INV_PROB_LNK_RES_UNEXP:
    case MFW_SS_INV_PROB_UNEXP_LNK_OP:
        errStrCode = TxtUnexDta;
        break;
    case MFW_SS_ERR_PWD_REG_FAIL:
        errStrCode = TxtPwdErr;
        break;
    case MFW_SS_ERR_NEG_PWD_CHECK:
        errStrCode = TxtCodeInc;
        break;
    case MFW_SS_ERR_NUM_PWD_VIOLATION:
        errStrCode = TxtBlckPerm;
        break;
    case MFW_SS_ERR_UNKNOWN_ALPHA:
        errStrCode = TxtUnkAlph;
        break;
    case MFW_SS_ERR_USSD_BUSY:
        errStrCode = TxtNetworkBusy;
        break;
    case MFW_SS_ERR_MAX_NUM_MPTY_EXCEED:
        errStrCode = TxtMaxMpty;
        break;
    case MFW_SS_ERR_RESOURCE_NOT_AVAIL:
        errStrCode = TxtOperationNotAvail;
        break;
    case MFW_SS_RES_PROB_UNRECOG_INV_ID:
    case MFW_SS_INV_PROB_UNRECOG_LNK_ID:
    case MFW_SS_ERR_PROB_UNRECOG_INV_ID:
    case MFW_SS_GEN_PROB_UNRECOG_CMP:
    case MFW_SS_INV_PROB_UNRECOG_OP:
    case MFW_SS_ERR_PROB_UNRECOG_ERR:
        errStrCode = TxtUnRec;
        break;
    case MFW_SS_RES_PROB_MISTYPED_PAR:
    case MFW_SS_GEN_PROB_MISTYPED_CMP:
    case MFW_SS_INV_PROB_MISTYPED_PAR:
    case MFW_SS_ERR_PROB_MISTYPED_PAR:
        errStrCode = TxtMisTyp;
        break;
    case MFW_SS_GEN_PROB_BAD_STRUCT_CMP:
        errStrCode = TxtBadStruct;
        break;
    case MFW_SS_INV_PROB_DUPL_INV_ID:
        errStrCode = TxtDupInv;
        break;
    case MFW_SS_INV_PROB_RESOURCE_LIM:
        errStrCode = TxtResLim;
        break;
    case MFW_SS_INV_PROB_INIT_RELEASE:
        errStrCode = TxtIniRel;
        break;
    case MFW_SS_ERR_FATAL_INV_RESULT:
    case MFW_SS_ERR_FATAL_CCD_DEC:
    case MFW_SS_ERR_FATAL_SS_ENT:
        errStrCode = TxtFatRes;
        break;
    default:
        break;
    }
    return errStrCode;
}

/*******************************************************************************

 $Function:    	serviceGetType

 $Description:	Return code of text string that indicates the SS Type
            CW, CF, CFU, etc
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


unsigned int serviceGetType( T_MFW_SS_CODES type )
{
    unsigned int strTypeCode = 0;

    //	TRACE_FUNCTION("++ serviceGetType");

    switch( type )
    {
    case SS_CODES_UNKNOWN:
        break;

    case SS_CF_ALL:
        strTypeCode =  TxtAllCalls;
        break;

    case SS_CF_ALL_COND:
        strTypeCode =  TxtNotImplemented;
        break;

    case SS_CF_CFU:
        strTypeCode =  TxtAllCalls;
        break;

    case SS_CF_CFNRy:
        strTypeCode =  TxtCallDivertNoReach;
        break;

    case SS_CF_CFNR:
        strTypeCode =  TxtCallDivertNoReply;
        break;

    case SS_CF_CFB:
        strTypeCode =  TxtCallDivertIfBusy;
        break;

    case SS_CB_BAOC:
        strTypeCode =  TxtCallBAOC;
        break;
    case SS_CB_BAOIC:
        strTypeCode =  TxtCallBAOIC;
        break;
    case SS_CB_BAOICexH:
        strTypeCode =  TxtCallBAOICexH;
        break;
    case SS_CB_BAIC:
        strTypeCode =  TxtCallBAIC;
        break;
    case SS_CB_BAICroam:
        strTypeCode =  TxtCallBAICroam;
        break;
    case SS_CB_ALL:
        strTypeCode =  TxtCallBarringAll;
        break;
    case SS_CB_ALL_BAOC:
        strTypeCode =  TxtCallBAOCAll;
        break;
    case SS_CB_ALL_BAIC:
        strTypeCode =  TxtCallBAICAll;
        break;

    case SS_CW:
        strTypeCode = TxtCallWaiting;
        break;

    case SS_CCBS:
        break;

    case SS_CLIP:
        strTypeCode = TxtCLIP;
        break;
    case SS_CLIR:
        strTypeCode =  TxtSendID;
        break;

    case SS_COLP:
        strTypeCode = TxtCOLP;
        break;
    case SS_COLR:
        strTypeCode = TxtCOLR;
        break;

    case SS_PIN1:
    case SS_PIN2:
        break;

    default:
        break;
    }
    return strTypeCode;
}


/*******************************************************************************

 $Function:    	serviceGetCategory

 $Description:	return the code for the MMI text string for the service category.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

unsigned int serviceGetCategory( T_MFW_SS_CATEGORY cat )
{
    unsigned int strCatCode = 0;

    //	TRACE_FUNCTION("++ serviceGetCategory");

    switch( cat )
    {
    case SS_CTG_UNKNOWN:
        break;

    case SS_REGISTRATION:
    case SS_ACTIVATION:
        strCatCode = TxtActivated;
        break;

    case SS_ERASURE:
    case SS_DEACTIVATION:
        strCatCode = TxtDeActivated;
        break;

    case SS_INTERROGATION:
        //          TRACE_FUNCTION("SS Interrogation");
        break;

    default:
        break;
    }
    return strCatCode;
}


/*******************************************************************************

 $Function:    	servicesDivertActivate

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesDivertActivate(void)
{
    //   TRACE_FUNCTION("servicesDivertActivate");
    CFAction = CFActivate;
}

/*******************************************************************************

 $Function:    	servicesDivertCheck

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesDivertCheck(void)
{
    char SS_string[60] = {'\0'};
    /*
     * Interrogate Call Divert
     */
    //    TRACE_FUNCTION("glowing: servicesDivertCheck -- enter");

    CFAction = CFCheck;

    getCFAction(SS_string);
    getCFType(SS_string);
    getCFService(SS_string); //SPR#929 - DS - Changed from getCFServiceCheck.
    strcat(SS_string, "#");

    //TRACE_FUNCTION(SS_string);
    //   TRACE_EVENT_P1("glowing: servicesDivertCheck -- %s", SS_string );

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );
    //    TRACE_FUNCTION("glowing: servicesDivertCheck -- leave");
}


/****************************WUFEI APPEND***************************************************

 $Function:    	ShowAffirmWin

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void ShowAffirmWin (void)
{

    T_DISPLAY_DATA   display_info;
    dialog_info_init(&display_info);//gdy add
    display_info.LeftSoftKey  = TxtSoftOK;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.TextId2       = TxtCancelAffirm;//TxtCFCancelAffirm;
    display_info.TextId      = '\0';
    display_info.TextString   = '\0';
    display_info.TextString2   = '\0';
    display_info.Time         = FOREVER;
    display_info.Identifier   = CFCancelAffirm;
    display_info.iconindex=REMIND_REQUIRE;   //hu binhao 2003-1-14
    display_info.Callback     = (T_VOID_FUNC)services_info_cb;
    display_info.KeyEvents    = KEY_HUP | KEY_LEFT | KEY_RIGHT;

    ss_data.info_win = info_dialog (ss_data.win, &display_info);
}

/*******************************************************************************

 $Function:    	servicesDivertDeactivate

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesDivertDeactivate(void)
{
    char SS_string[60] = {'\0'};
    /*
     * Deactivate Call Divert
     */
    //  TRACE_FUNCTION("servicesDivertDeactivate");

    CFAction = CFDeactivate;

    getCFAction(SS_string);
    getCFType(SS_string);
    getCFService(SS_string); //SPR#929 - DS - Changed from getCFServiceCheck.
    SS_string[strlen(SS_string)] = '#';

    //    TRACE_FUNCTION(SS_string);

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
    {
        showFailed( ss_data.win );
    }
    else
    {
        /*  //hubinhao 2003-2-10 commented
            if (CphsPresent())
                {	//save the status to SIM

                    if (CFAction == CFDeactivate ) //hu binhao move and change 12-23 for bug  5109
                    switch (CFService)
                    {
                        case (CFVoice):	
                        case CFAuxVoice:

                            if (GetAlsLine() == MFW_SERV_LINE1)
                                cphs_set_divert_status(MFW_CFLAG_NOTSet,0,0,0);
                            else
                                cphs_set_divert_status(0,MFW_CFLAG_NOTSet,0,0);
                        break;
                        case (CFData): 	cphs_set_divert_status(0,0,0,MFW_CFLAG_NOTSet);break;
                        case (CFFax):	cphs_set_divert_status(0,0,MFW_CFLAG_NOTSet,0);break;
                        case (CFAll):	
                            if (GetAlsLine() == MFW_SERV_LINE1)
                                cphs_set_divert_status(MFW_CFLAG_NOTSet,0,MFW_CFLAG_NOTSet,MFW_CFLAG_NOTSet);
                            else
                                cphs_set_divert_status(0,MFW_CFLAG_NOTSet,MFW_CFLAG_NOTSet,MFW_CFLAG_NOTSet);
                        break;
                    }
                }
            else
                {
                    if (CFAction == CFDeactivate) 
                        {
                            FlashDCTbData.CFFlag=0; 
                            flash_DCTbwrite();   
                        }
                    if (CFAction == CFActivate) 
                        {
                            FlashDCTbData.CFFlag=1; 
                            flash_DCTbwrite();
                        }
                }
            */
    }

}

/*******************************************************************************

 $Function:    	servicesDivertVoice

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesDivertVoice(void)
{
    //   TRACE_FUNCTION("glowing: servicesDivertVoice");
    /*mc SPR 742 check if line2 is the current line*/
    if( !ALSPresent(NULL, NULL, NULL) && GetAlsLine() == MFW_SERV_LINE2/*FFS_flashData.als_selLine == MFW_SERV_LINE2*/ )
    {
        //	    TRACE_EVENT("glowing: servicesDivertVoice CFService = CFAuxVoice");
        CFService = CFAuxVoice;
    }
    else /*mc end*/
    {
        // 	    TRACE_EVENT("glowing: servicesDivertVoice CFService = CFVoice");
        CFService = CFVoice;
    }
}

/*******************************************************************************

 $Function:    	servicesDivertFax

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesDivertFax(void)
{
    //  TRACE_FUNCTION("servicesDivertFax");
    CFService = CFFax;
    CFType = CFUnconditional;
}


/*******************************************************************************

 $Function:    	servicesDivertData

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertData(void)
{
    //   TRACE_FUNCTION("servicesDivertData");
    CFService = CFData;
    CFType = CFUnconditional; //WUFEI APPEND

}

/*******************************************************************************

 $Function:    	servicesDivertActionAll

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesDivertActionAll(void)
{
    //  TRACE_FUNCTION("servicesDivertActionAll");
    CFService = CFAll;
}


/*******************************************************************************

 $Function:    	servicesDivertBusy

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertBusy(void)
{
    //TRACE_FUNCTION("servicesDivertBusy");
    servicesDivertVoice();  //hu binhao 2003-2-11
    CFType = CFBusy;
}

/****************************WUFEI Modify******************************************

 $Function:    	servicesDivertNoAnswer

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertNoAnswer(void)
{

    //  TRACE_FUNCTION("servicesDivertNoAnswer");
    servicesDivertVoice();  //hu binhao 2003-2-11
    CFType = CFNoReply;      

}

/****************************WUFEI Modify******************************************

 $Function:    	CFNRy_cb

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static void CFNRy_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    if( ss_data.info_win )
    {
        SEND_EVENT(ss_data.info_win, DIALOG_DESTROY, 0, 0);
        ss_data.info_win=0;
    }
    switch( reason )
    {
    case INFO_KCD_LEFT:                           
        SEND_EVENT(ss_data.win,ServicesDoCallDivert, 0, 0);
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	servicesDivertNotReachable

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertNotReachable(void)
{
    //   TRACE_FUNCTION("servicesDivertNotReachable");
    CFType = CFAllConditional;
}

/*******************************************************************************

 $Function:    	servicesDivertNoService

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertNoService(void)
{
    //  TRACE_FUNCTION("glowing: servicesDivertNoService -- enter");
    servicesDivertVoice();  //hu binhao 2003-2-11
    CFType = CFNoReach;
    //   TRACE_FUNCTION("glowing: servicesDivertNoService -- leave");
}


/*******************************************************************************

 $Function:    	servicesDivertAllCalls

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertAllCalls(void)
{
    //  TRACE_FUNCTION("servicesDivertAllCalls");
    servicesDivertVoice();  //hu binhao 2003-2-11
    CFType = CFUnconditional;
}

/*******************************************************************************

 $Function:    	servicesDivertCancelAll

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesDivertCancelAll(void)
{
    //    TRACE_FUNCTION("servicesDivertCancelAll");
    CFType = CFAllCalls;
    CFAction = CFDeactivate;
    CFService = CFAll;
    ShowAffirmWin(); //WUFEI MODIFY
    //servicesSendCallDivert(0);
}

/**********************************WUFEI APPEND*********************************************
$Function: servicesVoiceDivertCancelAll
$Description: Cancel All Voice Call Divert
$Returns:
$Arguments:
********************************************************************************/

void servicesVoiceDivertCancelAll(void)
{
    //	TRACE_FUNCTION("servicesVoiceDivertCancelAll");
    CFType = CFAllCalls;
    CFAction = CFDeactivate;
    CFService = CFVoice;
    ShowAffirmWin();//WUFEI MODIFY
    //servicesSendCallDivert(0);
}
/*******************************************************************************

 $Function:    	servicesBarringAllOutgoing

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesBarringAllOutgoing(void)
{
    //   TRACE_FUNCTION("servicesBarringAllOutgoing");
    CBType = CBAllOutgoing;
}

/*******************************************************************************

 $Function:    	servicesBarringInternational

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesBarringInternational(void)
{
    //   TRACE_FUNCTION("servicesBarringInternational");
    CBType = CBInternational;
}

/*******************************************************************************

 $Function:    	servicesBarringInternationalHome

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesBarringInternationalHome(void)
{
    //    TRACE_FUNCTION("servicesBarringInternationalHome");
    CBType = CBInternationalHome;
}


/*******************************************************************************

 $Function:    	servicesBarringAllIncoming

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesBarringAllIncoming(void)
{
    //  TRACE_FUNCTION("servicesBarringAllIncoming");
    CBType = CBAllIncoming;
}

/*******************************************************************************

 $Function:    	servicesBarringIncomingRoaming

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesBarringIncomingRoaming(void)
{
    //  TRACE_FUNCTION("servicesBarringIncomingRoaming");
    CBType = CBIncomingRoaming;
}


/*******************************************************************************

 $Function:    	services_get_voice_number_cb

 $Description:	callback function for the enter voicemail number window
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/




static void services_get_voice_number_cb(T_MFW_HND win,USHORT reason)
{
    //   TRACE_FUNCTION("services_get_voice_number_cb");

    switch( reason )
    {
    case SERVICES_INPUT_LEFT:
        //           TRACE_FUNCTION("SERVICES_INPUT_LEFT");
        /* send number if one has been entered */
        if( strlen(ss_data.edt_buf_number) > 0 )
            SEND_EVENT(win, SERVICES_DO_CALL_VOICE_DIVERT, 0, 0);
        break;
    case SERVICES_INPUT_RIGHT://wufei 0910
        //           TRACE_FUNCTION("SERVICES_INPUT_RIGHT");
        SEND_EVENT(ss_data.input_number_win, SERVICES_INPUT_DESTROY, 0, 0);
        ss_data.input_number_win = 0;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	servicesDoVoiceMailNumber

 $Description:	this function should access voicemail number if it is already
            entered, otherwise allow access to voicemail editing window
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesDoVoiceMailNumber(void)
{
    char voiceNum[30] = {'\0'};

    //  TRACE_FUNCTION("glowing: servicesDoVoiceMailNumber -- enter");

    //JVJEmsgsGetVoiceAddress(voiceNum);

    /* instead of the above we should use something like:  */
    if( strlen(voiceNum) > 0 )
    {
        servicesSendCallDivert(voiceNum);
    }
    else
    {
        T_ss * data = &ss_data;
        T_input_properties input;

        /*     memset(data->edt_buf_number,'\0',PHB_MAX_LEN);
             input.abc = FALSE;
             input.text = TxtEnterDivertNumber;  //hu binhao 2002-12-17
             input.edt_attr_input = &data->edt_attr_number;
             input.left_soft_key = TxtSoftOK;
             input.right_soft_key = TxtSoftBack;
             input.callback = services_get_voice_number_cb;*/
        input.text = TxtVoicemail;  //hu binhao 2002-12-17
        data->input_number_win = services_input_start(data->win,&input);

    }

}


/*******************************************************************************

 $Function:    	servicesGetOtherNumber

 $Description:	Sets up an editor for entering another number.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/




static void ServicesGetOtherNumber(T_MFW_HND win)
{
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_ss * data = (T_ss *)win_data->user;

    T_input_properties input;

    memset(data->edt_buf_number,'\0',PHB_MAX_LEN);
    /*	input.abc = FALSE;
    //	input.text = TxtEnterNumber;
        input.text = TxtEnterDivertNumber; ////hu binhao 2002-12-17
        input.edt_attr_input = &data->edt_attr_number;
        input.left_soft_key = TxtSearchName; //hu binhao 2003-2-18
        input.right_soft_key = TxtSoftBack;
        input.callback = services_get_number_cb;*/
    input.text = TxtEnterDivertNumber; //zy 2003-1-18
    data->input_number_win = services_input_start(win,&input);


}
/******************************WUFEI APPEND**************************************
$Function: services_info_screen
$Description:
$Returns:
$Arguments:
********************************************************************************/
void services_info_screen (T_MFW_HND win, USHORT MessageId )
{
    T_DISPLAY_DATA display_info;

    //   TRACE_FUNCTION ("services_info_screen()");
    dialog_info_init(&display_info);//gdy add

    if( MessageId==TxtDone||MessageId==TxtActivated||MessageId==TxtDeActivated )  //hu binhao 2003-1-6
    {
        display_info.iconindex=REMIND_COMPLETE;

    }
    else
    {
        display_info.iconindex=REMIND_NORECORD;
    }
    display_info.TextId2=MessageId;
    display_info.Time=FOREVER;

    display_info.TextString   = '\0'; 
    display_info.TextString2  = '\0';
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtNull;
    // display_info.Time         = 1000;
    display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;
    display_info.TextId       = NULL;
    display_info.Identifier   = NULL;
    display_info.Callback     = (T_VOID_FUNC)NULL;
    info_dialog (win, &display_info); 
}
/**********************************WUFEI APPEND********************************
$Function: servicesGetUsedNumber
$Description:
$Returns:
$Arguments:
********************************************************************************/
static void ServicesGetUsedNumber(void)
{

    T_MFW_HND win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());

    win = buildUsedNumberMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }

}   

/********************************WUFEI***********************************************

 $Function:     buildUsedNumberMenu

 $Description:  Builds the usednumber menu dynamenu from the numbers stored in the flash

 $Returns:    None

 $Arguments:  None

*******************************************************************************/
static T_MFW_HND  buildUsedNumberMenu( MfwHnd parent_window)
{
    T_USEDNUMBER_INFO *  data = (T_USEDNUMBER_INFO *)ALLOC_MEMORY (sizeof (T_USEDNUMBER_INFO));
    T_MFW_WIN  * win;

    //    TRACE_EVENT (">>>> buildUsedNumberMenu()");

    /*
     * Create window handler
     */

    data->numbers_win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)usednumber_win_cb);
    if( data->numbers_win EQ NULL )
    {
        return NULL;
    }

    // TRACE_EVENT(">>>> UsedNumber window created: " );
    /*
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)numbers_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->numbers_win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
    winShow(data->numbers_win);
    /*
     * return window handle
     */

    return data->numbers_win;
}

/*****************************WUFEI**************************************************

 $Function:     numbers_exec_cb

 $Description:  Exec callback function of the usednumber window (dynamic list of
        all the usuas used numbers)

 $Returns:    none

 $Arguments:  win - window handler
        event - mfw event
        parameter - optional data.

*******************************************************************************/
void numbers_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_USEDNUMBER_INFO   * data = (T_USEDNUMBER_INFO *)win_data->user;
    UBYTE i;
    UBYTE n;
    // char srcNumberStr[19];  hu binhao 2002-12-30 for 5222

    TRACE_EVENT (">>>>> number_exec_cb()");

    switch( event )
    {
    case E_INIT:

        //   TRACE_EVENT(">>>> number_exec_cb() Event:E_INIT");

        /* initialization of administrative data */


        data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

        if( data->menu_list_data == 0 )
        {
            //     TRACE_EVENT("Failed memory alloc 1 ");
            return;
        }
        //flash_DCTbread();	//hxl moved this to ffsfile_init 2002-11-26
        n = usednumber_GetListCount(RES_USEDNUMBER);
        if( n==0 )
        {
            services_info_screen(win,TxtEmptyList);
            usednumber_destroy(data->numbers_win);//wufei 0830
        }
        else
        {
            data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( (n+1) * sizeof(T_MFW_MNU_ITEM) );

            if( data->menu_list_data->List == 0 )
            {
                //     TRACE_EVENT("Failed memory alloc 2");
                return;
            }
            for( i = 0; i < n ; i++ )
            {
                /* 2004/06 sunsj modify for picture manage */
                data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_CALLRECORD_UNUMBER, 0);//&Unumbersicon; //hu binhao 2002-12-30 for 5221
                data->menu_list_data->List[i].exta = 0;
                data->menu_list_data->List[i].edit = 0;
                data->menu_list_data->List[i].menu = 0;
                data->menu_list_data->List[i].func = NULL;

                memset(DCTbVar[i],'\0',40);
                /*
                #ifdef CHINESE_MMI
                memset(srcNumberStr,'\0',19);
                strcpy(srcNumberStr,(char *)FlashDCTbData.UsedNumberTable[i]);
                //ChangeToUcs2(srcNumberStr,DCTbVar[i]);  
                #else*/  //hu binhao 2002-12-18 for bug 5107
                strcpy(DCTbVar[i],(char *)FlashDCTbData.UsedNumberTable[i]);
                //#endif
                data->menu_list_data->List[i].str  = (char *)(TxtDCTbVar0+i);
                data->menu_list_data->List[i].flagFunc = item_flag_none;
            }
            data->menu_list_data->List[n].icon = GET_ICONATTR(ICON_LISTCOMMON, 0);//&colist;  /* 2004/06 sunsj modify for icon manage */
            data->menu_list_data->List[n].exta = 0;
            data->menu_list_data->List[n].edit = 0;
            data->menu_list_data->List[n].menu = 0;
            data->menu_list_data->List[n].func = NULL;
            data->menu_list_data->List[n].str = (char*)TxtDeleteAll;//ȫɾ
            data->menu_list_data->List[n].flagFunc = item_flag_none;
            data->menu_list_data->ListLength =n+1;
            data->menu_list_data->ListPosition = 1;
            data->menu_list_data->CursorPosition = 1;
            data->menu_list_data->SnapshotSize = n+1;
            data->menu_list_data->Font = 0;
            data->menu_list_data->LeftSoftKey = TxtSoftSelect;
            data->menu_list_data->RightSoftKey = TxtSoftBack;
            data->menu_list_data->KeyEvents = KEY_ALL;
            data->menu_list_data->Reason = 0;
            data->menu_list_data->Strings = FALSE;
            data->menu_list_data->Attr   = &UsedNumber_menuAttrib;
            data->menu_list_data->autoDestroy    = FALSE;
            data->menu_list_data->ListMenuFlag=1;  //hu binhao 2002-12-23 
            data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNumberInCommonUse); //hu binhao 2002-12-23
            listDisplayListMenu(win, data->menu_list_data,(ListCbFunc)UsedNumberList_cb,0);
        }
        break;
    default:
        break;

    }
}

/***********************************WUFEI APPEND*******************************
$Function: UsedNumberList_cb
$Description:
$Return:
$Description:
********************************************************************************/
static void UsedNumberList_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_USEDNUMBER_INFO * data     = (T_USEDNUMBER_INFO *)win_data->user;
    T_MFW_HND      * l_parent;
    UBYTE n;
    UBYTE i;
    T_DISPLAY_DATA display_info;
    T_EDITOR_DATA editor_data;//wufei add 0910
    UBYTE Reason;
    Reason=ListData->Reason;

    if( (Reason EQ LISTS_REASON_BACK) || (Reason EQ LISTS_REASON_CLEAR)
        || (Reason EQ LISTS_REASON_HANGUP) )
    {
        l_parent = data->parent;
        listsDestroy(ListData->win);  
        usednumber_destroy(data->numbers_win);
    }
    else if( (Reason EQ LISTS_REASON_SELECT)||(Reason EQ LISTS_REASON_OK) ) //hu binhao 2003-2-21
    {
        //n = usednumber_GetListCount(RES_USEDNUMBER);    
        n=ListData->ListLength; 
        i=ListData->ListPosition;
        if( i<n-1 )
        {
            if( CFType==CFNoReply )//wufei add 0910
            {

                memset(ss_data.edt_buf_number,'\0',PHB_MAX_LEN);
                strcpy(ss_data.edt_buf_number,(char*)FlashDCTbData.UsedNumberTable[i]);
                ss_data.input_tim_menu=bookMenuStart(ss_data.win, menuSetTimeAttributes(), CFTimeSet);
                /*memset(ss_data.edt_buf_number,'\0',PHB_MAX_LEN);
                strcpy(ss_data.edt_buf_number,(char*)FlashDCTbData.UsedNumberTable[i]);			
                TRACE_FUNCTION("SERVICES_INPUT_LEFT");
                memset(ss_data.edt_buf_NoAnswerTime,'\0',sizeof(ss_data.edt_buf_NoAnswerTime));
                bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
                (char*)ss_data.edt_buf_NoAnswerTime,5, &editor_data.editor_attr ); //wufei modified 0813//0910
                editor_data.LeftSoftKey          = TxtSoftOK;               
                editor_data.AlternateLeftSoftKey = TxtNull;                
                editor_data.RightSoftKey         = TxtDelete;               
                editor_data.hide                 = FALSE;               
                editor_data.mode                 = DIGITS_MODE;                
                editor_data.timeout              = FOREVER;
                editor_data.Identifier	= 0;
                editor_data.TextString	= NULL;     
                editor_data.destroyEditor        = TRUE;
                editor_data.Callback   = (T_EDIT_CB)CFNRy_cb;               
                editor_data.TextId = TxtEnterNRyTime;
                editor_data.min_enter  = 1;
                ss_data.info_win = editor_start(ss_data.win, &editor_data);
    */
            }
            else
            {
                //			TRACE_FUNCTION("SERVICES_INPUT_LEFT");
                servicesSendCallDivert((char *)FlashDCTbData.UsedNumberTable[i]);
            }
        }
        else
        {
            //for(i=0;i<n;i++)
            //memset(FlashDCTbData.UsedNumberTable[i],'\0',21);
            memset(FlashDCTbData.UsedNumberTable,'\0',(n-1)*19);
            FlashDCTbData.UsedTbIdx=0;
            //FREE_MEMORY ((void*)FlashDCTbData.UsedNumberTable, sizeof (ListWinInfo));
            flash_DCTbwrite();
            //SEND_EVENT(ss_data.win,ServicesOk,NULL,NULL);

            // 	TRACE_FUNCTION ("Usednumber List Empty");
            services_info_screen(data->numbers_win,TxtDone);
            l_parent = data->parent;    //hu binhao 2002-12-18 for 5108
            listsDestroy(ListData->win); //hu binhao 2002-12-18 for 5108
            usednumber_destroy(data->numbers_win); //hu binhao 2002-12-18 fro 5108
        }
        //listsDestroy(ListData->win);  //wufei 0905
        //usednumber_destroy(data->numbers_win);//wufei 0905

    }
}

/*******************************WUFEI************************************************

 $Function:     usednumber_destroy

 $Description:  Destroy the usednumber window.

 $Returns:    none

 $Arguments:  own_window- current window
*******************************************************************************/

static void usednumber_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_USEDNUMBER_INFO     * data;
    UBYTE n;

    //  TRACE_EVENT ("usednumber_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_USEDNUMBER_INFO *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */
            win_delete (data->numbers_win);

            /*
             * Free Memory
             */

            n = usednumber_GetListCount(RES_USEDNUMBER);

            if( data->menu_list_data != NULL )
            {
                FREE_MEMORY ((void *)data->menu_list_data->List, (n+1) * sizeof (T_MFW_MNU_ITEM));//zy add"+1"20030304
                FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
            }
            FREE_MEMORY ((void *)data, sizeof (T_USEDNUMBER_INFO));

        }
        else
        {
            //     TRACE_EVENT ("usednumber_destroy() called twice");
        }
    }
}

/**************************************WUFEI*****************************************

 $Function:     usednumber_win_cb

 $Description:  Window callback function for the usednumber window.

 $Returns:    none

 $Arguments:  w - mfw window handler
        e - mfw event

*******************************************************************************/

static int usednumber_win_cb (MfwEvt e, MfwWin *w)    /* yyy window event handler */
{
    // TRACE_EVENT ("usednumber_win_cb()");
    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */

    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/************************************WUFEI*******************************************

 $Function:     usednumber_menu_cb

 $Description:  Call back function for the usednumber menu.

 $Returns:

 $Arguments:
*******************************************************************************/
static int usednumber_menu_cb (MfwEvt e, MfwMnu *m){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    //    T_call_menu * data = (T_call_menu *)win_data->user;

    switch( e )
    {
    case E_MNU_ESCAPE:
        //call_menu_destroy(win);
        //call_data.win_menu = 0;
        break;
    default:
        return 0;
    }
    return 1;
}

/********************************WUFEI***********************************************

 $Function:     usednumber_GetListCount

 $Description:  Returns the number of entries in resource table.

 $Returns:    Number of entries in Melody table.

 $Arguments:  res - Resource Id.

*******************************************************************************/
int usednumber_GetListCount(res_ListTB_type res)
// Returns the number of the resource type available in the phone.
{
    int index=0;
    switch( res )
    {
    
    case RES_USEDNUMBER: //WUFEI
        while( strlen((char *)FlashDCTbData.UsedNumberTable[index])!=0 && index<10 )
            index++;
        return index;
        break;
    case RES_LANGUAGE:

        break;
    case RES_STRING:        

        break;
    case RES_GROUPEDNUMBER://WUFEI
        while( strlen((char *)FlashDCTbData.GroupedNumber[index]) !=0 && index<10 )
            index++;
        return index;
        break;
    default:        

        break;

    }
    return index;
}

/*******************************************************************************

 $Function:    	servicesDoOtherNumber

 $Description:	
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesDoOtherNumber(void)
{

    //  TRACE_FUNCTION("servicesDoOtherNumber");

    SEND_EVENT(ss_data.win, ServicesOtherNumber, 0, 0);


    /* this is function called from menu, it will also send a signal to start
       window being displayed for editing or calling phonebook */
    /* set up and show edit field */
}

/******************************WUFEI APPEND************************************
$Function:   servicesDoUsedNumber
$Description:
$Returns:
$Arguments:
********************************************************************************/
void servicesDoUsedNumber(void)
{
    //	TRACE_FUNCTION("servicesDoUsedNumber");
    SEND_EVENT(ss_data.win, ServicesUsedNumber, 0, 0);
}

/*******************************************************************************

 $Function:    	servicesStoreVoiceMailNumber

 $Description:	Store number to Voicemail number (currently in SMS, should be in PCM?)
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void servicesStoreVoiceMailNumber( void )
{
    char voiceNum[30] = {'\0'};
    //   TRACE_FUNCTION("servicesStoreVoiceMailNumber");

    getCFNumber(voiceNum);

}

/*******************************************************************************

 $Function:    	servicesUSSDDisplayList

 $Description:	List all stored USSDs.
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesUSSDDisplayList(void)
{
    //   TRACE_FUNCTION("servicesUSSDList");
}


/*******************************************************************************

 $Function:    	services_ussd_list_cb

 $Description:	callback function list dialog.            

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void services_ussd_list_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    //    TRACE_FUNCTION("services_ussd_list_cb");

}

/*******************************************************************************

 $Function:    	servicesUSSDSend

 $Description:	Enter a USSD to send.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesUSSDSend(void)
{
    //   TRACE_FUNCTION("servicesUSSDSend");
    servicesExec(ServicesUSSDSendEdit, 0);
}

/*******************************************************************************

 $Function:    	servicesUSSDAddNew

 $Description:	Add a new USSD to those in the list if there's enough space.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void servicesUSSDAddNew(void)
{
    //  TRACE_FUNCTION("servicesUSSDAddNew");
    /* if there is space left in the flash then add a new one */
    if( 0 )
        servicesExec(ServicesUSSDNew,0);
    /* else no room left so display message */
    else
        servicesExec(ServicesUSSDAlreadyFull, 0);
}

/*******************************************************************************

 $Function:    	servicesUSSDEdit

 $Description:	Edit selected USSD.
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int servicesUSSDEdit(struct MfwMnuTag* m, struct MfwMnuItemTag* i)
{
    //   TRACE_FUNCTION("servicesUSSDEdit");
    /* get current ussd from list into variables */
    strcpy(mCurrentUSSDNumber, "54321");
    strcpy(mCurrentUSSDName, "Jorp");

    /* send signal to start editing USSD */
    servicesExec(ServicesUSSDChange, 0);
    return 0;
}

/*******************************************************************************

 $Function:    	servicesUSSDDelete

 $Description:	Delete selected USSD.

 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int servicesUSSDDelete(struct MfwMnuTag* m, struct MfwMnuItemTag* i)
{
    //    TRACE_FUNCTION("servicesUSSDDelete");
    /* get current USSD from list and delete it.
        Will need to update list somehow */

    return 0;

}

/*******************************************************************************

 $Function:    	servicesStoreUSSD

 $Description:	Store selected USSD to NVM.
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void servicesStoreUSSD(void)
{
    //   TRACE_FUNCTION("servicesStoreUSSD");
}

/*******************************************************************************

 $Function:    	servicesActivateIRDA

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int servicesActivateIRDA(MfwMnu* m, MfwMnuItem* i)
{

}

/*******************************************************************************

 $Function:    	servicesDeactivateIRDA

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
int servicesDeactivateIRDA(MfwMnu* m, MfwMnuItem* i)
{

}

/*******************************************************************************

 $Function:    	ussd_input_create

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static T_MFW_HND ussd_input_create(MfwHnd parent)
{
    T_MFW_WIN     * win_data;
    T_ussd_input *  data = (T_ussd_input *)ALLOC_MEMORY (sizeof (T_ussd_input));

    //	TRACE_FUNCTION ("ussd_input_create()");

    data->win = win_create (parent, 0, E_WIN_VISIBLE, (T_MFW_CB)ussd_input_win_cb);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)ussd_input;
    data->mmi_control.data     = data;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;

    /*
     * return window handle
     */

    data->kbd = kbdCreate(data->win,KEY_ALL,(MfwCb)ussd_input_kbd_cb);
    data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)ussd_input_kbd_long_cb);
    data->parent_win = parent;


    return data->win;

}

/*******************************************************************************

 $Function:    	ussd_input_destroy

 $Description:	Destroy the ussd_input_destroy dialog.
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void ussd_input_destroy(MfwHnd window){
    T_MFW_WIN     * win  = ((T_MFW_HDR *)window)->data;
    T_ussd_input * data = (T_ussd_input *)win->user;

    //	TRACE_FUNCTION ("ussd_input_destroy()");

    if( data )
    {
        editDeactivate();
        winDelete (data->win);
        /*     * Free Memory
         */
        FREE_MEMORY ((void *)data, sizeof (T_ussd_input));
    }
    ss_data.ussd_num_win = 0;
}

/*******************************************************************************

 $Function:    	ussd_input_start

 $Description:	
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static MfwHnd ussd_input_start(MfwHnd parent,T_input_properties *properties){


    T_MFW_HND win;

    // TRACE_FUNCTION ("ussd_input_start()");


    win = ussd_input_create (parent);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, SERVICES_INPUT_INIT, 0, properties);
    }
    return win;
}

/*******************************************************************************

 $Function:    	ussd_input

 $Description:	Dialog function for ussd_input window.
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void ussd_input (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_ussd_input     * data = (T_ussd_input *)win_data->user;

    T_input_properties* properties = (T_input_properties*) parameter;

    //   TRACE_FUNCTION ("T_ussd_input()");

    switch( event )
    {
    case SERVICES_INPUT_INIT:
        data->properties.abc    = properties->abc;
        data->properties.text   = properties->text;
        data->properties.edt_attr_input = properties->edt_attr_input;
        data->properties.left_soft_key = properties->left_soft_key;
        data->properties.right_soft_key = properties->right_soft_key;
        data->properties.callback = properties->callback;
        data->edt_input = edtCreate(data->win,data->properties.edt_attr_input,0,0);
        edtChar(data->edt_input,ecBottom);
        winShow(data->win);
        break;
    default:
        return;
    }
}

/*******************************************************************************

 $Function:    	ussd_input_win_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int ussd_input_win_cb (MfwEvt e, MfwWin *w){

    T_ussd_input * data = (T_ussd_input *)w->user;

    int i =0;

    //    TRACE_FUNCTION ("ussd_input_win_cb()");

    switch( e )
    {
    case MfwWinVisible:
        dspl_TextOut(menuArea.px,menuArea.py,0,GET_TEXT(data->properties.text));
        break;
    default:
        return 0;
    }
    return 1;
}

/*******************************************************************************

 $Function:    	ussd_input_kbd_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int ussd_input_kbd_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_ussd_input * data = (T_ussd_input *)win_data->user;

    T_MFW_SS_PARA ussd_data;

    //   TRACE_FUNCTION ("ussd_input_kbd_cb()");

    switch( k->code )
    {
    case KCD_MNUUP:
        edtChar(data->edt_input,ecRight);
        break;
    case KCD_MNUDOWN:
        edtChar(data->edt_input,ecLeft);
        break;
    case KCD_LEFT:

        ussd_data.ussd_info.len = strlen((char*)ss_data.edt_buf_number);
        ussd_data.ussd_info.dcs = ss_data.dcs;
        ussd_data.ussd_info.error = MFW_SS_NO_ERROR;

        sendUSSD (&ussd_data);

        ussd_input_destroy(data->win);
        break;
    case KCD_HUP:
        edtChar(data->edt_input,ecBack);
        break;
    case KCD_RIGHT:
        ussd_input_destroy(data->win);
        break;
    default:
        edtChar(data->edt_input,editControls[k->code]);
        break;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	ussd_input_kbd_long_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int ussd_input_kbd_long_cb (MfwEvt e, MfwKbd *k)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_ussd_input * data = (T_ussd_input *)win_data->user;


    if( (e & KEY_CLEAR) && (e & KEY_LONG) )
    {
        edtClear(data->edt_input);
        ussd_input_destroy(data->win);
        return MFW_EVENT_CONSUMED;
    }
    return  MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	ussd_number_input_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void ussd_number_input_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    switch( reason )
    {
    
    case SERVICES_INPUT_LEFT:
        break;
    case SERVICES_INPUT_RIGHT:
        break;
    case SERVICES_INPUT_CLEAR:
        break;
    default:
        return;
    }
}

static T_MFW_HND   dialog_ext_info_create      (T_MFW_HND  parent_win);
static void        dialog_ext_info_destroy     (T_MFW_HND  own_window);
void        dialog_ext_info             (T_MFW_HND  win,
                                         USHORT event, SHORT value, void * parameter);
static int         dialog_ext_info_win_cb      (T_MFW_EVENT event, T_MFW_WIN * win);
static T_MFW_CB    dialog_ext_info_tim_cb      (T_MFW_EVENT event, T_MFW_TIM * tc);
static int         dialog_ext_info_kbd_cb      (T_MFW_EVENT event, T_MFW_KBD * keyboard);
static int         dialog_ext_info_kbd_long_cb (T_MFW_EVENT e, T_MFW_KBD *k);
/*******************************************************************************

 $Function:    	dialog_ext_info_dialog

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
T_MFW_HND dialog_ext_info_dialog (T_MFW_HND           parent_win,
                                  T_dialog_ext_info * display_info)
{
    T_MFW_HND win;

    win = dialog_ext_info_create (parent_win);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, DIALOG_INIT, 0, display_info);
    }
    return win;
}


/*******************************************************************************

 $Function:    	dialog_ext_info_create

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static T_MFW_HND dialog_ext_info_create (T_MFW_HND parent_win)
{
    T_MFW_WIN         * win_data;
    T_dialog_ext_info *  data = (T_dialog_ext_info *)ALLOC_MEMORY (sizeof (T_dialog_ext_info));

    //  TRACE_FUNCTION ("dialog_ext_info_create()");

    if( data EQ 0 )
    {
        //    TRACE_FUNCTION("NOT ENOUGH RESOURCES FOR DATA");
        return 0;
    }
    data->info_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)dialog_ext_info_win_cb);

    if( data->info_win EQ 0 )
    {
        //    TRACE_FUNCTION("NOT ENOUGH RESOURCES FOR 4 line INFO WIN");
        return 0;
    }

    /*
     * Create window handler
     */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)dialog_ext_info;
    data->mmi_control.data     = data;
    data->parent_win           = parent_win;
    win_data                   = ((T_MFW_HDR *)data->info_win)->data;
    win_data->user             = (void *)data;


    win_show(data->info_win);
    /*
     * return window handle
     */
    return data->info_win;
}

/*******************************************************************************

 $Function:    	dialog_ext_info_destroy

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void dialog_ext_info_destroy (T_MFW_HND own_window)
{
    T_MFW_WIN     * win  = ((T_MFW_HDR *)own_window)->data;
    T_dialog_ext_info * data = (T_dialog_ext_info *)win->user;

    // TRACE_FUNCTION ("dialog_ext_info_destroy()");

    if( data )
    {
        /*
         * Exit TIMER & KEYBOARD Handle
         */
        kbd_delete (data->info_kbd);
        kbd_delete (data->info_kbd_long);
        tim_delete (data->info_tim);

        /*
         * Delete WIN Handler
         */
        win_delete (data->info_win);
        /*
         * Free Memory
         */
        FREE_MEMORY ((void *)data, sizeof (T_dialog_ext_info));
    }
}

/*******************************************************************************

 $Function:    	dialog_ext_info

 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
void dialog_ext_info (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data     = ((T_MFW_HDR *)win)->data;
    T_dialog_ext_info  * data     = (T_dialog_ext_info *)win_data->user;
    T_dialog_ext_info  * display_info = (T_dialog_ext_info *)parameter;

    //TRACE_FUNCTION ("dialog_ext_info()");

    switch( event )
    {
    case DIALOG_INIT:
        /*
         * Initialize dialog
         */
        /*
         * Store any other data
         */
        data->LeftSoftKey  = display_info->LeftSoftKey;
        data->RightSoftKey = display_info->RightSoftKey;
        data->Time         = display_info->Time;
        data->KeyEvents    = display_info->KeyEvents;
        data->TextId1      = display_info->TextId1;
        data->TextId2      = display_info->TextId2;
        data->TextString4  = display_info->TextString4;
        data->Identifier   = display_info->Identifier;
        data->Callback     = display_info->Callback;
        /*
         * Create timer and keyboard handler
         */
        data->info_tim             = tim_create (win, display_info->Time, (T_MFW_CB)dialog_ext_info_tim_cb);
        data->info_kbd             = kbd_create (win, data->KeyEvents, (T_MFW_CB)dialog_ext_info_kbd_cb);  //hu binhao 2003-3-21
        data->info_kbd_long        = kbd_create (win, KEY_ALL|KEY_LONG, (T_MFW_CB)dialog_ext_info_kbd_long_cb);

        if( display_info->Time NEQ FOREVER )
            tim_start (data->info_tim);
        win_show(win);
        break;

    case DIALOG_DESTROY:
        dialog_ext_info_destroy(win);
        break;
    }
}

/*******************************************************************************

 $Function:    	dialog_ext_info_win_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static int dialog_ext_info_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
    T_dialog_ext_info * data = (T_dialog_ext_info *)win->user;
    T_DISPLAY_DATA display_info;
    // TRACE_FUNCTION ("dialog_ext_info_win_cb()");

    if( data EQ 0 )
        return 1;

    switch( event )
    {
    case E_WIN_VISIBLE:
        /*
         * Print the information dialog
         */

        /*2003/12/4, wangyan modify*/
        /*      dspl_ClearAll();
        
              displaySoftKeys(data->LeftSoftKey, data->RightSoftKey);
              if (data->TextId1 NEQ 0)
              {
                displayAlignedText(CENTER, FIRST_LINE, 0, GET_TEXT(data->TextId1));
              }
        
              if (data->TextId2 NEQ 0)
              {
                displayAlignedText(CENTER, SECOND_LINE, 0, GET_TEXT(data->TextId2));
              }
        
              if (data->TextString4)
              {
                displayAlignedText(CENTER, THIRD_LINE, 0, data->TextString4);
              }*/


        dialog_info_init(&display_info);
        display_info.LeftSoftKey    = data->LeftSoftKey;
        display_info.RightSoftKey   = data->RightSoftKey;
        display_info.TextId         = data->TextId1;
        display_info.TextId2        = data->TextId2;
        display_info.TextString2       = data->TextString4;
        display_info.Callback       = NULL;
        /* 2004/05/08 sunsj modify */
        display_info.Time           = THREE_SECS;
        display_info.KeyEvents      = KEY_LEFT|KEY_RIGHT|KEY_HUP;
        display_info.iconindex=0;
        /*
        * Call Info Screen
        */
        info_dialog (win, &display_info);

        break;

    default:
        return 0;
    }
    return 1;
}


/*******************************************************************************

 $Function:    	dialog_ext_info_tim_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static T_MFW_CB dialog_ext_info_tim_cb (T_MFW_EVENT event, T_MFW_TIM *tc)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_ext_info * data = (T_dialog_ext_info *)win_data->user;

    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->Identifier;
    void (* Callback)() = data->Callback;

    dialog_ext_info_destroy (win);

    if( Callback )
        (Callback) (parent_win, Identifier, INFO_TIMEOUT);

    return 0;
}

/*******************************************************************************

 $Function:    	dialog_ext_info_kbd_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

static int dialog_ext_info_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_ext_info * data = (T_dialog_ext_info *)win_data->user;
    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->Identifier;
    void (* Callback)() = data->Callback;

    TRACE_FUNCTION("dialog_ext_info_kbd_cb");

    switch( keyboard->code )
    {
    case KCD_LEFT:
        if( data->KeyEvents & KEY_LEFT )
        {
            dialog_ext_info_destroy (win);
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_LEFT);
        }
        break;

    case KCD_RIGHT:
        if( data->KeyEvents & KEY_RIGHT )
        {
            dialog_ext_info_destroy (win);
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_RIGHT);
        }
        break;

    case KCD_HUP:
        if( data->KeyEvents & KEY_CLEAR )
        {
            dialog_ext_info_destroy (win);
            if( Callback )
                (Callback) (parent_win, Identifier, INFO_KCD_HUP);
        }
        break;
        dialog_ext_info_destroy (win);

    case KCD_MNUUP:
        dialog_ext_info_destroy (win);
        if( Callback )
            (Callback) (parent_win, Identifier, INFO_KCD_UP);
        break;

    case KCD_MNUDOWN:
        dialog_ext_info_destroy (win);
        if( Callback )
            (Callback) (parent_win, Identifier, INFO_KCD_DOWN);
        break;

    default:
        return MFW_EVENT_PASSED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	dialog_ext_info_kbd_long_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/






static int dialog_ext_info_kbd_long_cb (T_MFW_EVENT e, T_MFW_KBD *k)
{
    T_MFW_HND       win  = mfw_parent (mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_dialog_ext_info * data = (T_dialog_ext_info *)win_data->user;
    T_MFW_HND       parent_win = data->parent_win;
    USHORT          Identifier = data->Identifier;
    void (* Callback)() = data->Callback;

    // TRACE_FUNCTION("dialog_ext_info_kbd_long_cb");

    switch( k->code )
    {
    case KCD_MNUUP:
        dialog_ext_info_destroy (win);
        if( Callback )
            (Callback) (parent_win, Identifier, INFO_KCD_UP);
        break;

    case KCD_MNUDOWN:
        dialog_ext_info_destroy (win);
        if( Callback )
            (Callback) (parent_win, Identifier, INFO_KCD_DOWN);
        break;
    }
    /*
     * Consume all long key presses
     */
    return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:    	services_get_number_cb

 $Description:	callback function for the edt_input editor win
            
 $Returns:		

 $Arguments:	
 
*******************************************************************************/
static void services_get_number_cb(T_MFW_HND win,USHORT identify,USHORT reason)
{
    /*
    beging of zy 2003-02-19 change
    */
#if 0
    TRACE_FUNCTION("services_get_number_cb");
    //T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    //T_ss * data = (T_ss *)win_data->user;

    switch( reason )
    {
    case SERVICES_INPUT_LEFT:
        if( CFType==CFNoReply )
        {
            ss_data.input_tim_menu=bookMenuStart(win, menuSetTimeAttributes(), (SHORT)CFTimeSet);
            /*T_EDITOR_DATA editor_data;
            TRACE_FUNCTION("SERVICES_INPUT_LEFT");
            memset(ss_data.edt_buf_NoAnswerTime,'\0',sizeof(ss_data.edt_buf_NoAnswerTime));
            bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
            (char*)ss_data.edt_buf_NoAnswerTime,5, &editor_data.editor_attr ); //wufei modified 0813//0910
            editor_data.LeftSoftKey          = TxtSoftOK;               
            editor_data.AlternateLeftSoftKey = TxtNull;                
            editor_data.RightSoftKey         = TxtDelete;               
            editor_data.hide                 = FALSE;               
            editor_data.mode                 = DIGITS_MODE;                
            editor_data.timeout              = FOREVER;
            editor_data.Identifier	= 0;
            editor_data.TextString	= NULL;     
            editor_data.destroyEditor        = TRUE;
            editor_data.Callback   = (T_EDIT_CB)CFNRy_cb;               
            editor_data.TextId = TxtEnterNRyTime;
            editor_data.min_enter  = 1;
            ss_data.info_win = editor_start(ss_data.win, &editor_data);*/

        }
        else
        {
            TRACE_FUNCTION("SERVICES_INPUT_LEFT");
            SEND_EVENT(win, ServicesDoCallDivert, 0, 0);
        }
        break;
    case SERVICES_INPUT_RIGHT:
        TRACE_FUNCTION("SERVICES_INPUT_RIGHT");
        SEND_EVENT(ss_data.input_number_win, SERVICES_INPUT_DESTROY, 0, 0);
        ss_data.input_number_win = 0;
        //SEND_EVENT(win, ServicesDoCallDivert, 0, 0);
        //bookSearchStart(ss_data.input_number_win);
        break;
    default:
        break;
    }
#endif
    switch( reason )
    {
    case INFO_KCD_ALTERNATELEFT:
    case INFO_KCD_LEFT:

        //  		TRACE_EVENT("zy:servicegetnumber:INFO_KCD_LEFT:");
        //  		TRACE_EVENT(ss_data.edt_buf_number)
        if( strlen(ss_data.edt_buf_number) <= 0 )
        {
            T_MFW_HND phbk_win;
            phbk_win = bookPhonebookStart(ss_data.input_number_win,PhbkFromDivert);//beging phbsearch win

        }
        else
        {

            if( CFType==CFNoReply )
            {
                ss_data.input_tim_menu=bookMenuStart(ss_data.win, menuSetTimeAttributes(), (SHORT)CFTimeSet);//begin timer menu
            }
            else
            {
                //				TRACE_FUNCTION("SERVICES_INPUT_LEFT");
                SEND_EVENT(ss_data.win, ServicesDoCallDivert, 0, 0);//send calldivert command
            }
        }

        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        //			TRACE_EVENT("zy:servicegetnumber:INFO_KCD_HUP:");
        SEND_EVENT(ss_data.input_number_win, SERVICES_INPUT_DESTROY, 0, 0);
        ss_data.input_number_win = 0;
        break;
    default:
        break;
    }
    /*
    end of zy change 2003-02-19 
    */
}

/*******************************************************************************

 $Function:    	services_input_create
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/




static T_MFW_HND services_input_create(MfwHnd parent){


    T_MFW_WIN     * win_data;
    T_services_input *  data = (T_services_input *)ALLOC_MEMORY (sizeof (T_services_input));



    //	TRACE_FUNCTION ("services_input_create()");

    data->win = win_create (parent, 0, E_WIN_VISIBLE, (T_MFW_CB)services_input_win_cb);
    /* 2004/03/30 sunsj add */
    data->edt_input = edt_create(data->win,0,0,0);

    if( data->win EQ 0 )
        return 0;

    /*
     * Create window handler
     */
    data->mmi_control.dialog   = (T_DIALOG_FUNC)services_input;
    data->mmi_control.data     = data;
    win_data                   = ((T_MFW_HDR *)data->win)->data;
    win_data->user             = (void *)data;

    /*
     * return window handle
     */
    /*
    zy move 2003-02-19 needn't kbd we use editorwin
    */
    //data->kbd = kbdCreate(data->win,KEY_ALL,(MfwCb)services_input_kbd_cb);
    //data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)services_input_kbd_long_cb);
    /*
    end of zy chang 2003-02-19
    */
    data->parent_win = parent;

    winShow(data->win); /*2003/12/5, wangyan modify*/
    return data->win;

}


/*******************************************************************************

 $Function:    	services_input_destroy
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/





static void services_input_destroy(MfwHnd window){
    T_MFW_WIN     * win  = ((T_MFW_HDR *)window)->data;
    T_services_input * data = (T_services_input *)win->user;

    //	TRACE_FUNCTION ("services_input_destroy()");

    if( data )
    {
        // editDeactivate();
        /*
        zy 2003-02-19
        destory editor win because we set 
        editor.destoryflag=false,it will not destory by it self
        */
        editor_destroy(data->edt_input);

        winDelete (data->win);
        /*     * Free Memory
         */
        FREE_MEMORY ((void *)data, sizeof (T_services_input));
    }
}


/*******************************************************************************

 $Function:    	services_input_start
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static MfwHnd services_input_start(MfwHnd parent,T_input_properties *properties){


    T_MFW_HND win;

    // TRACE_FUNCTION ("services_input_start()");

    win = services_input_create (parent);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, SERVICES_INPUT_INIT, 0, properties);
    }
    return win;
}


/*******************************************************************************

 $Function:    	services_input
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void services_input (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_services_input     * data = (T_services_input *)win_data->user;

    T_input_properties* properties = (T_input_properties*) parameter;
    T_EDITOR_DATA editor_data;
    // TRACE_FUNCTION ("T_services_input()");
    /*begin of zy change 2003-02-19 use new editor*/
    switch( event )
    {
    case SERVICES_INPUT_INIT:
        editor_attr_init_fullscr(&editor_data.editor_attr,1,properties->text,ss_data.edt_buf_number,PHB_MAX_LEN,edtCurBar1);
        editor_data.min_enter            = 1;             
        editor_data.LeftSoftKey          = TxtConfirm;
        editor_data.AlternateLeftSoftKey = TxtSearchName;
        editor_data.RightSoftKey         = TxtDelete;   /* 2004/03/30 sunsj modify */
        editor_data.Callback             = (T_EDIT_CB)services_get_number_cb;
        editor_data.destroyEditor        = FALSE;//zy:needn't destory by editorwin itself because it still should could goto phonebook
        editor_data.mode                 = PHONENUMONLY_MODE;
        editor_data.hide                 = FALSE;
        editor_data.Identifier           = 0; 
        editor_data.TextString           = NULL;  
        editor_data.timeout              = FOREVER;  // Avoid to return empty strings
        editor_data.TextId               = '\0';

        data->edt_input = editor_start(data->win,&editor_data);
        winShow(data->edt_input);
        /*2003/12/4, wangyan modify*/
        /*end of zy change 2003-02-19*/
        break;
    case SERVICES_INPUT_DESTROY:
        //         TRACE_FUNCTION("SERVICES_INPUT_DESTROY");
        services_input_destroy(data->win);
        break;
    case DIVERT_PHBK_NUMBER:
        strncpy(ss_data.edt_buf_number, (char *)parameter, strlen((char *)parameter)+1);
        /*
        zy 2003-02-19 move needn't show 
        */
        /*data->properties.left_soft_key=TxtSoftOK;//wufei add 0910
          data->properties.right_soft_key=TxtDelete;
          winShow(data->win);*/
        /*
        zy end of zy change 2003-02-19 only show editor
        */
        break;
        //case ADD_CUG_NAME: //WUFEI APPEND
        //strncpy(ss_data.edt_buf_CUG_new_Name, (char *)parameter, strlen((char *)parameter)+1);
        //break;
        //case ADD_CUG_INDEX: //WUFEI APPEND
        //strncpy(ss_data.edt_buf_CUG_new_Index, (char *)parameter, strlen((char *)parameter)+1);
        //break;
    default:
        return;
    }

}

/*******************************************************************************

 $Function:    	services_input_win_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static int services_input_win_cb (MfwEvt e, MfwWin *w){

    T_services_input * data = (T_services_input *)w->user;
    MfwHdr *edit_hdr=(MfwHdr *)data->edt_input;
    MfwEdt *edit=(MfwEdt *)edit_hdr->data;

    int i =0;

    //    TRACE_FUNCTION ("services_input_win_cb()");

    switch( e )
    {
    case MfwWinVisible:
        /*zy move all 2003-02-19 because editor win will show*/
        //    dspl_ClearAll();
        // updateWindow(edit, 0);
        //edtShow(data->edt_input);
        //edtChar(data->edt_input, ecBottom); // zhang xiu ping 2002-12-25 5118
        //PROMPT(menuArea.px,menuArea.py,0,data->properties.text);
        //	displaySoftKeys(data->properties.left_soft_key,data->properties.right_soft_key);
        break;
    default:
        return 0;
    }

    return 1;

}
/*
zy 2003-02-19 move kbdcd because editor win will treat all kbdthings
*/

#if 0
/******************************WUFEI MODIFY*************************************************

 $Function:    	services_input_kbd_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static int services_input_kbd_cb (MfwEvt e, MfwKbd *k){


    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_services_input * data = (T_services_input *)win_data->user;

    TRACE_FUNCTION ("services_input_kbd_cb()");

    if( activeEditor() NEQ data->edt_input )
        editActivate(data->edt_input,data->properties.abc);
    switch( k->code )
    {
    case KCD_MNULEFT:
        edtChar(data->edt_input,ecLeft);
        break;
    case KCD_MNURIGHT:
        edtChar(data->edt_input,ecRight);
        break;
    case KCD_MNUUP:
        edtChar(data->edt_input,ecUp);
        break;
    case KCD_MNUDOWN:
        edtChar(data->edt_input,ecDown);
        break;
    case KCD_HASH:
        edtChar(data->edt_input,'#');
        break;
    case KCD_STAR:
        edtChar(data->edt_input, '*');
        break;
    case KCD_LEFT:
        TRACE_FUNCTION("left key pressed");
        if( strlen(data->properties.edt_attr_input->text) > 0 )
        {
            data->properties.callback(data->parent_win,SERVICES_INPUT_LEFT);
        }
        else
        {
            if( bookPhoneBookLoading()==BOOK_SUCCESS )
            {
                T_MFW_HND phbk_win;
                phbk_win = bookPhonebookStart(data->win,PhbkFromDivert);
                //data->properties.left_soft_key=TxtSoftOK;//wufei 0910
                //data->properties.right_soft_key=TxtDelete;
                //winShow(data->win);
            }
        }

        break;
    case KCD_HUP:
        /* if edit field is empty then exit, else delete one char */
        /*
        data->properties.callback(data->parent_win,SERVICES_INPUT_CLEAR);
        if (strlen(data->properties.edt_attr_input->text) > 0)
            {
                edtChar(data->edt_input,ecBack);
                
                if(strlen(data->properties.edt_attr_input->text) == 0)
                {
                    data->properties.left_soft_key=TxtPhonebook;  //hu binhao 2002-12-13
                    data->properties.right_soft_key=TxtSoftBack;
                }
                else
                {
                    data->properties.left_soft_key=TxtSoftOK;
                    data->properties.right_soft_key=TxtDelete;
                }
                winShow(data->win);
            }
        else
        */
        services_input_destroy(data->win);
        break;
    case KCD_RIGHT:
        // Check if there is a digit in the edit buffer softkey should be delete.
        if( strlen(data->properties.edt_attr_input->text) > 0 )
        {
            edtChar(data->edt_input,ecBack);
            if( strlen(data->properties.edt_attr_input->text) == 0 )
            {
                data->properties.left_soft_key=TxtSearchName;  //hu binhao 2002-12-13
                data->properties.right_soft_key=TxtSoftBack;
                winShow(data->win);
            }
        }
        else
        {
            // MZ 26/02/01 services_input_destroy(data->win);
            // Activate phone book .
            //if (bookPhoneBookLoading()==BOOK_SUCCESS)
            //{
            //T_MFW_HND phbk_win;
            //phbk_win = bookPhonebookStart(data->win,PhbkFromDivert);
            //}
            data->properties.callback(data->parent_win,SERVICES_INPUT_RIGHT);

        }

        break;
    default:
        if( k->code>9 )
            break;
        editEventKey (e,k);
        if( strlen(data->properties.edt_attr_input->text) > 0 )
        {
            data->properties.right_soft_key=TxtDelete;
            data->properties.left_soft_key=TxtSoftOK;
        }
        else
        {
            data->properties.right_soft_key=TxtSoftBack;
            data->properties.left_soft_key=TxtSearchName;  //hu binhao 2003-2-18
        }
        //winShow(data->win);
        displaySoftKeys(data->properties.left_soft_key,data->properties.right_soft_key);

        break;
    }
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	services_input_kbd_long_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/




static int services_input_kbd_long_cb (MfwEvt e, MfwKbd *k){

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_services_input * data = (T_services_input *)win_data->user;
    MfwHdr *edit_hdr=(MfwHdr *)data->edt_input;
    MfwEdt *edit=(MfwEdt *)edit_hdr->data;


    if( (e & KEY_RIGHT) && (e & KEY_LONG) )
    {
        if( edit->attr->text[0] NEQ '\0' )
        {
            memset(edit->attr->text, 0, sizeof(edit->attr->text));                      
            edtShow(data->edt_input);
            edtChar(data->edt_input, ecTop);
        }

        //edtClear(data->edt_input);
        //else services_input_destroy(data->win);
        return MFW_EVENT_CONSUMED;
    }
    if( e & KEY_LONG )
    {
        if( e & KEY_0 )
        {
            edtChar(data->edt_input, ecBack);
            edtChar(data->edt_input, '+');
            return MFW_EVENT_CONSUMED;
        }
        if( e & KEY_HASH )
        {
            edtChar(data->edt_input, ecBack);
            edtChar(data->edt_input, 'P');
            return MFW_EVENT_CONSUMED;
        }

    }

    return  MFW_EVENT_CONSUMED;
}



#endif


/*******************************************************************************

 $Function:    	servicesCallBarringCheck
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesCallBarringCheck(void)
{
    char SS_string[60] = {'\0'};

    //  TRACE_FUNCTION("servicesCallBarringCheck");

    CBAction = CBCheck;

    getCBAction(SS_string);
    getCBType(SS_string);
    SS_string[strlen(SS_string)-1] = '#';

    //   TRACE_FUNCTION(SS_string);

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );

}

/*******************************************************************************

 $Function:    	servicesCallBarringDeactivate
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void servicesCallBarringDeactivate(void)
{
    char SS_string[60] = {'\0'};

    //  TRACE_FUNCTION("servicesCallBarringDeactivate");

    CBAction = CBDeactivate;

    getCBAction(SS_string);
    getCBType(SS_string);
    getCBPassword(SS_string);
    SS_string[strlen(SS_string)-1] = '#';

    //  TRACE_FUNCTION(SS_string);

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );

}

/*******************************************************************************

 $Function:    	servicesCallBarringActivate
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesCallBarringActivate(void)
{
    char SS_string[60] = {'\0'};

    //  TRACE_FUNCTION("servicesCallBarringDeactivate");

    CBAction = CBActivate;

    getCBAction(SS_string);
    getCBType(SS_string);
    getCBPassword(SS_string);
    SS_string[strlen(SS_string)-1] = '#';


    //  TRACE_FUNCTION(SS_string);

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );

}


/*******************************************************************************

 $Function:    	servicesCallBarringCancelAll
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void servicesCallBarringCancelAll(void)
{
    char SS_string[60] = {'\0'};

    // TRACE_FUNCTION("servicesCallBarringCancelAll");


    strcat(SS_string, "#330*");
    getCBPassword(SS_string);
    SS_string[strlen(SS_string)-1] = '#';

    //   TRACE_FUNCTION(SS_string);

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );

}


/*******************************************************************************

 $Function:    	getCBAction
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void getCBAction(char * pSSstring)
{
    switch( CBAction )
    {
    case CBActivate:
        strcpy(pSSstring, "*");
        break;
    case CBDeactivate:
        strcpy(pSSstring, "#");
        break;
    case CBCheck:
        strcpy(pSSstring, "*#");
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	getCBType
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void getCBType(char* pSSstring)
{


    switch( CBType )
    {
    case CBAllOutgoing:
        strcat(pSSstring, "33*");
        break;
    case CBInternational:
        strcat(pSSstring, "331*");
        break;
    case CBAllIncoming:
        strcat(pSSstring, "35*");
        break;
    case CBInternationalHome:
        strcat(pSSstring, "332*");
        break;
    case CBIncomingRoaming:
        strcat(pSSstring, "351*");
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	getCBPassword
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


static void getCBPassword(char* pSSstring)
{
    strcat(pSSstring, (char*)ss_data.edt_buf_cb_password);
    strcat(pSSstring, "*");
}

/*******************************************************************************

 $Function:    	requestCBPassword
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



void requestCBPassword(void)
{

    T_EDITOR_DATA editor_data;

    //SPR#1014 - DS - Reset editor data
    memset(&editor_data, '\0', sizeof(editor_data));
    /*               
     * Setup an editor to display a string                
     */ 

    memset(ss_data.edt_buf_cb_password,'\0',sizeof(ss_data.edt_buf_cb_password));
    bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
                           (char*)ss_data.edt_buf_cb_password,CB_PSW_LEN+3, &editor_data.editor_attr ); //wufei moidify 0813 orignal value is 0 18 84 28 and CB_PSW_LEN+1
    editor_data.LeftSoftKey          = TxtSoftOK;               
    editor_data.AlternateLeftSoftKey = TxtNull;                
    editor_data.RightSoftKey         = TxtSoftBack;               
    editor_data.hide                 = TRUE;               
    editor_data.mode                 = DIGITS_MODE;                
    editor_data.timeout              = FOREVER;                
    editor_data.Identifier           = CBCheckPassword;   
    editor_data.destroyEditor        = TRUE;
    editor_data.Callback   = (T_EDIT_CB)CB_password_cb;               
    editor_data.TextId = TxtPassword;
    editor_data.TextString       =   NULL;
    editor_data.min_enter  = CB_PSW_LEN;                                                                 
    //editor_data.destroyEditor = TRUE;
    ss_data.info_win = editor_start(ss_data.win, &editor_data);               

}

/*******************************************************************************

 $Function:    	CB_password_cb
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/



static void CB_password_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{

    switch( identifier )
    {
    case CBCheckPassword:
        ss_data.info_win = 0;
        //ss_data.cb_menu_win      = bookMenuStart( ss_data.win, bookCallBarringMenuAttributes(), NULL);
        //ss_data.info_win = 0;
        switch( reason )
        {
        case INFO_KCD_LEFT:
            ss_data.cb_menu_win = bookMenuStart( ss_data.win, bookCallBarringMenuAttributes(), NULL);
            break;//wufei 0904
        case INFO_KCD_HUP:
            bookMenuDestroy(ss_data.cb_menu_win);
            break;
        default:
            break;
        }
        break;              
    case CBNewPassword:
        ss_data.info_win = 0;
        switch( reason )
        {
        case INFO_KCD_LEFT:
            confirmNewCBPassword();
            break;
        default:
            break;
        }
        break;
    case CBConfirmNewPassword:
        ss_data.info_win = 0;
        switch( reason )
        {
        case INFO_KCD_LEFT:
            changeCBPassword();
            break;
        default:
            break;
        }
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	enterNewCBPassword
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void enterNewCBPassword(void)
{

    T_EDITOR_DATA editor_data;

    memset(ss_data.edt_buf_cb_password,'\0',sizeof(ss_data.edt_buf_cb_password));
    bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
                           (char*)ss_data.edt_buf_cb_password,CB_PSW_LEN+3, &editor_data.editor_attr );//wufei modied 0813
    editor_data.LeftSoftKey          = TxtSoftOK;               
    editor_data.AlternateLeftSoftKey = TxtNull;                
    editor_data.RightSoftKey         = TxtDelete;               
    editor_data.hide                 = TRUE;               
    editor_data.mode                 = DIGITS_MODE;                
    editor_data.timeout              = FOREVER;                
    editor_data.Identifier           = CBNewPassword;  
    editor_data.destroyEditor        = TRUE;
    editor_data.Callback   = (T_EDIT_CB)CB_password_cb;               
    editor_data.TextId = TxtNewPassword;
    editor_data.TextString       =   NULL;
    editor_data.min_enter  = CB_PSW_LEN;                                                                 
    editor_data.destroyEditor = TRUE;
    ss_data.info_win = editor_start(ss_data.win, &editor_data);              


    /*memset(ss_data.edt_buf_cb_new_password,'\0',sizeof(ss_data.edt_buf_cb_new_password));
    bookSetEditAttributes( 0, 8, 84 , 9, 0, 0, edtCurBar1, 0, 
        (char*)ss_data.edt_buf_cb_password,CB_PSW_LEN+1, &editor_data.editor_attr );
     editor_data.LeftSoftKey          = TxtSoftOK;               
     editor_data.AlternateLeftSoftKey = TxtNull;                
     editor_data.RightSoftKey         = TxtDelete;               
     editor_data.hide                 = TRUE;               
     editor_data.mode                 = DIGITS_MODE;                
     editor_data.timeout              = FOREVER;                
     editor_data.Identifier           = CBNewPassword;  
     editor_data.destroyEditor        = TRUE;
     editor_data.Callback   = (T_EDIT_CB)CB_password_cb;               
     editor_data.TextId = TxtNewPassword;
     editor_data.TextString       =   NULL;
     editor_data.min_enter  = CB_PSW_LEN; 							 	               					  
     editor_data.destroyEditor = TRUE;
     ss_data.info_win = editor_start(ss_data.win, &editor_data);  */             

}

/*******************************************************************************

 $Function:    	confirmNewCBPassword
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void confirmNewCBPassword(void)
{

    T_EDITOR_DATA editor_data;

    memset(ss_data.edt_buf_cb_password,'\0',sizeof(ss_data.edt_buf_cb_password));
    bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
                           (char*)ss_data.edt_buf_cb_password,CB_PSW_LEN+3, &editor_data.editor_attr ); //wufei modified 0813
    editor_data.LeftSoftKey          = TxtSoftOK;               
    editor_data.AlternateLeftSoftKey = TxtNull;                
    editor_data.RightSoftKey         = TxtDelete;               
    editor_data.hide                 = TRUE;               
    editor_data.mode                 = DIGITS_MODE;                
    editor_data.timeout              = FOREVER;                
    editor_data.Identifier           = CBConfirmNewPassword;  
    editor_data.destroyEditor        = TRUE;
    editor_data.Callback   = (T_EDIT_CB)CB_password_cb;               
    editor_data.TextId = TxtConfirmPassword;
    editor_data.TextString       =   NULL;
    editor_data.min_enter  = CB_PSW_LEN;                                                                 
    editor_data.destroyEditor = TRUE;
    ss_data.info_win = editor_start(ss_data.win, &editor_data);              

    /*	memset(ss_data.edt_buf_cb_conf_new_password,'\0',sizeof(ss_data.edt_buf_cb_conf_new_password));
        bookSetEditAttributes( 0, 8, 84 , 9, 0, 0, edtCurBar1, 0, 
            (char*)ss_data.edt_buf_cb_password,CB_PSW_LEN+1, &editor_data.editor_attr );
         editor_data.LeftSoftKey          = TxtSoftOK;               
         editor_data.AlternateLeftSoftKey = TxtNull;                
         editor_data.RightSoftKey         = TxtDelete;               
         editor_data.hide                 = TRUE;               
         editor_data.mode                 = DIGITS_MODE;                
         editor_data.timeout              = FOREVER;                
         editor_data.Identifier           = CBConfirmNewPassword;  
         editor_data.destroyEditor        = TRUE;
         editor_data.Callback   = (T_EDIT_CB)CB_password_cb;               
         editor_data.TextId = TxtConfirmPassword;
         editor_data.TextString       =   NULL;
         editor_data.min_enter  = CB_PSW_LEN; 							 	               					  
         editor_data.destroyEditor = TRUE;
         ss_data.info_win = editor_start(ss_data.win, &editor_data);    */           

}

/*******************************************************************************

 $Function:    	changeCBPassword
 
 $Description:	
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/


void changeCBPassword(void){

    char SS_string[60] = {'\0'};

    //  TRACE_FUNCTION("changeCBPassword");


    strcat(SS_string, "**03*330*");
    strcat(SS_string,(char*)ss_data.edt_buf_cb_password);
    strcat(SS_string,"*");
    strcat(SS_string,(char*)ss_data.edt_buf_cb_new_password);
    strcat(SS_string,"*");
    strcat(SS_string,(char*)ss_data.edt_buf_cb_conf_new_password);
    strcat(SS_string,"#");

    //  TRACE_FUNCTION(SS_string);

    if( ss_execute_transaction((UBYTE*)SS_string, 0) == MFW_SS_FAIL )
        showFailed( ss_data.win );


}


//-------------------------------------wufei add---------------------------------------------------

/*****************************WUFEI APPEND***********************/

void servicesDoCUGSetting(void)
{
    //	TRACE_FUNCTION("servicesDoUsedNumber");
    SEND_EVENT(ss_data.win, ServicesCUGSetting, 0, 0);
}





/**********************************WUFEI APPEND********************************
$Function: servicesGetUsedNumber
$Description:
$Returns:
$Arguments:
********************************************************************************/
static void ServicesCUGMenu(void)
{

    T_MFW_HND win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());

    //recources_Init (win);

    //Create 0.5 second ringer delay timer.
    //hRingerStartTimer = timCreate( 0, TIMHALFSECOND, (MfwCb)playCurrentSound);

    win = buildCUGMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }


}   

/********************************WUFEI***********************************************

 $Function:     buildUsedNumberMenu

 $Description:  Builds the cugnumber menu dynamenu from the melodies supplied
        by the resource manager

 $Returns:    None

 $Arguments:  None

*******************************************************************************/
static T_MFW_HND  buildCUGMenu( MfwHnd parent_window)
{
    T_CUG_INFO *  data = (T_CUG_INFO *)ALLOC_MEMORY (sizeof (T_CUG_INFO));
    T_MFW_WIN  * win;

    //   TRACE_EVENT (">>>> buildCUGMenu()");

    /*
     * Create window handler
     */

    data->cug_win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)cug_win_cb);
    if( data->cug_win EQ NULL )
    {
        return NULL;
    }

    // TRACE_EVENT(">>>> CUG window created: " );
    /*
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)cug_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->cug_win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
    winShow(data->cug_win);
    /*
     * return window handle
     */

    return data->cug_win;
}

/*****************************WUFEI**************************************************

 $Function:     numbers_exec_cb

 $Description:  Exec callback function of the cug window (dynamic list of
        all the cug number and other menu items)

 $Returns:    none

 $Arguments:  win - window handler
        event - mfw event
        parameter - optional data.

*******************************************************************************/
void cug_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_CUG_INFO   * data = (T_CUG_INFO *)win_data->user;
    UBYTE i;
    UBYTE n;
    ListWinInfo      * mnu_data = (ListWinInfo *)parameter;
    char srcCugNameStr[10];
    ////flash_read();//Add for Test

    //   TRACE_EVENT (">>>>> cug_exec_cb()");

    switch( event )
    {
    case E_INIT:

        //   TRACE_EVENT(">>>> cug_exec_cb() Event:E_INIT");

        /* initialization of administrative data */


        data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

        if( data->menu_list_data == 0 )
        {
            TRACE_EVENT("Failed memory alloc 1 ");
            return;
        }
        //flash_DCTbread();	//hxl moved this to ffsfile_init 2002-11-26
        n = usednumber_GetListCount(RES_GROUPEDNUMBER);
        data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( (n+2) * sizeof(T_MFW_MNU_ITEM) );
        if( data->menu_list_data->List == 0 )
        {
            //    TRACE_EVENT("Failed memory alloc 2");
            return;
        }
        if( n!=0 )
        {

            for( i = 0; i < n ; i++ )
            {
                data->menu_list_data->List[i].icon = 0;
                data->menu_list_data->List[i].exta = 0;
                data->menu_list_data->List[i].edit = 0;
                data->menu_list_data->List[i].menu = 0;
                data->menu_list_data->List[i].func = NULL;//530
                ///// memset(DCTbVar[i],'\0',21);
                ///// strcpy(DCTbVar[i],(char *)FlashDCTbData.GroupedNumber[i]);
                memset(DCTbVar[i],'\0',40);
#ifdef CHINESE_MMI     
                memset(srcCugNameStr,'\0',10);
                strcpy(srcCugNameStr,(char *)FlashDCTbData.GroupedNumber[i]);
                ChangeToUcs2(srcCugNameStr,DCTbVar[i]);
#else
                strcpy(DCTbVar[i],(char *)FlashDCTbData.GroupedNumber[i]);
#endif
                data->menu_list_data->List[i].str  = (char *)(TxtDCTbVar0+i);
                data->menu_list_data->List[i].flagFunc = item_flag_none;
            }
        }
        data->menu_list_data->List[n].icon = 0;
        data->menu_list_data->List[n].exta = 0;
        data->menu_list_data->List[n].edit = 0;
        data->menu_list_data->List[n].menu = 0;
        data->menu_list_data->List[n].func = NULL;
        data->menu_list_data->List[n].str  = (char*)TxtAddCUG;//
        data->menu_list_data->List[n].flagFunc = item_flag_none;
        data->menu_list_data->List[n+1].icon = 0;
        data->menu_list_data->List[n+1].exta = 0;
        data->menu_list_data->List[n+1].edit = 0;
        data->menu_list_data->List[n+1].menu = 0;
        data->menu_list_data->List[n+1].func = NULL;
        data->menu_list_data->List[n+1].str = (char*)TxtPreDefine;//Ԥ
        data->menu_list_data->List[n+1].flagFunc = item_flag_none;
        data->menu_list_data->ListLength =n+2;
        data->menu_list_data->ListPosition = 1;
        data->menu_list_data->CursorPosition = 1;
        data->menu_list_data->SnapshotSize = n+2;
        data->menu_list_data->Font = 0;
        data->menu_list_data->LeftSoftKey = TxtSoftSelect;
        data->menu_list_data->RightSoftKey = TxtSoftBack;
        data->menu_list_data->KeyEvents = KEY_ALL;
        data->menu_list_data->Reason = 0;
        data->menu_list_data->Strings = FALSE;
        data->menu_list_data->Attr   = &UsedNumber_menuAttrib;
        data->menu_list_data->autoDestroy    = FALSE;
        listDisplayListMenu(win, data->menu_list_data,(ListCbFunc)CUGList_cb,0);

        break;
    case E_UPDATE:
        listsDestroy(data->menu_list_data->win);
        FREE_MEMORY ((void *)data->menu_list_data->List, (listlen) * sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
        SEND_EVENT(cugwindows,E_INIT,0,0);
        break;

    case E_EXIT:
        //stop playing the melody stopPlayingMelody();
        listsDestroy(data->menu_list_data->win);  
        cugWin_destroy(data->cug_win);
        break;
    default:
        break;

    }
}

/***********************************WUFEI APPEND*******************************
$Function: UsedNumberList_cb
$Description:
$Return:
$Description:
********************************************************************************/
static void CUGList_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_CUG_INFO * data     = (T_CUG_INFO *)win_data->user;
    T_MFW_HND      * l_parent;
    UBYTE Reason;
    UBYTE ListLength,ListPosition;
    Reason=ListData->Reason;
    ListLength=ListData->ListLength;
    ListPosition=ListData->ListPosition;
    if( (Reason EQ LISTS_REASON_BACK) || (Reason EQ LISTS_REASON_CLEAR)
        || (Reason EQ LISTS_REASON_HANGUP) )
    {
        l_parent = data->parent;
        listsDestroy(ListData->win); 
        cugWin_destroy(data->cug_win);
    }
    else if( (Reason EQ LISTS_REASON_SELECT) || (Reason EQ LISTS_REASON_OK) )     //xsf add for list menu KCD_OK=KCD_LEFT 2003.03.10
    {

        if( ListLength>2 && ((ListPosition)<(ListLength-2)) )//530
        {
            cugListPosition=ListPosition;               
            cugwindows=data->cug_win;               
            listlen=ListLength;
            cugNameSubMnu();
        }
        else
        {
            if( ListPosition EQ (ListLength-2) )
            {
                cugwindows=data->cug_win;
                listlen=ListLength;
                AddCUGName(0);
            }
            else
            {
                //cugwindows=data->cug_win;
                //listlen=ListLength;
                PreDefinedCUG();
                listsDestroy(ListData->win); 
                cugWin_destroy(data->cug_win);
            }
        }

    }



}


/*******************************WUFEI************************************************

 $Function:     cugWin_destroy

 $Description:  Destroy the cug window.

 $Returns:    none

 $Arguments:  own_window- current window
*******************************************************************************/

static void cugWin_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_CUG_INFO     * data;
    UBYTE n;

    TRACE_EVENT ("cugWin_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_CUG_INFO *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */
            win_delete (data->cug_win);

            /*
             * Free Memory
             */

            n = usednumber_GetListCount(RES_GROUPEDNUMBER);

            if( data->menu_list_data != NULL )
            {
                FREE_MEMORY ((void *)data->menu_list_data->List, (n+2) * sizeof (T_MFW_MNU_ITEM));
                FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
            }
            FREE_MEMORY ((void *)data, sizeof (T_CUG_INFO));

        }
        else
        {
            //        TRACE_EVENT ("cugWin_destroy() called twice");
        }
    }
}

/**************************************WUFEI*****************************************

 $Function:     cug_win_cb

 $Description:  Window callback function for the cug window.

 $Returns:    none

 $Arguments:  w - mfw window handler
        e - mfw event

*******************************************************************************/

static int cug_win_cb (MfwEvt e, MfwWin *w)    /* yyy window event handler */
{
    //  TRACE_EVENT ("cug_win_cb()");
    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */

    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}


int cugNameSubMnu(void)
{
    T_MFW_WIN *win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    T_CUG_INFO   * data= (T_CUG_INFO *)ALLOC_MEMORY (sizeof (T_CUG_INFO));
    UBYTE n;

    data->cug_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)cug_win_cb);
    if( data->cug_win EQ NULL )
    {
        return NULL;
    }

    data->mmi_control.dialog = NULL;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->cug_win)->data;
    win->user                = (void *)data;
    data->parent             = parent_win;
    winShow(data->cug_win);

    data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

    if( data->menu_list_data == 0 )
    {
        //    TRACE_EVENT("Failed memory alloc 1 ");
        return;
    }
    data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( 4 * sizeof(T_MFW_MNU_ITEM) );
    if( data->menu_list_data->List == 0 )
    {
        //      TRACE_EVENT("Failed memory alloc 2");
        return;
    }

    for( n = 0; n < 4 ; n++ )                               /* with these items         */
    {
        data->menu_list_data->List[n].icon = 0;
        data->menu_list_data->List[n].exta = 0;
        data->menu_list_data->List[n].edit = 0;
        data->menu_list_data->List[n].menu = 0;
        data->menu_list_data->List[n].func = NULL;
        data->menu_list_data->List[n].flagFunc = item_flag_none;
    }
    data->menu_list_data->List[0].str = (char *)TxtSelect;
    data->menu_list_data->List[1].str = (char *)TxtModify;
    data->menu_list_data->List[2].str = (char *)TxtDelete;
    data->menu_list_data->List[3].str = (char *)TxtDeleteAll;
    data->menu_list_data->ListLength =4;
    data->menu_list_data->ListPosition = 1;
    data->menu_list_data->CursorPosition = 1;
    data->menu_list_data->SnapshotSize = 4;
    data->menu_list_data->Font = 0;
    data->menu_list_data->LeftSoftKey = TxtSoftSelect;
    data->menu_list_data->RightSoftKey = TxtSoftBack;
    data->menu_list_data->KeyEvents = KEY_ALL;
    data->menu_list_data->Reason = 0;
    data->menu_list_data->Strings = FALSE;
    data->menu_list_data->Attr   = &UsedNumber_menuAttrib;
    data->menu_list_data->autoDestroy    = FALSE;
    listDisplayListMenu(data->cug_win, data->menu_list_data,(ListCbFunc)CUGSubList_cb,0);
}

static void CUGSubList_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_CUG_INFO * data     = (T_CUG_INFO *)win_data->user;
    char* settedIdx;
    if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
        || (ListData->Reason EQ LISTS_REASON_HANGUP) )
    {

        listsDestroy(ListData->win); 
        win_delete (data->cug_win);
        FREE_MEMORY ((void *)data->menu_list_data->List, 4 * sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
        FREE_MEMORY ((void *)data, sizeof (T_CUG_INFO));
    }
    else if( (ListData->Reason EQ LISTS_REASON_SELECT) || (ListData->Reason EQ LISTS_REASON_OK) )     //xsf add for list menu KCD_OK=KCD_LEFT 2003.03.10
    {
        UBYTE i,idx;
        UBYTE n = usednumber_GetListCount(RES_GROUPEDNUMBER);
        T_MFW_SS_CUG_PARA *cugPara;
        i=ListData->ListPosition;
        switch( i )
        {
        case 0:
            cugPara->mode=MFW_SS_CUG_TMP_ENABLE;
            cugPara->info=MFW_SS_CUG_SUPP_PREF; 
            cugPara->index=(int)FlashDCTbData.SettedCUGIndex[cugListPosition]-48;
            if( cugPara->index )
            {
                if( ss_set_cug(cugPara) EQ MFW_SS_OK )
                {
                    services_info_screen(win,TxtDone);


                }
                else
                {
                    services_info_screen(win,TxtFailed);

                }
            }
            else
            {
                services_info_screen(win,TxtFailed);

            }

            //SEND_EVENT(cugwindows,E_UPDATE,0,0);
            break;
        case 1:
            AddCUGName(FlashDCTbData.GroupedNumber[cugListPosition]);

            break;
        case 2:
            cugPara->mode=MFW_SS_CUG_TMP_DISABLE;
            cugPara->info=MFW_SS_CUG_SUPP_PREF; 
            cugPara->index=(int)FlashDCTbData.SettedCUGIndex[cugListPosition]-48;
            if( ss_set_cug(cugPara) EQ MFW_SS_OK )
            {
                memset((char*)FlashDCTbData.GroupedNumber[cugListPosition],'\0',strlen((char*)FlashDCTbData.GroupedNumber[cugListPosition]));
                memset((char*)FlashDCTbData.SettedCUGIndex[cugListPosition],'\0',strlen((char*)FlashDCTbData.SettedCUGIndex[cugListPosition]));
                for( idx=cugListPosition;idx<n-1;idx++ )
                    strcpy((char*)FlashDCTbData.GroupedNumber[idx],(char*)FlashDCTbData.GroupedNumber[idx+1]);
                memset((char*)FlashDCTbData.GroupedNumber[n-1],'\0',9);         
                for( idx=cugListPosition;idx<n-1;idx++ )
                    strcpy((char*)FlashDCTbData.SettedCUGIndex[idx],(char*)FlashDCTbData.SettedCUGIndex[idx+1]);
                memset((char*)FlashDCTbData.SettedCUGIndex[n-1],'\0',2);
                flash_DCTbwrite();
                //services_info_screen(win,TxtDone);				
                SEND_EVENT(cugwindows,E_UPDATE,0,0);
                services_info_screen(win,TxtDone);
            }
            else
            {
                services_info_screen(win,TxtFailed);
            }
            break;
        case 3:
            cugPara->mode=MFW_SS_CUG_TMP_DISABLE;
            cugPara->info=MFW_SS_CUG_SUPP_PREF; 
            for( idx=0;idx<n;idx++ )
            {
                cugPara->index=(int)FlashDCTbData.SettedCUGIndex[i]-48;
                ss_set_cug(cugPara);

            }               
            memset((char*)FlashDCTbData.GroupedNumber,'\0',n*9);
            memset((char*)FlashDCTbData.SettedCUGIndex,'\0',n*2);
            flash_DCTbwrite();
            //services_info_screen(win,TxtDone);
            SEND_EVENT(cugwindows,E_UPDATE,0,0);
            services_info_screen(win,TxtDone);  
            break;          
        }
        listsDestroy(ListData->win); 
        win_delete (data->cug_win);
        FREE_MEMORY ((void *)data->menu_list_data->List, 4 * sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
        FREE_MEMORY ((void *)data, sizeof (T_CUG_INFO));

    }


}


void AddCUGName(uint8* name)
{   T_EDITOR_DATA editor_data;  
    memset(ss_data.edt_buf_CUG_new_Name,'\0',sizeof(ss_data.edt_buf_CUG_new_Name));
    if( name ) //wufei add 0813
    {
        editor_data.Identifier = CUGNameMod;        
        strcpy(ss_data.edt_buf_CUG_new_Name,(char*)name);
    }
    else
    {
        editor_data.Identifier = CUGName;
    }
    bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
                           (char*)ss_data.edt_buf_CUG_new_Name,11, &editor_data.editor_attr );//wufei modified 0813 orignal value is 0 18 84 28 the user can only input (11-3)=8 numbers
    editor_data.LeftSoftKey          = TxtSoftOK;               
    editor_data.AlternateLeftSoftKey = TxtNull;                
    editor_data.RightSoftKey         = TxtDelete;               
    editor_data.hide                 = FALSE;               
    editor_data.mode                 = ALPHA_MODE;                
    editor_data.timeout              = FOREVER;
    editor_data.destroyEditor        = TRUE;
    editor_data.Callback   = (T_EDIT_CB)CUG_Add_cb;               
    editor_data.TextId = TxtEnterName;
    editor_data.TextString       = NULL;
    editor_data.min_enter  = 1; 
    ss_data.info_win = editor_start(ss_data.win, &editor_data);              


}

static void CUG_Add_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
    UBYTE n;
    T_MFW_SS_CUG_PARA *cugPara;
    UBYTE cug_Index;
    UBYTE idx;
    //MfwEdt  *edt = ((T_MFW_HDR      *)(data->edt_edt))->data;
    switch( identifier )
    {
    case CUGCheck:
        //    ss_data.cb_menu_win      = bookMenuStart( ss_data.win, bookCallBarringMenuAttributes(), NULL);
        //	ss_data.info_win = 0;
        //	switch (reason)				
        //	{
        //	    case INFO_KCD_HUP:
        //			bookMenuDestroy(ss_data.cb_menu_win);
        //	    break;
        //	    default:
        //	    break;
        //	}
        break;              
    case CUGName:
        if( ss_data.info_win )
        {
            SEND_EVENT(ss_data.info_win, DIALOG_DESTROY, 0, 0);
            ss_data.info_win=0;
        }
        switch( reason )
        {
        case INFO_KCD_LEFT:                         
            //n = usednumber_GetListCount(RES_GROUPEDNUMBER);
            //strcpy(GroupedNumber[n],ss_data.edt_buf_CUG_new_Name);
            AddCUGIndex(0);
            break;
        default:
            break;
        }
        break;

    case CUGNameMod:
        if( ss_data.info_win )
        {
            SEND_EVENT(ss_data.info_win, DIALOG_DESTROY, 0, 0);
            ss_data.info_win=0;
        }
        switch( reason )
        {
        case INFO_KCD_LEFT:
            AddCUGIndex(FlashDCTbData.SettedCUGIndex[cugListPosition]);
            break;
        default:
            break;
        }
        break;

    case CUGIndex:
        if( ss_data.info_win )
        {
            SEND_EVENT(ss_data.info_win, DIALOG_DESTROY, 0, 0);
            ss_data.info_win=0;
        }
        switch( reason )
        {
        case INFO_KCD_LEFT:
            //T_MFW_SS_CUG_PARA *cugPara;
            //int cug_Index;
            n = usednumber_GetListCount(RES_GROUPEDNUMBER);
            if( n<10 )
            {
                //while(cmp AND i<n)
                //{
                //	if(strcmp((char*)FlashDCTbData.GroupedNumber[i],ss_data.edt_buf_CUG_new_Name)==0
                //		cmp=0;
                //	i++;
                //}
                memset((char*)FlashDCTbData.GroupedNumber[n],'\0',(10-n)*9);
                memset((char*)FlashDCTbData.SettedCUGIndex[n],'\0',(10-n)*2);
                cug_Index=atoi(ss_data.edt_buf_CUG_new_Index);                              
                if( cug_Index<10 )
                {
                    cugPara->mode=MFW_SS_CUG_TMP_ENABLE;
                    cugPara->info=MFW_SS_CUG_SUPP_PREF;                     
                    cugPara->index=cug_Index;
                    if( ss_set_cug(cugPara) EQ MFW_SS_OK )
                    {
                        strcpy((char*)FlashDCTbData.GroupedNumber[n],ss_data.edt_buf_CUG_new_Name);
                        strcpy((char*)FlashDCTbData.SettedCUGIndex[n],ss_data.edt_buf_CUG_new_Index);
                        flash_DCTbwrite();
                        services_info_screen(win,TxtDone);
                        SEND_EVENT(cugwindows,E_UPDATE,0,0);    
                    }
                    else
                        services_info_screen(win,TxtFailed);
                }
                else
                    services_info_screen(win,TxtOutofRange);


            }
            else
            {

                services_info_screen(win,TxtFull);
            }

            break;
        default:
            break;
        }
        //listsDestroy(Listwindows);  //wufei modified 0827
        //cugWin_destroy(cugwindows); //wufei modified 0827
        break;

    case CUGIndexMod:
        if( ss_data.info_win )
        {
            SEND_EVENT(ss_data.info_win, DIALOG_DESTROY, 0, 0);
            ss_data.info_win=0;
        }
        switch( reason )
        {
        case INFO_KCD_LEFT:
            cug_Index=atoi(ss_data.edt_buf_CUG_new_Index);
            if( cug_Index<10 )
            {
                cugPara->mode=MFW_SS_CUG_TMP_ENABLE;
                cugPara->info=MFW_SS_CUG_SUPP_PREF;                     
                cugPara->index=cug_Index;

                if( ss_set_cug(cugPara) EQ MFW_SS_OK )
                {
                    memset((char*)FlashDCTbData.GroupedNumber[cugListPosition],'\0',9);
                    memset((char*)FlashDCTbData.SettedCUGIndex[cugListPosition],'\0',2);
                    strcpy((char*)FlashDCTbData.GroupedNumber[cugListPosition],ss_data.edt_buf_CUG_new_Name);
                    strcpy((char*)FlashDCTbData.SettedCUGIndex[cugListPosition],ss_data.edt_buf_CUG_new_Index);
                    flash_DCTbwrite();
                    //services_info_screen(win,TxtDone);
                    SEND_EVENT(cugwindows,E_UPDATE,0,0);
                    services_info_screen(win,TxtDone);  
                }
                else
                {
                    services_info_screen(win,TxtFailed);
                }
            }
            else
                services_info_screen(win,TxtOutofRange);

            break;
        default:
            break;
        }               
        break;  

    default:
        break;
    }
}

void AddCUGIndex(uint8* index)
{

    T_EDITOR_DATA editor_data;
    memset(ss_data.edt_buf_CUG_new_Index,'\0',sizeof(ss_data.edt_buf_CUG_new_Index));
    if( index ) //wufei add 0813
    {
        editor_data.Identifier = CUGIndexMod;       
        strcpy(ss_data.edt_buf_CUG_new_Index,(char*)index);
    }
    else
    {
        editor_data.Identifier = CUGIndex;
    }
    bookSetEditAttributes( 0, 38, 100, 58, 0, 0, edtCurBar1, 0, 
                           (char*)ss_data.edt_buf_CUG_new_Index,4, &editor_data.editor_attr );//wufei modified 0813 the user can only input (4-3)=1 number
    editor_data.LeftSoftKey          = TxtSoftOK;               
    editor_data.AlternateLeftSoftKey = TxtNull;                
    editor_data.RightSoftKey         = TxtDelete;               
    editor_data.hide                 = FALSE;               
    editor_data.mode                 = DIGITS_MODE;                
    editor_data.timeout              = FOREVER;
    editor_data.destroyEditor        = TRUE;
    editor_data.Callback   = (T_EDIT_CB)CUG_Add_cb;               
    editor_data.TextId = TxtEnterIndex;
    editor_data.TextString       =   NULL;
    editor_data.min_enter  = 1;
    ss_data.info_win = editor_start(ss_data.win, &editor_data);              


}

void PreDefinedCUG(void)
{
    T_MFW_SS_CUG_PARA *cugPara;
    cugPara->mode=MFW_SS_CUG_TMP_ENABLE;
    cugPara->info=MFW_SS_CUG_SUPP_PREF;                     
    cugPara->index=MFW_SS_CUG_NO_INDEX; 
    if( ss_set_cug(cugPara) EQ MFW_SS_OK )
    {

        services_info_screen(win,TxtDone);
    }
    else
    {
        services_info_screen(win,TxtFailed);
    }
}

void ChangeToUcs2(char* srcStr, char * Ucs2Str)
{
    int i;
    Ucs2Str[0]=0x80;
    for( i=0;i<strlen(srcStr);i++ )
    {
        Ucs2Str[2*i+1]=0x00;
        Ucs2Str[2*(i+1)]=srcStr[i];
    }
    Ucs2Str[2*i+1]=0x00;
    Ucs2Str[2*i+2]=0x00;
    Ucs2Str[2*i+3]=0x00;

}

/**************wufei add 0928***********************************************/
/**********************************WUFEI APPEND********************************
$Function: servicesGetUsedNumber
$Description:
$Returns:
$Arguments:
********************************************************************************/

/**************************add for shortcut menu**************************/
T_MFW_HND GetLMNrecordStart(T_MFW_HND parent_win)
{

    T_MFW_HND win;
    // T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LMN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return win;
}
T_MFW_HND GetLJNrecordStart(T_MFW_HND parent_win)
{

    T_MFW_HND win;
    // T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LJN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return win;
}
T_MFW_HND GetLRNrecordStart(T_MFW_HND parent_win)
{

    T_MFW_HND win;
    //T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LRN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return win;
}

T_MFW_HND  GetLDNrecordStart(T_MFW_HND parent_win)
{

    T_MFW_HND win;
    // T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LDN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return win;
}
/*****************************end of adding****************************/


int GetLMNrecord(void)
{

    T_MFW_HND win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LMN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return 0;
}
int GetLJNrecord(void)
{

    T_MFW_HND win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LJN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return 0;
}
int GetLRNrecord(void)
{

    T_MFW_HND win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LRN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return 0;
}

int GetLDNrecord(void)
{

    T_MFW_HND win;
    T_MFW_HND parent_win = mfw_parent(mfw_header());
    recentcallbook=PHB_LDN;
    win = buildRecentCallMenu(parent_win);
    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, 0, 0);
    }
    return 0;
}


/********************************WUFEI***********************************************

 $Function:     buildUsedNumberMenu

 $Description:  Builds the cugnumber menu dynamenu from the melodies supplied
        by the resource manager

 $Returns:    None

 $Arguments:  None

*******************************************************************************/
static T_MFW_HND  buildRecentCallMenu( MfwHnd parent_window)
{
    T_RecentCall_INFO *  data = (T_RecentCall_INFO *)ALLOC_MEMORY (sizeof (T_RecentCall_INFO));
    T_MFW_WIN  * win;

    data->recentcall_win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)recentcall_win_cb);
    if( data->recentcall_win EQ NULL )
    {
        return NULL;
    }
    cugwindows=data->recentcall_win; //hu binhao 2003-1-21
    CallListFlag=0; // hu binhao 2003-1-21
    /*
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)recentcall_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->recentcall_win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
    winShow(data->recentcall_win);
    /*
     * return window handle
     */

    return data->recentcall_win;
}

/*****************************WUFEI**************************************************

 $Function:     numbers_exec_cb

 $Description:  Exec callback function of the cug window (dynamic list of
        all the cug number and other menu items)

 $Returns:    none

 $Arguments:  win - window handler
        event - mfw event
        parameter - optional data.

*******************************************************************************/
void recentcall_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_RecentCall_INFO   * data = (T_RecentCall_INFO *)win_data->user;
    UBYTE i;
    UBYTE n,m;
    ListWinInfo      * mnu_data = (ListWinInfo *)parameter;
    char srcCugNameStr[41];

    T_FindName * searchRCdata;
    //  char recentname[10][21];


    switch( event )
    {
    case E_INIT:
        searchRCdata = (T_FindName *) mfwAlloc(sizeof(T_FindName));//zy 2003-02-17 move here only INIT alloc
        memset((char *)searchRCdata,'\0',sizeof(searchRCdata));
        //	 TRACE_EVENT("E_INIT E_INIT 21 ");
        data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

        if( data->menu_list_data == 0 )
        {
            //    TRACE_EVENT("Failed memory alloc 1 ");
            mfwFree((U8 *) searchRCdata, sizeof(T_FindName));     ////zy 2003-02-17 add
            return;
        }
        n = recentcall_GetListCount();
        listlen=n;  //2003-1-21
        //	zgzTraceDataFunc_EAST("recentcall_GetListCount  listlen", listlen);

        if( n!=0 )
        {
            data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( 10 * sizeof(T_MFW_MNU_ITEM) );
            if( data->menu_list_data->List == 0 )
            {
                //     TRACE_EVENT("Failed memory alloc 2");
                mfwFree((U8 *) searchRCdata, sizeof(T_FindName));    //zy 2003-02-17 add
                return;
            }

            for( i = 0; i < n ; i++ )
            {
                // data->menu_list_data->List[i].icon = 0;
                data->menu_list_data->List[i].exta = 0;
                data->menu_list_data->List[i].edit = 0;
                data->menu_list_data->List[i].menu = 0;
                data->menu_list_data->List[i].func = NULL;
                data->menu_list_data->List[i].flagFunc = item_flag_none;
            }

            m=0;
            switch( recentcallbook )
            {
            case PHB_LMN:
                for( i = 0; i < n ; i++ )
                {
                    MmiTraceInt(FlashDCTbData.MForNameFlag[i]);

                    if( FlashDCTbData.MForNameFlag[i] )   //hu binhao 12-13 for fix 3120 bug 1 represent sim card have not ready
                    {
                        if( FindNumber((char *)FlashDCTbData.LMNTable[i],searchRCdata) )
                        {
                            memcpy(FlashDCTbData.Mname[i],searchRCdata->name,sizeof(searchRCdata->name));
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.Mname[i];
                            FlashDCTbData.MForNameFlag[i]=0;
                            MmiTrace("PHB_LMN hubh2");
                            flash_DCTbwrite();  //hu binhao 2003-1-7
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.LMNTable[i];
                        }
                        memset((char *)searchRCdata,'\0',sizeof(searchRCdata));  //ready for next

                    }
                    else
                    {
                        if( wstrlen(FlashDCTbData.Mname[i]) )
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.Mname[i];
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.LMNTable[i];
                        }



                    }

                    if( FlashDCTbData.LMNflag[i]==1 )
                    {
                        /* 2004/06 sunsj modify for picture manage */
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_CALLRECORD_NOREAD, 0);//&M_NotRead_callsicon;
                    }
                    else
                    {
                        data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_CALLRECORD_READ, 0);//&M_Read_callsicon;

                    }
                }
                data->menu_list_data->ListMenuFlag =1;  //hu binhao 2002-12-17
                data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtMissedCalls); //hu binhao 2002-12-13,for fix 3118 bug

                //2004-04-13 Sunny add
                if( FlashDCTbData.MissedCallNum>0 &&!MCallHintDleteFlag )  //hu binhao add &&MCallHintDleteFlag 2003-129
                {
                    memset((char * )FlashDCTbData.LMNflag,'\0',10);   //hu binhao 11-29
                    FlashDCTbData.MissedCallNum=0;   //hu binhao 11-29 
                    idle_data.missedCalls = 0; 
                    flash_DCTbwrite();               //hu binhao  11-29
                }
                //2004-04-13 Sunny add end

                break;
            case PHB_LJN:
                for( i = 0; i < n ; i++ )
                {
                    if( FlashDCTbData.JForNameFlag[i]==1 )   ////hu binhao 12-13 for fix 3120 bug
                    {
                        if( FindNumber((char *)FlashDCTbData.LJNTable[i],searchRCdata) )
                        {
                            memcpy(FlashDCTbData.Jname[i],searchRCdata->name,sizeof(searchRCdata->name));
                            //data->menu_list_data->List[i].str = (char*)recentname[m];
                            //m++;
                            // memset((char *)searchRCdata,'\0',sizeof(searchRCdata));
                            //wstrcpy((char*)FlashDCTbData.Jname[i],(char *)searchRCdata->name);
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.Jname[i];
                            FlashDCTbData.JForNameFlag[i]=0;
                            flash_DCTbwrite();  //hu binhao 2003-1-7

                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.LJNTable[i];
                        }
                        memset((char *)searchRCdata,'\0',sizeof(searchRCdata));

                    }
                    else
                    {
                        if( wstrlen(FlashDCTbData.Jname[i]) )
                        {

                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.Jname[i];
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.LJNTable[i];

                        }

                    }
                    /* 2004/06 sunsj modify for picture manage */
                    data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_CALLRECORD_LJN, 0);//&Jcallsicon;
                }
                data->menu_list_data->ListMenuFlag =1;  //hu binhao 2002-12-17
                data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtRejectCalls); //hu binhao 2002-12-13,for fix 3118 bug

                break;
            case PHB_LDN:
                for( i = 0; i < n ; i++ )
                {
                    if( FlashDCTbData.DForNameFlag[i]==1 )   //hu binhao 12-13 for fix 3120 bug
                    {
                        if( FindNumber((char *)FlashDCTbData.LDNTable[i],searchRCdata) )
                        {
                            memcpy((char *)FlashDCTbData.Dname[i],searchRCdata->name,sizeof(searchRCdata->name));
                            data->menu_list_data->List[i].str = (char *)FlashDCTbData.Dname[i];
                            FlashDCTbData.DForNameFlag[i]=0;
                            flash_DCTbwrite();  //hu binhao 2003-1-7
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char *)FlashDCTbData.LDNTable[i];
                        }
                        memset((char *)searchRCdata,'\0',sizeof(searchRCdata));

                    }
                    else
                    {
                        if( wstrlen(FlashDCTbData.Dname[i]) )
                        {

                            data->menu_list_data->List[i].str = (char *)FlashDCTbData.Dname[i];
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char *)FlashDCTbData.LDNTable[i];

                        }

                    }
                    /* 2004/06 sunsj modify for picture manage */
                    data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_CALLRECORD_LDN, 0);//&Dcallsicon;
                }
                data->menu_list_data->ListMenuFlag =1;  //hu binhao 2002-12-17
                data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtOutgoingCalls); //hu binhao 2002-12-13,for fix 3118 bug

                break;
            case PHB_LRN:
                for( i = 0; i < n ; i++ )
                {
                    if( FlashDCTbData.RForNameFlag[i]==1 )   //hu binhao 12-13 for fix 3120 bug
                    {
                        if( FindNumber((char *)FlashDCTbData.LRNTable[i],searchRCdata) )
                        {
                            memcpy((char*)FlashDCTbData.Rname[i],searchRCdata->name,sizeof(searchRCdata->name));
                            //m++;

                            // wstrcpy((char*)FlashDCTbData.Rname[i],(char *)searchRCdata->name);
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.Rname[i];
                            FlashDCTbData.RForNameFlag[i]=0;
                            flash_DCTbwrite();  //hu binhao 2003-1-7
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.LRNTable[i];
                        }
                        memset((char *)searchRCdata,'\0',sizeof(searchRCdata));
                    }
                    else
                    {
                        if( wstrlen(FlashDCTbData.Rname[i]) )
                        {

                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.Rname[i];
                        }
                        else
                        {
                            data->menu_list_data->List[i].str = (char*)FlashDCTbData.LRNTable[i];

                        }
                    }
                    /* 2004/06 sunsj modify for picture manage */
                    data->menu_list_data->List[i].icon  = GET_ICONATTR(ICON_CALLRECORD_LRN, 0);//&Rcallsicon;
                }
                data->menu_list_data->ListMenuFlag =1;  //hu binhao 2002-12-17
                data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtIncomingCalls); //hu binhao 2002-12-13,for fix 3118 bug

                break;
            }

            mfwFree((U8 *) searchRCdata, sizeof(T_FindName));     //hu binhao 

            data->menu_list_data->ListLength =n;
            data->menu_list_data->ListPosition = 1;
            data->menu_list_data->CursorPosition = 1;
            data->menu_list_data->SnapshotSize = n;
            data->menu_list_data->Font = 0;
            data->menu_list_data->LeftSoftKey = TxtSoftSelect;
            data->menu_list_data->RightSoftKey = TxtSoftBack;
            data->menu_list_data->KeyEvents = KEY_ALL;
            data->menu_list_data->Reason = 0;
            data->menu_list_data->Strings = TRUE;
            data->menu_list_data->Attr   = &UsedNumber_menuAttrib;
            data->menu_list_data->autoDestroy    = FALSE;
            listDisplayListMenu(win, data->menu_list_data,(ListCbFunc)RecentCallList_cb,0);
            //ShowRencentCallDetail((char *)FlashDCTbData.LDNTable[0]); 

            //if  (getMissedCallNum()) //
            if( FlashDCTbData.MissedCallNum>0 &&!MCallHintDleteFlag )  //hu binhao add &&MCallHintDleteFlag 2003-129
            {
                //2004-04-13 Sunny remove
                /*memset((char * )FlashDCTbData.LMNflag,'\0',10);   //hu binhao 11-29
                FlashDCTbData.MissedCallNum=0;   //hu binhao 11-29 
                idle_data.missedCalls = 0; 
                flash_DCTbwrite();  */             //hu binhao  11-29
            }


        }
        else
        {
            if( CallsDeleteAllFlag==1 )  //hu binhao 2003-1-7
            {
                CallsDeleteAllFlag=0;
                iniNoRecord=0;
            }
            else
            {
                services_info_screen(ss_data.win,TxtEmptyList);
                iniNoRecord=1;
            }
            mfwFree((U8 *) searchRCdata, sizeof(T_FindName));     //hu binhao 2003-3-18
            //listsDestroy(data->menu_list_data->win);
            //FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
            //winDelete(data->recentcall_win);
            recentcallWin_destroy(data->recentcall_win);
        }


        break;
    case E_UPDATE:
        listsDestroy(data->menu_list_data->win);
        FREE_MEMORY ((void *)data->menu_list_data->List, 10 * sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));

        //     TRACE_FUNCTION("hu binhao 1-24");
        SEND_EVENT(data->recentcall_win,E_INIT,0,0);    // 2003-1-24
        break;
    default:
        break;

    }
}

/***********************************WUFEI APPEND*******************************
$Function: UsedNumberList_cb
$Description:
$Return:
$Description:
********************************************************************************/
static void RecentCallList_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_RecentCall_INFO * data     = (T_RecentCall_INFO *)win_data->user;
    T_MFW_HND      * l_parent;
    UBYTE Reason;
    UBYTE ListLength,ListPosition;
    Reason=ListData->Reason;
    ListLength=ListData->ListLength;
    ListPosition=ListData->ListPosition;
    if( (Reason EQ LISTS_REASON_BACK) || (Reason EQ LISTS_REASON_CLEAR)
        || (Reason EQ LISTS_REASON_HANGUP) )
    {
        //l_parent = data->parent;
        listsDestroy(ListData->win); 
        recentcallWin_destroy(data->recentcall_win);
        CallListFlag=0; //hu binhao 2003-1-21
        // MCallHintDleteFlag=0; //hu binhao 2003-1-29
    }
    else if( (Reason EQ LISTS_REASON_SELECT)||(Reason EQ LISTS_REASON_OK) ) //hu binhao 2003-2-21
    {
        cugListPosition=ListPosition;             
        cugwindows=data->recentcall_win;              
        listlen=ListLength;
        showDetail(data->recentcall_win);
        //hu binhao 2003-4-29
        switch( recentcallbook )
        {
        
        case PHB_LMN:
            memcpy(NameShowDetail,(char *)FlashDCTbData.Mname[cugListPosition],24);
            memcpy(NumShowDetail,(char *)FlashDCTbData.LMNTable[cugListPosition],24);
            break;
        case PHB_LJN:
            memcpy(NameShowDetail,(char *)FlashDCTbData.Jname[cugListPosition],24);
            memcpy(NumShowDetail,(char *)FlashDCTbData.LJNTable[cugListPosition],24);
            break;
            //case PHB_LDN:
        case PHB_LRN:
            memcpy(NameShowDetail,(char *)FlashDCTbData.Rname[cugListPosition],24);
            memcpy(NumShowDetail,(char *)FlashDCTbData.LRNTable[cugListPosition],24);
            break;

        }

    }
    else if( Reason EQ LISTS_REASON_SEND )
    {
        if( recentcallbook == PHB_LMN )
        {
            T_EasyName data;
            memset(&data,0,sizeof(data));
            memcpy(data.name,(char *)FlashDCTbData.Mname[ListPosition],PHB_name_len);
            memcpy(data.number,(char *)FlashDCTbData.LMNTable[ListPosition],PHB_number_len);
            SetCallData(data);
            callNumber((UBYTE*)FlashDCTbData.LMNTable[ListPosition]);
        }
        else if( recentcallbook == PHB_LJN )
        {
            T_EasyName data;
            memset(&data,0,sizeof(data));
            memcpy(data.name,(char *)FlashDCTbData.Jname[ListPosition],PHB_name_len);
            memcpy(data.number,(char *)FlashDCTbData.LJNTable[ListPosition],PHB_number_len);
            SetCallData(data);
            callNumber((UBYTE*)FlashDCTbData.LJNTable[ListPosition]);
        }
        else if( recentcallbook == PHB_LRN )
        {
            T_EasyName data;
            memset(&data,0,sizeof(data));
            memcpy(data.name,(char *)FlashDCTbData.Rname[ListPosition],PHB_name_len);
            memcpy(data.number,(char *)FlashDCTbData.LRNTable[ListPosition],PHB_number_len);
            SetCallData(data);
            callNumber((UBYTE*)FlashDCTbData.LRNTable[ListPosition]);
        }
        else if( recentcallbook == PHB_LDN )
        {
            T_EasyName data;
            memset(&data,0,sizeof(data));
            memcpy(data.name,(char *)FlashDCTbData.Dname[ListPosition],PHB_name_len);
            memcpy(data.number,(char *)FlashDCTbData.LDNTable[ListPosition],PHB_number_len);
            SetCallData(data);
            callNumber((UBYTE*)FlashDCTbData.LDNTable[ListPosition]);
        }
    }
    else if( Reason EQ LISTS_REASON_UPDATE&&CallListFlag==1 )
    {
        //		TRACE_EVENT("E_UPDATE hubh 21 ");
        //this LISTS_REASON_UPDATE is from mmilist.c ' listsWinEvent (visible)
        if( CallListFlag==1 )   //calllistFlag changed in mmicall.c 's saveNumCallRecord
        {
            cugListPosition=ListPosition;              
            cugwindows=data->recentcall_win;               
            // listlen=ListLength;
            CallListFlag=0;  //2003-1-21
            SEND_EVENT(cugwindows,E_UPDATE,0,0);   //2003-1-21
        }
        /*listsDestroy(ListData->win); 
        recentcallWin_destroy(data->recentcall_win);
        CallListFlag=0; //hu binhao 2003-1-21
        */
    }


}


static void showDetail (T_MFW_HND win)  //hu binhao modify, 2002-10-30 for fix bug of in recent calls menu
{

    T_DISPLAY_DATA display_info;
    BOOL ret;
    //    	 static char text[25]; 				//25
    //    	 static char name[21];
    T_FindName * showdetaildata;
    //    	 static char textNumbert[21];				// 11-15

    dialog_info_init(&display_info);//gdy add
    showdetaildata = (T_FindName *) mfwAlloc(sizeof(T_FindName)); //fix bug of in recent calls menu, hu binhao 2002-10-30 
    memset(ss_data.text,'\0',25);          //25   	
    memset(ss_data.textNumbert,'\0',24);           //11-15 hu binhao
    memset(ss_data.name,'\0',24);          //11-15 hu binhao
    memset(&display_info,'\0',sizeof(display_info));



    display_info.KeyEvents    = KEY_HUP|KEY_LEFT|KEY_RIGHT|KEY_OK;  //hu binhao 2003-2-21 add ok key
    /*         display_info.TextId	= 0;
             display_info.TextId2      = 0;
            // display_info.TextString2  = text;
             display_info.TextString2  = '\0';
             display_info.TextString   = '\0';*/
    display_info.LeftSoftKey  = TxtSoftOptions;
    display_info.RightSoftKey = TxtSoftBack;
    display_info.Time        = FOREVER;
    display_info.Identifier    =RECTCALLDETAIL;
    display_info.iconindex    =0;
    display_info.Callback     = (T_VOID_FUNC) RecentCallDetail_cb;


    if( recentcallbook == PHB_LMN )
    {
        ret=FindNumber((char*)FlashDCTbData.LMNTable[cugListPosition],showdetaildata); 
        strcpy(ss_data.text, (char*)FlashDCTbData.LMNTime[cugListPosition]);
        strcpy(ss_data.textNumbert, (char*)FlashDCTbData.LMNTable[cugListPosition]);

        // dspl_TextOut(1,16,DSPL_TXTATTR_NORMAL,MmiRsrcGetText(TxtIncomingCallTime));
        display_info.TextId=TxtIncomingCallTime;
    }
    else if( recentcallbook == PHB_LJN )
    {
        ret=FindNumber((char*)FlashDCTbData.LJNTable[cugListPosition],showdetaildata); 
        strcpy(ss_data.text, (char*)FlashDCTbData.LJNTime[cugListPosition]); 
        strcpy(ss_data.textNumbert, (char*)FlashDCTbData.LJNTable[cugListPosition]);

        //dspl_TextOut(1,16,DSPL_TXTATTR_NORMAL,MmiRsrcGetText(TxtIncomingCallTime));
        display_info.TextId=TxtIncomingCallTime;
    }
    else if( recentcallbook == PHB_LRN )
    {
        ret=FindNumber((char*)FlashDCTbData.LRNTable[cugListPosition],showdetaildata); 
        strcpy(ss_data.text, (char*)FlashDCTbData.LRNTime[cugListPosition]); 
        strcpy(ss_data.textNumbert, (char*)FlashDCTbData.LRNTable[cugListPosition]);
        //	dspl_TextOut(1,16,DSPL_TXTATTR_NORMAL,MmiRsrcGetText(TxtIncomingCallTime));
        display_info.TextId=TxtIncomingCallTime;

    }
    else if( recentcallbook == PHB_LDN )
    {
        ret=FindNumber((char *)FlashDCTbData.LDNTable[cugListPosition],showdetaildata); 
        strcpy(ss_data.text, (char*)FlashDCTbData.LDNTime[cugListPosition]);
        strcpy(ss_data.textNumbert, (char*)FlashDCTbData.LDNTable[cugListPosition]);
        // dspl_TextOut(1,16,DSPL_TXTATTR_NORMAL,MmiRsrcGetText(TxtDialTime));
        display_info.TextId=TxtDialTime;
    }
    // dspl_TextOut(1,32,DSPL_TXTATTR_NORMAL,(char *)text);
    display_info.TextString=(char *)ss_data.text;
    //    	         TRACE_EVENT("showdetailbegin time is");
    //               	 TRACE_EVENT(display_info.TextString);
    if( ret )
    {
        //dspl_TextOut(1,55,DSPL_TXTATTR_NORMAL,MmiRsrcGetText(TxtName));
        display_info.TextId2=TxtName;
        if( showdetaildata->GroupIndex==9 )  //back name 
        {
            //dspl_BitBlt(45 , 55, 16, 16,0, (void *) IconBookGrouping15, 0) ; // hu bin hao 11-22 ,back name icon will be changed
            display_info.iconindex    =100;
        }
        // dspl_TextOut(1,71,DSPL_TXTATTR_NORMAL,(char *)searchRCdata->name);
        if( wstrBitlen((char *)showdetaildata->name)>14 )   //2003-4-8 fix: too long name cover the infor in the next line
        {

            truncateString((char *)showdetaildata->name, (char *)showdetaildata->name, 12, POS_END,".");
        }
        wstrcpy(ss_data.name,(char *)showdetaildata->name);
        display_info.TextString2=(char *)ss_data.name;
        //	   		     TRACE_EVENT("showdetailbegin name is");
        //              	 TRACE_EVENT(display_info.TextString2);
    }
    else
    {
        display_info.TextId2=0;
        display_info.TextString2='\0';
    }
    //dspl_TextOut(1,94,DSPL_TXTATTR_NORMAL,MmiRsrcGetText(TxtNumberShow));
    display_info.TextId3=TxtNumberShow;
    // dspl_TextOut(1,110,DSPL_TXTATTR_NORMAL,(char*)textNumbert);
    display_info.TextString3=(char*)ss_data.textNumbert;
    //                 TRACE_EVENT("showdetailbegin number is");
    //              	 TRACE_EVENT(display_info.TextString3);
    mfwFree((U8 *) showdetaildata, sizeof(T_FindName));     //hu binhao 10-30
    ss_data.info_win = info_dialog (win, &display_info);

}


static int RecentCallDetail_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    switch( Reason )
    {
    case INFO_KCD_LEFT:
        //dspl_Clear(0,0,119,144);
        //winDelete(ss_data.info_win);
        ss_data.info_win =0;
        recentcallSubMnu();
        break;

    case INFO_KCD_RIGHT: 
        //winDelete(ss_data.info_win);
        ss_data.info_win = 0;
        break;
    }

    return MFW_EVENT_CONSUMED;
}
/*******************************WUFEI************************************************

 $Function:     cugWin_destroy

 $Description:  Destroy the cug window.

 $Returns:    none

 $Arguments:  own_window- current window
*******************************************************************************/

static void recentcallWin_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_RecentCall_INFO     * data;
    UBYTE n;

    //  TRACE_EVENT ("cugWin_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_RecentCall_INFO *)win_data->user;

        if( data )
        {

            win_delete (data->recentcall_win);
            //n = recentcall_GetListCount();

            if( data->menu_list_data != NULL&&(iniNoRecord!=1) )
            {
                FREE_MEMORY ((void *)data->menu_list_data->List, 10 * sizeof (T_MFW_MNU_ITEM));
                FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
            }
            else if( data->menu_list_data != NULL&&(iniNoRecord==1) )
            {
                FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
            }
            FREE_MEMORY ((void *)data, sizeof (T_RecentCall_INFO));

        }
        else
        {
            //      TRACE_EVENT ("cugWin_destroy() called twice");
        }
    }
    cugwindows=0; //hu binhao 2003-1-21
    iniNoRecord=0;
}

/**************************************WUFEI*****************************************

 $Function:     cug_win_cb

 $Description:  Window callback function for the cug window.

 $Returns:    none

 $Arguments:  w - mfw window handler
        e - mfw event

*******************************************************************************/

static int recentcall_win_cb (MfwEvt e, MfwWin *w)    /* yyy window event handler */
{
    //  TRACE_EVENT ("cug_win_cb()");
    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */

    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}


int recentcallSubMnu(void)
{
    T_MFW_WIN *win;
    //T_MFW_HND parent_win = mfw_parent(mfw_header());
    T_MFW_HND parent_win = cugwindows;
    T_RecentCall_INFO   * data= (T_RecentCall_INFO *)ALLOC_MEMORY (sizeof (T_RecentCall_INFO));
    UBYTE n;

    data->recentcall_win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)recentcall_win_cb);
    if( data->recentcall_win EQ NULL )
    {
        return NULL;
    }

    data->mmi_control.dialog = NULL;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->recentcall_win)->data;
    win->user                = (void *)data;
    data->parent             = parent_win;
    winShow(data->recentcall_win);

    data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

    if( data->menu_list_data == 0 )
    {
        //   TRACE_EVENT("Failed memory alloc 1 ");
        return;
    }
    data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( 5 * sizeof(T_MFW_MNU_ITEM) );
    if( data->menu_list_data->List == 0 )
    {
        //   TRACE_EVENT("Failed memory alloc 2");
        return;
    }

    for( n = 0; n < 5 ; n++ )                               /* with these items         */
    {
        data->menu_list_data->List[n].icon = GET_ICONATTR(ICON_LISTCOMMON, 0);//&colist;/* 2004/06 sunsj modify for icon manage */
        data->menu_list_data->List[n].exta = 0;
        data->menu_list_data->List[n].edit = 0;
        data->menu_list_data->List[n].menu = 0;
        data->menu_list_data->List[n].func = NULL;
        data->menu_list_data->List[n].flagFunc = item_flag_none;
    }
    data->menu_list_data->ListMenuFlag=1;  //hu binhao 2002-1218 for 3118
    data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtSoftOptions); //hu binhao 2002-12-13,for 3118 bug
    data->menu_list_data->List[0].str = (char *)TxtSave;
    data->menu_list_data->List[1].str = (char *)TxtCallSetup;
    data->menu_list_data->List[2].str = (char *)TxtSendMessage;
    data->menu_list_data->List[3].str = (char *)TxtDelete;
    data->menu_list_data->List[4].str = (char *)TxtDeleteAll;
    data->menu_list_data->ListLength =5;
    data->menu_list_data->ListPosition = 1;
    data->menu_list_data->CursorPosition = 1;
    data->menu_list_data->SnapshotSize = 5;
    data->menu_list_data->Font = 0;
    data->menu_list_data->LeftSoftKey = TxtSoftSelect;
    data->menu_list_data->RightSoftKey = TxtSoftBack;
    data->menu_list_data->KeyEvents = KEY_ALL;
    data->menu_list_data->Reason = 0;
    data->menu_list_data->Strings = FALSE;
    data->menu_list_data->Attr   = &UsedNumber_menuAttrib;
    data->menu_list_data->autoDestroy    = FALSE;
    listDisplayListMenu(data->recentcall_win, data->menu_list_data,(ListCbFunc)recentcallSubList_cb,0);
}

static void recentcallSubList_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_RecentCall_INFO * data     = (T_RecentCall_INFO *)win_data->user;
    char* settedIdx;
    T_SmsUserData    SmsData;
    memset(&SmsData,'\0',sizeof(SmsData));  //hu binhao 11-5
    if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
        || (ListData->Reason EQ LISTS_REASON_HANGUP) )
    {

        listsDestroy(ListData->win); 
        win_delete (data->recentcall_win);
        FREE_MEMORY ((void *)data->menu_list_data->List, 5 * sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
        FREE_MEMORY ((void *)data, sizeof (T_RecentCall_INFO));
    }
    else if( (ListData->Reason EQ LISTS_REASON_SELECT)||(ListData->Reason EQ LISTS_REASON_OK) )  //hu binhao 2003-2-21 add ok
    {
        UBYTE i,idx;
        UBYTE n = recentcall_GetListCount();    
        i=ListData->ListPosition;
        switch( i )
        {
        case 0:
            if( bookPhoneBookLoading()==BOOK_SUCCESS )
            {
                T_MFW_HND phbk_win;
                phbk_win = bookPhonebookStart(data->recentcall_win,PhbkNameEnterRecentCall);
                if( recentcallbook == PHB_LMN )
                    //SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)FlashDCTbData.LMNTable[cugListPosition] );
                    SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)NumShowDetail);  //hu binhao 2003-4-29

                else if( recentcallbook == PHB_LJN )
                    //SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)FlashDCTbData.LJNTable[cugListPosition] );
                    SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)NumShowDetail );

                else if( recentcallbook == PHB_LRN )
                    //SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)FlashDCTbData.LRNTable[cugListPosition] );
                    SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)NumShowDetail );

                else if( recentcallbook == PHB_LDN )
                    SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)FlashDCTbData.LDNTable[cugListPosition] );


            }

            break;
        case 1:
            if( recentcallbook == PHB_LMN )
            {
                T_EasyName data;
                memset(&data,0,sizeof(data));
                //memcpy(data.name,(char *)FlashDCTbData.Mname[cugListPosition],PHB_name_len);
                //memcpy(data.number,(char *)FlashDCTbData.LMNTable[cugListPosition],PHB_number_len);
                memcpy(data.name,(char *)NameShowDetail,PHB_name_len);  //hu binhao 2003-4-29
                memcpy(data.number,(char *)NumShowDetail,PHB_number_len); //hu binhao 2003-4-29
                SetCallData(data);
                //callNumber(FlashDCTbData.LMNTable[cugListPosition]);
                callNumber(NumShowDetail);  //hu binhao 2003-4-29
            }
            else if( recentcallbook == PHB_LJN )
            {
                T_EasyName data;
                memset(&data,0,sizeof(data));
                //memcpy(data.name,(char *)FlashDCTbData.Jname[cugListPosition],PHB_name_len);
                //memcpy(data.number,(char *)FlashDCTbData.LJNTable[cugListPosition],PHB_number_len);
                memcpy(data.name,(char *)NameShowDetail,PHB_name_len);  //hu binhao 2003-4-29
                memcpy(data.number,(char *)NumShowDetail,PHB_number_len); //hu binhao 2003-4-29
                SetCallData(data);
                //callNumber(FlashDCTbData.LJNTable[cugListPosition]);
                callNumber(NumShowDetail);  //hu binhao 2003-4-29
            }
            else if( recentcallbook == PHB_LRN )
            {
                T_EasyName data;
                memset(&data,0,sizeof(data));
                //memcpy(data.name,(char *)FlashDCTbData.Rname[cugListPosition],PHB_name_len);
                //memcpy(data.number,(char *)FlashDCTbData.LRNTable[cugListPosition],PHB_number_len);
                memcpy(data.name,(char *)NameShowDetail,PHB_name_len);  //hu binhao 2003-4-29
                memcpy(data.number,(char *)NumShowDetail,PHB_number_len); //hu binhao 2003-4-29
                SetCallData(data);
                //				TRACE_EVENT_P1("wangyan: %s", data.name);
                //				TRACE_EVENT_P1("wangyan: %s", data.number);
                //callNumber(FlashDCTbData.LRNTable[cugListPosition]);
                callNumber(NumShowDetail);  //hu binhao 2003-4-29
            }
            else if( recentcallbook == PHB_LDN )
            {
                T_EasyName data;
                memset(&data,0,sizeof(data));
                memcpy(data.name,(char *)FlashDCTbData.Dname[cugListPosition],PHB_name_len);
                memcpy(data.number,(char *)FlashDCTbData.LDNTable[cugListPosition],PHB_number_len);
                SetCallData(data);
                callNumber(FlashDCTbData.LDNTable[cugListPosition]);
            }
            break;
        case 2:
            SmsData.Send_state =E_REPLY;  //hu binhao 11-5
            if( recentcallbook == PHB_LMN )
            {
                memcpy(SmsData.NumberBuffer,NumShowDetail,PHB_number_len); //hu binhao 2003-4-29
                SmsSend_SEND_start( win, (T_SmsUserData *)&SmsData);
            }
            else if( recentcallbook == PHB_LJN )
            {
                //memcpy(SmsData.NumberBuffer,FlashDCTbData.LJNTable[cugListPosition],PHB_number_len);
                memcpy(SmsData.NumberBuffer,NumShowDetail,PHB_number_len); //hu binhao 2003-4-29
                SmsSend_SEND_start( win,(T_SmsUserData *)&SmsData);
            }
            else if( recentcallbook == PHB_LRN )
            {
                //memcpy(SmsData.NumberBuffer,FlashDCTbData.LRNTable[cugListPosition],PHB_number_len);
                memcpy(SmsData.NumberBuffer,NumShowDetail,PHB_number_len); //hu binhao 2003-4-29
                SmsSend_SEND_start( win,(T_SmsUserData *)&SmsData);
            }
            else if( recentcallbook == PHB_LDN )
            {
                memcpy(SmsData.NumberBuffer,FlashDCTbData.LDNTable[cugListPosition],PHB_number_len);
                SmsSend_SEND_start( win, (T_SmsUserData *)&SmsData);
            }
            break;
        case 3:
            switch( recentcallbook )
            {
            case PHB_LMN:
                //hu binhao 2003-4-29
                if( strcmp((char*)FlashDCTbData.LMNTable[cugListPosition],(char *)NumShowDetail)!=0 )
                {
                    cugListPosition=GetPosition('M',NumShowDetail);
                }
                memset((char*)FlashDCTbData.LMNTable[cugListPosition],'\0',24);
                memset((char*)FlashDCTbData.LMNTime[cugListPosition],'\0',21);

                memset((char*)FlashDCTbData.Mname[cugListPosition],'\0',24);  //hu binhao 2002-12-29
                FlashDCTbData.MForNameFlag[cugListPosition]=0;  //hu binhao 2002-12-29

                for( idx=cugListPosition;idx<n-1;idx++ )
                {
                    memcpy((char*)FlashDCTbData.LMNTable[idx],(char*)FlashDCTbData.LMNTable[idx+1],24);
                    memcpy((char*)FlashDCTbData.Mname[idx],(char*)FlashDCTbData.Mname[idx+1],24);  //hu binhao 2002-12-29
                    FlashDCTbData.MForNameFlag[idx]=FlashDCTbData.MForNameFlag[idx+1];       //hu binhao 2002-12-29
                    memcpy((char*)FlashDCTbData.LMNTime[idx],(char*)FlashDCTbData.LMNTime[idx+1],21);


                }
                memset((char*)FlashDCTbData.LMNTable[n-1],'\0',24);  //hu binhao 2002-12-29 change 21 to 24		
                memset((char*)FlashDCTbData.LMNTime[n-1],'\0',21);   //hu binhao 2002-12-29 		
                memset((char*)FlashDCTbData.Mname[n-1],'\0',24);    //hu binhao 2002-12-29   change form 21 to 24 2003-2-11
                FlashDCTbData.MForNameFlag[n-1]=0;                      //hu binhao 2002-12-29
                //for(idx=cugListPosition;idx<n-1;idx++)
                //strcpy((char*)FlashDCTbData.LMNTime[idx],(char*)FlashDCTbData.LMNTime[idx+1]);
                //memset((char*)FlashDCTbData.LMNTable[n-1],'\0',21);
                FlashDCTbData.LMNID--;
                flash_DCTbwrite();
                break;

            case PHB_LJN:
                //hu binhao 2003-4-29
                if( strcmp((char*)FlashDCTbData.LJNTable[cugListPosition],(char *)NumShowDetail)!=0 )
                {
                    cugListPosition=GetPosition('J',NumShowDetail);
                }
                memset((char*)FlashDCTbData.LJNTable[cugListPosition],'\0',24);
                memset((char*)FlashDCTbData.LJNTime[cugListPosition],'\0',21);
                memset((char*)FlashDCTbData.Jname[cugListPosition],'\0',24);  //hu binhao 2002-12-29
                FlashDCTbData.JForNameFlag[cugListPosition]=0;  //hu binhao 2002-12-29
                for( idx=cugListPosition;idx<n-1;idx++ )
                {
                    memcpy((char*)FlashDCTbData.LJNTable[idx],(char*)FlashDCTbData.LJNTable[idx+1],24);
                    memcpy((char*)FlashDCTbData.Jname[idx],(char*)FlashDCTbData.Jname[idx+1],24);  //hu binhao 2002-12-29
                    FlashDCTbData.JForNameFlag[idx]=FlashDCTbData.JForNameFlag[idx+1];       //hu binhao 2002-12-29
                    memcpy((char*)FlashDCTbData.LJNTime[idx],(char*)FlashDCTbData.LJNTime[idx+1],21);
                }
                memset((char*)FlashDCTbData.LJNTable[n-1],'\0',24);      //hu binhao 2002-12-29 change 21 to 24
                memset((char*)FlashDCTbData.LJNTime[n-1],'\0',21);   //hu binhao 2002-12-29 		
                memset((char*)FlashDCTbData.Jname[n-1],'\0',24);     //hu binhao 2002-12-29 
                FlashDCTbData.JForNameFlag[n-1]=0;                   //hu binhao 2002-12-29
                //for(idx=cugListPosition;idx<n-1;idx++)
                //strcpy((char*)FlashDCTbData.LJNTime[idx],(char*)FlashDCTbData.LJNTime[idx+1]);
                //memset((char*)FlashDCTbData.LJNTable[n-1],'\0',21);
                FlashDCTbData.LJNID--;
                flash_DCTbwrite();
                break;
            case PHB_LDN:
                memset((char*)FlashDCTbData.LDNTable[cugListPosition],'\0',24);
                memset((char*)FlashDCTbData.LDNTime[cugListPosition],'\0',21);
                memset((char*)FlashDCTbData.Dname[cugListPosition],'\0',24);  //hu binhao 2002-12-29
                FlashDCTbData.DForNameFlag[cugListPosition]=0;  //hu binhao 2002-12-29
                for( idx=cugListPosition;idx<n-1;idx++ )
                {
                    memcpy((char*)FlashDCTbData.LDNTable[idx],(char*)FlashDCTbData.LDNTable[idx+1],24);
                    memcpy((char*)FlashDCTbData.Dname[idx],(char*)FlashDCTbData.Dname[idx+1],24);  //hu binhao 2002-12-29
                    FlashDCTbData.DForNameFlag[idx]=FlashDCTbData.DForNameFlag[idx+1];       //hu binhao 2002-12-29
                    memcpy((char*)FlashDCTbData.LDNTime[idx],(char*)FlashDCTbData.LDNTime[idx+1],21);
                }
                memset((char*)FlashDCTbData.LDNTable[n-1],'\0',24); 
                memset((char*)FlashDCTbData.LDNTime[n-1],'\0',21);   //hu binhao 2002-12-29 		
                memset((char*)FlashDCTbData.Dname[n-1],'\0',24);     //hu binhao 2002-12-29 
                FlashDCTbData.DForNameFlag[n-1]=0;                   //hu binhao 2002-12-29
                //for(idx=cugListPosition;idx<n-1;idx++)
                //	strcpy((char*)FlashDCTbData.LDNTime[idx],(char*)FlashDCTbData.LDNTime[idx+1]);
                //memset((char*)FlashDCTbData.LDNTable[n-1],'\0',21);
                FlashDCTbData.LDNID--;
                flash_DCTbwrite();
                break;
            case PHB_LRN:
                //hu binhao 2003-4-29
                if( strcmp((char*)FlashDCTbData.LRNTable[cugListPosition],(char *)NumShowDetail)!=0 )
                {
                    cugListPosition=GetPosition('R',NumShowDetail);
                }
                memset((char*)FlashDCTbData.LRNTable[cugListPosition],'\0',24);
                memset((char*)FlashDCTbData.LRNTime[cugListPosition],'\0',21);
                memset((char*)FlashDCTbData.Rname[cugListPosition],'\0',24);  //hu binhao 2002-12-29
                FlashDCTbData.RForNameFlag[cugListPosition]=0;  //hu binhao 2002-12-29
                for( idx=cugListPosition;idx<n-1;idx++ )
                {
                    memcpy((char*)FlashDCTbData.LRNTable[idx],(char*)FlashDCTbData.LRNTable[idx+1],24);
                    memcpy((char*)FlashDCTbData.Rname[idx],(char*)FlashDCTbData.Rname[idx+1],24);  //hu binhao 2002-12-29
                    FlashDCTbData.RForNameFlag[idx]=FlashDCTbData.RForNameFlag[idx+1];       //hu binhao 2002-12-29
                    memcpy((char*)FlashDCTbData.LRNTime[idx],(char*)FlashDCTbData.LRNTime[idx+1],21);
                }
                memset((char*)FlashDCTbData.LRNTable[n-1],'\0',24);
                memset((char*)FlashDCTbData.LRNTime[n-1],'\0',21);   //hu binhao 2002-12-29 		
                memset((char*)FlashDCTbData.Rname[n-1],'\0',24);     //hu binhao 2002-12-29 
                FlashDCTbData.RForNameFlag[n-1]=0;                   //hu binhao 2002-12-29
                //for(idx=cugListPosition;idx<n-1;idx++)
                //strcpy((char*)FlashDCTbData.LRNTime[idx],(char*)FlashDCTbData.LRNTime[idx+1]);
                //memset((char*)FlashDCTbData.LRNTable[n-1],'\0',21);
                FlashDCTbData.LRNID--;
                flash_DCTbwrite();
                break;
            }
            CallsDeleteAllFlag=1; //hu binhao 2003-1-8
            SEND_EVENT(cugwindows,E_UPDATE,0,0);
            services_info_screen(win,TxtDone);
            break;
        case 4: 
            switch( recentcallbook )
            {
            case PHB_LMN:
                memset((char*)FlashDCTbData.LMNTable,'\0',n*24); //hu binhao 2002-12-29
                memset((char*)FlashDCTbData.LMNTime,'\0',n*21);
                memset((char*)FlashDCTbData.Mname,'\0',n*24); //hu binhao 2002-12-29  change from 21 to 24 2003-2-11
                memset((char*)FlashDCTbData.MForNameFlag,'\0',10); //hu binhao 2002-12-29

                FlashDCTbData.LMNID=0;
                flash_DCTbwrite();
                break;
            case PHB_LJN:
                memset((char*)FlashDCTbData.LJNTable,'\0',n*24);
                memset((char*)FlashDCTbData.LJNTime,'\0',n*21);
                memset((char*)FlashDCTbData.Jname,'\0',n*24); //hu binhao 2002-12-29
                memset((char*)FlashDCTbData.JForNameFlag,'\0',10); //hu binhao 2002-12-29
                FlashDCTbData.LJNID=0;
                flash_DCTbwrite();
                break;
            case PHB_LRN:
                memset((char*)FlashDCTbData.LRNTable,'\0',n*24);
                memset((char*)FlashDCTbData.LRNTime,'\0',n*21);
                memset((char*)FlashDCTbData.Rname,'\0',n*24); //hu binhao 2002-12-29
                memset((char*)FlashDCTbData.RForNameFlag,'\0',10); //hu binhao 2002-12-29
                FlashDCTbData.LRNID=0;
                flash_DCTbwrite();
                break;
            case PHB_LDN:
                memset((char*)FlashDCTbData.LDNTable,'\0',n*24);
                memset((char*)FlashDCTbData.LDNTime,'\0',n*21);
                memset((char*)FlashDCTbData.Dname,'\0',n*24); //hu binhao 2002-12-29
                memset((char*)FlashDCTbData.DForNameFlag,'\0',10); //hu binhao 2002-12-29
                FlashDCTbData.LDNID=0;
                flash_DCTbwrite();
                break;
            }
            CallsDeleteAllFlag=1; //hu binhao 2003-1-7
            SEND_EVENT(cugwindows,E_UPDATE,0,0);
            services_info_screen(win,TxtDone);  

            break;          
        }
        listsDestroy(ListData->win); 
        win_delete (data->recentcall_win);
        FREE_MEMORY ((void *)data->menu_list_data->List, 5 * sizeof (T_MFW_MNU_ITEM));
        FREE_MEMORY ((void *)data->menu_list_data, sizeof (ListMenuData));
        FREE_MEMORY ((void *)data, sizeof (T_RecentCall_INFO));

    }


}


int recentcall_GetListCount(void)
// Returns the number of the resource type available in the phone.
{
    int index=0;
    switch( recentcallbook )
    {
    
    case PHB_LMN: //WUFEI
        //while(strlen((char*)FlashDCTbData.LMNTable[index])>0 && index<10)
        //index++;
        return FlashDCTbData.LMNID;
        break;
    case PHB_LJN:
        //while(strlen((char*)FlashDCTbData.LRNTable[index])>0 && index<10)
        //index++;
        return FlashDCTbData.LJNID;
        break;
    case PHB_LRN:
        //while(strlen((char*)FlashDCTbData.LRNTable[index])>0 && index<10)
        //index++;
        return FlashDCTbData.LRNID;
        break;
    case PHB_LDN:       
        //while(strlen((char*)FlashDCTbData.LDNTable[index])>0 && index<10)
        //index++;
        return FlashDCTbData.LDNID;
        break;
    default: 
        break;

    }
    return index;
}
/*void ShowRencentCallDetail(char * num)
{
  

   dspl_Clear (0,112,119,144);//128
   dspl_DrawRect(0,112,119,144);//128
                              
   //if (FindNumber((char*)Current->list.entry[Index].number,searchdata)==TRUE)
   dspl_TextOut(1,114,0,num);
}*//*2003/12/4, wangyan delete*/

////////////hu bin hao append 2002-12-2 begin ///////////////

/*******************************************************************************

 $Function:     Rnum_exeDelAll

 $Description:  delete all types of recent number,such as "missed","rejected","reponse"and"dial".

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int Rnum_exeDelAll(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       parent        = mfwParent( mfw_header() );
    T_DISPLAY_DATA display_info;
    T_MFW_HND win = Rnum_create(parent);
    T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    T_RecentCall_INFO   *data       = (T_RecentCall_INFO *) win_data->user;

    // T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    // tTimerData   *data       = (tTimerData *) win_data->user;
    dialog_info_init(&display_info);//gdy add
    if( (FlashDCTbData.LMNID==0)&&(FlashDCTbData.LJNID==0)&&(FlashDCTbData.LRNID==0)&&(FlashDCTbData.LDNID==0) )
    {
        display_info.KeyEvents    = KEY_LEFT;
        display_info.TextId       = 0;
        display_info.TextId2      = TXTNoRecentNumber;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';
        display_info.LeftSoftKey  = 0;
        display_info.RightSoftKey = 0;
        //display_info.Time         = ONE_SECS;
        display_info.iconindex=REMIND_NORECORD;   //hu binhao 2003-1-6
        display_info.Time=FOREVER;
        //display_info.Identifier =0 ;  
        display_info.Callback     = (T_VOID_FUNC) Rnum_NoCalls_OK_cb;
    }
    else
    {
        display_info.KeyEvents    = KEY_CLEAR|KEY_LEFT|KEY_RIGHT;

        //display_info.TextId2       = TxtOkToDelete;
        display_info.TextId2       = TxtDeleteAll; /* 2003/10/29, wangyan, modify dialog delete style*/

        display_info.TextId= 0;
        display_info.TextString   = '\0';
        display_info.TextString2  = '\0';

        //display_info.LeftSoftKey  = TxtYes;   //hu binhao 2003-1-6
        //display_info.RightSoftKey = TxtNo;    //hu binhao 2003-1-6
        display_info.LeftSoftKey  = TxtSoftOK;   /* 2003/10/29, wangyan, modify dialog delete style*/
        display_info.RightSoftKey = TxtSoftBack;    /* 2003/10/29, wangyan, modify dialog delete style*/

        display_info.Time         = FOREVER;
        display_info.iconindex=REMIND_REQUIRE;  //2003-1-6
        // display_info.Identifier = ALL_CALLS_DURATION; 
        //  display_info.Identifier = 14;  //will be changed hu bin hao 2002-12-2
        display_info.Callback     = (T_VOID_FUNC) Rnum_reset_OK_cb;
    }
    info_dialog( win, &display_info );
    return MFW_EVENT_CONSUMED;

}

/*******************************************************************************

 $Function:     Rnum_create

 $Description:  create win

 $Returns:    

 $Arguments:  
        

*******************************************************************************/
static T_MFW_HND Rnum_create(MfwHnd parent_window)
{
    T_RecentCall_INFO     * data = (T_RecentCall_INFO *)ALLOC_MEMORY (sizeof(T_RecentCall_INFO));
    T_MFW_WIN  * win;

    if( data EQ NULL )
    {
        return NULL;
    }

    // Create window handler
    data->recentcall_win = win_create (parent_window, 0, E_WIN_VISIBLE, NULL);
    if( data->recentcall_win EQ NULL )
    {

        return NULL;
    }
    // connect the dialog data to the MFW-window
    data->mmi_control.dialog = (T_DIALOG_FUNC)NULL;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->recentcall_win)->data;
    win->user                = (T_RecentCall_INFO *)data;
    //  data->parent_win         = parent_window;
    data->parent         = parent_window;

    return data->recentcall_win;
}


/*******************************************************************************

 $Function:     Rnum_destroy

 $Description:  Destroys the timer window and frees up memory

 $Returns:    nothing

 $Arguments:  Window

*******************************************************************************/
void Rnum_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    //tTimerData   * data = (tTimerData *)ALLOC_MEMORY (sizeof(tTimerData));;
    //T_RecentCall_INFO   * data = (T_RecentCall_INFO *)ALLOC_MEMORY (sizeof(T_RecentCall_INFO));;
    T_RecentCall_INFO   * data ;

    if( own_window )
    {

        win_data = ((T_MFW_HDR *)own_window)->data;
        if( win_data != NULL )
            data = ( T_RecentCall_INFO   *)win_data->user;

        if( data )
        {
            //    TRACE_FUNCTION ("Rnum_destroy()");

            win_delete (data->recentcall_win);
            // Free Memory
            FREE_MEMORY (( void *)data, sizeof( T_RecentCall_INFO));

        }
        else
        {
            //    TRACE_EVENT ("Rnum_destroy() called twice");
        }
    }
}


/*******************************************************************************

 $Function:   Rnum_NoCalls_OK_cb

 $Description:  
 $Returns:    

 $Arguments:  window, identifier (which timer), Reason (which key pressed)

*******************************************************************************/
static int Rnum_NoCalls_OK_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    Rnum_destroy(win);
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:   Rnum_reset_OK_cb

 $Description:  Callback function for "OK to Delete timer" window
 $Returns:    status int

 $Arguments:  window, identifier (which timer), Reason (which key pressed)

*******************************************************************************/
static int Rnum_reset_OK_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{

    switch( Reason )
    {
    case INFO_KCD_LEFT:
        Reset_all_calls();display_reset_calls(win);Rnum_destroy(win);break;//WUFEI APPEND
        break;

    case INFO_KCD_RIGHT: 
    case INFO_KCD_HUP:
        Rnum_destroy(win);
        break;
    }

    return MFW_EVENT_CONSUMED;
}

/*************************hu bin hao*********************************************
 $Function:  Reset_all_calls
 $Description: Reset all calls
 $Returns: nothing
 $Arguments: none
*******************************************************************************/
void Reset_all_calls()
{
    //  TRACE_EVENT("Reset_all_calls()");
    memset((char*)FlashDCTbData.LMNTable,'\0',10*24);
    memset((char*)FlashDCTbData.LMNTime,'\0',10*21);
    memset((char*)FlashDCTbData.Mname,'\0',10*21);  //hu binhao 2002-12-30
    memset((char*)FlashDCTbData.MForNameFlag,'\0',10);  //hu binhao 2002-12-30
    memset((char*)FlashDCTbData.LMNflag,'\0',10);  //hu binhao 2002-12-30
    FlashDCTbData.LMNID=0;

    memset((char*)FlashDCTbData.LJNTable,'\0',10*24);
    memset((char*)FlashDCTbData.LJNTime,'\0',10*21);
    memset((char*)FlashDCTbData.Jname,'\0',10*21);  //hu binhao 2002-12-30
    memset((char*)FlashDCTbData.JForNameFlag,'\0',10);  //hu binhao 2002-12-30
    FlashDCTbData.LJNID=0;

    memset((char*)FlashDCTbData.LRNTable,'\0',10*24);
    memset((char*)FlashDCTbData.LRNTime,'\0',10*21);
    memset((char*)FlashDCTbData.Rname,'\0',10*21);  //hu binhao 2002-12-30
    memset((char*)FlashDCTbData.RForNameFlag,'\0',10);  //hu binhao 2002-12-30
    FlashDCTbData.LRNID=0;

    memset((char*)FlashDCTbData.LDNTable,'\0',10*24);
    memset((char*)FlashDCTbData.LDNTime,'\0',10*21);
    memset((char*)FlashDCTbData.Dname,'\0',10*21);  //hu binhao 2002-12-30
    memset((char*)FlashDCTbData.DForNameFlag,'\0',10);  //hu binhao 2002-12-30
    FlashDCTbData.LDNID=0;
    FlashDCTbData.MissedCallNum=0;//zy 2003-03-27
    flash_DCTbwrite();

    return;
}

/*******************************************************************************

 $Function:   display_reset_calls

 $Description:  Dsiplays confirmation that timer has been reset.
 $Returns:    none

 $Arguments:  parent window

*******************************************************************************/
void display_reset_calls(T_MFW_HND parent)
{
    T_DISPLAY_DATA display_info;
    //   TRACE_FUNCTION ("display_reset_calls()");

    // T_MFW_HND win = timer_create(parent);
    //	T_MFW_WIN       *win_data   = ( (T_MFW_HDR *) win )->data;
    //  tTimerData   *data       = (tTimerData *) win_data->user;

    dialog_info_init(&display_info);//gdy add
    display_info.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
    display_info.TextId       = 0;
    display_info.TextId2      = TxtDelSucceed;
    display_info.TextString   = NULL;
    display_info.TextString2  = NULL;
    display_info.LeftSoftKey  = TxtNull;
    display_info.RightSoftKey = TxtNull;
    display_info.Time         = FOREVER;
    display_info.Callback     = NULL;
    display_info.iconindex=REMIND_COMPLETE;     //2003-1-6
    info_dialog( parent, &display_info );
}
int NoRplyTime(struct MfwMnuTag* m, struct MfwMnuItemTag* i)
{   
    switch( (int)i->str )
    {
    case Txt5sec:
        strcpy(ss_data.edt_buf_NoAnswerTime,"5");
        // 	TRACE_EVENT("CFTime is 5");
        break;
    case Txt10sec:
        strcpy(ss_data.edt_buf_NoAnswerTime,"10");
        //	 	TRACE_EVENT("CFTime is 10");
        break;
    case Txt15sec:
        strcpy(ss_data.edt_buf_NoAnswerTime,"15");
        //	 	TRACE_EVENT("CFTime is 15");
        break;
    case Txt20sec:
        strcpy(ss_data.edt_buf_NoAnswerTime,"20");
        //	 	TRACE_EVENT("CFTime is 20");
        break;
    case Txt25sec:
        strcpy(ss_data.edt_buf_NoAnswerTime,"25");
        //	 	TRACE_EVENT("CFTime is 25");
        break;
    case Txt30sec:
        strcpy(ss_data.edt_buf_NoAnswerTime,"30");
        //	 	TRACE_EVENT("CFTime is 30");
        break;
    default:
        break;
    }
    SEND_EVENT(ss_data.win,ServicesDoCallDivert, 0, 0);
    bookMenuDestroy(ss_data.input_tim_menu);  //2003 1-14
    ss_data.input_tim_menu=0;

    return 0;

}
/*
BOOL IsCFSetMenu(void)
{
   if(ss_data.input_tim_menu)  
    return TRUE;
   else
    return FALSE;
}
*///zy move 12/29
static UBYTE GetPosition(char Rcalltype,const uint8 * Mnum) //hu binhao 2003-4-29
{
    UBYTE n;
    int i;
    n=0;
    switch( Rcalltype )
    {
    case 'M':
        n=FlashDCTbData.LMNID;
        for( i=0;i<n;i++ )
        {
            if( GetShortNumber((char *)FlashDCTbData.LMNTable[i])==GetShortNumber((char *)Mnum) )
            {
                if( strcmp((char*)FlashDCTbData.LMNTable[i],(char *)Mnum)==0 )
                {

                    break;
                }
            }
        }
        break;
    case 'J':
        n=FlashDCTbData.LJNID;
        for( i=0;i<n;i++ )
        {
            if( GetShortNumber((char *)FlashDCTbData.LJNTable[i])==GetShortNumber((char *)Mnum) )
            {
                if( strcmp((char*)FlashDCTbData.LJNTable[i],(char *)Mnum)==0 )
                {

                    break;
                }
            }
        }
        break;
    case 'R':
        n=FlashDCTbData.LRNID;
        for( i=0;i<n;i++ )
        {
            if( GetShortNumber((char *)FlashDCTbData.LRNTable[i])==GetShortNumber((char *)Mnum) )
            {
                if( strcmp((char*)FlashDCTbData.LRNTable[i],(char *)Mnum)==0 )
                {

                    break;
                }
            }
        }
        break;
    }
    return i;
}
