/*******************************************************************************

                    CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
                                                                              
********************************************************************************

 $Project name:	Basic MMI                                                      
 $Project code:	BMI                                                            
 $Module:		SMS
 $File:		    MmiSmsRead.c
 $Revision:		1.0                                                       
                                                                              
 $Author:		Condat(UK)                                                         
 $Date:		    25/10/00                                                      
                                                                               
********************************************************************************
                                                                              
 Description:
 
    Shared definitions of data elements are made in here
    and accessed via the primitive operations supplied
                        
********************************************************************************

 $History: MmiSmsRead.c

    25/10/00			Original Condat(UK) BMI version.	
  09/08         windy modified
  19/08/02   ver0.111   wangxia  modified 
 $End

*******************************************************************************/

#define MMI_SMSREAD_C

#define ENTITY_MFW

/* includes */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#if defined (NEW_FRAME)

    #include "typedefs.h"
    #include "vsi.h"
    #include "pei.h"
    #include "custom.h"
    #include "gsm.h"

#else

    #include "stddefs.h"
    #include "custom.h"
    #include "gsm.h"
    #include "vsi.h"

#endif
#include "p_sim.h"


#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "ksd.h"
#include "psa.h"
#include "mfw_sms.h"
#include "mfw_smsi.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"

#include "psa_util.h"

#include "dspl.h"
// #include "unicode_types.h"

#include "MmiMain.h"
#include "MmiDummy.h"
//#include "MmiLists.h"
#include "MmiMmi.h"
#include "mmicall.h"//GW 29/11/01 for 'callNumber'

#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiEditor.h"
#include "MmiBookShared.h" // MZ 
#include "mmiSmsMenu.h"
#include "MmiSmsSend.h"
#include "MmiSmsRead.h"
#include "MmiSmsIdle.h"
#include "mfw_ffs.h"

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"

#include "aci_cmh.h"	//GW 29/11/01 added for types in aci_fd.h
#include "aci_fd.h"		//GW 29/11/01 added for types in 'cmh.h'
#include "cmh.h" 		//GW 29/11/01 added for types in 'cmh_phb.h'
#include "cmh_phb.h"	//GW 29/11/01 added for cmhPHB_getAdrStr
#include "mfw_cnvt.h"
#include "mmiusersymbolinput.h"
#include "Mmiicons.h"
#include "mfw_ffs.h"
#include "GameDisplay.h"
#include "Mmitoolkit_timer.h"
//#define TDTRACE 1
#include "mmiutilapi.h"
#include "mmihost.h"	/* 2004/04/05 sunsj add */
#include "mmiiconresource.h"/* 2004/06 sunsj modify for icon manage */

//GW 29/11/01 - added header file - removed extern void callNumber(UBYTE* number);

// GSM alphabet characters unknown in the ASCII table have been replaced by <SP> characters
static const char g_translation_ascii_table[128] = { 64, 156, 36, 157, 138, 130, 151, 141, 149, 128,
    10,   2 ,  7,  32, 143, 134,   4,  95, 232, 226, 239, 234, 227,   5, 228,
    233, 240,  32, 146, 145, 225, 144,  32,  33,  34,  35,   1,  37,  38,  39,
    40,  41,  42,  43,  44, 45,  46,  47,  48,  49,  50,  51,  52,  53,  54,
    55,  56,  57,  58,  59,  60,  61,  62,  63, 173,  65,  66,  67,  68,  69,
    70,  71,  72,  73,  74,  75,  76,  77,  78,  79,  80,  81,  82,  83,  84,
    85,  86,  87,  88,  89,  90, 142, 153, 165, 154,  06, 168,  97,  98,  99,
    100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114,
    115, 116, 117, 118, 119, 120, 121, 122, 132, 148, 164, 129, 133};


static const int g_translation_unicode[128] = { 0x0040, 0x00A3, 0x0024, 0x00A5, 0x00E8, 0x00E9, 0x00F9, 0x00EC, 0x00F2, 0x00C7, 0x000A, 0x00D8, 0x00F8,
    0x000D, 0x00C5, 0x00E5, 0x0394, 0x005F, 0x03A6, 0x0393, 0x039B, 0x03A9, 0x03A0, 0x03A8, 0x03A3, 0x0398,
    0x039E, 0x03A2, 0x00C6, 0x00E6, 0x00DF, 0x00C9, 0x0020, 0x0021, 0x0022, 0x0023, 0x00A4, 0x0025, 0x0026,
    0x0027, 0x0028, 0x0029, 0x002A, 0x002B, 0x002C, 0x002D, 0x002E, 0x002F, 0x0030, 0x0031, 0x0032, 0x0033,
    0x0034, 0x0035, 0x0036, 0x0037, 0x0038, 0x0039, 0x003A, 0x003B, 0x003C, 0x003D, 0x003E, 0x003F, 0x00A1,
    0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047, 0x0048, 0x0049, 0x004A, 0x004B, 0x004C, 0x004D,
    0x004E, 0x004F, 0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057, 0x0058, 0x0059, 0x005A,
    0x00C4, 0x00D6, 0x00D1, 0x00DC, 0x00A7, 0x00BF, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067,
    0x0068, 0x0069, 0x006A, 0x006B, 0x006C, 0x006D, 0x006E, 0x006F, 0x0070, 0x0071, 0x0072, 0x0073, 0x0074,
    0x0075, 0x0076, 0x0077, 0x0078, 0x0079, 0x007A, 0x00E4, 0x00F6, 0x00F1, 0x00FC, 0x00E0};

/*********************************************************************

                 DYNAMIC MENU WINDOW. DECLARATION

**********************************************************************/


// Those information are passed to the sms editor
typedef struct
{
    SHORT          sms_index;
    T_MMI_SMS_STAT sms_type;
    T_MFW_SMS_PARA *sms_info;
    char *assoc_name;
}T_SMS_EDITOR_DATA;


/* This variable is used to know in which state we are when MFW callback function is called */
typedef struct
{
    SHORT nb_sms_stored;
    T_MFW_SMS_MSG sms_messages[MAX_MESSAGES]; /* store info about the SMS: index... */
    wstring_t* sms_header[MAX_MESSAGES]; /* header displayed in the dynamic menu */
}T_SMS_LIST_DATA;

typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;
    T_MFW_HND       kbd;
    /* associated handlers */

    T_MFW_HND       sms_handle;         /* MFW sms handler      */

    /* internal data */
    T_SMS_LIST_DATA sms_list_data;
    T_SMS_EDITOR_DATA sms_editor_data;
    T_MFW_HND   list_editor;
    ListMenuData *menu_list_data;
    UBYTE           option_select;  /* indicate what the user selected in the Optionsmenu*/

} T_SMSREAD_R;
//T_MFW_HND   list_editor;
typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;
    T_MFW_HND       editor_win;

    /* associated handlers */


    /* internal data */
    T_SMS_EDITOR_DATA *sms_editor_data;
    //T_SMS_LIST_DATA sms_list_data;
    ListMenuData *menu_list_data;
    //char editor_buffer[MAX_EDITOR_LEN];
} T_SMSREAD_R_TEXTEDT2;


typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */

    /* !!! **************************************** modify here **************************************** !!!*/
    T_MFW_HND       kbd;
    T_MFW_HND       kbd_long;
    T_MFW_HND       menu;
    /* !!! **************************************** end modify here **************************************** !!! */

    /* internal data */

    /* !!! **************************************** modify here **************************************** !!!*/
    BOOL            answer; /* TRUE == YES, FALSE == NO */
    T_MFW_HND       sms;
    T_MFW_HND       dialog_win;

    /* !!! **************************************** end modify here **************************************** !!! */
    T_SMS_EDITOR_DATA *sms_editor_data;    //NM 25.8
} T_SMSREAD_R_OPT;


typedef struct
{
    /* administrative data */

    T_MMI_CONTROL   mmi_control;
    T_MFW_HND       win;
    SHORT           id;
    T_MFW_HND       parent;

    /* associated handlers */


    /* internal data */
    T_SMS_EDITOR_DATA sms_editor_data;
    char editor_buffer[MAX_EDITOR_LEN];

} T_SMSREAD_R_TEXTEDT;


//MZ 7/02/01 graphic object type
// typedef MfwMnuItem *grph_Obj_t;

static enum
{
    READ_SMS_LIST,
    READ_FLASH_SMS_LIST,
    READ_SELECTED_FLASH_SMS,
    READ_SELECTED_SMS
} g_sms_state;  
static int g_sms_fixed_state;

//MZ 7/02/01 tmp enums.
static enum
{
    MFW_MB_LINE1,
    MFW_MB_DATA
}mfw_mailBox_type;

//static char buf[100];
static MfwMnuAttr readSMS_menuAttrib =
{
    0,
    &readSMS_menuArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};

/*2003/12/4, wangyan add*/
static MfwMnuAttr readSMS_menuAttribMo =
{
    0,
    &readSMS_menuAreaMo,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    NULL,                               /* with these items         */
    0                                   /* number of items     */
};

static T_MFW_HND SmsRead_R_OPT_create (T_MFW_HND parent);
static void SmsRead_R_OPT_destroy (T_MFW_HND window);
static void SmsRead_R_OPT_StandardDialog(T_MFW_HND win, int TextId, ULONG duration);
static void SmsRead_R_OPT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int SmsRead_R_OPT_win_cb (MfwEvt e, MfwWin *w);
//static int SmsRead_R_OPT_mfw_cb (MfwEvt event, void *parameter);
static int SmsRead_R_OPT_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
static int SmsRead_R_OPT_kbd_cb (MfwEvt e, MfwKbd *k);
static int SmsRead_R_OPT_mnu_cb (MfwEvt e, MfwMnu *m);
static int SmsRead_R_OPTExeDelete(MfwMnu* m, MfwMnuItem* i);
static int SmsRead_R_OPTExeReply(MfwMnu* m, MfwMnuItem* i);
static int SmsRead_R_OPTExeStoreNumber(MfwMnu* m, MfwMnuItem* i);
static int SmsRead_R_OPTExeForward(MfwMnu* m, MfwMnuItem* i);
void SmsRead_R_OPTExeCallNumber(void);
static int SmsRead_R_OPTExeEdit(MfwMnu* m, MfwMnuItem* i);
static int SmsRead_R_OPTExeToNVM(MfwMnu* m, MfwMnuItem* i);

/* 2004/06 sunsj modify for icon manage */
extern const MfwIcnAttr colist[];

static MfwMnuItem SmsRead_R_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtReply,0,(MenuFunc)SmsRead_R_OPTExeReply,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtForward,0,(MenuFunc)SmsRead_R_OPTExeForward,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtDelete,0,(MenuFunc)SmsRead_R_OPTExeDelete,item_flag_none},
    // {0,0,0,(char *)TxtEdit,0,(MenuFunc)SmsRead_R_OPTExeEdit,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtCallNumber,0,(MenuFunc)SmsRead_R_OPTExeCallNumber,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtExtractNumber,0,(MenuFunc)SmsRead_R_OPTExeStoreNumber,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSaveToNVM,0,(MenuFunc)SmsRead_R_OPTExeToNVM,item_flag_none}
};

static MfwMnuAttr SmsRead_R_OPTAttrib =
{
    0,
    &SmsRead_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsRead_R_OPTItems,                      /* with these items         */
    sizeof(SmsRead_R_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};
static MfwMnuItem SmsRead_FST_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtReply,0,(MenuFunc)SmsRead_R_OPTExeReply,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtDelete,0,(MenuFunc)SmsRead_R_OPTExeDelete,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtForward,0,(MenuFunc)SmsRead_R_OPTExeForward,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtExtractNumber,0,(MenuFunc)SmsRead_R_OPTExeStoreNumber,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtCallNumber,0,(MenuFunc)SmsRead_R_OPTExeCallNumber,item_flag_none}
};

static MfwMnuAttr SmsRead_FST_OPTAttrib =
{
    0,
    &SmsRead_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsRead_FST_OPTItems,                      /* with these items         */
    sizeof(SmsRead_FST_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};
static MfwMnuItem SmsRead_FSO_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtForward,0,(MenuFunc)SmsRead_R_OPTExeForward,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtDelete,0,(MenuFunc)SmsRead_R_OPTExeDelete,item_flag_none}
};

static MfwMnuAttr SmsRead_FSO_OPTAttrib =
{
    0,
    &SmsRead_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsRead_FSO_OPTItems,                      /* with these items         */
    sizeof(SmsRead_FSO_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};
static MfwMnuItem SmsRead_RO_OPTItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtForward,0,(MenuFunc)SmsRead_R_OPTExeForward,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtDelete,0,(MenuFunc)SmsRead_R_OPTExeDelete,item_flag_none},
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtSaveToNVM,0,(MenuFunc)SmsRead_R_OPTExeToNVM,item_flag_none}
};

static MfwMnuAttr SmsRead_RO_OPTAttrib =
{
    0,
    &SmsRead_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsRead_RO_OPTItems,                      /* with these items         */
    sizeof(SmsRead_RO_OPTItems)/sizeof(MfwMnuItem) /* number of items     */
};

static MfwMnuItem SmsRead_R_OPTInvalidItems [] =
{
    {(MfwIcnAttr *)&colist,0,0,(char *)TxtDelete,0,(MenuFunc)SmsRead_R_OPTExeDelete,item_flag_none}
};
static MfwMnuAttr SmsRead_R_OPTInvalidAttrib =
{
    0,
    &SmsRead_R_OPTArea,
    MNU_LEFT | MNU_LIST | MNU_CUR_LINE, /* centered page menu       */
    -1,                                 /* use default font         */
    SmsRead_R_OPTInvalidItems,                      /* with these items         */
    sizeof(SmsRead_R_OPTInvalidItems)/sizeof(MfwMnuItem) /* number of items     */
};

SHORT g_sms_list_counter=0;

static SHORT g_nb_line_sms;

static  T_MFW_HND       info_win=0;
static T_MFW_HND        deleting_win = 0;
static  T_MFW_HND       list_win=0;

/* R is the identifier used for the function of the Read menu window */
static T_MFW_HND SmsRead_R_create (T_MFW_HND parent);
static void SmsRead_R_destroy (T_MFW_HND window);
static void SmsRead_R_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int SmsRead_R_win_cb (MfwEvt e, MfwWin *w);
static int SmsRead_R_mfw_cb(MfwEvt event, void *parameter);
static int SmsRead_R_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
static void SmsRead_R_smslist_cb(T_MFW_HND * Parent, ListMenuData * ListData);
static void SmsRead_R_BuildList(T_MFW_HND win,int inUnicode);
void SmsRead_R_Flash_BuildList(T_MFW_HND win, int inUnicode);

// Fill an unicode structure for display
void string_CopyW2W(wstring_t *strDestination, charw_t *strSource, USHORT count );

static T_MFW_HND SmsRead_R_TEXTEDT_create (T_MFW_HND parent);
static void SmsRead_R_TEXTEDT_destroy (T_MFW_HND window);
static void SmsRead_R_TEXTEDT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int SmsRead_R_TEXTEDT_win_cb (MfwEvt e, MfwWin *w);
static void SmsRead_R_TEXTEDT_editor_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);

static T_MFW_HND SmsRead_R_TEXTEDT2_create (T_MFW_HND parent);
static void SmsRead_R_TEXTEDT2_destroy (T_MFW_HND window);
static void SmsRead_R_TEXTEDT2_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int SmsRead_R_TEXTEDT2_win_cb (MfwEvt e, MfwWin *w);
static void SmsRead_R_TEXTEDT2_editor_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
static void SmsRead_R_TEXTEDT2_smslist_cb(T_MFW_HND * Parent, ListMenuData * ListData);
int SmsRead_R_KINDExeIncoming(MfwMnu* m, MfwMnuItem* i);
int SmsRead_R_KINDExeOutgoing(MfwMnu* m, MfwMnuItem* i);
int FlashSMS_DEL_OPT_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
void FLASH_Sms_DELETED_Dialog(T_MFW_HND win,  int TextId, ULONG duration);
int FLASH_Sms_DELETED_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
int FlashSMS_DEL_OPT_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
// Added new dialog for searching for numbers in SMS message.
static T_MFW_HND smsRead_NumberName_info_screen(T_MFW_HND parent_window, T_SmsUserData *UserData,char* name);
UBYTE check_assoc_name(char *name, T_MFW_SMS_ADDR sms_addr);
char sms_text_ascii[MAX_MSG_LEN+3];//[MAX_LISTSMS_LEN];
char sms_readtext[MAX_MSG_LEN+3];
char sms_text_buffer[MAX_LISTSMS_LEN+3];
MfwEdtAttr  sms_editor_attr;

/* we need this variable "read_status" to know which sms message we are going
   to edit (user pressed in the sms menu-> EDIT)
   because SMS_MT & SMS_MO have different size of character 
   (current length saved in "current_sms_len") !!
   SMS_MT includes additional TIME, DATE and NUMBER and we dont want
   to show it when we are editing.
*/
//static UBYTE read_status;
static USHORT current_sms_len= 0;

static T_SmsUserData   SmsData;
char buf[MAX_EDITOR_LEN];
//char indexsms[5];
static T_MFW_SMS_STAT sms_list_type;
static T_MFW_SMS_MO    MO;
static T_MFW_SMS_MT    MT;
static char sms_list_time[30];
static int type;
//int type;/* 2004/4/20, wangyan modify */
static int ModifyMenuList=0;

static BOOL Search_forNextNumber(T_SmsUserData *UserData);
int ComTime(UINT16 y1,UINT16 m1,UINT16 d1,UINT16 h1,UINT16 mi1,
            UINT16 y2,UINT16 m2,UINT16 d2,UINT16 h2,UINT16 mi2);
void SortSms(SHORT l_found,T_MFW_SMS_MSG * msg_list) ;
int Flash_sms_delete(SHORT index,ListMenuData *menu_list_data);
int Moveup_Flash_sms(SHORT index,ListMenuData *menu_list_data);
extern UINT8 g_pcsyncstatus ;//hxl add ,if  pcsync run ,return,2003-2-13
int SmsDel_Useless_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason);
int Moveup_List_sms(SHORT index,T_SMS_LIST_DATA * list_data,ListMenuData *menu_list_data);
extern unsigned char no_wait;
#define TIME_THREESEC     3000//every 6 seconds read SMS PBK state
static MfwHnd smsphkchecktimer;          /* clock via software timer */

/*******************************************************************************

 $Function:    	charPtrToUBYTEPtr

 $Description:	Converts a char ptr to a UBYTE ptr. The procedures can be replaced by macro 
                once all conversions are confirmed as valid.
                
 $Returns:		data set to new type

 $Arguments:	data -data item of input type.
 
*******************************************************************************/
#ifndef MMI_USE_MACROS
UBYTE   charToUBYTE             ( char chr )    {   return((UBYTE)chr);}
UBYTE*  charPtrToUBYTEPtr       ( char *ptr )   {   return((UBYTE*)ptr);}
UBYTE   SHORTToUBYTE            ( SHORT data )  {   return((UBYTE)data);}

char    UBYTEToChar             ( UBYTE data)   {   return((char)data);}
char*   UBYTEPtrToCharPtr       ( UBYTE* data)  {   return((char*)data);}
char*   USHORTPtrToCharPtr  ( USHORT* data) {   return((char*)data);}

USHORT  charToUSHORT            ( char chr )    {   return((USHORT)chr);}
USHORT  UBYTEToUSHORT           ( UBYTE data)   {   return((USHORT)data);}
USHORT* charPtrToUSHORTPtr  (char* data)        {   return((USHORT*)data);}

#else
    #define 	charToUBYTE			(UBYTE)
    #define 	charPtrToUBYTEPtr	(UBYTE*)
    #define 	SHORTToUBYTE		(UBYTE)	

    #define		UBYTEPtrToCharPtr	(char*)
    #define		UBYTEToChar			(char)
    #define		USHORTPtrToCharPtr	(char*)

    #define 	charToUSHORT		(USHORT)	
    #define 	UBYTEToUSHORT		(USHORT)
    #define		charPtrToUSHORTPtr	(USHORT*)
#endif
T_MMI_FLASH_SORT_INDEX Flash_sms_sort_index[FLSAH_SMS_NUM];
int total=0;
FlashSms * tmp_flash;
/*******************************************************************************

 $Function:  smsphkchecktimeEvent

 $Description:   times event  clock

 $Returns:    none.

 $Arguments:

*******************************************************************************/

static int smsphkchecktimeEvent (MfwEvt e, MfwTim *t)
{
    static int wait=2;/**/

    if( no_wait )
    {
        if( (bookPhoneBookLoading()==BOOK_SUCCESS) && smsidle_get_ready_state() )
        {
            if( wait )
            {
                timStart(smsphkchecktimer);
                wait--;
            }
            else
            {
                timStop(smsphkchecktimer);
                timDelete(smsphkchecktimer);
                smsphkchecktimer=0;
                //yq added for set phbwaitflag
                no_wait=0;
                if( info_win )
                {
                    SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
                    info_win = 0;
                }
                SmsRead_R_start(NULL,(T_MFW_SMS_STAT*) &sms_list_type);
            }
        }
        else
            timStart(smsphkchecktimer);
    }
    else
    {
        timStop(smsphkchecktimer);
        timDelete(smsphkchecktimer);
        smsphkchecktimer=0;
        if( info_win )
        {
            SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
            info_win = 0;
        }
        SmsRead_R_start(NULL,(T_MFW_SMS_STAT*) &sms_list_type);
    }
    return 1;
}
/*******************************************************************************

 $Function:    	Moveup_List_sms

 $Description:	move flash sms up 
            
 $Returns:		if success return 1 else return 0

 $Arguments:	
*******************************************************************************/
int Moveup_List_sms(SHORT index,T_SMS_LIST_DATA * list_data,ListMenuData *menu_list_data)
{
    SHORT  i=index,Count;
    TRACE_FUNCTION ("Moveup_List_sms()");

    Count = list_data->nb_sms_stored;
    sprintf(buf,">>>> ,list_data->nb_sms_stored=%d",list_data->nb_sms_stored);
    TRACE_EVENT(buf);
    /* Move the list data up one. */
    while( i < Count-1 ) //c005 rsa avoid copying from behind the array
    {
        list_data->sms_messages[i] = list_data->sms_messages[i+1] ; 
        memcpy(menu_list_data->List[i].str,menu_list_data->List[i+1].str,MENU_TEXT_LENGTH);
        menu_list_data->List[i].icon=menu_list_data->List[i+1].icon;
        i++;
    }
    //list_data->nb_sms_stored--;
    g_nb_line_sms =list_data->nb_sms_stored-1;
    return MFW_SMS_OK;
}
/*******************************************************************************

 $Function:    	Find_avail

 $Description:	find available flash sms table location 
            
 $Returns:		if success return location else return 0

 $Arguments:	
*******************************************************************************/
int Find_avail()
{
    int i,j=0,k=-1;

    TRACE_FUNCTION ("Find_avail()");
    /*first find the available item in current table   */
    for( i=0;i<FlashSMS_table_len;i++ )
    {
        if( Flash_sms_messages[CurrentFlashSmsTable*FlashSMS_table_len+i].flag==FALSE )
        {
            k=i;
            break;
        }
    }
    if( k!=-1 )
        /*if find one return the index*/
        return k;
    else
    {
        for( i=0;i<FLSAH_SMS_NUM;i++ )
            if( Flash_sms_messages[i].flag==FALSE )
            {
                k=i;
                break;
            }
        CurrentFlashSmsTable=k/FlashSMS_table_len;
        flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
        /*if find one return the index*/
        return(k%FlashSMS_Table);
    }
}
/*******************************************************************************

 $Function:    	Find_Del_Table

 $Description:	find which table has the right id sms
            
 $Returns:		if success return location else return 0

 $Arguments:	
*******************************************************************************/
int Find_Del_Table(UBYTE id)
{
    int  i,j=0,k=-1;

    TRACE_FUNCTION ("Find_Del_Table()");

    for( i=0;i<FlashSMS_table_len;i++ )
        if( Flash_sms_messages[CurrentFlashSmsTable*FlashSMS_table_len+i].id==id )
        {
            k=i;
            break;
            //return i;
        }
    if( k!=-1 )
        return k;
    else
    {
        for( j=0;((j<FlashSMS_Table)&&(j !=CurrentFlashSmsTable));j++ )//
        {
            for( i=0;i<FlashSMS_table_len;i++ )
                if( Flash_sms_messages[j*FlashSMS_table_len+i].id==id )
                {
                    k=i;
                    //return i;
                    sprintf(buf,">>>> ,Find_CurrentFlashSmsTable=%d,i=%d",CurrentFlashSmsTable,i);
                    TRACE_EVENT(buf);
                    break;
                }
            if( k!=-1 )
                break;
        }
        flash_Smsread(FlashSMSTable[j]);
        CurrentFlashSmsTable=j;
        return k;
    }
}

/*******************************************************************************

 $Function:    	FreshTableId

 $Description:	Fresh every item's id for deleted one
            
 $Returns:		if success return location else return 0

 $Arguments:	
*******************************************************************************/
void FreshTableId(UBYTE id)
{
    int  i,j=0;
    BOOL k=FALSE;

    TRACE_FUNCTION ("FreshTableId()");

    for( i=0;i<FlashSMStotal;i++ )
    {
        if( Flash_sms_sort_index[i].id>id )
        {
            Flash_sms_sort_index[i].id--;
            //sprintf(buf,">>>> ,Flash_sms_sort_index[%d].id=%d",i,Flash_sms_sort_index[i].id);
            //TRACE_EVENT(buf);
        }
    }

    for( j=0;((j<FlashSMS_Table));j++ )//&&(j !=CurrentFlashSmsTable)
    {
        flash_Smsread(FlashSMSTable[j]);
        for( i=0;i<FlashSMS_table_len;i++ )
        {
            if( (Flash_sms_messages[j*FlashSMS_table_len+i].id>id)
                &&(Flash_sms_messages[j*FlashSMS_table_len+i].flag!=FALSE) )
            {
                Flash_sms_messages[j*FlashSMS_table_len+i].id--;
                //sprintf(buf,">>>> ,Flash_sms_messages[%d].id=%d",
                //	j*FlashSMS_table_len+i,Flash_sms_messages[j*FlashSMS_table_len+i].id);
                //TRACE_EVENT(buf);
            }
            if( (FFS_SMSData.NVMSMS[i].id>id)&&(FFS_SMSData.NVMSMS[i].flag!=FALSE) )
            {
                FFS_SMSData.NVMSMS[i].id--;
                //sprintf(buf,">>>> ,FFS_SMSData.NVMSMS[i].id=%d",FFS_SMSData.NVMSMS[i].id);
                //TRACE_EVENT(buf);
                k=TRUE;
            }
        }
        if( k )
        {
            flash_Smswrite(FlashSMSTable[j]);
            k=FALSE;
        }
    }

    flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
    return ;
}
/*******************************************************************************

 $Function:    	SortFlashSms

 $Description:	sort the sms by its time stamp 
            
 $Returns:		the sorted sms list

 $Arguments:	
*******************************************************************************/
void SortFlashSms(T_MFW_SMS_STAT stat,T_MMI_FLASH_SMS_INDEX * msg_list) 
{
    UINT8 i,j;
    T_MMI_FLASH_SORT_INDEX temp;
    UINT16 year,month,day,hour,minute,year0,month0,day0,hour0,minute0;
    T_MMI_FLASH_SMS_INDEX *temp1,*temp2;

    TRACE_FUNCTION ("SortFlashSms()");

    memset(Flash_sms_sort_index,0,sizeof(T_MMI_FLASH_SORT_INDEX)*FLSAH_SMS_NUM);
    total=0;
    switch( stat )
    {
    case MFW_SMS_FLASH_MT:
        for( i=0;i<FLSAH_SMS_NUM;i++ )
        {
            if( msg_list[i].flag!=FALSE )
            {
                if( msg_list[i].state==MFW_SMS_MT )
                {
                    Flash_sms_sort_index[total].index=msg_list[i].index;
                    Flash_sms_sort_index[total].id=msg_list[i].id;
                    sprintf(buf,">>>> ,SortFlashSms,msg_list[%d].state=%d",i,msg_list[i].state);
                    TRACE_EVENT(buf);
                    total++;
                }
            }
        }
        break;

    case MFW_SMS_FLASH_MO:
        for( i=0;i<FLSAH_SMS_NUM;i++ )
        {
            if( msg_list[i].flag!=FALSE )
            {
                if( msg_list[i].state == MFW_SMS_STOR_UNSENT
                    ||msg_list[i].state == MFW_SMS_STOR_SENT )
                {
                    Flash_sms_sort_index[total].index=msg_list[i].index;
                    Flash_sms_sort_index[total].id=msg_list[i].id;
                    total++;
                }
            }
        }
        break;

    default:
        break;
    }
    //sprintf(buf,">>>> ,SortFlashSms,Flash_sms_sort_index[total].index=%d,id=%d,total=%d",list_data->nb_sms_stored);
    //TRACE_EVENT(buf);
#if 1
    switch( stat )
    {
    case MFW_SMS_FLASH_MT:
        for( i=1;i<total;i++ )
            for( j=0;j<total-i;j++ )
            {
                temp1=&Flash_sms_messages[Flash_sms_sort_index[j].index];
                temp2=&Flash_sms_messages[Flash_sms_sort_index[j+1].index];
                year=((temp1->time.year[0])%13)*10+(temp1->time.year[1])%13;
                month=(temp1->time.month[0]%13)*10+temp1->time.month[1]%13;
                day=(temp1->time.day[0]%32)*10+temp1->time.day[1]%32;
                hour=(temp1->time.hour[0]%24)*10+temp1->time.hour[1]%24;
                minute=(temp1->time.minute[0]%60)*10+temp1->time.minute[1]%60;
                year0=((temp2->time.year[0])%13)*10+(temp2->time.year[1])%13;
                month0=(temp2->time.month[0]%13)*10+temp2->time.month[1]%13;
                day0=(temp2->time.day[0]%32)*10+temp2->time.day[1]%32;
                hour0=(temp2->time.hour[0]%24)*10+temp2->time.hour[1]%24;
                minute0=(temp2->time.minute[0]%60)*10+temp2->time.minute[1]%60;
                if( ComTime(year0,month0,day0,hour0,minute0,year,month,day,hour,minute) )
                {
                    memset(&temp, 0, sizeof(T_MMI_FLASH_SORT_INDEX));
                    memcpy(&temp,&Flash_sms_sort_index[j],sizeof(T_MMI_FLASH_SORT_INDEX)); 
                    memcpy(&Flash_sms_sort_index[j],&Flash_sms_sort_index[j+1],sizeof(T_MMI_FLASH_SORT_INDEX)); 
                    memcpy(&Flash_sms_sort_index[j+1],&temp,sizeof(T_MMI_FLASH_SORT_INDEX)); 
                }
            }
        break;

    case MFW_SMS_FLASH_MO:
        for( i=1;i<total;i++ )
            for( j=0;j<total-i;j++ )
            {
                if( Flash_sms_sort_index[j].id>Flash_sms_sort_index[j+1].id )
                {
                    memset(&temp, 0, sizeof(T_MMI_FLASH_SORT_INDEX));
                    memcpy(&temp,&Flash_sms_sort_index[j],sizeof(T_MMI_FLASH_SORT_INDEX)); 
                    memcpy(&Flash_sms_sort_index[j],&Flash_sms_sort_index[j+1],sizeof(T_MMI_FLASH_SORT_INDEX)); 
                    memcpy(&Flash_sms_sort_index[j+1],&temp,sizeof(T_MMI_FLASH_SORT_INDEX)); 
                }
            }
        break;

    default:
        break;
    }
#endif
}

/*******************************************************************************

 $Function:    	Fresh_Del_TableId

 $Description:	delete the requsted item and fresh every item's ID more than that of the deleted one
            
 $Returns:		if success return location else return 0

 $Arguments:	
*******************************************************************************/
void Fresh_Del_TableId(UBYTE id)
{
    int  i,j=0;
    BOOL k=FALSE;

    TRACE_FUNCTION ("Fresh_Del_TableId()");

    for( j=0;((j<FlashSMS_Table));j++ )//&&(j !=CurrentFlashSmsTable)
    {
        flash_Smsread(FlashSMSTable[j]);
        CurrentFlashSmsTable=j;
        for( i=0;i<FlashSMS_table_len;i++ )
        {
            if( (Flash_sms_messages[j*FlashSMS_table_len+i].id==id)
                &&(Flash_sms_messages[j*FlashSMS_table_len+i].flag!=FALSE) )
            {
                Flash_sms_messages[j*FlashSMS_table_len+i].flag=FALSE;
            }
            else if( (Flash_sms_messages[j*FlashSMS_table_len+i].id>id)
                     && (Flash_sms_messages[j*FlashSMS_table_len+i].flag!=FALSE) )
            {
                Flash_sms_messages[j*FlashSMS_table_len+i].id--;
                //sprintf(buf,">>>> ,Flash_sms_messages[%d].id=%d",
                //	j*FlashSMS_table_len+i,Flash_sms_messages[j*FlashSMS_table_len+i].id);
                //TRACE_EVENT(buf);
            }
            if( (FFS_SMSData.NVMSMS[i].id==id) && (FFS_SMSData.NVMSMS[i].flag!=FALSE) )
            {
                FFS_SMSData.NVMSMS[i].flag=FALSE;
                k=TRUE;
            }
            else if( (FFS_SMSData.NVMSMS[i].id>id)&&(FFS_SMSData.NVMSMS[i].flag!=FALSE) )
            {
                FFS_SMSData.NVMSMS[i].id--;
                k=TRUE;
                //sprintf(buf,">>>> ,FFS_SMSData.NVMSMS[i].id=%d",FFS_SMSData.NVMSMS[i].id);
                //TRACE_EVENT(buf);
            }
        }
        if( k )
        {
            flash_Smswrite(FlashSMSTable[j]);
            k=FALSE;
        }
    }
    for( i=0;i<FlashSMStotal;i++ )
    {
        if( Flash_sms_sort_index[i].id>id )
        {
            Flash_sms_sort_index[i].id--;
            //sprintf(buf,">>>> ,Flash_sms_sort_index[%d].id=%d",i,Flash_sms_sort_index[i].id);
            //TRACE_EVENT(buf);
        }
    }
    //flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
    return ;
}
/*******************************************************************************

 $Function:    	Flash_sms_delete

 $Description:	delete sms saved at FLASH 
            
 $Returns:		if success return 1 else return 0

 $Arguments:	
*******************************************************************************/
int Flash_sms_delete(SHORT index,ListMenuData *menu_list_data)
{
    FlashSms * tmp;
    int i ;
    UBYTE id;
    TRACE_FUNCTION ("Flash_sms_delete()");

    id=Flash_sms_sort_index[index].id;

    /*i=Find_Del_Table(Flash_sms_sort_index[index].id);
    sprintf(buf,">>>> ,Flash_sms_sort_index[%d].id=%d",index,Flash_sms_sort_index[index].id);
    TRACE_EVENT(buf);
    tmp=&FFS_SMSData.NVMSMS[i];
    tmp->flag=FALSE;
    Flash_sms_messages[i+CurrentFlashSmsTable*FlashSMS_table_len].flag=FALSE;
    flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);
    FreshTableId( id);*/

    /*decrease the id of those items whose id is more than the one deleted*/
    Fresh_Del_TableId( id);
    for( i=index;i<FlashSMStotal-1;i++ )
    {
        Flash_sms_sort_index[i]=Flash_sms_sort_index[i+1];
        memcpy(menu_list_data->List[i].str,menu_list_data->List[i+1].str,MENU_TEXT_LENGTH);
        menu_list_data->List[i].icon=menu_list_data->List[i+1].icon;
    }
    FlashSMStotal--;
    total--;
    //g_nb_line_sms =FFS_SMSData.total;
    menu_list_data->ListLength--;
    menu_list_data->SnapshotSize--;
    //flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);
    return MFW_SMS_OK;
}
/*******************************************************************************

 $Function:    	SmsRead_convertSMSmsg

 $Description:	Convert a string into an ascii string with 0x80 as first word if data is unicode
            
 $Returns:		execution status

 $Arguments:	ipString - input byte array
                ipDataType - type of input data
                ipLength - length of input string (in bytes) 
                opString - output byte array
                opDataType - type of output data
                opLength - length of output string (in bytes) 
*******************************************************************************/

int SmsRead_convertSMSmsg(          char * ipString,    UBYTE ipDataType,   int ipLength,
                                    char * opString,    UBYTE opDataType,   int opLength, UBYTE addNull)
{
    int i;
    UBYTE text_8bit[MAX_EDITOR_LEN+1];  //buffer for conversion from 7bit to 8bit
    int len;
    if( (opString == NULL) || (ipString==NULL) || (opLength ==0) )
        return(FALSE);
    opString[0] = 'X';
    opString[1] = '?';
    opString[2] = 0x00;

    switch( ipDataType )
    {
    case MFW_DCS_UCS2:
    default:    //assume if no valid type, input type is 8bit ascii.
        if( opDataType == MFW_DCS_UCS2 )
        {   //Copy array and add 0x80, 0x7F as first word
            if( ipLength < opLength )
                len = ipLength;
            else
                len = opLength;
            opString[0]=0x80;
            for( i=1;i<=len;i++ )
                opString[i] = ipString[i-1];
            if( len+2<opLength )
            {
                opString[len+1  ] = 0x00;
                opString[len+2] = 0x00;
            }
        }
        else if( opDataType == MFW_DCS_8bits )
        {
            if( ipLength/2 < opLength )
                len = ipLength/2;
            else
                len = opLength;

            for( i=0;i<len;i++ )
            {
                if( ipString[i*2] == 0x00 )  //ascii char - display 
                    opString[i] = ipString[i*2+1];
                else    //unknown char - display '?'
                    opString[i] = '?';
            }
            if( len<opLength )
            {
                opString[len  ] = 0x00;
            }

        }
        else    //Output data type is 7 bits - not implemented
        {
        }
        break;
    case MFW_DCS_8bits:
        //	default:	//assume if no valid type, input type is 8bit ascii.
        if( ipLength <=0 )
            ipLength = strlen(ipString); //calculate length if not supplied
        if( opDataType == MFW_DCS_UCS2 )
        {   //Convert data to unicode
            if( ipLength*2 < opLength )
                len = ipLength;
            else
                len = opLength/2;
            for( i = 0; i < len; i++ )
            {
                opString[i*2]   = 0x00;
                opString[i*2+1] = ipString[i];
            }
            if( len*2+1 < opLength )
            {
                opString[len*2]   = 0x00;
                opString[len*2+1] = 0x00;
            }
        }
        else if( opDataType == MFW_DCS_8bits )
        {   //Data already in correct format - copy
            if( ipLength < opLength )
                len = ipLength;
            else
                len = opLength;
            for( i=0;i<len;i++ )
                opString[i] = ipString[i];
            if( len<opLength )
                opString[len] = 0x00;
        }
        else if( opDataType == MFW_ASCII )
        {
            TRACE_EVENT_P2("ipLength: %d, oplength: %d", ipLength, opLength);
            if( ipLength < opLength )
                len = ipLength;
            else
                len = opLength;
            for( i = 0; i < len; i++ )
            {
                opString[i] = g_translation_ascii_table[/*UBYTEToChar*/(ipString[i])];
            }
            //				opLength = ipLength;
        }
        else // convert data to 7bit
        {
            TRACE_EVENT("ELSE 7bit convertion");
            len = utl_cvt8To7 ((UBYTE *)ipString , ipLength, (UBYTE*)opString, 0);              
        }
        break;
    case MFW_DCS_7bits:
        if( opDataType == MFW_DCS_7bits ) //text string is already in this format
        {
            //Data already in correct format - copy
            if( ipLength < opLength )
                len = ipLength;
            else
                len = opLength;
            for( i=0;i<len;i++ )
                opString[i] = ipString[i];
            if( len<opLength )
                opString[len] = 0x00;
        }
        else if( opDataType == MFW_DCS_8bits )
        {
            len = utl_cvt7To8 ((UBYTE *)ipString , ipLength, text_8bit, 0 );
            if( len > opLength )
                len = opLength;
            for( i = 0; i < len; i++ )
            {
                opString[i] = g_translation_ascii_table[UBYTEToChar(text_8bit[i])];
            }
            if( len <opLength )
                opString[len] = 0x00;
            else
                opString[opLength]=0x00;
        }
        else if( opDataType == MFW_ASCII )
        {
            for( i = 0; i < len; i++ )
            {
                opString[i] = g_translation_ascii_table[/*UBYTEToChar*/(ipString[i])];
            }
            //				opLength = ipLength;
        }
        else
        {   //Convert to unicode
            len = utl_cvt7To8 ((UBYTE *)ipString , ipLength, text_8bit, 0 );
            if( len*2 > opLength )
                len = opLength/2;
            for( i = 0; i < len; i++ )
            {
                opString[i*2]   = 0x00;
                opString[i*2+1] = g_translation_ascii_table[UBYTEToChar(text_8bit[i])];
            }
            if( len*2+1 < opLength )
            {
                opString[len*2]   = 0x00;
                opString[len*2+1] = 0x00;
            }
        }
        break;
    case MFW_ASCII:
        {   if( opDataType == MFW_DCS_8bits )
            {
                int i, j;
                if( ipLength < opLength )
                    len = ipLength;
                else
                    len = opLength;
                for( i=0; i<len; i++ )/*for each char*/
                {
                    /*if character same in ASCII as GSM, just copy char*/
                    if( ipString[i] == g_translation_ascii_table[ipString[i]] )
                    {
                        opString[i] = ipString[i];
                    }
                    else/*find match in table and copy index of match*/
                    {
                        for( j=0; j<128; j++ )
                        {
                            if( ipString[i] == g_translation_ascii_table[j] )
                            {
                                opString[i] = j;
                            }
                            break;
                        }
                    }
                }
            }

            break;
        }
    }
    if( addNull )
    {   //Add 0x00 (or 0x00,0x00) to end of array
        opString[opLength-1] = 0x00;
        if( opDataType == MFW_DCS_UCS2 )
        {
            opString[opLength-2] = 0x00;
        }
    }
    return TRUE;
}
/*******************************************************************************

 $Function:    	ChangeTime

 $Description:	change the input time 
            
 $Returns:		return 0

 $Arguments:	
*******************************************************************************/
void ChangeTime( char * text,T_MFW_SMS_SCTP*    rctp)
{
    int index=0;
    MMI_TRACE_EVENT(("ChangeTime()"));

    text[index++]='0'+rctp->month[0];
    text[index++]='0'+rctp->month[1];
    text[index++]='/';
    text[index++]='0'+rctp->day[0];
    text[index++]='0'+rctp->day[1];
    text[index++]=',';

    text[index++] ='0'+rctp->hour[0];
    text[index++]='0'+rctp->hour[1];
    text[index++]=':';
    text[index++]='0'+rctp->minute[0];
    text[index++]='0'+rctp->minute[1];
    return;
    //text[index++]='\n';	
}
/*******************************************************************************

 $Function:    	ComTime

 $Description:	compare the input time 
            
 $Returns:		if time1>time2 return 1 else return 0

 $Arguments:	
*******************************************************************************/
int ComTime(UINT16 y1,UINT16 m1,UINT16 d1,UINT16 h1,UINT16 mi1,
            UINT16 y2,UINT16 m2,UINT16 d2,UINT16 h2,UINT16 mi2)
{
    TRACE_FUNCTION ("ComTime()");
    if( y1>y2 )
        return 1;
    else if( y1==y2 && m1>m2 )
        return 1;
    else if( y1==y2 && m1==m2 && d1>d2 )
        return 1;
    else if( y1==y2 && m1==m2 && d1==d2 && h1>h2 )
        return 1;
    else if( y1==y2 && m1==m2 && d1==d2 && h1==h2 && mi1>mi2 )
        return 1;
    else
        return 0;
}
/*******************************************************************************

 $Function:    	SortSms

 $Description:	sort the sms by its time stamp 
            
 $Returns:		the sorted sms list

 $Arguments:	
*******************************************************************************/
void SortSms(SHORT l_found,T_MFW_SMS_MSG * msg_list) 
{
    UINT16 year,month,day,hour,minute,year0,month0,day0,hour0,minute0;
    UINT8 i,j;
    T_MFW_SMS_MSG temp;
    TRACE_FUNCTION ("SortSms()");

    for( i=1;i<l_found;i++ )
        for( j=0;j<l_found-i;j++ )
        {
            year=((msg_list[j].rctp.year[0])%13)*10+(msg_list[j].rctp.year[1])%13;
            month=(msg_list[j].rctp.month[0]%13)*10+msg_list[j].rctp.month[1]%13;
            day=(msg_list[j].rctp.day[0]%32)*10+msg_list[j].rctp.day[1]%32;
            hour=(msg_list[j].rctp.hour[0]%24)*10+msg_list[j].rctp.hour[1]%24;
            minute=(msg_list[j].rctp.minute[0]%60)*10+msg_list[j].rctp.minute[1]%60;

            year0=((msg_list[j+1].rctp.year[0])%13)*10+(msg_list[j+1].rctp.year[1])%13;
            month0=(msg_list[j+1].rctp.month[0]%13)*10+msg_list[j+1].rctp.month[1]%13;
            day0=(msg_list[j+1].rctp.day[0]%32)*10+msg_list[j+1].rctp.day[1]%32;
            hour0=(msg_list[j+1].rctp.hour[0]%24)*10+msg_list[j+1].rctp.hour[1]%24;
            minute0=(msg_list[j+1].rctp.minute[0]%60)*10+msg_list[j+1].rctp.minute[1]%60;
            if( ComTime(year0,month0,day0,hour0,minute0,year,month,day,hour,minute) )
            {
                memset(&temp, 0, sizeof(T_MFW_SMS_MSG));
                memcpy(&temp,&msg_list[j],sizeof(T_MFW_SMS_MSG)); 
                memcpy(&msg_list[j],&msg_list[j+1],sizeof(T_MFW_SMS_MSG)); 
                memcpy(&msg_list[j+1],&temp,sizeof(T_MFW_SMS_MSG)); 
            }
        }
}

/*******************************************************************************

 $Function:    	ShowTime

 $Description:	show mt sms time 
            
 $Returns:		

 $Arguments:	
*******************************************************************************/
void ShowTime(char* text)
{
    int old_color;    

    MMI_TRACE_EVENT(("wangyan ShowTime()"));

    dspl_Clear(0, VIEWLIST_MENU_VERTICAL_SIZE-LINE_HEIGHT, SCREEN_SIZE_X, VIEWLIST_MENU_VERTICAL_SIZE);
    old_color=dspl_GetBkgColor();
    dspl_SetBkgColor(0xF8E0EE);
    dspl_Clear(0, VIEWLIST_MENU_VERTICAL_SIZE-LINE_HEIGHT, SCREEN_SIZE_X, VIEWLIST_MENU_VERTICAL_SIZE);
    dspl_SetBkgColor(old_color);
    /* 2004/06 sunsj modify for picture manage */
    DRAW_ICON(ICON_SMSMTTIME);
    //dspl_BitBlt(1, VIEWLIST_MENU_VERTICAL_SIZE-LINE_HEIGHT, 20, 12, 0, (void *)Mtsmstime, 0);
    set_font_type(UNI12X12_FONT);
    dspl_colorTextOut(25,VIEWLIST_MENU_VERTICAL_SIZE-LINE_HEIGHT,DSPL_TXTATTR_TRANSPARENT,(char*)text,0x000000);
    set_font_type(NORMAL_FONT);
}

/*******************************************************************************

 $Function:    	ExtractNumber

 $Description:	extract number from sms,remove"+86" 
            
 $Returns:		

 $Arguments:	
*******************************************************************************/
void ExtractNumber(T_MFW_SMS_ADDR * tmp,char * Buffer)
{
    if( tmp->ton == MFW_TON_INTERNATIONAL )
    {
        if( tmp->number[0] == '+' )
        {
            if( tmp->number[1] == '8' && tmp->number[2] == '6' )
                strcpy(Buffer,(char *)tmp->number+3);
            else
                strcpy(Buffer,(char *)tmp->number); 
        }
        else
        {
            if( tmp->number[0] == '8'&& tmp->number[1] == '6' )
                strcpy((char *)Buffer,(char *)tmp->number+2);
            else
            {
                //strcpy((char *)Buffer,(char *)tmp->number);				
                strcpy((char *)Buffer,"+");             
                strncat((char *)Buffer,(char *)tmp->number,sizeof(tmp->number)-2); 
            }
        }
    }
    else
        strcpy((char *)Buffer,(char *)tmp->number); 
}

/**/

/*******************************************************************************

 $Function:    	SmsRead_R_start

 $Description:	Start the creation of the main window for SMS reading
 
 $Returns:		mfw window handler 

 $Arguments:	parent_window - Parent window handler
                menuAttr	  - Menu attributes.
 
*******************************************************************************/
T_MFW_HND SmsRead_R_start(T_MFW_HND parent_window, T_MFW_SMS_STAT* menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsRead_R_start()");
    win = SmsRead_R_create (parent_window);

    if( win NEQ NULL )
    {
        /* We transmit to the SMS editor the address of the data buffer */
        SEND_EVENT (win, E_INIT, SmsRead_R_ID, (void *)menuAttr);
    }
    return win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_create

 $Description:	create the SMS read window (dynamic list of all the SMS)
 
 $Returns:		mfw window handler 

 $Arguments:	parent_window - Parent window handler
 
*******************************************************************************/
static T_MFW_HND SmsRead_R_create(MfwHnd parent_window)
{
    T_SMSREAD_R      * data = (T_SMSREAD_R *)ALLOC_MEMORY (sizeof (T_SMSREAD_R));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsRead_R_create()");

    /* Create window handler */

    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)SmsRead_R_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* connect the dialog data to the MFW-window */
    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsRead_R_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;
    winShow(data->win);

    /* return window handle */
    return data->win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_destroy

 $Description:	Destroy the SMS read window (dynamic list of all the SMS)
 
 $Returns:		none

 $Arguments:	own_window - window handler
 
*******************************************************************************/

static void SmsRead_R_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SMSREAD_R     * data;
    USHORT i;

    TRACE_FUNCTION ("SmsRead_R_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_SMSREAD_R *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            if( data->sms_handle )
                sms_delete(data->sms_handle);

            if( smsphkchecktimer )
                timDelete(smsphkchecktimer);

            if( info_win )
            {
                SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
                info_win = 0;
            }
            if( data->list_editor )
                edtDelete(data->list_editor);
            if( list_win )
            {
                listsDestroy(list_win);
                //SEND_EVENT(list_win,DIALOG_DESTROY,0,0 );
                list_win = 0;
            }
            win_delete (data->win);
            /*     
             * Free Memory
             */

            /* Free the data allocated for the name associated to the phone number */
            //if (data->sms_editor_data.assoc_name != NULL)
            //	FREE_MEMORY( (void *)data->sms_editor_data.assoc_name, strlen(data->sms_editor_data.assoc_name) + 1);

            /* Free the data allocated for the dynamic list */
            if( data->menu_list_data != NULL )
            {
                sprintf(buf,">>>> SmsRead_R_destroy,(data->sms_list_data).nb_sms_stored=%d",(data->sms_list_data).nb_sms_stored);
                TRACE_EVENT(buf);
                if( (data->sms_list_data.nb_sms_stored) )
                    for( i = 0; i <(data->sms_list_data).nb_sms_stored; i++ )
                    {
                        //					sprintf(buf,">> R_destroy: Free sms_header :%d, size:%d ",(void *)data->sms_list_data.sms_header[i],MENU_TEXT_LENGTH+ 1);
                        //					TRACE_EVENT(buf);
                        //FREE_MEMORY( (void *)data->sms_list_data.sms_header[i], MENU_TEXT_LENGTH+ 1);
                        FREE_MEMORY( (void *)data->menu_list_data->List[i].str, MENU_TEXT_LENGTH);
                    }
                else
                    for( i = 0; i <g_nb_line_sms; i++ )
                    {
                        FREE_MEMORY( (void *)data->menu_list_data->List[i].str, MENU_TEXT_LENGTH);
                    }
                FREE_MEMORY ((void *)data->menu_list_data->List,MAX_MESSAGES * sizeof(T_MFW_MNU_ITEM));
                FREE_MEMORY ((UBYTE *)data->menu_list_data, sizeof(ListMenuData));
            }
            data->menu_list_data = NULL;
            //FREE_MEMORY ((void *)data->sms_editor_data.sms_info, sizeof (T_MFW_SMS_PARA));
            FREE_MEMORY ((void *)data, sizeof (T_SMSREAD_R));
            total=0;
        }
        else
        {
            TRACE_EVENT ("SmsRead_R_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_exec_cb

 $Description:	Exec callback function of the SMS read window (dynamic list of 
                all the SMS)
 
 $Returns:		none

 $Arguments:	win - window handler
                event - mfw event
                parameter - optional data.
 
*******************************************************************************/
void SmsRead_R_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
/* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R    * data = (T_SMSREAD_R *)win_data->user;
    T_SMS_LIST_DATA * list_data = &data->sms_list_data;
    T_MFW_EVENT     MfwEvents;
    T_MFW_HND l_parent;
    T_DISPLAY_DATA DisplayInfo;
    // Status of SMS reading
    T_MFW status;
    char    info[30];
    int i;

    TRACE_FUNCTION ("SmsRead_R_exec_cb()");
    /* clrobert delete 
    sms_list_type = *(T_MFW_SMS_STAT *)parameter;
    */ 
    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */
        info_win=0;
        data->id = value;
        data->menu_list_data = NULL;
        if( (sms_list_type == MFW_SMS_MO)||(sms_list_type == MFW_SMS_MT) )
        {
            //NM 24.8
            /* Verify that SMS handling has been correctly initialised */
            /* we want to get the whole SMS list */
            list_data->nb_sms_stored = sms_message_list(sms_list_type, list_data->sms_messages, MAX_MESSAGES); 

            if( list_data->nb_sms_stored > 0 )
            {
                // We want to read all the SMS
                g_sms_state = READ_SMS_LIST;
                /* global counter to decrement each time a message is read */
                //g_sms_list_counter = 0;
                ModifyMenuList=0;
                /* Initialise counter for number of entries in sms list. used to call the correct no of FreeAllocs MZ 8/03/01  */
                g_nb_line_sms =list_data->nb_sms_stored;
                if( sms_list_type==MFW_SMS_MT )
                {
                    SortSms(data->sms_list_data.nb_sms_stored ,data->sms_list_data.sms_messages); 
                }
                SmsRead_R_BuildList(win,0);

                //dspl_Clear(0, 128, 120, 142);/*2003/10/29, wangyan, fix bug*/

                if( (data->sms_list_data.sms_messages[g_sms_list_counter].stat == MFW_SMS_UNREAD)
                    ||(data->sms_list_data.sms_messages[g_sms_list_counter].stat == MFW_SMS_READ) )
                {
                    memset(sms_list_time,0, sizeof(sms_list_time));
                    ChangeTime( (char *) sms_list_time,&data->sms_list_data.sms_messages[g_sms_list_counter].rctp);
                    ShowTime((char * )sms_list_time);
                }

                /* We have to handle E_SMS_MO and E_SMS_MT MFW events, in order to retrieve the SMS */
                MfwEvents = E_SMS_MT  | E_SMS_MO | E_SMS_MT_RECEIVED | E_SMS_MO_AVAIL| 
                            E_SMS_ERR | E_SMS_OK | E_SMS_MEM_FREE    | E_SMS_MEM_FULL;
                data->sms_handle = sms_create(win,MfwEvents,(MfwCb)SmsRead_R_mfw_cb);
            }
            else
                SmsRead_DisplayStandardDialog(win, TxtNoMessages, ONE_SECS);
        }
        else //if((sms_list_type == MFW_SMS_FLASH_MO)||(sms_list_type == MFW_SMS_FLASH_MT))
        {
            /* global counter to decrement each time a message is read */
            //g_sms_list_counter = 0;
            /* Initialise counter for number of entries in sms list. used to call the correct 
               no of FreeAllocs MZ 8/03/01  */
            SortFlashSms(sms_list_type,Flash_sms_messages);
            g_nb_line_sms =total;
            if( g_nb_line_sms > 0 )
            {
                ModifyMenuList=0;
                g_sms_state = READ_FLASH_SMS_LIST;
                SmsRead_R_Flash_BuildList(win,0);
                if( Flash_sms_messages[Flash_sms_sort_index[g_sms_list_counter].index].state == MFW_SMS_MT )
                {
                    memset(sms_list_time,0, sizeof(sms_list_time));
                    ChangeTime( (char *) sms_list_time,&Flash_sms_messages[Flash_sms_sort_index[g_sms_list_counter].index].time);
                    ShowTime((char * )sms_list_time);
                }
                /*				else
                                    dspl_Clear(0, 128, 120, 142);*//*2003/12/5, wangyan modify*/
            }
            else
                SmsRead_DisplayStandardDialog(win, TxtNoMessages, ONE_SECS);
        }
        break;

    case E_RETURN:
        MMI_TRACE_EVENT(("wangyan SmsRead_R_exec_cb E_RETURN type=%d",type));
        /* Call the recreate function that will create and display a dynamic list from the list of SMS */
        //l_parent = data->parent;
        //SmsRead_R_destroy(win);
        //SEND_EVENT(l_parent, E_RETURN, data->id, NULL);
        MMI_TRACE_EVENT(("wangyan g_sms_fixed_state=%d ModifyMenuList=%d",g_sms_fixed_state,ModifyMenuList));
        if( g_sms_fixed_state EQ READ_SELECTED_SMS )
        {
            g_sms_state = READ_SMS_LIST;
            //data->menu_list_data->ListPosition=g_sms_list_counter+1;
            //listDisplayListMenu(win, data->menu_list_data, (ListCbFunc_t)SmsRead_R_smslist_cb,0);
            //list_win = data->menu_list_data->win;
            sms_list_type=type;
            //			dspl_Clear(0, 128, 120, 142);/*2003/12/5, wangyan modify*/
            if( type==MFW_SMS_MT )
            {
                ShowTime((char * )sms_list_time);
            }
        }
        else if( g_sms_fixed_state EQ READ_SELECTED_FLASH_SMS )
        {
            if( ModifyMenuList==1 )
            {
#if 1
                listsDestroy(list_win);
                list_win = 0;
                if( data->menu_list_data->ListLength>0 )
                {
                    if( g_sms_list_counter<data->menu_list_data->ListLength )
                        data->menu_list_data->ListPosition=g_sms_list_counter+1;
                    else
                    {
                        g_sms_list_counter=0;
                        data->menu_list_data->ListPosition=1;
                    }
                    listDisplayListMenu(data->win, data->menu_list_data, (ListCbFunc_t)SmsRead_R_smslist_cb,0);
                    list_win = data->menu_list_data->win;
                    g_sms_state = READ_FLASH_SMS_LIST;
                    //type=MFW_SMS_FLASH;
                    if( CurrentFlashSmsTable!=Flash_sms_sort_index[g_sms_list_counter].index/FlashSMS_table_len )
                    {
                        CurrentFlashSmsTable=Flash_sms_sort_index[g_sms_list_counter].index/FlashSMS_table_len;
                        flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
                    }
                    i=Flash_sms_sort_index[g_sms_list_counter].index%FlashSMS_table_len;
                    //i=Find_Del_Table(Flash_sms_sort_index[g_sms_list_counter].id);
                    MMI_TRACE_EVENT(("wangyan listDisplayListMenu state=%d",FFS_SMSData.NVMSMS[i].state));
                    if( FFS_SMSData.NVMSMS[i].state == MFW_SMS_MT )
                    {
                        memset(sms_list_time,0, sizeof(sms_list_time));
                        ChangeTime( (char *) sms_list_time,&FFS_SMSData.NVMSMS[i].time);
                        ShowTime((char * )sms_list_time);
                    }
                    /*else
                        dspl_Clear(0, 128, 120, 142);*//*2003/12/5, wangyan modify*/
                }
                else
                    SmsRead_R_destroy(data->win);
                if( info_win )
                {
                    SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
                    info_win = 0;
                }
#endif
            }
            else
            {
                g_sms_state = READ_FLASH_SMS_LIST;
                //dspl_Clear(0, 128, 120, 142);/*2003/12/5, wangyan modify*/
                if( type==MFW_SMS_FLASH_MT )
                {
                    ShowTime((char * )sms_list_time);
                }
            }
        }
        break;

    case E_BACK:
        /* Received an E_BACK event from the dynamic list --> suicide and E_RETURN to parent */
#if 0
        SmsRead_R_destroy(win);
        sprintf(buf,">>>> E_BACK,sms_list_type=%d",sms_list_type);
        TRACE_EVENT(buf);
        sprintf(buf,">>>> E_BACK,sms_fixed_list_type=%d",sms_fixed_list_type);
        TRACE_EVENT(buf);
        sms_list_type=sms_fixed_list_type;
        SmsRead_R_start(NULL, (T_MFW_SMS_STAT*)&sms_list_type);
#endif
        l_parent = data->parent;
        SmsRead_R_destroy(win);
        SEND_EVENT(l_parent, E_RETURN, data->id, NULL);     
        break;

    case E_EXIT: // Terminate exit from sms send...
        //listDisplayListMenu(win, data->menu_list_data, (ListCbFunc_t)SmsRead_R_smslist_cb,0);
        l_parent = data->parent;
        SmsRead_R_destroy(win);
        SEND_EVENT(l_parent, E_RETURN, data->id, NULL);     
        //edtShow(data->list_editor);
        break;
    default:
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_win_cb

 $Description:	Window callback function of the SMS read window (dynamic list of 
                all the SMS)
 
 $Returns:		none

 $Arguments:	w - mfw window handler
                e - mfw event
                
*******************************************************************************/

static int SmsRead_R_win_cb (MfwEvt e, MfwWin *w)    /* yyy window event handler */
{
    TRACE_FUNCTION ("SmsRead_R_win_cb()");
    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        break;
    case MfwWinFocussed: /* input focus / selected   */ 
    case MfwWinDelete:   /* window will be deleted   */        
    default:        
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	SmsRead_R_mfw_cb

 $Description:	MFW callback function of the SMS read window (dynamic list of all the SMS).
                Only interesting events for reading are handled here
 
 $Returns:		event status

 $Arguments:	parameter - optional data
                event - mfw event

*******************************************************************************/
int SmsRead_R_mfw_cb(MfwEvt event, void *parameter)
{
    T_MFW_HND    win  = mfwParent((MfwHdr *)mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R      * data = (T_SMSREAD_R *)win_data->user;
    T_SMS_LIST_DATA * list_data = &(data->sms_list_data);
    T_MFW_SMS_MO * MoMessage;
    T_MFW_SMS_MT * MtMessage;

    T_MFW_SMS_IDX msg_info;
    T_DISPLAY_DATA DisplayInfo;
    MMI_TRACE_EVENT(("SmsRead_R_mfw_cb event=%d",event));
    switch( event )
    {
    case E_SMS_OK: 

        if( deleting_win )
        {
            //T_MFW_SMS_STAT  sms_list_type = MFW_SMS_ALL;
            //if(sms_list_type==MFW_SMS_MT||sms_list_type==MFW_SMS_MO)
            //{
            //listsDestroy(list_win);
            //list_win=0;
            //}
            //SmsRead_R_destroy(data->win);
            //SmsRead_R_start(NULL, (T_MFW_SMS_STAT*)&type);
            //TRACE_FUNCTION ("******windy show deleted message");
            if( Moveup_List_sms(g_sms_list_counter,list_data,data->menu_list_data)==MFW_SMS_OK )
            {
                MMI_TRACE_EVENT(("wangyan sms list deleting_win"));
                listsDestroy(list_win);
                list_win = 0;
                data->menu_list_data->ListLength--;
                data->menu_list_data->SnapshotSize--;
                if( data->menu_list_data->ListLength>0 )
                {
                    if( g_sms_list_counter<data->menu_list_data->ListLength )
                        data->menu_list_data->ListPosition=g_sms_list_counter+1;
                    else
                    {
                        g_sms_list_counter=0;
                        data->menu_list_data->ListPosition=1;
                    }
                    listDisplayListMenu(data->win, data->menu_list_data, (ListCbFunc_t)SmsRead_R_smslist_cb,0);
                    list_win = data->menu_list_data->win;
                    g_sms_state = READ_SMS_LIST;
                    if( (data->sms_list_data.sms_messages[g_sms_list_counter].stat == MFW_SMS_UNREAD)
                        ||(data->sms_list_data.sms_messages[g_sms_list_counter].stat == MFW_SMS_READ) )
                    {
                        memset(sms_list_time,0, sizeof(sms_list_time));
                        ChangeTime( (char *) sms_list_time,
                                    &data->sms_list_data.sms_messages[g_sms_list_counter].rctp);
                        ShowTime((char * )sms_list_time);
                    }
                }
                else
                    SmsRead_R_destroy(data->win);
            }
            SEND_EVENT(deleting_win,DIALOG_DESTROY,0,0 );
            deleting_win = 0;
        }
        break;

    case E_SMS_MO:
        TRACE_EVENT("SmsRead_R_mfw_cb case:E_SMS_MO ");
        MoMessage = (T_MFW_SMS_MO *)parameter;
        // We are reading all the SMS on the SIM
        if( g_sms_state EQ READ_SELECTED_SMS )
        {
            g_sms_fixed_state=g_sms_state;
            data->sms_editor_data.sms_info = (T_MFW_SMS_PARA *)ALLOC_MEMORY (sizeof (T_MFW_SMS_PARA));
            data->sms_editor_data.sms_type = MMI_SMS_MO;
            memcpy(data->sms_editor_data.sms_info, (T_MFW_SMS_PARA *)MoMessage, sizeof(T_MFW_SMS_PARA));
            SmsRead_R_TEXTEDT2_start(win, (MfwMnuAttr *)&(data->sms_editor_data));
        }
        break;

    case E_SMS_MT:// nm 16.8
        //case E_SMS_MT_RECEIVED:// nm 
        MtMessage = (T_MFW_SMS_MT *)parameter;

        TRACE_EVENT_P1("g_sms_list_counter in MT = %d", g_sms_list_counter);
        if( g_sms_state EQ READ_SELECTED_SMS )
        {
            TRACE_EVENT_P1("MtMessage len: %d", MtMessage->msg_len);
            g_sms_fixed_state=g_sms_state;      

            data->sms_editor_data.sms_type = MMI_SMS_MT;
            data->sms_editor_data.sms_info = (T_MFW_SMS_PARA *)ALLOC_MEMORY (sizeof (T_MFW_SMS_PARA));
            memcpy(data->sms_editor_data.sms_info, (T_MFW_SMS_PARA *)MtMessage, sizeof(T_MFW_SMS_PARA));
            SmsRead_R_TEXTEDT2_start(win, (MfwMnuAttr *)&(data->sms_editor_data));
        }
        break;

    case E_SMS_ERR:
        TRACE_EVENT("SMS Error");
        g_sms_state = READ_SMS_LIST;
        if( info_win )
        {
            SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
            info_win = 0;
        }
        if( deleting_win )
        {
            SmsRead_R_destroy(data->win);
            SEND_EVENT(deleting_win,DIALOG_DESTROY,0,0 );
            deleting_win = 0;
        }
#if 0
        dialog_info_init(&DisplayInfo);//gdy add
        DisplayInfo.RightSoftKey = TxtSoftBack;
        DisplayInfo.LeftSoftKey = TxtSoftOK;
        DisplayInfo.TextId  =TxtUselessSMS;
        DisplayInfo.TextId2 =TxtAdviceDel;
        // Generic function for info messages
        DisplayInfo.Time   = FOREVER;
        DisplayInfo.iconindex =REMIND_REQUIRE;
        DisplayInfo.Callback = (T_VOID_FUNC)SmsDel_Useless_dialog_cb; 
        info_dialog(win, &DisplayInfo);
#endif
        return MFW_EVENT_REJECTED;

    default:
        TRACE_EVENT(" SmsRead_R_mfw_cb case: Default");
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}
/*******************************************************************************

 $Function:    	SmsDel_Useless_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list of all the SMS)
                Case where SMS has not been initialized yet
 
 $Returns:		status

 $Arguments:	win - current window handler
                Identifier - window id
                Reason - Event cause.
                
*******************************************************************************/

int SmsDel_Useless_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R *data = (T_SMSREAD_R *)win_data->user;
    T_MFW_HND *lparent = data->parent;
    T_DISPLAY_DATA DisplayInfo;

    TRACE_FUNCTION ("SmsDel_Useless_dialog_cb()");

    switch( Reason )
    {
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        // Send E_RETURN event to parent window
        SmsRead_R_destroy(win);
        SEND_EVENT(lparent, E_RETURN, data->id, NULL);
        return MFW_EVENT_CONSUMED;

    case INFO_KCD_LEFT:
        if( sms_msg_delete((UBYTE)data->sms_editor_data.sms_index)== MFW_SMS_OK )
        {
            if( deleting_win == 0 )
            {
                dialog_info_init(&DisplayInfo);//gdy add
                DisplayInfo.RightSoftKey = 0;
                DisplayInfo.Time         = FOREVER;
                DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
                DisplayInfo.TextId2      = TxtDeleted;
                DisplayInfo.iconindex    =REMIND_SUCCEED;
                deleting_win=info_dialog(win, &DisplayInfo);
            }
        }
        else
        {
            dialog_info_init(&DisplayInfo);//gdy add
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;
            DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
            DisplayInfo.TextId2      = TxtTryAgain;
            DisplayInfo.iconindex    =REMIND_WAITTING;
            DisplayInfo.Callback=(T_VOID_FUNC)SmsRead_R_dialog_cb;
            info_dialog(data->win, &DisplayInfo);
        }
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}
/*******************************************************************************

 $Function:    	SmsReadnvmsms_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list of all the SMS)
                Case where SMS has not been initialized yet
 
 $Returns:		status

 $Arguments:	win - current window handler
                Identifier - window id
                Reason - Event cause.
                
*******************************************************************************/

int SmsReadnvmsms_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R *data = (T_SMSREAD_R *)win_data->user;
    TRACE_FUNCTION ("SmsReadnvmsms_dialog_cb()");

    switch( Reason )
    {
    case INFO_TIMEOUT:
        info_win=0;
        if( (tmp_flash->state == MFW_SMS_STOR_UNSENT)||(tmp_flash->state == MFW_SMS_STOR_SENT) )
        {
            memcpy(MO.dest_addr.number,tmp_flash->addr,MFW_NUM_LEN);
            memcpy((char *)MO.sms_msg,tmp_flash->sms_msg,MAX_MSG_LEN);
            MO.msg_len=tmp_flash->msg_len;
            MO.dcs=tmp_flash->dcs;
            data->sms_editor_data.sms_type = MMI_SMS_FLASH_MO;
            data->sms_editor_data.sms_info = (T_MFW_SMS_PARA *)ALLOC_MEMORY (sizeof (T_MFW_SMS_PARA));
            memcpy(data->sms_editor_data.sms_info, (T_MFW_SMS_PARA *)&MO, sizeof(T_MFW_SMS_PARA));
            SmsRead_R_TEXTEDT2_start(data->win, (MfwMnuAttr *)&(data->sms_editor_data));
        }
        else if( tmp_flash->state == MFW_SMS_MT )
        {
            memcpy(MT.orig_addr.number,tmp_flash->addr,MFW_NUM_LEN);
            memcpy((char *)MT.sms_msg,tmp_flash->sms_msg,MAX_MSG_LEN);
            memcpy((char *)MT.sctp.year, (char *)tmp_flash->time.year, MAX_SCTP_DIGITS);
            memcpy((char *)MT.sctp.month, (char *)tmp_flash->time.month, MAX_SCTP_DIGITS);
            memcpy((char *)MT.sctp.day, (char *)tmp_flash->time.day, MAX_SCTP_DIGITS);
            memcpy((char *)MT.sctp.hour, (char *)tmp_flash->time.hour, MAX_SCTP_DIGITS);
            memcpy((char *)MT.sctp.minute, (char *)tmp_flash->time.minute,MAX_SCTP_DIGITS);
            MT.msg_len=tmp_flash->msg_len;
            MT.dcs=tmp_flash->dcs;
            data->sms_editor_data.sms_type = MMI_SMS_FLASH_MT;
            data->sms_editor_data.sms_info = (T_MFW_SMS_PARA *)ALLOC_MEMORY (sizeof (T_MFW_SMS_PARA));
            memcpy(data->sms_editor_data.sms_info, (T_MFW_SMS_PARA *)&MT ,sizeof(T_MFW_SMS_PARA));
            SmsRead_R_TEXTEDT2_start(data->win, (MfwMnuAttr *)&(data->sms_editor_data));
        }
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_smslist_cb

 $Description:	Callback function for the dynamic list of the SMS read window.
 
 $Returns:		none

 $Arguments:	Parent - window handler
                ListData - Menu list data.
                
*******************************************************************************/

void SmsRead_R_smslist_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_SMSREAD_R * data     = (T_SMSREAD_R *)win_data->user;    

    T_MFW_HND      * l_parent;
    SHORT            l_id;
    USHORT index=0;
    T_MFW_SMS_MSG * tmp_sms;
    T_MMI_FLASH_SMS_INDEX * tmp;
    int i;
    T_DISPLAY_DATA DisplayInfo;
    TRACE_FUNCTION("SmsRead_R_smslist_cb ");

    // In all the case, we need the index of the selected message
    switch( ListData->Reason )
    {
    case LISTS_REASON_SELECT:
    case LISTS_REASON_OK:
        TRACE_EVENT(">>> Reason:LISTS_REASON_SELECT ");
        sprintf(buf,">>>> ,List->position=%d",ListData->ListPosition);
        TRACE_EVENT(buf);
        if( g_sms_state EQ READ_SMS_LIST )
        {
            // We want only to retrieve the selected SMS
            data->sms_editor_data.sms_index = data->sms_list_data.sms_messages[ListData->ListPosition].index;
            g_sms_state = READ_SELECTED_SMS;
            g_sms_list_counter =ListData->ListPosition;
            if( !info_win )
                info_win = smsRead_info_screen(data->win,TxtReadingSms);
            if( sms_read(MFW_SMS_MESSAGE, (UBYTE)data->sms_editor_data.sms_index)!=MFW_SMS_OK )
            {
                SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
                info_win = 0;
                g_sms_state = READ_SMS_LIST;
            }
        }
        else if( g_sms_state EQ READ_FLASH_SMS_LIST )
        {
            g_sms_state = READ_SELECTED_FLASH_SMS;
            g_sms_fixed_state=g_sms_state;
            //g_sms_list_counter =ListData->ListPosition;
            //data->sms_editor_data.sms_index = ListData->ListPosition;
            /*sprintf(buf,">>>> ,smslist_cb,Flash_sms_sort_index[g_sms_list_counter].id=%d",Flash_sms_sort_index[g_sms_list_counter].id);
            TRACE_EVENT(buf);
            sprintf(buf,">>>> ,smslist_cb,Find_Del_Table.i=%d,g_sms_list_counter=%d",i,g_sms_list_counter);
            TRACE_EVENT(buf);
            sprintf(buf,">>>> ,SmsRead_R_smslist_cb,CurrentFlashSmsTable=%d",CurrentFlashSmsTable);
            TRACE_EVENT(buf);
            sprintf(buf,">>>> ,SmsRead_R_smslist_cb,tmp_flash->state=%d",tmp_flash->state);
            TRACE_EVENT(buf);*/
            if( CurrentFlashSmsTable!=(Flash_sms_sort_index[g_sms_list_counter].index/FlashSMS_table_len) )
            {
                CurrentFlashSmsTable=Flash_sms_sort_index[g_sms_list_counter].index/FlashSMS_table_len;
                flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
            }
            i=Flash_sms_sort_index[g_sms_list_counter].index % FlashSMS_table_len;
            //i=Find_Del_Table(Flash_sms_sort_index[g_sms_list_counter].id);
            tmp_flash=&FFS_SMSData.NVMSMS[i];
            if( !info_win )
            {
                dialog_info_init(&DisplayInfo);//gdy add
                DisplayInfo.RightSoftKey = TxtNull;
                DisplayInfo.TextId2 =TxtReadingSms;
                // Generic function for info messages
                DisplayInfo.KeyEvents= KEY_CLEAR;
                DisplayInfo.Time   = 500;
                DisplayInfo.iconindex =REMIND_WAITTING;
                DisplayInfo.Callback = (T_VOID_FUNC)SmsReadnvmsms_dialog_cb; 
                info_win =info_dialog(data->win, &DisplayInfo);
            }
        }

        //API deletion of the list
        break;

    case LISTS_REASON_UP:
        if( g_sms_state EQ READ_SMS_LIST )
        {
            g_sms_list_counter = (g_sms_list_counter+ g_nb_line_sms - 1) % g_nb_line_sms;
            tmp_sms=&data->sms_list_data.sms_messages[g_sms_list_counter];
            if( (tmp_sms->stat == MFW_SMS_UNREAD)||(tmp_sms->stat == MFW_SMS_READ) )
            {
                memset(sms_list_time,0, sizeof(sms_list_time));
                ChangeTime( (char *) sms_list_time,&tmp_sms->rctp);
                ShowTime((char * )sms_list_time);
                /*sprintf(buf,">>>> LISTS_REASON_DOWN,sms_list_time=%s",sms_list_time);
                TRACE_EVENT(buf);*/
            }
        }
        else if( g_sms_state EQ READ_FLASH_SMS_LIST )
        {
            g_sms_list_counter = (g_sms_list_counter+total- 1) % total;
            index=Flash_sms_sort_index[g_sms_list_counter].index;
            tmp=&Flash_sms_messages[index];
            if( tmp->state == MFW_SMS_MT )
            {
                memset(sms_list_time,0, sizeof(sms_list_time));
                ChangeTime( (char *) sms_list_time,&tmp->time);
                ShowTime((char * )sms_list_time);
            }
            /*else
                dspl_Clear(0, 128, 120, 142);*//*2003/12/5, wangyan modify*/
        }
        break;

    case LISTS_REASON_UPDATE:
        //		dspl_Clear(0, 128, 120, 142);/*2003/12/5, wangyan modify*/
        MMI_TRACE_EVENT(("wangyan LISTS_REASON_UPDATE sms_list_type=%d",sms_list_type));
        /*2004/7/16, wy modify nvm message time show*/
        //if( sms_list_type==MFW_SMS_MT )
        if(( sms_list_type==MFW_SMS_MT )||( sms_list_type==MFW_SMS_FLASH_MT ))
        {
            dspl_Clear(0, VIEWLIST_MENU_VERTICAL_SIZE-LINE_HEIGHT, SCREEN_SIZE_X, VIEWLIST_MENU_VERTICAL_SIZE);/*2003/12/5, wangyan modify*/
            ShowTime((char * )sms_list_time);
        }
        break;

    case LISTS_REASON_DOWN:
        if( g_sms_state EQ READ_SMS_LIST )
        {
            g_sms_list_counter = (g_sms_list_counter+ g_nb_line_sms + 1) % g_nb_line_sms;
            tmp_sms=&data->sms_list_data.sms_messages[g_sms_list_counter];
            if( (tmp_sms->stat == MFW_SMS_UNREAD)||(tmp_sms->stat == MFW_SMS_READ) )
            {
                memset(sms_list_time,0, sizeof(sms_list_time));
                ChangeTime( (char *) sms_list_time,&tmp_sms->rctp);
                ShowTime((char * )sms_list_time);
                /*sprintf(buf,">>>> LISTS_REASON_DOWN,sms_list_time=%s",sms_list_time);
                TRACE_EVENT(buf);*/
            }
        }
        else if( g_sms_state EQ READ_FLASH_SMS_LIST )
        {
            g_sms_list_counter = (g_sms_list_counter+ total+ 1) %total;
            index=Flash_sms_sort_index[g_sms_list_counter].index;
            tmp=&Flash_sms_messages[index];
            if( tmp->state == MFW_SMS_MT )
            {
                memset(sms_list_time,0, sizeof(sms_list_time));
                ChangeTime( (char *) sms_list_time,&tmp->time);
                ShowTime((char * )sms_list_time);
            }
            /*else
                dspl_Clear(0, 128, 120, 142);*//*2003/12/5, wangyan modify*/
        }
        break;

    case LISTS_REASON_BACK:
    case LISTS_REASON_CLEAR:
        TRACE_EVENT(">>> Reason: LISTS_REASON_BACK/CLEAR ");
        //listsDestroy(ListData->win);
        //list_win=0;
        SmsRead_R_destroy(data->win);
        break;
    }
}

BOOL GetSMSLISTWINHandle()
{
    if( list_win )
        return TRUE;
    else
        return FALSE;
}
/*******************************************************************************

 $Function:    	SmsRead_R_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list of all the SMS)
                Case where SMS has not been initialized yet
 
 $Returns:		status

 $Arguments:	win - current window handler
                Identifier - window id
                Reason - Event cause.
                
*******************************************************************************/

int SmsRead_R_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R *data = (T_SMSREAD_R *)win_data->user;
    T_MFW_HND *lparent = data->parent;

    TRACE_FUNCTION ("SmsRead_dialog_cb()");

    switch( Reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        // Commit suicide
        // Send E_RETURN event to parent window
        //SmsRead_R_destroy(win);
        info_win = 0;
        deleting_win = 0;
        SEND_EVENT(data->win, E_BACK, data->id, NULL);
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}
/*******************************************************************************

 $Function:    	SmsRead_R_BuildList

 $Description:	Build the list of SMS for the dynamic list.
 
 $Returns:		status

 $Arguments:	win - current window handler
 
*******************************************************************************/

void SmsRead_R_Flash_BuildList(T_MFW_HND win, int inUnicode)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R *data = (T_SMSREAD_R *)win_data->user;

    /* List is complete so present menu. */
    USHORT i;
    T_FindName  searchPhdata;
    char sms_text_buffer[50];
    T_MMI_FLASH_SMS_INDEX * tmp_sms;

    TRACE_FUNCTION("SmsRead_R_BuildList");

    data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

    if( data->menu_list_data == 0 )
    {
        TRACE_EVENT("Failed memory alloc 1 ");
        return;
    }

    data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( MAX_MESSAGES * sizeof(T_MFW_MNU_ITEM) );//JVJE

    if( data->menu_list_data->List == 0 )
    {
        TRACE_EVENT("Failed memory alloc 2");
        return;
    }
    /*2004/7/16, wy modify nvm message time show*/
    if( sms_list_type==MFW_SMS_FLASH_MT )
    {
        data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNVMInbox);
    }
    else if( sms_list_type==MFW_SMS_FLASH_MO )
    {
        data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNVMOutbox);
    }
    /*2004/7/16, wy modify nvm message time show*/
    //data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtNVMMsg);

    for( i = 0; i < (total); i++ )
    {
        tmp_sms=&Flash_sms_messages[Flash_sms_sort_index[i].index];
        /*sprintf(buf,">>>> ,Flash_BuildList,Flash_sms_sort_index[%d].index=%d,id=%d",i,Flash_sms_sort_index[i].index,Flash_sms_sort_index[i].id);
        TRACE_EVENT(buf);
        sprintf(buf,">>>> ,Flash_sms_messages[Flash_sms_sort_index[%d].index].index=%d",i,tmp_sms->index);
        TRACE_EVENT(buf);
        sprintf(buf,">>>> ,Flash_BuildList,Flash_sms_messages[Flash_sms_sort_index[%d].index].addr=%s",
                i,tmp_sms->addr);
        TRACE_EVENT(buf);
        sprintf(buf,">>>> ,Flash_BuildList,Flash_sms_messages[Flash_sms_sort_index[%d].index].state=%d",
                i,tmp_sms->state);
        TRACE_EVENT(buf);*/
        if( tmp_sms->state== MFW_SMS_MT )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSMT_LIST, 0);//&mtlist;
            //strcpy((char *)SmsData.NumberBuffer,(char *)tmp_sms->addr);				
        }
        else if( tmp_sms->state== MFW_SMS_STOR_SENT )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSMO_LIST, 0);//&molist;
        }
        else if( tmp_sms->state == MFW_SMS_STOR_UNSENT )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSUNMO_LIST, 0);//&unmolist;
        }
        /* add the number or the name if he can find it in the phonebook*/
        memset(sms_text_buffer, 0, sizeof(sms_text_buffer));
        if( tmp_sms->addr[0]!='\0' )
            if( FindNumber((char*)tmp_sms->addr, (T_FindName *)&searchPhdata) )
            {
                memcpy(sms_text_buffer,(char*)searchPhdata.name,13);
            }
            else
            {
                memcpy(sms_text_buffer,(char*)tmp_sms->addr,12);
            }
        data->menu_list_data->List[i].str = (char *)ALLOC_MEMORY (MENU_TEXT_LENGTH);
        if( sms_text_buffer[0]==0x80 )
            memcpy(data->menu_list_data->List[i].str,(char*)sms_text_buffer,13);
        else
            memcpy(data->menu_list_data->List[i].str,(char*)sms_text_buffer,12);
        data->menu_list_data->List[i].exta = 0;
        data->menu_list_data->List[i].edit = 0;
        data->menu_list_data->List[i].menu = 0;
        data->menu_list_data->List[i].func = NULL;
        data->menu_list_data->List[i].flagFunc = item_flag_none; 
    }
    data->menu_list_data->ListLength = total;
    data->menu_list_data->ListPosition =g_sms_list_counter+1 ;
    data->menu_list_data->CursorPosition = 1;
    data->menu_list_data->SnapshotSize =total;
    data->menu_list_data->Font = 0;
    data->menu_list_data->LeftSoftKey = TxtRead;
    data->menu_list_data->RightSoftKey = TxtSoftBack;
    data->menu_list_data->KeyEvents = KEY_ALL;
    data->menu_list_data->Reason = 0;
    data->menu_list_data->Strings = TRUE;
    if( tmp_sms->state== MFW_SMS_MT )
        data->menu_list_data->Attr   = &readSMS_menuAttrib; /*2003/12/4, wangyan modify*/
    else data->menu_list_data->Attr   = &readSMS_menuAttribMo;
    data->menu_list_data->autoDestroy    = FALSE;
    data->menu_list_data->ListMenuFlag=1;//for display the title
    /* Create the dynamic menu window */
    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc_t)SmsRead_R_smslist_cb,inUnicode);
    list_win = data->menu_list_data->win;
    if( info_win )
    {
        SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
        info_win = 0;
    }
}
/*******************************************************************************

 $Function:    	SmsRead_R_BuildList

 $Description:	Build the list of SMS for the dynamic list.
 
 $Returns:		status

 $Arguments:	win - current window handler
 
*******************************************************************************/

void SmsRead_R_BuildList(T_MFW_HND win, int inUnicode)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R *data = (T_SMSREAD_R *)win_data->user;

    /* List is complete so present menu. */
    USHORT i;
    T_MFW_SMS_IDX msg_info;
    T_FindName  searchPhdata;
    char sms_text_buffer[50];
    T_MFW_SMS_MSG * tmp_sms;

    TRACE_FUNCTION("SmsRead_R_BuildList");

    data->menu_list_data = (ListMenuData *)ALLOC_MEMORY(sizeof(ListMenuData));

    if( data->menu_list_data == 0 )
    {
        TRACE_EVENT("Failed memory alloc 1 ");
        return;
    }

    data->menu_list_data->List = (T_MFW_MNU_ITEM *)ALLOC_MEMORY( MAX_MESSAGES * sizeof(T_MFW_MNU_ITEM) );//JVJE

    if( data->menu_list_data->List == 0 )
    {
        TRACE_EVENT("Failed memory alloc 2");
        return;
    }

    //	data->menu_list_data->list.items = (grph_Obj_t*)ALLOC_MEMORY((data->sms_list_data).nb_sms_stored * sizeof(grph_Obj_t));
    if( sms_list_type==MFW_SMS_MT )
    {
        data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtReadMt);
    }
    else if( sms_list_type==MFW_SMS_MO )
    {
        data->menu_list_data->ListMenuHeadStr=(char *) MmiRsrcGetText(TxtReadMo);
    }

    for( i = 0; i < ((data->sms_list_data).nb_sms_stored); i++ )
    {
        tmp_sms=&data->sms_list_data.sms_messages[i];
        //sms_copy_idx(tmp_sms->index, &msg_info);
        msg_info.stat =tmp_sms->stat;
        if( msg_info.stat == MFW_SMS_UNREAD )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSNEW_LIST, 0);//&newsmslist;
            memset(sms_text_buffer, 0, sizeof(sms_text_buffer));
            /* add the number or the name if he can find it in the phonebook*/
            ExtractNumber(&tmp_sms->addr,(char *)SmsData.NumberBuffer);
            if( FindNumber((char*)(SmsData.NumberBuffer), (T_FindName *)&searchPhdata) )
            {
                memcpy(sms_text_buffer,(char*)searchPhdata.name,13);
            }
            else
            {
                memcpy(sms_text_buffer,(char*)SmsData.NumberBuffer,12);
            }
        }
        else if( msg_info.stat == MFW_SMS_READ )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSMT_LIST, 0);//&mtlist;
            memset(sms_text_buffer, 0, sizeof(sms_text_buffer));
            ExtractNumber(&tmp_sms->addr,(char *)SmsData.NumberBuffer);

            /* find the number or the name if he can find it in the phonebook*/
            if( FindNumber((char*)(SmsData.NumberBuffer), (T_FindName *)&searchPhdata) )
            {
                memcpy(sms_text_buffer,(char*)searchPhdata.name,13);
            }
            else
            {
                memcpy(sms_text_buffer,(char*)SmsData.NumberBuffer,12);
            }
        }
        else if( msg_info.stat == MFW_SMS_STOR_SENT )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSMO_LIST, 0);//&molist;
            memset(sms_text_buffer, 0, sizeof(sms_text_buffer));
            /* find the number or the name if he can find it in the phonebook*/
            if( FindNumber((char*)tmp_sms->addr.number, (T_FindName *)&searchPhdata) )
            {
                memcpy(sms_text_buffer,(char*)searchPhdata.name,13);
            }
            else
            {
                memcpy(sms_text_buffer,(char*)tmp_sms->addr.number,12);
            }
        }
        else if( msg_info.stat == MFW_SMS_STOR_UNSENT )
        {
            /* 2004/06 sunsj modify for picture manage */
            data->menu_list_data->List[i].icon = GET_ICONATTR(ICON_SMSUNMO_LIST, 0);//&unmolist;
            memset(sms_text_buffer, 0, sizeof(sms_text_buffer));
            /* find the number or the name if he can find it in the phonebook*/
            if( tmp_sms->addr.number[0]!='\0' )
                if( FindNumber((char*)tmp_sms->addr.number, (T_FindName *)&searchPhdata) )
                {
                    memcpy(sms_text_buffer,(char*)searchPhdata.name,13);
                }
                else
                {
                    memcpy(sms_text_buffer,(char*)tmp_sms->addr.number,12);
                }
        }
        data->menu_list_data->List[i].str = (char *)ALLOC_MEMORY (MENU_TEXT_LENGTH);
        if( sms_text_buffer[0]==0x80 )
            memcpy(data->menu_list_data->List[i].str,(char*)sms_text_buffer,13);
        else
            memcpy(data->menu_list_data->List[i].str,(char*)sms_text_buffer,12);
        //data->menu_list_data->List[i].str =(char*)tmp_sms->addr.number;
        data->menu_list_data->List[i].exta = 0;
        data->menu_list_data->List[i].edit = 0;
        data->menu_list_data->List[i].menu = 0;
        data->menu_list_data->List[i].func = NULL;
        data->menu_list_data->List[i].flagFunc = item_flag_none; 
    }
    data->menu_list_data->ListLength = (data->sms_list_data).nb_sms_stored;//GetFree((data->sms_list_data).nb_sms_stored);
    data->menu_list_data->ListPosition =g_sms_list_counter+1 ;
    data->menu_list_data->CursorPosition = 1;
    data->menu_list_data->SnapshotSize =(data->sms_list_data).nb_sms_stored;
    data->menu_list_data->Font = 0;
    data->menu_list_data->LeftSoftKey = TxtRead;
    data->menu_list_data->RightSoftKey = TxtSoftBack;
    data->menu_list_data->KeyEvents = KEY_ALL;
    data->menu_list_data->Reason = 0;
    data->menu_list_data->Strings = TRUE;
    if( sms_list_type==MFW_SMS_MT )
        data->menu_list_data->Attr   = &readSMS_menuAttrib;/*2003/12/4, wangyan modify*/
    else data->menu_list_data->Attr   = &readSMS_menuAttribMo;
    data->menu_list_data->autoDestroy    = FALSE;
    data->menu_list_data->ListMenuFlag=1;//for display the title
    /* Create the dynamic menu window */
    listDisplayListMenu(win, data->menu_list_data, (ListCbFunc_t)SmsRead_R_smslist_cb,inUnicode);
    list_win = data->menu_list_data->win;
    if( info_win )
    {
        SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
        info_win = 0;
    }
}

#if 0
/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT_start

 $Description:	Start the creation of the SMS editor window (display of the text 
                of one SMS)
 
 $Returns:		win - window handler.

 $Arguments:	parent_window - current window handler
                data - Menu attributes.
 
*******************************************************************************/

T_MFW_HND SmsRead_R_TEXTEDT_start(T_MFW_HND parent_window, MfwMnuAttr *data)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT_start()");

    win = SmsRead_R_TEXTEDT_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, SmsRead_R_TEXTEDT_ID, (void *)data);
    }
    return win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT_create

 $Description:	Create the SMS editor window (display of the text of one SMS) 
            
 
 $Returns:		win - window handler.

 $Arguments:	parent_window - parent window handler
 
*******************************************************************************/

static T_MFW_HND SmsRead_R_TEXTEDT_create(MfwHnd parent_window)
{
    T_SMSREAD_R_TEXTEDT      * data = (T_SMSREAD_R_TEXTEDT *)ALLOC_MEMORY (sizeof (T_SMSREAD_R_TEXTEDT));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT_create()");

    /*
     * Create window handler
     */

    data->win = 
    win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)SmsRead_R_TEXTEDT_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* 
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsRead_R_TEXTEDT_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */
    return data->win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT_destroy

 $Description:	Destroy the SMS editor window (display of the text of one SMS)
            
 
 $Returns:		none

 $Arguments:	own_window - current window handler
 
*******************************************************************************/

static void SmsRead_R_TEXTEDT_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SMSREAD_R_TEXTEDT     * data;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_SMSREAD_R_TEXTEDT *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            win_delete (data->win);

            /*     
             * Free Memory
             */
            FREE_MEMORY ((void *)data->sms_editor_data.sms_info, sizeof (T_MFW_SMS_PARA));
            FREE_MEMORY ((void *)data, sizeof (T_SMSREAD_R_TEXTEDT));
        }
        else
        {
            TRACE_EVENT ("SmsRead_R_TEXTEDT_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT_exec_cb

 $Description:	Exec callback function of the SMS editor window (display of the 
                text of one SMS)
            
 $Returns:		none

 $Arguments:	win - current window handler
                event- window event
                value - unique id.
                parameter - optional data
 
*******************************************************************************/

void SmsRead_R_TEXTEDT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
/* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R_TEXTEDT          * data = (T_SMSREAD_R_TEXTEDT *)win_data->user;
    T_MFW_HND      * l_parent;
    SHORT            l_id;
    T_MFW_SMS_MO *SmsMo;
    T_MFW_SMS_MT *SmsMt;

    T_EDITOR_DATA sms_editor_info;

    // char sms_text_ascii[MAX_MSG_LEN + 1];
    charw_t *pt_unicode;


    TRACE_FUNCTION ("SmsRead_R_TEXTEDT_exec_cb()");

    switch( event )
    {
    case E_INIT:

        /* initialization of administrative data */
        data->id = value;

        /* NO BREAK !! */
    case E_RETURN:

        /* Create an editor to display the SMS, TBD create default values function */
        sms_editor_info.editor_attr.win.px   = 6;
        sms_editor_info.editor_attr.win.py   = 12;
        sms_editor_info.editor_attr.win.sx   = 80;
        sms_editor_info.editor_attr.win.sy   = 40;
        sms_editor_info.editor_attr.fgColor  = 0;
        sms_editor_info.editor_attr.font     = 0;
        sms_editor_info.editor_attr.mode     = edtCurBar1;
        sms_editor_info.editor_attr.controls = 0;
        sms_editor_info.editor_attr.text     = (char *)data->editor_buffer;  /* sms buffer */
        sms_editor_info.editor_attr.size     = MAX_EDITOR_LEN; 

        sms_editor_info.LeftSoftKey       = TxtSoftOptions;
        sms_editor_info.RightSoftKey      = TxtDelete;
        sms_editor_info.TextId            = '\0';  
        sms_editor_info.Identifier        = SmsRead_SMS_DISPLAY_ID;  // Display of the SMS no edition possible
        sms_editor_info.mode              = ALPHA_MODE; 
        sms_editor_info.destroyEditor     = TRUE; 
        sms_editor_info.Callback          = (T_EDIT_CB)SmsRead_R_TEXTEDT_editor_cb;

        editor_start(win,&sms_editor_info);  /* start the editor */ 

        break;

    case E_BACK:
        l_parent = data->parent;
        l_id = data->id;
        SmsRead_R_TEXTEDT_destroy(data->win);
        /* The editor has sent an E_BACK event, we return to the previous window (E_RETURN) */
        SEND_EVENT (l_parent, E_RETURN, l_id, NULL);
        break;

    case E_ABORT:
    case E_EXIT:
        l_parent = data->parent;
        l_id = data->id;
        SmsRead_R_TEXTEDT_destroy(data->win);
        SEND_EVENT (l_parent, event, l_id, NULL); /* forward event to parent */
        break;

    default:
        return;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT_win_cb

 $Description:	Window callback function of the SMS editor window (display of 
                the text of one SMS)
            
 $Returns:		status

 $Arguments:	w - mfw window handler
                e - window event
*******************************************************************************/

static int SmsRead_R_TEXTEDT_win_cb (MfwEvt e, MfwWin *w)
/* window event handler */
{
    TRACE_FUNCTION ("SmsRead_R_TEXTEDT_win_cb()");

    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
#if(MAIN_LCD_SIZE==3)
		draw_softkeybar_updown_arrow();//jhxu720
#endif
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT_editor_cb

 $Description:	Callback function of the SMS editor window (editor itself).
            
 $Returns:		none

 $Arguments:	win - mfw window handler
                Identifier - unique Id
                Reason - cause of event
*******************************************************************************/

void SmsRead_R_TEXTEDT_editor_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{

    T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R_TEXTEDT2 * data     = (T_SMSREAD_R_TEXTEDT2 *)win_data->user;


    TRACE_FUNCTION("SmsRead_R_TEXTEDT_editor_cb");
    switch( Reason )
    {
    case INFO_KCD_LEFT:
        /* show the options menu */
        SmsRead_R_OPT_start(win, (MfwMnuAttr*)&data->sms_editor_data);
        break;
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        SEND_EVENT (win, E_BACK, Identifier, NULL); /* forward event to parent */
        break;
    default:
        break;
    }
}
#endif
/*******************************************************************************

 $Function:    	SmsRead_timer_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list of all the SMS)
                Case where SMS has not been initialized yet
 
 $Returns:		status

 $Arguments:	win - current window handler
                Identifier - window id
                Reason - Event cause.
                
*******************************************************************************/

int SmsRead_timer_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    TRACE_FUNCTION ("SmsRead_timer_dialog_cb()");

    switch( Reason )
    {
    case INFO_KCD_HUP:
    case INFO_KCD_RIGHT:
        info_win = 0;
        if( smsphkchecktimer )
            timDelete(smsphkchecktimer);
        smsphkchecktimer=0;
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}
/*******************************************************************************

 $Function:     IdleReadsms

 $Description:  This function is called when the user press Send in the
        main SMS menu.

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/
int IdleReadsms(T_MFW_HND       win,T_MFW_SMS_STAT *menuAttr)
{
    T_DISPLAY_DATA DisplayInfo;

    sms_list_type=*(T_MFW_SMS_STAT *)menuAttr ;

    if( g_pcsyncstatus )//when pcsync run ,return,hxl add 2003-2-13
        return 1;

    g_sms_list_counter = 0;
    if( no_wait )//!smsidle_get_ready_state()&&
    {
        smsphkchecktimer= timCreate(0,ONE_SECS,(MfwCb)smsphkchecktimeEvent);
        //info_screen(win, TxtSimNot, TxtPleaseWait,(T_VOID_FUNC) SmsRead_R_dialog_cb,REMIND_WAITTING); 
        dialog_info_init(&DisplayInfo);//gdy add
        SmsMenu_loadDialogDefault(&DisplayInfo);
        DisplayInfo.TextId  = TxtSimNot;
        DisplayInfo.TextId2 = TxtPleaseWait;
        DisplayInfo.RightSoftKey=TxtSoftBack;
        DisplayInfo.KeyEvents= KEY_CLEAR|KEY_RIGHT;
        // Generic function for info messages
        DisplayInfo.Time   = FOREVER;
        DisplayInfo.iconindex =REMIND_WAITTING;
        DisplayInfo.Callback = (T_VOID_FUNC)SmsRead_timer_dialog_cb; 
        info_win=info_dialog(win, &DisplayInfo);
        timStart(smsphkchecktimer);                 /*      start clock          */
        return 1;
    }
    /* Call the function that manages SMS reading */
    SmsRead_R_start(win,(T_MFW_SMS_STAT*) &sms_list_type);
    return 1;
}
/*******************************************************************************

 $Function:     M_exeNVMMsg

 $Description:  This function is called when the user press Send in the
        main SMS menu.

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/
/*2003/11/28, wangyan delete*/
#if 0
int M_exeNVMMsg(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_SMS_STAT  sms_NVM_list_type = MFW_SMS_FLASH;

    if( g_pcsyncstatus )//when pcsync run ,return,hxl add 2003-2-13
        return 1;
    g_sms_list_counter = 0;
    /* Call the function that manages SMS reading */
    SmsRead_R_start(win, &sms_NVM_list_type);
    return 1;
}
#endif
/*******************************************************************************

 $Function:     SmsRead_R_NVMExeOutgoing

 $Description:  This function is called when the user press Read in the
          main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int SmsRead_R_NVMExeOutgoing(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    sms_list_type = MFW_SMS_FLASH_MO;

    //if(g_pcsyncstatus)//when pcsync run ,return,hxl add 2003-2-13
    //return 1;

    g_sms_list_counter = 0;
    /* Call the function that manages SMS reading */
    SmsRead_R_start(win, &sms_list_type);
    return 1;
}

/*******************************************************************************

 $Function:     SmsRead_R_NVMExeOutgoing

 $Description:  This function is called when the user press Read in the
          main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int SmsRead_R_NVMExeIncoming(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    sms_list_type = MFW_SMS_FLASH_MT;

    //if(g_pcsyncstatus)//when pcsync run ,return,hxl add 2003-2-13
    //return 1;
    g_sms_list_counter = 0;
    /* Call the function that manages SMS reading */
    SmsRead_R_start(win, &sms_list_type);
    return 1;
}
/*******************************************************************************

 $Function:     M_exeRead

 $Description:  This function is called when the user press Read in the
          main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int SmsRead_R_KINDExeIncoming(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    //T_MFW_SMS_STAT  sms_Incoming_list_type = MFW_SMS_MT;
    T_DISPLAY_DATA DisplayInfo;

    sms_list_type= MFW_SMS_MT;

    if( g_pcsyncstatus )//when pcsync run ,return,hxl add 2003-2-13
        return 1;

    g_sms_list_counter = 0;
    if( no_wait )//!smsidle_get_ready_state()&&
    {
        smsphkchecktimer= timCreate(0,ONE_SECS,(MfwCb)smsphkchecktimeEvent);
        //info_screen(win, TxtSimNot, TxtPleaseWait,(T_VOID_FUNC) SmsRead_R_dialog_cb,REMIND_WAITTING); 
        dialog_info_init(&DisplayInfo);//gdy add
        SmsMenu_loadDialogDefault(&DisplayInfo);
        DisplayInfo.TextId  = TxtSimNot;
        DisplayInfo.TextId2 = TxtPleaseWait;
        DisplayInfo.RightSoftKey=TxtSoftBack;
        DisplayInfo.KeyEvents= KEY_CLEAR|KEY_RIGHT;
        // Generic function for info messages
        DisplayInfo.Time   = FOREVER;
        DisplayInfo.iconindex =REMIND_WAITTING;
        DisplayInfo.Callback = (T_VOID_FUNC)SmsRead_timer_dialog_cb; 
        info_win=info_dialog(win, &DisplayInfo);
        timStart(smsphkchecktimer);                 /*      start clock          */
        return 1;
    }
    /* Call the function that manages SMS reading */
    SmsRead_R_start(win,(T_MFW_SMS_STAT*) &sms_list_type);

    return 1;
}

/*******************************************************************************

 $Function:     SmsRead_R_KINDExeOutgoing

 $Description:  This function is called when the user press Read outbox message in the
                main SMS menu

 $Returns:    Execution status

 $Arguments:  m - menu handler
        i - Menu item selected

*******************************************************************************/

int SmsRead_R_KINDExeOutgoing(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    //T_MFW_SMS_STAT  sms_Outgoing_list_type = MFW_SMS_MO;
    T_DISPLAY_DATA DisplayInfo;

    sms_list_type= MFW_SMS_MO;

    if( g_pcsyncstatus )//when pcsync run ,return,hxl add 2003-2-13
        return 1;

    g_sms_list_counter = 0;
    if( no_wait )
    {
        smsphkchecktimer= timCreate(0,ONE_SECS,(MfwCb)smsphkchecktimeEvent);
        //info_screen(win, TxtSimNot, TxtPleaseWait,(T_VOID_FUNC) SmsRead_R_dialog_cb,REMIND_WAITTING); 
        dialog_info_init(&DisplayInfo);//gdy add
        SmsMenu_loadDialogDefault(&DisplayInfo);
        DisplayInfo.TextId  = TxtSimNot;
        DisplayInfo.TextId2 = TxtPleaseWait;
        // Generic function for info messages
        DisplayInfo.Time   = FOREVER;
        DisplayInfo.RightSoftKey=TxtSoftBack;
        DisplayInfo.KeyEvents= KEY_CLEAR|KEY_RIGHT;
        DisplayInfo.iconindex =REMIND_WAITTING;
        DisplayInfo.Callback = (T_VOID_FUNC)SmsRead_timer_dialog_cb; 
        info_win=info_dialog(win, &DisplayInfo);
        timStart(smsphkchecktimer);                 /*      start clock          */
        return 1;
    }

    /* Call the function that manages SMS reading */
    SmsRead_R_start(win, (T_MFW_SMS_STAT*)&sms_list_type);

    return 1;
}
/*******************************************************************************

 $Function:    	SmsRead_R_OPTExeToNVM

 $Description:	Called when the user press SavetoNVM
            
 $Returns:		event status.

 $Arguments:	m - pointer to menu.
                i - index if selected menu item.
*******************************************************************************/

static int SmsRead_R_OPTExeToNVM(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT  * data     = (T_SMSREAD_R_OPT *)win_data->user;
    int j,index;
    T_DISPLAY_DATA DisplayInfo;
    FlashSms * tmp;
    T_MMI_FLASH_SMS_INDEX * tmp_index;
    T_MFW_SMS_IDX msg_info;

    TRACE_FUNCTION("SmsRead_R_OPTExeToNVM");
    j=Find_avail();
    sprintf(buf,">>>> ,Find_avail,j=%d",j);
    TRACE_EVENT(buf);
    index=j+CurrentFlashSmsTable*FlashSMS_table_len;
    sprintf(buf,">>>> ,j+CurrentFlashSmsTable*FlashSMS_table_len,index=%d",index);
    TRACE_EVENT(buf);
    tmp=&FFS_SMSData.NVMSMS[j];
    tmp_index=&Flash_sms_messages[index];
    if( FlashSMStotal < FLSAH_SMS_NUM )
    {
        if( data->sms_editor_data->sms_type == MMI_SMS_MO )
        {
            FlashSMStotal++;
            sms_copy_idx(data->sms_editor_data->sms_info->sms_mo.msg_ref, &msg_info);
            tmp->id=FlashSMStotal;
            memcpy((char *)tmp->addr,
                   (char *)data->sms_editor_data->sms_info->sms_mo.dest_addr.number,MFW_NUM_LEN);
            memcpy((char *)tmp->sms_msg,
                   (char *)data->sms_editor_data->sms_info->sms_mo.sms_msg,MAX_MSG_LEN);
            tmp->msg_len=data->sms_editor_data->sms_info->sms_mo.msg_len;
            if( msg_info.stat == MFW_SMS_STOR_UNSENT )
            {
                tmp->state=MFW_SMS_STOR_UNSENT;
                Flash_sms_messages[index].state=MFW_SMS_STOR_UNSENT;
            }
            else// if(msg_info.stat == MFW_SMS_STOR_SENT)
            {
                tmp->state=MFW_SMS_STOR_SENT;
                Flash_sms_messages[index].state=MFW_SMS_STOR_SENT;
            }
            tmp->dcs=data->sms_editor_data->sms_info->sms_mo.dcs;
            tmp->flag=TRUE;
            Flash_sms_messages[index].index=index;
            Flash_sms_messages[index].id=FlashSMStotal;
            memcpy((char *)Flash_sms_messages[index].addr,
                   (char *)data->sms_editor_data->sms_info->sms_mo.dest_addr.number,MFW_NUM_LEN);
            Flash_sms_messages[index].flag=TRUE;
            flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);        
        }
        else if( data->sms_editor_data->sms_type ==MMI_SMS_MT )
        {
            FlashSMStotal++;
            tmp->id=FlashSMStotal;
            ExtractNumber(&data->sms_editor_data->sms_info->sms_mt.orig_addr,(char *)tmp->addr);
            memcpy(&tmp->time, 
                   &data->sms_editor_data->sms_info->sms_mt.sctp, sizeof(T_MFW_SMS_SCTP));
            memcpy((char *)tmp->sms_msg,
                   (char *)data->sms_editor_data->sms_info->sms_mt.sms_msg,MAX_MSG_LEN);
            tmp->msg_len=data->sms_editor_data->sms_info->sms_mt.msg_len;
            tmp->state=MFW_SMS_MT;
            tmp->dcs=data->sms_editor_data->sms_info->sms_mt.dcs;
            tmp->flag=TRUE;
            memcpy(&tmp_index->time, 
                   &data->sms_editor_data->sms_info->sms_mt.sctp, sizeof(T_MFW_SMS_SCTP));
            tmp_index->index=index;
            tmp_index->id=FlashSMStotal;
            tmp_index->state=MFW_SMS_MT;
            /*Here extract the number for we needn't do it when build the list*/
            ExtractNumber(&data->sms_editor_data->sms_info->sms_mt.orig_addr,(char *)tmp_index->addr);
            tmp_index->flag=TRUE;
            flash_Smswrite(FlashSMSTable[CurrentFlashSmsTable]);        
        }

        Flash_sms_delete_screen(data->win,TxtSavingSms,500);
    }
    else
        SmsRead_R_OPT_StandardDialog(win, TxtSMSNVMFull, ONE_SECS);   
    //SmsRead_R_TEXTEDT2_destroy(parent_data->win);
    //SmsRead_R_OPT_destroy(data->win);
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPTExeDelete

 $Description:	Called when the user press Delete in the Option menu
            
 $Returns:		event status.

 $Arguments:	m - pointer to menu.
                i - index if selected menu item.
*******************************************************************************/

static int SmsRead_R_OPTExeDelete(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND          win      = mfwParent(mfw_header());
    T_MFW_WIN        * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT  * data     = (T_SMSREAD_R_OPT *)win_data->user;

    /* access to data from parent   */
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;

    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_HDR    * l_parent  =  parent_data->parent;

    T_DISPLAY_DATA DisplayInfo;

    TRACE_FUNCTION("SmsRead_R_OPTExeDelete");
    if( ( data->sms_editor_data->sms_type==MMI_SMS_MT )
        ||( data->sms_editor_data->sms_type==MMI_SMS_MO ) )
    {
        //deleting_win= smsRead_info_screen(parent_data->parent,TxtDeleted);
        if( data->sms_editor_data->sms_type==MMI_SMS_MT )
            sms_list_type=MFW_SMS_MT;
        else if( data->sms_editor_data->sms_type==MMI_SMS_MO )
            sms_list_type=MFW_SMS_MO;
        if( sms_msg_delete((UBYTE)data->sms_editor_data->sms_index)== MFW_SMS_OK )
        {
            if( deleting_win == 0 )
            {
                dialog_info_init(&DisplayInfo);//gdy add
                DisplayInfo.RightSoftKey = TxtSoftBack;
                DisplayInfo.LeftSoftKey =0;
                DisplayInfo.Time         = FOREVER;
                DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
                DisplayInfo.TextId2      = TxtDeleted;
                DisplayInfo.iconindex    =REMIND_SUCCEED;
                DisplayInfo.Callback=(T_VOID_FUNC)SmsRead_R_dialog_cb;
                deleting_win=info_dialog(parent_data->parent, &DisplayInfo);
            }
            SmsRead_R_TEXTEDT2_destroy(parent_data->win);
            SmsRead_R_OPT_destroy(data->win);
        }
        else
        {
            dialog_info_init(&DisplayInfo);//gdy add
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;
            DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
            DisplayInfo.TextId2      = TxtTryAgain;
            DisplayInfo.iconindex    =REMIND_WAITTING;
            DisplayInfo.Callback=(T_VOID_FUNC)FLASH_Sms_DELETED_dialog_cb;
            info_dialog(data->win, &DisplayInfo);
            //SmsRead_R_TEXTEDT2_destroy(parent_data->win);
            //SmsRead_R_OPT_destroy(data->win);
        }
    }
    else if( ( data->sms_editor_data->sms_type==MMI_SMS_FLASH_MT )
             ||( data->sms_editor_data->sms_type==MMI_SMS_FLASH_MO ) )
    {
        /* 2004/04/09 sunsj remove */
        /*
        if( FlashHostkeyData.HostLock_flag&&FlashHostkeyData.HostProtect_Items[PRO_MSGBOX] )
            HostkeyProtectOpts(data->win,PRO_MSGBOX);
        */
        if( Flash_sms_delete(g_sms_list_counter,parent_data->menu_list_data)== MFW_SMS_OK )
        {
#if 0
            dialog_info_init(&DisplayInfo);//gdy add
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;
            DisplayInfo.KeyEvents    = KEY_CLEAR;
            DisplayInfo.TextId2      = TxtDeleted;
            DisplayInfo.iconindex    =REMIND_SUCCEED;
            //DisplayInfo.Callback=(T_VOID_FUNC)FLASH_Sms_DELETED_dialog_cb;
            info_win=info_dialog(l_parent, &DisplayInfo);
#endif
            SmsRead_R_TEXTEDT2_destroy(parent_data->win);
            SmsRead_R_OPT_destroy(data->win);
            ModifyMenuList=1;
            SEND_EVENT (l_parent, E_RETURN,NULL, NULL);
            /*2004/04/16,talcon add */
            dialog_info_init(&DisplayInfo);//gdy add
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;
            DisplayInfo.KeyEvents    = KEY_CLEAR;
            DisplayInfo.TextId2      = TxtDeleted;
            DisplayInfo.iconindex    =REMIND_SUCCEED;
            //DisplayInfo.Callback=(T_VOID_FUNC)FLASH_Sms_DELETED_dialog_cb;
            info_dialog(l_parent, &DisplayInfo); /* 2004/4/20, wangyan modify*/
            /*end talcon add*/
            //FLASH_Sms_DELETED_Dialog(data->win, TxtDeleted,ONE_SECS); // TBD remplacer par ID
            /* set the status that the user selected the delete item */
        }
    }
    //SmsRead_R_OPT_StandardDialog(win, "Deleting...", 2000); // TBD remplacer par ID
    // Destroy the text editor and free memory.
    //SmsRead_R_TEXTEDT2_destroy(parent_data->win);
    //SmsRead_R_OPT_destroy(data->win);
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPTExeReply

 $Description:	Called when the user press Reply in the Option menu
            
 $Returns:		event status.

 $Arguments:	m - pointer to menu.
                i - index if selected menu item.
*******************************************************************************/

static int SmsRead_R_OPTExeReply(MfwMnu* m, MfwMnuItem* i)
{
    T_SmsUserData   SmsData;

    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT         * data = (T_SMSREAD_R_OPT *)win_data->user; 

    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;

    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;


    TRACE_FUNCTION("SmsRead_R_OPTExeReply");


    /* Copy the number and name information to the SMS buffer
    */
    SmsData.Send_state= E_REPLY;
    SmsData.TextBuffer[0] = '\0';
    //Copy the calling number for pasting into the number buffer;
    if( data->sms_editor_data->sms_info->sms_mt.orig_addr.ton ==MFW_TON_INTERNATIONAL )
    {
        if( data->sms_editor_data->sms_info->sms_mt.orig_addr.number[0] == '+' )
        {
            strcpy((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number);
        }
        else
        {
            strcpy((char *)SmsData.NumberBuffer,"+");
            strncat((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number,sizeof(SmsData.NumberBuffer)-2);
        }
    }
    else
        strcpy((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number);
    //strcpy((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number); 
    /*NM,  FTA 34.2.8 
            we have to know from where we are calling the 
            sms sending part. We should use the Service
            CenterNumber from the Caller only in the case of REPLYING
          */
    {
        char debug[30];
        sprintf(debug, "SC (ours): %s", (char *)SmsData.CentreBuffer);
        TRACE_EVENT(debug);
        sprintf(debug, "SC (given): %s", (char *)parent_data->sms_editor_data->sms_info->sms_mt.sc_addr);
        TRACE_EVENT(debug);
        sprintf(debug, "Reply path: %d", parent_data->sms_editor_data->sms_info->sms_mt.rp);
        TRACE_EVENT(debug);
    }

    // SH - Check the reply path to see if we should use our own service centre number
    SmsData.called_from_reply_item = FALSE;
#if 0    
    if( data->sms_editor_data->sms_info->sms_mt.rp &&
        strlen(data->sms_editor_data->sms_info->sms_mt.sc_addr) != 0 )
    {
        SmsData.called_from_reply_item = TRUE;
        // copy the service center number as well
        strcpy((char *)SmsData.CentreBuffer, (char *)data->sms_editor_data->sms_info->sms_mt.sc_addr);
    }
    else
    {
        /* use the own Service Center Number if the caller doesnt send one*/
        SmsData.called_from_reply_item = FALSE;
    }
#endif
    /* NM,  FTA 34.2.8  */
    /* NM,  FTA 34.2.8  */

    /* Destroy the Options Menu and text editor.before starting the Send Editor.*/
    /* p304 SH - call this after destroying editor & windows. parent_data is lost,
    so use pointer saved from above */
    SmsSend_SEND_start(parent_data->win, (void *) &SmsData);
    // Destroy the text editor, free memory
    //SmsRead_R_TEXTEDT2_destroy(parent_data->win);
    SmsRead_R_OPT_destroy(data->win);

    return 1;
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPTExeStoreNumber

 $Description:	Called when the user press Store Number in the Option menu
            
 $Returns:		event status.

 $Arguments:	m - pointer to menu.
                i - index if selected menu item.
*******************************************************************************/

static int SmsRead_R_OPTExeStoreNumber(MfwMnu* m, MfwMnuItem* i)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT         * data = (T_SMSREAD_R_OPT *)win_data->user;

    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_PHB_ENTRY  pb_data;
    //T_MFW_SMS_ADDR * tmp;

    TRACE_FUNCTION("SmsRead_R_OPTExeStoreNumber");
    ExtractNumber(&(data->sms_editor_data->sms_info->sms_mt.orig_addr),(char *)SmsData.NumberBuffer);
    //strcpy((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number); 
    if( bookPhoneBookLoading()==BOOK_SUCCESS )
    {
        T_MFW_HND phbk_win;

        phbk_win = bookPhonebookStart(win,PhbkNameEnterSms);
        SEND_EVENT( phbk_win, PHBK_SEND_NUMBER, 0,(char*)SmsData.NumberBuffer);
    }
    else
    {
        //Ժ
    }



    /*	
        strcpy((char *)SmsData.TextBuffer,(char *)parent_data->sms_editor_data->sms_info->sms_mt.sms_msg); 
        strcpy((char*)pb_data.number, (char*)SmsData.NumberBuffer); 
        
        //Search the phonebook for the sender number entry and display the tag and number.
        if (bookFindNameInPhonebook((const char*)&SmsData.NumberBuffer[0], &pb_data) !=0)
        {
    #ifdef NO_ASCIIZ			
            //Display the tag and number dialog.
            smsRead_NumberName_info_screen(parent_data->parent,(void *)&SmsData, (char*)pb_data.name.data);
    #else
            //Display the tag and number dialog.
            smsRead_NumberName_info_screen(parent_data->parent,(void *)&SmsData, (char*)pb_data.name);
    #endif
    
        }
        else
        {		
            smsRead_NumberName_info_screen(parent_data->parent,(void *)&SmsData,NULL);
        }
    */  

    /* Destroy the Options Menu and text editor. */
    //SmsRead_R_OPT_destroy(data->win);
    // Destroy the text editor, rel memory. 
    //SmsRead_R_TEXTEDT2_destroy(parent_data->win);
    return 1;
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPTExeEdit

 $Description:	Called when the user press Forward in the Option menu
            
 $Returns:		event status.

 $Arguments:	m - pointer to menu.
                i - index if selected menu item.
*******************************************************************************/

static int SmsRead_R_OPTExeEdit(MfwMnu* m, MfwMnuItem* i)
{
    T_SmsUserData   SmsData;
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT         * data = (T_SMSREAD_R_OPT *)win_data->user;

    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;

    TRACE_FUNCTION("SmsRead_R_OPTExeEdit");

    /* Copy the number and name information to the SMS buffer
   */
    SmsData.Send_state= E_EDIT;
    SmsData.NumberBuffer[0] = '\0';
    memcpy(SmsData.TextBuffer,sms_text_ascii,MAX_MSG_LEN);/* assumption: sms_text_ascii is still filled from reading the SMS*/
    SmsData.called_from_reply_item = FALSE;


    //NM FIX_170102
    //converting to 8bits before showing on the screen !
    //	SmsRead_convertSMSmsg(	parent_data->sms_editor_data->sms_info->sms_mt.sms_msg, parent_data->sms_editor_data->sms_info->sms_mt.dcs, parent_data->sms_editor_data->sms_info->sms_mt.msg_len,
    //							(char *)SmsData.TextBuffer, MFW_DCS_8bits,  MAX_MSG_LEN, TRUE);

    //NM FIX_170102 END

    SmsSend_SEND_start(parent_data->parent, (void *) &SmsData);

    /* Destroy the Options Menu and text editor.before starting the Send Editor.*/
    // Destroy the text editor and release memory
    SmsRead_R_TEXTEDT2_destroy(parent_data->win);
    SmsRead_R_OPT_destroy(data->win);

    return 1;
}


/*******************************************************************************

 $Function:    	SmsRead_R_OPTExeEdit

 $Description:	Called when the user press Forward in the Option menu
            
 $Returns:		event status.

 $Arguments:	m - pointer to menu.
                i - index if selected menu item.
*******************************************************************************/

static int SmsRead_R_OPTExeForward(MfwMnu* m, MfwMnuItem* i)
{
    T_SmsUserData   SmsData;
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT         * data = (T_SMSREAD_R_OPT *)win_data->user;

    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_SMS_IDX msg_info; /*2004/4/20, wangyan modify*/
    TRACE_FUNCTION("SmsRead_R_OPTExeEdit");

    /* Copy the number and name information to the SMS buffer*/
    SmsData.Send_state= E_FORWARD;
    SmsData.NumberBuffer[0] = '\0';

    /*2004/4/20, wangyan modify*/
    MMI_TRACE_EVENT(("wangyan SmsRead_R_OPTExeForward sms_type=%d",data->sms_editor_data->sms_type));
    if( data->sms_editor_data->sms_type==MMI_SMS_MO )
    {
        SmsData.sms_index=data->sms_editor_data->sms_index;
        sms_copy_idx(SmsData.sms_index, &msg_info);
        MMI_TRACE_EVENT(("wangyan SmsRead_R_OPTExeForward index=%d,type=%d,status=%d",data->sms_editor_data->sms_index,msg_info.msg_type,msg_info.stat));
        if( msg_info.stat==MFW_SMS_STOR_UNSENT )
            SmsData.msg_type=MFW_SMS_STOR_UNSENT;
        SmsData.sms_type=MENU_MMI_SMS_MO;
    }
    else if( data->sms_editor_data->sms_type==MMI_SMS_FLASH_MO )
    {

        MMI_TRACE_EVENT(("wangyan SmsRead_R_OPTExeForward index=%d,type=%d,status=%d",data->sms_editor_data->sms_index,msg_info.msg_type,msg_info.stat));
        if( tmp_flash->state==MFW_SMS_STOR_UNSENT )
            SmsData.msg_type=MFW_SMS_STOR_UNSENT;/*2004/4/6, wangyan add*/
        SmsData.sms_type=MENU_MMI_SMS_FLASH_MO;
        //		SmsData.smsflash=tmp_flash;
    }
    /*2004/4/20, wangyan modify*/


    //when we were reading the saved-SMS with the length of MAX_MSG_LEN
    memcpy(SmsData.TextBuffer,sms_text_ascii,MAX_MSG_LEN);/* assumption: sms_text_ascii is still filled from reading the SMS*/
    SmsData.called_from_reply_item = FALSE;
    /* Destroy the Options Menu and text editor.before starting the Send Editor.*/
    // Destroy the text editor and release memory
    SmsSend_SEND_start(parent_data->win, (void *) &SmsData);
    //SmsRead_R_TEXTEDT2_destroy(parent_data->win);
    SmsRead_R_OPT_destroy(data->win);   

    return 1;
}

/* api Store number for calling when reading SMS - 04/03/2002
*/

/*******************************************************************************

 $Function:    	Search_forNextNumber

 $Description:    Search through the SMS text and find a telephone number, the number 
                may start with the '+' prefix.
             
 $Returns:		Boolean
 
 $Arguments:	UserData - SMS data info
*******************************************************************************/
void SmsRead_R_OPTExeCallNumber(void)
{
    T_MFW_HND       win  = mfwParent(mfw_header());
    T_MFW_WIN     * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT         * data = (T_SMSREAD_R_OPT *)win_data->user;

    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_PHB_ENTRY  pb_data;

    TRACE_FUNCTION("SmsRead_R_OPTExeCallNumber");

    TRACE_EVENT_P1("TON = %d",parent_data->sms_editor_data->sms_info->sms_mt.orig_addr.ton);
    if( data->sms_editor_data->sms_info->sms_mt.orig_addr.ton ==MFW_TON_INTERNATIONAL )
    {
        if( data->sms_editor_data->sms_info->sms_mt.orig_addr.number[0] == '+' )
        {
            strcpy((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number);
        }
        else
        {
            strcpy((char *)SmsData.NumberBuffer,"+");
            strncat((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number,sizeof(SmsData.NumberBuffer)-2);
        }
    }
    else
        strcpy((char *)SmsData.NumberBuffer,(char *)data->sms_editor_data->sms_info->sms_mt.orig_addr.number);

    strcpy((char*)pb_data.number, (char*)SmsData.NumberBuffer); 
    callNumber(pb_data.number);

}
/*******************************************************************************

 $Function:    	SmsRead_R_READSMS_OPT_start

 $Description:	Start the creation of the Option Window from the Read SMS
                Text window.
            
 $Returns:		mfw window handler

 $Arguments:	parent_window- pointer to menu.
                menuAttr - menu attributes.
*******************************************************************************/

T_MFW_HND SmsRead_R_READSMS_OPT_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsRead_R_OPT_start()");

    win = SmsRead_R_OPT_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, SmsRead_R_READSMS_OPT_ID, (void *)menuAttr);
    }
    return win;
}
#if 0
/*******************************************************************************

 $Function:    	SmsRead_R_OPT_start

 $Description:	Start the creation of the Option window
            
 $Returns:		mfw window handler

 $Arguments:	parent_window- pointer to parent window
                menuAttr - menu attributes.
*******************************************************************************/

T_MFW_HND SmsRead_R_OPT_start(T_MFW_HND parent_window, MfwMnuAttr *menuAttr)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsRead_R_OPT_start()");

    win = SmsRead_R_OPT_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, SmsRead_R_OPT_ID, (void *)menuAttr);
    }
    return win;
}
#endif
/*******************************************************************************

 $Function:    	SmsRead_R_OPT_create

 $Description:	Create the Options window
            
 $Returns:		window handler

 $Arguments:	parent_window- pointer to parent window
*******************************************************************************/

static T_MFW_HND SmsRead_R_OPT_create(MfwHnd parent_window)
{
    T_SMSREAD_R_OPT      * data = (T_SMSREAD_R_OPT *)ALLOC_MEMORY (sizeof (T_SMSREAD_R_OPT));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsRead_R_OPT_create()");

    /*
     * Create window handler
     */

    data->win = 
    win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)SmsRead_R_OPT_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* 
     * connect the dialog data to the MFW-window
     */

    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsRead_R_OPT_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /*
     * return window handle
     */

    return data->win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPT_destroy

 $Description:	Destroy the Option window
            
 $Returns:		none

 $Arguments:	own_window- current window
*******************************************************************************/

static void SmsRead_R_OPT_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SMSREAD_R_OPT     * data;

    TRACE_FUNCTION ("SmsRead_R_OPT_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_SMSREAD_R_OPT *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            //sms_delete(data->sms);
            win_delete (data->win);

            /*     
             * Free Memory
             */
            FREE_MEMORY ((void *)data, sizeof (T_SMSREAD_R_OPT));
        }
        else
        {
            TRACE_EVENT ("SmsRead_R_OPT_destroy() called twice");
        }
    }
}
/*******************************************************************************

 $Function:    	SmsRead_R_OPT_exec_cb

 $Description:	Exec callback function for the Option window
            
 $Returns:		none

 $Arguments:	win- current window
                event - window event Id
                value - unique Id
                parameter- optional data.
*******************************************************************************/

void SmsRead_R_OPT_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
/* callback handler for events sent to to trigger execution */
{
    T_MFW_WIN        * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R_OPT  * data     = (T_SMSREAD_R_OPT *)win_data->user;
    SHORT            l_id;
    T_MFW_HDR    *parent      =  data->parent;
    T_MFW_EVENT         MfwEvents;
    char *title;
    T_MFW_SMS_IDX msg_info;
    TRACE_FUNCTION ("SmsRead_R_OPT_exec_cb()");


    switch( event )
    {
    case E_INIT:
        TRACE_EVENT(">> SmsRead_R_OPT_exec_cb(), E_INIT ");
        /* initialization of administrative data */
        data->id = value;

        if( value == SmsRead_R_READSMS_OPT_ID )
        {
            data->sms_editor_data = (T_SMS_EDITOR_DATA *)parameter;

            MfwEvents = E_SMS_ERR | E_SMS_OK;
            //data->sms = sms_create(data->win,MfwEvents,(MfwCb)SmsRead_R_OPT_mfw_cb);

            data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)SmsRead_R_OPT_kbd_cb);
            data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)SmsRead_R_OPT_kbd_cb);

            title = (char *) MmiRsrcGetText(TxtSoftOptions);  // get the editor title text
            /*check to see if we have an invalid message*/
            if( data->sms_editor_data->sms_type==MMI_SMS_MT )
            {
                sms_copy_idx(data->sms_editor_data->sms_index, &msg_info);
                if( msg_info.stat == MFW_SMS_INVALID )
                    data->menu = mnuListCreate(data->win,&SmsRead_R_OPTInvalidAttrib/*SPR 1830*/, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
                else
                    data->menu = mnuListCreate(data->win,&SmsRead_R_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
            }
            else if( data->sms_editor_data->sms_type==MMI_SMS_MO )
            {
                sms_copy_idx(data->sms_editor_data->sms_index, &msg_info);
                if( msg_info.stat == MFW_SMS_INVALID )
                    data->menu = mnuListCreate(data->win,&SmsRead_R_OPTInvalidAttrib/*SPR 1830*/, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
                else
                    data->menu = mnuListCreate(data->win,&SmsRead_RO_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
            }
            else if( data->sms_editor_data->sms_type==MMI_SMS_FLASH_MT )
                data->menu = mnuListCreate(data->win,&SmsRead_FST_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
            else if( data->sms_editor_data->sms_type==MMI_SMS_FLASH_MO )
                data->menu = mnuListCreate(data->win,&SmsRead_FSO_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
            mnuLang(data->menu,mainMmiLng);

            /* put the (new) dialog window on top of the window stack */
            mnuUnhide(data->menu);
            winShow(win);
            break;
        }
        else
        {
            // Catch the events concerning delete
            MfwEvents = E_SMS_ERR | E_SMS_OK;

            //data->sms = sms_create(data->win,MfwEvents,(MfwCb)SmsRead_R_OPT_mfw_cb);
            data->sms_editor_data = (T_SMS_EDITOR_DATA *)parameter;
        }
        break;
    case E_RETURN:
        /* create the dialog handler */
        TRACE_EVENT ("******windySmsRead_R_OPT_E_RETURN");
        //data->sms_editor_data = (T_SMS_EDITOR_DATA *)parameter;
#if 0
        data->kbd =      kbdCreate(data->win,KEY_ALL,         (MfwCb)SmsRead_R_OPT_kbd_cb);
        data->kbd_long = kbdCreate(data->win,KEY_ALL|KEY_LONG,(MfwCb)SmsRead_R_OPT_kbd_cb);
        title = (char *) MmiRsrcGetText(TxtSoftOptions);  // get the editor title text
        data->menu = mnuListCreate(data->win,&SmsRead_R_OPTAttrib, E_MNU_ESCAPE, (MfwCb)SmsRead_R_OPT_mnu_cb,title);
        mnuLang(data->menu,mainMmiLng);

        /* put the (new) dialog window on top of the window stack */
        mnuUnhide(data->menu);
        winShow(win);
#endif
        break;

    case E_BACK:
        l_id = data->id;
        SmsRead_R_OPT_destroy(data->win);
        SEND_EVENT (parent, E_RETURN, l_id, NULL); /* forward event to parent */
        break;

    case E_ABORT:
    case E_EXIT:
        SmsRead_R_OPT_destroy(data->win);
        SEND_EVENT (parent, event, l_id, NULL); /* forward event to parent */
        break;
    default:
        return;
    }
}
#if 0
/*******************************************************************************

 $Function:    	SmsRead_R_OPT_mfw_cb

 $Description:	Exec callback function for the DEL_ALL_ACK window
            
 $Returns:		status

 $Arguments:	event - window event Id
                parameter- optional data.
*******************************************************************************/

int SmsRead_R_OPT_mfw_cb (MfwEvt event, void *parameter)
{
    T_MFW_HND          win       = mfwParent((MfwHdr *)mfw_header());
    T_MFW_WIN        * win_data  = (T_MFW_WIN *)((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT  * data      = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_EVENT        MfwEvents;
    /* access to data from parent   */
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;

    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;

    T_DISPLAY_DATA DisplayInfo;

    TRACE_FUNCTION ("SmsRead_R_OPT_mfw_cb()");

    switch( event )
    {
    case E_SMS_ERR:
        if( deleting_win )
        {
            SEND_EVENT(deleting_win,DIALOG_DESTROY,0,0 );
            deleting_win = 0;
        }
        //winDelete(data->dialog_win);
        /* Display "All SMS deleted" and after timeout go back to parent */
        SmsRead_R_OPT_StandardDialog(win, TxtFailed, ONE_SECS); // TBD remplacer par ID

        break;

    case E_SMS_OK: 
        /* go now back to the parent             */
        /* destroy the dialog at first           */
        //winDelete(data->dialog_win);
        //TRACE_FUNCTION ("******windy delete sms first time");
        //if(deleting_win)
        //{
        // SEND_EVENT(deleting_win,DIALOG_DESTROY,0,0 );
        //	deleting_win = 0;
        //	SmsRead_R_TEXTEDT2_destroy(parent_data->win);
        //	SmsRead_R_OPT_destroy(data->win);
        //}
        /* Display "All SMS deleted" and after timeout go back to parent */
        //FLASH_Sms_DELETED_Dialog(data->win, TxtDeleted,ONE_SECS); // TBD remplacer par ID
        //SmsRead_R_OPT_StandardDialog(data->win, TxtDeleted, THREE_SECS); // TBD remplacer par ID
        break;
    }

}   
#endif
/*******************************************************************************

 $Function:    	SmsRead_R_OPT_mnu_cb

 $Description:	Menu callback function for the Option window
            
 $Returns:		status

 $Arguments:	e - mfw event Id
                m - menu handle
*******************************************************************************/

static int SmsRead_R_OPT_mnu_cb (MfwEvt e, MfwMnu *m)
/* SmsRead_R_OPT menu event handler */
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT      * data = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_HND  * l_parent;
    SHORT        l_id;

    TRACE_EVENT ("SmsRead_R_OPT_mnu_cb()");

    switch( e )
    {
    case E_MNU_ESCAPE: /* back to previous menu */
        l_parent = data->parent;
        l_id = data->id;
        SmsRead_R_OPT_destroy(data->win);
        SEND_EVENT (l_parent, E_RETURN, data->id, NULL);
        break;
    default: /* in mnuCreate() only E_MNU_ESCAPE has been enabled! */
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPT_win_cb

 $Description:	Window callback function for the Option window
            
 $Returns:		status

 $Arguments:	e - mfw event Id
                w - window handler
*******************************************************************************/

static int SmsRead_R_OPT_win_cb (MfwEvt e, MfwWin *w)
/* SmsRead_R_OPT window event handler */
{
    TRACE_FUNCTION ("SmsRead_R_OPT_win_cb()");

    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        displaySoftKeys(TxtSoftSelect,TxtSoftBack);
#if(MAIN_LCD_SZIE==3)
		draw_softkeybar_leftright_arrow();//jhxu720
#endif
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPT_kbd_cb

 $Description:	Exec callback function for the Option window
            
 $Returns:		status

 $Arguments:	e - keyboard event Id
                k - keyboard data 
*******************************************************************************/

static int SmsRead_R_OPT_kbd_cb (MfwEvt e, MfwKbd *k)
/* SmsRead_R_OPT keyboard event handler */
{
    T_MFW_HND    win  = mfwParent(mfw_header());
    T_MFW_WIN  * win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT      * data = (T_SMSREAD_R_OPT *)win_data->user;

    TRACE_FUNCTION ("SmsRead_R_OPT_kbd_cb()");

    if( e & KEY_LONG )
    {
        switch( k->code )
        {
        case KCD_HUP: /* back to previous menu */
            returntoidle(0);
            //mnuEscape(data->menu);
            break;
        case KCD_RIGHT: /* Power Down */
            return MFW_EVENT_REJECTED; /* handled by idle */
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    else
    {
        switch( k->code )
        {
        case KCD_MNUUP: /* highlight previous entry */
            mnuUp(data->menu);
            break;
        case KCD_MNUDOWN: /* highlight next entry */
            mnuDown(data->menu);
            break;
        case KCD_LEFT: /* activate this entry */
        case KCD_OK:
            mnuSelect(data->menu);
            break;
        case KCD_HUP: /* back to previous menu */
            if( returntoidle(0) )
                //mnuEscape(data->menu);
                break;
        case KCD_RIGHT: /* back to previous menu */
            mnuEscape(data->menu);
            break;
        case KCD_0://2004-05-10 Sunny add
        case KCD_1:
        case KCD_2:
        case KCD_3:
        case KCD_4:
        case KCD_5:
        case KCD_6:
        case KCD_7:
        case KCD_8:
        case KCD_9:
            mnuKeyAction(data->menu, k->code);
            break;//2004-05-10 Sunny add end
        default: /* no response to all other keys */
            return MFW_EVENT_CONSUMED;
        }
    }
    return MFW_EVENT_CONSUMED;
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPT_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list 
                of all the SMS). Case where SMS has not been initialized yet.
            
 $Returns:		status

 $Arguments:	win - window handler.
                Identifier -  unique identifier.
                Reason - cause of event.
*******************************************************************************/

int SmsRead_R_OPT_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT *data = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;

    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;

    TRACE_FUNCTION ("SmsRead_dialog_cb()");

    switch( Reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_HUP:
        // Commit suicide
        SmsRead_R_OPT_destroy(data->win);
        // Send E_RETURN event to parent window
        SEND_EVENT(parent_data->win, E_RETURN, data->id, NULL);
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_DisplayStandardDialog

 $Description:	Display a standard dialog with no soft key and 3 seconds of display
            
 $Returns:		none

 $Arguments:	win - window handler.
                text -  text string.
                duration - seconds
*******************************************************************************/

void SmsRead_DisplayStandardDialog(T_MFW_HND win, int TextId, ULONG duration)
{
    T_DISPLAY_DATA DisplayInfo;

    dialog_info_init(&DisplayInfo);//gdy add
    SmsMenu_loadDialogDefault(&DisplayInfo);

    DisplayInfo.TextId2 = TextId;
    DisplayInfo.Time = duration;
    DisplayInfo.iconindex=REMIND_NORECORD;//REMIND_NORECORD;
    //DisplayInfo.TextString = text;
    DisplayInfo.Callback = (T_VOID_FUNC)SmsRead_R_dialog_cb; 

    info_dialog(win, &DisplayInfo);
}

/*******************************************************************************

 $Function:    	SmsRead_R_OPT_StandardDialog

 $Description:	Display a standard dialog with no soft key and 3 seconds of display
            
 $Returns:		none

 $Arguments:	win - window handler.
                text -  text string.
                duration - seconds
*******************************************************************************/

void SmsRead_R_OPT_StandardDialog(T_MFW_HND win,  int TextId, ULONG duration)
{
    T_DISPLAY_DATA DisplayInfo;

    dialog_info_init(&DisplayInfo);//gdy add
    SmsMenu_loadDialogDefault(&DisplayInfo);

    DisplayInfo.TextId2 = TextId;
    DisplayInfo.Time = duration;
    //DisplayInfo.TextString = text;
    DisplayInfo.iconindex =REMIND_NORECORD;
    DisplayInfo.Callback = (T_VOID_FUNC)SmsRead_R_OPT_dialog_cb; //TBD

    info_dialog(win, &DisplayInfo);
}

/*******************************************************************************

 $Function:    	SmsRead_gsm_to_unicode

 $Description:	Convert a string coded in GSM alphabet in unicode string
            
 $Returns:		execution status

 $Arguments:	unicode_string - unicode string 
                gsm_string -  gsm text string.
                length - string length
*******************************************************************************/

#if 0
UBYTE SmsRead_gsm_to_unicode(charw_t * unicode_string, char * gsm_string, UBYTE length)
{
    UBYTE i;

    for( i = 0; i < length; i++ )
        unicode_string[i] = g_translation_unicode[gsm_string[i]];
    unicode_string[++i] = '\0';

    return TRUE;
}
#endif 

/*******************************************************************************

 $Function:    	SmsRead_gsm_to_ascii

 $Description:	Convert a string coded in GSM alphabet in ASCII string
            
 $Returns:		execution status

 $Arguments:	unicode_string - unicode string 
                gsm_string -  gsm text string.
                length - string length
*******************************************************************************/

UBYTE SmsRead_gsm_to_ascii(char * ascii_string, char * gsm_string, UBYTE length)
{
    USHORT i;

    for( i = 0; i < length; i++ )
        ascii_string[i] = g_translation_ascii_table[gsm_string[i]];
    ascii_string[++i] = '\0';

    return TRUE;
}

/*******************************************************************************

 $Function:    	string_CopyW2W

 $Description:	
            
 $Returns:		none

 $Arguments:	strDestination - destination string
                strSource -  source string
                count -number of character.
*******************************************************************************/

void string_CopyW2W(wstring_t *strDestination, charw_t *strSource, USHORT count )
// Copy characters of an ascii string to a wide counted string
{
    charw_t *pout = strDestination;
    //strDestination->length= count;
    while( count!=0 )
    {
        *pout++ = *strSource++;
        count--;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_start

 $Description:	Start the creation of the SMS editor window (display of the text 
                of one SMS)
 
 $Returns:		win - window handler.

 $Arguments:	parent_window - current window handler
                data - Menu attributes.
 
*******************************************************************************/

T_MFW_HND SmsRead_R_TEXTEDT2_start(T_MFW_HND parent_window, MfwMnuAttr *data)
{
    T_MFW_HND win;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT2_start()");

    win = SmsRead_R_TEXTEDT2_create (parent_window);

    if( win NEQ NULL )
    {
        SEND_EVENT (win, E_INIT, SmsRead_R_TEXTEDT2_ID, (void *)data);
    }
    return win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_create

 $Description:	Create the SMS editor window (display of the text of one SMS)
 
 $Returns:		window handler.

 $Arguments:	parent_window - current window handler
                
*******************************************************************************/

static T_MFW_HND SmsRead_R_TEXTEDT2_create(MfwHnd parent_window)
{
    T_SMSREAD_R_TEXTEDT2      * data = (T_SMSREAD_R_TEXTEDT2 *)ALLOC_MEMORY (sizeof (T_SMSREAD_R_TEXTEDT2));
    T_MFW_WIN  * win;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT2_create()");

    /* Create window handler  */

    data->win = win_create (parent_window, 0, E_WIN_VISIBLE, (T_MFW_CB)SmsRead_R_TEXTEDT2_win_cb);
    if( data->win EQ NULL )
    {
        return NULL;
    }
    /* connect the dialog data to the MFW-window  */

    data->mmi_control.dialog = (T_DIALOG_FUNC)SmsRead_R_TEXTEDT2_exec_cb;
    data->mmi_control.data   = data;
    win                      = ((T_MFW_HDR *)data->win)->data;
    win->user                = (void *)data;
    data->parent             = parent_window;

    /* return window handle */
    winShow(data->win);
    return data->win;
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_destroy

 $Description:	Destroy the SMS editor window (display of the text of one SMS)
 
 $Returns:		none

 $Arguments:	own_window - current window handler
                
*******************************************************************************/

static void SmsRead_R_TEXTEDT2_destroy(MfwHnd own_window)
{
    T_MFW_WIN * win_data;
    T_SMSREAD_R_TEXTEDT2     * data;

    USHORT i;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT2_destroy()");

    if( own_window )
    {
        win_data = ((T_MFW_HDR *)own_window)->data;
        data = (T_SMSREAD_R_TEXTEDT2 *)win_data->user;

        if( data )
        {
            /*
             * Delete WIN handler
             */ 
            sprintf(buf,">>>> CHECK before sms_info pointer:%d ",(void *)data->sms_editor_data->sms_info);
            TRACE_EVENT(buf);
            editor_destroy(data->editor_win);

            win_delete (data->win);
            /*     
             * Free Memory
             */

            //MZ 18/4/01  Delete the SMS info buffer.

            //sprintf(buf,">> SmsRead_R:Free T_MFW_SMS_PARA sms_info:%d size:%d",(void*)data->sms_editor_data->sms_info,sizeof(T_MFW_SMS_PARA));
            //TRACE_EVENT(buf);

            FREE_MEMORY ((void *)data->sms_editor_data->sms_info, sizeof (T_MFW_SMS_PARA));

            //sprintf(buf,">> SmsRead_R:Free T_SMSREAD_R_TEXTEDT2 SMS data:%d size:%d",(void*)data,sizeof (T_SMSREAD_R_TEXTEDT2));
            //TRACE_EVENT(buf);
            FREE_MEMORY ((void *)data, sizeof (T_SMSREAD_R_TEXTEDT2));
            //	sprintf(buf,">>>> FREE_MEMORY,sms_list_type=%d",sms_list_type);
            //	TRACE_EVENT(buf);

        }
        else
        {
            TRACE_EVENT ("SmsRead_R_TEXTEDT2_destroy() called twice");
        }
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXT_editor_cb

 $Description:	Callback function for the text editor
 
 $Returns:		none

 $Arguments:	win - current window handler
                Identifier -Unique identifier.
                reason - event 
*******************************************************************************/

static void SmsRead_R_TEXT_editor_cb (T_MFW_HND win, USHORT Identifier, SHORT reason)
{
    T_MFW_PHB_ENTRY  pb_data;
    T_MFW_WIN   * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R_TEXTEDT2      * data     = (T_SMSREAD_R_TEXTEDT2 *)win_data->user;
    //T_MFW_SMS_STAT  sms_list_type = MFW_SMS_ALL;
    TRACE_FUNCTION ("SmsRead_R_TEXT_editor_cb()");

    switch( reason )
    {
    case INFO_KCD_LEFT:
        // Present the user with an Options menu from the Read SMS text screen.:16/2/01
        SmsRead_R_READSMS_OPT_start(win, (MfwMnuAttr*)data->sms_editor_data);
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        SEND_EVENT (win, E_RETURN, data->id, NULL);
        /*MC very dodgy list refresh*/
        //SmsRead_R_mfw_cb(E_SMS_OK, NULL);
        break;
    case INFO_KCD_DOWN:
        // Scroll Down the text screen 
        // SEND_EVENT (win, E_RETURN, SMSSEND_ID_NBEDIT, NULL);
        break;
    case INFO_KCD_CALL:
        TRACE_EVENT_P1("Number is = %d",(int)pb_data.number);
        callNumber(pb_data.number);
        break;

    case INFO_EDT_UPDATE:
#if 0 /*2003/12/5, wangyan modify*/
        if( type EQ MFW_SMS_MO )
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=14 )
                {
                    dspl_Clear(0, 0, 120, 17);
                    drawSolidRectangle(2, 2, 117, 17, 2, 0x77ECB1,0x006400);
                }
                else
                {
                    dspl_Clear(0, 0, 120, 33);
                    drawSolidRectangle(2, 2, 117, 33, 2, 0x77ECB1,0x006400);
                }
            }
        }
        else
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=26 )
                {
                    dspl_Clear(0, 0, 120, 33);
                    drawSolidRectangle(2, 2, 117, 33, 2, 0x77ECB1,0x006400);
                }
                else
                {
                    dspl_Clear(0, 0, 120, 49);
                    drawSolidRectangle(2, 2, 117, 49, 2, 0x77ECB1,0x006400);
                }
            }
        }
        dspl_colorTextOut(3,2,DSPL_TXTATTR_TRANSPARENT,(char*)sms_text_buffer,0x000000);
#endif /*2003/12/5, wangyan modify*/
        if( type EQ MFW_SMS_MO )
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=14 )
                {
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
                else
                {
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,14, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
            }
        }
        else
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=26 )
                {
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,14, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);

                }
                else
                {
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,14, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    // dspl_BitBlt(0,26, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
            }
        }
        //2004-04-06 Sunny modify. old: 0xffffff
        drawcolorclarity(2,2,(char*)sms_text_buffer,0x000000);
        break;
    default:
        TRACE_EVENT("Err: Default No match found");
        break;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_exec_cb

 $Description:	Exec callback function of the SMS editor window (display of the 
                text of one SMS)
 
 $Returns:		none

 $Arguments:	win - current window handler
                event - event id
                value - unique id
                parameter - optional data. 
*******************************************************************************/

void SmsRead_R_TEXTEDT2_exec_cb (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
/* callback handler for events sent to to trigger execution */
{   
    T_MFW_WIN      * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R_TEXTEDT2   * data = (T_SMSREAD_R_TEXTEDT2 *)win_data->user;
    T_MFW_HND      * l_parent=  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)l_parent)->data;
    T_SMSREAD_R  * parent_data =  (T_SMSREAD_R *)win_data2->user;
    SHORT            l_id;
    T_MFW_SMS_MO *SmsMo;
    T_MFW_SMS_MT *SmsMt;
    T_MFW_SMS_CB *SmsCb;
    T_EDITOR_DATA sms_editor_info;
    USHORT i;
    char text_8bit[50];  //buffer for conversion from 7bit to 8bit
    USHORT index=0;
    char * tmpsms;
    USHORT* unicodeStr; 
    USHORT* txtStr;
    int uIndex;
    T_FindName  searchPhdata;
    T_MFW_SMS_IDX msg_info;
    char NumberBuffer[NUMBER_LENGTH];
    USHORT sms_len;

    TRACE_FUNCTION ("SmsRead_R_TEXTEDT2_exec_cb()");

    switch( event )
    {
    case E_INIT:
        /* initialization of administrative data */
        data->id = value;
        data->sms_editor_data = (T_SMS_EDITOR_DATA *)parameter;
        data->menu_list_data=(ListMenuData *)parent_data->menu_list_data;
        switch( data->sms_editor_data->sms_type )
        {
        case MMI_SMS_MO:
        case MMI_SMS_FLASH_MO:
            /* where does we need that:   For editor when the user wants to editing the sms-message */
            SmsMo = (T_MFW_SMS_MO *)data->sms_editor_data->sms_info;
            if( data->sms_editor_data->sms_type==MMI_SMS_MO )
                type=MFW_SMS_MO;
            else
                type=MFW_SMS_FLASH_MO;
            //read_status = MFW_SMS_MO;
            if( g_sms_state EQ READ_SELECTED_SMS )
                sms_copy_idx(SmsMo->msg_ref, &msg_info);
            else
            {
                if( CurrentFlashSmsTable!=Flash_sms_sort_index[g_sms_list_counter].index/FlashSMS_table_len )
                {
                    CurrentFlashSmsTable=Flash_sms_sort_index[g_sms_list_counter].index/FlashSMS_table_len;
                    flash_Smsread(FlashSMSTable[CurrentFlashSmsTable]);
                }
                i=Flash_sms_sort_index[g_sms_list_counter].index%FlashSMS_table_len;
                //i=Find_Del_Table(Flash_sms_sort_index[g_sms_list_counter].id);
                msg_info.stat=FFS_SMSData.NVMSMS[i].state;
            }
            memset (sms_text_buffer, 0, sizeof(sms_text_buffer));
            if( msg_info.stat != MFW_SMS_INVALID )/*SPR 1830*/
            {
                memset (text_8bit, 0, sizeof(text_8bit));
                if( Mmi_getCurrentLanguage() != CHINESE_LANGUAGE )
                {
                    if( msg_info.stat == MFW_SMS_STOR_UNSENT )
                        strcpy(sms_text_buffer,MmiRsrcGetText(TxtUNSend));
                    else// if(msg_info.stat == MFW_SMS_STOR_SENT)
                        strcpy(sms_text_buffer,MmiRsrcGetText(TxtSendTo));
                    strcat(sms_text_buffer,":");            
                }
                else
                {
                    unicodeStr =charPtrToUSHORTPtr(sms_text_buffer);
                    uIndex = 0;
                    if( msg_info.stat == MFW_SMS_STOR_UNSENT )
                        txtStr = charPtrToUSHORTPtr(MmiRsrcGetText(TxtUNSend));
                    else// if(msg_info.stat == MFW_SMS_STOR_SENT)
                        txtStr = charPtrToUSHORTPtr(MmiRsrcGetText(TxtSendTo));
                    while( (*txtStr!= 0) && (uIndex*2 <MAX_LISTSMS_LEN) )
                    {
                        unicodeStr[uIndex] = *txtStr;
                        txtStr++;
                        uIndex++;
                    }
                    wstrcat(USHORTPtrToCharPtr(unicodeStr),":");
                }
                memset(text_8bit, 0, sizeof(text_8bit));
                /* add the number or the name if he can find it in the phonebook*/
                if( FindNumber((char*)SmsMo->dest_addr.number, (T_FindName *)&searchPhdata) )
                {
                    if( searchPhdata.name[0] != 0x80 )
                        AscEx_To_Unicode((char*)searchPhdata.name, (char*)text_8bit );
                    else
                        memcpy(text_8bit,(char*)searchPhdata.name,sizeof(searchPhdata.name));
                }
                else
                {
                    AscEx_To_Unicode((char*)SmsMo->dest_addr.number,(char*)text_8bit );
                }
                wstrcat(sms_text_buffer,text_8bit);
                memset(sms_text_ascii,0, sizeof(sms_text_ascii));
                if( SmsMo->dcs==0x08 ||SmsMo->dcs==0x18 )
                {
                    sprintf(buf, "windy: SmsMo->dcs=%d", SmsMo->dcs);
                    TRACE_EVENT(buf);
                    tmpsms=mmi_Sim_Sys(SmsMo->sms_msg,SmsMo->msg_len,  MFW_DCS_UCS2,MAX_MSG_LEN);
                    sprintf(buf, "windy:SmsMo->msg_len= %d", SmsMo->msg_len);
                    TRACE_EVENT(buf);
                    memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
                }
                else
                {
                    sprintf(buf, "windy: 8bitsSmsMo->dcs=%d", SmsMo->dcs);
                    TRACE_EVENT(buf);
                    //windy modify here according NOKIA's short message ,if sms is all ASCII it must be 8bits code.
                    tmpsms=mmi_Sim_Sys(SmsMo->sms_msg,SmsMo->msg_len,MFW_DCS_8bits,MAX_MSG_LEN);
                    memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
                }
            }
            else
            {
                if( Mmi_getCurrentLanguage() != CHINESE_LANGUAGE )
                {
                    strcpy(sms_text_ascii,MmiRsrcGetText(TxtInvalidMessage));
                }
                else
                {
                    unicodeStr =charPtrToUSHORTPtr(sms_text_ascii);
                    uIndex = 0;
                    txtStr = charPtrToUSHORTPtr(MmiRsrcGetText(TxtInvalidMessage));
                    while( (*txtStr!= 0) && (uIndex*2 <MAX_LISTSMS_LEN) )
                    {
                        unicodeStr[uIndex] = *txtStr;
                        txtStr++;
                        uIndex++;
                    }
                    wstrcat(USHORTPtrToCharPtr(unicodeStr),".");
                }
            }
            //sms_change_read_status(SmsMo->msg_ref);
            break;

        case MMI_SMS_MT:
        case MMI_SMS_FLASH_MT:
            /* where does we need that: For editor when the user wants to editing the sms-message */
            SmsMt = (T_MFW_SMS_MT *)data->sms_editor_data->sms_info;
            if( data->sms_editor_data->sms_type==MMI_SMS_MT )
                type=MFW_SMS_MT;
            else
                type=MFW_SMS_FLASH_MT;
            //read_status = MFW_SMS_MT;
            sms_copy_idx(SmsMt->index, &msg_info);
            memset(sms_text_buffer,0, sizeof(sms_text_buffer));
            if( msg_info.stat!=MFW_SMS_INVALID )
            {
                memset (text_8bit, 0, sizeof(text_8bit));
                ChangeTime( (char *) text_8bit,&SmsMt->sctp);
                strcat(text_8bit,"\n");
                AscEx_To_Unicode((char* )text_8bit, (char*)sms_text_buffer );

                memset(text_8bit,0, sizeof(text_8bit));
                /* 2004/02/11 sunsj modify sms display */
                /*
                if( Mmi_getCurrentLanguage() != CHINESE_LANGUAGE )
                {
                    strcpy(text_8bit,MmiRsrcGetText(TxtRecieveFrom));
                    strcat(text_8bit,":");          
                }
                else
                {
                    unicodeStr =charPtrToUSHORTPtr(text_8bit);
                    uIndex = 0;
                    txtStr = charPtrToUSHORTPtr(MmiRsrcGetText(TxtRecieveFrom));
                    while( (*txtStr!= 0) && (uIndex*2 <MAX_LISTSMS_LEN) )
                    {
                        unicodeStr[uIndex] = *txtStr;
                        txtStr++;
                        uIndex++;
                    }
                    wstrcat(USHORTPtrToCharPtr(unicodeStr),":");
                }
                wstrcat(sms_text_buffer,text_8bit);
                
                memset(text_8bit, 0, sizeof(text_8bit));
                */
                memset(NumberBuffer, 0, sizeof(NumberBuffer));
                ExtractNumber(&(SmsMt->orig_addr),(char *)NumberBuffer);

                /* add the number or the name if he can find it in the phonebook*/
                if( FindNumber((char*)(NumberBuffer), (T_FindName *)&searchPhdata) )
                {
                    if( searchPhdata.name[0] != 0x80 )
                        AscEx_To_Unicode((char*)searchPhdata.name, (char*)text_8bit );
                    else
                        memcpy(text_8bit,(char*)searchPhdata.name,sizeof(searchPhdata.name));
                }
                else
                {
                    AscEx_To_Unicode((char*)NumberBuffer,(char*)text_8bit );
                }
                wstrcat(sms_text_buffer,text_8bit);
                memset((char*)sms_text_ascii,0,sizeof(sms_text_ascii));
                if( SmsMt->dcs==0x08||SmsMt->dcs==0x18 )
                {
                    //                    sprintf(buf, "windy: SmsMt->dcs=%d", SmsMt->dcs);
                    //                    TRACE_EVENT(buf);
                    tmpsms=mmi_Sim_Sys(SmsMt->sms_msg,SmsMt->msg_len,MFW_DCS_UCS2,MAX_MSG_LEN);
                    //                    sprintf(buf, "windy:SmsMt->msg_len= %d", SmsMt->msg_len);
                    //                    TRACE_EVENT(buf);
                    memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
                }
                else
                {
                    //                    sprintf(buf, "windy: 8bitsSmsMt->dcs=%d", SmsMt->dcs);
                    //                    TRACE_EVENT(buf);
                    tmpsms=mmi_Sim_Sys(SmsMt->sms_msg,SmsMt->msg_len, MFW_DCS_8bits,MAX_MSG_LEN);
                    memcpy(sms_text_ascii,tmpsms,MAX_MSG_LEN);
                }
            }
            else
            {
                if( Mmi_getCurrentLanguage() != CHINESE_LANGUAGE )
                {
                    strcpy(sms_text_ascii,MmiRsrcGetText(TxtInvalidMessage));
                }
                else
                {
                    unicodeStr =charPtrToUSHORTPtr(sms_text_ascii);
                    uIndex = 0;
                    txtStr = charPtrToUSHORTPtr(MmiRsrcGetText(TxtInvalidMessage));
                    while( (*txtStr!= 0) && (uIndex*2 <MAX_LISTSMS_LEN) )
                    {
                        unicodeStr[uIndex] = *txtStr;
                        txtStr++;
                        uIndex++;
                    }
                    wstrcat(USHORTPtrToCharPtr(unicodeStr),".");
                }
            }
            if( g_sms_state EQ READ_SELECTED_SMS )
            {
                //sms_copy_idx(SmsMt->index, &msg_info);
                //if(msg_info.stat==MFW_SMS_UNREAD)
                //{
                sms_change_read_status(SmsMt->index);
                parent_data->sms_list_data.sms_messages[g_sms_list_counter].stat=MFW_SMS_READ;
                /* 2004/06 sunsj modify for picture manage */
                parent_data->menu_list_data->List[g_sms_list_counter].icon = GET_ICONATTR(ICON_SMSMT_LIST, 0);//&mtlist;
                //ModifyMenuList=1;
                //}
            }
            break;

        case MMI_SMS_CB:
            SmsCb = (T_MFW_SMS_CB *)data->sms_editor_data->sms_info;
            break;

        }

        SmsSend_loadEditDefault(&sms_editor_info);
#if (MAIN_LCD_SIZE==3)//jhxu720
		if( (type EQ MFW_SMS_MO)||(type EQ MFW_SMS_FLASH_MO) )
        {
            //if( wstrBitlen((char * )sms_text_buffer)<=14 )
            //{
            //    sms_editor_info.editor_attr.win.px=0;
            //    sms_editor_info.editor_attr.win.py=20;
            //    sms_editor_info.editor_attr.win.sx=120;
            //    sms_editor_info.editor_attr.win.sy=122;
            //}
            //else
            {
				/* 2004/03/29 sunsj modify */
                sms_editor_info.editor_attr.win.px=1;
                sms_editor_info.editor_attr.win.py=26;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X - 2;
                sms_editor_info.editor_attr.win.sy=87;
            }
        }
        else
        {
			/* 2004/02/11 sunsj modify sms display */
            //if( wstrBitlen((char * )sms_text_buffer)<=26 )
            {
                sms_editor_info.editor_attr.win.px=1;
                sms_editor_info.editor_attr.win.py=26;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X-2;
                sms_editor_info.editor_attr.win.sy=87;//shiheng modify
            }
			/*
            else
            {
			sms_editor_info.editor_attr.win.px=0;
			sms_editor_info.editor_attr.win.py=26;
			sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X;
			sms_editor_info.editor_attr.win.sy=41;
            }
			*/
        }
#elif ( MAIN_LCD_SIZE==4 )
        if( (type EQ MFW_SMS_MO)||(type EQ MFW_SMS_FLASH_MO) )
        {
            if( wstrBitlen((char * )sms_text_buffer)<=14 )
            {
                sms_editor_info.editor_attr.win.px=0;
                sms_editor_info.editor_attr.win.py=20;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X;
                sms_editor_info.editor_attr.win.sy=122;
            }
            else
            {
                sms_editor_info.editor_attr.win.px=0;
                sms_editor_info.editor_attr.win.py=36;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X;
                sms_editor_info.editor_attr.win.sy=106;
            }
        }
        else
        {
            if( wstrBitlen((char * )sms_text_buffer)<=26 )
            {
                sms_editor_info.editor_attr.win.px=0;
                sms_editor_info.editor_attr.win.py=36;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X;
                sms_editor_info.editor_attr.win.sy=106;
            }
            else
            {
                sms_editor_info.editor_attr.win.px=0;
                sms_editor_info.editor_attr.win.py=52;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X;
                sms_editor_info.editor_attr.win.sy=90;
            }
        }
#elif ( MAIN_LCD_SIZE==2 )
        if( (type EQ MFW_SMS_MO)||(type EQ MFW_SMS_FLASH_MO) )
        {
            //if( wstrBitlen((char * )sms_text_buffer)<=14 )
            //{
            //    sms_editor_info.editor_attr.win.px=0;
            //    sms_editor_info.editor_attr.win.py=20;
            //    sms_editor_info.editor_attr.win.sx=120;
            //    sms_editor_info.editor_attr.win.sy=122;
            //}
            //else
            {
                /* 2004/03/29 sunsj modify */
                sms_editor_info.editor_attr.win.px=1;
                sms_editor_info.editor_attr.win.py=26;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X - 2;
                sms_editor_info.editor_attr.win.sy=41;
            }
        }
        else
        {
            /* 2004/02/11 sunsj modify sms display */
            //if( wstrBitlen((char * )sms_text_buffer)<=26 )
            {
                sms_editor_info.editor_attr.win.px=1;
                sms_editor_info.editor_attr.win.py=26;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X-2;
                sms_editor_info.editor_attr.win.sy=41;
            }
            /*
            else
            {
                sms_editor_info.editor_attr.win.px=0;
                sms_editor_info.editor_attr.win.py=26;
                sms_editor_info.editor_attr.win.sx=SCREEN_SIZE_X;
                sms_editor_info.editor_attr.win.sy=41;
            }
            */
        }
#endif
        sms_editor_info.editor_attr.text = (char *)sms_text_ascii;  
        /*		Actually we have 2 different size of messages:
                1) SMS_MT with MAX_EDITOR_LEN because of the DATE,TIME,NUMBER
                2) SMS_MO with MAX_MSG_LEN, just the message itself
        */
        sms_editor_info.editor_attr.size     = MAX_MSG_LEN+3;
        sms_editor_info.editor_attr.fgColor  = 0xffffff;
        sms_editor_info.min_enter            = 0; 
        sms_editor_info.LeftSoftKey          = TxtSoftOptions;
        sms_editor_info.AlternateLeftSoftKey = TxtSoftOptions;
        sms_editor_info.RightSoftKey         = TxtSoftBack;
        sms_editor_info.Identifier           = SMSREAD_EDIT ; 
        sms_editor_info.destroyEditor        = FALSE ;
        sms_editor_info.Callback             = (T_EDIT_CB)SmsRead_R_TEXT_editor_cb;
        sms_editor_info.mode                 = READ_ONLY_MODE;

        data->editor_win = editor_start(win,&sms_editor_info);  /* start the editor */

#if 0 /*2003/12/5, wangyan modify*/
        if( (type EQ MFW_SMS_MO)||(type EQ MFW_SMS_FLASH_MO) )
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=14 )
                {
                    dspl_Clear(0, 0, 120, 17);
                    drawSolidRectangle(2, 2, 117, 17, 2, 0x77ECB1,0x006400);
                }
                else
                {
                    dspl_Clear(0, 0, 120, 33);
                    drawSolidRectangle(2, 2, 117, 33, 2, 0x77ECB1,0x006400);
                }
            }
        }
        else
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=26 )
                {
                    dspl_Clear(0, 0, 120, 33);
                    drawSolidRectangle(2, 2, 117, 33, 2, 0x77ECB1,0x006400);
                }
                else
                {
                    dspl_Clear(0, 0, 120, 49);
                    drawSolidRectangle(2, 2, 117, 49, 2, 0x77ECB1,0x006400);
                }
            }
        }
        dspl_colorTextOut(3,2,DSPL_TXTATTR_TRANSPARENT,(char*)sms_text_buffer,0x000000);
#endif /*2003/12/5, wangyan modify*/


        if( (type EQ MFW_SMS_MO)||(type EQ MFW_SMS_FLASH_MO) )
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                if( wstrBitlen((char * )sms_text_buffer)<=14 )
                {
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
                else
                {
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,16, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
            }
        }
        else
        {
            if( wstrBitlen((char * )sms_text_buffer)>0 )
            {
                /* 2004/02/11 sunsj modify sms display */
                //if( wstrBitlen((char * )sms_text_buffer)<=26 )
                {
                    dspl_Clear(0, 0, SCREEN_SIZE_X, 26);
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,16, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
                /*
                else
                {
                    dspl_Clear(0, 0, SCREEN_SIZE_X, 26);
                    //dspl_BitBlt(0, 0, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,16, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                    //dspl_BitBlt(0,32, menuup[FlashSettingData.theme].area.sx, menuup[FlashSettingData.theme].area.sy, 0, (void*)menuup[FlashSettingData.theme].icons, 0);
                }
                */
            }
        }
        /* 2004/02/11 sunsj modify sms display */
        drawcolorclarity(2,2,(char*)sms_text_buffer,0x000000);

        if( info_win )
        {
            SEND_EVENT(info_win,DIALOG_DESTROY,0,0 );
            info_win = 0;
        }
        break;

    case E_BACK:
        l_parent = data->parent;
        l_id = data->id;
        /* The editor has sent an E_BACK event, we return to the previous window (E_RETURN) */
        SmsRead_R_TEXTEDT2_destroy(data->win);
        SEND_EVENT (l_parent, E_BACK, l_id, NULL);
        break;

    case E_RETURN:
        l_parent = data->parent;
        l_id = data->id;
        /* The editor has sent an E_BACK event, we return to the previous window (E_RETURN) */
        SmsRead_R_TEXTEDT2_destroy(data->win);
        SEND_EVENT (l_parent, E_RETURN, l_id, NULL);
        break;

    case E_ABORT:
    case E_EXIT:
        l_parent = data->parent;
        l_id = data->id;
        SEND_EVENT (l_parent, event, l_id, NULL); /* forward event to parent */
        SmsRead_R_TEXTEDT2_destroy(data->win);
        break;

    default:
        return;
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_win_cb

 $Description:	Window callback function of the SMS editor window (display of 
                the text of one SMS).

 $Returns:		execution status

 $Arguments:	w - mfw window handle
                e - event id
                value - unique id
                parameter - optional data. 
*******************************************************************************/

static int SmsRead_R_TEXTEDT2_win_cb (MfwEvt e, MfwWin *w)
/* window event handler */
{
    TRACE_FUNCTION ("SmsRead_R_TEXTEDT2_win_cb()");

    switch( e )
    {
    case MfwWinVisible:  /* window is visible  */
        break;
    case MfwWinFocussed: /* input focus / selected   */
    case MfwWinDelete:   /* window will be deleted   */
    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}
#if 0
/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_smslist_cb

 $Description:	Callback function of the SMS editor window (editor itself).
 
 $Returns:		none
 
 $Arguments:	Parent - parent window.
                ListData - Menu item list
*******************************************************************************/

void SmsRead_R_TEXTEDT2_smslist_cb(T_MFW_HND * Parent, ListMenuData * ListData)
{
    T_MFW_WIN       * win_data = ((T_MFW_HDR *)Parent)->data;
    T_SMSREAD_R * data     = (T_SMSREAD_R *)win_data->user;    

    T_MFW_HND      * l_parent;
    SHORT            l_id;

    if( (ListData->Reason EQ LISTS_REASON_BACK) || (ListData->Reason EQ LISTS_REASON_CLEAR)
        || (ListData->Reason EQ LISTS_REASON_HANGUP) )
    {
        l_parent = data->parent;
        l_id = data->id;
        SmsRead_R_destroy(data->win);
        //The editor has sent an back event, we return to the previous window (E_RETURN)
        SEND_EVENT (l_parent, E_RETURN, l_id, NULL);
    }
}

/*******************************************************************************

 $Function:    	check_assoc_name

 $Description:	This function search if a phone number corresponds to any name in phonebook
                or to the voice mailbox or to the SMS center
                BE CAREFUL it allocates memory for the name, that has to be freed by the caller
                It returns the length of the associated name if found, else length is 0 and name is NULL
             
 $Returns:		string length
 
 $Arguments:	name - string
                sms_addr - phonenumber string.
*******************************************************************************/

UBYTE check_assoc_name(char *name, T_MFW_SMS_ADDR sms_addr)
{
    // MZ T_MFW_SMS_STAT pb_entry;
    T_MFW_SMS_ADDR pb_entry;
    USHORT i;



    // TBD: add international numbers management

    // Voice, fax... mailboxes data

    USHORT max_rcd;
    char mail_number[PHB_MAX_LEN + 1];
    char mail_alpha[10]; // size hard coded in pcm.h
    UBYTE nlen;

    name = NULL;

    // First: look in phonebook

    if( bookFindNameInPhonebook((const char*)&sms_addr.number[0], (T_MFW_PHB_ENTRY*)&pb_entry) )
    {
        // A name has been found
        if( (name = (char*)ALLOC_MEMORY(strlen(pb_entry.tag) + 1)) != NULL )
        {
            strcpy(name, pb_entry.tag);
            return strlen(name);
        }
    }

    // Then the different mailboxes (voice, fax, data...)
    for( i = MFW_MB_LINE1; i <= MFW_MB_DATA; i++ )
    {
        
        {
            cmhPHB_getAdrStr(mail_number, PHB_MAX_LEN - 1, FFS_flashData.mbn_Num, FFS_flashData.mbn_len);

            if( strcmp(sms_addr.number, mail_number) EQ 0 )
            {
                // If the same number then we get the alpha identifier
                cmhPHB_getMfwTagNt ( FFS_flashData.mbn_AlphId, 10, (UBYTE*)mail_alpha, &nlen );
                mail_alpha[nlen] = '\0';    

                if( (name = (char*)ALLOC_MEMORY(strlen(mail_alpha) + 1)) != NULL )
                {
                    strcpy(name, mail_alpha);
                    return strlen(name);
                }
            }
        }
    }
}

/*******************************************************************************

 $Function:    	SmsRead_R_TEXTEDT2_editor_cb

 $Description:  Callback function for the  text editor.
             
 $Returns:		void
 
 $Arguments:	win - current window.
                Identifier - unique id
                Reason - event id
*******************************************************************************/

void SmsRead_R_TEXTEDT2_editor_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{

    T_MFW_WIN           * win_data = ((T_MFW_HDR *) win)->data;
    T_SMSREAD_R_TEXTEDT2 * data     = (T_SMSREAD_R_TEXTEDT2 *)win_data->user;

    TRACE_FUNCTION("SmsRead_R_TEXTEDT2_editor_cb");
    switch( Reason )
    {
    case INFO_KCD_LEFT:
    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
        SEND_EVENT (data->parent, E_RETURN, Identifier, NULL); /* forward event to parent */
        break;
    default:
        break;
    }
}
#endif
/*******************************************************************************

 $Function:    	smsRead_info_screen

 $Description:  Callback function for the  text editor.
             
 $Returns:		window handle
 
 $Arguments:	win - current window.
                TextId - text id
*******************************************************************************/

MfwHnd smsRead_info_screen(MfwHnd win,int TextId)
{
    T_DISPLAY_DATA DisplayInfo;
    T_MFW_HND        delete_win ;   
    dialog_info_init(&DisplayInfo);//gdy add
    DisplayInfo.RightSoftKey = 0;
    //DisplayInfo.LeftSoftKey = 0;
    DisplayInfo.Time         = 10000;
    //    DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
    DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_CLEAR|KEY_HUP;/* 2004/4/20, wangyan modify */
    DisplayInfo.TextId2       = TextId;
    DisplayInfo.TextId      = 0;
    DisplayInfo.Identifier   = NULL;
    DisplayInfo.Callback     = NULL;
    DisplayInfo.iconindex =REMIND_WAITTING;//REMIND_NORECORD;
    DisplayInfo.Callback=(T_VOID_FUNC)SmsRead_R_dialog_cb;
    delete_win=info_dialog(win, &DisplayInfo);

    return delete_win;
}

/*******************************************************************************

 $Function:     Sms_NVM_DEL_dialog_cb

 $Description:  Handler function for standard dialogs in smsmenu module

 $Returns:    Execution status

 $Arguments:    win - current window
        Identifier - unique id
        Reason- event id

*******************************************************************************/
int Sms_NVM_DEL_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT *data = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_HDR    * l_parent      =  parent_data->parent;
    T_DISPLAY_DATA DisplayInfo;

    TRACE_FUNCTION ("Sms_NVM_DEL_dialog_cb()");


    switch( Reason )
    {
    // User want to delete the SMS
    case INFO_KCD_LEFT:
        // Trigger the deletion
        if( sms_msg_delete((UBYTE)data->sms_editor_data->sms_index)== MFW_SMS_OK )
        {
            if( deleting_win == 0 )
            {
                dialog_info_init(&DisplayInfo);//gdy add
                DisplayInfo.RightSoftKey = TxtSoftBack;
                DisplayInfo.LeftSoftKey =0;
                DisplayInfo.Time         = FOREVER;
                DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
                DisplayInfo.TextId2      = TxtDeleted;
                DisplayInfo.iconindex    =REMIND_SUCCEED;
                DisplayInfo.Callback=(T_VOID_FUNC)SmsRead_R_dialog_cb;
                deleting_win=info_dialog(parent_data->parent, &DisplayInfo);
            }
            SmsRead_R_TEXTEDT2_destroy(parent_data->win);
            SmsRead_R_OPT_destroy(data->win);
        }
        else
        {
            dialog_info_init(&DisplayInfo);//gdy add
            DisplayInfo.RightSoftKey = 0;
            DisplayInfo.Time         = ONE_SECS;
            DisplayInfo.KeyEvents    = KEY_CLEAR|KEY_RIGHT;
            DisplayInfo.TextId2      = TxtTryAgain;
            DisplayInfo.iconindex    =REMIND_WAITTING;
            DisplayInfo.Callback=(T_VOID_FUNC)FLASH_Sms_DELETED_dialog_cb;
            info_dialog(data->win, &DisplayInfo);
        }
        break;

    case INFO_KCD_RIGHT:
    case INFO_KCD_HUP:
    case INFO_TIMEOUT:
        /* Destroy the owner of the dialog box */
        SmsRead_R_OPT_destroy(data->win);
        SmsRead_R_TEXTEDT2_destroy(parent_data->win);
        ModifyMenuList=0;
        SEND_EVENT (l_parent, E_RETURN, NULL, NULL);
        //SEND_EVENT (parent_data->win, E_BACK,NULL, NULL);
        break;

    default:
        return MFW_EVENT_REJECTED;
    }
    return MFW_EVENT_CONSUMED;
}
/*******************************************************************************

 $Function:    	FLASH_Sms_DELETED_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list 
                of all the SMS). Case where SMS has not been initialized yet.
            
 $Returns:		status

 $Arguments:	win - window handler.
                Identifier -  unique identifier.
                Reason - cause of event.
*******************************************************************************/

int FLASH_Sms_DELETED_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT *data = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_HDR    * l_parent      =  parent_data->parent;

    TRACE_FUNCTION ("SmsRead_dialog_cb()");

    switch( Reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_HUP:
        // Commit suicide
        // Send E_RETURN event to parent window
        /* Destroy the owner of the dialog box */
        SmsRead_R_OPT_destroy(data->win);
        ModifyMenuList=1;
        SEND_EVENT (parent_data->win, E_RETURN,NULL, NULL);
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}
/*******************************************************************************

 $Function:    	FLASH_Sms_DELETED_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list 
                of all the SMS). Case where SMS has not been initialized yet.
            
 $Returns:		status

 $Arguments:	win - window handler.
                Identifier -  unique identifier.
                Reason - cause of event.
*******************************************************************************/

int FLASH_Sms_REQUIRE_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT *data = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;
    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;
    T_MFW_HDR    * l_parent      =  parent_data->parent;
    T_DISPLAY_DATA DisplayInfo;

    TRACE_FUNCTION ("SmsRead_dialog_cb()");

    switch( Reason )
    {
    case INFO_TIMEOUT:
    case INFO_KCD_HUP:
        // Commit suicide
        // Send E_RETURN event to parent window
        dialog_info_init(&DisplayInfo);//gdy add
        DisplayInfo.TextId =   TxtDelThisMsg1;
        DisplayInfo.TextId2    =   TxtDelThisMsg2;
        DisplayInfo.Time         = FOREVER;
        DisplayInfo.KeyEvents    = KEY_RIGHT|KEY_LEFT|KEY_CLEAR;
        DisplayInfo.Identifier   = NULL;
        DisplayInfo.LeftSoftKey  = TxtSoftOK;
        DisplayInfo.RightSoftKey  = TxtSoftBack;
        DisplayInfo.iconindex   =REMIND_REQUIRE;
        DisplayInfo.Callback     = (T_VOID_FUNC)Sms_NVM_DEL_dialog_cb;
        (void) info_dialog(win, &DisplayInfo);
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}


/*******************************************************************************

 $Function:    	FLASH_Sms_DELETED_Dialog

 $Description:	Display a standard dialog with no soft key and 3 seconds of display
            
 $Returns:		none

 $Arguments:	win - window handler.
                text -  text string.
                duration - seconds
*******************************************************************************/

void FLASH_Sms_DELETED_Dialog(T_MFW_HND win,  int TextId, ULONG duration)
{
    T_DISPLAY_DATA DisplayInfo;

    dialog_info_init(&DisplayInfo);//gdy add
    SmsMenu_loadDialogDefault(&DisplayInfo);

    DisplayInfo.TextId2 = TextId;
    DisplayInfo.Time = duration;
    DisplayInfo.iconindex =REMIND_SUCCEED;
    DisplayInfo.Callback = (T_VOID_FUNC)FLASH_Sms_REQUIRE_dialog_cb; //TBD

    info_dialog(win, &DisplayInfo);
}
/*******************************************************************************

 $Function:    	FlashSMS_DEL_OPT_dialog_cb

 $Description:	Dialog callback function of the SMS read window (dynamic list 
                of all the SMS). Case where SMS has not been initialized yet.
            
 $Returns:		status

 $Arguments:	win - window handler.
                Identifier -  unique identifier.
                Reason - cause of event.
*******************************************************************************/

int FlashSMS_DEL_OPT_dialog_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_OPT *data = (T_SMSREAD_R_OPT *)win_data->user;
    T_MFW_HND *lparent = data->parent;

    TRACE_FUNCTION ("SmsRead_dialog_cb()");

    switch( Reason )
    {
    case INFO_TIMEOUT:
        FLASH_Sms_DELETED_Dialog(data->win, TxtDone,ONE_SECS); // TBD remplacer par ID
        return MFW_EVENT_CONSUMED;

    default:
        return MFW_EVENT_REJECTED;
    }
}

/*******************************************************************************

 $Function:    	Flash_sms_delete_screen

 $Description:  Callback function for the  text editor.
             
 $Returns:		window handle
 
 $Arguments:	win - current window.
                TextId - text id
*******************************************************************************/

void Flash_sms_delete_screen(MfwHnd win,int TextId, ULONG duration)

{
    T_DISPLAY_DATA DisplayInfo;
    T_MFW_HND        delwin = 0;

    dialog_info_init(&DisplayInfo);//gdy add
    SmsMenu_loadDialogDefault(&DisplayInfo);

    DisplayInfo.TextId2= TextId;
    DisplayInfo.Time = duration;
    DisplayInfo.iconindex=REMIND_COPYING;
    DisplayInfo.Callback = (T_VOID_FUNC)FlashSMS_DEL_OPT_dialog_cb; //TBD

    delwin= info_dialog(win, &DisplayInfo);
    //mmi_dialogs_insert_fixmov_animation(delwin, 200 ,WAITING,8);//xsf add network search animation    
}

/*******************************************************************************

 $Function:    	SmsRead_FindNextNumber_cb

 $Description:	Exec callback function for searching the SMS text message.
 
 $Returns:		none

 $Arguments:	win - window handler
                event - mfw event
                value -optional id
                parameter - optional data.
 
*******************************************************************************/
void SmsRead_FindNextNumber_cb(T_MFW_HND win, USHORT Identifier, USHORT Reason)
{
    T_MFW_WIN *win_data = ((T_MFW_HDR *)win)->data;
    T_SMSREAD_R_TEXTEDT2 *data = (T_SMSREAD_R_TEXTEDT2 *)win_data->user;
    T_MFW_HDR    * parent      =  data->parent;

    T_MFW_WIN    * win_data2   =  ((T_MFW_HDR *)parent)->data;
    T_SMSREAD_R_TEXTEDT2  * parent_data =  (T_SMSREAD_R_TEXTEDT2 *)win_data2->user;

    T_MFW_PHB_ENTRY  pb_data;


    TRACE_FUNCTION(" SmsRead_FindNextNumber_cb() ");

    switch( Reason )
    {
    case INFO_KCD_RIGHT:
    case INFO_KCD_CLEAR:

        break;
    case INFO_KCD_LEFT:

        // Check for numbers in SMS text, check for '+' .

        if( Search_forNextNumber(&SmsData) )
        {

            if( bookFindNameInPhonebook((const char*)&SmsData.NumberBuffer[0], &pb_data) !=0 )
            {
                //Display the tag and number dialog.
#ifdef NO_ASCIIZ							
                smsRead_NumberName_info_screen(parent_data->parent,(void *)&SmsData, (char*)pb_data.name.data);
#else
                smsRead_NumberName_info_screen(parent_data->parent,(void *)&SmsData, (char*)pb_data.name);
#endif
            }
            else
            {
                smsRead_NumberName_info_screen(parent_data->parent,(void *)&SmsData,NULL);
            }           
        }
        break;
    case INFO_KCD_OFFHOOK:
        callNumber(SmsData.NumberBuffer); 
        break;

    default:
        TRACE_EVENT(" >>> INFO Default   ");
        //return MFW_EVENT_REJECTED;
        break;
    }

}

/*******************************************************************************

 $Function:    	smsRead_NumberName_info_screen

 $Description:    Display the number and name of numbers found in the received SMS text.
             
 $Returns:		window handle
 
 $Arguments:	win - current window.
                UserData - Sms data info
*******************************************************************************/

static MfwHnd smsRead_NumberName_info_screen(MfwHnd win,T_SmsUserData *UserData, char* nameTag)
{

    T_DISPLAY_DATA DisplayInfo;


    TRACE_FUNCTION("smsRead_NumberName_info_screen() ");
    dialog_info_init(&DisplayInfo);//gdy add
    if( nameTag != NULL )
        DisplayInfo.TextString   = nameTag;
    else
        DisplayInfo.TextString   = '\0';

    DisplayInfo.TextString2  = (char*)UserData->NumberBuffer;
    DisplayInfo.LeftSoftKey  = TxtSoftNext;
    DisplayInfo.RightSoftKey = TxtSoftBack;
    DisplayInfo.Time         = FOREVER;
    DisplayInfo.KeyEvents    = KEY_ALL;
    DisplayInfo.TextId       = 0;
    DisplayInfo.TextId2      = 0;
    DisplayInfo.Identifier     = NULL;
    DisplayInfo.Callback     = (T_VOID_FUNC)SmsRead_FindNextNumber_cb;

    TRACE_EVENT(">>>>> Display Information Screen ");
    return info_dialog(win, &DisplayInfo);

}

/*******************************************************************************

 $Function:    	Search_forNextNumber

 $Description:    Search through the SMS text and find a telephone number, the number 
                may start with the '+' prefix.
             
 $Returns:		Boolean
 
 $Arguments:	UserData - SMS data info
*******************************************************************************/
static BOOL Search_forNextNumber(T_SmsUserData *UserData)
{
    int sms_length;
    int index=0;
    char *smsTextChar;
    char telNumberBuffer[NUMBER_LENGTH];

    TRACE_FUNCTION(">>> Search_forNextNumber() ");

    sms_length = strlen((char*)UserData->TextBuffer);
    smsTextChar = (char*)UserData->TextBuffer;

    memset (telNumberBuffer, '\0', NUMBER_LENGTH);

    while( sms_length > 0 )
    {

        if( (*smsTextChar >= '0' && *smsTextChar  <= '9') || (*smsTextChar  == '+') )
        {
            // A number has been found start to copy number into buffer
            telNumberBuffer[index++] = *smsTextChar;
        }
        smsTextChar++;
        sms_length--;
    }

    if( strlen(telNumberBuffer) > 10 )
    {
        strcpy((char*)UserData->NumberBuffer, telNumberBuffer);
        return TRUE;
    }

    return FALSE;

}   

//glowing,2004-07-02, import from mfw/ATBCommon.c
#ifndef _M188_
/*******************************************************************************

 $Function:		ATB_char_GSM

 $Description:	Returns the GSM of the provided ascii character.Added for SPR 2175.

 $Returns:		A GSM character

 $Arguments:	character - The ascii character

*******************************************************************************/

char ATB_char_GSM(char ascii_character)
{	int i;
	/*check if GSM and ASCII encoding are the same value*/
	if (g_translation_ascii_table[ascii_character] == ascii_character)
		return ascii_character;
	
	/*otherwise we have to search for the correct entry in the GSM to ASCII table*/
	for (i=0; i<128; i++)
	{
		if (g_translation_ascii_table[i] == ascii_character)
			return i;

	}
}
#endif



#undef MMI_SMSREAD_C
