/*******************************************************************************

					CONDAT (UK)

********************************************************************************                                                                              

 This software product is the property of Condat (UK) Ltd and may not be
 disclosed to any third party without the express permission of the owner.                                 
																			  
********************************************************************************

 $Project name:                                                   
 $Project code:	                                                           
 $Module:		
 $File:		    AUIWap.c
 $Revision:		                                                      
																			  
 $Author:		Condat(UK)                                                         
 $Date:		                                                          
																			   
********************************************************************************
																			  
 Description:
	The user interface for WAP.  Provides the required menus, lists, dialogs and
	utilises the functionality of the ATB appropriately.
						
********************************************************************************

 $History: AUIWap.c

	
	   
 $End

*******************************************************************************/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#if defined (NEW_FRAME)

	#include "typedefs.h"
	#include "vsi.h"
	#include "pei.h"
	#include "custom.h"
	#include "gsm.h"

#else  /* NEW_FRAME */

	#include "stddefs.h"
	#include "custom.h"
	#include "gsm.h"
	#include "vsi.h"

#endif /* NEW_FRAME */

#include "Mfw_sys.h"

#include "mfw_mfw.h"
#include "mfw_win.h"
#include "mfw_kbd.h"
#include "mfw_edt.h"
#include "mfw_tim.h"
#include "mfw_phb.h"
#include "mfw_sms.h"
#include "mfw_icn.h"
#include "mfw_mnu.h"
#include "mfw_lng.h"
#include "mfw_sat.h"
#include "mfw_kbd.h"
#include "mfw_nm.h"
//GW Removed T9 references
#include "Mfw_cm.h"

#include "dspl.h"

#include "MmiMmi.h"
#include "MmiMain.h"
#include "MmiDummy.h"
#include "MmiDialogs.h"
#include "MmiLists.h"
#include "MmiCall.h"

#include "MmiMenu.h"
#include "MmiSoftKeys.h"
#include "MmiResources.h"

#include "MmiBlkLangDB.h"
#include "MmiBookUtils.h"
#include "MmiEditor.h"
#include "MmiEditor_i.h"
#include "MmiBookshared.h"
#include "ATBData.h"
#include "wap_types.h"
#include "ATBWapAUI.h"
#include "mmiSmsMenu.h"
#include "Mmismssend.h"
#include "AUIWap.h"
/* SPR#1574 - SH */
#ifdef MMI_GPRS_ENABLED
	#include "MmiGprs.h"
#endif

#include "cus_aci.h"
#include "p_sim.h"
#include "pcm.h"
#include "mmiusersymbolinput.h"      //zhaowm 2002.11.28
#include "MmiWapFfs.h"                  //zhaowm 2002.12.09
#include "MmiIcons.h"  //zhaowm
#include "mmitextinput.h"	/* 2004/04/28 sunsj add */
#include "listicn.h"

// wyj
//#define TRACE_AUIWAP
//#define	TRACE_FUNCTION MI_dbgPrintf_

#ifdef MMS_WAP_ENABLED
#include "MMSAgent.h"
#include "wap_interface.h"
#include "mmimmsffs.h"
#endif

#define TRACE_AUIWAP
#define WAP_TRACE 1
#include "mmiutilapi.h"
#define TRACE_EVENT(f) WAP_TRACE_EVENT(("hyl,Auiwap.c,%s",f));
#define TRACE_FUNCTION(f) TRACE_EVENT(f);

#undef TRACE_MEMALLOC					// Define this to trace memory allocations & freeings

#define ALLOC_MEMORY mfwAlloc
#define FREE_MEMORY  mfwFree
#define PIN_MAX_LEN	8					// Max no of characters to enter for a PIN

// Events

#define WAP_INIT 200					// initialise WAP browser
#define WAP_SHOW_CARD	 201			// display the WAP card

// Size of options menu

/* 2004/05/28 sunsj modify */
/*talcon add for M288*/
#if (MAIN_LCD_SIZE==4)/*128x160*/
#define WAP_MENU_LEFT 0
#define WAP_MENU_RIGHT 128        
#define WAP_MENU_TOP 0
#define WAP_MENU_BOTTOM 144        

// Size of editor screen
#define WAP_EDITOR_LEFT 4           
#define WAP_EDITOR_RIGHT 124
#define WAP_EDITOR_TOP 18
#define WAP_EDITOR_BOTTOM 124
#elif (MAIN_LCD_SIZE==3)/*128x128*/
#define WAP_MENU_LEFT 0
#define WAP_MENU_RIGHT 128        
#define WAP_MENU_TOP 0
#define WAP_MENU_BOTTOM 110

// Size of editor screen
#define WAP_EDITOR_LEFT 4           
#define WAP_EDITOR_RIGHT 124
#define WAP_EDITOR_TOP 18
#define WAP_EDITOR_BOTTOM 124
#endif


/* Edit modes
 *
 * Specify what to do after editing a URL.
 */

enum
{
	WAP_GOTO_URL,
	WAP_ADD_BOOKMARK,
	WAP_ADD_BOOKMARK_NAME,
	WAP_EDIT_BOOKMARK,
	WAP_EDIT_BOOKMARK_URL,
	WAP_EDIT_HISTORY,
	WAP_EDIT_HISTORY_URL,
	WAP_EDIT_HOMEPAGE,
	//WAP_DIALOGE_ID,
	WAP_EDIT_APN
};


/* Delete modes
 *
 * Specify what to do after delete confirmation screen.
 */

enum
{
	WAP_DELETE_BOOKMARK,
	WAP_DELETE_HISTORY,
	WAP_CLEAR_HISTORY
};

/* Number edit modes
 *
 * Specify what to do after a numeric edit screen
 */

enum
{
	WAP_DIALUP_NUMBER,
	WAP_IP_ADDRESS1,
	WAP_IP_ADDRESS2,
	WAP_PORT1,
	WAP_PORT2,
	WAP_RESPONSE_TIMER

};


/* Options menu items
 *
 * These are the menu items in the options menu.
 */

enum
{
	WAP_ADDBOOKMARK,
	WAP_BOOKMARKS,
	WAP_GOTO,
	WAP_HOMEPAGE,
	WAP_BACK,
	WAP_RELOAD,
	WAP_EXIT,

	MAX_OPTIONS					// Always have this at the end of the list
};

/* Options menu items
 *
 * These are the menu items in the options menu.
 */

enum
{
	WAP_SELECT,
	WAP_CustSoftKey,

	MAX__CUST_OPTIONS					// Always have this at the end of the list
};

/* T_WAP_BROWSER
 *
 * This structure holds all information about the wap browser window.
 */

typedef struct
{
	T_MMI_CONTROL       mmi_control;
	T_MFW_HND           parent_win;
	T_MFW_HND           win;
	T_MFW_HND           kbd;
	T_MFW_HND           kbd_long;

	USHORT              TextId1;					// The first text string...
	USHORT              TextId2;					// ..and the second
	char                *TextString1;				// The first line of plain text...
	char                *TextString2;				// ...and the second line.
} T_WAP_BROWSER;


/* T_WAP_DATA
 *
 * All data for WAP can be accessed through this structure.
 */

typedef struct
{
	T_MMI_CONTROL       mmi_control;
	T_MFW_HND           parent_win;
	T_MFW_HND           win;						// The WAP data window (sits behind all other windows)
	T_MFW_HND           edit_win;					// ...input window
	T_MFW_HND           options_win;				// ...options window
	T_MFW_HND           menu_win;					// ...main WAP menu window
	T_MFW_HND           browser_win;				// The browser window
	T_MFW_HND           list_win;					// List window (bookmarks etc)
	ListMenuData        *list_data;					// ...and its list data
	T_MFW_HND           optionsmenu_win;			// The options menu window, accessible from browser
	ListMenuData        *optionsmenu_data;			// ...and its list data
	T_WAP_LIST          *OptionsList;				// The list of options menu items
	T_MFW_HND           temp_win;					// Temporary window pointer storage
	T_MFW_HND           connect_win;				// The "connecting" dialog window
	T_MFW_HND           error_win;					/* SPR#1739 - SH - Error dialog */

	T_MFW_HND           main_kbd;               

	char                *Buffer;					// Buffer for text input
	char                *Buffer2;					// Second buffer for dual input dialogs
	char                *Format;					// Input format string
	char                *Message;					// Buffer for text output
	char                *LeftSoftKey;				// Text for custom left soft key
	char                *RightSoftKey;				// Text for custom right soft key
	char                *URLSelect;					// The current URL that is selected in a list menu
	UBYTE               OptionSelect;				// The number of the selected URL

	T_WAP_VIEW          *View;						// Pointer to current view
	BOOL                connected;					// Are we connected?

	void                *gen_pointer;				// Pointer to  generic data
	BOOL                update_forbid;				// If TRUE, forbids update to the WAP browser window
	T_MFW_HND           timer;						/* SPR#1569 - SH - Mfw timer */
	T_MFW_HND           other_menu_win;				// wyj WAP menu window
#ifdef MMS_WAP_ENABLED
	T_MMS_WAP_DATA *mmsdata;
#endif
} T_WAP_DATA;


/* List menu attributes
 *
 * Needed for creating the menu.
 */

static MfwRect list_menuArea =                  // menus display area
{
	WAP_MENU_LEFT, WAP_MENU_TOP, WAP_MENU_RIGHT, WAP_MENU_BOTTOM
};

static MfwMnuAttr list_menuAttrib =
{
	0,
	&list_menuArea,
	MNU_LEFT | MNU_LIST | MNU_CUR_LINE,				// centered page menu
	-1,												// use default font
	NULL,											// with these items
	0												// number of items
};

/*
	Local Handler the wap window (At the moment only one instance possible in BMI
*/

MfwHnd wap_main_window = 0;
int text_input_flag = 0;

/* Prototypes for functions */

T_MFW_HND           AUI_please_wait(T_MFW_HND parent_win);	/* SPR#1569 - SH - Added this function */
void                AUI_please_wait_cb(T_MFW_HND win, USHORT identifier, SHORT reason);	/* SPR#1569 - SH - Added this function */
static void         AUI_menu_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
int                 AUI_homepage(MfwMnu* menu, MfwMnuItem* item);
int                 AUI_wap_startup_begin(MfwEvt evt, MfwTim timer); /* SPR#1569 - SH - Added this function */
void                AUI_destroy (T_MFW_HND own_window, USHORT windows);
static int          AUI_cb (T_MFW_EVENT event, T_MFW_WIN * win);
static int          AUI_main_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
void                AUI_control (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
//T_MFW_HND			AUI_connecting_dialog (T_MFW_HND win, ULONG status);
static int          AUI_connecting_dialog (T_MFW_HND win, ULONG status);
void                AUI_connecting_dialog_cb (T_MFW_HND win, UBYTE identifier, UBYTE reason);
//void				AUI_connect_URL (T_MFW_HND win, char *URL);
T_MFW_HND           AUI_win_create (T_MFW_HND parent_win);
int                 AUI_win_destroy (T_MFW_HND win);
static int          AUI_win_cb (T_MFW_EVENT event, T_MFW_WIN * win);
void                AUI_win_control (T_MFW_HND win, USHORT event, SHORT value, void * parameter);
static int          AUI_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard);
static int          AUI_kbd_long_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard);
int                 AUI_edit(char *shortcut, USHORT identifier, int prompt, USHORT maxlen);
static T_MFW_HND    AUI_edit_create(MfwHnd parent_win, USHORT identifier, int prompt, USHORT maxlen);
static void         AUI_edit_cb(T_MFW_HND win, USHORT identifier, USHORT reason);
static void         AUI_bookmarks_list_cb(T_MFW_HND win, ListMenuData *EntryListData);
static void         AUI_history_list_cb(T_MFW_HND parent_win, ListMenuData *EntryListData);
static void         AUI_profiles_list_cb(T_MFW_HND parent_win, ListMenuData *EntryListData);
static void         AUI_profiles_setup_cb(T_MFW_HND win, ListMenuData *EntryListData);
static int          AUI_entry_list (T_MFW_HND win, T_WAP_LIST *EntryList, ListCbFunc Callback, UBYTE pos,int prompt);
static ListMenuData*   AUI_entry_list_create (T_MFW_HND win, T_WAP_LIST *EntryList, ListCbFunc Callback, UBYTE pos,int prompt);
int                 AUI_entry_goto(WAP_LIST_TYPE identifier);
int                 AUI_entry_delete(UBYTE identifier);
void                AUI_entry_delete_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
int                 AUI_entry_sendSMS(void);
static void         AUI_profile_name_edit_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
static void         AUI_username_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
static void         AUI_password_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
int                 AUI_number_edit(T_MFW_HND parent_win, int identifier, int prompt);
static void         AUI_number_edit_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
static void         AUI_error_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void         AUI_info_dialog(T_MFW_HND win, USHORT TxtId1, USHORT TxtId2);
static void         AUI_standard_editor(T_EDITOR_DATA *editor_data, char *buffer, U16 size, UBYTE mode, T_EDIT_CB callback);
static void         AUI_input_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void         AUI_password_cb_1(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void         AUI_password_cb_2(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void         AUI_confirm_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void         AUI_info_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason);
static void         AUI_options_menu_cb(T_MFW_HND win, ListMenuData *EntryListData);
static void         AUI_CustSoftKey_menu_cb(T_MFW_HND win, ListMenuData *EntryListData);
static void         AUI_goto_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason);
static void         info_screen (T_MFW_HND win, USHORT TextId, USHORT TextId2, T_VOID_FUNC  Callback);

T_MFW_HND          AUI_Exit_Inquire_dialog (T_MFW_HND win);
void                AUI_Exit_Inquire_Dialog_cb (T_MFW_HND win, UBYTE identifier, UBYTE reason);
static BOOL wap_callActive = FALSE;
int WapTitle=0;//zhaowm 2002.12.08 add for wap menu title
int optiongoback=0;	 //zhaowm 2002.12.08 add for going back to the browser.
extern int IsGprsSupported(void);	//zhaowm 2003.1.14 to check whether GPRS is supported in current cell. 
int URlconnect=0;//zhaowm 2003.2.14 add for enter internet by one step ,1--enter internet by one step,0--enter wap menu

/* Set up variables and functions for tracing purposes */
#ifdef TRACE_MEMALLOC
U16 memUsed = 0;
UBYTE memTracker[110] = {0};
#endif

static char test_string[40];

int check_memory()
{
	sprintf(test_string, "Memory left: %d", mfwCheckMemoryLeft());
	TRACE_EVENT(test_string);
	return;
}



static void info_screen (T_MFW_HND win, USHORT TextId, USHORT TextId2, T_VOID_FUNC  Callback)
/* present info <TextId> for 3 seconds in a simple infoscreen */
{
	T_DISPLAY_DATA display_info;

	TRACE_FUNCTION ("info_screen()");

/*	dlg_initDisplayData_TextId( &display_info, TxtNull, TxtNull, TextId,  TextId2 );
	dlg_initDisplayData_events( &display_info, (T_VOID_FUNC)Callback, THREE_SECS, 0 );*/
	dialog_info_init(&display_info);
	display_info.TextId         = TextId;
	display_info.TextId2        = TextId2;
	display_info.Callback       = (T_VOID_FUNC)Callback;
	display_info.Time           = THREE_SECS;
	display_info.KeyEvents      = 0;
	display_info.iconindex=REMIND_COMPLETE;
	display_info.Identifier   = 0;/*2003/12/13, wangyan modify*/

	info_dialog (win, &display_info); 
}

/*******************************************************************************

 $Function:    	AUI_menu

 $Description:	The main WAP menu
 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_menu(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND	win;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_menu");
#endif

	win = AUI_create(mfwParent( mfw_header()));

	if (!win)
	{
		TRACE_EVENT("ERROR - Wap Already Open");
	}
	
	check_memory();

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_please_wait

 $Description:	Creates a "Please Wait" message that will hang around until WAP has
				been started

 $Returns:		Window handle of the created window

 $Arguments:	parent_win - the parent window
 
*******************************************************************************/

T_MFW_HND AUI_please_wait(T_MFW_HND parent_win)
{
	T_DISPLAY_DATA display_info;

	TRACE_FUNCTION("AUI_please_wait()");

/*	dlg_initDisplayData_TextId( &display_info, TxtNull, TxtNull,TxtNull , TxtPleaseWait);
	dlg_initDisplayData_events( &display_info, (T_VOID_FUNC)AUI_please_wait_cb, 2000, 0 );*//*2003/12/13, wangyan modify*/
	//dlg_initDisplayData_events( &display_info, (T_VOID_FUNC)AUI_please_wait_cb, 10000, 0 );
	dialog_info_init(&display_info);
	display_info.RightSoftKey	= TxtNull;	/* 2004/05/28 sunsj modify */
	display_info.TextId2        = TxtPleaseWait;
	display_info.Callback       = (T_VOID_FUNC)AUI_please_wait_cb;
	display_info.Time           = 2000;
	display_info.KeyEvents=0;
	display_info.iconindex=REMIND_WAITTING;

	return info_dialog(parent_win,&display_info); //information screen
}

/* SPR#1569 - SH - Added this function */

void AUI_please_wait_cb(T_MFW_HND win, USHORT identifier, SHORT reason)
{
	T_MFW_WIN     * win_data  = ((T_MFW_HDR *)win)->data;
	T_MMI_CONTROL * control  = (T_MMI_CONTROL *)win_data->user;


	TRACE_FUNCTION("AUI_please_wait_cb()");

	switch (reason)
	{
	case INFO_TIMEOUT:
		if (control->dialog NEQ 0)
			SEND_EVENT(win, DIALOG_DESTROY, NULL, NULL);
		info_screen(NULL, TxtTimedOut, TxtNull, NULL);
		break;

	}
}


/*******************************************************************************

 $Function:    	AUI_wap_start_done

 $Description:	SPR#1569 - SH - Added this function
				WAP has started - can create new view
 
 $Returns:		None

 $Arguments:	None.
 
*******************************************************************************/

void AUI_wap_start_done(void)
{
	T_MFW_HND win           = wap_main_window;
	T_MFW_WIN *win_data     = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA *data        = (T_WAP_DATA *)win_data->user;								// WAP data
	T_MMI_WAP_NEW_VIEW_IND  wap_view;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_start_done");
	TRACE_EVENT_P1("Data: %d", data);
#endif

	wap_view.object_id      = 1;
	wap_view.uaMode         = 1;												// Specifies WML user agent
	wap_view.view_width     = WAP_SCREEN_WIDTH;									// Width of screen for browser
	wap_view.view_height    = WAP_SCREEN_HEIGHT;								// Height of screen for browser
	wap_view.font_height    = WAP_CHAR_HEIGHT;
	wap_view.unicode_height = WAP_CHAR_HEIGHT;
	wap_view.unicode_width  = WAP_CHAR_WIDTH*2;

	/* Get height and widths of all characters in current font */

	wap_view.font_width_length = 256;
	wap_view.font_width = (UBYTE *)AUI_wap_memory_alloc(256*sizeof(UBYTE));
	//font_getAllAsciiWidths(wap_view.font_width);
	memset(wap_view.font_width,8,256*sizeof(UBYTE));//zhaowm temp

	data->View = ATB_wap_new_view(&wap_view, (void *)data);	// Create the view

	AUI_wap_memory_free(wap_view.font_width, 256*sizeof(UBYTE));

	data->connected = FALSE;													// We're not connected yet

	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_new_view_done

 $Description:	SPR#1569 - SH - Added this function
				View has started - can create menu
 
 $Returns:		None

 $Arguments:	None.
 
*******************************************************************************/

void AUI_wap_new_view_done(void)
{
	T_MFW_HND win           = wap_main_window;
	T_MFW_WIN *win_data     = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA *data        = (T_WAP_DATA *)win_data->user;								// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_startup_done");
#endif

	if (data!=NULL)
	{
		SEND_EVENT(data->win,WAP_INIT,0,0);											// Initialise window

		if (data->temp_win)
		{
			SEND_EVENT(data->temp_win, DIALOG_DESTROY, NULL, NULL);
			data->temp_win = NULL;
		}

		if (URlconnect)			  //zhaowm 2003.0217 for entering internet by one step
		{
			URlconnect = 0;
			AUI_connect_URL(win, data->View->Profile->Homepage);						// Connect & attempt to download homepage
		}
		else
		{
			WapTitle = TxtWAP;	 //zhaowm 2002.12.08  
			data->menu_win = bookMenuStart(win, WAPMenuAttributes(), PhbkWap);				 // Create WAP Menu
			SEND_EVENT(data->menu_win, ADD_CALLBACK, NULL, (void *)AUI_menu_cb);	 // Add our own callback
		} 
	}

	return;
}

/*******************************************************************************

 $Function:    	AUI_menu_cb

 $Description:	Callback function for the WAP menu
 
 $Returns:		

 $Arguments:	parent_win 	- the WAP data window
				identifier 	- unused
				reason		- unused
 
*******************************************************************************/

static void AUI_menu_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN       *win_data;       //= ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA      *data;           //= (T_WAP_DATA *)win_data->user;				// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_menu_cb");
#endif
	TRACE_EVENT("AUI_menu_cb");

	if(parent_win)
		win_data    = ((T_MFW_HDR *)parent_win)->data;

	if(win_data)
		data      = (T_WAP_DATA *)win_data->user;
	
	if(data->win)
	AUI_destroy(data->win, WAP_WIN);


	return;


}


/*******************************************************************************

 $Function:    	AUI_homepage

 $Description:	Enter WAP browser with URL=homepage URL
 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_homepage(MfwMnu* menu, MfwMnuItem* item)
{   
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// parent_win = WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// This is the WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_homepage");
#endif

	if (win==NULL)
		return NULL;

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

/*
	if ((data->View->Profile->AccessType == WAP_GPRS_DATA)&&(IsGprsSupported() == 0))       //zhaowm 2003.1.14
	   {
		AUI_info_dialog(data->win, TxtnoGPRSservice, NULL);												// Display "Changed" message
		return NULL;
		}

 */       
	AUI_connect_URL(win, data->View->Profile->Homepage);						// Connect & attempt to download homepage

	return MFW_EVENT_CONSUMED;
}


//zhaowm 2002.12.28 add for entering the wap browser by one-step.
int  AUI_homepageStart(T_MFW_HND parent_win)
{

	T_MFW_HND   win         = AUI_create(parent_win);							// create WAP data window
	//T_WAP_DATA	*data;
	//T_MFW_WIN		*win_data ; 

	//if (win==NULL)
	//	return NULL;
	URlconnect = 1;	 //zhaowm 2003.02.14 


	//win_data		= ((T_MFW_HDR *)win)->data;
	//data			= (T_WAP_DATA *)win_data->user;								// WAP data

/*
	if ((data->View->Profile->AccessType == WAP_GPRS_DATA)&&(IsGprsSupported()== 0))       //zhaowm 2003.1.14
	   {
		AUI_info_dialog(data->win, TxtnoGPRSservice, NULL);	
		AUI_destroy(data->win, ALL_WIN);
		return NULL;
		}

 */

/*
	if (data!=NULL)
	{
		SEND_EVENT(data->win,WAP_INIT,0,0);											// Initialise window
		if (data->temp_win)
		{
			SEND_EVENT(data->temp_win, DIALOG_DESTROY, NULL, NULL);
			data->temp_win = NULL;
		}

		AUI_connect_URL(win, data->View->Profile->Homepage);						// Connect & attempt to download homepage
	}
*/  

	//AUI_connect_URL(win, data->View->Profile->Homepage);						// Connect & attempt to download homepage
	return MFW_EVENT_CONSUMED;


}

/*******************************************************************************

 $Function:    	AUI_create

 $Description:	Creates a window (never shown) to which is attached all the data that
				is used in WAP.  This is distinct from the WAP card browser window,
				which is created dynamically.
				SPR#1569 - SH - Some of the functionality moved to different functions
 
 $Returns:		Pointer to the new window

 $Arguments:	parent win	- pointer to the parent window of the data window
 
*******************************************************************************/

T_MFW_HND AUI_create (T_MFW_HND parent_win)
{
	T_MFW_WIN               *win_data;
	T_WAP_DATA              *data       = (T_WAP_DATA *)AUI_wap_memory_alloc (sizeof (T_WAP_DATA));		// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_create");
#endif

	if (wap_main_window) /*One instance of WAP already activated*/
	{
		AUI_wap_memory_free((UBYTE *)data, sizeof (T_WAP_DATA));
		return NULL;
	}

	// Create the WAP data window

	data->update_forbid = FALSE;
	data->win = win_create (parent_win, 0, E_WIN_VISIBLE, (T_MFW_CB)AUI_cb);	// Create invisible window, to which data is attached
	if (data->win==NULL)
	{
		AUI_wap_memory_free((UBYTE *)data, sizeof (T_WAP_DATA));
		return NULL;
	}



	// Create window handler
	wap_main_window = data->win;
	data->main_kbd      = kbd_create (data->win, KEY_ALL, (T_MFW_CB)AUI_main_kbd_cb);

	data->mmi_control.dialog    = (T_DIALOG_FUNC)AUI_control;
	data->mmi_control.data      = (void *)data;
	data->parent_win            = parent_win;
	win_data                    = ((T_MFW_HDR *)data->win)->data;
	win_data->user              = (void *)data;									// Attach data to window

	// Reset various window pointers

	data->edit_win      = NULL;
	data->options_win   = NULL;
	data->list_win      = NULL;
	data->menu_win      = NULL;													// Indicate none of these windows exist yet
	data->other_menu_win= NULL;	//wyj
	data->browser_win   = NULL;
	data->list_data     = NULL;
	data->connect_win   = NULL;
	data->error_win     = NULL;		/* SPR#1739 - SH */

	//	Allocate memory for some strings

	data->Buffer        = (char *)AUI_wap_memory_alloc ((INPUT_MAX_LEN+1)*sizeof(char));	// Input buffer 1
	data->Buffer2       = (char *)AUI_wap_memory_alloc ((INPUT_MAX_LEN+1)*sizeof(char));	// Input buffer 2
	data->Format        = (char *)AUI_wap_memory_alloc ((INPUT_MAX_LEN+1)*sizeof(char));	// Input format string
	data->Message       = (char *)AUI_wap_memory_alloc ((URL_MAX_LEN+1)*sizeof(char));		// Message buffer (URL generally longest string we'll use)
	data->LeftSoftKey   = (char *)AUI_wap_memory_alloc ((SOFTKEY_MAX_LEN+1)*sizeof(char));	// Left softkey text
	//data->RightSoftKey	= (char *)AUI_wap_memory_alloc ((SOFTKEY_MAX_LEN+1)*sizeof(char));	// Right softkey text
	data->RightSoftKey  = (char *)AUI_wap_memory_alloc (((SOFTKEY_MAX_LEN)*2+3)*sizeof(char));	// Right softkey text

	// Create list for options menu

	data->OptionsList   = ATB_wap_entry_list_create(WAP_OPTIONS_LIST, MAX_OPTIONS+1, OPTIONS_MAX_LEN);	// Options menu list

	/* SPR#1569 - SH - Generate "Please wait" window while WAP starts up */

	data->temp_win = AUI_please_wait(data->win);

	data->timer = timCreate(data->win, ONE_SECS, (MfwCb)AUI_wap_startup_begin);
	timStart(data->timer);

	return data->win;

}

/* SPR#1569 - SH - Added this function */

int AUI_wap_startup_begin(MfwEvt evt, MfwTim timer)
{
	T_MFW_HND win           = wap_main_window;
	T_MFW_WIN *win_data     = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA *data        = (T_WAP_DATA *)win_data->user;								// WAP data
	T_MMI_WAP_START_IND     wap_start;											// dummy parameter for the wap start event

	// Create Profile (read in bookmarks, history etc).

	timDelete(data->timer);
	data->timer = NULL;
	ATB_wap_start(&wap_start);													// wap_start is just a dummy parameter

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_destroy

 $Description:	Destroys the specified WAP windows and their data
 
 $Returns:		void

 $Arguments:	win			- pointer to the browser window
				windows		- determines which windows will be destroyed.
				(e.g. LIST_WIN | EDIT_WIN | OPTIONS_WIN | WAP_WIN)
 
*******************************************************************************/

void AUI_destroy (T_MFW_HND win, USHORT windows)
{
	T_MFW_WIN           *win_data  = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA          *data = (T_WAP_DATA *)win_data->user;					// WAP data
	USHORT              entryIndex;


#ifdef TRACE_AUIWAP
	UBYTE   trackIndex;
	TRACE_FUNCTION("AUI_destroy");
#endif

	WAP_TRACE_EVENT(("hyl,AUI_destroy,%d",windows));

	if (data==NULL)
		return;

	if ((windows & BROWSER_WIN) && (data->browser_win != NULL))					// Destroy WAP browser window
	{
#ifdef TRACE_AUIWAP
		TRACE_FUNCTION("AUI_destroy browser");
#endif
		/* Cancel any pending operation */

		ATB_wap_stop_download(data->View);

		/* SPR#1739 - SH - Destroy the error dialog if it exists */

		if (data->error_win)
		{
			SEND_EVENT(data->error_win, DIALOG_DESTROY, 0, 0);
			data->error_win = NULL;
		}
		/* Destroy the browser */
		AUI_win_destroy(data->browser_win);
		data->browser_win = NULL;

		/* SPR#1189 - SH - Connecting window is now explicitly destroyed, see below */

		/* We're now no longer connected */

		data->connected = FALSE;
	}
	/* SPR#1189 - SH - Can destroy connect window explicitly */

	if ((windows & CONNECT_WIN) && (data->connect_win != NULL))													// Destroy "connecting" window
	{
		SEND_EVENT(data->connect_win,DIALOG_DESTROY,0,0);
		data->connect_win = NULL;
	}

	if ((windows & MENU_WIN) && (data->menu_win != NULL))						// Destroy main WAP menu
	{
#ifdef TRACE_AUIWAP
		TRACE_FUNCTION("AUI_destroy menu");
#endif
		bookMenuDestroy(data->menu_win);
		data->menu_win = NULL;
	}

	if ((windows & OTHER_MENU_WIN) && (data->other_menu_win != NULL))	// Destroy other WAP menu wyj
	{
#ifdef TRACE_AUIWAP
		TRACE_FUNCTION("AUI_destroy other menu");
#endif
		TRACE_FUNCTION("data->other_menu_win = %d", data->other_menu_win);
		bookMenuDestroy(data->other_menu_win);
		data->other_menu_win = NULL;
	}						

	if ((windows & OPTIONSMENU_WIN) && (data->optionsmenu_win != NULL))			// Destroy options menu
	{
#ifdef TRACE_AUIWAP
		TRACE_FUNCTION("AUI_destroy optionsmenu");
#endif
		// Remove all options list entries

		for (entryIndex=0; entryIndex<(data->OptionsList->no_of_entries); entryIndex++)
		{
			if (data->OptionsList->Entry[entryIndex]!=NULL)
			{
				//AUI_wap_memory_free((UBYTE *)data->OptionsList->Entry[entryIndex], (strlen(data->OptionsList->Entry[entryIndex])+1)*sizeof(char));  // Destroy each entry
				AUI_wap_memory_free((UBYTE *)data->OptionsList->Entry[entryIndex], (wstrlen(data->OptionsList->Entry[entryIndex])+3)*sizeof(char));	 // Destroy each entry
				data->OptionsList->Entry[entryIndex] = NULL;

			}
		}

		if (data->optionsmenu_data)												// For empty list, this memory is not allocated
		{
			AUI_wap_memory_free((UBYTE *)data->optionsmenu_data->List, (data->optionsmenu_data->ListLength)*sizeof(T_MFW_MNU_ITEM)); 
			AUI_wap_memory_free((UBYTE *)data->optionsmenu_data, sizeof(ListMenuData));	// Destroy menu */
			data->optionsmenu_data = NULL;										// Destroy menu items list
		}

		listsDestroy(data->optionsmenu_win);									// Same for list window
		data->optionsmenu_win = NULL;
	}

	if ((windows & LIST_WIN) && (data->list_win != NULL))						// Destroy entry list
	{
#ifdef TRACE_AUIWAP
		TRACE_FUNCTION("AUI_destroy list");
#endif
		if (data->list_data)													// For empty list, this memory is not allocated
		{
			AUI_wap_memory_free((UBYTE *)data->list_data->List, (data->list_data->ListLength)*sizeof(T_MFW_MNU_ITEM));
			AUI_wap_memory_free((UBYTE *)data->list_data, sizeof(ListMenuData));		// Destroy list */
			data->list_data = NULL;												// Destroy menu items list
		}
		listsDestroy(data->list_win);											// Same for list window
		data->list_win = NULL;
	}

	if ((windows & OPTIONS_WIN) && (data->options_win != NULL))					// Entry options menu (e.g. Bookmark options)
	{
#ifdef TRACE_AUIWAP
		TRACE_EVENT("AUI_destroy options");
#endif
		bookMenuDestroy(data->options_win);
		data->options_win = NULL;
	}

	if ((windows & EDIT_WIN) && (data->edit_win != NULL))						// Edit window
	{
#ifdef TRACE_AUIWAP
		TRACE_EVENT("AUI_destroy editor");
#endif
		if( text_input_flag == 1 )
		{
			text_input_destroy(data->edit_win);
			text_input_flag = 0;
		}
		else
		{
		editor_destroy(data->edit_win);
		}
		data->edit_win = NULL;
	}

	if (windows & WAP_WIN)														// Destroy WAP data win (exiting WAP)
	{
#ifdef TRACE_AUIWAP
		TRACE_EVENT("AUI_destroy WAP");
#endif

		/* SPR#1569 - SH - Destroy now happens in stages
		 * Display "Please wait" dialog; WAP destroy will complete on callback */

		data->temp_win = AUI_please_wait(data->win);
		ATB_wap_destroy();														// Destroy all views
	}

#ifdef TRACE_AUIWAP
	TRACE_EVENT("AUI_destroy end");
#endif

#ifdef TRACE_MEMALLOC
	for (trackIndex = 0; trackIndex<110; trackIndex++)							// Used to track memory allocations
	{
		sprintf(test_string, "TRACKINDEX %d is %d", trackIndex, memTracker[trackIndex]);
		TRACE_EVENT(test_string);
	}
#endif
	return;
}

/*******************************************************************************

 $Function:    	AUI_wap_close_view_done

 $Description:	SPR#1569 - SH - Added this function
				Called when a view has been closed
				
 $Returns:		void

 $Arguments:	None
 
*******************************************************************************/

void AUI_wap_close_view_done(void)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_close_view_done");
#endif

	ATB_wap_destroy();
}


/*******************************************************************************

 $Function:    	AUI_wap_terminate_done

 $Description:	SPR#1569 - SH - Added this function
				Called when a WAP termination is complete
				
 $Returns:		void

 $Arguments:	None
 
*******************************************************************************/

void AUI_wap_terminate_done(void)
{
	T_MFW_HND win           = wap_main_window;
	T_MFW_WIN *win_data     = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA *data        = (T_WAP_DATA *)win_data->user;								// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_terminate_done");
#endif

	if (data->temp_win)
	{
		SEND_EVENT(data->temp_win, DIALOG_DESTROY, NULL, NULL);
		data->temp_win = NULL;
	}

	if (data!=NULL)
	{
		AUI_wap_memory_free ((UBYTE *)data->Buffer, (INPUT_MAX_LEN+1)*sizeof(char));	// Delete input buffer 1
		AUI_wap_memory_free ((UBYTE *)data->Buffer2, (INPUT_MAX_LEN+1)*sizeof(char));	// Delete input buffer 2
		AUI_wap_memory_free ((UBYTE *)data->Format, (INPUT_MAX_LEN+1)*sizeof(char));	// Delete format string
		AUI_wap_memory_free ((UBYTE *)data->Message, (URL_MAX_LEN+1)*sizeof(char));		// Delete output buffer
		AUI_wap_memory_free ((UBYTE *)data->LeftSoftKey, (SOFTKEY_MAX_LEN+1)*sizeof(char));	 // Delete left softkey text
		AUI_wap_memory_free ((UBYTE *)data->RightSoftKey, ((SOFTKEY_MAX_LEN)*2+3)*sizeof(char)); // Delete right softkey text
		//AUI_wap_memory_free ((UBYTE *)data->RightSoftKey, (SOFTKEY_MAX_LEN+1)*sizeof(char)); // Delete right softkey text

		ATB_wap_entry_list_destroy(data->OptionsList);							// Destroy options menu list

		win_delete(data->win);													// Destroy the WAP data window
		wap_main_window = 0;
		AUI_wap_memory_free ((UBYTE *)data, sizeof (T_WAP_DATA));				// Destroy main data structure
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_cb

 $Description:	Callback function for WAP data window.  This window displays "not
				connected", since its appearance means a connection failure has
				occurred.  Apart from this, all information to be displayed should be
				in the other WAP windows (browser window, options window etc).
 
 $Returns:		void

 $Arguments:	event		- window handle event
				win			- WAP browser window
				
*******************************************************************************/

static int AUI_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_cb");
#endif

	switch (event)
	{
	case E_WIN_VISIBLE:
		if (win->flags & E_WIN_VISIBLE)
		{
			dspl_ClearAll();												// Clear the browser area
			/* SPR#1365 - SH - If this screen is displayed, the connection has been
			 * terminated, so display 'Not Connected' */
			PROMPT(4,12,0, TxtNotConnected);					//"disconnected"					//"connecting"
			displaySoftKeys(TxtReload,TxtExit);							// Default "back" soft key
		}
		break;
	}
	return;
}

/*******************************************************************************

 $Function:    	AUI_main_kbd_cb

 $Description:	
 
 $Returns:		

 $Arguments:	
				
*******************************************************************************/

static int AUI_main_kbd_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
	T_MFW_HND       win             = mfwParent( mfw_header());                 
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_main_kbd_cb");
#endif
	TRACE_EVENT("AUI_main_kbd_cb_zhao");

	switch (keyboard->code)
	{
	case KCD_HUP:                                                           
	case KCD_RIGHT:                                                         
		AUI_destroy(data->win, ALL_WIN);

		break;
	case KCD_LEFT:
		AUI_connect_URL(data->win, data->View->URL);
		break;
	default:
		break;
	}
	return MFW_EVENT_CONSUMED;
}



/*******************************************************************************

 $Function:    	AUI_control

 $Description:	Dialog function for WAP data window.  Since this window only
				displays the "not connected" message, currently this function can
				only show the window.
 
 $Returns:		void

 $Arguments:	win			- WAP data window
				event		- Window handle event
				value		- not used
				parameter	- not used

*******************************************************************************/

void AUI_control (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_control");
#endif

	switch (event)
	{
	case WAP_INIT:
		win_show(win);
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_connecting_dialog

 $Description:	Show "Connecting..." dialog (displayed while sending configuration
				information to WAP gateway)
				SPR#1574 - SH - Added parameter so dialog can show different messages.
				Currently, shows "Connecting..." message when GPRS is attaching, followed
				by "Logging on".
 
 $Returns:		Window handler

 $Arguments:	win		- pointer to the WAP data window
 
*******************************************************************************/

//T_MFW_HND AUI_connecting_dialog (T_MFW_HND win, ULONG status)
static int AUI_connecting_dialog (T_MFW_HND win, ULONG status)	  //zhaowm 2003/1/11
{
	T_MFW_WIN           *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA          *data       = (T_WAP_DATA *)win_data->user;				// WAP data
	T_DISPLAY_DATA      display_info;

#ifdef TRACE_AUIWAP		
	WAP_TRACE_EVENT(("AUI_connecting_dialog: %d",status) );
#endif

	switch (status)
	{
	case ATB_WAP_LOGGING_IN:
		//dlg_initDisplayData_TextId( &display_info, TxtNull, TxtCancel,TxtLoggingIn , TxtNull);/*2003/12/13, wangyan modify*/
		dialog_info_init(&display_info);
		display_info.RightSoftKey=TxtCancel;
		display_info.TextId         = TxtLoggingIn;
		display_info.TextString2    = data->View->Profile->Title;			// Show Profile name
		break;

	case ATB_WAP_ATTACHING:
		//dlg_initDisplayData_TextId( &display_info, TxtNull, TxtCancel,TxtConnecting , TxtNull);
		dialog_info_init(&display_info);
		display_info.RightSoftKey=TxtCancel;
		display_info.TextId         = TxtConnecting;
		display_info.TextString2    = data->View->Profile->Title;			// Show Profile name
		break;

	case ATB_WAP_CARD_READING:
		//dlg_initDisplayData_TextId( &display_info, TxtNull, TxtCancel,TxtDownloading , TxtNull);
		dialog_info_init(&display_info);
		display_info.RightSoftKey=TxtCancel;
		display_info.TextId         = TxtDownloading;
		display_info.TextString2    = data->View->Title;			// Show name of card being read
		break;

	case ATB_WAP_CONNECTING:
		//dlg_initDisplayData_TextId( &display_info, TxtNull, TxtCancel,TxtLoggingIn , TxtNull);
		dialog_info_init(&display_info);
		display_info.RightSoftKey=TxtCancel;
		display_info.TextId         = TxtLoggingIn;
		display_info.TextString2    = data->View->Profile->Title;			// Show Profile name
		break;

	case ATB_WAP_PLEASE_WAIT:
	default:
		//dlg_initDisplayData_TextId(&display_info, TxtNull, TxtCancel,TxtNull , TxtPleaseWait);
		dialog_info_init(&display_info);
		display_info.RightSoftKey=TxtCancel;
		display_info.TextId2        = TxtPleaseWait;
		break;
	}

	/* Destroy any previous dialog */

	AUI_destroy(data->win, CONNECT_WIN);

	/* Create new dialog */
	display_info.Callback= (T_VOID_FUNC)AUI_connecting_dialog_cb;
	display_info.Time           = FOREVER;
	display_info.KeyEvents=KEY_CLEAR | KEY_RIGHT;

//	dlg_initDisplayData_events( &display_info, (T_VOID_FUNC)AUI_connecting_dialog_cb, FOREVER, KEY_CLEAR | KEY_RIGHT );
	display_info.iconindex      = REMIND_WAP;
	data->connect_win           = info_dialog(win, &display_info);
	/* Create new dialog */
	//dlg_initDisplayData_events( &display_info, (T_VOID_FUNC)AUI_connecting_dialog_cb, FOREVER, KEY_CLEAR | KEY_RIGHT );

	//return info_dialog(win, &display_info);
	return 1;

}


/*******************************************************************************

 $Function:    	AUI_connecting_dialog_cb

 $Description:	Callback function for connecting dialog
 
 $Returns:		void

 $Arguments:	win			- pointer to the WAP data window
				identifier	- identifies function that has called callback
				reason		- reason for callback
 
*******************************************************************************/

void AUI_connecting_dialog_cb (T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_connecting_dialog_cb");
#endif

	/* SPR#1739 - SH - This should be set to NULL in all cases */

	data->connect_win = NULL;
	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:													// "Cancel" exits WAP
		/* SPR#1189 - SH - If browser is active, completely exit WAP.
		 * Otherwise, just return to last menu. */

		if (data->browser_win)
		{
			AUI_destroy(win, ALL_WIN);
		}
		else
		{
			/* Cancel any pending operation */
			ATB_wap_stop_download(data->View);
			/* End the call */
			AUI_end_call();
			/* Indicate we're no longer connected */
			ATB_wap_status_change(data->View, ATB_WAP_ONLINE_CONNECTION_CLOSED);
		}
		break;

	default:
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_connect_URL

 $Description:	Connects to WAP gateway (if required) and starts to download URL
 
 $Returns:		void

 $Arguments:	win		- pointer to the WAP data window
				URL		- URL to connect to
 
*******************************************************************************/

void AUI_connect_URL (T_MFW_HND win, char *URL)
{
	T_MFW_WIN   *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data           = (T_WAP_DATA *)win_data->user;					// WAP data
	T_WAP_VIEW  *View               = data->View;
	T_MMI_WAP_DOWNLOAD_URL_IND              DownloadURL;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_connect_URL");
#endif

	/* SPR#1739 - SH - If the browser is already visible, we can destroy the other windows */

	if (data->browser_win)
	{
		AUI_destroy(data->win, LIST_WIN | MENU_WIN | OPTIONSMENU_WIN | EDIT_WIN | OPTIONS_WIN | OTHER_MENU_WIN);
	}

	/* Display "Please Wait" to cover delay until call dialog is displayed */
	/* SPR#1739 - SH - Only display "Please Wait" if browser window is
	   not open. */

	if (!data->browser_win || !data->connected)
	{
		ATB_wap_status_change(data->View, ATB_WAP_PLEASE_WAIT);
	}
	if (!data->connected)													// If we're not already connected
	{
		ATB_wap_profile_send(View);											// Send configuration data
	}

	strcpy(View->URL, URL);													// Store URL

	// Send event requesting URL download

	DownloadURL.object_id = View->object_id;
	DownloadURL.url_length = strlen(URL)+1;									// Include final NULL
	DownloadURL.Url = URL;
	DownloadURL.reload = TRUE;												// Do not fetch from cache
	ATB_wap_download_url(&DownloadURL);										// Tell ATB to download URL

	/* Destroy some windows for now; we want to return to the list win
	 * if the connection is cancelled */

	AUI_destroy(data->win, OPTIONS_WIN | EDIT_WIN);						/* SPR#1189 - SH - Now only destroy options & edit windows */

	return;
}


/*******************************************************************************

 $Function:    	AUI_win_create

 $Description:	Create the WAP card browser window
 
 $Returns:		void

 $Arguments:	parent_win			- Pointer to the WAP data window

*******************************************************************************/

T_MFW_HND AUI_win_create (T_MFW_HND parent_win)
{
	T_MFW_WIN           *win_data;
	T_WAP_BROWSER       *data = (T_WAP_BROWSER *)AUI_wap_memory_alloc(sizeof(T_WAP_BROWSER));	// WAP browser data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_win_create");
#endif

	data->win = win_create(parent_win,0,E_WIN_VISIBLE, (T_MFW_CB)AUI_win_cb);	// Create the browser window

	// Create keyboard handler
	data->kbd       = kbd_create (data->win, KEY_ALL, (T_MFW_CB)AUI_kbd_cb);
	data->kbd_long  = kbd_create (data->win, KEY_ALL|KEY_LONG, (T_MFW_CB)AUI_kbd_long_cb);

	// Create window handler

	data->mmi_control.dialog    = (T_DIALOG_FUNC)AUI_win_control;
	data->mmi_control.data      = (void *)data;
	data->parent_win            = parent_win;
	win_data                    = ((T_MFW_HDR *)data->win)->data;
	win_data->user              = (void *)data;									// Attach browser data to window

	return data->win;
}


/*******************************************************************************

 $Function:    	AUI_win_destroy

 $Description:	Destroy the WAP card browser window
 
 $Returns:		void

 $Arguments:	win				- Pointer to the WAP browser window

*******************************************************************************/

int AUI_win_destroy (T_MFW_HND win)
{

	T_MFW_WIN           *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_BROWSER       *data       = (T_WAP_BROWSER *)win_data->user;			// WAP browser data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_win_destroy");
#endif

	kbd_delete(data->kbd);														// Delete keyboard handlers
	kbd_delete(data->kbd_long);

	win_delete(win);															// Delete window
	AUI_wap_memory_free((UBYTE *)data, sizeof(T_WAP_BROWSER));					// Destroy data structure

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_win_control

 $Description:	Dialog function for WAP Browser window
 
 $Returns:		void

 $Arguments:	win			- WAP card browser window
				event		- Window handle event
				value		- not used
				parameter	- not used

*******************************************************************************/

void AUI_win_control (T_MFW_HND win, USHORT event, SHORT value, void * parameter)
{
	T_MFW_WIN       *win_data           = ((T_MFW_HDR *)win)->data;
	T_WAP_BROWSER   *data               = (T_WAP_BROWSER *)win_data->user;		// WAP Browser data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_win_control");
#endif

	switch (event)
	{
	case WAP_INIT:															// Currently does nothing
		break;

	case WAP_SHOW_CARD:														// Show the current card
		data->TextId1       = NULL;
		data->TextId2       = NULL;
		data->TextString1   = NULL;
		data->TextString2   = NULL;
		win_show(win);
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_win_cb

 $Description:	Callback function for browser window
 
 $Returns:		void

 $Arguments:	event		- window handle event
				win			- WAP browser window
				
*******************************************************************************/

static int AUI_win_cb (T_MFW_EVENT event, T_MFW_WIN * win)
{
	T_WAP_BROWSER   *BrowserData    = (T_WAP_BROWSER *)win->user;				// WAP browser data
	T_MFW_HND       parent_win      = BrowserData->parent_win;
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	char            *LeftSoftKey;
	char            *RightSoftKey;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_win_cb");
#endif

	if (data==NULL)
		return NULL;
	if (optiongoback)	  //2002.12.12 zhaowm for temp
	{
		if (data->update_forbid)
			return NULL;
	}
	optiongoback = 0; 
	switch (event)
	{
	case E_WIN_VISIBLE:
		if (win->flags & E_WIN_VISIBLE)
		{
			dspl_ClearAll();												// Clear the browser are
			ATB_wap_buffer_display(data->View);								// Display the buffered page


			/* SPR#1575 - SH - Display "Cancel" when downloading or reading in a card */
			if (ATB_wap_status_get(data->View, ATB_WAP_DOWNLOADING)
				|| ATB_wap_status_get(data->View, ATB_WAP_CARD_READING))
			{
				displaySoftKeys(TxtNull, TxtCancel);
				//displaySoftKeys(TxtNull, TxtSoftOptions);
			}
			else
			{
				if (data->View->CustSoftKeys)
					displaySoftKeys(TxtSoftOptions, Txtfunction);	// Show customised keys
				else
					//	{
					/*
					if (data->View->CanGoBack)
						displaySoftKeys(TxtSoftOptions, TxtSoftBack);		// Show "options" and "back"
					else
						displaySoftKeys(TxtSoftOptions, TxtNull);			// Only show "options" if we can't go back
					*/
					displaySoftKeys(TxtSoftSelect, Txtfunction);			//zhaowm 2002/10/21 using leftsoftkey go to the next URL
				//displaySoftKeys(TxtSoftSelect, TxtSoftOptions);			//zhaowm 2002/10/21 using leftsoftkey go to the next URL
				//	}
			}
		}
		break;

	default:
		return 0;
	}
	return 1;
}



/*******************************************************************************

 $Function:    	AUI_kbd_cb

 $Description:	Keyboard event handler for browser window

 $Returns:		status int

 $Arguments:	event			- window handle event
				keyboard		- keyboard control block

*******************************************************************************/

static int AUI_kbd_cb (T_MFW_EVENT event, T_MFW_KBD *keyboard)
{   
	T_MFW_HND       win                 = mfwParent( mfw_header());				// parent_win = WAP menu window
	T_MFW_WIN       *win_data           = ((T_MFW_HDR *)win)->data;
	T_WAP_BROWSER   *BrowserData        = (T_WAP_BROWSER *)win_data->user;		// WAP browser data
	T_MFW_HND       parent_win          = BrowserData->parent_win;
	T_MFW_WIN       *parent_win_data    = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA      *data               = (T_WAP_DATA *)parent_win_data->user;	// WAP data
	T_WAP_VIEW      *View               = data->View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_kbd_cb");
#endif

	switch (keyboard->code)
	{
	case KCD_LEFT:															// Open options menu if not downloading
	case KCD_OK:
		//zhaowm 2003/01/15  KCD_LEFT exchanges with KCD_RIGHT, moreover,to use "select"instead of"Back".
		/*
		if (!ATB_wap_status_get(View, ATB_WAP_DOWNLOADING))
			{
			AUI_wap_options_menu_open(ATB_wap_buffer_identify_element(View));

			}
		*/  
		if (ATB_wap_status_get(View, ATB_WAP_DOWNLOADING)
			|| ATB_wap_status_get(View, ATB_WAP_CARD_READING))
		{
			//	ATB_wap_stop_download(View);
		}
		else
		{
			if (View->CustSoftKeys)
				AUI_wap_CustSoftKey_menu_open(ATB_wap_buffer_identify_element(View));
			else
			{
				//ATB_wap_card_go_back(View);									// Otherwise default is "Back"
				//AUI_destroy(win, OPTIONSMENU_WIN);							// Destroy options menu
				data->update_forbid = FALSE;
				ATB_wap_options_menu_select(View);							// tell ATB to do something
				TRACE_EVENT("go_to_link");	//zhaowm 2002/1106

			}
		}
		break;

	case KCD_RIGHT: 

/* SPR#1575 - SH - Open options menu if not downloading or reading a card */
		if (ATB_wap_status_get(View, ATB_WAP_DOWNLOADING)|| ATB_wap_status_get(View, ATB_WAP_CARD_READING))
		{
			ATB_wap_stop_download(View);
		}

		else
		{
			//if (View->CustSoftKeys)
			//	ATB_wap_key_selected(View, View->CustSoftKeyId);  	  		// Customised right soft key
			//else
			//	ATB_wap_card_go_back(View);									// Otherwise default is "Back"
			//}

			/* SPR#1575 - SH - Open options menu if not downloading or reading a card */
			if (!ATB_wap_status_get(View, ATB_WAP_DOWNLOADING)&& !ATB_wap_status_get(View, ATB_WAP_CARD_READING))
			{
				AUI_wap_options_menu_open(ATB_wap_buffer_identify_element(View));
			}
		}
		break;

	case KCD_MNUUP:
		ATB_wap_card_key_event(View, WAP_KEY_UP);							// Scroll card up
		break;

	case KCD_MNUDOWN:
		ATB_wap_card_key_event(View, WAP_KEY_DOWN);							// Scroll card down
		break;

	case KCD_1:
		ATB_wap_card_key_event(View, WAP_KEY_LEFT);							// Scroll card left
		break;

	case KCD_3:
		ATB_wap_card_key_event(View, WAP_KEY_RIGHT);						// Scroll card right
		break;

	case KCD_2:
		ATB_wap_card_scroll(View,0);										// Go to top of card
		break;

	case KCD_5:
		ATB_wap_card_scroll(View,View->cardYPosition-WAP_PAGE_SCROLL);		// Scroll up a page
		break;

	case KCD_8:
		ATB_wap_card_scroll(View,View->cardYPosition+WAP_PAGE_SCROLL);		// Scroll down a page
		break;

	case KCD_0:
		ATB_wap_card_scroll(View,View->cardHeight-WAP_SCREEN_HEIGHT);		// Go to bottom of card
		break;

	case KCD_CALL:
		ATB_wap_card_key_event(View, WAP_KEY_SELECT);						// Select an option
		break;

	case KCD_HUP:
		AUI_Exit_Inquire_dialog (data->win);

		break;

	case KCD_F4:  //zhaowm 2003.0328
		ATB_wap_stop_download(data->View);
		AUI_destroy(data->win,ALL_WIN); 
		AUI_end_call();		 // zhaowm 2003.0324  Call this function to end a GPRS or CSD call 		

		break;
	case KCD_STAR:
		View->Status ^= WAP_STATUS_SCALEIMAGES;								// Toggle image scaling
		ATB_wap_profile_save(data->View);									// Save change to flash
		ATB_wap_card_refresh(View);
		break;

	default:
		break;
	}
	return MFW_EVENT_CONSUMED;
}


static int AUI_kbd_long_cb(T_MFW_EVENT event, T_MFW_KBD *keyboard)
{
	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_goto_www

 $Description:	Opens up a text edit screen for entering URLs with "www." entered.
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_goto_www(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_goto_www");
#endif

	AUI_edit(GET_TEXT(TxtWWWdot),WAP_GOTO_URL,TxtGoTo,URL_MAX_LEN);			// Enter editor

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_goto_wap

 $Description:	Opens up a text edit screen for entering URLs with "wap." entered.
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_goto_wap(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_goto_wap");
#endif

	AUI_edit(GET_TEXT(TxtWAPdot),WAP_GOTO_URL, TxtGoTo, URL_MAX_LEN);		// Enter editor

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	MMI_AUI_goto_other

 $Description:	Opens up a blank text edit screen for entering URLs
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_goto_other(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_goto_other");
#endif

	AUI_edit("",WAP_GOTO_URL, TxtGoTo, URL_MAX_LEN);						// Enter editor

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_edit

 $Description:	Opens up a text edit screen for editing URLs
			 
 $Returns:		

 $Arguments:	shortcut	- pointer to a string that will appear in the editor
				identifier	- specifies what to do with the URL (connect, store etc).
				prompt		- textId of prompt to display
				maxlen		- maximum length of the edited string
 
*******************************************************************************/

int AUI_edit(char *shortcut, USHORT identifier, int prompt, USHORT maxlen)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_edit");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	if (identifier==WAP_EDIT_HOMEPAGE)											// If we're editing the homepage URL,
		shortcut = data->View->Profile->Homepage;								// this is the shortcut

	if (identifier==WAP_EDIT_APN)
		shortcut = data->View->Profile->APN;

	if (shortcut[0] == 0x80)   //zhaowm 2003.1.7
		wstrncpy(data->Buffer, shortcut, wstrlen(shortcut));
	else
		strcpy(data->Buffer, shortcut);												// Copy shortcut into editing buffer
	AUI_edit_create(data->win, identifier, prompt, maxlen);						// Create edit window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_edit_create

 $Description:	Creates the edit screen
			 
 $Returns:		none.

 $Arguments:	parent_win	- the originating window
				identifier	- purpose for edit window (e.g. go to URL)
				prompt		- textId of prompt to display
				maxlen		- maximum length of the editor
 
*******************************************************************************/

static T_MFW_HND AUI_edit_create(MfwHnd parent_win, USHORT identifier, int prompt, USHORT maxlen)
{
	T_MFW_WIN   *win_data       = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA  *data           = (T_WAP_DATA *)win_data->user;					// WAP data

	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_edit_create");
#endif

	/* 2003/12/04 sunsj */
	AUI_standard_editor(&editor_data, data->Buffer, maxlen, TEXTINPUT_MODE, (T_EDIT_CB)AUI_edit_cb); // Setup standard editor //zhaowm 2002.11.28 handle chinese input

	//editor_data.TextId				= prompt;				//zhaowm 2002.11.28 "TextId" not used for title. // Prompt to display above editor
	editor_data.editor_attr.title_id   =prompt;
	editor_data.Identifier          = identifier;								// Purpose of edit window (for callback)
	editor_data.InputMode           = LOWERCASE_INPUT_MODE;

	data->edit_win = text_input(data->win, &editor_data);
	text_input_flag = 1;

	//data->edit_win = editor_start(data->win,&editor_data);						// Start the editor

	return data->edit_win;
}


/*******************************************************************************

 $Function:    	AUI_edit_cb

 $Description:	Callback function for edit screen.  This performs the following functions,
				the user having provided a new or updated URL:
				
				- Goto URL
				- Editing of Bookmark and History entries
				- Add new bookmark
				- Edit homepage
 
 $Returns:		void

 $Arguments:	win			- the WAP data window
				identifier	- identifier for the edit type (just 0 so far)
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_edit_cb(T_MFW_HND win, USHORT identifier, USHORT reason)
{
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data       = (T_WAP_DATA *)win_data->user;					// WAP data
	T_WAP_VIEW      *View       = data->View;


#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_edit_cb");
#endif
	switch (reason)
	{
	case INFO_KCD_LEFT:
		switch (identifier)
		{
		// Go to URL
		
		case WAP_GOTO_URL:
			AUI_connect_URL(data->win, data->Buffer);					// Download URL
			break;

			// Edit Bookmark name

		case WAP_EDIT_BOOKMARK:
			AUI_destroy(data->win, EDIT_WIN | LIST_WIN | OPTIONS_WIN);										// Destroy all above including the list
			ATB_wap_entry_change(WAP_BOOKMARKS_LIST, View->Bookmarks, data->Buffer, data->OptionSelect);	// Change the bookmark entry
			ATB_wap_profile_save(View);																		// Save change to flash
			AUI_entry_list(data->win, View->Bookmarks, (ListCbFunc)AUI_bookmarks_list_cb,0,2);				// Display new bookmark list
			AUI_info_dialog(data->win, NULL, TxtChanged);													// Display "Changed" message
			break;

			// Edit Bookmark URL

		case WAP_EDIT_BOOKMARK_URL:
			AUI_destroy(data->win, EDIT_WIN | LIST_WIN | OPTIONS_WIN);										// Destroy all above including the list
			ATB_wap_entry_change(WAP_BOOKMARKS_LIST, View->BookmarksURL, data->Buffer, data->OptionSelect);	// Change the bookmark entry
			ATB_wap_profile_save(View);																		// Save change to flash
			AUI_entry_list(data->win, View->Bookmarks, (ListCbFunc)AUI_bookmarks_list_cb,0,2);				// Display new bookmark list
			AUI_info_dialog(data->win,NULL , TxtChanged);													// Display "Changed" message
			break;

			// Edit History name

		case WAP_EDIT_HISTORY:
			AUI_destroy(data->win, EDIT_WIN | LIST_WIN | OPTIONS_WIN);
			ATB_wap_entry_change(WAP_HISTORY_LIST, View->History, data->Buffer, data->OptionSelect);	// Change the history entry
			ATB_wap_profile_save(View);																	// Save change to flash
			AUI_entry_list(data->win, View->History, (ListCbFunc)AUI_history_list_cb,0,2);					// Display new history list
			AUI_info_dialog(data->win,NULL, TxtChanged);												// Display "Changed" message
			break;

			// Edit History URL

		case WAP_EDIT_HISTORY_URL:
			AUI_destroy(data->win, EDIT_WIN | LIST_WIN | OPTIONS_WIN);
			ATB_wap_entry_change(WAP_HISTORY_LIST, View->HistoryURL, data->Buffer, data->OptionSelect);	// Change the history entry
			ATB_wap_profile_save(View);																	// Save change to flash
			AUI_entry_list(data->win, View->History, (ListCbFunc)AUI_history_list_cb,0,2);					// Display new history list
			AUI_info_dialog(data->win, NULL,TxtChanged);												// Display "Changed" message
			break;

			// Add Bookmark

		case WAP_ADD_BOOKMARK:
			AUI_destroy(data->win, EDIT_WIN);															// Destroy editor
			strcpy(data->Buffer2, data->Buffer);														// Store URL in second buffer
			//strcpy(data->Buffer, "");																	// Clear editor for name
			memset(data->Buffer, 0, (INPUT_MAX_LEN+1)*sizeof(char));//zhaowm 2003.0314
			AUI_edit_create(data->win, WAP_ADD_BOOKMARK_NAME, TxtEditName, CARD_TITLE_MAX_LEN);			// Edit name of new bookmark
			break;

			// Add Bookmark name

		case WAP_ADD_BOOKMARK_NAME:
			AUI_destroy(data->win, EDIT_WIN);											// Destroy second editor
			if (ATB_wap_entry_add(View->BookmarksURL, data->Buffer2)==NULL)				// Add URL entry
			{
				AUI_info_dialog(data->win, TxtBookmarks, TxtFull);						// If list is full, say so
			}
			else
			{
				ATB_wap_entry_add(View->Bookmarks, data->Buffer);						// Add name entry
				ATB_wap_profile_save(View);												// Save change to flash
				AUI_entry_list(data->win, View->Bookmarks, (ListCbFunc)AUI_bookmarks_list_cb,0,2);// Display new bookmark list
				AUI_info_dialog(data->win,NULL ,TxtStored);							// Display "Stored" message
			}
			break;

			// Edit Homepage URL

		case WAP_EDIT_HOMEPAGE:
			if (data->Buffer[0] == 0x80)   //zhaowm 2003.1.7
				wstrncpy(View->Profile->Homepage, data->Buffer, wstrlen(data->Buffer));
			else
				strcpy(View->Profile->Homepage, data->Buffer);					// Change the homepage
			ATB_wap_profile_save(View);									// Save change to flash
			AUI_destroy(data->win, EDIT_WIN);							// Kill the editor
			AUI_info_dialog(data->win,NULL , TxtChanged);				// "Changed"
			break;
			// Edit APN

		case WAP_EDIT_APN:
			if (data->Buffer[0] == 0x80)   //zhaowm 2003.1.7
				wstrncpy(View->Profile->APN, data->Buffer, wstrlen(data->Buffer));
			else
				strcpy(View->Profile->APN, data->Buffer);							// Change the homepage
			ATB_wap_profile_save(View);									// Save change to flash
			AUI_destroy(data->win, EDIT_WIN);							// Kill the editor
			AUI_info_dialog(data->win, NULL, TxtChanged);				// "Changed"
			break;

		default:
			break;
		}
		break;

	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:													// (Exit from Editor)
		AUI_destroy(data->win,EDIT_WIN);									// Destroy edit window
		if (identifier == WAP_ADD_BOOKMARK_NAME)							// If we've destroyed the name editor,
		{
			if (data->Buffer2[0] == 0x80)	//zhaowm 2003.1.7
				wstrncpy(data->Buffer, data->Buffer2, wstrlen(data->Buffer2));
			else
				strcpy(data->Buffer, data->Buffer2);							// copy the URL back into the editor
			AUI_edit_create(data->win, WAP_ADD_BOOKMARK, TxtEditURL, CARD_TITLE_MAX_LEN);
		}
		break;

	default:
		break;
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_add_www

 $Description:	Opens up a text edit screen for entering URLs with "www." entered.
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_bookmarks_add_www(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_add_www");
#endif

	AUI_edit(GET_TEXT(TxtWWWdot),WAP_ADD_BOOKMARK, TxtGoTo, URL_MAX_LEN);	// Open up the editor

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_add_wap

 $Description:	Opens up a text edit screen for entering URLs with "wap." entered.
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_bookmarks_add_wap(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_add_www");
#endif

	AUI_edit(GET_TEXT(TxtWAPdot),WAP_ADD_BOOKMARK, TxtGoTo, URL_MAX_LEN);	// Open up the editor

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_add_other

 $Description:	Opens up a blank text edit screen for entering URLs
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_bookmarks_add_other(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_add_www");
#endif

	AUI_edit("",WAP_ADD_BOOKMARK, TxtGoTo, URL_MAX_LEN);					// Open up the editor

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_list

 $Description:	List Bookmarks menu option
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_bookmarks_list(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_list");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	// Create the list menu

	AUI_entry_list(win, data->View->Bookmarks, (ListCbFunc) AUI_bookmarks_list_cb,0,2);

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_list_cb

 $Description:	Callback function for bookmarks list menu
 
 $Returns:		void		

 $Arguments:	win				- WAP data window
				EntryListData	- list menu data of bookmarks list
 
*******************************************************************************/

static void AUI_bookmarks_list_cb(T_MFW_HND win, ListMenuData *EntryListData)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_list_cb");
	sprintf(test_string, "Reason for callback: %d", EntryListData->Reason);
	TRACE_EVENT(test_string);
#endif

	switch (EntryListData->Reason)
	{
	case LISTS_REASON_SELECT:                                   
	case LISTS_REASON_OK:
		// Option is selected...

		data->OptionSelect = EntryListData->ListPosition;						// Store selected bookmark no.
		data->URLSelect = View->BookmarksURL->Entry[data->OptionSelect];	// Store the URL of the bookmark
		WapTitle = TxtSoftOptions;	 //zhaowm 2002.12.08  
		data->options_win = bookMenuStart(win, WAPBookOptMenuAttributes(), PhbkWap);	// Create bookmark options menu
		break;
	case LISTS_REASON_SEND:
		data->OptionSelect = EntryListData->ListPosition;						// Store selected bookmark no.
		data->URLSelect = View->BookmarksURL->Entry[data->OptionSelect];	// Store the URL of the bookmark

		AUI_connect_URL(data->win, data->URLSelect);						// The selected menu item is the new URL
		break;
	case LISTS_REASON_CLEAR:
	case LISTS_REASON_HANGUP:												// sbh: added, so hangup key exits
	case LISTS_REASON_BACK:													// Exit list menu
		AUI_destroy(win,LIST_WIN);											// Kill the list window
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_goto

 $Description:	Open up the selected bookmark in the WAP browser
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_goto(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_goto");
#endif

	return AUI_entry_goto(WAP_BOOKMARKS_LIST);  
}   


/*******************************************************************************

 $Function:    	AUI_bookmarks_edit

 $Description:	Edit the name of the selected bookmark
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_edit(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	char            *Entry;

#ifdef TRACE_AUIWAP
	UBYTE   entryIndex;

	TRACE_FUNCTION("AUI_bookmarks_edit");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	Entry           = data->View->Bookmarks->Entry[data->OptionSelect];			// The bookmark name to be edited

	AUI_edit(Entry, WAP_EDIT_BOOKMARK, TxtEditName, CARD_TITLE_MAX_LEN);		// Open up editor
	return MFW_EVENT_CONSUMED;  
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_edit_url

 $Description:	Edit the URL of the selected bookmark
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_edit_url(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	char            *Entry;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_edit_url");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	Entry           = data->View->BookmarksURL->Entry[data->OptionSelect];		// The bookmark URL to be edited

	AUI_edit(Entry, WAP_EDIT_BOOKMARK_URL, TxtEditURL, URL_MAX_LEN);			// Open up editor
	return MFW_EVENT_CONSUMED;  
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_delete

 $Description:	Delete the selected bookmark from the bookmarks list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_bookmarks_delete(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_delete");
#endif

	AUI_entry_delete(WAP_DELETE_BOOKMARK);

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_bookmarks_sendSMS

 $Description:	Open up a bookmark in an SMS write editor
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_bookmarks_sendSMS(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_bookmarks_sendSMS");
#endif

	AUI_entry_sendSMS();

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_history_list

 $Description:	List History menu option
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_history_list(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_list");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	// Create the history list menu

	AUI_entry_list(win, data->View->History, (ListCbFunc) AUI_history_list_cb,0,2);

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_history_list_cb

 $Description:	Callback function for history list menu
 
 $Returns:		void		

 $Arguments:	win				- WAP data window
				EntryListData	- list menu data of history lsit
 
*******************************************************************************/

static void AUI_history_list_cb(T_MFW_HND win, ListMenuData *EntryListData)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_list_cb");
#endif

	switch (EntryListData->Reason)
	{
	case LISTS_REASON_SELECT:                                   
	case LISTS_REASON_OK:
		// Option is selected...

		data->OptionSelect = EntryListData->ListPosition;					// Store selected history entry no.
		data->URLSelect = View->HistoryURL->Entry[data->OptionSelect];		 // Store the URL of the history entry
		WapTitle = TxtSoftOptions;	 //zhaowm 2002.12.08
		data->options_win = bookMenuStart(win, WAPHistOptMenuAttributes(), PhbkWap);	 // Create history options menu
		break;


	case LISTS_REASON_SEND:                                 
		data->OptionSelect = EntryListData->ListPosition;						// Store selected bookmark no.
		data->URLSelect = View->HistoryURL->Entry[data->OptionSelect];	// Store the URL of the bookmark

		AUI_connect_URL(data->win, data->URLSelect);						// The selected menu item is the new URL
		break;

	case LISTS_REASON_BACK:													// Exit menu
		AUI_destroy(win,LIST_WIN);											// Destroy list window
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_history_goto

 $Description:	Open up the selected history entry in the WAP browser
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_goto(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_goto");
#endif

	return AUI_entry_goto(WAP_HISTORY_LIST);    
}   


/*******************************************************************************

 $Function:    	AUI_history_edit

 $Description:	Edit the name of the selected history entry
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_edit(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	char            *Entry;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_edit");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	Entry           = data->View->History->Entry[data->OptionSelect];

	//AUI_edit(Entry+NUMBER_PADDING, WAP_EDIT_HISTORY, TxtEditName, CARD_TITLE_MAX_LEN);
	AUI_edit(Entry, WAP_EDIT_HISTORY, TxtEditName, CARD_TITLE_MAX_LEN);//zhaowm 2003.1.8
	return MFW_EVENT_CONSUMED;  
}


/*******************************************************************************

 $Function:    	AUI_history_edit_url

 $Description:	Edit the URL of the selected history entry
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_edit_url(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	char            *Entry;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_edit_url");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	Entry           = data->View->HistoryURL->Entry[data->OptionSelect];

	AUI_edit(Entry, WAP_EDIT_HISTORY_URL, TxtEditURL, URL_MAX_LEN);
	return MFW_EVENT_CONSUMED;  
}


/*******************************************************************************

 $Function:    	AUI_history_delete

 $Description:	Delete the selected entry from the history list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_delete(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_delete");
#endif

	AUI_entry_delete(WAP_DELETE_HISTORY);

	return MFW_EVENT_CONSUMED;
}   


/*******************************************************************************

 $Function:    	AUI_history_clear

 $Description:	Deletes all entries in history list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_clear(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_DISPLAY_DATA  display_info;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_clear");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	dialog_info_init(&display_info);//gdy add	
	display_info.TextId         = NULL;//TxtOkToDelete;								// "OK to delete" prompt
	display_info.TextId2        = TxtOkToDelete;//NULL;
	display_info.TextString     = NULL;
	display_info.TextString2    = NULL;
	display_info.LeftSoftKey    = TxtSoftOK;
	display_info.RightSoftKey   = TxtSoftBack;//TxtExit;
	display_info.Time           = FOREVER;
	display_info.Callback       = (T_VOID_FUNC)AUI_entry_delete_cb;
	display_info.Identifier     = WAP_CLEAR_HISTORY;							// Identifier specifies action on callback
	display_info.iconindex          =REMIND_REQUIRE;


	info_dialog(win, &display_info);
	return 1;
}


/*******************************************************************************

 $Function:    	AUI_history_addbook

 $Description:	Adds a history item to the bookmarks list
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item	
 
*******************************************************************************/

int AUI_history_addbook(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_WAP_VIEW      *View;
	char            *Entry;
	char            *URL;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_addbook");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data
	View        = data->View;

	Entry       = View->History->Entry[data->OptionSelect];						// Text of the history entry
	URL         = View->HistoryURL->Entry[data->OptionSelect];					// URL of the entry

	if (ATB_wap_entry_add(View->Bookmarks, Entry+NUMBER_PADDING)==NULL)			// Try to add history item to bookmarks
		AUI_info_dialog(data->win,TxtBookmarks , TxtFull);						// if it's full, say "Bookmarks Full"
	else
	{
		ATB_wap_entry_add(View->BookmarksURL, URL);
		ATB_wap_profile_save(View);												// Save change to flash
		AUI_info_dialog(data->win,NULL , TxtStored);							// Display "Stored" message
	}
	return 1;
}


/*******************************************************************************

 $Function:    	AUI_history_sendSMS

 $Description:	Open up a history entry in an SMS write editor
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_history_sendSMS(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_history_sendSMS");
#endif

	AUI_entry_sendSMS();

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_profiles_list

 $Description:	Lists names of all profiles in flash
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_profiles_list(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_WAP_VIEW      *View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_profiles_list");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	View            = data->View;

	// Create the profile list menu

	View->ProfilesList->type = WAP_PROFILES_LIST;								// To differentiate from WAP_PROFILES_SETUP
	AUI_entry_list(win, View->ProfilesList, (ListCbFunc) AUI_profiles_list_cb, View->ProfileId,0);		// Create the profiles list

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_profiles_list_cb

 $Description:	Callback function for profiles list menu
 
 $Returns:		void		

 $Arguments:	win				- WAP data window
				EntryListData	- list menu data of profiles list
 
*******************************************************************************/

static void AUI_profiles_list_cb(T_MFW_HND win, ListMenuData *EntryListData)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;
	UBYTE           temp_storage;												// Used to store new profile id

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_profiles_list_cb");
#endif

	switch (EntryListData->Reason)
	{
	case LISTS_REASON_SEND:
	case LISTS_REASON_SELECT:                                   
	case LISTS_REASON_OK:
		// The user has chosen a profile
		temp_storage = EntryListData->ListPosition;							// Store selected profile number for a bit...
		//	AUI_destroy(win,LIST_WIN);											// Destroy the list window
		// Get new profile
		ATB_wap_profile_read(View, temp_storage);							// Read in new profile data
		ATB_wap_profile_save(View);											// Save the change to flash
		AUI_info_dialog(data->win,NULL , TxtChanged);
		AUI_destroy(win,LIST_WIN);											// Display "Changed"
		break;

	case LISTS_REASON_BACK:													// Exit menu (back, timeout etc).		
		AUI_destroy(win,LIST_WIN);											// Destroy the list window
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_profiles_setup

 $Description:	Lists names of all profiles in flash, in order to change settings
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_profiles_setup(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_WAP_VIEW      *View;

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	View            = data->View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_profiles_setup");
#endif

	// Store the current profile number - we're going to temporarily change profiles
	// to edit the settings, then switch back.

	data->OptionSelect = View->ProfileId;

	// Create the profile list menu

	View->ProfilesList->type = WAP_PROFILES_SETUP;								// To differentiate from WAP_PROFILES_LIST
	AUI_entry_list(win, View->ProfilesList, (ListCbFunc) AUI_profiles_setup_cb, View->ProfileId,2);	  // Create the profiles list menu

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_profiles_setup_cb

 $Description:	Callback function for profiles list menu
 
 $Returns:		void		

 $Arguments:	win				- WAP data window
				EntryListData	- list menu data of profiles list
 
*******************************************************************************/

static void AUI_profiles_setup_cb(T_MFW_HND win, ListMenuData *EntryListData)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;
	UBYTE           original_profile  = View->ProfileId;
	UBYTE           new_profile;


#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_profiles_setup_cb");
#endif

	switch (EntryListData->Reason)
	{
	case LISTS_REASON_SEND:
	case LISTS_REASON_SELECT:                                   
	case LISTS_REASON_OK:
		// The user has chosen a profile

		new_profile = EntryListData->ListPosition;							// Change profile number
		ATB_wap_profile_read(View, new_profile);							// Read in selected profile
		WapTitle = TxtSettings;	  //zhaowm 2002.12.08
		data->options_win = bookMenuStart(win, WAPProfOptionsAttributes(), PhbkWap);	 // Create settings menu
		break;

	case LISTS_REASON_BACK:													// Exit menu		
		AUI_destroy(win,LIST_WIN);

		if (View->ProfileId!=data->OptionSelect)							// We've changed profile...
		{
			ATB_wap_profile_read(View, original_profile);					// Read in original profile
		}

		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_entry_list

 $Description:	Create an entry list and store its pointer in list_win/list_data
 
 $Returns:		pointer to list menu data

 $Arguments:	win			- the WAP data window
				EntryList	- pointer to entry list table
				Callback	- the callback function
				pos			- the default highlighted option
				prompt      = 0  used for profile select            //zhaowm 2002.12.15
							  1  used for browser option menu's haad str 
							  2  used for others
							  3  used for custsoftkey option menu
*******************************************************************************/

static int AUI_entry_list (T_MFW_HND win, T_WAP_LIST *EntryList, ListCbFunc Callback, UBYTE pos,int prompt)
{
	T_MFW_WIN   *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data           = (T_WAP_DATA *)win_data->user;					// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_entry_list");
#endif

	/* Destroy previous list, if it exists */

	if (data->list_win)
	{
		AUI_destroy(data->win, LIST_WIN);
	}

	/* Create new list */

	data->list_data = AUI_entry_list_create (win, EntryList, Callback, pos, prompt);	// Create the entry list
	if (data->list_data)														// If list has been created...
		data->list_win = data->list_data->win;									// Attach the resulting window to the data
	else
	{
		data->list_win = NULL;													// No window created
	}
	return 1;       
}


/*******************************************************************************

 $Function:    	AUI_entry_list_create

 $Description:	Create an entry list for Bookmarks/History/Profiles, or options menu
 
 $Returns:		pointer to list menu data

 $Arguments:	win			- the WAP data window
				EntryList	- pointer to bookmarks table
				Callback	- the callback function for the entry list
				pos			- the default highlighted option
 
*******************************************************************************/

static ListMenuData * AUI_entry_list_create (T_MFW_HND win, T_WAP_LIST *EntryList, ListCbFunc Callback, UBYTE pos,int prompt)
{
	ListMenuData *EntryListData;
	USHORT      entryIndex;
	USHORT      no_of_entries   = EntryList->no_of_entries;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_entry_list_create");
#endif

	if (no_of_entries==0)														// Is the list empty?
	{
		AUI_info_dialog(win,NULL , TxtEmpty);									// Show "Empty List" message
		return NULL;
	}

	EntryListData = (ListMenuData *)AUI_wap_memory_alloc (sizeof(ListMenuData));	// Allocate memory for list data

	if (EntryListData==NULL)
		return NULL;

	EntryListData->List = (T_MFW_MNU_ITEM *) AUI_wap_memory_alloc (no_of_entries*sizeof (T_MFW_MNU_ITEM));

	if (EntryListData->List==NULL)
		return NULL;

	// Fill Menu List

	for (entryIndex=0; entryIndex < no_of_entries; entryIndex++)
	{
		//EntryListData->List[entryIndex].icon = 0;
		EntryListData->List[entryIndex].exta = 0;
		EntryListData->List[entryIndex].edit = 0;
		EntryListData->List[entryIndex].menu = 0;
		EntryListData->List[entryIndex].func = 0;

		if (EntryList->Entry[entryIndex]!=NULL)
			EntryListData->List[entryIndex].str = (char *)EntryList->Entry[entryIndex];	  // Copy Entry into list
		else
			EntryListData->List[entryIndex].str	= GET_TEXT(TxtEmpty);			// ....otherwise "Empty"

		if ( prompt == 0)	  //zhaowm 2002.12.15  used for profiled selection
		{
			EntryListData->List[entryIndex].icon = (MfwIcnAttr*)&situationIcon;   
			EntryListData->List[entryIndex].flagFunc = options_check;
		}
		else
		{
			EntryListData->List[entryIndex].icon = (MfwIcnAttr*)&colist;   
			EntryListData->List[entryIndex].flagFunc = item_flag_none ;
		}

	}



	// zhaowm 2002/12/13 add head title in the list menu.
	EntryListData->ListMenuFlag    =1;
	if ( prompt == 1)
		EntryListData->ListMenuHeadStr = (char *) MmiRsrcGetText(Txtonlinefunction);
	else if (( prompt == 0)||( prompt == 3))
		EntryListData->ListMenuHeadStr = (char *) MmiRsrcGetText(TxtSoftOptions);
	else
		EntryListData->ListMenuHeadStr = (char *) MmiRsrcGetText(TxtLIST);

	/* Fill common parameters for list handling */


	EntryListData->ListLength       = no_of_entries;

	//zhaowm 2002.11.28 changed 

	//EntryListData->CursorPosition	= 1;										// Starting position
	EntryListData->ListPosition     = pos+1;
	//if (pos>3)                                                                
	//	EntryListData->CursorPosition = pos-3;									// Make sure highlighted is on screen
	//EntryListData->SnapshotSize		= 5;										// 5 entries on the screen at once
	//EntryListData->Font				= 0;


	if (EntryList->type==WAP_PROFILES_LIST || EntryList->type==WAP_OPTIONS_LIST)		// For these lists, left soft key is Select
		EntryListData->LeftSoftKey  = TxtSoftSelect;
	else
		EntryListData->LeftSoftKey	= TxtSoftOptions;

	EntryListData->RightSoftKey = TxtSoftBack;
	EntryListData->KeyEvents    = KEY_CALL | KEY_HUP | KEY_RIGHT | KEY_LEFT | KEY_MNUUP | KEY_MNUDOWN|KEY_OK;
	EntryListData->Reason       = 0;
	EntryListData->Strings      = TRUE;											// Use strings not text ID's
	EntryListData->Attr         = &list_menuAttrib;
	EntryListData->autoDestroy  = FALSE;										// Don't destroy on exit

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("Display list");
#endif
	listDisplayListMenu(win, EntryListData, (ListCbFunc)Callback,0);				// Display the list

	return EntryListData;
}


/*******************************************************************************

 $Function:    	AUI_entry_goto

 $Description:	Open up the selected bookmark/history entry in the WAP browser
 
 $Returns:		

 $Arguments:	identifier	- specifies whether history or bookmarks list
 
*******************************************************************************/

int AUI_entry_goto(WAP_LIST_TYPE identifier)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_entry_goto");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	switch (identifier)
	{
	case WAP_BOOKMARKS_LIST:
	case WAP_HISTORY_LIST:
		AUI_connect_URL(data->win, data->URLSelect);						// The selected menu item is the new URL
		break;
	}

	return MFW_EVENT_CONSUMED;  
}


/*******************************************************************************

 $Function:    	AUI_entry_delete

 $Description:	Delete the selected entry from the history/bookmarks list
 
 $Returns:		

 $Arguments:	identifier	- specifies history list or bookmarks list	
 
*******************************************************************************/

int AUI_entry_delete(UBYTE identifier)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// Options menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for options menu
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_DISPLAY_DATA  display_info;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_entry_delete");
#endif

	dialog_info_init(&display_info);//gdy add
	display_info.KeyEvents      = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
	display_info.TextId         = NULL;//TxtPressOk;									// "Press OK to"
	display_info.TextId2        = TxtDelete;									// "Delete"
	display_info.TextString     = NULL;
	display_info.TextString2    = NULL;
	display_info.LeftSoftKey    = TxtSoftOK;									// Soft keys
	display_info.RightSoftKey   = TxtSoftBack;
	display_info.Time           = FOREVER;
	display_info.Callback       = (T_VOID_FUNC)AUI_entry_delete_cb;
	display_info.Identifier     = identifier;									// Type of list
	display_info.iconindex          =REMIND_REQUIRE;

	info_dialog(win, &display_info);

	return MFW_EVENT_CONSUMED;  
}


/*******************************************************************************

 $Function:    	AUI_entry_delete_cb

 $Description:	Callback function for delete confirmation
 
 $Returns:		

 $Arguments:	win			- WAP data window
				identifier	- Type of list
				reason		- reason for callback	
 
*******************************************************************************/

void AUI_entry_delete_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_entry_delete_cb");
#endif

	switch (identifier)
	{
	case WAP_DELETE_BOOKMARK:
		switch (reason)
		{
		case INFO_KCD_LEFT:
			ATB_wap_entry_remove(View->Bookmarks, data->OptionSelect);	   // Delete the selected bookmark name
			ATB_wap_entry_remove(View->BookmarksURL, data->OptionSelect);  // Delete the selected bookmark URL
			ATB_wap_profile_save(View);									// Save change to flash
			AUI_destroy(win,OPTIONS_WIN | LIST_WIN);					// Destroy options window and list window
			AUI_entry_list(data->win, View->Bookmarks, (ListCbFunc)AUI_bookmarks_list_cb,0,2); // Recreate list
			AUI_info_dialog(data->win, NULL, TxtDeleted);			// Say "Entry Deleted"
			break;
		case INFO_KCD_RIGHT:
		case INFO_KCD_CLEAR:
			break;
		default:
			break;
		}
		break;

	case WAP_DELETE_HISTORY:
		switch (reason)
		{
		case INFO_KCD_LEFT:
			ATB_wap_entry_remove(View->History, data->OptionSelect);	// Delete the selected history entry name
			ATB_wap_entry_remove(View->HistoryURL, data->OptionSelect);	// Delete the selected history entry URL
			ATB_wap_profile_save(View);									// Save change to flash
			//ATB_wap_renumber_history(View->History);					// Renumber history list
			AUI_destroy(win, OPTIONS_WIN | LIST_WIN);					// Destroy options window and list window
			AUI_entry_list(data->win, View->History, (ListCbFunc)AUI_history_list_cb,0,2);	// Recreate list
			AUI_info_dialog(data->win, NULL, TxtDeleted);			// Say "Entry Deleted"
		case INFO_KCD_RIGHT:
		case INFO_KCD_CLEAR:
			break;
		default:
			break;
		}
		break;

	case WAP_CLEAR_HISTORY:
		switch (reason)
		{
		case INFO_KCD_LEFT:
			ATB_wap_entry_remove_all(View->History);					// Delete all history name entries
			ATB_wap_entry_remove_all(View->HistoryURL);					// Delete all history URL entries
			ATB_wap_profile_save(View);									// Save change to flash
			AUI_entry_list(data->win, View->History, (ListCbFunc)AUI_history_list_cb,0,2);	// Recreate list
			break;
		case INFO_KCD_RIGHT:
		case INFO_KCD_CLEAR:
			break;
		default:
			break;
		}

	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_entry_sendSMS

 $Description:	Open up an SMS editing screen with the selected URL
 
 $Returns:		

 $Arguments:	none
 
*******************************************************************************/

int AUI_entry_sendSMS(void)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_SmsUserData   UserData;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_entry_sendSMS");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	if (data->URLSelect[0] == 0x80)		 //zhaowm 2003.0408
		wstrncpy((char *)UserData.TextBuffer, data->URLSelect, wstrlen(data->URLSelect));
	else
		strcpy((char *)UserData.TextBuffer, data->URLSelect);						// Copy name into SMS editing buffer
	*(UserData.NumberBuffer) = NULL;											// No number...
	*(UserData.CentreBuffer) = NULL;											// or service centre supplied.

	UserData.called_from_reply_item = FALSE;    
	UserData.Send_state =E_FORWARD;

	//data->edit_win = SmsSend_SEND_start(win, &UserData);						// Start editing SMS
	SmsSend_SEND_start(win, (T_SmsUserData *)&UserData);						// Start editing SMS

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_profile_name_edit

 $Description:	Opens up a text edit screen for editing the name of a profile
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_profile_name_edit(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_profile_name_edit");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	if (data->View->Profile->Title[0] == 0x80)	 //zhaowm 2003.03.14
		wstrncpy(data->Buffer, data->View->Profile->Title, wstrlen(data->View->Profile->Title));
	else
		strcpy(data->Buffer, data->View->Profile->Title);							// Copy name into editing buffer

	// Set up editor

	//AUI_standard_editor(&editor_data, data->Buffer, PROFILENAME_MAX_LEN, ALPHA_MODE, (T_EDIT_CB)AUI_profile_name_edit_cb);
	/* 2003/12/04 sunsj modify */
	AUI_standard_editor(&editor_data, data->Buffer, CARD_TITLE_MAX_LEN, TEXTINPUT_MODE, (T_EDIT_CB)AUI_profile_name_edit_cb);

	//editor_data.TextId				= TxtProfileName;							// "Profile Name:"
	editor_data.editor_attr.title_id   =TxtEditName;							//zhaowm 2002.11.28 "TextId" not used for title.
	editor_data.min_enter           = 1;										// Avoid returning empty strings
	editor_data.InputMode = LOWERCASE_INPUT_MODE;

	data->edit_win = text_input(win, &editor_data);
	text_input_flag = 1;

//	data->edit_win = editor_start(win, &editor_data);							// Create input window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_profile_name_edit_cb

 $Description:	Callback function for editing a profile's title
 
 $Returns:		void

 $Arguments:	parent_win	- the WAP data window
				identifier	- identifier for the edit type (just 0 so far)
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_profile_name_edit_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// Get data again from win
	T_WAP_VIEW  *View       = data->View;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION(" AUI_profile_name_edit_cb");
#endif

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		AUI_destroy(data->win, EDIT_WIN);									// Right soft key kills editor
		break;

	case INFO_KCD_LEFT:
		ATB_wap_entry_change(WAP_PROFILES_LIST, View->ProfilesList, data->Buffer, View->ProfileId);	 // Change profile name
		ATB_wap_profile_save(View);											// Save change to flash
		AUI_destroy(data->win,OPTIONS_WIN | LIST_WIN | EDIT_WIN);			// Destroy options window and list window
		AUI_entry_list(data->win, View->ProfilesList, (ListCbFunc)AUI_profiles_setup_cb,View->ProfileId,2);	// List profiles again
		AUI_info_dialog(data->win, NULL,TxtChanged);						// Display "Changed" message
	default:
		break;
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_dialupNumber

 $Description:	Opens up a numeric edit screen for editing the dialup number
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_dialupNumber(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_dialup_number");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	strcpy(data->Buffer, data->View->Profile->DialupNumber);					// Copy dialup number into buffer
	AUI_number_edit(win, WAP_DIALUP_NUMBER, TxtDialupNumber);					// Open editor

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_IPAddress1

 $Description:	Opens up a numeric edit screen for editing the primary IP address
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_IPAddress1(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_IPAddress1");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	strcpy(data->Buffer, data->View->Profile->IPAddress1);						// Copy IP address into edit buffer

	// Set up editor

	AUI_standard_editor(&editor_data, data->Buffer, IPADDRESS_MAX_LEN, IPADDRESS_MODE, (T_EDIT_CB)AUI_number_edit_cb);
	editor_data.Identifier          = WAP_IP_ADDRESS1;             
	//editor_data.TextId				= TxtIPAddress1;
	editor_data.editor_attr.title_id   =TxtIPAddress1;							//zhaowm 2002.11.28 "TextId" not used for title.
	editor_data.min_enter           = 1;										// Avoid returning empty strings
	editor_data.FormatString        = "NNN\\.NNN\\.NNN\\.NNN";      
	data->edit_win = editor_start(win, &editor_data);							// Create input window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_IPAddress2

 $Description:	Opens up a numeric edit screen for editing the secondary IP address
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_IPAddress2(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_IPAddress2");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	strcpy(data->Buffer, data->View->Profile->IPAddress2);						// Copy IP address into edit buffer

	// Set up editor

	AUI_standard_editor(&editor_data, data->Buffer, IPADDRESS_MAX_LEN, IPADDRESS_MODE, (T_EDIT_CB)AUI_number_edit_cb);
	editor_data.Identifier          = WAP_IP_ADDRESS2;             
	//editor_data.TextId				= TxtIPAddress2;
	editor_data.editor_attr.title_id   =TxtIPAddress2;							//zhaowm 2002.11.28 "TextId" not used for title.
	editor_data.min_enter           = 1;										// Avoid returning empty strings
	editor_data.FormatString        = "NNN\\.NNN\\.NNN\\.NNN";      
	data->edit_win = editor_start(win, &editor_data);							// Create input window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_Port1

 $Description:	Opens up a numeric edit screen for editing the primary port
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_Port1(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_Port1");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	sprintf(data->Buffer, "%d", data->View->Profile->Port1);					// Copy response timer into buffer
	AUI_number_edit(win, WAP_PORT1, TxtPort1);							// Open editor

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_Port2

 $Description:	Opens up a numeric edit screen for editing the secondary port
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_Port2(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_Port2");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	sprintf(data->Buffer, "%d", data->View->Profile->Port2);					// Copy response timer into buffer
	AUI_number_edit(win, WAP_PORT2, TxtPort2);									// Open editor

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_APN

 $Description:	Opens up a numeric edit screen for editing the APN
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_APN(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_APN");
#endif

	AUI_edit(NULL,WAP_EDIT_APN, TxtAPN, URL_MAX_LEN);

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_username

 $Description:	Opens up a text edit screen for editing the ISP username
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_username(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_username");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	strcpy(data->Buffer, data->View->Profile->Username);						// Copy name into editing buffer

	// Set up editor

	AUI_standard_editor(&editor_data, data->Buffer, USERNAME_MAX_LEN+3, TEXTINPUT_MODE, (T_EDIT_CB)AUI_username_cb);

	//editor_data.TextId				= TxtISPUsername;							// "Username"
	editor_data.editor_attr.title_id   =TxtISPUsername;							 //zhaowm 2002.11.28 "TextId" not used for title.
	editor_data.hide                = FALSE;
	editor_data.InputMode = LOWERCASE_INPUT_MODE;

	data->edit_win = text_input(win, &editor_data);
	text_input_flag = 1;
//	data->edit_win = editor_start(win, &editor_data);							// Create input window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_username_cb

 $Description:	Callback function for editing the ISP username
 
 $Returns:		void

 $Arguments:	parent_win	- the WAP data window
				identifier	- identifier for the edit type (just 0 so far)
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_username_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// Get data again from win

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION(" AUI_username_cb");
#endif

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		AUI_destroy(data->win, EDIT_WIN);									// Right soft key kills editor
		break;

	case INFO_KCD_LEFT:
		AUI_destroy(data->win, EDIT_WIN);									// Kill editor
		strcpy(data->View->Profile->Username, data->Buffer);				// Change username
		ATB_wap_profile_save(data->View);									// Save change to flash
		AUI_info_dialog(data->win, NULL, TxtChanged);						// Display "Changed" message
	default:
		break;
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_password

 $Description:	Opens up a text edit screen for editing the ISP password
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_password(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_password");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	strcpy(data->Buffer, data->View->Profile->Password);						// Copy password into editing buffer

	// Set up editor

	AUI_standard_editor(&editor_data, data->Buffer, PASSWORD_MAX_LEN+3, SHUZI_MODE, (T_EDIT_CB)AUI_password_cb);

	//editor_data.TextId				= TxtISPPassword;							// "Password"
	editor_data.editor_attr.title_id   =TxtISPPassword;							 //zhaowm 2002.11.28 "TextId" not used for title.
	editor_data.hide                = TRUE;										// Password is hidden (*****)
//	editor_data.InputMode = LOWERCASE_INP
	data->edit_win = editor_start(win, &editor_data);							// Create input window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_password_cb

 $Description:	Callback function for editing the ISP password
 
 $Returns:		void

 $Arguments:	parent_win	- the WAP data window
				identifier	- identifier for the edit type (just 0 so far)
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_password_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// Get data again from win

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION(" AUI_password_cb");
#endif

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		AUI_destroy(data->win, EDIT_WIN);									// Right soft key kills editor
		break;

	case INFO_KCD_LEFT:
		AUI_destroy(data->win, EDIT_WIN);									// Kill editor
		strcpy(data->View->Profile->Password, data->Buffer);				// Change password
		ATB_wap_profile_save(data->View);									// Save change to flash
		AUI_info_dialog(data->win, NULL, TxtChanged);						// Display "Changed" message
	default:
		break;
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_response_timer

 $Description:	Opens up a numeric edit screen for editing the server number
			 
 $Returns:		none.

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

int AUI_response_timer(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// current menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for current menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_response_timer");
#endif

	win_data    = ((T_MFW_HDR *)win)->data;
	data        = (T_WAP_DATA *)win_data->user;									// WAP data

	sprintf(data->Buffer, "%d", data->View->Profile->ResponseTimer);			// Copy response timer into buffer
	AUI_number_edit(win, WAP_RESPONSE_TIMER, TxtResponseTimer);					// Open editor

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_number_edit

 $Description:	Opens up a numeric edit screen.
				The digits to be edited should be in data->Buffer.
			 
 $Returns:		none.

 $Arguments:	parent_win	- the WAP data window
				identifier	- specifies which edit screen it is (server no. etc)
				prompt		- prompt, e.g "IP Address"
 
*******************************************************************************/

int AUI_number_edit(T_MFW_HND parent_win, int identifier, int prompt)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_EDITOR_DATA   editor_data;

	// Set up editor

	AUI_standard_editor(&editor_data, data->Buffer, NUMBER_MAX_LEN+3, SHUZI_MODE, (T_EDIT_CB)AUI_number_edit_cb);

	editor_data.Identifier          = identifier;								// this is the purpose            
	//editor_data.TextId				= prompt;
	editor_data.editor_attr.title_id   =prompt;									//zhaowm 2002.11.28 "TextId" not used for title. 
	editor_data.min_enter           = 1;										// Avoid returning empty strings

	data->edit_win = editor_start(parent_win, &editor_data);					// Create input window

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_number_edit_cb

 $Description:	Callback function for editing a number
 
 $Returns:		void

 $Arguments:	parent_win	- the WAP data window
				identifier	- identifier for the edit type (server or service no.)
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_number_edit_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN       *win_data   = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA      *data       = (T_WAP_DATA *)win_data->user;						// WAP data
	T_WAP_VIEW      *View       = data->View;
	T_WAP_PROFILE   *Profile    = View->Profile;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_number_edit_cb");
#endif

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		AUI_destroy(data->win, EDIT_WIN);									// Just kill window if back pressed
		break;

	case INFO_KCD_LEFT:
		AUI_destroy(data->win, EDIT_WIN);
		switch (identifier)
		{
		case WAP_DIALUP_NUMBER:
			strcpy(Profile->DialupNumber, data->Buffer);				// Copy the dialup number to the Profile
			break;

		case WAP_IP_ADDRESS1:
			strcpy(Profile->IPAddress1, data->Buffer);					// Copy the IP address to the Profile
			break;

		case WAP_IP_ADDRESS2:
			strcpy(Profile->IPAddress2, data->Buffer);					// Copy the IP address to the Profile
			break;

		case WAP_PORT1:
			Profile->Port1 = atoi(data->Buffer);						// Copy the port number to the Profile
			break;

		case WAP_PORT2:
			Profile->Port2 = atoi(data->Buffer);						// Copy the port number to the Profile
			break;

		case WAP_RESPONSE_TIMER:
			Profile->ResponseTimer = atoi(data->Buffer);				// Read response timer number from buffer
			break;
		}
		ATB_wap_profile_save(View);											// Save change to flash
		AUI_info_dialog(data->win, NULL, TxtChanged);						// Display "Changed" message
		break;

	default:
		break;
	}

	return;
}


/*******************************************************************************

 $Function:    	MMI_AUI_homepage_edit

 $Description:	Opens up a text edit screen for changing the homepage URL
			 
 $Returns:		MFW_EVENT_CONSUMED

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_homepage_edit(MfwMnu* menu, MfwMnuItem* item)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_homepage_edit");
#endif

	AUI_edit(NULL,WAP_EDIT_HOMEPAGE, TxtEditURL, URL_MAX_LEN);

	return MFW_EVENT_CONSUMED;
}


/*******************************************************************************

 $Function:    	AUI_connectionType

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_connectionType(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_connectionType");
#endif
	WapTitle = TxtConnectionType;	//zhaowm 2002.12.08
	data->options_win = bookMenuStart(win, WAPConnectionTypeAttributes(), PhbkWap);
	SEND_EVENT(data->options_win, DEFAULT_OPTION, NULL, &data->View->Profile->ConnectionType); // Add our own callback

	return;
}


/*******************************************************************************

 $Function:    	AUI_connectionType_set

 $Description:	Set WAP connection to temporary or permanent
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_connectionType_set(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_connectionType_set");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	data->View->Profile->ConnectionType = menu->lCursor[menu->level];			// Change connection type
	ATB_wap_profile_save(data->View);											// Save change to flash
	AUI_info_dialog(win,NULL , TxtChanged);										// "Changed"

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_security

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_security(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_security_on");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	WapTitle = TxtSecurity;	  //zhaowm 2002.12.08
	data->options_win = bookMenuStart(win, WAPSecurityOptionAttributes(), PhbkWap);
	SEND_EVENT(data->options_win, DEFAULT_OPTION, NULL, &data->View->Profile->Security); // Add our own callback

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_security_set

 $Description:	Switch security on or off
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_security_set(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_security_off");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	data->View->Profile->Security = (BOOL)menu->lCursor[menu->level];
	ATB_wap_profile_save(data->View);											// Save change to flash	
	AUI_info_dialog(win,NULL , TxtChanged);										// "Changed"

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_access

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_access(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_access");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	WapTitle = TxtAccessType;	//zhaowm 2002.12.08
	data->options_win = bookMenuStart(win, WAPAccessTypeAttributes(), PhbkWap);
	SEND_EVENT(data->options_win, DEFAULT_OPTION, NULL, &data->View->Profile->AccessType); // Add our own callback

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_access_set

 $Description:	Set access type
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_access_set(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_access_CSD");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data

	data->View->Profile->AccessType  = menu->lCursor[menu->level];				// Change access type
	ATB_wap_profile_save(data->View);											// Save change to flash	
	AUI_info_dialog(win,NULL , TxtChanged);										// "Changed"

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_savehist

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_savehist(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	UBYTE           SaveHistory;

#ifdef TRACE_AUIWAP	
	TRACE_FUNCTION("AUI_savehist");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	WapTitle = TxtSaveHistory;	 //zhaowm 2002.12.08
	data->options_win = bookMenuStart(win, WAPSaveHistoryAttributes(), PhbkWap);
	SaveHistory = (data->View->Status & WAP_STATUS_SAVEHISTORY)/WAP_STATUS_SAVEHISTORY;	// 1 or 0 depending on flag
	SEND_EVENT(data->options_win, DEFAULT_OPTION, NULL, &SaveHistory); // Add our own callback

	return 1;
}

/*******************************************************************************

 $Function:    	AUI_savehist_set

 $Description:	Set save history on or off
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_savehist_set(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_savehist_set");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// Data for WAP browser

	if (menu->lCursor[menu->level])
		data->View->Status |= WAP_STATUS_SAVEHISTORY;
	else
		data->View->Status &= ~WAP_STATUS_SAVEHISTORY;

	ATB_wap_profile_save(data->View);											// Save change to flash
	AUI_info_dialog(win, NULL, TxtChanged);

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_scaleimages

 $Description:	Sets cursor position for this menu based on the current settings
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_scaleimages(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;
	UBYTE           ScaleImages;

#ifdef TRACE_AUIWAP	
	TRACE_FUNCTION("AUI_scaleimages");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// WAP data
	WapTitle = TxtScaleImages;	 //zhaowm 2002.12.08
	data->options_win = bookMenuStart(win, WAPScaleImagesAttributes(), PhbkWap);
	ScaleImages = (data->View->Status & WAP_STATUS_SCALEIMAGES)/WAP_STATUS_SCALEIMAGES;	// 1 or 0 depending on flag
	SEND_EVENT(data->options_win, DEFAULT_OPTION, NULL, &ScaleImages); // Add our own callback

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_scaleimages_set

 $Description:	Set image scaling on or off
 
 $Returns:		

 $Arguments:	menu		- pointer to the current menu
				item		- pointer to the current menu item
 
*******************************************************************************/

int AUI_scaleimages_set(MfwMnu* menu, MfwMnuItem* item)
{
	T_MFW_HND       parent_win      = mfwParent( mfw_header());					// WAP menu window
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	tBookStandard   *parent_data    = (tBookStandard *)win_data->user;			// data for WAP menu window
	T_MFW_HND       win             = parent_data->parent_win;					// WAP data window
	T_WAP_DATA      *data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_scaleimages_set");
#endif

	win_data        = ((T_MFW_HDR *)win)->data;
	data            = (T_WAP_DATA *)win_data->user;								// Data for WAP browser

	if (menu->lCursor[menu->level])
		data->View->Status |= WAP_STATUS_SCALEIMAGES;
	else
		data->View->Status &= ~WAP_STATUS_SCALEIMAGES;

	ATB_wap_profile_save(data->View);											// Save change to flash
	AUI_info_dialog(win,NULL , TxtChanged);

	return 1;
}


/*******************************************************************************

 $Function:    	AUI_info_dialog

 $Description:	Display message for three seconds
 
 $Returns:		

 $Arguments:	parent_win		- Parent window
				TextId 			- Id of text string to display
 
*******************************************************************************/

static void AUI_info_dialog(T_MFW_HND parent_win, USHORT TxtId1, USHORT TxtId2)
{
	T_DISPLAY_DATA  display_info;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_info_dialog");
#endif

	dialog_info_init(&display_info);//gdy add
	display_info.iconindex=0;
	display_info.BackColor=0xffffff;
	display_info.FontColor=0x000000;   
	display_info.Identifier=0; 
	display_info.KeyEvents      = NULL;
	display_info.TextId         = TxtId1;
	display_info.TextId2        = TxtId2;
	display_info.TextString     = NULL;
	display_info.TextString2    = NULL;
	display_info.LeftSoftKey    = NULL;
	display_info.RightSoftKey   = NULL;
	display_info.Time           = ONE_SECS;	 //zhaowm 29/12/02 THREE_SECS;
	display_info.Callback       = NULL;
	display_info.Identifier     = NULL;
	display_info.iconindex          =REMIND_COMPLETE;

	info_dialog(parent_win, &display_info);
	return;
}


/*******************************************************************************

 $Function:    	AUI_error_dialog

 $Description:	Display error message for three seconds
				SPR#1574 - SH - Add "GPRS not supported" message
 
 $Returns:		

 $Arguments:	View			- The current view
				errorCode		- Number of the error
 
*******************************************************************************/

void AUI_error_dialog(T_WAP_VIEW *View, SHORT errorCode)
{
	T_DISPLAY_DATA  display_info;
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data
	static char errorNumber[20];
	char *err;
	USHORT errId1, errId2;
	USHORT lsk, rsk;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_error_dialog");
#endif

#ifdef MMS_WAP_ENABLED
/*talcon add for mms*/
	if(View->object_id== 128)
	{
		handle_mms_queue_err(errorCode);
		return;
	}
#endif
	
	sprintf(errorNumber, "Error: %4x", errorCode);								// Convert the error code to text

	errId1 = 0;
	errId2 = 0;

	switch (errorCode)
	{
	case ERROR_GPRS_NOT_SUPPORTED:
		errId1 = TxtGPRS;
		errId2 = TxtNotSupported;
		break;
		/* SPR#1656 - SH - New error when call is disconnected */
	case ERROR_CALL_DISCONNECTED:
		errId1 = TxtConnecting;
		errId2 = TxtFailed;
		break;
	case 0:     err = "Unknown err"; break;
	case 3:
	case 4:
	case 5: err = "Not implemented"; break;
	case 6: err = "Unsupported"; break;
	case 7: err = "Overload"; break;
	case 8: err = "No response"; break;
	case 9: err = "Msg too large"; break;
	case 64: err = "Bad request"; break;
	case 65: err = "Unauthorized"; break;
	case 66: err = "Payment req."; break;
	case 67: err = "Forbidden"; break;
	case 68: err = "File not fnd"; break;
	case 69: err = "Not allowed"; break;
	case 70: err = "Not acceptable"; break;
	case 71: err = "Proxy Auth Req"; break;
	case 72:
	case 1009: err = "Req. timeout"; break;
	case 73: err = "HTTP Conflict"; break;
	case 1001:
	case 8002: err = "Out of mem."; break;    
	case 1005: err = "WML error"; break;
	case 1006: err = "Display error"; break;
	case 1007: err = "Card empty"; break;
	case 1008: err = "URL invalid"; break;
	case 8001: err = "Memory low"; break;
	default:
		err = "";
		if (errorCode<10)
			err = "WTP error";
		else if (errorCode<100)
			err = "HTTP error";
		else if (errorCode<1000)
			err = "WSP error";
		else if (errorCode<2000)
			err = "WAE error";
		else if (errorCode<3000)
			err = "WSPCL error";
		else if (errorCode<4000)
			err = "WSPCM error";
		else if (errorCode<5000)
			err = "WTP error";
		else if (errorCode<6000)
			err = "WTLS error";
		else if (errorCode<7000)
			err = "WDP error";
		else if (errorCode<8000)
			err = "UDCP error";
		break;
	}

	/* SPR#1575 - SH - Decide on soft keys.  If browser is not present,
	 * can only exit. */

	if (data->browser_win)
	{
		lsk = TxtReload;
		rsk = TxtSoftBack;
	}
	else
	{
		lsk = TxtNull;
		rsk = TxtExit;
	}
	errId1 =TxtNull;
	errId2 =TxtFailed;

	/* If a text tag has been provided, use it */

	// if (errId1!=0)
	//dlg_initDisplayData_TextId( &display_info, lsk, rsk, errId1, errId2);/*2003/12/13, wangyan modify*/
	dialog_info_init(&display_info);
	display_info.LeftSoftKey    = (USHORT)lsk;
	display_info.RightSoftKey   = (USHORT)rsk;
	display_info.TextId         = errId1;
	display_info.TextId2        = errId2;
	display_info.Time           = FOREVER;
	display_info.KeyEvents      = KEY_LEFT | KEY_RIGHT;
	//else
	//	dlg_initDisplayData_TextStr( &display_info, lsk, rsk, errorNumber, err);

	//dlg_initDisplayData_events( &display_info, NULL, FOREVER, KEY_LEFT | KEY_RIGHT);/*2003/12/13, wangyan modify*/

	/*
//	dialog_info_init(&display_info);//gdy add
	display_info.KeyEvents		= KEY_LEFT | KEY_RIGHT;
	display_info.TextId			= NULL;
	display_info.TextId2		= NULL;

	if (errId1!=0)
	   { display_info.TextString	= GET_TEXT(TxtGPRS);
		 display_info.TextString2	= GET_TEXT(TxtNotSupported);
		 }
	else
	   { display_info.TextString		= errorNumber;
		 display_info.TextString2	= err;
		 }
	display_info.LeftSoftKey	= TxtReload;
	display_info.RightSoftKey	= TxtSoftBack;
	display_info.Time			= FOREVER;
	display_info.Identifier		=NULL;// WAP_DIALOGE_ID;
	//display_info.iconindex          =REMIND_FAILURE;

	 */

	display_info.Callback       = (T_VOID_FUNC)AUI_error_cb;
	display_info. iconindex =REMIND_FAILURE;
	/* SPR#1739 - SH - Destroy any previous error dialog */
	if (data->error_win)
	{
		SEND_EVENT(data->error_win, DIALOG_DESTROY, 0, 0);
	}
	data->error_win = info_dialog(data->win, &display_info);

	return;
}


/*******************************************************************************

 $Function:    	AUI_error_cb

 $Description:	Callback function for the WAP error dialog.
 
 $Returns:		void

 $Arguments:	win			- the WAP data window
				identifier	- this is the dialog id
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_error_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;					// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_error_cb");
#endif

	data->error_win = NULL;				/* SPR#1739 - SH - Coming here, dialog is destroyed */
	data->update_forbid = FALSE;

	/* Destroy any connecting dialog */
	/* SPR#1739 - SH - Do this now with AUI_destroy */

	AUI_destroy(data->win, CONNECT_WIN);

	/* SPR#1497 - SH - Softkeys now give two options */
	switch (reason)
	{
	/* Right soft key: Back*/
	case INFO_KCD_RIGHT:
		if (data->browser_win && data->View)
		{
			ATB_wap_card_go_back(data->View);
		}
		else	/* Connecting failed, exit */
		{
			AUI_destroy(win, ALL_WIN);

		}
		break;

		/* Left soft key: Reload */
	case INFO_KCD_LEFT:
		TRACE_EVENT_P1("URL: %s", data->View->URL);
		/* SPR#1656 - SH - If browser window is not present, try
		 * to connect again */
		if (data->browser_win)
		{
			ATB_wap_card_refresh(data->View);
		}
		else
		{
			AUI_connect_URL(data->win, data->View->URL);
		}
		break;
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_standard_editor

 $Description:	Sets up standard attributes for a WAP editor
 
 $Returns:		

 $Arguments:	editor_data		- pointer to existing editor_data
				size 			- maximum length of editor
				mode			- editor mode
				callback		- callback function
 
*******************************************************************************/

static void AUI_standard_editor(T_EDITOR_DATA *editor_data, char *buffer, U16 size, UBYTE mode, T_EDIT_CB callback)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_standard_editor");
#endif

	editor_data->editor_attr.win.px     = WAP_EDITOR_LEFT;						// Bounds of edit window
	editor_data->editor_attr.win.py     = WAP_EDITOR_TOP;
	editor_data->editor_attr.win.sx     = WAP_EDITOR_RIGHT;
	editor_data->editor_attr.win.sy     = WAP_EDITOR_BOTTOM;
	editor_data->editor_attr.fgColor    = 0xffffff;									// Foreground colour
	editor_data->editor_attr.font       = 0;									// Font
	editor_data->editor_attr.mode       = edtCurBar1;							// Normal cursor mode
	editor_data->editor_attr.controls   = 0;
	editor_data->editor_attr.titleMode  =1;										//zhaowm 2002.11.28 add title
	//editor_data->editor_attr.title_id = '\0';
	editor_data->editor_attr.textnum   = NULL;   
	editor_data->LeftSoftKey            = TxtSoftOK;							// Default: LSK is "OK"               
	editor_data->AlternateLeftSoftKey   = TxtSoftOK;							/* 2004/05/28 sunsj modify */
	editor_data->RightSoftKey           = TxtDelete;							// Default: RSK is "Delete"
	editor_data->timeout                = FOREVER;								// Default: no timeout for editor
	editor_data->destroyEditor          = FALSE;								// Default: don't destroy editor on exit
	editor_data->hide                   = FALSE;								// Default: input not hidden
	editor_data->Identifier             = NULL;									// Default: not used
	editor_data->min_enter              = 0;									// Minimum no. of characters
	editor_data->TextId                 = NULL;									// Default: no text
	editor_data->TextString             = NULL;
	editor_data->edtInPbk               = 0;

	editor_data->editor_attr.text       = buffer;								// Input buffer
	editor_data->Callback               = callback;
	editor_data->editor_attr.size       = size;
	editor_data->mode                   = mode;


	return;
}



/*******************************************************************************

 $Function:    	AUI_wap_input_dialog_open

 $Description:	Prompts the MMI to open an input dialog given a particular format and
				string.
				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	Dialog			- Dialog information
				View			- The current view
 
*******************************************************************************/

T_WAP_RES AUI_wap_input_dialog_open(T_WAP_MMI_INPUT_DIALOG_REQ *Dialog, T_WAP_VIEW *View)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data
	USHORT          formatIndex;
	USHORT          bufferIndex;
	USHORT          bufferLength;												// Length of original buffer

	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_input_dialog_open");
#endif
	TRACE_EVENT("AUI_wap_input_dialog_open_zhao");
	data->gen_pointer = Dialog->dialog_pointer;									// Needed by GLE

	if (Dialog->input_length > INPUT_MAX_LEN)									// Crop input to max length
	{
		Dialog->input_length = INPUT_MAX_LEN;
		*(Dialog->Input+INPUT_MAX_LEN) = NULL;
	}

	if (Dialog->size > INPUT_MAX_LEN)											// No more than max chars accepted
		Dialog->size = INPUT_MAX_LEN;
	memset(data->Buffer, 0, (INPUT_MAX_LEN+1)*sizeof(char));//zhaowm 2003.0401
	if (Dialog->is_password)
		ATB_ushort2char_old(data->Buffer, Dialog->Input, (USHORT)Dialog->input_length);	// Convert current input to char type, store in input buffer
	else
		ATB_ushort2char(data->Buffer, Dialog->Input, (USHORT)Dialog->input_length);	// Convert current input to char type, store in input buffer

	//ATB_ushort2char(data->Message, Dialog->Title, (USHORT)Dialog->title_length);       // Convert title to char, store in output buffer
	ATB_ushort2char_old(data->Message, Dialog->Title, (USHORT)Dialog->title_length);	   // Convert title to char, store in output buffer
	ATB_crop_text(data->Message, strlen(data->Message), WAP_SCREEN_WIDTH);		// Crop message to fit
	ATB_ushort2char(data->Format, Dialog->Format, (USHORT)Dialog->format_length);	// Convert format string to char, store in format buffer
//	ATB_ushort2char_old(data->Format, Dialog->Format, (USHORT)Dialog->format_length);   // Convert format string to char, store in format buffer

	/* 2003/12/04 sunsj */
	AUI_standard_editor(&editor_data, data->Buffer, (Dialog->size)+3, TEXTINPUT_MODE, (T_EDIT_CB)AUI_input_cb);

	editor_data.editor_attr.title_id   =Txtnotitle; 
	// Need to set input mode & put fixed characters into input buffer

	if (Dialog->format_length != 0)												// If we're using formatted input
	{

		/* 2003/12/04 sunsj */
		editor_data.mode            = TEXTINPUT_MODE;								// Special mode for formatted input
		formatIndex = 0;
		bufferIndex = 0;

		if (data->Buffer[0] == 0x80)
		{
			bufferLength = wstrlen(data->Buffer)-1;

			while (formatIndex<(wstrlen(data->Format))-1)
			{
				if (*(data->Format+formatIndex) == '\\')							// Backslash character indicates fixed char
				{
					formatIndex++;
					*(data->Buffer+bufferIndex) = *(data->Format+formatIndex);		// Put fixed char into buffer
				}
				else if (strchr("123456789*", *(data->Format+formatIndex)))			// In a delimited field...
				{
					if (bufferIndex<bufferLength)									// if we're not at the end of the string, 
						formatIndex--;												// stay where we are in the formatstring
					else
						formatIndex++;												// otherwise go to end of string
				}
				else if (bufferIndex>=bufferLength)									// If we're past the end of the existing buffer...
				{
					//*(data->Buffer+bufferIndex) = ' ';								// Fill it with empty space
				}
				bufferIndex++;
				formatIndex++;
			}

			*(data->Buffer+bufferIndex) = 0x00;										// Terminate the buffer string
			*(data->Buffer+bufferIndex+1) = 0x00;										// Terminate the buffer string
		}

		else
		{
			bufferLength = strlen(data->Buffer);

			while (formatIndex<(wstrlen(data->Format))-1)
			{
				if (*(data->Format+formatIndex) == '\\')							// Backslash character indicates fixed char
				{
					formatIndex++;
					*(data->Buffer+bufferIndex) = *(data->Format+formatIndex);		// Put fixed char into buffer
				}
				else if (strchr("123456789*", *(data->Format+formatIndex)))			// In a delimited field...
				{
					if (bufferIndex<bufferLength)									// if we're not at the end of the string, 
						formatIndex--;												// stay where we are in the formatstring
					else
						formatIndex++;												// otherwise go to end of string
				}
				else if (bufferIndex>=bufferLength)									// If we're past the end of the existing buffer...
				{
					//*(data->Buffer+bufferIndex) = ' ';								// Fill it with empty space
				}
				bufferIndex++;
				formatIndex++;
			}

			*(data->Buffer+bufferIndex) = NULL;										 // Terminate the buffer string
		}
	}

	editor_data.Identifier          = Dialog->dialog_id;						// this is the dialog identity (to be passed to callback)
	editor_data.TextString          = data->Message;							// String to be displayed in output buffer
	editor_data.FormatString        = data->Format;								// Provide the editor with the format string

	if (Dialog->is_password)
	{
		editor_data.hide            = TRUE; 
	}

	if (!Dialog->empty_ok)
		editor_data.min_enter       = 1;										// Won't accept empty input
	TRACE_EVENT("zhaoem_temp");
	data->edit_win = text_input(data->win, &editor_data);
	text_input_flag = 1;

//	data->edit_win = editor_start(data->win, &editor_data);						// Create input window

	return WAP_OK;
}


/*******************************************************************************

 $Function:    	AUI_input_cb

 $Description:	Callback function for the WAP input dialog.
 
 $Returns:		void

 $Arguments:	win			- the WAP data window
				identifier	- this is the dialog id
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_input_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// WAP data
	T_MMI_WAP_INPUT_DIALOG_CNF DialogCnf;
	BOOL        edited;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_input_cb");
#endif
	TRACE_EVENT("AUI_input_cb_zhao");

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		edited = FALSE;														// Don't change text
		break;

	default:
		edited = TRUE;														// Text is changed
		break;
	}
	DialogCnf.object_id     = data->View->object_id;
	DialogCnf.dialog_id     = identifier;										// Dialog id is passed from AUI_input
	DialogCnf.Text          = (USHORT *)AUI_wap_memory_alloc((wstrlen(data->Buffer)+1)*sizeof(USHORT));
	if (data->Buffer[0] == 0x80)
		DialogCnf.text_length   = ATB_uni2ushort(DialogCnf.Text, data->Buffer);		// ..and now updated input string
	else
		DialogCnf.text_length	= ATB_char2ushort(DialogCnf.Text, data->Buffer);	// ..and now updated input string
	DialogCnf.edited        = edited;											// TRUE if text changed
	DialogCnf.dialog_pointer    = data->gen_pointer;							// Needed by GLE

	ATB_wap_input_dialog_closed(&DialogCnf);							// Send data to ATB

	AUI_wap_memory_free((UBYTE *)DialogCnf.Text, (wstrlen(data->Buffer)+1)*sizeof(USHORT));

	AUI_destroy(data->win,EDIT_WIN);											// Destroy edit window
	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_password_dialog_open

 $Description:	Prompts the MMI to open a password dialog.
				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	Dialog			- Dialog information
				View			- The current view
 
*******************************************************************************/

T_WAP_RES AUI_wap_password_dialog_open(T_WAP_MMI_PASSWORD_DIALOG_REQ *Dialog,T_WAP_VIEW *View)
{
	T_WAP_DATA 		*data		= View->UIdata;
#ifdef NEW_EDITOR
	T_AUI_EDITOR_DATA editor_data;
#else
	T_EDITOR_DATA	editor_data;
#endif /* NEW_EDITOR */
	USHORT			titlelen;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_password_dialog_open");
#endif

	if (!data)
	{
		return WAP_FAIL;
	}

	/* SPR#2393 - Clear buffer */
	
	memset(data->Buffer, 0, USERNAME_MAX_LEN+1);	/* Input field is char type */
	
	/* Need to prompt for two separate things: the username and password! */

#ifdef NEW_EDITOR
	AUI_standard_editor(&editor_data, Dialog->dialog_id, ED_MODE_ALPHA, TxtISPUsername, (T_AUI_EDIT_CB)AUI_password_cb_1);
	AUI_edit_SetBuffer(&editor_data, ATB_DCS_ASCII, (UBYTE *)data->Buffer, USERNAME_MAX_LEN+1);
	AUI_edit_SetTextStr(&editor_data, TxtSoftOK, TxtDelete, TxtISPUsername, NULL);

	/* Don't update WAP browser window while editor is open */
	
	data->update_forbid = TRUE;
	
	data->edit_win = AUI_edit_Start(data->win, &editor_data);
#else /* NEW_EDITOR */
	AUI_standard_editor(&editor_data, data->Buffer, USERNAME_MAX_LEN, ALPHA_MODE, (T_EDIT_CB)AUI_password_cb_1);

	editor_data.Identifier = Dialog->dialog_id; /* this is the dialog identity (to be passed to callback) */
	editor_data.TextId = TxtISPUsername; /* SPR#2393 */
	
	/* Don't update WAP browser window while editor is open */
	data->update_forbid = TRUE;
	
	data->edit_win = editor_start(data->win, &editor_data);
#endif /* NEW_EDITOR */

	return WAP_OK;
}


/*******************************************************************************

 $Function:    	AUI_password_cb_1

 $Description:	Callback function for the WAP password dialog, after username entered.
				Prompts for password.
 
 $Returns:		void

 $Arguments:	win			- the WAP data window
				identifier	- this is the dialog id
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_password_cb_1(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// WAP data
	T_EDITOR_DATA   editor_data;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_password_dialog_cb_1");
#endif
	TRACE_EVENT("AUI_password_dialog_cb_1_zhao");

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		AUI_destroy(data->win,EDIT_WIN);									// Destroy edit window
		break;

	case INFO_KCD_LEFT:
		*(data->Buffer2) = NULL;											// Empty string for password

		AUI_standard_editor(&editor_data, data->Buffer2, PASSWORD_MAX_LEN+3, SHUZI_MODE,
							(T_EDIT_CB)AUI_password_cb_2);

		editor_data.Identifier  = identifier;								// this is the dialog identity
		editor_data.TextString  = data->Message;
		editor_data.hide        = TRUE;

		data->temp_win = data->edit_win;									// Store pointer to this edit window
		data->edit_win = editor_start(data->win, &editor_data);				// Create input window

		return;
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_password_cb_2

 $Description:	Callback function for the WAP password dialog.
 
 $Returns:		void

 $Arguments:	win			- the WAP data window
				identifier	- this is the dialog id
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_password_cb_2(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// WAP data
	T_MMI_WAP_PASSWORD_DIALOG_CNF DialogCnf;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_password_cb_2");
#endif
	TRACE_EVENT("AUI_password_cb_2_zhao");

	switch (reason)
	{
	case INFO_KCD_HUP:
	case INFO_KCD_RIGHT:
		AUI_destroy(data->win,EDIT_WIN);									// Destroy this edit window
		data->edit_win = data->temp_win;									// Reinstate previous edit window
		break;

	case INFO_KCD_LEFT:
		DialogCnf.object_id     = data->View->object_id;
		DialogCnf.dialog_id     = identifier;
		DialogCnf.input_length  = strlen(data->Buffer);
		DialogCnf.Input         = data->Buffer;
		DialogCnf.password_length  = strlen(data->Buffer2);
		DialogCnf.Password      = data->Buffer2;
		AUI_destroy(data->win,EDIT_WIN);									// Destroy 2nd edit window
		data->edit_win = data->temp_win;
		AUI_destroy(data->win,EDIT_WIN);									// Destroy 1st edit window
		ATB_wap_password_dialog_closed(&DialogCnf);
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_confirm_dialog_open

 $Description:	Prompts the MMI to open a confirmation dialog.
				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	Dialog			- Dialog information
				View			- The current view
 
*******************************************************************************/

T_WAP_RES AUI_wap_confirm_dialog_open(T_WAP_MMI_CONFIRM_DIALOG_REQ *Dialog, T_WAP_VIEW *View)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data


	T_DISPLAY_DATA  display_info;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_confirm_dialog_open");
#endif
	TRACE_EVENT("AUI_wap_confirm_dialog_open_zhao");

	ATB_ushort2char(data->Message, Dialog->Message, Dialog->message_length);	// Convert current input to char type, store in output buffer
	ATB_ushort2char(data->LeftSoftKey, Dialog->Ok_key, Dialog->ok_key_length);
	ATB_ushort2char(data->RightSoftKey, Dialog->Cancel_key, Dialog->cancel_key_length);

	display_info.KeyEvents      = KEY_CLEAR | KEY_LEFT | KEY_RIGHT;
	display_info.TextId         = NULL;
	display_info.TextId2        = NULL;
	display_info.TextString     = data->Message;
	display_info.TextString2    = NULL;
	display_info.LeftSoftKey    = TxtNull;										// Softkeys are assigned via strings, so
	display_info.RightSoftKey   = TxtNull;										// these assignations are null
	display_info.LSKString      = data->LeftSoftKey;
	display_info.RSKString      = data->RightSoftKey;
	display_info.Time           = FOREVER;
	display_info.Callback       = (T_VOID_FUNC)AUI_confirm_cb;
	display_info.Identifier     = Dialog->dialog_id;

	info_dialog_softkeystrings (data->win, &display_info);						// Info dialog with cust. soft keys
	return WAP_OK;
}


/*******************************************************************************

 $Function:    	AUI_confirm_cb

 $Description:	Callback function for the WAP confirmation dialog.
 
 $Returns:		void

 $Arguments:	win			- the WAP data window 
				identifier	- this is the dialog id
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_confirm_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// WAP data
	T_MMI_WAP_CONFIRM_DIALOG_CNF DialogCnf;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_confirm_cb");
#endif
	TRACE_EVENT("AUI_confirm_cb_zhao");

	switch (reason)
	{
	case INFO_KCD_HUP:
		AUI_destroy(data->win,EDIT_WIN);									// Destroy edit window
		break;

	case INFO_KCD_RIGHT:
		DialogCnf.dialog_id = identifier;									// Dialog id is passed from AUI_input
		DialogCnf.answer    = FALSE;										// Confirmation is false

		AUI_destroy(data->win,EDIT_WIN);									// Destroy edit window
		ATB_wap_confirm_dialog_closed(&DialogCnf);							// Send data to ATB
		break;

	case INFO_KCD_LEFT:
		DialogCnf.dialog_id = identifier;									// Dialog id is passed from AUI_input
		DialogCnf.answer    = TRUE;											// Confirmation is true
		AUI_destroy(data->win,EDIT_WIN);									// Destroy edit window
		ATB_wap_confirm_dialog_closed(&DialogCnf);							// Send data to ATB
		break;
	}
	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_info_dialog_open

 $Description:	Prompts the MMI to open an info dialog.
				
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	Dialog			- Dialog information
				View			- The current view
 
*******************************************************************************/

T_WAP_RES AUI_wap_info_dialog_open(T_WAP_MMI_INFO_DIALOG_REQ *Dialog, T_WAP_VIEW *View)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data
	T_DISPLAY_DATA  display_info;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_info_dialog_open");
#endif
	TRACE_EVENT("AUI_wap_info_dialog_open_zhao");

	ATB_ushort2char(data->Message, Dialog->Message, Dialog->message_length);	// Store message in output buffer as char

	dialog_info_init(&display_info);//gdy add
	display_info.KeyEvents      = NULL;
	display_info.TextId         = NULL;
	display_info.TextId2        = NULL;
	display_info.TextString     = data->Message;
	display_info.TextString2    = NULL;
	display_info.LeftSoftKey    = NULL;
	display_info.RightSoftKey   = NULL;
	display_info.Time           = ONE_SECS;	//zhaowm 29/12/02 THREE_SECS;
	display_info.Callback       = (T_VOID_FUNC)AUI_info_cb;
	display_info.Identifier     = NULL;

	info_dialog(data->win, &display_info);

}


/*******************************************************************************

 $Function:    	AUI_info_cb

 $Description:	Callback function for the WAP confirmation dialog.
 
 $Returns:		void

 $Arguments:	win			- the WAP data window
				identifier	- this is the dialog id
				reason		- reason for callback
 
*******************************************************************************/

static void AUI_info_cb(T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;					// WAP data
	T_MMI_WAP_CONFIRM_DIALOG_CNF DialogCnf;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_info_cb");
#endif
	TRACE_EVENT("AUI_info_cb");

	DialogCnf.dialog_id = identifier;										// Dialog id is passed from AUI_input
	DialogCnf.answer    = TRUE;												// Confirmation is true
	AUI_destroy(data->win,EDIT_WIN);										// Destroy edit window
	ATB_wap_confirm_dialog_closed(&DialogCnf);								// Send data to ATB

	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_options_menu_open

 $Description:	The ATB will send to the AUI the contents of the menu list
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 $Arguments:	contextType	- the context, to specify the first item in the menu
 
*******************************************************************************/

T_WAP_RES AUI_wap_options_menu_open(UBYTE contextType)
{
	T_MFW_HND       browser_win         = mfwParent( mfw_header());				// Current window will be WAP browser
	T_MFW_WIN       *browser_win_data   = ((T_MFW_HDR *)browser_win)->data;
	T_WAP_BROWSER   *browser_data       = (T_WAP_BROWSER *)browser_win_data->user;	// Data for WAP browser

	T_MFW_HND       win                 = browser_data->parent_win;				// WAP data window
	T_MFW_WIN       *win_data           = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data               = (T_WAP_DATA *)win_data->user;			// WAP data

	UBYTE           startIndex;
	UBYTE           optionIndex;
	const USHORT    optionsItems[]      = {TxtBookmark, TxtBookmarks, TxtGoTo, TxtHomepage, TxtSOFTBACK, TxtReload, TxtExit};
	const USHORT    contextItem[]       = {TxtGoToLink, TxtEdit, TxtSelect, TxtSelect, TxtSelect, TxtSelect, TxtSelect, TxtSelect};
	char            *entry;
	char            *contextKey;
	T_WAP_LIST      *OptionsList        = (T_WAP_LIST *)data->OptionsList;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_options_menu_open");

	sprintf(test_string, "Browser data: %x", browser_data);
	TRACE_EVENT(test_string);
#endif

	data->update_forbid = TRUE;
	startIndex = 0;

	OptionsList->no_of_entries = MAX_OPTIONS;
/*
	if (contextType!=NULL)														// If context key is supplied, put it in
		{
		contextKey = (char *)MmiRsrcGetText(contextItem[contextType-1]);
		OptionsList->no_of_entries++;
		OptionsList->Entry[0] = (char *) AUI_wap_memory_alloc((strlen(contextKey)+1)*sizeof(char));
		strcpy(OptionsList->Entry[0], contextKey);
		startIndex = 1;															// Start filling menu from second entry
		}
*/

	for (optionIndex=startIndex; optionIndex<OptionsList->no_of_entries; optionIndex++)	 // Fill in rest of entries
	{
		entry = (char*)MmiRsrcGetText(optionsItems[optionIndex-startIndex]);
		//OptionsList->Entry[optionIndex] = (char *) AUI_wap_memory_alloc((strlen(entry)+1)*sizeof(char));
		OptionsList->Entry[optionIndex] = (char *) AUI_wap_memory_alloc((wstrlen(entry)+3)*sizeof(char));
		wstrncpy(OptionsList->Entry[optionIndex], entry, wstrlen(entry));
		//strcpy(OptionsList->Entry[optionIndex], entry);
	}

	data->optionsmenu_data = AUI_entry_list_create (win, OptionsList, (ListCbFunc)AUI_options_menu_cb,0,1);
	data->optionsmenu_win = data->optionsmenu_data->win;

	return WAP_OK;
}


/*******************************************************************************

 $Function:    	AUI_options_menu_cb

 $Description:	Callback function for options menu
 
 $Returns:		void		

 $Arguments:	win				- parent window
				EntryListData	- list menu data of bookmarks lsit
 
*******************************************************************************/

static void AUI_options_menu_cb(T_MFW_HND win, ListMenuData *EntryListData)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;
	UBYTE           no_of_entries;  
	//data->update_forbid = TRUE;  //zhaowm 2002.12.09
	optiongoback = 0;
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_options_menu_cb");
	sprintf(test_string, "Reason for callback: %d", EntryListData->Reason);
	TRACE_EVENT(test_string);
#endif

	switch (EntryListData->Reason)
	{
	case LISTS_REASON_SELECT:                                   
	case LISTS_REASON_OK:
		// Option is selected...
		no_of_entries = EntryListData->ListLength;
		data->OptionSelect = EntryListData->ListPosition;					// Store selected option no.
		/*
		if (no_of_entries>MAX_OPTIONS)										// i.e. there's a contextual key in menu
			{
			
			if (data->OptionSelect==0)										// if we've selected it...
				{
				AUI_destroy(win, OPTIONSMENU_WIN);							// Destroy options menu
				data->update_forbid = FALSE;
				ATB_wap_options_menu_select(View);							// tell ATB to do something
				return;
				}
			else
				data->OptionSelect--;										// Otherwise, pretend it isn't there
			}
		  */    

		switch (data->OptionSelect)
		{
		case WAP_ADDBOOKMARK:
			if (ATB_wap_entry_add(View->Bookmarks, View->Title)==WAP_FAIL) // Try to add current title to bookmarks
				AUI_info_dialog(data->win, TxtBookmarks, TxtFull);		// if it's full, say "Bookmarks Full"
			else
			{
				ATB_wap_entry_add(View->BookmarksURL, View->URL);		// Store URL
				ATB_wap_profile_save(View);								// Save change to flash
				AUI_info_dialog(data->win,NULL , TxtStored);			// Display "Stored" message
			}
			break;

		case WAP_BOOKMARKS:
			AUI_entry_list(win, View->Bookmarks, (ListCbFunc) AUI_bookmarks_list_cb,0,2); // Open up bookmarks list
			break;

		case WAP_GOTO:
			WapTitle = TxtGoTo;	  //zhaowm 2002.12.08
			data->other_menu_win = bookMenuStart(win, WAPGoToAttributes(), PhbkWap);	// Create WAP Menu again
			SEND_EVENT(data->other_menu_win, ADD_CALLBACK, NULL, (void *)AUI_goto_cb);  // Add our own callback
			break;

		case WAP_HOMEPAGE:  
			AUI_connect_URL(win, View->Profile->Homepage);				// Connect to homepage
			break;

		case WAP_BACK:
			AUI_destroy(win, OPTIONSMENU_WIN);							// Destroy
			ATB_wap_card_go_back(View);									// Go to previous card
			break;

		case WAP_RELOAD:
			AUI_destroy(win, OPTIONSMENU_WIN);							// Destroy
			ATB_wap_card_refresh(View);									// Reload current card
			break;

		case WAP_EXIT:
			AUI_destroy(win, ALL_WIN);									// Exit from options menu	
			AUI_end_call();					   // zhaowm 2003.0324  Call this function to end a GPRS or CSD call 		    				
			break;

		}

		break;

	case LISTS_REASON_BACK:													// Exit menu (back, timeout etc).
	case LISTS_REASON_CLEAR:    
		AUI_destroy(win,OPTIONSMENU_WIN);									// Return to browser
		optiongoback = 1;
		break;
	default:
		break;
	}
	data->update_forbid = FALSE;
	return;
}


//zhaowm 2003.1.19 add
/*******************************************************************************

 $Function:    	AUI_wap_CustSoftKey_menu_open

 $Description:	The ATB will send to the AUI the contents of the menu list
 
 $Returns:		WAP_OK if successful, WAP_FAIL if otherwise

 
*******************************************************************************/

T_WAP_RES AUI_wap_CustSoftKey_menu_open(UBYTE contextType)
{
	T_MFW_HND       browser_win         = mfwParent( mfw_header());				// Current window will be WAP browser
	T_MFW_WIN       *browser_win_data   = ((T_MFW_HDR *)browser_win)->data;
	T_WAP_BROWSER   *browser_data       = (T_WAP_BROWSER *)browser_win_data->user;	// Data for WAP browser

	T_MFW_HND       win                 = browser_data->parent_win;				// WAP data window
	T_MFW_WIN       *win_data           = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data               = (T_WAP_DATA *)win_data->user;			// WAP data

	T_WAP_LIST      *OptionsList        = (T_WAP_LIST *)data->OptionsList;


#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_options_menu_open");

	sprintf(test_string, "Browser data: %x", browser_data);
	TRACE_EVENT(test_string);
#endif

	data->update_forbid = TRUE;
	OptionsList->no_of_entries = MAX__CUST_OPTIONS;

	OptionsList->Entry[0] = (char *) AUI_wap_memory_alloc((wstrlen((char *) MmiRsrcGetText(TxtSelect))+3)*sizeof(char));
	OptionsList->Entry[1] = (char *) AUI_wap_memory_alloc((wstrlen(data->RightSoftKey)+3)*sizeof(char));



	wstrncpy(OptionsList->Entry[0], (char *) MmiRsrcGetText(TxtSelect), wstrlen((char *) MmiRsrcGetText(TxtSelect)));
	wstrncpy(OptionsList->Entry[1], data->RightSoftKey, wstrlen(data->RightSoftKey));

	data->optionsmenu_data = AUI_entry_list_create (win, OptionsList, (ListCbFunc)AUI_CustSoftKey_menu_cb,0,3);
	data->optionsmenu_win = data->optionsmenu_data->win;

	return WAP_OK;
}


/*******************************************************************************

 $Function:    	AUI_wap_CustSoftKey_menu_cb

 $Description:	Callback function for options menu
 
 $Returns:		void		

 $Arguments:	win				- parent window
				EntryListData	- list menu data of bookmarks lsit
 
*******************************************************************************/

static void AUI_CustSoftKey_menu_cb(T_MFW_HND win, ListMenuData *EntryListData)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data
	T_WAP_VIEW      *View           = data->View;
	UBYTE           no_of_entries;  
	optiongoback = 0;
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_options_menu_cb");
	sprintf(test_string, "Reason for callback: %d", EntryListData->Reason);
	TRACE_EVENT(test_string);
#endif

	switch (EntryListData->Reason)
	{
	case LISTS_REASON_SELECT:                                   
	case LISTS_REASON_OK:
		// Option is selected...
		no_of_entries = EntryListData->ListLength;
		data->OptionSelect = EntryListData->ListPosition;					// Store selected option no.

		switch (data->OptionSelect)
		{
		case WAP_SELECT:
			AUI_destroy(win, OPTIONSMENU_WIN);							// Destroy options menu
			data->update_forbid = FALSE;
			ATB_wap_options_menu_select(View);							// tell ATB to do something
			return;
			break;

		case WAP_CustSoftKey:
			AUI_destroy(win, OPTIONSMENU_WIN);							// Destroy options menu
			ATB_wap_key_selected(View, View->CustSoftKeyId);			// Customised right soft key
			break;

		}

		break;

	case LISTS_REASON_BACK:													// Exit menu (back, timeout etc).
	case LISTS_REASON_CLEAR:    
		AUI_destroy(win,OPTIONSMENU_WIN);									// Return to browser
		optiongoback = 1;
		break;
	}
	data->update_forbid = FALSE;
	return;
}////zhaowm 

/*******************************************************************************

 $Function:    	AUI_goto_cb

 $Description:	Callback function for the goto URL menu
 
 $Returns:		

 $Arguments:	menu 	- pointer to current menu
				item 	- pointer to current menu item
 
*******************************************************************************/

static void AUI_goto_cb(T_MFW_HND parent_win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN       *win_data       = ((T_MFW_HDR *)parent_win)->data;
	T_WAP_DATA      *data           = (T_WAP_DATA *)win_data->user;				// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_goto_cb");
#endif

	data->other_menu_win = NULL;
	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_memory_alloc

 $Description:	Called by the WAP.ATB to allocate memory.
 
 $Returns:		Address if successful, null if not.

 $Arguments:	size of memory to be allocated.
 
*******************************************************************************/

U8* AUI_wap_memory_alloc(USHORT size)
{


#ifdef TRACE_MEMALLOC
	memUsed += size;
	if (size<110)
	{
		memTracker[size]++;
		sprintf(test_string, "ALLOC %d, tracking = %d", size, memTracker[size]);
	}
	else
	{
		sprintf(test_string, "ALLOC %d, used = %d", size, memUsed);
	}
	TRACE_FUNCTION(test_string);
#endif


	return mfwAlloc(size);
}


/*******************************************************************************

 $Function:    	AUI_wap_memory_free

 $Description:	Called by the WAP.ATB to free memory
 
 $Returns:		

 $Arguments:	address and size of memory to be freed.
 
*******************************************************************************/

U8 AUI_wap_memory_free(U8* address,U16 size)
{

#ifdef TRACE_MEMALLOC
	memUsed -= size;
	if (size<110)
	{
		memTracker[size]--;
		sprintf(test_string, "FREE %d, tracking = %d", size, memTracker[size]);
	}
	else
	{
		sprintf(test_string, "FREE %d, used = %d", size, memUsed);
	}
	TRACE_EVENT(test_string);
#endif


	mfwFree(address,size);
	return 1;
}

/*******************************************************************************

 $Function:    	ATB_wap_card_show

 $Description:	Called by the WAP.ATB to show the and/or create the card window.
 
 $Returns:		

 $Arguments:	View	- The current view

 
*******************************************************************************/

void AUI_wap_card_show_req(T_WAP_VIEW *View)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_card_show_req");
#endif

	/* SPR#1739 - SH - If the connecting window or list window are still extant,
	 * destroy them */

	AUI_destroy(data->win, CONNECT_WIN | LIST_WIN);

	/* If WAP browser window doesn't exist, create it */

	if (data->browser_win==NULL)
		data->browser_win = AUI_win_create(data->win);							// Create WAP browser

	SEND_EVENT(data->browser_win,WAP_SHOW_CARD,0,0);							// Initialise window

	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_status_notify

 $Description:	Called by the WAP.ATB when a status flag has changed
				SPR#1574 - SH:
				- Status is now just a value, rather than a bit field.
				- Added two new states: ATB_WAP_ATTACHING, GPRS is trying to
				  attach, and ATB_WAP_ATTACH_FAILED, GPRS attach has
				  failed.
				- Don't need to destroy connecting window, as this is done
				  automatically.
 
 $Returns:		

 $Arguments:	View			- The current view
				status			- parameter which status has changed
 
*******************************************************************************/

void AUI_wap_status_notify(T_WAP_VIEW *View, USHORT status)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_status_notify");
#endif

	switch (status)
	{

	/* If no status, destroy connecting window */
	
	case ATB_WAP_NO_STATUS:
		TRACE_EVENT("Status: Detached");
		if(data->win)/*talcon add 2004.07.02*/
		AUI_destroy(data->win, CONNECT_WIN);		/* SPR#1189 - SH - Destroys connect window */
		break;

	case ATB_WAP_ATTACHING:												// When logging in
		TRACE_EVENT("Status: Attaching");   
		//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_ATTACHING);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_ATTACHING);
		break;

	case ATB_WAP_ATTACH_FAILED:												// When logging in
		TRACE_EVENT("Status: Detached");
		if(data->win)/*talcon add 2004.07.02*/
		{
		AUI_destroy(data->win, CONNECT_WIN);		/* SPR#1189 - SH - Destroys connect window */

		AUI_info_dialog(data->win, TxtGPRS, TxtNotAvailable);
		}
		break;

	case ATB_WAP_CONNECTING:												// When connecting
		TRACE_EVENT("Status: Connecting");

		wap_callActive = TRUE;												// Declare WAP call in progress
		data->connected = TRUE;
		/* SPR#1575 - SH - Display new "Connecting..." dialog */
		//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_CONNECTING);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_CONNECTING);
		break;

	case ATB_WAP_LOGGING_IN:												// When logging in
		TRACE_EVENT("Status: Logging in");
		/* Display dialog with "Logging In" */
		//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_LOGGING_IN);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_LOGGING_IN);	//zhaowm 2003.1.11

		break;

	case ATB_WAP_DOWNLOADING:
		TRACE_EVENT("Status: Downloading");
		data->connected = TRUE;												// We're connected
		break;

		/* SPR#1575 - SH - New status to indicate card is being read
		 * from cache or from network */

	case ATB_WAP_CARD_READING:
		TRACE_EVENT("Status: ATB_WAP_CARD_READING");
		if (data->connect_win)/*talcon add 2004.07.02*/
		{
			//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_CARD_READING);
			AUI_connecting_dialog(data->win, ATB_WAP_CARD_READING);

		}
		break;

	case ATB_WAP_ONLINE_CONNECTION_CLOSED:
		TRACE_EVENT("Status: ATB_WAP_ONLINE_CONNECTION_CLOSED");
		if(data->win)/*talcon add 2004.07.02*/
		AUI_destroy(data->win, BROWSER_WIN | CONNECT_WIN | OPTIONS_WIN);	/* SPR#1189 - SH - Explicitly destroy connect window */
		data->connected = FALSE;
		wap_callActive = FALSE;												// WAP call no longer in progress
		break;

	case ATB_WAP_PLEASE_WAIT:
		TRACE_EVENT("Status: ATB_WAP_PLEASE_WAIT");
		//	data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_PLEASE_WAIT);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_PLEASE_WAIT);
		break;

	default:
		return;     
	}

	if (data->browser_win)						/*The card is prompted to show the status*/
	{
		TRACE_EVENT("Updating card view for status.");
		win_show(data->browser_win);
	}
}


/*******************************************************************************

 $Function:    	AUI_wap_change_soft_key

 $Description:	Called by the WAP.ATB when the card requests a custom text for a
				soft key
 
 $Returns:		

 $Arguments:	View			- The current view
				Label			- The text of the custom soft key
				length			- Length of the text
				keyId			- The id of the key, to send to the AUS Browser
									when the key is pressed.
 
*******************************************************************************/


void AUI_wap_change_soft_key(T_WAP_VIEW *View, USHORT *Label, USHORT length, USHORT keyId)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data
	char            *OptionsText        = MmiRsrcGetText(TxtSoftOptions);
	SHORT           optionsWidth;
	SHORT           labelWidth;

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_wap_change_soft_key");
#endif
	TRACE_EVENT("AUI_wap_change_soft_key_zhao");

	if (length > 0)
	{
		//strcpy(data->LeftSoftKey, OptionsText);									// Left soft key is Options
		ATB_ushort2char(data->RightSoftKey, Label, length);						// Convert RSK text to char type

		// Make sure softkeys fit into the space by cropping them if necessary
		/*  //zhaowm 2003.1.119
		 optionsWidth	= ATB_textWidth(data->LeftSoftKey, strlen(data->LeftSoftKey));
		 labelWidth		= ATB_textWidth(data->RightSoftKey, length);
 
		 if ((labelWidth+optionsWidth) > WAP_TOTAL_WIDTH)						// If they don't fit...
			 {
			 optionsWidth = WAP_TOTAL_WIDTH-labelWidth-WAP_SOFTKEY_SPACING;		// Try shortening "options"
			 if (optionsWidth<ATB_textWidth(OptionsText, WAP_SOFTKEY_MIN_LENGTH))    // If it's too short....
				 {
				 optionsWidth = ATB_textWidth(OptionsText, WAP_SOFTKEY_MIN_LENGTH); // Shorten the other key
				 labelWidth = WAP_TOTAL_WIDTH-optionsWidth-WAP_SOFTKEY_SPACING;
				 }
			 }
		 ATB_crop_text(data->LeftSoftKey, strlen(OptionsText), optionsWidth);	// Crop the texts
		 ATB_crop_text(data->RightSoftKey, length, labelWidth);
		 */
		View->CustSoftKeys = TRUE;												// We are using cust. soft keys
		View->CustSoftKeyId = keyId;
	}
	else
		View->CustSoftKeys = FALSE;

	return;
}


/*******************************************************************************

 $Function:    	AUI_wap_string

 $Description:	Gives the ATB the text of a required string (specific for now)
 
 $Returns:		Pointer to the string

 $Arguments:	The string ID (see ATBData.h for list of strings)
 
*******************************************************************************/

char *AUI_wap_string(USHORT stringID)
{
	/* SPR#1575 - SH - Add string "updating" */

	char *string;

	switch (stringID)
	{
	case WAP_STRING_DOWNLOADING:
		string = MmiRsrcGetText(TxtDownloading);
		break;

	case WAP_STRING_UPDATING:
		string = MmiRsrcGetText(TxtUpdating);
		break;

	default:
		string = MmiRsrcGetText(TxtError);
		break;
	}

	return string;
}

/*******************************************************************************

 $Function:    	AUI_wap_launch_browser

 $Description:	Launches the browser to a given URL and a bearer list arranged by priority. 
 
 $Returns:		TRUE-> succesfully launched, FALSE -> error

 $Arguments:	The URL and the bearer list.
 
*******************************************************************************/

T_MFW_HND AUI_wap_launch_browser(char *URL,UBYTE* bearer_list,UBYTE bearer_list_len)
{
	T_MFW_HND wap_window;

	if (!(wap_window = AUI_create(idle_get_window())))
		return NULL; /*Error */

	AUI_connect_URL(wap_window,URL);

	return wap_window;
}


/*******************************************************************************

 $Function:    	AUI_wap_extDestroy

 $Description:	Allows external files to destroy the WAP application
 
 $Returns:		

 $Arguments:	
 
*******************************************************************************/

void AUI_wap_extDestroy(void)
{   
	T_WAP_DATA *data = (T_WAP_DATA *)ATB_wap_UIdata();

	if (data)
		AUI_destroy(data->win, ALL_WIN);

	return;
}

/*******************************************************************************

 $Function:    	AUI_wap_call_disconnect

 $Description:	SPR#1656 - SH - Called when a CSD call is terminated
				Called when a CSD call is terminated - informs WAP of this.
 
 $Returns:		None.

 $Arguments:	
 
*******************************************************************************/

void AUI_wap_call_disconnect(void)
{
	T_WAP_DATA *data = (T_WAP_DATA *)ATB_wap_UIdata();

	TRACE_FUNCTION("AUI_wap_call_disconnect()");
	if (data)
	{
		if (data->View)
		{
			/* View exists; are we in the connected, or in the connecting screen? */
			if (data->connected || data->connect_win)
			{
				ATB_wap_status_change(data->View, ATB_WAP_ONLINE_CONNECTION_CLOSED);
				AUI_error_dialog(data->View, ERROR_CALL_DISCONNECTED);
			}
		}
	}

	return;
}


/*******************************************************************************

 $Function:    	AUI_end_call

 $Description:	SPR#1575 - SH - Determine whether call is CSD or GPRS,
				and attempt to end it.
				NOTE: this function may be called after WAP is destroyed, so it should
				never attempt to access WAP data.
 
 $Returns:		None.

 $Arguments:	None.
 
*******************************************************************************/

void AUI_end_call(void)
{
	T_WAP_DATA *data = (T_WAP_DATA *)ATB_wap_UIdata();

	TRACE_FUNCTION("AUI_end_call");

	/* SPR#1189 - SH If WAP browser is active, inform it of disconnection */

	if (data)
	{
		ATB_wap_disconnect(data->View);
	}

	/* Terminate CSD call, destroy calling window */

	if (call_get_window())
	{
		TRACE_EVENT("Ending CSD call");
		SEND_EVENT(call_get_window(), CALL_DESTROY_CALLING_WINDOW, 0, 0);
		disconnect_wap_call(WAP_CS_DATA);
	}

	/* Terminate GPRS call */
	else
	{
		TRACE_EVENT("Ending GPRS call");
		disconnect_wap_call(WAP_GPRS_DATA);
	}

	return;
}

#ifdef MMI_GPRS_ENABLED

/*******************************************************************************

 $Function:    	AUI_wap_GPRS_status

 $Description:	Called when GPRS state changes.  If WAP is active, updates status.
				SPR#1574 - SH - Added this function
 
 $Returns:		None.

 $Arguments:	
 
*******************************************************************************/

void AUI_wap_gprs_status(UBYTE status)
{
	T_WAP_DATA *data = (T_WAP_DATA *)ATB_wap_UIdata();

	TRACE_FUNCTION("AUI_wap_gprs_status");

	if (data)
	{
		if (data->View->Profile->AccessType==WAP_GPRS_DATA)
		{
			if (status==GPRS_ATTACHED)
			{
				TRACE_EVENT("GPRS is now attached.");
				/* SPR#1189 - SH - Check that login is still proceeding */

				if (ATB_wap_status_get(data->View, ATB_WAP_ATTACHING))
				{
					TRACE_EVENT("Status is attaching; proceed to logging in.");
					ATB_wap_status_change(data->View, ATB_WAP_LOGGING_IN);
					/* SPR#1575 - SH - Are now attached, can connect */
					connect_gprs(data->View->object_id);
				}
				else
				{
					TRACE_EVENT("Status is not attaching, do nothing.");
				}
			}
			if (status==GPRS_OFF)
			{
				TRACE_EVENT("GPRS is OFF");
				disconnect_wap_call(WAP_GPRS_DATA);
				if(data->win)/*talcon add for mms ,2004.07.05*/
					AUI_destroy(data->win, BROWSER_WIN | CONNECT_WIN);	/* SPR#1189 - SH - Explicitly destroy connect window */
				ATB_wap_status_change(data->View, ATB_WAP_ATTACH_FAILED);
			}
		}
	}
	return;
}
#endif /* MMI_GPRS_ENABLED */




//2002.1208 zhaowm add for check AccessType menu should show what icon
USHORT options_check (struct MfwMnuTag *m, struct MfwMnuAttrTag *ma, struct MfwMnuItemTag *mi)
{

	T_WAP_VIEW      *View    = ATB_wap_get_view(1);

	T_WAP_PROFILE * Profile = View->Profile;
	TRACE_EVENT("accesstype_check");

	if(WAPAccessTypeAttributes() == ma)
	{
		if ( ((Profile->AccessType==0)&&(((int)mi->str)==TxtGPRSData))||
		 ((Profile->AccessType==1)&&(((int)mi->str)==TxtCSData))||
		 ((Profile->AccessType==2)&&(((int)mi->str)==TxtSMS))
		)

		return FLAGFUNC_TRUE_ICON;
	}
	else if(ma == WAPSecurityOptionAttributes())
	{
		if ( ((Profile->Security==0)&&(((int)mi->str)==TxtOff))||
			  ((Profile->Security==1)&&(((int)mi->str)==TxtOn))
			  )
			return FLAGFUNC_TRUE_ICON;
	}

	else if(ma == WAPConnectionTypeAttributes())
	{
		if ( ((Profile->ConnectionType==0)&&(((int)mi->str)==TxtTemporary))||
			  ((Profile->ConnectionType==1)&&(((int)mi->str)==TxtContinuous))
			  )
		return FLAGFUNC_TRUE_ICON;
	}
	else if(ma == WAPScaleImagesAttributes())
	{
		
		if ( (((WapData.Status & WAP_STATUS_SCALEIMAGES)/WAP_STATUS_SCALEIMAGES == 0)&&(((int)mi->str)==TxtOff) )||
			  (((WapData.Status & WAP_STATUS_SCALEIMAGES)/WAP_STATUS_SCALEIMAGES == 1)&&(((int)mi->str)==TxtOn) ))

			return FLAGFUNC_TRUE_ICON;
	}
	else if(ma == WAPSaveHistoryAttributes())
	{
		if ( (((WapData.Status & WAP_STATUS_SAVEHISTORY)/WAP_STATUS_SAVEHISTORY == 0)&&(((int)mi->str)==TxtOff) )||
			  (((WapData.Status & WAP_STATUS_SAVEHISTORY)/WAP_STATUS_SAVEHISTORY == 1)&&(((int)mi->str)==TxtOn) ))

		return FLAGFUNC_TRUE_ICON;
	}

	else if(ma == WAPProfOptionsAttributes())
	{
		if ( ((WapData.Profile[WapData.ProfileId].Title== mi->str)) )
		
			return FLAGFUNC_TRUE_ICON;
	}


		return FLAGFUNC_FALSE_ICON;

}///zhaowm add 2002.1122.

T_MFW_HND         AUI_Exit_Inquire_dialog (T_MFW_HND win)
{
	T_DISPLAY_DATA     display_info;

#ifdef TRACE_AUIWAP		
	TRACE_FUNCTION("AUI_connecting_dialog");
#endif

	dialog_info_init(&display_info);//gdy add
	display_info.KeyEvents      = KEY_CLEAR | KEY_RIGHT|KEY_LEFT;
	display_info.TextId         = NULL;//TxtLoggingIn;
	display_info.TextId2        = Txtdisconnectionbrow;
	display_info.TextString     = NULL;
	display_info.TextString2    = NULL;//data->View->Profile->Title;			// Show Profile name
	display_info.LeftSoftKey    = TxtSoftOK;
	display_info.RightSoftKey   = TxtCancel;							// Cancel key
	display_info.Time           = FOREVER;                                          
	display_info.Callback       = (T_VOID_FUNC)AUI_Exit_Inquire_Dialog_cb;
	display_info.Identifier     = NULL;
	display_info.iconindex          =REMIND_REQUIRE;
	return info_dialog(win, &display_info);

}

void   AUI_Exit_Inquire_Dialog_cb (T_MFW_HND win, UBYTE identifier, UBYTE reason)
{
	T_MFW_WIN   *win_data   = ((T_MFW_HDR *)win)->data;
	T_WAP_DATA  *data       = (T_WAP_DATA *)win_data->user;						// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_connecting_dialog_cb");
#endif

	switch (reason)
	{
	case INFO_KCD_LEFT:
		ATB_wap_stop_download(data->View);
		AUI_destroy(data->win,ALL_WIN); 
		AUI_end_call();		 // zhaowm 2003.0324  Call this function to end a GPRS or CSD call 		
		break;

	default:
		break;
	}
	return;
}


#ifdef MMS_WAP_ENABLED
/*********talcon add for mms *****************/
/********************************************/

T_WAP_DATA mms_data;
T_MMS_VIEW mms_view;

 
int AUI_mms_start()
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_mms_start");
#endif
	//if(!ATB_wap_get_view(0))
	{
		T_MMI_WAP_MMSSTART_IND     mms_start;		
		ATB_mms_start(&mms_start);
	}
	//AUI_mms_new_view();
	return 1;
}


void AUI_mms_start_done(void)
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_mms_start_done");
#endif
	WAP_DELAY(30);
	AUI_mms_new_view();
	WAP_DELAY(30);
#ifdef MMS_WAP_TEST
	wap_mms_evt_cb(NET_CONFIGURE_CNF, MMI_MMS_SUCCESS, NULL);
#endif

	WAP_DELAY(30);
	handle_mms_queue_begin();

	return;
}

void AUI_mms_close()
{
	T_WAP_VIEW* mms_view = ATB_wap_get_view(128);
	T_WAP_VIEW* wap_view = ATB_wap_get_view(1);

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_mms_close");
#endif
		
	/***close wap ********/
	if( mms_view)
	{

		
		if(wap_view == 0)
		{
			T_MMI_WAP_MMSTERMINATE_IND parameter;
			parameter.access_type = mms_view->Profile->AccessType;
			AUI_end_call();

			M_MMI_WAP_MMSTERMINATE_IND(&parameter);
		}
		
		ATB_wap_view_delete(mms_view);
	}

}

void AUI_mms_terminate_done()
{
#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_mms_terminate_done");
#endif

/*
#ifdef MMS_WAP_TEST
	wap_mms_evt_cb(NET_CLOSE_CNF, MMI_MMS_SUCCESS, NULL);
#endif
*/
}


/**********************
$Description:
	translate mms setting to wap setting
***********************************/
void AUI_mms_setting_mms2wap(T_WAP_PROFILE *profile)
{
	T_MMS_PARA_SETTINGS *pMMSSetting;

	TRACE_FUNCTION("AUI_mms_setting_mms2wap");
	/*translate mms setting to wap setting*/
	if(mmsSettings.curSettingsIndex >= MMS_SETTINGS_SUM)
	{
		mmsSettings.curSettingsIndex = 0;
		flash_MMSSettingswrite();
	}
	pMMSSetting = &mmsSettings.allSettings[mmsSettings.curSettingsIndex];

	memset(profile, 0, sizeof(T_WAP_PROFILE));

	profile->ResponseTimer = 60;
	//memcpy(profile->Title, pMMSSetting->strName
	switch(pMMSSetting->transportMode)
	{
	case ONLY_GPRS:
		{
			T_MMS_GPRS_SETTINGS *pMMSGPRS = &pMMSSetting->gprsSettings;

			/*access type*/
			profile->AccessType = WAP_GPRS_DATA;
			/*ip address*/
			memcpy(profile->IPAddress1, pMMSGPRS->IPAddress, strlen(pMMSGPRS->IPAddress) );
			memcpy(profile->IPAddress2, pMMSGPRS->IPAddress, strlen(pMMSGPRS->IPAddress) );

			/*ip port*/
			//memcpy(profile->Port1, pMMSGPRS->IPPort, sizeof(profile->Port1) );
			profile->Port1 = atoi(pMMSGPRS->IPPort);
			profile->Port2 = profile->Port1;

			/*APN*/
			memcpy(profile->APN, pMMSGPRS->APN, strlen(pMMSGPRS->APN) );

			/*Username*/
			memcpy(profile->Username, pMMSGPRS->userName, strlen( pMMSGPRS->userName) );

			/*Password*/
			memcpy(profile->Password, pMMSGPRS->password, strlen(pMMSGPRS->password) );
		}
		break;
	case ONLY_GSM:
		{

			T_MMS_GSM_SETTINGS *pGSMGPRS = &pMMSSetting->gsmSettings;

			/*access type*/
			profile->AccessType = WAP_CS_DATA;
			
			/*ip address*/
			memcpy(profile->IPAddress1, pGSMGPRS->IPAddress, strlen(pGSMGPRS->IPAddress) );
			memcpy(profile->IPAddress2, pGSMGPRS->IPAddress, strlen(pGSMGPRS->IPAddress) );

			/*ip port*/
			//memcpy(profile->Port1, pGSMGPRS->IPPort, sizeof(profile->Port1) );
			profile->Port1 = atoi(pGSMGPRS->IPPort);
			profile->Port2 = profile->Port1;

			/*dialNumber*/
			memcpy(profile->DialupNumber, pGSMGPRS->dialNumber, sizeof(profile->DialupNumber) );

			/*Username*/
			memcpy(profile->Username, pGSMGPRS->userName, sizeof(profile->Username) );

			/*Password*/
			memcpy(profile->Password, pGSMGPRS->password, sizeof(profile->Password) );

		}
		break;
	default:
		TRACE_EVENT("mms setting,Error");
		break;
	}

}
void AUI_mms_new_view()
{

	static T_WAP_PROFILE profile;

	TRACE_FUNCTION("AUI_mms_new_view");
	
	AUI_mms_setting_mms2wap(&profile);
	
	/*for test*/	
	memset(&mms_data, 0 ,sizeof(mms_data) );
	mms_view.UIdata = &mms_data;
	mms_data.View = &mms_view;

	
	mms_view.object_id = 128;//128,WMLS_CONTENT
	mms_view.channel = WAP_CHANNEL_ID;
	//mms_view.Profile = (T_WAP_PROFILE*)&mms_profile;
	mms_view.Profile = (T_WAP_PROFILE*)&profile;

	ATB_wap_wiew_add(&mms_view);
	
	ATB_wap_status_change(&mms_view, ATB_WAP_PLEASE_WAIT);		
	ATB_mms_profile_send(&mms_view);	

}


void AUI_mms_status_notify(T_WAP_VIEW *View, USHORT status)
{
	T_WAP_DATA      *data               = (T_WAP_DATA *)View->UIdata;			// WAP data

#ifdef TRACE_AUIWAP
	TRACE_FUNCTION("AUI_mms_status_notify");
#endif

	switch (status)
	{

	/* If no status, destroy connecting window */
	
	case ATB_WAP_NO_STATUS:
		TRACE_EVENT("Status: Detached");
		if(data->win)/*talcon add 2004.07.02*/
		AUI_destroy(data->win, CONNECT_WIN);		/* SPR#1189 - SH - Destroys connect window */
		break;

	case ATB_WAP_ATTACHING:												// When logging in
		TRACE_EVENT("Status: Attaching");   
		//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_ATTACHING);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_ATTACHING);
		break;

	case ATB_WAP_ATTACH_FAILED:												// When logging in
		TRACE_EVENT("Status: Detached");
		if(data->win)/*talcon add 2004.07.02*/
		{
		AUI_destroy(data->win, CONNECT_WIN);		/* SPR#1189 - SH - Destroys connect window */

		AUI_info_dialog(data->win, TxtGPRS, TxtNotAvailable);
		}
		break;

	case ATB_WAP_CONNECTING:												// When connecting
		TRACE_EVENT("Status: Connecting");

		wap_callActive = TRUE;												// Declare WAP call in progress
		data->connected = TRUE;
		/* SPR#1575 - SH - Display new "Connecting..." dialog */
		//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_CONNECTING);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_CONNECTING);
		break;

	case ATB_WAP_LOGGING_IN:												// When logging in
		TRACE_EVENT("Status: Logging in");
		/* Display dialog with "Logging In" */
		//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_LOGGING_IN);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_LOGGING_IN);	//zhaowm 2003.1.11

		break;

	case ATB_WAP_DOWNLOADING:
		TRACE_EVENT("Status: Downloading");
		data->connected = TRUE;												// We're connected
		break;

		/* SPR#1575 - SH - New status to indicate card is being read
		 * from cache or from network */

	case ATB_WAP_CARD_READING:
		if (data->connect_win)/*talcon add 2004.07.02*/
		{
			//data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_CARD_READING);
			AUI_connecting_dialog(data->win, ATB_WAP_CARD_READING);

		}
		break;

	case ATB_WAP_ONLINE_CONNECTION_CLOSED:
		if(data->win)/*talcon add 2004.07.02*/
		AUI_destroy(data->win, BROWSER_WIN | CONNECT_WIN | OPTIONS_WIN);	/* SPR#1189 - SH - Explicitly destroy connect window */
		data->connected = FALSE;
		wap_callActive = FALSE;												// WAP call no longer in progress
		break;

	case ATB_WAP_PLEASE_WAIT:
		//	data->connect_win =  AUI_connecting_dialog(data->win, ATB_WAP_PLEASE_WAIT);
		if(data->win)/*talcon add 2004.07.02*/
		AUI_connecting_dialog(data->win, ATB_WAP_PLEASE_WAIT);
		break;

	default:
		return;     
	}

}


#endif




